#include <common.h>
#ifndef __PANEL_CONFIG_PARAM_SN_H__
#define __PANEL_CONFIG_PARAM_SN_H__

#ifdef CONFIG_CUSTOM_SN_PANEL
#define SN_BIN_LEN 611

typedef struct _SN_PANEL_INFO{
	char Version_String[16];
	UINT32 Panel_Number;
	UINT8 Reserved_00;
	UINT8 Reserved_01;
	UINT8 Reserved_02;
	UINT8 Reserved_03;
	UINT8 Reserved_04;
	UINT8 Reserved_05;
	UINT8 Reserved_06;
	UINT8 Reserved_07;
	UINT8 Reserved_08;
	UINT8 Reserved_09;
	UINT8 Reserved_10;
	UINT8 Reserved_11;
	UINT8 PanelIndex;
	char PanelIDString[16];
	UINT8 InchSize;
	UINT8 Chassis_Index;
	UINT16 Panel_Width;
	UINT16 Panel_Height;
	UINT32 Reserved_12;
	UINT32 PixelClk60Hz;
	UINT32 Reserved_13;
	UINT16 HTotalMax;

	UINT16 HTotal60Hz;

	UINT16 HTotalMin;

	UINT16 VTotalMax;

	UINT16 VTotal60Hz;

	UINT16 VTotalMin;

	UINT8 VClkMax;
	UINT8 VClkMin;
	UINT8 HSyncWidth_60Hz;
	UINT8 VSyncWidth_60Hz;
	UINT16 HFrontPorch_60Hz;
	UINT16 HbackPorch_60Hz;
	UINT16 VFrontPorch_60Hz;
	UINT16 VbackPorch_60Hz;
	UINT8 HSyncPolarity;
	UINT8 VSyncPolarity;
	UINT32 PixelClk50Hz;
	UINT16 HTotal50Hz;
	UINT8 VCOM_Pattern;
	UINT8 VCOM_Type;
	UINT8 Drive_strength;
	UINT8 Pre_emphasis_On_Off;
	UINT8 Pre_emphasis_level;
	UINT8 Spread_spectrum_On_Off;
	UINT8 SpreadPermillage;
	UINT32 SpreadFreq;
	UINT8 Video_I_F_format;
	UINT16 VTotal50Hz;
	UINT8 HSyncWidth_50Hz;
	UINT8 VSyncWidth_50Hz;
	UINT16 HFrontPorch_50Hz;
	UINT16 HbackPorch_50Hz;
	UINT16 VFrontPorch_50Hz;
	UINT16 VbackPorch_50Hz;
	UINT8 Mura_CUC_ID;
#ifdef CONFIG_TCON_LESS
	UINT8 Tcon_Index;	// UINT8 Reserved_15;	tcon less
#else
	UINT8 Reserved_15;
#endif
	UINT16 CURRENT_MAX;
	UINT16 CURRENT_MIN;
	UINT16 BL_PWM_MAX;
	UINT16 BL_PWM_MIN;
	UINT16 BL_CUR_FREQ;
	UINT16 BL_PWM_FREQ;
	UINT16 BL_WAIT_LOGO;
	UINT16 BL_PSL_DIFF;
	UINT32 PixelClk48Hz;
	UINT16 HTotal48Hz;
	UINT16 VTotal48Hz;
	UINT8 HSyncWidth_48Hz;
	UINT8 VSyncWidth_48Hz;
	UINT16 HFrontPorch_48Hz;
	UINT16 HbackPorch_48Hz;
	UINT16 VFrontPorch_48Hz;
	UINT16 VbackPorch_48Hz;
	UINT8 Reserved_16;
	UINT8 Reserved_17;
	UINT8 Reserved_18;
	UINT8 Reserved_19;
	UINT8 Reserved_20;
	UINT8 Reserved_21;
	UINT8 Reserved_22;
	UINT8 Reserved_23;
	UINT8 Reserved_24;
	UINT8 Reserved_25;
	UINT8 Reserved_26;
	UINT8 Reserved_27;
	UINT8 Reserved_28;
	UINT8 Reserved_29;
	UINT8 Reserved_30;
	UINT8 LVDS_clock_level;
	UINT8 Mura_CUC_data_transfer; //Reserved_32
#if 1
	UINT8 _12V_WAIT;
	UINT8 EDID_WAIT;
	UINT8 VBO_WAIT;
#else
	UINT8 Reserved_33;
	UINT8 Reserved_34;
	UINT8 Reserved_35;
#endif
#if 1//defined(CONFIG_CUSTOM_Vulcan_PowerSequence)
	UINT8 External_device_control_1_X1_31_24;
	UINT8 External_device_control_1_X1_23_16;
	UINT8 External_device_control_1_X1_15_8;
	UINT8 External_device_control_1_X1_7_0;
	UINT8 External_device_control_1_X2_31_24;
	UINT8 External_device_control_1_X2_23_16;
	UINT8 External_device_control_1_X2_15_8;
	UINT8 External_device_control_1_X2_7_0;
	UINT8 External_device_control_1_X3_31_24;
	UINT8 External_device_control_1_X3_23_16;
	UINT8 External_device_control_1_X3_15_8;
	UINT8 External_device_control_1_X3_7_0;
	UINT8 External_device_control_1_X4_31_24;
	UINT8 External_device_control_1_X4_23_16;
	UINT8 External_device_control_1_X4_15_8;
	UINT8 External_device_control_1_X4_7_0;
	UINT8 External_device_control_1_X5_31_24;
	UINT8 External_device_control_1_X5_23_16;
	UINT8 External_device_control_1_X5_15_8;
	UINT8 External_device_control_1_X5_7_0;
	UINT8 External_device_control_1_X6_31_24;
	UINT8 External_device_control_1_X6_23_16;
	UINT8 External_device_control_1_X6_15_8;
	UINT8 External_device_control_1_X6_7_0;
	UINT8 External_device_control_1_X7_31_24;
	UINT8 External_device_control_1_X7_23_16;
	UINT8 External_device_control_1_X7_15_8;
	UINT8 External_device_control_1_X7_7_0;
	UINT8 External_device_control_1_X8_31_24;
	UINT8 External_device_control_1_X8_23_16;
	UINT8 External_device_control_1_X8_15_8;
	UINT8 External_device_control_1_X8_7_0;
	UINT8 External_device_control_1_X9_31_24;
	UINT8 External_device_control_1_X9_23_16;
	UINT8 External_device_control_1_X9_15_8;
	UINT8 External_device_control_1_X9_7_0;
	UINT8 External_device_control_1_X10_31_24;
	UINT8 External_device_control_1_X10_23_16;
	UINT8 External_device_control_1_X10_15_8;
	UINT8 External_device_control_1_X10_7_0;
	UINT8 External_device_control_1_X11_31_24;
	UINT8 External_device_control_1_X11_23_16;
	UINT8 External_device_control_1_X11_15_8;
	UINT8 External_device_control_1_X11_7_0;
	UINT8 External_device_control_1_X12_31_24;
	UINT8 External_device_control_1_X12_23_16;
	UINT8 External_device_control_1_X12_15_8;
	UINT8 External_device_control_1_X12_7_0;
	UINT8 External_device_control_1_X13_31_24;
	UINT8 External_device_control_1_X13_23_16;
	UINT8 External_device_control_1_X13_15_8;
	UINT8 External_device_control_1_X13_7_0;
	UINT8 External_device_control_1_X14_31_24;
	UINT8 External_device_control_1_X14_23_16;
	UINT8 External_device_control_1_X14_15_8;
	UINT8 External_device_control_1_X14_7_0;
	UINT8 External_device_control_1_X15_31_24;
	UINT8 External_device_control_1_X15_23_16;
	UINT8 External_device_control_1_X15_15_8;
	UINT8 External_device_control_1_X15_7_0;
	UINT8 External_device_control_1_X16_31_24;
	UINT8 External_device_control_1_X16_23_16;
	UINT8 External_device_control_1_X16_15_8;
	UINT8 External_device_control_1_X16_7_0;

	UINT8 External_device_control_1_X17_31_24;
	UINT8 External_device_control_1_X17_23_16;
	UINT8 External_device_control_1_X17_15_8;
	UINT8 External_device_control_1_X17_7_0;

	UINT16 External_device_control_1_X18_Reserved_00;
	UINT16 External_device_control_1_X18_Reserved_01;
	UINT16 External_device_control_1_X19_Reserved_00;
	UINT16 External_device_control_1_X19_Reserved_01;
	UINT16 External_device_control_1_X20_Reserved_00;
	UINT16 External_device_control_1_X20_Reserved_01;
	UINT16 External_device_control_1_X21_Reserved_00;
	UINT16 External_device_control_1_X21_Reserved_01;
	UINT16 External_device_control_1_X22_Reserved_00;
	UINT16 External_device_control_1_X22_Reserved_01;
	UINT16 External_device_control_1_X23_Reserved_00;
	UINT16 External_device_control_1_X23_Reserved_01;
	UINT16 External_device_control_1_X24_Reserved_00;
	UINT16 External_device_control_1_X24_Reserved_01;
	UINT16 External_device_control_1_X25_Reserved_00;
	UINT16 External_device_control_1_X25_Reserved_01;
	UINT16 External_device_control_1_X26_Reserved_00;
	UINT16 External_device_control_1_X26_Reserved_01;
	UINT16 External_device_control_1_X27_Reserved_00;
	UINT16 External_device_control_1_X27_Reserved_01;
	UINT16 External_device_control_1_X28_Reserved_00;
	UINT16 External_device_control_1_X28_Reserved_01;

	char VTOD_De_emphasis_set[32];
#endif
	char Common_control[40];
	char Reserved[248];

} SN_PANEL_INFO;

typedef struct _PANEL_CONFIG_PARAMETER_SN{

	UINT8 iCONFIG_DISPLAY_PORT:2;				//0: single port, 1: double port, 2:4 port
	UINT8 iCONFIG_DISPLAY_COLOR_BITS:2; 		//0: 30bits, 1:24 bits, 2: 18bits
	UINT8 iCONFIG_DISPLAY_EVEN_RSV1_BIT:1;		//0: Indicate 0, 1: Indicate 1
	UINT8 iCONFIG_DISPLAY_ODD_RSV1_BIT:1;		//0: Indicate 0, 1: Indicate 1
	UINT8 iCONFIG_DISPLAY_BITMAPPING_TABLE:1;	//0: Table1, 1:Table2
	UINT8 iCONFIG_DISPLAY_PORTAB_SWAP:1;		//0: No Swap, 1: Swap , 4 port lvds has 24 type mapping tables
	//1 byte

	UINT8 iCONFIG_DISPLAY_RED_BLUE_SWAP:1;		//0: No Swap, 1: Swap
	UINT8 iCONFIG_DISPLAY_MSB_LSB_SWAP:1;		//0: No Swap, 1: Swap
	UINT8 iCONFIG_DISPLAY_SKEW_DATA_OUTPUT:1;	//0: Disable, 1: Skew data output
	UINT8 iCONFIG_DISPLAY_OUTPUT_INVERSE:1; 	//0: No Swap, 1: Swap
	UINT8 iCONFIG_DISPLAY_VERTICAL_SYNC_NORMAL:1;
	UINT8 iCONFIG_DISPLAY_HORIZONTAL_SYNC_NORMAL:1;
	UINT8 iCONFIG_DISPLAY_RATIO_4X3:2;
	//2 bytes

	UINT16 iCONFIG_DISPLAY_CLOCK_MAX;		//119
	UINT16 iCONFIG_DISPLAY_CLOCK_MIN;
	UINT8 iCONFIG_DISPLAY_REFRESH_RATE; 		//75
	UINT32 iCONFIG_DISPLAY_CLOCK_TYPICAL;		//70*1000000 // hsliao 20081008
		//11 bytes

	UINT16 iCONFIG_DISP_HORIZONTAL_TOTAL;		//(1688 -1)
	UINT16 iCONFIG_DISP_VERTICAL_TOTAL; 		//(1066 - 1)
		//15 bytes

	UINT8 iCONFIG_DISP_HSYNC_WIDTH; 			//(32 - 1)
	UINT8 iCONFIG_DISP_VSYNC_LENGTH;			//(6 - 1)
		//17 bytes

	UINT16 iCONFIG_DISP_DEN_STA_HPOS;			//200//201//32
	UINT16 iCONFIG_DISP_DEN_END_HPOS;// 				1480//1482//1312
	UINT16 iCONFIG_DISP_DEN_STA_VPOS;// 				16//frank@1118 Change 5bits to 16 bits to solve overflow problem
	UINT16 iCONFIG_DISP_DEN_END_VPOS;// 				1040
		//25 bytes

	UINT16 iCONFIG_DISP_ACT_STA_HPOS:3;//				0
	UINT16 iCONFIG_DISP_ACT_END_HPOS:13;//				1280
	UINT16 iCONFIG_DISP_ACT_STA_VPOS:3;//				0
	UINT16 iCONFIG_DISP_ACT_END_VPOS:13;//				1024
		//33 bytes

	UINT16 iCONFIG_DISP_HSYNC_LASTLINE;//				(1688 - 1)
	UINT8 iCONFIG_DISP_DCLK_DELAY;//					0
	UINT8 _iCONFIG_DISP_ACT_STA_BIOS;// 				0x00
	UINT8 iCONFIG_DEFAULT_DPLL_M_DIVIDER;// 		0x68 //hpwang 20071119 set default DCLK=(27*104/8)/2/2=87.75MHz
	UINT8 iCONFIG_DEFAULT_DPLL_N_DIVIDER;// 		0x18
		//39 bytes

	UINT16 iPANEL_TO_LVDS_ON_ms;//						50 // Delay(T1+T2): Panel Power --> LVDS Signal
	UINT16 iLVDS_TO_LIGHT_ON_ms;//						200 // Delay(T3):	 Settings: LVDS Signal --> Backlight On

	UINT16 iLIGHT_TO_LDVS_OFF_ms;// 				200 // Delay(T4):	 Turn Off backlight and delay to turn off LVDS signal
	UINT16 iLVDS_TO_PANEL_OFF_ms;// 				40 // Delay(T5+T6): LVDS Signal Off --> Panel Power Off
		//47 bytes

	UINT16 iPANEL_OFF_TO_ON_ms;//						1000 // Delay(T7):	  Totally Off --> Next On
	UINT16 iCONFIG_BACKLIGHT_PWM_FREQ;//				10000
	UINT8 iCONFIG_BACKLIGHT_PWM_DUTY;// 			10
	UINT8 iFIX_LAST_LINE_ENABLE;//				0
	UINT8 iFIX_LAST_LINE_4X_ENABLE;//				0
	UINT8 iVFLIP;// 								0
		//55 bytes

	UINT8 iPICASSO_CONTROL_ON;
	UINT8 i3D_DISPLAY_SUPPORT;
	UINT8 i3D_LINE_ALTERNATIVE_SUPPORT;
	UINT8 i3D_PR_OUTPUT_LR_SWAP;
	UINT8 i3D_SG_OUTPUT_120HZ_ON;
	UINT8 i3D_SG_24HZ_OUTPUT_FHD_ON;
	UINT8 iSCALER_2D_3D_CVT_HWSHIFT_ENABLE;
		//62 bytes

	//append new parameters 2012-3-21
	UINT16 iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MIN;
	UINT16 iCONFIG_DISP_VERTICAL_TOTAL_50Hz_MAX;
	UINT16 iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MIN;
	UINT16 iCONFIG_DISP_VERTICAL_TOTAL_60Hz_MAX;
		//70 bytes

	UINT8 iCONFIG_LVDS_4_PORTS_INDEX;
	UINT8 iCONFIG_LVDS_PN_SWAP;
	UINT8 iCONFIG_LVDS_MIRROR;
		//73 bytes

	UINT32 iCONFIG_DISPLAY_PORT_CONFIG1;
	UINT32 iCONFIG_DISPLAY_PORT_CONFIG2;
	UINT8 iCONFIG_SR_MODE;
	UINT8 iCONFIG_SR_PIXEL_MODE;
	UINT8 iCONFIG_SFG_SEG_NUM;
	UINT8 iCONFIG_SFG_PORT_NUM;
	UINT8 iCONFIG_PANEL_TYPE;	// (0:LVDS 2k1k only), (1: VBY_ONE 4k2K), (2: LVDS 4k2k+2k1k (NEED define CUSTOM INDEX))
	UINT8 iCONFIG_PANEL_CUSTOM_INDEX; // 0: none, 1: M3_CMI_55, 2: PA168_AU55,
		//87 bytes

	UINT8 i3D_DISPLAY_TIMING;
	// 88 byte

		UINT8 iCONFIG_CUSTOMER_PANEL_ID;

	//Reserve for new parameters
	UINT16 iCONFIG_DISP_RESVER05;
	UINT32 iCONFIG_DISP_RESVER06; //sizeof is 100byte now. don't add more item
		//95 bytes
	UINT16 iPANEL_WIDTH_MM;
	UINT16 iPANEL_HEIGHT_MM;
	UINT16 iBACKLIGHT_PWM_48HZ_FREQ;
	UINT16 iBACKLIGHT_PWM_50HZ_FREQ;
	UINT16 iBACKLIGHT_PWM_60HZ_FREQ;

	//105 bytes
	UINT32 iPixelClk60Hz;
	UINT16 iHTotal60Hz;
	UINT16 iVTotal60Hz;
	UINT8  iHSyncWidth_60Hz;
	UINT8  iVSyncWidth_60Hz;
	UINT16 iHFrontPorch_60Hz;
	UINT16 iHbackPorch_60Hz;
	UINT16 iVFrontPorch_60Hz;
	UINT16 iVbackPorch_60Hz;

	UINT32 iPixelClk50Hz;
	UINT16 iHTotal50Hz;
	UINT16 iVTotal50Hz;
	UINT8  iHSyncWidth_50Hz;
	UINT8  iVSyncWidth_50Hz;
	UINT16 iHFrontPorch_50Hz;
	UINT16 iHbackPorch_50Hz;
	UINT16 iVFrontPorch_50Hz;
	UINT16 iVbackPorch_50Hz;

	UINT32 iPixelClk48Hz;
	UINT16 iHTotal48Hz;
	UINT16 iVTotal48Hz;
	UINT8 iHSyncWidth_48Hz;
	UINT8 iVSyncWidth_48Hz;
	UINT16 iHFrontPorch_48Hz;
	UINT16 iHbackPorch_48Hz;
	UINT16 iVFrontPorch_48Hz;
	UINT16 iVbackPorch_48Hz;
#ifdef CONFIG_TCON_LESS
	UINT8  iTcon_Index;
	//160 byte
	char iBuf[31];
#else
	//159 byte
	char iBuf[32];
#endif
	//191 byte
#ifdef CONFIG_CUSTOMER_TV010
	char sPanelName[40];
#else
	char sPanelName[32];
#endif

} __attribute__((aligned(4))) PANEL_CONFIG_PARAMETER_SN;


#endif

#endif//#ifndef __PANEL_CONFIG_PARAM_SN_H__

