#ifndef __SMP_H__
#define __SMP_H__

#define CACHE_LINE_SIZE       64

#define SMP_SHARED_SEM_REG         (0xb801a624)

typedef enum {
   MAGIC_COPROC_IN_REDIRECT   = 0x00000000,  // core pending in redirect
   MAGIC_COPROC_JUMP_TO_UBOOT = 0x00020000,  // core jump to uboot entry address
   MAGIC_COPROC_OP_POWER_CTRL = 0x1234cafe,
   MAGIC_COPROC_OP_GET_READY  = 0x23790000,  // core get ready in uboot
   MAGIC_COPROC_OP_SCU_TEST,              // core enter scu_test
   MAGIC_COPROC_OP_MEM_TEST,              // core enter mem_test
   MAGIC_COPROC_OP_MAX_POWER_TEST,        // core enter max_power test
   MAGIC_COPROC_OP_SMP_DISABLE=0x24000000,
   // ...
   MAGIC_COPROC_MEM_TEST_OK   = 0xcafe0000,  // core mtest result ok
   MAGIC_COPROC_MEM_TEST_FAIL = 0xcafe1111,  // core mtest result fail
   MAGIC_COPROC_MEM_TEST_DONE = 0xcafeffff,  // core mtest result done
   // ...
   MAGIC_COPROC_NOT_SUPPORT   = 0xFFFFFFFF
} MAGIC_COPROC_OP_T;

typedef void (*CoreWakeupFunc ) (void);
void smp_mutex_lock(void);
void smp_mutex_unlock(void);
int smp_processor_id(unsigned int mpidr);
int smp_boot_secondary(unsigned int cpu_bitmap);
int smp_init(void);
void smp_release_coproc(void);
int smp_active_cores(void);
#endif	//__SMP_H__
