/*----------------------------------------------------------------------------
*
* The confidential and proprietary information contained in this file may
* only be used by a person authorised under and to the extent permitted
* by a subsisting licensing agreement from ARM Limited or its affiliates.
*
*        (C) COPYRIGHT 2008-2009, 2011-2017 ARM Limited or its affiliates.
*             ALL RIGHTS RESERVED
*             
* This entire notice must be reproduced on all copies of this file
* and copies of this file may only be made by a person if such person is
* permitted to do so under the terms of a subsisting license agreement
* from ARM Limited or its affiliates.
*
* Release   : r0p0-00eac0
*-----------------------------------------------------------------------------*/
#include "MaliFns.h"
#include "non_coherent_DVALIN_Load.h"
// Max errors - note this is a negative number
#ifndef MAX_ERR
  #define MAX_ERR -4
#endif
#ifndef VERBOSE_CHECK
  #define VERBOSE_CHECK 0
#endif

int Load_fpgahex () {
  int res = 0;
  struct t_LoadData_fpgahex *r = &LoadData_fpgahex;
  if (res > MAX_ERR) { res += Mali_MemCpy((unsigned int *)0xd6000000, 0xd6000000, r->data_d6000000, 0, 0x400); };
  if (res > MAX_ERR) { res += Mali_MemCpy((unsigned int *)0xd6001000, 0xd6001000, r->data_d6001000, 0, 0x400); };
  if (res > MAX_ERR) { res += Mali_MemCpy((unsigned int *)0xd6002000, 0xd6002000, r->data_d6002000, 0, 0x400); };
  if (res > MAX_ERR) { res += Mali_MemCpy((unsigned int *)0xd6003000, 0xd6003000, r->data_d6003000, 0, 0x400); };
  if (res > MAX_ERR) { res += Mali_MemCpy((unsigned int *)0xd6004000, 0xd6004000, r->data_d6004000, 0, 0x400); };
  if (res > MAX_ERR) { res += Mali_MemCpy((unsigned int *)0xd6005000, 0xd6005000, r->data_d6005000, 0, 0x400); };
  if (res > MAX_ERR) { res += Mali_MemCpy((unsigned int *)0xd6006000, 0xd6006000, r->data_d6006000, 0, 0x400); };
  if (res > MAX_ERR) { res += Mali_MemCpy((unsigned int *)0xd6007000, 0xd6007000, r->data_d6007000, 0, 0x400); };
  if (res > MAX_ERR) { res += Mali_MemCpy((unsigned int *)0xd6008000, 0xd6008000, r->data_d6008000, 0, 0x400); };
  if (res > MAX_ERR) { res += Mali_MemCpy((unsigned int *)0xd6009000, 0xd6009000, r->data_d6009000, 0, 0x400); };
  /* Return -1 if a compare fail */
  if (res) { return res; };
  return 0;
};

int Load_input_000001_remapped () {
  int res = 0;
  struct t_LoadData_input_000001_remapped *r = &LoadData_input_000001_remapped;
  if (res > MAX_ERR) { res += Mali_MemCpy((unsigned int *)0xd6033000, 0xd6033000, r->data_d6033000, 0, 0x400); };
  /* Return -1 if a compare fail */
  if (res) { return res; };
  return 0;
};

int Load_input_000002_remapped () {
  int res = 0;
  struct t_LoadData_input_000002_remapped *r = &LoadData_input_000002_remapped;
  if (res > MAX_ERR) { res += Mali_MemCpy((unsigned int *)0xd6034000, 0xd6034000, r->data_d6034000, 0, 0x3f0); };
  /* Return -1 if a compare fail */
  if (res) { return res; };
  return 0;
};

int Load_input_000003_remapped () {
  int res = 0;
  struct t_LoadData_input_000003_remapped *r = &LoadData_input_000003_remapped;
  if (res > MAX_ERR) { res += Mali_MemCpy((unsigned int *)0xd600a000, 0xd600a000, r->data_d600a000, 0, 0x090); };
  /* Return -1 if a compare fail */
  if (res) { return res; };
  return 0;
};

int Load_input_000004_remapped () {
  int res = 0;
  struct t_LoadData_input_000004_remapped *r = &LoadData_input_000004_remapped;
  if (res > MAX_ERR) { res += Mali_MemCpy((unsigned int *)0xd6038000, 0xd6038000, r->data_d6038000, 0, 0x010); };
  /* Return -1 if a compare fail */
  if (res) { return res; };
  return 0;
};

int Load_input_000007_remapped () {
  int res = 0;
  struct t_LoadData_input_000007_remapped *r = &LoadData_input_000007_remapped;
  if (res > MAX_ERR) { res += Mali_MemCpy((unsigned int *)0xd600b000, 0xd600b000, r->data_d600b000, 0, 0x010); };
  /* Return -1 if a compare fail */
  if (res) { return res; };
  return 0;
};

int Load_input_000008_remapped () {
  int res = 0;
  struct t_LoadData_input_000008_remapped *r = &LoadData_input_000008_remapped;
  if (res > MAX_ERR) { res += Mali_MemCpy((unsigned int *)0xd6039000, 0xd6039000, r->data_d6039000, 0, 0x240); };
  /* Return -1 if a compare fail */
  if (res) { return res; };
  return 0;
};

int Load_input_000009_remapped () {
  int res = 0;
  struct t_LoadData_input_000009_remapped *r = &LoadData_input_000009_remapped;
  if (res > MAX_ERR) { res += Mali_MemCpy((unsigned int *)0xd6037000, 0xd6037000, r->data_d6037000, 0, 0x0e0); };
  /* Return -1 if a compare fail */
  if (res) { return res; };
  return 0;
};

int Load_input_000010_remapped () {
  int res = 0;
  struct t_LoadData_input_000010_remapped *r = &LoadData_input_000010_remapped;
  if (res > MAX_ERR) { res += Mali_MemCpy((unsigned int *)0xd6039000, 0xd6039000, r->data_d6039000, 0, 0x240); };
  /* Return -1 if a compare fail */
  if (res) { return res; };
  return 0;
};

int Load_input_000011_remapped () {
  int res = 0;
  struct t_LoadData_input_000011_remapped *r = &LoadData_input_000011_remapped;
  if (res > MAX_ERR) { res += Mali_MemCpy((unsigned int *)0xd6035000, 0xd6035fc0, r->data_d6035fc0, 0, 0x010); };
  /* Return -1 if a compare fail */
  if (res) { return res; };
  return 0;
};

int Load_input_000012_remapped () {
  int res = 0;
  struct t_LoadData_input_000012_remapped *r = &LoadData_input_000012_remapped;
  if (res > MAX_ERR) { res += Mali_MemCpy((unsigned int *)0xd602b000, 0xd602b000, r->data_d602b000, 0, 0x400); };
  if (res > MAX_ERR) { res += Mali_MemCpy((unsigned int *)0xd602c000, 0xd602c000, r->data_d602c000, 0, 0x400); };
  if (res > MAX_ERR) { res += Mali_MemCpy((unsigned int *)0xd602d000, 0xd602d000, r->data_d602d000, 0, 0x400); };
  if (res > MAX_ERR) { res += Mali_MemCpy((unsigned int *)0xd602e000, 0xd602e000, r->data_d602e000, 0, 0x400); };
  /* Return -1 if a compare fail */
  if (res) { return res; };
  return 0;
};

int Load_input_000013_remapped () {
  int res = 0;
  struct t_LoadData_input_000013_remapped *r = &LoadData_input_000013_remapped;
  if (res > MAX_ERR) { res += Mali_MemCpy((unsigned int *)0xd602b000, 0xd602b000, r->data_d602b000, 0, 0x400); };
  if (res > MAX_ERR) { res += Mali_MemCpy((unsigned int *)0xd602c000, 0xd602c000, r->data_d602c000, 0, 0x400); };
  if (res > MAX_ERR) { res += Mali_MemCpy((unsigned int *)0xd602d000, 0xd602d000, r->data_d602d000, 0, 0x400); };
  if (res > MAX_ERR) { res += Mali_MemCpy((unsigned int *)0xd602e000, 0xd602e000, r->data_d602e000, 0, 0x400); };
  /* Return -1 if a compare fail */
  if (res) { return res; };
  return 0;
};

int Load_input_000015_remapped () {
  int res = 0;
  struct t_LoadData_input_000015_remapped *r = &LoadData_input_000015_remapped;
  if (res > MAX_ERR) { res += Mali_MemCpy((unsigned int *)0xd6036000, 0xd6036080, r->data_d6036080, 0, 0x060); };
  /* Return -1 if a compare fail */
  if (res) { return res; };
  return 0;
};
