#include "qc_verify.h"
#include "hdmi.h"
//#include "hdmi_reg.h"
#include "hdmi_tx_reg.h"
#include "hdmi_bus_reg.h"
//#include "VO_reg.h"
//#include "TV.h"
//#include "TVE_reg.h"
//#include "crt_sys_reg.h"
#include <qc_verify_common.h>
#include <rtd_types_qc.h>
#include "mhl_tx_cbus_reg.h"
#include "rbusCBUS_PMMReg.h"
#include "rbusCBUSReg.h"

    //mode 1: //TV NTSC-M (1440x480)
    //mode 2: //TV 480p
    //mode 3: //TV PAL (1440x480)
    //mode 4: //TV 576p
    //mode 5: //TV 720p60Hz
    //mode 6: //TV 1080i50Hz
    //mode 7: //TV 1080i60Hz
    //mode 17: //TV 480p
    //mode 18: //TV 1080p24Hz
    //mode 20: //TV 720p50Hz
    //mode 21: //TV 1080p50Hz
    //mode 22: //TV 1080p60Hz
    //mode 32: //TV 3840x2160 30Hz
    //mode 33: //TV 800x600 72Hz
    //mode 34: //TV 720x480i60Hz 13.5M
    //mode 35: //TV 3840x2160 60Hz

UINT8 case_mode = 22;
UINT8 rgb_mode = 2;	 //0:RGB444, 1:YCbCr420, 2:YCbCr444, 3:YCbCr422
UINT8 DVIorHDMI_flag=1; //0:DVI, 1:HDMI, 2:MHL
UINT8 xvYCC=0; //Extended-gamut YCC color space
//UINT8 PixelColorFormat=2; //0:RGB444, 1:YCbCr420, 2:YCbCr444, 3:YCbCr422
UINT8 DeepColorEnable=0; //0:disable 1:enable
UINT8 DeepColorDepth=4; //0:not indicated, 4:24bits, 5:30bits, 6:36bits, other:reserved
UINT8 TimingGen=1;        //0: TVE 1:HDMI
UINT8 Enable3D=0;
UINT8 Format3D=0;         //0: frame packing 1: field alternative 2: line alternative 3: side-by-side
                           //4: l+depth 5: l+depth+graphics+graphics-depth 6: top-and-down
                           //8: side-by-side(half)
bool mhl_pp_mode_en = 0;	//only for MHL

UINT8 AudioCodingType=0; //Refer to CEA-861B table 19.
UINT8 AudioChannelCount=1; // 1:2ch, 2:3ch, 3:4ch, 4:5ch, 5:6ch, 6:7ch, 7:8ch
UINT8 SamplingFrequency=3; // 1:32k, 2:44.1k, 3:48k, 4:88.2k, 5:96k, 6:176.4k, 7:192k
UINT8 SampleSize=3; // 1:16bit, 2:20bit, 3:24bit
UINT8 AudioType=1; //0:I2S 8ch-PCM, 1:I2S 2ch-PCM, 2:SPDIF PCM, 3:SPDIF RAW, 4:HBR
UINT8 CTSSource=0; //0:by CTShw, 1:by CTSsw

UINT8 Test_Mode=1; //(Audio InfoFrame)1:Refer to Stream Header
UINT32 mode;
UINT8 RGB_flag=0;
UINT8 mv_flag=1;
unsigned int sum;
unsigned int *sumbuf = &sum;
UINT8 *UART_flag = 1;

#define CEC_CTS_7_9 1
#define GDI_POWER_SAVING 0
#define Lookback_mode 0
#define QCINFO_CMD_BUFFER_SIZE  128
//#define OUTPUT_SRC_SELECT_HDMI 1		// 1:hdmi , 0:mhl
#define CBUS_R10K_LDO_ADJ 0

#if 0 	// move to hdmi.h 
#define Mag2_PTG_En 1				//0: normal QC code , 1: PTG function
#define QC_Code_For_Verify_Chip 1		// 1:output by key in command , 0:normal QC code flow
#define MHL_TX_CBUS_EN 0		//0: disable CBUS dicovery , 1: enable CBUS discovery
#define HDMI_TX_MBIST_CHECK 0		//QC code test BIST function
#endif

enum hdmi_tx_cmd {
    HDMI_TX_CMD_TEST_EXIT = 0,
    HDMI_TX_CMD_TEST_PROTOCOL,
    HDMI_TX_CMD_TEST_CEC,
    HDMI_TX_CMD_TEST_SCRIPT,
    HDMI_TX_CMD_ITEM_NUM
};

enum hdmi_tx_sub_cmd {
    HDMI_TX_SUB_CMD_NONE = 0,
    HDMI_TX_SUB_CMD_CONFIG_VIDEO_PARAM,
    HDMI_TX_SUB_CMD_CONFIG_AUDIO_PARAM,
    HDMI_TX_SUB_CMD_SET_AND_GO,
    HDMI_TX_SUB_CMD_ITEM_NUM
};

INT8* cmd_str_array[HDMI_TX_CMD_ITEM_NUM] = {"exit", "hdmi", "cec", "script"};
INT8* hdmi_tx_sub_cmd[HDMI_TX_SUB_CMD_ITEM_NUM] = {"none", "video", "audio", "go"};
INT32 hdmi_tx_argc = 0;
INT8 **hdmi_tx_argv = NULL;


//###########################################################################################################################
void BusyWaiting(UINT32 count)
{
    UINT32 i=0;
    if(count>10000)
        count=10000;
    while(count>0)
    {
        i=5; //about 200uS
        while(i>0) i--;
        count--;
    }
}


static void phy_default_setting()
{

//PHY setting
rtd_outl(0xb803de20, 0xbc4a8758);  //TX PLL parameter set, LDO_1V, VCO gain, internal LDO
rtd_outl(0xb803de24, 0x0fc00000);  //P2S LDO, preemphasis, termination R and C
rtd_outl(0xb803de28, 0x44442220);  //driving, pre-em driving current
rtd_outl(0xb803de2c, 0xc0032000);  //PLLDISP parameter, PLLDISP output disnable, PLLDISP power off
rtd_outl(0xb803de30, 0x20004002);  //PLLDISP N code, tmds div, pixel div
rtd_outl(0xb803de34, 0x00000000);  //Reserved
//rtd_outl(0xb803de0c, 0x93680013);  //PLLDISP N code = 19+3
rtd_outl(0xb803de0c, 0x9b780013);  //PLLDISP N code = 19+3
rtd_outl(0xb803de10, 0x1e200284);  //PLLDISP N code load
rtd_outl(0xb803de10, 0x1e200285);  //PLLDISP N code load


rtd_outl(0xb803de2c, 0xc0032001);  //PLLDISP parameter, PLLDISP output disnable, PLLDISP power on
rtd_outl(0xb803de2c, 0x40032001);  //PLLDISP parameter, PLLDISP output ennable, PLLDISP power on
rtd_outl(0xb803de20, 0xfc4a8758);  //TX PLL parameter set, LDO_1V, VCO gain, TX PLL power on

rtd_outl(0xb8000214, 0x00000100);  //HDMI_TMDS_DIV = 1

#if 0
//MAC setting
//HDMI TX timing gen
rtd_outl(0xb803d234, 0x0117077f);  // horizontal blank = 280-1, horizontal data active = 1920-1
rtd_outl(0xb803d238, 0x002b0057);  // horizontal sync width = 44 -1, horizontal front porch = 88-1
rtd_outl(0xb803d23c, 0x00000093);  // horizontal back proch = 148-1
rtd_outl(0xb803d240, 0x04370437);  // vertical single field size (only active video) = 1080 -1, vertical total data active (with active space) = 1080-1
rtd_outl(0xb803d24c, 0x000a002c);  // vertical sync width = 10, vertical blank = 45-1
rtd_outl(0xb803d250, 0x00230008);  // vertical back proch = 36-1, vertical front porch = 8

//HDMI TX pattern gen
rtd_outl(0xb803d2e0, 0x077f0437);  // H_act = 1920, V_act = 1080
//rtd_outl(0xb803d2e4, 0x81df010d);  // output picture type = color bar
rtd_outl(0xb803d2e4, 0x31df010d);  // output picture type = gray ramp
rtd_outl(0xb803d2e8, 0x3ff00000);  // color 0
rtd_outl(0xb803d2ec, 0x000ffc00);  // color 1
rtd_outl(0xb803d2f0, 0x000003ff);  // color 2
rtd_outl(0xb803d2f4, 0x3fffffff);  // color 3
rtd_outl(0xb803d2f8, 0x00000000);  // color 4
rtd_outl(0xb803d2fc, 0x000fffff);  // color 5
rtd_outl(0xb803d300, 0x3ffffc00);  // color 6
rtd_outl(0xb803d304, 0x3ff003ff);  // color 7
rtd_outl(0xb803d2e0, 0x877f0437);  // pattern gen enable


rtd_outl(0xb803d034, 0xc00000a2);  // TMDS encoder disable, HDMI disable, HDCP1.4, data from pattern gen
//rtd_outl(0xb800d0bc, 0x14000000);  // disable HDMI audio data path, off debug color path
//rtd_outl(0xb800d030, 0x00000924);  // hsync/vsync delay all 0
rtd_outl(0xb803d154, 0x5280f100);  // video format change wait 1 vsync, do not use setting first deep color phase by SW, setting first deep color phase by SW, use default deep phase by SW, default phase, do not deep color mode
rtd_outl(0xb803d020, 0x00002004);  // image end signal (don't care in FPGA), progressive HD mode, HDMI timing genator enable
//rtd_outl(0xb800d0a4, 0x0000007e);  // enable transmission periodic island packet (active when [0]=1)

// YCbCr mode (no transform0
rtd_outl(0xb803d024, 0x00004000);
rtd_outl(0xb803d028, 0x00000000);
rtd_outl(0xb803d02c, 0x00000000);
rtd_outl(0xb803d200, 0x00000000);
rtd_outl(0xb803d204, 0x00004000);
rtd_outl(0xb803d208, 0x00000000);
rtd_outl(0xb803d20c, 0x00000000);
rtd_outl(0xb803d210, 0x00000000);
rtd_outl(0xb803d214, 0x00004000);
rtd_outl(0xb803d218, 0x00000000);
rtd_outl(0xb803d21c, 0x00000000);
rtd_outl(0xb803d220, 0x00000000);

//rtd_outl(0xb803d078, 0x00000008);  // enable GCP trnsmission
//rtd_outl(0xb803d078, 0x00000009);  // enable GCP trnsmission (writen enable)
//rtd_outl(0xb803d0a0, 0x21084210);  // setting periodic island packet cycle length
rtd_outl(0xb803d0b4, 0x00000c66);  // max packet length = 18-1 in vertical blanking, max packet length = 6-1 in horizontal blanking
rtd_outl(0xb803d0b8, 0x0005506b);  // YCbcr444, not repeat pixel, HDMI mode, HS/VS +polarity
//rtd_outl(0xb803d0b8, 0x0007b06b);  // YCbcr444, not repeat pixel, HDMI mode, HS/VS -polarity 

//rtd_outl(0xb803d07c, 0x000d0282);  // packet type=0x82, version=0x02, length=0x0d
//rtd_outl(0xb803d080, 0x20a82077);  // no IT contect, sYCC601, RGB quantization range = default, no knonw non-uniform scaling,
                   // colorimetry=ITU709, picture aspect ratio=16:9, active format aspect ratio=same as picture aspect ratio,
                   // YCbCr444, active format vaild, bar data not vaild, no scan information
                   // checksum = ~(0x82+0x02+0x0d+0x00+0x20+0xa8+0x20+0x10+0x00)+1 = 0x77
//rtd_outl(0xb800d084, 0x00000010);  // no pixel reperirion, video code = 16
//rtd_outl(0xb800d088, 0x00000000);
//rtd_outl(0xb800d08c, 0x00000000);
//rtd_outl(0xb800d090, 0x00000000);
//rtd_outl(0xb800d094, 0x00000000);
//rtd_outl(0xb800d098, 0x00000000);
//rtd_outl(0xb800d09c, 0x00000000);
rtd_outl(0xb803d0b0, 0x00007700);  // enable write periodic island packet SRAM, periodic island packet SRAM start address = 0x00
rtd_outl(0xb803d0a0, 0x00000011);  // write trnsmission period of periodic island packet SRAM
rtd_outl(0xb803d0a4, 0x00000003);  // enable transmission periodic island packet (active when [0]=1)

rtd_outl(0xb803d158, 0x00000300);  // video format change

rtd_outl(0xb803d2a4, 0x0000c000);  // reset TMDS data output async FIFO
rtd_outl(0xb803d2a4, 0x00000000);  // reset TMDS data output async FIFO

//rtd_outl(0xb803d14c, 0xc0000032);  // PRBS7 output
rtd_outl(0xb803d2a8, 0x00000000);  // Scramble disable , GB TMDS COUNT disable

rtd_outl(0xb803d034, 0xc00000f3);  // TMDS encoder enable, HDMI enable

//PHY output lane 
rtd_outl(0xb803de24, 0x0ffc0000);  //Lane0~3 output enable
#endif

	rtd_maskl(HDMI_BUS_PHY_CTRL1_reg, ~HDMI_BUS_PHY_CTRL1_pll_ldo_lv_sel_mask, HDMI_BUS_PHY_CTRL1_pll_ldo_lv_sel(1));	//pll_ldo_1v_sel
	rtd_maskl(HDMI_BUS_PHY_CTRL1_reg, ~HDMI_BUS_PHY_CTRL1_pll_ldo_v18_sel_mask, HDMI_BUS_PHY_CTRL1_pll_ldo_v18_sel(1));	//pll_ldo_v18_sel
	rtd_maskl(HDMI_BUS_PHY_CTRL2_reg, ~HDMI_BUS_PHY_CTRL2_p2s_ldo_sel_mask, HDMI_BUS_PHY_CTRL2_p2s_ldo_sel(0));		//p2s_ldo_sel
	rtd_maskl(HDMI_BUS_PHY_CTRL5_reg, ~HDMI_BUS_PHY_CTRL5_plldisp_ldosel_mask, HDMI_BUS_PHY_CTRL5_plldisp_ldosel(0));		//plldisp_ldo_sel

	rtd_maskl(HDMI_BUS_PHY_CTRL5_reg, ~HDMI_BUS_PHY_CTRL5_plldisp_r3_mask, HDMI_BUS_PHY_CTRL5_plldisp_r3(1));		//input clk pre-divider sel negative edge

}

void Display(UINT32 mode, UINT32 colorbar, UINT32 RGB_mode, UINT32 video_format, bool pp_mode_en)
{ 

    SET_HDMI_Video(mode, RGB_mode, DVIorHDMI_flag, DeepColorEnable, DeepColorDepth, xvYCC, TimingGen, Enable3D, Format3D, pp_mode_en);
    ///SET_HDMI_Audio(mode, DVIorHDMI_flag, SamplingFrequency, SampleSize, AudioChannelCount, AudioType, CTSSource);
    GO_function(mode, 1, 1);
   // return;
}


static int get_hdmi_tx_sub_cmd_enum(INT8 *str)
{
    int i, ret = HDMI_TX_SUB_CMD_NONE;
    for (i = 0; i < HDMI_TX_SUB_CMD_ITEM_NUM; i++)
    {
        if (strcmp(hdmi_tx_sub_cmd[i], str) == 0)
        {
            ret = i;
            break;
        }
    }
    return ret;
}

static void config_video_param(void)
{
    //hdmi video case_mode DeepColorEnable DeepColorDepth TimingGen Enable3D Format3D rgb_mode
    case_mode = strtoul((const INT8 *) (hdmi_tx_argv[2]), (INT8 **) NULL, 10);
    DeepColorEnable = strtoul((const INT8 *) (hdmi_tx_argv[3]), (INT8 **) NULL, 10);
    DeepColorDepth = strtoul((const INT8 *) (hdmi_tx_argv[4]), (INT8 **) NULL, 10);
    TimingGen = strtoul((const INT8 *) (hdmi_tx_argv[5]), (INT8 **) NULL, 10);
    Enable3D = strtoul((const INT8 *) (hdmi_tx_argv[6]), (INT8 **) NULL, 10);
    Format3D = strtoul((const INT8 *) (hdmi_tx_argv[7]), (INT8 **) NULL, 10);
    rgb_mode = strtoul((const INT8 *) (hdmi_tx_argv[8]), (INT8 **) NULL, 10);
    mhl_pp_mode_en = strtoul((const INT8 *) (hdmi_tx_argv[9]), (INT8 **) NULL, 10);
    DVIorHDMI_flag = strtoul((const INT8 *) (hdmi_tx_argv[10]), (INT8 **) NULL, 10);
    printf("%d, %d, %d, %d, %d, %d, %d, %d, %d\n",
            case_mode, DeepColorEnable, DeepColorDepth,
            TimingGen, Enable3D, Format3D, rgb_mode, mhl_pp_mode_en, DVIorHDMI_flag);
    //rtd_maskl(0xb80001c4, 0xffc3ffff, 0x00000);
}

static void config_audio_param(void)
{
    //hdmi audio SamplingFrequency SampleSize AudioChannelCount AudioType CTSSource
    SamplingFrequency = strtoul((const INT8 *) (hdmi_tx_argv[2]), (INT8 **) NULL, 10);
    SampleSize = strtoul((const INT8 *) (hdmi_tx_argv[3]), (INT8 **) NULL, 10);
    AudioChannelCount = strtoul((const INT8 *) (hdmi_tx_argv[4]), (INT8 **) NULL, 10);
    AudioType = strtoul((const INT8 *) (hdmi_tx_argv[5]), (INT8 **) NULL, 10);
    CTSSource = strtoul((const INT8 *) (hdmi_tx_argv[6]), (INT8 **) NULL, 10);
    printf("%d, %d, %d, %d, %d\n",
            SamplingFrequency, SampleSize, AudioChannelCount,
            AudioType, CTSSource);
}


static void mhl_tx_cbus_init(void)
{
	UINT32 value1,value2;
	
	printk("[CBUS TX] CBUS setting init!!\n");
	
	//CRT setting
	rtd_maskl(0xb8000104, 0xffffb9ff, 0x4600);  //CBUS, HDMI RX, HDMI TX reset release
	rtd_maskl(0xb800010c, 0xffffefff, 0x1000);  //HDMI TX PLL reset release

	rtd_maskl(0xb8000114, 0xffffb9ff, 0x4600);  //CBUS, HDMI RX, HDMI TX clk enable

	rtd_maskl(0xb8060034, 0xffffffcf, 0x30);  //ST CBUS TX RX reset release
	rtd_maskl(0xb8060044, 0xffffffcf, 0x30);  //ST CBUS TX and RX clk enable
	rtd_maskl(0xb8060044, 0xfffffbff, 0x400);  //ST CBUS TX IP clk enable

	//CBUS PHY
	//rtd_outl(0xb8062b1c, 0x00000000);	// CBUS_EN_TX (en_driver_tx) FW mode control enable

#if CBUS_R10K_LDO_ADJ
	value1=rtd_inl(0xb8062b30);
	value1=(value1&(_BIT10|_BIT9|_BIT8));
	value2=rtd_inl(0xb8062b38);
	value2=(value2&(_BIT14|_BIT13|_BIT12));
#endif

	//rtd_outl(0xb8062b30, 0x00000b03);	// CBUS bias and LDO enable
	rtd_outl(0xb8062b30, 0x00000a03);	// CBUS bias and LDO enable, LDO=0x10
	//rtd_outl(0xb8062b38, 0x0b0ab607);	// BMOS enable, GPIO_CBUS sel, CBUS enable
	//rtd_outl(0xb8062b38, 0x0b0ab637);	// BMOS enable, GPIO_CBUS sel, CBUS enable , strength sel 0x3
	rtd_outl(0xb8062b38, 0x08CAB637);	// BMOS enable, GPIO_CBUS sel, CBUS enable , strength sel 0x3

#if CBUS_R10K_LDO_ADJ
	rtd_maskl(0xb8062b30, 0xfffff8ff, value1);	//LDO voltage
	rtd_maskl(0xb8062b38, 0xffff8fff, value2);	//R10K value
#endif	

	//CBUS MAC
	rtd_outl(0xb8062c04, 0x0363E896);	//Tsrc_float = 52ms
	rtd_outl(0xb8062c00, 0x00000100);	//MHL disable , CBUS clk cycle time
	rtd_outl(0xb8062c00, 0x80000100);	//MHL enable , CBUS clk cycle time


#if 0	//for CBUS connect RXsense function
//HDMI TX PHY setting
rtd_outl(0xb803de20, 0xbc468759);  //TX PLL parameter set, LDO_1V, VCO gain, internal LDO
rtd_outl(0xb803de24, 0x084000e8);  //P2S LDO, preemphasis, termination R and C
//rtd_outl(0xb803de24, 0x0840fc00);  //P2S LDO, preemphasis, termination R and C
rtd_outl(0xb803de28, 0x77745550);  //driving, pre-em driving current
rtd_outl(0xb803de2c, 0xf0071000);  //PLLDISP parameter, PLLDISP output disnable, PLLDISP power off
rtd_outl(0xb803de30, 0x30022002);  //PLLDISP N code, tmds div, pixel div
rtd_outl(0xb803de34, 0x00000000);  //Reserved
//rtd_outl(0xb803de0c, 0x93680013);  //PLLDISP N code = 19+3
rtd_outl(0xb803de0c, 0x9b780013);  //PLLDISP N code = 19+3
rtd_outl(0xb803de10, 0x1e200284);  //PLLDISP N code load
rtd_outl(0xb803de10, 0x1e200285);  //PLLDISP N code load

rtd_outl(0xb803de2c, 0xf0071001);  //PLLDISP parameter, PLLDISP output disnable, PLLDISP power on
rtd_outl(0xb803de2c, 0x70071001);  //PLLDISP parameter, PLLDISP output ennable, PLLDISP power on
rtd_outl(0xb803de20, 0xfc468759);  //TX PLL parameter set, LDO_1V, VCO gain, TX PLL power on

rtd_outl(0xb803de24, 0x084200e8);  //P2S LDO, preemphasis, termination R and C, MHL mode enable
//rtd_outl(0xb803de24, 0x0842fc00);  //P2S LDO, preemphasis, termination R and C, MHL mode enable
rtd_outl(0xb803de24, 0x086200e8);  //B CH lane output enable , for RXsense normal work

rtd_outl(0xb8000214, 0x00001100);  //HDMI_TMDS_DIV = 2
#else if
rtd_outl(0xb803de24, 0x00730000);  //HDMI TX bias enable, B CH lane output enable, B channel MHL mode enable, for RXsense normal work
#endif
	
}


static int mhl_tx_cbus_connect(void)
{
    //CBUS_MSC_CMD_PARAM_ST param;
    cbus_dis1_RBUS dis1;
    //cbus_phy0_RBUS phy0;
    cbus_test_RBUS test;
    cbus_RBUS cbus0;
    fw0_req_01_RBUS fw0_req_01;
    cbus_dis4_RBUS dis4;
    msc_reg_31_RBUS msc_31;
    msc_reg_30_RBUS msc_30;
    cbus_msc_06_RBUS cbus_msc_06;
    cbus_dummy0_RBUS dummy0;
    int ret, rst = 0, cnt = 5000;
    UINT32 path_en_cnt = 500;

#if 0	//RXsense debug output from PHY flag
	rtd_part_outl(0xb806023c, 15, 8, 0x0e); // ST top sel CBUS TX
	rtd_part_outl(0xb8062e64, 4, 4, 0x1); //Debug port ouput enable
	rtd_part_outl(0xb8062e64, 3, 0, 0x0); //Debug port sel , RXsense is bit[3] from PHY flag
	
	rtd_part_outl(0xb8060204, 15, 12, 0x2); //pad_st_gpio_06_io, ST_dbg_bit[4]
#endif	


#if 0		//RXsense fW mode setting
    	cbus_dis0_RBUS dis0;
	dis0.regValue = rtd_inl(CBUS_DIS0_VADDR);
	dis0.rxsense_fw_mode=1;
	dis0.rxsense_fw_value=1;
	rtd_outl(CBUS_DIS0_VADDR, dis0.regValue);	
#endif

    dis1.regValue = rtd_inl(CBUS_DIS1_VADDR);
    if (!dis1.both_path_en)
    {
        test.regValue = rtd_inl(CBUS_TEST_VADDR);
        test.fw_control_r10k = 0;					//R10K enable sel HW mode
        rtd_outl(CBUS_TEST_VADDR, test.regValue);

        dis4.regValue = 0;
        rtd_outl(CBUS_DIS4_VADDR, dis4.regValue);

        printk("- status = 0x%08x\n", rtd_inl(CBUS_DIS4_VADDR));
        //CBUS
        fw0_req_01.regValue = rtd_inl(FW0_REQ_01_VADDR);
        fw0_req_01.check_fw0_msg_processing = 0;	//clear FSM IRQ
        rtd_outl(FW0_REQ_01_VADDR, fw0_req_01.regValue);

        cbus0.regValue = rtd_inl(CBUS_VADDR);
        cbus0.enable = 1;						//CBUS MAC enable
        rtd_outl(CBUS_VADDR, cbus0.regValue);

        printk("- after cbus enable status = 0x%08x, 1k stus = 0x%08x\n", rtd_inl(CBUS_DIS4_VADDR), rtd_inl(0xb8062c20));
        while (1)
        {
            dis4.regValue = rtd_inl(CBUS_DIS4_VADDR);
            if ((dis4.src3_10 == 1) ||
                (dis4.src3_09 == 1) ||
                (dis4.src3_08 == 1) ||
                (dis4.src3_07 == 1) ||
                (dis4.src3_06 == 1) ||
                (dis4.src3_05 == 1) ||
                (dis4.src3_04 == 1) ||
                (dis4.src3_03 == 1) ||
                (dis4.src3_02 == 1) ||
                (dis4.src3_01 == 1) ||
                (dis4.src3_00 == 1))
            {
                printk("- src3 state, status = 0x%08x, 1k stus = 0x%08x\n", dis4.regValue, rtd_inl(0xb8062c20));

                //printk("- first off 1k det = 0x%08x, then status = 0x%08x, 1k stus = 0x%08x\n", rtd_inl(CBUS_PHY0_VADDR), rtd_inl(CBUS_DIS4_VADDR), rtd_inl(0xb8062c20));
            }
            else if (dis4.src1 == 1)
            {
                printk("- src1 state, status = 0x%08x, 1k stus = 0x%08x\n", dis4.regValue, rtd_inl(0xb8062c20));
            }
            else if (dis4.src2 == 1)
            {
                printk("- src2 state, status = 0x%08x, 1k stus = 0x%08x\n", dis4.regValue, rtd_inl(0xb8062c20));
            }
            else if (dis4.src0 == 1)
            {
                printk("- src0 state, status = 0x%08x, 1k stus = 0x%08x\n", dis4.regValue, rtd_inl(0xb8062c20));
            }
            else if ((dis4.irq_src6_7 == 0) && (dis4.src4 == 1))
            {
                printk("- src4 state, status = 0x%08x, 1k stus = 0x%08x\n", dis4.regValue, rtd_inl(0xb8062c20));
            }
            else if ((dis4.irq_src6_7 == 1) && (dis4.src5 == 0))
            {
                printk("- happen src3 / src4 time out to src7, status = 0x%08x, 1k stus = 0x%08x\n", dis4.regValue, rtd_inl(0xb8062c20));
                dis4.irq_src6_7 = 0;
                rtd_outl(CBUS_DIS4_VADDR, dis4.regValue);

                //printk("- first on 1k det = 0x%08x, then status = 0x%08x, 1k stus = 0x%08x\n", rtd_inl(CBUS_PHY0_VADDR), rtd_inl(CBUS_DIS4_VADDR), rtd_inl(0xb8062c20));
            }
            else if ((dis4.irq_src6_7 == 1) && (dis4.src5 == 1))
            {
                printk("- happen src5 time out to src7, status = 0x%08x, 1k stus = 0x%08x\n", dis4.regValue, rtd_inl(0xb8062c20));
                dis4.irq_src6_7 = 0;
                rtd_outl(CBUS_DIS4_VADDR, dis4.regValue);

            #if 0
                phy0.regValue = rtd_inl(CBUS_PHY0_VADDR);
                phy0.reg_mhl_r1k_det = 1;
                phy0.reg_r1k_vth_sel = 1;
                rtd_outl(CBUS_PHY0_VADDR, phy0.regValue);
            #endif

                //printk("- first on 1k det = 0x%08x, then status = 0x%08x, 1k stus = 0x%08x\n", rtd_inl(CBUS_PHY0_VADDR), rtd_inl(CBUS_DIS4_VADDR), rtd_inl(0xb8062c20));
            }
            else if ((dis4.irq_src6_7 == 0) && (dis4.src5 == 1))
            {
                printk("- src5 state, status = 0x%08x, 1k stus = 0x%08x\n", dis4.regValue, rtd_inl(0xb8062c20));
                break;
            }
            // cnt--;
        }

        printk("- wait path enable\n");
        while (path_en_cnt)	//wait path enable or HPD or capability command from sink
        {
		//printk("- 0xb8062c84 = 0x%08x\n",  rtd_inl(MSC_REG_30_VADDR));
		//printk("- 0xb8062c88 = 0x%08x\n",  rtd_inl(MSC_REG_31_VADDR));
		//printk("- 0xb8062d98 = 0x%08x\n\n", rtd_inl(CBUS_MSC_06_VADDR));

            msc_31.regValue = rtd_inl(MSC_REG_31_VADDR);
            msc_30.regValue = rtd_inl(MSC_REG_30_VADDR);
            cbus_msc_06.regValue = rtd_inl(CBUS_MSC_06_VADDR);
            if ((msc_31.path_en && cbus_msc_06.irq_path_en_chg) ||
                (msc_30.dcap_rdy && cbus_msc_06.irq_dcap_rdy_chg)||cbus_msc_06.irq_set_hpd)
            {
                printk("- path enable flag = %d, rdy flag = %d\n, hpd set flag = %d\n", msc_31.path_en, msc_30.dcap_rdy, cbus_msc_06.irq_set_hpd);
                cbus_msc_06.irq_path_en_chg = 0;
                cbus_msc_06.irq_dcap_rdy_chg = 0;
                cbus_msc_06.irq_set_hpd = 0;
                rtd_outl(CBUS_MSC_06_VADDR,cbus_msc_06.regValue);
                break;
            }
            path_en_cnt--;
        }

        // param.cmd = MSC_CMD_WRITE_STAT_SET_INT;
        // param.offset = 0x31;
        // param.data0 = 0x8;
        // param.data1 = 0;
        // param.data_len = 0;
        // ret = set_msc_cmd_case0(&param);
        // check_return_err_code(ret);

        //CBUS both_en = 1
        if (path_en_cnt)
        {
            dis1.regValue = rtd_inl(CBUS_DIS1_VADDR);
            dis1.both_path_en = 1;
            rtd_outl(CBUS_DIS1_VADDR, dis1.regValue);	//entry src6 by FW

            printk("- receive path enable, entry src6\n");
            //while ((rtd_inl(CBUS_DIS4_VADDR) & 0x00002000) == 0);
        }
        else
        {
            dis1.regValue = rtd_inl(CBUS_DIS1_VADDR);
            dis1.both_path_en = 1;
            rtd_outl(CBUS_DIS1_VADDR, dis1.regValue);	//entry src6 by FW
            
            printk("- wait path enable time out, and entry src6\n");
            //while ((rtd_inl(CBUS_DIS4_VADDR) & 0x00002000) == 0);
            rst = -1;
        }
    }

    return rst;

}


static void system_init(void)
{
	printk("[HDMI TX] system init\n");

	// CRT initial start	
	rtd_maskl(0xb8000104, 0xffffb9ff, 0x4600);  //CBUS, HDMI RX, HDMI TX reset release
	rtd_maskl(0xb800010c, 0xffffefff, 0x1000);  //HDMI TX PLL reset release
	rtd_maskl(0xb8000114, 0xffffb9ff, 0x4600);  //CBUS, HDMI RX, HDMI TX clk enable

	phy_default_setting();	//PHY LDO setting

#if MHL_TX_CBUS_EN 
	mhl_tx_cbus_init();
	mhl_tx_cbus_connect();
#endif

}


static void set_and_go(void)
{
    UINT32 mode, colorbar, pattern;
    UINT32 RGB_mode, video_format;
    UINT32 T_COUNT=0;
    UINT8 i=0;
    UINT32 test_pattern[]={1,22};
    int result=0;

    //mode 1: //TV NTSC-M
    //mode 2: //TV 525p
    //mode 3: //TV PAL
    //mode 4: //TV 626p
    //mode 5: //TV 720p60Hz
    //mode 6: //TV 1080i50Hz
    //mode 7: //TV 1080i60Hz
    //mode 18: //TV 1080p24Hz
    //mode 20: //TV 720p50Hz
    //mode 21: //TV 1080p50Hz
    //mode 22: //TV 1080p60Hz
    //Default display type=============================================
    //mode = 22; //4

    mode = case_mode;
    RGB_mode = rgb_mode;
    //mode =test_pattern[1];
    //DeepColorEnable=0;
    //DeepColorDepth=4; //0:not indicated, 4:24bits, 5:30bits, 6:36bits, other:reserved
    //TimingGen=0;        //0: TVE 1:HDMI
    //Enable3D=0;
    //Format3D=0; //0:frame packing 1:field alternative 2:Line alternative 3:Side-by-Side(Full) 4:L+depth 5:L+depth+graphics... 6:Top/bottom 8:Side-by-Side(Half)
    colorbar = 4; // not use
    pattern=0; // not use
    //RGB_mode = 1;
    video_format = 1; // not use

    Display(mode, colorbar, RGB_mode, video_format, mhl_pp_mode_en);
 
}

void HDMI_Test(void){
    UINT32 mode, colorbar, pattern;
    UINT32 RGB_mode, video_format;
    UINT32 T_COUNT=0;
    UINT8 i=0;
    UINT32 test_pattern[]={1,22};
    int result=0, sub_cmd;

    sub_cmd = get_hdmi_tx_sub_cmd_enum(*(&hdmi_tx_argv[1]));

    switch (sub_cmd) {

        case HDMI_TX_SUB_CMD_CONFIG_VIDEO_PARAM:
            printf("- config video param\n");
            config_video_param();
            break;
        case HDMI_TX_SUB_CMD_CONFIG_AUDIO_PARAM:
            printf("- config audio param\n");
            config_audio_param();
            break;
        case HDMI_TX_SUB_CMD_SET_AND_GO:
            printf("- set and go\n");
            set_and_go();
            break;
        default:
            printf("- none\n");
            break;
    }

    return SUCCESS;
}
#if 0
BOOL CCec_Test(void)
{
    //Set RESET and CLOCK enable=======================================
    rtd_maskl(SYS_CLOCK_ENABLE1_reg,~_BIT8, _BIT8); //enable hdmi clock
    rtd_maskl(SYS_SOFT_RESET1_reg,~_BIT12, _BIT12); //hdmi reset disable
    rtd_maskl(SYS_CLOCK_ENABLE2_reg,~_BIT11, _BIT11); //enable cec clock
    rtd_maskl(SYS_SOFT_RESET2_reg,~_BIT21, _BIT21); //cec reset disable

#if Lookback_mode
    UINT32 CEC_DATA[2][4];
    UINT8 i,timeoutcnt=255;

    CEC_DATA[0][0]=0x00112233;
    CEC_DATA[0][1]=0x44556677;
    CEC_DATA[0][2]=0x8899aabb;
    CEC_DATA[0][3]=0xccddee00;

    //rtd_outl(HDMI_CEC_CR0_ADDR,0xc714fc1f);       //CEC loop back enable, RBUS=202MHz, addr is 0x7
    rtd_outl(HDMI_CEC_CR0_ADDR,0xc714221f);     //CEC loop back enable, RBUS=27MHz, addr is 0x7
    rtd_outl(HDMI_CEC_TxCR0_ADDR,0x0507c0);     //CEC TX addr is 0x5, dest addr is 0x7
    rtd_outl(HDMI_CEC_RxTCR0_ADDR,0x8abc2a50);      //start low 0x8c->0x8a,data period 0x52->0x50 for 27MHz
    rtd_maskl(HDMI_CEC_TxCR0_ADDR,~_BIT20,_BIT20);      //CEC TX addr enable

    rtd_outl(HDMI_CEC_TxDR1_ADDR,CEC_DATA[0][0]);       //CEC TX FIFO
    rtd_outl(HDMI_CEC_TxDR2_ADDR,CEC_DATA[0][1]);       //CEC TX FIFO
    rtd_outl(HDMI_CEC_TxDR3_ADDR,CEC_DATA[0][2]);       //CEC TX FIFO
    rtd_outl(HDMI_CEC_TxDR4_ADDR,CEC_DATA[0][3]);       //CEC TX FIFO
    rtd_outl(HDMI_CEC_TxDR0_ADDR,0xf);                  //CEC TX FIFO num


    rtd_maskl(HDMI_CEC_RxCR0_ADDR,~_BIT14,_BIT14);      //CEC RX reset
    rtd_maskl(HDMI_CEC_TxCR0_ADDR,~_BIT14,_BIT14);      //CEC TX reset
    udelay(1000);
    rtd_maskl(HDMI_CEC_RxCR0_ADDR,~_BIT14,0x0);     //CEC RX reset
    rtd_maskl(HDMI_CEC_TxCR0_ADDR,~_BIT14,0x0);     //CEC TX reset
    udelay(1000);
    rtd_maskl(HDMI_CEC_TxDR0_ADDR,~_BIT6,_BIT6);        //CEC TX FIFO num double buffer load
    rtd_maskl(HDMI_CEC_RxCR0_ADDR,~_BIT15,_BIT15);      //CEC RX reset
    udelay(1000);
    rtd_maskl(HDMI_CEC_TxCR0_ADDR,~_BIT15,_BIT15);      //CEC TX enable
    rtd_maskl(HDMI_CEC_RxCR0_ADDR,~_BIT6,_BIT6);        //clr RX interrupt flag
    do                                          //wait RX ok flag
    {
        udelay(5000);
        if((rtd_inl(HDMI_CEC_RxCR0_ADDR) & _BIT6))
            break;
    } while (--timeoutcnt);
    if (timeoutcnt==0)
        printk("wait CEC RX timeout!!!\n");

    CEC_DATA[1][0]=rtd_inl(HDMI_CEC_RxDR1_ADDR);
    CEC_DATA[1][1]=rtd_inl(HDMI_CEC_RxDR2_ADDR);
    CEC_DATA[1][2]=rtd_inl(HDMI_CEC_RxDR3_ADDR);
    CEC_DATA[1][3]=rtd_inl(HDMI_CEC_RxDR4_ADDR);

    for (i=0;i<4;i++)
        {
        if (CEC_DATA[0][i]!=CEC_DATA[1][i])
            return FALSE;
        }
    return TRUE;
#else
#if CEC_CTS_7_9
    UINT32 CEC_DATA[2][4];
    UINT32 timeoutcnt=25500;
    UINT32 init_addr,broadcast_flag;
    UINT8  i=0,rx_len=0,j=0;

while(i<2){
    printk("CEC Init ...\n");
    i++;
    CEC_DATA[0][0]=0x00112233;
    CEC_DATA[0][1]=0x44556677;
    CEC_DATA[0][2]=0x8899aabb;
    CEC_DATA[0][3]=0xccddee00;

    //rtd_outl(HDMI_CEC_CR0_ADDR,0x4414fc1f);       //CEC enable, RBUS=202MHz, addr is 0x0
    rtd_outl(HDMI_CEC_CR0_ADDR,0x4414221f);     //CEC enable, RBUS=27MHz, addr is 0x4
    rtd_outl(HDMI_CEC_TxCR0_ADDR,0x0507c0);     //CEC TX addr is 0x5, dest addr is 0x7
    rtd_outl(HDMI_CEC_RxTCR0_ADDR,0x8abc2a50);      //start low 0x8c->0x8a,data period 0x52->0x50 for 27MHz
    //rtd_maskl(HDMI_CEC_TxCR0_ADDR,~_BIT20,_BIT20);        //CEC TX addr enable
    rtd_maskl(HDMI_CEC_RTCR0_ADDR,0x0000ffff,0x05670000);       //LA3=5,LA2=6,LA1=7, for DMP use

    rtd_outl(HDMI_CEC_TxDR1_ADDR,CEC_DATA[0][0]);       //CEC TX FIFO
    rtd_outl(HDMI_CEC_TxDR2_ADDR,CEC_DATA[0][1]);       //CEC TX FIFO
    rtd_outl(HDMI_CEC_TxDR3_ADDR,CEC_DATA[0][2]);       //CEC TX FIFO
    rtd_outl(HDMI_CEC_TxDR4_ADDR,CEC_DATA[0][3]);       //CEC TX FIFO
    //rtd_outl(HDMI_CEC_TxDR0_ADDR,0xf);                    //CEC TX FIFO num

    rtd_maskl(HDMI_CEC_RxCR0_ADDR,~_BIT14,_BIT14);      //CEC RX reset
    rtd_maskl(HDMI_CEC_TxCR0_ADDR,~_BIT14,_BIT14);      //CEC TX reset
    udelay(1000);
    rtd_maskl(HDMI_CEC_RxCR0_ADDR,~_BIT14,0x0);     //CEC RX normal
    rtd_maskl(HDMI_CEC_TxCR0_ADDR,~_BIT14,0x0);     //CEC TX normal
    udelay(1000);
    //rtd_maskl(HDMI_CEC_TxDR0_ADDR,~_BIT6,_BIT6);      //CEC TX FIFO num double buffer load
    rtd_maskl(HDMI_CEC_RxCR0_ADDR,~_BIT15,_BIT15);      //CEC RX enable
    udelay(1000);
    //rtd_maskl(HDMI_CEC_TxCR0_ADDR,~_BIT15,_BIT15);        //CEC TX enable
    rtd_maskl(HDMI_CEC_RxCR0_ADDR,~_BIT6,_BIT6);        //clr RX interrupt flag

#if GDI_POWER_SAVING
    rtd_outl(GDI_CEC_COMPARE_OPCODE_01,0xff);
    rtd_outl(GDI_CEC_SEND_OPCODE_01,0x00);
    rtd_outl(GDI_CEC_COMPARE_OPCODE_02,0x83);
    rtd_outl(GDI_CEC_SEND_OPCODE_02,0x84);
    rtd_outl(GDI_CEC_OPERAND_04,0x10);
    rtd_outl(GDI_CEC_OPERAND_05,0x00);
    rtd_outl(GDI_CEC_SEND_OPERAND_NUMBER_01,0x00);      //opcode number = 0
    rtd_outl(GDI_CEC_SEND_OPERAND_NUMBER_02,0x02);      //opcode number = 2
    rtd_outl(GDI_CEC_OPCODE_ENABLE,0x03);               //compare opcode1,opcode2 enable
    rtd_maskl(GDI_POWER_SAVING_MODE,~_BIT8,_BIT8);      //Irq enable
#endif

    do                                          //wait RX ok flag
    {
        udelay(5000);
        if((rtd_inl(HDMI_CEC_RxCR0_ADDR) & _BIT6))
            break;
    } while (--timeoutcnt);
    if (timeoutcnt==0)
        printk("wait CEC RX timeout!!!\n");

    init_addr=(rtd_inl(HDMI_CEC_RxCR0_ADDR)&0x0f00);
    broadcast_flag = (rtd_inl(HDMI_CEC_RxCR0_ADDR)>>31);
    rx_len= rtd_inl(HDMI_CEC_RxCR0_ADDR)&0x1f;
    CEC_DATA[1][0]=rtd_inl(HDMI_CEC_RxDR1_ADDR);
    CEC_DATA[1][1]=rtd_inl(HDMI_CEC_RxDR2_ADDR);
    CEC_DATA[1][2]=rtd_inl(HDMI_CEC_RxDR3_ADDR);
    CEC_DATA[1][3]=rtd_inl(HDMI_CEC_RxDR4_ADDR);

    printk("init_addr = %x\n",init_addr);
    printk("broadcast_flag = %x\n",broadcast_flag);
    printk("rx_len = %d\n",rx_len);
    if (rx_len>0)
        printk("CEC_DATA[1][0] = %x\n",CEC_DATA[1][0]);

    if(rx_len>4)
        printk("CEC_DATA[1][1] = %x\n",CEC_DATA[1][1]);

    if(rx_len>8)
        printk("CEC_DATA[1][2] = %x\n",CEC_DATA[1][2]);

    if(rx_len>12)
        printk("CEC_DATA[1][3] = %x\n",CEC_DATA[1][3]);

#if GDI_POWER_SAVING
    if((rtd_inl(GDI_POWER_SAVING_MODE) & _BIT31))
        printk("GDI_POWER_SAVING_MODE IRQ PENDING\n");

    rtd_maskl(GDI_POWER_SAVING_MODE,~_BIT31,_BIT31);        //clr Irq
    j=20;
    do
    {
        udelay(5000);

    } while (--j);
#else

    if (((CEC_DATA[1][0]>>24) == 0xff)&&(broadcast_flag == 0))//cmd=Abort
    {
        CEC_DATA[0][0]=(0x00<<24);
        rtd_outl(HDMI_CEC_TxDR1_ADDR,CEC_DATA[0][0]);       //CEC TX FIFO
        rtd_outl(HDMI_CEC_TxDR0_ADDR,0x1);                  //CEC TX FIFO num=1
        rtd_maskl(HDMI_CEC_TxDR0_ADDR,~_BIT6,_BIT6);        //CEC TX FIFO num double buffer load
        rtd_maskl(HDMI_CEC_TxCR0_ADDR,~0x00000f00,init_addr);       //dest addr
        rtd_maskl(HDMI_CEC_TxCR0_ADDR,~_BIT15,_BIT15);      //CEC TX enable
        printk("CEC TX send <Feature Abort >\n");
        do                                          //wait TX ok flag
        {
            udelay(5000);
            if((rtd_inl(HDMI_CEC_TxCR0_ADDR) & _BIT6))
                break;
        } while (--timeoutcnt);

        if (timeoutcnt==0)
            printk("wait CEC TX timeout!!!\n");
    }
    else if (((CEC_DATA[1][0]>>24)== 0x83)&&(broadcast_flag == 0))//cmd=Give Physical Address
    {
        init_addr = (0xf<<8);//broadcast
        CEC_DATA[0][0]=(0x84<<24)|(0x10<<16)|(0x00<<8);//physical address = 0x1000
        rtd_outl(HDMI_CEC_TxDR1_ADDR,CEC_DATA[0][0]);       //CEC TX FIFO
        rtd_outl(HDMI_CEC_TxDR0_ADDR,0x3);                  //CEC TX FIFO num=3
        rtd_maskl(HDMI_CEC_TxDR0_ADDR,~_BIT6,_BIT6);        //CEC TX FIFO num double buffer load
        rtd_maskl(HDMI_CEC_TxCR0_ADDR,~0x00000f00,init_addr);       //dest addr
        rtd_maskl(HDMI_CEC_TxCR0_ADDR,~_BIT15,_BIT15);      //CEC TX enable
        printk("CEC TX send <Report Physical Address> = %x\n",CEC_DATA[0][0]);
        do                                          //wait TX ok flag
        {
            udelay(5000);
            if((rtd_inl(HDMI_CEC_TxCR0_ADDR) & _BIT6))
                break;
        } while (--timeoutcnt);

        if (timeoutcnt==0)
            printk("wait CEC TX timeout!!!\n");
    }
#endif
}
#endif//CEC_CTS_7_9

#endif
    return TRUE;
}
#endif

bool MBIST_CHECK(void)
{
    UINT8 i,time_counter=100;

	printk("[HDMI TX] hdmi tx 1 or hdmi tx 2 DRF and BIST test start !!\n");
	rtd_outl(HDMI_BUS_BIST_EN_reg, (HDMI_BUS_BIST_EN_hdmi0_bist_en(1)|HDMI_BUS_BIST_EN_hdmi1_bist_en(1)));  //bist test enable		
	do
	{
		udelay(1000);
		if ((rtd_inl(HDMI_BIST1_ST_reg)&_BIT0)&&(rtd_inl(HDMI_BIST2_ST_reg)&_BIT0))     //wait bist finish
            	break;
	}
	while(--time_counter);
	
	if (time_counter==0)
    		{
        	printk("[HDMI TX] hdmi tx 1 or hdmi tx 2 BIST test time out !!\n");
        	return FAILED;
    		}

	if ((rtd_inl(HDMI_BIST1_ST_reg)&_BIT1)||(rtd_inl(HDMI_BIST2_ST_reg)&_BIT1))	//check bist test result
		{  
        	printk("[HDMI TX] hdmi tx 1 or hdmi tx 2 BIST test fail !!\n");
        	return FAILED;
		}

	rtd_maskl(HDMI_BUS_BIST_EN_reg,~(HDMI_BUS_BIST_EN_hdmi1_bist_en_mask|HDMI_BUS_BIST_EN_hdmi0_bist_en_mask),0);      //bist test disable

	
	rtd_outl(HDMI_BUS_DRF_BIST_EN_reg, (HDMI_BUS_DRF_BIST_EN_hdmi0_drf_bist_en(1)|HDMI_BUS_DRF_BIST_EN_hdmi1_drf_bist_en(1)));  //DRF test enable
	do
	{
		udelay(1000);
		if ((rtd_inl(HDMI_DRF_BIST1_ST_reg)&_BIT0)&&(rtd_inl(HDMI_DRF_BIST2_ST_reg)&_BIT0))     //wait bist finish
            	break;
	}
	while(--time_counter);
	
	if (time_counter==0)
    		{
        	printk("[HDMI TX] hdmi tx 1 or hdmi tx 2 DRF  test time out !!\n");
        	return FAILED;
    		}

	if ((rtd_inl(HDMI_DRF_BIST1_ST_reg)&_BIT1)||(rtd_inl(HDMI_DRF_BIST2_ST_reg)&_BIT1))	//check bist test result
		{  
        	printk("[HDMI TX] hdmi tx 1 or hdmi tx 2 DRF  test fail !!\n");
        	return FAILED;
		}

	rtd_maskl(HDMI_BUS_DRF_BIST_EN_reg,~(HDMI_BUS_DRF_BIST_EN_hdmi0_drf_bist_en_mask|HDMI_BUS_DRF_BIST_EN_hdmi1_drf_bist_en_mask),0);      //bist test disable

	printk("[HDMI TX] hdmi tx 1 or hdmi tx 2 DRF and BIST test pass !!\n");
	return SUCCESS;
}


void HDMI_TX_Script(void)
{
#if 0
printk("[HDMI TX] script file HDMI 1080p 8bit output !!\n");
//1080P8bit output
//CRT setting
rtd_maskl(0xb8000104, 0xffffb9ff, 0x4600);  //CBUS, HDMI RX, HDMI TX reset release
rtd_maskl(0xb800010c, 0xffffefff, 0x1000);  //HDMI TX PLL reset release

rtd_maskl(0xb8000114, 0xffffb9ff, 0x4600);  //CBUS, HDMI RX, HDMI TX clk enable


//PHY setting
rtd_outl(0xb803de20, 0xbc4a8758);  //TX PLL parameter set, LDO_1V, VCO gain, internal LDO
rtd_outl(0xb803de24, 0x0fc00000);  //P2S LDO, preemphasis, termination R and C
rtd_outl(0xb803de28, 0x44442220);  //driving, pre-em driving current
rtd_outl(0xb803de2c, 0xc0032000);  //PLLDISP parameter, PLLDISP output disnable, PLLDISP power off
rtd_outl(0xb803de30, 0x20004002);  //PLLDISP N code, tmds div, pixel div
rtd_outl(0xb803de34, 0x00000000);  //Reserved
//rtd_outl(0xb803de0c, 0x93680013);  //PLLDISP N code = 19+3
rtd_outl(0xb803de0c, 0x9b780013);  //PLLDISP N code = 19+3
rtd_outl(0xb803de10, 0x1e200284);  //PLLDISP N code load
rtd_outl(0xb803de10, 0x1e200285);  //PLLDISP N code load


rtd_outl(0xb803de2c, 0xc0032001);  //PLLDISP parameter, PLLDISP output disnable, PLLDISP power on
rtd_outl(0xb803de2c, 0x40032001);  //PLLDISP parameter, PLLDISP output ennable, PLLDISP power on
rtd_outl(0xb803de20, 0xfc4a8758);  //TX PLL parameter set, LDO_1V, VCO gain, TX PLL power on

rtd_outl(0xb8000214, 0x00000100);  //HDMI_TMDS_DIV = 1


//MAC setting
//HDMI TX timing gen
rtd_outl(0xb803d234, 0x0117077f);  // horizontal blank = 280-1, horizontal data active = 1920-1
rtd_outl(0xb803d238, 0x002b0057);  // horizontal sync width = 44 -1, horizontal front porch = 88-1
rtd_outl(0xb803d23c, 0x00000093);  // horizontal back proch = 148-1
rtd_outl(0xb803d240, 0x04370437);  // vertical single field size (only active video) = 1080 -1, vertical total data active (with active space) = 1080-1
rtd_outl(0xb803d24c, 0x000a002c);  // vertical sync width = 10, vertical blank = 45-1
rtd_outl(0xb803d250, 0x00230008);  // vertical back proch = 36-1, vertical front porch = 8

//HDMI TX pattern gen
rtd_outl(0xb803d2e0, 0x077f0437);  // H_act = 1920, V_act = 1080
//rtd_outl(0xb803d2e4, 0x81df010d);  // output picture type = color bar
rtd_outl(0xb803d2e4, 0x31df010d);  // output picture type = gray ramp
rtd_outl(0xb803d2e8, 0x3ff00000);  // color 0
rtd_outl(0xb803d2ec, 0x000ffc00);  // color 1
rtd_outl(0xb803d2f0, 0x000003ff);  // color 2
rtd_outl(0xb803d2f4, 0x3fffffff);  // color 3
rtd_outl(0xb803d2f8, 0x00000000);  // color 4
rtd_outl(0xb803d2fc, 0x000fffff);  // color 5
rtd_outl(0xb803d300, 0x3ffffc00);  // color 6
rtd_outl(0xb803d304, 0x3ff003ff);  // color 7
rtd_outl(0xb803d2e0, 0x877f0437);  // pattern gen enable


rtd_outl(0xb803d034, 0xc00000a2);  // TMDS encoder disable, HDMI disable, HDCP1.4, data from pattern gen
//rtd_outl(0xb800d0bc, 0x14000000);  // disable HDMI audio data path, off debug color path
//rtd_outl(0xb800d030, 0x00000924);  // hsync/vsync delay all 0
rtd_outl(0xb803d154, 0x5280f100);  // video format change wait 1 vsync, do not use setting first deep color phase by SW, setting first deep color phase by SW, use default deep phase by SW, default phase, do not deep color mode
rtd_outl(0xb803d020, 0x00002004);  // image end signal (don't care in FPGA), progressive HD mode, HDMI timing genator enable
//rtd_outl(0xb800d0a4, 0x0000007e);  // enable transmission periodic island packet (active when [0]=1)

// YCbCr mode (no transform0
rtd_outl(0xb803d024, 0x00004000);
rtd_outl(0xb803d028, 0x00000000);
rtd_outl(0xb803d02c, 0x00000000);
rtd_outl(0xb803d200, 0x00000000);
rtd_outl(0xb803d204, 0x00004000);
rtd_outl(0xb803d208, 0x00000000);
rtd_outl(0xb803d20c, 0x00000000);
rtd_outl(0xb803d210, 0x00000000);
rtd_outl(0xb803d214, 0x00004000);
rtd_outl(0xb803d218, 0x00000000);
rtd_outl(0xb803d21c, 0x00000000);
rtd_outl(0xb803d220, 0x00000000);

//rtd_outl(0xb803d078, 0x00000008);  // enable GCP trnsmission
//rtd_outl(0xb803d078, 0x00000009);  // enable GCP trnsmission (writen enable)
//rtd_outl(0xb803d0a0, 0x21084210);  // setting periodic island packet cycle length
rtd_outl(0xb803d0b4, 0x00000c66);  // max packet length = 18-1 in vertical blanking, max packet length = 6-1 in horizontal blanking
rtd_outl(0xb803d0b8, 0x0005506b);  // YCbcr444, not repeat pixel, HDMI mode, HS/VS +polarity
//rtd_outl(0xb803d0b8, 0x0007b06b);  // YCbcr444, not repeat pixel, HDMI mode, HS/VS -polarity 

//rtd_outl(0xb803d07c, 0x000d0282);  // packet type=0x82, version=0x02, length=0x0d
//rtd_outl(0xb803d080, 0x20a82077);  // no IT contect, sYCC601, RGB quantization range = default, no knonw non-uniform scaling,
                   // colorimetry=ITU709, picture aspect ratio=16:9, active format aspect ratio=same as picture aspect ratio,
                   // YCbCr444, active format vaild, bar data not vaild, no scan information
                   // checksum = ~(0x82+0x02+0x0d+0x00+0x20+0xa8+0x20+0x10+0x00)+1 = 0x77
//rtd_outl(0xb800d084, 0x00000010);  // no pixel reperirion, video code = 16
//rtd_outl(0xb800d088, 0x00000000);
//rtd_outl(0xb800d08c, 0x00000000);
//rtd_outl(0xb800d090, 0x00000000);
//rtd_outl(0xb800d094, 0x00000000);
//rtd_outl(0xb800d098, 0x00000000);
//rtd_outl(0xb800d09c, 0x00000000);
rtd_outl(0xb803d0b0, 0x00007700);  // enable write periodic island packet SRAM, periodic island packet SRAM start address = 0x00
rtd_outl(0xb803d0a0, 0x00000011);  // write trnsmission period of periodic island packet SRAM
rtd_outl(0xb803d0a4, 0x00000003);  // enable transmission periodic island packet (active when [0]=1)

rtd_outl(0xb803d158, 0x00000300);  // video format change

rtd_outl(0xb803d2a4, 0x0000c000);  // reset TMDS data output async FIFO
rtd_outl(0xb803d2a4, 0x00000000);  // reset TMDS data output async FIFO

//rtd_outl(0xb803d14c, 0xc0000032);  // PRBS7 output
rtd_outl(0xb803d2a8, 0x00000000);  // Scramble disable , GB TMDS COUNT disable

rtd_outl(0xb803d034, 0xc00000f3);  // TMDS encoder enable, HDMI enable


//PHY output lane 
rtd_outl(0xb803de24, 0x0ffc0000);  //Lane0~3 output enable

#else
printk("[HDMI TX] script file HDMI 4K2K output !!\n");
//CRT setting
rtd_maskl(0xb8000104, 0xffffb9ff, 0x4600);  //CBUS, HDMI RX, HDMI TX reset release
rtd_maskl(0xb800010c, 0xffffefff, 0x1000);  //HDMI TX PLL reset release

rtd_maskl(0xb8000114, 0xffffb9ff, 0x4600);  //CBUS, HDMI RX, HDMI TX clk enable



//PHY setting
rtd_outl(0xb803de20, 0xbc43875a);  //TX PLL parameter set, LDO_1V, VCO gain, internal LDO
rtd_outl(0xb803de24, 0x0fc00000);  //P2S LDO, preemphasis, termination R and C
rtd_outl(0xb803de28, 0x77746660);  //driving, pre-em driving current
rtd_outl(0xb803de2c, 0xc0030000);  //PLLDISP parameter, PLLDISP output disnable, PLLDISP power off
//rtd_outl(0xb803de30, 0x21022000);  //PLLDISP N code, tmds div, pixel div
rtd_outl(0xb803de30, 0x61022000);  //PLLDISP N code, tmds div, pixel div
rtd_outl(0xb803de34, 0x00000000);  //Reserved
//rtd_outl(0xb803de0c, 0x93680013);  //PLLDISP N code = 19+3
rtd_outl(0xb803de0c, 0x9b780013);  //PLLDISP N code = 19+3
rtd_outl(0xb803de10, 0x1e200284);  //PLLDISP N code load
rtd_outl(0xb803de10, 0x1e200285);  //PLLDISP N code load


rtd_outl(0xb803de2c, 0xc0030001);  //PLLDISP parameter, PLLDISP output disnable, PLLDISP power on
rtd_outl(0xb803de2c, 0x40030001);  //PLLDISP parameter, PLLDISP output ennable, PLLDISP power on
rtd_outl(0xb803de20, 0xfc43875a);  //TX PLL parameter set, LDO_1V, VCO gain, TX PLL power on

rtd_outl(0xb8000214, 0x00000100);  //HDMI_TMDS_DIV = 1

//MAC setting
//HDMI TX timing gen
rtd_outl(0xb803d234, 0x022f0eff);  // horizontal blank = 560-1, horizontal data active = 3840-1
rtd_outl(0xb803d238, 0x005700af);  // horizontal sync width = 88 -1, horizontal front porch = 176-1
rtd_outl(0xb803d23c, 0x00000127);  // horizontal back proch = 296-1
rtd_outl(0xb803d240, 0x086f086f);  // vertical single field size (only active video) = 2160 -1, vertical total data active (with active space) = 2160-1
rtd_outl(0xb803d24c, 0x000a0059);  // vertical sync width = 10, vertical blank = 90-1
rtd_outl(0xb803d250, 0x00470008);  // vertical back proch = 72-1, vertical front porch = 8

//HDMI TX pattern gen
rtd_outl(0xb803d2e0, 0x0eff086f);  // H_act = 3840, V_act = 2160
//rtd_outl(0xb803d2e4, 0x81df010d);  // output picture type = color bar
rtd_outl(0xb803d2e4, 0x31df010d);  // output picture type = gray ramp
rtd_outl(0xb803d2e8, 0x3ff00000);  // color 0
rtd_outl(0xb803d2ec, 0x000ffc00);  // color 1
rtd_outl(0xb803d2f0, 0x000003ff);  // color 2
rtd_outl(0xb803d2f4, 0x3fffffff);  // color 3
rtd_outl(0xb803d2f8, 0x00000000);  // color 4
rtd_outl(0xb803d2fc, 0x000fffff);  // color 5
rtd_outl(0xb803d300, 0x3ffffc00);  // color 6
rtd_outl(0xb803d304, 0x3ff003ff);  // color 7
rtd_outl(0xb803d2e0, 0x8eff086f);  // pattern gen enable


rtd_outl(0xb803d034, 0xc00000a2);  // TMDS encoder disable, HDMI disable, HDCP1.4, data from pattern gen
//rtd_outl(0xb800d0bc, 0x14000000);  // disable HDMI audio data path, off debug color path
//rtd_outl(0xb800d030, 0x00000924);  // hsync/vsync delay all 0
rtd_outl(0xb803d154, 0x5280f100);  // video format change wait 1 vsync, do not use setting first deep color phase by SW, setting first deep color phase by SW, use default deep phase by SW, default phase, do not deep color mode
rtd_outl(0xb803d020, 0x00002004);  // image end signal (don't care in FPGA), progressive HD mode, HDMI timing genator enable
//rtd_outl(0xb800d0a4, 0x0000007e);  // enable transmission periodic island packet (active when [0]=1)

// YCbCr mode (no transform0
rtd_outl(0xb803d024, 0x00004000);
rtd_outl(0xb803d028, 0x00000000);
rtd_outl(0xb803d02c, 0x00000000);
rtd_outl(0xb803d200, 0x00000000);
rtd_outl(0xb803d204, 0x00004000);
rtd_outl(0xb803d208, 0x00000000);
rtd_outl(0xb803d20c, 0x00000000);
rtd_outl(0xb803d210, 0x00000000);
rtd_outl(0xb803d214, 0x00004000);
rtd_outl(0xb803d218, 0x00000000);
rtd_outl(0xb803d21c, 0x00000000);
rtd_outl(0xb803d220, 0x00000000);

//rtd_outl(0xb800d078, 0x00000008);  // enable GCP trnsmission
//rtd_outl(0xb800d078, 0x00000009);  // enable GCP trnsmission (writen enable)
//rtd_outl(0xb800d0a0, 0x21084210);  // setting periodic island packet cycle length
rtd_outl(0xb803d0b4, 0x00000c66);  // max packet length = 18-1 in vertical blanking, max packet length = 6-1 in horizontal blanking
rtd_outl(0xb803d0b8, 0x0005506b);  // YCbcr444, not repeat pixel, HDMI mode

//rtd_outl(0xb800d07c, 0x000d0282);  // packet type=0x82, version=0x02, length=0x0d
//rtd_outl(0xb800d080, 0x20a85047);  // no IT contect, sYCC601, RGB quantization range = default, no knonw non-uniform scaling,
                   // colorimetry=ITU709, picture aspect ratio=16:9, active format aspect ratio=same as picture aspect ratio,
                   // YCbCr444, active format vaild, bar data not vaild, no scan information
                   // checksum = ~(0x82+0x02+0x0d+0x00+0x50+0xa8+0x20+0x10+0x00)+1
//rtd_outl(0xb800d084, 0x00000010);  // no pixel reperirion, video code = 16
//rtd_outl(0xb800d088, 0x00000000);
//rtd_outl(0xb800d08c, 0x00000000);
//rtd_outl(0xb800d090, 0x00000000);
//rtd_outl(0xb800d094, 0x00000000);
//rtd_outl(0xb800d098, 0x00000000);
//rtd_outl(0xb800d09c, 0x00000000);
rtd_outl(0xb803d0b0, 0x00007700);  // enable write periodic island packet SRAM, periodic island packet SRAM start address = 0x00
rtd_outl(0xb803d0a0, 0x00000011);  // write trnsmission period of periodic island packet SRAM
rtd_outl(0xb803d0a4, 0x00000003);  // enable transmission periodic island packet (active when [0]=1)

rtd_outl(0xb803d158, 0x00000300);  // video format change

rtd_outl(0xb803d2a4, 0x0000c000);  // reset TMDS data output async FIFO
rtd_outl(0xb803d2a4, 0x00000000);  // reset TMDS data output async FIFO

//rtd_outl(0xb803d2a8, 0x000001c0);  // Scramble enable , GB TMDS COUNT enable

rtd_outl(0xb803d034, 0xc00000f3);  // TMDS encoder enable, HDMI enable
//ScalerTimer_DelayXms(50);
//rtd_outl(0xb803d2a8, 0x000001cf);  // Scramble enable , GB TMDS COUNT enable

//PHY output lane 
rtd_outl(0xb803de24, 0x0ffc0000);  //Lane0~3 output enable
#endif
}

void MHL_TX_Script(void)
{
printk("[MHL TX] script file MHL 1080p PPM output !!\n");
//PHY setting
rtd_outl(0xb803de20, 0xbc468759);  //TX PLL parameter set, LDO_1V, VCO gain, internal LDO
rtd_outl(0xb803de24, 0x084000e8);  //P2S LDO, preemphasis, termination R and C
rtd_outl(0xb803de28, 0x77745550);  //driving, pre-em driving current
rtd_outl(0xb803de2c, 0xf0071000);  //PLLDISP parameter, PLLDISP output disnable, PLLDISP power off
rtd_outl(0xb803de30, 0x30022002);  //PLLDISP N code, tmds div, pixel div
rtd_outl(0xb803de34, 0x00000000);  //Reserved
//rtd_outl(0xb803de0c, 0x93680013);  //PLLDISP N code = 19+3
rtd_outl(0xb803de0c, 0x9b780013);  //PLLDISP N code = 19+3
rtd_outl(0xb803de10, 0x1e200284);  //PLLDISP N code load
rtd_outl(0xb803de10, 0x1e200285);  //PLLDISP N code load

rtd_outl(0xb803de2c, 0xf0071001);  //PLLDISP parameter, PLLDISP output disnable, PLLDISP power on
rtd_outl(0xb803de2c, 0x70071001);  //PLLDISP parameter, PLLDISP output ennable, PLLDISP power on
rtd_outl(0xb803de20, 0xfc468759);  //TX PLL parameter set, LDO_1V, VCO gain, TX PLL power on

rtd_outl(0xb803de24, 0x084200e8);  //P2S LDO, preemphasis, termination R and C, MHL mode enable

rtd_outl(0xb8000214, 0x00001100);  //HDMI_TMDS_DIV = 2


//MAC setting
//HDMI TX timing gen
rtd_outl(0xb803d234, 0x0117077f);  // horizontal blank = 280-1, horizontal data active = 1920-1
rtd_outl(0xb803d238, 0x002b0057);  // horizontal sync width = 44 -1, horizontal front porch = 88-1
rtd_outl(0xb803d23c, 0x00000093);  // horizontal back proch = 148-1
rtd_outl(0xb803d240, 0x04370437);  // vertical single field size (only active video) = 1080 -1, vertical total data active (with active space) = 1080-1
rtd_outl(0xb803d24c, 0x000a002c);  // vertical sync width = 10, vertical blank = 45-1
rtd_outl(0xb803d250, 0x00230008);  // vertical back proch = 36-1, vertical front porch = 8

//HDMI TX pattern gen
rtd_outl(0xb803d2e0, 0x077f0437);  // H_act = 1920, V_act = 1080
//rtd_outl(0xb803d2e4, 0x81df010d);  // output picture type = color bar
rtd_outl(0xb803d2e4, 0x31df010d);  // output picture type = gray ramp
//ShawnSung rtd_outl(0xb803d2e8, 0x3ff00000);  // color 0
//ShawnSung rtd_outl(0xb803d2ec, 0x000ffc00);  // color 1
//ShawnSung rtd_outl(0xb803d2f0, 0x000003ff);  // color 2
//ShawnSung rtd_outl(0xb803d2f4, 0x3fffffff);  // color 3
//ShawnSung rtd_outl(0xb803d2f8, 0x00000000);  // color 4
//ShawnSung rtd_outl(0xb803d2fc, 0x000fffff);  // color 5
//ShawnSung rtd_outl(0xb803d300, 0x3ffffc00);  // color 6
//ShawnSung rtd_outl(0xb803d304, 0x3ff003ff);  // color 7
rtd_outl(0xb803d2e8, 0x3ac80200);  // color 0
rtd_outl(0xb803d2ec, 0x34810248);  // color 1
rtd_outl(0xb803d2f0, 0x2a8a6040);  // color 2
rtd_outl(0xb803d2f4, 0x24436088);  // color 3
rtd_outl(0xb803d2f8, 0x1acca374);  // color 4
rtd_outl(0xb803d2fc, 0x1485a3c0);  // color 5
rtd_outl(0xb803d300, 0x0a4f01b8);  // color 6
rtd_outl(0xb803d304, 0x04080200);  // color 7
//ShawnSung rtd_outl(0xb803d308, 0x30000000);  // Color space sel
rtd_outl(0xb803d308, 0x10000000);  // Color space sel YCbCr444
rtd_outl(0xb803d2e0, 0x877f0437);  // pattern gen enable


rtd_outl(0xb803d034, 0xc00000a2);  // TMDS encoder disable, HDMI disable, HDCP1.4, data from pattern gen
//rtd_outl(0xb800d0bc, 0x14000000);  // disable HDMI audio data path, off debug color path
//rtd_outl(0xb800d030, 0x00000924);  // hsync/vsync delay all 0
rtd_outl(0xb803d154, 0x5280f100);  // video format change wait 1 vsync, do not use setting first deep color phase by SW, setting first deep color phase by SW, use default deep phase by SW, default phase, do not deep color mode
rtd_outl(0xb803d020, 0x00002004);  // image end signal (don't care in FPGA), progressive HD mode, HDMI timing genator enable
//rtd_outl(0xb800d0a4, 0x0000007e);  // enable transmission periodic island packet (active when [0]=1)

// YCbCr mode (no transform0
rtd_outl(0xb803d024, 0x00004000);
rtd_outl(0xb803d028, 0x00000000);
rtd_outl(0xb803d02c, 0x00000000);
rtd_outl(0xb803d200, 0x00000000);
rtd_outl(0xb803d204, 0x00004000);
rtd_outl(0xb803d208, 0x00000000);
rtd_outl(0xb803d20c, 0x00000000);
rtd_outl(0xb803d210, 0x00000000);
rtd_outl(0xb803d214, 0x00004000);
rtd_outl(0xb803d218, 0x00000000);
rtd_outl(0xb803d21c, 0x00000000);
rtd_outl(0xb803d220, 0x00000000);

//rtd_outl(0xb800d078, 0x00000008);  // enable GCP trnsmission
//rtd_outl(0xb800d078, 0x00000009);  // enable GCP trnsmission (writen enable)
//rtd_outl(0xb800d0a0, 0x21084210);  // setting periodic island packet cycle length
rtd_outl(0xb803d0b4, 0x00000c66);  // max packet length = 18-1 in vertical blanking, max packet length = 6-1 in horizontal blanking
//ShawnSung rtd_outl(0xb803d0b8, 0x0005505b);  // *****YCbcr420, not repeat pixel, HDMI mode
rtd_outl(0xb803d0b8, 0x0005507b);  // *****YCbCr422, not repeat pixel, HDMI mode

rtd_outl(0xb803d07c, 0x000d0282);  // packet type=0x82, version=0x02, length=0x0d
rtd_outl(0xb803d080, 0x20a82077);  // no IT contect, sYCC601, RGB quantization range = default, no knonw non-uniform scaling,
                   // colorimetry=ITU709, picture aspect ratio=16:9, active format aspect ratio=same as picture aspect ratio,
                   // YCbCr444, active format vaild, bar data not vaild, no scan information
                   // checksum = ~(0x82+0x02+0x0d+0x00+0x20+0xa8+0x20+0x10+0x00)+1 = 0x77
rtd_outl(0xb803d084, 0x00000010);  // no pixel reperirion, video code = 16
//rtd_outl(0xb800d088, 0x00000000);
//rtd_outl(0xb800d08c, 0x00000000);
//rtd_outl(0xb800d090, 0x00000000);
//rtd_outl(0xb800d094, 0x00000000);
//rtd_outl(0xb800d098, 0x00000000);
//rtd_outl(0xb800d09c, 0x00000000);
rtd_outl(0xb803d0b0, 0x00007700);  // enable write periodic island packet SRAM, periodic island packet SRAM start address = 0x00
rtd_outl(0xb803d0a0, 0x00000011);  // write trnsmission period of periodic island packet SRAM
rtd_outl(0xb803d0a4, 0x00000003);  // enable transmission periodic island packet (active when [0]=1)

rtd_outl(0xb803d158, 0x00000300);  // video format change

rtd_outl(0xb803d2a4, 0x0000c000);  // reset TMDS data output async FIFO
rtd_outl(0xb803d2a4, 0x00000000);  // reset TMDS data output async FIFO

rtd_outl(0xb803d034, 0xc00000f3);  // TMDS encoder enable, HDMI enable
rtd_outl(0xb803d298, 0x0000026f);  // HDMI_MHLCTRL_xor_pixel_sel(1), HDMI_MHLCTRL_mhl_enc_sel(0), HDMI_MHLCTRL_mhl_pp_mode(0), HDMI_MHLCTRL_mhl_enable(1)  *

//PHY lane output
rtd_outl(0xb803de24, 0x086200e8);  //Lane B output enable

}

static int get_hdmi_tx_cmd_enum(INT8 *str)
{
    int i, ret = HDMI_TX_CMD_TEST_EXIT;
    for (i = 0; i < HDMI_TX_CMD_ITEM_NUM; i++)
    {
        if (strcmp(cmd_str_array[i], str) == 0)
        {
            ret = i;
            break;
        }
    }
    return ret;
}

void HDMI_Loop_Back_test(void)
{
	system_init();	//CRT reset and clk enable

    	printk("Video info: %d, %d, %d, %d, %d, %d, %d\n",
            case_mode, DeepColorEnable, DeepColorDepth,
            TimingGen, Enable3D, Format3D, rgb_mode);

	printk("Audio info: %d, %d, %d, %d, %d\n",
            SamplingFrequency, SampleSize, AudioChannelCount,
            AudioType, CTSSource);

	//config_audio_param();
	set_and_go();
	printk("[HDMI TX] HDMI TX and RX loop back test, result refer to RX\n");
/*
	if (!QC_Hdmi_Main(1)) 	//RX CRC check
				{
					printk("HDMITX and RX loop back test fail\n");
				}
				else
				{
					printk("HDMITX and RX loop back test pass\n");
				}
*/
}

void QC_Code_For_Verify(void)
{
UINT8 receive_buf[QCINFO_CMD_BUFFER_SIZE];
    int i, option, tNum;
    bool loop = TRUE;

    system_init();	//CRT reset and clk enable
    while (loop) {
        printk("type hdmi tx cmd >> ");
        memset(receive_buf, 0, QCINFO_CMD_BUFFER_SIZE);
        GetLine(receive_buf, QCINFO_CMD_BUFFER_SIZE, 1);
        hdmi_tx_argc = GetArgc((const INT8 *) receive_buf);
        hdmi_tx_argv = (INT8 **) GetArgv((const INT8 *) receive_buf);

        option = get_hdmi_tx_cmd_enum(*(&hdmi_tx_argv[0]));
        ////tNum = strtoul((const INT8 *) (hdmi_tx_argv[1]), (INT8 **) NULL, 10);
        ////printk("str to int = %d\n", tNum);
        printk("\n");
        switch (option) {
            case HDMI_TX_CMD_TEST_PROTOCOL:
                printk("[test video and audio]\n");
                HDMI_Test();
                break;
            case HDMI_TX_CMD_TEST_CEC:
                printk("[test cec]\n");
                break;
            case HDMI_TX_CMD_TEST_SCRIPT:
                printk("[test script]\n");
                HDMI_TX_Script();
                //MHL_TX_Script();
                break;
            case HDMI_TX_CMD_TEST_EXIT:
                loop = FALSE;
                printk("[test exit]\n");
                break;
        }
    }

}


void GPIO_Pin_Share(void)
{
	rtd_part_outl(0xb800081c,15,12,0xf);	//pinshare GPIO30
	rtd_part_outl(0xb801bd00,30,30,0x0);	//GPIO30 is GPI
	
	rtd_part_outl(0xb8000820,7,4,0xf);		//pinshare GPIO35
	rtd_part_outl(0xb801bd04,3,3,0x0);		//GPIO35 is GPI
	
	rtd_part_outl(0xb8000824,23,20,0xf);	//pinshare GPIO37
	rtd_part_outl(0xb801bd04,5,5,0x0);		//GPIO37 is GPI

	rtd_part_outl(0xb8000834,31,28,0xf);	//pinshare GPIO52
	rtd_part_outl(0xb801bd04,20,20,0x0);	//GPIO52 is GPI

	rtd_part_outl(0xb8000834,15,12,0xf);	//pinshare GPIO54
	rtd_part_outl(0xb801bd04,22,22,0x0);	//GPIO54 is GPI

	rtd_part_outl(0xb8000838,31,28,0xf);	//pinshare GPIO56
	rtd_part_outl(0xb801bd04,24,24,0x0);	//GPIO56 is GPI

	rtd_part_outl(0xb8000838,15,12,0xf);	//pinshare GPIO58
	rtd_part_outl(0xb801bd04,26,26,0x0);	//GPIO58 is GPI

	rtd_part_outl(0xb800083c,31,28,0xf);	//pinshare GPIO60
	rtd_part_outl(0xb801bd04,28,28,0x0);	//GPIO60 is GPI

	rtd_part_outl(0xb800083c,15,12,0xf);	//pinshare GPIO62
	rtd_part_outl(0xb801bd04,30,30,0x0);	//GPIO62 is GPI

	rtd_part_outl(0xb8000840,31,28,0xf);	//pinshare GPIO64
	rtd_part_outl(0xb801bd08,0,0,0x0);		//GPIO64 is GPI

	rtd_part_outl(0xb8000840,15,12,0xf);	//pinshare GPIO66
	rtd_part_outl(0xb801bd08,2,2,0x0);		//GPIO66 is GPI
}

void Get_GPIO_Value(void)
{
	UINT32 gpio_value;

	printf("[GPIO30] = %d !\n", (rtd_inl(0xb801bd30)&_BIT30)>>30);
	printf("[GPIO35] = %d !\n", (rtd_inl(0xb801bd34)&_BIT3)>>3);
	printf("[GPIO37] = %d !\n", (rtd_inl(0xb801bd34)&_BIT5)>5);
	printf("[GPIO52] = %d !\n", (rtd_inl(0xb801bd34)&_BIT20)>>20);
	printf("[GPIO54] = %d !\n", (rtd_inl(0xb801bd34)&_BIT22)>>22);
	printf("[GPIO56] = %d !\n", (rtd_inl(0xb801bd34)&_BIT24)>>24);
	printf("[GPIO58] = %d !\n", (rtd_inl(0xb801bd34)&_BIT26)>>26);
	printf("[GPIO60] = %d !\n", (rtd_inl(0xb801bd34)&_BIT28)>>28);
	printf("[GPIO62] = %d !\n", (rtd_inl(0xb801bd34)&_BIT30)>>30);
	printf("[GPIO64] = %d !\n", rtd_inl(0xb801bd38)&_BIT0);
	printf("[GPIO66] = %d !\n", (rtd_inl(0xb801bd38)&_BIT2)>>2);		
}

int Get_Timing_Format(void)
{
	UINT8 value,temp;
	UINT8 freq0,freq1,freq2,freq3;

	freq3 = (rtd_inl(0xb801bd34)&_BIT28)>>28;	//GPIO60
	freq2 = (rtd_inl(0xb801bd34)&_BIT30)>>30;	//GPIO62
	freq1 = rtd_inl(0xb801bd38)&_BIT0;			//GPIO64
	freq0 = (rtd_inl(0xb801bd38)&_BIT2)>>2;	//GPIO66
	temp = (freq3<<3)|(freq2<<2)|(freq1<<1)|freq0;
	printf("\nPTG Timing format GPIO detect = %d !\n", temp);



if (((rtd_inl(0xb801bd34)&_BIT20)>>20)==1)	//GPIO52 detect
{
	DVIorHDMI_flag=2;
	switch (temp) 	//MHL mode
        {
		case 0:		//HDMI 480P60
              	value = 2;
              	mhl_pp_mode_en=0;
              	printf("PTG Output MHL Timing format  = 480P60 !\n");
              	break;
		case 3:		//HDMI 1080P60
              	value = 22;
              	mhl_pp_mode_en=1;
              	printf("PTG Output MHL Timing format  = 1080P60 (PPM)!\n");
              	break;
		case 2:		//HDMI 720P60			
              	value = 5;
              	mhl_pp_mode_en=0;
              	printf("PTG Output MHL Timing format  = 720P60 !\n");
              	break;
		
		default:		//HDMI 480P60
              	value = 2;
              	printf("GPIO value not suppot , PTG Output MHL Timing format  = 480P60 !\n");
              	break;
               }
}
else
{
	DVIorHDMI_flag=1;
	switch (temp) 	//HDMI mode
        {
		case 0:		//HDMI 480P60
              	value = 2;
              	printf("PTG Output HDMI Timing format  = 480P60 !\n");
              	break;
		case 1:		//HDMI 480P60
              	value = 34;
              	printf("PTG Output HDMI Timing format  = 720x480i 13.5MHz !\n");
              	break;              	
		case 3:		//HDMI 1080P60
              	value = 22;
              	printf("PTG Output HDMI Timing format  = 1080P60 !\n");
              	break;
		case 2:		//HDMI 720P60			
              	value = 5;
              	printf("PTG Output HDMI Timing format  = 720P60 !\n");
              	break;
		case 5:		//HDMI 3840x2160@30
              	value = 32;
              	printf("PTG Output HDMI Timing format  = 4K2K30 !\n");
              	break;
		case 6:		//HDMI 3840x2160@60
              	value = 35;
              	printf("PTG Output HDMI Timing format  = 4K2K60 !\n");
              	break;
		default:		//HDMI 480P60
              	value = 2;
              	printf("GPIO value not suppot , PTG Output HDMI Timing format  = 480P60 !\n");
              	break;
               }
}	

	return value;
}

#if Mag2_PTG_En
int QC_Verifier_HDMI_TX(void)
{
	UINT8 timing_value;
	UINT8 value_compare = 255;
	UINT8 video_format ;	// 1:MHL , 0:HDMI
	UINT8 format_compare = 255;
	bool freq_change_flag = 0;
	bool format_change_flag = 0;

	
	GPIO_Pin_Share();
	Get_GPIO_Value();

	system_init();	//CRT reset and clk enable
	
	while(1)
	{
		timing_value = Get_Timing_Format();	//GPIO value translate to Video timing
		if(value_compare==timing_value)
			freq_change_flag = 0;	//Timing change		
		else
			freq_change_flag = 1;	//Timing not change

		value_compare = timing_value;
		

		video_format = (rtd_inl(0xb801bd34)&_BIT20)>>20;	// 1:MHL , 0:HDMI 
		if(format_compare==video_format)
			format_change_flag = 0;	//video mode change		
		else
			format_change_flag = 1;	//video mode change

		format_compare = video_format;

		if ((freq_change_flag==1)|(format_change_flag==1))
		{			
				// CRT initial start	
			//rtd_maskl(0xb8000104, 0xffffb9ff, 0x0000);  //CBUS, HDMI RX, HDMI TX reset 
			rtd_maskl(0xb8000104, 0xfffffdff, 0x000);  ///HDMI TX reset 
			rtd_maskl(0xb800010c, 0xffffefff, 0x0000);  //HDMI TX PLL reset 
			//rtd_maskl(0xb8000114, 0xffffb9ff, 0x0000);  //CBUS, HDMI RX, HDMI TX clk disable
			rtd_maskl(0xb8000114, 0xfffffdff, 0x000);  //HDMI TX clk disable
			udelay(1000);
			system_init();	//CRT reset and clk enable


			if (video_format==1)	// 1:MHL , 0:HDMI 
				SET_HDMI_Video(timing_value, 1, 2, 0, 4, 0, 1, 0, 0, mhl_pp_mode_en);	//set MHL mode and PP mode
				//MHL_TX_Script();
			else
				SET_HDMI_Video(timing_value, 0, 1, 0, 4, 0, 1, 0, 0, 0);	//set HDMI mode
		}
		else
			udelay(200000);
	}
}

#else

int QC_Verifier_HDMI_TX(void)
{
#if 1    
#if QC_Code_For_Verify_Chip
	QC_Code_For_Verify();	//QC code for chip verify , need key in command	
#else
	HDMI_Loop_Back_test();	//normal QC code flow for QC Loop back test
#endif
#endif

#if 0
    HDMI_Test();
#endif

#if 0
    CCec_Test();
#endif

#if 0
HDMI_TX_Script();
#endif

#if 0
mhl_tx_cbus_init();
mhl_tx_cbus_connect();	//for CBUS connect check
MHL_TX_Script();
#endif

#if HDMI_TX_MBIST_CHECK
	if (MBIST_CHECK())
	{
		return FAILED;
	}
#endif

    return SUCCESS;
}
#endif
