/**************************************************************
// Spec Version                  : 1.4
// Parser Version                : DVR_Parser_6.11(120105)
// CModelGen Version             : 5.1 2012.01.05
// Naming Rule                   :  Register_Name
// Naming Rule                   : Module_Register_Name_reg
// Parse Option                  : Only Parse _op1
// Parse Address Region          : All Address Region
// Decode bit number             : 12 bits
// Firmware Header Generate Date : 2013/11/13 14:18:21
***************************************************************/


#ifndef _MD_REG_H_INCLUDED_
#define _MD_REG_H_INCLUDED_
#ifdef  _MD_USE_STRUCT
typedef struct
{
unsigned int     reserved_0:28;
unsigned int     smq_idle:1;
unsigned int     smq_cmd_swap:1;
unsigned int     smq_go:1;
unsigned int     write_data:1;
}MD_SMQ_CNTL;

typedef struct
{
unsigned int     reserved_0:21;
unsigned int     fdma_go_busy:1;
unsigned int     ur_length_err:1;
unsigned int     ur_rx_timeout:1;
unsigned int     ur_rx_thd:1;
unsigned int     ur_tx_thd:1;
unsigned int     smq_mode_2b4berr:1;
unsigned int     fdma_done:1;
unsigned int     smq_empty:1;
unsigned int     smq_length_err:1;
unsigned int     smq_inst_err:1;
unsigned int     write_data:1;
}MD_SMQ_INT_STATUS;

typedef struct
{
unsigned int     reserved_0:21;
unsigned int     scpu_int_en:1;
unsigned int     ur_length_err_en:1;
unsigned int     ur_rx_timeout_en:1;
unsigned int     ur_rx_thd_en:1;
unsigned int     ur_tx_thd_en:1;
unsigned int     smq_mode_2b4b_err_en:1;
unsigned int     fdma_done_en:1;
unsigned int     smq_empty_en:1;
unsigned int     smq_length_err_en:1;
unsigned int     smq_inst_err_en:1;
unsigned int     write_data:1;
}MD_SMQ_INT_ENABLE;

typedef struct
{
unsigned int     reserved_0:1;
unsigned int     smq_base:27;
unsigned int     reserved_1:4;
}MD_SMQBASE;

typedef struct
{
unsigned int     reserved_0:1;
unsigned int     smq_limit:27;
unsigned int     reserved_1:4;
}MD_SMQLIMIT;

typedef struct
{
unsigned int     reserved_0:1;
unsigned int     smq_rdptr:27;
unsigned int     reserved_1:4;
}MD_SMQRDPTR;

typedef struct
{
unsigned int     reserved_0:1;
unsigned int     smq_wrptr:27;
unsigned int     reserved_1:4;
}MD_SMQWRPTR;

typedef struct
{
unsigned int     reserved_0:27;
unsigned int     smq_inst_remain:5;
}MD_SMQFIFOSTATE;

typedef struct
{
unsigned int     reserved_0:16;
unsigned int     smq_inst_cnt:16;
}MD_SMQ_INSTCNT;

typedef struct
{
unsigned int     reserved_0:28;
unsigned int     vmq_idle:1;
unsigned int     vmq_cmd_swap:1;
unsigned int     vmq_go:1;
unsigned int     write_data:1;
}MD_VMQ_CNTL;

typedef struct
{
unsigned int     reserved_0:27;
unsigned int     vmq_mode_2b4berr:1;
unsigned int     vmq_empty:1;
unsigned int     vmq_length_err:1;
unsigned int     vmq_inst_err:1;
unsigned int     write_data:1;
}MD_VMQ_INT_STATUS;

typedef struct
{
unsigned int     reserved_0:26;
unsigned int     vcpu_int_en:1;
unsigned int     vmq_mode_2b4b_err_en:1;
unsigned int     vmq_empty_en:1;
unsigned int     vmq_length_err_en:1;
unsigned int     vmq_inst_err_en:1;
unsigned int     write_data:1;
}MD_VMQ_INT_ENABLE;

typedef struct
{
unsigned int     reserved_0:1;
unsigned int     vmq_base:27;
unsigned int     reserved_1:4;
}MD_VMQBASE;

typedef struct
{
unsigned int     reserved_0:1;
unsigned int     vmq_limit:27;
unsigned int     reserved_1:4;
}MD_VMQLIMIT;

typedef struct
{
unsigned int     reserved_0:1;
unsigned int     vmq_rdptr:27;
unsigned int     reserved_1:4;
}MD_VMQRDPTR;

typedef struct
{
unsigned int     reserved_0:1;
unsigned int     vmq_wrptr:27;
unsigned int     reserved_1:4;
}MD_VMQWRPTR;

typedef struct
{
unsigned int     reserved_0:27;
unsigned int     vmq_inst_remain:5;
}MD_VMQFIFOSTATE;

typedef struct
{
unsigned int     reserved_0:16;
unsigned int     vmq_inst_cnt:16;
}MD_VMQ_INSTCNT;

typedef struct
{
unsigned int     reserved_0:28;
unsigned int     kmq_idle:1;
unsigned int     kmq_cmd_swap:1;
unsigned int     kmq_go:1;
unsigned int     write_data:1;
}MD_KMQ_CNTL;

typedef struct
{
unsigned int     reserved_0:27;
unsigned int     kmq_mode_2b4berr:1;
unsigned int     kmq_empty:1;
unsigned int     kmq_length_err:1;
unsigned int     kmq_inst_err:1;
unsigned int     write_data:1;
}MD_KMQ_INT_STATUS;

typedef struct
{
unsigned int     reserved_0:26;
unsigned int     kcpu_int_en:1;
unsigned int     kmq_mode_2b4b_err_en:1;
unsigned int     kmq_empty_en:1;
unsigned int     kmq_length_err_en:1;
unsigned int     kmq_inst_err_en:1;
unsigned int     write_data:1;
}MD_KMQ_INT_ENABLE;

typedef struct
{
unsigned int     reserved_0:1;
unsigned int     kmq_base:27;
unsigned int     reserved_1:4;
}MD_KMQBASE;

typedef struct
{
unsigned int     reserved_0:1;
unsigned int     kmq_limit:27;
unsigned int     reserved_1:4;
}MD_KMQLIMIT;

typedef struct
{
unsigned int     reserved_0:1;
unsigned int     kmq_rdptr:27;
unsigned int     reserved_1:4;
}MD_KMQRDPTR;

typedef struct
{
unsigned int     reserved_0:1;
unsigned int     kmq_wrptr:27;
unsigned int     reserved_1:4;
}MD_KMQWRPTR;

typedef struct
{
unsigned int     reserved_0:27;
unsigned int     kmq_inst_remain:5;
}MD_KMQFIFOSTATE;

typedef struct
{
unsigned int     reserved_0:16;
unsigned int     kmq_inst_cnt:16;
}MD_KMQ_INSTCNT;

typedef struct
{
unsigned int     reserved_0:17;
unsigned int     md_dbg_sel1:7;
unsigned int     md_dbg_sel0:7;
unsigned int     md_dbg_enable:1;
}MD_DBG;

typedef struct
{
unsigned int     reserved_0:1;
unsigned int     fdma_ddr_saddr:31;
}MD_FDMA_DDR_SADDR;

typedef struct
{
unsigned int     reserved_0:7;
unsigned int     fdma_fl_saddr:25;
}MD_FDMA_FL_SADDR;

typedef struct
{
unsigned int     reserved_0:1;
unsigned int     fl_cp_en:1;
unsigned int     fl_mapping_mode:1;
unsigned int     fdma_swap:1;
unsigned int     fdma_max_xfer:2;
unsigned int     fdma_dir:1;
unsigned int     fdma_length:25;
}MD_FDMA_CTRL2;

typedef struct
{
unsigned int     reserved_0:28;
unsigned int     write_en2:1;
unsigned int     fdma_stop:1;
unsigned int     write_en1:1;
unsigned int     fdma_go:1;
}MD_FDMA_CTRL1;

typedef struct
{
unsigned int     reserved_0:1;
unsigned int     fdma_ddr_saddr_k:31;
}MD_FDMA_DDR_SADDR_K;

typedef struct
{
unsigned int     reserved_0:7;
unsigned int     fdma_fl_saddr_k:25;
}MD_FDMA_FL_SADDR_K;

typedef struct
{
unsigned int     Disable_md_block_mode:1;
unsigned int     fl_cp_en_k:1;
unsigned int     fl_mapping_mode_k:1;
unsigned int     fdma_swap_k:1;
unsigned int     fdma_max_xfer_k:2;
unsigned int     fdma_dir_k:1;
unsigned int     fdma_length_k:25;
}MD_FDMA_CTRL2_K;

typedef struct
{
unsigned int     reserved_0:28;
unsigned int     write_en2_k:1;
unsigned int     fdma_stop_k:1;
unsigned int     write_en1_k:1;
unsigned int     fdma_go_k:1;
}MD_FDMA_CTRL1_K;

typedef struct
{
unsigned int     reserved_0:31;
unsigned int     gating_en:1;
}MD_POWER;

typedef struct
{
unsigned int     dummy1:32;
}MD_DUMMY1;

typedef struct
{
unsigned int     dummy2:32;
}MD_DUMMY2;

typedef struct
{
unsigned int     reserved_0:31;
unsigned int     md_BIST_MODE_A:1;
}MD_BIST_MODE;

typedef struct
{
unsigned int     reserved_0:31;
unsigned int     md_BIST_DONE_A:1;
}MD_BIST_DONE;

typedef struct
{
unsigned int     reserved_0:31;
unsigned int     md_BIST_FAIL_GROUP_A:1;
}MD_BIST_FAIL_GROUP;

typedef struct
{
unsigned int     reserved_0:29;
unsigned int     md_BIST_A_FAIL_2:1;
unsigned int     md_BIST_A_FAIL_1:1;
unsigned int     md_BIST_A_FAIL_0:1;
}MD_BIST_A_FAIL;

typedef struct
{
unsigned int     reserved_0:31;
unsigned int     md_DRF_MODE_A:1;
}MD_DRF_MODE;

typedef struct
{
unsigned int     reserved_0:31;
unsigned int     md_DRF_RESUME_A:1;
}MD_DRF_RESUME;

typedef struct
{
unsigned int     reserved_0:31;
unsigned int     md_DRF_DONE_A:1;
}MD_DRF_DONE;

typedef struct
{
unsigned int     reserved_0:31;
unsigned int     md_DRF_PAUSE_A:1;
}MD_DRF_PAUSE;

typedef struct
{
unsigned int     reserved_0:29;
unsigned int     md_DRF_A_FAIL_2:1;
unsigned int     md_DRF_A_FAIL_1:1;
unsigned int     md_DRF_A_FAIL_0:1;
}MD_DRF_A_FAIL;

typedef struct
{
unsigned int     reserved_0:31;
unsigned int     md_DRF_FAIL_GROUP_A:1;
}MD_DRF_FAIL_GROUP;

typedef struct
{
unsigned int     reserved_0:11;
unsigned int     dvse_2:1;
unsigned int     dvs_2:4;
unsigned int     reserved_1:3;
unsigned int     dvse_1:1;
unsigned int     dvs_1:4;
unsigned int     reserved_2:3;
unsigned int     dvse_0:1;
unsigned int     dvs_0:4;
}BIST_DVS;

typedef struct
{
unsigned int     reserved_0:31;
unsigned int     reg_mode:1;
}MD_REG_MODE;

typedef struct
{
unsigned int     reserved_0:15;
unsigned int     reg_poll:1;
unsigned int     loop:16;
}MD_REG_CTRL;

typedef struct
{
unsigned int     cmd_word1:32;
}MD_REG_CMD1;

typedef struct
{
unsigned int     cmd_word2:32;
}MD_REG_CMD2;

typedef struct
{
unsigned int     cmd_word3:32;
}MD_REG_CMD3;

typedef struct
{
unsigned int     cmd_word4:32;
}MD_REG_CMD4;

typedef struct
{
unsigned int     reserved_0:29;
unsigned int     crc_data_ctrl:1;
unsigned int     w_crc_start:1;
unsigned int     w_crc_conti:1;
}MD_W_CRC_CTRL;

typedef struct
{
unsigned int     w_crc_mask1:32;
}MD_W_CRC_MASK1;

typedef struct
{
unsigned int     w_crc_mask2:32;
}MD_W_CRC_MASK2;

typedef struct
{
unsigned int     w_crc_result:32;
}MD_W_CRC_RESULT;

typedef struct
{
unsigned int     reserved_0:29;
unsigned int     auto_cmp_en:1;
unsigned int     r_crc_start:1;
unsigned int     r_crc_conti:1;
}MD_R_CRC_CTRL;

typedef struct
{
unsigned int     r_crc_mask1:32;
}MD_R_CRC_MASK1;

typedef struct
{
unsigned int     r_crc_mask2:32;
}MD_R_CRC_MASK2;

typedef struct
{
unsigned int     des_crc_result:32;
}MD_DES_CRC;

typedef struct
{
unsigned int     r_crc_result:32;
}MD_R_CRC_RESULT;

typedef struct
{
unsigned int     reserved_0:15;
unsigned int     cmd_addr_err:1;
unsigned int     crc_err_cnt:16;
}MD_CRC_STATUS;

typedef struct
{
unsigned int     reserved_0:31;
unsigned int     multi_req_en:1;
}MD_MULTI_REQ;

#endif

#define MD_SMQ_CNTL                                                                  0x1800B000
#define MD_SMQ_CNTL_reg_addr                                                         "0xB800B000"
#define MD_SMQ_CNTL_reg                                                              0xB800B000
#define set_MD_SMQ_CNTL_reg(data)   (*((volatile unsigned int*) MD_SMQ_CNTL_reg)=data)
#define get_MD_SMQ_CNTL_reg   (*((volatile unsigned int*) MD_SMQ_CNTL_reg))
#define MD_SMQ_CNTL_inst_adr                                                         "0x0000"
#define MD_SMQ_CNTL_inst                                                             0x0000
#define MD_SMQ_CNTL_smq_idle_shift                                                   (3)
#define MD_SMQ_CNTL_smq_idle_mask                                                    (0x00000008)
#define MD_SMQ_CNTL_smq_idle(data)                                                   (0x00000008&((data)<<3))
#define MD_SMQ_CNTL_smq_idle_src(data)                                               ((0x00000008&(data))>>3)
#define MD_SMQ_CNTL_get_smq_idle(data)                                               ((0x00000008&(data))>>3)
#define MD_SMQ_CNTL_smq_cmd_swap_shift                                               (2)
#define MD_SMQ_CNTL_smq_cmd_swap_mask                                                (0x00000004)
#define MD_SMQ_CNTL_smq_cmd_swap(data)                                               (0x00000004&((data)<<2))
#define MD_SMQ_CNTL_smq_cmd_swap_src(data)                                           ((0x00000004&(data))>>2)
#define MD_SMQ_CNTL_get_smq_cmd_swap(data)                                           ((0x00000004&(data))>>2)
#define MD_SMQ_CNTL_smq_go_shift                                                     (1)
#define MD_SMQ_CNTL_smq_go_mask                                                      (0x00000002)
#define MD_SMQ_CNTL_smq_go(data)                                                     (0x00000002&((data)<<1))
#define MD_SMQ_CNTL_smq_go_src(data)                                                 ((0x00000002&(data))>>1)
#define MD_SMQ_CNTL_get_smq_go(data)                                                 ((0x00000002&(data))>>1)
#define MD_SMQ_CNTL_write_data_shift                                                 (0)
#define MD_SMQ_CNTL_write_data_mask                                                  (0x00000001)
#define MD_SMQ_CNTL_write_data(data)                                                 (0x00000001&((data)<<0))
#define MD_SMQ_CNTL_write_data_src(data)                                             ((0x00000001&(data))>>0)
#define MD_SMQ_CNTL_get_write_data(data)                                             ((0x00000001&(data))>>0)


#define MD_SMQ_INT_STATUS                                                            0x1800B004
#define MD_SMQ_INT_STATUS_reg_addr                                                   "0xB800B004"
#define MD_SMQ_INT_STATUS_reg                                                        0xB800B004
#define set_MD_SMQ_INT_STATUS_reg(data)   (*((volatile unsigned int*) MD_SMQ_INT_STATUS_reg)=data)
#define get_MD_SMQ_INT_STATUS_reg   (*((volatile unsigned int*) MD_SMQ_INT_STATUS_reg))
#define MD_SMQ_INT_STATUS_inst_adr                                                   "0x0001"
#define MD_SMQ_INT_STATUS_inst                                                       0x0001
#define MD_SMQ_INT_STATUS_fdma_go_busy_shift                                         (10)
#define MD_SMQ_INT_STATUS_fdma_go_busy_mask                                          (0x00000400)
#define MD_SMQ_INT_STATUS_fdma_go_busy(data)                                         (0x00000400&((data)<<10))
#define MD_SMQ_INT_STATUS_fdma_go_busy_src(data)                                     ((0x00000400&(data))>>10)
#define MD_SMQ_INT_STATUS_get_fdma_go_busy(data)                                     ((0x00000400&(data))>>10)
#define MD_SMQ_INT_STATUS_ur_length_err_shift                                        (9)
#define MD_SMQ_INT_STATUS_ur_length_err_mask                                         (0x00000200)
#define MD_SMQ_INT_STATUS_ur_length_err(data)                                        (0x00000200&((data)<<9))
#define MD_SMQ_INT_STATUS_ur_length_err_src(data)                                    ((0x00000200&(data))>>9)
#define MD_SMQ_INT_STATUS_get_ur_length_err(data)                                    ((0x00000200&(data))>>9)
#define MD_SMQ_INT_STATUS_ur_rx_timeout_shift                                        (8)
#define MD_SMQ_INT_STATUS_ur_rx_timeout_mask                                         (0x00000100)
#define MD_SMQ_INT_STATUS_ur_rx_timeout(data)                                        (0x00000100&((data)<<8))
#define MD_SMQ_INT_STATUS_ur_rx_timeout_src(data)                                    ((0x00000100&(data))>>8)
#define MD_SMQ_INT_STATUS_get_ur_rx_timeout(data)                                    ((0x00000100&(data))>>8)
#define MD_SMQ_INT_STATUS_ur_rx_thd_shift                                            (7)
#define MD_SMQ_INT_STATUS_ur_rx_thd_mask                                             (0x00000080)
#define MD_SMQ_INT_STATUS_ur_rx_thd(data)                                            (0x00000080&((data)<<7))
#define MD_SMQ_INT_STATUS_ur_rx_thd_src(data)                                        ((0x00000080&(data))>>7)
#define MD_SMQ_INT_STATUS_get_ur_rx_thd(data)                                        ((0x00000080&(data))>>7)
#define MD_SMQ_INT_STATUS_ur_tx_thd_shift                                            (6)
#define MD_SMQ_INT_STATUS_ur_tx_thd_mask                                             (0x00000040)
#define MD_SMQ_INT_STATUS_ur_tx_thd(data)                                            (0x00000040&((data)<<6))
#define MD_SMQ_INT_STATUS_ur_tx_thd_src(data)                                        ((0x00000040&(data))>>6)
#define MD_SMQ_INT_STATUS_get_ur_tx_thd(data)                                        ((0x00000040&(data))>>6)
#define MD_SMQ_INT_STATUS_smq_mode_2b4berr_shift                                     (5)
#define MD_SMQ_INT_STATUS_smq_mode_2b4berr_mask                                      (0x00000020)
#define MD_SMQ_INT_STATUS_smq_mode_2b4berr(data)                                     (0x00000020&((data)<<5))
#define MD_SMQ_INT_STATUS_smq_mode_2b4berr_src(data)                                 ((0x00000020&(data))>>5)
#define MD_SMQ_INT_STATUS_get_smq_mode_2b4berr(data)                                 ((0x00000020&(data))>>5)
#define MD_SMQ_INT_STATUS_fdma_done_shift                                            (4)
#define MD_SMQ_INT_STATUS_fdma_done_mask                                             (0x00000010)
#define MD_SMQ_INT_STATUS_fdma_done(data)                                            (0x00000010&((data)<<4))
#define MD_SMQ_INT_STATUS_fdma_done_src(data)                                        ((0x00000010&(data))>>4)
#define MD_SMQ_INT_STATUS_get_fdma_done(data)                                        ((0x00000010&(data))>>4)
#define MD_SMQ_INT_STATUS_smq_empty_shift                                            (3)
#define MD_SMQ_INT_STATUS_smq_empty_mask                                             (0x00000008)
#define MD_SMQ_INT_STATUS_smq_empty(data)                                            (0x00000008&((data)<<3))
#define MD_SMQ_INT_STATUS_smq_empty_src(data)                                        ((0x00000008&(data))>>3)
#define MD_SMQ_INT_STATUS_get_smq_empty(data)                                        ((0x00000008&(data))>>3)
#define MD_SMQ_INT_STATUS_smq_length_err_shift                                       (2)
#define MD_SMQ_INT_STATUS_smq_length_err_mask                                        (0x00000004)
#define MD_SMQ_INT_STATUS_smq_length_err(data)                                       (0x00000004&((data)<<2))
#define MD_SMQ_INT_STATUS_smq_length_err_src(data)                                   ((0x00000004&(data))>>2)
#define MD_SMQ_INT_STATUS_get_smq_length_err(data)                                   ((0x00000004&(data))>>2)
#define MD_SMQ_INT_STATUS_smq_inst_err_shift                                         (1)
#define MD_SMQ_INT_STATUS_smq_inst_err_mask                                          (0x00000002)
#define MD_SMQ_INT_STATUS_smq_inst_err(data)                                         (0x00000002&((data)<<1))
#define MD_SMQ_INT_STATUS_smq_inst_err_src(data)                                     ((0x00000002&(data))>>1)
#define MD_SMQ_INT_STATUS_get_smq_inst_err(data)                                     ((0x00000002&(data))>>1)
#define MD_SMQ_INT_STATUS_write_data_shift                                           (0)
#define MD_SMQ_INT_STATUS_write_data_mask                                            (0x00000001)
#define MD_SMQ_INT_STATUS_write_data(data)                                           (0x00000001&((data)<<0))
#define MD_SMQ_INT_STATUS_write_data_src(data)                                       ((0x00000001&(data))>>0)
#define MD_SMQ_INT_STATUS_get_write_data(data)                                       ((0x00000001&(data))>>0)


#define MD_SMQ_INT_ENABLE                                                            0x1800B008
#define MD_SMQ_INT_ENABLE_reg_addr                                                   "0xB800B008"
#define MD_SMQ_INT_ENABLE_reg                                                        0xB800B008
#define set_MD_SMQ_INT_ENABLE_reg(data)   (*((volatile unsigned int*) MD_SMQ_INT_ENABLE_reg)=data)
#define get_MD_SMQ_INT_ENABLE_reg   (*((volatile unsigned int*) MD_SMQ_INT_ENABLE_reg))
#define MD_SMQ_INT_ENABLE_inst_adr                                                   "0x0002"
#define MD_SMQ_INT_ENABLE_inst                                                       0x0002
#define MD_SMQ_INT_ENABLE_scpu_int_en_shift                                          (10)
#define MD_SMQ_INT_ENABLE_scpu_int_en_mask                                           (0x00000400)
#define MD_SMQ_INT_ENABLE_scpu_int_en(data)                                          (0x00000400&((data)<<10))
#define MD_SMQ_INT_ENABLE_scpu_int_en_src(data)                                      ((0x00000400&(data))>>10)
#define MD_SMQ_INT_ENABLE_get_scpu_int_en(data)                                      ((0x00000400&(data))>>10)
#define MD_SMQ_INT_ENABLE_ur_length_err_en_shift                                     (9)
#define MD_SMQ_INT_ENABLE_ur_length_err_en_mask                                      (0x00000200)
#define MD_SMQ_INT_ENABLE_ur_length_err_en(data)                                     (0x00000200&((data)<<9))
#define MD_SMQ_INT_ENABLE_ur_length_err_en_src(data)                                 ((0x00000200&(data))>>9)
#define MD_SMQ_INT_ENABLE_get_ur_length_err_en(data)                                 ((0x00000200&(data))>>9)
#define MD_SMQ_INT_ENABLE_ur_rx_timeout_en_shift                                     (8)
#define MD_SMQ_INT_ENABLE_ur_rx_timeout_en_mask                                      (0x00000100)
#define MD_SMQ_INT_ENABLE_ur_rx_timeout_en(data)                                     (0x00000100&((data)<<8))
#define MD_SMQ_INT_ENABLE_ur_rx_timeout_en_src(data)                                 ((0x00000100&(data))>>8)
#define MD_SMQ_INT_ENABLE_get_ur_rx_timeout_en(data)                                 ((0x00000100&(data))>>8)
#define MD_SMQ_INT_ENABLE_ur_rx_thd_en_shift                                         (7)
#define MD_SMQ_INT_ENABLE_ur_rx_thd_en_mask                                          (0x00000080)
#define MD_SMQ_INT_ENABLE_ur_rx_thd_en(data)                                         (0x00000080&((data)<<7))
#define MD_SMQ_INT_ENABLE_ur_rx_thd_en_src(data)                                     ((0x00000080&(data))>>7)
#define MD_SMQ_INT_ENABLE_get_ur_rx_thd_en(data)                                     ((0x00000080&(data))>>7)
#define MD_SMQ_INT_ENABLE_ur_tx_thd_en_shift                                         (6)
#define MD_SMQ_INT_ENABLE_ur_tx_thd_en_mask                                          (0x00000040)
#define MD_SMQ_INT_ENABLE_ur_tx_thd_en(data)                                         (0x00000040&((data)<<6))
#define MD_SMQ_INT_ENABLE_ur_tx_thd_en_src(data)                                     ((0x00000040&(data))>>6)
#define MD_SMQ_INT_ENABLE_get_ur_tx_thd_en(data)                                     ((0x00000040&(data))>>6)
#define MD_SMQ_INT_ENABLE_smq_mode_2b4b_err_en_shift                                 (5)
#define MD_SMQ_INT_ENABLE_smq_mode_2b4b_err_en_mask                                  (0x00000020)
#define MD_SMQ_INT_ENABLE_smq_mode_2b4b_err_en(data)                                 (0x00000020&((data)<<5))
#define MD_SMQ_INT_ENABLE_smq_mode_2b4b_err_en_src(data)                             ((0x00000020&(data))>>5)
#define MD_SMQ_INT_ENABLE_get_smq_mode_2b4b_err_en(data)                             ((0x00000020&(data))>>5)
#define MD_SMQ_INT_ENABLE_fdma_done_en_shift                                         (4)
#define MD_SMQ_INT_ENABLE_fdma_done_en_mask                                          (0x00000010)
#define MD_SMQ_INT_ENABLE_fdma_done_en(data)                                         (0x00000010&((data)<<4))
#define MD_SMQ_INT_ENABLE_fdma_done_en_src(data)                                     ((0x00000010&(data))>>4)
#define MD_SMQ_INT_ENABLE_get_fdma_done_en(data)                                     ((0x00000010&(data))>>4)
#define MD_SMQ_INT_ENABLE_smq_empty_en_shift                                         (3)
#define MD_SMQ_INT_ENABLE_smq_empty_en_mask                                          (0x00000008)
#define MD_SMQ_INT_ENABLE_smq_empty_en(data)                                         (0x00000008&((data)<<3))
#define MD_SMQ_INT_ENABLE_smq_empty_en_src(data)                                     ((0x00000008&(data))>>3)
#define MD_SMQ_INT_ENABLE_get_smq_empty_en(data)                                     ((0x00000008&(data))>>3)
#define MD_SMQ_INT_ENABLE_smq_length_err_en_shift                                    (2)
#define MD_SMQ_INT_ENABLE_smq_length_err_en_mask                                     (0x00000004)
#define MD_SMQ_INT_ENABLE_smq_length_err_en(data)                                    (0x00000004&((data)<<2))
#define MD_SMQ_INT_ENABLE_smq_length_err_en_src(data)                                ((0x00000004&(data))>>2)
#define MD_SMQ_INT_ENABLE_get_smq_length_err_en(data)                                ((0x00000004&(data))>>2)
#define MD_SMQ_INT_ENABLE_smq_inst_err_en_shift                                      (1)
#define MD_SMQ_INT_ENABLE_smq_inst_err_en_mask                                       (0x00000002)
#define MD_SMQ_INT_ENABLE_smq_inst_err_en(data)                                      (0x00000002&((data)<<1))
#define MD_SMQ_INT_ENABLE_smq_inst_err_en_src(data)                                  ((0x00000002&(data))>>1)
#define MD_SMQ_INT_ENABLE_get_smq_inst_err_en(data)                                  ((0x00000002&(data))>>1)
#define MD_SMQ_INT_ENABLE_write_data_shift                                           (0)
#define MD_SMQ_INT_ENABLE_write_data_mask                                            (0x00000001)
#define MD_SMQ_INT_ENABLE_write_data(data)                                           (0x00000001&((data)<<0))
#define MD_SMQ_INT_ENABLE_write_data_src(data)                                       ((0x00000001&(data))>>0)
#define MD_SMQ_INT_ENABLE_get_write_data(data)                                       ((0x00000001&(data))>>0)


#define MD_SMQBASE                                                                   0x1800B00C
#define MD_SMQBASE_reg_addr                                                          "0xB800B00C"
#define MD_SMQBASE_reg                                                               0xB800B00C
#define set_MD_SMQBASE_reg(data)   (*((volatile unsigned int*) MD_SMQBASE_reg)=data)
#define get_MD_SMQBASE_reg   (*((volatile unsigned int*) MD_SMQBASE_reg))
#define MD_SMQBASE_inst_adr                                                          "0x0003"
#define MD_SMQBASE_inst                                                              0x0003
#define MD_SMQBASE_smq_base_shift                                                    (4)
#define MD_SMQBASE_smq_base_mask                                                     (0x7FFFFFF0)
#define MD_SMQBASE_smq_base(data)                                                    (0x7FFFFFF0&((data)<<4))
#define MD_SMQBASE_smq_base_src(data)                                                ((0x7FFFFFF0&(data))>>4)
#define MD_SMQBASE_get_smq_base(data)                                                ((0x7FFFFFF0&(data))>>4)


#define MD_SMQLIMIT                                                                  0x1800B010
#define MD_SMQLIMIT_reg_addr                                                         "0xB800B010"
#define MD_SMQLIMIT_reg                                                              0xB800B010
#define set_MD_SMQLIMIT_reg(data)   (*((volatile unsigned int*) MD_SMQLIMIT_reg)=data)
#define get_MD_SMQLIMIT_reg   (*((volatile unsigned int*) MD_SMQLIMIT_reg))
#define MD_SMQLIMIT_inst_adr                                                         "0x0004"
#define MD_SMQLIMIT_inst                                                             0x0004
#define MD_SMQLIMIT_smq_limit_shift                                                  (4)
#define MD_SMQLIMIT_smq_limit_mask                                                   (0x7FFFFFF0)
#define MD_SMQLIMIT_smq_limit(data)                                                  (0x7FFFFFF0&((data)<<4))
#define MD_SMQLIMIT_smq_limit_src(data)                                              ((0x7FFFFFF0&(data))>>4)
#define MD_SMQLIMIT_get_smq_limit(data)                                              ((0x7FFFFFF0&(data))>>4)


#define MD_SMQRDPTR                                                                  0x1800B014
#define MD_SMQRDPTR_reg_addr                                                         "0xB800B014"
#define MD_SMQRDPTR_reg                                                              0xB800B014
#define set_MD_SMQRDPTR_reg(data)   (*((volatile unsigned int*) MD_SMQRDPTR_reg)=data)
#define get_MD_SMQRDPTR_reg   (*((volatile unsigned int*) MD_SMQRDPTR_reg))
#define MD_SMQRDPTR_inst_adr                                                         "0x0005"
#define MD_SMQRDPTR_inst                                                             0x0005
#define MD_SMQRDPTR_smq_rdptr_shift                                                  (4)
#define MD_SMQRDPTR_smq_rdptr_mask                                                   (0x7FFFFFF0)
#define MD_SMQRDPTR_smq_rdptr(data)                                                  (0x7FFFFFF0&((data)<<4))
#define MD_SMQRDPTR_smq_rdptr_src(data)                                              ((0x7FFFFFF0&(data))>>4)
#define MD_SMQRDPTR_get_smq_rdptr(data)                                              ((0x7FFFFFF0&(data))>>4)


#define MD_SMQWRPTR                                                                  0x1800B018
#define MD_SMQWRPTR_reg_addr                                                         "0xB800B018"
#define MD_SMQWRPTR_reg                                                              0xB800B018
#define set_MD_SMQWRPTR_reg(data)   (*((volatile unsigned int*) MD_SMQWRPTR_reg)=data)
#define get_MD_SMQWRPTR_reg   (*((volatile unsigned int*) MD_SMQWRPTR_reg))
#define MD_SMQWRPTR_inst_adr                                                         "0x0006"
#define MD_SMQWRPTR_inst                                                             0x0006
#define MD_SMQWRPTR_smq_wrptr_shift                                                  (4)
#define MD_SMQWRPTR_smq_wrptr_mask                                                   (0x7FFFFFF0)
#define MD_SMQWRPTR_smq_wrptr(data)                                                  (0x7FFFFFF0&((data)<<4))
#define MD_SMQWRPTR_smq_wrptr_src(data)                                              ((0x7FFFFFF0&(data))>>4)
#define MD_SMQWRPTR_get_smq_wrptr(data)                                              ((0x7FFFFFF0&(data))>>4)


#define MD_SMQFIFOSTATE                                                              0x1800B01C
#define MD_SMQFIFOSTATE_reg_addr                                                     "0xB800B01C"
#define MD_SMQFIFOSTATE_reg                                                          0xB800B01C
#define set_MD_SMQFIFOSTATE_reg(data)   (*((volatile unsigned int*) MD_SMQFIFOSTATE_reg)=data)
#define get_MD_SMQFIFOSTATE_reg   (*((volatile unsigned int*) MD_SMQFIFOSTATE_reg))
#define MD_SMQFIFOSTATE_inst_adr                                                     "0x0007"
#define MD_SMQFIFOSTATE_inst                                                         0x0007
#define MD_SMQFIFOSTATE_smq_inst_remain_shift                                        (0)
#define MD_SMQFIFOSTATE_smq_inst_remain_mask                                         (0x0000001F)
#define MD_SMQFIFOSTATE_smq_inst_remain(data)                                        (0x0000001F&((data)<<0))
#define MD_SMQFIFOSTATE_smq_inst_remain_src(data)                                    ((0x0000001F&(data))>>0)
#define MD_SMQFIFOSTATE_get_smq_inst_remain(data)                                    ((0x0000001F&(data))>>0)


#define MD_SMQ_INSTCNT                                                               0x1800B020
#define MD_SMQ_INSTCNT_reg_addr                                                      "0xB800B020"
#define MD_SMQ_INSTCNT_reg                                                           0xB800B020
#define set_MD_SMQ_INSTCNT_reg(data)   (*((volatile unsigned int*) MD_SMQ_INSTCNT_reg)=data)
#define get_MD_SMQ_INSTCNT_reg   (*((volatile unsigned int*) MD_SMQ_INSTCNT_reg))
#define MD_SMQ_INSTCNT_inst_adr                                                      "0x0008"
#define MD_SMQ_INSTCNT_inst                                                          0x0008
#define MD_SMQ_INSTCNT_smq_inst_cnt_shift                                            (0)
#define MD_SMQ_INSTCNT_smq_inst_cnt_mask                                             (0x0000FFFF)
#define MD_SMQ_INSTCNT_smq_inst_cnt(data)                                            (0x0000FFFF&((data)<<0))
#define MD_SMQ_INSTCNT_smq_inst_cnt_src(data)                                        ((0x0000FFFF&(data))>>0)
#define MD_SMQ_INSTCNT_get_smq_inst_cnt(data)                                        ((0x0000FFFF&(data))>>0)


#define MD_VMQ_CNTL                                                                  0x1800B030
#define MD_VMQ_CNTL_reg_addr                                                         "0xB800B030"
#define MD_VMQ_CNTL_reg                                                              0xB800B030
#define set_MD_VMQ_CNTL_reg(data)   (*((volatile unsigned int*) MD_VMQ_CNTL_reg)=data)
#define get_MD_VMQ_CNTL_reg   (*((volatile unsigned int*) MD_VMQ_CNTL_reg))
#define MD_VMQ_CNTL_inst_adr                                                         "0x000C"
#define MD_VMQ_CNTL_inst                                                             0x000C
#define MD_VMQ_CNTL_vmq_idle_shift                                                   (3)
#define MD_VMQ_CNTL_vmq_idle_mask                                                    (0x00000008)
#define MD_VMQ_CNTL_vmq_idle(data)                                                   (0x00000008&((data)<<3))
#define MD_VMQ_CNTL_vmq_idle_src(data)                                               ((0x00000008&(data))>>3)
#define MD_VMQ_CNTL_get_vmq_idle(data)                                               ((0x00000008&(data))>>3)
#define MD_VMQ_CNTL_vmq_cmd_swap_shift                                               (2)
#define MD_VMQ_CNTL_vmq_cmd_swap_mask                                                (0x00000004)
#define MD_VMQ_CNTL_vmq_cmd_swap(data)                                               (0x00000004&((data)<<2))
#define MD_VMQ_CNTL_vmq_cmd_swap_src(data)                                           ((0x00000004&(data))>>2)
#define MD_VMQ_CNTL_get_vmq_cmd_swap(data)                                           ((0x00000004&(data))>>2)
#define MD_VMQ_CNTL_vmq_go_shift                                                     (1)
#define MD_VMQ_CNTL_vmq_go_mask                                                      (0x00000002)
#define MD_VMQ_CNTL_vmq_go(data)                                                     (0x00000002&((data)<<1))
#define MD_VMQ_CNTL_vmq_go_src(data)                                                 ((0x00000002&(data))>>1)
#define MD_VMQ_CNTL_get_vmq_go(data)                                                 ((0x00000002&(data))>>1)
#define MD_VMQ_CNTL_write_data_shift                                                 (0)
#define MD_VMQ_CNTL_write_data_mask                                                  (0x00000001)
#define MD_VMQ_CNTL_write_data(data)                                                 (0x00000001&((data)<<0))
#define MD_VMQ_CNTL_write_data_src(data)                                             ((0x00000001&(data))>>0)
#define MD_VMQ_CNTL_get_write_data(data)                                             ((0x00000001&(data))>>0)


#define MD_VMQ_INT_STATUS                                                            0x1800B034
#define MD_VMQ_INT_STATUS_reg_addr                                                   "0xB800B034"
#define MD_VMQ_INT_STATUS_reg                                                        0xB800B034
#define set_MD_VMQ_INT_STATUS_reg(data)   (*((volatile unsigned int*) MD_VMQ_INT_STATUS_reg)=data)
#define get_MD_VMQ_INT_STATUS_reg   (*((volatile unsigned int*) MD_VMQ_INT_STATUS_reg))
#define MD_VMQ_INT_STATUS_inst_adr                                                   "0x000D"
#define MD_VMQ_INT_STATUS_inst                                                       0x000D
#define MD_VMQ_INT_STATUS_vmq_mode_2b4berr_shift                                     (4)
#define MD_VMQ_INT_STATUS_vmq_mode_2b4berr_mask                                      (0x00000010)
#define MD_VMQ_INT_STATUS_vmq_mode_2b4berr(data)                                     (0x00000010&((data)<<4))
#define MD_VMQ_INT_STATUS_vmq_mode_2b4berr_src(data)                                 ((0x00000010&(data))>>4)
#define MD_VMQ_INT_STATUS_get_vmq_mode_2b4berr(data)                                 ((0x00000010&(data))>>4)
#define MD_VMQ_INT_STATUS_vmq_empty_shift                                            (3)
#define MD_VMQ_INT_STATUS_vmq_empty_mask                                             (0x00000008)
#define MD_VMQ_INT_STATUS_vmq_empty(data)                                            (0x00000008&((data)<<3))
#define MD_VMQ_INT_STATUS_vmq_empty_src(data)                                        ((0x00000008&(data))>>3)
#define MD_VMQ_INT_STATUS_get_vmq_empty(data)                                        ((0x00000008&(data))>>3)
#define MD_VMQ_INT_STATUS_vmq_length_err_shift                                       (2)
#define MD_VMQ_INT_STATUS_vmq_length_err_mask                                        (0x00000004)
#define MD_VMQ_INT_STATUS_vmq_length_err(data)                                       (0x00000004&((data)<<2))
#define MD_VMQ_INT_STATUS_vmq_length_err_src(data)                                   ((0x00000004&(data))>>2)
#define MD_VMQ_INT_STATUS_get_vmq_length_err(data)                                   ((0x00000004&(data))>>2)
#define MD_VMQ_INT_STATUS_vmq_inst_err_shift                                         (1)
#define MD_VMQ_INT_STATUS_vmq_inst_err_mask                                          (0x00000002)
#define MD_VMQ_INT_STATUS_vmq_inst_err(data)                                         (0x00000002&((data)<<1))
#define MD_VMQ_INT_STATUS_vmq_inst_err_src(data)                                     ((0x00000002&(data))>>1)
#define MD_VMQ_INT_STATUS_get_vmq_inst_err(data)                                     ((0x00000002&(data))>>1)
#define MD_VMQ_INT_STATUS_write_data_shift                                           (0)
#define MD_VMQ_INT_STATUS_write_data_mask                                            (0x00000001)
#define MD_VMQ_INT_STATUS_write_data(data)                                           (0x00000001&((data)<<0))
#define MD_VMQ_INT_STATUS_write_data_src(data)                                       ((0x00000001&(data))>>0)
#define MD_VMQ_INT_STATUS_get_write_data(data)                                       ((0x00000001&(data))>>0)


#define MD_VMQ_INT_ENABLE                                                            0x1800B038
#define MD_VMQ_INT_ENABLE_reg_addr                                                   "0xB800B038"
#define MD_VMQ_INT_ENABLE_reg                                                        0xB800B038
#define set_MD_VMQ_INT_ENABLE_reg(data)   (*((volatile unsigned int*) MD_VMQ_INT_ENABLE_reg)=data)
#define get_MD_VMQ_INT_ENABLE_reg   (*((volatile unsigned int*) MD_VMQ_INT_ENABLE_reg))
#define MD_VMQ_INT_ENABLE_inst_adr                                                   "0x000E"
#define MD_VMQ_INT_ENABLE_inst                                                       0x000E
#define MD_VMQ_INT_ENABLE_vcpu_int_en_shift                                          (5)
#define MD_VMQ_INT_ENABLE_vcpu_int_en_mask                                           (0x00000020)
#define MD_VMQ_INT_ENABLE_vcpu_int_en(data)                                          (0x00000020&((data)<<5))
#define MD_VMQ_INT_ENABLE_vcpu_int_en_src(data)                                      ((0x00000020&(data))>>5)
#define MD_VMQ_INT_ENABLE_get_vcpu_int_en(data)                                      ((0x00000020&(data))>>5)
#define MD_VMQ_INT_ENABLE_vmq_mode_2b4b_err_en_shift                                 (4)
#define MD_VMQ_INT_ENABLE_vmq_mode_2b4b_err_en_mask                                  (0x00000010)
#define MD_VMQ_INT_ENABLE_vmq_mode_2b4b_err_en(data)                                 (0x00000010&((data)<<4))
#define MD_VMQ_INT_ENABLE_vmq_mode_2b4b_err_en_src(data)                             ((0x00000010&(data))>>4)
#define MD_VMQ_INT_ENABLE_get_vmq_mode_2b4b_err_en(data)                             ((0x00000010&(data))>>4)
#define MD_VMQ_INT_ENABLE_vmq_empty_en_shift                                         (3)
#define MD_VMQ_INT_ENABLE_vmq_empty_en_mask                                          (0x00000008)
#define MD_VMQ_INT_ENABLE_vmq_empty_en(data)                                         (0x00000008&((data)<<3))
#define MD_VMQ_INT_ENABLE_vmq_empty_en_src(data)                                     ((0x00000008&(data))>>3)
#define MD_VMQ_INT_ENABLE_get_vmq_empty_en(data)                                     ((0x00000008&(data))>>3)
#define MD_VMQ_INT_ENABLE_vmq_length_err_en_shift                                    (2)
#define MD_VMQ_INT_ENABLE_vmq_length_err_en_mask                                     (0x00000004)
#define MD_VMQ_INT_ENABLE_vmq_length_err_en(data)                                    (0x00000004&((data)<<2))
#define MD_VMQ_INT_ENABLE_vmq_length_err_en_src(data)                                ((0x00000004&(data))>>2)
#define MD_VMQ_INT_ENABLE_get_vmq_length_err_en(data)                                ((0x00000004&(data))>>2)
#define MD_VMQ_INT_ENABLE_vmq_inst_err_en_shift                                      (1)
#define MD_VMQ_INT_ENABLE_vmq_inst_err_en_mask                                       (0x00000002)
#define MD_VMQ_INT_ENABLE_vmq_inst_err_en(data)                                      (0x00000002&((data)<<1))
#define MD_VMQ_INT_ENABLE_vmq_inst_err_en_src(data)                                  ((0x00000002&(data))>>1)
#define MD_VMQ_INT_ENABLE_get_vmq_inst_err_en(data)                                  ((0x00000002&(data))>>1)
#define MD_VMQ_INT_ENABLE_write_data_shift                                           (0)
#define MD_VMQ_INT_ENABLE_write_data_mask                                            (0x00000001)
#define MD_VMQ_INT_ENABLE_write_data(data)                                           (0x00000001&((data)<<0))
#define MD_VMQ_INT_ENABLE_write_data_src(data)                                       ((0x00000001&(data))>>0)
#define MD_VMQ_INT_ENABLE_get_write_data(data)                                       ((0x00000001&(data))>>0)


#define MD_VMQBASE                                                                   0x1800B03C
#define MD_VMQBASE_reg_addr                                                          "0xB800B03C"
#define MD_VMQBASE_reg                                                               0xB800B03C
#define set_MD_VMQBASE_reg(data)   (*((volatile unsigned int*) MD_VMQBASE_reg)=data)
#define get_MD_VMQBASE_reg   (*((volatile unsigned int*) MD_VMQBASE_reg))
#define MD_VMQBASE_inst_adr                                                          "0x000F"
#define MD_VMQBASE_inst                                                              0x000F
#define MD_VMQBASE_vmq_base_shift                                                    (4)
#define MD_VMQBASE_vmq_base_mask                                                     (0x7FFFFFF0)
#define MD_VMQBASE_vmq_base(data)                                                    (0x7FFFFFF0&((data)<<4))
#define MD_VMQBASE_vmq_base_src(data)                                                ((0x7FFFFFF0&(data))>>4)
#define MD_VMQBASE_get_vmq_base(data)                                                ((0x7FFFFFF0&(data))>>4)


#define MD_VMQLIMIT                                                                  0x1800B040
#define MD_VMQLIMIT_reg_addr                                                         "0xB800B040"
#define MD_VMQLIMIT_reg                                                              0xB800B040
#define set_MD_VMQLIMIT_reg(data)   (*((volatile unsigned int*) MD_VMQLIMIT_reg)=data)
#define get_MD_VMQLIMIT_reg   (*((volatile unsigned int*) MD_VMQLIMIT_reg))
#define MD_VMQLIMIT_inst_adr                                                         "0x0010"
#define MD_VMQLIMIT_inst                                                             0x0010
#define MD_VMQLIMIT_vmq_limit_shift                                                  (4)
#define MD_VMQLIMIT_vmq_limit_mask                                                   (0x7FFFFFF0)
#define MD_VMQLIMIT_vmq_limit(data)                                                  (0x7FFFFFF0&((data)<<4))
#define MD_VMQLIMIT_vmq_limit_src(data)                                              ((0x7FFFFFF0&(data))>>4)
#define MD_VMQLIMIT_get_vmq_limit(data)                                              ((0x7FFFFFF0&(data))>>4)


#define MD_VMQRDPTR                                                                  0x1800B044
#define MD_VMQRDPTR_reg_addr                                                         "0xB800B044"
#define MD_VMQRDPTR_reg                                                              0xB800B044
#define set_MD_VMQRDPTR_reg(data)   (*((volatile unsigned int*) MD_VMQRDPTR_reg)=data)
#define get_MD_VMQRDPTR_reg   (*((volatile unsigned int*) MD_VMQRDPTR_reg))
#define MD_VMQRDPTR_inst_adr                                                         "0x0011"
#define MD_VMQRDPTR_inst                                                             0x0011
#define MD_VMQRDPTR_vmq_rdptr_shift                                                  (4)
#define MD_VMQRDPTR_vmq_rdptr_mask                                                   (0x7FFFFFF0)
#define MD_VMQRDPTR_vmq_rdptr(data)                                                  (0x7FFFFFF0&((data)<<4))
#define MD_VMQRDPTR_vmq_rdptr_src(data)                                              ((0x7FFFFFF0&(data))>>4)
#define MD_VMQRDPTR_get_vmq_rdptr(data)                                              ((0x7FFFFFF0&(data))>>4)


#define MD_VMQWRPTR                                                                  0x1800B048
#define MD_VMQWRPTR_reg_addr                                                         "0xB800B048"
#define MD_VMQWRPTR_reg                                                              0xB800B048
#define set_MD_VMQWRPTR_reg(data)   (*((volatile unsigned int*) MD_VMQWRPTR_reg)=data)
#define get_MD_VMQWRPTR_reg   (*((volatile unsigned int*) MD_VMQWRPTR_reg))
#define MD_VMQWRPTR_inst_adr                                                         "0x0012"
#define MD_VMQWRPTR_inst                                                             0x0012
#define MD_VMQWRPTR_vmq_wrptr_shift                                                  (4)
#define MD_VMQWRPTR_vmq_wrptr_mask                                                   (0x7FFFFFF0)
#define MD_VMQWRPTR_vmq_wrptr(data)                                                  (0x7FFFFFF0&((data)<<4))
#define MD_VMQWRPTR_vmq_wrptr_src(data)                                              ((0x7FFFFFF0&(data))>>4)
#define MD_VMQWRPTR_get_vmq_wrptr(data)                                              ((0x7FFFFFF0&(data))>>4)


#define MD_VMQFIFOSTATE                                                              0x1800B04C
#define MD_VMQFIFOSTATE_reg_addr                                                     "0xB800B04C"
#define MD_VMQFIFOSTATE_reg                                                          0xB800B04C
#define set_MD_VMQFIFOSTATE_reg(data)   (*((volatile unsigned int*) MD_VMQFIFOSTATE_reg)=data)
#define get_MD_VMQFIFOSTATE_reg   (*((volatile unsigned int*) MD_VMQFIFOSTATE_reg))
#define MD_VMQFIFOSTATE_inst_adr                                                     "0x0013"
#define MD_VMQFIFOSTATE_inst                                                         0x0013
#define MD_VMQFIFOSTATE_vmq_inst_remain_shift                                        (0)
#define MD_VMQFIFOSTATE_vmq_inst_remain_mask                                         (0x0000001F)
#define MD_VMQFIFOSTATE_vmq_inst_remain(data)                                        (0x0000001F&((data)<<0))
#define MD_VMQFIFOSTATE_vmq_inst_remain_src(data)                                    ((0x0000001F&(data))>>0)
#define MD_VMQFIFOSTATE_get_vmq_inst_remain(data)                                    ((0x0000001F&(data))>>0)


#define MD_VMQ_INSTCNT                                                               0x1800B050
#define MD_VMQ_INSTCNT_reg_addr                                                      "0xB800B050"
#define MD_VMQ_INSTCNT_reg                                                           0xB800B050
#define set_MD_VMQ_INSTCNT_reg(data)   (*((volatile unsigned int*) MD_VMQ_INSTCNT_reg)=data)
#define get_MD_VMQ_INSTCNT_reg   (*((volatile unsigned int*) MD_VMQ_INSTCNT_reg))
#define MD_VMQ_INSTCNT_inst_adr                                                      "0x0014"
#define MD_VMQ_INSTCNT_inst                                                          0x0014
#define MD_VMQ_INSTCNT_vmq_inst_cnt_shift                                            (0)
#define MD_VMQ_INSTCNT_vmq_inst_cnt_mask                                             (0x0000FFFF)
#define MD_VMQ_INSTCNT_vmq_inst_cnt(data)                                            (0x0000FFFF&((data)<<0))
#define MD_VMQ_INSTCNT_vmq_inst_cnt_src(data)                                        ((0x0000FFFF&(data))>>0)
#define MD_VMQ_INSTCNT_get_vmq_inst_cnt(data)                                        ((0x0000FFFF&(data))>>0)


#define MD_KMQ_CNTL                                                                  0x1800B060
#define MD_KMQ_CNTL_reg_addr                                                         "0xB800B060"
#define MD_KMQ_CNTL_reg                                                              0xB800B060
#define set_MD_KMQ_CNTL_reg(data)   (*((volatile unsigned int*) MD_KMQ_CNTL_reg)=data)
#define get_MD_KMQ_CNTL_reg   (*((volatile unsigned int*) MD_KMQ_CNTL_reg))
#define MD_KMQ_CNTL_inst_adr                                                         "0x0018"
#define MD_KMQ_CNTL_inst                                                             0x0018
#define MD_KMQ_CNTL_kmq_idle_shift                                                   (3)
#define MD_KMQ_CNTL_kmq_idle_mask                                                    (0x00000008)
#define MD_KMQ_CNTL_kmq_idle(data)                                                   (0x00000008&((data)<<3))
#define MD_KMQ_CNTL_kmq_idle_src(data)                                               ((0x00000008&(data))>>3)
#define MD_KMQ_CNTL_get_kmq_idle(data)                                               ((0x00000008&(data))>>3)
#define MD_KMQ_CNTL_kmq_cmd_swap_shift                                               (2)
#define MD_KMQ_CNTL_kmq_cmd_swap_mask                                                (0x00000004)
#define MD_KMQ_CNTL_kmq_cmd_swap(data)                                               (0x00000004&((data)<<2))
#define MD_KMQ_CNTL_kmq_cmd_swap_src(data)                                           ((0x00000004&(data))>>2)
#define MD_KMQ_CNTL_get_kmq_cmd_swap(data)                                           ((0x00000004&(data))>>2)
#define MD_KMQ_CNTL_kmq_go_shift                                                     (1)
#define MD_KMQ_CNTL_kmq_go_mask                                                      (0x00000002)
#define MD_KMQ_CNTL_kmq_go(data)                                                     (0x00000002&((data)<<1))
#define MD_KMQ_CNTL_kmq_go_src(data)                                                 ((0x00000002&(data))>>1)
#define MD_KMQ_CNTL_get_kmq_go(data)                                                 ((0x00000002&(data))>>1)
#define MD_KMQ_CNTL_write_data_shift                                                 (0)
#define MD_KMQ_CNTL_write_data_mask                                                  (0x00000001)
#define MD_KMQ_CNTL_write_data(data)                                                 (0x00000001&((data)<<0))
#define MD_KMQ_CNTL_write_data_src(data)                                             ((0x00000001&(data))>>0)
#define MD_KMQ_CNTL_get_write_data(data)                                             ((0x00000001&(data))>>0)


#define MD_KMQ_INT_STATUS                                                            0x1800B064
#define MD_KMQ_INT_STATUS_reg_addr                                                   "0xB800B064"
#define MD_KMQ_INT_STATUS_reg                                                        0xB800B064
#define set_MD_KMQ_INT_STATUS_reg(data)   (*((volatile unsigned int*) MD_KMQ_INT_STATUS_reg)=data)
#define get_MD_KMQ_INT_STATUS_reg   (*((volatile unsigned int*) MD_KMQ_INT_STATUS_reg))
#define MD_KMQ_INT_STATUS_inst_adr                                                   "0x0019"
#define MD_KMQ_INT_STATUS_inst                                                       0x0019
#define MD_KMQ_INT_STATUS_kmq_mode_2b4berr_shift                                     (4)
#define MD_KMQ_INT_STATUS_kmq_mode_2b4berr_mask                                      (0x00000010)
#define MD_KMQ_INT_STATUS_kmq_mode_2b4berr(data)                                     (0x00000010&((data)<<4))
#define MD_KMQ_INT_STATUS_kmq_mode_2b4berr_src(data)                                 ((0x00000010&(data))>>4)
#define MD_KMQ_INT_STATUS_get_kmq_mode_2b4berr(data)                                 ((0x00000010&(data))>>4)
#define MD_KMQ_INT_STATUS_kmq_empty_shift                                            (3)
#define MD_KMQ_INT_STATUS_kmq_empty_mask                                             (0x00000008)
#define MD_KMQ_INT_STATUS_kmq_empty(data)                                            (0x00000008&((data)<<3))
#define MD_KMQ_INT_STATUS_kmq_empty_src(data)                                        ((0x00000008&(data))>>3)
#define MD_KMQ_INT_STATUS_get_kmq_empty(data)                                        ((0x00000008&(data))>>3)
#define MD_KMQ_INT_STATUS_kmq_length_err_shift                                       (2)
#define MD_KMQ_INT_STATUS_kmq_length_err_mask                                        (0x00000004)
#define MD_KMQ_INT_STATUS_kmq_length_err(data)                                       (0x00000004&((data)<<2))
#define MD_KMQ_INT_STATUS_kmq_length_err_src(data)                                   ((0x00000004&(data))>>2)
#define MD_KMQ_INT_STATUS_get_kmq_length_err(data)                                   ((0x00000004&(data))>>2)
#define MD_KMQ_INT_STATUS_kmq_inst_err_shift                                         (1)
#define MD_KMQ_INT_STATUS_kmq_inst_err_mask                                          (0x00000002)
#define MD_KMQ_INT_STATUS_kmq_inst_err(data)                                         (0x00000002&((data)<<1))
#define MD_KMQ_INT_STATUS_kmq_inst_err_src(data)                                     ((0x00000002&(data))>>1)
#define MD_KMQ_INT_STATUS_get_kmq_inst_err(data)                                     ((0x00000002&(data))>>1)
#define MD_KMQ_INT_STATUS_write_data_shift                                           (0)
#define MD_KMQ_INT_STATUS_write_data_mask                                            (0x00000001)
#define MD_KMQ_INT_STATUS_write_data(data)                                           (0x00000001&((data)<<0))
#define MD_KMQ_INT_STATUS_write_data_src(data)                                       ((0x00000001&(data))>>0)
#define MD_KMQ_INT_STATUS_get_write_data(data)                                       ((0x00000001&(data))>>0)


#define MD_KMQ_INT_ENABLE                                                            0x1800B068
#define MD_KMQ_INT_ENABLE_reg_addr                                                   "0xB800B068"
#define MD_KMQ_INT_ENABLE_reg                                                        0xB800B068
#define set_MD_KMQ_INT_ENABLE_reg(data)   (*((volatile unsigned int*) MD_KMQ_INT_ENABLE_reg)=data)
#define get_MD_KMQ_INT_ENABLE_reg   (*((volatile unsigned int*) MD_KMQ_INT_ENABLE_reg))
#define MD_KMQ_INT_ENABLE_inst_adr                                                   "0x001A"
#define MD_KMQ_INT_ENABLE_inst                                                       0x001A
#define MD_KMQ_INT_ENABLE_kcpu_int_en_shift                                          (5)
#define MD_KMQ_INT_ENABLE_kcpu_int_en_mask                                           (0x00000020)
#define MD_KMQ_INT_ENABLE_kcpu_int_en(data)                                          (0x00000020&((data)<<5))
#define MD_KMQ_INT_ENABLE_kcpu_int_en_src(data)                                      ((0x00000020&(data))>>5)
#define MD_KMQ_INT_ENABLE_get_kcpu_int_en(data)                                      ((0x00000020&(data))>>5)
#define MD_KMQ_INT_ENABLE_kmq_mode_2b4b_err_en_shift                                 (4)
#define MD_KMQ_INT_ENABLE_kmq_mode_2b4b_err_en_mask                                  (0x00000010)
#define MD_KMQ_INT_ENABLE_kmq_mode_2b4b_err_en(data)                                 (0x00000010&((data)<<4))
#define MD_KMQ_INT_ENABLE_kmq_mode_2b4b_err_en_src(data)                             ((0x00000010&(data))>>4)
#define MD_KMQ_INT_ENABLE_get_kmq_mode_2b4b_err_en(data)                             ((0x00000010&(data))>>4)
#define MD_KMQ_INT_ENABLE_kmq_empty_en_shift                                         (3)
#define MD_KMQ_INT_ENABLE_kmq_empty_en_mask                                          (0x00000008)
#define MD_KMQ_INT_ENABLE_kmq_empty_en(data)                                         (0x00000008&((data)<<3))
#define MD_KMQ_INT_ENABLE_kmq_empty_en_src(data)                                     ((0x00000008&(data))>>3)
#define MD_KMQ_INT_ENABLE_get_kmq_empty_en(data)                                     ((0x00000008&(data))>>3)
#define MD_KMQ_INT_ENABLE_kmq_length_err_en_shift                                    (2)
#define MD_KMQ_INT_ENABLE_kmq_length_err_en_mask                                     (0x00000004)
#define MD_KMQ_INT_ENABLE_kmq_length_err_en(data)                                    (0x00000004&((data)<<2))
#define MD_KMQ_INT_ENABLE_kmq_length_err_en_src(data)                                ((0x00000004&(data))>>2)
#define MD_KMQ_INT_ENABLE_get_kmq_length_err_en(data)                                ((0x00000004&(data))>>2)
#define MD_KMQ_INT_ENABLE_kmq_inst_err_en_shift                                      (1)
#define MD_KMQ_INT_ENABLE_kmq_inst_err_en_mask                                       (0x00000002)
#define MD_KMQ_INT_ENABLE_kmq_inst_err_en(data)                                      (0x00000002&((data)<<1))
#define MD_KMQ_INT_ENABLE_kmq_inst_err_en_src(data)                                  ((0x00000002&(data))>>1)
#define MD_KMQ_INT_ENABLE_get_kmq_inst_err_en(data)                                  ((0x00000002&(data))>>1)
#define MD_KMQ_INT_ENABLE_write_data_shift                                           (0)
#define MD_KMQ_INT_ENABLE_write_data_mask                                            (0x00000001)
#define MD_KMQ_INT_ENABLE_write_data(data)                                           (0x00000001&((data)<<0))
#define MD_KMQ_INT_ENABLE_write_data_src(data)                                       ((0x00000001&(data))>>0)
#define MD_KMQ_INT_ENABLE_get_write_data(data)                                       ((0x00000001&(data))>>0)


#define MD_KMQBASE                                                                   0x1800B06C
#define MD_KMQBASE_reg_addr                                                          "0xB800B06C"
#define MD_KMQBASE_reg                                                               0xB800B06C
#define set_MD_KMQBASE_reg(data)   (*((volatile unsigned int*) MD_KMQBASE_reg)=data)
#define get_MD_KMQBASE_reg   (*((volatile unsigned int*) MD_KMQBASE_reg))
#define MD_KMQBASE_inst_adr                                                          "0x001B"
#define MD_KMQBASE_inst                                                              0x001B
#define MD_KMQBASE_kmq_base_shift                                                    (4)
#define MD_KMQBASE_kmq_base_mask                                                     (0x7FFFFFF0)
#define MD_KMQBASE_kmq_base(data)                                                    (0x7FFFFFF0&((data)<<4))
#define MD_KMQBASE_kmq_base_src(data)                                                ((0x7FFFFFF0&(data))>>4)
#define MD_KMQBASE_get_kmq_base(data)                                                ((0x7FFFFFF0&(data))>>4)


#define MD_KMQLIMIT                                                                  0x1800B070
#define MD_KMQLIMIT_reg_addr                                                         "0xB800B070"
#define MD_KMQLIMIT_reg                                                              0xB800B070
#define set_MD_KMQLIMIT_reg(data)   (*((volatile unsigned int*) MD_KMQLIMIT_reg)=data)
#define get_MD_KMQLIMIT_reg   (*((volatile unsigned int*) MD_KMQLIMIT_reg))
#define MD_KMQLIMIT_inst_adr                                                         "0x001C"
#define MD_KMQLIMIT_inst                                                             0x001C
#define MD_KMQLIMIT_kmq_limit_shift                                                  (4)
#define MD_KMQLIMIT_kmq_limit_mask                                                   (0x7FFFFFF0)
#define MD_KMQLIMIT_kmq_limit(data)                                                  (0x7FFFFFF0&((data)<<4))
#define MD_KMQLIMIT_kmq_limit_src(data)                                              ((0x7FFFFFF0&(data))>>4)
#define MD_KMQLIMIT_get_kmq_limit(data)                                              ((0x7FFFFFF0&(data))>>4)


#define MD_KMQRDPTR                                                                  0x1800B074
#define MD_KMQRDPTR_reg_addr                                                         "0xB800B074"
#define MD_KMQRDPTR_reg                                                              0xB800B074
#define set_MD_KMQRDPTR_reg(data)   (*((volatile unsigned int*) MD_KMQRDPTR_reg)=data)
#define get_MD_KMQRDPTR_reg   (*((volatile unsigned int*) MD_KMQRDPTR_reg))
#define MD_KMQRDPTR_inst_adr                                                         "0x001D"
#define MD_KMQRDPTR_inst                                                             0x001D
#define MD_KMQRDPTR_kmq_rdptr_shift                                                  (4)
#define MD_KMQRDPTR_kmq_rdptr_mask                                                   (0x7FFFFFF0)
#define MD_KMQRDPTR_kmq_rdptr(data)                                                  (0x7FFFFFF0&((data)<<4))
#define MD_KMQRDPTR_kmq_rdptr_src(data)                                              ((0x7FFFFFF0&(data))>>4)
#define MD_KMQRDPTR_get_kmq_rdptr(data)                                              ((0x7FFFFFF0&(data))>>4)


#define MD_KMQWRPTR                                                                  0x1800B078
#define MD_KMQWRPTR_reg_addr                                                         "0xB800B078"
#define MD_KMQWRPTR_reg                                                              0xB800B078
#define set_MD_KMQWRPTR_reg(data)   (*((volatile unsigned int*) MD_KMQWRPTR_reg)=data)
#define get_MD_KMQWRPTR_reg   (*((volatile unsigned int*) MD_KMQWRPTR_reg))
#define MD_KMQWRPTR_inst_adr                                                         "0x001E"
#define MD_KMQWRPTR_inst                                                             0x001E
#define MD_KMQWRPTR_kmq_wrptr_shift                                                  (4)
#define MD_KMQWRPTR_kmq_wrptr_mask                                                   (0x7FFFFFF0)
#define MD_KMQWRPTR_kmq_wrptr(data)                                                  (0x7FFFFFF0&((data)<<4))
#define MD_KMQWRPTR_kmq_wrptr_src(data)                                              ((0x7FFFFFF0&(data))>>4)
#define MD_KMQWRPTR_get_kmq_wrptr(data)                                              ((0x7FFFFFF0&(data))>>4)


#define MD_KMQFIFOSTATE                                                              0x1800B07C
#define MD_KMQFIFOSTATE_reg_addr                                                     "0xB800B07C"
#define MD_KMQFIFOSTATE_reg                                                          0xB800B07C
#define set_MD_KMQFIFOSTATE_reg(data)   (*((volatile unsigned int*) MD_KMQFIFOSTATE_reg)=data)
#define get_MD_KMQFIFOSTATE_reg   (*((volatile unsigned int*) MD_KMQFIFOSTATE_reg))
#define MD_KMQFIFOSTATE_inst_adr                                                     "0x001F"
#define MD_KMQFIFOSTATE_inst                                                         0x001F
#define MD_KMQFIFOSTATE_kmq_inst_remain_shift                                        (0)
#define MD_KMQFIFOSTATE_kmq_inst_remain_mask                                         (0x0000001F)
#define MD_KMQFIFOSTATE_kmq_inst_remain(data)                                        (0x0000001F&((data)<<0))
#define MD_KMQFIFOSTATE_kmq_inst_remain_src(data)                                    ((0x0000001F&(data))>>0)
#define MD_KMQFIFOSTATE_get_kmq_inst_remain(data)                                    ((0x0000001F&(data))>>0)


#define MD_KMQ_INSTCNT                                                               0x1800B080
#define MD_KMQ_INSTCNT_reg_addr                                                      "0xB800B080"
#define MD_KMQ_INSTCNT_reg                                                           0xB800B080
#define set_MD_KMQ_INSTCNT_reg(data)   (*((volatile unsigned int*) MD_KMQ_INSTCNT_reg)=data)
#define get_MD_KMQ_INSTCNT_reg   (*((volatile unsigned int*) MD_KMQ_INSTCNT_reg))
#define MD_KMQ_INSTCNT_inst_adr                                                      "0x0020"
#define MD_KMQ_INSTCNT_inst                                                          0x0020
#define MD_KMQ_INSTCNT_kmq_inst_cnt_shift                                            (0)
#define MD_KMQ_INSTCNT_kmq_inst_cnt_mask                                             (0x0000FFFF)
#define MD_KMQ_INSTCNT_kmq_inst_cnt(data)                                            (0x0000FFFF&((data)<<0))
#define MD_KMQ_INSTCNT_kmq_inst_cnt_src(data)                                        ((0x0000FFFF&(data))>>0)
#define MD_KMQ_INSTCNT_get_kmq_inst_cnt(data)                                        ((0x0000FFFF&(data))>>0)


#define MD_DBG                                                                       0x1800B0D0
#define MD_DBG_reg_addr                                                              "0xB800B0D0"
#define MD_DBG_reg                                                                   0xB800B0D0
#define set_MD_DBG_reg(data)   (*((volatile unsigned int*) MD_DBG_reg)=data)
#define get_MD_DBG_reg   (*((volatile unsigned int*) MD_DBG_reg))
#define MD_DBG_inst_adr                                                              "0x0034"
#define MD_DBG_inst                                                                  0x0034
#define MD_DBG_md_dbg_sel1_shift                                                     (8)
#define MD_DBG_md_dbg_sel1_mask                                                      (0x00007F00)
#define MD_DBG_md_dbg_sel1(data)                                                     (0x00007F00&((data)<<8))
#define MD_DBG_md_dbg_sel1_src(data)                                                 ((0x00007F00&(data))>>8)
#define MD_DBG_get_md_dbg_sel1(data)                                                 ((0x00007F00&(data))>>8)
#define MD_DBG_md_dbg_sel0_shift                                                     (1)
#define MD_DBG_md_dbg_sel0_mask                                                      (0x000000FE)
#define MD_DBG_md_dbg_sel0(data)                                                     (0x000000FE&((data)<<1))
#define MD_DBG_md_dbg_sel0_src(data)                                                 ((0x000000FE&(data))>>1)
#define MD_DBG_get_md_dbg_sel0(data)                                                 ((0x000000FE&(data))>>1)
#define MD_DBG_md_dbg_enable_shift                                                   (0)
#define MD_DBG_md_dbg_enable_mask                                                    (0x00000001)
#define MD_DBG_md_dbg_enable(data)                                                   (0x00000001&((data)<<0))
#define MD_DBG_md_dbg_enable_src(data)                                               ((0x00000001&(data))>>0)
#define MD_DBG_get_md_dbg_enable(data)                                               ((0x00000001&(data))>>0)


#define MD_FDMA_DDR_SADDR                                                            0x1800B088
#define MD_FDMA_DDR_SADDR_reg_addr                                                   "0xB800B088"
#define MD_FDMA_DDR_SADDR_reg                                                        0xB800B088
#define set_MD_FDMA_DDR_SADDR_reg(data)   (*((volatile unsigned int*) MD_FDMA_DDR_SADDR_reg)=data)
#define get_MD_FDMA_DDR_SADDR_reg   (*((volatile unsigned int*) MD_FDMA_DDR_SADDR_reg))
#define MD_FDMA_DDR_SADDR_inst_adr                                                   "0x0022"
#define MD_FDMA_DDR_SADDR_inst                                                       0x0022
#define MD_FDMA_DDR_SADDR_fdma_ddr_saddr_shift                                       (0)
#define MD_FDMA_DDR_SADDR_fdma_ddr_saddr_mask                                        (0x7FFFFFFF)
#define MD_FDMA_DDR_SADDR_fdma_ddr_saddr(data)                                       (0x7FFFFFFF&((data)<<0))
#define MD_FDMA_DDR_SADDR_fdma_ddr_saddr_src(data)                                   ((0x7FFFFFFF&(data))>>0)
#define MD_FDMA_DDR_SADDR_get_fdma_ddr_saddr(data)                                   ((0x7FFFFFFF&(data))>>0)


#define MD_FDMA_FL_SADDR                                                             0x1800B08c
#define MD_FDMA_FL_SADDR_reg_addr                                                    "0xB800B08C"
#define MD_FDMA_FL_SADDR_reg                                                         0xB800B08C
#define set_MD_FDMA_FL_SADDR_reg(data)   (*((volatile unsigned int*) MD_FDMA_FL_SADDR_reg)=data)
#define get_MD_FDMA_FL_SADDR_reg   (*((volatile unsigned int*) MD_FDMA_FL_SADDR_reg))
#define MD_FDMA_FL_SADDR_inst_adr                                                    "0x0023"
#define MD_FDMA_FL_SADDR_inst                                                        0x0023
#define MD_FDMA_FL_SADDR_fdma_fl_saddr_shift                                         (0)
#define MD_FDMA_FL_SADDR_fdma_fl_saddr_mask                                          (0x01FFFFFF)
#define MD_FDMA_FL_SADDR_fdma_fl_saddr(data)                                         (0x01FFFFFF&((data)<<0))
#define MD_FDMA_FL_SADDR_fdma_fl_saddr_src(data)                                     ((0x01FFFFFF&(data))>>0)
#define MD_FDMA_FL_SADDR_get_fdma_fl_saddr(data)                                     ((0x01FFFFFF&(data))>>0)


#define MD_FDMA_CTRL2                                                                0x1800B090
#define MD_FDMA_CTRL2_reg_addr                                                       "0xB800B090"
#define MD_FDMA_CTRL2_reg                                                            0xB800B090
#define set_MD_FDMA_CTRL2_reg(data)   (*((volatile unsigned int*) MD_FDMA_CTRL2_reg)=data)
#define get_MD_FDMA_CTRL2_reg   (*((volatile unsigned int*) MD_FDMA_CTRL2_reg))
#define MD_FDMA_CTRL2_inst_adr                                                       "0x0024"
#define MD_FDMA_CTRL2_inst                                                           0x0024
#define MD_FDMA_CTRL2_fl_cp_en_shift                                                 (30)
#define MD_FDMA_CTRL2_fl_cp_en_mask                                                  (0x40000000)
#define MD_FDMA_CTRL2_fl_cp_en(data)                                                 (0x40000000&((data)<<30))
#define MD_FDMA_CTRL2_fl_cp_en_src(data)                                             ((0x40000000&(data))>>30)
#define MD_FDMA_CTRL2_get_fl_cp_en(data)                                             ((0x40000000&(data))>>30)
#define MD_FDMA_CTRL2_fl_mapping_mode_shift                                          (29)
#define MD_FDMA_CTRL2_fl_mapping_mode_mask                                           (0x20000000)
#define MD_FDMA_CTRL2_fl_mapping_mode(data)                                          (0x20000000&((data)<<29))
#define MD_FDMA_CTRL2_fl_mapping_mode_src(data)                                      ((0x20000000&(data))>>29)
#define MD_FDMA_CTRL2_get_fl_mapping_mode(data)                                      ((0x20000000&(data))>>29)
#define MD_FDMA_CTRL2_fdma_swap_shift                                                (28)
#define MD_FDMA_CTRL2_fdma_swap_mask                                                 (0x10000000)
#define MD_FDMA_CTRL2_fdma_swap(data)                                                (0x10000000&((data)<<28))
#define MD_FDMA_CTRL2_fdma_swap_src(data)                                            ((0x10000000&(data))>>28)
#define MD_FDMA_CTRL2_get_fdma_swap(data)                                            ((0x10000000&(data))>>28)
#define MD_FDMA_CTRL2_fdma_max_xfer_shift                                            (26)
#define MD_FDMA_CTRL2_fdma_max_xfer_mask                                             (0x0C000000)
#define MD_FDMA_CTRL2_fdma_max_xfer(data)                                            (0x0C000000&((data)<<26))
#define MD_FDMA_CTRL2_fdma_max_xfer_src(data)                                        ((0x0C000000&(data))>>26)
#define MD_FDMA_CTRL2_get_fdma_max_xfer(data)                                        ((0x0C000000&(data))>>26)
#define MD_FDMA_CTRL2_fdma_dir_shift                                                 (25)
#define MD_FDMA_CTRL2_fdma_dir_mask                                                  (0x02000000)
#define MD_FDMA_CTRL2_fdma_dir(data)                                                 (0x02000000&((data)<<25))
#define MD_FDMA_CTRL2_fdma_dir_src(data)                                             ((0x02000000&(data))>>25)
#define MD_FDMA_CTRL2_get_fdma_dir(data)                                             ((0x02000000&(data))>>25)
#define MD_FDMA_CTRL2_fdma_length_shift                                              (0)
#define MD_FDMA_CTRL2_fdma_length_mask                                               (0x01FFFFFF)
#define MD_FDMA_CTRL2_fdma_length(data)                                              (0x01FFFFFF&((data)<<0))
#define MD_FDMA_CTRL2_fdma_length_src(data)                                          ((0x01FFFFFF&(data))>>0)
#define MD_FDMA_CTRL2_get_fdma_length(data)                                          ((0x01FFFFFF&(data))>>0)


#define MD_FDMA_CTRL1                                                                0x1800B094
#define MD_FDMA_CTRL1_reg_addr                                                       "0xB800B094"
#define MD_FDMA_CTRL1_reg                                                            0xB800B094
#define set_MD_FDMA_CTRL1_reg(data)   (*((volatile unsigned int*) MD_FDMA_CTRL1_reg)=data)
#define get_MD_FDMA_CTRL1_reg   (*((volatile unsigned int*) MD_FDMA_CTRL1_reg))
#define MD_FDMA_CTRL1_inst_adr                                                       "0x0025"
#define MD_FDMA_CTRL1_inst                                                           0x0025
#define MD_FDMA_CTRL1_write_en2_shift                                                (3)
#define MD_FDMA_CTRL1_write_en2_mask                                                 (0x00000008)
#define MD_FDMA_CTRL1_write_en2(data)                                                (0x00000008&((data)<<3))
#define MD_FDMA_CTRL1_write_en2_src(data)                                            ((0x00000008&(data))>>3)
#define MD_FDMA_CTRL1_get_write_en2(data)                                            ((0x00000008&(data))>>3)
#define MD_FDMA_CTRL1_fdma_stop_shift                                                (2)
#define MD_FDMA_CTRL1_fdma_stop_mask                                                 (0x00000004)
#define MD_FDMA_CTRL1_fdma_stop(data)                                                (0x00000004&((data)<<2))
#define MD_FDMA_CTRL1_fdma_stop_src(data)                                            ((0x00000004&(data))>>2)
#define MD_FDMA_CTRL1_get_fdma_stop(data)                                            ((0x00000004&(data))>>2)
#define MD_FDMA_CTRL1_write_en1_shift                                                (1)
#define MD_FDMA_CTRL1_write_en1_mask                                                 (0x00000002)
#define MD_FDMA_CTRL1_write_en1(data)                                                (0x00000002&((data)<<1))
#define MD_FDMA_CTRL1_write_en1_src(data)                                            ((0x00000002&(data))>>1)
#define MD_FDMA_CTRL1_get_write_en1(data)                                            ((0x00000002&(data))>>1)
#define MD_FDMA_CTRL1_fdma_go_shift                                                  (0)
#define MD_FDMA_CTRL1_fdma_go_mask                                                   (0x00000001)
#define MD_FDMA_CTRL1_fdma_go(data)                                                  (0x00000001&((data)<<0))
#define MD_FDMA_CTRL1_fdma_go_src(data)                                              ((0x00000001&(data))>>0)
#define MD_FDMA_CTRL1_get_fdma_go(data)                                              ((0x00000001&(data))>>0)


#define MD_FDMA_DDR_SADDR_K                                                          0x1800B190
#define MD_FDMA_DDR_SADDR_K_reg_addr                                                 "0xB800B190"
#define MD_FDMA_DDR_SADDR_K_reg                                                      0xB800B190
#define set_MD_FDMA_DDR_SADDR_K_reg(data)   (*((volatile unsigned int*) MD_FDMA_DDR_SADDR_K_reg)=data)
#define get_MD_FDMA_DDR_SADDR_K_reg   (*((volatile unsigned int*) MD_FDMA_DDR_SADDR_K_reg))
#define MD_FDMA_DDR_SADDR_K_inst_adr                                                 "0x0064"
#define MD_FDMA_DDR_SADDR_K_inst                                                     0x0064
#define MD_FDMA_DDR_SADDR_K_fdma_ddr_saddr_k_shift                                   (0)
#define MD_FDMA_DDR_SADDR_K_fdma_ddr_saddr_k_mask                                    (0x7FFFFFFF)
#define MD_FDMA_DDR_SADDR_K_fdma_ddr_saddr_k(data)                                   (0x7FFFFFFF&((data)<<0))
#define MD_FDMA_DDR_SADDR_K_fdma_ddr_saddr_k_src(data)                               ((0x7FFFFFFF&(data))>>0)
#define MD_FDMA_DDR_SADDR_K_get_fdma_ddr_saddr_k(data)                               ((0x7FFFFFFF&(data))>>0)


#define MD_FDMA_FL_SADDR_K                                                           0x1800B194
#define MD_FDMA_FL_SADDR_K_reg_addr                                                  "0xB800B194"
#define MD_FDMA_FL_SADDR_K_reg                                                       0xB800B194
#define set_MD_FDMA_FL_SADDR_K_reg(data)   (*((volatile unsigned int*) MD_FDMA_FL_SADDR_K_reg)=data)
#define get_MD_FDMA_FL_SADDR_K_reg   (*((volatile unsigned int*) MD_FDMA_FL_SADDR_K_reg))
#define MD_FDMA_FL_SADDR_K_inst_adr                                                  "0x0065"
#define MD_FDMA_FL_SADDR_K_inst                                                      0x0065
#define MD_FDMA_FL_SADDR_K_fdma_fl_saddr_k_shift                                     (0)
#define MD_FDMA_FL_SADDR_K_fdma_fl_saddr_k_mask                                      (0x01FFFFFF)
#define MD_FDMA_FL_SADDR_K_fdma_fl_saddr_k(data)                                     (0x01FFFFFF&((data)<<0))
#define MD_FDMA_FL_SADDR_K_fdma_fl_saddr_k_src(data)                                 ((0x01FFFFFF&(data))>>0)
#define MD_FDMA_FL_SADDR_K_get_fdma_fl_saddr_k(data)                                 ((0x01FFFFFF&(data))>>0)


#define MD_FDMA_CTRL2_K                                                              0x1800B198
#define MD_FDMA_CTRL2_K_reg_addr                                                     "0xB800B198"
#define MD_FDMA_CTRL2_K_reg                                                          0xB800B198
#define set_MD_FDMA_CTRL2_K_reg(data)   (*((volatile unsigned int*) MD_FDMA_CTRL2_K_reg)=data)
#define get_MD_FDMA_CTRL2_K_reg   (*((volatile unsigned int*) MD_FDMA_CTRL2_K_reg))
#define MD_FDMA_CTRL2_K_inst_adr                                                     "0x0066"
#define MD_FDMA_CTRL2_K_inst                                                         0x0066
#define MD_FDMA_CTRL2_K_Disable_md_block_mode_shift                                  (31)
#define MD_FDMA_CTRL2_K_Disable_md_block_mode_mask                                   (0x80000000)
#define MD_FDMA_CTRL2_K_Disable_md_block_mode(data)                                  (0x80000000&((data)<<31))
#define MD_FDMA_CTRL2_K_Disable_md_block_mode_src(data)                              ((0x80000000&(data))>>31)
#define MD_FDMA_CTRL2_K_get_Disable_md_block_mode(data)                              ((0x80000000&(data))>>31)
#define MD_FDMA_CTRL2_K_fl_cp_en_k_shift                                             (30)
#define MD_FDMA_CTRL2_K_fl_cp_en_k_mask                                              (0x40000000)
#define MD_FDMA_CTRL2_K_fl_cp_en_k(data)                                             (0x40000000&((data)<<30))
#define MD_FDMA_CTRL2_K_fl_cp_en_k_src(data)                                         ((0x40000000&(data))>>30)
#define MD_FDMA_CTRL2_K_get_fl_cp_en_k(data)                                         ((0x40000000&(data))>>30)
#define MD_FDMA_CTRL2_K_fl_mapping_mode_k_shift                                      (29)
#define MD_FDMA_CTRL2_K_fl_mapping_mode_k_mask                                       (0x20000000)
#define MD_FDMA_CTRL2_K_fl_mapping_mode_k(data)                                      (0x20000000&((data)<<29))
#define MD_FDMA_CTRL2_K_fl_mapping_mode_k_src(data)                                  ((0x20000000&(data))>>29)
#define MD_FDMA_CTRL2_K_get_fl_mapping_mode_k(data)                                  ((0x20000000&(data))>>29)
#define MD_FDMA_CTRL2_K_fdma_swap_k_shift                                            (28)
#define MD_FDMA_CTRL2_K_fdma_swap_k_mask                                             (0x10000000)
#define MD_FDMA_CTRL2_K_fdma_swap_k(data)                                            (0x10000000&((data)<<28))
#define MD_FDMA_CTRL2_K_fdma_swap_k_src(data)                                        ((0x10000000&(data))>>28)
#define MD_FDMA_CTRL2_K_get_fdma_swap_k(data)                                        ((0x10000000&(data))>>28)
#define MD_FDMA_CTRL2_K_fdma_max_xfer_k_shift                                        (26)
#define MD_FDMA_CTRL2_K_fdma_max_xfer_k_mask                                         (0x0C000000)
#define MD_FDMA_CTRL2_K_fdma_max_xfer_k(data)                                        (0x0C000000&((data)<<26))
#define MD_FDMA_CTRL2_K_fdma_max_xfer_k_src(data)                                    ((0x0C000000&(data))>>26)
#define MD_FDMA_CTRL2_K_get_fdma_max_xfer_k(data)                                    ((0x0C000000&(data))>>26)
#define MD_FDMA_CTRL2_K_fdma_dir_k_shift                                             (25)
#define MD_FDMA_CTRL2_K_fdma_dir_k_mask                                              (0x02000000)
#define MD_FDMA_CTRL2_K_fdma_dir_k(data)                                             (0x02000000&((data)<<25))
#define MD_FDMA_CTRL2_K_fdma_dir_k_src(data)                                         ((0x02000000&(data))>>25)
#define MD_FDMA_CTRL2_K_get_fdma_dir_k(data)                                         ((0x02000000&(data))>>25)
#define MD_FDMA_CTRL2_K_fdma_length_k_shift                                          (0)
#define MD_FDMA_CTRL2_K_fdma_length_k_mask                                           (0x01FFFFFF)
#define MD_FDMA_CTRL2_K_fdma_length_k(data)                                          (0x01FFFFFF&((data)<<0))
#define MD_FDMA_CTRL2_K_fdma_length_k_src(data)                                      ((0x01FFFFFF&(data))>>0)
#define MD_FDMA_CTRL2_K_get_fdma_length_k(data)                                      ((0x01FFFFFF&(data))>>0)


#define MD_FDMA_CTRL1_K                                                              0x1800B19C
#define MD_FDMA_CTRL1_K_reg_addr                                                     "0xB800B19C"
#define MD_FDMA_CTRL1_K_reg                                                          0xB800B19C
#define set_MD_FDMA_CTRL1_K_reg(data)   (*((volatile unsigned int*) MD_FDMA_CTRL1_K_reg)=data)
#define get_MD_FDMA_CTRL1_K_reg   (*((volatile unsigned int*) MD_FDMA_CTRL1_K_reg))
#define MD_FDMA_CTRL1_K_inst_adr                                                     "0x0067"
#define MD_FDMA_CTRL1_K_inst                                                         0x0067
#define MD_FDMA_CTRL1_K_write_en2_k_shift                                            (3)
#define MD_FDMA_CTRL1_K_write_en2_k_mask                                             (0x00000008)
#define MD_FDMA_CTRL1_K_write_en2_k(data)                                            (0x00000008&((data)<<3))
#define MD_FDMA_CTRL1_K_write_en2_k_src(data)                                        ((0x00000008&(data))>>3)
#define MD_FDMA_CTRL1_K_get_write_en2_k(data)                                        ((0x00000008&(data))>>3)
#define MD_FDMA_CTRL1_K_fdma_stop_k_shift                                            (2)
#define MD_FDMA_CTRL1_K_fdma_stop_k_mask                                             (0x00000004)
#define MD_FDMA_CTRL1_K_fdma_stop_k(data)                                            (0x00000004&((data)<<2))
#define MD_FDMA_CTRL1_K_fdma_stop_k_src(data)                                        ((0x00000004&(data))>>2)
#define MD_FDMA_CTRL1_K_get_fdma_stop_k(data)                                        ((0x00000004&(data))>>2)
#define MD_FDMA_CTRL1_K_write_en1_k_shift                                            (1)
#define MD_FDMA_CTRL1_K_write_en1_k_mask                                             (0x00000002)
#define MD_FDMA_CTRL1_K_write_en1_k(data)                                            (0x00000002&((data)<<1))
#define MD_FDMA_CTRL1_K_write_en1_k_src(data)                                        ((0x00000002&(data))>>1)
#define MD_FDMA_CTRL1_K_get_write_en1_k(data)                                        ((0x00000002&(data))>>1)
#define MD_FDMA_CTRL1_K_fdma_go_k_shift                                              (0)
#define MD_FDMA_CTRL1_K_fdma_go_k_mask                                               (0x00000001)
#define MD_FDMA_CTRL1_K_fdma_go_k(data)                                              (0x00000001&((data)<<0))
#define MD_FDMA_CTRL1_K_fdma_go_k_src(data)                                          ((0x00000001&(data))>>0)
#define MD_FDMA_CTRL1_K_get_fdma_go_k(data)                                          ((0x00000001&(data))>>0)


#define MD_POWER                                                                     0x1800B128
#define MD_POWER_reg_addr                                                            "0xB800B128"
#define MD_POWER_reg                                                                 0xB800B128
#define set_MD_POWER_reg(data)   (*((volatile unsigned int*) MD_POWER_reg)=data)
#define get_MD_POWER_reg   (*((volatile unsigned int*) MD_POWER_reg))
#define MD_POWER_inst_adr                                                            "0x004A"
#define MD_POWER_inst                                                                0x004A
#define MD_POWER_gating_en_shift                                                     (0)
#define MD_POWER_gating_en_mask                                                      (0x00000001)
#define MD_POWER_gating_en(data)                                                     (0x00000001&((data)<<0))
#define MD_POWER_gating_en_src(data)                                                 ((0x00000001&(data))>>0)
#define MD_POWER_get_gating_en(data)                                                 ((0x00000001&(data))>>0)


#define MD_DUMMY1                                                                    0x1800B09C
#define MD_DUMMY1_reg_addr                                                           "0xB800B09C"
#define MD_DUMMY1_reg                                                                0xB800B09C
#define set_MD_DUMMY1_reg(data)   (*((volatile unsigned int*) MD_DUMMY1_reg)=data)
#define get_MD_DUMMY1_reg   (*((volatile unsigned int*) MD_DUMMY1_reg))
#define MD_DUMMY1_inst_adr                                                           "0x0027"
#define MD_DUMMY1_inst                                                               0x0027
#define MD_DUMMY1_dummy1_shift                                                       (0)
#define MD_DUMMY1_dummy1_mask                                                        (0xFFFFFFFF)
#define MD_DUMMY1_dummy1(data)                                                       (0xFFFFFFFF&((data)<<0))
#define MD_DUMMY1_dummy1_src(data)                                                   ((0xFFFFFFFF&(data))>>0)
#define MD_DUMMY1_get_dummy1(data)                                                   ((0xFFFFFFFF&(data))>>0)


#define MD_DUMMY2                                                                    0x1800B0A0
#define MD_DUMMY2_reg_addr                                                           "0xB800B0A0"
#define MD_DUMMY2_reg                                                                0xB800B0A0
#define set_MD_DUMMY2_reg(data)   (*((volatile unsigned int*) MD_DUMMY2_reg)=data)
#define get_MD_DUMMY2_reg   (*((volatile unsigned int*) MD_DUMMY2_reg))
#define MD_DUMMY2_inst_adr                                                           "0x0028"
#define MD_DUMMY2_inst                                                               0x0028
#define MD_DUMMY2_dummy2_shift                                                       (0)
#define MD_DUMMY2_dummy2_mask                                                        (0xFFFFFFFF)
#define MD_DUMMY2_dummy2(data)                                                       (0xFFFFFFFF&((data)<<0))
#define MD_DUMMY2_dummy2_src(data)                                                   ((0xFFFFFFFF&(data))>>0)
#define MD_DUMMY2_get_dummy2(data)                                                   ((0xFFFFFFFF&(data))>>0)


#define MD_BIST_MODE                                                                 0x1800B200
#define MD_BIST_MODE_reg_addr                                                        "0xB800B200"
#define MD_BIST_MODE_reg                                                             0xB800B200
#define set_MD_BIST_MODE_reg(data)   (*((volatile unsigned int*) MD_BIST_MODE_reg)=data)
#define get_MD_BIST_MODE_reg   (*((volatile unsigned int*) MD_BIST_MODE_reg))
#define MD_BIST_MODE_inst_adr                                                        "0x0080"
#define MD_BIST_MODE_inst                                                            0x0080
#define MD_BIST_MODE_md_BIST_MODE_A_shift                                            (0)
#define MD_BIST_MODE_md_BIST_MODE_A_mask                                             (0x00000001)
#define MD_BIST_MODE_md_BIST_MODE_A(data)                                            (0x00000001&((data)<<0))
#define MD_BIST_MODE_md_BIST_MODE_A_src(data)                                        ((0x00000001&(data))>>0)
#define MD_BIST_MODE_get_md_BIST_MODE_A(data)                                        ((0x00000001&(data))>>0)


#define MD_BIST_DONE                                                                 0x1800B204
#define MD_BIST_DONE_reg_addr                                                        "0xB800B204"
#define MD_BIST_DONE_reg                                                             0xB800B204
#define set_MD_BIST_DONE_reg(data)   (*((volatile unsigned int*) MD_BIST_DONE_reg)=data)
#define get_MD_BIST_DONE_reg   (*((volatile unsigned int*) MD_BIST_DONE_reg))
#define MD_BIST_DONE_inst_adr                                                        "0x0081"
#define MD_BIST_DONE_inst                                                            0x0081
#define MD_BIST_DONE_md_BIST_DONE_A_shift                                            (0)
#define MD_BIST_DONE_md_BIST_DONE_A_mask                                             (0x00000001)
#define MD_BIST_DONE_md_BIST_DONE_A(data)                                            (0x00000001&((data)<<0))
#define MD_BIST_DONE_md_BIST_DONE_A_src(data)                                        ((0x00000001&(data))>>0)
#define MD_BIST_DONE_get_md_BIST_DONE_A(data)                                        ((0x00000001&(data))>>0)


#define MD_BIST_FAIL_GROUP                                                           0x1800B208
#define MD_BIST_FAIL_GROUP_reg_addr                                                  "0xB800B208"
#define MD_BIST_FAIL_GROUP_reg                                                       0xB800B208
#define set_MD_BIST_FAIL_GROUP_reg(data)   (*((volatile unsigned int*) MD_BIST_FAIL_GROUP_reg)=data)
#define get_MD_BIST_FAIL_GROUP_reg   (*((volatile unsigned int*) MD_BIST_FAIL_GROUP_reg))
#define MD_BIST_FAIL_GROUP_inst_adr                                                  "0x0082"
#define MD_BIST_FAIL_GROUP_inst                                                      0x0082
#define MD_BIST_FAIL_GROUP_md_BIST_FAIL_GROUP_A_shift                                (0)
#define MD_BIST_FAIL_GROUP_md_BIST_FAIL_GROUP_A_mask                                 (0x00000001)
#define MD_BIST_FAIL_GROUP_md_BIST_FAIL_GROUP_A(data)                                (0x00000001&((data)<<0))
#define MD_BIST_FAIL_GROUP_md_BIST_FAIL_GROUP_A_src(data)                            ((0x00000001&(data))>>0)
#define MD_BIST_FAIL_GROUP_get_md_BIST_FAIL_GROUP_A(data)                            ((0x00000001&(data))>>0)


#define MD_BIST_A_FAIL                                                               0x1800B20C
#define MD_BIST_A_FAIL_reg_addr                                                      "0xB800B20C"
#define MD_BIST_A_FAIL_reg                                                           0xB800B20C
#define set_MD_BIST_A_FAIL_reg(data)   (*((volatile unsigned int*) MD_BIST_A_FAIL_reg)=data)
#define get_MD_BIST_A_FAIL_reg   (*((volatile unsigned int*) MD_BIST_A_FAIL_reg))
#define MD_BIST_A_FAIL_inst_adr                                                      "0x0083"
#define MD_BIST_A_FAIL_inst                                                          0x0083
#define MD_BIST_A_FAIL_md_BIST_A_FAIL_2_shift                                        (2)
#define MD_BIST_A_FAIL_md_BIST_A_FAIL_2_mask                                         (0x00000004)
#define MD_BIST_A_FAIL_md_BIST_A_FAIL_2(data)                                        (0x00000004&((data)<<2))
#define MD_BIST_A_FAIL_md_BIST_A_FAIL_2_src(data)                                    ((0x00000004&(data))>>2)
#define MD_BIST_A_FAIL_get_md_BIST_A_FAIL_2(data)                                    ((0x00000004&(data))>>2)
#define MD_BIST_A_FAIL_md_BIST_A_FAIL_1_shift                                        (1)
#define MD_BIST_A_FAIL_md_BIST_A_FAIL_1_mask                                         (0x00000002)
#define MD_BIST_A_FAIL_md_BIST_A_FAIL_1(data)                                        (0x00000002&((data)<<1))
#define MD_BIST_A_FAIL_md_BIST_A_FAIL_1_src(data)                                    ((0x00000002&(data))>>1)
#define MD_BIST_A_FAIL_get_md_BIST_A_FAIL_1(data)                                    ((0x00000002&(data))>>1)
#define MD_BIST_A_FAIL_md_BIST_A_FAIL_0_shift                                        (0)
#define MD_BIST_A_FAIL_md_BIST_A_FAIL_0_mask                                         (0x00000001)
#define MD_BIST_A_FAIL_md_BIST_A_FAIL_0(data)                                        (0x00000001&((data)<<0))
#define MD_BIST_A_FAIL_md_BIST_A_FAIL_0_src(data)                                    ((0x00000001&(data))>>0)
#define MD_BIST_A_FAIL_get_md_BIST_A_FAIL_0(data)                                    ((0x00000001&(data))>>0)


#define MD_DRF_MODE                                                                  0x1800B210
#define MD_DRF_MODE_reg_addr                                                         "0xB800B210"
#define MD_DRF_MODE_reg                                                              0xB800B210
#define set_MD_DRF_MODE_reg(data)   (*((volatile unsigned int*) MD_DRF_MODE_reg)=data)
#define get_MD_DRF_MODE_reg   (*((volatile unsigned int*) MD_DRF_MODE_reg))
#define MD_DRF_MODE_inst_adr                                                         "0x0084"
#define MD_DRF_MODE_inst                                                             0x0084
#define MD_DRF_MODE_md_DRF_MODE_A_shift                                              (0)
#define MD_DRF_MODE_md_DRF_MODE_A_mask                                               (0x00000001)
#define MD_DRF_MODE_md_DRF_MODE_A(data)                                              (0x00000001&((data)<<0))
#define MD_DRF_MODE_md_DRF_MODE_A_src(data)                                          ((0x00000001&(data))>>0)
#define MD_DRF_MODE_get_md_DRF_MODE_A(data)                                          ((0x00000001&(data))>>0)


#define MD_DRF_RESUME                                                                0x1800B214
#define MD_DRF_RESUME_reg_addr                                                       "0xB800B214"
#define MD_DRF_RESUME_reg                                                            0xB800B214
#define set_MD_DRF_RESUME_reg(data)   (*((volatile unsigned int*) MD_DRF_RESUME_reg)=data)
#define get_MD_DRF_RESUME_reg   (*((volatile unsigned int*) MD_DRF_RESUME_reg))
#define MD_DRF_RESUME_inst_adr                                                       "0x0085"
#define MD_DRF_RESUME_inst                                                           0x0085
#define MD_DRF_RESUME_md_DRF_RESUME_A_shift                                          (0)
#define MD_DRF_RESUME_md_DRF_RESUME_A_mask                                           (0x00000001)
#define MD_DRF_RESUME_md_DRF_RESUME_A(data)                                          (0x00000001&((data)<<0))
#define MD_DRF_RESUME_md_DRF_RESUME_A_src(data)                                      ((0x00000001&(data))>>0)
#define MD_DRF_RESUME_get_md_DRF_RESUME_A(data)                                      ((0x00000001&(data))>>0)


#define MD_DRF_DONE                                                                  0x1800B218
#define MD_DRF_DONE_reg_addr                                                         "0xB800B218"
#define MD_DRF_DONE_reg                                                              0xB800B218
#define set_MD_DRF_DONE_reg(data)   (*((volatile unsigned int*) MD_DRF_DONE_reg)=data)
#define get_MD_DRF_DONE_reg   (*((volatile unsigned int*) MD_DRF_DONE_reg))
#define MD_DRF_DONE_inst_adr                                                         "0x0086"
#define MD_DRF_DONE_inst                                                             0x0086
#define MD_DRF_DONE_md_DRF_DONE_A_shift                                              (0)
#define MD_DRF_DONE_md_DRF_DONE_A_mask                                               (0x00000001)
#define MD_DRF_DONE_md_DRF_DONE_A(data)                                              (0x00000001&((data)<<0))
#define MD_DRF_DONE_md_DRF_DONE_A_src(data)                                          ((0x00000001&(data))>>0)
#define MD_DRF_DONE_get_md_DRF_DONE_A(data)                                          ((0x00000001&(data))>>0)


#define MD_DRF_PAUSE                                                                 0x1800B21C
#define MD_DRF_PAUSE_reg_addr                                                        "0xB800B21C"
#define MD_DRF_PAUSE_reg                                                             0xB800B21C
#define set_MD_DRF_PAUSE_reg(data)   (*((volatile unsigned int*) MD_DRF_PAUSE_reg)=data)
#define get_MD_DRF_PAUSE_reg   (*((volatile unsigned int*) MD_DRF_PAUSE_reg))
#define MD_DRF_PAUSE_inst_adr                                                        "0x0087"
#define MD_DRF_PAUSE_inst                                                            0x0087
#define MD_DRF_PAUSE_md_DRF_PAUSE_A_shift                                            (0)
#define MD_DRF_PAUSE_md_DRF_PAUSE_A_mask                                             (0x00000001)
#define MD_DRF_PAUSE_md_DRF_PAUSE_A(data)                                            (0x00000001&((data)<<0))
#define MD_DRF_PAUSE_md_DRF_PAUSE_A_src(data)                                        ((0x00000001&(data))>>0)
#define MD_DRF_PAUSE_get_md_DRF_PAUSE_A(data)                                        ((0x00000001&(data))>>0)


#define MD_DRF_A_FAIL                                                                0x1800B220
#define MD_DRF_A_FAIL_reg_addr                                                       "0xB800B220"
#define MD_DRF_A_FAIL_reg                                                            0xB800B220
#define set_MD_DRF_A_FAIL_reg(data)   (*((volatile unsigned int*) MD_DRF_A_FAIL_reg)=data)
#define get_MD_DRF_A_FAIL_reg   (*((volatile unsigned int*) MD_DRF_A_FAIL_reg))
#define MD_DRF_A_FAIL_inst_adr                                                       "0x0088"
#define MD_DRF_A_FAIL_inst                                                           0x0088
#define MD_DRF_A_FAIL_md_DRF_A_FAIL_2_shift                                          (2)
#define MD_DRF_A_FAIL_md_DRF_A_FAIL_2_mask                                           (0x00000004)
#define MD_DRF_A_FAIL_md_DRF_A_FAIL_2(data)                                          (0x00000004&((data)<<2))
#define MD_DRF_A_FAIL_md_DRF_A_FAIL_2_src(data)                                      ((0x00000004&(data))>>2)
#define MD_DRF_A_FAIL_get_md_DRF_A_FAIL_2(data)                                      ((0x00000004&(data))>>2)
#define MD_DRF_A_FAIL_md_DRF_A_FAIL_1_shift                                          (1)
#define MD_DRF_A_FAIL_md_DRF_A_FAIL_1_mask                                           (0x00000002)
#define MD_DRF_A_FAIL_md_DRF_A_FAIL_1(data)                                          (0x00000002&((data)<<1))
#define MD_DRF_A_FAIL_md_DRF_A_FAIL_1_src(data)                                      ((0x00000002&(data))>>1)
#define MD_DRF_A_FAIL_get_md_DRF_A_FAIL_1(data)                                      ((0x00000002&(data))>>1)
#define MD_DRF_A_FAIL_md_DRF_A_FAIL_0_shift                                          (0)
#define MD_DRF_A_FAIL_md_DRF_A_FAIL_0_mask                                           (0x00000001)
#define MD_DRF_A_FAIL_md_DRF_A_FAIL_0(data)                                          (0x00000001&((data)<<0))
#define MD_DRF_A_FAIL_md_DRF_A_FAIL_0_src(data)                                      ((0x00000001&(data))>>0)
#define MD_DRF_A_FAIL_get_md_DRF_A_FAIL_0(data)                                      ((0x00000001&(data))>>0)


#define MD_DRF_FAIL_GROUP                                                            0x1800B224
#define MD_DRF_FAIL_GROUP_reg_addr                                                   "0xB800B224"
#define MD_DRF_FAIL_GROUP_reg                                                        0xB800B224
#define set_MD_DRF_FAIL_GROUP_reg(data)   (*((volatile unsigned int*) MD_DRF_FAIL_GROUP_reg)=data)
#define get_MD_DRF_FAIL_GROUP_reg   (*((volatile unsigned int*) MD_DRF_FAIL_GROUP_reg))
#define MD_DRF_FAIL_GROUP_inst_adr                                                   "0x0089"
#define MD_DRF_FAIL_GROUP_inst                                                       0x0089
#define MD_DRF_FAIL_GROUP_md_DRF_FAIL_GROUP_A_shift                                  (0)
#define MD_DRF_FAIL_GROUP_md_DRF_FAIL_GROUP_A_mask                                   (0x00000001)
#define MD_DRF_FAIL_GROUP_md_DRF_FAIL_GROUP_A(data)                                  (0x00000001&((data)<<0))
#define MD_DRF_FAIL_GROUP_md_DRF_FAIL_GROUP_A_src(data)                              ((0x00000001&(data))>>0)
#define MD_DRF_FAIL_GROUP_get_md_DRF_FAIL_GROUP_A(data)                              ((0x00000001&(data))>>0)


#define BIST_DVS                                                                     0x1800B228
#define BIST_DVS_reg_addr                                                            "0xB800B228"
#define BIST_DVS_reg                                                                 0xB800B228
#define set_BIST_DVS_reg(data)   (*((volatile unsigned int*) BIST_DVS_reg)=data)
#define get_BIST_DVS_reg   (*((volatile unsigned int*) BIST_DVS_reg))
#define BIST_DVS_inst_adr                                                            "0x008A"
#define BIST_DVS_inst                                                                0x008A
#define BIST_DVS_dvse_2_shift                                                        (20)
#define BIST_DVS_dvse_2_mask                                                         (0x00100000)
#define BIST_DVS_dvse_2(data)                                                        (0x00100000&((data)<<20))
#define BIST_DVS_dvse_2_src(data)                                                    ((0x00100000&(data))>>20)
#define BIST_DVS_get_dvse_2(data)                                                    ((0x00100000&(data))>>20)
#define BIST_DVS_dvs_2_shift                                                         (16)
#define BIST_DVS_dvs_2_mask                                                          (0x000F0000)
#define BIST_DVS_dvs_2(data)                                                         (0x000F0000&((data)<<16))
#define BIST_DVS_dvs_2_src(data)                                                     ((0x000F0000&(data))>>16)
#define BIST_DVS_get_dvs_2(data)                                                     ((0x000F0000&(data))>>16)
#define BIST_DVS_dvse_1_shift                                                        (12)
#define BIST_DVS_dvse_1_mask                                                         (0x00001000)
#define BIST_DVS_dvse_1(data)                                                        (0x00001000&((data)<<12))
#define BIST_DVS_dvse_1_src(data)                                                    ((0x00001000&(data))>>12)
#define BIST_DVS_get_dvse_1(data)                                                    ((0x00001000&(data))>>12)
#define BIST_DVS_dvs_1_shift                                                         (8)
#define BIST_DVS_dvs_1_mask                                                          (0x00000F00)
#define BIST_DVS_dvs_1(data)                                                         (0x00000F00&((data)<<8))
#define BIST_DVS_dvs_1_src(data)                                                     ((0x00000F00&(data))>>8)
#define BIST_DVS_get_dvs_1(data)                                                     ((0x00000F00&(data))>>8)
#define BIST_DVS_dvse_0_shift                                                        (4)
#define BIST_DVS_dvse_0_mask                                                         (0x00000010)
#define BIST_DVS_dvse_0(data)                                                        (0x00000010&((data)<<4))
#define BIST_DVS_dvse_0_src(data)                                                    ((0x00000010&(data))>>4)
#define BIST_DVS_get_dvse_0(data)                                                    ((0x00000010&(data))>>4)
#define BIST_DVS_dvs_0_shift                                                         (0)
#define BIST_DVS_dvs_0_mask                                                          (0x0000000F)
#define BIST_DVS_dvs_0(data)                                                         (0x0000000F&((data)<<0))
#define BIST_DVS_dvs_0_src(data)                                                     ((0x0000000F&(data))>>0)
#define BIST_DVS_get_dvs_0(data)                                                     ((0x0000000F&(data))>>0)


#define MD_REG_MODE                                                                  0x1800B144
#define MD_REG_MODE_reg_addr                                                         "0xB800B144"
#define MD_REG_MODE_reg                                                              0xB800B144
#define set_MD_REG_MODE_reg(data)   (*((volatile unsigned int*) MD_REG_MODE_reg)=data)
#define get_MD_REG_MODE_reg   (*((volatile unsigned int*) MD_REG_MODE_reg))
#define MD_REG_MODE_inst_adr                                                         "0x0051"
#define MD_REG_MODE_inst                                                             0x0051
#define MD_REG_MODE_reg_mode_shift                                                   (0)
#define MD_REG_MODE_reg_mode_mask                                                    (0x00000001)
#define MD_REG_MODE_reg_mode(data)                                                   (0x00000001&((data)<<0))
#define MD_REG_MODE_reg_mode_src(data)                                               ((0x00000001&(data))>>0)
#define MD_REG_MODE_get_reg_mode(data)                                               ((0x00000001&(data))>>0)


#define MD_REG_CTRL                                                                  0x1800B148
#define MD_REG_CTRL_reg_addr                                                         "0xB800B148"
#define MD_REG_CTRL_reg                                                              0xB800B148
#define set_MD_REG_CTRL_reg(data)   (*((volatile unsigned int*) MD_REG_CTRL_reg)=data)
#define get_MD_REG_CTRL_reg   (*((volatile unsigned int*) MD_REG_CTRL_reg))
#define MD_REG_CTRL_inst_adr                                                         "0x0052"
#define MD_REG_CTRL_inst                                                             0x0052
#define MD_REG_CTRL_reg_poll_shift                                                   (16)
#define MD_REG_CTRL_reg_poll_mask                                                    (0x00010000)
#define MD_REG_CTRL_reg_poll(data)                                                   (0x00010000&((data)<<16))
#define MD_REG_CTRL_reg_poll_src(data)                                               ((0x00010000&(data))>>16)
#define MD_REG_CTRL_get_reg_poll(data)                                               ((0x00010000&(data))>>16)
#define MD_REG_CTRL_loop_shift                                                       (0)
#define MD_REG_CTRL_loop_mask                                                        (0x0000FFFF)
#define MD_REG_CTRL_loop(data)                                                       (0x0000FFFF&((data)<<0))
#define MD_REG_CTRL_loop_src(data)                                                   ((0x0000FFFF&(data))>>0)
#define MD_REG_CTRL_get_loop(data)                                                   ((0x0000FFFF&(data))>>0)


#define MD_REG_CMD1                                                                  0x1800B14C
#define MD_REG_CMD1_reg_addr                                                         "0xB800B14C"
#define MD_REG_CMD1_reg                                                              0xB800B14C
#define set_MD_REG_CMD1_reg(data)   (*((volatile unsigned int*) MD_REG_CMD1_reg)=data)
#define get_MD_REG_CMD1_reg   (*((volatile unsigned int*) MD_REG_CMD1_reg))
#define MD_REG_CMD1_inst_adr                                                         "0x0053"
#define MD_REG_CMD1_inst                                                             0x0053
#define MD_REG_CMD1_cmd_word1_shift                                                  (0)
#define MD_REG_CMD1_cmd_word1_mask                                                   (0xFFFFFFFF)
#define MD_REG_CMD1_cmd_word1(data)                                                  (0xFFFFFFFF&((data)<<0))
#define MD_REG_CMD1_cmd_word1_src(data)                                              ((0xFFFFFFFF&(data))>>0)
#define MD_REG_CMD1_get_cmd_word1(data)                                              ((0xFFFFFFFF&(data))>>0)


#define MD_REG_CMD2                                                                  0x1800B150
#define MD_REG_CMD2_reg_addr                                                         "0xB800B150"
#define MD_REG_CMD2_reg                                                              0xB800B150
#define set_MD_REG_CMD2_reg(data)   (*((volatile unsigned int*) MD_REG_CMD2_reg)=data)
#define get_MD_REG_CMD2_reg   (*((volatile unsigned int*) MD_REG_CMD2_reg))
#define MD_REG_CMD2_inst_adr                                                         "0x0054"
#define MD_REG_CMD2_inst                                                             0x0054
#define MD_REG_CMD2_cmd_word2_shift                                                  (0)
#define MD_REG_CMD2_cmd_word2_mask                                                   (0xFFFFFFFF)
#define MD_REG_CMD2_cmd_word2(data)                                                  (0xFFFFFFFF&((data)<<0))
#define MD_REG_CMD2_cmd_word2_src(data)                                              ((0xFFFFFFFF&(data))>>0)
#define MD_REG_CMD2_get_cmd_word2(data)                                              ((0xFFFFFFFF&(data))>>0)


#define MD_REG_CMD3                                                                  0x1800B154
#define MD_REG_CMD3_reg_addr                                                         "0xB800B154"
#define MD_REG_CMD3_reg                                                              0xB800B154
#define set_MD_REG_CMD3_reg(data)   (*((volatile unsigned int*) MD_REG_CMD3_reg)=data)
#define get_MD_REG_CMD3_reg   (*((volatile unsigned int*) MD_REG_CMD3_reg))
#define MD_REG_CMD3_inst_adr                                                         "0x0055"
#define MD_REG_CMD3_inst                                                             0x0055
#define MD_REG_CMD3_cmd_word3_shift                                                  (0)
#define MD_REG_CMD3_cmd_word3_mask                                                   (0xFFFFFFFF)
#define MD_REG_CMD3_cmd_word3(data)                                                  (0xFFFFFFFF&((data)<<0))
#define MD_REG_CMD3_cmd_word3_src(data)                                              ((0xFFFFFFFF&(data))>>0)
#define MD_REG_CMD3_get_cmd_word3(data)                                              ((0xFFFFFFFF&(data))>>0)


#define MD_REG_CMD4                                                                  0x1800B158
#define MD_REG_CMD4_reg_addr                                                         "0xB800B158"
#define MD_REG_CMD4_reg                                                              0xB800B158
#define set_MD_REG_CMD4_reg(data)   (*((volatile unsigned int*) MD_REG_CMD4_reg)=data)
#define get_MD_REG_CMD4_reg   (*((volatile unsigned int*) MD_REG_CMD4_reg))
#define MD_REG_CMD4_inst_adr                                                         "0x0056"
#define MD_REG_CMD4_inst                                                             0x0056
#define MD_REG_CMD4_cmd_word4_shift                                                  (0)
#define MD_REG_CMD4_cmd_word4_mask                                                   (0xFFFFFFFF)
#define MD_REG_CMD4_cmd_word4(data)                                                  (0xFFFFFFFF&((data)<<0))
#define MD_REG_CMD4_cmd_word4_src(data)                                              ((0xFFFFFFFF&(data))>>0)
#define MD_REG_CMD4_get_cmd_word4(data)                                              ((0xFFFFFFFF&(data))>>0)


#define MD_W_CRC_CTRL                                                                0x1800B15C
#define MD_W_CRC_CTRL_reg_addr                                                       "0xB800B15C"
#define MD_W_CRC_CTRL_reg                                                            0xB800B15C
#define set_MD_W_CRC_CTRL_reg(data)   (*((volatile unsigned int*) MD_W_CRC_CTRL_reg)=data)
#define get_MD_W_CRC_CTRL_reg   (*((volatile unsigned int*) MD_W_CRC_CTRL_reg))
#define MD_W_CRC_CTRL_inst_adr                                                       "0x0057"
#define MD_W_CRC_CTRL_inst                                                           0x0057
#define MD_W_CRC_CTRL_crc_data_ctrl_shift                                            (2)
#define MD_W_CRC_CTRL_crc_data_ctrl_mask                                             (0x00000004)
#define MD_W_CRC_CTRL_crc_data_ctrl(data)                                            (0x00000004&((data)<<2))
#define MD_W_CRC_CTRL_crc_data_ctrl_src(data)                                        ((0x00000004&(data))>>2)
#define MD_W_CRC_CTRL_get_crc_data_ctrl(data)                                        ((0x00000004&(data))>>2)
#define MD_W_CRC_CTRL_w_crc_start_shift                                              (1)
#define MD_W_CRC_CTRL_w_crc_start_mask                                               (0x00000002)
#define MD_W_CRC_CTRL_w_crc_start(data)                                              (0x00000002&((data)<<1))
#define MD_W_CRC_CTRL_w_crc_start_src(data)                                          ((0x00000002&(data))>>1)
#define MD_W_CRC_CTRL_get_w_crc_start(data)                                          ((0x00000002&(data))>>1)
#define MD_W_CRC_CTRL_w_crc_conti_shift                                              (0)
#define MD_W_CRC_CTRL_w_crc_conti_mask                                               (0x00000001)
#define MD_W_CRC_CTRL_w_crc_conti(data)                                              (0x00000001&((data)<<0))
#define MD_W_CRC_CTRL_w_crc_conti_src(data)                                          ((0x00000001&(data))>>0)
#define MD_W_CRC_CTRL_get_w_crc_conti(data)                                          ((0x00000001&(data))>>0)


#define MD_W_CRC_MASK1                                                               0x1800B160
#define MD_W_CRC_MASK1_reg_addr                                                      "0xB800B160"
#define MD_W_CRC_MASK1_reg                                                           0xB800B160
#define set_MD_W_CRC_MASK1_reg(data)   (*((volatile unsigned int*) MD_W_CRC_MASK1_reg)=data)
#define get_MD_W_CRC_MASK1_reg   (*((volatile unsigned int*) MD_W_CRC_MASK1_reg))
#define MD_W_CRC_MASK1_inst_adr                                                      "0x0058"
#define MD_W_CRC_MASK1_inst                                                          0x0058
#define MD_W_CRC_MASK1_w_crc_mask1_shift                                             (0)
#define MD_W_CRC_MASK1_w_crc_mask1_mask                                              (0xFFFFFFFF)
#define MD_W_CRC_MASK1_w_crc_mask1(data)                                             (0xFFFFFFFF&((data)<<0))
#define MD_W_CRC_MASK1_w_crc_mask1_src(data)                                         ((0xFFFFFFFF&(data))>>0)
#define MD_W_CRC_MASK1_get_w_crc_mask1(data)                                         ((0xFFFFFFFF&(data))>>0)


#define MD_W_CRC_MASK2                                                               0x1800B164
#define MD_W_CRC_MASK2_reg_addr                                                      "0xB800B164"
#define MD_W_CRC_MASK2_reg                                                           0xB800B164
#define set_MD_W_CRC_MASK2_reg(data)   (*((volatile unsigned int*) MD_W_CRC_MASK2_reg)=data)
#define get_MD_W_CRC_MASK2_reg   (*((volatile unsigned int*) MD_W_CRC_MASK2_reg))
#define MD_W_CRC_MASK2_inst_adr                                                      "0x0059"
#define MD_W_CRC_MASK2_inst                                                          0x0059
#define MD_W_CRC_MASK2_w_crc_mask2_shift                                             (0)
#define MD_W_CRC_MASK2_w_crc_mask2_mask                                              (0xFFFFFFFF)
#define MD_W_CRC_MASK2_w_crc_mask2(data)                                             (0xFFFFFFFF&((data)<<0))
#define MD_W_CRC_MASK2_w_crc_mask2_src(data)                                         ((0xFFFFFFFF&(data))>>0)
#define MD_W_CRC_MASK2_get_w_crc_mask2(data)                                         ((0xFFFFFFFF&(data))>>0)


#define MD_W_CRC_RESULT                                                              0x1800B168
#define MD_W_CRC_RESULT_reg_addr                                                     "0xB800B168"
#define MD_W_CRC_RESULT_reg                                                          0xB800B168
#define set_MD_W_CRC_RESULT_reg(data)   (*((volatile unsigned int*) MD_W_CRC_RESULT_reg)=data)
#define get_MD_W_CRC_RESULT_reg   (*((volatile unsigned int*) MD_W_CRC_RESULT_reg))
#define MD_W_CRC_RESULT_inst_adr                                                     "0x005A"
#define MD_W_CRC_RESULT_inst                                                         0x005A
#define MD_W_CRC_RESULT_w_crc_result_shift                                           (0)
#define MD_W_CRC_RESULT_w_crc_result_mask                                            (0xFFFFFFFF)
#define MD_W_CRC_RESULT_w_crc_result(data)                                           (0xFFFFFFFF&((data)<<0))
#define MD_W_CRC_RESULT_w_crc_result_src(data)                                       ((0xFFFFFFFF&(data))>>0)
#define MD_W_CRC_RESULT_get_w_crc_result(data)                                       ((0xFFFFFFFF&(data))>>0)


#define MD_R_CRC_CTRL                                                                0x1800B16C
#define MD_R_CRC_CTRL_reg_addr                                                       "0xB800B16C"
#define MD_R_CRC_CTRL_reg                                                            0xB800B16C
#define set_MD_R_CRC_CTRL_reg(data)   (*((volatile unsigned int*) MD_R_CRC_CTRL_reg)=data)
#define get_MD_R_CRC_CTRL_reg   (*((volatile unsigned int*) MD_R_CRC_CTRL_reg))
#define MD_R_CRC_CTRL_inst_adr                                                       "0x005B"
#define MD_R_CRC_CTRL_inst                                                           0x005B
#define MD_R_CRC_CTRL_auto_cmp_en_shift                                              (2)
#define MD_R_CRC_CTRL_auto_cmp_en_mask                                               (0x00000004)
#define MD_R_CRC_CTRL_auto_cmp_en(data)                                              (0x00000004&((data)<<2))
#define MD_R_CRC_CTRL_auto_cmp_en_src(data)                                          ((0x00000004&(data))>>2)
#define MD_R_CRC_CTRL_get_auto_cmp_en(data)                                          ((0x00000004&(data))>>2)
#define MD_R_CRC_CTRL_r_crc_start_shift                                              (1)
#define MD_R_CRC_CTRL_r_crc_start_mask                                               (0x00000002)
#define MD_R_CRC_CTRL_r_crc_start(data)                                              (0x00000002&((data)<<1))
#define MD_R_CRC_CTRL_r_crc_start_src(data)                                          ((0x00000002&(data))>>1)
#define MD_R_CRC_CTRL_get_r_crc_start(data)                                          ((0x00000002&(data))>>1)
#define MD_R_CRC_CTRL_r_crc_conti_shift                                              (0)
#define MD_R_CRC_CTRL_r_crc_conti_mask                                               (0x00000001)
#define MD_R_CRC_CTRL_r_crc_conti(data)                                              (0x00000001&((data)<<0))
#define MD_R_CRC_CTRL_r_crc_conti_src(data)                                          ((0x00000001&(data))>>0)
#define MD_R_CRC_CTRL_get_r_crc_conti(data)                                          ((0x00000001&(data))>>0)


#define MD_R_CRC_MASK1                                                               0x1800B170
#define MD_R_CRC_MASK1_reg_addr                                                      "0xB800B170"
#define MD_R_CRC_MASK1_reg                                                           0xB800B170
#define set_MD_R_CRC_MASK1_reg(data)   (*((volatile unsigned int*) MD_R_CRC_MASK1_reg)=data)
#define get_MD_R_CRC_MASK1_reg   (*((volatile unsigned int*) MD_R_CRC_MASK1_reg))
#define MD_R_CRC_MASK1_inst_adr                                                      "0x005C"
#define MD_R_CRC_MASK1_inst                                                          0x005C
#define MD_R_CRC_MASK1_r_crc_mask1_shift                                             (0)
#define MD_R_CRC_MASK1_r_crc_mask1_mask                                              (0xFFFFFFFF)
#define MD_R_CRC_MASK1_r_crc_mask1(data)                                             (0xFFFFFFFF&((data)<<0))
#define MD_R_CRC_MASK1_r_crc_mask1_src(data)                                         ((0xFFFFFFFF&(data))>>0)
#define MD_R_CRC_MASK1_get_r_crc_mask1(data)                                         ((0xFFFFFFFF&(data))>>0)


#define MD_R_CRC_MASK2                                                               0x1800B174
#define MD_R_CRC_MASK2_reg_addr                                                      "0xB800B174"
#define MD_R_CRC_MASK2_reg                                                           0xB800B174
#define set_MD_R_CRC_MASK2_reg(data)   (*((volatile unsigned int*) MD_R_CRC_MASK2_reg)=data)
#define get_MD_R_CRC_MASK2_reg   (*((volatile unsigned int*) MD_R_CRC_MASK2_reg))
#define MD_R_CRC_MASK2_inst_adr                                                      "0x005D"
#define MD_R_CRC_MASK2_inst                                                          0x005D
#define MD_R_CRC_MASK2_r_crc_mask2_shift                                             (0)
#define MD_R_CRC_MASK2_r_crc_mask2_mask                                              (0xFFFFFFFF)
#define MD_R_CRC_MASK2_r_crc_mask2(data)                                             (0xFFFFFFFF&((data)<<0))
#define MD_R_CRC_MASK2_r_crc_mask2_src(data)                                         ((0xFFFFFFFF&(data))>>0)
#define MD_R_CRC_MASK2_get_r_crc_mask2(data)                                         ((0xFFFFFFFF&(data))>>0)


#define MD_DES_CRC                                                                   0x1800B178
#define MD_DES_CRC_reg_addr                                                          "0xB800B178"
#define MD_DES_CRC_reg                                                               0xB800B178
#define set_MD_DES_CRC_reg(data)   (*((volatile unsigned int*) MD_DES_CRC_reg)=data)
#define get_MD_DES_CRC_reg   (*((volatile unsigned int*) MD_DES_CRC_reg))
#define MD_DES_CRC_inst_adr                                                          "0x005E"
#define MD_DES_CRC_inst                                                              0x005E
#define MD_DES_CRC_des_crc_result_shift                                              (0)
#define MD_DES_CRC_des_crc_result_mask                                               (0xFFFFFFFF)
#define MD_DES_CRC_des_crc_result(data)                                              (0xFFFFFFFF&((data)<<0))
#define MD_DES_CRC_des_crc_result_src(data)                                          ((0xFFFFFFFF&(data))>>0)
#define MD_DES_CRC_get_des_crc_result(data)                                          ((0xFFFFFFFF&(data))>>0)


#define MD_R_CRC_RESULT                                                              0x1800B17C
#define MD_R_CRC_RESULT_reg_addr                                                     "0xB800B17C"
#define MD_R_CRC_RESULT_reg                                                          0xB800B17C
#define set_MD_R_CRC_RESULT_reg(data)   (*((volatile unsigned int*) MD_R_CRC_RESULT_reg)=data)
#define get_MD_R_CRC_RESULT_reg   (*((volatile unsigned int*) MD_R_CRC_RESULT_reg))
#define MD_R_CRC_RESULT_inst_adr                                                     "0x005F"
#define MD_R_CRC_RESULT_inst                                                         0x005F
#define MD_R_CRC_RESULT_r_crc_result_shift                                           (0)
#define MD_R_CRC_RESULT_r_crc_result_mask                                            (0xFFFFFFFF)
#define MD_R_CRC_RESULT_r_crc_result(data)                                           (0xFFFFFFFF&((data)<<0))
#define MD_R_CRC_RESULT_r_crc_result_src(data)                                       ((0xFFFFFFFF&(data))>>0)
#define MD_R_CRC_RESULT_get_r_crc_result(data)                                       ((0xFFFFFFFF&(data))>>0)


#define MD_CRC_STATUS                                                                0x1800B180
#define MD_CRC_STATUS_reg_addr                                                       "0xB800B180"
#define MD_CRC_STATUS_reg                                                            0xB800B180
#define set_MD_CRC_STATUS_reg(data)   (*((volatile unsigned int*) MD_CRC_STATUS_reg)=data)
#define get_MD_CRC_STATUS_reg   (*((volatile unsigned int*) MD_CRC_STATUS_reg))
#define MD_CRC_STATUS_inst_adr                                                       "0x0060"
#define MD_CRC_STATUS_inst                                                           0x0060
#define MD_CRC_STATUS_cmd_addr_err_shift                                             (16)
#define MD_CRC_STATUS_cmd_addr_err_mask                                              (0x00010000)
#define MD_CRC_STATUS_cmd_addr_err(data)                                             (0x00010000&((data)<<16))
#define MD_CRC_STATUS_cmd_addr_err_src(data)                                         ((0x00010000&(data))>>16)
#define MD_CRC_STATUS_get_cmd_addr_err(data)                                         ((0x00010000&(data))>>16)
#define MD_CRC_STATUS_crc_err_cnt_shift                                              (0)
#define MD_CRC_STATUS_crc_err_cnt_mask                                               (0x0000FFFF)
#define MD_CRC_STATUS_crc_err_cnt(data)                                              (0x0000FFFF&((data)<<0))
#define MD_CRC_STATUS_crc_err_cnt_src(data)                                          ((0x0000FFFF&(data))>>0)
#define MD_CRC_STATUS_get_crc_err_cnt(data)                                          ((0x0000FFFF&(data))>>0)


#define MD_MULTI_REQ                                                                 0x1800B184
#define MD_MULTI_REQ_reg_addr                                                        "0xB800B184"
#define MD_MULTI_REQ_reg                                                             0xB800B184
#define set_MD_MULTI_REQ_reg(data)   (*((volatile unsigned int*) MD_MULTI_REQ_reg)=data)
#define get_MD_MULTI_REQ_reg   (*((volatile unsigned int*) MD_MULTI_REQ_reg))
#define MD_MULTI_REQ_inst_adr                                                        "0x0061"
#define MD_MULTI_REQ_inst                                                            0x0061
#define MD_MULTI_REQ_multi_req_en_shift                                              (0)
#define MD_MULTI_REQ_multi_req_en_mask                                               (0x00000001)
#define MD_MULTI_REQ_multi_req_en(data)                                              (0x00000001&((data)<<0))
#define MD_MULTI_REQ_multi_req_en_src(data)                                          ((0x00000001&(data))>>0)
#define MD_MULTI_REQ_get_multi_req_en(data)                                          ((0x00000001&(data))>>0)


#endif
