#include <qc_verify_common.h>
#include "MD_Domain_qc.h"

//#define SpeedUp 1
#define PATTERN_LEN 0x76a700
#define Str_ADDR 0x40000000
#define End_ADDR 0x60000000

//#define QC_JUMP_ADDR  0xb200000
//#define QC_JUMP_ADDR2 0xb280000 //end of heap (b200000~b280000)
//#define QC_JUMP_ADDR3 0x0900000//0xd4000  //end of TLB (d0000~d4000)

#define CAP_CRC_EN   0xb8025220 //before enter DDR
#define CAP_CRC_REG  0xb8025224
#define DISP_CRC_EN  0xb8029040 //DDR output
#define DISP_CRC_REG 0xb8029044
///////////////////////////////////////////
//      SFG  CRC move to CP, remove since MAC7P
///////////////////////////////////////////
//#define PANEL_CRC_EN 0xb802D910 //final stage
//#define PANEL_CRC_REG 0xb802D914
#define SCAN_I3DMA_DC2H_CRC 1


#define CAP_CRC  0x3cb18aa7 //color bar:0x81D44754;
#define DISP_CRC 0x3cb18aa7 //color bar:0x81D44754;
#define UZUM_GOLDEN_CRC 0x3cb18aa7
#define UZUS_GOLDEN_CRC 0xb1a66880 //0xb1a66880 Merlin 10bits, Mac7P 8bits
#define I3DMA_UZUM_GOLDEN_CRC 0x3e07d7a8
#define DC2H_UZUS_GOLDEN_CRC 0xb764bb79


extern void Enable_DISPD_clock(void); //from BISR_qc.c
unsigned int ddr_size(unsigned int DDR_SIZE_SET)
{
/*
b0000 : None
b0001 : 512Mbit x16
b0010 : 1Gbit x16
b0011 : 2Gbit x16
b0100 : 4Gbit x16
b'0101 : 8Gbit x16
b'0110 : 4Gbit x8
b0111 : 2Gbit x32
b1000 : 4Gbit x32
*/
	unsigned int DDR_SIZE;
	switch (DDR_SIZE_SET) {
	    case 0:
	    		DDR_SIZE=0;
	        break;
	    case 1:
	    		DDR_SIZE=512;
	        break;
	    case 2:
	    		DDR_SIZE=512*2;
	        break;
	    case 3:
	    		DDR_SIZE=512*4;
	        break;
	    case 4:
	    		DDR_SIZE=512*8;
	        break;
	    case 5:
	    		DDR_SIZE=512*16;
	        break;
	    case 6:
	    		DDR_SIZE=512*8;
	        break;
	    case 7:
	    		DDR_SIZE=512*4;
	        break;
	    case 8:
	    		DDR_SIZE=512*8;
	        break;
	    default:
	        DDR_SIZE=0;
    }
    return DDR_SIZE;
}

int DDR_Full_Scan(UINT32 Str_addr, UINT32 End_addr)
{
	int bIoStatus = SUCCESS;
	UINT32 FRC_ADDR, cval, tmp_addr=0,tmpBoundary;
	UINT16 i, loop, loop_max, bRound=1;
	UINT16 timeout_count_default=1000,timeout_count;

	//scan 0x40000000 to 0x5fffffff
	loop_max = ((End_addr-Str_addr)/PATTERN_LEN);
	printk("DDR full scan from 0x%08x to 0x%08x,loop_max=%d\n",Str_addr, (End_addr-1),loop_max);
	FRC_ADDR = End_addr-PATTERN_LEN;

	rtd_outl(0xb8029040, 0x000a1800); //stop CRC

	rtd_maskl(0xb8025c44, 0xe000ffff, 0x00010000); //iv2dv_3d_line_l,[28:16]=0x1


	#if SpeedUp
	rtd_maskl(0xb8028000, 0xfbffffff, 0x01000000); //FRC mode
	#else
	rtd_maskl(0xb8028000, 0xfbffffff, 0x04000000); //frame sync mode
	rtd_outl(0xb8025C64, 0x80000465); // DCTL Hsync self gen
 	#endif


	rtd_maskl(0xb8027328, 0xffffffbf, 0x00000000); //[6]=0, double buffer disable, single buffer enable
	rtd_outl(0xb802732c, 0x00000001); //bit0 = 1, single buffer, display enable
	rtd_outl(0xb8027220, 0x00000001); //for capture single buffer and clear FIFO
	rtd_outl(0xb8027228, 0x00000001); //enable the cap FIFO
	tmpBoundary=rtd_inl(0xB8027204)&0xff;
	tmpBoundary=End_addr-tmpBoundary*8;
	rtd_outl(0xb802727c, tmpBoundary); //
	rtd_outl(0xb802746c, tmpBoundary); //
	rtd_outl(0xb8027208, FRC_ADDR); // cap0 start address1
	rtd_outl(0xb802730c, FRC_ADDR); // disp0 start address1
	rtd_outl(0xb80280f4, _BIT4); //line compare once mode status[4],write 1 to clear
	rtd_outl(0xb8028228, 0x8000000F); //enable line compare, [30]=0 once mode, line=15
	rtd_outl(0xb8029040, 0x000a1803); //continuous mode, start CRC
	rtd_outl(0xb8027334, 0x00000007); //for display register change
	timeout_count=timeout_count_default;
	while((((rtd_inl(0xb80280f4)&_BIT4)==0)||((rtd_inl(0xb8027334)&_BIT0)==1))&&(timeout_count>0))  //line compare once mode status[31], HW auto clear
		{
	  		udelay(20);
			timeout_count=timeout_count-1;
			if(timeout_count==0)
				{
					printk("DDR full scan from 0x%08x to 0x%08x, timeout1!!!!rtd_inl(0xb8028228)=0x%08x,\n",Str_addr, (End_addr-1),rtd_inl(0xb8028228));
					bIoStatus = FAILED;
					return FAILED;
				}
			}
	//rtd_maskl(0xb80280f4, ~0x10, 0x10); //line compare once mode status[4],write 1 to clear
//	printk("DDR full scan from 0x%08x to 0x%08x, timeout1!!!!rtd_inl(0xb8027334)=0x%08x,FRC_ADDR=%x\n",Str_addr, (End_addr-1),rtd_inl(0xb8027334),FRC_ADDR);



	#if 0 //signal measurement by GPIO
	for(i = 0; i<35; i++)
	{
		#if 1
		rtd_outl(0xb8029040, 0x000a1801); //continuous mode, start CRC	//mac2 modify
		while((rtd_inl(0xb8029040)&0x1));
		tmp = (rtd_inl(0xb801bc18)&0x80000);
		rtd_maskl(0xb801bc18,0xfff7ffff,~tmp); //GPIO19
		#else
		udelay(3000);
		rtd_outl(0xb8028228, 0x800001F4);; //enable line cmp
		while((rtd_inl(0xb8028228)&0x80000000)); //line compare once mode status[31]
		rtd_maskl(0xb80280f4, ~0x10, 0x10); //[4]write 1 to clear
		tmp = rtd_inl(0xb801bc18)&0x80000;
		rtd_maskl(0xb801bc18,0xfff7ffff,~tmp); //GPIO19
		/*#else
		rtd_outl(0xb802730c, FRC_ADDR);
		rtd_outl(0xb8027334, 0x00000007); //for display register change
		while((rtd_inl(0xb8027334)&0x1));
		tmp = rtd_inl(0xb801bc18)&0x80000;
		rtd_maskl(0xb801bc18,0xfff7ffff,~tmp); //GPIO19
		FRC_ADDR -= 0x10;*/
		#endif
	}
	printk("i=%d\n",i);
	#endif
	//udelay(20000);
	for(i=0; i<bRound; i++)
	{
		for(loop=0; loop<=(loop_max+1); loop++)
		{
			//pattern = loop%3;
			timeout_count=timeout_count_default;
			while((((rtd_inl(0xb80280f4)&_BIT4)==0)||((rtd_inl(0xb8027334)&_BIT0)==1))&&(timeout_count>0)) //line compare once mode status[31], HW auto clear
				{
			  		udelay(20);
					timeout_count=timeout_count-1;
					//printk("DDR full scan from VLC_liner(0xb8028228)=0x%08x,(0xb80280f4)=0x%08x,(0xb8027334)=0x%08x,\n",rtd_inl(0xb8028228),rtd_inl(0xb80280f4),rtd_inl(0xb8027334));
					if(timeout_count==0)
						{
							printk("DDR full scan from 0x%08x to 0x%08x, timeout1!!!!rtd_inl(0xb8028228)=0x%08x,\n",Str_addr, (End_addr-1),rtd_inl(0xb8028228));
							bIoStatus = FAILED;
							return FAILED;
						}
					}
			rtd_outl(0xb80280f4, _BIT4); //line compare once mode status[4],write 1 to clear
			rtd_maskl(0xb8028228, 0x7fffffff, 0x80000000); //enable line cmp


			if(loop < loop_max)
				rtd_outl(0xb8027208, FRC_ADDR); //cap(N) start address1
			if(loop >=2){	             // read addr delay 2 frame
					rtd_outl(0xb802730c, FRC_ADDR+PATTERN_LEN*2);
				       rtd_outl(0xb8027334, 0x00000007); //for display register change
			}
			/*
			timeout_count=timeout_count_default;
			while(((rtd_inl(0xb8027334)&_BIT0)==1)&&(timeout_count>0)) //line compare once mode status[31], HW auto clear
				{
			  		udelay(20);
					timeout_count=timeout_count-1;
					//printk("DDR full scan from VLC_liner(0xb8028228)=0x%08x,(0xb80280f4)=0x%08x,(0xb8027334)=0x%08x,\n",rtd_inl(0xb8028228),rtd_inl(0xb80280f4),rtd_inl(0xb8027334));
					if(timeout_count==0)
						{
							printk("DDR full scan from 0x%08x to 0x%08x, timeout1!!!!rtd_inl(0xb8028228)=0x%08x,\n",Str_addr, (End_addr-1),rtd_inl(0xb8028228));
							bIoStatus = FAILED;
							return FAILED;
						}
					}
					*/
			//check CRC of disp(N-2)
			if(loop >= 2)
			{
				//mdelay(10);
				//printk("0xb8027334 = 0x%x\n",rtd_inl(0xb8027334));
				for(timeout_count=0;timeout_count<10;timeout_count++){
				cval = rtd_inl(0xb8029044); //CRC result
				tmp_addr = FRC_ADDR+PATTERN_LEN*2;
				//printk("%d)FRC addr is 0x%x to 0x%x,cap_addr=0x%x,disp_addr=0x%x\n",loop,tmp_addr, (tmp_addr+PATTERN_LEN-4),rtd_inl(0xb8027208),rtd_inl(0xb802730c));
				if (cval != DISP_CRC)
 					printk("%d)FRC addr is %x to %x,cap_addr=%x,disp_addr=%x, timeout_count=%d\n",loop,tmp_addr, (tmp_addr+PATTERN_LEN-4),rtd_inl(0xb8027208),rtd_inl(0xb802730c),timeout_count);
        else
        	break;
				}
				if (timeout_count==10){
					printk(" ->Disp FIFO CRC fail = %x, reg=%x, (Golden is %x), 7334=%x\n", cval, rtd_inl(0xb8029044), DISP_CRC,rtd_inl(0xb8027334));

					bIoStatus = FAILED;
					return FAILED;
				}
			}
			FRC_ADDR -= PATTERN_LEN;
		}

		rtd_maskl(0xb8028228,0x7fffffff, 0x80000000); //enable line compare
	}
/*
	FRC_ADDR = Str_addr;
	rtd_outl(0xb802730c, FRC_ADDR);
	rtd_outl(0xb8027208, FRC_ADDR); // cap0 start address1

	while(rtd_inl(0xb8028228)&0x80000000); //line compare once mode status[31], HW auto clear
	rtd_maskl(0xb80280f4, ~0x10, 0x10); //line compare once mode status[4],write 1 to clear
	rtd_maskl(0xb8028228, 0x7fffffff, 0x80000000); //enable line cmp

	cval = rtd_inl(0xb8029044); //CRC result
	printk("FRC addr is %x to %x\n",FRC_ADDR, (FRC_ADDR+PATTERN_LEN-4));
	if (cval != DISP_CRC)
	{
	    printk(" ->Disp FIFO CRC fail = %x (Golden is %x)\n", cval, DISP_CRC);
		bIoStatus = FAILED;
	}
*/
	return bIoStatus;
}


int QC_Verifier_MD_Domain(void)
{
	int bIoStatus = SUCCESS;
	int bSts = SUCCESS;


	//UINT32 FRC_ADDR, cval, tmp_addr,tmpBoundary;
	UINT16 loop, loop_max; //bRound=1;
	UINT16 i, bScan = 1; //, err_cnt=0;
	//UINT8  pattern = 0;
	//UINT8  pat[3] = {0x3,0x2,0x4};

       rtd_outl(0xb800010c, 0x00002001);
	rtd_outl(0xb8000114, 0x60002803);// enable TVSB1~3,APLL_ADC,I/M/D domain clock
	rtd_outl(0xb8000114, 0x60002802);// disable TVSB1~3,APLL_ADC,I/M/D domain clock
	rtd_outl(0xb8000104, 0xE0002806);// hold TVSB1~3,APLL_ADC,I/M/D domain reset
	rtd_outl(0xb8000104, 0xE0002807);// release TVSB1~3,APLL_ADC,I/M/D domain reset
	rtd_outl(0xb800010c, 0x00002001);// release D3 reset
	udelay(100000);
	rtd_outl(0xb8000114, 0x60002803);// enable TVSB1~3,APLL_ADC,I/M/D domain clock
	rtd_outl(0xb8000108,  0x03000000);// RESET TVSB1~3,APLL_ADC,I/M/D domain clock
	rtd_outl(0xb8000108,  0x03000001);// disable TVSB1~3,APLL_ADC,I/M/D domain clock
	rtd_outl(0xb8000118,  0x03000001);// disable TVSB1~3,APLL_ADC,I/M/D domain clock
	rtd_outl(0xb8029000,	0x00000000);// disable PTG

              //Enable_DISPD_clock();


		#if SpeedUp

		 #include "./Merlin6/case22_ipg1080p_frc_uhd.tbl"
		rtd_maskl(0xb8028000, 0xfbffffff, 0x01000000); //frame sync mode		rtd_outl(0xb8028000,0x81000000);
		rtd_maskl(0xb8028300, 0xffffefff, 0x00008000);

		#else

		#include "./Merlin6/case22_ipg1080p_frc_uhd.tbl"
		#endif
                                //        #include "./Merlin2/Ddomain_LPhy.tbl"
	         //mini lvds using low-speed phy, epi/vby1 high-speed phy. share the same low-speed phy in MD test.
		  rtd_maskl(0xb80006C8, 0x7FFFFFFF, 0x00000000);	// DPLL use LS APHY

	rtd_maskl(0xb802210c, ~0x1, 0x0); //IPTG disable
	rtd_maskl(0xb802210c, ~0x1, 0x1); //IPTG enable
	rtd_maskl(0xb8022210, 0xf7ffffff, 0x08000000); //change to random pattern [27]=1
	udelay(1000);

	// DISABLE DMA
		// CapSub
		rtd_outl(0xB802742c, 0x00000000); // disps_en
		//I3DDMA
		rtd_outl(0xb8025870, 0x00000000); // cap_en
		//DC2H
		rtd_outl(0xb8029d80, 0x00000000); // cap_en

		rtd_outl(0xB8027334, 0x00070007); // double buffer

#if 0 //auto cmp mode
	rtd_outl(0xb802522c,CAP_CRC); //cap golden CRC
	rtd_outl(0xb8029050,DISP_CRC); //disp golden CRC
	rtd_outl(0xb802D91C,PANEL_CRC); //panel golden CRC
	rtd_outl(CAP_CRC_EN,0x3); //for cap:[1]conti,[0]start
	rtd_outl(DISP_CRC_EN,0x3); //for disp:[1]conti,[0]start
	rtd_outl(PANEL_CRC_EN,0x3); //for panel:[1]conti,[0]start

	for(i=0; i<=50; i++)
	{
		if((rtd_inl(CAP_CRC_REG) == CAP_CRC) && (rtd_inl(DISP_CRC_REG) == DISP_CRC))
		{
			printf("i=%d\n",i);
			break;
		}
	}

	rtd_maskl(CAP_CRC_EN,0xfffffff7,0x8); //for cap:[3]auto_cmp
	rtd_maskl(0xb8029048,0xfffffffd,0x2); //for disp:[1]auto_cmp
	rtd_maskl(PANEL_CRC_EN,0xfffffff7,0x8); //for panel:[3]auto_cmp

	for(i=0; i<1000; i++)
	{
		err_cnt = rtd_inl(0xb8025234);
		if(err_cnt != 0)
		{
			bIoStatus = FAILED;
			printk("M domain Cap(UZD) CRC fail! CRC = %x, err_cnt=%d(Golden is %x)\n",rtd_inl(CAP_CRC_REG),err_cnt,CAP_CRC);
		}
		err_cnt = rtd_inl(0xb8029058);
		if(err_cnt != 0)
		{
			bIoStatus = FAILED;
			printk("M domain Disp FIFO(UZU) CRC fail! CRC = %x, err_cnt=%d(Golden is %x)\n",rtd_inl(DISP_CRC_REG),err_cnt,DISP_CRC);
		}
	}
	if(bIoStatus == SUCCESS)
		printk("M domain Capture/Display PASS.\n");
	else
		printk("M domain Capture/Display FAIL!!!\n");

	for(i=0; i<1000; i++)
	{
		err_cnt = rtd_inl(0xb802D924);
		if(err_cnt != 0)
		{
			bIoStatus = FAILED;
			bSts = FAILED;
			printk("D-domain panel interface CRC fail! CRC = %x, err_cnt=%d(Golden is %x)\n",rtd_inl(PANEL_CRC_REG),err_cnt,PANEL_CRC);
		}
	}
	if(bSts == SUCCESS)
		printk("D-domain PASS!!!\n");
#else
	//--------------------- M-domain Main channel CRC check -------------------------------------------
	for(i=0; i<=50; i++)
	{

		udelay(5);
		loop_max=10000;
		loop=0;
//tMs = rtd_inl(TC7CVR)/27000; //Timer7
//printk("==>MD check time cap en=%d (%d)ms\n",(tMs-tTotal),tMs);
		rtd_outl(CAP_CRC_EN,0x00000001);
		rtd_outl(DISP_CRC_EN,0x00000001);
		while((rtd_inl(CAP_CRC_EN)&0x01) == 1)
		{
			loop++;
			udelay(4);
			if (loop>loop_max)
				{
				printk("CAP CRC unclear 1 CAP_CRC_EN= %x \n",rtd_inl(CAP_CRC_EN));
				return FAILED;
				}
			}
//tMs = rtd_inl(TC7CVR)/27000; //Timer7
//printk("==>MD check time cap en measure finish=%d (%d)ms\n",(tMs-tTotal),tMs);
		loop=0;
		while((rtd_inl(DISP_CRC_EN)&0x01) == 1)
		{
			loop++;
			udelay(4);
//			printk("DISP_CRC_EN= %x \n",rtd_inl(DISP_CRC_EN));
			if (loop>loop_max){
			printk("DISP CRC unclear 1 CAP_CRC_EN= %x \n",rtd_inl(DISP_CRC_EN));
			return FAILED;
				}
		}

		if((rtd_inl(CAP_CRC_REG) == CAP_CRC) && (rtd_inl(DISP_CRC_REG) == DISP_CRC)){
			bIoStatus = SUCCESS;
			break;
	}
		else if (i<49)
			bIoStatus = FAILED;
		else
			return FAILED;
	}

	if(bIoStatus == SUCCESS)
		printk("M domain Capture/Display PASS.\n");
	else
		printk("M domain Capture/Display FAIL!!!\n");
#if 0
	//--------------------- D-domain CRC check (SFG output CRC)-------------------------------------------
	for(i=0; i<=bScan; i++)
	{
//tMs = rtd_inl(TC7CVR)/27000; //Timer7
//printk("==>MD check time PIF en =%d (%d)ms\n",(tMs-tTotal),tMs);
		rtd_outl(PANEL_CRC_EN,0x00000001);

		loop=0;
		while((rtd_inl(PANEL_CRC_EN)&0x01) == 1)
		{
			loop++;
			udelay(4);
			if (loop>loop_max){
			printk("PANEL CRC unclear PANEL_CRC_EN= %x \n",rtd_inl(PANEL_CRC_EN));
			return FAILED;
				}
			}
//tMs = rtd_inl(TC7CVR)/27000; //Timer7
//printk("==>MD check time PIF en measure finish=%d (%d)ms\n",(tMs-tTotal),tMs);
		if(rtd_inl(PANEL_CRC_REG) != PANEL_CRC)
		{
			//last stage CRC
			printk("D-domain panel interface CRC fail! CRC = %x (Golden is %x)\n", rtd_inl(PANEL_CRC_REG), PANEL_CRC);
			printk("D-domain FAIL!!!\n");
			bSts = FAILED;
			bIoStatus = FAILED;
		}
	}

	if(bSts == SUCCESS)
		printk("D-domain PASS!!!\n");
#endif
#endif

	//DDR full scan
	if(bIoStatus == FAILED)
		return FAILED;
	else
	{
			unsigned int DDR_SIZE, U1_DDR_SIZE, U2_DDR_SIZE, U3_DDR_SIZE, U4_DDR_SIZE;
			unsigned int U1_DDR_SIZE_SET, U2_DDR_SIZE_SET, U3_DDR_SIZE_SET, U4_DDR_SIZE_SET;

			U1_DDR_SIZE_SET = rtd_inl(0xb803809c)&0xf;
			U2_DDR_SIZE_SET = (rtd_inl(0xb803809c)>>8)&0xf;
			U3_DDR_SIZE_SET = (rtd_inl(0xb803809c)>>16)&0xf;
			U4_DDR_SIZE_SET = (rtd_inl(0xb803809c)>>24)&0xf;

			//printk("DDR_SIZE=%d\n",DDR_SIZE);
			U1_DDR_SIZE=ddr_size(U1_DDR_SIZE_SET);
			U2_DDR_SIZE=ddr_size(U2_DDR_SIZE_SET);
			U3_DDR_SIZE=ddr_size(U3_DDR_SIZE_SET);
			U4_DDR_SIZE=ddr_size(U4_DDR_SIZE_SET);

			DDR_SIZE = U1_DDR_SIZE+U2_DDR_SIZE+U3_DDR_SIZE+U4_DDR_SIZE;

		switch (DDR_SIZE) {
	    case (512*8*3):	//4Gbx3ea
	      	printk("DDR_SIZE=1.5GB\n");
					bIoStatus = (bIoStatus==SUCCESS)?DDR_Full_Scan(0x00608000, 0x03000000): FAILED;
					bIoStatus = (bIoStatus==SUCCESS)?DDR_Full_Scan(0x03010000, 0x16000000): FAILED;
					bIoStatus = (bIoStatus==SUCCESS)?DDR_Full_Scan(0x18000000, 0x23000000): FAILED;
					bIoStatus = (bIoStatus==SUCCESS)?DDR_Full_Scan(0x23900000, 0x60000000): FAILED;

				if(bIoStatus == SUCCESS)
					printk("1.5GB DDR full scan pass\n");
				else
					printk("1.5GB DDR full scan fail\n");

	        break;

	    case (512*8*4): //4Gbx4ea
	        printk("DDR_SIZE=2.0GB\n");
					bIoStatus = (bIoStatus==SUCCESS)?DDR_Full_Scan(0x00608000, 0x03000000): FAILED;
					bIoStatus = (bIoStatus==SUCCESS)?DDR_Full_Scan(0x03010000, 0x16000000): FAILED;
					bIoStatus = (bIoStatus==SUCCESS)?DDR_Full_Scan(0x18000000, 0x23000000): FAILED;
					bIoStatus = (bIoStatus==SUCCESS)?DDR_Full_Scan(0x23900000, 0x40000000): FAILED;
					bIoStatus = (bIoStatus==SUCCESS)?DDR_Full_Scan(0x42000000, 0x80000000): FAILED;
					if(bIoStatus == SUCCESS)
						printk("2.0GB DDR full scan pass\n");
					else
						printk("2.0GB DDR full scan fail\n");

	        break;

	    default:
	        printk("Bypass DDR full scan SKIP!!!!!!!\n");
    }
	}

#if SCAN_I3DMA_DC2H_CRC
		//printk("MD_domain test SCAN_I3DMA_DC2H_CRC test=%d\n",SCAN_I3DMA_DC2H_CRC);
		#if SpeedUp // back to normal
		#include "./Merlin6/apll_ipg1080p.tbl"
		#include "./Merlin6/dpll_594MHz.tbl"
		rtd_maskl(0xb8028000, 0xfbffffff, 0x04000000); //frame sync mode		rtd_outl(0xb8028000,0x85000000); //DTG framesync
 		#endif


	if(bIoStatus == FAILED)
		return FAILED;
		UINT32 CurrentCRC[2] = {rtd_inl(0xb8029044),rtd_inl(0xb8029218)};
		UINT32 count=0,timeout_count=1000;

	#include "./Merlin6/capm_caps_dispm_disps.tbl"
	// capM
	 rtd_outl(0xB8027208, 0x10000000); // dma address
	 // dispM
	 rtd_outl(0xB802730c, 0x10000000); // addr
	 // capS
        rtd_outl(0xB8027248, 0x20000000); // dma address
        // dispS
        rtd_outl(0xB802740c, 0x20000000); // addr

        rtd_outl(0xB8027334, 0x00070007); // double buffer

		printk("MD_domain test capm_caps_dispm_disps\n");

		for(count=20; count>0; count--)
		{

			rtd_outl(0xb8029040,rtd_inl(0xb8029040)|0x00000001);

			timeout_count=10;
			while(((rtd_inl(0xb8029040)&0x01) == 1)&&(timeout_count>0))
				{
	  		udelay(10000);
			timeout_count=timeout_count-1;
				}
			rtd_outl(0xb8029214,rtd_inl(0xb8029214)|0x00000001);

			timeout_count=10;
			while(((rtd_inl(0xb8029214)&0x01) == 1)&&(timeout_count>0))
			{
	  		udelay(10000);
			timeout_count=timeout_count-1;
				}
			CurrentCRC[0] = rtd_inl(0xb8029044);
			CurrentCRC[1] = rtd_inl(0xb8029218);


		if(CurrentCRC[0] != UZUM_GOLDEN_CRC || CurrentCRC[1] != UZUS_GOLDEN_CRC){

			if(count==1){
			printk(" DMA setting fail!,Current CRC: 0x%x , 0x%x,count=%d,timeout_count=%d\n", CurrentCRC[0], CurrentCRC[1],count,timeout_count);
			return FAILED;
				}
			}else{
			printk("CapM/S DMA setting Success!\n\n");
			break;
			}
		}
	#if 0
	#include "./Merlin6/i3ddma.tbl"
             rtd_outl(0xb8025820, 0x10000000); // 1st address
             rtd_outl(0xb8025824, 0x10000000); // 2nd address
	      rtd_outl(0xb8022410, 0x98050001); // DMA VGIP random gen
//		printk("MD_domain test i3ddma\n");
              rtd_maskl(0xb8027220,0xffffffbf,0x0); // single buffer              rtd_maskl(0xb8027328,0xffffffbf,0x0); // single buffer		rtd_outl(0xB8027334, 0x00070007); // double buffer
              rtd_maskl(0xb8027328,0xffffffbf,0x0); // single buffer		rtd_outl(0xB8027334, 0x00070007); // double buffer
              rtd_outl(0xb802730c, rtd_inl(0xb8025820)); // sync I3DDma/DispM addr
              rtd_outl(0xB8027334, 0x00070007); // double buffer
              //Restore I3D VSD Default
              rtd_part_outl(0xb8025600,8,8,0x1);//444

		for(count=20; count>0; count--)
		{

			rtd_outl(0xb8029040,rtd_inl(0xb8029040)|0x00000001);
			timeout_count=10;
			while(((rtd_inl(0xb8029040)&0x01) == 1)&&(timeout_count>0))
			{
	  		udelay(10000);
			timeout_count=timeout_count-1;
				}
			CurrentCRC[0] = rtd_inl(0xb8029044);

		if(CurrentCRC[0] != I3DMA_UZUM_GOLDEN_CRC){
			if(count==1){
				printk(" i3ddma setting fail! Current CRC: 0x%x,Golden: 0x%x,count=%d,timeout_count=%d \n",  CurrentCRC[0],I3DMA_UZUM_GOLDEN_CRC,count,timeout_count );
				return FAILED;
				}
	     }	else{
			printk("I3ddma setting Success!\n\n");
			break;
			}
		}


	#endif
	#if 1
	#include "./Merlin6/dc2h.tbl"
	rtd_outl(0xb8029000, 0x00000001); //UZUPTG
	rtd_outl(0xb8029d98, 0x20000000); // 1st address
	rtd_outl(0xb8029d9c, 0x20000000); // 2nd address
	rtd_outl(0xb8029da0, 0x20000000); // 3rd address
	rtd_outl(0xB802740c, rtd_inl(0xb8029d98)); // sync dc2h/DispM addr
       rtd_outl(0xB8027334, 0x00070007); // double buffer
//			printk("MD_domain test dc2h\n");

		for(count=20; count>0; count--)
		{

			rtd_outl(0xb8029214,rtd_inl(0xb8029214)|0x00000001);

			timeout_count=10;
			while(((rtd_inl(0xb8029214)&0x01) == 1)&&(timeout_count>0))
			{
	  		udelay(10000);
			timeout_count=timeout_count-1;
				}


		CurrentCRC[1] = rtd_inl(0xb8029218);

		if(CurrentCRC[1] != DC2H_UZUS_GOLDEN_CRC){

			if(count==1){
				printk(" dc2h setting fail!Current CRC: 0x%x,Golden: 0x%x,count=%d,timeout_count=%d \n",  CurrentCRC[1],DC2H_UZUS_GOLDEN_CRC,count,timeout_count);
				return FAILED;}
		}else{
		printk("dc2h setting Success!\n\n");
		break;
			}
		}
        #endif

#endif
	return bIoStatus;
}
