#include <qc_verify_common.h>
#include <hdmi_merlin2/hdmi_qc.h>
#include <hdmi_merlin2/hdmiInternal.h>



typedef enum {
	PHY_PROC_INIT,
	PHY_PROC_RECORD,
	PHY_PROC_CLOSE_ADP,


	PHY_PROC_RECOVER_6G_LONGCABLE,
	PHY_PROC_RECOVER_6G_LONGCABLE_RECORD,
	PHY_PROC_RECOVER_6G_LONGCABLE_CLOSE_ADP,

	PHY_PROC_RECOVER_MI,

	PHY_PROC_DONE,
} HDMIRX_PHY_PROC_T;

#if AUDIO_DETECT_EN
unsigned char current_channel;
#endif

bool QC_CBUS_Send_WRITE_BURST_COMMAND(void)
{
char write_buff[6]={1,2,3,4,5,6};
int state;
state=MHLMscSendWriteBurst(_MHL_REG_SCRATCH_START, 6, &write_buff[6], _MHL_WRITE_BURST_WITH_REQ);
if(state==0)
	printf("\r\n lzqmsg==>send write burst OK");
else
	printf("\r\n lzqmsg==>send write burst NG");

	return 1;
}
void QC_CBUS(UINT8 channel)
{
	UINT32 timer1 = 0, discovery_time_pt = 0, msc_time_pt = 0, break_time_pt = 0, t1_send_1st_cmd = 0;
	UINT16 cbus_st = CBUS_INIT;
	UINT16 key=0xff;
	MHL2_IN_PIN();
	PINMUX_SEL_MHL_OUT();

	lib_hdmi_z0_set(MHL_CHANNEL, LN_B, 0);
	CBUSSwitch(1);

	rtd_maskl(CBUS_PMM_CBUS_STANDBY_04_reg, ~(CBUS_PMM_CBUS_STANDBY_04_disconn_irq_en_mask|CBUS_PMM_CBUS_STANDBY_04_cbus_disconn_mask), (CBUS_PMM_CBUS_STANDBY_04_cbus_disconn_mask)); // qc only
	HDMI_PRINTF("[CBUS] Please connecting MHL source, waiting.....%s\n", (CTS_TEST)?"(CTS Mode, press ""x"" to quit)":"");
	break_time_pt = timer1;

	while(1)	{
		if ((rtd_inl(CBUS_PMM_CBUS_STANDBY_04_reg)&(CBUS_PMM_CBUS_STANDBY_04_cbus_disconn_mask)) == (CBUS_PMM_CBUS_STANDBY_04_cbus_disconn_mask)) {
			mhl_disconnect();
			cbus_st = CBUS_INIT;
			break_time_pt = timer1;
			HDMI_PRINTF("[CBUS] disconnected!\n");
		}

		//wait wake up pulse
		if (cbus_st == CBUS_INIT) {
			if((rtd_inl(CBUS_PMM_CBUS_STANDBY_00_reg)&(CBUS_PMM_CBUS_STANDBY_00_wake_pulse_det_mask)) == ( CBUS_PMM_CBUS_STANDBY_00_wake_pulse_det_mask)) { // wake up  occurs
		        		rtd_outl(CBUS_PMM_CBUS_STANDBY_00_reg, CBUS_PMM_CBUS_STANDBY_00_wake_pulse_det_mask); //Sirius
		        		cbus_st = CBUS_WAKE;
				break_time_pt = timer1;
		        		HDMI_PRINTF("[CBUS] wake up pulse!\n");
	    		}
		}

		//wait discovery pulse
		if (cbus_st == CBUS_WAKE)	{
			if((rtd_inl(CBUS_PMM_CBUS_STANDBY_00_reg)&(CBUS_PMM_CBUS_STANDBY_00_dis_pulse_det_mask)) == (CBUS_PMM_CBUS_STANDBY_00_dis_pulse_det_mask )) {   // discovery occurs
				lib_hdmi_z0_set(MHL_CHANNEL, LN_B, 1);
				MHL_Z100k_Switch(MHL_CHANNEL, 1);
				SET_MHL_READY_TO_TRANSMIT(1); /* 6.3.6.5, if mhl3_ocbus_send_cmd fail, cannot response within 2s*/
#if MHL3_ENABLE
				t1_send_1st_cmd = 10; /* 4.3.15.1; 2 */
				while (--t1_send_1st_cmd) {
					udelay(1000);
					if (rtd_inl(CBUS_PMM_CBUS_STANDBY_04_reg)&(CBUS_PMM_CBUS_STANDBY_04_cbus_disconn_mask)) {
						rtd_maskl(CBUS_PMM_CBUS_STANDBY_00_reg, ~(CBUS_PMM_CBUS_STANDBY_00_dis_pulse_det_mask|CBUS_PMM_CBUS_STANDBY_00_wake_pulse_det_mask), (CBUS_PMM_CBUS_STANDBY_00_dis_pulse_det_mask|CBUS_PMM_CBUS_STANDBY_00_wake_pulse_det_mask));
						rtd_maskl(CBUS_PMM_CBUS_STANDBY_04_reg, ~(CBUS_PMM_CBUS_STANDBY_04_disconn_irq_en_mask|CBUS_PMM_CBUS_STANDBY_04_cbus_disconn_mask), (CBUS_PMM_CBUS_STANDBY_04_disconn_irq_en_mask|CBUS_PMM_CBUS_STANDBY_04_cbus_disconn_mask));

						rtd_maskl(CBUS_PMM_CBUS_STANDBY_02_reg, ~(CBUS_PMM_CBUS_STANDBY_02_dis_deb_lv_mask), 0);
						continue;
					}
				}

				mhl3_init_state();
				if (mhl3_ocbus_send_cmd()) {
					mhl3_ecbus_discovery();
				}
#endif
				rtd_maskl(CBUS_PMM_CBUS_STANDBY_00_reg, ~(CBUS_PMM_CBUS_STANDBY_00_dis_pulse_det_mask|CBUS_PMM_CBUS_STANDBY_00_wake_pulse_det_mask), (CBUS_PMM_CBUS_STANDBY_00_dis_pulse_det_mask|CBUS_PMM_CBUS_STANDBY_00_wake_pulse_det_mask));
				rtd_maskl(CBUS_PMM_CBUS_STANDBY_04_reg, ~(CBUS_PMM_CBUS_STANDBY_04_disconn_irq_en_mask|CBUS_PMM_CBUS_STANDBY_04_cbus_disconn_mask), (CBUS_PMM_CBUS_STANDBY_04_disconn_irq_en_mask|CBUS_PMM_CBUS_STANDBY_04_cbus_disconn_mask));

				rtd_maskl(CBUS_PMM_CBUS_STANDBY_02_reg, ~(CBUS_PMM_CBUS_STANDBY_02_dis_deb_lv_mask), 0);

				cbus_st = CBUS_DISCOVERY;
		  		HDMI_PRINTF("[CBUS] discovery done\n");
				//udelay(10000);
				break_time_pt = timer1;
				discovery_time_pt  = timer1;

	    		}
		}

#if MHL3_ENABLE

		if (mhl3_get_src_ver()>=0x30) {
			if (cbus_st > CBUS_WAKE) {
				if (!mhl3_ecbus_discovery()) {
					cbus_st = CBUS_INIT;
					CBUSSwitch(1);
					HDMI_PRINTF("re-connect\n");
				}
			}

			if (mhl3_get_state() == MHL3_READY) {
				cbus_st = CBUS_READY;
			}
			break_time_pt = timer1;
		} else if (cbus_st == CBUS_DISCOVERY) {
			udelay(100000); /* 4.3.6.2*/
			if (MHLMscSendCommand(MHL_MSC_CMD_CODE_SET_HPD, MHL_MSC_CMD_CODE_NULL, MHL_MSC_CMD_CODE_NULL) == _MHL_OK) {
	    			cbus_st = CBUS_SETHPD;
				break_time_pt = timer1;
				HDMI_PRINTF("[CBUS] sent set_hpd\n");
	    		} else {
				HDMI_PRINTF("[CBUS] MHL_SET_HPD FAIL!!!!!  \n");
	    		}
			udelay(10000);
		}

#if 0
		if ((mhl_is_ver3x()) && cbus_st > CBUS_WAKE) {
			if (!mhl3_ecbus_discovery()) {
				cbus_st = CBUS_INIT;
				CBUSSwitch(1);
				HDMI_PRINTF("re-connect\n");
			}
		}

		if (cbus_st == CBUS_DISCOVERY) {
			if (mhl_is_ver3x()) {
				if (mhl3_get_state() == MHL3_READY) {
					cbus_st = CBUS_READY;
				}
				break_time_pt = timer1;
			} else {
				udelay(100000); /* 4.3.6.2*/
				if (MHLMscSendCommand(MHL_MSC_CMD_CODE_SET_HPD, MHL_MSC_CMD_CODE_NULL, MHL_MSC_CMD_CODE_NULL) == _MHL_OK) {
		    			cbus_st = CBUS_SETHPD;
					break_time_pt = timer1;
					HDMI_PRINTF("[CBUS] sent set_hpd\n");
		    		} else {
					HDMI_PRINTF("[CBUS] MHL_SET_HPD FAIL!!!!!  \n");
		    		}
				udelay(10000);
			}


		}
#endif
#else
		if (cbus_st == CBUS_DISCOVERY && (abs(timer1-discovery_time_pt)>300)) {
			if (MHLMscSendCommand(MHL_MSC_CMD_CODE_SET_HPD, MHL_MSC_CMD_CODE_NULL, MHL_MSC_CMD_CODE_NULL) == _MHL_OK) {
	    			cbus_st = CBUS_SETHPD;
				break_time_pt = timer1;
				HDMI_PRINTF("[CBUS] sent set_hpd\n");
	    		} else {
				HDMI_PRINTF("[CBUS] MHL_SET_HPD FAIL!!!!!  \n");
	    		}
			udelay(10000);
			discovery_time_pt  = timer1;
		}
#endif

		//SEND path enable command
		if (cbus_st == CBUS_SETHPD) {
			if (MHLMscSendCommand(MHL_MSC_CMD_CODE_WRT_STAT, _MHL_REG_LINK_MODE, LINK_MODE_PATH_EN) == _MHL_OK) {
				cbus_st = CBUS_PATHEN;
				break_time_pt = timer1;
				HDMI_PRINTF("[CBUS] sent path_en, MHL is connected successfully\n");
			} else {
				HDMI_PRINTF("[CBUS]  PATH_EN FAIL!!!!!  \n");
			}
			udelay(10000);
	    	}

		if (cbus_st == CBUS_PATHEN) {
			if (MHLMscSendCommand(MHL_MSC_CMD_CODE_WRT_STAT, _MHL_REG_CONNECTED_RDY, CONNECT_DCAP_RDY) == _MHL_OK) {
				MHL_Z100k_Switch(MHL_CHANNEL, 0);
				cbus_st = CBUS_READY;
				break_time_pt = timer1;
				HDMI_PRINTF("[CBUS] sent dcap, ver=%x\n", rtd_inl(CBUS_MSC_REG_01_reg));
			} else {
				HDMI_PRINTF("[CBUS] MHL DEV CAP RDY FAIL!!!!!  \n");
			}
			udelay(10000);
		}
#if 0
		if (CBUS_CBUS_MSC_06_get_clk_mode_chg(rtd_inl(CBUS_CBUS_MSC_06_reg))) {
			_bMhl_clk_mode = (CBUS_MSC_REG_31_get_clk_mode(rtd_inl(CBUS_MSC_REG_31_reg)) == 0x02)?1:0;
			HDMI_PRINTF("[CBUS] PP mode = %d\n", _bMhl_clk_mode);
			rtd_outl(CBUS_CBUS_MSC_06_reg, CBUS_CBUS_MSC_06_clk_mode_chg_mask);
		}
#endif
		if (cbus_st == CBUS_READY || cbus_st == CBUS_PATHEN) {
			if (abs(timer1-msc_time_pt) > 100) {
				if (MHLMscCheckDeviceINT()) {
					break_time_pt = timer1;
				}
				msc_time_pt = timer1;
			}
		}


#if 0//for Cbus test 6.3.3.1~6.3.6.4
		key=rtd_inl(0x18062300);
		if ( key=='z' ) {
			printf("\r\n lzqmsg==>get state");
				bCBUS_MSC_CMD1_GET_STATE();//0x62
		}
		else if(key=='a')
			{
			printf("\r\n lzqmsg==>GET_VENDOR_ID");
			bCBUS_MSC_CMD1_GET_VENDOR_ID();//0x63
		}
		else if(key=='b')
			{
			printf("\r\n lzqmsg==>GET_MSC_ERR");
			bCBUS_MSC_CMD1_GET_MSC_ERR();//0x6b
		}
		else if(key=='c')
			{
			printf("\r\n lzqmsg==>write_burst_handler");
			mhl_write_burst_handler();
		}
		else if(key=='d')
			{
			printf("\r\n lzqmsg==>write_burst_handler");
			bCBUS_MSC_CMD1_GET_DDC_ERR();//0x6a
		}
		else if(key=='e')
			{
			printf("\r\n lzqmsg==>write_burst_handler");
			Cbus_SEND_RCP_SUB_Command(0x25);//0x68
		}
		else if(key=='f')
			{
			printf("\r\n lzqmsg==>send write_burst");
			QC_CBUS_Send_WRITE_BURST_COMMAND();//0x6c
		}
		else if(key=='g')
			{
			printf("\r\n lzqmsg==>send write_burst");
			MHLMscSendCommand(MHL_MSC_CMD_CODE_SET_INT, _MHL_REG_RCHANGE_INT, FEAT_REQ);//0x60c
		}
		else if(key=='x')
			{
			printf("\r\n lzqmsg==>continue~~");
			break;
			}
#else
		if ( GETCHAR_x ) {
			break;
		}
#endif
		if (!CTS_TEST) {
			if (abs(timer1-break_time_pt) > LOOP_TIMEOUT) {
				break; //quit if no command in timeout
			}
		}

		udelay(1000); //loop takes at least 1ms
		timer1++;

	}

}
unsigned int qc_mhl_detect_clock(unsigned char port)
{
#define WAIT_FOR_CLOCK		50
#define STABLE_CLK_CNT		4
#define CLK_ABS(x, y)	((x > y) ? (x-y) : (y-x))

	unsigned char i, stable_cnt = 0;
	unsigned int tmp_clk = 0, b_clk = 0;

	for (i=0; i<WAIT_FOR_CLOCK; i++) {
		HDMI_PRINTF("Waiting for clock, timer=%d\r", i);
		lib_hdmi_trigger_measure_start(port);
		mdelay(20);
		lib_hdmi_trigger_measure_stop(port);
		mdelay(10);
		if (lib_hdmi_is_clk_ready(port)) {
			tmp_clk = lib_hdmi_get_clock(port);
			if (tmp_clk> VALID_MIN_CLOCK && CLK_ABS(tmp_clk, b_clk) < 5) {
				if (++stable_cnt > STABLE_CLK_CNT)
					break;
			} else {
				b_clk = tmp_clk;
				stable_cnt = 0;
			}
		} else {
			b_clk = 0;
			stable_cnt = 0;
		}

		mdelay(40);
	}

	if (stable_cnt <= STABLE_CLK_CNT) {
		b_clk = 0;
	}

	HDMI_PRINTF("\n");
	return b_clk;
}


extern HDMI_PORT_INFO_T hdmi_rx[4];
bool MHL_DetectMode(unsigned char nport, UINT32 b)
{
	hdmi_rx[nport].timing_t.tmds_clk_b = b;
	lib_hdmi_clear_interlace_reg(nport);

	newbase_hdmi2p0_detect_config(nport);

#if 0 //MSR_HV  //BOX will send 420, then crc is unstable
	mdelay(400);
	newbase_hdmi_setup_video_pll(nport);
#endif

	lib_hdmi_meas_select_port(nport);

#if MSR_HV
	lib_hdmims_measure(&hdmi_rx[nport].timing_t);
	//lib_hdmims_get_hvstart(&hdmi_rx[nport].timing_t);

	HDMI_PRINTF("HDMI/DVI=%d\n", GET_H_MODE(nport));
	HDMI_PRINTF("INTERLACE=%d\n", GET_H_INTERLACE(nport));
	HDMI_PRINTF("COLOR_SPACE=%d (0:RGB; 1:422; 2:444; 3:420)\n", GET_H_COLOR_SPACE(nport));
	HDMI_PRINTF("COLOR_DEPTH=%d (0:8bit; 1:10bit; 2:12bit)\n", GET_H_COLOR_DEPTH(nport));
#endif

    return TRUE;

}


#if AUDIO_DETECT_EN

bool Hdmi_Audio_Start(void)
{
	unsigned char port = current_channel;
	unsigned char i;

	/*for (i=0; i<HDMI_PORT_TOTAL_NUM; i++)
	{
		//SET_H_AUDIO_FSM(i, AUDIO_FSM_AUDIO_START);
		lib_hdmi_audio_init(i);
	}*/
	lib_hdmi_audio_init(port);

	hdmi_rx[port].audio_t.sr_mismatch_cnt = 0;


	if (!newbase_hdmi_audio_wait_sample(port)) {
		HD_PRINT("No audio sample(p%d)\n", port);
		return FALSE;
	}

	//SET_H_AUDIO_FSM(port, AUDIO_FSM_FREQ_DETECT);
	return TRUE;
}

bool Hdmi_Audio_Freq_Detect(void)
{
	unsigned char port = current_channel;
	HDMI_AUDIO_FREQ_T t, t2;
	HDMI_AUDIO_TRACK_MODE track_mode;

	HD_PRINT("AUDIO_FSM_FREQ_DETECT[%d]\n", port);

	hdmi_rx[port].audio_t.coding_type = lib_hdmi_audio_is_nonpcm(port);

	newbase_hdmi_audio_get_freq(port, &t, &track_mode);
	newbase_hdmi_audio_get_freq(port, &t2, &track_mode);
	HD_PRINT("Hdmi_GetAudioFreq t=%ld\n", t.ACR_freq);
	HD_PRINT("Hdmi_GetAudioFreq t2=%ld\n", t2.ACR_freq);

	if ((t.ACR_freq != 0) && (t.ACR_freq==t2.ACR_freq))
	{
		if (HDMI_ABS(t.ACR_freq, t.SPDIF_freq) > (t.ACR_freq/20)) {
		// WOSQRTK-4508 // treat as noise if SR in (CS&info) arenot match > 5%
			HD_PRINT("[HDMI] Freq in N/CTS and CS are not match!!(cnt=%d)\n", hdmi_rx[port].audio_t.sr_mismatch_cnt);
			if (hdmi_rx[port].audio_t.sr_mismatch_cnt == 0) {
				hdmi_rx[port].audio_t.sr_mismatch_cnt++;
				//SET_HDMI_AUDIO_FSM(AUDIO_FSM_AUDIO_START);
				if (newbase_hdmi_audio_set_pll(port, t.ACR_freq, t.ACR_N, track_mode) == TRUE) {
					return TRUE;
				}
			} else {
				hdmi_rx[port].audio_t.sr_mismatch_cnt = 0;
				if (newbase_hdmi_audio_set_pll(port, t.ACR_freq, t.ACR_N, HDMI_AUDIO_TREND_BOUND) == TRUE) {
					return TRUE;
				}
			}
		}

		if (hdmi_rx[port].audio_t.track_mode_tgl == 1) {
			hdmi_rx[port].audio_t.track_mode_tgl = 0;
			if (newbase_hdmi_audio_set_pll(port, t.ACR_freq, t.ACR_N, track_mode))
			{
				//SET_H_AUDIO_FSM(port, AUDIO_FSM_AUDIO_WAIT_PLL_READY);
				return TRUE;
			}
		} else {
			hdmi_rx[port].audio_t.track_mode_tgl = 1;
			if (newbase_hdmi_audio_set_pll(port, t.ACR_freq, t.ACR_N, HDMI_AUDIO_TREND_BOUND))
			{
				//SET_H_AUDIO_FSM(port, AUDIO_FSM_AUDIO_WAIT_PLL_READY);
				return TRUE;
			}
		}
	}
	else
	{
		if ((t.ACR_freq == 0)||(t2.ACR_freq == 0)) { //cts = 0,use t.SPDIF_freq and force to trend_boundary tracking
			if (newbase_hdmi_audio_set_pll(port, t.SPDIF_freq, t.ACR_N, HDMI_AUDIO_TREND_BOUND))
			{
				if (t.SPDIF_freq == t2.SPDIF_freq) {
					//SET_H_AUDIO_FSM(port, AUDIO_FSM_AUDIO_WAIT_PLL_READY);
					return TRUE;
				}
			}
		}
	}

	return FALSE;
}

bool Hdmi_Audio_Wait_PLL_Ready(void)
{
	unsigned char port = current_channel;
	HD_PRINT("AUDIO_FSM_AUDIO_WAIT_PLL_READY\n");

	if (!newbase_hdmi_audio_is_pll_ready(port))
	{
		//SET_H_AUDIO_FSM(port, AUDIO_FSM_AUDIO_START);
		return FALSE;
	}

	//SET_H_AUDIO_FSM(port, AUDIO_FSM_AUDIO_START_OUT);
	return TRUE;
}

bool Hdmi_Audio_Output(void)
{
	unsigned char port = current_channel;
	HD_PRINT("AUDIO_FSM_AUDIO_START_OUT[%d]\n", port);

	lib_hdmi_audio_generate(port);
	lib_hdmi_audio_output(port, 1);

	//SET_H_AUDIO_FSM(port, AUDIO_FSM_AUDIO_CHECK);
	return TRUE;

}


bool Hdmi_AudioModeDetect(void)
{
	if ( !Hdmi_Audio_Start() ) {
		HDMI_PRINTF("[HDMI] WARNING: No audio sample.\n");
		return FALSE;
	}
	mdelay(20);
	if ( !Hdmi_Audio_Freq_Detect() ) {
		HDMI_PRINTF("[HDMI] WARNING: Cannot detect audio freq.\n");
		return FALSE;
	}
	mdelay(20);
	if ( !Hdmi_Audio_Wait_PLL_Ready() ) {
		HDMI_PRINTF("[HDMI] WARNING: Audio PLL is not ready.\n");
		return FALSE;
	}
	mdelay(20);
	if ( !Hdmi_Audio_Output() ) {
		return FALSE;
	}

	return TRUE;
}
#endif


bool mhl_CRC_en(unsigned char nport)
{
	UINT8 tmo = 50;

#if defined(RDC_SINGLE_LANE)
	rtd_maskl(HDMI_TMDS_CRCC_reg, ~(HDMI_TMDS_CRCC_crc_r_en_mask|HDMI_TMDS_CRCC_crc_g_en_mask), 0);
#endif

	rtd_maskl(HDMI_TMDS_CRCC_reg, ~HDMI_TMDS_CRCC_crcc_mask, 0);	//CRC check disable
	rtd_maskl(HDMI_TMDS_CRCC_reg, ~HDMI_TMDS_CRCC_crcc_mask, HDMI_TMDS_CRCC_crcc(1));	//CRC check enable


	while (!(rtd_inl(HDMI_TMDS_CRCC_reg)&HDMI_TMDS_CRCC_crc_done_mask)) { //wait CRC done bit
		udelay(10000);
		if (!tmo--) {
			//HDMI_PRINTF("[HDMI] WARNING: FAIL: Wait CRC Timeout !!!\n");
			return FALSE;
		}
	}

	return TRUE;
}

unsigned char qc_mhl_check_crc(unsigned char nport, QC_HDMI_CRC_ST *crc_read, QC_HDMI_CRC_ST *crc_buf)
{
bool is_interlace = 0;

	is_interlace=(rtd_inl(HDMI_HDMI_VCR_reg) & HDMI_HDMI_VCR_eot_mask);

	crc_read->val[0] = rtd_inl(HDMI_TMDS_CRCO0_reg);
	crc_read->val[1] = rtd_inl(HDMI_TMDS_CRCO1_reg);

	if (crc_read->val[0] == 0) {
		return 0;
	}

	if (is_interlace) {
		if ( ((crc_read->val[0] == crc_buf[0].val[0]) && (crc_read->val[1] == crc_buf[0].val[1])) ||
			((crc_read->val[0] == crc_buf[1].val[0]) && (crc_read->val[1] == crc_buf[1].val[1]))) {

			return 1;
		} else {

			crc_buf[0].val[0] = crc_buf[1].val[0];
			crc_buf[0].val[1] = crc_buf[1].val[1];
			crc_buf[1].val[0] = crc_read->val[0];
			crc_buf[1].val[1] = crc_read->val[1];
			return 0;
		}
	} else {
		if ((crc_read->val[0] == crc_buf[0].val[0]) && (crc_read->val[1] == crc_buf[0].val[1]) &&
			!(rtd_inl(HDMI_TMDS_CRCC_reg)&HDMI_TMDS_CRCC_crc_nonstable_mask)) {

			return 1;
		} else {

			crc_buf[0].val[0] = crc_read->val[0];
			crc_buf[0].val[1] = crc_read->val[1];
			rtd_maskl(HDMI_TMDS_CRCC_reg, ~HDMI_TMDS_CRCC_crc_nonstable_mask, HDMI_TMDS_CRCC_crc_nonstable(1));	//CRC unstable clear
			return 0;
		}
	}

	return 0;
}


bool QC_MHL_CRCCheck(unsigned char nport)
{
#define DATA_TIMEOUT	30
#define CRC_TIMEOUT	60

//unsigned int on_counting = 0, total_cnt = 0;
unsigned int i, stable_cnt = 0;
unsigned int err_cnt_rgbhv = 0;
QC_HDMI_CRC_ST crc_buf[2], crc_read;


#if defined(RDC_SINGLE_LANE)
	printk("****** RDC_SINGLE_LANE *******\n");
	if (!HDMI_TMDS_CTRL_get_bcd(rtd_inl(HDMI_TMDS_CTRL_reg)))
	{
		printk("[HDMI] WARNING: No B-Channel Data\n");
		return FALSE;
	}
#else
	for (i = 0; i < DATA_TIMEOUT; i++) {
		HDMI_PRINTF("Waiting for data, timer=%d\r", i);
		if ((HDMI_TMDS_CTRL_get_bcd(rtd_inl(HDMI_TMDS_CTRL_reg))&&HDMI_TMDS_CTRL_get_gcd(rtd_inl(HDMI_TMDS_CTRL_reg))&&HDMI_TMDS_CTRL_get_rcd(rtd_inl(HDMI_TMDS_CTRL_reg))))
			break;
		mdelay(100);
	}

	if (!(HDMI_TMDS_CTRL_get_bcd(rtd_inl(HDMI_TMDS_CTRL_reg))&&
		HDMI_TMDS_CTRL_get_gcd(rtd_inl(HDMI_TMDS_CTRL_reg))&&
		HDMI_TMDS_CTRL_get_rcd(rtd_inl(HDMI_TMDS_CTRL_reg)))) {
		printk("[HDMI] WARNING: No Input Data\n");
		return FALSE;
	}
#endif
	// Waiting for pattern is in stable status
	if (!mhl_CRC_en(nport)) {
		HDMI_PRINTF("[HDMI] WARNING: FAIL: Wait CRC Timeout !!!\n");
		return FALSE;
	}

	HDMI_PRINTF("\r\n");


	crc_buf[0].val[0] = 0;
	crc_buf[0].val[1] = 0;
	crc_buf[1].val[0] = 0;
	crc_buf[1].val[1] = 0;
	crc_read.val[0] = 0;
	crc_read.val[1] = 0;


	// Wait for CRC Stable or timeout
	stable_cnt = 0;
	for (i=0; i<CRC_TIMEOUT; i++) {
		if (qc_mhl_check_crc(nport, &crc_read, crc_buf)) {
			if (stable_cnt++ > 2) {
				// crc stable
				break;
			}
		}
		printk("[HDMI] CRC=%08X\r",
			crc_read.val[0]);
		mdelay(100);
	}

	// Start counting
	stable_cnt = 0;
	for (i=0; i<CRC_COUNT; i++) {
#if (!defined(RDC_SINGLE_LANE))
		if (rtd_inl(HDMI_TMDS_CTRL_reg) != 0xf8) {
			err_cnt_rgbhv++;
		}
#endif
		if (qc_mhl_check_crc(nport, &crc_read, crc_buf)) {
			stable_cnt++;
		}
		printk("[HDMI] CRC=%08X: Pass=(%02d/%02d)%s\r",
			crc_read.val[0],
			stable_cnt, CRC_COUNT, (err_cnt_rgbhv>0)?", NO HVRGB":"");
		mdelay(100);
	}


	printk("\n");

	if ( (CRC_COUNT-stable_cnt) || err_cnt_rgbhv) {
		return FALSE;
	} else {
		return TRUE;
	}

}

#if 0
HDMI_bool MHL_CTS_Mode(void)
{
static bool test_send_rcp=0;
static bool test_send_ucp=0;
//int MCS_TEST_COUNT;
int send_rcp_status;
int send_ucp_status;
int i;

int key,test;

rtd_inl(0x18062300);
printf("\r\n\n ***********************************************************");
printf("\r\n\tpress key to chose:");
printf("\r\n*\t\t a:MSC test(Get RAP/RCP/UCP command )");
printf("\r\n*\t\t b:MSC test(send RCP command )");
printf("\r\n*\t\t c:MSC test(send UCP command )");
printf("\r\n*******x: exit here and continue*****");

printf("\r\n ***********************************************************\n");

while(1)
	{
	key=rtd_inl(0x18062300);
	if(key=='x')
		{
		key=0;
		break;
		}
	else if(key=='a')
		{
		key=1;
		break;
		}
	else if(key=='b')
		{
		key=2;
		break;
		}
	else if(key=='c')
		{
		key=3;
		break;
		}
	mdelay(100);
	}

switch(key)
{
	case 0:
		printf("\r\n **************continue************");
		break;
	case 1:
		printf("\r\n lzqmsg==> start MSC test ! press 'x' exit !");
		while(1)
			{
			UserMHLMscCHECK_MODE();
			if(GETCHAR_x)
				break;
			}
		break;
	case 2:
		printf("\r\n lzqmsg-->press 's' send command, 'x' exit");
		key=rtd_inl(0x18062300);
		while(1)
			{
			key=rtd_inl(0x18062300);
			if(key=='x')
				break;
			else if(key=='s')
				{
				key=0x25;
				send_rcp_status=Cbus_SEND_RCP_SUB_Command(key);
				printf("\r\n lzqmsg-->send_rcp_status=%d",send_rcp_status);
				}
			mdelay(100);
			}
		break;
	case 3:
		printf("\r\n lzqmsg==>press 's' to start ucp Transmit test, 'x' to continue ");
		key=rtd_inl(0x18062300);
		while(1){
			key=rtd_inl(0x18062300);
			if(key=='x')
				break;
			else if( key=='s' )
				{
				MHL_CTRL.bBuf[0]='U';
				MHL_CTRL.bBuf[1]='C';
				MHL_CTRL.bBuf[2]='P';
				MHL_CTRL.bBuf[3]=' ';
				MHL_CTRL.bBuf[4]='t';
				MHL_CTRL.bBuf[5]='e';
				MHL_CTRL.bBuf[6]='s';
				MHL_CTRL.bBuf[7]='t';
				printf("\r\n lzqmsg==>UCP COMMAND");
				for(i=0;i<8;i++)
						{
						while(1){
							send_ucp_status=Cbus_SEND_UCP_SUB_Command(MHL_CTRL.bBuf[i]);
							if(send_ucp_status==0)
								{
								break;
								}
							else
								{
								SET_MHL_READY_TO_TRANSMIT(1);
								HDMI_DELAYMS(100);
								break;
								}
							}
						printf("\r\n lzqmsg-->send_rcp_status=%d",send_rcp_status);
						}
				}
				mdelay(100);
			}
	default: break;
}

printf("\r\n\n *******************chose command****************");
printf("\r\n**a:get state");
printf("\r\n**b:get vendor id");
printf("\r\n*******x: exit here and continue*****");
printf("\r\n *************************************************");

key=rtd_inl(0x18062300);
while(1)
	{
	key=rtd_inl(0x18062300);
	if(key=='x')
		{
		key=0;
		break;
		}
	else if(key=='a')
		{
		key=1;
		break;
		}
	else if(key=='b')
		{
		key=2;
		break;
		}
	mdelay(100);
	}

switch(key)
{
	case 0:
		printf("\r\n **************continue************");
		break;
	case 1:
		printf("\r\n lzqmsg==>press 's' to send get state command, 'x' to continue ");
		key=rtd_inl(0x18062300);
		while(1){
			key=rtd_inl(0x18062300);
			if(key=='x')
				break;
			else if( key=='s' )
				bCBUS_MSC_CMD1_GET_STATE();
			mdelay(100);
			}
		break;
	case 2:
		printf("\r\n lzqmsg==>press 's' to send vendor id command, 'x' to continue ");
		key=rtd_inl(0x18062300);
		while(1){
			key=rtd_inl(0x18062300);
			if(key=='x')
				break;
			else if( key=='s' )
				bCBUS_MSC_CMD1_GET_VENDOR_ID();
			mdelay(100);
			}
		break;

}


 return 1;

}
#endif


bool QC_MHL_Main(UINT8 channel)
{
	bool crc_result = TRUE;

	unsigned int b;
	unsigned char port = channel;

	HDMI_PRINTF("[HDMI] ================ START OF TEST (PORT=%d) ======================\n", channel);

	newbase_hdmi_init_source(channel);

	if (DEFAULT_CBUS_EN^((rtd_inl(DEBUG_REG_ADDR)&DEBUG_31_BYPASS_CBUS)>>31)) {
		QC_CBUS(port);
		MHL_CheckPPMode();
	} else {
		CBUSSwitch(1);
		lib_hdmi_z0_set(MHL_CHANNEL, LN_B, 1);
#if MHL3_ENABLE
		drvif_mhl3_cbus_switch(MHL3_MODE);
#endif

		if (DEFAULT_PP_MODE^((rtd_inl(DEBUG_REG_ADDR)&DEBUG_30_FORCE_MHL_PP)>>30)) {
			MHL_setPPMode(1);
		} else {
			MHL_setPPMode(0);
		}

		if (MHL3_MODE) {
			rtd_maskl(DBG_FW_ADDR, ~DBG_01_MHL3_ON, DBG_01_MHL3_ON);
		}
	}

#if AUDIO_DETECT_EN
	current_channel = port;
#endif

	newbase_hdmi_set_is_mhl(port, 1);
	newbase_hdmi_set_is_mhl_ppmode(port, MHL_IsPPMode());
	newbase_hdmi_set_is_mhl3(port, mhl_is_ver3x());

#if MHL3_ENABLE
	mhl3_check_link_rate();
	printk("[HDMI] MHL3 link mode=%d\n", mhl3_get_link_rate());
#endif
	mhl_clk_switch(channel, 1);

	MHLSwitch(channel, 1);

	b = qc_mhl_detect_clock(port);
	printk("[HDMI] TMDS CLOCK=%d\n", (b*27+128)>>8);

#if MHL3_ENABLE
	if (newbase_hdmi_get_is_mhl(port) && newbase_hdmi_get_is_mhl3(port)) {
		b <<= (mhl3_get_link_rate()+1);
	}
#endif

	if (b > 100) {
		newbase_hdmi_set_phy(port, b);

		mdelay(40);
		newbase_hdmi_dfe_record(port, b); // lib_hdmi_dfe_record_enable(nport, 1);
		mdelay(40);
		newbase_hdmi_dfe_record(port, b); // lib_hdmi_dfe_record_enable(nport, 0);
		//mdelay(40);
		newbase_hdmi_dfe_close(port, b, PHY_PROC_CLOSE_ADP); // lib_hdmi_set_dfe_close(nport, clk);

		mdelay(100);
		MHL_DetectMode(port, b);

#if 0
	if (CTS_TEST)
		MHL_CTS_Mode();
#endif

#if AUDIO_DETECT_EN
		Hdmi_AudioModeDetect();
#endif

#if DISPLAY_EN
		#include "case3_ipg1080p_frc_fhd/case3_hdmi1080p_frc_fhd.tbl"
#endif

		crc_result = QC_MHL_CRCCheck(port);

		printk("[HDMI] Port%d TMDS clock = %03dMHz, CRC checked: %s\n", channel, (b*27+128)>>8, crc_result?"PASS":"FAIL!");
	}

	HDMI_PRINTF("[HDMI] ================ END OF TEST (PORT=%d) ======================\n\n", channel);

	return crc_result;
}

bool IsMHLPortEnable(UINT8 pt)
{
	if (pt == 0) {
		return MHL1_CHECK_CRC; //(MPort0!=0);
	} else if (pt == 1) {
		return MHL2_CHECK_CRC; //(MPort1!=0);
	} else {
		return MHL3_CHECK_CRC; //(MPort2!=0);
	}
}

int QC_Verifier_MHL(void)
{
	int Result = SUCCESS;
	bool test_flag = TRUE;
	UINT16  i=0,j=0;

	printk("Merlin2 MHL Rx QC Test\n");

//-------------------------------------
//  Reset Value Test
//-------------------------------------
//
//	return DefaultValueTest();
//
//-------------------------------------
	HdmiTable_Init();
	newbase_hdmi_init();

	for ( i=0; i<MHL_QCloop; i++ ) {
		printk("[HDMI] LOOP=#%d\n", i+1);

		for (j=0; j<3; j++) {
			if (IsMHLPortEnable(j)) {
				test_flag &= QC_MHL_Main(j);
			}
		}
#if LOOP_ERROR_BREAK
		if (!test_flag) {
			break;
		}
#endif
	}

	if (!test_flag) {
		Result = FAILED;
	}

	return Result;
}

