/*=============================================================
 * Copyright (c)      Realtek Semiconductor Corporation, 2004
 *
 * All rights reserved.
 *
 *============================================================*/

/*======================= Description ============================
 *
 * file: 		MHL_detect.c
 *
 * author: 	The Ant Man
 * date:
 * version: 	3.0
 *
 *============================================================*/

/*========================Header Files============================*/
#include "hdmiInternal.h"

#if MHL_SUPPORT


unsigned char newbase_mhl_cts_mode(void)
{
	UserMHLMscCHECK_MODE();
	SET_ISMHL(TRUE);
	mhl_clk_switch(MHL_CHANNEL, 1);
	MHL_CheckPPMode();
	MHLSwitch(MHL_CHANNEL, 1);
	lib_hdmi_z0_set(MHL_CHANNEL, LN_ALL, 1);

	newbase_hdmi_set_is_mhl(MHL_CHANNEL, 1);
	newbase_hdmi_set_is_mhl_ppmode(MHL_CHANNEL, MHL_IsPPMode());

	HDMI_PRINTF("MHL CTS MODE SET !!!!!! \n");
	return TRUE;
}

unsigned char newbase_mhl_detect_mode(unsigned char port)
{
//	bool prev_pp;

	if (DETECT_MHL2_IN) {
#if  CBUS_NOT_BYPASS
		if (GET_SETTINGMHL() == 0) {
			lib_hdmi_z0_set(port, LN_B, 0);
			HDMI2_MHL2_SEL_MHL_OUT;
			CBUSSwitch(1);
			Cbus_Power(1);
			SET_SETTINGMHL(1);

		} else {
			MHLMscRAPHandler();
		}

		if (!MHLNormalPreDetect()) {
			return FALSE;    /* _MODE_NOSIGNAL;*/
		} else
#endif
		{
			UserMHLMscCHECK_MODE();
			mhl_clk_switch(port, 1);
			SET_ISMHL(TRUE);

			if (newbase_rxphy_get_clk(port) < VALID_MIN_CLOCK) {
				return FALSE;
			}

//			prev_pp = MHL_IsPPMode();
			MHL_CheckPPMode();
			HD_PRINT("[MHL] clk=%d, pp=%d\n", newbase_rxphy_get_clk(port), MHL_IsPPMode());

//			if (prev_pp != MHL_IsPPMode())
			if (MHL_IsPPMode())
			{
				newbase_rxphy_reset_setphy_proc(port);
			}

			MHLSwitch(port, 1); //sony z3 set mhl_ctrl after clock is stable

			newbase_hdmi_set_is_mhl(port, 1);
			newbase_hdmi_set_is_mhl_ppmode(port, MHL_IsPPMode());
#if MHL3_ENABLE
			lib_mhl3_set_detectmode(port, newbase_hdmi_get_is_mhl3(port));
#endif
			return TRUE;  /* MHL OK */
		}
	} else {

		newbase_hdmi_set_is_mhl(port, 0);
		newbase_hdmi_set_is_mhl_ppmode(port, MHL_IsPPMode());
		SET_ISMHL(0);
		SET_MHL_PROCESS_STATE(_MHL_STATE_INITIAL);
		if (GET_SETTINGMHL()) {
			lib_hdmi_z0_set(port, LN_ALL, 1);
			mhl_clk_switch(port, 0);
			MHLSwitch(MHL_CHANNEL,0);
			CBUSSwitch(0);

			HDMI2_MHL2_SEL_HDMI_OUT;
			SET_SETTINGMHL(0);
		}
		return TRUE;
	}



}










#if MHL3_ENABLE
void lib_mhl3_set_detectmode(unsigned char nport, unsigned char mhl3)
{
	if (mhl3) {
		hdmiport_mask(HDMI_HDMI_SCR_reg, ~(HDMI_HDMI_SCR_dvi_reset_ds_cm_en_mask), 0);
		hdmiport_mask(HDMI_HDMI_SCR_reg, ~(HDMI_HDMI_SCR_mode_mask|HDMI_HDMI_SCR_msmode_mask), (HDMI_HDMI_SCR_mode_mask|HDMI_HDMI_SCR_msmode_mask));
	} else {
		hdmiport_mask(HDMI_HDMI_SCR_reg, ~(HDMI_HDMI_SCR_dvi_reset_ds_cm_en_mask), HDMI_HDMI_SCR_dvi_reset_ds_cm_en_mask);
		hdmiport_mask(HDMI_HDMI_SCR_reg, ~(HDMI_HDMI_SCR_mode_mask|HDMI_HDMI_SCR_msmode_mask), 0);
	}

}
#endif










#endif

