#ifndef __MHL_FUNCTION_H_
#define __MHL_FUNCTION_H_
#include <rtd_types_qc.h>

typedef struct {
    UINT16 cmd;
    UINT16 offset;
    UINT16 data0;
    UINT16 data1;
    UINT8 data_len;
} CBUS_MSC_CMD_PARAM_ST;

typedef struct {
    UINT16 cmd;
    UINT16 offset;
    UINT8 seg_value;
    UINT32 addr_0x60;
    UINT32 addr_w;
    UINT32 addr_r;
    UINT8 data_len;
} CBUS_DDC_CMD_PARAM_ST;

UINT32 CheckReceiveCommand(void);

int set_msc_cmd_case0(CBUS_MSC_CMD_PARAM_ST *param);
int set_msc_cmd_case1(CBUS_MSC_CMD_PARAM_ST *param);
int set_msc_cmd_case2(CBUS_MSC_CMD_PARAM_ST *param);
int set_msc_cmd_case4(CBUS_MSC_CMD_PARAM_ST *param);
int set_msc_cmd_case5(CBUS_MSC_CMD_PARAM_ST *param);

int set_ddc_cmd_case0(CBUS_DDC_CMD_PARAM_ST *param);
int set_ddc_cmd_case1(CBUS_DDC_CMD_PARAM_ST *param);
int set_ddc_cmd_case2(CBUS_DDC_CMD_PARAM_ST *param);
int set_ddc_cmd_case3(CBUS_DDC_CMD_PARAM_ST *param);
int test_send_ddc_case_3(CBUS_DDC_CMD_PARAM_ST *param);

void get_data_from_fifo_to_buf(UINT8 len, UINT8* buf);

#endif //__MHL_FUNCTION_H_