#include <peripheral_common.h>
static UINT32 nAddr_GPO_IO;
static UINT8  N_bit_GPO;
static UINT32 nAddr_GPO_HL;
void GPIO_Init(void)
{
	//CRT:Clock init
	//clken:0
	rtd_outl(0xb8000118,0x00000020);//CLKEN_GPIO[5]
	rtd_outl(0xb8060040,0x00000200);//CLKEN_ISO_MISC

	//RSTN:0
	rtd_outl(0xb8000108,0x00000020);//RSTN_GPIO[5]
	rtd_outl(0xb8060030,0x00000200);//RSTN_ISO_MISC

	//clken:1
	rtd_outl(0xb8000118,0x00000021);//CLKEN_GPIO
	rtd_outl(0xb8060040,0x00000201);//CLKEN_ISO_MISC

	//clken:0
	rtd_outl(0xb8000118,0x00000020);//CLKEN_GPIO
	rtd_outl(0xb8060040,0x00000200);//CLKEN_ISO_MISC

	//RSTN:1
	rtd_outl(0xb8000108,0x00000021);//RSTN_GPIO
	rtd_outl(0xb8060030,0x00000201);//RSTN_ISO_MISC

	//clken:1
	rtd_outl(0xb8000118,0x00000021);//CLKEN_GPIO
	rtd_outl(0xb8060040,0x00000201);//CLKEN_ISO_MISC

	//-------- LVDS power----------------------------------------------------------------
	rtd_outl(0xb8000c74,0x80000000); //POW_PLT_X=POW_PLT_Y=1
}

void Verifier_GPIO_Freq(UINT8 nGPIO_Num,UINT32 Pinshare_addr,UINT8 Pinshare_msb,UINT8 Pinshare_lsb,UINT32 Pinshare_val,bool bISO)
{
    UINT32 GP0DIR;
	UINT32 GP0DATO;

	UINT32 nVal_Addr_GPO_IO;
	UINT32 nVal_nAddr_GPO_H;
	UINT32 nVal_nAddr_GPO_L;

	GPIO_Init();
	
	if(bISO)
	{		
	   GP0DIR = GP0DIR_ISO;
	   GP0DATO = GP0DATO_ISO;
	   printk("ST_GPIO Num:%d HL Freq running....\n",nGPIO_Num);
	}
	else
	{
		GP0DIR = GP0DIR_Misc;
		GP0DATO = GP0DATO_Misc;
		printk("MISC_GPIO Num:%d HL Freq running....\n",nGPIO_Num);
	}

	

	Set_Pinshare(Pinshare_addr,Pinshare_msb,Pinshare_lsb,Pinshare_val);

	printk("Pinshare:0x%x[%d:%d] =>0x%x\n",Pinshare_addr,Pinshare_msb,Pinshare_lsb,Pinshare_val);

    nAddr_GPO_IO = GP0DIR + (nGPIO_Num/32)*4;
	nAddr_GPO_HL = GP0DATO + (nGPIO_Num/32)*4;
   	N_bit_GPO =  nGPIO_Num - (nGPIO_Num/32)*32;

	nVal_Addr_GPO_IO = SetFieldValue(dw(nAddr_GPO_IO),N_bit_GPO, N_bit_GPO,1);//Set to GPO
	nVal_nAddr_GPO_H = SetFieldValue(dw(nAddr_GPO_HL),N_bit_GPO, N_bit_GPO,1);//GPO_H
	nVal_nAddr_GPO_L = SetFieldValue(dw(nAddr_GPO_HL),N_bit_GPO, N_bit_GPO,0);	//GPO_L

    ew(nAddr_GPO_IO,nVal_Addr_GPO_IO);
    printk("nAddr_GPO_IO:0x%x=>0x%x;\n",nAddr_GPO_IO,nVal_Addr_GPO_IO);
	printk("nAddr_GPO_HL:0x%x=>0x%x;\n",nAddr_GPO_HL,nVal_nAddr_GPO_H);
	printk("nAddr_GPO_HL:0x%x=>0x%x;\n",nAddr_GPO_HL,nVal_nAddr_GPO_L);
	

	while(1)
	{
		ew(nAddr_GPO_HL,nVal_nAddr_GPO_H);
		ew(nAddr_GPO_HL,nVal_nAddr_GPO_L);
	}
}

