/*
 *************************************************************************
 *
 *                   "DHRYSTONE" Benchmark Program
 *                   -----------------------------
 *
 *  Version:    C, Version 2.1
 *
 *  File:       dhry_1.c (part 2 of 3)
 *
 *  Date:       May 25, 1988
 *
 *  Author:     Reinhold P. Weicker
 *
 *************************************************************************
 */

#include <qc_verify_common.h>
#include <timer_reg.h>
#include "benchmark.h"
#include "dhry.h"
#include <malloc.h>
/* Global Variables: */

Rec_Pointer     Ptr_Glob,
                Next_Ptr_Glob;
int             Int_Glob;
Boolean         Bool_Glob;
char            Ch_1_Glob,
                Ch_2_Glob;
int             Arr_1_Glob [50];
int             Arr_2_Glob [50] [50];

char Reg_Define[] = "Register option selected.";

// Compiler will optimise away part of the Dhrystone loop unless we convince it
// the final values of the variables used in the benchmark might be printed...
int dont_print __attribute__((weak)) = 1;

//#define rtd_inl(a)  		(*(volatile unsigned int *)(a))

#ifndef ROPT
#define REG
        /* REG becomes defined as empty */
        /* i.e. no register variables   */
#else
#define REG register
#endif

Enumeration Func_1 (Capital_Letter Ch_1_Par_Val, Capital_Letter Ch_2_Par_Val);
Boolean Func_2 (Str_30 Str_1_Par_Ref, Str_30 Str_2_Par_Ref);
void Proc_1 (REG Rec_Pointer Ptr_Val_Par);
void Proc_2 (One_Fifty *Int_Par_Ref);
void Proc_3 (Rec_Pointer *Ptr_Ref_Par);
void Proc_4 (void);
void Proc_5 (void);
void Proc_6 (Enumeration  Enum_Val_Par, Enumeration *Enum_Ref_Par);
void Proc_7 (One_Fifty Int_1_Par_Val, One_Fifty Int_2_Par_Val, One_Fifty *Int_Par_Ref);
void Proc_8 (Arr_1_Dim Arr_1_Par_Ref, Arr_2_Dim Arr_2_Par_Ref, int Int_1_Par_Val, int Int_2_Par_Val);


/* variables for time measurement: */
#define VERBOSE
#define Too_Small_Time 2
#define DHRY_VAXMIPS_LOW  1000
                /* Measurements should last at least 2 seconds */

unsigned int Begin_Time = 0;
unsigned int End_Time = 0;
unsigned int User_Time = 0;
unsigned int Dhrystones_Per_Second = 0;
unsigned int Vax_Mips = 0;
/* end of variables for time measurement */

int main_dhrystone(void)
/*****/

  /* main program, corresponds to procedures        */
  /* Main and Proc_0 in the Ada version             */
{
//  double   dtime();

        One_Fifty       Int_1_Loc;
  REG   One_Fifty       Int_2_Loc;
        One_Fifty       Int_3_Loc;
  REG   char            Ch_Index;
        Enumeration     Enum_Loc;
        Str_30          Str_1_Loc;
        Str_30          Str_2_Loc;
  REG   int             Run_Index;
  REG   int             Number_Of_Runs;

//        FILE            *Ap;
  MAINSTART

  /* Initializations */

//  if ((Ap = fopen("dhry.res","a+")) == NULL)
//    {
//       printf("Can not open dhry.res\n\n");
//       exit(1);
//    }

  Next_Ptr_Glob = (Rec_Pointer) malloc (sizeof (Rec_Type));
  Ptr_Glob = (Rec_Pointer) malloc (sizeof (Rec_Type));

  Ptr_Glob->Ptr_Comp                    = Next_Ptr_Glob;
  Ptr_Glob->Discr                       = Ident_1;
  Ptr_Glob->variant.var_1.Enum_Comp     = Ident_3;
  Ptr_Glob->variant.var_1.Int_Comp      = 40;
  strcpy (Ptr_Glob->variant.var_1.Str_Comp,
          "DHRYSTONE PROGRAM, SOME STRING");
  strcpy (Str_1_Loc, "DHRYSTONE PROGRAM, 1'ST STRING");

  Arr_2_Glob [8][7] = 10;
        /* Was missing in published program. Without this statement,    */
        /* Arr_2_Glob [8][7] would have an undefined value.             */
        /* Warning: With 16-Bit processors and Number_Of_Runs > 32000,  */
        /* overflow may occur for this array element.                   */

//  printf ("\n");
//  printf ("Dhrystone Benchmark, Version 2.1 (Language: C)\n");
//  printf ("\n");
/*
  if (Reg)
    {
      printf ("Program compiled with 'register' attribute\n");
      printf ("\n");
    }
  else
    {
      printf ("Program compiled without 'register' attribute\n");
      printf ("\n");
    }
*/
#ifdef VERBOSE
//  printf ("Please give the number of runs through the benchmark: ");
#endif
  {
/*  The following 3 lines commented out by ARM
 *  int n;
 *  scanf ("%d", &n);
 *  Number_Of_Runs = n;
 *
 *  The following 2 lines added by ARM
 */
#ifdef VERBOSE
//    printf("%d", ITERATIONS);
#endif
    Number_Of_Runs = ITERATIONS;
  }
#ifdef VERBOSE
//  printf ("\n");
#endif

//  printf ("Execution starts, %d runs through Dhrystone\n\n",Number_Of_Runs);

  /***************/
  /* Start timer */
  /***************/
  //printf("[%s:%d]:0x%08x=0x%08x!\n", __FUNCTION__, __LINE__, 0xb801b63c, rtd_inl(0xb801b63c));
  Begin_Time = rtd_inl(TIMER_TC7CVR_reg); //Timer7

  BENCHSTART

  for (Run_Index = 1; Run_Index <= Number_Of_Runs; ++Run_Index)
  {
    LOOPSTART

    Proc_5();
    Proc_4();
      /* Ch_1_Glob == 'A', Ch_2_Glob == 'B', Bool_Glob == true */
    Int_1_Loc = 2;
    Int_2_Loc = 3;
    strcpy (Str_2_Loc, "DHRYSTONE PROGRAM, 2'ND STRING");
    Enum_Loc = Ident_2;
    Bool_Glob = ! Func_2 (Str_1_Loc, Str_2_Loc);
      /* Bool_Glob == 1 */
    while (Int_1_Loc < Int_2_Loc)  /* loop body executed once */
    {
      Int_3_Loc = 5 * Int_1_Loc - Int_2_Loc;
        /* Int_3_Loc == 7 */
      Proc_7 (Int_1_Loc, Int_2_Loc, &Int_3_Loc);
        /* Int_3_Loc == 7 */
      Int_1_Loc += 1;
    } /* while */
      /* Int_1_Loc == 3, Int_2_Loc == 3, Int_3_Loc == 7 */
    Proc_8 (Arr_1_Glob, Arr_2_Glob, Int_1_Loc, Int_3_Loc);
      /* Int_Glob == 5 */
    Proc_1 (Ptr_Glob);
    for (Ch_Index = 'A'; Ch_Index <= Ch_2_Glob; ++Ch_Index)
                             /* loop body executed twice */
    {
      if (Enum_Loc == Func_1 (Ch_Index, 'C'))
          /* then, not executed */
        {
        Proc_6 (Ident_1, &Enum_Loc);
        strcpy (Str_2_Loc, "DHRYSTONE PROGRAM, 3'RD STRING");
        Int_2_Loc = (int) Run_Index;
        Int_Glob = (int) Run_Index;
        }
    }
      /* Int_1_Loc == 3, Int_2_Loc == 3, Int_3_Loc == 7 */
    Int_2_Loc = Int_2_Loc * Int_1_Loc;
    Int_1_Loc = Int_2_Loc / Int_3_Loc;
    Int_2_Loc = 7 * (Int_2_Loc - Int_3_Loc) - Int_1_Loc;
      /* Int_1_Loc == 1, Int_2_Loc == 13, Int_3_Loc == 7 */
    Proc_2 (&Int_1_Loc);
      /* Int_1_Loc == 5 */

    LOOPEND

  } /* loop "for Run_Index" */

  BENCHFINISHED

  /**************/
  /* Stop timer */
  /**************/

  End_Time = rtd_inl(TIMER_TC7CVR_reg); //Timer7
  //printf("[%s:%d]:0x%08x=0x%08x!\n", __FUNCTION__, __LINE__, 0xb801b63c, rtd_inl(0xb801b63c));
  //printf ("Execution ends\n");
  //printf ("\n");
#ifndef VERBOSE
  if (!dont_print)
  {
#endif
    printf ("Final values of the variables used in the benchmark:\n");
    printf ("\n");
    printf ("Int_Glob:            %d\n", Int_Glob);
    printf ("        should be:   %d\n", 5);
    printf ("Bool_Glob:           %d\n", Bool_Glob);
    printf ("        should be:   %d\n", 1);
    printf ("Ch_1_Glob:           %c\n", Ch_1_Glob);
    printf ("        should be:   %c\n", 'A');
    printf ("Ch_2_Glob:           %c\n", Ch_2_Glob);
    printf ("        should be:   %c\n", 'B');
    printf ("Arr_1_Glob[8]:       %d\n", Arr_1_Glob[8]);
    printf ("        should be:   %d\n", 7);
    printf ("Arr_2_Glob[8][7]:    %d\n", Arr_2_Glob[8][7]);
    printf ("        should be:   Number_Of_Runs + 10\n");
    printf ("Ptr_Glob->\n");
    printf ("  Ptr_Comp:          %d\n", (int) Ptr_Glob->Ptr_Comp);
    printf ("        should be:   (implementation-dependent)\n");
    printf ("  Discr:             %d\n", Ptr_Glob->Discr);
    printf ("        should be:   %d\n", 0);
    printf ("  Enum_Comp:         %d\n", Ptr_Glob->variant.var_1.Enum_Comp);
    printf ("        should be:   %d\n", 2);
    printf ("  Int_Comp:          %d\n", Ptr_Glob->variant.var_1.Int_Comp);
    printf ("        should be:   %d\n", 17);
    printf ("  Str_Comp:          %s\n", Ptr_Glob->variant.var_1.Str_Comp);
    printf ("        should be:   DHRYSTONE PROGRAM, SOME STRING\n");
    printf ("Next_Ptr_Glob->\n");
    printf ("  Ptr_Comp:          %d\n", (int) Next_Ptr_Glob->Ptr_Comp);
    printf ("        should be:   (implementation-dependent), same as above\n");
    printf ("  Discr:             %d\n", Next_Ptr_Glob->Discr);
    printf ("        should be:   %d\n", 0);
    printf ("  Enum_Comp:         %d\n", Next_Ptr_Glob->variant.var_1.Enum_Comp);
    printf ("        should be:   %d\n", 1);
    printf ("  Int_Comp:          %d\n", Next_Ptr_Glob->variant.var_1.Int_Comp);
    printf ("        should be:   %d\n", 18);
    printf ("  Str_Comp:          %s\n", Next_Ptr_Glob->variant.var_1.Str_Comp);
    printf ("        should be:   DHRYSTONE PROGRAM, SOME STRING\n");
    printf ("Int_1_Loc:           %d\n", Int_1_Loc);
    printf ("        should be:   %d\n", 5);
    printf ("Int_2_Loc:           %d\n", Int_2_Loc);
    printf ("        should be:   %d\n", 13);
    printf ("Int_3_Loc:           %d\n", Int_3_Loc);
    printf ("        should be:   %d\n", 7);
    printf ("Enum_Loc:            %d\n", Enum_Loc);
    printf ("        should be:   %d\n", 1);
    printf ("Str_1_Loc:           %s\n", Str_1_Loc);
    printf ("        should be:   DHRYSTONE PROGRAM, 1'ST STRING\n");
    printf ("Str_2_Loc:           %s\n", Str_2_Loc);
    printf ("        should be:   DHRYSTONE PROGRAM, 2'ND STRING\n");
    printf ("\n");
#ifndef VERBOSE
  }
#endif

  printf ("Test Start Clock from %d to %d!\n", Begin_Time, End_Time);

  User_Time = (End_Time - Begin_Time);

  if (User_Time < Too_Small_Time)
  {
    printf ("Measured time too small to obtain meaningful results\n");
    printf ("Please increase number of runs\n");
    printf ("User_Time:%d < Too_Small_Time:%d\n", User_Time, Too_Small_Time);
  }
  else
  {
    Dhrystones_Per_Second = Number_Of_Runs * (27000000/User_Time);
    Vax_Mips =             (Number_Of_Runs * (27000000/1757))/User_Time;

    printf ("Test Dhrystones runs : %d!\n", Number_Of_Runs);
    printf ("Total take time      : %d.%02d ms (%d clock)!\n", User_Time/27000, (User_Time/270)%100, User_Time);
    printf ("Each Dhrystones take : %d.%03d ns!\n", User_Time/(27*Number_Of_Runs), ((User_Time*1000)/(27*Number_Of_Runs))%1000);
    printf ("Each Second can run  : %u Dhrystones!\n", Dhrystones_Per_Second);
    printf ("Vax_Mips             : %d.%02d!\n", Vax_Mips, (Number_Of_Runs * ((27000000)/1757*100))/User_Time%100);

    if(Vax_Mips > DHRY_VAXMIPS_LOW )
        printf(" \n ** TEST PASSED **\t\n");
    else
        printf(" \n ** TEST FAILED **\t\n");
#ifdef ROPT
//    printf ("Register option selected?  YES\n");
#else
//    printf ("Register option selected?  NO\n");
//  strcpy(Reg_Define, "Register option not selected.");
#endif

//    printf ("Microseconds for one run through Dhrystone: ");
//    printf ("%7.1lf \n", Microseconds);
//    printf ("Dhrystones per Second:                      ");
//    printf ("%10.1lf \n", Dhrystones_Per_Second);
//    printf ("VAX MIPS rating = %10.6lf \n",Vax_Mips);
//    printf ("\n");

//  fprintf(Ap,"\n");
//  fprintf(Ap,"Dhrystone Benchmark, Version 2.1 (Language: C)\n");
//  fprintf(Ap,"%s\n",Reg_Define);
//  fprintf(Ap,"Microseconds for one loop: %7.1lf\n",Microseconds);
//  fprintf(Ap,"Dhrystones per second: %10.1lf\n",Dhrystones_Per_Second);
//  fprintf(Ap,"VAX MIPS rating: %10.3lf\n",Vax_Mips);
//  fclose(Ap);

  }
  MAINEND;
  return 0;
}


void Proc_1 (REG Rec_Pointer Ptr_Val_Par)
/******************/
    /* executed once */
{
  REG Rec_Pointer Next_Record = Ptr_Val_Par->Ptr_Comp;
                                        /* == Ptr_Glob_Next */
  /* Local variable, initialized with Ptr_Val_Par->Ptr_Comp,    */
  /* corresponds to "rename" in Ada, "with" in Pascal           */

  structassign (*Ptr_Val_Par->Ptr_Comp, *Ptr_Glob);
  Ptr_Val_Par->variant.var_1.Int_Comp = 5;
  Next_Record->variant.var_1.Int_Comp
        = Ptr_Val_Par->variant.var_1.Int_Comp;
  Next_Record->Ptr_Comp = Ptr_Val_Par->Ptr_Comp;
  Proc_3 (&Next_Record->Ptr_Comp);
    /* Ptr_Val_Par->Ptr_Comp->Ptr_Comp
                        == Ptr_Glob->Ptr_Comp */
  if (Next_Record->Discr == Ident_1)
    /* then, executed */
  {
    Next_Record->variant.var_1.Int_Comp = 6;
    Proc_6 (Ptr_Val_Par->variant.var_1.Enum_Comp,
           &Next_Record->variant.var_1.Enum_Comp);
    Next_Record->Ptr_Comp = Ptr_Glob->Ptr_Comp;
    Proc_7 (Next_Record->variant.var_1.Int_Comp, 10,
           &Next_Record->variant.var_1.Int_Comp);
  }
  else /* not executed */
    structassign (*Ptr_Val_Par, *Ptr_Val_Par->Ptr_Comp);
} /* Proc_1 */


void Proc_2 (One_Fifty *Int_Par_Ref)
/******************/
    /* executed once */
    /* *Int_Par_Ref == 1, becomes 4 */
{
  One_Fifty  Int_Loc;
  Enumeration   Enum_Loc;

  Int_Loc = *Int_Par_Ref + 10;
  do /* executed once */
    if (Ch_1_Glob == 'A')
      /* then, executed */
    {
      Int_Loc -= 1;
      *Int_Par_Ref = Int_Loc - Int_Glob;
      Enum_Loc = Ident_1;
    } /* if */
  while (Enum_Loc != Ident_1); /* true */
} /* Proc_2 */


void Proc_3 (Rec_Pointer *Ptr_Ref_Par)
/******************/
    /* executed once */
    /* Ptr_Ref_Par becomes Ptr_Glob */
{
  if (Ptr_Glob != Null)
    /* then, executed */
    *Ptr_Ref_Par = Ptr_Glob->Ptr_Comp;
  Proc_7 (10, Int_Glob, &Ptr_Glob->variant.var_1.Int_Comp);
} /* Proc_3 */


void Proc_4 () /* without parameters */
/*******/
    /* executed once */
{
  Boolean Bool_Loc;

  Bool_Loc = Ch_1_Glob == 'A';
  Bool_Glob = Bool_Loc | Bool_Glob;
  Ch_2_Glob = 'B';
} /* Proc_4 */


void Proc_5 () /* without parameters */
/*******/
    /* executed once */
{
  Ch_1_Glob = 'A';
  Bool_Glob = false;
} /* Proc_5 */


        /* Procedure for the assignment of structures,          */
        /* if the C compiler doesn't support this feature       */
#ifdef  NOSTRUCTASSIGN
void memcpy (register char *d, register char *s, register int l)
{
  while (l--) *d++ = *s++;
}
#endif
