#ifndef __VE_PLAT_H__
#define __VE_PLAT_H__

#include "util/io.h"
#include "util/timer.h"
#include "util/util.h"
#include "util/armv7.h"
#include "util/types.h"

/* v_entry when vcpu jump form romcode */
#define MIPS_KSEG1BASE             (0xa0000000) /*vcpu use kseg1 base*/
#define MIPS_V_FINISH_VE_CODE_ADDR 0x00000200 /*the address when vcpu finish ve test will jump to*/
#define V_FINISH_VE_CODE_ADDR_SEG1 (MIPS_KSEG1BASE|MIPS_V_FINISH_VE_CODE_ADDR)

#define VE_TEST_PASS_VAL 0xbabebabe /*ve test result:PASS*/
#define VE_TEST_FAIL_VAL 0xdeaddead /*ve test result:FAIL*/
#define VE_MODE_VCPU_ONLY 0x01000000 /*ve test mode:VCPU-ONLY mode*/
#define VE_TEST_RUN_CMD 0x01000000 /*ve test command: run ve test*/
#define VE_STATUS_DONE 0x02000000 /*ve test status : DONE*/
#define VE_STATUS_CRC_ERROR 0x03000000 /*ve test status : CRC ERROR*/

/* VE1 Param Address*/
#define VE1_TEST_RESULT_ADDR (0x00002104) /*output from ve,ve test result address,VE_TEST_PASS_VAL or VE_TEST_FAIL_VAL will be written at here*/
#define VE1_TEST_MODE_ADDR (0x00002120) /*param for ve,the value at this address means ve test mode(ex:vcpu-only test)*/
#define VE1_FINISH_RELOAD_VAL_ADDR (0x0000210c) /*param for ve,the value at this address means when finish vcpu will jump to the address which equal the value.*/
#define VE1_RUN_CMD_ADDR (0x00002100) /*param for ve,the value means the command code for ve*/
#define VE1_STATUS_VAL_ADDR (0x01fff000) /*output from ve,the value means ve test status,use to moniter ve run status*/
#define MIPS_V_ENTRY_VE1_PARTTEN  (0xa3204000) /*ve pattern start address*/
//#define MIPS_V_ENTRY_VE1_PARTTEN  (MIPS_KSEG1BASE|0x00200000) /*ve pattern start address*/

/* VE2 Param Address*/
#define VE2_TEST_RESULT_ADDR  (0x00002404)
#define VE2_TEST_MODE_ADDR 0x00002320
#define VE2_FINISH_RELOAD_VAL_ADDR 0x0000240c
#define VE2_RUN_CMD_ADDR 0x00002400
#define VE2_STATUS_VAL_ADDR (0x01fff000)
#define MIPS_V_ENTRY_VE2_PARTTEN            (0xa3204000) /* v entry from dv pattern */

/* v_entry when vcpu jump form romcode */
#define MIPS_V_ENTRY_CODE_ADDR             (0x00000200) /*the address of v_entry_qc.img,this img is vcpu start code*/
//#define MIPS_VIDEO_FW_ENTRY_PTR_V1_ADDR    (0x000000e4) /*param for ve,the value means where the ve pattern start from*/
#define MIPS_VIDEO_FW_ENTRY_PTR_V1_ADDR    (0x00002200) /*param for ve,the value in this address means where the ve pattern start from*/
#define MIPS_VIDEO_FW_ENTRY_PTR_V2_ADDR    (0x00002210) /*param for ve,the value means where the ve pattern start from*/

/*regs*/
#define VCPU_JUMP_ADDR_reg                 (0xb801a61c) /* register which represent VCPU jump address */
#define CRT_SYS_SRST0_reg                     (0xb8000100) /*module reset control reg0*/
#define CRT_SYS_SRST1_reg					   (0xb8000104)	/*module reset control reg1*/
#define CRT_SYS_CLKEN0_reg                     (0xb8000110) /*vcpu clock reg0*/
#define CRT_SYS_CLKEN1_reg					   (0xb8000114) /*vcpu clock reg1*/
#define REG_HW_SEMAPHORE                   (0xb801a000) /*vcpu semaphore*/

#endif /*__VE_PLAT_H__*/
