#include "util.h"
#include "../vp9_plat.h"

void enable_vp9vp1_clock(void)
{
	rtd_clearbits(SYS_CLKEN0_reg, _BIT13 | _BIT3);
	rtd_clearbits(SYS_CLKEN1_reg, _BIT22);
	cnt_udelay(10);

	// rst = 0
	// VP9, VDE, VE_P2, VE, VCPU
	// VDEC, ME, SE
	rtd_clearbits(SYS_SRST0_reg, _BIT28 | _BIT26 | _BIT13 | _BIT6 | _BIT3);
	//rtd_clearbits(SYS_SRST1_reg, _BIT22 | _BIT12 | _BIT5);
	cnt_udelay(10);

	// clk = 1
	rtd_setbits(SYS_CLKEN0_reg, _BIT13 | _BIT3);
	rtd_setbits(SYS_CLKEN1_reg, _BIT22);
    cnt_udelay(10);

	// clk = 0
	rtd_clearbits(SYS_CLKEN0_reg, _BIT13 | _BIT3);
	rtd_clearbits(SYS_CLKEN1_reg, _BIT22);
	cnt_udelay(10);

	// rst = 1
	rtd_setbits(SYS_SRST0_reg, _BIT28 | _BIT26 | _BIT13 | _BIT6 | _BIT3);
	//rtd_setbits(SYS_SRST1_reg, _BIT22 | _BIT12 | _BIT5);
	cnt_udelay(10);

	// clk = 1
	rtd_setbits(SYS_CLKEN0_reg, _BIT13 | _BIT3);
	rtd_setbits(SYS_CLKEN1_reg, _BIT22);
	cnt_udelay(10);
}

int disable_vp9vp1_clock(void)
{
	int ret = 0;

	// clk = 0
	// VP9, VDE, VE_P2, VE, VCPU
	// VDEC, ME, SE
	rtd_clearbits(SYS_CLKEN0_reg, _BIT13 | _BIT5 | _BIT4 | _BIT3);
	rtd_clearbits(SYS_CLKEN1_reg, _BIT22 | _BIT12 | _BIT5);

	// rst = 0
	// VP9, VDE, VE_P2, VE, VCPU
	// VDEC, ME, SE
	rtd_clearbits(SYS_SRST0_reg, _BIT13 | _BIT6 | _BIT5 | _BIT4 | _BIT3);
	rtd_clearbits(SYS_SRST1_reg, _BIT22 | _BIT12 | _BIT5);

	return ret;
}

int enable_vcpus(void)
{
	flush_dcache_all();
	rtd_outl(SB2_HD_SEM_reg, 0x1);
	enable_vp9vp1_clock();
	cnt_udelay(1000);
	rtd_outl(SB2_HD_SEM_reg, 0x0);
	cnt_udelay(20000);

	return 0;
}

int disable_vcpus(void)
{
	flush_dcache_all();
	rtd_outl(SB2_HD_SEM_reg, 0x1);
	disable_vp9vp1_clock();
	cnt_udelay(1000);
	rtd_outl(SB2_HD_SEM_reg, 0x0);
	cnt_udelay(20000);

	return 0;
}

