#ifndef __VE_PLAT_H__
#define __VE_PLAT_H__

#include "util/io.h"
#include "util/timer.h"
#include "util/util.h"
#include "util/armv7.h"
#include "util/types.h"

/* v_entry when vcpu jump form romcode */
#define MIPS_KSEG1BASE             (0xa0000000) /*vcpu use kseg1 base*/

#define VP9_STATUS_BUSY 0x01000000
#define VP9_STATUS_PASS 0x02000000
#define VP9_STATUS_FAIL 0x03000000

#define VP9_TEST_PASS_VAL 0xbabebabe /*ve test result:PASS*/
#define VP9_TEST_FAIL_VAL 0xdeaddead /*ve test result:FAIL*/
#define VP9_MODE_VCPU_ONLY 0x01000000 /*ve test mode:VCPU-ONLY mode*/

/* VP9V1 Param Address*/
#define VP9V1_STATUS_VAL_ADDR (0x01fff000) /*output from VP9*/
#define VFW_ENTRY_VP9V1_PARTTEN  (0x00004000) /*vp9v1 pattern start address*/
//#define VFW_ENTRY_VP9V1_PARTTEN  (MIPS_KSEG1BASE|0x03204000) /*VVVVVVVVVVEEEEEEEEEEEE pattern start address*/
#define VP9V1_TEST_RESULT_ADDR (0x00002104) /*output from ve,ve test result address,VE_TEST_PASS_VAL or VE_TEST_FAIL_VAL will be written at here*/
#define VP9V1_TEST_MODE_ADDR (0x00002120) /*param for ve,the value at this address means ve test mode(ex:vcpu-only test)*/
#define VP9V1_FINISH_RELOAD_VAL_ADDR (0x0000210c) /*param for ve,the value at this address means when finish vcpu will jump to the address which equal the value.*/
#define VP9V1_RUN_CMD_ADDR (0x00002100) /*param for ve,the value means the command code for ve*/

/* VP9V2 Param Address*/

/* v_entry when vcpu jump form romcode */
#define VFW_ENTRY_ADDR             (0x00000200) /*the address of v_entry_qc.img,this img is vcpu start code*/
#define VFW_ENTRY_PTR_V1_ADDR    (0x00001ffc)

/*regs*/
#define VCPU_JUMP_ADDR_reg                 (0xb801a61c) /* register which represent VCPU jump address */
#define SYS_SRST0_reg                      (0xb8000100) /*module reset control reg0*/
#define SYS_SRST1_reg					   (0xb8000104)	/*module reset control reg1*/
#define SYS_CLKEN0_reg                     (0xb8000110) /*vcpu clock reg0*/
#define SYS_CLKEN1_reg					   (0xb8000114) /*vcpu clock reg1*/
#define SB2_HD_SEM_reg      				(0xb801a000)

#endif /*__VE_PLAT_H__*/
