/**
* @file Mac7p-DesignSpec-D-Domain_3dLUT
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2019/11/22
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_C3DLUT_REG_H_
#define _RBUS_C3DLUT_REG_H_

#include "rbusTypes.h"



//  C3DLUT Register Address



#define  C3DLUT_C3DLUT_LUT_CTRL_VADDR                       	(0xb8028a00)
#define  C3DLUT_C3DLUT_DB_CTL_0_VADDR                       	(0xb8028ad8)
#define  C3DLUT_DMATO3DLUT_CTRL_VADDR                       	(0xb8028adc)
#define  C3DLUT_C3DLUT_LUT_CTRL0_VADDR                      	(0xb8028a04)
#define  C3DLUT_C3DLUT_LUT_WR_DATA_1_VADDR                  	(0xb8028a08)
#define  C3DLUT_C3DLUT_LUT_WR_DATA_2_VADDR                  	(0xb8028a0c)
#define  C3DLUT_C3DLUT_LUT_WR_DATA_3_VADDR                  	(0xb8028a10)
#define  C3DLUT_C3DLUT_LUT_WR_DATA_4_VADDR                  	(0xb8028a14)
#define  C3DLUT_C3DLUT_LUT_WR_DATA_5_VADDR                  	(0xb8028a18)
#define  C3DLUT_C3DLUT_LUT_WR_DATA_6_VADDR                  	(0xb8028a1c)
#define  C3DLUT_C3DLUT_LUT_WR_DATA_7_VADDR                  	(0xb8028a20)
#define  C3DLUT_C3DLUT_LUT_WR_DATA_8_VADDR                  	(0xb8028a24)
#define  C3DLUT_C3DLUT_LUT_WR_DATA_9_VADDR                  	(0xb8028a28)
#define  C3DLUT_C3DLUT_LUT_WR_DATA_10_VADDR                 	(0xb8028a2c)
#define  C3DLUT_C3DLUT_LUT_WR_DATA_11_VADDR                 	(0xb8028a30)
#define  C3DLUT_C3DLUT_LUT_WR_DATA_12_VADDR                 	(0xb8028a34)
#define  C3DLUT_C3DLUT_LUT_WR_DATA_13_VADDR                 	(0xb8028a38)
#define  C3DLUT_C3DLUT_LUT_WR_DATA_14_VADDR                 	(0xb8028a3c)
#define  C3DLUT_C3DLUT_LUT_WR_DATA_15_VADDR                 	(0xb8028a40)
#define  C3DLUT_C3DLUT_LUT_WR_DATA_16_VADDR                 	(0xb8028a44)
#define  C3DLUT_C3DLUT_LUT_WR_DATA_17_VADDR                 	(0xb8028a48)
#define  C3DLUT_C3DLUT_LUT_WR_DATA_18_VADDR                 	(0xb8028a4c)
#define  C3DLUT_C3DLUT_LUT_RD_DATA_1_VADDR                  	(0xb8028a90)
#define  C3DLUT_C3DLUT_LUT_RD_DATA_2_VADDR                  	(0xb8028a94)
#define  C3DLUT_C3DLUT_LUT_RD_DATA_3_VADDR                  	(0xb8028a98)
#define  C3DLUT_C3DLUT_LUT_RD_DATA_4_VADDR                  	(0xb8028a9c)
#define  C3DLUT_C3DLUT_LUT_RD_DATA_5_VADDR                  	(0xb8028aa0)
#define  C3DLUT_C3DLUT_LUT_RD_DATA_6_VADDR                  	(0xb8028aa4)
#define  C3DLUT_C3DLUT_LUT_RD_DATA_7_VADDR                  	(0xb8028aa8)
#define  C3DLUT_C3DLUT_LUT_RD_DATA_8_VADDR                  	(0xb8028aac)
#define  C3DLUT_C3DLUT_LUT_RD_DATA_9_VADDR                  	(0xb8028ab0)
#define  C3DLUT_C3DLUT_LUT_RD_DATA_10_VADDR                 	(0xb8028ab4)
#define  C3DLUT_C3DLUT_LUT_RD_DATA_11_VADDR                 	(0xb8028ab8)
#define  C3DLUT_C3DLUT_LUT_RD_DATA_12_VADDR                 	(0xb8028abc)
#define  C3DLUT_C3DLUT_LUT_RD_DATA_13_VADDR                 	(0xb8028ac0)
#define  C3DLUT_C3DLUT_LUT_RD_DATA_14_VADDR                 	(0xb8028ac4)
#define  C3DLUT_C3DLUT_LUT_RD_DATA_15_VADDR                 	(0xb8028ac8)
#define  C3DLUT_C3DLUT_LUT_RD_DATA_16_VADDR                 	(0xb8028acc)
#define  C3DLUT_C3DLUT_LUT_RD_DATA_17_VADDR                 	(0xb8028ad0)
#define  C3DLUT_C3DLUT_LUT_RD_DATA_18_VADDR                 	(0xb8028ad4)
#define  C3DLUT_C3DLUT_LUT_MBIST_VADDR                      	(0xb8028b18)
#define  C3DLUT_C3DLUT_DUMMY1_VADDR                         	(0xb8028b1c)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======C3DLUT register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  rounding_en:1;
        RBus_UInt32  c3dlut_ctrl_overlay:1;
        RBus_UInt32  c3dlut_ctrl_sub:1;
        RBus_UInt32  c3dlut_ctrl_main:1;
    };
}c3dlut_c3dlut_lut_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  db_read_0:1;
        RBus_UInt32  db_en_0:1;
        RBus_UInt32  db_apply_0:1;
    };
}c3dlut_c3dlut_db_ctl_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  dmato3dlut_en:1;
    };
}c3dlut_dmato3dlut_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  lut_rw_sel:2;
        RBus_UInt32  lut_write_en:1;
        RBus_UInt32  lut_read_en:1;
        RBus_UInt32  hw_fw_priority_opt:1;
        RBus_UInt32  res2:18;
        RBus_UInt32  lut_rw_adr:8;
    };
}c3dlut_c3dlut_lut_ctrl0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_wr_data_d0_1:16;
        RBus_UInt32  lut_wr_data_d1_1:16;
    };
}c3dlut_c3dlut_lut_wr_data_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  lut_wr_data_d2_1:16;
    };
}c3dlut_c3dlut_lut_wr_data_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_wr_data_d0_2:16;
        RBus_UInt32  lut_wr_data_d1_2:16;
    };
}c3dlut_c3dlut_lut_wr_data_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  lut_wr_data_d2_2:16;
    };
}c3dlut_c3dlut_lut_wr_data_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_wr_data_d0_3:16;
        RBus_UInt32  lut_wr_data_d1_3:16;
    };
}c3dlut_c3dlut_lut_wr_data_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  lut_wr_data_d2_3:16;
    };
}c3dlut_c3dlut_lut_wr_data_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_wr_data_d0_4:16;
        RBus_UInt32  lut_wr_data_d1_4:16;
    };
}c3dlut_c3dlut_lut_wr_data_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  lut_wr_data_d2_4:16;
    };
}c3dlut_c3dlut_lut_wr_data_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_wr_data_d0_5:16;
        RBus_UInt32  lut_wr_data_d1_5:16;
    };
}c3dlut_c3dlut_lut_wr_data_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  lut_wr_data_d2_5:16;
    };
}c3dlut_c3dlut_lut_wr_data_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_wr_data_d0_6:16;
        RBus_UInt32  lut_wr_data_d1_6:16;
    };
}c3dlut_c3dlut_lut_wr_data_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  lut_wr_data_d2_6:16;
    };
}c3dlut_c3dlut_lut_wr_data_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_wr_data_d0_7:16;
        RBus_UInt32  lut_wr_data_d1_7:16;
    };
}c3dlut_c3dlut_lut_wr_data_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  lut_wr_data_d2_7:16;
    };
}c3dlut_c3dlut_lut_wr_data_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_wr_data_d0_8:16;
        RBus_UInt32  lut_wr_data_d1_8:16;
    };
}c3dlut_c3dlut_lut_wr_data_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  lut_wr_data_d2_8:16;
    };
}c3dlut_c3dlut_lut_wr_data_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_wr_data_d0_9:16;
        RBus_UInt32  lut_wr_data_d1_9:16;
    };
}c3dlut_c3dlut_lut_wr_data_17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  lut_wr_data_d2_9:16;
    };
}c3dlut_c3dlut_lut_wr_data_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_rd_data_d0_1:16;
        RBus_UInt32  lut_rd_data_d1_1:16;
    };
}c3dlut_c3dlut_lut_rd_data_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  lut_rd_data_d2_1:16;
    };
}c3dlut_c3dlut_lut_rd_data_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_rd_data_d0_2:16;
        RBus_UInt32  lut_rd_data_d1_2:16;
    };
}c3dlut_c3dlut_lut_rd_data_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  lut_rd_data_d2_2:16;
    };
}c3dlut_c3dlut_lut_rd_data_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_rd_data_d0_3:16;
        RBus_UInt32  lut_rd_data_d1_3:16;
    };
}c3dlut_c3dlut_lut_rd_data_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  lut_rd_data_d2_3:16;
    };
}c3dlut_c3dlut_lut_rd_data_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_rd_data_d0_4:16;
        RBus_UInt32  lut_rd_data_d1_4:16;
    };
}c3dlut_c3dlut_lut_rd_data_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  lut_rd_data_d2_4:16;
    };
}c3dlut_c3dlut_lut_rd_data_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_rd_data_d0_5:16;
        RBus_UInt32  lut_rd_data_d1_5:16;
    };
}c3dlut_c3dlut_lut_rd_data_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  lut_rd_data_d2_5:16;
    };
}c3dlut_c3dlut_lut_rd_data_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_rd_data_d0_6:16;
        RBus_UInt32  lut_rd_data_d1_6:16;
    };
}c3dlut_c3dlut_lut_rd_data_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  lut_rd_data_d2_6:16;
    };
}c3dlut_c3dlut_lut_rd_data_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_rd_data_d0_7:16;
        RBus_UInt32  lut_rd_data_d1_7:16;
    };
}c3dlut_c3dlut_lut_rd_data_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  lut_rd_data_d2_7:16;
    };
}c3dlut_c3dlut_lut_rd_data_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_rd_data_d0_8:16;
        RBus_UInt32  lut_rd_data_d1_8:16;
    };
}c3dlut_c3dlut_lut_rd_data_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  lut_rd_data_d2_8:16;
    };
}c3dlut_c3dlut_lut_rd_data_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_rd_data_d0_9:16;
        RBus_UInt32  lut_rd_data_d1_9:16;
    };
}c3dlut_c3dlut_lut_rd_data_17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  lut_rd_data_d2_9:16;
    };
}c3dlut_c3dlut_lut_rd_data_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  d_3d_lut_ls:1;
        RBus_UInt32  d_3d_lut_rme:1;
        RBus_UInt32  d_3d_lut_rm:4;
        RBus_UInt32  d_3d_lut_test1:1;
        RBus_UInt32  res1:9;
        RBus_UInt32  d_3d_lut_bist_fail_7:1;
        RBus_UInt32  d_3d_lut_bist_fail_6:1;
        RBus_UInt32  d_3d_lut_bist_fail_5:1;
        RBus_UInt32  d_3d_lut_bist_fail_4:1;
        RBus_UInt32  d_3d_lut_bist_fail_3:1;
        RBus_UInt32  d_3d_lut_bist_fail_2:1;
        RBus_UInt32  d_3d_lut_bist_fail_1:1;
        RBus_UInt32  d_3d_lut_bist_fail_0:1;
        RBus_UInt32  d_3d_lut_drf_bist_fail_7:1;
        RBus_UInt32  d_3d_lut_drf_bist_fail_6:1;
        RBus_UInt32  d_3d_lut_drf_bist_fail_5:1;
        RBus_UInt32  d_3d_lut_drf_bist_fail_4:1;
        RBus_UInt32  d_3d_lut_drf_bist_fail_3:1;
        RBus_UInt32  d_3d_lut_drf_bist_fail_2:1;
        RBus_UInt32  d_3d_lut_drf_bist_fail_1:1;
        RBus_UInt32  d_3d_lut_drf_bist_fail_0:1;
    };
}c3dlut_c3dlut_lut_mbist_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1:32;
    };
}c3dlut_c3dlut_dummy1_RBUS;

#else //apply LITTLE_ENDIAN

//======C3DLUT register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  c3dlut_ctrl_main:1;
        RBus_UInt32  c3dlut_ctrl_sub:1;
        RBus_UInt32  c3dlut_ctrl_overlay:1;
        RBus_UInt32  rounding_en:1;
        RBus_UInt32  res1:28;
    };
}c3dlut_c3dlut_lut_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  db_apply_0:1;
        RBus_UInt32  db_en_0:1;
        RBus_UInt32  db_read_0:1;
        RBus_UInt32  res1:29;
    };
}c3dlut_c3dlut_db_ctl_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dmato3dlut_en:1;
        RBus_UInt32  res1:31;
    };
}c3dlut_dmato3dlut_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_rw_adr:8;
        RBus_UInt32  res1:18;
        RBus_UInt32  hw_fw_priority_opt:1;
        RBus_UInt32  lut_read_en:1;
        RBus_UInt32  lut_write_en:1;
        RBus_UInt32  lut_rw_sel:2;
        RBus_UInt32  res2:1;
    };
}c3dlut_c3dlut_lut_ctrl0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_wr_data_d1_1:16;
        RBus_UInt32  lut_wr_data_d0_1:16;
    };
}c3dlut_c3dlut_lut_wr_data_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_wr_data_d2_1:16;
        RBus_UInt32  res1:16;
    };
}c3dlut_c3dlut_lut_wr_data_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_wr_data_d1_2:16;
        RBus_UInt32  lut_wr_data_d0_2:16;
    };
}c3dlut_c3dlut_lut_wr_data_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_wr_data_d2_2:16;
        RBus_UInt32  res1:16;
    };
}c3dlut_c3dlut_lut_wr_data_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_wr_data_d1_3:16;
        RBus_UInt32  lut_wr_data_d0_3:16;
    };
}c3dlut_c3dlut_lut_wr_data_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_wr_data_d2_3:16;
        RBus_UInt32  res1:16;
    };
}c3dlut_c3dlut_lut_wr_data_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_wr_data_d1_4:16;
        RBus_UInt32  lut_wr_data_d0_4:16;
    };
}c3dlut_c3dlut_lut_wr_data_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_wr_data_d2_4:16;
        RBus_UInt32  res1:16;
    };
}c3dlut_c3dlut_lut_wr_data_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_wr_data_d1_5:16;
        RBus_UInt32  lut_wr_data_d0_5:16;
    };
}c3dlut_c3dlut_lut_wr_data_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_wr_data_d2_5:16;
        RBus_UInt32  res1:16;
    };
}c3dlut_c3dlut_lut_wr_data_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_wr_data_d1_6:16;
        RBus_UInt32  lut_wr_data_d0_6:16;
    };
}c3dlut_c3dlut_lut_wr_data_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_wr_data_d2_6:16;
        RBus_UInt32  res1:16;
    };
}c3dlut_c3dlut_lut_wr_data_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_wr_data_d1_7:16;
        RBus_UInt32  lut_wr_data_d0_7:16;
    };
}c3dlut_c3dlut_lut_wr_data_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_wr_data_d2_7:16;
        RBus_UInt32  res1:16;
    };
}c3dlut_c3dlut_lut_wr_data_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_wr_data_d1_8:16;
        RBus_UInt32  lut_wr_data_d0_8:16;
    };
}c3dlut_c3dlut_lut_wr_data_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_wr_data_d2_8:16;
        RBus_UInt32  res1:16;
    };
}c3dlut_c3dlut_lut_wr_data_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_wr_data_d1_9:16;
        RBus_UInt32  lut_wr_data_d0_9:16;
    };
}c3dlut_c3dlut_lut_wr_data_17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_wr_data_d2_9:16;
        RBus_UInt32  res1:16;
    };
}c3dlut_c3dlut_lut_wr_data_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_rd_data_d1_1:16;
        RBus_UInt32  lut_rd_data_d0_1:16;
    };
}c3dlut_c3dlut_lut_rd_data_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_rd_data_d2_1:16;
        RBus_UInt32  res1:16;
    };
}c3dlut_c3dlut_lut_rd_data_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_rd_data_d1_2:16;
        RBus_UInt32  lut_rd_data_d0_2:16;
    };
}c3dlut_c3dlut_lut_rd_data_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_rd_data_d2_2:16;
        RBus_UInt32  res1:16;
    };
}c3dlut_c3dlut_lut_rd_data_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_rd_data_d1_3:16;
        RBus_UInt32  lut_rd_data_d0_3:16;
    };
}c3dlut_c3dlut_lut_rd_data_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_rd_data_d2_3:16;
        RBus_UInt32  res1:16;
    };
}c3dlut_c3dlut_lut_rd_data_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_rd_data_d1_4:16;
        RBus_UInt32  lut_rd_data_d0_4:16;
    };
}c3dlut_c3dlut_lut_rd_data_7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_rd_data_d2_4:16;
        RBus_UInt32  res1:16;
    };
}c3dlut_c3dlut_lut_rd_data_8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_rd_data_d1_5:16;
        RBus_UInt32  lut_rd_data_d0_5:16;
    };
}c3dlut_c3dlut_lut_rd_data_9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_rd_data_d2_5:16;
        RBus_UInt32  res1:16;
    };
}c3dlut_c3dlut_lut_rd_data_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_rd_data_d1_6:16;
        RBus_UInt32  lut_rd_data_d0_6:16;
    };
}c3dlut_c3dlut_lut_rd_data_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_rd_data_d2_6:16;
        RBus_UInt32  res1:16;
    };
}c3dlut_c3dlut_lut_rd_data_12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_rd_data_d1_7:16;
        RBus_UInt32  lut_rd_data_d0_7:16;
    };
}c3dlut_c3dlut_lut_rd_data_13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_rd_data_d2_7:16;
        RBus_UInt32  res1:16;
    };
}c3dlut_c3dlut_lut_rd_data_14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_rd_data_d1_8:16;
        RBus_UInt32  lut_rd_data_d0_8:16;
    };
}c3dlut_c3dlut_lut_rd_data_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_rd_data_d2_8:16;
        RBus_UInt32  res1:16;
    };
}c3dlut_c3dlut_lut_rd_data_16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_rd_data_d1_9:16;
        RBus_UInt32  lut_rd_data_d0_9:16;
    };
}c3dlut_c3dlut_lut_rd_data_17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lut_rd_data_d2_9:16;
        RBus_UInt32  res1:16;
    };
}c3dlut_c3dlut_lut_rd_data_18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  d_3d_lut_drf_bist_fail_0:1;
        RBus_UInt32  d_3d_lut_drf_bist_fail_1:1;
        RBus_UInt32  d_3d_lut_drf_bist_fail_2:1;
        RBus_UInt32  d_3d_lut_drf_bist_fail_3:1;
        RBus_UInt32  d_3d_lut_drf_bist_fail_4:1;
        RBus_UInt32  d_3d_lut_drf_bist_fail_5:1;
        RBus_UInt32  d_3d_lut_drf_bist_fail_6:1;
        RBus_UInt32  d_3d_lut_drf_bist_fail_7:1;
        RBus_UInt32  d_3d_lut_bist_fail_0:1;
        RBus_UInt32  d_3d_lut_bist_fail_1:1;
        RBus_UInt32  d_3d_lut_bist_fail_2:1;
        RBus_UInt32  d_3d_lut_bist_fail_3:1;
        RBus_UInt32  d_3d_lut_bist_fail_4:1;
        RBus_UInt32  d_3d_lut_bist_fail_5:1;
        RBus_UInt32  d_3d_lut_bist_fail_6:1;
        RBus_UInt32  d_3d_lut_bist_fail_7:1;
        RBus_UInt32  res1:9;
        RBus_UInt32  d_3d_lut_test1:1;
        RBus_UInt32  d_3d_lut_rm:4;
        RBus_UInt32  d_3d_lut_rme:1;
        RBus_UInt32  d_3d_lut_ls:1;
    };
}c3dlut_c3dlut_lut_mbist_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1:32;
    };
}c3dlut_c3dlut_dummy1_RBUS;




#endif 


#endif 
