/**
* @file Mac7p-DesignSpec-EPI
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2019/11/22
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_EPI_REG_H_
#define _RBUS_EPI_REG_H_

#include "rbusTypes.h"



//  EPI Register Address



#define  EPI_EPI_PACKET_CTR1_0_0_VADDR                      	(0xb8026000)
#define  EPI_EPI_PACKET_CTRL_VADDR                          	(0xb8026060)
#define  EPI_EPI_CLOCK_CTRL0_VADDR                          	(0xb8026064)
#define  EPI_EPI_DGB_READ_VADDR                             	(0xb8026068)
#define  EPI_EPI_PORT_OPTION_CTRL_VADDR                     	(0xb802606c)
#define  EPI_EPI_CMPI_FRONT_VADDR                           	(0xb8026070)
#define  EPI_CMPI_DUMMY_COLOR_0_VADDR                       	(0xb8026080)
#define  EPI_CMPI_DUMMY_COLOR_1_VADDR                       	(0xb8026084)
#define  EPI_CMPI_DUMMY_COLOR_2_VADDR                       	(0xb8026088)
#define  EPI_CMPI_DUMMY_COLOR_3_VADDR                       	(0xb802608c)
#define  EPI_EPI_CRC_CTRL_0_VADDR                           	(0xb8026090)
#define  EPI_EPI_CRC_CTRL_1_VADDR                           	(0xb8026094)
#define  EPI_EPI_CRC_CTRL_2_VADDR                           	(0xb8026098)
#define  EPI_EPI_DATA_SRC_VADDR                             	(0xb802609c)
#define  EPI_EPI_PACKET_CTR1_INV_VADDR                      	(0xb80260a4)
#define  EPI_EPI_PACKET_CTR1_INV_TABLE_1_VADDR              	(0xb80260a8)
#define  EPI_EPI_PACKET_CTR1_INV_TABLE_2_VADDR              	(0xb80260ac)
#define  EPI_EPI_CMPI_RLC_VADDR                             	(0xb8026110)
#define  EPI_EPI_CMPI_VBT_VADDR                             	(0xb8026114)
#define  EPI_EPI_CMPI_VBT_OPT_VADDR                         	(0xb8026118)
#define  EPI_EPI_SCR_TCON_RST_VADDR                         	(0xb802617c)
#define  EPI_EPI_SCR8_CTRL_VADDR                            	(0xb8026180)
#define  EPI_EPI_SCR8_INI_VAL_VADDR                         	(0xb8026184)
#define  EPI_EPI_SCR10_CTRL_VADDR                           	(0xb8026188)
#define  EPI_EPI_SCR10_INI_VAL_VADDR                        	(0xb802618c)
#define  EPI_EPI_SCR8CM_CTRL_VADDR                          	(0xb8026190)
#define  EPI_EPI_SCR8CM_INI_VAL_VADDR                       	(0xb8026194)
#define  EPI_EPI_SCR10CM_CTRL_VADDR                         	(0xb8026198)
#define  EPI_EPI_SCR10CM_INI_VAL_VADDR                      	(0xb802619c)
#define  EPI_EPI_CMPI_PG_CTRL_VADDR                         	(0xb80261a0)
#define  EPI_EPI_CMPI_PG_CMD_ST_VADDR                       	(0xb80261a4)
#define  EPI_EPI_CMPI_PG_CMD_CMD1_VADDR                     	(0xb80261a8)
#define  EPI_EPI_CMPI_PG_CMD_CMD2_VADDR                     	(0xb80261ac)
#define  EPI_EPI_CMPI_PG_CMD_CMD3_VADDR                     	(0xb80261b0)
#define  EPI_EPI_CMPI_PG_CMD_CMD4_VADDR                     	(0xb8026300)
#define  EPI_EPI_CMPI_PG_CMD_CMD5_VADDR                     	(0xb8026304)
#define  EPI_EPI_CMPI_PG_START_VADDR                        	(0xb80261b4)
#define  EPI_EPI_CMPI_PG_DATA0_VADDR                        	(0xb80261b8)
#define  EPI_EPI_CMPI_PG_DATA1_VADDR                        	(0xb80261bc)
#define  EPI_EPI_CMPI_PG_DATA2_VADDR                        	(0xb80261c0)
#define  EPI_EPI_CMPI_PG_DATA3_VADDR                        	(0xb80261c4)
#define  EPI_EPI_CMPI_PG_DATA4_VADDR                        	(0xb80261c8)
#define  EPI_EPI_CMPI_PG_DATA5_VADDR                        	(0xb80261cc)
#define  EPI_EPI_CMPI_PG_DATA6_VADDR                        	(0xb80261d0)
#define  EPI_EPI_CMPI_PG_DATA7_VADDR                        	(0xb80261d4)
#define  EPI_EPI_CMPI_PG_DATA8_VADDR                        	(0xb80261d8)
#define  EPI_EPI_CMPI_PG_DATA9_VADDR                        	(0xb80261dc)
#define  EPI_EPI_CMPI_PG_DATA10_VADDR                       	(0xb8026308)
#define  EPI_EPI_CMPI_PG_DATA11_VADDR                       	(0xb802630c)
#define  EPI_EPI_CMPI_PG_DATA12_VADDR                       	(0xb8026310)
#define  EPI_EPI_CMPI_PG_DATA13_VADDR                       	(0xb8026314)
#define  EPI_EPI_CMPI_PG_DATA14_VADDR                       	(0xb8026318)
#define  EPI_EPI_CMPI_PG_DATA15_VADDR                       	(0xb802631c)
#define  EPI_EPI_CMPI_PG_DATA16_VADDR                       	(0xb8026320)
#define  EPI_EPI_CMPI_PG_DATA17_VADDR                       	(0xb8026324)
#define  EPI_EPI_CMPI_PG_DATA18_VADDR                       	(0xb8026328)
#define  EPI_EPI_CMPI_PG_DATA19_VADDR                       	(0xb802632c)
#define  EPI_EPI_CMPI_PG_DATA20_VADDR                       	(0xb8026330)
#define  EPI_EPI_CMPI_PG_DATA21_VADDR                       	(0xb8026334)
#define  EPI_EPI_CMPI_PG_DATA22_VADDR                       	(0xb8026338)
#define  EPI_EPI_CMPI_PG_DATA23_VADDR                       	(0xb802633c)
#define  EPI_EPI_CMPI_PG_DATA24_VADDR                       	(0xb8026340)
#define  EPI_EPI_CMPI_PG_DATA25_VADDR                       	(0xb8026344)
#define  EPI_EPI_CMPI_PG_DATA26_VADDR                       	(0xb8026348)
#define  EPI_EPI_CMPI_PG_DATA27_VADDR                       	(0xb802634c)
#define  EPI_EPI_CMPI_PG_DATA28_VADDR                       	(0xb8026350)
#define  EPI_EPI_CMPI_PG_DATA29_VADDR                       	(0xb8026354)
#define  EPI_EPI_CMPI_PG_DATA30_VADDR                       	(0xb8026358)
#define  EPI_EPI_CMPI_PG_DATA31_VADDR                       	(0xb802635c)
#define  EPI_EPI_CMPI_PG_DATA32_VADDR                       	(0xb8026360)
#define  EPI_EPI_CMPI_PG_DATA33_VADDR                       	(0xb8026364)
#define  EPI_EPI_CMPI_PG_DATA34_VADDR                       	(0xb8026368)
#define  EPI_EPI_CMPI_PG_DATA35_VADDR                       	(0xb802636c)
#define  EPI_EPI_CMPI_PG_DATA36_VADDR                       	(0xb8026370)
#define  EPI_EPI_CMPI_PG_DATA37_VADDR                       	(0xb8026374)
#define  EPI_EPI_CMPI_PG_DATA38_VADDR                       	(0xb8026378)
#define  EPI_EPI_CMPI_PG_DATA39_VADDR                       	(0xb802637c)
#define  EPI_EPI_CMPI_PG_DATA40_VADDR                       	(0xb8026400)
#define  EPI_EPI_CMPI_PG_DATA41_VADDR                       	(0xb8026404)
#define  EPI_EPI_CMPI_PG_DATA42_VADDR                       	(0xb8026408)
#define  EPI_EPI_CMPI_PG_DATA43_VADDR                       	(0xb802640c)
#define  EPI_EPI_CMPI_PG_DATA44_VADDR                       	(0xb8026410)
#define  EPI_EPI_CMPI_PG_DATA45_VADDR                       	(0xb8026414)
#define  EPI_EPI_CMPI_PG_DATA46_VADDR                       	(0xb8026418)
#define  EPI_EPI_CMPI_PG_DATA47_VADDR                       	(0xb802641c)
#define  EPI_EPI_CMPI_PG_DATA48_VADDR                       	(0xb8026420)
#define  EPI_EPI_CMPI_PG_DATA49_VADDR                       	(0xb8026424)
#define  EPI_EPI_CMPI_PG_DATA50_VADDR                       	(0xb8026428)
#define  EPI_EPI_CMPI_PG_DATA51_VADDR                       	(0xb802642c)
#define  EPI_EPI_CMPI_PG_DATA52_VADDR                       	(0xb8026430)
#define  EPI_EPI_CMPI_PG_DATA53_VADDR                       	(0xb8026434)
#define  EPI_EPI_CMPI_PG_DATA54_VADDR                       	(0xb8026438)
#define  EPI_EPI_CMPI_PG_DATA55_VADDR                       	(0xb802643c)
#define  EPI_EPI_CMPI_PG_DATA56_VADDR                       	(0xb8026440)
#define  EPI_EPI_CMPI_PG_DATA57_VADDR                       	(0xb8026444)
#define  EPI_EPI_CMPI_PG_DATA58_VADDR                       	(0xb8026448)
#define  EPI_EPI_CMPI_PG_DATA59_VADDR                       	(0xb802644c)
#define  EPI_EPI_CMPI_PG_END_VADDR                          	(0xb80261e0)
#define  EPI_EPI_LS_PORT_EN_VADDR                           	(0xb80261e4)
#define  EPI_EPI_FSM_SEL_VADDR                              	(0xb80261e8)
#define  EPI_EPI_DATA_PORT_EN_VADDR                         	(0xb80261ec)
#define  EPI_EPI_DEN_FALL_LOCA_VADDR                        	(0xb80263f8)
#define  EPI_EPI_LOCK_DEBOUNCE_CTL_VADDR                    	(0xb80263fc)
#define  EPI_EPI_DBG_REG_FLAG_VADDR                         	(0xb80261f0)
#define  EPI_EPI_DBG_REG_CTL_VADDR                          	(0xb80261f4)
#define  EPI_EPI_SOE_CONTROL_VADDR                          	(0xb80261fc)
#define  EPI_EPI_SOE_LINE0_LANE0_VADDR                      	(0xb8026200)
#define  EPI_EPI_SOE_LINE1_LANE0_VADDR                      	(0xb8026204)
#define  EPI_EPI_SOE_LINE2_LANE0_VADDR                      	(0xb8026208)
#define  EPI_EPI_SOE_LINE3_LANE0_VADDR                      	(0xb802620c)
#define  EPI_EPI_SOE_LINE0_LANE1_VADDR                      	(0xb8026210)
#define  EPI_EPI_SOE_LINE1_LANE1_VADDR                      	(0xb8026214)
#define  EPI_EPI_SOE_LINE2_LANE1_VADDR                      	(0xb8026218)
#define  EPI_EPI_SOE_LINE3_LANE1_VADDR                      	(0xb802621c)
#define  EPI_EPI_SOE_LINE0_LANE2_VADDR                      	(0xb8026220)
#define  EPI_EPI_SOE_LINE1_LANE2_VADDR                      	(0xb8026224)
#define  EPI_EPI_SOE_LINE2_LANE2_VADDR                      	(0xb8026228)
#define  EPI_EPI_SOE_LINE3_LANE2_VADDR                      	(0xb802622c)
#define  EPI_EPI_SOE_LINE0_LANE3_VADDR                      	(0xb8026230)
#define  EPI_EPI_SOE_LINE1_LANE3_VADDR                      	(0xb8026234)
#define  EPI_EPI_SOE_LINE2_LANE3_VADDR                      	(0xb8026238)
#define  EPI_EPI_SOE_LINE3_LANE3_VADDR                      	(0xb802623c)
#define  EPI_EPI_SOE_LINE0_LANE4_VADDR                      	(0xb8026240)
#define  EPI_EPI_SOE_LINE1_LANE4_VADDR                      	(0xb8026244)
#define  EPI_EPI_SOE_LINE2_LANE4_VADDR                      	(0xb8026248)
#define  EPI_EPI_SOE_LINE3_LANE4_VADDR                      	(0xb802624c)
#define  EPI_EPI_SOE_LINE0_LANE5_VADDR                      	(0xb8026250)
#define  EPI_EPI_SOE_LINE1_LANE5_VADDR                      	(0xb8026254)
#define  EPI_EPI_SOE_LINE2_LANE5_VADDR                      	(0xb8026258)
#define  EPI_EPI_SOE_LINE3_LANE5_VADDR                      	(0xb802625c)
#define  EPI_EPI_SOE_LINE0_LANE6_VADDR                      	(0xb8026260)
#define  EPI_EPI_SOE_LINE1_LANE6_VADDR                      	(0xb8026264)
#define  EPI_EPI_SOE_LINE2_LANE6_VADDR                      	(0xb8026268)
#define  EPI_EPI_SOE_LINE3_LANE6_VADDR                      	(0xb802626c)
#define  EPI_EPI_SOE_LINE0_LANE7_VADDR                      	(0xb8026270)
#define  EPI_EPI_SOE_LINE1_LANE7_VADDR                      	(0xb8026274)
#define  EPI_EPI_SOE_LINE2_LANE7_VADDR                      	(0xb8026278)
#define  EPI_EPI_SOE_LINE3_LANE7_VADDR                      	(0xb802627c)
#define  EPI_EPI_SOE_LINE0_LANE8_VADDR                      	(0xb8026280)
#define  EPI_EPI_SOE_LINE1_LANE8_VADDR                      	(0xb8026284)
#define  EPI_EPI_SOE_LINE2_LANE8_VADDR                      	(0xb8026288)
#define  EPI_EPI_SOE_LINE3_LANE8_VADDR                      	(0xb802628c)
#define  EPI_EPI_SOE_LINE0_LANE9_VADDR                      	(0xb8026290)
#define  EPI_EPI_SOE_LINE1_LANE9_VADDR                      	(0xb8026294)
#define  EPI_EPI_SOE_LINE2_LANE9_VADDR                      	(0xb8026298)
#define  EPI_EPI_SOE_LINE3_LANE9_VADDR                      	(0xb802629c)
#define  EPI_EPI_SOE_LINE0_LANE10_VADDR                     	(0xb80262a0)
#define  EPI_EPI_SOE_LINE1_LANE10_VADDR                     	(0xb80262a4)
#define  EPI_EPI_SOE_LINE2_LANE10_VADDR                     	(0xb80262a8)
#define  EPI_EPI_SOE_LINE3_LANE10_VADDR                     	(0xb80262ac)
#define  EPI_EPI_SOE_LINE0_LANE11_VADDR                     	(0xb80262b0)
#define  EPI_EPI_SOE_LINE1_LANE11_VADDR                     	(0xb80262b4)
#define  EPI_EPI_SOE_LINE2_LANE11_VADDR                     	(0xb80262b8)
#define  EPI_EPI_SOE_LINE3_LANE11_VADDR                     	(0xb80262bc)
#define  EPI_EPI_LANE_DST_MUX0_VADDR                        	(0xb8026380)
#define  EPI_EPI_LANE_DST_MUX1_VADDR                        	(0xb8026384)
#define  EPI_EPI_LANE_DST_MUX2_VADDR                        	(0xb8026388)
#define  EPI_EPI_LANE_DST_MUX3_VADDR                        	(0xb802638c)
#define  EPI_EPI_LANE_DST_MUX4_VADDR                        	(0xb8026390)
#define  EPI_EPI_LANE_DST_MUX5_VADDR                        	(0xb8026394)
#define  EPI_EPI_LANE_CST_MUX0_VADDR                        	(0xb8026398)
#define  EPI_EPI_LANE_CST_MUX1_VADDR                        	(0xb802639c)
#define  EPI_EPI_LANE_CST_MUX2_VADDR                        	(0xb80263a0)
#define  EPI_EPI_LANE_CST_MUX3_VADDR                        	(0xb80263a4)
#define  EPI_EPI_LANE_CST_MUX4_VADDR                        	(0xb80263a8)
#define  EPI_EPI_LANE_CST_MUX5_VADDR                        	(0xb80263ac)
#define  EPI_EPI_LANE_CTR1_MUX0_VADDR                       	(0xb80263b0)
#define  EPI_EPI_LANE_CTR1_MUX1_VADDR                       	(0xb80263b4)
#define  EPI_EPI_LANE_CTR1_MUX2_VADDR                       	(0xb80263b8)
#define  EPI_EPI_LANE_CTR1_MUX3_VADDR                       	(0xb80263bc)
#define  EPI_EPI_LANE_CTR1_MUX4_VADDR                       	(0xb80263c0)
#define  EPI_EPI_LANE_CTR1_MUX5_VADDR                       	(0xb80263c4)
#define  EPI_EPI_LANE_CTR2_MUX0_VADDR                       	(0xb80263c8)
#define  EPI_EPI_LANE_CTR2_MUX1_VADDR                       	(0xb80263cc)
#define  EPI_EPI_LANE_CTR2_MUX2_VADDR                       	(0xb80263d0)
#define  EPI_EPI_LANE_CTR2_MUX3_VADDR                       	(0xb80263d4)
#define  EPI_EPI_LANE_CTR2_MUX4_VADDR                       	(0xb80263d8)
#define  EPI_EPI_LANE_CTR2_MUX5_VADDR                       	(0xb80263dc)
#define  EPI_EPI_LANE_CTR3_MUX0_VADDR                       	(0xb80263e0)
#define  EPI_EPI_LANE_CTR3_MUX1_VADDR                       	(0xb80263e4)
#define  EPI_EPI_LANE_CTR3_MUX2_VADDR                       	(0xb80263e8)
#define  EPI_EPI_LANE_CTR3_MUX3_VADDR                       	(0xb80263ec)
#define  EPI_EPI_LANE_CTR3_MUX4_VADDR                       	(0xb80263f0)
#define  EPI_EPI_LANE_CTR3_MUX5_VADDR                       	(0xb80263f4)
#define  EPI_EPI_TCON_MUX_VADDR                             	(0xb8026500)
#define  EPI_EPI_TCON_MUX1_VADDR                            	(0xb8026504)
#define  EPI_EPI_TCON_MUX2_VADDR                            	(0xb8026508)
#define  EPI_EPI_TCON_MUX3_VADDR                            	(0xb802650c)
#define  EPI_EPI_DUMMY_REG_VADDR                            	(0xb8026510)
#define  EPI_EPI_HW_DUMMY0_REG_VADDR                        	(0xb8026514)
#define  EPI_EPI_HW_DUMMY1_REG_VADDR                        	(0xb8026518)
#define  EPI_EPI_HW_DUMMY2_REG_VADDR                        	(0xb802651c)
#define  EPI_EPI_HW_DUMMY3_REG_VADDR                        	(0xb8026520)
#define  EPI_EPI_CEDS_POL_REG_VADDR                         	(0xb8026524)
#define  EPI_EPI_LANE_DST_DATA_VADDR                        	(0xb8026528)
#define  EPI_EPI_LANE_CST_DATA_VADDR                        	(0xb802653c)
#define  EPI_EPI_LANE_CTR4_DATA_VADDR                       	(0xb8026a60)
#define  EPI_EPI_LANE_CTR5_DATA_VADDR                       	(0xb8026aa0)
#define  EPI_EPI_LANE0_CTR1_ODATA_VADDR                     	(0xb8026554)
#define  EPI_EPI_LANE1_CTR1_ODATA_VADDR                     	(0xb802655c)
#define  EPI_EPI_LANE2_CTR1_ODATA_VADDR                     	(0xb8026564)
#define  EPI_EPI_LANE3_CTR1_ODATA_VADDR                     	(0xb802656c)
#define  EPI_EPI_LANE4_CTR1_ODATA_VADDR                     	(0xb8026574)
#define  EPI_EPI_LANE5_CTR1_ODATA_VADDR                     	(0xb802657c)
#define  EPI_EPI_LANE6_CTR1_ODATA_VADDR                     	(0xb8026584)
#define  EPI_EPI_LANE7_CTR1_ODATA_VADDR                     	(0xb802658c)
#define  EPI_EPI_LANE8_CTR1_ODATA_VADDR                     	(0xb8026594)
#define  EPI_EPI_LANE9_CTR1_ODATA_VADDR                     	(0xb802659c)
#define  EPI_EPI_LANE10_CTR1_ODATA_VADDR                    	(0xb80265a4)
#define  EPI_EPI_LANE11_CTR1_ODATA_VADDR                    	(0xb80265ac)
#define  EPI_EPI_LANE0_CTR2_ODATA_VADDR                     	(0xb8026624)
#define  EPI_EPI_LANE1_CTR2_ODATA_VADDR                     	(0xb802662c)
#define  EPI_EPI_LANE2_CTR2_ODATA_VADDR                     	(0xb8026634)
#define  EPI_EPI_LANE3_CTR2_ODATA_VADDR                     	(0xb802663c)
#define  EPI_EPI_LANE4_CTR2_ODATA_VADDR                     	(0xb8026644)
#define  EPI_EPI_LANE5_CTR2_ODATA_VADDR                     	(0xb802664c)
#define  EPI_EPI_LANE6_CTR2_ODATA_VADDR                     	(0xb8026654)
#define  EPI_EPI_LANE7_CTR2_ODATA_VADDR                     	(0xb802665c)
#define  EPI_EPI_LANE8_CTR2_ODATA_VADDR                     	(0xb8026664)
#define  EPI_EPI_LANE9_CTR2_ODATA_VADDR                     	(0xb802666c)
#define  EPI_EPI_LANE10_CTR2_ODATA_VADDR                    	(0xb8026674)
#define  EPI_EPI_LANE11_CTR2_ODATA_VADDR                    	(0xb802667c)
#define  EPI_EPI_LANE0_CTR3_ODATA_VADDR                     	(0xb80266f4)
#define  EPI_EPI_LANE1_CTR3_ODATA_VADDR                     	(0xb80266fc)
#define  EPI_EPI_LANE2_CTR3_ODATA_VADDR                     	(0xb8026704)
#define  EPI_EPI_LANE3_CTR3_ODATA_VADDR                     	(0xb802670c)
#define  EPI_EPI_LANE4_CTR3_ODATA_VADDR                     	(0xb8026714)
#define  EPI_EPI_LANE5_CTR3_ODATA_VADDR                     	(0xb802671c)
#define  EPI_EPI_LANE6_CTR3_ODATA_VADDR                     	(0xb8026724)
#define  EPI_EPI_LANE7_CTR3_ODATA_VADDR                     	(0xb802672c)
#define  EPI_EPI_LANE8_CTR3_ODATA_VADDR                     	(0xb8026734)
#define  EPI_EPI_LANE9_CTR3_ODATA_VADDR                     	(0xb802673c)
#define  EPI_EPI_LANE10_CTR3_ODATA_VADDR                    	(0xb8026744)
#define  EPI_EPI_LANE11_CTR3_ODATA_VADDR                    	(0xb802674c)
#define  EPI_EPI_GPLUT_CONTROL_VADDR                        	(0xb8026450)
#define  EPI_EPI_GPLUT_LINE_01_VADDR                        	(0xb8026454)
#define  EPI_EPI_GPLUT_LINE_23_VADDR                        	(0xb8026458)
#define  EPI_EPI_GPLUT_LINE_45_VADDR                        	(0xb802645c)
#define  EPI_EPI_GPLUT_LINE_67_VADDR                        	(0xb8026460)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======EPI register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  phase2_preamble_num_0:4;
        RBus_UInt32  res2:12;
        RBus_UInt32  phase1_preamble_num_0:4;
    };
}epi_epi_packet_ctr1_0_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  epi_data_unfl:1;
        RBus_UInt32  epi_data_unfl_clr:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  epi_bit_mode:2;
        RBus_UInt32  res2:3;
        RBus_UInt32  data_mode_change:1;
        RBus_UInt32  res3:19;
        RBus_UInt32  lock_dmy_line_en:1;
        RBus_UInt32  epi_version:3;
    };
}epi_epi_packet_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  force_ctsfifo_rstn_epi:1;
        RBus_UInt32  ctrl5_en:1;
        RBus_UInt32  ctrl4_en:1;
        RBus_UInt32  epi_reset:1;
        RBus_UInt32  epi_lock_int_en:1;
        RBus_UInt32  ctrl_start_en:1;
        RBus_UInt32  ctrl3_en:1;
        RBus_UInt32  data_start_en:1;
        RBus_UInt32  res1:19;
        RBus_UInt32  lock_wait_vs_en:1;
        RBus_UInt32  hw_lock:1;
        RBus_UInt32  epi_lock:1;
        RBus_UInt32  epi_lock_sel:1;
        RBus_UInt32  epi_lock_change:1;
    };
}epi_epi_clock_ctrl0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  epi_tst_out:32;
    };
}epi_epi_dgb_read_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  two_pixel_mode:1;
        RBus_UInt32  ext_subpixel_mode:1;
        RBus_UInt32  res1:5;
        RBus_UInt32  port_num:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  epi_enable:1;
        RBus_UInt32  back_value:2;
        RBus_UInt32  front_value:2;
        RBus_UInt32  res3:2;
        RBus_UInt32  ceds_28s_soe_sel_en:1;
        RBus_UInt32  res4:9;
    };
}epi_epi_port_option_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  epi_dbg_en:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  epi_otpin_ver_sel:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  dummy18026070_24_20:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  epi_otpin_port_sel:5;
        RBus_UInt32  res4:1;
        RBus_UInt32  front_cmd:3;
        RBus_UInt32  res5:1;
        RBus_UInt32  front_data:3;
        RBus_UInt32  res6:1;
        RBus_UInt32  front_rlc:3;
    };
}epi_epi_cmpi_front_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  dummy_color_0:30;
    };
}epi_cmpi_dummy_color_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  dummy_color_1:30;
    };
}epi_cmpi_dummy_color_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  dummy_color_2:30;
    };
}epi_cmpi_dummy_color_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  dummy_color_3:30;
    };
}epi_cmpi_dummy_color_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_mismatch_count:12;
        RBus_UInt32  dummy18026090_19_16:4;
        RBus_UInt32  crc_port_sel:12;
        RBus_UInt32  dummy18026090_3:1;
        RBus_UInt32  crc_mismatch_clear:1;
        RBus_UInt32  crc_conti:1;
        RBus_UInt32  crc_start:1;
    };
}epi_epi_crc_ctrl_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_result:32;
    };
}epi_epi_crc_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_golden:32;
    };
}epi_epi_crc_ctrl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  epi_src_sel:1;
        RBus_UInt32  epi_src_data:30;
    };
}epi_epi_data_src_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:23;
        RBus_UInt32  inv_table_line_cycle:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  pod2_inv_phase_bypass:1;
    };
}epi_epi_packet_ctr1_inv_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  inv_line_1:4;
        RBus_UInt32  inv_line_2:4;
        RBus_UInt32  inv_line_3:4;
        RBus_UInt32  inv_line_4:4;
        RBus_UInt32  inv_line_5:4;
        RBus_UInt32  inv_line_6:4;
        RBus_UInt32  inv_line_7:4;
        RBus_UInt32  inv_line_8:4;
    };
}epi_epi_packet_ctr1_inv_table_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  inv_line_9:4;
        RBus_UInt32  inv_line_10:4;
        RBus_UInt32  inv_line_11:4;
        RBus_UInt32  inv_line_12:4;
        RBus_UInt32  inv_line_13:4;
        RBus_UInt32  inv_line_14:4;
        RBus_UInt32  inv_line_15:4;
        RBus_UInt32  inv_line_16:4;
    };
}epi_epi_packet_ctr1_inv_table_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  rlc_en:1;
    };
}epi_epi_cmpi_rlc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  clk_training1_sel:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  vbt_type_sel:3;
    };
}epi_epi_cmpi_vbt_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  dummy18026118_1:1;
        RBus_UInt32  between_s3_to_ct1:1;
    };
}epi_epi_cmpi_vbt_opt_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:23;
        RBus_UInt32  scr_every_line_rst:1;
        RBus_UInt32  scr_tcon_source2:4;
        RBus_UInt32  scr_tcon_source:4;
    };
}epi_epi_scr_tcon_rst_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  clk_edge_mode_sel:3;
        RBus_UInt32  res2:2;
        RBus_UInt32  clk_edge_scramble_en:1;
        RBus_UInt32  hvbp_scramble_en:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  ini_scr8_en:1;
        RBus_UInt32  scr8_enable:1;
    };
}epi_epi_scr8_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  scr8_ini_val:24;
    };
}epi_epi_scr8_ini_val_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  ini_scr10_en:1;
        RBus_UInt32  scr10_enable:1;
    };
}epi_epi_scr10_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  scr10_ini_val:20;
    };
}epi_epi_scr10_ini_val_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  scr8_cm_enable:1;
    };
}epi_epi_scr8cm_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  scr8_cm_ini_val:12;
    };
}epi_epi_scr8cm_ini_val_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  scr10_cm_enable:1;
    };
}epi_epi_scr10cm_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  scr10_cm_ini_val:10;
    };
}epi_epi_scr10cm_ini_val_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:15;
        RBus_UInt32  cmpi_pgamma_en:1;
        RBus_UInt32  dummy180261a0_15_12:4;
        RBus_UInt32  res2:2;
        RBus_UInt32  cmpi_back_color_sel:2;
        RBus_UInt32  res3:2;
        RBus_UInt32  cmpi_middle_color_sel:2;
        RBus_UInt32  res4:2;
        RBus_UInt32  cmpi_front_color_sel:2;
    };
}epi_epi_cmpi_pg_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_cmd_st:24;
    };
}epi_epi_cmpi_pg_cmd_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_cmd_cmd1:24;
    };
}epi_epi_cmpi_pg_cmd_cmd1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_cmd_cmd2:24;
    };
}epi_epi_cmpi_pg_cmd_cmd2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_cmd_cmd3:24;
    };
}epi_epi_cmpi_pg_cmd_cmd3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_cmd_cmd4:24;
    };
}epi_epi_cmpi_pg_cmd_cmd4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_cmd_cmd5:24;
    };
}epi_epi_cmpi_pg_cmd_cmd5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_start:24;
    };
}epi_epi_cmpi_pg_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data0:24;
    };
}epi_epi_cmpi_pg_data0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data1:24;
    };
}epi_epi_cmpi_pg_data1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data2:24;
    };
}epi_epi_cmpi_pg_data2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data3:24;
    };
}epi_epi_cmpi_pg_data3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data4:24;
    };
}epi_epi_cmpi_pg_data4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data5:24;
    };
}epi_epi_cmpi_pg_data5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data6:24;
    };
}epi_epi_cmpi_pg_data6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data7:24;
    };
}epi_epi_cmpi_pg_data7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data8:24;
    };
}epi_epi_cmpi_pg_data8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data9:24;
    };
}epi_epi_cmpi_pg_data9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data10:24;
    };
}epi_epi_cmpi_pg_data10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data11:24;
    };
}epi_epi_cmpi_pg_data11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data12:24;
    };
}epi_epi_cmpi_pg_data12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data13:24;
    };
}epi_epi_cmpi_pg_data13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data14:24;
    };
}epi_epi_cmpi_pg_data14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data15:24;
    };
}epi_epi_cmpi_pg_data15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data16:24;
    };
}epi_epi_cmpi_pg_data16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data17:24;
    };
}epi_epi_cmpi_pg_data17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data18:24;
    };
}epi_epi_cmpi_pg_data18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data19:24;
    };
}epi_epi_cmpi_pg_data19_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data20:24;
    };
}epi_epi_cmpi_pg_data20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data21:24;
    };
}epi_epi_cmpi_pg_data21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data22:24;
    };
}epi_epi_cmpi_pg_data22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data23:24;
    };
}epi_epi_cmpi_pg_data23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data24:24;
    };
}epi_epi_cmpi_pg_data24_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data25:24;
    };
}epi_epi_cmpi_pg_data25_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data26:24;
    };
}epi_epi_cmpi_pg_data26_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data27:24;
    };
}epi_epi_cmpi_pg_data27_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data28:24;
    };
}epi_epi_cmpi_pg_data28_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data29:24;
    };
}epi_epi_cmpi_pg_data29_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data30:24;
    };
}epi_epi_cmpi_pg_data30_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data31:24;
    };
}epi_epi_cmpi_pg_data31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data32:24;
    };
}epi_epi_cmpi_pg_data32_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data33:24;
    };
}epi_epi_cmpi_pg_data33_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data34:24;
    };
}epi_epi_cmpi_pg_data34_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data35:24;
    };
}epi_epi_cmpi_pg_data35_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data36:24;
    };
}epi_epi_cmpi_pg_data36_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data37:24;
    };
}epi_epi_cmpi_pg_data37_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data38:24;
    };
}epi_epi_cmpi_pg_data38_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_data39:24;
    };
}epi_epi_cmpi_pg_data39_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  cmpi_pg_data40:21;
    };
}epi_epi_cmpi_pg_data40_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  cmpi_pg_data41:21;
    };
}epi_epi_cmpi_pg_data41_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  cmpi_pg_data42:21;
    };
}epi_epi_cmpi_pg_data42_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  cmpi_pg_data43:21;
    };
}epi_epi_cmpi_pg_data43_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  cmpi_pg_data44:21;
    };
}epi_epi_cmpi_pg_data44_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  cmpi_pg_data45:21;
    };
}epi_epi_cmpi_pg_data45_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  cmpi_pg_data46:21;
    };
}epi_epi_cmpi_pg_data46_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  cmpi_pg_data47:21;
    };
}epi_epi_cmpi_pg_data47_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  cmpi_pg_data48:21;
    };
}epi_epi_cmpi_pg_data48_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  cmpi_pg_data49:21;
    };
}epi_epi_cmpi_pg_data49_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  cmpi_pg_data50:21;
    };
}epi_epi_cmpi_pg_data50_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  cmpi_pg_data51:21;
    };
}epi_epi_cmpi_pg_data51_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  cmpi_pg_data52:21;
    };
}epi_epi_cmpi_pg_data52_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  cmpi_pg_data53:21;
    };
}epi_epi_cmpi_pg_data53_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  cmpi_pg_data54:21;
    };
}epi_epi_cmpi_pg_data54_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  cmpi_pg_data55:21;
    };
}epi_epi_cmpi_pg_data55_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  cmpi_pg_data56:21;
    };
}epi_epi_cmpi_pg_data56_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  cmpi_pg_data57:21;
    };
}epi_epi_cmpi_pg_data57_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  cmpi_pg_data58:21;
    };
}epi_epi_cmpi_pg_data58_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  cmpi_pg_data59:21;
    };
}epi_epi_cmpi_pg_data59_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  cmpi_pg_end:24;
    };
}epi_epi_cmpi_pg_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  ls_port_en:12;
    };
}epi_epi_ls_port_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  ss_fsm_sel:12;
    };
}epi_epi_fsm_sel_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  constant_update_mode:1;
        RBus_UInt32  res1:19;
        RBus_UInt32  data_port_en:12;
    };
}epi_epi_data_port_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sw_cal:1;
        RBus_UInt32  res1:17;
        RBus_UInt32  sw_cal_value:14;
    };
}epi_epi_den_fall_loca_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  debounce_hi_window:12;
        RBus_UInt32  res2:3;
        RBus_UInt32  debounce_low_window:12;
        RBus_UInt32  debounce_en:1;
    };
}epi_epi_lock_debounce_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  hs_distance_flag:1;
        RBus_UInt32  hs_den_length_flag:1;
        RBus_UInt32  den_length_flag:1;
        RBus_UInt32  den_num_flag:1;
    };
}epi_epi_dbg_reg_flag_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  hs_distance_det_en:1;
        RBus_UInt32  hs_den_length_det_en:1;
        RBus_UInt32  den_length_det_en:1;
        RBus_UInt32  den_num_det_en:1;
    };
}epi_epi_dbg_reg_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  soe_table_line_cycle:2;
        RBus_UInt32  ctr12_ref_soe:2;
    };
}epi_epi_soe_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane0_soe0:30;
    };
}epi_epi_soe_line0_lane0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane0_soe1:30;
    };
}epi_epi_soe_line1_lane0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane0_soe2:30;
    };
}epi_epi_soe_line2_lane0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane0_soe3:30;
    };
}epi_epi_soe_line3_lane0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane1_soe0:30;
    };
}epi_epi_soe_line0_lane1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane1_soe1:30;
    };
}epi_epi_soe_line1_lane1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane1_soe2:30;
    };
}epi_epi_soe_line2_lane1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane1_soe3:30;
    };
}epi_epi_soe_line3_lane1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane2_soe0:30;
    };
}epi_epi_soe_line0_lane2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane2_soe1:30;
    };
}epi_epi_soe_line1_lane2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane2_soe2:30;
    };
}epi_epi_soe_line2_lane2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane2_soe3:30;
    };
}epi_epi_soe_line3_lane2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane3_soe0:30;
    };
}epi_epi_soe_line0_lane3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane3_soe1:30;
    };
}epi_epi_soe_line1_lane3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane3_soe2:30;
    };
}epi_epi_soe_line2_lane3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane3_soe3:30;
    };
}epi_epi_soe_line3_lane3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane4_soe0:30;
    };
}epi_epi_soe_line0_lane4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane4_soe1:30;
    };
}epi_epi_soe_line1_lane4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane4_soe2:30;
    };
}epi_epi_soe_line2_lane4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane4_soe3:30;
    };
}epi_epi_soe_line3_lane4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane5_soe0:30;
    };
}epi_epi_soe_line0_lane5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane5_soe1:30;
    };
}epi_epi_soe_line1_lane5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane5_soe2:30;
    };
}epi_epi_soe_line2_lane5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane5_soe3:30;
    };
}epi_epi_soe_line3_lane5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane6_soe0:30;
    };
}epi_epi_soe_line0_lane6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane6_soe1:30;
    };
}epi_epi_soe_line1_lane6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane6_soe2:30;
    };
}epi_epi_soe_line2_lane6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane6_soe3:30;
    };
}epi_epi_soe_line3_lane6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane7_soe0:30;
    };
}epi_epi_soe_line0_lane7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane7_soe1:30;
    };
}epi_epi_soe_line1_lane7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane7_soe2:30;
    };
}epi_epi_soe_line2_lane7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane7_soe3:30;
    };
}epi_epi_soe_line3_lane7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane8_soe0:30;
    };
}epi_epi_soe_line0_lane8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane8_soe1:30;
    };
}epi_epi_soe_line1_lane8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane8_soe2:30;
    };
}epi_epi_soe_line2_lane8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane8_soe3:30;
    };
}epi_epi_soe_line3_lane8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane9_soe0:30;
    };
}epi_epi_soe_line0_lane9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane9_soe1:30;
    };
}epi_epi_soe_line1_lane9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane9_soe2:30;
    };
}epi_epi_soe_line2_lane9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane9_soe3:30;
    };
}epi_epi_soe_line3_lane9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane10_soe0:30;
    };
}epi_epi_soe_line0_lane10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane10_soe1:30;
    };
}epi_epi_soe_line1_lane10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane10_soe2:30;
    };
}epi_epi_soe_line2_lane10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane10_soe3:30;
    };
}epi_epi_soe_line3_lane10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane11_soe0:30;
    };
}epi_epi_soe_line0_lane11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane11_soe1:30;
    };
}epi_epi_soe_line1_lane11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane11_soe2:30;
    };
}epi_epi_soe_line2_lane11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane11_soe3:30;
    };
}epi_epi_soe_line3_lane11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  lane_d_st_c4_mux_sel:4;
        RBus_UInt32  lane_d_st_c3_mux_sel:4;
        RBus_UInt32  lane_d_st_c2_mux_sel:4;
        RBus_UInt32  lane_d_st_c1_mux_sel:4;
        RBus_UInt32  lane_d_st_c0_mux_sel:4;
    };
}epi_epi_lane_dst_mux0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  lane_d_st_c9_mux_sel:4;
        RBus_UInt32  lane_d_st_c8_mux_sel:4;
        RBus_UInt32  lane_d_st_c7_mux_sel:4;
        RBus_UInt32  lane_d_st_c6_mux_sel:4;
        RBus_UInt32  lane_d_st_c5_mux_sel:4;
    };
}epi_epi_lane_dst_mux1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  lane_d_st_c14_mux_sel:4;
        RBus_UInt32  lane_d_st_c13_mux_sel:4;
        RBus_UInt32  lane_d_st_c12_mux_sel:4;
        RBus_UInt32  lane_d_st_c11_mux_sel:4;
        RBus_UInt32  lane_d_st_c10_mux_sel:4;
    };
}epi_epi_lane_dst_mux2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  lane_d_st_c19_mux_sel:4;
        RBus_UInt32  lane_d_st_c18_mux_sel:4;
        RBus_UInt32  lane_d_st_c17_mux_sel:4;
        RBus_UInt32  lane_d_st_c16_mux_sel:4;
        RBus_UInt32  lane_d_st_c15_mux_sel:4;
    };
}epi_epi_lane_dst_mux3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  lane_d_st_c24_mux_sel:4;
        RBus_UInt32  lane_d_st_c23_mux_sel:4;
        RBus_UInt32  lane_d_st_c22_mux_sel:4;
        RBus_UInt32  lane_d_st_c21_mux_sel:4;
        RBus_UInt32  lane_d_st_c20_mux_sel:4;
    };
}epi_epi_lane_dst_mux4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  lane_d_st_c29_mux_sel:4;
        RBus_UInt32  lane_d_st_c28_mux_sel:4;
        RBus_UInt32  lane_d_st_c27_mux_sel:4;
        RBus_UInt32  lane_d_st_c26_mux_sel:4;
        RBus_UInt32  lane_d_st_c25_mux_sel:4;
    };
}epi_epi_lane_dst_mux5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  lane_c_st_c4_mux_sel:4;
        RBus_UInt32  lane_c_st_c3_mux_sel:4;
        RBus_UInt32  lane_c_st_c2_mux_sel:4;
        RBus_UInt32  lane_c_st_c1_mux_sel:4;
        RBus_UInt32  lane_c_st_c0_mux_sel:4;
    };
}epi_epi_lane_cst_mux0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  lane_c_st_c9_mux_sel:4;
        RBus_UInt32  lane_c_st_c8_mux_sel:4;
        RBus_UInt32  lane_c_st_c7_mux_sel:4;
        RBus_UInt32  lane_c_st_c6_mux_sel:4;
        RBus_UInt32  lane_c_st_c5_mux_sel:4;
    };
}epi_epi_lane_cst_mux1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  lane_c_st_c14_mux_sel:4;
        RBus_UInt32  lane_c_st_c13_mux_sel:4;
        RBus_UInt32  lane_c_st_c12_mux_sel:4;
        RBus_UInt32  lane_c_st_c11_mux_sel:4;
        RBus_UInt32  lane_c_st_c10_mux_sel:4;
    };
}epi_epi_lane_cst_mux2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  lane_c_st_c19_mux_sel:4;
        RBus_UInt32  lane_c_st_c18_mux_sel:4;
        RBus_UInt32  lane_c_st_c17_mux_sel:4;
        RBus_UInt32  lane_c_st_c16_mux_sel:4;
        RBus_UInt32  lane_c_st_c15_mux_sel:4;
    };
}epi_epi_lane_cst_mux3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  lane_c_st_c24_mux_sel:4;
        RBus_UInt32  lane_c_st_c23_mux_sel:4;
        RBus_UInt32  lane_c_st_c22_mux_sel:4;
        RBus_UInt32  lane_c_st_c21_mux_sel:4;
        RBus_UInt32  lane_c_st_c20_mux_sel:4;
    };
}epi_epi_lane_cst_mux4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  lane_c_st_c29_mux_sel:4;
        RBus_UInt32  lane_c_st_c28_mux_sel:4;
        RBus_UInt32  lane_c_st_c27_mux_sel:4;
        RBus_UInt32  lane_c_st_c26_mux_sel:4;
        RBus_UInt32  lane_c_st_c25_mux_sel:4;
    };
}epi_epi_lane_cst_mux5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  lane_ctr1_c4_mux_sel:4;
        RBus_UInt32  lane_ctr1_c3_mux_sel:4;
        RBus_UInt32  lane_ctr1_c2_mux_sel:4;
        RBus_UInt32  lane_ctr1_c1_mux_sel:4;
        RBus_UInt32  lane_ctr1_c0_mux_sel:4;
    };
}epi_epi_lane_ctr1_mux0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  lane_ctr1_c9_mux_sel:4;
        RBus_UInt32  lane_ctr1_c8_mux_sel:4;
        RBus_UInt32  lane_ctr1_c7_mux_sel:4;
        RBus_UInt32  lane_ctr1_c6_mux_sel:4;
        RBus_UInt32  lane_ctr1_c5_mux_sel:4;
    };
}epi_epi_lane_ctr1_mux1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  lane_ctr1_c14_mux_sel:4;
        RBus_UInt32  lane_ctr1_c13_mux_sel:4;
        RBus_UInt32  lane_ctr1_c12_mux_sel:4;
        RBus_UInt32  lane_ctr1_c11_mux_sel:4;
        RBus_UInt32  lane_ctr1_c10_mux_sel:4;
    };
}epi_epi_lane_ctr1_mux2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  lane_ctr1_c19_mux_sel:4;
        RBus_UInt32  lane_ctr1_c18_mux_sel:4;
        RBus_UInt32  lane_ctr1_c17_mux_sel:4;
        RBus_UInt32  lane_ctr1_c16_mux_sel:4;
        RBus_UInt32  lane_ctr1_c15_mux_sel:4;
    };
}epi_epi_lane_ctr1_mux3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  lane_ctr1_c24_mux_sel:4;
        RBus_UInt32  lane_ctr1_c23_mux_sel:4;
        RBus_UInt32  lane_ctr1_c22_mux_sel:4;
        RBus_UInt32  lane_ctr1_c21_mux_sel:4;
        RBus_UInt32  lane_ctr1_c20_mux_sel:4;
    };
}epi_epi_lane_ctr1_mux4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  lane_ctr1_c29_mux_sel:4;
        RBus_UInt32  lane_ctr1_c28_mux_sel:4;
        RBus_UInt32  lane_ctr1_c27_mux_sel:4;
        RBus_UInt32  lane_ctr1_c26_mux_sel:4;
        RBus_UInt32  lane_ctr1_c25_mux_sel:4;
    };
}epi_epi_lane_ctr1_mux5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  lane_ctr2_c4_mux_sel:4;
        RBus_UInt32  lane_ctr2_c3_mux_sel:4;
        RBus_UInt32  lane_ctr2_c2_mux_sel:4;
        RBus_UInt32  lane_ctr2_c1_mux_sel:4;
        RBus_UInt32  lane_ctr2_c0_mux_sel:4;
    };
}epi_epi_lane_ctr2_mux0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  lane_ctr2_c9_mux_sel:4;
        RBus_UInt32  lane_ctr2_c8_mux_sel:4;
        RBus_UInt32  lane_ctr2_c7_mux_sel:4;
        RBus_UInt32  lane_ctr2_c6_mux_sel:4;
        RBus_UInt32  lane_ctr2_c5_mux_sel:4;
    };
}epi_epi_lane_ctr2_mux1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  lane_ctr2_c14_mux_sel:4;
        RBus_UInt32  lane_ctr2_c13_mux_sel:4;
        RBus_UInt32  lane_ctr2_c12_mux_sel:4;
        RBus_UInt32  lane_ctr2_c11_mux_sel:4;
        RBus_UInt32  lane_ctr2_c10_mux_sel:4;
    };
}epi_epi_lane_ctr2_mux2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  lane_ctr2_c19_mux_sel:4;
        RBus_UInt32  lane_ctr2_c18_mux_sel:4;
        RBus_UInt32  lane_ctr2_c17_mux_sel:4;
        RBus_UInt32  lane_ctr2_c16_mux_sel:4;
        RBus_UInt32  lane_ctr2_c15_mux_sel:4;
    };
}epi_epi_lane_ctr2_mux3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  lane_ctr2_c24_mux_sel:4;
        RBus_UInt32  lane_ctr2_c23_mux_sel:4;
        RBus_UInt32  lane_ctr2_c22_mux_sel:4;
        RBus_UInt32  lane_ctr2_c21_mux_sel:4;
        RBus_UInt32  lane_ctr2_c20_mux_sel:4;
    };
}epi_epi_lane_ctr2_mux4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  lane_ctr2_c29_mux_sel:4;
        RBus_UInt32  lane_ctr2_c28_mux_sel:4;
        RBus_UInt32  lane_ctr2_c27_mux_sel:4;
        RBus_UInt32  lane_ctr2_c26_mux_sel:4;
        RBus_UInt32  lane_ctr2_c25_mux_sel:4;
    };
}epi_epi_lane_ctr2_mux5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  lane_ctr3_c4_mux_sel:4;
        RBus_UInt32  lane_ctr3_c3_mux_sel:4;
        RBus_UInt32  lane_ctr3_c2_mux_sel:4;
        RBus_UInt32  lane_ctr3_c1_mux_sel:4;
        RBus_UInt32  lane_ctr3_c0_mux_sel:4;
    };
}epi_epi_lane_ctr3_mux0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  lane_ctr3_c9_mux_sel:4;
        RBus_UInt32  lane_ctr3_c8_mux_sel:4;
        RBus_UInt32  lane_ctr3_c7_mux_sel:4;
        RBus_UInt32  lane_ctr3_c6_mux_sel:4;
        RBus_UInt32  lane_ctr3_c5_mux_sel:4;
    };
}epi_epi_lane_ctr3_mux1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  lane_ctr3_c14_mux_sel:4;
        RBus_UInt32  lane_ctr3_c13_mux_sel:4;
        RBus_UInt32  lane_ctr3_c12_mux_sel:4;
        RBus_UInt32  lane_ctr3_c11_mux_sel:4;
        RBus_UInt32  lane_ctr3_c10_mux_sel:4;
    };
}epi_epi_lane_ctr3_mux2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  lane_ctr3_c19_mux_sel:4;
        RBus_UInt32  lane_ctr3_c18_mux_sel:4;
        RBus_UInt32  lane_ctr3_c17_mux_sel:4;
        RBus_UInt32  lane_ctr3_c16_mux_sel:4;
        RBus_UInt32  lane_ctr3_c15_mux_sel:4;
    };
}epi_epi_lane_ctr3_mux3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  lane_ctr3_c24_mux_sel:4;
        RBus_UInt32  lane_ctr3_c23_mux_sel:4;
        RBus_UInt32  lane_ctr3_c22_mux_sel:4;
        RBus_UInt32  lane_ctr3_c21_mux_sel:4;
        RBus_UInt32  lane_ctr3_c20_mux_sel:4;
    };
}epi_epi_lane_ctr3_mux4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  lane_ctr3_c29_mux_sel:4;
        RBus_UInt32  lane_ctr3_c28_mux_sel:4;
        RBus_UInt32  lane_ctr3_c27_mux_sel:4;
        RBus_UInt32  lane_ctr3_c26_mux_sel:4;
        RBus_UInt32  lane_ctr3_c25_mux_sel:4;
    };
}epi_epi_lane_ctr3_mux5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:10;
        RBus_UInt32  tcon_c_sel:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  tcon_b_sel:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  tcon_a_sel:6;
    };
}epi_epi_tcon_mux_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:10;
        RBus_UInt32  tcon_f_sel:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  tcon_e_sel:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  tcon_d_sel:6;
    };
}epi_epi_tcon_mux1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:10;
        RBus_UInt32  tcon_i_sel:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  tcon_h_sel:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  tcon_g_sel:6;
    };
}epi_epi_tcon_mux2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:18;
        RBus_UInt32  tcon_k_sel:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  tcon_j_sel:6;
    };
}epi_epi_tcon_mux3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy18026510_31_0:32;
    };
}epi_epi_dummy_reg_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy_hw0:32;
    };
}epi_epi_hw_dummy0_reg_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy_hw1:32;
    };
}epi_epi_hw_dummy1_reg_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy_hw2:32;
    };
}epi_epi_hw_dummy2_reg_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy_hw3:32;
    };
}epi_epi_hw_dummy3_reg_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  ceds_pol2_inv:12;
        RBus_UInt32  res2:4;
        RBus_UInt32  ceds_pol_inv:12;
    };
}epi_epi_ceds_pol_reg_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  d_st:30;
    };
}epi_epi_lane_dst_data_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  c_st:30;
    };
}epi_epi_lane_cst_data_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane_ctr4:30;
    };
}epi_epi_lane_ctr4_data_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane_ctr5:30;
    };
}epi_epi_lane_ctr5_data_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane0_ctr1_odd:30;
    };
}epi_epi_lane0_ctr1_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane1_ctr1_odd:30;
    };
}epi_epi_lane1_ctr1_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane2_ctr1_odd:30;
    };
}epi_epi_lane2_ctr1_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane3_ctr1_odd:30;
    };
}epi_epi_lane3_ctr1_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane4_ctr1_odd:30;
    };
}epi_epi_lane4_ctr1_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane5_ctr1_odd:30;
    };
}epi_epi_lane5_ctr1_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane6_ctr1_odd:30;
    };
}epi_epi_lane6_ctr1_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane7_ctr1_odd:30;
    };
}epi_epi_lane7_ctr1_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane8_ctr1_odd:30;
    };
}epi_epi_lane8_ctr1_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane9_ctr1_odd:30;
    };
}epi_epi_lane9_ctr1_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane10_ctr1_odd:30;
    };
}epi_epi_lane10_ctr1_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane11_ctr1_odd:30;
    };
}epi_epi_lane11_ctr1_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane0_ctr2_odd:30;
    };
}epi_epi_lane0_ctr2_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane1_ctr2_odd:30;
    };
}epi_epi_lane1_ctr2_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane2_ctr2_odd:30;
    };
}epi_epi_lane2_ctr2_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane3_ctr2_odd:30;
    };
}epi_epi_lane3_ctr2_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane4_ctr2_odd:30;
    };
}epi_epi_lane4_ctr2_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane5_ctr2_odd:30;
    };
}epi_epi_lane5_ctr2_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane6_ctr2_odd:30;
    };
}epi_epi_lane6_ctr2_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane7_ctr2_odd:30;
    };
}epi_epi_lane7_ctr2_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane8_ctr2_odd:30;
    };
}epi_epi_lane8_ctr2_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane9_ctr2_odd:30;
    };
}epi_epi_lane9_ctr2_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane10_ctr2_odd:30;
    };
}epi_epi_lane10_ctr2_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane11_ctr2_odd:30;
    };
}epi_epi_lane11_ctr2_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane0_ctr3_odd:30;
    };
}epi_epi_lane0_ctr3_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane1_ctr3_odd:30;
    };
}epi_epi_lane1_ctr3_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane2_ctr3_odd:30;
    };
}epi_epi_lane2_ctr3_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane3_ctr3_odd:30;
    };
}epi_epi_lane3_ctr3_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane4_ctr3_odd:30;
    };
}epi_epi_lane4_ctr3_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane5_ctr3_odd:30;
    };
}epi_epi_lane5_ctr3_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane6_ctr3_odd:30;
    };
}epi_epi_lane6_ctr3_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane7_ctr3_odd:30;
    };
}epi_epi_lane7_ctr3_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane8_ctr3_odd:30;
    };
}epi_epi_lane8_ctr3_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane9_ctr3_odd:30;
    };
}epi_epi_lane9_ctr3_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane10_ctr3_odd:30;
    };
}epi_epi_lane10_ctr3_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  lane11_ctr3_odd:30;
    };
}epi_epi_lane11_ctr3_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  gp_table_line_cycle:4;
    };
}epi_epi_gplut_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  gp_table_line_1:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  gp_table_line_0:5;
    };
}epi_epi_gplut_line_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  gp_table_line_3:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  gp_table_line_2:5;
    };
}epi_epi_gplut_line_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  gp_table_line_5:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  gp_table_line_4:5;
    };
}epi_epi_gplut_line_45_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  gp_table_line_7:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  gp_table_line_6:5;
    };
}epi_epi_gplut_line_67_RBUS;

#else //apply LITTLE_ENDIAN

//======EPI register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  phase1_preamble_num_0:4;
        RBus_UInt32  res1:12;
        RBus_UInt32  phase2_preamble_num_0:4;
        RBus_UInt32  res2:12;
    };
}epi_epi_packet_ctr1_0_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  epi_version:3;
        RBus_UInt32  lock_dmy_line_en:1;
        RBus_UInt32  res1:19;
        RBus_UInt32  data_mode_change:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  epi_bit_mode:2;
        RBus_UInt32  res3:1;
        RBus_UInt32  epi_data_unfl_clr:1;
        RBus_UInt32  epi_data_unfl:1;
    };
}epi_epi_packet_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  epi_lock_change:1;
        RBus_UInt32  epi_lock_sel:1;
        RBus_UInt32  epi_lock:1;
        RBus_UInt32  hw_lock:1;
        RBus_UInt32  lock_wait_vs_en:1;
        RBus_UInt32  res1:19;
        RBus_UInt32  data_start_en:1;
        RBus_UInt32  ctrl3_en:1;
        RBus_UInt32  ctrl_start_en:1;
        RBus_UInt32  epi_lock_int_en:1;
        RBus_UInt32  epi_reset:1;
        RBus_UInt32  ctrl4_en:1;
        RBus_UInt32  ctrl5_en:1;
        RBus_UInt32  force_ctsfifo_rstn_epi:1;
    };
}epi_epi_clock_ctrl0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  epi_tst_out:32;
    };
}epi_epi_dgb_read_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  ceds_28s_soe_sel_en:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  front_value:2;
        RBus_UInt32  back_value:2;
        RBus_UInt32  epi_enable:1;
        RBus_UInt32  res3:3;
        RBus_UInt32  port_num:5;
        RBus_UInt32  res4:5;
        RBus_UInt32  ext_subpixel_mode:1;
        RBus_UInt32  two_pixel_mode:1;
    };
}epi_epi_port_option_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  front_rlc:3;
        RBus_UInt32  res1:1;
        RBus_UInt32  front_data:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  front_cmd:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  epi_otpin_port_sel:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  dummy18026070_24_20:5;
        RBus_UInt32  res5:3;
        RBus_UInt32  epi_otpin_ver_sel:1;
        RBus_UInt32  res6:2;
        RBus_UInt32  epi_dbg_en:1;
    };
}epi_epi_cmpi_front_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy_color_0:30;
        RBus_UInt32  res1:2;
    };
}epi_cmpi_dummy_color_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy_color_1:30;
        RBus_UInt32  res1:2;
    };
}epi_cmpi_dummy_color_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy_color_2:30;
        RBus_UInt32  res1:2;
    };
}epi_cmpi_dummy_color_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy_color_3:30;
        RBus_UInt32  res1:2;
    };
}epi_cmpi_dummy_color_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_start:1;
        RBus_UInt32  crc_conti:1;
        RBus_UInt32  crc_mismatch_clear:1;
        RBus_UInt32  dummy18026090_3:1;
        RBus_UInt32  crc_port_sel:12;
        RBus_UInt32  dummy18026090_19_16:4;
        RBus_UInt32  crc_mismatch_count:12;
    };
}epi_epi_crc_ctrl_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_result:32;
    };
}epi_epi_crc_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_golden:32;
    };
}epi_epi_crc_ctrl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  epi_src_data:30;
        RBus_UInt32  epi_src_sel:1;
        RBus_UInt32  res1:1;
    };
}epi_epi_data_src_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pod2_inv_phase_bypass:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  inv_table_line_cycle:5;
        RBus_UInt32  res2:23;
    };
}epi_epi_packet_ctr1_inv_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  inv_line_8:4;
        RBus_UInt32  inv_line_7:4;
        RBus_UInt32  inv_line_6:4;
        RBus_UInt32  inv_line_5:4;
        RBus_UInt32  inv_line_4:4;
        RBus_UInt32  inv_line_3:4;
        RBus_UInt32  inv_line_2:4;
        RBus_UInt32  inv_line_1:4;
    };
}epi_epi_packet_ctr1_inv_table_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  inv_line_16:4;
        RBus_UInt32  inv_line_15:4;
        RBus_UInt32  inv_line_14:4;
        RBus_UInt32  inv_line_13:4;
        RBus_UInt32  inv_line_12:4;
        RBus_UInt32  inv_line_11:4;
        RBus_UInt32  inv_line_10:4;
        RBus_UInt32  inv_line_9:4;
    };
}epi_epi_packet_ctr1_inv_table_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rlc_en:1;
        RBus_UInt32  res1:31;
    };
}epi_epi_cmpi_rlc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vbt_type_sel:3;
        RBus_UInt32  res1:1;
        RBus_UInt32  clk_training1_sel:1;
        RBus_UInt32  res2:27;
    };
}epi_epi_cmpi_vbt_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  between_s3_to_ct1:1;
        RBus_UInt32  dummy18026118_1:1;
        RBus_UInt32  res1:30;
    };
}epi_epi_cmpi_vbt_opt_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  scr_tcon_source:4;
        RBus_UInt32  scr_tcon_source2:4;
        RBus_UInt32  scr_every_line_rst:1;
        RBus_UInt32  res1:23;
    };
}epi_epi_scr_tcon_rst_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  scr8_enable:1;
        RBus_UInt32  ini_scr8_en:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  hvbp_scramble_en:1;
        RBus_UInt32  clk_edge_scramble_en:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  clk_edge_mode_sel:3;
        RBus_UInt32  res3:21;
    };
}epi_epi_scr8_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  scr8_ini_val:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_scr8_ini_val_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  scr10_enable:1;
        RBus_UInt32  ini_scr10_en:1;
        RBus_UInt32  res1:30;
    };
}epi_epi_scr10_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  scr10_ini_val:20;
        RBus_UInt32  res1:12;
    };
}epi_epi_scr10_ini_val_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  scr8_cm_enable:1;
        RBus_UInt32  res1:31;
    };
}epi_epi_scr8cm_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  scr8_cm_ini_val:12;
        RBus_UInt32  res1:20;
    };
}epi_epi_scr8cm_ini_val_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  scr10_cm_enable:1;
        RBus_UInt32  res1:31;
    };
}epi_epi_scr10cm_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  scr10_cm_ini_val:10;
        RBus_UInt32  res1:22;
    };
}epi_epi_scr10cm_ini_val_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_front_color_sel:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  cmpi_middle_color_sel:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  cmpi_back_color_sel:2;
        RBus_UInt32  res3:2;
        RBus_UInt32  dummy180261a0_15_12:4;
        RBus_UInt32  cmpi_pgamma_en:1;
        RBus_UInt32  res4:15;
    };
}epi_epi_cmpi_pg_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_cmd_st:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_cmd_st_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_cmd_cmd1:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_cmd_cmd1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_cmd_cmd2:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_cmd_cmd2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_cmd_cmd3:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_cmd_cmd3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_cmd_cmd4:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_cmd_cmd4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_cmd_cmd5:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_cmd_cmd5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_start:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_start_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data0:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data1:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data2:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data3:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data4:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data5:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data6:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data7:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data8:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data9:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data10:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data11:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data12:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data13:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data14:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data15:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data16:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data17:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data18:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data19:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data19_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data20:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data21:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data22:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data23:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data24:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data24_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data25:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data25_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data26:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data26_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data27:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data27_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data28:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data28_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data29:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data29_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data30:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data30_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data31:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data32:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data32_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data33:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data33_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data34:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data34_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data35:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data35_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data36:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data36_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data37:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data37_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data38:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data38_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data39:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_data39_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data40:21;
        RBus_UInt32  res1:11;
    };
}epi_epi_cmpi_pg_data40_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data41:21;
        RBus_UInt32  res1:11;
    };
}epi_epi_cmpi_pg_data41_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data42:21;
        RBus_UInt32  res1:11;
    };
}epi_epi_cmpi_pg_data42_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data43:21;
        RBus_UInt32  res1:11;
    };
}epi_epi_cmpi_pg_data43_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data44:21;
        RBus_UInt32  res1:11;
    };
}epi_epi_cmpi_pg_data44_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data45:21;
        RBus_UInt32  res1:11;
    };
}epi_epi_cmpi_pg_data45_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data46:21;
        RBus_UInt32  res1:11;
    };
}epi_epi_cmpi_pg_data46_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data47:21;
        RBus_UInt32  res1:11;
    };
}epi_epi_cmpi_pg_data47_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data48:21;
        RBus_UInt32  res1:11;
    };
}epi_epi_cmpi_pg_data48_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data49:21;
        RBus_UInt32  res1:11;
    };
}epi_epi_cmpi_pg_data49_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data50:21;
        RBus_UInt32  res1:11;
    };
}epi_epi_cmpi_pg_data50_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data51:21;
        RBus_UInt32  res1:11;
    };
}epi_epi_cmpi_pg_data51_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data52:21;
        RBus_UInt32  res1:11;
    };
}epi_epi_cmpi_pg_data52_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data53:21;
        RBus_UInt32  res1:11;
    };
}epi_epi_cmpi_pg_data53_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data54:21;
        RBus_UInt32  res1:11;
    };
}epi_epi_cmpi_pg_data54_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data55:21;
        RBus_UInt32  res1:11;
    };
}epi_epi_cmpi_pg_data55_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data56:21;
        RBus_UInt32  res1:11;
    };
}epi_epi_cmpi_pg_data56_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data57:21;
        RBus_UInt32  res1:11;
    };
}epi_epi_cmpi_pg_data57_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data58:21;
        RBus_UInt32  res1:11;
    };
}epi_epi_cmpi_pg_data58_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_data59:21;
        RBus_UInt32  res1:11;
    };
}epi_epi_cmpi_pg_data59_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmpi_pg_end:24;
        RBus_UInt32  res1:8;
    };
}epi_epi_cmpi_pg_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ls_port_en:12;
        RBus_UInt32  res1:20;
    };
}epi_epi_ls_port_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ss_fsm_sel:12;
        RBus_UInt32  res1:20;
    };
}epi_epi_fsm_sel_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  data_port_en:12;
        RBus_UInt32  res1:19;
        RBus_UInt32  constant_update_mode:1;
    };
}epi_epi_data_port_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sw_cal_value:14;
        RBus_UInt32  res1:17;
        RBus_UInt32  sw_cal:1;
    };
}epi_epi_den_fall_loca_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  debounce_en:1;
        RBus_UInt32  debounce_low_window:12;
        RBus_UInt32  res1:3;
        RBus_UInt32  debounce_hi_window:12;
        RBus_UInt32  res2:4;
    };
}epi_epi_lock_debounce_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  den_num_flag:1;
        RBus_UInt32  den_length_flag:1;
        RBus_UInt32  hs_den_length_flag:1;
        RBus_UInt32  hs_distance_flag:1;
        RBus_UInt32  res1:28;
    };
}epi_epi_dbg_reg_flag_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  den_num_det_en:1;
        RBus_UInt32  den_length_det_en:1;
        RBus_UInt32  hs_den_length_det_en:1;
        RBus_UInt32  hs_distance_det_en:1;
        RBus_UInt32  res1:28;
    };
}epi_epi_dbg_reg_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctr12_ref_soe:2;
        RBus_UInt32  soe_table_line_cycle:2;
        RBus_UInt32  res1:28;
    };
}epi_epi_soe_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane0_soe0:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line0_lane0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane0_soe1:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line1_lane0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane0_soe2:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line2_lane0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane0_soe3:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line3_lane0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane1_soe0:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line0_lane1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane1_soe1:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line1_lane1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane1_soe2:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line2_lane1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane1_soe3:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line3_lane1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane2_soe0:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line0_lane2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane2_soe1:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line1_lane2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane2_soe2:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line2_lane2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane2_soe3:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line3_lane2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane3_soe0:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line0_lane3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane3_soe1:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line1_lane3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane3_soe2:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line2_lane3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane3_soe3:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line3_lane3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane4_soe0:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line0_lane4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane4_soe1:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line1_lane4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane4_soe2:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line2_lane4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane4_soe3:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line3_lane4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane5_soe0:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line0_lane5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane5_soe1:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line1_lane5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane5_soe2:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line2_lane5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane5_soe3:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line3_lane5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane6_soe0:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line0_lane6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane6_soe1:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line1_lane6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane6_soe2:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line2_lane6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane6_soe3:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line3_lane6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane7_soe0:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line0_lane7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane7_soe1:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line1_lane7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane7_soe2:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line2_lane7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane7_soe3:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line3_lane7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane8_soe0:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line0_lane8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane8_soe1:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line1_lane8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane8_soe2:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line2_lane8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane8_soe3:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line3_lane8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane9_soe0:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line0_lane9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane9_soe1:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line1_lane9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane9_soe2:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line2_lane9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane9_soe3:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line3_lane9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane10_soe0:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line0_lane10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane10_soe1:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line1_lane10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane10_soe2:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line2_lane10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane10_soe3:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line3_lane10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane11_soe0:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line0_lane11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane11_soe1:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line1_lane11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane11_soe2:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line2_lane11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane11_soe3:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_soe_line3_lane11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_d_st_c0_mux_sel:4;
        RBus_UInt32  lane_d_st_c1_mux_sel:4;
        RBus_UInt32  lane_d_st_c2_mux_sel:4;
        RBus_UInt32  lane_d_st_c3_mux_sel:4;
        RBus_UInt32  lane_d_st_c4_mux_sel:4;
        RBus_UInt32  res1:12;
    };
}epi_epi_lane_dst_mux0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_d_st_c5_mux_sel:4;
        RBus_UInt32  lane_d_st_c6_mux_sel:4;
        RBus_UInt32  lane_d_st_c7_mux_sel:4;
        RBus_UInt32  lane_d_st_c8_mux_sel:4;
        RBus_UInt32  lane_d_st_c9_mux_sel:4;
        RBus_UInt32  res1:12;
    };
}epi_epi_lane_dst_mux1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_d_st_c10_mux_sel:4;
        RBus_UInt32  lane_d_st_c11_mux_sel:4;
        RBus_UInt32  lane_d_st_c12_mux_sel:4;
        RBus_UInt32  lane_d_st_c13_mux_sel:4;
        RBus_UInt32  lane_d_st_c14_mux_sel:4;
        RBus_UInt32  res1:12;
    };
}epi_epi_lane_dst_mux2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_d_st_c15_mux_sel:4;
        RBus_UInt32  lane_d_st_c16_mux_sel:4;
        RBus_UInt32  lane_d_st_c17_mux_sel:4;
        RBus_UInt32  lane_d_st_c18_mux_sel:4;
        RBus_UInt32  lane_d_st_c19_mux_sel:4;
        RBus_UInt32  res1:12;
    };
}epi_epi_lane_dst_mux3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_d_st_c20_mux_sel:4;
        RBus_UInt32  lane_d_st_c21_mux_sel:4;
        RBus_UInt32  lane_d_st_c22_mux_sel:4;
        RBus_UInt32  lane_d_st_c23_mux_sel:4;
        RBus_UInt32  lane_d_st_c24_mux_sel:4;
        RBus_UInt32  res1:12;
    };
}epi_epi_lane_dst_mux4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_d_st_c25_mux_sel:4;
        RBus_UInt32  lane_d_st_c26_mux_sel:4;
        RBus_UInt32  lane_d_st_c27_mux_sel:4;
        RBus_UInt32  lane_d_st_c28_mux_sel:4;
        RBus_UInt32  lane_d_st_c29_mux_sel:4;
        RBus_UInt32  res1:12;
    };
}epi_epi_lane_dst_mux5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_c_st_c0_mux_sel:4;
        RBus_UInt32  lane_c_st_c1_mux_sel:4;
        RBus_UInt32  lane_c_st_c2_mux_sel:4;
        RBus_UInt32  lane_c_st_c3_mux_sel:4;
        RBus_UInt32  lane_c_st_c4_mux_sel:4;
        RBus_UInt32  res1:12;
    };
}epi_epi_lane_cst_mux0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_c_st_c5_mux_sel:4;
        RBus_UInt32  lane_c_st_c6_mux_sel:4;
        RBus_UInt32  lane_c_st_c7_mux_sel:4;
        RBus_UInt32  lane_c_st_c8_mux_sel:4;
        RBus_UInt32  lane_c_st_c9_mux_sel:4;
        RBus_UInt32  res1:12;
    };
}epi_epi_lane_cst_mux1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_c_st_c10_mux_sel:4;
        RBus_UInt32  lane_c_st_c11_mux_sel:4;
        RBus_UInt32  lane_c_st_c12_mux_sel:4;
        RBus_UInt32  lane_c_st_c13_mux_sel:4;
        RBus_UInt32  lane_c_st_c14_mux_sel:4;
        RBus_UInt32  res1:12;
    };
}epi_epi_lane_cst_mux2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_c_st_c15_mux_sel:4;
        RBus_UInt32  lane_c_st_c16_mux_sel:4;
        RBus_UInt32  lane_c_st_c17_mux_sel:4;
        RBus_UInt32  lane_c_st_c18_mux_sel:4;
        RBus_UInt32  lane_c_st_c19_mux_sel:4;
        RBus_UInt32  res1:12;
    };
}epi_epi_lane_cst_mux3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_c_st_c20_mux_sel:4;
        RBus_UInt32  lane_c_st_c21_mux_sel:4;
        RBus_UInt32  lane_c_st_c22_mux_sel:4;
        RBus_UInt32  lane_c_st_c23_mux_sel:4;
        RBus_UInt32  lane_c_st_c24_mux_sel:4;
        RBus_UInt32  res1:12;
    };
}epi_epi_lane_cst_mux4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_c_st_c25_mux_sel:4;
        RBus_UInt32  lane_c_st_c26_mux_sel:4;
        RBus_UInt32  lane_c_st_c27_mux_sel:4;
        RBus_UInt32  lane_c_st_c28_mux_sel:4;
        RBus_UInt32  lane_c_st_c29_mux_sel:4;
        RBus_UInt32  res1:12;
    };
}epi_epi_lane_cst_mux5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_ctr1_c0_mux_sel:4;
        RBus_UInt32  lane_ctr1_c1_mux_sel:4;
        RBus_UInt32  lane_ctr1_c2_mux_sel:4;
        RBus_UInt32  lane_ctr1_c3_mux_sel:4;
        RBus_UInt32  lane_ctr1_c4_mux_sel:4;
        RBus_UInt32  res1:12;
    };
}epi_epi_lane_ctr1_mux0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_ctr1_c5_mux_sel:4;
        RBus_UInt32  lane_ctr1_c6_mux_sel:4;
        RBus_UInt32  lane_ctr1_c7_mux_sel:4;
        RBus_UInt32  lane_ctr1_c8_mux_sel:4;
        RBus_UInt32  lane_ctr1_c9_mux_sel:4;
        RBus_UInt32  res1:12;
    };
}epi_epi_lane_ctr1_mux1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_ctr1_c10_mux_sel:4;
        RBus_UInt32  lane_ctr1_c11_mux_sel:4;
        RBus_UInt32  lane_ctr1_c12_mux_sel:4;
        RBus_UInt32  lane_ctr1_c13_mux_sel:4;
        RBus_UInt32  lane_ctr1_c14_mux_sel:4;
        RBus_UInt32  res1:12;
    };
}epi_epi_lane_ctr1_mux2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_ctr1_c15_mux_sel:4;
        RBus_UInt32  lane_ctr1_c16_mux_sel:4;
        RBus_UInt32  lane_ctr1_c17_mux_sel:4;
        RBus_UInt32  lane_ctr1_c18_mux_sel:4;
        RBus_UInt32  lane_ctr1_c19_mux_sel:4;
        RBus_UInt32  res1:12;
    };
}epi_epi_lane_ctr1_mux3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_ctr1_c20_mux_sel:4;
        RBus_UInt32  lane_ctr1_c21_mux_sel:4;
        RBus_UInt32  lane_ctr1_c22_mux_sel:4;
        RBus_UInt32  lane_ctr1_c23_mux_sel:4;
        RBus_UInt32  lane_ctr1_c24_mux_sel:4;
        RBus_UInt32  res1:12;
    };
}epi_epi_lane_ctr1_mux4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_ctr1_c25_mux_sel:4;
        RBus_UInt32  lane_ctr1_c26_mux_sel:4;
        RBus_UInt32  lane_ctr1_c27_mux_sel:4;
        RBus_UInt32  lane_ctr1_c28_mux_sel:4;
        RBus_UInt32  lane_ctr1_c29_mux_sel:4;
        RBus_UInt32  res1:12;
    };
}epi_epi_lane_ctr1_mux5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_ctr2_c0_mux_sel:4;
        RBus_UInt32  lane_ctr2_c1_mux_sel:4;
        RBus_UInt32  lane_ctr2_c2_mux_sel:4;
        RBus_UInt32  lane_ctr2_c3_mux_sel:4;
        RBus_UInt32  lane_ctr2_c4_mux_sel:4;
        RBus_UInt32  res1:12;
    };
}epi_epi_lane_ctr2_mux0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_ctr2_c5_mux_sel:4;
        RBus_UInt32  lane_ctr2_c6_mux_sel:4;
        RBus_UInt32  lane_ctr2_c7_mux_sel:4;
        RBus_UInt32  lane_ctr2_c8_mux_sel:4;
        RBus_UInt32  lane_ctr2_c9_mux_sel:4;
        RBus_UInt32  res1:12;
    };
}epi_epi_lane_ctr2_mux1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_ctr2_c10_mux_sel:4;
        RBus_UInt32  lane_ctr2_c11_mux_sel:4;
        RBus_UInt32  lane_ctr2_c12_mux_sel:4;
        RBus_UInt32  lane_ctr2_c13_mux_sel:4;
        RBus_UInt32  lane_ctr2_c14_mux_sel:4;
        RBus_UInt32  res1:12;
    };
}epi_epi_lane_ctr2_mux2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_ctr2_c15_mux_sel:4;
        RBus_UInt32  lane_ctr2_c16_mux_sel:4;
        RBus_UInt32  lane_ctr2_c17_mux_sel:4;
        RBus_UInt32  lane_ctr2_c18_mux_sel:4;
        RBus_UInt32  lane_ctr2_c19_mux_sel:4;
        RBus_UInt32  res1:12;
    };
}epi_epi_lane_ctr2_mux3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_ctr2_c20_mux_sel:4;
        RBus_UInt32  lane_ctr2_c21_mux_sel:4;
        RBus_UInt32  lane_ctr2_c22_mux_sel:4;
        RBus_UInt32  lane_ctr2_c23_mux_sel:4;
        RBus_UInt32  lane_ctr2_c24_mux_sel:4;
        RBus_UInt32  res1:12;
    };
}epi_epi_lane_ctr2_mux4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_ctr2_c25_mux_sel:4;
        RBus_UInt32  lane_ctr2_c26_mux_sel:4;
        RBus_UInt32  lane_ctr2_c27_mux_sel:4;
        RBus_UInt32  lane_ctr2_c28_mux_sel:4;
        RBus_UInt32  lane_ctr2_c29_mux_sel:4;
        RBus_UInt32  res1:12;
    };
}epi_epi_lane_ctr2_mux5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_ctr3_c0_mux_sel:4;
        RBus_UInt32  lane_ctr3_c1_mux_sel:4;
        RBus_UInt32  lane_ctr3_c2_mux_sel:4;
        RBus_UInt32  lane_ctr3_c3_mux_sel:4;
        RBus_UInt32  lane_ctr3_c4_mux_sel:4;
        RBus_UInt32  res1:12;
    };
}epi_epi_lane_ctr3_mux0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_ctr3_c5_mux_sel:4;
        RBus_UInt32  lane_ctr3_c6_mux_sel:4;
        RBus_UInt32  lane_ctr3_c7_mux_sel:4;
        RBus_UInt32  lane_ctr3_c8_mux_sel:4;
        RBus_UInt32  lane_ctr3_c9_mux_sel:4;
        RBus_UInt32  res1:12;
    };
}epi_epi_lane_ctr3_mux1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_ctr3_c10_mux_sel:4;
        RBus_UInt32  lane_ctr3_c11_mux_sel:4;
        RBus_UInt32  lane_ctr3_c12_mux_sel:4;
        RBus_UInt32  lane_ctr3_c13_mux_sel:4;
        RBus_UInt32  lane_ctr3_c14_mux_sel:4;
        RBus_UInt32  res1:12;
    };
}epi_epi_lane_ctr3_mux2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_ctr3_c15_mux_sel:4;
        RBus_UInt32  lane_ctr3_c16_mux_sel:4;
        RBus_UInt32  lane_ctr3_c17_mux_sel:4;
        RBus_UInt32  lane_ctr3_c18_mux_sel:4;
        RBus_UInt32  lane_ctr3_c19_mux_sel:4;
        RBus_UInt32  res1:12;
    };
}epi_epi_lane_ctr3_mux3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_ctr3_c20_mux_sel:4;
        RBus_UInt32  lane_ctr3_c21_mux_sel:4;
        RBus_UInt32  lane_ctr3_c22_mux_sel:4;
        RBus_UInt32  lane_ctr3_c23_mux_sel:4;
        RBus_UInt32  lane_ctr3_c24_mux_sel:4;
        RBus_UInt32  res1:12;
    };
}epi_epi_lane_ctr3_mux4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_ctr3_c25_mux_sel:4;
        RBus_UInt32  lane_ctr3_c26_mux_sel:4;
        RBus_UInt32  lane_ctr3_c27_mux_sel:4;
        RBus_UInt32  lane_ctr3_c28_mux_sel:4;
        RBus_UInt32  lane_ctr3_c29_mux_sel:4;
        RBus_UInt32  res1:12;
    };
}epi_epi_lane_ctr3_mux5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tcon_a_sel:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  tcon_b_sel:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  tcon_c_sel:6;
        RBus_UInt32  res3:10;
    };
}epi_epi_tcon_mux_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tcon_d_sel:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  tcon_e_sel:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  tcon_f_sel:6;
        RBus_UInt32  res3:10;
    };
}epi_epi_tcon_mux1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tcon_g_sel:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  tcon_h_sel:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  tcon_i_sel:6;
        RBus_UInt32  res3:10;
    };
}epi_epi_tcon_mux2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tcon_j_sel:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  tcon_k_sel:6;
        RBus_UInt32  res2:18;
    };
}epi_epi_tcon_mux3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy18026510_31_0:32;
    };
}epi_epi_dummy_reg_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy_hw0:32;
    };
}epi_epi_hw_dummy0_reg_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy_hw1:32;
    };
}epi_epi_hw_dummy1_reg_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy_hw2:32;
    };
}epi_epi_hw_dummy2_reg_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy_hw3:32;
    };
}epi_epi_hw_dummy3_reg_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ceds_pol_inv:12;
        RBus_UInt32  res1:4;
        RBus_UInt32  ceds_pol2_inv:12;
        RBus_UInt32  res2:4;
    };
}epi_epi_ceds_pol_reg_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  d_st:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane_dst_data_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  c_st:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane_cst_data_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_ctr4:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane_ctr4_data_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_ctr5:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane_ctr5_data_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane0_ctr1_odd:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane0_ctr1_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane1_ctr1_odd:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane1_ctr1_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane2_ctr1_odd:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane2_ctr1_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane3_ctr1_odd:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane3_ctr1_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane4_ctr1_odd:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane4_ctr1_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane5_ctr1_odd:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane5_ctr1_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane6_ctr1_odd:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane6_ctr1_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane7_ctr1_odd:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane7_ctr1_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane8_ctr1_odd:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane8_ctr1_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane9_ctr1_odd:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane9_ctr1_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane10_ctr1_odd:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane10_ctr1_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane11_ctr1_odd:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane11_ctr1_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane0_ctr2_odd:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane0_ctr2_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane1_ctr2_odd:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane1_ctr2_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane2_ctr2_odd:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane2_ctr2_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane3_ctr2_odd:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane3_ctr2_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane4_ctr2_odd:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane4_ctr2_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane5_ctr2_odd:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane5_ctr2_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane6_ctr2_odd:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane6_ctr2_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane7_ctr2_odd:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane7_ctr2_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane8_ctr2_odd:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane8_ctr2_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane9_ctr2_odd:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane9_ctr2_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane10_ctr2_odd:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane10_ctr2_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane11_ctr2_odd:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane11_ctr2_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane0_ctr3_odd:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane0_ctr3_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane1_ctr3_odd:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane1_ctr3_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane2_ctr3_odd:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane2_ctr3_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane3_ctr3_odd:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane3_ctr3_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane4_ctr3_odd:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane4_ctr3_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane5_ctr3_odd:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane5_ctr3_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane6_ctr3_odd:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane6_ctr3_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane7_ctr3_odd:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane7_ctr3_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane8_ctr3_odd:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane8_ctr3_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane9_ctr3_odd:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane9_ctr3_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane10_ctr3_odd:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane10_ctr3_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane11_ctr3_odd:30;
        RBus_UInt32  res1:2;
    };
}epi_epi_lane11_ctr3_odata_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gp_table_line_cycle:4;
        RBus_UInt32  res1:28;
    };
}epi_epi_gplut_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gp_table_line_0:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  gp_table_line_1:5;
        RBus_UInt32  res2:19;
    };
}epi_epi_gplut_line_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gp_table_line_2:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  gp_table_line_3:5;
        RBus_UInt32  res2:19;
    };
}epi_epi_gplut_line_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gp_table_line_4:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  gp_table_line_5:5;
        RBus_UInt32  res2:19;
    };
}epi_epi_gplut_line_45_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gp_table_line_6:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  gp_table_line_7:5;
        RBus_UInt32  res2:19;
    };
}epi_epi_gplut_line_67_RBUS;




#endif 


#endif 
