/**
* @file Mac7p-DesignSpec-D-Domain_LGD_Dither
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2019/11/22
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_LGD_DITHER_REG_H_
#define _RBUS_LGD_DITHER_REG_H_

#include "rbusTypes.h"



//  LGD_DITHER Register Address



#define  LGD_DITHER_LGD_DITHER_CTRL_VADDR                   	(0xb8028e00)
#define  LGD_DITHER_LGD_DITHER_SEQ_R_00_15_VADDR            	(0xb8028e04)
#define  LGD_DITHER_LGD_DITHER_SEQ_R_16_31_VADDR            	(0xb8028e08)
#define  LGD_DITHER_LGD_DITHER_SEQ_G_00_15_VADDR            	(0xb8028e0c)
#define  LGD_DITHER_LGD_DITHER_SEQ_G_16_31_VADDR            	(0xb8028e10)
#define  LGD_DITHER_LGD_DITHER_SEQ_B_00_15_VADDR            	(0xb8028e14)
#define  LGD_DITHER_LGD_DITHER_SEQ_B_16_31_VADDR            	(0xb8028e18)
#define  LGD_DITHER_LGD_DITHER_TB_R_VADDR                   	(0xb8028e1c)
#define  LGD_DITHER_LGD_DITHER_TB_G_VADDR                   	(0xb8028e20)
#define  LGD_DITHER_LGD_DITHER_TB_B_VADDR                   	(0xb8028e24)
#define  LGD_DITHER_LGD_DITHER_TEMP_VADDR                   	(0xb8028e28)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======LGD_DITHER register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  location_sel:1;
        RBus_UInt32  lgd_dither_en:1;
        RBus_UInt32  temporal_enable:1;
        RBus_UInt32  value_sign:1;
        RBus_UInt32  res2:3;
    };
}lgd_dither_lgd_dither_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seq_r_15:2;
        RBus_UInt32  seq_r_14:2;
        RBus_UInt32  seq_r_13:2;
        RBus_UInt32  seq_r_12:2;
        RBus_UInt32  seq_r_11:2;
        RBus_UInt32  seq_r_10:2;
        RBus_UInt32  seq_r_9:2;
        RBus_UInt32  seq_r_8:2;
        RBus_UInt32  seq_r_7:2;
        RBus_UInt32  seq_r_6:2;
        RBus_UInt32  seq_r_5:2;
        RBus_UInt32  seq_r_4:2;
        RBus_UInt32  seq_r_3:2;
        RBus_UInt32  seq_r_2:2;
        RBus_UInt32  seq_r_1:2;
        RBus_UInt32  seq_r_0:2;
    };
}lgd_dither_lgd_dither_seq_r_00_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seq_r_31:2;
        RBus_UInt32  seq_r_30:2;
        RBus_UInt32  seq_r_29:2;
        RBus_UInt32  seq_r_28:2;
        RBus_UInt32  seq_r_27:2;
        RBus_UInt32  seq_r_26:2;
        RBus_UInt32  seq_r_25:2;
        RBus_UInt32  seq_r_24:2;
        RBus_UInt32  seq_r_23:2;
        RBus_UInt32  seq_r_22:2;
        RBus_UInt32  seq_r_21:2;
        RBus_UInt32  seq_r_20:2;
        RBus_UInt32  seq_r_19:2;
        RBus_UInt32  seq_r_18:2;
        RBus_UInt32  seq_r_17:2;
        RBus_UInt32  seq_r_16:2;
    };
}lgd_dither_lgd_dither_seq_r_16_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seq_g_15:2;
        RBus_UInt32  seq_g_14:2;
        RBus_UInt32  seq_g_13:2;
        RBus_UInt32  seq_g_12:2;
        RBus_UInt32  seq_g_11:2;
        RBus_UInt32  seq_g_10:2;
        RBus_UInt32  seq_g_9:2;
        RBus_UInt32  seq_g_8:2;
        RBus_UInt32  seq_g_7:2;
        RBus_UInt32  seq_g_6:2;
        RBus_UInt32  seq_g_5:2;
        RBus_UInt32  seq_g_4:2;
        RBus_UInt32  seq_g_3:2;
        RBus_UInt32  seq_g_2:2;
        RBus_UInt32  seq_g_1:2;
        RBus_UInt32  seq_g_0:2;
    };
}lgd_dither_lgd_dither_seq_g_00_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seq_g_31:2;
        RBus_UInt32  seq_g_30:2;
        RBus_UInt32  seq_g_29:2;
        RBus_UInt32  seq_g_28:2;
        RBus_UInt32  seq_g_27:2;
        RBus_UInt32  seq_g_26:2;
        RBus_UInt32  seq_g_25:2;
        RBus_UInt32  seq_g_24:2;
        RBus_UInt32  seq_g_23:2;
        RBus_UInt32  seq_g_22:2;
        RBus_UInt32  seq_g_21:2;
        RBus_UInt32  seq_g_20:2;
        RBus_UInt32  seq_g_19:2;
        RBus_UInt32  seq_g_18:2;
        RBus_UInt32  seq_g_17:2;
        RBus_UInt32  seq_g_16:2;
    };
}lgd_dither_lgd_dither_seq_g_16_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seq_b_15:2;
        RBus_UInt32  seq_b_14:2;
        RBus_UInt32  seq_b_13:2;
        RBus_UInt32  seq_b_12:2;
        RBus_UInt32  seq_b_11:2;
        RBus_UInt32  seq_b_10:2;
        RBus_UInt32  seq_b_9:2;
        RBus_UInt32  seq_b_8:2;
        RBus_UInt32  seq_b_7:2;
        RBus_UInt32  seq_b_6:2;
        RBus_UInt32  seq_b_5:2;
        RBus_UInt32  seq_b_4:2;
        RBus_UInt32  seq_b_3:2;
        RBus_UInt32  seq_b_2:2;
        RBus_UInt32  seq_b_1:2;
        RBus_UInt32  seq_b_0:2;
    };
}lgd_dither_lgd_dither_seq_b_00_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seq_b_31:2;
        RBus_UInt32  seq_b_30:2;
        RBus_UInt32  seq_b_29:2;
        RBus_UInt32  seq_b_28:2;
        RBus_UInt32  seq_b_27:2;
        RBus_UInt32  seq_b_26:2;
        RBus_UInt32  seq_b_25:2;
        RBus_UInt32  seq_b_24:2;
        RBus_UInt32  seq_b_23:2;
        RBus_UInt32  seq_b_22:2;
        RBus_UInt32  seq_b_21:2;
        RBus_UInt32  seq_b_20:2;
        RBus_UInt32  seq_b_19:2;
        RBus_UInt32  seq_b_18:2;
        RBus_UInt32  seq_b_17:2;
        RBus_UInt32  seq_b_16:2;
    };
}lgd_dither_lgd_dither_seq_b_16_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tab_r_33:2;
        RBus_UInt32  tab_r_32:2;
        RBus_UInt32  tab_r_31:2;
        RBus_UInt32  tab_r_30:2;
        RBus_UInt32  tab_r_23:2;
        RBus_UInt32  tab_r_22:2;
        RBus_UInt32  tab_r_21:2;
        RBus_UInt32  tab_r_20:2;
        RBus_UInt32  tab_r_13:2;
        RBus_UInt32  tab_r_12:2;
        RBus_UInt32  tab_r_11:2;
        RBus_UInt32  tab_r_10:2;
        RBus_UInt32  tab_r_03:2;
        RBus_UInt32  tab_r_02:2;
        RBus_UInt32  tab_r_01:2;
        RBus_UInt32  tab_r_00:2;
    };
}lgd_dither_lgd_dither_tb_r_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tab_g_33:2;
        RBus_UInt32  tab_g_32:2;
        RBus_UInt32  tab_g_31:2;
        RBus_UInt32  tab_g_30:2;
        RBus_UInt32  tab_g_23:2;
        RBus_UInt32  tab_g_22:2;
        RBus_UInt32  tab_g_21:2;
        RBus_UInt32  tab_g_20:2;
        RBus_UInt32  tab_g_13:2;
        RBus_UInt32  tab_g_12:2;
        RBus_UInt32  tab_g_11:2;
        RBus_UInt32  tab_g_10:2;
        RBus_UInt32  tab_g_03:2;
        RBus_UInt32  tab_g_02:2;
        RBus_UInt32  tab_g_01:2;
        RBus_UInt32  tab_g_00:2;
    };
}lgd_dither_lgd_dither_tb_g_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tab_b_33:2;
        RBus_UInt32  tab_b_32:2;
        RBus_UInt32  tab_b_31:2;
        RBus_UInt32  tab_b_30:2;
        RBus_UInt32  tab_b_23:2;
        RBus_UInt32  tab_b_22:2;
        RBus_UInt32  tab_b_21:2;
        RBus_UInt32  tab_b_20:2;
        RBus_UInt32  tab_b_13:2;
        RBus_UInt32  tab_b_12:2;
        RBus_UInt32  tab_b_11:2;
        RBus_UInt32  tab_b_10:2;
        RBus_UInt32  tab_b_03:2;
        RBus_UInt32  tab_b_02:2;
        RBus_UInt32  tab_b_01:2;
        RBus_UInt32  tab_b_00:2;
    };
}lgd_dither_lgd_dither_tb_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  temp_offset_15:2;
        RBus_UInt32  temp_offset_14:2;
        RBus_UInt32  temp_offset_13:2;
        RBus_UInt32  temp_offset_12:2;
        RBus_UInt32  temp_offset_11:2;
        RBus_UInt32  temp_offset_10:2;
        RBus_UInt32  temp_offset_9:2;
        RBus_UInt32  temp_offset_8:2;
        RBus_UInt32  temp_offset_7:2;
        RBus_UInt32  temp_offset_6:2;
        RBus_UInt32  temp_offset_5:2;
        RBus_UInt32  temp_offset_4:2;
        RBus_UInt32  temp_offset_3:2;
        RBus_UInt32  temp_offset_2:2;
        RBus_UInt32  temp_offset_1:2;
        RBus_UInt32  temp_offset_0:2;
    };
}lgd_dither_lgd_dither_temp_RBUS;

#else //apply LITTLE_ENDIAN

//======LGD_DITHER register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  value_sign:1;
        RBus_UInt32  temporal_enable:1;
        RBus_UInt32  lgd_dither_en:1;
        RBus_UInt32  location_sel:1;
        RBus_UInt32  res2:25;
    };
}lgd_dither_lgd_dither_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seq_r_0:2;
        RBus_UInt32  seq_r_1:2;
        RBus_UInt32  seq_r_2:2;
        RBus_UInt32  seq_r_3:2;
        RBus_UInt32  seq_r_4:2;
        RBus_UInt32  seq_r_5:2;
        RBus_UInt32  seq_r_6:2;
        RBus_UInt32  seq_r_7:2;
        RBus_UInt32  seq_r_8:2;
        RBus_UInt32  seq_r_9:2;
        RBus_UInt32  seq_r_10:2;
        RBus_UInt32  seq_r_11:2;
        RBus_UInt32  seq_r_12:2;
        RBus_UInt32  seq_r_13:2;
        RBus_UInt32  seq_r_14:2;
        RBus_UInt32  seq_r_15:2;
    };
}lgd_dither_lgd_dither_seq_r_00_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seq_r_16:2;
        RBus_UInt32  seq_r_17:2;
        RBus_UInt32  seq_r_18:2;
        RBus_UInt32  seq_r_19:2;
        RBus_UInt32  seq_r_20:2;
        RBus_UInt32  seq_r_21:2;
        RBus_UInt32  seq_r_22:2;
        RBus_UInt32  seq_r_23:2;
        RBus_UInt32  seq_r_24:2;
        RBus_UInt32  seq_r_25:2;
        RBus_UInt32  seq_r_26:2;
        RBus_UInt32  seq_r_27:2;
        RBus_UInt32  seq_r_28:2;
        RBus_UInt32  seq_r_29:2;
        RBus_UInt32  seq_r_30:2;
        RBus_UInt32  seq_r_31:2;
    };
}lgd_dither_lgd_dither_seq_r_16_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seq_g_0:2;
        RBus_UInt32  seq_g_1:2;
        RBus_UInt32  seq_g_2:2;
        RBus_UInt32  seq_g_3:2;
        RBus_UInt32  seq_g_4:2;
        RBus_UInt32  seq_g_5:2;
        RBus_UInt32  seq_g_6:2;
        RBus_UInt32  seq_g_7:2;
        RBus_UInt32  seq_g_8:2;
        RBus_UInt32  seq_g_9:2;
        RBus_UInt32  seq_g_10:2;
        RBus_UInt32  seq_g_11:2;
        RBus_UInt32  seq_g_12:2;
        RBus_UInt32  seq_g_13:2;
        RBus_UInt32  seq_g_14:2;
        RBus_UInt32  seq_g_15:2;
    };
}lgd_dither_lgd_dither_seq_g_00_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seq_g_16:2;
        RBus_UInt32  seq_g_17:2;
        RBus_UInt32  seq_g_18:2;
        RBus_UInt32  seq_g_19:2;
        RBus_UInt32  seq_g_20:2;
        RBus_UInt32  seq_g_21:2;
        RBus_UInt32  seq_g_22:2;
        RBus_UInt32  seq_g_23:2;
        RBus_UInt32  seq_g_24:2;
        RBus_UInt32  seq_g_25:2;
        RBus_UInt32  seq_g_26:2;
        RBus_UInt32  seq_g_27:2;
        RBus_UInt32  seq_g_28:2;
        RBus_UInt32  seq_g_29:2;
        RBus_UInt32  seq_g_30:2;
        RBus_UInt32  seq_g_31:2;
    };
}lgd_dither_lgd_dither_seq_g_16_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seq_b_0:2;
        RBus_UInt32  seq_b_1:2;
        RBus_UInt32  seq_b_2:2;
        RBus_UInt32  seq_b_3:2;
        RBus_UInt32  seq_b_4:2;
        RBus_UInt32  seq_b_5:2;
        RBus_UInt32  seq_b_6:2;
        RBus_UInt32  seq_b_7:2;
        RBus_UInt32  seq_b_8:2;
        RBus_UInt32  seq_b_9:2;
        RBus_UInt32  seq_b_10:2;
        RBus_UInt32  seq_b_11:2;
        RBus_UInt32  seq_b_12:2;
        RBus_UInt32  seq_b_13:2;
        RBus_UInt32  seq_b_14:2;
        RBus_UInt32  seq_b_15:2;
    };
}lgd_dither_lgd_dither_seq_b_00_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  seq_b_16:2;
        RBus_UInt32  seq_b_17:2;
        RBus_UInt32  seq_b_18:2;
        RBus_UInt32  seq_b_19:2;
        RBus_UInt32  seq_b_20:2;
        RBus_UInt32  seq_b_21:2;
        RBus_UInt32  seq_b_22:2;
        RBus_UInt32  seq_b_23:2;
        RBus_UInt32  seq_b_24:2;
        RBus_UInt32  seq_b_25:2;
        RBus_UInt32  seq_b_26:2;
        RBus_UInt32  seq_b_27:2;
        RBus_UInt32  seq_b_28:2;
        RBus_UInt32  seq_b_29:2;
        RBus_UInt32  seq_b_30:2;
        RBus_UInt32  seq_b_31:2;
    };
}lgd_dither_lgd_dither_seq_b_16_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tab_r_00:2;
        RBus_UInt32  tab_r_01:2;
        RBus_UInt32  tab_r_02:2;
        RBus_UInt32  tab_r_03:2;
        RBus_UInt32  tab_r_10:2;
        RBus_UInt32  tab_r_11:2;
        RBus_UInt32  tab_r_12:2;
        RBus_UInt32  tab_r_13:2;
        RBus_UInt32  tab_r_20:2;
        RBus_UInt32  tab_r_21:2;
        RBus_UInt32  tab_r_22:2;
        RBus_UInt32  tab_r_23:2;
        RBus_UInt32  tab_r_30:2;
        RBus_UInt32  tab_r_31:2;
        RBus_UInt32  tab_r_32:2;
        RBus_UInt32  tab_r_33:2;
    };
}lgd_dither_lgd_dither_tb_r_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tab_g_00:2;
        RBus_UInt32  tab_g_01:2;
        RBus_UInt32  tab_g_02:2;
        RBus_UInt32  tab_g_03:2;
        RBus_UInt32  tab_g_10:2;
        RBus_UInt32  tab_g_11:2;
        RBus_UInt32  tab_g_12:2;
        RBus_UInt32  tab_g_13:2;
        RBus_UInt32  tab_g_20:2;
        RBus_UInt32  tab_g_21:2;
        RBus_UInt32  tab_g_22:2;
        RBus_UInt32  tab_g_23:2;
        RBus_UInt32  tab_g_30:2;
        RBus_UInt32  tab_g_31:2;
        RBus_UInt32  tab_g_32:2;
        RBus_UInt32  tab_g_33:2;
    };
}lgd_dither_lgd_dither_tb_g_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tab_b_00:2;
        RBus_UInt32  tab_b_01:2;
        RBus_UInt32  tab_b_02:2;
        RBus_UInt32  tab_b_03:2;
        RBus_UInt32  tab_b_10:2;
        RBus_UInt32  tab_b_11:2;
        RBus_UInt32  tab_b_12:2;
        RBus_UInt32  tab_b_13:2;
        RBus_UInt32  tab_b_20:2;
        RBus_UInt32  tab_b_21:2;
        RBus_UInt32  tab_b_22:2;
        RBus_UInt32  tab_b_23:2;
        RBus_UInt32  tab_b_30:2;
        RBus_UInt32  tab_b_31:2;
        RBus_UInt32  tab_b_32:2;
        RBus_UInt32  tab_b_33:2;
    };
}lgd_dither_lgd_dither_tb_b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  temp_offset_0:2;
        RBus_UInt32  temp_offset_1:2;
        RBus_UInt32  temp_offset_2:2;
        RBus_UInt32  temp_offset_3:2;
        RBus_UInt32  temp_offset_4:2;
        RBus_UInt32  temp_offset_5:2;
        RBus_UInt32  temp_offset_6:2;
        RBus_UInt32  temp_offset_7:2;
        RBus_UInt32  temp_offset_8:2;
        RBus_UInt32  temp_offset_9:2;
        RBus_UInt32  temp_offset_10:2;
        RBus_UInt32  temp_offset_11:2;
        RBus_UInt32  temp_offset_12:2;
        RBus_UInt32  temp_offset_13:2;
        RBus_UInt32  temp_offset_14:2;
        RBus_UInt32  temp_offset_15:2;
    };
}lgd_dither_lgd_dither_temp_RBUS;




#endif 


#endif 
