/**
* @file Mac7p_DesignSpec-I-Domain_Main_Dither
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2019/11/22
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_MAIN_DITHER_REG_H_
#define _RBUS_MAIN_DITHER_REG_H_

#include "rbusTypes.h"



//  MAIN_DITHER Register Address



#define  MAIN_DITHER_I_MAIN_DITHER_CTRL1_VADDR              	(0xb8022600)
#define  MAIN_DITHER_I_MAIN_DITHER_SEQ_R_00_15_VADDR        	(0xb8022604)
#define  MAIN_DITHER_I_MAIN_DITHER_SEQ_R_16_31_VADDR        	(0xb8022608)
#define  MAIN_DITHER_I_MAIN_DITHER_SEQ_G_00_07_VADDR        	(0xb802260c)
#define  MAIN_DITHER_I_MAIN_DITHER_SEQ_G_16_31_VADDR        	(0xb8022610)
#define  MAIN_DITHER_I_MAIN_DITHER_SEQ_B_00_15_VADDR        	(0xb8022614)
#define  MAIN_DITHER_I_MAIN_DITHER_SEQ_B_16_31_VADDR        	(0xb8022618)
#define  MAIN_DITHER_I_MAIN_DITHER_TB_R_00_VADDR            	(0xb802261c)
#define  MAIN_DITHER_I_MAIN_DITHER_TB_R_02_VADDR            	(0xb8022620)
#define  MAIN_DITHER_I_MAIN_DITHER_TB_G_00_VADDR            	(0xb8022624)
#define  MAIN_DITHER_I_MAIN_DITHER_TB_G_02_VADDR            	(0xb8022628)
#define  MAIN_DITHER_I_MAIN_DITHER_TB_B_00_VADDR            	(0xb802262c)
#define  MAIN_DITHER_I_MAIN_DITHER_TB_B_02_VADDR            	(0xb8022630)
#define  MAIN_DITHER_I_MAIN_DITHER_TEMP_TB_VADDR            	(0xb8022634)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======MAIN_DITHER register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  main_dither_bit_sel:1;
        RBus_UInt32  res2:4;
        RBus_UInt32  main_dither_en:1;
        RBus_UInt32  main_dither_temporal_enable:1;
        RBus_UInt32  main_dither_value_sign:1;
        RBus_UInt32  res3:3;
    };
}main_dither_i_main_dither_ctrl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  main_dither_seq_r_15:2;
        RBus_UInt32  main_dither_seq_r_14:2;
        RBus_UInt32  main_dither_seq_r_13:2;
        RBus_UInt32  main_dither_seq_r_12:2;
        RBus_UInt32  main_dither_seq_r_11:2;
        RBus_UInt32  main_dither_seq_r_10:2;
        RBus_UInt32  main_dither_seq_r_9:2;
        RBus_UInt32  main_dither_seq_r_8:2;
        RBus_UInt32  main_dither_seq_r_7:2;
        RBus_UInt32  main_dither_seq_r_6:2;
        RBus_UInt32  main_dither_seq_r_5:2;
        RBus_UInt32  main_dither_seq_r_4:2;
        RBus_UInt32  main_dither_seq_r_3:2;
        RBus_UInt32  main_dither_seq_r_2:2;
        RBus_UInt32  main_dither_seq_r_1:2;
        RBus_UInt32  main_dither_seq_r_0:2;
    };
}main_dither_i_main_dither_seq_r_00_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  main_dither_seq_r_31:2;
        RBus_UInt32  main_dither_seq_r_30:2;
        RBus_UInt32  main_dither_seq_r_29:2;
        RBus_UInt32  main_dither_seq_r_28:2;
        RBus_UInt32  main_dither_seq_r_27:2;
        RBus_UInt32  main_dither_seq_r_26:2;
        RBus_UInt32  main_dither_seq_r_25:2;
        RBus_UInt32  main_dither_seq_r_24:2;
        RBus_UInt32  main_dither_seq_r_23:2;
        RBus_UInt32  main_dither_seq_r_22:2;
        RBus_UInt32  main_dither_seq_r_21:2;
        RBus_UInt32  main_dither_seq_r_20:2;
        RBus_UInt32  main_dither_seq_r_19:2;
        RBus_UInt32  main_dither_seq_r_18:2;
        RBus_UInt32  main_dither_seq_r_17:2;
        RBus_UInt32  main_dither_seq_r_16:2;
    };
}main_dither_i_main_dither_seq_r_16_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  main_dither_seq_g_15:2;
        RBus_UInt32  main_dither_seq_g_14:2;
        RBus_UInt32  main_dither_seq_g_13:2;
        RBus_UInt32  main_dither_seq_g_12:2;
        RBus_UInt32  main_dither_seq_g_11:2;
        RBus_UInt32  main_dither_seq_g_10:2;
        RBus_UInt32  main_dither_seq_g_9:2;
        RBus_UInt32  main_dither_seq_g_8:2;
        RBus_UInt32  main_dither_seq_g_7:2;
        RBus_UInt32  main_dither_seq_g_6:2;
        RBus_UInt32  main_dither_seq_g_5:2;
        RBus_UInt32  main_dither_seq_g_4:2;
        RBus_UInt32  main_dither_seq_g_3:2;
        RBus_UInt32  main_dither_seq_g_2:2;
        RBus_UInt32  main_dither_seq_g_1:2;
        RBus_UInt32  main_dither_seq_g_0:2;
    };
}main_dither_i_main_dither_seq_g_00_07_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  main_dither_seq_g_31:2;
        RBus_UInt32  main_dither_seq_g_30:2;
        RBus_UInt32  main_dither_seq_g_29:2;
        RBus_UInt32  main_dither_seq_g_28:2;
        RBus_UInt32  main_dither_seq_g_27:2;
        RBus_UInt32  main_dither_seq_g_26:2;
        RBus_UInt32  main_dither_seq_g_25:2;
        RBus_UInt32  main_dither_seq_g_24:2;
        RBus_UInt32  main_dither_seq_g_23:2;
        RBus_UInt32  main_dither_seq_g_22:2;
        RBus_UInt32  main_dither_seq_g_21:2;
        RBus_UInt32  main_dither_seq_g_20:2;
        RBus_UInt32  main_dither_seq_g_19:2;
        RBus_UInt32  main_dither_seq_g_18:2;
        RBus_UInt32  main_dither_seq_g_17:2;
        RBus_UInt32  main_dither_seq_g_16:2;
    };
}main_dither_i_main_dither_seq_g_16_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  main_dither_seq_b_15:2;
        RBus_UInt32  main_dither_seq_b_14:2;
        RBus_UInt32  main_dither_seq_b_13:2;
        RBus_UInt32  main_dither_seq_b_12:2;
        RBus_UInt32  main_dither_seq_b_11:2;
        RBus_UInt32  main_dither_seq_b_10:2;
        RBus_UInt32  main_dither_seq_b_9:2;
        RBus_UInt32  main_dither_seq_b_8:2;
        RBus_UInt32  main_dither_seq_b_7:2;
        RBus_UInt32  main_dither_seq_b_6:2;
        RBus_UInt32  main_dither_seq_b_5:2;
        RBus_UInt32  main_dither_seq_b_4:2;
        RBus_UInt32  main_dither_seq_b_3:2;
        RBus_UInt32  main_dither_seq_b_2:2;
        RBus_UInt32  main_dither_seq_b_1:2;
        RBus_UInt32  main_dither_seq_b_0:2;
    };
}main_dither_i_main_dither_seq_b_00_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  main_dither_seq_b_31:2;
        RBus_UInt32  main_dither_seq_b_30:2;
        RBus_UInt32  main_dither_seq_b_29:2;
        RBus_UInt32  main_dither_seq_b_28:2;
        RBus_UInt32  main_dither_seq_b_27:2;
        RBus_UInt32  main_dither_seq_b_26:2;
        RBus_UInt32  main_dither_seq_b_25:2;
        RBus_UInt32  main_dither_seq_b_24:2;
        RBus_UInt32  main_dither_seq_b_23:2;
        RBus_UInt32  main_dither_seq_b_22:2;
        RBus_UInt32  main_dither_seq_b_21:2;
        RBus_UInt32  main_dither_seq_b_20:2;
        RBus_UInt32  main_dither_seq_b_19:2;
        RBus_UInt32  main_dither_seq_b_18:2;
        RBus_UInt32  main_dither_seq_b_17:2;
        RBus_UInt32  main_dither_seq_b_16:2;
    };
}main_dither_i_main_dither_seq_b_16_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  main_dither_tab_r_13:4;
        RBus_UInt32  main_dither_tab_r_12:4;
        RBus_UInt32  main_dither_tab_r_11:4;
        RBus_UInt32  main_dither_tab_r_10:4;
        RBus_UInt32  main_dither_tab_r_03:4;
        RBus_UInt32  main_dither_tab_r_02:4;
        RBus_UInt32  main_dither_tab_r_01:4;
        RBus_UInt32  main_dither_tab_r_00:4;
    };
}main_dither_i_main_dither_tb_r_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  main_dither_tab_r_33:4;
        RBus_UInt32  main_dither_tab_r_32:4;
        RBus_UInt32  main_dither_tab_r_31:4;
        RBus_UInt32  main_dither_tab_r_30:4;
        RBus_UInt32  main_dither_tab_r_23:4;
        RBus_UInt32  main_dither_tab_r_22:4;
        RBus_UInt32  main_dither_tab_r_21:4;
        RBus_UInt32  main_dither_tab_r_20:4;
    };
}main_dither_i_main_dither_tb_r_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  main_dither_tab_g_13:4;
        RBus_UInt32  main_dither_tab_g_12:4;
        RBus_UInt32  main_dither_tab_g_11:4;
        RBus_UInt32  main_dither_tab_g_10:4;
        RBus_UInt32  main_dither_tab_g_03:4;
        RBus_UInt32  main_dither_tab_g_02:4;
        RBus_UInt32  main_dither_tab_g_01:4;
        RBus_UInt32  main_dither_tab_g_00:4;
    };
}main_dither_i_main_dither_tb_g_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  main_dither_tab_g_33:4;
        RBus_UInt32  main_dither_tab_g_32:4;
        RBus_UInt32  main_dither_tab_g_31:4;
        RBus_UInt32  main_dither_tab_g_30:4;
        RBus_UInt32  main_dither_tab_g_23:4;
        RBus_UInt32  main_dither_tab_g_22:4;
        RBus_UInt32  main_dither_tab_g_21:4;
        RBus_UInt32  main_dither_tab_g_20:4;
    };
}main_dither_i_main_dither_tb_g_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  main_dither_tab_b_13:4;
        RBus_UInt32  main_dither_tab_b_12:4;
        RBus_UInt32  main_dither_tab_b_11:4;
        RBus_UInt32  main_dither_tab_b_10:4;
        RBus_UInt32  main_dither_tab_b_03:4;
        RBus_UInt32  main_dither_tab_b_02:4;
        RBus_UInt32  main_dither_tab_b_01:4;
        RBus_UInt32  main_dither_tab_b_00:4;
    };
}main_dither_i_main_dither_tb_b_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  main_dither_tab_b_33:4;
        RBus_UInt32  main_dither_tab_b_32:4;
        RBus_UInt32  main_dither_tab_b_31:4;
        RBus_UInt32  main_dither_tab_b_30:4;
        RBus_UInt32  main_dither_tab_b_23:4;
        RBus_UInt32  main_dither_tab_b_22:4;
        RBus_UInt32  main_dither_tab_b_21:4;
        RBus_UInt32  main_dither_tab_b_20:4;
    };
}main_dither_i_main_dither_tb_b_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  main_dither_tab_temp_offset_15:2;
        RBus_UInt32  main_dither_tab_temp_offset_14:2;
        RBus_UInt32  main_dither_tab_temp_offset_13:2;
        RBus_UInt32  main_dither_tab_temp_offset_12:2;
        RBus_UInt32  main_dither_tab_temp_offset_11:2;
        RBus_UInt32  main_dither_tab_temp_offset_10:2;
        RBus_UInt32  main_dither_tab_temp_offset_9:2;
        RBus_UInt32  main_dither_tab_temp_offset_8:2;
        RBus_UInt32  main_dither_tab_temp_offset_7:2;
        RBus_UInt32  main_dither_tab_temp_offset_6:2;
        RBus_UInt32  main_dither_tab_temp_offset_5:2;
        RBus_UInt32  main_dither_tab_temp_offset_4:2;
        RBus_UInt32  main_dither_tab_temp_offset_3:2;
        RBus_UInt32  main_dither_tab_temp_offset_2:2;
        RBus_UInt32  main_dither_tab_temp_offset_1:2;
        RBus_UInt32  main_dither_tab_temp_offset_0:2;
    };
}main_dither_i_main_dither_temp_tb_RBUS;

#else //apply LITTLE_ENDIAN

//======MAIN_DITHER register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  main_dither_value_sign:1;
        RBus_UInt32  main_dither_temporal_enable:1;
        RBus_UInt32  main_dither_en:1;
        RBus_UInt32  res2:4;
        RBus_UInt32  main_dither_bit_sel:1;
        RBus_UInt32  res3:21;
    };
}main_dither_i_main_dither_ctrl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  main_dither_seq_r_0:2;
        RBus_UInt32  main_dither_seq_r_1:2;
        RBus_UInt32  main_dither_seq_r_2:2;
        RBus_UInt32  main_dither_seq_r_3:2;
        RBus_UInt32  main_dither_seq_r_4:2;
        RBus_UInt32  main_dither_seq_r_5:2;
        RBus_UInt32  main_dither_seq_r_6:2;
        RBus_UInt32  main_dither_seq_r_7:2;
        RBus_UInt32  main_dither_seq_r_8:2;
        RBus_UInt32  main_dither_seq_r_9:2;
        RBus_UInt32  main_dither_seq_r_10:2;
        RBus_UInt32  main_dither_seq_r_11:2;
        RBus_UInt32  main_dither_seq_r_12:2;
        RBus_UInt32  main_dither_seq_r_13:2;
        RBus_UInt32  main_dither_seq_r_14:2;
        RBus_UInt32  main_dither_seq_r_15:2;
    };
}main_dither_i_main_dither_seq_r_00_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  main_dither_seq_r_16:2;
        RBus_UInt32  main_dither_seq_r_17:2;
        RBus_UInt32  main_dither_seq_r_18:2;
        RBus_UInt32  main_dither_seq_r_19:2;
        RBus_UInt32  main_dither_seq_r_20:2;
        RBus_UInt32  main_dither_seq_r_21:2;
        RBus_UInt32  main_dither_seq_r_22:2;
        RBus_UInt32  main_dither_seq_r_23:2;
        RBus_UInt32  main_dither_seq_r_24:2;
        RBus_UInt32  main_dither_seq_r_25:2;
        RBus_UInt32  main_dither_seq_r_26:2;
        RBus_UInt32  main_dither_seq_r_27:2;
        RBus_UInt32  main_dither_seq_r_28:2;
        RBus_UInt32  main_dither_seq_r_29:2;
        RBus_UInt32  main_dither_seq_r_30:2;
        RBus_UInt32  main_dither_seq_r_31:2;
    };
}main_dither_i_main_dither_seq_r_16_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  main_dither_seq_g_0:2;
        RBus_UInt32  main_dither_seq_g_1:2;
        RBus_UInt32  main_dither_seq_g_2:2;
        RBus_UInt32  main_dither_seq_g_3:2;
        RBus_UInt32  main_dither_seq_g_4:2;
        RBus_UInt32  main_dither_seq_g_5:2;
        RBus_UInt32  main_dither_seq_g_6:2;
        RBus_UInt32  main_dither_seq_g_7:2;
        RBus_UInt32  main_dither_seq_g_8:2;
        RBus_UInt32  main_dither_seq_g_9:2;
        RBus_UInt32  main_dither_seq_g_10:2;
        RBus_UInt32  main_dither_seq_g_11:2;
        RBus_UInt32  main_dither_seq_g_12:2;
        RBus_UInt32  main_dither_seq_g_13:2;
        RBus_UInt32  main_dither_seq_g_14:2;
        RBus_UInt32  main_dither_seq_g_15:2;
    };
}main_dither_i_main_dither_seq_g_00_07_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  main_dither_seq_g_16:2;
        RBus_UInt32  main_dither_seq_g_17:2;
        RBus_UInt32  main_dither_seq_g_18:2;
        RBus_UInt32  main_dither_seq_g_19:2;
        RBus_UInt32  main_dither_seq_g_20:2;
        RBus_UInt32  main_dither_seq_g_21:2;
        RBus_UInt32  main_dither_seq_g_22:2;
        RBus_UInt32  main_dither_seq_g_23:2;
        RBus_UInt32  main_dither_seq_g_24:2;
        RBus_UInt32  main_dither_seq_g_25:2;
        RBus_UInt32  main_dither_seq_g_26:2;
        RBus_UInt32  main_dither_seq_g_27:2;
        RBus_UInt32  main_dither_seq_g_28:2;
        RBus_UInt32  main_dither_seq_g_29:2;
        RBus_UInt32  main_dither_seq_g_30:2;
        RBus_UInt32  main_dither_seq_g_31:2;
    };
}main_dither_i_main_dither_seq_g_16_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  main_dither_seq_b_0:2;
        RBus_UInt32  main_dither_seq_b_1:2;
        RBus_UInt32  main_dither_seq_b_2:2;
        RBus_UInt32  main_dither_seq_b_3:2;
        RBus_UInt32  main_dither_seq_b_4:2;
        RBus_UInt32  main_dither_seq_b_5:2;
        RBus_UInt32  main_dither_seq_b_6:2;
        RBus_UInt32  main_dither_seq_b_7:2;
        RBus_UInt32  main_dither_seq_b_8:2;
        RBus_UInt32  main_dither_seq_b_9:2;
        RBus_UInt32  main_dither_seq_b_10:2;
        RBus_UInt32  main_dither_seq_b_11:2;
        RBus_UInt32  main_dither_seq_b_12:2;
        RBus_UInt32  main_dither_seq_b_13:2;
        RBus_UInt32  main_dither_seq_b_14:2;
        RBus_UInt32  main_dither_seq_b_15:2;
    };
}main_dither_i_main_dither_seq_b_00_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  main_dither_seq_b_16:2;
        RBus_UInt32  main_dither_seq_b_17:2;
        RBus_UInt32  main_dither_seq_b_18:2;
        RBus_UInt32  main_dither_seq_b_19:2;
        RBus_UInt32  main_dither_seq_b_20:2;
        RBus_UInt32  main_dither_seq_b_21:2;
        RBus_UInt32  main_dither_seq_b_22:2;
        RBus_UInt32  main_dither_seq_b_23:2;
        RBus_UInt32  main_dither_seq_b_24:2;
        RBus_UInt32  main_dither_seq_b_25:2;
        RBus_UInt32  main_dither_seq_b_26:2;
        RBus_UInt32  main_dither_seq_b_27:2;
        RBus_UInt32  main_dither_seq_b_28:2;
        RBus_UInt32  main_dither_seq_b_29:2;
        RBus_UInt32  main_dither_seq_b_30:2;
        RBus_UInt32  main_dither_seq_b_31:2;
    };
}main_dither_i_main_dither_seq_b_16_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  main_dither_tab_r_00:4;
        RBus_UInt32  main_dither_tab_r_01:4;
        RBus_UInt32  main_dither_tab_r_02:4;
        RBus_UInt32  main_dither_tab_r_03:4;
        RBus_UInt32  main_dither_tab_r_10:4;
        RBus_UInt32  main_dither_tab_r_11:4;
        RBus_UInt32  main_dither_tab_r_12:4;
        RBus_UInt32  main_dither_tab_r_13:4;
    };
}main_dither_i_main_dither_tb_r_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  main_dither_tab_r_20:4;
        RBus_UInt32  main_dither_tab_r_21:4;
        RBus_UInt32  main_dither_tab_r_22:4;
        RBus_UInt32  main_dither_tab_r_23:4;
        RBus_UInt32  main_dither_tab_r_30:4;
        RBus_UInt32  main_dither_tab_r_31:4;
        RBus_UInt32  main_dither_tab_r_32:4;
        RBus_UInt32  main_dither_tab_r_33:4;
    };
}main_dither_i_main_dither_tb_r_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  main_dither_tab_g_00:4;
        RBus_UInt32  main_dither_tab_g_01:4;
        RBus_UInt32  main_dither_tab_g_02:4;
        RBus_UInt32  main_dither_tab_g_03:4;
        RBus_UInt32  main_dither_tab_g_10:4;
        RBus_UInt32  main_dither_tab_g_11:4;
        RBus_UInt32  main_dither_tab_g_12:4;
        RBus_UInt32  main_dither_tab_g_13:4;
    };
}main_dither_i_main_dither_tb_g_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  main_dither_tab_g_20:4;
        RBus_UInt32  main_dither_tab_g_21:4;
        RBus_UInt32  main_dither_tab_g_22:4;
        RBus_UInt32  main_dither_tab_g_23:4;
        RBus_UInt32  main_dither_tab_g_30:4;
        RBus_UInt32  main_dither_tab_g_31:4;
        RBus_UInt32  main_dither_tab_g_32:4;
        RBus_UInt32  main_dither_tab_g_33:4;
    };
}main_dither_i_main_dither_tb_g_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  main_dither_tab_b_00:4;
        RBus_UInt32  main_dither_tab_b_01:4;
        RBus_UInt32  main_dither_tab_b_02:4;
        RBus_UInt32  main_dither_tab_b_03:4;
        RBus_UInt32  main_dither_tab_b_10:4;
        RBus_UInt32  main_dither_tab_b_11:4;
        RBus_UInt32  main_dither_tab_b_12:4;
        RBus_UInt32  main_dither_tab_b_13:4;
    };
}main_dither_i_main_dither_tb_b_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  main_dither_tab_b_20:4;
        RBus_UInt32  main_dither_tab_b_21:4;
        RBus_UInt32  main_dither_tab_b_22:4;
        RBus_UInt32  main_dither_tab_b_23:4;
        RBus_UInt32  main_dither_tab_b_30:4;
        RBus_UInt32  main_dither_tab_b_31:4;
        RBus_UInt32  main_dither_tab_b_32:4;
        RBus_UInt32  main_dither_tab_b_33:4;
    };
}main_dither_i_main_dither_tb_b_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  main_dither_tab_temp_offset_0:2;
        RBus_UInt32  main_dither_tab_temp_offset_1:2;
        RBus_UInt32  main_dither_tab_temp_offset_2:2;
        RBus_UInt32  main_dither_tab_temp_offset_3:2;
        RBus_UInt32  main_dither_tab_temp_offset_4:2;
        RBus_UInt32  main_dither_tab_temp_offset_5:2;
        RBus_UInt32  main_dither_tab_temp_offset_6:2;
        RBus_UInt32  main_dither_tab_temp_offset_7:2;
        RBus_UInt32  main_dither_tab_temp_offset_8:2;
        RBus_UInt32  main_dither_tab_temp_offset_9:2;
        RBus_UInt32  main_dither_tab_temp_offset_10:2;
        RBus_UInt32  main_dither_tab_temp_offset_11:2;
        RBus_UInt32  main_dither_tab_temp_offset_12:2;
        RBus_UInt32  main_dither_tab_temp_offset_13:2;
        RBus_UInt32  main_dither_tab_temp_offset_14:2;
        RBus_UInt32  main_dither_tab_temp_offset_15:2;
    };
}main_dither_i_main_dither_temp_tb_RBUS;




#endif 


#endif 
