/**
* @file Mac7p-DesignSpec-I-Domain_SmartFIT
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2019/11/22
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_SMARTFIT_REG_H_
#define _RBUS_SMARTFIT_REG_H_

#include "rbusTypes.h"



//  SMARTFIT Register Address



#define  SMARTFIT_AUTO_FIELD_VADDR                          	(0xb8022000)
#define  SMARTFIT_AUTO_H_BOUNDARY_VADDR                     	(0xb8022004)
#define  SMARTFIT_AUTO_V_BOUNDARY_VADDR                     	(0xb8022008)
#define  SMARTFIT_AUTO_R_G_B_MARGIN_VADDR                   	(0xb802200c)
#define  SMARTFIT_AUTO_ADJ_VADDR                            	(0xb8022010)
#define  SMARTFIT_AUTO_RESULT_VSTA_END_VADDR                	(0xb8022014)
#define  SMARTFIT_AUTO_RESULT_HSTA_END_VADDR                	(0xb8022018)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======SMARTFIT register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smartfit_src_sel:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  smfit_en_n:1;
        RBus_UInt32  res2:15;
        RBus_UInt32  smfit_vs_delay_sel:1;
        RBus_UInt32  vgip_db_disable:1;
        RBus_UInt32  adj_source:2;
        RBus_UInt32  rl_sel_en:1;
        RBus_UInt32  rl_sel:1;
        RBus_UInt32  odd_sel_en:1;
        RBus_UInt32  odd_sel:1;
        RBus_UInt32  no_hs_mode:1;
        RBus_UInt32  res3:5;
    };
}smartfit_auto_field_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  hb_sta:14;
        RBus_UInt32  res2:2;
        RBus_UInt32  hb_end:14;
    };
}smartfit_auto_h_boundary_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  vb_sta:14;
        RBus_UInt32  res2:2;
        RBus_UInt32  vb_end:14;
    };
}smartfit_auto_v_boundary_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  red_nm:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  grn_nm:6;
        RBus_UInt32  vb_th:2;
        RBus_UInt32  blu_nm:6;
        RBus_UInt32  dummy1802200c_9:1;
        RBus_UInt32  res2:9;
    };
}smartfit_auto_r_g_b_margin_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  m_vgen_en:1;
        RBus_UInt32  res2:5;
        RBus_UInt32  dummy18022010_1:1;
        RBus_UInt32  now_af:1;
    };
}smartfit_auto_adj_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  vx_sta:14;
        RBus_UInt32  res2:2;
        RBus_UInt32  vx_end:14;
    };
}smartfit_auto_result_vsta_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  hx_sta:14;
        RBus_UInt32  res2:2;
        RBus_UInt32  hx_end:14;
    };
}smartfit_auto_result_hsta_end_RBUS;

#else //apply LITTLE_ENDIAN

//======SMARTFIT register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  no_hs_mode:1;
        RBus_UInt32  odd_sel:1;
        RBus_UInt32  odd_sel_en:1;
        RBus_UInt32  rl_sel:1;
        RBus_UInt32  rl_sel_en:1;
        RBus_UInt32  adj_source:2;
        RBus_UInt32  vgip_db_disable:1;
        RBus_UInt32  smfit_vs_delay_sel:1;
        RBus_UInt32  res2:15;
        RBus_UInt32  smfit_en_n:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  smartfit_src_sel:1;
    };
}smartfit_auto_field_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hb_end:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  hb_sta:14;
        RBus_UInt32  res2:2;
    };
}smartfit_auto_h_boundary_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vb_end:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  vb_sta:14;
        RBus_UInt32  res2:2;
    };
}smartfit_auto_v_boundary_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  dummy1802200c_9:1;
        RBus_UInt32  blu_nm:6;
        RBus_UInt32  vb_th:2;
        RBus_UInt32  grn_nm:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  red_nm:6;
    };
}smartfit_auto_r_g_b_margin_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  now_af:1;
        RBus_UInt32  dummy18022010_1:1;
        RBus_UInt32  res1:5;
        RBus_UInt32  m_vgen_en:1;
        RBus_UInt32  res2:24;
    };
}smartfit_auto_adj_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vx_end:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  vx_sta:14;
        RBus_UInt32  res2:2;
    };
}smartfit_auto_result_vsta_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hx_end:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  hx_sta:14;
        RBus_UInt32  res2:2;
    };
}smartfit_auto_result_hsta_end_RBUS;




#endif 


#endif 
