/**
* @file Mac7p_DesignSpec_Vby1_OSD
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2019/11/22
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_VBY1_OSD_REG_H_
#define _RBUS_VBY1_OSD_REG_H_

#include "rbusTypes.h"



//  VBY1_OSD Register Address



#define  VBY1_OSD_OSD_VIDEO_FORMAT_VADDR                    	(0xb802d800)
#define  VBY1_OSD_OSD_LANE_STATUS_VADDR                     	(0xb802d804)
#define  VBY1_OSD_OSD_CTL_VADDR                             	(0xb802d808)
#define  VBY1_OSD_OSD_TRANSMIT_CONTROL_VADDR                	(0xb802d80c)
#define  VBY1_OSD_OSD_TRANSMIT_STATUS_VADDR                 	(0xb802d810)
#define  VBY1_OSD_OSD_THREE_FLAG_VADDR                      	(0xb802d814)
#define  VBY1_OSD_OSD_CRC_CONTROL_VADDR                     	(0xb802d818)
#define  VBY1_OSD_OSD_CRC_RESULT_VADDR                      	(0xb802d81c)
#define  VBY1_OSD_OSD_CRC_DES_VADDR                         	(0xb802d820)
#define  VBY1_OSD_OSD_CRC_ERROR_CNT_VADDR                   	(0xb802d824)
#define  VBY1_OSD_OSD_ASYNC_FIFO_RST_VADDR                  	(0xb802d828)
#define  VBY1_OSD_OSD_VBY1_DEBUG_VADDR                      	(0xb802d82c)
#define  VBY1_OSD_OSD_VBY1_STATUS_FW_CTRL_VADDR             	(0xb802d830)
#define  VBY1_OSD_OSD_DATA_CAPTURE_VADDR                    	(0xb802d834)
#define  VBY1_OSD_OSD_DATA_CAPTURE_1_VADDR                  	(0xb802d838)
#define  VBY1_OSD_OSD_DATA_CAPTURE_2_VADDR                  	(0xb802d83c)
#define  VBY1_OSD_OSD_DBG_EN_VADDR                          	(0xb802d850)
#define  VBY1_OSD_OSD_DBG_DATA_VADDR                        	(0xb802d854)
#define  VBY1_OSD_OSD_DPHY_CTL_VADDR                        	(0xb802d858)
#define  VBY1_OSD_OSD_DPHY_RD_VADDR                         	(0xb802d85c)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======VBY1_OSD register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  vby1_aphy0_7_in_sel:2;
        RBus_UInt32  vby1_aphy8_15_in_sel:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  lclk_inv_sel:1;
        RBus_UInt32  vby1_dclk_div_sel:3;
        RBus_UInt32  color_format:4;
        RBus_UInt32  res3:6;
        RBus_UInt32  win:10;
    };
}vby1_osd_osd_video_format_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:11;
        RBus_UInt32  lane_count:5;
        RBus_UInt32  res2:13;
        RBus_UInt32  byte_mode:3;
    };
}vby1_osd_osd_lane_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  ctl:16;
    };
}vby1_osd_osd_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_en:1;
        RBus_UInt32  pll_stable:1;
        RBus_UInt32  transfer_en:1;
        RBus_UInt32  video_trans_mode:1;
        RBus_UInt32  debounce_cnt:4;
        RBus_UInt32  bs_after_aln:1;
        RBus_UInt32  be_before_aln:1;
        RBus_UInt32  reg_delay:22;
    };
}vby1_osd_osd_transmit_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802d810_31_8:24;
        RBus_UInt32  res1:2;
        RBus_UInt32  aln_finish:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  video_en:1;
        RBus_UInt32  aln_en:1;
        RBus_UInt32  cdr_en:1;
    };
}vby1_osd_osd_transmit_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  three_mode:2;
        RBus_UInt32  three_en:1;
    };
}vby1_osd_osd_three_flag_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  lane_crc_en:4;
        RBus_UInt32  res2:13;
        RBus_UInt32  reg_crc_auto_cmp_en:1;
        RBus_UInt32  reg_crc_conti:1;
        RBus_UInt32  reg_crc_start:1;
    };
}vby1_osd_osd_crc_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_result:32;
    };
}vby1_osd_osd_crc_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_crc_des:32;
    };
}vby1_osd_osd_crc_des_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  crc_err_cnt:16;
    };
}vby1_osd_osd_crc_error_cnt_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:14;
        RBus_UInt32  fifo_vs_rst_en:2;
        RBus_UInt32  fifo_vs_rst_delay:16;
    };
}vby1_osd_osd_async_fifo_rst_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  dummy1802d82c_3_0:4;
    };
}vby1_osd_osd_vby1_debug_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  htpdn_mode_ctrl:1;
        RBus_UInt32  lockn_mode_ctrl:1;
        RBus_UInt32  fw_htpdn_set:1;
        RBus_UInt32  fw_lockn_set:1;
        RBus_UInt32  htpdn_ie:1;
        RBus_UInt32  lockn_ie:1;
        RBus_UInt32  htpdn_int_status:1;
        RBus_UInt32  lockn_int_status:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  vs_inv:1;
        RBus_UInt32  hs_inv:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  de_only_mode_vs_set:1;
        RBus_UInt32  de_only_mode_hs_set:1;
        RBus_UInt32  de_only_mode:1;
        RBus_UInt32  res3:12;
        RBus_UInt32  htpdn:1;
        RBus_UInt32  lockn:1;
        RBus_UInt32  hw_htpdn:1;
        RBus_UInt32  hw_lockn:1;
    };
}vby1_osd_osd_vby1_status_fw_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  capture_lane_sel:4;
        RBus_UInt32  capture_active_only:1;
        RBus_UInt32  capture_v:11;
        RBus_UInt32  capture_en:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  capture_h:13;
    };
}vby1_osd_osd_data_capture_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  dummy1802d838_7_0:8;
    };
}vby1_osd_osd_data_capture_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  capture_data_l:32;
    };
}vby1_osd_osd_data_capture_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  dbg_en:1;
    };
}vby1_osd_osd_dbg_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dbg_data:32;
    };
}vby1_osd_osd_dbg_data_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  e8b10b_en:1;
        RBus_UInt32  e8b10b_initial_running_disparity:1;
        RBus_UInt32  e8b10b_dis_i:1;
        RBus_UInt32  e8b10b_dis_j:1;
        RBus_UInt32  res1:7;
        RBus_UInt32  scr_sel:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  scramble_en:1;
        RBus_UInt32  scramble_initial_value:16;
    };
}vby1_osd_osd_dphy_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  e8b10b_running_disparity:4;
    };
}vby1_osd_osd_dphy_rd_RBUS;

#else //apply LITTLE_ENDIAN

//======VBY1_OSD register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  win:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  color_format:4;
        RBus_UInt32  vby1_dclk_div_sel:3;
        RBus_UInt32  lclk_inv_sel:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  vby1_aphy8_15_in_sel:2;
        RBus_UInt32  vby1_aphy0_7_in_sel:2;
        RBus_UInt32  res3:2;
    };
}vby1_osd_osd_video_format_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  byte_mode:3;
        RBus_UInt32  res1:13;
        RBus_UInt32  lane_count:5;
        RBus_UInt32  res2:11;
    };
}vby1_osd_osd_lane_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ctl:16;
        RBus_UInt32  res1:16;
    };
}vby1_osd_osd_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_delay:22;
        RBus_UInt32  be_before_aln:1;
        RBus_UInt32  bs_after_aln:1;
        RBus_UInt32  debounce_cnt:4;
        RBus_UInt32  video_trans_mode:1;
        RBus_UInt32  transfer_en:1;
        RBus_UInt32  pll_stable:1;
        RBus_UInt32  reg_en:1;
    };
}vby1_osd_osd_transmit_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cdr_en:1;
        RBus_UInt32  aln_en:1;
        RBus_UInt32  video_en:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  aln_finish:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  dummy1802d810_31_8:24;
    };
}vby1_osd_osd_transmit_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  three_en:1;
        RBus_UInt32  three_mode:2;
        RBus_UInt32  res1:29;
    };
}vby1_osd_osd_three_flag_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_crc_start:1;
        RBus_UInt32  reg_crc_conti:1;
        RBus_UInt32  reg_crc_auto_cmp_en:1;
        RBus_UInt32  res1:13;
        RBus_UInt32  lane_crc_en:4;
        RBus_UInt32  res2:12;
    };
}vby1_osd_osd_crc_control_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_result:32;
    };
}vby1_osd_osd_crc_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_crc_des:32;
    };
}vby1_osd_osd_crc_des_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_err_cnt:16;
        RBus_UInt32  res1:16;
    };
}vby1_osd_osd_crc_error_cnt_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fifo_vs_rst_delay:16;
        RBus_UInt32  fifo_vs_rst_en:2;
        RBus_UInt32  res1:14;
    };
}vby1_osd_osd_async_fifo_rst_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802d82c_3_0:4;
        RBus_UInt32  res1:28;
    };
}vby1_osd_osd_vby1_debug_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hw_lockn:1;
        RBus_UInt32  hw_htpdn:1;
        RBus_UInt32  lockn:1;
        RBus_UInt32  htpdn:1;
        RBus_UInt32  res1:12;
        RBus_UInt32  de_only_mode:1;
        RBus_UInt32  de_only_mode_hs_set:1;
        RBus_UInt32  de_only_mode_vs_set:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  hs_inv:1;
        RBus_UInt32  vs_inv:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  lockn_int_status:1;
        RBus_UInt32  htpdn_int_status:1;
        RBus_UInt32  lockn_ie:1;
        RBus_UInt32  htpdn_ie:1;
        RBus_UInt32  fw_lockn_set:1;
        RBus_UInt32  fw_htpdn_set:1;
        RBus_UInt32  lockn_mode_ctrl:1;
        RBus_UInt32  htpdn_mode_ctrl:1;
    };
}vby1_osd_osd_vby1_status_fw_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  capture_h:13;
        RBus_UInt32  res1:2;
        RBus_UInt32  capture_en:1;
        RBus_UInt32  capture_v:11;
        RBus_UInt32  capture_active_only:1;
        RBus_UInt32  capture_lane_sel:4;
    };
}vby1_osd_osd_data_capture_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1802d838_7_0:8;
        RBus_UInt32  res1:24;
    };
}vby1_osd_osd_data_capture_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  capture_data_l:32;
    };
}vby1_osd_osd_data_capture_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dbg_en:1;
        RBus_UInt32  res1:31;
    };
}vby1_osd_osd_dbg_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dbg_data:32;
    };
}vby1_osd_osd_dbg_data_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  scramble_initial_value:16;
        RBus_UInt32  scramble_en:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  scr_sel:1;
        RBus_UInt32  res2:7;
        RBus_UInt32  e8b10b_dis_j:1;
        RBus_UInt32  e8b10b_dis_i:1;
        RBus_UInt32  e8b10b_initial_running_disparity:1;
        RBus_UInt32  e8b10b_en:1;
    };
}vby1_osd_osd_dphy_ctl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  e8b10b_running_disparity:4;
        RBus_UInt32  res1:28;
    };
}vby1_osd_osd_dphy_rd_RBUS;




#endif 


#endif 
