/**
* @file rbusFCIC_TOPReg.h
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2016/6/3
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_FCIC_TOP_REG_H_
#define _RBUS_FCIC_TOP_REG_H_

#include "rbusTypes.h"



//  FCIC_TOP Register Address



#define  FCIC_TOP_FCIC_CTRL_1_VADDR                         	(0xb802ec00)
#define  FCIC_TOP_FCIC_CRTL_2_VADDR                         	(0xb802ec04)
#define  FCIC_TOP_FCIC_EEPROM_IF_1_VADDR                    	(0xb802ec08)
#define  FCIC_TOP_FCIC_EEPROM_IF_2_VADDR                    	(0xb802ec0c)
#define  FCIC_TOP_FCIC_FLASH_IF_1_VADDR                     	(0xb802ec10)
#define  FCIC_TOP_FCIC_FLASH_IF_2_VADDR                     	(0xb802ec14)
#define  FCIC_TOP_FCIC_FLASH_IF_3_VADDR                     	(0xb802ec18)
#define  FCIC_TOP_FCIC_FLASH_IF_4_VADDR                     	(0xb802ec1c)
#define  FCIC_TOP_FCIC_FLASH_IF_5_VADDR                     	(0xb802ec20)
#define  FCIC_TOP_FCIC_FLASH_DBG_1_VADDR                    	(0xb802ec24)
#define  FCIC_TOP_FCIC_FLASH_DBG_2_VADDR                    	(0xb802ec28)
#define  FCIC_TOP_FCIC_FLASH_DBG_3_VADDR                    	(0xb802ec2c)
#define  FCIC_TOP_FCIC_BIST_MODE_VADDR                      	(0xb802ec30)
#define  FCIC_TOP_FCIC_DRF_MODE_VADDR                       	(0xb802ec34)
#define  FCIC_TOP_FCIC_DRF_RESUME_VADDR                     	(0xb802ec38)
#define  FCIC_TOP_FCIC_BIST_DONE_VADDR                      	(0xb802ec3c)
#define  FCIC_TOP_FCIC_DRF_DONE_VADDR                       	(0xb802ec40)
#define  FCIC_TOP_FCIC_BIST_FAIL_0_VADDR                    	(0xb802ec44)
#define  FCIC_TOP_FCIC_BIST_FAIL_1_VADDR                    	(0xb802ec48)
#define  FCIC_TOP_FCIC_DRF_FAIL_0_VADDR                     	(0xb802ec4c)
#define  FCIC_TOP_FCIC_DRF_FAIL_1_VADDR                     	(0xb802ec50)
#define  FCIC_TOP_FCIC_DRF_PAUSE_VADDR                      	(0xb802ec54)
#define  FCIC_TOP_FCIC_RME_0_VADDR                          	(0xb802ec58)
#define  FCIC_TOP_FCIC_RME_1_VADDR                          	(0xb802ec5c)
#define  FCIC_TOP_FCIC_RM_0_VADDR                           	(0xb802ec60)
#define  FCIC_TOP_FCIC_RM_1_VADDR                           	(0xb802ec64)
#define  FCIC_TOP_FCIC_RM_2_VADDR                           	(0xb802ec68)
#define  FCIC_TOP_FCIC_RM_3_VADDR                           	(0xb802ec6c)
#define  FCIC_TOP_FCIC_RM_4_VADDR                           	(0xb802ec70)
#define  FCIC_TOP_FCIC_RM_5_VADDR                           	(0xb802ec74)
#define  FCIC_TOP_FCIC_RM_6_VADDR                           	(0xb802ec78)
#define  FCIC_TOP_FCIC_IO_REG_VADDR                         	(0xb802ec7c)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======FCIC_TOP register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  fcic_rbus_if_enable:2;
    };
}fcic_top_fcic_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:23;
        RBus_UInt32  auto_detect_result:2;
        RBus_UInt32  auto_detect_en:1;
        RBus_UInt32  user_timing_sel:2;
        RBus_UInt32  multi_access_en:1;
        RBus_UInt32  flash_write_enable:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  eeprom_write_enable:1;
    };
}fcic_top_fcic_crtl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:12;
        RBus_UInt32  cfg_rdata:8;
        RBus_UInt32  cfg_addr:12;
    };
}fcic_top_fcic_eeprom_if_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cfg_data_3:8;
        RBus_UInt32  cfg_data_2:8;
        RBus_UInt32  cfg_data_1:8;
        RBus_UInt32  cfg_data_0:8;
    };
}fcic_top_fcic_eeprom_if_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:14;
        RBus_UInt32  flash_done:1;
        RBus_UInt32  flash_addr:17;
    };
}fcic_top_fcic_flash_if_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  flash_data_0:32;
    };
}fcic_top_fcic_flash_if_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  flash_data_1:32;
    };
}fcic_top_fcic_flash_if_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  flash_data_2:32;
    };
}fcic_top_fcic_flash_if_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  flash_data_3:32;
    };
}fcic_top_fcic_flash_if_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  rd_addr:15;
        RBus_UInt32  res2:6;
        RBus_UInt32  flash_dbg_rd_en:1;
        RBus_UInt32  eep_dbg_rd_en:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  template_data_mux:3;
        RBus_UInt32  flash_dbg_mux:4;
    };
}fcic_top_fcic_flash_dbg_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  flash_rdata_0:32;
    };
}fcic_top_fcic_flash_dbg_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  flash_rdata_1:32;
    };
}fcic_top_fcic_flash_dbg_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mbist_fcic_ed_bist_mode:1;
        RBus_UInt32  mbist_fcic_template_bist_mode:1;
        RBus_UInt32  mbist_fcic_template_2_bist_mode:1;
        RBus_UInt32  mbist_fcic_template_1_bist_mode:1;
        RBus_UInt32  mbist_fcic_int_2_bist_mode:1;
        RBus_UInt32  mbist_fcic_int_1_bist_mode:1;
        RBus_UInt32  mbist_fcic_16728_2_bist_mode:1;
        RBus_UInt32  mbist_fcic_16728_1_bist_mode:1;
    };
}fcic_top_fcic_bist_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mbist_fcic_ed_drf_mode:1;
        RBus_UInt32  mbist_fcic_template_drf_mode:1;
        RBus_UInt32  mbist_fcic_template_2_drf_mode:1;
        RBus_UInt32  mbist_fcic_template_1_drf_mode:1;
        RBus_UInt32  mbist_fcic_int_2_drf_mode:1;
        RBus_UInt32  mbist_fcic_int_1_drf_mode:1;
        RBus_UInt32  mbist_fcic_16728_2_drf_mode:1;
        RBus_UInt32  mbist_fcic_16728_1_drf_mode:1;
    };
}fcic_top_fcic_drf_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mbist_fcic_ed_drf_resume:1;
        RBus_UInt32  mbist_fcic_template_drf_resume:1;
        RBus_UInt32  mbist_fcic_template_2_drf_resume:1;
        RBus_UInt32  mbist_fcic_template_1_drf_resume:1;
        RBus_UInt32  mbist_fcic_int_2_drf_resume:1;
        RBus_UInt32  mbist_fcic_int_1_drf_resume:1;
        RBus_UInt32  mbist_fcic_16728_2_drf_resume:1;
        RBus_UInt32  mbist_fcic_16728_1_drf_resume:1;
    };
}fcic_top_fcic_drf_resume_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mbist_fcic_ed_bist_done:1;
        RBus_UInt32  mbist_fcic_template_bist_done:1;
        RBus_UInt32  mbist_fcic_template_2_bist_done:1;
        RBus_UInt32  mbist_fcic_template_1_bist_done:1;
        RBus_UInt32  mbist_fcic_int_2_bist_done:1;
        RBus_UInt32  mbist_fcic_int_1_bist_done:1;
        RBus_UInt32  mbist_fcic_16728_2_bist_done:1;
        RBus_UInt32  mbist_fcic_16728_1_bist_done:1;
    };
}fcic_top_fcic_bist_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mbist_fcic_ed_drf_done:1;
        RBus_UInt32  mbist_fcic_template_drf_done:1;
        RBus_UInt32  mbist_fcic_template_2_drf_done:1;
        RBus_UInt32  mbist_fcic_template_1_drf_done:1;
        RBus_UInt32  mbist_fcic_int_2_drf_done:1;
        RBus_UInt32  mbist_fcic_int_1_drf_done:1;
        RBus_UInt32  mbist_fcic_16728_2_drf_done:1;
        RBus_UInt32  mbist_fcic_16728_1_drf_done:1;
    };
}fcic_top_fcic_drf_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  mbist_fcic_int_2_bist_fail:6;
        RBus_UInt32  mbist_fcic_int_1_bist_fail:6;
        RBus_UInt32  mbist_fcic_16728_2_bist_fail:8;
        RBus_UInt32  mbist_fcic_16728_1_bist_fail:8;
    };
}fcic_top_fcic_bist_fail_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  mbist_fcic_ed_bist_fail:1;
        RBus_UInt32  mbist_fcic_template_bist_fail:7;
        RBus_UInt32  mbist_fcic_template_2_bist_fail:8;
        RBus_UInt32  mbist_fcic_template_1_bist_fail:8;
    };
}fcic_top_fcic_bist_fail_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  mbist_fcic_int_2_drf_fail:6;
        RBus_UInt32  mbist_fcic_int_1_drf_fail:6;
        RBus_UInt32  mbist_fcic_16728_2_drf_fail:8;
        RBus_UInt32  mbist_fcic_16728_1_drf_fail:8;
    };
}fcic_top_fcic_drf_fail_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  mbist_fcic_ed_drf_fail:1;
        RBus_UInt32  mbist_fcic_template_drf_fail:7;
        RBus_UInt32  mbist_fcic_template_2_drf_fail:8;
        RBus_UInt32  mbist_fcic_template_1_drf_fail:8;
    };
}fcic_top_fcic_drf_fail_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mbist_fcic_ed_drf_pause:1;
        RBus_UInt32  mbist_fcic_template_drf_pause:1;
        RBus_UInt32  mbist_fcic_template_2_drf_pause:1;
        RBus_UInt32  mbist_fcic_template_1_drf_pause:1;
        RBus_UInt32  mbist_fcic_int_2_drf_pause:1;
        RBus_UInt32  mbist_fcic_int_1_drf_pause:1;
        RBus_UInt32  mbist_fcic_16728_2_drf_pause:1;
        RBus_UInt32  mbist_fcic_16728_1_drf_pause:1;
    };
}fcic_top_fcic_drf_pause_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  testrwm:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  fcic_int_2_rme_5:1;
        RBus_UInt32  fcic_int_2_rme_4:1;
        RBus_UInt32  fcic_int_2_rme_3:1;
        RBus_UInt32  fcic_int_2_rme_2:1;
        RBus_UInt32  fcic_int_2_rme_1:1;
        RBus_UInt32  fcic_int_2_rme_0:1;
        RBus_UInt32  fcic_int_1_rme_5:1;
        RBus_UInt32  fcic_int_1_rme_4:1;
        RBus_UInt32  fcic_int_1_rme_3:1;
        RBus_UInt32  fcic_int_1_rme_2:1;
        RBus_UInt32  fcic_int_1_rme_1:1;
        RBus_UInt32  fcic_int_1_rme_0:1;
        RBus_UInt32  fcic_16728_2_rme_7:1;
        RBus_UInt32  fcic_16728_2_rme_6:1;
        RBus_UInt32  fcic_16728_2_rme_5:1;
        RBus_UInt32  fcic_16728_2_rme_4:1;
        RBus_UInt32  fcic_16728_2_rme_3:1;
        RBus_UInt32  fcic_16728_2_rme_2:1;
        RBus_UInt32  fcic_16728_2_rme_1:1;
        RBus_UInt32  fcic_16728_2_rme_0:1;
        RBus_UInt32  fcic_16728_1_rme_7:1;
        RBus_UInt32  fcic_16728_1_rme_6:1;
        RBus_UInt32  fcic_16728_1_rme_5:1;
        RBus_UInt32  fcic_16728_1_rme_4:1;
        RBus_UInt32  fcic_16728_1_rme_3:1;
        RBus_UInt32  fcic_16728_1_rme_2:1;
        RBus_UInt32  fcic_16728_1_rme_1:1;
        RBus_UInt32  fcic_16728_1_rme_0:1;
    };
}fcic_top_fcic_rme_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  fcic_ed_rme_0:1;
        RBus_UInt32  fcic_template_rme_6:1;
        RBus_UInt32  fcic_template_rme_5:1;
        RBus_UInt32  fcic_template_rme_4:1;
        RBus_UInt32  fcic_template_rme_3:1;
        RBus_UInt32  fcic_template_rme_2:1;
        RBus_UInt32  fcic_template_rme_1:1;
        RBus_UInt32  fcic_template_rme_0:1;
        RBus_UInt32  fcic_template_2_rme_7:1;
        RBus_UInt32  fcic_template_2_rme_6:1;
        RBus_UInt32  fcic_template_2_rme_5:1;
        RBus_UInt32  fcic_template_2_rme_4:1;
        RBus_UInt32  fcic_template_2_rme_3:1;
        RBus_UInt32  fcic_template_2_rme_2:1;
        RBus_UInt32  fcic_template_2_rme_1:1;
        RBus_UInt32  fcic_template_2_rme_0:1;
        RBus_UInt32  fcic_template_1_rme_7:1;
        RBus_UInt32  fcic_template_1_rme_6:1;
        RBus_UInt32  fcic_template_1_rme_5:1;
        RBus_UInt32  fcic_template_1_rme_4:1;
        RBus_UInt32  fcic_template_1_rme_3:1;
        RBus_UInt32  fcic_template_1_rme_2:1;
        RBus_UInt32  fcic_template_1_rme_1:1;
        RBus_UInt32  fcic_template_1_rme_0:1;
    };
}fcic_top_fcic_rme_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fcic_16728_1_rm_7:4;
        RBus_UInt32  fcic_16728_1_rm_6:4;
        RBus_UInt32  fcic_16728_1_rm_5:4;
        RBus_UInt32  fcic_16728_1_rm_4:4;
        RBus_UInt32  fcic_16728_1_rm_3:4;
        RBus_UInt32  fcic_16728_1_rm_2:4;
        RBus_UInt32  fcic_16728_1_rm_1:4;
        RBus_UInt32  fcic_16728_1_rm_0:4;
    };
}fcic_top_fcic_rm_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fcic_16728_2_rm_7:4;
        RBus_UInt32  fcic_16728_2_rm_6:4;
        RBus_UInt32  fcic_16728_2_rm_5:4;
        RBus_UInt32  fcic_16728_2_rm_4:4;
        RBus_UInt32  fcic_16728_2_rm_3:4;
        RBus_UInt32  fcic_16728_2_rm_2:4;
        RBus_UInt32  fcic_16728_2_rm_1:4;
        RBus_UInt32  fcic_16728_2_rm_0:4;
    };
}fcic_top_fcic_rm_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  fcic_int_1_rm_5:4;
        RBus_UInt32  fcic_int_1_rm_4:4;
        RBus_UInt32  fcic_int_1_rm_3:4;
        RBus_UInt32  fcic_int_1_rm_2:4;
        RBus_UInt32  fcic_int_1_rm_1:4;
        RBus_UInt32  fcic_int_1_rm_0:4;
    };
}fcic_top_fcic_rm_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  fcic_int_2_rm_5:4;
        RBus_UInt32  fcic_int_2_rm_4:4;
        RBus_UInt32  fcic_int_2_rm_3:4;
        RBus_UInt32  fcic_int_2_rm_2:4;
        RBus_UInt32  fcic_int_2_rm_1:4;
        RBus_UInt32  fcic_int_2_rm_0:4;
    };
}fcic_top_fcic_rm_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fcic_template_1_rm_7:4;
        RBus_UInt32  fcic_template_1_rm_6:4;
        RBus_UInt32  fcic_template_1_rm_5:4;
        RBus_UInt32  fcic_template_1_rm_4:4;
        RBus_UInt32  fcic_template_1_rm_3:4;
        RBus_UInt32  fcic_template_1_rm_2:4;
        RBus_UInt32  fcic_template_1_rm_1:4;
        RBus_UInt32  fcic_template_1_rm_0:4;
    };
}fcic_top_fcic_rm_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fcic_template_2_rm_7:4;
        RBus_UInt32  fcic_template_2_rm_6:4;
        RBus_UInt32  fcic_template_2_rm_5:4;
        RBus_UInt32  fcic_template_2_rm_4:4;
        RBus_UInt32  fcic_template_2_rm_3:4;
        RBus_UInt32  fcic_template_2_rm_2:4;
        RBus_UInt32  fcic_template_2_rm_1:4;
        RBus_UInt32  fcic_template_2_rm_0:4;
    };
}fcic_top_fcic_rm_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fcic_ed_rm_0:4;
        RBus_UInt32  fcic_template_rm_6:4;
        RBus_UInt32  fcic_template_rm_5:4;
        RBus_UInt32  fcic_template_rm_4:4;
        RBus_UInt32  fcic_template_rm_3:4;
        RBus_UInt32  fcic_template_rm_2:4;
        RBus_UInt32  fcic_template_rm_1:4;
        RBus_UInt32  fcic_template_rm_0:4;
    };
}fcic_top_fcic_rm_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  color_4:2;
        RBus_UInt32  color_3:2;
        RBus_UInt32  color_2:2;
        RBus_UInt32  color_1:2;
        RBus_UInt32  mplus_opt:1;
        RBus_UInt32  fcic_io_reg_en:1;
    };
}fcic_top_fcic_io_reg_RBUS;

#else //apply LITTLE_ENDIAN

//======FCIC_TOP register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fcic_rbus_if_enable:2;
        RBus_UInt32  res1:30;
    };
}fcic_top_fcic_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eeprom_write_enable:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  flash_write_enable:1;
        RBus_UInt32  multi_access_en:1;
        RBus_UInt32  user_timing_sel:2;
        RBus_UInt32  auto_detect_en:1;
        RBus_UInt32  auto_detect_result:2;
        RBus_UInt32  res2:23;
    };
}fcic_top_fcic_crtl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cfg_addr:12;
        RBus_UInt32  cfg_rdata:8;
        RBus_UInt32  res1:12;
    };
}fcic_top_fcic_eeprom_if_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cfg_data_0:8;
        RBus_UInt32  cfg_data_1:8;
        RBus_UInt32  cfg_data_2:8;
        RBus_UInt32  cfg_data_3:8;
    };
}fcic_top_fcic_eeprom_if_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  flash_addr:17;
        RBus_UInt32  flash_done:1;
        RBus_UInt32  res1:14;
    };
}fcic_top_fcic_flash_if_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  flash_data_0:32;
    };
}fcic_top_fcic_flash_if_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  flash_data_1:32;
    };
}fcic_top_fcic_flash_if_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  flash_data_2:32;
    };
}fcic_top_fcic_flash_if_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  flash_data_3:32;
    };
}fcic_top_fcic_flash_if_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  flash_dbg_mux:4;
        RBus_UInt32  template_data_mux:3;
        RBus_UInt32  res1:1;
        RBus_UInt32  eep_dbg_rd_en:1;
        RBus_UInt32  flash_dbg_rd_en:1;
        RBus_UInt32  res2:6;
        RBus_UInt32  rd_addr:15;
        RBus_UInt32  res3:1;
    };
}fcic_top_fcic_flash_dbg_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  flash_rdata_0:32;
    };
}fcic_top_fcic_flash_dbg_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  flash_rdata_1:32;
    };
}fcic_top_fcic_flash_dbg_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mbist_fcic_16728_1_bist_mode:1;
        RBus_UInt32  mbist_fcic_16728_2_bist_mode:1;
        RBus_UInt32  mbist_fcic_int_1_bist_mode:1;
        RBus_UInt32  mbist_fcic_int_2_bist_mode:1;
        RBus_UInt32  mbist_fcic_template_1_bist_mode:1;
        RBus_UInt32  mbist_fcic_template_2_bist_mode:1;
        RBus_UInt32  mbist_fcic_template_bist_mode:1;
        RBus_UInt32  mbist_fcic_ed_bist_mode:1;
        RBus_UInt32  res1:24;
    };
}fcic_top_fcic_bist_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mbist_fcic_16728_1_drf_mode:1;
        RBus_UInt32  mbist_fcic_16728_2_drf_mode:1;
        RBus_UInt32  mbist_fcic_int_1_drf_mode:1;
        RBus_UInt32  mbist_fcic_int_2_drf_mode:1;
        RBus_UInt32  mbist_fcic_template_1_drf_mode:1;
        RBus_UInt32  mbist_fcic_template_2_drf_mode:1;
        RBus_UInt32  mbist_fcic_template_drf_mode:1;
        RBus_UInt32  mbist_fcic_ed_drf_mode:1;
        RBus_UInt32  res1:24;
    };
}fcic_top_fcic_drf_mode_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mbist_fcic_16728_1_drf_resume:1;
        RBus_UInt32  mbist_fcic_16728_2_drf_resume:1;
        RBus_UInt32  mbist_fcic_int_1_drf_resume:1;
        RBus_UInt32  mbist_fcic_int_2_drf_resume:1;
        RBus_UInt32  mbist_fcic_template_1_drf_resume:1;
        RBus_UInt32  mbist_fcic_template_2_drf_resume:1;
        RBus_UInt32  mbist_fcic_template_drf_resume:1;
        RBus_UInt32  mbist_fcic_ed_drf_resume:1;
        RBus_UInt32  res1:24;
    };
}fcic_top_fcic_drf_resume_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mbist_fcic_16728_1_bist_done:1;
        RBus_UInt32  mbist_fcic_16728_2_bist_done:1;
        RBus_UInt32  mbist_fcic_int_1_bist_done:1;
        RBus_UInt32  mbist_fcic_int_2_bist_done:1;
        RBus_UInt32  mbist_fcic_template_1_bist_done:1;
        RBus_UInt32  mbist_fcic_template_2_bist_done:1;
        RBus_UInt32  mbist_fcic_template_bist_done:1;
        RBus_UInt32  mbist_fcic_ed_bist_done:1;
        RBus_UInt32  res1:24;
    };
}fcic_top_fcic_bist_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mbist_fcic_16728_1_drf_done:1;
        RBus_UInt32  mbist_fcic_16728_2_drf_done:1;
        RBus_UInt32  mbist_fcic_int_1_drf_done:1;
        RBus_UInt32  mbist_fcic_int_2_drf_done:1;
        RBus_UInt32  mbist_fcic_template_1_drf_done:1;
        RBus_UInt32  mbist_fcic_template_2_drf_done:1;
        RBus_UInt32  mbist_fcic_template_drf_done:1;
        RBus_UInt32  mbist_fcic_ed_drf_done:1;
        RBus_UInt32  res1:24;
    };
}fcic_top_fcic_drf_done_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mbist_fcic_16728_1_bist_fail:8;
        RBus_UInt32  mbist_fcic_16728_2_bist_fail:8;
        RBus_UInt32  mbist_fcic_int_1_bist_fail:6;
        RBus_UInt32  mbist_fcic_int_2_bist_fail:6;
        RBus_UInt32  res1:4;
    };
}fcic_top_fcic_bist_fail_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mbist_fcic_template_1_bist_fail:8;
        RBus_UInt32  mbist_fcic_template_2_bist_fail:8;
        RBus_UInt32  mbist_fcic_template_bist_fail:7;
        RBus_UInt32  mbist_fcic_ed_bist_fail:1;
        RBus_UInt32  res1:8;
    };
}fcic_top_fcic_bist_fail_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mbist_fcic_16728_1_drf_fail:8;
        RBus_UInt32  mbist_fcic_16728_2_drf_fail:8;
        RBus_UInt32  mbist_fcic_int_1_drf_fail:6;
        RBus_UInt32  mbist_fcic_int_2_drf_fail:6;
        RBus_UInt32  res1:4;
    };
}fcic_top_fcic_drf_fail_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mbist_fcic_template_1_drf_fail:8;
        RBus_UInt32  mbist_fcic_template_2_drf_fail:8;
        RBus_UInt32  mbist_fcic_template_drf_fail:7;
        RBus_UInt32  mbist_fcic_ed_drf_fail:1;
        RBus_UInt32  res1:8;
    };
}fcic_top_fcic_drf_fail_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mbist_fcic_16728_1_drf_pause:1;
        RBus_UInt32  mbist_fcic_16728_2_drf_pause:1;
        RBus_UInt32  mbist_fcic_int_1_drf_pause:1;
        RBus_UInt32  mbist_fcic_int_2_drf_pause:1;
        RBus_UInt32  mbist_fcic_template_1_drf_pause:1;
        RBus_UInt32  mbist_fcic_template_2_drf_pause:1;
        RBus_UInt32  mbist_fcic_template_drf_pause:1;
        RBus_UInt32  mbist_fcic_ed_drf_pause:1;
        RBus_UInt32  res1:24;
    };
}fcic_top_fcic_drf_pause_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fcic_16728_1_rme_0:1;
        RBus_UInt32  fcic_16728_1_rme_1:1;
        RBus_UInt32  fcic_16728_1_rme_2:1;
        RBus_UInt32  fcic_16728_1_rme_3:1;
        RBus_UInt32  fcic_16728_1_rme_4:1;
        RBus_UInt32  fcic_16728_1_rme_5:1;
        RBus_UInt32  fcic_16728_1_rme_6:1;
        RBus_UInt32  fcic_16728_1_rme_7:1;
        RBus_UInt32  fcic_16728_2_rme_0:1;
        RBus_UInt32  fcic_16728_2_rme_1:1;
        RBus_UInt32  fcic_16728_2_rme_2:1;
        RBus_UInt32  fcic_16728_2_rme_3:1;
        RBus_UInt32  fcic_16728_2_rme_4:1;
        RBus_UInt32  fcic_16728_2_rme_5:1;
        RBus_UInt32  fcic_16728_2_rme_6:1;
        RBus_UInt32  fcic_16728_2_rme_7:1;
        RBus_UInt32  fcic_int_1_rme_0:1;
        RBus_UInt32  fcic_int_1_rme_1:1;
        RBus_UInt32  fcic_int_1_rme_2:1;
        RBus_UInt32  fcic_int_1_rme_3:1;
        RBus_UInt32  fcic_int_1_rme_4:1;
        RBus_UInt32  fcic_int_1_rme_5:1;
        RBus_UInt32  fcic_int_2_rme_0:1;
        RBus_UInt32  fcic_int_2_rme_1:1;
        RBus_UInt32  fcic_int_2_rme_2:1;
        RBus_UInt32  fcic_int_2_rme_3:1;
        RBus_UInt32  fcic_int_2_rme_4:1;
        RBus_UInt32  fcic_int_2_rme_5:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  testrwm:1;
    };
}fcic_top_fcic_rme_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fcic_template_1_rme_0:1;
        RBus_UInt32  fcic_template_1_rme_1:1;
        RBus_UInt32  fcic_template_1_rme_2:1;
        RBus_UInt32  fcic_template_1_rme_3:1;
        RBus_UInt32  fcic_template_1_rme_4:1;
        RBus_UInt32  fcic_template_1_rme_5:1;
        RBus_UInt32  fcic_template_1_rme_6:1;
        RBus_UInt32  fcic_template_1_rme_7:1;
        RBus_UInt32  fcic_template_2_rme_0:1;
        RBus_UInt32  fcic_template_2_rme_1:1;
        RBus_UInt32  fcic_template_2_rme_2:1;
        RBus_UInt32  fcic_template_2_rme_3:1;
        RBus_UInt32  fcic_template_2_rme_4:1;
        RBus_UInt32  fcic_template_2_rme_5:1;
        RBus_UInt32  fcic_template_2_rme_6:1;
        RBus_UInt32  fcic_template_2_rme_7:1;
        RBus_UInt32  fcic_template_rme_0:1;
        RBus_UInt32  fcic_template_rme_1:1;
        RBus_UInt32  fcic_template_rme_2:1;
        RBus_UInt32  fcic_template_rme_3:1;
        RBus_UInt32  fcic_template_rme_4:1;
        RBus_UInt32  fcic_template_rme_5:1;
        RBus_UInt32  fcic_template_rme_6:1;
        RBus_UInt32  fcic_ed_rme_0:1;
        RBus_UInt32  res1:8;
    };
}fcic_top_fcic_rme_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fcic_16728_1_rm_0:4;
        RBus_UInt32  fcic_16728_1_rm_1:4;
        RBus_UInt32  fcic_16728_1_rm_2:4;
        RBus_UInt32  fcic_16728_1_rm_3:4;
        RBus_UInt32  fcic_16728_1_rm_4:4;
        RBus_UInt32  fcic_16728_1_rm_5:4;
        RBus_UInt32  fcic_16728_1_rm_6:4;
        RBus_UInt32  fcic_16728_1_rm_7:4;
    };
}fcic_top_fcic_rm_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fcic_16728_2_rm_0:4;
        RBus_UInt32  fcic_16728_2_rm_1:4;
        RBus_UInt32  fcic_16728_2_rm_2:4;
        RBus_UInt32  fcic_16728_2_rm_3:4;
        RBus_UInt32  fcic_16728_2_rm_4:4;
        RBus_UInt32  fcic_16728_2_rm_5:4;
        RBus_UInt32  fcic_16728_2_rm_6:4;
        RBus_UInt32  fcic_16728_2_rm_7:4;
    };
}fcic_top_fcic_rm_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fcic_int_1_rm_0:4;
        RBus_UInt32  fcic_int_1_rm_1:4;
        RBus_UInt32  fcic_int_1_rm_2:4;
        RBus_UInt32  fcic_int_1_rm_3:4;
        RBus_UInt32  fcic_int_1_rm_4:4;
        RBus_UInt32  fcic_int_1_rm_5:4;
        RBus_UInt32  res1:8;
    };
}fcic_top_fcic_rm_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fcic_int_2_rm_0:4;
        RBus_UInt32  fcic_int_2_rm_1:4;
        RBus_UInt32  fcic_int_2_rm_2:4;
        RBus_UInt32  fcic_int_2_rm_3:4;
        RBus_UInt32  fcic_int_2_rm_4:4;
        RBus_UInt32  fcic_int_2_rm_5:4;
        RBus_UInt32  res1:8;
    };
}fcic_top_fcic_rm_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fcic_template_1_rm_0:4;
        RBus_UInt32  fcic_template_1_rm_1:4;
        RBus_UInt32  fcic_template_1_rm_2:4;
        RBus_UInt32  fcic_template_1_rm_3:4;
        RBus_UInt32  fcic_template_1_rm_4:4;
        RBus_UInt32  fcic_template_1_rm_5:4;
        RBus_UInt32  fcic_template_1_rm_6:4;
        RBus_UInt32  fcic_template_1_rm_7:4;
    };
}fcic_top_fcic_rm_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fcic_template_2_rm_0:4;
        RBus_UInt32  fcic_template_2_rm_1:4;
        RBus_UInt32  fcic_template_2_rm_2:4;
        RBus_UInt32  fcic_template_2_rm_3:4;
        RBus_UInt32  fcic_template_2_rm_4:4;
        RBus_UInt32  fcic_template_2_rm_5:4;
        RBus_UInt32  fcic_template_2_rm_6:4;
        RBus_UInt32  fcic_template_2_rm_7:4;
    };
}fcic_top_fcic_rm_5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fcic_template_rm_0:4;
        RBus_UInt32  fcic_template_rm_1:4;
        RBus_UInt32  fcic_template_rm_2:4;
        RBus_UInt32  fcic_template_rm_3:4;
        RBus_UInt32  fcic_template_rm_4:4;
        RBus_UInt32  fcic_template_rm_5:4;
        RBus_UInt32  fcic_template_rm_6:4;
        RBus_UInt32  fcic_ed_rm_0:4;
    };
}fcic_top_fcic_rm_6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fcic_io_reg_en:1;
        RBus_UInt32  mplus_opt:1;
        RBus_UInt32  color_1:2;
        RBus_UInt32  color_2:2;
        RBus_UInt32  color_3:2;
        RBus_UInt32  color_4:2;
        RBus_UInt32  res1:22;
    };
}fcic_top_fcic_io_reg_RBUS;




#endif 


#endif 
