/**
* @file Merlin3-DesignSpec-D-Domain_Mixer
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2017/6/9
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_OSDOVL_REG_H_
#define _RBUS_OSDOVL_REG_H_

#include "rbusTypes.h"



//  OSDOVL Register Address



#define  OSDOVL_MIXER_CTRL2_VADDR                           	(0xb802b000)
#define  OSDOVL_MIXER_LAYER_SEL_VADDR                       	(0xb802b004)
#define  OSDOVL_MIXER_C0_PLANE_ALPHA1_VADDR                 	(0xb802b008)
#define  OSDOVL_MIXER_C0_PLANE_ALPHA2_VADDR                 	(0xb802b00c)
#define  OSDOVL_MIXER_C0_PLANE_OFFSET_VADDR                 	(0xb802b010)
#define  OSDOVL_MIXER_C1_PLANE_ALPHA1_VADDR                 	(0xb802b014)
#define  OSDOVL_MIXER_C1_PLANE_ALPHA2_VADDR                 	(0xb802b018)
#define  OSDOVL_MIXER_C1_PLANE_OFFSET_VADDR                 	(0xb802b01c)
#define  OSDOVL_MIXER_C2_PLANE_ALPHA1_VADDR                 	(0xb802b020)
#define  OSDOVL_MIXER_C2_PLANE_ALPHA2_VADDR                 	(0xb802b024)
#define  OSDOVL_MIXER_C2_PLANE_OFFSET_VADDR                 	(0xb802b028)
#define  OSDOVL_MIXER_C3_PLANE_ALPHA1_VADDR                 	(0xb802b02c)
#define  OSDOVL_MIXER_C3_PLANE_ALPHA2_VADDR                 	(0xb802b030)
#define  OSDOVL_MIXER_C3_PLANE_OFFSET_VADDR                 	(0xb802b034)
#define  OSDOVL_MIXER_OSD_GAMMA_CTRL_VADDR                  	(0xb802b038)
#define  OSDOVL_MIXER_OSD_GAMMA_DYNAMIC_REGION_D3_D2_VADDR  	(0xb802b03c)
#define  OSDOVL_MIXER_OSD3X3_DATA_IN_OFFSET_0_VADDR         	(0xb802b040)
#define  OSDOVL_MIXER_OSD3X3_DATA_IN_OFFSET_1_VADDR         	(0xb802b044)
#define  OSDOVL_MIXER_OSD3X3_DATA_0_VADDR                   	(0xb802b048)
#define  OSDOVL_MIXER_OSD3X3_DATA_1_VADDR                   	(0xb802b04c)
#define  OSDOVL_MIXER_OSD3X3_DATA_2_VADDR                   	(0xb802b050)
#define  OSDOVL_MIXER_OSD3X3_DATA_3_VADDR                   	(0xb802b054)
#define  OSDOVL_MIXER_OSD3X3_DATA_4_VADDR                   	(0xb802b058)
#define  OSDOVL_MIXER_OSD3X3_OUT_OFFSET_0_VADDR             	(0xb802b05c)
#define  OSDOVL_MIXER_OSD3X3_OUT_OFFSET_1_VADDR             	(0xb802b060)
#define  OSDOVL_MIXER_B1_VADDR                              	(0xb802b064)
#define  OSDOVL_MIXER_B2_VADDR                              	(0xb802b068)
#define  OSDOVL_MIXER_B3_VADDR                              	(0xb802b06c)
#define  OSDOVL_MIXER_GAMMA1_PORT_VADDR                     	(0xb802b070)
#define  OSDOVL_MIXER_GAMMA1_CTRL_1_VADDR                   	(0xb802b074)
#define  OSDOVL_MIXER_GAMMA2_PORT_VADDR                     	(0xb802b078)
#define  OSDOVL_MIXER_GAMMA2_CTRL_1_VADDR                   	(0xb802b080)
#define  OSDOVL_MIXER_GAMMA_BIST_CTRL_1_VADDR               	(0xb802b088)
#define  OSDOVL_MIXER_GAMMA_BIST_CTRL_2_VADDR               	(0xb802b08c)
#define  OSDOVL_MIXER_CRC_SEL_VADDR                         	(0xb802b090)
#define  OSDOVL_MIXER_CRC_CTRL_VADDR                        	(0xb802b094)
#define  OSDOVL_MIXER_CRC_RESULT_VADDR                      	(0xb802b098)
#define  OSDOVL_OSD_DB_CTRL_VADDR                           	(0xb802b0a0)
#define  OSDOVL_MIXER_SETTING_ERROR_VADDR                   	(0xb802b0b4)
#define  OSDOVL_MIXER_LINE_MASK_VADDR                       	(0xb802b0c0)
#define  OSDOVL_MEASURE_OSD1_STA_VADDR                      	(0xb802b0d0)
#define  OSDOVL_MEASURE_OSD1_END_VADDR                      	(0xb802b0d4)
#define  OSDOVL_MEASURE_OSD2_STA_VADDR                      	(0xb802b0d8)
#define  OSDOVL_MEASURE_OSD2_END_VADDR                      	(0xb802b0dc)
#define  OSDOVL_MEASURE_OSD3_STA_VADDR                      	(0xb802b0e0)
#define  OSDOVL_MEASURE_OSD3_END_VADDR                      	(0xb802b0e4)
#define  OSDOVL_MEASURE_OSD6_STA_VADDR                      	(0xb802b0f8)
#define  OSDOVL_MEASURE_OSD6_END_VADDR                      	(0xb802b0fc)



#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======OSDOVL register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  measure_osd_zone_en:1;
        RBus_UInt32  measure_osd_zone_type:1;
        RBus_UInt32  res1:5;
        RBus_UInt32  video_src_sel:1;
        RBus_UInt32  video_alpha:8;
        RBus_UInt32  res2:9;
        RBus_UInt32  mixero6_en:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  mixero3_en:1;
        RBus_UInt32  mixero2_en:1;
        RBus_UInt32  mixero1_en:1;
        RBus_UInt32  mixer_en:1;
    };
}osdovl_mixer_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  c3_plane_alpha_en:1;
        RBus_UInt32  c2_plane_alpha_en:1;
        RBus_UInt32  c1_plane_alpha_en:1;
        RBus_UInt32  c0_plane_alpha_en:1;
        RBus_UInt32  res2:9;
        RBus_UInt32  c3_sel:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  c2_sel:3;
        RBus_UInt32  res4:1;
        RBus_UInt32  c1_sel:3;
        RBus_UInt32  res5:1;
        RBus_UInt32  c0_sel:3;
    };
}osdovl_mixer_layer_sel_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:7;
        RBus_UInt32  plane_alpha_a:9;
        RBus_UInt32  res2:7;
        RBus_UInt32  plane_alpha_r:9;
    };
}osdovl_mixer_c0_plane_alpha1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:7;
        RBus_UInt32  plane_alpha_g:9;
        RBus_UInt32  res2:7;
        RBus_UInt32  plane_alpha_b:9;
    };
}osdovl_mixer_c0_plane_alpha2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  plane_offset_a:8;
        RBus_UInt32  plane_offset_r:8;
        RBus_UInt32  plane_offset_g:8;
        RBus_UInt32  plane_offset_b:8;
    };
}osdovl_mixer_c0_plane_offset_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:7;
        RBus_UInt32  plane_alpha_a:9;
        RBus_UInt32  res2:7;
        RBus_UInt32  plane_alpha_r:9;
    };
}osdovl_mixer_c1_plane_alpha1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:7;
        RBus_UInt32  plane_alpha_g:9;
        RBus_UInt32  res2:7;
        RBus_UInt32  plane_alpha_b:9;
    };
}osdovl_mixer_c1_plane_alpha2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  plane_offset_a:8;
        RBus_UInt32  plane_offset_r:8;
        RBus_UInt32  plane_offset_g:8;
        RBus_UInt32  plane_offset_b:8;
    };
}osdovl_mixer_c1_plane_offset_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:7;
        RBus_UInt32  plane_alpha_a:9;
        RBus_UInt32  res2:7;
        RBus_UInt32  plane_alpha_r:9;
    };
}osdovl_mixer_c2_plane_alpha1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:7;
        RBus_UInt32  plane_alpha_g:9;
        RBus_UInt32  res2:7;
        RBus_UInt32  plane_alpha_b:9;
    };
}osdovl_mixer_c2_plane_alpha2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  plane_offset_a:8;
        RBus_UInt32  plane_offset_r:8;
        RBus_UInt32  plane_offset_g:8;
        RBus_UInt32  plane_offset_b:8;
    };
}osdovl_mixer_c2_plane_offset_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:7;
        RBus_UInt32  plane_alpha_a:9;
        RBus_UInt32  res2:7;
        RBus_UInt32  plane_alpha_r:9;
    };
}osdovl_mixer_c3_plane_alpha1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:7;
        RBus_UInt32  plane_alpha_g:9;
        RBus_UInt32  res2:7;
        RBus_UInt32  plane_alpha_b:9;
    };
}osdovl_mixer_c3_plane_alpha2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  plane_offset_a:8;
        RBus_UInt32  plane_offset_r:8;
        RBus_UInt32  plane_offset_g:8;
        RBus_UInt32  plane_offset_b:8;
    };
}osdovl_mixer_c3_plane_offset_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  d1_m3:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  d1_m2:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  d1_m1:3;
        RBus_UInt32  res4:1;
        RBus_UInt32  d1_m0:3;
        RBus_UInt32  osd6_gamma_zone_type:2;
        RBus_UInt32  osd3_gamma_zone_type:2;
        RBus_UInt32  osd2_gamma_zone_type:2;
        RBus_UInt32  osd1_gamma_zone_type:2;
        RBus_UInt32  res5:1;
        RBus_UInt32  osd_gamma_position:3;
        RBus_UInt32  dynamic_region_en:1;
        RBus_UInt32  mixer_gamma2_en:1;
        RBus_UInt32  mixer_osd3x3_en:1;
        RBus_UInt32  mixer_gamma1_en:1;
    };
}osdovl_mixer_osd_gamma_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  d3_m3:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  d3_m2:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  d3_m1:3;
        RBus_UInt32  res4:1;
        RBus_UInt32  d3_m0:3;
        RBus_UInt32  res5:1;
        RBus_UInt32  d2_m3:3;
        RBus_UInt32  res6:1;
        RBus_UInt32  d2_m2:3;
        RBus_UInt32  res7:1;
        RBus_UInt32  d2_m1:3;
        RBus_UInt32  res8:1;
        RBus_UInt32  d2_m0:3;
    };
}osdovl_mixer_osd_gamma_dynamic_region_d3_d2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  y_offset:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  x_offset:13;
    };
}osdovl_mixer_osd3x3_data_in_offset_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  z_offset:13;
    };
}osdovl_mixer_osd3x3_data_in_offset_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  k12:14;
        RBus_UInt32  res2:2;
        RBus_UInt32  k11:14;
    };
}osdovl_mixer_osd3x3_data_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  k21:14;
        RBus_UInt32  res2:2;
        RBus_UInt32  k13:14;
    };
}osdovl_mixer_osd3x3_data_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  k23:14;
        RBus_UInt32  res2:2;
        RBus_UInt32  k22:14;
    };
}osdovl_mixer_osd3x3_data_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  k32:14;
        RBus_UInt32  res2:2;
        RBus_UInt32  k31:14;
    };
}osdovl_mixer_osd3x3_data_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:18;
        RBus_UInt32  k33:14;
    };
}osdovl_mixer_osd3x3_data_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  goffset:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  roffset:13;
    };
}osdovl_mixer_osd3x3_out_offset_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  boffset:13;
    };
}osdovl_mixer_osd3x3_out_offset_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  k1:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  k2:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  k3:6;
        RBus_UInt32  res4:2;
        RBus_UInt32  k4:6;
    };
}osdovl_mixer_b1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  k1:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  k2:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  k3:6;
        RBus_UInt32  res4:2;
        RBus_UInt32  k4:6;
    };
}osdovl_mixer_b2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  k1:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  k2:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  k3:6;
        RBus_UInt32  res4:2;
        RBus_UInt32  k4:6;
    };
}osdovl_mixer_b3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  gamma1_tab_index:12;
        RBus_UInt32  res2:1;
        RBus_UInt32  gamma1_tab_d0:7;
        RBus_UInt32  res3:1;
        RBus_UInt32  gamma1_tab_d1:7;
    };
}osdovl_mixer_gamma1_port_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  gamma1_tab_addr:7;
        RBus_UInt32  res2:6;
        RBus_UInt32  gamma1_ax_rw_sel:2;
        RBus_UInt32  res3:1;
        RBus_UInt32  gamma1_ax_ch_sel:2;
        RBus_UInt32  gamma1_fifo_empty:1;
        RBus_UInt32  gamma1_fifo_full:1;
        RBus_UInt32  gamma1_wr_error:1;
        RBus_UInt32  dummy1802b074_1:1;
        RBus_UInt32  res4:1;
    };
}osdovl_mixer_gamma1_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  gamma2_tab_index:12;
        RBus_UInt32  res2:1;
        RBus_UInt32  gamma2_tab_d0:7;
        RBus_UInt32  res3:1;
        RBus_UInt32  gamma2_tab_d1:7;
    };
}osdovl_mixer_gamma2_port_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:9;
        RBus_UInt32  gamma2_tab_addr:7;
        RBus_UInt32  res2:6;
        RBus_UInt32  gamma2_ax_rw_sel:2;
        RBus_UInt32  res3:1;
        RBus_UInt32  gamma2_ax_ch_sel:2;
        RBus_UInt32  gamma2_fifo_empty:1;
        RBus_UInt32  gamma2_fifo_full:1;
        RBus_UInt32  gamma2_wr_error:1;
        RBus_UInt32  dummy1802b080_1:1;
        RBus_UInt32  res4:1;
    };
}osdovl_mixer_gamma2_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:20;
        RBus_UInt32  gamma2_ls:1;
        RBus_UInt32  gamma1_ls:1;
        RBus_UInt32  gamma2_rme:1;
        RBus_UInt32  gamma1_rme:1;
        RBus_UInt32  gamma2_rm:4;
        RBus_UInt32  gamma1_rm:4;
    };
}osdovl_mixer_gamma_bist_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:17;
        RBus_UInt32  gamma2_r_drf_bist_fail:1;
        RBus_UInt32  gamma2_g_drf_bist_fail:1;
        RBus_UInt32  gamma2_b_drf_bist_fail:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  gamma1_r_drf_bist_fail:1;
        RBus_UInt32  gamma1_g_drf_bist_fail:1;
        RBus_UInt32  gamma1_b_drf_bist_fail:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  gamma2_r_bist_fail:1;
        RBus_UInt32  gamma2_g_bist_fail:1;
        RBus_UInt32  gamma2_b_bist_fail:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  gamma1_r_bist_fail:1;
        RBus_UInt32  gamma1_g_bist_fail:1;
        RBus_UInt32  gamma1_b_bist_fail:1;
    };
}osdovl_mixer_gamma_bist_ctrl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  mixer_crc_sel:4;
    };
}osdovl_mixer_crc_sel_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  mixer_crc_done:1;
        RBus_UInt32  mixer_crc_cont:1;
        RBus_UInt32  mixer_crc_start:1;
    };
}osdovl_mixer_crc_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mixer_crc_result:32;
    };
}osdovl_mixer_crc_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  db_read:1;
        RBus_UInt32  db_en:1;
        RBus_UInt32  db_load:1;
    };
}osdovl_osd_db_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:17;
        RBus_UInt32  one_layer_setting_conflict:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  c3_src_conflict:1;
        RBus_UInt32  c2_src_conflict:1;
        RBus_UInt32  c1_src_conflict:1;
        RBus_UInt32  c0_src_conflict:1;
        RBus_UInt32  res3:8;
    };
}osdovl_mixer_setting_error_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:18;
        RBus_UInt32  osd6_line_mask:2;
        RBus_UInt32  res2:4;
        RBus_UInt32  osd3_line_mask:2;
        RBus_UInt32  osd2_line_mask:2;
        RBus_UInt32  osd1_line_mask:2;
        RBus_UInt32  video_line_mask:2;
    };
}osdovl_mixer_line_mask_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  x:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  y:13;
    };
}osdovl_measure_osd1_sta_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  x:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  y:13;
    };
}osdovl_measure_osd1_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  x:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  y:13;
    };
}osdovl_measure_osd2_sta_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  x:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  y:13;
    };
}osdovl_measure_osd2_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  x:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  y:13;
    };
}osdovl_measure_osd3_sta_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  x:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  y:13;
    };
}osdovl_measure_osd3_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  x:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  y:13;
    };
}osdovl_measure_osd6_sta_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  x:13;
        RBus_UInt32  res2:3;
        RBus_UInt32  y:13;
    };
}osdovl_measure_osd6_end_RBUS;

#else //apply LITTLE_ENDIAN

//======OSDOVL register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mixer_en:1;
        RBus_UInt32  mixero1_en:1;
        RBus_UInt32  mixero2_en:1;
        RBus_UInt32  mixero3_en:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  mixero6_en:1;
        RBus_UInt32  res2:9;
        RBus_UInt32  video_alpha:8;
        RBus_UInt32  video_src_sel:1;
        RBus_UInt32  res3:5;
        RBus_UInt32  measure_osd_zone_type:1;
        RBus_UInt32  measure_osd_zone_en:1;
    };
}osdovl_mixer_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  c0_sel:3;
        RBus_UInt32  res1:1;
        RBus_UInt32  c1_sel:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  c2_sel:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  c3_sel:3;
        RBus_UInt32  res4:9;
        RBus_UInt32  c0_plane_alpha_en:1;
        RBus_UInt32  c1_plane_alpha_en:1;
        RBus_UInt32  c2_plane_alpha_en:1;
        RBus_UInt32  c3_plane_alpha_en:1;
        RBus_UInt32  res5:4;
    };
}osdovl_mixer_layer_sel_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  plane_alpha_r:9;
        RBus_UInt32  res1:7;
        RBus_UInt32  plane_alpha_a:9;
        RBus_UInt32  res2:7;
    };
}osdovl_mixer_c0_plane_alpha1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  plane_alpha_b:9;
        RBus_UInt32  res1:7;
        RBus_UInt32  plane_alpha_g:9;
        RBus_UInt32  res2:7;
    };
}osdovl_mixer_c0_plane_alpha2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  plane_offset_b:8;
        RBus_UInt32  plane_offset_g:8;
        RBus_UInt32  plane_offset_r:8;
        RBus_UInt32  plane_offset_a:8;
    };
}osdovl_mixer_c0_plane_offset_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  plane_alpha_r:9;
        RBus_UInt32  res1:7;
        RBus_UInt32  plane_alpha_a:9;
        RBus_UInt32  res2:7;
    };
}osdovl_mixer_c1_plane_alpha1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  plane_alpha_b:9;
        RBus_UInt32  res1:7;
        RBus_UInt32  plane_alpha_g:9;
        RBus_UInt32  res2:7;
    };
}osdovl_mixer_c1_plane_alpha2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  plane_offset_b:8;
        RBus_UInt32  plane_offset_g:8;
        RBus_UInt32  plane_offset_r:8;
        RBus_UInt32  plane_offset_a:8;
    };
}osdovl_mixer_c1_plane_offset_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  plane_alpha_r:9;
        RBus_UInt32  res1:7;
        RBus_UInt32  plane_alpha_a:9;
        RBus_UInt32  res2:7;
    };
}osdovl_mixer_c2_plane_alpha1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  plane_alpha_b:9;
        RBus_UInt32  res1:7;
        RBus_UInt32  plane_alpha_g:9;
        RBus_UInt32  res2:7;
    };
}osdovl_mixer_c2_plane_alpha2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  plane_offset_b:8;
        RBus_UInt32  plane_offset_g:8;
        RBus_UInt32  plane_offset_r:8;
        RBus_UInt32  plane_offset_a:8;
    };
}osdovl_mixer_c2_plane_offset_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  plane_alpha_r:9;
        RBus_UInt32  res1:7;
        RBus_UInt32  plane_alpha_a:9;
        RBus_UInt32  res2:7;
    };
}osdovl_mixer_c3_plane_alpha1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  plane_alpha_b:9;
        RBus_UInt32  res1:7;
        RBus_UInt32  plane_alpha_g:9;
        RBus_UInt32  res2:7;
    };
}osdovl_mixer_c3_plane_alpha2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  plane_offset_b:8;
        RBus_UInt32  plane_offset_g:8;
        RBus_UInt32  plane_offset_r:8;
        RBus_UInt32  plane_offset_a:8;
    };
}osdovl_mixer_c3_plane_offset_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mixer_gamma1_en:1;
        RBus_UInt32  mixer_osd3x3_en:1;
        RBus_UInt32  mixer_gamma2_en:1;
        RBus_UInt32  dynamic_region_en:1;
        RBus_UInt32  osd_gamma_position:3;
        RBus_UInt32  res1:1;
        RBus_UInt32  osd1_gamma_zone_type:2;
        RBus_UInt32  osd2_gamma_zone_type:2;
        RBus_UInt32  osd3_gamma_zone_type:2;
        RBus_UInt32  osd6_gamma_zone_type:2;
        RBus_UInt32  d1_m0:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  d1_m1:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  d1_m2:3;
        RBus_UInt32  res4:1;
        RBus_UInt32  d1_m3:3;
        RBus_UInt32  res5:1;
    };
}osdovl_mixer_osd_gamma_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  d2_m0:3;
        RBus_UInt32  res1:1;
        RBus_UInt32  d2_m1:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  d2_m2:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  d2_m3:3;
        RBus_UInt32  res4:1;
        RBus_UInt32  d3_m0:3;
        RBus_UInt32  res5:1;
        RBus_UInt32  d3_m1:3;
        RBus_UInt32  res6:1;
        RBus_UInt32  d3_m2:3;
        RBus_UInt32  res7:1;
        RBus_UInt32  d3_m3:3;
        RBus_UInt32  res8:1;
    };
}osdovl_mixer_osd_gamma_dynamic_region_d3_d2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  x_offset:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  y_offset:13;
        RBus_UInt32  res2:3;
    };
}osdovl_mixer_osd3x3_data_in_offset_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  z_offset:13;
        RBus_UInt32  res1:19;
    };
}osdovl_mixer_osd3x3_data_in_offset_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  k11:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  k12:14;
        RBus_UInt32  res2:2;
    };
}osdovl_mixer_osd3x3_data_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  k13:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  k21:14;
        RBus_UInt32  res2:2;
    };
}osdovl_mixer_osd3x3_data_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  k22:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  k23:14;
        RBus_UInt32  res2:2;
    };
}osdovl_mixer_osd3x3_data_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  k31:14;
        RBus_UInt32  res1:2;
        RBus_UInt32  k32:14;
        RBus_UInt32  res2:2;
    };
}osdovl_mixer_osd3x3_data_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  k33:14;
        RBus_UInt32  res1:18;
    };
}osdovl_mixer_osd3x3_data_4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  roffset:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  goffset:13;
        RBus_UInt32  res2:3;
    };
}osdovl_mixer_osd3x3_out_offset_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  boffset:13;
        RBus_UInt32  res1:19;
    };
}osdovl_mixer_osd3x3_out_offset_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  k4:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  k3:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  k2:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  k1:6;
        RBus_UInt32  res4:2;
    };
}osdovl_mixer_b1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  k4:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  k3:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  k2:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  k1:6;
        RBus_UInt32  res4:2;
    };
}osdovl_mixer_b2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  k4:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  k3:6;
        RBus_UInt32  res2:2;
        RBus_UInt32  k2:6;
        RBus_UInt32  res3:2;
        RBus_UInt32  k1:6;
        RBus_UInt32  res4:2;
    };
}osdovl_mixer_b3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gamma1_tab_d1:7;
        RBus_UInt32  res1:1;
        RBus_UInt32  gamma1_tab_d0:7;
        RBus_UInt32  res2:1;
        RBus_UInt32  gamma1_tab_index:12;
        RBus_UInt32  res3:4;
    };
}osdovl_mixer_gamma1_port_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  dummy1802b074_1:1;
        RBus_UInt32  gamma1_wr_error:1;
        RBus_UInt32  gamma1_fifo_full:1;
        RBus_UInt32  gamma1_fifo_empty:1;
        RBus_UInt32  gamma1_ax_ch_sel:2;
        RBus_UInt32  res2:1;
        RBus_UInt32  gamma1_ax_rw_sel:2;
        RBus_UInt32  res3:6;
        RBus_UInt32  gamma1_tab_addr:7;
        RBus_UInt32  res4:9;
    };
}osdovl_mixer_gamma1_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gamma2_tab_d1:7;
        RBus_UInt32  res1:1;
        RBus_UInt32  gamma2_tab_d0:7;
        RBus_UInt32  res2:1;
        RBus_UInt32  gamma2_tab_index:12;
        RBus_UInt32  res3:4;
    };
}osdovl_mixer_gamma2_port_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  dummy1802b080_1:1;
        RBus_UInt32  gamma2_wr_error:1;
        RBus_UInt32  gamma2_fifo_full:1;
        RBus_UInt32  gamma2_fifo_empty:1;
        RBus_UInt32  gamma2_ax_ch_sel:2;
        RBus_UInt32  res2:1;
        RBus_UInt32  gamma2_ax_rw_sel:2;
        RBus_UInt32  res3:6;
        RBus_UInt32  gamma2_tab_addr:7;
        RBus_UInt32  res4:9;
    };
}osdovl_mixer_gamma2_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gamma1_rm:4;
        RBus_UInt32  gamma2_rm:4;
        RBus_UInt32  gamma1_rme:1;
        RBus_UInt32  gamma2_rme:1;
        RBus_UInt32  gamma1_ls:1;
        RBus_UInt32  gamma2_ls:1;
        RBus_UInt32  res1:20;
    };
}osdovl_mixer_gamma_bist_ctrl_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gamma1_b_bist_fail:1;
        RBus_UInt32  gamma1_g_bist_fail:1;
        RBus_UInt32  gamma1_r_bist_fail:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  gamma2_b_bist_fail:1;
        RBus_UInt32  gamma2_g_bist_fail:1;
        RBus_UInt32  gamma2_r_bist_fail:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  gamma1_b_drf_bist_fail:1;
        RBus_UInt32  gamma1_g_drf_bist_fail:1;
        RBus_UInt32  gamma1_r_drf_bist_fail:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  gamma2_b_drf_bist_fail:1;
        RBus_UInt32  gamma2_g_drf_bist_fail:1;
        RBus_UInt32  gamma2_r_drf_bist_fail:1;
        RBus_UInt32  res4:17;
    };
}osdovl_mixer_gamma_bist_ctrl_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mixer_crc_sel:4;
        RBus_UInt32  res1:28;
    };
}osdovl_mixer_crc_sel_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mixer_crc_start:1;
        RBus_UInt32  mixer_crc_cont:1;
        RBus_UInt32  mixer_crc_done:1;
        RBus_UInt32  res1:29;
    };
}osdovl_mixer_crc_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mixer_crc_result:32;
    };
}osdovl_mixer_crc_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  db_load:1;
        RBus_UInt32  db_en:1;
        RBus_UInt32  db_read:1;
        RBus_UInt32  res1:29;
    };
}osdovl_osd_db_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  c0_src_conflict:1;
        RBus_UInt32  c1_src_conflict:1;
        RBus_UInt32  c2_src_conflict:1;
        RBus_UInt32  c3_src_conflict:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  one_layer_setting_conflict:1;
        RBus_UInt32  res3:17;
    };
}osdovl_mixer_setting_error_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  video_line_mask:2;
        RBus_UInt32  osd1_line_mask:2;
        RBus_UInt32  osd2_line_mask:2;
        RBus_UInt32  osd3_line_mask:2;
        RBus_UInt32  res1:4;
        RBus_UInt32  osd6_line_mask:2;
        RBus_UInt32  res2:18;
    };
}osdovl_mixer_line_mask_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  y:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  x:13;
        RBus_UInt32  res2:3;
    };
}osdovl_measure_osd1_sta_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  y:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  x:13;
        RBus_UInt32  res2:3;
    };
}osdovl_measure_osd1_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  y:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  x:13;
        RBus_UInt32  res2:3;
    };
}osdovl_measure_osd2_sta_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  y:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  x:13;
        RBus_UInt32  res2:3;
    };
}osdovl_measure_osd2_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  y:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  x:13;
        RBus_UInt32  res2:3;
    };
}osdovl_measure_osd3_sta_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  y:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  x:13;
        RBus_UInt32  res2:3;
    };
}osdovl_measure_osd3_end_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  y:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  x:13;
        RBus_UInt32  res2:3;
    };
}osdovl_measure_osd6_sta_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  y:13;
        RBus_UInt32  res1:3;
        RBus_UInt32  x:13;
        RBus_UInt32  res2:3;
    };
}osdovl_measure_osd6_end_RBUS;




#endif 


#endif 
