/*=============================================================
 * Copyright (c)      Realtek Semiconductor Corporation, 2013 *
 * All rights reserved.                                       *
 *============================================================*/

/*======================= Description ========================*/
/**
 * @file audio_app.h
 * This file is a header file for LasVegas Audio PostPorcessing library.
 * @author Clayton Wu , <clayton@realtek.com>
 * @date 2014.1.8
 * @version 0.1
 *
 */
//#include "rbusTypes.h"
#ifndef __AUDIO_QC_H__
#define __AUDIO_QC_H__

#ifdef __cplusplus
extern "C" {
#endif
#define ALIGN64 __attribute__ ((aligned(64)))
/*======================== Audio Config =========================*/
#define QC_test

#define DMA_LOOPBACK

//#define HDMI2AUDIO

//#define EARC_CMDC
#ifdef EARC_CMDC
#define eARC_write_latency
#endif

#define config_AudioInit
#ifdef QC_test
#define config_AudioPath_Analog
#define config_AudioPath_Digital
#define I2S_D0_FROM_SRC_5
#define config_AudioDMA
#define config_AudioFunction
#define SET_DMA_ADDR
#undef config_Audio_biascurrent_30u
#else
#define HDMI_to_Autio_Path
#endif

/*======================== Constant ===========================*/
#if 1
#define _BIT0 (0x1)
#define _BIT1 (0x2)
#define _BIT2 (0x4)
#define _BIT3 (0x8)
#define _BIT4 (0x10)
#define _BIT5 (0x20)
#define _BIT6 (0x40)
#define _BIT7 (0x80)
#define _BIT8 (0x100)
#define _BIT9 (0x200)

#define _BIT10 (0x400)
#define _BIT11 (0x800)
#define _BIT12 (0x1000)
#define _BIT13 (0x2000)
#define _BIT14 (0x4000)
#define _BIT15 (0x8000)
#define _BIT16 (0x10000)
#define _BIT17 (0x20000)
#define _BIT18 (0x40000)
#define _BIT19 (0x80000)

#define _BIT20 (0x100000)
#define _BIT21 (0x200000)
#define _BIT22 (0x400000)
#define _BIT23 (0x800000)
#define _BIT24 (0x1000000)
#define _BIT25 (0x2000000)
#define _BIT26 (0x4000000)
#define _BIT27 (0x8000000)
#define _BIT28 (0x10000000)
#define _BIT29 (0x20000000)

#define _BIT30 (0x40000000)
#define _BIT31 (0x80000000)
#endif

#define DMA_USE_GOLDEN_PATTERN
#ifdef DMA_USE_GOLDEN_PATTERN
#define DMABUFSAMPLES (48) 	// 8192 samples, 8192*4 bytes = 32kbytes
#else
#define DMABUFSAMPLES (8192) 	// 8192 samples, 8192*4 bytes = 32kbytes
#endif
#define DMACHANNELS (2) 		// 2 channels
#define ScalerTimer_DelayXms(mSec)		udelay(mSec)
#define DATA_COMPARE_FIXED_RX

#ifdef EARC_CMDC
#define  EARCMISC_earc_ana_0_reg                                                 0xB80B8004
#define  EARCMISC_earc_ana_1_reg                                                 0xB80B8008
#define  EARCMISC_earc_ana_2_reg                                                 0xB80B800C
#define  EARCMISC_earc_dphy1_reg                                                 0xB80B802C
#define  EARCMISC_earc_dphy2_reg                                                 0xB80B8030
#define  EARC_eARC_CMDC_TIMING0_reg                                              0xB8006DC0
#define  EARC_eARC_CMDC_TIMING1_reg                                              0xB8006DC4
#define  EARC_eARC_CMDC_READ_reg                                                 0xB8006DD4
#define  EARC_eARC_CMDC_REQ_reg                                                  0xB8006DC8
#define  EARC_eARC_CMDC_PAYLOAD_reg                                              0xB8006DCC
#define  EARC_eARC_CMDC_WRITE_reg                                                0xB8006DD0
#define  EARC_eARC_CMDC_NACK_UECC_reg                                            0xB8006DD8
#define  EARC_eARC_CMDC_IRQ_reg                                                  0xB8006DDC
#define  EARC_eARC_CMDC_IRQ_EN_reg                                               0xB8006DE0

#define AIO_EARC_CAP_DEVICE_ID 			0xA0
#define AIO_EARC_CAP_OFFSET 				0x00
#define AIO_EARC_LATENCY_DEVICE_ID 		0x74
#define AIO_EARC_ERX_LATENCY_OFFSET 		0xD2 //read transaction
#define AIO_EARC_ERX_LATENCY_REQ_OFFSET 	0xD3 //write transaction

#define AIO_EARC_ERR_READ_TRANS_IRQ (AIO_EARC_READ_NACK_IRQ | AIO_EARC_READ_UECC_IRQ \
		| AIO_EARC_NO_RESPONSE_IRQ	| AIO_EARC_UNEXP_RESPONSE_IRQ | AIO_EARC_LOST_HEARTBEAT_IRQ)
#define AIO_EARC_ERR_WRITE_TRANS_IRQ (AIO_EARC_WRITE_NACK_IRQ | AIO_EARC_LOST_HEARTBEAT_IRQ\
		| AIO_EARC_NO_RESPONSE_IRQ	| AIO_EARC_UNEXP_RESPONSE_IRQ | AIO_EARC_WRITE_NACK_IRQ)

#define AIO_EARC_HPD_IRQ 				0x00000001
#define AIO_EARC_CAP_CHNG_IRQ 		(AIO_EARC_HPD_IRQ << 1)
#define AIO_EARC_START_CHNG_IRQ 		(AIO_EARC_HPD_IRQ << 2)
#define AIO_EARC_UNEXP_RESPONSE_IRQ	(AIO_EARC_HPD_IRQ << 3)
#define AIO_EARC_NO_RESPONSE_IRQ 	(AIO_EARC_HPD_IRQ << 4)
#define AIO_EARC_ERR_UECC_IRQ 		(AIO_EARC_HPD_IRQ << 5)
#define AIO_EARC_LOST_HEARTBEAT_IRQ 	(AIO_EARC_HPD_IRQ << 6)
#define AIO_EARC_HEARTBEAT_ACK_IRQ 	(AIO_EARC_HPD_IRQ << 7)
#define AIO_EARC_COMMA_TIMEOUT_IRQ 	(AIO_EARC_HPD_IRQ << 8)
#define AIO_EARC_RDATA_VALID_IRQ 		(AIO_EARC_HPD_IRQ << 9)
#define AIO_EARC_REQUEST_FIN_IRQ 		(AIO_EARC_HPD_IRQ << 10)
#define AIO_EARC_READ_UECC_IRQ 		(AIO_EARC_HPD_IRQ << 11)
#define AIO_EARC_READ_NACK_IRQ 		(AIO_EARC_HPD_IRQ << 12)
#define AIO_EARC_WRITE_NACK_IRQ 		(AIO_EARC_HPD_IRQ << 13)

#define AIO_OK				(0)
#define AIO_ERROR			(0x80000000)

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  earc_pll_wdset:1;
        RBus_UInt32  earc_pll_wdrst:1;
        RBus_UInt32  earc_pll_rs:3;
        RBus_UInt32  earc_pll_oeb:1;
        RBus_UInt32  earc_pll_k:3;
        RBus_UInt32  earc_pll_ip:4;
        RBus_UInt32  earc_pll_dbug_en:1;
        RBus_UInt32  earc_pll_cs:2;
        RBus_UInt32  earc_pll_cp:2;
        RBus_UInt32  df_trf_sel:2;
        RBus_UInt32  df_ck_sel:1;
        RBus_UInt32  res1:6;
        RBus_UInt32  earc_data_sel:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  pow_earc_pll:1;
        RBus_UInt32  pow_earc_mbias:1;
        RBus_UInt32  pow_earc_driver:1;
    };
}earcmisc_earc_ana_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  r_en:4;
        RBus_UInt32  r_test_en:1;
        RBus_UInt32  reserved_aphy:8;
        RBus_UInt32  res1:4;
        RBus_UInt32  r60_sel:4;
        RBus_UInt32  r300_sel:3;
        RBus_UInt32  earc_pll_pibypass:1;
        RBus_UInt32  earc_pll_p:2;
        RBus_UInt32  ldo18v_sel:2;
        RBus_UInt32  cm_ib_sel:3;
    };
}earcmisc_earc_ana_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pow_earc_ldo:1;
        RBus_UInt32  rstb_pll_vco:1;
        RBus_UInt32  earc_pll_ckrdy_fast:1;
        RBus_UInt32  df_duty_sel:3;
        RBus_UInt32  vol_level_extra:2;
        RBus_UInt32  vol_level_cm:1;
        RBus_UInt32  vol_level_df:1;
        RBus_UInt32  earc_test_mode2:1;
        RBus_UInt32  cm_data_inv:1;
        RBus_UInt32  arc_res_sel:3;
        RBus_UInt32  res1:2;
        RBus_UInt32  ldo18v_ref_sel:1;
        RBus_UInt32  earc_test_sel:4;
        RBus_UInt32  earc_test_mode:1;
        RBus_UInt32  earc_saving_mode:1;
        RBus_UInt32  df_ib_sel:3;
        RBus_UInt32  cm_trf_sel:3;
        RBus_UInt32  rstb_spk_div:1;
        RBus_UInt32  rstb_earc_pll:1;
    };
}earcmisc_earc_ana_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  df_data_inv:1;
        RBus_UInt32  df_data_sel:1;
        RBus_UInt32  df_out_inv:1;
        RBus_UInt32  df_prbs_clr:1;
        RBus_UInt32  df_prbs_en:1;
        RBus_UInt32  df_prbs_inv:1;
        RBus_UInt32  df_prbs_sel:2;
        RBus_UInt32  prbs_num:8;
        RBus_UInt32  debug_ro:8;
        RBus_UInt32  cm_rx_response:6;
        RBus_UInt32  res1:2;
    };
}earcmisc_earc_dphy1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  tx_conn_comma_off_min:4;
        RBus_UInt32  tx_conn_comma_off_max:4;
        RBus_UInt32  tx_conn_comma_count:5;
        RBus_UInt32  res2:1;
        RBus_UInt32  tx_connearc_valid:4;
        RBus_UInt32  tx_timeout:3;
        RBus_UInt32  tx_disconn:4;
        RBus_UInt32  force_earc_mode:1;
        RBus_UInt32  hdmi_hpd_hp:1;
    };
}earc_earc_cmdc_timing0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  heartbeat:4;
        RBus_UInt32  lost_heartbeat:5;
        RBus_UInt32  tx_format_chg:8;
        RBus_UInt32  res1:3;
        RBus_UInt32  tx_conn_comma_on_min:4;
        RBus_UInt32  tx_conn_comma_on_max:4;
        RBus_UInt32  res2:4;
    };
}earc_earc_cmdc_timing1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  read_uecc_num:8;
        RBus_UInt32  read_nack_num:8;
        RBus_UInt32  write_nack_num:8;
        RBus_UInt32  res1:8;
    };
}earc_earc_cmdc_nack_uecc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cmdc_tx_en:1;
        RBus_UInt32  hdmi_hpd:1;
        RBus_UInt32  fw_req:1;
        RBus_UInt32  request_case:1;
        RBus_UInt32  disc_state:4;
        RBus_UInt32  trans_state:4;
        RBus_UInt32  earc_hpd_status:1;
        RBus_UInt32  rdata_len:8;
        RBus_UInt32  continue_status:1;
        RBus_UInt32  force_trans_state:2;
        RBus_UInt32  heartbeat_en:1;
        RBus_UInt32  res1:5;
        RBus_UInt32  capability_stop:1;
        RBus_UInt32  capability_mode:1;
    };
}earc_earc_cmdc_req_RBUS;
typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  earc_hpd_irq:1;
        RBus_UInt32  cap_chng_irq:1;
        RBus_UInt32  start_chng_irq:1;
        RBus_UInt32  unexp_response_irq:1;
        RBus_UInt32  no_response_irq:1;
        RBus_UInt32  err_uecc_irq:1;
        RBus_UInt32  lost_heartbeat_irq:1;
        RBus_UInt32  heartbeat_ack_irq:1;
        RBus_UInt32  comma_timeout_irq:1;
        RBus_UInt32  rdata_valid_irq:1;
        RBus_UInt32  request_fin_irq:1;
        RBus_UInt32  read_uecc_irq:1;
        RBus_UInt32  read_nack_irq:1;
        RBus_UInt32  write_nack_irq:1;
        RBus_UInt32  res1:18;
    };
}earc_earc_cmdc_irq_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  earc_hpd_irq_en:1;
        RBus_UInt32  cap_chng_irq_en:1;
        RBus_UInt32  start_chng_irq_en:1;
        RBus_UInt32  unexp_response_irq_en:1;
        RBus_UInt32  no_response_irq_en:1;
        RBus_UInt32  err_uecc_irq_en:1;
        RBus_UInt32  lost_heartbeat_irq_en:1;
        RBus_UInt32  heartbeat_ack_irq_en:1;
        RBus_UInt32  comma_timeout_irq_en:1;
        RBus_UInt32  rdata_valid_irq_en:1;
        RBus_UInt32  request_fin_irq_en:1;
        RBus_UInt32  read_uecc_irq_en:1;
        RBus_UInt32  read_nack_irq_en:1;
        RBus_UInt32  write_nack_irq_en:1;
        RBus_UInt32  res1:18;
    };
}earc_earc_cmdc_irq_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  offset:8;
        RBus_UInt32  device_id:8;
        RBus_UInt32  res1:16;
    };
}earc_earc_cmdc_payload_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  write_data:8;
        RBus_UInt32  res1:24;
    };
}earc_earc_cmdc_write_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  read_data:32;
    };
}earc_earc_cmdc_read_RBUS;

typedef enum {
	AIO_EARC_IDLE1				=	0x0,
	AIO_EARC_EARC_HANKSHAKE	=	0x1,
	AIO_EARC_EARC				=	0x2,
	AIO_EARC_EARC_FAIL		=	0xF,
} AIO_EARC_STATE_T;

typedef enum {
	AIO_EARC_STATE_IDLE1	=	0x0,
	AIO_EARC_STATE_IDLE2	=	0x1,
	AIO_EARC_STATE_DISC1	=	0x2,
	AIO_EARC_STATE_DISC2	=	0x4,
	AIO_EARC_STATE_EARC	=	0x8,
} AIO_EARC_STATE_MACHINE_T;

typedef enum {
	AIO_AUDIO_EARC_RX_STATUS_NONE			= 0,
	AIO_AUDIO_EARC_RX_STATUS_CAP_CHNG,
	AIO_AUDIO_EARC_RX_STATUS_STAT_CHNG,
} AIO_AUDIO_EARC_RX_STATUS_T;

typedef enum {
	AIO_AUDIO_EARC_READ_CAP	= 0,
	AIO_AUDIO_EARC_READ_LATENCY,
} AIO_AUDIO_EARC_READ_T;

typedef enum {
	AIO_AUDIO_EARC_IDLE			= 	0x00,
	AIO_AUDIO_EARC_ABORT			=	0x01,
	AIO_AUDIO_EARC_EARC_CMD		=	0x02,
	AIO_AUDIO_EARC_DEVICE_ID		=	0x03,
	AIO_AUDIO_EARC_OFFSET		=	0x04,
	AIO_AUDIO_EARC_CONT1			=	0x05,
	AIO_AUDIO_EARC_CONT2			=	0x06,
	AIO_AUDIO_EARC_RETRY			=	0x07,
	AIO_AUDIO_EARC_DATA1			=	0x08,
	AIO_AUDIO_EARC_DATA2			=	0x09,
	AIO_AUDIO_EARC_STOP			=	0x0A,
} AIO_AUDIO_EARC_TRANS_STATE_T;

typedef enum {
	AIO_AUDIO_EARC_TRAN_IDLE						=	0x000,
	/* Read State */
	AIO_AUDIO_EARC_TRAN_READ_CAP_PROCESS		=	0x001,
	AIO_AUDIO_EARC_TRAN_READ_CAP_RETRY		=	0x002,
	AIO_AUDIO_EARC_TRAN_READ_CAP_FINISH		=	0x003,
	AIO_AUDIO_EARC_TRAN_READ_CAP_FALSE			=	0x004,
	
	AIO_AUDIO_EARC_TRAN_READ_LATENCY_PROCESS	=	0x011,
	AIO_AUDIO_EARC_TRAN_READ_LATENCY_RETRY	=	0x012,
	AIO_AUDIO_EARC_TRAN_READ_LATENCY_FINISH	=	0x013,
	AIO_AUDIO_EARC_TRAN_READ_LATENCY_FALSE	=	0x014,
	
	/* Write State */
	AIO_AUDIO_EARC_TRAN_WRITE_LATENCY_PROCESS=	0x111,
	AIO_AUDIO_EARC_TRAN_WRITE_LATENCY_RETRY	=	0x112,
	AIO_AUDIO_EARC_TRAN_WRITE_LATENCY_FINISH	=	0x113,
	AIO_AUDIO_EARC_TRAN_WRITE_LATENCY_FALSE	=	0x114,
} AIO_AUDIO_EARC_TRAN_STATE_T;

typedef struct {
	AIO_EARC_STATE_MACHINE_T ConnectState;
	AIO_AUDIO_EARC_RX_STATUS_T RxState;
	bool ReadCapReady;
	bool ReadLatencyReady;
	AIO_AUDIO_EARC_TRAN_STATE_T TransactionState;
	bool CommaTimeout;
} EARC_STATE_T;

typedef struct {
	AIO_AUDIO_EARC_READ_T Type;
	unsigned char *ReadData;
} AIO_AUDIO_EARC_CMDC_READ_T;

typedef enum {
	AIO_AUDIO_ARC	= 0,
	AIO_AUDIO_EARC,
} AIO_AUDIO_EARC_ARC_SWITCH_T;
#endif

/*======================== Type Defines ========================*/

/*------------------DMA----------------------*/
typedef enum {
	//PlayBack/TimeShiting path select
	TS_Path					=0x0,
 	PB_Path					=0x1,
 	ARC_Path				=0x2	//Clayton 2019/6/2
}QC_Path_Sel;

typedef enum {
	//R/L channel select
	CHL						=0x0,
 	CHR						=0x1,
}QC_LRCH_Sel;

typedef enum {
	DMA_nonPCM				=0x1,
	DMA_PCM				=0x0,
}QC_DMA_Format;

typedef enum {
    TV                      = 0x0,
    DMP                     = 0x1,
    TV_VUCP			= 0x2
}QC_pcm_format;

typedef enum {
    from_ds_fifo        =0x0,
    from_post_hw            =0x1,
    from_HDMI_IN            =0x2,
    from_pb_dma_read        =0x3,
}QC_DMA_wr_Src_Sel;

typedef enum {
	DMA_from_DMA_Read           =0x0,
	DMA_triangular_wave			=0x1,
	DMA_increase_count_wave		=0x2,
	DMA_zeros					= 0x3
}QC_DMA_output_src_Sel;

typedef enum {
	one_CH					=0x0,
	nonPCM_twoCH			=0x0,
	two_CH					=0x1,
	nonPCM_fourCH			=0x1,
	three_CH					=0x2,
	four_CH					=0x3,
	nonPCM_eightCH			=0x3,
	five_CH					=0x4,
	six_CH					=0x5,
	seven_CH					=0x6,
	eight_CH					=0x7,
}QC_ChannelType_Sel;


typedef enum {
    non_hbr                 = 0x0,
    hbr_mode                = 0x1,
}QC_DMA_W_HBRMode;

typedef enum {
    w_dma_pcm_non_random    = 0x0,
    w_dma_pcm_random        = 0x1,
}QC_DMA_W_RamdomMode;

typedef struct {
	UINT32 src_from;
	UINT32 w_pcm_format;
	UINT32 wr_channels;
	UINT32 audio_in_type;
	UINT32 samples;
    	UINT32 w_path;
	UINT32 w_HBR_mode;		
    	UINT32 pcm_random;
}QC_WDMA_CFG;

typedef struct {
	UINT32 CH01;
	UINT32 CH23;
	UINT32 CH45;
	UINT32 CH67;
}QC_WDMA_FIFO_SRC;

typedef struct {
	UINT32 src_from;
	UINT32 r_pcm_format;
	UINT32 rd_channels;
	UINT32 audio_out_type;
	UINT32 samples;
    	UINT32 r_path;
	//UINT32 R_HBR_mode;
}QC_RDMA_CFG;

typedef struct {
	UINT32 rd_start_addr_ch0;
	UINT32 rd_start_addr_ch1;
	UINT32 rd_start_addr_ch2;
	UINT32 rd_start_addr_ch3;
	UINT32 rd_start_addr_ch4;
    	UINT32 rd_start_addr_ch5;
	UINT32 rd_start_addr_ch6;
	UINT32 rd_start_addr_ch7;		
}QC_RD_START_ADDR;

typedef struct {
	UINT32 wr_start_addr_ch0;
	UINT32 wr_start_addr_ch1;
	UINT32 wr_start_addr_ch2;
	UINT32 wr_start_addr_ch3;
	UINT32 wr_start_addr_ch4;
    	UINT32 wr_start_addr_ch5;
	UINT32 wr_start_addr_ch6;
	UINT32 wr_start_addr_ch7;		
}QC_WR_START_ADDR;

typedef enum {
	//DSFIFO source select
	TV_audio					=0x0,
 	ADC						=0x1,
 	SPDIFin					=0x2, 	
	I2Sch01					=0x4,
	I2Sch23					=0x5,
	I2Sch45					=0x6,
	I2Sch67					=0x7,
	dmic0					=0x8,
	dmic1					=0x9,
	asrcin_in					=0xa
}QC_FIFO_SrcSel;

//Frank add
typedef enum {
	AIO_PEAK_SRC_ATV              = 0x0,
	AIO_PEAK_SRC_BBADC            = 0x1,
	AIO_PEAK_SRC_SPDIF            = 0x2,
	AIO_PEAK_SRC_BBADC2           = 0x3,
	AIO_PEAK_SRC_I2S_CH01         = 0x4,
	AIO_PEAK_SRC_I2S_CH23         = 0x5,
	AIO_PEAK_SRC_I2S_CH45         = 0x6,
	AIO_PEAK_SRC_I2S_CH67         = 0x7,
	AIO_PEAK_SRC_BF_AVC2_PB_CH01  = 0x8,
	AIO_PEAK_SRC_AF_AVC2_PB_CH01  = 0x9,
	AIO_PEAK_SRC_TS_CH01          = 0xA,
	AIO_PEAK_SRC_AF_AVC2_PB_CH23  = 0xB,
	AIO_PEAK_SRC_AF_AVC2_PB_CH45  = 0xC,
	AIO_PEAK_SRC_AF_AVC2_PB_CH67  = 0xD,
	//others hw_ts ch0/1

}AIO_PEAK_SRC;

typedef enum {
	//DSFIFO source select
	BF_AVC1					=0x0,
 	BF_AVC2					=0x1,
 	AF_AVC1					=0x2,
 	AF_AVC2					=0x3,
 	CH23_AF_AVC2            =0x4,
 	CH45_AF_AVC2            =0x5,
 	CH67_AF_AVC2            =0x6,
	BF_TSDVC				=0x7,
 	AF_TSDVC				=0x8,
}QC_DAC_SrcSel;

typedef enum {
	SPDIF0					=0x0,
 	SPDIF1					=0x1,
}QC_SPDIF_Index;

typedef enum {
	normal_spdif_out					=0x0,
 	from_external_spdif_in_pad		=0x1,
 	disable_spdif_out					=0x3
}QC_SPDIF_Output_Sel;

typedef enum {
	SPDIF_ch01_before_distortion			=0x0,
 	SPDIF_chXY_before_avc2				=0x1,
 	SPDIF_ch01_after_avc1					=0x2,
 	SPDIF_chXY_after_avc2					=0x3,
 	SPDIF_ch01_before_TSDVC				=0x4,
 	SPDIF_ch01_after_TSDVC				=0x5,
 	SPDIF_non_pcm_from_pb_dma			=0x6,
 	SPDIF_non_pcm_from_ts_dma			=0x7,
 	SPDIF_pcm_from_arc_dma				=0x8,
 	SPDIF_ch23_after_avc2					=0xa,
 	SPDIF_ch45_after_avc2					=0xb,
 	SPDIF_non_pcm_from_arc_dma			=0xc,
 	SPDIF_zeros							=0xf 	
}QC_SPDIF_Pcm_Source_Sel;

typedef enum {
	normal_i2s_out					=0x0,
 	from_external_i2s_in_pad			=0x1,
 	disable_i2s_out					=0x4
}QC_I2S_Output_Sel;

typedef enum {
	I2S_ch01_before_distortion			=0x0,
 	I2S_ch01_before_avc2				=0x1,
 	I2S_ch01_after_avc1					=0x2,
 	I2S_ch01_after_avc2					=0x3,
 	I2S_ch01_before_TSDVC				=0x4,
 	I2S_ch01_after_TSDVC				=0x5,
 	I2S_ch01_after_mixer					=0x6,
 	I2S_ch01_arc_dma							=0x9,
 	I2S_ch01_zeros							=0xf 	
}QC_I2S_Pcm_Source_Sel_Ch01;

typedef enum {
 	I2S_ch23_before_avc2				=0x1,
 	I2S_ch23_after_avc2					=0x3,
 	I2S_ch23_arc_dma							=0x9
}QC_I2S_Pcm_Source_Sel_Ch23;

typedef enum {
 	I2S_ch45_before_avc2				=0x1,
 	I2S_ch45_after_avc2					=0x3,
 	I2S_ch45_arc_dma							=0x9
}QC_I2S_Pcm_Source_Sel_Ch45;

typedef enum {
 	I2S_ch67_before_avc2				=0x1,
 	I2S_ch67_after_avc2					=0x3,
 	I2S_ch67_arc_dma							=0x9
}QC_I2S_Pcm_Source_Sel_Ch67;

typedef enum {
 	I2S_MCLK_128Fs				=0x0,
 	I2S_MCLK_256Fs				=0x1,
 	I2S_MCLK_512Fs				=0x2,
 	I2S_MCLK_OFF				=0x3
}QC_I2S_MCLK;

typedef enum {
	ch01			=0x0,
 	ch23			=0x1,
 	ch45			=0x2,
 	ch67			=0x3
}QC_CH_Pair;

typedef enum {
    PLL_eARC_1X            	= 0x0,
    PLL_SPDIF                 	= 0x1,
    PLL_AUDIO                	= 0x2,
    PLL_eARC_1X_48k		= 0x3
}ClockSource;

typedef enum {
    play_r_128fs           	= 0x0,
    play_r_128fs_ts          	= 0x1,
    play_r_128fs_arc       	= 0x2,
    ASRC_out_clk			= 0x3
}ClockSrc;


typedef enum {
	DMA_Play				=0x1,
	DMA_Bypass 				=0x0,
}QC_DMA_PATH;


typedef enum {
	zeros					=0x0,
	triangular_wave			=0x1,
	increase_count_wave		=0x2,
}QC_InternalPeattern_Sel;

typedef enum {
	oneCH					=0x1,
	twoCH					=0x2,
	threeCH					=0x3,
	fourCH					=0x4,
	fiveCH					=0x5,
	sixCH					=0x6,
	sevenCH					=0x7,
	eightCH					=0x8,
}QC_ChannelNumber_Sel;

typedef enum {
	CH0						=0x0,
	CH1						=0x1,
	CH2						=0x2,
	CH3						=0x3,
	CH4						=0x4,
	CH5						=0x5,
	CH6						=0x6,
	CH7						=0x7,
}QC_Channel_Sel;

typedef enum {
	PrePeakDetect			=0x0,
	PostPeakDetect			=0x1,
}QC_PeakDetect_Sel;

typedef enum {
	//I2S IN source select
	I2S_normal            	 		=0x0,
	I2S_HDMI		  		=0x1,
	I2S_loopback			 	=0x2,
	I2S_disable			 	=0x4,	//Merlin5 update
}QC_I2SIO_SrcSel;

typedef enum {
	//SPDIF IN/Out source select
	SPDIF_normal              		=0x0,
	SPDIF_HDMI		 		=0x1,
	SPDIF_loopback			=0x2,
	SPDIF_disable			 	=0x3,
}QC_SPDIFIO_SrcSel;

typedef enum {
	//Analog input/output source select
	AIN1_ADC					=0x0,
	AIN2_ADC					=0x1,
	AIN3_ADC					=0x2,
	AIN4_ADC					=0x4,
	AIN5_ADC					=0x5,
	AIO1_ADC					=0x6,
	AIO2_ADC					=0x7,
	AIN1_ADC2					=0x8,
	AIN2_ADC2					=0x9,
	AIN3_ADC2					=0xA,
	AIN4_ADC2					=0xB,
	AIN5_ADC2					=0xC,
	AIO1_ADC2					=0xD,
	AIO2_ADC2					=0xE,
	DAC0					    =0x10,
	DAC1					    =0x11,
	MUTEALL					    =-1,
}QC_AIO_SrcSel;

typedef enum {
	//QC test case select
	PCB_QFP				=0x0,
	PCB_BGA				=0x1,
}QC_AudioTestcase;

typedef struct {
	UINT32 src_from;
	//UINT32 tv_bu_format;
	UINT32 pcm_format;
	//UINT32 lsb_random;
	UINT32 wr_channels;
	UINT32 rd_channels;
	//UINT32 hbr_mode;
	//UINT32 hbr_wr_channels;
	UINT32 samples;
	//UINT32 dma_pattern;
	UINT32 is_playback;
}QC_DMA_CFG;

/*===================== Routines Prototype ====================*/
// Register R/W
static void WriteRegister(UINT32 address, UINT32 data);
static UINT32 ReadRegister(UINT32 address);
static void WriteMaskRegister(UINT32 address, UINT32 mask, UINT32 data);
void aud_Delay(int delayMS);

//config_AudioInit
void aud_DrPLL(void);
void aud_DrClock(void);
void aud_DrBaseband(void);
void aud_DrGpio(void);
void aud_DrSIF(void);
void aud_DrInitialize(void);

//config_AudioPath_Digital
/*---I2S---*/
void dx_I2sSetInputPri(QC_I2SIO_SrcSel src_select);
UINT32 dx_I2sGetWordLength(UINT32 is_sec_module);
UINT32 dx_I2sGetSampleRate(void);
void dx_I2sSetOutput(QC_I2SIO_SrcSel  src_select, UINT32 pcm_src);
/*---SPDIF---*/
void dx_SpdifSetInput(QC_SPDIFIO_SrcSel src_select);
UINT32 dx_SpdifGetSampleRate(void);
void dx_SpdifSetOutput0(QC_SPDIFIO_SrcSel src_select, UINT32 pcm_src);
void dx_SpdifSetOutput1(QC_SPDIFIO_SrcSel src_select, UINT32 pcm_src);

//config_AudioPath_Analog
void dx_AdcSetInput(QC_AIO_SrcSel src_select);
void dx_FifoPlay_CH01(QC_FIFO_SrcSel play_src_select);
void dx_FifoTs_CH01(QC_FIFO_SrcSel ts_src_select);
void dx_Dac0SetOutput(UINT32 src_select);
void dx_Dac1SetOutput(UINT32 src_select);
void dx_HPSetOutput(QC_AIO_SrcSel src_select);
void dx_LOSetOutput(QC_AIO_SrcSel src_select);
void dx_AIO1SetOutput(QC_AIO_SrcSel src_select);
void dx_AIO2SetOutput(QC_AIO_SrcSel src_select);

//config_AudioFunction
UINT32 dx_AutotSineCheck(UINT32 amplitude, UINT32 cntthd, UINT32 frequency ,QC_LRCH_Sel ch_select);
UINT32 dx_PeakDetectSet( AIO_PEAK_SRC src_select , QC_LRCH_Sel ch_select);

//config_AudioDMA
void dx_DmaTsPath(QC_DMA_PATH is_ts_dma);
void dx_DmaDsPath(QC_DMA_PATH is_play_dma);
void dx_InternalPatternGenerator(QC_InternalPeattern_Sel test_case, QC_ChannelNumber_Sel chs);
void dx_InternalPatternGeneratorTS(QC_InternalPeattern_Sel test_case, QC_ChannelNumber_Sel chs);

/*---QC test function---*/
//i2s internal path samplerate detection
UINT32 aud_esd_I2s(void);
//spdif internal path samplerate detection
UINT32 aud_esd_Spdif0(void);
UINT32 aud_esd_Spdif1(void);
//all of aud_baseband_PeakDetection ( analog path peak detection ) is added ycwu
UINT32 aud_baseband_PeakDetection(QC_AudioTestcase test_case);
UINT32 aud_spdif_PeakDetection(QC_AudioTestcase test_case);
UINT32 aud_I2S_PeakDetection(QC_AudioTestcase test_case);
UINT32 aud_baseband_AutoSineCheck(QC_AudioTestcase test_case);
#ifdef SET_DMA_ADDR
int aud_QcDma(unsigned int wr_ptr, unsigned int rd_ptr);
#else
int aud_QcDma(unsigned int *wr_ptr, unsigned int *rd_ptr);
#endif

#endif

