/**
* @file rbusTV_SB1_ANAReg.h
* RBus systemc program.
*
* @author RS_MM2_SD
* @email jason9.ccc@realtek.com
 * @date 2015-2-16
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_sIFD_ANALOG_VADDR_H_
#define _RBUS_sIFD_ANALOG_VADDR_H_

//#include  "../../../uboot/include/asm/arch-rtd299s/rbus/rbusTypes.h"

#include "rtd_types_qc.h"

//  TV_SB1_ANA Register Address


#define  IFD_ANALOG_VDAC_CTRL1_VADDR                                               (0xB8033000)
#define  IFD_ANALOG_VDAC_CTRL2_VADDR                                               (0xB8033004)
#define  IFD_ANALOG_VDAC_CTRL3_VADDR                                               (0xB8033008)
#define  IFD_ANALOG_VDAC_SRC_SEL_VADDR                                             (0xB8033024)
#define  IFD_ANALOG_IFADC_CTRL1_VADDR                                              (0xB8033100)
#define  IFD_ANALOG_IFADC_CTRL2_VADDR                                              (0xB8033104)
#define  IFD_ANALOG_IFADC_SERVO_VADDR                                              (0xB8033108)
#define  IFD_ANALOG_IFADC_MBIAS_VADDR                                              (0xB803310C)
#define  IFD_ANALOG_IFADC_POW_VADDR                                                (0xB8033110)
#define  IFD_ANALOG_LSADC_RSSI_CTRL_VADDR                                          (0xB8033200)
#define  IFD_ANALOG_LSADC_RSSI_POW_MBIAS_VADDR                                     (0xB8033204)

#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======TV_SB1_ANA register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  reg_vid_powldv:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  reg_vid_powmbias:1;
        RBus_UInt32  res3:3;
        RBus_UInt32  reg_vid_powvdac:1;
        RBus_UInt32  res4:2;
        RBus_UInt32  reg_vid_mbias_ibsel:2;
        RBus_UInt32  res5:2;
        RBus_UInt32  reg_vid_mbias_ibxsel:2;
        RBus_UInt32  res6:3;
        RBus_UInt32  reg_vid_ldv_bufgain:1;
        RBus_UInt32  res7:3;
        RBus_UInt32  reg_vid_ldv_dcc:1;
        RBus_UInt32  res8:2;
        RBus_UInt32  reg_vid_ldv_vcmsel:2;
    };
}vdac_ctrl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  reg_vid_ldv_stby:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  reg_vid_ldv_biassel:2;
        RBus_UInt32  res3:3;
        RBus_UInt32  reg_vid_ldv_endrv:1;
        RBus_UInt32  res4:2;
        RBus_UInt32  reg_vid_ldv_iqsel:2;
        RBus_UInt32  res5:1;
        RBus_UInt32  reg_vid_ldv_odsel:3;
        RBus_UInt32  res6:2;
        RBus_UInt32  reg_vid_vdac_biassel:2;
        RBus_UInt32  res7:3;
        RBus_UInt32  reg_vid_vdac_dcc:1;
        RBus_UInt32  res8:3;
        RBus_UInt32  reg_vid_vdac_stby:1;
    };
}vdac_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  reg_vid_vdac_vcmsel:2;
        RBus_UInt32  res2:3;
        RBus_UInt32  reg_vid_vdac_endrv:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  reg_vid_vdac_iqsel:2;
        RBus_UInt32  res4:1;
        RBus_UInt32  reg_vid_vdac_odsel:3;
        RBus_UInt32  res5:3;
        RBus_UInt32  reg_vid_vdac_ckmode:1;
        RBus_UInt32  res6:1;
        RBus_UInt32  reg_vid_vdac_dacisel:3;
        RBus_UInt32  res7:2;
        RBus_UInt32  reg_vid_vdac_rsel:2;
        RBus_UInt32  res8:2;
        RBus_UInt32  reg_vid_vdac_csel:2;
    };
}vdac_ctrl3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  reg_vdac_clk_polar:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  reg_vdac_src_sel:3;
    };
}vdac_src_sel_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  reg_adc2x_bg_sel:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  reg_adc2x_ckout_div:2;
        RBus_UInt32  res3:3;
        RBus_UInt32  reg_adc2x_ckout_edge:1;
        RBus_UInt32  res4:3;
        RBus_UInt32  reg_adc2x_delay:1;
        RBus_UInt32  res5:3;
        RBus_UInt32  res6:1;
        RBus_UInt32  reg_adc2x_fixgain:4;
        RBus_UInt32  res7:2;
        RBus_UInt32  reg_adc2x_ifbw:2;
        RBus_UInt32  res8:3;
        RBus_UInt32  reg_adc2x_insel:1;
    };
}ifadc_ctrl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  reg_adc2x_ldo_sel:2;
        RBus_UInt32  res2:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:2;
        RBus_UInt32  reg_adc2x_vref_sel:2;
        RBus_UInt32  res5:1;
        RBus_UInt32  reg_ifcmp_isel:3;
        RBus_UInt32  res6:2;
        RBus_UInt32  reg_ifd_ckin_sel:2;
        RBus_UInt32  reg_ifd_reserved:8;
        RBus_UInt32  res7:4;
    };
}ifadc_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  reg_adc2x_servo:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  reg_adc2x_svbwc:2;
        RBus_UInt32  res3:2;
        RBus_UInt32  reg_adc2x_svbwr:2;
    };
}ifadc_servo_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_mbias_ifpga:12;
        RBus_UInt32  res1:2;
        RBus_UInt32  reg_mbias_isel:2;
        RBus_UInt32  res2:16;
    };
}ifadc_mbias_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  reg_adc2x_adcpow:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  reg_adc2x_difpow:1;
        RBus_UInt32  res3:3;
        RBus_UInt32  reg_adc2x_ifpgapow:1;
        RBus_UInt32  res4:3;
        RBus_UInt32  reg_adc2x_meta_pow:1;
        RBus_UInt32  res5:3;
        RBus_UInt32  reg_adc2x_servopow2:1;
        RBus_UInt32  res6:3;
        RBus_UInt32  reg_pow_mbias:1;
        RBus_UInt32  res7:8;
    };
}ifadc_pow_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:19;
        RBus_UInt32  reg_lsadc_cksel:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  reg_lsadc_div:2;
        RBus_UInt32  res3:2;
        RBus_UInt32  reg_rssi_bias:2;
        RBus_UInt32  res4:2;
        RBus_UInt32  reg_rssi_cl:2;
    };
}lsadc_rssi_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:23;
        RBus_UInt32  reg_rssi_lsadc_pow:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  reg_mbias_lsadc:2;
        RBus_UInt32  res3:2;
        RBus_UInt32  reg_mbias_rssi:2;
    };
}lsadc_rssi_pow_mbias_RBUS;

#else //apply LITTLE_ENDIAN

//======TV_SB1_ANA register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_vid_ldv_vcmsel:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  reg_vid_ldv_dcc:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  reg_vid_ldv_bufgain:1;
        RBus_UInt32  res3:3;
        RBus_UInt32  reg_vid_mbias_ibxsel:2;
        RBus_UInt32  res4:2;
        RBus_UInt32  reg_vid_mbias_ibsel:2;
        RBus_UInt32  res5:2;
        RBus_UInt32  reg_vid_powvdac:1;
        RBus_UInt32  res6:3;
        RBus_UInt32  reg_vid_powmbias:1;
        RBus_UInt32  res7:3;
        RBus_UInt32  reg_vid_powldv:1;
        RBus_UInt32  res8:3;
    };
}vdac_ctrl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_vid_vdac_stby:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  reg_vid_vdac_dcc:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  reg_vid_vdac_biassel:2;
        RBus_UInt32  res3:2;
        RBus_UInt32  reg_vid_ldv_odsel:3;
        RBus_UInt32  res4:1;
        RBus_UInt32  reg_vid_ldv_iqsel:2;
        RBus_UInt32  res5:2;
        RBus_UInt32  reg_vid_ldv_endrv:1;
        RBus_UInt32  res6:3;
        RBus_UInt32  reg_vid_ldv_biassel:2;
        RBus_UInt32  res7:2;
        RBus_UInt32  reg_vid_ldv_stby:1;
        RBus_UInt32  res8:3;
    };
}vdac_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_vid_vdac_csel:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  reg_vid_vdac_rsel:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  reg_vid_vdac_dacisel:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  reg_vid_vdac_ckmode:1;
        RBus_UInt32  res4:3;
        RBus_UInt32  reg_vid_vdac_odsel:3;
        RBus_UInt32  res5:1;
        RBus_UInt32  reg_vid_vdac_iqsel:2;
        RBus_UInt32  res6:2;
        RBus_UInt32  reg_vid_vdac_endrv:1;
        RBus_UInt32  res7:3;
        RBus_UInt32  reg_vid_vdac_vcmsel:2;
        RBus_UInt32  res8:2;
    };
}vdac_ctrl3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_vdac_src_sel:3;
        RBus_UInt32  res1:1;
        RBus_UInt32  reg_vdac_clk_polar:1;
        RBus_UInt32  res2:27;
    };
}vdac_src_sel_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_adc2x_insel:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  reg_adc2x_ifbw:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  reg_adc2x_fixgain:4;
        RBus_UInt32  res3:1;
        RBus_UInt32  res4:3;
        RBus_UInt32  reg_adc2x_delay:1;
        RBus_UInt32  res5:3;
        RBus_UInt32  reg_adc2x_ckout_edge:1;
        RBus_UInt32  res6:3;
        RBus_UInt32  reg_adc2x_ckout_div:2;
        RBus_UInt32  res7:2;
        RBus_UInt32  reg_adc2x_bg_sel:2;
        RBus_UInt32  res8:2;
    };
}ifadc_ctrl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  reg_ifd_reserved:8;
        RBus_UInt32  reg_ifd_ckin_sel:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  reg_ifcmp_isel:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  reg_adc2x_vref_sel:2;
        RBus_UInt32  res4:2;
        RBus_UInt32  res5:1;
        RBus_UInt32  res6:3;
        RBus_UInt32  reg_adc2x_ldo_sel:2;
        RBus_UInt32  res7:2;
    };
}ifadc_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_adc2x_svbwr:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  reg_adc2x_svbwc:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  reg_adc2x_servo:2;
        RBus_UInt32  res3:22;
    };
}ifadc_servo_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:16;
        RBus_UInt32  reg_mbias_isel:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  reg_mbias_ifpga:12;
    };
}ifadc_mbias_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  reg_pow_mbias:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  reg_adc2x_servopow2:1;
        RBus_UInt32  res3:3;
        RBus_UInt32  reg_adc2x_meta_pow:1;
        RBus_UInt32  res4:3;
        RBus_UInt32  reg_adc2x_ifpgapow:1;
        RBus_UInt32  res5:3;
        RBus_UInt32  reg_adc2x_difpow:1;
        RBus_UInt32  res6:3;
        RBus_UInt32  reg_adc2x_adcpow:1;
        RBus_UInt32  res7:3;
    };
}ifadc_pow_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_rssi_cl:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  reg_rssi_bias:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  reg_lsadc_div:2;
        RBus_UInt32  res3:2;
        RBus_UInt32  reg_lsadc_cksel:1;
        RBus_UInt32  res4:19;
    };
}lsadc_rssi_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_mbias_rssi:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  reg_mbias_lsadc:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  reg_rssi_lsadc_pow:1;
        RBus_UInt32  res3:23;
    };
}lsadc_rssi_pow_mbias_RBUS;




#endif 


#endif 
