/*=============================================================
 * Copyright (c)      Realtek Semiconductor Corporation, 2016
 *
 * All rights reserved.
 *
 *============================================================*/

/*======================= Description ============================
 *
 * file: 		hdmi_ddc.c
 *
 * author: 	Ant Man, Scott Lang
 * date:
 * version: 	3.0
 *
 *============================================================*/

/*========================Header Files============================*/
#include "hdmi_common.h"





/**********************************************************************************************
*
*	Marco or Definitions
*
**********************************************************************************************/

#define REG_EDID_CTL_OFFSET          0x0c
#define REG_DDC_SIR_OFFSET           0x20
#define REG_DDC_SAP_OFFSET          0x24





/**********************************************************************************************
*
*	Const Declarations
*
**********************************************************************************************/

const unsigned int ddc_reg[HDMI_PORT_TOTAL_NUM] = {
	ISO_MISC_DDC1_I2C_CR_reg,
	ISO_MISC_DDC2_I2C_CR_reg,
	ISO_MISC_DDC3_I2C_CR_reg,
	ISO_MISC_DDC4_I2C_CR_reg
};


const unsigned int pinmux_reg[HDMI_PORT_TOTAL_NUM] = {
	0xb8060214,
	0xb8060210,
	0xb8060210,
	0xb8060218,
};

const unsigned int pinmux_mask[HDMI_PORT_TOTAL_NUM] = {
	0xf0000000,
	0x0000f000,
	0xf0000000,
	0xf0000000,
};

const unsigned int pinmux_gpo[HDMI_PORT_TOTAL_NUM] = {
	0x50000000,
	0x00005000,
	0x50000000,
	0x50000000,
};

const unsigned int gpio_dir_reg[HDMI_PORT_TOTAL_NUM] = {
	0xb8061104,
	0xb8061100,
	0xb8061100,
	0xb8061104,
};
const unsigned int gpio_dir_bit[HDMI_PORT_TOTAL_NUM]= {_BIT1, _BIT30, _BIT28, _BIT5};


/**********************************************************************************************
*
*	Funtion Declarations
*
**********************************************************************************************/


unsigned char lib_hdmiddc_is_edid_valid(unsigned char* EDID);





/**********************************************************************************************
*
*	Function Body
*
**********************************************************************************************/

void lib_hdmiddc_crt_on(void)
{

//int rtk_ddc_drv_crt_on(void)
    hdmi_out(STB_ST_SRST1_reg, (STB_ST_SRST1_write_data_mask|STB_ST_SRST1_rstn_ddc1_mask|STB_ST_SRST1_rstn_ddc2_mask|STB_ST_SRST1_rstn_ddc3_mask|STB_ST_SRST1_rstn_ddc4_mask));
    hdmi_out(STB_ST_CLKEN1_reg, (STB_ST_CLKEN1_write_data_mask|STB_ST_CLKEN1_clken_ddc1_mask|STB_ST_CLKEN1_clken_ddc2_mask|STB_ST_CLKEN1_clken_ddc3_mask|STB_ST_CLKEN1_clken_ddc4_mask));

    hdmi_out(STB_ST_SRST1_reg, (STB_ST_SRST1_write_data_mask|STB_ST_SRST1_rstn_ddc_mask));
    hdmi_out(STB_ST_CLKEN1_reg, (STB_ST_CLKEN1_write_data_mask|STB_ST_CLKEN1_clken_ddc_mask));



}


void lib_hdmiddc_sync_reset(unsigned char port)
{
	switch (port) {
	case 0:
		hdmi_out(STB_ST_CLKEN1_reg, (STB_ST_CLKEN1_clken_ddc1_mask));
		hdmi_out(STB_ST_SRST1_reg, (STB_ST_SRST1_rstn_ddc1_mask));

		hdmi_out(STB_ST_CLKEN1_reg, (STB_ST_SRST1_write_data_mask|STB_ST_CLKEN1_clken_ddc1_mask));
		hdmi_out(STB_ST_CLKEN1_reg, (STB_ST_CLKEN1_clken_ddc1_mask));

		hdmi_out(STB_ST_SRST1_reg, (STB_ST_SRST1_write_data_mask|STB_ST_SRST1_rstn_ddc1_mask));
		hdmi_out(STB_ST_CLKEN1_reg, (STB_ST_CLKEN1_write_data_mask|STB_ST_CLKEN1_clken_ddc1_mask));
		break;
	case 1:
		hdmi_out(STB_ST_CLKEN1_reg, (STB_ST_CLKEN1_clken_ddc2_mask));
		hdmi_out(STB_ST_SRST1_reg, (STB_ST_SRST1_rstn_ddc2_mask));

		hdmi_out(STB_ST_CLKEN1_reg, (STB_ST_SRST1_write_data_mask|STB_ST_CLKEN1_clken_ddc2_mask));
		hdmi_out(STB_ST_CLKEN1_reg, (STB_ST_CLKEN1_clken_ddc2_mask));

		hdmi_out(STB_ST_SRST1_reg, (STB_ST_SRST1_write_data_mask|STB_ST_SRST1_rstn_ddc2_mask));
		hdmi_out(STB_ST_CLKEN1_reg, (STB_ST_CLKEN1_write_data_mask|STB_ST_CLKEN1_clken_ddc2_mask));
		break;
	case 2:
		hdmi_out(STB_ST_CLKEN1_reg, (STB_ST_CLKEN1_clken_ddc3_mask));
		hdmi_out(STB_ST_SRST1_reg, (STB_ST_SRST1_rstn_ddc3_mask));

		hdmi_out(STB_ST_CLKEN1_reg, (STB_ST_SRST1_write_data_mask|STB_ST_CLKEN1_clken_ddc3_mask));
		hdmi_out(STB_ST_CLKEN1_reg, (STB_ST_CLKEN1_clken_ddc3_mask));

		hdmi_out(STB_ST_SRST1_reg, (STB_ST_SRST1_write_data_mask|STB_ST_SRST1_rstn_ddc3_mask));
		hdmi_out(STB_ST_CLKEN1_reg, (STB_ST_CLKEN1_write_data_mask|STB_ST_CLKEN1_clken_ddc3_mask));
		break;
	case 3:
		hdmi_out(STB_ST_CLKEN1_reg, (STB_ST_CLKEN1_clken_ddc4_mask));
		hdmi_out(STB_ST_SRST1_reg, (STB_ST_SRST1_rstn_ddc4_mask));

		hdmi_out(STB_ST_CLKEN1_reg, (STB_ST_SRST1_write_data_mask|STB_ST_CLKEN1_clken_ddc4_mask));
		hdmi_out(STB_ST_CLKEN1_reg, (STB_ST_CLKEN1_clken_ddc4_mask));

		hdmi_out(STB_ST_SRST1_reg, (STB_ST_SRST1_write_data_mask|STB_ST_SRST1_rstn_ddc4_mask));
		hdmi_out(STB_ST_CLKEN1_reg, (STB_ST_CLKEN1_write_data_mask|STB_ST_CLKEN1_clken_ddc4_mask));
		break;
	default:
		break;
	}

}




unsigned char lib_hdmiddc_write(unsigned char port, unsigned char* EDID, unsigned int len)
{
	unsigned char en_bk;
	unsigned int i, ddc_addr;

	lib_hdmiddc_crt_on();

	if (!lib_hdmiddc_is_edid_valid(EDID))
		return FALSE;

	if (port >= HDMI_PORT_TOTAL_NUM)
		return FALSE;


	ddc_addr = ddc_reg[port];

	en_bk = ISO_MISC_DDC1_EDID_CR_get_edid_en(hdmi_in(ddc_addr + REG_EDID_CTL_OFFSET));
	hdmi_mask(ddc_addr + REG_EDID_CTL_OFFSET, ~ISO_MISC_DDC1_EDID_CR_edid_en_mask, ISO_MISC_DDC1_EDID_CR_edid_en(0));

	for (i=0; i<len; i++) {
		hdmi_out(ddc_addr+REG_DDC_SIR_OFFSET, i);
		hdmi_out(ddc_addr+REG_DDC_SAP_OFFSET, EDID[i]);
	}

	hdmi_mask(ddc_addr, ~ISO_MISC_DDC1_I2C_CR_debounce_mode_mask, ISO_MISC_DDC1_I2C_CR_debounce_mode(2));	//20170120 ddc_debounce=2 by DDC DIC/SD
	hdmi_mask(ddc_addr + REG_EDID_CTL_OFFSET, ~ISO_MISC_DDC1_EDID_CR_edid_en_mask, ISO_MISC_DDC1_EDID_CR_edid_en(en_bk));

	return TRUE;

}

unsigned char lib_hdmiddc_read(unsigned char port, unsigned char *edid_tbl, unsigned int len)
{
	unsigned int i;
	unsigned int ddc_addr;

	if (port >= HDMI_PORT_TOTAL_NUM)
		return FALSE;


	ddc_addr = ddc_reg[port];
	hdmi_out(ddc_addr+REG_DDC_SIR_OFFSET, 0);

	ddc_addr += REG_DDC_SAP_OFFSET;

	for(i=0; i< len; i++) {
		edid_tbl[i] = hdmi_in(ddc_addr);
	}

	return TRUE;
}

void lib_hdmiddc_enable(unsigned char port, unsigned char enable)
{
	unsigned int ddc_addr;

	if (port >= HDMI_PORT_TOTAL_NUM)
		return;


	ddc_addr = ddc_reg[port];
	hdmi_mask(ddc_addr + REG_EDID_CTL_OFFSET, ~ISO_MISC_DDC1_EDID_CR_edid_en_mask, ISO_MISC_DDC1_EDID_CR_edid_en((enable!=0)));
}

void lib_hdmiddc_set_sda_delay(unsigned char port, unsigned char delay_sel)
{
	unsigned int ddc_addr;

	if (port >= HDMI_PORT_TOTAL_NUM)
		return;

	ddc_addr = ddc_reg[port];
	hdmi_mask(ddc_addr+0x2C, ~ISO_MISC_DDC1_DDC_SCR_dataoutputdelay_sel_mask, ISO_MISC_DDC1_DDC_SCR_dataoutputdelay_sel(delay_sel));
}


unsigned char lib_hdmiddc_is_edid_valid(unsigned char* EDID)
{

	if((0x0 != EDID[0])||(0xff != EDID[1])||(0xff != EDID[6])||(0x0 != EDID[7]))
	{
		return FALSE;
	}

	return TRUE;

}

void lib_hdmiddc_sda2gpio(unsigned char port)
{
#ifndef ENABLE_FUNCTIONAL_TEST
        //MT board use GPIO, disable it for safe sake
	hdmi_mask(pinmux_reg[port], ~(pinmux_mask[port]), pinmux_mask[port]);
#endif
}

void lib_hdmiddc_gpio2sda(unsigned char port)
{
#ifndef ENABLE_FUNCTIONAL_TEST
        //MT board use GPIO, disable it for safe sake
	hdmi_mask(pinmux_reg[port], ~(pinmux_mask[port]), pinmux_gpo[port]);
#endif
}

void lib_hdmiddc_sda_dir_out(unsigned char port, unsigned char dir_o)
{
#ifndef ENABLE_FUNCTIONAL_TEST
	if (port >= HDMI_PORT_TOTAL_NUM)
		return;
	if (dir_o)
		rtd_outl(gpio_dir_reg[port],gpio_dir_bit[port]|_BIT0);
	else
		rtd_outl(gpio_dir_reg[port],gpio_dir_bit[port]);
#endif
}

