#ifndef _HDMI_QC_H_
#define _HDMI_QC_H_



//========= BOARD DEFINITION ======
#define PCB_LG_KXL			1

#if PCB_LG_KXL
#define PHY_Z0				0x12
#define MHL_CIRCUIT			0
#else
#define PHY_Z0				0xc
#define MHL_CIRCUIT			0
#endif


#if defined(Config_Package_type_BGA_27x27)
	#define PCB_HDMI_4K120		1 
	#define PCB_HDMI_4K60		0
#else
	#define PCB_HDMI_4K120		0 
	#define PCB_HDMI_4K60		1 
#endif


#if PCB_LG_KXL



#define HDMI_HOTPLUG0(x)  { rtd_outl(0xb8061104, _BIT3|_BIT0); \
							rtd_outl(0xb806110c, (_BIT3|((1-x) << 0))) ; }

#define HDMI_HOTPLUG1(x)	{}

#define HDMI_HOTPLUG2(x)	{}

#define HDMI_HOTPLUG3(x)	{}

#if 0
#define HDMI_HOTPLUG3(x)	{ rtd_maskl(0xB8061104, ~_BIT3, _BIT3); \
                                                                        rtd_maskl(0xB806110c, ~_BIT3, (1-x)<<3); }
#endif

#define SET_HDMIRX_HPD(port, high) {if (port == 0) {HDMI_HOTPLUG0(high);}}
		
#else
#error "Need to define HPD"
#endif



#if PCB_LG_KXL
#define HDMI_DDC0_en()	{ rtd_maskl(0xb8060218, 0xffff0f0f, 0x00005050); }//GPIO 29/30    
#define HDMI_DDC1_en()	{ rtd_maskl(0xb8060218, 0x0f0fffff, 0x50500000); }//GPIO 27/28
#define HDMI_DDC2_en()	{ rtd_maskl(0xb8060220, 0x0f0fffff, 0x50500000); }//GPIO 35/36 
#define HDMI_DDC3_en()	{ rtd_maskl(0xb806021c, 0x0f0fffff, 0x50500000); }//GPIO 31/32 
                                                
#else
#define HDMI_DDC0_en()
#define HDMI_DDC1_en()
#define HDMI_DDC2_en()
#define HDMI_DDC3_en()
#endif



//========= USER DEFINITION ======
#if CONFIG_FT
#define HDMI_PRINT_EN                               0
#else
#define HDMI_PRINT_EN                               1
#endif

#define MSR_HV				1	//measure h,v info
#define CRC_COUNT			(10)	// In general test every 100ms, crc check loop count.  (ex.10*60 = 1 mins)
#define LOOP_ERROR_BREAK		0	// Debug Use: Quit program if any error occurred
#define DISPLAY_EN			0
#define X_KEY_EXIT			1


#ifdef QC_VERIFIER
#define HDCP_EN_DELAY			1
#define QD980_TX_PATCH		1
#endif
//#define RDC_SINGLE_LANE


// ------------  HDMI ----------------
#define HDMI1_CHECK_CRC		1
#define HDMI2_CHECK_CRC		1
#ifdef CONFIG_RTD287O_B19_QC
#define HDMI3_CHECK_CRC		0
#else
#define HDMI3_CHECK_CRC		1
#endif
#define HDMI4_CHECK_CRC		1

#define QC_BIST_CHECK			1
#define HDMI_QCloop			1	//QC Test loop
#define HDMI_2P0_FORCE_6G		1
#define HDMI_2P0_SCDC_TIMEOUT		10	//QD980 needs long time to output SCDC/Video Data (44)



//==============================


//

#define RDC_TEST				0
#if RDC_TEST
#undef HDMI1_CHECK_CRC
#define HDMI1_CHECK_CRC			0
#undef HDMI2_CHECK_CRC
#define HDMI2_CHECK_CRC			0
#undef HDMI3_CHECK_CRC
#define HDMI3_CHECK_CRC			0
#undef HDMI4_CHECK_CRC
#define HDMI4_CHECK_CRC			1  // if check frl mode

//#define RDC_SINGLE_LANE


#undef QC_BIST_CHECK
#define QC_BIST_CHECK			0

#endif




#if 0

//HDCP
//#define ENABLE_HDMI_1_1_SUPPORT
#define HDCP_10_DVI		0x91
#define HDCP_11_HDMI		0x93

#define MHL_SUPPORT		CONFIG_QC_MHL

#endif


//for sync with demo code
//#define hdmi_mask			rtd_maskl
//#define hdmi_out				rtd_outl
//#define hdmi_in				rtd_inl

#define hdmi_in(addr)                       rtd_inl(addr)
#define hdmi_out(addr, value)               rtd_outl(addr, value)
#define hdmi_mask(addr, andmask, ormask)    rtd_maskl(addr, andmask, ormask)


#if HDMI_PRINT_EN
#define HDMI_EMG(fmt, args...)		printk("[HDMI] " fmt, ##args)
#define HDMI_PRINTF(fmt, args...)			printk("[HDMI] " fmt, ##args)
#define HDMI_INFO(fmt,args...)		printk("[HDMI] " fmt, ##args)
#define HDMI_SCDC_INFO(fmt,args...)		{}
#else
#define HDMI_PRINTF_EMG(fmt, args...)		{}
#define HDMI_PRINTF(fmt, args...)			{}
#define HDMI_EMG(fmt, args...)			{}
#define HDMI_INFO(fmt,args...)			{}
#define HDMI_SCDC_INFO(fmt,args...)		{}
#endif


#define _TRUE 				1
#define _FALSE				0
#define down(x)				{}
#define up(x)				{}
#define SET_MODE_IVTOTAL(x)		{}
#define SET_MODE_IHTOTAL(x)		{}
#define SET_MODE_IVHEIGHT(x)		{}
#define SET_MODE_IHWIDTH(x)		{}
#define SET_MODE_IVSTA(x)		{}
#define SET_MODE_IHSTA(x)		{}
#define SET_MODE_IVFREQ(x)		{}
#define SET_MODE_IHFREQ(x)		{}
#define SET_MODE_IVCOUNT(x)		{}
#define SET_MODE_IHCOUNT(x)		{}

#define SET_SCALER_POLARITY(x)			{}
#define SET_SCALER_IVTOTAL(x)			{}
#define SET_SCALER_IHTOTAL(x)			{}
#define SET_SCALER_IVHEIGHT(x)			{}
#define SET_SCALER_IVHEIGHT_PRE(x)		{}
#define SET_SCALER_IHWIDTH(x)			{}
#define SET_SCALER_IHWIDTH_PRE(x)		{}
#define SET_SCALER_IVSTA(x)			{}
#define SET_SCALER_IVSTA_PRE(x)		{}
#define SET_SCALER_IHSTA(x)			{}
#define SET_SCALER_IHSTA_PRE(x)		{}
#define SET_SCALER_IVFREQ(x)			{}
#define SET_SCALER_IHFREQ(x)			{}
#define SET_SCALER_IVCOUNT(x)			{}
#define SET_SCALER_IHCOUNT(x)			{}
#define SET_SCALER_ISINTERLACE(x)		{}
#define SET_SCALER_IS422(x)			{}
#define SET_SCALER_COLORSPACE(x)		{}
#define SET_SCALER_COLORDEPTH(x)		{}
#define SET_SCALER_COLORIMEYRY(x)		{}

#define SCALERDRV_WAIT_VS()		{}

#define msleep(x)			mdelay(x)
#define newbase_rxphy_isr_enable(on)		{}
#define newbase_hdmi_infoframe_thread_enable(on)	{}
#define newbase_hdmi_audio_thread_enable(on)		{}
#define _init_timing_detect_sem()	{}

#define _lock_timing_detect_sem()	{}
#define _init_info_pack_sem()	{}
//#define HDMI_SMPHR_INFOPKT_GET()	{}
#define _unlock_timing_detect_sem()  {}

#define _init_hpd_delay_wq(q_func)		{}
#define _start_hpd_delay_wq(delayms)		(-1)
#define _cancel_hpd_delay_wq()			{}
#define _destroy_hpd_delay_wq()			{}

#define rtk_gpio_set_dir(gpo,st) {}
#define rtk_gpio_output(gpo,st) {}
#define rtk_gpio_input(gpi) (-1)
#define Hdmi_Search_Mode(timing) (-1)

#define getHDMIRx_BroadInfo(x, yy)	0


enum _MODE_RESULT
{
	_MODE_NOSIGNAL	= 0xFF,
	_MODE_NOSUPPORT	= 0xFE,
	_MODE_NOCABLE		= 0xFD,
	_MODE_SUCCESS		= 0xFC,
	_MODE_DETECT		= 0xFB,
	_MDOE_UNDKOWN	= 0xFA,
};

enum _SCALER_DISP_CHANNEL{
        SLR_MAIN_DISPLAY = 0,
        SLR_SUB_DISPLAY
};

#ifndef _ENABLE
#define _ENABLE			1
#endif

#ifndef _DISABLE
#define _DISABLE			0
#endif


#define GETCHAR_x ('x' == rtd_inl(0x18062300)) //UART0


typedef struct {
	unsigned int val[2];
}QC_HDMI_CRC_ST;



extern void HdmiTable_Init(void);


#endif

