/******************************************************************************
*
*   Copyright(c) 2016 Realtek Semiconductor Corp. All rights reserved.
*
*   @author realtek.com
*
******************************************************************************/
#include <rbus_types.h>
#include <sys_reg_reg.h>
#include <io.h>
#include <common.h>
#include <drivers/md/rtk_md.h>
#include <drivers/md/rtk_md_test.h>

static int do_mdd(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
    rtk_md_init();
    rtk_md_unit_test();
    rtk_md_performance_test();
    return 0;
}

U_BOOT_CMD(
    callmd, 4,  1,  do_mdd,
    "md testcase",
    "md testcase"
);

static int do_md_ddr_test(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{
    uint32_t addr, size, value;

    rtk_md_init();

    if (argc == 4) {
        addr = simple_strtoul(argv[1], NULL, 16);
        size = simple_strtoul(argv[2], NULL, 16);
        value = simple_strtoul(argv[3], NULL, 16);
        printf("[MD] write addr=0x%08x, size=0x%08x, value = 0x%02x\n",
               addr, size, value & 0xff);
        smd_memfill(addr, size, value);

    }

    return 0;
}


U_BOOT_CMD(
    mddd,   4,  1,  do_md_ddr_test,
    "md write seq",
    "try : mdd address size value"
);


