/**
* @file Merlin6_DesignSpec_KeyTable
* RBus systemc program.
*
* @author RS_MM2_SD
* @email mm_mm2_rd_sw_kernel@realtek.com
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_NAG_KT_REG_H_
#define _RBUS_NAG_KT_REG_H_

#include "rbus_types.h"



//  NAG_KT Register Address
#define  NAG_KT_nag_ctrl                                                        0x1806C900
#define  NAG_KT_nag_ctrl_reg_addr                                                "0xB806C900"
#define  NAG_KT_nag_ctrl_reg                                                     0xB806C900
#define  NAG_KT_nag_ctrl_inst_addr                                               "0x0000"
#define  set_NAG_KT_nag_ctrl_reg(data)                                           (*((volatile unsigned int*)NAG_KT_nag_ctrl_reg)=data)
#define  get_NAG_KT_nag_ctrl_reg                                                 (*((volatile unsigned int*)NAG_KT_nag_ctrl_reg))
#define  NAG_KT_nag_ctrl_kt_init_shift                                           (5)
#define  NAG_KT_nag_ctrl_akl_init_shift                                          (2)
#define  NAG_KT_nag_ctrl_dsc_aeskp_init_shift                                    (1)
#define  NAG_KT_nag_ctrl_dsc_csa2kp_init_shift                                   (0)
#define  NAG_KT_nag_ctrl_kt_init_mask                                            (0x00000020)
#define  NAG_KT_nag_ctrl_akl_init_mask                                           (0x00000004)
#define  NAG_KT_nag_ctrl_dsc_aeskp_init_mask                                     (0x00000002)
#define  NAG_KT_nag_ctrl_dsc_csa2kp_init_mask                                    (0x00000001)
#define  NAG_KT_nag_ctrl_kt_init(data)                                           (0x00000020&((data)<<5))
#define  NAG_KT_nag_ctrl_akl_init(data)                                          (0x00000004&((data)<<2))
#define  NAG_KT_nag_ctrl_dsc_aeskp_init(data)                                    (0x00000002&((data)<<1))
#define  NAG_KT_nag_ctrl_dsc_csa2kp_init(data)                                   (0x00000001&(data))
#define  NAG_KT_nag_ctrl_get_kt_init(data)                                       ((0x00000020&(data))>>5)
#define  NAG_KT_nag_ctrl_get_akl_init(data)                                      ((0x00000004&(data))>>2)
#define  NAG_KT_nag_ctrl_get_dsc_aeskp_init(data)                                ((0x00000002&(data))>>1)
#define  NAG_KT_nag_ctrl_get_dsc_csa2kp_init(data)                               (0x00000001&(data))

#define  NAG_KT_dsc_stat                                                        0x1806C904
#define  NAG_KT_dsc_stat_reg_addr                                                "0xB806C904"
#define  NAG_KT_dsc_stat_reg                                                     0xB806C904
#define  NAG_KT_dsc_stat_inst_addr                                               "0x0001"
#define  set_NAG_KT_dsc_stat_reg(data)                                           (*((volatile unsigned int*)NAG_KT_dsc_stat_reg)=data)
#define  get_NAG_KT_dsc_stat_reg                                                 (*((volatile unsigned int*)NAG_KT_dsc_stat_reg))
#define  NAG_KT_dsc_stat_dsc_status_shift                                        (0)
#define  NAG_KT_dsc_stat_dsc_status_mask                                         (0xFFFFFFFF)
#define  NAG_KT_dsc_stat_dsc_status(data)                                        (0xFFFFFFFF&(data))
#define  NAG_KT_dsc_stat_get_dsc_status(data)                                    (0xFFFFFFFF&(data))

#define  NAG_KT_otp_stat                                                        0x1806C908
#define  NAG_KT_otp_stat_reg_addr                                                "0xB806C908"
#define  NAG_KT_otp_stat_reg                                                     0xB806C908
#define  NAG_KT_otp_stat_inst_addr                                               "0x0002"
#define  set_NAG_KT_otp_stat_reg(data)                                           (*((volatile unsigned int*)NAG_KT_otp_stat_reg)=data)
#define  get_NAG_KT_otp_stat_reg                                                 (*((volatile unsigned int*)NAG_KT_otp_stat_reg))
#define  NAG_KT_otp_stat_otp_status_shift                                        (0)
#define  NAG_KT_otp_stat_otp_status_mask                                         (0x00000003)
#define  NAG_KT_otp_stat_otp_status(data)                                        (0x00000003&(data))
#define  NAG_KT_otp_stat_get_otp_status(data)                                    (0x00000003&(data))

#define  NAG_KT_akl_int                                                         0x1806C90C
#define  NAG_KT_akl_int_reg_addr                                                 "0xB806C90C"
#define  NAG_KT_akl_int_reg                                                      0xB806C90C
#define  NAG_KT_akl_int_inst_addr                                                "0x0003"
#define  set_NAG_KT_akl_int_reg(data)                                            (*((volatile unsigned int*)NAG_KT_akl_int_reg)=data)
#define  get_NAG_KT_akl_int_reg                                                  (*((volatile unsigned int*)NAG_KT_akl_int_reg))
#define  NAG_KT_akl_int_akl_interrupt_shift                                      (0)
#define  NAG_KT_akl_int_akl_interrupt_mask                                       (0x00000001)
#define  NAG_KT_akl_int_akl_interrupt(data)                                      (0x00000001&(data))
#define  NAG_KT_akl_int_get_akl_interrupt(data)                                  (0x00000001&(data))

#define  NAG_KT_clk_det                                                         0x1806C910
#define  NAG_KT_clk_det_reg_addr                                                 "0xB806C910"
#define  NAG_KT_clk_det_reg                                                      0xB806C910
#define  NAG_KT_clk_det_inst_addr                                                "0x0004"
#define  set_NAG_KT_clk_det_reg(data)                                            (*((volatile unsigned int*)NAG_KT_clk_det_reg)=data)
#define  get_NAG_KT_clk_det_reg                                                  (*((volatile unsigned int*)NAG_KT_clk_det_reg))
#define  NAG_KT_clk_det_abnormal_clk_detected_shift                              (21)
#define  NAG_KT_clk_det_akl_clk_det_checking_shift                               (20)
#define  NAG_KT_clk_det_down_limit_shift                                         (12)
#define  NAG_KT_clk_det_up_limit_shift                                           (4)
#define  NAG_KT_clk_det_akl_clk_det_en_shift                                     (0)
#define  NAG_KT_clk_det_abnormal_clk_detected_mask                               (0x00200000)
#define  NAG_KT_clk_det_akl_clk_det_checking_mask                                (0x00100000)
#define  NAG_KT_clk_det_down_limit_mask                                          (0x000FF000)
#define  NAG_KT_clk_det_up_limit_mask                                            (0x00000FF0)
#define  NAG_KT_clk_det_akl_clk_det_en_mask                                      (0x00000001)
#define  NAG_KT_clk_det_abnormal_clk_detected(data)                              (0x00200000&((data)<<21))
#define  NAG_KT_clk_det_akl_clk_det_checking(data)                               (0x00100000&((data)<<20))
#define  NAG_KT_clk_det_down_limit(data)                                         (0x000FF000&((data)<<12))
#define  NAG_KT_clk_det_up_limit(data)                                           (0x00000FF0&((data)<<4))
#define  NAG_KT_clk_det_akl_clk_det_en(data)                                     (0x00000001&(data))
#define  NAG_KT_clk_det_get_abnormal_clk_detected(data)                          ((0x00200000&(data))>>21)
#define  NAG_KT_clk_det_get_akl_clk_det_checking(data)                           ((0x00100000&(data))>>20)
#define  NAG_KT_clk_det_get_down_limit(data)                                     ((0x000FF000&(data))>>12)
#define  NAG_KT_clk_det_get_up_limit(data)                                       ((0x00000FF0&(data))>>4)
#define  NAG_KT_clk_det_get_akl_clk_det_en(data)                                 (0x00000001&(data))

#define  NAG_KT_kt_wr_akl                                                       0x1806C920
#define  NAG_KT_kt_wr_akl_reg_addr                                               "0xB806C920"
#define  NAG_KT_kt_wr_akl_reg                                                    0xB806C920
#define  NAG_KT_kt_wr_akl_inst_addr                                              "0x0005"
#define  set_NAG_KT_kt_wr_akl_reg(data)                                          (*((volatile unsigned int*)NAG_KT_kt_wr_akl_reg)=data)
#define  get_NAG_KT_kt_wr_akl_reg                                                (*((volatile unsigned int*)NAG_KT_kt_wr_akl_reg))
#define  NAG_KT_kt_wr_akl_akl_wt_err_shift                                       (28)
#define  NAG_KT_kt_wr_akl_dummy_27_6_shift                                       (6)
#define  NAG_KT_kt_wr_akl_akl_key_attr_shift                                     (4)
#define  NAG_KT_kt_wr_akl_akl_wt_en_shift                                        (0)
#define  NAG_KT_kt_wr_akl_akl_wt_err_mask                                        (0xF0000000)
#define  NAG_KT_kt_wr_akl_dummy_27_6_mask                                        (0x0FFFFFC0)
#define  NAG_KT_kt_wr_akl_akl_key_attr_mask                                      (0x00000030)
#define  NAG_KT_kt_wr_akl_akl_wt_en_mask                                         (0x00000003)
#define  NAG_KT_kt_wr_akl_akl_wt_err(data)                                       (0xF0000000&((data)<<28))
#define  NAG_KT_kt_wr_akl_dummy_27_6(data)                                       (0x0FFFFFC0&((data)<<6))
#define  NAG_KT_kt_wr_akl_akl_key_attr(data)                                     (0x00000030&((data)<<4))
#define  NAG_KT_kt_wr_akl_akl_wt_en(data)                                        (0x00000003&(data))
#define  NAG_KT_kt_wr_akl_get_akl_wt_err(data)                                   ((0xF0000000&(data))>>28)
#define  NAG_KT_kt_wr_akl_get_dummy_27_6(data)                                   ((0x0FFFFFC0&(data))>>6)
#define  NAG_KT_kt_wr_akl_get_akl_key_attr(data)                                 ((0x00000030&(data))>>4)
#define  NAG_KT_kt_wr_akl_get_akl_wt_en(data)                                    (0x00000003&(data))

#define  NAG_KT_kt_wr_uris_0                                                    0x1806C928
#define  NAG_KT_kt_wr_uris_0_reg_addr                                            "0xB806C928"
#define  NAG_KT_kt_wr_uris_0_reg                                                 0xB806C928
#define  NAG_KT_kt_wr_uris_0_inst_addr                                           "0x0006"
#define  set_NAG_KT_kt_wr_uris_0_reg(data)                                       (*((volatile unsigned int*)NAG_KT_kt_wr_uris_0_reg)=data)
#define  get_NAG_KT_kt_wr_uris_0_reg                                             (*((volatile unsigned int*)NAG_KT_kt_wr_uris_0_reg))
#define  NAG_KT_kt_wr_uris_0_akl_smp_uris_31_0_shift                             (0)
#define  NAG_KT_kt_wr_uris_0_akl_smp_uris_31_0_mask                              (0xFFFFFFFF)
#define  NAG_KT_kt_wr_uris_0_akl_smp_uris_31_0(data)                             (0xFFFFFFFF&(data))
#define  NAG_KT_kt_wr_uris_0_get_akl_smp_uris_31_0(data)                         (0xFFFFFFFF&(data))

#define  NAG_KT_kt_wr_uris_1                                                    0x1806C92C
#define  NAG_KT_kt_wr_uris_1_reg_addr                                            "0xB806C92C"
#define  NAG_KT_kt_wr_uris_1_reg                                                 0xB806C92C
#define  NAG_KT_kt_wr_uris_1_inst_addr                                           "0x0007"
#define  set_NAG_KT_kt_wr_uris_1_reg(data)                                       (*((volatile unsigned int*)NAG_KT_kt_wr_uris_1_reg)=data)
#define  get_NAG_KT_kt_wr_uris_1_reg                                             (*((volatile unsigned int*)NAG_KT_kt_wr_uris_1_reg))
#define  NAG_KT_kt_wr_uris_1_akl_smp_uris_55_32_shift                            (0)
#define  NAG_KT_kt_wr_uris_1_akl_smp_uris_55_32_mask                             (0x00FFFFFF)
#define  NAG_KT_kt_wr_uris_1_akl_smp_uris_55_32(data)                            (0x00FFFFFF&(data))
#define  NAG_KT_kt_wr_uris_1_get_akl_smp_uris_55_32(data)                        (0x00FFFFFF&(data))

#define  NAG_KT_kt_wr_hkey                                                      0x1806C130
#define  NAG_KT_kt_wr_hkey_reg_addr                                              "0xB806C130"
#define  NAG_KT_kt_wr_hkey_reg                                                   0xB806C130
#define  NAG_KT_kt_wr_hkey_inst_addr                                             "0x0008"
#define  set_NAG_KT_kt_wr_hkey_reg(data)                                         (*((volatile unsigned int*)NAG_KT_kt_wr_hkey_reg)=data)
#define  get_NAG_KT_kt_wr_hkey_reg                                               (*((volatile unsigned int*)NAG_KT_kt_wr_hkey_reg))
#define  NAG_KT_kt_wr_hkey_hkey_wt_en_shift                                      (0)
#define  NAG_KT_kt_wr_hkey_hkey_wt_en_mask                                       (0x00000001)
#define  NAG_KT_kt_wr_hkey_hkey_wt_en(data)                                      (0x00000001&(data))
#define  NAG_KT_kt_wr_hkey_get_hkey_wt_en(data)                                  (0x00000001&(data))

#define  NAG_KT_kt_wr_iv                                                        0x1806C134
#define  NAG_KT_kt_wr_iv_reg_addr                                                "0xB806C134"
#define  NAG_KT_kt_wr_iv_reg                                                     0xB806C134
#define  NAG_KT_kt_wr_iv_inst_addr                                               "0x0009"
#define  set_NAG_KT_kt_wr_iv_reg(data)                                           (*((volatile unsigned int*)NAG_KT_kt_wr_iv_reg)=data)
#define  get_NAG_KT_kt_wr_iv_reg                                                 (*((volatile unsigned int*)NAG_KT_kt_wr_iv_reg))
#define  NAG_KT_kt_wr_iv_iv_hw_upt_en_shift                                      (4)
#define  NAG_KT_kt_wr_iv_iv_wt_en_shift                                          (0)
#define  NAG_KT_kt_wr_iv_iv_hw_upt_en_mask                                       (0x00000010)
#define  NAG_KT_kt_wr_iv_iv_wt_en_mask                                           (0x00000001)
#define  NAG_KT_kt_wr_iv_iv_hw_upt_en(data)                                      (0x00000010&((data)<<4))
#define  NAG_KT_kt_wr_iv_iv_wt_en(data)                                          (0x00000001&(data))
#define  NAG_KT_kt_wr_iv_get_iv_hw_upt_en(data)                                  ((0x00000010&(data))>>4)
#define  NAG_KT_kt_wr_iv_get_iv_wt_en(data)                                      (0x00000001&(data))

#define  NAG_KT_kt_wr_addr                                                      0x1806C138
#define  NAG_KT_kt_wr_addr_reg_addr                                              "0xB806C138"
#define  NAG_KT_kt_wr_addr_reg                                                   0xB806C138
#define  NAG_KT_kt_wr_addr_inst_addr                                             "0x000A"
#define  set_NAG_KT_kt_wr_addr_reg(data)                                         (*((volatile unsigned int*)NAG_KT_kt_wr_addr_reg)=data)
#define  get_NAG_KT_kt_wr_addr_reg                                               (*((volatile unsigned int*)NAG_KT_kt_wr_addr_reg))
#define  NAG_KT_kt_wr_addr_wt_addr_to_sram_2_shift                               (8)
#define  NAG_KT_kt_wr_addr_wt_addr_to_sram_shift                                 (0)
#define  NAG_KT_kt_wr_addr_wt_addr_to_sram_2_mask                                (0x00007F00)
#define  NAG_KT_kt_wr_addr_wt_addr_to_sram_mask                                  (0x0000007F)
#define  NAG_KT_kt_wr_addr_wt_addr_to_sram_2(data)                               (0x00007F00&((data)<<8))
#define  NAG_KT_kt_wr_addr_wt_addr_to_sram(data)                                 (0x0000007F&(data))
#define  NAG_KT_kt_wr_addr_get_wt_addr_to_sram_2(data)                           ((0x00007F00&(data))>>8)
#define  NAG_KT_kt_wr_addr_get_wt_addr_to_sram(data)                             (0x0000007F&(data))

#define  NAG_KT_kt_wr_hkey_kc                                                   0x1806C93C
#define  NAG_KT_kt_wr_hkey_kc_reg_addr                                           "0xB806C93C"
#define  NAG_KT_kt_wr_hkey_kc_reg                                                0xB806C93C
#define  NAG_KT_kt_wr_hkey_kc_inst_addr                                          "0x000B"
#define  set_NAG_KT_kt_wr_hkey_kc_reg(data)                                      (*((volatile unsigned int*)NAG_KT_kt_wr_hkey_kc_reg)=data)
#define  get_NAG_KT_kt_wr_hkey_kc_reg                                            (*((volatile unsigned int*)NAG_KT_kt_wr_hkey_kc_reg))
#define  NAG_KT_kt_wr_hkey_kc_hkey_attr_shift                                    (4)
#define  NAG_KT_kt_wr_hkey_kc_hkey_wt_en_kc_shift                                (0)
#define  NAG_KT_kt_wr_hkey_kc_hkey_attr_mask                                     (0x00000030)
#define  NAG_KT_kt_wr_hkey_kc_hkey_wt_en_kc_mask                                 (0x00000001)
#define  NAG_KT_kt_wr_hkey_kc_hkey_attr(data)                                    (0x00000030&((data)<<4))
#define  NAG_KT_kt_wr_hkey_kc_hkey_wt_en_kc(data)                                (0x00000001&(data))
#define  NAG_KT_kt_wr_hkey_kc_get_hkey_attr(data)                                ((0x00000030&(data))>>4)
#define  NAG_KT_kt_wr_hkey_kc_get_hkey_wt_en_kc(data)                            (0x00000001&(data))

#define  NAG_KT_kt_host_ctrl                                                    0x1806C140
#define  NAG_KT_kt_host_ctrl_reg_addr                                            "0xB806C140"
#define  NAG_KT_kt_host_ctrl_reg                                                 0xB806C140
#define  NAG_KT_kt_host_ctrl_inst_addr                                           "0x000C"
#define  set_NAG_KT_kt_host_ctrl_reg(data)                                       (*((volatile unsigned int*)NAG_KT_kt_host_ctrl_reg)=data)
#define  get_NAG_KT_kt_host_ctrl_reg                                             (*((volatile unsigned int*)NAG_KT_kt_host_ctrl_reg))
#define  NAG_KT_kt_host_ctrl_dummy_31_8_shift                                    (8)
#define  NAG_KT_kt_host_ctrl_hkey_decrypt_en_shift                               (5)
#define  NAG_KT_kt_host_ctrl_hkey_encrypt_en_shift                               (4)
#define  NAG_KT_kt_host_ctrl_hkey_algorithm_shift                                (0)
#define  NAG_KT_kt_host_ctrl_dummy_31_8_mask                                     (0xFFFFFF00)
#define  NAG_KT_kt_host_ctrl_hkey_decrypt_en_mask                                (0x00000020)
#define  NAG_KT_kt_host_ctrl_hkey_encrypt_en_mask                                (0x00000010)
#define  NAG_KT_kt_host_ctrl_hkey_algorithm_mask                                 (0x00000001)
#define  NAG_KT_kt_host_ctrl_dummy_31_8(data)                                    (0xFFFFFF00&((data)<<8))
#define  NAG_KT_kt_host_ctrl_hkey_decrypt_en(data)                               (0x00000020&((data)<<5))
#define  NAG_KT_kt_host_ctrl_hkey_encrypt_en(data)                               (0x00000010&((data)<<4))
#define  NAG_KT_kt_host_ctrl_hkey_algorithm(data)                                (0x00000001&(data))
#define  NAG_KT_kt_host_ctrl_get_dummy_31_8(data)                                ((0xFFFFFF00&(data))>>8)
#define  NAG_KT_kt_host_ctrl_get_hkey_decrypt_en(data)                           ((0x00000020&(data))>>5)
#define  NAG_KT_kt_host_ctrl_get_hkey_encrypt_en(data)                           ((0x00000010&(data))>>4)
#define  NAG_KT_kt_host_ctrl_get_hkey_algorithm(data)                            (0x00000001&(data))

#define  NAG_KT_kt_host_0                                                       0x1806C150
#define  NAG_KT_kt_host_0_reg_addr                                               "0xB806C150"
#define  NAG_KT_kt_host_0_reg                                                    0xB806C150
#define  NAG_KT_kt_host_0_inst_addr                                              "0x000D"
#define  set_NAG_KT_kt_host_0_reg(data)                                          (*((volatile unsigned int*)NAG_KT_kt_host_0_reg)=data)
#define  get_NAG_KT_kt_host_0_reg                                                (*((volatile unsigned int*)NAG_KT_kt_host_0_reg))
#define  NAG_KT_kt_host_0_hkey_iv_31_0_shift                                     (0)
#define  NAG_KT_kt_host_0_hkey_iv_31_0_mask                                      (0xFFFFFFFF)
#define  NAG_KT_kt_host_0_hkey_iv_31_0(data)                                     (0xFFFFFFFF&(data))
#define  NAG_KT_kt_host_0_get_hkey_iv_31_0(data)                                 (0xFFFFFFFF&(data))

#define  NAG_KT_kt_host_1                                                       0x1806C154
#define  NAG_KT_kt_host_1_reg_addr                                               "0xB806C154"
#define  NAG_KT_kt_host_1_reg                                                    0xB806C154
#define  NAG_KT_kt_host_1_inst_addr                                              "0x000E"
#define  set_NAG_KT_kt_host_1_reg(data)                                          (*((volatile unsigned int*)NAG_KT_kt_host_1_reg)=data)
#define  get_NAG_KT_kt_host_1_reg                                                (*((volatile unsigned int*)NAG_KT_kt_host_1_reg))
#define  NAG_KT_kt_host_1_hkey_iv_63_32_shift                                    (0)
#define  NAG_KT_kt_host_1_hkey_iv_63_32_mask                                     (0xFFFFFFFF)
#define  NAG_KT_kt_host_1_hkey_iv_63_32(data)                                    (0xFFFFFFFF&(data))
#define  NAG_KT_kt_host_1_get_hkey_iv_63_32(data)                                (0xFFFFFFFF&(data))

#define  NAG_KT_kt_host_2                                                       0x1806C158
#define  NAG_KT_kt_host_2_reg_addr                                               "0xB806C158"
#define  NAG_KT_kt_host_2_reg                                                    0xB806C158
#define  NAG_KT_kt_host_2_inst_addr                                              "0x000F"
#define  set_NAG_KT_kt_host_2_reg(data)                                          (*((volatile unsigned int*)NAG_KT_kt_host_2_reg)=data)
#define  get_NAG_KT_kt_host_2_reg                                                (*((volatile unsigned int*)NAG_KT_kt_host_2_reg))
#define  NAG_KT_kt_host_2_hkey_iv_95_64_shift                                    (0)
#define  NAG_KT_kt_host_2_hkey_iv_95_64_mask                                     (0xFFFFFFFF)
#define  NAG_KT_kt_host_2_hkey_iv_95_64(data)                                    (0xFFFFFFFF&(data))
#define  NAG_KT_kt_host_2_get_hkey_iv_95_64(data)                                (0xFFFFFFFF&(data))

#define  NAG_KT_kt_host_3                                                       0x1806C15C
#define  NAG_KT_kt_host_3_reg_addr                                               "0xB806C15C"
#define  NAG_KT_kt_host_3_reg                                                    0xB806C15C
#define  NAG_KT_kt_host_3_inst_addr                                              "0x0010"
#define  set_NAG_KT_kt_host_3_reg(data)                                          (*((volatile unsigned int*)NAG_KT_kt_host_3_reg)=data)
#define  get_NAG_KT_kt_host_3_reg                                                (*((volatile unsigned int*)NAG_KT_kt_host_3_reg))
#define  NAG_KT_kt_host_3_hkey_iv_127_96_shift                                   (0)
#define  NAG_KT_kt_host_3_hkey_iv_127_96_mask                                    (0xFFFFFFFF)
#define  NAG_KT_kt_host_3_hkey_iv_127_96(data)                                   (0xFFFFFFFF&(data))
#define  NAG_KT_kt_host_3_get_hkey_iv_127_96(data)                               (0xFFFFFFFF&(data))

#define  NAG_KT_iv_upt_idx                                                      0x1806C160
#define  NAG_KT_iv_upt_idx_reg_addr                                              "0xB806C160"
#define  NAG_KT_iv_upt_idx_reg                                                   0xB806C160
#define  NAG_KT_iv_upt_idx_inst_addr                                             "0x0011"
#define  set_NAG_KT_iv_upt_idx_reg(data)                                         (*((volatile unsigned int*)NAG_KT_iv_upt_idx_reg)=data)
#define  get_NAG_KT_iv_upt_idx_reg                                               (*((volatile unsigned int*)NAG_KT_iv_upt_idx_reg))
#define  NAG_KT_iv_upt_idx_iv_upt_index_shift                                    (0)
#define  NAG_KT_iv_upt_idx_iv_upt_index_mask                                     (0x0000007F)
#define  NAG_KT_iv_upt_idx_iv_upt_index(data)                                    (0x0000007F&(data))
#define  NAG_KT_iv_upt_idx_get_iv_upt_index(data)                                (0x0000007F&(data))

#define  NAG_KT_iv_upt_0                                                        0x1806C170
#define  NAG_KT_iv_upt_0_reg_addr                                                "0xB806C170"
#define  NAG_KT_iv_upt_0_reg                                                     0xB806C170
#define  NAG_KT_iv_upt_0_inst_addr                                               "0x0012"
#define  set_NAG_KT_iv_upt_0_reg(data)                                           (*((volatile unsigned int*)NAG_KT_iv_upt_0_reg)=data)
#define  get_NAG_KT_iv_upt_0_reg                                                 (*((volatile unsigned int*)NAG_KT_iv_upt_0_reg))
#define  NAG_KT_iv_upt_0_iv_nxt_31_0_shift                                       (0)
#define  NAG_KT_iv_upt_0_iv_nxt_31_0_mask                                        (0xFFFFFFFF)
#define  NAG_KT_iv_upt_0_iv_nxt_31_0(data)                                       (0xFFFFFFFF&(data))
#define  NAG_KT_iv_upt_0_get_iv_nxt_31_0(data)                                   (0xFFFFFFFF&(data))

#define  NAG_KT_iv_upt_1                                                        0x1806C174
#define  NAG_KT_iv_upt_1_reg_addr                                                "0xB806C174"
#define  NAG_KT_iv_upt_1_reg                                                     0xB806C174
#define  NAG_KT_iv_upt_1_inst_addr                                               "0x0013"
#define  set_NAG_KT_iv_upt_1_reg(data)                                           (*((volatile unsigned int*)NAG_KT_iv_upt_1_reg)=data)
#define  get_NAG_KT_iv_upt_1_reg                                                 (*((volatile unsigned int*)NAG_KT_iv_upt_1_reg))
#define  NAG_KT_iv_upt_1_iv_nxt_63_32_shift                                      (0)
#define  NAG_KT_iv_upt_1_iv_nxt_63_32_mask                                       (0xFFFFFFFF)
#define  NAG_KT_iv_upt_1_iv_nxt_63_32(data)                                      (0xFFFFFFFF&(data))
#define  NAG_KT_iv_upt_1_get_iv_nxt_63_32(data)                                  (0xFFFFFFFF&(data))

#define  NAG_KT_iv_upt_2                                                        0x1806C178
#define  NAG_KT_iv_upt_2_reg_addr                                                "0xB806C178"
#define  NAG_KT_iv_upt_2_reg                                                     0xB806C178
#define  NAG_KT_iv_upt_2_inst_addr                                               "0x0014"
#define  set_NAG_KT_iv_upt_2_reg(data)                                           (*((volatile unsigned int*)NAG_KT_iv_upt_2_reg)=data)
#define  get_NAG_KT_iv_upt_2_reg                                                 (*((volatile unsigned int*)NAG_KT_iv_upt_2_reg))
#define  NAG_KT_iv_upt_2_iv_nxt_95_64_shift                                      (0)
#define  NAG_KT_iv_upt_2_iv_nxt_95_64_mask                                       (0xFFFFFFFF)
#define  NAG_KT_iv_upt_2_iv_nxt_95_64(data)                                      (0xFFFFFFFF&(data))
#define  NAG_KT_iv_upt_2_get_iv_nxt_95_64(data)                                  (0xFFFFFFFF&(data))

#define  NAG_KT_iv_upt_3                                                        0x1806C17C
#define  NAG_KT_iv_upt_3_reg_addr                                                "0xB806C17C"
#define  NAG_KT_iv_upt_3_reg                                                     0xB806C17C
#define  NAG_KT_iv_upt_3_inst_addr                                               "0x0015"
#define  set_NAG_KT_iv_upt_3_reg(data)                                           (*((volatile unsigned int*)NAG_KT_iv_upt_3_reg)=data)
#define  get_NAG_KT_iv_upt_3_reg                                                 (*((volatile unsigned int*)NAG_KT_iv_upt_3_reg))
#define  NAG_KT_iv_upt_3_iv_nxt_127_96_shift                                     (0)
#define  NAG_KT_iv_upt_3_iv_nxt_127_96_mask                                      (0xFFFFFFFF)
#define  NAG_KT_iv_upt_3_iv_nxt_127_96(data)                                     (0xFFFFFFFF&(data))
#define  NAG_KT_iv_upt_3_get_iv_nxt_127_96(data)                                 (0xFFFFFFFF&(data))

#define  NAG_KT_kt_cp                                                           0x1806C180
#define  NAG_KT_kt_cp_reg_addr                                                   "0xB806C180"
#define  NAG_KT_kt_cp_reg                                                        0xB806C180
#define  NAG_KT_kt_cp_inst_addr                                                  "0x0016"
#define  set_NAG_KT_kt_cp_reg(data)                                              (*((volatile unsigned int*)NAG_KT_kt_cp_reg)=data)
#define  get_NAG_KT_kt_cp_reg                                                    (*((volatile unsigned int*)NAG_KT_kt_cp_reg))
#define  NAG_KT_kt_cp_copy_en_shift                                              (16)
#define  NAG_KT_kt_cp_to_addr_shift                                              (8)
#define  NAG_KT_kt_cp_from_addr_shift                                            (0)
#define  NAG_KT_kt_cp_copy_en_mask                                               (0x00010000)
#define  NAG_KT_kt_cp_to_addr_mask                                               (0x00007F00)
#define  NAG_KT_kt_cp_from_addr_mask                                             (0x0000007F)
#define  NAG_KT_kt_cp_copy_en(data)                                              (0x00010000&((data)<<16))
#define  NAG_KT_kt_cp_to_addr(data)                                              (0x00007F00&((data)<<8))
#define  NAG_KT_kt_cp_from_addr(data)                                            (0x0000007F&(data))
#define  NAG_KT_kt_cp_get_copy_en(data)                                          ((0x00010000&(data))>>16)
#define  NAG_KT_kt_cp_get_to_addr(data)                                          ((0x00007F00&(data))>>8)
#define  NAG_KT_kt_cp_get_from_addr(data)                                        (0x0000007F&(data))

#define  NAG_KT_kt_index_status                                                 0x1806C190
#define  NAG_KT_kt_index_status_reg_addr                                         "0xB806C190"
#define  NAG_KT_kt_index_status_reg                                              0xB806C190
#define  NAG_KT_kt_index_status_inst_addr                                        "0x0017"
#define  set_NAG_KT_kt_index_status_reg(data)                                    (*((volatile unsigned int*)NAG_KT_kt_index_status_reg)=data)
#define  get_NAG_KT_kt_index_status_reg                                          (*((volatile unsigned int*)NAG_KT_kt_index_status_reg))
#define  NAG_KT_kt_index_status_kt_status_iv_upt_shift                           (13)
#define  NAG_KT_kt_index_status_kt_status_busy_shift                             (12)
#define  NAG_KT_kt_index_status_kt_status_sel_shift                              (4)
#define  NAG_KT_kt_index_status_key_table_idle_shift                             (0)
#define  NAG_KT_kt_index_status_kt_status_iv_upt_mask                            (0x00002000)
#define  NAG_KT_kt_index_status_kt_status_busy_mask                              (0x00001000)
#define  NAG_KT_kt_index_status_kt_status_sel_mask                               (0x000007F0)
#define  NAG_KT_kt_index_status_key_table_idle_mask                              (0x00000001)
#define  NAG_KT_kt_index_status_kt_status_iv_upt(data)                           (0x00002000&((data)<<13))
#define  NAG_KT_kt_index_status_kt_status_busy(data)                             (0x00001000&((data)<<12))
#define  NAG_KT_kt_index_status_kt_status_sel(data)                              (0x000007F0&((data)<<4))
#define  NAG_KT_kt_index_status_key_table_idle(data)                             (0x00000001&(data))
#define  NAG_KT_kt_index_status_get_kt_status_iv_upt(data)                       ((0x00002000&(data))>>13)
#define  NAG_KT_kt_index_status_get_kt_status_busy(data)                         ((0x00001000&(data))>>12)
#define  NAG_KT_kt_index_status_get_kt_status_sel(data)                          ((0x000007F0&(data))>>4)
#define  NAG_KT_kt_index_status_get_key_table_idle(data)                         (0x00000001&(data))

#define  NAG_KT_key_chk_status                                                  0x1806C1A0
#define  NAG_KT_key_chk_status_reg_addr                                          "0xB806C1A0"
#define  NAG_KT_key_chk_status_reg                                               0xB806C1A0
#define  NAG_KT_key_chk_status_inst_addr                                         "0x0018"
#define  set_NAG_KT_key_chk_status_reg(data)                                     (*((volatile unsigned int*)NAG_KT_key_chk_status_reg)=data)
#define  get_NAG_KT_key_chk_status_reg                                           (*((volatile unsigned int*)NAG_KT_key_chk_status_reg))
#define  NAG_KT_key_chk_status_key_chk_status_m2m_shift                          (12)
#define  NAG_KT_key_chk_status_key_chk_status_tp_shift                           (4)
#define  NAG_KT_key_chk_status_key_error_int_en_shift                            (1)
#define  NAG_KT_key_chk_status_key_error_shift                                   (0)
#define  NAG_KT_key_chk_status_key_chk_status_m2m_mask                           (0x0001F000)
#define  NAG_KT_key_chk_status_key_chk_status_tp_mask                            (0x000001F0)
#define  NAG_KT_key_chk_status_key_error_int_en_mask                             (0x00000002)
#define  NAG_KT_key_chk_status_key_error_mask                                    (0x00000001)
#define  NAG_KT_key_chk_status_key_chk_status_m2m(data)                          (0x0001F000&((data)<<12))
#define  NAG_KT_key_chk_status_key_chk_status_tp(data)                           (0x000001F0&((data)<<4))
#define  NAG_KT_key_chk_status_key_error_int_en(data)                            (0x00000002&((data)<<1))
#define  NAG_KT_key_chk_status_key_error(data)                                   (0x00000001&(data))
#define  NAG_KT_key_chk_status_get_key_chk_status_m2m(data)                      ((0x0001F000&(data))>>12)
#define  NAG_KT_key_chk_status_get_key_chk_status_tp(data)                       ((0x000001F0&(data))>>4)
#define  NAG_KT_key_chk_status_get_key_error_int_en(data)                        ((0x00000002&(data))>>1)
#define  NAG_KT_key_chk_status_get_key_error(data)                               (0x00000001&(data))

#define  NAG_KT_dma_ctrl_kc                                                     0x1806CA00
#define  NAG_KT_dma_ctrl_kc_reg_addr                                             "0xB806CA00"
#define  NAG_KT_dma_ctrl_kc_reg                                                  0xB806CA00
#define  NAG_KT_dma_ctrl_kc_inst_addr                                            "0x0019"
#define  set_NAG_KT_dma_ctrl_kc_reg(data)                                        (*((volatile unsigned int*)NAG_KT_dma_ctrl_kc_reg)=data)
#define  get_NAG_KT_dma_ctrl_kc_reg                                              (*((volatile unsigned int*)NAG_KT_dma_ctrl_kc_reg))
#define  NAG_KT_dma_ctrl_kc_m2m_busy_kc_shift                                    (4)
#define  NAG_KT_dma_ctrl_kc_m2m_go_kc_shift                                      (0)
#define  NAG_KT_dma_ctrl_kc_m2m_busy_kc_mask                                     (0x00000010)
#define  NAG_KT_dma_ctrl_kc_m2m_go_kc_mask                                       (0x00000001)
#define  NAG_KT_dma_ctrl_kc_m2m_busy_kc(data)                                    (0x00000010&((data)<<4))
#define  NAG_KT_dma_ctrl_kc_m2m_go_kc(data)                                      (0x00000001&(data))
#define  NAG_KT_dma_ctrl_kc_get_m2m_busy_kc(data)                                ((0x00000010&(data))>>4)
#define  NAG_KT_dma_ctrl_kc_get_m2m_go_kc(data)                                  (0x00000001&(data))

#define  NAG_KT_dma_set_kc                                                      0x1806CA04
#define  NAG_KT_dma_set_kc_reg_addr                                              "0xB806CA04"
#define  NAG_KT_dma_set_kc_reg                                                   0xB806CA04
#define  NAG_KT_dma_set_kc_inst_addr                                             "0x001A"
#define  set_NAG_KT_dma_set_kc_reg(data)                                         (*((volatile unsigned int*)NAG_KT_dma_set_kc_reg)=data)
#define  get_NAG_KT_dma_set_kc_reg                                               (*((volatile unsigned int*)NAG_KT_dma_set_kc_reg))
#define  NAG_KT_dma_set_kc_m2m_key_index_kc_shift                                (24)
#define  NAG_KT_dma_set_kc_m2m_aes_mode_kc_shift                                 (20)
#define  NAG_KT_dma_set_kc_m2m_encrypt_en_kc_shift                               (16)
#define  NAG_KT_dma_set_kc_m2m_key_len_kc_shift                                  (12)
#define  NAG_KT_dma_set_kc_m2m_algorithm_kc_shift                                (8)
#define  NAG_KT_dma_set_kc_m2m_wr_region_kc_shift                                (4)
#define  NAG_KT_dma_set_kc_m2m_rd_region_kc_shift                                (0)
#define  NAG_KT_dma_set_kc_m2m_key_index_kc_mask                                 (0x7F000000)
#define  NAG_KT_dma_set_kc_m2m_aes_mode_kc_mask                                  (0x00F00000)
#define  NAG_KT_dma_set_kc_m2m_encrypt_en_kc_mask                                (0x00010000)
#define  NAG_KT_dma_set_kc_m2m_key_len_kc_mask                                   (0x00001000)
#define  NAG_KT_dma_set_kc_m2m_algorithm_kc_mask                                 (0x00000100)
#define  NAG_KT_dma_set_kc_m2m_wr_region_kc_mask                                 (0x00000030)
#define  NAG_KT_dma_set_kc_m2m_rd_region_kc_mask                                 (0x00000003)
#define  NAG_KT_dma_set_kc_m2m_key_index_kc(data)                                (0x7F000000&((data)<<24))
#define  NAG_KT_dma_set_kc_m2m_aes_mode_kc(data)                                 (0x00F00000&((data)<<20))
#define  NAG_KT_dma_set_kc_m2m_encrypt_en_kc(data)                               (0x00010000&((data)<<16))
#define  NAG_KT_dma_set_kc_m2m_key_len_kc(data)                                  (0x00001000&((data)<<12))
#define  NAG_KT_dma_set_kc_m2m_algorithm_kc(data)                                (0x00000100&((data)<<8))
#define  NAG_KT_dma_set_kc_m2m_wr_region_kc(data)                                (0x00000030&((data)<<4))
#define  NAG_KT_dma_set_kc_m2m_rd_region_kc(data)                                (0x00000003&(data))
#define  NAG_KT_dma_set_kc_get_m2m_key_index_kc(data)                            ((0x7F000000&(data))>>24)
#define  NAG_KT_dma_set_kc_get_m2m_aes_mode_kc(data)                             ((0x00F00000&(data))>>20)
#define  NAG_KT_dma_set_kc_get_m2m_encrypt_en_kc(data)                           ((0x00010000&(data))>>16)
#define  NAG_KT_dma_set_kc_get_m2m_key_len_kc(data)                              ((0x00001000&(data))>>12)
#define  NAG_KT_dma_set_kc_get_m2m_algorithm_kc(data)                            ((0x00000100&(data))>>8)
#define  NAG_KT_dma_set_kc_get_m2m_wr_region_kc(data)                            ((0x00000030&(data))>>4)
#define  NAG_KT_dma_set_kc_get_m2m_rd_region_kc(data)                            (0x00000003&(data))

#define  NAG_KT_dma_rd_adr_kc                                                   0x1806CA08
#define  NAG_KT_dma_rd_adr_kc_reg_addr                                           "0xB806CA08"
#define  NAG_KT_dma_rd_adr_kc_reg                                                0xB806CA08
#define  NAG_KT_dma_rd_adr_kc_inst_addr                                          "0x001B"
#define  set_NAG_KT_dma_rd_adr_kc_reg(data)                                      (*((volatile unsigned int*)NAG_KT_dma_rd_adr_kc_reg)=data)
#define  get_NAG_KT_dma_rd_adr_kc_reg                                            (*((volatile unsigned int*)NAG_KT_dma_rd_adr_kc_reg))
#define  NAG_KT_dma_rd_adr_kc_m2m_rd_addr_kc_shift                               (0)
#define  NAG_KT_dma_rd_adr_kc_m2m_rd_addr_kc_mask                                (0xFFFFFFFF)
#define  NAG_KT_dma_rd_adr_kc_m2m_rd_addr_kc(data)                               (0xFFFFFFFF&(data))
#define  NAG_KT_dma_rd_adr_kc_get_m2m_rd_addr_kc(data)                           (0xFFFFFFFF&(data))

#define  NAG_KT_dma_wr_adr_kc                                                   0x1806CA0C
#define  NAG_KT_dma_wr_adr_kc_reg_addr                                           "0xB806CA0C"
#define  NAG_KT_dma_wr_adr_kc_reg                                                0xB806CA0C
#define  NAG_KT_dma_wr_adr_kc_inst_addr                                          "0x001C"
#define  set_NAG_KT_dma_wr_adr_kc_reg(data)                                      (*((volatile unsigned int*)NAG_KT_dma_wr_adr_kc_reg)=data)
#define  get_NAG_KT_dma_wr_adr_kc_reg                                            (*((volatile unsigned int*)NAG_KT_dma_wr_adr_kc_reg))
#define  NAG_KT_dma_wr_adr_kc_m2m_wr_addr_kc_shift                               (0)
#define  NAG_KT_dma_wr_adr_kc_m2m_wr_addr_kc_mask                                (0xFFFFFFFF)
#define  NAG_KT_dma_wr_adr_kc_m2m_wr_addr_kc(data)                               (0xFFFFFFFF&(data))
#define  NAG_KT_dma_wr_adr_kc_get_m2m_wr_addr_kc(data)                           (0xFFFFFFFF&(data))

#define  NAG_KT_dma_rd_len_kc                                                   0x1806CA10
#define  NAG_KT_dma_rd_len_kc_reg_addr                                           "0xB806CA10"
#define  NAG_KT_dma_rd_len_kc_reg                                                0xB806CA10
#define  NAG_KT_dma_rd_len_kc_inst_addr                                          "0x001D"
#define  set_NAG_KT_dma_rd_len_kc_reg(data)                                      (*((volatile unsigned int*)NAG_KT_dma_rd_len_kc_reg)=data)
#define  get_NAG_KT_dma_rd_len_kc_reg                                            (*((volatile unsigned int*)NAG_KT_dma_rd_len_kc_reg))
#define  NAG_KT_dma_rd_len_kc_m2m_rd_total_len_kc_shift                          (0)
#define  NAG_KT_dma_rd_len_kc_m2m_rd_total_len_kc_mask                           (0xFFFFFFFF)
#define  NAG_KT_dma_rd_len_kc_m2m_rd_total_len_kc(data)                          (0xFFFFFFFF&(data))
#define  NAG_KT_dma_rd_len_kc_get_m2m_rd_total_len_kc(data)                      (0xFFFFFFFF&(data))

#define  NAG_KT_dma_wr_len_kc                                                   0x1806CA14
#define  NAG_KT_dma_wr_len_kc_reg_addr                                           "0xB806CA14"
#define  NAG_KT_dma_wr_len_kc_reg                                                0xB806CA14
#define  NAG_KT_dma_wr_len_kc_inst_addr                                          "0x001E"
#define  set_NAG_KT_dma_wr_len_kc_reg(data)                                      (*((volatile unsigned int*)NAG_KT_dma_wr_len_kc_reg)=data)
#define  get_NAG_KT_dma_wr_len_kc_reg                                            (*((volatile unsigned int*)NAG_KT_dma_wr_len_kc_reg))
#define  NAG_KT_dma_wr_len_kc_m2m_wr_total_len_kc_shift                          (0)
#define  NAG_KT_dma_wr_len_kc_m2m_wr_total_len_kc_mask                           (0xFFFFFFFF)
#define  NAG_KT_dma_wr_len_kc_m2m_wr_total_len_kc(data)                          (0xFFFFFFFF&(data))
#define  NAG_KT_dma_wr_len_kc_get_m2m_wr_total_len_kc(data)                      (0xFFFFFFFF&(data))

#define  NAG_KT_dma_dsc_len_0_kc                                                0x1806CA18
#define  NAG_KT_dma_dsc_len_0_kc_reg_addr                                        "0xB806CA18"
#define  NAG_KT_dma_dsc_len_0_kc_reg                                             0xB806CA18
#define  NAG_KT_dma_dsc_len_0_kc_inst_addr                                       "0x001F"
#define  set_NAG_KT_dma_dsc_len_0_kc_reg(data)                                   (*((volatile unsigned int*)NAG_KT_dma_dsc_len_0_kc_reg)=data)
#define  get_NAG_KT_dma_dsc_len_0_kc_reg                                         (*((volatile unsigned int*)NAG_KT_dma_dsc_len_0_kc_reg))
#define  NAG_KT_dma_dsc_len_0_kc_m2m_pkt_len_kc_shift                            (0)
#define  NAG_KT_dma_dsc_len_0_kc_m2m_pkt_len_kc_mask                             (0xFFFFFFFF)
#define  NAG_KT_dma_dsc_len_0_kc_m2m_pkt_len_kc(data)                            (0xFFFFFFFF&(data))
#define  NAG_KT_dma_dsc_len_0_kc_get_m2m_pkt_len_kc(data)                        (0xFFFFFFFF&(data))

#define  NAG_KT_dma_dsc_len_1_kc                                                0x1806CA1C
#define  NAG_KT_dma_dsc_len_1_kc_reg_addr                                        "0xB806CA1C"
#define  NAG_KT_dma_dsc_len_1_kc_reg                                             0xB806CA1C
#define  NAG_KT_dma_dsc_len_1_kc_inst_addr                                       "0x0020"
#define  set_NAG_KT_dma_dsc_len_1_kc_reg(data)                                   (*((volatile unsigned int*)NAG_KT_dma_dsc_len_1_kc_reg)=data)
#define  get_NAG_KT_dma_dsc_len_1_kc_reg                                         (*((volatile unsigned int*)NAG_KT_dma_dsc_len_1_kc_reg))
#define  NAG_KT_dma_dsc_len_1_kc_m2m_msc_len_kc_shift                            (0)
#define  NAG_KT_dma_dsc_len_1_kc_m2m_msc_len_kc_mask                             (0xFFFFFFFF)
#define  NAG_KT_dma_dsc_len_1_kc_m2m_msc_len_kc(data)                            (0xFFFFFFFF&(data))
#define  NAG_KT_dma_dsc_len_1_kc_get_m2m_msc_len_kc(data)                        (0xFFFFFFFF&(data))

#define  NAG_KT_dma_aes_cfg_0_kc                                                0x1806CA20
#define  NAG_KT_dma_aes_cfg_0_kc_reg_addr                                        "0xB806CA20"
#define  NAG_KT_dma_aes_cfg_0_kc_reg                                             0xB806CA20
#define  NAG_KT_dma_aes_cfg_0_kc_inst_addr                                       "0x0021"
#define  set_NAG_KT_dma_aes_cfg_0_kc_reg(data)                                   (*((volatile unsigned int*)NAG_KT_dma_aes_cfg_0_kc_reg)=data)
#define  get_NAG_KT_dma_aes_cfg_0_kc_reg                                         (*((volatile unsigned int*)NAG_KT_dma_aes_cfg_0_kc_reg))
#define  NAG_KT_dma_aes_cfg_0_kc_m2m_aes_crypt_byte_cnt_kc_shift                 (0)
#define  NAG_KT_dma_aes_cfg_0_kc_m2m_aes_crypt_byte_cnt_kc_mask                  (0xFFFFFFFF)
#define  NAG_KT_dma_aes_cfg_0_kc_m2m_aes_crypt_byte_cnt_kc(data)                 (0xFFFFFFFF&(data))
#define  NAG_KT_dma_aes_cfg_0_kc_get_m2m_aes_crypt_byte_cnt_kc(data)             (0xFFFFFFFF&(data))

#define  NAG_KT_dma_aes_cfg_1_kc                                                0x1806CA24
#define  NAG_KT_dma_aes_cfg_1_kc_reg_addr                                        "0xB806CA24"
#define  NAG_KT_dma_aes_cfg_1_kc_reg                                             0xB806CA24
#define  NAG_KT_dma_aes_cfg_1_kc_inst_addr                                       "0x0022"
#define  set_NAG_KT_dma_aes_cfg_1_kc_reg(data)                                   (*((volatile unsigned int*)NAG_KT_dma_aes_cfg_1_kc_reg)=data)
#define  get_NAG_KT_dma_aes_cfg_1_kc_reg                                         (*((volatile unsigned int*)NAG_KT_dma_aes_cfg_1_kc_reg))
#define  NAG_KT_dma_aes_cfg_1_kc_m2m_aes_skip_byte_cnt_kc_shift                  (0)
#define  NAG_KT_dma_aes_cfg_1_kc_m2m_aes_skip_byte_cnt_kc_mask                   (0xFFFFFFFF)
#define  NAG_KT_dma_aes_cfg_1_kc_m2m_aes_skip_byte_cnt_kc(data)                  (0xFFFFFFFF&(data))
#define  NAG_KT_dma_aes_cfg_1_kc_get_m2m_aes_skip_byte_cnt_kc(data)              (0xFFFFFFFF&(data))

#define  NAG_KT_dma_aes_gcm_0_kc                                                0x1806CA30
#define  NAG_KT_dma_aes_gcm_0_kc_reg_addr                                        "0xB806CA30"
#define  NAG_KT_dma_aes_gcm_0_kc_reg                                             0xB806CA30
#define  NAG_KT_dma_aes_gcm_0_kc_inst_addr                                       "0x0023"
#define  set_NAG_KT_dma_aes_gcm_0_kc_reg(data)                                   (*((volatile unsigned int*)NAG_KT_dma_aes_gcm_0_kc_reg)=data)
#define  get_NAG_KT_dma_aes_gcm_0_kc_reg                                         (*((volatile unsigned int*)NAG_KT_dma_aes_gcm_0_kc_reg))
#define  NAG_KT_dma_aes_gcm_0_kc_m2m_aes_gcm_len_al_kc_shift                     (0)
#define  NAG_KT_dma_aes_gcm_0_kc_m2m_aes_gcm_len_al_kc_mask                      (0xFFFFFFFF)
#define  NAG_KT_dma_aes_gcm_0_kc_m2m_aes_gcm_len_al_kc(data)                     (0xFFFFFFFF&(data))
#define  NAG_KT_dma_aes_gcm_0_kc_get_m2m_aes_gcm_len_al_kc(data)                 (0xFFFFFFFF&(data))

#define  NAG_KT_dma_aes_gcm_1_kc                                                0x1806CA34
#define  NAG_KT_dma_aes_gcm_1_kc_reg_addr                                        "0xB806CA34"
#define  NAG_KT_dma_aes_gcm_1_kc_reg                                             0xB806CA34
#define  NAG_KT_dma_aes_gcm_1_kc_inst_addr                                       "0x0024"
#define  set_NAG_KT_dma_aes_gcm_1_kc_reg(data)                                   (*((volatile unsigned int*)NAG_KT_dma_aes_gcm_1_kc_reg)=data)
#define  get_NAG_KT_dma_aes_gcm_1_kc_reg                                         (*((volatile unsigned int*)NAG_KT_dma_aes_gcm_1_kc_reg))
#define  NAG_KT_dma_aes_gcm_1_kc_m2m_aes_gcm_len_ah_kc_shift                     (0)
#define  NAG_KT_dma_aes_gcm_1_kc_m2m_aes_gcm_len_ah_kc_mask                      (0xFFFFFFFF)
#define  NAG_KT_dma_aes_gcm_1_kc_m2m_aes_gcm_len_ah_kc(data)                     (0xFFFFFFFF&(data))
#define  NAG_KT_dma_aes_gcm_1_kc_get_m2m_aes_gcm_len_ah_kc(data)                 (0xFFFFFFFF&(data))

#define  NAG_KT_dma_aes_gcm_2_kc                                                0x1806CA38
#define  NAG_KT_dma_aes_gcm_2_kc_reg_addr                                        "0xB806CA38"
#define  NAG_KT_dma_aes_gcm_2_kc_reg                                             0xB806CA38
#define  NAG_KT_dma_aes_gcm_2_kc_inst_addr                                       "0x0025"
#define  set_NAG_KT_dma_aes_gcm_2_kc_reg(data)                                   (*((volatile unsigned int*)NAG_KT_dma_aes_gcm_2_kc_reg)=data)
#define  get_NAG_KT_dma_aes_gcm_2_kc_reg                                         (*((volatile unsigned int*)NAG_KT_dma_aes_gcm_2_kc_reg))
#define  NAG_KT_dma_aes_gcm_2_kc_m2m_aes_gcm_len_ivl_kc_shift                    (0)
#define  NAG_KT_dma_aes_gcm_2_kc_m2m_aes_gcm_len_ivl_kc_mask                     (0xFFFFFFFF)
#define  NAG_KT_dma_aes_gcm_2_kc_m2m_aes_gcm_len_ivl_kc(data)                    (0xFFFFFFFF&(data))
#define  NAG_KT_dma_aes_gcm_2_kc_get_m2m_aes_gcm_len_ivl_kc(data)                (0xFFFFFFFF&(data))

#define  NAG_KT_dma_aes_gcm_3_kc                                                0x1806CA3C
#define  NAG_KT_dma_aes_gcm_3_kc_reg_addr                                        "0xB806CA3C"
#define  NAG_KT_dma_aes_gcm_3_kc_reg                                             0xB806CA3C
#define  NAG_KT_dma_aes_gcm_3_kc_inst_addr                                       "0x0026"
#define  set_NAG_KT_dma_aes_gcm_3_kc_reg(data)                                   (*((volatile unsigned int*)NAG_KT_dma_aes_gcm_3_kc_reg)=data)
#define  get_NAG_KT_dma_aes_gcm_3_kc_reg                                         (*((volatile unsigned int*)NAG_KT_dma_aes_gcm_3_kc_reg))
#define  NAG_KT_dma_aes_gcm_3_kc_m2m_aes_gcm_len_ivh_kc_shift                    (0)
#define  NAG_KT_dma_aes_gcm_3_kc_m2m_aes_gcm_len_ivh_kc_mask                     (0xFFFFFFFF)
#define  NAG_KT_dma_aes_gcm_3_kc_m2m_aes_gcm_len_ivh_kc(data)                    (0xFFFFFFFF&(data))
#define  NAG_KT_dma_aes_gcm_3_kc_get_m2m_aes_gcm_len_ivh_kc(data)                (0xFFFFFFFF&(data))

#define  NAG_KT_dma_aes_gcm_4_kc                                                0x1806CA40
#define  NAG_KT_dma_aes_gcm_4_kc_reg_addr                                        "0xB806CA40"
#define  NAG_KT_dma_aes_gcm_4_kc_reg                                             0xB806CA40
#define  NAG_KT_dma_aes_gcm_4_kc_inst_addr                                       "0x0027"
#define  set_NAG_KT_dma_aes_gcm_4_kc_reg(data)                                   (*((volatile unsigned int*)NAG_KT_dma_aes_gcm_4_kc_reg)=data)
#define  get_NAG_KT_dma_aes_gcm_4_kc_reg                                         (*((volatile unsigned int*)NAG_KT_dma_aes_gcm_4_kc_reg))
#define  NAG_KT_dma_aes_gcm_4_kc_m2m_aes_gcm_len_cl_kc_shift                     (0)
#define  NAG_KT_dma_aes_gcm_4_kc_m2m_aes_gcm_len_cl_kc_mask                      (0xFFFFFFFF)
#define  NAG_KT_dma_aes_gcm_4_kc_m2m_aes_gcm_len_cl_kc(data)                     (0xFFFFFFFF&(data))
#define  NAG_KT_dma_aes_gcm_4_kc_get_m2m_aes_gcm_len_cl_kc(data)                 (0xFFFFFFFF&(data))

#define  NAG_KT_dma_aes_gcm_5_kc                                                0x1806CA44
#define  NAG_KT_dma_aes_gcm_5_kc_reg_addr                                        "0xB806CA44"
#define  NAG_KT_dma_aes_gcm_5_kc_reg                                             0xB806CA44
#define  NAG_KT_dma_aes_gcm_5_kc_inst_addr                                       "0x0028"
#define  set_NAG_KT_dma_aes_gcm_5_kc_reg(data)                                   (*((volatile unsigned int*)NAG_KT_dma_aes_gcm_5_kc_reg)=data)
#define  get_NAG_KT_dma_aes_gcm_5_kc_reg                                         (*((volatile unsigned int*)NAG_KT_dma_aes_gcm_5_kc_reg))
#define  NAG_KT_dma_aes_gcm_5_kc_m2m_aes_gcm_len_ch_kc_shift                     (0)
#define  NAG_KT_dma_aes_gcm_5_kc_m2m_aes_gcm_len_ch_kc_mask                      (0xFFFFFFFF)
#define  NAG_KT_dma_aes_gcm_5_kc_m2m_aes_gcm_len_ch_kc(data)                     (0xFFFFFFFF&(data))
#define  NAG_KT_dma_aes_gcm_5_kc_get_m2m_aes_gcm_len_ch_kc(data)                 (0xFFFFFFFF&(data))

#define  NAG_KT_dma_aes_gcm_6_kc                                                0x1806CA48
#define  NAG_KT_dma_aes_gcm_6_kc_reg_addr                                        "0xB806CA48"
#define  NAG_KT_dma_aes_gcm_6_kc_reg                                             0xB806CA48
#define  NAG_KT_dma_aes_gcm_6_kc_inst_addr                                       "0x0029"
#define  set_NAG_KT_dma_aes_gcm_6_kc_reg(data)                                   (*((volatile unsigned int*)NAG_KT_dma_aes_gcm_6_kc_reg)=data)
#define  get_NAG_KT_dma_aes_gcm_6_kc_reg                                         (*((volatile unsigned int*)NAG_KT_dma_aes_gcm_6_kc_reg))
#define  NAG_KT_dma_aes_gcm_6_kc_m2m_aes_gcm_len_t_kc_shift                      (0)
#define  NAG_KT_dma_aes_gcm_6_kc_m2m_aes_gcm_len_t_kc_mask                       (0x0000007F)
#define  NAG_KT_dma_aes_gcm_6_kc_m2m_aes_gcm_len_t_kc(data)                      (0x0000007F&(data))
#define  NAG_KT_dma_aes_gcm_6_kc_get_m2m_aes_gcm_len_t_kc(data)                  (0x0000007F&(data))

#define  NAG_KT_dma_aes_gcm_7_kc                                                0x1806CA4C
#define  NAG_KT_dma_aes_gcm_7_kc_reg_addr                                        "0xB806CA4C"
#define  NAG_KT_dma_aes_gcm_7_kc_reg                                             0xB806CA4C
#define  NAG_KT_dma_aes_gcm_7_kc_inst_addr                                       "0x002A"
#define  set_NAG_KT_dma_aes_gcm_7_kc_reg(data)                                   (*((volatile unsigned int*)NAG_KT_dma_aes_gcm_7_kc_reg)=data)
#define  get_NAG_KT_dma_aes_gcm_7_kc_reg                                         (*((volatile unsigned int*)NAG_KT_dma_aes_gcm_7_kc_reg))
#define  NAG_KT_dma_aes_gcm_7_kc_m2m_aes_gcm_err_kc_shift                        (0)
#define  NAG_KT_dma_aes_gcm_7_kc_m2m_aes_gcm_err_kc_mask                         (0x00000001)
#define  NAG_KT_dma_aes_gcm_7_kc_m2m_aes_gcm_err_kc(data)                        (0x00000001&(data))
#define  NAG_KT_dma_aes_gcm_7_kc_get_m2m_aes_gcm_err_kc(data)                    (0x00000001&(data))

#define  NAG_KT_dma_int_kc                                                      0x1806CA70
#define  NAG_KT_dma_int_kc_reg_addr                                              "0xB806CA70"
#define  NAG_KT_dma_int_kc_reg                                                   0xB806CA70
#define  NAG_KT_dma_int_kc_inst_addr                                             "0x002B"
#define  set_NAG_KT_dma_int_kc_reg(data)                                         (*((volatile unsigned int*)NAG_KT_dma_int_kc_reg)=data)
#define  get_NAG_KT_dma_int_kc_reg                                               (*((volatile unsigned int*)NAG_KT_dma_int_kc_reg))
#define  NAG_KT_dma_int_kc_m2m_kcpu_int_shift                                    (4)
#define  NAG_KT_dma_int_kc_m2m_kcpu_int_en_shift                                 (0)
#define  NAG_KT_dma_int_kc_m2m_kcpu_int_mask                                     (0x00000010)
#define  NAG_KT_dma_int_kc_m2m_kcpu_int_en_mask                                  (0x00000001)
#define  NAG_KT_dma_int_kc_m2m_kcpu_int(data)                                    (0x00000010&((data)<<4))
#define  NAG_KT_dma_int_kc_m2m_kcpu_int_en(data)                                 (0x00000001&(data))
#define  NAG_KT_dma_int_kc_get_m2m_kcpu_int(data)                                ((0x00000010&(data))>>4)
#define  NAG_KT_dma_int_kc_get_m2m_kcpu_int_en(data)                             (0x00000001&(data))

#define  NAG_KT_dma_ctrl_sc                                                     0x1806C280
#define  NAG_KT_dma_ctrl_sc_reg_addr                                             "0xB806C280"
#define  NAG_KT_dma_ctrl_sc_reg                                                  0xB806C280
#define  NAG_KT_dma_ctrl_sc_inst_addr                                            "0x002C"
#define  set_NAG_KT_dma_ctrl_sc_reg(data)                                        (*((volatile unsigned int*)NAG_KT_dma_ctrl_sc_reg)=data)
#define  get_NAG_KT_dma_ctrl_sc_reg                                              (*((volatile unsigned int*)NAG_KT_dma_ctrl_sc_reg))
#define  NAG_KT_dma_ctrl_sc_m2m_busy_sc_shift                                    (4)
#define  NAG_KT_dma_ctrl_sc_m2m_go_sc_shift                                      (0)
#define  NAG_KT_dma_ctrl_sc_m2m_busy_sc_mask                                     (0x00000010)
#define  NAG_KT_dma_ctrl_sc_m2m_go_sc_mask                                       (0x00000001)
#define  NAG_KT_dma_ctrl_sc_m2m_busy_sc(data)                                    (0x00000010&((data)<<4))
#define  NAG_KT_dma_ctrl_sc_m2m_go_sc(data)                                      (0x00000001&(data))
#define  NAG_KT_dma_ctrl_sc_get_m2m_busy_sc(data)                                ((0x00000010&(data))>>4)
#define  NAG_KT_dma_ctrl_sc_get_m2m_go_sc(data)                                  (0x00000001&(data))

#define  NAG_KT_dma_ctrl_sc_kc                                                  0x1806CA80
#define  NAG_KT_dma_ctrl_sc_kc_reg_addr                                          "0xB806CA80"
#define  NAG_KT_dma_ctrl_sc_kc_reg                                               0xB806CA80
#define  NAG_KT_dma_ctrl_sc_kc_inst_addr                                         "0x002D"
#define  set_NAG_KT_dma_ctrl_sc_kc_reg(data)                                     (*((volatile unsigned int*)NAG_KT_dma_ctrl_sc_kc_reg)=data)
#define  get_NAG_KT_dma_ctrl_sc_kc_reg                                           (*((volatile unsigned int*)NAG_KT_dma_ctrl_sc_kc_reg))
#define  NAG_KT_dma_ctrl_sc_kc_smp_decrypt_en_shift                              (1)
#define  NAG_KT_dma_ctrl_sc_kc_smp_encrypt_en_shift                              (0)
#define  NAG_KT_dma_ctrl_sc_kc_smp_decrypt_en_mask                               (0x00000002)
#define  NAG_KT_dma_ctrl_sc_kc_smp_encrypt_en_mask                               (0x00000001)
#define  NAG_KT_dma_ctrl_sc_kc_smp_decrypt_en(data)                              (0x00000002&((data)<<1))
#define  NAG_KT_dma_ctrl_sc_kc_smp_encrypt_en(data)                              (0x00000001&(data))
#define  NAG_KT_dma_ctrl_sc_kc_get_smp_decrypt_en(data)                          ((0x00000002&(data))>>1)
#define  NAG_KT_dma_ctrl_sc_kc_get_smp_encrypt_en(data)                          (0x00000001&(data))

#define  NAG_KT_dma_set_sc                                                      0x1806C284
#define  NAG_KT_dma_set_sc_reg_addr                                              "0xB806C284"
#define  NAG_KT_dma_set_sc_reg                                                   0xB806C284
#define  NAG_KT_dma_set_sc_inst_addr                                             "0x002E"
#define  set_NAG_KT_dma_set_sc_reg(data)                                         (*((volatile unsigned int*)NAG_KT_dma_set_sc_reg)=data)
#define  get_NAG_KT_dma_set_sc_reg                                               (*((volatile unsigned int*)NAG_KT_dma_set_sc_reg))
#define  NAG_KT_dma_set_sc_m2m_key_index_sc_shift                                (24)
#define  NAG_KT_dma_set_sc_m2m_aes_mode_sc_shift                                 (20)
#define  NAG_KT_dma_set_sc_m2m_encrypt_en_sc_shift                               (16)
#define  NAG_KT_dma_set_sc_m2m_key_len_sc_shift                                  (12)
#define  NAG_KT_dma_set_sc_m2m_algorithm_sc_shift                                (8)
#define  NAG_KT_dma_set_sc_m2m_wr_region_sc_shift                                (4)
#define  NAG_KT_dma_set_sc_m2m_rd_region_sc_shift                                (0)
#define  NAG_KT_dma_set_sc_m2m_key_index_sc_mask                                 (0x7F000000)
#define  NAG_KT_dma_set_sc_m2m_aes_mode_sc_mask                                  (0x00F00000)
#define  NAG_KT_dma_set_sc_m2m_encrypt_en_sc_mask                                (0x00010000)
#define  NAG_KT_dma_set_sc_m2m_key_len_sc_mask                                   (0x00001000)
#define  NAG_KT_dma_set_sc_m2m_algorithm_sc_mask                                 (0x00000100)
#define  NAG_KT_dma_set_sc_m2m_wr_region_sc_mask                                 (0x00000010)
#define  NAG_KT_dma_set_sc_m2m_rd_region_sc_mask                                 (0x00000001)
#define  NAG_KT_dma_set_sc_m2m_key_index_sc(data)                                (0x7F000000&((data)<<24))
#define  NAG_KT_dma_set_sc_m2m_aes_mode_sc(data)                                 (0x00F00000&((data)<<20))
#define  NAG_KT_dma_set_sc_m2m_encrypt_en_sc(data)                               (0x00010000&((data)<<16))
#define  NAG_KT_dma_set_sc_m2m_key_len_sc(data)                                  (0x00001000&((data)<<12))
#define  NAG_KT_dma_set_sc_m2m_algorithm_sc(data)                                (0x00000100&((data)<<8))
#define  NAG_KT_dma_set_sc_m2m_wr_region_sc(data)                                (0x00000010&((data)<<4))
#define  NAG_KT_dma_set_sc_m2m_rd_region_sc(data)                                (0x00000001&(data))
#define  NAG_KT_dma_set_sc_get_m2m_key_index_sc(data)                            ((0x7F000000&(data))>>24)
#define  NAG_KT_dma_set_sc_get_m2m_aes_mode_sc(data)                             ((0x00F00000&(data))>>20)
#define  NAG_KT_dma_set_sc_get_m2m_encrypt_en_sc(data)                           ((0x00010000&(data))>>16)
#define  NAG_KT_dma_set_sc_get_m2m_key_len_sc(data)                              ((0x00001000&(data))>>12)
#define  NAG_KT_dma_set_sc_get_m2m_algorithm_sc(data)                            ((0x00000100&(data))>>8)
#define  NAG_KT_dma_set_sc_get_m2m_wr_region_sc(data)                            ((0x00000010&(data))>>4)
#define  NAG_KT_dma_set_sc_get_m2m_rd_region_sc(data)                            (0x00000001&(data))

#define  NAG_KT_dma_rd_adr_sc                                                   0x1806C288
#define  NAG_KT_dma_rd_adr_sc_reg_addr                                           "0xB806C288"
#define  NAG_KT_dma_rd_adr_sc_reg                                                0xB806C288
#define  NAG_KT_dma_rd_adr_sc_inst_addr                                          "0x002F"
#define  set_NAG_KT_dma_rd_adr_sc_reg(data)                                      (*((volatile unsigned int*)NAG_KT_dma_rd_adr_sc_reg)=data)
#define  get_NAG_KT_dma_rd_adr_sc_reg                                            (*((volatile unsigned int*)NAG_KT_dma_rd_adr_sc_reg))
#define  NAG_KT_dma_rd_adr_sc_m2m_rd_addr_sc_shift                               (0)
#define  NAG_KT_dma_rd_adr_sc_m2m_rd_addr_sc_mask                                (0xFFFFFFFF)
#define  NAG_KT_dma_rd_adr_sc_m2m_rd_addr_sc(data)                               (0xFFFFFFFF&(data))
#define  NAG_KT_dma_rd_adr_sc_get_m2m_rd_addr_sc(data)                           (0xFFFFFFFF&(data))

#define  NAG_KT_dma_wr_adr_sc                                                   0x1806C28C
#define  NAG_KT_dma_wr_adr_sc_reg_addr                                           "0xB806C28C"
#define  NAG_KT_dma_wr_adr_sc_reg                                                0xB806C28C
#define  NAG_KT_dma_wr_adr_sc_inst_addr                                          "0x0030"
#define  set_NAG_KT_dma_wr_adr_sc_reg(data)                                      (*((volatile unsigned int*)NAG_KT_dma_wr_adr_sc_reg)=data)
#define  get_NAG_KT_dma_wr_adr_sc_reg                                            (*((volatile unsigned int*)NAG_KT_dma_wr_adr_sc_reg))
#define  NAG_KT_dma_wr_adr_sc_m2m_wr_addr_sc_shift                               (0)
#define  NAG_KT_dma_wr_adr_sc_m2m_wr_addr_sc_mask                                (0xFFFFFFFF)
#define  NAG_KT_dma_wr_adr_sc_m2m_wr_addr_sc(data)                               (0xFFFFFFFF&(data))
#define  NAG_KT_dma_wr_adr_sc_get_m2m_wr_addr_sc(data)                           (0xFFFFFFFF&(data))

#define  NAG_KT_dma_rd_len_sc                                                   0x1806C290
#define  NAG_KT_dma_rd_len_sc_reg_addr                                           "0xB806C290"
#define  NAG_KT_dma_rd_len_sc_reg                                                0xB806C290
#define  NAG_KT_dma_rd_len_sc_inst_addr                                          "0x0031"
#define  set_NAG_KT_dma_rd_len_sc_reg(data)                                      (*((volatile unsigned int*)NAG_KT_dma_rd_len_sc_reg)=data)
#define  get_NAG_KT_dma_rd_len_sc_reg                                            (*((volatile unsigned int*)NAG_KT_dma_rd_len_sc_reg))
#define  NAG_KT_dma_rd_len_sc_m2m_rd_total_len_sc_shift                          (0)
#define  NAG_KT_dma_rd_len_sc_m2m_rd_total_len_sc_mask                           (0xFFFFFFFF)
#define  NAG_KT_dma_rd_len_sc_m2m_rd_total_len_sc(data)                          (0xFFFFFFFF&(data))
#define  NAG_KT_dma_rd_len_sc_get_m2m_rd_total_len_sc(data)                      (0xFFFFFFFF&(data))

#define  NAG_KT_dma_wr_len_sc                                                   0x1806C294
#define  NAG_KT_dma_wr_len_sc_reg_addr                                           "0xB806C294"
#define  NAG_KT_dma_wr_len_sc_reg                                                0xB806C294
#define  NAG_KT_dma_wr_len_sc_inst_addr                                          "0x0032"
#define  set_NAG_KT_dma_wr_len_sc_reg(data)                                      (*((volatile unsigned int*)NAG_KT_dma_wr_len_sc_reg)=data)
#define  get_NAG_KT_dma_wr_len_sc_reg                                            (*((volatile unsigned int*)NAG_KT_dma_wr_len_sc_reg))
#define  NAG_KT_dma_wr_len_sc_m2m_wr_total_len_sc_shift                          (0)
#define  NAG_KT_dma_wr_len_sc_m2m_wr_total_len_sc_mask                           (0xFFFFFFFF)
#define  NAG_KT_dma_wr_len_sc_m2m_wr_total_len_sc(data)                          (0xFFFFFFFF&(data))
#define  NAG_KT_dma_wr_len_sc_get_m2m_wr_total_len_sc(data)                      (0xFFFFFFFF&(data))

#define  NAG_KT_dma_dsc_len_0_sc                                                0x1806C298
#define  NAG_KT_dma_dsc_len_0_sc_reg_addr                                        "0xB806C298"
#define  NAG_KT_dma_dsc_len_0_sc_reg                                             0xB806C298
#define  NAG_KT_dma_dsc_len_0_sc_inst_addr                                       "0x0033"
#define  set_NAG_KT_dma_dsc_len_0_sc_reg(data)                                   (*((volatile unsigned int*)NAG_KT_dma_dsc_len_0_sc_reg)=data)
#define  get_NAG_KT_dma_dsc_len_0_sc_reg                                         (*((volatile unsigned int*)NAG_KT_dma_dsc_len_0_sc_reg))
#define  NAG_KT_dma_dsc_len_0_sc_m2m_pkt_len_sc_shift                            (0)
#define  NAG_KT_dma_dsc_len_0_sc_m2m_pkt_len_sc_mask                             (0xFFFFFFFF)
#define  NAG_KT_dma_dsc_len_0_sc_m2m_pkt_len_sc(data)                            (0xFFFFFFFF&(data))
#define  NAG_KT_dma_dsc_len_0_sc_get_m2m_pkt_len_sc(data)                        (0xFFFFFFFF&(data))

#define  NAG_KT_dma_dsc_len_1_sc                                                0x1806C29C
#define  NAG_KT_dma_dsc_len_1_sc_reg_addr                                        "0xB806C29C"
#define  NAG_KT_dma_dsc_len_1_sc_reg                                             0xB806C29C
#define  NAG_KT_dma_dsc_len_1_sc_inst_addr                                       "0x0034"
#define  set_NAG_KT_dma_dsc_len_1_sc_reg(data)                                   (*((volatile unsigned int*)NAG_KT_dma_dsc_len_1_sc_reg)=data)
#define  get_NAG_KT_dma_dsc_len_1_sc_reg                                         (*((volatile unsigned int*)NAG_KT_dma_dsc_len_1_sc_reg))
#define  NAG_KT_dma_dsc_len_1_sc_m2m_msc_len_sc_shift                            (0)
#define  NAG_KT_dma_dsc_len_1_sc_m2m_msc_len_sc_mask                             (0xFFFFFFFF)
#define  NAG_KT_dma_dsc_len_1_sc_m2m_msc_len_sc(data)                            (0xFFFFFFFF&(data))
#define  NAG_KT_dma_dsc_len_1_sc_get_m2m_msc_len_sc(data)                        (0xFFFFFFFF&(data))

#define  NAG_KT_dma_aes_cfg_0_sc                                                0x1806C2A0
#define  NAG_KT_dma_aes_cfg_0_sc_reg_addr                                        "0xB806C2A0"
#define  NAG_KT_dma_aes_cfg_0_sc_reg                                             0xB806C2A0
#define  NAG_KT_dma_aes_cfg_0_sc_inst_addr                                       "0x0035"
#define  set_NAG_KT_dma_aes_cfg_0_sc_reg(data)                                   (*((volatile unsigned int*)NAG_KT_dma_aes_cfg_0_sc_reg)=data)
#define  get_NAG_KT_dma_aes_cfg_0_sc_reg                                         (*((volatile unsigned int*)NAG_KT_dma_aes_cfg_0_sc_reg))
#define  NAG_KT_dma_aes_cfg_0_sc_m2m_aes_crypt_byte_cnt_sc_shift                 (0)
#define  NAG_KT_dma_aes_cfg_0_sc_m2m_aes_crypt_byte_cnt_sc_mask                  (0xFFFFFFFF)
#define  NAG_KT_dma_aes_cfg_0_sc_m2m_aes_crypt_byte_cnt_sc(data)                 (0xFFFFFFFF&(data))
#define  NAG_KT_dma_aes_cfg_0_sc_get_m2m_aes_crypt_byte_cnt_sc(data)             (0xFFFFFFFF&(data))

#define  NAG_KT_dma_aes_cfg_1_sc                                                0x1806C2A4
#define  NAG_KT_dma_aes_cfg_1_sc_reg_addr                                        "0xB806C2A4"
#define  NAG_KT_dma_aes_cfg_1_sc_reg                                             0xB806C2A4
#define  NAG_KT_dma_aes_cfg_1_sc_inst_addr                                       "0x0036"
#define  set_NAG_KT_dma_aes_cfg_1_sc_reg(data)                                   (*((volatile unsigned int*)NAG_KT_dma_aes_cfg_1_sc_reg)=data)
#define  get_NAG_KT_dma_aes_cfg_1_sc_reg                                         (*((volatile unsigned int*)NAG_KT_dma_aes_cfg_1_sc_reg))
#define  NAG_KT_dma_aes_cfg_1_sc_m2m_aes_skip_byte_cnt_sc_shift                  (0)
#define  NAG_KT_dma_aes_cfg_1_sc_m2m_aes_skip_byte_cnt_sc_mask                   (0xFFFFFFFF)
#define  NAG_KT_dma_aes_cfg_1_sc_m2m_aes_skip_byte_cnt_sc(data)                  (0xFFFFFFFF&(data))
#define  NAG_KT_dma_aes_cfg_1_sc_get_m2m_aes_skip_byte_cnt_sc(data)              (0xFFFFFFFF&(data))

#define  NAG_KT_dma_aes_gcm_0_sc                                                0x1806C2B0
#define  NAG_KT_dma_aes_gcm_0_sc_reg_addr                                        "0xB806C2B0"
#define  NAG_KT_dma_aes_gcm_0_sc_reg                                             0xB806C2B0
#define  NAG_KT_dma_aes_gcm_0_sc_inst_addr                                       "0x0037"
#define  set_NAG_KT_dma_aes_gcm_0_sc_reg(data)                                   (*((volatile unsigned int*)NAG_KT_dma_aes_gcm_0_sc_reg)=data)
#define  get_NAG_KT_dma_aes_gcm_0_sc_reg                                         (*((volatile unsigned int*)NAG_KT_dma_aes_gcm_0_sc_reg))
#define  NAG_KT_dma_aes_gcm_0_sc_m2m_aes_gcm_len_al_sc_shift                     (0)
#define  NAG_KT_dma_aes_gcm_0_sc_m2m_aes_gcm_len_al_sc_mask                      (0xFFFFFFFF)
#define  NAG_KT_dma_aes_gcm_0_sc_m2m_aes_gcm_len_al_sc(data)                     (0xFFFFFFFF&(data))
#define  NAG_KT_dma_aes_gcm_0_sc_get_m2m_aes_gcm_len_al_sc(data)                 (0xFFFFFFFF&(data))

#define  NAG_KT_dma_aes_gcm_1_sc                                                0x1806C2B4
#define  NAG_KT_dma_aes_gcm_1_sc_reg_addr                                        "0xB806C2B4"
#define  NAG_KT_dma_aes_gcm_1_sc_reg                                             0xB806C2B4
#define  NAG_KT_dma_aes_gcm_1_sc_inst_addr                                       "0x0038"
#define  set_NAG_KT_dma_aes_gcm_1_sc_reg(data)                                   (*((volatile unsigned int*)NAG_KT_dma_aes_gcm_1_sc_reg)=data)
#define  get_NAG_KT_dma_aes_gcm_1_sc_reg                                         (*((volatile unsigned int*)NAG_KT_dma_aes_gcm_1_sc_reg))
#define  NAG_KT_dma_aes_gcm_1_sc_m2m_aes_gcm_len_ah_sc_shift                     (0)
#define  NAG_KT_dma_aes_gcm_1_sc_m2m_aes_gcm_len_ah_sc_mask                      (0xFFFFFFFF)
#define  NAG_KT_dma_aes_gcm_1_sc_m2m_aes_gcm_len_ah_sc(data)                     (0xFFFFFFFF&(data))
#define  NAG_KT_dma_aes_gcm_1_sc_get_m2m_aes_gcm_len_ah_sc(data)                 (0xFFFFFFFF&(data))

#define  NAG_KT_dma_aes_gcm_2_sc                                                0x1806C2B8
#define  NAG_KT_dma_aes_gcm_2_sc_reg_addr                                        "0xB806C2B8"
#define  NAG_KT_dma_aes_gcm_2_sc_reg                                             0xB806C2B8
#define  NAG_KT_dma_aes_gcm_2_sc_inst_addr                                       "0x0039"
#define  set_NAG_KT_dma_aes_gcm_2_sc_reg(data)                                   (*((volatile unsigned int*)NAG_KT_dma_aes_gcm_2_sc_reg)=data)
#define  get_NAG_KT_dma_aes_gcm_2_sc_reg                                         (*((volatile unsigned int*)NAG_KT_dma_aes_gcm_2_sc_reg))
#define  NAG_KT_dma_aes_gcm_2_sc_m2m_aes_gcm_len_ivl_sc_shift                    (0)
#define  NAG_KT_dma_aes_gcm_2_sc_m2m_aes_gcm_len_ivl_sc_mask                     (0xFFFFFFFF)
#define  NAG_KT_dma_aes_gcm_2_sc_m2m_aes_gcm_len_ivl_sc(data)                    (0xFFFFFFFF&(data))
#define  NAG_KT_dma_aes_gcm_2_sc_get_m2m_aes_gcm_len_ivl_sc(data)                (0xFFFFFFFF&(data))

#define  NAG_KT_dma_aes_gcm_3_sc                                                0x1806C2BC
#define  NAG_KT_dma_aes_gcm_3_sc_reg_addr                                        "0xB806C2BC"
#define  NAG_KT_dma_aes_gcm_3_sc_reg                                             0xB806C2BC
#define  NAG_KT_dma_aes_gcm_3_sc_inst_addr                                       "0x003A"
#define  set_NAG_KT_dma_aes_gcm_3_sc_reg(data)                                   (*((volatile unsigned int*)NAG_KT_dma_aes_gcm_3_sc_reg)=data)
#define  get_NAG_KT_dma_aes_gcm_3_sc_reg                                         (*((volatile unsigned int*)NAG_KT_dma_aes_gcm_3_sc_reg))
#define  NAG_KT_dma_aes_gcm_3_sc_m2m_aes_gcm_len_ivh_sc_shift                    (0)
#define  NAG_KT_dma_aes_gcm_3_sc_m2m_aes_gcm_len_ivh_sc_mask                     (0xFFFFFFFF)
#define  NAG_KT_dma_aes_gcm_3_sc_m2m_aes_gcm_len_ivh_sc(data)                    (0xFFFFFFFF&(data))
#define  NAG_KT_dma_aes_gcm_3_sc_get_m2m_aes_gcm_len_ivh_sc(data)                (0xFFFFFFFF&(data))

#define  NAG_KT_dma_aes_gcm_4_sc                                                0x1806C2C0
#define  NAG_KT_dma_aes_gcm_4_sc_reg_addr                                        "0xB806C2C0"
#define  NAG_KT_dma_aes_gcm_4_sc_reg                                             0xB806C2C0
#define  NAG_KT_dma_aes_gcm_4_sc_inst_addr                                       "0x003B"
#define  set_NAG_KT_dma_aes_gcm_4_sc_reg(data)                                   (*((volatile unsigned int*)NAG_KT_dma_aes_gcm_4_sc_reg)=data)
#define  get_NAG_KT_dma_aes_gcm_4_sc_reg                                         (*((volatile unsigned int*)NAG_KT_dma_aes_gcm_4_sc_reg))
#define  NAG_KT_dma_aes_gcm_4_sc_m2m_aes_gcm_len_cl_sc_shift                     (0)
#define  NAG_KT_dma_aes_gcm_4_sc_m2m_aes_gcm_len_cl_sc_mask                      (0xFFFFFFFF)
#define  NAG_KT_dma_aes_gcm_4_sc_m2m_aes_gcm_len_cl_sc(data)                     (0xFFFFFFFF&(data))
#define  NAG_KT_dma_aes_gcm_4_sc_get_m2m_aes_gcm_len_cl_sc(data)                 (0xFFFFFFFF&(data))

#define  NAG_KT_dma_aes_gcm_5_sc                                                0x1806C2C4
#define  NAG_KT_dma_aes_gcm_5_sc_reg_addr                                        "0xB806C2C4"
#define  NAG_KT_dma_aes_gcm_5_sc_reg                                             0xB806C2C4
#define  NAG_KT_dma_aes_gcm_5_sc_inst_addr                                       "0x003C"
#define  set_NAG_KT_dma_aes_gcm_5_sc_reg(data)                                   (*((volatile unsigned int*)NAG_KT_dma_aes_gcm_5_sc_reg)=data)
#define  get_NAG_KT_dma_aes_gcm_5_sc_reg                                         (*((volatile unsigned int*)NAG_KT_dma_aes_gcm_5_sc_reg))
#define  NAG_KT_dma_aes_gcm_5_sc_m2m_aes_gcm_len_ch_sc_shift                     (0)
#define  NAG_KT_dma_aes_gcm_5_sc_m2m_aes_gcm_len_ch_sc_mask                      (0xFFFFFFFF)
#define  NAG_KT_dma_aes_gcm_5_sc_m2m_aes_gcm_len_ch_sc(data)                     (0xFFFFFFFF&(data))
#define  NAG_KT_dma_aes_gcm_5_sc_get_m2m_aes_gcm_len_ch_sc(data)                 (0xFFFFFFFF&(data))

#define  NAG_KT_dma_aes_gcm_6_sc                                                0x1806C2C8
#define  NAG_KT_dma_aes_gcm_6_sc_reg_addr                                        "0xB806C2C8"
#define  NAG_KT_dma_aes_gcm_6_sc_reg                                             0xB806C2C8
#define  NAG_KT_dma_aes_gcm_6_sc_inst_addr                                       "0x003D"
#define  set_NAG_KT_dma_aes_gcm_6_sc_reg(data)                                   (*((volatile unsigned int*)NAG_KT_dma_aes_gcm_6_sc_reg)=data)
#define  get_NAG_KT_dma_aes_gcm_6_sc_reg                                         (*((volatile unsigned int*)NAG_KT_dma_aes_gcm_6_sc_reg))
#define  NAG_KT_dma_aes_gcm_6_sc_m2m_aes_gcm_len_t_sc_shift                      (0)
#define  NAG_KT_dma_aes_gcm_6_sc_m2m_aes_gcm_len_t_sc_mask                       (0x0000007F)
#define  NAG_KT_dma_aes_gcm_6_sc_m2m_aes_gcm_len_t_sc(data)                      (0x0000007F&(data))
#define  NAG_KT_dma_aes_gcm_6_sc_get_m2m_aes_gcm_len_t_sc(data)                  (0x0000007F&(data))

#define  NAG_KT_dma_aes_gcm_7_sc                                                0x1806C2CC
#define  NAG_KT_dma_aes_gcm_7_sc_reg_addr                                        "0xB806C2CC"
#define  NAG_KT_dma_aes_gcm_7_sc_reg                                             0xB806C2CC
#define  NAG_KT_dma_aes_gcm_7_sc_inst_addr                                       "0x003E"
#define  set_NAG_KT_dma_aes_gcm_7_sc_reg(data)                                   (*((volatile unsigned int*)NAG_KT_dma_aes_gcm_7_sc_reg)=data)
#define  get_NAG_KT_dma_aes_gcm_7_sc_reg                                         (*((volatile unsigned int*)NAG_KT_dma_aes_gcm_7_sc_reg))
#define  NAG_KT_dma_aes_gcm_7_sc_m2m_aes_gcm_err_sc_shift                        (0)
#define  NAG_KT_dma_aes_gcm_7_sc_m2m_aes_gcm_err_sc_mask                         (0x00000001)
#define  NAG_KT_dma_aes_gcm_7_sc_m2m_aes_gcm_err_sc(data)                        (0x00000001&(data))
#define  NAG_KT_dma_aes_gcm_7_sc_get_m2m_aes_gcm_err_sc(data)                    (0x00000001&(data))

#define  NAG_KT_dma_int_sc                                                      0x1806C2F0
#define  NAG_KT_dma_int_sc_reg_addr                                              "0xB806C2F0"
#define  NAG_KT_dma_int_sc_reg                                                   0xB806C2F0
#define  NAG_KT_dma_int_sc_inst_addr                                             "0x003F"
#define  set_NAG_KT_dma_int_sc_reg(data)                                         (*((volatile unsigned int*)NAG_KT_dma_int_sc_reg)=data)
#define  get_NAG_KT_dma_int_sc_reg                                               (*((volatile unsigned int*)NAG_KT_dma_int_sc_reg))
#define  NAG_KT_dma_int_sc_m2m_scpu_int_shift                                    (4)
#define  NAG_KT_dma_int_sc_m2m_scpu_int_en_shift                                 (0)
#define  NAG_KT_dma_int_sc_m2m_scpu_int_mask                                     (0x00000010)
#define  NAG_KT_dma_int_sc_m2m_scpu_int_en_mask                                  (0x00000001)
#define  NAG_KT_dma_int_sc_m2m_scpu_int(data)                                    (0x00000010&((data)<<4))
#define  NAG_KT_dma_int_sc_m2m_scpu_int_en(data)                                 (0x00000001&(data))
#define  NAG_KT_dma_int_sc_get_m2m_scpu_int(data)                                ((0x00000010&(data))>>4)
#define  NAG_KT_dma_int_sc_get_m2m_scpu_int_en(data)                             (0x00000001&(data))

#define  NAG_KT_kt_bist_mode_resume                                             0x1806C300
#define  NAG_KT_kt_bist_mode_resume_reg_addr                                     "0xB806C300"
#define  NAG_KT_kt_bist_mode_resume_reg                                          0xB806C300
#define  NAG_KT_kt_bist_mode_resume_inst_addr                                    "0x0040"
#define  set_NAG_KT_kt_bist_mode_resume_reg(data)                                (*((volatile unsigned int*)NAG_KT_kt_bist_mode_resume_reg)=data)
#define  get_NAG_KT_kt_bist_mode_resume_reg                                      (*((volatile unsigned int*)NAG_KT_kt_bist_mode_resume_reg))
#define  NAG_KT_kt_bist_mode_resume_nag_dma_drf_test_resume_shift                (10)
#define  NAG_KT_kt_bist_mode_resume_nag_mem_drf_test_resume_shift                (9)
#define  NAG_KT_kt_bist_mode_resume_nag_kt_drf_test_resume_shift                 (8)
#define  NAG_KT_kt_bist_mode_resume_nag_dma_drf_bist_mode_shift                  (6)
#define  NAG_KT_kt_bist_mode_resume_nag_mem_drf_bist_mode_shift                  (5)
#define  NAG_KT_kt_bist_mode_resume_nag_kt_drf_bist_mode_shift                   (4)
#define  NAG_KT_kt_bist_mode_resume_nag_dma_bist_mode_shift                      (2)
#define  NAG_KT_kt_bist_mode_resume_nag_mem_bist_mode_shift                      (1)
#define  NAG_KT_kt_bist_mode_resume_nag_kt_bist_mode_shift                       (0)
#define  NAG_KT_kt_bist_mode_resume_nag_dma_drf_test_resume_mask                 (0x00000400)
#define  NAG_KT_kt_bist_mode_resume_nag_mem_drf_test_resume_mask                 (0x00000200)
#define  NAG_KT_kt_bist_mode_resume_nag_kt_drf_test_resume_mask                  (0x00000100)
#define  NAG_KT_kt_bist_mode_resume_nag_dma_drf_bist_mode_mask                   (0x00000040)
#define  NAG_KT_kt_bist_mode_resume_nag_mem_drf_bist_mode_mask                   (0x00000020)
#define  NAG_KT_kt_bist_mode_resume_nag_kt_drf_bist_mode_mask                    (0x00000010)
#define  NAG_KT_kt_bist_mode_resume_nag_dma_bist_mode_mask                       (0x00000004)
#define  NAG_KT_kt_bist_mode_resume_nag_mem_bist_mode_mask                       (0x00000002)
#define  NAG_KT_kt_bist_mode_resume_nag_kt_bist_mode_mask                        (0x00000001)
#define  NAG_KT_kt_bist_mode_resume_nag_dma_drf_test_resume(data)                (0x00000400&((data)<<10))
#define  NAG_KT_kt_bist_mode_resume_nag_mem_drf_test_resume(data)                (0x00000200&((data)<<9))
#define  NAG_KT_kt_bist_mode_resume_nag_kt_drf_test_resume(data)                 (0x00000100&((data)<<8))
#define  NAG_KT_kt_bist_mode_resume_nag_dma_drf_bist_mode(data)                  (0x00000040&((data)<<6))
#define  NAG_KT_kt_bist_mode_resume_nag_mem_drf_bist_mode(data)                  (0x00000020&((data)<<5))
#define  NAG_KT_kt_bist_mode_resume_nag_kt_drf_bist_mode(data)                   (0x00000010&((data)<<4))
#define  NAG_KT_kt_bist_mode_resume_nag_dma_bist_mode(data)                      (0x00000004&((data)<<2))
#define  NAG_KT_kt_bist_mode_resume_nag_mem_bist_mode(data)                      (0x00000002&((data)<<1))
#define  NAG_KT_kt_bist_mode_resume_nag_kt_bist_mode(data)                       (0x00000001&(data))
#define  NAG_KT_kt_bist_mode_resume_get_nag_dma_drf_test_resume(data)            ((0x00000400&(data))>>10)
#define  NAG_KT_kt_bist_mode_resume_get_nag_mem_drf_test_resume(data)            ((0x00000200&(data))>>9)
#define  NAG_KT_kt_bist_mode_resume_get_nag_kt_drf_test_resume(data)             ((0x00000100&(data))>>8)
#define  NAG_KT_kt_bist_mode_resume_get_nag_dma_drf_bist_mode(data)              ((0x00000040&(data))>>6)
#define  NAG_KT_kt_bist_mode_resume_get_nag_mem_drf_bist_mode(data)              ((0x00000020&(data))>>5)
#define  NAG_KT_kt_bist_mode_resume_get_nag_kt_drf_bist_mode(data)               ((0x00000010&(data))>>4)
#define  NAG_KT_kt_bist_mode_resume_get_nag_dma_bist_mode(data)                  ((0x00000004&(data))>>2)
#define  NAG_KT_kt_bist_mode_resume_get_nag_mem_bist_mode(data)                  ((0x00000002&(data))>>1)
#define  NAG_KT_kt_bist_mode_resume_get_nag_kt_bist_mode(data)                   (0x00000001&(data))

#define  NAG_KT_kt_bist_ls_rm_rme_test1                                         0x1806C304
#define  NAG_KT_kt_bist_ls_rm_rme_test1_reg_addr                                 "0xB806C304"
#define  NAG_KT_kt_bist_ls_rm_rme_test1_reg                                      0xB806C304
#define  NAG_KT_kt_bist_ls_rm_rme_test1_inst_addr                                "0x0041"
#define  set_NAG_KT_kt_bist_ls_rm_rme_test1_reg(data)                            (*((volatile unsigned int*)NAG_KT_kt_bist_ls_rm_rme_test1_reg)=data)
#define  get_NAG_KT_kt_bist_ls_rm_rme_test1_reg                                  (*((volatile unsigned int*)NAG_KT_kt_bist_ls_rm_rme_test1_reg))
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_dma_testrwm_shift                    (30)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_dma_test1_shift                      (26)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_mem_test1_shift                      (25)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_kt_test1_shift                       (24)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_dma_rme_shift                        (22)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_mem_rme_shift                        (21)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_kt_rme_shift                         (20)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_dma_rm_shift                         (12)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_mem_rm_shift                         (8)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_kt_rm_shift                          (4)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_dma_ls_shift                         (2)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_mem_ls_shift                         (1)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_kt_ls_shift                          (0)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_dma_testrwm_mask                     (0x40000000)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_dma_test1_mask                       (0x04000000)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_mem_test1_mask                       (0x02000000)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_kt_test1_mask                        (0x01000000)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_dma_rme_mask                         (0x00400000)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_mem_rme_mask                         (0x00200000)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_kt_rme_mask                          (0x00100000)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_dma_rm_mask                          (0x0000F000)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_mem_rm_mask                          (0x00000F00)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_kt_rm_mask                           (0x000000F0)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_dma_ls_mask                          (0x00000004)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_mem_ls_mask                          (0x00000002)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_kt_ls_mask                           (0x00000001)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_dma_testrwm(data)                    (0x40000000&((data)<<30))
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_dma_test1(data)                      (0x04000000&((data)<<26))
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_mem_test1(data)                      (0x02000000&((data)<<25))
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_kt_test1(data)                       (0x01000000&((data)<<24))
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_dma_rme(data)                        (0x00400000&((data)<<22))
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_mem_rme(data)                        (0x00200000&((data)<<21))
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_kt_rme(data)                         (0x00100000&((data)<<20))
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_dma_rm(data)                         (0x0000F000&((data)<<12))
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_mem_rm(data)                         (0x00000F00&((data)<<8))
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_kt_rm(data)                          (0x000000F0&((data)<<4))
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_dma_ls(data)                         (0x00000004&((data)<<2))
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_mem_ls(data)                         (0x00000002&((data)<<1))
#define  NAG_KT_kt_bist_ls_rm_rme_test1_nag_kt_ls(data)                          (0x00000001&(data))
#define  NAG_KT_kt_bist_ls_rm_rme_test1_get_nag_dma_testrwm(data)                ((0x40000000&(data))>>30)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_get_nag_dma_test1(data)                  ((0x04000000&(data))>>26)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_get_nag_mem_test1(data)                  ((0x02000000&(data))>>25)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_get_nag_kt_test1(data)                   ((0x01000000&(data))>>24)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_get_nag_dma_rme(data)                    ((0x00400000&(data))>>22)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_get_nag_mem_rme(data)                    ((0x00200000&(data))>>21)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_get_nag_kt_rme(data)                     ((0x00100000&(data))>>20)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_get_nag_dma_rm(data)                     ((0x0000F000&(data))>>12)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_get_nag_mem_rm(data)                     ((0x00000F00&(data))>>8)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_get_nag_kt_rm(data)                      ((0x000000F0&(data))>>4)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_get_nag_dma_ls(data)                     ((0x00000004&(data))>>2)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_get_nag_mem_ls(data)                     ((0x00000002&(data))>>1)
#define  NAG_KT_kt_bist_ls_rm_rme_test1_get_nag_kt_ls(data)                      (0x00000001&(data))

#define  NAG_KT_kt_bist_status                                                  0x1806C308
#define  NAG_KT_kt_bist_status_reg_addr                                          "0xB806C308"
#define  NAG_KT_kt_bist_status_reg                                               0xB806C308
#define  NAG_KT_kt_bist_status_inst_addr                                         "0x0042"
#define  set_NAG_KT_kt_bist_status_reg(data)                                     (*((volatile unsigned int*)NAG_KT_kt_bist_status_reg)=data)
#define  get_NAG_KT_kt_bist_status_reg                                           (*((volatile unsigned int*)NAG_KT_kt_bist_status_reg))
#define  NAG_KT_kt_bist_status_nag_dma_drf_bist_fail_grp_shift                   (18)
#define  NAG_KT_kt_bist_status_nag_mem_drf_bist_fail_shift                       (17)
#define  NAG_KT_kt_bist_status_nag_kt_drf_bist_fail_grp_shift                    (16)
#define  NAG_KT_kt_bist_status_nag_dma_bist_fail_grp_shift                       (14)
#define  NAG_KT_kt_bist_status_nag_mem_bist_fail_shift                           (13)
#define  NAG_KT_kt_bist_status_nag_kt_bist_fail_grp_shift                        (12)
#define  NAG_KT_kt_bist_status_nag_dma_drf_start_pause_shift                     (10)
#define  NAG_KT_kt_bist_status_nag_mem_drf_start_pause_shift                     (9)
#define  NAG_KT_kt_bist_status_nag_kt_drf_start_pause_shift                      (8)
#define  NAG_KT_kt_bist_status_nag_dma_drf_bist_done_shift                       (6)
#define  NAG_KT_kt_bist_status_nag_mem_drf_bist_done_shift                       (5)
#define  NAG_KT_kt_bist_status_nag_kt_drf_bist_done_shift                        (4)
#define  NAG_KT_kt_bist_status_nag_dma_bist_done_shift                           (2)
#define  NAG_KT_kt_bist_status_nag_mem_bist_done_shift                           (1)
#define  NAG_KT_kt_bist_status_nag_kt_bist_done_shift                            (0)
#define  NAG_KT_kt_bist_status_nag_dma_drf_bist_fail_grp_mask                    (0x00040000)
#define  NAG_KT_kt_bist_status_nag_mem_drf_bist_fail_mask                        (0x00020000)
#define  NAG_KT_kt_bist_status_nag_kt_drf_bist_fail_grp_mask                     (0x00010000)
#define  NAG_KT_kt_bist_status_nag_dma_bist_fail_grp_mask                        (0x00004000)
#define  NAG_KT_kt_bist_status_nag_mem_bist_fail_mask                            (0x00002000)
#define  NAG_KT_kt_bist_status_nag_kt_bist_fail_grp_mask                         (0x00001000)
#define  NAG_KT_kt_bist_status_nag_dma_drf_start_pause_mask                      (0x00000400)
#define  NAG_KT_kt_bist_status_nag_mem_drf_start_pause_mask                      (0x00000200)
#define  NAG_KT_kt_bist_status_nag_kt_drf_start_pause_mask                       (0x00000100)
#define  NAG_KT_kt_bist_status_nag_dma_drf_bist_done_mask                        (0x00000040)
#define  NAG_KT_kt_bist_status_nag_mem_drf_bist_done_mask                        (0x00000020)
#define  NAG_KT_kt_bist_status_nag_kt_drf_bist_done_mask                         (0x00000010)
#define  NAG_KT_kt_bist_status_nag_dma_bist_done_mask                            (0x00000004)
#define  NAG_KT_kt_bist_status_nag_mem_bist_done_mask                            (0x00000002)
#define  NAG_KT_kt_bist_status_nag_kt_bist_done_mask                             (0x00000001)
#define  NAG_KT_kt_bist_status_nag_dma_drf_bist_fail_grp(data)                   (0x00040000&((data)<<18))
#define  NAG_KT_kt_bist_status_nag_mem_drf_bist_fail(data)                       (0x00020000&((data)<<17))
#define  NAG_KT_kt_bist_status_nag_kt_drf_bist_fail_grp(data)                    (0x00010000&((data)<<16))
#define  NAG_KT_kt_bist_status_nag_dma_bist_fail_grp(data)                       (0x00004000&((data)<<14))
#define  NAG_KT_kt_bist_status_nag_mem_bist_fail(data)                           (0x00002000&((data)<<13))
#define  NAG_KT_kt_bist_status_nag_kt_bist_fail_grp(data)                        (0x00001000&((data)<<12))
#define  NAG_KT_kt_bist_status_nag_dma_drf_start_pause(data)                     (0x00000400&((data)<<10))
#define  NAG_KT_kt_bist_status_nag_mem_drf_start_pause(data)                     (0x00000200&((data)<<9))
#define  NAG_KT_kt_bist_status_nag_kt_drf_start_pause(data)                      (0x00000100&((data)<<8))
#define  NAG_KT_kt_bist_status_nag_dma_drf_bist_done(data)                       (0x00000040&((data)<<6))
#define  NAG_KT_kt_bist_status_nag_mem_drf_bist_done(data)                       (0x00000020&((data)<<5))
#define  NAG_KT_kt_bist_status_nag_kt_drf_bist_done(data)                        (0x00000010&((data)<<4))
#define  NAG_KT_kt_bist_status_nag_dma_bist_done(data)                           (0x00000004&((data)<<2))
#define  NAG_KT_kt_bist_status_nag_mem_bist_done(data)                           (0x00000002&((data)<<1))
#define  NAG_KT_kt_bist_status_nag_kt_bist_done(data)                            (0x00000001&(data))
#define  NAG_KT_kt_bist_status_get_nag_dma_drf_bist_fail_grp(data)               ((0x00040000&(data))>>18)
#define  NAG_KT_kt_bist_status_get_nag_mem_drf_bist_fail(data)                   ((0x00020000&(data))>>17)
#define  NAG_KT_kt_bist_status_get_nag_kt_drf_bist_fail_grp(data)                ((0x00010000&(data))>>16)
#define  NAG_KT_kt_bist_status_get_nag_dma_bist_fail_grp(data)                   ((0x00004000&(data))>>14)
#define  NAG_KT_kt_bist_status_get_nag_mem_bist_fail(data)                       ((0x00002000&(data))>>13)
#define  NAG_KT_kt_bist_status_get_nag_kt_bist_fail_grp(data)                    ((0x00001000&(data))>>12)
#define  NAG_KT_kt_bist_status_get_nag_dma_drf_start_pause(data)                 ((0x00000400&(data))>>10)
#define  NAG_KT_kt_bist_status_get_nag_mem_drf_start_pause(data)                 ((0x00000200&(data))>>9)
#define  NAG_KT_kt_bist_status_get_nag_kt_drf_start_pause(data)                  ((0x00000100&(data))>>8)
#define  NAG_KT_kt_bist_status_get_nag_dma_drf_bist_done(data)                   ((0x00000040&(data))>>6)
#define  NAG_KT_kt_bist_status_get_nag_mem_drf_bist_done(data)                   ((0x00000020&(data))>>5)
#define  NAG_KT_kt_bist_status_get_nag_kt_drf_bist_done(data)                    ((0x00000010&(data))>>4)
#define  NAG_KT_kt_bist_status_get_nag_dma_bist_done(data)                       ((0x00000004&(data))>>2)
#define  NAG_KT_kt_bist_status_get_nag_mem_bist_done(data)                       ((0x00000002&(data))>>1)
#define  NAG_KT_kt_bist_status_get_nag_kt_bist_done(data)                        (0x00000001&(data))

#define  NAG_KT_kt_bist_fail                                                    0x1806C30C
#define  NAG_KT_kt_bist_fail_reg_addr                                            "0xB806C30C"
#define  NAG_KT_kt_bist_fail_reg                                                 0xB806C30C
#define  NAG_KT_kt_bist_fail_inst_addr                                           "0x0043"
#define  set_NAG_KT_kt_bist_fail_reg(data)                                       (*((volatile unsigned int*)NAG_KT_kt_bist_fail_reg)=data)
#define  get_NAG_KT_kt_bist_fail_reg                                             (*((volatile unsigned int*)NAG_KT_kt_bist_fail_reg))
#define  NAG_KT_kt_bist_fail_nag_dma_drf_bist_fail_1_shift                       (25)
#define  NAG_KT_kt_bist_fail_nag_dma_drf_bist_fail_0_shift                       (24)
#define  NAG_KT_kt_bist_fail_nag_kt_drf_bist_fail_0_shift                        (16)
#define  NAG_KT_kt_bist_fail_nag_dma_bist_fail_1_shift                           (9)
#define  NAG_KT_kt_bist_fail_nag_dma_bist_fail_0_shift                           (8)
#define  NAG_KT_kt_bist_fail_nag_kt_bist_fail_0_shift                            (0)
#define  NAG_KT_kt_bist_fail_nag_dma_drf_bist_fail_1_mask                        (0x02000000)
#define  NAG_KT_kt_bist_fail_nag_dma_drf_bist_fail_0_mask                        (0x01000000)
#define  NAG_KT_kt_bist_fail_nag_kt_drf_bist_fail_0_mask                         (0x00010000)
#define  NAG_KT_kt_bist_fail_nag_dma_bist_fail_1_mask                            (0x00000200)
#define  NAG_KT_kt_bist_fail_nag_dma_bist_fail_0_mask                            (0x00000100)
#define  NAG_KT_kt_bist_fail_nag_kt_bist_fail_0_mask                             (0x00000001)
#define  NAG_KT_kt_bist_fail_nag_dma_drf_bist_fail_1(data)                       (0x02000000&((data)<<25))
#define  NAG_KT_kt_bist_fail_nag_dma_drf_bist_fail_0(data)                       (0x01000000&((data)<<24))
#define  NAG_KT_kt_bist_fail_nag_kt_drf_bist_fail_0(data)                        (0x00010000&((data)<<16))
#define  NAG_KT_kt_bist_fail_nag_dma_bist_fail_1(data)                           (0x00000200&((data)<<9))
#define  NAG_KT_kt_bist_fail_nag_dma_bist_fail_0(data)                           (0x00000100&((data)<<8))
#define  NAG_KT_kt_bist_fail_nag_kt_bist_fail_0(data)                            (0x00000001&(data))
#define  NAG_KT_kt_bist_fail_get_nag_dma_drf_bist_fail_1(data)                   ((0x02000000&(data))>>25)
#define  NAG_KT_kt_bist_fail_get_nag_dma_drf_bist_fail_0(data)                   ((0x01000000&(data))>>24)
#define  NAG_KT_kt_bist_fail_get_nag_kt_drf_bist_fail_0(data)                    ((0x00010000&(data))>>16)
#define  NAG_KT_kt_bist_fail_get_nag_dma_bist_fail_1(data)                       ((0x00000200&(data))>>9)
#define  NAG_KT_kt_bist_fail_get_nag_dma_bist_fail_0(data)                       ((0x00000100&(data))>>8)
#define  NAG_KT_kt_bist_fail_get_nag_kt_bist_fail_0(data)                        (0x00000001&(data))

#define  NAG_KT_rdma_ctrl                                                       0x1806C400
#define  NAG_KT_rdma_ctrl_reg_addr                                               "0xB806C400"
#define  NAG_KT_rdma_ctrl_reg                                                    0xB806C400
#define  NAG_KT_rdma_ctrl_inst_addr                                              "0x0044"
#define  set_NAG_KT_rdma_ctrl_reg(data)                                          (*((volatile unsigned int*)NAG_KT_rdma_ctrl_reg)=data)
#define  get_NAG_KT_rdma_ctrl_reg                                                (*((volatile unsigned int*)NAG_KT_rdma_ctrl_reg))
#define  NAG_KT_rdma_ctrl_rdma_force_all_rst_shift                               (31)
#define  NAG_KT_rdma_ctrl_rdma_max_outstanding_shift                             (8)
#define  NAG_KT_rdma_ctrl_rdma_burst_len_shift                                   (0)
#define  NAG_KT_rdma_ctrl_rdma_force_all_rst_mask                                (0x80000000)
#define  NAG_KT_rdma_ctrl_rdma_max_outstanding_mask                              (0x00000300)
#define  NAG_KT_rdma_ctrl_rdma_burst_len_mask                                    (0x000000FF)
#define  NAG_KT_rdma_ctrl_rdma_force_all_rst(data)                               (0x80000000&((data)<<31))
#define  NAG_KT_rdma_ctrl_rdma_max_outstanding(data)                             (0x00000300&((data)<<8))
#define  NAG_KT_rdma_ctrl_rdma_burst_len(data)                                   (0x000000FF&(data))
#define  NAG_KT_rdma_ctrl_get_rdma_force_all_rst(data)                           ((0x80000000&(data))>>31)
#define  NAG_KT_rdma_ctrl_get_rdma_max_outstanding(data)                         ((0x00000300&(data))>>8)
#define  NAG_KT_rdma_ctrl_get_rdma_burst_len(data)                               (0x000000FF&(data))

#define  NAG_KT_rdma_status                                                     0x1806C404
#define  NAG_KT_rdma_status_reg_addr                                             "0xB806C404"
#define  NAG_KT_rdma_status_reg                                                  0xB806C404
#define  NAG_KT_rdma_status_inst_addr                                            "0x0045"
#define  set_NAG_KT_rdma_status_reg(data)                                        (*((volatile unsigned int*)NAG_KT_rdma_status_reg)=data)
#define  get_NAG_KT_rdma_status_reg                                              (*((volatile unsigned int*)NAG_KT_rdma_status_reg))
#define  NAG_KT_rdma_status_rdma_zero_length_err_shift                           (16)
#define  NAG_KT_rdma_status_rdma_cur_outstanding_shift                           (12)
#define  NAG_KT_rdma_status_rdma_cmd_water_shift                                 (8)
#define  NAG_KT_rdma_status_rdma_data_water_shift                                (0)
#define  NAG_KT_rdma_status_rdma_zero_length_err_mask                            (0x00010000)
#define  NAG_KT_rdma_status_rdma_cur_outstanding_mask                            (0x00007000)
#define  NAG_KT_rdma_status_rdma_cmd_water_mask                                  (0x00000700)
#define  NAG_KT_rdma_status_rdma_data_water_mask                                 (0x0000007F)
#define  NAG_KT_rdma_status_rdma_zero_length_err(data)                           (0x00010000&((data)<<16))
#define  NAG_KT_rdma_status_rdma_cur_outstanding(data)                           (0x00007000&((data)<<12))
#define  NAG_KT_rdma_status_rdma_cmd_water(data)                                 (0x00000700&((data)<<8))
#define  NAG_KT_rdma_status_rdma_data_water(data)                                (0x0000007F&(data))
#define  NAG_KT_rdma_status_get_rdma_zero_length_err(data)                       ((0x00010000&(data))>>16)
#define  NAG_KT_rdma_status_get_rdma_cur_outstanding(data)                       ((0x00007000&(data))>>12)
#define  NAG_KT_rdma_status_get_rdma_cmd_water(data)                             ((0x00000700&(data))>>8)
#define  NAG_KT_rdma_status_get_rdma_data_water(data)                            (0x0000007F&(data))

#define  NAG_KT_wdma_ctrl                                                       0x1806C410
#define  NAG_KT_wdma_ctrl_reg_addr                                               "0xB806C410"
#define  NAG_KT_wdma_ctrl_reg                                                    0xB806C410
#define  NAG_KT_wdma_ctrl_inst_addr                                              "0x0046"
#define  set_NAG_KT_wdma_ctrl_reg(data)                                          (*((volatile unsigned int*)NAG_KT_wdma_ctrl_reg)=data)
#define  get_NAG_KT_wdma_ctrl_reg                                                (*((volatile unsigned int*)NAG_KT_wdma_ctrl_reg))
#define  NAG_KT_wdma_ctrl_wdma_force_all_rst_shift                               (31)
#define  NAG_KT_wdma_ctrl_wdma_burst_len_shift                                   (0)
#define  NAG_KT_wdma_ctrl_wdma_force_all_rst_mask                                (0x80000000)
#define  NAG_KT_wdma_ctrl_wdma_burst_len_mask                                    (0x000000FF)
#define  NAG_KT_wdma_ctrl_wdma_force_all_rst(data)                               (0x80000000&((data)<<31))
#define  NAG_KT_wdma_ctrl_wdma_burst_len(data)                                   (0x000000FF&(data))
#define  NAG_KT_wdma_ctrl_get_wdma_force_all_rst(data)                           ((0x80000000&(data))>>31)
#define  NAG_KT_wdma_ctrl_get_wdma_burst_len(data)                               (0x000000FF&(data))

#define  NAG_KT_wdma_status                                                     0x1806C414
#define  NAG_KT_wdma_status_reg_addr                                             "0xB806C414"
#define  NAG_KT_wdma_status_reg                                                  0xB806C414
#define  NAG_KT_wdma_status_inst_addr                                            "0x0047"
#define  set_NAG_KT_wdma_status_reg(data)                                        (*((volatile unsigned int*)NAG_KT_wdma_status_reg)=data)
#define  get_NAG_KT_wdma_status_reg                                              (*((volatile unsigned int*)NAG_KT_wdma_status_reg))
#define  NAG_KT_wdma_status_wdma_zero_length_err_shift                           (16)
#define  NAG_KT_wdma_status_wdma_cmd_water_shift                                 (8)
#define  NAG_KT_wdma_status_wdma_data_water_shift                                (0)
#define  NAG_KT_wdma_status_wdma_zero_length_err_mask                            (0x00010000)
#define  NAG_KT_wdma_status_wdma_cmd_water_mask                                  (0x00000700)
#define  NAG_KT_wdma_status_wdma_data_water_mask                                 (0x0000007F)
#define  NAG_KT_wdma_status_wdma_zero_length_err(data)                           (0x00010000&((data)<<16))
#define  NAG_KT_wdma_status_wdma_cmd_water(data)                                 (0x00000700&((data)<<8))
#define  NAG_KT_wdma_status_wdma_data_water(data)                                (0x0000007F&(data))
#define  NAG_KT_wdma_status_get_wdma_zero_length_err(data)                       ((0x00010000&(data))>>16)
#define  NAG_KT_wdma_status_get_wdma_cmd_water(data)                             ((0x00000700&(data))>>8)
#define  NAG_KT_wdma_status_get_wdma_data_water(data)                            (0x0000007F&(data))

#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======NAG_KT register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  kt_init:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  akl_init:1;
        RBus_UInt32  dsc_aeskp_init:1;
        RBus_UInt32  dsc_csa2kp_init:1;
    };
}nag_kt_nag_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dsc_status:32;
    };
}nag_kt_dsc_stat_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  otp_status:2;
    };
}nag_kt_otp_stat_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  akl_interrupt:1;
    };
}nag_kt_akl_int_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:10;
        RBus_UInt32  abnormal_clk_detected:1;
        RBus_UInt32  akl_clk_det_checking:1;
        RBus_UInt32  down_limit:8;
        RBus_UInt32  up_limit:8;
        RBus_UInt32  res2:3;
        RBus_UInt32  akl_clk_det_en:1;
    };
}nag_kt_clk_det_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  akl_wt_err:4;
        RBus_UInt32  dummy1806c920_27_6:22;
        RBus_UInt32  akl_key_attr:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  akl_wt_en:2;
    };
}nag_kt_kt_wr_akl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  akl_smp_uris_31_0:32;
    };
}nag_kt_kt_wr_uris_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:8;
        RBus_UInt32  akl_smp_uris_55_32:24;
    };
}nag_kt_kt_wr_uris_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  hkey_wt_en:1;
    };
}nag_kt_kt_wr_hkey_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  iv_hw_upt_en:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  iv_wt_en:1;
    };
}nag_kt_kt_wr_iv_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:17;
        RBus_UInt32  wt_addr_to_sram_2:7;
        RBus_UInt32  res2:1;
        RBus_UInt32  wt_addr_to_sram:7;
    };
}nag_kt_kt_wr_addr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  hkey_attr:2;
        RBus_UInt32  res2:3;
        RBus_UInt32  hkey_wt_en_kc:1;
    };
}nag_kt_kt_wr_hkey_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1806c140_31_8:24;
        RBus_UInt32  res1:2;
        RBus_UInt32  hkey_decrypt_en:1;
        RBus_UInt32  hkey_encrypt_en:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  hkey_algorithm:1;
    };
}nag_kt_kt_host_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hkey_iv_31_0:32;
    };
}nag_kt_kt_host_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hkey_iv_63_32:32;
    };
}nag_kt_kt_host_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hkey_iv_95_64:32;
    };
}nag_kt_kt_host_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hkey_iv_127_96:32;
    };
}nag_kt_kt_host_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  iv_upt_index:7;
    };
}nag_kt_iv_upt_idx_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  iv_nxt_31_0:32;
    };
}nag_kt_iv_upt_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  iv_nxt_63_32:32;
    };
}nag_kt_iv_upt_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  iv_nxt_95_64:32;
    };
}nag_kt_iv_upt_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  iv_nxt_127_96:32;
    };
}nag_kt_iv_upt_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:15;
        RBus_UInt32  copy_en:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  to_addr:7;
        RBus_UInt32  res3:1;
        RBus_UInt32  from_addr:7;
    };
}nag_kt_kt_cp_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:18;
        RBus_UInt32  kt_status_iv_upt:1;
        RBus_UInt32  kt_status_busy:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  kt_status_sel:7;
        RBus_UInt32  res3:3;
        RBus_UInt32  key_table_idle:1;
    };
}nag_kt_kt_index_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:15;
        RBus_UInt32  key_chk_status_m2m:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  key_chk_status_tp:5;
        RBus_UInt32  res3:2;
        RBus_UInt32  key_error_int_en:1;
        RBus_UInt32  key_error:1;
    };
}nag_kt_key_chk_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  m2m_busy_kc:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  m2m_go_kc:1;
    };
}nag_kt_dma_ctrl_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  m2m_key_index_kc:7;
        RBus_UInt32  m2m_aes_mode_kc:4;
        RBus_UInt32  res2:3;
        RBus_UInt32  m2m_encrypt_en_kc:1;
        RBus_UInt32  res3:3;
        RBus_UInt32  m2m_key_len_kc:1;
        RBus_UInt32  res4:3;
        RBus_UInt32  m2m_algorithm_kc:1;
        RBus_UInt32  res5:2;
        RBus_UInt32  m2m_wr_region_kc:2;
        RBus_UInt32  res6:2;
        RBus_UInt32  m2m_rd_region_kc:2;
    };
}nag_kt_dma_set_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_rd_addr_kc:32;
    };
}nag_kt_dma_rd_adr_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_wr_addr_kc:32;
    };
}nag_kt_dma_wr_adr_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_rd_total_len_kc:32;
    };
}nag_kt_dma_rd_len_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_wr_total_len_kc:32;
    };
}nag_kt_dma_wr_len_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_pkt_len_kc:32;
    };
}nag_kt_dma_dsc_len_0_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_msc_len_kc:32;
    };
}nag_kt_dma_dsc_len_1_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_aes_crypt_byte_cnt_kc:32;
    };
}nag_kt_dma_aes_cfg_0_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_aes_skip_byte_cnt_kc:32;
    };
}nag_kt_dma_aes_cfg_1_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_aes_gcm_len_al_kc:32;
    };
}nag_kt_dma_aes_gcm_0_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_aes_gcm_len_ah_kc:32;
    };
}nag_kt_dma_aes_gcm_1_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_aes_gcm_len_ivl_kc:32;
    };
}nag_kt_dma_aes_gcm_2_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_aes_gcm_len_ivh_kc:32;
    };
}nag_kt_dma_aes_gcm_3_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_aes_gcm_len_cl_kc:32;
    };
}nag_kt_dma_aes_gcm_4_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_aes_gcm_len_ch_kc:32;
    };
}nag_kt_dma_aes_gcm_5_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  m2m_aes_gcm_len_t_kc:7;
    };
}nag_kt_dma_aes_gcm_6_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  m2m_aes_gcm_err_kc:1;
    };
}nag_kt_dma_aes_gcm_7_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  m2m_kcpu_int:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  m2m_kcpu_int_en:1;
    };
}nag_kt_dma_int_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  m2m_busy_sc:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  m2m_go_sc:1;
    };
}nag_kt_dma_ctrl_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  smp_decrypt_en:1;
        RBus_UInt32  smp_encrypt_en:1;
    };
}nag_kt_dma_ctrl_sc_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  m2m_key_index_sc:7;
        RBus_UInt32  m2m_aes_mode_sc:4;
        RBus_UInt32  res2:3;
        RBus_UInt32  m2m_encrypt_en_sc:1;
        RBus_UInt32  res3:3;
        RBus_UInt32  m2m_key_len_sc:1;
        RBus_UInt32  res4:3;
        RBus_UInt32  m2m_algorithm_sc:1;
        RBus_UInt32  res5:3;
        RBus_UInt32  m2m_wr_region_sc:1;
        RBus_UInt32  res6:3;
        RBus_UInt32  m2m_rd_region_sc:1;
    };
}nag_kt_dma_set_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_rd_addr_sc:32;
    };
}nag_kt_dma_rd_adr_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_wr_addr_sc:32;
    };
}nag_kt_dma_wr_adr_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_rd_total_len_sc:32;
    };
}nag_kt_dma_rd_len_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_wr_total_len_sc:32;
    };
}nag_kt_dma_wr_len_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_pkt_len_sc:32;
    };
}nag_kt_dma_dsc_len_0_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_msc_len_sc:32;
    };
}nag_kt_dma_dsc_len_1_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_aes_crypt_byte_cnt_sc:32;
    };
}nag_kt_dma_aes_cfg_0_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_aes_skip_byte_cnt_sc:32;
    };
}nag_kt_dma_aes_cfg_1_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_aes_gcm_len_al_sc:32;
    };
}nag_kt_dma_aes_gcm_0_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_aes_gcm_len_ah_sc:32;
    };
}nag_kt_dma_aes_gcm_1_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_aes_gcm_len_ivl_sc:32;
    };
}nag_kt_dma_aes_gcm_2_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_aes_gcm_len_ivh_sc:32;
    };
}nag_kt_dma_aes_gcm_3_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_aes_gcm_len_cl_sc:32;
    };
}nag_kt_dma_aes_gcm_4_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_aes_gcm_len_ch_sc:32;
    };
}nag_kt_dma_aes_gcm_5_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  m2m_aes_gcm_len_t_sc:7;
    };
}nag_kt_dma_aes_gcm_6_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  m2m_aes_gcm_err_sc:1;
    };
}nag_kt_dma_aes_gcm_7_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  m2m_scpu_int:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  m2m_scpu_int_en:1;
    };
}nag_kt_dma_int_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:21;
        RBus_UInt32  nag_dma_drf_test_resume:1;
        RBus_UInt32  nag_mem_drf_test_resume:1;
        RBus_UInt32  nag_kt_drf_test_resume:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  nag_dma_drf_bist_mode:1;
        RBus_UInt32  nag_mem_drf_bist_mode:1;
        RBus_UInt32  nag_kt_drf_bist_mode:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  nag_dma_bist_mode:1;
        RBus_UInt32  nag_mem_bist_mode:1;
        RBus_UInt32  nag_kt_bist_mode:1;
    };
}nag_kt_kt_bist_mode_resume_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  nag_dma_testrwm:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  nag_dma_test1:1;
        RBus_UInt32  nag_mem_test1:1;
        RBus_UInt32  nag_kt_test1:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  nag_dma_rme:1;
        RBus_UInt32  nag_mem_rme:1;
        RBus_UInt32  nag_kt_rme:1;
        RBus_UInt32  res4:4;
        RBus_UInt32  nag_dma_rm:4;
        RBus_UInt32  nag_mem_rm:4;
        RBus_UInt32  nag_kt_rm:4;
        RBus_UInt32  res5:1;
        RBus_UInt32  nag_dma_ls:1;
        RBus_UInt32  nag_mem_ls:1;
        RBus_UInt32  nag_kt_ls:1;
    };
}nag_kt_kt_bist_ls_rm_rme_test1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:13;
        RBus_UInt32  nag_dma_drf_bist_fail_grp:1;
        RBus_UInt32  nag_mem_drf_bist_fail:1;
        RBus_UInt32  nag_kt_drf_bist_fail_grp:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  nag_dma_bist_fail_grp:1;
        RBus_UInt32  nag_mem_bist_fail:1;
        RBus_UInt32  nag_kt_bist_fail_grp:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  nag_dma_drf_start_pause:1;
        RBus_UInt32  nag_mem_drf_start_pause:1;
        RBus_UInt32  nag_kt_drf_start_pause:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  nag_dma_drf_bist_done:1;
        RBus_UInt32  nag_mem_drf_bist_done:1;
        RBus_UInt32  nag_kt_drf_bist_done:1;
        RBus_UInt32  res5:1;
        RBus_UInt32  nag_dma_bist_done:1;
        RBus_UInt32  nag_mem_bist_done:1;
        RBus_UInt32  nag_kt_bist_done:1;
    };
}nag_kt_kt_bist_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  nag_dma_drf_bist_fail_1:1;
        RBus_UInt32  nag_dma_drf_bist_fail_0:1;
        RBus_UInt32  res2:7;
        RBus_UInt32  nag_kt_drf_bist_fail_0:1;
        RBus_UInt32  res3:6;
        RBus_UInt32  nag_dma_bist_fail_1:1;
        RBus_UInt32  nag_dma_bist_fail_0:1;
        RBus_UInt32  res4:7;
        RBus_UInt32  nag_kt_bist_fail_0:1;
    };
}nag_kt_kt_bist_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rdma_force_all_rst:1;
        RBus_UInt32  res1:21;
        RBus_UInt32  rdma_max_outstanding:2;
        RBus_UInt32  rdma_burst_len:8;
    };
}nag_kt_rdma_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:15;
        RBus_UInt32  rdma_zero_length_err:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  rdma_cur_outstanding:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  rdma_cmd_water:3;
        RBus_UInt32  res4:1;
        RBus_UInt32  rdma_data_water:7;
    };
}nag_kt_rdma_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  wdma_force_all_rst:1;
        RBus_UInt32  res1:23;
        RBus_UInt32  wdma_burst_len:8;
    };
}nag_kt_wdma_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:15;
        RBus_UInt32  wdma_zero_length_err:1;
        RBus_UInt32  res2:5;
        RBus_UInt32  wdma_cmd_water:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  wdma_data_water:7;
    };
}nag_kt_wdma_status_RBUS;

#else //apply LITTLE_ENDIAN

//======NAG_KT register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dsc_csa2kp_init:1;
        RBus_UInt32  dsc_aeskp_init:1;
        RBus_UInt32  akl_init:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  kt_init:1;
        RBus_UInt32  res2:26;
    };
}nag_kt_nag_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dsc_status:32;
    };
}nag_kt_dsc_stat_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  otp_status:2;
        RBus_UInt32  res1:30;
    };
}nag_kt_otp_stat_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  akl_interrupt:1;
        RBus_UInt32  res1:31;
    };
}nag_kt_akl_int_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  akl_clk_det_en:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  up_limit:8;
        RBus_UInt32  down_limit:8;
        RBus_UInt32  akl_clk_det_checking:1;
        RBus_UInt32  abnormal_clk_detected:1;
        RBus_UInt32  res2:10;
    };
}nag_kt_clk_det_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  akl_wt_en:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  akl_key_attr:2;
        RBus_UInt32  dummy1806c920_27_6:22;
        RBus_UInt32  akl_wt_err:4;
    };
}nag_kt_kt_wr_akl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  akl_smp_uris_31_0:32;
    };
}nag_kt_kt_wr_uris_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  akl_smp_uris_55_32:24;
        RBus_UInt32  res1:8;
    };
}nag_kt_kt_wr_uris_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hkey_wt_en:1;
        RBus_UInt32  res1:31;
    };
}nag_kt_kt_wr_hkey_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  iv_wt_en:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  iv_hw_upt_en:1;
        RBus_UInt32  res2:27;
    };
}nag_kt_kt_wr_iv_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  wt_addr_to_sram:7;
        RBus_UInt32  res1:1;
        RBus_UInt32  wt_addr_to_sram_2:7;
        RBus_UInt32  res2:17;
    };
}nag_kt_kt_wr_addr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hkey_wt_en_kc:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  hkey_attr:2;
        RBus_UInt32  res2:26;
    };
}nag_kt_kt_wr_hkey_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hkey_algorithm:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  hkey_encrypt_en:1;
        RBus_UInt32  hkey_decrypt_en:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  dummy1806c140_31_8:24;
    };
}nag_kt_kt_host_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hkey_iv_31_0:32;
    };
}nag_kt_kt_host_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hkey_iv_63_32:32;
    };
}nag_kt_kt_host_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hkey_iv_95_64:32;
    };
}nag_kt_kt_host_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hkey_iv_127_96:32;
    };
}nag_kt_kt_host_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  iv_upt_index:7;
        RBus_UInt32  res1:25;
    };
}nag_kt_iv_upt_idx_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  iv_nxt_31_0:32;
    };
}nag_kt_iv_upt_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  iv_nxt_63_32:32;
    };
}nag_kt_iv_upt_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  iv_nxt_95_64:32;
    };
}nag_kt_iv_upt_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  iv_nxt_127_96:32;
    };
}nag_kt_iv_upt_3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  from_addr:7;
        RBus_UInt32  res1:1;
        RBus_UInt32  to_addr:7;
        RBus_UInt32  res2:1;
        RBus_UInt32  copy_en:1;
        RBus_UInt32  res3:15;
    };
}nag_kt_kt_cp_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  key_table_idle:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  kt_status_sel:7;
        RBus_UInt32  res2:1;
        RBus_UInt32  kt_status_busy:1;
        RBus_UInt32  kt_status_iv_upt:1;
        RBus_UInt32  res3:18;
    };
}nag_kt_kt_index_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  key_error:1;
        RBus_UInt32  key_error_int_en:1;
        RBus_UInt32  res1:2;
        RBus_UInt32  key_chk_status_tp:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  key_chk_status_m2m:5;
        RBus_UInt32  res3:15;
    };
}nag_kt_key_chk_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_go_kc:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  m2m_busy_kc:1;
        RBus_UInt32  res2:27;
    };
}nag_kt_dma_ctrl_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_rd_region_kc:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  m2m_wr_region_kc:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  m2m_algorithm_kc:1;
        RBus_UInt32  res3:3;
        RBus_UInt32  m2m_key_len_kc:1;
        RBus_UInt32  res4:3;
        RBus_UInt32  m2m_encrypt_en_kc:1;
        RBus_UInt32  res5:3;
        RBus_UInt32  m2m_aes_mode_kc:4;
        RBus_UInt32  m2m_key_index_kc:7;
        RBus_UInt32  res6:1;
    };
}nag_kt_dma_set_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_rd_addr_kc:32;
    };
}nag_kt_dma_rd_adr_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_wr_addr_kc:32;
    };
}nag_kt_dma_wr_adr_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_rd_total_len_kc:32;
    };
}nag_kt_dma_rd_len_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_wr_total_len_kc:32;
    };
}nag_kt_dma_wr_len_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_pkt_len_kc:32;
    };
}nag_kt_dma_dsc_len_0_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_msc_len_kc:32;
    };
}nag_kt_dma_dsc_len_1_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_aes_crypt_byte_cnt_kc:32;
    };
}nag_kt_dma_aes_cfg_0_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_aes_skip_byte_cnt_kc:32;
    };
}nag_kt_dma_aes_cfg_1_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_aes_gcm_len_al_kc:32;
    };
}nag_kt_dma_aes_gcm_0_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_aes_gcm_len_ah_kc:32;
    };
}nag_kt_dma_aes_gcm_1_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_aes_gcm_len_ivl_kc:32;
    };
}nag_kt_dma_aes_gcm_2_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_aes_gcm_len_ivh_kc:32;
    };
}nag_kt_dma_aes_gcm_3_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_aes_gcm_len_cl_kc:32;
    };
}nag_kt_dma_aes_gcm_4_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_aes_gcm_len_ch_kc:32;
    };
}nag_kt_dma_aes_gcm_5_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_aes_gcm_len_t_kc:7;
        RBus_UInt32  res1:25;
    };
}nag_kt_dma_aes_gcm_6_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_aes_gcm_err_kc:1;
        RBus_UInt32  res1:31;
    };
}nag_kt_dma_aes_gcm_7_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_kcpu_int_en:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  m2m_kcpu_int:1;
        RBus_UInt32  res2:27;
    };
}nag_kt_dma_int_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_go_sc:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  m2m_busy_sc:1;
        RBus_UInt32  res2:27;
    };
}nag_kt_dma_ctrl_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  smp_encrypt_en:1;
        RBus_UInt32  smp_decrypt_en:1;
        RBus_UInt32  res1:30;
    };
}nag_kt_dma_ctrl_sc_kc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_rd_region_sc:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  m2m_wr_region_sc:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  m2m_algorithm_sc:1;
        RBus_UInt32  res3:3;
        RBus_UInt32  m2m_key_len_sc:1;
        RBus_UInt32  res4:3;
        RBus_UInt32  m2m_encrypt_en_sc:1;
        RBus_UInt32  res5:3;
        RBus_UInt32  m2m_aes_mode_sc:4;
        RBus_UInt32  m2m_key_index_sc:7;
        RBus_UInt32  res6:1;
    };
}nag_kt_dma_set_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_rd_addr_sc:32;
    };
}nag_kt_dma_rd_adr_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_wr_addr_sc:32;
    };
}nag_kt_dma_wr_adr_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_rd_total_len_sc:32;
    };
}nag_kt_dma_rd_len_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_wr_total_len_sc:32;
    };
}nag_kt_dma_wr_len_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_pkt_len_sc:32;
    };
}nag_kt_dma_dsc_len_0_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_msc_len_sc:32;
    };
}nag_kt_dma_dsc_len_1_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_aes_crypt_byte_cnt_sc:32;
    };
}nag_kt_dma_aes_cfg_0_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_aes_skip_byte_cnt_sc:32;
    };
}nag_kt_dma_aes_cfg_1_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_aes_gcm_len_al_sc:32;
    };
}nag_kt_dma_aes_gcm_0_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_aes_gcm_len_ah_sc:32;
    };
}nag_kt_dma_aes_gcm_1_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_aes_gcm_len_ivl_sc:32;
    };
}nag_kt_dma_aes_gcm_2_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_aes_gcm_len_ivh_sc:32;
    };
}nag_kt_dma_aes_gcm_3_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_aes_gcm_len_cl_sc:32;
    };
}nag_kt_dma_aes_gcm_4_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_aes_gcm_len_ch_sc:32;
    };
}nag_kt_dma_aes_gcm_5_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_aes_gcm_len_t_sc:7;
        RBus_UInt32  res1:25;
    };
}nag_kt_dma_aes_gcm_6_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_aes_gcm_err_sc:1;
        RBus_UInt32  res1:31;
    };
}nag_kt_dma_aes_gcm_7_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  m2m_scpu_int_en:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  m2m_scpu_int:1;
        RBus_UInt32  res2:27;
    };
}nag_kt_dma_int_sc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  nag_kt_bist_mode:1;
        RBus_UInt32  nag_mem_bist_mode:1;
        RBus_UInt32  nag_dma_bist_mode:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  nag_kt_drf_bist_mode:1;
        RBus_UInt32  nag_mem_drf_bist_mode:1;
        RBus_UInt32  nag_dma_drf_bist_mode:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  nag_kt_drf_test_resume:1;
        RBus_UInt32  nag_mem_drf_test_resume:1;
        RBus_UInt32  nag_dma_drf_test_resume:1;
        RBus_UInt32  res3:21;
    };
}nag_kt_kt_bist_mode_resume_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  nag_kt_ls:1;
        RBus_UInt32  nag_mem_ls:1;
        RBus_UInt32  nag_dma_ls:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  nag_kt_rm:4;
        RBus_UInt32  nag_mem_rm:4;
        RBus_UInt32  nag_dma_rm:4;
        RBus_UInt32  res2:4;
        RBus_UInt32  nag_kt_rme:1;
        RBus_UInt32  nag_mem_rme:1;
        RBus_UInt32  nag_dma_rme:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  nag_kt_test1:1;
        RBus_UInt32  nag_mem_test1:1;
        RBus_UInt32  nag_dma_test1:1;
        RBus_UInt32  res4:3;
        RBus_UInt32  nag_dma_testrwm:1;
        RBus_UInt32  res5:1;
    };
}nag_kt_kt_bist_ls_rm_rme_test1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  nag_kt_bist_done:1;
        RBus_UInt32  nag_mem_bist_done:1;
        RBus_UInt32  nag_dma_bist_done:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  nag_kt_drf_bist_done:1;
        RBus_UInt32  nag_mem_drf_bist_done:1;
        RBus_UInt32  nag_dma_drf_bist_done:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  nag_kt_drf_start_pause:1;
        RBus_UInt32  nag_mem_drf_start_pause:1;
        RBus_UInt32  nag_dma_drf_start_pause:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  nag_kt_bist_fail_grp:1;
        RBus_UInt32  nag_mem_bist_fail:1;
        RBus_UInt32  nag_dma_bist_fail_grp:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  nag_kt_drf_bist_fail_grp:1;
        RBus_UInt32  nag_mem_drf_bist_fail:1;
        RBus_UInt32  nag_dma_drf_bist_fail_grp:1;
        RBus_UInt32  res5:13;
    };
}nag_kt_kt_bist_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  nag_kt_bist_fail_0:1;
        RBus_UInt32  res1:7;
        RBus_UInt32  nag_dma_bist_fail_0:1;
        RBus_UInt32  nag_dma_bist_fail_1:1;
        RBus_UInt32  res2:6;
        RBus_UInt32  nag_kt_drf_bist_fail_0:1;
        RBus_UInt32  res3:7;
        RBus_UInt32  nag_dma_drf_bist_fail_0:1;
        RBus_UInt32  nag_dma_drf_bist_fail_1:1;
        RBus_UInt32  res4:6;
    };
}nag_kt_kt_bist_fail_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rdma_burst_len:8;
        RBus_UInt32  rdma_max_outstanding:2;
        RBus_UInt32  res1:21;
        RBus_UInt32  rdma_force_all_rst:1;
    };
}nag_kt_rdma_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rdma_data_water:7;
        RBus_UInt32  res1:1;
        RBus_UInt32  rdma_cmd_water:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  rdma_cur_outstanding:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  rdma_zero_length_err:1;
        RBus_UInt32  res4:15;
    };
}nag_kt_rdma_status_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  wdma_burst_len:8;
        RBus_UInt32  res1:23;
        RBus_UInt32  wdma_force_all_rst:1;
    };
}nag_kt_wdma_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  wdma_data_water:7;
        RBus_UInt32  res1:1;
        RBus_UInt32  wdma_cmd_water:3;
        RBus_UInt32  res2:5;
        RBus_UInt32  wdma_zero_length_err:1;
        RBus_UInt32  res3:15;
    };
}nag_kt_wdma_status_RBUS;




#endif 


#endif 
