/**************************************************************
// Spec Version                  : 0.9
// Parser Version                : DVR_Parser_6.8(110516)
// CModelGen Version             : 5.0 2009.04.09
// Naming Rule                   :  Module_Register_Name
// Naming Rule                   : Module_Register_Name_reg
// Parse Option                  : Only Parse _op1
// Parse Address Region          : All Address Region 
// Decode bit number             : 12 bits
// Firmware Header Generate Date : 2014-5-16 9:17:37
***************************************************************/


#ifndef _MHL_REG_H_INCLUDED_
#define _MHL_REG_H_INCLUDED_
#ifdef  _MHL_USE_STRUCT
typedef struct 
{
unsigned int     enable:1;
unsigned int     irq_en_8051:1;
unsigned int     irq_en_scpu:1;
unsigned int     cbus_multi_sync:1;
unsigned int     reserved_0:16;
unsigned int     mhl_clk_ns:12;
}MHL_CBUS;

typedef struct 
{
unsigned int     reserved_0:1;
unsigned int     r1k_fw_mode:1;
unsigned int     r1k_fw_value:1;
unsigned int     bypass_discov:1;
unsigned int     tsrc_float:8;
unsigned int     rxsense_fw_mode:1;
unsigned int     rxsense_fw_value:1;
unsigned int     tsrc_stable:10;
unsigned int     trxsense_deglitch:8;
}MHL_CBUS_DIS0;

typedef struct 
{
unsigned int     both_path_en:1;
unsigned int     trxsense_chk:9;
unsigned int     tsrc_wake_width1:5;
unsigned int     tsrc_wake_width2:7;
unsigned int     tsrc_wake_to_discov:10;
}MHL_CBUS_DIS1;

typedef struct 
{
unsigned int     reserved_0:5;
unsigned int     tsrc_pulse_width:7;
unsigned int     tsrc_conn:8;
unsigned int     reserved_1:2;
unsigned int     tsrc_arbitrate:10;
}MHL_CBUS_DIS2;

typedef struct 
{
unsigned int     tsink_float:8;
unsigned int     reserved_0:2;
unsigned int     drive_wake_pulse_low_en:1;
unsigned int     discovery_check_sink_start:5;
unsigned int     reserved_1:3;
unsigned int     max_discovery_pulse_count:5;
unsigned int     reserved_2:3;
unsigned int     irq_en_src6_7:1;
unsigned int     irq_en_src3_4:1;
unsigned int     irq_en_tmds_off:1;
unsigned int     irq_en_tmds_out:1;
unsigned int     discov_standby:1;
}MHL_CBUS_DIS3;

typedef struct 
{
unsigned int     reserved_0:1;
unsigned int     src0:1;
unsigned int     src1:1;
unsigned int     src2:1;
unsigned int     src3_00:1;
unsigned int     src3_01:1;
unsigned int     src3_02:1;
unsigned int     src3_03:1;
unsigned int     src3_04:1;
unsigned int     src3_05:1;
unsigned int     src3_06:1;
unsigned int     src3_07:1;
unsigned int     src3_08:1;
unsigned int     src3_09:1;
unsigned int     src3_10:1;
unsigned int     reserved_1:1;
unsigned int     src4:1;
unsigned int     src5:1;
unsigned int     src6:1;
unsigned int     src7:1;
unsigned int     reserved_2:7;
unsigned int     irq_src6_7:1;
unsigned int     irq_src3_4:1;
unsigned int     irq_tmds_off:1;
unsigned int     irq_tmds_out:1;
unsigned int     reserved_3:1;
}MHL_CBUS_DIS4;

typedef struct 
{
unsigned int     Dmy:32;
}MHL_CBUS_DIS5;

typedef struct 
{
unsigned int     Dmy:32;
}MHL_CBUS_PHY0;

typedef struct 
{
unsigned int     reserved_0:19;
unsigned int     CBUS_DATA_TX:1;
unsigned int     HDMI_HPD_OUT_TX:1;
unsigned int     REGO_MHL_HPD_DET_TX:1;
unsigned int     REGO_MHL_R1K_DET_TX:1;
unsigned int     TEST_OUT:5;
unsigned int     DATA_IN_TX:1;
unsigned int     CBUS_EN_TX:1;
unsigned int     EN_R10K_TX:2;
}MHL_CBUS_PHY1;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     dev_state:8;
}MHL_MSC_REG_00;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     mhl_ver:8;
}MHL_MSC_REG_01;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     dev_cat:1;
unsigned int     plim:2;
unsigned int     pow:1;
unsigned int     dev_type:4;
}MHL_MSC_REG_02;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     adop_id_h:8;
}MHL_MSC_REG_03;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     adop_id_l:8;
}MHL_MSC_REG_04;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     vid_link_mode:2;
unsigned int     supp_vga:1;
unsigned int     supp_islands:1;
unsigned int     supp_ppixel:1;
unsigned int     supp_yuv422:1;
unsigned int     supp_yuv444:1;
unsigned int     supp_rgb444:1;
}MHL_MSC_REG_05;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     aud_link_mode:6;
unsigned int     aud_8ch:1;
unsigned int     aud_2ch:1;
}MHL_MSC_REG_06;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     supp_vt:1;
unsigned int     video_type:3;
unsigned int     vt_game:1;
unsigned int     vt_cinema:1;
unsigned int     vt_photo:1;
unsigned int     vt_graphics:1;
}MHL_MSC_REG_07;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     ld_gui:1;
unsigned int     ld_speaker:1;
unsigned int     ld_record:1;
unsigned int     ld_tuner:1;
unsigned int     ld_media:1;
unsigned int     ld_audio:1;
unsigned int     ld_video:1;
unsigned int     ld_display:1;
}MHL_MSC_REG_08;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     bandwid:8;
}MHL_MSC_REG_09;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     feature_flag:3;
unsigned int     ucp_recv_supp:1;
unsigned int     ucp_send_supp:1;
unsigned int     sp_supp:1;
unsigned int     rap_supp:1;
unsigned int     rcp_supp:1;
}MHL_MSC_REG_0A;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     device_id_h:8;
}MHL_MSC_REG_0B;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     device_id_l:8;
}MHL_MSC_REG_0C;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     scr_size:8;
}MHL_MSC_REG_0D;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     stat_size:4;
unsigned int     int_size:4;
}MHL_MSC_REG_0E;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     cap_0f:8;
}MHL_MSC_REG_0F;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     rchg_int:3;
unsigned int     3d_req:1;
unsigned int     grt_wrt:1;
unsigned int     req_wrt:1;
unsigned int     dscr_chg:1;
unsigned int     dcap_chg:1;
}MHL_MSC_REG_20;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     dchg_int_7:1;
unsigned int     dchg_int_6:1;
unsigned int     dchg_int_5:1;
unsigned int     dchg_int_4:1;
unsigned int     dchg_int_3:1;
unsigned int     dchg_int_2:1;
unsigned int     edid_chg:1;
unsigned int     dchg_int_0:1;
}MHL_MSC_REG_21;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     chg22_7:1;
unsigned int     chg22_6:1;
unsigned int     chg22_5:1;
unsigned int     chg22_4:1;
unsigned int     chg22_3:1;
unsigned int     chg22_2:1;
unsigned int     chg22_1:1;
unsigned int     chg22_0:1;
}MHL_MSC_REG_22;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     chg23_7:1;
unsigned int     chg23_6:1;
unsigned int     chg23_5:1;
unsigned int     chg23_4:1;
unsigned int     chg23_3:1;
unsigned int     chg23_2:1;
unsigned int     chg23_1:1;
unsigned int     chg23_0:1;
}MHL_MSC_REG_23;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     chg24_7:1;
unsigned int     chg24_6:1;
unsigned int     chg24_5:1;
unsigned int     chg24_4:1;
unsigned int     chg24_3:1;
unsigned int     chg24_2:1;
unsigned int     chg24_1:1;
unsigned int     chg24_0:1;
}MHL_MSC_REG_24;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     chg25_7:1;
unsigned int     chg25_6:1;
unsigned int     chg25_5:1;
unsigned int     chg25_4:1;
unsigned int     chg25_3:1;
unsigned int     chg25_2:1;
unsigned int     chg25_1:1;
unsigned int     chg25_0:1;
}MHL_MSC_REG_25;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     chg26_7:1;
unsigned int     chg26_6:1;
unsigned int     chg26_5:1;
unsigned int     chg26_4:1;
unsigned int     chg26_3:1;
unsigned int     chg26_2:1;
unsigned int     chg26_1:1;
unsigned int     chg26_0:1;
}MHL_MSC_REG_26;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     chg27_7:1;
unsigned int     chg27_6:1;
unsigned int     chg27_5:1;
unsigned int     chg27_4:1;
unsigned int     chg27_3:1;
unsigned int     chg27_2:1;
unsigned int     chg27_1:1;
unsigned int     chg27_0:1;
}MHL_MSC_REG_27;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     connected_rdy:7;
unsigned int     dcap_rdy:1;
}MHL_MSC_REG_30;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     link_mode:3;
unsigned int     reserved_1:1;
unsigned int     path_en:1;
unsigned int     reserved_2:3;
}MHL_MSC_REG_31;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     stat_32:8;
}MHL_MSC_REG_32;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     stat_33:8;
}MHL_MSC_REG_33;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     stat_34:8;
}MHL_MSC_REG_34;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     stat_35:8;
}MHL_MSC_REG_35;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     stat_36:8;
}MHL_MSC_REG_36;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     stat_37:8;
}MHL_MSC_REG_37;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     scratch_40:8;
}MHL_MSC_REG_40;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     scratch_41:8;
}MHL_MSC_REG_41;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     scratch_42:8;
}MHL_MSC_REG_42;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     scratch_43:8;
}MHL_MSC_REG_43;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     scratch_44:8;
}MHL_MSC_REG_44;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     scratch_45:8;
}MHL_MSC_REG_45;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     scratch_46:8;
}MHL_MSC_REG_46;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     scratch_47:8;
}MHL_MSC_REG_47;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     scratch_48:8;
}MHL_MSC_REG_48;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     scratch_49:8;
}MHL_MSC_REG_49;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     scratch_4A:8;
}MHL_MSC_REG_4A;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     scratch_4B:8;
}MHL_MSC_REG_4B;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     scratch_4C:8;
}MHL_MSC_REG_4C;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     scratch_4D:8;
}MHL_MSC_REG_4D;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     scratch_4E:8;
}MHL_MSC_REG_4E;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     scratch_4F:8;
}MHL_MSC_REG_4F;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     scratch_50:8;
}MHL_MSC_REG_50;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     scratch_51:8;
}MHL_MSC_REG_51;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     scratch_52:8;
}MHL_MSC_REG_52;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     scratch_53:8;
}MHL_MSC_REG_53;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     scratch_54:8;
}MHL_MSC_REG_54;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     scratch_55:8;
}MHL_MSC_REG_55;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     scratch_56:8;
}MHL_MSC_REG_56;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     scratch_57:8;
}MHL_MSC_REG_57;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     scratch_58:8;
}MHL_MSC_REG_58;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     scratch_59:8;
}MHL_MSC_REG_59;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     scratch_5A:8;
}MHL_MSC_REG_5A;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     scratch_5B:8;
}MHL_MSC_REG_5B;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     scratch_5C:8;
}MHL_MSC_REG_5C;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     scratch_5D:8;
}MHL_MSC_REG_5D;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     scratch_5E:8;
}MHL_MSC_REG_5E;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     scratch_5F:8;
}MHL_MSC_REG_5F;

typedef struct 
{
unsigned int     reserved_0:11;
unsigned int     sync0_hb:9;
unsigned int     reserved_1:3;
unsigned int     sync0_lb:9;
}MHL_CBUS_LINK_00;

typedef struct 
{
unsigned int     reserved_0:16;
unsigned int     sync1_hb:8;
unsigned int     sync1_lb:8;
}MHL_CBUS_LINK_01;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     sync_bit_time:8;
}MHL_CBUS_LINK_02;

typedef struct 
{
unsigned int     reserved_0:23;
unsigned int     abs_thres_en:1;
unsigned int     abs_threshold:8;
}MHL_CBUS_LINK_03;

typedef struct 
{
unsigned int     reserved_0:32;
}MHL_CBUS_LINK_04;

typedef struct 
{
unsigned int     reserved_0:25;
unsigned int     irq_en_parity_fail:1;
unsigned int     ctrl_16_resv:1;
unsigned int     parity_fail_limit:5;
}MHL_CBUS_LINK_05;

typedef struct 
{
unsigned int     reserved_0:25;
unsigned int     ack_fall:7;
}MHL_CBUS_LINK_06;

typedef struct 
{
unsigned int     reserved_0:25;
unsigned int     ack_0:7;
}MHL_CBUS_LINK_07;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     irq_parity_fail:1;
unsigned int     reserved_1:7;
}MHL_CBUS_LINK_08;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     tx_bit_time:8;
}MHL_CBUS_LINK_09;

typedef struct 
{
unsigned int     reserved_0:32;
}MHL_CBUS_LINK_0A;

typedef struct 
{
unsigned int     reserved_0:25;
unsigned int     tx_ack_fal:7;
}MHL_CBUS_LINK_0B;

typedef struct 
{
unsigned int     reserved_0:25;
unsigned int     tx_ack_low_hb:7;
}MHL_CBUS_LINK_0C;

typedef struct 
{
unsigned int     reserved_0:25;
unsigned int     tx_ack_low_lb:7;
}MHL_CBUS_LINK_0D;

typedef struct 
{
unsigned int     reserved_0:17;
unsigned int     retry_lv:7;
unsigned int     reserved_1:2;
unsigned int     irq_en_retry_ddc:1;
unsigned int     irq_en_retry_msc:1;
unsigned int     Dmy:4;
}MHL_CBUS_LINK_0E;

typedef struct 
{
unsigned int     reserved_0:19;
unsigned int     drv_str:5;
unsigned int     reserved_1:2;
unsigned int     drv_hi_cbus:6;
}MHL_CBUS_LINK_0F;

typedef struct 
{
unsigned int     reserved_0:28;
unsigned int     wait:4;
}MHL_CBUS_LINK_10;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     req_opp:8;
}MHL_CBUS_LINK_11;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     req_cont:8;
}MHL_CBUS_LINK_12;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     req_hold:4;
unsigned int     resp_hold:4;
}MHL_CBUS_LINK_13;

typedef struct 
{
unsigned int     rx_fifo_clr:1;
unsigned int     reserved_0:10;
unsigned int     packet_max:5;
unsigned int     glob_time:8;
unsigned int     reserved_1:7;
unsigned int     irq_en_link_err:1;
}MHL_CBUS_LINK_14;

typedef struct 
{
unsigned int     reserved_0:25;
unsigned int     burst_timeout:1;
unsigned int     reserved_1:2;
unsigned int     irq_retry_ddc:1;
unsigned int     irq_retry_msc:1;
unsigned int     chk_err:1;
unsigned int     irq_link_err:1;
}MHL_CBUS_LINK_15;

typedef struct 
{
unsigned int     reserved_0:16;
unsigned int     fwdef_cmd_rev:8;
unsigned int     reserved_1:7;
unsigned int     avoid_conf:1;
}MHL_CBUS_FLAG_0;

typedef struct 
{
unsigned int     msc_idle_resp_abort:1;
unsigned int     reserved_0:25;
unsigned int     mcumsc_en:1;
unsigned int     Dmy:5;
}MHL_CBUS_MSC_00;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     na_msc_cmd:8;
}MHL_CBUS_MSC_01;

typedef struct 
{
unsigned int     reserved_0:11;
unsigned int     na_rx_len:5;
unsigned int     reserved_1:6;
unsigned int     rx_fifo_full:1;
unsigned int     rx_fifo_empty:1;
unsigned int     na_msc_offset:8;
}MHL_CBUS_MSC_02;

typedef struct 
{
unsigned int     reserved_0:32;
}MHL_CBUS_MSC_03;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     rx_fifo_data:8;
}MHL_CBUS_MSC_04;

typedef struct 
{
unsigned int     reserved_0:32;
}MHL_CBUS_MSC_05;

typedef struct 
{
unsigned int     reserved_0:1;
unsigned int     irq_set_hpd:1;
unsigned int     irq_clr_hpd:1;
unsigned int     irq_ucp:1;
unsigned int     irq_ucpk:1;
unsigned int     irq_ucpe:1;
unsigned int     irq_dcap_rdy_chg:1;
unsigned int     reserved_1:1;
unsigned int     irq_path_en_chg:1;
unsigned int     reserved_2:1;
unsigned int     irq_msge:1;
unsigned int     irq_rcp:1;
unsigned int     irq_rcpk:1;
unsigned int     irq_rcpe:1;
unsigned int     irq_rap:1;
unsigned int     irq_rapk:1;
unsigned int     irq_msg_sub:1;
unsigned int     irq_wr_stat:1;
unsigned int     irq_rd_devcap:1;
unsigned int     irq_get_stat:1;
unsigned int     irq_get_id:1;
unsigned int     irq_get_msg:1;
unsigned int     irq_sc1_err:1;
unsigned int     irq_ddc_err:1;
unsigned int     irq_msc_err:1;
unsigned int     irq_wr_burst:1;
unsigned int     irq_sc3_err:1;
unsigned int     irq_fwdef_cmd:1;
unsigned int     irq_allmsc_cmd:1;
unsigned int     irq_abort_res:1;
unsigned int     irq_abort_req:1;
unsigned int     irq_ddc_abort:1;
}MHL_CBUS_MSC_06;

typedef struct 
{
unsigned int     reserved_0:1;
unsigned int     irq_en_set_hpd:1;
unsigned int     irq_en_clr_hpd:1;
unsigned int     irq_en_ucp:1;
unsigned int     irq_en_ucpk:1;
unsigned int     irq_en_ucpe:1;
unsigned int     irq_en_dcap_rdy_chg:1;
unsigned int     reserved_1:1;
unsigned int     irq_en_path_en_chg:1;
unsigned int     reserved_2:1;
unsigned int     irq_en_msge:1;
unsigned int     irq_en_rcp:1;
unsigned int     irq_en_rcpk:1;
unsigned int     irq_en_rcpe:1;
unsigned int     irq_en_rap:1;
unsigned int     irq_en_rapk:1;
unsigned int     irq_en_msg_sub:1;
unsigned int     irq_en_wr_stat:1;
unsigned int     irq_en_rd_devcap:1;
unsigned int     irq_en_get_stat:1;
unsigned int     irq_en_get_id:1;
unsigned int     irq_en_get_msg:1;
unsigned int     irq_en_sc1_err:1;
unsigned int     irq_en_ddc_err:1;
unsigned int     irq_en_msc_err:1;
unsigned int     irq_en_wr_burst:1;
unsigned int     irq_en_sc3_err:1;
unsigned int     irq_en_fwdef_cmd:1;
unsigned int     irq_en_allmsc_cmd:1;
unsigned int     irq_en_abort_res:1;
unsigned int     irq_en_abort_req:1;
unsigned int     irq_en_ddc_abort:1;
}MHL_CBUS_MSC_07;

typedef struct 
{
unsigned int     irq_rchg_bit7:1;
unsigned int     irq_rchg_bit6:1;
unsigned int     irq_rchg_bit5:1;
unsigned int     irq_3d_req:1;
unsigned int     irq_grt_wrt:1;
unsigned int     irq_req_wrt:1;
unsigned int     irq_dscr_chg:1;
unsigned int     irq_dcap_chg:1;
unsigned int     irq_dchg_bit7:1;
unsigned int     irq_dchg_bit6:1;
unsigned int     irq_dchg_bit5:1;
unsigned int     irq_dchg_bit4:1;
unsigned int     irq_dchg_bit3:1;
unsigned int     irq_dchg_bit2:1;
unsigned int     irq_edid_chg:1;
unsigned int     irq_dchg_bit0:1;
unsigned int     irq_chg22_bit7:1;
unsigned int     irq_chg22_bit6:1;
unsigned int     irq_chg22_bit5:1;
unsigned int     irq_chg22_bit4:1;
unsigned int     irq_chg22_bit3:1;
unsigned int     irq_chg22_bit2:1;
unsigned int     irq_chg22_bit1:1;
unsigned int     irq_chg22_bit0:1;
unsigned int     irq_chg23_bit7:1;
unsigned int     irq_chg23_bit6:1;
unsigned int     irq_chg23_bit5:1;
unsigned int     irq_chg23_bit4:1;
unsigned int     irq_chg23_bit3:1;
unsigned int     irq_chg23_bit2:1;
unsigned int     irq_chg23_bit1:1;
unsigned int     irq_chg23_bit0:1;
}MHL_CBUS_MSC_08;

typedef struct 
{
unsigned int     irq_en_rchg_bit7:1;
unsigned int     irq_en_rchg_bit6:1;
unsigned int     irq_en_rchg_bit5:1;
unsigned int     irq_en_3d_req:1;
unsigned int     irq_en_grt_wrt:1;
unsigned int     irq_en_req_wrt:1;
unsigned int     irq_en_dscr_chg:1;
unsigned int     irq_en_dcap_chg:1;
unsigned int     irq_en_dchg_bit7:1;
unsigned int     irq_en_dchg_bit6:1;
unsigned int     irq_en_dchg_bit5:1;
unsigned int     irq_en_dchg_bit4:1;
unsigned int     irq_en_dchg_bit3:1;
unsigned int     irq_en_dchg_bit2:1;
unsigned int     irq_en_edid_chg:1;
unsigned int     irq_en_dchg_bit0:1;
unsigned int     irq_en_chg22_bit7:1;
unsigned int     irq_en_chg22_bit6:1;
unsigned int     irq_en_chg22_bit5:1;
unsigned int     irq_en_chg22_bit4:1;
unsigned int     irq_en_chg22_bit3:1;
unsigned int     irq_en_chg22_bit2:1;
unsigned int     irq_en_chg22_bit1:1;
unsigned int     irq_en_chg22_bit0:1;
unsigned int     irq_en_chg23_bit7:1;
unsigned int     irq_en_chg23_bit6:1;
unsigned int     irq_en_chg23_bit5:1;
unsigned int     irq_en_chg23_bit4:1;
unsigned int     irq_en_chg23_bit3:1;
unsigned int     irq_en_chg23_bit2:1;
unsigned int     irq_en_chg23_bit1:1;
unsigned int     irq_en_chg23_bit0:1;
}MHL_CBUS_MSC_09;

typedef struct 
{
unsigned int     irq_chg24_bit7:1;
unsigned int     irq_chg24_bit6:1;
unsigned int     irq_chg24_bit5:1;
unsigned int     irq_chg24_bit4:1;
unsigned int     irq_chg24_bit3:1;
unsigned int     irq_chg24_bit2:1;
unsigned int     irq_chg24_bit1:1;
unsigned int     irq_chg24_bit0:1;
unsigned int     irq_chg25_bit7:1;
unsigned int     irq_chg25_bit6:1;
unsigned int     irq_chg25_bit5:1;
unsigned int     irq_chg25_bit4:1;
unsigned int     irq_chg25_bit3:1;
unsigned int     irq_chg25_bit2:1;
unsigned int     irq_chg25_bit1:1;
unsigned int     irq_chg25_bit0:1;
unsigned int     irq_chg26_bit7:1;
unsigned int     irq_chg26_bit6:1;
unsigned int     irq_chg26_bit5:1;
unsigned int     irq_chg26_bit4:1;
unsigned int     irq_chg26_bit3:1;
unsigned int     irq_chg26_bit2:1;
unsigned int     irq_chg26_bit1:1;
unsigned int     irq_chg26_bit0:1;
unsigned int     irq_chg27_bit7:1;
unsigned int     irq_chg27_bit6:1;
unsigned int     irq_chg27_bit5:1;
unsigned int     irq_chg27_bit4:1;
unsigned int     irq_chg27_bit3:1;
unsigned int     irq_chg27_bit2:1;
unsigned int     irq_chg27_bit1:1;
unsigned int     irq_chg27_bit0:1;
}MHL_CBUS_MSC_0A;

typedef struct 
{
unsigned int     irq_en_chg24_bit7:1;
unsigned int     irq_en_chg24_bit6:1;
unsigned int     irq_en_chg24_bit5:1;
unsigned int     irq_en_chg24_bit4:1;
unsigned int     irq_en_chg24_bit3:1;
unsigned int     irq_en_chg24_bit2:1;
unsigned int     irq_en_chg24_bit1:1;
unsigned int     irq_en_chg24_bit0:1;
unsigned int     irq_en_chg25_bit7:1;
unsigned int     irq_en_chg25_bit6:1;
unsigned int     irq_en_chg25_bit5:1;
unsigned int     irq_en_chg25_bit4:1;
unsigned int     irq_en_chg25_bit3:1;
unsigned int     irq_en_chg25_bit2:1;
unsigned int     irq_en_chg25_bit1:1;
unsigned int     irq_en_chg25_bit0:1;
unsigned int     irq_en_chg26_bit7:1;
unsigned int     irq_en_chg26_bit6:1;
unsigned int     irq_en_chg26_bit5:1;
unsigned int     irq_en_chg26_bit4:1;
unsigned int     irq_en_chg26_bit3:1;
unsigned int     irq_en_chg26_bit2:1;
unsigned int     irq_en_chg26_bit1:1;
unsigned int     irq_en_chg26_bit0:1;
unsigned int     irq_en_chg27_bit7:1;
unsigned int     irq_en_chg27_bit6:1;
unsigned int     irq_en_chg27_bit5:1;
unsigned int     irq_en_chg27_bit4:1;
unsigned int     irq_en_chg27_bit3:1;
unsigned int     irq_en_chg27_bit2:1;
unsigned int     irq_en_chg27_bit1:1;
unsigned int     irq_en_chg27_bit0:1;
}MHL_CBUS_MSC_0B;

typedef struct 
{
unsigned int     reserved_0:22;
unsigned int     irq_msc_err_update:1;
unsigned int     reserved_1:1;
unsigned int     msc_err_code:8;
}MHL_CBUS_MSC_0C;

typedef struct 
{
unsigned int     reserved_0:1;
unsigned int     msc_err_update_no_err:1;
unsigned int     irq_en_msc_err_update:1;
unsigned int     reserved_1:19;
unsigned int     rcp_reply_abort:1;
unsigned int     rcp_reply_nack:1;
unsigned int     vendor_id:8;
}MHL_CBUS_MSC_0D;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     msg_cmd:8;
}MHL_CBUS_MSC_0E;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     msg_dat:8;
}MHL_CBUS_MSC_0F;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     msge_rcv:8;
}MHL_CBUS_MSC_10;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     rcp_rcv:8;
}MHL_CBUS_MSC_11;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     rcpk_rcv:8;
}MHL_CBUS_MSC_12;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     rcpe_rcv:8;
}MHL_CBUS_MSC_13;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     rap_rcv:8;
}MHL_CBUS_MSC_14;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     rapk_rcv:8;
}MHL_CBUS_MSC_15;

typedef struct 
{
unsigned int     reserved_0:26;
unsigned int     wb_id_chk:1;
unsigned int     reserved_1:5;
}MHL_CBUS_MSC_16;

typedef struct 
{
unsigned int     reserved_0:16;
unsigned int     adop_idh_rcv:8;
unsigned int     adop_idl_rcv:8;
}MHL_CBUS_MSC_17;

typedef struct 
{
unsigned int     reserved_0:32;
}MHL_CBUS_MSC_18;

typedef struct 
{
unsigned int     reserved_0:32;
}MHL_CBUS_MSC_19;

typedef struct 
{
unsigned int     reserved_0:18;
unsigned int     msc_fsm:6;
unsigned int     reserved_1:2;
unsigned int     ddc_fsm:6;
}MHL_CBUS_MSC_1A;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     cap_offset:8;
}MHL_CBUS_MSC_1B;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     int_offset:8;
}MHL_CBUS_MSC_1C;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     sta_offset:8;
}MHL_CBUS_MSC_1D;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     scr_offset:8;
}MHL_CBUS_MSC_1E;

typedef struct 
{
unsigned int     reserved_0:30;
unsigned int     ddc_err_force:1;
unsigned int     msc_err_force:1;
}MHL_CBUS_MSC_1F;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     ddc_err_fw:8;
}MHL_CBUS_MSC_20;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     msc_err_fw:8;
}MHL_CBUS_MSC_21;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     ucp_rcv:8;
}MHL_CBUS_MSC_22;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     ucpk_rcv:8;
}MHL_CBUS_MSC_23;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     ucpe_rcv:8;
}MHL_CBUS_MSC_24;

typedef struct 
{
unsigned int     reserved_0:22;
unsigned int     fw0_msg_processing:1;
unsigned int     fw0_req:1;
unsigned int     reserved_1:1;
unsigned int     fw0_fifo_full:1;
unsigned int     fw0_fifo_empty:1;
unsigned int     reserved_2:5;
}MHL_FW0_REQ_00;

typedef struct 
{
unsigned int     reserved_0:19;
unsigned int     check_fw0_msg_processing:1;
unsigned int     reserved_1:1;
unsigned int     fw0_tx_case:3;
unsigned int     fw0_cmd1:8;
}MHL_FW0_REQ_01;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     fw0_cmd2:8;
}MHL_FW0_REQ_02;

typedef struct 
{
unsigned int     reserved_0:8;
unsigned int     fw0_data1:8;
unsigned int     fw0_data2:8;
unsigned int     fw0_offset:8;
}MHL_FW0_REQ_03;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     fw0_data:8;
}MHL_FW0_REQ_04;

typedef struct 
{
unsigned int     fw0_fifo_clr:1;
unsigned int     reserved_0:19;
unsigned int     fw0_fifo_len:4;
unsigned int     reserved_1:2;
unsigned int     irq_en_fw0_rcv_err:1;
unsigned int     irq_en_fw0_fin:1;
unsigned int     irq_en_fw0_cmd:1;
unsigned int     irq_en_fw0_data:1;
unsigned int     reserved_2:2;
}MHL_FW0_REQ_05;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     fw0_cmd_rcv:8;
}MHL_FW0_REQ_06;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     fw0_data_rcv:8;
}MHL_FW0_REQ_07;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     fw0_rdata:8;
}MHL_FW0_REQ_08;

typedef struct 
{
unsigned int     reserved_0:23;
unsigned int     irq_fw0_fin:1;
unsigned int     irq_fw0_cmd:1;
unsigned int     irq_fw0_data:1;
unsigned int     irq_fw0_rcv_err:1;
unsigned int     reserved_1:5;
}MHL_FW0_REQ_09;

typedef struct 
{
unsigned int     ddc_req:1;
unsigned int     reserved_0:21;
unsigned int     irq_ddc_err_update:1;
unsigned int     irq_ddc_data:1;
unsigned int     ddc_err_code:8;
}MHL_CBUS_DDC_00;

typedef struct 
{
unsigned int     ddc_idle_resp_abort:1;
unsigned int     ddc_err_update_no_err:1;
unsigned int     irq_en_ddc_err_update:1;
unsigned int     reserved_0:5;
unsigned int     ddc_addr_w:8;
unsigned int     ddc_addr_r:8;
unsigned int     reserved_1:8;
}MHL_CBUS_DDC_01;

typedef struct 
{
unsigned int     reserved_0:18;
unsigned int     ddc_req_type:2;
unsigned int     reserved_1:3;
unsigned int     mcuddc_need_resp:1;
unsigned int     mcuddc_en:1;
unsigned int     reserved_2:4;
unsigned int     irq_en_ddc_data:1;
unsigned int     ddc_req_ctrl:1;
unsigned int     reserved_3:1;
}MHL_CBUS_DDC_02;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     ddc_cmd_fw:8;
}MHL_CBUS_DDC_03;

typedef struct 
{
unsigned int     reserved_0:23;
unsigned int     ddc_rcv_data:9;
}MHL_CBUS_DDC_04;

typedef struct 
{
unsigned int     reserved_0:24;
unsigned int     ddc_data_fw:8;
}MHL_CBUS_DDC_05;

typedef struct 
{
unsigned int     reserved_0:8;
unsigned int     ddc_offset:8;
unsigned int     ddc_seg_val:8;
unsigned int     ddc_addr_0x60:8;
}MHL_CBUS_DDC_06;

typedef struct 
{
unsigned int     reserved_0:27;
unsigned int     cbus_busy:1;
unsigned int     link_busy:1;
unsigned int     translation_busy:1;
unsigned int     ddc_busy:1;
unsigned int     msc_busy:1;
}MHL_CBUS_WDOG;

typedef struct 
{
unsigned int     reserved_0:32;
}MHL_CBUS_INT_EN;

typedef struct 
{
unsigned int     reserved_0:25;
unsigned int     irq_discovery:1;
unsigned int     irq_link:1;
unsigned int     irq_ddc:1;
unsigned int     irq_msc_ch:1;
unsigned int     irq_msc_int:1;
unsigned int     irq_msc_stat:1;
unsigned int     reserved_1:1;
}MHL_CBUS_INT_INDEX;

typedef struct 
{
unsigned int     reserved_0:14;
unsigned int     fw_r10k_en:2;
unsigned int     reserved_1:2;
unsigned int     fw_control_r10k:1;
unsigned int     fw_cbus_drive:1;
unsigned int     fw_cbus_level:1;
unsigned int     fw_out:1;
unsigned int     cbus_test_md:2;
unsigned int     reserved_2:3;
unsigned int     dbg_en:1;
unsigned int     dbg_sel:4;
}MHL_CBUS_TEST;

typedef struct 
{
unsigned int     Dmy:32;
}MHL_CBUS_DUMMY0;

#endif

#define MHL_CBUS                                                                     0x18062C00
#define MHL_CBUS_reg_addr                                                            "0xB8062C00"
#define MHL_CBUS_reg                                                                 0xB8062C00
#define set_MHL_CBUS_reg(data)   (*((volatile unsigned int*) MHL_CBUS_reg)=data)
#define get_MHL_CBUS_reg   (*((volatile unsigned int*) MHL_CBUS_reg))
#define MHL_CBUS_inst_adr                                                            "0x0000"
#define MHL_CBUS_inst                                                                0x0000
#define MHL_CBUS_enable_shift                                                        (31)
#define MHL_CBUS_enable_mask                                                         (0x80000000)
#define MHL_CBUS_enable(data)                                                        (0x80000000&((data)<<31))
#define MHL_CBUS_enable_src(data)                                                    ((0x80000000&(data))>>31)
#define MHL_CBUS_get_enable(data)                                                    ((0x80000000&(data))>>31)
#define MHL_CBUS_irq_en_8051_shift                                                   (30)
#define MHL_CBUS_irq_en_8051_mask                                                    (0x40000000)
#define MHL_CBUS_irq_en_8051(data)                                                   (0x40000000&((data)<<30))
#define MHL_CBUS_irq_en_8051_src(data)                                               ((0x40000000&(data))>>30)
#define MHL_CBUS_get_irq_en_8051(data)                                               ((0x40000000&(data))>>30)
#define MHL_CBUS_irq_en_scpu_shift                                                   (29)
#define MHL_CBUS_irq_en_scpu_mask                                                    (0x20000000)
#define MHL_CBUS_irq_en_scpu(data)                                                   (0x20000000&((data)<<29))
#define MHL_CBUS_irq_en_scpu_src(data)                                               ((0x20000000&(data))>>29)
#define MHL_CBUS_get_irq_en_scpu(data)                                               ((0x20000000&(data))>>29)
#define MHL_CBUS_cbus_multi_sync_shift                                               (28)
#define MHL_CBUS_cbus_multi_sync_mask                                                (0x10000000)
#define MHL_CBUS_cbus_multi_sync(data)                                               (0x10000000&((data)<<28))
#define MHL_CBUS_cbus_multi_sync_src(data)                                           ((0x10000000&(data))>>28)
#define MHL_CBUS_get_cbus_multi_sync(data)                                           ((0x10000000&(data))>>28)
#define MHL_CBUS_mhl_clk_ns_shift                                                    (0)
#define MHL_CBUS_mhl_clk_ns_mask                                                     (0x00000FFF)
#define MHL_CBUS_mhl_clk_ns(data)                                                    (0x00000FFF&((data)<<0))
#define MHL_CBUS_mhl_clk_ns_src(data)                                                ((0x00000FFF&(data))>>0)
#define MHL_CBUS_get_mhl_clk_ns(data)                                                ((0x00000FFF&(data))>>0)


#define MHL_CBUS_DIS0                                                                0x18062C04
#define MHL_CBUS_DIS0_reg_addr                                                       "0xB8062C04"
#define MHL_CBUS_DIS0_reg                                                            0xB8062C04
#define set_MHL_CBUS_DIS0_reg(data)   (*((volatile unsigned int*) MHL_CBUS_DIS0_reg)=data)
#define get_MHL_CBUS_DIS0_reg   (*((volatile unsigned int*) MHL_CBUS_DIS0_reg))
#define MHL_CBUS_DIS0_inst_adr                                                       "0x0001"
#define MHL_CBUS_DIS0_inst                                                           0x0001
#define MHL_CBUS_DIS0_r1k_fw_mode_shift                                              (30)
#define MHL_CBUS_DIS0_r1k_fw_mode_mask                                               (0x40000000)
#define MHL_CBUS_DIS0_r1k_fw_mode(data)                                              (0x40000000&((data)<<30))
#define MHL_CBUS_DIS0_r1k_fw_mode_src(data)                                          ((0x40000000&(data))>>30)
#define MHL_CBUS_DIS0_get_r1k_fw_mode(data)                                          ((0x40000000&(data))>>30)
#define MHL_CBUS_DIS0_r1k_fw_value_shift                                             (29)
#define MHL_CBUS_DIS0_r1k_fw_value_mask                                              (0x20000000)
#define MHL_CBUS_DIS0_r1k_fw_value(data)                                             (0x20000000&((data)<<29))
#define MHL_CBUS_DIS0_r1k_fw_value_src(data)                                         ((0x20000000&(data))>>29)
#define MHL_CBUS_DIS0_get_r1k_fw_value(data)                                         ((0x20000000&(data))>>29)
#define MHL_CBUS_DIS0_bypass_discov_shift                                            (28)
#define MHL_CBUS_DIS0_bypass_discov_mask                                             (0x10000000)
#define MHL_CBUS_DIS0_bypass_discov(data)                                            (0x10000000&((data)<<28))
#define MHL_CBUS_DIS0_bypass_discov_src(data)                                        ((0x10000000&(data))>>28)
#define MHL_CBUS_DIS0_get_bypass_discov(data)                                        ((0x10000000&(data))>>28)
#define MHL_CBUS_DIS0_tsrc_float_shift                                               (20)
#define MHL_CBUS_DIS0_tsrc_float_mask                                                (0x0FF00000)
#define MHL_CBUS_DIS0_tsrc_float(data)                                               (0x0FF00000&((data)<<20))
#define MHL_CBUS_DIS0_tsrc_float_src(data)                                           ((0x0FF00000&(data))>>20)
#define MHL_CBUS_DIS0_get_tsrc_float(data)                                           ((0x0FF00000&(data))>>20)
#define MHL_CBUS_DIS0_rxsense_fw_mode_shift                                          (19)
#define MHL_CBUS_DIS0_rxsense_fw_mode_mask                                           (0x00080000)
#define MHL_CBUS_DIS0_rxsense_fw_mode(data)                                          (0x00080000&((data)<<19))
#define MHL_CBUS_DIS0_rxsense_fw_mode_src(data)                                      ((0x00080000&(data))>>19)
#define MHL_CBUS_DIS0_get_rxsense_fw_mode(data)                                      ((0x00080000&(data))>>19)
#define MHL_CBUS_DIS0_rxsense_fw_value_shift                                         (18)
#define MHL_CBUS_DIS0_rxsense_fw_value_mask                                          (0x00040000)
#define MHL_CBUS_DIS0_rxsense_fw_value(data)                                         (0x00040000&((data)<<18))
#define MHL_CBUS_DIS0_rxsense_fw_value_src(data)                                     ((0x00040000&(data))>>18)
#define MHL_CBUS_DIS0_get_rxsense_fw_value(data)                                     ((0x00040000&(data))>>18)
#define MHL_CBUS_DIS0_tsrc_stable_shift                                              (8)
#define MHL_CBUS_DIS0_tsrc_stable_mask                                               (0x0003FF00)
#define MHL_CBUS_DIS0_tsrc_stable(data)                                              (0x0003FF00&((data)<<8))
#define MHL_CBUS_DIS0_tsrc_stable_src(data)                                          ((0x0003FF00&(data))>>8)
#define MHL_CBUS_DIS0_get_tsrc_stable(data)                                          ((0x0003FF00&(data))>>8)
#define MHL_CBUS_DIS0_trxsense_deglitch_shift                                        (0)
#define MHL_CBUS_DIS0_trxsense_deglitch_mask                                         (0x000000FF)
#define MHL_CBUS_DIS0_trxsense_deglitch(data)                                        (0x000000FF&((data)<<0))
#define MHL_CBUS_DIS0_trxsense_deglitch_src(data)                                    ((0x000000FF&(data))>>0)
#define MHL_CBUS_DIS0_get_trxsense_deglitch(data)                                    ((0x000000FF&(data))>>0)


#define MHL_CBUS_DIS1                                                                0x18062C08
#define MHL_CBUS_DIS1_reg_addr                                                       "0xB8062C08"
#define MHL_CBUS_DIS1_reg                                                            0xB8062C08
#define set_MHL_CBUS_DIS1_reg(data)   (*((volatile unsigned int*) MHL_CBUS_DIS1_reg)=data)
#define get_MHL_CBUS_DIS1_reg   (*((volatile unsigned int*) MHL_CBUS_DIS1_reg))
#define MHL_CBUS_DIS1_inst_adr                                                       "0x0002"
#define MHL_CBUS_DIS1_inst                                                           0x0002
#define MHL_CBUS_DIS1_both_path_en_shift                                             (31)
#define MHL_CBUS_DIS1_both_path_en_mask                                              (0x80000000)
#define MHL_CBUS_DIS1_both_path_en(data)                                             (0x80000000&((data)<<31))
#define MHL_CBUS_DIS1_both_path_en_src(data)                                         ((0x80000000&(data))>>31)
#define MHL_CBUS_DIS1_get_both_path_en(data)                                         ((0x80000000&(data))>>31)
#define MHL_CBUS_DIS1_trxsense_chk_shift                                             (22)
#define MHL_CBUS_DIS1_trxsense_chk_mask                                              (0x7FC00000)
#define MHL_CBUS_DIS1_trxsense_chk(data)                                             (0x7FC00000&((data)<<22))
#define MHL_CBUS_DIS1_trxsense_chk_src(data)                                         ((0x7FC00000&(data))>>22)
#define MHL_CBUS_DIS1_get_trxsense_chk(data)                                         ((0x7FC00000&(data))>>22)
#define MHL_CBUS_DIS1_tsrc_wake_width1_shift                                         (17)
#define MHL_CBUS_DIS1_tsrc_wake_width1_mask                                          (0x003E0000)
#define MHL_CBUS_DIS1_tsrc_wake_width1(data)                                         (0x003E0000&((data)<<17))
#define MHL_CBUS_DIS1_tsrc_wake_width1_src(data)                                     ((0x003E0000&(data))>>17)
#define MHL_CBUS_DIS1_get_tsrc_wake_width1(data)                                     ((0x003E0000&(data))>>17)
#define MHL_CBUS_DIS1_tsrc_wake_width2_shift                                         (10)
#define MHL_CBUS_DIS1_tsrc_wake_width2_mask                                          (0x0001FC00)
#define MHL_CBUS_DIS1_tsrc_wake_width2(data)                                         (0x0001FC00&((data)<<10))
#define MHL_CBUS_DIS1_tsrc_wake_width2_src(data)                                     ((0x0001FC00&(data))>>10)
#define MHL_CBUS_DIS1_get_tsrc_wake_width2(data)                                     ((0x0001FC00&(data))>>10)
#define MHL_CBUS_DIS1_tsrc_wake_to_discov_shift                                      (0)
#define MHL_CBUS_DIS1_tsrc_wake_to_discov_mask                                       (0x000003FF)
#define MHL_CBUS_DIS1_tsrc_wake_to_discov(data)                                      (0x000003FF&((data)<<0))
#define MHL_CBUS_DIS1_tsrc_wake_to_discov_src(data)                                  ((0x000003FF&(data))>>0)
#define MHL_CBUS_DIS1_get_tsrc_wake_to_discov(data)                                  ((0x000003FF&(data))>>0)


#define MHL_CBUS_DIS2                                                                0x18062C0C
#define MHL_CBUS_DIS2_reg_addr                                                       "0xB8062C0C"
#define MHL_CBUS_DIS2_reg                                                            0xB8062C0C
#define set_MHL_CBUS_DIS2_reg(data)   (*((volatile unsigned int*) MHL_CBUS_DIS2_reg)=data)
#define get_MHL_CBUS_DIS2_reg   (*((volatile unsigned int*) MHL_CBUS_DIS2_reg))
#define MHL_CBUS_DIS2_inst_adr                                                       "0x0003"
#define MHL_CBUS_DIS2_inst                                                           0x0003
#define MHL_CBUS_DIS2_tsrc_pulse_width_shift                                         (20)
#define MHL_CBUS_DIS2_tsrc_pulse_width_mask                                          (0x07F00000)
#define MHL_CBUS_DIS2_tsrc_pulse_width(data)                                         (0x07F00000&((data)<<20))
#define MHL_CBUS_DIS2_tsrc_pulse_width_src(data)                                     ((0x07F00000&(data))>>20)
#define MHL_CBUS_DIS2_get_tsrc_pulse_width(data)                                     ((0x07F00000&(data))>>20)
#define MHL_CBUS_DIS2_tsrc_conn_shift                                                (12)
#define MHL_CBUS_DIS2_tsrc_conn_mask                                                 (0x000FF000)
#define MHL_CBUS_DIS2_tsrc_conn(data)                                                (0x000FF000&((data)<<12))
#define MHL_CBUS_DIS2_tsrc_conn_src(data)                                            ((0x000FF000&(data))>>12)
#define MHL_CBUS_DIS2_get_tsrc_conn(data)                                            ((0x000FF000&(data))>>12)
#define MHL_CBUS_DIS2_tsrc_arbitrate_shift                                           (0)
#define MHL_CBUS_DIS2_tsrc_arbitrate_mask                                            (0x000003FF)
#define MHL_CBUS_DIS2_tsrc_arbitrate(data)                                           (0x000003FF&((data)<<0))
#define MHL_CBUS_DIS2_tsrc_arbitrate_src(data)                                       ((0x000003FF&(data))>>0)
#define MHL_CBUS_DIS2_get_tsrc_arbitrate(data)                                       ((0x000003FF&(data))>>0)


#define MHL_CBUS_DIS3                                                                0x18062C10
#define MHL_CBUS_DIS3_reg_addr                                                       "0xB8062C10"
#define MHL_CBUS_DIS3_reg                                                            0xB8062C10
#define set_MHL_CBUS_DIS3_reg(data)   (*((volatile unsigned int*) MHL_CBUS_DIS3_reg)=data)
#define get_MHL_CBUS_DIS3_reg   (*((volatile unsigned int*) MHL_CBUS_DIS3_reg))
#define MHL_CBUS_DIS3_inst_adr                                                       "0x0004"
#define MHL_CBUS_DIS3_inst                                                           0x0004
#define MHL_CBUS_DIS3_tsink_float_shift                                              (24)
#define MHL_CBUS_DIS3_tsink_float_mask                                               (0xFF000000)
#define MHL_CBUS_DIS3_tsink_float(data)                                              (0xFF000000&((data)<<24))
#define MHL_CBUS_DIS3_tsink_float_src(data)                                          ((0xFF000000&(data))>>24)
#define MHL_CBUS_DIS3_get_tsink_float(data)                                          ((0xFF000000&(data))>>24)
#define MHL_CBUS_DIS3_drive_wake_pulse_low_en_shift                                  (21)
#define MHL_CBUS_DIS3_drive_wake_pulse_low_en_mask                                   (0x00200000)
#define MHL_CBUS_DIS3_drive_wake_pulse_low_en(data)                                  (0x00200000&((data)<<21))
#define MHL_CBUS_DIS3_drive_wake_pulse_low_en_src(data)                              ((0x00200000&(data))>>21)
#define MHL_CBUS_DIS3_get_drive_wake_pulse_low_en(data)                              ((0x00200000&(data))>>21)
#define MHL_CBUS_DIS3_discovery_check_sink_start_shift                               (16)
#define MHL_CBUS_DIS3_discovery_check_sink_start_mask                                (0x001F0000)
#define MHL_CBUS_DIS3_discovery_check_sink_start(data)                               (0x001F0000&((data)<<16))
#define MHL_CBUS_DIS3_discovery_check_sink_start_src(data)                           ((0x001F0000&(data))>>16)
#define MHL_CBUS_DIS3_get_discovery_check_sink_start(data)                           ((0x001F0000&(data))>>16)
#define MHL_CBUS_DIS3_max_discovery_pulse_count_shift                                (8)
#define MHL_CBUS_DIS3_max_discovery_pulse_count_mask                                 (0x00001F00)
#define MHL_CBUS_DIS3_max_discovery_pulse_count(data)                                (0x00001F00&((data)<<8))
#define MHL_CBUS_DIS3_max_discovery_pulse_count_src(data)                            ((0x00001F00&(data))>>8)
#define MHL_CBUS_DIS3_get_max_discovery_pulse_count(data)                            ((0x00001F00&(data))>>8)
#define MHL_CBUS_DIS3_irq_en_src6_7_shift                                            (4)
#define MHL_CBUS_DIS3_irq_en_src6_7_mask                                             (0x00000010)
#define MHL_CBUS_DIS3_irq_en_src6_7(data)                                            (0x00000010&((data)<<4))
#define MHL_CBUS_DIS3_irq_en_src6_7_src(data)                                        ((0x00000010&(data))>>4)
#define MHL_CBUS_DIS3_get_irq_en_src6_7(data)                                        ((0x00000010&(data))>>4)
#define MHL_CBUS_DIS3_irq_en_src3_4_shift                                            (3)
#define MHL_CBUS_DIS3_irq_en_src3_4_mask                                             (0x00000008)
#define MHL_CBUS_DIS3_irq_en_src3_4(data)                                            (0x00000008&((data)<<3))
#define MHL_CBUS_DIS3_irq_en_src3_4_src(data)                                        ((0x00000008&(data))>>3)
#define MHL_CBUS_DIS3_get_irq_en_src3_4(data)                                        ((0x00000008&(data))>>3)
#define MHL_CBUS_DIS3_irq_en_tmds_off_shift                                          (2)
#define MHL_CBUS_DIS3_irq_en_tmds_off_mask                                           (0x00000004)
#define MHL_CBUS_DIS3_irq_en_tmds_off(data)                                          (0x00000004&((data)<<2))
#define MHL_CBUS_DIS3_irq_en_tmds_off_src(data)                                      ((0x00000004&(data))>>2)
#define MHL_CBUS_DIS3_get_irq_en_tmds_off(data)                                      ((0x00000004&(data))>>2)
#define MHL_CBUS_DIS3_irq_en_tmds_out_shift                                          (1)
#define MHL_CBUS_DIS3_irq_en_tmds_out_mask                                           (0x00000002)
#define MHL_CBUS_DIS3_irq_en_tmds_out(data)                                          (0x00000002&((data)<<1))
#define MHL_CBUS_DIS3_irq_en_tmds_out_src(data)                                      ((0x00000002&(data))>>1)
#define MHL_CBUS_DIS3_get_irq_en_tmds_out(data)                                      ((0x00000002&(data))>>1)
#define MHL_CBUS_DIS3_discov_standby_shift                                           (0)
#define MHL_CBUS_DIS3_discov_standby_mask                                            (0x00000001)
#define MHL_CBUS_DIS3_discov_standby(data)                                           (0x00000001&((data)<<0))
#define MHL_CBUS_DIS3_discov_standby_src(data)                                       ((0x00000001&(data))>>0)
#define MHL_CBUS_DIS3_get_discov_standby(data)                                       ((0x00000001&(data))>>0)


#define MHL_CBUS_DIS4                                                                0x18062C14
#define MHL_CBUS_DIS4_reg_addr                                                       "0xB8062C14"
#define MHL_CBUS_DIS4_reg                                                            0xB8062C14
#define set_MHL_CBUS_DIS4_reg(data)   (*((volatile unsigned int*) MHL_CBUS_DIS4_reg)=data)
#define get_MHL_CBUS_DIS4_reg   (*((volatile unsigned int*) MHL_CBUS_DIS4_reg))
#define MHL_CBUS_DIS4_inst_adr                                                       "0x0005"
#define MHL_CBUS_DIS4_inst                                                           0x0005
#define MHL_CBUS_DIS4_src0_shift                                                     (30)
#define MHL_CBUS_DIS4_src0_mask                                                      (0x40000000)
#define MHL_CBUS_DIS4_src0(data)                                                     (0x40000000&((data)<<30))
#define MHL_CBUS_DIS4_src0_src(data)                                                 ((0x40000000&(data))>>30)
#define MHL_CBUS_DIS4_get_src0(data)                                                 ((0x40000000&(data))>>30)
#define MHL_CBUS_DIS4_src1_shift                                                     (29)
#define MHL_CBUS_DIS4_src1_mask                                                      (0x20000000)
#define MHL_CBUS_DIS4_src1(data)                                                     (0x20000000&((data)<<29))
#define MHL_CBUS_DIS4_src1_src(data)                                                 ((0x20000000&(data))>>29)
#define MHL_CBUS_DIS4_get_src1(data)                                                 ((0x20000000&(data))>>29)
#define MHL_CBUS_DIS4_src2_shift                                                     (28)
#define MHL_CBUS_DIS4_src2_mask                                                      (0x10000000)
#define MHL_CBUS_DIS4_src2(data)                                                     (0x10000000&((data)<<28))
#define MHL_CBUS_DIS4_src2_src(data)                                                 ((0x10000000&(data))>>28)
#define MHL_CBUS_DIS4_get_src2(data)                                                 ((0x10000000&(data))>>28)
#define MHL_CBUS_DIS4_src3_00_shift                                                  (27)
#define MHL_CBUS_DIS4_src3_00_mask                                                   (0x08000000)
#define MHL_CBUS_DIS4_src3_00(data)                                                  (0x08000000&((data)<<27))
#define MHL_CBUS_DIS4_src3_00_src(data)                                              ((0x08000000&(data))>>27)
#define MHL_CBUS_DIS4_get_src3_00(data)                                              ((0x08000000&(data))>>27)
#define MHL_CBUS_DIS4_src3_01_shift                                                  (26)
#define MHL_CBUS_DIS4_src3_01_mask                                                   (0x04000000)
#define MHL_CBUS_DIS4_src3_01(data)                                                  (0x04000000&((data)<<26))
#define MHL_CBUS_DIS4_src3_01_src(data)                                              ((0x04000000&(data))>>26)
#define MHL_CBUS_DIS4_get_src3_01(data)                                              ((0x04000000&(data))>>26)
#define MHL_CBUS_DIS4_src3_02_shift                                                  (25)
#define MHL_CBUS_DIS4_src3_02_mask                                                   (0x02000000)
#define MHL_CBUS_DIS4_src3_02(data)                                                  (0x02000000&((data)<<25))
#define MHL_CBUS_DIS4_src3_02_src(data)                                              ((0x02000000&(data))>>25)
#define MHL_CBUS_DIS4_get_src3_02(data)                                              ((0x02000000&(data))>>25)
#define MHL_CBUS_DIS4_src3_03_shift                                                  (24)
#define MHL_CBUS_DIS4_src3_03_mask                                                   (0x01000000)
#define MHL_CBUS_DIS4_src3_03(data)                                                  (0x01000000&((data)<<24))
#define MHL_CBUS_DIS4_src3_03_src(data)                                              ((0x01000000&(data))>>24)
#define MHL_CBUS_DIS4_get_src3_03(data)                                              ((0x01000000&(data))>>24)
#define MHL_CBUS_DIS4_src3_04_shift                                                  (23)
#define MHL_CBUS_DIS4_src3_04_mask                                                   (0x00800000)
#define MHL_CBUS_DIS4_src3_04(data)                                                  (0x00800000&((data)<<23))
#define MHL_CBUS_DIS4_src3_04_src(data)                                              ((0x00800000&(data))>>23)
#define MHL_CBUS_DIS4_get_src3_04(data)                                              ((0x00800000&(data))>>23)
#define MHL_CBUS_DIS4_src3_05_shift                                                  (22)
#define MHL_CBUS_DIS4_src3_05_mask                                                   (0x00400000)
#define MHL_CBUS_DIS4_src3_05(data)                                                  (0x00400000&((data)<<22))
#define MHL_CBUS_DIS4_src3_05_src(data)                                              ((0x00400000&(data))>>22)
#define MHL_CBUS_DIS4_get_src3_05(data)                                              ((0x00400000&(data))>>22)
#define MHL_CBUS_DIS4_src3_06_shift                                                  (21)
#define MHL_CBUS_DIS4_src3_06_mask                                                   (0x00200000)
#define MHL_CBUS_DIS4_src3_06(data)                                                  (0x00200000&((data)<<21))
#define MHL_CBUS_DIS4_src3_06_src(data)                                              ((0x00200000&(data))>>21)
#define MHL_CBUS_DIS4_get_src3_06(data)                                              ((0x00200000&(data))>>21)
#define MHL_CBUS_DIS4_src3_07_shift                                                  (20)
#define MHL_CBUS_DIS4_src3_07_mask                                                   (0x00100000)
#define MHL_CBUS_DIS4_src3_07(data)                                                  (0x00100000&((data)<<20))
#define MHL_CBUS_DIS4_src3_07_src(data)                                              ((0x00100000&(data))>>20)
#define MHL_CBUS_DIS4_get_src3_07(data)                                              ((0x00100000&(data))>>20)
#define MHL_CBUS_DIS4_src3_08_shift                                                  (19)
#define MHL_CBUS_DIS4_src3_08_mask                                                   (0x00080000)
#define MHL_CBUS_DIS4_src3_08(data)                                                  (0x00080000&((data)<<19))
#define MHL_CBUS_DIS4_src3_08_src(data)                                              ((0x00080000&(data))>>19)
#define MHL_CBUS_DIS4_get_src3_08(data)                                              ((0x00080000&(data))>>19)
#define MHL_CBUS_DIS4_src3_09_shift                                                  (18)
#define MHL_CBUS_DIS4_src3_09_mask                                                   (0x00040000)
#define MHL_CBUS_DIS4_src3_09(data)                                                  (0x00040000&((data)<<18))
#define MHL_CBUS_DIS4_src3_09_src(data)                                              ((0x00040000&(data))>>18)
#define MHL_CBUS_DIS4_get_src3_09(data)                                              ((0x00040000&(data))>>18)
#define MHL_CBUS_DIS4_src3_10_shift                                                  (17)
#define MHL_CBUS_DIS4_src3_10_mask                                                   (0x00020000)
#define MHL_CBUS_DIS4_src3_10(data)                                                  (0x00020000&((data)<<17))
#define MHL_CBUS_DIS4_src3_10_src(data)                                              ((0x00020000&(data))>>17)
#define MHL_CBUS_DIS4_get_src3_10(data)                                              ((0x00020000&(data))>>17)
#define MHL_CBUS_DIS4_src4_shift                                                     (15)
#define MHL_CBUS_DIS4_src4_mask                                                      (0x00008000)
#define MHL_CBUS_DIS4_src4(data)                                                     (0x00008000&((data)<<15))
#define MHL_CBUS_DIS4_src4_src(data)                                                 ((0x00008000&(data))>>15)
#define MHL_CBUS_DIS4_get_src4(data)                                                 ((0x00008000&(data))>>15)
#define MHL_CBUS_DIS4_src5_shift                                                     (14)
#define MHL_CBUS_DIS4_src5_mask                                                      (0x00004000)
#define MHL_CBUS_DIS4_src5(data)                                                     (0x00004000&((data)<<14))
#define MHL_CBUS_DIS4_src5_src(data)                                                 ((0x00004000&(data))>>14)
#define MHL_CBUS_DIS4_get_src5(data)                                                 ((0x00004000&(data))>>14)
#define MHL_CBUS_DIS4_src6_shift                                                     (13)
#define MHL_CBUS_DIS4_src6_mask                                                      (0x00002000)
#define MHL_CBUS_DIS4_src6(data)                                                     (0x00002000&((data)<<13))
#define MHL_CBUS_DIS4_src6_src(data)                                                 ((0x00002000&(data))>>13)
#define MHL_CBUS_DIS4_get_src6(data)                                                 ((0x00002000&(data))>>13)
#define MHL_CBUS_DIS4_src7_shift                                                     (12)
#define MHL_CBUS_DIS4_src7_mask                                                      (0x00001000)
#define MHL_CBUS_DIS4_src7(data)                                                     (0x00001000&((data)<<12))
#define MHL_CBUS_DIS4_src7_src(data)                                                 ((0x00001000&(data))>>12)
#define MHL_CBUS_DIS4_get_src7(data)                                                 ((0x00001000&(data))>>12)
#define MHL_CBUS_DIS4_irq_src6_7_shift                                               (4)
#define MHL_CBUS_DIS4_irq_src6_7_mask                                                (0x00000010)
#define MHL_CBUS_DIS4_irq_src6_7(data)                                               (0x00000010&((data)<<4))
#define MHL_CBUS_DIS4_irq_src6_7_src(data)                                           ((0x00000010&(data))>>4)
#define MHL_CBUS_DIS4_get_irq_src6_7(data)                                           ((0x00000010&(data))>>4)
#define MHL_CBUS_DIS4_irq_src3_4_shift                                               (3)
#define MHL_CBUS_DIS4_irq_src3_4_mask                                                (0x00000008)
#define MHL_CBUS_DIS4_irq_src3_4(data)                                               (0x00000008&((data)<<3))
#define MHL_CBUS_DIS4_irq_src3_4_src(data)                                           ((0x00000008&(data))>>3)
#define MHL_CBUS_DIS4_get_irq_src3_4(data)                                           ((0x00000008&(data))>>3)
#define MHL_CBUS_DIS4_irq_tmds_off_shift                                             (2)
#define MHL_CBUS_DIS4_irq_tmds_off_mask                                              (0x00000004)
#define MHL_CBUS_DIS4_irq_tmds_off(data)                                             (0x00000004&((data)<<2))
#define MHL_CBUS_DIS4_irq_tmds_off_src(data)                                         ((0x00000004&(data))>>2)
#define MHL_CBUS_DIS4_get_irq_tmds_off(data)                                         ((0x00000004&(data))>>2)
#define MHL_CBUS_DIS4_irq_tmds_out_shift                                             (1)
#define MHL_CBUS_DIS4_irq_tmds_out_mask                                              (0x00000002)
#define MHL_CBUS_DIS4_irq_tmds_out(data)                                             (0x00000002&((data)<<1))
#define MHL_CBUS_DIS4_irq_tmds_out_src(data)                                         ((0x00000002&(data))>>1)
#define MHL_CBUS_DIS4_get_irq_tmds_out(data)                                         ((0x00000002&(data))>>1)


#define MHL_CBUS_DIS5                                                                0x18062C18
#define MHL_CBUS_DIS5_reg_addr                                                       "0xB8062C18"
#define MHL_CBUS_DIS5_reg                                                            0xB8062C18
#define set_MHL_CBUS_DIS5_reg(data)   (*((volatile unsigned int*) MHL_CBUS_DIS5_reg)=data)
#define get_MHL_CBUS_DIS5_reg   (*((volatile unsigned int*) MHL_CBUS_DIS5_reg))
#define MHL_CBUS_DIS5_inst_adr                                                       "0x0006"
#define MHL_CBUS_DIS5_inst                                                           0x0006
#define MHL_CBUS_DIS5_Dmy_shift                                                      (0)
#define MHL_CBUS_DIS5_Dmy_mask                                                       (0xFFFFFFFF)
#define MHL_CBUS_DIS5_Dmy(data)                                                      (0xFFFFFFFF&((data)<<0))
#define MHL_CBUS_DIS5_Dmy_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
#define MHL_CBUS_DIS5_get_Dmy(data)                                                  ((0xFFFFFFFF&(data))>>0)


#define MHL_CBUS_PHY0                                                                0x18062C1C
#define MHL_CBUS_PHY0_reg_addr                                                       "0xB8062C1C"
#define MHL_CBUS_PHY0_reg                                                            0xB8062C1C
#define set_MHL_CBUS_PHY0_reg(data)   (*((volatile unsigned int*) MHL_CBUS_PHY0_reg)=data)
#define get_MHL_CBUS_PHY0_reg   (*((volatile unsigned int*) MHL_CBUS_PHY0_reg))
#define MHL_CBUS_PHY0_inst_adr                                                       "0x0007"
#define MHL_CBUS_PHY0_inst                                                           0x0007
#define MHL_CBUS_PHY0_Dmy_shift                                                      (0)
#define MHL_CBUS_PHY0_Dmy_mask                                                       (0xFFFFFFFF)
#define MHL_CBUS_PHY0_Dmy(data)                                                      (0xFFFFFFFF&((data)<<0))
#define MHL_CBUS_PHY0_Dmy_src(data)                                                  ((0xFFFFFFFF&(data))>>0)
#define MHL_CBUS_PHY0_get_Dmy(data)                                                  ((0xFFFFFFFF&(data))>>0)


#define MHL_CBUS_PHY1                                                                0x18062C20
#define MHL_CBUS_PHY1_reg_addr                                                       "0xB8062C20"
#define MHL_CBUS_PHY1_reg                                                            0xB8062C20
#define set_MHL_CBUS_PHY1_reg(data)   (*((volatile unsigned int*) MHL_CBUS_PHY1_reg)=data)
#define get_MHL_CBUS_PHY1_reg   (*((volatile unsigned int*) MHL_CBUS_PHY1_reg))
#define MHL_CBUS_PHY1_inst_adr                                                       "0x0008"
#define MHL_CBUS_PHY1_inst                                                           0x0008
#define MHL_CBUS_PHY1_CBUS_DATA_TX_shift                                             (12)
#define MHL_CBUS_PHY1_CBUS_DATA_TX_mask                                              (0x00001000)
#define MHL_CBUS_PHY1_CBUS_DATA_TX(data)                                             (0x00001000&((data)<<12))
#define MHL_CBUS_PHY1_CBUS_DATA_TX_src(data)                                         ((0x00001000&(data))>>12)
#define MHL_CBUS_PHY1_get_CBUS_DATA_TX(data)                                         ((0x00001000&(data))>>12)
#define MHL_CBUS_PHY1_HDMI_HPD_OUT_TX_shift                                          (11)
#define MHL_CBUS_PHY1_HDMI_HPD_OUT_TX_mask                                           (0x00000800)
#define MHL_CBUS_PHY1_HDMI_HPD_OUT_TX(data)                                          (0x00000800&((data)<<11))
#define MHL_CBUS_PHY1_HDMI_HPD_OUT_TX_src(data)                                      ((0x00000800&(data))>>11)
#define MHL_CBUS_PHY1_get_HDMI_HPD_OUT_TX(data)                                      ((0x00000800&(data))>>11)
#define MHL_CBUS_PHY1_REGO_MHL_HPD_DET_TX_shift                                      (10)
#define MHL_CBUS_PHY1_REGO_MHL_HPD_DET_TX_mask                                       (0x00000400)
#define MHL_CBUS_PHY1_REGO_MHL_HPD_DET_TX(data)                                      (0x00000400&((data)<<10))
#define MHL_CBUS_PHY1_REGO_MHL_HPD_DET_TX_src(data)                                  ((0x00000400&(data))>>10)
#define MHL_CBUS_PHY1_get_REGO_MHL_HPD_DET_TX(data)                                  ((0x00000400&(data))>>10)
#define MHL_CBUS_PHY1_REGO_MHL_R1K_DET_TX_shift                                      (9)
#define MHL_CBUS_PHY1_REGO_MHL_R1K_DET_TX_mask                                       (0x00000200)
#define MHL_CBUS_PHY1_REGO_MHL_R1K_DET_TX(data)                                      (0x00000200&((data)<<9))
#define MHL_CBUS_PHY1_REGO_MHL_R1K_DET_TX_src(data)                                  ((0x00000200&(data))>>9)
#define MHL_CBUS_PHY1_get_REGO_MHL_R1K_DET_TX(data)                                  ((0x00000200&(data))>>9)
#define MHL_CBUS_PHY1_TEST_OUT_shift                                                 (4)
#define MHL_CBUS_PHY1_TEST_OUT_mask                                                  (0x000001F0)
#define MHL_CBUS_PHY1_TEST_OUT(data)                                                 (0x000001F0&((data)<<4))
#define MHL_CBUS_PHY1_TEST_OUT_src(data)                                             ((0x000001F0&(data))>>4)
#define MHL_CBUS_PHY1_get_TEST_OUT(data)                                             ((0x000001F0&(data))>>4)
#define MHL_CBUS_PHY1_DATA_IN_TX_shift                                               (3)
#define MHL_CBUS_PHY1_DATA_IN_TX_mask                                                (0x00000008)
#define MHL_CBUS_PHY1_DATA_IN_TX(data)                                               (0x00000008&((data)<<3))
#define MHL_CBUS_PHY1_DATA_IN_TX_src(data)                                           ((0x00000008&(data))>>3)
#define MHL_CBUS_PHY1_get_DATA_IN_TX(data)                                           ((0x00000008&(data))>>3)
#define MHL_CBUS_PHY1_CBUS_EN_TX_shift                                               (2)
#define MHL_CBUS_PHY1_CBUS_EN_TX_mask                                                (0x00000004)
#define MHL_CBUS_PHY1_CBUS_EN_TX(data)                                               (0x00000004&((data)<<2))
#define MHL_CBUS_PHY1_CBUS_EN_TX_src(data)                                           ((0x00000004&(data))>>2)
#define MHL_CBUS_PHY1_get_CBUS_EN_TX(data)                                           ((0x00000004&(data))>>2)
#define MHL_CBUS_PHY1_EN_R10K_TX_shift                                               (0)
#define MHL_CBUS_PHY1_EN_R10K_TX_mask                                                (0x00000003)
#define MHL_CBUS_PHY1_EN_R10K_TX(data)                                               (0x00000003&((data)<<0))
#define MHL_CBUS_PHY1_EN_R10K_TX_src(data)                                           ((0x00000003&(data))>>0)
#define MHL_CBUS_PHY1_get_EN_R10K_TX(data)                                           ((0x00000003&(data))>>0)


#define MHL_MSC_REG_00                                                               0x18062C24
#define MHL_MSC_REG_00_reg_addr                                                      "0xB8062C24"
#define MHL_MSC_REG_00_reg                                                           0xB8062C24
#define set_MHL_MSC_REG_00_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_00_reg)=data)
#define get_MHL_MSC_REG_00_reg   (*((volatile unsigned int*) MHL_MSC_REG_00_reg))
#define MHL_MSC_REG_00_inst_adr                                                      "0x0009"
#define MHL_MSC_REG_00_inst                                                          0x0009
#define MHL_MSC_REG_00_dev_state_shift                                               (0)
#define MHL_MSC_REG_00_dev_state_mask                                                (0x000000FF)
#define MHL_MSC_REG_00_dev_state(data)                                               (0x000000FF&((data)<<0))
#define MHL_MSC_REG_00_dev_state_src(data)                                           ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_00_get_dev_state(data)                                           ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_01                                                               0x18062C28
#define MHL_MSC_REG_01_reg_addr                                                      "0xB8062C28"
#define MHL_MSC_REG_01_reg                                                           0xB8062C28
#define set_MHL_MSC_REG_01_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_01_reg)=data)
#define get_MHL_MSC_REG_01_reg   (*((volatile unsigned int*) MHL_MSC_REG_01_reg))
#define MHL_MSC_REG_01_inst_adr                                                      "0x000A"
#define MHL_MSC_REG_01_inst                                                          0x000A
#define MHL_MSC_REG_01_mhl_ver_shift                                                 (0)
#define MHL_MSC_REG_01_mhl_ver_mask                                                  (0x000000FF)
#define MHL_MSC_REG_01_mhl_ver(data)                                                 (0x000000FF&((data)<<0))
#define MHL_MSC_REG_01_mhl_ver_src(data)                                             ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_01_get_mhl_ver(data)                                             ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_02                                                               0x18062C2C
#define MHL_MSC_REG_02_reg_addr                                                      "0xB8062C2C"
#define MHL_MSC_REG_02_reg                                                           0xB8062C2C
#define set_MHL_MSC_REG_02_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_02_reg)=data)
#define get_MHL_MSC_REG_02_reg   (*((volatile unsigned int*) MHL_MSC_REG_02_reg))
#define MHL_MSC_REG_02_inst_adr                                                      "0x000B"
#define MHL_MSC_REG_02_inst                                                          0x000B
#define MHL_MSC_REG_02_dev_cat_shift                                                 (7)
#define MHL_MSC_REG_02_dev_cat_mask                                                  (0x00000080)
#define MHL_MSC_REG_02_dev_cat(data)                                                 (0x00000080&((data)<<7))
#define MHL_MSC_REG_02_dev_cat_src(data)                                             ((0x00000080&(data))>>7)
#define MHL_MSC_REG_02_get_dev_cat(data)                                             ((0x00000080&(data))>>7)
#define MHL_MSC_REG_02_plim_shift                                                    (5)
#define MHL_MSC_REG_02_plim_mask                                                     (0x00000060)
#define MHL_MSC_REG_02_plim(data)                                                    (0x00000060&((data)<<5))
#define MHL_MSC_REG_02_plim_src(data)                                                ((0x00000060&(data))>>5)
#define MHL_MSC_REG_02_get_plim(data)                                                ((0x00000060&(data))>>5)
#define MHL_MSC_REG_02_pow_shift                                                     (4)
#define MHL_MSC_REG_02_pow_mask                                                      (0x00000010)
#define MHL_MSC_REG_02_pow(data)                                                     (0x00000010&((data)<<4))
#define MHL_MSC_REG_02_pow_src(data)                                                 ((0x00000010&(data))>>4)
#define MHL_MSC_REG_02_get_pow(data)                                                 ((0x00000010&(data))>>4)
#define MHL_MSC_REG_02_dev_type_shift                                                (0)
#define MHL_MSC_REG_02_dev_type_mask                                                 (0x0000000F)
#define MHL_MSC_REG_02_dev_type(data)                                                (0x0000000F&((data)<<0))
#define MHL_MSC_REG_02_dev_type_src(data)                                            ((0x0000000F&(data))>>0)
#define MHL_MSC_REG_02_get_dev_type(data)                                            ((0x0000000F&(data))>>0)


#define MHL_MSC_REG_03                                                               0x18062C30
#define MHL_MSC_REG_03_reg_addr                                                      "0xB8062C30"
#define MHL_MSC_REG_03_reg                                                           0xB8062C30
#define set_MHL_MSC_REG_03_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_03_reg)=data)
#define get_MHL_MSC_REG_03_reg   (*((volatile unsigned int*) MHL_MSC_REG_03_reg))
#define MHL_MSC_REG_03_inst_adr                                                      "0x000C"
#define MHL_MSC_REG_03_inst                                                          0x000C
#define MHL_MSC_REG_03_adop_id_h_shift                                               (0)
#define MHL_MSC_REG_03_adop_id_h_mask                                                (0x000000FF)
#define MHL_MSC_REG_03_adop_id_h(data)                                               (0x000000FF&((data)<<0))
#define MHL_MSC_REG_03_adop_id_h_src(data)                                           ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_03_get_adop_id_h(data)                                           ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_04                                                               0x18062C34
#define MHL_MSC_REG_04_reg_addr                                                      "0xB8062C34"
#define MHL_MSC_REG_04_reg                                                           0xB8062C34
#define set_MHL_MSC_REG_04_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_04_reg)=data)
#define get_MHL_MSC_REG_04_reg   (*((volatile unsigned int*) MHL_MSC_REG_04_reg))
#define MHL_MSC_REG_04_inst_adr                                                      "0x000D"
#define MHL_MSC_REG_04_inst                                                          0x000D
#define MHL_MSC_REG_04_adop_id_l_shift                                               (0)
#define MHL_MSC_REG_04_adop_id_l_mask                                                (0x000000FF)
#define MHL_MSC_REG_04_adop_id_l(data)                                               (0x000000FF&((data)<<0))
#define MHL_MSC_REG_04_adop_id_l_src(data)                                           ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_04_get_adop_id_l(data)                                           ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_05                                                               0x18062C38
#define MHL_MSC_REG_05_reg_addr                                                      "0xB8062C38"
#define MHL_MSC_REG_05_reg                                                           0xB8062C38
#define set_MHL_MSC_REG_05_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_05_reg)=data)
#define get_MHL_MSC_REG_05_reg   (*((volatile unsigned int*) MHL_MSC_REG_05_reg))
#define MHL_MSC_REG_05_inst_adr                                                      "0x000E"
#define MHL_MSC_REG_05_inst                                                          0x000E
#define MHL_MSC_REG_05_vid_link_mode_shift                                           (6)
#define MHL_MSC_REG_05_vid_link_mode_mask                                            (0x000000C0)
#define MHL_MSC_REG_05_vid_link_mode(data)                                           (0x000000C0&((data)<<6))
#define MHL_MSC_REG_05_vid_link_mode_src(data)                                       ((0x000000C0&(data))>>6)
#define MHL_MSC_REG_05_get_vid_link_mode(data)                                       ((0x000000C0&(data))>>6)
#define MHL_MSC_REG_05_supp_vga_shift                                                (5)
#define MHL_MSC_REG_05_supp_vga_mask                                                 (0x00000020)
#define MHL_MSC_REG_05_supp_vga(data)                                                (0x00000020&((data)<<5))
#define MHL_MSC_REG_05_supp_vga_src(data)                                            ((0x00000020&(data))>>5)
#define MHL_MSC_REG_05_get_supp_vga(data)                                            ((0x00000020&(data))>>5)
#define MHL_MSC_REG_05_supp_islands_shift                                            (4)
#define MHL_MSC_REG_05_supp_islands_mask                                             (0x00000010)
#define MHL_MSC_REG_05_supp_islands(data)                                            (0x00000010&((data)<<4))
#define MHL_MSC_REG_05_supp_islands_src(data)                                        ((0x00000010&(data))>>4)
#define MHL_MSC_REG_05_get_supp_islands(data)                                        ((0x00000010&(data))>>4)
#define MHL_MSC_REG_05_supp_ppixel_shift                                             (3)
#define MHL_MSC_REG_05_supp_ppixel_mask                                              (0x00000008)
#define MHL_MSC_REG_05_supp_ppixel(data)                                             (0x00000008&((data)<<3))
#define MHL_MSC_REG_05_supp_ppixel_src(data)                                         ((0x00000008&(data))>>3)
#define MHL_MSC_REG_05_get_supp_ppixel(data)                                         ((0x00000008&(data))>>3)
#define MHL_MSC_REG_05_supp_yuv422_shift                                             (2)
#define MHL_MSC_REG_05_supp_yuv422_mask                                              (0x00000004)
#define MHL_MSC_REG_05_supp_yuv422(data)                                             (0x00000004&((data)<<2))
#define MHL_MSC_REG_05_supp_yuv422_src(data)                                         ((0x00000004&(data))>>2)
#define MHL_MSC_REG_05_get_supp_yuv422(data)                                         ((0x00000004&(data))>>2)
#define MHL_MSC_REG_05_supp_yuv444_shift                                             (1)
#define MHL_MSC_REG_05_supp_yuv444_mask                                              (0x00000002)
#define MHL_MSC_REG_05_supp_yuv444(data)                                             (0x00000002&((data)<<1))
#define MHL_MSC_REG_05_supp_yuv444_src(data)                                         ((0x00000002&(data))>>1)
#define MHL_MSC_REG_05_get_supp_yuv444(data)                                         ((0x00000002&(data))>>1)
#define MHL_MSC_REG_05_supp_rgb444_shift                                             (0)
#define MHL_MSC_REG_05_supp_rgb444_mask                                              (0x00000001)
#define MHL_MSC_REG_05_supp_rgb444(data)                                             (0x00000001&((data)<<0))
#define MHL_MSC_REG_05_supp_rgb444_src(data)                                         ((0x00000001&(data))>>0)
#define MHL_MSC_REG_05_get_supp_rgb444(data)                                         ((0x00000001&(data))>>0)


#define MHL_MSC_REG_06                                                               0x18062C3C
#define MHL_MSC_REG_06_reg_addr                                                      "0xB8062C3C"
#define MHL_MSC_REG_06_reg                                                           0xB8062C3C
#define set_MHL_MSC_REG_06_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_06_reg)=data)
#define get_MHL_MSC_REG_06_reg   (*((volatile unsigned int*) MHL_MSC_REG_06_reg))
#define MHL_MSC_REG_06_inst_adr                                                      "0x000F"
#define MHL_MSC_REG_06_inst                                                          0x000F
#define MHL_MSC_REG_06_aud_link_mode_shift                                           (2)
#define MHL_MSC_REG_06_aud_link_mode_mask                                            (0x000000FC)
#define MHL_MSC_REG_06_aud_link_mode(data)                                           (0x000000FC&((data)<<2))
#define MHL_MSC_REG_06_aud_link_mode_src(data)                                       ((0x000000FC&(data))>>2)
#define MHL_MSC_REG_06_get_aud_link_mode(data)                                       ((0x000000FC&(data))>>2)
#define MHL_MSC_REG_06_aud_8ch_shift                                                 (1)
#define MHL_MSC_REG_06_aud_8ch_mask                                                  (0x00000002)
#define MHL_MSC_REG_06_aud_8ch(data)                                                 (0x00000002&((data)<<1))
#define MHL_MSC_REG_06_aud_8ch_src(data)                                             ((0x00000002&(data))>>1)
#define MHL_MSC_REG_06_get_aud_8ch(data)                                             ((0x00000002&(data))>>1)
#define MHL_MSC_REG_06_aud_2ch_shift                                                 (0)
#define MHL_MSC_REG_06_aud_2ch_mask                                                  (0x00000001)
#define MHL_MSC_REG_06_aud_2ch(data)                                                 (0x00000001&((data)<<0))
#define MHL_MSC_REG_06_aud_2ch_src(data)                                             ((0x00000001&(data))>>0)
#define MHL_MSC_REG_06_get_aud_2ch(data)                                             ((0x00000001&(data))>>0)


#define MHL_MSC_REG_07                                                               0x18062C40
#define MHL_MSC_REG_07_reg_addr                                                      "0xB8062C40"
#define MHL_MSC_REG_07_reg                                                           0xB8062C40
#define set_MHL_MSC_REG_07_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_07_reg)=data)
#define get_MHL_MSC_REG_07_reg   (*((volatile unsigned int*) MHL_MSC_REG_07_reg))
#define MHL_MSC_REG_07_inst_adr                                                      "0x0010"
#define MHL_MSC_REG_07_inst                                                          0x0010
#define MHL_MSC_REG_07_supp_vt_shift                                                 (7)
#define MHL_MSC_REG_07_supp_vt_mask                                                  (0x00000080)
#define MHL_MSC_REG_07_supp_vt(data)                                                 (0x00000080&((data)<<7))
#define MHL_MSC_REG_07_supp_vt_src(data)                                             ((0x00000080&(data))>>7)
#define MHL_MSC_REG_07_get_supp_vt(data)                                             ((0x00000080&(data))>>7)
#define MHL_MSC_REG_07_video_type_shift                                              (4)
#define MHL_MSC_REG_07_video_type_mask                                               (0x00000070)
#define MHL_MSC_REG_07_video_type(data)                                              (0x00000070&((data)<<4))
#define MHL_MSC_REG_07_video_type_src(data)                                          ((0x00000070&(data))>>4)
#define MHL_MSC_REG_07_get_video_type(data)                                          ((0x00000070&(data))>>4)
#define MHL_MSC_REG_07_vt_game_shift                                                 (3)
#define MHL_MSC_REG_07_vt_game_mask                                                  (0x00000008)
#define MHL_MSC_REG_07_vt_game(data)                                                 (0x00000008&((data)<<3))
#define MHL_MSC_REG_07_vt_game_src(data)                                             ((0x00000008&(data))>>3)
#define MHL_MSC_REG_07_get_vt_game(data)                                             ((0x00000008&(data))>>3)
#define MHL_MSC_REG_07_vt_cinema_shift                                               (2)
#define MHL_MSC_REG_07_vt_cinema_mask                                                (0x00000004)
#define MHL_MSC_REG_07_vt_cinema(data)                                               (0x00000004&((data)<<2))
#define MHL_MSC_REG_07_vt_cinema_src(data)                                           ((0x00000004&(data))>>2)
#define MHL_MSC_REG_07_get_vt_cinema(data)                                           ((0x00000004&(data))>>2)
#define MHL_MSC_REG_07_vt_photo_shift                                                (1)
#define MHL_MSC_REG_07_vt_photo_mask                                                 (0x00000002)
#define MHL_MSC_REG_07_vt_photo(data)                                                (0x00000002&((data)<<1))
#define MHL_MSC_REG_07_vt_photo_src(data)                                            ((0x00000002&(data))>>1)
#define MHL_MSC_REG_07_get_vt_photo(data)                                            ((0x00000002&(data))>>1)
#define MHL_MSC_REG_07_vt_graphics_shift                                             (0)
#define MHL_MSC_REG_07_vt_graphics_mask                                              (0x00000001)
#define MHL_MSC_REG_07_vt_graphics(data)                                             (0x00000001&((data)<<0))
#define MHL_MSC_REG_07_vt_graphics_src(data)                                         ((0x00000001&(data))>>0)
#define MHL_MSC_REG_07_get_vt_graphics(data)                                         ((0x00000001&(data))>>0)


#define MHL_MSC_REG_08                                                               0x18062C44
#define MHL_MSC_REG_08_reg_addr                                                      "0xB8062C44"
#define MHL_MSC_REG_08_reg                                                           0xB8062C44
#define set_MHL_MSC_REG_08_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_08_reg)=data)
#define get_MHL_MSC_REG_08_reg   (*((volatile unsigned int*) MHL_MSC_REG_08_reg))
#define MHL_MSC_REG_08_inst_adr                                                      "0x0011"
#define MHL_MSC_REG_08_inst                                                          0x0011
#define MHL_MSC_REG_08_ld_gui_shift                                                  (7)
#define MHL_MSC_REG_08_ld_gui_mask                                                   (0x00000080)
#define MHL_MSC_REG_08_ld_gui(data)                                                  (0x00000080&((data)<<7))
#define MHL_MSC_REG_08_ld_gui_src(data)                                              ((0x00000080&(data))>>7)
#define MHL_MSC_REG_08_get_ld_gui(data)                                              ((0x00000080&(data))>>7)
#define MHL_MSC_REG_08_ld_speaker_shift                                              (6)
#define MHL_MSC_REG_08_ld_speaker_mask                                               (0x00000040)
#define MHL_MSC_REG_08_ld_speaker(data)                                              (0x00000040&((data)<<6))
#define MHL_MSC_REG_08_ld_speaker_src(data)                                          ((0x00000040&(data))>>6)
#define MHL_MSC_REG_08_get_ld_speaker(data)                                          ((0x00000040&(data))>>6)
#define MHL_MSC_REG_08_ld_record_shift                                               (5)
#define MHL_MSC_REG_08_ld_record_mask                                                (0x00000020)
#define MHL_MSC_REG_08_ld_record(data)                                               (0x00000020&((data)<<5))
#define MHL_MSC_REG_08_ld_record_src(data)                                           ((0x00000020&(data))>>5)
#define MHL_MSC_REG_08_get_ld_record(data)                                           ((0x00000020&(data))>>5)
#define MHL_MSC_REG_08_ld_tuner_shift                                                (4)
#define MHL_MSC_REG_08_ld_tuner_mask                                                 (0x00000010)
#define MHL_MSC_REG_08_ld_tuner(data)                                                (0x00000010&((data)<<4))
#define MHL_MSC_REG_08_ld_tuner_src(data)                                            ((0x00000010&(data))>>4)
#define MHL_MSC_REG_08_get_ld_tuner(data)                                            ((0x00000010&(data))>>4)
#define MHL_MSC_REG_08_ld_media_shift                                                (3)
#define MHL_MSC_REG_08_ld_media_mask                                                 (0x00000008)
#define MHL_MSC_REG_08_ld_media(data)                                                (0x00000008&((data)<<3))
#define MHL_MSC_REG_08_ld_media_src(data)                                            ((0x00000008&(data))>>3)
#define MHL_MSC_REG_08_get_ld_media(data)                                            ((0x00000008&(data))>>3)
#define MHL_MSC_REG_08_ld_audio_shift                                                (2)
#define MHL_MSC_REG_08_ld_audio_mask                                                 (0x00000004)
#define MHL_MSC_REG_08_ld_audio(data)                                                (0x00000004&((data)<<2))
#define MHL_MSC_REG_08_ld_audio_src(data)                                            ((0x00000004&(data))>>2)
#define MHL_MSC_REG_08_get_ld_audio(data)                                            ((0x00000004&(data))>>2)
#define MHL_MSC_REG_08_ld_video_shift                                                (1)
#define MHL_MSC_REG_08_ld_video_mask                                                 (0x00000002)
#define MHL_MSC_REG_08_ld_video(data)                                                (0x00000002&((data)<<1))
#define MHL_MSC_REG_08_ld_video_src(data)                                            ((0x00000002&(data))>>1)
#define MHL_MSC_REG_08_get_ld_video(data)                                            ((0x00000002&(data))>>1)
#define MHL_MSC_REG_08_ld_display_shift                                              (0)
#define MHL_MSC_REG_08_ld_display_mask                                               (0x00000001)
#define MHL_MSC_REG_08_ld_display(data)                                              (0x00000001&((data)<<0))
#define MHL_MSC_REG_08_ld_display_src(data)                                          ((0x00000001&(data))>>0)
#define MHL_MSC_REG_08_get_ld_display(data)                                          ((0x00000001&(data))>>0)


#define MHL_MSC_REG_09                                                               0x18062C48
#define MHL_MSC_REG_09_reg_addr                                                      "0xB8062C48"
#define MHL_MSC_REG_09_reg                                                           0xB8062C48
#define set_MHL_MSC_REG_09_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_09_reg)=data)
#define get_MHL_MSC_REG_09_reg   (*((volatile unsigned int*) MHL_MSC_REG_09_reg))
#define MHL_MSC_REG_09_inst_adr                                                      "0x0012"
#define MHL_MSC_REG_09_inst                                                          0x0012
#define MHL_MSC_REG_09_bandwid_shift                                                 (0)
#define MHL_MSC_REG_09_bandwid_mask                                                  (0x000000FF)
#define MHL_MSC_REG_09_bandwid(data)                                                 (0x000000FF&((data)<<0))
#define MHL_MSC_REG_09_bandwid_src(data)                                             ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_09_get_bandwid(data)                                             ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_0A                                                               0x18062C4C
#define MHL_MSC_REG_0A_reg_addr                                                      "0xB8062C4C"
#define MHL_MSC_REG_0A_reg                                                           0xB8062C4C
#define set_MHL_MSC_REG_0A_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_0A_reg)=data)
#define get_MHL_MSC_REG_0A_reg   (*((volatile unsigned int*) MHL_MSC_REG_0A_reg))
#define MHL_MSC_REG_0A_inst_adr                                                      "0x0013"
#define MHL_MSC_REG_0A_inst                                                          0x0013
#define MHL_MSC_REG_0A_feature_flag_shift                                            (5)
#define MHL_MSC_REG_0A_feature_flag_mask                                             (0x000000E0)
#define MHL_MSC_REG_0A_feature_flag(data)                                            (0x000000E0&((data)<<5))
#define MHL_MSC_REG_0A_feature_flag_src(data)                                        ((0x000000E0&(data))>>5)
#define MHL_MSC_REG_0A_get_feature_flag(data)                                        ((0x000000E0&(data))>>5)
#define MHL_MSC_REG_0A_ucp_recv_supp_shift                                           (4)
#define MHL_MSC_REG_0A_ucp_recv_supp_mask                                            (0x00000010)
#define MHL_MSC_REG_0A_ucp_recv_supp(data)                                           (0x00000010&((data)<<4))
#define MHL_MSC_REG_0A_ucp_recv_supp_src(data)                                       ((0x00000010&(data))>>4)
#define MHL_MSC_REG_0A_get_ucp_recv_supp(data)                                       ((0x00000010&(data))>>4)
#define MHL_MSC_REG_0A_ucp_send_supp_shift                                           (3)
#define MHL_MSC_REG_0A_ucp_send_supp_mask                                            (0x00000008)
#define MHL_MSC_REG_0A_ucp_send_supp(data)                                           (0x00000008&((data)<<3))
#define MHL_MSC_REG_0A_ucp_send_supp_src(data)                                       ((0x00000008&(data))>>3)
#define MHL_MSC_REG_0A_get_ucp_send_supp(data)                                       ((0x00000008&(data))>>3)
#define MHL_MSC_REG_0A_sp_supp_shift                                                 (2)
#define MHL_MSC_REG_0A_sp_supp_mask                                                  (0x00000004)
#define MHL_MSC_REG_0A_sp_supp(data)                                                 (0x00000004&((data)<<2))
#define MHL_MSC_REG_0A_sp_supp_src(data)                                             ((0x00000004&(data))>>2)
#define MHL_MSC_REG_0A_get_sp_supp(data)                                             ((0x00000004&(data))>>2)
#define MHL_MSC_REG_0A_rap_supp_shift                                                (1)
#define MHL_MSC_REG_0A_rap_supp_mask                                                 (0x00000002)
#define MHL_MSC_REG_0A_rap_supp(data)                                                (0x00000002&((data)<<1))
#define MHL_MSC_REG_0A_rap_supp_src(data)                                            ((0x00000002&(data))>>1)
#define MHL_MSC_REG_0A_get_rap_supp(data)                                            ((0x00000002&(data))>>1)
#define MHL_MSC_REG_0A_rcp_supp_shift                                                (0)
#define MHL_MSC_REG_0A_rcp_supp_mask                                                 (0x00000001)
#define MHL_MSC_REG_0A_rcp_supp(data)                                                (0x00000001&((data)<<0))
#define MHL_MSC_REG_0A_rcp_supp_src(data)                                            ((0x00000001&(data))>>0)
#define MHL_MSC_REG_0A_get_rcp_supp(data)                                            ((0x00000001&(data))>>0)


#define MHL_MSC_REG_0B                                                               0x18062C50
#define MHL_MSC_REG_0B_reg_addr                                                      "0xB8062C50"
#define MHL_MSC_REG_0B_reg                                                           0xB8062C50
#define set_MHL_MSC_REG_0B_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_0B_reg)=data)
#define get_MHL_MSC_REG_0B_reg   (*((volatile unsigned int*) MHL_MSC_REG_0B_reg))
#define MHL_MSC_REG_0B_inst_adr                                                      "0x0014"
#define MHL_MSC_REG_0B_inst                                                          0x0014
#define MHL_MSC_REG_0B_device_id_h_shift                                             (0)
#define MHL_MSC_REG_0B_device_id_h_mask                                              (0x000000FF)
#define MHL_MSC_REG_0B_device_id_h(data)                                             (0x000000FF&((data)<<0))
#define MHL_MSC_REG_0B_device_id_h_src(data)                                         ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_0B_get_device_id_h(data)                                         ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_0C                                                               0x18062C54
#define MHL_MSC_REG_0C_reg_addr                                                      "0xB8062C54"
#define MHL_MSC_REG_0C_reg                                                           0xB8062C54
#define set_MHL_MSC_REG_0C_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_0C_reg)=data)
#define get_MHL_MSC_REG_0C_reg   (*((volatile unsigned int*) MHL_MSC_REG_0C_reg))
#define MHL_MSC_REG_0C_inst_adr                                                      "0x0015"
#define MHL_MSC_REG_0C_inst                                                          0x0015
#define MHL_MSC_REG_0C_device_id_l_shift                                             (0)
#define MHL_MSC_REG_0C_device_id_l_mask                                              (0x000000FF)
#define MHL_MSC_REG_0C_device_id_l(data)                                             (0x000000FF&((data)<<0))
#define MHL_MSC_REG_0C_device_id_l_src(data)                                         ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_0C_get_device_id_l(data)                                         ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_0D                                                               0x18062C58
#define MHL_MSC_REG_0D_reg_addr                                                      "0xB8062C58"
#define MHL_MSC_REG_0D_reg                                                           0xB8062C58
#define set_MHL_MSC_REG_0D_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_0D_reg)=data)
#define get_MHL_MSC_REG_0D_reg   (*((volatile unsigned int*) MHL_MSC_REG_0D_reg))
#define MHL_MSC_REG_0D_inst_adr                                                      "0x0016"
#define MHL_MSC_REG_0D_inst                                                          0x0016
#define MHL_MSC_REG_0D_scr_size_shift                                                (0)
#define MHL_MSC_REG_0D_scr_size_mask                                                 (0x000000FF)
#define MHL_MSC_REG_0D_scr_size(data)                                                (0x000000FF&((data)<<0))
#define MHL_MSC_REG_0D_scr_size_src(data)                                            ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_0D_get_scr_size(data)                                            ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_0E                                                               0x18062C5C
#define MHL_MSC_REG_0E_reg_addr                                                      "0xB8062C5C"
#define MHL_MSC_REG_0E_reg                                                           0xB8062C5C
#define set_MHL_MSC_REG_0E_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_0E_reg)=data)
#define get_MHL_MSC_REG_0E_reg   (*((volatile unsigned int*) MHL_MSC_REG_0E_reg))
#define MHL_MSC_REG_0E_inst_adr                                                      "0x0017"
#define MHL_MSC_REG_0E_inst                                                          0x0017
#define MHL_MSC_REG_0E_stat_size_shift                                               (4)
#define MHL_MSC_REG_0E_stat_size_mask                                                (0x000000F0)
#define MHL_MSC_REG_0E_stat_size(data)                                               (0x000000F0&((data)<<4))
#define MHL_MSC_REG_0E_stat_size_src(data)                                           ((0x000000F0&(data))>>4)
#define MHL_MSC_REG_0E_get_stat_size(data)                                           ((0x000000F0&(data))>>4)
#define MHL_MSC_REG_0E_int_size_shift                                                (0)
#define MHL_MSC_REG_0E_int_size_mask                                                 (0x0000000F)
#define MHL_MSC_REG_0E_int_size(data)                                                (0x0000000F&((data)<<0))
#define MHL_MSC_REG_0E_int_size_src(data)                                            ((0x0000000F&(data))>>0)
#define MHL_MSC_REG_0E_get_int_size(data)                                            ((0x0000000F&(data))>>0)


#define MHL_MSC_REG_0F                                                               0x18062C60
#define MHL_MSC_REG_0F_reg_addr                                                      "0xB8062C60"
#define MHL_MSC_REG_0F_reg                                                           0xB8062C60
#define set_MHL_MSC_REG_0F_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_0F_reg)=data)
#define get_MHL_MSC_REG_0F_reg   (*((volatile unsigned int*) MHL_MSC_REG_0F_reg))
#define MHL_MSC_REG_0F_inst_adr                                                      "0x0018"
#define MHL_MSC_REG_0F_inst                                                          0x0018
#define MHL_MSC_REG_0F_cap_0f_shift                                                  (0)
#define MHL_MSC_REG_0F_cap_0f_mask                                                   (0x000000FF)
#define MHL_MSC_REG_0F_cap_0f(data)                                                  (0x000000FF&((data)<<0))
#define MHL_MSC_REG_0F_cap_0f_src(data)                                              ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_0F_get_cap_0f(data)                                              ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_20                                                               0x18062C64
#define MHL_MSC_REG_20_reg_addr                                                      "0xB8062C64"
#define MHL_MSC_REG_20_reg                                                           0xB8062C64
#define set_MHL_MSC_REG_20_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_20_reg)=data)
#define get_MHL_MSC_REG_20_reg   (*((volatile unsigned int*) MHL_MSC_REG_20_reg))
#define MHL_MSC_REG_20_inst_adr                                                      "0x0019"
#define MHL_MSC_REG_20_inst                                                          0x0019
#define MHL_MSC_REG_20_rchg_int_shift                                                (5)
#define MHL_MSC_REG_20_rchg_int_mask                                                 (0x000000E0)
#define MHL_MSC_REG_20_rchg_int(data)                                                (0x000000E0&((data)<<5))
#define MHL_MSC_REG_20_rchg_int_src(data)                                            ((0x000000E0&(data))>>5)
#define MHL_MSC_REG_20_get_rchg_int(data)                                            ((0x000000E0&(data))>>5)
#define MHL_MSC_REG_20_3d_req_shift                                                  (4)
#define MHL_MSC_REG_20_3d_req_mask                                                   (0x00000010)
#define MHL_MSC_REG_20_3d_req(data)                                                  (0x00000010&((data)<<4))
#define MHL_MSC_REG_20_3d_req_src(data)                                              ((0x00000010&(data))>>4)
#define MHL_MSC_REG_20_get_3d_req(data)                                              ((0x00000010&(data))>>4)
#define MHL_MSC_REG_20_grt_wrt_shift                                                 (3)
#define MHL_MSC_REG_20_grt_wrt_mask                                                  (0x00000008)
#define MHL_MSC_REG_20_grt_wrt(data)                                                 (0x00000008&((data)<<3))
#define MHL_MSC_REG_20_grt_wrt_src(data)                                             ((0x00000008&(data))>>3)
#define MHL_MSC_REG_20_get_grt_wrt(data)                                             ((0x00000008&(data))>>3)
#define MHL_MSC_REG_20_req_wrt_shift                                                 (2)
#define MHL_MSC_REG_20_req_wrt_mask                                                  (0x00000004)
#define MHL_MSC_REG_20_req_wrt(data)                                                 (0x00000004&((data)<<2))
#define MHL_MSC_REG_20_req_wrt_src(data)                                             ((0x00000004&(data))>>2)
#define MHL_MSC_REG_20_get_req_wrt(data)                                             ((0x00000004&(data))>>2)
#define MHL_MSC_REG_20_dscr_chg_shift                                                (1)
#define MHL_MSC_REG_20_dscr_chg_mask                                                 (0x00000002)
#define MHL_MSC_REG_20_dscr_chg(data)                                                (0x00000002&((data)<<1))
#define MHL_MSC_REG_20_dscr_chg_src(data)                                            ((0x00000002&(data))>>1)
#define MHL_MSC_REG_20_get_dscr_chg(data)                                            ((0x00000002&(data))>>1)
#define MHL_MSC_REG_20_dcap_chg_shift                                                (0)
#define MHL_MSC_REG_20_dcap_chg_mask                                                 (0x00000001)
#define MHL_MSC_REG_20_dcap_chg(data)                                                (0x00000001&((data)<<0))
#define MHL_MSC_REG_20_dcap_chg_src(data)                                            ((0x00000001&(data))>>0)
#define MHL_MSC_REG_20_get_dcap_chg(data)                                            ((0x00000001&(data))>>0)


#define MHL_MSC_REG_21                                                               0x18062C68
#define MHL_MSC_REG_21_reg_addr                                                      "0xB8062C68"
#define MHL_MSC_REG_21_reg                                                           0xB8062C68
#define set_MHL_MSC_REG_21_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_21_reg)=data)
#define get_MHL_MSC_REG_21_reg   (*((volatile unsigned int*) MHL_MSC_REG_21_reg))
#define MHL_MSC_REG_21_inst_adr                                                      "0x001A"
#define MHL_MSC_REG_21_inst                                                          0x001A
#define MHL_MSC_REG_21_dchg_int_7_shift                                              (7)
#define MHL_MSC_REG_21_dchg_int_7_mask                                               (0x00000080)
#define MHL_MSC_REG_21_dchg_int_7(data)                                              (0x00000080&((data)<<7))
#define MHL_MSC_REG_21_dchg_int_7_src(data)                                          ((0x00000080&(data))>>7)
#define MHL_MSC_REG_21_get_dchg_int_7(data)                                          ((0x00000080&(data))>>7)
#define MHL_MSC_REG_21_dchg_int_6_shift                                              (6)
#define MHL_MSC_REG_21_dchg_int_6_mask                                               (0x00000040)
#define MHL_MSC_REG_21_dchg_int_6(data)                                              (0x00000040&((data)<<6))
#define MHL_MSC_REG_21_dchg_int_6_src(data)                                          ((0x00000040&(data))>>6)
#define MHL_MSC_REG_21_get_dchg_int_6(data)                                          ((0x00000040&(data))>>6)
#define MHL_MSC_REG_21_dchg_int_5_shift                                              (5)
#define MHL_MSC_REG_21_dchg_int_5_mask                                               (0x00000020)
#define MHL_MSC_REG_21_dchg_int_5(data)                                              (0x00000020&((data)<<5))
#define MHL_MSC_REG_21_dchg_int_5_src(data)                                          ((0x00000020&(data))>>5)
#define MHL_MSC_REG_21_get_dchg_int_5(data)                                          ((0x00000020&(data))>>5)
#define MHL_MSC_REG_21_dchg_int_4_shift                                              (4)
#define MHL_MSC_REG_21_dchg_int_4_mask                                               (0x00000010)
#define MHL_MSC_REG_21_dchg_int_4(data)                                              (0x00000010&((data)<<4))
#define MHL_MSC_REG_21_dchg_int_4_src(data)                                          ((0x00000010&(data))>>4)
#define MHL_MSC_REG_21_get_dchg_int_4(data)                                          ((0x00000010&(data))>>4)
#define MHL_MSC_REG_21_dchg_int_3_shift                                              (3)
#define MHL_MSC_REG_21_dchg_int_3_mask                                               (0x00000008)
#define MHL_MSC_REG_21_dchg_int_3(data)                                              (0x00000008&((data)<<3))
#define MHL_MSC_REG_21_dchg_int_3_src(data)                                          ((0x00000008&(data))>>3)
#define MHL_MSC_REG_21_get_dchg_int_3(data)                                          ((0x00000008&(data))>>3)
#define MHL_MSC_REG_21_dchg_int_2_shift                                              (2)
#define MHL_MSC_REG_21_dchg_int_2_mask                                               (0x00000004)
#define MHL_MSC_REG_21_dchg_int_2(data)                                              (0x00000004&((data)<<2))
#define MHL_MSC_REG_21_dchg_int_2_src(data)                                          ((0x00000004&(data))>>2)
#define MHL_MSC_REG_21_get_dchg_int_2(data)                                          ((0x00000004&(data))>>2)
#define MHL_MSC_REG_21_edid_chg_shift                                                (1)
#define MHL_MSC_REG_21_edid_chg_mask                                                 (0x00000002)
#define MHL_MSC_REG_21_edid_chg(data)                                                (0x00000002&((data)<<1))
#define MHL_MSC_REG_21_edid_chg_src(data)                                            ((0x00000002&(data))>>1)
#define MHL_MSC_REG_21_get_edid_chg(data)                                            ((0x00000002&(data))>>1)
#define MHL_MSC_REG_21_dchg_int_0_shift                                              (0)
#define MHL_MSC_REG_21_dchg_int_0_mask                                               (0x00000001)
#define MHL_MSC_REG_21_dchg_int_0(data)                                              (0x00000001&((data)<<0))
#define MHL_MSC_REG_21_dchg_int_0_src(data)                                          ((0x00000001&(data))>>0)
#define MHL_MSC_REG_21_get_dchg_int_0(data)                                          ((0x00000001&(data))>>0)


#define MHL_MSC_REG_22                                                               0x18062C6C
#define MHL_MSC_REG_22_reg_addr                                                      "0xB8062C6C"
#define MHL_MSC_REG_22_reg                                                           0xB8062C6C
#define set_MHL_MSC_REG_22_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_22_reg)=data)
#define get_MHL_MSC_REG_22_reg   (*((volatile unsigned int*) MHL_MSC_REG_22_reg))
#define MHL_MSC_REG_22_inst_adr                                                      "0x001B"
#define MHL_MSC_REG_22_inst                                                          0x001B
#define MHL_MSC_REG_22_chg22_7_shift                                                 (7)
#define MHL_MSC_REG_22_chg22_7_mask                                                  (0x00000080)
#define MHL_MSC_REG_22_chg22_7(data)                                                 (0x00000080&((data)<<7))
#define MHL_MSC_REG_22_chg22_7_src(data)                                             ((0x00000080&(data))>>7)
#define MHL_MSC_REG_22_get_chg22_7(data)                                             ((0x00000080&(data))>>7)
#define MHL_MSC_REG_22_chg22_6_shift                                                 (6)
#define MHL_MSC_REG_22_chg22_6_mask                                                  (0x00000040)
#define MHL_MSC_REG_22_chg22_6(data)                                                 (0x00000040&((data)<<6))
#define MHL_MSC_REG_22_chg22_6_src(data)                                             ((0x00000040&(data))>>6)
#define MHL_MSC_REG_22_get_chg22_6(data)                                             ((0x00000040&(data))>>6)
#define MHL_MSC_REG_22_chg22_5_shift                                                 (5)
#define MHL_MSC_REG_22_chg22_5_mask                                                  (0x00000020)
#define MHL_MSC_REG_22_chg22_5(data)                                                 (0x00000020&((data)<<5))
#define MHL_MSC_REG_22_chg22_5_src(data)                                             ((0x00000020&(data))>>5)
#define MHL_MSC_REG_22_get_chg22_5(data)                                             ((0x00000020&(data))>>5)
#define MHL_MSC_REG_22_chg22_4_shift                                                 (4)
#define MHL_MSC_REG_22_chg22_4_mask                                                  (0x00000010)
#define MHL_MSC_REG_22_chg22_4(data)                                                 (0x00000010&((data)<<4))
#define MHL_MSC_REG_22_chg22_4_src(data)                                             ((0x00000010&(data))>>4)
#define MHL_MSC_REG_22_get_chg22_4(data)                                             ((0x00000010&(data))>>4)
#define MHL_MSC_REG_22_chg22_3_shift                                                 (3)
#define MHL_MSC_REG_22_chg22_3_mask                                                  (0x00000008)
#define MHL_MSC_REG_22_chg22_3(data)                                                 (0x00000008&((data)<<3))
#define MHL_MSC_REG_22_chg22_3_src(data)                                             ((0x00000008&(data))>>3)
#define MHL_MSC_REG_22_get_chg22_3(data)                                             ((0x00000008&(data))>>3)
#define MHL_MSC_REG_22_chg22_2_shift                                                 (2)
#define MHL_MSC_REG_22_chg22_2_mask                                                  (0x00000004)
#define MHL_MSC_REG_22_chg22_2(data)                                                 (0x00000004&((data)<<2))
#define MHL_MSC_REG_22_chg22_2_src(data)                                             ((0x00000004&(data))>>2)
#define MHL_MSC_REG_22_get_chg22_2(data)                                             ((0x00000004&(data))>>2)
#define MHL_MSC_REG_22_chg22_1_shift                                                 (1)
#define MHL_MSC_REG_22_chg22_1_mask                                                  (0x00000002)
#define MHL_MSC_REG_22_chg22_1(data)                                                 (0x00000002&((data)<<1))
#define MHL_MSC_REG_22_chg22_1_src(data)                                             ((0x00000002&(data))>>1)
#define MHL_MSC_REG_22_get_chg22_1(data)                                             ((0x00000002&(data))>>1)
#define MHL_MSC_REG_22_chg22_0_shift                                                 (0)
#define MHL_MSC_REG_22_chg22_0_mask                                                  (0x00000001)
#define MHL_MSC_REG_22_chg22_0(data)                                                 (0x00000001&((data)<<0))
#define MHL_MSC_REG_22_chg22_0_src(data)                                             ((0x00000001&(data))>>0)
#define MHL_MSC_REG_22_get_chg22_0(data)                                             ((0x00000001&(data))>>0)


#define MHL_MSC_REG_23                                                               0x18062C70
#define MHL_MSC_REG_23_reg_addr                                                      "0xB8062C70"
#define MHL_MSC_REG_23_reg                                                           0xB8062C70
#define set_MHL_MSC_REG_23_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_23_reg)=data)
#define get_MHL_MSC_REG_23_reg   (*((volatile unsigned int*) MHL_MSC_REG_23_reg))
#define MHL_MSC_REG_23_inst_adr                                                      "0x001C"
#define MHL_MSC_REG_23_inst                                                          0x001C
#define MHL_MSC_REG_23_chg23_7_shift                                                 (7)
#define MHL_MSC_REG_23_chg23_7_mask                                                  (0x00000080)
#define MHL_MSC_REG_23_chg23_7(data)                                                 (0x00000080&((data)<<7))
#define MHL_MSC_REG_23_chg23_7_src(data)                                             ((0x00000080&(data))>>7)
#define MHL_MSC_REG_23_get_chg23_7(data)                                             ((0x00000080&(data))>>7)
#define MHL_MSC_REG_23_chg23_6_shift                                                 (6)
#define MHL_MSC_REG_23_chg23_6_mask                                                  (0x00000040)
#define MHL_MSC_REG_23_chg23_6(data)                                                 (0x00000040&((data)<<6))
#define MHL_MSC_REG_23_chg23_6_src(data)                                             ((0x00000040&(data))>>6)
#define MHL_MSC_REG_23_get_chg23_6(data)                                             ((0x00000040&(data))>>6)
#define MHL_MSC_REG_23_chg23_5_shift                                                 (5)
#define MHL_MSC_REG_23_chg23_5_mask                                                  (0x00000020)
#define MHL_MSC_REG_23_chg23_5(data)                                                 (0x00000020&((data)<<5))
#define MHL_MSC_REG_23_chg23_5_src(data)                                             ((0x00000020&(data))>>5)
#define MHL_MSC_REG_23_get_chg23_5(data)                                             ((0x00000020&(data))>>5)
#define MHL_MSC_REG_23_chg23_4_shift                                                 (4)
#define MHL_MSC_REG_23_chg23_4_mask                                                  (0x00000010)
#define MHL_MSC_REG_23_chg23_4(data)                                                 (0x00000010&((data)<<4))
#define MHL_MSC_REG_23_chg23_4_src(data)                                             ((0x00000010&(data))>>4)
#define MHL_MSC_REG_23_get_chg23_4(data)                                             ((0x00000010&(data))>>4)
#define MHL_MSC_REG_23_chg23_3_shift                                                 (3)
#define MHL_MSC_REG_23_chg23_3_mask                                                  (0x00000008)
#define MHL_MSC_REG_23_chg23_3(data)                                                 (0x00000008&((data)<<3))
#define MHL_MSC_REG_23_chg23_3_src(data)                                             ((0x00000008&(data))>>3)
#define MHL_MSC_REG_23_get_chg23_3(data)                                             ((0x00000008&(data))>>3)
#define MHL_MSC_REG_23_chg23_2_shift                                                 (2)
#define MHL_MSC_REG_23_chg23_2_mask                                                  (0x00000004)
#define MHL_MSC_REG_23_chg23_2(data)                                                 (0x00000004&((data)<<2))
#define MHL_MSC_REG_23_chg23_2_src(data)                                             ((0x00000004&(data))>>2)
#define MHL_MSC_REG_23_get_chg23_2(data)                                             ((0x00000004&(data))>>2)
#define MHL_MSC_REG_23_chg23_1_shift                                                 (1)
#define MHL_MSC_REG_23_chg23_1_mask                                                  (0x00000002)
#define MHL_MSC_REG_23_chg23_1(data)                                                 (0x00000002&((data)<<1))
#define MHL_MSC_REG_23_chg23_1_src(data)                                             ((0x00000002&(data))>>1)
#define MHL_MSC_REG_23_get_chg23_1(data)                                             ((0x00000002&(data))>>1)
#define MHL_MSC_REG_23_chg23_0_shift                                                 (0)
#define MHL_MSC_REG_23_chg23_0_mask                                                  (0x00000001)
#define MHL_MSC_REG_23_chg23_0(data)                                                 (0x00000001&((data)<<0))
#define MHL_MSC_REG_23_chg23_0_src(data)                                             ((0x00000001&(data))>>0)
#define MHL_MSC_REG_23_get_chg23_0(data)                                             ((0x00000001&(data))>>0)


#define MHL_MSC_REG_24                                                               0x18062C74
#define MHL_MSC_REG_24_reg_addr                                                      "0xB8062C74"
#define MHL_MSC_REG_24_reg                                                           0xB8062C74
#define set_MHL_MSC_REG_24_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_24_reg)=data)
#define get_MHL_MSC_REG_24_reg   (*((volatile unsigned int*) MHL_MSC_REG_24_reg))
#define MHL_MSC_REG_24_inst_adr                                                      "0x001D"
#define MHL_MSC_REG_24_inst                                                          0x001D
#define MHL_MSC_REG_24_chg24_7_shift                                                 (7)
#define MHL_MSC_REG_24_chg24_7_mask                                                  (0x00000080)
#define MHL_MSC_REG_24_chg24_7(data)                                                 (0x00000080&((data)<<7))
#define MHL_MSC_REG_24_chg24_7_src(data)                                             ((0x00000080&(data))>>7)
#define MHL_MSC_REG_24_get_chg24_7(data)                                             ((0x00000080&(data))>>7)
#define MHL_MSC_REG_24_chg24_6_shift                                                 (6)
#define MHL_MSC_REG_24_chg24_6_mask                                                  (0x00000040)
#define MHL_MSC_REG_24_chg24_6(data)                                                 (0x00000040&((data)<<6))
#define MHL_MSC_REG_24_chg24_6_src(data)                                             ((0x00000040&(data))>>6)
#define MHL_MSC_REG_24_get_chg24_6(data)                                             ((0x00000040&(data))>>6)
#define MHL_MSC_REG_24_chg24_5_shift                                                 (5)
#define MHL_MSC_REG_24_chg24_5_mask                                                  (0x00000020)
#define MHL_MSC_REG_24_chg24_5(data)                                                 (0x00000020&((data)<<5))
#define MHL_MSC_REG_24_chg24_5_src(data)                                             ((0x00000020&(data))>>5)
#define MHL_MSC_REG_24_get_chg24_5(data)                                             ((0x00000020&(data))>>5)
#define MHL_MSC_REG_24_chg24_4_shift                                                 (4)
#define MHL_MSC_REG_24_chg24_4_mask                                                  (0x00000010)
#define MHL_MSC_REG_24_chg24_4(data)                                                 (0x00000010&((data)<<4))
#define MHL_MSC_REG_24_chg24_4_src(data)                                             ((0x00000010&(data))>>4)
#define MHL_MSC_REG_24_get_chg24_4(data)                                             ((0x00000010&(data))>>4)
#define MHL_MSC_REG_24_chg24_3_shift                                                 (3)
#define MHL_MSC_REG_24_chg24_3_mask                                                  (0x00000008)
#define MHL_MSC_REG_24_chg24_3(data)                                                 (0x00000008&((data)<<3))
#define MHL_MSC_REG_24_chg24_3_src(data)                                             ((0x00000008&(data))>>3)
#define MHL_MSC_REG_24_get_chg24_3(data)                                             ((0x00000008&(data))>>3)
#define MHL_MSC_REG_24_chg24_2_shift                                                 (2)
#define MHL_MSC_REG_24_chg24_2_mask                                                  (0x00000004)
#define MHL_MSC_REG_24_chg24_2(data)                                                 (0x00000004&((data)<<2))
#define MHL_MSC_REG_24_chg24_2_src(data)                                             ((0x00000004&(data))>>2)
#define MHL_MSC_REG_24_get_chg24_2(data)                                             ((0x00000004&(data))>>2)
#define MHL_MSC_REG_24_chg24_1_shift                                                 (1)
#define MHL_MSC_REG_24_chg24_1_mask                                                  (0x00000002)
#define MHL_MSC_REG_24_chg24_1(data)                                                 (0x00000002&((data)<<1))
#define MHL_MSC_REG_24_chg24_1_src(data)                                             ((0x00000002&(data))>>1)
#define MHL_MSC_REG_24_get_chg24_1(data)                                             ((0x00000002&(data))>>1)
#define MHL_MSC_REG_24_chg24_0_shift                                                 (0)
#define MHL_MSC_REG_24_chg24_0_mask                                                  (0x00000001)
#define MHL_MSC_REG_24_chg24_0(data)                                                 (0x00000001&((data)<<0))
#define MHL_MSC_REG_24_chg24_0_src(data)                                             ((0x00000001&(data))>>0)
#define MHL_MSC_REG_24_get_chg24_0(data)                                             ((0x00000001&(data))>>0)


#define MHL_MSC_REG_25                                                               0x18062C78
#define MHL_MSC_REG_25_reg_addr                                                      "0xB8062C78"
#define MHL_MSC_REG_25_reg                                                           0xB8062C78
#define set_MHL_MSC_REG_25_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_25_reg)=data)
#define get_MHL_MSC_REG_25_reg   (*((volatile unsigned int*) MHL_MSC_REG_25_reg))
#define MHL_MSC_REG_25_inst_adr                                                      "0x001E"
#define MHL_MSC_REG_25_inst                                                          0x001E
#define MHL_MSC_REG_25_chg25_7_shift                                                 (7)
#define MHL_MSC_REG_25_chg25_7_mask                                                  (0x00000080)
#define MHL_MSC_REG_25_chg25_7(data)                                                 (0x00000080&((data)<<7))
#define MHL_MSC_REG_25_chg25_7_src(data)                                             ((0x00000080&(data))>>7)
#define MHL_MSC_REG_25_get_chg25_7(data)                                             ((0x00000080&(data))>>7)
#define MHL_MSC_REG_25_chg25_6_shift                                                 (6)
#define MHL_MSC_REG_25_chg25_6_mask                                                  (0x00000040)
#define MHL_MSC_REG_25_chg25_6(data)                                                 (0x00000040&((data)<<6))
#define MHL_MSC_REG_25_chg25_6_src(data)                                             ((0x00000040&(data))>>6)
#define MHL_MSC_REG_25_get_chg25_6(data)                                             ((0x00000040&(data))>>6)
#define MHL_MSC_REG_25_chg25_5_shift                                                 (5)
#define MHL_MSC_REG_25_chg25_5_mask                                                  (0x00000020)
#define MHL_MSC_REG_25_chg25_5(data)                                                 (0x00000020&((data)<<5))
#define MHL_MSC_REG_25_chg25_5_src(data)                                             ((0x00000020&(data))>>5)
#define MHL_MSC_REG_25_get_chg25_5(data)                                             ((0x00000020&(data))>>5)
#define MHL_MSC_REG_25_chg25_4_shift                                                 (4)
#define MHL_MSC_REG_25_chg25_4_mask                                                  (0x00000010)
#define MHL_MSC_REG_25_chg25_4(data)                                                 (0x00000010&((data)<<4))
#define MHL_MSC_REG_25_chg25_4_src(data)                                             ((0x00000010&(data))>>4)
#define MHL_MSC_REG_25_get_chg25_4(data)                                             ((0x00000010&(data))>>4)
#define MHL_MSC_REG_25_chg25_3_shift                                                 (3)
#define MHL_MSC_REG_25_chg25_3_mask                                                  (0x00000008)
#define MHL_MSC_REG_25_chg25_3(data)                                                 (0x00000008&((data)<<3))
#define MHL_MSC_REG_25_chg25_3_src(data)                                             ((0x00000008&(data))>>3)
#define MHL_MSC_REG_25_get_chg25_3(data)                                             ((0x00000008&(data))>>3)
#define MHL_MSC_REG_25_chg25_2_shift                                                 (2)
#define MHL_MSC_REG_25_chg25_2_mask                                                  (0x00000004)
#define MHL_MSC_REG_25_chg25_2(data)                                                 (0x00000004&((data)<<2))
#define MHL_MSC_REG_25_chg25_2_src(data)                                             ((0x00000004&(data))>>2)
#define MHL_MSC_REG_25_get_chg25_2(data)                                             ((0x00000004&(data))>>2)
#define MHL_MSC_REG_25_chg25_1_shift                                                 (1)
#define MHL_MSC_REG_25_chg25_1_mask                                                  (0x00000002)
#define MHL_MSC_REG_25_chg25_1(data)                                                 (0x00000002&((data)<<1))
#define MHL_MSC_REG_25_chg25_1_src(data)                                             ((0x00000002&(data))>>1)
#define MHL_MSC_REG_25_get_chg25_1(data)                                             ((0x00000002&(data))>>1)
#define MHL_MSC_REG_25_chg25_0_shift                                                 (0)
#define MHL_MSC_REG_25_chg25_0_mask                                                  (0x00000001)
#define MHL_MSC_REG_25_chg25_0(data)                                                 (0x00000001&((data)<<0))
#define MHL_MSC_REG_25_chg25_0_src(data)                                             ((0x00000001&(data))>>0)
#define MHL_MSC_REG_25_get_chg25_0(data)                                             ((0x00000001&(data))>>0)


#define MHL_MSC_REG_26                                                               0x18062C7C
#define MHL_MSC_REG_26_reg_addr                                                      "0xB8062C7C"
#define MHL_MSC_REG_26_reg                                                           0xB8062C7C
#define set_MHL_MSC_REG_26_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_26_reg)=data)
#define get_MHL_MSC_REG_26_reg   (*((volatile unsigned int*) MHL_MSC_REG_26_reg))
#define MHL_MSC_REG_26_inst_adr                                                      "0x001F"
#define MHL_MSC_REG_26_inst                                                          0x001F
#define MHL_MSC_REG_26_chg26_7_shift                                                 (7)
#define MHL_MSC_REG_26_chg26_7_mask                                                  (0x00000080)
#define MHL_MSC_REG_26_chg26_7(data)                                                 (0x00000080&((data)<<7))
#define MHL_MSC_REG_26_chg26_7_src(data)                                             ((0x00000080&(data))>>7)
#define MHL_MSC_REG_26_get_chg26_7(data)                                             ((0x00000080&(data))>>7)
#define MHL_MSC_REG_26_chg26_6_shift                                                 (6)
#define MHL_MSC_REG_26_chg26_6_mask                                                  (0x00000040)
#define MHL_MSC_REG_26_chg26_6(data)                                                 (0x00000040&((data)<<6))
#define MHL_MSC_REG_26_chg26_6_src(data)                                             ((0x00000040&(data))>>6)
#define MHL_MSC_REG_26_get_chg26_6(data)                                             ((0x00000040&(data))>>6)
#define MHL_MSC_REG_26_chg26_5_shift                                                 (5)
#define MHL_MSC_REG_26_chg26_5_mask                                                  (0x00000020)
#define MHL_MSC_REG_26_chg26_5(data)                                                 (0x00000020&((data)<<5))
#define MHL_MSC_REG_26_chg26_5_src(data)                                             ((0x00000020&(data))>>5)
#define MHL_MSC_REG_26_get_chg26_5(data)                                             ((0x00000020&(data))>>5)
#define MHL_MSC_REG_26_chg26_4_shift                                                 (4)
#define MHL_MSC_REG_26_chg26_4_mask                                                  (0x00000010)
#define MHL_MSC_REG_26_chg26_4(data)                                                 (0x00000010&((data)<<4))
#define MHL_MSC_REG_26_chg26_4_src(data)                                             ((0x00000010&(data))>>4)
#define MHL_MSC_REG_26_get_chg26_4(data)                                             ((0x00000010&(data))>>4)
#define MHL_MSC_REG_26_chg26_3_shift                                                 (3)
#define MHL_MSC_REG_26_chg26_3_mask                                                  (0x00000008)
#define MHL_MSC_REG_26_chg26_3(data)                                                 (0x00000008&((data)<<3))
#define MHL_MSC_REG_26_chg26_3_src(data)                                             ((0x00000008&(data))>>3)
#define MHL_MSC_REG_26_get_chg26_3(data)                                             ((0x00000008&(data))>>3)
#define MHL_MSC_REG_26_chg26_2_shift                                                 (2)
#define MHL_MSC_REG_26_chg26_2_mask                                                  (0x00000004)
#define MHL_MSC_REG_26_chg26_2(data)                                                 (0x00000004&((data)<<2))
#define MHL_MSC_REG_26_chg26_2_src(data)                                             ((0x00000004&(data))>>2)
#define MHL_MSC_REG_26_get_chg26_2(data)                                             ((0x00000004&(data))>>2)
#define MHL_MSC_REG_26_chg26_1_shift                                                 (1)
#define MHL_MSC_REG_26_chg26_1_mask                                                  (0x00000002)
#define MHL_MSC_REG_26_chg26_1(data)                                                 (0x00000002&((data)<<1))
#define MHL_MSC_REG_26_chg26_1_src(data)                                             ((0x00000002&(data))>>1)
#define MHL_MSC_REG_26_get_chg26_1(data)                                             ((0x00000002&(data))>>1)
#define MHL_MSC_REG_26_chg26_0_shift                                                 (0)
#define MHL_MSC_REG_26_chg26_0_mask                                                  (0x00000001)
#define MHL_MSC_REG_26_chg26_0(data)                                                 (0x00000001&((data)<<0))
#define MHL_MSC_REG_26_chg26_0_src(data)                                             ((0x00000001&(data))>>0)
#define MHL_MSC_REG_26_get_chg26_0(data)                                             ((0x00000001&(data))>>0)


#define MHL_MSC_REG_27                                                               0x18062C80
#define MHL_MSC_REG_27_reg_addr                                                      "0xB8062C80"
#define MHL_MSC_REG_27_reg                                                           0xB8062C80
#define set_MHL_MSC_REG_27_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_27_reg)=data)
#define get_MHL_MSC_REG_27_reg   (*((volatile unsigned int*) MHL_MSC_REG_27_reg))
#define MHL_MSC_REG_27_inst_adr                                                      "0x0020"
#define MHL_MSC_REG_27_inst                                                          0x0020
#define MHL_MSC_REG_27_chg27_7_shift                                                 (7)
#define MHL_MSC_REG_27_chg27_7_mask                                                  (0x00000080)
#define MHL_MSC_REG_27_chg27_7(data)                                                 (0x00000080&((data)<<7))
#define MHL_MSC_REG_27_chg27_7_src(data)                                             ((0x00000080&(data))>>7)
#define MHL_MSC_REG_27_get_chg27_7(data)                                             ((0x00000080&(data))>>7)
#define MHL_MSC_REG_27_chg27_6_shift                                                 (6)
#define MHL_MSC_REG_27_chg27_6_mask                                                  (0x00000040)
#define MHL_MSC_REG_27_chg27_6(data)                                                 (0x00000040&((data)<<6))
#define MHL_MSC_REG_27_chg27_6_src(data)                                             ((0x00000040&(data))>>6)
#define MHL_MSC_REG_27_get_chg27_6(data)                                             ((0x00000040&(data))>>6)
#define MHL_MSC_REG_27_chg27_5_shift                                                 (5)
#define MHL_MSC_REG_27_chg27_5_mask                                                  (0x00000020)
#define MHL_MSC_REG_27_chg27_5(data)                                                 (0x00000020&((data)<<5))
#define MHL_MSC_REG_27_chg27_5_src(data)                                             ((0x00000020&(data))>>5)
#define MHL_MSC_REG_27_get_chg27_5(data)                                             ((0x00000020&(data))>>5)
#define MHL_MSC_REG_27_chg27_4_shift                                                 (4)
#define MHL_MSC_REG_27_chg27_4_mask                                                  (0x00000010)
#define MHL_MSC_REG_27_chg27_4(data)                                                 (0x00000010&((data)<<4))
#define MHL_MSC_REG_27_chg27_4_src(data)                                             ((0x00000010&(data))>>4)
#define MHL_MSC_REG_27_get_chg27_4(data)                                             ((0x00000010&(data))>>4)
#define MHL_MSC_REG_27_chg27_3_shift                                                 (3)
#define MHL_MSC_REG_27_chg27_3_mask                                                  (0x00000008)
#define MHL_MSC_REG_27_chg27_3(data)                                                 (0x00000008&((data)<<3))
#define MHL_MSC_REG_27_chg27_3_src(data)                                             ((0x00000008&(data))>>3)
#define MHL_MSC_REG_27_get_chg27_3(data)                                             ((0x00000008&(data))>>3)
#define MHL_MSC_REG_27_chg27_2_shift                                                 (2)
#define MHL_MSC_REG_27_chg27_2_mask                                                  (0x00000004)
#define MHL_MSC_REG_27_chg27_2(data)                                                 (0x00000004&((data)<<2))
#define MHL_MSC_REG_27_chg27_2_src(data)                                             ((0x00000004&(data))>>2)
#define MHL_MSC_REG_27_get_chg27_2(data)                                             ((0x00000004&(data))>>2)
#define MHL_MSC_REG_27_chg27_1_shift                                                 (1)
#define MHL_MSC_REG_27_chg27_1_mask                                                  (0x00000002)
#define MHL_MSC_REG_27_chg27_1(data)                                                 (0x00000002&((data)<<1))
#define MHL_MSC_REG_27_chg27_1_src(data)                                             ((0x00000002&(data))>>1)
#define MHL_MSC_REG_27_get_chg27_1(data)                                             ((0x00000002&(data))>>1)
#define MHL_MSC_REG_27_chg27_0_shift                                                 (0)
#define MHL_MSC_REG_27_chg27_0_mask                                                  (0x00000001)
#define MHL_MSC_REG_27_chg27_0(data)                                                 (0x00000001&((data)<<0))
#define MHL_MSC_REG_27_chg27_0_src(data)                                             ((0x00000001&(data))>>0)
#define MHL_MSC_REG_27_get_chg27_0(data)                                             ((0x00000001&(data))>>0)


#define MHL_MSC_REG_30                                                               0x18062C84
#define MHL_MSC_REG_30_reg_addr                                                      "0xB8062C84"
#define MHL_MSC_REG_30_reg                                                           0xB8062C84
#define set_MHL_MSC_REG_30_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_30_reg)=data)
#define get_MHL_MSC_REG_30_reg   (*((volatile unsigned int*) MHL_MSC_REG_30_reg))
#define MHL_MSC_REG_30_inst_adr                                                      "0x0021"
#define MHL_MSC_REG_30_inst                                                          0x0021
#define MHL_MSC_REG_30_connected_rdy_shift                                           (1)
#define MHL_MSC_REG_30_connected_rdy_mask                                            (0x000000FE)
#define MHL_MSC_REG_30_connected_rdy(data)                                           (0x000000FE&((data)<<1))
#define MHL_MSC_REG_30_connected_rdy_src(data)                                       ((0x000000FE&(data))>>1)
#define MHL_MSC_REG_30_get_connected_rdy(data)                                       ((0x000000FE&(data))>>1)
#define MHL_MSC_REG_30_dcap_rdy_shift                                                (0)
#define MHL_MSC_REG_30_dcap_rdy_mask                                                 (0x00000001)
#define MHL_MSC_REG_30_dcap_rdy(data)                                                (0x00000001&((data)<<0))
#define MHL_MSC_REG_30_dcap_rdy_src(data)                                            ((0x00000001&(data))>>0)
#define MHL_MSC_REG_30_get_dcap_rdy(data)                                            ((0x00000001&(data))>>0)


#define MHL_MSC_REG_31                                                               0x18062C88
#define MHL_MSC_REG_31_reg_addr                                                      "0xB8062C88"
#define MHL_MSC_REG_31_reg                                                           0xB8062C88
#define set_MHL_MSC_REG_31_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_31_reg)=data)
#define get_MHL_MSC_REG_31_reg   (*((volatile unsigned int*) MHL_MSC_REG_31_reg))
#define MHL_MSC_REG_31_inst_adr                                                      "0x0022"
#define MHL_MSC_REG_31_inst                                                          0x0022
#define MHL_MSC_REG_31_link_mode_shift                                               (5)
#define MHL_MSC_REG_31_link_mode_mask                                                (0x000000E0)
#define MHL_MSC_REG_31_link_mode(data)                                               (0x000000E0&((data)<<5))
#define MHL_MSC_REG_31_link_mode_src(data)                                           ((0x000000E0&(data))>>5)
#define MHL_MSC_REG_31_get_link_mode(data)                                           ((0x000000E0&(data))>>5)
#define MHL_MSC_REG_31_path_en_shift                                                 (3)
#define MHL_MSC_REG_31_path_en_mask                                                  (0x00000008)
#define MHL_MSC_REG_31_path_en(data)                                                 (0x00000008&((data)<<3))
#define MHL_MSC_REG_31_path_en_src(data)                                             ((0x00000008&(data))>>3)
#define MHL_MSC_REG_31_get_path_en(data)                                             ((0x00000008&(data))>>3)


#define MHL_MSC_REG_32                                                               0x18062C8C
#define MHL_MSC_REG_32_reg_addr                                                      "0xB8062C8C"
#define MHL_MSC_REG_32_reg                                                           0xB8062C8C
#define set_MHL_MSC_REG_32_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_32_reg)=data)
#define get_MHL_MSC_REG_32_reg   (*((volatile unsigned int*) MHL_MSC_REG_32_reg))
#define MHL_MSC_REG_32_inst_adr                                                      "0x0023"
#define MHL_MSC_REG_32_inst                                                          0x0023
#define MHL_MSC_REG_32_stat_32_shift                                                 (0)
#define MHL_MSC_REG_32_stat_32_mask                                                  (0x000000FF)
#define MHL_MSC_REG_32_stat_32(data)                                                 (0x000000FF&((data)<<0))
#define MHL_MSC_REG_32_stat_32_src(data)                                             ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_32_get_stat_32(data)                                             ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_33                                                               0x18062C90
#define MHL_MSC_REG_33_reg_addr                                                      "0xB8062C90"
#define MHL_MSC_REG_33_reg                                                           0xB8062C90
#define set_MHL_MSC_REG_33_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_33_reg)=data)
#define get_MHL_MSC_REG_33_reg   (*((volatile unsigned int*) MHL_MSC_REG_33_reg))
#define MHL_MSC_REG_33_inst_adr                                                      "0x0024"
#define MHL_MSC_REG_33_inst                                                          0x0024
#define MHL_MSC_REG_33_stat_33_shift                                                 (0)
#define MHL_MSC_REG_33_stat_33_mask                                                  (0x000000FF)
#define MHL_MSC_REG_33_stat_33(data)                                                 (0x000000FF&((data)<<0))
#define MHL_MSC_REG_33_stat_33_src(data)                                             ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_33_get_stat_33(data)                                             ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_34                                                               0x18062C94
#define MHL_MSC_REG_34_reg_addr                                                      "0xB8062C94"
#define MHL_MSC_REG_34_reg                                                           0xB8062C94
#define set_MHL_MSC_REG_34_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_34_reg)=data)
#define get_MHL_MSC_REG_34_reg   (*((volatile unsigned int*) MHL_MSC_REG_34_reg))
#define MHL_MSC_REG_34_inst_adr                                                      "0x0025"
#define MHL_MSC_REG_34_inst                                                          0x0025
#define MHL_MSC_REG_34_stat_34_shift                                                 (0)
#define MHL_MSC_REG_34_stat_34_mask                                                  (0x000000FF)
#define MHL_MSC_REG_34_stat_34(data)                                                 (0x000000FF&((data)<<0))
#define MHL_MSC_REG_34_stat_34_src(data)                                             ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_34_get_stat_34(data)                                             ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_35                                                               0x18062C98
#define MHL_MSC_REG_35_reg_addr                                                      "0xB8062C98"
#define MHL_MSC_REG_35_reg                                                           0xB8062C98
#define set_MHL_MSC_REG_35_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_35_reg)=data)
#define get_MHL_MSC_REG_35_reg   (*((volatile unsigned int*) MHL_MSC_REG_35_reg))
#define MHL_MSC_REG_35_inst_adr                                                      "0x0026"
#define MHL_MSC_REG_35_inst                                                          0x0026
#define MHL_MSC_REG_35_stat_35_shift                                                 (0)
#define MHL_MSC_REG_35_stat_35_mask                                                  (0x000000FF)
#define MHL_MSC_REG_35_stat_35(data)                                                 (0x000000FF&((data)<<0))
#define MHL_MSC_REG_35_stat_35_src(data)                                             ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_35_get_stat_35(data)                                             ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_36                                                               0x18062C9C
#define MHL_MSC_REG_36_reg_addr                                                      "0xB8062C9C"
#define MHL_MSC_REG_36_reg                                                           0xB8062C9C
#define set_MHL_MSC_REG_36_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_36_reg)=data)
#define get_MHL_MSC_REG_36_reg   (*((volatile unsigned int*) MHL_MSC_REG_36_reg))
#define MHL_MSC_REG_36_inst_adr                                                      "0x0027"
#define MHL_MSC_REG_36_inst                                                          0x0027
#define MHL_MSC_REG_36_stat_36_shift                                                 (0)
#define MHL_MSC_REG_36_stat_36_mask                                                  (0x000000FF)
#define MHL_MSC_REG_36_stat_36(data)                                                 (0x000000FF&((data)<<0))
#define MHL_MSC_REG_36_stat_36_src(data)                                             ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_36_get_stat_36(data)                                             ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_37                                                               0x18062CA0
#define MHL_MSC_REG_37_reg_addr                                                      "0xB8062CA0"
#define MHL_MSC_REG_37_reg                                                           0xB8062CA0
#define set_MHL_MSC_REG_37_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_37_reg)=data)
#define get_MHL_MSC_REG_37_reg   (*((volatile unsigned int*) MHL_MSC_REG_37_reg))
#define MHL_MSC_REG_37_inst_adr                                                      "0x0028"
#define MHL_MSC_REG_37_inst                                                          0x0028
#define MHL_MSC_REG_37_stat_37_shift                                                 (0)
#define MHL_MSC_REG_37_stat_37_mask                                                  (0x000000FF)
#define MHL_MSC_REG_37_stat_37(data)                                                 (0x000000FF&((data)<<0))
#define MHL_MSC_REG_37_stat_37_src(data)                                             ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_37_get_stat_37(data)                                             ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_40                                                               0x18062CA4
#define MHL_MSC_REG_40_reg_addr                                                      "0xB8062CA4"
#define MHL_MSC_REG_40_reg                                                           0xB8062CA4
#define set_MHL_MSC_REG_40_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_40_reg)=data)
#define get_MHL_MSC_REG_40_reg   (*((volatile unsigned int*) MHL_MSC_REG_40_reg))
#define MHL_MSC_REG_40_inst_adr                                                      "0x0029"
#define MHL_MSC_REG_40_inst                                                          0x0029
#define MHL_MSC_REG_40_scratch_40_shift                                              (0)
#define MHL_MSC_REG_40_scratch_40_mask                                               (0x000000FF)
#define MHL_MSC_REG_40_scratch_40(data)                                              (0x000000FF&((data)<<0))
#define MHL_MSC_REG_40_scratch_40_src(data)                                          ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_40_get_scratch_40(data)                                          ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_41                                                               0x18062CA8
#define MHL_MSC_REG_41_reg_addr                                                      "0xB8062CA8"
#define MHL_MSC_REG_41_reg                                                           0xB8062CA8
#define set_MHL_MSC_REG_41_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_41_reg)=data)
#define get_MHL_MSC_REG_41_reg   (*((volatile unsigned int*) MHL_MSC_REG_41_reg))
#define MHL_MSC_REG_41_inst_adr                                                      "0x002A"
#define MHL_MSC_REG_41_inst                                                          0x002A
#define MHL_MSC_REG_41_scratch_41_shift                                              (0)
#define MHL_MSC_REG_41_scratch_41_mask                                               (0x000000FF)
#define MHL_MSC_REG_41_scratch_41(data)                                              (0x000000FF&((data)<<0))
#define MHL_MSC_REG_41_scratch_41_src(data)                                          ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_41_get_scratch_41(data)                                          ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_42                                                               0x18062CAC
#define MHL_MSC_REG_42_reg_addr                                                      "0xB8062CAC"
#define MHL_MSC_REG_42_reg                                                           0xB8062CAC
#define set_MHL_MSC_REG_42_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_42_reg)=data)
#define get_MHL_MSC_REG_42_reg   (*((volatile unsigned int*) MHL_MSC_REG_42_reg))
#define MHL_MSC_REG_42_inst_adr                                                      "0x002B"
#define MHL_MSC_REG_42_inst                                                          0x002B
#define MHL_MSC_REG_42_scratch_42_shift                                              (0)
#define MHL_MSC_REG_42_scratch_42_mask                                               (0x000000FF)
#define MHL_MSC_REG_42_scratch_42(data)                                              (0x000000FF&((data)<<0))
#define MHL_MSC_REG_42_scratch_42_src(data)                                          ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_42_get_scratch_42(data)                                          ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_43                                                               0x18062CB0
#define MHL_MSC_REG_43_reg_addr                                                      "0xB8062CB0"
#define MHL_MSC_REG_43_reg                                                           0xB8062CB0
#define set_MHL_MSC_REG_43_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_43_reg)=data)
#define get_MHL_MSC_REG_43_reg   (*((volatile unsigned int*) MHL_MSC_REG_43_reg))
#define MHL_MSC_REG_43_inst_adr                                                      "0x002C"
#define MHL_MSC_REG_43_inst                                                          0x002C
#define MHL_MSC_REG_43_scratch_43_shift                                              (0)
#define MHL_MSC_REG_43_scratch_43_mask                                               (0x000000FF)
#define MHL_MSC_REG_43_scratch_43(data)                                              (0x000000FF&((data)<<0))
#define MHL_MSC_REG_43_scratch_43_src(data)                                          ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_43_get_scratch_43(data)                                          ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_44                                                               0x18062CB4
#define MHL_MSC_REG_44_reg_addr                                                      "0xB8062CB4"
#define MHL_MSC_REG_44_reg                                                           0xB8062CB4
#define set_MHL_MSC_REG_44_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_44_reg)=data)
#define get_MHL_MSC_REG_44_reg   (*((volatile unsigned int*) MHL_MSC_REG_44_reg))
#define MHL_MSC_REG_44_inst_adr                                                      "0x002D"
#define MHL_MSC_REG_44_inst                                                          0x002D
#define MHL_MSC_REG_44_scratch_44_shift                                              (0)
#define MHL_MSC_REG_44_scratch_44_mask                                               (0x000000FF)
#define MHL_MSC_REG_44_scratch_44(data)                                              (0x000000FF&((data)<<0))
#define MHL_MSC_REG_44_scratch_44_src(data)                                          ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_44_get_scratch_44(data)                                          ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_45                                                               0x18062CB8
#define MHL_MSC_REG_45_reg_addr                                                      "0xB8062CB8"
#define MHL_MSC_REG_45_reg                                                           0xB8062CB8
#define set_MHL_MSC_REG_45_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_45_reg)=data)
#define get_MHL_MSC_REG_45_reg   (*((volatile unsigned int*) MHL_MSC_REG_45_reg))
#define MHL_MSC_REG_45_inst_adr                                                      "0x002E"
#define MHL_MSC_REG_45_inst                                                          0x002E
#define MHL_MSC_REG_45_scratch_45_shift                                              (0)
#define MHL_MSC_REG_45_scratch_45_mask                                               (0x000000FF)
#define MHL_MSC_REG_45_scratch_45(data)                                              (0x000000FF&((data)<<0))
#define MHL_MSC_REG_45_scratch_45_src(data)                                          ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_45_get_scratch_45(data)                                          ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_46                                                               0x18062CBC
#define MHL_MSC_REG_46_reg_addr                                                      "0xB8062CBC"
#define MHL_MSC_REG_46_reg                                                           0xB8062CBC
#define set_MHL_MSC_REG_46_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_46_reg)=data)
#define get_MHL_MSC_REG_46_reg   (*((volatile unsigned int*) MHL_MSC_REG_46_reg))
#define MHL_MSC_REG_46_inst_adr                                                      "0x002F"
#define MHL_MSC_REG_46_inst                                                          0x002F
#define MHL_MSC_REG_46_scratch_46_shift                                              (0)
#define MHL_MSC_REG_46_scratch_46_mask                                               (0x000000FF)
#define MHL_MSC_REG_46_scratch_46(data)                                              (0x000000FF&((data)<<0))
#define MHL_MSC_REG_46_scratch_46_src(data)                                          ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_46_get_scratch_46(data)                                          ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_47                                                               0x18062CC0
#define MHL_MSC_REG_47_reg_addr                                                      "0xB8062CC0"
#define MHL_MSC_REG_47_reg                                                           0xB8062CC0
#define set_MHL_MSC_REG_47_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_47_reg)=data)
#define get_MHL_MSC_REG_47_reg   (*((volatile unsigned int*) MHL_MSC_REG_47_reg))
#define MHL_MSC_REG_47_inst_adr                                                      "0x0030"
#define MHL_MSC_REG_47_inst                                                          0x0030
#define MHL_MSC_REG_47_scratch_47_shift                                              (0)
#define MHL_MSC_REG_47_scratch_47_mask                                               (0x000000FF)
#define MHL_MSC_REG_47_scratch_47(data)                                              (0x000000FF&((data)<<0))
#define MHL_MSC_REG_47_scratch_47_src(data)                                          ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_47_get_scratch_47(data)                                          ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_48                                                               0x18062CC4
#define MHL_MSC_REG_48_reg_addr                                                      "0xB8062CC4"
#define MHL_MSC_REG_48_reg                                                           0xB8062CC4
#define set_MHL_MSC_REG_48_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_48_reg)=data)
#define get_MHL_MSC_REG_48_reg   (*((volatile unsigned int*) MHL_MSC_REG_48_reg))
#define MHL_MSC_REG_48_inst_adr                                                      "0x0031"
#define MHL_MSC_REG_48_inst                                                          0x0031
#define MHL_MSC_REG_48_scratch_48_shift                                              (0)
#define MHL_MSC_REG_48_scratch_48_mask                                               (0x000000FF)
#define MHL_MSC_REG_48_scratch_48(data)                                              (0x000000FF&((data)<<0))
#define MHL_MSC_REG_48_scratch_48_src(data)                                          ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_48_get_scratch_48(data)                                          ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_49                                                               0x18062CC8
#define MHL_MSC_REG_49_reg_addr                                                      "0xB8062CC8"
#define MHL_MSC_REG_49_reg                                                           0xB8062CC8
#define set_MHL_MSC_REG_49_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_49_reg)=data)
#define get_MHL_MSC_REG_49_reg   (*((volatile unsigned int*) MHL_MSC_REG_49_reg))
#define MHL_MSC_REG_49_inst_adr                                                      "0x0032"
#define MHL_MSC_REG_49_inst                                                          0x0032
#define MHL_MSC_REG_49_scratch_49_shift                                              (0)
#define MHL_MSC_REG_49_scratch_49_mask                                               (0x000000FF)
#define MHL_MSC_REG_49_scratch_49(data)                                              (0x000000FF&((data)<<0))
#define MHL_MSC_REG_49_scratch_49_src(data)                                          ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_49_get_scratch_49(data)                                          ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_4A                                                               0x18062CCC
#define MHL_MSC_REG_4A_reg_addr                                                      "0xB8062CCC"
#define MHL_MSC_REG_4A_reg                                                           0xB8062CCC
#define set_MHL_MSC_REG_4A_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_4A_reg)=data)
#define get_MHL_MSC_REG_4A_reg   (*((volatile unsigned int*) MHL_MSC_REG_4A_reg))
#define MHL_MSC_REG_4A_inst_adr                                                      "0x0033"
#define MHL_MSC_REG_4A_inst                                                          0x0033
#define MHL_MSC_REG_4A_scratch_4A_shift                                              (0)
#define MHL_MSC_REG_4A_scratch_4A_mask                                               (0x000000FF)
#define MHL_MSC_REG_4A_scratch_4A(data)                                              (0x000000FF&((data)<<0))
#define MHL_MSC_REG_4A_scratch_4A_src(data)                                          ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_4A_get_scratch_4A(data)                                          ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_4B                                                               0x18062CD0
#define MHL_MSC_REG_4B_reg_addr                                                      "0xB8062CD0"
#define MHL_MSC_REG_4B_reg                                                           0xB8062CD0
#define set_MHL_MSC_REG_4B_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_4B_reg)=data)
#define get_MHL_MSC_REG_4B_reg   (*((volatile unsigned int*) MHL_MSC_REG_4B_reg))
#define MHL_MSC_REG_4B_inst_adr                                                      "0x0034"
#define MHL_MSC_REG_4B_inst                                                          0x0034
#define MHL_MSC_REG_4B_scratch_4B_shift                                              (0)
#define MHL_MSC_REG_4B_scratch_4B_mask                                               (0x000000FF)
#define MHL_MSC_REG_4B_scratch_4B(data)                                              (0x000000FF&((data)<<0))
#define MHL_MSC_REG_4B_scratch_4B_src(data)                                          ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_4B_get_scratch_4B(data)                                          ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_4C                                                               0x18062CD4
#define MHL_MSC_REG_4C_reg_addr                                                      "0xB8062CD4"
#define MHL_MSC_REG_4C_reg                                                           0xB8062CD4
#define set_MHL_MSC_REG_4C_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_4C_reg)=data)
#define get_MHL_MSC_REG_4C_reg   (*((volatile unsigned int*) MHL_MSC_REG_4C_reg))
#define MHL_MSC_REG_4C_inst_adr                                                      "0x0035"
#define MHL_MSC_REG_4C_inst                                                          0x0035
#define MHL_MSC_REG_4C_scratch_4C_shift                                              (0)
#define MHL_MSC_REG_4C_scratch_4C_mask                                               (0x000000FF)
#define MHL_MSC_REG_4C_scratch_4C(data)                                              (0x000000FF&((data)<<0))
#define MHL_MSC_REG_4C_scratch_4C_src(data)                                          ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_4C_get_scratch_4C(data)                                          ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_4D                                                               0x18062CD8
#define MHL_MSC_REG_4D_reg_addr                                                      "0xB8062CD8"
#define MHL_MSC_REG_4D_reg                                                           0xB8062CD8
#define set_MHL_MSC_REG_4D_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_4D_reg)=data)
#define get_MHL_MSC_REG_4D_reg   (*((volatile unsigned int*) MHL_MSC_REG_4D_reg))
#define MHL_MSC_REG_4D_inst_adr                                                      "0x0036"
#define MHL_MSC_REG_4D_inst                                                          0x0036
#define MHL_MSC_REG_4D_scratch_4D_shift                                              (0)
#define MHL_MSC_REG_4D_scratch_4D_mask                                               (0x000000FF)
#define MHL_MSC_REG_4D_scratch_4D(data)                                              (0x000000FF&((data)<<0))
#define MHL_MSC_REG_4D_scratch_4D_src(data)                                          ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_4D_get_scratch_4D(data)                                          ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_4E                                                               0x18062CDC
#define MHL_MSC_REG_4E_reg_addr                                                      "0xB8062CDC"
#define MHL_MSC_REG_4E_reg                                                           0xB8062CDC
#define set_MHL_MSC_REG_4E_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_4E_reg)=data)
#define get_MHL_MSC_REG_4E_reg   (*((volatile unsigned int*) MHL_MSC_REG_4E_reg))
#define MHL_MSC_REG_4E_inst_adr                                                      "0x0037"
#define MHL_MSC_REG_4E_inst                                                          0x0037
#define MHL_MSC_REG_4E_scratch_4E_shift                                              (0)
#define MHL_MSC_REG_4E_scratch_4E_mask                                               (0x000000FF)
#define MHL_MSC_REG_4E_scratch_4E(data)                                              (0x000000FF&((data)<<0))
#define MHL_MSC_REG_4E_scratch_4E_src(data)                                          ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_4E_get_scratch_4E(data)                                          ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_4F                                                               0x18062CE0
#define MHL_MSC_REG_4F_reg_addr                                                      "0xB8062CE0"
#define MHL_MSC_REG_4F_reg                                                           0xB8062CE0
#define set_MHL_MSC_REG_4F_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_4F_reg)=data)
#define get_MHL_MSC_REG_4F_reg   (*((volatile unsigned int*) MHL_MSC_REG_4F_reg))
#define MHL_MSC_REG_4F_inst_adr                                                      "0x0038"
#define MHL_MSC_REG_4F_inst                                                          0x0038
#define MHL_MSC_REG_4F_scratch_4F_shift                                              (0)
#define MHL_MSC_REG_4F_scratch_4F_mask                                               (0x000000FF)
#define MHL_MSC_REG_4F_scratch_4F(data)                                              (0x000000FF&((data)<<0))
#define MHL_MSC_REG_4F_scratch_4F_src(data)                                          ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_4F_get_scratch_4F(data)                                          ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_50                                                               0x18062CE4
#define MHL_MSC_REG_50_reg_addr                                                      "0xB8062CE4"
#define MHL_MSC_REG_50_reg                                                           0xB8062CE4
#define set_MHL_MSC_REG_50_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_50_reg)=data)
#define get_MHL_MSC_REG_50_reg   (*((volatile unsigned int*) MHL_MSC_REG_50_reg))
#define MHL_MSC_REG_50_inst_adr                                                      "0x0039"
#define MHL_MSC_REG_50_inst                                                          0x0039
#define MHL_MSC_REG_50_scratch_50_shift                                              (0)
#define MHL_MSC_REG_50_scratch_50_mask                                               (0x000000FF)
#define MHL_MSC_REG_50_scratch_50(data)                                              (0x000000FF&((data)<<0))
#define MHL_MSC_REG_50_scratch_50_src(data)                                          ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_50_get_scratch_50(data)                                          ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_51                                                               0x18062CE8
#define MHL_MSC_REG_51_reg_addr                                                      "0xB8062CE8"
#define MHL_MSC_REG_51_reg                                                           0xB8062CE8
#define set_MHL_MSC_REG_51_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_51_reg)=data)
#define get_MHL_MSC_REG_51_reg   (*((volatile unsigned int*) MHL_MSC_REG_51_reg))
#define MHL_MSC_REG_51_inst_adr                                                      "0x003A"
#define MHL_MSC_REG_51_inst                                                          0x003A
#define MHL_MSC_REG_51_scratch_51_shift                                              (0)
#define MHL_MSC_REG_51_scratch_51_mask                                               (0x000000FF)
#define MHL_MSC_REG_51_scratch_51(data)                                              (0x000000FF&((data)<<0))
#define MHL_MSC_REG_51_scratch_51_src(data)                                          ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_51_get_scratch_51(data)                                          ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_52                                                               0x18062CEC
#define MHL_MSC_REG_52_reg_addr                                                      "0xB8062CEC"
#define MHL_MSC_REG_52_reg                                                           0xB8062CEC
#define set_MHL_MSC_REG_52_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_52_reg)=data)
#define get_MHL_MSC_REG_52_reg   (*((volatile unsigned int*) MHL_MSC_REG_52_reg))
#define MHL_MSC_REG_52_inst_adr                                                      "0x003B"
#define MHL_MSC_REG_52_inst                                                          0x003B
#define MHL_MSC_REG_52_scratch_52_shift                                              (0)
#define MHL_MSC_REG_52_scratch_52_mask                                               (0x000000FF)
#define MHL_MSC_REG_52_scratch_52(data)                                              (0x000000FF&((data)<<0))
#define MHL_MSC_REG_52_scratch_52_src(data)                                          ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_52_get_scratch_52(data)                                          ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_53                                                               0x18062CF0
#define MHL_MSC_REG_53_reg_addr                                                      "0xB8062CF0"
#define MHL_MSC_REG_53_reg                                                           0xB8062CF0
#define set_MHL_MSC_REG_53_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_53_reg)=data)
#define get_MHL_MSC_REG_53_reg   (*((volatile unsigned int*) MHL_MSC_REG_53_reg))
#define MHL_MSC_REG_53_inst_adr                                                      "0x003C"
#define MHL_MSC_REG_53_inst                                                          0x003C
#define MHL_MSC_REG_53_scratch_53_shift                                              (0)
#define MHL_MSC_REG_53_scratch_53_mask                                               (0x000000FF)
#define MHL_MSC_REG_53_scratch_53(data)                                              (0x000000FF&((data)<<0))
#define MHL_MSC_REG_53_scratch_53_src(data)                                          ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_53_get_scratch_53(data)                                          ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_54                                                               0x18062CF4
#define MHL_MSC_REG_54_reg_addr                                                      "0xB8062CF4"
#define MHL_MSC_REG_54_reg                                                           0xB8062CF4
#define set_MHL_MSC_REG_54_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_54_reg)=data)
#define get_MHL_MSC_REG_54_reg   (*((volatile unsigned int*) MHL_MSC_REG_54_reg))
#define MHL_MSC_REG_54_inst_adr                                                      "0x003D"
#define MHL_MSC_REG_54_inst                                                          0x003D
#define MHL_MSC_REG_54_scratch_54_shift                                              (0)
#define MHL_MSC_REG_54_scratch_54_mask                                               (0x000000FF)
#define MHL_MSC_REG_54_scratch_54(data)                                              (0x000000FF&((data)<<0))
#define MHL_MSC_REG_54_scratch_54_src(data)                                          ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_54_get_scratch_54(data)                                          ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_55                                                               0x18062CF8
#define MHL_MSC_REG_55_reg_addr                                                      "0xB8062CF8"
#define MHL_MSC_REG_55_reg                                                           0xB8062CF8
#define set_MHL_MSC_REG_55_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_55_reg)=data)
#define get_MHL_MSC_REG_55_reg   (*((volatile unsigned int*) MHL_MSC_REG_55_reg))
#define MHL_MSC_REG_55_inst_adr                                                      "0x003E"
#define MHL_MSC_REG_55_inst                                                          0x003E
#define MHL_MSC_REG_55_scratch_55_shift                                              (0)
#define MHL_MSC_REG_55_scratch_55_mask                                               (0x000000FF)
#define MHL_MSC_REG_55_scratch_55(data)                                              (0x000000FF&((data)<<0))
#define MHL_MSC_REG_55_scratch_55_src(data)                                          ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_55_get_scratch_55(data)                                          ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_56                                                               0x18062CFC
#define MHL_MSC_REG_56_reg_addr                                                      "0xB8062CFC"
#define MHL_MSC_REG_56_reg                                                           0xB8062CFC
#define set_MHL_MSC_REG_56_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_56_reg)=data)
#define get_MHL_MSC_REG_56_reg   (*((volatile unsigned int*) MHL_MSC_REG_56_reg))
#define MHL_MSC_REG_56_inst_adr                                                      "0x003F"
#define MHL_MSC_REG_56_inst                                                          0x003F
#define MHL_MSC_REG_56_scratch_56_shift                                              (0)
#define MHL_MSC_REG_56_scratch_56_mask                                               (0x000000FF)
#define MHL_MSC_REG_56_scratch_56(data)                                              (0x000000FF&((data)<<0))
#define MHL_MSC_REG_56_scratch_56_src(data)                                          ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_56_get_scratch_56(data)                                          ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_57                                                               0x18062D00
#define MHL_MSC_REG_57_reg_addr                                                      "0xB8062D00"
#define MHL_MSC_REG_57_reg                                                           0xB8062D00
#define set_MHL_MSC_REG_57_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_57_reg)=data)
#define get_MHL_MSC_REG_57_reg   (*((volatile unsigned int*) MHL_MSC_REG_57_reg))
#define MHL_MSC_REG_57_inst_adr                                                      "0x0040"
#define MHL_MSC_REG_57_inst                                                          0x0040
#define MHL_MSC_REG_57_scratch_57_shift                                              (0)
#define MHL_MSC_REG_57_scratch_57_mask                                               (0x000000FF)
#define MHL_MSC_REG_57_scratch_57(data)                                              (0x000000FF&((data)<<0))
#define MHL_MSC_REG_57_scratch_57_src(data)                                          ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_57_get_scratch_57(data)                                          ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_58                                                               0x18062D04
#define MHL_MSC_REG_58_reg_addr                                                      "0xB8062D04"
#define MHL_MSC_REG_58_reg                                                           0xB8062D04
#define set_MHL_MSC_REG_58_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_58_reg)=data)
#define get_MHL_MSC_REG_58_reg   (*((volatile unsigned int*) MHL_MSC_REG_58_reg))
#define MHL_MSC_REG_58_inst_adr                                                      "0x0041"
#define MHL_MSC_REG_58_inst                                                          0x0041
#define MHL_MSC_REG_58_scratch_58_shift                                              (0)
#define MHL_MSC_REG_58_scratch_58_mask                                               (0x000000FF)
#define MHL_MSC_REG_58_scratch_58(data)                                              (0x000000FF&((data)<<0))
#define MHL_MSC_REG_58_scratch_58_src(data)                                          ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_58_get_scratch_58(data)                                          ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_59                                                               0x18062D08
#define MHL_MSC_REG_59_reg_addr                                                      "0xB8062D08"
#define MHL_MSC_REG_59_reg                                                           0xB8062D08
#define set_MHL_MSC_REG_59_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_59_reg)=data)
#define get_MHL_MSC_REG_59_reg   (*((volatile unsigned int*) MHL_MSC_REG_59_reg))
#define MHL_MSC_REG_59_inst_adr                                                      "0x0042"
#define MHL_MSC_REG_59_inst                                                          0x0042
#define MHL_MSC_REG_59_scratch_59_shift                                              (0)
#define MHL_MSC_REG_59_scratch_59_mask                                               (0x000000FF)
#define MHL_MSC_REG_59_scratch_59(data)                                              (0x000000FF&((data)<<0))
#define MHL_MSC_REG_59_scratch_59_src(data)                                          ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_59_get_scratch_59(data)                                          ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_5A                                                               0x18062D0C
#define MHL_MSC_REG_5A_reg_addr                                                      "0xB8062D0C"
#define MHL_MSC_REG_5A_reg                                                           0xB8062D0C
#define set_MHL_MSC_REG_5A_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_5A_reg)=data)
#define get_MHL_MSC_REG_5A_reg   (*((volatile unsigned int*) MHL_MSC_REG_5A_reg))
#define MHL_MSC_REG_5A_inst_adr                                                      "0x0043"
#define MHL_MSC_REG_5A_inst                                                          0x0043
#define MHL_MSC_REG_5A_scratch_5A_shift                                              (0)
#define MHL_MSC_REG_5A_scratch_5A_mask                                               (0x000000FF)
#define MHL_MSC_REG_5A_scratch_5A(data)                                              (0x000000FF&((data)<<0))
#define MHL_MSC_REG_5A_scratch_5A_src(data)                                          ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_5A_get_scratch_5A(data)                                          ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_5B                                                               0x18062D10
#define MHL_MSC_REG_5B_reg_addr                                                      "0xB8062D10"
#define MHL_MSC_REG_5B_reg                                                           0xB8062D10
#define set_MHL_MSC_REG_5B_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_5B_reg)=data)
#define get_MHL_MSC_REG_5B_reg   (*((volatile unsigned int*) MHL_MSC_REG_5B_reg))
#define MHL_MSC_REG_5B_inst_adr                                                      "0x0044"
#define MHL_MSC_REG_5B_inst                                                          0x0044
#define MHL_MSC_REG_5B_scratch_5B_shift                                              (0)
#define MHL_MSC_REG_5B_scratch_5B_mask                                               (0x000000FF)
#define MHL_MSC_REG_5B_scratch_5B(data)                                              (0x000000FF&((data)<<0))
#define MHL_MSC_REG_5B_scratch_5B_src(data)                                          ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_5B_get_scratch_5B(data)                                          ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_5C                                                               0x18062D14
#define MHL_MSC_REG_5C_reg_addr                                                      "0xB8062D14"
#define MHL_MSC_REG_5C_reg                                                           0xB8062D14
#define set_MHL_MSC_REG_5C_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_5C_reg)=data)
#define get_MHL_MSC_REG_5C_reg   (*((volatile unsigned int*) MHL_MSC_REG_5C_reg))
#define MHL_MSC_REG_5C_inst_adr                                                      "0x0045"
#define MHL_MSC_REG_5C_inst                                                          0x0045
#define MHL_MSC_REG_5C_scratch_5C_shift                                              (0)
#define MHL_MSC_REG_5C_scratch_5C_mask                                               (0x000000FF)
#define MHL_MSC_REG_5C_scratch_5C(data)                                              (0x000000FF&((data)<<0))
#define MHL_MSC_REG_5C_scratch_5C_src(data)                                          ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_5C_get_scratch_5C(data)                                          ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_5D                                                               0x18062D18
#define MHL_MSC_REG_5D_reg_addr                                                      "0xB8062D18"
#define MHL_MSC_REG_5D_reg                                                           0xB8062D18
#define set_MHL_MSC_REG_5D_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_5D_reg)=data)
#define get_MHL_MSC_REG_5D_reg   (*((volatile unsigned int*) MHL_MSC_REG_5D_reg))
#define MHL_MSC_REG_5D_inst_adr                                                      "0x0046"
#define MHL_MSC_REG_5D_inst                                                          0x0046
#define MHL_MSC_REG_5D_scratch_5D_shift                                              (0)
#define MHL_MSC_REG_5D_scratch_5D_mask                                               (0x000000FF)
#define MHL_MSC_REG_5D_scratch_5D(data)                                              (0x000000FF&((data)<<0))
#define MHL_MSC_REG_5D_scratch_5D_src(data)                                          ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_5D_get_scratch_5D(data)                                          ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_5E                                                               0x18062D1C
#define MHL_MSC_REG_5E_reg_addr                                                      "0xB8062D1C"
#define MHL_MSC_REG_5E_reg                                                           0xB8062D1C
#define set_MHL_MSC_REG_5E_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_5E_reg)=data)
#define get_MHL_MSC_REG_5E_reg   (*((volatile unsigned int*) MHL_MSC_REG_5E_reg))
#define MHL_MSC_REG_5E_inst_adr                                                      "0x0047"
#define MHL_MSC_REG_5E_inst                                                          0x0047
#define MHL_MSC_REG_5E_scratch_5E_shift                                              (0)
#define MHL_MSC_REG_5E_scratch_5E_mask                                               (0x000000FF)
#define MHL_MSC_REG_5E_scratch_5E(data)                                              (0x000000FF&((data)<<0))
#define MHL_MSC_REG_5E_scratch_5E_src(data)                                          ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_5E_get_scratch_5E(data)                                          ((0x000000FF&(data))>>0)


#define MHL_MSC_REG_5F                                                               0x18062D20
#define MHL_MSC_REG_5F_reg_addr                                                      "0xB8062D20"
#define MHL_MSC_REG_5F_reg                                                           0xB8062D20
#define set_MHL_MSC_REG_5F_reg(data)   (*((volatile unsigned int*) MHL_MSC_REG_5F_reg)=data)
#define get_MHL_MSC_REG_5F_reg   (*((volatile unsigned int*) MHL_MSC_REG_5F_reg))
#define MHL_MSC_REG_5F_inst_adr                                                      "0x0048"
#define MHL_MSC_REG_5F_inst                                                          0x0048
#define MHL_MSC_REG_5F_scratch_5F_shift                                              (0)
#define MHL_MSC_REG_5F_scratch_5F_mask                                               (0x000000FF)
#define MHL_MSC_REG_5F_scratch_5F(data)                                              (0x000000FF&((data)<<0))
#define MHL_MSC_REG_5F_scratch_5F_src(data)                                          ((0x000000FF&(data))>>0)
#define MHL_MSC_REG_5F_get_scratch_5F(data)                                          ((0x000000FF&(data))>>0)


#define MHL_CBUS_LINK_00                                                             0x18062D24
#define MHL_CBUS_LINK_00_reg_addr                                                    "0xB8062D24"
#define MHL_CBUS_LINK_00_reg                                                         0xB8062D24
#define set_MHL_CBUS_LINK_00_reg(data)   (*((volatile unsigned int*) MHL_CBUS_LINK_00_reg)=data)
#define get_MHL_CBUS_LINK_00_reg   (*((volatile unsigned int*) MHL_CBUS_LINK_00_reg))
#define MHL_CBUS_LINK_00_inst_adr                                                    "0x0049"
#define MHL_CBUS_LINK_00_inst                                                        0x0049
#define MHL_CBUS_LINK_00_sync0_hb_shift                                              (12)
#define MHL_CBUS_LINK_00_sync0_hb_mask                                               (0x001FF000)
#define MHL_CBUS_LINK_00_sync0_hb(data)                                              (0x001FF000&((data)<<12))
#define MHL_CBUS_LINK_00_sync0_hb_src(data)                                          ((0x001FF000&(data))>>12)
#define MHL_CBUS_LINK_00_get_sync0_hb(data)                                          ((0x001FF000&(data))>>12)
#define MHL_CBUS_LINK_00_sync0_lb_shift                                              (0)
#define MHL_CBUS_LINK_00_sync0_lb_mask                                               (0x000001FF)
#define MHL_CBUS_LINK_00_sync0_lb(data)                                              (0x000001FF&((data)<<0))
#define MHL_CBUS_LINK_00_sync0_lb_src(data)                                          ((0x000001FF&(data))>>0)
#define MHL_CBUS_LINK_00_get_sync0_lb(data)                                          ((0x000001FF&(data))>>0)


#define MHL_CBUS_LINK_01                                                             0x18062D28
#define MHL_CBUS_LINK_01_reg_addr                                                    "0xB8062D28"
#define MHL_CBUS_LINK_01_reg                                                         0xB8062D28
#define set_MHL_CBUS_LINK_01_reg(data)   (*((volatile unsigned int*) MHL_CBUS_LINK_01_reg)=data)
#define get_MHL_CBUS_LINK_01_reg   (*((volatile unsigned int*) MHL_CBUS_LINK_01_reg))
#define MHL_CBUS_LINK_01_inst_adr                                                    "0x004A"
#define MHL_CBUS_LINK_01_inst                                                        0x004A
#define MHL_CBUS_LINK_01_sync1_hb_shift                                              (8)
#define MHL_CBUS_LINK_01_sync1_hb_mask                                               (0x0000FF00)
#define MHL_CBUS_LINK_01_sync1_hb(data)                                              (0x0000FF00&((data)<<8))
#define MHL_CBUS_LINK_01_sync1_hb_src(data)                                          ((0x0000FF00&(data))>>8)
#define MHL_CBUS_LINK_01_get_sync1_hb(data)                                          ((0x0000FF00&(data))>>8)
#define MHL_CBUS_LINK_01_sync1_lb_shift                                              (0)
#define MHL_CBUS_LINK_01_sync1_lb_mask                                               (0x000000FF)
#define MHL_CBUS_LINK_01_sync1_lb(data)                                              (0x000000FF&((data)<<0))
#define MHL_CBUS_LINK_01_sync1_lb_src(data)                                          ((0x000000FF&(data))>>0)
#define MHL_CBUS_LINK_01_get_sync1_lb(data)                                          ((0x000000FF&(data))>>0)


#define MHL_CBUS_LINK_02                                                             0x18062D2C
#define MHL_CBUS_LINK_02_reg_addr                                                    "0xB8062D2C"
#define MHL_CBUS_LINK_02_reg                                                         0xB8062D2C
#define set_MHL_CBUS_LINK_02_reg(data)   (*((volatile unsigned int*) MHL_CBUS_LINK_02_reg)=data)
#define get_MHL_CBUS_LINK_02_reg   (*((volatile unsigned int*) MHL_CBUS_LINK_02_reg))
#define MHL_CBUS_LINK_02_inst_adr                                                    "0x004B"
#define MHL_CBUS_LINK_02_inst                                                        0x004B
#define MHL_CBUS_LINK_02_sync_bit_time_shift                                         (0)
#define MHL_CBUS_LINK_02_sync_bit_time_mask                                          (0x000000FF)
#define MHL_CBUS_LINK_02_sync_bit_time(data)                                         (0x000000FF&((data)<<0))
#define MHL_CBUS_LINK_02_sync_bit_time_src(data)                                     ((0x000000FF&(data))>>0)
#define MHL_CBUS_LINK_02_get_sync_bit_time(data)                                     ((0x000000FF&(data))>>0)


#define MHL_CBUS_LINK_03                                                             0x18062D30
#define MHL_CBUS_LINK_03_reg_addr                                                    "0xB8062D30"
#define MHL_CBUS_LINK_03_reg                                                         0xB8062D30
#define set_MHL_CBUS_LINK_03_reg(data)   (*((volatile unsigned int*) MHL_CBUS_LINK_03_reg)=data)
#define get_MHL_CBUS_LINK_03_reg   (*((volatile unsigned int*) MHL_CBUS_LINK_03_reg))
#define MHL_CBUS_LINK_03_inst_adr                                                    "0x004C"
#define MHL_CBUS_LINK_03_inst                                                        0x004C
#define MHL_CBUS_LINK_03_abs_thres_en_shift                                          (8)
#define MHL_CBUS_LINK_03_abs_thres_en_mask                                           (0x00000100)
#define MHL_CBUS_LINK_03_abs_thres_en(data)                                          (0x00000100&((data)<<8))
#define MHL_CBUS_LINK_03_abs_thres_en_src(data)                                      ((0x00000100&(data))>>8)
#define MHL_CBUS_LINK_03_get_abs_thres_en(data)                                      ((0x00000100&(data))>>8)
#define MHL_CBUS_LINK_03_abs_threshold_shift                                         (0)
#define MHL_CBUS_LINK_03_abs_threshold_mask                                          (0x000000FF)
#define MHL_CBUS_LINK_03_abs_threshold(data)                                         (0x000000FF&((data)<<0))
#define MHL_CBUS_LINK_03_abs_threshold_src(data)                                     ((0x000000FF&(data))>>0)
#define MHL_CBUS_LINK_03_get_abs_threshold(data)                                     ((0x000000FF&(data))>>0)


#define MHL_CBUS_LINK_04                                                             0x18062D34
#define MHL_CBUS_LINK_04_reg_addr                                                    "0xB8062D34"
#define MHL_CBUS_LINK_04_reg                                                         0xB8062D34
#define set_MHL_CBUS_LINK_04_reg(data)   (*((volatile unsigned int*) MHL_CBUS_LINK_04_reg)=data)
#define get_MHL_CBUS_LINK_04_reg   (*((volatile unsigned int*) MHL_CBUS_LINK_04_reg))
#define MHL_CBUS_LINK_04_inst_adr                                                    "0x004D"
#define MHL_CBUS_LINK_04_inst                                                        0x004D


#define MHL_CBUS_LINK_05                                                             0x18062D38
#define MHL_CBUS_LINK_05_reg_addr                                                    "0xB8062D38"
#define MHL_CBUS_LINK_05_reg                                                         0xB8062D38
#define set_MHL_CBUS_LINK_05_reg(data)   (*((volatile unsigned int*) MHL_CBUS_LINK_05_reg)=data)
#define get_MHL_CBUS_LINK_05_reg   (*((volatile unsigned int*) MHL_CBUS_LINK_05_reg))
#define MHL_CBUS_LINK_05_inst_adr                                                    "0x004E"
#define MHL_CBUS_LINK_05_inst                                                        0x004E
#define MHL_CBUS_LINK_05_irq_en_parity_fail_shift                                    (6)
#define MHL_CBUS_LINK_05_irq_en_parity_fail_mask                                     (0x00000040)
#define MHL_CBUS_LINK_05_irq_en_parity_fail(data)                                    (0x00000040&((data)<<6))
#define MHL_CBUS_LINK_05_irq_en_parity_fail_src(data)                                ((0x00000040&(data))>>6)
#define MHL_CBUS_LINK_05_get_irq_en_parity_fail(data)                                ((0x00000040&(data))>>6)
#define MHL_CBUS_LINK_05_ctrl_16_resv_shift                                          (5)
#define MHL_CBUS_LINK_05_ctrl_16_resv_mask                                           (0x00000020)
#define MHL_CBUS_LINK_05_ctrl_16_resv(data)                                          (0x00000020&((data)<<5))
#define MHL_CBUS_LINK_05_ctrl_16_resv_src(data)                                      ((0x00000020&(data))>>5)
#define MHL_CBUS_LINK_05_get_ctrl_16_resv(data)                                      ((0x00000020&(data))>>5)
#define MHL_CBUS_LINK_05_parity_fail_limit_shift                                     (0)
#define MHL_CBUS_LINK_05_parity_fail_limit_mask                                      (0x0000001F)
#define MHL_CBUS_LINK_05_parity_fail_limit(data)                                     (0x0000001F&((data)<<0))
#define MHL_CBUS_LINK_05_parity_fail_limit_src(data)                                 ((0x0000001F&(data))>>0)
#define MHL_CBUS_LINK_05_get_parity_fail_limit(data)                                 ((0x0000001F&(data))>>0)


#define MHL_CBUS_LINK_06                                                             0x18062D3C
#define MHL_CBUS_LINK_06_reg_addr                                                    "0xB8062D3C"
#define MHL_CBUS_LINK_06_reg                                                         0xB8062D3C
#define set_MHL_CBUS_LINK_06_reg(data)   (*((volatile unsigned int*) MHL_CBUS_LINK_06_reg)=data)
#define get_MHL_CBUS_LINK_06_reg   (*((volatile unsigned int*) MHL_CBUS_LINK_06_reg))
#define MHL_CBUS_LINK_06_inst_adr                                                    "0x004F"
#define MHL_CBUS_LINK_06_inst                                                        0x004F
#define MHL_CBUS_LINK_06_ack_fall_shift                                              (0)
#define MHL_CBUS_LINK_06_ack_fall_mask                                               (0x0000007F)
#define MHL_CBUS_LINK_06_ack_fall(data)                                              (0x0000007F&((data)<<0))
#define MHL_CBUS_LINK_06_ack_fall_src(data)                                          ((0x0000007F&(data))>>0)
#define MHL_CBUS_LINK_06_get_ack_fall(data)                                          ((0x0000007F&(data))>>0)


#define MHL_CBUS_LINK_07                                                             0x18062D40
#define MHL_CBUS_LINK_07_reg_addr                                                    "0xB8062D40"
#define MHL_CBUS_LINK_07_reg                                                         0xB8062D40
#define set_MHL_CBUS_LINK_07_reg(data)   (*((volatile unsigned int*) MHL_CBUS_LINK_07_reg)=data)
#define get_MHL_CBUS_LINK_07_reg   (*((volatile unsigned int*) MHL_CBUS_LINK_07_reg))
#define MHL_CBUS_LINK_07_inst_adr                                                    "0x0050"
#define MHL_CBUS_LINK_07_inst                                                        0x0050
#define MHL_CBUS_LINK_07_ack_0_shift                                                 (0)
#define MHL_CBUS_LINK_07_ack_0_mask                                                  (0x0000007F)
#define MHL_CBUS_LINK_07_ack_0(data)                                                 (0x0000007F&((data)<<0))
#define MHL_CBUS_LINK_07_ack_0_src(data)                                             ((0x0000007F&(data))>>0)
#define MHL_CBUS_LINK_07_get_ack_0(data)                                             ((0x0000007F&(data))>>0)


#define MHL_CBUS_LINK_08                                                             0x18062D44
#define MHL_CBUS_LINK_08_reg_addr                                                    "0xB8062D44"
#define MHL_CBUS_LINK_08_reg                                                         0xB8062D44
#define set_MHL_CBUS_LINK_08_reg(data)   (*((volatile unsigned int*) MHL_CBUS_LINK_08_reg)=data)
#define get_MHL_CBUS_LINK_08_reg   (*((volatile unsigned int*) MHL_CBUS_LINK_08_reg))
#define MHL_CBUS_LINK_08_inst_adr                                                    "0x0051"
#define MHL_CBUS_LINK_08_inst                                                        0x0051
#define MHL_CBUS_LINK_08_irq_parity_fail_shift                                       (7)
#define MHL_CBUS_LINK_08_irq_parity_fail_mask                                        (0x00000080)
#define MHL_CBUS_LINK_08_irq_parity_fail(data)                                       (0x00000080&((data)<<7))
#define MHL_CBUS_LINK_08_irq_parity_fail_src(data)                                   ((0x00000080&(data))>>7)
#define MHL_CBUS_LINK_08_get_irq_parity_fail(data)                                   ((0x00000080&(data))>>7)


#define MHL_CBUS_LINK_09                                                             0x18062D48
#define MHL_CBUS_LINK_09_reg_addr                                                    "0xB8062D48"
#define MHL_CBUS_LINK_09_reg                                                         0xB8062D48
#define set_MHL_CBUS_LINK_09_reg(data)   (*((volatile unsigned int*) MHL_CBUS_LINK_09_reg)=data)
#define get_MHL_CBUS_LINK_09_reg   (*((volatile unsigned int*) MHL_CBUS_LINK_09_reg))
#define MHL_CBUS_LINK_09_inst_adr                                                    "0x0052"
#define MHL_CBUS_LINK_09_inst                                                        0x0052
#define MHL_CBUS_LINK_09_tx_bit_time_shift                                           (0)
#define MHL_CBUS_LINK_09_tx_bit_time_mask                                            (0x000000FF)
#define MHL_CBUS_LINK_09_tx_bit_time(data)                                           (0x000000FF&((data)<<0))
#define MHL_CBUS_LINK_09_tx_bit_time_src(data)                                       ((0x000000FF&(data))>>0)
#define MHL_CBUS_LINK_09_get_tx_bit_time(data)                                       ((0x000000FF&(data))>>0)


#define MHL_CBUS_LINK_0A                                                             0x18062D4C
#define MHL_CBUS_LINK_0A_reg_addr                                                    "0xB8062D4C"
#define MHL_CBUS_LINK_0A_reg                                                         0xB8062D4C
#define set_MHL_CBUS_LINK_0A_reg(data)   (*((volatile unsigned int*) MHL_CBUS_LINK_0A_reg)=data)
#define get_MHL_CBUS_LINK_0A_reg   (*((volatile unsigned int*) MHL_CBUS_LINK_0A_reg))
#define MHL_CBUS_LINK_0A_inst_adr                                                    "0x0053"
#define MHL_CBUS_LINK_0A_inst                                                        0x0053


#define MHL_CBUS_LINK_0B                                                             0x18062D50
#define MHL_CBUS_LINK_0B_reg_addr                                                    "0xB8062D50"
#define MHL_CBUS_LINK_0B_reg                                                         0xB8062D50
#define set_MHL_CBUS_LINK_0B_reg(data)   (*((volatile unsigned int*) MHL_CBUS_LINK_0B_reg)=data)
#define get_MHL_CBUS_LINK_0B_reg   (*((volatile unsigned int*) MHL_CBUS_LINK_0B_reg))
#define MHL_CBUS_LINK_0B_inst_adr                                                    "0x0054"
#define MHL_CBUS_LINK_0B_inst                                                        0x0054
#define MHL_CBUS_LINK_0B_tx_ack_fal_shift                                            (0)
#define MHL_CBUS_LINK_0B_tx_ack_fal_mask                                             (0x0000007F)
#define MHL_CBUS_LINK_0B_tx_ack_fal(data)                                            (0x0000007F&((data)<<0))
#define MHL_CBUS_LINK_0B_tx_ack_fal_src(data)                                        ((0x0000007F&(data))>>0)
#define MHL_CBUS_LINK_0B_get_tx_ack_fal(data)                                        ((0x0000007F&(data))>>0)


#define MHL_CBUS_LINK_0C                                                             0x18062D54
#define MHL_CBUS_LINK_0C_reg_addr                                                    "0xB8062D54"
#define MHL_CBUS_LINK_0C_reg                                                         0xB8062D54
#define set_MHL_CBUS_LINK_0C_reg(data)   (*((volatile unsigned int*) MHL_CBUS_LINK_0C_reg)=data)
#define get_MHL_CBUS_LINK_0C_reg   (*((volatile unsigned int*) MHL_CBUS_LINK_0C_reg))
#define MHL_CBUS_LINK_0C_inst_adr                                                    "0x0055"
#define MHL_CBUS_LINK_0C_inst                                                        0x0055
#define MHL_CBUS_LINK_0C_tx_ack_low_hb_shift                                         (0)
#define MHL_CBUS_LINK_0C_tx_ack_low_hb_mask                                          (0x0000007F)
#define MHL_CBUS_LINK_0C_tx_ack_low_hb(data)                                         (0x0000007F&((data)<<0))
#define MHL_CBUS_LINK_0C_tx_ack_low_hb_src(data)                                     ((0x0000007F&(data))>>0)
#define MHL_CBUS_LINK_0C_get_tx_ack_low_hb(data)                                     ((0x0000007F&(data))>>0)


#define MHL_CBUS_LINK_0D                                                             0x18062D58
#define MHL_CBUS_LINK_0D_reg_addr                                                    "0xB8062D58"
#define MHL_CBUS_LINK_0D_reg                                                         0xB8062D58
#define set_MHL_CBUS_LINK_0D_reg(data)   (*((volatile unsigned int*) MHL_CBUS_LINK_0D_reg)=data)
#define get_MHL_CBUS_LINK_0D_reg   (*((volatile unsigned int*) MHL_CBUS_LINK_0D_reg))
#define MHL_CBUS_LINK_0D_inst_adr                                                    "0x0056"
#define MHL_CBUS_LINK_0D_inst                                                        0x0056
#define MHL_CBUS_LINK_0D_tx_ack_low_lb_shift                                         (0)
#define MHL_CBUS_LINK_0D_tx_ack_low_lb_mask                                          (0x0000007F)
#define MHL_CBUS_LINK_0D_tx_ack_low_lb(data)                                         (0x0000007F&((data)<<0))
#define MHL_CBUS_LINK_0D_tx_ack_low_lb_src(data)                                     ((0x0000007F&(data))>>0)
#define MHL_CBUS_LINK_0D_get_tx_ack_low_lb(data)                                     ((0x0000007F&(data))>>0)


#define MHL_CBUS_LINK_0E                                                             0x18062D5C
#define MHL_CBUS_LINK_0E_reg_addr                                                    "0xB8062D5C"
#define MHL_CBUS_LINK_0E_reg                                                         0xB8062D5C
#define set_MHL_CBUS_LINK_0E_reg(data)   (*((volatile unsigned int*) MHL_CBUS_LINK_0E_reg)=data)
#define get_MHL_CBUS_LINK_0E_reg   (*((volatile unsigned int*) MHL_CBUS_LINK_0E_reg))
#define MHL_CBUS_LINK_0E_inst_adr                                                    "0x0057"
#define MHL_CBUS_LINK_0E_inst                                                        0x0057
#define MHL_CBUS_LINK_0E_retry_lv_shift                                              (8)
#define MHL_CBUS_LINK_0E_retry_lv_mask                                               (0x00007F00)
#define MHL_CBUS_LINK_0E_retry_lv(data)                                              (0x00007F00&((data)<<8))
#define MHL_CBUS_LINK_0E_retry_lv_src(data)                                          ((0x00007F00&(data))>>8)
#define MHL_CBUS_LINK_0E_get_retry_lv(data)                                          ((0x00007F00&(data))>>8)
#define MHL_CBUS_LINK_0E_irq_en_retry_ddc_shift                                      (5)
#define MHL_CBUS_LINK_0E_irq_en_retry_ddc_mask                                       (0x00000020)
#define MHL_CBUS_LINK_0E_irq_en_retry_ddc(data)                                      (0x00000020&((data)<<5))
#define MHL_CBUS_LINK_0E_irq_en_retry_ddc_src(data)                                  ((0x00000020&(data))>>5)
#define MHL_CBUS_LINK_0E_get_irq_en_retry_ddc(data)                                  ((0x00000020&(data))>>5)
#define MHL_CBUS_LINK_0E_irq_en_retry_msc_shift                                      (4)
#define MHL_CBUS_LINK_0E_irq_en_retry_msc_mask                                       (0x00000010)
#define MHL_CBUS_LINK_0E_irq_en_retry_msc(data)                                      (0x00000010&((data)<<4))
#define MHL_CBUS_LINK_0E_irq_en_retry_msc_src(data)                                  ((0x00000010&(data))>>4)
#define MHL_CBUS_LINK_0E_get_irq_en_retry_msc(data)                                  ((0x00000010&(data))>>4)
#define MHL_CBUS_LINK_0E_Dmy_shift                                                   (0)
#define MHL_CBUS_LINK_0E_Dmy_mask                                                    (0x0000000F)
#define MHL_CBUS_LINK_0E_Dmy(data)                                                   (0x0000000F&((data)<<0))
#define MHL_CBUS_LINK_0E_Dmy_src(data)                                               ((0x0000000F&(data))>>0)
#define MHL_CBUS_LINK_0E_get_Dmy(data)                                               ((0x0000000F&(data))>>0)


#define MHL_CBUS_LINK_0F                                                             0x18062D60
#define MHL_CBUS_LINK_0F_reg_addr                                                    "0xB8062D60"
#define MHL_CBUS_LINK_0F_reg                                                         0xB8062D60
#define set_MHL_CBUS_LINK_0F_reg(data)   (*((volatile unsigned int*) MHL_CBUS_LINK_0F_reg)=data)
#define get_MHL_CBUS_LINK_0F_reg   (*((volatile unsigned int*) MHL_CBUS_LINK_0F_reg))
#define MHL_CBUS_LINK_0F_inst_adr                                                    "0x0058"
#define MHL_CBUS_LINK_0F_inst                                                        0x0058
#define MHL_CBUS_LINK_0F_drv_str_shift                                               (8)
#define MHL_CBUS_LINK_0F_drv_str_mask                                                (0x00001F00)
#define MHL_CBUS_LINK_0F_drv_str(data)                                               (0x00001F00&((data)<<8))
#define MHL_CBUS_LINK_0F_drv_str_src(data)                                           ((0x00001F00&(data))>>8)
#define MHL_CBUS_LINK_0F_get_drv_str(data)                                           ((0x00001F00&(data))>>8)
#define MHL_CBUS_LINK_0F_drv_hi_cbus_shift                                           (0)
#define MHL_CBUS_LINK_0F_drv_hi_cbus_mask                                            (0x0000003F)
#define MHL_CBUS_LINK_0F_drv_hi_cbus(data)                                           (0x0000003F&((data)<<0))
#define MHL_CBUS_LINK_0F_drv_hi_cbus_src(data)                                       ((0x0000003F&(data))>>0)
#define MHL_CBUS_LINK_0F_get_drv_hi_cbus(data)                                       ((0x0000003F&(data))>>0)


#define MHL_CBUS_LINK_10                                                             0x18062D64
#define MHL_CBUS_LINK_10_reg_addr                                                    "0xB8062D64"
#define MHL_CBUS_LINK_10_reg                                                         0xB8062D64
#define set_MHL_CBUS_LINK_10_reg(data)   (*((volatile unsigned int*) MHL_CBUS_LINK_10_reg)=data)
#define get_MHL_CBUS_LINK_10_reg   (*((volatile unsigned int*) MHL_CBUS_LINK_10_reg))
#define MHL_CBUS_LINK_10_inst_adr                                                    "0x0059"
#define MHL_CBUS_LINK_10_inst                                                        0x0059
#define MHL_CBUS_LINK_10_wait_shift                                                  (0)
#define MHL_CBUS_LINK_10_wait_mask                                                   (0x0000000F)
#define MHL_CBUS_LINK_10_wait(data)                                                  (0x0000000F&((data)<<0))
#define MHL_CBUS_LINK_10_wait_src(data)                                              ((0x0000000F&(data))>>0)
#define MHL_CBUS_LINK_10_get_wait(data)                                              ((0x0000000F&(data))>>0)


#define MHL_CBUS_LINK_11                                                             0x18062D68
#define MHL_CBUS_LINK_11_reg_addr                                                    "0xB8062D68"
#define MHL_CBUS_LINK_11_reg                                                         0xB8062D68
#define set_MHL_CBUS_LINK_11_reg(data)   (*((volatile unsigned int*) MHL_CBUS_LINK_11_reg)=data)
#define get_MHL_CBUS_LINK_11_reg   (*((volatile unsigned int*) MHL_CBUS_LINK_11_reg))
#define MHL_CBUS_LINK_11_inst_adr                                                    "0x005A"
#define MHL_CBUS_LINK_11_inst                                                        0x005A
#define MHL_CBUS_LINK_11_req_opp_shift                                               (0)
#define MHL_CBUS_LINK_11_req_opp_mask                                                (0x000000FF)
#define MHL_CBUS_LINK_11_req_opp(data)                                               (0x000000FF&((data)<<0))
#define MHL_CBUS_LINK_11_req_opp_src(data)                                           ((0x000000FF&(data))>>0)
#define MHL_CBUS_LINK_11_get_req_opp(data)                                           ((0x000000FF&(data))>>0)


#define MHL_CBUS_LINK_12                                                             0x18062D6C
#define MHL_CBUS_LINK_12_reg_addr                                                    "0xB8062D6C"
#define MHL_CBUS_LINK_12_reg                                                         0xB8062D6C
#define set_MHL_CBUS_LINK_12_reg(data)   (*((volatile unsigned int*) MHL_CBUS_LINK_12_reg)=data)
#define get_MHL_CBUS_LINK_12_reg   (*((volatile unsigned int*) MHL_CBUS_LINK_12_reg))
#define MHL_CBUS_LINK_12_inst_adr                                                    "0x005B"
#define MHL_CBUS_LINK_12_inst                                                        0x005B
#define MHL_CBUS_LINK_12_req_cont_shift                                              (0)
#define MHL_CBUS_LINK_12_req_cont_mask                                               (0x000000FF)
#define MHL_CBUS_LINK_12_req_cont(data)                                              (0x000000FF&((data)<<0))
#define MHL_CBUS_LINK_12_req_cont_src(data)                                          ((0x000000FF&(data))>>0)
#define MHL_CBUS_LINK_12_get_req_cont(data)                                          ((0x000000FF&(data))>>0)


#define MHL_CBUS_LINK_13                                                             0x18062D70
#define MHL_CBUS_LINK_13_reg_addr                                                    "0xB8062D70"
#define MHL_CBUS_LINK_13_reg                                                         0xB8062D70
#define set_MHL_CBUS_LINK_13_reg(data)   (*((volatile unsigned int*) MHL_CBUS_LINK_13_reg)=data)
#define get_MHL_CBUS_LINK_13_reg   (*((volatile unsigned int*) MHL_CBUS_LINK_13_reg))
#define MHL_CBUS_LINK_13_inst_adr                                                    "0x005C"
#define MHL_CBUS_LINK_13_inst                                                        0x005C
#define MHL_CBUS_LINK_13_req_hold_shift                                              (4)
#define MHL_CBUS_LINK_13_req_hold_mask                                               (0x000000F0)
#define MHL_CBUS_LINK_13_req_hold(data)                                              (0x000000F0&((data)<<4))
#define MHL_CBUS_LINK_13_req_hold_src(data)                                          ((0x000000F0&(data))>>4)
#define MHL_CBUS_LINK_13_get_req_hold(data)                                          ((0x000000F0&(data))>>4)
#define MHL_CBUS_LINK_13_resp_hold_shift                                             (0)
#define MHL_CBUS_LINK_13_resp_hold_mask                                              (0x0000000F)
#define MHL_CBUS_LINK_13_resp_hold(data)                                             (0x0000000F&((data)<<0))
#define MHL_CBUS_LINK_13_resp_hold_src(data)                                         ((0x0000000F&(data))>>0)
#define MHL_CBUS_LINK_13_get_resp_hold(data)                                         ((0x0000000F&(data))>>0)


#define MHL_CBUS_LINK_14                                                             0x18062D74
#define MHL_CBUS_LINK_14_reg_addr                                                    "0xB8062D74"
#define MHL_CBUS_LINK_14_reg                                                         0xB8062D74
#define set_MHL_CBUS_LINK_14_reg(data)   (*((volatile unsigned int*) MHL_CBUS_LINK_14_reg)=data)
#define get_MHL_CBUS_LINK_14_reg   (*((volatile unsigned int*) MHL_CBUS_LINK_14_reg))
#define MHL_CBUS_LINK_14_inst_adr                                                    "0x005D"
#define MHL_CBUS_LINK_14_inst                                                        0x005D
#define MHL_CBUS_LINK_14_rx_fifo_clr_shift                                           (31)
#define MHL_CBUS_LINK_14_rx_fifo_clr_mask                                            (0x80000000)
#define MHL_CBUS_LINK_14_rx_fifo_clr(data)                                           (0x80000000&((data)<<31))
#define MHL_CBUS_LINK_14_rx_fifo_clr_src(data)                                       ((0x80000000&(data))>>31)
#define MHL_CBUS_LINK_14_get_rx_fifo_clr(data)                                       ((0x80000000&(data))>>31)
#define MHL_CBUS_LINK_14_packet_max_shift                                            (16)
#define MHL_CBUS_LINK_14_packet_max_mask                                             (0x001F0000)
#define MHL_CBUS_LINK_14_packet_max(data)                                            (0x001F0000&((data)<<16))
#define MHL_CBUS_LINK_14_packet_max_src(data)                                        ((0x001F0000&(data))>>16)
#define MHL_CBUS_LINK_14_get_packet_max(data)                                        ((0x001F0000&(data))>>16)
#define MHL_CBUS_LINK_14_glob_time_shift                                             (8)
#define MHL_CBUS_LINK_14_glob_time_mask                                              (0x0000FF00)
#define MHL_CBUS_LINK_14_glob_time(data)                                             (0x0000FF00&((data)<<8))
#define MHL_CBUS_LINK_14_glob_time_src(data)                                         ((0x0000FF00&(data))>>8)
#define MHL_CBUS_LINK_14_get_glob_time(data)                                         ((0x0000FF00&(data))>>8)
#define MHL_CBUS_LINK_14_irq_en_link_err_shift                                       (0)
#define MHL_CBUS_LINK_14_irq_en_link_err_mask                                        (0x00000001)
#define MHL_CBUS_LINK_14_irq_en_link_err(data)                                       (0x00000001&((data)<<0))
#define MHL_CBUS_LINK_14_irq_en_link_err_src(data)                                   ((0x00000001&(data))>>0)
#define MHL_CBUS_LINK_14_get_irq_en_link_err(data)                                   ((0x00000001&(data))>>0)


#define MHL_CBUS_LINK_15                                                             0x18062D78
#define MHL_CBUS_LINK_15_reg_addr                                                    "0xB8062D78"
#define MHL_CBUS_LINK_15_reg                                                         0xB8062D78
#define set_MHL_CBUS_LINK_15_reg(data)   (*((volatile unsigned int*) MHL_CBUS_LINK_15_reg)=data)
#define get_MHL_CBUS_LINK_15_reg   (*((volatile unsigned int*) MHL_CBUS_LINK_15_reg))
#define MHL_CBUS_LINK_15_inst_adr                                                    "0x005E"
#define MHL_CBUS_LINK_15_inst                                                        0x005E
#define MHL_CBUS_LINK_15_burst_timeout_shift                                         (6)
#define MHL_CBUS_LINK_15_burst_timeout_mask                                          (0x00000040)
#define MHL_CBUS_LINK_15_burst_timeout(data)                                         (0x00000040&((data)<<6))
#define MHL_CBUS_LINK_15_burst_timeout_src(data)                                     ((0x00000040&(data))>>6)
#define MHL_CBUS_LINK_15_get_burst_timeout(data)                                     ((0x00000040&(data))>>6)
#define MHL_CBUS_LINK_15_irq_retry_ddc_shift                                         (3)
#define MHL_CBUS_LINK_15_irq_retry_ddc_mask                                          (0x00000008)
#define MHL_CBUS_LINK_15_irq_retry_ddc(data)                                         (0x00000008&((data)<<3))
#define MHL_CBUS_LINK_15_irq_retry_ddc_src(data)                                     ((0x00000008&(data))>>3)
#define MHL_CBUS_LINK_15_get_irq_retry_ddc(data)                                     ((0x00000008&(data))>>3)
#define MHL_CBUS_LINK_15_irq_retry_msc_shift                                         (2)
#define MHL_CBUS_LINK_15_irq_retry_msc_mask                                          (0x00000004)
#define MHL_CBUS_LINK_15_irq_retry_msc(data)                                         (0x00000004&((data)<<2))
#define MHL_CBUS_LINK_15_irq_retry_msc_src(data)                                     ((0x00000004&(data))>>2)
#define MHL_CBUS_LINK_15_get_irq_retry_msc(data)                                     ((0x00000004&(data))>>2)
#define MHL_CBUS_LINK_15_chk_err_shift                                               (1)
#define MHL_CBUS_LINK_15_chk_err_mask                                                (0x00000002)
#define MHL_CBUS_LINK_15_chk_err(data)                                               (0x00000002&((data)<<1))
#define MHL_CBUS_LINK_15_chk_err_src(data)                                           ((0x00000002&(data))>>1)
#define MHL_CBUS_LINK_15_get_chk_err(data)                                           ((0x00000002&(data))>>1)
#define MHL_CBUS_LINK_15_irq_link_err_shift                                          (0)
#define MHL_CBUS_LINK_15_irq_link_err_mask                                           (0x00000001)
#define MHL_CBUS_LINK_15_irq_link_err(data)                                          (0x00000001&((data)<<0))
#define MHL_CBUS_LINK_15_irq_link_err_src(data)                                      ((0x00000001&(data))>>0)
#define MHL_CBUS_LINK_15_get_irq_link_err(data)                                      ((0x00000001&(data))>>0)


#define MHL_CBUS_FLAG_0                                                              0x18062D7C
#define MHL_CBUS_FLAG_0_reg_addr                                                     "0xB8062D7C"
#define MHL_CBUS_FLAG_0_reg                                                          0xB8062D7C
#define set_MHL_CBUS_FLAG_0_reg(data)   (*((volatile unsigned int*) MHL_CBUS_FLAG_0_reg)=data)
#define get_MHL_CBUS_FLAG_0_reg   (*((volatile unsigned int*) MHL_CBUS_FLAG_0_reg))
#define MHL_CBUS_FLAG_0_inst_adr                                                     "0x005F"
#define MHL_CBUS_FLAG_0_inst                                                         0x005F
#define MHL_CBUS_FLAG_0_fwdef_cmd_rev_shift                                          (8)
#define MHL_CBUS_FLAG_0_fwdef_cmd_rev_mask                                           (0x0000FF00)
#define MHL_CBUS_FLAG_0_fwdef_cmd_rev(data)                                          (0x0000FF00&((data)<<8))
#define MHL_CBUS_FLAG_0_fwdef_cmd_rev_src(data)                                      ((0x0000FF00&(data))>>8)
#define MHL_CBUS_FLAG_0_get_fwdef_cmd_rev(data)                                      ((0x0000FF00&(data))>>8)
#define MHL_CBUS_FLAG_0_avoid_conf_shift                                             (0)
#define MHL_CBUS_FLAG_0_avoid_conf_mask                                              (0x00000001)
#define MHL_CBUS_FLAG_0_avoid_conf(data)                                             (0x00000001&((data)<<0))
#define MHL_CBUS_FLAG_0_avoid_conf_src(data)                                         ((0x00000001&(data))>>0)
#define MHL_CBUS_FLAG_0_get_avoid_conf(data)                                         ((0x00000001&(data))>>0)


#define MHL_CBUS_MSC_00                                                              0x18062D80
#define MHL_CBUS_MSC_00_reg_addr                                                     "0xB8062D80"
#define MHL_CBUS_MSC_00_reg                                                          0xB8062D80
#define set_MHL_CBUS_MSC_00_reg(data)   (*((volatile unsigned int*) MHL_CBUS_MSC_00_reg)=data)
#define get_MHL_CBUS_MSC_00_reg   (*((volatile unsigned int*) MHL_CBUS_MSC_00_reg))
#define MHL_CBUS_MSC_00_inst_adr                                                     "0x0060"
#define MHL_CBUS_MSC_00_inst                                                         0x0060
#define MHL_CBUS_MSC_00_msc_idle_resp_abort_shift                                    (31)
#define MHL_CBUS_MSC_00_msc_idle_resp_abort_mask                                     (0x80000000)
#define MHL_CBUS_MSC_00_msc_idle_resp_abort(data)                                    (0x80000000&((data)<<31))
#define MHL_CBUS_MSC_00_msc_idle_resp_abort_src(data)                                ((0x80000000&(data))>>31)
#define MHL_CBUS_MSC_00_get_msc_idle_resp_abort(data)                                ((0x80000000&(data))>>31)
#define MHL_CBUS_MSC_00_mcumsc_en_shift                                              (5)
#define MHL_CBUS_MSC_00_mcumsc_en_mask                                               (0x00000020)
#define MHL_CBUS_MSC_00_mcumsc_en(data)                                              (0x00000020&((data)<<5))
#define MHL_CBUS_MSC_00_mcumsc_en_src(data)                                          ((0x00000020&(data))>>5)
#define MHL_CBUS_MSC_00_get_mcumsc_en(data)                                          ((0x00000020&(data))>>5)
#define MHL_CBUS_MSC_00_Dmy_shift                                                    (0)
#define MHL_CBUS_MSC_00_Dmy_mask                                                     (0x0000001F)
#define MHL_CBUS_MSC_00_Dmy(data)                                                    (0x0000001F&((data)<<0))
#define MHL_CBUS_MSC_00_Dmy_src(data)                                                ((0x0000001F&(data))>>0)
#define MHL_CBUS_MSC_00_get_Dmy(data)                                                ((0x0000001F&(data))>>0)


#define MHL_CBUS_MSC_01                                                              0x18062D84
#define MHL_CBUS_MSC_01_reg_addr                                                     "0xB8062D84"
#define MHL_CBUS_MSC_01_reg                                                          0xB8062D84
#define set_MHL_CBUS_MSC_01_reg(data)   (*((volatile unsigned int*) MHL_CBUS_MSC_01_reg)=data)
#define get_MHL_CBUS_MSC_01_reg   (*((volatile unsigned int*) MHL_CBUS_MSC_01_reg))
#define MHL_CBUS_MSC_01_inst_adr                                                     "0x0061"
#define MHL_CBUS_MSC_01_inst                                                         0x0061
#define MHL_CBUS_MSC_01_na_msc_cmd_shift                                             (0)
#define MHL_CBUS_MSC_01_na_msc_cmd_mask                                              (0x000000FF)
#define MHL_CBUS_MSC_01_na_msc_cmd(data)                                             (0x000000FF&((data)<<0))
#define MHL_CBUS_MSC_01_na_msc_cmd_src(data)                                         ((0x000000FF&(data))>>0)
#define MHL_CBUS_MSC_01_get_na_msc_cmd(data)                                         ((0x000000FF&(data))>>0)


#define MHL_CBUS_MSC_02                                                              0x18062D88
#define MHL_CBUS_MSC_02_reg_addr                                                     "0xB8062D88"
#define MHL_CBUS_MSC_02_reg                                                          0xB8062D88
#define set_MHL_CBUS_MSC_02_reg(data)   (*((volatile unsigned int*) MHL_CBUS_MSC_02_reg)=data)
#define get_MHL_CBUS_MSC_02_reg   (*((volatile unsigned int*) MHL_CBUS_MSC_02_reg))
#define MHL_CBUS_MSC_02_inst_adr                                                     "0x0062"
#define MHL_CBUS_MSC_02_inst                                                         0x0062
#define MHL_CBUS_MSC_02_na_rx_len_shift                                              (16)
#define MHL_CBUS_MSC_02_na_rx_len_mask                                               (0x001F0000)
#define MHL_CBUS_MSC_02_na_rx_len(data)                                              (0x001F0000&((data)<<16))
#define MHL_CBUS_MSC_02_na_rx_len_src(data)                                          ((0x001F0000&(data))>>16)
#define MHL_CBUS_MSC_02_get_na_rx_len(data)                                          ((0x001F0000&(data))>>16)
#define MHL_CBUS_MSC_02_rx_fifo_full_shift                                           (9)
#define MHL_CBUS_MSC_02_rx_fifo_full_mask                                            (0x00000200)
#define MHL_CBUS_MSC_02_rx_fifo_full(data)                                           (0x00000200&((data)<<9))
#define MHL_CBUS_MSC_02_rx_fifo_full_src(data)                                       ((0x00000200&(data))>>9)
#define MHL_CBUS_MSC_02_get_rx_fifo_full(data)                                       ((0x00000200&(data))>>9)
#define MHL_CBUS_MSC_02_rx_fifo_empty_shift                                          (8)
#define MHL_CBUS_MSC_02_rx_fifo_empty_mask                                           (0x00000100)
#define MHL_CBUS_MSC_02_rx_fifo_empty(data)                                          (0x00000100&((data)<<8))
#define MHL_CBUS_MSC_02_rx_fifo_empty_src(data)                                      ((0x00000100&(data))>>8)
#define MHL_CBUS_MSC_02_get_rx_fifo_empty(data)                                      ((0x00000100&(data))>>8)
#define MHL_CBUS_MSC_02_na_msc_offset_shift                                          (0)
#define MHL_CBUS_MSC_02_na_msc_offset_mask                                           (0x000000FF)
#define MHL_CBUS_MSC_02_na_msc_offset(data)                                          (0x000000FF&((data)<<0))
#define MHL_CBUS_MSC_02_na_msc_offset_src(data)                                      ((0x000000FF&(data))>>0)
#define MHL_CBUS_MSC_02_get_na_msc_offset(data)                                      ((0x000000FF&(data))>>0)


#define MHL_CBUS_MSC_03                                                              0x18062D8C
#define MHL_CBUS_MSC_03_reg_addr                                                     "0xB8062D8C"
#define MHL_CBUS_MSC_03_reg                                                          0xB8062D8C
#define set_MHL_CBUS_MSC_03_reg(data)   (*((volatile unsigned int*) MHL_CBUS_MSC_03_reg)=data)
#define get_MHL_CBUS_MSC_03_reg   (*((volatile unsigned int*) MHL_CBUS_MSC_03_reg))
#define MHL_CBUS_MSC_03_inst_adr                                                     "0x0063"
#define MHL_CBUS_MSC_03_inst                                                         0x0063


#define MHL_CBUS_MSC_04                                                              0x18062D90
#define MHL_CBUS_MSC_04_reg_addr                                                     "0xB8062D90"
#define MHL_CBUS_MSC_04_reg                                                          0xB8062D90
#define set_MHL_CBUS_MSC_04_reg(data)   (*((volatile unsigned int*) MHL_CBUS_MSC_04_reg)=data)
#define get_MHL_CBUS_MSC_04_reg   (*((volatile unsigned int*) MHL_CBUS_MSC_04_reg))
#define MHL_CBUS_MSC_04_inst_adr                                                     "0x0064"
#define MHL_CBUS_MSC_04_inst                                                         0x0064
#define MHL_CBUS_MSC_04_rx_fifo_data_shift                                           (0)
#define MHL_CBUS_MSC_04_rx_fifo_data_mask                                            (0x000000FF)
#define MHL_CBUS_MSC_04_rx_fifo_data(data)                                           (0x000000FF&((data)<<0))
#define MHL_CBUS_MSC_04_rx_fifo_data_src(data)                                       ((0x000000FF&(data))>>0)
#define MHL_CBUS_MSC_04_get_rx_fifo_data(data)                                       ((0x000000FF&(data))>>0)


#define MHL_CBUS_MSC_05                                                              0x18062D94
#define MHL_CBUS_MSC_05_reg_addr                                                     "0xB8062D94"
#define MHL_CBUS_MSC_05_reg                                                          0xB8062D94
#define set_MHL_CBUS_MSC_05_reg(data)   (*((volatile unsigned int*) MHL_CBUS_MSC_05_reg)=data)
#define get_MHL_CBUS_MSC_05_reg   (*((volatile unsigned int*) MHL_CBUS_MSC_05_reg))
#define MHL_CBUS_MSC_05_inst_adr                                                     "0x0065"
#define MHL_CBUS_MSC_05_inst                                                         0x0065


#define MHL_CBUS_MSC_06                                                              0x18062D98
#define MHL_CBUS_MSC_06_reg_addr                                                     "0xB8062D98"
#define MHL_CBUS_MSC_06_reg                                                          0xB8062D98
#define set_MHL_CBUS_MSC_06_reg(data)   (*((volatile unsigned int*) MHL_CBUS_MSC_06_reg)=data)
#define get_MHL_CBUS_MSC_06_reg   (*((volatile unsigned int*) MHL_CBUS_MSC_06_reg))
#define MHL_CBUS_MSC_06_inst_adr                                                     "0x0066"
#define MHL_CBUS_MSC_06_inst                                                         0x0066
#define MHL_CBUS_MSC_06_irq_set_hpd_shift                                            (30)
#define MHL_CBUS_MSC_06_irq_set_hpd_mask                                             (0x40000000)
#define MHL_CBUS_MSC_06_irq_set_hpd(data)                                            (0x40000000&((data)<<30))
#define MHL_CBUS_MSC_06_irq_set_hpd_src(data)                                        ((0x40000000&(data))>>30)
#define MHL_CBUS_MSC_06_get_irq_set_hpd(data)                                        ((0x40000000&(data))>>30)
#define MHL_CBUS_MSC_06_irq_clr_hpd_shift                                            (29)
#define MHL_CBUS_MSC_06_irq_clr_hpd_mask                                             (0x20000000)
#define MHL_CBUS_MSC_06_irq_clr_hpd(data)                                            (0x20000000&((data)<<29))
#define MHL_CBUS_MSC_06_irq_clr_hpd_src(data)                                        ((0x20000000&(data))>>29)
#define MHL_CBUS_MSC_06_get_irq_clr_hpd(data)                                        ((0x20000000&(data))>>29)
#define MHL_CBUS_MSC_06_irq_ucp_shift                                                (28)
#define MHL_CBUS_MSC_06_irq_ucp_mask                                                 (0x10000000)
#define MHL_CBUS_MSC_06_irq_ucp(data)                                                (0x10000000&((data)<<28))
#define MHL_CBUS_MSC_06_irq_ucp_src(data)                                            ((0x10000000&(data))>>28)
#define MHL_CBUS_MSC_06_get_irq_ucp(data)                                            ((0x10000000&(data))>>28)
#define MHL_CBUS_MSC_06_irq_ucpk_shift                                               (27)
#define MHL_CBUS_MSC_06_irq_ucpk_mask                                                (0x08000000)
#define MHL_CBUS_MSC_06_irq_ucpk(data)                                               (0x08000000&((data)<<27))
#define MHL_CBUS_MSC_06_irq_ucpk_src(data)                                           ((0x08000000&(data))>>27)
#define MHL_CBUS_MSC_06_get_irq_ucpk(data)                                           ((0x08000000&(data))>>27)
#define MHL_CBUS_MSC_06_irq_ucpe_shift                                               (26)
#define MHL_CBUS_MSC_06_irq_ucpe_mask                                                (0x04000000)
#define MHL_CBUS_MSC_06_irq_ucpe(data)                                               (0x04000000&((data)<<26))
#define MHL_CBUS_MSC_06_irq_ucpe_src(data)                                           ((0x04000000&(data))>>26)
#define MHL_CBUS_MSC_06_get_irq_ucpe(data)                                           ((0x04000000&(data))>>26)
#define MHL_CBUS_MSC_06_irq_dcap_rdy_chg_shift                                       (25)
#define MHL_CBUS_MSC_06_irq_dcap_rdy_chg_mask                                        (0x02000000)
#define MHL_CBUS_MSC_06_irq_dcap_rdy_chg(data)                                       (0x02000000&((data)<<25))
#define MHL_CBUS_MSC_06_irq_dcap_rdy_chg_src(data)                                   ((0x02000000&(data))>>25)
#define MHL_CBUS_MSC_06_get_irq_dcap_rdy_chg(data)                                   ((0x02000000&(data))>>25)
#define MHL_CBUS_MSC_06_irq_path_en_chg_shift                                        (23)
#define MHL_CBUS_MSC_06_irq_path_en_chg_mask                                         (0x00800000)
#define MHL_CBUS_MSC_06_irq_path_en_chg(data)                                        (0x00800000&((data)<<23))
#define MHL_CBUS_MSC_06_irq_path_en_chg_src(data)                                    ((0x00800000&(data))>>23)
#define MHL_CBUS_MSC_06_get_irq_path_en_chg(data)                                    ((0x00800000&(data))>>23)
#define MHL_CBUS_MSC_06_irq_msge_shift                                               (21)
#define MHL_CBUS_MSC_06_irq_msge_mask                                                (0x00200000)
#define MHL_CBUS_MSC_06_irq_msge(data)                                               (0x00200000&((data)<<21))
#define MHL_CBUS_MSC_06_irq_msge_src(data)                                           ((0x00200000&(data))>>21)
#define MHL_CBUS_MSC_06_get_irq_msge(data)                                           ((0x00200000&(data))>>21)
#define MHL_CBUS_MSC_06_irq_rcp_shift                                                (20)
#define MHL_CBUS_MSC_06_irq_rcp_mask                                                 (0x00100000)
#define MHL_CBUS_MSC_06_irq_rcp(data)                                                (0x00100000&((data)<<20))
#define MHL_CBUS_MSC_06_irq_rcp_src(data)                                            ((0x00100000&(data))>>20)
#define MHL_CBUS_MSC_06_get_irq_rcp(data)                                            ((0x00100000&(data))>>20)
#define MHL_CBUS_MSC_06_irq_rcpk_shift                                               (19)
#define MHL_CBUS_MSC_06_irq_rcpk_mask                                                (0x00080000)
#define MHL_CBUS_MSC_06_irq_rcpk(data)                                               (0x00080000&((data)<<19))
#define MHL_CBUS_MSC_06_irq_rcpk_src(data)                                           ((0x00080000&(data))>>19)
#define MHL_CBUS_MSC_06_get_irq_rcpk(data)                                           ((0x00080000&(data))>>19)
#define MHL_CBUS_MSC_06_irq_rcpe_shift                                               (18)
#define MHL_CBUS_MSC_06_irq_rcpe_mask                                                (0x00040000)
#define MHL_CBUS_MSC_06_irq_rcpe(data)                                               (0x00040000&((data)<<18))
#define MHL_CBUS_MSC_06_irq_rcpe_src(data)                                           ((0x00040000&(data))>>18)
#define MHL_CBUS_MSC_06_get_irq_rcpe(data)                                           ((0x00040000&(data))>>18)
#define MHL_CBUS_MSC_06_irq_rap_shift                                                (17)
#define MHL_CBUS_MSC_06_irq_rap_mask                                                 (0x00020000)
#define MHL_CBUS_MSC_06_irq_rap(data)                                                (0x00020000&((data)<<17))
#define MHL_CBUS_MSC_06_irq_rap_src(data)                                            ((0x00020000&(data))>>17)
#define MHL_CBUS_MSC_06_get_irq_rap(data)                                            ((0x00020000&(data))>>17)
#define MHL_CBUS_MSC_06_irq_rapk_shift                                               (16)
#define MHL_CBUS_MSC_06_irq_rapk_mask                                                (0x00010000)
#define MHL_CBUS_MSC_06_irq_rapk(data)                                               (0x00010000&((data)<<16))
#define MHL_CBUS_MSC_06_irq_rapk_src(data)                                           ((0x00010000&(data))>>16)
#define MHL_CBUS_MSC_06_get_irq_rapk(data)                                           ((0x00010000&(data))>>16)
#define MHL_CBUS_MSC_06_irq_msg_sub_shift                                            (15)
#define MHL_CBUS_MSC_06_irq_msg_sub_mask                                             (0x00008000)
#define MHL_CBUS_MSC_06_irq_msg_sub(data)                                            (0x00008000&((data)<<15))
#define MHL_CBUS_MSC_06_irq_msg_sub_src(data)                                        ((0x00008000&(data))>>15)
#define MHL_CBUS_MSC_06_get_irq_msg_sub(data)                                        ((0x00008000&(data))>>15)
#define MHL_CBUS_MSC_06_irq_wr_stat_shift                                            (14)
#define MHL_CBUS_MSC_06_irq_wr_stat_mask                                             (0x00004000)
#define MHL_CBUS_MSC_06_irq_wr_stat(data)                                            (0x00004000&((data)<<14))
#define MHL_CBUS_MSC_06_irq_wr_stat_src(data)                                        ((0x00004000&(data))>>14)
#define MHL_CBUS_MSC_06_get_irq_wr_stat(data)                                        ((0x00004000&(data))>>14)
#define MHL_CBUS_MSC_06_irq_rd_devcap_shift                                          (13)
#define MHL_CBUS_MSC_06_irq_rd_devcap_mask                                           (0x00002000)
#define MHL_CBUS_MSC_06_irq_rd_devcap(data)                                          (0x00002000&((data)<<13))
#define MHL_CBUS_MSC_06_irq_rd_devcap_src(data)                                      ((0x00002000&(data))>>13)
#define MHL_CBUS_MSC_06_get_irq_rd_devcap(data)                                      ((0x00002000&(data))>>13)
#define MHL_CBUS_MSC_06_irq_get_stat_shift                                           (12)
#define MHL_CBUS_MSC_06_irq_get_stat_mask                                            (0x00001000)
#define MHL_CBUS_MSC_06_irq_get_stat(data)                                           (0x00001000&((data)<<12))
#define MHL_CBUS_MSC_06_irq_get_stat_src(data)                                       ((0x00001000&(data))>>12)
#define MHL_CBUS_MSC_06_get_irq_get_stat(data)                                       ((0x00001000&(data))>>12)
#define MHL_CBUS_MSC_06_irq_get_id_shift                                             (11)
#define MHL_CBUS_MSC_06_irq_get_id_mask                                              (0x00000800)
#define MHL_CBUS_MSC_06_irq_get_id(data)                                             (0x00000800&((data)<<11))
#define MHL_CBUS_MSC_06_irq_get_id_src(data)                                         ((0x00000800&(data))>>11)
#define MHL_CBUS_MSC_06_get_irq_get_id(data)                                         ((0x00000800&(data))>>11)
#define MHL_CBUS_MSC_06_irq_get_msg_shift                                            (10)
#define MHL_CBUS_MSC_06_irq_get_msg_mask                                             (0x00000400)
#define MHL_CBUS_MSC_06_irq_get_msg(data)                                            (0x00000400&((data)<<10))
#define MHL_CBUS_MSC_06_irq_get_msg_src(data)                                        ((0x00000400&(data))>>10)
#define MHL_CBUS_MSC_06_get_irq_get_msg(data)                                        ((0x00000400&(data))>>10)
#define MHL_CBUS_MSC_06_irq_sc1_err_shift                                            (9)
#define MHL_CBUS_MSC_06_irq_sc1_err_mask                                             (0x00000200)
#define MHL_CBUS_MSC_06_irq_sc1_err(data)                                            (0x00000200&((data)<<9))
#define MHL_CBUS_MSC_06_irq_sc1_err_src(data)                                        ((0x00000200&(data))>>9)
#define MHL_CBUS_MSC_06_get_irq_sc1_err(data)                                        ((0x00000200&(data))>>9)
#define MHL_CBUS_MSC_06_irq_ddc_err_shift                                            (8)
#define MHL_CBUS_MSC_06_irq_ddc_err_mask                                             (0x00000100)
#define MHL_CBUS_MSC_06_irq_ddc_err(data)                                            (0x00000100&((data)<<8))
#define MHL_CBUS_MSC_06_irq_ddc_err_src(data)                                        ((0x00000100&(data))>>8)
#define MHL_CBUS_MSC_06_get_irq_ddc_err(data)                                        ((0x00000100&(data))>>8)
#define MHL_CBUS_MSC_06_irq_msc_err_shift                                            (7)
#define MHL_CBUS_MSC_06_irq_msc_err_mask                                             (0x00000080)
#define MHL_CBUS_MSC_06_irq_msc_err(data)                                            (0x00000080&((data)<<7))
#define MHL_CBUS_MSC_06_irq_msc_err_src(data)                                        ((0x00000080&(data))>>7)
#define MHL_CBUS_MSC_06_get_irq_msc_err(data)                                        ((0x00000080&(data))>>7)
#define MHL_CBUS_MSC_06_irq_wr_burst_shift                                           (6)
#define MHL_CBUS_MSC_06_irq_wr_burst_mask                                            (0x00000040)
#define MHL_CBUS_MSC_06_irq_wr_burst(data)                                           (0x00000040&((data)<<6))
#define MHL_CBUS_MSC_06_irq_wr_burst_src(data)                                       ((0x00000040&(data))>>6)
#define MHL_CBUS_MSC_06_get_irq_wr_burst(data)                                       ((0x00000040&(data))>>6)
#define MHL_CBUS_MSC_06_irq_sc3_err_shift                                            (5)
#define MHL_CBUS_MSC_06_irq_sc3_err_mask                                             (0x00000020)
#define MHL_CBUS_MSC_06_irq_sc3_err(data)                                            (0x00000020&((data)<<5))
#define MHL_CBUS_MSC_06_irq_sc3_err_src(data)                                        ((0x00000020&(data))>>5)
#define MHL_CBUS_MSC_06_get_irq_sc3_err(data)                                        ((0x00000020&(data))>>5)
#define MHL_CBUS_MSC_06_irq_fwdef_cmd_shift                                          (4)
#define MHL_CBUS_MSC_06_irq_fwdef_cmd_mask                                           (0x00000010)
#define MHL_CBUS_MSC_06_irq_fwdef_cmd(data)                                          (0x00000010&((data)<<4))
#define MHL_CBUS_MSC_06_irq_fwdef_cmd_src(data)                                      ((0x00000010&(data))>>4)
#define MHL_CBUS_MSC_06_get_irq_fwdef_cmd(data)                                      ((0x00000010&(data))>>4)
#define MHL_CBUS_MSC_06_irq_allmsc_cmd_shift                                         (3)
#define MHL_CBUS_MSC_06_irq_allmsc_cmd_mask                                          (0x00000008)
#define MHL_CBUS_MSC_06_irq_allmsc_cmd(data)                                         (0x00000008&((data)<<3))
#define MHL_CBUS_MSC_06_irq_allmsc_cmd_src(data)                                     ((0x00000008&(data))>>3)
#define MHL_CBUS_MSC_06_get_irq_allmsc_cmd(data)                                     ((0x00000008&(data))>>3)
#define MHL_CBUS_MSC_06_irq_abort_res_shift                                          (2)
#define MHL_CBUS_MSC_06_irq_abort_res_mask                                           (0x00000004)
#define MHL_CBUS_MSC_06_irq_abort_res(data)                                          (0x00000004&((data)<<2))
#define MHL_CBUS_MSC_06_irq_abort_res_src(data)                                      ((0x00000004&(data))>>2)
#define MHL_CBUS_MSC_06_get_irq_abort_res(data)                                      ((0x00000004&(data))>>2)
#define MHL_CBUS_MSC_06_irq_abort_req_shift                                          (1)
#define MHL_CBUS_MSC_06_irq_abort_req_mask                                           (0x00000002)
#define MHL_CBUS_MSC_06_irq_abort_req(data)                                          (0x00000002&((data)<<1))
#define MHL_CBUS_MSC_06_irq_abort_req_src(data)                                      ((0x00000002&(data))>>1)
#define MHL_CBUS_MSC_06_get_irq_abort_req(data)                                      ((0x00000002&(data))>>1)
#define MHL_CBUS_MSC_06_irq_ddc_abort_shift                                          (0)
#define MHL_CBUS_MSC_06_irq_ddc_abort_mask                                           (0x00000001)
#define MHL_CBUS_MSC_06_irq_ddc_abort(data)                                          (0x00000001&((data)<<0))
#define MHL_CBUS_MSC_06_irq_ddc_abort_src(data)                                      ((0x00000001&(data))>>0)
#define MHL_CBUS_MSC_06_get_irq_ddc_abort(data)                                      ((0x00000001&(data))>>0)


#define MHL_CBUS_MSC_07                                                              0x18062D9C
#define MHL_CBUS_MSC_07_reg_addr                                                     "0xB8062D9C"
#define MHL_CBUS_MSC_07_reg                                                          0xB8062D9C
#define set_MHL_CBUS_MSC_07_reg(data)   (*((volatile unsigned int*) MHL_CBUS_MSC_07_reg)=data)
#define get_MHL_CBUS_MSC_07_reg   (*((volatile unsigned int*) MHL_CBUS_MSC_07_reg))
#define MHL_CBUS_MSC_07_inst_adr                                                     "0x0067"
#define MHL_CBUS_MSC_07_inst                                                         0x0067
#define MHL_CBUS_MSC_07_irq_en_set_hpd_shift                                         (30)
#define MHL_CBUS_MSC_07_irq_en_set_hpd_mask                                          (0x40000000)
#define MHL_CBUS_MSC_07_irq_en_set_hpd(data)                                         (0x40000000&((data)<<30))
#define MHL_CBUS_MSC_07_irq_en_set_hpd_src(data)                                     ((0x40000000&(data))>>30)
#define MHL_CBUS_MSC_07_get_irq_en_set_hpd(data)                                     ((0x40000000&(data))>>30)
#define MHL_CBUS_MSC_07_irq_en_clr_hpd_shift                                         (29)
#define MHL_CBUS_MSC_07_irq_en_clr_hpd_mask                                          (0x20000000)
#define MHL_CBUS_MSC_07_irq_en_clr_hpd(data)                                         (0x20000000&((data)<<29))
#define MHL_CBUS_MSC_07_irq_en_clr_hpd_src(data)                                     ((0x20000000&(data))>>29)
#define MHL_CBUS_MSC_07_get_irq_en_clr_hpd(data)                                     ((0x20000000&(data))>>29)
#define MHL_CBUS_MSC_07_irq_en_ucp_shift                                             (28)
#define MHL_CBUS_MSC_07_irq_en_ucp_mask                                              (0x10000000)
#define MHL_CBUS_MSC_07_irq_en_ucp(data)                                             (0x10000000&((data)<<28))
#define MHL_CBUS_MSC_07_irq_en_ucp_src(data)                                         ((0x10000000&(data))>>28)
#define MHL_CBUS_MSC_07_get_irq_en_ucp(data)                                         ((0x10000000&(data))>>28)
#define MHL_CBUS_MSC_07_irq_en_ucpk_shift                                            (27)
#define MHL_CBUS_MSC_07_irq_en_ucpk_mask                                             (0x08000000)
#define MHL_CBUS_MSC_07_irq_en_ucpk(data)                                            (0x08000000&((data)<<27))
#define MHL_CBUS_MSC_07_irq_en_ucpk_src(data)                                        ((0x08000000&(data))>>27)
#define MHL_CBUS_MSC_07_get_irq_en_ucpk(data)                                        ((0x08000000&(data))>>27)
#define MHL_CBUS_MSC_07_irq_en_ucpe_shift                                            (26)
#define MHL_CBUS_MSC_07_irq_en_ucpe_mask                                             (0x04000000)
#define MHL_CBUS_MSC_07_irq_en_ucpe(data)                                            (0x04000000&((data)<<26))
#define MHL_CBUS_MSC_07_irq_en_ucpe_src(data)                                        ((0x04000000&(data))>>26)
#define MHL_CBUS_MSC_07_get_irq_en_ucpe(data)                                        ((0x04000000&(data))>>26)
#define MHL_CBUS_MSC_07_irq_en_dcap_rdy_chg_shift                                    (25)
#define MHL_CBUS_MSC_07_irq_en_dcap_rdy_chg_mask                                     (0x02000000)
#define MHL_CBUS_MSC_07_irq_en_dcap_rdy_chg(data)                                    (0x02000000&((data)<<25))
#define MHL_CBUS_MSC_07_irq_en_dcap_rdy_chg_src(data)                                ((0x02000000&(data))>>25)
#define MHL_CBUS_MSC_07_get_irq_en_dcap_rdy_chg(data)                                ((0x02000000&(data))>>25)
#define MHL_CBUS_MSC_07_irq_en_path_en_chg_shift                                     (23)
#define MHL_CBUS_MSC_07_irq_en_path_en_chg_mask                                      (0x00800000)
#define MHL_CBUS_MSC_07_irq_en_path_en_chg(data)                                     (0x00800000&((data)<<23))
#define MHL_CBUS_MSC_07_irq_en_path_en_chg_src(data)                                 ((0x00800000&(data))>>23)
#define MHL_CBUS_MSC_07_get_irq_en_path_en_chg(data)                                 ((0x00800000&(data))>>23)
#define MHL_CBUS_MSC_07_irq_en_msge_shift                                            (21)
#define MHL_CBUS_MSC_07_irq_en_msge_mask                                             (0x00200000)
#define MHL_CBUS_MSC_07_irq_en_msge(data)                                            (0x00200000&((data)<<21))
#define MHL_CBUS_MSC_07_irq_en_msge_src(data)                                        ((0x00200000&(data))>>21)
#define MHL_CBUS_MSC_07_get_irq_en_msge(data)                                        ((0x00200000&(data))>>21)
#define MHL_CBUS_MSC_07_irq_en_rcp_shift                                             (20)
#define MHL_CBUS_MSC_07_irq_en_rcp_mask                                              (0x00100000)
#define MHL_CBUS_MSC_07_irq_en_rcp(data)                                             (0x00100000&((data)<<20))
#define MHL_CBUS_MSC_07_irq_en_rcp_src(data)                                         ((0x00100000&(data))>>20)
#define MHL_CBUS_MSC_07_get_irq_en_rcp(data)                                         ((0x00100000&(data))>>20)
#define MHL_CBUS_MSC_07_irq_en_rcpk_shift                                            (19)
#define MHL_CBUS_MSC_07_irq_en_rcpk_mask                                             (0x00080000)
#define MHL_CBUS_MSC_07_irq_en_rcpk(data)                                            (0x00080000&((data)<<19))
#define MHL_CBUS_MSC_07_irq_en_rcpk_src(data)                                        ((0x00080000&(data))>>19)
#define MHL_CBUS_MSC_07_get_irq_en_rcpk(data)                                        ((0x00080000&(data))>>19)
#define MHL_CBUS_MSC_07_irq_en_rcpe_shift                                            (18)
#define MHL_CBUS_MSC_07_irq_en_rcpe_mask                                             (0x00040000)
#define MHL_CBUS_MSC_07_irq_en_rcpe(data)                                            (0x00040000&((data)<<18))
#define MHL_CBUS_MSC_07_irq_en_rcpe_src(data)                                        ((0x00040000&(data))>>18)
#define MHL_CBUS_MSC_07_get_irq_en_rcpe(data)                                        ((0x00040000&(data))>>18)
#define MHL_CBUS_MSC_07_irq_en_rap_shift                                             (17)
#define MHL_CBUS_MSC_07_irq_en_rap_mask                                              (0x00020000)
#define MHL_CBUS_MSC_07_irq_en_rap(data)                                             (0x00020000&((data)<<17))
#define MHL_CBUS_MSC_07_irq_en_rap_src(data)                                         ((0x00020000&(data))>>17)
#define MHL_CBUS_MSC_07_get_irq_en_rap(data)                                         ((0x00020000&(data))>>17)
#define MHL_CBUS_MSC_07_irq_en_rapk_shift                                            (16)
#define MHL_CBUS_MSC_07_irq_en_rapk_mask                                             (0x00010000)
#define MHL_CBUS_MSC_07_irq_en_rapk(data)                                            (0x00010000&((data)<<16))
#define MHL_CBUS_MSC_07_irq_en_rapk_src(data)                                        ((0x00010000&(data))>>16)
#define MHL_CBUS_MSC_07_get_irq_en_rapk(data)                                        ((0x00010000&(data))>>16)
#define MHL_CBUS_MSC_07_irq_en_msg_sub_shift                                         (15)
#define MHL_CBUS_MSC_07_irq_en_msg_sub_mask                                          (0x00008000)
#define MHL_CBUS_MSC_07_irq_en_msg_sub(data)                                         (0x00008000&((data)<<15))
#define MHL_CBUS_MSC_07_irq_en_msg_sub_src(data)                                     ((0x00008000&(data))>>15)
#define MHL_CBUS_MSC_07_get_irq_en_msg_sub(data)                                     ((0x00008000&(data))>>15)
#define MHL_CBUS_MSC_07_irq_en_wr_stat_shift                                         (14)
#define MHL_CBUS_MSC_07_irq_en_wr_stat_mask                                          (0x00004000)
#define MHL_CBUS_MSC_07_irq_en_wr_stat(data)                                         (0x00004000&((data)<<14))
#define MHL_CBUS_MSC_07_irq_en_wr_stat_src(data)                                     ((0x00004000&(data))>>14)
#define MHL_CBUS_MSC_07_get_irq_en_wr_stat(data)                                     ((0x00004000&(data))>>14)
#define MHL_CBUS_MSC_07_irq_en_rd_devcap_shift                                       (13)
#define MHL_CBUS_MSC_07_irq_en_rd_devcap_mask                                        (0x00002000)
#define MHL_CBUS_MSC_07_irq_en_rd_devcap(data)                                       (0x00002000&((data)<<13))
#define MHL_CBUS_MSC_07_irq_en_rd_devcap_src(data)                                   ((0x00002000&(data))>>13)
#define MHL_CBUS_MSC_07_get_irq_en_rd_devcap(data)                                   ((0x00002000&(data))>>13)
#define MHL_CBUS_MSC_07_irq_en_get_stat_shift                                        (12)
#define MHL_CBUS_MSC_07_irq_en_get_stat_mask                                         (0x00001000)
#define MHL_CBUS_MSC_07_irq_en_get_stat(data)                                        (0x00001000&((data)<<12))
#define MHL_CBUS_MSC_07_irq_en_get_stat_src(data)                                    ((0x00001000&(data))>>12)
#define MHL_CBUS_MSC_07_get_irq_en_get_stat(data)                                    ((0x00001000&(data))>>12)
#define MHL_CBUS_MSC_07_irq_en_get_id_shift                                          (11)
#define MHL_CBUS_MSC_07_irq_en_get_id_mask                                           (0x00000800)
#define MHL_CBUS_MSC_07_irq_en_get_id(data)                                          (0x00000800&((data)<<11))
#define MHL_CBUS_MSC_07_irq_en_get_id_src(data)                                      ((0x00000800&(data))>>11)
#define MHL_CBUS_MSC_07_get_irq_en_get_id(data)                                      ((0x00000800&(data))>>11)
#define MHL_CBUS_MSC_07_irq_en_get_msg_shift                                         (10)
#define MHL_CBUS_MSC_07_irq_en_get_msg_mask                                          (0x00000400)
#define MHL_CBUS_MSC_07_irq_en_get_msg(data)                                         (0x00000400&((data)<<10))
#define MHL_CBUS_MSC_07_irq_en_get_msg_src(data)                                     ((0x00000400&(data))>>10)
#define MHL_CBUS_MSC_07_get_irq_en_get_msg(data)                                     ((0x00000400&(data))>>10)
#define MHL_CBUS_MSC_07_irq_en_sc1_err_shift                                         (9)
#define MHL_CBUS_MSC_07_irq_en_sc1_err_mask                                          (0x00000200)
#define MHL_CBUS_MSC_07_irq_en_sc1_err(data)                                         (0x00000200&((data)<<9))
#define MHL_CBUS_MSC_07_irq_en_sc1_err_src(data)                                     ((0x00000200&(data))>>9)
#define MHL_CBUS_MSC_07_get_irq_en_sc1_err(data)                                     ((0x00000200&(data))>>9)
#define MHL_CBUS_MSC_07_irq_en_ddc_err_shift                                         (8)
#define MHL_CBUS_MSC_07_irq_en_ddc_err_mask                                          (0x00000100)
#define MHL_CBUS_MSC_07_irq_en_ddc_err(data)                                         (0x00000100&((data)<<8))
#define MHL_CBUS_MSC_07_irq_en_ddc_err_src(data)                                     ((0x00000100&(data))>>8)
#define MHL_CBUS_MSC_07_get_irq_en_ddc_err(data)                                     ((0x00000100&(data))>>8)
#define MHL_CBUS_MSC_07_irq_en_msc_err_shift                                         (7)
#define MHL_CBUS_MSC_07_irq_en_msc_err_mask                                          (0x00000080)
#define MHL_CBUS_MSC_07_irq_en_msc_err(data)                                         (0x00000080&((data)<<7))
#define MHL_CBUS_MSC_07_irq_en_msc_err_src(data)                                     ((0x00000080&(data))>>7)
#define MHL_CBUS_MSC_07_get_irq_en_msc_err(data)                                     ((0x00000080&(data))>>7)
#define MHL_CBUS_MSC_07_irq_en_wr_burst_shift                                        (6)
#define MHL_CBUS_MSC_07_irq_en_wr_burst_mask                                         (0x00000040)
#define MHL_CBUS_MSC_07_irq_en_wr_burst(data)                                        (0x00000040&((data)<<6))
#define MHL_CBUS_MSC_07_irq_en_wr_burst_src(data)                                    ((0x00000040&(data))>>6)
#define MHL_CBUS_MSC_07_get_irq_en_wr_burst(data)                                    ((0x00000040&(data))>>6)
#define MHL_CBUS_MSC_07_irq_en_sc3_err_shift                                         (5)
#define MHL_CBUS_MSC_07_irq_en_sc3_err_mask                                          (0x00000020)
#define MHL_CBUS_MSC_07_irq_en_sc3_err(data)                                         (0x00000020&((data)<<5))
#define MHL_CBUS_MSC_07_irq_en_sc3_err_src(data)                                     ((0x00000020&(data))>>5)
#define MHL_CBUS_MSC_07_get_irq_en_sc3_err(data)                                     ((0x00000020&(data))>>5)
#define MHL_CBUS_MSC_07_irq_en_fwdef_cmd_shift                                       (4)
#define MHL_CBUS_MSC_07_irq_en_fwdef_cmd_mask                                        (0x00000010)
#define MHL_CBUS_MSC_07_irq_en_fwdef_cmd(data)                                       (0x00000010&((data)<<4))
#define MHL_CBUS_MSC_07_irq_en_fwdef_cmd_src(data)                                   ((0x00000010&(data))>>4)
#define MHL_CBUS_MSC_07_get_irq_en_fwdef_cmd(data)                                   ((0x00000010&(data))>>4)
#define MHL_CBUS_MSC_07_irq_en_allmsc_cmd_shift                                      (3)
#define MHL_CBUS_MSC_07_irq_en_allmsc_cmd_mask                                       (0x00000008)
#define MHL_CBUS_MSC_07_irq_en_allmsc_cmd(data)                                      (0x00000008&((data)<<3))
#define MHL_CBUS_MSC_07_irq_en_allmsc_cmd_src(data)                                  ((0x00000008&(data))>>3)
#define MHL_CBUS_MSC_07_get_irq_en_allmsc_cmd(data)                                  ((0x00000008&(data))>>3)
#define MHL_CBUS_MSC_07_irq_en_abort_res_shift                                       (2)
#define MHL_CBUS_MSC_07_irq_en_abort_res_mask                                        (0x00000004)
#define MHL_CBUS_MSC_07_irq_en_abort_res(data)                                       (0x00000004&((data)<<2))
#define MHL_CBUS_MSC_07_irq_en_abort_res_src(data)                                   ((0x00000004&(data))>>2)
#define MHL_CBUS_MSC_07_get_irq_en_abort_res(data)                                   ((0x00000004&(data))>>2)
#define MHL_CBUS_MSC_07_irq_en_abort_req_shift                                       (1)
#define MHL_CBUS_MSC_07_irq_en_abort_req_mask                                        (0x00000002)
#define MHL_CBUS_MSC_07_irq_en_abort_req(data)                                       (0x00000002&((data)<<1))
#define MHL_CBUS_MSC_07_irq_en_abort_req_src(data)                                   ((0x00000002&(data))>>1)
#define MHL_CBUS_MSC_07_get_irq_en_abort_req(data)                                   ((0x00000002&(data))>>1)
#define MHL_CBUS_MSC_07_irq_en_ddc_abort_shift                                       (0)
#define MHL_CBUS_MSC_07_irq_en_ddc_abort_mask                                        (0x00000001)
#define MHL_CBUS_MSC_07_irq_en_ddc_abort(data)                                       (0x00000001&((data)<<0))
#define MHL_CBUS_MSC_07_irq_en_ddc_abort_src(data)                                   ((0x00000001&(data))>>0)
#define MHL_CBUS_MSC_07_get_irq_en_ddc_abort(data)                                   ((0x00000001&(data))>>0)


#define MHL_CBUS_MSC_08                                                              0x18062DA0
#define MHL_CBUS_MSC_08_reg_addr                                                     "0xB8062DA0"
#define MHL_CBUS_MSC_08_reg                                                          0xB8062DA0
#define set_MHL_CBUS_MSC_08_reg(data)   (*((volatile unsigned int*) MHL_CBUS_MSC_08_reg)=data)
#define get_MHL_CBUS_MSC_08_reg   (*((volatile unsigned int*) MHL_CBUS_MSC_08_reg))
#define MHL_CBUS_MSC_08_inst_adr                                                     "0x0068"
#define MHL_CBUS_MSC_08_inst                                                         0x0068
#define MHL_CBUS_MSC_08_irq_rchg_bit7_shift                                          (31)
#define MHL_CBUS_MSC_08_irq_rchg_bit7_mask                                           (0x80000000)
#define MHL_CBUS_MSC_08_irq_rchg_bit7(data)                                          (0x80000000&((data)<<31))
#define MHL_CBUS_MSC_08_irq_rchg_bit7_src(data)                                      ((0x80000000&(data))>>31)
#define MHL_CBUS_MSC_08_get_irq_rchg_bit7(data)                                      ((0x80000000&(data))>>31)
#define MHL_CBUS_MSC_08_irq_rchg_bit6_shift                                          (30)
#define MHL_CBUS_MSC_08_irq_rchg_bit6_mask                                           (0x40000000)
#define MHL_CBUS_MSC_08_irq_rchg_bit6(data)                                          (0x40000000&((data)<<30))
#define MHL_CBUS_MSC_08_irq_rchg_bit6_src(data)                                      ((0x40000000&(data))>>30)
#define MHL_CBUS_MSC_08_get_irq_rchg_bit6(data)                                      ((0x40000000&(data))>>30)
#define MHL_CBUS_MSC_08_irq_rchg_bit5_shift                                          (29)
#define MHL_CBUS_MSC_08_irq_rchg_bit5_mask                                           (0x20000000)
#define MHL_CBUS_MSC_08_irq_rchg_bit5(data)                                          (0x20000000&((data)<<29))
#define MHL_CBUS_MSC_08_irq_rchg_bit5_src(data)                                      ((0x20000000&(data))>>29)
#define MHL_CBUS_MSC_08_get_irq_rchg_bit5(data)                                      ((0x20000000&(data))>>29)
#define MHL_CBUS_MSC_08_irq_3d_req_shift                                             (28)
#define MHL_CBUS_MSC_08_irq_3d_req_mask                                              (0x10000000)
#define MHL_CBUS_MSC_08_irq_3d_req(data)                                             (0x10000000&((data)<<28))
#define MHL_CBUS_MSC_08_irq_3d_req_src(data)                                         ((0x10000000&(data))>>28)
#define MHL_CBUS_MSC_08_get_irq_3d_req(data)                                         ((0x10000000&(data))>>28)
#define MHL_CBUS_MSC_08_irq_grt_wrt_shift                                            (27)
#define MHL_CBUS_MSC_08_irq_grt_wrt_mask                                             (0x08000000)
#define MHL_CBUS_MSC_08_irq_grt_wrt(data)                                            (0x08000000&((data)<<27))
#define MHL_CBUS_MSC_08_irq_grt_wrt_src(data)                                        ((0x08000000&(data))>>27)
#define MHL_CBUS_MSC_08_get_irq_grt_wrt(data)                                        ((0x08000000&(data))>>27)
#define MHL_CBUS_MSC_08_irq_req_wrt_shift                                            (26)
#define MHL_CBUS_MSC_08_irq_req_wrt_mask                                             (0x04000000)
#define MHL_CBUS_MSC_08_irq_req_wrt(data)                                            (0x04000000&((data)<<26))
#define MHL_CBUS_MSC_08_irq_req_wrt_src(data)                                        ((0x04000000&(data))>>26)
#define MHL_CBUS_MSC_08_get_irq_req_wrt(data)                                        ((0x04000000&(data))>>26)
#define MHL_CBUS_MSC_08_irq_dscr_chg_shift                                           (25)
#define MHL_CBUS_MSC_08_irq_dscr_chg_mask                                            (0x02000000)
#define MHL_CBUS_MSC_08_irq_dscr_chg(data)                                           (0x02000000&((data)<<25))
#define MHL_CBUS_MSC_08_irq_dscr_chg_src(data)                                       ((0x02000000&(data))>>25)
#define MHL_CBUS_MSC_08_get_irq_dscr_chg(data)                                       ((0x02000000&(data))>>25)
#define MHL_CBUS_MSC_08_irq_dcap_chg_shift                                           (24)
#define MHL_CBUS_MSC_08_irq_dcap_chg_mask                                            (0x01000000)
#define MHL_CBUS_MSC_08_irq_dcap_chg(data)                                           (0x01000000&((data)<<24))
#define MHL_CBUS_MSC_08_irq_dcap_chg_src(data)                                       ((0x01000000&(data))>>24)
#define MHL_CBUS_MSC_08_get_irq_dcap_chg(data)                                       ((0x01000000&(data))>>24)
#define MHL_CBUS_MSC_08_irq_dchg_bit7_shift                                          (23)
#define MHL_CBUS_MSC_08_irq_dchg_bit7_mask                                           (0x00800000)
#define MHL_CBUS_MSC_08_irq_dchg_bit7(data)                                          (0x00800000&((data)<<23))
#define MHL_CBUS_MSC_08_irq_dchg_bit7_src(data)                                      ((0x00800000&(data))>>23)
#define MHL_CBUS_MSC_08_get_irq_dchg_bit7(data)                                      ((0x00800000&(data))>>23)
#define MHL_CBUS_MSC_08_irq_dchg_bit6_shift                                          (22)
#define MHL_CBUS_MSC_08_irq_dchg_bit6_mask                                           (0x00400000)
#define MHL_CBUS_MSC_08_irq_dchg_bit6(data)                                          (0x00400000&((data)<<22))
#define MHL_CBUS_MSC_08_irq_dchg_bit6_src(data)                                      ((0x00400000&(data))>>22)
#define MHL_CBUS_MSC_08_get_irq_dchg_bit6(data)                                      ((0x00400000&(data))>>22)
#define MHL_CBUS_MSC_08_irq_dchg_bit5_shift                                          (21)
#define MHL_CBUS_MSC_08_irq_dchg_bit5_mask                                           (0x00200000)
#define MHL_CBUS_MSC_08_irq_dchg_bit5(data)                                          (0x00200000&((data)<<21))
#define MHL_CBUS_MSC_08_irq_dchg_bit5_src(data)                                      ((0x00200000&(data))>>21)
#define MHL_CBUS_MSC_08_get_irq_dchg_bit5(data)                                      ((0x00200000&(data))>>21)
#define MHL_CBUS_MSC_08_irq_dchg_bit4_shift                                          (20)
#define MHL_CBUS_MSC_08_irq_dchg_bit4_mask                                           (0x00100000)
#define MHL_CBUS_MSC_08_irq_dchg_bit4(data)                                          (0x00100000&((data)<<20))
#define MHL_CBUS_MSC_08_irq_dchg_bit4_src(data)                                      ((0x00100000&(data))>>20)
#define MHL_CBUS_MSC_08_get_irq_dchg_bit4(data)                                      ((0x00100000&(data))>>20)
#define MHL_CBUS_MSC_08_irq_dchg_bit3_shift                                          (19)
#define MHL_CBUS_MSC_08_irq_dchg_bit3_mask                                           (0x00080000)
#define MHL_CBUS_MSC_08_irq_dchg_bit3(data)                                          (0x00080000&((data)<<19))
#define MHL_CBUS_MSC_08_irq_dchg_bit3_src(data)                                      ((0x00080000&(data))>>19)
#define MHL_CBUS_MSC_08_get_irq_dchg_bit3(data)                                      ((0x00080000&(data))>>19)
#define MHL_CBUS_MSC_08_irq_dchg_bit2_shift                                          (18)
#define MHL_CBUS_MSC_08_irq_dchg_bit2_mask                                           (0x00040000)
#define MHL_CBUS_MSC_08_irq_dchg_bit2(data)                                          (0x00040000&((data)<<18))
#define MHL_CBUS_MSC_08_irq_dchg_bit2_src(data)                                      ((0x00040000&(data))>>18)
#define MHL_CBUS_MSC_08_get_irq_dchg_bit2(data)                                      ((0x00040000&(data))>>18)
#define MHL_CBUS_MSC_08_irq_edid_chg_shift                                           (17)
#define MHL_CBUS_MSC_08_irq_edid_chg_mask                                            (0x00020000)
#define MHL_CBUS_MSC_08_irq_edid_chg(data)                                           (0x00020000&((data)<<17))
#define MHL_CBUS_MSC_08_irq_edid_chg_src(data)                                       ((0x00020000&(data))>>17)
#define MHL_CBUS_MSC_08_get_irq_edid_chg(data)                                       ((0x00020000&(data))>>17)
#define MHL_CBUS_MSC_08_irq_dchg_bit0_shift                                          (16)
#define MHL_CBUS_MSC_08_irq_dchg_bit0_mask                                           (0x00010000)
#define MHL_CBUS_MSC_08_irq_dchg_bit0(data)                                          (0x00010000&((data)<<16))
#define MHL_CBUS_MSC_08_irq_dchg_bit0_src(data)                                      ((0x00010000&(data))>>16)
#define MHL_CBUS_MSC_08_get_irq_dchg_bit0(data)                                      ((0x00010000&(data))>>16)
#define MHL_CBUS_MSC_08_irq_chg22_bit7_shift                                         (15)
#define MHL_CBUS_MSC_08_irq_chg22_bit7_mask                                          (0x00008000)
#define MHL_CBUS_MSC_08_irq_chg22_bit7(data)                                         (0x00008000&((data)<<15))
#define MHL_CBUS_MSC_08_irq_chg22_bit7_src(data)                                     ((0x00008000&(data))>>15)
#define MHL_CBUS_MSC_08_get_irq_chg22_bit7(data)                                     ((0x00008000&(data))>>15)
#define MHL_CBUS_MSC_08_irq_chg22_bit6_shift                                         (14)
#define MHL_CBUS_MSC_08_irq_chg22_bit6_mask                                          (0x00004000)
#define MHL_CBUS_MSC_08_irq_chg22_bit6(data)                                         (0x00004000&((data)<<14))
#define MHL_CBUS_MSC_08_irq_chg22_bit6_src(data)                                     ((0x00004000&(data))>>14)
#define MHL_CBUS_MSC_08_get_irq_chg22_bit6(data)                                     ((0x00004000&(data))>>14)
#define MHL_CBUS_MSC_08_irq_chg22_bit5_shift                                         (13)
#define MHL_CBUS_MSC_08_irq_chg22_bit5_mask                                          (0x00002000)
#define MHL_CBUS_MSC_08_irq_chg22_bit5(data)                                         (0x00002000&((data)<<13))
#define MHL_CBUS_MSC_08_irq_chg22_bit5_src(data)                                     ((0x00002000&(data))>>13)
#define MHL_CBUS_MSC_08_get_irq_chg22_bit5(data)                                     ((0x00002000&(data))>>13)
#define MHL_CBUS_MSC_08_irq_chg22_bit4_shift                                         (12)
#define MHL_CBUS_MSC_08_irq_chg22_bit4_mask                                          (0x00001000)
#define MHL_CBUS_MSC_08_irq_chg22_bit4(data)                                         (0x00001000&((data)<<12))
#define MHL_CBUS_MSC_08_irq_chg22_bit4_src(data)                                     ((0x00001000&(data))>>12)
#define MHL_CBUS_MSC_08_get_irq_chg22_bit4(data)                                     ((0x00001000&(data))>>12)
#define MHL_CBUS_MSC_08_irq_chg22_bit3_shift                                         (11)
#define MHL_CBUS_MSC_08_irq_chg22_bit3_mask                                          (0x00000800)
#define MHL_CBUS_MSC_08_irq_chg22_bit3(data)                                         (0x00000800&((data)<<11))
#define MHL_CBUS_MSC_08_irq_chg22_bit3_src(data)                                     ((0x00000800&(data))>>11)
#define MHL_CBUS_MSC_08_get_irq_chg22_bit3(data)                                     ((0x00000800&(data))>>11)
#define MHL_CBUS_MSC_08_irq_chg22_bit2_shift                                         (10)
#define MHL_CBUS_MSC_08_irq_chg22_bit2_mask                                          (0x00000400)
#define MHL_CBUS_MSC_08_irq_chg22_bit2(data)                                         (0x00000400&((data)<<10))
#define MHL_CBUS_MSC_08_irq_chg22_bit2_src(data)                                     ((0x00000400&(data))>>10)
#define MHL_CBUS_MSC_08_get_irq_chg22_bit2(data)                                     ((0x00000400&(data))>>10)
#define MHL_CBUS_MSC_08_irq_chg22_bit1_shift                                         (9)
#define MHL_CBUS_MSC_08_irq_chg22_bit1_mask                                          (0x00000200)
#define MHL_CBUS_MSC_08_irq_chg22_bit1(data)                                         (0x00000200&((data)<<9))
#define MHL_CBUS_MSC_08_irq_chg22_bit1_src(data)                                     ((0x00000200&(data))>>9)
#define MHL_CBUS_MSC_08_get_irq_chg22_bit1(data)                                     ((0x00000200&(data))>>9)
#define MHL_CBUS_MSC_08_irq_chg22_bit0_shift                                         (8)
#define MHL_CBUS_MSC_08_irq_chg22_bit0_mask                                          (0x00000100)
#define MHL_CBUS_MSC_08_irq_chg22_bit0(data)                                         (0x00000100&((data)<<8))
#define MHL_CBUS_MSC_08_irq_chg22_bit0_src(data)                                     ((0x00000100&(data))>>8)
#define MHL_CBUS_MSC_08_get_irq_chg22_bit0(data)                                     ((0x00000100&(data))>>8)
#define MHL_CBUS_MSC_08_irq_chg23_bit7_shift                                         (7)
#define MHL_CBUS_MSC_08_irq_chg23_bit7_mask                                          (0x00000080)
#define MHL_CBUS_MSC_08_irq_chg23_bit7(data)                                         (0x00000080&((data)<<7))
#define MHL_CBUS_MSC_08_irq_chg23_bit7_src(data)                                     ((0x00000080&(data))>>7)
#define MHL_CBUS_MSC_08_get_irq_chg23_bit7(data)                                     ((0x00000080&(data))>>7)
#define MHL_CBUS_MSC_08_irq_chg23_bit6_shift                                         (6)
#define MHL_CBUS_MSC_08_irq_chg23_bit6_mask                                          (0x00000040)
#define MHL_CBUS_MSC_08_irq_chg23_bit6(data)                                         (0x00000040&((data)<<6))
#define MHL_CBUS_MSC_08_irq_chg23_bit6_src(data)                                     ((0x00000040&(data))>>6)
#define MHL_CBUS_MSC_08_get_irq_chg23_bit6(data)                                     ((0x00000040&(data))>>6)
#define MHL_CBUS_MSC_08_irq_chg23_bit5_shift                                         (5)
#define MHL_CBUS_MSC_08_irq_chg23_bit5_mask                                          (0x00000020)
#define MHL_CBUS_MSC_08_irq_chg23_bit5(data)                                         (0x00000020&((data)<<5))
#define MHL_CBUS_MSC_08_irq_chg23_bit5_src(data)                                     ((0x00000020&(data))>>5)
#define MHL_CBUS_MSC_08_get_irq_chg23_bit5(data)                                     ((0x00000020&(data))>>5)
#define MHL_CBUS_MSC_08_irq_chg23_bit4_shift                                         (4)
#define MHL_CBUS_MSC_08_irq_chg23_bit4_mask                                          (0x00000010)
#define MHL_CBUS_MSC_08_irq_chg23_bit4(data)                                         (0x00000010&((data)<<4))
#define MHL_CBUS_MSC_08_irq_chg23_bit4_src(data)                                     ((0x00000010&(data))>>4)
#define MHL_CBUS_MSC_08_get_irq_chg23_bit4(data)                                     ((0x00000010&(data))>>4)
#define MHL_CBUS_MSC_08_irq_chg23_bit3_shift                                         (3)
#define MHL_CBUS_MSC_08_irq_chg23_bit3_mask                                          (0x00000008)
#define MHL_CBUS_MSC_08_irq_chg23_bit3(data)                                         (0x00000008&((data)<<3))
#define MHL_CBUS_MSC_08_irq_chg23_bit3_src(data)                                     ((0x00000008&(data))>>3)
#define MHL_CBUS_MSC_08_get_irq_chg23_bit3(data)                                     ((0x00000008&(data))>>3)
#define MHL_CBUS_MSC_08_irq_chg23_bit2_shift                                         (2)
#define MHL_CBUS_MSC_08_irq_chg23_bit2_mask                                          (0x00000004)
#define MHL_CBUS_MSC_08_irq_chg23_bit2(data)                                         (0x00000004&((data)<<2))
#define MHL_CBUS_MSC_08_irq_chg23_bit2_src(data)                                     ((0x00000004&(data))>>2)
#define MHL_CBUS_MSC_08_get_irq_chg23_bit2(data)                                     ((0x00000004&(data))>>2)
#define MHL_CBUS_MSC_08_irq_chg23_bit1_shift                                         (1)
#define MHL_CBUS_MSC_08_irq_chg23_bit1_mask                                          (0x00000002)
#define MHL_CBUS_MSC_08_irq_chg23_bit1(data)                                         (0x00000002&((data)<<1))
#define MHL_CBUS_MSC_08_irq_chg23_bit1_src(data)                                     ((0x00000002&(data))>>1)
#define MHL_CBUS_MSC_08_get_irq_chg23_bit1(data)                                     ((0x00000002&(data))>>1)
#define MHL_CBUS_MSC_08_irq_chg23_bit0_shift                                         (0)
#define MHL_CBUS_MSC_08_irq_chg23_bit0_mask                                          (0x00000001)
#define MHL_CBUS_MSC_08_irq_chg23_bit0(data)                                         (0x00000001&((data)<<0))
#define MHL_CBUS_MSC_08_irq_chg23_bit0_src(data)                                     ((0x00000001&(data))>>0)
#define MHL_CBUS_MSC_08_get_irq_chg23_bit0(data)                                     ((0x00000001&(data))>>0)


#define MHL_CBUS_MSC_09                                                              0x18062DA4
#define MHL_CBUS_MSC_09_reg_addr                                                     "0xB8062DA4"
#define MHL_CBUS_MSC_09_reg                                                          0xB8062DA4
#define set_MHL_CBUS_MSC_09_reg(data)   (*((volatile unsigned int*) MHL_CBUS_MSC_09_reg)=data)
#define get_MHL_CBUS_MSC_09_reg   (*((volatile unsigned int*) MHL_CBUS_MSC_09_reg))
#define MHL_CBUS_MSC_09_inst_adr                                                     "0x0069"
#define MHL_CBUS_MSC_09_inst                                                         0x0069
#define MHL_CBUS_MSC_09_irq_en_rchg_bit7_shift                                       (31)
#define MHL_CBUS_MSC_09_irq_en_rchg_bit7_mask                                        (0x80000000)
#define MHL_CBUS_MSC_09_irq_en_rchg_bit7(data)                                       (0x80000000&((data)<<31))
#define MHL_CBUS_MSC_09_irq_en_rchg_bit7_src(data)                                   ((0x80000000&(data))>>31)
#define MHL_CBUS_MSC_09_get_irq_en_rchg_bit7(data)                                   ((0x80000000&(data))>>31)
#define MHL_CBUS_MSC_09_irq_en_rchg_bit6_shift                                       (30)
#define MHL_CBUS_MSC_09_irq_en_rchg_bit6_mask                                        (0x40000000)
#define MHL_CBUS_MSC_09_irq_en_rchg_bit6(data)                                       (0x40000000&((data)<<30))
#define MHL_CBUS_MSC_09_irq_en_rchg_bit6_src(data)                                   ((0x40000000&(data))>>30)
#define MHL_CBUS_MSC_09_get_irq_en_rchg_bit6(data)                                   ((0x40000000&(data))>>30)
#define MHL_CBUS_MSC_09_irq_en_rchg_bit5_shift                                       (29)
#define MHL_CBUS_MSC_09_irq_en_rchg_bit5_mask                                        (0x20000000)
#define MHL_CBUS_MSC_09_irq_en_rchg_bit5(data)                                       (0x20000000&((data)<<29))
#define MHL_CBUS_MSC_09_irq_en_rchg_bit5_src(data)                                   ((0x20000000&(data))>>29)
#define MHL_CBUS_MSC_09_get_irq_en_rchg_bit5(data)                                   ((0x20000000&(data))>>29)
#define MHL_CBUS_MSC_09_irq_en_3d_req_shift                                          (28)
#define MHL_CBUS_MSC_09_irq_en_3d_req_mask                                           (0x10000000)
#define MHL_CBUS_MSC_09_irq_en_3d_req(data)                                          (0x10000000&((data)<<28))
#define MHL_CBUS_MSC_09_irq_en_3d_req_src(data)                                      ((0x10000000&(data))>>28)
#define MHL_CBUS_MSC_09_get_irq_en_3d_req(data)                                      ((0x10000000&(data))>>28)
#define MHL_CBUS_MSC_09_irq_en_grt_wrt_shift                                         (27)
#define MHL_CBUS_MSC_09_irq_en_grt_wrt_mask                                          (0x08000000)
#define MHL_CBUS_MSC_09_irq_en_grt_wrt(data)                                         (0x08000000&((data)<<27))
#define MHL_CBUS_MSC_09_irq_en_grt_wrt_src(data)                                     ((0x08000000&(data))>>27)
#define MHL_CBUS_MSC_09_get_irq_en_grt_wrt(data)                                     ((0x08000000&(data))>>27)
#define MHL_CBUS_MSC_09_irq_en_req_wrt_shift                                         (26)
#define MHL_CBUS_MSC_09_irq_en_req_wrt_mask                                          (0x04000000)
#define MHL_CBUS_MSC_09_irq_en_req_wrt(data)                                         (0x04000000&((data)<<26))
#define MHL_CBUS_MSC_09_irq_en_req_wrt_src(data)                                     ((0x04000000&(data))>>26)
#define MHL_CBUS_MSC_09_get_irq_en_req_wrt(data)                                     ((0x04000000&(data))>>26)
#define MHL_CBUS_MSC_09_irq_en_dscr_chg_shift                                        (25)
#define MHL_CBUS_MSC_09_irq_en_dscr_chg_mask                                         (0x02000000)
#define MHL_CBUS_MSC_09_irq_en_dscr_chg(data)                                        (0x02000000&((data)<<25))
#define MHL_CBUS_MSC_09_irq_en_dscr_chg_src(data)                                    ((0x02000000&(data))>>25)
#define MHL_CBUS_MSC_09_get_irq_en_dscr_chg(data)                                    ((0x02000000&(data))>>25)
#define MHL_CBUS_MSC_09_irq_en_dcap_chg_shift                                        (24)
#define MHL_CBUS_MSC_09_irq_en_dcap_chg_mask                                         (0x01000000)
#define MHL_CBUS_MSC_09_irq_en_dcap_chg(data)                                        (0x01000000&((data)<<24))
#define MHL_CBUS_MSC_09_irq_en_dcap_chg_src(data)                                    ((0x01000000&(data))>>24)
#define MHL_CBUS_MSC_09_get_irq_en_dcap_chg(data)                                    ((0x01000000&(data))>>24)
#define MHL_CBUS_MSC_09_irq_en_dchg_bit7_shift                                       (23)
#define MHL_CBUS_MSC_09_irq_en_dchg_bit7_mask                                        (0x00800000)
#define MHL_CBUS_MSC_09_irq_en_dchg_bit7(data)                                       (0x00800000&((data)<<23))
#define MHL_CBUS_MSC_09_irq_en_dchg_bit7_src(data)                                   ((0x00800000&(data))>>23)
#define MHL_CBUS_MSC_09_get_irq_en_dchg_bit7(data)                                   ((0x00800000&(data))>>23)
#define MHL_CBUS_MSC_09_irq_en_dchg_bit6_shift                                       (22)
#define MHL_CBUS_MSC_09_irq_en_dchg_bit6_mask                                        (0x00400000)
#define MHL_CBUS_MSC_09_irq_en_dchg_bit6(data)                                       (0x00400000&((data)<<22))
#define MHL_CBUS_MSC_09_irq_en_dchg_bit6_src(data)                                   ((0x00400000&(data))>>22)
#define MHL_CBUS_MSC_09_get_irq_en_dchg_bit6(data)                                   ((0x00400000&(data))>>22)
#define MHL_CBUS_MSC_09_irq_en_dchg_bit5_shift                                       (21)
#define MHL_CBUS_MSC_09_irq_en_dchg_bit5_mask                                        (0x00200000)
#define MHL_CBUS_MSC_09_irq_en_dchg_bit5(data)                                       (0x00200000&((data)<<21))
#define MHL_CBUS_MSC_09_irq_en_dchg_bit5_src(data)                                   ((0x00200000&(data))>>21)
#define MHL_CBUS_MSC_09_get_irq_en_dchg_bit5(data)                                   ((0x00200000&(data))>>21)
#define MHL_CBUS_MSC_09_irq_en_dchg_bit4_shift                                       (20)
#define MHL_CBUS_MSC_09_irq_en_dchg_bit4_mask                                        (0x00100000)
#define MHL_CBUS_MSC_09_irq_en_dchg_bit4(data)                                       (0x00100000&((data)<<20))
#define MHL_CBUS_MSC_09_irq_en_dchg_bit4_src(data)                                   ((0x00100000&(data))>>20)
#define MHL_CBUS_MSC_09_get_irq_en_dchg_bit4(data)                                   ((0x00100000&(data))>>20)
#define MHL_CBUS_MSC_09_irq_en_dchg_bit3_shift                                       (19)
#define MHL_CBUS_MSC_09_irq_en_dchg_bit3_mask                                        (0x00080000)
#define MHL_CBUS_MSC_09_irq_en_dchg_bit3(data)                                       (0x00080000&((data)<<19))
#define MHL_CBUS_MSC_09_irq_en_dchg_bit3_src(data)                                   ((0x00080000&(data))>>19)
#define MHL_CBUS_MSC_09_get_irq_en_dchg_bit3(data)                                   ((0x00080000&(data))>>19)
#define MHL_CBUS_MSC_09_irq_en_dchg_bit2_shift                                       (18)
#define MHL_CBUS_MSC_09_irq_en_dchg_bit2_mask                                        (0x00040000)
#define MHL_CBUS_MSC_09_irq_en_dchg_bit2(data)                                       (0x00040000&((data)<<18))
#define MHL_CBUS_MSC_09_irq_en_dchg_bit2_src(data)                                   ((0x00040000&(data))>>18)
#define MHL_CBUS_MSC_09_get_irq_en_dchg_bit2(data)                                   ((0x00040000&(data))>>18)
#define MHL_CBUS_MSC_09_irq_en_edid_chg_shift                                        (17)
#define MHL_CBUS_MSC_09_irq_en_edid_chg_mask                                         (0x00020000)
#define MHL_CBUS_MSC_09_irq_en_edid_chg(data)                                        (0x00020000&((data)<<17))
#define MHL_CBUS_MSC_09_irq_en_edid_chg_src(data)                                    ((0x00020000&(data))>>17)
#define MHL_CBUS_MSC_09_get_irq_en_edid_chg(data)                                    ((0x00020000&(data))>>17)
#define MHL_CBUS_MSC_09_irq_en_dchg_bit0_shift                                       (16)
#define MHL_CBUS_MSC_09_irq_en_dchg_bit0_mask                                        (0x00010000)
#define MHL_CBUS_MSC_09_irq_en_dchg_bit0(data)                                       (0x00010000&((data)<<16))
#define MHL_CBUS_MSC_09_irq_en_dchg_bit0_src(data)                                   ((0x00010000&(data))>>16)
#define MHL_CBUS_MSC_09_get_irq_en_dchg_bit0(data)                                   ((0x00010000&(data))>>16)
#define MHL_CBUS_MSC_09_irq_en_chg22_bit7_shift                                      (15)
#define MHL_CBUS_MSC_09_irq_en_chg22_bit7_mask                                       (0x00008000)
#define MHL_CBUS_MSC_09_irq_en_chg22_bit7(data)                                      (0x00008000&((data)<<15))
#define MHL_CBUS_MSC_09_irq_en_chg22_bit7_src(data)                                  ((0x00008000&(data))>>15)
#define MHL_CBUS_MSC_09_get_irq_en_chg22_bit7(data)                                  ((0x00008000&(data))>>15)
#define MHL_CBUS_MSC_09_irq_en_chg22_bit6_shift                                      (14)
#define MHL_CBUS_MSC_09_irq_en_chg22_bit6_mask                                       (0x00004000)
#define MHL_CBUS_MSC_09_irq_en_chg22_bit6(data)                                      (0x00004000&((data)<<14))
#define MHL_CBUS_MSC_09_irq_en_chg22_bit6_src(data)                                  ((0x00004000&(data))>>14)
#define MHL_CBUS_MSC_09_get_irq_en_chg22_bit6(data)                                  ((0x00004000&(data))>>14)
#define MHL_CBUS_MSC_09_irq_en_chg22_bit5_shift                                      (13)
#define MHL_CBUS_MSC_09_irq_en_chg22_bit5_mask                                       (0x00002000)
#define MHL_CBUS_MSC_09_irq_en_chg22_bit5(data)                                      (0x00002000&((data)<<13))
#define MHL_CBUS_MSC_09_irq_en_chg22_bit5_src(data)                                  ((0x00002000&(data))>>13)
#define MHL_CBUS_MSC_09_get_irq_en_chg22_bit5(data)                                  ((0x00002000&(data))>>13)
#define MHL_CBUS_MSC_09_irq_en_chg22_bit4_shift                                      (12)
#define MHL_CBUS_MSC_09_irq_en_chg22_bit4_mask                                       (0x00001000)
#define MHL_CBUS_MSC_09_irq_en_chg22_bit4(data)                                      (0x00001000&((data)<<12))
#define MHL_CBUS_MSC_09_irq_en_chg22_bit4_src(data)                                  ((0x00001000&(data))>>12)
#define MHL_CBUS_MSC_09_get_irq_en_chg22_bit4(data)                                  ((0x00001000&(data))>>12)
#define MHL_CBUS_MSC_09_irq_en_chg22_bit3_shift                                      (11)
#define MHL_CBUS_MSC_09_irq_en_chg22_bit3_mask                                       (0x00000800)
#define MHL_CBUS_MSC_09_irq_en_chg22_bit3(data)                                      (0x00000800&((data)<<11))
#define MHL_CBUS_MSC_09_irq_en_chg22_bit3_src(data)                                  ((0x00000800&(data))>>11)
#define MHL_CBUS_MSC_09_get_irq_en_chg22_bit3(data)                                  ((0x00000800&(data))>>11)
#define MHL_CBUS_MSC_09_irq_en_chg22_bit2_shift                                      (10)
#define MHL_CBUS_MSC_09_irq_en_chg22_bit2_mask                                       (0x00000400)
#define MHL_CBUS_MSC_09_irq_en_chg22_bit2(data)                                      (0x00000400&((data)<<10))
#define MHL_CBUS_MSC_09_irq_en_chg22_bit2_src(data)                                  ((0x00000400&(data))>>10)
#define MHL_CBUS_MSC_09_get_irq_en_chg22_bit2(data)                                  ((0x00000400&(data))>>10)
#define MHL_CBUS_MSC_09_irq_en_chg22_bit1_shift                                      (9)
#define MHL_CBUS_MSC_09_irq_en_chg22_bit1_mask                                       (0x00000200)
#define MHL_CBUS_MSC_09_irq_en_chg22_bit1(data)                                      (0x00000200&((data)<<9))
#define MHL_CBUS_MSC_09_irq_en_chg22_bit1_src(data)                                  ((0x00000200&(data))>>9)
#define MHL_CBUS_MSC_09_get_irq_en_chg22_bit1(data)                                  ((0x00000200&(data))>>9)
#define MHL_CBUS_MSC_09_irq_en_chg22_bit0_shift                                      (8)
#define MHL_CBUS_MSC_09_irq_en_chg22_bit0_mask                                       (0x00000100)
#define MHL_CBUS_MSC_09_irq_en_chg22_bit0(data)                                      (0x00000100&((data)<<8))
#define MHL_CBUS_MSC_09_irq_en_chg22_bit0_src(data)                                  ((0x00000100&(data))>>8)
#define MHL_CBUS_MSC_09_get_irq_en_chg22_bit0(data)                                  ((0x00000100&(data))>>8)
#define MHL_CBUS_MSC_09_irq_en_chg23_bit7_shift                                      (7)
#define MHL_CBUS_MSC_09_irq_en_chg23_bit7_mask                                       (0x00000080)
#define MHL_CBUS_MSC_09_irq_en_chg23_bit7(data)                                      (0x00000080&((data)<<7))
#define MHL_CBUS_MSC_09_irq_en_chg23_bit7_src(data)                                  ((0x00000080&(data))>>7)
#define MHL_CBUS_MSC_09_get_irq_en_chg23_bit7(data)                                  ((0x00000080&(data))>>7)
#define MHL_CBUS_MSC_09_irq_en_chg23_bit6_shift                                      (6)
#define MHL_CBUS_MSC_09_irq_en_chg23_bit6_mask                                       (0x00000040)
#define MHL_CBUS_MSC_09_irq_en_chg23_bit6(data)                                      (0x00000040&((data)<<6))
#define MHL_CBUS_MSC_09_irq_en_chg23_bit6_src(data)                                  ((0x00000040&(data))>>6)
#define MHL_CBUS_MSC_09_get_irq_en_chg23_bit6(data)                                  ((0x00000040&(data))>>6)
#define MHL_CBUS_MSC_09_irq_en_chg23_bit5_shift                                      (5)
#define MHL_CBUS_MSC_09_irq_en_chg23_bit5_mask                                       (0x00000020)
#define MHL_CBUS_MSC_09_irq_en_chg23_bit5(data)                                      (0x00000020&((data)<<5))
#define MHL_CBUS_MSC_09_irq_en_chg23_bit5_src(data)                                  ((0x00000020&(data))>>5)
#define MHL_CBUS_MSC_09_get_irq_en_chg23_bit5(data)                                  ((0x00000020&(data))>>5)
#define MHL_CBUS_MSC_09_irq_en_chg23_bit4_shift                                      (4)
#define MHL_CBUS_MSC_09_irq_en_chg23_bit4_mask                                       (0x00000010)
#define MHL_CBUS_MSC_09_irq_en_chg23_bit4(data)                                      (0x00000010&((data)<<4))
#define MHL_CBUS_MSC_09_irq_en_chg23_bit4_src(data)                                  ((0x00000010&(data))>>4)
#define MHL_CBUS_MSC_09_get_irq_en_chg23_bit4(data)                                  ((0x00000010&(data))>>4)
#define MHL_CBUS_MSC_09_irq_en_chg23_bit3_shift                                      (3)
#define MHL_CBUS_MSC_09_irq_en_chg23_bit3_mask                                       (0x00000008)
#define MHL_CBUS_MSC_09_irq_en_chg23_bit3(data)                                      (0x00000008&((data)<<3))
#define MHL_CBUS_MSC_09_irq_en_chg23_bit3_src(data)                                  ((0x00000008&(data))>>3)
#define MHL_CBUS_MSC_09_get_irq_en_chg23_bit3(data)                                  ((0x00000008&(data))>>3)
#define MHL_CBUS_MSC_09_irq_en_chg23_bit2_shift                                      (2)
#define MHL_CBUS_MSC_09_irq_en_chg23_bit2_mask                                       (0x00000004)
#define MHL_CBUS_MSC_09_irq_en_chg23_bit2(data)                                      (0x00000004&((data)<<2))
#define MHL_CBUS_MSC_09_irq_en_chg23_bit2_src(data)                                  ((0x00000004&(data))>>2)
#define MHL_CBUS_MSC_09_get_irq_en_chg23_bit2(data)                                  ((0x00000004&(data))>>2)
#define MHL_CBUS_MSC_09_irq_en_chg23_bit1_shift                                      (1)
#define MHL_CBUS_MSC_09_irq_en_chg23_bit1_mask                                       (0x00000002)
#define MHL_CBUS_MSC_09_irq_en_chg23_bit1(data)                                      (0x00000002&((data)<<1))
#define MHL_CBUS_MSC_09_irq_en_chg23_bit1_src(data)                                  ((0x00000002&(data))>>1)
#define MHL_CBUS_MSC_09_get_irq_en_chg23_bit1(data)                                  ((0x00000002&(data))>>1)
#define MHL_CBUS_MSC_09_irq_en_chg23_bit0_shift                                      (0)
#define MHL_CBUS_MSC_09_irq_en_chg23_bit0_mask                                       (0x00000001)
#define MHL_CBUS_MSC_09_irq_en_chg23_bit0(data)                                      (0x00000001&((data)<<0))
#define MHL_CBUS_MSC_09_irq_en_chg23_bit0_src(data)                                  ((0x00000001&(data))>>0)
#define MHL_CBUS_MSC_09_get_irq_en_chg23_bit0(data)                                  ((0x00000001&(data))>>0)


#define MHL_CBUS_MSC_0A                                                              0x18062DA8
#define MHL_CBUS_MSC_0A_reg_addr                                                     "0xB8062DA8"
#define MHL_CBUS_MSC_0A_reg                                                          0xB8062DA8
#define set_MHL_CBUS_MSC_0A_reg(data)   (*((volatile unsigned int*) MHL_CBUS_MSC_0A_reg)=data)
#define get_MHL_CBUS_MSC_0A_reg   (*((volatile unsigned int*) MHL_CBUS_MSC_0A_reg))
#define MHL_CBUS_MSC_0A_inst_adr                                                     "0x006A"
#define MHL_CBUS_MSC_0A_inst                                                         0x006A
#define MHL_CBUS_MSC_0A_irq_chg24_bit7_shift                                         (31)
#define MHL_CBUS_MSC_0A_irq_chg24_bit7_mask                                          (0x80000000)
#define MHL_CBUS_MSC_0A_irq_chg24_bit7(data)                                         (0x80000000&((data)<<31))
#define MHL_CBUS_MSC_0A_irq_chg24_bit7_src(data)                                     ((0x80000000&(data))>>31)
#define MHL_CBUS_MSC_0A_get_irq_chg24_bit7(data)                                     ((0x80000000&(data))>>31)
#define MHL_CBUS_MSC_0A_irq_chg24_bit6_shift                                         (30)
#define MHL_CBUS_MSC_0A_irq_chg24_bit6_mask                                          (0x40000000)
#define MHL_CBUS_MSC_0A_irq_chg24_bit6(data)                                         (0x40000000&((data)<<30))
#define MHL_CBUS_MSC_0A_irq_chg24_bit6_src(data)                                     ((0x40000000&(data))>>30)
#define MHL_CBUS_MSC_0A_get_irq_chg24_bit6(data)                                     ((0x40000000&(data))>>30)
#define MHL_CBUS_MSC_0A_irq_chg24_bit5_shift                                         (29)
#define MHL_CBUS_MSC_0A_irq_chg24_bit5_mask                                          (0x20000000)
#define MHL_CBUS_MSC_0A_irq_chg24_bit5(data)                                         (0x20000000&((data)<<29))
#define MHL_CBUS_MSC_0A_irq_chg24_bit5_src(data)                                     ((0x20000000&(data))>>29)
#define MHL_CBUS_MSC_0A_get_irq_chg24_bit5(data)                                     ((0x20000000&(data))>>29)
#define MHL_CBUS_MSC_0A_irq_chg24_bit4_shift                                         (28)
#define MHL_CBUS_MSC_0A_irq_chg24_bit4_mask                                          (0x10000000)
#define MHL_CBUS_MSC_0A_irq_chg24_bit4(data)                                         (0x10000000&((data)<<28))
#define MHL_CBUS_MSC_0A_irq_chg24_bit4_src(data)                                     ((0x10000000&(data))>>28)
#define MHL_CBUS_MSC_0A_get_irq_chg24_bit4(data)                                     ((0x10000000&(data))>>28)
#define MHL_CBUS_MSC_0A_irq_chg24_bit3_shift                                         (27)
#define MHL_CBUS_MSC_0A_irq_chg24_bit3_mask                                          (0x08000000)
#define MHL_CBUS_MSC_0A_irq_chg24_bit3(data)                                         (0x08000000&((data)<<27))
#define MHL_CBUS_MSC_0A_irq_chg24_bit3_src(data)                                     ((0x08000000&(data))>>27)
#define MHL_CBUS_MSC_0A_get_irq_chg24_bit3(data)                                     ((0x08000000&(data))>>27)
#define MHL_CBUS_MSC_0A_irq_chg24_bit2_shift                                         (26)
#define MHL_CBUS_MSC_0A_irq_chg24_bit2_mask                                          (0x04000000)
#define MHL_CBUS_MSC_0A_irq_chg24_bit2(data)                                         (0x04000000&((data)<<26))
#define MHL_CBUS_MSC_0A_irq_chg24_bit2_src(data)                                     ((0x04000000&(data))>>26)
#define MHL_CBUS_MSC_0A_get_irq_chg24_bit2(data)                                     ((0x04000000&(data))>>26)
#define MHL_CBUS_MSC_0A_irq_chg24_bit1_shift                                         (25)
#define MHL_CBUS_MSC_0A_irq_chg24_bit1_mask                                          (0x02000000)
#define MHL_CBUS_MSC_0A_irq_chg24_bit1(data)                                         (0x02000000&((data)<<25))
#define MHL_CBUS_MSC_0A_irq_chg24_bit1_src(data)                                     ((0x02000000&(data))>>25)
#define MHL_CBUS_MSC_0A_get_irq_chg24_bit1(data)                                     ((0x02000000&(data))>>25)
#define MHL_CBUS_MSC_0A_irq_chg24_bit0_shift                                         (24)
#define MHL_CBUS_MSC_0A_irq_chg24_bit0_mask                                          (0x01000000)
#define MHL_CBUS_MSC_0A_irq_chg24_bit0(data)                                         (0x01000000&((data)<<24))
#define MHL_CBUS_MSC_0A_irq_chg24_bit0_src(data)                                     ((0x01000000&(data))>>24)
#define MHL_CBUS_MSC_0A_get_irq_chg24_bit0(data)                                     ((0x01000000&(data))>>24)
#define MHL_CBUS_MSC_0A_irq_chg25_bit7_shift                                         (23)
#define MHL_CBUS_MSC_0A_irq_chg25_bit7_mask                                          (0x00800000)
#define MHL_CBUS_MSC_0A_irq_chg25_bit7(data)                                         (0x00800000&((data)<<23))
#define MHL_CBUS_MSC_0A_irq_chg25_bit7_src(data)                                     ((0x00800000&(data))>>23)
#define MHL_CBUS_MSC_0A_get_irq_chg25_bit7(data)                                     ((0x00800000&(data))>>23)
#define MHL_CBUS_MSC_0A_irq_chg25_bit6_shift                                         (22)
#define MHL_CBUS_MSC_0A_irq_chg25_bit6_mask                                          (0x00400000)
#define MHL_CBUS_MSC_0A_irq_chg25_bit6(data)                                         (0x00400000&((data)<<22))
#define MHL_CBUS_MSC_0A_irq_chg25_bit6_src(data)                                     ((0x00400000&(data))>>22)
#define MHL_CBUS_MSC_0A_get_irq_chg25_bit6(data)                                     ((0x00400000&(data))>>22)
#define MHL_CBUS_MSC_0A_irq_chg25_bit5_shift                                         (21)
#define MHL_CBUS_MSC_0A_irq_chg25_bit5_mask                                          (0x00200000)
#define MHL_CBUS_MSC_0A_irq_chg25_bit5(data)                                         (0x00200000&((data)<<21))
#define MHL_CBUS_MSC_0A_irq_chg25_bit5_src(data)                                     ((0x00200000&(data))>>21)
#define MHL_CBUS_MSC_0A_get_irq_chg25_bit5(data)                                     ((0x00200000&(data))>>21)
#define MHL_CBUS_MSC_0A_irq_chg25_bit4_shift                                         (20)
#define MHL_CBUS_MSC_0A_irq_chg25_bit4_mask                                          (0x00100000)
#define MHL_CBUS_MSC_0A_irq_chg25_bit4(data)                                         (0x00100000&((data)<<20))
#define MHL_CBUS_MSC_0A_irq_chg25_bit4_src(data)                                     ((0x00100000&(data))>>20)
#define MHL_CBUS_MSC_0A_get_irq_chg25_bit4(data)                                     ((0x00100000&(data))>>20)
#define MHL_CBUS_MSC_0A_irq_chg25_bit3_shift                                         (19)
#define MHL_CBUS_MSC_0A_irq_chg25_bit3_mask                                          (0x00080000)
#define MHL_CBUS_MSC_0A_irq_chg25_bit3(data)                                         (0x00080000&((data)<<19))
#define MHL_CBUS_MSC_0A_irq_chg25_bit3_src(data)                                     ((0x00080000&(data))>>19)
#define MHL_CBUS_MSC_0A_get_irq_chg25_bit3(data)                                     ((0x00080000&(data))>>19)
#define MHL_CBUS_MSC_0A_irq_chg25_bit2_shift                                         (18)
#define MHL_CBUS_MSC_0A_irq_chg25_bit2_mask                                          (0x00040000)
#define MHL_CBUS_MSC_0A_irq_chg25_bit2(data)                                         (0x00040000&((data)<<18))
#define MHL_CBUS_MSC_0A_irq_chg25_bit2_src(data)                                     ((0x00040000&(data))>>18)
#define MHL_CBUS_MSC_0A_get_irq_chg25_bit2(data)                                     ((0x00040000&(data))>>18)
#define MHL_CBUS_MSC_0A_irq_chg25_bit1_shift                                         (17)
#define MHL_CBUS_MSC_0A_irq_chg25_bit1_mask                                          (0x00020000)
#define MHL_CBUS_MSC_0A_irq_chg25_bit1(data)                                         (0x00020000&((data)<<17))
#define MHL_CBUS_MSC_0A_irq_chg25_bit1_src(data)                                     ((0x00020000&(data))>>17)
#define MHL_CBUS_MSC_0A_get_irq_chg25_bit1(data)                                     ((0x00020000&(data))>>17)
#define MHL_CBUS_MSC_0A_irq_chg25_bit0_shift                                         (16)
#define MHL_CBUS_MSC_0A_irq_chg25_bit0_mask                                          (0x00010000)
#define MHL_CBUS_MSC_0A_irq_chg25_bit0(data)                                         (0x00010000&((data)<<16))
#define MHL_CBUS_MSC_0A_irq_chg25_bit0_src(data)                                     ((0x00010000&(data))>>16)
#define MHL_CBUS_MSC_0A_get_irq_chg25_bit0(data)                                     ((0x00010000&(data))>>16)
#define MHL_CBUS_MSC_0A_irq_chg26_bit7_shift                                         (15)
#define MHL_CBUS_MSC_0A_irq_chg26_bit7_mask                                          (0x00008000)
#define MHL_CBUS_MSC_0A_irq_chg26_bit7(data)                                         (0x00008000&((data)<<15))
#define MHL_CBUS_MSC_0A_irq_chg26_bit7_src(data)                                     ((0x00008000&(data))>>15)
#define MHL_CBUS_MSC_0A_get_irq_chg26_bit7(data)                                     ((0x00008000&(data))>>15)
#define MHL_CBUS_MSC_0A_irq_chg26_bit6_shift                                         (14)
#define MHL_CBUS_MSC_0A_irq_chg26_bit6_mask                                          (0x00004000)
#define MHL_CBUS_MSC_0A_irq_chg26_bit6(data)                                         (0x00004000&((data)<<14))
#define MHL_CBUS_MSC_0A_irq_chg26_bit6_src(data)                                     ((0x00004000&(data))>>14)
#define MHL_CBUS_MSC_0A_get_irq_chg26_bit6(data)                                     ((0x00004000&(data))>>14)
#define MHL_CBUS_MSC_0A_irq_chg26_bit5_shift                                         (13)
#define MHL_CBUS_MSC_0A_irq_chg26_bit5_mask                                          (0x00002000)
#define MHL_CBUS_MSC_0A_irq_chg26_bit5(data)                                         (0x00002000&((data)<<13))
#define MHL_CBUS_MSC_0A_irq_chg26_bit5_src(data)                                     ((0x00002000&(data))>>13)
#define MHL_CBUS_MSC_0A_get_irq_chg26_bit5(data)                                     ((0x00002000&(data))>>13)
#define MHL_CBUS_MSC_0A_irq_chg26_bit4_shift                                         (12)
#define MHL_CBUS_MSC_0A_irq_chg26_bit4_mask                                          (0x00001000)
#define MHL_CBUS_MSC_0A_irq_chg26_bit4(data)                                         (0x00001000&((data)<<12))
#define MHL_CBUS_MSC_0A_irq_chg26_bit4_src(data)                                     ((0x00001000&(data))>>12)
#define MHL_CBUS_MSC_0A_get_irq_chg26_bit4(data)                                     ((0x00001000&(data))>>12)
#define MHL_CBUS_MSC_0A_irq_chg26_bit3_shift                                         (11)
#define MHL_CBUS_MSC_0A_irq_chg26_bit3_mask                                          (0x00000800)
#define MHL_CBUS_MSC_0A_irq_chg26_bit3(data)                                         (0x00000800&((data)<<11))
#define MHL_CBUS_MSC_0A_irq_chg26_bit3_src(data)                                     ((0x00000800&(data))>>11)
#define MHL_CBUS_MSC_0A_get_irq_chg26_bit3(data)                                     ((0x00000800&(data))>>11)
#define MHL_CBUS_MSC_0A_irq_chg26_bit2_shift                                         (10)
#define MHL_CBUS_MSC_0A_irq_chg26_bit2_mask                                          (0x00000400)
#define MHL_CBUS_MSC_0A_irq_chg26_bit2(data)                                         (0x00000400&((data)<<10))
#define MHL_CBUS_MSC_0A_irq_chg26_bit2_src(data)                                     ((0x00000400&(data))>>10)
#define MHL_CBUS_MSC_0A_get_irq_chg26_bit2(data)                                     ((0x00000400&(data))>>10)
#define MHL_CBUS_MSC_0A_irq_chg26_bit1_shift                                         (9)
#define MHL_CBUS_MSC_0A_irq_chg26_bit1_mask                                          (0x00000200)
#define MHL_CBUS_MSC_0A_irq_chg26_bit1(data)                                         (0x00000200&((data)<<9))
#define MHL_CBUS_MSC_0A_irq_chg26_bit1_src(data)                                     ((0x00000200&(data))>>9)
#define MHL_CBUS_MSC_0A_get_irq_chg26_bit1(data)                                     ((0x00000200&(data))>>9)
#define MHL_CBUS_MSC_0A_irq_chg26_bit0_shift                                         (8)
#define MHL_CBUS_MSC_0A_irq_chg26_bit0_mask                                          (0x00000100)
#define MHL_CBUS_MSC_0A_irq_chg26_bit0(data)                                         (0x00000100&((data)<<8))
#define MHL_CBUS_MSC_0A_irq_chg26_bit0_src(data)                                     ((0x00000100&(data))>>8)
#define MHL_CBUS_MSC_0A_get_irq_chg26_bit0(data)                                     ((0x00000100&(data))>>8)
#define MHL_CBUS_MSC_0A_irq_chg27_bit7_shift                                         (7)
#define MHL_CBUS_MSC_0A_irq_chg27_bit7_mask                                          (0x00000080)
#define MHL_CBUS_MSC_0A_irq_chg27_bit7(data)                                         (0x00000080&((data)<<7))
#define MHL_CBUS_MSC_0A_irq_chg27_bit7_src(data)                                     ((0x00000080&(data))>>7)
#define MHL_CBUS_MSC_0A_get_irq_chg27_bit7(data)                                     ((0x00000080&(data))>>7)
#define MHL_CBUS_MSC_0A_irq_chg27_bit6_shift                                         (6)
#define MHL_CBUS_MSC_0A_irq_chg27_bit6_mask                                          (0x00000040)
#define MHL_CBUS_MSC_0A_irq_chg27_bit6(data)                                         (0x00000040&((data)<<6))
#define MHL_CBUS_MSC_0A_irq_chg27_bit6_src(data)                                     ((0x00000040&(data))>>6)
#define MHL_CBUS_MSC_0A_get_irq_chg27_bit6(data)                                     ((0x00000040&(data))>>6)
#define MHL_CBUS_MSC_0A_irq_chg27_bit5_shift                                         (5)
#define MHL_CBUS_MSC_0A_irq_chg27_bit5_mask                                          (0x00000020)
#define MHL_CBUS_MSC_0A_irq_chg27_bit5(data)                                         (0x00000020&((data)<<5))
#define MHL_CBUS_MSC_0A_irq_chg27_bit5_src(data)                                     ((0x00000020&(data))>>5)
#define MHL_CBUS_MSC_0A_get_irq_chg27_bit5(data)                                     ((0x00000020&(data))>>5)
#define MHL_CBUS_MSC_0A_irq_chg27_bit4_shift                                         (4)
#define MHL_CBUS_MSC_0A_irq_chg27_bit4_mask                                          (0x00000010)
#define MHL_CBUS_MSC_0A_irq_chg27_bit4(data)                                         (0x00000010&((data)<<4))
#define MHL_CBUS_MSC_0A_irq_chg27_bit4_src(data)                                     ((0x00000010&(data))>>4)
#define MHL_CBUS_MSC_0A_get_irq_chg27_bit4(data)                                     ((0x00000010&(data))>>4)
#define MHL_CBUS_MSC_0A_irq_chg27_bit3_shift                                         (3)
#define MHL_CBUS_MSC_0A_irq_chg27_bit3_mask                                          (0x00000008)
#define MHL_CBUS_MSC_0A_irq_chg27_bit3(data)                                         (0x00000008&((data)<<3))
#define MHL_CBUS_MSC_0A_irq_chg27_bit3_src(data)                                     ((0x00000008&(data))>>3)
#define MHL_CBUS_MSC_0A_get_irq_chg27_bit3(data)                                     ((0x00000008&(data))>>3)
#define MHL_CBUS_MSC_0A_irq_chg27_bit2_shift                                         (2)
#define MHL_CBUS_MSC_0A_irq_chg27_bit2_mask                                          (0x00000004)
#define MHL_CBUS_MSC_0A_irq_chg27_bit2(data)                                         (0x00000004&((data)<<2))
#define MHL_CBUS_MSC_0A_irq_chg27_bit2_src(data)                                     ((0x00000004&(data))>>2)
#define MHL_CBUS_MSC_0A_get_irq_chg27_bit2(data)                                     ((0x00000004&(data))>>2)
#define MHL_CBUS_MSC_0A_irq_chg27_bit1_shift                                         (1)
#define MHL_CBUS_MSC_0A_irq_chg27_bit1_mask                                          (0x00000002)
#define MHL_CBUS_MSC_0A_irq_chg27_bit1(data)                                         (0x00000002&((data)<<1))
#define MHL_CBUS_MSC_0A_irq_chg27_bit1_src(data)                                     ((0x00000002&(data))>>1)
#define MHL_CBUS_MSC_0A_get_irq_chg27_bit1(data)                                     ((0x00000002&(data))>>1)
#define MHL_CBUS_MSC_0A_irq_chg27_bit0_shift                                         (0)
#define MHL_CBUS_MSC_0A_irq_chg27_bit0_mask                                          (0x00000001)
#define MHL_CBUS_MSC_0A_irq_chg27_bit0(data)                                         (0x00000001&((data)<<0))
#define MHL_CBUS_MSC_0A_irq_chg27_bit0_src(data)                                     ((0x00000001&(data))>>0)
#define MHL_CBUS_MSC_0A_get_irq_chg27_bit0(data)                                     ((0x00000001&(data))>>0)


#define MHL_CBUS_MSC_0B                                                              0x18062DAC
#define MHL_CBUS_MSC_0B_reg_addr                                                     "0xB8062DAC"
#define MHL_CBUS_MSC_0B_reg                                                          0xB8062DAC
#define set_MHL_CBUS_MSC_0B_reg(data)   (*((volatile unsigned int*) MHL_CBUS_MSC_0B_reg)=data)
#define get_MHL_CBUS_MSC_0B_reg   (*((volatile unsigned int*) MHL_CBUS_MSC_0B_reg))
#define MHL_CBUS_MSC_0B_inst_adr                                                     "0x006B"
#define MHL_CBUS_MSC_0B_inst                                                         0x006B
#define MHL_CBUS_MSC_0B_irq_en_chg24_bit7_shift                                      (31)
#define MHL_CBUS_MSC_0B_irq_en_chg24_bit7_mask                                       (0x80000000)
#define MHL_CBUS_MSC_0B_irq_en_chg24_bit7(data)                                      (0x80000000&((data)<<31))
#define MHL_CBUS_MSC_0B_irq_en_chg24_bit7_src(data)                                  ((0x80000000&(data))>>31)
#define MHL_CBUS_MSC_0B_get_irq_en_chg24_bit7(data)                                  ((0x80000000&(data))>>31)
#define MHL_CBUS_MSC_0B_irq_en_chg24_bit6_shift                                      (30)
#define MHL_CBUS_MSC_0B_irq_en_chg24_bit6_mask                                       (0x40000000)
#define MHL_CBUS_MSC_0B_irq_en_chg24_bit6(data)                                      (0x40000000&((data)<<30))
#define MHL_CBUS_MSC_0B_irq_en_chg24_bit6_src(data)                                  ((0x40000000&(data))>>30)
#define MHL_CBUS_MSC_0B_get_irq_en_chg24_bit6(data)                                  ((0x40000000&(data))>>30)
#define MHL_CBUS_MSC_0B_irq_en_chg24_bit5_shift                                      (29)
#define MHL_CBUS_MSC_0B_irq_en_chg24_bit5_mask                                       (0x20000000)
#define MHL_CBUS_MSC_0B_irq_en_chg24_bit5(data)                                      (0x20000000&((data)<<29))
#define MHL_CBUS_MSC_0B_irq_en_chg24_bit5_src(data)                                  ((0x20000000&(data))>>29)
#define MHL_CBUS_MSC_0B_get_irq_en_chg24_bit5(data)                                  ((0x20000000&(data))>>29)
#define MHL_CBUS_MSC_0B_irq_en_chg24_bit4_shift                                      (28)
#define MHL_CBUS_MSC_0B_irq_en_chg24_bit4_mask                                       (0x10000000)
#define MHL_CBUS_MSC_0B_irq_en_chg24_bit4(data)                                      (0x10000000&((data)<<28))
#define MHL_CBUS_MSC_0B_irq_en_chg24_bit4_src(data)                                  ((0x10000000&(data))>>28)
#define MHL_CBUS_MSC_0B_get_irq_en_chg24_bit4(data)                                  ((0x10000000&(data))>>28)
#define MHL_CBUS_MSC_0B_irq_en_chg24_bit3_shift                                      (27)
#define MHL_CBUS_MSC_0B_irq_en_chg24_bit3_mask                                       (0x08000000)
#define MHL_CBUS_MSC_0B_irq_en_chg24_bit3(data)                                      (0x08000000&((data)<<27))
#define MHL_CBUS_MSC_0B_irq_en_chg24_bit3_src(data)                                  ((0x08000000&(data))>>27)
#define MHL_CBUS_MSC_0B_get_irq_en_chg24_bit3(data)                                  ((0x08000000&(data))>>27)
#define MHL_CBUS_MSC_0B_irq_en_chg24_bit2_shift                                      (26)
#define MHL_CBUS_MSC_0B_irq_en_chg24_bit2_mask                                       (0x04000000)
#define MHL_CBUS_MSC_0B_irq_en_chg24_bit2(data)                                      (0x04000000&((data)<<26))
#define MHL_CBUS_MSC_0B_irq_en_chg24_bit2_src(data)                                  ((0x04000000&(data))>>26)
#define MHL_CBUS_MSC_0B_get_irq_en_chg24_bit2(data)                                  ((0x04000000&(data))>>26)
#define MHL_CBUS_MSC_0B_irq_en_chg24_bit1_shift                                      (25)
#define MHL_CBUS_MSC_0B_irq_en_chg24_bit1_mask                                       (0x02000000)
#define MHL_CBUS_MSC_0B_irq_en_chg24_bit1(data)                                      (0x02000000&((data)<<25))
#define MHL_CBUS_MSC_0B_irq_en_chg24_bit1_src(data)                                  ((0x02000000&(data))>>25)
#define MHL_CBUS_MSC_0B_get_irq_en_chg24_bit1(data)                                  ((0x02000000&(data))>>25)
#define MHL_CBUS_MSC_0B_irq_en_chg24_bit0_shift                                      (24)
#define MHL_CBUS_MSC_0B_irq_en_chg24_bit0_mask                                       (0x01000000)
#define MHL_CBUS_MSC_0B_irq_en_chg24_bit0(data)                                      (0x01000000&((data)<<24))
#define MHL_CBUS_MSC_0B_irq_en_chg24_bit0_src(data)                                  ((0x01000000&(data))>>24)
#define MHL_CBUS_MSC_0B_get_irq_en_chg24_bit0(data)                                  ((0x01000000&(data))>>24)
#define MHL_CBUS_MSC_0B_irq_en_chg25_bit7_shift                                      (23)
#define MHL_CBUS_MSC_0B_irq_en_chg25_bit7_mask                                       (0x00800000)
#define MHL_CBUS_MSC_0B_irq_en_chg25_bit7(data)                                      (0x00800000&((data)<<23))
#define MHL_CBUS_MSC_0B_irq_en_chg25_bit7_src(data)                                  ((0x00800000&(data))>>23)
#define MHL_CBUS_MSC_0B_get_irq_en_chg25_bit7(data)                                  ((0x00800000&(data))>>23)
#define MHL_CBUS_MSC_0B_irq_en_chg25_bit6_shift                                      (22)
#define MHL_CBUS_MSC_0B_irq_en_chg25_bit6_mask                                       (0x00400000)
#define MHL_CBUS_MSC_0B_irq_en_chg25_bit6(data)                                      (0x00400000&((data)<<22))
#define MHL_CBUS_MSC_0B_irq_en_chg25_bit6_src(data)                                  ((0x00400000&(data))>>22)
#define MHL_CBUS_MSC_0B_get_irq_en_chg25_bit6(data)                                  ((0x00400000&(data))>>22)
#define MHL_CBUS_MSC_0B_irq_en_chg25_bit5_shift                                      (21)
#define MHL_CBUS_MSC_0B_irq_en_chg25_bit5_mask                                       (0x00200000)
#define MHL_CBUS_MSC_0B_irq_en_chg25_bit5(data)                                      (0x00200000&((data)<<21))
#define MHL_CBUS_MSC_0B_irq_en_chg25_bit5_src(data)                                  ((0x00200000&(data))>>21)
#define MHL_CBUS_MSC_0B_get_irq_en_chg25_bit5(data)                                  ((0x00200000&(data))>>21)
#define MHL_CBUS_MSC_0B_irq_en_chg25_bit4_shift                                      (20)
#define MHL_CBUS_MSC_0B_irq_en_chg25_bit4_mask                                       (0x00100000)
#define MHL_CBUS_MSC_0B_irq_en_chg25_bit4(data)                                      (0x00100000&((data)<<20))
#define MHL_CBUS_MSC_0B_irq_en_chg25_bit4_src(data)                                  ((0x00100000&(data))>>20)
#define MHL_CBUS_MSC_0B_get_irq_en_chg25_bit4(data)                                  ((0x00100000&(data))>>20)
#define MHL_CBUS_MSC_0B_irq_en_chg25_bit3_shift                                      (19)
#define MHL_CBUS_MSC_0B_irq_en_chg25_bit3_mask                                       (0x00080000)
#define MHL_CBUS_MSC_0B_irq_en_chg25_bit3(data)                                      (0x00080000&((data)<<19))
#define MHL_CBUS_MSC_0B_irq_en_chg25_bit3_src(data)                                  ((0x00080000&(data))>>19)
#define MHL_CBUS_MSC_0B_get_irq_en_chg25_bit3(data)                                  ((0x00080000&(data))>>19)
#define MHL_CBUS_MSC_0B_irq_en_chg25_bit2_shift                                      (18)
#define MHL_CBUS_MSC_0B_irq_en_chg25_bit2_mask                                       (0x00040000)
#define MHL_CBUS_MSC_0B_irq_en_chg25_bit2(data)                                      (0x00040000&((data)<<18))
#define MHL_CBUS_MSC_0B_irq_en_chg25_bit2_src(data)                                  ((0x00040000&(data))>>18)
#define MHL_CBUS_MSC_0B_get_irq_en_chg25_bit2(data)                                  ((0x00040000&(data))>>18)
#define MHL_CBUS_MSC_0B_irq_en_chg25_bit1_shift                                      (17)
#define MHL_CBUS_MSC_0B_irq_en_chg25_bit1_mask                                       (0x00020000)
#define MHL_CBUS_MSC_0B_irq_en_chg25_bit1(data)                                      (0x00020000&((data)<<17))
#define MHL_CBUS_MSC_0B_irq_en_chg25_bit1_src(data)                                  ((0x00020000&(data))>>17)
#define MHL_CBUS_MSC_0B_get_irq_en_chg25_bit1(data)                                  ((0x00020000&(data))>>17)
#define MHL_CBUS_MSC_0B_irq_en_chg25_bit0_shift                                      (16)
#define MHL_CBUS_MSC_0B_irq_en_chg25_bit0_mask                                       (0x00010000)
#define MHL_CBUS_MSC_0B_irq_en_chg25_bit0(data)                                      (0x00010000&((data)<<16))
#define MHL_CBUS_MSC_0B_irq_en_chg25_bit0_src(data)                                  ((0x00010000&(data))>>16)
#define MHL_CBUS_MSC_0B_get_irq_en_chg25_bit0(data)                                  ((0x00010000&(data))>>16)
#define MHL_CBUS_MSC_0B_irq_en_chg26_bit7_shift                                      (15)
#define MHL_CBUS_MSC_0B_irq_en_chg26_bit7_mask                                       (0x00008000)
#define MHL_CBUS_MSC_0B_irq_en_chg26_bit7(data)                                      (0x00008000&((data)<<15))
#define MHL_CBUS_MSC_0B_irq_en_chg26_bit7_src(data)                                  ((0x00008000&(data))>>15)
#define MHL_CBUS_MSC_0B_get_irq_en_chg26_bit7(data)                                  ((0x00008000&(data))>>15)
#define MHL_CBUS_MSC_0B_irq_en_chg26_bit6_shift                                      (14)
#define MHL_CBUS_MSC_0B_irq_en_chg26_bit6_mask                                       (0x00004000)
#define MHL_CBUS_MSC_0B_irq_en_chg26_bit6(data)                                      (0x00004000&((data)<<14))
#define MHL_CBUS_MSC_0B_irq_en_chg26_bit6_src(data)                                  ((0x00004000&(data))>>14)
#define MHL_CBUS_MSC_0B_get_irq_en_chg26_bit6(data)                                  ((0x00004000&(data))>>14)
#define MHL_CBUS_MSC_0B_irq_en_chg26_bit5_shift                                      (13)
#define MHL_CBUS_MSC_0B_irq_en_chg26_bit5_mask                                       (0x00002000)
#define MHL_CBUS_MSC_0B_irq_en_chg26_bit5(data)                                      (0x00002000&((data)<<13))
#define MHL_CBUS_MSC_0B_irq_en_chg26_bit5_src(data)                                  ((0x00002000&(data))>>13)
#define MHL_CBUS_MSC_0B_get_irq_en_chg26_bit5(data)                                  ((0x00002000&(data))>>13)
#define MHL_CBUS_MSC_0B_irq_en_chg26_bit4_shift                                      (12)
#define MHL_CBUS_MSC_0B_irq_en_chg26_bit4_mask                                       (0x00001000)
#define MHL_CBUS_MSC_0B_irq_en_chg26_bit4(data)                                      (0x00001000&((data)<<12))
#define MHL_CBUS_MSC_0B_irq_en_chg26_bit4_src(data)                                  ((0x00001000&(data))>>12)
#define MHL_CBUS_MSC_0B_get_irq_en_chg26_bit4(data)                                  ((0x00001000&(data))>>12)
#define MHL_CBUS_MSC_0B_irq_en_chg26_bit3_shift                                      (11)
#define MHL_CBUS_MSC_0B_irq_en_chg26_bit3_mask                                       (0x00000800)
#define MHL_CBUS_MSC_0B_irq_en_chg26_bit3(data)                                      (0x00000800&((data)<<11))
#define MHL_CBUS_MSC_0B_irq_en_chg26_bit3_src(data)                                  ((0x00000800&(data))>>11)
#define MHL_CBUS_MSC_0B_get_irq_en_chg26_bit3(data)                                  ((0x00000800&(data))>>11)
#define MHL_CBUS_MSC_0B_irq_en_chg26_bit2_shift                                      (10)
#define MHL_CBUS_MSC_0B_irq_en_chg26_bit2_mask                                       (0x00000400)
#define MHL_CBUS_MSC_0B_irq_en_chg26_bit2(data)                                      (0x00000400&((data)<<10))
#define MHL_CBUS_MSC_0B_irq_en_chg26_bit2_src(data)                                  ((0x00000400&(data))>>10)
#define MHL_CBUS_MSC_0B_get_irq_en_chg26_bit2(data)                                  ((0x00000400&(data))>>10)
#define MHL_CBUS_MSC_0B_irq_en_chg26_bit1_shift                                      (9)
#define MHL_CBUS_MSC_0B_irq_en_chg26_bit1_mask                                       (0x00000200)
#define MHL_CBUS_MSC_0B_irq_en_chg26_bit1(data)                                      (0x00000200&((data)<<9))
#define MHL_CBUS_MSC_0B_irq_en_chg26_bit1_src(data)                                  ((0x00000200&(data))>>9)
#define MHL_CBUS_MSC_0B_get_irq_en_chg26_bit1(data)                                  ((0x00000200&(data))>>9)
#define MHL_CBUS_MSC_0B_irq_en_chg26_bit0_shift                                      (8)
#define MHL_CBUS_MSC_0B_irq_en_chg26_bit0_mask                                       (0x00000100)
#define MHL_CBUS_MSC_0B_irq_en_chg26_bit0(data)                                      (0x00000100&((data)<<8))
#define MHL_CBUS_MSC_0B_irq_en_chg26_bit0_src(data)                                  ((0x00000100&(data))>>8)
#define MHL_CBUS_MSC_0B_get_irq_en_chg26_bit0(data)                                  ((0x00000100&(data))>>8)
#define MHL_CBUS_MSC_0B_irq_en_chg27_bit7_shift                                      (7)
#define MHL_CBUS_MSC_0B_irq_en_chg27_bit7_mask                                       (0x00000080)
#define MHL_CBUS_MSC_0B_irq_en_chg27_bit7(data)                                      (0x00000080&((data)<<7))
#define MHL_CBUS_MSC_0B_irq_en_chg27_bit7_src(data)                                  ((0x00000080&(data))>>7)
#define MHL_CBUS_MSC_0B_get_irq_en_chg27_bit7(data)                                  ((0x00000080&(data))>>7)
#define MHL_CBUS_MSC_0B_irq_en_chg27_bit6_shift                                      (6)
#define MHL_CBUS_MSC_0B_irq_en_chg27_bit6_mask                                       (0x00000040)
#define MHL_CBUS_MSC_0B_irq_en_chg27_bit6(data)                                      (0x00000040&((data)<<6))
#define MHL_CBUS_MSC_0B_irq_en_chg27_bit6_src(data)                                  ((0x00000040&(data))>>6)
#define MHL_CBUS_MSC_0B_get_irq_en_chg27_bit6(data)                                  ((0x00000040&(data))>>6)
#define MHL_CBUS_MSC_0B_irq_en_chg27_bit5_shift                                      (5)
#define MHL_CBUS_MSC_0B_irq_en_chg27_bit5_mask                                       (0x00000020)
#define MHL_CBUS_MSC_0B_irq_en_chg27_bit5(data)                                      (0x00000020&((data)<<5))
#define MHL_CBUS_MSC_0B_irq_en_chg27_bit5_src(data)                                  ((0x00000020&(data))>>5)
#define MHL_CBUS_MSC_0B_get_irq_en_chg27_bit5(data)                                  ((0x00000020&(data))>>5)
#define MHL_CBUS_MSC_0B_irq_en_chg27_bit4_shift                                      (4)
#define MHL_CBUS_MSC_0B_irq_en_chg27_bit4_mask                                       (0x00000010)
#define MHL_CBUS_MSC_0B_irq_en_chg27_bit4(data)                                      (0x00000010&((data)<<4))
#define MHL_CBUS_MSC_0B_irq_en_chg27_bit4_src(data)                                  ((0x00000010&(data))>>4)
#define MHL_CBUS_MSC_0B_get_irq_en_chg27_bit4(data)                                  ((0x00000010&(data))>>4)
#define MHL_CBUS_MSC_0B_irq_en_chg27_bit3_shift                                      (3)
#define MHL_CBUS_MSC_0B_irq_en_chg27_bit3_mask                                       (0x00000008)
#define MHL_CBUS_MSC_0B_irq_en_chg27_bit3(data)                                      (0x00000008&((data)<<3))
#define MHL_CBUS_MSC_0B_irq_en_chg27_bit3_src(data)                                  ((0x00000008&(data))>>3)
#define MHL_CBUS_MSC_0B_get_irq_en_chg27_bit3(data)                                  ((0x00000008&(data))>>3)
#define MHL_CBUS_MSC_0B_irq_en_chg27_bit2_shift                                      (2)
#define MHL_CBUS_MSC_0B_irq_en_chg27_bit2_mask                                       (0x00000004)
#define MHL_CBUS_MSC_0B_irq_en_chg27_bit2(data)                                      (0x00000004&((data)<<2))
#define MHL_CBUS_MSC_0B_irq_en_chg27_bit2_src(data)                                  ((0x00000004&(data))>>2)
#define MHL_CBUS_MSC_0B_get_irq_en_chg27_bit2(data)                                  ((0x00000004&(data))>>2)
#define MHL_CBUS_MSC_0B_irq_en_chg27_bit1_shift                                      (1)
#define MHL_CBUS_MSC_0B_irq_en_chg27_bit1_mask                                       (0x00000002)
#define MHL_CBUS_MSC_0B_irq_en_chg27_bit1(data)                                      (0x00000002&((data)<<1))
#define MHL_CBUS_MSC_0B_irq_en_chg27_bit1_src(data)                                  ((0x00000002&(data))>>1)
#define MHL_CBUS_MSC_0B_get_irq_en_chg27_bit1(data)                                  ((0x00000002&(data))>>1)
#define MHL_CBUS_MSC_0B_irq_en_chg27_bit0_shift                                      (0)
#define MHL_CBUS_MSC_0B_irq_en_chg27_bit0_mask                                       (0x00000001)
#define MHL_CBUS_MSC_0B_irq_en_chg27_bit0(data)                                      (0x00000001&((data)<<0))
#define MHL_CBUS_MSC_0B_irq_en_chg27_bit0_src(data)                                  ((0x00000001&(data))>>0)
#define MHL_CBUS_MSC_0B_get_irq_en_chg27_bit0(data)                                  ((0x00000001&(data))>>0)


#define MHL_CBUS_MSC_0C                                                              0x18062DB0
#define MHL_CBUS_MSC_0C_reg_addr                                                     "0xB8062DB0"
#define MHL_CBUS_MSC_0C_reg                                                          0xB8062DB0
#define set_MHL_CBUS_MSC_0C_reg(data)   (*((volatile unsigned int*) MHL_CBUS_MSC_0C_reg)=data)
#define get_MHL_CBUS_MSC_0C_reg   (*((volatile unsigned int*) MHL_CBUS_MSC_0C_reg))
#define MHL_CBUS_MSC_0C_inst_adr                                                     "0x006C"
#define MHL_CBUS_MSC_0C_inst                                                         0x006C
#define MHL_CBUS_MSC_0C_irq_msc_err_update_shift                                     (9)
#define MHL_CBUS_MSC_0C_irq_msc_err_update_mask                                      (0x00000200)
#define MHL_CBUS_MSC_0C_irq_msc_err_update(data)                                     (0x00000200&((data)<<9))
#define MHL_CBUS_MSC_0C_irq_msc_err_update_src(data)                                 ((0x00000200&(data))>>9)
#define MHL_CBUS_MSC_0C_get_irq_msc_err_update(data)                                 ((0x00000200&(data))>>9)
#define MHL_CBUS_MSC_0C_msc_err_code_shift                                           (0)
#define MHL_CBUS_MSC_0C_msc_err_code_mask                                            (0x000000FF)
#define MHL_CBUS_MSC_0C_msc_err_code(data)                                           (0x000000FF&((data)<<0))
#define MHL_CBUS_MSC_0C_msc_err_code_src(data)                                       ((0x000000FF&(data))>>0)
#define MHL_CBUS_MSC_0C_get_msc_err_code(data)                                       ((0x000000FF&(data))>>0)


#define MHL_CBUS_MSC_0D                                                              0x18062DB4
#define MHL_CBUS_MSC_0D_reg_addr                                                     "0xB8062DB4"
#define MHL_CBUS_MSC_0D_reg                                                          0xB8062DB4
#define set_MHL_CBUS_MSC_0D_reg(data)   (*((volatile unsigned int*) MHL_CBUS_MSC_0D_reg)=data)
#define get_MHL_CBUS_MSC_0D_reg   (*((volatile unsigned int*) MHL_CBUS_MSC_0D_reg))
#define MHL_CBUS_MSC_0D_inst_adr                                                     "0x006D"
#define MHL_CBUS_MSC_0D_inst                                                         0x006D
#define MHL_CBUS_MSC_0D_msc_err_update_no_err_shift                                  (30)
#define MHL_CBUS_MSC_0D_msc_err_update_no_err_mask                                   (0x40000000)
#define MHL_CBUS_MSC_0D_msc_err_update_no_err(data)                                  (0x40000000&((data)<<30))
#define MHL_CBUS_MSC_0D_msc_err_update_no_err_src(data)                              ((0x40000000&(data))>>30)
#define MHL_CBUS_MSC_0D_get_msc_err_update_no_err(data)                              ((0x40000000&(data))>>30)
#define MHL_CBUS_MSC_0D_irq_en_msc_err_update_shift                                  (29)
#define MHL_CBUS_MSC_0D_irq_en_msc_err_update_mask                                   (0x20000000)
#define MHL_CBUS_MSC_0D_irq_en_msc_err_update(data)                                  (0x20000000&((data)<<29))
#define MHL_CBUS_MSC_0D_irq_en_msc_err_update_src(data)                              ((0x20000000&(data))>>29)
#define MHL_CBUS_MSC_0D_get_irq_en_msc_err_update(data)                              ((0x20000000&(data))>>29)
#define MHL_CBUS_MSC_0D_rcp_reply_abort_shift                                        (9)
#define MHL_CBUS_MSC_0D_rcp_reply_abort_mask                                         (0x00000200)
#define MHL_CBUS_MSC_0D_rcp_reply_abort(data)                                        (0x00000200&((data)<<9))
#define MHL_CBUS_MSC_0D_rcp_reply_abort_src(data)                                    ((0x00000200&(data))>>9)
#define MHL_CBUS_MSC_0D_get_rcp_reply_abort(data)                                    ((0x00000200&(data))>>9)
#define MHL_CBUS_MSC_0D_rcp_reply_nack_shift                                         (8)
#define MHL_CBUS_MSC_0D_rcp_reply_nack_mask                                          (0x00000100)
#define MHL_CBUS_MSC_0D_rcp_reply_nack(data)                                         (0x00000100&((data)<<8))
#define MHL_CBUS_MSC_0D_rcp_reply_nack_src(data)                                     ((0x00000100&(data))>>8)
#define MHL_CBUS_MSC_0D_get_rcp_reply_nack(data)                                     ((0x00000100&(data))>>8)
#define MHL_CBUS_MSC_0D_vendor_id_shift                                              (0)
#define MHL_CBUS_MSC_0D_vendor_id_mask                                               (0x000000FF)
#define MHL_CBUS_MSC_0D_vendor_id(data)                                              (0x000000FF&((data)<<0))
#define MHL_CBUS_MSC_0D_vendor_id_src(data)                                          ((0x000000FF&(data))>>0)
#define MHL_CBUS_MSC_0D_get_vendor_id(data)                                          ((0x000000FF&(data))>>0)


#define MHL_CBUS_MSC_0E                                                              0x18062DB8
#define MHL_CBUS_MSC_0E_reg_addr                                                     "0xB8062DB8"
#define MHL_CBUS_MSC_0E_reg                                                          0xB8062DB8
#define set_MHL_CBUS_MSC_0E_reg(data)   (*((volatile unsigned int*) MHL_CBUS_MSC_0E_reg)=data)
#define get_MHL_CBUS_MSC_0E_reg   (*((volatile unsigned int*) MHL_CBUS_MSC_0E_reg))
#define MHL_CBUS_MSC_0E_inst_adr                                                     "0x006E"
#define MHL_CBUS_MSC_0E_inst                                                         0x006E
#define MHL_CBUS_MSC_0E_msg_cmd_shift                                                (0)
#define MHL_CBUS_MSC_0E_msg_cmd_mask                                                 (0x000000FF)
#define MHL_CBUS_MSC_0E_msg_cmd(data)                                                (0x000000FF&((data)<<0))
#define MHL_CBUS_MSC_0E_msg_cmd_src(data)                                            ((0x000000FF&(data))>>0)
#define MHL_CBUS_MSC_0E_get_msg_cmd(data)                                            ((0x000000FF&(data))>>0)


#define MHL_CBUS_MSC_0F                                                              0x18062DBC
#define MHL_CBUS_MSC_0F_reg_addr                                                     "0xB8062DBC"
#define MHL_CBUS_MSC_0F_reg                                                          0xB8062DBC
#define set_MHL_CBUS_MSC_0F_reg(data)   (*((volatile unsigned int*) MHL_CBUS_MSC_0F_reg)=data)
#define get_MHL_CBUS_MSC_0F_reg   (*((volatile unsigned int*) MHL_CBUS_MSC_0F_reg))
#define MHL_CBUS_MSC_0F_inst_adr                                                     "0x006F"
#define MHL_CBUS_MSC_0F_inst                                                         0x006F
#define MHL_CBUS_MSC_0F_msg_dat_shift                                                (0)
#define MHL_CBUS_MSC_0F_msg_dat_mask                                                 (0x000000FF)
#define MHL_CBUS_MSC_0F_msg_dat(data)                                                (0x000000FF&((data)<<0))
#define MHL_CBUS_MSC_0F_msg_dat_src(data)                                            ((0x000000FF&(data))>>0)
#define MHL_CBUS_MSC_0F_get_msg_dat(data)                                            ((0x000000FF&(data))>>0)


#define MHL_CBUS_MSC_10                                                              0x18062DC0
#define MHL_CBUS_MSC_10_reg_addr                                                     "0xB8062DC0"
#define MHL_CBUS_MSC_10_reg                                                          0xB8062DC0
#define set_MHL_CBUS_MSC_10_reg(data)   (*((volatile unsigned int*) MHL_CBUS_MSC_10_reg)=data)
#define get_MHL_CBUS_MSC_10_reg   (*((volatile unsigned int*) MHL_CBUS_MSC_10_reg))
#define MHL_CBUS_MSC_10_inst_adr                                                     "0x0070"
#define MHL_CBUS_MSC_10_inst                                                         0x0070
#define MHL_CBUS_MSC_10_msge_rcv_shift                                               (0)
#define MHL_CBUS_MSC_10_msge_rcv_mask                                                (0x000000FF)
#define MHL_CBUS_MSC_10_msge_rcv(data)                                               (0x000000FF&((data)<<0))
#define MHL_CBUS_MSC_10_msge_rcv_src(data)                                           ((0x000000FF&(data))>>0)
#define MHL_CBUS_MSC_10_get_msge_rcv(data)                                           ((0x000000FF&(data))>>0)


#define MHL_CBUS_MSC_11                                                              0x18062DC4
#define MHL_CBUS_MSC_11_reg_addr                                                     "0xB8062DC4"
#define MHL_CBUS_MSC_11_reg                                                          0xB8062DC4
#define set_MHL_CBUS_MSC_11_reg(data)   (*((volatile unsigned int*) MHL_CBUS_MSC_11_reg)=data)
#define get_MHL_CBUS_MSC_11_reg   (*((volatile unsigned int*) MHL_CBUS_MSC_11_reg))
#define MHL_CBUS_MSC_11_inst_adr                                                     "0x0071"
#define MHL_CBUS_MSC_11_inst                                                         0x0071
#define MHL_CBUS_MSC_11_rcp_rcv_shift                                                (0)
#define MHL_CBUS_MSC_11_rcp_rcv_mask                                                 (0x000000FF)
#define MHL_CBUS_MSC_11_rcp_rcv(data)                                                (0x000000FF&((data)<<0))
#define MHL_CBUS_MSC_11_rcp_rcv_src(data)                                            ((0x000000FF&(data))>>0)
#define MHL_CBUS_MSC_11_get_rcp_rcv(data)                                            ((0x000000FF&(data))>>0)


#define MHL_CBUS_MSC_12                                                              0x18062DC8
#define MHL_CBUS_MSC_12_reg_addr                                                     "0xB8062DC8"
#define MHL_CBUS_MSC_12_reg                                                          0xB8062DC8
#define set_MHL_CBUS_MSC_12_reg(data)   (*((volatile unsigned int*) MHL_CBUS_MSC_12_reg)=data)
#define get_MHL_CBUS_MSC_12_reg   (*((volatile unsigned int*) MHL_CBUS_MSC_12_reg))
#define MHL_CBUS_MSC_12_inst_adr                                                     "0x0072"
#define MHL_CBUS_MSC_12_inst                                                         0x0072
#define MHL_CBUS_MSC_12_rcpk_rcv_shift                                               (0)
#define MHL_CBUS_MSC_12_rcpk_rcv_mask                                                (0x000000FF)
#define MHL_CBUS_MSC_12_rcpk_rcv(data)                                               (0x000000FF&((data)<<0))
#define MHL_CBUS_MSC_12_rcpk_rcv_src(data)                                           ((0x000000FF&(data))>>0)
#define MHL_CBUS_MSC_12_get_rcpk_rcv(data)                                           ((0x000000FF&(data))>>0)


#define MHL_CBUS_MSC_13                                                              0x18062DCC
#define MHL_CBUS_MSC_13_reg_addr                                                     "0xB8062DCC"
#define MHL_CBUS_MSC_13_reg                                                          0xB8062DCC
#define set_MHL_CBUS_MSC_13_reg(data)   (*((volatile unsigned int*) MHL_CBUS_MSC_13_reg)=data)
#define get_MHL_CBUS_MSC_13_reg   (*((volatile unsigned int*) MHL_CBUS_MSC_13_reg))
#define MHL_CBUS_MSC_13_inst_adr                                                     "0x0073"
#define MHL_CBUS_MSC_13_inst                                                         0x0073
#define MHL_CBUS_MSC_13_rcpe_rcv_shift                                               (0)
#define MHL_CBUS_MSC_13_rcpe_rcv_mask                                                (0x000000FF)
#define MHL_CBUS_MSC_13_rcpe_rcv(data)                                               (0x000000FF&((data)<<0))
#define MHL_CBUS_MSC_13_rcpe_rcv_src(data)                                           ((0x000000FF&(data))>>0)
#define MHL_CBUS_MSC_13_get_rcpe_rcv(data)                                           ((0x000000FF&(data))>>0)


#define MHL_CBUS_MSC_14                                                              0x18062DD0
#define MHL_CBUS_MSC_14_reg_addr                                                     "0xB8062DD0"
#define MHL_CBUS_MSC_14_reg                                                          0xB8062DD0
#define set_MHL_CBUS_MSC_14_reg(data)   (*((volatile unsigned int*) MHL_CBUS_MSC_14_reg)=data)
#define get_MHL_CBUS_MSC_14_reg   (*((volatile unsigned int*) MHL_CBUS_MSC_14_reg))
#define MHL_CBUS_MSC_14_inst_adr                                                     "0x0074"
#define MHL_CBUS_MSC_14_inst                                                         0x0074
#define MHL_CBUS_MSC_14_rap_rcv_shift                                                (0)
#define MHL_CBUS_MSC_14_rap_rcv_mask                                                 (0x000000FF)
#define MHL_CBUS_MSC_14_rap_rcv(data)                                                (0x000000FF&((data)<<0))
#define MHL_CBUS_MSC_14_rap_rcv_src(data)                                            ((0x000000FF&(data))>>0)
#define MHL_CBUS_MSC_14_get_rap_rcv(data)                                            ((0x000000FF&(data))>>0)


#define MHL_CBUS_MSC_15                                                              0x18062DD4
#define MHL_CBUS_MSC_15_reg_addr                                                     "0xB8062DD4"
#define MHL_CBUS_MSC_15_reg                                                          0xB8062DD4
#define set_MHL_CBUS_MSC_15_reg(data)   (*((volatile unsigned int*) MHL_CBUS_MSC_15_reg)=data)
#define get_MHL_CBUS_MSC_15_reg   (*((volatile unsigned int*) MHL_CBUS_MSC_15_reg))
#define MHL_CBUS_MSC_15_inst_adr                                                     "0x0075"
#define MHL_CBUS_MSC_15_inst                                                         0x0075
#define MHL_CBUS_MSC_15_rapk_rcv_shift                                               (0)
#define MHL_CBUS_MSC_15_rapk_rcv_mask                                                (0x000000FF)
#define MHL_CBUS_MSC_15_rapk_rcv(data)                                               (0x000000FF&((data)<<0))
#define MHL_CBUS_MSC_15_rapk_rcv_src(data)                                           ((0x000000FF&(data))>>0)
#define MHL_CBUS_MSC_15_get_rapk_rcv(data)                                           ((0x000000FF&(data))>>0)


#define MHL_CBUS_MSC_16                                                              0x18062DD8
#define MHL_CBUS_MSC_16_reg_addr                                                     "0xB8062DD8"
#define MHL_CBUS_MSC_16_reg                                                          0xB8062DD8
#define set_MHL_CBUS_MSC_16_reg(data)   (*((volatile unsigned int*) MHL_CBUS_MSC_16_reg)=data)
#define get_MHL_CBUS_MSC_16_reg   (*((volatile unsigned int*) MHL_CBUS_MSC_16_reg))
#define MHL_CBUS_MSC_16_inst_adr                                                     "0x0076"
#define MHL_CBUS_MSC_16_inst                                                         0x0076
#define MHL_CBUS_MSC_16_wb_id_chk_shift                                              (5)
#define MHL_CBUS_MSC_16_wb_id_chk_mask                                               (0x00000020)
#define MHL_CBUS_MSC_16_wb_id_chk(data)                                              (0x00000020&((data)<<5))
#define MHL_CBUS_MSC_16_wb_id_chk_src(data)                                          ((0x00000020&(data))>>5)
#define MHL_CBUS_MSC_16_get_wb_id_chk(data)                                          ((0x00000020&(data))>>5)


#define MHL_CBUS_MSC_17                                                              0x18062DDC
#define MHL_CBUS_MSC_17_reg_addr                                                     "0xB8062DDC"
#define MHL_CBUS_MSC_17_reg                                                          0xB8062DDC
#define set_MHL_CBUS_MSC_17_reg(data)   (*((volatile unsigned int*) MHL_CBUS_MSC_17_reg)=data)
#define get_MHL_CBUS_MSC_17_reg   (*((volatile unsigned int*) MHL_CBUS_MSC_17_reg))
#define MHL_CBUS_MSC_17_inst_adr                                                     "0x0077"
#define MHL_CBUS_MSC_17_inst                                                         0x0077
#define MHL_CBUS_MSC_17_adop_idh_rcv_shift                                           (8)
#define MHL_CBUS_MSC_17_adop_idh_rcv_mask                                            (0x0000FF00)
#define MHL_CBUS_MSC_17_adop_idh_rcv(data)                                           (0x0000FF00&((data)<<8))
#define MHL_CBUS_MSC_17_adop_idh_rcv_src(data)                                       ((0x0000FF00&(data))>>8)
#define MHL_CBUS_MSC_17_get_adop_idh_rcv(data)                                       ((0x0000FF00&(data))>>8)
#define MHL_CBUS_MSC_17_adop_idl_rcv_shift                                           (0)
#define MHL_CBUS_MSC_17_adop_idl_rcv_mask                                            (0x000000FF)
#define MHL_CBUS_MSC_17_adop_idl_rcv(data)                                           (0x000000FF&((data)<<0))
#define MHL_CBUS_MSC_17_adop_idl_rcv_src(data)                                       ((0x000000FF&(data))>>0)
#define MHL_CBUS_MSC_17_get_adop_idl_rcv(data)                                       ((0x000000FF&(data))>>0)


#define MHL_CBUS_MSC_18                                                              0x18062DE0
#define MHL_CBUS_MSC_18_reg_addr                                                     "0xB8062DE0"
#define MHL_CBUS_MSC_18_reg                                                          0xB8062DE0
#define set_MHL_CBUS_MSC_18_reg(data)   (*((volatile unsigned int*) MHL_CBUS_MSC_18_reg)=data)
#define get_MHL_CBUS_MSC_18_reg   (*((volatile unsigned int*) MHL_CBUS_MSC_18_reg))
#define MHL_CBUS_MSC_18_inst_adr                                                     "0x0078"
#define MHL_CBUS_MSC_18_inst                                                         0x0078


#define MHL_CBUS_MSC_19                                                              0x18062DE4
#define MHL_CBUS_MSC_19_reg_addr                                                     "0xB8062DE4"
#define MHL_CBUS_MSC_19_reg                                                          0xB8062DE4
#define set_MHL_CBUS_MSC_19_reg(data)   (*((volatile unsigned int*) MHL_CBUS_MSC_19_reg)=data)
#define get_MHL_CBUS_MSC_19_reg   (*((volatile unsigned int*) MHL_CBUS_MSC_19_reg))
#define MHL_CBUS_MSC_19_inst_adr                                                     "0x0079"
#define MHL_CBUS_MSC_19_inst                                                         0x0079


#define MHL_CBUS_MSC_1A                                                              0x18062DE8
#define MHL_CBUS_MSC_1A_reg_addr                                                     "0xB8062DE8"
#define MHL_CBUS_MSC_1A_reg                                                          0xB8062DE8
#define set_MHL_CBUS_MSC_1A_reg(data)   (*((volatile unsigned int*) MHL_CBUS_MSC_1A_reg)=data)
#define get_MHL_CBUS_MSC_1A_reg   (*((volatile unsigned int*) MHL_CBUS_MSC_1A_reg))
#define MHL_CBUS_MSC_1A_inst_adr                                                     "0x007A"
#define MHL_CBUS_MSC_1A_inst                                                         0x007A
#define MHL_CBUS_MSC_1A_msc_fsm_shift                                                (8)
#define MHL_CBUS_MSC_1A_msc_fsm_mask                                                 (0x00003F00)
#define MHL_CBUS_MSC_1A_msc_fsm(data)                                                (0x00003F00&((data)<<8))
#define MHL_CBUS_MSC_1A_msc_fsm_src(data)                                            ((0x00003F00&(data))>>8)
#define MHL_CBUS_MSC_1A_get_msc_fsm(data)                                            ((0x00003F00&(data))>>8)
#define MHL_CBUS_MSC_1A_ddc_fsm_shift                                                (0)
#define MHL_CBUS_MSC_1A_ddc_fsm_mask                                                 (0x0000003F)
#define MHL_CBUS_MSC_1A_ddc_fsm(data)                                                (0x0000003F&((data)<<0))
#define MHL_CBUS_MSC_1A_ddc_fsm_src(data)                                            ((0x0000003F&(data))>>0)
#define MHL_CBUS_MSC_1A_get_ddc_fsm(data)                                            ((0x0000003F&(data))>>0)


#define MHL_CBUS_MSC_1B                                                              0x18062DEC
#define MHL_CBUS_MSC_1B_reg_addr                                                     "0xB8062DEC"
#define MHL_CBUS_MSC_1B_reg                                                          0xB8062DEC
#define set_MHL_CBUS_MSC_1B_reg(data)   (*((volatile unsigned int*) MHL_CBUS_MSC_1B_reg)=data)
#define get_MHL_CBUS_MSC_1B_reg   (*((volatile unsigned int*) MHL_CBUS_MSC_1B_reg))
#define MHL_CBUS_MSC_1B_inst_adr                                                     "0x007B"
#define MHL_CBUS_MSC_1B_inst                                                         0x007B
#define MHL_CBUS_MSC_1B_cap_offset_shift                                             (0)
#define MHL_CBUS_MSC_1B_cap_offset_mask                                              (0x000000FF)
#define MHL_CBUS_MSC_1B_cap_offset(data)                                             (0x000000FF&((data)<<0))
#define MHL_CBUS_MSC_1B_cap_offset_src(data)                                         ((0x000000FF&(data))>>0)
#define MHL_CBUS_MSC_1B_get_cap_offset(data)                                         ((0x000000FF&(data))>>0)


#define MHL_CBUS_MSC_1C                                                              0x18062DF0
#define MHL_CBUS_MSC_1C_reg_addr                                                     "0xB8062DF0"
#define MHL_CBUS_MSC_1C_reg                                                          0xB8062DF0
#define set_MHL_CBUS_MSC_1C_reg(data)   (*((volatile unsigned int*) MHL_CBUS_MSC_1C_reg)=data)
#define get_MHL_CBUS_MSC_1C_reg   (*((volatile unsigned int*) MHL_CBUS_MSC_1C_reg))
#define MHL_CBUS_MSC_1C_inst_adr                                                     "0x007C"
#define MHL_CBUS_MSC_1C_inst                                                         0x007C
#define MHL_CBUS_MSC_1C_int_offset_shift                                             (0)
#define MHL_CBUS_MSC_1C_int_offset_mask                                              (0x000000FF)
#define MHL_CBUS_MSC_1C_int_offset(data)                                             (0x000000FF&((data)<<0))
#define MHL_CBUS_MSC_1C_int_offset_src(data)                                         ((0x000000FF&(data))>>0)
#define MHL_CBUS_MSC_1C_get_int_offset(data)                                         ((0x000000FF&(data))>>0)


#define MHL_CBUS_MSC_1D                                                              0x18062DF4
#define MHL_CBUS_MSC_1D_reg_addr                                                     "0xB8062DF4"
#define MHL_CBUS_MSC_1D_reg                                                          0xB8062DF4
#define set_MHL_CBUS_MSC_1D_reg(data)   (*((volatile unsigned int*) MHL_CBUS_MSC_1D_reg)=data)
#define get_MHL_CBUS_MSC_1D_reg   (*((volatile unsigned int*) MHL_CBUS_MSC_1D_reg))
#define MHL_CBUS_MSC_1D_inst_adr                                                     "0x007D"
#define MHL_CBUS_MSC_1D_inst                                                         0x007D
#define MHL_CBUS_MSC_1D_sta_offset_shift                                             (0)
#define MHL_CBUS_MSC_1D_sta_offset_mask                                              (0x000000FF)
#define MHL_CBUS_MSC_1D_sta_offset(data)                                             (0x000000FF&((data)<<0))
#define MHL_CBUS_MSC_1D_sta_offset_src(data)                                         ((0x000000FF&(data))>>0)
#define MHL_CBUS_MSC_1D_get_sta_offset(data)                                         ((0x000000FF&(data))>>0)


#define MHL_CBUS_MSC_1E                                                              0x18062DF8
#define MHL_CBUS_MSC_1E_reg_addr                                                     "0xB8062DF8"
#define MHL_CBUS_MSC_1E_reg                                                          0xB8062DF8
#define set_MHL_CBUS_MSC_1E_reg(data)   (*((volatile unsigned int*) MHL_CBUS_MSC_1E_reg)=data)
#define get_MHL_CBUS_MSC_1E_reg   (*((volatile unsigned int*) MHL_CBUS_MSC_1E_reg))
#define MHL_CBUS_MSC_1E_inst_adr                                                     "0x007E"
#define MHL_CBUS_MSC_1E_inst                                                         0x007E
#define MHL_CBUS_MSC_1E_scr_offset_shift                                             (0)
#define MHL_CBUS_MSC_1E_scr_offset_mask                                              (0x000000FF)
#define MHL_CBUS_MSC_1E_scr_offset(data)                                             (0x000000FF&((data)<<0))
#define MHL_CBUS_MSC_1E_scr_offset_src(data)                                         ((0x000000FF&(data))>>0)
#define MHL_CBUS_MSC_1E_get_scr_offset(data)                                         ((0x000000FF&(data))>>0)


#define MHL_CBUS_MSC_1F                                                              0x18062DFC
#define MHL_CBUS_MSC_1F_reg_addr                                                     "0xB8062DFC"
#define MHL_CBUS_MSC_1F_reg                                                          0xB8062DFC
#define set_MHL_CBUS_MSC_1F_reg(data)   (*((volatile unsigned int*) MHL_CBUS_MSC_1F_reg)=data)
#define get_MHL_CBUS_MSC_1F_reg   (*((volatile unsigned int*) MHL_CBUS_MSC_1F_reg))
#define MHL_CBUS_MSC_1F_inst_adr                                                     "0x007F"
#define MHL_CBUS_MSC_1F_inst                                                         0x007F
#define MHL_CBUS_MSC_1F_ddc_err_force_shift                                          (1)
#define MHL_CBUS_MSC_1F_ddc_err_force_mask                                           (0x00000002)
#define MHL_CBUS_MSC_1F_ddc_err_force(data)                                          (0x00000002&((data)<<1))
#define MHL_CBUS_MSC_1F_ddc_err_force_src(data)                                      ((0x00000002&(data))>>1)
#define MHL_CBUS_MSC_1F_get_ddc_err_force(data)                                      ((0x00000002&(data))>>1)
#define MHL_CBUS_MSC_1F_msc_err_force_shift                                          (0)
#define MHL_CBUS_MSC_1F_msc_err_force_mask                                           (0x00000001)
#define MHL_CBUS_MSC_1F_msc_err_force(data)                                          (0x00000001&((data)<<0))
#define MHL_CBUS_MSC_1F_msc_err_force_src(data)                                      ((0x00000001&(data))>>0)
#define MHL_CBUS_MSC_1F_get_msc_err_force(data)                                      ((0x00000001&(data))>>0)


#define MHL_CBUS_MSC_20                                                              0x18062E00
#define MHL_CBUS_MSC_20_reg_addr                                                     "0xB8062E00"
#define MHL_CBUS_MSC_20_reg                                                          0xB8062E00
#define set_MHL_CBUS_MSC_20_reg(data)   (*((volatile unsigned int*) MHL_CBUS_MSC_20_reg)=data)
#define get_MHL_CBUS_MSC_20_reg   (*((volatile unsigned int*) MHL_CBUS_MSC_20_reg))
#define MHL_CBUS_MSC_20_inst_adr                                                     "0x0080"
#define MHL_CBUS_MSC_20_inst                                                         0x0080
#define MHL_CBUS_MSC_20_ddc_err_fw_shift                                             (0)
#define MHL_CBUS_MSC_20_ddc_err_fw_mask                                              (0x000000FF)
#define MHL_CBUS_MSC_20_ddc_err_fw(data)                                             (0x000000FF&((data)<<0))
#define MHL_CBUS_MSC_20_ddc_err_fw_src(data)                                         ((0x000000FF&(data))>>0)
#define MHL_CBUS_MSC_20_get_ddc_err_fw(data)                                         ((0x000000FF&(data))>>0)


#define MHL_CBUS_MSC_21                                                              0x18062E04
#define MHL_CBUS_MSC_21_reg_addr                                                     "0xB8062E04"
#define MHL_CBUS_MSC_21_reg                                                          0xB8062E04
#define set_MHL_CBUS_MSC_21_reg(data)   (*((volatile unsigned int*) MHL_CBUS_MSC_21_reg)=data)
#define get_MHL_CBUS_MSC_21_reg   (*((volatile unsigned int*) MHL_CBUS_MSC_21_reg))
#define MHL_CBUS_MSC_21_inst_adr                                                     "0x0081"
#define MHL_CBUS_MSC_21_inst                                                         0x0081
#define MHL_CBUS_MSC_21_msc_err_fw_shift                                             (0)
#define MHL_CBUS_MSC_21_msc_err_fw_mask                                              (0x000000FF)
#define MHL_CBUS_MSC_21_msc_err_fw(data)                                             (0x000000FF&((data)<<0))
#define MHL_CBUS_MSC_21_msc_err_fw_src(data)                                         ((0x000000FF&(data))>>0)
#define MHL_CBUS_MSC_21_get_msc_err_fw(data)                                         ((0x000000FF&(data))>>0)


#define MHL_CBUS_MSC_22                                                              0x18062E08
#define MHL_CBUS_MSC_22_reg_addr                                                     "0xB8062E08"
#define MHL_CBUS_MSC_22_reg                                                          0xB8062E08
#define set_MHL_CBUS_MSC_22_reg(data)   (*((volatile unsigned int*) MHL_CBUS_MSC_22_reg)=data)
#define get_MHL_CBUS_MSC_22_reg   (*((volatile unsigned int*) MHL_CBUS_MSC_22_reg))
#define MHL_CBUS_MSC_22_inst_adr                                                     "0x0082"
#define MHL_CBUS_MSC_22_inst                                                         0x0082
#define MHL_CBUS_MSC_22_ucp_rcv_shift                                                (0)
#define MHL_CBUS_MSC_22_ucp_rcv_mask                                                 (0x000000FF)
#define MHL_CBUS_MSC_22_ucp_rcv(data)                                                (0x000000FF&((data)<<0))
#define MHL_CBUS_MSC_22_ucp_rcv_src(data)                                            ((0x000000FF&(data))>>0)
#define MHL_CBUS_MSC_22_get_ucp_rcv(data)                                            ((0x000000FF&(data))>>0)


#define MHL_CBUS_MSC_23                                                              0x18062E0C
#define MHL_CBUS_MSC_23_reg_addr                                                     "0xB8062E0C"
#define MHL_CBUS_MSC_23_reg                                                          0xB8062E0C
#define set_MHL_CBUS_MSC_23_reg(data)   (*((volatile unsigned int*) MHL_CBUS_MSC_23_reg)=data)
#define get_MHL_CBUS_MSC_23_reg   (*((volatile unsigned int*) MHL_CBUS_MSC_23_reg))
#define MHL_CBUS_MSC_23_inst_adr                                                     "0x0083"
#define MHL_CBUS_MSC_23_inst                                                         0x0083
#define MHL_CBUS_MSC_23_ucpk_rcv_shift                                               (0)
#define MHL_CBUS_MSC_23_ucpk_rcv_mask                                                (0x000000FF)
#define MHL_CBUS_MSC_23_ucpk_rcv(data)                                               (0x000000FF&((data)<<0))
#define MHL_CBUS_MSC_23_ucpk_rcv_src(data)                                           ((0x000000FF&(data))>>0)
#define MHL_CBUS_MSC_23_get_ucpk_rcv(data)                                           ((0x000000FF&(data))>>0)


#define MHL_CBUS_MSC_24                                                              0x18062E10
#define MHL_CBUS_MSC_24_reg_addr                                                     "0xB8062E10"
#define MHL_CBUS_MSC_24_reg                                                          0xB8062E10
#define set_MHL_CBUS_MSC_24_reg(data)   (*((volatile unsigned int*) MHL_CBUS_MSC_24_reg)=data)
#define get_MHL_CBUS_MSC_24_reg   (*((volatile unsigned int*) MHL_CBUS_MSC_24_reg))
#define MHL_CBUS_MSC_24_inst_adr                                                     "0x0084"
#define MHL_CBUS_MSC_24_inst                                                         0x0084
#define MHL_CBUS_MSC_24_ucpe_rcv_shift                                               (0)
#define MHL_CBUS_MSC_24_ucpe_rcv_mask                                                (0x000000FF)
#define MHL_CBUS_MSC_24_ucpe_rcv(data)                                               (0x000000FF&((data)<<0))
#define MHL_CBUS_MSC_24_ucpe_rcv_src(data)                                           ((0x000000FF&(data))>>0)
#define MHL_CBUS_MSC_24_get_ucpe_rcv(data)                                           ((0x000000FF&(data))>>0)


#define MHL_FW0_REQ_00                                                               0x18062E14
#define MHL_FW0_REQ_00_reg_addr                                                      "0xB8062E14"
#define MHL_FW0_REQ_00_reg                                                           0xB8062E14
#define set_MHL_FW0_REQ_00_reg(data)   (*((volatile unsigned int*) MHL_FW0_REQ_00_reg)=data)
#define get_MHL_FW0_REQ_00_reg   (*((volatile unsigned int*) MHL_FW0_REQ_00_reg))
#define MHL_FW0_REQ_00_inst_adr                                                      "0x0085"
#define MHL_FW0_REQ_00_inst                                                          0x0085
#define MHL_FW0_REQ_00_fw0_msg_processing_shift                                      (9)
#define MHL_FW0_REQ_00_fw0_msg_processing_mask                                       (0x00000200)
#define MHL_FW0_REQ_00_fw0_msg_processing(data)                                      (0x00000200&((data)<<9))
#define MHL_FW0_REQ_00_fw0_msg_processing_src(data)                                  ((0x00000200&(data))>>9)
#define MHL_FW0_REQ_00_get_fw0_msg_processing(data)                                  ((0x00000200&(data))>>9)
#define MHL_FW0_REQ_00_fw0_req_shift                                                 (8)
#define MHL_FW0_REQ_00_fw0_req_mask                                                  (0x00000100)
#define MHL_FW0_REQ_00_fw0_req(data)                                                 (0x00000100&((data)<<8))
#define MHL_FW0_REQ_00_fw0_req_src(data)                                             ((0x00000100&(data))>>8)
#define MHL_FW0_REQ_00_get_fw0_req(data)                                             ((0x00000100&(data))>>8)
#define MHL_FW0_REQ_00_fw0_fifo_full_shift                                           (6)
#define MHL_FW0_REQ_00_fw0_fifo_full_mask                                            (0x00000040)
#define MHL_FW0_REQ_00_fw0_fifo_full(data)                                           (0x00000040&((data)<<6))
#define MHL_FW0_REQ_00_fw0_fifo_full_src(data)                                       ((0x00000040&(data))>>6)
#define MHL_FW0_REQ_00_get_fw0_fifo_full(data)                                       ((0x00000040&(data))>>6)
#define MHL_FW0_REQ_00_fw0_fifo_empty_shift                                          (5)
#define MHL_FW0_REQ_00_fw0_fifo_empty_mask                                           (0x00000020)
#define MHL_FW0_REQ_00_fw0_fifo_empty(data)                                          (0x00000020&((data)<<5))
#define MHL_FW0_REQ_00_fw0_fifo_empty_src(data)                                      ((0x00000020&(data))>>5)
#define MHL_FW0_REQ_00_get_fw0_fifo_empty(data)                                      ((0x00000020&(data))>>5)


#define MHL_FW0_REQ_01                                                               0x18062E18
#define MHL_FW0_REQ_01_reg_addr                                                      "0xB8062E18"
#define MHL_FW0_REQ_01_reg                                                           0xB8062E18
#define set_MHL_FW0_REQ_01_reg(data)   (*((volatile unsigned int*) MHL_FW0_REQ_01_reg)=data)
#define get_MHL_FW0_REQ_01_reg   (*((volatile unsigned int*) MHL_FW0_REQ_01_reg))
#define MHL_FW0_REQ_01_inst_adr                                                      "0x0086"
#define MHL_FW0_REQ_01_inst                                                          0x0086
#define MHL_FW0_REQ_01_check_fw0_msg_processing_shift                                (12)
#define MHL_FW0_REQ_01_check_fw0_msg_processing_mask                                 (0x00001000)
#define MHL_FW0_REQ_01_check_fw0_msg_processing(data)                                (0x00001000&((data)<<12))
#define MHL_FW0_REQ_01_check_fw0_msg_processing_src(data)                            ((0x00001000&(data))>>12)
#define MHL_FW0_REQ_01_get_check_fw0_msg_processing(data)                            ((0x00001000&(data))>>12)
#define MHL_FW0_REQ_01_fw0_tx_case_shift                                             (8)
#define MHL_FW0_REQ_01_fw0_tx_case_mask                                              (0x00000700)
#define MHL_FW0_REQ_01_fw0_tx_case(data)                                             (0x00000700&((data)<<8))
#define MHL_FW0_REQ_01_fw0_tx_case_src(data)                                         ((0x00000700&(data))>>8)
#define MHL_FW0_REQ_01_get_fw0_tx_case(data)                                         ((0x00000700&(data))>>8)
#define MHL_FW0_REQ_01_fw0_cmd1_shift                                                (0)
#define MHL_FW0_REQ_01_fw0_cmd1_mask                                                 (0x000000FF)
#define MHL_FW0_REQ_01_fw0_cmd1(data)                                                (0x000000FF&((data)<<0))
#define MHL_FW0_REQ_01_fw0_cmd1_src(data)                                            ((0x000000FF&(data))>>0)
#define MHL_FW0_REQ_01_get_fw0_cmd1(data)                                            ((0x000000FF&(data))>>0)


#define MHL_FW0_REQ_02                                                               0x18062E1C
#define MHL_FW0_REQ_02_reg_addr                                                      "0xB8062E1C"
#define MHL_FW0_REQ_02_reg                                                           0xB8062E1C
#define set_MHL_FW0_REQ_02_reg(data)   (*((volatile unsigned int*) MHL_FW0_REQ_02_reg)=data)
#define get_MHL_FW0_REQ_02_reg   (*((volatile unsigned int*) MHL_FW0_REQ_02_reg))
#define MHL_FW0_REQ_02_inst_adr                                                      "0x0087"
#define MHL_FW0_REQ_02_inst                                                          0x0087
#define MHL_FW0_REQ_02_fw0_cmd2_shift                                                (0)
#define MHL_FW0_REQ_02_fw0_cmd2_mask                                                 (0x000000FF)
#define MHL_FW0_REQ_02_fw0_cmd2(data)                                                (0x000000FF&((data)<<0))
#define MHL_FW0_REQ_02_fw0_cmd2_src(data)                                            ((0x000000FF&(data))>>0)
#define MHL_FW0_REQ_02_get_fw0_cmd2(data)                                            ((0x000000FF&(data))>>0)


#define MHL_FW0_REQ_03                                                               0x18062E20
#define MHL_FW0_REQ_03_reg_addr                                                      "0xB8062E20"
#define MHL_FW0_REQ_03_reg                                                           0xB8062E20
#define set_MHL_FW0_REQ_03_reg(data)   (*((volatile unsigned int*) MHL_FW0_REQ_03_reg)=data)
#define get_MHL_FW0_REQ_03_reg   (*((volatile unsigned int*) MHL_FW0_REQ_03_reg))
#define MHL_FW0_REQ_03_inst_adr                                                      "0x0088"
#define MHL_FW0_REQ_03_inst                                                          0x0088
#define MHL_FW0_REQ_03_fw0_data1_shift                                               (16)
#define MHL_FW0_REQ_03_fw0_data1_mask                                                (0x00FF0000)
#define MHL_FW0_REQ_03_fw0_data1(data)                                               (0x00FF0000&((data)<<16))
#define MHL_FW0_REQ_03_fw0_data1_src(data)                                           ((0x00FF0000&(data))>>16)
#define MHL_FW0_REQ_03_get_fw0_data1(data)                                           ((0x00FF0000&(data))>>16)
#define MHL_FW0_REQ_03_fw0_data2_shift                                               (8)
#define MHL_FW0_REQ_03_fw0_data2_mask                                                (0x0000FF00)
#define MHL_FW0_REQ_03_fw0_data2(data)                                               (0x0000FF00&((data)<<8))
#define MHL_FW0_REQ_03_fw0_data2_src(data)                                           ((0x0000FF00&(data))>>8)
#define MHL_FW0_REQ_03_get_fw0_data2(data)                                           ((0x0000FF00&(data))>>8)
#define MHL_FW0_REQ_03_fw0_offset_shift                                              (0)
#define MHL_FW0_REQ_03_fw0_offset_mask                                               (0x000000FF)
#define MHL_FW0_REQ_03_fw0_offset(data)                                              (0x000000FF&((data)<<0))
#define MHL_FW0_REQ_03_fw0_offset_src(data)                                          ((0x000000FF&(data))>>0)
#define MHL_FW0_REQ_03_get_fw0_offset(data)                                          ((0x000000FF&(data))>>0)


#define MHL_FW0_REQ_04                                                               0x18062E24
#define MHL_FW0_REQ_04_reg_addr                                                      "0xB8062E24"
#define MHL_FW0_REQ_04_reg                                                           0xB8062E24
#define set_MHL_FW0_REQ_04_reg(data)   (*((volatile unsigned int*) MHL_FW0_REQ_04_reg)=data)
#define get_MHL_FW0_REQ_04_reg   (*((volatile unsigned int*) MHL_FW0_REQ_04_reg))
#define MHL_FW0_REQ_04_inst_adr                                                      "0x0089"
#define MHL_FW0_REQ_04_inst                                                          0x0089
#define MHL_FW0_REQ_04_fw0_data_shift                                                (0)
#define MHL_FW0_REQ_04_fw0_data_mask                                                 (0x000000FF)
#define MHL_FW0_REQ_04_fw0_data(data)                                                (0x000000FF&((data)<<0))
#define MHL_FW0_REQ_04_fw0_data_src(data)                                            ((0x000000FF&(data))>>0)
#define MHL_FW0_REQ_04_get_fw0_data(data)                                            ((0x000000FF&(data))>>0)


#define MHL_FW0_REQ_05                                                               0x18062E28
#define MHL_FW0_REQ_05_reg_addr                                                      "0xB8062E28"
#define MHL_FW0_REQ_05_reg                                                           0xB8062E28
#define set_MHL_FW0_REQ_05_reg(data)   (*((volatile unsigned int*) MHL_FW0_REQ_05_reg)=data)
#define get_MHL_FW0_REQ_05_reg   (*((volatile unsigned int*) MHL_FW0_REQ_05_reg))
#define MHL_FW0_REQ_05_inst_adr                                                      "0x008A"
#define MHL_FW0_REQ_05_inst                                                          0x008A
#define MHL_FW0_REQ_05_fw0_fifo_clr_shift                                            (31)
#define MHL_FW0_REQ_05_fw0_fifo_clr_mask                                             (0x80000000)
#define MHL_FW0_REQ_05_fw0_fifo_clr(data)                                            (0x80000000&((data)<<31))
#define MHL_FW0_REQ_05_fw0_fifo_clr_src(data)                                        ((0x80000000&(data))>>31)
#define MHL_FW0_REQ_05_get_fw0_fifo_clr(data)                                        ((0x80000000&(data))>>31)
#define MHL_FW0_REQ_05_fw0_fifo_len_shift                                            (8)
#define MHL_FW0_REQ_05_fw0_fifo_len_mask                                             (0x00000F00)
#define MHL_FW0_REQ_05_fw0_fifo_len(data)                                            (0x00000F00&((data)<<8))
#define MHL_FW0_REQ_05_fw0_fifo_len_src(data)                                        ((0x00000F00&(data))>>8)
#define MHL_FW0_REQ_05_get_fw0_fifo_len(data)                                        ((0x00000F00&(data))>>8)
#define MHL_FW0_REQ_05_irq_en_fw0_rcv_err_shift                                      (5)
#define MHL_FW0_REQ_05_irq_en_fw0_rcv_err_mask                                       (0x00000020)
#define MHL_FW0_REQ_05_irq_en_fw0_rcv_err(data)                                      (0x00000020&((data)<<5))
#define MHL_FW0_REQ_05_irq_en_fw0_rcv_err_src(data)                                  ((0x00000020&(data))>>5)
#define MHL_FW0_REQ_05_get_irq_en_fw0_rcv_err(data)                                  ((0x00000020&(data))>>5)
#define MHL_FW0_REQ_05_irq_en_fw0_fin_shift                                          (4)
#define MHL_FW0_REQ_05_irq_en_fw0_fin_mask                                           (0x00000010)
#define MHL_FW0_REQ_05_irq_en_fw0_fin(data)                                          (0x00000010&((data)<<4))
#define MHL_FW0_REQ_05_irq_en_fw0_fin_src(data)                                      ((0x00000010&(data))>>4)
#define MHL_FW0_REQ_05_get_irq_en_fw0_fin(data)                                      ((0x00000010&(data))>>4)
#define MHL_FW0_REQ_05_irq_en_fw0_cmd_shift                                          (3)
#define MHL_FW0_REQ_05_irq_en_fw0_cmd_mask                                           (0x00000008)
#define MHL_FW0_REQ_05_irq_en_fw0_cmd(data)                                          (0x00000008&((data)<<3))
#define MHL_FW0_REQ_05_irq_en_fw0_cmd_src(data)                                      ((0x00000008&(data))>>3)
#define MHL_FW0_REQ_05_get_irq_en_fw0_cmd(data)                                      ((0x00000008&(data))>>3)
#define MHL_FW0_REQ_05_irq_en_fw0_data_shift                                         (2)
#define MHL_FW0_REQ_05_irq_en_fw0_data_mask                                          (0x00000004)
#define MHL_FW0_REQ_05_irq_en_fw0_data(data)                                         (0x00000004&((data)<<2))
#define MHL_FW0_REQ_05_irq_en_fw0_data_src(data)                                     ((0x00000004&(data))>>2)
#define MHL_FW0_REQ_05_get_irq_en_fw0_data(data)                                     ((0x00000004&(data))>>2)


#define MHL_FW0_REQ_06                                                               0x18062E2C
#define MHL_FW0_REQ_06_reg_addr                                                      "0xB8062E2C"
#define MHL_FW0_REQ_06_reg                                                           0xB8062E2C
#define set_MHL_FW0_REQ_06_reg(data)   (*((volatile unsigned int*) MHL_FW0_REQ_06_reg)=data)
#define get_MHL_FW0_REQ_06_reg   (*((volatile unsigned int*) MHL_FW0_REQ_06_reg))
#define MHL_FW0_REQ_06_inst_adr                                                      "0x008B"
#define MHL_FW0_REQ_06_inst                                                          0x008B
#define MHL_FW0_REQ_06_fw0_cmd_rcv_shift                                             (0)
#define MHL_FW0_REQ_06_fw0_cmd_rcv_mask                                              (0x000000FF)
#define MHL_FW0_REQ_06_fw0_cmd_rcv(data)                                             (0x000000FF&((data)<<0))
#define MHL_FW0_REQ_06_fw0_cmd_rcv_src(data)                                         ((0x000000FF&(data))>>0)
#define MHL_FW0_REQ_06_get_fw0_cmd_rcv(data)                                         ((0x000000FF&(data))>>0)


#define MHL_FW0_REQ_07                                                               0x18062E30
#define MHL_FW0_REQ_07_reg_addr                                                      "0xB8062E30"
#define MHL_FW0_REQ_07_reg                                                           0xB8062E30
#define set_MHL_FW0_REQ_07_reg(data)   (*((volatile unsigned int*) MHL_FW0_REQ_07_reg)=data)
#define get_MHL_FW0_REQ_07_reg   (*((volatile unsigned int*) MHL_FW0_REQ_07_reg))
#define MHL_FW0_REQ_07_inst_adr                                                      "0x008C"
#define MHL_FW0_REQ_07_inst                                                          0x008C
#define MHL_FW0_REQ_07_fw0_data_rcv_shift                                            (0)
#define MHL_FW0_REQ_07_fw0_data_rcv_mask                                             (0x000000FF)
#define MHL_FW0_REQ_07_fw0_data_rcv(data)                                            (0x000000FF&((data)<<0))
#define MHL_FW0_REQ_07_fw0_data_rcv_src(data)                                        ((0x000000FF&(data))>>0)
#define MHL_FW0_REQ_07_get_fw0_data_rcv(data)                                        ((0x000000FF&(data))>>0)


#define MHL_FW0_REQ_08                                                               0x18062E34
#define MHL_FW0_REQ_08_reg_addr                                                      "0xB8062E34"
#define MHL_FW0_REQ_08_reg                                                           0xB8062E34
#define set_MHL_FW0_REQ_08_reg(data)   (*((volatile unsigned int*) MHL_FW0_REQ_08_reg)=data)
#define get_MHL_FW0_REQ_08_reg   (*((volatile unsigned int*) MHL_FW0_REQ_08_reg))
#define MHL_FW0_REQ_08_inst_adr                                                      "0x008D"
#define MHL_FW0_REQ_08_inst                                                          0x008D
#define MHL_FW0_REQ_08_fw0_rdata_shift                                               (0)
#define MHL_FW0_REQ_08_fw0_rdata_mask                                                (0x000000FF)
#define MHL_FW0_REQ_08_fw0_rdata(data)                                               (0x000000FF&((data)<<0))
#define MHL_FW0_REQ_08_fw0_rdata_src(data)                                           ((0x000000FF&(data))>>0)
#define MHL_FW0_REQ_08_get_fw0_rdata(data)                                           ((0x000000FF&(data))>>0)


#define MHL_FW0_REQ_09                                                               0x18062E38
#define MHL_FW0_REQ_09_reg_addr                                                      "0xB8062E38"
#define MHL_FW0_REQ_09_reg                                                           0xB8062E38
#define set_MHL_FW0_REQ_09_reg(data)   (*((volatile unsigned int*) MHL_FW0_REQ_09_reg)=data)
#define get_MHL_FW0_REQ_09_reg   (*((volatile unsigned int*) MHL_FW0_REQ_09_reg))
#define MHL_FW0_REQ_09_inst_adr                                                      "0x008E"
#define MHL_FW0_REQ_09_inst                                                          0x008E
#define MHL_FW0_REQ_09_irq_fw0_fin_shift                                             (8)
#define MHL_FW0_REQ_09_irq_fw0_fin_mask                                              (0x00000100)
#define MHL_FW0_REQ_09_irq_fw0_fin(data)                                             (0x00000100&((data)<<8))
#define MHL_FW0_REQ_09_irq_fw0_fin_src(data)                                         ((0x00000100&(data))>>8)
#define MHL_FW0_REQ_09_get_irq_fw0_fin(data)                                         ((0x00000100&(data))>>8)
#define MHL_FW0_REQ_09_irq_fw0_cmd_shift                                             (7)
#define MHL_FW0_REQ_09_irq_fw0_cmd_mask                                              (0x00000080)
#define MHL_FW0_REQ_09_irq_fw0_cmd(data)                                             (0x00000080&((data)<<7))
#define MHL_FW0_REQ_09_irq_fw0_cmd_src(data)                                         ((0x00000080&(data))>>7)
#define MHL_FW0_REQ_09_get_irq_fw0_cmd(data)                                         ((0x00000080&(data))>>7)
#define MHL_FW0_REQ_09_irq_fw0_data_shift                                            (6)
#define MHL_FW0_REQ_09_irq_fw0_data_mask                                             (0x00000040)
#define MHL_FW0_REQ_09_irq_fw0_data(data)                                            (0x00000040&((data)<<6))
#define MHL_FW0_REQ_09_irq_fw0_data_src(data)                                        ((0x00000040&(data))>>6)
#define MHL_FW0_REQ_09_get_irq_fw0_data(data)                                        ((0x00000040&(data))>>6)
#define MHL_FW0_REQ_09_irq_fw0_rcv_err_shift                                         (5)
#define MHL_FW0_REQ_09_irq_fw0_rcv_err_mask                                          (0x00000020)
#define MHL_FW0_REQ_09_irq_fw0_rcv_err(data)                                         (0x00000020&((data)<<5))
#define MHL_FW0_REQ_09_irq_fw0_rcv_err_src(data)                                     ((0x00000020&(data))>>5)
#define MHL_FW0_REQ_09_get_irq_fw0_rcv_err(data)                                     ((0x00000020&(data))>>5)


#define MHL_CBUS_DDC_00                                                              0x18062E3C
#define MHL_CBUS_DDC_00_reg_addr                                                     "0xB8062E3C"
#define MHL_CBUS_DDC_00_reg                                                          0xB8062E3C
#define set_MHL_CBUS_DDC_00_reg(data)   (*((volatile unsigned int*) MHL_CBUS_DDC_00_reg)=data)
#define get_MHL_CBUS_DDC_00_reg   (*((volatile unsigned int*) MHL_CBUS_DDC_00_reg))
#define MHL_CBUS_DDC_00_inst_adr                                                     "0x008F"
#define MHL_CBUS_DDC_00_inst                                                         0x008F
#define MHL_CBUS_DDC_00_ddc_req_shift                                                (31)
#define MHL_CBUS_DDC_00_ddc_req_mask                                                 (0x80000000)
#define MHL_CBUS_DDC_00_ddc_req(data)                                                (0x80000000&((data)<<31))
#define MHL_CBUS_DDC_00_ddc_req_src(data)                                            ((0x80000000&(data))>>31)
#define MHL_CBUS_DDC_00_get_ddc_req(data)                                            ((0x80000000&(data))>>31)
#define MHL_CBUS_DDC_00_irq_ddc_err_update_shift                                     (9)
#define MHL_CBUS_DDC_00_irq_ddc_err_update_mask                                      (0x00000200)
#define MHL_CBUS_DDC_00_irq_ddc_err_update(data)                                     (0x00000200&((data)<<9))
#define MHL_CBUS_DDC_00_irq_ddc_err_update_src(data)                                 ((0x00000200&(data))>>9)
#define MHL_CBUS_DDC_00_get_irq_ddc_err_update(data)                                 ((0x00000200&(data))>>9)
#define MHL_CBUS_DDC_00_irq_ddc_data_shift                                           (8)
#define MHL_CBUS_DDC_00_irq_ddc_data_mask                                            (0x00000100)
#define MHL_CBUS_DDC_00_irq_ddc_data(data)                                           (0x00000100&((data)<<8))
#define MHL_CBUS_DDC_00_irq_ddc_data_src(data)                                       ((0x00000100&(data))>>8)
#define MHL_CBUS_DDC_00_get_irq_ddc_data(data)                                       ((0x00000100&(data))>>8)
#define MHL_CBUS_DDC_00_ddc_err_code_shift                                           (0)
#define MHL_CBUS_DDC_00_ddc_err_code_mask                                            (0x000000FF)
#define MHL_CBUS_DDC_00_ddc_err_code(data)                                           (0x000000FF&((data)<<0))
#define MHL_CBUS_DDC_00_ddc_err_code_src(data)                                       ((0x000000FF&(data))>>0)
#define MHL_CBUS_DDC_00_get_ddc_err_code(data)                                       ((0x000000FF&(data))>>0)


#define MHL_CBUS_DDC_01                                                              0x18062E40
#define MHL_CBUS_DDC_01_reg_addr                                                     "0xB8062E40"
#define MHL_CBUS_DDC_01_reg                                                          0xB8062E40
#define set_MHL_CBUS_DDC_01_reg(data)   (*((volatile unsigned int*) MHL_CBUS_DDC_01_reg)=data)
#define get_MHL_CBUS_DDC_01_reg   (*((volatile unsigned int*) MHL_CBUS_DDC_01_reg))
#define MHL_CBUS_DDC_01_inst_adr                                                     "0x0090"
#define MHL_CBUS_DDC_01_inst                                                         0x0090
#define MHL_CBUS_DDC_01_ddc_idle_resp_abort_shift                                    (31)
#define MHL_CBUS_DDC_01_ddc_idle_resp_abort_mask                                     (0x80000000)
#define MHL_CBUS_DDC_01_ddc_idle_resp_abort(data)                                    (0x80000000&((data)<<31))
#define MHL_CBUS_DDC_01_ddc_idle_resp_abort_src(data)                                ((0x80000000&(data))>>31)
#define MHL_CBUS_DDC_01_get_ddc_idle_resp_abort(data)                                ((0x80000000&(data))>>31)
#define MHL_CBUS_DDC_01_ddc_err_update_no_err_shift                                  (30)
#define MHL_CBUS_DDC_01_ddc_err_update_no_err_mask                                   (0x40000000)
#define MHL_CBUS_DDC_01_ddc_err_update_no_err(data)                                  (0x40000000&((data)<<30))
#define MHL_CBUS_DDC_01_ddc_err_update_no_err_src(data)                              ((0x40000000&(data))>>30)
#define MHL_CBUS_DDC_01_get_ddc_err_update_no_err(data)                              ((0x40000000&(data))>>30)
#define MHL_CBUS_DDC_01_irq_en_ddc_err_update_shift                                  (29)
#define MHL_CBUS_DDC_01_irq_en_ddc_err_update_mask                                   (0x20000000)
#define MHL_CBUS_DDC_01_irq_en_ddc_err_update(data)                                  (0x20000000&((data)<<29))
#define MHL_CBUS_DDC_01_irq_en_ddc_err_update_src(data)                              ((0x20000000&(data))>>29)
#define MHL_CBUS_DDC_01_get_irq_en_ddc_err_update(data)                              ((0x20000000&(data))>>29)
#define MHL_CBUS_DDC_01_ddc_addr_w_shift                                             (16)
#define MHL_CBUS_DDC_01_ddc_addr_w_mask                                              (0x00FF0000)
#define MHL_CBUS_DDC_01_ddc_addr_w(data)                                             (0x00FF0000&((data)<<16))
#define MHL_CBUS_DDC_01_ddc_addr_w_src(data)                                         ((0x00FF0000&(data))>>16)
#define MHL_CBUS_DDC_01_get_ddc_addr_w(data)                                         ((0x00FF0000&(data))>>16)
#define MHL_CBUS_DDC_01_ddc_addr_r_shift                                             (8)
#define MHL_CBUS_DDC_01_ddc_addr_r_mask                                              (0x0000FF00)
#define MHL_CBUS_DDC_01_ddc_addr_r(data)                                             (0x0000FF00&((data)<<8))
#define MHL_CBUS_DDC_01_ddc_addr_r_src(data)                                         ((0x0000FF00&(data))>>8)
#define MHL_CBUS_DDC_01_get_ddc_addr_r(data)                                         ((0x0000FF00&(data))>>8)


#define MHL_CBUS_DDC_02                                                              0x18062E44
#define MHL_CBUS_DDC_02_reg_addr                                                     "0xB8062E44"
#define MHL_CBUS_DDC_02_reg                                                          0xB8062E44
#define set_MHL_CBUS_DDC_02_reg(data)   (*((volatile unsigned int*) MHL_CBUS_DDC_02_reg)=data)
#define get_MHL_CBUS_DDC_02_reg   (*((volatile unsigned int*) MHL_CBUS_DDC_02_reg))
#define MHL_CBUS_DDC_02_inst_adr                                                     "0x0091"
#define MHL_CBUS_DDC_02_inst                                                         0x0091
#define MHL_CBUS_DDC_02_ddc_req_type_shift                                           (12)
#define MHL_CBUS_DDC_02_ddc_req_type_mask                                            (0x00003000)
#define MHL_CBUS_DDC_02_ddc_req_type(data)                                           (0x00003000&((data)<<12))
#define MHL_CBUS_DDC_02_ddc_req_type_src(data)                                       ((0x00003000&(data))>>12)
#define MHL_CBUS_DDC_02_get_ddc_req_type(data)                                       ((0x00003000&(data))>>12)
#define MHL_CBUS_DDC_02_mcuddc_need_resp_shift                                       (8)
#define MHL_CBUS_DDC_02_mcuddc_need_resp_mask                                        (0x00000100)
#define MHL_CBUS_DDC_02_mcuddc_need_resp(data)                                       (0x00000100&((data)<<8))
#define MHL_CBUS_DDC_02_mcuddc_need_resp_src(data)                                   ((0x00000100&(data))>>8)
#define MHL_CBUS_DDC_02_get_mcuddc_need_resp(data)                                   ((0x00000100&(data))>>8)
#define MHL_CBUS_DDC_02_mcuddc_en_shift                                              (7)
#define MHL_CBUS_DDC_02_mcuddc_en_mask                                               (0x00000080)
#define MHL_CBUS_DDC_02_mcuddc_en(data)                                              (0x00000080&((data)<<7))
#define MHL_CBUS_DDC_02_mcuddc_en_src(data)                                          ((0x00000080&(data))>>7)
#define MHL_CBUS_DDC_02_get_mcuddc_en(data)                                          ((0x00000080&(data))>>7)
#define MHL_CBUS_DDC_02_irq_en_ddc_data_shift                                        (2)
#define MHL_CBUS_DDC_02_irq_en_ddc_data_mask                                         (0x00000004)
#define MHL_CBUS_DDC_02_irq_en_ddc_data(data)                                        (0x00000004&((data)<<2))
#define MHL_CBUS_DDC_02_irq_en_ddc_data_src(data)                                    ((0x00000004&(data))>>2)
#define MHL_CBUS_DDC_02_get_irq_en_ddc_data(data)                                    ((0x00000004&(data))>>2)
#define MHL_CBUS_DDC_02_ddc_req_ctrl_shift                                           (1)
#define MHL_CBUS_DDC_02_ddc_req_ctrl_mask                                            (0x00000002)
#define MHL_CBUS_DDC_02_ddc_req_ctrl(data)                                           (0x00000002&((data)<<1))
#define MHL_CBUS_DDC_02_ddc_req_ctrl_src(data)                                       ((0x00000002&(data))>>1)
#define MHL_CBUS_DDC_02_get_ddc_req_ctrl(data)                                       ((0x00000002&(data))>>1)


#define MHL_CBUS_DDC_03                                                              0x18062E48
#define MHL_CBUS_DDC_03_reg_addr                                                     "0xB8062E48"
#define MHL_CBUS_DDC_03_reg                                                          0xB8062E48
#define set_MHL_CBUS_DDC_03_reg(data)   (*((volatile unsigned int*) MHL_CBUS_DDC_03_reg)=data)
#define get_MHL_CBUS_DDC_03_reg   (*((volatile unsigned int*) MHL_CBUS_DDC_03_reg))
#define MHL_CBUS_DDC_03_inst_adr                                                     "0x0092"
#define MHL_CBUS_DDC_03_inst                                                         0x0092
#define MHL_CBUS_DDC_03_ddc_cmd_fw_shift                                             (0)
#define MHL_CBUS_DDC_03_ddc_cmd_fw_mask                                              (0x000000FF)
#define MHL_CBUS_DDC_03_ddc_cmd_fw(data)                                             (0x000000FF&((data)<<0))
#define MHL_CBUS_DDC_03_ddc_cmd_fw_src(data)                                         ((0x000000FF&(data))>>0)
#define MHL_CBUS_DDC_03_get_ddc_cmd_fw(data)                                         ((0x000000FF&(data))>>0)


#define MHL_CBUS_DDC_04                                                              0x18062E4C
#define MHL_CBUS_DDC_04_reg_addr                                                     "0xB8062E4C"
#define MHL_CBUS_DDC_04_reg                                                          0xB8062E4C
#define set_MHL_CBUS_DDC_04_reg(data)   (*((volatile unsigned int*) MHL_CBUS_DDC_04_reg)=data)
#define get_MHL_CBUS_DDC_04_reg   (*((volatile unsigned int*) MHL_CBUS_DDC_04_reg))
#define MHL_CBUS_DDC_04_inst_adr                                                     "0x0093"
#define MHL_CBUS_DDC_04_inst                                                         0x0093
#define MHL_CBUS_DDC_04_ddc_rcv_data_shift                                           (0)
#define MHL_CBUS_DDC_04_ddc_rcv_data_mask                                            (0x000001FF)
#define MHL_CBUS_DDC_04_ddc_rcv_data(data)                                           (0x000001FF&((data)<<0))
#define MHL_CBUS_DDC_04_ddc_rcv_data_src(data)                                       ((0x000001FF&(data))>>0)
#define MHL_CBUS_DDC_04_get_ddc_rcv_data(data)                                       ((0x000001FF&(data))>>0)


#define MHL_CBUS_DDC_05                                                              0x18062E50
#define MHL_CBUS_DDC_05_reg_addr                                                     "0xB8062E50"
#define MHL_CBUS_DDC_05_reg                                                          0xB8062E50
#define set_MHL_CBUS_DDC_05_reg(data)   (*((volatile unsigned int*) MHL_CBUS_DDC_05_reg)=data)
#define get_MHL_CBUS_DDC_05_reg   (*((volatile unsigned int*) MHL_CBUS_DDC_05_reg))
#define MHL_CBUS_DDC_05_inst_adr                                                     "0x0094"
#define MHL_CBUS_DDC_05_inst                                                         0x0094
#define MHL_CBUS_DDC_05_ddc_data_fw_shift                                            (0)
#define MHL_CBUS_DDC_05_ddc_data_fw_mask                                             (0x000000FF)
#define MHL_CBUS_DDC_05_ddc_data_fw(data)                                            (0x000000FF&((data)<<0))
#define MHL_CBUS_DDC_05_ddc_data_fw_src(data)                                        ((0x000000FF&(data))>>0)
#define MHL_CBUS_DDC_05_get_ddc_data_fw(data)                                        ((0x000000FF&(data))>>0)


#define MHL_CBUS_DDC_06                                                              0x18062E54
#define MHL_CBUS_DDC_06_reg_addr                                                     "0xB8062E54"
#define MHL_CBUS_DDC_06_reg                                                          0xB8062E54
#define set_MHL_CBUS_DDC_06_reg(data)   (*((volatile unsigned int*) MHL_CBUS_DDC_06_reg)=data)
#define get_MHL_CBUS_DDC_06_reg   (*((volatile unsigned int*) MHL_CBUS_DDC_06_reg))
#define MHL_CBUS_DDC_06_inst_adr                                                     "0x0095"
#define MHL_CBUS_DDC_06_inst                                                         0x0095
#define MHL_CBUS_DDC_06_ddc_offset_shift                                             (16)
#define MHL_CBUS_DDC_06_ddc_offset_mask                                              (0x00FF0000)
#define MHL_CBUS_DDC_06_ddc_offset(data)                                             (0x00FF0000&((data)<<16))
#define MHL_CBUS_DDC_06_ddc_offset_src(data)                                         ((0x00FF0000&(data))>>16)
#define MHL_CBUS_DDC_06_get_ddc_offset(data)                                         ((0x00FF0000&(data))>>16)
#define MHL_CBUS_DDC_06_ddc_seg_val_shift                                            (8)
#define MHL_CBUS_DDC_06_ddc_seg_val_mask                                             (0x0000FF00)
#define MHL_CBUS_DDC_06_ddc_seg_val(data)                                            (0x0000FF00&((data)<<8))
#define MHL_CBUS_DDC_06_ddc_seg_val_src(data)                                        ((0x0000FF00&(data))>>8)
#define MHL_CBUS_DDC_06_get_ddc_seg_val(data)                                        ((0x0000FF00&(data))>>8)
#define MHL_CBUS_DDC_06_ddc_addr_0x60_shift                                          (0)
#define MHL_CBUS_DDC_06_ddc_addr_0x60_mask                                           (0x000000FF)
#define MHL_CBUS_DDC_06_ddc_addr_0x60(data)                                          (0x000000FF&((data)<<0))
#define MHL_CBUS_DDC_06_ddc_addr_0x60_src(data)                                      ((0x000000FF&(data))>>0)
#define MHL_CBUS_DDC_06_get_ddc_addr_0x60(data)                                      ((0x000000FF&(data))>>0)


#define MHL_CBUS_WDOG                                                                0x18062E58
#define MHL_CBUS_WDOG_reg_addr                                                       "0xB8062E58"
#define MHL_CBUS_WDOG_reg                                                            0xB8062E58
#define set_MHL_CBUS_WDOG_reg(data)   (*((volatile unsigned int*) MHL_CBUS_WDOG_reg)=data)
#define get_MHL_CBUS_WDOG_reg   (*((volatile unsigned int*) MHL_CBUS_WDOG_reg))
#define MHL_CBUS_WDOG_inst_adr                                                       "0x0096"
#define MHL_CBUS_WDOG_inst                                                           0x0096
#define MHL_CBUS_WDOG_cbus_busy_shift                                                (4)
#define MHL_CBUS_WDOG_cbus_busy_mask                                                 (0x00000010)
#define MHL_CBUS_WDOG_cbus_busy(data)                                                (0x00000010&((data)<<4))
#define MHL_CBUS_WDOG_cbus_busy_src(data)                                            ((0x00000010&(data))>>4)
#define MHL_CBUS_WDOG_get_cbus_busy(data)                                            ((0x00000010&(data))>>4)
#define MHL_CBUS_WDOG_link_busy_shift                                                (3)
#define MHL_CBUS_WDOG_link_busy_mask                                                 (0x00000008)
#define MHL_CBUS_WDOG_link_busy(data)                                                (0x00000008&((data)<<3))
#define MHL_CBUS_WDOG_link_busy_src(data)                                            ((0x00000008&(data))>>3)
#define MHL_CBUS_WDOG_get_link_busy(data)                                            ((0x00000008&(data))>>3)
#define MHL_CBUS_WDOG_translation_busy_shift                                         (2)
#define MHL_CBUS_WDOG_translation_busy_mask                                          (0x00000004)
#define MHL_CBUS_WDOG_translation_busy(data)                                         (0x00000004&((data)<<2))
#define MHL_CBUS_WDOG_translation_busy_src(data)                                     ((0x00000004&(data))>>2)
#define MHL_CBUS_WDOG_get_translation_busy(data)                                     ((0x00000004&(data))>>2)
#define MHL_CBUS_WDOG_ddc_busy_shift                                                 (1)
#define MHL_CBUS_WDOG_ddc_busy_mask                                                  (0x00000002)
#define MHL_CBUS_WDOG_ddc_busy(data)                                                 (0x00000002&((data)<<1))
#define MHL_CBUS_WDOG_ddc_busy_src(data)                                             ((0x00000002&(data))>>1)
#define MHL_CBUS_WDOG_get_ddc_busy(data)                                             ((0x00000002&(data))>>1)
#define MHL_CBUS_WDOG_msc_busy_shift                                                 (0)
#define MHL_CBUS_WDOG_msc_busy_mask                                                  (0x00000001)
#define MHL_CBUS_WDOG_msc_busy(data)                                                 (0x00000001&((data)<<0))
#define MHL_CBUS_WDOG_msc_busy_src(data)                                             ((0x00000001&(data))>>0)
#define MHL_CBUS_WDOG_get_msc_busy(data)                                             ((0x00000001&(data))>>0)


#define MHL_CBUS_INT_EN                                                              0x18062E5C
#define MHL_CBUS_INT_EN_reg_addr                                                     "0xB8062E5C"
#define MHL_CBUS_INT_EN_reg                                                          0xB8062E5C
#define set_MHL_CBUS_INT_EN_reg(data)   (*((volatile unsigned int*) MHL_CBUS_INT_EN_reg)=data)
#define get_MHL_CBUS_INT_EN_reg   (*((volatile unsigned int*) MHL_CBUS_INT_EN_reg))
#define MHL_CBUS_INT_EN_inst_adr                                                     "0x0097"
#define MHL_CBUS_INT_EN_inst                                                         0x0097


#define MHL_CBUS_INT_INDEX                                                           0x18062E60
#define MHL_CBUS_INT_INDEX_reg_addr                                                  "0xB8062E60"
#define MHL_CBUS_INT_INDEX_reg                                                       0xB8062E60
#define set_MHL_CBUS_INT_INDEX_reg(data)   (*((volatile unsigned int*) MHL_CBUS_INT_INDEX_reg)=data)
#define get_MHL_CBUS_INT_INDEX_reg   (*((volatile unsigned int*) MHL_CBUS_INT_INDEX_reg))
#define MHL_CBUS_INT_INDEX_inst_adr                                                  "0x0098"
#define MHL_CBUS_INT_INDEX_inst                                                      0x0098
#define MHL_CBUS_INT_INDEX_irq_discovery_shift                                       (6)
#define MHL_CBUS_INT_INDEX_irq_discovery_mask                                        (0x00000040)
#define MHL_CBUS_INT_INDEX_irq_discovery(data)                                       (0x00000040&((data)<<6))
#define MHL_CBUS_INT_INDEX_irq_discovery_src(data)                                   ((0x00000040&(data))>>6)
#define MHL_CBUS_INT_INDEX_get_irq_discovery(data)                                   ((0x00000040&(data))>>6)
#define MHL_CBUS_INT_INDEX_irq_link_shift                                            (5)
#define MHL_CBUS_INT_INDEX_irq_link_mask                                             (0x00000020)
#define MHL_CBUS_INT_INDEX_irq_link(data)                                            (0x00000020&((data)<<5))
#define MHL_CBUS_INT_INDEX_irq_link_src(data)                                        ((0x00000020&(data))>>5)
#define MHL_CBUS_INT_INDEX_get_irq_link(data)                                        ((0x00000020&(data))>>5)
#define MHL_CBUS_INT_INDEX_irq_ddc_shift                                             (4)
#define MHL_CBUS_INT_INDEX_irq_ddc_mask                                              (0x00000010)
#define MHL_CBUS_INT_INDEX_irq_ddc(data)                                             (0x00000010&((data)<<4))
#define MHL_CBUS_INT_INDEX_irq_ddc_src(data)                                         ((0x00000010&(data))>>4)
#define MHL_CBUS_INT_INDEX_get_irq_ddc(data)                                         ((0x00000010&(data))>>4)
#define MHL_CBUS_INT_INDEX_irq_msc_ch_shift                                          (3)
#define MHL_CBUS_INT_INDEX_irq_msc_ch_mask                                           (0x00000008)
#define MHL_CBUS_INT_INDEX_irq_msc_ch(data)                                          (0x00000008&((data)<<3))
#define MHL_CBUS_INT_INDEX_irq_msc_ch_src(data)                                      ((0x00000008&(data))>>3)
#define MHL_CBUS_INT_INDEX_get_irq_msc_ch(data)                                      ((0x00000008&(data))>>3)
#define MHL_CBUS_INT_INDEX_irq_msc_int_shift                                         (2)
#define MHL_CBUS_INT_INDEX_irq_msc_int_mask                                          (0x00000004)
#define MHL_CBUS_INT_INDEX_irq_msc_int(data)                                         (0x00000004&((data)<<2))
#define MHL_CBUS_INT_INDEX_irq_msc_int_src(data)                                     ((0x00000004&(data))>>2)
#define MHL_CBUS_INT_INDEX_get_irq_msc_int(data)                                     ((0x00000004&(data))>>2)
#define MHL_CBUS_INT_INDEX_irq_msc_stat_shift                                        (1)
#define MHL_CBUS_INT_INDEX_irq_msc_stat_mask                                         (0x00000002)
#define MHL_CBUS_INT_INDEX_irq_msc_stat(data)                                        (0x00000002&((data)<<1))
#define MHL_CBUS_INT_INDEX_irq_msc_stat_src(data)                                    ((0x00000002&(data))>>1)
#define MHL_CBUS_INT_INDEX_get_irq_msc_stat(data)                                    ((0x00000002&(data))>>1)


#define MHL_CBUS_TEST                                                                0x18062E64
#define MHL_CBUS_TEST_reg_addr                                                       "0xB8062E64"
#define MHL_CBUS_TEST_reg                                                            0xB8062E64
#define set_MHL_CBUS_TEST_reg(data)   (*((volatile unsigned int*) MHL_CBUS_TEST_reg)=data)
#define get_MHL_CBUS_TEST_reg   (*((volatile unsigned int*) MHL_CBUS_TEST_reg))
#define MHL_CBUS_TEST_inst_adr                                                       "0x0099"
#define MHL_CBUS_TEST_inst                                                           0x0099
#define MHL_CBUS_TEST_fw_r10k_en_shift                                               (16)
#define MHL_CBUS_TEST_fw_r10k_en_mask                                                (0x00030000)
#define MHL_CBUS_TEST_fw_r10k_en(data)                                               (0x00030000&((data)<<16))
#define MHL_CBUS_TEST_fw_r10k_en_src(data)                                           ((0x00030000&(data))>>16)
#define MHL_CBUS_TEST_get_fw_r10k_en(data)                                           ((0x00030000&(data))>>16)
#define MHL_CBUS_TEST_fw_control_r10k_shift                                          (13)
#define MHL_CBUS_TEST_fw_control_r10k_mask                                           (0x00002000)
#define MHL_CBUS_TEST_fw_control_r10k(data)                                          (0x00002000&((data)<<13))
#define MHL_CBUS_TEST_fw_control_r10k_src(data)                                      ((0x00002000&(data))>>13)
#define MHL_CBUS_TEST_get_fw_control_r10k(data)                                      ((0x00002000&(data))>>13)
#define MHL_CBUS_TEST_fw_cbus_drive_shift                                            (12)
#define MHL_CBUS_TEST_fw_cbus_drive_mask                                             (0x00001000)
#define MHL_CBUS_TEST_fw_cbus_drive(data)                                            (0x00001000&((data)<<12))
#define MHL_CBUS_TEST_fw_cbus_drive_src(data)                                        ((0x00001000&(data))>>12)
#define MHL_CBUS_TEST_get_fw_cbus_drive(data)                                        ((0x00001000&(data))>>12)
#define MHL_CBUS_TEST_fw_cbus_level_shift                                            (11)
#define MHL_CBUS_TEST_fw_cbus_level_mask                                             (0x00000800)
#define MHL_CBUS_TEST_fw_cbus_level(data)                                            (0x00000800&((data)<<11))
#define MHL_CBUS_TEST_fw_cbus_level_src(data)                                        ((0x00000800&(data))>>11)
#define MHL_CBUS_TEST_get_fw_cbus_level(data)                                        ((0x00000800&(data))>>11)
#define MHL_CBUS_TEST_fw_out_shift                                                   (10)
#define MHL_CBUS_TEST_fw_out_mask                                                    (0x00000400)
#define MHL_CBUS_TEST_fw_out(data)                                                   (0x00000400&((data)<<10))
#define MHL_CBUS_TEST_fw_out_src(data)                                               ((0x00000400&(data))>>10)
#define MHL_CBUS_TEST_get_fw_out(data)                                               ((0x00000400&(data))>>10)
#define MHL_CBUS_TEST_cbus_test_md_shift                                             (8)
#define MHL_CBUS_TEST_cbus_test_md_mask                                              (0x00000300)
#define MHL_CBUS_TEST_cbus_test_md(data)                                             (0x00000300&((data)<<8))
#define MHL_CBUS_TEST_cbus_test_md_src(data)                                         ((0x00000300&(data))>>8)
#define MHL_CBUS_TEST_get_cbus_test_md(data)                                         ((0x00000300&(data))>>8)
#define MHL_CBUS_TEST_dbg_en_shift                                                   (4)
#define MHL_CBUS_TEST_dbg_en_mask                                                    (0x00000010)
#define MHL_CBUS_TEST_dbg_en(data)                                                   (0x00000010&((data)<<4))
#define MHL_CBUS_TEST_dbg_en_src(data)                                               ((0x00000010&(data))>>4)
#define MHL_CBUS_TEST_get_dbg_en(data)                                               ((0x00000010&(data))>>4)
#define MHL_CBUS_TEST_dbg_sel_shift                                                  (0)
#define MHL_CBUS_TEST_dbg_sel_mask                                                   (0x0000000F)
#define MHL_CBUS_TEST_dbg_sel(data)                                                  (0x0000000F&((data)<<0))
#define MHL_CBUS_TEST_dbg_sel_src(data)                                              ((0x0000000F&(data))>>0)
#define MHL_CBUS_TEST_get_dbg_sel(data)                                              ((0x0000000F&(data))>>0)


#define MHL_CBUS_DUMMY0                                                              0x18062E68
#define MHL_CBUS_DUMMY0_reg_addr                                                     "0xB8062E68"
#define MHL_CBUS_DUMMY0_reg                                                          0xB8062E68
#define set_MHL_CBUS_DUMMY0_reg(data)   (*((volatile unsigned int*) MHL_CBUS_DUMMY0_reg)=data)
#define get_MHL_CBUS_DUMMY0_reg   (*((volatile unsigned int*) MHL_CBUS_DUMMY0_reg))
#define MHL_CBUS_DUMMY0_inst_adr                                                     "0x009A"
#define MHL_CBUS_DUMMY0_inst                                                         0x009A
#define MHL_CBUS_DUMMY0_Dmy_shift                                                    (0)
#define MHL_CBUS_DUMMY0_Dmy_mask                                                     (0xFFFFFFFF)
#define MHL_CBUS_DUMMY0_Dmy(data)                                                    (0xFFFFFFFF&((data)<<0))
#define MHL_CBUS_DUMMY0_Dmy_src(data)                                                ((0xFFFFFFFF&(data))>>0)
#define MHL_CBUS_DUMMY0_get_Dmy(data)                                                ((0xFFFFFFFF&(data))>>0)


#endif