#ifndef _QC_VERIFY_SE_H_
#define _QC_VERIFY_SE_H_
//#if CONFIG_FT
#if 1

#define SE_MEMORY_BASE				(0x45000000)
#define SE_INSTALL_UI_SURFACE2_ADDR		(SE_MEMORY_BASE)
#define SE_INSTALL_UI_SURFACE1_ADDR		(SE_MEMORY_BASE+0x7e9000)
#define SE_CMD_BUFFER_START_ADDR		(SE_MEMORY_BASE-0x1000000)
#define SE_INSTALL_UI_SURFACE2_ADDR_DUMMY_STCH	(SE_MEMORY_BASE+0x1001000)
/*End is about..SE_MEMORY_BASE+0x1004000*/

#else
#define SE_INSTALL_UI_SURFACE1_ADDR (0x16500000)
#define SE_INSTALL_UI_SURFACE2_ADDR (0x16500000+0x7e9000)
#define SE_CMD_BUFFER_START_ADDR (0x16400000)
#define SE_INSTALL_UI_SURFACE2_ADDR_DUMMY_STCH (0x16500000+1920*1080*4)

#endif

#define SE_SURFACE_PITCH        (1920*4)
#define SE_SURFACE_ROTATE_PITCH		(1080*4)
#define SE_SURFACE_W            (1920)
#define SE_SURFACE_H            (1080)

#if TEST_IN_AP

#define true                    1
#define false                   0
#define FAILED                  -1
#define assert(n)               while(1);

typedef unsigned int            uint32_t;
typedef unsigned short int      uint16_t;
typedef unsigned char           uint8_t;
//typedef unsigned char           bool;
typedef unsigned int            RBus_UInt32;
typedef int                     int32_t;
typedef long                    HRESULT;

//The Definition of Write Register Command for Columbus Streaming Engine
HRESULT SE_WriteRegister(SEINFO_CMDQUEUE byCommandQueue,        //Select Specific Command Queue
                         SEINFO_REGMODE  bRegisterModeSelect,   //Select Write Mode for Register/CLUT
                         SEINFO_WRITEREG wRegisterAddress,      //Set Write Address of Register/CLUT
                         uint32_t        dwRegisterValue);      //Set Specific Data for Write Register Command)
HRESULT SE_ExecCmd(SEINFO_CMDQUEUE       byCommandQueue);
extern "C" size_t se_write(uint32_t hQueue, uint8_t *pbyCommandBuffer, int dwCommandLength, int inst_count, int loc);
extern "C" void se_waitforcomplete(void);

SURFACEHANDLE g_hSurface[2] = {0,0};

#else

//#define SE_INSTALL_UI_SURFACE1_ADDR (0x02100000)   // size is 0x7e9000
//#define SE_INSTALL_UI_SURFACE2_ADDR (0x02900000)   // size is 0x465000
//#define SE_CMD_BUFFER_START_ADDR    (0x03100000)   // size is 0x4000
// use GPU qc mem
//#define GPU_PATTERN_OUT_ADDR      0x16400000 //0x7000000
//#define SE_INSTALL_UI_SURFACE1_ADDR (0x16500000)
//#define SE_INSTALL_UI_SURFACE2_ADDR (0x16500000+0x7e9000)
//#define SE_CMD_BUFFER_START_ADDR (0x16400000)

//#define SE_INSTALL_UI_SURFACE2_ADDR_DUMMY_STCH (0x16500000+1920*1080*4)

#define SE_CMD_SHIFT            (0xC0000000)
#define SE_CMD_SIZE             (0x4000)
#define SE_CMD_DELAY_MS_ATOMIC  (1)

#define SE_TEXT_SHIFT           (0)


#define FONT_COLOR              (0x0000FeFF)   //blue
#define FONT_COLOR_AA           (0x0000Fedd)   //blue

#define FONT_COLOR_AA2          (0x0000f1aa)   //blue

#define FONT_COLOR_BG           (0x99CCFFFF)

#define TEXT_SURFACE            SE_INSTALL_UI_SURFACE2_ADDR
#define WORD_HEIGHT             (80)

#if 0
#define  SE_CMDBASE_VADDR_reg                       (0xb800c000)
#define  SE_CMDLMT_VADDR_reg                        (0xb800c010)
#define  SE_CMDRPTR_VADDR_reg                       (0xb800c020)
#define  SE_CMDWPTR_VADDR_reg                       (0xb800c030)
#define  SE_SRWORDCNT_VADDR_reg                     (0xb800c040)
#define  SE_Q_PRIORITY_VADDR_reg                    (0xb800c050)
#define  SE_CLR_FMT_VADDR_reg                       (0xb800c060)
#define  SE_COLOR_KEY_VADDR_reg                     (0xb800c070)
#define  SE_DST_COLOR_KEY_VADDR_reg                 (0xb800c080)
#define  SE_SRC_COLOR_VADDR_reg                     (0xb800c090)
#define  SE_SRC_ALPHA_VADDR_reg                     (0xb800c0a0)
#define  SE_DEST_ALPHA_VADDR_reg                    (0xb800c0b0)
#define  SE_RSLT_ALPHA_VADDR_reg                    (0xb800c0c0)
#define  SE_BADDR1_VADDR_reg                        (0xb800c0d0)
#define  SE_PITCH1_VADDR_reg                        (0xb800c0e0)
#define  SE_BADDR2_VADDR_reg                        (0xb800c0f0)
#define  SE_PITCH2_VADDR_reg                        (0xb800c100)
#define  SE_CLUT_LOCK_ST_VADDR_reg                  (0xb800c1d0)
#define  SE_CONVSCALING_VADDR_reg                   (0xb800c1e0)
#define  SE_CONVCOEF1_VADDR_reg                     (0xb800c1f0)
#define  SE_CONVCOEF2_VADDR_reg                     (0xb800c200)
#define  SE_CONVCOEF3_VADDR_reg                     (0xb800c210)
#define  SE_CONVCOEF4_VADDR_reg                     (0xb800c220)
#define  SE_CONVCOEF5_VADDR_reg                     (0xb800c230)
#define  SE_CONVCOEF6_VADDR_reg                     (0xb800c240)
#define  SE_FCV_BITBLIT_COLOR_KEY_VADDR_reg         (0xb800c250)
#define  SE_SRC_CLR_RED_VADDR_reg                   (0xb800c260)
#define  SE_SRC_CLR_GREEN_VADDR_reg                 (0xb800c270)
#define  SE_SRC_CLR_BLUE_VADDR_reg                  (0xb800c280)
#define  SE_SRC_CLR_ALPHA_VADDR_reg                 (0xb800c290)
#define  SE_SYNC_VO_MARGIN_VADDR_reg                (0xb800c2a0)
#define  SE_SYNC_VO_LOCATION_VADDR_reg              (0xb800c2b0)
#define  SE_FB_COLORALPHA_VADDR_reg                 (0xb800cb50)
#define  SE_STRETCH_VADDR_reg                       (0xb800c2c0)
#define  SE_HDHS_VADDR_reg                          (0xb800c2d0)
#define  SE_VDHS_VADDR_reg                          (0xb800c2e0)
#define  SE_HCOEF1_VADDR_reg                        (0xb800c300)
#define  SE_HCOEF1_32_VADDR_reg                     (0xb800c380)
#define  SE_VCOEF1_VADDR_reg                        (0xb800c400)
#define  SE_VCOEF1_16_VADDR_reg                     (0xb800c440)
#define  SE_HCOEF2_VADDR_reg                        (0xb800c480)
#define  SE_HCOEF2_32_VADDR_reg                     (0xb800c500)
#define  SE_VCOEF2_VADDR_reg                        (0xb800c580)
#define  SE_VCOEF2_16_VADDR_reg                     (0xb800c5c0)
#define  SE_SC_BITBLIT_COLOR_KEY_VADDR_reg          (0xb800c900)
#define  SE_QT_INV_MATRIX_SCALING_VADDR_reg         (0xb800cb00)
#define  SE_QT_INV_MATRIX_SHEARING_VADDR_reg        (0xb800cb10)
#define  SE_QT_INV_MATRIX_MOVING_VADDR_reg          (0xb800cb20)
#define  SE_QT_INV_MATRIX_PROJECTION_0_VADDR_reg    (0xb800cb30)
#define  SE_QT_INV_MATRIX_PROJECTION_1_VADDR_reg    (0xb800cb40)
#define  SE_SRC_LG_2_VADDR_reg                      (0xb800cc20)
#define  SE_SRC_LG_3_VADDR_reg                      (0xb800cc30)
#define  SE_SRC_LG_4_VADDR_reg                      (0xb800cc40)
#define  SE_SRC_LG_5_VADDR_reg                      (0xb800cc50)
#define  SE_SRC_LG_6_VADDR_reg                      (0xb800cc60)
#define  SE_CTRL_VADDR_reg                          (0xb800c960)
#define  SE_IDLE_VADDR_reg                          (0xb800c970)
#define  SE_INTSEL_VADDR_reg                        (0xb800c980)
#define  SE_INTS_VADDR_reg                          (0xb800c990)
#define  SE_INTE_VADDR_reg                          (0xb800c9a0)
#define  SE_INSTCNT_L_VADDR_reg                     (0xb800c9b0)
#define  SE_INSTCNT_H_VADDR_reg                     (0xb800c9c0)
#define  SE_CLUT_RADR_VADDR_reg                     (0xb800c9d0)
#define  SE_CLUT_VALUE_VADDR_reg                    (0xb800c9d4)
#define  SE_DBG_VADDR_reg                           (0xb800c9d8)
#define  SE_SCTCH_VADDR_reg                         (0xb800c9dc)
#define  SE_GCRA_CTRL_VADDR_reg                     (0xb800c9e0)
#define  SE_GCRA_REQ_CNT_VADDR_reg                  (0xb800c9e4)
#define  SE_GCRA_TIM_CNT_VADDR_reg                  (0xb800c9e8)
#define  SE_GCRA_TIM_THR_VADDR_reg                  (0xb800c9ec)
#define  SE_GCRA_REQ_THR_VADDR_reg                  (0xb800c9f0)
#define  SE_READ_MARGIN_VADDR_reg                   (0xb800ca00)
#define  SE_BIST_MODE_VADDR_reg                     (0xb800ca04)
#define  SE_BIST_DONE_VADDR_reg                     (0xb800ca08)
#define  SE_BIST_FAIL_GROUP_VADDR_reg               (0xb800ca0c)
#define  SE_BIST_0_FAIL_VADDR_reg                   (0xb800ca10)
#define  SE_BIST_1_FAIL_VADDR_reg                   (0xb800ca14)
#define  SE_DRF_MODE_VADDR_reg                      (0xb800ca18)
#define  SE_DRF_RESUME_VADDR_reg                    (0xb800ca1c)
#define  SE_DRF_DONE_VADDR_reg                      (0xb800ca20)
#define  SE_DRF_PAUSE_VADDR_reg                     (0xb800ca24)
#define  SE_DRF_FAIL_GROUP_VADDR_reg                (0xb800ca28)
#define  SE_DRF_0_FAIL_VADDR_reg                    (0xb800ca2c)
#define  SE_DRF_1_FAIL_VADDR_reg                    (0xb800ca30)
#endif
//=============================================================================Draw API
#define SEINFO_ERROR_INTERRUPT_STATUS_MASK      0x0000FFF4    //Interrupt Mask of Error Status

#define SEINFO_STRETCH_COEFF_TABLE_MAX_TAP      3       //Maximum Number of TAP Fields
#define SEINFO_STRETCH_COEFF_TABLE_MAX_RATIO    5       //Maximum Number of Ratio Fields
#define SEINFO_STRETCH_COEFF_TABLE_MAX_COEFF    32      //Maximum Number of Coefficient Fields

#define SEINFO_STRETCH_VSCALING_COEFF_MAX       16      //Maximum Number of Vertical Scaling Coefficient Fields
#define SEINFO_STRETCH_HSCALING_COEFF_MAX       16      //Maximum Number of Horizontal Scaling Coefficient Fields

#define SEINFO_STRETCH_DELTA_PHASE              163840000   //Base Value of Delta Phase: 2^14

#define SEINFO_STRETCH_SECTION_1                30000   //Coefficient Range 1 in Stretch Command
#define SEINFO_STRETCH_SECTION_2                60000   //Coefficient Range 2 in Stretch Command

//=================================================================================================
typedef enum _SEINFO_OPCODE
{
    SEINFO_OPCODE_WRITE_REGISTER    = 0x01, //The Definition of Command Code: Write Register
    SEINFO_OPCODE_FETCH_CLUT        = 0x02, //The Definition of Command Code: Fetch CLUT
    SEINFO_OPCODE_FORMAT_CONVERSION = 0x03, //The Definition of Command Code: Format Conversion
    SEINFO_OPCODE_DRAW_LINE         = 0x04, //The Definition of Command Code: Draw Line
    SEINFO_OPCODE_LOCK_CLUT         = 0x04, //The Definition of Command Code: Lock CLUT. Defind on Saturn.
    SEINFO_OPCODE_BITBLT            = 0x05, //The Definition of Command Code: Bitblit
    SEINFO_OPCODE_STRETCH           = 0x06, //The Definition of Command Code: Stretch
    SEINFO_OPCODE_MIRROR            = 0x07, //The Definition of Command Code: Mirror
    SEINFO_OPCODE_DECODE_DVB        = 0x08, //The Definition of Command Code: Decode_DVB
    SEINFO_OPCODE_WAIT_VO_VSYNC     = 0x08, //The Definition of Command Code: Wait VO VSync. Defined on Saturn
#if 1
    SEINFO_OPCODE_REPEAT_BITBLIT    = 0x09, //Repeat Bitblit operation
#else
    SEINFO_OPCODE_DECODE_BDRLE      = 0x09, //The Definition of Command Code: Decode_BDRLE
#endif
    SEINFO_OPCODE_ROTATE            = 0x0A, //The Definition of Command Code: Rotate
#if 1
    SEINFO_OPCODE_QTRANSFORM        = 0x0B,
    SEINFO_OPCODE_LINEAR_GRADIENT   = 0x0C,
#else
    SEINFO_OPCODE_FELICS            = 0x0B, //The Definition of Command Code: Felics
    SEINFO_OPCODE_BITMAP            = 0x0C, //The Definition of Command Code: Bitmap
#endif
    SEINFO_OPCODE_DECIMATE          = 0x0D, //The Definition of Command Code: Decimate
    SEINFO_OPCODE_BIBLIT_EX         = 0x0D, //The Definition of Command Code: Bitblit with source color transform or directFB. Defined on Saturn.
    SEINFO_OPCODE_ALPHA             = 0x0E, //The Definition of Command Code: Alpha
    SEINFO_OPCODE_NOP               = 0x0F  //The Definition of Command Code: NOP
} SEINFO_OPCODE;

//=================================================================================================
#define    SEINFO_COMMAND_QUEUE0 0  //The Definition of Command Queue Type: Command Queue 0
#define    SEINFO_COMMAND_QUEUE1 1  //The Definition of Command Queue Type: Command Queue 1
#define    SEINFO_COMMAND_QUEUE2 2  //The Definition of Command Queue Type: Command Queue 2
typedef int SEINFO_CMDQUEUE;

#if 0
typedef enum _SEINFO_CMDQUEUE
{
   SEINFO_COMMAND_QUEUE0 = 0,   //The Definition of Command Queue Type: Command Queue 0
   SEINFO_COMMAND_QUEUE1 = 1,   //The Definition of Command Queue Type: Command Queue 1
   SEINFO_COMMAND_QUEUE2 = 2    //The Definition of Command Queue Type: Command Queue 2
} SEINFO_CMDQUEUE;
#endif

//=================================================================================================
typedef enum _SEINFO_DMAINFO
{
    SEINFO_DMA_CHANNEL0 = 0,    //The Definition of DMA Channel Type: DMA Channel 0
    SEINFO_DMA_CHANNEL1 = 1,    //The Definition of DMA Channel Type: DMA Channel 1
    SEINFO_DMA_CHANNEL2 = 2,    //The Definition of DMA Channel Type: DMA Channel 2
    SEINFO_DMA_CHANNEL3 = 3     //The Definition of DMA Channel Type: DMA Channel 3
} SEINFO_DMAINFO;

//=================================================================================================
typedef enum _SEINFO_CLIPPINGINFO
{
    SEINFO_CLIPPING_CHANNEL0 = 0,   //The Definition of Clipping Channel Type: Clipping Channel 0
    SEINFO_CLIPPING_CHANNEL1 = 1,   //The Definition of Clipping Channel Type: Clipping Channel 1
    SEINFO_CLIPPING_CHANNEL2 = 2,   //The Definition of Clipping Channel Type: Clipping Channel 2
    SEINFO_CLIPPING_CHANNEL3 = 3    //The Definition of Clipping Channel Type: Clipping Channel 3
} SEINFO_CLIPPINGINFO;

//=================================================================================================
typedef enum _SEINFO_CPU
{
    SEINFO_SCPU = 0,    //The Indicator of System CPU
    SEINFO_VCPU = 1,
#if 1
    SEINFO_VCPU2 = 2
#endif
} SEINFO_CPU;

//=================================================================================================
typedef enum _SEINFO_REGMODE
{
    SEINFO_REGMODE_REGISTER = 0,    //The Definition of Register Mode: Register
    SEINFO_REGMODE_CLUT     = 1 //The Definition of Register Mode: CLUT
} SEINFO_REGMODE;

//=================================================================================================
typedef enum _SEINFO_WRITEREG
{
	SEINFO_REG_COLOR_FORMAT = 0x060,
	SEINFO_REG_COLOR_KEY = 0x070,
	SEINFO_REG_DEST_COLOR_KEY = 0x80,
	SEINFO_REG_SRC_COLOR = 0x0D0,
	SEINFO_REG_SRC_ALPHA = 0x0E0,
	SEINFO_REG_DEST_ALPHA = 0x0F0,
	SEINFO_REG_RESULT_ALPHA = 0x100,
	SEINFO_REG_RESULT_COLOR = 0x110,
	SEINFO_REG_BASE_ADDR1 = 0x180,
	SEINFO_REG_PITCH1 = 0x190,
	SEINFO_REG_BASE_ADDR2 = 0x1a0,
	SEINFO_REG_PITCH2 = 0x1b0,
	SEINFO_REG_LOCK_CLUT = 0x1C0,
	SEINFO_REG_CONV_SCALING = 0x1D0,
	SEINFO_REG_CONV_COEF1 = 0x1E0,
	SEINFO_REG_CONV_COEF2 = 0x1F0,
	SEINFO_REG_CONV_COEF3 = 0x200,
	SEINFO_REG_CONV_COEF4 = 0x210,
	SEINFO_REG_CONV_COEF5 = 0x220,
	SEINFO_REG_CONV_COEF6 = 0x230,
	SEINFO_REG_FORMAT_CONVERT_BITBLIT_COLOR_KEY = 0x240,
	SEINFO_REG_SRC_CLR_RED = 0x250,
	SEINFO_REG_SRC_CLR_GREEN = 0x260,
	SEINFO_REG_SRC_CLR_BLUE = 0x270,
	SEINFO_REG_SRC_CLR_ALPHA = 0x280,
	SEINFO_REG_DFB_COLORALPHA = 0x2C0,
	SEINFO_REG_STRETCH = 0x2F0,
	SEINFO_REG_HDHS = 0x300,
	SEINFO_REG_VDHS = 0x310,
	SE20INFO_REG_STRETCH = 0x320,
	SE20INFO_REG_HDHS = 0x330,
	SE20INFO_REG_VDHS = 0x340,
	SEINFO_REG_HCOEF1 = 0x380,
	SEINFO_REG_HCOEF1_32  = 0x400,
	SEINFO_REG_VCOEF1 = 0x480,
	SEINFO_REG_VCOEF1_16  = 0x4C0,
	SEINFO_REG_HCOEF2 = 0x500,
	SEINFO_REG_HCOEF2_32  = 0x580,
	SEINFO_REG_VCOEF2 = 0x600,
	SEINFO_REG_VCOEF2_16  = 0x640,
	SE20INFO_REG_HCOEF1_32 = 0x680,
	SE20INFO_REG_HCOEF1_32_2 = 0x780,
	SE20INFO_REG_VCOEF1_32 = 0x880,
	SE20INFO_REG_VCOEF1_32_2 = 0x980,
	SEINFO_REG_SC_BITBLIT_COLOR_KEY = 0xA80,
	SE20INFO_REG_BASE_ADDR0 = 0xB80,
	SE20INFO_REG_BASE_ADDR1 = 0xB90,
	SE20INFO_REG_BASE_ADDR2 = 0xBA0,
	SE20INFO_REG_BASE_ADDR3 = 0xBB0,
	SE20INFO_REG_BASE_ADDR4 = 0xBC0,
	SE20INFO_REG_BASE_ADDR5 = 0xBD0,
	SE20INFO_REG_BASE_ADDR6 = 0xBE0,
	SE20INFO_REG_BASE_ADDR7 = 0xBF0,
	SE20INFO_REG_BASE_ADDR8 = 0xC00,
	SE20INFO_REG_BASE_ADDR9 = 0xC10,
	SE20INFO_REG_BASE_ADDR10 = 0xC20,
	SE20INFO_REG_BASE_ADDR11 = 0xC30,
	SE20INFO_REG_BASE_ADDR12 = 0xC40,
	SE20INFO_REG_BASE_ADDR13 = 0xC50,
	SE20INFO_REG_BASE_ADDR14 = 0xC60,
	SE20INFO_REG_BASE_ADDR15 = 0xC70,
	SE20INFO_REG_PITCH0 = 0xC80,
	SE20INFO_REG_PITCH1 = 0xC90,
	SE20INFO_REG_PITCH2 = 0xCA0,
	SE20INFO_REG_PITCH3 = 0xCB0,
	SE20INFO_REG_PITCH4 = 0xCC0,
	SE20INFO_REG_PITCH5 = 0xCD0,
	SE20INFO_REG_PITCH6 = 0xCE0,
	SE20INFO_REG_PITCH7 = 0xCF0,
	SE20INFO_REG_PITCH8 = 0xD00,
	SE20INFO_REG_PITCH9 = 0xD10,
	SE20INFO_REG_PITCH10 = 0xD20,
	SE20INFO_REG_PITCH11 = 0xD30,
	SE20INFO_REG_PITCH12 = 0xD40,
	SE20INFO_REG_PITCH13 = 0xD50,
	SE20INFO_REG_PITCH14 = 0xD60,
	SE20INFO_REG_PITCH15 = 0xD70,
	SEINFO_REG_SWAP_FBDC = 0xD80,
	SEINFO_REG_SE20_DUMMY = 0xE20,
	SEINFO_REG_CTRL = 0xE80,
	SEINFO_REG_IDLE = 0xE90,

} SEINFO_WRITEREG;

//=================================================================================================
typedef enum _SEINFO_ROPCODE
{
    SEINFO_ROPCODE_BLACK    = 0,                //black
    SEINFO_ROPCODE_AND      = 1,                //A AND B
    SEINFO_ROPCODE_AND_NOT  = 2,                //A AND ~B
    SEINFO_ROPCODE_COPY     = 3,                //A(COPY)
    SEINFO_ROPCODE_NOT_AND  = 4,                //~A AND B
    SEINFO_ROPCODE_B        = 5,                //B (NOP)
    SEINFO_ROPCODE_XOR      = 6,                //XOR
    SEINFO_ROPCODE_OR       = 7,                //OR
    SEINFO_ROPCODE_NOR      = 8,                //NOR
    SEINFO_ROPCODE_XNOR     = 9,                //XNOR
    SEINFO_ROPCODE_NOT_B    = 10,               //~B
    SEINFO_ROPCODE_OR_NOT   = 11,               //A OR ~B
    SEINFO_ROPCODE_NOT_A    = 12,               //~A
    SEINFO_ROPCODE_NOT_OR   = 13,               //~A OR B
    SEINFO_ROPCODE_NAND     = 14,               //NAND
    SEINFO_ROPCODE_WHITE    = 15,               //WHITE
    SEINFO_ROPCODE_NONE     = SEINFO_ROPCODE_B  //The Definition of ROP Code: Disable

} SEINFO_ROPCODE;

//=================================================================================================
typedef enum _SEINFO_DFB_OPERATION //Saturn Spec, page 32, command Bitblit, word 2, field: ROP code
{
    SEINFO_DFB_OP_WRITE_TMP_SRC_DATA_TO_DDR = 0,    // Write temporal source data to DDR.
    SEINFO_DFB_OP_COPY_SRC_DATA_TO_DEST     = 1,    // Copy source data to destination.
    SEINFO_DFB_OP_DISABLED                  = 4     // Disable this feature.
} SEINFO_DFB_OPERATION;

//=================================================================================================
typedef enum _SEINFO_MIRRORMODE
{
    SEINFO_MIRROR_X  = 1,   //The Definition of Mirror Mode: X Only
    SEINFO_MIRROR_Y  = 2,   //The Definition of Mirror Mode: Y Only
    SEINFO_MIRROR_XY = 3    //The Definition of Mirror Mode: X and Y
} SEINFO_MIRRORMODE;

//=================================================================================================
typedef enum _SEINFO_CLUT
{
    SEINFO_FETCH_CLUT_4ARGB   = 0,  //The Definition of CLUT Mode: 4 Entries ARGB for Index2 Format
    SEINFO_FETCH_CLUT_16ARGB  = 1,  //The Definition of CLUT Mode: 16 Entries ARGB for Index4 Format
    SEINFO_FETCH_CLUT_256ARGB = 2   //The Definition of CLUT Mode: 256 Entries ARGB for Index8 Format
} SEINFO_CLUT;

//=================================================================================================
typedef enum _SEINFO_SETUPMODE
{
    SEINFO_BITBLT_SETUP_CONST  = 0, //The Definition of Setup Mode: Constant Mode (Refer to Register SE_Src_Color/SE_Src_Alpha)
    SEINFO_BITBLT_SETUP_MANUAL = 1  //The Definition of Setup Mode: Manual Mode
} SEINFO_SETUPMODE;

//=================================================================================================
typedef enum _SEINFO_VSCALING_EN
{
    SEINFO_VSCALING_ENABLE  = true,     //Enable Vertical Scaling Operation
    SEINFO_VSCALING_DISABLE = false     //Disable Vertical Scaling Operation
} SEINFO_VSCALING_EN;

//=================================================================================================
typedef enum _SEINFO_HSCALING_EN
{
    SEINFO_HSCALING_ENABLE  = true,     //Enable Horizontal Scaling Operation
    SEINFO_HSCALING_DISABLE = false     //Disable Horizontal Scaling Operation
} SEINFO_HSCALING_EN;

//=================================================================================================
typedef enum _SEINFO_ALPHAPROC_EN
{
    SEINFO_ALPHAPROC_ENABLE  = true,    //Enable Alpha Operation
    SEINFO_ALPHAPROC_DISABLE = false    //Disable Alpha Operation
} SEINFO_ALPHAPROC_EN;

//=================================================================================================
typedef enum _SEINFO_CLIPPING_EN
{
    SEINFO_CLIPPING_ENABLE  = true,     //Enable Clipping Operation
    SEINFO_CLIPPING_DISABLE = false     //Disable Clipping Operation
} SEINFO_CLIPPING_EN;

//=================================================================================================
typedef enum _SEINFO_CONVERT_YUV_EN
{
    SEINFO_CONVERT_YUV_ENABLE  = true,  //Enable ARGB->YUV Operation in Felics Command
    SEINFO_CONVERT_YUV_DISABLE = false  //Disable ARGB->YUV Operation in Felics Command
} SEINFO_CONVERT_YUV_EN;

//=================================================================================================
typedef enum _SEINFO_FELICS_ALPHA_EN
{
    SEINFO_FELICS_ALPHA_ENABLE  = 0,    //Enable Alpha Operation in Felics Command
    SEINFO_FELICS_ALPHA_DISABLE = 1     //Disable Alpha Operation in Felics Command
} SEINFO_FELICS_ALPHA_EN;

//=================================================================================================
typedef enum _SEINFO_COMPRESSMODE
{
    SEINFO_DECOMPRESS = 0,  //The Definition of Compress Mode: Decompress
    SEINFO_COMPRESS   = 1   //The Definition of Compress Mode: Compress
} SEINFO_COMPRESSMODE;

//=================================================================================================
typedef enum _SEINFO_BITMAP_SRC
{
    SEINFO_BITMAP_DRAM  = 0,    //The Definition of Location of Bitmap: DRAM
    SEINFO_BITMAP_FLASH = 1     //The Definition of Location of Bitmap: Flash
} SEINFO_BITMAP_SRC;

//=================================================================================================
typedef enum _SEINFO_BITMAP_DIR
{
    SEINFO_BITMAP_DIR_INC = 0,  //The Definition of Direction of Bitmap: Increase
    SEINFO_BITMAP_DIR_DEC = 1   //The Definition of Direction of Bitmap: Decrease
} SEINFO_BITMAP_DIR;

//=================================================================================================
typedef enum _SEINFO_BGCOLOR_EN
{
    SEINFO_BGCOLOR_ENABLE  = true,  //Enable Background Color in Bitmap Command
    SEINFO_BGCOLOR_DISABLE = false  //Disable Background Color in Bitmap Command
} SEINFO_BGCOLOR_EN;

//=================================================================================================
typedef enum _SEINFO_FGCOLOR_EN
{
    SEINFO_FGCOLOR_ENABLE  = true,  //Enable Foreground Color in Bitmap Command
    SEINFO_FGCOLOR_DISABLE = false  //Disable Foreground Color in Bitmap Command
} SEINFO_FGCOLOR_EN;

//=================================================================================================
typedef enum _SEINFO_BITMAP_32BIT_EN
{
    SEINFO_BITMAP_32BIT_ENABLE  = true,     //Enable 32-bit Color in Bitmap Command
    SEINFO_BITMAP_32BIT_DISABLE = false     //Disable 32-bit Color in Bitmap Command
} SEINFO_BITMAP_32BIT_EN;

//=================================================================================================
typedef enum _SEINFO_NO_COLORMODIFY_EN
{
    SEINFO_NO_COLORMODIFY_ENABLE  = true,
    SEINFO_NO_COLORMODIFY_DISABLE = false
} SEINFO_NO_COLORMODIFY_EN;

//=================================================================================================
typedef enum _SEINFO_ERRORCOLOR_EN
{
    SEINFO_ERRORCOLOR_ENABLE  = true,   //Enable Error Color Pattern
    SEINFO_ERRORCOLOR_DISABLE = false   //Disable Error Color Pattern
} SEINFO_ERRORCOLOR_EN;

//=================================================================================================
typedef enum _SEINFO_BITMAP_ENDIAN
{
    SEINFO_BITMAP_BIG_ENDIAN    = 0,    //The Definition of Endian Type: Big Endian
    SEINFO_BITMAP_LITTLE_ENDIAN = 1     //The Definition of Endian Type: Little Endian
} SEINFO_BITMAP_ENDIAN;

//=================================================================================================
typedef enum _SEINFO_ROPMODE
{
    SEINFO_ALPHA_BLENDING = 0,      //The Definition of ROP Mode: Alpha Blending
    SEINFO_ROP_MODE       = 1       //The Definition of ROP Mode: ROP Mode
} SEINFO_ROPMODE;

//=================================================================================================
typedef enum _SEINFO_CORNER
{
    SEINFO_BITBLT_CORNER_TOP_LEFT     = 0,  //The Definition of Starting Corner: Top-Left
    SEINFO_BITBLT_CORNER_TOP_RIGHT    = 1,  //The Definition of Starting Corner: Top-Right
    SEINFO_BITBLT_CORNER_BOTTOM_LEFT  = 2,  //The Definition of Starting Corner: Bottom-Left
    SEINFO_BITBLT_CORNER_BOTTOM_RIGHT = 3,  //The Definition of Starting Corner: Bottom-Right
    SEINFO_BITBLT_CORNER_NONE         = 4   //The Definition of Starting Corner: Disable
} SEINFO_CORNER;

//=================================================================================================
typedef enum _SEINFO_ALPHAMODE
{
    SEINFO_BITBLT_ALPHA_CONST           = 0,    //The Definition of Alpha Mode: Constant (SE_Src_Alpha)
    SEINFO_BITBLT_ALPHA_1_CONST         = 1,    //The Definition of Alpha Mode: Constant (1 - SE_Src_Alpha)
    SEINFO_BITBLT_ALPHA_DEST            = 2,    //The Definition of Alpha Mode: Destination (Destination(A))
    SEINFO_BITBLT_ALPHA_1_DEST          = 3,    //The Definition of Alpha Mode: Destination (1 - Destination(A))
    SEINFO_BITBLT_ALPHA_SRC             = 4,    //The Definition of Alpha Mode: Source (Source(A))
    SEINFO_BITBLT_ALPHA_1_SRC           = 5,    //The Definition of Alpha Mode: Source (1 - Source(A))
#if 1
    SEINFO_BITBLT_ALPHA_DFB_CONSTANT_0  = 6,    //The Definition of Alpha Mode: Constant Value 0(for DFB). Defined on Saturn
    SEINFO_BITBLT_ALPHA_DFB_CONSTANT_1  = 7,    //The Definition of Alpha Mode: Constant Value 1(for DFB). Defined on Saturn
    SEINFO_BITBLT_ALPHA_DISABLE         = 8
#else
    SEINFO_BITBLT_ALPHA_DISABLE         = 6
#endif
} SEINFO_ALPHAMODE;

//=================================================================================================
typedef enum _SEINFO_OUTPUT_ALPHAMODE
{
    SEINFO_OUTPUT_ALPHA_NORMAL = 0,     //The Definition of Output Alpha Mode: Normal
    SEINFO_OUTPUT_ALPHA_CONST  = 1      //The Definition of Output Alpha Mode: Constant
} SEINFO_OUTPUT_ALPHAMODE;

//=================================================================================================
typedef enum _SEINFO_ALPHA_CMD_ALPHA_MODE
{
    SEINFO_ALPHA_CMD_ALPHA_CONST = 0,   //The Definition of Alpha Mode: Constant (SE_Src_Alpha)
    SEINFO_ALPHA_CMD_ALPHA_INDEX = 1    //The Definition of Alpha Mode: Using alpha index
} SEINFO_ALPHA_CMD_ALPHA_MODE;

//=================================================================================================
typedef enum _SEINFO_ALPHA_CMD_STREAM_MODE
{
    SEINFO_ALPHA_CMD_STREAM_ALPHA_ONLY = 0,
    SEINFO_ALPHA_CMD_STREAM_RGB565     = 1,
    SEINFO_ALPHA_CMD_STREAM_ARGB8888   = 2,
    SEINFO_ALPHA_CMD_STREAM_DISABLED   = 3
} SEINFO_ALPHA_CMD_STREAM_MODE;

//=================================================================================================
typedef enum _SEINFO_STRETCH
{
    SEINFO_STRETCH_FIR         = 1,     //The Definition of Scaling Algorithm: FIR
    SEINFO_STRETCH_REPEAT_DROP = 2,     //The Definition of Scaling Algorithm: Repeat/Drop
    SEINFO_STRETCH_DIRECTIONAL = 3      //The Definition of Scaling Algorithm: Directional Scaling
} SEINFO_STRETCH;

//=================================================================================================
typedef enum _SEINFO_SACLING_TYPE
{
    SEINFO_SCALING_UP      = 0,     //The Definition of Scaling Type: Scaling Up
    SEINFO_SCALING_DOWN    = 1,     //The Definition of Scaling Type: Scaling Down
    SEINFO_SCALING_DISABLE = 2      //The Definition of Scaling Type: Disable
} SEINFO_SACLING_TYPE;

//=================================================================================================
typedef enum _SEINFO_SACLING_TABLE
{
    SEINFO_SCALING_UP_2X   = 0,     //The Definition of Indicator of Coefficient Table: Scaling Up 2X
    SEINFO_SCALING_UP_4X   = 1,     //The Definition of Indicator of Coefficient Table: Scaling Up 4X
    SEINFO_SCALING_UP_8X   = 2,     //The Definition of Indicator of Coefficient Table: Scaling Up 8X
    SEINFO_SCALING_DOWN_2X = 3,     //The Definition of Indicator of Coefficient Table: Scaling Down 2X
    SEINFO_SCALING_DOWN_4X = 4      //The Definition of Indicator of Coefficient Table: Scaling Down 4X
} SEINFO_SACLING_TABLE;

//=================================================================================================
typedef enum _SEINFO_STRETCH_HTAP
{
    SEINFO_HSCALING_2TAP = 0,   //The Definition of Number of Taps in Horizontal Scaling: 2 Taps
    SEINFO_HSCALING_4TAP = 1,   //The Definition of Number of Taps in Horizontal Scaling: 4 Taps
    SEINFO_HSCALING_8TAP = 2    //The Definition of Number of Taps in Horizontal Scaling: 8 Taps
} SEINFO_STRETCH_HTAP;

//=================================================================================================
typedef enum _SEINFO_STRETCH_VTAP
{
    SEINFO_VSCALING_2TAP = 0,   //The Definition of Number of Taps in Vertical Scaling: 2 Taps
    SEINFO_VSCALING_4TAP = 1    //The Definition of Number of Taps in Vertical Scaling: 4 Taps
} SEINFO_STRETCH_VTAP;

//=================================================================================================
typedef enum _SEINFO_DECIMATE_SCALING
{
    SEINFO_DECIMATE_AVERAGE2 = 0,   //The Definition of Decimate Algorithm: Average 2
    SEINFO_DECIMATE_AVERAGE4 = 1,   //The Definition of Decimate Algorithm: Average 4
} SEINFO_DECIMATE_SCALING;

//=================================================================================================
typedef enum _SEINFO_COLORKEY
{
    SEINFO_COLORKEY_NONE        = 0,    //The Definition of Color Key: No Color Key
    SEINFO_COLORKEY_SOURCE      = 1,    //The Definition of Color Key: Source Side Color Key
    SEINFO_COLORKEY_DESTINATION = 2,    //The Definition of Color Key: Destination Side Color Key
    SEINFO_COLORKEY_BOTH        = 3     //The Definition of Color Key: Destination and Source Color Key
} SEINFO_COLORKEY;

//=================================================================================================
typedef enum _SEINFO_COLORKEY_DRAWLINE
{
    SEINFO_COLORKEY_DRAWLINE_NONE        = 0,   //The Definition of Color Key: No Color Key
    SEINFO_COLORKEY_DRAWLINE_DESTINATION = 1    //The Definition of Color Key: Destination Side Color Key
} SEINFO_COLORKEY_DRAWLINE;

//=================================================================================================
typedef enum _SEINFO_CONVERSION
{
    SEINFO_CONVERSION_INDEX_ARGB = 0,   //The Definition of Format Conversion: Index to ARGB
    SEINFO_CONVERSION_ARGB_ARGB  = 1,   //The Definition of Format Conversion: ARGB to ARGB
    SEINFO_CONVERSION_YUV_ARGB   = 2,   //The Definition of Format Conversion: YUV to ARGB
    SEINFO_CONVERSION_ARGB_YUV   = 3    //The Definition of Format Conversion: ARGB to YUV
} SEINFO_CONVERSION;

//=================================================================================================
typedef enum _SEINFO_INDEX_FORMAT
{
    SEINFO_FORMAT_INDEX2 = 0,   //The Definition of Color Format: Index 2
    SEINFO_FORMAT_INDEX4 = 1,   //The Definition of Color Format: Index 4
    SEINFO_FORMAT_INDEX8 = 2    //The Definition of Color Format: Index 8
} SEINFO_INDEX_FORMAT;

//=================================================================================================
typedef enum _SEINFO_RGB_FORMAT
{
    SEINFO_FORMAT_RGB332   = 0,     //The Definition of Color Format: RGB332
    SEINFO_FORMAT_RGB565   = 1,     //The Definition of Color Format: RGB565
    SEINFO_FORMAT_ARGB1555 = 2,     //The Definition of Color Format: ARGB1555
    SEINFO_FORMAT_ARGB4444 = 3,     //The Definition of Color Format: ARGB4444
    SEINFO_FORMAT_ARGB8888 = 4      //The Definition of Color Format: ARGB8888
} SEINFO_RGB_FORMAT;

//=================================================================================================
typedef enum _SEINFO_YUV_FORMAT
{
    SEINFO_FORMAT_YUV420 = 0,   //The Definition of Color Format: YUV420
    SEINFO_FORMAT_YUV422 = 1,   //The Definition of Color Format: YUV422
    SEINFO_FORMAT_YUV444 = 2    //The Definition of Color Format: YUV444
} SEINFO_YUV_FORMAT;

//=================================================================================================
typedef enum _SEINFO_COLOR_FORMAT
{
    SEINFO_COLOR_FORMAT_INDEX2   = 0,   //The Definition of Color Format: Index 2
#if 1
        SEINFO_COLOR_FORMAT_HSI  = 1,   //Magellan added
#else
    SEINFO_COLOR_FORMAT_INDEX4   = 1,   //The Definition of Color Format: Index 4
#endif
    SEINFO_COLOR_FORMAT_INDEX8   = 2,   //The Definition of Color Format: Index 8
    SEINFO_COLOR_FORMAT_RGB332   = 3,   //The Definition of Color Format: RGB332
    SEINFO_COLOR_FORMAT_RGB565   = 4,   //The Definition of Color Format: RGB565
    SEINFO_COLOR_FORMAT_ARGB1555 = 5,   //The Definition of Color Format: ARGB1555
    SEINFO_COLOR_FORMAT_ARGB4444 = 6,   //The Definition of Color Format: ARGB4444
    SEINFO_COLOR_FORMAT_ARGB8888 = 7,   //The Definition of Color Format: ARGB8888
    SEINFO_COLOR_FORMAT_Y        = 8,   //The Definition of Color Format: Y
    SEINFO_COLOR_FORMAT_UV       = 9,   //The Definition of Color Format: CbCr
    SEINFO_COLOR_FORMAT_YUV420   = 10,  //The Definition of Color Format: YCbCr420
    SEINFO_COLOR_FORMAT_YUV422   = 11,  //The Definition of Color Format: YCbCr422
    SEINFO_COLOR_FORMAT_YUV444   = 12,  //The Definition of Color Format: YCbCr444
    SEINFO_COLOR_FORMAT_RGB888   = 15   //The Definition of Color Format: RGB888
} SEINFO_COLOR_FORMAT;

//=================================================================================================
typedef enum _SEINFO_ARGB_ALPHA_LOCATION
{
    SEINFO_ARGB_ALPHA_LEFTMOST  = 0,    //The Definition of Location of Alpha Bit: Left-Most
    SEINFO_ARGB_ALPHA_RIGHTMOST = 1,    //The Definition of Location of Alpha Bit: Right-Most
    SEINFO_ARGB_ALPHA_NONE = 2          //The Definition of Location of Alpha Bit: None
} SEINFO_ARGB_ALPHA_LOCATION;

//=================================================================================================
typedef enum _SEINFO_RGB_LOCATION
{
    SEINFO_RGB_LOCATION_LEFTMOST  = 0,  //The Definition of Location of 2/6 for RGB565/RGB332: Left-Most
    SEINFO_RGB_LOCATION_MIDDLE    = 1,  //The Definition of Location of 2/6 for RGB565/RGB332: Middle
    SEINFO_RGB_LOCATION_RIGHTMOST = 2,  //The Definition of Location of 2/6 for RGB565/RGB332: Right-Most
    SEINFO_RGB_LOCATION_NONE      = 3   //The Definition of Location of 2/6 for RGB565/RGB332: None
} SEINFO_RGB_LOCATION;

//=================================================================================================
typedef enum _SEINFO_SRC_FORMAT
{
    SEINFO_SRC_FORMAT_INDEX2   = 0,     //The Definition of Color Format: Index 2
    SEINFO_SRC_FORMAT_INDEX4   = 1,     //The Definition of Color Format: Index 4
    SEINFO_SRC_FORMAT_INDEX8   = 2,     //The Definition of Color Format: Index 8
    SEINFO_SRC_FORMAT_RGB332   = 0,     //The Definition of Color Format: RGB332
    SEINFO_SRC_FORMAT_RGB565   = 1,     //The Definition of Color Format: RGB565
    SEINFO_SRC_FORMAT_ARGB1555 = 2,     //The Definition of Color Format: ARGB1555
    SEINFO_SRC_FORMAT_ARGB4444 = 3,     //The Definition of Color Format: ARGB4444
    SEINFO_SRC_FORMAT_ARGB8888 = 4,     //The Definition of Color Format: ARGB8888
    SEINFO_SRC_FORMAT_YUV420   = 0,     //The Definition of Color Format: YUV420
    SEINFO_SRC_FORMAT_YUV422   = 1,     //The Definition of Color Format: YUV422
    SEINFO_SRC_FORMAT_YUV444   = 2      //The Definition of Color Format: YUV444
} SEINFO_SRC_FORMAT;

//=================================================================================================
typedef enum _SEINFO_DEST_FORMAT
{
    SEINFO_DEST_FORMAT_RGB332   = 0,    //The Definition of Color Format: RGB332
    SEINFO_DEST_FORMAT_RGB565   = 1,    //The Definition of Color Format: RGB565
    SEINFO_DEST_FORMAT_ARGB1555 = 2,    //The Definition of Color Format: ARGB1555
    SEINFO_DEST_FORMAT_ARGB4444 = 3,    //The Definition of Color Format: ARGB4444
    SEINFO_DEST_FORMAT_ARGB8888 = 4,    //The Definition of Color Format: ARGB8888
#if 1
    SEINFO_DEST_FORMAT_RGB888   = 5,    //For cnvmode = 2b'00 or 2'b01 or 2'b10
    SEINFO_DEST_FORMAT_ARGB8565 = 6,    //For cnvmode = 2b'00 or 2'b01 or 2'b10
#endif
    SEINFO_DEST_FORMAT_YUV420   = 0,    //The Definition of Color Format: YUV420
    SEINFO_DEST_FORMAT_YUV422   = 1,    //The Definition of Color Format: YUV422
    SEINFO_DEST_FORMAT_YUV444   = 2 //The Definition of Color Format: YUV444
} SEINFO_DEST_FORMAT;

//=================================================================================================
typedef enum _SEINFO_GRADIENT
{
    SEINFO_GRADIENT_LEFT_UP     = 0,
    SEINFO_GRADIENT_LEFT_DOWN   = 1,
    SEINFO_GRADIENT_LEFT        = 2,
    SEINFO_GRADIENT_UP          = 3,
    SEINFO_GRADIENT_DISABLE     = 4,
    SEINFO_GRADIENT_MASK        = 0xf,
} SEINFO_GRADIENT;

//=================================================================================================
typedef enum _SEINFO_ROTATE
{
    SEINFO_ROTATE_90        = 0,    //The Definition of Angle for Rotate Command: 90 Degrees
    SEINFO_ROTATE_180       = 1,    //The Definition of Angle for Rotate Command: 180 Degrees
    SEINFO_ROTATE_270       = 2,    //The Definition of Angle for Rotate Command: 270 Degrees
    SEINFO_ROTATE_DISABLE   = 3     //The Definition of Direction for Gradient: Disable

} SEINFO_ROTATE;

//=================================================================================================
typedef enum _SEINFO_INTERLEAVING_MODE
{
    SEINFO_INTERLEAVING_MODE_ENABLE  = true,    //The Definition of Enable Interleaving Mode
    SEINFO_INTERLEAVING_MODE_DISABLE = false    //The Definition of Disable Interleaving Mode
} SEINFO_INTERLEAVING_MODE;

//=================================================================================================
typedef enum _SEINFO_SRC_CLR_TRANSFORM // Saturn Sepc, page 33, Command Bitblit, Word4, field: src_clr_transform
{
    SEINFO_SRC_CLR_TRANSFORM_DISABLE                = 0,    //Disable source color transform
    SEINFO_SRC_CLR_TRANSFORM_ENABLE_FOR_ALPHA_ONLY  = 1,    //Enable source color transform for alpha only
    SEINFO_SRC_CLR_TRANSFORM_ENABLE_FOR_ALL         = 2     //Enable source color transform for all components(RGBA)
} SEINFO_SOURCE_COLOR_TRANSFORM;

//=================================================================================================
typedef enum _SEINFO_DFB_CLR_BLEND_MODE // Saturn Sepc, page 33, Command Bitblit, Word4, field: fb_sel_srcclr_blend & fb_sel_destclr_blend
{
    SEINFO_DFB_BLEND_CONST_0              = 0,  //Constant Value 0
    SEINFO_DFB_BLEND_CONST_1              = 1,  //Constant Value 1
    SEINFO_DFB_BLEND_ALPHA_DEST           = 2,  //Select dest alpha (i.e. dest(A) – destination pixel by pixel alpha)
    SEINFO_DFB_BLEND_ALPHA_1_DEST         = 3,  //Select (1-dest(A))
    SEINFO_DFB_BLEND_ALPHA_SRC            = 4,  //Select pixel by pixel src alpha (i.e. src(A))
    SEINFO_DFB_BLEND_ALPHA_1_SRC          = 5,  //Select (1-src(A))
    SEINFO_DFB_BLEND_RGB_SRC              = 6,  //Select source color src(RGB)
    SEINFO_DFB_BLEND_RGB_1_SRC            = 7,  //Select (1-src(RGB))
    SEINFO_DFB_BLEND_RGB_DEST             = 8,  //Select destination color dest(RGB)
    SEINFO_DFB_BLEND_RGB_1_DEST           = 9,  //Select (1-dest(RGB))
    SEINFO_DFB_BLEND_MIN_ALPHA_SRC_1_DEST = 10, //Select min(src(A), 1-dest(A))
 } SEINFO_DFB_CLR_BLEND_MODE;

//=================================================================================================
#if 1
typedef enum _SEINFO_STRETCH_REPLACE_ALPHA  //Magellan spec page 55 , register STRETCH-replace_alpha
{
    SEINFO_STRETCH_REPLACE_ALPHA_DISABLE = 0,
    SEINFO_STRETCH_REPLACE_ALPHA_ENABLE  = 1
} SEINFO_STRETCH_REPLACE_ALPHA;

//=================================================================================================
typedef enum _SEINFO_STRETCH_REPLACE_COLOR  //Magellan spec page 55 , register STRETCH-replace_color
{
    SEINFO_STRETCH_REPLACE_COLOR_DISABLE = 0,
    SEINFO_STRETCH_REPLACE_COLOR_ENABLE  = 1
} SEINFO_STRETCH_REPLACE_COLOR;

#endif
//=================================================================================================

typedef struct _SE_FELICS_HEADER
{
    uint32_t    Word1;                          //IO[63:32]: Reserved
    union
    {
        uint32_t    Value;
        struct
        {
            uint32_t    BitStreamLength: 27;    //IO[26:0]: Bit Stream Length
            uint32_t    Abort: 1;               //IO[27]: Abort Status
            uint32_t    Reserved2: 4;           //IO[31:28]: Reserved
        } Fields;
    } Word2;
} SE_FELICS_HEADER;

//=================================================================================================
typedef struct _SE_PROCINFO
{
    uint16_t    wDataX;                     //Set Data Location X
    uint16_t    wDataY;                     //Set Data Location Y
    uint16_t    wDataHeight;                //Set Data Height
    uint16_t    wDataWidth;                 //Set Data Width

    uint8_t     byCommandQueueSelect;       //Select Corresponding Command Queue for Current Serivce
    bool        bInterruptService;          //Select Which CPU to Service Interrupt Events

    uint8_t     byBaseAddressIndex;         //Set Index of Base Address
                                            //- Sequential Mode: Select Corresponding SE_Baddr and SE_Pitch Registers
                                            //- Block Mode: Select DCU Address Index If Color Format is YUV
    uint8_t     byChronmaAddressIndex;      //Set DCU Index of Chronma Address
    bool        bInterleavingModeEnable;    //Enable/Disable Interleaving Mode
} SE_PROCINFO;

typedef struct _SE_QTMATRIX
{
    uint16_t scalingM11;
    uint16_t scalingM22;
    uint16_t shearingM12;
    uint16_t shearingM21;
    uint16_t movingM31;
    uint16_t movingM32;
    uint16_t projection0M13;
    uint16_t projection0M23;
    uint16_t projection1M33;
} SE_QTMATRIX;

typedef enum _SEINFO_QT_BytesPerPixel
{
    SEINFO_QT_1_BYTE_PER_PIXEL = 0,
    SEINFO_QT_2_BYTE_PER_PIXEL = 1,
    SEINFO_QT_3_BYTE_PER_PIXEL = 2,
    SEINFO_QT_4_BYTE_PER_PIXEL = 3
} SEINFO_QT_BytesPerPixel;
//=================================================================================================

typedef union _SEREG_SRC_CLR_RED
{
    uint32_t  Value;
    struct
    {
        //Register: SRC_CLR_RED (0x1800_C260)
        uint32_t  src_clr_mul_red: 9;       //IO[8:0]: Color multiplier coefficient of "R" component in format (0..256).
        uint32_t  Reserved: 7;              //IO[15:9]: Reserved
        uint32_t  src_clr_add_red: 9;       //IO[24:16]: Color offset coefficient of "R" component (-256 ~ 255)
        uint32_t  Reserved1: 7;             //IO[31:25]: Reserved
    } Fields;
} SEREG_SRC_CLR_RED;

//=================================================================================================
typedef union _SEREG_SRC_CLR_GREEN
{
    uint32_t  Value;
    struct
    {
        //Register: SRC_CLR_GREEN (0x1800_C270)
        uint32_t  src_clr_mul_green: 9;     //IO[8:0]: Color multiplier coefficient of "G" component in format (0..256).
        uint32_t  Reserved: 7;              //IO[15:9]: Reserved
        uint32_t  src_clr_add_green: 9;     //IO[24:16]: Color offset coefficient of "G" component (-256 ~ 255)
        uint32_t  Reserved1: 7;             //IO[31:25]: Reserved
    } Fields;
} SEREG_SRC_CLR_GREEN;

//=================================================================================================
typedef union _SEREG_SRC_CLR_BLUE
{
    uint32_t  Value;
    struct
    {
        //Register: SRC_CLR_BLUE (0x1800_C280)
        uint32_t  src_clr_mul_blue: 9;      //IO[8:0]: Color multiplier coefficient of "B" component in format (0..256).
        uint32_t  Reserved: 7;              //IO[15:9]: Reserved
        uint32_t  src_clr_add_blue: 9;      //IO[24:16]: Color offset coefficient of "B" component (-256 ~ 255)
        uint32_t  Reserved1: 7;             //IO[31:25]: Reserved
    } Fields;
} SEREG_SRC_CLR_BLUE;

//=================================================================================================
typedef union _SEREG_SRC_CLR_ALPHA
{
    uint32_t  Value;
    struct
    {
        //Register: SRC_CLR_ALPHA (0x1800_C290)
        uint32_t  src_clr_mul_alpha: 9;     //IO[8:0]: Color multiplier coefficient of "A" component in format (0..256).
        uint32_t  Reserved: 7;              //IO[15:9]: Reserved
        uint32_t  src_clr_add_alpha: 9;     //IO[24:16]: Color offset coefficient of "A" component (-256 ~ 255)
        uint32_t  Reserved1: 7;             //IO[31:25]: Reserved
    } Fields;
} SEREG_SRC_CLR_ALPHA;

//=================================================================================================
typedef struct _SECMD_WRITE_REGISTER
{
    //Command Type: Write Register
    struct
    {
        uint32_t    OpCode: 4;                    //IO[3:0]: Operational Code
        //           - 0x01: Write Register
        uint32_t    RegisterAddress: 12;        //IO[15:4]: Register Address
        uint32_t    Clut: 1;                     //IO[16]: Select to write registers or the CLUT
        //          - 0: register
        //          - 1: CLUT
        uint32_t    Reserved: 15;               //IO[31:17]: Reserved
    } Word1;

    struct
    {
        uint32_t    RegisterValue;                //IO[31:0]: Register Value
    } Word2;

    struct
    {
        uint32_t    Reserved;                    //IO[31:0]: Reserved
    } Word3;

    struct
    {
        uint32_t    Reserved;                    //IO[31:0]: Reserved
    } Word4;

    struct
    {
        uint32_t    Reserved;                    //IO[31:0]: Reserved
    } Word5;

    struct
    {
        uint32_t    Reserved;                    //IO[31:0]: Reserved
    } Word6;

    struct
    {
        uint32_t    Reserved;                    //IO[31:0]: Reserved
    } Word7;

    struct
    {
        uint32_t    Reserved;                    //IO[31:0]: Reserved
    } Word8;


} SECMD_WRITE_REGISTER;
#if 1
typedef struct _SECMD_WRITE_REGISTER2
{
    struct
    {
        uint32_t    OpCode: 4;
        uint32_t    RegisterAddress: 12;
        uint32_t    Clut: 1;
        uint32_t    Reserved: 15;
    } Word1;
    struct
    {
        uint32_t    RegisterValue;
    } Word2;

    struct
    {
        uint32_t    OpCode: 4;
        uint32_t    RegisterAddress: 12;
        uint32_t    Clut: 1;
        uint32_t    Reserved: 15;
    } Word3;
    struct
    {
        uint32_t    RegisterValue;
    } Word4;
    struct
    {
        uint32_t    OpCode: 4;
        uint32_t    RegisterAddress: 12;
        uint32_t    Clut: 1;
        uint32_t    Reserved: 15;
    } Word5;
    struct
    {
        uint32_t    RegisterValue;
    } Word6;
    struct
    {
        uint32_t    OpCode: 4;
        uint32_t    RegisterAddress: 12;
        uint32_t    Clut: 1;
        uint32_t    Reserved: 15;
    } Word7;
    struct
    {
        uint32_t    RegisterValue;
    } Word8;


} SECMD_WRITE_REGISTER2;
#endif
typedef struct _SECMD_FETCH_CLUT
{
    //Command Type: Fetch CLUT
    struct
    {
        uint32_t    OpCode: 4;                    //IO[3:0]: Operational Code
        //           - 0x02: Fetch Color Look Up Table Operation

        uint32_t    FetchEntry: 2;                //IO[5:4]: Fetch CLUT Mode
                                                //           - 00: 4 entries ARGB=16B (Index2)
                                                //           - 01: 16 entries ARGB=64B (Index4)
                                                //           - 10: 256 entries ARGB=1KB (Index8)
                                                //           - 11: reserved
        uint32_t    Force_load_clut: 1;            //IO[6]: Load clut table anyway
        uint32_t    Reserved: 25;               //IO[31:7]: Reserved
    } Word1;

    struct
    {
        uint32_t    StartingAddress: 31;        //IO[30:0]: starting address (byte address); in 16 byte alignment
        uint32_t    Reserved: 1;                   //IO[31:31]: Reserved
    } Word2;

    struct
    {
        uint32_t    Reserved;                    //IO[31:0]: Reserved
    } Word3;

    struct
    {
        uint32_t    Reserved;                    //IO[31:0]: Reserved
    } Word4;

    struct
    {
        uint32_t    Reserved;                    //IO[31:0]: Reserved
    } Word5;

    struct
    {
        uint32_t    Reserved;                    //IO[31:0]: Reserved
    } Word6;

    struct
    {
        uint32_t    Reserved;                    //IO[31:0]: Reserved
    } Word7;

    struct
    {
        uint32_t    Reserved;                    //IO[31:0]: Reserved
    } Word8;

} SECMD_FETCH_CLUT;

typedef struct _SECMD_LOCK_CLUT
{
    //Command Type: Lock CLUT
    struct
    {
        uint32_t    OpCode: 4;                    //IO[3:0]: Operational Code
        //           - 0x04: Lock Color Look Up Table Operation

        uint32_t    Lock_clut: 1;                //IO[4:4]: Lock CLUT
        //           - 1: Lock CLUT
        //           - 0: Unlock CLUT
        uint32_t    Reserved: 27;               //IO[31:5]: Reserved
    } Word1;

    struct
    {
        uint32_t    Reserved;                    //IO[31:0]: Reserved
    } Word2;

    struct
    {
        uint32_t    Reserved;                    //IO[31:0]: Reserved
    } Word3;

    struct
    {
        uint32_t    Reserved;                    //IO[31:0]: Reserved
    } Word4;

    struct
    {
        uint32_t    Reserved;                    //IO[31:0]: Reserved
    } Word5;

    struct
    {
        uint32_t    Reserved;                    //IO[31:0]: Reserved
    } Word6;

    struct
    {
        uint32_t    Reserved;                    //IO[31:0]: Reserved
    } Word7;

    struct
    {
        uint32_t    Reserved;                    //IO[31:0]: Reserved
    } Word8;

} SECMD_LOCK_CLUT;

typedef struct _SECMD_WAIT_VO_VSYNC
{
    //Command Type: Wait VO VSync
    struct
    {
        uint32_t    OpCode: 4;                    //IO[3:0]: Operational Code
        //           - 0x08:  Wait VO VSync Operation

        uint32_t    wait_vSync_num: 5;            //IO[8:4]: Waiting for n * (vo_vsync)
        uint32_t    Reserved: 23;               //IO[31:9]: Reserved
    } Word1;

    struct
    {
        uint32_t    Reserved;                    //IO[31:0]: Reserved
    } Word2;

    struct
    {
        uint32_t    Reserved;                    //IO[31:0]: Reserved
    } Word3;

    struct
    {
        uint32_t    Reserved;                    //IO[31:0]: Reserved
    } Word4;

    struct
    {
        uint32_t    Reserved;                    //IO[31:0]: Reserved
    } Word5;

    struct
    {
        uint32_t    Reserved;                    //IO[31:0]: Reserved
    } Word6;

    struct
    {
        uint32_t    Reserved;                    //IO[31:0]: Reserved
    } Word7;

    struct
    {
        uint32_t    Reserved;                    //IO[31:0]: Reserved
    } Word8;

} SECMD_WAIT_VO_VSYNC;

typedef struct _SECMD_FORMAT_CONVERSION
{
    //Command Type: Format Conversion
    struct
    {
        uint32_t    OpCode: 4;                    //IO[3:0]: Operational Code
        //           - 0x03: Color Format Conversion Operation

        uint32_t    Width: 12;                    //IO[15:4]: Width of image in pixels; For ConversionMode[1] == 1,
        //            Width should be an even number. 0 means 4096.

        uint32_t    Height: 12;                    //IO[27:16]: Height of image in pixels; note if 420,
        //             the height of C is only half of Y.
        //             For ConversionMode[1] == 1, Height should be an even number. 0 means 4096.

        uint32_t    SelectOutputAlpha: 1;         //IO[28]: SelectOutputAlpha
        //          - 0: use alpha from normal operation.
        //          - 1: use constant alpha in SE_Rslt_Alpha register
        //          - This field is only use if color_format = 8888 or 4444 or 1555.
        //          - If this SelectOutputAlpha = 1, then SE_Rslt_Alpha will overwrites
        //            the alpha value of the output for both alpha and ROP operation

        uint32_t    ColorKey: 1;                //IO[29]: ColorKey
        //          - 0: no color key
        //          - 1: source color key

        uint32_t    ConversionMode: 2;             //IO[31:30]: Conversion Mode:
        //               - 0: Index -> ARGB
        //               - 1: ARGB -> ARGB
        //               - 2: YCbCr -> ARGB
        //               - 3: ARGB -> YCbCr
    } Word1;

    struct
    {
        uint32_t    Reserved: 1;                //IO[0]: Reserved
                uint32_t  YUV422SeqEnable: 1; //IO[1]: YUV422 input data in sequential format YUYV
                                              //      - 0: disable YUV422 sequential input.
                                                                            //      - 1: enable YUV422 sequential input.
                uint32_t  ARGB8888MatrixEnable: 1;  // IO[2]: ARGB8888 to ARGB8888 conversion using a matrix operation
                                                    //   - 0: disable matrix operation.
                                                                                        //   - 1: enable matrix operation.
        uint32_t    directFB: 1;                //IO[3]: 0: disable directFB function
        //       1: enable directFB function
        uint32_t    FormatConversionBitblit: 1;    //IO[4]: 0: execute Format conversion only
        //       1: execute Bitblit instruction after Format

        uint32_t    InputX: 12;                   //IO[16:5]: input starting X coordinate; for ConversionMode == 2'b10,
        //            this should be an even number

        uint32_t    InputY: 12;                   //IO[28:17]: input starting Y coordinate; for ConversionMode == 2'b10,
        //             this should be an even number

        uint32_t    SourceFormat: 3;            //IO[31:29]: Source format:
        //             - For ConversionMode == 2'b00,
        //               - 3'b002: index 8
        //               - else: reserved
        //             - For ConversionMode == 2'b01 or 2'b11,
        //               - 3'b001: RGB565
        //               - 3'b010: ARGB1555
        //               - 3'b011: ARGB4444
        //               - 3'b100: ARGB8888
                //               - 3'b101: RGB888
        //               - else: reserved
        //             - For ConversionMode==2'b10,
        //               - 3'b000: YCbCr420
        //               - 3'b001: YCbCr422
        //               - else: reserved
    } Word2;

    struct
    {
        uint32_t    Reserved: 5;                //IO[4:0]: Reserved
        uint32_t    OutputX: 12;                   //IO[16:5]: output starting X coordinate; for ConversionMode == 2'b11,
        //            this should be an even number

        uint32_t    OutputY: 12;                   //IO[28:17]: output starting Y coordinate; for ConversionMode == 2'b11,
        //             this should be an even number

        uint32_t    DestinationFormat: 3;        //IO[31:29]: Dest format:
        //             - For ConversionMode==2'b00 or 2'b01 or 2'b10,
        //               - 3'b001: RGB565
        //               - 3'b010: ARGB1555
        //               - 3'b011: ARGB4444
        //               - 3'b100: ARGB8888
                //               - 3'b101: RGB888
                //               - 3'b110: ARGB8565(For Format conversion + Bitblit only)
        //               - else: reserved
        //             - For ConversionMode==2'b11,
        //               - 3'b000: YCbCr420
        //               - 3'b001: YCbCr422
        //               - else: reserved
    } Word3;

    struct
    {
        uint32_t    Reserved: 9;                //IO[8:0]: Reserved
                uint32_t  ROPCode1: 2;        //IO[10:9]: The most significant 2 bits for 16 ROP operations.
                //       The combination of {ROP_code1,ROP_code} is used to represent the 16 operations.
        uint32_t    ChromaAddressIndex: 7;         //IO[17:11]: Chroma address DCU index[6:0] if either source or
        //             dest color format is YCbCr

        uint32_t    DestAddressIndex: 7;           //IO[24:18]: Dest address index[1:0], this will select the
        //             corresponding SE_Baddr and SE_Pitch registers. EX 7'b0010110 will select PITCH2 register
                //             [NOTE]Baker: interleave mode is only for bitblit and stretch.
                //             Plz set interleave to 0 for other cases.(ref. Magellan spec page15)
        //             if destination color format is YCbCr(block mode),
        //             DAddr_index[6:0] is picture set index in DC addcmd.


        uint32_t    SrcAddressIndex: 7;            //IO[31:25]: Src address index[1:0], this will select the
        //             corresponding SE_Baddr and SE_Pitch registers
        //             if source color format is YCbCr(block mode)
                //             [NOTE]Baker: interleave mode is only for bitblit and stretch.
                //             Plz set interleave to 0 for other cases.(ref. Magellan spec page15)
        //             if destination color format is YCbCr(block mode),
        //             DAddr_index[6:0] is picture set index in DC addcmd.
    } Word4;

    struct
    {
        uint32_t    fb_sel_destclr_blend: 4;    //IO[3:0]: This field is used to select the destination color blending
        //              value (without alpha) to be used in generation of the output color
        uint32_t    fb_sel_srcclr_blend: 4;     //IO[7:4]: This field is used to select the source color blending
        //              value (without alpha) to be used in generation of the output color
        uint32_t    fb_demultiply: 1;           //IO[8:8]: Divide destination color by destination alpha before writing to DDR.
        uint32_t    fb_blend_alphachannel: 1;   //IO[9:9]: Modulate source alpha with constant alpha.
        uint32_t    fb_blend_coloralpha: 1;     //IO[10:10]: Replace source alpha with constant alpha
        uint32_t    fb_colorize: 1;             //IO[11:11]: Modulate source color with constant color
        uint32_t    fb_xor: 1;                  //IO[12:12]: XOR source pixel with destination pixel
        uint32_t    fb_src_premultiply: 1;      //IO[13:13]: Modulate source color with source alpha
        uint32_t    fb_src_premulcolor: 1;      //IO[14:14]: Modulate source color with constant alpha
        uint32_t    fb_dst_premultiply: 1;      //IO[15:15]: Modulate destination color with destination
        uint32_t    src_clr_transparency: 1;    //IO[16:16]: Enable/Disable transparency for source color transform
        uint32_t    src_clr_transform: 2;       //IO[18:17]: Enable/Disable source color transform
        uint32_t    rop_mode: 1;                //IO[19]: ROP Mode
        //          - 0: alpha blending
        //          - 1: ROP mode
        uint32_t    bitblit_color_key: 2;       //IO[21:20]: ColorKey(if rop_mode==0 or directFB==1)
        //           - 00: no color key
        //           - 01: source color key
        //           - 10: destination color key
        //           - 11: Both source color key and destination color key.
        uint32_t    sel_src_alpha: 3;           //IO[24:22]: This field is used to select the source alpha value to be
        //           used in generation of the output(if ropmode==1 or directFB ==1)
        //           - 000:  select constant SE_Src_Alpha
        //           - 001: select constant (1-SE_Src_Alpha)
        //           - 010: select dest alpha (i.e. dest(A) - destination pixel by pixel alpha)
        //           - 011: select (1-dest(A) )
        //           - 100: select pixel by pixel src alpha (i.e. src(A))
        //           - 101: select (1-src(A))
        //           - 110 and 111:  reserved
        uint32_t    rop_code: 2;                //IO[26:25]: ROP code for ROP operation
        uint32_t    sel_output_alpha: 1;        //IO[27]: SelectOutputAlpha
        //        - 0: use alpha from normal operation
        //        - 1: use constant alpha in SE_Rslt_Alpha register
        //        - This field is only use if color_format = 8888 or 4444 or 1555.
        //        - If this sel_output_alpha=1, then SE_Rslt_Alpha will overwrites the alpha
        //          value of the output for both alpha and ROP operation
        uint32_t    sync_vo: 1;                 //IO[28]:
        //          1: bitblit instruction needs to sync with VO current line number to avoid trashing
        //          0: bitblit is executed immediately without waiting
        uint32_t    sel_dest_alpha: 3;          //IO[31:29]: This field is used to select the destination alpha value
        //           to be used in generation of the output
        //           - 000:  select constant SE_Dest_Alpha
        //           - 001: select constant (1-SE_Dest_Alpha)
        //           - 010: select dest alpha (i.e. dest(A) - destination pixel by pixel alpha)
        //           - 011: select (1-dest(A) )
        //           - 100: select pixel by pixel src alpha (i.e. src(A))
        //           - 101: select (1-src(A))
        //           - 110 and 111:  reserved
        //           - the "1" in 001, 011 and 101 implies unity number,
        //             or 256 in 8 bit fractional number representation
    } Word5;

    struct
    {
        uint32_t    gl_sel_destclr_blend: 6;
        uint32_t    Reserved1: 2;
        uint32_t    gl_sel_srcclr_blend: 6;
        uint32_t    Reserved2: 2;
        uint32_t    gl_sel_dest_alpha: 6;
        uint32_t    Reserved3: 2;
        uint32_t    gl_sel_src_alpha: 6;
        uint32_t    Reserved4: 1;
        uint32_t    gl_enable: 1;
    } Word6;

    struct
    {
        uint32_t    Reserved;                    //IO[31:0]: Reserved
    } Word7;

    struct
    {
        uint32_t    Reserved;                    //IO[31:0]: Reserved
    } Word8;

} SECMD_FORMAT_CONVERSION;

typedef struct _SECMD_BITBLT
{
    //Command Type: Bitblit
    struct
    {
        uint32_t    OpCode: 4;                    //IO[3:0]: Operational Code
        //           - 0x05: Bitblit Operation
        //           - 0x0D: Bitblit Operation With Source Color Transformation or DFB


        uint32_t    Width: 12;                    //IO[15:4]: Width of image in pixels. 0 means 4096.

        uint32_t    Height: 12;                    //IO[27:16]: Height of image in pixels. 0 means 4096.

        uint32_t    InputSelect: 1;             //IO[28]: InputSelect
        //          - 0: select constant input (SE_Src_Color and SE_Src_Alpha);
        //          - 1: set input vector
        //          - If this field is 1, then the optional
        //            input address word of the command is presented

        uint32_t    SelectDestAlpha: 3;            //IO[31:29]: This field is used to select the destination alpha value
        //             to be used in generation of the output
        //             - 000:  select constant SE_Dest_Alpha
        //             - 001: select constant (1-SE_Dest_Alpha)
        //             - 010: select dest alpha (i.e. dest(A) - destination pixel by pixel alpha)
        //             - 011: select (1-dest(A) )
        //             - 100: select pixel by pixel src alpha (i.e. src(A))
        //             - 101: select (1-src(A))
        //             - 110 and 111:  reserved
        //             - the "1" in 001, 011 and 101 implies unity number,
        //               or 256 in 8 bit fractional number representation
    } Word1;

    struct
    {
        uint32_t    OutputX: 12;                   //IO[11:0]: output starting X coordinate

        uint32_t    OutputY: 12;                   //IO[23:12]: output starting Y coordinate

        uint32_t    StartingCorner: 2;            //IO[25:24]: GradientDirection
        //             - If InputSelect == 1, Starting_corner:
        //               - This field is used to allow Bitblit from a source that
        //                 overlaps with the destination.
        //               - SW should program the correct starting corner from 4 corners
        //                 of a rectangular to prevent data overwrite.
        //               - 00: start at top-left corner
        //               - 01: start at top-right corner
        //               - 10: start at bottom-left corner
        //               - 11: start at bottom-right corner

        uint32_t    RopCode: 2;                    //IO[27:26]: ROP code for ROP operation
        uint32_t    SelectOutputAlpha: 1;        //IO[28]: SelectOutputAlpha
        //          - 0: use alpha from normal operation
        //          - 1: use constant alpha in SE_Rslt_Alpha register
        //          - This field is only use if color_format = 8888 or 4444 or 1555.
        //          - If this sel_output_alpha=1, then SE_Rslt_Alpha will overwrites the alpha
        //            value of the output for both alpha and ROP operation

        uint32_t    sync_vo: 1;                    //IO[29]:
        //          1: bitblit instruction needs to sync with VO current line number to avoid trashing
        //          0: bitblit is executed immediately without waiting

        uint32_t    DestAddressIndex: 2;        //IO[31:30]: Dest address index, this will select the corresponding
        //             SE_Baddr and SE_Pitch registers
    } Word2;

    struct
    {
        uint32_t    InputX: 12;                   //IO[11:0]: input starting X coordinate

        uint32_t    InputY: 12;                   //IO[23:12]: input starting Y coordinate

        uint32_t    RopMode: 1;                    //IO[24]: ROP Mode
        //          - 0: alpha blending
        //          - 1: ROP mode

        uint32_t    ColorKey: 2;                //IO[26:25]: ColorKey
        //             - 00: no color key
        //             - 01: source color key
        //             - 10: destination color key
        //             - 11: Both source color key and destination color key.

        uint32_t    SelectSrcAlpha: 3;            //IO[29:27]: This field is used to select the source alpha value to be
        //             used in generation of the output
        //             - 000:  select constant SE_Src_Alpha
        //             - 001: select constant (1-SE_Src_Alpha)
        //             - 010: select dest alpha (i.e. dest(A) - destination pixel by pixel alpha)
        //             - 011: select (1-dest(A) )
        //             - 100: select pixel by pixel src alpha (i.e. src(A))
        //             - 101: select (1-src(A))
        //             - 110 and 111:  reserved

        uint32_t    SrcAddressIndex: 2;            //IO[31:30]: src address index, this will select the corresponding
        //             SE_Baddr and SE_Pitch registers (input address is optional,
        //             and only used if input_select = 1)
    } Word3;

    struct
    {
        uint32_t    linear_gradient_en: 1;
        uint32_t    opengl: 1;               //IO[8:0]: Reserved
        uint32_t    Reserved: 7;               //IO[8:0]: Reserved
        uint32_t    alpha_stream_mode: 1;               //IO[9]
        uint32_t    ROPCode1: 2;                // The most signif
        uint32_t    fb_sel_destclr_blend: 4;    //IO[15:12]: This field is used to select the destination color blending
        //              value (without alpha) to be used in generation of the output color
        uint32_t    fb_sel_srcclr_blend: 4;     //IO[19:16]: This field is used to select the source color blending
        //              value (without alpha) to be used in generation of the output color
        uint32_t    fb_demultiply: 1;           //IO[20:20]: Divide destination color by destination alpha before writing to DDR.
        uint32_t    fb_blend_alphachannel: 1;   //IO[21:21]: Modulate source alpha with constant alpha.
        uint32_t    fb_blend_coloralpha: 1;     //IO[22:22]: Replace source alpha with constant alpha
        uint32_t    fb_colorize: 1;             //IO[23:23]: Modulate source color with constant color
        uint32_t    fb_xor: 1;                  //IO[24:24]: XOR source pixel with destination pixel
        uint32_t    fb_src_premultiply: 1;      //IO[25:25]: Modulate source color with source alpha
        uint32_t    fb_src_premulcolor: 1;      //IO[26:26]: Modulate source color with constant alpha
        uint32_t    fb_dst_premultiply: 1;      //IO[27:27]: Modulate destination color with destination
        uint32_t    directFB: 1;                //IO[28:28]: Enable/Disable directFB function
        uint32_t    src_clr_transparency: 1;    //IO[29:29]: Enable/Disable transparency for source color transform
        uint32_t    src_clr_transform: 2;       //IO[31:30]: Enable/Disable source color transform
    } Word4;

    struct
    {
        uint32_t    gl_sel_destclr_blend: 6;
        uint32_t    Reserved1: 2;
        uint32_t    gl_sel_srcclr_blend: 6;
        uint32_t    Reserved2: 2;
        uint32_t    gl_sel_dest_alpha: 6;
        uint32_t    Reserved3: 2;
        uint32_t    gl_sel_src_alpha: 6;
        uint32_t    Reserved4: 2;
    } Word5;

    struct
    {
        uint32_t    Reserved;                    //IO[31:0]: Reserved
    } Word6;

    struct
    {
        uint32_t    Reserved;                    //IO[31:0]: Reserved
    } Word7;

    struct
    {
        uint32_t    Reserved;                    //IO[31:0]: Reserved
    } Word8;


} SECMD_BITBLT;

typedef struct _SECMD_STRETCH
{
    //Command Type: Stretch
    struct
    {
        uint32_t    OpCode: 4;                    //IO[3:0]: Operational Code
        //           - 0x06: Stretch Operation

        uint32_t    OutputX: 12;                //IO[15:4]: output starting X coordinate;
        //            when 422/420, this value should be an even number.

        uint32_t    OutputY: 12;                //IO[27:16]: output starting Y coordinate;
        //             when 420, this value should be an even number.

        uint32_t    ColorKey: 1;                //IO[28]: Color Key
        //        - 0: no color key
        //        - 1: source color key

        uint32_t    HScalingEnable: 1;            //IO[29]: Enable of H-scaling; if disable, only bypass
        uint32_t    VScalingEnable: 1;            //IO[30]: Enable of V-scaling; if disable, only bypass
        uint32_t    SrcInterleaving: 1;            //IO[31]: interleaving mode for source image
    } Word1;

    struct
    {
        uint32_t    OutputWidth: 12;            //IO[11:0]: Output number of pixels in Width. 0 means 4096.
        //            Due to HW implementation, the number should be not
        //            bigger than (Input_Width  * 8 / (H_scaling_delta_phase) + 16);
        //            when 422/420, this value should be an even number.

        uint32_t    OutputHeight: 12;            //IO[23:12]: Output number of pixels in Height. 0 means 4096; when 420,
        //             this value should be an even number.

        uint32_t    StretchBitblit: 1;            //IO[24]: 0: execute Stretch instruction only
        //        1: execute Bitblit instruction after Stretch
        uint32_t    directFB: 1;                //IO[25]: 0: disable directFB function
        //        1: enable directFB function

        uint32_t    Reserved: 4;                //IO[29:26]: Reserved

        uint32_t    ScalingAlgorithm: 2;        //IO[31:30]: Selection of scaling algorithm:
        //             - 00: reserved
        //             - 01: FIR
        //             - 10: repeat/drop (nearest neighbor)
        //             - 11: directional scaling (DS)
    } Word2;

    struct
    {
        uint32_t    InputX: 12;                    //IO[11:0]: input starting X coordinate;
        //            when 422/420, this value should be an even number.

        uint32_t    InputY: 12;                    //IO[23:12]: input starting Y coordinate;
        //             when 420, this value should be an even number.

        uint32_t    DestInterleaving: 1;        //IO[24]: interleaving mode for dest. image

        uint32_t    SrcAddressIndex: 7;            //IO[31:25]: SrcAddressIndex
        //             - Src address index[1:0], this will select the
        //               corresponding SE_Baddr and SE_Pitch registers
        //               if source color format is not YCbCr
        //             - Src address DCU index[6:0] if source color is YCbCr.
    } Word3;

    struct
    {
        uint32_t    InputWidth: 13;                    //IO[12:0]: Input number of pixels in Width. 0 means 8192;
        //            when 422/420, this value should be an even number.

        uint32_t    InputHeight: 12;                //IO[24:13]: Input number of pixels in Height. 0 means 4096;
        //             when 420, this value should be an even number.

        uint32_t    DestAddressIndex: 7;            //IO[31:25]: DestAddressIndex
        //             - Dest address index[1:0], this will select the
        //               corresponding SE_Baddr and SE_Pitch registers
        //               if destination color format is not YCbCr.
        //             - Dest address DCU index[6:0] if destination color format is YCbCr.
    } Word4;

    struct
    {
        uint32_t    fb_sel_destclr_blend: 4;    //IO[3:0]: This field is used to select the destination color blending
        //              value (without alpha) to be used in generation of the output color
        uint32_t    fb_sel_srcclr_blend: 4;     //IO[7:4]: This field is used to select the source color blending
        //              value (without alpha) to be used in generation of the output color
        uint32_t    fb_demultiply: 1;           //IO[8:8]: Divide destination color by destination alpha before writing to DDR.
        uint32_t    fb_blend_alphachannel: 1;   //IO[9:9]: Modulate source alpha with constant alpha.
        uint32_t    fb_blend_coloralpha: 1;     //IO[10:10]: Replace source alpha with constant alpha
        uint32_t    fb_colorize: 1;             //IO[11:11]: Modulate source color with constant color
        uint32_t    fb_xor: 1;                  //IO[12:12]: XOR source pixel with destination pixel
        uint32_t    fb_src_premultiply: 1;      //IO[13:13]: Modulate source color with source alpha
        uint32_t    fb_src_premulcolor: 1;      //IO[14:14]: Modulate source color with constant alpha
        uint32_t    fb_dst_premultiply: 1;      //IO[15:15]: Modulate destination color with destination
        uint32_t    src_clr_transparency: 1;    //IO[16:16]: Enable/Disable transparency for source color transform
        uint32_t    src_clr_transform: 2;       //IO[18:17]: Enable/Disable source color transform
        uint32_t    rop_mode: 1;                //IO[19]: ROP Mode
        //          - 0: alpha blending
        //          - 1: ROP mode
        uint32_t    bitblit_color_key: 2;       //IO[21:20]: ColorKey
        //           - 00: no color key
        //           - 01: source color key
        //           - 10: destination color key
        //           - 11: Both source color key and destination color key.
        uint32_t    sel_src_alpha: 3;           //IO[24:22]: This field is used to select the source alpha value to be
        //           used in generation of the output
        //           - 000:  select constant SE_Src_Alpha
        //           - 001: select constant (1-SE_Src_Alpha)
        //           - 010: select dest alpha (i.e. dest(A) - destination pixel by pixel alpha)
        //           - 011: select (1-dest(A) )
        //           - 100: select pixel by pixel src alpha (i.e. src(A))
        //           - 101: select (1-src(A))
        //           - 110 and 111:  reserved
        uint32_t    rop_code: 2;                //IO[26:25]: ROP code for ROP operation
        uint32_t    sel_output_alpha: 1;        //IO[27]: SelectOutputAlpha
        //        - 0: use alpha from normal operation
        //        - 1: use constant alpha in SE_Rslt_Alpha register
        //        - This field is only use if color_format = 8888 or 4444 or 1555.
        //        - If this sel_output_alpha=1, then SE_Rslt_Alpha will overwrites the alpha
        //          value of the output for both alpha and ROP operation
        uint32_t    sync_vo: 1;                 //IO[28]:
        //          1: bitblit instruction needs to sync with VO current line number to avoid trashing
        //          0: bitblit is executed immediately without waiting
        uint32_t    sel_dest_alpha: 3;          //IO[31:29]: This field is used to select the destination alpha value
        //           to be used in generation of the output
        //           - 000:  select constant SE_Dest_Alpha
        //           - 001: select constant (1-SE_Dest_Alpha)
        //           - 010: select dest alpha (i.e. dest(A) - destination pixel by pixel alpha)
        //           - 011: select (1-dest(A) )
        //           - 100: select pixel by pixel src alpha (i.e. src(A))
        //           - 101: select (1-src(A))
        //           - 110 and 111:  reserved
        //           - the "1" in 001, 011 and 101 implies unity number,
        //             or 256 in 8 bit fractional number representation
    } Word5;

    struct
    {
        uint32_t    gl_sel_destclr_blend: 6;
        uint32_t    Reserved1: 2;
        uint32_t    gl_sel_srcclr_blend: 6;
        uint32_t    Reserved2: 2;
        uint32_t    gl_sel_dest_alpha: 6;
        uint32_t    Reserved3: 2;
        uint32_t    gl_sel_src_alpha: 6;
        uint32_t    Reserved4: 1;
        uint32_t    gl_enable: 1;
    } Word6;
    struct
    {
        uint32_t    Reserved;
    } Word7;
    struct
    {
        uint32_t    Reserved;
    } Word8;

} SECMD_STRETCH;

typedef struct _SECMD_MIRROR
{
	struct
	{
		uint32_t	opcode: 4;
		uint32_t	outputx: 12;
		uint32_t	outputy: 12;
		uint32_t	mirrordirection: 2;
		uint32_t	destaddressindex: 2;
	} Word1;
	struct
	{
		uint32_t	width: 12;
		uint32_t	height: 12;
		uint32_t	reserved: 8;
	} Word2;
	struct
	{
		uint32_t	reserved1: 4;
		uint32_t	inputx: 12;
		uint32_t	inputy: 12;
		uint32_t	reserved2: 2;
		uint32_t	srcaddressindex: 2;
	} Word3;
	struct
	{
		uint32_t	reserved;
	} Word4;
} SECMD_MIRROR;

typedef struct _SECMD_ROTATE
{
	struct
	{
		uint32_t	opcode: 4;
		uint32_t	reserved1: 25;
		uint32_t	blockmodeoutput: 1;
		uint32_t	rotatemode: 2;
	} Word1;
	struct
	{
		uint32_t	inputx: 12;
		uint32_t	inputy: 12;
		uint32_t	reserved: 1;
		uint32_t	srcaddressindex: 7;
	} Word2;
	struct
	{
		uint32_t	outputx: 12;
		uint32_t	outputy: 12;
		uint32_t	reserved: 1;
		uint32_t	destaddressindex: 7;
	} Word3;

	struct
	{
		uint32_t	inputwidth: 12;
		uint32_t	reserved1: 4;
		uint32_t	inputheight: 12;
		uint32_t	reserved2: 4;
	} Word4;
} SECMD_ROTATE;

typedef struct _SECMD_ALPHA
{
    struct
    {
        uint32_t    OpCode: 4;
        uint32_t    Width: 12;
        uint32_t    Height: 12;
        uint32_t    SelAlpha: 1;
        uint32_t    StreamType: 2;
        uint32_t    DfbSrcColorKey: 1;
    } Word1;

    struct
    {
        uint32_t    InputSX: 12;
        uint32_t    InputSY: 12;
        uint32_t    DfbSrcMaskAlpha: 1;
        uint32_t    SAddrIndex: 7;
    } Word2;

    struct
    {
        uint32_t    InputDX: 12;
        uint32_t    InputDY: 12;
        uint32_t    DfbSrcMaskColor: 1;
        uint32_t    DAddrIndex: 7;
    } Word3;

    struct
    {
        uint32_t    OutputX: 12;
        uint32_t    OutputY: 12;
        uint32_t    Reserved: 1;
        uint32_t    RAddrIndex: 7;
    } Word4;

    struct
    {
        uint32_t    InputAX: 12;
        uint32_t    InputAY: 12;
        uint32_t    AaddrIndex: 2;
        uint32_t    Reserved: 3;
                uint32_t  InputSelect: 1;
        uint32_t    StreamAlphaLocation: 1;
        uint32_t    StreamBigEndian: 1;
    } Word5;

    struct
    {
        uint32_t    RCAddrIndex: 7;
        uint32_t    Reserved1: 1;
        uint32_t    DCAddrIndex: 7;
        uint32_t    Reserved2: 1;
        uint32_t    SCAddrIndex: 7;
        uint32_t    Reserved3: 9;
    } Word6;

    struct
    {
        uint32_t    Reserved;
    } Word7;

    struct
    {
        uint32_t    Reserved;
    } Word8;

} SECMD_ALPHA;


typedef struct _SECMD_REPEAT_BITBLT
{
    //Command Type: Repeat Bitblit
    struct
    {
        uint32_t    OpCode: 4;                    //IO[3:0]: Operational Code
        //           - 0x09: Repeat_Bitblit operation

        uint32_t    Width: 12;                    //IO[15:4]: Width of image in pixels. 0 means 4096.

        uint32_t    Height: 12;                    //IO[27:16]: Height of image in pixels. 0 means 4096.

        uint32_t    InputSelect: 1;             //IO[28]: InputSelect
        //          - 0: select constant input (SE_Src_Color);
        //          - 1: set input vector
        //          - If use const input, we can't set src_data_big_endian swap in op.

        uint32_t    SelectDestAlpha: 3;            //IO[31:29]: This field is used to select the destination alpha value
        //             to be used in generation of the output(for output alpha only in directFB)
        //             - 000: select constant SE_Dest_Alpha
        //             - 001: select constant (1-SE_Dest_Alpha)
        //             - 010: select dest alpha (i.e. dest(A) - destination pixel by pixel alpha)
        //             - 011: select (1-dest(A) )
        //             - 100: select pixel by pixel src alpha (i.e. src(A))
        //             - 101: select (1-src(A))
        //             - others:  reserved
                //
        //             - Forbid specifying 101,011,100 and 101 in RGB565 and RGB888 format.
    } Word1;

    struct
    {
        uint32_t    OutputX: 12;                   //IO[11:0]: output starting X coordinate

        uint32_t    OutputY: 12;                   //IO[23:12]: output starting Y coordinate

                uint32_t  Reserved1: 2;                //IO[25:24]

        uint32_t    RopCode: 2;                    //IO[27:26]: ROP code for ROP operation
        uint32_t    SelectOutputAlpha: 1;        //IO[28]: SelectOutputAlpha
        //          - 0: use alpha from normal operation
        //          - 1: use constant alpha in SE_Rslt_Alpha register
        //          - This field is only use if color_format = 8888 or 4444 or 1555.
        //          - If this sel_output_alpha=1, then SE_Rslt_Alpha will overwrites the alpha
        //            value of the output for both alpha and ROP operation

                uint32_t  Reserved2: 1;                //IO[29]

        uint32_t    DestAddressIndex: 2;        //IO[31:30]: Dest address index, this will select the corresponding
        //             SE_Baddr and SE_Pitch registers
    } Word2;

    struct
    {
        uint32_t    InputX: 12;                   //IO[11:0]: input starting X coordinate

        uint32_t    InputY: 12;                   //IO[23:12]: input starting Y coordinate

        uint32_t    RopMode: 1;                    //IO[24]: ROP Mode
        //          - 0: alpha blending
        //          - 1: ROP mode

        uint32_t    ColorKey: 2;                //IO[26:25]: ColorKey
        //             - 00: no color key
        //             - 01: source color key
        //             - 10: destination color key

        uint32_t    SelectSrcAlpha: 3;            //IO[29:27]: This field is used to select the source alpha value to be
        //             used in generation of the output(for output alpha only in directFB)
        //             - 000:  select constant SE_Src_Alpha
        //             - 001: select constant (1-SE_Src_Alpha)
        //             - 010: select dest alpha (i.e. dest(A) - destination pixel by pixel alpha)
        //             - 011: select (1-dest(A) )
        //             - 100: select pixel by pixel src alpha (i.e. src(A))
        //             - 101: select (1-src(A))
        //             - others:  reserved
                //
        //             - Forbid specifying 011,011,100 and 101 in RGB565 and RGB888 format.

        uint32_t    SrcAddressIndex: 2;            //IO[31:30]: src address index, this will select the corresponding
        //             SE_Baddr and SE_Pitch registers.
    } Word3;

    struct
    {
                uint32_t  Width: 12;      //Width of image in pixels. 0 means 4096
                uint32_t  Height: 12;      //Height of image in pixels. 0 means 4096
                uint32_t  ROPCode1: 2;      //The most significant 2 bits of ROP modes.
                //       The combination,{ROP code1, ROP code} is used to represent the 16 operations.
                uint32_t  Reserved: 6;
    } Word4;

    struct
    {
        uint32_t    Reserved;                    //IO[31:0]:
    } Word5;

    struct
    {
        uint32_t    Reserved;                    //IO[31:0]: Reserved
    } Word6;

    struct
    {
        uint32_t    Reserved;                    //IO[31:0]: Reserved
    } Word7;

    struct
    {
        uint32_t    Reserved;                    //IO[31:0]: Reserved
    } Word8;


} SECMD_REPEAT_BITBLT;

typedef struct _SECMD_COLOR_SELECTION
{
        //Command Type: Color Selection
        struct
        {
                uint32_t  OpCode: 4;      //[3:0]: 4'b1011 color selection function
                uint32_t  Width: 12;      //[15:4]: Width of image in pixels; 0 means 4096
                uint32_t  Height: 12;      //[27:16]: Height of image in pixels; 0 means 4096
                uint32_t  Reserved: 3;     //[30:28]
                uint32_t  HSIOut: 1;       //[31]: output HSI
                //                - 1'b0: does color selection procedure. Output is 1byte/1pixel
                //                - 1'b1: does not do color selection procedure.
                //                         Output is HSI 3byte/1pixel. It means it perform RGB->HSI conversion

        } Word1;

        struct
        {
                uint32_t  SourceAddressIndex: 7;            //[6:0]: SRC address index[1:0], this will select
                //                                       the corresponding SE_Baddr and SE_Pitch registers.
                uint32_t  H1OREnable: 1;                //[7]: Hue1 OR enable bit
                uint32_t    IntputX: 12;                //[19:8]: Input start X
                uint32_t  IntputY: 12;                //[31:20: ]Input start Y
        } Word2;

        struct
        {
                uint32_t  DestAddressIndex: 7;            //[6:0]: DEST address index[1:0], this will select
                //                                       the corresponding SE_Baddr and SE_Pitch registers.
                uint32_t  H2OREnable: 1;                //[7]: Hue1 OR enable bit
                uint32_t    OutputX: 12;                //[19:8]: Input start X
                uint32_t  OutputY: 12;                //[31:20]: Input start Y
        } Word3;

        struct
        {
                uint32_t    S1Min: 8;                //[7:0]: Saturation min threshold value 1
                uint32_t  S1Max: 8;                //[15:8]: Saturation max threshold value 1
                uint32_t    I1Min: 8;                //[23:16]: Intensity min threshold value 1
                uint32_t  I1Max: 8;                //[31:24]: Intensity max threshold value 1
        } Word4;

        struct
        {
                uint32_t    I2Min: 8;                //[7:0]: Intensity min threshold value 2
                uint32_t  I2Max: 8;                //[15:8]: Intensity max threshold value 2
                uint32_t    H1Min: 8;                //[23:16]: Hu min threshold value 1
                uint32_t  H1Max: 8;                //[31:24]: Hu max threshold value 1
        } Word5;

        struct
        {
                uint32_t    H2Min: 8;                //[7:0]: Hue min threshold value 2
                uint32_t  H2Max: 8;                //[15:8]: Hue max threshold value 2
                uint32_t    S2Min: 8;                //[23:16]: Saturation min threshold value 2
                uint32_t  S2Max: 8;                //[31:24]: Saturation max threshold value 2
        } Word6;

        struct
        {
                uint32_t    Reserved: 32;
        } Word7;

        struct
        {
                uint32_t    Reserved: 32;
        } Word8;
} SECMD_COLOR_SELECTION;

typedef struct _SECMD_QTRANSFORM
{
        //Command Type: QTransform
        struct
        {
                uint32_t  OpCode: 4;            //[3:0]: =4'b1100
                uint32_t  Width: 12;            //[15:4]: Number of pixels in Width of source image
                uint32_t  Height: 12;           //[27:16]: Number of pixels in Height of source image
                uint32_t  BytesPerPixel: 2;     //[29:28]: Color Format, Bytes per pixel
                                                                  //2'b00: 1 byte/pixel
                                                                  //2'b01: 2 byte/pixel
                                                                  //2'b10: 3 byte/pixel
                                                                  //2'b11: 4 byte/pixel
                uint32_t  Reserved: 2;          //[31:30]
        } Word1;

        struct
        {
                uint32_t  Width: 12;        //[11:0]: Number of pixel in Width of destination
                uint32_t  Height: 12;       //[23:12]: Number of pixel in Height of destination
                uint32_t  Reserved: 8;          //[31:24]
        } Word2;

        struct
        {
                uint32_t  SrcAddrIndex: 2;        //Source Address index[1:0], this will select the corresponding SE_Baddr,SE_Pitch register.
                uint32_t  Reserved: 6;
                uint32_t  InputX: 12;          //Starting X coordinate of source image;
                uint32_t  InputY: 12;          //Starting Y coordinate of source image;
        } Word3;

        struct
        {
                uint32_t  DestAddrIndex: 2;        //Dest Address index[1:0], this will select the corresponding SE_Baddr,SE_Pitch register.
                uint32_t  Reserved: 6;
                uint32_t  OutputX: 12;          //Starting X coordinate of destination image;
                uint32_t  OutputY: 12;          //Starting Y coordinate of destination image;
        } Word4;

        struct
        {
                uint32_t    Reserved: 32;                //[31:24]: Hu max threshold value 1
        } Word5;

        struct
        {
                uint32_t    Reserved: 32;                //[31:24]: Saturation max threshold value 2
        } Word6;

        struct
        {
                uint32_t    Reserved: 32;
        } Word7;

        struct
        {
                uint32_t    Reserved: 32;
        } Word8;
} SECMD_QTRANSFORM;

typedef struct _SECMD_EXTEND_FORMAT_CONVERT
{
        struct
        {
                uint32_t  OpCode: 4;
                uint32_t  rslt_fmt: 5;
                uint32_t  Reserved1: 3;
                uint32_t  rslt_swap_chroma: 2;
                uint32_t  src_swap_chroma: 2;
                uint32_t  ycbcr_itu_en: 1;
                uint32_t  clip_10_option: 1;
                uint32_t  matrix_en: 1;
                uint32_t  sel_output_alpha: 1;
                uint32_t  argb_order_1st: 5;
                uint32_t  fmt16_swap_1b: 1;
                uint32_t  Reserved2: 6;
        } Word1;
        struct
        {
                uint32_t  rslt_output_x: 13;
                uint32_t  rslt_output_y: 13;
                uint32_t  Reserved: 6;
        } Word2;
        struct
        {
                uint32_t  rslt_c2_addr_index: 7;
                uint32_t  Reserved1: 1;
                uint32_t  rslt_c1_addr_index: 7;
                uint32_t  Reserved2: 1;
                uint32_t  rslt_addr_index: 7;
                uint32_t  rslt_blk_mode_interleave: 1;
                uint32_t  Reserved3: 8;
        } Word3;
        struct
        {
                uint32_t  src_input_width: 13;
                uint32_t  src_input_height: 13;
                uint32_t  src_fmt: 5;
                uint32_t  Reserved: 1;
        } Word4;
        struct
        {
                uint32_t  src_input_x: 13;
                uint32_t  src_input_y: 13;
                uint32_t  Reserved: 6;
        } Word5;
        struct
        {
                uint32_t  src_c2_addr_index: 7;
                uint32_t  Reserved1: 1;
                uint32_t  src_c1_addr_index: 7;
                uint32_t  Reserved2: 1;
                uint32_t  src_addr_index: 7;
                uint32_t  src_blk_mode_interleave: 7;
                uint32_t  Reserved3: 8;
        } Word6;
        struct
        {

                uint32_t    Reserved: 32;
        } Word7;

        struct
        {
                uint32_t    Reserved: 32;
        } Word8;
} SECMD_EX_FMTCONV;

typedef struct _SECMD_NOP
{
    //Command Type: NOP
    struct
    {
        uint32_t    OpCode: 4;                    //IO[3:0]: Operational Code
        //           - 0x0F: NOP
        uint32_t  Reserved: 28;                   //IO[31:4]: Reserved
    } Word1;
} SECMD_NOP;

typedef struct _SECMD_EXT_FMT_CONV
{
#if 0
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordReg1;
	struct
	{
		UINT32	RegisterValue;
	} WordReg1_1;
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordReg2;
	struct
	{
		UINT32	RegisterValue;
	} WordReg2_1;
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordReg3;
	struct
	{
		UINT32	RegisterValue;
	} WordReg3_1;

	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordReg4;
	struct
	{
		UINT32	RegisterValue;
	} WordReg4_1;
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordAddr0;
	struct
	{
		UINT32	RegisterValue;
	} WordAddr0_1;
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordPitch0;
	struct
	{
		UINT32	RegisterValue;
	} WordPitch0_1;
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordAddr1;
	struct
	{
		UINT32	RegisterValue;
	} WordAddr1_1;
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordPitch1;
	struct
	{
		UINT32	RegisterValue;
	} WordPitch1_1;
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordAddr2;
	struct
	{
		UINT32	RegisterValue;
	} WordAddr2_1;
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordPitch2;
	struct
	{
		UINT32	RegisterValue;
	} WordPitch2_1;
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordAddr3;
	struct
	{
		UINT32	RegisterValue;
	} WordAddr3_1;
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordPitch3;
	struct
	{
		UINT32	RegisterValue;
	} WordPitch3_1;
#endif
	struct
	{
		UINT32	opcode: 4;
		UINT32	rslt_fmt: 5;
		UINT32	lay_ctl: 1;
		UINT32	lay_num: 1;
		UINT32	reserved0: 1;
		UINT32	rslt_swp_chr: 2;
		UINT32	src_swp_chr: 2;
		UINT32	itu_en: 1;
		UINT32	reserved1: 1;
		UINT32	rslt_matx_en: 1;
		UINT32	out_alpha: 1;
		UINT32	rslt_argb_order: 5;
		UINT32	reserved2: 1;
		UINT32	src2_argb_order: 5;
		UINT32	reserved3: 1;
	} Word1;
	struct
	{
		UINT32	rslt_out_x: 13;
		UINT32	rslt_out_y: 13;
		UINT32	reserved0: 2;
		UINT32  rslt_rotate: 2;
		UINT32  rslt_mirror: 2;
	} Word2;
	struct
	{
		UINT32	rslt_chr2_addr_index: 7;
		UINT32	reserved0: 1;
		UINT32	rslt_chr1_addr_index: 7;
		UINT32	reserved1: 1;
		UINT32	rslt_addr_index: 7;
		UINT32	rslt_blk_mode_interleave: 1;
		UINT32	reserved2: 8;
	} Word3;
	struct
	{
		UINT32	src1_inpt_w: 13;
		UINT32	src1_inpt_h: 13;
		UINT32	src1_fmt: 5;
		UINT32	src1_mat_en: 1;
	} Word4;
	struct
	{
		UINT32	src1_inpt_x: 13;
		UINT32	src1_inpt_y: 13;
		UINT32	src1_argb_order: 5;
		UINT32	src1_fcv_stch: 1;
	} Word5;
	struct
	{
		UINT32	src1_chr2_addr_index: 7;
		UINT32	reserved0: 1;
		UINT32	src1_chr1_addr_index: 7;
		UINT32	reserved1: 1;
		UINT32	src1_addr_index: 7;
		UINT32	src1_blk_mode_interleave: 1;
		UINT32	src1_inpt_sel: 1;
		UINT32	src1_lg_en: 1;
		UINT32	reserved2: 6;
	} Word6;
	struct
	{
		UINT32	Reserved: 32;
	} Word7;
	struct
	{
		UINT32	Reserved: 32;
	} Word8;
} SECMD_EXT_FMT_CONV;

typedef struct _SECMD_EXT_FMT_CONV_BLIT
{
#if 0
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordReg1;
	struct
	{
		UINT32	RegisterValue;
	} WordReg1_1;
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordReg2;
	struct
	{
		UINT32	RegisterValue;
	} WordReg2_1;
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordReg3;
	struct
	{
		UINT32	RegisterValue;
	} WordReg3_1;
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordReg4;
	struct
	{
		UINT32	RegisterValue;
	} WordReg4_1;
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordReg5;
	struct
	{
		UINT32	RegisterValue;
	} WordReg5_1;
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordReg6;
	struct
	{
		UINT32	RegisterValue;
	} WordReg6_1;
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordAddr0;
	struct
	{
		UINT32	RegisterValue;
	} WordAddr0_1;
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordPitch0;
	struct
	{
		UINT32	RegisterValue;
	} WordPitch0_1;
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordAddr1;
	struct
	{
		UINT32	RegisterValue;
	} WordAddr1_1;
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordPitch1;
	struct
	{
		UINT32	RegisterValue;
	} WordPitch1_1;
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordAddr2;
	struct
	{
		UINT32	RegisterValue;
	} WordAddr2_1;
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordPitch2;
	struct
	{
		UINT32	RegisterValue;
	} WordPitch2_1;
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordAddr3;
	struct
	{
		UINT32	RegisterValue;
	} WordAddr3_1;
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordPitch3;
	struct
	{
		UINT32	RegisterValue;
	} WordPitch3_1;
#endif
	struct
	{
		UINT32	opcode: 4;
		UINT32	rslt_fmt: 5;
		UINT32	lay_ctl: 1;
		UINT32	lay_num: 1;
		UINT32	sync_vo: 1;
		UINT32	rslt_swp_chr: 2;
		UINT32	src_swp_chr: 2;
		UINT32	itu_en: 1;
		UINT32	clip_10b: 1;
		UINT32	rslt_matx_en: 1;
		UINT32	out_alpha: 1;
		UINT32	rslt_argb_order: 5;
		UINT32	reserved0: 1;
		UINT32	src2_argb_order: 5;
		UINT32	two_dc_mode: 1;
	} Word1;
	struct
	{
		UINT32	rslt_out_x: 13;
		UINT32	rslt_out_y: 13;
		UINT32	reserved0: 6;
	} Word2;
	struct
	{
		UINT32	rslt_chr2_addr_index: 7;
		UINT32	reserved0: 1;
		UINT32	rslt_chr1_addr_index: 7;
		UINT32	reserved1: 1;
		UINT32	rslt_addr_index: 7;
		UINT32	rslt_blk_mode_interleave: 1;
		UINT32	reserved2: 8;
	} Word3;
	struct
	{
		UINT32	src1_inpt_w: 13;
		UINT32	src1_inpt_h: 13;
		UINT32	src1_fmt: 5;
		UINT32	src1_mat_en: 1;
	} Word4;
	struct
	{
		UINT32	src1_inpt_x: 13;
		UINT32	src1_inpt_y: 13;
		UINT32	src1_argb_order: 5;
		UINT32	src1_fcv_stch: 1;
	} Word5;
	struct
	{
		UINT32	src1_chr2_addr_index: 7;
		UINT32	reserved0: 1;
		UINT32	src1_chr1_addr_index: 7;
		UINT32	reserved1: 1;
		UINT32	src1_addr_index: 7;
		UINT32	src1_blk_mode_interleave: 1;
		UINT32	src1_inpt_sel: 1;
		UINT32	reserved2: 7;
	} Word6;
	struct
	{
		UINT32	src2_inpt_x: 13;
		UINT32	src2_inpt_y: 13;
		UINT32	src2_fmt: 5;
		UINT32	src2_mat_en: 1;
	} Word7;
	struct
	{
		UINT32	src2_chr2_addr_index: 7;
		UINT32	reserved0: 1;
		UINT32	src2_chr1_addr_index: 7;
		UINT32	reserved1: 1;
		UINT32	src2_addr_index: 7;
		UINT32	src2_blk_mode_interleave: 1;
		UINT32	src2_inpt_sel: 1;
		UINT32	src2_swp_chr: 2;
		UINT32	reserved2: 1;
		UINT32	src2_lg: 1;
		UINT32	reserved3: 3;
	} Word8;
	struct
	{
		UINT32	sel_s2_alpha: 3;
		UINT32	reserved0: 1;
		UINT32	sel_s1_alpha: 3;
		UINT32	reserved1: 1;
		UINT32	lay_num_ext: 3;
		UINT32	reserved2: 21;
	} Word9;
	struct
	{
		UINT32	rop_code_1: 4;
		UINT32	fb_sel_destclr_blend_1: 4;
		UINT32	fb_sel_srcclr_blend_1: 4;
		UINT32	fb_demultiply_1: 1;
		UINT32	fb_blend_alphachannel_1: 1;
		UINT32	fb_blend_coloralpha_1: 1;
		UINT32	fb_colorize_1: 1;
		UINT32	fb_xor_1: 1;
		UINT32	fb_src_premultiply_1: 1;
		UINT32	fb_src_premulcolor_1: 1;
		UINT32	fb_dst_premultiply_1: 1;
		UINT32	src_clr_transparency_1: 1;
		UINT32	src_clr_transform_1: 2;
		UINT32	reserved0: 2;
		UINT32	color_key_1: 2;
		UINT32	blend_sel_1: 4;
		UINT32	reserved1: 1;
	} Word10;
	struct
	{
		UINT32	gl_sel_destclr_1: 6;
		UINT32	reserved0: 2;
		UINT32	gl_sel_srctclr_1: 6;
		UINT32	reserved1: 2;
		UINT32	gl_sel_destalpha_1: 6;
		UINT32	reserved2: 2;
		UINT32	gl_sel_srctalpha_1: 6;
		UINT32	reserved3: 2;
	} Word11;
	struct
	{
		UINT32	Reserved: 32;
	} Word12;
	struct
	{
		UINT32	Reserved: 32;
	} Word13;
	struct
	{
		UINT32	Reserved: 32;
	} Word14;
	struct
	{
		UINT32	Reserved: 32;
	} Word15;
	struct
	{
		UINT32	Reserved: 32;
	} Word16;
} SECMD_EXT_FMT_CONV_BLIT;


typedef struct _SECMD_EXT_STCH_BLIT
{
#if 0
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordReg1;
	struct
	{
		UINT32	RegisterValue;
	} WordReg1_1;
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordReg2;
	struct
	{
		UINT32	RegisterValue;
	} WordReg2_1;
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordReg3;
	struct
	{
		UINT32	RegisterValue;
	} WordReg3_1;

	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordReg4;
	struct
	{
		UINT32	RegisterValue;
	} WordReg4_1;
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordReg5;
	struct
	{
		UINT32	RegisterValue;
	} WordReg5_1;
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordReg6;
	struct
	{
		UINT32	RegisterValue;
	} WordReg6_1;
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordAddr0;
	struct
	{
		UINT32	RegisterValue;
	} WordAddr0_1;
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordPitch0;
	struct
	{
		UINT32	RegisterValue;
	} WordPitch0_1;
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordAddr1;
	struct
	{
		UINT32	RegisterValue;
	} WordAddr1_1;
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordPitch1;
	struct
	{
		UINT32	RegisterValue;
	} WordPitch1_1;
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordAddr2;
	struct
	{
		UINT32	RegisterValue;
	} WordAddr2_1;
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordPitch2;
	struct
	{
		UINT32	RegisterValue;
	} WordPitch2_1;
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordAddr3;
	struct
	{
		UINT32	RegisterValue;
	} WordAddr3_1;
	struct
	{
		UINT32	OpCode: 4;
		UINT32	RegisterAddress: 12;
		UINT32	Clut: 1;
		UINT32	Reserved: 15;
	} WordPitch3;
	struct
	{
		UINT32	RegisterValue;
	} WordPitch3_1;
#endif
	struct
	{
		UINT32	opcode: 4;
		UINT32	rslt_fmt: 5;
		UINT32	lay_ctl: 1;
		UINT32	lay_num: 1;
		UINT32	reserved0: 1;
		UINT32	rslt_swp_chr: 2;
		UINT32	src_swp_chr: 2;
		UINT32	itu_en: 1;
		UINT32	reserved1: 1;
		UINT32	rslt_matx_en: 1;
		UINT32	out_alpha: 1;
		UINT32	rslt_argb_order: 5;
		UINT32	reserved2: 1;
		UINT32	src2_argb_order: 5;
		UINT32	reserved3: 1;
	} Word1;
	struct
	{
		UINT32	rslt_out_x: 13;
		UINT32	rslt_out_y: 13;
		UINT32	reserved0: 2;
		UINT32  rslt_rotate: 2;
		UINT32  rslt_mirror: 2;
	} Word2;
	struct
	{
		UINT32	rslt_chr2_addr_index: 7;
		UINT32	reserved0: 1;
		UINT32	rslt_chr1_addr_index: 7;
		UINT32	reserved1: 1;
		UINT32	rslt_addr_index: 7;
		UINT32	rslt_blk_mode_interleave: 1;
		UINT32	reserved2: 8;
	} Word3;
	struct
	{
		UINT32	src1_inpt_w: 13;
		UINT32	src1_inpt_h: 13;
		UINT32	src1_fmt: 5;
		UINT32	src1_mat_en: 1;
	} Word4;
	struct
	{
		UINT32	src1_inpt_x: 13;
		UINT32	src1_inpt_y: 13;
		UINT32	src1_argb_order: 5;
		UINT32	src1_fcv_stch: 1;
	} Word5;
	struct
	{
		UINT32	src1_chr2_addr_index: 7;
		UINT32	reserved0: 1;
		UINT32	src1_chr1_addr_index: 7;
		UINT32	reserved1: 1;
		UINT32	src1_addr_index: 7;
		UINT32	src1_blk_mode_interleave: 1;
		UINT32	src1_inpt_sel: 1;
		UINT32	src1_lg_en: 1;
		UINT32	reserved2: 6;
	} Word6;
	struct
	{
		UINT32	src2_inpt_x: 13;
		UINT32	src2_inpt_y: 13;
		UINT32	src2_fmt: 5;
		UINT32	src2_mat_en: 1;
	} Word7;
	struct
	{
		UINT32	src2_chr2_addr_index: 7;
		UINT32	reserved0: 1;
		UINT32	src2_chr1_addr_index: 7;
		UINT32	reserved1: 1;
		UINT32	src2_addr_index: 7;
		UINT32	src2_blk_mode_interleave: 1;
		UINT32	src2_inpt_sel: 1;
		UINT32	src2_swp_chr: 2;
		UINT32	reserved2: 1;
		UINT32	src2_lg: 1;
		UINT32	reserved3: 3;
	} Word8;
	struct
	{
		UINT32	sel_s2_alpha: 3;
		UINT32	reserved0: 1;
		UINT32	sel_s1_alpha: 3;
		UINT32	reserved1: 1;
		UINT32	lay_num_ext: 3;
		UINT32	reserved2: 21;
	} Word9;
	struct
	{
		UINT32	rop_code_1: 4;
		UINT32	fb_sel_destclr_blend_1: 4;
		UINT32	fb_sel_srcclr_blend_1: 4;
		UINT32	fb_demultiply_1: 1;
		UINT32	fb_blend_alphachannel_1: 1;
		UINT32	fb_blend_coloralpha_1: 1;
		UINT32	fb_colorize_1: 1;
		UINT32	fb_xor_1: 1;
		UINT32	fb_src_premultiply_1: 1;
		UINT32	fb_src_premulcolor_1: 1;
		UINT32	fb_dst_premultiply_1: 1;
		UINT32	src_clr_transparency_1: 1;
		UINT32	src_clr_transform_1: 2;
		UINT32	reserved0: 2;
		UINT32	color_key_1: 2;
		UINT32	blend_sel_1: 4;
		UINT32	reserved1: 1;
	} Word10;
	struct
	{
		UINT32	gl_sel_destclr_1: 6;
		UINT32	reserved0: 2;
		UINT32	gl_sel_srctclr_1: 6;
		UINT32	reserved1: 2;
		UINT32	gl_sel_destalpha_1: 6;
		UINT32	reserved2: 2;
		UINT32	gl_sel_srctalpha_1: 6;
		UINT32	reserved3: 2;
	} Word11;
	struct
	{
		UINT32	stch1_out_w: 13;
		UINT32	stch1_out_h: 13;
		UINT32	stch1_src: 3;
		UINT32	stch1_h_en: 1;
		UINT32	stch1_v_en: 1;
		UINT32	stch1_algo: 1;
	} Word12;
	struct
	{
		UINT32	src2_inpt_w: 13;
		UINT32	src2_inpt_h: 13;
		UINT32	Reserved: 6;
	} Word13;
	struct
	{
		UINT32	src2_out_x: 13;
		UINT32	src2_out_y: 13;
		UINT32	Reserved: 6;
	} Word14;
	struct
	{
		UINT32	stch2_out_w: 13;
		UINT32	stch2_out_h: 13;
		UINT32	stch2_src: 3;
		UINT32	stch2_h_en: 1;
		UINT32	stch2_v_en: 1;
		UINT32	stch2_algo: 1;
	} Word15;
	struct
	{
		UINT32	Reserved: 32;
	} Word16;
} SECMD_EXT_STCH_BLIT;




typedef union _SEREG_CLR_FMT
{
    uint32_t  Value;
    struct
    {
        //Register: CLR_FMT (0x1800_C060)
        uint32_t  Format: 4;                //IO[3:0]: Format
        //  -4'b0001: HSI
        //  -4'b0010: Index8
        //  -4'b0100: ARGB565
        //  -4'b0101: ARGB1555
        //  -4'b0110: ARGB4444
        //  -4'b0111: ARGB8888
        //  -4'b1000: Y (stretch & rotate command only)
        //  -4'b1001: CbCr (stretch & rotate command only)
        //  -4'b1010: YCbCr420 (alpha command only)
        //  -4'b1011: YCbCr422 (alpha command only)
        //  -4'b1111: RGB888
        //  else:reserved

        uint32_t  write_enable1: 1;         //IO[4]: Write enable for IO[3:0]
        uint32_t  alpha_loc: 1;             //IO[5]: Location of alpha pixel if the format is 8888, 4444, 1555 mode, this bit
        //         specifies whether the alpha pixel location is the leftmost (=0) or rightmost
        //         of a pixel
        uint32_t  write_enable2: 1;         //IO[6]: Write enable for IO[5]
        uint32_t  Reserved1: 6;             //IO[12:7]: Reserved
        uint32_t  alpha_loc2: 1;            //IO[13]: Specify the output alpha location in format conversion ARGB to ARGB mode
        uint32_t  write_enable5: 1;         //IO[14]: Write enable for IO[13]
        uint32_t  big_endian_i1: 1;         //IO[15]: SE works on big endian. If input color format is little endian, SE will swap data to big endian before operation
        uint32_t  write_enable6: 1;         //IO[16]: Write enable for IO[15]
        uint32_t  big_endian_i2: 1;         //IO[17]: Specify input color format for bitblit/alpha destination data (source data is specified by big_endian_i1)
        uint32_t  write_enable7: 1;         //IO[18]: Write enable for IO[17]
        uint32_t  big_endian_o: 1;          //IO[19]: Specify endian type for output color format. If output color format is little endian, SE will swap data to little endian after operation
        uint32_t  write_enable8: 1;         //IO[20]: Write enable for IO[19]
        uint32_t  rounding_en: 1;           //IO[21]: Rounding option for color format truncation (i.e. RGB888 to RGB565)
        //        - 0: disable rounding
        //        - 1: enable rounding
        uint32_t  write_enable10: 1;        //IO[22]: Write enable for IO[21]
        uint32_t  Reserved2: 9;             //IO[31:23]: Reserved
    } Fields;
} SEREG_CLR_FMT;

typedef enum _COLORKEYMODE
{
    ColorKey_Src,
    ColorKey_Des,
    ColorKey_None,
    ColorKey_Src_Des,
} COLORKEY_MODE;

typedef enum _STRETCH_COEFF_MODE
{
    SCALING_MODE_AUTO = 0,                // count stretch coefficient automatically
    SCALING_MODE_BY_USER = 1            // using stretch coefficient by user define

} STRETCH_COEFF_MODE;

#endif  // #if !TEST_IN_AP

typedef struct _SE_COLOR_FORMAT_EX
{
    bool bInputSrcColorFormatBigEndian;             // For field: big_endian_i1
    bool bInputDestColorFormatBigEndian;            // For field: big_endian_i2
    bool bOutputColorFormatBigEndian;               // For field: big_endian_o
    bool bEnableRoundingOption;                     // For field: rounding_en
} SE_COLOR_FORMAT_EX;

// Extra Parameters for Command Bitblit on Saturn. Saturn Spec page 31
//
typedef struct _SE_BITBLIT_EX
{
    bool bSyncVO;                                   // For Word2, field: sync_vo
    SEINFO_SOURCE_COLOR_TRANSFORM srcClrTranform;   // For Word4, field: src_clr_tranform
    bool bEnableSrcClrTransparency;                 // For Word4, field: src_clr_transparency
    bool bEnableDirectFB;                           // For Word4, field: directFB
    bool bEnableDfbDstPremultiply;                  // For Word4, field: fb_dst_premultiply
    bool bEnableDfbSrcPremulcolor;                  // For Word4, field: fb_src_premulcolor
    bool bEnableDfbSrcPremultiply;                  // For Word4, field: fb_src_premultiply
    bool bEnableDfbXor;                             // For Word4, field: fb_xor
    bool bEnableDfbColorize;                        // For Word4, field: fb_colorize
    bool bEnableDfbReplaceSrcAlphaWithConstAlpha;   // For Word4, field: fb_blend_coloralpha
    bool bEnableDfbModulateSrcAlphaWithConstAlpha;  // For Word4, field: fb_blend_alphachannel
    bool bEnableDfbDemultiply;                      // For Word4, field: fb_demultiply
    bool bEnableLinearGraident;                     // For Word4, field: linear_gradient_en
    SEINFO_DFB_CLR_BLEND_MODE selSrcClrBlend;       // For Word4, field: fb_sel_srcclr_blend
    SEINFO_DFB_CLR_BLEND_MODE selDestClrBlend;      // For Word4, field: fb_sel_destclr_blend
    SEINFO_DFB_OPERATION      dfbOperation;         // For Word2, field: ROP code

    uint8_t  constAlphaValue;                       // This will update Register: SRC_ALPHA. For fb_src_premulcolor, fb_blend_coloralpha, fb_blend_alphachannel
    uint8_t  constAlphaValueForBlendColorAlpha;     // This will update Register: fd_blend_coloralpha. MAC2SE USE the dedicated REGISTER while using fd_blend_coloralpha.
    uint32_t constColorValue;                       // This will update the Register: SRC_COLOR. For fb_colorize. LinearGradient src 1
    uint32_t constColorValueLG;                     // This will update the Register: SRC_COLOR. For fb_colorize. LinearGradient src 2
    bool     bEnableAlphaStreamMode;                // For Word5 alpha_stream_mode;
    // The following variables are needed for source color transform
    // Saturn Spec, page 40, Register: SRC_CLR_RED, SCR_CLR_GREEN, SRC_CLR_BLUE, SRC_CLR_ALPHA
    SEREG_SRC_CLR_RED   srcColorRed;
    SEREG_SRC_CLR_GREEN srcColorGreen;
    SEREG_SRC_CLR_BLUE  srcColorBlue;
    SEREG_SRC_CLR_ALPHA srcColorAlpha;
    SEINFO_GRADIENT     GradientDir;
} SE_BITBLIT_EX;

typedef struct _SE_FORMAT_CONVERT_EX
{
    SEINFO_ROPMODE ropMode;
    SEINFO_ALPHAMODE destAlphaModeSelect;           // For Word5, field: sel_dest_alpha
    uint8_t destAplhaValue;
    bool bSyncVO;                                   // For Word5, field: sync_vo
    SEINFO_OUTPUT_ALPHAMODE outputAlphaModeSelect;  // For Word5, field: sel_output_alpha
    SEINFO_ROPCODE ropCode;                         // For Word5, field: ROP code
    SEINFO_ALPHAMODE srcAlphaModeSelect;            // For Word5, field: sel_src_alpha
    uint8_t srcAplhaValue;
    SEINFO_COLORKEY colorKeySelect;                 // For Word5, field: bitblit_color_key
    SEINFO_SOURCE_COLOR_TRANSFORM srcClrTranform;   // For Word5, field: src_clr_tranform
    bool bEnableSrcClrTransparency;                 // For Word5, field: src_clr_transparency
    bool bEnableDirectFB;                           // For Word2, field: directFB
    bool bEnableDfbDstPremultiply;                  // For Word5, field: fb_dst_premultiply
    bool bEnableDfbSrcPremulcolor;                  // For Word5, field: fb_src_premulcolor
    bool bEnableDfbSrcPremultiply;                  // For Word5, field: fb_src_premultiply
    bool bEnableDfbXor;                             // For Word5, field: fb_xor
    bool bEnableDfbColorize;                        // For Word5, field: fb_colorize
    bool bEnableDfbReplaceSrcAlphaWithConstAlpha;   // For Word5, field: fb_blend_coloralpha
    bool bEnableDfbModulateSrcAlphaWithConstAlpha;  // For Word5, field: fb_blend_alphachannel
    bool bEnableDfbDemultiply;                      // For Word5, field: fb_demultiply
    SEINFO_DFB_CLR_BLEND_MODE selSrcClrBlend;       // For Word5, field: fb_sel_srcclr_blend
    SEINFO_DFB_CLR_BLEND_MODE selDestClrBlend;      // For Word5, field: fb_sel_destclr_blend
    SEINFO_DFB_OPERATION dfbOperation;              // For Word5, field: ROP code
    bool bEnableFormatConvertWithBitblit;           // For Word2, field: Format conversion + Bitblit

    uint8_t constAlphaValue;                        // This will update Register: SRC_ALPHA. For fb_src_premulcolor, fb_blend_coloralpha, fb_blend_alphachannel
    uint8_t constAlphaValueForBlendColorAlpha;      // This will update Register: fd_blend_coloralpha. MAC2SE USE the dedicated REGISTER while using fd_blend_coloralpha.
    uint32_t constColorValue;                       // This will update the Register: SRC_COLOR. For fb_colorize.   Gradient_src


    // The following variables are needed for source color transform
    // Saturn Spec, page 40, Register: SRC_CLR_RED, SCR_CLR_GREEN, SRC_CLR_BLUE, SRC_CLR_ALPHA
    SEREG_SRC_CLR_RED srcColorRed;
    SEREG_SRC_CLR_GREEN srcColorGreen;
    SEREG_SRC_CLR_BLUE srcColorBlue;
    SEREG_SRC_CLR_ALPHA srcColorAlpha;
} SE_FORMAT_CONVERT_EX;

typedef struct _SE_STRETCH_EX
{
    SEINFO_ALPHAMODE destAlphaModeSelect;           // For Word5, field: sel_dest_alpha
    uint8_t destAplhaValue;
    bool bSyncVO;                                   // For Word5, field: sync_vo
    SEINFO_OUTPUT_ALPHAMODE outputAlphaModeSelect;  // For Word5, field: sel_output_alpha
    SEINFO_ROPCODE ropCode;                         // For Word5, field: ROP code
    SEINFO_ALPHAMODE srcAlphaModeSelect;            // For Word5, field: sel_src_alpha
    uint8_t srcAplhaValue;
    SEINFO_COLORKEY colorKeySelect;                 // For Word5, field: bitblit_color_key
    SEINFO_SOURCE_COLOR_TRANSFORM srcClrTranform;   // For Word5, field: src_clr_tranform
    bool bEnableSrcClrTransparency;                 // For Word5, field: src_clr_transparency
    bool bEnableDirectFB;                           // For Word2, field: directFB
    bool bEnableDfbDstPremultiply;                  // For Word5, field: fb_dst_premultiply
    bool bEnableDfbSrcPremulcolor;                  // For Word5, field: fb_src_premulcolor
    bool bEnableDfbSrcPremultiply;                  // For Word5, field: fb_src_premultiply
    bool bEnableDfbXor;                             // For Word5, field: fb_xor
    bool bEnableDfbColorize;                        // For Word5, field: fb_colorize
    bool bEnableDfbReplaceSrcAlphaWithConstAlpha;   // For Word5, field: fb_blend_coloralpha
    bool bEnableDfbModulateSrcAlphaWithConstAlpha;  // For Word5, field: fb_blend_alphachannel
    bool bEnableDfbDemultiply;                      // For Word5, field: fb_demultiply
    SEINFO_DFB_CLR_BLEND_MODE selSrcClrBlend;       // For Word5, field: fb_sel_srcclr_blend
    SEINFO_DFB_CLR_BLEND_MODE selDestClrBlend;      // For Word5, field: fb_sel_destclr_blend
    SEINFO_DFB_OPERATION dfbOperation;              // For Word5, field: ROP code
    bool bEnableStretchWithBitblit;                 // For Word2, field: Stretch + Bitblit

    uint8_t constAlphaValue;                        // This will update Register: SRC_ALPHA. For fb_src_premulcolor, fb_blend_coloralpha, fb_blend_alphachannel
    uint8_t constAlphaValueForBlendColorAlpha;      // This will update Register: fd_blend_coloralpha. MAC2SE USE the dedicated REGISTER while using fd_blend_coloralpha.
    uint32_t constColorValue;                       // This will update the Register: SRC_COLOR. For fb_colorize.

    SEINFO_STRETCH_REPLACE_ALPHA replaceAlpha;        //For Register STRETCH repl_alpha
    SEINFO_STRETCH_REPLACE_COLOR replaceColor;      //For Register STRETCH repl_color

    // The following variables are needed for source color transform
    // Saturn Spec, page 40, Register: SRC_CLR_RED, SCR_CLR_GREEN, SRC_CLR_BLUE, SRC_CLR_ALPHA
    SEREG_SRC_CLR_RED srcColorRed;
    SEREG_SRC_CLR_GREEN srcColorGreen;
    SEREG_SRC_CLR_BLUE srcColorBlue;
    SEREG_SRC_CLR_ALPHA srcColorAlpha;
} SE_STRETCH_EX;

typedef struct _RECT_SE
{
    int x;
    int y;
    int w;
    int h;
} RECT_SE;

#define BITMAP_WIDTH    80
#define BITMAP_HEIGHT   60
static uint32_t _gStretchBmp[]=
{
    0xff7b91c0, 0xff7e92c1, 0xff7f95c4, 0xff8193c4, 0xff8397c6, 0xff8597c5, 0xff8898c6, 0xff8a9bc7,
    0xff8a9bca, 0xff8c9dcb, 0xff8e9ecc, 0xff919ecc, 0xff92a0cd, 0xff96a3ce, 0xff97a4cf, 0xff9ba7d2,
    0xff9ba7d2, 0xff9da9d4, 0xff9ea9d4, 0xffa0add7, 0xffa1add7, 0xffa1afd4, 0xffa2b0d7, 0xffa3b2d6,
    0xffa5b4d6, 0xffa7b4d6, 0xffaab4d6, 0xffaab6d6, 0xffacb6d6, 0xffadb6d5, 0xffafb7d7, 0xffaeb6d7,
    0xffafb7d7, 0xffaeb6d6, 0xffabb4d8, 0xffa9b0d5, 0xffa8b0d4, 0xffa5aed4, 0xffa6b0d6, 0xffa4aed3,
    0xffa3add6, 0xffa0add2, 0xffa1add5, 0xffa0abd3, 0xff9eabd3, 0xff9da9d3, 0xff9ba9d3, 0xff9aaad3,
    0xff9baad4, 0xff9aa9d2, 0xff97aad4, 0xff96a7d3, 0xff95a7d4, 0xff94a5d6, 0xff90a3d6, 0xff879ad4,
    0xff7f95d6, 0xff7e91d6, 0xff7a8fd3, 0xff768fd2, 0xff708bd0, 0xff6d8ad2, 0xff6989d0, 0xff6284d2,
    0xff5d84d1, 0xff5d83cf, 0xff5a7fd1, 0xff5b80d2, 0xff5b80d3, 0xff597fd0, 0xff5a7ecb, 0xff5b7fca,
    0xff587cc9, 0xff5579ca, 0xff5176c6, 0xff5075c7, 0xff4f74c5, 0xff4e73c4, 0xff4d72c3, 0xff4b70c2,
    0xff7d93c1, 0xff8093c3, 0xff8095c4, 0xff8295c4, 0xff8496c4, 0xff8798c6, 0xff8799c7, 0xff8a9bc9,
    0xff8b9cca, 0xff8c9dcb, 0xff909ecc, 0xff93a0cf, 0xff95a2d1, 0xff97a3d1, 0xff96a4d2, 0xff9aa6d3,
    0xff9caad4, 0xff9facd4, 0xffa0afd4, 0xffa2b1d4, 0xffa5b3d4, 0xffa6b4d4, 0xffa7b5d4, 0xffabb5d4,
    0xffadb5d3, 0xffaeb4d3, 0xffaeb3d4, 0xffb1b5d6, 0xffb0b4d4, 0xffafb3d3, 0xffb0b4d5, 0xffb2b2d4,
    0xffb0b1d4, 0xffb0b1d5, 0xffacafd5, 0xffa7abd2, 0xffa6aad2, 0xffa5a9d0, 0xffa4a8d2, 0xffa5a7d3,
    0xffa2a6d0, 0xffa1a4d1, 0xffa1a4d1, 0xff9fa6d1, 0xffa1a4cf, 0xff9fa5d1, 0xffa0a4ce, 0xffa0a5cf,
    0xff9ea5cf, 0xff9ea5d0, 0xff9fa8ce, 0xff9da8d0, 0xff9ea9d0, 0xff9caacf, 0xff99a9d1, 0xff93a4d1,
    0xff88a0d1, 0xff7d9ad2, 0xff7294d6, 0xff6f8fd5, 0xff6c8dd5, 0xff6688d5, 0xff6483d6, 0xff6283d4,
    0xff6685d2, 0xff6484cf, 0xff6384ce, 0xff6285cb, 0xff6283cc, 0xff5d80cc, 0xff5d7fce, 0xff5d7ecb,
    0xff5b7fc9, 0xff577cca, 0xff567bca, 0xff5479c9, 0xff5378c7, 0xff5076c4, 0xff4f73c2, 0xff4d72bf,
    0xff8094c2, 0xff8395c3, 0xff8395c3, 0xff8597c5, 0xff8596c4, 0xff8497c5, 0xff8698c6, 0xff8799c7,
    0xff8a9acb, 0xff8c9cce, 0xff8f9dce, 0xff919fcf, 0xff94a2cf, 0xff97a5d2, 0xff9ba8d3, 0xff9dadcf,
    0xffa1b1d3, 0xffa2b1d1, 0xffa5b3d0, 0xffa8b3d0, 0xffabb2d0, 0xffadb3d1, 0xffacb2d0, 0xffaeb1d2,
    0xffabafd1, 0xffadb1d1, 0xffacb0d2, 0xffadafd1, 0xffadb0d1, 0xffadb0d5, 0xffacafd3, 0xffacafd3,
    0xffa9afd4, 0xffa8acd3, 0xffa6abd3, 0xffa6a8d4, 0xffa1a6d3, 0xffa1a7d2, 0xffa1a6d3, 0xff9fa4d1,
    0xff9ea4d2, 0xff9ca3d1, 0xff9ba3d1, 0xff9ba2d0, 0xff98a0d1, 0xff98a0cf, 0xff999fd0, 0xff999fcf,
    0xff979ecc, 0xff989ecc, 0xff9d9fcf, 0xff9ca1cf, 0xff9da2ce, 0xff9aa0cf, 0xff99a1d1, 0xff97a2cd,
    0xff93a1cf, 0xff889dd1, 0xff7c98cf, 0xff7295d2, 0xff7194d4, 0xff6b90d5, 0xff678cd5, 0xff6387d4,
    0xff6586d3, 0xff6886d0, 0xff6885cf, 0xff6a84cd, 0xff6985cc, 0xff6783cc, 0xff6283c9, 0xff6282ca,
    0xff5c7fcc, 0xff597dcb, 0xff577bca, 0xff557aca, 0xff547ac7, 0xff5378c6, 0xff5276c3, 0xff5074c1,
    0xff8496c4, 0xff8597c5, 0xff8798c6, 0xff8797c5, 0xff8797c5, 0xff8698c7, 0xff889ac9, 0xff8698c9,
    0xff889bcb, 0xff8a9ccc, 0xff8ea0d0, 0xff90a3cf, 0xff95a8cf, 0xff9cabcf, 0xffa1b0ce, 0xffa4afce,
    0xffa6afcf, 0xffa8b0d0, 0xffabafce, 0xffaaafce, 0xffaaaecf, 0xffaaaed2, 0xffaaadd0, 0xffa9afd0,
    0xffa7acd1, 0xffa7add1, 0xffa9aed1, 0xffa8aed3, 0xffa8aed5, 0xffa8aed4, 0xffa9add4, 0xffa7acd4,
    0xffa7aed4, 0xffa4acd1, 0xffa3abd3, 0xffa1a8d4, 0xffa0a7d2, 0xffa1a8d5, 0xff9fa6d2, 0xff9ea7d3,
    0xff9ba4d2, 0xff9aa2d0, 0xff98a4d1, 0xff96a0d1, 0xff959fd1, 0xff939dcf, 0xff939dce, 0xff909dce,
    0xff909acc, 0xff929acc, 0xff939dcd, 0xff919acd, 0xff919ad0, 0xff9098cd, 0xff9198cd, 0xff8e96ce,
    0xff8c96cc, 0xff8a94ce, 0xff8595d0, 0xff8595ce, 0xff8095cd, 0xff7b95ce, 0xff7595d0, 0xff7393cf,
    0xff7290cf, 0xff6d8dce, 0xff6989cd, 0xff6985cc, 0xff6884ce, 0xff6784cc, 0xff6584cb, 0xff6383cb,
    0xff6283c9, 0xff5c80cc, 0xff597ecd, 0xff597dcb, 0xff557cc6, 0xff5579c5, 0xff5378c3, 0xff5275c2,
    0xff8598c4, 0xff8797c4, 0xff8899c6, 0xff879ac9, 0xff889ac8, 0xff899ac9, 0xff899bcb, 0xff899cca,
    0xff8e9ecc, 0xff8ea1ce, 0xff93a6cc, 0xff9aa8cb, 0xff9daacd, 0xffa1aaca, 0xffa3accd, 0xffa6abcd,
    0xffa7abcc, 0xffa7aace, 0xffa5aace, 0xffa6abcc, 0xffa5aad1, 0xffa5abd0, 0xffa6acd1, 0xffa5acd1,
    0xffa6add2, 0xffa5aed3, 0xffa4add2, 0xffa7add3, 0xffa6aed3, 0xffa7afd4, 0xffa5add3, 0xffa5aed2,
    0xffa4acd3, 0xffa5acd4, 0xffa3abd1, 0xffa3a9d3, 0xffa1a9d1, 0xffa0a7d2, 0xffa0a9d3, 0xffa0a9d3,
    0xff9fa7d1, 0xff9aa5d3, 0xff99a4d1, 0xff98a4d2, 0xff95a3d2, 0xff95a1d1, 0xff929ecf, 0xff919ecd,
    0xff909ccd, 0xff8e9bcd, 0xff909acd, 0xff8d9acf, 0xff8b97ce, 0xff8797cb, 0xff8593d0, 0xff8391cd,
    0xff8391ce, 0xff8491cd, 0xff808fca, 0xff8590cb, 0xff8591cd, 0xff8292cc, 0xff7e91cb, 0xff8093cb,
    0xff7e95c9, 0xff7b94cb, 0xff7891cb, 0xff6f8fcd, 0xff6a8bcf, 0xff6386cd, 0xff6082cf, 0xff5f82d1,
    0xff5e81d0, 0xff5c81cd, 0xff5c7fcd, 0xff597eca, 0xff587bc7, 0xff577bc7, 0xff567ac6, 0xff5479c0,
    0xff8698c6, 0xff8798c6, 0xff8a9aca, 0xff8a9cc8, 0xff899cc9, 0xff8a9ec9, 0xff8da0c9, 0xff91a3c8,
    0xff92a3c8, 0xff97a6c7, 0xff9ba7c9, 0xff9ea6ca, 0xff9ea4ca, 0xff9ca4ca, 0xff9ea4cb, 0xff9ea5cb,
    0xffa0a5cb, 0xffa1a6cc, 0xffa1a7cd, 0xffa1a9cd, 0xffa1aacf, 0xffa2abd0, 0xffa2acd0, 0xffa3acd1,
    0xffa2add0, 0xffa6aed3, 0xffa5add2, 0xffa5add2, 0xffa6aed3, 0xffa6aed3, 0xffa6aed3, 0xffa6aed3,
    0xffa4add2, 0xffa4add1, 0xffa4acd3, 0xffa4acd2, 0xffa3acd2, 0xffa2abd2, 0xffa1aad2, 0xffa0a8d0,
    0xff9ea8d2, 0xff9ba9d1, 0xff9aa7d0, 0xff99a6cf, 0xff98a4d0, 0xff95a3d1, 0xff95a2d0, 0xff94a0cf,
    0xff919dcc, 0xff909ccf, 0xff8d9acf, 0xff899acd, 0xff8897cf, 0xff8695d1, 0xff8193ce, 0xff8292ce,
    0xff8291cc, 0xff8091cc, 0xff7f90cb, 0xff768bcd, 0xff7a8bcc, 0xff7c8dcb, 0xff7e8dca, 0xff7f8eca,
    0xff818fca, 0xff8293c9, 0xff8092ca, 0xff7993c8, 0xff708fcd, 0xff688ece, 0xff5e87d0, 0xff5c83d3,
    0xff5e81d2, 0xff5d7fd1, 0xff5c7fcc, 0xff5b7fca, 0xff597fc9, 0xff567dc8, 0xff577bc6, 0xff567ac6,
    0xff8799c7, 0xff899bc9, 0xff8c9fca, 0xff8ea2ca, 0xff90a3c7, 0xff93a3c7, 0xff92a2c8, 0xff96a3c8,
    0xff99a3c7, 0xff9aa1c8, 0xff9ba2c9, 0xff99a1c9, 0xff9aa1cb, 0xff98a0cb, 0xff98a1cc, 0xff9aa3ca,
    0xff9ea6cd, 0xff9ea7cd, 0xff9da7cd, 0xff9fa6cb, 0xffa0a7ce, 0xffa2a9ce, 0xffa0a9ce, 0xffa0aace,
    0xffa3abcf, 0xffa4add2, 0xffa5add2, 0xffa5add2, 0xffa5add2, 0xffa6add2, 0xffa6aed3, 0xffa5add2,
    0xffa6aed3, 0xffa5add2, 0xffa4acd1, 0xffa5add2, 0xffa4abd1, 0xffa4acd4, 0xffa2aad0, 0xff9fa9d1,
    0xff9fa8d1, 0xff9da7d2, 0xff9ea7d2, 0xff9ba6d1, 0xff99a4d1, 0xff98a4d1, 0xff97a2cf, 0xff95a1d0,
    0xff939ece, 0xff919dd1, 0xff8e9bcf, 0xff8c9bce, 0xff8797ce, 0xff8496d1, 0xff8595ce, 0xff8596ce,
    0xff7f91cc, 0xff7d91ca, 0xff7a8fca, 0xff778ccc, 0xff7789ce, 0xff788dcc, 0xff788bcb, 0xff798bc8,
    0xff7a8bc8, 0xff7c8bc7, 0xff798bc9, 0xff778ac9, 0xff728cc9, 0xff6e8ccc, 0xff6389ce, 0xff6189ce,
    0xff6087cd, 0xff5e83cd, 0xff5a7fcd, 0xff597dca, 0xff597dcb, 0xff587cc8, 0xff587cc8, 0xff577bc7,
    0xff8b9fca, 0xff8ea2cb, 0xff91a5c6, 0xff95a6c6, 0xff97a4c7, 0xff96a3c6, 0xff97a1c6, 0xff989ec7,
    0xff969dc8, 0xff979fc9, 0xff979fca, 0xff959fcb, 0xff93a1cc, 0xff94a1ce, 0xff95a2cc, 0xff98a3cd,
    0xff97a4cf, 0xff99a4cc, 0xff99a4cc, 0xff9da6cd, 0xff9ba8cd, 0xff9eaace, 0xff9fa8cd, 0xffa0aace,
    0xffa3aad0, 0xffa2acd0, 0xffa4acd1, 0xffa5add2, 0xffa7afd4, 0xffa6aed3, 0xffa5add2, 0xffa4acd1,
    0xffa5add2, 0xffa4acd1, 0xffa4acd1, 0xffa3abd0, 0xffa3abd0, 0xffa4acd2, 0xffa2a9d1, 0xffa1a8d1,
    0xffa0a9d2, 0xff9fa8d3, 0xff9da6d1, 0xff9ea6d1, 0xff98a6ce, 0xff99a5d0, 0xff98a3cf, 0xff96a2cf,
    0xff94a0d0, 0xff919dcf, 0xff8f9cd2, 0xff8c9bd0, 0xff899ace, 0xff8798cd, 0xff8798cd, 0xff8495cb,
    0xff8293cc, 0xff7e92cb, 0xff7f92cb, 0xff7a90c8, 0xff788eca, 0xff788dcd, 0xff758bcb, 0xff728acc,
    0xff7288c9, 0xff7588c6, 0xff7386ca, 0xff6d83ce, 0xff6c84ca, 0xff6d86c9, 0xff6b87cb, 0xff6c89c9,
    0xff698ac9, 0xff6187c9, 0xff5c84ca, 0xff5b7fcb, 0xff597cc8, 0xff587cca, 0xff587dca, 0xff5b7cc5,
    0xff8ea4c6, 0xff96a6c6, 0xff97a4c6, 0xff97a5c7, 0xff96a3c6, 0xff95a1c6, 0xff929ec6, 0xff909cc6,
    0xff8f9cc6, 0xff909cc6, 0xff909dca, 0xff919ecc, 0xff92a0cc, 0xff93a0cc, 0xff93a0cc, 0xff95a1ce,
    0xff95a2ce, 0xff96a4cd, 0xff97a4ce, 0xff97a3cc, 0xff9aa6cc, 0xff9da7cd, 0xff9fa8cb, 0xffa0a9ce,
    0xffa1a8ce, 0xffa2aacf, 0xffa3abd0, 0xffa3abd0, 0xffa3abd0, 0xffa2aacf, 0xffa2aacf, 0xffa4acd1,
    0xffa3abd2, 0xffa2aad1, 0xffa4acd0, 0xffa3abd1, 0xffa1a9d0, 0xffa2aacf, 0xffa0a9d0, 0xffa0a7d0,
    0xff9fa8d1, 0xff9ea6d1, 0xff9ea8d3, 0xff9ba7d1, 0xff9ba6d1, 0xff99a6d0, 0xff97a4ce, 0xff95a1cf,
    0xff94a0d0, 0xff94a0d0, 0xff909dd1, 0xff8d9bd1, 0xff8c9cd0, 0xff8a9acd, 0xff8898cd, 0xff8797cb,
    0xff8596ca, 0xff8493cb, 0xff8092c9, 0xff7e91ca, 0xff7a8fc7, 0xff778dc7, 0xff7389cb, 0xff7089c8,
    0xff6f89c6, 0xff7187c9, 0xff6d85c8, 0xff6e85c6, 0xff6c82c7, 0xff6d83c7, 0xff6f83c7, 0xff6f86c6,
    0xff6d84c2, 0xff6a86c2, 0xff6586c2, 0xff6085c6, 0xff5981c7, 0xff587dc5, 0xff577cc9, 0xff5a7bc8,
    0xff95a1c6, 0xff93a1c4, 0xff96a2c8, 0xff94a0c6, 0xff94a0c6, 0xff929dc6, 0xff909dc8, 0xff8f9cc8,
    0xff8f9dc9, 0xff8f9cc8, 0xff8f9dca, 0xff909ecb, 0xff929fcc, 0xff93a0cd, 0xff94a1cc, 0xff93a0cd,
    0xff95a2cd, 0xff95a2cd, 0xff95a1cd, 0xff97a2cf, 0xff98a5ce, 0xff9ba4cd, 0xff9da8cb, 0xff9ea7cb,
    0xffa0a8cd, 0xffa1aace, 0xffa0a9ce, 0xffa0aacd, 0xffa1a9ce, 0xffa2aace, 0xffa2aace, 0xffa1a9d0,
    0xffa3abd2, 0xffa2aad2, 0xffa1a8d2, 0xffa0a9d1, 0xffa1a9d1, 0xffa0a8cf, 0xffa0a8d1, 0xff9ea8d3,
    0xffa0a7d4, 0xff9fa7d2, 0xff9ea8d3, 0xff9ea7d2, 0xff9da5d1, 0xff9ba6cf, 0xff98a4d0, 0xff97a3d0,
    0xff96a3d2, 0xff95a0d1, 0xff939fcf, 0xff909dd0, 0xff8f9ad0, 0xff8c97ce, 0xff8c9acc, 0xff8a95cc,
    0xff8695c9, 0xff8495ca, 0xff8494c9, 0xff8192c7, 0xff7c8fca, 0xff798cc7, 0xff758ac9, 0xff7289c8,
    0xff7087c7, 0xff6e86c8, 0xff6d84c8, 0xff6c83c7, 0xff6c82c5, 0xff6b82c7, 0xff6a81c5, 0xff6a7fc4,
    0xff6c80c1, 0xff6c80be, 0xff6e83be, 0xff6b81bc, 0xff6282bf, 0xff5f81c0, 0xff5b7ec3, 0xff587bc2,
    0xff909dc5, 0xff919dc4, 0xff929ec6, 0xff909dc5, 0xff92a0c6, 0xff929ec8, 0xff909dc8, 0xff909dc9,
    0xff909dc9, 0xff8f9cc9, 0xff8f9cc9, 0xff919ecb, 0xff919ecb, 0xff929fcd, 0xff94a1cd, 0xff94a1cd,
    0xff93a0cb, 0xff95a2cd, 0xff93a0cc, 0xff94a2ce, 0xff95a2ca, 0xff98a2ca, 0xff9aa4cd, 0xff9ba5cb,
    0xff9da7cc, 0xff9fa7cc, 0xff9fa8cd, 0xffa0a7cc, 0xffa0a9ce, 0xff9fa7cf, 0xffa1a8cf, 0xffa1aacf,
    0xffa1a9d0, 0xffa0a7ce, 0xff9fa6d0, 0xff9ea5d0, 0xff9ea5d0, 0xff9ea5d0, 0xff9ea7d0, 0xff9ea6d0,
    0xff9fa8d0, 0xff9fa9ce, 0xff9ea7d1, 0xff9ea6d2, 0xff9da4d1, 0xff9ba4d0, 0xff9aa3d0, 0xff9aa2d1,
    0xff96a1cf, 0xff96a0cd, 0xff939fce, 0xff919dd0, 0xff909ccf, 0xff8f9bcf, 0xff8d9ace, 0xff8a97cc,
    0xff8a96cb, 0xff8794c9, 0xff8394c7, 0xff8291c6, 0xff7e8fca, 0xff7a8fc7, 0xff788cc7, 0xff768ac3,
    0xff7389c4, 0xff7188c3, 0xff6e85c5, 0xff6c83c5, 0xff6a83c4, 0xff6a81c2, 0xff6880c1, 0xff697ec0,
    0xff677dbc, 0xff687cbb, 0xff697db6, 0xff6a7eb8, 0xff677eb7, 0xff647eb7, 0xff607db9, 0xff5c7cb9,
    0xff8996c3, 0xff8d99c5, 0xff8d9ac6, 0xff8f9cc7, 0xff8f9cc9, 0xff929eca, 0xff929fcb, 0xff919eca,
    0xff919eca, 0xff909dca, 0xff909dc9, 0xff909ecb, 0xff929fcb, 0xff93a0cd, 0xff93a0cc, 0xff94a1cd,
    0xff93a1cf, 0xff95a1ce, 0xff95a1cd, 0xff94a1cc, 0xff93a0ca, 0xff96a4cc, 0xff97a4ca, 0xff9ca5cc,
    0xff9da6cc, 0xff9ea6cb, 0xff9ea7cc, 0xff9ea8ce, 0xff9fa7cf, 0xff9fa7ce, 0xff9ea9cd, 0xff9fa7ce,
    0xff9ea7cd, 0xff9fa7ce, 0xff9da6cf, 0xff9da4ce, 0xff9ca5cd, 0xff9da6ce, 0xff9da5ce, 0xff9ea7ce,
    0xff9ea5cf, 0xff9fa5ce, 0xff9ea6ce, 0xff9ea6d0, 0xff9ea7d0, 0xff9ca5cf, 0xff9ba4cf, 0xff9ca3cf,
    0xff97a3ce, 0xff939fd0, 0xff949ecf, 0xff919ece, 0xff909dcc, 0xff8f9bcc, 0xff8d99cc, 0xff8c98cc,
    0xff8b97cb, 0xff8995c9, 0xff8894ca, 0xff8291c6, 0xff7f92c6, 0xff7d8cc8, 0xff7b8dc7, 0xff768bc4,
    0xff7588c4, 0xff7288c3, 0xff6d85c2, 0xff6c84c1, 0xff6b83c0, 0xff6981bf, 0xff677fbf, 0xff667ebd,
    0xff647dbc, 0xff647bbd, 0xff647ab7, 0xff657ab7, 0xff6479b7, 0xff6579b3, 0xff627bb3, 0xff617ab2,
    0xff8493c3, 0xff8696c2, 0xff8998c5, 0xff8a9ac7, 0xff8c9bc6, 0xff8f9cc8, 0xff8e9cc6, 0xff8f9bc9,
    0xff909dc8, 0xff909cca, 0xff919ecb, 0xff919dcc, 0xff919dcc, 0xff939ecc, 0xff94a1ce, 0xff93a0cb,
    0xff93a0cb, 0xff94a1cd, 0xff95a2ce, 0xff94a1cf, 0xff94a2ce, 0xff98a5cd, 0xff98a3cc, 0xff96a4cb,
    0xff9aa3cd, 0xff9ca4cc, 0xff9ba4cd, 0xff9da5ce, 0xffa0a6ce, 0xffa0a6cd, 0xffa2a5ce, 0xffa5a4cc,
    0xffa9a4cc, 0xffaea5cc, 0xffb0a6c9, 0xffbaa7c9, 0xffbda7c6, 0xffc4a8c7, 0xffc5a9c6, 0xffc6aac7,
    0xffc5a8c8, 0xffc5a8c7, 0xffc0a7c8, 0xffbba7cb, 0xffb8a7ca, 0xffafa7cc, 0xffa9a4cd, 0xffa4a5cc,
    0xff9ea2cf, 0xff9ca2ce, 0xff969fcf, 0xff959fcd, 0xff909cce, 0xff919ece, 0xff8f9dcc, 0xff8d99c9,
    0xff8c98ca, 0xff8a97cb, 0xff8695c9, 0xff8293c5, 0xff8291c4, 0xff7d8fc8, 0xff788cc7, 0xff788dc6,
    0xff758ac3, 0xff7388c1, 0xff7186c1, 0xff6d82c1, 0xff6b83c0, 0xff6980bf, 0xff6681bc, 0xff647fbd,
    0xff607ebd, 0xff627aba, 0xff617ab9, 0xff6079b7, 0xff5f79b4, 0xff6177b1, 0xff6176af, 0xff6075ae,
    0xff8295c1, 0xff8596c5, 0xff8295c3, 0xff8497c2, 0xff8596c3, 0xff8799c5, 0xff8c9ac7, 0xff8c9bc7,
    0xff8b9bc7, 0xff8e9cc8, 0xff8f9cc9, 0xff8f9cc9, 0xff909ecb, 0xff929fca, 0xff929fcb, 0xff929fcc,
    0xff94a1cd, 0xff95a2cd, 0xff94a1ce, 0xff94a1ca, 0xff96a3cd, 0xff99a2ce, 0xff99a3ca, 0xff9aa3ca,
    0xff9da1ca, 0xffa0a3ca, 0xffa6a4ca, 0xffb4a7c9, 0xffc3aac4, 0xffd3afc4, 0xffddb4c0, 0xffe9bdbe,
    0xffefc5bf, 0xfff3cdbf, 0xfffbd5c1, 0xfffcdfc1, 0xffffe6c4, 0xfffde9c5, 0xffffebc6, 0xffffecc8,
    0xffffedc4, 0xffffedc6, 0xffffeac2, 0xffffe5c0, 0xffffdebe, 0xffffd2bb, 0xfffbc8bd, 0xfff4bdbd,
    0xffe2b3c0, 0xffcfa8c2, 0xffbca5c7, 0xffaaa1c9, 0xffa09ecb, 0xff989dc9, 0xff939bcc, 0xff8c99cb,
    0xff8a98c7, 0xff8896c7, 0xff8595c8, 0xff8392c6, 0xff8090c4, 0xff7c8ec5, 0xff7a8bc6, 0xff788ac3,
    0xff758ac2, 0xff7287c2, 0xff7085be, 0xff6d85c0, 0xff6b84bb, 0xff6880bd, 0xff657fbc, 0xff637fbb,
    0xff607cbb, 0xff5f7cbb, 0xff5e7bb5, 0xff5f78b6, 0xff5e78b4, 0xff5d75b1, 0xff5e74ad, 0xff5d73ac,
    0xff9ea9cc, 0xff899bc3, 0xff8597c4, 0xff8293c2, 0xff8797c6, 0xff8899c3, 0xff8899c5, 0xff889ac5,
    0xff8c99c6, 0xff8c9ac6, 0xff8c9ac8, 0xff8f9bc8, 0xff919eca, 0xff8f9cc9, 0xff919ecb, 0xff929fca,
    0xff919ecb, 0xff93a2cc, 0xff949fc9, 0xff98a1cc, 0xff99a0c9, 0xff9fa3c8, 0xffa6a5c8, 0xffb5a7c6,
    0xffc6adc2, 0xffddb6bc, 0xfff2c4bd, 0xfff7d5be, 0xfff1e2c7, 0xffe0e6ce, 0xffd0e5da, 0xffc1dde0,
    0xffb7d6e9, 0xffb1cff1, 0xffaecbf4, 0xffafc8f9, 0xffb0c6fb, 0xffb1c4fc, 0xffb0c5fc, 0xffb2c4fc,
    0xffb3c8fe, 0xffb7ccff, 0xffbad2fe, 0xffbddbfe, 0xffc3e2fb, 0xffd0eef4, 0xffdbfcec, 0xffebffe1,
    0xfffbffd2, 0xfffff8c8, 0xffffe4bf, 0xffffcdb7, 0xffecb9bb, 0xffd4aabe, 0xffb7a0c1, 0xffa29bc3,
    0xff9798c7, 0xff8c95c5, 0xff8892c7, 0xff8493c5, 0xff7e92c3, 0xff7d8ec2, 0xff798bc0, 0xff7889bf,
    0xff7489be, 0xff7388bc, 0xff6f84be, 0xff6c82bb, 0xff6a82ba, 0xff677fba, 0xff647ebb, 0xff637cb8,
    0xff5f7cb9, 0xff5d7ab7, 0xff5d7ab7, 0xff5b78b4, 0xff5a77b3, 0xff5b74b0, 0xff5b73ab, 0xff5970a9,
    0xff97a4c7, 0xff90a0c8, 0xff8197c2, 0xff8291c0, 0xff8295c3, 0xff8697c5, 0xff8798c3, 0xff8899c5,
    0xff8697c6, 0xff8899c8, 0xff8c9ac5, 0xff8d9ac9, 0xff8d9bc8, 0xff8e9ccc, 0xff8e9bc9, 0xff8e9dcb,
    0xff919ecc, 0xff949ecb, 0xff9ba0ca, 0xffa6a3c9, 0xffb7a9c6, 0xffceb1c4, 0xffe9c4c0, 0xfff0d3c2,
    0xffe6e2cb, 0xffcee5da, 0xffb8d9e6, 0xffa9c9f0, 0xffa7bcf1, 0xffaab5ec, 0xffacb2e9, 0xffb0b4e6,
    0xffb2b7e1, 0xffb8bce2, 0xffbbbfe0, 0xffbdc1df, 0xffbdc4df, 0xffc1c6de, 0xffc0c6de, 0xffc1c8dd,
    0xffc6cbe4, 0xffcccde5, 0xffcecfe8, 0xffcfcee8, 0xffd0ccee, 0xffcfc8f0, 0xffccc4f5, 0xffc2c3fb,
    0xffb9c5ff, 0xffb8cdff, 0xffbdddfc, 0xffcff0f0, 0xffe9fddd, 0xfffff3c8, 0xffffdcbc, 0xfff2bfb6,
    0xffd6abba, 0xffb49fbf, 0xff9c95c4, 0xff8e90bf, 0xff848dc0, 0xff7d8cc0, 0xff7889be, 0xff7788bd,
    0xff7387bb, 0xff7086bd, 0xff7084be, 0xff6c81bb, 0xff6980bb, 0xff657fb6, 0xff647eb6, 0xff627ab3,
    0xff5e7bb2, 0xff5c7ab5, 0xff5c79b5, 0xff5a77b3, 0xff5b75b3, 0xff5973ae, 0xff5773a8, 0xff576ea7,
    0xff8899c5, 0xff8699c2, 0xff7991c1, 0xff7d94c2, 0xff8393c1, 0xff8396c2, 0xff8394c2, 0xff8394c2,
    0xff8495c3, 0xff8697c5, 0xff8797c6, 0xff8896c5, 0xff8b9ac5, 0xff8c9ac7, 0xff8e9cc7, 0xff929bc7,
    0xff9d9ec7, 0xffaea2c6, 0xffc3afc2, 0xffdac0c2, 0xffe6d3c5, 0xffd8e1d0, 0xffbdd9e4, 0xffa4c6ee,
    0xffa1b6f2, 0xffa8b3ec, 0xffb1b5e6, 0xffafb6dc, 0xffadb7d8, 0xffadb5d7, 0xffabb3d6, 0xffadb6d6,
    0xffb1b5d8, 0xffb3b8db, 0xffb6bbd9, 0xffb9bddd, 0xffbabfdd, 0xffbcbfde, 0xffbec0e0, 0xffbfc4de,
    0xffc2c5e0, 0xffc4c7e2, 0xffc4c6e2, 0xffc7c8e3, 0xffc7c8e4, 0xffc9cbe5, 0xffc9cce4, 0xffcbcde2,
    0xffcacfe2, 0xffcdcde6, 0xffc9c6e7, 0xffbfbeee, 0xffb3b9f8, 0xffaac1ff, 0xffb3d6f8, 0xffd2eee5,
    0xffeeefcc, 0xfffad6b9, 0xffe7bab5, 0xffc3a3b7, 0xffa493bb, 0xff8c8abb, 0xff7f87b9, 0xff7586bb,
    0xff7386b9, 0xff6f84bb, 0xff6c83bb, 0xff6a80b9, 0xff687eb7, 0xff647eb7, 0xff637cb5, 0xff617ab3,
    0xff5e78b1, 0xff5d78b3, 0xff5976b2, 0xff5976b0, 0xff5774b0, 0xff5471ac, 0xff5371a9, 0xff526ea7,
    0xffa5adcd, 0xff899bc4, 0xff768ec0, 0xff7b90c0, 0xff7b91c2, 0xff8091c2, 0xff8595c4, 0xff8596c2,
    0xff8295c3, 0xff8294c1, 0xff8494c2, 0xff8997c4, 0xff8996c4, 0xff9299c4, 0xff9f9dc3, 0xffb2a5c2,
    0xffccb4c2, 0xffdaccc2, 0xffd4d9ce, 0xffb9d4dd, 0xffa4c0eb, 0xffa2b2ed, 0xffa8b2e2, 0xffabb4dd,
    0xffaab5d7, 0xffaab3d5, 0xffabb2d6, 0xffaab2d6, 0xffa7b0d5, 0xffa7aed4, 0xffa7b1d5, 0xffa9b1d4,
    0xffacb4d5, 0xffb0b6d7, 0xffb5bada, 0xffb6bbdb, 0xffb7bcdc, 0xffbabedb, 0xffbabedc, 0xffbdc0df,
    0xffbdc1dd, 0xffbec3df, 0xffbfc3de, 0xffc1c5e0, 0xffc2c5e0, 0xffc2c4df, 0xffc0c3de, 0xffc0c4e0,
    0xffbfc3df, 0xffbdc2df, 0xffbcbfdd, 0xffbcc0dd, 0xffbec1db, 0xffc0c2db, 0xffbbbbe2, 0xffb0b1ee,
    0xffa1b3f4, 0xffa5c8f0, 0xffc8e1db, 0xffeae2c4, 0xffecc3b3, 0xffcda8b0, 0xffa890b6, 0xff8a83b5,
    0xff7882b7, 0xff7182b6, 0xff6c80b7, 0xff687fb7, 0xff667bb5, 0xff647ab2, 0xff6278b0, 0xff5f78b0,
    0xff5c77ae, 0xff5b76ad, 0xff5b74ab, 0xff5672ab, 0xff5570a9, 0xff5370a7, 0xff516ea6, 0xff506da3,
    0xffa4afcd, 0xff778dbd, 0xff738bbe, 0xff778dbf, 0xff798fc1, 0xff7c90c0, 0xff7e90c1, 0xff8091c1,
    0xff8294c2, 0xff8694c3, 0xff8693c1, 0xff8b93c1, 0xff9d99c0, 0xffb7a7c1, 0xffceb9bf, 0xffd4cdc5,
    0xffc1d5d3, 0xffa5c4e0, 0xff9bade7, 0xffa0ace1, 0xffa7afd5, 0xffa8b2d2, 0xffa8b2d3, 0xffa8b2d6,
    0xffa7afd3, 0xffa5afd3, 0xffa3aed2, 0xffa5afd3, 0xffa3abd0, 0xffa4aed1, 0xffa3abd0, 0xffa6aed2,
    0xffaab1d5, 0xffadb3d6, 0xffb0b6d6, 0xffb4b9d9, 0xffb6badb, 0xffb6b9d9, 0xffb9bcda, 0xffbabcdb,
    0xffbbbedb, 0xffbabeda, 0xffbbbfdc, 0xffbbbedc, 0xffbbbfdb, 0xffbabeda, 0xffbbbfdc, 0xffbabddb,
    0xffb9bcdd, 0xffb7b9da, 0xffb6b9d8, 0xffb4b8d8, 0xffb3b8d9, 0xffb3b7d7, 0xffb3b7d5, 0xffb0b6d3,
    0xffb1b7d2, 0xffadb1d9, 0xffa2a6e6, 0xff94aef0, 0xffa8cee2, 0xffd1deca, 0xffe3ccb4, 0xffcaa6ad,
    0xffa68dae, 0xff837eae, 0xff6e7eb3, 0xff677db2, 0xff647ab2, 0xff6179b1, 0xff5e76ae, 0xff5d75ad,
    0xff5b76ad, 0xff5874aa, 0xff5673ab, 0xff5472aa, 0xff556fa7, 0xff5170a9, 0xff4f6da5, 0xff4f6da3,
    0xff7d92c0, 0xff718bc3, 0xff718cbd, 0xff768dbf, 0xff768dbf, 0xff768cc0, 0xff768ebf, 0xff778bc0,
    0xff7d8ec1, 0xff858fbe, 0xff9795be, 0xffb1a1c1, 0xffc8b6be, 0xffcaccc7, 0xffb3ced5, 0xff98b6e3,
    0xff9ba7e3, 0xffa0a7da, 0xffa1adcf, 0xffa2aece, 0xffa4acd1, 0xffa2aed0, 0xff9fadd0, 0xff9eabce,
    0xff9eaacf, 0xffa1adcf, 0xffa1abcd, 0xffa1aacf, 0xffa1abd1, 0xffa0a9d1, 0xffa0a8d0, 0xffa2aad0,
    0xffa6add2, 0xffa8b1d5, 0xffabb4d6, 0xffafb6d6, 0xffb3b8d7, 0xffb2b8d7, 0xffb5bada, 0xffb5bada,
    0xffb5bbda, 0xffb6bad9, 0xffb5bad7, 0xffb7bbda, 0xffb7b9d9, 0xffb7bad9, 0xffb5bada, 0xffb4b9d8,
    0xffb1b6d6, 0xffb1b6d5, 0xffafb5d5, 0xffadb3d4, 0xffabb1d4, 0xffa9b0d1, 0xffa7aed2, 0xffa6afd2,
    0xffa5aed0, 0xffa3acd0, 0xffa6afcf, 0xffa9aece, 0xffa0a4d8, 0xff909fe9, 0xff94bde3, 0xffbed9ca,
    0xffdbc8b2, 0xffc2a0ab, 0xff9a83a8, 0xff757bac, 0xff647aae, 0xff5e76ad, 0xff5f76ad, 0xff5b75ae,
    0xff5a74ab, 0xff5672ab, 0xff5572aa, 0xff5371a7, 0xff536ea8, 0xff526fa6, 0xff506da7, 0xff4d6ba2,
    0xff6f88bc, 0xff6787be, 0xff7089c3, 0xff748cbd, 0xff778dbf, 0xff7c8ebf, 0xff798cbf, 0xff7c8bc1,
    0xff8c8dbb, 0xffa799bd, 0xffbfb2bd, 0xffcacac4, 0xffafccd7, 0xff95b3e2, 0xff95a2e1, 0xff9ea9d6,
    0xff9daccd, 0xff9daace, 0xff9baace, 0xff9ba9ce, 0xff9eaace, 0xff9ca9ce, 0xff9ba7d0, 0xff9ba6cf,
    0xff9aa8d0, 0xff9ba6ce, 0xff9ba7d0, 0xff9ba8d0, 0xff9ba7cf, 0xff9aa7d2, 0xff9ca7cf, 0xffa3acd0,
    0xffa4acd1, 0xffa7afd4, 0xffa9b1d5, 0xffaab2d7, 0xffaeb3d7, 0xffb0b6d6, 0xffb0b7d8, 0xffb3b8d8,
    0xffb2b7d7, 0xffb2b7d8, 0xffb1b7d8, 0xffb1b6d6, 0xffb2b7d6, 0xffb1b6d6, 0xffafb5d5, 0xffadb2d3,
    0xffadb3d5, 0xffa8b0d4, 0xffa6b0d5, 0xffa7add2, 0xffa4acd0, 0xffa2aad0, 0xffa3abd1, 0xffa2aace,
    0xffa0a8cd, 0xff9fa7cf, 0xff9fa6cd, 0xff9da4cb, 0xff9ca5ce, 0xff9ea8c9, 0xff9ea0d2, 0xff8a96df,
    0xff87b1de, 0xffb2cdc7, 0xffc8bcae, 0xffad8ea6, 0xff8378a6, 0xff6575a7, 0xff5c74ac, 0xff5972ab,
    0xff5771ab, 0xff5872aa, 0xff5571a8, 0xff5170a6, 0xff506da6, 0xff516fa5, 0xff4e6ca2, 0xff4d6ba1,
    0xff9ba5c6, 0xff8597c0, 0xff6c89bc, 0xff708bc0, 0xff778bbd, 0xff7c8abd, 0xff878cbc, 0xffa596bc,
    0xffbeadbb, 0xffcdc6c2, 0xffb2cdd2, 0xff94b3e2, 0xff95a2e1, 0xff9fa7d3, 0xff9da9ce, 0xff9baacf,
    0xff9aa7d2, 0xff97a4d1, 0xff99a6d2, 0xff97a5ce, 0xff9aa7d1, 0xff9aa7d0, 0xff98a5d0, 0xff99a6d0,
    0xff99a6d0, 0xff9aa7d2, 0xff99a5d1, 0xff99a5cf, 0xff98a5d0, 0xff99a5ce, 0xff9ba6d1, 0xffa1aacf,
    0xffa3abcf, 0xffa4acd1, 0xffa6add3, 0xffa6aed2, 0xffa8b1d3, 0xffaab3d4, 0xffadb4d6, 0xffadb5d5,
    0xffafb6d5, 0xffaeb4d5, 0xffadb4d5, 0xffadb3d6, 0xffadb3d5, 0xffabb1d3, 0xffa9b1d4, 0xffa9b1d3,
    0xffa5afcf, 0xffa5acd2, 0xffa4acd1, 0xffa1a9cf, 0xffa0a8cc, 0xffa0a8cd, 0xff9ea8cd, 0xff9da4cd,
    0xff9da3cd, 0xff99a2ca, 0xff9aa1c9, 0xff959eca, 0xff969dc9, 0xff969fc8, 0xff929dc9, 0xff93a0c3,
    0xff9096ca, 0xff7c89da, 0xff7ba9d1, 0xffaac1ba, 0xffb4a1a7, 0xff8f7d9f, 0xff6e72a1, 0xff5b71a6,
    0xff576ea4, 0xff546ea4, 0xff536da5, 0xff516da5, 0xff516da7, 0xff4e6ba4, 0xff4d6ba1, 0xff4b699f,
    0xffaeb6cf, 0xff909dc2, 0xff728abc, 0xff7187ba, 0xff7e89bd, 0xff9690b9, 0xffb7a3ba, 0xffd0c4be,
    0xffc5d6ce, 0xff98bee2, 0xff8e9fe5, 0xff9aa2d6, 0xff9baacd, 0xff98a7d2, 0xff97a4d0, 0xff96a2cd,
    0xff97a4cf, 0xff97a3cf, 0xff96a2ce, 0xff97a3d0, 0xff98a4d0, 0xff97a3ce, 0xff97a4ce, 0xff96a2cf,
    0xff97a4d0, 0xff96a3cf, 0xff97a3cf, 0xff96a3d0, 0xff96a3cf, 0xff98a4d0, 0xff99a6d0, 0xff9fa8d1,
    0xffa1aad1, 0xffa3acd2, 0xffa3acd2, 0xffa4abd0, 0xffa5acd1, 0xffa6aed4, 0xffa8b0d5, 0xffa8b1d6,
    0xffa8b1d3, 0xffa9b1d6, 0xffa7afd4, 0xffa8afd4, 0xffa6afd3, 0xffa6afd3, 0xffa4abd1, 0xffa2aacf,
    0xffa2aad0, 0xff9fa8ce, 0xffa0a8cd, 0xff9fa6ca, 0xff98a4cc, 0xff97a1ca, 0xff96a1c9, 0xff96a0ca,
    0xff939ec8, 0xff929dc8, 0xff929cc8, 0xff909cc5, 0xff8e9bc3, 0xff8e99c5, 0xff8a98c2, 0xff8b98c2,
    0xff8893bf, 0xff8696bd, 0xff8087c5, 0xff6a84cf, 0xff79a9c4, 0xffaab0ae, 0xffa48b9e, 0xff7a739b,
    0xff606fa3, 0xff546da3, 0xff536ea6, 0xff526ea5, 0xff4e6ca4, 0xff4c6ba1, 0xff4b6a9f, 0xff4b699f,
    0xff9ca7c6, 0xff7689ba, 0xff6681ba, 0xff7181b8, 0xff8781b1, 0xffaea3b7, 0xffb6c3c2, 0xff95bdd8,
    0xff7c9ce1, 0xff8c99d4, 0xff90a1c9, 0xff8e9ecc, 0xff8b9cca, 0xff8a9ac9, 0xff8a9bcc, 0xff8b9cca,
    0xff8c9ccb, 0xff8d9fcc, 0xff8f9ecd, 0xff8ea0cd, 0xff92a1cf, 0xff92a2cf, 0xff93a1cf, 0xff94a2d1,
    0xff929fcf, 0xff91a0cf, 0xff93a0cf, 0xff92a1d0, 0xff97a3ce, 0xff97a4d0, 0xff9aa7d3, 0xff9ba7d2,
    0xff9eaad4, 0xff9daad0, 0xff9ca8d2, 0xff9fa8d0, 0xffa0a9d2, 0xffa0abd2, 0xffa3abd0, 0xffa4acd1,
    0xffa5acd2, 0xffa5acd2, 0xffa4abcf, 0xffa5add4, 0xffa3abd0, 0xff9fa9d2, 0xff9fa7d1, 0xff9ba7d1,
    0xff9ba4cd, 0xff99a3cd, 0xff96a0ca, 0xff949fca, 0xff939fc9, 0xff929ec8, 0xff909dc7, 0xff8f9bc6,
    0xff8d9ac4, 0xff8f9bc4, 0xff8d9ac3, 0xff8c97c4, 0xff8a95c2, 0xff8895c1, 0xff8794c0, 0xff8591c1,
    0xff848fc0, 0xff7c8dbb, 0xff788abb, 0xff7a8cb8, 0xff737fc5, 0xff628dcc, 0xff8aafb6, 0xffaa9ca0,
    0xff8c7a9a, 0xff676e9f, 0xff566ba0, 0xff4f6ba4, 0xff4e6aa1, 0xff4d689f, 0xff4c689f, 0xff47669c,
    0xff98a5c5, 0xff969fc2, 0xff828bb7, 0xff908ab4, 0xffc8c4c9, 0xff9dbbc9, 0xff6594d3, 0xff7688cf,
    0xff8194c5, 0xff7c94c5, 0xff7e92c6, 0xff7d92c6, 0xff7e92c4, 0xff7e93c5, 0xff7f93c6, 0xff8196c8,
    0xff8497c9, 0xff8597ca, 0xff889bcb, 0xff899bcd, 0xff8d9ccd, 0xff8e9ed0, 0xff8d9dce, 0xff8f9fcd,
    0xff90a0cd, 0xff8d9fcc, 0xff8f9fce, 0xff909fce, 0xff93a1d0, 0xff97a2d2, 0xff99a6d2, 0xff9ca9d3,
    0xff9ba7d3, 0xff9aa7d3, 0xff9aa6d2, 0xff98a6d2, 0xff99a7d0, 0xff9aa5d0, 0xff9ca7d1, 0xff99a6d0,
    0xff9ba6d2, 0xff9ca7d1, 0xff9da8d1, 0xff9ea7d3, 0xff9ca3d2, 0xff98a4cf, 0xff99a3cf, 0xff98a1ce,
    0xff94a0cb, 0xff92a0cb, 0xff909cc9, 0xff8c99c8, 0xff8b98c4, 0xff8b99c4, 0xff8c97c3, 0xff8e98c6,
    0xff8d97c5, 0xff8c98c3, 0xff8a96c0, 0xff8896c2, 0xff8893c0, 0xff8794bf, 0xff8693bd, 0xff838ebd,
    0xff7c8dba, 0xff7988bb, 0xff7686b9, 0xff7485ba, 0xff7186b5, 0xff7382b8, 0xff607bca, 0xff6a9bc1,
    0xff9da7a6, 0xff9c859c, 0xff726f9a, 0xff57679b, 0xff4d679f, 0xff4b689e, 0xff496599, 0xff476396,
    0xff9ea5c2, 0xffa6a4c1, 0xffbeb4c5, 0xffb6c1c6, 0xffacc2d8, 0xffaab3e0, 0xff7a8dc4, 0xff768fc0,
    0xff748dc5, 0xff778dc3, 0xff798fc1, 0xff798fc3, 0xff788fc7, 0xff788fc9, 0xff7b92c8, 0xff7f94c9,
    0xff7f95c9, 0xff8298c9, 0xff8598cb, 0xff8798cb, 0xff899bce, 0xff8a9dcf, 0xff899bce, 0xff889bcd,
    0xff8b9bcf, 0xff8d9dcf, 0xff8e9ecf, 0xff8e9ecf, 0xff90a1cf, 0xff96a2d2, 0xff98a5d1, 0xff99a6d3,
    0xff98a5d2, 0xff95a2cf, 0xff95a2d0, 0xff94a0d0, 0xff95a1ce, 0xff95a2cd, 0xff95a2ce, 0xff95a2cd,
    0xff94a1cc, 0xff97a3cf, 0xff95a3ce, 0xff97a3ce, 0xff94a0cb, 0xff93a0cd, 0xff919dcd, 0xff909dcc,
    0xff8e9aca, 0xff8c99c8, 0xff8b97c5, 0xff8895c4, 0xff8694c1, 0xff8893c2, 0xff8795c2, 0xff8996c2,
    0xff8995c1, 0xff8996c2, 0xff8794bf, 0xff8491bd, 0xff8592be, 0xff818ebb, 0xff7f8cba, 0xff7b8aba,
    0xff7788b6, 0xff7386b6, 0xff7183b6, 0xff6d81b4, 0xff6d81b3, 0xff6b82b4, 0xff7082ae, 0xff6a7bc5,
    0xff5f8cc8, 0xff8aa9b0, 0xff9f8d9a, 0xff786f94, 0xff586594, 0xff4d6496, 0xff496094, 0xff445f90,
    0xff9896b8, 0xffb3afbd, 0xffaabec5, 0xff95add3, 0xff9aa3d4, 0xff9eaaca, 0xff8a9dc7, 0xff6987c3,
    0xff708ac2, 0xff758bc4, 0xff718cc4, 0xff748ec7, 0xff778fc7, 0xff778fc8, 0xff7a91c7, 0xff7c90c8,
    0xff8095cd, 0xff8399cf, 0xff8499cf, 0xff869acd, 0xff889acd, 0xff859bcd, 0xff859acd, 0xff879acc,
    0xff8699cc, 0xff8a9cce, 0xff8a9acd, 0xff8fa0d0, 0xff91a0d0, 0xff93a1cf, 0xff94a2cf, 0xff939fcf,
    0xff939fd0, 0xff919ecd, 0xff919ccc, 0xff919fce, 0xff8f9dcc, 0xff909dcc, 0xff919dcc, 0xff909ecd,
    0xff919ecd, 0xff909ccb, 0xff939ecd, 0xff929fcd, 0xff909ccc, 0xff8c9bcb, 0xff8d99c9, 0xff8b98c9,
    0xff8a97c8, 0xff8896c7, 0xff8493c7, 0xff8593c4, 0xff8592c2, 0xff8492c3, 0xff8895c2, 0xff8895c1,
    0xff8794c0, 0xff8592bf, 0xff8491bf, 0xff8491bd, 0xff818dbb, 0xff7f8dbb, 0xff7b89b8, 0xff7588b6,
    0xff7183b4, 0xff6d81b3, 0xff6d81b2, 0xff6a7fb2, 0xff677eb0, 0xff677db0, 0xff677dae, 0xff6b7fad,
    0xff697bb7, 0xff587cc4, 0xff6e9bb1, 0xff959396, 0xff7d708c, 0xff57618e, 0xff495f8d, 0xff415c8b,
    0xffa2a4b5, 0xff90b1c2, 0xff7d94cb, 0xff8f9bc8, 0xff95a1c1, 0xff909fc7, 0xff9ca9cb, 0xff7e92c3,
    0xff728cc1, 0xff6985c0, 0xff6e88c2, 0xff718bc3, 0xff748dc5, 0xff748dc6, 0xff798ec7, 0xff7b91ca,
    0xff7793cc, 0xff7e94d0, 0xff7e95ca, 0xff8299cc, 0xff8599ce, 0xff829ad0, 0xff849ad0, 0xff849bd2,
    0xff859bd4, 0xff879ed0, 0xff8b9ed1, 0xff8a9dd0, 0xff8fa0d1, 0xff8fa0d0, 0xff919ecf, 0xff919fd0,
    0xff8f9ecf, 0xff8f9ccf, 0xff8b9bce, 0xff8a9ccb, 0xff8b9acb, 0xff8d9ccd, 0xff8b9ccc, 0xff8b9ccb,
    0xff8c9bca, 0xff8c9bcd, 0xff8b9aca, 0xff8a99c9, 0xff8898c8, 0xff8795c8, 0xff8897ca, 0xff8796c9,
    0xff8696c7, 0xff8896c8, 0xff8593c6, 0xff8795c6, 0xff8996c8, 0xff8b96c8, 0xff8a97c4, 0xff8c99c4,
    0xff8b97c3, 0xff8a97c3, 0xff8996c3, 0xff8491be, 0xff828fbc, 0xff7d8bba, 0xff7888b7, 0xff7687b3,
    0xff7284b1, 0xff7082b3, 0xff6a7fb0, 0xff697eaf, 0xff667dab, 0xff657ca9, 0xff657aac, 0xff6479ab,
    0xff6379a7, 0xff6679a6, 0xff5873bf, 0xff5c8eb2, 0xff8a9697, 0xff7f748c, 0xff5a5f89, 0xff475e8e,
    0xff759dba, 0xff7589c3, 0xff7d8eba, 0xff7d90ba, 0xff8093bd, 0xff8d9ac2, 0xff9ba8ca, 0xff9aa6c8,
    0xffa6b0d0, 0xffa5aed2, 0xff8da0cb, 0xff7f93c7, 0xff6786c0, 0xff7f95c8, 0xff718dc7, 0xff6f8dc7,
    0xff8f9ecf, 0xff97a7d3, 0xff91a3cf, 0xff829ad3, 0xff829ad4, 0xff839ad2, 0xff849ad2, 0xff879dd6,
    0xff889dd7, 0xff8ba0d9, 0xff8a9fd6, 0xff8ca1d6, 0xff8ba0d5, 0xff8ea0d3, 0xff8a9dcf, 0xff899dce,
    0xff8999cd, 0xff879ace, 0xff899acd, 0xff8b9cce, 0xff889ccd, 0xff8899cc, 0xff899dd2, 0xff8b9dcf,
    0xff899dd1, 0xff8b9fd4, 0xff8aa1d8, 0xff8ca2d8, 0xff8ba0d7, 0xff8c9fd4, 0xff8c9ed3, 0xff91a1d4,
    0xff8e9ed2, 0xff8c9cd0, 0xff8a9bce, 0xff8999cd, 0xff8898cb, 0xff8b98c7, 0xff8b97c7, 0xff8897c6,
    0xff8693c3, 0xff8493c1, 0xff8490bf, 0xff818fbc, 0xff7d8bbb, 0xff7a89b8, 0xff7787b5, 0xff7284b2,
    0xff7182b0, 0xff697fb1, 0xff677ead, 0xff667cab, 0xff647aa7, 0xff6379a9, 0xff6378a8, 0xff6177a6,
    0xff6178a6, 0xff6278a7, 0xff677ca8, 0xff5c70b8, 0xff5685b7, 0xff82979c, 0xff867b8b, 0xff5f6489,
    0xff5d7ac2, 0xff6a85b9, 0xff6383b8, 0xff6d86b8, 0xff798ebc, 0xff8494bd, 0xff8b9ac4, 0xff94a2c4,
    0xff9da7c8, 0xffa4acca, 0xffbbbed8, 0xffbfc3db, 0xffb0b8d7, 0xffbdc1d9, 0xff94a3d2, 0xffa6b1d3,
    0xffb2b9d5, 0xffb6bbd7, 0xffaab4d3, 0xff839dd6, 0xff7f9dd5, 0xff829dd6, 0xff84a1da, 0xff849fd6,
    0xff85a0d8, 0xff88a1d8, 0xff869fd7, 0xff87a1d8, 0xff8aa2dd, 0xff89a7e0, 0xff8aa6e3, 0xff89a4df,
    0xff87a6e2, 0xff88a4e3, 0xff86a2e0, 0xff86a4e1, 0xff86a4e2, 0xff86a5e4, 0xff86a7e8, 0xff86aaed,
    0xff86a9ec, 0xff8cadee, 0xff8face6, 0xff91abe4, 0xff97aadf, 0xff96aae1, 0xff93a5dc, 0xff8da1d7,
    0xff8d9fd4, 0xff8e9dd1, 0xff899ace, 0xff889acb, 0xff8697c9, 0xff8697c6, 0xff8795c4, 0xff8290bf,
    0xff8291c0, 0xff7e8ebc, 0xff7a8cba, 0xff7889b7, 0xff7789b6, 0xff7386b5, 0xff7384b3, 0xff6f81af,
    0xff6a80af, 0xff687eaa, 0xff657bad, 0xff647ba6, 0xff627aa6, 0xff6178a5, 0xff6078a2, 0xff6178a3,
    0xff6177a3, 0xff6178a3, 0xff647aa7, 0xff667ca5, 0xff6173b6, 0xff5983bc, 0xff829ca7, 0xff908596,
    0xff5e7fb2, 0xff617fb5, 0xff607fb6, 0xff6382b7, 0xff6b86b9, 0xff758bbd, 0xff7c90bb, 0xff8292be,
    0xff8899c2, 0xff8394c0, 0xff8999c1, 0xff9da7c9, 0xffb4b9d5, 0xffafb5d5, 0xffb6bbd6, 0xffa6afd0,
    0xffb3b9d7, 0xffb0b6d4, 0xffb5bad6, 0xff98a7d2, 0xff7691cc, 0xff7c96cf, 0xff849ed8, 0xff89a7e2,
    0xff97aee8, 0xff91a8e1, 0xff8ea9e3, 0xff8ca9e8, 0xff82a4e4, 0xff83a7eb, 0xff84a8ed, 0xff82b0fa,
    0xff83aff9, 0xff83aef5, 0xff82b2fb, 0xff82b4fd, 0xff81affa, 0xff80b0fa, 0xff83b0fa, 0xff81aff9,
    0xff8cb0f5, 0xff8caeec, 0xff88adf0, 0xff87acef, 0xff88acef, 0xff8babeb, 0xff8aa5e3, 0xff89a2de,
    0xff899ed7, 0xff899ed5, 0xff899bd0, 0xff8998cc, 0xff8696ca, 0xff8696c7, 0xff8192c3, 0xff8290bf,
    0xff808ebd, 0xff7c8bba, 0xff798ab8, 0xff7688b5, 0xff7385b4, 0xff7182b1, 0xff7082b1, 0xff6d7eab,
    0xff677dac, 0xff6579ab, 0xff6379a8, 0xff6279a6, 0xff6178a4, 0xff6178a4, 0xff5d74a0, 0xff5d74a1,
    0xff687eab, 0xff697eab, 0xff687da9, 0xff6a7dac, 0xff697ea6, 0xff6879b6, 0xff5e84c1, 0xff889fa5,
    0xff5a7eb6, 0xff5c7db7, 0xff5e7eb5, 0xff6382b8, 0xff6484b9, 0xff6985bc, 0xff708bbe, 0xff778fbf,
    0xff768cc1, 0xff738bbf, 0xff768bbe, 0xff8c97c1, 0xff9ca6c8, 0xffa0aaca, 0xffa5aed1, 0xff9ba9cd,
    0xffabb1ce, 0xffa6afcf, 0xffacb4d2, 0xff97a5cf, 0xff6d8ac4, 0xff758ec7, 0xff7a98ce, 0xff7c95ce,
    0xff7892c9, 0xff7d97cd, 0xff829cd1, 0xff93a9df, 0xff9ab3ec, 0xff8aa7e4, 0xff85a0d9, 0xff819bd8,
    0xff819cd9, 0xff7e9ee1, 0xff80a4e8, 0xff81b4fd, 0xff84b7fa, 0xff83b3f9, 0xff86b6fa, 0xff88b9f9,
    0xff86b9fd, 0xff84abf2, 0xff80a4e7, 0xff80a3e6, 0xff88a6e5, 0xff8ea9e5, 0xff8caeef, 0xff88abec,
    0xff90a8df, 0xff8ba1db, 0xff8196d0, 0xff7f94c9, 0xff7e91c3, 0xff7d8ec1, 0xff7b8dc0, 0xff7c8bbc,
    0xff7789bb, 0xff7587b8, 0xff7486b5, 0xff7283b3, 0xff7182b2, 0xff6e80af, 0xff6b80ac, 0xff647ca9,
    0xff6378a9, 0xff5f76a6, 0xff5d73a0, 0xff5d74a0, 0xff5c739f, 0xff5b729e, 0xff5e75a1, 0xff5d739f,
    0xff6077a3, 0xff6177a3, 0xff697caa, 0xff6b7cab, 0xff6d7fad, 0xff6f81a9, 0xff6c7cb6, 0xff6186bd,
    0xff587bb5, 0xff5a7cba, 0xff5b7fbb, 0xff5c80c0, 0xff5f82be, 0xff6384c2, 0xff6083c5, 0xff6387c6,
    0xff688bcc, 0xff6b90d1, 0xff759cdd, 0xff759fe1, 0xff7897d2, 0xff7b9ad1, 0xff86a4de, 0xff84a2df,
    0xff8fa3d4, 0xff91a0cd, 0xff8d9ccb, 0xff8a9dcc, 0xff7795ce, 0xff7190cb, 0xff7190ca, 0xff7695d0,
    0xff7b9ad7, 0xff7997d6, 0xff7995d3, 0xff7492cf, 0xff7592ce, 0xff84a1dc, 0xff88a5e2, 0xff7a98d7,
    0xff7a9adc, 0xff7ca7ee, 0xff82b3fa, 0xff83b9fe, 0xff8ac0fe, 0xff8bc0fc, 0xff89befb, 0xff86b9fb,
    0xff85b9f9, 0xff87bcfc, 0xff88bcfc, 0xff85bcfd, 0xff85b1fa, 0xff8caeee, 0xff86a2e1, 0xff7d9ddf,
    0xff809edf, 0xff7e96d2, 0xff7f94cb, 0xff778dc6, 0xff738ac3, 0xff748ac2, 0xff768bbc, 0xff7a8abb,
    0xff7989bc, 0xff7287b9, 0xff6e82b5, 0xff6c83b3, 0xff697fb1, 0xff6980b0, 0xff677dae, 0xff677dae,
    0xff6379aa, 0xff6076a6, 0xff5d73a1, 0xff5a719c, 0xff596f9c, 0xff5c729d, 0xff586f9c, 0xff5e73a0,
    0xff6175a4, 0xff5d729e, 0xff6c80aa, 0xff6a7ba7, 0xff6c7dab, 0xff6f7ead, 0xff6c7da6, 0xff677bb5,
    0xff5678b8, 0xff587ab9, 0xff5b7cbc, 0xff5d7ebe, 0xff5d7fbe, 0xff5b80bd, 0xff6687c1, 0xff6387c2,
    0xff5f87c8, 0xff6288c9, 0xff658dd1, 0xff6a98de, 0xff6fa4ed, 0xff73a5f1, 0xff79adf6, 0xff79b1fa,
    0xff78aef6, 0xff719ee1, 0xff7094d3, 0xff6d90d0, 0xff708fcf, 0xff7193d2, 0xff779adb, 0xff7798da,
    0xff7799da, 0xff789bdb, 0xff7b9fe0, 0xff7ea2e3, 0xff7f9edc, 0xff84a4e1, 0xff90adea, 0xff86aaec,
    0xff79a6ee, 0xff7aa0e7, 0xff7094d8, 0xff6f8fd3, 0xff759ce2, 0xff83b7fd, 0xff94ccff, 0xff91c4ff,
    0xff8ec1fe, 0xff8fc4ff, 0xff8ec5ff, 0xff94c0fc, 0xff96b5f5, 0xff9db5ed, 0xff97aee6, 0xff95aae3,
    0xff819ddb, 0xff6b8bcf, 0xff6787ca, 0xff6887c6, 0xff6887c4, 0xff6a85c0, 0xff6b84bc, 0xff6881ba,
    0xff6681b9, 0xff6681b8, 0xff6681b7, 0xff647eb7, 0xff647cb2, 0xff6379b0, 0xff607aac, 0xff6078a9,
    0xff6277a9, 0xff6077a6, 0xff5e74a2, 0xff5d739d, 0xff6176a0, 0xff5d719e, 0xff6176a3, 0xff5d729e,
    0xff5e759f, 0xff5e739d, 0xff667aa4, 0xff6d7ea9, 0xff6a7ca7, 0xff697ba7, 0xff677aa4, 0xff60769e,
    0xff5176b2, 0xff567ab8, 0xff597cbb, 0xff587cba, 0xff597fbd, 0xff5880be, 0xff5c7fbf, 0xff6585c3,
    0xff6385c4, 0xff6a8bc8, 0xff6687c8, 0xff748fc8, 0xff6f91d2, 0xff6f9ce1, 0xff6f9adf, 0xff75a2e7,
    0xff7db1f9, 0xff83bcfe, 0xff80b1f6, 0xff7fabef, 0xff7799d6, 0xff7899d9, 0xff7a9bda, 0xff7ea1e1,
    0xff7fa1e1, 0xff89a7e6, 0xff9ab4e9, 0xff97afe8, 0xff94b0e9, 0xff82a1e1, 0xff7e9ddf, 0xff7392d4,
    0xff7395d4, 0xff80a5e8, 0xff8caff1, 0xff8db1f2, 0xff7898dc, 0xff6a8bd0, 0xff6a8dd2, 0xff6b8dd2,
    0xff7290d5, 0xff7493d5, 0xff7c9dde, 0xff90aeee, 0xff9fbbf4, 0xff98ade6, 0xff94a9e3, 0xffa0b4e6,
    0xffabb8e6, 0xffaab8e4, 0xff93a8dd, 0xff6b89ca, 0xff6382c5, 0xff6281c1, 0xff6180c0, 0xff5e7db9,
    0xff5c7ab8, 0xff5e7bb8, 0xff5b79b4, 0xff5a78b1, 0xff5775ad, 0xff5875ad, 0xff5975ad, 0xff5a73a9,
    0xff5a75a8, 0xff5973a5, 0xff5971a2, 0xff5b73a0, 0xff5c74a0, 0xff5e72a0, 0xff5d729e, 0xff5b709b,
    0xff597099, 0xff5b729c, 0xff6279a1, 0xff6679a4, 0xff6578a3, 0xff6677a2, 0xff6476a0, 0xff5e74a1,
    0xff5074b0, 0xff5477b3, 0xff5679b6, 0xff577dba, 0xff577dbb, 0xff597fbe, 0xff597fbe, 0xff5a80c0,
    0xff5f81c1, 0xff5f82c2, 0xff6186c7, 0xff6087c9, 0xff6388cd, 0xff6790d5, 0xff7299d9, 0xff7fa9ea,
    0xff80acef, 0xff7aa0e3, 0xff7295d6, 0xff7495d6, 0xff7597d8, 0xff7697d8, 0xff7598d8, 0xff7d9edd,
    0xff86a7e2, 0xff819dd5, 0xff7c9ad4, 0xff7a97d4, 0xff7c99d5, 0xff7a95d2, 0xff7796d2, 0xff7493d1,
    0xff7290d0, 0xff7190ce, 0xff7692d0, 0xff7894d3, 0xff7792d0, 0xff6f8fcf, 0xff718dcc, 0xff7891ce,
    0xff7e97d2, 0xff7d98d4, 0xff7b97d5, 0xff7994d0, 0xff7b95d3, 0xff859ad7, 0xff829cd4, 0xff8499d4,
    0xff829ad6, 0xff829bd6, 0xff8097d1, 0xff8699d2, 0xff728ec9, 0xff6684c4, 0xff5c7cbe, 0xff5a79b6,
    0xff5978b5, 0xff5775b2, 0xff5a77b2, 0xff5976b1, 0xff5674a9, 0xff5671a8, 0xff536da5, 0xff5470a1,
    0xff556da1, 0xff556f9f, 0xff566e9f, 0xff576e9b, 0xff596f98, 0xff596e98, 0xff576e99, 0xff586f9d,
    0xff5c739c, 0xff5b7198, 0xff5e729a, 0xff5f7198, 0xff5b7197, 0xff5b7199, 0xff4f6480, 0xff36524e,
    0xff4d6fad, 0xff5173af, 0xff5277b2, 0xff5479b4, 0xff587ab7, 0xff577dbc, 0xff5b7ebe, 0xff5d7ebe,
    0xff5d7fbf, 0xff5e81c1, 0xff6083c4, 0xff6485c9, 0xff6388c9, 0xff688ac9, 0xff7293cf, 0xff7c99d2,
    0xff8ba2d7, 0xff8aa2d7, 0xff809cd2, 0xff7796cc, 0xff7492cb, 0xff7491cc, 0xff7793cb, 0xff7592ca,
    0xff7a93cb, 0xff7891cb, 0xff7890c9, 0xff7891c9, 0xff7991ca, 0xff7b92ca, 0xff7c92cb, 0xff7c94cd,
    0xff7f97cd, 0xff7991c8, 0xff7f96cb, 0xff8599d0, 0xff7e96cd, 0xff99a8d6, 0xff8a9dd1, 0xff98aad9,
    0xff90a2d7, 0xff8a9fd4, 0xff8296d0, 0xff758fcc, 0xff7c93cb, 0xff7c92cb, 0xff7a8fc6, 0xff778dc5,
    0xff768ec8, 0xff6584c7, 0xff6283c6, 0xff5f7fc1, 0xff607fbf, 0xff617fbf, 0xff6281c0, 0xff637fba,
    0xff627eba, 0xff617eba, 0xff6581bd, 0xff637cb4, 0xff5776ac, 0xff526fa6, 0xff506da2, 0xff506b9d,
    0xff4f6b9a, 0xff526b9d, 0xff556e9c, 0xff536b9b, 0xff546c9c, 0xff526573, 0xff5870a4, 0xff4f6376,
    0xff4d5f68, 0xff556e93, 0xff596d95, 0xff566c93, 0xff526a90, 0xff506991, 0xff435b74, 0xff102129,
    0xff486ba4, 0xff4c70a8, 0xff5174ae, 0xff5275ac, 0xff5477b3, 0xff557bb8, 0xff577cb9, 0xff597dbc,
    0xff5a7cbb, 0xff597dba, 0xff5c7ebe, 0xff5e81c0, 0xff6284c4, 0xff6687c5, 0xff6e8dc7, 0xff7c94cc,
    0xff859ccf, 0xff8ca2d2, 0xff889dd5, 0xff879cd4, 0xff7d99cf, 0xff7794cb, 0xff7795cc, 0xff7893cd,
    0xff7d99d3, 0xff83a4de, 0xff7d9bd3, 0xff7291ca, 0xff7792ca, 0xff7390c6, 0xff7790c7, 0xff7b92ca,
    0xff8096cc, 0xff8ca1d2, 0xff8b9dd0, 0xff889ace, 0xff8595c9, 0xff7690c7, 0xff8398ca, 0xff92a2d2,
    0xff8999cc, 0xff8096ca, 0xff7991ca, 0xff708ac3, 0xff7189c2, 0xff6f8ac1, 0xff6e85be, 0xff6c82bc,
    0xff6983bb, 0xff6785c2, 0xff6583c0, 0xff6985c2, 0xff6986c2, 0xff6a85c1, 0xff6c87c0, 0xff6883bb,
    0xff6682b9, 0xff607db2, 0xff5975ab, 0xff5977af, 0xff5a74ab, 0xff5974a9, 0xff5470a2, 0xff536e9e,
    0xff506c9c, 0xff4d6796, 0xff536b95, 0xff506995, 0xff566d8f, 0xff485c69, 0xff465d69, 0xff586e92,
    0xff394c41, 0xff4f6787, 0xff526992, 0xff4e678c, 0xff4a6287, 0xff4b628a, 0xff51678a, 0xff020f12,
    0xff4669a0, 0xff486ca2, 0xff4c6fa7, 0xff5073ad, 0xff5679b4, 0xff5578b2, 0xff577ab3, 0xff5a7db5,
    0xff597cb6, 0xff5a7cb9, 0xff5b7cba, 0xff5b7dba, 0xff5d7fba, 0xff5f81bd, 0xff6585c1, 0xff6886c2,
    0xff6e89c2, 0xff748dc5, 0xff7893ca, 0xff7891cb, 0xff7892ca, 0xff7391c8, 0xff7390c9, 0xff7490cb,
    0xff7897ce, 0xff85a1d8, 0xff83a0d8, 0xff7b96cd, 0xff7891c9, 0xff7490c6, 0xff718ecc, 0xff7691cc,
    0xff7b93cc, 0xff8097cf, 0xff7c92cc, 0xff788ec5, 0xff7a8dc2, 0xff748bc4, 0xff7890c2, 0xff8595c7,
    0xff7e92c5, 0xff7b8fc2, 0xff748ac3, 0xff7389c3, 0xff6e87c0, 0xff6f83bc, 0xff677fb4, 0xff6380ba,
    0xff6280bd, 0xff617eb7, 0xff5d7ab4, 0xff5f7bb8, 0xff607db8, 0xff5e7bb5, 0xff5d7ab5, 0xff5c79b3,
    0xff5d7cb1, 0xff5977ae, 0xff5a78af, 0xff5a75ac, 0xff5570a6, 0xff536e9e, 0xff536e9e, 0xff526c9c,
    0xff4f6a98, 0xff506793, 0xff4e6693, 0xff506898, 0xff4f6a97, 0xff526464, 0xff364746, 0xff2f4655,
    0xff2f4134, 0xff475f65, 0xff4c6589, 0xff465e86, 0xff455d87, 0xff45627f, 0xff4e6894, 0xff020a0e,
    0xff42679b, 0xff45699f, 0xff4a6ca2, 0xff4c6fa5, 0xff4e71a8, 0xff5073ac, 0xff5275b0, 0xff5578b2,
    0xff5578b2, 0xff5679b5, 0xff577bb4, 0xff597bb6, 0xff5b7db6, 0xff607fba, 0xff6181bd, 0xff6383be,
    0xff6687c2, 0xff6a87c0, 0xff6d89c1, 0xff6f8bc3, 0xff718fc3, 0xff718ec6, 0xff708dc8, 0xff718fc9,
    0xff718fcb, 0xff718fcc, 0xff7892cc, 0xff7c96ce, 0xff718fc9, 0xff6f8cc6, 0xff6f8ec8, 0xff728ec7,
    0xff7990c9, 0xff7f94ce, 0xff7d93cd, 0xff7990c6, 0xff738ac3, 0xff768dc4, 0xff7289c1, 0xff6e89c1,
    0xff6e88c0, 0xff6d86bf, 0xff758ac2, 0xff7089c0, 0xff6c85be, 0xff637fb6, 0xff627db5, 0xff5e7cb3,
    0xff5d7bb3, 0xff5c7ab3, 0xff5e7bb7, 0xff5b7ab7, 0xff5b7abe, 0xff6281c3, 0xff6485c6, 0xff6e8acc,
    0xff5a77b1, 0xff5673af, 0xff5573a7, 0xff5072b0, 0xff506da0, 0xff506a9c, 0xff516a9c, 0xff4c6795,
    0xff4a6694, 0xff49618f, 0xff465e8b, 0xff395154, 0xff31496b, 0xff4e6a92, 0xff435334, 0xff1c2620,
    0xff22351c, 0xff384f3f, 0xff455e8f, 0xff425c83, 0xff233740, 0xff203422, 0xff183337, 0xff1e2829,
    0xff3d6699, 0xff42689b, 0xff466ba0, 0xff486ba0, 0xff4a6ea7, 0xff4d70ab, 0xff5072ac, 0xff5173ac,
    0xff5477af, 0xff5578b2, 0xff5578b2, 0xff5779b5, 0xff587cb5, 0xff5b7db8, 0xff5f7fb8, 0xff6181bd,
    0xff6383bb, 0xff6484c0, 0xff6686bf, 0xff6988c1, 0xff6b89c2, 0xff6b87c3, 0xff6888c1, 0xff6786c3,
    0xff6a89c6, 0xff738fc5, 0xff7e97ca, 0xff8095ca, 0xff7992c9, 0xff708dc3, 0xff718bc3, 0xff718dc4,
    0xff738bc4, 0xff778ec6, 0xff7990c5, 0xff7b91c7, 0xff7d93c5, 0xff8398c7, 0xff8095c6, 0xff7d92c4,
    0xff738abf, 0xff7289be, 0xff6c83b9, 0xff6781b7, 0xff657eb2, 0xff5f7aaf, 0xff5c77ad, 0xff5a75aa,
    0xff5873a7, 0xff5873ab, 0xff5673aa, 0xff59779f, 0xff5b738a, 0xff5f7984, 0xff5c7582, 0xff5c789b,
    0xff4f6f95, 0xff4a655f, 0xff3b515c, 0xff526250, 0xff506786, 0xff436192, 0xff44618f, 0xff46618d,
    0xff415c86, 0xff4f658b, 0xff546c68, 0xff192000, 0xff081707, 0xff303f29, 0xff364838, 0xff272112,
    0xff2c4220, 0xff253719, 0xff455658, 0xff476066, 0xff0d1d09, 0xff1a2710, 0xff29431e, 0xff0b1513,
    0xff3d679d, 0xff40679d, 0xff446aa2, 0xff496ca4, 0xff476ea7, 0xff4970a8, 0xff4e72ad, 0xff5077b0,
    0xff5074ae, 0xff5176b1, 0xff5478b1, 0xff5677b4, 0xff5678b4, 0xff587ab5, 0xff587bb4, 0xff5a7cb6,
    0xff5d7eb9, 0xff5c7eba, 0xff5c7ebb, 0xff5b7dbc, 0xff5d7fbe, 0xff5d80bf, 0xff5f81c0, 0xff6183c0,
    0xff6585c1, 0xff6785c1, 0xff6989c1, 0xff6b88c1, 0xff6b88c1, 0xff6c89c3, 0xff6e8ac0, 0xff728cc3,
    0xff6d8ac0, 0xff7189c1, 0xff758cc3, 0xff768bc2, 0xff768dc1, 0xff768dc0, 0xff7b8fc2, 0xff7b90c3,
    0xff7f94cd, 0xff6c86c3, 0xff6682b7, 0xff5e78ae, 0xff5873a9, 0xff5473a9, 0xff55709f, 0xff4f6c9f,
    0xff506c9e, 0xff4e6b9f, 0xff5271ab, 0xff465e47, 0xff526546, 0xff455542, 0xff3d4a28, 0xff495c40,
    0xff4e6a72, 0xff374836, 0xff243224, 0xff49553d, 0xff3c4a3a, 0xff495e76, 0xff4f5d5d, 0xff3e5b8a,
    0xff3e5788, 0xff455d72, 0xff3b483b, 0xff283115, 0xff060c0b, 0xff2b3a19, 0xff21301a, 0xff2a1610,
    0xff142910, 0xff36491c, 0xff2f464c, 0xff1a2f38, 0xff48521c, 0xff121e0c, 0xff304716, 0xff283c24,
    0xff3f68a2, 0xff3f6aa7, 0xff426ba5, 0xff466daa, 0xff4770aa, 0xff4970ab, 0xff4971ab, 0xff4b72ad,
    0xff4e74b0, 0xff4d75b1, 0xff4d75b3, 0xff5075b1, 0xff5375b5, 0xff5377b3, 0xff5478b5, 0xff5579b3,
    0xff5477b4, 0xff5479b9, 0xff5479b9, 0xff587abb, 0xff557cbc, 0xff5b7ebe, 0xff5e81c0, 0xff6083bf,
    0xff6185c1, 0xff6182be, 0xff6384bf, 0xff6586c1, 0xff6686c2, 0xff6784c0, 0xff6885c2, 0xff6b86bf,
    0xff6988be, 0xff6f88c0, 0xff6f8ac0, 0xff7086c1, 0xff6f87c2, 0xff6f89c5, 0xff6e88c3, 0xff728cc7,
    0xff647376, 0xff6b7d76, 0xff8693b9, 0xff6882ab, 0xff6780a6, 0xff667882, 0xff637580, 0xff697069,
    0xff43669e, 0xff48669d, 0xff4d6f6a, 0xff293f32, 0xff2a3625, 0xff374a31, 0xff3d492c, 0xff2c3720,
    0xff334028, 0xff445441, 0xff3c4c2b, 0xff354d1e, 0xff3f4f33, 0xff536652, 0xff263411, 0xff36462b,
    0xff344847, 0xff395454, 0xff283818, 0xff131b19, 0xff1a1d0f, 0xff0e1714, 0xff132924, 0xff0d0f12,
    0xff141c0a, 0xff1d3a2a, 0xff405b64, 0xff354b51, 0xff24394b, 0xff0e1818, 0xff111010, 0xff293025,
    0xff5f8cbd, 0xff5582b8, 0xff5682ba, 0xff4f7bb4, 0xff4f79b4, 0xff517cb6, 0xff527ab8, 0xff517ab8,
    0xff5179b7, 0xff517bb8, 0xff547dbb, 0xff527cbb, 0xff527cb9, 0xff527bb9, 0xff517ab8, 0xff5177bb,
    0xff5278b9, 0xff5279b8, 0xff557cbc, 0xff5c7fbe, 0xff5e82c0, 0xff5f84c1, 0xff5f84be, 0xff6185c2,
    0xff6485c1, 0xff6284bf, 0xff6386c1, 0xff6788c2, 0xff6586bd, 0xff6684bf, 0xff6784be, 0xff6683bc,
    0xff6584bb, 0xff6785bb, 0xff6883bf, 0xff6d89a2, 0xff6a8192, 0xff657e6b, 0xff5b6d49, 0xff617b74,
    0xff526554, 0xff354835, 0xff576d57, 0xff586b5b, 0xff6a725f, 0xff5c6148, 0xff475951, 0xff3a4d28,
    0xff6683af, 0xff5372ad, 0xff5e7fc7, 0xff435440, 0xff2b3823, 0xff31422b, 0xff233c1c, 0xff23391b,
    0xff314d24, 0xff233b1b, 0xff626338, 0xff42572a, 0xff374b1c, 0xff41542a, 0xff455126, 0xff1a2b13,
    0xff000401, 0xff17290e, 0xff405e26, 0xff1d2b10, 0xff020b05, 0xff24351d, 0xff616240, 0xff1f3b13,
    0xff495830, 0xff1c2c0a, 0xff444926, 0xff000000, 0xff312015, 0xff604430, 0xffab7355, 0xff70472e,
    0xff7099bd, 0xff7399bd, 0xff729bc0, 0xff779dc2, 0xff759bbf, 0xff7298bf, 0xff6f94be, 0xff7296be,
    0xff7397bf, 0xff6e92bf, 0xff7598c1, 0xff7799c1, 0xff7196be, 0xff6b90c0, 0xff7194c1, 0xff7496c4,
    0xff6e92c3, 0xff668cc0, 0xff5e83bb, 0xff5981bd, 0xff5f84bd, 0xff6286bc, 0xff6084be, 0xff6085bc,
    0xff6486be, 0xff5f86c3, 0xff6187be, 0xff6286bf, 0xff6685bf, 0xff6584bf, 0xff6887c0, 0xff6886be,
    0xff6987be, 0xff6984b8, 0xff6c88c0, 0xff677c74, 0xff5a6e43, 0xff455b40, 0xff5a6b4e, 0xff4f6042,
    0xff4a6142, 0xff8d7f5f, 0xff847f5c, 0xff3a533a, 0xff425b39, 0xff535a47, 0xff475942, 0xff395634,
    0xff2b491e, 0xff2c4419, 0xff334822, 0xff333e2b, 0xff0f1c0e, 0xff314f2c, 0xff274120, 0xff456632,
    0xff557636, 0xff6e873c, 0xff142813, 0xff5e712f, 0xff425422, 0xff738e36, 0xff384a1f, 0xff3f5c24,
    0xff1d2714, 0xff000000, 0xff334427, 0xff27301e, 0xff0e0e0e, 0xff403631, 0xff50423a, 0xff593f34,
    0xff54572a, 0xff372d23, 0xff161418, 0xff474841, 0xff4d4038, 0xff7e544a, 0xff39271f, 0xff000c03,
    0xff6792c4, 0xff6895c3, 0xff6a95c6, 0xff7099c3, 0xff7299c7, 0xff769ac4, 0xff779ac4, 0xff7598c1,
    0xff7698bf, 0xff7497bf, 0xff7698c1, 0xff7899c0, 0xff7495bf, 0xff7d9ac3, 0xff7998bf, 0xff7c99bf,
    0xff7e9dc3, 0xff809ec6, 0xff8ba3c6, 0xffadb4c8, 0xff9aacca, 0xff99acc9, 0xffacb7cf, 0xffa4b2cf,
    0xffa0afce, 0xffb2b9cf, 0xffc0c1d7, 0xffb6bad5, 0xffb7bfd7, 0xffb6bcd3, 0xffb5bbd3, 0xffc3c2d4,
    0xffc3c1d5, 0xffcac7d6, 0xffbec0dc, 0xff77868b, 0xff2e442d, 0xff425b41, 0xff364b38, 0xff3a4a3a,
    0xff264331, 0xff475440, 0xff565b48, 0xff6b786a, 0xff606c60, 0xff365837, 0xff546250, 0xff162821,
    0xff243824, 0xff17351e, 0xff00090a, 0xff202e22, 0xff1b2518, 0xff031005, 0xff49542e, 0xff7b883e,
    0xff565e2d, 0xff4b552e, 0xff495024, 0xff686c27, 0xff323118, 0xff22140e, 0xff3e3527, 0xff5a5427,
    0xff554b1d, 0xff5a5830, 0xff000000, 0xff000203, 0xff192410, 0xff4a522e, 0xff2d3f12, 0xff1d230a,
    0xff000c00, 0xff2e361e, 0xff17240f, 0xff17210f, 0xff1f320e, 0xff415c25, 0xff000000, 0xff000904,
    0xff294764, 0xff294966, 0xff2b4a67, 0xff2d4c6c, 0xff325171, 0xff32526f, 0xff4b6683, 0xff617a98,
    0xff6f859d, 0xff889ab4, 0xff6a849f, 0xff617c9d, 0xff8195b0, 0xff6885a4, 0xff8a9dbc, 0xff869eba,
    0xff748db4, 0xff829bbc, 0xff839dbc, 0xff7591bb, 0xff7e99be, 0xff88a2c5, 0xff859dc7, 0xff708cb3,
    0xff6d8bb7, 0xff6f8bba, 0xff5d799f, 0xff567296, 0xff527098, 0xff647d9b, 0xff61799c, 0xff617b98,
    0xff617a92, 0xff7d8b96, 0xff6b818a, 0xff90a593, 0xff81865e, 0xff836c51, 0xffa7866e, 0xff70894f,
    0xff759250, 0xffa6a273, 0xff83965b, 0xff7f7c44, 0xff5a793a, 0xff6e804f, 0xff728551, 0xff757d45,
    0xff6c7948, 0xff6f7044, 0xff4a472c, 0xff251b17, 0xff0e0c12, 0xff182828, 0xff1e282d, 0xff140e11,
    0xff2c2a15, 0xff000000, 0xff000e00, 0xff273714, 0xff3b5024, 0xff283b17, 0xff344e1f, 0xff3f5727,
    0xff908b4e, 0xff406323, 0xff829a59, 0xff7e793f, 0xff405628, 0xff313727, 0xff3c322c, 0xff323124,
    0xff61563a, 0xff364a1e, 0xff2c471c, 0xff000400, 0xff001000, 0xff000000, 0xff000000, 0xff020b03,
    0xff00253f, 0xff002e48, 0xff012f49, 0xff0c3954, 0xff083851, 0xff083650, 0xff073652, 0xff0a3654,
    0xff05314f, 0xff043150, 0xff083354, 0xff0a3452, 0xff002a4a, 0xff022f50, 0xff16405f, 0xff1a3f5f,
    0xff17415c, 0xff193e5c, 0xff1d405c, 0xff1a3d57, 0xff284560, 0xff2e4964, 0xff284866, 0xff284968,
    0xff33516b, 0xff33506f, 0xff4e6680, 0xff566b82, 0xff818b94, 0xff8a8d9a, 0xffbcbec1, 0xffa1a1ac,
    0xffaca8ad, 0xffb2b0af, 0xffd5ccc3, 0xffa1a09a, 0xffd3cabc, 0xffb5b9ad, 0xffafb198, 0xffb4ae9e,
    0xffb1a9a1, 0xffc3baa6, 0xffb1ac9e, 0xffb1b39e, 0xffc2c4ac, 0xffe8d6b7, 0xffead1b5, 0xfffff0cd,
    0xfffff5a6, 0xfff2d485, 0xffffffbc, 0xffffffbb, 0xffffffc4, 0xfffffba9, 0xfffff0a5, 0xffffffba,
    0xffffffba, 0xffffffb9, 0xffffffbd, 0xffffffba, 0xffffffb6, 0xffffffb5, 0xffffffc3, 0xffaf9e72,
    0xffffe7a7, 0xffffe5a8, 0xffffd59a, 0xffffdca1, 0xffefb68a, 0xffac8160, 0xffbe8c6a, 0xffc99b74,
    0xffa57f66, 0xffa5806a, 0xff7f685a, 0xff7a6655, 0xffa8866b, 0xffb99066, 0xffba966c, 0xff75664b,
    0xffb6c4c8, 0xffa0b3b9, 0xff8ca1a9, 0xff79939c, 0xff83979f, 0xff93a6ad, 0xff95a6ae, 0xff869da4,
    0xff9fb2b9, 0xff94a8ae, 0xffa2b4b9, 0xffa7bcc2, 0xffe6eeea, 0xffedf4f3, 0xff002130, 0xff033744,
    0xff164659, 0xff104154, 0xff0c3d50, 0xff12455b, 0xff0e465b, 0xff144c60, 0xff164c5e, 0xff154b60,
    0xff104857, 0xff134b5b, 0xff0f485c, 0xff124c5f, 0xff0e485c, 0xff074155, 0xff1e4b59, 0xff0e4556,
    0xff0f4156, 0xff1d4f61, 0xff29556b, 0xff2e586c, 0xff265267, 0xff134155, 0xff255269, 0xff1d4a61,
    0xff214d63, 0xff23526b, 0xff25516b, 0xff27526c, 0xff2b556e, 0xff28516a, 0xff30566c, 0xff36586f,
    0xff345972, 0xff4d6b78, 0xff50656e, 0xff5e6d6e, 0xff676d6b, 0xff6d7569, 0xff72736c, 0xff7b7969,
    0xff8e7e6a, 0xffa08e7a, 0xff937d5f, 0xffa88762, 0xffbc946b, 0xffdcab7f, 0xff4b2a15, 0xff000000,
    0xff49382a, 0xffa87b5e, 0xff8d6d4c, 0xff9f8461, 0xffc9af79, 0xfffddf9d, 0xffffe39f, 0xffffd091,
    0xffd8a876, 0xffc99871, 0xff9d7a53, 0xff997c55, 0xff7c6648, 0xff544e3d, 0xff3b3c2f, 0xff51453f,
    0xff495e75, 0xff4b5f79, 0xff4e627a, 0xff607488, 0xff63768e, 0xff65778a, 0xff647689, 0xff5a6d83,
    0xff5b6c7f, 0xff818e9f, 0xff95a1b8, 0xffa1abbe, 0xff96a3b5, 0xff919bb2, 0xff52708d, 0xff7990b0,
    0xff7b91b0, 0xff7e94ae, 0xff798ea7, 0xff6885a0, 0xff899bb1, 0xff6d87aa, 0xff547496, 0xff567894,
    0xff4d7396, 0xff4a6d8e, 0xff6d8aa2, 0xff48708c, 0xff3d647f, 0xff4d7087, 0xff35607c, 0xff285375,
    0xff1d4b6f, 0xff5e839e, 0xff456c8a, 0xff2b5b78, 0xff265773, 0xff326080, 0xff2b5a74, 0xff2b5f72,
    0xff316279, 0xff265667, 0xff2b5d6e, 0xff326776, 0xff306170, 0xff285b6a, 0xff265563, 0xff37656f,
    0xff476f76, 0xff37636d, 0xff26565c, 0xff2d5b68, 0xff22505a, 0xff13424f, 0xff154455, 0xff10374c,
    0xff00263c, 0xff254d60, 0xff677b6b, 0xff919377, 0xff868372, 0xff625b56, 0xff473c3e, 0xff78584e,
    0xff75554c, 0xff745146, 0xff85604d, 0xff876251, 0xff816554, 0xff806453, 0xff876c58, 0xff97785e,
    0xffa98f6a, 0xffae8b68, 0xffa68562, 0xff9e8369, 0xffae8e6b, 0xffcd9e72, 0xffdbad7d, 0xfff5be81,
    0xff405d72, 0xff466379, 0xff345166, 0xff254158, 0xff234256, 0xff254655, 0xff254659, 0xff1f3c4e,
    0xff1d3d4b, 0xff1c3e53, 0xff2c4962, 0xff274559, 0xff2f4f68, 0xff2e4f67, 0xff4b667b, 0xff385d6e,
    0xff466578, 0xff56717f, 0xff567580, 0xff6f8390, 0xff738996, 0xff567082, 0xff7d8d97, 0xff627c8b,
    0xff475f6e, 0xff476775, 0xff335260, 0xff667a8a, 0xff8f98a1, 0xffc7cbd4, 0xffd1cdd6, 0xffcbc9d2,
    0xffddd8dd, 0xffded6e2, 0xff556685, 0xff4f6485, 0xff677aa1, 0xff41577a, 0xff4d648d, 0xff415e88,
    0xff4d698f, 0xff4f6e8e, 0xff4b6a8c, 0xff3c5a73, 0xff4f6d83, 0xff527186, 0xff517986, 0xff577c89,
    0xff507681, 0xff577a83, 0xff557587, 0xff546b78, 0xff445d71, 0xff798390, 0xffb09f9e, 0xffddbb6f,
    0xfffffea8, 0xfffff99f, 0xffffe99c, 0xfff9d490, 0xfffff1ad, 0xfffff1a8, 0xfffcf0a6, 0xffece19c,
    0xffeada99, 0xfff7e7a3, 0xffffefa6, 0xfffffeb2, 0xfffff2a7, 0xffffeaa4, 0xffffe9a3, 0xfffed595,
    0xffecc48d, 0xffe4bc83, 0xfff3c78f, 0xffd6a97b, 0xffd4a97a, 0xffc19c76, 0xffcf9e73, 0xffbc9471,
    0xff476181, 0xff496381, 0xff455f7d, 0xff415a76, 0xff455e78, 0xff314c67, 0xff3c566d, 0xff47617a,
    0xff3f5970, 0xff3d5870, 0xff314d62, 0xff435d75, 0xff385465, 0xff566f8b, 0xff35556c, 0xff496178,
    0xff415d75, 0xff37536c, 0xff3d586f, 0xff46637e, 0xff506b89, 0xff446682, 0xff3f5e7d, 0xff3c5c7b,
    0xff416182, 0xff405f81, 0xff406180, 0xff335671, 0xff335674, 0xff385e79, 0xff265068, 0xff244c63,
    0xff3d5f81, 0xff305169, 0xff2c5166, 0xff365877, 0xff375977, 0xff3a5f7f, 0xff385c7d, 0xff69809a,
    0xff426485, 0xff3b5e7e, 0xff4c6e8d, 0xff597496, 0xff627a95, 0xff677a8f, 0xff738099, 0xff818ba6,
    0xff828496, 0xff9e959f, 0xffd6b79f, 0xffe6c1a4, 0xffffd19b, 0xffffd586, 0xffffd68b, 0xfffbcd8e,
    0xffdaa472, 0xffac8462, 0xffac8965, 0xffbf926c, 0xffab7557, 0xff9d6856, 0xff8f6453, 0xffb68a6a,
    0xffc5976e, 0xffbd8b6a, 0xffb08564, 0xffb58a6b, 0xffa28164, 0xffa98e6c, 0xffa68d6c, 0xffbf9f78,
    0xffc2a074, 0xffd6b282, 0xffd7aa7a, 0xffd5ab80, 0xffd7a775, 0xffe4b27f, 0xffd9aa7b, 0xffebb982,
    0xff1d4157, 0xff15394d, 0xff173b4d, 0xff14394b, 0xff204453, 0xff1b3e4e, 0xff27485c, 0xff214557,
    0xff153d50, 0xff184458, 0xff194658, 0xff1b475b, 0xff1d485a, 0xff1a4555, 0xff20495a, 0xff244b61,
    0xff2b536c, 0xff2a5163, 0xff294e64, 0xff2c5065, 0xff254a5d, 0xff284d63, 0xff285369, 0xff1d475a,
    0xff274d65, 0xff30576e, 0xff345771, 0xff254b66, 0xff305372, 0xff2e4c6b, 0xff415d81, 0xff395374,
    0xff304d69, 0xff32506c, 0xff314e69, 0xff2f4e64, 0xff375366, 0xff5a7088, 0xff747e91, 0xff888390,
    0xffd4c4cc, 0xffd7ccda, 0xff857f94, 0xff8a889c, 0xff8b889a, 0xff8b8798, 0xffad978b, 0xffd6aa7a,
    0xfff7c17e, 0xffffc982, 0xfffbc584, 0xfffcc985, 0xfff8c07b, 0xfffac982, 0xfff8c887, 0xfff9cc91,
    0xffdca56f, 0xffac7e5c, 0xff85614f, 0xff855f4a, 0xff937157, 0xff9f7e61, 0xffa57a5c, 0xff9c7b61,
    0xff775b51, 0xff64524b, 0xff5a4a47, 0xff574644, 0xff6e564f, 0xff856754, 0xff916d54, 0xffac8062,
    0xff99785e, 0xff9a755c, 0xff997558, 0xffa47f60, 0xff917057, 0xff756052, 0xff4b3e39, 0xff57483f,
    0xff18475a, 0xff19495b, 0xff22526b, 0xff1e4f61, 0xff1f5063, 0xff1d505e, 0xff225162, 0xff1f5360,
    0xff114a52, 0xff265967, 0xff2a5b70, 0xff275868, 0xff1d505d, 0xff235663, 0xff265a66, 0xff215860,
    0xff1f5359, 0xff245663, 0xff2c5d67, 0xff2c5a63, 0xff2d5c6c, 0xff315e71, 0xff285465, 0xff285567,
    0xff285569, 0xff214d63, 0xff274d63, 0xff294f5e, 0xff33566e, 0xff375978, 0xff32566e, 0xff395b7a,
    0xff395b75, 0xff38546a, 0xff4c6680, 0xff5a6c8a, 0xff5c657b, 0xff5d6275, 0xff6f779a, 0xff797fa6,
    0xff6d7390, 0xff4f5d71, 0xff5f6370, 0xff87756c, 0xffb9956f, 0xfff4be79, 0xffffca85, 0xfffec888,
    0xfff1bb81, 0xfffbc183, 0xfff7c07f, 0xfffcc27b, 0xfffabe73, 0xfff3bb7a, 0xffefc48b, 0xffd1ab79,
    0xffe4b87c, 0xffeeb37a, 0xfff0c388, 0xfff7c683, 0xffdfaf79, 0xffc79466, 0xffc9aa72, 0xffe7b681,
    0xfff1c185, 0xffd9a977, 0xffdaa26a, 0xffb18867, 0xff97785e, 0xff70594d, 0xff4f4440, 0xff3f3838,
    0xff3d3436, 0xff413a3a, 0xff4b3f3f, 0xff4e3d3a, 0xff6b5248, 0xff6c5748, 0xff93725c, 0xffb68967,
    0xff184c57, 0xff1b4f56, 0xff174d53, 0xff1a4f57, 0xff21535a, 0xff235662, 0xff275964, 0xff2b5a67,
    0xff2e5d69, 0xff26555f, 0xff27585a, 0xff326169, 0xff33616a, 0xff37646d, 0xff35626f, 0xff396273,
    0xff345b6f, 0xff34576b, 0xff2f5366, 0xff30546a, 0xff2f536b, 0xff294f64, 0xff2c5168, 0xff31566a,
    0xff305464, 0xff35576b, 0xff385b73, 0xff3d5d76, 0xff405f79, 0xff45627d, 0xff4d6479, 0xff536873,
    0xff465160, 0xff4e5a6f, 0xff535c73, 0xff687599, 0xff9098ca, 0xffa2abe1, 0xff8f94b8, 0xff646c83,
    0xff636067, 0xff876b5d, 0xffae8060, 0xffab8160, 0xffa97e62, 0xff9b725c, 0xff9b745e, 0xff8c6856,
    0xff7a5d52, 0xff906756, 0xffb28061, 0xff9e7054, 0xff946750, 0xffa77656, 0xffba875f, 0xffac7653,
    0xff7e5d4f, 0xff614a45, 0xff735649, 0xffbd8d68, 0xffca986d, 0xffd2a371, 0xffbd8b65, 0xffa67b5c,
    0xffc89b6e, 0xff9d7351, 0xffb68665, 0xffca9468, 0xffb28a64, 0xffd2a070, 0xffd9a478, 0xffd09f70,
    0xffc3956d, 0xffb68c66, 0xff655246, 0xff786152, 0xff453a38, 0xff403c3a, 0xff463b3a, 0xff574640,
    0xff1e4e5b, 0xff215162, 0xff1d4c57, 0xff204e5a, 0xff24535d, 0xff2b565f, 0xff2c5661, 0xff2c5762,
    0xff2f5768, 0xff345d6d, 0xff365f73, 0xff2e5865, 0xff264f57, 0xff315b67, 0xff315965, 0xff375b6c,
    0xff365a70, 0xff2f5460, 0xff385d6a, 0xff375b69, 0xff375664, 0xff385865, 0xff3f606d, 0xff416074,
    0xff425f78, 0xff46607c, 0xff49617b, 0xff485c73, 0xff495d73, 0xff4e5e72, 0xff5e6d80, 0xff696e84,
    0xffa0a1b5, 0xffb7b9d7, 0xff9da3d6, 0xff8188b1, 0xff647196, 0xff726d6c, 0xffa1886b, 0xffc8996b,
    0xffd9a770, 0xffbc8f6a, 0xffad8364, 0xffbe966d, 0xffbb9168, 0xffbd9269, 0xffc5976b, 0xffb38562,
    0xff6b5248, 0xff564137, 0xff7f5d49, 0xffc89163, 0xffe6a56a, 0xffffbf6c, 0xffffd48a, 0xfff8cd8a,
    0xffecba81, 0xffa67556, 0xff644d48, 0xffa2755c, 0xffd49c65, 0xfffec681, 0xffd6a771, 0xffe5b27b,
    0xffce9b6c, 0xffd79f71, 0xffbe8960, 0xffac7a59, 0xffb18367, 0xffc69066, 0xffa97e5c, 0xffa1775f,
    0xff96705a, 0xffa5795d, 0xffb08364, 0xffa88261, 0xffb18668, 0xff8e6a56, 0xff806554, 0xff514239,
    0xff215059, 0xff1f4e5b, 0xff214f61, 0xff21505e, 0xff234d5e, 0xff265061, 0xff2b5464, 0xff28525e,
    0xff315961, 0xff315961, 0xff30575d, 0xff3b626e, 0xff395e62, 0xff345861, 0xff3c5e67, 0xff395b67,
    0xff3f616b, 0xff3c5d6f, 0xff385969, 0xff3c5c70, 0xff456077, 0xff496278, 0xff4f6679, 0xff4c606f,
    0xff465a67, 0xff3e4d5b, 0xff445361, 0xff445362, 0xff4d5465, 0xff63697a, 0xff8d8fb1, 0xff7f7e99,
    0xffbfb6c3, 0xff9b96a9, 0xff747997, 0xff84839e, 0xffd69c69, 0xffd0975f, 0xffcb986b, 0xffd4a371,
    0xffc4976b, 0xffbd8f6a, 0xffa27860, 0xff9f775c, 0xffd7a36f, 0xfff7bf7b, 0xfff6bf7c, 0xffd7a46f,
    0xffa06e52, 0xff695448, 0xff59483e, 0xff4f3f39, 0xff4a352d, 0xff865c46, 0xffb98866, 0xffecb374,
    0xffffd991, 0xffe5b681, 0xffeab376, 0xff7e5f4b, 0xff7b5342, 0xffa57153, 0xffefb67a, 0xffcb9d6e,
    0xffc59468, 0xffa07256, 0xff573f37, 0xff644d41, 0xff463a36, 0xff816253, 0xff5a4842, 0xff665248,
    0xff6c5245, 0xff675147, 0xff6a5143, 0xff83614f, 0xff4e4139, 0xff8e6c54, 0xff825d49, 0xff8e6d57,
    0xff1b4950, 0xff1e4b55, 0xff1d4b55, 0xff254d56, 0xff254f58, 0xff2b535a, 0xff2c555d, 0xff31585f,
    0xff375e6d, 0xff365d68, 0xff375b65, 0xff3b5d6c, 0xff38585f, 0xff365758, 0xff406067, 0xff476773,
    0xff3d5a68, 0xff3e5461, 0xff475a66, 0xff55626e, 0xff55636d, 0xff5a6264, 0xff56626d, 0xff515e6f,
    0xff536073, 0xff4d5e7b, 0xff4b5e7a, 0xff515f76, 0xff565f72, 0xff4c566c, 0xff4c5567, 0xff6a6e80,
    0xff535a75, 0xff54648c, 0xff627198, 0xff6b6f8e, 0xff8488a8, 0xff9f9198, 0xffa47055, 0xffbb8e67,
    0xffd0a171, 0xffe2b275, 0xffefba78, 0xffc89a6a, 0xff846450, 0xff7e5d4f, 0xff997058, 0xff866251,
    0xff6f5546, 0xff6e5346, 0xff645145, 0xff4b3929, 0xff453126, 0xff493931, 0xff4c3e39, 0xff75574f,
    0xff8a6251, 0xffbd8b68, 0xfff2bd80, 0xffd6a574, 0xffc28c60, 0xff6b5243, 0xff715044, 0xff8d6550,
    0xffa0795c, 0xffdca571, 0xffdfa571, 0xff9f7658, 0xff926e5a, 0xff30231b, 0xff4a423c, 0xff4c3c37,
    0xff4f413b, 0xff4e433f, 0xff423731, 0xff483d36, 0xff3e322c, 0xff57453d, 0xff403834, 0xff473c37,
    0xff265156, 0xff2b5357, 0xff264f53, 0xff244e50, 0xff30575b, 0xff335553, 0xff33555a, 0xff3a5c5e,
    0xff3a5b5f, 0xff3c5b63, 0xff405f6a, 0xff3b5b5e, 0xff425d63, 0xff44585e, 0xff50625c, 0xff4c5a5a,
    0xff49575c, 0xff4e5b6b, 0xff4f5f70, 0xff4d5f70, 0xff515f74, 0xff586777, 0xff636a70, 0xff5b6876,
    0xff4e5b71, 0xff4e5c6e, 0xff5d6b80, 0xff5d6a88, 0xff50607f, 0xff5b6c8f, 0xff667393, 0xff60709e,
    0xff5c6b95, 0xff6e7aa0, 0xff68729c, 0xff8592bf, 0xffd5c2b6, 0xffc29168, 0xffb18562, 0xffbd9169,
    0xffd7a46b, 0xffe3ae72, 0xffe5af73, 0xfff4bd7c, 0xfff3bd78, 0xffb68964, 0xff654c3e, 0xff4b4036,
    0xff57463c, 0xff5b4c44, 0xff513e32, 0xff3b2818, 0xff5a4d45, 0xff5d493f, 0xff5b4841, 0xff564942,
    0xff574943, 0xff533f38, 0xff675048, 0xff7b553e, 0xffaf724c, 0xffc89a72, 0xff9e755b, 0xff7d6252,
    0xff523e35, 0xff4b3628, 0xff735041, 0xff8c6751, 0xff694e3b, 0xff946f5c, 0xff765b4c, 0xff51443f,
    0xff54443e, 0xff453931, 0xff4d403a, 0xff463d3b, 0xff4a403c, 0xff473932, 0xff4e3f37, 0xff5d4c41,
    0xff23484f, 0xff2a4d50, 0xff26474e, 0xff2e5053, 0xff2c4c4d, 0xff36565c, 0xff3a5757, 0xff3b5756,
    0xff425954, 0xff4b625f, 0xff465a55, 0xff4f605d, 0xff4e5d59, 0xff495b62, 0xff415364, 0xff405165,
    0xff455568, 0xff4f5d6e, 0xff555e69, 0xff5f6771, 0xff616974, 0xff5b6169, 0xff4f5762, 0xff606677,
    0xff697080, 0xff636b80, 0xff5a627c, 0xff4c5b7a, 0xff576688, 0xff536180, 0xff566181, 0xff646c87,
    0xff7f829c, 0xff94888c, 0xffb49b88, 0xffe3aa6d, 0xffc3915f, 0xffc99b6b, 0xffd9aa71, 0xffdca86e,
    0xffe0ac6f, 0xffe6b172, 0xffe5b072, 0xffe8b274, 0xfff1b976, 0xfff4b86e, 0xffc69367, 0xff977459,
    0xff6d574a, 0xff5c473c, 0xff432f22, 0xff4b3d31, 0xff58463e, 0xff57463e, 0xff62514a, 0xff5f4e46,
    0xff57463e, 0xff514139, 0xff43342c, 0xff52423c, 0xff51453f, 0xff604a43, 0xff6a4e3e, 0xff87624f,
    0xff5d493d, 0xff453830, 0xff50423d, 0xff45382f, 0xff4c3b31, 0xff4a3e36, 0xff4e403a, 0xff4f4239,
    0xff493a32, 0xff493e38, 0xff463b38, 0xff493d38, 0xff443b37, 0xff4a3d37, 0xff3d362f, 0xff403834
};

static uint32_t _gStretchBmp1[]=
{
    0xff7b91c0, 0xff7b91c0, 0xff7d91c0, 0xff7e92c1, 0xff7f94c2, 0xff7f95c4, 0xff8094c4, 0xff8093c4,
    0xff8294c4, 0xff8296c5, 0xff8397c6, 0xff8497c5, 0xff8597c5, 0xff8697c5, 0xff8898c6, 0xff8999c6,
    0xff8a9ac7, 0xff8a9bc8, 0xff8a9bc9, 0xff8a9bca, 0xff8b9ccb, 0xff8c9dcb, 0xff8d9ecc, 0xff8e9ecc,
    0xff8f9ecc, 0xff909ecc, 0xff919ecc, 0xff919fcd, 0xff92a0cd, 0xff94a2ce, 0xff96a3ce, 0xff96a3ce,
    0xff97a4cf, 0xff98a5d0, 0xff9aa6d1, 0xff9ba7d2, 0xff9ba7d2, 0xff9ba7d2, 0xff9ca8d3, 0xff9da9d4,
    0xff9da9d4, 0xff9ea9d4, 0xff9faad5, 0xffa0acd6, 0xffa0add7, 0xffa1add8, 0xffa1add7, 0xffa1aed5,
    0xffa1afd4, 0xffa1afd5, 0xffa2b0d7, 0xffa2b1d7, 0xffa3b1d6, 0xffa3b3d6, 0xffa4b4d6, 0xffa5b4d6,
    0xffa6b4d6, 0xffa7b4d6, 0xffa9b4d6, 0xffaab4d6, 0xffaab5d6, 0xffaab6d6, 0xffaab6d6, 0xffabb6d6,
    0xffacb6d6, 0xffadb6d5, 0xffadb6d5, 0xffaeb7d6, 0xffafb7d7, 0xffafb7d7, 0xffaeb6d7, 0xffaeb6d7,
    0xffafb7d7, 0xffafb7d7, 0xffafb7d6, 0xffaeb6d6, 0xffadb5d7, 0xffabb4d8, 0xffaab3d7, 0xffa9b1d6,
    0xffa9b0d5, 0xffa9b0d4, 0xffa8b0d4, 0xffa6afd4, 0xffa5aed4, 0xffa5afd5, 0xffa6b0d6, 0xffa6b0d5,
    0xffa5afd3, 0xffa4aed3, 0xffa4add5, 0xffa3add6, 0xffa1add3, 0xffa0add2, 0xffa0add3, 0xffa1add5,
    0xffa1acd5, 0xffa0abd3, 0xffa0abd3, 0xff9fabd3, 0xff9eabd3, 0xff9daad3, 0xff9da9d3, 0xff9ca9d3,
    0xff9ba9d3, 0xff9aa9d3, 0xff9aaad3, 0xff9aaad3, 0xff9baad4, 0xff9baad4, 0xff9ba9d3, 0xff9aa9d2,
    0xff99aad3, 0xff97aad4, 0xff96a9d4, 0xff96a8d3, 0xff96a7d3, 0xff95a7d3, 0xff95a7d4, 0xff95a6d5,
    0xff94a5d6, 0xff93a5d6, 0xff91a3d6, 0xff8da0d5, 0xff899cd4, 0xff8598d4, 0xff8196d5, 0xff7f95d6,
    0xff7e92d7, 0xff7e91d6, 0xff7c90d5, 0xff7a8fd3, 0xff798fd2, 0xff778fd2, 0xff758ed1, 0xff728cd0,
    0xff708bd0, 0xff6e8ad1, 0xff6d8ad2, 0xff6c8ad1, 0xff6989d0, 0xff6787d0, 0xff6485d2, 0xff6084d2,
    0xff5e84d2, 0xff5d84d1, 0xff5d84cf, 0xff5d83cf, 0xff5c81d0, 0xff5a7fd1, 0xff5a7fd1, 0xff5b80d2,
    0xff5b80d2, 0xff5b80d3, 0xff5b80d3, 0xff5a80d2, 0xff597fd0, 0xff597ecd, 0xff5a7ecb, 0xff5b7eca,
    0xff5b7fca, 0xff5b7fca, 0xff597dc9, 0xff587cc9, 0xff577aca, 0xff5579ca, 0xff5377c8, 0xff5176c6,
    0xff5075c6, 0xff5075c7, 0xff5075c7, 0xff4f74c6, 0xff4f74c5, 0xff4e73c4, 0xff4e73c4, 0xff4e73c4,
    0xff4d72c3, 0xff4c71c3, 0xff4b70c2, 0xff4b70c2, 0xff7d93c1, 0xff7d93c1, 0xff7f93c2, 0xff8093c3,
    0xff8094c4, 0xff8095c4, 0xff8195c4, 0xff8195c4, 0xff8295c4, 0xff8395c4, 0xff8496c4, 0xff8697c5,
    0xff8798c6, 0xff8798c6, 0xff8799c7, 0xff889ac8, 0xff899bc9, 0xff8a9bc9, 0xff8b9cca, 0xff8b9cca,
    0xff8b9dcb, 0xff8c9dcb, 0xff8e9dcb, 0xff909ecc, 0xff919fcd, 0xff929fce, 0xff94a1d0, 0xff94a1d1,
    0xff95a2d1, 0xff97a3d1, 0xff97a3d1, 0xff96a3d1, 0xff96a4d2, 0xff97a4d2, 0xff99a5d3, 0xff9ba7d3,
    0xff9ba9d4, 0xff9caad4, 0xff9eabd4, 0xff9facd4, 0xffa0add4, 0xffa0afd4, 0xffa1b0d4, 0xffa1b1d4,
    0xffa3b2d4, 0xffa4b2d4, 0xffa5b3d4, 0xffa6b4d4, 0xffa6b4d4, 0xffa6b5d4, 0xffa7b5d4, 0xffa8b5d4,
    0xffaab5d4, 0xffacb5d4, 0xffadb5d3, 0xffadb5d3, 0xffaeb5d3, 0xffaeb4d3, 0xffaeb3d3, 0xffaeb3d4,
    0xffafb4d5, 0xffb1b5d6, 0xffb1b5d6, 0xffb1b5d5, 0xffb0b4d4, 0xffafb3d3, 0xffafb3d3, 0xffafb4d4,
    0xffb0b4d5, 0xffb1b4d5, 0xffb2b3d4, 0xffb2b2d4, 0xffb1b1d4, 0xffb0b1d4, 0xffb0b1d5, 0xffb0b1d5,
    0xffafb0d5, 0xffacafd5, 0xffaaaed4, 0xffa8acd3, 0xffa6aad2, 0xffa6aad2, 0xffa6aad2, 0xffa5a9d1,
    0xffa5a9d0, 0xffa4a9d1, 0xffa4a8d2, 0xffa4a8d3, 0xffa5a7d3, 0xffa5a7d3, 0xffa3a6d1, 0xffa2a6d0,
    0xffa1a5d0, 0xffa1a4d1, 0xffa1a4d1, 0xffa1a4d1, 0xffa0a5d1, 0xff9fa6d1, 0xff9fa6d1, 0xffa0a5cf,
    0xffa1a4cf, 0xffa0a5d0, 0xff9fa5d1, 0xff9fa5d0, 0xffa0a4ce, 0xffa0a4ce, 0xffa0a5cf, 0xffa0a5cf,
    0xff9fa5cf, 0xff9ea5cf, 0xff9ea5d0, 0xff9ea5d0, 0xff9fa6cf, 0xff9fa8ce, 0xff9ea8ce, 0xff9da8d0,
    0xff9da8d0, 0xff9ea9d0, 0xff9ea9d0, 0xff9daacf, 0xff9caacf, 0xff9baad0, 0xff99a9d1, 0xff98a8d1,
    0xff95a5d1, 0xff91a3d1, 0xff8ca2d1, 0xff87a0d1, 0xff829dd1, 0xff7d9ad2, 0xff7797d4, 0xff7294d6,
    0xff7092d6, 0xff6f90d5, 0xff6e8ed5, 0xff6d8ed5, 0xff6c8dd5, 0xff688ad5, 0xff6688d5, 0xff6585d6,
    0xff6483d6, 0xff6382d6, 0xff6283d5, 0xff6383d4, 0xff6584d3, 0xff6685d2, 0xff6585d0, 0xff6484cf,
    0xff6384cf, 0xff6384ce, 0xff6384cd, 0xff6285cb, 0xff6285cb, 0xff6284cb, 0xff6283cc, 0xff5f81cc,
    0xff5d80cc, 0xff5c7fcd, 0xff5d7fce, 0xff5d7fcd, 0xff5d7ecc, 0xff5d7eca, 0xff5c7fc9, 0xff5b7fc9,
    0xff597ec9, 0xff577cca, 0xff567bca, 0xff567bca, 0xff557aca, 0xff5479c9, 0xff5479c9, 0xff5478c8,
    0xff5378c7, 0xff5177c5, 0xff5076c4, 0xff4f75c3, 0xff4f73c2, 0xff4e72c1, 0xff4d72bf, 0xff4d72bf,
    0xff8094c2, 0xff8094c2, 0xff8295c3, 0xff8395c3, 0xff8395c3, 0xff8395c3, 0xff8496c4, 0xff8597c5,
    0xff8597c5, 0xff8596c4, 0xff8596c4, 0xff8496c4, 0xff8497c5, 0xff8597c5, 0xff8698c6, 0xff8698c6,
    0xff8799c6, 0xff8899c8, 0xff899ac9, 0xff8a9acb, 0xff8b9bcd, 0xff8c9cce, 0xff8d9cce, 0xff8f9dce,
    0xff909ece, 0xff909ecf, 0xff92a0cf, 0xff93a1cf, 0xff94a2cf, 0xff96a4d1, 0xff97a5d2, 0xff99a6d3,
    0xff9ba8d3, 0xff9caad2, 0xff9caccf, 0xff9eaecf, 0xffa0b0d2, 0xffa1b1d3, 0xffa2b1d2, 0xffa2b1d1,
    0xffa3b2d0, 0xffa5b3d0, 0xffa6b3d0, 0xffa7b3d0, 0xffa9b3d0, 0xffaab2d0, 0xffabb2d0, 0xffadb3d1,
    0xffadb3d1, 0xffadb3d0, 0xffacb2d0, 0xffadb2d1, 0xffaeb1d2, 0xffaeb0d2, 0xffacafd1, 0xffabafd1,
    0xffacb0d1, 0xffadb1d1, 0xffadb1d2, 0xffacb0d2, 0xffacb0d2, 0xffadafd1, 0xffadafd1, 0xffadb0d0,
    0xffadb0d1, 0xffadb0d4, 0xffadb0d5, 0xffadb0d4, 0xffacafd3, 0xffacafd3, 0xffacafd3, 0xffabafd3,
    0xffaaafd4, 0xffa9afd4, 0xffa8add3, 0xffa8acd3, 0xffa7acd3, 0xffa6abd3, 0xffa6aad3, 0xffa6a9d4,
    0xffa5a7d4, 0xffa3a6d4, 0xffa1a6d3, 0xffa1a7d2, 0xffa1a7d2, 0xffa1a7d3, 0xffa1a6d3, 0xffa0a5d2,
    0xff9fa4d1, 0xff9fa4d1, 0xff9ea4d2, 0xff9ea4d2, 0xff9da3d1, 0xff9ca3d1, 0xff9ba3d1, 0xff9ba3d1,
    0xff9ba3d1, 0xff9ba2d0, 0xff9aa2d0, 0xff99a1d1, 0xff98a0d1, 0xff98a0d0, 0xff98a0cf, 0xff98a0cf,
    0xff999fd0, 0xff999fd0, 0xff999fd0, 0xff999fce, 0xff989ecd, 0xff979ecc, 0xff979ecb, 0xff989ecc,
    0xff9b9ecd, 0xff9d9fcf, 0xff9da0cf, 0xff9ca1cf, 0xff9ca1cf, 0xff9da2ce, 0xff9da2ce, 0xff9ba1ce,
    0xff9aa0cf, 0xff99a0d0, 0xff99a1d1, 0xff99a2d0, 0xff98a2ce, 0xff96a2cd, 0xff95a2ce, 0xff93a1cf,
    0xff8d9fd1, 0xff889dd1, 0xff829bd0, 0xff7d98cf, 0xff7897d0, 0xff7495d1, 0xff7195d3, 0xff7195d3,
    0xff7194d4, 0xff6e92d5, 0xff6b90d5, 0xff698ed5, 0xff678cd5, 0xff658ad5, 0xff6388d4, 0xff6386d4,
    0xff6486d4, 0xff6586d3, 0xff6786d1, 0xff6886d0, 0xff6886cf, 0xff6885cf, 0xff6985ce, 0xff6a84cd,
    0xff6a84cd, 0xff6a85cc, 0xff6985cc, 0xff6884cc, 0xff6783cc, 0xff6483cb, 0xff6283c9, 0xff6283c9,
    0xff6282c9, 0xff6181cb, 0xff5e80cc, 0xff5c7fcc, 0xff5a7ecc, 0xff597dcb, 0xff587cca, 0xff577bca,
    0xff567aca, 0xff557aca, 0xff557ac9, 0xff547ac8, 0xff547ac7, 0xff5379c6, 0xff5378c6, 0xff5377c5,
    0xff5276c3, 0xff5175c2, 0xff5074c1, 0xff5074c1, 0xff8496c4, 0xff8496c4, 0xff8497c5, 0xff8597c5,
    0xff8698c6, 0xff8798c6, 0xff8798c6, 0xff8797c5, 0xff8797c5, 0xff8797c5, 0xff8797c5, 0xff8697c6,
    0xff8698c7, 0xff8799c8, 0xff889ac9, 0xff8799c9, 0xff8698c9, 0xff8698c9, 0xff879aca, 0xff889bcb,
    0xff899bcb, 0xff8a9ccc, 0xff8c9ece, 0xff8ea0d0, 0xff8fa1d0, 0xff8fa2cf, 0xff91a4cf, 0xff93a6cf,
    0xff96a8cf, 0xff99aacf, 0xff9cabcf, 0xff9faecf, 0xffa1b0ce, 0xffa2b0ce, 0xffa3afce, 0xffa5afce,
    0xffa5afcf, 0xffa6afcf, 0xffa7b0d0, 0xffa8b0d0, 0xffaab0cf, 0xffabafce, 0xffabafce, 0xffaaafce,
    0xffaaafce, 0xffaaaece, 0xffaaaecf, 0xffaaaed1, 0xffaaaed2, 0xffaaadd1, 0xffaaadd0, 0xffaaaed0,
    0xffa9afd0, 0xffa9afd0, 0xffa8add1, 0xffa7acd1, 0xffa7acd1, 0xffa7add1, 0xffa8aed1, 0xffa9aed1,
    0xffa9aed2, 0xffa8aed2, 0xffa8aed4, 0xffa8aed5, 0xffa8aed5, 0xffa8aed5, 0xffa8aed4, 0xffa9aed4,
    0xffa9add4, 0xffa8acd4, 0xffa7acd4, 0xffa7acd4, 0xffa7aed4, 0xffa7aed4, 0xffa5add2, 0xffa4acd1,
    0xffa3acd2, 0xffa3abd3, 0xffa2aad4, 0xffa1a9d4, 0xffa1a7d4, 0xffa0a7d2, 0xffa0a7d2, 0xffa1a8d4,
    0xffa1a8d5, 0xffa0a7d4, 0xff9fa6d2, 0xff9fa6d2, 0xff9ea7d3, 0xff9da7d3, 0xff9ca5d3, 0xff9ba4d2,
    0xff9aa2d1, 0xff9aa2d0, 0xff99a3d0, 0xff98a4d1, 0xff97a3d1, 0xff96a1d1, 0xff969fd1, 0xff959fd1,
    0xff959fd1, 0xff949ed0, 0xff939dcf, 0xff939dce, 0xff939dce, 0xff929dce, 0xff919dce, 0xff909cce,
    0xff909bcd, 0xff909acc, 0xff9199cc, 0xff929acc, 0xff939ccc, 0xff939dcd, 0xff929ccd, 0xff919bcd,
    0xff919ace, 0xff919acf, 0xff919ad0, 0xff9099ce, 0xff9098cd, 0xff9198cd, 0xff9198cd, 0xff9097cd,
    0xff8f96ce, 0xff8d96ce, 0xff8d96cc, 0xff8c96cc, 0xff8b95cd, 0xff8a94ce, 0xff8794cf, 0xff8595d0,
    0xff8595d0, 0xff8595cf, 0xff8495ce, 0xff8295cd, 0xff8095cd, 0xff7d95cd, 0xff7b95ce, 0xff7895cf,
    0xff7595d0, 0xff7495d0, 0xff7394cf, 0xff7392cf, 0xff7391cf, 0xff7290cf, 0xff6f8ecf, 0xff6d8dce,
    0xff6b8bce, 0xff6989cd, 0xff6987cc, 0xff6986cc, 0xff6984cc, 0xff6884ce, 0xff6884ce, 0xff6884cd,
    0xff6784cc, 0xff6684cb, 0xff6584cb, 0xff6484cb, 0xff6383cb, 0xff6383cb, 0xff6383c9, 0xff6283c9,
    0xff5f82ca, 0xff5c80cc, 0xff5a7fcd, 0xff597ecd, 0xff597ecd, 0xff597dcc, 0xff587dca, 0xff567dc8,
    0xff557cc6, 0xff557ac5, 0xff5579c5, 0xff5479c4, 0xff5378c3, 0xff5277c2, 0xff5276c2, 0xff5275c2,
    0xff8598c4, 0xff8598c4, 0xff8697c4, 0xff8797c4, 0xff8898c5, 0xff8899c6, 0xff889ac7, 0xff879ac9,
    0xff879ac9, 0xff889ac8, 0xff889ac8, 0xff899ac8, 0xff899ac9, 0xff899aca, 0xff899bcb, 0xff899bcb,
    0xff889cca, 0xff8a9cca, 0xff8c9dcb, 0xff8e9ecc, 0xff8e9fce, 0xff8ea1ce, 0xff90a3cd, 0xff92a6cc,
    0xff96a7cb, 0xff99a8cb, 0xff9ba9cb, 0xff9caacd, 0xff9daacd, 0xff9faacb, 0xffa1aaca, 0xffa2abcb,
    0xffa3accd, 0xffa4accd, 0xffa5abcd, 0xffa6abcd, 0xffa7abcc, 0xffa7abcc, 0xffa7aacd, 0xffa7aace,
    0xffa6aace, 0xffa5aace, 0xffa5aacd, 0xffa6abcc, 0xffa6abcd, 0xffa5aacf, 0xffa5aad1, 0xffa5aad1,
    0xffa5abd0, 0xffa6acd0, 0xffa6acd1, 0xffa6acd1, 0xffa5acd1, 0xffa5acd1, 0xffa6add2, 0xffa6add2,
    0xffa6aed3, 0xffa5aed3, 0xffa4aed3, 0xffa4add2, 0xffa5add2, 0xffa7add3, 0xffa7add3, 0xffa6aed3,
    0xffa6aed3, 0xffa7afd4, 0xffa7afd4, 0xffa6aed4, 0xffa5add3, 0xffa5add3, 0xffa5aed2, 0xffa5aed2,
    0xffa4add3, 0xffa4acd3, 0xffa5acd4, 0xffa5acd4, 0xffa4acd3, 0xffa3abd1, 0xffa3aad1, 0xffa3a9d3,
    0xffa3a9d3, 0xffa2a9d2, 0xffa1a9d1, 0xffa0a8d1, 0xffa0a7d2, 0xffa0a8d3, 0xffa0a9d3, 0xffa0a9d3,
    0xffa0a9d3, 0xffa0a9d3, 0xffa0a8d1, 0xff9fa7d1, 0xff9ca6d2, 0xff9aa5d3, 0xff99a4d2, 0xff99a4d1,
    0xff99a4d1, 0xff98a4d2, 0xff97a4d2, 0xff96a4d2, 0xff95a3d2, 0xff95a2d2, 0xff95a1d1, 0xff949fd0,
    0xff929ecf, 0xff919ece, 0xff919ecd, 0xff919ecd, 0xff909dcd, 0xff909ccd, 0xff8e9bcd, 0xff8e9bcd,
    0xff8f9acd, 0xff909acd, 0xff8f9ace, 0xff8e9acf, 0xff8c99cf, 0xff8c98cf, 0xff8b97ce, 0xff8997cc,
    0xff8797cb, 0xff8695cd, 0xff8593d0, 0xff8492d0, 0xff8391ce, 0xff8391cd, 0xff8391ce, 0xff8391ce,
    0xff8491ce, 0xff8491cd, 0xff8290cb, 0xff808fca, 0xff818fca, 0xff8490ca, 0xff8690cc, 0xff8691cd,
    0xff8591cd, 0xff8492cd, 0xff8292cc, 0xff8091cb, 0xff7e91cb, 0xff7e91cb, 0xff8092cb, 0xff8094cb,
    0xff7f95c9, 0xff7e95c9, 0xff7c95ca, 0xff7b94cb, 0xff7a93cb, 0xff7991cb, 0xff7590cc, 0xff7190cc,
    0xff6d8ece, 0xff6c8dcf, 0xff698bcf, 0xff6688ce, 0xff6386cd, 0xff6184ce, 0xff6082cf, 0xff5f82d0,
    0xff5f82d1, 0xff5f82d1, 0xff5e81d1, 0xff5e81d0, 0xff5d81ce, 0xff5c81cd, 0xff5c80cd, 0xff5c7fcd,
    0xff5b7fcc, 0xff5a7ecb, 0xff597dc9, 0xff587cc8, 0xff587bc7, 0xff577bc7, 0xff577bc7, 0xff577bc7,
    0xff567ac6, 0xff557ac4, 0xff5479c1, 0xff5479bf, 0xff8698c6, 0xff8698c6, 0xff8698c6, 0xff8798c6,
    0xff8899c8, 0xff8a9aca, 0xff8a9bca, 0xff8a9cc8, 0xff8a9cc8, 0xff899cc9, 0xff899cc9, 0xff899dc9,
    0xff8a9ec9, 0xff8b9fc9, 0xff8da0c9, 0xff8fa1c9, 0xff90a3c8, 0xff91a3c8, 0xff91a3c8, 0xff92a3c8,
    0xff95a5c7, 0xff97a6c7, 0xff99a7c8, 0xff9ba7c9, 0xff9ca7ca, 0xff9ea6ca, 0xff9ea6ca, 0xff9ea5ca,
    0xff9ea4ca, 0xff9da4ca, 0xff9ca4ca, 0xff9da4ca, 0xff9ea4cb, 0xff9ea4cb, 0xff9ea5cb, 0xff9ea5cb,
    0xff9fa5cb, 0xffa0a5cb, 0xffa1a6cc, 0xffa1a6cc, 0xffa1a6cd, 0xffa1a7cd, 0xffa1a8cd, 0xffa1a9cd,
    0xffa1a9cd, 0xffa1aace, 0xffa1aacf, 0xffa2abd0, 0xffa2abd0, 0xffa2acd0, 0xffa2acd0, 0xffa2acd0,
    0xffa3acd1, 0xffa3acd1, 0xffa2add0, 0xffa2add0, 0xffa4aed2, 0xffa6aed3, 0xffa6aed3, 0xffa5add2,
    0xffa5add2, 0xffa5add2, 0xffa5add2, 0xffa6aed3, 0xffa6aed3, 0xffa6aed3, 0xffa6aed3, 0xffa6aed3,
    0xffa6aed3, 0xffa6aed3, 0xffa6aed3, 0xffa6aed3, 0xffa5add2, 0xffa4add2, 0xffa4add1, 0xffa4add1,
    0xffa4add2, 0xffa4acd3, 0xffa4acd3, 0xffa4acd2, 0xffa4acd2, 0xffa3acd2, 0xffa3acd2, 0xffa2acd2,
    0xffa2abd2, 0xffa2abd2, 0xffa1aad2, 0xffa1a9d1, 0xffa0a8d0, 0xffa0a8d0, 0xff9fa8d1, 0xff9ea8d2,
    0xff9ca9d2, 0xff9ba9d1, 0xff9aa8d1, 0xff9aa7d0, 0xff9aa7d0, 0xff99a6cf, 0xff99a6cf, 0xff99a5d0,
    0xff98a4d0, 0xff96a3d1, 0xff95a3d1, 0xff95a3d1, 0xff95a2d0, 0xff95a1d0, 0xff94a1cf, 0xff939fce,
    0xff929ecd, 0xff919dcc, 0xff909cce, 0xff909ccf, 0xff8f9bcf, 0xff8d9acf, 0xff8b9ace, 0xff8a9acd,
    0xff889acd, 0xff8898ce, 0xff8897cf, 0xff8796d1, 0xff8695d1, 0xff8394d0, 0xff8193ce, 0xff8193ce,
    0xff8292ce, 0xff8292ce, 0xff8291cd, 0xff8291cc, 0xff8191cc, 0xff8091cc, 0xff8091cb, 0xff7f90cb,
    0xff7c8ecc, 0xff778ccd, 0xff768acd, 0xff788acd, 0xff7a8bcc, 0xff7b8ccb, 0xff7c8dcb, 0xff7d8dca,
    0xff7e8dca, 0xff7e8dca, 0xff7f8eca, 0xff7f8eca, 0xff808eca, 0xff818fca, 0xff8292c9, 0xff8293c9,
    0xff8293ca, 0xff8092ca, 0xff7e92c9, 0xff7b93c8, 0xff7792c9, 0xff7390cb, 0xff6f8fcd, 0xff6c8fce,
    0xff688ece, 0xff638bcf, 0xff5e88d0, 0xff5c85d1, 0xff5c84d3, 0xff5c82d3, 0xff5d82d3, 0xff5e81d2,
    0xff5e80d2, 0xff5d7fd1, 0xff5d7fcf, 0xff5c7fcc, 0xff5c7fcb, 0xff5b7fca, 0xff5b7fca, 0xff5a7fc9,
    0xff597fc9, 0xff577ec9, 0xff567dc8, 0xff567cc7, 0xff577bc6, 0xff577ac6, 0xff567ac6, 0xff567ac6,
    0xff8799c7, 0xff8799c7, 0xff889ac8, 0xff899bc9, 0xff8a9dca, 0xff8c9fca, 0xff8da0ca, 0xff8ea1ca,
    0xff8ea2c9, 0xff8fa3c8, 0xff90a3c7, 0xff92a3c7, 0xff93a3c7, 0xff92a2c7, 0xff92a2c8, 0xff93a2c8,
    0xff95a3c8, 0xff97a3c8, 0xff98a3c7, 0xff99a3c7, 0xff9aa2c7, 0xff9aa1c8, 0xff9ba1c9, 0xff9ba2c9,
    0xff9aa2c9, 0xff99a1c9, 0xff99a1c9, 0xff9aa1ca, 0xff9aa1cb, 0xff99a0cb, 0xff98a0cb, 0xff98a0cc,
    0xff98a1cc, 0xff98a2cb, 0xff99a2ca, 0xff9ba4ca, 0xff9da5cc, 0xff9ea6cd, 0xff9ea7cd, 0xff9ea7cd,
    0xff9da7cd, 0xff9da7cd, 0xff9da7cc, 0xff9ea6cb, 0xff9fa6cb, 0xffa0a6cd, 0xffa0a7ce, 0xffa2a8ce,
    0xffa2a9ce, 0xffa1a9ce, 0xffa0a9ce, 0xffa0a9ce, 0xffa0aace, 0xffa1aace, 0xffa2abce, 0xffa3abcf,
    0xffa4acd1, 0xffa4add2, 0xffa5add2, 0xffa5add2, 0xffa5add2, 0xffa5add2, 0xffa5add2, 0xffa5add2,
    0xffa5add2, 0xffa6add2, 0xffa6add2, 0xffa6aed3, 0xffa6aed3, 0xffa6aed3, 0xffa5add2, 0xffa5add2,
    0xffa6aed3, 0xffa6aed3, 0xffa6aed3, 0xffa5add2, 0xffa4acd1, 0xffa4acd1, 0xffa4acd1, 0xffa5add2,
    0xffa5add2, 0xffa4acd1, 0xffa4abd1, 0xffa4acd3, 0xffa4acd4, 0xffa3abd2, 0xffa2aad0, 0xffa1aad0,
    0xff9fa9d1, 0xff9fa9d1, 0xff9fa8d1, 0xff9fa8d1, 0xff9ea7d2, 0xff9da7d2, 0xff9ea7d2, 0xff9ea7d2,
    0xff9da7d2, 0xff9ca6d1, 0xff9aa6d1, 0xff9aa5d1, 0xff99a4d1, 0xff98a4d1, 0xff98a4d1, 0xff98a3d0,
    0xff97a2cf, 0xff96a2cf, 0xff96a1d0, 0xff95a0d0, 0xff949fce, 0xff939ece, 0xff929dd0, 0xff919dd1,
    0xff909cd0, 0xff8e9bcf, 0xff8d9bce, 0xff8d9bce, 0xff8b9ace, 0xff8998ce, 0xff8797ce, 0xff8596d0,
    0xff8496d1, 0xff8495d0, 0xff8595ce, 0xff8696ce, 0xff8696ce, 0xff8495ce, 0xff8193cd, 0xff7f91cc,
    0xff7e91cb, 0xff7d91ca, 0xff7c90ca, 0xff7a8fca, 0xff798ecb, 0xff778dcb, 0xff778bcd, 0xff7789ce,
    0xff7789ce, 0xff788bcd, 0xff788dcc, 0xff788ccc, 0xff788bcb, 0xff788bca, 0xff798bc9, 0xff798bc8,
    0xff7a8bc8, 0xff7a8bc8, 0xff7c8bc7, 0xff7c8bc7, 0xff7b8bc8, 0xff798bc9, 0xff788bc9, 0xff788ac9,
    0xff768ac9, 0xff748bc9, 0xff728cc9, 0xff708cca, 0xff6e8ccc, 0xff698bcd, 0xff6489ce, 0xff6189ce,
    0xff6189ce, 0xff6189ce, 0xff6088cd, 0xff6087cd, 0xff5f85cd, 0xff5e83cd, 0xff5c81cd, 0xff5a7fcd,
    0xff597ecc, 0xff597dca, 0xff597dca, 0xff597dcb, 0xff597dcb, 0xff587cc9, 0xff587cc8, 0xff587cc8,
    0xff587cc8, 0xff587cc8, 0xff577bc7, 0xff577bc7, 0xff8b9fca, 0xff8b9fca, 0xff8da1cb, 0xff8ea2cb,
    0xff8fa4c9, 0xff91a5c6, 0xff92a6c5, 0xff94a6c6, 0xff96a6c6, 0xff97a5c7, 0xff97a4c7, 0xff96a3c6,
    0xff96a3c6, 0xff96a2c6, 0xff97a1c6, 0xff98a0c6, 0xff989fc7, 0xff989dc7, 0xff979dc8, 0xff969dc8,
    0xff969ec9, 0xff979fc9, 0xff979fc9, 0xff979fca, 0xff979fca, 0xff969fcb, 0xff949fcb, 0xff93a0cc,
    0xff93a1cc, 0xff93a1ce, 0xff94a1ce, 0xff94a1cd, 0xff95a2cc, 0xff96a2cc, 0xff98a3cd, 0xff98a3ce,
    0xff97a4cf, 0xff97a4cf, 0xff98a4cd, 0xff99a4cc, 0xff99a4cc, 0xff99a4cc, 0xff9aa5cc, 0xff9ca5cd,
    0xff9da7cd, 0xff9ca7cd, 0xff9ba8cd, 0xff9daace, 0xff9eaace, 0xff9fa9ce, 0xff9fa8cd, 0xff9fa8cd,
    0xffa0aace, 0xffa1aace, 0xffa2aacf, 0xffa3aad0, 0xffa2abd0, 0xffa2acd0, 0xffa3acd0, 0xffa4acd1,
    0xffa4acd1, 0xffa5add2, 0xffa6aed3, 0xffa7afd4, 0xffa7afd4, 0xffa7afd4, 0xffa6aed3, 0xffa6aed3,
    0xffa5add2, 0xffa5add2, 0xffa4acd1, 0xffa4acd1, 0xffa5add2, 0xffa5add2, 0xffa4acd1, 0xffa4acd1,
    0xffa4acd1, 0xffa4acd1, 0xffa4acd1, 0xffa3abd0, 0xffa3abd0, 0xffa3abd0, 0xffa3abd0, 0xffa4acd1,
    0xffa4acd2, 0xffa3abd2, 0xffa2a9d1, 0xffa2a8d1, 0xffa1a8d1, 0xffa1a8d1, 0xffa0a9d2, 0xffa0a9d2,
    0xffa0a9d3, 0xff9fa8d3, 0xff9ea7d2, 0xff9da6d1, 0xff9ea6d1, 0xff9ea6d1, 0xff9da6d0, 0xff9aa6cf,
    0xff98a6ce, 0xff98a6cf, 0xff99a5d0, 0xff99a4d0, 0xff98a3cf, 0xff97a3cf, 0xff97a2cf, 0xff96a2cf,
    0xff95a1d0, 0xff94a0d0, 0xff929ecf, 0xff919dcf, 0xff909cd0, 0xff8f9cd2, 0xff8e9cd2, 0xff8d9bd1,
    0xff8b9bcf, 0xff8a9acf, 0xff899ace, 0xff8899cd, 0xff8798cd, 0xff8798cd, 0xff8798cd, 0xff8697cc,
    0xff8596cb, 0xff8394cb, 0xff8394cc, 0xff8293cc, 0xff7f92cb, 0xff7e92cb, 0xff7f92cb, 0xff7f92cb,
    0xff7e92ca, 0xff7b91c8, 0xff798fc8, 0xff788fc9, 0xff788eca, 0xff788dcc, 0xff788dcd, 0xff778ccc,
    0xff758bcb, 0xff748bcb, 0xff728acc, 0xff728acc, 0xff7189ca, 0xff7288c9, 0xff7488c6, 0xff7588c6,
    0xff7587c7, 0xff7486c9, 0xff7185cc, 0xff6e83ce, 0xff6c83ce, 0xff6c83cc, 0xff6c84ca, 0xff6d85c9,
    0xff6d86c9, 0xff6c86ca, 0xff6b87cb, 0xff6b88cb, 0xff6c89c9, 0xff6c8ac9, 0xff6b8ac9, 0xff698ac9,
    0xff6589c9, 0xff6187c9, 0xff5e86c9, 0xff5c84ca, 0xff5b82cb, 0xff5b80cb, 0xff5b7eca, 0xff5a7dc9,
    0xff597cc8, 0xff587cc9, 0xff587cca, 0xff587dcb, 0xff587dca, 0xff597dc8, 0xff5a7cc6, 0xff5b7cc4,
    0xff8fa4c6, 0xff8fa4c6, 0xff93a5c6, 0xff96a6c6, 0xff97a5c6, 0xff97a4c6, 0xff97a4c6, 0xff97a5c7,
    0xff97a5c7, 0xff96a4c6, 0xff96a3c6, 0xff96a2c6, 0xff95a1c6, 0xff94a0c6, 0xff929ec6, 0xff919dc6,
    0xff909cc6, 0xff909cc6, 0xff8f9cc6, 0xff8f9cc6, 0xff909cc6, 0xff909cc6, 0xff909cc8, 0xff909dca,
    0xff909dcb, 0xff919ecc, 0xff919ecc, 0xff929fcc, 0xff92a0cc, 0xff93a0cc, 0xff93a0cc, 0xff93a0cc,
    0xff93a0cc, 0xff94a0cd, 0xff95a1ce, 0xff95a1ce, 0xff95a2ce, 0xff95a2ce, 0xff96a3cd, 0xff96a4cd,
    0xff97a4ce, 0xff97a4ce, 0xff97a3cd, 0xff97a3cc, 0xff97a3cc, 0xff99a5cc, 0xff9aa6cc, 0xff9ca7cd,
    0xff9da7cd, 0xff9ea7cc, 0xff9fa8cb, 0xff9fa9cc, 0xffa0a9cd, 0xffa0a9ce, 0xffa1a8ce, 0xffa1a8ce,
    0xffa2a9cf, 0xffa2aacf, 0xffa3abd0, 0xffa3abd0, 0xffa3abd0, 0xffa3abd0, 0xffa3abd0, 0xffa3abd0,
    0xffa3abd0, 0xffa2aacf, 0xffa2aacf, 0xffa2aacf, 0xffa2aacf, 0xffa3abd0, 0xffa4acd1, 0xffa4acd1,
    0xffa4acd2, 0xffa3abd2, 0xffa2aad2, 0xffa2aad1, 0xffa3abd0, 0xffa4acd0, 0xffa4acd0, 0xffa3abd1,
    0xffa2aad1, 0xffa1a9d1, 0xffa1a9d0, 0xffa2aacf, 0xffa2aacf, 0xffa1aacf, 0xffa0a9d0, 0xffa0a8d0,
    0xffa0a7d0, 0xffa0a7d0, 0xff9fa8d1, 0xff9fa8d1, 0xff9ea7d1, 0xff9ea6d1, 0xff9ea7d2, 0xff9ea8d3,
    0xff9da8d3, 0xff9ca7d1, 0xff9ba7d1, 0xff9ba6d1, 0xff9ba6d1, 0xff9aa6d1, 0xff99a6d0, 0xff98a5cf,
    0xff97a4ce, 0xff96a3ce, 0xff95a2cf, 0xff95a1cf, 0xff94a0d0, 0xff94a0d0, 0xff94a0d0, 0xff94a0d0,
    0xff929fd0, 0xff909dd1, 0xff8f9cd1, 0xff8e9bd1, 0xff8d9bd1, 0xff8c9cd1, 0xff8c9cd0, 0xff8b9bce,
    0xff8a9acd, 0xff8999cd, 0xff8898cd, 0xff8898cc, 0xff8797cb, 0xff8797cb, 0xff8697ca, 0xff8596ca,
    0xff8594cb, 0xff8493cb, 0xff8292ca, 0xff8092c9, 0xff7f92c9, 0xff7f91ca, 0xff7d91ca, 0xff7b90c8,
    0xff7a8fc7, 0xff788ec6, 0xff778dc7, 0xff758bc9, 0xff7389cb, 0xff7289cb, 0xff7189c9, 0xff6f89c7,
    0xff6f89c6, 0xff6f89c6, 0xff7188c8, 0xff7187c9, 0xff6f86c9, 0xff6d85c8, 0xff6d85c7, 0xff6e85c6,
    0xff6e84c6, 0xff6d83c7, 0xff6c82c7, 0xff6c82c7, 0xff6d83c7, 0xff6e83c7, 0xff6f83c7, 0xff6f84c7,
    0xff6f86c7, 0xff6f86c5, 0xff6e85c3, 0xff6d84c2, 0xff6c85c2, 0xff6a86c2, 0xff6886c2, 0xff6586c2,
    0xff6386c3, 0xff6186c5, 0xff5e84c7, 0xff5b83c7, 0xff5981c7, 0xff587fc6, 0xff587dc5, 0xff577cc7,
    0xff577cc9, 0xff587cc9, 0xff597bc8, 0xff5a7bc8, 0xff95a1c6, 0xff95a1c6, 0xff93a1c4, 0xff93a1c4,
    0xff94a2c6, 0xff96a2c8, 0xff96a1c8, 0xff94a0c7, 0xff94a0c6, 0xff94a0c6, 0xff94a0c6, 0xff939ec6,
    0xff929dc6, 0xff919dc7, 0xff909dc8, 0xff8f9dc8, 0xff8f9cc8, 0xff8f9cc8, 0xff8f9dc9, 0xff8f9dc9,
    0xff8f9cc8, 0xff8f9cc8, 0xff8f9cc9, 0xff8f9dca, 0xff8f9dca, 0xff909ecb, 0xff909ecb, 0xff919fcc,
    0xff929fcc, 0xff93a0cd, 0xff93a0cd, 0xff94a1cd, 0xff94a1cc, 0xff94a1cc, 0xff93a0cd, 0xff93a0cd,
    0xff94a1cd, 0xff95a2cd, 0xff95a2cd, 0xff95a2cd, 0xff95a1cd, 0xff95a1cd, 0xff96a1ce, 0xff97a1cf,
    0xff97a3cf, 0xff97a4cf, 0xff98a5ce, 0xff9aa4ce, 0xff9ba4cd, 0xff9ca6cc, 0xff9da8cb, 0xff9da8cb,
    0xff9ea7cb, 0xff9ea7cb, 0xff9fa7cc, 0xffa0a8cd, 0xffa1a9ce, 0xffa1aace, 0xffa1aace, 0xffa0a9ce,
    0xffa0a9ce, 0xffa0aacd, 0xffa0aacd, 0xffa1a9ce, 0xffa1a9ce, 0xffa2aace, 0xffa2aace, 0xffa2aace,
    0xffa2aace, 0xffa2aacf, 0xffa1a9cf, 0xffa1a9d1, 0xffa2aad2, 0xffa3abd2, 0xffa3abd2, 0xffa2aad2,
    0xffa2a9d2, 0xffa1a8d2, 0xffa1a8d2, 0xffa0a9d1, 0xffa0a9d1, 0xffa1a9d1, 0xffa1a9d1, 0xffa0a8d0,
    0xffa0a8cf, 0xffa0a8d0, 0xffa0a8d1, 0xff9fa8d2, 0xff9ea8d3, 0xff9ea8d3, 0xff9fa7d4, 0xffa0a7d4,
    0xffa0a7d3, 0xff9fa7d2, 0xff9ea8d2, 0xff9ea8d3, 0xff9ea8d3, 0xff9ea7d2, 0xff9ea6d2, 0xff9ea5d1,
    0xff9da5d1, 0xff9ca6d0, 0xff9ba6cf, 0xff9aa5cf, 0xff98a4d0, 0xff97a3d0, 0xff97a3d0, 0xff97a3d0,
    0xff96a3d1, 0xff96a3d2, 0xff96a1d2, 0xff95a0d1, 0xff949fd0, 0xff939fcf, 0xff929ecf, 0xff919ed0,
    0xff909cd0, 0xff8f9bd0, 0xff8f9ad0, 0xff8d98cf, 0xff8c97ce, 0xff8c99cd, 0xff8c9acc, 0xff8c99cc,
    0xff8b96cc, 0xff8994cb, 0xff8795ca, 0xff8695c9, 0xff8495c9, 0xff8495ca, 0xff8495ca, 0xff8494c9,
    0xff8393c8, 0xff8293c7, 0xff8091c7, 0xff7e90c9, 0xff7c8fca, 0xff7a8dc8, 0xff798cc7, 0xff778bc8,
    0xff758ac9, 0xff748ac9, 0xff7389c8, 0xff7189c8, 0xff7188c7, 0xff7087c7, 0xff6f86c8, 0xff6e86c8,
    0xff6d85c8, 0xff6d84c8, 0xff6d84c8, 0xff6c83c7, 0xff6c83c6, 0xff6c82c5, 0xff6c82c5, 0xff6c82c6,
    0xff6b82c7, 0xff6a82c6, 0xff6a81c5, 0xff6a80c5, 0xff6a7fc4, 0xff6a7fc3, 0xff6b80c2, 0xff6c80c1,
    0xff6c80bf, 0xff6c80be, 0xff6d82be, 0xff6e83be, 0xff6e83bd, 0xff6d81bc, 0xff6981bc, 0xff6582be,
    0xff6282bf, 0xff6082c0, 0xff5f81c0, 0xff5d80c2, 0xff5b7ec3, 0xff5a7dc3, 0xff587bc2, 0xff587bc2,
    0xff909dc5, 0xff909dc5, 0xff919dc4, 0xff919dc4, 0xff929ec5, 0xff929ec6, 0xff919ec6, 0xff909dc5,
    0xff909ec5, 0xff919fc5, 0xff92a0c6, 0xff929fc7, 0xff929ec8, 0xff919dc8, 0xff909dc8, 0xff909dc8,
    0xff909dc9, 0xff909dc9, 0xff909dc9, 0xff909dc9, 0xff8f9cc9, 0xff8f9cc9, 0xff8f9cc9, 0xff8f9cc9,
    0xff909dca, 0xff919ecb, 0xff919ecb, 0xff919ecb, 0xff919ecb, 0xff919ecc, 0xff929fcd, 0xff93a0cd,
    0xff94a1cd, 0xff94a1cd, 0xff94a1cd, 0xff94a1cd, 0xff93a0cb, 0xff93a0cb, 0xff94a1cc, 0xff95a2cd,
    0xff94a1cd, 0xff93a0cc, 0xff93a0cd, 0xff94a2ce, 0xff94a2cd, 0xff94a2cb, 0xff95a2ca, 0xff97a2c9,
    0xff98a2ca, 0xff99a3cc, 0xff9aa4cd, 0xff9aa4cd, 0xff9ba5cb, 0xff9ba5cb, 0xff9ca6cc, 0xff9da7cc,
    0xff9ea7cc, 0xff9fa7cc, 0xff9fa8cd, 0xff9fa8cd, 0xff9fa8cd, 0xffa0a7cc, 0xffa0a7cc, 0xffa0a9cd,
    0xffa0a9ce, 0xff9fa8cf, 0xff9fa7cf, 0xffa0a7cf, 0xffa1a8cf, 0xffa1a9cf, 0xffa1aacf, 0xffa1aacf,
    0xffa1aad0, 0xffa1a9d0, 0xffa1a8cf, 0xffa0a7ce, 0xffa0a6cf, 0xff9fa6d0, 0xff9fa6d0, 0xff9ea5d0,
    0xff9ea5d0, 0xff9ea5d0, 0xff9ea5d0, 0xff9ea5d0, 0xff9ea5d0, 0xff9ea6d0, 0xff9ea7d0, 0xff9ea7d0,
    0xff9ea6d0, 0xff9ea6d0, 0xff9fa7d0, 0xff9fa8d0, 0xff9fa9ce, 0xff9fa9ce, 0xff9fa8cf, 0xff9ea7d1,
    0xff9ea7d2, 0xff9ea6d2, 0xff9ea6d2, 0xff9ea5d2, 0xff9da4d1, 0xff9ca4d0, 0xff9ba4d0, 0xff9aa4d0,
    0xff9aa3d0, 0xff9aa3d0, 0xff9aa2d1, 0xff99a2d1, 0xff97a1d0, 0xff96a1cf, 0xff96a0ce, 0xff96a0cd,
    0xff95a0cd, 0xff939fce, 0xff929ecf, 0xff919dd0, 0xff919dd0, 0xff909ccf, 0xff909ccf, 0xff909bcf,
    0xff8f9bcf, 0xff8e9bcf, 0xff8d9ace, 0xff8c99cd, 0xff8a98cc, 0xff8a97cc, 0xff8a96cb, 0xff8a96cb,
    0xff8995ca, 0xff8794c9, 0xff8594c8, 0xff8394c7, 0xff8393c6, 0xff8292c6, 0xff8190c7, 0xff808fc9,
    0xff7e8fca, 0xff7b8fc9, 0xff7a8fc7, 0xff798ec7, 0xff788cc7, 0xff778bc6, 0xff778ac4, 0xff758ac3,
    0xff7489c4, 0xff7389c4, 0xff7289c3, 0xff7188c3, 0xff7087c4, 0xff6e85c5, 0xff6d84c5, 0xff6c83c5,
    0xff6b83c5, 0xff6b83c5, 0xff6a83c4, 0xff6a82c3, 0xff6a81c2, 0xff6981c1, 0xff6880c1, 0xff687fc1,
    0xff697ec1, 0xff697ebf, 0xff687dbd, 0xff677dbc, 0xff677cbc, 0xff687cbb, 0xff687cb8, 0xff697db6,
    0xff6a7db6, 0xff6a7eb8, 0xff6a7eb8, 0xff687eb7, 0xff677eb7, 0xff667eb7, 0xff647eb7, 0xff627eb8,
    0xff607db9, 0xff5e7db9, 0xff5d7cb9, 0xff5c7cb9, 0xff8a96c3, 0xff8a96c3, 0xff8b98c4, 0xff8d99c5,
    0xff8d9ac6, 0xff8d9ac6, 0xff8e9bc6, 0xff8f9cc7, 0xff8f9cc7, 0xff8f9cc8, 0xff8f9cc9, 0xff919dca,
    0xff929eca, 0xff929fcb, 0xff929fcb, 0xff929fcb, 0xff919eca, 0xff919eca, 0xff919eca, 0xff919eca,
    0xff909dca, 0xff909dca, 0xff909dc9, 0xff909dc9, 0xff909dca, 0xff909ecb, 0xff909ecb, 0xff919fcb,
    0xff929fcb, 0xff93a0cc, 0xff93a0cd, 0xff93a0cd, 0xff93a0cc, 0xff93a0cc, 0xff94a1cd, 0xff94a1ce,
    0xff93a1cf, 0xff93a1cf, 0xff94a1cf, 0xff95a1ce, 0xff95a1ce, 0xff95a1cd, 0xff95a1cd, 0xff94a1cc,
    0xff94a1cb, 0xff93a0ca, 0xff93a0ca, 0xff95a2cb, 0xff96a4cc, 0xff96a4cb, 0xff97a4ca, 0xff99a4ca,
    0xff9ba5cc, 0xff9da5cc, 0xff9da6cc, 0xff9da6cc, 0xff9ea6cb, 0xff9ea6cb, 0xff9ea6cb, 0xff9ea7cc,
    0xff9ea8cd, 0xff9ea8ce, 0xff9ea8ce, 0xff9fa7cf, 0xff9fa7cf, 0xff9fa7cf, 0xff9fa7ce, 0xff9ea8cd,
    0xff9ea9cd, 0xff9ea9cd, 0xff9fa7ce, 0xff9fa7ce, 0xff9ea7cd, 0xff9ea7cd, 0xff9fa7cd, 0xff9fa7ce,
    0xff9ea7cf, 0xff9da6cf, 0xff9da5cf, 0xff9da4ce, 0xff9da4ce, 0xff9ca4cd, 0xff9ca5cd, 0xff9da6ce,
    0xff9da6ce, 0xff9da5ce, 0xff9da5ce, 0xff9da6ce, 0xff9ea7ce, 0xff9ea7ce, 0xff9ea6cf, 0xff9ea5cf,
    0xff9fa5ce, 0xff9fa5ce, 0xff9fa5ce, 0xff9ea6ce, 0xff9ea6cf, 0xff9ea6d0, 0xff9ea6d0, 0xff9ea7d0,
    0xff9ea7d0, 0xff9da6cf, 0xff9ca5cf, 0xff9ba4cf, 0xff9ba4cf, 0xff9ca4cf, 0xff9ca3cf, 0xff9ba3cf,
    0xff99a3ce, 0xff96a3ce, 0xff94a1cf, 0xff939fd0, 0xff939ed0, 0xff949ecf, 0xff939ecf, 0xff929ece,
    0xff919ece, 0xff909ecd, 0xff909dcc, 0xff909ccc, 0xff8f9bcc, 0xff8e9acc, 0xff8d99cc, 0xff8d99cc,
    0xff8c98cc, 0xff8c98cc, 0xff8b97cc, 0xff8b97cb, 0xff8a96ca, 0xff8995c9, 0xff8995ca, 0xff8894ca,
    0xff8693c9, 0xff8391c7, 0xff8191c6, 0xff8092c6, 0xff7f92c6, 0xff7e8ec7, 0xff7d8cc8, 0xff7c8cc8,
    0xff7b8dc7, 0xff798dc6, 0xff778cc5, 0xff758ac4, 0xff7589c4, 0xff7588c4, 0xff7488c4, 0xff7288c3,
    0xff6f87c3, 0xff6d85c2, 0xff6c84c2, 0xff6c84c1, 0xff6c84c1, 0xff6b83c0, 0xff6b83c0, 0xff6a82bf,
    0xff6981bf, 0xff6880bf, 0xff677fbf, 0xff677fbe, 0xff667ebd, 0xff667ebd, 0xff657dbc, 0xff647dbc,
    0xff647cbd, 0xff647bbd, 0xff647aba, 0xff647ab7, 0xff647ab6, 0xff657ab7, 0xff657ab7, 0xff6479b7,
    0xff6479b7, 0xff6579b5, 0xff6579b3, 0xff647ab3, 0xff627bb3, 0xff617bb3, 0xff617ab2, 0xff617ab2,
    0xff8493c3, 0xff8493c3, 0xff8595c2, 0xff8696c2, 0xff8797c3, 0xff8998c5, 0xff8a99c6, 0xff8a9ac7,
    0xff8a9ac7, 0xff8b9bc6, 0xff8c9bc6, 0xff8e9cc7, 0xff8f9cc8, 0xff8f9cc7, 0xff8e9cc6, 0xff8e9cc7,
    0xff8f9bc8, 0xff8f9bc9, 0xff909cc8, 0xff909dc8, 0xff909cc9, 0xff909cca, 0xff909dcb, 0xff919ecb,
    0xff919ecb, 0xff919dcc, 0xff919dcc, 0xff919dcc, 0xff919dcc, 0xff929dcc, 0xff939ecc, 0xff94a0cd,
    0xff94a1ce, 0xff94a1cd, 0xff93a0cc, 0xff93a0cb, 0xff93a0cb, 0xff93a0cb, 0xff94a1cc, 0xff94a1cd,
    0xff95a2ce, 0xff95a2ce, 0xff95a2cf, 0xff94a1cf, 0xff94a1cf, 0xff93a1cf, 0xff94a2ce, 0xff96a4cd,
    0xff98a5cd, 0xff99a4cd, 0xff98a3cc, 0xff97a3cb, 0xff96a4cb, 0xff96a4cb, 0xff98a3cc, 0xff9aa3cd,
    0xff9ca4cc, 0xff9ca4cc, 0xff9ca4cc, 0xff9ba4cd, 0xff9ba4cd, 0xff9ca5ce, 0xff9ea5ce, 0xff9fa6ce,
    0xffa0a6ce, 0xffa0a6cd, 0xffa0a6cd, 0xffa1a6ce, 0xffa2a5ce, 0xffa3a5cd, 0xffa4a4cc, 0xffa6a4cc,
    0xffa7a4cc, 0xffa9a4cc, 0xffaca5cc, 0xffaea5cc, 0xffaea5cb, 0xffb0a6c9, 0xffb3a6c9, 0xffb8a7c9,
    0xffbba7c8, 0xffbca7c7, 0xffbea7c6, 0xffc1a8c6, 0xffc4a8c7, 0xffc5a8c7, 0xffc5a9c6, 0xffc6aac6,
    0xffc6aac7, 0xffc6aac7, 0xffc5a9c8, 0xffc5a8c8, 0xffc5a8c7, 0xffc5a8c7, 0xffc3a8c7, 0xffc1a7c8,
    0xffbea7c9, 0xffbca7cb, 0xffbaa7cb, 0xffbaa7ca, 0xffb7a7ca, 0xffb3a7cb, 0xffafa7cc, 0xffaca6cd,
    0xffa9a4cd, 0xffa7a4cd, 0xffa5a5cc, 0xffa2a5cd, 0xffa0a3ce, 0xff9ea2cf, 0xff9da2cf, 0xff9ca2ce,
    0xff99a1cf, 0xff969fcf, 0xff959fce, 0xff959fcd, 0xff949ecd, 0xff919dce, 0xff909cce, 0xff909dce,
    0xff919ece, 0xff909ecd, 0xff8f9dcc, 0xff8e9ccb, 0xff8d9ac9, 0xff8d98c9, 0xff8c98c9, 0xff8c98ca,
    0xff8b98cb, 0xff8a97cb, 0xff8896cb, 0xff8695c9, 0xff8494c8, 0xff8394c6, 0xff8293c4, 0xff8292c4,
    0xff8291c4, 0xff8090c6, 0xff7d8fc8, 0xff7a8dc8, 0xff788cc7, 0xff788cc7, 0xff788dc6, 0xff788dc5,
    0xff768bc4, 0xff758ac3, 0xff7489c2, 0xff7388c1, 0xff7287c1, 0xff7186c1, 0xff7084c1, 0xff6e83c1,
    0xff6c82c1, 0xff6c83c0, 0xff6b83c0, 0xff6a81c0, 0xff6980bf, 0xff6880bd, 0xff6681bc, 0xff6581bc,
    0xff6580bd, 0xff637fbd, 0xff617fbd, 0xff607ebd, 0xff617cbb, 0xff627aba, 0xff627ab9, 0xff617ab9,
    0xff617ab8, 0xff6079b8, 0xff6079b6, 0xff5f79b5, 0xff5f79b4, 0xff6078b2, 0xff6177b1, 0xff6176b0,
    0xff6176af, 0xff6176ae, 0xff6075ae, 0xff6075ae, 0xff8295c2, 0xff8295c2, 0xff8496c4, 0xff8596c5,
    0xff8495c5, 0xff8295c3, 0xff8296c2, 0xff8397c2, 0xff8497c2, 0xff8596c2, 0xff8596c3, 0xff8698c4,
    0xff8799c5, 0xff8a9ac6, 0xff8c9ac7, 0xff8d9ac7, 0xff8c9bc7, 0xff8c9bc7, 0xff8b9bc7, 0xff8b9bc7,
    0xff8d9cc8, 0xff8e9cc8, 0xff8f9cc9, 0xff8f9cc9, 0xff8f9cc9, 0xff8f9cc9, 0xff8f9cc9, 0xff8f9dca,
    0xff909ecb, 0xff919fca, 0xff929fca, 0xff929fca, 0xff929fcb, 0xff929fcb, 0xff929fcc, 0xff929fcc,
    0xff93a0cd, 0xff94a1cd, 0xff95a2cd, 0xff95a2cd, 0xff95a2ce, 0xff94a1ce, 0xff94a1cd, 0xff94a1ca,
    0xff94a1ca, 0xff95a2cc, 0xff96a3cd, 0xff98a2ce, 0xff99a2ce, 0xff99a2cc, 0xff99a3ca, 0xff99a3ca,
    0xff9aa3ca, 0xff9ba3ca, 0xff9ca1ca, 0xff9da1ca, 0xff9ea2ca, 0xffa0a3ca, 0xffa2a3ca, 0xffa5a4ca,
    0xffaaa5ca, 0xffb0a6ca, 0xffb8a8c8, 0xffbda9c6, 0xffc4aac4, 0xffcdadc4, 0xffd3afc4, 0xffd8b1c2,
    0xffdcb3c0, 0xffe2b7bf, 0xffe7bbbe, 0xffebbfbe, 0xffedc2bf, 0xffefc6bf, 0xfff1cabf, 0xfff3cdbf,
    0xfff7d1c0, 0xfffbd4c1, 0xfffcd9c1, 0xfffcddc1, 0xfffde1c2, 0xfffee4c3, 0xffffe6c4, 0xfffee8c5,
    0xfffde9c5, 0xfffeeac5, 0xffffebc6, 0xffffebc7, 0xffffecc8, 0xffffecc7, 0xffffedc5, 0xffffedc4,
    0xffffedc5, 0xffffedc6, 0xffffecc5, 0xffffeac2, 0xffffe9c1, 0xffffe7c0, 0xffffe4c0, 0xffffe1bf,
    0xffffddbe, 0xffffd7bc, 0xffffd2bb, 0xfffecdbc, 0xfffcc9bd, 0xfffac4bd, 0xfff7c0bd, 0xfff1babd,
    0xffe9b7bf, 0xffe1b2c0, 0xffd7acc1, 0xffcfa8c2, 0xffc6a6c4, 0xffbda5c7, 0xffb5a4c8, 0xffaea2c9,
    0xffa7a0ca, 0xffa39fcb, 0xff9f9ecb, 0xff9b9dca, 0xff989dc9, 0xff969cca, 0xff939bcc, 0xff909acc,
    0xff8d99cc, 0xff8b99ca, 0xff8a98c8, 0xff8a98c7, 0xff8997c7, 0xff8896c7, 0xff8796c8, 0xff8595c8,
    0xff8494c8, 0xff8493c7, 0xff8291c5, 0xff8191c4, 0xff8090c4, 0xff7e8fc4, 0xff7c8ec5, 0xff7b8dc6,
    0xff7a8bc6, 0xff798ac5, 0xff798ac4, 0xff778ac3, 0xff768ac2, 0xff758ac2, 0xff7388c2, 0xff7287c2,
    0xff7186c0, 0xff7085be, 0xff6f85bf, 0xff6e85c0, 0xff6c85bf, 0xff6c85bd, 0xff6b84bb, 0xff6a82bc,
    0xff6880bd, 0xff677fbd, 0xff657fbc, 0xff647fbc, 0xff647fbb, 0xff627ebb, 0xff617dbb, 0xff607cbb,
    0xff5f7cbc, 0xff5f7cbb, 0xff5e7cb8, 0xff5e7bb5, 0xff5e7ab5, 0xff5f79b6, 0xff5f78b6, 0xff5f78b5,
    0xff5e78b4, 0xff5d76b3, 0xff5d75b1, 0xff5d74af, 0xff5e74ad, 0xff5e74ac, 0xff5d73ac, 0xff5d73ac,
    0xff9ca7cb, 0xff9ca7cb, 0xff92a1c6, 0xff899bc3, 0xff8598c3, 0xff8597c4, 0xff8395c3, 0xff8293c2,
    0xff8393c3, 0xff8595c5, 0xff8797c6, 0xff8899c4, 0xff8899c3, 0xff8899c4, 0xff8899c5, 0xff8899c5,
    0xff889ac5, 0xff899ac5, 0xff8b99c6, 0xff8c99c6, 0xff8c9ac6, 0xff8c9ac6, 0xff8c9ac7, 0xff8c9ac8,
    0xff8d9ac8, 0xff8e9bc8, 0xff909cc8, 0xff919dc9, 0xff919eca, 0xff909dc9, 0xff8f9cc9, 0xff909dca,
    0xff919ecb, 0xff929fcb, 0xff929fca, 0xff929fca, 0xff919ecb, 0xff919ecb, 0xff92a1cc, 0xff93a2cc,
    0xff93a1ca, 0xff949fc9, 0xff959fca, 0xff97a1cc, 0xff98a1cc, 0xff98a0ca, 0xff99a0c9, 0xff9ca2c8,
    0xff9fa3c8, 0xffa1a4c8, 0xffa5a5c8, 0xffaaa5c8, 0xffb1a6c7, 0xffb9a8c5, 0xffbfaac4, 0xffc8adc1,
    0xffd3b1be, 0xffdeb6bc, 0xffe9bcbc, 0xfff1c3bd, 0xfff6cabd, 0xfff7d1bd, 0xfff7d9c0, 0xfff5dfc3,
    0xfff0e3c7, 0xffe8e6cb, 0xffe0e6ce, 0xffd8e7d4, 0xffd1e6d9, 0xffcae3dd, 0xffc4dfde, 0xffbedbe2,
    0xffbad8e6, 0xffb6d5ea, 0xffb3d2ee, 0xffb1cff1, 0xffafcdf3, 0xffaecbf4, 0xffaecaf6, 0xffafc9f8,
    0xffafc7fa, 0xffb0c7fb, 0xffb0c6fb, 0xffb1c5fc, 0xffb1c4fc, 0xffb0c4fc, 0xffb0c5fc, 0xffb0c5fc,
    0xffb1c4fc, 0xffb2c4fc, 0xffb2c6fd, 0xffb3c8fe, 0xffb5caff, 0xffb7ccff, 0xffb9ceff, 0xffbad1fe,
    0xffbbd5fe, 0xffbcd9fe, 0xffbeddfe, 0xffc0dffd, 0xffc4e3fb, 0xffcae8f7, 0xffd0eef4, 0xffd5f5f1,
    0xffdafbed, 0xffe0fee9, 0xffe7ffe4, 0xffefffdd, 0xfff7ffd7, 0xfffcffd1, 0xfffffdcc, 0xfffff8c8,
    0xfffff0c4, 0xffffe6c0, 0xffffdcbb, 0xffffd3b8, 0xfffcc8b7, 0xfff5bfb9, 0xffebb7bb, 0xffdfafbd,
    0xffd4aabe, 0xffc6a4c0, 0xffb9a0c1, 0xffae9ec2, 0xffa69cc2, 0xff9e9ac4, 0xff9a99c6, 0xff9698c7,
    0xff9096c6, 0xff8c95c5, 0xff8993c6, 0xff8892c7, 0xff8792c7, 0xff8593c6, 0xff8393c4, 0xff8093c4,
    0xff7e92c3, 0xff7d90c2, 0xff7d8ec2, 0xff7b8cc1, 0xff798bc0, 0xff798ac0, 0xff7889bf, 0xff7789bf,
    0xff7589be, 0xff7489be, 0xff7389bc, 0xff7388bc, 0xff7186bd, 0xff6f84be, 0xff6e83bd, 0xff6d82bc,
    0xff6b82bb, 0xff6b82ba, 0xff6a82ba, 0xff6980ba, 0xff677fba, 0xff657ebb, 0xff647ebb, 0xff647dba,
    0xff637cb9, 0xff627cb8, 0xff607cb9, 0xff5f7cb9, 0xff5e7bb8, 0xff5d7ab7, 0xff5d7ab7, 0xff5d7ab7,
    0xff5c79b6, 0xff5b78b5, 0xff5b78b4, 0xff5a78b3, 0xff5a77b3, 0xff5a75b2, 0xff5b74b0, 0xff5b74ae,
    0xff5b73ab, 0xff5a72aa, 0xff5971a9, 0xff5970a9, 0xff97a4c7, 0xff97a4c7, 0xff94a3c8, 0xff90a0c8,
    0xff889cc6, 0xff8298c3, 0xff8094c0, 0xff8191c0, 0xff8291c0, 0xff8293c2, 0xff8295c3, 0xff8496c5,
    0xff8697c5, 0xff8798c4, 0xff8798c3, 0xff8899c3, 0xff8899c4, 0xff8899c5, 0xff8697c6, 0xff8697c6,
    0xff8798c8, 0xff8899c8, 0xff8a9ac6, 0xff8c9ac5, 0xff8d9ac6, 0xff8d9ac8, 0xff8d9ac9, 0xff8d9bc8,
    0xff8d9bc8, 0xff8e9ccb, 0xff8e9ccc, 0xff8e9bcb, 0xff8e9bc9, 0xff8e9bc9, 0xff8e9cca, 0xff8e9dcb,
    0xff909ecc, 0xff919ecc, 0xff929ecc, 0xff949ecb, 0xff979fcb, 0xff9aa0ca, 0xff9ea1ca, 0xffa2a2c9,
    0xffa9a4c8, 0xffb0a6c7, 0xffb8a9c6, 0xffc4acc5, 0xffcfb1c4, 0xffdcb9c2, 0xffe8c2c0, 0xffefcac0,
    0xfff1cfc1, 0xfff0d7c3, 0xffecdec7, 0xffe5e3cc, 0xffd9e6d4, 0xffcee5da, 0xffc3e1e0, 0xffb9dbe5,
    0xffb1d3ea, 0xffabcdee, 0xffa7c5f1, 0xffa6c0f2, 0xffa7bbf1, 0xffa8b7ee, 0xffaab5ec, 0xffabb3ea,
    0xffacb2e9, 0xffadb2e8, 0xffafb3e7, 0xffb1b5e5, 0xffb1b6e2, 0xffb2b7e1, 0xffb6bae1, 0xffb8bce2,
    0xffbabee1, 0xffbbbfe0, 0xffbcc0df, 0xffbdc0df, 0xffbdc2df, 0xffbdc3df, 0xffbdc4df, 0xffc0c5de,
    0xffc1c6de, 0xffc1c6de, 0xffc0c6de, 0xffc0c6dd, 0xffc0c7dc, 0xffc2c9de, 0xffc4cae2, 0xffc7cbe4,
    0xffcacce5, 0xffcccde5, 0xffcdcee6, 0xffcecfe8, 0xffcecfe8, 0xffcfcee8, 0xffcfcee9, 0xffd0cdec,
    0xffd0ccee, 0xffd0caef, 0xffcfc8f0, 0xffcec6f2, 0xffcdc4f4, 0xffc9c3f7, 0xffc5c3fa, 0xffbfc3fc,
    0xffbbc3fe, 0xffb8c5ff, 0xffb7c8ff, 0xffb8cdff, 0xffb9d3ff, 0xffbcdbfd, 0xffc1e4f9, 0xffc9ecf4,
    0xffd5f5ec, 0xffe0fbe5, 0xffecfedb, 0xfff9fbd0, 0xfffff3c8, 0xffffeac1, 0xffffdebc, 0xfffdd2b8,
    0xfff7c6b6, 0xffedb9b6, 0xffe2b1b8, 0xffd3aaba, 0xffc2a3bd, 0xffb39fbf, 0xffa79ac2, 0xff9d95c4,
    0xff9693c3, 0xff9191c0, 0xff8b8fbf, 0xff878ebf, 0xff838dc0, 0xff7f8cc0, 0xff7d8cc0, 0xff7a8bbf,
    0xff7889be, 0xff7788be, 0xff7788bd, 0xff7688bc, 0xff7587bb, 0xff7387bb, 0xff7187bc, 0xff7086bd,
    0xff7085be, 0xff7084be, 0xff6f83bd, 0xff6d82bc, 0xff6b81bb, 0xff6a80bb, 0xff6980bb, 0xff677fb8,
    0xff657fb6, 0xff647fb6, 0xff647eb6, 0xff647db5, 0xff637bb4, 0xff617ab2, 0xff5f7bb2, 0xff5e7bb2,
    0xff5d7bb4, 0xff5c7ab5, 0xff5c7ab5, 0xff5c79b5, 0xff5b78b4, 0xff5a78b3, 0xff5a77b3, 0xff5b76b3,
    0xff5b75b3, 0xff5a74b1, 0xff5973ae, 0xff5873ab, 0xff5773a8, 0xff5771a7, 0xff576fa7, 0xff576da7,
    0xff8899c5, 0xff8899c5, 0xff889ac3, 0xff8699c2, 0xff7f95c1, 0xff7a91c1, 0xff7891c1, 0xff7b93c2,
    0xff7f94c2, 0xff8193c1, 0xff8393c1, 0xff8495c2, 0xff8396c2, 0xff8395c2, 0xff8394c2, 0xff8394c2,
    0xff8394c2, 0xff8394c2, 0xff8394c2, 0xff8495c3, 0xff8596c4, 0xff8697c5, 0xff8797c6, 0xff8797c6,
    0xff8796c6, 0xff8896c5, 0xff8997c5, 0xff8a99c5, 0xff8b9ac5, 0xff8c9ac6, 0xff8c9ac7, 0xff8d9bc7,
    0xff8e9cc7, 0xff8f9cc7, 0xff909bc7, 0xff949bc7, 0xff989dc7, 0xff9e9ec7, 0xffa69fc7, 0xffaea2c6,
    0xffb7a7c4, 0xffc1aec2, 0xffccb5c1, 0xffd5bbc2, 0xffdfc5c2, 0xffe5cdc3, 0xffe7d5c5, 0xffe1deca,
    0xffd8e1d0, 0xffcce1d9, 0xffbfdbe3, 0xffb2d3e9, 0xffa8cbed, 0xffa1c1f0, 0xff9fbaf2, 0xffa1b5f2,
    0xffa4b3ef, 0xffa8b3ec, 0xffadb4ea, 0xffb1b5e7, 0xffb1b5e2, 0xffb0b6de, 0xffaeb6da, 0xffaeb7d9,
    0xffadb7d8, 0xffadb6d7, 0xffadb5d7, 0xffacb4d6, 0xffabb3d6, 0xffabb4d6, 0xffacb5d6, 0xffaeb6d6,
    0xffb0b5d7, 0xffb1b5d8, 0xffb2b6da, 0xffb3b8db, 0xffb4bada, 0xffb6bbd9, 0xffb7bcda, 0xffb8bddc,
    0xffb9bedd, 0xffbabfdd, 0xffbabfdd, 0xffbbbfdd, 0xffbcbfde, 0xffbdbfdf, 0xffbec0e0, 0xffbec1df,
    0xffbfc3de, 0xffc0c5de, 0xffc1c5df, 0xffc2c5e0, 0xffc3c6e1, 0xffc4c7e2, 0xffc4c7e2, 0xffc4c6e2,
    0xffc5c7e2, 0xffc6c8e3, 0xffc7c8e3, 0xffc7c8e4, 0xffc7c8e4, 0xffc8cae5, 0xffc9cbe5, 0xffc9cce5,
    0xffc9cce4, 0xffcacce3, 0xffcbcde2, 0xffcbcee2, 0xffcacfe1, 0xffcacfe2, 0xffcccfe4, 0xffcdcde6,
    0xffcccae6, 0xffcac7e7, 0xffc6c3e9, 0xffc2c0ec, 0xffbcbcf0, 0xffb7b9f5, 0xffb2b9f9, 0xffacbbfe,
    0xffaac1ff, 0xffaac9fe, 0xffb1d4fa, 0xffbce0f3, 0xffcaeaeb, 0xffdaf2df, 0xffe6f3d5, 0xfff1eeca,
    0xfffae3bf, 0xfffad6b9, 0xfff6c9b5, 0xffeabcb5, 0xffdcb1b5, 0xffcca8b6, 0xffba9eb8, 0xffae97ba,
    0xffa192bb, 0xff948cbc, 0xff8c8abb, 0xff8588ba, 0xff8087b9, 0xff7b86ba, 0xff7786bb, 0xff7486bb,
    0xff7386ba, 0xff7386b9, 0xff7185ba, 0xff6f84bb, 0xff6d84bb, 0xff6c83bb, 0xff6b82bb, 0xff6a81ba,
    0xff6a7fb8, 0xff697eb8, 0xff687eb7, 0xff667eb7, 0xff647eb7, 0xff637db6, 0xff637cb5, 0xff627bb4,
    0xff627bb4, 0xff6079b2, 0xff5f79b1, 0xff5e78b1, 0xff5e78b2, 0xff5d78b3, 0xff5b77b3, 0xff5976b2,
    0xff5976b1, 0xff5976b0, 0xff5976b0, 0xff5875b0, 0xff5774b0, 0xff5572ae, 0xff5471ac, 0xff5371aa,
    0xff5371a9, 0xff5370a8, 0xff526fa7, 0xff526ea7, 0xffa2abcc, 0xffa2abcc, 0xff96a3c8, 0xff889ac4,
    0xff7d93c1, 0xff768ec0, 0xff768dbf, 0xff798fc0, 0xff7b90c0, 0xff7b91c1, 0xff7b91c2, 0xff7e91c2,
    0xff8091c2, 0xff8393c3, 0xff8595c4, 0xff8696c4, 0xff8696c2, 0xff8496c2, 0xff8396c3, 0xff8295c3,
    0xff8294c2, 0xff8294c1, 0xff8294c1, 0xff8494c2, 0xff8695c3, 0xff8897c4, 0xff8997c4, 0xff8896c4,
    0xff8996c4, 0xff8d97c4, 0xff9299c4, 0xff979ac4, 0xff9e9cc3, 0xffa59fc3, 0xffaca2c2, 0xffb8a8c2,
    0xffc3adc2, 0xffceb6c2, 0xffd7c2c1, 0xffdbcdc2, 0xffdbd5c6, 0xffd6d9cd, 0xffccdad3, 0xffc0d7d9,
    0xffb2d0e1, 0xffa9c8e7, 0xffa3beec, 0xffa0b6ef, 0xffa2b2ed, 0xffa4b0e9, 0xffa7b1e3, 0xffaab3e0,
    0xffabb4de, 0xffabb4db, 0xffabb5d9, 0xffaab5d7, 0xffaab4d5, 0xffaab3d5, 0xffabb2d5, 0xffabb2d6,
    0xffabb2d6, 0xffabb2d6, 0xffa9b2d6, 0xffa8b1d5, 0xffa7b0d5, 0xffa7aed4, 0xffa7aed4, 0xffa7afd4,
    0xffa7b1d5, 0xffa7b1d5, 0xffa8b1d4, 0xffaab1d4, 0xffabb3d4, 0xffacb4d5, 0xffaeb5d6, 0xffb0b6d7,
    0xffb3b8d8, 0xffb5bada, 0xffb6bbdb, 0xffb6bbdb, 0xffb6bbdb, 0xffb6bcdc, 0xffb7bcdc, 0xffb9bddb,
    0xffbabedb, 0xffbabedb, 0xffbabedc, 0xffbbbfdd, 0xffbcc0df, 0xffbdc0df, 0xffbdc1de, 0xffbdc1dd,
    0xffbec2de, 0xffbec3df, 0xffbec3df, 0xffbfc3de, 0xffc0c4df, 0xffc1c5e0, 0xffc1c5e0, 0xffc2c5e0,
    0xffc2c5e0, 0xffc2c5e0, 0xffc2c4df, 0xffc1c3de, 0xffc0c3de, 0xffc0c3df, 0xffc0c4e0, 0xffc0c4e0,
    0xffc0c4df, 0xffbfc3df, 0xffbec3df, 0xffbdc2df, 0xffbcc0de, 0xffbcbfdd, 0xffbcbfdd, 0xffbcc0dd,
    0xffbcc0dd, 0xffbdc1dc, 0xffbec1db, 0xffc0c2da, 0xffc0c2db, 0xffbfc0dd, 0xffbcbce1, 0xffb8b7e6,
    0xffb3b2eb, 0xffacb0f1, 0xffa5aff3, 0xff9fb4f5, 0xff9ebdf4, 0xffa5c9f0, 0xffb2d6e8, 0xffc4e0dd,
    0xffd7e6d3, 0xffe5e6c9, 0xffefddbf, 0xfff1d0b7, 0xffebc1b2, 0xffddb3af, 0xffcca7b0, 0xffbc9bb3,
    0xffab91b6, 0xff9c89b6, 0xff9085b5, 0xff8481b5, 0xff7c81b6, 0xff7782b7, 0xff7382b6, 0xff7182b6,
    0xff6e81b6, 0xff6c80b7, 0xff6a80b7, 0xff6980b7, 0xff677eb7, 0xff677cb6, 0xff667bb5, 0xff657ab3,
    0xff647ab2, 0xff6379b1, 0xff6278b0, 0xff6178b0, 0xff6078b0, 0xff5e78b0, 0xff5d77af, 0xff5c77ae,
    0xff5b77ad, 0xff5b76ad, 0xff5b75ac, 0xff5b74ab, 0xff5973ab, 0xff5773ab, 0xff5571ab, 0xff5571aa,
    0xff5570a9, 0xff5470a8, 0xff5370a7, 0xff526fa7, 0xff516ea6, 0xff506da5, 0xff506da4, 0xff506da3,
    0xff9fabcb, 0xff9fabcb, 0xff899bc3, 0xff768cbd, 0xff7088bc, 0xff728abd, 0xff748bbe, 0xff768cbf,
    0xff788ec0, 0xff788ec1, 0xff798fc1, 0xff7b90c0, 0xff7c90c0, 0xff7d90c0, 0xff7e90c1, 0xff7f90c1,
    0xff8091c1, 0xff8092c1, 0xff8193c2, 0xff8294c2, 0xff8594c3, 0xff8694c3, 0xff8694c2, 0xff8693c1,
    0xff8692c1, 0xff8892c1, 0xff8e94c1, 0xff9596c0, 0xff9f9ac0, 0xffaca0c1, 0xffb8a7c1, 0xffc4afc0,
    0xffcdb7bf, 0xffd4c1c0, 0xffd6c9c2, 0xffd2d1c8, 0xffcbd6ce, 0xffbfd5d4, 0xffafcedb, 0xffa4c3e0,
    0xff9db8e5, 0xff9baee7, 0xff9baae7, 0xff9eabe4, 0xffa2acde, 0xffa5aed9, 0xffa7afd4, 0xffa8b1d2,
    0xffa8b2d2, 0xffa8b2d2, 0xffa8b2d3, 0xffa8b2d4, 0xffa8b2d6, 0xffa8b1d6, 0xffa8b0d4, 0xffa7afd3,
    0xffa6afd3, 0xffa5afd3, 0xffa4aed2, 0xffa3aed2, 0xffa4aed2, 0xffa5afd3, 0xffa5aed3, 0xffa4acd1,
    0xffa3abd0, 0xffa4add0, 0xffa4aed1, 0xffa3add0, 0xffa3abd0, 0xffa4abd0, 0xffa5add1, 0xffa7afd3,
    0xffa9b0d4, 0xffaab1d5, 0xffacb2d6, 0xffadb3d6, 0xffaeb4d6, 0xffb0b6d6, 0xffb1b7d7, 0xffb3b8d8,
    0xffb5bada, 0xffb6badb, 0xffb6badb, 0xffb6b9da, 0xffb6b9d9, 0xffb7bad9, 0xffb9bcda, 0xffbabcda,
    0xffbabcdb, 0xffbabcdb, 0xffbbbddb, 0xffbbbedb, 0xffbabeda, 0xffbabeda, 0xffbabfdb, 0xffbbbfdc,
    0xffbbbfdc, 0xffbbbedc, 0xffbbbedc, 0xffbbbfdb, 0xffbbbfdb, 0xffbabeda, 0xffbabeda, 0xffbabfdb,
    0xffbbbfdc, 0xffbbbfdc, 0xffbabedb, 0xffbabddb, 0xffb9bddd, 0xffb9bcdd, 0xffb8badc, 0xffb7b9da,
    0xffb7b9d9, 0xffb6b9d8, 0xffb5b9d8, 0xffb4b8d8, 0xffb4b8d8, 0xffb3b8d9, 0xffb3b8d9, 0xffb3b7d8,
    0xffb3b7d7, 0xffb3b7d6, 0xffb3b7d5, 0xffb2b7d4, 0xffb0b6d3, 0xffb0b6d2, 0xffb1b7d1, 0xffb1b7d2,
    0xffb0b5d5, 0xffadb1d9, 0xffa9abdf, 0xffa3a6e5, 0xff9ba5ec, 0xff94a9f0, 0xff95b4ef, 0xff9cc3ea,
    0xffabd1e1, 0xffc1dcd5, 0xffd2dfc9, 0xffe0dbbe, 0xffe4cfb5, 0xffdfc0af, 0xffd3afad, 0xffc29eac,
    0xffb494ad, 0xffa38bae, 0xff9082ae, 0xff827eae, 0xff767db0, 0xff6f7eb3, 0xff6a7eb3, 0xff687db2,
    0xff667cb2, 0xff657bb2, 0xff647ab2, 0xff6279b2, 0xff6179b1, 0xff5f78b0, 0xff5e76ae, 0xff5d75ad,
    0xff5d75ad, 0xff5d75ad, 0xff5c76ad, 0xff5b76ad, 0xff5975ab, 0xff5874aa, 0xff5773aa, 0xff5673ab,
    0xff5573ab, 0xff5472ab, 0xff5471a9, 0xff5570a8, 0xff556fa7, 0xff5370a8, 0xff5170a9, 0xff506fa8,
    0xff4f6da5, 0xff4f6da4, 0xff4f6da3, 0xff4f6da3, 0xff7c91c1, 0xff7c91c1, 0xff768ec2, 0xff718bc3,
    0xff6f8bc0, 0xff708cbd, 0xff738cbd, 0xff758dbe, 0xff778dbf, 0xff768dbf, 0xff768dbf, 0xff768cc0,
    0xff768cc0, 0xff768dc0, 0xff768ebf, 0xff768dbf, 0xff768bc0, 0xff788bc0, 0xff7a8dc1, 0xff7d8ec1,
    0xff808ebf, 0xff858fbe, 0xff8c91bd, 0xff9594be, 0xffa098bf, 0xffaa9dc1, 0xffb8a5c0, 0xffc2aebe,
    0xffcab8be, 0xffcec5c2, 0xffcacdc7, 0xffc2d1cd, 0xffb6d0d4, 0xffa8c8db, 0xff9cbce1, 0xff96b1e5,
    0xff98aae5, 0xff9ba6e3, 0xff9ea5df, 0xffa0a7da, 0xffa1aad4, 0xffa1adcf, 0xffa1aecd, 0xffa2aecd,
    0xffa3aecf, 0xffa4acd0, 0xffa4acd1, 0xffa3add1, 0xffa2aed0, 0xffa1aed0, 0xff9fadd0, 0xff9eaccf,
    0xff9eabce, 0xff9eaace, 0xff9eaacf, 0xff9eaacf, 0xffa0accf, 0xffa1adcf, 0xffa1acce, 0xffa1abcd,
    0xffa1aacd, 0xffa1aace, 0xffa1aad0, 0xffa1abd1, 0xffa1abd1, 0xffa0aad1, 0xffa0a9d1, 0xffa0a8d1,
    0xffa0a8d0, 0xffa0a8d0, 0xffa1a9d0, 0xffa3abd0, 0xffa5acd1, 0xffa6add2, 0xffa7afd4, 0xffa8b1d5,
    0xffa9b3d6, 0xffabb4d6, 0xffacb5d6, 0xffaeb6d6, 0xffb0b7d6, 0xffb2b8d7, 0xffb3b8d7, 0xffb2b8d7,
    0xffb2b8d7, 0xffb3b9d8, 0xffb5bada, 0xffb5bada, 0xffb5bada, 0xffb5bada, 0xffb5bbda, 0xffb5bbda,
    0xffb6bada, 0xffb6bad9, 0xffb5bad8, 0xffb5bad7, 0xffb6bad8, 0xffb7bbd9, 0xffb7bbda, 0xffb7bada,
    0xffb7b9d9, 0xffb7b9d9, 0xffb7bad9, 0xffb6bada, 0xffb5bada, 0xffb5bada, 0xffb4b9d9, 0xffb3b8d7,
    0xffb2b7d7, 0xffb1b6d6, 0xffb1b6d5, 0xffb1b6d5, 0xffb0b6d5, 0xffafb5d5, 0xffaeb4d5, 0xffaeb4d4,
    0xffadb2d4, 0xffacb2d4, 0xffabb1d4, 0xffaab0d2, 0xffa9b0d1, 0xffa8afd1, 0xffa7aed2, 0xffa7aed2,
    0xffa6afd2, 0xffa6afd2, 0xffa5afd1, 0xffa5aed0, 0xffa3acd0, 0xffa3acd0, 0xffa4add0, 0xffa6afcf,
    0xffa8b0ce, 0xffa9afcd, 0xffa8accf, 0xffa5a8d3, 0xff9ea2da, 0xff959de4, 0xff8f9fea, 0xff8caaea,
    0xff91bae5, 0xffa0cadc, 0xffb3d7d1, 0xffc9dac3, 0xffd7d4b9, 0xffdcc6b1, 0xffd3b1ac, 0xffc29fab,
    0xffb08fa9, 0xff9d84a8, 0xff8b7da9, 0xff7c7bab, 0xff6e7aad, 0xff687aae, 0xff637aae, 0xff5f78ae,
    0xff5e76ad, 0xff5e76ad, 0xff5f76ad, 0xff5e76ae, 0xff5c75ae, 0xff5b75ae, 0xff5a74ac, 0xff5a74ab,
    0xff5873ab, 0xff5672ab, 0xff5572ab, 0xff5572aa, 0xff5472a9, 0xff5371a7, 0xff5370a7, 0xff536fa8,
    0xff536ea8, 0xff536ea7, 0xff526fa6, 0xff516ea7, 0xff506da7, 0xff4f6ca6, 0xff4d6ba3, 0xff4d6ba1,
    0xff6e88bc, 0xff6e88bc, 0xff6987bd, 0xff6787be, 0xff6a88c1, 0xff6f89c3, 0xff728ac1, 0xff738bbe,
    0xff758cbd, 0xff768dbe, 0xff788dbf, 0xff7b8ebf, 0xff7c8ebf, 0xff7b8dbf, 0xff798cbf, 0xff798bc0,
    0xff7a8bc1, 0xff7e8bc0, 0xff848bbd, 0xff8e8dbb, 0xff9b92bc, 0xffa899bd, 0xffb4a3bd, 0xffbeb0bd,
    0xffc7bcbe, 0xffccc6c1, 0xffc7cec8, 0xffbbd0d0, 0xffaccbd9, 0xff9dbfdf, 0xff94b2e2, 0xff92a8e4,
    0xff94a2e2, 0xff98a2de, 0xff9ca7d9, 0xff9faad3, 0xff9eaccf, 0xff9daccd, 0xff9dabcd, 0xff9daace,
    0xff9caace, 0xff9baace, 0xff9baace, 0xff9ba9ce, 0xff9ca9ce, 0xff9daace, 0xff9eaace, 0xff9daace,
    0xff9ca9ce, 0xff9ba8cf, 0xff9ba7d0, 0xff9ba6d0, 0xff9ba6cf, 0xff9ba6cf, 0xff9aa8d0, 0xff9aa8d0,
    0xff9ba7cf, 0xff9ba6ce, 0xff9ba6cf, 0xff9ba7d0, 0xff9ba8d0, 0xff9ba8d0, 0xff9ba8d0, 0xff9ba7cf,
    0xff9ba7cf, 0xff9aa7d1, 0xff9aa7d2, 0xff9aa7d1, 0xff9ca7cf, 0xff9ea9cf, 0xffa2abd0, 0xffa4acd0,
    0xffa4acd0, 0xffa4acd1, 0xffa6aed3, 0xffa7afd4, 0xffa8b0d5, 0xffa9b1d5, 0xffa9b1d6, 0xffa9b2d7,
    0xffabb2d7, 0xffadb2d7, 0xffaeb3d7, 0xffb0b5d6, 0xffb0b6d6, 0xffb0b7d7, 0xffb0b7d8, 0xffb1b8d8,
    0xffb3b8d8, 0xffb3b8d8, 0xffb3b7d7, 0xffb2b7d7, 0xffb2b7d8, 0xffb2b7d8, 0xffb2b7d8, 0xffb1b7d8,
    0xffb1b7d7, 0xffb1b6d6, 0xffb1b6d6, 0xffb2b7d6, 0xffb2b7d6, 0xffb2b7d6, 0xffb1b6d6, 0xffb0b6d6,
    0xffafb5d5, 0xffaeb4d4, 0xffadb2d3, 0xffadb2d3, 0xffadb3d4, 0xffadb3d5, 0xffaab1d4, 0xffa8b0d4,
    0xffa6b0d5, 0xffa6b0d5, 0xffa6afd4, 0xffa7aed3, 0xffa7add1, 0xffa5acd0, 0xffa4acd0, 0xffa2abd0,
    0xffa2aad0, 0xffa2aad1, 0xffa3abd1, 0xffa3abd0, 0xffa2aacf, 0xffa2aacd, 0xffa1a9cd, 0xffa0a8cd,
    0xff9fa7ce, 0xff9fa7cf, 0xff9fa7ce, 0xff9fa6cd, 0xff9ea5cc, 0xff9da4cb, 0xff9da4cc, 0xff9ca4cd,
    0xff9ca5ce, 0xff9da8ca, 0xff9ea8c9, 0xffa0a6cb, 0xff9fa1d1, 0xff989ad7, 0xff8e95dd, 0xff8699e1,
    0xff82a5e2, 0xff89b5dd, 0xff9fc6d3, 0xffb3cec6, 0xffc3ccba, 0xffc9c0af, 0xffc5ada9, 0xffb798a7,
    0xffa485a5, 0xff927ca5, 0xff7f77a6, 0xff7074a6, 0xff6475a7, 0xff5e74aa, 0xff5c74ac, 0xff5a73ac,
    0xff5972ab, 0xff5872ab, 0xff5771ab, 0xff5771ab, 0xff5872ab, 0xff5872aa, 0xff5772a9, 0xff5571a8,
    0xff5371a7, 0xff5270a6, 0xff506fa6, 0xff506ea6, 0xff506da6, 0xff516ea6, 0xff516fa5, 0xff506ea4,
    0xff4e6ca2, 0xff4d6ba1, 0xff4d6ba1, 0xff4d6ba1, 0xff99a4c5, 0xff99a4c5, 0xff909ec3, 0xff8497c0,
    0xff778fbd, 0xff6d89bc, 0xff6a88bd, 0xff6e8abf, 0xff728bc0, 0xff748bbe, 0xff778bbd, 0xff798abd,
    0xff7c8abd, 0xff7f8abd, 0xff858bbc, 0xff908ebc, 0xff9d92bc, 0xffac9abc, 0xffb6a4bb, 0xffc1afbb,
    0xffccbdbd, 0xffcdc7c2, 0xffc5cec9, 0xffb6cfd0, 0xffa5c7d9, 0xff98bae0, 0xff91ade4, 0xff91a5e4,
    0xff96a1e0, 0xff9ba3d9, 0xff9fa7d3, 0xff9fa8cf, 0xff9ea9ce, 0xff9caace, 0xff9baace, 0xff9baad0,
    0xff9ba8d1, 0xff9aa7d2, 0xff98a5d2, 0xff97a4d1, 0xff98a5d2, 0xff99a6d2, 0xff98a6d1, 0xff97a5ce,
    0xff97a5ce, 0xff99a6d0, 0xff9aa7d1, 0xff9aa7d1, 0xff9aa7d0, 0xff99a6d0, 0xff98a5d0, 0xff98a5d0,
    0xff99a6d0, 0xff99a6d0, 0xff99a6d0, 0xff99a6d0, 0xff9aa7d1, 0xff9aa7d2, 0xff9aa6d2, 0xff99a5d1,
    0xff99a5d0, 0xff99a5cf, 0xff99a5cf, 0xff98a5d0, 0xff98a5d0, 0xff98a5cf, 0xff99a5ce, 0xff99a5cf,
    0xff9ba6d1, 0xff9da7d1, 0xffa0a9cf, 0xffa2abcf, 0xffa3abcf, 0xffa3abcf, 0xffa4acd0, 0xffa4acd1,
    0xffa5acd2, 0xffa6add3, 0xffa6add3, 0xffa6aed2, 0xffa6afd2, 0xffa7b0d3, 0xffa8b1d3, 0xffa9b2d3,
    0xffaab3d4, 0xffacb4d5, 0xffadb4d6, 0xffadb4d6, 0xffadb5d5, 0xffadb5d5, 0xffaeb6d5, 0xffafb6d5,
    0xffafb5d5, 0xffaeb4d5, 0xffadb4d5, 0xffadb4d5, 0xffadb4d5, 0xffadb3d6, 0xffadb3d6, 0xffadb3d6,
    0xffadb3d5, 0xffacb2d4, 0xffabb1d3, 0xffaab1d3, 0xffa9b1d4, 0xffa9b1d4, 0xffa9b1d4, 0xffa8b1d2,
    0xffa6b0d0, 0xffa5afcf, 0xffa5add1, 0xffa5acd2, 0xffa5acd2, 0xffa4acd1, 0xffa3abd0, 0xffa2aad0,
    0xffa1a9ce, 0xffa0a8cd, 0xffa0a8cc, 0xffa0a8cc, 0xffa0a8cd, 0xff9fa8cd, 0xff9ea8cd, 0xff9da7cd,
    0xff9da5cd, 0xff9da3cd, 0xff9da3cd, 0xff9da3cd, 0xff9aa2cb, 0xff99a2ca, 0xff9aa2c9, 0xff9aa1c9,
    0xff98a0c9, 0xff969fca, 0xff959dca, 0xff959dca, 0xff969dc9, 0xff979ec8, 0xff969fc8, 0xff949ec9,
    0xff929dc9, 0xff929ec7, 0xff93a0c3, 0xff939fc3, 0xff939bc6, 0xff8f94cc, 0xff848ad5, 0xff7b89da,
    0xff7594da, 0xff78a5d3, 0xff89b6ca, 0xffa0c1c0, 0xffb2bfb4, 0xffb8b1ac, 0xffb39ea6, 0xffa48ca1,
    0xff8e7c9f, 0xff7e749f, 0xff7072a0, 0xff6571a3, 0xff5e71a5, 0xff5870a6, 0xff576fa5, 0xff576ea4,
    0xff556ea4, 0xff546ea4, 0xff536ea4, 0xff536da5, 0xff526da5, 0xff516da5, 0xff516da5, 0xff516da7,
    0xff516da7, 0xff4f6ca6, 0xff4e6ba4, 0xff4d6ba3, 0xff4d6ba1, 0xff4c6aa0, 0xff4b699f, 0xff4b699f,
    0xffabb3ce, 0xffabb3ce, 0xff9fa9c8, 0xff8f9cc2, 0xff7f92be, 0xff738bbc, 0xff6d87ba, 0xff6f87ba,
    0xff7287bb, 0xff7787bc, 0xff7f89bd, 0xff8a8bbb, 0xff9790b9, 0xffa596b9, 0xffb5a0ba, 0xffc3aeba,
    0xffcebdbc, 0xffd2ccc1, 0xffcfd5c7, 0xffc2d6d0, 0xffaaccdb, 0xff97bde3, 0xff8eade7, 0xff8da0e6,
    0xff919ce1, 0xff979fda, 0xff9ca4d3, 0xff9ca8ce, 0xff9baacd, 0xff99a9cf, 0xff98a7d2, 0xff97a6d2,
    0xff97a4d0, 0xff97a3cf, 0xff96a2cd, 0xff96a2cd, 0xff97a3ce, 0xff97a4cf, 0xff97a4cf, 0xff97a3cf,
    0xff96a2ce, 0xff96a2ce, 0xff96a2cf, 0xff97a3d0, 0xff97a3d0, 0xff98a4d0, 0xff98a4d0, 0xff97a3cf,
    0xff97a3ce, 0xff97a4ce, 0xff97a4ce, 0xff97a3ce, 0xff96a2cf, 0xff96a2cf, 0xff97a3d0, 0xff97a4d0,
    0xff96a4cf, 0xff96a3cf, 0xff96a3cf, 0xff97a3cf, 0xff97a3cf, 0xff96a3d0, 0xff96a3d0, 0xff96a3cf,
    0xff96a3cf, 0xff97a3d0, 0xff98a4d0, 0xff98a5d0, 0xff99a6d0, 0xff9ba7d0, 0xff9ea8d1, 0xffa0a9d1,
    0xffa1a9d1, 0xffa1aad1, 0xffa2abd2, 0xffa3acd2, 0xffa3acd2, 0xffa3acd2, 0xffa3acd1, 0xffa4abd0,
    0xffa4abd0, 0xffa5abd0, 0xffa5acd1, 0xffa5add3, 0xffa6aed4, 0xffa7afd5, 0xffa8b0d5, 0xffa8b1d6,
    0xffa8b1d6, 0xffa8b1d5, 0xffa8b1d4, 0xffa8b1d3, 0xffa9b1d5, 0xffa9b1d6, 0xffa8b0d5, 0xffa7afd4,
    0xffa7afd4, 0xffa8afd4, 0xffa8afd4, 0xffa7afd3, 0xffa6afd3, 0xffa6afd3, 0xffa6afd3, 0xffa5add2,
    0xffa4abd1, 0xffa3aad0, 0xffa2aacf, 0xffa2aacf, 0xffa2aad0, 0xffa2aad0, 0xffa0a9cf, 0xff9fa8ce,
    0xff9fa8ce, 0xffa0a8cd, 0xffa0a8cc, 0xffa0a7ca, 0xff9ea6ca, 0xff9aa5cb, 0xff98a4cc, 0xff97a2cb,
    0xff97a1ca, 0xff96a1c9, 0xff96a1c9, 0xff96a1c9, 0xff96a0ca, 0xff95a0ca, 0xff949fc9, 0xff939ec8,
    0xff929dc8, 0xff929dc8, 0xff929cc8, 0xff929cc8, 0xff929cc7, 0xff919cc6, 0xff8f9cc4, 0xff8f9cc3,
    0xff8e9bc3, 0xff8e9ac4, 0xff8e99c5, 0xff8c98c4, 0xff8a98c2, 0xff8a98c2, 0xff8b98c2, 0xff8b97c2,
    0xff8994c0, 0xff8893be, 0xff8796bd, 0xff8696bd, 0xff8590c0, 0xff8188c4, 0xff7782ca, 0xff6c80cf,
    0xff698acf, 0xff6d9ccb, 0xff7dacc3, 0xff95b4b9, 0xffabb0ad, 0xffb0a2a5, 0xffa88f9e, 0xff98809b,
    0xff84769a, 0xff71709c, 0xff676fa0, 0xff5e6fa3, 0xff576da3, 0xff546da3, 0xff526da4, 0xff536ea6,
    0xff536ea6, 0xff536ea5, 0xff516ea5, 0xff4f6da5, 0xff4e6ca4, 0xff4d6ba2, 0xff4c6ba1, 0xff4b6ba0,
    0xff4b6a9f, 0xff4b6a9f, 0xff4b699f, 0xff4b699f, 0xff98a4c5, 0xff98a4c5, 0xff8796bf, 0xff7588ba,
    0xff6a82b9, 0xff6581ba, 0xff6680ba, 0xff6c81b9, 0xff7580b6, 0xff7c7db2, 0xff8a82b1, 0xffa092b3,
    0xffafa4b7, 0xffb9b6bb, 0xffb8c2c0, 0xffaec7ca, 0xff9ec3d3, 0xff8cb6dc, 0xff80a6e1, 0xff7c9ae1,
    0xff8396db, 0xff8c99d4, 0xff909dcd, 0xff90a1c9, 0xff90a1c9, 0xff8f9fcb, 0xff8d9dcc, 0xff8c9dcb,
    0xff8b9cca, 0xff8a9bc9, 0xff8a9ac9, 0xff8a9aca, 0xff8a9bcc, 0xff8a9bcc, 0xff8b9cca, 0xff8b9cca,
    0xff8c9cca, 0xff8c9ccb, 0xff8c9ecc, 0xff8d9fcc, 0xff8e9fcd, 0xff8f9ecd, 0xff8f9ecd, 0xff8e9fcd,
    0xff8fa0cd, 0xff91a1ce, 0xff92a1cf, 0xff92a2cf, 0xff92a2cf, 0xff92a2cf, 0xff93a1cf, 0xff94a1d0,
    0xff94a2d1, 0xff94a2d1, 0xff93a0d0, 0xff929fcf, 0xff919fcf, 0xff91a0cf, 0xff92a0cf, 0xff93a0cf,
    0xff93a0cf, 0xff92a1d0, 0xff93a1d0, 0xff95a2ce, 0xff97a3ce, 0xff97a3cf, 0xff97a4d0, 0xff98a5d2,
    0xff9aa7d3, 0xff9aa7d3, 0xff9ba7d2, 0xff9ca8d2, 0xff9da9d4, 0xff9eaad4, 0xff9eaad2, 0xff9daad0,
    0xff9ca9d1, 0xff9ca8d2, 0xff9da8d1, 0xff9ea8d0, 0xff9fa8d0, 0xffa0a8d1, 0xffa0a9d2, 0xffa0aad2,
    0xffa0abd2, 0xffa1abd1, 0xffa3abd0, 0xffa4abd0, 0xffa4acd1, 0xffa4acd1, 0xffa5acd2, 0xffa5acd2,
    0xffa5acd2, 0xffa5acd2, 0xffa4abd0, 0xffa4abcf, 0xffa4acd1, 0xffa5add3, 0xffa5add4, 0xffa4acd1,
    0xffa3abd0, 0xffa0aad1, 0xff9fa9d2, 0xff9fa8d2, 0xff9fa7d1, 0xff9ea7d1, 0xff9ca7d1, 0xff9ba6d0,
    0xff9ba5ce, 0xff9ba4cd, 0xff9aa3cd, 0xff99a3cd, 0xff98a2cc, 0xff96a0ca, 0xff959fca, 0xff949fca,
    0xff949fca, 0xff939fc9, 0xff939fc9, 0xff939fc8, 0xff929ec8, 0xff919ec8, 0xff909dc7, 0xff909cc7,
    0xff8f9bc6, 0xff8e9bc6, 0xff8d9ac5, 0xff8d9ac4, 0xff8e9bc4, 0xff8f9bc4, 0xff8e9bc3, 0xff8d9ac3,
    0xff8d99c3, 0xff8c98c4, 0xff8c96c4, 0xff8b95c3, 0xff8a95c2, 0xff8995c1, 0xff8895c1, 0xff8895c0,
    0xff8794c0, 0xff8693c0, 0xff8592c1, 0xff8590c1, 0xff8590c1, 0xff848fc0, 0xff7f8ebd, 0xff7c8dbb,
    0xff798bbb, 0xff788abb, 0xff798bb9, 0xff7a8db7, 0xff7a89ba, 0xff7782c0, 0xff707ec7, 0xff6582cc,
    0xff628ecc, 0xff70a0c5, 0xff85aeb9, 0xff9bafad, 0xffa9a4a4, 0xffa9949c, 0xff9c859a, 0xff89789a,
    0xff77719c, 0xff666e9f, 0xff5c6ba0, 0xff566ba0, 0xff526ba2, 0xff506ba4, 0xff4e6ba4, 0xff4e6ba2,
    0xff4e6aa1, 0xff4d69a0, 0xff4d689f, 0xff4d689f, 0xff4c689f, 0xff4a679e, 0xff48669d, 0xff46669c,
    0xff98a5c5, 0xff98a5c5, 0xff99a4c4, 0xff959fc2, 0xff8b95bd, 0xff838cb8, 0xff8084b3, 0xff8784b2,
    0xff9e95b8, 0xffbcb2c2, 0xffcac7ca, 0xffb9c8ca, 0xff9bbac9, 0xff7da9ce, 0xff6697d3, 0xff648bd4,
    0xff7088d1, 0xff7a89cd, 0xff7f8fc8, 0xff8195c5, 0xff7f95c4, 0xff7c94c5, 0xff7d93c5, 0xff7e92c6,
    0xff7e92c6, 0xff7d92c6, 0xff7d92c6, 0xff7e92c5, 0xff7e92c4, 0xff7e93c4, 0xff7e93c5, 0xff7e93c5,
    0xff7f93c6, 0xff8094c7, 0xff8095c8, 0xff8296c8, 0xff8397c9, 0xff8497c9, 0xff8597ca, 0xff8597ca,
    0xff8699ca, 0xff889bcb, 0xff889bcc, 0xff899bcd, 0xff8a9bcd, 0xff8c9bcd, 0xff8d9ccd, 0xff8e9dcf,
    0xff8e9ed0, 0xff8d9ecf, 0xff8d9dce, 0xff8d9dcd, 0xff8e9ecd, 0xff909fcd, 0xff90a0cd, 0xff90a0cd,
    0xff8e9fcc, 0xff8d9fcc, 0xff8e9fcd, 0xff8f9fce, 0xff8f9fce, 0xff909fce, 0xff919fce, 0xff92a0cf,
    0xff93a1d0, 0xff95a1d1, 0xff97a2d2, 0xff98a4d2, 0xff99a6d2, 0xff9aa8d2, 0xff9ca9d3, 0xff9ca9d3,
    0xff9ca8d3, 0xff9ba7d3, 0xff9aa7d3, 0xff9aa7d3, 0xff9aa7d3, 0xff9aa6d2, 0xff99a6d2, 0xff98a6d2,
    0xff98a6d2, 0xff98a7d1, 0xff99a7d0, 0xff99a6d0, 0xff9aa5d0, 0xff9ba6d1, 0xff9ca7d1, 0xff9ba7d1,
    0xff99a6d0, 0xff99a6d0, 0xff9aa6d1, 0xff9ba6d2, 0xff9ca7d2, 0xff9ca7d1, 0xff9ca8d1, 0xff9da8d1,
    0xff9ea8d2, 0xff9ea8d3, 0xff9ea6d3, 0xff9da4d3, 0xff9ca3d2, 0xff99a3d0, 0xff98a4cf, 0xff98a4cf,
    0xff99a3cf, 0xff99a2cf, 0xff99a1ce, 0xff97a1cd, 0xff95a0cc, 0xff94a0cb, 0xff93a0cb, 0xff92a0cb,
    0xff919eca, 0xff909cc9, 0xff8f9bc9, 0xff8d9ac9, 0xff8b98c7, 0xff8b98c5, 0xff8b98c4, 0xff8b99c4,
    0xff8b99c4, 0xff8b98c3, 0xff8c97c3, 0xff8d97c4, 0xff8e98c6, 0xff8e98c6, 0xff8e97c6, 0xff8d97c5,
    0xff8d98c4, 0xff8c98c3, 0xff8b97c1, 0xff8a96c0, 0xff8996c0, 0xff8896c2, 0xff8895c2, 0xff8894c1,
    0xff8893c0, 0xff8893bf, 0xff8794bf, 0xff8794be, 0xff8693bd, 0xff8591bd, 0xff848fbd, 0xff828ebc,
    0xff7e8ebb, 0xff7c8dba, 0xff7a8abb, 0xff7988bb, 0xff7887ba, 0xff7686b9, 0xff7585b9, 0xff7585ba,
    0xff7385b9, 0xff7286b6, 0xff7286b4, 0xff7485b4, 0xff7381b8, 0xff6a7bc1, 0xff617ac9, 0xff5e84cb,
    0xff6294c6, 0xff75a2bb, 0xff8da9af, 0xffa1a6a4, 0xffa6989e, 0xff9c849c, 0xff8b789a, 0xff76709a,
    0xff656a9a, 0xff5b689a, 0xff52669c, 0xff4f669e, 0xff4c679f, 0xff4b689f, 0xff4b689e, 0xff4a679c,
    0xff496599, 0xff486497, 0xff476396, 0xff476396, 0xff9ea4c2, 0xff9ea4c2, 0xffa0a3c1, 0xffa7a4c1,
    0xffb3aac3, 0xffbdb2c5, 0xffbfbac4, 0xffb9bfc4, 0xffb3c3c9, 0xffafc4d1, 0xffadc2da, 0xffafbde1,
    0xffa9b2e0, 0xff94a0d4, 0xff7d8fc6, 0xff748abf, 0xff758dbf, 0xff758fc1, 0xff748ec3, 0xff748dc5,
    0xff758dc4, 0xff778dc3, 0xff788ec2, 0xff798fc1, 0xff798fc1, 0xff798fc2, 0xff798fc4, 0xff788fc6,
    0xff788fc7, 0xff788fc9, 0xff788fc9, 0xff7990c9, 0xff7b92c8, 0xff7d93c8, 0xff7e94c9, 0xff7f94c9,
    0xff7f94c9, 0xff7f95c9, 0xff8197c9, 0xff8298c9, 0xff8498ca, 0xff8598cb, 0xff8698cb, 0xff8798cb,
    0xff8898cc, 0xff889acd, 0xff899bce, 0xff8a9dcf, 0xff8a9dcf, 0xff8a9ccf, 0xff899bce, 0xff889bcd,
    0xff889bcd, 0xff889bcd, 0xff8a9bce, 0xff8b9bcf, 0xff8c9ccf, 0xff8d9dcf, 0xff8e9ecf, 0xff8e9ecf,
    0xff8e9ecf, 0xff8e9ecf, 0xff8e9fcf, 0xff8fa0cf, 0xff90a1cf, 0xff94a2d1, 0xff96a2d2, 0xff97a3d2,
    0xff98a5d1, 0xff99a6d2, 0xff99a6d3, 0xff99a6d3, 0xff99a6d3, 0xff98a5d2, 0xff96a3d0, 0xff95a2cf,
    0xff95a2cf, 0xff95a2d0, 0xff95a1d0, 0xff94a0d0, 0xff94a0d0, 0xff95a0cf, 0xff95a1ce, 0xff95a2cd,
    0xff95a2cd, 0xff95a2cd, 0xff95a2ce, 0xff95a2ce, 0xff95a2cd, 0xff95a2cd, 0xff94a1cc, 0xff94a1cc,
    0xff96a2ce, 0xff97a3cf, 0xff96a3cf, 0xff95a3ce, 0xff96a3ce, 0xff97a3ce, 0xff97a2cd, 0xff95a1cc,
    0xff94a0cb, 0xff93a0cc, 0xff93a0cd, 0xff929fcd, 0xff919dcd, 0xff919dcd, 0xff909dcc, 0xff909ccc,
    0xff8f9bcb, 0xff8e9aca, 0xff8d99c9, 0xff8c99c8, 0xff8c98c7, 0xff8b97c5, 0xff8a96c5, 0xff8995c4,
    0xff8795c3, 0xff8694c2, 0xff8694c1, 0xff8793c1, 0xff8893c2, 0xff8894c2, 0xff8795c2, 0xff8896c2,
    0xff8996c2, 0xff8996c2, 0xff8995c1, 0xff8995c1, 0xff8996c2, 0xff8996c2, 0xff8895c1, 0xff8794bf,
    0xff8693be, 0xff8491bd, 0xff8491bd, 0xff8592be, 0xff8592be, 0xff8390bc, 0xff818ebb, 0xff808dba,
    0xff7f8cba, 0xff7e8bba, 0xff7c8bba, 0xff7a8ab9, 0xff7889b7, 0xff7788b6, 0xff7487b6, 0xff7386b6,
    0xff7285b6, 0xff7183b6, 0xff7082b5, 0xff6e81b4, 0xff6d81b4, 0xff6d81b3, 0xff6d81b3, 0xff6b82b4,
    0xff6b82b4, 0xff6e83af, 0xff7082ad, 0xff6f7fb5, 0xff6c7bc0, 0xff667cc9, 0xff5d83cb, 0xff618fc7,
    0xff73a0be, 0xff8ca9af, 0xff9ca2a4, 0xffa1919b, 0xff978196, 0xff837594, 0xff6e6a93, 0xff616693,
    0xff566594, 0xff4f6495, 0xff4d6496, 0xff4b6296, 0xff496094, 0xff475f93, 0xff455f91, 0xff435f90,
    0xff9c99b8, 0xff9c99b8, 0xffa9a4ba, 0xffb4b0bd, 0xffb4bac0, 0xffacbfc4, 0xffa2bbca, 0xff98b2d1,
    0xff94a9d5, 0xff96a4d6, 0xff9ba3d4, 0xff9fa8ce, 0xff9eaaca, 0xff98a7c8, 0xff8d9fc7, 0xff7d94c5,
    0xff6e8ac4, 0xff6785c2, 0xff6b87c2, 0xff718ac2, 0xff748bc3, 0xff758bc4, 0xff738bc4, 0xff718cc4,
    0xff718dc5, 0xff738ec6, 0xff758ec7, 0xff768fc7, 0xff778fc7, 0xff778fc8, 0xff778fc8, 0xff7890c8,
    0xff7a91c7, 0xff7b91c7, 0xff7b90c7, 0xff7d91c9, 0xff7f93cb, 0xff8095cd, 0xff8298cf, 0xff8399cf,
    0xff8499cf, 0xff8499cf, 0xff8599ce, 0xff859acd, 0xff879acd, 0xff889acd, 0xff889acd, 0xff869bcd,
    0xff859bcd, 0xff859bcd, 0xff859acd, 0xff869acd, 0xff879acc, 0xff879acc, 0xff8699cc, 0xff8699cc,
    0xff889bcd, 0xff8a9cce, 0xff8a9bcd, 0xff8a9acd, 0xff8b9cce, 0xff8e9fcf, 0xff90a1d0, 0xff90a0d0,
    0xff91a0d0, 0xff92a1cf, 0xff93a1cf, 0xff94a2cf, 0xff94a2cf, 0xff94a1cf, 0xff93a0cf, 0xff939fcf,
    0xff939fd0, 0xff939fd0, 0xff929fce, 0xff919ecd, 0xff919dcc, 0xff919ccc, 0xff919dcd, 0xff919fce,
    0xff919fce, 0xff909ecd, 0xff8f9dcc, 0xff8f9dcc, 0xff909dcc, 0xff919dcc, 0xff919dcc, 0xff919dcc,
    0xff909ecd, 0xff909ecd, 0xff919ecd, 0xff919ecd, 0xff909dcc, 0xff909ccb, 0xff919dcc, 0xff939ecd,
    0xff939fcd, 0xff939fcd, 0xff929fcd, 0xff919dcc, 0xff909ccc, 0xff8d9bcc, 0xff8c9bcb, 0xff8c9aca,
    0xff8d99c9, 0xff8d99c9, 0xff8c98c9, 0xff8b98c9, 0xff8a97c8, 0xff8a97c8, 0xff8997c7, 0xff8896c7,
    0xff8695c7, 0xff8493c7, 0xff8493c6, 0xff8593c5, 0xff8593c3, 0xff8592c2, 0xff8592c2, 0xff8492c3,
    0xff8492c3, 0xff8693c3, 0xff8895c2, 0xff8995c2, 0xff8895c1, 0xff8895c1, 0xff8895c0, 0xff8794c0,
    0xff8693bf, 0xff8592bf, 0xff8491bf, 0xff8491bf, 0xff8491bf, 0xff8491be, 0xff8490bc, 0xff828ebc,
    0xff818dbb, 0xff808dbb, 0xff7f8dbb, 0xff7e8bba, 0xff7b89b8, 0xff7989b7, 0xff7689b6, 0xff7487b5,
    0xff7285b5, 0xff7183b4, 0xff6e81b3, 0xff6d81b3, 0xff6d81b2, 0xff6d81b2, 0xff6c80b2, 0xff6b7fb2,
    0xff697fb2, 0xff687eb1, 0xff677eb0, 0xff677db0, 0xff677db0, 0xff677daf, 0xff677dae, 0xff687ead,
    0xff6a7fac, 0xff6c7eae, 0xff6c7cb2, 0xff677ab9, 0xff5d78c1, 0xff577dc4, 0xff5d8bbf, 0xff6a99b4,
    0xff7f9ea7, 0xff91999b, 0xff968c91, 0xff8c7c8d, 0xff7a6d8c, 0xff68658c, 0xff56618e, 0xff4d5f8e,
    0xff495f8d, 0xff455e8c, 0xff425c8b, 0xff405c8b, 0xffa0a7b6, 0xffa0a7b6, 0xff99afbc, 0xff8fb1c2,
    0xff84a4c8, 0xff7d96cb, 0xff8093cc, 0xff8a98ca, 0xff929dc6, 0xff95a0c2, 0xff95a1c1, 0xff919fc4,
    0xff919fc7, 0xff98a6ca, 0xff9da9cb, 0xff95a3c9, 0xff8597c5, 0xff798fc2, 0xff758dc1, 0xff718bc1,
    0xff6b87c0, 0xff6985c0, 0xff6a85c1, 0xff6d87c2, 0xff6f89c2, 0xff708ac3, 0xff728cc3, 0xff738dc4,
    0xff748dc5, 0xff748dc6, 0xff748dc6, 0xff768dc6, 0xff798ec7, 0xff7a8fc8, 0xff7b90c9, 0xff7a92cb,
    0xff7892cb, 0xff7793cd, 0xff7b94cf, 0xff7e94d0, 0xff7e94cd, 0xff7e95ca, 0xff7f96ca, 0xff8198cb,
    0xff8399cd, 0xff8599cd, 0xff8599ce, 0xff839acf, 0xff829ad0, 0xff839ad0, 0xff849ad0, 0xff849ad1,
    0xff849bd1, 0xff849bd3, 0xff849bd4, 0xff859bd4, 0xff869dd2, 0xff879ed0, 0xff899ed0, 0xff8b9ed1,
    0xff8b9dd1, 0xff8a9dd0, 0xff8b9dd0, 0xff8d9fd1, 0xff8fa0d1, 0xff8fa0d1, 0xff8fa0d0, 0xff909fcf,
    0xff919ecf, 0xff919ecf, 0xff919fd0, 0xff919fd0, 0xff909fcf, 0xff8f9ecf, 0xff8f9dcf, 0xff8f9ccf,
    0xff8d9bcf, 0xff8b9bce, 0xff8a9bcd, 0xff8a9ccc, 0xff8a9ccb, 0xff8a9acb, 0xff8b9acb, 0xff8d9bcc,
    0xff8d9ccd, 0xff8c9ccd, 0xff8b9ccc, 0xff8b9ccc, 0xff8b9ccb, 0xff8b9ccb, 0xff8c9bca, 0xff8c9bca,
    0xff8c9bcc, 0xff8c9bcd, 0xff8c9bcc, 0xff8b9aca, 0xff8b9ac9, 0xff8a99c9, 0xff8a99c9, 0xff8999c8,
    0xff8898c8, 0xff8796c8, 0xff8795c8, 0xff8796c9, 0xff8897ca, 0xff8897ca, 0xff8796c9, 0xff8796c8,
    0xff8696c7, 0xff8696c7, 0xff8796c8, 0xff8896c8, 0xff8794c7, 0xff8593c6, 0xff8593c6, 0xff8694c6,
    0xff8895c6, 0xff8896c7, 0xff8996c8, 0xff8b96c9, 0xff8b96c8, 0xff8b96c6, 0xff8a97c4, 0xff8b98c4,
    0xff8c99c4, 0xff8c99c4, 0xff8c98c3, 0xff8b97c3, 0xff8a97c3, 0xff8a97c3, 0xff8a97c3, 0xff8996c3,
    0xff8794c2, 0xff8592bf, 0xff8390bd, 0xff8390bd, 0xff828fbc, 0xff7f8dbb, 0xff7d8bba, 0xff7a89b9,
    0xff7888b7, 0xff7788b6, 0xff7787b4, 0xff7586b2, 0xff7385b1, 0xff7284b1, 0xff7183b2, 0xff7082b3,
    0xff6d81b2, 0xff6a7fb0, 0xff697eb0, 0xff697eaf, 0xff687eae, 0xff677dac, 0xff667dab, 0xff657da9,
    0xff657ca9, 0xff657baa, 0xff657aac, 0xff6579ac, 0xff6479ac, 0xff6479aa, 0xff6379a8, 0xff6479a6,
    0xff667aa4, 0xff6678a7, 0xff5f74b3, 0xff5972be, 0xff557abf, 0xff5688b8, 0xff6594ac, 0xff7d99a0,
    0xff8d9595, 0xff8c878f, 0xff7f738c, 0xff6f6789, 0xff5d5f89, 0xff505c8a, 0xff495d8d, 0xff455e8f,
    0xff759abb, 0xff759abb, 0xff7490c0, 0xff7589c3, 0xff7989c0, 0xff7d8dbb, 0xff7e8fb9, 0xff7d90b9,
    0xff7d90ba, 0xff7e91bb, 0xff8193bd, 0xff8796bf, 0xff8d9ac2, 0xff95a1c6, 0xff9ba7ca, 0xff9ba8ca,
    0xff9aa6c8, 0xff9ca8c9, 0xffa2adcd, 0xffa7b1d1, 0xffa9b1d3, 0xffa5aed2, 0xff9ba9cf, 0xff8fa1cc,
    0xff889bc9, 0xff8396c8, 0xff788fc5, 0xff6b88c1, 0xff6887c0, 0xff758fc4, 0xff7f95c8, 0xff7b93c8,
    0xff738ec7, 0xff6d8bc6, 0xff6c8bc6, 0xff7490c8, 0xff8498cc, 0xff919fd0, 0xff97a5d3, 0xff97a7d3,
    0xff96a7d1, 0xff92a4cf, 0xff8ca0d0, 0xff859cd2, 0xff8099d4, 0xff8199d4, 0xff829ad4, 0xff839ad3,
    0xff839ad2, 0xff839ad1, 0xff849ad2, 0xff859bd3, 0xff869cd5, 0xff879dd7, 0xff889dd7, 0xff889dd7,
    0xff8a9fd9, 0xff8ba0d9, 0xff8ba0d8, 0xff8a9fd6, 0xff8ba0d6, 0xff8ca1d6, 0xff8ca1d6, 0xff8ba0d6,
    0xff8ba0d5, 0xff8da0d4, 0xff8ea0d3, 0xff8d9fd1, 0xff8a9dcf, 0xff899dce, 0xff899dce, 0xff899cce,
    0xff899acd, 0xff8999cd, 0xff8899ce, 0xff879ace, 0xff889ace, 0xff899acd, 0xff8a9bcd, 0xff8b9cce,
    0xff8b9cce, 0xff899cce, 0xff889ccd, 0xff889acc, 0xff8899cc, 0xff889bcf, 0xff899dd2, 0xff8a9dd2,
    0xff8b9dd0, 0xff8b9dcf, 0xff8a9dd0, 0xff899dd1, 0xff8a9ed3, 0xff8b9fd4, 0xff8ba0d6, 0xff8aa1d8,
    0xff8ba2d9, 0xff8ca2d8, 0xff8ca2d8, 0xff8ba1d8, 0xff8ba0d7, 0xff8c9fd5, 0xff8c9fd4, 0xff8c9ed3,
    0xff8c9ed3, 0xff8e9fd3, 0xff90a1d4, 0xff91a1d4, 0xff909fd3, 0xff8e9ed2, 0xff8d9dd1, 0xff8c9cd0,
    0xff8b9ccf, 0xff8a9bce, 0xff8a9ace, 0xff8999cd, 0xff8999cd, 0xff8898cc, 0xff8898cb, 0xff8a98c8,
    0xff8b98c7, 0xff8c98c7, 0xff8b97c7, 0xff8a97c7, 0xff8997c6, 0xff8796c5, 0xff8794c4, 0xff8693c3,
    0xff8593c2, 0xff8493c1, 0xff8492c0, 0xff8490bf, 0xff8390be, 0xff828fbd, 0xff808ebc, 0xff7e8cbb,
    0xff7d8bbb, 0xff7b8ab9, 0xff7a89b8, 0xff7988b7, 0xff7787b5, 0xff7586b4, 0xff7385b3, 0xff7283b1,
    0xff7283b0, 0xff7182b0, 0xff6c80b1, 0xff697fb1, 0xff677eaf, 0xff677ead, 0xff677dac, 0xff667dac,
    0xff667baa, 0xff657ba8, 0xff647aa7, 0xff6379a8, 0xff6379a9, 0xff6379a9, 0xff6378a8, 0xff6278a7,
    0xff6177a6, 0xff6177a6, 0xff6178a6, 0xff6178a6, 0xff6178a6, 0xff6278a7, 0xff657ba6, 0xff677ca7,
    0xff6477ad, 0xff5f70b5, 0xff5872ba, 0xff527bbb, 0xff5888b6, 0xff6d94aa, 0xff83979b, 0xff8c8e92,
    0xff897e8b, 0xff7a7189, 0xff666789, 0xff5b6289, 0xff5f7bc1, 0xff5f7bc1, 0xff6681bd, 0xff6a85b9,
    0xff6785b8, 0xff6383b8, 0xff6583b8, 0xff6a85b8, 0xff7088b9, 0xff758bbb, 0xff7a8fbc, 0xff8092bc,
    0xff8494bd, 0xff8897c0, 0xff8a99c4, 0xff8e9dc4, 0xff92a0c4, 0xff96a4c5, 0xff9aa5c7, 0xff9da7c8,
    0xffa0a9c8, 0xffa4acca, 0xffafb4d0, 0xffbabdd7, 0xffc0c2db, 0xffc1c4db, 0xffbcc1da, 0xffb4bbd8,
    0xffb1b9d7, 0xffbbc0d9, 0xffbcc0d9, 0xffaab3d6, 0xff96a5d2, 0xff94a4d1, 0xffa0acd2, 0xffaab4d3,
    0xffafb7d4, 0xffb3bad5, 0xffb7bcd7, 0xffb6bbd7, 0xffb5bad5, 0xffadb6d3, 0xff9cacd4, 0xff8aa1d5,
    0xff7e9bd6, 0xff7d9bd5, 0xff7f9dd5, 0xff809dd5, 0xff829dd6, 0xff839fd8, 0xff84a1da, 0xff84a1d9,
    0xff849fd7, 0xff849fd6, 0xff849fd7, 0xff85a0d8, 0xff87a1d8, 0xff88a1d8, 0xff87a0d7, 0xff869fd7,
    0xff869fd7, 0xff86a0d7, 0xff88a1d9, 0xff89a1db, 0xff8aa2dd, 0xff8aa5df, 0xff89a7e0, 0xff89a7e2,
    0xff8aa6e3, 0xff8aa5e2, 0xff89a4e0, 0xff88a4df, 0xff87a5e1, 0xff87a6e2, 0xff88a5e3, 0xff88a4e3,
    0xff87a3e2, 0xff86a2e0, 0xff86a2e0, 0xff86a4e1, 0xff86a4e1, 0xff86a4e2, 0xff86a4e2, 0xff86a4e3,
    0xff86a5e4, 0xff86a6e6, 0xff86a7e8, 0xff86a8ea, 0xff86aaec, 0xff86aaed, 0xff85a9ec, 0xff86a9ec,
    0xff89abee, 0xff8cadee, 0xff8eadeb, 0xff8face7, 0xff90ace5, 0xff90abe5, 0xff92abe3, 0xff95aae0,
    0xff97aadf, 0xff97aae0, 0xff96aae1, 0xff95a8df, 0xff93a6dd, 0xff91a3da, 0xff8ea2d8, 0xff8ca0d6,
    0xff8ca0d5, 0xff8d9fd4, 0xff8e9ed2, 0xff8e9dd1, 0xff8c9bd0, 0xff899ace, 0xff889acd, 0xff889acc,
    0xff8899ca, 0xff8798ca, 0xff8697c9, 0xff8697c7, 0xff8697c6, 0xff8797c5, 0xff8795c4, 0xff8693c2,
    0xff8391c0, 0xff8290bf, 0xff8291c0, 0xff8291c0, 0xff808fbe, 0xff7e8ebc, 0xff7c8dbb, 0xff7a8cba,
    0xff798bb9, 0xff7889b8, 0xff7889b7, 0xff7889b6, 0xff7789b6, 0xff7487b6, 0xff7386b5, 0xff7385b4,
    0xff7384b3, 0xff7283b2, 0xff7082b0, 0xff6e81af, 0xff6c80af, 0xff6a80af, 0xff697fac, 0xff687eaa,
    0xff677cac, 0xff657bad, 0xff647bab, 0xff647ba7, 0xff647ba5, 0xff637ba6, 0xff627aa6, 0xff6179a6,
    0xff6178a5, 0xff6078a3, 0xff6078a2, 0xff6078a2, 0xff6178a3, 0xff6178a3, 0xff6177a3, 0xff6177a3,
    0xff6177a3, 0xff6178a3, 0xff6279a5, 0xff647aa7, 0xff657ba6, 0xff667da4, 0xff667aa8, 0xff6474b0,
    0xff5f73b8, 0xff5878bd, 0xff5984bc, 0xff6a92b5, 0xff7f9ca9, 0xff8b979f, 0xff8f8a98, 0xff918394,
    0xff5e7fb2, 0xff5e7fb2, 0xff607fb4, 0xff617fb5, 0xff617fb6, 0xff607fb6, 0xff6080b6, 0xff6281b7,
    0xff6483b7, 0xff6884b8, 0xff6c86b9, 0xff7189bc, 0xff758bbd, 0xff798ebc, 0xff7c90bb, 0xff7e91bb,
    0xff8191bd, 0xff8494bf, 0xff8797c1, 0xff8899c2, 0xff8596c1, 0xff8394c0, 0xff8394c0, 0xff8898c1,
    0xff8e9dc3, 0xff97a3c6, 0xffa4accc, 0xffafb5d2, 0xffb5b9d6, 0xffb2b7d6, 0xffafb5d5, 0xffb3b8d6,
    0xffb6bbd6, 0xffb1b7d4, 0xffa8b0d0, 0xffa7b0d1, 0xffaeb5d5, 0xffb3b9d7, 0xffb2b8d6, 0xffb0b6d4,
    0xffb5b9d5, 0xffb6bbd6, 0xffafb6d5, 0xffa1add3, 0xff8ea1d0, 0xff7e96cd, 0xff7590cc, 0xff7691cc,
    0xff7c96cf, 0xff8099d3, 0xff839dd7, 0xff85a1dc, 0xff87a5e0, 0xff8ca9e4, 0xff94ade8, 0xff97aee8,
    0xff95abe4, 0xff91a8e1, 0xff8fa8e1, 0xff8ea9e2, 0xff8ea9e5, 0xff8daae8, 0xff8aa8e7, 0xff85a5e5,
    0xff82a4e4, 0xff82a5e8, 0xff83a7eb, 0xff84a7eb, 0xff84a8ec, 0xff83abf1, 0xff82aff8, 0xff82b1fb,
    0xff83b0fb, 0xff83aff9, 0xff83aef6, 0xff83aef5, 0xff83b0f7, 0xff82b2fa, 0xff82b3fd, 0xff82b4fd,
    0xff82b3fd, 0xff81b1fb, 0xff81affa, 0xff80affa, 0xff80b0fa, 0xff81b0fa, 0xff83b0fa, 0xff82b0fa,
    0xff80affa, 0xff83aff9, 0xff88b0f7, 0xff8db0f4, 0xff8dafef, 0xff8caeec, 0xff8aaded, 0xff88adf0,
    0xff87adf0, 0xff87acef, 0xff87acef, 0xff87acef, 0xff88acef, 0xff8aaced, 0xff8babeb, 0xff8ba8e7,
    0xff8aa5e4, 0xff8aa4e1, 0xff89a3df, 0xff89a1dc, 0xff899fd9, 0xff899ed7, 0xff899ed6, 0xff899ed5,
    0xff899dd3, 0xff899bd0, 0xff899ace, 0xff8999cd, 0xff8897cb, 0xff8796cb, 0xff8696ca, 0xff8696c8,
    0xff8696c7, 0xff8494c5, 0xff8192c3, 0xff8191c1, 0xff8290c0, 0xff8290be, 0xff818fbe, 0xff808ebd,
    0xff7e8cbb, 0xff7c8bba, 0xff7a8ab9, 0xff798ab8, 0xff7889b7, 0xff7789b6, 0xff7587b5, 0xff7486b4,
    0xff7385b4, 0xff7283b2, 0xff7182b1, 0xff7182b1, 0xff7082b1, 0xff6f81af, 0xff6e7fac, 0xff6c7eab,
    0xff697dab, 0xff677dac, 0xff657aac, 0xff6579ab, 0xff6479aa, 0xff6379a8, 0xff6379a7, 0xff6279a6,
    0xff6279a5, 0xff6178a5, 0xff6178a4, 0xff6178a4, 0xff6178a4, 0xff5f76a2, 0xff5d74a0, 0xff5c739f,
    0xff5c73a0, 0xff5f76a3, 0xff647ba8, 0xff697fac, 0xff6a7fac, 0xff697eab, 0xff687eaa, 0xff687da9,
    0xff697daa, 0xff6a7dac, 0xff6a7dab, 0xff6a7ea6, 0xff697da6, 0xff697aad, 0xff6779b7, 0xff5f7bbf,
    0xff5d82c2, 0xff6a8eb9, 0xff809aab, 0xff8ca2a2, 0xff5a7eb6, 0xff5a7eb6, 0xff5b7db7, 0xff5c7db7,
    0xff5d7db6, 0xff5e7eb5, 0xff607fb6, 0xff6281b7, 0xff6483b8, 0xff6384b9, 0xff6484b9, 0xff6684bb,
    0xff6985bc, 0xff6c87bd, 0xff6f8abe, 0xff738dbe, 0xff768fbf, 0xff788fc0, 0xff778dc1, 0xff768cc1,
    0xff748bc0, 0xff738bbf, 0xff728abe, 0xff758abe, 0xff7c8ebe, 0xff8693c0, 0xff919bc3, 0xff98a2c6,
    0xff9da7c8, 0xff9fa9c9, 0xffa0aaca, 0xffa4adce, 0xffa5aed1, 0xffa1acd0, 0xff9ba9ce, 0xff9daacd,
    0xffa6aecd, 0xffabb1ce, 0xffa9b0ce, 0xffa6afcf, 0xffaab3d1, 0xffacb4d2, 0xffa9b2d2, 0xff9fabd1,
    0xff8d9ecd, 0xff7891c7, 0xff6b89c3, 0xff6e89c4, 0xff758ec7, 0xff7893cb, 0xff7a98ce, 0xff7b98cf,
    0xff7c96cf, 0xff7b94cd, 0xff7992ca, 0xff7892c9, 0xff7a94cb, 0xff7d97cd, 0xff7e99ce, 0xff819bd0,
    0xff88a0d5, 0xff8fa6db, 0xff97ade3, 0xff9bb2ea, 0xff99b3ec, 0xff91ade9, 0xff8aa7e4, 0xff86a3de,
    0xff85a0d9, 0xff839ed7, 0xff829cd8, 0xff819bd8, 0xff819bd8, 0xff819cd9, 0xff7f9ddd, 0xff7e9ee1,
    0xff7f9fe3, 0xff80a3e7, 0xff80aaf0, 0xff81b1fa, 0xff82b6ff, 0xff83b8fd, 0xff84b7fa, 0xff83b4f9,
    0xff83b3f9, 0xff84b4f9, 0xff86b6fa, 0xff87b7fa, 0xff88b9f9, 0xff88bafa, 0xff87bbfd, 0xff86b8fd,
    0xff85b1f8, 0xff84abf2, 0xff82a6ec, 0xff80a4e7, 0xff7fa3e6, 0xff7fa3e6, 0xff81a3e6, 0xff85a5e5,
    0xff89a6e5, 0xff8da8e4, 0xff8ea9e5, 0xff8eacea, 0xff8daeef, 0xff8aaef0, 0xff88acee, 0xff89aae9,
    0xff8eaae3, 0xff90a8de, 0xff8fa5dd, 0xff8ba1db, 0xff869bd6, 0xff8297d1, 0xff7f94cd, 0xff7f94ca,
    0xff7f93c7, 0xff7e92c5, 0xff7e91c3, 0xff7e8fc1, 0xff7d8ec1, 0xff7c8dc1, 0xff7b8dc0, 0xff7b8cbf,
    0xff7c8cbd, 0xff7b8bbc, 0xff798abb, 0xff7789bb, 0xff7588b9, 0xff7587b8, 0xff7587b7, 0xff7486b5,
    0xff7385b4, 0xff7284b3, 0xff7283b3, 0xff7282b3, 0xff7182b2, 0xff6f81b0, 0xff6e80af, 0xff6d80ae,
    0xff6b80ac, 0xff697fab, 0xff657da9, 0xff637ba9, 0xff6379a9, 0xff6378a9, 0xff6177a8, 0xff5f76a6,
    0xff5e74a3, 0xff5d73a0, 0xff5d739f, 0xff5d74a0, 0xff5d74a0, 0xff5c749f, 0xff5c739f, 0xff5b729e,
    0xff5b729e, 0xff5c739f, 0xff5e75a1, 0xff5e74a0, 0xff5d739f, 0xff5d74a0, 0xff5f76a2, 0xff6077a3,
    0xff6077a3, 0xff6177a3, 0xff6579a6, 0xff687caa, 0xff6a7cab, 0xff6b7cab, 0xff6c7cac, 0xff6c7ead,
    0xff6d7fac, 0xff6f81aa, 0xff6f81a9, 0xff6f7eae, 0xff6d7cb5, 0xff687fba, 0xff6384bc, 0xff6087be,
    0xff587bb6, 0xff587bb6, 0xff597bb8, 0xff5a7cba, 0xff5b7dbb, 0xff5b7fbb, 0xff5b80bd, 0xff5c80bf,
    0xff5d80c0, 0xff5e81bf, 0xff5f82be, 0xff6284c0, 0xff6384c2, 0xff6283c4, 0xff6083c5, 0xff6084c5,
    0xff6286c5, 0xff6488c7, 0xff6689ca, 0xff688bcc, 0xff698dce, 0xff6b90d1, 0xff7096d7, 0xff749bdc,
    0xff769fe1, 0xff75a0e2, 0xff759edf, 0xff7799d7, 0xff7897d1, 0xff7997cf, 0xff7b9ad1, 0xff819fd7,
    0xff86a4dd, 0xff86a4e1, 0xff84a3e0, 0xff86a2dd, 0xff8ba3d8, 0xff90a3d3, 0xff92a2cf, 0xff91a0cd,
    0xff909ecb, 0xff8d9ccb, 0xff8d9ccb, 0xff8c9dcc, 0xff869ccd, 0xff7e98ce, 0xff7694ce, 0xff7291cc,
    0xff7190cb, 0xff708fca, 0xff7190ca, 0xff7291cb, 0xff7594ce, 0xff7897d2, 0xff7a99d5, 0xff7b9ad7,
    0xff7a99d7, 0xff7997d6, 0xff7996d5, 0xff7995d3, 0xff7794d1, 0xff7592d0, 0xff7391ce, 0xff7390cd,
    0xff7693cf, 0xff7e9bd6, 0xff85a2dc, 0xff89a6e1, 0xff89a6e3, 0xff84a1df, 0xff7d9ad9, 0xff7997d6,
    0xff7997d8, 0xff7a9bdd, 0xff7ba1e6, 0xff7ca7ee, 0xff7fadf5, 0xff82b2fa, 0xff82b6fd, 0xff82b8fe,
    0xff84bbfe, 0xff88beff, 0xff8ac0fe, 0xff8bc1fd, 0xff8bc0fc, 0xff8ac0fb, 0xff89befb, 0xff88bcfb,
    0xff87bafb, 0xff85b8fb, 0xff85b8f9, 0xff85b9f9, 0xff86bbfb, 0xff87bcfc, 0xff88bcfc, 0xff88bcfc,
    0xff87bdfd, 0xff86bdfd, 0xff84bafd, 0xff84b5fc, 0xff86b1fa, 0xff8ab0f4, 0xff8caeee, 0xff8ba9e7,
    0xff87a3e2, 0xff829fdf, 0xff7e9ddf, 0xff7d9ddf, 0xff7f9ee0, 0xff809ede, 0xff7f99d8, 0xff7e96d2,
    0xff7f95ce, 0xff7f94cb, 0xff7d92c9, 0xff798fc7, 0xff758cc5, 0xff748ac4, 0xff738ac3, 0xff738ac3,
    0xff748ac2, 0xff758bbf, 0xff768bbc, 0xff788bbb, 0xff798abb, 0xff7a8abb, 0xff7a89bc, 0xff7989bc,
    0xff7588bb, 0xff7287b9, 0xff7084b7, 0xff6e82b5, 0xff6d82b4, 0xff6d83b3, 0xff6b82b2, 0xff6a80b2,
    0xff697fb1, 0xff6980b0, 0xff6980b0, 0xff687faf, 0xff677dae, 0xff677dae, 0xff677dae, 0xff667cad,
    0xff657bac, 0xff6379aa, 0xff6177a8, 0xff6076a6, 0xff5f75a4, 0xff5d73a1, 0xff5c729f, 0xff5b719d,
    0xff59709b, 0xff596f9c, 0xff596f9c, 0xff5b719d, 0xff5c729d, 0xff5a719c, 0xff586f9c, 0xff59709d,
    0xff5c729f, 0xff5f74a1, 0xff6175a4, 0xff6074a3, 0xff5e72a0, 0xff5d729e, 0xff6479a3, 0xff6b7fa9,
    0xff6d80aa, 0xff6b7ca8, 0xff6a7ba7, 0xff6b7ca9, 0xff6c7dac, 0xff6e7ead, 0xff6f7ead, 0xff6e7ea9,
    0xff6d7da6, 0xff6a7caa, 0xff687bb2, 0xff667bb7, 0xff5678b8, 0xff5678b8, 0xff5779b8, 0xff587ab9,
    0xff597bba, 0xff5b7cbc, 0xff5c7dbd, 0xff5d7ebe, 0xff5d7ebe, 0xff5d7fbe, 0xff5d7fbe, 0xff5b7fbd,
    0xff5b80bd, 0xff6083bf, 0xff6587c1, 0xff6788c1, 0xff6487c1, 0xff6287c3, 0xff6087c6, 0xff5f87c8,
    0xff6087c8, 0xff6288c9, 0xff6389cc, 0xff658cd0, 0xff6790d5, 0xff6995da, 0xff6b9be2, 0xff6da1e9,
    0xff6fa4ee, 0xff71a5f0, 0xff73a5f1, 0xff76a8f3, 0xff79acf6, 0xff7aaff8, 0xff79b1fa, 0xff79b1fa,
    0xff79b1fa, 0xff78adf5, 0xff74a5ea, 0xff719ee1, 0xff7098d9, 0xff7094d3, 0xff6f92d1, 0xff6d90d0,
    0xff6d8fcf, 0xff6f8fcf, 0xff708fcf, 0xff7091d0, 0xff7193d2, 0xff7497d7, 0xff779adb, 0xff789adc,
    0xff7799db, 0xff7798da, 0xff7798da, 0xff7799da, 0xff779ada, 0xff789bdb, 0xff799ddd, 0xff7b9fe0,
    0xff7ca1e2, 0xff7da2e3, 0xff7ea1e2, 0xff7e9fde, 0xff7f9edc, 0xff81a0dd, 0xff84a4e1, 0xff8ba9e5,
    0xff90adea, 0xff8fadeb, 0xff8aabec, 0xff83a9ed, 0xff7ca8ee, 0xff79a6ee, 0xff7aa3ec, 0xff7aa0e7,
    0xff769ae0, 0xff7195d9, 0xff6e90d4, 0xff6e8ed2, 0xff6f90d4, 0xff7195da, 0xff769ee4, 0xff7cabf4,
    0xff84b8fd, 0xff8dc4ff, 0xff94ccff, 0xff95ccff, 0xff93c7ff, 0xff90c3ff, 0xff8fc1fe, 0xff8ec1fe,
    0xff8ec2ff, 0xff8fc4ff, 0xff8ec5ff, 0xff8ec5ff, 0xff90c4ff, 0xff93c2fd, 0xff95bdfb, 0xff95b8f8,
    0xff97b5f4, 0xff9bb5f0, 0xff9db5ed, 0xff9bb2e9, 0xff98afe6, 0xff97ade5, 0xff97ace4, 0xff92a8e2,
    0xff8aa3df, 0xff7f9bda, 0xff7291d4, 0xff6b8bcf, 0xff6787cc, 0xff6787ca, 0xff6787c8, 0xff6887c7,
    0xff6887c5, 0xff6887c5, 0xff6887c4, 0xff6986c2, 0xff6a85c0, 0xff6b85be, 0xff6b84bc, 0xff6a83bb,
    0xff6982ba, 0xff6781ba, 0xff6681b9, 0xff6681b9, 0xff6681b8, 0xff6681b8, 0xff6681b7, 0xff6681b7,
    0xff6580b7, 0xff647fb7, 0xff647db6, 0xff647db4, 0xff647cb2, 0xff647ab1, 0xff6379b0, 0xff6279ae,
    0xff607aac, 0xff607aab, 0xff6079a9, 0xff6078a9, 0xff6277a9, 0xff6277a9, 0xff6177a8, 0xff6077a6,
    0xff5f76a4, 0xff5e74a2, 0xff5d73a0, 0xff5d739d, 0xff5e749d, 0xff60769f, 0xff6176a0, 0xff5f739f,
    0xff5d719e, 0xff5f73a1, 0xff6176a3, 0xff6075a2, 0xff5e739f, 0xff5d729e, 0xff5d749f, 0xff5e759f,
    0xff5d739d, 0xff5e739d, 0xff6176a0, 0xff6579a3, 0xff697ca7, 0xff6c7ea9, 0xff6d7ea9, 0xff6c7da8,
    0xff6a7ca7, 0xff697ba7, 0xff697ba7, 0xff697ba6, 0xff677aa4, 0xff6579a2, 0xff61779f, 0xff5f769d,
    0xff5276b3, 0xff5276b3, 0xff5478b5, 0xff567ab8, 0xff587bba, 0xff597cbb, 0xff597cbb, 0xff587cba,
    0xff587dba, 0xff597ebc, 0xff597fbd, 0xff5880be, 0xff5880be, 0xff597fbe, 0xff5b7fbf, 0xff5f81c0,
    0xff6484c2, 0xff6585c3, 0xff6485c4, 0xff6386c4, 0xff6889c7, 0xff6a8bc8, 0xff6889c8, 0xff6687c8,
    0xff6a89c7, 0xff728dc7, 0xff7490c9, 0xff7290cd, 0xff6f92d3, 0xff6f98dc, 0xff6f9ce1, 0xff6e9be1,
    0xff6f9adf, 0xff709be0, 0xff739fe4, 0xff77a5eb, 0xff7aacf3, 0xff7eb3fa, 0xff82bafe, 0xff83bcfe,
    0xff82b9fb, 0xff80b2f7, 0xff80aff5, 0xff80aef3, 0xff7da7e9, 0xff799edd, 0xff7798d5, 0xff7797d6,
    0xff7899d9, 0xff7999d9, 0xff7a9bda, 0xff7b9ddc, 0xff7da0e0, 0xff7ea1e2, 0xff7ea1e1, 0xff7fa1e1,
    0xff83a3e4, 0xff89a7e6, 0xff92aee8, 0xff99b4e9, 0xff9bb4e9, 0xff99b0e8, 0xff97afe8, 0xff97b1e9,
    0xff93afe9, 0xff89a7e4, 0xff82a1e1, 0xff7f9fe0, 0xff7e9ddf, 0xff7a99db, 0xff7594d6, 0xff7191d2,
    0xff7192d1, 0xff7396d5, 0xff7a9edf, 0xff80a5e8, 0xff87abee, 0xff8caff1, 0xff8fb2f4, 0xff8fb4f4,
    0xff8aadee, 0xff80a2e4, 0xff7696da, 0xff6e8ed3, 0xff6a8bd0, 0xff688bd0, 0xff6a8cd2, 0xff6a8dd2,
    0xff6a8dd2, 0xff6c8dd3, 0xff708fd4, 0xff7290d5, 0xff7391d4, 0xff7493d5, 0xff7696d8, 0xff7b9cdd,
    0xff82a3e4, 0xff8baaeb, 0xff95b3f1, 0xff9cbaf5, 0xff9fbbf4, 0xff9cb4ec, 0xff98ade6, 0xff94a9e3,
    0xff93a8e3, 0xff97ace4, 0xff9cb1e5, 0xffa3b6e6, 0xffa8b7e6, 0xffacb9e6, 0xffaebae6, 0xffaab8e4,
    0xffa3b4e2, 0xff96aade, 0xff849dd7, 0xff728fce, 0xff6585c7, 0xff6382c6, 0xff6382c5, 0xff6281c2,
    0xff6281c1, 0xff6281c1, 0xff6180c0, 0xff607fbe, 0xff5f7eba, 0xff5d7cb8, 0xff5c7bb8, 0xff5c7ab8,
    0xff5d7bb8, 0xff5e7bb8, 0xff5d7ab6, 0xff5b79b4, 0xff5b79b3, 0xff5a78b2, 0xff5977b0, 0xff5876ae,
    0xff5775ad, 0xff5775ad, 0xff5875ad, 0xff5875ad, 0xff5975ad, 0xff5974ac, 0xff5a73aa, 0xff5a73a9,
    0xff5a74a8, 0xff5a75a8, 0xff5974a6, 0xff5973a5, 0xff5972a4, 0xff5971a2, 0xff5a71a1, 0xff5b72a0,
    0xff5b73a0, 0xff5c74a0, 0xff5c74a0, 0xff5d73a0, 0xff5e72a0, 0xff5e729f, 0xff5d729e, 0xff5c719d,
    0xff5c709c, 0xff5a709a, 0xff597099, 0xff597099, 0xff59709a, 0xff5b729c, 0xff5e759e, 0xff6179a1,
    0xff647aa3, 0xff6679a4, 0xff6679a4, 0xff6578a4, 0xff6578a3, 0xff6677a3, 0xff6677a2, 0xff6677a1,
    0xff6476a0, 0xff6275a0, 0xff5f74a1, 0xff5d74a1, 0xff5074b0, 0xff5074b0, 0xff5276b2, 0xff5477b3,
    0xff5578b4, 0xff5679b6, 0xff577bb8, 0xff577cb9, 0xff577dba, 0xff577dbb, 0xff577dbb, 0xff587ebd,
    0xff597fbe, 0xff597fbe, 0xff597fbe, 0xff597fbf, 0xff5980c0, 0xff5b80c0, 0xff5d81c1, 0xff5f81c1,
    0xff5f81c1, 0xff5f82c2, 0xff6084c4, 0xff6186c7, 0xff6187c8, 0xff6087c8, 0xff6087ca, 0xff6287cb,
    0xff6388ce, 0xff648cd2, 0xff6790d5, 0xff6b93d6, 0xff7198d8, 0xff779fdf, 0xff7da6e6, 0xff81aced,
    0xff81adf0, 0xff80acef, 0xff7da6ea, 0xff7aa0e3, 0xff769adc, 0xff7295d6, 0xff7294d4, 0xff7394d5,
    0xff7495d6, 0xff7596d7, 0xff7597d8, 0xff7697d8, 0xff7697d8, 0xff7597d8, 0xff7598d8, 0xff7799d9,
    0xff7b9cdc, 0xff80a1df, 0xff84a6e2, 0xff86a7e1, 0xff84a2db, 0xff819dd5, 0xff7e9bd3, 0xff7c9ad4,
    0xff7b99d4, 0xff7a97d4, 0xff7a97d4, 0xff7b99d5, 0xff7c99d5, 0xff7b97d3, 0xff7a95d2, 0xff7995d2,
    0xff7796d2, 0xff7695d2, 0xff7594d1, 0xff7392d1, 0xff7391d0, 0xff7290d0, 0xff7190ce, 0xff7190ce,
    0xff7391ce, 0xff7692d0, 0xff7793d1, 0xff7894d3, 0xff7894d3, 0xff7893d1, 0xff7692d0, 0xff7290cf,
    0xff6f8fcf, 0xff6e8dcd, 0xff708dcc, 0xff738ecc, 0xff7690cd, 0xff7a92cf, 0xff7d95d1, 0xff7e97d2,
    0xff7e98d3, 0xff7d98d4, 0xff7c98d5, 0xff7b97d5, 0xff7a96d3, 0xff7994d1, 0xff7994d0, 0xff7994d1,
    0xff7c95d3, 0xff8298d6, 0xff859ad7, 0xff849cd6, 0xff829cd4, 0xff829bd4, 0xff849ad4, 0xff8499d4,
    0xff8399d5, 0xff829ad6, 0xff829bd7, 0xff829bd6, 0xff8199d4, 0xff8097d1, 0xff8398d1, 0xff879ad3,
    0xff8398d1, 0xff7a93cd, 0xff718dc8, 0xff6a88c6, 0xff6684c4, 0xff6080c1, 0xff5c7cbf, 0xff5a7abb,
    0xff5a79b7, 0xff5a79b5, 0xff5978b5, 0xff5978b5, 0xff5776b3, 0xff5775b2, 0xff5876b2, 0xff5a77b2,
    0xff5a77b2, 0xff5a76b2, 0xff5876af, 0xff5775ac, 0xff5674a9, 0xff5672a8, 0xff5671a8, 0xff556fa7,
    0xff536da5, 0xff536ea3, 0xff5470a2, 0xff5470a1, 0xff556ea1, 0xff556da1, 0xff556ea0, 0xff556f9f,
    0xff556f9f, 0xff566e9f, 0xff566e9e, 0xff576e9c, 0xff576e9a, 0xff586f99, 0xff596f98, 0xff596f98,
    0xff596e98, 0xff586e98, 0xff576e99, 0xff576e9a, 0xff576e9c, 0xff59709d, 0xff5b729d, 0xff5c739c,
    0xff5c729a, 0xff5b7198, 0xff5c7199, 0xff5e729a, 0xff5f729a, 0xff5f7199, 0xff5e7198, 0xff5c7197,
    0xff5b7198, 0xff5c729b, 0xff5b7199, 0xff586d92, 0xff516684, 0xff465d6d, 0xff3a5556, 0xff335049,
    0xff4d6fad, 0xff4d6fad, 0xff4f71ae, 0xff5173af, 0xff5275b0, 0xff5277b2, 0xff5278b3, 0xff5379b3,
    0xff5579b5, 0xff5779b6, 0xff587ab7, 0xff577cba, 0xff577dbc, 0xff597ebd, 0xff5b7ebe, 0xff5c7ebe,
    0xff5d7ebe, 0xff5d7ebe, 0xff5d7ebe, 0xff5d7fbf, 0xff5d80c0, 0xff5e81c1, 0xff5f82c2, 0xff6083c4,
    0xff6284c6, 0xff6384c8, 0xff6486ca, 0xff6387c9, 0xff6388c9, 0xff6588c8, 0xff688ac9, 0xff6c8ecb,
    0xff7192ce, 0xff7595d0, 0xff7997d1, 0xff809bd3, 0xff87a0d6, 0xff8ca3d7, 0xff8da3d8, 0xff8aa2d7,
    0xff86a0d5, 0xff819dd3, 0xff7c9ad0, 0xff7997cd, 0xff7695cb, 0xff7493cb, 0xff7492cb, 0xff7391cc,
    0xff7491cc, 0xff7692cc, 0xff7793cb, 0xff7693cb, 0xff7592ca, 0xff7692ca, 0xff7893cb, 0xff7a93cb,
    0xff7992cb, 0xff7891cb, 0xff7890ca, 0xff7890c9, 0xff7890c9, 0xff7891c9, 0xff7891c9, 0xff7891ca,
    0xff7991ca, 0xff7a92ca, 0xff7b92ca, 0xff7c92ca, 0xff7c92cb, 0xff7c92cc, 0xff7c93cd, 0xff7d95cd,
    0xff7f97ce, 0xff7f97cd, 0xff7b93ca, 0xff7991c8, 0xff7b92c8, 0xff7e95ca, 0xff8298cd, 0xff8599cf,
    0xff8398d0, 0xff7e95cd, 0xff8097ce, 0xff8fa2d3, 0xff99a8d6, 0xff94a4d4, 0xff8b9ed1, 0xff8da1d3,
    0xff96a8d8, 0xff98aada, 0xff94a6d9, 0xff90a2d7, 0xff8da0d5, 0xff8a9fd4, 0xff879bd2, 0xff8397d0,
    0xff7c92ce, 0xff7690cd, 0xff758fcb, 0xff7991cb, 0xff7c93cb, 0xff7d93cb, 0xff7c92cb, 0xff7b91c9,
    0xff7a8fc6, 0xff798ec5, 0xff788dc5, 0xff778dc6, 0xff788fc7, 0xff758dc8, 0xff6c88c8, 0xff6584c7,
    0xff6283c7, 0xff6283c6, 0xff6182c4, 0xff5f80c2, 0xff5f7fc0, 0xff5f7fbf, 0xff607fbf, 0xff617fbf,
    0xff617fbf, 0xff6180c0, 0xff6281c0, 0xff6381be, 0xff6380bb, 0xff637fb9, 0xff637eba, 0xff627eba,
    0xff617eba, 0xff617eba, 0xff6380bc, 0xff6581bd, 0xff6680bb, 0xff657eb7, 0xff617bb2, 0xff5b78af,
    0xff5675ab, 0xff5371a8, 0xff526fa6, 0xff516ea4, 0xff506da2, 0xff506ca0, 0xff506b9e, 0xff506b9c,
    0xff4f6b9a, 0xff4f6b9a, 0xff506b9c, 0xff526b9d, 0xff546d9d, 0xff556e9c, 0xff556d9c, 0xff536c9b,
    0xff536b9d, 0xff546ca0, 0xff546b98, 0xff526781, 0xff526574, 0xff556b8a, 0xff5870a2, 0xff566d9c,
    0xff516682, 0xff4d606d, 0xff4c5e65, 0xff4d606a, 0xff51677e, 0xff556e94, 0xff586f98, 0xff596e96,
    0xff596d95, 0xff576c94, 0xff556c92, 0xff536b91, 0xff526a91, 0xff526b93, 0xff516a92, 0xff4f688b,
    0xff465f79, 0xff314759, 0xff192b36, 0xff0b1b21, 0xff486ca4, 0xff486ca4, 0xff4a6ea6, 0xff4c70a8,
    0xff4f72ab, 0xff5174ae, 0xff5275ae, 0xff5275ac, 0xff5275ad, 0xff5376b0, 0xff5477b4, 0xff557ab7,
    0xff557bb8, 0xff567cb9, 0xff577cb9, 0xff587dba, 0xff597dbc, 0xff597dbc, 0xff5a7cbc, 0xff5a7cbb,
    0xff597cba, 0xff597dba, 0xff5a7dbc, 0xff5c7ebe, 0xff5d7fbf, 0xff5d80bf, 0xff5f82c1, 0xff6083c3,
    0xff6284c4, 0xff6485c5, 0xff6687c5, 0xff6989c6, 0xff6d8cc7, 0xff738fc9, 0xff7992cb, 0xff7f96cd,
    0xff8299ce, 0xff869dcf, 0xff8aa1d1, 0xff8ca2d2, 0xff8ba0d4, 0xff899ed5, 0xff889cd5, 0xff889cd5,
    0xff859cd3, 0xff819ad1, 0xff7c99ce, 0xff7896cc, 0xff7794cb, 0xff7694cb, 0xff7795cc, 0xff7794cc,
    0xff7793cc, 0xff7993ce, 0xff7b96d0, 0xff7e9ad4, 0xff82a1db, 0xff83a4de, 0xff82a2db, 0xff7e9cd4,
    0xff7897cf, 0xff7392cb, 0xff7290c9, 0xff7591ca, 0xff7792ca, 0xff7591c7, 0xff7390c6, 0xff7490c6,
    0xff7690c7, 0xff7890c8, 0xff7a91c9, 0xff7c93ca, 0xff7d94cb, 0xff8197cd, 0xff889dd0, 0xff8ca1d2,
    0xff8da1d2, 0xff8c9ed0, 0xff8a9ccf, 0xff899bcf, 0xff8899cd, 0xff8797cb, 0xff8494c9, 0xff7a91c7,
    0xff7690c7, 0xff7992c7, 0xff8197c9, 0xff8a9dcd, 0xff91a1d1, 0xff92a1d2, 0xff8e9dcf, 0xff8899cc,
    0xff8497ca, 0xff8096ca, 0xff7d94ca, 0xff7a92ca, 0xff758ec8, 0xff718bc4, 0xff6f89c2, 0xff7089c2,
    0xff7189c2, 0xff708ac2, 0xff6f8ac1, 0xff6f88c0, 0xff6e85be, 0xff6d83bd, 0xff6d82bc, 0xff6b82bb,
    0xff6a82ba, 0xff6983bb, 0xff6885bf, 0xff6785c2, 0xff6684c2, 0xff6583c0, 0xff6683c0, 0xff6884c2,
    0xff6985c2, 0xff6986c2, 0xff6986c2, 0xff6985c2, 0xff6a85c1, 0xff6b86c1, 0xff6c87c0, 0xff6b86be,
    0xff6984bc, 0xff6783ba, 0xff6783ba, 0xff6682b9, 0xff6380b5, 0xff607db2, 0xff5c79ae, 0xff5975ab,
    0xff5875ac, 0xff5977ae, 0xff5977af, 0xff5a75ad, 0xff5a74ab, 0xff5a74aa, 0xff5974a9, 0xff5772a6,
    0xff5470a3, 0xff536fa0, 0xff536e9f, 0xff526e9d, 0xff516d9d, 0xff4f6b9c, 0xff4d6898, 0xff4d6796,
    0xff506995, 0xff536b95, 0xff526b95, 0xff506996, 0xff516a95, 0xff556d95, 0xff556c8c, 0xff4f647a,
    0xff475b68, 0xff445961, 0xff455c66, 0xff4e657c, 0xff586e93, 0xff536884, 0xff425556, 0xff394c41,
    0xff42575e, 0xff4f6788, 0xff536b94, 0xff536a94, 0xff516992, 0xff4f688e, 0xff4d668a, 0xff4b6388,
    0xff4a6287, 0xff4a6188, 0xff4c638c, 0xff556d96, 0xff546b90, 0xff384b64, 0xff112029, 0xff000606,
    0xff4669a0, 0xff4669a0, 0xff476ba1, 0xff486ca2, 0xff4a6da4, 0xff4c6fa6, 0xff4d70a9, 0xff4f72ab,
    0xff5275af, 0xff5477b2, 0xff5679b4, 0xff5679b3, 0xff5578b2, 0xff5679b2, 0xff577ab3, 0xff587bb4,
    0xff5a7db5, 0xff5a7db5, 0xff597db5, 0xff597cb6, 0xff597cb8, 0xff5a7cb9, 0xff5b7cba, 0xff5b7cba,
    0xff5b7cba, 0xff5b7dba, 0xff5b7dba, 0xff5c7eba, 0xff5d7fba, 0xff5e80bb, 0xff5f81bd, 0xff6283bf,
    0xff6585c1, 0xff6686c2, 0xff6786c2, 0xff6987c2, 0xff6c88c2, 0xff6f89c2, 0xff728bc3, 0xff748dc5,
    0xff7690c8, 0xff7893ca, 0xff7893cb, 0xff7892cb, 0xff7891cb, 0xff7992cb, 0xff7892ca, 0xff7592c9,
    0xff7391c8, 0xff7290c8, 0xff7390c9, 0xff738fca, 0xff738fca, 0xff7491cb, 0xff7594cc, 0xff7998cf,
    0xff809ed4, 0xff85a1d8, 0xff86a2da, 0xff84a1d9, 0xff809dd5, 0xff7d98cf, 0xff7a94cb, 0xff7992ca,
    0xff7891c8, 0xff7690c6, 0xff7490c6, 0xff728fc8, 0xff718ecc, 0xff728fcd, 0xff7490cc, 0xff7792cc,
    0xff7992cc, 0xff7c94cc, 0xff7f96ce, 0xff8097cf, 0xff7f95cf, 0xff7d93cd, 0xff7a90ca, 0xff788fc7,
    0xff788dc4, 0xff7a8dc2, 0xff7a8dc2, 0xff768bc3, 0xff748bc4, 0xff748dc3, 0xff778fc2, 0xff7d92c4,
    0xff8395c6, 0xff8595c7, 0xff8194c6, 0xff7e92c5, 0xff7c90c3, 0xff7b8fc2, 0xff788cc2, 0xff748ac3,
    0xff7389c3, 0xff7389c3, 0xff7289c3, 0xff6f88c1, 0xff6e87c0, 0xff6f85be, 0xff6f83bc, 0xff6c81b7,
    0xff687fb4, 0xff657fb5, 0xff6480b8, 0xff6280bb, 0xff6280bd, 0xff6280bd, 0xff627fba, 0xff617eb7,
    0xff5f7cb5, 0xff5d7ab4, 0xff5d7ab5, 0xff5e7ab7, 0xff5f7cb9, 0xff607db9, 0xff607db8, 0xff5f7cb6,
    0xff5e7bb5, 0xff5d7ab5, 0xff5d7ab5, 0xff5d79b5, 0xff5c79b4, 0xff5c7ab3, 0xff5d7cb2, 0xff5d7cb1,
    0xff5b79af, 0xff5977ae, 0xff5977ae, 0xff5a78af, 0xff5a78af, 0xff5b76ad, 0xff5974ab, 0xff5772a9,
    0xff5570a5, 0xff536ea1, 0xff536e9e, 0xff536e9d, 0xff536e9e, 0xff536e9e, 0xff526d9d, 0xff516c9b,
    0xff506b9a, 0xff4f6a98, 0xff506895, 0xff506793, 0xff4f6692, 0xff4e6693, 0xff4e6695, 0xff506797,
    0xff50699a, 0xff4f6a9d, 0xff506b95, 0xff536a7e, 0xff526363, 0xff465650, 0xff384946, 0xff31444a,
    0xff2f4654, 0xff2d444e, 0xff2c3f3a, 0xff304234, 0xff3b5048, 0xff486066, 0xff4c657b, 0xff4d6688,
    0xff4b638c, 0xff476088, 0xff455d86, 0xff455c87, 0xff455d86, 0xff445f81, 0xff466481, 0xff506e94,
    0xff516c99, 0xff374b6b, 0xff111c28, 0xff000000, 0xff42679b, 0xff42679b, 0xff43689d, 0xff45699f,
    0xff476aa1, 0xff4a6ca2, 0xff4b6da3, 0xff4c6ea4, 0xff4d70a6, 0xff4d70a7, 0xff4e71a8, 0xff4f72aa,
    0xff5073ac, 0xff5174ae, 0xff5275b0, 0xff5376b1, 0xff5578b2, 0xff5578b2, 0xff5578b2, 0xff5578b2,
    0xff5678b4, 0xff5679b5, 0xff567ab5, 0xff577bb4, 0xff587bb5, 0xff587bb6, 0xff597bb6, 0xff5a7cb6,
    0xff5b7db6, 0xff5e7eb8, 0xff607fba, 0xff6180bc, 0xff6181bd, 0xff6282bd, 0xff6282be, 0xff6484bf,
    0xff6586c1, 0xff6687c2, 0xff6887c1, 0xff6a87c0, 0xff6c88c0, 0xff6d89c1, 0xff6e8ac2, 0xff6f8ac3,
    0xff708cc3, 0xff718ec3, 0xff718fc3, 0xff718fc5, 0xff718ec6, 0xff708dc7, 0xff708dc8, 0xff708ec8,
    0xff718fc9, 0xff718fc9, 0xff718fca, 0xff718fcb, 0xff708fcc, 0xff718fcc, 0xff7490cc, 0xff7792cc,
    0xff7b94cd, 0xff7d96ce, 0xff7a95cd, 0xff7592cb, 0xff708ec9, 0xff6f8cc7, 0xff6f8cc6, 0xff6f8dc7,
    0xff6f8ec8, 0xff6f8ec8, 0xff718ec7, 0xff738ec7, 0xff768fc8, 0xff7a90c9, 0xff7d93cc, 0xff7f94ce,
    0xff7f94cf, 0xff7e93ce, 0xff7c92cb, 0xff7a91c8, 0xff778ec5, 0xff748bc3, 0xff738ac3, 0xff758cc4,
    0xff768dc4, 0xff758bc3, 0xff7389c1, 0xff7089c1, 0xff6f89c1, 0xff6e89c1, 0xff6e89c0, 0xff6e88c0,
    0xff6d86bf, 0xff6d86bf, 0xff7188c0, 0xff758ac2, 0xff758ac2, 0xff728ac1, 0xff6f88c0, 0xff6e87bf,
    0xff6b85bd, 0xff6681b9, 0xff637fb6, 0xff627eb5, 0xff627db5, 0xff617db4, 0xff5f7cb3, 0xff5d7cb3,
    0xff5d7bb3, 0xff5d7bb3, 0xff5c7ab3, 0xff5c7ab3, 0xff5d7ab5, 0xff5e7bb7, 0xff5d7bb7, 0xff5c7ab6,
    0xff5a7ab8, 0xff5a79bb, 0xff5b7abf, 0xff5f7ec1, 0xff6281c3, 0xff6383c4, 0xff6485c6, 0xff6988ca,
    0xff6e8bce, 0xff6b87c8, 0xff627eba, 0xff5976b0, 0xff5673ae, 0xff5673af, 0xff5673aa, 0xff5573a7,
    0xff5373aa, 0xff5173b0, 0xff4f71ae, 0xff506fa6, 0xff506d9f, 0xff506b9c, 0xff506a9c, 0xff516a9c,
    0xff516a9c, 0xff50699a, 0xff4d6896, 0xff4b6794, 0xff4a6794, 0xff4a6694, 0xff4a6391, 0xff496190,
    0xff496092, 0xff475f8e, 0xff425a77, 0xff3c545c, 0xff354d51, 0xff2f475c, 0xff334b71, 0xff415c8c,
    0xff4f6b91, 0xff50676d, 0xff46583c, 0xff354124, 0xff222c20, 0xff18231c, 0xff1b2a18, 0xff23371c,
    0xff2d4326, 0xff395041, 0xff415969, 0xff455e8c, 0xff486299, 0xff46618f, 0xff3c5576, 0xff2d4358,
    0xff22353a, 0xff1f3227, 0xff203422, 0xff1b342a, 0xff183335, 0xff192f35, 0xff1d2a2c, 0xff1f2728,
    0xff3e6699, 0xff3e6699, 0xff40679a, 0xff42689b, 0xff446a9e, 0xff466ba0, 0xff476ba0, 0xff486b9f,
    0xff486ba1, 0xff496da4, 0xff4a6ea8, 0xff4c6faa, 0xff4d70ab, 0xff4f71ac, 0xff5072ac, 0xff5072ac,
    0xff5172ac, 0xff5274ac, 0xff5376ae, 0xff5477af, 0xff5578b1, 0xff5578b2, 0xff5578b2, 0xff5578b2,
    0xff5678b3, 0xff5779b4, 0xff577ab5, 0xff577bb5, 0xff587cb5, 0xff597db7, 0xff5b7db8, 0xff5d7eb8,
    0xff5f7fb8, 0xff6080ba, 0xff6181bc, 0xff6282bd, 0xff6282bb, 0xff6383bb, 0xff6484be, 0xff6484c0,
    0xff6585c0, 0xff6686bf, 0xff6787bf, 0xff6888c0, 0xff6a88c1, 0xff6b89c2, 0xff6b89c2, 0xff6c88c3,
    0xff6b87c3, 0xff6a87c2, 0xff6888c1, 0xff6787c1, 0xff6786c2, 0xff6786c4, 0xff6887c5, 0xff6a89c6,
    0xff6f8cc5, 0xff738fc5, 0xff7993c7, 0xff7e97ca, 0xff8097cb, 0xff8196ca, 0xff7f94ca, 0xff7c93ca,
    0xff7892c9, 0xff738fc5, 0xff708dc3, 0xff708bc2, 0xff718bc3, 0xff718cc3, 0xff718dc4, 0xff718dc4,
    0xff728bc4, 0xff738bc4, 0xff758cc5, 0xff778ec6, 0xff788fc6, 0xff7990c5, 0xff7a90c6, 0xff7b91c7,
    0xff7b91c7, 0xff7c92c6, 0xff7e94c5, 0xff8197c6, 0xff8398c7, 0xff8397c7, 0xff8195c6, 0xff7f94c6,
    0xff7e93c5, 0xff7b90c3, 0xff768cc1, 0xff738abf, 0xff7289bf, 0xff7289be, 0xff7086bc, 0xff6d83b9,
    0xff6a82b8, 0xff6881b8, 0xff6680b6, 0xff667fb4, 0xff657eb2, 0xff627cb0, 0xff5f7aaf, 0xff5d78ae,
    0xff5c77ad, 0xff5b76ac, 0xff5a75ab, 0xff5974a9, 0xff5974a7, 0xff5873a7, 0xff5873a9, 0xff5873ab,
    0xff5773ac, 0xff5673ab, 0xff5775a8, 0xff5877a3, 0xff5a769a, 0xff5a7491, 0xff5b7389, 0xff5e7785,
    0xff5f7983, 0xff5e7780, 0xff5c7581, 0xff5d768a, 0xff5d7897, 0xff5a779f, 0xff54739f, 0xff4f6f91,
    0xff4c6a74, 0xff49645e, 0xff405959, 0xff3b515b, 0xff415454, 0xff4d5e4d, 0xff546558, 0xff546773,
    0xff4f6789, 0xff486492, 0xff436192, 0xff426092, 0xff436190, 0xff45618f, 0xff46628e, 0xff45608b,
    0xff415d88, 0xff415c87, 0xff49608c, 0xff50668c, 0xff587085, 0xff576f6f, 0xff435542, 0xff262f11,
    0xff0e1500, 0xff051000, 0xff0a1909, 0xff1b2b18, 0xff31402a, 0xff384b37, 0xff384b3a, 0xff323a2c,
    0xff2a2518, 0xff272411, 0xff2a361a, 0xff2b421e, 0xff253c17, 0xff25371a, 0xff334334, 0xff435353,
    0xff4d616a, 0xff4e666f, 0xff3c5456, 0xff1e3227, 0xff0b1a05, 0xff0d1903, 0xff1b2811, 0xff253918,
    0xff2a441e, 0xff21371c, 0xff111f16, 0xff081012, 0xff3d679d, 0xff3d679d, 0xff3e679c, 0xff40679d,
    0xff42689f, 0xff446aa2, 0xff466ba3, 0xff486ca4, 0xff496da5, 0xff486da6, 0xff476ea7, 0xff486fa7,
    0xff4970a8, 0xff4b71aa, 0xff4e72ad, 0xff4f74af, 0xff5076b0, 0xff5077b0, 0xff5075af, 0xff5074ae,
    0xff5075b0, 0xff5176b1, 0xff5277b1, 0xff5478b1, 0xff5578b2, 0xff5677b3, 0xff5677b4, 0xff5677b4,
    0xff5678b4, 0xff5779b5, 0xff587ab5, 0xff587bb4, 0xff587bb4, 0xff587bb4, 0xff597cb5, 0xff5b7cb7,
    0xff5c7db8, 0xff5d7eb9, 0xff5d7eba, 0xff5c7eba, 0xff5c7eba, 0xff5c7ebb, 0xff5c7ebb, 0xff5b7dbc,
    0xff5b7dbc, 0xff5c7ebd, 0xff5d7fbe, 0xff5d80bf, 0xff5d80bf, 0xff5e80c0, 0xff5f81c0, 0xff6082c0,
    0xff6082c0, 0xff6284c0, 0xff6485c1, 0xff6585c1, 0xff6685c1, 0xff6785c1, 0xff6887c1, 0xff6989c1,
    0xff6a89c1, 0xff6b88c1, 0xff6b88c1, 0xff6b88c1, 0xff6b88c1, 0xff6b89c3, 0xff6c89c3, 0xff6d89c2,
    0xff6e8ac0, 0xff708bc1, 0xff728cc3, 0xff718cc3, 0xff6e8bc1, 0xff6d8ac0, 0xff6f89c0, 0xff7189c1,
    0xff738ac2, 0xff758cc3, 0xff768cc3, 0xff768bc2, 0xff768bc2, 0xff768cc1, 0xff768dc1, 0xff758dc0,
    0xff768dc0, 0xff788ec1, 0xff7b8fc2, 0xff7b8fc2, 0xff7b8fc2, 0xff7c91c5, 0xff8094cb, 0xff7e93cd,
    0xff748cc9, 0xff6c86c3, 0xff6884bd, 0xff6682b8, 0xff637fb3, 0xff607ab0, 0xff5c76ac, 0xff5a74aa,
    0xff5773a9, 0xff5573aa, 0xff5473a9, 0xff5572a4, 0xff5570a0, 0xff536e9e, 0xff506d9f, 0xff4f6c9f,
    0xff4f6c9e, 0xff506c9e, 0xff4e6b9d, 0xff4e6ba1, 0xff516fae, 0xff5271af, 0xff4e6b8c, 0xff47615a,
    0xff485e3d, 0xff4f6340, 0xff526547, 0xff4c5d46, 0xff445441, 0xff3f4d33, 0xff3d4928, 0xff404e29,
    0xff465735, 0xff4c624e, 0xff506b6a, 0xff4d6971, 0xff425954, 0xff364734, 0xff283725, 0xff233122,
    0xff2f3c2a, 0xff434f38, 0xff4a563d, 0xff414e36, 0xff3c4b3e, 0xff425561, 0xff4a5e76, 0xff4f606c,
    0xff505e5e, 0xff4a5d69, 0xff415c81, 0xff3c5a8f, 0xff3c578e, 0xff3f5888, 0xff435d80, 0xff455d71,
    0xff43565a, 0xff3d4b40, 0xff36412a, 0xff2f381b, 0xff1e260f, 0xff0c110a, 0xff070d0b, 0xff182212,
    0xff2b3b19, 0xff293d1c, 0xff22331b, 0xff242517, 0xff2a1912, 0xff25160f, 0xff181e0e, 0xff152c0f,
    0xff253c12, 0xff374a1d, 0xff384d35, 0xff31484a, 0xff243c4d, 0xff193040, 0xff233531, 0xff3e4b25,
    0xff464f19, 0xff2c3510, 0xff121e0c, 0xff1b2d0e, 0xff2d4314, 0xff31481c, 0xff2b4022, 0xff273b25,
    0xff3f68a3, 0xff3f68a3, 0xff3f69a5, 0xff3f6aa7, 0xff406aa6, 0xff426ba5, 0xff446ca6, 0xff456ca9,
    0xff476eaa, 0xff476faa, 0xff4770aa, 0xff4870ab, 0xff4970ab, 0xff4970ab, 0xff4971ab, 0xff4971ab,
    0xff4a72ac, 0xff4c72ae, 0xff4d73af, 0xff4e74b0, 0xff4e75b1, 0xff4d75b1, 0xff4d75b2, 0xff4d75b3,
    0xff4e75b2, 0xff4f75b1, 0xff5175b2, 0xff5275b4, 0xff5375b5, 0xff5376b4, 0xff5377b3, 0xff5378b4,
    0xff5478b5, 0xff5579b5, 0xff5579b3, 0xff5579b3, 0xff5477b3, 0xff5477b4, 0xff5478b7, 0xff5479b9,
    0xff5479b9, 0xff5479b9, 0xff5579ba, 0xff587abb, 0xff587abb, 0xff567bbc, 0xff557cbc, 0xff587dbd,
    0xff5b7ebe, 0xff5d7fbf, 0xff5e81c0, 0xff5f82c0, 0xff6083bf, 0xff6084bf, 0xff6185c1, 0xff6185c1,
    0xff6183bf, 0xff6182be, 0xff6282be, 0xff6384bf, 0xff6485c0, 0xff6586c1, 0xff6586c1, 0xff6686c2,
    0xff6686c2, 0xff6785c1, 0xff6784c0, 0xff6784c1, 0xff6885c2, 0xff6985c1, 0xff6b86c0, 0xff6b86be,
    0xff6987be, 0xff6988be, 0xff6c88bf, 0xff6f88c0, 0xff7089c0, 0xff6f8ac0, 0xff6f89c0, 0xff7087c1,
    0xff7086c1, 0xff6f86c1, 0xff6f87c2, 0xff6f88c4, 0xff6f89c5, 0xff6e88c4, 0xff6e88c3, 0xff708bca,
    0xff738ece, 0xff7087b8, 0xff687a90, 0xff637270, 0xff647568, 0xff6c7e77, 0xff7b8a96, 0xff8693b5,
    0xff7f90bc, 0xff6f86b1, 0xff6580aa, 0xff6580ab, 0xff6780a4, 0xff677b90, 0xff667882, 0xff647680,
    0xff637580, 0xff677475, 0xff6c7268, 0xff626e71, 0xff4f698c, 0xff4165a2, 0xff4264a8, 0xff49679d,
    0xff4e6f8b, 0xff4f7170, 0xff426153, 0xff30493c, 0xff253829, 0xff263324, 0xff2b3725, 0xff31422c,
    0xff384b31, 0xff3d4d31, 0xff3e4b2d, 0xff384227, 0xff2f3921, 0xff2b361f, 0xff2e3a22, 0xff35422b,
    0xff3f4e3a, 0xff445441, 0xff43523b, 0xff3d4d2e, 0xff384b23, 0xff354c1d, 0xff354d1f, 0xff394c28,
    0xff425238, 0xff51634f, 0xff526551, 0xff3f5035, 0xff293715, 0xff263410, 0xff314021, 0xff374832,
    0xff35473e, 0xff354a4b, 0xff395358, 0xff395453, 0xff344b3a, 0xff2a3b1c, 0xff1f2c12, 0xff161f17,
    0xff131917, 0xff181b12, 0xff191c0e, 0xff14180f, 0xff0e1815, 0xff10211e, 0xff132924, 0xff112221,
    0xff0e1317, 0xff0d0e0d, 0xff101308, 0xff141d0a, 0xff162a15, 0xff1e3b2c, 0xff2f4e4a, 0xff3f5b62,
    0xff425b65, 0xff3a5157, 0xff324750, 0xff2b4151, 0xff223648, 0xff162630, 0xff0d1717, 0xff0b0e0d,
    0xff0f0e0e, 0xff191916, 0xff252a21, 0xff2b3327, 0xff5e8bbc, 0xff5e8bbc, 0xff5986ba, 0xff5582b8,
    0xff5582b9, 0xff5682ba, 0xff5480b8, 0xff507db5, 0xff4e7ab3, 0xff4e79b3, 0xff4f79b4, 0xff507bb5,
    0xff517cb6, 0xff527bb7, 0xff527ab8, 0xff527ab8, 0xff517ab8, 0xff517ab8, 0xff5179b7, 0xff5179b7,
    0xff517ab7, 0xff517bb8, 0xff537cb9, 0xff547dbb, 0xff547dbb, 0xff527cbb, 0xff527cbb, 0xff527cba,
    0xff527cb9, 0xff527cb9, 0xff527bb9, 0xff527bb8, 0xff517ab8, 0xff5179b9, 0xff5177bb, 0xff5177bb,
    0xff5277ba, 0xff5278b9, 0xff5278b8, 0xff5279b8, 0xff537aba, 0xff547cbc, 0xff577dbd, 0xff5b7ebe,
    0xff5d80bf, 0xff5e81bf, 0xff5e82c0, 0xff5f83c1, 0xff5f84c1, 0xff5f84bf, 0xff5f84be, 0xff5f84bf,
    0xff6085c1, 0xff6285c2, 0xff6385c2, 0xff6485c1, 0xff6384bf, 0xff6284bf, 0xff6285c0, 0xff6386c1,
    0xff6587c2, 0xff6688c2, 0xff6788c1, 0xff6687be, 0xff6586bd, 0xff6585be, 0xff6684bf, 0xff6784bf,
    0xff6784be, 0xff6784bd, 0xff6683bc, 0xff6683bc, 0xff6584bb, 0xff6584bb, 0xff6685ba, 0xff6785bc,
    0xff6784c0, 0xff6883c0, 0xff6a85b7, 0xff6c89a9, 0xff6d889e, 0xff6c8499, 0xff6a8190, 0xff68807d,
    0xff657d69, 0xff5f7553, 0xff5b6d48, 0xff5d7155, 0xff617a6e, 0xff607974, 0xff5a7065, 0xff4e6150,
    0xff3b4d3b, 0xff354835, 0xff425641, 0xff546a54, 0xff5a705c, 0xff576c5b, 0xff5c6d5d, 0xff667161,
    0xff6b725d, 0xff656950, 0xff5c6148, 0xff525d4e, 0xff485a52, 0xff3d503b, 0xff374922, 0xff42573d,
    0xff597381, 0xff6784b4, 0xff5d7cb7, 0xff5373af, 0xff597ac5, 0xff5e80cc, 0xff5875a1, 0xff4b5f5d,
    0xff3c4a2d, 0xff303d22, 0xff2b3823, 0xff2e3c27, 0xff31422b, 0xff2b4125, 0xff243d1d, 0xff203919,
    0xff21371a, 0xff263d1d, 0xff2e4822, 0xff2f4c23, 0xff233f1c, 0xff243c1c, 0xff424d29, 0xff5f6137,
    0xff5f6438, 0xff4c5c2f, 0xff3c5325, 0xff374d1e, 0xff374b1c, 0xff3c5024, 0xff42552a, 0xff48572b,
    0xff475328, 0xff394721, 0xff253618, 0xff101e0d, 0xff030a04, 0xff000300, 0xff071105, 0xff192b0f,
    0xff304a1c, 0xff405e26, 0xff3b5622, 0xff283a16, 0xff131e0b, 0xff040d04, 0xff010b05, 0xff0c1a0d,
    0xff27371f, 0xff4a5234, 0xff616241, 0xff505833, 0xff29411a, 0xff223e15, 0xff3c5128, 0xff47562e,
    0xff31401b, 0xff1d2d0a, 0xff303c17, 0xff434925, 0xff2f331b, 0xff090c06, 0xff000000, 0xff170d09,
    0xff342217, 0xff473222, 0xff634632, 0xff8d6147, 0xffab7355, 0xffa06a4d, 0xff7e5137, 0xff6a432a,
    0xff7099bd, 0xff7099bd, 0xff7299bd, 0xff7399bd, 0xff729abe, 0xff729bc0, 0xff749cc1, 0xff769dc2,
    0xff779dc2, 0xff769cc0, 0xff759bbf, 0xff7399bf, 0xff7298bf, 0xff7096bf, 0xff6f94be, 0xff7094be,
    0xff7195be, 0xff7397be, 0xff7397bf, 0xff7397bf, 0xff6f93bf, 0xff6e92bf, 0xff7194c0, 0xff7497c1,
    0xff7799c1, 0xff7899c1, 0xff7699c0, 0xff7498bf, 0xff7095be, 0xff6c92bf, 0xff6b90c0, 0xff6d91c0,
    0xff7093c1, 0xff7395c2, 0xff7496c4, 0xff7396c4, 0xff7194c4, 0xff6d92c3, 0xff698fc2, 0xff668cc0,
    0xff6287bd, 0xff5e83bb, 0xff5b81bb, 0xff5981bc, 0xff5a81bd, 0xff5c83bd, 0xff6084bd, 0xff6286bc,
    0xff6286bc, 0xff6185bd, 0xff6084be, 0xff6084bd, 0xff6085bc, 0xff6185bc, 0xff6386bd, 0xff6486bf,
    0xff6186c2, 0xff5f86c3, 0xff5f87c1, 0xff6187be, 0xff6187be, 0xff6186bf, 0xff6386bf, 0xff6585bf,
    0xff6685bf, 0xff6584bf, 0xff6584bf, 0xff6685c0, 0xff6887c0, 0xff6887bf, 0xff6886be, 0xff6886be,
    0xff6987bf, 0xff6987bd, 0xff6985b9, 0xff6984b9, 0xff6b87c2, 0xff6c88c3, 0xff6c86ac, 0xff698088,
    0xff657963, 0xff60744e, 0xff576c40, 0xff4a5f3b, 0xff455b40, 0xff4e6147, 0xff596a4e, 0xff59694c,
    0xff526345, 0xff4a5e40, 0xff445d3e, 0xff4e6344, 0xff737354, 0xff8f8060, 0xff978664, 0xff8a825f,
    0xff6b7051, 0xff475a40, 0xff335036, 0xff385535, 0xff445b3a, 0xff4e5b42, 0xff535a47, 0xff515a47,
    0xff495943, 0xff42593f, 0xff3d5839, 0xff35532f, 0xff2e4e25, 0xff2a481c, 0xff2a4418, 0xff2c4419,
    0xff2f461c, 0xff334821, 0xff364828, 0xff37432d, 0xff2b3525, 0xff172115, 0xff101e0f, 0xff223a1f,
    0xff314f2c, 0xff2d4a28, 0xff274221, 0xff2e4a24, 0xff3d5d2e, 0xff4a6c34, 0xff4f7235, 0xff5a7b38,
    0xff6f8c3e, 0xff6c853b, 0xff405627, 0xff172b14, 0xff243718, 0xff4f6329, 0xff5e712f, 0xff4b5c26,
    0xff465823, 0xff647c30, 0xff738e36, 0xff5c732d, 0xff3d4f21, 0xff364c1f, 0xff3f5b24, 0xff3a5522,
    0xff2c3e1c, 0xff182011, 0xff030302, 0xff010100, 0xff161d11, 0xff2f3f24, 0xff36472a, 0xff2e3a23,
    0xff1f2619, 0xff10130f, 0xff0f0f0f, 0xff251f1e, 0xff413732, 0xff4c4039, 0xff50433b, 0xff55413a,
    0xff583e36, 0xff5a4532, 0xff59542e, 0xff535629, 0xff474526, 0xff352b22, 0xff201819, 0xff151217,
    0xff222225, 0xff3c3e3a, 0xff4b4b43, 0xff49443c, 0xff53423a, 0xff6f4f45, 0xff7f544a, 0xff69443b,
    0xff422c24, 0xff1f1911, 0xff080f07, 0xff000900, 0xff6792c4, 0xff6792c4, 0xff6794c3, 0xff6895c3,
    0xff6895c5, 0xff6a95c6, 0xff6c96c5, 0xff6f98c3, 0xff7199c4, 0xff7199c6, 0xff7299c7, 0xff759ac6,
    0xff769ac4, 0xff779ac4, 0xff779ac4, 0xff7699c3, 0xff7598c2, 0xff7598c0, 0xff7698bf, 0xff7698bf,
    0xff7597bf, 0xff7497bf, 0xff7597c0, 0xff7698c1, 0xff7799c1, 0xff7899c0, 0xff7798c0, 0xff7496bf,
    0xff7595bf, 0xff7a98c2, 0xff7d9ac3, 0xff7c99c2, 0xff7998bf, 0xff7998be, 0xff7b98be, 0xff7d9ac0,
    0xff7d9cc1, 0xff7e9dc3, 0xff7e9dc5, 0xff809ec6, 0xff829fc6, 0xff89a2c6, 0xff98aac7, 0xffa9b2c7,
    0xffadb4c9, 0xffa3b0ca, 0xff98abca, 0xff96aac9, 0xff99acc9, 0xffa2b2cc, 0xffabb7cf, 0xffacb7d0,
    0xffa7b4cf, 0xffa2b1cf, 0xff9fafce, 0xffa1afce, 0xffa9b4ce, 0xffb3b9cf, 0xffbbbed3, 0xffc0c1d7,
    0xffbebfd7, 0xffb8bbd5, 0xffb5bad5, 0xffb6bdd7, 0xffb7bfd7, 0xffb7bed5, 0xffb6bcd3, 0xffb4bbd3,
    0xffb4bbd3, 0xffb9bdd3, 0xffc0c1d4, 0xffc4c2d4, 0xffc3c1d5, 0xffc4c2d5, 0xffc9c5d5, 0xffcbc8d7,
    0xffcccae0, 0xffc2c3df, 0xffabb1c9, 0xff8b97a4, 0xff617370, 0xff3e5343, 0xff2c432a, 0xff354e32,
    0xff425b41, 0xff3e563f, 0xff374d39, 0xff374938, 0xff3b4a3a, 0xff354838, 0xff294332, 0xff274431,
    0xff374c38, 0xff475440, 0xff4f5642, 0xff555a46, 0xff5f6654, 0xff697465, 0xff6d796d, 0xff6a746a,
    0xff5c6a5c, 0xff425e43, 0xff375937, 0xff456043, 0xff54634f, 0xff424f43, 0xff21322a, 0xff13251d,
    0xff1d2f20, 0xff253a24, 0xff203c23, 0xff16341d, 0xff081d12, 0xff000a0a, 0xff081110, 0xff1a261e,
    0xff233123, 0xff212d1f, 0xff172115, 0xff041007, 0xff031005, 0xff1c2814, 0xff424d2a, 0xff636f39,
    0xff78853e, 0xff7a863c, 0xff677033, 0xff545c2d, 0xff4c552d, 0xff4a542e, 0xff464f29, 0xff474f25,
    0xff575d25, 0xff686d28, 0xff626525, 0xff47491e, 0xff2e2b16, 0xff21170e, 0xff22140e, 0xff2b1d19,
    0xff3a3125, 0xff4a432a, 0xff565029, 0xff5c5524, 0xff584f1e, 0xff584e1f, 0xff615c2d, 0xff595730,
    0xff31311c, 0xff060603, 0xff000000, 0xff000000, 0xff030705, 0xff0c1409, 0xff1e2913, 0xff394224,
    0xff4b532e, 0xff435125, 0xff314315, 0xff27360d, 0xff222a0b, 0xff141a06, 0xff030d00, 0xff020e02,
    0xff182211, 0xff2e361e, 0xff28321a, 0xff1a2711, 0xff14200d, 0xff151f0f, 0xff17220e, 0xff19280c,
    0xff243811, 0xff39541e, 0xff415b25, 0xff263516, 0xff050703, 0xff000000, 0xff000402, 0xff000a04,
    0xff294764, 0xff294764, 0xff294865, 0xff294966, 0xff2a4966, 0xff2b4a67, 0xff2c4a68, 0xff2c4b6b,
    0xff2e4d6e, 0xff314f70, 0xff315170, 0xff30506e, 0xff32526f, 0xff3b5976, 0xff486481, 0xff546e8c,
    0xff5c7694, 0xff657d9a, 0xff69819a, 0xff72889f, 0xff8395ae, 0xff889ab4, 0xff7e93ad, 0xff6d86a1,
    0xff627d9b, 0xff5e7a9b, 0xff6781a1, 0xff798eab, 0xff8094af, 0xff718ba8, 0xff6885a4, 0xff768eae,
    0xff879bba, 0xff8ea1be, 0xff8aa0bc, 0xff829ab8, 0xff7891b5, 0xff748db4, 0xff7b94b8, 0xff829bbc,
    0xff859ebd, 0xff849ebc, 0xff7e99bb, 0xff7793bb, 0xff7591bb, 0xff7995bc, 0xff7f9abf, 0xff85a0c2,
    0xff88a2c5, 0xff8aa2c9, 0xff869ec8, 0xff7e97c1, 0xff748fb6, 0xff6d8ab2, 0xff6c8ab4, 0xff6e8cb8,
    0xff708dbc, 0xff6f8bba, 0xff6883af, 0xff5f7aa1, 0xff597599, 0xff577396, 0xff547095, 0xff516f96,
    0xff537198, 0xff5d789a, 0xff647d9b, 0xff647c9c, 0xff627a9c, 0xff61799b, 0xff617b99, 0xff607a96,
    0xff5e7993, 0xff637b92, 0xff748595, 0xff7d8b96, 0xff748590, 0xff6b808a, 0xff768e8f, 0xff8aa196,
    0xff91a48a, 0xff889571, 0xff7f825a, 0xff7d714e, 0xff846c52, 0xff997560, 0xffa7836d, 0xff998967,
    0xff7b8956, 0xff698a4b, 0xff6a8e4a, 0xff799453, 0xff979e68, 0xffa6a274, 0xff9ba16e, 0xff87985f,
    0xff808d52, 0xff828148, 0xff77793f, 0xff637739, 0xff59793b, 0xff637c46, 0xff6e8050, 0xff728453,
    0xff728552, 0xff74834d, 0xff767f47, 0xff747c45, 0xff6f7b47, 0xff6d7a49, 0xff717848, 0xff6f7044,
    0xff62603b, 0xff4e4b2e, 0xff3c3523, 0xff2d231b, 0xff1d1313, 0xff120b10, 0xff0d0d13, 0xff111c1e,
    0xff182929, 0xff1d2d2f, 0xff1e2a2f, 0xff1a1e24, 0xff141016, 0xff191210, 0xff282414, 0xff2a2814,
    0xff131109, 0xff000000, 0xff000000, 0xff000a00, 0xff0b1b05, 0xff1e2d0f, 0xff2f411a, 0xff394d22,
    0xff3a4f24, 0xff30431d, 0xff283b17, 0xff2b4119, 0xff324c1e, 0xff334f20, 0xff355122, 0xff526331,
    0xff807f47, 0xff8d894b, 0xff5f7131, 0xff406424, 0xff577b3a, 0xff7c9756, 0xff8c9858, 0xff888548,
    0xff737038, 0xff55622e, 0xff3c5327, 0xff314325, 0xff313627, 0xff35322a, 0xff3b312c, 0xff372f28,
    0xff302d23, 0xff3b3828, 0xff564b35, 0xff615739, 0xff4f532d, 0xff364b1e, 0xff314e1d, 0xff2d4a1d,
    0xff1d3013, 0xff080f05, 0xff000000, 0xff000900, 0xff001000, 0xff000900, 0xff000000, 0xff000000,
    0xff000000, 0xff010401, 0xff020902, 0xff020c03, 0xff002640, 0xff002640, 0xff002a44, 0xff002e48,
    0xff002e48, 0xff002f49, 0xff05324d, 0xff0a3752, 0xff0c3a55, 0xff0a3953, 0xff083851, 0xff083750,
    0xff083650, 0xff073651, 0xff073652, 0xff083653, 0xff0a3754, 0xff093553, 0xff073351, 0xff05314f,
    0xff04304f, 0xff043150, 0xff063252, 0xff083354, 0xff0a3454, 0xff0b3553, 0xff083250, 0xff032d4c,
    0xff00294a, 0xff002a4b, 0xff022f50, 0xff0b3758, 0xff153f5e, 0xff1a4161, 0xff1a4060, 0xff1a3f5e,
    0xff18415d, 0xff17415c, 0xff183f5c, 0xff193e5c, 0xff1b3f5c, 0xff1d405c, 0xff1b3f5a, 0xff193d57,
    0xff1c3e58, 0xff23425c, 0xff294661, 0xff2e4863, 0xff2e4964, 0xff2c4965, 0xff294866, 0xff274867,
    0xff274867, 0xff2a4b69, 0xff2f4f6a, 0xff33516b, 0xff314f6c, 0xff33506f, 0xff3f5a77, 0xff4c647f,
    0xff506881, 0xff516880, 0xff5f7185, 0xff73818e, 0xff828b94, 0xff858a95, 0xff8b8e9b, 0xffa4a7af,
    0xffbabcc0, 0xffb8babe, 0xffa7a8b1, 0xffa09faa, 0xffa6a3ab, 0xffaca8ad, 0xffadaaac, 0xffb3b1b0,
    0xffc8c2bc, 0xffd5cdc4, 0xffc5beb6, 0xffa7a59f, 0xffa6a49d, 0xffc3bbb0, 0xffd4cbbd, 0xffc6c4b8,
    0xffb4b9ac, 0xffafb4a1, 0xffaeb199, 0xffb0b097, 0xffb3af9c, 0xffb3ac9f, 0xffb0a9a0, 0xffb3aaa2,
    0xffbeb4a5, 0xffc3baa6, 0xffbdb5a3, 0xffb3ad9f, 0xffaeac9c, 0xffafaf9c, 0xffb3b6a0, 0xffb8bda6,
    0xffc5c6ad, 0xffdad1b4, 0xffe8d6b7, 0xffebd3b5, 0xffead0b4, 0xfff1dabf, 0xfffbe9cc, 0xfffff5c9,
    0xfffff9b8, 0xfffef2a0, 0xfff6dd89, 0xfff2d485, 0xfff7e49b, 0xfffefbb8, 0xffffffc1, 0xffffffbc,
    0xffffffbe, 0xffffffc4, 0xffffffc3, 0xfffffeb5, 0xfffffba8, 0xfffff4a2, 0xfffff0a3, 0xfffff4ab,
    0xfffffcb6, 0xffffffbc, 0xffffffbc, 0xffffffba, 0xffffffb9, 0xffffffb9, 0xffffffbb, 0xffffffbd,
    0xffffffbd, 0xffffffbb, 0xffffffb9, 0xffffffb7, 0xffffffb5, 0xffffffb4, 0xffffffb6, 0xffffffc3,
    0xffffffc6, 0xffe0dba7, 0xffb6a97c, 0xffb6a274, 0xffe0c990, 0xffffebaa, 0xffffeeae, 0xffffe5a8,
    0xffffdda1, 0xffffd69b, 0xffffd89c, 0xffffdea1, 0xffffd89f, 0xfffbc896, 0xffeab186, 0xffc89570,
    0xffab805f, 0xffac7f5f, 0xffba8968, 0xffc6946f, 0xffcb9b74, 0xffc39772, 0xffb1896b, 0xffa57f66,
    0xffa57f68, 0xffa4806a, 0xff947564, 0xff826a5b, 0xff766255, 0xff756253, 0xff816b59, 0xff977b64,
    0xffab886c, 0xffb58e6a, 0xffba9167, 0xffc2986b, 0xffbe986d, 0xffa48762, 0xff826f51, 0xff6e6148,
    0xffb4c2c7, 0xffb4c2c7, 0xffabbcc1, 0xffa0b3b9, 0xff96aab1, 0xff8da2aa, 0xff839aa3, 0xff7b959e,
    0xff78929b, 0xff7d939c, 0xff8498a0, 0xff8da0a8, 0xff94a6ad, 0xff97a8b0, 0xff96a7af, 0xff8fa2a9,
    0xff869da4, 0xff8aa0a7, 0xff97acb3, 0xff9fb2b9, 0xff99acb3, 0xff94a8ae, 0xff99acb1, 0xffa1b3b8,
    0xffa1b4ba, 0xffa0b6bd, 0xffb3c6ca, 0xffd1dedd, 0xfff1f7f3, 0xffffffff, 0xffe9f0f0, 0xff809198,
    0xff0f2d3c, 0xff001020, 0xff002937, 0xff073c4a, 0xff114354, 0xff17475a, 0xff144558, 0xff104154,
    0xff0d3e51, 0xff0c3d50, 0xff0e3f53, 0xff114359, 0xff12465c, 0xff0f465b, 0xff0e465b, 0xff114a5e,
    0xff144c60, 0xff164d5f, 0xff164c5e, 0xff164c5f, 0xff164b60, 0xff144a5e, 0xff11495a, 0xff104857,
    0xff124a59, 0xff134b5b, 0xff114a5c, 0xff0f485c, 0xff10495d, 0xff124c5f, 0xff124c5f, 0xff104a5e,
    0xff0d475b, 0xff074257, 0xff084155, 0xff124556, 0xff1d4a59, 0xff1b4a58, 0xff124757, 0xff0c4355,
    0xff0c4055, 0xff104256, 0xff16495c, 0xff1d4f61, 0xff235367, 0xff28556b, 0xff2c576d, 0xff2e586d,
    0xff2e586c, 0xff2b566b, 0xff245065, 0xff184559, 0xff134155, 0xff1a485d, 0xff245168, 0xff245168,
    0xff1f4c63, 0xff1d4a60, 0xff1f4b61, 0xff214d64, 0xff225068, 0xff23526b, 0xff24526c, 0xff25516b,
    0xff26516b, 0xff26516c, 0xff28536d, 0xff2a556e, 0xff2b556e, 0xff29526c, 0xff28516a, 0xff2b536a,
    0xff2f556c, 0xff33576d, 0xff35586e, 0xff355870, 0xff325771, 0xff355a73, 0xff436577, 0xff4d6b78,
    0xff506974, 0xff50666f, 0xff54676d, 0xff5b6b6e, 0xff616e6e, 0xff646d6c, 0xff686e6b, 0xff6b7269,
    0xff6d7569, 0xff6f746a, 0xff71736c, 0xff74746b, 0xff78776a, 0xff7f7a68, 0xff877b68, 0xff90806c,
    0xff9c8a77, 0xffa08e7a, 0xff9a876f, 0xff937e61, 0xff977d5c, 0xffa2835f, 0xffad8a63, 0xffb48e66,
    0xffc39a70, 0xffe1b184, 0xffdbaa7e, 0xffa37652, 0xff59351d, 0xff1e0b00, 0xff010000, 0xff020404,
    0xff221c15, 0xff533f30, 0xff8c674f, 0xffa97b5e, 0xffa47959, 0xff916f4e, 0xff8d704f, 0xff967b5a,
    0xffa78d66, 0xffb79e6f, 0xffceb47c, 0xffe9cd8e, 0xfffee09e, 0xffffe8a3, 0xffffe5a1, 0xffffe09d,
    0xffffd896, 0xfff8c78b, 0xffe6b57e, 0xffd7a675, 0xffd19f74, 0xffc89770, 0xffb48862, 0xff9f7b55,
    0xff997951, 0xff9b7d55, 0xff957953, 0xff89704e, 0xff796447, 0xff665942, 0xff534d3c, 0xff424234,
    0xff3a3c2f, 0xff3f3d33, 0xff4c433b, 0xff534641, 0xff495e75, 0xff495e75, 0xff4a5e77, 0xff4b5f79,
    0xff4b5f79, 0xff4d6179, 0xff54687e, 0xff5c7185, 0xff62768b, 0xff63778e, 0xff63768e, 0xff65778c,
    0xff65778a, 0xff66778a, 0xff657789, 0xff617387, 0xff5c6f84, 0xff586b80, 0xff56687c, 0xff5d6d80,
    0xff707f8f, 0xff828fa0, 0xff8d99ad, 0xff94a0b7, 0xff9ca7bd, 0xffa1abbf, 0xffa0abbd, 0xff9ba7b9,
    0xff97a3b6, 0xff99a2b6, 0xff8f9ab1, 0xff70839d, 0xff54718e, 0xff577594, 0xff6f88a8, 0xff7d93b4,
    0xff7d93b3, 0xff7b91b0, 0xff7e94b0, 0xff7e94ae, 0xff7e92ab, 0xff7a8fa8, 0xff7189a3, 0xff68849f,
    0xff6e89a3, 0xff8096ac, 0xff8a9bb2, 0xff7e93b0, 0xff6c86aa, 0xff5e7ca0, 0xff557497, 0xff537493,
    0xff567793, 0xff557894, 0xff507696, 0xff4b7195, 0xff476c8f, 0xff4b6e8f, 0xff5d7c98, 0xff6c89a2,
    0xff66869e, 0xff517792, 0xff426b87, 0xff3c6581, 0xff3e657f, 0xff486c84, 0xff4d7087, 0xff456b83,
    0xff38627d, 0xff2f5b79, 0xff2b5676, 0xff224e71, 0xff19476b, 0xff214f72, 0xff466f8d, 0xff5f849f,
    0xff5c809b, 0xff4a708e, 0xff3a6482, 0xff2f5e7b, 0xff275875, 0xff245672, 0xff275874, 0xff2e5d7c,
    0xff326080, 0xff305e7c, 0xff2c5a75, 0xff2a5b72, 0xff2a5e71, 0xff2d6174, 0xff306379, 0xff306178,
    0xff2a5a6e, 0xff265667, 0xff275768, 0xff2a5c6d, 0xff2e6172, 0xff316675, 0xff336776, 0xff326473,
    0xff2f6170, 0xff2b5d6d, 0xff285b6a, 0xff255665, 0xff255463, 0xff2a5966, 0xff32616c, 0xff3c6972,
    0xff456e76, 0xff476f76, 0xff406a73, 0xff36636c, 0xff2d5b63, 0xff26565c, 0xff27575f, 0xff2c5b67,
    0xff2c5a67, 0xff285561, 0xff204f58, 0xff184651, 0xff13424f, 0xff134351, 0xff154455, 0xff154154,
    0xff133b50, 0xff0b3147, 0xff01263d, 0xff00263d, 0xff0e374f, 0xff264e61, 0xff436468, 0xff62786b,
    0xff7c8970, 0xff8d9276, 0xff959478, 0xff908e78, 0xff848171, 0xff726d63, 0xff605955, 0xff4d4647,
    0xff453b3e, 0xff544241, 0xff6e524a, 0xff7c5a4f, 0xff7a584e, 0xff74544b, 0xff725147, 0xff745146,
    0xff7c5748, 0xff845f4c, 0xff88624f, 0xff886250, 0xff866352, 0xff836453, 0xff806554, 0xff7f6453,
    0xff806453, 0xff826655, 0xff866b57, 0xff8c6f5a, 0xff92745c, 0xff9c7e61, 0xffa48967, 0xffaa906b,
    0xffae906b, 0xffae8b68, 0xffac8864, 0xffa78562, 0xffa18363, 0xff9e8267, 0xff9f846a, 0xffa5896a,
    0xffb08f6b, 0xffbf966e, 0xffcd9e72, 0xffd4a577, 0xffdaac7c, 0xffe5b47f, 0xfff1bb81, 0xfff8c081,
    0xff415e73, 0xff415e73, 0xff466378, 0xff466379, 0xff405d72, 0xff365368, 0xff2d4a60, 0xff27435a,
    0xff233f56, 0xff224056, 0xff234256, 0xff244555, 0xff254655, 0xff264758, 0xff254759, 0xff234356,
    0xff203e51, 0xff1e3b4c, 0xff1d3c4a, 0xff1c3d4b, 0xff1a3c4e, 0xff1c3e54, 0xff24445c, 0xff2b4962,
    0xff2c4860, 0xff28455a, 0xff28465b, 0xff2c4c63, 0xff2e4f68, 0xff2c4d66, 0xff2f5068, 0xff3d5a71,
    0xff4a657a, 0xff476578, 0xff3b5f70, 0xff385d6e, 0xff3e6073, 0xff486679, 0xff516d7d, 0xff56717f,
    0xff55737f, 0xff55747f, 0xff5e7a85, 0xff6a808c, 0xff738794, 0xff778b97, 0xff708794, 0xff5d7788,
    0xff577082, 0xff687c8b, 0xff7b8b96, 0xff7b8d97, 0xff6b8391, 0xff5a7584, 0xff4e6676, 0xff465f6e,
    0xff476472, 0xff466674, 0xff395a68, 0xff325260, 0xff3e5a6a, 0xff576f7f, 0xff718291, 0xff7f8c97,
    0xff949da5, 0xffb4b9c2, 0xffc8ccd5, 0xffd2d1da, 0xffd2cfd8, 0xffcfcbd4, 0xffcbc8d2, 0xffcecbd3,
    0xffd7d3d9, 0xffe2dce1, 0xffeee4eb, 0xffdcd4e1, 0xffa0a2b8, 0xff5e6d8b, 0xff425879, 0xff485e7f,
    0xff54698c, 0xff63779c, 0xff65789f, 0xff51658a, 0xff41577a, 0xff445a7f, 0xff4c628b, 0xff4a638d,
    0xff435f89, 0xff425f89, 0xff48658d, 0xff4e6a8f, 0xff506d8f, 0xff4f6e8e, 0xff4f6e8f, 0xff4c6b8d,
    0xff446383, 0xff3d5b76, 0xff3e5c73, 0xff48657c, 0xff506e84, 0xff537086, 0xff527186, 0xff517586,
    0xff517886, 0xff537b88, 0xff577c89, 0xff567b88, 0xff527884, 0xff507681, 0xff547881, 0xff577a83,
    0xff577986, 0xff557688, 0xff567283, 0xff566e7c, 0xff4f6674, 0xff435d6f, 0xff455e72, 0xff5d7082,
    0xff7a8491, 0xff94919e, 0xffac9da0, 0xffc2a68c, 0xffd3b073, 0xffe8cb75, 0xfff7eb93, 0xffffffaa,
    0xffffffa8, 0xfffff99f, 0xfffff39e, 0xffffeb9c, 0xfffdde96, 0xfffad48f, 0xfffad794, 0xfffde6a3,
    0xfffff2ae, 0xfffff4ad, 0xfffff1a8, 0xfffff2a8, 0xfffdf1a6, 0xfff7eca3, 0xffefe49e, 0xffe9de9a,
    0xffe8da98, 0xffeada99, 0xfff1e09f, 0xfff7e7a3, 0xfffceba4, 0xffffeea6, 0xfffff6ab, 0xfffffdb1,
    0xfffffeb1, 0xfffff8ac, 0xfffff1a6, 0xffffeda4, 0xffffeaa4, 0xffffeba5, 0xffffeaa4, 0xffffe49f,
    0xffffda98, 0xfffbd092, 0xfff3c990, 0xffeac28c, 0xffe4bd86, 0xffe5bd83, 0xffedc389, 0xfff3c78f,
    0xffebbf8a, 0xffdcaf7f, 0xffd3a679, 0xffd5a879, 0xffd2a87a, 0xffc8a278, 0xffc19c76, 0xffc79d74,
    0xffce9e73, 0xffca9b72, 0xffc09671, 0xffba9371, 0xff476181, 0xff476181, 0xff496381, 0xff496381,
    0xff486280, 0xff46607e, 0xff435d7a, 0xff415a77, 0xff425b76, 0xff465e79, 0xff445d77, 0xff38526d,
    0xff314c67, 0xff334e67, 0xff3a546b, 0xff415b73, 0xff466079, 0xff476179, 0xff435c74, 0xff3f5970,
    0xff3e5971, 0xff3d586f, 0xff365168, 0xff314d62, 0xff365268, 0xff405a73, 0xff425c72, 0xff3a5567,
    0xff3a5668, 0xff4d677e, 0xff566f8b, 0xff48657f, 0xff37576f, 0xff38566d, 0xff455e75, 0xff4a6279,
    0xff466078, 0xff405c74, 0xff3a566f, 0xff37536c, 0xff38536b, 0xff3c576e, 0xff405c73, 0xff44607a,
    0xff496682, 0xff4f6a87, 0xff506b89, 0xff4a6a86, 0xff446682, 0xff41627f, 0xff3f5e7d, 0xff3d5c7b,
    0xff3c5c7a, 0xff3d5d7c, 0xff3f5f80, 0xff416182, 0xff416082, 0xff405f81, 0xff416182, 0xff416181,
    0xff3c5e7b, 0xff355873, 0xff315570, 0xff325471, 0xff345775, 0xff385c79, 0xff385e79, 0xff305972,
    0xff275169, 0xff224c62, 0xff214a60, 0xff295069, 0xff365a7a, 0xff3d5f81, 0xff385875, 0xff305168,
    0xff2c4f64, 0xff2b5065, 0xff2f536b, 0xff345774, 0xff375978, 0xff375977, 0xff375a78, 0xff395d7c,
    0xff395e7f, 0xff355b7c, 0xff365b7c, 0xff4a6988, 0xff647c97, 0xff677f99, 0xff53708f, 0xff3f6283,
    0xff395c7d, 0xff3b5e7e, 0xff416483, 0xff4a6d8b, 0xff517192, 0xff567395, 0xff5c7697, 0xff5f7997,
    0xff627a94, 0xff657a90, 0xff677a8f, 0xff6c7c92, 0xff727f98, 0xff79859f, 0xff7f8aa6, 0xff828aa4,
    0xff80859b, 0xff828496, 0xff8d8a9a, 0xff9f969f, 0xffb9a59f, 0xffd3b59f, 0xffdfbda1, 0xffe3bfa4,
    0xffecc5a4, 0xfff8cca1, 0xffffd299, 0xffffd58d, 0xffffd586, 0xffffd786, 0xffffd68a, 0xffffd68e,
    0xffffd390, 0xfff6c68a, 0xffe9b47d, 0xffd6a070, 0xffbb8c66, 0xffab8362, 0xffa68261, 0xffaa8764,
    0xffb38e69, 0xffbd936d, 0xffbe8e69, 0xffb4805e, 0xffaa7356, 0xffa26b55, 0xff9c6756, 0xff916152,
    0xff8e6252, 0xff996f5a, 0xffad8165, 0xffbd916d, 0xffc4976f, 0xffc6976e, 0xffc3916d, 0xffbd8b6a,
    0xffb68766, 0xffb08564, 0xffb28766, 0xffb58a6a, 0xffb2886a, 0xffa88366, 0xffa28164, 0xffa48768,
    0xffa98e6c, 0xffa68d6c, 0xffa58d6c, 0xffad9370, 0xffba9b76, 0xffc1a078, 0xffc19f75, 0xffc3a175,
    0xffcdab7c, 0xffd6b282, 0xffd9b07f, 0xffd8ab7b, 0xffd6aa7c, 0xffd5ab80, 0xffd5aa7e, 0xffd5a778,
    0xffd8a875, 0xffdfad7a, 0xffe4b27f, 0xffdfae7e, 0xffd9aa7b, 0xffdeae7d, 0xffe7b681, 0xffedbb83,
    0xff1c4056, 0xff1c4056, 0xff183c51, 0xff15394d, 0xff15394c, 0xff173b4d, 0xff153a4c, 0xff13384b,
    0xff163b4c, 0xff1c4151, 0xff204453, 0xff1d404f, 0xff1b3e4e, 0xff214254, 0xff26475b, 0xff27495c,
    0xff244759, 0xff1e4355, 0xff183f51, 0xff153d50, 0xff164054, 0xff184458, 0xff194659, 0xff194658,
    0xff1a4659, 0xff1a475b, 0xff1c475b, 0xff1d485b, 0xff1d4859, 0xff1b4656, 0xff1a4555, 0xff1c4656,
    0xff1f4959, 0xff214a5c, 0xff234a5f, 0xff264d64, 0xff29516a, 0xff2b536c, 0xff2b5367, 0xff2a5163,
    0xff294f62, 0xff294e64, 0xff2a4f65, 0xff2c5066, 0xff2b4f63, 0xff274c5f, 0xff254a5d, 0xff264b5f,
    0xff284d63, 0xff295168, 0xff29536a, 0xff244f64, 0xff1e495c, 0xff1d475a, 0xff22495f, 0xff284e66,
    0xff2d546b, 0xff30576e, 0xff345971, 0xff355872, 0xff2f536d, 0xff274c67, 0xff264c67, 0xff2c506e,
    0xff305271, 0xff2e4e6c, 0xff2e4c6b, 0xff375476, 0xff405c80, 0xff415c80, 0xff3c5678, 0xff365171,
    0xff324e6b, 0xff304d69, 0xff314f6a, 0xff32506c, 0xff324f6b, 0xff314e6a, 0xff304d67, 0xff2f4d65,
    0xff2f4e63, 0xff304e61, 0xff395568, 0xff4a647a, 0xff5b7189, 0xff687990, 0xff737e92, 0xff787d8d,
    0xff7e7c8a, 0xff988f9b, 0xffbdafb7, 0xffdacad2, 0xffe5d7e1, 0xffd6cbd9, 0xffb1a8ba, 0xff8a8498,
    0xff7e798f, 0xff868398, 0xff8b899d, 0xff8b899b, 0xff8a879a, 0xff87869a, 0xff8b8798, 0xff978c93,
    0xffa9958d, 0xffbc9d84, 0xffcca57c, 0xffe0b079, 0xffeeba7b, 0xfff9c37e, 0xffffc881, 0xffffc982,
    0xfffec883, 0xfffbc584, 0xfffbc685, 0xfffcc986, 0xfffbc783, 0xfff9c27e, 0xfff8c07b, 0xfff9c57e,
    0xfffac982, 0xfff9c984, 0xfff8c886, 0xfffacc8d, 0xfffccf93, 0xfff6c78c, 0xffebb67d, 0xffd9a26d,
    0xffc18d62, 0xffab7d5c, 0xff956d55, 0xff86624f, 0xff805c4b, 0xff825c49, 0xff87624c, 0xff8d6a51,
    0xff947358, 0xff9b7b5f, 0xff9f7e61, 0xffa47d5f, 0xffa57b5c, 0xffa57c5e, 0xffa27e61, 0xff95755f,
    0xff846657, 0xff745950, 0xff69544c, 0xff64524b, 0xff5e4e49, 0xff5a4a47, 0xff564745, 0xff554543,
    0xff5a4846, 0xff644f4b, 0xff705850, 0xff7b6053, 0xff856754, 0xff8a6a53, 0xff906c54, 0xff9c7459,
    0xffa97d60, 0xffab8163, 0xffa17c60, 0xff98775e, 0xff98765d, 0xff9a755c, 0xff997459, 0xff997458,
    0xff9e795b, 0xffa47f5f, 0xffa37e5f, 0xff9b775b, 0xff906f57, 0xff846956, 0xff745f51, 0xff5e4e45,
    0xff4c3f3a, 0xff4a3d38, 0xff53453d, 0xff584940, 0xff18475a, 0xff18475a, 0xff184759, 0xff19495b,
    0xff1e4e63, 0xff22526b, 0xff225269, 0xff1f5063, 0xff1e4f61, 0xff1f4f62, 0xff1f5063, 0xff1d5060,
    0xff1d505e, 0xff1f5060, 0xff225162, 0xff235263, 0xff215462, 0xff1b515c, 0xff134b54, 0xff124a52,
    0xff1c525d, 0xff265968, 0xff2a5c6e, 0xff2b5b70, 0xff2a5b6f, 0xff29596b, 0xff255665, 0xff1f525f,
    0xff1d505d, 0xff1f535f, 0xff235663, 0xff255966, 0xff265a66, 0xff255a65, 0xff225962, 0xff20575e,
    0xff1f545a, 0xff1f5359, 0xff21545e, 0xff245663, 0xff285a66, 0xff2c5d67, 0xff2d5d66, 0xff2c5b63,
    0xff2c5a64, 0xff2c5b68, 0xff2e5d6d, 0xff315e71, 0xff315e71, 0xff2d5a6c, 0xff295566, 0xff275364,
    0xff285466, 0xff285568, 0xff295669, 0xff275569, 0xff235066, 0xff214d63, 0xff234c63, 0xff264d63,
    0xff284d60, 0xff284e5d, 0xff2b5060, 0xff305467, 0xff345770, 0xff375977, 0xff375978, 0xff345773,
    0xff32566e, 0xff345771, 0xff375a78, 0xff3a5c7b, 0xff3a5c79, 0xff385a73, 0xff36556b, 0xff38546a,
    0xff405b72, 0xff4a647e, 0xff536a87, 0xff586c8b, 0xff5c6b88, 0xff5c6881, 0xff5c6479, 0xff5b6072,
    0xff5d6275, 0xff646b84, 0xff6d7597, 0xff757da3, 0xff7980a7, 0xff797ea4, 0xff757a9b, 0xff6a718d,
    0xff58647b, 0xff4e5c71, 0xff505c6e, 0xff5b616f, 0xff6a676e, 0xff7b6f6c, 0xff927b6c, 0xffa5886d,
    0xffbf996f, 0xffe0af74, 0xfff5bf79, 0xffffc87f, 0xffffcb84, 0xffffcc88, 0xffffca89, 0xfffbc587,
    0xfff4be83, 0xfff1bb81, 0xfff6be82, 0xfffbc183, 0xfffac182, 0xfff7c080, 0xfff8c17e, 0xfffbc27c,
    0xfffcc279, 0xfffcc075, 0xfffabd73, 0xfff6bb75, 0xfff3bb7b, 0xfff3c184, 0xfff0c58b, 0xffe4bc87,
    0xffd5af7d, 0xffd1ab78, 0xffdbb37a, 0xffe5b87c, 0xffecb47a, 0xffeeb37a, 0xffefba81, 0xfff0c287,
    0xfff4c789, 0xfff8c886, 0xfff4c381, 0xffeaba7e, 0xffdcac77, 0xffce9a6b, 0xffc69466, 0xffc39a68,
    0xffc7a770, 0xffd2af78, 0xffe0b37e, 0xffedba84, 0xfff3c186, 0xfff0c085, 0xffe3b47e, 0xffd9a977,
    0xffdba670, 0xffdba36b, 0xffcf9a68, 0xffbb8e68, 0xffa98466, 0xffa17f63, 0xff94765d, 0xff836855,
    0xff6f584d, 0xff5e4d46, 0xff514541, 0xff463e3c, 0xff413a39, 0xff3d3637, 0xff3c3436, 0xff3d3436,
    0xff3e3637, 0xff413a3a, 0xff463d3d, 0xff4a3f3f, 0xff4b3d3d, 0xff4b3b3a, 0xff54413c, 0xff624b43,
    0xff6b5248, 0xff6a5447, 0xff6c5748, 0xff7b6250, 0xff8f6f5a, 0xffa27c62, 0xffb18666, 0xffba8b68,
    0xff194c57, 0xff194c57, 0xff1a4e57, 0xff1b4f56, 0xff194e54, 0xff174d53, 0xff174d54, 0xff194e56,
    0xff1c5058, 0xff1f5258, 0xff21535b, 0xff22555f, 0xff235662, 0xff255863, 0xff275964, 0xff295965,
    0xff2a5a66, 0xff2c5b68, 0xff2e5d6a, 0xff2e5d69, 0xff295864, 0xff26555f, 0xff25555a, 0xff265759,
    0xff2b5b5e, 0xff305f66, 0xff33626b, 0xff33616a, 0xff33616a, 0xff36636c, 0xff37646d, 0xff36636e,
    0xff35626f, 0xff366271, 0xff396373, 0xff386173, 0xff365e71, 0xff345b6f, 0xff34586d, 0xff34576b,
    0xff325568, 0xff2f5366, 0xff2f5367, 0xff305469, 0xff30546b, 0xff30546c, 0xff2e536a, 0xff2b5066,
    0xff294f64, 0xff294f65, 0xff2b5167, 0xff2e536a, 0xff30556a, 0xff315669, 0xff305565, 0xff305464,
    0xff335567, 0xff35576b, 0xff36596f, 0xff385b73, 0xff3a5c75, 0xff3c5d75, 0xff3e5d77, 0xff3f5e78,
    0xff405f7a, 0xff42617c, 0xff45627d, 0xff49637c, 0xff4c647a, 0xff516778, 0xff546a76, 0xff51646e,
    0xff4a5864, 0xff465060, 0xff495467, 0xff4e5a6f, 0xff4f596f, 0xff525b71, 0xff57627c, 0xff606d8d,
    0xff717da5, 0xff838cba, 0xff949ccf, 0xffa0a9e1, 0xffa3ace2, 0xff9fa6d5, 0xff9398be, 0xff7f86a5,
    0xff6b748e, 0xff5e6579, 0xff5c606d, 0xff645f65, 0xff75635e, 0xff886b5d, 0xff9d765d, 0xffad7f60,
    0xffb18360, 0xffad8260, 0xffab8161, 0xffab8062, 0xffa87d62, 0xffa0765e, 0xff9b725c, 0xff9b735d,
    0xff9b745e, 0xff97715c, 0xff916b58, 0xff866454, 0xff7c5f52, 0xff795c52, 0xff825f53, 0xff916856,
    0xffa4755d, 0xffb28061, 0xffb07e5e, 0xffa47557, 0xff996c52, 0xff946750, 0xff946750, 0xff9d6e52,
    0xffa87756, 0xffb3815c, 0xffba875f, 0xffbb855c, 0xffb47c56, 0xffa37051, 0xff8f6651, 0xff795a4e,
    0xff664e48, 0xff604944, 0xff5f4843, 0xff6e5247, 0xff8c6853, 0xffaf8262, 0xffc7946c, 0xffca976d,
    0xffcc9a6e, 0xffd2a271, 0xffd2a371, 0xffcb9b6d, 0xffc08e66, 0xffb18160, 0xffa67a5b, 0xffac8160,
    0xffc0946b, 0xffc6996c, 0xffae835c, 0xff9c7251, 0xffa27657, 0xffb28363, 0xffc18d68, 0xffca9369,
    0xffc69367, 0xffb88c64, 0xffb38b64, 0xffc09569, 0xffd3a070, 0xffd9a576, 0xffdaa578, 0xffd8a477,
    0xffd3a172, 0xffcd9d6f, 0xffc8996e, 0xffc4966d, 0xffc3956c, 0xffb48b65, 0xff8e6f55, 0xff695547,
    0xff665348, 0xff766051, 0xff715b4e, 0xff574741, 0xff423837, 0xff3d3837, 0xff403c3a, 0xff413b3a,
    0xff453b3a, 0xff4c3e3c, 0xff54443f, 0xff594741, 0xff1f4f5c, 0xff1f4f5c, 0xff205060, 0xff215162,
    0xff1f4f5d, 0xff1d4c58, 0xff1d4c57, 0xff1f4d59, 0xff214f5b, 0xff22515c, 0xff25535d, 0xff29555e,
    0xff2b565f, 0xff2c5660, 0xff2c5661, 0xff2c5661, 0xff2c5761, 0xff2c5763, 0xff2d5666, 0xff2f5768,
    0xff325a6b, 0xff345d6d, 0xff365f72, 0xff365f73, 0xff345e70, 0xff305a69, 0xff2b5560, 0xff275059,
    0xff264f57, 0xff2c5660, 0xff315b67, 0xff325b67, 0xff315965, 0xff335967, 0xff365b6a, 0xff385b6e,
    0xff385b71, 0xff35596f, 0xff315566, 0xff2f5460, 0xff335863, 0xff375c69, 0xff395e6b, 0xff385c6a,
    0xff375a68, 0xff375765, 0xff375664, 0xff375663, 0xff385865, 0xff3b5c68, 0xff3f606c, 0xff406170,
    0xff416073, 0xff416075, 0xff415f77, 0xff425f78, 0xff445f7b, 0xff46607c, 0xff48617d, 0xff49617c,
    0xff495f78, 0xff485d74, 0xff485c72, 0xff485c73, 0xff495d73, 0xff4a5c71, 0xff4e5e72, 0xff556578,
    0xff5d6c7f, 0xff5f6b7f, 0xff62697f, 0xff74778c, 0xff8d8ea2, 0xffa5a6b9, 0xffb6b6ce, 0xffb7b9d8,
    0xffb0b4dd, 0xffa1a6d9, 0xff939acc, 0xff888fbb, 0xff7881aa, 0xff6a77a1, 0xff626f92, 0xff656a7a,
    0xff726d6b, 0xff857767, 0xff9d856a, 0xffb18f6b, 0xffc1956a, 0xffd09e6c, 0xffd9a66f, 0xffd8a770,
    0xffca9b6d, 0xffbb8e6a, 0xffb18566, 0xffac8264, 0xffb18867, 0xffbb926c, 0xffbf976d, 0xffbd946a,
    0xffbb9168, 0xffbb9168, 0xffbd9269, 0xffc3966b, 0xffc5986b, 0xffc5956a, 0xffbe8e66, 0xffa47a5d,
    0xff836352, 0xff654e45, 0xff544039, 0xff554037, 0xff60473b, 0xff785846, 0xff996f53, 0xffb9865e,
    0xffd49967, 0xffdf9f69, 0xffe9a76a, 0xfff8b469, 0xffffc06d, 0xffffcc7a, 0xffffd488, 0xfffed58e,
    0xfffbd18c, 0xfff8cb8a, 0xfff7c789, 0xffe9b67e, 0xffc89368, 0xffa37355, 0xff7b5849, 0xff634b47,
    0xff6d534c, 0xff8f6857, 0xffb07f5f, 0xffc48e60, 0xffdaa168, 0xfff6bc79, 0xfffec681, 0xffeebb7c,
    0xffd9aa72, 0xffd8a974, 0xffe3b17a, 0xffe2af79, 0xffd5a371, 0xffce9b6c, 0xffd49e70, 0xffd79f71,
    0xffce976a, 0xffc18b62, 0xffb5815b, 0xffae7b58, 0xffaa7a5b, 0xffac7e62, 0xffb38568, 0xffc08d69,
    0xffc69066, 0xffbc8a61, 0xffac805c, 0xffa47a5c, 0xffa2785f, 0xff9e755e, 0xff97715b, 0xff96705a,
    0xff9c735a, 0xffa6795d, 0xffac7f61, 0xffb08364, 0xffae8363, 0xffa98261, 0xffaa8463, 0xffb18868,
    0xffb08567, 0xffa0785f, 0xff8e6a56, 0xff886856, 0xff826655, 0xff6f594b, 0xff59483e, 0xff4c3e36,
    0xff215059, 0xff215059, 0xff204f5a, 0xff1f4e5b, 0xff204e5e, 0xff214f61, 0xff215061, 0xff21505f,
    0xff214f5e, 0xff224e5d, 0xff234d5e, 0xff244e60, 0xff265061, 0xff295263, 0xff2b5464, 0xff2a5362,
    0xff28525f, 0xff29535e, 0xff2e5760, 0xff315961, 0xff325a62, 0xff315961, 0xff30575e, 0xff30575c,
    0xff345b63, 0xff39606c, 0xff3c636e, 0xff3b6167, 0xff385d61, 0xff355960, 0xff345861, 0xff375a64,
    0xff3b5e67, 0xff3b5d67, 0xff395b67, 0xff3a5c68, 0xff3d5f69, 0xff3f616c, 0xff3e606e, 0xff3c5d6f,
    0xff395a6c, 0xff385969, 0xff38596a, 0xff3a5b6e, 0xff3e5d72, 0xff425f75, 0xff456077, 0xff486178,
    0xff496278, 0xff4c657a, 0xff4f6679, 0xff4f6576, 0xff4d6272, 0xff4b5f6d, 0xff495d6a, 0xff455966,
    0xff40515e, 0xff3e4d5b, 0xff404e5c, 0xff435260, 0xff445462, 0xff435362, 0xff455262, 0xff485162,
    0xff4d5465, 0xff575d6c, 0xff646a7c, 0xff7a7e98, 0xff8c8eaf, 0xff898aac, 0xff7d7d9b, 0xff8b889f,
    0xffada6b7, 0xffc1b8c4, 0xffb3aab9, 0xff9a95a8, 0xff84849d, 0xff757997, 0xff6f779b, 0xff777da1,
    0xff958995, 0xffbe957c, 0xffda9d66, 0xffda9b5d, 0xffd0975f, 0xffcc9663, 0xffcb976a, 0xffce9c6f,
    0xffd4a271, 0xffd2a271, 0xffcb9c6d, 0xffc4976b, 0xffc1946b, 0xffbd8f6a, 0xffb08466, 0xffa47961,
    0xff9a725c, 0xff99725a, 0xffa87e5f, 0xffc19267, 0xffdca771, 0xffefb878, 0xfff8c07b, 0xfffdc47e,
    0xfff9c17d, 0xfff0ba7a, 0xffe2af74, 0xffcc9869, 0xffb5805b, 0xff9a6a50, 0xff7c5b4b, 0xff685448,
    0xff5d4d43, 0xff59483f, 0xff54453c, 0xff51413b, 0xff4b3b35, 0xff44332e, 0xff4c362d, 0xff694738,
    0xff875d47, 0xff9f7056, 0xffb58464, 0xffce986c, 0xffe3a970, 0xfff6c07b, 0xffffd48a, 0xfffed992,
    0xfff0c78b, 0xffe6b781, 0xffefb97e, 0xffeeb678, 0xffc89968, 0xff937054, 0xff715344, 0xff704e40,
    0xff7b5241, 0xff8c5d47, 0xffa77354, 0xffcf9668, 0xffedb479, 0xffecb67b, 0xffd5a572, 0xffc89a6c,
    0xffc8996b, 0xffc59368, 0xffb68460, 0xff9e7055, 0xff795645, 0xff5a4038, 0xff553f38, 0xff624a3f,
    0xff5d493f, 0xff4a3d37, 0xff4a3c38, 0xff675046, 0xff816253, 0xff74594e, 0xff5e4a44, 0xff594842,
    0xff624f47, 0xff695348, 0xff6b5346, 0xff6c5245, 0xff6a5146, 0xff675147, 0xff664f44, 0xff685043,
    0xff765848, 0xff84614f, 0xff795b4b, 0xff5a483e, 0xff50433a, 0xff6d5747, 0xff8f6c54, 0xff8e6850,
    0xff845f4a, 0xff85604c, 0xff8b6954, 0xff8f6f58, 0xff1b4951, 0xff1b4951, 0xff1d4a53, 0xff1e4b55,
    0xff1d4b55, 0xff1d4b55, 0xff1f4c55, 0xff234c56, 0xff264d56, 0xff254e57, 0xff254f58, 0xff295159,
    0xff2b535a, 0xff2c545b, 0xff2c555d, 0xff2d565d, 0xff2f575d, 0xff335962, 0xff365c69, 0xff375e6d,
    0xff375e6b, 0xff365d68, 0xff365c65, 0xff375b65, 0xff395c68, 0xff3b5d6c, 0xff3b5c6b, 0xff395a64,
    0xff37575d, 0xff355658, 0xff365758, 0xff3a5a5d, 0xff3f5f65, 0xff44646d, 0xff476772, 0xff466672,
    0xff415f6d, 0xff3c5967, 0xff3c5562, 0xff3e5461, 0xff415562, 0xff465965, 0xff4c5d69, 0xff53616d,
    0xff56636f, 0xff55636f, 0xff55636c, 0xff586266, 0xff5a6264, 0xff596267, 0xff57626c, 0xff54616e,
    0xff525f6f, 0xff515e70, 0xff535f71, 0xff536074, 0xff505f78, 0xff4d5e7b, 0xff4b5e7c, 0xff4b5e7b,
    0xff4c5e79, 0xff4f5f77, 0xff535f75, 0xff566074, 0xff565e72, 0xff505a6f, 0xff4b556b, 0xff485267,
    0xff4a5466, 0xff575e6f, 0xff676b7c, 0xff696c80, 0xff5c6178, 0xff525976, 0xff505d81, 0xff54648d,
    0xff5a6b95, 0xff617198, 0xff657094, 0xff676d8e, 0xff707392, 0xff7a7fa1, 0xff878baa, 0xff9693a8,
    0xff9f9096, 0xffa28076, 0xffa37158, 0xffaa7553, 0xffb58560, 0xffc1946b, 0xffc99b6f, 0xffd2a372,
    0xffdbac74, 0xffe3b375, 0xffedba78, 0xfff1bc79, 0xffe9b476, 0xffd7a66f, 0xffb88d64, 0xff987457,
    0xff80604e, 0xff78594c, 0xff7f5d4f, 0xff8c6654, 0xff986f58, 0xff976f58, 0xff8d6754, 0xff805e4e,
    0xff755849, 0xff6e5446, 0xff6e5345, 0xff6e5346, 0xff6c5448, 0xff665246, 0xff5b4a3c, 0xff503e2f,
    0xff473525, 0xff453124, 0xff453126, 0xff47352c, 0xff483931, 0xff473a34, 0xff4a3d38, 0xff584641,
    0xff6b514b, 0xff7b5a51, 0xff815c4f, 0xff8d6452, 0xffa5765d, 0xffbf8d69, 0xffdda877, 0xfff2bc80,
    0xfff0bd80, 0xffdfae79, 0xffd3a070, 0xffd09969, 0xffbb875d, 0xff8b674d, 0xff695142, 0xff62493f,
    0xff6d4d42, 0xff795547, 0xff865f4d, 0xff916953, 0xff956f57, 0xffa57d5e, 0xffc6966a, 0xffdea672,
    0xffe9ae75, 0xffe4a973, 0xffcc9769, 0xffac805c, 0xff9a7358, 0xff9c755e, 0xff8a6855, 0xff594235,
    0xff2f221b, 0xff322a24, 0xff453e38, 0xff4d433e, 0xff4c3e39, 0xff4d3c37, 0xff4e3f39, 0xff4f423c,
    0xff50443f, 0xff4e433f, 0xff483d38, 0xff423832, 0xff433832, 0xff473d36, 0xff463b34, 0xff3f342e,
    0xff40332d, 0xff4d3d35, 0xff57453d, 0xff4e413a, 0xff423935, 0xff403834, 0xff453b36, 0xff483c37,
    0xff275156, 0xff275156, 0xff2a5357, 0xff2b5357, 0xff295156, 0xff274f53, 0xff244e51, 0xff234d4f,
    0xff265052, 0xff2c5458, 0xff31575b, 0xff335756, 0xff335553, 0xff335455, 0xff335559, 0xff35575c,
    0xff395b5d, 0xff3b5d5e, 0xff3a5c5f, 0xff3a5b5f, 0xff3b5a61, 0xff3c5b63, 0xff3f5d68, 0xff405f6a,
    0xff3e5e67, 0xff3b5c60, 0xff3c5b5e, 0xff3f5d61, 0xff425c63, 0xff435961, 0xff44585e, 0xff4a5d5d,
    0xff50625c, 0xff50615b, 0xff4e5c5a, 0xff4b585a, 0xff49575a, 0xff49575d, 0xff4c5965, 0xff4e5b6b,
    0xff4f5d6f, 0xff4f5f70, 0xff4e5f70, 0xff4d5f70, 0xff4d5f71, 0xff4f5e72, 0xff515f75, 0xff546477,
    0xff586777, 0xff5f6974, 0xff636a70, 0xff636b72, 0xff5e6a75, 0xff586576, 0xff525f73, 0xff4d5a70,
    0xff4b596d, 0xff4e5c6e, 0xff556375, 0xff5c6a7e, 0xff606d85, 0xff5f6c88, 0xff5a6887, 0xff536281,
    0xff50607f, 0xff546688, 0xff5b6c8f, 0xff627191, 0xff667393, 0xff667398, 0xff62719d, 0xff5e6e9d,
    0xff5b6b97, 0xff5d6c95, 0xff67759b, 0xff6e7aa0, 0xff6a759c, 0xff68719b, 0xff6b78a7, 0xff7787b9,
    0xff98a0c4, 0xffbfbac4, 0xffd8c2b1, 0xffd2aa86, 0xffc19067, 0xffb7855d, 0xffb18460, 0xffb18663,
    0xffb78c67, 0xffc3956a, 0xffce9e6a, 0xffd9a56c, 0xffe0ac6f, 0xffe3ae72, 0xffe4ae72, 0xffe5af73,
    0xffeab476, 0xfff1ba7b, 0xfff8c07d, 0xfffbc47c, 0xfff2bc78, 0xffd7a470, 0xffb48763, 0xff8d6951,
    0xff694f40, 0xff534137, 0xff4b3f35, 0xff4a4036, 0xff514339, 0xff58473d, 0xff5c4c43, 0xff5b4c44,
    0xff59483f, 0xff534035, 0xff473325, 0xff3c2818, 0xff3e2d1e, 0xff4e4035, 0xff5c4f47, 0xff5f4e45,
    0xff5d493f, 0xff5d483f, 0xff5b4841, 0xff594841, 0xff574942, 0xff564943, 0xff574a44, 0xff564842,
    0xff52413b, 0xff533f38, 0xff5a453f, 0xff654e47, 0xff6c5146, 0xff73523f, 0xff86593e, 0xff9d6543,
    0xffb47750, 0xffc79167, 0xffc89a72, 0xffba8f6c, 0xffa3795e, 0xff926d58, 0xff866856, 0xff725a4c,
    0xff5e493f, 0xff4e3b32, 0xff463328, 0xff4b3628, 0xff5a3f31, 0xff6f4d3e, 0xff825c4a, 0xff8c6651,
    0xff86634d, 0xff715440, 0xff6b503d, 0xff805f4c, 0xff95705c, 0xff8e6b59, 0xff7b5e4f, 0xff675146,
    0xff564841, 0xff4e423e, 0xff52443f, 0xff53433d, 0xff4b3d36, 0xff453931, 0xff483b34, 0xff4c3f39,
    0xff4b403b, 0xff473e3b, 0xff463e3c, 0xff49403d, 0xff4a403b, 0xff483c36, 0xff473932, 0xff493a32,
    0xff4d3e36, 0xff54443b, 0xff5a4a3f, 0xff5f4d42, 0xff24494f, 0xff24494f, 0xff284c50, 0xff2a4d50,
    0xff284a4f, 0xff26474e, 0xff284a50, 0xff2d4e53, 0xff2e5052, 0xff2c4d4e, 0xff2c4c4e, 0xff315256,
    0xff36565c, 0xff39575b, 0xff3a5758, 0xff3a5756, 0xff3a5756, 0xff3c5755, 0xff3f5753, 0xff435a55,
    0xff49605c, 0xff4b625f, 0xff495f5b, 0xff465b56, 0xff485b57, 0xff4d5f5c, 0xff50605d, 0xff505f5a,
    0xff4e5d59, 0xff4c5c5e, 0xff495b62, 0xff455764, 0xff415464, 0xff3f5164, 0xff3f5165, 0xff405165,
    0xff425366, 0xff465669, 0xff4b5a6c, 0xff4f5d6e, 0xff525d6c, 0xff545e69, 0xff59616b, 0xff5d656f,
    0xff616973, 0xff626a75, 0xff616974, 0xff5f656e, 0xff5a6068, 0xff535a63, 0xff4f5761, 0xff535a67,
    0xff5b6272, 0xff646a7b, 0xff686e7f, 0xff697081, 0xff676f81, 0xff636b80, 0xff60677e, 0xff5b637c,
    0xff545e7a, 0xff4d5b79, 0xff4d5d7d, 0xff536384, 0xff576688, 0xff556484, 0xff536180, 0xff535f7f,
    0xff556080, 0xff596382, 0xff5f6884, 0xff6a718c, 0xff757b97, 0xff81839c, 0xff8b8594, 0xff94888c,
    0xffa0908b, 0xffb09989, 0xffc9a480, 0xffdfaa73, 0xffe2a667, 0xffd09960, 0xffc1905f, 0xffc29364,
    0xffc99b6b, 0xffd1a36f, 0xffd8a971, 0xffdbab71, 0xffdca96f, 0xffdda86e, 0xffdeaa6e, 0xffe1ad6f,
    0xffe4b071, 0xffe6b172, 0xffe6b172, 0xffe5b072, 0xffe5b073, 0xffe6b173, 0xffeab475, 0xffeeb776,
    0xfff3ba76, 0xfff9bd72, 0xfff4b86e, 0xffe4aa6b, 0xffcb9768, 0xffb58763, 0xffa27b5d, 0xff8b6c55,
    0xff79604f, 0xff6b5549, 0xff624d43, 0xff5b463b, 0xff4e392d, 0xff442f22, 0xff423023, 0xff47392c,
    0xff4e4035, 0xff55443b, 0xff58463e, 0xff57463e, 0xff57463e, 0xff5c4b44, 0xff615049, 0xff63524b,
    0xff615048, 0xff5d4c44, 0xff5a4941, 0xff57463e, 0xff54443c, 0xff504138, 0xff493931, 0xff43342c,
    0xff46372f, 0xff4f3f38, 0xff53443e, 0xff51443f, 0xff524540, 0xff594842, 0xff604a43, 0xff634a40,
    0xff684d3e, 0xff775744, 0xff86614d, 0xff83604e, 0xff6f5445, 0xff59463b, 0xff4a3b32, 0xff453830,
    0xff493c36, 0xff4f413c, 0xff4d403a, 0xff473a32, 0xff45372e, 0xff49392f, 0xff4c3b31, 0xff4b3d33,
    0xff4a3e36, 0xff4c3f38, 0xff4e403a, 0xff4f413b, 0xff50433a, 0xff4e4137, 0xff4b3c34, 0xff493a32,
    0xff493c35, 0xff493e38, 0xff473d39, 0xff463b38, 0xff473b38, 0xff493d38, 0xff483d38, 0xff453c37,
    0xff453b37, 0xff483d38, 0xff4a3d37, 0xff443a33, 0xff3e362f, 0xff3d3630, 0xff3f3733, 0xff403835,
};

static uint32_t _gStretchBmp2[]=
{
    0xff7b91c0, 0xff7e92c1, 0xff7f95c4, 0xff8193c4, 0xff8397c6, 0xff8597c5, 0xff8898c6, 0xff8a9bc7,
    0xff8a9bca, 0xff8c9dcb, 0xff8e9ecc, 0xff919ecc, 0xff92a0cd, 0xff96a3ce, 0xff97a4cf, 0xff9ba7d2,
    0xff9ba7d2, 0xff9da9d4, 0xff9ea9d4, 0xffa0add7, 0xffa1add7, 0xffa1afd4, 0xffa2b0d7, 0xffa3b2d6,
    0xffa6b4d6, 0xffa7b4d6, 0xffaab4d6, 0xffabb6d6, 0xffacb6d6, 0xffadb6d5, 0xffafb7d7, 0xffaeb6d7,
    0xffafb7d7, 0xffaeb6d6, 0xffabb4d8, 0xffa9b0d5, 0xffa8b0d4, 0xffa5aed4, 0xffa6b0d6, 0xffa4aed3,
    0xffa3add6, 0xffa0acd2, 0xffa1acd5, 0xffa0abd3, 0xff9eabd3, 0xff9da9d3, 0xff9ca9d3, 0xff9baad3,
    0xff9baad4, 0xff9aa9d2, 0xff98aad4, 0xff96a7d3, 0xff96a7d4, 0xff95a6d6, 0xff91a4d6, 0xff889bd4,
    0xff7f96d6, 0xff7e91d6, 0xff798fd3, 0xff758fd2, 0xff708bd0, 0xff6c8ad2, 0xff6988d0, 0xff6284d2,
    0xff5e84d1, 0xff5d83cf, 0xff5a7fd1, 0xff5b80d2, 0xff5b80d3, 0xff597fd0, 0xff5a7ecb, 0xff5b7fca,
    0xff587cc9, 0xff5579ca, 0xff5176c6, 0xff5075c7, 0xff4f74c5, 0xff4e73c4, 0xff4d72c3, 0xff4b70c2,
    0xff7b91c0, 0xff7e92c1, 0xff7f95c4, 0xff8193c4, 0xff8397c6, 0xff8597c5, 0xff8898c6, 0xff8a9bc7,
    0xff8a9bca, 0xff8c9dcb, 0xff8e9ecc, 0xff919ecc, 0xff92a0cd, 0xff96a3ce, 0xff97a4cf, 0xff9ba7d2,
    0xff9ba7d2, 0xff9da9d4, 0xff9ea9d4, 0xffa0add7, 0xffa1add7, 0xffa1afd4, 0xffa2b0d7, 0xffa3b2d6,
    0xffa6b4d6, 0xffa7b4d6, 0xffaab4d6, 0xffabb6d6, 0xffacb6d6, 0xffadb6d5, 0xffafb7d7, 0xffaeb6d7,
    0xffafb7d7, 0xffaeb6d6, 0xffabb4d8, 0xffa9b0d5, 0xffa8b0d4, 0xffa5aed4, 0xffa6b0d6, 0xffa4aed3,
    0xffa3add6, 0xffa0acd2, 0xffa1acd5, 0xffa0abd3, 0xff9eabd3, 0xff9da9d3, 0xff9ca9d3, 0xff9baad3,
    0xff9baad4, 0xff9aa9d2, 0xff98aad4, 0xff96a7d3, 0xff96a7d4, 0xff95a6d6, 0xff91a4d6, 0xff889bd4,
    0xff7f96d6, 0xff7e91d6, 0xff798fd3, 0xff758fd2, 0xff708bd0, 0xff6c8ad2, 0xff6988d0, 0xff6284d2,
    0xff5e84d1, 0xff5d83cf, 0xff5a7fd1, 0xff5b80d2, 0xff5b80d3, 0xff597fd0, 0xff5a7ecb, 0xff5b7fca,
    0xff587cc9, 0xff5579ca, 0xff5176c6, 0xff5075c7, 0xff4f74c5, 0xff4e73c4, 0xff4d72c3, 0xff4b70c2,
    0xff7c92c0, 0xff7f92c2, 0xff7f95c4, 0xff8194c4, 0xff8397c5, 0xff8698c6, 0xff8899c7, 0xff8a9bc8,
    0xff8b9cca, 0xff8c9dcb, 0xff8f9ecc, 0xff929fcd, 0xff93a1cf, 0xff96a3cf, 0xff96a4d0, 0xff9aa6d3,
    0xff9ba8d3, 0xff9eaad4, 0xff9eabd4, 0xffa0afd6, 0xffa2b0d6, 0xffa3b1d4, 0xffa4b3d6, 0xffa6b4d5,
    0xffa9b5d5, 0xffaab4d5, 0xffacb4d5, 0xffaeb6d6, 0xffaeb5d5, 0xffaeb5d4, 0xffb0b6d6, 0xffb0b4d6,
    0xffb0b4d6, 0xffb0b4d6, 0xffacb2d7, 0xffa8aed3, 0xffa8aed3, 0xffa5acd2, 0xffa5add4, 0xffa5abd3,
    0xffa3aad3, 0xffa1a9d2, 0xffa2a9d3, 0xffa0a9d2, 0xffa0a8d1, 0xff9fa8d2, 0xff9ea7d1, 0xff9da8d1,
    0xff9da8d2, 0xff9ca8d1, 0xff9baad1, 0xff99a8d2, 0xff99a9d2, 0xff98a8d3, 0xff94a7d4, 0xff8c9fd3,
    0xff829ad4, 0xff7d95d4, 0xff7591d5, 0xff728ed4, 0xff6e8bd2, 0xff6988d3, 0xff6685d3, 0xff6283d3,
    0xff6184d1, 0xff6083cf, 0xff5e81d0, 0xff5d82cf, 0xff5e81d0, 0xff5a7fce, 0xff5b7ecd, 0xff5b7ecb,
    0xff597dc9, 0xff567aca, 0xff5378c8, 0xff5277c8, 0xff5176c6, 0xff4f74c4, 0xff4e72c2, 0xff4c71c0,
    0xff7d93c1, 0xff8093c3, 0xff8095c4, 0xff8295c4, 0xff8496c4, 0xff8798c6, 0xff8799c7, 0xff8a9bc9,
    0xff8b9cca, 0xff8c9dcb, 0xff909ecc, 0xff93a0cf, 0xff95a2d1, 0xff97a3d1, 0xff96a4d2, 0xff9aa6d3,
    0xff9ba9d4, 0xff9fabd4, 0xff9faed4, 0xffa1b0d5, 0xffa4b2d5, 0xffa5b3d4, 0xffa6b5d5, 0xffaab5d4,
    0xffacb5d4, 0xffadb4d4, 0xffaeb3d4, 0xffb0b6d6, 0xffb0b5d4, 0xffafb4d3, 0xffb0b5d5, 0xffb2b3d4,
    0xffb0b2d4, 0xffb0b2d5, 0xffacb0d6, 0xffa7acd2, 0xffa7abd2, 0xffa5aad0, 0xffa4a9d2, 0xffa5a8d3,
    0xffa2a7d1, 0xffa1a5d1, 0xffa1a5d2, 0xff9fa7d1, 0xffa1a5cf, 0xff9fa6d1, 0xffa0a5ce, 0xffa0a6d0,
    0xff9ea6d0, 0xff9ea6d1, 0xff9ea9cf, 0xff9ca8d0, 0xff9da9d1, 0xff9baad0, 0xff98a9d2, 0xff91a3d2,
    0xff869fd2, 0xff7c99d3, 0xff7293d6, 0xff708fd5, 0xff6c8cd4, 0xff6688d5, 0xff6483d5, 0xff6283d4,
    0xff6585d2, 0xff6384cf, 0xff6183ce, 0xff6184cc, 0xff6182cd, 0xff5c80cd, 0xff5c7fce, 0xff5c7ecb,
    0xff5b7fc9, 0xff577cca, 0xff557aca, 0xff5378c9, 0xff5277c7, 0xff5075c4, 0xff4f73c2, 0xff4d72bf,
    0xff7e93c1, 0xff8193c3, 0xff8195c4, 0xff8396c4, 0xff8496c4, 0xff8798c6, 0xff8799c7, 0xff899bc9,
    0xff8b9cca, 0xff8c9dcc, 0xff909ecc, 0xff93a0cf, 0xff95a2d1, 0xff97a3d2, 0xff97a4d3, 0xff9aa7d2,
    0xff9dacd4, 0xffa0add3, 0xffa1b1d3, 0xffa3b2d3, 0xffa7b4d3, 0xffa8b5d3, 0xffa9b5d3, 0xffadb5d4,
    0xffaeb4d2, 0xffafb4d2, 0xffaeb2d3, 0xffb1b4d5, 0xffb0b3d3, 0xffafb2d3, 0xffafb3d4, 0xffb1b1d3,
    0xffafb0d4, 0xffafb0d5, 0xffabaed4, 0xffa7aad2, 0xffa5a9d2, 0xffa4a8d0, 0xffa3a7d2, 0xffa4a6d3,
    0xffa1a5d0, 0xffa0a3d1, 0xffa0a3d1, 0xff9ea5d1, 0xffa0a3cf, 0xff9ea4d0, 0xff9fa3ce, 0xffa0a3cf,
    0xff9da3ce, 0xff9ea3cf, 0xffa0a6ce, 0xff9ea7d0, 0xff9fa8cf, 0xff9da9ce, 0xff9aa8d1, 0xff95a5d0,
    0xff8ba2d0, 0xff7f9cd2, 0xff7395d5, 0xff6e90d5, 0xff6c8ed6, 0xff6689d6, 0xff6484d7, 0xff6283d4,
    0xff6685d2, 0xff6584cf, 0xff6585ce, 0xff6485cb, 0xff6484cb, 0xff5f81cc, 0xff5e80cd, 0xff5e7fcb,
    0xff5b7fca, 0xff577cca, 0xff577bca, 0xff5479c9, 0xff5479c7, 0xff5177c4, 0xff5074c2, 0xff4e73bf,
    0xff7f94c1, 0xff8294c3, 0xff8195c3, 0xff8496c5, 0xff8496c4, 0xff8597c5, 0xff8698c6, 0xff889ac8,
    0xff8b9bcb, 0xff8c9ccd, 0xff909dcd, 0xff929fcf, 0xff95a2d0, 0xff97a4d2, 0xff98a6d3, 0xff9baad1,
    0xff9fafd4, 0xffa0afd2, 0xffa3b2d2, 0xffa6b3d2, 0xffa9b3d1, 0xffabb4d2, 0xffabb4d1, 0xffaeb3d3,
    0xffadb2d2, 0xffafb3d2, 0xffadb1d3, 0xffb0b1d3, 0xffafb2d2, 0xffafb1d4, 0xffaeb1d4, 0xffafb0d3,
    0xffacafd4, 0xffacaed4, 0xffa9acd4, 0xffa7a9d3, 0xffa3a7d3, 0xffa3a7d1, 0xffa2a6d2, 0xffa2a4d2,
    0xffa0a4d1, 0xff9ea3d1, 0xff9ea3d1, 0xff9da3d0, 0xff9ca1d0, 0xff9ba2d0, 0xff9da1cf, 0xff9da1cf,
    0xff9ba1cd, 0xff9ba1cd, 0xffa0a3ce, 0xff9ea5cf, 0xff9fa6ce, 0xff9da5cf, 0xff9ba6d1, 0xff97a5ce,
    0xff90a3d0, 0xff839ed1, 0xff7697d2, 0xff6e93d4, 0xff6d91d6, 0xff678cd6, 0xff6487d6, 0xff6184d5,
    0xff6585d3, 0xff6685d0, 0xff6785cf, 0xff6885cc, 0xff6785cb, 0xff6382cc, 0xff6081cb, 0xff6080ca,
    0xff5b7fcb, 0xff587dcb, 0xff577bca, 0xff557aca, 0xff5479c7, 0xff5277c5, 0xff5175c3, 0xff4f73c0,
    0xff8094c2, 0xff8395c3, 0xff8395c3, 0xff8597c5, 0xff8596c4, 0xff8497c5, 0xff8698c6, 0xff8799c7,
    0xff8a9acb, 0xff8c9cce, 0xff8f9dce, 0xff919fcf, 0xff94a2cf, 0xff97a5d2, 0xff9ba8d3, 0xff9dadcf,
    0xffa1b1d3, 0xffa2b1d1, 0xffa5b3d0, 0xffa8b3d0, 0xffabb2d0, 0xffadb3d1, 0xffacb2d0, 0xffaeb1d2,
    0xffabafd1, 0xffadb1d1, 0xffacb0d2, 0xffadafd1, 0xffadb0d1, 0xffadb0d5, 0xffacafd3, 0xffacafd3,
    0xffa9afd4, 0xffa8acd3, 0xffa6abd3, 0xffa6a8d4, 0xffa1a6d3, 0xffa1a7d2, 0xffa1a6d3, 0xff9fa4d1,
    0xff9ea4d2, 0xff9ca3d1, 0xff9ba3d1, 0xff9ba2d0, 0xff98a0d1, 0xff98a0cf, 0xff999fd0, 0xff999fcf,
    0xff979ecc, 0xff989ecc, 0xff9d9fcf, 0xff9ca1cf, 0xff9da2ce, 0xff9aa0cf, 0xff99a1d1, 0xff97a2cd,
    0xff93a1cf, 0xff889dd1, 0xff7c98cf, 0xff7295d2, 0xff7194d4, 0xff6b90d5, 0xff678cd5, 0xff6387d4,
    0xff6586d3, 0xff6886d0, 0xff6885cf, 0xff6a84cd, 0xff6985cc, 0xff6783cc, 0xff6283c9, 0xff6282ca,
    0xff5c7fcc, 0xff597dcb, 0xff577bca, 0xff557aca, 0xff547ac7, 0xff5378c6, 0xff5276c3, 0xff5074c1,
    0xff8295c3, 0xff8496c4, 0xff8596c4, 0xff8697c5, 0xff8696c4, 0xff8497c5, 0xff8698c7, 0xff8698c7,
    0xff899acb, 0xff8b9cce, 0xff8e9dcf, 0xff90a0cf, 0xff94a4cf, 0xff98a7d2, 0xff9dabd2, 0xff9fafce,
    0xffa3b1d2, 0xffa4b2d0, 0xffa8b3cf, 0xffaab2cf, 0xffacb1cf, 0xffadb2d1, 0xffacb0cf, 0xffadb0d1,
    0xffaaadd1, 0xffabafd1, 0xffabafd1, 0xffabaed1, 0xffabafd2, 0xffabafd5, 0xffabaed3, 0xffaaaed3,
    0xffa8afd4, 0xffa6abd2, 0xffa4abd3, 0xffa4a8d4, 0xffa0a6d3, 0xffa1a7d3, 0xffa0a6d3, 0xff9ea4d1,
    0xff9ca4d2, 0xff9ba2d0, 0xff99a3d1, 0xff99a1d0, 0xff969fd1, 0xff959ecf, 0xff969ed0, 0xff959ecf,
    0xff949ccc, 0xff969ccb, 0xff9a9ece, 0xff999ece, 0xff999fcf, 0xff979ccf, 0xff979ed0, 0xff959ecd,
    0xff939ece, 0xff8a9bd0, 0xff8098cf, 0xff7896d1, 0xff7695d2, 0xff7093d3, 0xff6b90d4, 0xff678bd3,
    0xff6889d2, 0xff6988d0, 0xff6886cf, 0xff6a84cd, 0xff6984cd, 0xff6884cc, 0xff6484c9, 0xff6383ca,
    0xff5e80cb, 0xff5a7ecb, 0xff587ccb, 0xff567bcb, 0xff547bc7, 0xff5478c6, 0xff5277c3, 0xff5174c2,
    0xff8395c4, 0xff8497c5, 0xff8697c5, 0xff8797c5, 0xff8696c4, 0xff8597c6, 0xff8799c8, 0xff8698c8,
    0xff889acb, 0xff8a9bcc, 0xff8e9fd0, 0xff8fa1cf, 0xff94a6cf, 0xff9aaad0, 0xffa0afcf, 0xffa2afce,
    0xffa5b0d0, 0xffa7b1d0, 0xffaab1ce, 0xffaab1cf, 0xffabafcf, 0xffacb0d2, 0xffabaed0, 0xffabb0d0,
    0xffa8acd1, 0xffa9aed1, 0xffaaaed1, 0xffa9aed2, 0xffa9aed4, 0xffa9aed4, 0xffaaadd4, 0xffa8acd4,
    0xffa7aed4, 0xffa4acd1, 0xffa3abd3, 0xffa2a8d4, 0xffa0a6d2, 0xffa1a8d5, 0xff9fa6d2, 0xff9ea6d2,
    0xff9ba4d2, 0xff9aa2d0, 0xff98a4d1, 0xff97a0d1, 0xff959fd1, 0xff949dcf, 0xff949dcf, 0xff929dce,
    0xff919acc, 0xff949bcc, 0xff969dce, 0xff949bcd, 0xff959cd0, 0xff939ace, 0xff949ace, 0xff9299ce,
    0xff8f99cc, 0xff8b97cf, 0xff8497d0, 0xff8096cf, 0xff7c96cf, 0xff7795d0, 0xff7194d2, 0xff6e90d1,
    0xff6d8dd1, 0xff6a8bcf, 0xff6787ce, 0xff6984cc, 0xff6884cd, 0xff6884cc, 0xff6584ca, 0xff6383ca,
    0xff6182c9, 0xff5b7fcc, 0xff587dcc, 0xff587ccb, 0xff547cc6, 0xff5479c5, 0xff5377c3, 0xff5174c2,
    0xff8496c4, 0xff8597c5, 0xff8798c6, 0xff8797c5, 0xff8797c5, 0xff8698c7, 0xff889ac9, 0xff8698c9,
    0xff889bcb, 0xff8a9ccc, 0xff8ea0d0, 0xff90a4cf, 0xff96a9cf, 0xff9dabcf, 0xffa2b0ce, 0xffa5afce,
    0xffa7afcf, 0xffa8b0d0, 0xffabafce, 0xffaaafce, 0xffaaaecf, 0xffaaaed2, 0xffaaadd0, 0xffa9afd0,
    0xffa7acd1, 0xffa7add1, 0xffa9aed1, 0xffa8aed3, 0xffa8aed5, 0xffa8aed4, 0xffa9add4, 0xffa7acd4,
    0xffa7aed4, 0xffa4acd1, 0xffa3abd3, 0xffa1a8d4, 0xffa0a7d2, 0xffa1a8d5, 0xff9fa6d2, 0xff9ea7d3,
    0xff9ba4d2, 0xff9aa2d0, 0xff98a4d1, 0xff96a0d1, 0xff959fd1, 0xff939dcf, 0xff939dce, 0xff909dce,
    0xff909acc, 0xff919acc, 0xff929dcd, 0xff909acd, 0xff9099d0, 0xff8f98cd, 0xff9097cd, 0xff8d95ce,
    0xff8b95cc, 0xff8a93ce, 0xff8594d0, 0xff8695ce, 0xff8195cd, 0xff7c95ce, 0xff7695cf, 0xff7594cf,
    0xff7391ce, 0xff6e8ece, 0xff6a8acd, 0xff6986cc, 0xff6884ce, 0xff6784cc, 0xff6584cb, 0xff6383cb,
    0xff6283c9, 0xff5c80cc, 0xff597ecd, 0xff597dcb, 0xff557cc6, 0xff5579c5, 0xff5378c3, 0xff5275c2,
    0xff8597c4, 0xff8697c5, 0xff8899c6, 0xff8798c7, 0xff8898c6, 0xff8799c8, 0xff889aca, 0xff8799ca,
    0xff8a9ccc, 0xff8b9ecd, 0xff8fa3cf, 0xff94a6cd, 0xff99aace, 0xff9faccc, 0xffa3b0cd, 0xffa6aece,
    0xffa8aecd, 0xffa9aecf, 0xffa9adce, 0xffa9adcd, 0xffa8acd0, 0xffa8acd1, 0xffa8acd1, 0xffa7add0,
    0xffa7acd2, 0xffa5add2, 0xffa6add1, 0xffa7add3, 0xffa7aed4, 0xffa7aed4, 0xffa7add4, 0xffa5add3,
    0xffa5add4, 0xffa4acd2, 0xffa3abd2, 0xffa1a8d4, 0xffa0a8d1, 0xffa0a7d4, 0xff9fa7d2, 0xff9fa8d3,
    0xff9da5d1, 0xff9aa3d1, 0xff98a4d1, 0xff96a1d2, 0xff94a1d2, 0xff939ed0, 0xff929dce, 0xff8f9dcd,
    0xff8f9acd, 0xff8f9acc, 0xff919bcd, 0xff8e99ce, 0xff8d98cf, 0xff8b97cb, 0xff8b95ce, 0xff8892ce,
    0xff8793cd, 0xff8892cd, 0xff8492cd, 0xff8893cc, 0xff8594cc, 0xff8095cc, 0xff7b94cd, 0xff7b95cd,
    0xff7994cc, 0xff7391cd, 0xff6f8dcc, 0xff6b89cd, 0xff6887cf, 0xff6584cc, 0xff6383cd, 0xff6283ce,
    0xff6182cc, 0xff5c81cc, 0xff5b7fcd, 0xff597ecb, 0xff567bc6, 0xff567ac6, 0xff5479c4, 0xff5377c1,
    0xff8598c4, 0xff8797c4, 0xff8899c6, 0xff8799c9, 0xff889ac8, 0xff8999c9, 0xff899bcb, 0xff889bca,
    0xff8d9dcc, 0xff8da0ce, 0xff92a5cd, 0xff98a8cc, 0xff9caacd, 0xffa1abcb, 0xffa3adcd, 0xffa7accd,
    0xffa8accc, 0xffa8abce, 0xffa6abce, 0xffa7accc, 0xffa6aad1, 0xffa6abd0, 0xffa7acd1, 0xffa6acd1,
    0xffa6add2, 0xffa5aed3, 0xffa4add2, 0xffa7add3, 0xffa6aed3, 0xffa7afd4, 0xffa5add3, 0xffa5aed2,
    0xffa4acd3, 0xffa5acd4, 0xffa3abd1, 0xffa3a9d3, 0xffa1a9d1, 0xffa0a7d2, 0xffa0a9d3, 0xffa0a9d3,
    0xff9ea7d1, 0xff9aa4d3, 0xff99a4d1, 0xff98a3d2, 0xff95a2d2, 0xff95a0d1, 0xff929ecf, 0xff909ecd,
    0xff909ccd, 0xff8e9bcd, 0xff909acd, 0xff8d9acf, 0xff8c97ce, 0xff8897cb, 0xff8793d0, 0xff8491cd,
    0xff8491ce, 0xff8591cd, 0xff8190cb, 0xff8791cb, 0xff8692cd, 0xff8293cc, 0xff7d92cc, 0xff7f94cb,
    0xff7d95ca, 0xff7993cb, 0xff7690cb, 0xff6d8dcd, 0xff698acf, 0xff6385cd, 0xff6182ce, 0xff6082d0,
    0xff5f81cf, 0xff5c81cd, 0xff5c7fcd, 0xff597eca, 0xff587bc7, 0xff577bc7, 0xff567ac6, 0xff5478c0,
    0xff8598c4, 0xff8797c4, 0xff8899c7, 0xff879ac9, 0xff889ac9, 0xff899bc9, 0xff8a9ccb, 0xff8b9eca,
    0xff8f9fcb, 0xff90a3cd, 0xff95a7cb, 0xff9ca8ca, 0xff9ea9cc, 0xffa1a9c9, 0xffa3aacc, 0xffa5aacd,
    0xffa6a9cb, 0xffa6a9cd, 0xffa4a9ce, 0xffa5aacc, 0xffa4aad1, 0xffa4abd0, 0xffa5acd1, 0xffa4acd1,
    0xffa5add2, 0xffa5aed3, 0xffa4add2, 0xffa7add3, 0xffa6aed3, 0xffa7afd4, 0xffa5add3, 0xffa5aed2,
    0xffa4acd3, 0xffa5acd4, 0xffa3abd1, 0xffa3aad3, 0xffa1aad1, 0xffa0a8d2, 0xffa0a9d3, 0xffa0a9d2,
    0xff9fa7d1, 0xff9aa6d3, 0xff99a5d1, 0xff98a5d1, 0xff96a4d2, 0xff95a2d1, 0xff929fcf, 0xff929ecd,
    0xff909ccd, 0xff8e9bcd, 0xff8f9acd, 0xff8c9acf, 0xff8a97ce, 0xff8696cc, 0xff8392d0, 0xff8291cd,
    0xff8290ce, 0xff8391cd, 0xff808fca, 0xff828fcb, 0xff8490cd, 0xff8291cc, 0xff7f90ca, 0xff8192ca,
    0xff8095c9, 0xff7e95ca, 0xff7b92cb, 0xff7291cc, 0xff6b8dcf, 0xff6388cd, 0xff5f83d0, 0xff5e82d2,
    0xff5e81d1, 0xff5c81ce, 0xff5c7fcd, 0xff597eca, 0xff587cc7, 0xff577cc7, 0xff567ac6, 0xff557ac1,
    0xff8698c5, 0xff8797c5, 0xff8999c8, 0xff889bc9, 0xff889bc9, 0xff899cc9, 0xff8b9eca, 0xff8ea1c9,
    0xff90a1ca, 0xff94a5ca, 0xff98a8ca, 0xff9ea8ca, 0xff9fa7cb, 0xff9fa7c9, 0xffa1a7cc, 0xffa2a7cc,
    0xffa3a7cb, 0xffa4a7cd, 0xffa2a8cd, 0xffa3aacd, 0xffa2aad0, 0xffa3abd0, 0xffa3acd1, 0xffa4acd1,
    0xffa3add1, 0xffa6aed3, 0xffa4add2, 0xffa6add2, 0xffa6aed3, 0xffa6afd4, 0xffa5aed3, 0xffa6aed3,
    0xffa4acd2, 0xffa4add2, 0xffa4acd2, 0xffa4abd2, 0xffa2abd2, 0xffa1a9d2, 0xffa1aad3, 0xffa0a8d1,
    0xff9fa8d2, 0xff9aa8d2, 0xff99a6d0, 0xff99a6d0, 0xff97a4d1, 0xff95a2d1, 0xff94a1d0, 0xff939fce,
    0xff909dcc, 0xff8f9cce, 0xff8e9ace, 0xff8a9ace, 0xff8997cf, 0xff8696ce, 0xff8192cf, 0xff8191ce,
    0xff8291cd, 0xff8191cd, 0xff808fca, 0xff7c8ccc, 0xff7f8dcc, 0xff7f8fcb, 0xff7f8eca, 0xff8190ca,
    0xff8292c9, 0xff8195ca, 0xff7f93ca, 0xff7693ca, 0xff6e8ece, 0xff658bce, 0xff5e85d0, 0xff5c82d3,
    0xff5d80d2, 0xff5d7fd0, 0xff5c7fcc, 0xff5a7fca, 0xff597ec8, 0xff567dc8, 0xff577bc6, 0xff557ac3,
    0xff8698c6, 0xff8798c6, 0xff8a9aca, 0xff8a9cc8, 0xff899cc9, 0xff8a9ec9, 0xff8da0c9, 0xff91a3c8,
    0xff92a3c8, 0xff97a6c7, 0xff9ba7c9, 0xff9ea6ca, 0xff9ea4ca, 0xff9ca4ca, 0xff9ea4cb, 0xff9ea5cb,
    0xffa0a5cb, 0xffa1a6cc, 0xffa1a7cd, 0xffa1a9cd, 0xffa1aacf, 0xffa2abd0, 0xffa2acd0, 0xffa3acd1,
    0xffa2add0, 0xffa6aed3, 0xffa5add2, 0xffa5add2, 0xffa6aed3, 0xffa6aed3, 0xffa6aed3, 0xffa6aed3,
    0xffa4add2, 0xffa4add1, 0xffa4acd3, 0xffa4acd2, 0xffa3acd2, 0xffa2abd2, 0xffa1aad2, 0xffa0a8d0,
    0xff9ea8d2, 0xff9ba9d1, 0xff9aa7d0, 0xff99a6cf, 0xff98a4d0, 0xff95a3d1, 0xff95a2d0, 0xff94a0cf,
    0xff919dcc, 0xff909ccf, 0xff8d9acf, 0xff899acd, 0xff8897cf, 0xff8695d1, 0xff8193ce, 0xff8292ce,
    0xff8291cc, 0xff8091cc, 0xff7f90cb, 0xff768bcd, 0xff7a8bcc, 0xff7c8dcb, 0xff7e8dca, 0xff7f8eca,
    0xff818fca, 0xff8293c9, 0xff8092ca, 0xff7993c8, 0xff708fcd, 0xff688ece, 0xff5e87d0, 0xff5c83d3,
    0xff5e81d2, 0xff5d7fd1, 0xff5c7fcc, 0xff5b7fca, 0xff597fc9, 0xff567dc8, 0xff577bc6, 0xff567ac6,
    0xff8698c6, 0xff8799c7, 0xff8b9bcb, 0xff8b9ec9, 0xff8b9ec8, 0xff8da0c8, 0xff8fa1c9, 0xff93a4c8,
    0xff95a4c7, 0xff99a5c6, 0xff9ca6c9, 0xff9da4c9, 0xff9da2ca, 0xff9aa2ca, 0xff9ca2cb, 0xff9ca4ca,
    0xff9fa5cb, 0xffa0a6cc, 0xffa0a7cd, 0xffa0a8cc, 0xffa1a9cf, 0xffa2aacf, 0xffa1abcf, 0xffa2abd0,
    0xffa2accf, 0xffa6aed3, 0xffa5add2, 0xffa5add2, 0xffa6aed3, 0xffa6aed3, 0xffa6aed3, 0xffa6aed3,
    0xffa5aed2, 0xffa4add1, 0xffa4acd3, 0xffa5add2, 0xffa4acd2, 0xffa3acd3, 0xffa1aad1, 0xffa0a8d0,
    0xff9ea8d2, 0xff9ca9d1, 0xff9ba7d1, 0xff9aa6cf, 0xff99a4d0, 0xff96a3d1, 0xff96a2d0, 0xff95a0d0,
    0xff929dcc, 0xff919cd0, 0xff8d9acf, 0xff8a9acd, 0xff8797cf, 0xff8595d2, 0xff8293ce, 0xff8393ce,
    0xff8191cc, 0xff7f91cb, 0xff7d90cb, 0xff748acd, 0xff7889cd, 0xff7a8ccb, 0xff7c8cca, 0xff7d8dc9,
    0xff808dc9, 0xff8191c8, 0xff7f90ca, 0xff7a91c7, 0xff728fcb, 0xff6b8fce, 0xff5f88d0, 0xff5d85d2,
    0xff5e83d1, 0xff5d80d0, 0xff5b7fcc, 0xff5a7eca, 0xff597fca, 0xff577dc8, 0xff577bc7, 0xff567ac7,
    0xff8698c7, 0xff889ac8, 0xff8b9dcb, 0xff8ca0ca, 0xff8ea1c8, 0xff90a2c8, 0xff90a2c8, 0xff95a4c8,
    0xff98a4c7, 0xff9aa3c7, 0xff9ca4c9, 0xff9ba2c9, 0xff9ca1ca, 0xff99a1ca, 0xff9aa1cc, 0xff9ba3ca,
    0xff9fa6cc, 0xff9fa7cd, 0xff9ea7cd, 0xff9fa7cb, 0xffa1a8ce, 0xffa2a9cf, 0xffa0aacf, 0xffa1abcf,
    0xffa3accf, 0xffa5add2, 0xffa5add2, 0xffa5add2, 0xffa5add2, 0xffa6add2, 0xffa6aed3, 0xffa5add2,
    0xffa6aed3, 0xffa5add2, 0xffa4acd2, 0xffa5add2, 0xffa4abd1, 0xffa4acd4, 0xffa2aad0, 0xff9fa9d1,
    0xff9fa8d1, 0xff9ca8d2, 0xff9da7d2, 0xff9aa6d0, 0xff99a4d1, 0xff97a4d1, 0xff97a2cf, 0xff95a1d0,
    0xff929ecd, 0xff919dd1, 0xff8d9bcf, 0xff8b9bcd, 0xff8797ce, 0xff8495d2, 0xff8494ce, 0xff8495ce,
    0xff7f91cc, 0xff7d91ca, 0xff7b8fca, 0xff768bcd, 0xff7789ce, 0xff798dcc, 0xff7a8bcb, 0xff7b8cc8,
    0xff7d8cc8, 0xff7f8dc8, 0xff7c8dc9, 0xff798dc8, 0xff728eca, 0xff6d8ecd, 0xff6189cf, 0xff5e88d0,
    0xff5f85cf, 0xff5d81cf, 0xff5a7ecd, 0xff597dca, 0xff597ecb, 0xff577cc8, 0xff587cc7, 0xff567bc7,
    0xff8799c7, 0xff899bc9, 0xff8ca0ca, 0xff8fa3ca, 0xff91a3c7, 0xff94a3c7, 0xff93a2c8, 0xff97a3c8,
    0xff99a3c7, 0xff9aa1c8, 0xff9ba2c9, 0xff99a1c9, 0xff99a1cb, 0xff98a0cb, 0xff98a1cc, 0xff9aa3ca,
    0xff9ea6cd, 0xff9ea7cd, 0xff9da7cd, 0xff9fa6cb, 0xffa0a7ce, 0xffa2a9ce, 0xffa0a9ce, 0xffa0aace,
    0xffa3abcf, 0xffa4add2, 0xffa5add2, 0xffa5add2, 0xffa5add2, 0xffa6add2, 0xffa6aed3, 0xffa5add2,
    0xffa6aed3, 0xffa5add2, 0xffa4acd1, 0xffa5add2, 0xffa4abd1, 0xffa4acd4, 0xffa2aad0, 0xff9fa9d1,
    0xff9fa8d1, 0xff9da7d2, 0xff9ea7d2, 0xff9ba6d1, 0xff99a4d1, 0xff98a4d1, 0xff97a2cf, 0xff95a1d0,
    0xff939ece, 0xff919dd1, 0xff8e9bcf, 0xff8c9bce, 0xff8797ce, 0xff8496d1, 0xff8595ce, 0xff8596ce,
    0xff7f91cc, 0xff7d91ca, 0xff7a8fca, 0xff778ccc, 0xff7789ce, 0xff788dcc, 0xff788bcb, 0xff788bc8,
    0xff798bc8, 0xff7b8ac7, 0xff788ac9, 0xff7689ca, 0xff728bc9, 0xff6e8ccc, 0xff6489ce, 0xff6289ce,
    0xff6188cd, 0xff5e83cd, 0xff5a7fcd, 0xff597dca, 0xff597dcb, 0xff587cc8, 0xff587cc8, 0xff577bc7,
    0xff899bc9, 0xff8b9ecb, 0xff8ea2c8, 0xff91a5c8, 0xff94a4c7, 0xff95a4c6, 0xff95a2c7, 0xff98a1c8,
    0xff99a0c8, 0xff9aa0c9, 0xff9aa0c9, 0xff97a0ca, 0xff96a1cc, 0xff96a0cd, 0xff96a1cc, 0xff99a3cb,
    0xff9ba5ce, 0xff9ca6cd, 0xff9ba6cc, 0xff9ea6cc, 0xff9ea7ce, 0xffa0aace, 0xff9fa8ce, 0xffa0aace,
    0xffa3abd0, 0xffa3add1, 0xffa5add2, 0xffa5add2, 0xffa6aed3, 0xffa6aed3, 0xffa6aed3, 0xffa4acd1,
    0xffa6aed3, 0xffa5add2, 0xffa4acd1, 0xffa4acd1, 0xffa4abd0, 0xffa4acd4, 0xffa2aad0, 0xffa0a9d1,
    0xffa0a9d1, 0xff9ea7d3, 0xff9ea6d2, 0xff9da6d1, 0xff98a5cf, 0xff99a4d1, 0xff98a2cf, 0xff96a2d0,
    0xff949fcf, 0xff919dd0, 0xff8e9bd0, 0xff8c9bcf, 0xff8898ce, 0xff8597cf, 0xff8697ce, 0xff8596cd,
    0xff8092cc, 0xff7d91ca, 0xff7c90cb, 0xff788eca, 0xff778bcd, 0xff788dcd, 0xff768bcb, 0xff758aca,
    0xff7689c9, 0xff7989c6, 0xff7688ca, 0xff7286cc, 0xff6f88c9, 0xff6e89cb, 0xff6789cd, 0xff668acb,
    0xff648acb, 0xff5f85cb, 0xff5a81cc, 0xff597dcb, 0xff597cca, 0xff587cc9, 0xff587dc9, 0xff597cc6,
    0xff8a9eca, 0xff8da1cb, 0xff90a4c7, 0xff94a6c6, 0xff96a4c7, 0xff96a3c6, 0xff97a1c6, 0xff999fc7,
    0xff979ec8, 0xff989fc9, 0xff989fca, 0xff969fcb, 0xff94a1cc, 0xff94a1ce, 0xff95a2cc, 0xff98a3cd,
    0xff98a4cf, 0xff9aa4cc, 0xff9aa4cc, 0xff9ea6cd, 0xff9ca8cd, 0xff9faace, 0xff9fa8cd, 0xffa0aace,
    0xffa3aad0, 0xffa2acd0, 0xffa4acd1, 0xffa5add2, 0xffa7afd4, 0xffa6aed3, 0xffa5add2, 0xffa4acd1,
    0xffa5add2, 0xffa4acd1, 0xffa4acd1, 0xffa3abd0, 0xffa3abd0, 0xffa4acd3, 0xffa2a9d1, 0xffa1a8d1,
    0xffa0a9d2, 0xff9fa8d3, 0xff9da6d1, 0xff9ea6d1, 0xff98a6ce, 0xff99a5d0, 0xff98a3cf, 0xff96a2cf,
    0xff94a0d0, 0xff919dcf, 0xff8f9cd2, 0xff8c9bd0, 0xff8899ce, 0xff8698ce, 0xff8798cd, 0xff8495cb,
    0xff8193cc, 0xff7d92cb, 0xff7e92cb, 0xff798fc8, 0xff788dcb, 0xff788dcd, 0xff758bcb, 0xff738acc,
    0xff7388c9, 0xff7688c6, 0xff7486ca, 0xff6e83ce, 0xff6d85ca, 0xff6d87c9, 0xff6a88cc, 0xff6b89ca,
    0xff688aca, 0xff6087ca, 0xff5b83cb, 0xff5a7ecb, 0xff597cc9, 0xff587cca, 0xff587dca, 0xff5b7cc5,
    0xff8ca1ca, 0xff90a4ca, 0xff93a6c6, 0xff96a6c6, 0xff98a4c7, 0xff96a3c6, 0xff97a0c6, 0xff979dc7,
    0xff949cc8, 0xff959ec8, 0xff959eca, 0xff949fcb, 0xff92a1cc, 0xff93a1ce, 0xff94a2cc, 0xff97a3ce,
    0xff96a3cf, 0xff98a4cc, 0xff98a4cc, 0xff9ca5cd, 0xff9aa8cd, 0xff9daace, 0xff9fa8cd, 0xffa0aace,
    0xffa3aad0, 0xffa2acd0, 0xffa4acd1, 0xffa5add2, 0xffa7afd4, 0xffa5add2, 0xffa4acd1, 0xffa4acd1,
    0xffa5add2, 0xffa4acd1, 0xffa4acd1, 0xffa3abd0, 0xffa3abd0, 0xffa4acd1, 0xffa2a9d1, 0xffa1a8d1,
    0xffa0a9d2, 0xff9fa8d3, 0xff9da6d1, 0xff9ea6d1, 0xff98a6ce, 0xff99a5d0, 0xff98a3cf, 0xff96a2cf,
    0xff94a0d0, 0xff929ecf, 0xff8f9cd2, 0xff8c9bd0, 0xff8a9bce, 0xff8899cd, 0xff8798cd, 0xff8495cb,
    0xff8394cc, 0xff7f92cb, 0xff8092cb, 0xff7b91c8, 0xff788fc9, 0xff788dcc, 0xff748bcb, 0xff718acc,
    0xff7188c9, 0xff7488c7, 0xff7185ca, 0xff6c83cd, 0xff6b83ca, 0xff6d85c8, 0xff6d86ca, 0xff6e89c8,
    0xff6b89c7, 0xff6387c7, 0xff5e85c8, 0xff5c80cb, 0xff597dc8, 0xff587cc9, 0xff587dca, 0xff5b7cc6,
    0xff8ca3c8, 0xff94a6c8, 0xff95a5c5, 0xff97a6c6, 0xff97a4c6, 0xff96a2c6, 0xff959fc6, 0xff939cc6,
    0xff919cc7, 0xff939dc7, 0xff939eca, 0xff929ecc, 0xff92a1cc, 0xff93a0cd, 0xff93a1cc, 0xff96a2ce,
    0xff95a3cf, 0xff97a4cd, 0xff98a4cd, 0xff99a4cc, 0xff9aa7cc, 0xff9da9cd, 0xff9fa8cc, 0xffa0aace,
    0xffa2a9cf, 0xffa2abcf, 0xffa4acd1, 0xffa4acd1, 0xffa5add2, 0xffa4acd1, 0xffa3abd0, 0xffa4acd1,
    0xffa4acd2, 0xffa3abd1, 0xffa4acd0, 0xffa3abd0, 0xffa2aad0, 0xffa3abd0, 0xffa1a9d0, 0xffa1a7d0,
    0xff9fa9d1, 0xff9ea7d2, 0xff9ea7d2, 0xff9ca7d1, 0xff9aa6d0, 0xff99a6d0, 0xff97a4ce, 0xff95a1cf,
    0xff94a0d0, 0xff939fcf, 0xff8f9cd2, 0xff8c9bd1, 0xff8b9ccf, 0xff899acd, 0xff8798cd, 0xff8596cb,
    0xff8495cb, 0xff8292cb, 0xff8092ca, 0xff7c91c9, 0xff798fc8, 0xff778dc9, 0xff738acb, 0xff7089ca,
    0xff6f89c7, 0xff7287c8, 0xff6f85c9, 0xff6d84c9, 0xff6b82c8, 0xff6d84c8, 0xff6f85c9, 0xff6f88c7,
    0xff6c87c5, 0xff6787c5, 0xff6186c5, 0xff5d83c9, 0xff587fc8, 0xff577cc8, 0xff577cca, 0xff5b7bc7,
    0xff8ea4c6, 0xff96a6c6, 0xff97a4c6, 0xff97a5c7, 0xff96a3c6, 0xff95a1c6, 0xff929ec6, 0xff909cc6,
    0xff8f9cc6, 0xff909cc6, 0xff909dca, 0xff919ecc, 0xff92a0cc, 0xff93a0cc, 0xff93a0cc, 0xff95a1ce,
    0xff95a2ce, 0xff96a4cd, 0xff97a4ce, 0xff97a3cc, 0xff9aa6cc, 0xff9da7cd, 0xff9fa8cb, 0xffa0a9ce,
    0xffa1a8ce, 0xffa2aacf, 0xffa3abd0, 0xffa3abd0, 0xffa3abd0, 0xffa2aacf, 0xffa2aacf, 0xffa4acd1,
    0xffa3abd2, 0xffa2aad1, 0xffa4acd0, 0xffa3abd1, 0xffa1a9d0, 0xffa2aacf, 0xffa0a9d0, 0xffa0a7d0,
    0xff9fa8d1, 0xff9ea6d1, 0xff9ea8d3, 0xff9ba7d1, 0xff9ba6d1, 0xff99a6d0, 0xff97a4ce, 0xff95a1cf,
    0xff94a0d0, 0xff94a0d0, 0xff909dd1, 0xff8d9bd1, 0xff8c9cd0, 0xff8a9acd, 0xff8898cd, 0xff8797cb,
    0xff8596ca, 0xff8493cb, 0xff8092c9, 0xff7e91ca, 0xff7a8fc7, 0xff778dc7, 0xff7389cb, 0xff7089c8,
    0xff6f89c6, 0xff7187c9, 0xff6d85c8, 0xff6e85c6, 0xff6c82c7, 0xff6d83c7, 0xff6f83c7, 0xff6f86c6,
    0xff6d84c2, 0xff6a86c2, 0xff6586c2, 0xff6085c6, 0xff5981c7, 0xff587dc5, 0xff577cc9, 0xff5a7bc8,
    0xff91a4c6, 0xff96a5c5, 0xff98a4c7, 0xff97a4c7, 0xff95a2c6, 0xff949fc6, 0xff919dc7, 0xff8f9cc6,
    0xff8e9cc7, 0xff8f9cc6, 0xff8f9dca, 0xff909ecc, 0xff92a0cc, 0xff93a0cc, 0xff93a0cc, 0xff94a0ce,
    0xff95a2ce, 0xff95a3cd, 0xff96a3ce, 0xff97a2cd, 0xff99a6cd, 0xff9ca6cd, 0xff9fa8cb, 0xffa0a8cd,
    0xffa1a8ce, 0xffa2aacf, 0xffa2aacf, 0xffa2abcf, 0xffa2aacf, 0xffa2aace, 0xffa2aace, 0xffa3abd1,
    0xffa3abd2, 0xffa2aad2, 0xffa3abd1, 0xffa2abd1, 0xffa1a9d0, 0xffa1a9cf, 0xffa0a9d0, 0xff9fa7d1,
    0xff9fa8d2, 0xff9ea6d1, 0xff9ea8d3, 0xff9ca7d1, 0xff9ca6d1, 0xff9aa6d0, 0xff97a4cf, 0xff95a2cf,
    0xff95a1d1, 0xff95a0d1, 0xff919ed0, 0xff8e9cd1, 0xff8d9bd0, 0xff8b99cd, 0xff8999cd, 0xff8896cb,
    0xff8596c9, 0xff8494cb, 0xff8193c9, 0xff7f92c9, 0xff7b8fc8, 0xff778cc6, 0xff7389cb, 0xff7089c8,
    0xff6f88c6, 0xff6f86c9, 0xff6c85c8, 0xff6d85c6, 0xff6c82c6, 0xff6c82c7, 0xff6e82c6, 0xff6e84c5,
    0xff6d82c1, 0xff6c84c0, 0xff6986c0, 0xff6485c3, 0xff5c82c5, 0xff5a7fc3, 0xff587dc8, 0xff597bc7,
    0xff94a2c6, 0xff94a3c4, 0xff97a3c8, 0xff95a2c6, 0xff95a1c6, 0xff939ec6, 0xff909dc8, 0xff8f9cc7,
    0xff8f9dc8, 0xff8f9cc7, 0xff8f9dca, 0xff909ecb, 0xff929fcc, 0xff93a0cd, 0xff94a1cc, 0xff93a0cd,
    0xff95a2cd, 0xff95a3cd, 0xff96a2cd, 0xff97a2ce, 0xff99a5ce, 0xff9ca5cd, 0xff9ea8cb, 0xff9fa8cc,
    0xffa0a8cd, 0xffa1aace, 0xffa1aacf, 0xffa1aace, 0xffa1a9ce, 0xffa2aace, 0xffa2aace, 0xffa2aad0,
    0xffa3abd2, 0xffa2aad2, 0xffa2a9d2, 0xffa1aad1, 0xffa1a9d1, 0xffa1a9cf, 0xffa0a8d1, 0xff9ea8d3,
    0xffa0a7d4, 0xff9fa6d2, 0xff9ea8d3, 0xff9da7d2, 0xff9da5d1, 0xff9ba6cf, 0xff97a4cf, 0xff96a3d0,
    0xff96a2d2, 0xff95a0d1, 0xff929fd0, 0xff8f9dd0, 0xff8e9ad0, 0xff8b97ce, 0xff8b9acc, 0xff8995cc,
    0xff8595c9, 0xff8495ca, 0xff8394c9, 0xff8092c8, 0xff7b8fc9, 0xff788cc7, 0xff7489ca, 0xff7189c8,
    0xff6f87c7, 0xff6e86c9, 0xff6d84c8, 0xff6d84c7, 0xff6c82c5, 0xff6c82c7, 0xff6c81c6, 0xff6c81c5,
    0xff6d81c1, 0xff6c82bf, 0xff6d85bf, 0xff6983bf, 0xff5f82c2, 0xff5d80c2, 0xff597ec6, 0xff587bc5,
    0xff95a1c6, 0xff93a1c4, 0xff96a2c8, 0xff94a0c6, 0xff94a0c6, 0xff929dc6, 0xff909dc8, 0xff8f9cc8,
    0xff8f9dc9, 0xff8f9cc8, 0xff8f9dca, 0xff909ecb, 0xff929fcc, 0xff93a0cd, 0xff94a1cc, 0xff93a0cd,
    0xff95a2cd, 0xff95a2cd, 0xff95a1cd, 0xff97a2cf, 0xff98a5ce, 0xff9ba4cd, 0xff9da8cb, 0xff9ea7cb,
    0xffa0a8cd, 0xffa1aace, 0xffa0a9ce, 0xffa0aacd, 0xffa1a9ce, 0xffa2aace, 0xffa2aace, 0xffa1a9d0,
    0xffa3abd2, 0xffa2aad2, 0xffa1a8d2, 0xffa0a9d1, 0xffa1a9d1, 0xffa0a8cf, 0xffa0a8d1, 0xff9ea8d3,
    0xffa0a7d4, 0xff9fa7d2, 0xff9ea8d3, 0xff9ea7d2, 0xff9da5d1, 0xff9ba6cf, 0xff98a4d0, 0xff97a3d0,
    0xff96a3d2, 0xff95a0d1, 0xff939fcf, 0xff909dd0, 0xff8f9ad0, 0xff8c97ce, 0xff8c9acc, 0xff8a95cc,
    0xff8695c9, 0xff8495ca, 0xff8494c9, 0xff8192c7, 0xff7c8fca, 0xff798cc7, 0xff758ac9, 0xff7289c8,
    0xff7087c7, 0xff6e86c8, 0xff6d84c8, 0xff6c83c7, 0xff6c82c5, 0xff6b82c7, 0xff6a81c5, 0xff6a7fc4,
    0xff6c80c1, 0xff6c80be, 0xff6e83bd, 0xff6c81bb, 0xff6382be, 0xff6081bf, 0xff5b7ec2, 0xff587bc1,
    0xff94a0c6, 0xff929fc4, 0xff95a0c7, 0xff929ec5, 0xff93a0c6, 0xff929dc7, 0xff909dc8, 0xff8f9cc9,
    0xff8f9dc9, 0xff8f9cc9, 0xff8f9cca, 0xff909ecb, 0xff919ecc, 0xff929fcd, 0xff94a1cd, 0xff93a0cd,
    0xff94a1cc, 0xff95a2cd, 0xff94a0cc, 0xff96a2cf, 0xff97a4cc, 0xff9aa3cb, 0xff9ca6cc, 0xff9ca6cb,
    0xff9fa8cc, 0xffa0a9cd, 0xff9fa8cd, 0xffa0a8cc, 0xffa0a9ce, 0xffa1a9ce, 0xffa2a9cf, 0xffa1a9d0,
    0xffa2aad1, 0xffa1a9d0, 0xffa0a7d1, 0xff9fa7d1, 0xffa0a7d1, 0xff9fa6d0, 0xff9fa8d1, 0xff9ea7d2,
    0xffa0a8d3, 0xff9fa8d0, 0xff9ea8d2, 0xff9ea7d2, 0xff9da4d1, 0xff9ba5cf, 0xff99a3d0, 0xff98a3d1,
    0xff96a2d1, 0xff96a0cf, 0xff939fce, 0xff919dd0, 0xff909bd0, 0xff8e99cf, 0xff8d9acd, 0xff8a96cc,
    0xff8895ca, 0xff8595c9, 0xff8394c8, 0xff8292c6, 0xff7d8fcb, 0xff798ec7, 0xff768bc8, 0xff7489c6,
    0xff7188c6, 0xff6f87c6, 0xff6e84c7, 0xff6c83c7, 0xff6b82c5, 0xff6a81c5, 0xff6980c3, 0xff697ec2,
    0xff6a7ebf, 0xff6b7ebc, 0xff6d80ba, 0xff6c80b9, 0xff6681bb, 0xff6280bc, 0xff5e7ebe, 0xff597cbe,
    0xff919ec5, 0xff919ec4, 0xff939fc6, 0xff909dc5, 0xff92a0c6, 0xff929ec8, 0xff909dc8, 0xff909dc9,
    0xff909dc9, 0xff8f9cc9, 0xff8f9cc9, 0xff919ecb, 0xff919ecb, 0xff929fcd, 0xff94a1cd, 0xff94a1cd,
    0xff93a0cb, 0xff95a2cd, 0xff93a0cc, 0xff94a2ce, 0xff95a3cb, 0xff98a2ca, 0xff9ba5cd, 0xff9ba5cb,
    0xff9da7cc, 0xff9fa7cc, 0xff9fa8cd, 0xffa0a7cc, 0xffa0a9ce, 0xff9fa7cf, 0xffa1a8cf, 0xffa1aacf,
    0xffa1a9d0, 0xffa0a7cf, 0xff9fa6d0, 0xff9ea6d0, 0xff9fa6d0, 0xff9ea5d0, 0xff9ea7d0, 0xff9ea6d1,
    0xff9fa8d1, 0xff9fa9cf, 0xff9ea7d1, 0xff9ea6d2, 0xff9da4d1, 0xff9ba4d0, 0xff9aa3d0, 0xff9aa2d1,
    0xff96a1d0, 0xff96a0cd, 0xff939fce, 0xff919dd0, 0xff909ccf, 0xff8f9acf, 0xff8d9ace, 0xff8a97cc,
    0xff8996cb, 0xff8694c9, 0xff8394c7, 0xff8291c6, 0xff7e8fca, 0xff7a8fc7, 0xff778cc7, 0xff768ac4,
    0xff7389c4, 0xff7088c4, 0xff6e85c6, 0xff6c83c6, 0xff6a83c4, 0xff6a81c3, 0xff6880c2, 0xff697ec1,
    0xff687dbd, 0xff697cbb, 0xff6a7eb7, 0xff6b7fb8, 0xff677fb8, 0xff647fb8, 0xff5f7dbb, 0xff5b7cba,
    0xff8e9bc5, 0xff909cc4, 0xff919dc6, 0xff909dc5, 0xff919fc7, 0xff929ec9, 0xff919dc9, 0xff909dc9,
    0xff909dc9, 0xff8f9cc9, 0xff8f9cc9, 0xff919ecb, 0xff919ecb, 0xff929fcd, 0xff94a1cd, 0xff94a1cd,
    0xff93a0cc, 0xff95a2cd, 0xff93a0cc, 0xff94a2cd, 0xff94a1c9, 0xff97a2ca, 0xff99a4cd, 0xff9ba5cb,
    0xff9da7cc, 0xff9fa7cc, 0xff9fa8cd, 0xffa0a7cc, 0xffa0a9ce, 0xff9fa7cf, 0xffa0a8cf, 0xffa0aacf,
    0xffa0a9cf, 0xff9fa7ce, 0xff9ea6d0, 0xff9ca4d0, 0xff9ca5d0, 0xff9ca5d0, 0xff9ca6d0, 0xff9ca6d0,
    0xff9da7d0, 0xff9ea8ce, 0xff9da7d0, 0xff9da6d2, 0xff9ca4d1, 0xff9aa4d0, 0xff9aa3d0, 0xff9aa2d1,
    0xff96a1ce, 0xff95a0cd, 0xff939fce, 0xff919dd0, 0xff909cce, 0xff8f9bce, 0xff8d9ace, 0xff8a97cc,
    0xff8b96cb, 0xff8894c9, 0xff8494c7, 0xff8291c6, 0xff7e90c9, 0xff7b8fc7, 0xff798cc7, 0xff768ac3,
    0xff7489c4, 0xff7188c3, 0xff6e85c4, 0xff6c83c4, 0xff6a83c3, 0xff6a81c1, 0xff6880c0, 0xff687ebf,
    0xff667dbb, 0xff677bbb, 0xff687cb5, 0xff697db7, 0xff677db6, 0xff657db5, 0xff617db7, 0xff5d7cb7,
    0xff8c99c4, 0xff8f9bc5, 0xff8f9bc6, 0xff909cc6, 0xff909ec8, 0xff929eca, 0xff929fca, 0xff919eca,
    0xff919eca, 0xff909dca, 0xff909cc9, 0xff909ecb, 0xff929fcb, 0xff93a0cd, 0xff93a0cc, 0xff94a1cd,
    0xff93a1ce, 0xff95a1ce, 0xff94a0cc, 0xff94a1cc, 0xff93a0c9, 0xff96a3cb, 0xff98a4cb, 0xff9ca5cc,
    0xff9da7cc, 0xff9ea6cb, 0xff9fa8cc, 0xff9fa8cd, 0xff9fa8cf, 0xff9fa7cf, 0xff9fa9ce, 0xff9fa9cf,
    0xff9ea8ce, 0xff9ea7ce, 0xff9ca6d0, 0xff9aa4cf, 0xff99a4cf, 0xff99a5d0, 0xff99a5d0, 0xff9aa6cf,
    0xff9aa6d0, 0xff9ba6ce, 0xff9aa6d0, 0xff9ba6d1, 0xff9ba6d1, 0xff9aa4d0, 0xff99a4d0, 0xff9ba2d0,
    0xff96a2ce, 0xff939fcf, 0xff939ecf, 0xff919ecf, 0xff909dcd, 0xff8f9bcd, 0xff8d99cd, 0xff8b98cc,
    0xff8b97cb, 0xff8894c9, 0xff8694c9, 0xff8291c6, 0xff7e91c8, 0xff7c8dc8, 0xff7a8dc7, 0xff768ac3,
    0xff7488c4, 0xff7288c3, 0xff6d85c3, 0xff6c84c2, 0xff6a83c1, 0xff6981c0, 0xff677fc0, 0xff677ebe,
    0xff657dbb, 0xff657bbc, 0xff667bb6, 0xff677bb7, 0xff667bb7, 0xff657bb4, 0xff627cb5, 0xff607bb4,
    0xff8996c3, 0xff8d99c5, 0xff8d9ac6, 0xff8f9cc7, 0xff8f9cc9, 0xff929eca, 0xff929fcb, 0xff919eca,
    0xff919eca, 0xff909dca, 0xff909dc9, 0xff909ecb, 0xff929fcb, 0xff93a0cd, 0xff93a0cc, 0xff94a1cd,
    0xff93a1cf, 0xff95a1ce, 0xff95a1cd, 0xff94a1cc, 0xff93a0ca, 0xff96a4cc, 0xff97a4ca, 0xff9ca5cc,
    0xff9da6cc, 0xff9ea6cb, 0xff9ea7cc, 0xff9ea8ce, 0xff9fa7cf, 0xff9fa7ce, 0xff9ea9cd, 0xff9fa7ce,
    0xff9ea7cd, 0xff9fa7ce, 0xff9da6cf, 0xff9da4ce, 0xff9ba5cd, 0xff9ca6ce, 0xff9ca5ce, 0xff9da7ce,
    0xff9da5cf, 0xff9ea5ce, 0xff9da6ce, 0xff9ea6d0, 0xff9ea7d0, 0xff9ca5cf, 0xff9ba4cf, 0xff9ca3cf,
    0xff97a3ce, 0xff939fd0, 0xff949ecf, 0xff919ece, 0xff909dcc, 0xff8f9bcc, 0xff8d99cc, 0xff8c98cc,
    0xff8b97cb, 0xff8995c9, 0xff8894ca, 0xff8291c6, 0xff7f92c6, 0xff7d8cc8, 0xff7b8dc7, 0xff768bc4,
    0xff7588c4, 0xff7288c3, 0xff6d85c2, 0xff6c84c1, 0xff6b83c0, 0xff6981bf, 0xff677fbf, 0xff667ebd,
    0xff647dbc, 0xff647bbd, 0xff647ab7, 0xff657ab7, 0xff6479b7, 0xff6579b3, 0xff627bb3, 0xff617ab2,
    0xff8794c3, 0xff8a98c4, 0xff8c99c6, 0xff8e9bc8, 0xff8e9cc9, 0xff929eca, 0xff919eca, 0xff919dca,
    0xff919eca, 0xff909dca, 0xff919eca, 0xff909ecc, 0xff929ecb, 0xff939fcd, 0xff93a0cd, 0xff94a1cc,
    0xff93a1ce, 0xff95a1ce, 0xff95a2cd, 0xff94a1cd, 0xff93a0cb, 0xff96a5cc, 0xff97a4ca, 0xff9aa5cc,
    0xff9ca5cd, 0xff9da5cb, 0xff9ca6cc, 0xff9ca7cf, 0xff9da6cf, 0xff9ca6ce, 0xff9ba7ce, 0xff9ca4ce,
    0xff9ca4cd, 0xff9fa4ce, 0xff9ea3ce, 0xffa2a1cd, 0xffa2a1cb, 0xffa5a2cc, 0xffa6a1cb, 0xffa7a3cb,
    0xffa6a1cd, 0xffa7a1cc, 0xffa4a2cc, 0xffa3a2cf, 0xffa1a3cf, 0xff9da3cf, 0xff9aa2cf, 0xff99a2cf,
    0xff95a2cf, 0xff929fd1, 0xff929ed0, 0xff919ece, 0xff8f9dcd, 0xff8f9ccd, 0xff8d9acc, 0xff8d98cb,
    0xff8c97cb, 0xff8a96ca, 0xff8894ca, 0xff8292c6, 0xff8092c5, 0xff7d8dc8, 0xff7a8dc7, 0xff778cc5,
    0xff7589c4, 0xff7388c2, 0xff6e85c2, 0xff6c83c1, 0xff6b83c0, 0xff6981bf, 0xff6780be, 0xff657ebd,
    0xff627dbc, 0xff637abc, 0xff637ab8, 0xff6379b7, 0xff6279b6, 0xff6478b2, 0xff6279b1, 0xff6178b0,
    0xff8593c3, 0xff8897c2, 0xff8a99c5, 0xff8c9bc8, 0xff8d9cc7, 0xff919dc9, 0xff8f9dc7, 0xff909cca,
    0xff919ec9, 0xff909cca, 0xff919ecb, 0xff919dcc, 0xff919dcc, 0xff939ecc, 0xff94a1ce, 0xff93a0cb,
    0xff93a0cc, 0xff94a1cd, 0xff95a2ce, 0xff94a1cf, 0xff93a1cd, 0xff97a5cd, 0xff97a3cc, 0xff97a4cb,
    0xff9aa4cd, 0xff9ca5cc, 0xff9aa5cd, 0xff9ba6cf, 0xff9ca6cf, 0xff9aa5ce, 0xff9aa4cf, 0xff9ca2ce,
    0xff9ea1ce, 0xffa3a1ce, 0xffa3a1cb, 0xffaba0cb, 0xffada0c8, 0xffb4a0c9, 0xffb5a1c8, 0xffb6a2c9,
    0xffb5a0ca, 0xffb59fc9, 0xffb19fca, 0xffaca0cd, 0xffaaa1cd, 0xffa2a2cf, 0xff9da0cf, 0xff99a2ce,
    0xff95a1d0, 0xff94a1d0, 0xff919ed0, 0xff929fce, 0xff8e9cce, 0xff909dce, 0xff8e9ccc, 0xff8d99ca,
    0xff8c98cb, 0xff8a97cb, 0xff8795ca, 0xff8293c5, 0xff8292c4, 0xff7d8ec8, 0xff798cc7, 0xff788dc6,
    0xff7589c3, 0xff7388c1, 0xff7086c1, 0xff6d82c1, 0xff6b83c0, 0xff6980bf, 0xff6681bd, 0xff647fbd,
    0xff617ebd, 0xff637abb, 0xff627ab9, 0xff6179b7, 0xff6079b5, 0xff6277b1, 0xff6277b0, 0xff6176af,
    0xff8392c3, 0xff8596c2, 0xff8898c5, 0xff899ac7, 0xff8b9bc6, 0xff8e9cc8, 0xff8e9cc6, 0xff8f9bc9,
    0xff909dc8, 0xff909cca, 0xff919ecb, 0xff919dcc, 0xff919dcc, 0xff939ecc, 0xff94a1ce, 0xff93a0cb,
    0xff93a0cb, 0xff94a1cd, 0xff95a2ce, 0xff94a1cf, 0xff94a2ce, 0xff98a5cd, 0xff98a3cc, 0xff95a4cb,
    0xff99a2cd, 0xff9aa3cc, 0xff99a3cd, 0xff9ca4ce, 0xffa1a4cd, 0xffa3a5cc, 0xffa6a4cc, 0xffaba4ca,
    0xffb0a5ca, 0xffb5a7ca, 0xffb8a9c7, 0xffc2abc7, 0xffc5acc4, 0xffccadc5, 0xffcdafc4, 0xffceb0c5,
    0xffcdaec6, 0xffcdadc5, 0xffc8acc5, 0xffc3abc8, 0xffc0aac7, 0xffb6a9c9, 0xffb0a5ca, 0xffaaa5ca,
    0xffa2a1ce, 0xff9ea0cd, 0xff969dcf, 0xff949ecd, 0xff8f9bce, 0xff909ece, 0xff8e9dcc, 0xff8c99c9,
    0xff8c98ca, 0xff8a97cb, 0xff8695c9, 0xff8293c5, 0xff8291c4, 0xff7d8fc8, 0xff788cc7, 0xff788dc6,
    0xff758ac3, 0xff7388c1, 0xff7186c1, 0xff6d82c1, 0xff6b83c0, 0xff6980bf, 0xff6681bc, 0xff647fbd,
    0xff607ebd, 0xff627aba, 0xff617ab9, 0xff6079b7, 0xff5f79b4, 0xff6177b1, 0xff6176af, 0xff6075ae,
    0xff8092c1, 0xff8495c3, 0xff8596c4, 0xff8799c5, 0xff8899c4, 0xff8b9ac7, 0xff8d9bc6, 0xff8e9bc8,
    0xff8e9cc7, 0xff8f9cc9, 0xff909dca, 0xff909dcb, 0xff909dcc, 0xff939fcb, 0xff93a0cd, 0xff929fcb,
    0xff94a1cc, 0xff95a1cd, 0xff95a2cf, 0xff94a1cd, 0xff95a3ce, 0xff98a4ce, 0xff97a3cb, 0xff95a3cb,
    0xff97a1cc, 0xff98a2cc, 0xff99a1cd, 0xffa1a1cd, 0xffaca2c9, 0xffb6a5c8, 0xffbfa7c5, 0xffc9acc2,
    0xffd0b1c2, 0xffd6b7c1, 0xffdcbdc0, 0xffe3c3c0, 0xffe6c7bf, 0xffe9cac0, 0xffebcbc0, 0xffecccc2,
    0xffebccc0, 0xffeacbc0, 0xffe7c8bf, 0xffe3c5c0, 0xffe1c0be, 0xffdab8bf, 0xffd3b0c1, 0xffcbaac1,
    0xffbca3c7, 0xffb09ec8, 0xffa19ccc, 0xff979ccd, 0xff909ace, 0xff8f9dcd, 0xff8e9ccd, 0xff8b99ca,
    0xff8a98c9, 0xff8997ca, 0xff8595c9, 0xff8293c5, 0xff8290c4, 0xff7c8fc7, 0xff798bc7, 0xff788cc5,
    0xff758ac3, 0xff7387c2, 0xff7186c0, 0xff6d83c1, 0xff6b84be, 0xff6980be, 0xff6680bc, 0xff637fbc,
    0xff607dbc, 0xff617bbb, 0xff5f7bb7, 0xff5f78b7, 0xff5e79b4, 0xff5f76b1, 0xff6075ae, 0xff5f74ad,
    0xff8093c0, 0xff8596c5, 0xff8395c3, 0xff8598c3, 0xff8697c3, 0xff8899c5, 0xff8c9ac7, 0xff8d9bc7,
    0xff8c9bc7, 0xff8e9cc8, 0xff909cc9, 0xff8f9cc9, 0xff909ecb, 0xff929fca, 0xff929fcb, 0xff929fcc,
    0xff94a1cd, 0xff95a2cd, 0xff94a1ce, 0xff94a1cb, 0xff96a3ce, 0xff98a2ce, 0xff98a3ca, 0xff97a3ca,
    0xff99a0cb, 0xff9ba2cb, 0xff9fa1cb, 0xffaca3ca, 0xffbba5c5, 0xffccaac4, 0xffd7aec0, 0xffe4b7bd,
    0xffebbfbd, 0xfff0c8bd, 0xfff8d0be, 0xfffbdabd, 0xfffee1c0, 0xfffde4c1, 0xffffe6c2, 0xffffe7c4,
    0xffffe7c0, 0xffffe7c1, 0xfffee4be, 0xfffddebc, 0xfffcd7bb, 0xfff9cbb9, 0xfff4bfbb, 0xffebb5bc,
    0xffd8abc1, 0xffc5a1c3, 0xffb29fc9, 0xffa19dcb, 0xff989ccd, 0xff939ccb, 0xff909bcd, 0xff8a99cb,
    0xff8998c7, 0xff8896c8, 0xff8595c8, 0xff8392c6, 0xff8190c4, 0xff7c8ec6, 0xff7a8bc7, 0xff788bc4,
    0xff758ac2, 0xff7287c2, 0xff7085be, 0xff6d85c1, 0xff6b84bc, 0xff6880bd, 0xff657fbc, 0xff637fbb,
    0xff607cbb, 0xff5f7cbb, 0xff5e7bb5, 0xff5f78b6, 0xff5e78b4, 0xff5e75b1, 0xff5f74ad, 0xff5e73ac,
    0xff8799c3, 0xff8597c5, 0xff8295c3, 0xff8396c2, 0xff8596c3, 0xff8699c4, 0xff8b9ac7, 0xff8b9bc6,
    0xff8b9bc7, 0xff8e9cc7, 0xff8e9bc9, 0xff8f9cc8, 0xff909ecb, 0xff919fc9, 0xff929fcb, 0xff929fcc,
    0xff94a1cd, 0xff95a2cd, 0xff94a0cd, 0xff94a1ca, 0xff96a2cc, 0xff98a1cd, 0xff99a2ca, 0xff9da2c9,
    0xffa4a1c8, 0xffaca5c6, 0xffb8a9c6, 0xffc6b0c4, 0xffd2b6c2, 0xffddbcc4, 0xffe2c1c3, 0xffe9c7c3,
    0xffeccdc6, 0xffedd2c8, 0xfff4d8cb, 0xfff4e1cc, 0xfff6e6cf, 0xfff4e9d0, 0xfff5ebd1, 0xfff6ebd3,
    0xfff6edcf, 0xfff7eed2, 0xfff8ecce, 0xfff9eacb, 0xfffae5c9, 0xfffeddc4, 0xfffed8c4, 0xfffccec1,
    0xfff0c5c0, 0xffe0b9c0, 0xffcfb2c2, 0xffbea8c3, 0xffb0a1c6, 0xffa29cc6, 0xff9799ca, 0xff8d98ca,
    0xff8a97c7, 0xff8795c6, 0xff8594c8, 0xff8392c6, 0xff7f90c4, 0xff7c8ec4, 0xff7a8bc5, 0xff788ac2,
    0xff758ac1, 0xff7287c1, 0xff7085be, 0xff6d85bf, 0xff6b84ba, 0xff6880bc, 0xff657fbc, 0xff637fba,
    0xff607cbb, 0xff5e7cba, 0xff5e7bb5, 0xff5e78b6, 0xff5d78b4, 0xff5c75b1, 0xff5d74ad, 0xff5c72ab,
    0xff94a2c8, 0xff8799c3, 0xff8496c4, 0xff8295c2, 0xff8696c5, 0xff8799c3, 0xff8a99c6, 0xff899bc6,
    0xff8c9ac6, 0xff8d9bc6, 0xff8d9bc9, 0xff8f9bc8, 0xff919ecb, 0xff909dc9, 0xff929fcb, 0xff929fcb,
    0xff929fcc, 0xff94a3cd, 0xff93a0cb, 0xff95a1cb, 0xff95a0cb, 0xff98a1cb, 0xff9aa1c9, 0xffa4a1c8,
    0xffb3a2c4, 0xffc7a9be, 0xffdcb5bd, 0xffe7c5bc, 0xffead1c0, 0xffe5d7c6, 0xffded9cd, 0xffd8d7d1,
    0xffd3d6d8, 0xffd0d4de, 0xffd1d4e2, 0xffd1d7e5, 0xffd3d8e8, 0xffd2d8ea, 0xffd2d9ea, 0xffd3d9eb,
    0xffd4dcea, 0xffd6dfeb, 0xffd8e1e8, 0xffdbe6e7, 0xffdfe8e4, 0xffe9ebdd, 0xfff0f1d7, 0xfffaeecf,
    0xfffee9c5, 0xfff8debf, 0xffefcdbb, 0xffe5b8b7, 0xffd0a7bd, 0xffb89dc1, 0xffa197c6, 0xff9196c8,
    0xff8b96c8, 0xff8694c6, 0xff8593c8, 0xff8393c6, 0xff7e92c4, 0xff7d8ec3, 0xff7a8bc2, 0xff7889c1,
    0xff758ac0, 0xff7388be, 0xff6f84be, 0xff6c84bd, 0xff6b83ba, 0xff687fbb, 0xff647ebc, 0xff637dba,
    0xff607cba, 0xff5e7bb9, 0xff5d7bb6, 0xff5d78b5, 0xff5b78b3, 0xff5c74b1, 0xff5c73ac, 0xff5b71aa,
    0xff9ea9cc, 0xff899bc3, 0xff8597c4, 0xff8293c2, 0xff8797c6, 0xff8899c3, 0xff8899c5, 0xff889ac5,
    0xff8c99c6, 0xff8c9ac6, 0xff8c9ac8, 0xff8f9bc8, 0xff919eca, 0xff8f9cc9, 0xff919ecb, 0xff929fca,
    0xff919ecb, 0xff93a2cc, 0xff949fc9, 0xff98a1cc, 0xff99a0c9, 0xff9ea3c8, 0xffa5a4c8, 0xffb4a6c6,
    0xffc5acc2, 0xffdcb5bc, 0xfff2c3bd, 0xfff8d5bd, 0xfff2e2c6, 0xffe1e6cd, 0xffd2e5d9, 0xffc3dedf,
    0xffb9d7e8, 0xffb3d0f0, 0xffb0ccf3, 0xffb1c9f8, 0xffb2c8fb, 0xffb3c6fc, 0xffb2c7fc, 0xffb4c6fc,
    0xffb5cafd, 0xffb9ceff, 0xffbcd3fd, 0xffbfdcfd, 0xffc5e3fa, 0xffd2eff3, 0xffddfdeb, 0xffedffe0,
    0xfffdffd1, 0xfffff8c7, 0xffffe3be, 0xffffccb6, 0xffebb8bb, 0xffd3a9be, 0xffb59fc1, 0xffa09ac3,
    0xff9698c7, 0xff8b95c5, 0xff8892c7, 0xff8493c5, 0xff7e92c3, 0xff7d8ec2, 0xff798bc0, 0xff7889bf,
    0xff7489be, 0xff7388bc, 0xff6f84be, 0xff6c82bb, 0xff6a82ba, 0xff677fba, 0xff647ebb, 0xff637cb8,
    0xff5f7cb9, 0xff5d7ab7, 0xff5d7ab7, 0xff5b78b4, 0xff5a77b3, 0xff5b74b0, 0xff5b73ab, 0xff5970a9,
    0xffa0aacc, 0xff8c9ec5, 0xff8598c4, 0xff8292c1, 0xff8697c6, 0xff8898c4, 0xff8899c4, 0xff889ac5,
    0xff8a98c6, 0xff8b9ac7, 0xff8c9ac7, 0xff8f9bc8, 0xff909dc9, 0xff8e9cca, 0xff909dcb, 0xff909fca,
    0xff909ecb, 0xff91a0cc, 0xff939ec9, 0xff99a0cc, 0xffa0a0c8, 0xffaea4c5, 0xffc0aec3, 0xffd0b6c1,
    0xffdac2c1, 0xffe2cbc3, 0xffe8d1c9, 0xffe5d8ce, 0xffdedcd7, 0xffd0dcda, 0xffc3dae3, 0xffb7d3e7,
    0xffafceec, 0xffacc9f2, 0xffaac6f4, 0xffabc4f7, 0xffacc2f8, 0xffaec1f8, 0xffadc2f8, 0xffafc1f8,
    0xffb1c5fc, 0xffb6c9fd, 0xffbacffe, 0xffbcd6fe, 0xffc1dcfe, 0xffcbe5fa, 0xffd3eff5, 0xffdcf2ef,
    0xffe7f4e4, 0xffecf3dc, 0xfff0ead3, 0xfffae1c7, 0xfff7d7c2, 0xffeec6bc, 0xffd7b4ba, 0xffc0a3bb,
    0xffab99c2, 0xff9494c3, 0xff8990c7, 0xff8491c4, 0xff7d90c2, 0xff7c8ec1, 0xff788bbf, 0xff7889be,
    0xff7488bd, 0xff7288bc, 0xff6f84be, 0xff6c81bb, 0xff6a81ba, 0xff667fb8, 0xff647eb9, 0xff637bb6,
    0xff5f7cb7, 0xff5c7ab6, 0xff5d7ab7, 0xff5a78b4, 0xff5a76b3, 0xff5a74af, 0xff5a73aa, 0xff586fa8,
    0xff9ca8c9, 0xff90a0c7, 0xff8398c3, 0xff8291c0, 0xff8396c4, 0xff8798c5, 0xff8799c4, 0xff889ac5,
    0xff8898c6, 0xff8999c8, 0xff8c9ac6, 0xff8e9bc9, 0xff8e9cc9, 0xff8e9ccc, 0xff8f9cca, 0xff8f9ecb,
    0xff909ecc, 0xff919fcc, 0xff959eca, 0xff9d9fcb, 0xffaba2c7, 0xffc1a8c3, 0xffdebabe, 0xffebcabe,
    0xffe8dac4, 0xffd9e0d0, 0xffcbd9db, 0xffc0d1e5, 0xffbbc9e9, 0xffb8c4e7, 0xffb4c1e9, 0xffb2c0e8,
    0xffb0c0e6, 0xffb3c1e9, 0xffb4c2e9, 0xffb6c2e9, 0xffb6c3e9, 0xffb9c4e9, 0xffb8c4e8, 0xffb9c5e7,
    0xffbec9ee, 0xffc4ccef, 0xffc6cff1, 0xffc8d1f1, 0xffcad2f6, 0xffcdd3f5, 0xffced4f7, 0xffcbd5f9,
    0xffc9d7f8, 0xffcadcf4, 0xffd0e5ef, 0xffe1efe1, 0xfff4f5d1, 0xffffe7bf, 0xfff7ceb6, 0xffe3b1b4,
    0xffc49fbb, 0xffa396c1, 0xff8f90c6, 0xff868fc1, 0xff7f8ec1, 0xff7b8dc1, 0xff778abf, 0xff7788be,
    0xff7388bc, 0xff7187bd, 0xff7084be, 0xff6c81bb, 0xff6981bb, 0xff667fb7, 0xff647eb7, 0xff627ab4,
    0xff5e7cb4, 0xff5c7ab6, 0xff5d7ab6, 0xff5a77b3, 0xff5b76b3, 0xff5a73af, 0xff5873a9, 0xff586ea7,
    0xff95a2c6, 0xff90a0c8, 0xff8097c2, 0xff8291c0, 0xff8295c3, 0xff8697c5, 0xff8798c3, 0xff8899c5,
    0xff8697c6, 0xff8899c8, 0xff8c9ac5, 0xff8d9ac9, 0xff8d9bc8, 0xff8e9ccc, 0xff8d9bc9, 0xff8d9ccb,
    0xff909dcc, 0xff949dcb, 0xff9da0c9, 0xffaba4c8, 0xffbdadc5, 0xffd3b6c4, 0xffeac8c2, 0xffeed5c5,
    0xffe3e2cf, 0xffcbe4dd, 0xffb5d8e8, 0xffa6c7f1, 0xffa4baf2, 0xffa8b3ec, 0xffaab0e9, 0xffafb2e5,
    0xffb2b5e0, 0xffb8bbe1, 0xffbbbedf, 0xffbec0de, 0xffbec4de, 0xffc2c6dd, 0xffc1c6dd, 0xffc2c8dc,
    0xffc7cbe3, 0xffcdcde4, 0xffcecee7, 0xffd0cde7, 0xffd0cbed, 0xffcfc7ef, 0xffcbc2f5, 0xffc1c1fb,
    0xffb7c3ff, 0xffb6cbff, 0xffbbdbfe, 0xffcceef3, 0xffe5fce1, 0xfffbf3cd, 0xfffddfc0, 0xfff5c6b8,
    0xffddb2b9, 0xffbda3bd, 0xffa396c2, 0xff918fbe, 0xff848cc0, 0xff7c8bc0, 0xff7789be, 0xff7688bd,
    0xff7387bb, 0xff7086bd, 0xff7084be, 0xff6c81bb, 0xff6980bb, 0xff657fb6, 0xff647eb6, 0xff627ab3,
    0xff5e7bb2, 0xff5c7ab5, 0xff5c79b5, 0xff5a77b3, 0xff5b75b3, 0xff5973ae, 0xff5773a8, 0xff576ea7,
    0xff8d9dc5, 0xff8c9dc6, 0xff7d95c1, 0xff8093c1, 0xff8394c2, 0xff8597c4, 0xff8596c2, 0xff8696c4,
    0xff8596c5, 0xff8798c7, 0xff8a99c6, 0xff8a98c7, 0xff8c9bc7, 0xff8c9bca, 0xff8c9bc8, 0xff8c9bca,
    0xff929cca, 0xff9c9cc9, 0xffada3c5, 0xffc2afc3, 0xffd6bfc2, 0xffdccdc6, 0xffddd4d0, 0xffd2d3d7,
    0xffc9d3e0, 0xffbbd3e8, 0xffafcbec, 0xffa4bfec, 0xffa3b6ea, 0xffa6b1e6, 0xffa8ade2, 0xffadb1df,
    0xffb2b3dc, 0xffb7b8de, 0xffbabcdb, 0xffbdbfdc, 0xffbdc2db, 0xffc1c3db, 0xffc1c4dc, 0xffc2c7da,
    0xffc7c9e0, 0xffcbcbe1, 0xffcccbe3, 0xffcecae4, 0xffcec8e8, 0xffcdc6eb, 0xffcac3ef, 0xffc3c2f2,
    0xffbbc5f6, 0xffbccafa, 0xffbdd2f9, 0xffc3dcf6, 0xffcfe4f0, 0xffdae3e6, 0xffe3e2d9, 0xffefdeca,
    0xffefd2bd, 0xffe0bbb6, 0xffc4a3b9, 0xffa493b9, 0xff8d8bbe, 0xff7e88bf, 0xff7787bc, 0xff7487bc,
    0xff7287ba, 0xff6f85bd, 0xff6e84bd, 0xff6b81ba, 0xff697fb9, 0xff647fb7, 0xff647db6, 0xff627ab3,
    0xff5e7ab1, 0xff5d79b4, 0xff5a78b4, 0xff5a77b2, 0xff5975b2, 0xff5772ad, 0xff5572a8, 0xff556ea7,
    0xff8799c4, 0xff879ac3, 0xff7a92c1, 0xff7e94c2, 0xff8393c1, 0xff8496c2, 0xff8394c2, 0xff8394c2,
    0xff8495c3, 0xff8697c6, 0xff8898c6, 0xff8896c6, 0xff8b9ac5, 0xff8c9ac8, 0xff8d9cc8, 0xff8f9ac8,
    0xff989cc8, 0xffa79ec7, 0xffbdaac2, 0xffd7bbc1, 0xffe6d0c2, 0xffdcdfcc, 0xffc6dadf, 0xffafcaea,
    0xffaabdf0, 0xffacbbec, 0xffb1bae9, 0xffacb8e1, 0xffaab7dd, 0xffabb4db, 0xffaab1d9, 0xffadb5d8,
    0xffb1b4d9, 0xffb4b8dc, 0xffb7bbd9, 0xffbabddd, 0xffbbc0dc, 0xffbdc0dd, 0xffbfc1df, 0xffc0c5dd,
    0xffc3c6e0, 0xffc6c8e2, 0xffc6c7e2, 0xffc9c9e3, 0xffc9c8e5, 0xffcacae7, 0xffcacae7, 0xffc9cbe6,
    0xffc7cde7, 0xffc9cdeb, 0xffc6c9ec, 0xffc0c5f1, 0xffb9c3f8, 0xffb4c9fb, 0xffbedbf2, 0xffdbeede,
    0xfff3ecc6, 0xfff9d1b5, 0xffe1b2b4, 0xffba9cb7, 0xff9b8ebc, 0xff8588bc, 0xff7b86ba, 0xff7486bc,
    0xff7386b9, 0xff6f84bc, 0xff6d83bc, 0xff6a80b9, 0xff687eb8, 0xff647eb7, 0xff637db5, 0xff617ab3,
    0xff5e78b1, 0xff5d78b4, 0xff5977b3, 0xff5976b1, 0xff5874b1, 0xff5571ad, 0xff5471a9, 0xff536ea7,
    0xff8c9cc6, 0xff8699c2, 0xff7890c1, 0xff7c94c2, 0xff8293c1, 0xff8295c2, 0xff8394c2, 0xff8394c2,
    0xff8395c3, 0xff8596c4, 0xff8696c5, 0xff8896c5, 0xff8a99c5, 0xff8b99c6, 0xff8f9bc6, 0xff979bc6,
    0xffa7a1c5, 0xffbbabc4, 0xffccbac2, 0xffdac8c6, 0xffded4cd, 0xffcfddd8, 0xffb5d4e8, 0xff9ec1f0,
    0xff9cb2f1, 0xffa5aeea, 0xffafb1e3, 0xffafb3d9, 0xffadb5d5, 0xffacb4d4, 0xffaab3d4, 0xffacb5d4,
    0xffb0b5d7, 0xffb2b7da, 0xffb6bbd9, 0xffb8bcdd, 0xffb9bedd, 0xffbbbede, 0xffbdbfe0, 0xffbfc3de,
    0xffc1c4df, 0xffc2c6e1, 0xffc2c5e1, 0xffc5c7e2, 0xffc5c7e2, 0xffc7cae3, 0xffc7cbe1, 0xffcacddf,
    0xffcacedf, 0xffcccbe2, 0xffc8c3e3, 0xffbdbaeb, 0xffb0b4f5, 0xffa6bdfe, 0xffadd0fa, 0xffc8e7ed,
    0xffe1ebd7, 0xfff1dac4, 0xffeac7ba, 0xffd3b3b7, 0xffb79cb7, 0xff9a8db7, 0xff8586b8, 0xff7684ba,
    0xff7285b9, 0xff6f84ba, 0xff6c82ba, 0xff6980b9, 0xff687db6, 0xff647db6, 0xff637bb4, 0xff617ab3,
    0xff5e78b0, 0xff5d78b2, 0xff5975b0, 0xff5875af, 0xff5673ae, 0xff5371ab, 0xff5270a9, 0xff516ea6,
    0xff98a4ca, 0xff899bc3, 0xff778fc1, 0xff7c92c1, 0xff7e92c2, 0xff8193c2, 0xff8595c3, 0xff8495c2,
    0xff8395c3, 0xff8395c2, 0xff8595c4, 0xff8897c4, 0xff8797c5, 0xff8b98c5, 0xff939ac5, 0xffa29dc3,
    0xffbca8c2, 0xffd1bdc0, 0xffd7cfc6, 0xffcdd3d1, 0xffc1cdde, 0xffb7c8e6, 0xffacc3e8, 0xffa2bae8,
    0xffa1b2e5, 0xffa7afe0, 0xffaeb1dd, 0xffadb2d7, 0xffaab3d5, 0xffaab1d4, 0xffa9b3d4, 0xffabb3d4,
    0xffaeb5d5, 0xffb1b7d8, 0xffb6bad9, 0xffb7bcdc, 0xffb8bddc, 0xffbbbedc, 0xffbcbede, 0xffbec2df,
    0xffbfc2de, 0xffc0c5e0, 0xffc1c4df, 0xffc3c6e1, 0xffc4c6e1, 0xffc5c8e1, 0xffc4c8df, 0xffc6c9df,
    0xffc5c9de, 0xffc6c7e0, 0xffc3c0e0, 0xffbdbce4, 0xffb6b9e9, 0xffb2bfee, 0xffb2c5f1, 0xffbbccf1,
    0xffbfd0ea, 0xffcbd5dd, 0xffdfdbca, 0xffe9d1b9, 0xffdab0b1, 0xffb496b1, 0xff9286b7, 0xff7b80b8,
    0xff7182b9, 0xff6e83b9, 0xff6b81b9, 0xff6980b8, 0xff677cb6, 0xff647cb4, 0xff637ab2, 0xff6079b2,
    0xff5d77af, 0xff5c77b0, 0xff5b75ad, 0xff5773ad, 0xff5572ac, 0xff5370a9, 0xff526fa7, 0xff506da5,
    0xffa4accd, 0xff899bc4, 0xff768ec0, 0xff7b90c0, 0xff7b91c2, 0xff8091c2, 0xff8595c4, 0xff8596c2,
    0xff8295c3, 0xff8294c1, 0xff8494c2, 0xff8997c4, 0xff8996c4, 0xff9199c4, 0xff9e9dc3, 0xffb1a4c2,
    0xffccb3c2, 0xffdbccc2, 0xffd5d9cd, 0xffbbd5dc, 0xffa6c1eb, 0xffa3b3ed, 0xffa8b3e3, 0xffaab4de,
    0xffa9b4d8, 0xffa9b2d6, 0xffabb2d6, 0xffaab2d6, 0xffa7b0d5, 0xffa7aed4, 0xffa7b1d5, 0xffa9b1d4,
    0xffacb4d5, 0xffb0b6d7, 0xffb5bada, 0xffb6bbdb, 0xffb7bcdc, 0xffbabedb, 0xffbabedc, 0xffbdc0df,
    0xffbdc1dd, 0xffbec3df, 0xffbfc3de, 0xffc1c5e0, 0xffc2c5e0, 0xffc2c4df, 0xffc0c3de, 0xffc0c4e0,
    0xffc0c3df, 0xffbec2df, 0xffbcbfdd, 0xffbcbfdd, 0xffbdc0dc, 0xffbfc1dc, 0xffbabbe3, 0xffb0b3ef,
    0xffa2b5f4, 0xffa7c9ef, 0xffcae2da, 0xffece2c3, 0xffecc2b2, 0xffcca7b0, 0xffa78fb6, 0xff8982b5,
    0xff7782b7, 0xff7182b6, 0xff6c80b7, 0xff687fb7, 0xff667bb5, 0xff647ab2, 0xff6278b0, 0xff5f78b0,
    0xff5c77ae, 0xff5b76ad, 0xff5b74ab, 0xff5672ab, 0xff5570a9, 0xff5370a7, 0xff516ea6, 0xff506da3,
    0xffabb2cf, 0xff8497c2, 0xff758dbf, 0xff7a8fbf, 0xff7a90c2, 0xff7f90c1, 0xff8494c3, 0xff8495c2,
    0xff8295c3, 0xff8394c2, 0xff8393c1, 0xff8795c3, 0xff8c94c3, 0xff9d9bc2, 0xffb2a5c0, 0xffc5b5c0,
    0xffd0c4c6, 0xffced0cc, 0xffc3d0d9, 0xffadc9e3, 0xff9eb9e8, 0xff9eade8, 0xffa6aedd, 0xffacb2d9,
    0xffabb3d3, 0xffa9b2d2, 0xffa8b1d3, 0xffa8b1d5, 0xffa5aed3, 0xffa6aed3, 0xffa5afd3, 0xffa8b0d3,
    0xffabb3d5, 0xffafb5d6, 0xffb4b9d9, 0xffb5bada, 0xffb7bbdc, 0xffb9bcda, 0xffbabddb, 0xffbcbede,
    0xffbcc0dc, 0xffbcc1dd, 0xffbec2dd, 0xffbfc3df, 0xffbfc3de, 0xffbfc2dd, 0xffbec1dd, 0xffbdc1de,
    0xffbcc0df, 0xffbabedd, 0xffb9bddb, 0xffbabeda, 0xffbcbfd8, 0xffbfbfd6, 0xffbab7dc, 0xffadace6,
    0xff9faeee, 0xff9fbfef, 0xffb8d2e4, 0xffd1d8d6, 0xffdfcfc2, 0xffdac1b5, 0xffc5a5b2, 0xffa28ab0,
    0xff8481b4, 0xff737eb3, 0xff6a7fb6, 0xff667eb6, 0xff657ab4, 0xff6379b1, 0xff6177af, 0xff5e77af,
    0xff5c77ad, 0xff5a75ab, 0xff5a74aa, 0xff5572aa, 0xff556fa8, 0xff5270a7, 0xff506da5, 0xff506da3,
    0xffaab3cf, 0xff7c91be, 0xff748bbf, 0xff788ebf, 0xff7990c2, 0xff7d90c1, 0xff8192c2, 0xff8293c1,
    0xff8295c2, 0xff8594c3, 0xff8393c1, 0xff8693c2, 0xff9395c1, 0xffac9fc1, 0xffc6b0bd, 0xffd4c6c1,
    0xffcad3cd, 0xffb5cbd9, 0xffaabae4, 0xffa4b7e4, 0xffa3b3dd, 0xffa4b0db, 0xffa8b0d7, 0xffaab2d8,
    0xffa9b1d3, 0xffa7b0d3, 0xffa5afd3, 0xffa6b0d4, 0xffa4acd1, 0xffa5aed2, 0xffa4add1, 0xffa7afd3,
    0xffabb2d5, 0xffaeb4d6, 0xffb2b7d7, 0xffb5bada, 0xffb6bbdc, 0xffb7bada, 0xffb9bdda, 0xffbbbddc,
    0xffbcbfdb, 0xffbbbfdb, 0xffbcc0dd, 0xffbdc0dd, 0xffbdc1dc, 0xffbcc0db, 0xffbcc0dc, 0xffbcbfdc,
    0xffbbbede, 0xffb8bbdb, 0xffb8bbd9, 0xffb7bbd9, 0xffb7bbd8, 0xffb9bbd7, 0xffb7b8d7, 0xffafb2da,
    0xffaab4dd, 0xffa7b7e3, 0xffa9b6e8, 0xffa9bee9, 0xffbed2d7, 0xffdbd9c0, 0xffdfbfaf, 0xffbc98ac,
    0xff9584b0, 0xff787bb0, 0xff697eb5, 0xff667eb4, 0xff647ab3, 0xff6279b1, 0xff5f76ae, 0xff5e76ad,
    0xff5b76ad, 0xff5975aa, 0xff5773ab, 0xff5472aa, 0xff556fa7, 0xff5170a9, 0xff4f6da5, 0xff4f6da3,
    0xffa2aecc, 0xff768cbd, 0xff738bbe, 0xff778dbf, 0xff798fc1, 0xff7b90c0, 0xff7d90c1, 0xff7f90c1,
    0xff8194c2, 0xff8593c3, 0xff8692c1, 0xff8d92c1, 0xffa19abf, 0xffbcabc0, 0xffcfbdc0, 0xffd2cec7,
    0xffbed4d5, 0xffa2c2e1, 0xff99abe7, 0xff9faae0, 0xffa7aed4, 0xffa8b2d1, 0xffa8b2d2, 0xffa7b2d5,
    0xffa6aed3, 0xffa5afd3, 0xffa3aed1, 0xffa5afd3, 0xffa3abd0, 0xffa4aed1, 0xffa3abd0, 0xffa6aed2,
    0xffaab1d5, 0xffadb3d6, 0xffb0b6d6, 0xffb4b9d9, 0xffb6badb, 0xffb6b9d9, 0xffb9bcda, 0xffbabcdb,
    0xffbbbedb, 0xffbabeda, 0xffbbbfdc, 0xffbbbedc, 0xffbbbedb, 0xffbabeda, 0xffbbbfdc, 0xffbabddb,
    0xffb8bbdd, 0xffb7b9d9, 0xffb6b9d8, 0xffb3b8d8, 0xffb2b7d9, 0xffb2b6d6, 0xffb2b6d4, 0xffb0b6d2,
    0xffb1b7d0, 0xffadb0d7, 0xffa1a4e5, 0xff92acf0, 0xffa4cce4, 0xffcddcce, 0xffe1cfb7, 0xffceadae,
    0xffae92ac, 0xff887fad, 0xff6f7cb2, 0xff667cb2, 0xff637ab2, 0xff6079b1, 0xff5e76ae, 0xff5d75ad,
    0xff5b76ad, 0xff5874aa, 0xff5673ab, 0xff5472aa, 0xff556fa7, 0xff5170a9, 0xff4f6da5, 0xff4f6da3,
    0xff93a3c7, 0xff738bc0, 0xff728bbd, 0xff768dbf, 0xff778ec0, 0xff788ec0, 0xff798fc0, 0xff7b8ec0,
    0xff7e91c2, 0xff8391c1, 0xff8a91c0, 0xff9a95c0, 0xffb5a5bc, 0xffc8bcc1, 0xffc9cac8, 0xffbbc8d4,
    0xffaec3de, 0xff9eb6e1, 0xff99a9df, 0xff9fa9d9, 0xffa6acd1, 0xffa6b1cf, 0xffa4b0d0, 0xffa3afd2,
    0xffa3acd1, 0xffa3aed1, 0xffa2adcf, 0xffa3add1, 0xffa2abd0, 0xffa2acd1, 0xffa2a9d0, 0xffa4acd1,
    0xffa8afd4, 0xffaab2d6, 0xffadb5d6, 0xffb2b8d7, 0xffb5b9d9, 0xffb4b8d8, 0xffb8bbda, 0xffb8bbda,
    0xffb8bddb, 0xffb8bcd9, 0xffb8bdd9, 0xffb9bcdb, 0xffb9bcda, 0xffb8bcd9, 0xffb8bddb, 0xffb7bbda,
    0xffb5b9da, 0xffb4b7d7, 0xffb3b7d6, 0xffb1b5d6, 0xffafb4d7, 0xffaeb3d4, 0xffadb3d2, 0xffacb4d0,
    0xffaeb4ce, 0xffaaadd3, 0xffa1a5dd, 0xff96aae5, 0xff9ebce3, 0xffb2c6de, 0xffc4cecb, 0xffd0c7b8,
    0xffcbabab, 0xffa389a9, 0xff7e7bad, 0xff687aaf, 0xff617ab1, 0xff5f78b0, 0xff5e76ad, 0xff5c75ad,
    0xff5b75ac, 0xff5773aa, 0xff5573ab, 0xff5472a9, 0xff546fa7, 0xff5170a8, 0xff4f6da6, 0xff4e6ca3,
    0xff8396c2, 0xff728bc2, 0xff718cbd, 0xff768dbf, 0xff768dbf, 0xff768cc0, 0xff778ebf, 0xff788cc0,
    0xff7c8fc2, 0xff838fbf, 0xff9292be, 0xffaa9cc1, 0xffc5b1bc, 0xffcdcac4, 0xffbad0d1, 0xffa0bbe0,
    0xff9fade3, 0xff9faadd, 0xff9facd3, 0xffa2add1, 0xffa5acd1, 0xffa3afd0, 0xffa0aed0, 0xff9faccf,
    0xff9fabcf, 0xffa2aed0, 0xffa1accd, 0xffa2abcf, 0xffa2abd1, 0xffa1aad1, 0xffa1a8d0, 0xffa2aad0,
    0xffa7add2, 0xffa9b1d5, 0xffacb4d6, 0xffb0b7d6, 0xffb4b9d7, 0xffb3b8d7, 0xffb6bada, 0xffb6bada,
    0xffb6bcda, 0xffb7bbd9, 0xffb6bbd7, 0xffb8bcda, 0xffb8bad9, 0xffb8bbd9, 0xffb6bbdb, 0xffb5bad9,
    0xffb2b7d7, 0xffb2b7d6, 0xffb0b6d5, 0xffaeb4d5, 0xffacb2d5, 0xffaab1d2, 0xffa9afd2, 0xffa8b0d2,
    0xffa7b0cf, 0xffa5acd0, 0xffa5add2, 0xffa5add4, 0xff9faadc, 0xff97a8e8, 0xff9fc3de, 0xffc6d9c4,
    0xffdcc3ae, 0xffbc98a9, 0xff917ea9, 0xff6f7aad, 0xff627aaf, 0xff5e76ae, 0xff5f76ad, 0xff5b75ae,
    0xff5a74ab, 0xff5672ab, 0xff5572aa, 0xff5371a7, 0xff536ea8, 0xff526fa7, 0xff506da7, 0xff4d6ba2,
    0xff758cbe, 0xff6d89c3, 0xff718cbe, 0xff768dbf, 0xff768dbf, 0xff778cc0, 0xff758dbf, 0xff758ac0,
    0xff7d8cc0, 0xff8a8fbd, 0xffa19abd, 0xffbcabc0, 0xffc9bfc2, 0xffc2cccd, 0xffaac8da, 0xff93b1e4,
    0xff98a3e0, 0xff9fa5d7, 0xffa1adcc, 0xffa1adcc, 0xffa3abd0, 0xffa0adcf, 0xff9dabd0, 0xff9da9cd,
    0xff9ca9cf, 0xffa0abce, 0xffa0aacd, 0xffa0a9cf, 0xffa0aad1, 0xff9fa8d1, 0xff9fa8d0, 0xffa2aad0,
    0xffa5acd2, 0xffa7b1d5, 0xffaab3d6, 0xffaeb5d6, 0xffb2b7d7, 0xffb1b8d7, 0xffb4b9da, 0xffb4bada,
    0xffb4bad9, 0xffb5b9d9, 0xffb4b9d7, 0xffb6bad9, 0xffb6b8d8, 0xffb6b9d8, 0xffb4b9d9, 0xffb2b7d7,
    0xffb0b5d5, 0xffafb5d4, 0xffadb4d5, 0xffabb2d3, 0xffa9b0d3, 0xffa7aed0, 0xffa5add2, 0xffa4aed1,
    0xffa3accf, 0xffa1abcf, 0xffa5aecc, 0xffa9acca, 0xff9fa0d5, 0xff8c9be6, 0xff8eb6e5, 0xffb3d1d2,
    0xffd0cbbb, 0xffc8afaf, 0xffaa8fa7, 0xff817ca9, 0xff6878ac, 0xff5d75ac, 0xff5e76ad, 0xff5a74ae,
    0xff5973ab, 0xff5672ab, 0xff5572aa, 0xff5371a7, 0xff526ea8, 0xff526fa6, 0xff506da6, 0xff4d6ba2,
    0xff6c86bb, 0xff6787c0, 0xff718ac1, 0xff758dbd, 0xff768dbf, 0xff798dc0, 0xff768dbf, 0xff7589c1,
    0xff8089bd, 0xff9590bc, 0xffb2a4bb, 0xffc9bec0, 0xffbfcacc, 0xffaac1da, 0xff9eb4e0, 0xff97acde,
    0xff99a7d6, 0xff9ea7d2, 0xff9eaccc, 0xff9eaccc, 0xffa1abcf, 0xff9eabce, 0xff9ca9d0, 0xff9ca7ce,
    0xff9ba9cf, 0xff9da8ce, 0xff9da9ce, 0xff9da9cf, 0xff9ea9d0, 0xff9ca8d2, 0xff9da7cf, 0xffa2abd0,
    0xffa5acd1, 0xffa7b0d5, 0xffaab2d6, 0xffacb4d7, 0xffb0b5d7, 0xffb1b7d6, 0xffb2b8d9, 0xffb4b9d9,
    0xffb3b8d8, 0xffb4b8d9, 0xffb2b8d8, 0xffb3b8d7, 0xffb4b8d7, 0xffb4b8d7, 0xffb1b7d7, 0xffb0b5d5,
    0xffafb4d5, 0xffabb3d4, 0xffa9b2d5, 0xffa9afd3, 0xffa6aed2, 0xffa4acd0, 0xffa4acd2, 0xffa3acd0,
    0xffa1aace, 0xffa0a9cf, 0xffa3abcc, 0xffa4a9c9, 0xff9ea2d2, 0xff94a0d8, 0xff95aade, 0xff9cb3dc,
    0xffabc2cf, 0xffc4c6ba, 0xffc2a8a7, 0xff9981a6, 0xff7274a9, 0xff5d74aa, 0xff5b75ae, 0xff5973ad,
    0xff5872ac, 0xff5772ab, 0xff5572a9, 0xff5271a6, 0xff516da7, 0xff526fa5, 0xff4f6da4, 0xff4d6ba2,
    0xff6e87bc, 0xff6787be, 0xff7089c3, 0xff748cbd, 0xff778dbf, 0xff7c8ebf, 0xff798cbf, 0xff7b8bc1,
    0xff8b8cbb, 0xffa698bd, 0xffbfb1bd, 0xffcbcac3, 0xffb0cdd6, 0xff96b4e2, 0xff95a3e1, 0xff9da9d7,
    0xff9cabce, 0xff9daace, 0xff9baace, 0xff9ba9ce, 0xff9eaace, 0xff9ca9ce, 0xff9ba7d0, 0xff9ba6cf,
    0xff9aa8d0, 0xff9ba6ce, 0xff9ba7d0, 0xff9ba8d0, 0xff9ba7cf, 0xff9aa7d2, 0xff9ca7cf, 0xffa3acd0,
    0xffa4acd1, 0xffa7afd4, 0xffa9b1d5, 0xffaab2d7, 0xffaeb3d7, 0xffb0b6d6, 0xffb0b7d8, 0xffb3b8d8,
    0xffb2b7d7, 0xffb2b7d8, 0xffb1b7d8, 0xffb1b6d6, 0xffb2b7d6, 0xffb1b6d6, 0xffafb5d5, 0xffadb2d3,
    0xffadb3d5, 0xffa8b0d4, 0xffa6b0d5, 0xffa7add2, 0xffa4acd0, 0xffa2aad0, 0xffa3abd1, 0xffa2aace,
    0xffa0a8cd, 0xff9fa7cf, 0xff9fa6cd, 0xff9ea4cb, 0xff9ca4ce, 0xff9da7ca, 0xff9da0d3, 0xff8a98e0,
    0xff89b3de, 0xffb4cec6, 0xffc9bbad, 0xffac8da6, 0xff8277a6, 0xff6475a7, 0xff5c74ac, 0xff5972ab,
    0xff5771ab, 0xff5872aa, 0xff5571a8, 0xff5170a6, 0xff506da6, 0xff516fa5, 0xff4e6ca2, 0xff4d6ba1,
    0xff7a8fbe, 0xff6f8bbe, 0xff6e89c1, 0xff728cbe, 0xff778dbe, 0xff7b8dbf, 0xff7a8abe, 0xff878bbf,
    0xff9d94b9, 0xffbba9bc, 0xffc2c1c2, 0xffbbc8cf, 0xffa4c0de, 0xff93ace0, 0xff95a0dc, 0xff9ea8d2,
    0xff9cabcc, 0xff9ba8ce, 0xff9aa9cf, 0xff99a7ce, 0xff9ca9cf, 0xff9ba8cf, 0xff9aa6d0, 0xff9aa6d0,
    0xff99a7d0, 0xff9aa6cf, 0xff9aa6d1, 0xff9aa7d0, 0xff9aa6cf, 0xff99a6d1, 0xff9ba7d0, 0xffa3acd0,
    0xffa4acd0, 0xffa6aed3, 0xffa8afd4, 0xffa8b0d6, 0xffacb2d6, 0xffaeb5d5, 0xffafb6d7, 0xffb1b7d7,
    0xffb1b7d6, 0xffb1b6d7, 0xffb0b6d7, 0xffafb5d6, 0xffb0b6d5, 0xffafb4d5, 0xffadb4d4, 0xffabb1d3,
    0xffaab2d3, 0xffa6aed4, 0xffa5aed4, 0xffa5abd1, 0xffa3aace, 0xffa1a9cf, 0xffa2aad0, 0xffa0a8cd,
    0xff9fa6cd, 0xff9da5cd, 0xff9da4cc, 0xff99a1cb, 0xff9aa3cc, 0xff9ea7c5, 0xff9c9cce, 0xff8892d8,
    0xff81a6dd, 0xff9ebbd2, 0xffb4bfbb, 0xffb7a5aa, 0xff9a84a3, 0xff7174a3, 0xff5e71a9, 0xff5771aa,
    0xff5670a9, 0xff5771a8, 0xff5470a7, 0xff516fa6, 0xff506da6, 0xff506ea5, 0xff4e6ca1, 0xff4c6aa0,
    0xff8d9bc2, 0xff7c92bf, 0xff6c89be, 0xff718cc0, 0xff768cbe, 0xff798abe, 0xff7e89bd, 0xff968ebd,
    0xffb2a0b9, 0xffcbbcbd, 0xffbbcdcb, 0xffa2bddc, 0xff99ade2, 0xff9aa9d8, 0xff9aa5d3, 0xff9daad0,
    0xff9ba9d0, 0xff98a6d0, 0xff9aa7d1, 0xff98a6ce, 0xff9ba8d0, 0xff9ba8d0, 0xff99a5d0, 0xff9aa6d0,
    0xff99a7d0, 0xff9aa7d1, 0xff99a6d1, 0xff9aa6cf, 0xff99a6d0, 0xff99a6cf, 0xff9ba6d1, 0xffa2abcf,
    0xffa3abcf, 0xffa5add2, 0xffa7aed4, 0xffa7afd4, 0xffaab2d4, 0xffacb4d4, 0xffaeb5d7, 0xffafb6d6,
    0xffb0b7d6, 0xffafb5d6, 0xffaeb5d6, 0xffaeb4d6, 0xffafb4d5, 0xffadb2d4, 0xffabb2d4, 0xffaab2d3,
    0xffa7b0d0, 0xffa6add3, 0xffa4add2, 0xffa2aad0, 0xffa1a9cd, 0xffa1a9ce, 0xffa0a9ce, 0xff9fa6cd,
    0xff9fa4cd, 0xff9ba4cb, 0xff9ca2ca, 0xff979fcb, 0xff989fca, 0xff9aa2c7, 0xff969dcb, 0xff8f9bcb,
    0xff8a9cd3, 0xff889bda, 0xff90b5ca, 0xffb5bcb2, 0xffb096a3, 0xff82759f, 0xff6370a4, 0xff5771a8,
    0xff566ea6, 0xff556fa6, 0xff546ea6, 0xff516ea5, 0xff516da7, 0xff4f6ca5, 0xff4d6ba1, 0xff4c6a9f,
    0xff9fa8c7, 0xff8899c0, 0xff6d89bc, 0xff708bc0, 0xff778bbd, 0xff7d8abd, 0xff8b8cbb, 0xffab9abb,
    0xffc3b3bc, 0xffccc9c5, 0xffafcbd5, 0xff92b1e3, 0xff95a1e0, 0xff9fa7d3, 0xff9da9cd, 0xff9baacf,
    0xff9aa7d2, 0xff97a4d1, 0xff99a6d2, 0xff97a5ce, 0xff9aa7d1, 0xff9aa7d0, 0xff98a5d0, 0xff99a6d0,
    0xff99a6d0, 0xff9aa7d2, 0xff99a5d1, 0xff99a5cf, 0xff98a5d0, 0xff99a5ce, 0xff9ba6d1, 0xffa1aacf,
    0xffa3abcf, 0xffa4acd1, 0xffa6add3, 0xffa6aed2, 0xffa8b1d3, 0xffaab3d4, 0xffadb4d6, 0xffadb5d5,
    0xffafb6d5, 0xffaeb4d5, 0xffadb4d5, 0xffadb3d6, 0xffacb3d5, 0xffabb1d3, 0xffa9b1d4, 0xffa9b1d3,
    0xffa5afcf, 0xffa5acd2, 0xffa4acd1, 0xffa1a9cf, 0xff9fa8cc, 0xffa0a8cd, 0xff9da8cd, 0xff9da4cd,
    0xff9ca3cd, 0xff98a2ca, 0xff99a1c9, 0xff949eca, 0xff959dc8, 0xff959ec8, 0xff919dc8, 0xff93a0c2,
    0xff9095c8, 0xff7a87d9, 0xff78a6d2, 0xffa5bfbd, 0xffb3a5a9, 0xff95829f, 0xff7372a0, 0xff5c70a5,
    0xff566ea4, 0xff536ea4, 0xff536da5, 0xff516da5, 0xff516da7, 0xff4e6ba4, 0xff4d6ba1, 0xff4b699f,
    0xffaab1cc, 0xff909dc2, 0xff6f8abb, 0xff708abe, 0xff798bbe, 0xff868bbb, 0xff9f94ba, 0xffc3adba,
    0xffcdc9c2, 0xffbacad3, 0xffa0bae0, 0xff92a9e0, 0xff97a3d9, 0xff9ea7d2, 0xff9ca8cd, 0xff99a7ce,
    0xff99a6d2, 0xff97a3d1, 0xff98a4d1, 0xff97a4cf, 0xff99a6d1, 0xff99a5cf, 0xff98a5cf, 0xff98a4cf,
    0xff98a5d0, 0xff99a6d1, 0xff98a4d0, 0xff98a4cf, 0xff97a4d0, 0xff99a4cf, 0xff9aa6d0, 0xffa0a9d0,
    0xffa2aacf, 0xffa4acd1, 0xffa5add2, 0xffa5acd1, 0xffa6afd2, 0xffa8b1d4, 0xffabb2d6, 0xffaab3d6,
    0xffacb4d4, 0xffacb3d6, 0xffaab2d5, 0xffabb1d5, 0xffaab1d4, 0xffa9b0d3, 0xffa7aed3, 0xffa6aed1,
    0xffa3adcf, 0xffa2aad0, 0xffa3abcf, 0xffa1a8cc, 0xff9ca6cc, 0xff9ca5cc, 0xff9aa5cb, 0xff9aa2cc,
    0xff99a1cb, 0xff959fc9, 0xff969ec9, 0xff929dc8, 0xff929cc6, 0xff929cc7, 0xff8d9bc5, 0xff919ec0,
    0xff8e92c3, 0xff7c89cf, 0xff7697d0, 0xff8ba9c8, 0xff9eadb4, 0xffa699a2, 0xff8b7a9c, 0xff656ea0,
    0xff576da4, 0xff526da3, 0xff536da6, 0xff526da5, 0xff506da6, 0xff4d6ba3, 0xff4c6ba0, 0xff4b699f,
    0xffaeb6cf, 0xff929ec2, 0xff728bbc, 0xff7188bb, 0xff7c8abe, 0xff918eba, 0xffb29eba, 0xffd1bfbc,
    0xffcbd6ca, 0xffa1c3df, 0xff92a5e5, 0xff99a4d9, 0xff9ba9d0, 0xff9aa8d2, 0xff99a6cf, 0xff97a4cd,
    0xff98a5d0, 0xff98a3d0, 0xff97a3cf, 0xff98a3d0, 0xff99a5d0, 0xff98a4ce, 0xff97a4ce, 0xff96a3cf,
    0xff98a5d0, 0xff97a4d0, 0xff98a3cf, 0xff97a3d0, 0xff96a3cf, 0xff98a4d0, 0xff99a6d0, 0xffa0a8d1,
    0xffa1aad0, 0xffa4acd2, 0xffa4acd2, 0xffa5abd0, 0xffa6add1, 0xffa7afd4, 0xffa9b1d5, 0xffa9b2d6,
    0xffa9b2d3, 0xffaab2d6, 0xffa8b0d4, 0xffa9b0d4, 0xffa7b0d3, 0xffa7b0d3, 0xffa5acd1, 0xffa3abcf,
    0xffa3abd0, 0xffa0a9cf, 0xffa1a9ce, 0xffa0a7cb, 0xff99a5cc, 0xff98a2ca, 0xff97a2ca, 0xff97a1cb,
    0xff959fc9, 0xff939ec8, 0xff939dc8, 0xff919cc6, 0xff8f9bc4, 0xff8f9ac6, 0xff8b99c3, 0xff8d9ac1,
    0xff8a93c0, 0xff8493c1, 0xff7e8ac8, 0xff718dcf, 0xff82adc0, 0xffaeadaa, 0xffa0859c, 0xff72709c,
    0xff5b6ea4, 0xff526da3, 0xff536ea6, 0xff526ea5, 0xff4e6ca5, 0xff4c6ba2, 0xff4b6a9f, 0xff4b699f,
    0xffadb5ce, 0xff8b99c0, 0xff6f88bc, 0xff7085b9, 0xff7e85ba, 0xff9e93b8, 0xffbfadbb, 0xffcbc9c3,
    0xffb8d0d5, 0xff91b6e3, 0xff8b9be2, 0xff99a0d3, 0xff99a9cb, 0xff95a5d0, 0xff94a2d0, 0xff94a0cc,
    0xff95a2ce, 0xff95a2ce, 0xff95a1cd, 0xff96a2d0, 0xff97a3d0, 0xff96a3ce, 0xff96a3ce, 0xff96a2cf,
    0xff96a3d0, 0xff95a2cf, 0xff96a2cf, 0xff95a3d0, 0xff96a3cf, 0xff98a4d0, 0xff99a6d1, 0xff9ea8d1,
    0xffa0aad2, 0xffa2acd2, 0xffa1abd2, 0xffa3aad0, 0xffa4abd1, 0xffa5add4, 0xffa7afd4, 0xffa7b0d5,
    0xffa7b0d3, 0xffa8b0d5, 0xffa6aed3, 0xffa7aed4, 0xffa5aed2, 0xffa4aed3, 0xffa3aad1, 0xffa0a9cf,
    0xffa1a9d0, 0xff9ea7cd, 0xff9ea6cc, 0xff9da5ca, 0xff97a3cc, 0xff95a0c9, 0xff94a0c8, 0xff949fc9,
    0xff919dc7, 0xff919cc7, 0xff909bc7, 0xff8f9bc4, 0xff8d9ac2, 0xff8c98c4, 0xff8997c1, 0xff8996c2,
    0xff8792be, 0xff8596ba, 0xff7f84c2, 0xff6780cd, 0xff72a2c8, 0xff9fafb6, 0xffa696a1, 0xff897b9a,
    0xff696fa1, 0xff556ca2, 0xff526da5, 0xff516ea5, 0xff4e6ca3, 0xff4c6aa0, 0xff4b6a9f, 0xff4a699f,
    0xffa5afca, 0xff7e8fbc, 0xff6884bb, 0xff6e82b9, 0xff7d7db3, 0xffa999b5, 0xffc3bebd, 0xffb3c9cf,
    0xff99b7de, 0xff8ea7de, 0xff8e9ed6, 0xff959fd0, 0xff93a3ca, 0xff90a0cd, 0xff909fce, 0xff909ecb,
    0xff919fcd, 0xff92a1cd, 0xff92a0cd, 0xff92a2ce, 0xff95a2d0, 0xff94a2ce, 0xff95a3cf, 0xff95a2d1,
    0xff94a1d0, 0xff93a1cf, 0xff95a1cf, 0xff94a2d0, 0xff97a3ce, 0xff97a4d0, 0xff9aa7d2, 0xff9ca7d2,
    0xff9faad3, 0xffa0abd1, 0xff9faad2, 0xffa2a9d0, 0xffa2aad2, 0xffa3acd3, 0xffa5add2, 0xffa6aed3,
    0xffa7aed2, 0xffa7aed4, 0xffa5acd1, 0xffa7aed4, 0xffa4add1, 0xffa2acd3, 0xffa1a8d1, 0xff9da8d0,
    0xff9ea6ce, 0xff9ca5cd, 0xff9aa3cb, 0xff99a2ca, 0xff95a1cb, 0xff949fc9, 0xff929fc8, 0xff919dc7,
    0xff8e9bc5, 0xff909cc6, 0xff8f9bc5, 0xff8e99c4, 0xff8b97c2, 0xff8a96c3, 0xff8895c1, 0xff8793c2,
    0xff8691bf, 0xff8192b9, 0xff7c86be, 0xff6f84c3, 0xff708fc9, 0xff7fa0c4, 0xff9da9aa, 0xffa18c99,
    0xff7a719c, 0xff5a6ba1, 0xff526ca3, 0xff4f6da5, 0xff4e6ba2, 0xff4d69a0, 0xff4c699f, 0xff49689e,
    0xff9da8c6, 0xff7689ba, 0xff6681ba, 0xff7181b8, 0xff8680b1, 0xffaea2b7, 0xffb8c4c2, 0xff97bfd8,
    0xff7d9ee1, 0xff8c9ad5, 0xff90a0ca, 0xff8f9ecc, 0xff8c9dca, 0xff8a9ac9, 0xff8a9bcc, 0xff8b9cca,
    0xff8c9ccb, 0xff8d9fcc, 0xff8f9ecd, 0xff8ea0cd, 0xff92a1cf, 0xff92a2cf, 0xff93a1cf, 0xff94a2d1,
    0xff929fcf, 0xff91a0cf, 0xff93a0cf, 0xff92a1d0, 0xff97a3ce, 0xff97a4d0, 0xff9aa7d3, 0xff9ba7d2,
    0xff9eaad4, 0xff9daad0, 0xff9ca8d2, 0xff9fa8d0, 0xffa0a9d2, 0xffa0abd2, 0xffa3abd0, 0xffa4acd1,
    0xffa5acd2, 0xffa5acd2, 0xffa4abcf, 0xffa5add4, 0xffa3abd0, 0xff9fa9d2, 0xff9fa7d1, 0xff9ba7d1,
    0xff9ba4cd, 0xff99a3cd, 0xff96a0ca, 0xff949fca, 0xff939fc9, 0xff929ec8, 0xff909dc7, 0xff8f9bc6,
    0xff8d9ac4, 0xff8f9bc4, 0xff8d9ac3, 0xff8c97c4, 0xff8a95c2, 0xff8895c1, 0xff8794c0, 0xff8591c1,
    0xff848fc0, 0xff7c8dbb, 0xff7889bb, 0xff798bb9, 0xff7280c6, 0xff638fcc, 0xff8cb0b5, 0xffab9b9f,
    0xff8b799a, 0xff666e9f, 0xff566ba0, 0xff4f6ba4, 0xff4e6aa1, 0xff4d689f, 0xff4c689f, 0xff47669c,
    0xff98a5c5, 0xff7c8ebc, 0xff6980b8, 0xff787fb5, 0xff9f96b6, 0xffaaadbb, 0xff9ab8c9, 0xff85abd9,
    0xff7794da, 0xff8694ce, 0xff8b9dc5, 0xff889ac9, 0xff8697c8, 0xff8597c6, 0xff8598ca, 0xff879ac9,
    0xff899aca, 0xff8a9ccb, 0xff8c9dcc, 0xff8c9ecd, 0xff909fce, 0xff90a1d0, 0xff91a0cf, 0xff93a1d0,
    0xff919fce, 0xff8f9fce, 0xff919fcf, 0xff91a0cf, 0xff96a2cf, 0xff97a3d1, 0xff9aa7d3, 0xff9ba8d2,
    0xff9da9d4, 0xff9ca9d1, 0xff9ba7d2, 0xff9ca7d1, 0xff9da8d2, 0xff9ea9d1, 0xffa1aad0, 0xffa0aad0,
    0xffa2aad2, 0xffa2aad1, 0xffa2aacf, 0xffa3abd4, 0xffa1a8d1, 0xff9ca7d1, 0xff9da6d1, 0xff9aa5d0,
    0xff98a2cc, 0xff97a2cc, 0xff939eca, 0xff919dca, 0xff909cc7, 0xff8f9cc7, 0xff8e9bc6, 0xff8e9ac6,
    0xff8d99c4, 0xff8e9ac3, 0xff8c99c2, 0xff8b96c4, 0xff8994c1, 0xff8795c0, 0xff8794bf, 0xff8490c0,
    0xff818ebe, 0xff7a8bbb, 0xff7789b9, 0xff7a8bb7, 0xff727dc0, 0xff6086c9, 0xff79a2c1, 0xff9ba2ab,
    0xff9b8c9a, 0xff7b739c, 0xff5c6a9d, 0xff4f69a2, 0xff4d69a1, 0xff4c689f, 0xff4b679d, 0xff47659a,
    0xff97a5c5, 0xff8b98c0, 0xff7484b6, 0xff8481b3, 0xffbbb3c1, 0xffa1b7c2, 0xff77a2d1, 0xff7b94d4,
    0xff7d94cd, 0xff8094c8, 0xff8396c6, 0xff8195c7, 0xff8194c5, 0xff8194c5, 0xff8195c7, 0xff8397c8,
    0xff8698c9, 0xff8799ca, 0xff8a9ccb, 0xff8a9ccd, 0xff8e9dcd, 0xff8f9fd0, 0xff8f9ece, 0xff91a0ce,
    0xff91a0cd, 0xff8e9fcc, 0xff909fce, 0xff91a0ce, 0xff94a2d0, 0xff97a3d2, 0xff99a6d3, 0xff9ca9d3,
    0xff9ca8d4, 0xff9ba8d3, 0xff9ba7d2, 0xff9aa7d2, 0xff9ba8d1, 0xff9ca7d1, 0xff9ea8d1, 0xff9ca8d0,
    0xff9ea8d3, 0xff9fa8d1, 0xff9fa9d1, 0xffa0a9d4, 0xff9ea5d2, 0xff9aa5d0, 0xff9ba4d0, 0xff99a3cf,
    0xff96a1cb, 0xff94a1cc, 0xff929dca, 0xff8e9bc9, 0xff8d9ac5, 0xff8d9bc5, 0xff8d99c4, 0xff8e99c6,
    0xff8d98c5, 0xff8d99c3, 0xff8b97c1, 0xff8997c3, 0xff8993c1, 0xff8895c0, 0xff8794be, 0xff848fbe,
    0xff7e8ebc, 0xff7a89bb, 0xff7787b9, 0xff7788b9, 0xff7283b9, 0xff6c83bf, 0xff6789c9, 0xff7da1b9,
    0xffa29f9f, 0xff927b9a, 0xff666b9b, 0xff51679e, 0xff4c68a1, 0xff4b689f, 0xff4a669b, 0xff476498,
    0xff98a5c5, 0xff98a0c2, 0xff888eb8, 0xff958eb5, 0xffcac8cb, 0xff9dbccc, 0xff6291d3, 0xff7586ce,
    0xff8193c4, 0xff7b93c4, 0xff7d91c5, 0xff7c91c5, 0xff7d91c4, 0xff7d92c5, 0xff7e93c6, 0xff8196c8,
    0xff8397c9, 0xff8497ca, 0xff889bcb, 0xff899bcd, 0xff8d9ccd, 0xff8e9ed0, 0xff8d9dce, 0xff8e9fcd,
    0xff90a0cd, 0xff8d9fcc, 0xff8f9fce, 0xff909fce, 0xff93a1d0, 0xff97a2d2, 0xff99a6d2, 0xff9ca9d3,
    0xff9ba7d3, 0xff9aa7d3, 0xff9aa6d2, 0xff98a6d2, 0xff99a7d0, 0xff9aa5d0, 0xff9ba7d1, 0xff98a6d0,
    0xff9aa6d2, 0xff9ba7d1, 0xff9ca8d1, 0xff9da7d3, 0xff9ba3d2, 0xff98a4cf, 0xff98a3cf, 0xff98a1ce,
    0xff93a0cb, 0xff91a0cb, 0xff909cc9, 0xff8b99c8, 0xff8a97c4, 0xff8b98c4, 0xff8b97c3, 0xff8e98c6,
    0xff8d97c5, 0xff8c98c3, 0xff8a96c0, 0xff8896c2, 0xff8893c0, 0xff8794bf, 0xff8693bd, 0xff838ebd,
    0xff7c8dba, 0xff7988bb, 0xff7686b9, 0xff7384ba, 0xff7186b4, 0xff7382b7, 0xff5f79c9, 0xff6799c4,
    0xff9aa8a9, 0xff9f8a9c, 0xff787199, 0xff59669a, 0xff4c669e, 0xff4b689e, 0xff496599, 0xff476396,
    0xff9ba6c4, 0xff9fa3c3, 0xffa29ebd, 0xffa8a6bb, 0xffc3cdd3, 0xffa2bbd7, 0xff658bce, 0xff7487c7,
    0xff7c90c2, 0xff7890c2, 0xff7b8fc3, 0xff7a8fc4, 0xff7a90c5, 0xff7a90c7, 0xff7c92c6, 0xff7f95c8,
    0xff8196c8, 0xff8397c9, 0xff8699ca, 0xff8899cc, 0xff8b9bcd, 0xff8c9dd0, 0xff8b9cce, 0xff8b9dcd,
    0xff8e9ece, 0xff8d9ecd, 0xff8f9fcf, 0xff8f9ece, 0xff91a1d0, 0xff97a2d2, 0xff99a6d2, 0xff9ba8d3,
    0xff9aa6d3, 0xff98a5d2, 0xff98a5d1, 0xff96a3d1, 0xff97a4cf, 0xff98a3cf, 0xff98a5d0, 0xff97a4cf,
    0xff97a3cf, 0xff99a5d0, 0xff99a6d0, 0xff9ba5d1, 0xff98a1cf, 0xff96a2ce, 0xff95a0ce, 0xff949fcd,
    0xff919dcb, 0xff8f9dca, 0xff8e9ac7, 0xff8a97c6, 0xff8896c2, 0xff8996c3, 0xff8995c2, 0xff8c97c4,
    0xff8b96c3, 0xff8b97c3, 0xff8995bf, 0xff8694bf, 0xff8793bf, 0xff8491bd, 0xff8390bc, 0xff808cbc,
    0xff798bb8, 0xff7687b9, 0xff7484b8, 0xff7083b8, 0xff7085b3, 0xff7181b5, 0xff6479bf, 0xff638cc8,
    0xff81a1b8, 0xff9e9ca3, 0xff8e7c97, 0xff646797, 0xff4f659a, 0xff4b669b, 0xff496297, 0xff466193,
    0xff9ea6c3, 0xffa4a3c2, 0xffb9aec3, 0xffb5bcc3, 0xffb3c7d7, 0xffa9b5df, 0xff748bc6, 0xff768dc1,
    0xff768ec4, 0xff778ec3, 0xff7a8fc1, 0xff798fc3, 0xff788fc6, 0xff788fc8, 0xff7b92c8, 0xff7f94c9,
    0xff7f95c9, 0xff8298c9, 0xff8598cb, 0xff8798cb, 0xff899bce, 0xff8b9dcf, 0xff8a9bce, 0xff899bcd,
    0xff8c9ccf, 0xff8d9dcf, 0xff8e9ecf, 0xff8e9ecf, 0xff90a1cf, 0xff96a2d2, 0xff98a5d1, 0xff9aa7d3,
    0xff99a6d2, 0xff96a3d0, 0xff96a3d1, 0xff95a1d0, 0xff96a2ce, 0xff96a3cd, 0xff96a3cf, 0xff96a3cd,
    0xff95a2cd, 0xff98a4d0, 0xff96a4cf, 0xff98a4cf, 0xff95a0cc, 0xff94a1cd, 0xff929ece, 0xff919ecc,
    0xff8f9bca, 0xff8d9ac8, 0xff8c98c5, 0xff8895c4, 0xff8694c1, 0xff8894c2, 0xff8795c2, 0xff8a96c3,
    0xff8a95c2, 0xff8a96c2, 0xff8894bf, 0xff8492be, 0xff8692be, 0xff828fbb, 0xff808dba, 0xff7c8bbb,
    0xff7889b6, 0xff7486b7, 0xff7283b7, 0xff6e81b5, 0xff6e82b3, 0xff6d82b4, 0xff6d80b2, 0xff687fc7,
    0xff6792c5, 0xff92a9ac, 0xff9e8898, 0xff726b94, 0xff546496, 0xff4c6598, 0xff496195, 0xff456091,
    0xff9da2c0, 0xffaba6c0, 0xffc2bcc6, 0xffb4c4cb, 0xffa6bcda, 0xffaab1de, 0xff7e8fc3, 0xff738ebf,
    0xff728cc4, 0xff778cc3, 0xff778ec1, 0xff788fc4, 0xff778fc7, 0xff778fc9, 0xff7a92c8, 0xff7e93c9,
    0xff7f95ca, 0xff8298ca, 0xff8598cc, 0xff8798cb, 0xff899bce, 0xff899dce, 0xff889bce, 0xff879acd,
    0xff8a9ace, 0xff8d9dcf, 0xff8d9dcf, 0xff8e9ecf, 0xff90a1cf, 0xff95a2d1, 0xff97a4d1, 0xff98a4d2,
    0xff97a4d2, 0xff94a1ce, 0xff94a1cf, 0xff939fd0, 0xff94a0cd, 0xff94a1cc, 0xff94a1cd, 0xff94a1cd,
    0xff93a0cc, 0xff95a1ce, 0xff94a2ce, 0xff96a2cd, 0xff939fcb, 0xff919fcd, 0xff909ccc, 0xff8e9ccb,
    0xff8d99ca, 0xff8b98c7, 0xff8996c5, 0xff8794c4, 0xff8593c1, 0xff8792c2, 0xff8795c2, 0xff8895c1,
    0xff8894c0, 0xff8895c1, 0xff8693bf, 0xff8490bc, 0xff8491bd, 0xff808dbb, 0xff7e8bb9, 0xff7989b9,
    0xff7587b5, 0xff7185b5, 0xff7082b5, 0xff6c80b3, 0xff6c80b2, 0xff6a81b3, 0xff7082ab, 0xff6a79c1,
    0xff5b86c9, 0xff7ea4b7, 0xff9b949e, 0xff837793, 0xff606591, 0xff4e6294, 0xff485f92, 0xff435e8e,
    0xff9a9abc, 0xffb3abbe, 0xffbcc2c6, 0xffa6bcd1, 0xff9fafd9, 0xffa5aed5, 0xff8495c4, 0xff6c8ac1,
    0xff708ac3, 0xff778cc4, 0xff748dc3, 0xff768ec6, 0xff778fc7, 0xff778fc9, 0xff7a92c8, 0xff7d91c8,
    0xff8095cc, 0xff8399cc, 0xff8599ce, 0xff8799cc, 0xff889acd, 0xff879ccd, 0xff869acd, 0xff879acc,
    0xff8899cc, 0xff8c9cce, 0xff8b9bcd, 0xff8f9fd0, 0xff91a0cf, 0xff95a2d0, 0xff96a4d0, 0xff95a1d0,
    0xff95a1d1, 0xff929fcd, 0xff939ecd, 0xff939fcf, 0xff919ecd, 0xff929fcc, 0xff939fcd, 0xff929fcd,
    0xff929fcc, 0xff939fcc, 0xff94a0cd, 0xff94a1cd, 0xff929ecb, 0xff8f9dcc, 0xff8e9aca, 0xff8d9aca,
    0xff8b98c9, 0xff8997c7, 0xff8694c6, 0xff8693c3, 0xff8592c1, 0xff8591c2, 0xff8795c2, 0xff8895c1,
    0xff8794c0, 0xff8693c0, 0xff8491be, 0xff8491bc, 0xff828fbc, 0xff7f8dbb, 0xff7c8ab9, 0xff7789b8,
    0xff7384b5, 0xff6f83b4, 0xff6e82b4, 0xff6b80b3, 0xff697fb2, 0xff687fb2, 0xff6c80ac, 0xff6b7bb7,
    0xff6080c2, 0xff6891c1, 0xff879ca6, 0xff938692, 0xff6e678d, 0xff4f6091, 0xff475f90, 0xff415d8c,
    0xff9896b8, 0xffb4afbd, 0xffacbfc5, 0xff96aed3, 0xff9aa3d5, 0xff9faacb, 0xff8a9cc7, 0xff6987c3,
    0xff708ac2, 0xff758bc4, 0xff718cc4, 0xff748ec7, 0xff778fc7, 0xff778fc8, 0xff7a91c7, 0xff7c90c8,
    0xff8095cd, 0xff8399cf, 0xff8499cf, 0xff869acd, 0xff889acd, 0xff859bcd, 0xff859acd, 0xff879acc,
    0xff8699cc, 0xff8a9cce, 0xff8a9acd, 0xff8fa0d0, 0xff91a0d0, 0xff93a1cf, 0xff94a2cf, 0xff939fcf,
    0xff939fd0, 0xff919ecd, 0xff919ccc, 0xff919fce, 0xff8f9dcc, 0xff909dcc, 0xff919dcc, 0xff909ecd,
    0xff919ecd, 0xff909ccb, 0xff939ecd, 0xff929fcd, 0xff909ccc, 0xff8c9bcb, 0xff8d99c9, 0xff8b98c9,
    0xff8a97c8, 0xff8896c7, 0xff8493c7, 0xff8593c4, 0xff8592c2, 0xff8492c3, 0xff8895c2, 0xff8895c1,
    0xff8794c0, 0xff8592bf, 0xff8491bf, 0xff8491bd, 0xff818dbb, 0xff7f8dbb, 0xff7b89b8, 0xff7588b6,
    0xff7183b4, 0xff6d81b3, 0xff6d81b2, 0xff6a7fb2, 0xff677eb0, 0xff677db0, 0xff677dae, 0xff6b7fad,
    0xff687bb8, 0xff587dc4, 0xff709cb0, 0xff969395, 0xff7c6f8c, 0xff56618e, 0xff495f8d, 0xff415c8b,
    0xff9e99b6, 0xffabb4be, 0xff99b2c8, 0xff91a6d2, 0xff98a0ce, 0xff98a6c7, 0xff92a3c9, 0xff6c88c3,
    0xff6d88c0, 0xff6d86c2, 0xff6d89c3, 0xff728cc6, 0xff778fc7, 0xff758ec7, 0xff7a90c7, 0xff7c90c9,
    0xff7c94cd, 0xff8096d0, 0xff8197cd, 0xff859acc, 0xff879acd, 0xff839ace, 0xff849ace, 0xff869ace,
    0xff8599ce, 0xff889cce, 0xff8a9bce, 0xff8d9fd0, 0xff91a0d0, 0xff91a1cf, 0xff93a0cf, 0xff929ecf,
    0xff929ed0, 0xff909dcd, 0xff8f9bcc, 0xff8e9ecd, 0xff8d9bcb, 0xff8f9ccc, 0xff8f9ccb, 0xff8e9dcc,
    0xff8f9dcc, 0xff8e9bcb, 0xff909ccb, 0xff8f9ccb, 0xff8d9aca, 0xff8998c9, 0xff8b97c8, 0xff8896c8,
    0xff8896c7, 0xff8795c7, 0xff8392c6, 0xff8593c4, 0xff8693c4, 0xff8693c5, 0xff8996c2, 0xff8996c2,
    0xff8895c1, 0xff8793c0, 0xff8693c1, 0xff8491bd, 0xff818dbb, 0xff7e8cbb, 0xff7a88b8, 0xff7588b5,
    0xff7183b3, 0xff6e81b3, 0xff6c80b1, 0xff6a7fb1, 0xff667eae, 0xff667cad, 0xff667cae, 0xff697eaa,
    0xff6879b0, 0xff5776bd, 0xff618fba, 0xff86979f, 0xff897f8c, 0xff65648b, 0xff4b5d8b, 0xff415c8c,
    0xffa4a0b5, 0xff9cb5c0, 0xff87a0cb, 0xff91a0cd, 0xff98a1c6, 0xff93a2c7, 0xff98a7ca, 0xff758dc3,
    0xff6c87bf, 0xff6582bf, 0xff6b86c2, 0xff708bc4, 0xff768ec6, 0xff738dc6, 0xff7a8fc7, 0xff7c91ca,
    0xff7792cc, 0xff7d93d0, 0xff7d95cb, 0xff8399cc, 0xff8699cd, 0xff829acf, 0xff849acf, 0xff849ad0,
    0xff859ad2, 0xff879dce, 0xff8b9dcf, 0xff8b9dcf, 0xff90a0d0, 0xff90a0cf, 0xff929fcf, 0xff929fd0,
    0xff909ecf, 0xff909dcf, 0xff8d9bcd, 0xff8b9dcb, 0xff8c9acb, 0xff8e9ccd, 0xff8d9ccb, 0xff8c9ccb,
    0xff8d9bca, 0xff8d9acc, 0xff8d9ac9, 0xff8c99c8, 0xff8998c7, 0xff8795c7, 0xff8997c9, 0xff8795c8,
    0xff8695c6, 0xff8795c7, 0xff8492c5, 0xff8694c5, 0xff8895c6, 0xff8995c7, 0xff8997c3, 0xff8b98c3,
    0xff8a97c2, 0xff8996c2, 0xff8895c2, 0xff8491be, 0xff828fbc, 0xff7e8cba, 0xff7988b7, 0xff7687b4,
    0xff7284b2, 0xff7082b3, 0xff6b80b1, 0xff697eb0, 0xff667dad, 0xff667cab, 0xff657bad, 0xff667bab,
    0xff6579aa, 0xff6077ae, 0xff597dbf, 0xff6c95aa, 0xff8e8f90, 0xff756b8a, 0xff515c89, 0xff435d8e,
    0xffa0a5b5, 0xff8dafc3, 0xff7c92ca, 0xff8e9ac7, 0xff94a0c0, 0xff8f9ec7, 0xff9daacb, 0xff8194c3,
    0xff768fc2, 0xff6c87c1, 0xff6e88c2, 0xff708ac2, 0xff718bc4, 0xff738cc6, 0xff778dc7, 0xff7890ca,
    0xff7793cc, 0xff7e94d0, 0xff7e95ca, 0xff8299cc, 0xff8599ce, 0xff829ad0, 0xff849ad0, 0xff849bd3,
    0xff859bd5, 0xff879ed1, 0xff8b9ed1, 0xff8a9dd0, 0xff8fa0d1, 0xff8fa0d0, 0xff909dce, 0xff909fcf,
    0xff8f9dce, 0xff8e9bce, 0xff8b9bcd, 0xff8a9cca, 0xff8b9aca, 0xff8d9bcc, 0xff8b9ccc, 0xff8b9cca,
    0xff8c9bc9, 0xff8c9bcd, 0xff8a9aca, 0xff8a99c9, 0xff8798c9, 0xff8795c8, 0xff8897ca, 0xff8897ca,
    0xff8696c8, 0xff8896c9, 0xff8594c6, 0xff8795c7, 0xff8996c9, 0xff8b96c8, 0xff8a97c4, 0xff8c99c4,
    0xff8b97c3, 0xff8a97c3, 0xff8996c3, 0xff8491be, 0xff828fbc, 0xff7d8bba, 0xff7888b7, 0xff7687b3,
    0xff7284b1, 0xff7082b3, 0xff6a7fb0, 0xff697eaf, 0xff667dab, 0xff657ca9, 0xff657aac, 0xff6379ab,
    0xff6379a6, 0xff6679a5, 0xff5872be, 0xff598cb4, 0xff87979a, 0xff82788c, 0xff5e6088, 0xff475d8d,
    0xff91a5b6, 0xff819fc4, 0xff7b8ec4, 0xff8895c1, 0xff8b9bbd, 0xff8e9cc5, 0xff9fabcc, 0xff8e9dc6,
    0xff8b9ec9, 0xff8497c9, 0xff7890c5, 0xff718ac3, 0xff6785c0, 0xff738cc5, 0xff728bc6, 0xff708cc8,
    0xff7e95cd, 0xff869ad1, 0xff8499cb, 0xff8299cf, 0xff8499d1, 0xff829ad1, 0xff8499d0, 0xff859cd4,
    0xff879cd6, 0xff899fd4, 0xff8b9fd4, 0xff8b9fd3, 0xff8da0d2, 0xff8f9fd0, 0xff8d9ccd, 0xff8d9dce,
    0xff8c9acc, 0xff8b9acd, 0xff8a9acc, 0xff8a9bca, 0xff899aca, 0xff8b99ca, 0xff8a9bcd, 0xff8b9bca,
    0xff8a9aca, 0xff8b9bce, 0xff899ccf, 0xff8a9cce, 0xff879ace, 0xff8898cc, 0xff8999cd, 0xff8c9bce,
    0xff8999cc, 0xff8a99cc, 0xff8897ca, 0xff8897ca, 0xff8997ca, 0xff8c97c8, 0xff8b97c6, 0xff8b99c6,
    0xff8996c4, 0xff8896c3, 0xff8894c2, 0xff8391be, 0xff808ebc, 0xff7c8ab9, 0xff7888b6, 0xff7586b3,
    0xff7283b0, 0xff6d81b3, 0xff697fae, 0xff687dad, 0xff657ca9, 0xff647ba9, 0xff6479ab, 0xff6277a9,
    0xff6178a5, 0xff6678a4, 0xff5d73b6, 0xff557fb9, 0xff7294a7, 0xff888890, 0xff706987, 0xff4e5e8b,
    0xff7da1b9, 0xff788ec4, 0xff7e8ebc, 0xff8092bc, 0xff8395bd, 0xff8e9bc3, 0xff9daacb, 0xff98a4c8,
    0xffa0accf, 0xff9da9d0, 0xff859bc9, 0xff788ec5, 0xff6383bf, 0xff7991c6, 0xff6f8bc6, 0xff6c8bc7,
    0xff899ace, 0xff91a3d2, 0xff8ca0ce, 0xff829ad2, 0xff839ad3, 0xff839ad2, 0xff8499d1, 0xff879dd6,
    0xff889dd7, 0xff8ba0d8, 0xff8a9fd5, 0xff8ca0d5, 0xff8ca0d4, 0xff8e9fd2, 0xff8b9ccd, 0xff8a9dcd,
    0xff8a99cc, 0xff8899cd, 0xff8999cc, 0xff8b9bcc, 0xff889bcb, 0xff8998ca, 0xff899cd0, 0xff8b9ccc,
    0xff899cce, 0xff8b9dd1, 0xff899fd5, 0xff8ba0d5, 0xff899ed4, 0xff8a9dd1, 0xff8b9dd1, 0xff90a0d2,
    0xff8d9dd0, 0xff8b9bcf, 0xff899acd, 0xff8998cc, 0xff8898cb, 0xff8c98c7, 0xff8b97c7, 0xff8998c6,
    0xff8794c3, 0xff8594c2, 0xff8691c0, 0xff8290bd, 0xff7e8cbc, 0xff7b89b8, 0xff7787b5, 0xff7385b2,
    0xff7282b0, 0xff6a7fb2, 0xff677ead, 0xff677cac, 0xff647aa7, 0xff6379a9, 0xff6378a9, 0xff6177a7,
    0xff6178a6, 0xff6378a6, 0xff657aab, 0xff5973ba, 0xff5c8ab3, 0xff869597, 0xff817588, 0xff586189,
    0xff6c96bd, 0xff7184c1, 0xff788bb8, 0xff798db8, 0xff7d91bd, 0xff8c99c1, 0xff98a6c9, 0xff9ca8c8,
    0xffaab3d0, 0xffacb3d3, 0xff9baacf, 0xff8e9ecc, 0xff738fc4, 0xff8c9fcc, 0xff7590c9, 0xff7893c9,
    0xff98a4d0, 0xffa0add4, 0xff97a7d0, 0xff819ad4, 0xff819bd5, 0xff839bd3, 0xff849bd4, 0xff879dd6,
    0xff879dd7, 0xff8aa0d9, 0xff899fd6, 0xff8ba1d6, 0xff8ba0d7, 0xff8da1d5, 0xff8a9fd2, 0xff889ed0,
    0xff889bd0, 0xff879bd1, 0xff889bcf, 0xff8a9dd1, 0xff889dd0, 0xff879bd0, 0xff889fd6, 0xff8a9fd5,
    0xff889fd6, 0xff8ba2da, 0xff8ba4dc, 0xff8ea5db, 0xff8ea3d9, 0xff8fa2d7, 0xff8ea0d5, 0xff91a2d5,
    0xff8f9fd3, 0xff8d9dd1, 0xff8a9ccf, 0xff899acd, 0xff8898cb, 0xff8a98c7, 0xff8b97c7, 0xff8695c5,
    0xff8592c3, 0xff8292c0, 0xff828fbe, 0xff7f8ebb, 0xff7c8aba, 0xff7888b7, 0xff7686b5, 0xff7183b1,
    0xff7082b0, 0xff687faf, 0xff667dad, 0xff657caa, 0xff637aa6, 0xff6279a8, 0xff6278a7, 0xff6177a5,
    0xff6177a5, 0xff6178a6, 0xff687ca5, 0xff5e6fb5, 0xff527fbb, 0xff7a97a4, 0xff8b858f, 0xff6b6a8a,
    0xff6287c1, 0xff6d84bd, 0xff6d87b8, 0xff7389b8, 0xff7b90bc, 0xff8997bf, 0xff93a0c7, 0xff9ba7c7,
    0xffa7afcd, 0xffadb3d0, 0xffb1b8d6, 0xffabb4d6, 0xff92a4ce, 0xffa7b2d3, 0xff8298cd, 0xff8fa3ce,
    0xffa6afd3, 0xffadb5d6, 0xffa1aed2, 0xff809bd6, 0xff819dd6, 0xff839dd5, 0xff849fd7, 0xff859ed5,
    0xff849dd6, 0xff89a0d8, 0xff879ed6, 0xff89a0d6, 0xff8ba1d9, 0xff8ca4da, 0xff8aa2da, 0xff89a0d5,
    0xff88a0d7, 0xff879fd9, 0xff879dd6, 0xff889fd7, 0xff87a0d7, 0xff879fd8, 0xff87a2de, 0xff89a4e0,
    0xff86a4e1, 0xff8ca8e5, 0xff8ea8e1, 0xff90a8df, 0xff94a7db, 0xff94a6dc, 0xff92a3d8, 0xff90a2d6,
    0xff8f9fd4, 0xff8e9dd1, 0xff8a9bce, 0xff889acc, 0xff8798ca, 0xff8898c6, 0xff8996c6, 0xff8493c2,
    0xff8392c2, 0xff8090be, 0xff7e8dbc, 0xff7b8bb9, 0xff798ab8, 0xff7687b6, 0xff7585b4, 0xff7082b1,
    0xff6d81b0, 0xff687fac, 0xff667cad, 0xff657ba8, 0xff637aa6, 0xff6278a7, 0xff6178a4, 0xff6178a4,
    0xff6077a3, 0xff6077a4, 0xff667ba5, 0xff6275ac, 0xff5777bb, 0xff688fb2, 0xff8b9499, 0xff80768f,
    0xff5d7ac2, 0xff6a85b9, 0xff6383b8, 0xff6d86b8, 0xff798ebc, 0xff8494bd, 0xff8b9ac4, 0xff95a3c4,
    0xff9ea8c8, 0xffa5adcb, 0xffbcbed8, 0xffbfc3db, 0xffafb7d7, 0xffbcc1d9, 0xff93a2d2, 0xffa5b0d3,
    0xffb2b9d5, 0xffb6bbd7, 0xffaab4d3, 0xff839dd6, 0xff7f9dd5, 0xff829dd6, 0xff84a1da, 0xff849fd6,
    0xff85a0d8, 0xff88a1d8, 0xff869fd7, 0xff87a1d8, 0xff8aa2dd, 0xff89a7e0, 0xff8aa6e3, 0xff89a4de,
    0xff87a6e1, 0xff88a4e2, 0xff86a2df, 0xff86a4e0, 0xff86a4e1, 0xff86a5e3, 0xff86a7e7, 0xff86aaec,
    0xff86a9ec, 0xff8cadee, 0xff8face6, 0xff91abe4, 0xff97aadf, 0xff96aae1, 0xff93a5dc, 0xff8da1d7,
    0xff8d9fd4, 0xff8e9dd1, 0xff899ace, 0xff889acb, 0xff8697c9, 0xff8697c6, 0xff8795c4, 0xff8290bf,
    0xff8291c0, 0xff7e8ebc, 0xff7a8cba, 0xff7889b7, 0xff7789b6, 0xff7386b5, 0xff7384b3, 0xff6f81af,
    0xff6a80af, 0xff687eaa, 0xff657bad, 0xff647ba6, 0xff627aa6, 0xff6178a5, 0xff6078a2, 0xff6178a3,
    0xff6177a3, 0xff6178a3, 0xff647aa7, 0xff667ba5, 0xff6073b7, 0xff5984bc, 0xff839ca6, 0xff908495,
    0xff5b78bd, 0xff6683b6, 0xff5f81b7, 0xff6884b7, 0xff748bbb, 0xff7f91bd, 0xff8596c0, 0xff8e9dc2,
    0xff97a2c5, 0xff9aa5c6, 0xffb1b6d2, 0xffbcc0d8, 0xffbbbfda, 0xffc0c3da, 0xffa4aed5, 0xffadb5d4,
    0xffb7bdd7, 0xffb8bcd7, 0xffb1b8d5, 0xff8aa1d5, 0xff7c9ad3, 0xff809cd5, 0xff85a1db, 0xff86a3db,
    0xff8da7df, 0xff8ca5dc, 0xff89a3dc, 0xff88a4de, 0xff86a2e0, 0xff86a8e5, 0xff88a8ea, 0xff87aaec,
    0xff86acee, 0xff87a9ec, 0xff85a9ec, 0xff84aaec, 0xff84a8ec, 0xff84aaee, 0xff85abf0, 0xff83acf4,
    0xff88acf1, 0xff8daff0, 0xff8eaeeb, 0xff8fade9, 0xff94ace6, 0xff93ace6, 0xff91a5de, 0xff8ba1d9,
    0xff8b9ed5, 0xff8c9dd2, 0xff899bcf, 0xff899acb, 0xff8697ca, 0xff8697c7, 0xff8594c4, 0xff8290be,
    0xff8290bf, 0xff7d8dbb, 0xff798bb9, 0xff7788b6, 0xff7588b5, 0xff7285b4, 0xff7283b2, 0xff6f80ae,
    0xff697fae, 0xff677daa, 0xff657aac, 0xff637ba6, 0xff627aa6, 0xff6178a5, 0xff5f77a1, 0xff6077a2,
    0xff647aa6, 0xff647aa6, 0xff657ba7, 0xff687ea5, 0xff6474b0, 0xff597dbe, 0xff7598b3, 0xff96939b,
    0xff5d7cb6, 0xff6381b5, 0xff6080b7, 0xff6582b7, 0xff6f88ba, 0xff7a8ebd, 0xff8092bd, 0xff8796bf,
    0xff8f9dc3, 0xff8d9bc2, 0xff9aa5c8, 0xffabb2cf, 0xffbabed8, 0xffb8bcd8, 0xffb1b8d6, 0xffaab2d2,
    0xffb6bbd8, 0xffb4b9d6, 0xffb5bad6, 0xff93a5d3, 0xff7995cf, 0xff7e99d2, 0xff85a0da, 0xff89a7e1,
    0xff96aee7, 0xff91a8e1, 0xff8da8e2, 0xff8aa7e5, 0xff81a2e2, 0xff83a7ea, 0xff85a9ee, 0xff84b0f8,
    0xff84b0f8, 0xff85aef4, 0xff83b0f7, 0xff83b0f7, 0xff82acf5, 0xff81aef6, 0xff83aef7, 0xff81adf8,
    0xff8baef3, 0xff8dafed, 0xff8baeef, 0xff8badee, 0xff8caded, 0xff8eacea, 0xff8ca4e0, 0xff8aa1db,
    0xff899dd5, 0xff8a9dd3, 0xff8a9bd0, 0xff8a99cc, 0xff8797ca, 0xff8797c7, 0xff8393c3, 0xff8290bf,
    0xff818fbe, 0xff7d8cba, 0xff798bb9, 0xff7688b5, 0xff7486b4, 0xff7183b2, 0xff7183b2, 0xff6e7fac,
    0xff687ead, 0xff667bab, 0xff647aaa, 0xff637aa6, 0xff6279a5, 0xff6279a5, 0xff5d75a0, 0xff5e75a2,
    0xff677daa, 0xff687daa, 0xff677ca8, 0xff697ea9, 0xff677aa9, 0xff617abb, 0xff658dbd, 0xff919d9f,
    0xff5e7fb2, 0xff607fb5, 0xff607fb6, 0xff6382b7, 0xff6a86b9, 0xff748abd, 0xff7b8fbb, 0xff8191be,
    0xff8698c1, 0xff8192bf, 0xff8696bf, 0xff9ba4c7, 0xffb4b8d4, 0xffafb4d4, 0xffb8bcd5, 0xffa6afcf,
    0xffb3b9d6, 0xffb0b6d4, 0xffb6bbd6, 0xff99a8d2, 0xff7590cb, 0xff7b95ce, 0xff849ed7, 0xff89a6e1,
    0xff96ade6, 0xff90a7e0, 0xff8ea9e2, 0xff8eaae9, 0xff84a6e6, 0xff83a7eb, 0xff84a7ec, 0xff82aff9,
    0xff83aef8, 0xff83adf4, 0xff82b1fb, 0xff82b5fe, 0xff81b0fb, 0xff80b0fb, 0xff83b1fb, 0xff81b0fa,
    0xff8cb1f6, 0xff8badec, 0xff87acef, 0xff86abee, 0xff87abee, 0xff8babeb, 0xff8aa6e5, 0xff89a3e0,
    0xff8a9fd8, 0xff899fd6, 0xff899bd0, 0xff8998cc, 0xff8696ca, 0xff8696c7, 0xff8192c3, 0xff8290bf,
    0xff7f8ebd, 0xff7c8bba, 0xff798ab8, 0xff7688b5, 0xff7385b4, 0xff7182b1, 0xff7082b1, 0xff6c7eab,
    0xff677dac, 0xff6479ab, 0xff6379a7, 0xff6279a6, 0xff6178a4, 0xff6178a4, 0xff5d74a0, 0xff5d74a1,
    0xff687eab, 0xff697eab, 0xff687da9, 0xff6a7dac, 0xff6a7fa6, 0xff6979b5, 0xff5d82c2, 0xff859fa7,
    0xff5c7fb2, 0xff5e7eb5, 0xff5f7eb5, 0xff6382b7, 0xff6784b8, 0xff6f87bc, 0xff768dbb, 0xff7d90bd,
    0xff7f92c0, 0xff798dbd, 0xff7b8dba, 0xff949cc0, 0xffadb2ce, 0xffaab0cf, 0xffb5b8d3, 0xffa3adcd,
    0xffb2b7d2, 0xffadb4d2, 0xffb5bad5, 0xff9ba8d0, 0xff708cc6, 0xff7991ca, 0xff809cd4, 0xff84a0da,
    0xff8aa2da, 0xff89a1d8, 0xff8aa5dc, 0xff93ace7, 0xff90aeeb, 0xff86a8ea, 0xff84a4e4, 0xff81a8ed,
    0xff82a7ec, 0xff80a7ec, 0xff80acf3, 0xff81b5ff, 0xff81b3fc, 0xff80b1fb, 0xff84b3fc, 0xff84b4fa,
    0xff8ab5fa, 0xff88abee, 0xff83a7eb, 0xff82a6ea, 0xff87a8ea, 0xff8baae8, 0xff8baaeb, 0xff89a8e6,
    0xff8da3db, 0xff8ba1d9, 0xff8699d1, 0xff8597cb, 0xff8394c7, 0xff8393c4, 0xff7e90c2, 0xff7f8ebe,
    0xff7b8bbc, 0xff7989b9, 0xff7788b6, 0xff7586b4, 0xff7283b3, 0xff7081b0, 0xff6e81ae, 0xff687da9,
    0xff657aaa, 0xff6277a9, 0xff6076a4, 0xff6077a4, 0xff5f76a2, 0xff5e75a1, 0xff5e75a1, 0xff5d73a0,
    0xff657ca8, 0xff677ca9, 0xff697caa, 0xff6b7dad, 0xff6c80a8, 0xff6d7caf, 0xff617ec0, 0xff7597b2,
    0xff5b7fb5, 0xff5d7db6, 0xff5e7eb5, 0xff6382b7, 0xff6584b9, 0xff6b86bc, 0xff728cbd, 0xff7990be,
    0xff798dc0, 0xff758bbd, 0xff778abb, 0xff8f98bf, 0xffa2aac9, 0xffa4accb, 0xffabb1d1, 0xff9eaacc,
    0xffaeb3cf, 0xffa9b1d0, 0xffb0b7d3, 0xff99a6cf, 0xff6d8ac4, 0xff768fc7, 0xff7c99d0, 0xff7e98d1,
    0xff7c95cc, 0xff8099cf, 0xff849ed3, 0xff95abe2, 0xff9ab4ee, 0xff89a7e6, 0xff84a1db, 0xff819edd,
    0xff829fdd, 0xff7fa0e3, 0xff80a5ea, 0xff81b4fe, 0xff83b6fa, 0xff82b2fa, 0xff85b5fa, 0xff87b8f9,
    0xff87b8fd, 0xff85aaf0, 0xff80a3e7, 0xff80a2e6, 0xff88a6e5, 0xff8da9e5, 0xff8caeef, 0xff89abeb,
    0xff90a8de, 0xff8ca2db, 0xff8297d0, 0xff8195ca, 0xff8092c4, 0xff7f8fc2, 0xff7c8ec1, 0xff7d8cbc,
    0xff788abb, 0xff7687b8, 0xff7587b5, 0xff7384b3, 0xff7282b2, 0xff6f80af, 0xff6c80ac, 0xff657ca9,
    0xff6378a9, 0xff6076a7, 0xff5e74a1, 0xff5e75a1, 0xff5d74a0, 0xff5c739f, 0xff5e75a1, 0xff5d739f,
    0xff6178a4, 0xff6378a5, 0xff697caa, 0xff6b7cac, 0xff6d7fac, 0xff6f80aa, 0xff697cb9, 0xff658bbb,
    0xff597db6, 0xff5b7db8, 0xff5d7eb6, 0xff6282ba, 0xff6284ba, 0xff6784bd, 0xff6c89c0, 0xff728dc1,
    0xff728bc3, 0xff708bc3, 0xff758dc4, 0xff8697c6, 0xff93a1c8, 0xff98a5c9, 0xff9eaad2, 0xff96a6cf,
    0xffa6adcd, 0xffa2accd, 0xffa6afd0, 0xff96a4ce, 0xff6e8cc5, 0xff748dc7, 0xff7796cc, 0xff7a93cc,
    0xff7691c8, 0xff7a95cc, 0xff7f99cf, 0xff8ea4da, 0xff95aee7, 0xff8aa6e2, 0xff85a0d8, 0xff7f98d4,
    0xff8099d6, 0xff7d9ee2, 0xff81a7eb, 0xff82b7ff, 0xff86bbfc, 0xff85b6f9, 0xff86b8fa, 0xff88baf9,
    0xff85bafd, 0xff83aef4, 0xff80a7ea, 0xff80a7e9, 0xff87a7e8, 0xff8da9e6, 0xff8aaced, 0xff85a9eb,
    0xff8ea7e0, 0xff8aa0da, 0xff8196cf, 0xff7d93c8, 0xff7c8fc2, 0xff7b8dc1, 0xff7a8cbf, 0xff7c8bbc,
    0xff7789bb, 0xff7487b8, 0xff7385b5, 0xff7183b3, 0xff6f81b2, 0xff6d80af, 0xff6a7fac, 0xff647caa,
    0xff6378a9, 0xff5f76a5, 0xff5c729f, 0xff5c739f, 0xff5b719e, 0xff5b719d, 0xff5d74a0, 0xff5d739f,
    0xff5f76a3, 0xff5f75a1, 0xff6a7daa, 0xff6b7caa, 0xff6d7fad, 0xff7081a9, 0xff6e7bb2, 0xff5e82bf,
    0xff597cb5, 0xff5b7cb9, 0xff5c7fb8, 0xff5f81bd, 0xff6183bc, 0xff6584c0, 0xff6585c3, 0xff6a8ac4,
    0xff6d8bc8, 0xff6e8ecb, 0xff7696d2, 0xff7e9bd4, 0xff859aca, 0xff899eca, 0xff92a6d6, 0xff8da3d5,
    0xff9ca7cd, 0xff9ca5cb, 0xff9ca6cd, 0xff92a1cc, 0xff7391c9, 0xff728ec8, 0xff7392c9, 0xff7793cc,
    0xff7895cf, 0xff7995d0, 0xff7b96cf, 0xff8099d2, 0xff849fd9, 0xff87a3de, 0xff86a1dc, 0xff7b95d2,
    0xff7d98d6, 0xff7da3e8, 0xff83aff5, 0xff84bcff, 0xff8ac1ff, 0xff89bcfb, 0xff87bafa, 0xff86b9fa,
    0xff84b9fb, 0xff84b4f8, 0xff84b1f3, 0xff81b1f3, 0xff84acf1, 0xff8babea, 0xff87a6e7, 0xff7fa2e5,
    0xff87a3e0, 0xff859cd6, 0xff8296cd, 0xff7b90c7, 0xff788dc2, 0xff788bc1, 0xff798cbd, 0xff7c8bbb,
    0xff7a89bc, 0xff7487b9, 0xff7183b5, 0xff6f83b2, 0xff6d80b1, 0xff6b81af, 0xff697ead, 0xff667dac,
    0xff6378a9, 0xff5f76a6, 0xff5c72a0, 0xff5a729d, 0xff596f9c, 0xff5b729d, 0xff59719d, 0xff5e73a0,
    0xff6075a3, 0xff5e739f, 0xff6c7fab, 0xff6a7ba8, 0xff6d7ead, 0xff7080ab, 0xff6e7cac, 0xff627ebd,
    0xff587bb5, 0xff5a7cba, 0xff5b7fbb, 0xff5c80c0, 0xff5f82be, 0xff6384c2, 0xff6083c5, 0xff6387c6,
    0xff688bcc, 0xff6b90d1, 0xff759cdd, 0xff759fe0, 0xff7897d1, 0xff7b9ad0, 0xff86a4dd, 0xff84a2de,
    0xff90a3d3, 0xff92a0cd, 0xff8e9ccb, 0xff8b9dcc, 0xff7795ce, 0xff7190cb, 0xff7190ca, 0xff7695d0,
    0xff7b99d6, 0xff7997d5, 0xff7995d2, 0xff7492cf, 0xff7693ce, 0xff84a1dc, 0xff88a5e1, 0xff7a97d6,
    0xff7a9adb, 0xff7ca7ee, 0xff82b3fa, 0xff83baff, 0xff8ac1fe, 0xff8bc0fc, 0xff89befb, 0xff86b9fb,
    0xff85b9f9, 0xff87bcfc, 0xff88bbfb, 0xff85bbfd, 0xff85b1fa, 0xff8caeee, 0xff86a2e1, 0xff7d9ddf,
    0xff809edf, 0xff7f96d2, 0xff7f94cb, 0xff778dc6, 0xff738ac3, 0xff748ac2, 0xff768bbc, 0xff7a8abb,
    0xff7989bc, 0xff7287b9, 0xff6e82b5, 0xff6c83b3, 0xff697fb1, 0xff6980b0, 0xff677dae, 0xff677dae,
    0xff6379aa, 0xff6076a6, 0xff5d73a1, 0xff5a719c, 0xff596f9c, 0xff5c729d, 0xff586f9c, 0xff5e73a0,
    0xff6175a4, 0xff5d729e, 0xff6c80aa, 0xff6a7ba7, 0xff6c7dab, 0xff6f7ead, 0xff6c7da6, 0xff667bb6,
    0xff577ab6, 0xff597bba, 0xff5b7ebc, 0xff5c7fc1, 0xff5e81bf, 0xff6083c1, 0xff6184c5, 0xff6186c5,
    0xff638acc, 0xff678ed0, 0xff7099dd, 0xff6e9ee5, 0xff719bde, 0xff759cdd, 0xff7fa7e9, 0xff7ea7eb,
    0xff84a5df, 0xff839cd1, 0xff7f95ca, 0xff7e96cb, 0xff7594cf, 0xff7091cd, 0xff7292cf, 0xff7595d3,
    0xff799ad9, 0xff7797d8, 0xff7696d7, 0xff7294d3, 0xff7391ce, 0xff83a2dd, 0xff8ca9e6, 0xff7e9fdf,
    0xff799fe4, 0xff7ba5ed, 0xff7aa9ef, 0xff7baaee, 0xff84b6f6, 0xff8bc2ff, 0xff90c8ff, 0xff8cc0ff,
    0xff8abffd, 0xff8cc4ff, 0xff8cc4ff, 0xff8bc1ff, 0xff89b3fb, 0xff92b1ef, 0xff8ba5e1, 0xff839fdf,
    0xff7c9bdd, 0xff728ecf, 0xff748dc9, 0xff718ac5, 0xff6f89c3, 0xff7088c1, 0xff7389bb, 0xff7587bb,
    0xff7487bb, 0xff6e86b9, 0xff6c82b6, 0xff6982b5, 0xff677eb2, 0xff677eb0, 0xff657cae, 0xff667cad,
    0xff6379aa, 0xff6177a6, 0xff5e74a1, 0xff5b719c, 0xff5c719d, 0xff5c729d, 0xff5b719e, 0xff5e73a0,
    0xff6175a3, 0xff5d729d, 0xff6b7fa8, 0xff6b7ca8, 0xff6c7daa, 0xff6d7dac, 0xff6b7ca4, 0xff6678ad,
    0xff5779b8, 0xff597aba, 0xff5b7dbc, 0xff5d7fbf, 0xff5e80be, 0xff5d81be, 0xff6586c3, 0xff6287c3,
    0xff6088ca, 0xff638acc, 0xff6992d7, 0xff6a9be3, 0xff6fa2ea, 0xff73a2eb, 0xff7cacf3, 0xff7baff6,
    0xff7caaee, 0xff769ad9, 0xff7492cd, 0xff7290cb, 0xff7290cf, 0xff7092d0, 0xff7597d7, 0xff7696d7,
    0xff7799d9, 0xff7699d9, 0xff779adc, 0xff779bdd, 0xff7897d5, 0xff84a3df, 0xff90adea, 0xff85a8e9,
    0xff7aa5ed, 0xff7aa2e9, 0xff729adf, 0xff7196da, 0xff7aa6ea, 0xff88bfff, 0xff96d0ff, 0xff92c7ff,
    0xff8fc4ff, 0xff90c8ff, 0xff8fc8ff, 0xff91c2ff, 0xff91b4f8, 0xff99b4ef, 0xff93abe4, 0xff8da5e1,
    0xff7b9adb, 0xff6888cd, 0xff6887c8, 0xff6b88c5, 0xff6b88c4, 0xff6d86c0, 0xff6f86bb, 0xff6d84ba,
    0xff6c84ba, 0xff6a83b8, 0xff6982b7, 0xff6780b7, 0xff667db2, 0xff657bb0, 0xff627bad, 0xff637aab,
    0xff6378a9, 0xff6177a6, 0xff5e74a2, 0xff5c729c, 0xff5f749f, 0xff5d719d, 0xff5f74a2, 0xff5e729f,
    0xff5f75a1, 0xff5e739d, 0xff687ca6, 0xff6d7ea9, 0xff6b7da8, 0xff6b7ca9, 0xff697ba4, 0xff6277a3,
    0xff5678b8, 0xff587ab9, 0xff5b7cbc, 0xff5d7ebe, 0xff5d7fbe, 0xff5a80bd, 0xff6687c1, 0xff6387c2,
    0xff5f87c8, 0xff6288c9, 0xff648cd0, 0xff6b97dc, 0xff6fa4ed, 0xff73a5f2, 0xff78acf6, 0xff78b1fa,
    0xff77aff8, 0xff71a1e5, 0xff7096d7, 0xff6d92d3, 0xff708fcf, 0xff7294d3, 0xff789bdc, 0xff7899db,
    0xff7799db, 0xff799cdc, 0xff7ea2e2, 0xff81a4e5, 0xff82a0de, 0xff84a4e2, 0xff8fadea, 0xff85a9ec,
    0xff79a6ed, 0xff7ba1e8, 0xff7295d9, 0xff7190d4, 0xff749ae1, 0xff81b4fa, 0xff92c9fd, 0xff8fc1fd,
    0xff8cbefc, 0xff8dc1fd, 0xff8dc3fd, 0xff95c0fc, 0xff98b7f6, 0xff9eb5ed, 0xff98afe7, 0xff98ace4,
    0xff85a0dc, 0xff6f8ed1, 0xff6989cc, 0xff6786c6, 0xff6786c4, 0xff6984c0, 0xff6a84bc, 0xff6780ba,
    0xff6580b9, 0xff6581b8, 0xff6581b7, 0xff637db7, 0xff637bb2, 0xff6279b0, 0xff5f7aac, 0xff5f78a9,
    0xff6277a9, 0xff6077a6, 0xff5e74a2, 0xff5d739d, 0xff6176a0, 0xff5d719e, 0xff6176a3, 0xff5d729e,
    0xff5d759e, 0xff5e739d, 0xff667aa4, 0xff6d7ea9, 0xff6a7ca7, 0xff697ba7, 0xff677aa5, 0xff6177a0,
    0xff5477b6, 0xff577ab9, 0xff5a7cbc, 0xff5b7dbc, 0xff5b7fbe, 0xff5980bd, 0xff6284c0, 0xff6587c2,
    0xff6086c6, 0xff6689c8, 0xff6489cc, 0xff6f94d3, 0xff6f9de4, 0xff71a3ee, 0xff73a5ee, 0xff75abf4,
    0xff78b1fc, 0xff77aef3, 0xff76a3e7, 0xff739de1, 0xff7393d2, 0xff7496d6, 0xff799cdc, 0xff7a9ddf,
    0xff7a9cdd, 0xff80a2e2, 0xff8cace7, 0xff8dace9, 0xff8caae5, 0xff84a4e3, 0xff89a7e7, 0xff7ea1e3,
    0xff76a0e4, 0xff7ea4e9, 0xff7da0e3, 0xff7d9de0, 0xff7497de, 0xff76a1e8, 0xff81b0eb, 0xff7fabeb,
    0xff81abec, 0xff83aeec, 0xff86b4f1, 0xff96bbf8, 0xff9fbcf7, 0xff9eb4eb, 0xff99aee7, 0xff9fb2e6,
    0xff98ace1, 0xff8aa1da, 0xff7b96d4, 0xff6586c7, 0xff6383c4, 0xff6582c0, 0xff6682be, 0xff627fba,
    0xff607db9, 0xff627eb8, 0xff607db6, 0xff5f7bb5, 0xff5e79b0, 0xff5e77af, 0xff5d78ad, 0xff5d75a9,
    0xff5f77a9, 0xff5d76a6, 0xff5c73a2, 0xff5d749f, 0xff6076a1, 0xff5e72a0, 0xff6175a2, 0xff5c719c,
    0xff5b729b, 0xff5d739d, 0xff647aa3, 0xff6b7da8, 0xff687ba6, 0xff6879a5, 0xff677aa5, 0xff6278a5,
    0xff5276b3, 0xff567ab8, 0xff597cbc, 0xff597cba, 0xff5a7fbd, 0xff5880be, 0xff5e80bf, 0xff6686c3,
    0xff6385c5, 0xff6a8bc8, 0xff6687c9, 0xff7491cb, 0xff7094d7, 0xff709ee5, 0xff709de3, 0xff74a4ea,
    0xff7bb1fa, 0xff80bafd, 0xff7eaff4, 0xff7da9ed, 0xff7698d5, 0xff7799d8, 0xff7a9bdb, 0xff7da0e1,
    0xff7da0e0, 0xff87a6e6, 0xff99b4ea, 0xff96b0ea, 0xff94b0e9, 0xff83a2e2, 0xff81a0e2, 0xff7695d8,
    0xff7498d8, 0xff80a6ea, 0xff8aadef, 0xff8aaeef, 0xff7798dd, 0xff6c90d6, 0xff6f95d8, 0xff6f94d8,
    0xff7596db, 0xff7799da, 0xff7fa3e3, 0xff93b2f2, 0xffa1bdf7, 0xff9bb0e8, 0xff96abe5, 0xffa2b5e7,
    0xffa9b7e6, 0xffa5b4e2, 0xff8ea5dc, 0xff6887c9, 0xff6282c5, 0xff6281c1, 0xff6281c0, 0xff5f7eb9,
    0xff5d7bb8, 0xff5f7cb8, 0xff5c7ab5, 0xff5b79b2, 0xff5976ae, 0xff5976ae, 0xff5a76ad, 0xff5b74a9,
    0xff5b76a9, 0xff5a74a6, 0xff5a72a2, 0xff5c73a0, 0xff5d75a1, 0xff5e72a0, 0xff5e739f, 0xff5b709b,
    0xff597099, 0xff5b729c, 0xff6379a2, 0xff687aa6, 0xff6679a4, 0xff6778a3, 0xff6678a3, 0xff6177a6,
    0xff5076b1, 0xff567ab7, 0xff587cba, 0xff577cba, 0xff587fbd, 0xff5880be, 0xff5a7ebf, 0xff6384c3,
    0xff6384c3, 0xff698ac7, 0xff6586c7, 0xff718dc6, 0xff6d8dce, 0xff6d99de, 0xff6f98dc, 0xff77a2e7,
    0xff7eb1f8, 0xff83bafc, 0xff7eaef4, 0xff7faaee, 0xff779ad8, 0xff7899da, 0xff799bda, 0xff7fa2e2,
    0xff82a4e3, 0xff8aa7e4, 0xff98b2e6, 0xff94ace5, 0xff92aee7, 0xff809fdf, 0xff7b9adc, 0xff7190d1,
    0xff7292d1, 0xff7da2e3, 0xff8aacee, 0xff8cafef, 0xff7896d9, 0xff6786cb, 0xff6686cc, 0xff6887cc,
    0xff718cd0, 0xff728fd1, 0xff7a98d9, 0xff8ba7e7, 0xff99b5ee, 0xff94a9e3, 0xff91a7e0, 0xff9cb0e4,
    0xffa8b6e5, 0xffaab8e4, 0xff95a9dd, 0xff728dcd, 0xff6684c6, 0xff6281c2, 0xff5f7fc0, 0xff5c7cb8,
    0xff5a79b7, 0xff5b79b7, 0xff5977b3, 0xff5877b0, 0xff5574ac, 0xff5774ac, 0xff5773ac, 0xff5872a8,
    0xff5873a7, 0xff5872a4, 0xff5870a2, 0xff5a729f, 0xff5b739e, 0xff5d72a0, 0xff5b719c, 0xff5b709d,
    0xff5a719b, 0xff5b729b, 0xff6178a0, 0xff6477a1, 0xff6377a1, 0xff6476a0, 0xff60739a, 0xff586f93,
    0xff5075b1, 0xff5579b5, 0xff577ab8, 0xff577dba, 0xff577ebc, 0xff5980be, 0xff597ebe, 0xff5e82c1,
    0xff6183c2, 0xff6486c4, 0xff6386c7, 0xff688ac7, 0xff688acd, 0xff6a95da, 0xff7098da, 0xff7ba7ea,
    0xff7eaff6, 0xff7dadf1, 0xff77a2e6, 0xff7aa0e4, 0xff7699d9, 0xff7899da, 0xff779ada, 0xff7fa1e1,
    0xff85a8e5, 0xff87a3de, 0xff8ba7de, 0xff88a2dd, 0xff88a4df, 0xff7d9ad9, 0xff7898d7, 0xff7190d1,
    0xff7090d0, 0xff7799d9, 0xff809fe0, 0xff81a2e2, 0xff7794d5, 0xff6687cb, 0xff6886ca, 0xff6c88ca,
    0xff758fcf, 0xff7691d1, 0xff7996d6, 0xff829ddb, 0xff8aa5e1, 0xff8da2de, 0xff8aa2db, 0xff91a6dd,
    0xff97a9df, 0xff9aaddf, 0xff8ea3d9, 0xff8096d1, 0xff6e8bc9, 0xff6483c3, 0xff5c7dbf, 0xff5a7ab7,
    0xff5878b6, 0xff5876b3, 0xff5876b1, 0xff5776b0, 0xff5574aa, 0xff5672aa, 0xff5570a9, 0xff5671a5,
    0xff5770a4, 0xff5671a1, 0xff576fa1, 0xff59709d, 0xff5a719b, 0xff5c719f, 0xff596f99, 0xff5a71a0,
    0xff5c74a0, 0xff5b729a, 0xff60759d, 0xff62749d, 0xff5f749c, 0xff60749d, 0xff586c8d, 0xff4a6473,
    0xff5074b0, 0xff5477b3, 0xff5679b6, 0xff577dba, 0xff577dbb, 0xff597fbe, 0xff597fbe, 0xff5a80c0,
    0xff5f81c1, 0xff5f82c2, 0xff6186c7, 0xff6087c9, 0xff6388cd, 0xff6790d5, 0xff7299d9, 0xff7fa9ea,
    0xff80acf0, 0xff7aa1e4, 0xff7296d7, 0xff7496d7, 0xff7597d8, 0xff7697d8, 0xff7598d8, 0xff7d9edd,
    0xff86a7e2, 0xff829ed6, 0xff7d9bd5, 0xff7b98d5, 0xff7d9ad6, 0xff7a95d2, 0xff7796d2, 0xff7493d1,
    0xff7290d0, 0xff7190cf, 0xff7793d1, 0xff7995d4, 0xff7792d0, 0xff6e8ece, 0xff708ccb, 0xff7790cd,
    0xff7d96d1, 0xff7c97d3, 0xff7b96d5, 0xff7994d0, 0xff7c96d4, 0xff859ad7, 0xff829cd4, 0xff859ad5,
    0xff839bd7, 0xff849dd7, 0xff8198d2, 0xff8699d2, 0xff728ec9, 0xff6684c4, 0xff5c7cbe, 0xff5a79b6,
    0xff5978b5, 0xff5775b2, 0xff5a77b2, 0xff5976b1, 0xff5674a9, 0xff5671a8, 0xff536da5, 0xff5470a1,
    0xff556da1, 0xff556f9f, 0xff566e9f, 0xff576e9b, 0xff596f98, 0xff596e99, 0xff576e99, 0xff586f9e,
    0xff5c739d, 0xff5b7198, 0xff5e729a, 0xff5f7198, 0xff5b7197, 0xff5b7199, 0xff4f6481, 0xff375350,
    0xff4f72af, 0xff5376b2, 0xff5478b4, 0xff567cb9, 0xff577cba, 0xff597ebe, 0xff5a7fbe, 0xff5a7fbf,
    0xff5e80c0, 0xff5e81c2, 0xff6085c6, 0xff6086ca, 0xff6287cc, 0xff678dd0, 0xff7397d6, 0xff7fa5e3,
    0xff84a9e7, 0xff7e9edd, 0xff7494d1, 0xff7392d0, 0xff7495d4, 0xff7595d4, 0xff7596d4, 0xff7a9ad6,
    0xff83a1da, 0xff7c97cf, 0xff7793cd, 0xff7792ce, 0xff7994cf, 0xff7a93ce, 0xff7894cf, 0xff7794d0,
    0xff7692cf, 0xff718dc9, 0xff7690ca, 0xff7a92cf, 0xff7993ce, 0xff7f99d2, 0xff7a92cd, 0xff849ad2,
    0xff869cd4, 0xff839bd5, 0xff7e96d3, 0xff7690cc, 0xff7891cd, 0xff8196d2, 0xff7e97ce, 0xff7e93ce,
    0xff7b94d1, 0xff7490d0, 0xff748fcd, 0xff7c92cd, 0xff6d8ac6, 0xff6482c3, 0xff5d7dbe, 0xff5c7ab7,
    0xff5b79b6, 0xff5a77b4, 0xff5e7bb7, 0xff5d78b2, 0xff5675aa, 0xff5470a7, 0xff516ca3, 0xff526e9f,
    0xff526b9e, 0xff546e9e, 0xff556e9e, 0xff556d9b, 0xff576d99, 0xff576b8c, 0xff5870a0, 0xff546a8f,
    0xff596e8e, 0xff5a7097, 0xff5c7098, 0xff5c6f96, 0xff586f94, 0xff576e96, 0xff485e77, 0xff26403b,
    0xff4e71af, 0xff5274b0, 0xff5378b3, 0xff557ab6, 0xff587bb8, 0xff587ebd, 0xff5b7ebe, 0xff5c7ebf,
    0xff5e80c0, 0xff5e81c2, 0xff6084c5, 0xff6386ca, 0xff6288ca, 0xff688bcc, 0xff7395d2, 0xff7d9ed9,
    0xff89a5dd, 0xff85a0d9, 0xff7b99d1, 0xff7494cc, 0xff7392ce, 0xff7492cf, 0xff7694ce, 0xff7795ce,
    0xff7d98d0, 0xff7991ca, 0xff7790ca, 0xff7891cb, 0xff7992cc, 0xff7b92cc, 0xff7b93cc, 0xff7a94ce,
    0xff7c95ce, 0xff748ec7, 0xff7a93ca, 0xff8096cf, 0xff7b95ce, 0xff93a5d6, 0xff859ad0, 0xff91a5d7,
    0xff8da1d7, 0xff889fd5, 0xff8196d1, 0xff758fcc, 0xff7b93cc, 0xff7f94ce, 0xff7c93ca, 0xff7a90c9,
    0xff7891cc, 0xff6a88cb, 0xff6887c9, 0xff6986c6, 0xff6483c1, 0xff6180c0, 0xff5f7fbf, 0xff607db9,
    0xff5f7cb9, 0xff5e7cb9, 0xff6480bc, 0xff627bb4, 0xff5676ab, 0xff526fa6, 0xff506ca2, 0xff506c9d,
    0xff506b9b, 0xff536c9e, 0xff556e9d, 0xff546c9b, 0xff556c9c, 0xff55687d, 0xff5971a7, 0xff50657d,
    0xff536679, 0xff576f95, 0xff5b6e96, 0xff596d94, 0xff556c92, 0xff536b93, 0xff435b73, 0xff192d30,
    0xff4d6fac, 0xff5173af, 0xff5277b2, 0xff5479b3, 0xff587ab7, 0xff577dbc, 0xff5b7ebe, 0xff5d7ebe,
    0xff5d7fbf, 0xff5e81c1, 0xff6083c4, 0xff6485c9, 0xff6388c9, 0xff688ac8, 0xff7293ce, 0xff7c98d1,
    0xff8ca2d6, 0xff8ca3d7, 0xff829dd2, 0xff7997cc, 0xff7592cb, 0xff7491cb, 0xff7793cb, 0xff7592c9,
    0xff7a93cb, 0xff7892cc, 0xff7890c9, 0xff7791c8, 0xff7991ca, 0xff7b92c9, 0xff7c92ca, 0xff7c94cd,
    0xff8097cd, 0xff7b92c8, 0xff8197cb, 0xff869ad0, 0xff7f96cd, 0xff99a8d5, 0xff8b9ed1, 0xff9aabd9,
    0xff91a2d7, 0xff8a9fd4, 0xff8296d0, 0xff748ecb, 0xff7b92ca, 0xff7b91ca, 0xff798ec5, 0xff768cc4,
    0xff758dc6, 0xff6483c6, 0xff6182c5, 0xff5e7ec1, 0xff607fbf, 0xff627fbf, 0xff6382c0, 0xff6480bb,
    0xff637fba, 0xff627fba, 0xff6581bc, 0xff637cb4, 0xff5776ac, 0xff526fa6, 0xff506da2, 0xff506b9d,
    0xff4f6b9a, 0xff516b9d, 0xff556e9b, 0xff536b9b, 0xff546c9b, 0xff516471, 0xff5770a2, 0xff506478,
    0xff4b5d64, 0xff556e93, 0xff596d95, 0xff556c93, 0xff51698f, 0xff4f6891, 0xff435b75, 0xff0d1e26,
    0xff4b6da9, 0xff4f72ac, 0xff5276b0, 0xff5377b0, 0xff5678b5, 0xff567cbb, 0xff597dbc, 0xff5b7dbe,
    0xff5c7dbd, 0xff5c7fbe, 0xff5e81c1, 0xff6283c5, 0xff6387c7, 0xff6889c7, 0xff7190cb, 0xff7e96ce,
    0xff8ca0d2, 0xff8fa4d5, 0xff879ed4, 0xff809ad0, 0xff7995cc, 0xff7692cb, 0xff7894ca, 0xff7692ca,
    0xff7b94cd, 0xff7c99d3, 0xff7994cc, 0xff7490c8, 0xff7891c9, 0xff7791c7, 0xff7b91c8, 0xff7d93cb,
    0xff8198cc, 0xff8499cc, 0xff879bcd, 0xff899bd0, 0xff8397cc, 0xff8da0d0, 0xff8a9dcf, 0xff9aaad8,
    0xff90a0d3, 0xff879cd0, 0xff7f94cd, 0xff728cc7, 0xff778ec6, 0xff758ec6, 0xff748ac2, 0xff7187c0,
    0xff6f88c0, 0xff6483c4, 0xff6182c3, 0xff6180c1, 0xff6382c0, 0xff6682c1, 0xff6985c1, 0xff6782bc,
    0xff6681bb, 0xff627fb8, 0xff607cb5, 0xff5f7ab2, 0xff5976ac, 0xff5572a8, 0xff526fa2, 0xff516c9d,
    0xff4f6b9b, 0xff4f699a, 0xff546d99, 0xff516a98, 0xff556c96, 0xff4c5f6b, 0xff516a8d, 0xff566b85,
    0xff435552, 0xff526b90, 0xff566b94, 0xff526a90, 0xff4e668b, 0xff4d658e, 0xff49607c, 0xff06141b,
    0xff496ca5, 0xff4d71a9, 0xff5175af, 0xff5276ad, 0xff5477b3, 0xff557bb9, 0xff587cba, 0xff5a7dbd,
    0xff5a7cbc, 0xff5a7ebb, 0xff5d7fbf, 0xff5f82c2, 0xff6385c5, 0xff6788c6, 0xff6f8ec8, 0xff7d95cd,
    0xff889ed0, 0xff8ea4d3, 0xff899ed5, 0xff869cd3, 0xff7c99ce, 0xff7794cb, 0xff7795cc, 0xff7893cc,
    0xff7d98d2, 0xff81a1dc, 0xff7c99d1, 0xff7290c9, 0xff7792ca, 0xff7490c6, 0xff7890c7, 0xff7c92ca,
    0xff8197cc, 0xff8ba0d1, 0xff8b9dd0, 0xff899bcf, 0xff8596ca, 0xff7c94c9, 0xff869acc, 0xff95a5d4,
    0xff8b9bce, 0xff8298cc, 0xff7b92cb, 0xff708bc4, 0xff738ac3, 0xff708bc2, 0xff7086bf, 0xff6e83bd,
    0xff6b84bc, 0xff6685c3, 0xff6483c1, 0xff6784c2, 0xff6885c2, 0xff6a85c2, 0xff6c87c1, 0xff6983bc,
    0xff6682ba, 0xff617eb4, 0xff5b77ad, 0xff5a78b0, 0xff5a75ac, 0xff5874a9, 0xff5370a2, 0xff536e9e,
    0xff506c9c, 0xff4d6797, 0xff546c96, 0xff506996, 0xff566d90, 0xff485c69, 0xff4a6173, 0xff5a6f92,
    0xff3c4f45, 0xff50688b, 0xff536a93, 0xff4f688d, 0xff4b6388, 0xff4c638b, 0xff4f6586, 0xff031014,
    0xff476aa3, 0xff4b6fa6, 0xff5073ac, 0xff5274ac, 0xff5477b3, 0xff557ab7, 0xff577cb7, 0xff597dbb,
    0xff5a7cba, 0xff597db9, 0xff5c7dbd, 0xff5d80be, 0xff6183c2, 0xff6486c3, 0xff6c8bc5, 0xff7891ca,
    0xff8098cc, 0xff889ecf, 0xff869cd4, 0xff869bd3, 0xff7d99cf, 0xff7794ca, 0xff7694cc, 0xff7893cd,
    0xff7d9ad3, 0xff85a6df, 0xff7f9ed5, 0xff7392cb, 0xff7792ca, 0xff7390c6, 0xff758fc8, 0xff7a92ca,
    0xff7f95cc, 0xff8ca1d2, 0xff899cd0, 0xff8598cc, 0xff8494c7, 0xff728dc5, 0xff8096c8, 0xff909fcf,
    0xff8797ca, 0xff7f94c8, 0xff778fc8, 0xff7089c2, 0xff6f88c1, 0xff6e88bf, 0xff6c83bb, 0xff6981bb,
    0xff6782ba, 0xff6684c0, 0xff6481bd, 0xff6884c0, 0xff6885c0, 0xff6984be, 0xff6a85bd, 0xff6681b9,
    0xff6581b7, 0xff5f7cb0, 0xff5875aa, 0xff5976ae, 0xff5a73aa, 0xff5974a7, 0xff5470a1, 0xff536e9e,
    0xff506c9c, 0xff4d6795, 0xff526a94, 0xff516a98, 0xff566e91, 0xff495c65, 0xff41565d, 0xff52698b,
    0xff36483c, 0xff4d6581, 0xff506890, 0xff4c658a, 0xff4a6289, 0xff4b638b, 0xff546a92, 0xff000b0e,
    0xff476aa1, 0xff496ea4, 0xff4e71aa, 0xff5174ad, 0xff5679b5, 0xff557ab5, 0xff577bb5, 0xff5a7db8,
    0xff5a7cb8, 0xff5a7cb9, 0xff5b7cbc, 0xff5c7ebc, 0xff5f81be, 0xff6183c0, 0xff6988c3, 0xff708bc6,
    0xff7790c6, 0xff7f96ca, 0xff8098d0, 0xff8096d0, 0xff7b96cd, 0xff7593c9, 0xff7592ca, 0xff7691cc,
    0xff7b99d1, 0xff87a6dd, 0xff82a1d8, 0xff7794cc, 0xff7892c9, 0xff7390c6, 0xff738fca, 0xff7892cc,
    0xff7d94cc, 0xff869dd1, 0xff8397ce, 0xff7e93c8, 0xff8090c4, 0xff728bc4, 0xff7c93c5, 0xff8c9bcb,
    0xff8395c7, 0xff7e92c5, 0xff758cc5, 0xff7289c3, 0xff6e87c0, 0xff6f85be, 0xff6981b7, 0xff6680bb,
    0xff6481bc, 0xff6481bb, 0xff607db8, 0xff6480bc, 0xff6581bc, 0xff637fb8, 0xff637eb7, 0xff5f7bb3,
    0xff617fb4, 0xff5c7aaf, 0xff5976ad, 0xff5a76ac, 0xff5872a9, 0xff5671a3, 0xff546fa0, 0xff536e9e,
    0xff506b9a, 0xff4f6794, 0xff516994, 0xff526b9e, 0xff556f98, 0xff4e5f60, 0xff394d51, 0xff425a75,
    0xff334538, 0xff4b6375, 0xff4f678c, 0xff496188, 0xff4a628e, 0xff4b668d, 0xff566e9c, 0xff00070b,
    0xff4669a0, 0xff486ca2, 0xff4c6fa7, 0xff5073ad, 0xff5679b4, 0xff5578b2, 0xff577ab3, 0xff5a7db5,
    0xff597cb6, 0xff5a7cb9, 0xff5b7cba, 0xff5b7dba, 0xff5d7fba, 0xff5f81bd, 0xff6585c1, 0xff6886c2,
    0xff6e89c2, 0xff758dc5, 0xff7993ca, 0xff7991cb, 0xff7892ca, 0xff7391c8, 0xff7390c9, 0xff7490cb,
    0xff7897ce, 0xff85a2d9, 0xff83a0d8, 0xff7b96cd, 0xff7891c9, 0xff7490c6, 0xff718ecc, 0xff7691cc,
    0xff7b93cc, 0xff8197cf, 0xff7c92cc, 0xff788ec5, 0xff7a8dc2, 0xff738bc4, 0xff7890c2, 0xff8595c7,
    0xff7e92c5, 0xff7b8fc2, 0xff748ac3, 0xff7389c3, 0xff6e87c0, 0xff6f83bc, 0xff677fb4, 0xff6380ba,
    0xff6280bd, 0xff617eb7, 0xff5d7ab4, 0xff5f7bb8, 0xff607db8, 0xff5e7bb5, 0xff5d7ab5, 0xff5c79b3,
    0xff5d7cb1, 0xff5977ae, 0xff5a78af, 0xff5a75ac, 0xff5570a6, 0xff536e9e, 0xff536e9e, 0xff526c9c,
    0xff4f6a98, 0xff506793, 0xff4e6693, 0xff506899, 0xff506b97, 0xff526463, 0xff364746, 0xff304757,
    0xff2f4134, 0xff475f66, 0xff4c6589, 0xff465e86, 0xff455e88, 0xff466381, 0xff4f6996, 0xff01090d,
    0xff45689e, 0xff476ba1, 0xff4b6ea5, 0xff4f72ab, 0xff5477b0, 0xff5476af, 0xff5678b2, 0xff597cb4,
    0xff587bb4, 0xff597bb8, 0xff5a7cb8, 0xff5a7cb8, 0xff5c7eb8, 0xff5f80bb, 0xff6383bf, 0xff6484c0,
    0xff6987c1, 0xff6f89c2, 0xff738fc6, 0xff748ec8, 0xff7691c7, 0xff7290c7, 0xff728fc9, 0xff7390cb,
    0xff7695cd, 0xff7f9bd4, 0xff809cd5, 0xff7c97ce, 0xff7590c9, 0xff728fc6, 0xff708ecc, 0xff7490cb,
    0xff7a92cb, 0xff7f95cf, 0xff7b91cc, 0xff768dc4, 0xff768bc1, 0xff748ac3, 0xff748cc0, 0xff7b8fc4,
    0xff778ec3, 0xff768bc0, 0xff748ac3, 0xff7389c3, 0xff6e87c0, 0xff6b81ba, 0xff657eb4, 0xff617fb8,
    0xff607fbb, 0xff5f7cb5, 0xff5d7ab5, 0xff5d7ab8, 0xff5d7cbc, 0xff5e7cbd, 0xff5e7dbe, 0xff627fbe,
    0xff5c7ab2, 0xff5876b4, 0xff5a79b2, 0xff5775b4, 0xff536fa5, 0xff526d9d, 0xff536d9e, 0xff506b9a,
    0xff4e6997, 0xff4e6592, 0xff4a6293, 0xff4b6488, 0xff486391, 0xff546a7a, 0xff39493c, 0xff24383e,
    0xff293b2b, 0xff435b58, 0xff49638e, 0xff435c86, 0xff3b5274, 0xff395461, 0xff3b5679, 0xff0c1418,
    0xff43689c, 0xff466aa0, 0xff4b6da3, 0xff4d70a8, 0xff5173ab, 0xff5274ad, 0xff5376b1, 0xff577ab3,
    0xff5679b3, 0xff577ab6, 0xff587bb6, 0xff5a7cb7, 0xff5c7db7, 0xff607fbb, 0xff6282be, 0xff6383bf,
    0xff6787c2, 0xff6c88c1, 0xff708bc3, 0xff718cc5, 0xff7390c5, 0xff728fc7, 0xff718ec9, 0xff7390ca,
    0xff7392cc, 0xff7693cf, 0xff7a95cf, 0xff7c96ce, 0xff728fc9, 0xff708dc6, 0xff6f8eca, 0xff738fc9,
    0xff7a91ca, 0xff7f95cf, 0xff7c92cd, 0xff788fc5, 0xff7389c2, 0xff748bc4, 0xff7189c0, 0xff718ac2,
    0xff718ac1, 0xff7088bf, 0xff758ac3, 0xff728ac2, 0xff6d86c0, 0xff6680b8, 0xff647eb5, 0xff5f7eb6,
    0xff5e7db7, 0xff5d7bb4, 0xff5e7bb7, 0xff5c7ab9, 0xff5c7bc2, 0xff6180c6, 0xff6283c9, 0xff6b87cb,
    0xff5b79b4, 0xff5875b7, 0xff5978b1, 0xff5274b9, 0xff516ea4, 0xff526c9d, 0xff536c9e, 0xff4e6998,
    0xff4c6896, 0xff4a6290, 0xff465e91, 0xff425c6e, 0xff3d5781, 0xff536e92, 0xff405036, 0xff1d2c2b,
    0xff243621, 0xff3d554b, 0xff466093, 0xff425c87, 0xff2e4358, 0xff2a413b, 0xff233f52, 0xff192224,
    0xff42679b, 0xff45699f, 0xff4a6ca2, 0xff4c6fa4, 0xff4d70a7, 0xff5073ac, 0xff5275b0, 0xff5577b1,
    0xff5578b2, 0xff5679b5, 0xff577bb4, 0xff597bb6, 0xff5b7db6, 0xff607fba, 0xff6181bd, 0xff6383be,
    0xff6687c2, 0xff6987c0, 0xff6c89c1, 0xff6f8bc3, 0xff718fc3, 0xff718ec6, 0xff708dc8, 0xff708ec9,
    0xff708ecb, 0xff718ecb, 0xff7992cc, 0xff7d96ce, 0xff728fc9, 0xff6f8cc6, 0xff6f8ec8, 0xff728ec7,
    0xff7990c9, 0xff7f94ce, 0xff7d93cd, 0xff7990c6, 0xff748bc3, 0xff778ec4, 0xff738ac1, 0xff6e89c1,
    0xff6d87bf, 0xff6d86bf, 0xff758ac1, 0xff7089c0, 0xff6c85bd, 0xff637fb5, 0xff627db5, 0xff5e7cb2,
    0xff5d7ab2, 0xff5c7ab3, 0xff5e7bb6, 0xff5b7bb8, 0xff5b7abd, 0xff6382c2, 0xff6586c5, 0xff6e8bcd,
    0xff5976b0, 0xff5673ab, 0xff5472a4, 0xff5071ab, 0xff506da0, 0xff4f699c, 0xff50699d, 0xff4c6794,
    0xff496593, 0xff49618f, 0xff47608a, 0xff354c4b, 0xff2d4563, 0xff4c688e, 0xff435434, 0xff1c251d,
    0xff23361c, 0xff364c3b, 0xff455e8c, 0xff445e82, 0xff1e3239, 0xff1e311d, 0xff163131, 0xff1d2728,
    0xff3f6699, 0xff44689d, 0xff486ba0, 0xff4a6da2, 0xff4c6fa6, 0xff4e71ab, 0xff5173ae, 0xff5375af,
    0xff5577b0, 0xff5678b3, 0xff567ab3, 0xff587ab5, 0xff5a7db5, 0xff5e7eb9, 0xff6080bb, 0xff6282be,
    0xff6485bf, 0xff6786c0, 0xff6a87c0, 0xff6d8ac2, 0xff6f8dc2, 0xff6f8bc5, 0xff6d8bc5, 0xff6d8bc6,
    0xff6e8cc9, 0xff718ec8, 0xff7c94cb, 0xff8097cd, 0xff7591ca, 0xff6f8cc5, 0xff708dc6, 0xff718dc5,
    0xff778dc7, 0xff7c91cb, 0xff7c92ca, 0xff7a91c7, 0xff788ec4, 0xff7d93c6, 0xff788ec4, 0xff738cc2,
    0xff6e87be, 0xff6e87be, 0xff7287be, 0xff6c86bc, 0xff6a83b9, 0xff617db3, 0xff5f7bb3, 0xff5d79af,
    0xff5b77ad, 0xff5b77b0, 0xff5b78b1, 0xff5b7bb4, 0xff5b78ad, 0xff6381ae, 0xff6483b1, 0xff6986c0,
    0xff5573a7, 0xff526f8e, 0xff4b6689, 0xff516c86, 0xff516d9b, 0xff49669a, 0xff4a669a, 0xff496491,
    0xff46618d, 0xff4c638f, 0xff4e677e, 0xff273624, 0xff1b3038, 0xff405768, 0xff405137, 0xff1f2114,
    0xff283c1d, 0xff2c4129, 0xff465b77, 0xff48627a, 0xff10221e, 0xff1a2a11, 0xff1a3523, 0xff151f20,
    0xff3e6699, 0xff42689b, 0xff476ba0, 0xff486ba0, 0xff4a6ea7, 0xff4e70ab, 0xff5072ac, 0xff5173ac,
    0xff5477af, 0xff5578b2, 0xff5578b2, 0xff5779b5, 0xff587cb5, 0xff5c7db8, 0xff607fb9, 0xff6282be,
    0xff6484bc, 0xff6585c0, 0xff6787bf, 0xff6b89c1, 0xff6d8ac2, 0xff6d88c4, 0xff6a89c2, 0xff6987c4,
    0xff6b8ac7, 0xff738fc6, 0xff7f97cb, 0xff8196cb, 0xff7992ca, 0xff708dc3, 0xff718bc4, 0xff718dc4,
    0xff748cc5, 0xff788fc7, 0xff7a91c6, 0xff7b91c7, 0xff7c92c5, 0xff8298c7, 0xff7e94c6, 0xff7b91c4,
    0xff7189be, 0xff7189be, 0xff6e84ba, 0xff6983b9, 0xff6780b4, 0xff607bb0, 0xff5d78af, 0xff5b76ac,
    0xff5974a9, 0xff5974ad, 0xff5774ac, 0xff5b79a9, 0xff5c7596, 0xff627d91, 0xff607b92, 0xff607da9,
    0xff50709b, 0xff4d696c, 0xff40586a, 0xff52655e, 0xff516a8f, 0xff446295, 0xff456294, 0xff47628e,
    0xff425e87, 0xff4f658d, 0xff546d70, 0xff1b2407, 0xff0c1d12, 0xff344539, 0xff3a4c39, 0xff252112,
    0xff2c4220, 0xff26381c, 0xff475860, 0xff4a636d, 0xff0a1b0c, 0xff1a2810, 0xff253f1f, 0xff0c1515,
    0xff3c6699, 0xff41689b, 0xff456ba0, 0xff486ba0, 0xff496ea7, 0xff4c70aa, 0xff5072ac, 0xff5173ac,
    0xff5376ae, 0xff5478b2, 0xff5578b2, 0xff5779b5, 0xff577bb5, 0xff5a7cb7, 0xff5e7eb7, 0xff6080bc,
    0xff6282ba, 0xff6283bf, 0xff6484be, 0xff6686c0, 0xff6887c1, 0xff6885c2, 0xff6686c0, 0xff6585c2,
    0xff6988c5, 0xff718dc4, 0xff7b95c8, 0xff7d93c8, 0xff7791c7, 0xff708dc3, 0xff718bc2, 0xff718dc4,
    0xff718ac3, 0xff758cc4, 0xff788fc4, 0xff7b90c6, 0xff7d93c4, 0xff8297c6, 0xff8195c6, 0xff7f93c4,
    0xff778dc5, 0xff7189c2, 0xff6981b8, 0xff647eb5, 0xff617baf, 0xff5c78af, 0xff5a75ab, 0xff5772a9,
    0xff5771a4, 0xff5671a8, 0xff5572ab, 0xff56738d, 0xff5b7279, 0xff5a7272, 0xff556b6a, 0xff587286,
    0xff4f6f8e, 0xff455e4f, 0xff33474a, 0xff515e44, 0xff4c6175, 0xff425f8d, 0xff466187, 0xff44608f,
    0xff405b87, 0xff4e6487, 0xff51675d, 0xff191f00, 0xff030f00, 0xff2d3b1c, 0xff314332, 0xff2a1f10,
    0xff293f1e, 0xff273915, 0xff40514f, 0xff3e5659, 0xff172505, 0xff18240d, 0xff2d481a, 0xff0e1b14,
    0xff3c669b, 0xff41679b, 0xff456aa1, 0xff496ba1, 0xff486ea7, 0xff4a70a9, 0xff4f72ac, 0xff5176ae,
    0xff5275ae, 0xff5377b1, 0xff5578b1, 0xff5778b5, 0xff577ab4, 0xff597bb6, 0xff5b7db5, 0xff5d7eb9,
    0xff6080ba, 0xff5f81bc, 0xff6081bd, 0xff6081be, 0xff6383c0, 0xff6282c0, 0xff6283c0, 0xff6383c1,
    0xff6786c3, 0xff6d89c2, 0xff728fc5, 0xff748dc4, 0xff728cc4, 0xff6e8bc3, 0xff708bc1, 0xff728dc4,
    0xff6f8ac1, 0xff738bc2, 0xff778ec3, 0xff798ec4, 0xff7a91c3, 0xff7d93c2, 0xff8093c4, 0xff7e92c3,
    0xff7e94d1, 0xff6f88c9, 0xff6480b7, 0xff607ab1, 0xff5b75ac, 0xff5675af, 0xff5672a7, 0xff506ea8,
    0xff546fa0, 0xff526ea3, 0xff5371b1, 0xff506b6a, 0xff5a6f60, 0xff506458, 0xff485a45, 0xff526963,
    0xff507085, 0xff3c513e, 0xff283833, 0xff4f5a40, 0xff435456, 0xff445e84, 0xff4e6278, 0xff415f95,
    0xff3f5a8d, 0xff4b617f, 0xff48594d, 0xff222905, 0xff010a00, 0xff2e3c17, 0xff2a3925, 0xff2d1b0f,
    0xff1e3517, 0xff304216, 0xff364949, 0xff293f45, 0xff333e0b, 0xff15210b, 0xff324d18, 0xff1b2c1b,
    0xff3d679d, 0xff40679d, 0xff446aa2, 0xff496ca4, 0xff476ea7, 0xff4970a8, 0xff4e72ad, 0xff5077b0,
    0xff5074ae, 0xff5176b1, 0xff5478b1, 0xff5677b4, 0xff5678b4, 0xff587ab5, 0xff587bb4, 0xff5a7cb6,
    0xff5d7eb9, 0xff5c7eba, 0xff5c7ebb, 0xff5b7dbc, 0xff5d7fbe, 0xff5d80bf, 0xff5f81c0, 0xff6183c0,
    0xff6585c1, 0xff6785c1, 0xff6a89c1, 0xff6b88c1, 0xff6b88c1, 0xff6c89c3, 0xff6e8ac0, 0xff728cc3,
    0xff6d8ac0, 0xff7189c1, 0xff758cc3, 0xff768bc2, 0xff768dc1, 0xff778dc0, 0xff7c8fc2, 0xff7b90c3,
    0xff7f94ce, 0xff6c86c4, 0xff6582b7, 0xff5e78ae, 0xff5873a9, 0xff5473aa, 0xff5570a0, 0xff4f6ca0,
    0xff506c9e, 0xff4e6b9f, 0xff5271ac, 0xff475f48, 0xff536647, 0xff465642, 0xff3d4a28, 0xff495d41,
    0xff4e6b73, 0xff374835, 0xff243224, 0xff49553c, 0xff3c4a3b, 0xff495e77, 0xff4f5e5f, 0xff3e5b8b,
    0xff3e5789, 0xff455d73, 0xff3c493c, 0xff283013, 0xff050b09, 0xff2b3a18, 0xff21301a, 0xff2b1610,
    0xff152a10, 0xff36491b, 0xff2f464b, 0xff1a2f38, 0xff47511a, 0xff121e0c, 0xff314816, 0xff273b23,
    0xff3b659d, 0xff3e669f, 0xff4269a2, 0xff486ba6, 0xff466ea7, 0xff486fa8, 0xff4c71ac, 0xff4e75af,
    0xff4f73ae, 0xff4f75b0, 0xff5176b1, 0xff5476b2, 0xff5576b4, 0xff5678b4, 0xff5679b4, 0xff587bb4,
    0xff5a7bb7, 0xff597cb9, 0xff587bba, 0xff587abb, 0xff587dbd, 0xff5b7ebe, 0xff5e80c0, 0xff6083bf,
    0xff6385c0, 0xff6483c0, 0xff6586bf, 0xff6786c0, 0xff6886c1, 0xff6a87c2, 0xff6c88c1, 0xff708ac2,
    0xff6b8abf, 0xff7088c0, 0xff738bc2, 0xff7489c3, 0xff738bc4, 0xff738bc7, 0xff788eca, 0xff7990ca,
    0xff798cb5, 0xff6f87af, 0xff738abe, 0xff617cb2, 0xff5b77ac, 0xff5975a0, 0xff5b7397, 0xff596f91,
    0xff49679c, 0xff4a689c, 0xff4f6f90, 0xff395036, 0xff445434, 0xff3e4e36, 0xff3b4621, 0xff3e4d2c,
    0xff455b57, 0xff3b4a38, 0xff27351f, 0xff415030, 0xff3b4931, 0xff4e626a, 0xff414d3e, 0xff3d566d,
    0xff3e5678, 0xff425c6b, 0xff303c2a, 0xff222b19, 0xff0e120d, 0xff202c15, 0xff152718, 0xff200f10,
    0xff0e1e0a, 0xff304723, 0xff324c57, 0xff213841, 0xff425231, 0xff0a180e, 0xff1c2f0e, 0xff273b26,
    0xff3b649e, 0xff3d67a3, 0xff4068a2, 0xff466ba8, 0xff466fa8, 0xff486fa9, 0xff4970aa, 0xff4c73ad,
    0xff4e73af, 0xff4d74b0, 0xff4e75b2, 0xff5175b1, 0xff5475b4, 0xff5477b3, 0xff5578b4, 0xff567ab2,
    0xff5678b5, 0xff567ab9, 0xff5579b9, 0xff587abb, 0xff557cbc, 0xff5a7dbe, 0xff5e80c0, 0xff6083bf,
    0xff6185c1, 0xff6282be, 0xff6384bf, 0xff6586c0, 0xff6786c2, 0xff6885c1, 0xff6986c2, 0xff6d88c0,
    0xff6a89bf, 0xff7088c1, 0xff718bc1, 0xff7287c4, 0xff7189c7, 0xff718bcd, 0xff738cd0, 0xff768fcf,
    0xff6d7d90, 0xff718591, 0xff8393c3, 0xff6782b4, 0xff627eae, 0xff627992, 0xff62768c, 0xff67727d,
    0xff42649c, 0xff48669b, 0xff4c6e70, 0xff2c4331, 0xff33412a, 0xff3a4c32, 0xff3e4828, 0xff333f24,
    0xff3a4939, 0xff435240, 0xff314125, 0xff384d23, 0xff3e4d33, 0xff53665e, 0xff2d3b1f, 0xff3b4e45,
    0xff3c535f, 0xff3f5b62, 0xff29361d, 0xff18201a, 0xff181a0f, 0xff131c13, 0xff0d231d, 0xff120b11,
    0xff0d1706, 0xff24402a, 0xff3a5764, 0xff324a51, 0xff2f4546, 0xff061412, 0xff08130a, 0xff233325,
    0xff416aa4, 0xff3f6ba8, 0xff426ca6, 0xff456daa, 0xff4670aa, 0xff4870ac, 0xff4871ac, 0xff4a71ad,
    0xff4d73b0, 0xff4c75b1, 0xff4c75b3, 0xff4f74b1, 0xff5274b5, 0xff5276b3, 0xff5377b5, 0xff5378b3,
    0xff5376b4, 0xff5378b9, 0xff5379b9, 0xff587abb, 0xff557cbc, 0xff5b7ebe, 0xff5e81c0, 0xff6083bf,
    0xff6185c1, 0xff6182be, 0xff6384bf, 0xff6586c1, 0xff6686c2, 0xff6784c0, 0xff6885c2, 0xff6a85bf,
    0xff6888be, 0xff6e88c0, 0xff6e89c0, 0xff7086c0, 0xff6f87c2, 0xff6f89c1, 0xff6c86bb, 0xff718cc4,
    0xff627170, 0xff65786d, 0xff8391b3, 0xff6882a7, 0xff6980a3, 0xff67777d, 0xff62737c, 0xff676e62,
    0xff4669a4, 0xff4a68a3, 0xff4f7272, 0xff2a4033, 0xff293524, 0xff364930, 0xff3b482b, 0xff29341d,
    0xff303e24, 0xff40513e, 0xff42512d, 0xff344c1d, 0xff3e4f31, 0xff51634d, 0xff26340f, 0xff334225,
    0xff2f423f, 0xff37524f, 0xff293a17, 0xff121b18, 0xff191d0e, 0xff0d1714, 0xff182d26, 0xff0b1111,
    0xff171f0c, 0xff1b3828, 0xff425d62, 0xff31454b, 0xff223549, 0xff121a19, 0xff1d1616, 0xff313327,
    0xff4c77af, 0xff4673af, 0xff4873ae, 0xff4670ae, 0xff4771ae, 0xff4a73b0, 0xff4a73b0, 0xff4a73b1,
    0xff4c73b3, 0xff4c76b4, 0xff4c76b6, 0xff4d75b5, 0xff4f75b6, 0xff5077b5, 0xff4f76b6, 0xff4f75b6,
    0xff5074b5, 0xff5077b8, 0xff5379ba, 0xff5a7cbc, 0xff587ebe, 0xff5c80c0, 0xff5e82bf, 0xff6084c1,
    0xff6285c1, 0xff6182be, 0xff6384c0, 0xff6687c2, 0xff6586c0, 0xff6683bf, 0xff6784c0, 0xff6884bd,
    0xff6686bc, 0xff6b87be, 0xff6b86bf, 0xff6f88b7, 0xff6d85b3, 0xff6d87a0, 0xff647b8a, 0xff6b86a6,
    0xff5a6a5f, 0xff4a5f4c, 0xff6f828c, 0xff647b89, 0xff6e7d89, 0xff646f63, 0xff586969, 0xff565f44,
    0xff5778b3, 0xff506fb2, 0xff587b9e, 0xff344838, 0xff293523, 0xff33442c, 0xff314225, 0xff223018,
    0xff2c3e1d, 0xff2f432e, 0xff575f35, 0xff364e20, 0xff3b4d27, 0xff47593b, 0xff313e14, 0xff253315,
    0xff18241e, 0xff2a4332, 0xff324a1b, 0xff152014, 0xff10160a, 0xff132116, 0xff374632, 0xff0d2210,
    0xff2b361b, 0xff17321a, 0xff485a4b, 0xff192528, 0xff242834, 0xff312a22, 0xff603f34, 0xff543f2d,
    0xff5a87ba, 0xff507db6, 0xff517db7, 0xff4b77b2, 0xff4b75b2, 0xff4d78b4, 0xff4e77b6, 0xff4e77b6,
    0xff4e76b6, 0xff4e78b7, 0xff507aba, 0xff4f79b9, 0xff5079b8, 0xff5079b8, 0xff4f78b7, 0xff4f75b9,
    0xff5076b7, 0xff5077b7, 0xff547bbc, 0xff5c7ebe, 0xff5d81c0, 0xff5e83c1, 0xff5f84be, 0xff6185c2,
    0xff6485c1, 0xff6284be, 0xff6386c1, 0xff6788c2, 0xff6586be, 0xff6684bf, 0xff6784be, 0xff6683bc,
    0xff6584bb, 0xff6885bc, 0xff6883bf, 0xff6e89a9, 0xff6c839e, 0xff69827a, 0xff5d7058, 0xff647f82,
    0xff546657, 0xff354a37, 0xff5a7163, 0xff5d7067, 0xff6d766b, 0xff5f654e, 0xff4b5d57, 0xff41512e,
    0xff6684b8, 0xff5474b7, 0xff5f81c6, 0xff40523f, 0xff2c3824, 0xff31422b, 0xff263d1e, 0xff213419,
    0xff2e4721, 0xff22391e, 0xff646639, 0xff3e5327, 0xff374b1e, 0xff40522d, 0xff414d22, 0xff1a2a12,
    0xff040906, 0xff1d3117, 0xff3d5b23, 0xff1a2810, 0xff050e06, 0xff1e301a, 0xff585d3d, 0xff173510,
    0xff42502c, 0xff192d0c, 0xff485030, 0xff020506, 0xff2c201a, 0xff533d2b, 0xffa06b50, 0xff704830,
    0xff6692bf, 0xff5d89ba, 0xff5e89bd, 0xff5883b8, 0xff5780b7, 0xff5882b9, 0xff5880ba, 0xff5880ba,
    0xff587fb9, 0xff5780ba, 0xff5b83bd, 0xff5982bd, 0xff5882ba, 0xff567fbb, 0xff567fba, 0xff577cbe,
    0xff567dbb, 0xff557cb9, 0xff557cbc, 0xff597ebe, 0xff5d81bf, 0xff5e84c0, 0xff5c82bd, 0xff5e83c0,
    0xff6284c0, 0xff5e83bf, 0xff5f84c0, 0xff6386c1, 0xff6284bc, 0xff6382be, 0xff6482bd, 0xff6281bb,
    0xff6282ba, 0xff6382b9, 0xff6581be, 0xff6b8695, 0xff687e7f, 0xff5e765a, 0xff5a6b3e, 0xff5d7563,
    0xff50644e, 0xff434f37, 0xff5c6e4f, 0xff4f634b, 0xff626c4f, 0xff5a5d43, 0xff445649, 0xff364d24,
    0xff5f7c95, 0xff4e6b93, 0xff5a79b2, 0xff43533e, 0xff25331e, 0xff32462c, 0xff203b1b, 0xff26401e,
    0xff385727, 0xff2f491e, 0xff555932, 0xff485d2c, 0xff394e1b, 0xff4c622a, 0xff455327, 0xff1d3214,
    0xff000200, 0xff0c1a02, 0xff426029, 0xff212f13, 0xff010906, 0xff2b3722, 0xff676243, 0xff2e411b,
    0xff546134, 0xff212a0c, 0xff3c3d1d, 0xff0a0706, 0xff392418, 0xff704b39, 0xffa77053, 0xff623e27,
    0xff6d98bf, 0xff6a93bc, 0xff6a94bf, 0xff6991bd, 0xff678fbb, 0xff658ebc, 0xff648abc, 0xff658cbc,
    0xff668cbc, 0xff6289bd, 0xff698ebf, 0xff698ec0, 0xff648dbc, 0xff5f87bd, 0xff638abe, 0xff6589c2,
    0xff6187c0, 0xff5b83bc, 0xff567dba, 0xff517bbc, 0xff597fbd, 0xff5b82bd, 0xff577fbc, 0xff5980bd,
    0xff5e81bd, 0xff5780c0, 0xff5780bd, 0xff5b81be, 0xff5d7fbb, 0xff5c7ebd, 0xff5f80bd, 0xff5d7ebb,
    0xff5d7fba, 0xff5d7db5, 0xff617fbc, 0xff678081, 0xff657a60, 0xff516849, 0xff5d6d44, 0xff576b4f,
    0xff506548, 0xff6e6a4c, 0xff737954, 0xff3f563b, 0xff4f613d, 0xff595b44, 0xff435642, 0xff39552c,
    0xff466457, 0xff3e5954, 0xff4b666d, 0xff3e4a35, 0xff192615, 0xff36502f, 0xff1f3c1c, 0xff315127,
    0xff476a30, 0xff526d2d, 0xff303d21, 0xff53682f, 0xff3f541f, 0xff678332, 0xff3f5223, 0xff2b471b,
    0xff071006, 0xff000300, 0xff40592c, 0xff28341b, 0xff060909, 0xff36352a, 0xff615443, 0xff4a442c,
    0xff5d6534, 0xff2d2a17, 0xff282519, 0xff2c2a26, 0xff48332a, 0xff805146, 0xff79513d, 0xff322514,
    0xff7099bd, 0xff7399bd, 0xff729bc0, 0xff779dc2, 0xff759bbf, 0xff7298bf, 0xff6f94be, 0xff7296be,
    0xff7297bf, 0xff6e92bf, 0xff7598c1, 0xff7699c1, 0xff7096be, 0xff6a90c0, 0xff7094c1, 0xff7395c4,
    0xff6d91c3, 0xff658bc0, 0xff5d82bb, 0xff5880bd, 0xff5e83bd, 0xff6185bc, 0xff5f83be, 0xff5f84bc,
    0xff6385be, 0xff5e85c3, 0xff6086be, 0xff6185bf, 0xff6584bf, 0xff6483bf, 0xff6786c0, 0xff6685be,
    0xff6786be, 0xff6783b8, 0xff6b87c0, 0xff677c74, 0xff5b6f44, 0xff455b3f, 0xff5a6b4c, 0xff4f6142,
    0xff4a6142, 0xff8c7e5e, 0xff837f5b, 0xff395239, 0xff425b38, 0xff535a46, 0xff465841, 0xff395633,
    0xff2d4b20, 0xff2d451b, 0xff354a26, 0xff343f2c, 0xff0f1c0e, 0xff32502d, 0xff26401f, 0xff436531,
    0xff547636, 0xff6d863b, 0xff152914, 0xff5e712f, 0xff425422, 0xff738f36, 0xff394b1f, 0xff3e5b23,
    0xff1b2512, 0xff000000, 0xff344628, 0xff28311e, 0xff0d0d0e, 0xff403631, 0xff52433b, 0xff594034,
    0xff56592b, 0xff372d22, 0xff171417, 0xff464640, 0xff4d3f37, 0xff80544b, 0xff3e2a21, 0xff030d04,
    0xff739dc6, 0xff77a0c6, 0xff77a1c9, 0xff7ea5ca, 0xff7da3c9, 0xff7ca1c8, 0xff789cc5, 0xff789cc3,
    0xff789cc2, 0xff7296c1, 0xff7a9cc4, 0xff7d9ec4, 0xff7499c0, 0xff7597c4, 0xff7698c2, 0xff7a9ac4,
    0xff7799c5, 0xff7094c4, 0xff6e8ebf, 0xff7894c1, 0xff7492c2, 0xff7593c0, 0xff7b96c4, 0xff7996c3,
    0xff7b96c4, 0xff7e9ac9, 0xff869fca, 0xff839cca, 0xff879dcb, 0xff859ac9, 0xff879dca, 0xff8c9fc9,
    0xff8d9fca, 0xff8e9ec6, 0xff8d9fcf, 0xff6a7c76, 0xff445a30, 0xff3c563a, 0xff465c44, 0xff435238,
    0xff385138, 0xff7a7256, 0xff777155, 0xff455c48, 0xff485d44, 0xff455640, 0xff495945, 0xff27422d,
    0xff1d390e, 0xff1b3608, 0xff192906, 0xff2b3827, 0xff111e0f, 0xff213b1d, 0xff354b25, 0xff617e3c,
    0xff5c7637, 0xff70853e, 0xff223317, 0xff69762e, 0xff3d481f, 0xff5e6b2a, 0xff394121, 0xff4e5f27,
    0xff2e3216, 0xff1c170f, 0xff182114, 0xff131913, 0xff10120e, 0xff484133, 0xff423e2b, 0xff4b3528,
    0xff333a18, 0xff372f24, 0xff101113, 0xff414539, 0xff44412f, 0xff725f44, 0xff1a120f, 0xff000400,
    0xff719dcd, 0xff73a0cc, 0xff74a0cf, 0xff7ba4cd, 0xff7ca3cf, 0xff7ea3cd, 0xff7ba0ca, 0xff789cc5,
    0xff789bc3, 0xff7297c1, 0xff799cc5, 0xff7c9ec4, 0xff7497c1, 0xff7c9bc6, 0xff7798c0, 0xff7b99c1,
    0xff7d9dc5, 0xff7a9bc6, 0xff819cc4, 0xff9eabc7, 0xff8ea4c8, 0xff8da4c6, 0xff9dadcc, 0xff99abcd,
    0xff97a9cc, 0xffa4b1cf, 0xffb3bad7, 0xffabb5d6, 0xffaeb9d8, 0xffabb5d4, 0xffabb5d4, 0xffb7bbd5,
    0xffb7bad7, 0xffbabdd5, 0xffb3b9de, 0xff707f82, 0xff2f4629, 0xff3a573d, 0xff334c38, 0xff384737,
    0xff264231, 0xff535944, 0xff5f5f4b, 0xff5b6d60, 0xff576558, 0xff375438, 0xff4d5c4c, 0xff142b22,
    0xff1b3217, 0xff103011, 0xff020f03, 0xff233324, 0xff182415, 0xff0c1e0b, 0xff45542b, 0xff7b8f41,
    0xff5c6c33, 0xff606f38, 0xff3f4a22, 0xff6e742b, 0xff36371a, 0xff383118, 0xff3d3725, 0xff585827,
    0xff423d16, 0xff453f25, 0xff000000, 0xff000104, 0xff13190d, 0xff4c4e31, 0xff333f19, 0xff2d2913,
    0xff0b1704, 0xff313221, 0xff12190f, 0xff293221, 0xff2f3b1c, 0xff596534, 0xff080605, 0xff000602,
    0xff648ebf, 0xff6591be, 0xff6791c1, 0xff6d95be, 0xff6f95c3, 0xff7396c0, 0xff7799c2, 0xff7798c1,
    0xff7999bf, 0xff7a9bc1, 0xff7899c1, 0xff7999c0, 0xff7998c1, 0xff809cc4, 0xff7e9bc2, 0xff809cc1,
    0xff819fc5, 0xff85a2c9, 0xff90a7c9, 0xffb0b7cb, 0xff9eafcd, 0xff9db0cc, 0xffb0bad2, 0xffa6b4d0,
    0xffa1b0d0, 0xffb4bad1, 0xffbfc0d6, 0xffb4b8d3, 0xffb3bcd4, 0xffb3bad0, 0xffb1b7cf, 0xffbfbfd1,
    0xffbfbed1, 0xffc8c5d3, 0xffb9bcd6, 0xff79898c, 0xff2f442c, 0xff445a3f, 0xff3b4c39, 0xff3a4c38,
    0xff274630, 0xff495640, 0xff555c46, 0xff6d7867, 0xff5e6b5c, 0xff345835, 0xff53624e, 0xff16281e,
    0xff243724, 0xff17351f, 0xff000407, 0xff19251c, 0xff131c13, 0xff000801, 0xff414c2b, 0xff707a36,
    0xff4d5326, 0xff3d4525, 0xff3f461d, 0xff5e6220, 0xff2c2c14, 0xff180b08, 0xff373022, 0xff565225,
    0xff584e1e, 0xff57592d, 0xff020502, 0xff020402, 0xff16250f, 0xff454f2c, 0xff283b10, 0xff171f07,
    0xff000c00, 0xff2b361b, 0xff16260d, 0xff101a09, 0xff162c08, 0xff34521e, 0xff000000, 0xff000602,
    0xff4d729c, 0xff4e749c, 0xff50749e, 0xff54779d, 0xff587aa3, 0xff5b7ca0, 0xff6a87ab, 0xff7491b5,
    0xff7d97b7, 0xff8aa3c3, 0xff7a96b8, 0xff7692b7, 0xff869fc2, 0xff7f99bd, 0xff8da3c6, 0xff8ca5c5,
    0xff849ec4, 0xff8da7cb, 0xff95accc, 0xffa4b1cd, 0xff9bafcf, 0xff9fb4d2, 0xffaab8d6, 0xff9aabcb,
    0xff94a8cc, 0xffa1afce, 0xff9da7c3, 0xff929fbc, 0xff8c9ebd, 0xff95a3bb, 0xff8e9bb8, 0xff99a4b9,
    0xff98a2b6, 0xffabafb9, 0xff96a2b4, 0xff839690, 0xff485839, 0xff5b5c40, 0xff665f4b, 0xff4a613b,
    0xff416236, 0xff697150, 0xff627048, 0xff757855, 0xff576d48, 0xff416237, 0xff586c49, 0xff314023,
    0xff37492c, 0xff31452a, 0xff0c0e0a, 0xff0c0e0d, 0xff000406, 0xff000105, 0xff242f24, 0xff3b3d1b,
    0xff2f3012, 0xff0d1106, 0xff151f03, 0xff37400e, 0xff222b0f, 0xff080700, 0xff272e15, 0xff464e20,
    0xff6b642c, 0xff455a22, 0xff2b3b1f, 0xff2a2b13, 0xff1c3412, 0xff344125, 0xff243014, 0xff121d0a,
    0xff1e2312, 0xff263b16, 0xff19330e, 0xff000600, 0xff001600, 0xff0c2507, 0xff000000, 0xff000100,
    0xff345373, 0xff345474, 0xff365575, 0xff385779, 0xff3d5c7f, 0xff3e5d7c, 0xff56708f, 0xff6a83a3,
    0xff788ea7, 0xff90a2bd, 0xff738da9, 0xff6b85a7, 0xff8a9dba, 0xff738faf, 0xff91a4c4, 0xff8da5c2,
    0xff7d95bd, 0xff8ba3c5, 0xff8da6c5, 0xff869ec5, 0xff8aa3c7, 0xff93abcd, 0xff94a8d0, 0xff7e97bd,
    0xff7a95c0, 0xff7f97c3, 0xff6e85a9, 0xff657da0, 0xff5d7aa1, 0xff6e85a3, 0xff677da1, 0xff6b839f,
    0xff6a8199, 0xff86929d, 0xff708591, 0xff8ca292, 0xff6f7750, 0xff776448, 0xff977a63, 0xff637e46,
    0xff658545, 0xff969568, 0xff788c53, 0xff7a7843, 0xff547237, 0xff5d7443, 0xff657b4a, 0xff5d6835,
    0xff57673c, 0xff59603a, 0xff312f1c, 0xff130b0b, 0xff000005, 0xff021318, 0xff131e24, 0xff100b0a,
    0xff211f0b, 0xff000000, 0xff000500, 0xff1f2e09, 0xff2a3d17, 0xff142308, 0xff263c13, 0xff3a5121,
    0xff827d41, 0xff375a1c, 0xff668048, 0xff63612f, 0xff2e491d, 0xff2b3523, 0xff2f2d23, 0xff222619,
    0xff4d472e, 0xff2c4418, 0xff234115, 0xff000000, 0xff000b00, 0xff000100, 0xff000000, 0xff000400,
    0xff14334e, 0xff153753, 0xff173954, 0xff1c3d5c, 0xff1f415f, 0xff1e415d, 0xff345370, 0xff4a6684,
    0xff546e87, 0xff6c829c, 0xff506e8a, 0xff486687, 0xff617995, 0xff4a6b8b, 0xff778dac, 0xff748da9,
    0xff627da2, 0xff6f89a9, 0xff708ba9, 0xff5f7da7, 0xff6c87ab, 0xff7690b3, 0xff708ab4, 0xff5e7ca2,
    0xff5e7da7, 0xff5e7bab, 0xff536f95, 0xff4f6b8d, 0xff557093, 0xff687d98, 0xff7084a1, 0xff697f99,
    0xff6b7f94, 0xff859097, 0xff7d8d90, 0xff9aaa97, 0xffa09e78, 0xff998167, 0xffb9987d, 0xff889a62,
    0xff8ea265, 0xffbbb284, 0xff96a46b, 0xff908b53, 0xff738d4e, 0xff929968, 0xff939c67, 0xffa0a166,
    0xff979d5f, 0xff978d55, 0xff7a764e, 0xff554a38, 0xff403d36, 0xff4b5746, 0xff494e46, 0xff3b342f,
    0xff545235, 0xff2c2c20, 0xff2d3a23, 0xff4c5c35, 0xff637844, 0xff526738, 0xff607a44, 0xff586b3a,
    0xffb2aa69, 0xff65813e, 0xffabb971, 0xffa79b5a, 0xff666d3d, 0xff423e2f, 0xff533e38, 0xff4e4435,
    0xff766448, 0xff4a552c, 0xff3d5029, 0xff13130e, 0xff1e2414, 0xff201411, 0xff282017, 0xff191e11,
    0xff001a36, 0xff00233f, 0xff002742, 0xff07304e, 0xff05314e, 0xff032f4b, 0xff0e3855, 0xff1d4362,
    0xff1d425f, 0xff2a4d6c, 0xff1c4363, 0xff193f60, 0xff1a3e5f, 0xff0e395c, 0xff476888, 0xff486585,
    0xff3b5d7d, 0xff436282, 0xff466482, 0xff3a5a7d, 0xff4a6484, 0xff536b8a, 0xff4b678c, 0xff426084,
    0xff496689, 0xff48648d, 0xff526b8b, 0xff556b88, 0xff738196, 0xff828a9d, 0xffa3aab9, 0xff9096a8,
    0xff979ba6, 0xffa7a7a8, 0xffb7b6af, 0xffa9ac9d, 0xffcdc2a5, 0xffb9aa94, 0xffc5b091, 0xffafb088,
    0xffb0b18b, 0xffd1c39d, 0xffb2b28b, 0xffaea87d, 0xffa9b483, 0xffd2c699, 0xffd2c496, 0xffe7dba5,
    0xffe2db8a, 0xffd8bd70, 0xffd2cd8f, 0xffbcb482, 0xffb0ae88, 0xffb7b981, 0xffb3ac7c, 0xffa9a57d,
    0xffb5b580, 0xff9fa074, 0xffa1a97a, 0xffafb981, 0xffbbc986, 0xffafbf7e, 0xffc3d395, 0xff949461,
    0xffeddc96, 0xffbcbf7b, 0xffe6d791, 0xffe2c987, 0xffb29668, 0xff715742, 0xff855e4e, 0xff8a6d54,
    0xff8d7158, 0xff766a4c, 0xff5d5c44, 0xff453b33, 0xff695844, 0xff76573f, 0xff7f6548, 0xff4c4630,
    0xff00223c, 0xff002b45, 0xff002c46, 0xff0a3752, 0xff06364f, 0xff05344e, 0xff053450, 0xff093553,
    0xff04304e, 0xff043150, 0xff073253, 0xff093351, 0xff002949, 0xff002d4e, 0xff184261, 0xff1c4161,
    0xff18425d, 0xff1b3f5d, 0xff1f415e, 0xff1b3e58, 0xff294661, 0xff304a66, 0xff294968, 0xff294969,
    0xff34516c, 0xff335070, 0xff4e6680, 0xff566a82, 0xff808a94, 0xff8a8d9a, 0xffbcbec1, 0xffa1a1ac,
    0xffaca8ad, 0xffb2b0af, 0xffd5ccc2, 0xffa3a29b, 0xffd6ccbd, 0xffb8baad, 0xffb3b399, 0xffb6b09e,
    0xffb4aba1, 0xffc7bca7, 0xffb3ae9e, 0xffb3b49d, 0xffc3c5ab, 0xffead7b7, 0xffecd2b5, 0xfffff2cd,
    0xfffff7a6, 0xfff4d585, 0xffffffbc, 0xfffefdb9, 0xfffdfdc3, 0xfffefaa9, 0xfffdeea4, 0xfffcfbb8,
    0xfffdfdb8, 0xfffbfbb6, 0xfffcfcbb, 0xfffcfdb8, 0xfffdfeb5, 0xfffcfeb4, 0xfffeffc3, 0xffb09f73,
    0xffffe9a8, 0xfffde5a7, 0xffffd89c, 0xffffdea1, 0xffedb589, 0xffa87e5e, 0xffbb8969, 0xffc69973,
    0xffa57f66, 0xffa37f69, 0xff7e6859, 0xff776453, 0xffa6846a, 0xffb78d64, 0xffb9956b, 0xff74654a,
    0xff3d5b6d, 0xff355c6d, 0xff2d5568, 0xff2d566a, 0xff2d5668, 0xff335a6d, 0xff30586d, 0xff2b5369,
    0xff30566d, 0xff254d64, 0xff30556c, 0xff33596e, 0xff416276, 0xff496b80, 0xff00263f, 0xff002c45,
    0xff05354b, 0xff032f49, 0xff052f48, 0xff073248, 0xff0e364e, 0xff163c53, 0xff143d55, 0xff153f5a,
    0xff1d4558, 0xff1e465d, 0xff32566c, 0xff3c5e71, 0xff5e777f, 0xff5f7380, 0xff929fa1, 0xff778790,
    0xff818b92, 0xff849194, 0xffa8acab, 0xff7e888b, 0xffa5abaa, 0xff849998, 0xff83978d, 0xff8a9192,
    0xff888d94, 0xff939b99, 0xff899095, 0xff899897, 0xff9da8a4, 0xffb8b4aa, 0xffbcb2a9, 0xffcecbbe,
    0xffcdcf9f, 0xffcdbe89, 0xffdee3b4, 0xffe7eab5, 0xffeeedbc, 0xfff0eba4, 0xfff1e1a1, 0xfff6f3b5,
    0xfffcf3b6, 0xfffffbbb, 0xfffbf0b3, 0xfffceeae, 0xfffff1ad, 0xffffffb8, 0xffdccd9a, 0xff7b6d50,
    0xffceb786, 0xfffcd4a1, 0xffe9bb88, 0xfff0cd98, 0xfffbc392, 0xffdcb07f, 0xffe9ba87, 0xfff2be8a,
    0xffc09271, 0xffbf8f75, 0xff91715d, 0xff91775d, 0xffa98669, 0xffa48560, 0xff9a825f, 0xff6b5d4a,
    0xff92a6ad, 0xff7f99a2, 0xff6e8a95, 0xff5f7f8b, 0xff65818c, 0xff738e98, 0xff738d98, 0xff678590,
    0xff7a95a1, 0xff6b8793, 0xff78919c, 0xff7c98a2, 0xffaebfc2, 0xffb7c8cd, 0xff001b2c, 0xff002a3a,
    0xff06384b, 0xff003247, 0xff003044, 0xff06374d, 0xff02384e, 0xff0c4054, 0xff0f4255, 0xff0f4258,
    0xff0f4251, 0xff124556, 0xff14475c, 0xff1d4f62, 0xff285766, 0xff225061, 0xff486971, 0xff335d69,
    0xff395c6a, 0xff3e646f, 0xff577481, 0xff4c6977, 0xff567380, 0xff3b606b, 0xff476b76, 0xff456373,
    0xff476375, 0xff4c6d7d, 0xff4a687b, 0xff4b6b7c, 0xff567484, 0xff5f7683, 0xff667985, 0xff70838e,
    0xff6d8484, 0xff808c80, 0xff8a978b, 0xff98a08b, 0xffa2a28d, 0xffa8a883, 0xffaca283, 0xffb5af8a,
    0xffc5b48c, 0xffd3bf97, 0xffc1ab80, 0xffccaf7f, 0xffddba85, 0xfffed39a, 0xff846745, 0xff252218,
    0xff78664a, 0xffcea17a, 0xffb18c63, 0xffc1a378, 0xffe4be87, 0xfffdd999, 0xffffdf9d, 0xffffd294,
    0xffd4a376, 0xffc99674, 0xff997657, 0xff977b57, 0xff8b7053, 0xff6a5e47, 0xff534e3c, 0xff4e453f,
    0xffb8c5c9, 0xffa2b4ba, 0xff8fa3ab, 0xff7e97a0, 0xff899ba3, 0xff99aab1, 0xff9baab2, 0xff8ba0a7,
    0xffa4b5bc, 0xff9daeb4, 0xffacbcc0, 0xffb2c5ca, 0xffeff5f1, 0xfff5faf9, 0xff042534, 0xff0b3e4c,
    0xff1e4c60, 0xff18475b, 0xff134356, 0xff174960, 0xff154c61, 0xff195166, 0xff184e61, 0xff184e63,
    0xff124b5b, 0xff154d5e, 0xff144c61, 0xff114c60, 0xff09455b, 0xff013e52, 0xff134454, 0xff043e51,
    0xff033850, 0xff164b5f, 0xff225169, 0xff27556a, 0xff1c4c62, 0xff0d3e54, 0xff1e4e67, 0xff16475f,
    0xff1a4a61, 0xff1a4d67, 0xff1e4d68, 0xff214f6a, 0xff23506b, 0xff1e4b66, 0xff254f67, 0xff2c516a,
    0xff2b536f, 0xff436576, 0xff445c68, 0xff52656a, 0xff5b6465, 0xff5d6a62, 0xff616766, 0xff686a62,
    0xff786c60, 0xff8d7f73, 0xff86735a, 0xff9f805e, 0xffb28a66, 0xffce9d77, 0xff3d1c0c, 0xff000000,
    0xff402d24, 0xff9d6f56, 0xff836346, 0xff95795a, 0xffbfa673, 0xfff5d899, 0xfff7dc9b, 0xfff8ca8d,
    0xffd5a775, 0xffc79770, 0xff9d7952, 0xff997c56, 0xff7c6648, 0xff57503e, 0xff3f3f31, 0xff5b4c43,
    0xff97a5b0, 0xff8a99a7, 0xff80919f, 0xff7e939f, 0xff8796a4, 0xff92a0ab, 0xff93a0ab, 0xff8496a2,
    0xff95a3ae, 0xffa3b0b8, 0xffb5c1cb, 0xffc0ccd5, 0xffe2e7e9, 0xffe4e6ed, 0xff244358, 0xff3d6479,
    0xff496d86, 0xff466b81, 0xff40647b, 0xff38647d, 0xff466f85, 0xff3d6a85, 0xff2d5d77, 0xff306078,
    0xff295d76, 0xff295b73, 0xff39697f, 0xff215970, 0xff104963, 0xff0f465e, 0xff0a3f56, 0xff003753,
    0xff002e4e, 0xff20556f, 0xff235471, 0xff1e516c, 0xff0e4560, 0xff0f4460, 0xff174b67, 0xff124a61,
    0xff174d65, 0xff104760, 0xff174c64, 0xff1d536c, 0xff1b4e67, 0xff114660, 0xff14465d, 0xff1f4c63,
    0xff27536e, 0xff2f5a70, 0xff264c5a, 0xff335462, 0xff355058, 0xff2b4a50, 0xff2a4855, 0xff294150,
    0xff293443, 0xff495462, 0xff666556, 0xff8b7a60, 0xff917761, 0xff91705f, 0xff260c0c, 0xff1b0c11,
    0xff402726, 0xff7b4f43, 0xff724f3c, 0xff7f5d4a, 0xff987f5e, 0xffc0a379, 0xffc3a97d, 0xffcba477,
    0xffc19c6f, 0xffbb906b, 0xff9d7b55, 0xff997e5d, 0xff8b7353, 0xff836c51, 0xff79684e, 0xff9e7d5e,
    0xff5d7084, 0xff5b6d85, 0xff5c6f84, 0xff6b7f91, 0xff708197, 0xff748495, 0xff738394, 0xff687a8e,
    0xff6d7c8e, 0xff909baa, 0xffa4aec2, 0xffb0b9ca, 0xffafb9c7, 0xffacb2c5, 0xff486681, 0xff6f89a7,
    0xff728ba9, 0xff738ca6, 0xff6e869f, 0xff5c7d99, 0xff7b92a8, 0xff6382a4, 0xff486d8f, 0xff4c728e,
    0xff456f91, 0xff426989, 0xff64859d, 0xff3d6a85, 0xff2d5a76, 0xff376179, 0xff21516d, 0xff134567,
    0xff073c61, 0xff47738f, 0xff3b6684, 0xff255874, 0xff1c506b, 0xff285978, 0xff23556f, 0xff23596c,
    0xff285c73, 0xff1d5063, 0xff23586a, 0xff2c6273, 0xff285b6c, 0xff1f5465, 0xff1e4e5f, 0xff2e5d6a,
    0xff3e6773, 0xff325f6c, 0xff225158, 0xff2b5765, 0xff234e58, 0xff123f4b, 0xff103f50, 0xff09314a,
    0xff001c37, 0xff20445c, 0xff5d6f63, 0xff898970, 0xff81796a, 0xff645753, 0xff34252b, 0xff5a3d3b,
    0xff61423e, 0xff6e473f, 0xff795343, 0xff7e5749, 0xff7f6352, 0xff886c58, 0xff8f745d, 0xff9e7d61,
    0xffab8f69, 0xffae8a67, 0xffa07f5c, 0xff9a8065, 0xffa38664, 0xffbc926a, 0xffc49d72, 0xffe4b17a,
    0xff3c536b, 0xff415772, 0xff425871, 0xff51667c, 0xff526880, 0xff54697c, 0xff52687b, 0xff495d74,
    0xff475b6e, 0xff6b7b8e, 0xff808ea8, 0xff8895aa, 0xff7a8ba1, 0xff74829c, 0xff5a7794, 0xff788fae,
    0xff7c91ae, 0xff8397af, 0xff7e93a9, 0xff748ca5, 0xff93a1b5, 0xff7289aa, 0xff647f9d, 0xff607f98,
    0xff527494, 0xff4f708e, 0xff6b869b, 0xff557791, 0xff55738b, 0xff718a9e, 0xff5b7b95, 0xff506f8e,
    0xff496b8a, 0xff839db6, 0xff4c6e8d, 0xff325d7c, 0xff345f7e, 0xff386183, 0xff335d7a, 0xff2f6077,
    0xff386680, 0xff2f5c6f, 0xff326174, 0xff346675, 0xff366473, 0xff2f606f, 0xff2c5b68, 0xff3b6a73,
    0xff497278, 0xff38656f, 0xff265861, 0xff2a5969, 0xff1a4b5b, 0xff184659, 0xff264e61, 0xff2a484e,
    0xff23494e, 0xff456b6c, 0xff829378, 0xffa4a37f, 0xff9a9b81, 0xff777464, 0xff6d6559, 0xff9c7e67,
    0xff917460, 0xff8a6c57, 0xff9e7e60, 0xff9e8064, 0xff957c62, 0xff8e745d, 0xff957b61, 0xffa28364,
    0xffb29870, 0xffb6936c, 0xffb6946d, 0xffa98b6e, 0xffba9772, 0xffd6a578, 0xffe9b583, 0xfff9c184,
    0xff39546a, 0xff405a73, 0xff375167, 0xff375066, 0xff365067, 0xff395465, 0xff375366, 0xff2e475b,
    0xff2c4656, 0xff3e586c, 0xff536984, 0xff53697d, 0xff4f6982, 0xff48627b, 0xff57738c, 0xff5a7890,
    0xff647e96, 0xff72899b, 0xff708999, 0xff788d9e, 0xff8a9ba9, 0xff697f98, 0xff798c9e, 0xff678295,
    0xff4f6a81, 0xff4e6d82, 0xff506c7c, 0xff657d91, 0xff7d8d9c, 0xffadb7c4, 0xffa9b2c2, 0xffa0aabc,
    0xffa5afbe, 0xffc5c9da, 0xff566d8d, 0xff436282, 0xff537095, 0xff3f5c7f, 0xff436286, 0xff355c7f,
    0xff456989, 0xff416780, 0xff3f6680, 0xff365e71, 0xff41687a, 0xff3f687a, 0xff3c6a75, 0xff46727c,
    0xff49747b, 0xff416d76, 0xff316072, 0xff315a6c, 0xff1c4962, 0xff3b5c75, 0xff637182, 0xff80805b,
    0xff93ac80, 0xffa8bd8b, 0xffc9c890, 0xffd5c38c, 0xffd4d2a0, 0xffc2bf8d, 0xffc1bb8a, 0xffcfbd8a,
    0xffc4b083, 0xffc6b383, 0xffd7c28b, 0xffd6cb93, 0xffd2c18b, 0xffccb584, 0xffd0b886, 0xffd4af7e,
    0xffd2b181, 0xffcea978, 0xffd9b181, 0xffc19b75, 0xffc9a278, 0xffcca178, 0xffe0ac7d, 0xffdbab7b,
    0xff3e5b71, 0xff456278, 0xff335065, 0xff254158, 0xff234256, 0xff254655, 0xff254659, 0xff1f3b4e,
    0xff1c3c4a, 0xff1d3e54, 0xff2d4a63, 0xff28465a, 0xff2f4f68, 0xff2d4e67, 0xff4d687d, 0xff3b5f71,
    0xff48677a, 0xff597381, 0xff597782, 0xff718592, 0xff768b98, 0xff587184, 0xff7e8e98, 0xff637d8c,
    0xff48606f, 0xff486876, 0xff355462, 0xff677b8b, 0xff9099a2, 0xffc8ccd5, 0xffd2ced7, 0xffcbc9d3,
    0xffddd8dd, 0xffe0d8e4, 0xff566786, 0xff4f6485, 0xff677aa1, 0xff41587b, 0xff4d648d, 0xff405e88,
    0xff4d698f, 0xff4f6e8e, 0xff4b6a8c, 0xff3c5a73, 0xff4e6d82, 0xff517185, 0xff507885, 0xff567c88,
    0xff4f7681, 0xff557982, 0xff527386, 0xff506977, 0xff3f5b70, 0xff74808f, 0xffab9c9d, 0xffd8b86e,
    0xfff9fba6, 0xfffbf79f, 0xfffde99c, 0xfff8d491, 0xfffef1ae, 0xfffcf0a7, 0xfffbf0a6, 0xffede29d,
    0xffe9d999, 0xfff5e5a2, 0xfffeeea6, 0xfffefdb1, 0xfffdf0a6, 0xfffce7a2, 0xfffde7a2, 0xfffcd394,
    0xffebc38d, 0xffe3bb82, 0xfff2c78f, 0xffd5a87b, 0xffd4a97a, 0xffc39d77, 0xffd2a074, 0xffbf9672,
    0xff446079, 0xff4a667f, 0xff3a566f, 0xff2b465f, 0xff29475d, 0xff234457, 0xff27475b, 0xff284459,
    0xff244353, 0xff1e3f56, 0xff244159, 0xff254359, 0xff29485f, 0xff34546e, 0xff456075, 0xff395a6c,
    0xff405e72, 0xff496474, 0xff4c6a77, 0xff647a8a, 0xff688092, 0xff506c80, 0xff6f8190, 0xff597487,
    0xff465f72, 0xff466477, 0xff325164, 0xff5a7083, 0xff7b8996, 0xffa7b3c0, 0xffa9b0bb, 0xffa6adb7,
    0xffc0c2cd, 0xffb4b5c2, 0xff495f7a, 0xff4b6283, 0xff5f749a, 0xff3e577a, 0xff466089, 0xff4e6991,
    0xff426189, 0xff426487, 0xff4b6c8f, 0xff43607d, 0xff56718a, 0xff5b758b, 0xff5d7e91, 0xff628198,
    0xff59778b, 0xff6a8290, 0xff818d95, 0xff85888a, 0xff848583, 0xffafa594, 0xffdbbca0, 0xfffdcf7d,
    0xfffff9a3, 0xfffce793, 0xfff8d991, 0xfff6ca8a, 0xfff3d698, 0xfff1d496, 0xffebd596, 0xffe9d595,
    0xfff0d796, 0xfff9de9d, 0xfff9e19d, 0xfffbefa9, 0xfff3e09c, 0xfff4de9d, 0xfff1db9b, 0xfff6d093,
    0xffe9c18a, 0xffeac288, 0xfff7c990, 0xffdfb181, 0xffdeaf7c, 0xffd3a97c, 0xffdba879, 0xffcfa379,
    0xff496382, 0xff4e6885, 0xff445f7b, 0xff3c5571, 0xff3d5770, 0xff2d4962, 0xff355167, 0xff3e5870,
    0xff385267, 0xff334f67, 0xff2d485e, 0xff3a546b, 0xff334f63, 0xff4d6784, 0xff3c5a71, 0xff456074,
    0xff425e74, 0xff3e596f, 0xff445f72, 0xff536d84, 0xff5c7590, 0xff4a6a83, 0xff536c86, 0xff4a6782,
    0xff45627e, 0xff43627f, 0xff3b5b76, 0xff436178, 0xff4f6a81, 0xff648095, 0xff567486, 0xff547182,
    0xff7187a1, 0xff62778b, 0xff37566d, 0xff3f5d7d, 0xff476486, 0xff395b7c, 0xff395b80, 0xff5d7798,
    0xff365b81, 0xff31577a, 0xff476c8e, 0xff4d6b8c, 0xff5a7691, 0xff60788d, 0xff677e98, 0xff6f85a5,
    0xff697a94, 0xff838a9c, 0xffb4a79e, 0xffc1ac9d, 0xffd3b795, 0xffe4c58c, 0xfff4cf94, 0xffffd088,
    0xfff1c686, 0xffcdab75, 0xffcdab78, 0xffdaac7a, 0xffc99a70, 0xffbe906e, 0xffb28e6c, 0xffcda97c,
    0xffddb680, 0xffdcb081, 0xffd4ae7d, 0xffd8b786, 0xffc6aa7c, 0xffc9b181, 0xffc5ae80, 0xffd6b585,
    0xffd5b07f, 0xffe3be88, 0xffe9bb85, 0xffdeb183, 0xffe0af7a, 0xffe7b582, 0xffe5b280, 0xffecba84,
    0xff455f7f, 0xff46607e, 0xff435d7a, 0xff3f5874, 0xff445d77, 0xff304b66, 0xff3c566d, 0xff47617a,
    0xff3e5870, 0xff3c576f, 0xff2f4c61, 0xff415c74, 0xff375364, 0xff546d89, 0xff32536a, 0xff485f77,
    0xff405c75, 0xff35516b, 0xff3a566d, 0xff42607c, 0xff4b6785, 0xff416380, 0xff3b5b7b, 0xff385978,
    0xff3f6081, 0xff3f5e81, 0xff406181, 0xff30546f, 0xff2e5372, 0xff305773, 0xff204b65, 0xff1d465f,
    0xff34587b, 0xff284b64, 0xff2a4f64, 0xff335674, 0xff345773, 0xff3c6180, 0xff3b5e7d, 0xff6d829a,
    0xff4e6c8b, 0xff486886, 0xff51708f, 0xff5e779a, 0xff647b98, 0xff677a91, 0xff768099, 0xff878da4,
    0xff8c8995, 0xffa89a9e, 0xffdebb9f, 0xffeec6a4, 0xffffd59b, 0xffffd986, 0xffffd88a, 0xfffecf90,
    0xffd89f6f, 0xffa67c5e, 0xffa27f5f, 0xffb58966, 0xffa36d52, 0xff976253, 0xff8a5d4f, 0xffb08366,
    0xffbb8d69, 0xffb18064, 0xffa37a5e, 0xffa97e64, 0xff99785f, 0xffa38868, 0xffa38869, 0xffbe9d77,
    0xffc09e73, 0xffd4b081, 0xffd4a778, 0xffd5aa7f, 0xffd4a473, 0xffdfae7d, 0xffcea276, 0xffe1b27d,
    0xff35526f, 0xff314e69, 0xff304e66, 0xff2e4b63, 0xff375469, 0xff28445c, 0xff355067, 0xff3a576d,
    0xff2f4e65, 0xff2e4f66, 0xff25485b, 0xff32546b, 0xff2c4e5f, 0xff3e5d74, 0xff294c61, 0xff3a566f,
    0xff375872, 0xff2e4f66, 0xff314f68, 0xff365671, 0xff385772, 0xff345872, 0xff2e5472, 0xff294e69,
    0xff345776, 0xff395b7a, 0xff3d5f7e, 0xff274d6a, 0xff284e6f, 0xff244968, 0xff224a6a, 0xff1d425f,
    0xff26496b, 0xff1f435e, 0xff284b62, 0xff2c4f69, 0xff2f5169, 0xff486985, 0xff526c84, 0xff7d8595,
    0xff8e97aa, 0xff8e99b1, 0xff6a7994, 0xff7382a1, 0xff73819d, 0xff707c97, 0xff8a8795, 0xffa99893,
    0xffbea28d, 0xffd2b094, 0xfff5c595, 0xffffce9b, 0xffffd591, 0xffffd984, 0xffffd687, 0xffffd195,
    0xffd69a6a, 0xff9d7056, 0xff886450, 0xff946a53, 0xff90614b, 0xff906252, 0xff8b5b4d, 0xff9e755e,
    0xff926b57, 0xff835f52, 0xff74574d, 0xff7a594f, 0xff7d5f52, 0xff92745c, 0xff99795d, 0xffba926f,
    0xffb3906b, 0xffc19a74, 0xffbf946b, 0xffc69d75, 0xffbb9068, 0xffb58f6c, 0xff92755a, 0xffa38361,
    0xff23455c, 0xff1b3d53, 0xff1c3e51, 0xff1a3c50, 0xff264757, 0xff1e3f50, 0xff2b4a5e, 0xff27495c,
    0xff1c4055, 0xff1d465b, 0xff1b4557, 0xff20495e, 0xff21495b, 0xff224a5c, 0xff21495b, 0xff294d64,
    0xff2f546f, 0xff2b5064, 0xff2a4d65, 0xff2e5168, 0xff294c61, 0xff2a4e66, 0xff29536b, 0xff1f485d,
    0xff2a4f69, 0xff335972, 0xff375a75, 0xff254b67, 0xff2d5171, 0xff2a4a69, 0xff39587c, 0xff314e6e,
    0xff2c4a68, 0xff2c4c68, 0xff2d4c66, 0xff2c4d63, 0xff335165, 0xff566f89, 0xff6c7a8d, 0xff878490,
    0xffc9bec8, 0xffcec6d6, 0xff817f96, 0xff8588a0, 0xff83869d, 0xff7f819a, 0xffa0908e, 0xffcaa47f,
    0xffeaba81, 0xfff5c486, 0xfffbc689, 0xfffecb8b, 0xffffc681, 0xffffce83, 0xfffccc87, 0xfffdcf93,
    0xffdaa16d, 0xffa47759, 0xff7f5b4c, 0xff825b49, 0xff8d6952, 0xff99755d, 0xff9c6f57, 0xff98765e,
    0xff76584f, 0xff644f4a, 0xff584746, 0xff594644, 0xff6e554e, 0xff886a56, 0xff967157, 0xffb58867,
    0xffa48163, 0xffa88163, 0xffa67f5e, 0xffb18a67, 0xff9d795c, 0xff856c59, 0xff57483f, 0xff645245,
    0xff183f53, 0xff10384b, 0xff153c4f, 0xff113a4b, 0xff1c4353, 0xff19404e, 0xff24485b, 0xff1c4555,
    0xff0f3c4c, 0xff174659, 0xff1a495c, 0xff19485b, 0xff194859, 0xff154352, 0xff1e4b5a, 0xff1f4b5e,
    0xff265267, 0xff275262, 0xff275063, 0xff295062, 0xff224a5b, 0xff274e63, 0xff265266, 0xff1c4759,
    0xff244d63, 0xff2b546a, 0xff30546c, 0xff244a62, 0xff305371, 0xff2e4c6c, 0xff405c80, 0xff3a5577,
    0xff304e6a, 0xff32506c, 0xff36536e, 0xff365269, 0xff3c5465, 0xff5b6c81, 0xff787f94, 0xff898394,
    0xffd0bfca, 0xffcbc2d0, 0xff817a8f, 0xff8d8694, 0xff988d93, 0xffa69694, 0xffc6a68a, 0xffebb77a,
    0xffffca7e, 0xffffd081, 0xffffc881, 0xffffcc82, 0xfffcc178, 0xfffbc882, 0xfff8c889, 0xfff3c88e,
    0xffe2ac73, 0xffbe8b63, 0xff9a745a, 0xff976f52, 0xffa07d5e, 0xffa68463, 0xffae8662, 0xffaa8768,
    0xff886a59, 0xff735f52, 0xff6b564b, 0xff5d4b47, 0xff6f574f, 0xff7a5e4f, 0xff7d5e4c, 0xff906b56,
    0xff7e6352, 0xff7f6150, 0xff836550, 0xff8d6d55, 0xff846652, 0xff6a574c, 0xff4d3f3a, 0xff5d4b41,
    0xff164156, 0xff133e52, 0xff1b465e, 0xff174456, 0xff1c495b, 0xff1a4755, 0xff224b5e, 0xff1b4a59,
    0xff0c404c, 0xff1d5060, 0xff225368, 0xff1e4e61, 0xff184a59, 0xff184a58, 0xff20515f, 0xff1c505c,
    0xff20515d, 0xff235461, 0xff295765, 0xff295561, 0xff265362, 0xff2c576a, 0xff265365, 0xff204e5f,
    0xff255065, 0xff234f65, 0xff294f65, 0xff244b5e, 0xff30546e, 0xff315171, 0xff375876, 0xff38577a,
    0xff335571, 0xff33526a, 0xff415d79, 0xff475e78, 0xff485869, 0xff576171, 0xff737995, 0xff8483a0,
    0xffa39db2, 0xff8b90a4, 0xff6a6c80, 0xff887d81, 0xffac9482, 0xffd8b289, 0xffefc18a, 0xffffc984,
    0xffffcd83, 0xffffd285, 0xffffca82, 0xffffce81, 0xffffc777, 0xfffec781, 0xfff8cb8e, 0xffe5be87,
    0xffecbb7c, 0xffe4a974, 0xffd1a577, 0xffcca06d, 0xffc2996d, 0xffb68c64, 0xffbe9d6c, 0xffcfa478,
    0xffbf9871, 0xffaa8867, 0xffa57e5a, 0xff836756, 0xff806556, 0xff6a534a, 0xff584740, 0xff584640,
    0xff4f413e, 0xff52433f, 0xff614d45, 0xff674f43, 0xff785c4d, 0xff6b564a, 0xff735a4c, 0xff8f6d56,
    0xff174659, 0xff18485a, 0xff21516a, 0xff1d4e60, 0xff1e4f62, 0xff1d4f5d, 0xff225162, 0xff1e525f,
    0xff104951, 0xff255867, 0xff295b70, 0xff265767, 0xff1c4f5d, 0xff225562, 0xff255965, 0xff20575f,
    0xff1f5359, 0xff245663, 0xff2c5d67, 0xff2c5a63, 0xff2c5b6b, 0xff315e71, 0xff285465, 0xff275466,
    0xff275569, 0xff214d63, 0xff274d63, 0xff284f5e, 0xff33566e, 0xff365878, 0xff32566f, 0xff395b7a,
    0xff385b75, 0xff38546a, 0xff4c6680, 0xff596b89, 0xff5b6479, 0xff5c6174, 0xff70779a, 0xff7a7fa6,
    0xff717693, 0xff536074, 0xff5f6371, 0xff87756d, 0xffb99570, 0xfff4bf7a, 0xffffcb85, 0xffffca88,
    0xfff5be81, 0xfffec383, 0xfff9c17f, 0xfffec47b, 0xfffbbf73, 0xfff4bc7b, 0xfff0c58c, 0xffd2ac7a,
    0xffe6b97c, 0xffefb47a, 0xfff0c388, 0xfff5c482, 0xffdeae79, 0xffc69466, 0xffc9aa72, 0xffe6b681,
    0xffefbf84, 0xffd7a876, 0xffd7a069, 0xffae8666, 0xff95775d, 0xff6e584c, 0xff4e433f, 0xff3e3737,
    0xff3c3335, 0xff403939, 0xff4b3f3f, 0xff4e3d3a, 0xff6b5248, 0xff6b5648, 0xff91705b, 0xffb48766,
    0xff174959, 0xff1a4d5a, 0xff1f5366, 0xff1d5160, 0xff1f5262, 0xff1f5461, 0xff235564, 0xff235764,
    0xff1a525a, 0xff275965, 0xff2a5c6a, 0xff2c5d6a, 0xff255863, 0xff2b5d68, 0xff2c5f6b, 0xff295d66,
    0xff24565e, 0xff295766, 0xff2d5b67, 0xff2d5965, 0xff2e5b6e, 0xff2e5a6e, 0xff285265, 0xff2b5669,
    0xff295566, 0xff254e63, 0xff2a5066, 0xff2f5465, 0xff375972, 0xff3c5e7c, 0xff38596f, 0xff406077,
    0xff38546a, 0xff385064, 0xff4c6077, 0xff617191, 0xff747a9a, 0xff777c9e, 0xff7780aa, 0xff6a759f,
    0xff565f7c, 0xff4e535e, 0xff746967, 0xff917562, 0xffb88e66, 0xffe1a96b, 0xffe5b277, 0xffdbaa79,
    0xffcb9d73, 0xffdca677, 0xffe4ad77, 0xffdba56c, 0xffd49e65, 0xffd49e6c, 0xffd8ab7a, 0xffbb9066,
    0xffbc966b, 0xffc3946b, 0xffd5ab7a, 0xfff3c181, 0xffe0ae79, 0xffcc9969, 0xffc7a36f, 0xffd6a676,
    0xfff1c083, 0xffcf9e6d, 0xffdca26d, 0xffc5956c, 0xffa48261, 0xff8e6f58, 0xff776152, 0xff655447,
    0xff614e45, 0xff5e4f45, 0xff463c3c, 0xff4f3f3c, 0xff53423e, 0xff574a40, 0xff7e6353, 0xffa27b5f,
    0xff174b57, 0xff1a4e57, 0xff1a505a, 0xff1b505a, 0xff20535d, 0xff215562, 0xff255864, 0xff285966,
    0xff265a63, 0xff255660, 0xff27595e, 0xff30616a, 0xff2f5f69, 0xff33626c, 0xff32626f, 0xff33616f,
    0xff2e5968, 0xff30576a, 0xff2d5566, 0xff2e5568, 0xff2e566d, 0xff2a5368, 0xff295066, 0xff2e5569,
    0xff2c5363, 0xff2d5367, 0xff31566d, 0xff375a70, 0xff3c5d77, 0xff41617e, 0xff445f74, 0xff4a6573,
    0xff394c5d, 0xff3d4e62, 0xff4b586d, 0xff647295, 0xff8a91bd, 0xff969fd2, 0xff858eb9, 0xff5d6c90,
    0xff53596d, 0xff6c5d5b, 0xff987762, 0xffa07b5f, 0xffae8262, 0xffb38560, 0xffb48866, 0xffa67e62,
    0xff99755f, 0xffb18165, 0xffc9946b, 0xffb1815c, 0xffa57655, 0xffb07f5c, 0xffbf8e66, 0xffab7855,
    0xff8c6b55, 0xff806252, 0xff9a785c, 0xffd5a473, 0xffd2a173, 0xffcd9d6d, 0xffbf9268, 0xffb38764,
    0xffd8aa77, 0xffac8059, 0xffc59169, 0xffcc976b, 0xffae8863, 0xffba8f68, 0xffb88e6c, 0xffab8662,
    0xffa17d5f, 0xff96765a, 0xff524540, 0xff645148, 0xff413636, 0xff423d3a, 0xff574742, 0xff755b4d,
    0xff184c57, 0xff1c5057, 0xff174d52, 0xff1a4f57, 0xff21535a, 0xff245662, 0xff285964, 0xff2c5a67,
    0xff2f5d6a, 0xff275560, 0xff28595b, 0xff326169, 0xff336069, 0xff37646d, 0xff35626f, 0xff3a6274,
    0xff355b70, 0xff34576a, 0xff305366, 0xff30546a, 0xff2f526a, 0xff294f63, 0xff2d5268, 0xff32576b,
    0xff315566, 0xff37596d, 0xff3a5c75, 0xff3f5e77, 0xff41607a, 0xff46627c, 0xff4e6478, 0xff556873,
    0xff4b5564, 0xff566177, 0xff59617b, 0xff6a779c, 0xff8c97cc, 0xff9fa9df, 0xff9094b5, 0xff696e80,
    0xff6b6466, 0xff8d6e5d, 0xffb28260, 0xffaf8461, 0xffa97e62, 0xff976f5b, 0xff97715c, 0xff886454,
    0xff72574f, 0xff876051, 0xffad7b5e, 0xffa07154, 0xff996a52, 0xffad7a57, 0xffbe8b61, 0xffaf7a55,
    0xff805e50, 0xff5d4642, 0xff684d45, 0xffba8a67, 0xffcc996d, 0xffd8a974, 0xffbd8b65, 0xffa87c5d,
    0xffc7996d, 0xffa07552, 0xffb88766, 0xffcc9468, 0xffb78d66, 0xffd8a472, 0xffdfa87a, 0xffd6a272,
    0xffc8986f, 0xffbc9068, 0xff6d5849, 0xff7e6655, 0xff4d403c, 0xff433e3b, 0xff463b3a, 0xff50413d,
    0xff1a4d59, 0xff1e515c, 0xff184c51, 0xff1c4e57, 0xff23545a, 0xff285761, 0xff2a5963, 0xff2d5a66,
    0xff315c6c, 0xff2d5966, 0xff2e5c65, 0xff305d66, 0xff2d5962, 0xff36626c, 0xff345e6b, 0xff3a6072,
    0xff365b72, 0xff325565, 0xff335768, 0xff33576a, 0xff325366, 0xff2e5161, 0xff345769, 0xff385b6f,
    0xff39596e, 0xff405e77, 0xff42617b, 0xff445f79, 0xff456079, 0xff496078, 0xff536679, 0xff5e6b78,
    0xff6e7384, 0xff838aa4, 0xff7a80a5, 0xff757fa7, 0xff7687be, 0xff8a92b7, 0xff979098, 0xff8f7e74,
    0xff9a8067, 0xffa57d61, 0xffb78561, 0xffba8f66, 0xffad8363, 0xff9c755d, 0xffa0785e, 0xff8f6955,
    0xff624c48, 0xff694b42, 0xff976b54, 0xffb37f5b, 0xffbe855e, 0xffd39a60, 0xffdbab72, 0xffcc9b6b,
    0xffa57c60, 0xff6d4d43, 0xff533d3e, 0xffae7e61, 0xffd59e6b, 0xfff0bd7e, 0xffc59368, 0xffbf9068,
    0xffc7986b, 0xffb7865e, 0xffc08b66, 0xffc58d63, 0xffbe8f6b, 0xffdda471, 0xffd8a173, 0xffcf9a70,
    0xffc0916c, 0xffc08f68, 0xff916f58, 0xff96775d, 0xff7c6151, 0xff5f4e46, 0xff594a44, 0xff453936,
    0xff1d4e5b, 0xff205161, 0xff1c4c55, 0xff1f4e59, 0xff24545c, 0xff2b575f, 0xff2c5761, 0xff2d5863,
    0xff305869, 0xff325c6c, 0xff355f71, 0xff2e5965, 0xff275159, 0xff325d69, 0xff315a66, 0xff385c6e,
    0xff365a71, 0xff2f5460, 0xff375c6a, 0xff365a69, 0xff355563, 0xff355663, 0xff3c5e6c, 0xff3e5f73,
    0xff405e77, 0xff45617d, 0xff48627d, 0xff485d75, 0xff485e75, 0xff4c5e73, 0xff596a7c, 0xff656c80,
    0xff9395a9, 0xffadb0ce, 0xff979dce, 0xff7e86b0, 0xff6274a2, 0xff73747f, 0xff9c8976, 0xffba926c,
    0xffcc9f6e, 0xffb78b68, 0xffb08463, 0xffbf966c, 0xffb68d66, 0xffb18865, 0xffb98d67, 0xffa87c5e,
    0xff654e47, 0xff584138, 0xff86614c, 0xffc99163, 0xffe5a36a, 0xfffbbb6b, 0xffface86, 0xffeec384,
    0xffdaa978, 0xff94674f, 0xff584343, 0xffa6785e, 0xffd9a068, 0xffffc983, 0xffd1a16e, 0xffddab77,
    0xffcd9a6c, 0xffd29b6e, 0xffc48e64, 0xffb6815d, 0xffba8a6b, 0xffd0986a, 0xffb98a63, 0xffb08265,
    0xffa37a60, 0xffb08161, 0xffad8163, 0xffa68261, 0xffaa8165, 0xff836352, 0xff765f51, 0xff4a3d36,
    0xff1f4f5b, 0xff215162, 0xff1f4d5a, 0xff214e5b, 0xff24525e, 0xff2b555f, 0xff2c5562, 0xff2b5661,
    0xff2f5766, 0xff355d6c, 0xff365e71, 0xff305966, 0xff285057, 0xff315a66, 0xff335964, 0xff375a6a,
    0xff385b6f, 0xff315662, 0xff385d6a, 0xff385c6a, 0xff3a5867, 0xff3c5b69, 0xff446370, 0xff446174,
    0xff445f76, 0xff465d76, 0xff4a5f76, 0xff485a6f, 0xff4a5b6f, 0xff546073, 0xff6b778d, 0xff70728b,
    0xffb3b1c3, 0xffbfbeda, 0xff9ea3d4, 0xff858ab1, 0xff787686, 0xff816f5b, 0xffac8b64, 0xffd5a06a,
    0xffe1ab70, 0xffc0916b, 0xffa87f63, 0xffb9916b, 0xffc5996b, 0xffd0a26f, 0xffd6a571, 0xffc19067,
    0xff755749, 0xff534137, 0xff725544, 0xffb6855d, 0xffd19661, 0xfff4b568, 0xfffdd089, 0xffffd58d,
    0xffffce8c, 0xffba8761, 0xff7b5f50, 0xff956c56, 0xffc28c5c, 0xfff4bb7b, 0xffe2b176, 0xffe9b67d,
    0xffce9b6c, 0xffd0996e, 0xffa67756, 0xff996d52, 0xff9a735d, 0xffbb8864, 0xff967055, 0xff926d5a,
    0xff8b6755, 0xff997058, 0xffac8062, 0xffa88160, 0xffaa8165, 0xff987159, 0xff896955, 0xff5f4c3f,
    0xff21505b, 0xff20505f, 0xff204e5f, 0xff214f5e, 0xff234f5f, 0xff285261, 0xff2c5463, 0xff29535f,
    0xff305762, 0xff335b66, 0xff335a67, 0xff365e6a, 0xff31575c, 0xff325964, 0xff375b65, 0xff375967,
    0xff3c5f6d, 0xff365a6a, 0xff375b6a, 0xff385c6d, 0xff3e5c70, 0xff425f73, 0xff4a6576, 0xff496172,
    0xff455c6e, 0xff415366, 0xff475869, 0xff455566, 0xff4b5669, 0xff5e6677, 0xff8389a7, 0xff7b7a95,
    0xffc6bfcd, 0xffb7b1c7, 0xff8c90b8, 0xff8889a9, 0xffaf8a6f, 0xffad8254, 0xffc09567, 0xffdba56e,
    0xffd5a26d, 0xffbd8e6a, 0xff9e755f, 0xffa88162, 0xffd7a470, 0xfff1bb7a, 0xfff1bb7a, 0xffd5a26e,
    0xff8f654f, 0xff5c493f, 0xff624c3f, 0xff82634c, 0xff8f6748, 0xffc48d59, 0xffe6b47d, 0xffffcf85,
    0xffffe296, 0xffd7a574, 0xffb38963, 0xff805e4c, 0xff976a4c, 0xffd29968, 0xfff5be7d, 0xffe1b079,
    0xffcd9a6b, 0xffb48260, 0xff715140, 0xff775847, 0xff675045, 0xffa47960, 0xff765a4a, 0xff7c5f51,
    0xff7c5c4d, 0xff806150, 0xff906c54, 0xff9c755a, 0xff806451, 0xff9b735a, 0xff8d6852, 0xff7d614e,
    0xff215059, 0xff1f4e5b, 0xff214f61, 0xff21505e, 0xff234d5e, 0xff265061, 0xff2b5464, 0xff28525e,
    0xff315961, 0xff315961, 0xff30575e, 0xff3b626e, 0xff395e62, 0xff345861, 0xff3c5e67, 0xff395b67,
    0xff3f616b, 0xff3c5d6f, 0xff385969, 0xff3c5c70, 0xff456077, 0xff496278, 0xff4f6679, 0xff4c606f,
    0xff465a67, 0xff3e4d5b, 0xff445361, 0xff445362, 0xff4d5465, 0xff63697a, 0xff8e90b2, 0xff7f7e99,
    0xffc2b8c5, 0xff9e99ac, 0xff767b9a, 0xff85849f, 0xffd59b68, 0xffcf955c, 0xffcb986a, 0xffd6a471,
    0xffc6986b, 0xffbd8f6a, 0xffa17760, 0xff9f775c, 0xffd8a46f, 0xfff9c07c, 0xfff7c07d, 0xffd8a56f,
    0xffa06e52, 0xff685347, 0xff59483e, 0xff52413a, 0xff4e382e, 0xff8a5f47, 0xffbd8c68, 0xffefb676,
    0xffffdc93, 0xffe6b681, 0xffe8b175, 0xff7d5e4a, 0xff7b5342, 0xffa87354, 0xfff1b87b, 0xffcd9f6f,
    0xffc69568, 0xffa17357, 0xff573f37, 0xff644d41, 0xff463a36, 0xff836354, 0xff5b4842, 0xff675248,
    0xff6c5245, 0xff685247, 0xff6d5344, 0xff856350, 0xff51443b, 0xff906d55, 0xff845e4a, 0xff8e6d57,
    0xff1f4d55, 0xff1e4c58, 0xff204e5e, 0xff224f5c, 0xff234c5c, 0xff26505f, 0xff2b5462, 0xff2a535e,
    0xff335b65, 0xff325a62, 0xff31575d, 0xff3c626f, 0xff3a5d62, 0xff34575d, 0xff3d5f68, 0xff3d606c,
    0xff3f606a, 0xff3d5b6b, 0xff3c5967, 0xff455e70, 0xff4c6275, 0xff506372, 0xff526576, 0xff4e5f6e,
    0xff4b5c69, 0xff425163, 0xff445466, 0xff475565, 0xff515667, 0xff5d6374, 0xff7b7e9c, 0xff7b7a91,
    0xff9f9aa9, 0xff7f8199, 0xff697290, 0xff7a7a93, 0xffc39677, 0xffc89a73, 0xffc28b63, 0xffcd9d6e,
    0xffc5986d, 0xffc99a6e, 0xffba8d68, 0xffa67c5d, 0xffb88b63, 0xffd3a16d, 0xffe1ad74, 0xffc59569,
    0xff986a50, 0xff6e5649, 0xff5a4a40, 0xff423530, 0xff362622, 0xff64453a, 0xff8d6753, 0xffc79467,
    0xffdfb87f, 0xffe7b581, 0xffffc982, 0xff9d795a, 0xff895f49, 0xff825946, 0xffc69468, 0xffb58963,
    0xffbe8f66, 0xffb78561, 0xff7f5e48, 0xff705646, 0xff56453e, 0xff58433a, 0xff493e3c, 0xff57463f,
    0xff5e493f, 0xff594943, 0xff554339, 0xff6c5245, 0xff3d342f, 0xff7e614d, 0xff6c5041, 0xff7c614f,
    0xff1b4a51, 0xff1d4b56, 0xff1d4c59, 0xff244e59, 0xff234d59, 0xff29525d, 0xff2b555f, 0xff2e565f,
    0xff355d6b, 0xff345c66, 0xff345961, 0xff3c5f6f, 0xff385a60, 0xff345759, 0xff3e6068, 0xff436572,
    0xff3d5c6a, 0xff3c5664, 0xff425966, 0xff50616f, 0xff526370, 0xff576268, 0xff546270, 0xff4f5d6e,
    0xff515f6f, 0xff495973, 0xff475972, 0xff4c5a6e, 0xff555c6d, 0xff51596c, 0xff5c6277, 0xff727384,
    0xff6f7086, 0xff616c8f, 0xff647194, 0xff6f708c, 0xff968994, 0xffad958e, 0xffaf7959, 0xffc2936a,
    0xffcb9d70, 0xffd9aa73, 0xffdcaa72, 0xffb78c64, 0xff8e6b54, 0xff997359, 0xffb98a65, 0xffa3785c,
    0xff815e4b, 0xff705548, 0xff615045, 0xff47382d, 0xff3b2921, 0xff4f3b33, 0xff624b41, 0xff956e58,
    0xffae8463, 0xffd6a276, 0xffffcc86, 0xffc89b6f, 0xffad7d59, 0xff6a4d3f, 0xff8d664f, 0xff9d7257,
    0xffb18663, 0xffdaa271, 0xffc39166, 0xff8e6b52, 0xff7e6152, 0xff362821, 0xff453e3a, 0xff4f3f39,
    0xff53433c, 0xff524541, 0xff473a33, 0xff55443b, 0xff3b302b, 0xff675044, 0xff4f4038, 0xff5a4940,
    0xff1c4950, 0xff1f4c55, 0xff1d4b54, 0xff254d55, 0xff265058, 0xff2c5359, 0xff2c555d, 0xff32595f,
    0xff375e6d, 0xff365d68, 0xff385c66, 0xff3a5c6b, 0xff38585f, 0xff375758, 0xff426166, 0xff486772,
    0xff3e5a67, 0xff3f5461, 0xff485a67, 0xff55626e, 0xff55636d, 0xff5b6365, 0xff58636d, 0xff525f6f,
    0xff525f73, 0xff4d5e7b, 0xff4d607c, 0xff536179, 0xff565f73, 0xff4c576e, 0xff4b5567, 0xff686e81,
    0xff4d5673, 0xff51638d, 0xff5f6f99, 0xff697093, 0xff868caf, 0xff9f9098, 0xffa26e54, 0xffb98c67,
    0xffd1a171, 0xffe4b375, 0xfff2bc79, 0xffcd9e6c, 0xff876751, 0xff7a5a4e, 0xff8e6853, 0xff7c5b4d,
    0xff6b5244, 0xff6d5346, 0xff645145, 0xff493726, 0xff463328, 0xff483831, 0xff483b37, 0xff6d524c,
    0xff815b4d, 0xffb58464, 0xffebb87e, 0xffd6a473, 0xffc78e61, 0xff715847, 0xff704f44, 0xff89624f,
    0xff997459, 0xffd6a06d, 0xffe0a571, 0xffa3785a, 0xff946f5a, 0xff35261e, 0xff4d443d, 0xff4b3c37,
    0xff4e413b, 0xff4c423e, 0xff413731, 0xff453b35, 0xff3e322d, 0xff53423b, 0xff3e3733, 0xff463b37,
    0xff204d53, 0xff244f56, 0xff214d53, 0xff244d52, 0xff2b545a, 0xff2f5455, 0xff2f555b, 0xff365b5f,
    0xff385d69, 0xff385c67, 0xff3b5e6a, 0xff395b65, 0xff3b5a61, 0xff3c5759, 0xff496361, 0xff4c6368,
    0xff435861, 0xff455664, 0xff4c5d6b, 0xff52606f, 0xff53616f, 0xff5b656c, 0xff5f676e, 0xff566372,
    0xff4f5c72, 0xff4d5d77, 0xff546680, 0xff596782, 0xff536078, 0xff515f7c, 0xff535f75, 0xff636e8d,
    0xff49567b, 0xff556894, 0xff5c6d9c, 0xff6c7bab, 0xffa3a5bd, 0xffaa8f87, 0xffa27257, 0xffb68b66,
    0xffd4a36e, 0xffe6b375, 0xfff2bc78, 0xffe2af74, 0xffaf875f, 0xff866353, 0xff6e5145, 0xff5b473e,
    0xff5d4a3f, 0xff665046, 0xff5e4b3e, 0xff422f1d, 0xff4e3e34, 0xff4d3d35, 0xff473a37, 0xff5a4745,
    0xff674b45, 0xff88634f, 0xffb68e6a, 0xffb9895f, 0xffc98a5b, 0xff9a785b, 0xff7e5a4c, 0xff7e5e4e,
    0xff775a48, 0xffa07751, 0xffbe8961, 0xffa3785a, 0xff8a6650, 0xff5d4437, 0xff604f44, 0xff4c3e3a,
    0xff4f423c, 0xff473d37, 0xff443934, 0xff413936, 0xff423733, 0xff4a3b35, 0xff413834, 0xff4d403a,
    0xff255056, 0xff295257, 0xff254f53, 0xff234e50, 0xff2f575c, 0xff325553, 0xff32555a, 0xff395c5f,
    0xff395c62, 0xff3a5b64, 0xff3f5f6b, 0xff395b60, 0xff405c63, 0xff42585d, 0xff4f635d, 0xff4d5d5d,
    0xff48575c, 0xff4c5a69, 0xff4e5e6f, 0xff4d5f70, 0xff515f73, 0xff596775, 0xff636a70, 0xff5a6775,
    0xff4d5a70, 0xff4d5c6f, 0xff5b6a80, 0xff5d6a87, 0xff50607d, 0xff596a8b, 0xff626f8d, 0xff60709b,
    0xff55648e, 0xff66759e, 0xff616e9d, 0xff7a8bbf, 0xffcabebd, 0xffbc9070, 0xffab7e5f, 0xffba8e68,
    0xffd6a36c, 0xffe4af73, 0xffe9b274, 0xfff1bb7b, 0xffe3b072, 0xffa67d5f, 0xff61483d, 0xff4a3e36,
    0xff57463c, 0xff5d4d45, 0xff554236, 0xff3c2818, 0xff574a41, 0xff59463d, 0xff55443e, 0xff554742,
    0xff5a4943, 0xff5f473d, 0xff7b6052, 0xff8c6346, 0xffbb7b50, 0xffc3966f, 0xff997059, 0xff7c6151,
    0xff5a4439, 0xff5f4531, 0xff875f49, 0xff966e55, 0xff735541, 0xff8b6755, 0xff735a4b, 0xff50423e,
    0xff53443e, 0xff453932, 0xff4b3e38, 0xff443c3a, 0xff483e3a, 0xff473932, 0xff4c3e37, 0xff5a4a40,
    0xff275055, 0xff2c5356, 0xff274e52, 0xff264e50, 0xff305659, 0xff345554, 0xff355559, 0xff3b5b5c,
    0xff3c5a5c, 0xff3f5c62, 0xff425e67, 0xff3f5c5c, 0xff455e62, 0xff46595f, 0xff4f5f5c, 0xff4a575a,
    0xff49565d, 0xff505c6d, 0xff515f70, 0xff506070, 0xff546075, 0xff586676, 0xff61676e, 0xff5d6977,
    0xff535e74, 0xff525f70, 0xff5e6b80, 0xff5b6887, 0xff516182, 0xff5b6c90, 0xff667394, 0xff606f9d,
    0xff63719a, 0xff787f9e, 0xff777a99, 0xff999ab5, 0xffdabfa7, 0xffc79364, 0xffba8e66, 0xffc3966a,
    0xffd9a66b, 0xffe4ae72, 0xffe4ae72, 0xfff6be7c, 0xfffec57c, 0xffc79668, 0xff725643, 0xff53463a,
    0xff59483e, 0xff594a42, 0xff4c392d, 0xff3c2a1b, 0xff5c4f47, 0xff5e4a40, 0xff5e4b44, 0xff554941,
    0xff524641, 0xff483833, 0xff52403d, 0xff6a4938, 0xff9b6748, 0xffbe926e, 0xff997158, 0xff7d6252,
    0xff4c3a33, 0xff3b2b22, 0xff61453b, 0xff7d5d4a, 0xff5f4736, 0xff906e5b, 0xff73584a, 0xff51443f,
    0xff52423c, 0xff453931, 0xff4d403b, 0xff463d3b, 0xff4a403d, 0xff463932, 0xff4c3e36, 0xff5a4a40,
    0xff254c52, 0xff2c5053, 0xff274a50, 0xff2a4f51, 0xff2f5153, 0xff365658, 0xff385658, 0xff3b5959,
    0xff3f5a57, 0xff465f60, 0xff445c5e, 0xff475e5c, 0xff4a5d5d, 0xff485a61, 0xff485960, 0xff45535f,
    0xff485662, 0xff505d6e, 0xff535f6d, 0xff576471, 0xff5a6575, 0xff5a6470, 0xff585f68, 0xff5f6877,
    0xff5e677a, 0xff5b6578, 0xff5d677e, 0xff546281, 0xff546486, 0xff576789, 0xff5e6b8c, 0xff626e93,
    0xff727a9c, 0xff878496, 0xff978b90, 0xffc1a491, 0xffd1a982, 0xffc99766, 0xffca9d6c, 0xffd09f6c,
    0xffdda96d, 0xffe5af72, 0xffe4af72, 0xfff0b979, 0xfffbc27a, 0xffe1a96c, 0xff9c7455, 0xff745d49,
    0xff624f44, 0xff5a483f, 0xff473327, 0xff433326, 0xff5b4b43, 0xff5b4940, 0xff614e47, 0xff594b43,
    0xff53453f, 0xff493a34, 0xff453632, 0xff5a4338, 0xff745442, 0xff916f59, 0xff82604b, 0xff826250,
    0xff524037, 0xff3b2e27, 0xff54403a, 0xff5f493c, 0xff544032, 0xff70584a, 0xff614d42, 0xff50433c,
    0xff4e3e37, 0xff473b34, 0xff4a3e3a, 0xff483d3a, 0xff473e3a, 0xff473a34, 0xff453a32, 0xff4d413a,
    0xff23484f, 0xff2a4d50, 0xff26474e, 0xff2e5053, 0xff2c4c4d, 0xff36565c, 0xff3a5757, 0xff3b5756,
    0xff425954, 0xff4b625f, 0xff465a55, 0xff4f605d, 0xff4e5d59, 0xff495b62, 0xff415364, 0xff405164,
    0xff455568, 0xff4f5d6e, 0xff555e69, 0xff5f6771, 0xff616974, 0xff5b616a, 0xff505762, 0xff606677,
    0xff697080, 0xff636b80, 0xff5a627c, 0xff4c5b7b, 0xff576688, 0xff536281, 0xff576282, 0xff646c88,
    0xff7f829c, 0xff94888d, 0xffb39a88, 0xffe2aa6f, 0xffc59361, 0xffc99b6a, 0xffd9aa71, 0xffdca86e,
    0xffe0ac6f, 0xffe6b172, 0xffe5b072, 0xffe9b374, 0xfff3ba77, 0xfff4b86e, 0xffc49166, 0xff957358,
    0xff6c574a, 0xff5c473c, 0xff432f22, 0xff4b3c30, 0xff58473f, 0xff57463e, 0xff62514a, 0xff5e4e46,
    0xff56463e, 0xff4f4038, 0xff41332c, 0xff51413b, 0xff52453f, 0xff634c44, 0xff6c4f3f, 0xff87624f,
    0xff5c483c, 0xff43362f, 0xff4f413c, 0xff46392f, 0xff4c3b31, 0xff4d4038, 0xff4f413b, 0xff4f4239,
    0xff493a32, 0xff493e38, 0xff463b38, 0xff493d38, 0xff443b37, 0xff4a3d37, 0xff3d362f, 0xff413934,
    0xff23474e, 0xff2a4c4f, 0xff26464d, 0xff2f5053, 0xff2c4b4b, 0xff36565d, 0xff3b5757, 0xff3b5655,
    0xff435953, 0xff4d635f, 0xff475953, 0xff51615d, 0xff4f5d58, 0xff4a5b62, 0xff3f5165, 0xff3f5066,
    0xff455569, 0xff4f5d6e, 0xff565e68, 0xff616871, 0xff636a74, 0xff5b6067, 0xff4d5560, 0xff616677,
    0xff6c7282, 0xff656d82, 0xff5a617c, 0xff4a5978, 0xff586789, 0xff52607e, 0xff545f7f, 0xff646c84,
    0xff83859d, 0xff988a8a, 0xffbc9f86, 0xffedad64, 0xffc18c55, 0xffca9c6b, 0xffddae73, 0xffdfab6f,
    0xffe1ad6f, 0xffe6b172, 0xffe5b072, 0xffe7b173, 0xfff1b976, 0xfffbbd6f, 0xffd19b6b, 0xff9f7a5d,
    0xff6f594c, 0xff5c463b, 0xff412d20, 0xff4d3f34, 0xff58453d, 0xff56463e, 0xff63524b, 0xff604f46,
    0xff57463d, 0xff514139, 0xff3f3129, 0xff4e403c, 0xff47403e, 0xff55413e, 0xff644a3b, 0xff88624f,
    0xff5e4a3e, 0xff443831, 0xff4c403d, 0xff3d332b, 0xff493930, 0xff423932, 0xff4a3d38, 0xff4f4238,
    0xff483931, 0xff493f39, 0xff453a38, 0xff493d38, 0xff433a36, 0xff4a3d38, 0xff3b352e, 0xff3d3633,
};

#if !CONFIG_FT
static uint32_t _gStretchBmp3[]=
{
    0xff7b91c0, 0xff7b91c0, 0xff7d91c0, 0xff7e92c1, 0xff7f94c2, 0xff7f95c4, 0xff8094c4, 0xff8093c4,
    0xff8294c4, 0xff8296c5, 0xff8397c6, 0xff8497c5, 0xff8597c5, 0xff8697c5, 0xff8898c6, 0xff8999c6,
    0xff8a9ac7, 0xff8a9bc8, 0xff8a9bc9, 0xff8a9bca, 0xff8b9ccb, 0xff8c9dcb, 0xff8d9ecc, 0xff8e9ecc,
    0xff8f9ecc, 0xff909ecc, 0xff919ecc, 0xff919fcd, 0xff92a0cd, 0xff94a2ce, 0xff96a3ce, 0xff96a3ce,
    0xff97a4cf, 0xff98a5d0, 0xff9aa6d1, 0xff9ba7d2, 0xff9ba7d2, 0xff9ba7d2, 0xff9ca8d3, 0xff9da9d4,
    0xff9da9d4, 0xff9ea9d4, 0xff9faad5, 0xffa0acd6, 0xffa0add7, 0xffa1add8, 0xffa1add7, 0xffa1aed5,
    0xffa1afd4, 0xffa1afd5, 0xffa2b0d7, 0xffa2b1d7, 0xffa3b1d6, 0xffa3b3d6, 0xffa4b4d6, 0xffa5b4d6,
    0xffa6b4d6, 0xffa7b4d6, 0xffa9b4d6, 0xffaab4d6, 0xffaab5d6, 0xffaab6d6, 0xffaab6d6, 0xffabb6d6,
    0xffacb6d6, 0xffadb6d5, 0xffadb6d5, 0xffaeb7d6, 0xffafb7d7, 0xffafb7d7, 0xffaeb6d7, 0xffaeb6d7,
    0xffafb7d7, 0xffafb7d7, 0xffafb7d6, 0xffaeb6d6, 0xffadb5d7, 0xffabb4d8, 0xffaab3d7, 0xffa9b1d6,
    0xffa9b0d5, 0xffa9b0d4, 0xffa8b0d4, 0xffa6afd4, 0xffa5aed4, 0xffa5afd5, 0xffa6b0d6, 0xffa6b0d5,
    0xffa5afd3, 0xffa4aed3, 0xffa4add5, 0xffa3add6, 0xffa1add3, 0xffa0add2, 0xffa0add3, 0xffa1add5,
    0xffa1acd5, 0xffa0abd3, 0xffa0abd3, 0xff9fabd3, 0xff9eabd3, 0xff9daad3, 0xff9da9d3, 0xff9ca9d3,
    0xff9ba9d3, 0xff9aa9d3, 0xff9aaad3, 0xff9aaad3, 0xff9baad4, 0xff9baad4, 0xff9ba9d3, 0xff9aa9d2,
    0xff99aad3, 0xff97aad4, 0xff96a9d4, 0xff96a8d3, 0xff96a7d3, 0xff95a7d3, 0xff95a7d4, 0xff95a6d5,
    0xff94a5d6, 0xff93a5d6, 0xff91a3d6, 0xff8da0d5, 0xff899cd4, 0xff8598d4, 0xff8196d5, 0xff7f95d6,
    0xff7e92d7, 0xff7e91d6, 0xff7c90d5, 0xff7a8fd3, 0xff798fd2, 0xff778fd2, 0xff758ed1, 0xff728cd0,
    0xff708bd0, 0xff6e8ad1, 0xff6d8ad2, 0xff6c8ad1, 0xff6989d0, 0xff6787d0, 0xff6485d2, 0xff6084d2,
    0xff5e84d2, 0xff5d84d1, 0xff5d84cf, 0xff5d83cf, 0xff5c81d0, 0xff5a7fd1, 0xff5a7fd1, 0xff5b80d2,
    0xff5b80d2, 0xff5b80d3, 0xff5b80d3, 0xff5a80d2, 0xff597fd0, 0xff597ecd, 0xff5a7ecb, 0xff5b7eca,
    0xff5b7fca, 0xff5b7fca, 0xff597dc9, 0xff587cc9, 0xff577aca, 0xff5579ca, 0xff5377c8, 0xff5176c6,
    0xff5075c6, 0xff5075c7, 0xff5075c7, 0xff4f74c6, 0xff4f74c5, 0xff4e73c4, 0xff4e73c4, 0xff4e73c4,
    0xff4d72c3, 0xff4c71c3, 0xff4b70c2, 0xff4b70c2, 0xff7b91c0, 0xff7b91c0, 0xff7d91c0, 0xff7e92c1,
    0xff7f94c2, 0xff7f95c4, 0xff8094c4, 0xff8093c4, 0xff8294c4, 0xff8296c5, 0xff8397c6, 0xff8497c5,
    0xff8597c5, 0xff8697c5, 0xff8898c6, 0xff8999c6, 0xff8a9ac7, 0xff8a9bc8, 0xff8a9bc9, 0xff8a9bca,
    0xff8b9ccb, 0xff8c9dcb, 0xff8d9ecc, 0xff8e9ecc, 0xff8f9ecc, 0xff909ecc, 0xff919ecc, 0xff919fcd,
    0xff92a0cd, 0xff94a2ce, 0xff96a3ce, 0xff96a3ce, 0xff97a4cf, 0xff98a5d0, 0xff9aa6d1, 0xff9ba7d2,
    0xff9ba7d2, 0xff9ba7d2, 0xff9ca8d3, 0xff9da9d4, 0xff9da9d4, 0xff9ea9d4, 0xff9faad5, 0xffa0acd6,
    0xffa0add7, 0xffa1add8, 0xffa1add7, 0xffa1aed5, 0xffa1afd4, 0xffa1afd5, 0xffa2b0d7, 0xffa2b1d7,
    0xffa3b1d6, 0xffa3b3d6, 0xffa4b4d6, 0xffa5b4d6, 0xffa6b4d6, 0xffa7b4d6, 0xffa9b4d6, 0xffaab4d6,
    0xffaab5d6, 0xffaab6d6, 0xffaab6d6, 0xffabb6d6, 0xffacb6d6, 0xffadb6d5, 0xffadb6d5, 0xffaeb7d6,
    0xffafb7d7, 0xffafb7d7, 0xffaeb6d7, 0xffaeb6d7, 0xffafb7d7, 0xffafb7d7, 0xffafb7d6, 0xffaeb6d6,
    0xffadb5d7, 0xffabb4d8, 0xffaab3d7, 0xffa9b1d6, 0xffa9b0d5, 0xffa9b0d4, 0xffa8b0d4, 0xffa6afd4,
    0xffa5aed4, 0xffa5afd5, 0xffa6b0d6, 0xffa6b0d5, 0xffa5afd3, 0xffa4aed3, 0xffa4add5, 0xffa3add6,
    0xffa1add3, 0xffa0add2, 0xffa0add3, 0xffa1add5, 0xffa1acd5, 0xffa0abd3, 0xffa0abd3, 0xff9fabd3,
    0xff9eabd3, 0xff9daad3, 0xff9da9d3, 0xff9ca9d3, 0xff9ba9d3, 0xff9aa9d3, 0xff9aaad3, 0xff9aaad3,
    0xff9baad4, 0xff9baad4, 0xff9ba9d3, 0xff9aa9d2, 0xff99aad3, 0xff97aad4, 0xff96a9d4, 0xff96a8d3,
    0xff96a7d3, 0xff95a7d3, 0xff95a7d4, 0xff95a6d5, 0xff94a5d6, 0xff93a5d6, 0xff91a3d6, 0xff8da0d5,
    0xff899cd4, 0xff8598d4, 0xff8196d5, 0xff7f95d6, 0xff7e92d7, 0xff7e91d6, 0xff7c90d5, 0xff7a8fd3,
    0xff798fd2, 0xff778fd2, 0xff758ed1, 0xff728cd0, 0xff708bd0, 0xff6e8ad1, 0xff6d8ad2, 0xff6c8ad1,
    0xff6989d0, 0xff6787d0, 0xff6485d2, 0xff6084d2, 0xff5e84d2, 0xff5d84d1, 0xff5d84cf, 0xff5d83cf,
    0xff5c81d0, 0xff5a7fd1, 0xff5a7fd1, 0xff5b80d2, 0xff5b80d2, 0xff5b80d3, 0xff5b80d3, 0xff5a80d2,
    0xff597fd0, 0xff597ecd, 0xff5a7ecb, 0xff5b7eca, 0xff5b7fca, 0xff5b7fca, 0xff597dc9, 0xff587cc9,
    0xff577aca, 0xff5579ca, 0xff5377c8, 0xff5176c6, 0xff5075c6, 0xff5075c7, 0xff5075c7, 0xff4f74c6,
    0xff4f74c5, 0xff4e73c4, 0xff4e73c4, 0xff4e73c4, 0xff4d72c3, 0xff4c71c3, 0xff4b70c2, 0xff4b70c2,
    0xff7b92c0, 0xff7b92c0, 0xff7d92c1, 0xff7e92c2, 0xff7f93c3, 0xff7f95c4, 0xff8095c4, 0xff8094c4,
    0xff8194c4, 0xff8296c5, 0xff8397c5, 0xff8597c5, 0xff8697c5, 0xff8797c5, 0xff8898c6, 0xff8999c7,
    0xff8a9ac7, 0xff8a9bc9, 0xff8a9bc9, 0xff8a9bca, 0xff8b9ccb, 0xff8c9dcb, 0xff8d9ecb, 0xff8f9ecc,
    0xff909ecc, 0xff919fcd, 0xff929fcd, 0xff93a0ce, 0xff93a1ce, 0xff95a2cf, 0xff96a3cf, 0xff96a3cf,
    0xff96a4d0, 0xff97a5d1, 0xff99a6d2, 0xff9ba6d3, 0xff9ba6d3, 0xff9ba7d3, 0xff9ca9d4, 0xff9daad4,
    0xff9daad4, 0xff9eabd4, 0xff9facd5, 0xff9fadd6, 0xffa1aed6, 0xffa2afd6, 0xffa2afd6, 0xffa2b0d5,
    0xffa2b1d4, 0xffa2b2d5, 0xffa3b2d6, 0xffa4b2d6, 0xffa4b3d6, 0xffa6b4d6, 0xffa7b5d5, 0xffa8b5d5,
    0xffa9b5d5, 0xffa9b4d5, 0xffaab4d5, 0xffabb4d6, 0xffacb5d6, 0xffadb6d6, 0xffadb6d6, 0xffadb6d6,
    0xffadb6d6, 0xffadb5d4, 0xffaeb5d4, 0xffafb5d5, 0xffb0b6d7, 0xffb0b6d7, 0xffb0b5d6, 0xffb0b5d6,
    0xffb0b5d6, 0xffb0b5d6, 0xffb0b5d6, 0xffafb5d6, 0xffaeb4d7, 0xffacb3d7, 0xffaab2d6, 0xffa9b0d5,
    0xffa8aed4, 0xffa8aed3, 0xffa8aed3, 0xffa6add3, 0xffa5add3, 0xffa5aed4, 0xffa6aed5, 0xffa6aed5,
    0xffa5add3, 0xffa5acd3, 0xffa4abd4, 0xffa3abd4, 0xffa2aad3, 0xffa1aad2, 0xffa1aad3, 0xffa1aad4,
    0xffa1aad4, 0xffa0aad2, 0xffa0aad2, 0xffa0a9d2, 0xffa0a9d2, 0xff9fa8d3, 0xff9ea8d3, 0xff9da8d2,
    0xff9da8d1, 0xff9da8d1, 0xff9ca9d2, 0xff9ca9d2, 0xff9ca9d3, 0xff9ca9d3, 0xff9ca8d2, 0xff9ca8d2,
    0xff9ba9d2, 0xff9aaad2, 0xff99aad2, 0xff98a8d2, 0xff98a8d2, 0xff98a8d3, 0xff98a8d3, 0xff98a8d4,
    0xff97a7d4, 0xff96a7d4, 0xff94a5d4, 0xff91a3d4, 0xff8d9fd3, 0xff889bd3, 0xff8499d4, 0xff8098d5,
    0xff7e96d5, 0xff7d94d5, 0xff7a92d5, 0xff7790d4, 0xff7690d4, 0xff758fd3, 0xff738ed3, 0xff708cd2,
    0xff6e8bd2, 0xff6b8ad3, 0xff6a89d3, 0xff6988d3, 0xff6786d2, 0xff6585d2, 0xff6383d3, 0xff6183d3,
    0xff6084d2, 0xff6084d1, 0xff5f84d0, 0xff5f83cf, 0xff5e82cf, 0xff5d81d0, 0xff5d81d0, 0xff5d82d0,
    0xff5d82d0, 0xff5d82d1, 0xff5d81d1, 0xff5b80d0, 0xff5a7fcf, 0xff5a7ece, 0xff5b7ecc, 0xff5b7ecb,
    0xff5b7eca, 0xff5b7eca, 0xff5a7ec9, 0xff597dc9, 0xff587bca, 0xff567aca, 0xff5579c9, 0xff5378c7,
    0xff5277c7, 0xff5176c8, 0xff5176c8, 0xff5075c7, 0xff5075c6, 0xff4f75c5, 0xff4e74c4, 0xff4e73c4,
    0xff4d72c3, 0xff4c71c2, 0xff4b71c1, 0xff4b71c1, 0xff7c92c1, 0xff7c92c1, 0xff7e92c1, 0xff7f92c2,
    0xff7f93c3, 0xff7f95c4, 0xff7f95c4, 0xff8094c4, 0xff8294c4, 0xff8395c5, 0xff8496c5, 0xff8697c6,
    0xff8798c6, 0xff8798c6, 0xff8799c7, 0xff889ac8, 0xff899bc9, 0xff8a9bc9, 0xff8b9cca, 0xff8b9cca,
    0xff8b9dcb, 0xff8c9dcb, 0xff8d9dcb, 0xff8f9ecc, 0xff919ecd, 0xff929fcd, 0xff939fcf, 0xff94a0d0,
    0xff94a1d0, 0xff96a2d0, 0xff97a3d0, 0xff96a3d0, 0xff96a4d1, 0xff97a5d2, 0xff99a5d3, 0xff9aa7d3,
    0xff9ba7d3, 0xff9ba8d3, 0xff9da9d4, 0xff9eaad4, 0xff9fabd4, 0xff9fadd4, 0xffa0aed4, 0xffa0afd5,
    0xffa2b0d5, 0xffa2b1d5, 0xffa3b1d5, 0xffa4b2d4, 0xffa4b3d4, 0xffa4b4d4, 0xffa5b4d5, 0xffa6b4d5,
    0xffa7b4d5, 0xffa9b4d5, 0xffaab5d4, 0xffabb5d4, 0xffacb4d4, 0xffacb4d4, 0xffacb4d4, 0xffadb4d5,
    0xffaeb5d6, 0xffafb6d7, 0xffafb6d7, 0xffafb6d6, 0xffafb5d5, 0xffafb4d3, 0xffafb4d3, 0xffafb5d4,
    0xffb0b6d6, 0xffb1b6d6, 0xffb1b5d5, 0xffb1b4d5, 0xffb0b3d5, 0xffb0b3d5, 0xffb0b3d6, 0xffb0b3d6,
    0xffafb2d6, 0xffacb1d6, 0xffaab0d5, 0xffa9aed4, 0xffa7acd3, 0xffa7acd3, 0xffa7acd3, 0xffa6abd2,
    0xffa5abd1, 0xffa5abd2, 0xffa5abd3, 0xffa5abd3, 0xffa5aad3, 0xffa5aad3, 0xffa4a9d2, 0xffa3a8d2,
    0xffa2a7d1, 0xffa1a7d1, 0xffa1a7d1, 0xffa2a7d2, 0xffa1a7d2, 0xffa0a8d2, 0xffa0a8d2, 0xffa1a7d0,
    0xffa1a7d0, 0xffa0a7d1, 0xff9fa7d2, 0xff9fa6d1, 0xff9fa6cf, 0xff9fa6cf, 0xff9fa7d0, 0xff9fa7d0,
    0xff9ea7d1, 0xff9ea7d1, 0xff9da7d1, 0xff9da7d1, 0xff9da9d0, 0xff9daad0, 0xff9caad0, 0xff9ba8d1,
    0xff9ba8d1, 0xff9ba9d2, 0xff9ba9d2, 0xff9ba9d1, 0xff9aa9d1, 0xff99a9d2, 0xff97a8d3, 0xff94a6d3,
    0xff91a3d2, 0xff8da0d2, 0xff889ed3, 0xff839cd3, 0xff7f99d3, 0xff7c97d3, 0xff7795d5, 0xff7392d6,
    0xff7290d6, 0xff718fd4, 0xff708dd4, 0xff6f8dd4, 0xff6d8cd4, 0xff6a8ad4, 0xff6888d4, 0xff6686d4,
    0xff6584d4, 0xff6483d4, 0xff6283d3, 0xff6283d3, 0xff6385d3, 0xff6385d2, 0xff6284d0, 0xff6183cf,
    0xff6082cf, 0xff6082cf, 0xff6083ce, 0xff5f84cd, 0xff5f84cd, 0xff5f83ce, 0xff5f82ce, 0xff5d80cd,
    0xff5b7fcd, 0xff5b7ece, 0xff5b7ece, 0xff5b7ecd, 0xff5c7ecc, 0xff5c7eca, 0xff5b7ec9, 0xff5a7ec9,
    0xff587dc9, 0xff567bca, 0xff557aca, 0xff5479c9, 0xff5479c9, 0xff5378c8, 0xff5378c8, 0xff5377c7,
    0xff5277c6, 0xff5076c5, 0xff4f75c4, 0xff4e74c3, 0xff4e72c2, 0xff4d71c1, 0xff4c71c0, 0xff4c71c0,
    0xff7d93c1, 0xff7d93c1, 0xff7f93c2, 0xff8093c3, 0xff8094c4, 0xff8095c4, 0xff8195c4, 0xff8195c4,
    0xff8295c4, 0xff8395c4, 0xff8496c4, 0xff8697c5, 0xff8798c6, 0xff8798c6, 0xff8799c7, 0xff889ac8,
    0xff899bc9, 0xff8a9bc9, 0xff8b9cca, 0xff8b9cca, 0xff8b9dcb, 0xff8c9dcb, 0xff8e9dcb, 0xff909ecc,
    0xff919fcd, 0xff929fce, 0xff94a1d0, 0xff94a1d1, 0xff95a2d1, 0xff97a3d1, 0xff97a3d1, 0xff96a3d1,
    0xff96a4d2, 0xff97a4d2, 0xff99a5d3, 0xff9ba7d3, 0xff9ba9d4, 0xff9caad4, 0xff9eabd4, 0xff9facd4,
    0xffa0add4, 0xffa0afd4, 0xffa1b0d4, 0xffa1b1d4, 0xffa3b2d4, 0xffa4b2d4, 0xffa5b3d4, 0xffa6b4d4,
    0xffa6b4d4, 0xffa6b5d4, 0xffa7b5d4, 0xffa8b5d4, 0xffaab5d4, 0xffacb5d4, 0xffadb5d3, 0xffadb5d3,
    0xffaeb5d3, 0xffaeb4d3, 0xffaeb3d3, 0xffaeb3d4, 0xffafb4d5, 0xffb1b5d6, 0xffb1b5d6, 0xffb1b5d5,
    0xffb0b4d4, 0xffafb3d3, 0xffafb3d3, 0xffafb4d4, 0xffb0b4d5, 0xffb1b4d5, 0xffb2b3d4, 0xffb2b2d4,
    0xffb1b1d4, 0xffb0b1d4, 0xffb0b1d5, 0xffb0b1d5, 0xffafb0d5, 0xffacafd5, 0xffaaaed4, 0xffa8acd3,
    0xffa6aad2, 0xffa6aad2, 0xffa6aad2, 0xffa5a9d1, 0xffa5a9d0, 0xffa4a9d1, 0xffa4a8d2, 0xffa4a8d3,
    0xffa5a7d3, 0xffa5a7d3, 0xffa3a6d1, 0xffa2a6d0, 0xffa1a5d0, 0xffa1a4d1, 0xffa1a4d1, 0xffa1a4d1,
    0xffa0a5d1, 0xff9fa6d1, 0xff9fa6d1, 0xffa0a5cf, 0xffa1a4cf, 0xffa0a5d0, 0xff9fa5d1, 0xff9fa5d0,
    0xffa0a4ce, 0xffa0a4ce, 0xffa0a5cf, 0xffa0a5cf, 0xff9fa5cf, 0xff9ea5cf, 0xff9ea5d0, 0xff9ea5d0,
    0xff9fa6cf, 0xff9fa8ce, 0xff9ea8ce, 0xff9da8d0, 0xff9da8d0, 0xff9ea9d0, 0xff9ea9d0, 0xff9daacf,
    0xff9caacf, 0xff9baad0, 0xff99a9d1, 0xff98a8d1, 0xff95a5d1, 0xff91a3d1, 0xff8ca2d1, 0xff87a0d1,
    0xff829dd1, 0xff7d9ad2, 0xff7797d4, 0xff7294d6, 0xff7092d6, 0xff6f90d5, 0xff6e8ed5, 0xff6d8ed5,
    0xff6c8dd5, 0xff688ad5, 0xff6688d5, 0xff6585d6, 0xff6483d6, 0xff6382d6, 0xff6283d5, 0xff6383d4,
    0xff6584d3, 0xff6685d2, 0xff6585d0, 0xff6484cf, 0xff6384cf, 0xff6384ce, 0xff6384cd, 0xff6285cb,
    0xff6285cb, 0xff6284cb, 0xff6283cc, 0xff5f81cc, 0xff5d80cc, 0xff5c7fcd, 0xff5d7fce, 0xff5d7fcd,
    0xff5d7ecc, 0xff5d7eca, 0xff5c7fc9, 0xff5b7fc9, 0xff597ec9, 0xff577cca, 0xff567bca, 0xff567bca,
    0xff557aca, 0xff5479c9, 0xff5479c9, 0xff5478c8, 0xff5378c7, 0xff5177c5, 0xff5076c4, 0xff4f75c3,
    0xff4f73c2, 0xff4e72c1, 0xff4d72bf, 0xff4d72bf, 0xff7e93c1, 0xff7e93c1, 0xff8094c2, 0xff8194c3,
    0xff8194c3, 0xff8195c3, 0xff8295c3, 0xff8396c4, 0xff8396c4, 0xff8496c4, 0xff8496c4, 0xff8597c5,
    0xff8698c6, 0xff8699c7, 0xff8699c7, 0xff8799c7, 0xff889ac8, 0xff8a9ac8, 0xff8a9bc9, 0xff8b9bca,
    0xff8b9ccb, 0xff8c9dcc, 0xff8e9dcc, 0xff909dcd, 0xff919ece, 0xff929fce, 0xff94a1d0, 0xff94a1d0,
    0xff95a2d1, 0xff96a3d2, 0xff97a3d2, 0xff97a4d3, 0xff97a5d3, 0xff98a6d3, 0xff99a7d2, 0xff9ba9d2,
    0xff9cacd3, 0xff9dadd4, 0xff9faed4, 0xffa0aed3, 0xffa0afd3, 0xffa1b1d3, 0xffa2b2d3, 0xffa3b2d3,
    0xffa5b2d3, 0xffa6b3d2, 0xffa7b4d2, 0xffa8b5d3, 0xffa9b5d3, 0xffa9b5d3, 0xffa9b5d2, 0xffaab5d2,
    0xffacb4d3, 0xffaeb4d3, 0xffaeb3d2, 0xffaeb3d2, 0xffafb3d2, 0xffafb3d2, 0xffaeb2d2, 0xffaeb2d3,
    0xffafb2d4, 0xffb1b3d4, 0xffb1b3d4, 0xffb1b3d3, 0xffb0b3d3, 0xffafb2d3, 0xffafb2d3, 0xffafb2d4,
    0xffafb2d4, 0xffb0b2d4, 0xffb1b1d3, 0xffb1b1d3, 0xffafb0d4, 0xffaeb0d4, 0xffaeb0d4, 0xffaeafd4,
    0xffacaed4, 0xffaaadd4, 0xffa9acd3, 0xffa8aad2, 0xffa6a8d2, 0xffa5a8d2, 0xffa4a8d2, 0xffa4a8d1,
    0xffa4a8d0, 0xffa4a7d1, 0xffa3a6d2, 0xffa3a5d2, 0xffa3a5d2, 0xffa3a5d2, 0xffa2a5d1, 0xffa1a5d0,
    0xffa0a4d0, 0xffa0a3d1, 0xffa0a3d1, 0xff9fa3d1, 0xff9fa3d1, 0xff9ea4d0, 0xff9ea4d0, 0xff9fa3cf,
    0xff9fa2cf, 0xff9ea3d0, 0xff9da3d0, 0xff9ea3cf, 0xff9fa2ce, 0xff9fa2ce, 0xff9fa3cf, 0xff9fa3cf,
    0xff9ea2cd, 0xff9da2cd, 0xff9da2ce, 0xff9da3cf, 0xff9fa4cf, 0xffa0a5ce, 0xffa0a5ce, 0xff9ea6cf,
    0xff9ea6cf, 0xffa0a7cf, 0xffa0a8cf, 0xff9fa8ce, 0xff9da8ce, 0xff9ca8cf, 0xff9ba8d1, 0xff9aa7d1,
    0xff98a6cf, 0xff94a4cf, 0xff91a3cf, 0xff8ca2d0, 0xff869fd0, 0xff809dd1, 0xff7a9ad2, 0xff7597d4,
    0xff7194d5, 0xff6f92d5, 0xff6d90d5, 0xff6d90d6, 0xff6c8fd6, 0xff698cd6, 0xff668ad6, 0xff6487d7,
    0xff6385d7, 0xff6284d7, 0xff6183d6, 0xff6283d5, 0xff6484d4, 0xff6685d3, 0xff6684d1, 0xff6684cf,
    0xff6684ce, 0xff6685ce, 0xff6685cd, 0xff6585cc, 0xff6585cb, 0xff6585cb, 0xff6584cb, 0xff6382cb,
    0xff6181cc, 0xff6080cd, 0xff5f80cd, 0xff5f80cd, 0xff5f7fcc, 0xff5e7fcb, 0xff5d7fca, 0xff5b7fca,
    0xff597dca, 0xff587cca, 0xff587bca, 0xff577bca, 0xff567bca, 0xff557ac9, 0xff547ac9, 0xff5479c8,
    0xff5479c7, 0xff5278c6, 0xff5177c5, 0xff5076c4, 0xff5074c2, 0xff4f73c1, 0xff4e73bf, 0xff4e73bf,
    0xff7f94c2, 0xff7f94c2, 0xff8194c3, 0xff8294c3, 0xff8294c3, 0xff8295c3, 0xff8396c4, 0xff8497c5,
    0xff8497c5, 0xff8596c4, 0xff8596c4, 0xff8596c4, 0xff8597c5, 0xff8597c5, 0xff8698c6, 0xff8799c7,
    0xff879ac7, 0xff899ac9, 0xff8a9bca, 0xff8b9bcb, 0xff8b9ccc, 0xff8c9ccd, 0xff8e9ccd, 0xff909dcd,
    0xff919ece, 0xff929ecf, 0xff929fcf, 0xff93a0d0, 0xff94a1d0, 0xff96a3d1, 0xff97a4d2, 0xff98a5d3,
    0xff99a6d3, 0xff9aa7d2, 0xff9aa9d0, 0xff9cabd1, 0xff9eaed3, 0xff9fafd4, 0xffa0b0d3, 0xffa1b0d2,
    0xffa2b1d2, 0xffa3b3d2, 0xffa4b3d2, 0xffa5b3d1, 0xffa7b3d1, 0xffa8b3d1, 0xffa9b3d1, 0xffaab4d2,
    0xffabb4d2, 0xffabb4d1, 0xffabb4d1, 0xffacb4d2, 0xffaeb3d3, 0xffaeb2d3, 0xffadb1d2, 0xffadb1d1,
    0xffaeb2d1, 0xffaeb2d1, 0xffadb2d2, 0xffadb1d3, 0xffaeb1d3, 0xffafb1d2, 0xffafb1d2, 0xffafb1d1,
    0xffafb1d1, 0xffaeb1d3, 0xffaeb1d4, 0xffaeb1d4, 0xffaeb1d3, 0xffafb1d3, 0xffafb0d3, 0xffafb0d3,
    0xffadafd4, 0xffacafd4, 0xffabaed4, 0xffabadd4, 0xffaaadd4, 0xffa8acd3, 0xffa8abd3, 0xffa7aad3,
    0xffa6a8d3, 0xffa4a7d3, 0xffa3a7d3, 0xffa2a7d2, 0xffa2a7d1, 0xffa2a7d2, 0xffa2a6d3, 0xffa2a5d3,
    0xffa1a4d1, 0xffa1a4d1, 0xffa0a4d1, 0xffa0a4d1, 0xff9fa3d1, 0xff9ea3d1, 0xff9da3d1, 0xff9da3d1,
    0xff9da3d1, 0xff9da3d0, 0xff9da3d0, 0xff9ca2d0, 0xff9ba1d0, 0xff9ba2d0, 0xff9ba2d0, 0xff9ba1d0,
    0xff9ca0cf, 0xff9da0cf, 0xff9da1cf, 0xff9da1cf, 0xff9ba0ce, 0xff9aa0cd, 0xff9aa0cd, 0xff9ba0cd,
    0xff9da1cd, 0xff9fa2ce, 0xff9fa3cf, 0xff9ea4cf, 0xff9ea4cf, 0xff9fa5ce, 0xff9fa5ce, 0xff9da4ce,
    0xff9ca4cf, 0xff9ca4d0, 0xff9ba5d1, 0xff9aa5d0, 0xff99a5ce, 0xff97a5ce, 0xff94a4cf, 0xff90a3d0,
    0xff8aa1d1, 0xff849ed1, 0xff7e9bd1, 0xff7897d1, 0xff7395d2, 0xff6f94d3, 0xff6d93d4, 0xff6d93d5,
    0xff6d92d5, 0xff6a8fd6, 0xff678dd6, 0xff658bd6, 0xff6488d6, 0xff6286d6, 0xff6184d5, 0xff6184d5,
    0xff6384d4, 0xff6585d3, 0xff6785d1, 0xff6785d0, 0xff6785d0, 0xff6785cf, 0xff6785ce, 0xff6885cd,
    0xff6885cb, 0xff6885cb, 0xff6785cb, 0xff6683cc, 0xff6482cc, 0xff6282cc, 0xff6082cb, 0xff6082cb,
    0xff6081ca, 0xff5f81ca, 0xff5d80cb, 0xff5b7fcb, 0xff597ecb, 0xff587dcb, 0xff577ccb, 0xff577bca,
    0xff567bca, 0xff557aca, 0xff557aca, 0xff5479c8, 0xff5479c7, 0xff5378c6, 0xff5277c5, 0xff5276c4,
    0xff5175c3, 0xff5074c2, 0xff4f73c0, 0xff4f73c0, 0xff8094c2, 0xff8094c2, 0xff8295c3, 0xff8395c3,
    0xff8395c3, 0xff8395c3, 0xff8496c4, 0xff8597c5, 0xff8597c5, 0xff8596c4, 0xff8596c4, 0xff8496c4,
    0xff8497c5, 0xff8597c5, 0xff8698c6, 0xff8698c6, 0xff8799c6, 0xff8899c8, 0xff899ac9, 0xff8a9acb,
    0xff8b9bcd, 0xff8c9cce, 0xff8d9cce, 0xff8f9dce, 0xff909ece, 0xff909ecf, 0xff92a0cf, 0xff93a1cf,
    0xff94a2cf, 0xff96a4d1, 0xff97a5d2, 0xff99a6d3, 0xff9ba8d3, 0xff9caad2, 0xff9caccf, 0xff9eaecf,
    0xffa0b0d2, 0xffa1b1d3, 0xffa2b1d2, 0xffa2b1d1, 0xffa3b2d0, 0xffa5b3d0, 0xffa6b3d0, 0xffa7b3d0,
    0xffa9b3d0, 0xffaab2d0, 0xffabb2d0, 0xffadb3d1, 0xffadb3d1, 0xffadb3d0, 0xffacb2d0, 0xffadb2d1,
    0xffaeb1d2, 0xffaeb0d2, 0xffacafd1, 0xffabafd1, 0xffacb0d1, 0xffadb1d1, 0xffadb1d2, 0xffacb0d2,
    0xffacb0d2, 0xffadafd1, 0xffadafd1, 0xffadb0d0, 0xffadb0d1, 0xffadb0d4, 0xffadb0d5, 0xffadb0d4,
    0xffacafd3, 0xffacafd3, 0xffacafd3, 0xffabafd3, 0xffaaafd4, 0xffa9afd4, 0xffa8add3, 0xffa8acd3,
    0xffa7acd3, 0xffa6abd3, 0xffa6aad3, 0xffa6a9d4, 0xffa5a7d4, 0xffa3a6d4, 0xffa1a6d3, 0xffa1a7d2,
    0xffa1a7d2, 0xffa1a7d3, 0xffa1a6d3, 0xffa0a5d2, 0xff9fa4d1, 0xff9fa4d1, 0xff9ea4d2, 0xff9ea4d2,
    0xff9da3d1, 0xff9ca3d1, 0xff9ba3d1, 0xff9ba3d1, 0xff9ba3d1, 0xff9ba2d0, 0xff9aa2d0, 0xff99a1d1,
    0xff98a0d1, 0xff98a0d0, 0xff98a0cf, 0xff98a0cf, 0xff999fd0, 0xff999fd0, 0xff999fd0, 0xff999fce,
    0xff989ecd, 0xff979ecc, 0xff979ecb, 0xff989ecc, 0xff9b9ecd, 0xff9d9fcf, 0xff9da0cf, 0xff9ca1cf,
    0xff9ca1cf, 0xff9da2ce, 0xff9da2ce, 0xff9ba1ce, 0xff9aa0cf, 0xff99a0d0, 0xff99a1d1, 0xff99a2d0,
    0xff98a2ce, 0xff96a2cd, 0xff95a2ce, 0xff93a1cf, 0xff8d9fd1, 0xff889dd1, 0xff829bd0, 0xff7d98cf,
    0xff7897d0, 0xff7495d1, 0xff7195d3, 0xff7195d3, 0xff7194d4, 0xff6e92d5, 0xff6b90d5, 0xff698ed5,
    0xff678cd5, 0xff658ad5, 0xff6388d4, 0xff6386d4, 0xff6486d4, 0xff6586d3, 0xff6786d1, 0xff6886d0,
    0xff6886cf, 0xff6885cf, 0xff6985ce, 0xff6a84cd, 0xff6a84cd, 0xff6a85cc, 0xff6985cc, 0xff6884cc,
    0xff6783cc, 0xff6483cb, 0xff6283c9, 0xff6283c9, 0xff6282c9, 0xff6181cb, 0xff5e80cc, 0xff5c7fcc,
    0xff5a7ecc, 0xff597dcb, 0xff587cca, 0xff577bca, 0xff567aca, 0xff557aca, 0xff557ac9, 0xff547ac8,
    0xff547ac7, 0xff5379c6, 0xff5378c6, 0xff5377c5, 0xff5276c3, 0xff5175c2, 0xff5074c1, 0xff5074c1,
    0xff8295c3, 0xff8295c3, 0xff8396c4, 0xff8496c4, 0xff8596c4, 0xff8596c4, 0xff8596c4, 0xff8697c5,
    0xff8697c5, 0xff8696c4, 0xff8696c4, 0xff8596c4, 0xff8497c5, 0xff8598c6, 0xff8698c7, 0xff8698c7,
    0xff8698c7, 0xff8698c8, 0xff8899c9, 0xff899acb, 0xff8a9bcd, 0xff8b9cce, 0xff8c9ccf, 0xff8e9dcf,
    0xff8f9ecf, 0xff8f9fcf, 0xff91a1cf, 0xff92a3cf, 0xff94a4cf, 0xff96a6d1, 0xff98a7d2, 0xff9ba9d3,
    0xff9dabd2, 0xff9eadd0, 0xff9eaece, 0xffa0b0ce, 0xffa2b1d1, 0xffa3b1d2, 0xffa4b2d1, 0xffa4b2d0,
    0xffa6b3cf, 0xffa8b3cf, 0xffa9b3cf, 0xffaab2cf, 0xffabb2cf, 0xffabb1cf, 0xffacb1cf, 0xffadb2d0,
    0xffadb2d1, 0xffadb1d0, 0xffacb0cf, 0xffacb0cf, 0xffadb0d1, 0xffadafd1, 0xffabaed1, 0xffaaadd1,
    0xffaaaed1, 0xffabafd1, 0xffabafd1, 0xffabafd1, 0xffabafd1, 0xffabaed1, 0xffabaed1, 0xffabafd1,
    0xffabafd2, 0xffabafd4, 0xffabafd5, 0xffabafd4, 0xffabaed3, 0xffabaed3, 0xffaaaed3, 0xffaaaed3,
    0xffa9afd4, 0xffa8afd4, 0xffa7add3, 0xffa6abd2, 0xffa5abd2, 0xffa4abd3, 0xffa4aad4, 0xffa4a9d4,
    0xffa3a7d4, 0xffa1a6d3, 0xffa0a6d3, 0xffa0a7d3, 0xffa1a7d3, 0xffa1a7d3, 0xffa0a6d3, 0xff9fa5d2,
    0xff9fa4d1, 0xff9da4d1, 0xff9da4d2, 0xff9ca4d2, 0xff9ba3d1, 0xff9ba2d0, 0xff9aa2d0, 0xff99a3d1,
    0xff99a3d1, 0xff99a2d0, 0xff98a0d0, 0xff97a0d1, 0xff969fd1, 0xff959ed0, 0xff959ecf, 0xff959ecf,
    0xff969ed0, 0xff969ed0, 0xff959ed0, 0xff959ece, 0xff949dcd, 0xff949ccc, 0xff959ccb, 0xff969ccb,
    0xff989dcc, 0xff9a9ece, 0xff9a9ece, 0xff999ece, 0xff999ece, 0xff999fcf, 0xff999fcf, 0xff989dcf,
    0xff979ccf, 0xff979dd0, 0xff979ed0, 0xff979ecf, 0xff969ece, 0xff959ecd, 0xff949ecd, 0xff939ece,
    0xff8e9dcf, 0xff8a9bd0, 0xff859ad0, 0xff8198cf, 0xff7c97cf, 0xff7996d0, 0xff7796d1, 0xff7795d2,
    0xff7695d2, 0xff7394d3, 0xff7093d3, 0xff6d92d4, 0xff6b90d4, 0xff698ed4, 0xff678cd3, 0xff678ad3,
    0xff6789d2, 0xff6889d2, 0xff6988d1, 0xff6988d0, 0xff6887d0, 0xff6886cf, 0xff6985ce, 0xff6a84cd,
    0xff6a84cd, 0xff6a84cd, 0xff6984cd, 0xff6984cd, 0xff6884cc, 0xff6684ca, 0xff6484c9, 0xff6484c9,
    0xff6483ca, 0xff6282ca, 0xff6081cb, 0xff5e80cb, 0xff5c7fcb, 0xff5a7ecb, 0xff597dcb, 0xff587ccb,
    0xff577bcb, 0xff577bcb, 0xff557bca, 0xff557bc8, 0xff547bc7, 0xff5479c6, 0xff5478c6, 0xff5378c5,
    0xff5277c3, 0xff5176c2, 0xff5175c2, 0xff5174c2, 0xff8395c3, 0xff8395c3, 0xff8396c4, 0xff8497c4,
    0xff8597c5, 0xff8697c5, 0xff8797c5, 0xff8797c5, 0xff8797c5, 0xff8796c4, 0xff8696c4, 0xff8596c5,
    0xff8597c6, 0xff8698c7, 0xff8799c8, 0xff8799c8, 0xff8698c8, 0xff8698c8, 0xff8799ca, 0xff889acb,
    0xff899acc, 0xff8a9bcd, 0xff8c9ccf, 0xff8e9ed0, 0xff8e9fd0, 0xff8ea0cf, 0xff90a2cf, 0xff92a4cf,
    0xff94a6cf, 0xff98a8d0, 0xff9aa9d1, 0xff9dacd1, 0xff9faed0, 0xffa0afcf, 0xffa1afce, 0xffa3afce,
    0xffa4b0d0, 0xffa5b1d1, 0xffa5b1d1, 0xffa6b1d0, 0xffa8b1cf, 0xffaab1ce, 0xffaab1ce, 0xffaab1cf,
    0xffaab1cf, 0xffabb0cf, 0xffabb0cf, 0xffacb0d1, 0xffacb0d2, 0xffacafd1, 0xffabafd0, 0xffabafd0,
    0xffabb0d0, 0xffaaafd0, 0xffa9add1, 0xffa8acd1, 0xffa8add1, 0xffa9aed1, 0xffaaafd1, 0xffaaafd1,
    0xffaaafd1, 0xffa9aed2, 0xffa9aed2, 0xffaaaed3, 0xffaaaed4, 0xffaaaed4, 0xffaaaed4, 0xffaaaed4,
    0xffaaadd4, 0xffa9add4, 0xffa8add4, 0xffa8add4, 0xffa7aed4, 0xffa7aed4, 0xffa6add2, 0xffa5acd1,
    0xffa5acd2, 0xffa4abd3, 0xffa3aad4, 0xffa3a9d4, 0xffa1a7d4, 0xffa0a6d3, 0xffa0a6d3, 0xffa1a7d4,
    0xffa1a8d5, 0xffa0a7d4, 0xff9fa6d2, 0xff9fa6d2, 0xff9ea6d2, 0xff9da6d2, 0xff9ca5d2, 0xff9ba4d2,
    0xff9aa2d1, 0xff9aa2d0, 0xff99a3d0, 0xff98a4d1, 0xff98a3d1, 0xff97a1d1, 0xff979fd1, 0xff969fd1,
    0xff959fd1, 0xff949ed0, 0xff949dcf, 0xff959dcf, 0xff959dcf, 0xff949dcf, 0xff939dce, 0xff929dce,
    0xff929ccd, 0xff929bcc, 0xff939bcc, 0xff949bcc, 0xff959ccd, 0xff969dce, 0xff969dce, 0xff959ccd,
    0xff959ccd, 0xff959cce, 0xff959ccf, 0xff949bcf, 0xff949ace, 0xff959ace, 0xff959bce, 0xff949bce,
    0xff939ace, 0xff929ace, 0xff919acd, 0xff909acd, 0xff8e98ce, 0xff8b97cf, 0xff8797d0, 0xff8497d0,
    0xff8197d0, 0xff8096cf, 0xff7e96cf, 0xff7d96cf, 0xff7b96cf, 0xff7895cf, 0xff7594d0, 0xff7294d1,
    0xff7093d2, 0xff6f92d2, 0xff6d90d1, 0xff6d8ed1, 0xff6c8dd1, 0xff6c8cd1, 0xff6b8bd0, 0xff6a8acf,
    0xff6889cf, 0xff6787ce, 0xff6786cd, 0xff6984cc, 0xff6984cc, 0xff6984cd, 0xff6984cd, 0xff6984cd,
    0xff6884cc, 0xff6784cb, 0xff6584ca, 0xff6484ca, 0xff6383ca, 0xff6383ca, 0xff6283c9, 0xff6182c9,
    0xff5e80cb, 0xff5b7fcc, 0xff597ecc, 0xff587dcc, 0xff587ccc, 0xff587ccc, 0xff577cca, 0xff557cc8,
    0xff547cc6, 0xff547bc5, 0xff5479c5, 0xff5478c4, 0xff5377c3, 0xff5276c2, 0xff5174c2, 0xff5174c2,
    0xff8496c4, 0xff8496c4, 0xff8497c5, 0xff8597c5, 0xff8698c6, 0xff8798c6, 0xff8798c6, 0xff8797c5,
    0xff8797c5, 0xff8797c5, 0xff8797c5, 0xff8697c6, 0xff8698c7, 0xff8799c8, 0xff889ac9, 0xff8799c9,
    0xff8698c9, 0xff8698c9, 0xff879aca, 0xff889bcb, 0xff899bcb, 0xff8a9ccc, 0xff8c9ece, 0xff8ea0d0,
    0xff8fa1d0, 0xff8fa2cf, 0xff91a4cf, 0xff93a6cf, 0xff96a8cf, 0xff99aacf, 0xff9cabcf, 0xff9faecf,
    0xffa1b0ce, 0xffa2b0ce, 0xffa3afce, 0xffa5afce, 0xffa5afcf, 0xffa6afcf, 0xffa7b0d0, 0xffa8b0d0,
    0xffaab0cf, 0xffabafce, 0xffabafce, 0xffaaafce, 0xffaaafce, 0xffaaaece, 0xffaaaecf, 0xffaaaed1,
    0xffaaaed2, 0xffaaadd1, 0xffaaadd0, 0xffaaaed0, 0xffa9afd0, 0xffa9afd0, 0xffa8add1, 0xffa7acd1,
    0xffa7acd1, 0xffa7add1, 0xffa8aed1, 0xffa9aed1, 0xffa9aed2, 0xffa8aed2, 0xffa8aed4, 0xffa8aed5,
    0xffa8aed5, 0xffa8aed5, 0xffa8aed4, 0xffa9aed4, 0xffa9add4, 0xffa8acd4, 0xffa7acd4, 0xffa7acd4,
    0xffa7aed4, 0xffa7aed4, 0xffa5add2, 0xffa4acd1, 0xffa3acd2, 0xffa3abd3, 0xffa2aad4, 0xffa1a9d4,
    0xffa1a7d4, 0xffa0a7d2, 0xffa0a7d2, 0xffa1a8d4, 0xffa1a8d5, 0xffa0a7d4, 0xff9fa6d2, 0xff9fa6d2,
    0xff9ea7d3, 0xff9da7d3, 0xff9ca5d3, 0xff9ba4d2, 0xff9aa2d1, 0xff9aa2d0, 0xff99a3d0, 0xff98a4d1,
    0xff97a3d1, 0xff96a1d1, 0xff969fd1, 0xff959fd1, 0xff959fd1, 0xff949ed0, 0xff939dcf, 0xff939dce,
    0xff939dce, 0xff929dce, 0xff919dce, 0xff909cce, 0xff909bcd, 0xff909acc, 0xff9199cc, 0xff929acc,
    0xff939ccc, 0xff939dcd, 0xff929ccd, 0xff919bcd, 0xff919ace, 0xff919acf, 0xff919ad0, 0xff9099ce,
    0xff9098cd, 0xff9198cd, 0xff9198cd, 0xff9097cd, 0xff8f96ce, 0xff8d96ce, 0xff8d96cc, 0xff8c96cc,
    0xff8b95cd, 0xff8a94ce, 0xff8794cf, 0xff8595d0, 0xff8595d0, 0xff8595cf, 0xff8495ce, 0xff8295cd,
    0xff8095cd, 0xff7d95cd, 0xff7b95ce, 0xff7895cf, 0xff7595d0, 0xff7495d0, 0xff7394cf, 0xff7392cf,
    0xff7391cf, 0xff7290cf, 0xff6f8ecf, 0xff6d8dce, 0xff6b8bce, 0xff6989cd, 0xff6987cc, 0xff6986cc,
    0xff6984cc, 0xff6884ce, 0xff6884ce, 0xff6884cd, 0xff6784cc, 0xff6684cb, 0xff6584cb, 0xff6484cb,
    0xff6383cb, 0xff6383cb, 0xff6383c9, 0xff6283c9, 0xff5f82ca, 0xff5c80cc, 0xff5a7fcd, 0xff597ecd,
    0xff597ecd, 0xff597dcc, 0xff587dca, 0xff567dc8, 0xff557cc6, 0xff557ac5, 0xff5579c5, 0xff5479c4,
    0xff5378c3, 0xff5277c2, 0xff5276c2, 0xff5275c2, 0xff8597c4, 0xff8597c4, 0xff8597c5, 0xff8697c5,
    0xff8798c6, 0xff8899c6, 0xff8899c6, 0xff8798c6, 0xff8798c6, 0xff8798c6, 0xff8798c6, 0xff8798c7,
    0xff8798c8, 0xff8899c9, 0xff889aca, 0xff879aca, 0xff8699ca, 0xff8699ca, 0xff889bcb, 0xff899ccc,
    0xff899ccd, 0xff8a9dcd, 0xff8c9fce, 0xff8fa2cf, 0xff90a3cf, 0xff92a4ce, 0xff94a6ce, 0xff96a8cf,
    0xff99aacf, 0xff9cabce, 0xff9faccd, 0xffa1aecd, 0xffa3b0cd, 0xffa4b0cd, 0xffa5afce, 0xffa6aece,
    0xffa7aece, 0xffa7aece, 0xffa8aecf, 0xffa9aecf, 0xffaaaecf, 0xffaaadce, 0xffaaadcd, 0xffa9adcd,
    0xffa9adcd, 0xffa9accf, 0xffa9acd0, 0xffa8acd1, 0xffa8acd1, 0xffa9acd1, 0xffa9acd0, 0xffa8add0,
    0xffa7aed0, 0xffa7aed0, 0xffa7add1, 0xffa7acd1, 0xffa6acd2, 0xffa6add2, 0xffa6add1, 0xffa7add1,
    0xffa7add1, 0xffa7aed2, 0xffa7aed4, 0xffa7aed5, 0xffa7aed5, 0xffa7aed5, 0xffa7aed4, 0xffa7aed4,
    0xffa7add4, 0xffa7add4, 0xffa6acd3, 0xffa6acd3, 0xffa6add4, 0xffa6add4, 0xffa5add3, 0xffa4acd2,
    0xffa4acd2, 0xffa3abd2, 0xffa2aad3, 0xffa1a9d4, 0xffa1a8d4, 0xffa0a8d3, 0xffa0a8d2, 0xffa1a8d3,
    0xffa1a8d4, 0xffa0a7d3, 0xff9fa7d2, 0xff9fa7d2, 0xff9fa8d3, 0xff9fa8d3, 0xff9da6d3, 0xff9ca5d2,
    0xff9ba3d1, 0xff9aa3d1, 0xff99a4d1, 0xff98a4d1, 0xff97a3d1, 0xff97a2d2, 0xff95a1d2, 0xff95a0d2,
    0xff94a0d1, 0xff939fd1, 0xff939ed0, 0xff939dcf, 0xff929dce, 0xff919dce, 0xff909dcd, 0xff8f9ccd,
    0xff8f9bcc, 0xff8f9acc, 0xff909acc, 0xff909acc, 0xff919bcc, 0xff919ccd, 0xff919bcd, 0xff909ace,
    0xff8f99cf, 0xff8e98d0, 0xff8e98d0, 0xff8d98ce, 0xff8c97cc, 0xff8d96cd, 0xff8d95ce, 0xff8c94ce,
    0xff8b93ce, 0xff8993ce, 0xff8893cd, 0xff8893cc, 0xff8992cc, 0xff8992cd, 0xff8692ce, 0xff8493ce,
    0xff8593cd, 0xff8794cc, 0xff8894cc, 0xff8694cc, 0xff8494cc, 0xff8195cd, 0xff7f95cd, 0xff7c95ce,
    0xff7995ce, 0xff7895ce, 0xff7995cd, 0xff7995cd, 0xff7894cd, 0xff7793cd, 0xff7491cd, 0xff7290cd,
    0xff6f8ecc, 0xff6d8ccc, 0xff6c8acc, 0xff6b89cd, 0xff6987ce, 0xff6987cf, 0xff6886cf, 0xff6685ce,
    0xff6584cc, 0xff6483cc, 0xff6483cc, 0xff6383cc, 0xff6283cd, 0xff6283cd, 0xff6283cc, 0xff6183cb,
    0xff5e82cb, 0xff5c81cc, 0xff5b80cd, 0xff5a7fcd, 0xff5a7fcd, 0xff597ecc, 0xff587eca, 0xff577dc8,
    0xff567cc6, 0xff567bc5, 0xff567ac5, 0xff557ac5, 0xff5479c4, 0xff5378c3, 0xff5377c2, 0xff5376c1,
    0xff8598c4, 0xff8598c4, 0xff8697c4, 0xff8797c4, 0xff8898c5, 0xff8899c6, 0xff8899c7, 0xff8799c8,
    0xff8799c8, 0xff8899c7, 0xff8899c7, 0xff8899c8, 0xff8899c9, 0xff8899ca, 0xff889acb, 0xff879acb,
    0xff879aca, 0xff889aca, 0xff8a9ccb, 0xff8c9dcc, 0xff8c9ecd, 0xff8c9fce, 0xff8da1ce, 0xff8fa4ce,
    0xff92a5cd, 0xff95a6cc, 0xff97a8cc, 0xff98a9ce, 0xff9aaace, 0xff9eaacc, 0xffa0abcb, 0xffa2adcc,
    0xffa3afcd, 0xffa5afcd, 0xffa6aecd, 0xffa8adcd, 0xffa8adcd, 0xffa8adcd, 0xffa8acce, 0xffa8accf,
    0xffa8accf, 0xffa8acce, 0xffa8accd, 0xffa8accc, 0xffa8accd, 0xffa7abcf, 0xffa7abd1, 0xffa7acd1,
    0xffa7acd1, 0xffa8acd1, 0xffa8acd1, 0xffa7acd1, 0xffa6add1, 0xffa6add1, 0xffa6acd2, 0xffa6acd2,
    0xffa5add2, 0xffa5add2, 0xffa5add2, 0xffa5add2, 0xffa6add2, 0xffa7add3, 0xffa7add3, 0xffa6aed4,
    0xffa6aed4, 0xffa7afd4, 0xffa7afd4, 0xffa7aed4, 0xffa6add3, 0xffa6add3, 0xffa5add3, 0xffa5add3,
    0xffa5acd3, 0xffa5acd3, 0xffa5acd3, 0xffa5acd3, 0xffa4acd2, 0xffa3abd1, 0xffa3aad2, 0xffa2a9d3,
    0xffa2a8d3, 0xffa1a8d2, 0xffa0a8d1, 0xffa0a7d2, 0xffa0a7d3, 0xffa0a7d3, 0xff9fa8d3, 0xff9fa9d3,
    0xff9fa9d3, 0xff9fa9d3, 0xff9fa7d2, 0xff9ea6d1, 0xff9ca5d2, 0xff9aa4d2, 0xff99a4d2, 0xff98a4d1,
    0xff98a3d1, 0xff97a2d2, 0xff96a2d2, 0xff95a2d2, 0xff94a2d2, 0xff94a0d1, 0xff949fd0, 0xff939ecf,
    0xff929dce, 0xff919dcd, 0xff909dcd, 0xff909dcd, 0xff8f9ccd, 0xff8f9bcd, 0xff8f9acc, 0xff8f9acc,
    0xff909acc, 0xff919bcd, 0xff909bcd, 0xff8f9bce, 0xff8d99ce, 0xff8d98cf, 0xff8c97cf, 0xff8a97cc,
    0xff8997cb, 0xff8996cd, 0xff8994cf, 0xff8893cf, 0xff8792ce, 0xff8692cd, 0xff8692cd, 0xff8692cd,
    0xff8791cd, 0xff8791cd, 0xff8491cd, 0xff8291cc, 0xff8491cb, 0xff8792cb, 0xff8892cb, 0xff8893cc,
    0xff8693cd, 0xff8494cd, 0xff8294cc, 0xff7f94cc, 0xff7c93cc, 0xff7c93cc, 0xff7d94cc, 0xff7d94cc,
    0xff7c95cb, 0xff7b95cb, 0xff7894cc, 0xff7692cc, 0xff7491cc, 0xff728fcc, 0xff708ecc, 0xff6d8ccd,
    0xff6b8ace, 0xff6a89cf, 0xff6988cf, 0xff6686ce, 0xff6485cd, 0xff6383cd, 0xff6282ce, 0xff6282cf,
    0xff6182cf, 0xff6182cf, 0xff6182ce, 0xff6082cd, 0xff5e82cc, 0xff5c81cc, 0xff5b80cd, 0xff5b7fcd,
    0xff5a7fcc, 0xff5a7ecb, 0xff587dc9, 0xff587cc7, 0xff577bc6, 0xff577ac6, 0xff577ac6, 0xff567ac6,
    0xff5579c5, 0xff5479c3, 0xff5378c1, 0xff5378bf, 0xff8598c4, 0xff8598c4, 0xff8697c4, 0xff8797c4,
    0xff8898c5, 0xff8899c6, 0xff889ac7, 0xff879ac9, 0xff879ac9, 0xff889ac8, 0xff889ac8, 0xff899ac8,
    0xff899ac9, 0xff899aca, 0xff899bcb, 0xff899bcb, 0xff889cca, 0xff8a9cca, 0xff8c9dcb, 0xff8e9ecc,
    0xff8e9fce, 0xff8ea1ce, 0xff90a3cd, 0xff92a6cc, 0xff96a7cb, 0xff99a8cb, 0xff9ba9cb, 0xff9caacd,
    0xff9daacd, 0xff9faacb, 0xffa1aaca, 0xffa2abcb, 0xffa3accd, 0xffa4accd, 0xffa5abcd, 0xffa6abcd,
    0xffa7abcc, 0xffa7abcc, 0xffa7aacd, 0xffa7aace, 0xffa6aace, 0xffa5aace, 0xffa5aacd, 0xffa6abcc,
    0xffa6abcd, 0xffa5aacf, 0xffa5aad1, 0xffa5aad1, 0xffa5abd0, 0xffa6acd0, 0xffa6acd1, 0xffa6acd1,
    0xffa5acd1, 0xffa5acd1, 0xffa6add2, 0xffa6add2, 0xffa6aed3, 0xffa5aed3, 0xffa4aed3, 0xffa4add2,
    0xffa5add2, 0xffa7add3, 0xffa7add3, 0xffa6aed3, 0xffa6aed3, 0xffa7afd4, 0xffa7afd4, 0xffa6aed4,
    0xffa5add3, 0xffa5add3, 0xffa5aed2, 0xffa5aed2, 0xffa4add3, 0xffa4acd3, 0xffa5acd4, 0xffa5acd4,
    0xffa4acd3, 0xffa3abd1, 0xffa3aad1, 0xffa3a9d3, 0xffa3a9d3, 0xffa2a9d2, 0xffa1a9d1, 0xffa0a8d1,
    0xffa0a7d2, 0xffa0a8d3, 0xffa0a9d3, 0xffa0a9d3, 0xffa0a9d3, 0xffa0a9d3, 0xffa0a8d1, 0xff9fa7d1,
    0xff9ca6d2, 0xff9aa5d3, 0xff99a4d2, 0xff99a4d1, 0xff99a4d1, 0xff98a4d2, 0xff97a4d2, 0xff96a4d2,
    0xff95a3d2, 0xff95a2d2, 0xff95a1d1, 0xff949fd0, 0xff929ecf, 0xff919ece, 0xff919ecd, 0xff919ecd,
    0xff909dcd, 0xff909ccd, 0xff8e9bcd, 0xff8e9bcd, 0xff8f9acd, 0xff909acd, 0xff8f9ace, 0xff8e9acf,
    0xff8c99cf, 0xff8c98cf, 0xff8b97ce, 0xff8997cc, 0xff8797cb, 0xff8695cd, 0xff8593d0, 0xff8492d0,
    0xff8391ce, 0xff8391cd, 0xff8391ce, 0xff8391ce, 0xff8491ce, 0xff8491cd, 0xff8290cb, 0xff808fca,
    0xff828fca, 0xff8590ca, 0xff8790cc, 0xff8691cd, 0xff8591cd, 0xff8492cd, 0xff8292cc, 0xff8091cb,
    0xff7e91cb, 0xff7e91cb, 0xff8092cb, 0xff8094cb, 0xff7f95c9, 0xff7e95c9, 0xff7c95ca, 0xff7b94cb,
    0xff7a93cb, 0xff7991cb, 0xff7590cc, 0xff7190cc, 0xff6d8ece, 0xff6c8dcf, 0xff698bcf, 0xff6688ce,
    0xff6386cd, 0xff6184ce, 0xff6082cf, 0xff5f82d0, 0xff5f82d1, 0xff5f82d1, 0xff5e81d1, 0xff5e81d0,
    0xff5d81ce, 0xff5c81cd, 0xff5c80cd, 0xff5c7fcd, 0xff5b7fcc, 0xff5a7ecb, 0xff597dc9, 0xff587cc8,
    0xff587bc7, 0xff577bc7, 0xff577bc7, 0xff577bc7, 0xff567ac6, 0xff557ac4, 0xff5479c1, 0xff5479bf,
    0xff8598c5, 0xff8598c5, 0xff8697c4, 0xff8797c4, 0xff8898c5, 0xff8999c7, 0xff899ac8, 0xff889bc9,
    0xff889bc9, 0xff889ac9, 0xff889ac9, 0xff899ac9, 0xff899bc9, 0xff899cca, 0xff8a9dcb, 0xff8b9eca,
    0xff8b9fc9, 0xff8d9fc9, 0xff8e9fca, 0xff8fa0cb, 0xff90a2cc, 0xff91a4cc, 0xff93a6cc, 0xff95a7cb,
    0xff99a8ca, 0xff9ca8ca, 0xff9ea8ca, 0xff9ea9cc, 0xff9ea9cc, 0xff9fa8ca, 0xffa0a8c9, 0xffa1a8ca,
    0xffa2a9cc, 0xffa3a9cc, 0xffa4a9cc, 0xffa4a9cc, 0xffa5a9cb, 0xffa5a9cb, 0xffa5a8cc, 0xffa5a8cd,
    0xffa4a8ce, 0xffa3a8ce, 0xffa3a9cd, 0xffa4aacc, 0xffa4aacd, 0xffa3aacf, 0xffa3aad1, 0xffa3abd1,
    0xffa3abd0, 0xffa3acd0, 0xffa4acd1, 0xffa4acd1, 0xffa4acd1, 0xffa4acd1, 0xffa5add2, 0xffa5add2,
    0xffa5aed3, 0xffa5aed3, 0xffa4aed3, 0xffa4add2, 0xffa5add2, 0xffa6add3, 0xffa6add3, 0xffa6aed3,
    0xffa6aed3, 0xffa7afd4, 0xffa7afd4, 0xffa6aed4, 0xffa5add3, 0xffa5add3, 0xffa5aed2, 0xffa5aed2,
    0xffa4add3, 0xffa4acd3, 0xffa5acd3, 0xffa5acd3, 0xffa4acd2, 0xffa3abd2, 0xffa3abd2, 0xffa3aad3,
    0xffa3aad3, 0xffa3aad2, 0xffa2aad1, 0xffa1a9d1, 0xffa0a8d2, 0xffa0a9d3, 0xffa0aad3, 0xffa0aad3,
    0xffa0a9d2, 0xffa0a9d2, 0xffa0a8d1, 0xff9fa8d1, 0xff9ca8d2, 0xff9aa7d3, 0xff99a6d2, 0xff99a5d1,
    0xff99a5d1, 0xff98a5d1, 0xff98a5d1, 0xff97a5d1, 0xff96a4d1, 0xff95a3d1, 0xff95a2d1, 0xff94a0d1,
    0xff939fd0, 0xff939fcf, 0xff929fce, 0xff929ecd, 0xff919dcd, 0xff909ccd, 0xff8f9bce, 0xff8e9bce,
    0xff8f9ace, 0xff8f9ace, 0xff8e9ace, 0xff8c9acf, 0xff8a99cf, 0xff8a98cf, 0xff8997ce, 0xff8797cd,
    0xff8696cd, 0xff8494cf, 0xff8292d0, 0xff8191cf, 0xff8190ce, 0xff8190cd, 0xff8290ce, 0xff8290ce,
    0xff8291ce, 0xff8291cd, 0xff8190cb, 0xff7f8fca, 0xff7f8eca, 0xff7f8eca, 0xff818ecc, 0xff828fcd,
    0xff828fcd, 0xff8290cc, 0xff8190cb, 0xff808fca, 0xff7f8fca, 0xff8090ca, 0xff8191ca, 0xff8293ca,
    0xff8293c9, 0xff8194c9, 0xff8095c9, 0xff7f95ca, 0xff7f94cb, 0xff7e93cb, 0xff7a93cb, 0xff7693cb,
    0xff7191cc, 0xff6e8fce, 0xff6b8dcf, 0xff688bcf, 0xff6489ce, 0xff6186cf, 0xff5e83d0, 0xff5d82d1,
    0xff5d82d3, 0xff5d82d3, 0xff5d81d3, 0xff5d80d2, 0xff5c80d0, 0xff5c80cf, 0xff5c80ce, 0xff5c7fcd,
    0xff5b7fcc, 0xff5a7fcb, 0xff5a7ec9, 0xff597dc8, 0xff597cc8, 0xff587cc8, 0xff577cc8, 0xff577bc7,
    0xff577ac6, 0xff567ac5, 0xff557ac3, 0xff557ac2, 0xff8698c5, 0xff8698c5, 0xff8697c5, 0xff8797c5,
    0xff8898c7, 0xff8999c9, 0xff899ac9, 0xff899bc8, 0xff899bc8, 0xff889bc9, 0xff889bc9, 0xff889bc9,
    0xff899cc9, 0xff8a9dca, 0xff8b9eca, 0xff8c9fca, 0xff8da0c9, 0xff8fa1c9, 0xff8fa2c9, 0xff90a2c9,
    0xff92a4c9, 0xff94a5c9, 0xff96a7c9, 0xff99a8ca, 0xff9ba8ca, 0xff9da8ca, 0xff9fa8ca, 0xff9fa7cb,
    0xff9fa6cb, 0xff9ea6ca, 0xff9ea6ca, 0xff9fa6ca, 0xffa0a7cb, 0xffa0a7cc, 0xffa1a7cc, 0xffa1a7cc,
    0xffa2a7cb, 0xffa3a7cb, 0xffa3a7cb, 0xffa3a7cc, 0xffa2a7cd, 0xffa2a8cd, 0xffa2a9cd, 0xffa3aacd,
    0xffa3aace, 0xffa2aacf, 0xffa2aad0, 0xffa3abd0, 0xffa3abd0, 0xffa3acd0, 0xffa3acd1, 0xffa3acd1,
    0xffa4acd1, 0xffa4acd1, 0xffa3add1, 0xffa3add1, 0xffa5aed2, 0xffa6aed3, 0xffa5aed3, 0xffa4add2,
    0xffa4add2, 0xffa6add2, 0xffa6add2, 0xffa6aed3, 0xffa6aed3, 0xffa6afd3, 0xffa6afd3, 0xffa5afd3,
    0xffa5aed3, 0xffa5aed3, 0xffa6aed3, 0xffa6aed3, 0xffa5add2, 0xffa4acd2, 0xffa4add2, 0xffa4add2,
    0xffa4add2, 0xffa4acd2, 0xffa4acd2, 0xffa4abd2, 0xffa4abd2, 0xffa3abd2, 0xffa2abd2, 0xffa1aad2,
    0xffa1aad2, 0xffa1aad3, 0xffa1aad3, 0xffa1a9d2, 0xffa0a8d1, 0xffa0a8d1, 0xff9fa8d2, 0xff9ea8d2,
    0xff9ca8d2, 0xff9aa8d2, 0xff99a7d1, 0xff99a6d0, 0xff99a6d0, 0xff99a6d0, 0xff99a6d0, 0xff98a5d1,
    0xff97a4d1, 0xff96a3d1, 0xff95a3d1, 0xff94a2d1, 0xff94a1d0, 0xff94a0cf, 0xff93a0cf, 0xff929ecd,
    0xff919ecc, 0xff909dcc, 0xff8f9ccd, 0xff8f9cce, 0xff8f9bce, 0xff8e9ace, 0xff8d9ace, 0xff8b9ace,
    0xff8a9ace, 0xff8998cf, 0xff8997cf, 0xff8896cf, 0xff8695cf, 0xff8394cf, 0xff8192cf, 0xff8091cf,
    0xff8191ce, 0xff8191ce, 0xff8291cd, 0xff8291cd, 0xff8291cd, 0xff8191cc, 0xff8190cb, 0xff808fca,
    0xff7e8eca, 0xff7c8ccc, 0xff7b8ccc, 0xff7d8ccc, 0xff7e8dcc, 0xff7f8ecc, 0xff7f8ecb, 0xff7f8eca,
    0xff7f8eca, 0xff808fca, 0xff818fca, 0xff8190ca, 0xff8291c9, 0xff8292c9, 0xff8294ca, 0xff8195ca,
    0xff8194ca, 0xff8093ca, 0xff7c93ca, 0xff7893ca, 0xff7492cb, 0xff7191cd, 0xff6d8fce, 0xff698ece,
    0xff658cce, 0xff6189cf, 0xff5e85d0, 0xff5c83d1, 0xff5c82d3, 0xff5c81d3, 0xff5d81d3, 0xff5e80d2,
    0xff5e7fd1, 0xff5d7fd0, 0xff5d7fce, 0xff5c7fcc, 0xff5c7fcb, 0xff5b7fca, 0xff5b7fc9, 0xff5a7ec9,
    0xff597ec8, 0xff577ec8, 0xff567dc8, 0xff567cc7, 0xff577bc6, 0xff567ac5, 0xff557ac4, 0xff557ac4,
    0xff8698c6, 0xff8698c6, 0xff8698c6, 0xff8798c6, 0xff8899c8, 0xff8a9aca, 0xff8a9bca, 0xff8a9cc8,
    0xff8a9cc8, 0xff899cc9, 0xff899cc9, 0xff899dc9, 0xff8a9ec9, 0xff8b9fc9, 0xff8da0c9, 0xff8fa1c9,
    0xff90a3c8, 0xff91a3c8, 0xff91a3c8, 0xff92a3c8, 0xff95a5c7, 0xff97a6c7, 0xff99a7c8, 0xff9ba7c9,
    0xff9ca7ca, 0xff9ea6ca, 0xff9ea6ca, 0xff9ea5ca, 0xff9ea4ca, 0xff9da4ca, 0xff9ca4ca, 0xff9da4ca,
    0xff9ea4cb, 0xff9ea4cb, 0xff9ea5cb, 0xff9ea5cb, 0xff9fa5cb, 0xffa0a5cb, 0xffa1a6cc, 0xffa1a6cc,
    0xffa1a6cd, 0xffa1a7cd, 0xffa1a8cd, 0xffa1a9cd, 0xffa1a9cd, 0xffa1aace, 0xffa1aacf, 0xffa2abd0,
    0xffa2abd0, 0xffa2acd0, 0xffa2acd0, 0xffa2acd0, 0xffa3acd1, 0xffa3acd1, 0xffa2add0, 0xffa2add0,
    0xffa4aed2, 0xffa6aed3, 0xffa6aed3, 0xffa5add2, 0xffa5add2, 0xffa5add2, 0xffa5add2, 0xffa6aed3,
    0xffa6aed3, 0xffa6aed3, 0xffa6aed3, 0xffa6aed3, 0xffa6aed3, 0xffa6aed3, 0xffa6aed3, 0xffa6aed3,
    0xffa5add2, 0xffa4add2, 0xffa4add1, 0xffa4add1, 0xffa4add2, 0xffa4acd3, 0xffa4acd3, 0xffa4acd2,
    0xffa4acd2, 0xffa3acd2, 0xffa3acd2, 0xffa2acd2, 0xffa2abd2, 0xffa2abd2, 0xffa1aad2, 0xffa1a9d1,
    0xffa0a8d0, 0xffa0a8d0, 0xff9fa8d1, 0xff9ea8d2, 0xff9ca9d2, 0xff9ba9d1, 0xff9aa8d1, 0xff9aa7d0,
    0xff9aa7d0, 0xff99a6cf, 0xff99a6cf, 0xff99a5d0, 0xff98a4d0, 0xff96a3d1, 0xff95a3d1, 0xff95a3d1,
    0xff95a2d0, 0xff95a1d0, 0xff94a1cf, 0xff939fce, 0xff929ecd, 0xff919dcc, 0xff909cce, 0xff909ccf,
    0xff8f9bcf, 0xff8d9acf, 0xff8b9ace, 0xff8a9acd, 0xff889acd, 0xff8898ce, 0xff8897cf, 0xff8796d1,
    0xff8695d1, 0xff8394d0, 0xff8193ce, 0xff8193ce, 0xff8292ce, 0xff8292ce, 0xff8291cd, 0xff8291cc,
    0xff8191cc, 0xff8091cc, 0xff8091cb, 0xff7f90cb, 0xff7c8ecc, 0xff778ccd, 0xff768acd, 0xff788acd,
    0xff7a8bcc, 0xff7b8ccb, 0xff7c8dcb, 0xff7d8dca, 0xff7e8dca, 0xff7e8dca, 0xff7f8eca, 0xff7f8eca,
    0xff808eca, 0xff818fca, 0xff8292c9, 0xff8293c9, 0xff8293ca, 0xff8092ca, 0xff7e92c9, 0xff7b93c8,
    0xff7792c9, 0xff7390cb, 0xff6f8fcd, 0xff6c8fce, 0xff688ece, 0xff638bcf, 0xff5e88d0, 0xff5c85d1,
    0xff5c84d3, 0xff5c82d3, 0xff5d82d3, 0xff5e81d2, 0xff5e80d2, 0xff5d7fd1, 0xff5d7fcf, 0xff5c7fcc,
    0xff5c7fcb, 0xff5b7fca, 0xff5b7fca, 0xff5a7fc9, 0xff597fc9, 0xff577ec9, 0xff567dc8, 0xff567cc7,
    0xff577bc6, 0xff577ac6, 0xff567ac6, 0xff567ac6, 0xff8698c6, 0xff8698c6, 0xff8698c6, 0xff8799c7,
    0xff899ac9, 0xff8b9bcb, 0xff8b9ccb, 0xff8b9eca, 0xff8b9ec9, 0xff8b9ec8, 0xff8b9ec8, 0xff8c9fc8,
    0xff8da0c8, 0xff8ea0c9, 0xff8fa1c9, 0xff90a2c9, 0xff92a3c8, 0xff94a4c8, 0xff94a4c7, 0xff95a4c7,
    0xff97a5c6, 0xff99a5c6, 0xff9ba6c7, 0xff9ca6c9, 0xff9da6c9, 0xff9da5c9, 0xff9da3c9, 0xff9da3ca,
    0xff9da2ca, 0xff9ba2ca, 0xff9aa2ca, 0xff9ba2cb, 0xff9ca2cb, 0xff9ca3cb, 0xff9ca4ca, 0xff9da4ca,
    0xff9ea5cb, 0xff9fa5cb, 0xffa0a6cc, 0xffa0a6cc, 0xffa0a6cd, 0xffa0a7cd, 0xffa0a7cd, 0xffa0a8cc,
    0xffa0a8cc, 0xffa1a9ce, 0xffa1a9cf, 0xffa2aacf, 0xffa2aacf, 0xffa2abcf, 0xffa1abcf, 0xffa1abcf,
    0xffa2abd0, 0xffa2abd0, 0xffa2abcf, 0xffa2accf, 0xffa5add1, 0xffa6aed3, 0xffa6aed3, 0xffa5add2,
    0xffa5add2, 0xffa5add2, 0xffa5add2, 0xffa6aed3, 0xffa6aed3, 0xffa6aed3, 0xffa6aed3, 0xffa6aed3,
    0xffa6aed3, 0xffa6aed3, 0xffa6aed3, 0xffa6aed3, 0xffa5aed2, 0xffa5aed2, 0xffa4aed1, 0xffa4add1,
    0xffa4acd2, 0xffa4acd3, 0xffa4acd3, 0xffa5add2, 0xffa5add2, 0xffa5acd2, 0xffa4acd2, 0xffa4acd3,
    0xffa3acd3, 0xffa2abd2, 0xffa1aad1, 0xffa1a9d0, 0xffa0a8d0, 0xffa0a8d0, 0xff9fa8d1, 0xff9ea8d2,
    0xff9da9d2, 0xff9ca9d1, 0xff9ba8d1, 0xff9ba7d1, 0xff9ba7d0, 0xff9aa6cf, 0xff9aa6cf, 0xff9aa5cf,
    0xff99a4d0, 0xff97a3d1, 0xff96a3d1, 0xff96a3d1, 0xff96a2d0, 0xff96a1d0, 0xff95a1d0, 0xff949fcf,
    0xff939ecd, 0xff929dcc, 0xff929cce, 0xff919cd0, 0xff8f9bd0, 0xff8d9acf, 0xff8c9ace, 0xff8b9acd,
    0xff899acd, 0xff8898ce, 0xff8797cf, 0xff8696d1, 0xff8595d2, 0xff8394d0, 0xff8293ce, 0xff8293ce,
    0xff8393ce, 0xff8393ce, 0xff8292cd, 0xff8191cc, 0xff8091cb, 0xff7f91cb, 0xff7f91cb, 0xff7d90cb,
    0xff7a8ecc, 0xff758bcd, 0xff7489cd, 0xff7689cd, 0xff7889cd, 0xff798bcc, 0xff7a8ccb, 0xff7b8cca,
    0xff7c8cca, 0xff7c8cca, 0xff7d8dc9, 0xff7e8dc9, 0xff7f8dc9, 0xff808dc9, 0xff8190c8, 0xff8191c8,
    0xff8191c9, 0xff7f90ca, 0xff7e90c9, 0xff7c91c7, 0xff7891c7, 0xff7590c9, 0xff728fcb, 0xff6f90cd,
    0xff6b8fce, 0xff658ccf, 0xff6089d0, 0xff5d86d1, 0xff5d85d2, 0xff5d84d2, 0xff5e84d2, 0xff5e83d1,
    0xff5e81d1, 0xff5d80d0, 0xff5c7fce, 0xff5b7fcc, 0xff5b7fcb, 0xff5a7eca, 0xff5a7eca, 0xff597fca,
    0xff597fca, 0xff587ec9, 0xff577dc8, 0xff577cc7, 0xff577bc7, 0xff577ac7, 0xff567ac7, 0xff567ac7,
    0xff8698c6, 0xff8698c6, 0xff8798c7, 0xff8899c8, 0xff899bca, 0xff8b9dcb, 0xff8c9ecb, 0xff8c9fcb,
    0xff8ca0ca, 0xff8ca1c9, 0xff8da1c8, 0xff8fa2c8, 0xff90a2c8, 0xff90a2c8, 0xff90a2c8, 0xff91a3c8,
    0xff94a4c8, 0xff96a4c8, 0xff96a4c7, 0xff97a4c7, 0xff99a3c7, 0xff9aa3c7, 0xff9ba3c8, 0xff9ca4c9,
    0xff9ca4c9, 0xff9ba3c9, 0xff9ba3c9, 0xff9ca2ca, 0xff9ca2ca, 0xff9aa1ca, 0xff99a1ca, 0xff99a1cb,
    0xff9aa1cc, 0xff9aa2cb, 0xff9aa2ca, 0xff9ca4ca, 0xff9ea4cb, 0xff9fa5cc, 0xff9fa6cd, 0xff9fa7cd,
    0xff9ea7cd, 0xff9ea7cd, 0xff9ea7cc, 0xff9fa7cb, 0xffa0a7cb, 0xffa1a7cd, 0xffa1a8ce, 0xffa2a9cf,
    0xffa2aacf, 0xffa1aacf, 0xffa0aacf, 0xffa0aacf, 0xffa1abcf, 0xffa1abcf, 0xffa1accf, 0xffa2accf,
    0xffa4add2, 0xffa5add3, 0xffa5add3, 0xffa5add2, 0xffa5add2, 0xffa5add2, 0xffa5add2, 0xffa5add2,
    0xffa5add2, 0xffa6add2, 0xffa6add2, 0xffa6aed2, 0xffa6aed3, 0xffa6aed3, 0xffa6add3, 0xffa6add3,
    0xffa5aed3, 0xffa5aed3, 0xffa5aed2, 0xffa5add2, 0xffa4acd2, 0xffa4acd2, 0xffa4acd2, 0xffa5add2,
    0xffa5add2, 0xffa4acd2, 0xffa4acd2, 0xffa4acd4, 0xffa4acd4, 0xffa3abd2, 0xffa2aad0, 0xffa1aacf,
    0xff9fa9d0, 0xff9fa9d0, 0xff9fa8d1, 0xff9fa8d1, 0xff9da8d1, 0xff9ca8d1, 0xff9ca8d1, 0xff9da7d1,
    0xff9ca7d1, 0xff9ba6d0, 0xff9aa6d0, 0xff99a5d1, 0xff99a4d1, 0xff98a4d1, 0xff97a4d1, 0xff96a3d0,
    0xff96a2cf, 0xff96a2cf, 0xff95a1d0, 0xff94a0cf, 0xff939fce, 0xff929ecd, 0xff929dcf, 0xff919dd1,
    0xff8f9cd1, 0xff8d9bcf, 0xff8c9bce, 0xff8c9bcd, 0xff8a9acd, 0xff8899cd, 0xff8797ce, 0xff8596d1,
    0xff8495d2, 0xff8394d1, 0xff8394ce, 0xff8394ce, 0xff8495ce, 0xff8394ce, 0xff8292cd, 0xff8091cc,
    0xff7f91cb, 0xff7e91ca, 0xff7d90ca, 0xff7b8fca, 0xff798ecb, 0xff768ccc, 0xff758ace, 0xff7689ce,
    0xff7789ce, 0xff788bcd, 0xff798dcc, 0xff798ccc, 0xff7a8bcb, 0xff7b8bca, 0xff7c8cc8, 0xff7c8cc8,
    0xff7d8cc9, 0xff7d8cc9, 0xff7f8dc8, 0xff7f8ec8, 0xff7e8ec8, 0xff7c8ec9, 0xff7b8ec9, 0xff7a8ec8,
    0xff788ec8, 0xff758ec9, 0xff728eca, 0xff708fcc, 0xff6d8ecd, 0xff678cce, 0xff6189cf, 0xff5e88d0,
    0xff5e87d0, 0xff5e87d0, 0xff5e86cf, 0xff5e85cf, 0xff5e83cf, 0xff5d81cf, 0xff5c7fce, 0xff5a7ecd,
    0xff5a7dcc, 0xff5a7dca, 0xff5a7dca, 0xff5a7ecb, 0xff597ecb, 0xff587dca, 0xff577cc8, 0xff577cc7,
    0xff587cc7, 0xff577cc7, 0xff567bc7, 0xff567bc7, 0xff8799c7, 0xff8799c7, 0xff889ac8, 0xff899bc9,
    0xff8a9dca, 0xff8c9fca, 0xff8da0ca, 0xff8ea1ca, 0xff8ea2c9, 0xff8fa3c8, 0xff90a3c7, 0xff92a3c7,
    0xff93a3c7, 0xff92a2c7, 0xff92a2c8, 0xff93a2c8, 0xff95a3c8, 0xff97a3c8, 0xff98a3c7, 0xff99a3c7,
    0xff9aa2c7, 0xff9aa1c8, 0xff9ba1c9, 0xff9ba2c9, 0xff9aa2c9, 0xff99a1c9, 0xff99a1c9, 0xff9aa1ca,
    0xff9aa1cb, 0xff99a0cb, 0xff98a0cb, 0xff98a0cc, 0xff98a1cc, 0xff98a2cb, 0xff99a2ca, 0xff9ba4ca,
    0xff9da5cc, 0xff9ea6cd, 0xff9ea7cd, 0xff9ea7cd, 0xff9da7cd, 0xff9da7cd, 0xff9da7cc, 0xff9ea6cb,
    0xff9fa6cb, 0xffa0a6cd, 0xffa0a7ce, 0xffa2a8ce, 0xffa2a9ce, 0xffa1a9ce, 0xffa0a9ce, 0xffa0a9ce,
    0xffa0aace, 0xffa1aace, 0xffa2abce, 0xffa3abcf, 0xffa4acd1, 0xffa4add2, 0xffa5add2, 0xffa5add2,
    0xffa5add2, 0xffa5add2, 0xffa5add2, 0xffa5add2, 0xffa5add2, 0xffa6add2, 0xffa6add2, 0xffa6aed3,
    0xffa6aed3, 0xffa6aed3, 0xffa5add2, 0xffa5add2, 0xffa6aed3, 0xffa6aed3, 0xffa6aed3, 0xffa5add2,
    0xffa4acd1, 0xffa4acd1, 0xffa4acd1, 0xffa5add2, 0xffa5add2, 0xffa4acd1, 0xffa4abd1, 0xffa4acd3,
    0xffa4acd4, 0xffa3abd2, 0xffa2aad0, 0xffa1aad0, 0xff9fa9d1, 0xff9fa9d1, 0xff9fa8d1, 0xff9fa8d1,
    0xff9ea7d2, 0xff9da7d2, 0xff9ea7d2, 0xff9ea7d2, 0xff9da7d2, 0xff9ca6d1, 0xff9aa6d1, 0xff9aa5d1,
    0xff99a4d1, 0xff98a4d1, 0xff98a4d1, 0xff98a3d0, 0xff97a2cf, 0xff96a2cf, 0xff96a1d0, 0xff95a0d0,
    0xff949fce, 0xff939ece, 0xff929dd0, 0xff919dd1, 0xff909cd0, 0xff8e9bcf, 0xff8d9bce, 0xff8d9bce,
    0xff8b9ace, 0xff8998ce, 0xff8797ce, 0xff8596d0, 0xff8496d1, 0xff8495d0, 0xff8595ce, 0xff8696ce,
    0xff8696ce, 0xff8495ce, 0xff8193cd, 0xff7f91cc, 0xff7e91cb, 0xff7d91ca, 0xff7c90ca, 0xff7a8fca,
    0xff798ecb, 0xff778dcb, 0xff778bcd, 0xff7789ce, 0xff7789ce, 0xff788bcd, 0xff788dcc, 0xff788ccc,
    0xff788bcb, 0xff788bca, 0xff798bc9, 0xff798bc8, 0xff7a8bc8, 0xff7a8bc8, 0xff7c8bc7, 0xff7c8bc7,
    0xff7b8bc8, 0xff798bc9, 0xff788bc9, 0xff788ac9, 0xff768ac9, 0xff748bc9, 0xff728cc9, 0xff708cca,
    0xff6e8ccc, 0xff698bcd, 0xff6489ce, 0xff6189ce, 0xff6189ce, 0xff6189ce, 0xff6088cd, 0xff6087cd,
    0xff5f85cd, 0xff5e83cd, 0xff5c81cd, 0xff5a7fcd, 0xff597ecc, 0xff597dca, 0xff597dca, 0xff597dcb,
    0xff597dcb, 0xff587cc9, 0xff587cc8, 0xff587cc8, 0xff587cc8, 0xff587cc8, 0xff577bc7, 0xff577bc7,
    0xff889bc8, 0xff889bc8, 0xff899cc9, 0xff8a9dca, 0xff8b9fca, 0xff8da2c9, 0xff8ea3c9, 0xff90a4c9,
    0xff92a4c9, 0xff92a4c8, 0xff93a4c7, 0xff94a4c6, 0xff95a4c6, 0xff95a3c6, 0xff95a2c7, 0xff96a2c8,
    0xff97a2c8, 0xff98a2c8, 0xff99a1c7, 0xff99a1c7, 0xff9aa0c8, 0xff9aa0c9, 0xff9aa0c9, 0xff9aa1c9,
    0xff99a1c9, 0xff98a0c9, 0xff97a0c9, 0xff97a1ca, 0xff97a1cb, 0xff96a0cc, 0xff96a0cc, 0xff96a0cc,
    0xff97a1cc, 0xff98a2cb, 0xff98a2cb, 0xff9aa4cc, 0xff9ba5cd, 0xff9ca6ce, 0xff9ca6ce, 0xff9ca6cd,
    0xff9ba6cd, 0xff9ba6cd, 0xff9ca6cc, 0xff9ea6cb, 0xff9fa6cb, 0xff9ea6cd, 0xff9ea7ce, 0xffa0a8ce,
    0xffa1a9ce, 0xffa0a9ce, 0xff9fa8ce, 0xff9fa8ce, 0xff9fa9ce, 0xffa1aace, 0xffa2abce, 0xffa3abcf,
    0xffa3acd0, 0xffa3add1, 0xffa4add2, 0xffa5add2, 0xffa5add2, 0xffa5add2, 0xffa5add2, 0xffa6aed3,
    0xffa6aed3, 0xffa6add2, 0xffa6add2, 0xffa6add2, 0xffa6aed3, 0xffa6aed3, 0xffa5add2, 0xffa5add2,
    0xffa6aed3, 0xffa6aed3, 0xffa6aed3, 0xffa5add2, 0xffa4acd1, 0xffa4acd1, 0xffa4acd1, 0xffa4acd1,
    0xffa4acd1, 0xffa4abd1, 0xffa4abd1, 0xffa4acd3, 0xffa4acd4, 0xffa3abd2, 0xffa2aad0, 0xffa1aad0,
    0xffa0a9d1, 0xffa0a9d1, 0xffa0a8d1, 0xffa0a8d1, 0xff9fa7d2, 0xff9ea7d3, 0xff9ea7d3, 0xff9ea7d2,
    0xff9ea7d2, 0xff9da6d1, 0xff9ba6d1, 0xff9aa5d0, 0xff99a5d0, 0xff99a5d1, 0xff99a4d1, 0xff99a3d0,
    0xff98a2cf, 0xff97a2cf, 0xff97a2d0, 0xff96a2d0, 0xff95a0cf, 0xff949fcf, 0xff929ed0, 0xff919dd1,
    0xff909cd1, 0xff8e9bd0, 0xff8d9bd0, 0xff8d9bcf, 0xff8b9acf, 0xff8999ce, 0xff8798ce, 0xff8597cf,
    0xff8597d0, 0xff8596cf, 0xff8696ce, 0xff8696ce, 0xff8696cd, 0xff8495cd, 0xff8193cc, 0xff7f91cc,
    0xff7d91cb, 0xff7d91ca, 0xff7c91ca, 0xff7b90ca, 0xff7a8fca, 0xff798eca, 0xff778ccb, 0xff778acc,
    0xff778acd, 0xff788ccd, 0xff788dcd, 0xff788ccc, 0xff778bcb, 0xff778aca, 0xff768ac9, 0xff768ac9,
    0xff768ac8, 0xff778ac8, 0xff7989c6, 0xff7989c6, 0xff7989c7, 0xff7789c9, 0xff7688ca, 0xff7587cb,
    0xff7387cb, 0xff7188ca, 0xff7089c9, 0xff6f8aca, 0xff6e8acb, 0xff6a8acc, 0xff6689cd, 0xff6589cd,
    0xff658acc, 0xff658acc, 0xff648acc, 0xff6389cc, 0xff6187cc, 0xff5e85cc, 0xff5c83cd, 0xff5a80cd,
    0xff597fcd, 0xff597dcc, 0xff597dcb, 0xff597cca, 0xff597cca, 0xff587cc9, 0xff587cc9, 0xff587dc9,
    0xff587dc9, 0xff587dc8, 0xff587cc7, 0xff587cc6, 0xff899dca, 0xff899dca, 0xff8b9ecb, 0xff8ca0cb,
    0xff8da2c9, 0xff8fa4c7, 0xff90a5c7, 0xff92a5c7, 0xff94a5c7, 0xff95a4c7, 0xff95a4c7, 0xff96a4c6,
    0xff96a4c6, 0xff96a3c6, 0xff96a2c7, 0xff97a1c7, 0xff99a0c7, 0xff99a0c7, 0xff989fc8, 0xff989fc8,
    0xff99a0c9, 0xff99a0c9, 0xff99a0ca, 0xff99a0ca, 0xff98a0ca, 0xff979fca, 0xff969fca, 0xff95a0cb,
    0xff95a1cc, 0xff95a1cd, 0xff95a1cd, 0xff95a1cd, 0xff96a2cc, 0xff97a2cc, 0xff98a3cc, 0xff99a3cd,
    0xff99a4ce, 0xff99a5cf, 0xff9aa5cd, 0xff9ba5cc, 0xff9aa5cc, 0xff9aa5cc, 0xff9ba5cc, 0xff9da6cc,
    0xff9ea6cc, 0xff9da7cd, 0xff9da8cd, 0xff9eaace, 0xff9faace, 0xff9fa9ce, 0xff9fa8cd, 0xff9fa8cd,
    0xffa0aace, 0xffa1aace, 0xffa2aacf, 0xffa3aad0, 0xffa3abd1, 0xffa3acd1, 0xffa3acd1, 0xffa4acd1,
    0xffa4acd1, 0xffa5add2, 0xffa6aed3, 0xffa7afd4, 0xffa7afd4, 0xffa7afd4, 0xffa6aed3, 0xffa6aed3,
    0xffa6aed3, 0xffa5add2, 0xffa4acd1, 0xffa4acd1, 0xffa5add2, 0xffa6aed2, 0xffa6aed1, 0xffa5add1,
    0xffa4acd1, 0xffa4acd1, 0xffa4acd1, 0xffa4acd1, 0xffa4acd1, 0xffa4abd0, 0xffa4abd0, 0xffa4acd2,
    0xffa4acd3, 0xffa3abd2, 0xffa2a9d1, 0xffa1a9d1, 0xffa0a9d1, 0xffa0a9d1, 0xffa0a9d2, 0xffa0a9d2,
    0xffa0a9d3, 0xff9fa8d3, 0xff9ea7d2, 0xff9da6d1, 0xff9ea6d1, 0xff9ea6d1, 0xff9da6d1, 0xff9aa5d0,
    0xff98a5cf, 0xff98a5d0, 0xff99a5d0, 0xff99a4d0, 0xff98a3cf, 0xff97a3cf, 0xff97a2cf, 0xff96a1cf,
    0xff95a0d0, 0xff949fd0, 0xff929ed0, 0xff919dd0, 0xff909cd1, 0xff8f9cd1, 0xff8e9cd1, 0xff8d9bd0,
    0xff8b9bcf, 0xff899ace, 0xff8899ce, 0xff8698ce, 0xff8697ce, 0xff8797ce, 0xff8797cd, 0xff8697cd,
    0xff8596cc, 0xff8394cc, 0xff8293cc, 0xff8192cc, 0xff7e92cb, 0xff7d92cb, 0xff7d92cb, 0xff7d91cb,
    0xff7c90ca, 0xff7a90c9, 0xff788ec9, 0xff778dcb, 0xff778ccc, 0xff788dcd, 0xff788dcd, 0xff778ccc,
    0xff768bcb, 0xff758bcb, 0xff748acb, 0xff748acb, 0xff7489ca, 0xff7489c9, 0xff7689c7, 0xff7789c6,
    0xff7788c7, 0xff7587ca, 0xff7386cc, 0xff7184cd, 0xff6f84cd, 0xff6e86cb, 0xff6e87ca, 0xff6e88ca,
    0xff6e88ca, 0xff6b88cb, 0xff6888cc, 0xff6889cc, 0xff698acb, 0xff698acb, 0xff688bcb, 0xff668acb,
    0xff6288cb, 0xff5f86cb, 0xff5c84cc, 0xff5a82cc, 0xff5a80cc, 0xff5a7fcb, 0xff5a7dca, 0xff597cc9,
    0xff597cc9, 0xff587cc9, 0xff587cca, 0xff587dcb, 0xff587dca, 0xff597dc8, 0xff5a7cc6, 0xff5a7cc4,
    0xff8b9fca, 0xff8b9fca, 0xff8da1cb, 0xff8ea2cb, 0xff8fa4c9, 0xff91a5c6, 0xff92a6c5, 0xff94a6c6,
    0xff96a6c6, 0xff97a5c7, 0xff97a4c7, 0xff96a3c6, 0xff96a3c6, 0xff96a2c6, 0xff97a1c6, 0xff98a0c6,
    0xff989fc7, 0xff989dc7, 0xff979dc8, 0xff969dc8, 0xff969ec9, 0xff979fc9, 0xff979fc9, 0xff979fca,
    0xff979fca, 0xff969fcb, 0xff949fcb, 0xff93a0cc, 0xff93a1cc, 0xff93a1ce, 0xff94a1ce, 0xff94a1cd,
    0xff95a2cc, 0xff96a2cc, 0xff98a3cd, 0xff98a3ce, 0xff97a4cf, 0xff97a4cf, 0xff98a4cd, 0xff99a4cc,
    0xff99a4cc, 0xff99a4cc, 0xff9aa5cc, 0xff9ca5cd, 0xff9da7cd, 0xff9ca7cd, 0xff9ba8cd, 0xff9daace,
    0xff9eaace, 0xff9fa9ce, 0xff9fa8cd, 0xff9fa8cd, 0xffa0aace, 0xffa1aace, 0xffa2aacf, 0xffa3aad0,
    0xffa2abd0, 0xffa2acd0, 0xffa3acd0, 0xffa4acd1, 0xffa4acd1, 0xffa5add2, 0xffa6aed3, 0xffa7afd4,
    0xffa7afd4, 0xffa7afd4, 0xffa6aed3, 0xffa6aed3, 0xffa5add2, 0xffa5add2, 0xffa4acd1, 0xffa4acd1,
    0xffa5add2, 0xffa5add2, 0xffa4acd1, 0xffa4acd1, 0xffa4acd1, 0xffa4acd1, 0xffa4acd1, 0xffa3abd0,
    0xffa3abd0, 0xffa3abd0, 0xffa3abd0, 0xffa4acd1, 0xffa4acd2, 0xffa3abd2, 0xffa2a9d1, 0xffa2a8d1,
    0xffa1a8d1, 0xffa1a8d1, 0xffa0a9d2, 0xffa0a9d2, 0xffa0a9d3, 0xff9fa8d3, 0xff9ea7d2, 0xff9da6d1,
    0xff9ea6d1, 0xff9ea6d1, 0xff9da6d0, 0xff9aa6cf, 0xff98a6ce, 0xff98a6cf, 0xff99a5d0, 0xff99a4d0,
    0xff98a3cf, 0xff97a3cf, 0xff97a2cf, 0xff96a2cf, 0xff95a1d0, 0xff94a0d0, 0xff929ecf, 0xff919dcf,
    0xff909cd0, 0xff8f9cd2, 0xff8e9cd2, 0xff8d9bd1, 0xff8b9bcf, 0xff8a9acf, 0xff899ace, 0xff8899cd,
    0xff8798cd, 0xff8798cd, 0xff8798cd, 0xff8697cc, 0xff8596cb, 0xff8394cb, 0xff8394cc, 0xff8293cc,
    0xff7f92cb, 0xff7e92cb, 0xff7f92cb, 0xff7f92cb, 0xff7e92ca, 0xff7b91c8, 0xff798fc8, 0xff788fc9,
    0xff788eca, 0xff788dcc, 0xff788dcd, 0xff778ccc, 0xff758bcb, 0xff748bcb, 0xff728acc, 0xff728acc,
    0xff7189ca, 0xff7288c9, 0xff7488c6, 0xff7588c6, 0xff7587c7, 0xff7486c9, 0xff7185cc, 0xff6e83ce,
    0xff6c83ce, 0xff6c83cc, 0xff6c84ca, 0xff6d85c9, 0xff6d86c9, 0xff6c86ca, 0xff6b87cb, 0xff6b88cb,
    0xff6c89c9, 0xff6c8ac9, 0xff6b8ac9, 0xff698ac9, 0xff6589c9, 0xff6187c9, 0xff5e86c9, 0xff5c84ca,
    0xff5b82cb, 0xff5b80cb, 0xff5b7eca, 0xff5a7dc9, 0xff597cc8, 0xff587cc9, 0xff587cca, 0xff587dcb,
    0xff587dca, 0xff597dc8, 0xff5a7cc6, 0xff5b7cc4, 0xff8da1c9, 0xff8da1c9, 0xff8fa3ca, 0xff91a4ca,
    0xff93a5c8, 0xff94a5c5, 0xff95a6c5, 0xff96a6c6, 0xff98a6c6, 0xff98a5c7, 0xff98a4c7, 0xff97a4c6,
    0xff96a3c6, 0xff96a2c6, 0xff96a0c6, 0xff969fc6, 0xff969ec6, 0xff959cc6, 0xff949cc7, 0xff939cc7,
    0xff949dc7, 0xff959ec8, 0xff959ec9, 0xff949eca, 0xff949ecb, 0xff939ecc, 0xff939fcc, 0xff92a0cc,
    0xff92a1cc, 0xff92a1cd, 0xff93a1ce, 0xff93a1cd, 0xff94a1cc, 0xff95a1cc, 0xff97a2cd, 0xff97a2cf,
    0xff96a3cf, 0xff96a3cf, 0xff97a4cd, 0xff98a4cc, 0xff98a4cc, 0xff98a4cd, 0xff99a4cd, 0xff9ba5cd,
    0xff9ba6cd, 0xff9aa7cc, 0xff9aa8cc, 0xff9ca9cd, 0xff9da9ce, 0xff9ea8cd, 0xff9fa8cc, 0xff9fa9cc,
    0xffa0aacd, 0xffa0aacf, 0xffa1a9d0, 0xffa2a9d0, 0xffa2aad0, 0xffa2abd0, 0xffa3acd0, 0xffa4acd1,
    0xffa4acd1, 0xffa5acd2, 0xffa5acd2, 0xffa6add3, 0xffa6aed3, 0xffa6aed3, 0xffa5add2, 0xffa4acd1,
    0xffa4acd1, 0xffa4acd1, 0xffa4acd1, 0xffa4acd1, 0xffa4acd2, 0xffa4acd2, 0xffa3abd1, 0xffa3abd1,
    0xffa3abd1, 0xffa4acd1, 0xffa4acd1, 0xffa3abd0, 0xffa3abd0, 0xffa2aad0, 0xffa2aad0, 0xffa3abd1,
    0xffa4acd1, 0xffa3abd1, 0xffa1a9d1, 0xffa1a8d1, 0xffa1a8d0, 0xffa1a8d0, 0xffa0a9d1, 0xffa0a9d2,
    0xffa0a8d2, 0xff9fa7d2, 0xff9ea7d2, 0xff9da7d2, 0xff9da7d2, 0xff9da6d1, 0xff9ca6d0, 0xff9aa6cf,
    0xff99a6cf, 0xff99a6d0, 0xff99a5d0, 0xff99a4d0, 0xff98a3cf, 0xff97a3cf, 0xff97a2cf, 0xff96a2cf,
    0xff95a1d0, 0xff94a0d0, 0xff939fcf, 0xff929ecf, 0xff919dd0, 0xff8f9cd2, 0xff8e9bd2, 0xff8d9bd2,
    0xff8b9bd1, 0xff8b9bd0, 0xff8a9bcf, 0xff899acd, 0xff8899cc, 0xff8899cc, 0xff8798cd, 0xff8697cc,
    0xff8697cb, 0xff8596cb, 0xff8495cb, 0xff8394cb, 0xff8193cb, 0xff8092cb, 0xff8092cb, 0xff8092ca,
    0xff7f92c9, 0xff7c91c8, 0xff7a91c8, 0xff7990c8, 0xff798fc8, 0xff798eca, 0xff788dcb, 0xff768bcb,
    0xff748acb, 0xff728acb, 0xff718acb, 0xff6f8aca, 0xff6f89c9, 0xff7088c8, 0xff7287c7, 0xff7387c7,
    0xff7286c8, 0xff7085c9, 0xff6e84ca, 0xff6d83cc, 0xff6b83cc, 0xff6b82ca, 0xff6b82c9, 0xff6c83c8,
    0xff6d84c8, 0xff6e85c9, 0xff6e86ca, 0xff6f87ca, 0xff6f89c9, 0xff6f89c7, 0xff6d89c6, 0xff6b89c6,
    0xff6789c6, 0xff6488c7, 0xff6187c7, 0xff5e85c7, 0xff5d84c8, 0xff5d82ca, 0xff5b80ca, 0xff597ec9,
    0xff587dc8, 0xff587cc8, 0xff587cc9, 0xff577cca, 0xff577dca, 0xff587dc9, 0xff5a7cc7, 0xff5b7cc6,
    0xff8ea3c7, 0xff8ea3c7, 0xff91a5c8, 0xff94a6c8, 0xff96a6c7, 0xff96a5c6, 0xff97a5c6, 0xff97a6c7,
    0xff97a6c7, 0xff97a5c6, 0xff97a4c6, 0xff97a3c6, 0xff96a2c6, 0xff95a1c6, 0xff949fc6, 0xff949ec6,
    0xff939cc6, 0xff929cc6, 0xff919cc6, 0xff919cc6, 0xff919dc6, 0xff929dc7, 0xff929dc8, 0xff929dca,
    0xff929dcb, 0xff929ecc, 0xff929ecc, 0xff929fcc, 0xff92a0cc, 0xff93a0cd, 0xff93a0cd, 0xff93a0cc,
    0xff93a1cc, 0xff94a1cc, 0xff96a2cd, 0xff96a2ce, 0xff95a3cf, 0xff95a3cf, 0xff96a4ce, 0xff97a4cd,
    0xff98a4cd, 0xff98a4cd, 0xff98a4cd, 0xff99a4cc, 0xff99a5cc, 0xff99a6cc, 0xff9aa7cc, 0xff9ca8cd,
    0xff9da8cd, 0xff9ea8cc, 0xff9fa8cc, 0xff9fa9cc, 0xffa0aacd, 0xffa0aace, 0xffa1a9cf, 0xffa2a9cf,
    0xffa2aacf, 0xffa2abcf, 0xffa3abcf, 0xffa4abd0, 0xffa4abd0, 0xffa4acd1, 0xffa4acd1, 0xffa5add2,
    0xffa5add2, 0xffa4acd1, 0xffa3abd0, 0xffa3abd0, 0xffa3abd0, 0xffa3abd0, 0xffa4acd1, 0xffa4acd1,
    0xffa4acd2, 0xffa4acd2, 0xffa3abd2, 0xffa3abd1, 0xffa3abd0, 0xffa4acd0, 0xffa4acd0, 0xffa3abd1,
    0xffa3abd1, 0xffa2aad0, 0xffa2aad0, 0xffa3abd0, 0xffa3abd0, 0xffa2aad0, 0xffa1a9d0, 0xffa1a8d0,
    0xffa1a7d0, 0xffa1a7d0, 0xffa0a8d1, 0xff9fa9d1, 0xff9ea8d2, 0xff9ea7d2, 0xff9ea7d2, 0xff9ea7d2,
    0xff9ea7d2, 0xff9da7d1, 0xff9ba7d1, 0xff9ba6d0, 0xff9aa6d0, 0xff99a6d0, 0xff99a6d0, 0xff98a5cf,
    0xff97a4ce, 0xff96a3ce, 0xff95a2cf, 0xff95a1cf, 0xff94a0d0, 0xff94a0d0, 0xff94a0cf, 0xff939fcf,
    0xff919ed0, 0xff8f9dd2, 0xff8e9cd2, 0xff8d9bd2, 0xff8c9bd1, 0xff8b9cd0, 0xff8b9ccf, 0xff8a9bce,
    0xff899acd, 0xff8899cd, 0xff8798cd, 0xff8798cc, 0xff8697cb, 0xff8697cb, 0xff8596cb, 0xff8495cb,
    0xff8394cb, 0xff8293cb, 0xff8192cb, 0xff8092ca, 0xff7f92ca, 0xff7e91c9, 0xff7c91c8, 0xff7a90c7,
    0xff798fc7, 0xff788ec8, 0xff778dc9, 0xff758cca, 0xff738acb, 0xff7289cb, 0xff7189cb, 0xff6f89c9,
    0xff6f89c8, 0xff6f89c7, 0xff7188c7, 0xff7287c8, 0xff7186c9, 0xff6f85c9, 0xff6e85c9, 0xff6d84c9,
    0xff6d83c9, 0xff6c82c8, 0xff6c82c8, 0xff6c83c7, 0xff6d84c7, 0xff6e84c7, 0xff6f84c8, 0xff6f85c8,
    0xff6f87c8, 0xff6f88c6, 0xff6e88c5, 0xff6c87c4, 0xff6a87c4, 0xff6787c4, 0xff6487c4, 0xff6186c5,
    0xff5f86c6, 0xff5e85c8, 0xff5c83c9, 0xff5981c9, 0xff587fc8, 0xff577dc7, 0xff577cc7, 0xff577cc8,
    0xff577cca, 0xff587cca, 0xff5a7bc8, 0xff5b7bc8, 0xff8fa4c6, 0xff8fa4c6, 0xff93a5c6, 0xff96a6c6,
    0xff97a5c6, 0xff97a4c6, 0xff97a4c6, 0xff97a5c7, 0xff97a5c7, 0xff96a4c6, 0xff96a3c6, 0xff96a2c6,
    0xff95a1c6, 0xff94a0c6, 0xff929ec6, 0xff919dc6, 0xff909cc6, 0xff909cc6, 0xff8f9cc6, 0xff8f9cc6,
    0xff909cc6, 0xff909cc6, 0xff909cc8, 0xff909dca, 0xff909dcb, 0xff919ecc, 0xff919ecc, 0xff929fcc,
    0xff92a0cc, 0xff93a0cc, 0xff93a0cc, 0xff93a0cc, 0xff93a0cc, 0xff94a0cd, 0xff95a1ce, 0xff95a1ce,
    0xff95a2ce, 0xff95a2ce, 0xff96a3cd, 0xff96a4cd, 0xff97a4ce, 0xff97a4ce, 0xff97a3cd, 0xff97a3cc,
    0xff97a3cc, 0xff99a5cc, 0xff9aa6cc, 0xff9ca7cd, 0xff9da7cd, 0xff9ea7cc, 0xff9fa8cb, 0xff9fa9cc,
    0xffa0a9cd, 0xffa0a9ce, 0xffa1a8ce, 0xffa1a8ce, 0xffa2a9cf, 0xffa2aacf, 0xffa3abd0, 0xffa3abd0,
    0xffa3abd0, 0xffa3abd0, 0xffa3abd0, 0xffa3abd0, 0xffa3abd0, 0xffa2aacf, 0xffa2aacf, 0xffa2aacf,
    0xffa2aacf, 0xffa3abd0, 0xffa4acd1, 0xffa4acd1, 0xffa4acd2, 0xffa3abd2, 0xffa2aad2, 0xffa2aad1,
    0xffa3abd0, 0xffa4acd0, 0xffa4acd0, 0xffa3abd1, 0xffa2aad1, 0xffa1a9d1, 0xffa1a9d0, 0xffa2aacf,
    0xffa2aacf, 0xffa1aacf, 0xffa0a9d0, 0xffa0a8d0, 0xffa0a7d0, 0xffa0a7d0, 0xff9fa8d1, 0xff9fa8d1,
    0xff9ea7d1, 0xff9ea6d1, 0xff9ea7d2, 0xff9ea8d3, 0xff9da8d3, 0xff9ca7d1, 0xff9ba7d1, 0xff9ba6d1,
    0xff9ba6d1, 0xff9aa6d1, 0xff99a6d0, 0xff98a5cf, 0xff97a4ce, 0xff96a3ce, 0xff95a2cf, 0xff95a1cf,
    0xff94a0d0, 0xff94a0d0, 0xff94a0d0, 0xff94a0d0, 0xff929fd0, 0xff909dd1, 0xff8f9cd1, 0xff8e9bd1,
    0xff8d9bd1, 0xff8c9cd1, 0xff8c9cd0, 0xff8b9bce, 0xff8a9acd, 0xff8999cd, 0xff8898cd, 0xff8898cc,
    0xff8797cb, 0xff8797cb, 0xff8697ca, 0xff8596ca, 0xff8594cb, 0xff8493cb, 0xff8292ca, 0xff8092c9,
    0xff7f92c9, 0xff7f91ca, 0xff7d91ca, 0xff7b90c8, 0xff7a8fc7, 0xff788ec6, 0xff778dc7, 0xff758bc9,
    0xff7389cb, 0xff7289cb, 0xff7189c9, 0xff6f89c7, 0xff6f89c6, 0xff6f89c6, 0xff7188c8, 0xff7187c9,
    0xff6f86c9, 0xff6d85c8, 0xff6d85c7, 0xff6e85c6, 0xff6e84c6, 0xff6d83c7, 0xff6c82c7, 0xff6c82c7,
    0xff6d83c7, 0xff6e83c7, 0xff6f83c7, 0xff6f84c7, 0xff6f86c7, 0xff6f86c5, 0xff6e85c3, 0xff6d84c2,
    0xff6c85c2, 0xff6a86c2, 0xff6886c2, 0xff6586c2, 0xff6386c3, 0xff6186c5, 0xff5e84c7, 0xff5b83c7,
    0xff5981c7, 0xff587fc6, 0xff587dc5, 0xff577cc7, 0xff577cc9, 0xff587cc9, 0xff597bc8, 0xff5a7bc8,
    0xff92a4c6, 0xff92a4c6, 0xff94a5c5, 0xff96a5c5, 0xff98a5c6, 0xff98a4c7, 0xff98a4c7, 0xff97a4c7,
    0xff97a4c7, 0xff96a3c6, 0xff95a2c6, 0xff95a0c6, 0xff949fc6, 0xff939ec7, 0xff919dc7, 0xff909cc7,
    0xff8f9cc6, 0xff8f9cc6, 0xff8e9cc7, 0xff8e9cc7, 0xff8f9cc6, 0xff8f9cc6, 0xff8f9cc8, 0xff8f9dca,
    0xff8f9dcb, 0xff909ecc, 0xff909ecc, 0xff919fcc, 0xff92a0cc, 0xff93a0cc, 0xff93a0cc, 0xff93a0cc,
    0xff93a0cc, 0xff93a0cd, 0xff94a0ce, 0xff94a0ce, 0xff95a1ce, 0xff95a2ce, 0xff95a3cd, 0xff95a3cd,
    0xff95a3cd, 0xff96a3ce, 0xff96a2ce, 0xff97a2cd, 0xff97a3cd, 0xff98a5cd, 0xff99a6cd, 0xff9ba6cd,
    0xff9ca6cd, 0xff9ea7cc, 0xff9fa8cb, 0xffa0a8cb, 0xffa0a8cc, 0xffa0a8cd, 0xffa1a8ce, 0xffa1a8ce,
    0xffa2a9cf, 0xffa2aacf, 0xffa2aacf, 0xffa2aacf, 0xffa2aacf, 0xffa2abcf, 0xffa2abcf, 0xffa2aacf,
    0xffa2aacf, 0xffa2aace, 0xffa2aace, 0xffa2aace, 0xffa2aace, 0xffa2aacf, 0xffa3abd0, 0xffa3abd1,
    0xffa3abd2, 0xffa3abd2, 0xffa2aad2, 0xffa2aad2, 0xffa2aad2, 0xffa3abd1, 0xffa3abd1, 0xffa2abd1,
    0xffa2abd1, 0xffa1aad0, 0xffa1a9d0, 0xffa1a9cf, 0xffa1a9cf, 0xffa1a9cf, 0xffa0a9d0, 0xffa0a8d0,
    0xff9fa7d1, 0xff9fa7d1, 0xff9fa8d2, 0xff9fa8d2, 0xff9ea7d1, 0xff9ea6d1, 0xff9ea7d2, 0xff9ea8d3,
    0xff9da8d3, 0xff9ca7d1, 0xff9ca7d1, 0xff9ca6d1, 0xff9ca6d1, 0xff9ba6d1, 0xff9aa6d0, 0xff99a5cf,
    0xff97a4cf, 0xff96a3cf, 0xff95a2cf, 0xff95a2cf, 0xff95a1d0, 0xff95a1d1, 0xff95a1d1, 0xff95a0d1,
    0xff939fd0, 0xff919ed0, 0xff909dd0, 0xff8f9cd1, 0xff8e9cd1, 0xff8d9bd1, 0xff8d9bd0, 0xff8c9ace,
    0xff8b99cd, 0xff8a99cd, 0xff8999cd, 0xff8998cd, 0xff8897cc, 0xff8796ca, 0xff8696c9, 0xff8596c9,
    0xff8495ca, 0xff8494cb, 0xff8393ca, 0xff8193c9, 0xff8093c9, 0xff8092c9, 0xff7e91c9, 0xff7d90c9,
    0xff7b8fc8, 0xff798dc6, 0xff778cc6, 0xff758ac8, 0xff7389cb, 0xff7289cb, 0xff7189c9, 0xff7089c7,
    0xff6f89c6, 0xff6f88c6, 0xff6f87c8, 0xff6f86c9, 0xff6e85c9, 0xff6c85c8, 0xff6c85c7, 0xff6d85c6,
    0xff6d84c6, 0xff6c83c6, 0xff6c82c6, 0xff6c82c7, 0xff6c82c7, 0xff6d82c7, 0xff6e82c6, 0xff6e83c6,
    0xff6e84c6, 0xff6e84c4, 0xff6d83c2, 0xff6d82c1, 0xff6d83c0, 0xff6c84c0, 0xff6b85c0, 0xff6986c0,
    0xff6886c1, 0xff6686c2, 0xff6284c4, 0xff5e83c5, 0xff5c82c5, 0xff5a80c4, 0xff5a7fc3, 0xff597ec5,
    0xff587dc8, 0xff587cc8, 0xff597bc7, 0xff597bc7, 0xff94a3c6, 0xff94a3c6, 0xff94a3c4, 0xff95a3c4,
    0xff96a3c6, 0xff97a3c8, 0xff97a3c8, 0xff96a2c7, 0xff96a2c7, 0xff95a2c6, 0xff95a1c6, 0xff949fc6,
    0xff939ec6, 0xff929dc6, 0xff909dc7, 0xff8f9dc7, 0xff8f9cc7, 0xff8f9cc7, 0xff8e9dc8, 0xff8e9dc8,
    0xff8f9cc7, 0xff8f9cc7, 0xff8f9cc8, 0xff8f9dca, 0xff8f9dcb, 0xff909ecb, 0xff909ecb, 0xff919fcc,
    0xff929fcc, 0xff93a0cd, 0xff93a0cd, 0xff94a1cd, 0xff94a1cc, 0xff94a1cc, 0xff93a0cd, 0xff93a0cd,
    0xff94a1cd, 0xff95a2cd, 0xff95a3cd, 0xff95a3cd, 0xff95a3cd, 0xff96a2ce, 0xff96a2ce, 0xff97a2ce,
    0xff97a3ce, 0xff98a5ce, 0xff99a6ce, 0xff9ba5ce, 0xff9ca5cd, 0xff9da6cc, 0xff9ea8cb, 0xff9ea8cb,
    0xff9fa8cc, 0xff9fa8cc, 0xffa0a8cd, 0xffa1a8cd, 0xffa2a9ce, 0xffa2aace, 0xffa2aacf, 0xffa1aacf,
    0xffa1aacf, 0xffa1abce, 0xffa1abce, 0xffa1aace, 0xffa1a9ce, 0xffa2a9ce, 0xffa2aace, 0xffa2aace,
    0xffa2aace, 0xffa2aacf, 0xffa2aacf, 0xffa2aad1, 0xffa3abd2, 0xffa3abd2, 0xffa2aad2, 0xffa2aad2,
    0xffa2aad2, 0xffa2aad2, 0xffa2aad2, 0xffa1aad1, 0xffa1aad1, 0xffa1a9d1, 0xffa1a9d1, 0xffa1a9d0,
    0xffa1a9cf, 0xffa1a9d0, 0xffa0a8d1, 0xffa0a8d1, 0xff9fa8d2, 0xff9fa8d2, 0xffa0a7d3, 0xffa0a7d3,
    0xffa0a6d2, 0xff9fa6d2, 0xff9fa7d2, 0xff9ea8d3, 0xff9ea8d3, 0xff9da7d2, 0xff9da6d2, 0xff9da5d1,
    0xff9da5d1, 0xff9ca6d0, 0xff9aa6cf, 0xff98a5cf, 0xff97a4cf, 0xff96a3cf, 0xff96a2d0, 0xff96a2d1,
    0xff95a2d2, 0xff95a2d2, 0xff95a1d2, 0xff95a0d1, 0xff949fd0, 0xff929ed0, 0xff919dd0, 0xff909cd0,
    0xff8f9cd0, 0xff8e9cd0, 0xff8e9bd0, 0xff8c99cf, 0xff8b98ce, 0xff8b98cd, 0xff8b99cc, 0xff8b98cc,
    0xff8a97cc, 0xff8896cb, 0xff8695ca, 0xff8595c9, 0xff8495c9, 0xff8495ca, 0xff8494ca, 0xff8393c9,
    0xff8293c9, 0xff8192c8, 0xff7f91c8, 0xff7d90c9, 0xff7b8fc9, 0xff798dc8, 0xff788cc7, 0xff768ac8,
    0xff7489ca, 0xff7389ca, 0xff7289c9, 0xff7089c8, 0xff7088c7, 0xff6f87c7, 0xff6e86c8, 0xff6e86c9,
    0xff6d85c9, 0xff6c84c8, 0xff6c84c7, 0xff6d84c6, 0xff6d84c6, 0xff6c83c6, 0xff6c82c6, 0xff6c82c7,
    0xff6c82c7, 0xff6c82c7, 0xff6c81c6, 0xff6c81c6, 0xff6c81c6, 0xff6c81c4, 0xff6d81c2, 0xff6d81c1,
    0xff6d81bf, 0xff6c82bf, 0xff6c84bf, 0xff6c85c0, 0xff6b85c0, 0xff6a84bf, 0xff6683bf, 0xff6282c1,
    0xff5e82c2, 0xff5d81c2, 0xff5c80c2, 0xff5a7fc4, 0xff597dc6, 0xff587cc6, 0xff587bc5, 0xff587bc5,
    0xff95a1c6, 0xff95a1c6, 0xff93a1c4, 0xff93a1c4, 0xff94a2c6, 0xff96a2c8, 0xff96a1c8, 0xff94a0c7,
    0xff94a0c6, 0xff94a0c6, 0xff94a0c6, 0xff939ec6, 0xff929dc6, 0xff919dc7, 0xff909dc8, 0xff8f9dc8,
    0xff8f9cc8, 0xff8f9cc8, 0xff8f9dc9, 0xff8f9dc9, 0xff8f9cc8, 0xff8f9cc8, 0xff8f9cc9, 0xff8f9dca,
    0xff8f9dca, 0xff909ecb, 0xff909ecb, 0xff919fcc, 0xff929fcc, 0xff93a0cd, 0xff93a0cd, 0xff94a1cd,
    0xff94a1cc, 0xff94a1cc, 0xff93a0cd, 0xff93a0cd, 0xff94a1cd, 0xff95a2cd, 0xff95a2cd, 0xff95a2cd,
    0xff95a1cd, 0xff95a1cd, 0xff96a1ce, 0xff97a1cf, 0xff97a3cf, 0xff97a4cf, 0xff98a5ce, 0xff9aa4ce,
    0xff9ba4cd, 0xff9ca6cc, 0xff9da8cb, 0xff9da8cb, 0xff9ea7cb, 0xff9ea7cb, 0xff9fa7cc, 0xffa0a8cd,
    0xffa1a9ce, 0xffa1aace, 0xffa1aace, 0xffa0a9ce, 0xffa0a9ce, 0xffa0aacd, 0xffa0aacd, 0xffa1a9ce,
    0xffa1a9ce, 0xffa2aace, 0xffa2aace, 0xffa2aace, 0xffa2aace, 0xffa2aacf, 0xffa1a9cf, 0xffa1a9d1,
    0xffa2aad2, 0xffa3abd2, 0xffa3abd2, 0xffa2aad2, 0xffa2a9d2, 0xffa1a8d2, 0xffa1a8d2, 0xffa0a9d1,
    0xffa0a9d1, 0xffa1a9d1, 0xffa1a9d1, 0xffa0a8d0, 0xffa0a8cf, 0xffa0a8d0, 0xffa0a8d1, 0xff9fa8d2,
    0xff9ea8d3, 0xff9ea8d3, 0xff9fa7d4, 0xffa0a7d4, 0xffa0a7d3, 0xff9fa7d2, 0xff9ea8d2, 0xff9ea8d3,
    0xff9ea8d3, 0xff9ea7d2, 0xff9ea6d2, 0xff9ea5d1, 0xff9da5d1, 0xff9ca6d0, 0xff9ba6cf, 0xff9aa5cf,
    0xff98a4d0, 0xff97a3d0, 0xff97a3d0, 0xff97a3d0, 0xff96a3d1, 0xff96a3d2, 0xff96a1d2, 0xff95a0d1,
    0xff949fd0, 0xff939fcf, 0xff929ecf, 0xff919ed0, 0xff909cd0, 0xff8f9bd0, 0xff8f9ad0, 0xff8d98cf,
    0xff8c97ce, 0xff8c99cd, 0xff8c9acc, 0xff8c99cc, 0xff8b96cc, 0xff8994cb, 0xff8795ca, 0xff8695c9,
    0xff8495c9, 0xff8495ca, 0xff8495ca, 0xff8494c9, 0xff8393c8, 0xff8293c7, 0xff8091c7, 0xff7e90c9,
    0xff7c8fca, 0xff7a8dc8, 0xff798cc7, 0xff778bc8, 0xff758ac9, 0xff748ac9, 0xff7389c8, 0xff7189c8,
    0xff7188c7, 0xff7087c7, 0xff6f86c8, 0xff6e86c8, 0xff6d85c8, 0xff6d84c8, 0xff6d84c8, 0xff6c83c7,
    0xff6c83c6, 0xff6c82c5, 0xff6c82c5, 0xff6c82c6, 0xff6b82c7, 0xff6a82c6, 0xff6a81c5, 0xff6a80c5,
    0xff6a7fc4, 0xff6a7fc3, 0xff6b80c2, 0xff6c80c1, 0xff6c80bf, 0xff6c80be, 0xff6d82be, 0xff6e83be,
    0xff6e83bd, 0xff6d81bc, 0xff6981bc, 0xff6582be, 0xff6282bf, 0xff6082c0, 0xff5f81c0, 0xff5d80c2,
    0xff5b7ec3, 0xff5a7dc3, 0xff587bc2, 0xff587bc2, 0xff95a0c6, 0xff95a0c6, 0xff939fc4, 0xff929fc4,
    0xff93a0c6, 0xff95a1c8, 0xff94a1c7, 0xff939fc6, 0xff929fc5, 0xff93a0c5, 0xff93a0c6, 0xff939ec7,
    0xff929dc7, 0xff919dc8, 0xff909dc8, 0xff8f9dc8, 0xff8f9cc8, 0xff8f9cc8, 0xff8f9dc9, 0xff8f9dc9,
    0xff8f9cc8, 0xff8f9cc8, 0xff8f9cc9, 0xff8f9dca, 0xff8f9dca, 0xff909ecb, 0xff909ecb, 0xff919fcc,
    0xff929fcc, 0xff93a0cd, 0xff93a0cd, 0xff94a1cd, 0xff94a1cc, 0xff94a1cc, 0xff93a0cd, 0xff93a0cd,
    0xff94a1cc, 0xff94a1cc, 0xff95a2cd, 0xff95a2cd, 0xff94a1cd, 0xff94a0cd, 0xff94a0ce, 0xff95a1cf,
    0xff96a3cf, 0xff96a4ce, 0xff97a4cd, 0xff99a3cc, 0xff9aa3cc, 0xff9ba5cc, 0xff9ca7cc, 0xff9ca7cc,
    0xff9da6cb, 0xff9da6cb, 0xff9ea7cc, 0xff9fa8cd, 0xffa0a9cd, 0xffa0a9cd, 0xffa0a9ce, 0xff9fa9ce,
    0xff9fa9cd, 0xffa0a9cc, 0xffa0a9cc, 0xffa1a9cd, 0xffa1a9ce, 0xffa1a9ce, 0xffa1a9ce, 0xffa2a9ce,
    0xffa2a9ce, 0xffa2a9cf, 0xffa1a9cf, 0xffa1a9d1, 0xffa3abd2, 0xffa3abd2, 0xffa2aad1, 0xffa1a9d1,
    0xffa0a8d1, 0xffa0a7d2, 0xffa0a7d2, 0xff9fa8d1, 0xff9fa8d1, 0xffa0a8d1, 0xffa0a8d1, 0xff9fa7d0,
    0xff9fa7cf, 0xff9fa7d0, 0xff9fa8d1, 0xff9fa8d2, 0xff9ea7d3, 0xff9ea7d3, 0xff9fa7d3, 0xffa0a7d3,
    0xffa0a8d2, 0xff9fa8d1, 0xff9ea8d2, 0xff9ea8d3, 0xff9ea8d3, 0xff9ea7d2, 0xff9ea6d2, 0xff9ea5d1,
    0xff9da4d1, 0xff9ca4d0, 0xff9ba5cf, 0xff9aa5cf, 0xff99a4d0, 0xff99a4d0, 0xff98a3d1, 0xff98a3d1,
    0xff97a3d1, 0xff96a3d1, 0xff96a1d1, 0xff96a0d0, 0xff959fcf, 0xff939fce, 0xff929ece, 0xff919ed0,
    0xff919cd0, 0xff919bd0, 0xff909ad0, 0xff8e98d0, 0xff8d98cf, 0xff8d99ce, 0xff8d9acd, 0xff8c99cd,
    0xff8b96cc, 0xff8994cc, 0xff8895cb, 0xff8795ca, 0xff8695ca, 0xff8595ca, 0xff8595c9, 0xff8494c8,
    0xff8493c7, 0xff8393c6, 0xff8191c7, 0xff7f90ca, 0xff7d8fcb, 0xff7a8ec9, 0xff798dc7, 0xff778cc7,
    0xff768bc8, 0xff758ac7, 0xff758ac6, 0xff7388c6, 0xff7288c6, 0xff7187c6, 0xff7087c6, 0xff6f87c6,
    0xff6e86c6, 0xff6d84c7, 0xff6d83c7, 0xff6c83c7, 0xff6c83c7, 0xff6b82c6, 0xff6b82c5, 0xff6b82c6,
    0xff6b82c6, 0xff6a82c5, 0xff6981c4, 0xff6980c4, 0xff697ec4, 0xff697ec2, 0xff6a7fc1, 0xff6b7fbf,
    0xff6b7ebd, 0xff6b7ebc, 0xff6d7fbb, 0xff6e81bb, 0xff6e81ba, 0xff6d80ba, 0xff6b80ba, 0xff6881bb,
    0xff6581bc, 0xff6381bc, 0xff6181bd, 0xff5f80bf, 0xff5d7ec0, 0xff5b7dc0, 0xff5a7bbf, 0xff597bbf,
    0xff939fc6, 0xff939fc6, 0xff929ec4, 0xff929ec4, 0xff939fc5, 0xff94a0c7, 0xff939fc7, 0xff919ec5,
    0xff919ec5, 0xff92a0c5, 0xff93a0c6, 0xff939ec7, 0xff929dc7, 0xff919dc7, 0xff909dc8, 0xff909dc8,
    0xff909dc9, 0xff909dc9, 0xff909dc9, 0xff909dc9, 0xff8f9cc9, 0xff8f9cc9, 0xff8f9cc9, 0xff8f9cc9,
    0xff909dca, 0xff919ecb, 0xff919ecb, 0xff919ecb, 0xff919ecb, 0xff919ecc, 0xff929fcd, 0xff93a0cd,
    0xff94a1cd, 0xff94a1cd, 0xff94a1cd, 0xff94a1cd, 0xff94a1cb, 0xff94a1cb, 0xff95a2cc, 0xff95a2cd,
    0xff94a1cc, 0xff93a0cc, 0xff93a0cd, 0xff94a1cf, 0xff95a2cf, 0xff95a3cc, 0xff96a3cb, 0xff98a2ca,
    0xff99a2cb, 0xff9aa3cc, 0xff9ba5cd, 0xff9ba6cd, 0xff9ca6cb, 0xff9ca6cb, 0xff9da7cb, 0xff9ea7cc,
    0xffa0a8cd, 0xffa0a8cd, 0xffa0a8cd, 0xff9fa8cd, 0xff9fa8cd, 0xffa0a8cc, 0xffa0a8cc, 0xffa0a9cd,
    0xffa0a9ce, 0xffa0a8cf, 0xffa0a8cf, 0xffa1a8cf, 0xffa2a9cf, 0xffa2a9cf, 0xffa1aacf, 0xffa1aacf,
    0xffa2aad1, 0xffa2aad1, 0xffa2a9d0, 0xffa1a8cf, 0xffa1a7d0, 0xffa0a6d1, 0xffa0a6d1, 0xff9fa6d1,
    0xff9fa6d1, 0xff9fa6d1, 0xff9fa6d1, 0xff9fa6d0, 0xff9fa6d0, 0xff9fa6d0, 0xff9fa7d1, 0xff9fa7d1,
    0xff9ea7d1, 0xff9ea7d1, 0xff9fa8d2, 0xffa0a8d2, 0xffa0a9d0, 0xff9fa9cf, 0xff9ea8d0, 0xff9ea7d2,
    0xff9ea7d2, 0xff9ea6d2, 0xff9ea5d2, 0xff9ea4d1, 0xff9da4d1, 0xff9ca5d0, 0xff9ba5d0, 0xff9aa4d0,
    0xff99a3d0, 0xff99a2d0, 0xff99a2d1, 0xff98a2d1, 0xff97a2d1, 0xff96a2d0, 0xff96a1cf, 0xff96a0ce,
    0xff95a0ce, 0xff939fce, 0xff929ecf, 0xff919ed0, 0xff919cd0, 0xff909cd0, 0xff909bd0, 0xff8f9ad0,
    0xff8e9acf, 0xff8e9acf, 0xff8d9ace, 0xff8c99cd, 0xff8b97cd, 0xff8a96cb, 0xff8996cb, 0xff8996ca,
    0xff8795c9, 0xff8694c9, 0xff8494c8, 0xff8394c7, 0xff8393c6, 0xff8392c6, 0xff8190c7, 0xff7f90ca,
    0xff7d8fcb, 0xff7a8fc9, 0xff798ec7, 0xff788dc7, 0xff778bc8, 0xff768ac7, 0xff768ac5, 0xff748ac4,
    0xff7389c4, 0xff7288c5, 0xff7187c5, 0xff7087c5, 0xff6f86c5, 0xff6e85c6, 0xff6d84c6, 0xff6c83c6,
    0xff6c83c6, 0xff6b83c5, 0xff6b83c5, 0xff6b82c5, 0xff6a81c4, 0xff6981c3, 0xff6880c2, 0xff687fc2,
    0xff697ec1, 0xff697ec0, 0xff697ebf, 0xff697ebe, 0xff697dbc, 0xff6a7dbb, 0xff6b7eb9, 0xff6c7fb8,
    0xff6d7fb8, 0xff6d7fb9, 0xff6b7fb9, 0xff6880b9, 0xff6680b9, 0xff6480b9, 0xff6380ba, 0xff617fbb,
    0xff5e7ebc, 0xff5c7dbc, 0xff5b7cbc, 0xff5a7cbc, 0xff909dc5, 0xff909dc5, 0xff919dc4, 0xff919dc4,
    0xff929ec5, 0xff929ec6, 0xff919ec6, 0xff909dc5, 0xff909ec5, 0xff919fc5, 0xff92a0c6, 0xff929fc7,
    0xff929ec8, 0xff919dc8, 0xff909dc8, 0xff909dc8, 0xff909dc9, 0xff909dc9, 0xff909dc9, 0xff909dc9,
    0xff8f9cc9, 0xff8f9cc9, 0xff8f9cc9, 0xff8f9cc9, 0xff909dca, 0xff919ecb, 0xff919ecb, 0xff919ecb,
    0xff919ecb, 0xff919ecc, 0xff929fcd, 0xff93a0cd, 0xff94a1cd, 0xff94a1cd, 0xff94a1cd, 0xff94a1cd,
    0xff93a0cb, 0xff93a0cb, 0xff94a1cc, 0xff95a2cd, 0xff94a1cd, 0xff93a0cc, 0xff93a0cd, 0xff94a2ce,
    0xff94a2cd, 0xff94a2cb, 0xff95a2ca, 0xff97a2c9, 0xff98a2ca, 0xff99a3cc, 0xff9aa4cd, 0xff9aa4cd,
    0xff9ba5cb, 0xff9ba5cb, 0xff9ca6cc, 0xff9da7cc, 0xff9ea7cc, 0xff9fa7cc, 0xff9fa8cd, 0xff9fa8cd,
    0xff9fa8cd, 0xffa0a7cc, 0xffa0a7cc, 0xffa0a9cd, 0xffa0a9ce, 0xff9fa8cf, 0xff9fa7cf, 0xffa0a7cf,
    0xffa1a8cf, 0xffa1a9cf, 0xffa1aacf, 0xffa1aacf, 0xffa1aad0, 0xffa1a9d0, 0xffa1a8cf, 0xffa0a7ce,
    0xffa0a6cf, 0xff9fa6d0, 0xff9fa6d0, 0xff9ea5d0, 0xff9ea5d0, 0xff9ea5d0, 0xff9ea5d0, 0xff9ea5d0,
    0xff9ea5d0, 0xff9ea6d0, 0xff9ea7d0, 0xff9ea7d0, 0xff9ea6d0, 0xff9ea6d0, 0xff9fa7d0, 0xff9fa8d0,
    0xff9fa9ce, 0xff9fa9ce, 0xff9fa8cf, 0xff9ea7d1, 0xff9ea7d2, 0xff9ea6d2, 0xff9ea6d2, 0xff9ea5d2,
    0xff9da4d1, 0xff9ca4d0, 0xff9ba4d0, 0xff9aa4d0, 0xff9aa3d0, 0xff9aa3d0, 0xff9aa2d1, 0xff99a2d1,
    0xff97a1d0, 0xff96a1cf, 0xff96a0ce, 0xff96a0cd, 0xff95a0cd, 0xff939fce, 0xff929ecf, 0xff919dd0,
    0xff919dd0, 0xff909ccf, 0xff909ccf, 0xff909bcf, 0xff8f9bcf, 0xff8e9bcf, 0xff8d9ace, 0xff8c99cd,
    0xff8a98cc, 0xff8a97cc, 0xff8a96cb, 0xff8a96cb, 0xff8995ca, 0xff8794c9, 0xff8594c8, 0xff8394c7,
    0xff8393c6, 0xff8292c6, 0xff8190c7, 0xff808fc9, 0xff7e8fca, 0xff7b8fc9, 0xff7a8fc7, 0xff798ec7,
    0xff788cc7, 0xff778bc6, 0xff778ac4, 0xff758ac3, 0xff7489c4, 0xff7389c4, 0xff7289c3, 0xff7188c3,
    0xff7087c4, 0xff6e85c5, 0xff6d84c5, 0xff6c83c5, 0xff6b83c5, 0xff6b83c5, 0xff6a83c4, 0xff6a82c3,
    0xff6a81c2, 0xff6981c1, 0xff6880c1, 0xff687fc1, 0xff697ec1, 0xff697ebf, 0xff687dbd, 0xff677dbc,
    0xff677cbc, 0xff687cbb, 0xff687cb8, 0xff697db6, 0xff6a7db6, 0xff6a7eb8, 0xff6a7eb8, 0xff687eb7,
    0xff677eb7, 0xff667eb7, 0xff647eb7, 0xff627eb8, 0xff607db9, 0xff5e7db9, 0xff5d7cb9, 0xff5c7cb9,
    0xff8e9bc4, 0xff8e9bc4, 0xff8f9bc5, 0xff909bc5, 0xff909bc6, 0xff909cc6, 0xff909cc6, 0xff909cc6,
    0xff909dc6, 0xff919ec6, 0xff919fc7, 0xff929fc8, 0xff929ec9, 0xff929ec9, 0xff919ec9, 0xff919ec9,
    0xff919eca, 0xff919eca, 0xff919dc9, 0xff919dc9, 0xff909cc9, 0xff8f9cc9, 0xff8f9cc9, 0xff8f9cc9,
    0xff909dca, 0xff919ecb, 0xff919ecb, 0xff919ecb, 0xff919ecb, 0xff919ecc, 0xff929fcd, 0xff93a0cd,
    0xff94a1cd, 0xff94a1cd, 0xff94a1cd, 0xff94a1cd, 0xff93a0cc, 0xff93a0cc, 0xff94a1cd, 0xff95a2cd,
    0xff94a1cd, 0xff93a0cc, 0xff93a0cc, 0xff94a2cd, 0xff94a2cc, 0xff94a1ca, 0xff94a1c9, 0xff96a1c9,
    0xff97a2ca, 0xff98a3cb, 0xff99a4cc, 0xff9aa4cc, 0xff9ba5cb, 0xff9ca6cb, 0xff9ca7cc, 0xff9da7cc,
    0xff9ea6cb, 0xff9fa6cb, 0xff9fa7cc, 0xff9fa8cd, 0xff9fa8cd, 0xff9fa7cd, 0xff9fa7cd, 0xffa0a8ce,
    0xffa0a8ce, 0xff9fa7cf, 0xff9fa7cf, 0xff9fa7cf, 0xffa0a8ce, 0xffa0a9ce, 0xffa0a9cf, 0xffa0a9cf,
    0xff9fa9cf, 0xff9fa8cf, 0xff9ea7ce, 0xff9ea7ce, 0xff9ea7cf, 0xff9da6d0, 0xff9ca5d0, 0xff9ba4d0,
    0xff9ba4d0, 0xff9ba4cf, 0xff9ba4cf, 0xff9ba5d0, 0xff9ba5d0, 0xff9ba6d0, 0xff9ba6d0, 0xff9ba6d0,
    0xff9ba6d0, 0xff9ba6d0, 0xff9ca7d0, 0xff9ca7d0, 0xff9ca8cf, 0xff9ca8ce, 0xff9ca8cf, 0xff9ca7d0,
    0xff9ca7d1, 0xff9ca6d2, 0xff9ca6d2, 0xff9ba5d2, 0xff9ba5d1, 0xff9aa4d0, 0xff9aa4d0, 0xff9aa4d0,
    0xff9aa3d0, 0xff9aa3d1, 0xff9aa2d1, 0xff99a2d1, 0xff97a1cf, 0xff96a1ce, 0xff95a0ce, 0xff959fce,
    0xff949fce, 0xff939fce, 0xff929ece, 0xff919dcf, 0xff919dcf, 0xff909dce, 0xff909dce, 0xff909cce,
    0xff8f9bce, 0xff8e9ace, 0xff8d99ce, 0xff8c98cd, 0xff8b97cc, 0xff8b97cc, 0xff8b96cb, 0xff8b96cb,
    0xff8a95ca, 0xff8894c9, 0xff8794c9, 0xff8594c8, 0xff8493c7, 0xff8392c6, 0xff8191c6, 0xff7f90c8,
    0xff7e90c9, 0xff7c8fc8, 0xff7b8ec7, 0xff7b8ec7, 0xff7a8dc7, 0xff798cc6, 0xff778bc4, 0xff758ac3,
    0xff7589c4, 0xff7489c4, 0xff7389c3, 0xff7288c3, 0xff7087c3, 0xff6e85c4, 0xff6d84c4, 0xff6c83c4,
    0xff6b83c4, 0xff6b83c4, 0xff6a83c3, 0xff6a82c1, 0xff6a81c0, 0xff6980c0, 0xff687fc0, 0xff687fc0,
    0xff687ec0, 0xff687ebe, 0xff677dbc, 0xff667dbb, 0xff667cbc, 0xff667bbc, 0xff667bb9, 0xff677bb5,
    0xff687bb5, 0xff697cb6, 0xff697cb7, 0xff687cb7, 0xff677cb6, 0xff667cb5, 0xff657cb5, 0xff637db5,
    0xff617db6, 0xff607db6, 0xff5e7cb6, 0xff5e7cb6, 0xff8c98c4, 0xff8c98c4, 0xff8d99c5, 0xff8f9ac5,
    0xff8f9bc6, 0xff8f9bc6, 0xff8f9bc6, 0xff909cc6, 0xff909cc6, 0xff909dc7, 0xff909dc8, 0xff919ec9,
    0xff929eca, 0xff929fcb, 0xff929fcb, 0xff929fcb, 0xff919eca, 0xff919eca, 0xff919eca, 0xff919eca,
    0xff909dca, 0xff909dca, 0xff909dc9, 0xff909dc9, 0xff909dca, 0xff909ecb, 0xff909ecb, 0xff919fcb,
    0xff929fcb, 0xff93a0cc, 0xff93a0cd, 0xff93a0cd, 0xff93a0cc, 0xff93a0cc, 0xff94a1cd, 0xff94a1cd,
    0xff93a1ce, 0xff93a1ce, 0xff94a1ce, 0xff95a1ce, 0xff95a1ce, 0xff94a1cd, 0xff94a1cd, 0xff94a1cc,
    0xff94a1cb, 0xff93a0ca, 0xff93a0c9, 0xff95a2ca, 0xff96a3cb, 0xff97a4cb, 0xff98a4cb, 0xff99a4cb,
    0xff9ba5cc, 0xff9da6cc, 0xff9da7cc, 0xff9da7cc, 0xff9ea6cb, 0xff9ea6cb, 0xff9fa7cb, 0xff9fa8cc,
    0xff9fa8cc, 0xff9fa8cd, 0xff9fa8cd, 0xff9fa8ce, 0xff9fa8cf, 0xff9fa7cf, 0xff9fa7cf, 0xff9ea8cf,
    0xff9ea9ce, 0xff9ea9ce, 0xff9fa8ce, 0xff9fa8ce, 0xff9ea8ce, 0xff9ea8ce, 0xff9ea8ce, 0xff9ea7ce,
    0xff9da7cf, 0xff9ba6d0, 0xff9aa5d0, 0xff9aa4cf, 0xff9aa4cf, 0xff99a5cf, 0xff99a5cf, 0xff99a5cf,
    0xff99a5cf, 0xff99a5cf, 0xff99a5cf, 0xff99a5cf, 0xff9aa6cf, 0xff9aa6cf, 0xff9aa6d0, 0xff9aa6d0,
    0xff9ba6cf, 0xff9ba6ce, 0xff9ba6ce, 0xff9aa6cf, 0xff9aa6d0, 0xff9ba6d1, 0xff9ba6d1, 0xff9ba6d1,
    0xff9ba6d1, 0xff9ba5d0, 0xff9aa4d0, 0xff99a4d0, 0xff99a4d0, 0xff9aa3d0, 0xff9ba2d0, 0xff9aa2d0,
    0xff98a2cf, 0xff96a2ce, 0xff94a0ce, 0xff939fcf, 0xff939ecf, 0xff939ecf, 0xff929ecf, 0xff919ecf,
    0xff919ecf, 0xff909ece, 0xff909dcd, 0xff909ccd, 0xff8f9bcd, 0xff8e9acd, 0xff8d99cd, 0xff8c99cd,
    0xff8b98cc, 0xff8b98cc, 0xff8b98cb, 0xff8b97cb, 0xff8995ca, 0xff8894c9, 0xff8894c9, 0xff8794c9,
    0xff8693c8, 0xff8392c6, 0xff8191c6, 0xff7f91c7, 0xff7e91c8, 0xff7d8fc8, 0xff7c8dc8, 0xff7c8dc8,
    0xff7b8dc7, 0xff798dc6, 0xff778cc4, 0xff758ac3, 0xff7589c4, 0xff7588c4, 0xff7488c3, 0xff7288c3,
    0xff6f87c3, 0xff6d85c3, 0xff6c84c3, 0xff6c84c2, 0xff6c84c2, 0xff6b83c1, 0xff6b83c1, 0xff6a82c0,
    0xff6981c0, 0xff6880c0, 0xff677fc0, 0xff677fc0, 0xff677ebf, 0xff677ebd, 0xff667dbd, 0xff657dbc,
    0xff657cbc, 0xff657bbc, 0xff657bb9, 0xff667bb6, 0xff677bb6, 0xff677bb7, 0xff677bb7, 0xff677ab7,
    0xff667ab7, 0xff667ab5, 0xff657bb4, 0xff647cb4, 0xff627cb5, 0xff617cb5, 0xff607bb4, 0xff607bb4,
    0xff8a96c3, 0xff8a96c3, 0xff8b98c4, 0xff8d99c5, 0xff8d9ac6, 0xff8d9ac6, 0xff8e9bc6, 0xff8f9cc7,
    0xff8f9cc7, 0xff8f9cc8, 0xff8f9cc9, 0xff919dca, 0xff929eca, 0xff929fcb, 0xff929fcb, 0xff929fcb,
    0xff919eca, 0xff919eca, 0xff919eca, 0xff919eca, 0xff909dca, 0xff909dca, 0xff909dc9, 0xff909dc9,
    0xff909dca, 0xff909ecb, 0xff909ecb, 0xff919fcb, 0xff929fcb, 0xff93a0cc, 0xff93a0cd, 0xff93a0cd,
    0xff93a0cc, 0xff93a0cc, 0xff94a1cd, 0xff94a1ce, 0xff93a1cf, 0xff93a1cf, 0xff94a1cf, 0xff95a1ce,
    0xff95a1ce, 0xff95a1cd, 0xff95a1cd, 0xff94a1cc, 0xff94a1cb, 0xff93a0ca, 0xff93a0ca, 0xff95a2cb,
    0xff96a4cc, 0xff96a4cb, 0xff97a4ca, 0xff99a4ca, 0xff9ba5cc, 0xff9da5cc, 0xff9da6cc, 0xff9da6cc,
    0xff9ea6cb, 0xff9ea6cb, 0xff9ea6cb, 0xff9ea7cc, 0xff9ea8cd, 0xff9ea8ce, 0xff9ea8ce, 0xff9fa7cf,
    0xff9fa7cf, 0xff9fa7cf, 0xff9fa7ce, 0xff9ea8cd, 0xff9ea9cd, 0xff9ea9cd, 0xff9fa7ce, 0xff9fa7ce,
    0xff9ea7cd, 0xff9ea7cd, 0xff9fa7cd, 0xff9fa7ce, 0xff9ea7cf, 0xff9da6cf, 0xff9da5cf, 0xff9da4ce,
    0xff9da4ce, 0xff9ca4cd, 0xff9ba5cd, 0xff9ba6ce, 0xff9ca6ce, 0xff9ca5ce, 0xff9ca5ce, 0xff9ca6ce,
    0xff9da7ce, 0xff9da7ce, 0xff9da6cf, 0xff9da5cf, 0xff9ea5ce, 0xff9ea5ce, 0xff9ea5ce, 0xff9da6ce,
    0xff9da6cf, 0xff9ea6d0, 0xff9ea6d0, 0xff9ea7d0, 0xff9ea7d0, 0xff9da6cf, 0xff9ca5cf, 0xff9ba4cf,
    0xff9ba4cf, 0xff9ca4cf, 0xff9ca3cf, 0xff9ba3cf, 0xff99a3ce, 0xff96a3ce, 0xff94a1cf, 0xff939fd0,
    0xff939ed0, 0xff949ecf, 0xff939ecf, 0xff929ece, 0xff919ece, 0xff909ecd, 0xff909dcc, 0xff909ccc,
    0xff8f9bcc, 0xff8e9acc, 0xff8d99cc, 0xff8d99cc, 0xff8c98cc, 0xff8c98cc, 0xff8b97cc, 0xff8b97cb,
    0xff8a96ca, 0xff8995c9, 0xff8995ca, 0xff8894ca, 0xff8693c9, 0xff8391c7, 0xff8191c6, 0xff8092c6,
    0xff7f92c6, 0xff7e8ec7, 0xff7d8cc8, 0xff7c8cc8, 0xff7b8dc7, 0xff798dc6, 0xff778cc5, 0xff758ac4,
    0xff7589c4, 0xff7588c4, 0xff7488c4, 0xff7288c3, 0xff6f87c3, 0xff6d85c2, 0xff6c84c2, 0xff6c84c1,
    0xff6c84c1, 0xff6b83c0, 0xff6b83c0, 0xff6a82bf, 0xff6981bf, 0xff6880bf, 0xff677fbf, 0xff677fbe,
    0xff667ebd, 0xff667ebd, 0xff657dbc, 0xff647dbc, 0xff647cbd, 0xff647bbd, 0xff647aba, 0xff647ab7,
    0xff647ab6, 0xff657ab7, 0xff657ab7, 0xff6479b7, 0xff6479b7, 0xff6579b5, 0xff6579b3, 0xff647ab3,
    0xff627bb3, 0xff617bb3, 0xff617ab2, 0xff617ab2, 0xff8794c3, 0xff8794c3, 0xff8996c3, 0xff8a98c4,
    0xff8b99c5, 0xff8c99c6, 0xff8d9ac7, 0xff8e9bc8, 0xff8e9bc8, 0xff8e9cc9, 0xff8e9cc9, 0xff919dca,
    0xff929eca, 0xff929eca, 0xff919eca, 0xff919eca, 0xff919dca, 0xff919dca, 0xff919eca, 0xff919eca,
    0xff909dca, 0xff909dca, 0xff909dca, 0xff919eca, 0xff919ecb, 0xff909ecc, 0xff909ecc, 0xff919ecb,
    0xff929ecb, 0xff939fcc, 0xff939fcd, 0xff939fcd, 0xff93a0cd, 0xff93a0cd, 0xff94a1cc, 0xff94a1cc,
    0xff93a1cd, 0xff93a1ce, 0xff94a1ce, 0xff95a1ce, 0xff95a2ce, 0xff95a2cd, 0xff95a2cd, 0xff94a1cd,
    0xff94a1cd, 0xff93a0cc, 0xff93a0cb, 0xff95a3cc, 0xff96a5cc, 0xff96a5cb, 0xff97a4ca, 0xff98a4ca,
    0xff99a5cb, 0xff9ba5cc, 0xff9ba5cd, 0xff9ca5cd, 0xff9da5cc, 0xff9da5cb, 0xff9da5cb, 0xff9ca6cc,
    0xff9ca7cd, 0xff9ca7ce, 0xff9ca7cf, 0xff9da6cf, 0xff9da6cf, 0xff9da6ce, 0xff9ca6ce, 0xff9ba7ce,
    0xff9ba7ce, 0xff9ba6ce, 0xff9ca5ce, 0xff9ca4ce, 0xff9ca4cd, 0xff9ca4cd, 0xff9ea4ce, 0xff9fa4ce,
    0xff9ea4ce, 0xff9ea3ce, 0xff9fa2ce, 0xffa1a1cd, 0xffa2a1cc, 0xffa2a1cb, 0xffa2a1cb, 0xffa4a2cc,
    0xffa5a2cc, 0xffa6a1cc, 0xffa6a1cb, 0xffa7a2cb, 0xffa7a3cb, 0xffa7a3cb, 0xffa6a2cc, 0xffa6a1cd,
    0xffa7a1cd, 0xffa7a1cc, 0xffa6a1cc, 0xffa4a2cc, 0xffa3a2cd, 0xffa3a2ce, 0xffa3a2cf, 0xffa2a3cf,
    0xffa1a3cf, 0xff9fa3cf, 0xff9da3cf, 0xff9ba3cf, 0xff9aa2cf, 0xff9aa2cf, 0xff99a2cf, 0xff98a2cf,
    0xff97a2cf, 0xff95a2cf, 0xff93a0d0, 0xff929fd1, 0xff929ed1, 0xff929ed0, 0xff929ecf, 0xff919ece,
    0xff919ece, 0xff909dcd, 0xff8f9dcd, 0xff8f9dcd, 0xff8f9ccd, 0xff8e9bcd, 0xff8d9acc, 0xff8d99cc,
    0xff8d98cb, 0xff8d98cb, 0xff8d97cb, 0xff8c97cb, 0xff8b97ca, 0xff8a96ca, 0xff8995ca, 0xff8894ca,
    0xff8693c9, 0xff8392c7, 0xff8192c5, 0xff8192c5, 0xff8092c5, 0xff7e8fc7, 0xff7d8dc8, 0xff7c8dc8,
    0xff7a8dc7, 0xff798dc6, 0xff788cc5, 0xff768bc5, 0xff768ac4, 0xff7589c4, 0xff7488c3, 0xff7388c2,
    0xff7187c2, 0xff6e85c2, 0xff6d84c2, 0xff6c83c1, 0xff6c83c1, 0xff6b83c0, 0xff6b83c0, 0xff6a82bf,
    0xff6981bf, 0xff6881bf, 0xff6780be, 0xff667fbe, 0xff667ebd, 0xff647ebd, 0xff637ebc, 0xff627dbc,
    0xff627bbc, 0xff637abc, 0xff637aba, 0xff637ab8, 0xff637ab7, 0xff6379b7, 0xff6379b7, 0xff6279b7,
    0xff6279b6, 0xff6378b4, 0xff6478b2, 0xff6378b1, 0xff6279b1, 0xff6179b1, 0xff6178b0, 0xff6178b0,
    0xff8593c3, 0xff8593c3, 0xff8795c3, 0xff8897c3, 0xff8a98c4, 0xff8b99c6, 0xff8c9ac7, 0xff8c9bc8,
    0xff8c9bc8, 0xff8d9cc8, 0xff8e9cc8, 0xff909dc9, 0xff919dc9, 0xff919dc8, 0xff909dc8, 0xff909dc9,
    0xff909cca, 0xff909cca, 0xff919ec9, 0xff919ec9, 0xff909dc9, 0xff909cca, 0xff909dca, 0xff919ecb,
    0xff919ecb, 0xff919dcc, 0xff919dcc, 0xff929ecc, 0xff929ecc, 0xff939ecd, 0xff939fcd, 0xff94a0ce,
    0xff94a1ce, 0xff94a1cd, 0xff93a0cc, 0xff93a0cc, 0xff93a0cc, 0xff93a0cc, 0xff94a1cd, 0xff94a1cd,
    0xff95a2ce, 0xff95a2ce, 0xff95a2ce, 0xff94a1ce, 0xff94a1ce, 0xff93a0cd, 0xff93a1cd, 0xff95a4cd,
    0xff97a5cd, 0xff97a4cc, 0xff97a3cb, 0xff97a3cb, 0xff98a4cc, 0xff99a4cc, 0xff9aa4cd, 0xff9ba4cd,
    0xff9ca5cc, 0xff9ca5cc, 0xff9ca5cc, 0xff9ba5cd, 0xff9ba5ce, 0xff9ba6cf, 0xff9ba6cf, 0xff9ca6cf,
    0xff9ca6cf, 0xff9ba5ce, 0xff9aa5ce, 0xff9aa5ce, 0xff9aa5cf, 0xff9ba4cf, 0xff9ba3ce, 0xff9ca2ce,
    0xff9da1ce, 0xff9ea1ce, 0xffa1a1ce, 0xffa2a1ce, 0xffa2a1cd, 0xffa2a1cc, 0xffa4a1cc, 0xffa7a0cb,
    0xffaaa0ca, 0xffaa9fc9, 0xffab9fc8, 0xffafa0c8, 0xffb1a0c9, 0xffb2a0c9, 0xffb2a0c8, 0xffb3a1c8,
    0xffb3a2c9, 0xffb3a2ca, 0xffb2a0cb, 0xffb29fcb, 0xffb29fca, 0xffb29fc9, 0xffb19fc9, 0xffae9fca,
    0xffac9fcb, 0xffaba0cd, 0xffaaa0ce, 0xffa9a1cd, 0xffa8a1cd, 0xffa3a2ce, 0xffa0a2cf, 0xff9ea1cf,
    0xff9ca0cf, 0xff9ba0cf, 0xff9aa2ce, 0xff98a2ce, 0xff96a2cf, 0xff94a1d0, 0xff93a1d0, 0xff93a0d0,
    0xff929fd0, 0xff919ed0, 0xff919ecf, 0xff919fce, 0xff909fce, 0xff8f9dcd, 0xff8e9ccd, 0xff8f9cce,
    0xff909dce, 0xff8f9dcd, 0xff8e9ccc, 0xff8e9bcb, 0xff8d9aca, 0xff8d99ca, 0xff8c98cb, 0xff8c98cb,
    0xff8b98cb, 0xff8a97cb, 0xff8996cb, 0xff8795ca, 0xff8594c8, 0xff8392c6, 0xff8192c4, 0xff8192c4,
    0xff8192c4, 0xff7f90c6, 0xff7d8ec8, 0xff7b8dc8, 0xff798dc7, 0xff788dc7, 0xff778dc6, 0xff778cc5,
    0xff768ac4, 0xff7589c3, 0xff7488c2, 0xff7388c2, 0xff7287c1, 0xff7086c1, 0xff6f84c1, 0xff6e83c1,
    0xff6c82c1, 0xff6c83c0, 0xff6b83c0, 0xff6a81c0, 0xff6980bf, 0xff6880be, 0xff6681bd, 0xff6681bd,
    0xff6580bd, 0xff647fbd, 0xff627fbd, 0xff617ebd, 0xff627cbc, 0xff637abb, 0xff637aba, 0xff627ab9,
    0xff627ab8, 0xff6179b8, 0xff6179b7, 0xff6179b6, 0xff6179b5, 0xff6278b3, 0xff6378b1, 0xff6378b0,
    0xff6278b0, 0xff6278b0, 0xff6177af, 0xff6177af, 0xff8493c3, 0xff8493c3, 0xff8595c2, 0xff8696c2,
    0xff8797c3, 0xff8998c5, 0xff8a99c6, 0xff8a9ac7, 0xff8a9ac7, 0xff8b9bc6, 0xff8c9bc6, 0xff8e9cc7,
    0xff8f9cc8, 0xff8f9cc7, 0xff8e9cc6, 0xff8e9cc7, 0xff8f9bc8, 0xff8f9bc9, 0xff909cc8, 0xff909dc8,
    0xff909cc9, 0xff909cca, 0xff909dcb, 0xff919ecb, 0xff919ecb, 0xff919dcc, 0xff919dcc, 0xff919dcc,
    0xff919dcc, 0xff929dcc, 0xff939ecc, 0xff94a0cd, 0xff94a1ce, 0xff94a1cd, 0xff93a0cc, 0xff93a0cb,
    0xff93a0cb, 0xff93a0cb, 0xff94a1cc, 0xff94a1cd, 0xff95a2ce, 0xff95a2ce, 0xff95a2cf, 0xff94a1cf,
    0xff94a1cf, 0xff93a1cf, 0xff94a2ce, 0xff96a4cd, 0xff98a5cd, 0xff99a4cd, 0xff98a3cc, 0xff97a3cb,
    0xff96a4cb, 0xff96a4cb, 0xff98a3cc, 0xff9aa3cd, 0xff9ca4cc, 0xff9ca4cc, 0xff9ca4cc, 0xff9ba4cd,
    0xff9ba4cd, 0xff9ca5ce, 0xff9ea5ce, 0xff9fa6ce, 0xff9fa6ce, 0xff9fa6cd, 0xff9fa6cd, 0xffa0a6ce,
    0xffa1a5ce, 0xffa2a5cd, 0xffa3a4cc, 0xffa5a4cc, 0xffa6a4cc, 0xffa8a4cc, 0xffaba4cc, 0xffada4cc,
    0xffada4cb, 0xffafa5c9, 0xffb2a5c9, 0xffb7a6c9, 0xffbaa6c8, 0xffbaa6c7, 0xffbca6c6, 0xffbfa7c6,
    0xffc2a7c7, 0xffc3a7c7, 0xffc3a8c6, 0xffc4a9c6, 0xffc4a9c7, 0xffc4a9c7, 0xffc3a8c8, 0xffc3a7c8,
    0xffc4a7c7, 0xffc4a7c7, 0xffc2a7c7, 0xffbfa6c8, 0xffbca6c9, 0xffbaa6cb, 0xffb9a6cb, 0xffb8a6ca,
    0xffb6a6ca, 0xffb1a6cb, 0xffada6cc, 0xffaaa4cd, 0xffa8a3cd, 0xffa6a4cd, 0xffa4a5cc, 0xffa1a5cd,
    0xff9fa3ce, 0xff9da2cf, 0xff9ca2cf, 0xff9ba2ce, 0xff98a1cf, 0xff959fcf, 0xff959fce, 0xff959fcd,
    0xff949ecd, 0xff919dce, 0xff909cce, 0xff909dce, 0xff919ece, 0xff909ecd, 0xff8f9dcc, 0xff8e9ccb,
    0xff8d9ac9, 0xff8d98c9, 0xff8c98c9, 0xff8c98ca, 0xff8b98cb, 0xff8a97cb, 0xff8896cb, 0xff8695c9,
    0xff8494c8, 0xff8394c6, 0xff8293c4, 0xff8292c4, 0xff8291c4, 0xff8090c6, 0xff7d8fc8, 0xff7a8dc8,
    0xff788cc7, 0xff788cc7, 0xff788dc6, 0xff788dc5, 0xff768bc4, 0xff758ac3, 0xff7489c2, 0xff7388c1,
    0xff7287c1, 0xff7186c1, 0xff7084c1, 0xff6e83c1, 0xff6c82c1, 0xff6c83c0, 0xff6b83c0, 0xff6a81c0,
    0xff6980bf, 0xff6880bd, 0xff6681bc, 0xff6581bc, 0xff6580bd, 0xff637fbd, 0xff617fbd, 0xff607ebd,
    0xff617cbb, 0xff627aba, 0xff627ab9, 0xff617ab9, 0xff617ab8, 0xff6079b8, 0xff6079b6, 0xff5f79b5,
    0xff5f79b4, 0xff6078b2, 0xff6177b1, 0xff6176b0, 0xff6176af, 0xff6176ae, 0xff6075ae, 0xff6075ae,
    0xff8192c2, 0xff8192c2, 0xff8394c3, 0xff8595c3, 0xff8696c3, 0xff8697c4, 0xff8798c4, 0xff8899c5,
    0xff8899c5, 0xff8899c5, 0xff8999c5, 0xff8b9ac6, 0xff8c9bc7, 0xff8d9bc7, 0xff8d9bc6, 0xff8d9bc7,
    0xff8e9bc8, 0xff8e9bc8, 0xff8e9cc8, 0xff8e9cc8, 0xff8f9cc9, 0xff909cca, 0xff919dcb, 0xff919ecb,
    0xff919ecb, 0xff909dcb, 0xff909dcb, 0xff909dcc, 0xff919dcc, 0xff929dcb, 0xff939ecb, 0xff94a0cc,
    0xff94a1cd, 0xff94a1cd, 0xff93a0cb, 0xff93a0cb, 0xff94a0cb, 0xff94a0cb, 0xff94a1cc, 0xff94a1cd,
    0xff95a2ce, 0xff95a2ce, 0xff95a2ce, 0xff94a1ce, 0xff94a1ce, 0xff94a2ce, 0xff95a3ce, 0xff97a4ce,
    0xff98a4ce, 0xff99a4cd, 0xff98a3cc, 0xff97a3cb, 0xff95a3cb, 0xff95a3cb, 0xff97a2cc, 0xff98a1cd,
    0xff99a2cc, 0xff99a2cc, 0xff98a2cc, 0xff99a1cd, 0xff9ba1cd, 0xff9ea2cd, 0xffa2a2cc, 0xffa5a3cb,
    0xffa9a3ca, 0xffada4c9, 0xffb0a5c9, 0xffb3a5c9, 0xffb6a6c8, 0xffb9a7c7, 0xffbca8c6, 0xffc0aac5,
    0xffc3abc5, 0xffc5adc5, 0xffc8afc5, 0xffcab1c4, 0xffcdb3c3, 0xffcfb6c2, 0xffd3b8c2, 0xffd6bac2,
    0xffd9bcc2, 0xffdabdc1, 0xffdbbec1, 0xffdebfc2, 0xffe0c0c2, 0xffe1c1c1, 0xffe2c1c1, 0xffe2c2c2,
    0xffe2c2c3, 0xffe2c2c3, 0xffe1c1c2, 0xffe1c1c2, 0xffe1c1c2, 0xffe1c1c2, 0xffe0c0c1, 0xffddbec1,
    0xffdbbdc2, 0xffdabdc3, 0xffd8bbc3, 0xffd8bac2, 0xffd6b8c1, 0xffd2b5c1, 0xffceb3c2, 0xffcbb0c3,
    0xffc8acc4, 0xffc5aac4, 0xffc1a9c4, 0xffbca7c5, 0xffb7a4c7, 0xffb2a2c9, 0xffaea0ca, 0xffaa9fca,
    0xffa49ecb, 0xff9f9dcd, 0xff9b9dcd, 0xff989dcd, 0xff949dcd, 0xff919bce, 0xff909bce, 0xff8f9ccd,
    0xff8f9dcd, 0xff8f9dcd, 0xff8e9ccd, 0xff8d9bcc, 0xff8c9acb, 0xff8b99c9, 0xff8b98c9, 0xff8b98c9,
    0xff8a98ca, 0xff8997ca, 0xff8796ca, 0xff8595c9, 0xff8494c8, 0xff8294c6, 0xff8292c4, 0xff8291c4,
    0xff8290c4, 0xff808fc6, 0xff7d8fc7, 0xff7a8ec7, 0xff788cc7, 0xff788cc7, 0xff788cc6, 0xff788cc5,
    0xff768bc4, 0xff758ac3, 0xff7489c2, 0xff7388c2, 0xff7287c1, 0xff7186c0, 0xff7085c0, 0xff6e83c1,
    0xff6c83c1, 0xff6c83bf, 0xff6b83be, 0xff6a81bf, 0xff6980bf, 0xff6880be, 0xff6681bc, 0xff6581bc,
    0xff6480bd, 0xff627fbd, 0xff617ebd, 0xff607dbd, 0xff607cbc, 0xff617bba, 0xff617ab9, 0xff607ab8,
    0xff607ab8, 0xff5f79b7, 0xff5f79b6, 0xff5e79b5, 0xff5e79b4, 0xff5e77b2, 0xff5f76b1, 0xff6075af,
    0xff6075ae, 0xff6075ad, 0xff5f74ad, 0xff5f74ad, 0xff8092c1, 0xff8092c1, 0xff8294c3, 0xff8495c4,
    0xff8496c4, 0xff8496c3, 0xff8597c3, 0xff8698c4, 0xff8698c4, 0xff8797c3, 0xff8797c3, 0xff8899c5,
    0xff899ac6, 0xff8b9bc7, 0xff8d9bc7, 0xff8e9bc8, 0xff8d9bc8, 0xff8d9bc8, 0xff8c9cc7, 0xff8c9cc7,
    0xff8e9cc8, 0xff8f9cc9, 0xff909dca, 0xff909dca, 0xff909dca, 0xff909cca, 0xff909cca, 0xff909dcb,
    0xff909ecc, 0xff929fcb, 0xff939fcb, 0xff93a0cb, 0xff93a0cc, 0xff93a0cc, 0xff929fcc, 0xff929fcc,
    0xff93a0cc, 0xff94a1cc, 0xff95a2cc, 0xff95a2cd, 0xff95a2ce, 0xff94a2cf, 0xff94a2ce, 0xff94a1cc,
    0xff94a1cc, 0xff94a2cd, 0xff95a3ce, 0xff97a3cf, 0xff98a3ce, 0xff98a3cd, 0xff97a3cb, 0xff96a3cb,
    0xff95a3cb, 0xff95a2cb, 0xff96a1cc, 0xff97a0cc, 0xff98a0cc, 0xff98a1cc, 0xff98a1cc, 0xff99a0cc,
    0xff9da0cc, 0xffa2a1cd, 0xffa8a1cb, 0xffaea2c9, 0xffb4a3c7, 0xffbca5c6, 0xffc1a6c6, 0xffc6a7c4,
    0xffcbaac2, 0xffd1acc1, 0xffd5afbf, 0xffdab3bf, 0xffddb5bf, 0xffdfb9bf, 0xffe2bdbe, 0xffe5c0be,
    0xffe9c3be, 0xffedc6be, 0xffefcabe, 0xfff0cebd, 0xfff2d2bd, 0xfff4d4be, 0xfff5d5be, 0xfff6d7bf,
    0xfff6d8bf, 0xfff7d9bf, 0xfff8dac0, 0xfff8dbc1, 0xfff8dbc2, 0xfff8dbc1, 0xfff7dbbf, 0xfff7dbbe,
    0xfff7dbbf, 0xfff7dbc0, 0xfff6dabf, 0xfff5d7bd, 0xfff4d5bc, 0xfff3d3bc, 0xfff2d1bc, 0xfff2cfbb,
    0xfff1cbbb, 0xffefc6ba, 0xffecc1ba, 0xffe9bcbb, 0xffe6b8bd, 0xffe3b4bd, 0xffdfb0bd, 0xffd8acbf,
    0xffd1a8c1, 0xffc9a4c3, 0xffc1a0c4, 0xffba9ec5, 0xffb29cc7, 0xffaa9cca, 0xffa39ccb, 0xff9d9ccc,
    0xff979ccd, 0xff959ace, 0xff929ace, 0xff909bcd, 0xff8f9ccc, 0xff8f9ccc, 0xff8e9bcd, 0xff8d9acd,
    0xff8b99cc, 0xff8999ca, 0xff8998c9, 0xff8998c8, 0xff8998c8, 0xff8897c9, 0xff8796c9, 0xff8595c8,
    0xff8494c7, 0xff8393c7, 0xff8391c5, 0xff8291c4, 0xff8190c4, 0xff7e90c5, 0xff7c8fc6, 0xff7a8dc7,
    0xff798bc7, 0xff798bc7, 0xff788bc6, 0xff778bc4, 0xff768bc4, 0xff758ac3, 0xff7388c3, 0xff7287c2,
    0xff7286c0, 0xff7186bf, 0xff7085c0, 0xff6e84c1, 0xff6c84c0, 0xff6c84be, 0xff6b84bd, 0xff6a82bd,
    0xff6880be, 0xff6780bd, 0xff6580bc, 0xff6480bc, 0xff647fbc, 0xff627fbc, 0xff617ebc, 0xff607dbc,
    0xff607cbc, 0xff607cbb, 0xff607cb9, 0xff5f7bb6, 0xff5f7ab6, 0xff5f79b7, 0xff5f78b7, 0xff5e78b5,
    0xff5e78b4, 0xff5e77b2, 0xff5e76b1, 0xff5f75af, 0xff5f74ae, 0xff5f74ad, 0xff5e74ad, 0xff5e74ad,
    0xff8295c2, 0xff8295c2, 0xff8496c4, 0xff8596c5, 0xff8495c5, 0xff8295c3, 0xff8296c2, 0xff8397c2,
    0xff8497c2, 0xff8596c2, 0xff8596c3, 0xff8698c4, 0xff8799c5, 0xff8a9ac6, 0xff8c9ac7, 0xff8d9ac7,
    0xff8c9bc7, 0xff8c9bc7, 0xff8b9bc7, 0xff8b9bc7, 0xff8d9cc8, 0xff8e9cc8, 0xff8f9cc9, 0xff8f9cc9,
    0xff8f9cc9, 0xff8f9cc9, 0xff8f9cc9, 0xff8f9dca, 0xff909ecb, 0xff919fca, 0xff929fca, 0xff929fca,
    0xff929fcb, 0xff929fcb, 0xff929fcc, 0xff929fcc, 0xff93a0cd, 0xff94a1cd, 0xff95a2cd, 0xff95a2cd,
    0xff95a2ce, 0xff94a1ce, 0xff94a1cd, 0xff94a1ca, 0xff94a1ca, 0xff95a2cc, 0xff96a3cd, 0xff98a2ce,
    0xff99a2ce, 0xff99a2cc, 0xff99a3ca, 0xff99a3ca, 0xff99a3ca, 0xff99a3ca, 0xff9ba1ca, 0xff9ca1ca,
    0xff9da2ca, 0xff9fa3ca, 0xffa1a3ca, 0xffa4a3ca, 0xffa9a4ca, 0xffafa5ca, 0xffb7a7c8, 0xffbca8c6,
    0xffc3a9c4, 0xffccacc4, 0xffd2aec4, 0xffd7b0c2, 0xffdbb2c0, 0xffe1b6bf, 0xffe6babe, 0xffebbebe,
    0xffeec1bf, 0xffefc5bf, 0xfff1c9be, 0xfff3ccbe, 0xfff7cfbf, 0xfffbd3c0, 0xfffcd8c0, 0xfffdddc0,
    0xfffee1c1, 0xffffe4c2, 0xffffe6c3, 0xfffee8c4, 0xfffee9c4, 0xfffeeac4, 0xffffebc5, 0xffffebc6,
    0xffffecc7, 0xffffecc6, 0xffffedc4, 0xffffedc3, 0xffffedc4, 0xffffecc5, 0xffffebc4, 0xffffe9c1,
    0xffffe8c0, 0xffffe6bf, 0xffffe3bf, 0xffffe0be, 0xffffdcbd, 0xffffd6bb, 0xffffd1ba, 0xfffdccbb,
    0xfffbc8bc, 0xfff8c3bc, 0xfff6bfbd, 0xfff0b9be, 0xffe8b6bf, 0xffe0b1c0, 0xffd6abc1, 0xffcea7c2,
    0xffc5a5c4, 0xffbca4c7, 0xffb3a3c8, 0xffaca1c9, 0xffa59fca, 0xffa19ecb, 0xff9e9ecb, 0xff9a9dca,
    0xff979dc9, 0xff949cca, 0xff929bcc, 0xff909acc, 0xff8d99cc, 0xff8b99ca, 0xff8a98c8, 0xff8a98c7,
    0xff8997c7, 0xff8896c7, 0xff8796c8, 0xff8595c8, 0xff8494c8, 0xff8493c7, 0xff8291c5, 0xff8191c4,
    0xff8090c4, 0xff7e8fc4, 0xff7c8ec5, 0xff7b8dc6, 0xff7a8bc6, 0xff798ac5, 0xff798ac4, 0xff778ac3,
    0xff768ac2, 0xff758ac2, 0xff7388c2, 0xff7287c2, 0xff7186c0, 0xff7085be, 0xff6f85bf, 0xff6e85c0,
    0xff6c85bf, 0xff6c85bd, 0xff6b84bb, 0xff6a82bc, 0xff6880bd, 0xff677fbd, 0xff657fbc, 0xff647fbc,
    0xff647fbb, 0xff627ebb, 0xff617dbb, 0xff607cbb, 0xff5f7cbc, 0xff5f7cbb, 0xff5e7cb8, 0xff5e7bb5,
    0xff5e7ab5, 0xff5f79b6, 0xff5f78b6, 0xff5f78b5, 0xff5e78b4, 0xff5d76b3, 0xff5d75b1, 0xff5d74af,
    0xff5e74ad, 0xff5e74ac, 0xff5d73ac, 0xff5d73ac, 0xff8b9bc5, 0xff8b9bc5, 0xff8899c5, 0xff8697c4,
    0xff8495c4, 0xff8295c3, 0xff8295c2, 0xff8296c2, 0xff8396c2, 0xff8496c3, 0xff8596c4, 0xff8698c4,
    0xff8799c4, 0xff899ac5, 0xff8b9ac7, 0xff8b9bc7, 0xff8a9bc6, 0xff8a9bc6, 0xff8a9ac7, 0xff8b9ac7,
    0xff8c9bc7, 0xff8d9bc7, 0xff8e9bc8, 0xff8e9bc9, 0xff8e9bc9, 0xff8f9cc8, 0xff8f9cc9, 0xff909dca,
    0xff909ecb, 0xff919eca, 0xff919ec9, 0xff929eca, 0xff929fcb, 0xff929fcb, 0xff929fcb, 0xff929fcb,
    0xff939fcc, 0xff93a0cd, 0xff94a2cd, 0xff94a2cd, 0xff94a1cd, 0xff93a0cc, 0xff93a0cb, 0xff94a1ca,
    0xff94a1ca, 0xff94a2cb, 0xff95a2cc, 0xff97a1cc, 0xff98a1cc, 0xff98a1cb, 0xff99a1ca, 0xff9aa1ca,
    0xff9da1c9, 0xffa1a1c8, 0xffa4a0c7, 0xffa9a1c6, 0xffafa3c4, 0xffb5a6c3, 0xffbca9c3, 0xffc3acc3,
    0xffc9b0c2, 0xffceb5c1, 0xffd4b9c1, 0xffd8bcc1, 0xffdcc0c1, 0xffdfc3c3, 0xffe1c5c4, 0xffe2c7c5,
    0xffe2c9c6, 0xffe3cbc6, 0xffe4ccc6, 0xffe5cec8, 0xffe5cfca, 0xffe5d0cc, 0xffe4d2ce, 0xffe5d3cf,
    0xffe7d5d1, 0xffead8d2, 0xffeadad3, 0xffeaddd3, 0xffeae0d5, 0xffece2d6, 0xffece3d7, 0xffebe4d8,
    0xffeae4d9, 0xffeae5d9, 0xffebe6d9, 0xffebe6da, 0xffece6db, 0xffece6db, 0xffece7d9, 0xffece8d8,
    0xffede9d9, 0xffedeada, 0xffedead9, 0xffeeead6, 0xffefead5, 0xffefe9d5, 0xfff1e9d3, 0xfff2e8d2,
    0xfff3e7d1, 0xfff7e4ce, 0xfff9e2cc, 0xfffae2cb, 0xfffbe1ca, 0xfffcdfc8, 0xfffddbc6, 0xfffcd7c4,
    0xfffad4c2, 0xfff5d0c1, 0xffefcabf, 0xffe9c5bf, 0xffe2c0bf, 0xffdbbbbf, 0xffd5b5bf, 0xffcfb0bf,
    0xffc7aac0, 0xffc0a5c2, 0xffb9a1c3, 0xffb09ec3, 0xffa99cc4, 0xffa29ac6, 0xff9b98c9, 0xff9497ca,
    0xff8f97ca, 0xff8b97ca, 0xff8a97c9, 0xff8a97c8, 0xff8896c6, 0xff8695c6, 0xff8595c7, 0xff8494c8,
    0xff8493c8, 0xff8492c7, 0xff8292c5, 0xff8192c5, 0xff7f91c4, 0xff7d8fc4, 0xff7c8ec4, 0xff7b8dc4,
    0xff7a8bc4, 0xff798ac3, 0xff7989c2, 0xff7789c2, 0xff768ac1, 0xff758ac1, 0xff7388c1, 0xff7287c0,
    0xff7186bf, 0xff7085be, 0xff6f84be, 0xff6e84be, 0xff6c84bd, 0xff6c84bb, 0xff6b84ba, 0xff6a82bb,
    0xff6880bc, 0xff677fbc, 0xff657ebc, 0xff647ebb, 0xff647eba, 0xff627eba, 0xff617dbb, 0xff607cbb,
    0xff5f7cbb, 0xff5e7cba, 0xff5d7cb8, 0xff5d7bb5, 0xff5d7ab5, 0xff5e79b5, 0xff5e78b5, 0xff5e78b5,
    0xff5d78b4, 0xff5c77b3, 0xff5c75b1, 0xff5c74ae, 0xff5d73ac, 0xff5d72ab, 0xff5c72ab, 0xff5c72ab,
    0xff94a2c8, 0xff94a2c8, 0xff8d9dc5, 0xff8799c3, 0xff8497c3, 0xff8496c4, 0xff8395c3, 0xff8294c2,
    0xff8394c2, 0xff8496c4, 0xff8697c5, 0xff8798c4, 0xff8799c3, 0xff8899c4, 0xff8999c6, 0xff8999c6,
    0xff899ac6, 0xff8a9ac6, 0xff8b9ac6, 0xff8c9ac6, 0xff8d9bc6, 0xff8d9bc6, 0xff8d9bc7, 0xff8d9bc9,
    0xff8e9bc9, 0xff8e9bc8, 0xff909cc8, 0xff919dc9, 0xff919eca, 0xff909dc9, 0xff909dc9, 0xff919eca,
    0xff929fcb, 0xff929fcb, 0xff929fcb, 0xff929fcb, 0xff929fcc, 0xff929fcc, 0xff93a2cc, 0xff94a3cc,
    0xff94a1cb, 0xff939fca, 0xff949fca, 0xff95a1cb, 0xff95a1cb, 0xff95a0cb, 0xff95a0cb, 0xff97a1cb,
    0xff98a1ca, 0xff99a1ca, 0xff9aa1c9, 0xff9ea1c9, 0xffa2a1c9, 0xffa9a1c7, 0xffafa1c5, 0xffb7a3c2,
    0xffc2a7bf, 0xffccabbd, 0xffd6b0bc, 0xffe0b6bc, 0xffe7bdbc, 0xffebc4bb, 0xffeeccbd, 0xffeed1bf,
    0xffedd6c1, 0xffe9d9c4, 0xffe5dac7, 0xffe1dccb, 0xffdddccf, 0xffd9dbd1, 0xffd6dad2, 0xffd2d8d5,
    0xffd0d7d9, 0xffcdd6dd, 0xffcbd4e0, 0xffcad3e2, 0xffcad3e4, 0xffcbd3e5, 0xffcbd3e6, 0xffcbd4e8,
    0xffcbd4ea, 0xffccd5eb, 0xffcdd5ec, 0xffcdd4ed, 0xffccd4ee, 0xffccd5ee, 0xffccd6ee, 0xffccd6ee,
    0xffcdd5ef, 0xffcdd5ef, 0xffcdd7ee, 0xffcdd8ee, 0xffcfdaef, 0xffd0dbf0, 0xffd1ddef, 0xffd2dfed,
    0xffd3e1ed, 0xffd4e3ec, 0xffd6e5eb, 0xffd7e6ea, 0xffdbe7e8, 0xffe0e9e4, 0xffe5ece1, 0xffe9f0de,
    0xffecf4dc, 0xfff1f5d8, 0xfff6f3d5, 0xfffbf1cf, 0xfffef0ca, 0xffffeec5, 0xfffeeac1, 0xfffbe4bf,
    0xfff8dcbc, 0xfff4d3ba, 0xfff1c9b8, 0xffeec0b6, 0xffe7b6b7, 0xffdeaeb9, 0xffd3a8bc, 0xffc7a1be,
    0xffbd9ec0, 0xffb19ac3, 0xffa698c5, 0xff9c97c6, 0xff9596c7, 0xff8f96c7, 0xff8d96c8, 0xff8b96c8,
    0xff8895c7, 0xff8694c6, 0xff8593c7, 0xff8593c8, 0xff8593c8, 0xff8493c7, 0xff8293c5, 0xff8093c5,
    0xff7e92c4, 0xff7d90c3, 0xff7d8ec3, 0xff7c8cc3, 0xff7a8bc2, 0xff798ac1, 0xff7989c0, 0xff7789c0,
    0xff758ac0, 0xff748ac0, 0xff7389bf, 0xff7388be, 0xff7186be, 0xff6f84be, 0xff6e83be, 0xff6d83bd,
    0xff6b83bc, 0xff6b83bb, 0xff6a83ba, 0xff6981ba, 0xff677fbb, 0xff657ebc, 0xff647ebc, 0xff647ebb,
    0xff637dba, 0xff627db9, 0xff607cba, 0xff5f7cba, 0xff5e7bba, 0xff5e7bb9, 0xff5e7bb8, 0xff5d7bb6,
    0xff5d7ab5, 0xff5c79b5, 0xff5c78b5, 0xff5b77b4, 0xff5b77b3, 0xff5b75b2, 0xff5c74b1, 0xff5c73af,
    0xff5c73ac, 0xff5b72ab, 0xff5a71aa, 0xff5a71aa, 0xff9ca7cb, 0xff9ca7cb, 0xff92a1c6, 0xff899bc3,
    0xff8598c3, 0xff8597c4, 0xff8395c3, 0xff8293c2, 0xff8393c3, 0xff8595c5, 0xff8797c6, 0xff8899c4,
    0xff8899c3, 0xff8899c4, 0xff8899c5, 0xff8899c5, 0xff889ac5, 0xff899ac5, 0xff8b99c6, 0xff8c99c6,
    0xff8c9ac6, 0xff8c9ac6, 0xff8c9ac7, 0xff8c9ac8, 0xff8d9ac8, 0xff8e9bc8, 0xff909cc8, 0xff919dc9,
    0xff919eca, 0xff909dc9, 0xff8f9cc9, 0xff909dca, 0xff919ecb, 0xff929fcb, 0xff929fca, 0xff929fca,
    0xff919ecb, 0xff919ecb, 0xff92a1cc, 0xff93a2cc, 0xff93a1ca, 0xff949fc9, 0xff959fca, 0xff97a1cc,
    0xff98a1cc, 0xff98a0ca, 0xff99a0c9, 0xff9ba2c8, 0xff9ea3c8, 0xffa0a4c8, 0xffa4a4c8, 0xffa9a4c8,
    0xffb0a5c7, 0xffb8a7c5, 0xffbea9c4, 0xffc7acc1, 0xffd2b0be, 0xffddb5bc, 0xffe8bbbc, 0xfff1c2bd,
    0xfff7c9bc, 0xfff8d1bc, 0xfff8d9be, 0xfff6dfc2, 0xfff1e3c6, 0xffe9e6ca, 0xffe1e6cd, 0xffdae7d3,
    0xffd3e6d8, 0xffcce3dc, 0xffc6e0dd, 0xffc0dce1, 0xffbcdae5, 0xffb8d6e9, 0xffb5d3ed, 0xffb3d0f0,
    0xffb1cef2, 0xffb0ccf3, 0xffb0cbf5, 0xffb1caf7, 0xffb1c9f9, 0xffb2c8fa, 0xffb2c8fb, 0xffb3c7fc,
    0xffb3c6fc, 0xffb2c6fc, 0xffb2c7fc, 0xffb2c7fc, 0xffb3c6fc, 0xffb4c6fc, 0xffb4c8fc, 0xffb5cafd,
    0xffb7ccff, 0xffb9ceff, 0xffbbd0fe, 0xffbcd2fd, 0xffbdd6fd, 0xffbedafd, 0xffc0defd, 0xffc2e0fc,
    0xffc6e4fa, 0xffcce9f6, 0xffd2eff3, 0xffd7f6f0, 0xffdcfcec, 0xffe2ffe8, 0xffe9ffe3, 0xfff2ffdc,
    0xfff9ffd6, 0xfffeffd0, 0xfffffdcb, 0xfffff8c7, 0xfffff0c3, 0xffffe5bf, 0xffffdbba, 0xffffd2b7,
    0xfffcc7b6, 0xfff4beb9, 0xffeab6bb, 0xffdeaebd, 0xffd2a9be, 0xffc5a3c0, 0xffb79fc1, 0xffac9cc2,
    0xffa49bc2, 0xff9c99c4, 0xff9999c6, 0xff9598c7, 0xff8f96c6, 0xff8b95c5, 0xff8993c6, 0xff8892c7,
    0xff8792c7, 0xff8593c6, 0xff8393c4, 0xff8093c4, 0xff7e92c3, 0xff7d90c2, 0xff7d8ec2, 0xff7b8cc1,
    0xff798bc0, 0xff798ac0, 0xff7889bf, 0xff7789bf, 0xff7589be, 0xff7489be, 0xff7389bc, 0xff7388bc,
    0xff7186bd, 0xff6f84be, 0xff6e83bd, 0xff6d82bc, 0xff6b82bb, 0xff6b82ba, 0xff6a82ba, 0xff6980ba,
    0xff677fba, 0xff657ebb, 0xff647ebb, 0xff647dba, 0xff637cb9, 0xff627cb8, 0xff607cb9, 0xff5f7cb9,
    0xff5e7bb8, 0xff5d7ab7, 0xff5d7ab7, 0xff5d7ab7, 0xff5c79b6, 0xff5b78b5, 0xff5b78b4, 0xff5a78b3,
    0xff5a77b3, 0xff5a75b2, 0xff5b74b0, 0xff5b74ae, 0xff5b73ab, 0xff5a72aa, 0xff5971a9, 0xff5970a9,
    0xff9ea9cb, 0xff9ea9cb, 0xff95a3c8, 0xff8c9ec5, 0xff879bc4, 0xff8598c4, 0xff8395c3, 0xff8292c1,
    0xff8292c2, 0xff8495c4, 0xff8697c6, 0xff8898c5, 0xff8898c4, 0xff8898c4, 0xff8899c4, 0xff889ac4,
    0xff889ac5, 0xff889ac5, 0xff8998c6, 0xff8a98c6, 0xff8b99c7, 0xff8b9ac7, 0xff8b9ac7, 0xff8c9ac7,
    0xff8d9ac7, 0xff8e9bc8, 0xff909cc8, 0xff909dc9, 0xff909dc9, 0xff8f9cca, 0xff8e9cca, 0xff8f9ccb,
    0xff909dcb, 0xff909ecb, 0xff909fca, 0xff909fca, 0xff909ecb, 0xff909ecb, 0xff909fcc, 0xff91a0cc,
    0xff919fca, 0xff939ec9, 0xff959eca, 0xff97a0cc, 0xff9aa0cc, 0xff9da0ca, 0xffa1a0c8, 0xffa7a1c6,
    0xffaea4c5, 0xffb6a8c4, 0xffbfadc3, 0xffc6b1c2, 0xffcdb4c1, 0xffd3b9c1, 0xffd7bec1, 0xffdbc3c1,
    0xffdfc8c2, 0xffe2cbc3, 0xffe6cec6, 0xffe8d1c8, 0xffe8d4cb, 0xffe7d7cc, 0xffe4d9d0, 0xffe2dbd4,
    0xffdddcd7, 0xffd6ddd9, 0xffd0dcda, 0xffcadcde, 0xffc4dae2, 0xffbed8e5, 0xffbad5e6, 0xffb4d2e8,
    0xffb1d0ea, 0xffafceed, 0xffadcbf0, 0xffacc9f2, 0xffabc7f3, 0xffaac6f4, 0xffaac5f5, 0xffabc4f6,
    0xffabc3f7, 0xffacc3f8, 0xffacc2f8, 0xffadc1f8, 0xffaec1f8, 0xffaec1f8, 0xffadc2f8, 0xffadc2f8,
    0xffaec1f8, 0xffafc1f9, 0xffb0c3fb, 0xffb1c5fc, 0xffb4c7fd, 0xffb6c9fd, 0xffb8ccfe, 0xffbacefe,
    0xffbbd1fe, 0xffbbd4fe, 0xffbdd7fe, 0xffbedafe, 0xffc2ddfe, 0xffc7e1fc, 0xffcbe5fa, 0xffcfeaf8,
    0xffd2eff5, 0xffd6f1f3, 0xffdaf2f1, 0xffdff3ed, 0xffe4f4e8, 0xffe8f4e3, 0xffebf5df, 0xffecf3dc,
    0xffedf0d8, 0xffefebd4, 0xfff4e7cf, 0xfff9e3c9, 0xfffbdfc5, 0xfffadbc3, 0xfff7d6c1, 0xfff4cebe,
    0xffeec6bc, 0xffe5beba, 0xffd9b5ba, 0xffcfadba, 0xffc6a7ba, 0xffbba0bc, 0xffb39cc0, 0xffa998c2,
    0xff9c96c3, 0xff9494c3, 0xff8d92c5, 0xff8990c7, 0xff8790c7, 0xff8591c5, 0xff8291c3, 0xff7f91c3,
    0xff7d90c2, 0xff7c8fc1, 0xff7c8ec1, 0xff7a8dc0, 0xff788bbf, 0xff788abf, 0xff7889be, 0xff7789be,
    0xff7688bd, 0xff7488bd, 0xff7388bc, 0xff7288bc, 0xff7186bd, 0xff6f84be, 0xff6e83bd, 0xff6d81bc,
    0xff6b81bb, 0xff6b81ba, 0xff6a81ba, 0xff6880b9, 0xff667fb8, 0xff657fb9, 0xff647eb9, 0xff647db8,
    0xff647bb7, 0xff627bb6, 0xff617cb7, 0xff5f7cb7, 0xff5d7bb6, 0xff5c7ab6, 0xff5c7ab7, 0xff5d7ab7,
    0xff5c7ab6, 0xff5b79b5, 0xff5a78b4, 0xff5a77b4, 0xff5a76b3, 0xff5a75b1, 0xff5a74af, 0xff5a74ac,
    0xff5a73aa, 0xff5972a9, 0xff5870a8, 0xff586fa8, 0xff9ca7ca, 0xff9ca7ca, 0xff96a4c9, 0xff8fa0c7,
    0xff889cc5, 0xff8399c3, 0xff8195c1, 0xff8291c0, 0xff8291c0, 0xff8394c2, 0xff8496c4, 0xff8698c5,
    0xff8798c5, 0xff8799c5, 0xff8799c4, 0xff879ac4, 0xff889ac5, 0xff889ac5, 0xff8899c6, 0xff8898c6,
    0xff8898c8, 0xff8999c8, 0xff8a99c7, 0xff8c9ac6, 0xff8d9ac7, 0xff8e9bc8, 0xff8e9bc9, 0xff8f9cc9,
    0xff8f9cc9, 0xff8e9ccb, 0xff8e9ccc, 0xff8e9ccb, 0xff8f9cca, 0xff8f9dca, 0xff8f9ecb, 0xff8f9ecb,
    0xff8f9ecc, 0xff8f9ecc, 0xff909fcc, 0xff919fcc, 0xff929fcb, 0xff949eca, 0xff969eca, 0xff999fcb,
    0xff9e9fca, 0xffa2a0c9, 0xffa9a1c7, 0xffb3a3c5, 0xffbfa7c4, 0xffcbaec1, 0xffd7b6be, 0xffe1bebd,
    0xffe6c3bd, 0xffe9cbbf, 0xffe9d2c0, 0xffe6d8c4, 0xffe0ddc8, 0xffdbddcd, 0xffd6dcd2, 0xffd2d9d7,
    0xffcdd6dc, 0xffc8d3df, 0xffc4d1e3, 0xffc2cfe5, 0xffc1cde6, 0xffbecae5, 0xffbcc9e5, 0xffbac7e6,
    0xffb7c6e8, 0xffb5c5e8, 0xffb4c4e8, 0xffb2c2e8, 0xffb0c2e8, 0xffb0c2e8, 0xffb1c3ea, 0xffb2c3eb,
    0xffb2c3eb, 0xffb2c3eb, 0xffb3c3eb, 0xffb4c2eb, 0xffb4c2eb, 0xffb4c3ec, 0xffb4c3ec, 0xffb6c4eb,
    0xffb7c4eb, 0xffb7c4eb, 0xffb6c4eb, 0xffb6c4ea, 0xffb6c4e9, 0xffb8c5eb, 0xffb9c6ef, 0xffbbc8f1,
    0xffbfcaf2, 0xffc1cbf2, 0xffc3cdf3, 0xffc4cff4, 0xffc4d0f4, 0xffc5d1f4, 0xffc6d3f5, 0xffc7d3f7,
    0xffc9d4f8, 0xffccd5f7, 0xffcdd6f6, 0xffced7f6, 0xffcfd9f7, 0xffcfdaf8, 0xffcedaf8, 0xffcedaf8,
    0xffcedbf6, 0xffcedcf5, 0xffcfdef3, 0xffd0e0f1, 0xffd1e3ef, 0xffd5e5eb, 0xffdbe9e6, 0xffe2ece1,
    0xffeaefd9, 0xfff0f2d4, 0xfff7f1cd, 0xfffeebc4, 0xffffe2be, 0xfffdd8b9, 0xfff5ccb6, 0xffedc0b4,
    0xffe4b4b3, 0xffd7a8b5, 0xffcba1b9, 0xffbd9cbd, 0xffac98bf, 0xff9f96c1, 0xff9593c5, 0xff8f90c7,
    0xff8a8fc6, 0xff878fc3, 0xff838fc1, 0xff808ec1, 0xff7e8ec1, 0xff7c8ec1, 0xff7b8dc1, 0xff798cc0,
    0xff778abf, 0xff7789bf, 0xff7888be, 0xff7788be, 0xff7588bd, 0xff7388bc, 0xff7188bc, 0xff7187bc,
    0xff7186bd, 0xff7084be, 0xff6f83bd, 0xff6d81bc, 0xff6b81bb, 0xff6a81bb, 0xff6981bb, 0xff6780b9,
    0xff667fb7, 0xff657fb7, 0xff647eb8, 0xff637cb7, 0xff637bb5, 0xff617ab4, 0xff5f7bb4, 0xff5e7cb4,
    0xff5c7bb5, 0xff5c7ab6, 0xff5d7ab6, 0xff5d7ab6, 0xff5c79b5, 0xff5b78b4, 0xff5a77b4, 0xff5b76b4,
    0xff5b76b3, 0xff5b74b1, 0xff5a73af, 0xff5a73ac, 0xff5973a9, 0xff5971a8, 0xff586fa7, 0xff586da7,
    0xff97a5c7, 0xff97a5c7, 0xff95a3c8, 0xff90a0c8, 0xff889cc6, 0xff8298c3, 0xff8094c0, 0xff8191c0,
    0xff8291c0, 0xff8293c2, 0xff8295c3, 0xff8496c5, 0xff8697c5, 0xff8798c4, 0xff8798c3, 0xff8899c3,
    0xff8899c4, 0xff8899c5, 0xff8697c6, 0xff8697c6, 0xff8798c8, 0xff8899c8, 0xff8a9ac6, 0xff8c9ac5,
    0xff8d9ac6, 0xff8d9ac8, 0xff8d9ac9, 0xff8d9bc8, 0xff8d9bc8, 0xff8e9ccb, 0xff8e9ccc, 0xff8e9bcb,
    0xff8e9bc9, 0xff8e9bc9, 0xff8e9cca, 0xff8e9dcb, 0xff909ecc, 0xff919ecc, 0xff929ecc, 0xff949ecb,
    0xff969fcb, 0xff99a0ca, 0xff9da1ca, 0xffa1a2c9, 0xffa8a4c8, 0xffafa6c7, 0xffb7a8c6, 0xffc2abc5,
    0xffceb0c4, 0xffdbb8c2, 0xffe8c1c0, 0xffefc9bf, 0xfff2cfc0, 0xfff1d7c2, 0xffeddec6, 0xffe6e3cb,
    0xffdbe6d3, 0xffd0e5d9, 0xffc5e2df, 0xffbbdce4, 0xffb3d5e9, 0xffadceed, 0xffa9c6f1, 0xffa8c1f2,
    0xffa9bdf1, 0xffaab9ee, 0xffabb7ec, 0xffabb5ea, 0xffacb4e9, 0xffadb4e8, 0xffafb4e8, 0xffb0b6e6,
    0xffb0b7e3, 0xffb1b8e2, 0xffb4bae2, 0xffb7bce3, 0xffb9bee2, 0xffbabfe1, 0xffbbc0e0, 0xffbcc0e0,
    0xffbcc2e0, 0xffbcc3e0, 0xffbcc4e0, 0xffbfc6df, 0xffc0c6df, 0xffc0c6df, 0xffbfc5df, 0xffbfc5de,
    0xffbfc6dd, 0xffc1c8df, 0xffc3c9e3, 0xffc6cae5, 0xffc9cce6, 0xffcbcde6, 0xffcccee7, 0xffcdcfe9,
    0xffcdcfe9, 0xffcecee9, 0xffceceea, 0xffcfcded, 0xffcfccef, 0xffcfcaf0, 0xffcec9f1, 0xffcec7f3,
    0xffcdc6f5, 0xffc9c5f8, 0xffc5c5fb, 0xffbfc5fd, 0xffbcc5fe, 0xffb9c7ff, 0xffb9caff, 0xffbacfff,
    0xffbbd5fe, 0xffbedcfc, 0xffc3e5f8, 0xffcbedf3, 0xffd7f6eb, 0xffe2fce4, 0xffedfeda, 0xfff9fbcf,
    0xfffff3c7, 0xffffeac0, 0xffffdebb, 0xfffdd0b7, 0xfff7c5b5, 0xffedb8b5, 0xffe1b0b7, 0xffd2a9ba,
    0xffc0a2bd, 0xffb19ebf, 0xffa599c2, 0xff9c94c4, 0xff9592c3, 0xff9091c0, 0xff8a8fbf, 0xff868ebf,
    0xff828dc0, 0xff7f8cc0, 0xff7d8cc0, 0xff7a8bbf, 0xff7889be, 0xff7788be, 0xff7788bd, 0xff7688bc,
    0xff7587bb, 0xff7387bb, 0xff7187bc, 0xff7086bd, 0xff7085be, 0xff7084be, 0xff6f83bd, 0xff6d82bc,
    0xff6b81bb, 0xff6a80bb, 0xff6980bb, 0xff677fb8, 0xff657fb6, 0xff647fb6, 0xff647eb6, 0xff647db5,
    0xff637bb4, 0xff617ab2, 0xff5f7bb2, 0xff5e7bb2, 0xff5d7bb4, 0xff5c7ab5, 0xff5c7ab5, 0xff5c79b5,
    0xff5b78b4, 0xff5a78b3, 0xff5a77b3, 0xff5b76b3, 0xff5b75b3, 0xff5a74b1, 0xff5973ae, 0xff5873ab,
    0xff5773a8, 0xff5771a7, 0xff576fa7, 0xff576da7, 0xff8f9fc5, 0xff8f9fc5, 0xff8f9fc6, 0xff8d9ec6,
    0xff869ac4, 0xff7f96c2, 0xff7d93c1, 0xff8092c1, 0xff8192c1, 0xff8293c1, 0xff8294c2, 0xff8496c4,
    0xff8597c4, 0xff8597c3, 0xff8597c2, 0xff8597c2, 0xff8697c3, 0xff8697c4, 0xff8596c4, 0xff8596c5,
    0xff8697c7, 0xff8798c8, 0xff8999c7, 0xff8b99c5, 0xff8b99c6, 0xff8b99c7, 0xff8b99c8, 0xff8c9ac7,
    0xff8c9bc7, 0xff8d9bca, 0xff8d9bcb, 0xff8d9bca, 0xff8c9bc8, 0xff8c9bc8, 0xff8c9bc9, 0xff8e9bca,
    0xff909ccb, 0xff929ccb, 0xff959bcb, 0xff999cca, 0xff9e9ec9, 0xffa5a1c7, 0xffaea5c6, 0xffb6a8c5,
    0xffc0aec4, 0xffc8b4c3, 0xffcfbac3, 0xffd6c0c3, 0xffdac5c5, 0xffe0cbc7, 0xffe4d0ca, 0xffe4d3cd,
    0xffe1d4cf, 0xffdcd6d3, 0xffd8d9d6, 0xffd2dbdb, 0xffc8dce1, 0xffc0dae5, 0xffb8d7e9, 0xffb1d1ec,
    0xffaacbee, 0xffa5c5ef, 0xffa1bfef, 0xffa0baef, 0xffa1b6ee, 0xffa3b2eb, 0xffa5b0e9, 0xffa6aee7,
    0xffa8ade5, 0xffaaaee4, 0xffacb0e3, 0xffaeb2e1, 0xffafb2de, 0xffb1b3dd, 0xffb5b7dd, 0xffb7b9de,
    0xffb9bbdd, 0xffbbbcdc, 0xffbcbddc, 0xffbdbedc, 0xffbdc0dc, 0xffbdc1db, 0xffbec2db, 0xffc0c3db,
    0xffc1c4db, 0xffc1c4dc, 0xffc1c4dc, 0xffc1c5db, 0xffc1c6da, 0xffc3c8db, 0xffc5c9de, 0xffc8cae0,
    0xffcacbe1, 0xffcccbe1, 0xffcdcce2, 0xffcdcce4, 0xffcecce4, 0xffcfcbe4, 0xffcfcbe5, 0xffcfcae8,
    0xffcfc9ea, 0xffcec7eb, 0xffcdc5ec, 0xffccc3ee, 0xffcbc1f1, 0xffc7c0f3, 0xffc3c0f5, 0xffbec0f7,
    0xffbac1f9, 0xffb7c3fb, 0xffb7c6fd, 0xffb8c9fe, 0xffb8cefe, 0xffbad4fd, 0xffbddafc, 0xffc1e1f9,
    0xffc9e8f5, 0xffd0ecf0, 0xffd9efea, 0xffe2eee3, 0xffe7ebdd, 0xffebe8d7, 0xffeee4d1, 0xfff1dfcb,
    0xfff3dac6, 0xfff3d3c0, 0xfff0cdbe, 0xffe9c6bb, 0xffe0bcb9, 0xffd5b3b9, 0xffc8a9ba, 0xffba9fbc,
    0xffae98bc, 0xffa393bb, 0xff978fbc, 0xff908cbe, 0xff888bbf, 0xff8189c0, 0xff7d89bf, 0xff7988be,
    0xff7788bc, 0xff7688bc, 0xff7587bd, 0xff7587bc, 0xff7487bb, 0xff7387ba, 0xff7086bc, 0xff6f85bd,
    0xff6f85bd, 0xff6f84bd, 0xff6e83bc, 0xff6d82bb, 0xff6b80bb, 0xff6a7fbb, 0xff697fba, 0xff667fb8,
    0xff647fb6, 0xff647fb5, 0xff647eb5, 0xff647db4, 0xff637bb4, 0xff617ab2, 0xff5f7ab1, 0xff5e7ab1,
    0xff5d7ab3, 0xff5c7ab5, 0xff5b79b5, 0xff5b78b4, 0xff5b78b3, 0xff5a77b2, 0xff5a77b2, 0xff5a76b3,
    0xff5a75b3, 0xff5973b0, 0xff5772ad, 0xff5673aa, 0xff5573a8, 0xff5572a7, 0xff556fa7, 0xff556da7,
    0xff899ac4, 0xff899ac4, 0xff8a9bc4, 0xff899bc4, 0xff8397c3, 0xff7d94c1, 0xff7b92c1, 0xff7e93c1,
    0xff8093c1, 0xff8293c1, 0xff8394c1, 0xff8496c2, 0xff8497c3, 0xff8496c3, 0xff8495c2, 0xff8495c2,
    0xff8495c3, 0xff8495c3, 0xff8495c3, 0xff8496c4, 0xff8697c6, 0xff8798c7, 0xff8898c7, 0xff8998c6,
    0xff8997c6, 0xff8997c6, 0xff8a98c6, 0xff8b9ac6, 0xff8c9bc6, 0xff8c9bc8, 0xff8c9bc9, 0xff8c9bc9,
    0xff8c9bc8, 0xff8c9bc8, 0xff8c9ac9, 0xff8e9ac9, 0xff909bc9, 0xff959cc9, 0xff9a9bc9, 0xffa19cc8,
    0xffa99fc6, 0xffb3a5c3, 0xffbeabc2, 0xffc8b1c1, 0xffd4b9c0, 0xffdcc1c0, 0xffe1cac1, 0xffe2d3c4,
    0xffded8c9, 0xffdadbd0, 0xffd4dad7, 0xffcbd6dc, 0xffc4d2df, 0xffbdcde3, 0xffbacae7, 0xffb7c8ea,
    0xffb5c7eb, 0xffb3c6eb, 0xffb2c5ec, 0xffb0c2eb, 0xffadc0ea, 0xffa9bde8, 0xffa7bbe6, 0xffa7b9e4,
    0xffa7b7e3, 0xffa8b4e1, 0xffa9b2e0, 0xffa9b0de, 0xffa9afdd, 0xffaab0dc, 0xffacb2dc, 0xffaeb3dc,
    0xffb0b4db, 0xffb2b4db, 0xffb4b6dc, 0xffb5b8dd, 0xffb7badc, 0xffb9bcda, 0xffbabdda, 0xffbcbddc,
    0xffbcbfdc, 0xffbcc0dc, 0xffbcc1dc, 0xffbec1dc, 0xffbfc1dc, 0xffc0c1dd, 0xffc0c2de, 0xffc0c3dd,
    0xffc0c5db, 0xffc2c7dc, 0xffc3c8de, 0xffc5c8e0, 0xffc8c9e1, 0xffc9c9e1, 0xffc9c9e2, 0xffc9c9e3,
    0xffcac9e3, 0xffcbc9e3, 0xffcbc9e4, 0xffcbc8e6, 0xffcbc8e7, 0xffccc8e8, 0xffccc8e9, 0xffccc7ea,
    0xffcac6eb, 0xffc9c6eb, 0xffc7c7ec, 0xffc5c7ed, 0xffc2c8ee, 0xffc1c9ef, 0xffc2caf2, 0xffc3cbf3,
    0xffc3ccf3, 0xffc2cef3, 0xffc1cff4, 0xffc1cff5, 0xffc1d1f5, 0xffc2d2f5, 0xffc3d3f5, 0xffc4d4f4,
    0xffc6d6f2, 0xffc9daee, 0xffcedee8, 0xffd7e3e1, 0xffe1e7d9, 0xffebe9cf, 0xfff1e7c7, 0xfff4e0bf,
    0xfff5d4b7, 0xfff0c6b4, 0xffe6b9b3, 0xffd7acb4, 0xffc7a1b6, 0xffb79ab7, 0xffa692b9, 0xff9a8ebc,
    0xff908abd, 0xff8688be, 0xff8087be, 0xff7b87bd, 0xff7887bb, 0xff7687bb, 0xff7487bc, 0xff7287bc,
    0xff7287ba, 0xff7287ba, 0xff7086bb, 0xff6f85bc, 0xff6e85bc, 0xff6d84bc, 0xff6c83bb, 0xff6c81ba,
    0xff6a7fba, 0xff697fb9, 0xff687fb9, 0xff667fb8, 0xff647fb7, 0xff637eb7, 0xff637db6, 0xff627cb5,
    0xff627bb4, 0xff607ab2, 0xff5f79b1, 0xff5e79b1, 0xff5d79b2, 0xff5d79b4, 0xff5c78b5, 0xff5a77b4,
    0xff5a77b3, 0xff5a77b1, 0xff5a77b1, 0xff5a76b2, 0xff5975b2, 0xff5773b0, 0xff5672ad, 0xff5572ab,
    0xff5472a9, 0xff5471a8, 0xff546fa7, 0xff546ea7, 0xff8899c5, 0xff8899c5, 0xff889ac3, 0xff8699c2,
    0xff7f95c1, 0xff7a91c1, 0xff7891c1, 0xff7b93c2, 0xff7f94c2, 0xff8193c1, 0xff8393c1, 0xff8495c2,
    0xff8396c2, 0xff8395c2, 0xff8394c2, 0xff8394c2, 0xff8394c2, 0xff8394c2, 0xff8394c2, 0xff8495c3,
    0xff8596c4, 0xff8697c5, 0xff8797c6, 0xff8797c6, 0xff8796c6, 0xff8896c5, 0xff8997c5, 0xff8a99c5,
    0xff8b9ac5, 0xff8c9ac6, 0xff8c9ac7, 0xff8d9bc7, 0xff8e9cc7, 0xff8e9cc7, 0xff8f9bc7, 0xff939bc7,
    0xff979dc7, 0xff9d9ec7, 0xffa59fc7, 0xffada1c6, 0xffb6a6c4, 0xffc0acc2, 0xffcbb3c1, 0xffd5bac2,
    0xffdfc4c2, 0xffe6ccc2, 0xffe8d5c4, 0xffe2dec9, 0xffd9e1cf, 0xffcee1d8, 0xffc1dce2, 0xffb4d4e8,
    0xffaaccec, 0xffa2c2f0, 0xffa1bcf2, 0xffa2b7f2, 0xffa4b5f0, 0xffa8b5ed, 0xffacb5eb, 0xffb0b6e8,
    0xffb0b6e3, 0xffafb6df, 0xffadb6db, 0xffadb7da, 0xffacb7d9, 0xffacb5d8, 0xffacb4d8, 0xffabb2d8,
    0xffabb2d7, 0xffabb3d6, 0xffacb4d6, 0xffaeb5d6, 0xffb0b5d7, 0xffb1b5d8, 0xffb2b7da, 0xffb3b8db,
    0xffb4bada, 0xffb6bbd9, 0xffb7bcda, 0xffb8bddc, 0xffb9bedd, 0xffbabfdd, 0xffbabfdd, 0xffbbbfdd,
    0xffbcbfde, 0xffbdbfdf, 0xffbec0e0, 0xffbec1df, 0xffbfc3dd, 0xffc0c5dd, 0xffc1c5df, 0xffc2c5e0,
    0xffc4c6e1, 0xffc5c7e2, 0xffc5c7e2, 0xffc5c6e2, 0xffc6c7e2, 0xffc8c8e3, 0xffc8c8e3, 0xffc7c8e4,
    0xffc7c8e4, 0xffc8c9e5, 0xffc9cae5, 0xffc9cbe5, 0xffc9cbe5, 0xffc9cbe4, 0xffcacce3, 0xffcacde3,
    0xffc9cee2, 0xffc9cee3, 0xffcbcee5, 0xffcccde7, 0xffcbcae7, 0xffc9c7e8, 0xffc5c3ea, 0xffc2c0ed,
    0xffbcbdf1, 0xffb8bbf6, 0xffb3bbfa, 0xffadbdfe, 0xffacc3ff, 0xffaccbfe, 0xffb3d5f9, 0xffbee1f2,
    0xffccebea, 0xffdcf2de, 0xffe8f3d4, 0xfff3eec9, 0xfffbe3be, 0xfffbd6b8, 0xfff6c8b5, 0xffeabbb5,
    0xffdbb0b5, 0xffcba7b6, 0xffb99db8, 0xffac96ba, 0xff9f91bb, 0xff938cbc, 0xff8b8abb, 0xff8488ba,
    0xff7f87b9, 0xff7a86ba, 0xff7686bb, 0xff7486bb, 0xff7386ba, 0xff7386b9, 0xff7185ba, 0xff6f84bb,
    0xff6d84bb, 0xff6c83bb, 0xff6b82bb, 0xff6a81ba, 0xff6a7fb8, 0xff697eb8, 0xff687eb7, 0xff667eb7,
    0xff647eb7, 0xff637db6, 0xff637cb5, 0xff627bb4, 0xff627bb4, 0xff6079b2, 0xff5f79b1, 0xff5e78b1,
    0xff5e78b2, 0xff5d78b3, 0xff5b77b3, 0xff5976b2, 0xff5976b1, 0xff5976b0, 0xff5976b0, 0xff5875b0,
    0xff5774b0, 0xff5572ae, 0xff5471ac, 0xff5371aa, 0xff5371a9, 0xff5370a8, 0xff526fa7, 0xff526ea7,
    0xff8f9ec6, 0xff8f9ec6, 0xff8c9dc4, 0xff879ac2, 0xff7e95c1, 0xff7790c1, 0xff7790c1, 0xff7a92c2,
    0xff7d93c2, 0xff8092c1, 0xff8192c1, 0xff8293c1, 0xff8294c2, 0xff8394c3, 0xff8494c3, 0xff8494c3,
    0xff8394c2, 0xff8394c2, 0xff8395c3, 0xff8395c3, 0xff8496c3, 0xff8496c3, 0xff8496c4, 0xff8596c5,
    0xff8696c5, 0xff8796c4, 0xff8896c4, 0xff8997c5, 0xff8998c5, 0xff8a98c6, 0xff8b98c6, 0xff8d99c6,
    0xff8f9ac6, 0xff929ac6, 0xff969ac5, 0xff9e9cc5, 0xffa69fc4, 0xffb0a4c4, 0xffbbaac3, 0xffc3b0c2,
    0xffcbb8c2, 0xffd1c0c3, 0xffd5c6c5, 0xffd7cac8, 0xffd8cecc, 0xffd8d1d0, 0xffd6d4d4, 0xffcfd7d9,
    0xffc7d7dd, 0xffbdd5e3, 0xffb3d0e7, 0xffa9caeb, 0xffa1c3ed, 0xff9cbbef, 0xff9bb5ef, 0xff9db0ee,
    0xffa1aeea, 0xffa5aee7, 0xffabaee4, 0xffafb0e2, 0xffb0b1de, 0xffafb2da, 0xffaeb4d7, 0xffadb5d5,
    0xffacb5d5, 0xffacb4d4, 0xffacb3d4, 0xffabb3d4, 0xffaab3d4, 0xffaab4d4, 0xffabb5d4, 0xffadb5d4,
    0xffaeb5d5, 0xffafb5d6, 0xffb1b6d8, 0xffb2b7d9, 0xffb3b9d9, 0xffb5bbd9, 0xffb6bcda, 0xffb7bcdb,
    0xffb8bcdc, 0xffb9bddd, 0xffb9bedd, 0xffbabedd, 0xffbbbedd, 0xffbcbede, 0xffbdbfdf, 0xffbdc0df,
    0xffbec2df, 0xffbec3df, 0xffbfc3df, 0xffc0c3df, 0xffc1c4e0, 0xffc1c5e1, 0xffc1c4e1, 0xffc2c4e0,
    0xffc3c5e1, 0xffc4c6e2, 0xffc5c7e2, 0xffc5c7e2, 0xffc5c7e2, 0xffc6c9e2, 0xffc7cae2, 0xffc6cae1,
    0xffc6cae0, 0xffc7cbe0, 0xffc8ccdf, 0xffc9cddf, 0xffc9cdde, 0xffc9cdde, 0xffcbcce0, 0xffcbcae1,
    0xffcac7e1, 0xffc8c3e2, 0xffc4bfe4, 0xffc0bce7, 0xffbab8eb, 0xffb5b5ef, 0xffb0b5f3, 0xffabb8f8,
    0xffa9bdfa, 0xffa8c4fb, 0xffaccbf9, 0xffb4d4f6, 0xffbedcf2, 0xffc9e2eb, 0xffd1e4e4, 0xffd9e3dc,
    0xffe2ded3, 0xffe6d9cc, 0xffead5c5, 0xffe9d0c0, 0xffe6cabb, 0xffe0c3b8, 0xffd6b7b6, 0xffcdabb5,
    0xffc1a0b5, 0xffb096b5, 0xffa190b5, 0xff9589b6, 0xff8a85b8, 0xff8183b9, 0xff7a82b9, 0xff7482b9,
    0xff7283b9, 0xff7184b9, 0xff6f84ba, 0xff6e83ba, 0xff6d83ba, 0xff6b82ba, 0xff6a81ba, 0xff6981b9,
    0xff697fb7, 0xff687eb7, 0xff677db6, 0xff657db6, 0xff647db6, 0xff647cb5, 0xff637bb3, 0xff627bb2,
    0xff617ab2, 0xff5f79b1, 0xff5e78b0, 0xff5d77b0, 0xff5d77b1, 0xff5d77b1, 0xff5c76b0, 0xff5a75af,
    0xff5975ae, 0xff5875ae, 0xff5875ae, 0xff5774ae, 0xff5673ae, 0xff5471ac, 0xff5370aa, 0xff5270a9,
    0xff5270a8, 0xff526fa7, 0xff516ea6, 0xff516ea6, 0xff99a5c9, 0xff99a5c9, 0xff92a1c7, 0xff889bc4,
    0xff7e94c1, 0xff778fc0, 0xff768fc0, 0xff7a91c1, 0xff7d92c1, 0xff7d92c2, 0xff7e92c2, 0xff8092c2,
    0xff8193c2, 0xff8394c3, 0xff8595c4, 0xff8696c4, 0xff8596c2, 0xff8596c2, 0xff8495c3, 0xff8395c3,
    0xff8395c2, 0xff8395c2, 0xff8395c2, 0xff8495c3, 0xff8596c3, 0xff8797c4, 0xff8897c4, 0xff8797c5,
    0xff8797c5, 0xff8997c5, 0xff8c98c5, 0xff8f99c5, 0xff939ac5, 0xff989ac5, 0xff9f9bc4, 0xffaa9fc2,
    0xffb5a3c2, 0xffc1aac1, 0xffceb6bf, 0xffd5c1c0, 0xffd9cac2, 0xffd9d1c6, 0xffd5d4cb, 0xffced5d0,
    0xffc6d3d7, 0xffc0cfdd, 0xffbbcae2, 0xffb6c6e7, 0xffb3c4e8, 0xffb0c2e8, 0xffadc0e7, 0xffa9bee7,
    0xffa5bbe6, 0xffa3b7e6, 0xffa2b5e4, 0xffa3b3e3, 0xffa5b1e0, 0xffa7b0de, 0xffaab0dd, 0xffadb1dc,
    0xffaeb1da, 0xffaeb2d8, 0xffacb2d6, 0xffabb2d5, 0xffaab2d5, 0xffa9b1d4, 0xffa9b0d4, 0xffa9b1d4,
    0xffa9b2d5, 0xffa9b2d5, 0xffa9b3d4, 0xffabb3d4, 0xffacb4d4, 0xffaeb5d5, 0xffb0b6d7, 0xffb1b7d8,
    0xffb4b8d9, 0xffb6bada, 0xffb7bbdb, 0xffb7bcdc, 0xffb7bcdc, 0xffb7bddc, 0xffb8bddc, 0xffbabedc,
    0xffbbbedc, 0xffbbbedd, 0xffbbbede, 0xffbcbfdf, 0xffbdc0df, 0xffbec1df, 0xffbfc2de, 0xffbfc2de,
    0xffc0c3df, 0xffc0c4e0, 0xffc0c4e0, 0xffc0c4df, 0xffc1c5e0, 0xffc2c6e1, 0xffc3c6e1, 0xffc4c6e1,
    0xffc4c6e1, 0xffc5c7e1, 0xffc5c7e1, 0xffc4c7e0, 0xffc3c7df, 0xffc3c7df, 0xffc5c8df, 0xffc5c8df,
    0xffc4c8de, 0xffc4c8de, 0xffc4c8df, 0xffc4c7e0, 0xffc4c4df, 0xffc2c1df, 0xffc1bee0, 0xffbebde2,
    0xffbcbce4, 0xffbabbe5, 0xffb8bbe6, 0xffb5bde9, 0xffb4bfeb, 0xffb3c1ed, 0xffb4c4ef, 0xffb6c5f0,
    0xffb8c6f1, 0xffb9c8f1, 0xffb9c9ef, 0xffbacbec, 0xffbecfe6, 0xffc4d3e0, 0xffcedad8, 0xffd9decf,
    0xffe3dfc6, 0xffeadbbe, 0xffeccfb6, 0xffe8c0b2, 0xffddb0af, 0xffcba2ae, 0xffb897b0, 0xffa78eb3,
    0xff9787b7, 0xff8a82b8, 0xff8080b8, 0xff7880b8, 0xff7381b8, 0xff7082b8, 0xff6e83b8, 0xff6e83b8,
    0xff6d82b9, 0xff6c81b9, 0xff6b80b9, 0xff6a80b8, 0xff687eb8, 0xff687db7, 0xff677cb6, 0xff657bb5,
    0xff647bb4, 0xff647ab3, 0xff6379b2, 0xff6279b2, 0xff6179b1, 0xff5f79b1, 0xff5e78b0, 0xff5d77af,
    0xff5c77af, 0xff5c77af, 0xff5c76ae, 0xff5b75ad, 0xff5a74ad, 0xff5874ad, 0xff5672ad, 0xff5672ac,
    0xff5571ab, 0xff5470a9, 0xff5370a8, 0xff5370a8, 0xff526fa7, 0xff516ea6, 0xff506da5, 0xff506da4,
    0xffa1aacc, 0xffa1aacc, 0xff96a3c8, 0xff889bc4, 0xff7d93c1, 0xff768ec0, 0xff768dbf, 0xff798fc0,
    0xff7b90c0, 0xff7b91c1, 0xff7b91c2, 0xff7e91c2, 0xff8091c2, 0xff8393c3, 0xff8595c4, 0xff8696c4,
    0xff8696c2, 0xff8496c2, 0xff8396c3, 0xff8295c3, 0xff8294c2, 0xff8294c1, 0xff8294c1, 0xff8494c2,
    0xff8695c3, 0xff8897c4, 0xff8997c4, 0xff8896c4, 0xff8996c4, 0xff8c97c4, 0xff9199c4, 0xff969ac4,
    0xff9d9dc3, 0xffa49fc3, 0xffaba1c2, 0xffb7a7c2, 0xffc3acc2, 0xffceb5c2, 0xffd8c2c1, 0xffdccdc2,
    0xffdcd5c6, 0xffd7d9cc, 0xffcddbd2, 0xffc2d8d8, 0xffb5d1e0, 0xffabc9e7, 0xffa5bfec, 0xffa2b7ef,
    0xffa3b3ed, 0xffa5b1e9, 0xffa8b3e4, 0xffa9b3e1, 0xffaab4df, 0xffaab4dc, 0xffa9b4da, 0xffa9b4d8,
    0xffa9b3d6, 0xffa9b2d6, 0xffaab2d6, 0xffabb2d6, 0xffabb2d6, 0xffabb2d6, 0xffa9b2d6, 0xffa8b1d5,
    0xffa7b0d5, 0xffa7aed4, 0xffa7aed4, 0xffa7afd4, 0xffa7b1d5, 0xffa7b1d5, 0xffa8b1d4, 0xffaab1d4,
    0xffabb3d4, 0xffacb4d5, 0xffaeb5d6, 0xffb0b6d7, 0xffb3b8d8, 0xffb5bada, 0xffb6bbdb, 0xffb6bbdb,
    0xffb6bbdb, 0xffb6bcdc, 0xffb7bcdc, 0xffb9bddb, 0xffbabedb, 0xffbabedb, 0xffbabedc, 0xffbbbfdd,
    0xffbcc0df, 0xffbdc0df, 0xffbdc1de, 0xffbdc1dd, 0xffbec2de, 0xffbec3df, 0xffbec3df, 0xffbfc3de,
    0xffc0c4df, 0xffc1c5e0, 0xffc1c5e0, 0xffc2c5e0, 0xffc2c5e0, 0xffc2c5e0, 0xffc2c4df, 0xffc1c3de,
    0xffc0c3de, 0xffc0c3df, 0xffc0c4e0, 0xffc0c4e0, 0xffc0c4df, 0xffc0c3df, 0xffbfc3df, 0xffbec2df,
    0xffbdc1de, 0xffbcbfdd, 0xffbcbfdd, 0xffbcbfdd, 0xffbcbfdd, 0xffbcc0dc, 0xffbdc0dc, 0xffbfc1db,
    0xffbfc1dc, 0xffbebfde, 0xffbbbce2, 0xffb7b8e7, 0xffb3b4ed, 0xffacb2f1, 0xffa5b2f4, 0xffa1b6f5,
    0xffa0bff4, 0xffa7caef, 0xffb4d7e7, 0xffc6e1dc, 0xffd9e7d2, 0xffe7e6c8, 0xfff1ddbe, 0xfff2cfb6,
    0xffebc0b1, 0xffddb1af, 0xffcba6b0, 0xffbb9ab3, 0xffaa90b6, 0xff9b88b6, 0xff8f84b5, 0xff8381b5,
    0xff7b81b6, 0xff7682b7, 0xff7282b6, 0xff7182b6, 0xff6e81b6, 0xff6c80b7, 0xff6a80b7, 0xff6980b7,
    0xff677eb7, 0xff677cb6, 0xff667bb5, 0xff657ab3, 0xff647ab2, 0xff6379b1, 0xff6278b0, 0xff6178b0,
    0xff6078b0, 0xff5e78b0, 0xff5d77af, 0xff5c77ae, 0xff5b77ad, 0xff5b76ad, 0xff5b75ac, 0xff5b74ab,
    0xff5973ab, 0xff5773ab, 0xff5571ab, 0xff5571aa, 0xff5570a9, 0xff5470a8, 0xff5370a7, 0xff526fa7,
    0xff516ea6, 0xff506da5, 0xff506da4, 0xff506da3, 0xffa7afcd, 0xffa7afcd, 0xff95a3c7, 0xff8396c2,
    0xff798fbf, 0xff748dbf, 0xff758cbe, 0xff788ebf, 0xff7a8fc0, 0xff7a90c1, 0xff7a90c2, 0xff7d90c1,
    0xff7f90c1, 0xff8292c2, 0xff8494c3, 0xff8595c3, 0xff8495c2, 0xff8495c2, 0xff8395c3, 0xff8295c3,
    0xff8295c3, 0xff8394c2, 0xff8393c1, 0xff8393c1, 0xff8494c2, 0xff8695c3, 0xff8895c3, 0xff8994c3,
    0xff8d94c3, 0xff9497c3, 0xff9d9bc2, 0xffa79fc1, 0xffb0a4c0, 0xffbaaabf, 0xffc1b1bf, 0xffc9b9c1,
    0xffcebfc3, 0xffd1c5c6, 0xffd1cdc9, 0xffced0cc, 0xffcbd2d2, 0xffc5d1d8, 0xffbccfdd, 0xffb2cce1,
    0xffa8c6e5, 0xffa1bfe7, 0xff9db7e9, 0xff9cb0ea, 0xff9eade8, 0xffa1ace3, 0xffa5adde, 0xffa9afdb,
    0xffabb1da, 0xffadb3d8, 0xffacb3d5, 0xffabb3d3, 0xffaab3d2, 0xffa9b2d2, 0xffa8b1d2, 0xffa8b1d3,
    0xffa8b1d4, 0xffa8b1d5, 0xffa7b0d5, 0xffa6afd4, 0xffa5aed3, 0xffa5aed3, 0xffa6aed3, 0xffa5aed3,
    0xffa5afd3, 0xffa6afd3, 0xffa7b0d3, 0xffa9b1d3, 0xffaab2d4, 0xffabb3d5, 0xffadb4d5, 0xffafb5d6,
    0xffb2b7d7, 0xffb4b9d9, 0xffb5bada, 0xffb5bada, 0xffb5badb, 0xffb6bbdc, 0xffb7bbdc, 0xffb8bcdb,
    0xffb9bcda, 0xffb9bcda, 0xffbabddb, 0xffbbbddc, 0xffbcbede, 0xffbcbede, 0xffbcbfdd, 0xffbcc0dc,
    0xffbcc1dc, 0xffbcc1dd, 0xffbdc1dd, 0xffbec2dd, 0xffbfc2de, 0xffbfc3df, 0xffbfc3df, 0xffbfc3df,
    0xffbfc3de, 0xffbfc3dd, 0xffbfc2dd, 0xffbfc1dd, 0xffbec1dd, 0xffbec1dd, 0xffbdc1de, 0xffbdc1de,
    0xffbcc1df, 0xffbcc0df, 0xffbbbfde, 0xffbabedd, 0xffb9bddc, 0xffb9bddb, 0xffb9bddb, 0xffbabeda,
    0xffbabeda, 0xffbbbfd9, 0xffbcbfd8, 0xffbfc0d6, 0xffbfbfd6, 0xffbebcd8, 0xffbbb8db, 0xffb6b2df,
    0xffb1aee4, 0xffa9abe8, 0xffa3abec, 0xff9eafef, 0xff9bb6f1, 0xff9fbfef, 0xffa8c9eb, 0xffb5d1e5,
    0xffc2d7e0, 0xffccd9da, 0xffd6d7d1, 0xffddd4c9, 0xffe0cfc0, 0xffdfc9b9, 0xffdac1b5, 0xffd3b5b2,
    0xffc8a8b2, 0xffba9ab1, 0xffab8fb0, 0xff9986b1, 0xff8d82b3, 0xff8280b4, 0xff787eb3, 0xff737eb3,
    0xff6e7eb4, 0xff6a7fb6, 0xff687fb6, 0xff677fb6, 0xff657db6, 0xff657bb5, 0xff657ab4, 0xff6479b2,
    0xff6379b1, 0xff6278b0, 0xff6177af, 0xff6077af, 0xff5f77af, 0xff5d77af, 0xff5d77ae, 0xff5c77ad,
    0xff5b76ac, 0xff5a75ab, 0xff5a75aa, 0xff5a74aa, 0xff5873aa, 0xff5673aa, 0xff5571aa, 0xff5570a9,
    0xff556fa8, 0xff5470a7, 0xff5270a7, 0xff516fa6, 0xff506da5, 0xff506da4, 0xff506da3, 0xff506da3,
    0xffa6afcd, 0xffa6afcd, 0xff91a0c5, 0xff7d91bf, 0xff748cbd, 0xff738bbf, 0xff748cbf, 0xff778dbf,
    0xff788fc0, 0xff7890c1, 0xff7990c2, 0xff7c90c2, 0xff7e90c1, 0xff8091c1, 0xff8192c2, 0xff8292c2,
    0xff8393c1, 0xff8394c1, 0xff8295c2, 0xff8295c2, 0xff8495c3, 0xff8594c3, 0xff8493c2, 0xff8393c1,
    0xff8393c1, 0xff8493c2, 0xff8893c2, 0xff8c93c1, 0xff9395c1, 0xff9e99c1, 0xffaa9ec1, 0xffb6a4bf,
    0xffc1acbe, 0xffcbb5be, 0xffd1bebe, 0xffd3c8c2, 0xffd1cec6, 0xffcbd2cc, 0xffc2d1d2, 0xffbacdd7,
    0xffb3c6dd, 0xffafbfe2, 0xffaabce4, 0xffa7bbe5, 0xffa3b8e3, 0xffa2b5e1, 0xffa2b2df, 0xffa2b0de,
    0xffa3afdd, 0xffa5afda, 0xffa8b0d8, 0xffaab1d8, 0xffabb2d8, 0xffabb2d7, 0xffabb1d5, 0xffaab1d3,
    0xffa8b1d2, 0xffa7b1d2, 0xffa6b0d2, 0xffa5afd3, 0xffa6afd4, 0xffa7b0d4, 0xffa7afd4, 0xffa5add2,
    0xffa4acd1, 0xffa4add1, 0xffa5aed2, 0xffa4aed2, 0xffa4add2, 0xffa5add2, 0xffa6aed3, 0xffa8b0d3,
    0xffaab1d4, 0xffabb2d5, 0xffadb3d6, 0xffaeb4d6, 0xffb0b5d6, 0xffb2b7d7, 0xffb3b8d8, 0xffb4b9d9,
    0xffb5badb, 0xffb6bbdc, 0xffb6bbdc, 0xffb7bbdb, 0xffb8bbda, 0xffb8bcda, 0xffb9bdda, 0xffbabddb,
    0xffbbbddc, 0xffbbbddc, 0xffbcbedc, 0xffbcbfdc, 0xffbbc0dc, 0xffbbc0dc, 0xffbcc1dc, 0xffbdc1dd,
    0xffbdc1dd, 0xffbdc0dd, 0xffbdc0dd, 0xffbdc1dd, 0xffbdc1dd, 0xffbcc0dc, 0xffbcc0db, 0xffbcc0db,
    0xffbdc0dc, 0xffbdc0dc, 0xffbcbfdd, 0xffbcbfdd, 0xffbcbfde, 0xffbbbede, 0xffb9bcdd, 0xffb8bbdc,
    0xffb8bbda, 0xffb8bbd9, 0xffb8bbd9, 0xffb7bbd9, 0xffb7bbd9, 0xffb7bcd9, 0xffb8bcd8, 0xffbabcd6,
    0xffbabbd6, 0xffbabad6, 0xffb8b8d8, 0xffb5b5d9, 0xffb1b2db, 0xffadb0dd, 0xffaab1de, 0xffa7b2e0,
    0xffa6b5e3, 0xffa6b8e5, 0xffa8b9e7, 0xffabbbe8, 0xffadbde9, 0xffadc0e9, 0xffb3c6e4, 0xffbbcddc,
    0xffc6d4d1, 0xffd4d9c6, 0xffdcd6bd, 0xffe1ceb5, 0xffdebfaf, 0xffd3adac, 0xffc39dac, 0xffae8eac,
    0xff9f87ae, 0xff8f82b0, 0xff7f7cb1, 0xff757bb1, 0xff6d7cb3, 0xff697eb5, 0xff677fb5, 0xff667fb4,
    0xff667db4, 0xff657bb3, 0xff657ab3, 0xff6479b2, 0xff6279b1, 0xff6078af, 0xff5f76ae, 0xff5f76ae,
    0xff5e76ae, 0xff5d76ae, 0xff5c76ae, 0xff5b76ad, 0xff5a76ab, 0xff5975aa, 0xff5974aa, 0xff5873ab,
    0xff5773ab, 0xff5672ab, 0xff5571a9, 0xff5570a8, 0xff556fa7, 0xff5370a8, 0xff5170a8, 0xff506fa7,
    0xff4f6da5, 0xff4f6da4, 0xff4f6da3, 0xff4f6da3, 0xff9faccb, 0xff9faccb, 0xff899bc3, 0xff768cbd,
    0xff7088bc, 0xff728abd, 0xff748bbe, 0xff768cbf, 0xff788ec0, 0xff788ec1, 0xff798fc1, 0xff7b90c0,
    0xff7c90c0, 0xff7d90c0, 0xff7e90c1, 0xff7f90c1, 0xff8091c1, 0xff8092c1, 0xff8193c2, 0xff8294c2,
    0xff8594c3, 0xff8694c3, 0xff8694c2, 0xff8693c1, 0xff8693c1, 0xff8792c1, 0xff8d93c1, 0xff9495c0,
    0xff9e99c0, 0xffab9fc1, 0xffb7a6c1, 0xffc3aec0, 0xffcdb6bf, 0xffd4c0bf, 0xffd6c9c2, 0xffd3d1c7,
    0xffccd6cc, 0xffc1d6d3, 0xffb2cfdb, 0xffa6c4e0, 0xff9fb9e5, 0xff9cafe7, 0xff9cabe7, 0xff9eace4,
    0xffa1addf, 0xffa4aeda, 0xffa6afd5, 0xffa7b0d3, 0xffa7b1d3, 0xffa8b1d2, 0xffa8b1d3, 0xffa8b2d4,
    0xffa8b2d6, 0xffa8b2d6, 0xffa8b0d4, 0xffa7afd3, 0xffa6afd3, 0xffa5afd3, 0xffa4aed2, 0xffa3aed2,
    0xffa4aed2, 0xffa5afd3, 0xffa5aed3, 0xffa4acd1, 0xffa3abd0, 0xffa4add0, 0xffa4aed1, 0xffa3add0,
    0xffa3abd0, 0xffa4abd0, 0xffa5add1, 0xffa7afd3, 0xffa9b0d4, 0xffaab1d5, 0xffacb2d6, 0xffadb3d6,
    0xffaeb4d6, 0xffb0b6d6, 0xffb1b7d7, 0xffb3b8d8, 0xffb5bada, 0xffb6badb, 0xffb6badb, 0xffb6b9da,
    0xffb6b9d9, 0xffb7bad9, 0xffb9bcda, 0xffbabcda, 0xffbabcdb, 0xffbabcdb, 0xffbbbddb, 0xffbbbedb,
    0xffbabeda, 0xffbabeda, 0xffbabfdb, 0xffbbbfdc, 0xffbbbfdc, 0xffbbbedc, 0xffbbbedc, 0xffbbbfdb,
    0xffbbbfdb, 0xffbabeda, 0xffbabeda, 0xffbabfdb, 0xffbbbfdc, 0xffbbbfdc, 0xffbabedb, 0xffbabddb,
    0xffb9bddd, 0xffb9bcdd, 0xffb8badc, 0xffb7b9da, 0xffb7b9d9, 0xffb6b9d8, 0xffb5b9d8, 0xffb4b8d8,
    0xffb4b8d8, 0xffb3b8d9, 0xffb3b8d9, 0xffb4b7d8, 0xffb4b7d7, 0xffb4b7d6, 0xffb3b7d5, 0xffb2b6d5,
    0xffb1b5d4, 0xffb0b5d3, 0xffb0b6d2, 0xffb0b6d3, 0xffafb4d6, 0xffacb1da, 0xffa8abe0, 0xffa3a7e6,
    0xff9ca7ec, 0xff96abf0, 0xff97b6ef, 0xff9ec4e9, 0xffadd2df, 0xffc3ded3, 0xffd4e0c8, 0xffe1dbbd,
    0xffe5cfb4, 0xffe0beaf, 0xffd3aead, 0xffc29dad, 0xffb393ad, 0xffa28aae, 0xff8f81ae, 0xff817eae,
    0xff757db0, 0xff6e7eb3, 0xff697eb3, 0xff687db2, 0xff667cb2, 0xff657bb2, 0xff647ab2, 0xff6279b2,
    0xff6179b1, 0xff5f78b0, 0xff5e76ae, 0xff5d75ad, 0xff5d75ad, 0xff5d75ad, 0xff5c76ad, 0xff5b76ad,
    0xff5975ab, 0xff5874aa, 0xff5773aa, 0xff5673ab, 0xff5573ab, 0xff5472ab, 0xff5471a9, 0xff5570a8,
    0xff556fa7, 0xff5370a8, 0xff5170a9, 0xff506fa8, 0xff4f6da5, 0xff4f6da4, 0xff4f6da3, 0xff4f6da3,
    0xff94a4c8, 0xff94a4c8, 0xff8296c3, 0xff738bbf, 0xff6f88bd, 0xff718abd, 0xff738cbd, 0xff758dbe,
    0xff778dbf, 0xff788ec0, 0xff788ec0, 0xff798ec0, 0xff798ec0, 0xff798ec0, 0xff7a8fc0, 0xff7b8fc0,
    0xff7b8fc1, 0xff7d90c1, 0xff7e91c2, 0xff7f92c2, 0xff8292c2, 0xff8492c2, 0xff8691c1, 0xff8891c0,
    0xff8c91c0, 0xff9192c0, 0xff9b96bf, 0xffa69bbe, 0xffb1a2bd, 0xffbeadbf, 0xffc6b7c1, 0xffccbfc2,
    0xffcec5c4, 0xffccc9c8, 0xffc8cbcd, 0xffc1ccd3, 0xffbaccd8, 0xffb1cadd, 0xffa6c2e1, 0xff9db9e2,
    0xff98b0e3, 0xff96a9e3, 0xff98a6e0, 0xff9ca8dd, 0xffa0a9d9, 0xffa5abd5, 0xffa7acd1, 0xffa8afcf,
    0xffa7b1cf, 0xffa6b2cf, 0xffa5b1d0, 0xffa5b1d1, 0xffa5b0d3, 0xffa5afd3, 0xffa4aed2, 0xffa4add1,
    0xffa4add2, 0xffa4aed2, 0xffa3aed1, 0xffa2add0, 0xffa3add0, 0xffa4add1, 0xffa4add1, 0xffa3abd0,
    0xffa2abd0, 0xffa3acd1, 0xffa3add1, 0xffa2abd1, 0xffa2a9d0, 0xffa2a9d0, 0xffa3abd0, 0xffa5add2,
    0xffa7aed3, 0xffa9afd4, 0xffaab1d5, 0xffabb2d6, 0xffacb3d6, 0xffaeb5d6, 0xffb0b6d7, 0xffb2b7d7,
    0xffb4b9d9, 0xffb5b9da, 0xffb5b9da, 0xffb4b8d9, 0xffb4b8d8, 0xffb6b9d9, 0xffb8bbda, 0xffb8bbda,
    0xffb8bbda, 0xffb8bbda, 0xffb9bcdb, 0xffb9bddb, 0xffb9bcda, 0xffb9bcd9, 0xffb9bcd9, 0xffb9bdda,
    0xffb9bddb, 0xffb9bddb, 0xffb9bddb, 0xffb9bddb, 0xffb9bdda, 0xffb9bcd9, 0xffb9bcd9, 0xffb9bdda,
    0xffb9bddb, 0xffb9bddb, 0xffb8bcda, 0xffb8bbda, 0xffb7bbdb, 0xffb6badb, 0xffb5b8d9, 0xffb5b7d8,
    0xffb5b7d7, 0xffb4b7d6, 0xffb3b7d6, 0xffb2b6d6, 0xffb1b6d6, 0xffb0b5d7, 0xffb0b5d7, 0xffafb4d6,
    0xffafb4d5, 0xffafb4d4, 0xffafb4d3, 0xffaeb4d2, 0xffadb5d1, 0xffadb5cf, 0xffafb6ce, 0xffafb5ce,
    0xffaeb1d0, 0xffabadd4, 0xffa7a7d9, 0xffa1a3df, 0xff99a2e5, 0xff93a5e9, 0xff92aeeb, 0xff96b9e9,
    0xffa0c4e5, 0xffafcce0, 0xffbdcfd9, 0xffc8d2d0, 0xffcfd1c6, 0xffd3cdbd, 0xffd3c5b7, 0xffd0b9b1,
    0xffcbaead, 0xffc0a0aa, 0xffac8fa9, 0xff9984aa, 0xff887dac, 0xff7b7baf, 0xff707ab0, 0xff6a7bb0,
    0xff647bb0, 0xff637bb1, 0xff627ab1, 0xff6079b1, 0xff5f78b0, 0xff5e77af, 0xff5e76ae, 0xff5d75ae,
    0xff5c75ad, 0xff5c75ad, 0xff5c75ac, 0xff5b75ac, 0xff5974ab, 0xff5773aa, 0xff5673aa, 0xff5573ab,
    0xff5473ab, 0xff5472aa, 0xff5471a8, 0xff5570a7, 0xff556fa7, 0xff5370a8, 0xff5170a8, 0xff506fa7,
    0xff4f6da6, 0xff4e6ca5, 0xff4e6ca3, 0xff4e6ca3, 0xff889bc5, 0xff889bc5, 0xff7c92c3, 0xff738bc1,
    0xff708abf, 0xff718bbd, 0xff738cbd, 0xff758dbe, 0xff778dbf, 0xff778ec0, 0xff778ec0, 0xff778dc0,
    0xff778dc0, 0xff778ebf, 0xff788fbf, 0xff788ebf, 0xff788dc0, 0xff7a8dc1, 0xff7b8fc2, 0xff7d90c2,
    0xff7f90c1, 0xff8290c0, 0xff8690bf, 0xff8b91bf, 0xff9392bf, 0xff9c95c0, 0xffa99bbf, 0xffb5a3bd,
    0xffc1adbc, 0xffcabbbe, 0xffccc5c2, 0xffcbccc6, 0xffc4cfcb, 0xffbbccd1, 0xffb1c6d8, 0xffaabfde,
    0xffa8bbe0, 0xffa5b7e1, 0xffa1b2e1, 0xff9eafdf, 0xff9cacdd, 0xff9caada, 0xff9daad7, 0xff9fabd5,
    0xffa2abd3, 0xffa4abd2, 0xffa6acd1, 0xffa6afcf, 0xffa5b0cf, 0xffa4b0cf, 0xffa2afd0, 0xffa1afd0,
    0xffa1aed0, 0xffa1add0, 0xffa1acd0, 0xffa1abd0, 0xffa2add0, 0xffa3aed0, 0xffa3adcf, 0xffa2acce,
    0xffa2acce, 0xffa3accf, 0xffa3acd0, 0xffa2abd1, 0xffa2abd1, 0xffa2abd1, 0xffa2abd1, 0xffa1aad0,
    0xffa1a9d0, 0xffa1a9d0, 0xffa2aad1, 0xffa4acd1, 0xffa6add2, 0xffa7aed3, 0xffa9b0d4, 0xffaab2d5,
    0xffabb4d6, 0xffacb5d6, 0xffaeb6d6, 0xffb0b7d7, 0xffb2b8d7, 0xffb4b9d8, 0xffb4b9d8, 0xffb3b8d8,
    0xffb3b8d8, 0xffb5b9d9, 0xffb7bbda, 0xffb7bbda, 0xffb7bbda, 0xffb7bbda, 0xffb7bcdb, 0xffb7bcdb,
    0xffb7bbda, 0xffb7bbd9, 0xffb7bbd8, 0xffb7bcd8, 0xffb8bcd9, 0xffb9bcdb, 0xffb9bcdb, 0xffb8bbdb,
    0xffb8bbda, 0xffb8bbd9, 0xffb8bbd9, 0xffb8bcda, 0xffb7bcdb, 0xffb7bcdb, 0xffb6bcda, 0xffb6bad9,
    0xffb5b9d8, 0xffb4b8d8, 0xffb3b7d7, 0xffb3b7d6, 0xffb3b7d6, 0xffb2b6d6, 0xffb1b6d6, 0xffb0b5d5,
    0xffafb5d5, 0xffaeb4d6, 0xffaeb3d6, 0xffadb2d4, 0xffacb2d3, 0xffabb1d2, 0xffabb1d2, 0xffabb1d2,
    0xffaab2d1, 0xffaab2d0, 0xffabb3cf, 0xffabb2cf, 0xffa9afcf, 0xffa7add1, 0xffa5aad4, 0xffa3a9d6,
    0xffa1a9d9, 0xff9faadb, 0xff9dacdd, 0xff9dafdf, 0xff9eb2e1, 0xffa0b3e4, 0xffa4b6e4, 0xffa8bee0,
    0xffaec8d8, 0xffbad0ce, 0xffc6d4c4, 0xffd2d0b8, 0xffd9c5b0, 0xffd5b5aa, 0xffc5a0a7, 0xffb08fa8,
    0xff9d82a9, 0xff8a7bab, 0xff7a78ac, 0xff6f78ad, 0xff6579af, 0xff617ab0, 0xff5f7ab0, 0xff5e79b0,
    0xff5e77af, 0xff5f76ae, 0xff5f76ad, 0xff5e76ad, 0xff5d75ae, 0xff5c75ae, 0xff5c75ad, 0xff5b75ac,
    0xff5874ab, 0xff5673ab, 0xff5572ab, 0xff5572ab, 0xff5472aa, 0xff5371a9, 0xff5370a8, 0xff546fa8,
    0xff546ea8, 0xff536ea7, 0xff526fa7, 0xff516ea7, 0xff506da7, 0xff4f6ca5, 0xff4e6ca3, 0xff4e6ca1,
    0xff7c92c1, 0xff7c92c1, 0xff768ec2, 0xff718bc3, 0xff6f8bc0, 0xff708cbd, 0xff738cbd, 0xff758dbe,
    0xff778dbf, 0xff768dbf, 0xff768dbf, 0xff768cc0, 0xff768cc0, 0xff768dc0, 0xff768ebf, 0xff768dbf,
    0xff768bc0, 0xff788bc0, 0xff7a8dc1, 0xff7d8ec1, 0xff818ebf, 0xff858fbe, 0xff8b91bd, 0xff9494be,
    0xff9f98bf, 0xffa99cc1, 0xffb7a4c0, 0xffc2adbe, 0xffcab7be, 0xffcec4c1, 0xffcbcdc6, 0xffc4d2cc,
    0xffb8d1d3, 0xffa9c9da, 0xff9dbde1, 0xff96b2e5, 0xff98abe5, 0xff9ba7e3, 0xff9ea6df, 0xff9fa7db,
    0xffa0a9d5, 0xffa0acd1, 0xffa1adce, 0xffa1adce, 0xffa3adce, 0xffa4acd0, 0xffa4acd1, 0xffa3add1,
    0xffa2aed0, 0xffa1aed0, 0xff9fadd0, 0xff9eaccf, 0xff9eabce, 0xff9eaace, 0xff9eaacf, 0xff9eaacf,
    0xffa0accf, 0xffa1adcf, 0xffa1acce, 0xffa1abcd, 0xffa1aacd, 0xffa1aace, 0xffa1aad0, 0xffa1abd1,
    0xffa1abd1, 0xffa0aad1, 0xffa0a9d1, 0xffa0a8d1, 0xffa0a8d0, 0xffa0a8d0, 0xffa1a9d0, 0xffa3abd0,
    0xffa5acd1, 0xffa6add2, 0xffa7afd4, 0xffa8b1d5, 0xffa9b3d6, 0xffabb4d6, 0xffacb5d6, 0xffaeb6d6,
    0xffb0b7d6, 0xffb2b8d7, 0xffb3b8d7, 0xffb2b8d7, 0xffb2b8d7, 0xffb3b9d8, 0xffb5bada, 0xffb5bada,
    0xffb5bada, 0xffb5bada, 0xffb5bbda, 0xffb5bbda, 0xffb6bada, 0xffb6bad9, 0xffb5bad8, 0xffb5bad7,
    0xffb6bad8, 0xffb7bbd9, 0xffb7bbda, 0xffb7bada, 0xffb7b9d9, 0xffb7b9d9, 0xffb7bad9, 0xffb6bada,
    0xffb5bada, 0xffb5bada, 0xffb4b9d9, 0xffb3b8d7, 0xffb2b7d7, 0xffb1b6d6, 0xffb1b6d5, 0xffb1b6d5,
    0xffb0b6d5, 0xffafb5d5, 0xffaeb4d5, 0xffaeb4d4, 0xffadb2d4, 0xffacb2d4, 0xffabb1d4, 0xffaab0d2,
    0xffa9b0d1, 0xffa8afd1, 0xffa7aed2, 0xffa6aed2, 0xffa6afd2, 0xffa6afd2, 0xffa6afd1, 0xffa6aed0,
    0xffa4acd0, 0xffa3acd0, 0xffa3add0, 0xffa5aed0, 0xffa7aecf, 0xffa8aece, 0xffa7acd0, 0xffa4a8d4,
    0xff9ea3db, 0xff959fe4, 0xff90a1ea, 0xff8eacea, 0xff93bce5, 0xffa2ccdc, 0xffb5d8d0, 0xffcbdbc2,
    0xffd9d4b8, 0xffddc6b0, 0xffd3b1ab, 0xffc29eaa, 0xffb08ea8, 0xff9c83a8, 0xff8a7da9, 0xff7b7bab,
    0xff6d7aad, 0xff667aae, 0xff627aae, 0xff5f78ae, 0xff5e76ad, 0xff5e76ad, 0xff5f76ad, 0xff5e76ae,
    0xff5c75ae, 0xff5b75ae, 0xff5a74ac, 0xff5a74ab, 0xff5873ab, 0xff5672ab, 0xff5572ab, 0xff5572aa,
    0xff5472a9, 0xff5371a7, 0xff5370a7, 0xff536fa8, 0xff536ea8, 0xff536ea7, 0xff526fa6, 0xff516ea7,
    0xff506da7, 0xff4f6ca6, 0xff4d6ba3, 0xff4d6ba1, 0xff708abe, 0xff708abe, 0xff6d88c0, 0xff6b88c2,
    0xff6d89c1, 0xff708bbf, 0xff738cbe, 0xff758dbe, 0xff768dbe, 0xff768dbf, 0xff768dbf, 0xff778cc0,
    0xff778cc0, 0xff768dbf, 0xff758dbf, 0xff748cc0, 0xff748bc1, 0xff768ac1, 0xff798ac0, 0xff7f8bbf,
    0xff858bbe, 0xff8d8ebd, 0xff9893bc, 0xffa59bbc, 0xffb2a4bd, 0xffbdacbf, 0xffc5b6c1, 0xffc8bec2,
    0xffc7c4c6, 0xffc2c9cb, 0xffbac9d1, 0xffb1c8d7, 0xffa8c4dc, 0xff9ebce1, 0xff96b3e3, 0xff93abe3,
    0xff95a6e0, 0xff99a3dd, 0xff9da3d9, 0xff9fa5d5, 0xffa0a8d0, 0xffa0accc, 0xffa0adcb, 0xffa0adcb,
    0xffa0adcd, 0xffa2acce, 0xffa2abcf, 0xffa1accf, 0xffa0accf, 0xff9facd0, 0xff9dabd0, 0xff9caacf,
    0xff9ca9cd, 0xff9ca9cd, 0xff9ca9ce, 0xff9ca9cf, 0xff9eaacf, 0xff9faace, 0xff9faacd, 0xff9faacd,
    0xff9faacd, 0xff9fa9ce, 0xff9fa9cf, 0xff9faad0, 0xff9faad0, 0xff9ea9d2, 0xff9ea8d2, 0xff9ea7d1,
    0xff9ea7d0, 0xff9fa8d0, 0xffa1a9d0, 0xffa3abd0, 0xffa4abd0, 0xffa5acd1, 0xffa6aed3, 0xffa7b0d5,
    0xffa8b2d6, 0xffaab3d6, 0xffabb4d6, 0xffacb5d6, 0xffaeb5d6, 0xffb0b6d7, 0xffb1b6d7, 0xffb1b6d7,
    0xffb1b7d7, 0xffb2b8d8, 0xffb3b9da, 0xffb4b9da, 0xffb4b9d9, 0xffb4b9d9, 0xffb4b9d9, 0xffb4b9d9,
    0xffb5b9d9, 0xffb5b9d9, 0xffb4b9d8, 0xffb3b9d7, 0xffb3b9d7, 0xffb5b9d9, 0xffb5b9d9, 0xffb5b8d8,
    0xffb5b8d8, 0xffb5b9d8, 0xffb5b9d8, 0xffb4b9d8, 0xffb3b8d8, 0xffb2b7d7, 0xffb2b6d6, 0xffb0b6d6,
    0xffb0b5d5, 0xffafb5d5, 0xffafb4d4, 0xffaeb4d4, 0xffadb4d5, 0xffabb3d5, 0xffabb2d5, 0xffabb2d4,
    0xffabb1d3, 0xffa9b0d2, 0xffa8afd2, 0xffa7aed0, 0xffa6add0, 0xffa5acd1, 0xffa5acd2, 0xffa5acd2,
    0xffa4add1, 0xffa4add1, 0xffa3acd0, 0xffa2abcf, 0xffa1aacf, 0xffa1aacf, 0xffa2abce, 0xffa5adcc,
    0xffa7adca, 0xffa9adc8, 0xffa7a9ca, 0xffa3a4cf, 0xff9d9fd5, 0xff939add, 0xff8d9ce2, 0xff8aa4e5,
    0xff8dafe4, 0xff96bbe0, 0xffa3c5db, 0xffb3cbd2, 0xffbeccc9, 0xffc7c9c0, 0xffcbc2b8, 0xffc8b7b2,
    0xffc3a9ab, 0xffb69aa6, 0xffa58ca5, 0xff9381a7, 0xff7f79a9, 0xff7277aa, 0xff6876ab, 0xff6075ab,
    0xff5d75ab, 0xff5c76ac, 0xff5d76ad, 0xff5c76ae, 0xff5b75ae, 0xff5a74ae, 0xff5973ac, 0xff5973ab,
    0xff5872ab, 0xff5772ab, 0xff5672aa, 0xff5572a9, 0xff5472a8, 0xff5271a6, 0xff5270a6, 0xff526fa7,
    0xff526ea7, 0xff526ea6, 0xff526fa5, 0xff516ea6, 0xff506da6, 0xff4f6ca5, 0xff4d6ba3, 0xff4d6ba2,
    0xff6b86bc, 0xff6b86bc, 0xff6886be, 0xff6786c0, 0xff6b88c2, 0xff708ac2, 0xff738bc0, 0xff758cbe,
    0xff758cbd, 0xff768dbe, 0xff768dbf, 0xff798ec0, 0xff7a8ec0, 0xff798ebf, 0xff768dbf, 0xff748cc0,
    0xff748ac1, 0xff7688c0, 0xff7b88bf, 0xff8289bd, 0xff8d8cbc, 0xff9891bc, 0xffa699bb, 0xffb3a4bb,
    0xffc0b0bc, 0xffc9bbbe, 0xffccc5c3, 0xffc6cbc8, 0xffbbcccf, 0xffafc7d6, 0xffa6bfdb, 0xff9fb8df,
    0xff9cb2e1, 0xff99aee1, 0xff98acdf, 0xff98aadb, 0xff99a9d8, 0xff9aa8d5, 0xff9da7d2, 0xff9ea8d1,
    0xff9ea9ce, 0xff9eabcc, 0xff9eabcc, 0xff9eabcd, 0xff9eabcd, 0xffa0abce, 0xffa0abce, 0xff9fabce,
    0xff9eabce, 0xff9daacf, 0xff9ca9d0, 0xff9ba8d0, 0xff9ba7ce, 0xff9ba7ce, 0xff9ba8cf, 0xff9ba9cf,
    0xff9ca9ce, 0xff9da8ce, 0xff9da8ce, 0xff9da8cf, 0xff9da8cf, 0xff9da9d0, 0xff9da9d0, 0xff9da9d0,
    0xff9da9d0, 0xff9ca9d2, 0xff9ca8d2, 0xff9ca7d1, 0xff9da7cf, 0xff9fa8cf, 0xffa2aad0, 0xffa4abd0,
    0xffa4acd0, 0xffa4acd1, 0xffa6aed3, 0xffa7b0d5, 0xffa9b1d6, 0xffaab2d6, 0xffabb3d6, 0xffabb4d7,
    0xffadb4d7, 0xffafb5d7, 0xffb0b5d7, 0xffb1b6d6, 0xffb1b7d6, 0xffb1b8d7, 0xffb2b8d9, 0xffb3b9d9,
    0xffb4b9d9, 0xffb4b9d9, 0xffb3b8d8, 0xffb3b8d8, 0xffb3b8d9, 0xffb3b8d9, 0xffb2b8d9, 0xffb2b8d8,
    0xffb2b8d8, 0xffb3b8d7, 0xffb3b8d7, 0xffb4b8d7, 0xffb4b8d7, 0xffb4b8d7, 0xffb3b8d7, 0xffb2b8d7,
    0xffb1b7d7, 0xffb0b6d6, 0xffafb5d4, 0xffafb4d4, 0xffafb4d5, 0xffafb4d5, 0xffadb3d4, 0xffabb2d4,
    0xffaab2d5, 0xffa9b2d5, 0xffa9b1d5, 0xffa9b0d4, 0xffa9afd2, 0xffa7aed2, 0xffa6aed1, 0xffa5add0,
    0xffa4acd0, 0xffa4acd1, 0xffa4acd2, 0xffa4acd1, 0xffa3acd0, 0xffa3acce, 0xffa2abce, 0xffa1aace,
    0xffa0a9cf, 0xffa0a9cf, 0xffa1aace, 0xffa2aacc, 0xffa3aacb, 0xffa4a9ca, 0xffa2a7cb, 0xffa0a5ce,
    0xff9ca2d1, 0xff98a1d4, 0xff96a2d6, 0xff96a5d9, 0xff97a8dc, 0xff97aade, 0xff97acde, 0xff9ab1dc,
    0xff9eb9d8, 0xffa7c1d1, 0xffb7c9c6, 0xffc2c8bb, 0xffcac0b0, 0xffc8b0a8, 0xffbb9ca4, 0xffa88aa4,
    0xff917ba5, 0xff8076a7, 0xff7173a8, 0xff6573a9, 0xff5e74aa, 0xff5b75ac, 0xff5b75ad, 0xff5a75ad,
    0xff5974ad, 0xff5973ad, 0xff5872ac, 0xff5872ac, 0xff5872ac, 0xff5872ab, 0xff5772aa, 0xff5572a9,
    0xff5472a8, 0xff5372a6, 0xff5170a6, 0xff516ea7, 0xff516da7, 0xff526ea6, 0xff526fa5, 0xff516ea5,
    0xff4f6ca4, 0xff4e6ba3, 0xff4d6ba2, 0xff4d6ba1, 0xff6d87bc, 0xff6d87bc, 0xff6987bd, 0xff6787be,
    0xff6a88c1, 0xff6f89c3, 0xff728ac1, 0xff738bbe, 0xff758cbd, 0xff768dbe, 0xff788dbf, 0xff7b8ebf,
    0xff7c8ebf, 0xff7b8dbf, 0xff798cbf, 0xff788bc0, 0xff798bc1, 0xff7d8bc0, 0xff838abd, 0xff8d8cbb,
    0xff9a91bc, 0xffa798bd, 0xffb3a2bd, 0xffbeafbd, 0xffc7bcbe, 0xffccc6c0, 0xffc8cec7, 0xffbcd1cf,
    0xffadccd8, 0xff9ec0df, 0xff95b3e2, 0xff92a9e4, 0xff94a3e2, 0xff98a3de, 0xff9ca7da, 0xff9eaad4,
    0xff9dabd0, 0xff9cabce, 0xff9dabcd, 0xff9daace, 0xff9caace, 0xff9baace, 0xff9baace, 0xff9ba9ce,
    0xff9ca9ce, 0xff9daace, 0xff9eaace, 0xff9daace, 0xff9ca9ce, 0xff9ba8cf, 0xff9ba7d0, 0xff9ba6d0,
    0xff9ba6cf, 0xff9ba6cf, 0xff9aa8d0, 0xff9aa8d0, 0xff9ba7cf, 0xff9ba6ce, 0xff9ba6cf, 0xff9ba7d0,
    0xff9ba8d0, 0xff9ba8d0, 0xff9ba8d0, 0xff9ba7cf, 0xff9ba7cf, 0xff9aa7d1, 0xff9aa7d2, 0xff9aa7d1,
    0xff9ca7cf, 0xff9ea9cf, 0xffa2abd0, 0xffa4acd0, 0xffa4acd0, 0xffa4acd1, 0xffa6aed3, 0xffa7afd4,
    0xffa8b0d5, 0xffa9b1d5, 0xffa9b1d6, 0xffa9b2d7, 0xffabb2d7, 0xffadb2d7, 0xffaeb3d7, 0xffb0b5d6,
    0xffb0b6d6, 0xffb0b7d7, 0xffb0b7d8, 0xffb1b8d8, 0xffb3b8d8, 0xffb3b8d8, 0xffb3b7d7, 0xffb2b7d7,
    0xffb2b7d8, 0xffb2b7d8, 0xffb2b7d8, 0xffb1b7d8, 0xffb1b7d7, 0xffb1b6d6, 0xffb1b6d6, 0xffb2b7d6,
    0xffb2b7d6, 0xffb2b7d6, 0xffb1b6d6, 0xffb0b6d6, 0xffafb5d5, 0xffaeb4d4, 0xffadb2d3, 0xffadb2d3,
    0xffadb3d4, 0xffadb3d5, 0xffaab1d4, 0xffa8b0d4, 0xffa6b0d5, 0xffa6b0d5, 0xffa6afd4, 0xffa7aed3,
    0xffa7add1, 0xffa5acd0, 0xffa4acd0, 0xffa2abd0, 0xffa2aad0, 0xffa2aad1, 0xffa3abd1, 0xffa3abd0,
    0xffa2aacf, 0xffa2aacd, 0xffa1a9cd, 0xffa0a8cd, 0xff9fa7ce, 0xff9fa7cf, 0xff9fa7ce, 0xff9fa6cd,
    0xff9fa5cc, 0xff9ea4cb, 0xff9da4cc, 0xff9ca4cd, 0xff9ca4ce, 0xff9ca7cb, 0xff9da7ca, 0xff9fa5cd,
    0xff9ea1d2, 0xff979bd8, 0xff8e96de, 0xff869be2, 0xff83a7e2, 0xff8bb7dd, 0xffa1c8d2, 0xffb5cfc5,
    0xffc5ccb9, 0xffcabfae, 0xffc5aca8, 0xffb797a6, 0xffa284a5, 0xff917ba5, 0xff7e76a6, 0xff6f74a6,
    0xff6375a7, 0xff5e75aa, 0xff5c74ac, 0xff5a73ac, 0xff5972ab, 0xff5872ab, 0xff5771ab, 0xff5771ab,
    0xff5872ab, 0xff5872aa, 0xff5772a9, 0xff5571a8, 0xff5371a7, 0xff5270a6, 0xff506fa6, 0xff506ea6,
    0xff506da6, 0xff516ea6, 0xff516fa5, 0xff506ea4, 0xff4e6ca2, 0xff4d6ba1, 0xff4d6ba1, 0xff4d6ba1,
    0xff798fbe, 0xff798fbe, 0xff738dbe, 0xff6f8bbe, 0xff6d89c0, 0xff6e89c1, 0xff6f8ac0, 0xff718bbf,
    0xff738cbe, 0xff758dbe, 0xff788dbe, 0xff7a8dbf, 0xff7b8dbf, 0xff7a8cbf, 0xff7a8abe, 0xff7d89bf,
    0xff828abf, 0xff8b8cbe, 0xff948fbb, 0xffa095b9, 0xffb09fba, 0xffbcaabc, 0xffc2b6be, 0xffc3c0c1,
    0xffc2c6c6, 0xffbfc8cb, 0xffb7c8d3, 0xffadc5da, 0xffa2bfdf, 0xff97b4e1, 0xff93abe0, 0xff91a4df,
    0xff94a0dd, 0xff98a1d9, 0xff9da6d4, 0xff9fa9d0, 0xff9dabcd, 0xff9cabcc, 0xff9ba9cd, 0xff9ba8ce,
    0xff9ba8cf, 0xff9aa9cf, 0xff99a8cf, 0xff99a7ce, 0xff9aa7ce, 0xff9ba8cf, 0xff9ca9cf, 0xff9ca9cf,
    0xff9ba8cf, 0xff9aa7cf, 0xff9aa6d0, 0xff9aa6d0, 0xff9aa6d0, 0xff9aa6d0, 0xff99a7d0, 0xff99a7d0,
    0xff9aa6cf, 0xff9aa6cf, 0xff9aa6d0, 0xff9aa6d1, 0xff9aa6d1, 0xff9aa7d0, 0xff9aa7d0, 0xff9aa6cf,
    0xff9aa6cf, 0xff99a6d0, 0xff99a6d1, 0xff99a6d1, 0xff9aa7d0, 0xff9ea9d0, 0xffa1abd0, 0xffa4acd0,
    0xffa4acd0, 0xffa4acd0, 0xffa5add2, 0xffa6aed3, 0xffa7afd4, 0xffa8afd4, 0xffa8afd5, 0xffa8b0d6,
    0xffa9b0d6, 0xffabb1d6, 0xffacb2d6, 0xffadb4d5, 0xffaeb5d5, 0xffaeb6d6, 0xffafb6d7, 0xffb0b6d7,
    0xffb1b7d7, 0xffb1b7d7, 0xffb1b7d6, 0xffb1b7d6, 0xffb1b6d7, 0xffb1b6d7, 0xffb1b6d7, 0xffb0b6d7,
    0xffb0b6d7, 0xffafb5d6, 0xffafb5d6, 0xffb0b6d5, 0xffb0b6d5, 0xffb0b5d5, 0xffafb4d5, 0xffaeb4d5,
    0xffadb4d4, 0xffacb3d4, 0xffabb1d3, 0xffabb1d3, 0xffabb2d3, 0xffaab2d3, 0xffa8b0d4, 0xffa6aed4,
    0xffa5aed4, 0xffa5aed4, 0xffa5add3, 0xffa5acd2, 0xffa5abd0, 0xffa4aacf, 0xffa3aace, 0xffa2a9ce,
    0xffa1a9cf, 0xffa1aad0, 0xffa2aad0, 0xffa2aacf, 0xffa1a9ce, 0xffa0a7cd, 0xff9fa7cd, 0xff9fa6cd,
    0xff9ea5cd, 0xff9da5cd, 0xff9da5cd, 0xff9da4cc, 0xff9ca3cc, 0xff9aa1cb, 0xff99a1cb, 0xff99a2cc,
    0xff9aa4cb, 0xff9da7c7, 0xff9ea7c5, 0xff9fa3c8, 0xff9d9dcd, 0xff9696d2, 0xff8c91d6, 0xff8494da,
    0xff7f9ddd, 0xff82a8dd, 0xff90b4d9, 0xff9fbcd2, 0xffabc1c8, 0xffb3c1bd, 0xffb9b9b4, 0xffbaadad,
    0xffb39da7, 0xffa88ea4, 0xff9782a2, 0xff8379a2, 0xff7074a3, 0xff6571a6, 0xff5e71a9, 0xff5a71aa,
    0xff5871aa, 0xff5671aa, 0xff5670aa, 0xff5670a9, 0xff5771a8, 0xff5771a8, 0xff5671a8, 0xff5470a7,
    0xff5370a7, 0xff526fa6, 0xff516ea6, 0xff506da6, 0xff506da6, 0xff506ea6, 0xff506ea5, 0xff4f6da3,
    0xff4e6ca1, 0xff4d6ba0, 0xff4c6aa0, 0xff4c6aa0, 0xff8898c2, 0xff8898c2, 0xff8195c0, 0xff7891bf,
    0xff718cbf, 0xff6d89bf, 0xff6d89bf, 0xff6f8bc0, 0xff728cc0, 0xff748cbf, 0xff768cbe, 0xff798cbe,
    0xff7a8bbe, 0xff7a8abe, 0xff7c89bd, 0xff8389bd, 0xff8d8abd, 0xff9a90bc, 0xffa496ba, 0xffb1a0b9,
    0xffc2aeba, 0xffcababd, 0xffc8c5c1, 0xffc0cbc8, 0xffb5cacf, 0xffabc3d6, 0xffa2bbde, 0xff9db5e2,
    0xff9aafe2, 0xff99abde, 0xff99a9da, 0xff98a5d7, 0xff99a4d5, 0xff9aa5d3, 0xff9ca9d2, 0xff9dabd0,
    0xff9caacf, 0xff9ba9cf, 0xff9aa7cf, 0xff99a6cf, 0xff99a7d0, 0xff9aa8d1, 0xff99a7d0, 0xff98a6ce,
    0xff98a6ce, 0xff9aa7cf, 0xff9ba8d0, 0xff9ba9cf, 0xff9ba8cf, 0xff9aa7cf, 0xff99a5d0, 0xff99a5d0,
    0xff9aa6d0, 0xff9aa6d0, 0xff99a7d0, 0xff99a7d0, 0xff9aa7d1, 0xff9aa7d1, 0xff9aa7d1, 0xff99a6d1,
    0xff99a6d0, 0xff9aa6cf, 0xff9aa6cf, 0xff99a6d0, 0xff99a6d0, 0xff99a6cf, 0xff99a6cf, 0xff99a6cf,
    0xff9ba6d0, 0xff9da8d0, 0xffa1aacf, 0xffa3abcf, 0xffa3abcf, 0xffa3abcf, 0xffa4acd1, 0xffa5add2,
    0xffa6aed3, 0xffa7aed4, 0xffa7aed4, 0xffa7afd4, 0xffa7b0d4, 0xffa9b1d5, 0xffaab2d5, 0xffabb3d5,
    0xffacb4d5, 0xffadb5d6, 0xffaeb5d7, 0xffaeb5d7, 0xffafb6d6, 0xffb0b6d6, 0xffb1b7d6, 0xffb1b7d6,
    0xffb1b6d6, 0xffb0b5d6, 0xffb0b5d6, 0xffafb5d6, 0xffafb5d6, 0xffaeb4d6, 0xffaeb4d6, 0xffafb5d5,
    0xffafb5d5, 0xffaeb4d4, 0xffadb3d4, 0xffacb3d4, 0xffabb3d4, 0xffabb3d4, 0xffabb2d3, 0xffabb2d2,
    0xffa9b2d1, 0xffa8b1d1, 0xffa7aed2, 0xffa6add3, 0xffa5add3, 0xffa4add3, 0xffa4acd2, 0xffa3abd1,
    0xffa3aacf, 0xffa2a9ce, 0xffa2a9cd, 0xffa1a9cd, 0xffa1a9ce, 0xffa1aacf, 0xffa0aacf, 0xffa0a9ce,
    0xff9fa7cd, 0xff9fa5cd, 0xff9fa5cd, 0xff9fa5cd, 0xff9ca4cd, 0xff9ba4cc, 0xff9ca4cb, 0xff9ca3ca,
    0xff9aa2ca, 0xff98a0cb, 0xff979fcb, 0xff989fcc, 0xff99a0cb, 0xff9aa3c7, 0xff9aa3c6, 0xff9aa0c8,
    0xff989dca, 0xff949acc, 0xff8f99cd, 0xff8b99cf, 0xff899bd3, 0xff889dd6, 0xff889dda, 0xff8ba1d9,
    0xff8dabd4, 0xff94b6ca, 0xffa2bdc0, 0xffb1bdb6, 0xffb9b3ac, 0xffb7a3a6, 0xffab90a2, 0xff9680a0,
    0xff7e74a0, 0xff6e70a2, 0xff636fa4, 0xff5b70a7, 0xff5871a9, 0xff5671a9, 0xff5670a7, 0xff566fa6,
    0xff556fa6, 0xff556fa6, 0xff556fa6, 0xff546ea6, 0xff536ea6, 0xff526ea5, 0xff516ea5, 0xff516da7,
    0xff516da7, 0xff506ca7, 0xff4f6ca5, 0xff4e6ca3, 0xff4d6ba1, 0xff4c6ba0, 0xff4c6aa0, 0xff4c6aa0,
    0xff98a3c5, 0xff98a3c5, 0xff8f9ec3, 0xff8397c0, 0xff768fbd, 0xff6d89bc, 0xff6a88bd, 0xff6e8abf,
    0xff728bc0, 0xff748bbe, 0xff778bbd, 0xff7a8abd, 0xff7c8abd, 0xff7e8abd, 0xff848bbc, 0xff8f8dbc,
    0xff9c91bc, 0xffab99bc, 0xffb5a2bb, 0xffc0aebb, 0xffccbdbd, 0xffcec7c1, 0xffc6cfc7, 0xffb7d0cf,
    0xffa6c8d8, 0xff9abbdf, 0xff92aee4, 0xff92a6e5, 0xff96a2e1, 0xff9ba4da, 0xff9ea7d4, 0xff9fa8d0,
    0xff9da8ce, 0xff9ca9cd, 0xff9baace, 0xff9baad0, 0xff9ba8d1, 0xff9aa7d2, 0xff98a5d2, 0xff97a4d1,
    0xff98a5d2, 0xff99a6d2, 0xff98a6d1, 0xff97a5ce, 0xff97a5ce, 0xff99a6d0, 0xff9aa7d1, 0xff9aa7d1,
    0xff9aa7d0, 0xff99a6d0, 0xff98a5d0, 0xff98a5d0, 0xff99a6d0, 0xff99a6d0, 0xff99a6d0, 0xff99a6d0,
    0xff9aa7d1, 0xff9aa7d2, 0xff9aa6d2, 0xff99a5d1, 0xff99a5d0, 0xff99a5cf, 0xff99a5cf, 0xff98a5d0,
    0xff98a5d0, 0xff98a5cf, 0xff99a5ce, 0xff99a5cf, 0xff9ba6d1, 0xff9da7d1, 0xffa0a9cf, 0xffa2abcf,
    0xffa3abcf, 0xffa3abcf, 0xffa4acd0, 0xffa4acd1, 0xffa5acd2, 0xffa6add3, 0xffa6add3, 0xffa6aed2,
    0xffa6afd2, 0xffa7b0d3, 0xffa8b1d3, 0xffa9b2d3, 0xffaab3d4, 0xffacb4d5, 0xffadb4d6, 0xffadb4d6,
    0xffadb5d5, 0xffadb5d5, 0xffaeb6d5, 0xffafb6d5, 0xffafb5d5, 0xffaeb4d5, 0xffadb4d5, 0xffadb4d5,
    0xffadb4d5, 0xffadb3d6, 0xffadb3d6, 0xffadb3d6, 0xffadb3d5, 0xffacb2d4, 0xffabb1d3, 0xffaab1d3,
    0xffa9b1d4, 0xffa9b1d4, 0xffa9b1d4, 0xffa8b1d2, 0xffa6b0d0, 0xffa5afcf, 0xffa5add1, 0xffa5acd2,
    0xffa5acd2, 0xffa4acd1, 0xffa3abd0, 0xffa2aad0, 0xffa1a9ce, 0xffa0a8cd, 0xffa0a8cc, 0xffa0a8cc,
    0xffa0a8cd, 0xff9fa8cd, 0xff9ea8cd, 0xff9da7cd, 0xff9da5cd, 0xff9da3cd, 0xff9da3cd, 0xff9da3cd,
    0xff9aa2cb, 0xff99a2ca, 0xff9aa2c9, 0xff9aa1c9, 0xff98a0c9, 0xff969fca, 0xff959dca, 0xff959dca,
    0xff969dc9, 0xff979ec8, 0xff969fc8, 0xff949ec9, 0xff929dc9, 0xff929ec7, 0xff929fc4, 0xff929ec4,
    0xff929ac7, 0xff8e94cd, 0xff838bd6, 0xff7b8bdb, 0xff7697da, 0xff7aa8d3, 0xff8cb8ca, 0xffa2c1bf,
    0xffb4beb3, 0xffbab0ab, 0xffb49da5, 0xffa48ba0, 0xff8d7b9f, 0xff7d749f, 0xff6f72a0, 0xff6471a3,
    0xff5d71a5, 0xff5870a6, 0xff576fa5, 0xff576ea4, 0xff556ea4, 0xff546ea4, 0xff536ea4, 0xff536da5,
    0xff526da5, 0xff516da5, 0xff516da5, 0xff516da7, 0xff516da7, 0xff4f6ca6, 0xff4e6ba4, 0xff4d6ba3,
    0xff4d6ba1, 0xff4c6aa0, 0xff4b699f, 0xff4b699f, 0xffa5adca, 0xffa5adca, 0xff9ba5c6, 0xff8d9bc1,
    0xff7d92bd, 0xff6f8bbb, 0xff6b88bc, 0xff6d89be, 0xff728abf, 0xff758bbf, 0xff798bbe, 0xff7e8abd,
    0xff838abc, 0xff8a8bbb, 0xff9590ba, 0xffa497b9, 0xffb49fb9, 0xffc2adbb, 0xffc9babd, 0xffccc4c1,
    0xffc9cbc8, 0xffc1cbce, 0xffb5c9d5, 0xffa7c3db, 0xff9bbae0, 0xff93b0e2, 0xff8fa7e2, 0xff91a2df,
    0xff96a1db, 0xff9ca4d6, 0xff9fa7d2, 0xff9fa9cf, 0xff9ea9cd, 0xff9ca9cc, 0xff9ba8cd, 0xff9aa8cf,
    0xff99a7d1, 0xff99a6d2, 0xff98a4d2, 0xff97a3d1, 0xff97a4d1, 0xff98a5d1, 0xff98a5d0, 0xff97a4cf,
    0xff97a4cf, 0xff98a5d0, 0xff99a6d1, 0xff99a6d1, 0xff99a6d0, 0xff99a6cf, 0xff98a5cf, 0xff98a5cf,
    0xff98a5d0, 0xff98a5d0, 0xff99a5d0, 0xff99a5d0, 0xff99a6d1, 0xff99a6d1, 0xff99a5d1, 0xff98a4d0,
    0xff98a4d0, 0xff98a4cf, 0xff98a4cf, 0xff97a4d0, 0xff97a4d0, 0xff98a4cf, 0xff99a4ce, 0xff99a5cf,
    0xff9aa6d1, 0xff9ca7d1, 0xff9fa8cf, 0xffa1aacf, 0xffa2aacf, 0xffa2abcf, 0xffa3acd0, 0xffa4acd1,
    0xffa5add2, 0xffa5add2, 0xffa5add2, 0xffa5add1, 0xffa5add1, 0xffa6aed1, 0xffa7afd2, 0xffa7b0d3,
    0xffa8b1d4, 0xffa9b2d5, 0xffabb3d6, 0xffabb3d6, 0xffabb4d5, 0xffabb4d5, 0xffacb5d4, 0xffadb5d4,
    0xffadb4d5, 0xffacb3d5, 0xffabb2d5, 0xffabb2d5, 0xffabb2d5, 0xffabb2d5, 0xffabb2d5, 0xffaab2d4,
    0xffaab2d4, 0xffaab1d3, 0xffa9b0d3, 0xffa8afd3, 0xffa7afd3, 0xffa7afd3, 0xffa7afd2, 0xffa6afd1,
    0xffa5aed0, 0xffa4adcf, 0xffa3acd0, 0xffa3abd1, 0xffa3abd0, 0xffa3abcf, 0xffa2aace, 0xffa1a9cd,
    0xff9fa8cd, 0xff9ea7cc, 0xff9da7cc, 0xff9da6cc, 0xff9da6cc, 0xff9ca6cb, 0xff9ba6cb, 0xff9ba5cb,
    0xff9ba3cc, 0xff9ba1cc, 0xff9ba1cc, 0xff9aa1cc, 0xff97a0ca, 0xff96a0c9, 0xff96a0c9, 0xff979fc9,
    0xff969ec9, 0xff949dc8, 0xff939dc8, 0xff939cc7, 0xff939cc7, 0xff949cc7, 0xff939cc7, 0xff909bc7,
    0xff8e9bc6, 0xff8f9dc4, 0xff91a0c1, 0xff939dc0, 0xff9398c1, 0xff8e90c5, 0xff8287ce, 0xff7986d3,
    0xff738dd5, 0xff7399d3, 0xff7da6cf, 0xff8cafca, 0xff9bb4c0, 0xffa4b2b7, 0xffa8aaae, 0xffa99fa6,
    0xffa190a1, 0xff96839d, 0xff86789d, 0xff76729e, 0xff6870a1, 0xff5d6ea3, 0xff596da4, 0xff566da4,
    0xff536da3, 0xff526da3, 0xff526da4, 0xff536da5, 0xff536da5, 0xff526da5, 0xff526da5, 0xff516da6,
    0xff506da6, 0xff4e6ca5, 0xff4d6ba3, 0xff4c6ba1, 0xff4c6ba0, 0xff4c6a9f, 0xff4b699f, 0xff4b699f,
    0xffabb2cd, 0xffabb2cd, 0xff9fa9c7, 0xff909dc2, 0xff8093be, 0xff728cbc, 0xff6c88bb, 0xff6e89bc,
    0xff7189bd, 0xff7689be, 0xff7c8abe, 0xff828abc, 0xff8b8cba, 0xff978fba, 0xffa696ba, 0xffb7a1b9,
    0xffc6afb9, 0xffd1bfbb, 0xffd3ccc0, 0xffcdd2c8, 0xffbcd0d2, 0xffacc8db, 0xffa0bce1, 0xff98b1e3,
    0xff95a9e3, 0xff95a7df, 0xff96a5db, 0xff98a5d7, 0xff99a6d4, 0xff9ba7d2, 0xff9ca8d2, 0xff9ca8d0,
    0xff9ba7ce, 0xff9aa6cd, 0xff99a5cd, 0xff99a5ce, 0xff99a5d0, 0xff99a5d1, 0xff98a4d1, 0xff98a3d0,
    0xff98a3d0, 0xff98a3d0, 0xff98a3d0, 0xff98a4d0, 0xff98a4d0, 0xff99a5d1, 0xff99a5d1, 0xff98a4d0,
    0xff98a4cf, 0xff98a5cf, 0xff98a5cf, 0xff98a4cf, 0xff97a3cf, 0xff97a3cf, 0xff98a4d0, 0xff98a5d0,
    0xff98a5d0, 0xff98a5d0, 0xff98a5d0, 0xff98a4d0, 0xff98a4d0, 0xff97a4d0, 0xff97a4d0, 0xff96a4d0,
    0xff96a4d0, 0xff97a4cf, 0xff98a4cf, 0xff98a5cf, 0xff99a6d0, 0xff9ba7d0, 0xff9fa8d0, 0xffa1a9d0,
    0xffa2aad0, 0xffa2aad0, 0xffa3abd1, 0xffa4acd2, 0xffa5acd2, 0xffa5acd2, 0xffa5acd1, 0xffa5acd0,
    0xffa5acd0, 0xffa5add0, 0xffa6aed1, 0xffa7afd3, 0xffa8b0d4, 0xffa9b1d5, 0xffaab2d6, 0xffaab3d6,
    0xffaab3d6, 0xffaab3d6, 0xffaab3d4, 0xffaab3d4, 0xffabb3d5, 0xffabb2d6, 0xffaab2d6, 0xffa9b1d5,
    0xffa9b1d5, 0xffaab0d5, 0xffaab0d5, 0xffa9b0d4, 0xffa8b0d4, 0xffa8b0d3, 0xffa8b0d3, 0xffa7afd3,
    0xffa6add2, 0xffa6add1, 0xffa5add0, 0xffa5add0, 0xffa4add0, 0xffa3acd0, 0xffa2abd0, 0xffa1aacf,
    0xffa1aacf, 0xffa2aace, 0xffa2a9cd, 0xffa1a8cb, 0xff9fa7cb, 0xff9da6cc, 0xff9ba6cc, 0xff9aa4cc,
    0xff9aa3cb, 0xff99a3ca, 0xff99a3ca, 0xff99a2ca, 0xff99a1cb, 0xff99a1cb, 0xff98a0cb, 0xff97a0ca,
    0xff959fc9, 0xff949ec9, 0xff959dc9, 0xff959dc9, 0xff949dc9, 0xff929dc8, 0xff919dc6, 0xff919cc5,
    0xff919cc5, 0xff929bc6, 0xff919bc6, 0xff8e9ac6, 0xff8c9ac4, 0xff8d9bc2, 0xff8f9dc1, 0xff8f9bc0,
    0xff8e97c0, 0xff8b92c1, 0xff858fc5, 0xff808ec8, 0xff7c8dcb, 0xff7a8fcc, 0xff7992ce, 0xff7a96ce,
    0xff809fca, 0xff87a9c3, 0xff93afb9, 0xffa3aeae, 0xffada4a4, 0xffa9949e, 0xff9b829c, 0xff88769b,
    0xff74709d, 0xff636c9f, 0xff5c6ca2, 0xff576da4, 0xff536da4, 0xff526da3, 0xff526da4, 0xff536ea6,
    0xff536ea6, 0xff536ea5, 0xff516ea5, 0xff506ea5, 0xff4f6da5, 0xff4d6ca4, 0xff4c6ba2, 0xff4b6aa1,
    0xff4b6aa0, 0xff4b6a9f, 0xff4b699f, 0xff4b699f, 0xffacb3ce, 0xffacb3ce, 0xffa0a9c8, 0xff909cc2,
    0xff8092be, 0xff738bbc, 0xff6d87ba, 0xff6f87ba, 0xff7287bb, 0xff7787bc, 0xff7f89bd, 0xff8a8bbb,
    0xff9590b9, 0xffa496b9, 0xffb3a0ba, 0xffc3aeba, 0xffcebcbb, 0xffd4ccbf, 0xffd1d6c6, 0xffc4d7cf,
    0xffaccddb, 0xff99bee3, 0xff8faee7, 0xff8da1e6, 0xff909de1, 0xff96a0db, 0xff9ba4d4, 0xff9ba7cf,
    0xff9ba9ce, 0xff99a9d0, 0xff98a7d2, 0xff97a6d2, 0xff97a4d0, 0xff97a3cf, 0xff96a2cd, 0xff96a2cd,
    0xff97a3ce, 0xff97a4cf, 0xff97a4cf, 0xff97a3cf, 0xff96a2ce, 0xff96a2ce, 0xff96a2cf, 0xff97a3d0,
    0xff97a3d0, 0xff98a4d0, 0xff98a4d0, 0xff97a3cf, 0xff97a3ce, 0xff97a4ce, 0xff97a4ce, 0xff97a3ce,
    0xff96a2cf, 0xff96a2cf, 0xff97a3d0, 0xff97a4d0, 0xff96a4cf, 0xff96a3cf, 0xff96a3cf, 0xff97a3cf,
    0xff97a3cf, 0xff96a3d0, 0xff96a3d0, 0xff96a3cf, 0xff96a3cf, 0xff97a3d0, 0xff98a4d0, 0xff98a5d0,
    0xff99a6d0, 0xff9ba7d0, 0xff9ea8d1, 0xffa0a9d1, 0xffa1a9d1, 0xffa1aad1, 0xffa2abd2, 0xffa3acd2,
    0xffa3acd2, 0xffa3acd2, 0xffa3acd1, 0xffa4abd0, 0xffa4abd0, 0xffa5abd0, 0xffa5acd1, 0xffa5add3,
    0xffa6aed4, 0xffa7afd5, 0xffa8b0d5, 0xffa8b1d6, 0xffa8b1d6, 0xffa8b1d5, 0xffa8b1d4, 0xffa8b1d3,
    0xffa9b1d5, 0xffa9b1d6, 0xffa8b0d5, 0xffa7afd4, 0xffa7afd4, 0xffa8afd4, 0xffa8afd4, 0xffa7afd3,
    0xffa6afd3, 0xffa6afd3, 0xffa6afd3, 0xffa5add2, 0xffa4abd1, 0xffa3aad0, 0xffa2aacf, 0xffa2aacf,
    0xffa2aad0, 0xffa2aad0, 0xffa0a9cf, 0xff9fa8ce, 0xff9fa8ce, 0xffa0a8cd, 0xffa0a8cc, 0xffa0a7ca,
    0xff9ea6ca, 0xff9aa5cb, 0xff98a4cc, 0xff97a2cb, 0xff97a1ca, 0xff96a1c9, 0xff96a1c9, 0xff96a1c9,
    0xff96a0ca, 0xff95a0ca, 0xff949fc9, 0xff939ec8, 0xff929dc8, 0xff929dc8, 0xff929cc8, 0xff929cc8,
    0xff929cc7, 0xff919cc6, 0xff8f9cc4, 0xff8f9cc3, 0xff8e9bc3, 0xff8e9ac4, 0xff8e99c5, 0xff8c98c4,
    0xff8a98c2, 0xff8a98c2, 0xff8b98c2, 0xff8b97c1, 0xff8994c0, 0xff8893bf, 0xff8795bd, 0xff8595be,
    0xff848fc1, 0xff8088c5, 0xff7783cb, 0xff6d82cf, 0xff6a8ccf, 0xff6f9ecb, 0xff7fadc3, 0xff97b4b8,
    0xffacb0ac, 0xffb1a1a4, 0xffa88e9e, 0xff977e9b, 0xff83759a, 0xff706f9c, 0xff666ea0, 0xff5d6fa3,
    0xff576ea3, 0xff546da3, 0xff536da4, 0xff536ea6, 0xff536ea6, 0xff536ea5, 0xff516ea5, 0xff4f6da5,
    0xff4e6ca4, 0xff4d6ba2, 0xff4c6ba1, 0xff4b6ba0, 0xff4b6a9f, 0xff4b6a9f, 0xff4b699f, 0xff4b699f,
    0xffa7b0cb, 0xffa7b0cb, 0xff98a3c5, 0xff8695bf, 0xff778cbc, 0xff6d87bc, 0xff6a85bb, 0xff6c84ba,
    0xff7083b8, 0xff7580b7, 0xff7f82b7, 0xff918ab6, 0xffa395b7, 0xffb4a3b8, 0xffc1b1ba, 0xffc8bebe,
    0xffc7c8c3, 0xffc1cecb, 0xffb9cdd2, 0xffabc7da, 0xff9abde0, 0xff8eb1e2, 0xff89a5e2, 0xff8b9ddf,
    0xff909ada, 0xff969ed5, 0xff99a2cf, 0xff98a5cb, 0xff97a7ca, 0xff95a5cc, 0xff94a3cf, 0xff93a2d0,
    0xff93a1cf, 0xff93a0ce, 0xff93a0cc, 0xff93a0cc, 0xff94a1cd, 0xff94a1ce, 0xff94a2ce, 0xff94a2ce,
    0xff94a1cd, 0xff94a0cd, 0xff94a0cd, 0xff94a1ce, 0xff94a2cf, 0xff95a3d0, 0xff96a3d0, 0xff95a3cf,
    0xff95a3ce, 0xff95a3ce, 0xff96a3ce, 0xff96a3cf, 0xff95a2d0, 0xff95a2d0, 0xff95a2d0, 0xff95a2d0,
    0xff94a2cf, 0xff94a2cf, 0xff95a2cf, 0xff96a2cf, 0xff96a2cf, 0xff95a2d0, 0xff95a2d0, 0xff95a3ce,
    0xff96a3ce, 0xff97a3cf, 0xff98a4d0, 0xff98a5d1, 0xff99a6d1, 0xff9aa6d1, 0xff9ca7d1, 0xff9ea8d1,
    0xff9fa9d2, 0xffa0aad2, 0xffa1acd1, 0xffa1acd1, 0xffa1acd2, 0xffa1abd2, 0xffa2abd1, 0xffa3aad0,
    0xffa3aad0, 0xffa4aad0, 0xffa4abd1, 0xffa4acd3, 0xffa4add4, 0xffa5aed4, 0xffa6aed3, 0xffa7aed4,
    0xffa7afd5, 0xffa7afd5, 0xffa7afd3, 0xffa7afd2, 0xffa8afd4, 0xffa8afd5, 0xffa7aed4, 0xffa6add2,
    0xffa6add2, 0xffa7aed4, 0xffa7aed4, 0xffa6aed3, 0xffa5aed2, 0xffa4aed3, 0xffa4add3, 0xffa3abd2,
    0xffa2a9d1, 0xffa1a9d0, 0xff9fa9cf, 0xff9fa9cf, 0xffa0a9cf, 0xffa0a8cf, 0xff9ea7ce, 0xff9da6cd,
    0xff9da5cd, 0xff9da5cc, 0xff9da5cb, 0xff9da4ca, 0xff9ba4ca, 0xff98a3cb, 0xff96a2cb, 0xff95a1ca,
    0xff95a0c9, 0xff949fc8, 0xff939fc8, 0xff939fc8, 0xff939ec8, 0xff929ec8, 0xff919dc7, 0xff909cc6,
    0xff909cc6, 0xff909cc7, 0xff909cc7, 0xff909bc7, 0xff909bc6, 0xff8f9ac5, 0xff8d9ac3, 0xff8d99c2,
    0xff8c99c2, 0xff8c98c3, 0xff8b97c4, 0xff8a96c3, 0xff8896c1, 0xff8896c1, 0xff8895c2, 0xff8894c2,
    0xff8793c1, 0xff8693be, 0xff8595ba, 0xff8495b9, 0xff838ebb, 0xff7f86c0, 0xff7680c5, 0xff6c7dc9,
    0xff6784cb, 0xff6991cb, 0xff739fc9, 0xff84a8c4, 0xff96abbb, 0xffa2a9b0, 0xffa6a0a6, 0xffa3939e,
    0xff99879a, 0xff897a99, 0xff7a739c, 0xff6b6e9f, 0xff5e6ca1, 0xff566ca2, 0xff526ca4, 0xff526da5,
    0xff516da5, 0xff516da5, 0xff506da5, 0xff4f6ca4, 0xff4e6ba3, 0xff4d6aa1, 0xff4c6aa0, 0xff4b6a9f,
    0xff4b699f, 0xff4b699f, 0xff4a689e, 0xff4a689e, 0xffa0a9c8, 0xffa0a9c8, 0xff8e9bc2, 0xff7b8cbc,
    0xff6e85ba, 0xff6783bb, 0xff6682bb, 0xff6a82ba, 0xff7080b7, 0xff757ab4, 0xff817db2, 0xff978ab2,
    0xffab9cb5, 0xffbcaeb7, 0xffc4bebc, 0xffc1c8c3, 0xffb6cacc, 0xffa7c5d6, 0xff9bbbdc, 0xff91b0e0,
    0xff8ea9df, 0xff8ea5dc, 0xff8da1d8, 0xff8f9fd5, 0xff919ed2, 0xff939ed0, 0xff94a0cd, 0xff93a1cb,
    0xff92a2ca, 0xff90a1cb, 0xff8f9fcc, 0xff8f9ecd, 0xff8f9ece, 0xff8f9ecd, 0xff8f9ecc, 0xff8f9ecb,
    0xff909ecb, 0xff909fcc, 0xff91a1cd, 0xff91a1cd, 0xff92a0cd, 0xff929fcd, 0xff929fcd, 0xff91a0ce,
    0xff91a1ce, 0xff93a2cf, 0xff94a2cf, 0xff94a2ce, 0xff94a2ce, 0xff94a2ce, 0xff95a2cf, 0xff95a2d0,
    0xff95a2d1, 0xff95a2d1, 0xff94a1d1, 0xff94a0d0, 0xff93a0cf, 0xff93a1cf, 0xff94a1cf, 0xff95a1cf,
    0xff94a1cf, 0xff93a2d0, 0xff94a2d0, 0xff96a3ce, 0xff97a3ce, 0xff97a3cf, 0xff97a4d0, 0xff98a5d1,
    0xff9aa7d2, 0xff9ba7d2, 0xff9ba7d2, 0xff9da8d2, 0xff9ea9d3, 0xff9faad3, 0xff9fabd1, 0xff9fabd0,
    0xff9eaad1, 0xff9ea9d2, 0xff9fa9d1, 0xffa0a9d0, 0xffa1a9d0, 0xffa2a9d1, 0xffa2aad2, 0xffa2abd3,
    0xffa2acd3, 0xffa3add2, 0xffa5add1, 0xffa6add1, 0xffa6aed3, 0xffa6aed3, 0xffa7aed2, 0xffa7aed2,
    0xffa7aed3, 0xffa7aed3, 0xffa6add1, 0xffa5acd0, 0xffa5acd1, 0xffa6aed3, 0xffa6aed4, 0xffa5aed2,
    0xffa4add1, 0xffa3acd2, 0xffa2abd3, 0xffa2a9d2, 0xffa1a8d1, 0xffa0a8d1, 0xff9ea8d0, 0xff9da8d0,
    0xff9ea7cf, 0xff9ea6ce, 0xff9ca5cd, 0xff9ba5cd, 0xff9aa4cc, 0xff9aa3cb, 0xff99a3ca, 0xff99a2ca,
    0xff97a2ca, 0xff96a1cb, 0xff95a1cb, 0xff94a0ca, 0xff949fc9, 0xff939ec8, 0xff929ec8, 0xff929ec8,
    0xff919dc7, 0xff909cc7, 0xff8f9bc6, 0xff8e9bc5, 0xff8f9cc5, 0xff909cc5, 0xff8f9cc5, 0xff8e9bc5,
    0xff8e9ac5, 0xff8d9ac4, 0xff8d98c4, 0xff8c98c3, 0xff8b97c2, 0xff8a96c2, 0xff8996c2, 0xff8896c1,
    0xff8895c0, 0xff8894c1, 0xff8794c2, 0xff8792c2, 0xff8791c1, 0xff8690bf, 0xff8391bc, 0xff8091ba,
    0xff7e8dbb, 0xff7c88bd, 0xff7785bf, 0xff7385c0, 0xff7086c3, 0xff6f88c6, 0xff708dc9, 0xff7294ca,
    0xff7a9ec6, 0xff89a8bc, 0xff99acae, 0xffa4a6a3, 0xffa8989c, 0xff9f8798, 0xff8e7a9a, 0xff79709c,
    0xff686b9f, 0xff5a6ba1, 0xff546ba2, 0xff526ca3, 0xff506ca4, 0xff4f6ca5, 0xff4f6ca5, 0xff4e6ca3,
    0xff4e6ba2, 0xff4d6aa1, 0xff4d69a0, 0xff4d69a0, 0xff4c69a0, 0xff4b689f, 0xff49679e, 0xff48679e,
    0xff99a4c5, 0xff99a4c5, 0xff8796bf, 0xff7588ba, 0xff6a82b9, 0xff6581ba, 0xff6680ba, 0xff6c81b9,
    0xff747fb6, 0xff7c7db2, 0xff8981b1, 0xff9f91b3, 0xffafa3b7, 0xffbab6bb, 0xffbac3c0, 0xffb0c8ca,
    0xffa0c5d3, 0xff8eb8dc, 0xff81a9e1, 0xff7d9ce1, 0xff8398dc, 0xff8c9ad5, 0xff8f9dcf, 0xff90a0ca,
    0xff90a0ca, 0xff909fcb, 0xff8e9ecc, 0xff8d9ecb, 0xff8c9dca, 0xff8b9bc9, 0xff8a9ac9, 0xff8a9aca,
    0xff8a9bcc, 0xff8a9bcc, 0xff8b9cca, 0xff8b9cca, 0xff8c9cca, 0xff8c9ccb, 0xff8c9ecc, 0xff8d9fcc,
    0xff8e9fcd, 0xff8f9ecd, 0xff8f9ecd, 0xff8e9fcd, 0xff8fa0cd, 0xff91a1ce, 0xff92a1cf, 0xff92a2cf,
    0xff92a2cf, 0xff92a2cf, 0xff93a1cf, 0xff94a1d0, 0xff94a2d1, 0xff94a2d1, 0xff93a0d0, 0xff929fcf,
    0xff919fcf, 0xff91a0cf, 0xff92a0cf, 0xff93a0cf, 0xff93a0cf, 0xff92a1d0, 0xff93a1d0, 0xff95a2ce,
    0xff97a3ce, 0xff97a3cf, 0xff97a4d0, 0xff98a5d2, 0xff9aa7d3, 0xff9aa7d3, 0xff9ba7d2, 0xff9ca8d2,
    0xff9da9d4, 0xff9eaad4, 0xff9eaad2, 0xff9daad0, 0xff9ca9d1, 0xff9ca8d2, 0xff9da8d1, 0xff9ea8d0,
    0xff9fa8d0, 0xffa0a8d1, 0xffa0a9d2, 0xffa0aad2, 0xffa0abd2, 0xffa1abd1, 0xffa3abd0, 0xffa4abd0,
    0xffa4acd1, 0xffa4acd1, 0xffa5acd2, 0xffa5acd2, 0xffa5acd2, 0xffa5acd2, 0xffa4abd0, 0xffa4abcf,
    0xffa4acd1, 0xffa5add3, 0xffa5add4, 0xffa4acd1, 0xffa3abd0, 0xffa0aad1, 0xff9fa9d2, 0xff9fa8d2,
    0xff9fa7d1, 0xff9ea7d1, 0xff9ca7d1, 0xff9ba6d0, 0xff9ba5ce, 0xff9ba4cd, 0xff9aa3cd, 0xff99a3cd,
    0xff98a2cc, 0xff96a0ca, 0xff959fca, 0xff949fca, 0xff949fca, 0xff939fc9, 0xff939fc9, 0xff939fc8,
    0xff929ec8, 0xff919ec8, 0xff909dc7, 0xff909cc7, 0xff8f9bc6, 0xff8e9bc6, 0xff8d9ac5, 0xff8d9ac4,
    0xff8e9bc4, 0xff8f9bc4, 0xff8e9bc3, 0xff8d9ac3, 0xff8d99c3, 0xff8c98c4, 0xff8c96c4, 0xff8b95c3,
    0xff8a95c2, 0xff8995c1, 0xff8895c1, 0xff8895c0, 0xff8794c0, 0xff8693c0, 0xff8592c1, 0xff8590c1,
    0xff8590c1, 0xff848fc0, 0xff7f8ebd, 0xff7c8dbb, 0xff798bbb, 0xff7889bb, 0xff788ab9, 0xff798cb8,
    0xff7889bb, 0xff7682c1, 0xff6f7fc8, 0xff6584cd, 0xff6390cc, 0xff71a2c4, 0xff88afb8, 0xff9dafac,
    0xffaaa4a3, 0xffaa939c, 0xff9b849a, 0xff88779a, 0xff76709c, 0xff656e9f, 0xff5c6ca0, 0xff566ba0,
    0xff526ba2, 0xff506ba4, 0xff4e6ba4, 0xff4e6ba2, 0xff4e6aa1, 0xff4d69a0, 0xff4d689f, 0xff4d689f,
    0xff4c689f, 0xff4a679e, 0xff48669d, 0xff46669c, 0xff95a3c4, 0xff95a3c4, 0xff8999c0, 0xff7b8dbc,
    0xff6f85ba, 0xff6980b8, 0xff697db7, 0xff707cb5, 0xff8082b5, 0xff928cb5, 0xffa298b6, 0xffaba5b8,
    0xffaaaebb, 0xffa6b6c0, 0xff9cb9c8, 0xff93b7d0, 0xff8ab0d6, 0xff80a5db, 0xff789adc, 0xff7793da,
    0xff7e91d4, 0xff8694ce, 0xff8a98c8, 0xff8b9dc5, 0xff8b9dc5, 0xff899bc8, 0xff8799c9, 0xff8798c9,
    0xff8697c8, 0xff8597c6, 0xff8597c6, 0xff8597c8, 0xff8598ca, 0xff8699ca, 0xff869ac9, 0xff889ac9,
    0xff889aca, 0xff899aca, 0xff8a9bcb, 0xff8a9ccb, 0xff8b9dcb, 0xff8c9dcc, 0xff8c9dcc, 0xff8c9ecd,
    0xff8d9ecd, 0xff8f9fce, 0xff909fce, 0xff90a0cf, 0xff90a1d0, 0xff90a1d0, 0xff91a0cf, 0xff92a0cf,
    0xff93a1d0, 0xff93a1d0, 0xff92a0cf, 0xff919fce, 0xff8f9fce, 0xff8f9fce, 0xff909fce, 0xff919fcf,
    0xff919fcf, 0xff91a0cf, 0xff92a0cf, 0xff94a1cf, 0xff96a2cf, 0xff97a2d0, 0xff97a3d1, 0xff98a5d2,
    0xff9aa7d3, 0xff9ba8d3, 0xff9ba8d2, 0xff9ca8d2, 0xff9da9d4, 0xff9da9d4, 0xff9da9d2, 0xff9ca9d1,
    0xff9ba8d1, 0xff9ba7d2, 0xff9ba7d2, 0xff9ca7d1, 0xff9ca7d1, 0xff9da8d2, 0xff9da8d2, 0xff9da9d2,
    0xff9ea9d1, 0xffa0aad0, 0xffa1aad0, 0xffa1aad0, 0xffa0aad0, 0xffa0aad0, 0xffa1aad1, 0xffa2aad2,
    0xffa2aad2, 0xffa2aad1, 0xffa2aad0, 0xffa2aacf, 0xffa2abd1, 0xffa3abd3, 0xffa3abd4, 0xffa2a9d2,
    0xffa1a8d1, 0xff9ea7d1, 0xff9ca7d1, 0xff9ca7d1, 0xff9da6d1, 0xff9ca6d1, 0xff9ba5d1, 0xff99a4cf,
    0xff99a3cd, 0xff98a2cc, 0xff98a2cc, 0xff97a2cc, 0xff95a0cb, 0xff939eca, 0xff929dca, 0xff919dca,
    0xff919dc9, 0xff909cc8, 0xff909cc7, 0xff8f9cc7, 0xff8f9cc7, 0xff8e9cc7, 0xff8e9bc6, 0xff8e9bc6,
    0xff8e9ac6, 0xff8e9ac6, 0xff8d99c5, 0xff8d99c4, 0xff8e9ac3, 0xff8e9ac3, 0xff8d9ac2, 0xff8c99c2,
    0xff8c98c3, 0xff8b97c4, 0xff8b95c4, 0xff8a94c2, 0xff8994c1, 0xff8895c0, 0xff8795c0, 0xff8795bf,
    0xff8794bf, 0xff8693bf, 0xff8591c0, 0xff838fc0, 0xff838fbf, 0xff818ebe, 0xff7d8cbc, 0xff7a8bbb,
    0xff788aba, 0xff7789b9, 0xff788ab8, 0xff7a8cb6, 0xff7a88b8, 0xff7781bc, 0xff707cc1, 0xff657ec7,
    0xff6087c9, 0xff6794c8, 0xff75a1c3, 0xff87a7ba, 0xff96a5b1, 0xffa09fa6, 0xffa1969e, 0xff9a8a99,
    0xff8d7d99, 0xff7a729c, 0xff6b6c9c, 0xff5e6a9d, 0xff55699f, 0xff5069a1, 0xff4d69a2, 0xff4d69a2,
    0xff4d69a1, 0xff4c69a0, 0xff4c689f, 0xff4c689e, 0xff4b679d, 0xff4a669c, 0xff48659a, 0xff47659a,
    0xff96a4c5, 0xff96a4c5, 0xff909ec2, 0xff8796bf, 0xff7b8cbb, 0xff7284b7, 0xff717db3, 0xff797cb2,
    0xff8e89b5, 0xffa99fbb, 0xffb9b1bf, 0xffb4b8c0, 0xffa2b6c1, 0xff90b1c8, 0xff7fa8cf, 0xff79a0d4,
    0xff7b9bd5, 0xff7c96d5, 0xff7b94d2, 0xff7c93ce, 0xff7f93cb, 0xff8194c9, 0xff8396c7, 0xff8497c6,
    0xff8497c7, 0xff8296c8, 0xff8296c8, 0xff8295c6, 0xff8295c5, 0xff8295c5, 0xff8295c5, 0xff8295c6,
    0xff8295c7, 0xff8396c7, 0xff8397c8, 0xff8598c8, 0xff8598c9, 0xff8698c9, 0xff8698ca, 0xff8799cb,
    0xff889acc, 0xff8a9ccc, 0xff8a9dcc, 0xff8a9dcd, 0xff8b9dcd, 0xff8d9ecd, 0xff8f9ecd, 0xff8f9fcf,
    0xff8f9fd0, 0xff8f9ecf, 0xff8f9ece, 0xff909fce, 0xff91a0ce, 0xff91a0ce, 0xff91a0cd, 0xff91a0cd,
    0xff8f9fcd, 0xff8e9fcd, 0xff8f9fcd, 0xff909fce, 0xff909fce, 0xff90a0cf, 0xff92a0cf, 0xff94a1cf,
    0xff95a2cf, 0xff96a2d0, 0xff97a3d1, 0xff98a5d2, 0xff9aa7d3, 0xff9ba8d3, 0xff9ca9d3, 0xff9ca9d3,
    0xff9ca8d4, 0xff9ca8d4, 0xff9ba8d3, 0xff9ba8d2, 0xff9ba8d2, 0xff9ba7d2, 0xff9ba7d2, 0xff9aa7d2,
    0xff9aa7d2, 0xff9ba8d1, 0xff9ba8d1, 0xff9ba7d1, 0xff9ca7d1, 0xff9ea7d1, 0xff9fa8d1, 0xff9fa8d0,
    0xff9da8d0, 0xff9da8d1, 0xff9ea8d2, 0xff9fa8d3, 0xff9fa9d2, 0xff9fa9d1, 0xff9fa9d0, 0xffa0a9d0,
    0xffa1a9d1, 0xffa1a9d3, 0xffa1a8d4, 0xffa0a7d3, 0xff9fa6d2, 0xff9ca6d1, 0xff9aa6d0, 0xff9aa6d0,
    0xff9ba5d0, 0xff9ba4d0, 0xff9aa3cf, 0xff98a3ce, 0xff97a2cd, 0xff96a2cc, 0xff95a2cc, 0xff94a1cc,
    0xff939fcb, 0xff929dca, 0xff919cca, 0xff8f9bc9, 0xff8e9bc8, 0xff8e9ac7, 0xff8e9ac6, 0xff8d9bc5,
    0xff8d9bc5, 0xff8d9ac4, 0xff8d99c4, 0xff8d99c5, 0xff8e99c6, 0xff8e99c6, 0xff8d98c6, 0xff8d98c5,
    0xff8d99c4, 0xff8d99c3, 0xff8c98c2, 0xff8b97c1, 0xff8a97c2, 0xff8997c3, 0xff8996c3, 0xff8994c2,
    0xff8993c1, 0xff8994c0, 0xff8895c0, 0xff8895bf, 0xff8794be, 0xff8692be, 0xff8590bf, 0xff838fbf,
    0xff818fbd, 0xff7f8ebc, 0xff7c8bbb, 0xff7a89bb, 0xff7888ba, 0xff7788b9, 0xff7788b8, 0xff7889b8,
    0xff7787b8, 0xff7583b9, 0xff7180ba, 0xff6c80bd, 0xff6983c2, 0xff6686c7, 0xff698bc9, 0xff7095c5,
    0xff7a9fbc, 0xff8ba4b0, 0xff9ba3a5, 0xffa39a9d, 0xff9e8b99, 0xff8d799a, 0xff7a6f9a, 0xff676a9c,
    0xff5a679d, 0xff53679e, 0xff4e67a0, 0xff4c67a1, 0xff4c68a1, 0xff4b68a1, 0xff4b689f, 0xff4b679d,
    0xff4a669b, 0xff49659a, 0xff486498, 0xff476498, 0xff98a5c5, 0xff98a5c5, 0xff98a3c4, 0xff949ec2,
    0xff8a94bd, 0xff818bb8, 0xff7f83b3, 0xff8683b2, 0xff9d94b7, 0xffbcb1c1, 0xffcac6c9, 0xffb9c7c9,
    0xff9bbac8, 0xff7eaacd, 0xff6798d2, 0xff648cd4, 0xff7089d2, 0xff7a8ace, 0xff7e8fc9, 0xff8094c5,
    0xff7e95c4, 0xff7c94c5, 0xff7d93c5, 0xff7e92c6, 0xff7e92c6, 0xff7d92c6, 0xff7d92c6, 0xff7e92c5,
    0xff7e92c4, 0xff7e93c4, 0xff7e93c5, 0xff7e93c5, 0xff7f93c6, 0xff8094c7, 0xff8095c8, 0xff8296c8,
    0xff8397c9, 0xff8497c9, 0xff8597ca, 0xff8597ca, 0xff8699ca, 0xff889bcb, 0xff889bcc, 0xff899bcd,
    0xff8a9bcd, 0xff8c9bcd, 0xff8d9ccd, 0xff8e9dcf, 0xff8e9ed0, 0xff8d9ecf, 0xff8d9dce, 0xff8d9dcd,
    0xff8e9ecd, 0xff909fcd, 0xff90a0cd, 0xff90a0cd, 0xff8e9fcc, 0xff8d9fcc, 0xff8e9fcd, 0xff8f9fce,
    0xff8f9fce, 0xff909fce, 0xff919fce, 0xff92a0cf, 0xff93a1d0, 0xff95a1d1, 0xff97a2d2, 0xff98a4d2,
    0xff99a6d2, 0xff9aa8d2, 0xff9ca9d3, 0xff9ca9d3, 0xff9ca8d3, 0xff9ba7d3, 0xff9aa7d3, 0xff9aa7d3,
    0xff9aa7d3, 0xff9aa6d2, 0xff99a6d2, 0xff98a6d2, 0xff98a6d2, 0xff98a7d1, 0xff99a7d0, 0xff99a6d0,
    0xff9aa5d0, 0xff9ba6d1, 0xff9ca7d1, 0xff9ba7d1, 0xff99a6d0, 0xff99a6d0, 0xff9aa6d1, 0xff9ba6d2,
    0xff9ca7d2, 0xff9ca7d1, 0xff9ca8d1, 0xff9da8d1, 0xff9ea8d2, 0xff9ea8d3, 0xff9ea6d3, 0xff9da4d3,
    0xff9ca3d2, 0xff99a3d0, 0xff98a4cf, 0xff98a4cf, 0xff99a3cf, 0xff99a2cf, 0xff99a1ce, 0xff97a1cd,
    0xff95a0cc, 0xff94a0cb, 0xff93a0cb, 0xff92a0cb, 0xff919eca, 0xff909cc9, 0xff8f9bc9, 0xff8d9ac9,
    0xff8b98c7, 0xff8b98c5, 0xff8b98c4, 0xff8b99c4, 0xff8b99c4, 0xff8b98c3, 0xff8c97c3, 0xff8d97c4,
    0xff8e98c6, 0xff8e98c6, 0xff8e97c6, 0xff8d97c5, 0xff8d98c4, 0xff8c98c3, 0xff8b97c1, 0xff8a96c0,
    0xff8996c0, 0xff8896c2, 0xff8895c2, 0xff8894c1, 0xff8893c0, 0xff8893bf, 0xff8794bf, 0xff8794be,
    0xff8693bd, 0xff8591bd, 0xff848fbd, 0xff828ebc, 0xff7e8ebb, 0xff7c8dba, 0xff7a8abb, 0xff7988bb,
    0xff7887ba, 0xff7686b9, 0xff7585b9, 0xff7585ba, 0xff7385b9, 0xff7285b6, 0xff7185b4, 0xff7384b5,
    0xff7281ba, 0xff697cc3, 0xff617bca, 0xff5e85cc, 0xff6495c6, 0xff77a3bb, 0xff8faaae, 0xffa2a6a3,
    0xffa6979e, 0xff9c839c, 0xff8b779a, 0xff756f9a, 0xff64699a, 0xff5a679a, 0xff52669c, 0xff4e669e,
    0xff4d679f, 0xff4b689f, 0xff4b689e, 0xff4a679c, 0xff496599, 0xff486497, 0xff476396, 0xff476396,
    0xff9ba6c5, 0xff9ba6c5, 0xff9da5c5, 0xff9ea2c3, 0xff9c9dbf, 0xff9a99bc, 0xff9a96b7, 0xff9d98b6,
    0xffaba8bc, 0xffc0c0c8, 0xffc8d0d2, 0xffb9ccd5, 0xff9ebbd4, 0xff7ea4d3, 0xff648ed1, 0xff6083ce,
    0xff6d83cb, 0xff7887c7, 0xff7d8dc4, 0xff7e92c2, 0xff7c92c2, 0xff7991c3, 0xff7a91c4, 0xff7b90c4,
    0xff7b90c4, 0xff7a90c4, 0xff7a90c4, 0xff7b90c4, 0xff7b90c4, 0xff7b91c5, 0xff7b91c6, 0xff7c91c6,
    0xff7d92c6, 0xff7e93c7, 0xff7f94c8, 0xff8095c8, 0xff8096c9, 0xff8196c9, 0xff8296c9, 0xff8396c9,
    0xff8498ca, 0xff869acb, 0xff879acb, 0xff8799cc, 0xff8999cc, 0xff8a9acc, 0xff8b9bcd, 0xff8d9dcf,
    0xff8d9dd0, 0xff8c9dcf, 0xff8b9cce, 0xff8b9ccd, 0xff8b9dcd, 0xff8d9ecd, 0xff8e9fce, 0xff8f9fce,
    0xff8e9ecd, 0xff8d9ecd, 0xff8e9ecd, 0xff8f9fce, 0xff8f9fce, 0xff8f9ece, 0xff8f9ece, 0xff90a0cf,
    0xff92a1d0, 0xff95a1d1, 0xff97a2d2, 0xff98a4d2, 0xff99a6d2, 0xff9aa8d2, 0xff9ca9d3, 0xff9ca9d3,
    0xff9ba7d3, 0xff9aa6d3, 0xff99a5d2, 0xff98a5d2, 0xff98a5d2, 0xff98a5d2, 0xff97a5d2, 0xff96a4d2,
    0xff96a4d1, 0xff96a5d0, 0xff97a5cf, 0xff98a4cf, 0xff98a4cf, 0xff99a4d0, 0xff99a5d0, 0xff98a5d0,
    0xff97a4cf, 0xff97a4cf, 0xff97a4d0, 0xff98a4d0, 0xff99a5d1, 0xff9aa6d1, 0xff9aa6d1, 0xff9aa6d0,
    0xff9aa6d0, 0xff9ba6d1, 0xff9ba4d1, 0xff9aa2d1, 0xff99a1d0, 0xff97a2cf, 0xff96a3ce, 0xff96a2ce,
    0xff96a1ce, 0xff96a0ce, 0xff959fcd, 0xff949fcd, 0xff939ecc, 0xff929ecb, 0xff919ecb, 0xff909eca,
    0xff8f9cc9, 0xff8e9ac7, 0xff8d99c7, 0xff8b98c7, 0xff8996c6, 0xff8996c3, 0xff8996c2, 0xff8a97c2,
    0xff8a97c3, 0xff8a97c2, 0xff8a96c2, 0xff8b96c3, 0xff8c97c5, 0xff8c97c5, 0xff8c96c5, 0xff8c96c4,
    0xff8c97c4, 0xff8b97c3, 0xff8a96c1, 0xff8995bf, 0xff8895bf, 0xff8694c0, 0xff8694c0, 0xff8793c0,
    0xff8793bf, 0xff8692bf, 0xff8592be, 0xff8592bd, 0xff8491bc, 0xff8390bc, 0xff828ebc, 0xff808dbb,
    0xff7c8db9, 0xff7a8cb8, 0xff7889b9, 0xff7787ba, 0xff7686b9, 0xff7485b8, 0xff7384b8, 0xff7283b8,
    0xff7083b7, 0xff7085b4, 0xff7185b2, 0xff7384b2, 0xff7380b5, 0xff6b7abb, 0xff6277c2, 0xff5d7dc8,
    0xff5e89ca, 0xff6a97c5, 0xff7ba1bc, 0xff8ea5b1, 0xff9ca1a8, 0xffa196a1, 0xff9a889b, 0xff8b7a98,
    0xff796f97, 0xff686997, 0xff596599, 0xff51649b, 0xff4d659c, 0xff4b669d, 0xff4b679c, 0xff4a659a,
    0xff496397, 0xff486295, 0xff466294, 0xff466294, 0xff9ca6c4, 0xff9ca6c4, 0xff9ea4c3, 0xffa2a3c2,
    0xffa9a3c1, 0xffaea5c0, 0xffb0a8be, 0xffafadbd, 0xffb3b9c3, 0xffbbc6cd, 0xffbdccd7, 0xffb6c7dd,
    0xffa5b7dc, 0xff88a1d5, 0xff6f8ccc, 0xff6885c6, 0xff7188c5, 0xff778bc3, 0xff788dc3, 0xff798fc3,
    0xff798fc2, 0xff788fc2, 0xff798fc2, 0xff7a8fc2, 0xff7a8fc2, 0xff7a8fc3, 0xff7a8fc4, 0xff798fc5,
    0xff798fc6, 0xff798fc8, 0xff7990c8, 0xff7a91c8, 0xff7c92c7, 0xff7d93c8, 0xff7e95c9, 0xff7f95c9,
    0xff8095c8, 0xff8095c8, 0xff8196c8, 0xff8297c9, 0xff8498c9, 0xff8699ca, 0xff8799ca, 0xff8798cb,
    0xff8898cc, 0xff899acd, 0xff8a9bce, 0xff8c9dd0, 0xff8c9dd0, 0xff8b9ccf, 0xff8a9bce, 0xff8a9bcd,
    0xff8a9ccd, 0xff8b9ccd, 0xff8c9dce, 0xff8d9dcf, 0xff8d9ece, 0xff8d9ece, 0xff8d9fce, 0xff8e9fcf,
    0xff8e9fcf, 0xff8e9ece, 0xff8e9ece, 0xff8fa0ce, 0xff91a1cf, 0xff95a1d1, 0xff97a2d2, 0xff98a4d2,
    0xff99a6d1, 0xff9aa7d2, 0xff9ba8d4, 0xff9ba8d4, 0xff9aa7d3, 0xff99a6d2, 0xff98a5d1, 0xff97a4d1,
    0xff97a4d1, 0xff97a4d1, 0xff96a3d1, 0xff95a2d1, 0xff95a2d1, 0xff95a3d0, 0xff96a3cf, 0xff97a3ce,
    0xff97a3ce, 0xff97a4ce, 0xff97a4cf, 0xff97a4cf, 0xff96a3ce, 0xff96a3ce, 0xff96a3ce, 0xff96a3ce,
    0xff98a4cf, 0xff99a5d0, 0xff98a5d0, 0xff97a5cf, 0xff98a5cf, 0xff99a4d0, 0xff99a3d0, 0xff98a2ce,
    0xff97a1cd, 0xff96a1cd, 0xff95a1ce, 0xff94a0ce, 0xff949fce, 0xff949fce, 0xff939ecd, 0xff929ecc,
    0xff919dcb, 0xff909cca, 0xff8f9bc9, 0xff8e9bc9, 0xff8e9ac8, 0xff8d99c6, 0xff8c98c6, 0xff8a97c5,
    0xff8896c4, 0xff8795c3, 0xff8795c2, 0xff8895c2, 0xff8995c2, 0xff8895c2, 0xff8895c2, 0xff8996c2,
    0xff8a97c3, 0xff8b97c3, 0xff8b96c2, 0xff8b96c2, 0xff8b97c3, 0xff8a97c3, 0xff8996c1, 0xff8895bf,
    0xff8794be, 0xff8593be, 0xff8593be, 0xff8693bf, 0xff8693bf, 0xff8491bd, 0xff8390bc, 0xff8390bb,
    0xff828fbb, 0xff818ebb, 0xff7f8cbb, 0xff7d8bba, 0xff7b8ab8, 0xff798ab7, 0xff7688b7, 0xff7587b8,
    0xff7486b8, 0xff7384b7, 0xff7283b7, 0xff7082b6, 0xff6f82b5, 0xff6f83b4, 0xff6f83b3, 0xff7083b3,
    0xff6f82b4, 0xff6d7fb4, 0xff6a7db7, 0xff667ebf, 0xff6481c7, 0xff6689ca, 0xff6a93c7, 0xff769dbf,
    0xff89a5b3, 0xff9aa4a6, 0xffa1989d, 0xff9b8697, 0xff8b7694, 0xff766c94, 0xff626595, 0xff566397,
    0xff4e6498, 0xff4b6599, 0xff4b6699, 0xff4a6598, 0xff496296, 0xff486194, 0xff466093, 0xff456092,
    0xff9ea4c2, 0xff9ea4c2, 0xffa0a3c1, 0xffa7a4c1, 0xffb3aac3, 0xffbdb1c5, 0xffbfb9c4, 0xffb9bfc3,
    0xffb4c4c8, 0xffb0c6d1, 0xffafc4da, 0xffb0bfe2, 0xffa9b3e0, 0xff93a0d4, 0xff7b8ec6, 0xff7288bf,
    0xff758cbf, 0xff758ec1, 0xff748dc3, 0xff748dc5, 0xff758dc4, 0xff778dc3, 0xff788ec2, 0xff798fc1,
    0xff798fc1, 0xff798fc2, 0xff798fc4, 0xff788fc6, 0xff788fc7, 0xff788fc9, 0xff788fc9, 0xff7990c9,
    0xff7b92c8, 0xff7d93c8, 0xff7e94c9, 0xff7f94c9, 0xff7f94c9, 0xff7f95c9, 0xff8197c9, 0xff8298c9,
    0xff8498ca, 0xff8598cb, 0xff8698cb, 0xff8798cb, 0xff8898cc, 0xff889acd, 0xff899bce, 0xff8a9dcf,
    0xff8a9dcf, 0xff8a9ccf, 0xff899bce, 0xff889bcd, 0xff889bcd, 0xff889bcd, 0xff8a9bce, 0xff8b9bcf,
    0xff8c9ccf, 0xff8d9dcf, 0xff8e9ecf, 0xff8e9ecf, 0xff8e9ecf, 0xff8e9ecf, 0xff8e9fcf, 0xff8fa0cf,
    0xff90a1cf, 0xff94a2d1, 0xff96a2d2, 0xff97a3d2, 0xff98a5d1, 0xff99a6d2, 0xff99a6d3, 0xff99a6d3,
    0xff99a6d3, 0xff98a5d2, 0xff96a3d0, 0xff95a2cf, 0xff95a2cf, 0xff95a2d0, 0xff95a1d0, 0xff94a0d0,
    0xff94a0d0, 0xff95a0cf, 0xff95a1ce, 0xff95a2cd, 0xff95a2cd, 0xff95a2cd, 0xff95a2ce, 0xff95a2ce,
    0xff95a2cd, 0xff95a2cd, 0xff94a1cc, 0xff94a1cc, 0xff96a2ce, 0xff97a3cf, 0xff96a3cf, 0xff95a3ce,
    0xff96a3ce, 0xff97a3ce, 0xff97a2cd, 0xff95a1cc, 0xff94a0cb, 0xff93a0cc, 0xff93a0cd, 0xff929fcd,
    0xff919dcd, 0xff919dcd, 0xff909dcc, 0xff909ccc, 0xff8f9bcb, 0xff8e9aca, 0xff8d99c9, 0xff8c99c8,
    0xff8c98c7, 0xff8b97c5, 0xff8a96c5, 0xff8995c4, 0xff8795c3, 0xff8694c2, 0xff8694c1, 0xff8793c1,
    0xff8893c2, 0xff8894c2, 0xff8795c2, 0xff8896c2, 0xff8996c2, 0xff8996c2, 0xff8995c1, 0xff8995c1,
    0xff8996c2, 0xff8996c2, 0xff8895c1, 0xff8794bf, 0xff8693be, 0xff8491bd, 0xff8491bd, 0xff8592be,
    0xff8592be, 0xff8390bc, 0xff818ebb, 0xff808dba, 0xff7f8cba, 0xff7e8bba, 0xff7c8bba, 0xff7a8ab9,
    0xff7889b7, 0xff7788b6, 0xff7487b6, 0xff7386b6, 0xff7285b6, 0xff7183b6, 0xff7082b5, 0xff6e81b4,
    0xff6d81b4, 0xff6d81b3, 0xff6d81b3, 0xff6c82b4, 0xff6b82b4, 0xff6d82b0, 0xff6f81ae, 0xff6e7eb6,
    0xff6b7ac1, 0xff657dca, 0xff5e84cc, 0xff6291c7, 0xff75a1bd, 0xff8eaaae, 0xff9ea2a3, 0xffa2909b,
    0xff978096, 0xff837394, 0xff6d6993, 0xff5f6693, 0xff556594, 0xff4f6495, 0xff4d6496, 0xff4b6296,
    0xff496094, 0xff475f93, 0xff455f91, 0xff435f90, 0xff9e9fbf, 0xff9e9fbf, 0xffa5a2be, 0xffafa8bf,
    0xffbab3c2, 0xffc1bec5, 0xffbec3c8, 0xffb5c3cb, 0xffacc1d0, 0xffa6bcd6, 0xffa5b8dc, 0xffabb6df,
    0xffa9afdc, 0xff98a1d1, 0xff8393c5, 0xff768cbf, 0xff718cbe, 0xff6e8bc0, 0xff6f8bc2, 0xff718bc4,
    0xff758bc4, 0xff778cc3, 0xff778dc2, 0xff768ec2, 0xff768fc2, 0xff778fc3, 0xff778fc5, 0xff778fc6,
    0xff778fc7, 0xff778fc9, 0xff778fc9, 0xff7890c9, 0xff7a92c8, 0xff7c92c8, 0xff7d92c9, 0xff7e92c9,
    0xff7f94ca, 0xff7f95ca, 0xff8198ca, 0xff8299cb, 0xff8499cc, 0xff8598cd, 0xff8698cc, 0xff8798cb,
    0xff8799cb, 0xff889acd, 0xff889bce, 0xff889cce, 0xff889cce, 0xff889bce, 0xff879acd, 0xff879acc,
    0xff879acc, 0xff879acc, 0xff889acd, 0xff899ace, 0xff8b9bcf, 0xff8c9ccf, 0xff8d9ccf, 0xff8d9cce,
    0xff8d9dce, 0xff8e9ecf, 0xff8ea0cf, 0xff8fa0cf, 0xff90a1cf, 0xff93a2d0, 0xff95a2d1, 0xff96a3d1,
    0xff97a4d0, 0xff97a4d1, 0xff97a3d2, 0xff97a3d2, 0xff97a3d2, 0xff96a3d1, 0xff94a1cf, 0xff93a0ce,
    0xff93a0ce, 0xff94a0ce, 0xff94a0ce, 0xff939fcf, 0xff939fcf, 0xff939fce, 0xff939fcd, 0xff93a0cc,
    0xff93a0cc, 0xff93a0cc, 0xff93a0cd, 0xff93a0cd, 0xff93a0cd, 0xff93a0cd, 0xff93a0cc, 0xff93a0cc,
    0xff94a0cc, 0xff94a0cd, 0xff94a0ce, 0xff94a1ce, 0xff95a2ce, 0xff95a2cd, 0xff95a2cc, 0xff93a0cb,
    0xff929fcb, 0xff919ecc, 0xff919ecc, 0xff909dcc, 0xff8f9bcb, 0xff8f9bcb, 0xff8e9bcb, 0xff8e9acb,
    0xff8d99ca, 0xff8c98c9, 0xff8b97c8, 0xff8a97c7, 0xff8996c6, 0xff8895c5, 0xff8795c4, 0xff8694c4,
    0xff8694c2, 0xff8593c1, 0xff8593c1, 0xff8592c1, 0xff8692c2, 0xff8693c2, 0xff8795c2, 0xff8795c2,
    0xff8895c1, 0xff8895c1, 0xff8894c0, 0xff8894c0, 0xff8894c1, 0xff8794c1, 0xff8693c0, 0xff8592bf,
    0xff8591be, 0xff8490bc, 0xff8490bc, 0xff8490bd, 0xff8390bd, 0xff818fbc, 0xff808dbb, 0xff7f8bba,
    0xff7d8ab9, 0xff7b8ab9, 0xff7989b9, 0xff7788b8, 0xff7587b6, 0xff7486b5, 0xff7185b4, 0xff7084b4,
    0xff7083b5, 0xff6f82b5, 0xff6e81b5, 0xff6c80b4, 0xff6b80b3, 0xff6b80b2, 0xff6b80b2, 0xff6980b3,
    0xff6980b3, 0xff6c81ae, 0xff6f81ab, 0xff6f7eb0, 0xff6e79b9, 0xff6779c2, 0xff5e7dc7, 0xff5c86c8,
    0xff6694c4, 0xff78a0bb, 0xff89a1af, 0xff969ba2, 0xff989099, 0xff908394, 0xff827590, 0xff716c8f,
    0xff61658f, 0xff556191, 0xff4e6193, 0xff4a6093, 0xff485f91, 0xff455e90, 0xff435d8e, 0xff415d8e,
    0xff9c9bbb, 0xff9c9bbb, 0xffa9a2bc, 0xffb5adbe, 0xffbcb9c0, 0xffbcc2c4, 0xffb4c2c9, 0xffa8bdce,
    0xff9fb6d4, 0xff9db0d7, 0xff9fadd8, 0xffa5afd7, 0xffa4aed3, 0xff98a4cc, 0xff8798c6, 0xff788fc2,
    0xff6e8ac1, 0xff6988c1, 0xff6c89c2, 0xff718ac3, 0xff758bc4, 0xff778cc4, 0xff768dc3, 0xff748dc3,
    0xff748dc4, 0xff758ec5, 0xff768ec6, 0xff778fc7, 0xff778fc7, 0xff778fc9, 0xff778fc9, 0xff7890c8,
    0xff7a92c7, 0xff7b92c7, 0xff7c91c7, 0xff7e91c9, 0xff7f93cb, 0xff8095cc, 0xff8298cd, 0xff8399cd,
    0xff8499ce, 0xff8599ce, 0xff8699cd, 0xff8799cc, 0xff8799cc, 0xff8899cd, 0xff889acd, 0xff889ccd,
    0xff879ccd, 0xff869bcd, 0xff869acd, 0xff869acd, 0xff879acc, 0xff879acc, 0xff8799cc, 0xff8799cc,
    0xff899bcd, 0xff8b9cce, 0xff8b9bcd, 0xff8b9bcd, 0xff8c9cce, 0xff8e9fcf, 0xff90a0d0, 0xff90a0d0,
    0xff91a0d0, 0xff93a0d0, 0xff94a1d0, 0xff95a2d0, 0xff96a3d0, 0xff96a3d0, 0xff95a1d0, 0xff95a1d0,
    0xff95a1d1, 0xff95a1d1, 0xff93a0cf, 0xff929fcd, 0xff929ecc, 0xff939ecd, 0xff939ece, 0xff929fcf,
    0xff929fcf, 0xff919ece, 0xff919ecd, 0xff929fcc, 0xff929fcc, 0xff929fcc, 0xff929ecc, 0xff929ecc,
    0xff929fcd, 0xff929fcd, 0xff929fcd, 0xff929fcd, 0xff929ecc, 0xff929ecc, 0xff939fcc, 0xff94a0cd,
    0xff94a1cd, 0xff94a1cd, 0xff94a1cd, 0xff939fcc, 0xff929ecc, 0xff8f9dcc, 0xff8e9dcc, 0xff8e9ccb,
    0xff8e9aca, 0xff8d9aca, 0xff8c9aca, 0xff8c9aca, 0xff8b99ca, 0xff8b98c9, 0xff8a97c8, 0xff8996c7,
    0xff8895c7, 0xff8694c6, 0xff8594c5, 0xff8593c5, 0xff8593c3, 0xff8592c2, 0xff8592c1, 0xff8491c1,
    0xff8491c2, 0xff8593c2, 0xff8795c2, 0xff8896c2, 0xff8895c1, 0xff8895c1, 0xff8894c0, 0xff8794c0,
    0xff8794bf, 0xff8693bf, 0xff8592bf, 0xff8491be, 0xff8491be, 0xff8491bd, 0xff8490bd, 0xff838fbc,
    0xff828ebc, 0xff808dbc, 0xff7f8dbb, 0xff7e8cba, 0xff7c8ab9, 0xff7a89b8, 0xff7789b8, 0xff7587b6,
    0xff7385b6, 0xff7284b5, 0xff6f82b4, 0xff6e82b4, 0xff6e82b3, 0xff6e82b3, 0xff6d81b3, 0xff6c80b3,
    0xff6a7fb3, 0xff6a7fb2, 0xff697fb1, 0xff687fb2, 0xff687fb2, 0xff697fae, 0xff6b7fac, 0xff6c7ead,
    0xff6c7cb2, 0xff697cb8, 0xff657cbe, 0xff6180c2, 0xff6085c5, 0xff658ec2, 0xff7298b8, 0xff809dab,
    0xff8e9b9e, 0xff969196, 0xff90818f, 0xff81728d, 0xff6e668d, 0xff5d618e, 0xff4f6090, 0xff495f90,
    0xff475f8f, 0xff445e8e, 0xff425d8d, 0xff405c8c, 0xff9c99b8, 0xff9c99b8, 0xffaaa3ba, 0xffb5b0bd,
    0xffb5bbc0, 0xffaec0c4, 0xffa4bcca, 0xff99b3d0, 0xff94aad5, 0xff97a5d6, 0xff9ba3d5, 0xffa0a8d0,
    0xff9faacb, 0xff99a6c9, 0xff8d9ec7, 0xff7d94c5, 0xff6e8ac4, 0xff6785c2, 0xff6b87c2, 0xff718ac2,
    0xff748bc3, 0xff758bc4, 0xff738bc4, 0xff718cc4, 0xff718dc5, 0xff738ec6, 0xff758ec7, 0xff768fc7,
    0xff778fc7, 0xff778fc8, 0xff778fc8, 0xff7890c8, 0xff7a91c7, 0xff7b91c7, 0xff7b90c7, 0xff7d91c9,
    0xff7f93cb, 0xff8095cd, 0xff8298cf, 0xff8399cf, 0xff8499cf, 0xff8499cf, 0xff8599ce, 0xff859acd,
    0xff879acd, 0xff889acd, 0xff889acd, 0xff869bcd, 0xff859bcd, 0xff859bcd, 0xff859acd, 0xff869acd,
    0xff879acc, 0xff879acc, 0xff8699cc, 0xff8699cc, 0xff889bcd, 0xff8a9cce, 0xff8a9bcd, 0xff8a9acd,
    0xff8b9cce, 0xff8e9fcf, 0xff90a1d0, 0xff90a0d0, 0xff91a0d0, 0xff92a1cf, 0xff93a1cf, 0xff94a2cf,
    0xff94a2cf, 0xff94a1cf, 0xff93a0cf, 0xff939fcf, 0xff939fd0, 0xff939fd0, 0xff929fce, 0xff919ecd,
    0xff919dcc, 0xff919ccc, 0xff919dcd, 0xff919fce, 0xff919fce, 0xff909ecd, 0xff8f9dcc, 0xff8f9dcc,
    0xff909dcc, 0xff919dcc, 0xff919dcc, 0xff919dcc, 0xff909ecd, 0xff909ecd, 0xff919ecd, 0xff919ecd,
    0xff909dcc, 0xff909ccb, 0xff919dcc, 0xff939ecd, 0xff939fcd, 0xff939fcd, 0xff929fcd, 0xff919dcc,
    0xff909ccc, 0xff8d9bcc, 0xff8c9bcb, 0xff8c9aca, 0xff8d99c9, 0xff8d99c9, 0xff8c98c9, 0xff8b98c9,
    0xff8a97c8, 0xff8a97c8, 0xff8997c7, 0xff8896c7, 0xff8695c7, 0xff8493c7, 0xff8493c6, 0xff8593c5,
    0xff8593c3, 0xff8592c2, 0xff8592c2, 0xff8492c3, 0xff8492c3, 0xff8693c3, 0xff8895c2, 0xff8995c2,
    0xff8895c1, 0xff8895c1, 0xff8895c0, 0xff8794c0, 0xff8693bf, 0xff8592bf, 0xff8491bf, 0xff8491bf,
    0xff8491bf, 0xff8491be, 0xff8490bc, 0xff828ebc, 0xff818dbb, 0xff808dbb, 0xff7f8dbb, 0xff7e8bba,
    0xff7b89b8, 0xff7989b7, 0xff7689b6, 0xff7487b5, 0xff7285b5, 0xff7183b4, 0xff6e81b3, 0xff6d81b3,
    0xff6d81b2, 0xff6d81b2, 0xff6c80b2, 0xff6b7fb2, 0xff697fb2, 0xff687eb1, 0xff677eb0, 0xff677db0,
    0xff677db0, 0xff677daf, 0xff677dae, 0xff687ead, 0xff6b7fac, 0xff6b7eae, 0xff6b7cb3, 0xff667aba,
    0xff5d79c2, 0xff587ec4, 0xff5e8cbf, 0xff6c9bb3, 0xff819fa6, 0xff929a9a, 0xff968c90, 0xff8b7b8d,
    0xff796d8c, 0xff66648c, 0xff55618e, 0xff4d5f8e, 0xff495f8d, 0xff455e8c, 0xff425c8b, 0xff405c8b,
    0xffa09cb7, 0xffa09cb7, 0xffa8aaba, 0xffabb5be, 0xffa5b7c2, 0xff9bb4c7, 0xff94aecd, 0xff91a9d1,
    0xff92a3d3, 0xff95a0d1, 0xff99a0cd, 0xff99a3c9, 0xff99a6c7, 0xff99a8c8, 0xff94a5c9, 0xff859ac8,
    0xff738dc5, 0xff6885c2, 0xff6a86c0, 0xff6d88c0, 0xff6d86c1, 0xff6d86c2, 0xff6d87c2, 0xff6d89c3,
    0xff6e8ac4, 0xff718bc5, 0xff748dc6, 0xff768ec7, 0xff778fc7, 0xff768ec7, 0xff758ec7, 0xff778fc7,
    0xff7a90c7, 0xff7b90c7, 0xff7c90c8, 0xff7c91ca, 0xff7c93cc, 0xff7c94cd, 0xff7e95d0, 0xff8096d0,
    0xff8096cf, 0xff8197cd, 0xff8298cc, 0xff8499cc, 0xff869acc, 0xff879acd, 0xff879acd, 0xff859ace,
    0xff839ace, 0xff839ace, 0xff849ace, 0xff859ace, 0xff869ace, 0xff869ace, 0xff8599ce, 0xff8599ce,
    0xff879bce, 0xff889cce, 0xff899bce, 0xff8a9bce, 0xff8b9ccf, 0xff8c9ed0, 0xff8ea0d0, 0xff90a0d0,
    0xff91a0d0, 0xff91a1cf, 0xff91a1cf, 0xff92a1cf, 0xff93a0cf, 0xff939fcf, 0xff929ecf, 0xff929ecf,
    0xff929ed0, 0xff929ed0, 0xff919ece, 0xff909dcd, 0xff8f9ccc, 0xff8f9bcc, 0xff8f9ccc, 0xff8e9ecd,
    0xff8e9ecd, 0xff8d9ccc, 0xff8d9bcb, 0xff8e9bcc, 0xff8f9ccc, 0xff8f9ccc, 0xff8f9ccb, 0xff8f9ccb,
    0xff8e9dcc, 0xff8e9dcc, 0xff8f9dcc, 0xff8f9dcc, 0xff8e9ccb, 0xff8e9bcb, 0xff8f9bcb, 0xff909ccb,
    0xff909ccb, 0xff8f9ccb, 0xff8f9ccb, 0xff8e9bca, 0xff8d9aca, 0xff8a99c9, 0xff8998c9, 0xff8a97c8,
    0xff8b97c8, 0xff8a97c8, 0xff8996c8, 0xff8896c8, 0xff8896c7, 0xff8896c7, 0xff8896c7, 0xff8795c7,
    0xff8593c7, 0xff8392c6, 0xff8392c5, 0xff8493c4, 0xff8593c4, 0xff8693c4, 0xff8693c4, 0xff8693c5,
    0xff8693c5, 0xff8794c4, 0xff8996c2, 0xff8996c2, 0xff8996c2, 0xff8996c2, 0xff8896c1, 0xff8895c1,
    0xff8794c0, 0xff8793c0, 0xff8793c1, 0xff8693c1, 0xff8593c0, 0xff8592be, 0xff8390bc, 0xff828ebb,
    0xff818dbb, 0xff7f8cbb, 0xff7e8cbb, 0xff7c8aba, 0xff7a88b8, 0xff7888b7, 0xff7688b6, 0xff7487b4,
    0xff7285b3, 0xff7183b3, 0xff6f81b3, 0xff6e81b3, 0xff6d80b2, 0xff6c80b1, 0xff6b80b1, 0xff6b7fb1,
    0xff697fb0, 0xff677eaf, 0xff667eae, 0xff667dad, 0xff667cad, 0xff667cae, 0xff667cae, 0xff677dac,
    0xff697eaa, 0xff6a7daa, 0xff6a7bac, 0xff6778b1, 0xff5e74b8, 0xff5676be, 0xff5680bf, 0xff5e8dbc,
    0xff6e96b2, 0xff7f99a6, 0xff8c9499, 0xff8f8a90, 0xff887c8b, 0xff796f8a, 0xff64638b, 0xff565e8b,
    0xff4c5d8b, 0xff455c8b, 0xff425c8c, 0xff405c8c, 0xffa3a2b6, 0xffa3a2b6, 0xffa3afbb, 0xff9fb6c0,
    0xff94b0c6, 0xff8ba5cb, 0xff89a0ce, 0xff8ea1cf, 0xff93a1cd, 0xff97a1c9, 0xff98a1c7, 0xff96a1c6,
    0xff95a2c7, 0xff98a6c9, 0xff98a7ca, 0xff8c9ec8, 0xff7b92c5, 0xff6e89c2, 0xff6c87c0, 0xff6a86bf,
    0xff6783be, 0xff6682bf, 0xff6783c0, 0xff6a85c2, 0xff6d88c3, 0xff6f8ac4, 0xff728cc5, 0xff758ec6,
    0xff768ec6, 0xff758dc6, 0xff748dc6, 0xff768ec6, 0xff798fc7, 0xff7c90c8, 0xff7c91c9, 0xff7b91cb,
    0xff7892cb, 0xff7792cd, 0xff7a93cf, 0xff7d94d0, 0xff7e94ce, 0xff7e95cb, 0xff8096cb, 0xff8298cc,
    0xff8499cc, 0xff8699cd, 0xff8699cd, 0xff849ace, 0xff839acf, 0xff839acf, 0xff849acf, 0xff849acf,
    0xff859ad0, 0xff859ad0, 0xff859ad1, 0xff859ad1, 0xff869ccf, 0xff879dce, 0xff899dce, 0xff8b9ccf,
    0xff8b9ccf, 0xff8b9dcf, 0xff8c9fcf, 0xff8ea0d0, 0xff90a0d0, 0xff90a0cf, 0xff90a0cf, 0xff91a0cf,
    0xff929fcf, 0xff929fcf, 0xff929fd0, 0xff929fd0, 0xff919ed0, 0xff919ecf, 0xff919ece, 0xff909dce,
    0xff8f9cce, 0xff8d9bcd, 0xff8c9ccc, 0xff8c9dcb, 0xff8c9dcb, 0xff8c9bcb, 0xff8c9acb, 0xff8d9bcc,
    0xff8e9ccd, 0xff8e9ccc, 0xff8d9ccb, 0xff8c9ccb, 0xff8c9ccb, 0xff8c9ccb, 0xff8d9cca, 0xff8e9cca,
    0xff8d9bcb, 0xff8d9acb, 0xff8e9aca, 0xff8e9ac9, 0xff8e9ac9, 0xff8d9ac9, 0xff8c9ac9, 0xff8b99c8,
    0xff8a98c8, 0xff8996c8, 0xff8895c8, 0xff8896c8, 0xff8997c8, 0xff8997c8, 0xff8895c8, 0xff8795c8,
    0xff8695c7, 0xff8695c6, 0xff8795c7, 0xff8795c7, 0xff8693c7, 0xff8492c6, 0xff8492c6, 0xff8594c5,
    0xff8794c5, 0xff8894c6, 0xff8894c6, 0xff8894c7, 0xff8894c7, 0xff8895c5, 0xff8996c3, 0xff8a97c3,
    0xff8b98c3, 0xff8b98c3, 0xff8b97c2, 0xff8a96c2, 0xff8996c2, 0xff8996c2, 0xff8996c2, 0xff8895c2,
    0xff8794c1, 0xff8592bf, 0xff8390bd, 0xff838fbc, 0xff828ebc, 0xff808dbc, 0xff7e8cbb, 0xff7c8ab9,
    0xff7988b7, 0xff7888b6, 0xff7788b5, 0xff7587b3, 0xff7386b2, 0xff7184b2, 0xff7083b3, 0xff6f82b3,
    0xff6d81b2, 0xff6b80b1, 0xff6a7fb1, 0xff6a7eb0, 0xff687eaf, 0xff677dae, 0xff667dad, 0xff667cab,
    0xff667cab, 0xff657bac, 0xff657bad, 0xff667bad, 0xff677bab, 0xff677bab, 0xff677aaa, 0xff6679ab,
    0xff6277ad, 0xff5d77b2, 0xff5979ba, 0xff597ebf, 0xff5f88bb, 0xff6992b0, 0xff7997a2, 0xff899496,
    0xff8f8a8d, 0xff867a8a, 0xff72698a, 0xff616089, 0xff525c8a, 0xff485a8b, 0xff435b8c, 0xff415c8d,
    0xffa1a7b6, 0xffa1a7b6, 0xff9ab0bc, 0xff90b2c2, 0xff84a5c8, 0xff7d97cb, 0xff8093cc, 0xff8a98cb,
    0xff929dc7, 0xff95a0c3, 0xff95a1c1, 0xff919fc4, 0xff91a0c7, 0xff98a6ca, 0xff9da9cb, 0xff94a3c9,
    0xff8597c5, 0xff788ec2, 0xff748cc1, 0xff708ac1, 0xff6a86c0, 0xff6884c0, 0xff6985c1, 0xff6c87c2,
    0xff6f89c2, 0xff708ac3, 0xff728cc3, 0xff738dc4, 0xff748dc5, 0xff748dc6, 0xff748dc6, 0xff768dc6,
    0xff798ec7, 0xff7a8fc8, 0xff7b90c9, 0xff7a92cb, 0xff7892cb, 0xff7793cd, 0xff7b94cf, 0xff7e94d0,
    0xff7e94cd, 0xff7e95ca, 0xff7f96ca, 0xff8198cb, 0xff8399cd, 0xff8599cd, 0xff8599ce, 0xff839acf,
    0xff829ad0, 0xff839ad0, 0xff849ad0, 0xff849ad1, 0xff849bd1, 0xff849bd3, 0xff849bd4, 0xff859bd4,
    0xff869dd2, 0xff879ed0, 0xff899ed0, 0xff8b9ed1, 0xff8b9dd1, 0xff8a9dd0, 0xff8b9dd0, 0xff8d9fd1,
    0xff8fa0d1, 0xff8fa0d1, 0xff8fa0d0, 0xff909fcf, 0xff919ecf, 0xff919ecf, 0xff919fd0, 0xff919fd0,
    0xff909fcf, 0xff8f9ecf, 0xff8f9dcf, 0xff8f9ccf, 0xff8d9bcf, 0xff8b9bce, 0xff8a9bcd, 0xff8a9ccc,
    0xff8a9ccb, 0xff8a9acb, 0xff8b9acb, 0xff8d9bcc, 0xff8d9ccd, 0xff8c9ccd, 0xff8b9ccc, 0xff8b9ccc,
    0xff8b9ccb, 0xff8b9ccb, 0xff8c9bca, 0xff8c9bca, 0xff8c9bcc, 0xff8c9bcd, 0xff8c9bcc, 0xff8b9aca,
    0xff8b9ac9, 0xff8a99c9, 0xff8a99c9, 0xff8999c8, 0xff8898c8, 0xff8796c8, 0xff8795c8, 0xff8796c9,
    0xff8897ca, 0xff8897ca, 0xff8796c9, 0xff8796c8, 0xff8696c7, 0xff8696c7, 0xff8796c8, 0xff8896c8,
    0xff8794c7, 0xff8593c6, 0xff8593c6, 0xff8694c6, 0xff8895c6, 0xff8896c7, 0xff8996c8, 0xff8b96c9,
    0xff8b96c8, 0xff8b96c6, 0xff8a97c4, 0xff8b98c4, 0xff8c99c4, 0xff8c99c4, 0xff8c98c3, 0xff8b97c3,
    0xff8a97c3, 0xff8a97c3, 0xff8a97c3, 0xff8996c3, 0xff8794c2, 0xff8592bf, 0xff8390bd, 0xff8390bd,
    0xff828fbc, 0xff7f8dbb, 0xff7d8bba, 0xff7a89b9, 0xff7888b7, 0xff7788b6, 0xff7787b4, 0xff7586b2,
    0xff7385b1, 0xff7284b1, 0xff7183b2, 0xff7082b3, 0xff6d81b2, 0xff6a7fb0, 0xff697eb0, 0xff697eaf,
    0xff687eae, 0xff677dac, 0xff667dab, 0xff657da9, 0xff657ca9, 0xff657baa, 0xff657aac, 0xff6579ac,
    0xff6479ac, 0xff6479aa, 0xff6379a8, 0xff6479a6, 0xff6579a4, 0xff6578a8, 0xff5e74b4, 0xff5873bf,
    0xff547cc0, 0xff5789b8, 0xff6794ac, 0xff7e999f, 0xff8e9594, 0xff8c868e, 0xff7e728c, 0xff6d6689,
    0xff5c5f89, 0xff4f5c8a, 0xff485d8d, 0xff445e8f, 0xff94a7b8, 0xff94a7b8, 0xff8ca8be, 0xff83a5c4,
    0xff7c9ac7, 0xff798fc7, 0xff7e8ec5, 0xff8693c3, 0xff8c98c1, 0xff8e9bbe, 0xff8e9dbe, 0xff8c9cc1,
    0xff8f9dc5, 0xff98a5ca, 0xff9fabcc, 0xff9ba7ca, 0xff8f9ec6, 0xff8798c4, 0xff8598c5, 0xff8398c6,
    0xff7f95c6, 0xff7b92c6, 0xff778fc5, 0xff748dc4, 0xff738cc3, 0xff728bc2, 0xff6f89c2, 0xff6b87c2,
    0xff6a87c2, 0xff6f8ac4, 0xff738cc5, 0xff748cc6, 0xff748cc6, 0xff738cc6, 0xff728cc7, 0xff748ec9,
    0xff7791ca, 0xff7c95cd, 0xff8197d0, 0xff8398d1, 0xff8398ce, 0xff8298cb, 0xff8198cb, 0xff8199cd,
    0xff8299cf, 0xff8399cf, 0xff8499d0, 0xff839ad1, 0xff829ad1, 0xff839ad0, 0xff849ad0, 0xff849bd1,
    0xff859cd3, 0xff859cd5, 0xff869cd6, 0xff869cd6, 0xff879ed4, 0xff889fd3, 0xff8a9fd3, 0xff8b9fd3,
    0xff8b9fd3, 0xff8a9ed2, 0xff8b9ed2, 0xff8d9fd2, 0xff8ea0d2, 0xff8fa0d1, 0xff8f9fd0, 0xff8f9ecf,
    0xff8e9dce, 0xff8e9dce, 0xff8e9ece, 0xff8e9ece, 0xff8d9ccd, 0xff8d9bcd, 0xff8d9acd, 0xff8c9acd,
    0xff8b9acd, 0xff8a9acd, 0xff8a9acc, 0xff8a9bcb, 0xff8a9bca, 0xff8a9aca, 0xff8a9aca, 0xff8b9acb,
    0xff8b9acb, 0xff8b9bcc, 0xff8a9ccc, 0xff8a9ccb, 0xff8b9bca, 0xff8b9bca, 0xff8b9ac9, 0xff8b9aca,
    0xff8b9bcd, 0xff8b9bce, 0xff8a9bce, 0xff899bcd, 0xff899bcd, 0xff899bcd, 0xff899bcd, 0xff889acc,
    0xff8799cc, 0xff8797cb, 0xff8797cb, 0xff8798cb, 0xff8899cc, 0xff8999cc, 0xff8a99cc, 0xff8a99cc,
    0xff8998cb, 0xff8898ca, 0xff8998cb, 0xff8998cb, 0xff8897ca, 0xff8796c8, 0xff8796c8, 0xff8896c9,
    0xff8896c9, 0xff8897ca, 0xff8997ca, 0xff8b97c9, 0xff8c97c8, 0xff8c97c6, 0xff8b97c5, 0xff8b98c5,
    0xff8c99c5, 0xff8c99c5, 0xff8b97c4, 0xff8a96c4, 0xff8997c3, 0xff8997c3, 0xff8997c3, 0xff8995c3,
    0xff8894c2, 0xff8592bf, 0xff8390bd, 0xff828fbd, 0xff818ebc, 0xff7e8cba, 0xff7c8ab9, 0xff7a89b8,
    0xff7888b6, 0xff7787b5, 0xff7687b4, 0xff7486b2, 0xff7385b0, 0xff7284b0, 0xff7082b2, 0xff6e81b3,
    0xff6b80b2, 0xff697faf, 0xff687eaf, 0xff687daf, 0xff677dad, 0xff667cab, 0xff657ca9, 0xff647ca8,
    0xff647ba9, 0xff647aaa, 0xff6479ab, 0xff6378ab, 0xff6278aa, 0xff6278a8, 0xff6179a6, 0xff6379a4,
    0xff6579a1, 0xff6678a3, 0xff6274ad, 0xff5c72b8, 0xff5575bd, 0xff527ebb, 0xff5b89b5, 0xff6c93ac,
    0xff7d97a1, 0xff879097, 0xff87828e, 0xff7e7489, 0xff6e6887, 0xff5d6088, 0xff505e8b, 0xff495d8d,
    0xff86a3b9, 0xff86a3b9, 0xff809cbf, 0xff7c96c4, 0xff7b90c4, 0xff7c8ec1, 0xff7f8ebf, 0xff8291be,
    0xff8594bd, 0xff8696bc, 0xff8798bd, 0xff8a99c0, 0xff8f9bc4, 0xff97a4c8, 0xff9eabcb, 0xff9ca9ca,
    0xff95a3c8, 0xff93a1c7, 0xff95a4ca, 0xff96a6cc, 0xff95a5ce, 0xff91a1cd, 0xff899ccb, 0xff8096c8,
    0xff7a91c5, 0xff768dc4, 0xff6e88c2, 0xff6584bf, 0xff6383bf, 0xff6c89c2, 0xff748dc5, 0xff748dc6,
    0xff718bc6, 0xff6d8ac6, 0xff6b89c6, 0xff718cc8, 0xff7b92cb, 0xff8598ce, 0xff8a9dd1, 0xff8b9ed2,
    0xff8b9ed0, 0xff899ccd, 0xff869bcd, 0xff8399cf, 0xff8299d1, 0xff8299d2, 0xff8399d2, 0xff839ad2,
    0xff839ad1, 0xff8399d1, 0xff8499d1, 0xff859ad2, 0xff869bd4, 0xff869cd6, 0xff869cd6, 0xff879cd6,
    0xff899ed6, 0xff8a9fd6, 0xff8b9fd6, 0xff8b9fd5, 0xff8b9fd5, 0xff8ca0d4, 0xff8ca0d4, 0xff8ca0d3,
    0xff8ca0d3, 0xff8ea0d2, 0xff8f9fd1, 0xff8e9dcf, 0xff8c9ccd, 0xff8b9ccd, 0xff8b9dcd, 0xff8b9ccd,
    0xff8b9acc, 0xff8b99cb, 0xff8a99cc, 0xff8999cc, 0xff8999cc, 0xff8a99cb, 0xff8b9acb, 0xff8b9bcb,
    0xff8b9bcb, 0xff8a9bca, 0xff899aca, 0xff8999c9, 0xff8a99ca, 0xff8a9acc, 0xff8a9cce, 0xff8a9ccd,
    0xff8b9bcb, 0xff8b9bca, 0xff8a9bcb, 0xff8a9bcc, 0xff8b9cce, 0xff8b9ccf, 0xff8a9cd1, 0xff899dd2,
    0xff899ed2, 0xff8a9ed2, 0xff8a9ed2, 0xff899dd2, 0xff889cd1, 0xff889bd0, 0xff899acf, 0xff899acf,
    0xff8a9bcf, 0xff8c9ccf, 0xff8e9dd0, 0xff8e9dd0, 0xff8c9ccf, 0xff8b9bce, 0xff8b9acd, 0xff8b9acd,
    0xff8a9acc, 0xff8999cb, 0xff8999cb, 0xff8998cb, 0xff8998cb, 0xff8998cb, 0xff8998cb, 0xff8b98c9,
    0xff8c98c8, 0xff8c97c7, 0xff8b97c7, 0xff8b98c7, 0xff8a99c6, 0xff8a98c6, 0xff8996c5, 0xff8895c4,
    0xff8795c3, 0xff8795c2, 0xff8794c2, 0xff8793c1, 0xff8692c0, 0xff8491be, 0xff828fbd, 0xff808ebc,
    0xff7f8dbc, 0xff7d8bba, 0xff7c8ab9, 0xff7a89b8, 0xff7888b6, 0xff7687b5, 0xff7586b3, 0xff7384b1,
    0xff7384b0, 0xff7283b0, 0xff6f81b1, 0xff6c80b2, 0xff6a7fb0, 0xff687fae, 0xff677eae, 0xff677eae,
    0xff677cac, 0xff667ca9, 0xff657ba8, 0xff647aa8, 0xff647aa9, 0xff6479aa, 0xff6478aa, 0xff6377aa,
    0xff6277a9, 0xff6177a7, 0xff6078a7, 0xff6178a6, 0xff6378a4, 0xff6478a5, 0xff6477a9, 0xff6277af,
    0xff5c76b5, 0xff5775ba, 0xff577cba, 0xff5d88b6, 0xff6991ac, 0xff7b95a0, 0xff898f92, 0xff89818b,
    0xff7e7187, 0xff6c6686, 0xff596188, 0xff4e5d89, 0xff769bbb, 0xff769bbb, 0xff7591c0, 0xff758ac3,
    0xff798ac0, 0xff7c8dbb, 0xff7e8fb9, 0xff7d8fb9, 0xff7d90ba, 0xff7e91bb, 0xff8093bd, 0xff8796bf,
    0xff8d9ac2, 0xff95a1c6, 0xff9ca7ca, 0xff9ca8ca, 0xff9aa6c8, 0xff9ca8c9, 0xffa1adcd, 0xffa6b1d1,
    0xffa8b1d3, 0xffa4add2, 0xff9aa7cf, 0xff8ea0cc, 0xff879ac9, 0xff8295c8, 0xff778ec5, 0xff6a87c1,
    0xff6786c0, 0xff748ec4, 0xff7e94c8, 0xff7b92c8, 0xff738ec7, 0xff6c8bc6, 0xff6b8bc6, 0xff7390c8,
    0xff8397cc, 0xff909ed0, 0xff96a4d3, 0xff96a6d3, 0xff95a6d1, 0xff91a3cf, 0xff8b9fd0, 0xff849bd2,
    0xff8199d4, 0xff8199d4, 0xff829ad4, 0xff839ad3, 0xff839ad2, 0xff839ad1, 0xff849ad2, 0xff859bd3,
    0xff869cd5, 0xff879dd7, 0xff889dd7, 0xff889dd7, 0xff8a9fd9, 0xff8ba0d9, 0xff8ba0d8, 0xff8a9fd6,
    0xff8ba0d6, 0xff8ca1d6, 0xff8ca1d6, 0xff8ba0d6, 0xff8ba0d5, 0xff8da0d4, 0xff8ea0d3, 0xff8d9fd1,
    0xff8a9dcf, 0xff899dce, 0xff899dce, 0xff899cce, 0xff899acd, 0xff8999cd, 0xff8899ce, 0xff879ace,
    0xff889ace, 0xff899acd, 0xff8a9bcd, 0xff8b9cce, 0xff8b9cce, 0xff899cce, 0xff889ccd, 0xff889acc,
    0xff8899cc, 0xff889bcf, 0xff899dd2, 0xff8a9dd1, 0xff8b9dcf, 0xff8b9dce, 0xff8a9dcf, 0xff899dd0,
    0xff8a9ed2, 0xff8b9fd4, 0xff8ba0d6, 0xff8aa1d8, 0xff8ba2d9, 0xff8ca2d8, 0xff8ca2d8, 0xff8ba1d8,
    0xff8ba0d7, 0xff8c9fd5, 0xff8c9fd4, 0xff8c9ed3, 0xff8c9ed3, 0xff8e9fd3, 0xff90a1d4, 0xff91a1d4,
    0xff909fd3, 0xff8e9ed2, 0xff8d9dd1, 0xff8c9cd0, 0xff8b9ccf, 0xff8a9bce, 0xff8a9ace, 0xff8999cd,
    0xff8999cd, 0xff8898cc, 0xff8898cb, 0xff8a98c8, 0xff8b98c7, 0xff8c98c7, 0xff8b97c7, 0xff8a97c7,
    0xff8997c6, 0xff8796c5, 0xff8794c4, 0xff8693c3, 0xff8593c2, 0xff8493c1, 0xff8492c0, 0xff8490bf,
    0xff8390be, 0xff828fbd, 0xff808ebc, 0xff7e8cbb, 0xff7d8bbb, 0xff7b8ab9, 0xff7a89b8, 0xff7988b7,
    0xff7787b5, 0xff7586b4, 0xff7385b3, 0xff7283b1, 0xff7283b0, 0xff7182b0, 0xff6c80b1, 0xff697fb1,
    0xff677eaf, 0xff677ead, 0xff677dac, 0xff667dac, 0xff667baa, 0xff657ba8, 0xff647aa7, 0xff6379a8,
    0xff6379a9, 0xff6379a9, 0xff6378a8, 0xff6278a7, 0xff6177a6, 0xff6177a6, 0xff6178a6, 0xff6178a6,
    0xff6178a6, 0xff6278a7, 0xff657aa7, 0xff667ba8, 0xff6376ae, 0xff5e70b6, 0xff5772bb, 0xff537cbc,
    0xff5989b6, 0xff6e94a9, 0xff84979a, 0xff8d8e90, 0xff897d8a, 0xff7a6f88, 0xff666689, 0xff5a6189,
    0xff698fbf, 0xff698fbf, 0xff6c88c0, 0xff6f84c0, 0xff7285bd, 0xff7589b9, 0xff768bb7, 0xff768bb7,
    0xff788db9, 0xff798eba, 0xff7d90bc, 0xff8494be, 0xff8b98c0, 0xff929ec5, 0xff96a3c9, 0xff99a6c9,
    0xff9aa7c8, 0xff9faac9, 0xffa5afcd, 0xffabb3d1, 0xffafb5d2, 0xffaeb4d2, 0xffaab3d2, 0xffa4b0d2,
    0xffa0acd2, 0xff9ba8d0, 0xff90a0cd, 0xff8298c9, 0xff7e96c7, 0xff8c9fcb, 0xff95a5ce, 0xff8a9dcd,
    0xff7b93ca, 0xff7691c9, 0xff7a95ca, 0xff859bcc, 0xff93a2cf, 0xff9fa9d2, 0xffa5afd4, 0xffa4b0d5,
    0xffa2b0d3, 0xff9cabd1, 0xff91a4d2, 0xff859dd4, 0xff7e99d6, 0xff7f9ad6, 0xff819cd6, 0xff829bd5,
    0xff839bd4, 0xff839bd4, 0xff849cd5, 0xff859cd5, 0xff869dd6, 0xff869dd6, 0xff869dd7, 0xff869dd7,
    0xff899fd9, 0xff8aa0d9, 0xff899fd8, 0xff889ed6, 0xff889fd6, 0xff89a0d6, 0xff8aa1d6, 0xff8ba1d7,
    0xff8ba1d8, 0xff8da2d8, 0xff8da2d7, 0xff8ca1d6, 0xff8aa0d5, 0xff899fd3, 0xff899fd2, 0xff899dd1,
    0xff889dd1, 0xff889cd2, 0xff879cd3, 0xff879cd3, 0xff879bd2, 0xff889bd1, 0xff899bd1, 0xff8a9cd2,
    0xff8a9dd2, 0xff889ed2, 0xff879ed2, 0xff879cd1, 0xff879cd2, 0xff879ed5, 0xff88a0d8, 0xff89a1d9,
    0xff8aa1d8, 0xff89a1d8, 0xff88a1d9, 0xff87a1da, 0xff89a3dc, 0xff8ba4dd, 0xff8ca5dd, 0xff8ca5dd,
    0xff8da6dd, 0xff8ea6dd, 0xff8fa6dc, 0xff90a5db, 0xff90a4da, 0xff91a4d9, 0xff91a4d9, 0xff90a3d8,
    0xff8fa1d6, 0xff90a1d6, 0xff91a2d6, 0xff91a2d6, 0xff90a0d5, 0xff8f9fd4, 0xff8e9ed2, 0xff8d9dd1,
    0xff8c9cd0, 0xff8a9bcf, 0xff899bce, 0xff899ace, 0xff889acd, 0xff8799cc, 0xff8798cb, 0xff8898c9,
    0xff8998c7, 0xff8a98c6, 0xff8a97c6, 0xff8996c5, 0xff8796c5, 0xff8594c4, 0xff8593c3, 0xff8492c2,
    0xff8391c0, 0xff8291bf, 0xff8190be, 0xff808ebd, 0xff7f8ebc, 0xff7f8dbb, 0xff7d8cba, 0xff7c8bb9,
    0xff7b8ab9, 0xff7989b8, 0xff7888b7, 0xff7787b6, 0xff7686b4, 0xff7485b3, 0xff7284b2, 0xff7082b1,
    0xff7082b0, 0xff6f81b0, 0xff6b80af, 0xff687fae, 0xff667eae, 0xff667dad, 0xff667dac, 0xff657caa,
    0xff657ca8, 0xff647ba6, 0xff637aa6, 0xff6279a7, 0xff6278a8, 0xff6278a7, 0xff6278a6, 0xff6278a6,
    0xff6177a5, 0xff6177a5, 0xff6077a4, 0xff6077a4, 0xff6076a4, 0xff6177a5, 0xff657aa4, 0xff677ca4,
    0xff6678a9, 0xff6271af, 0xff5b70b6, 0xff5375bb, 0xff547fbb, 0xff618cb4, 0xff7596a7, 0xff85959c,
    0xff8d8d93, 0xff86808e, 0xff78728c, 0xff6f6a8b, 0xff6384c2, 0xff6384c2, 0xff6884c0, 0xff6d84bd,
    0xff6d85ba, 0xff6c87b8, 0xff6d88b7, 0xff7088b7, 0xff748ab9, 0xff778cbb, 0xff7c90bc, 0xff8393bd,
    0xff8897be, 0xff8d9bc2, 0xff919fc7, 0xff95a2c7, 0xff98a4c6, 0xff9da8c7, 0xffa2abca, 0xffa7aecc,
    0xffaab0cd, 0xffacb2cf, 0xffb1b6d3, 0xffb4bad7, 0xffb5bbd8, 0xffb3bad8, 0xffa9b3d6, 0xff9caad2,
    0xff98a8d0, 0xffa5b1d2, 0xffaab5d4, 0xff9aa8d2, 0xff879bce, 0xff8499cd, 0xff8ea0ce, 0xff99a8d0,
    0xffa2add1, 0xffaab2d4, 0xffafb6d6, 0xffaeb6d6, 0xffacb5d4, 0xffa5b1d2, 0xff96a8d3, 0xff869ed5,
    0xff7d99d6, 0xff7e9bd6, 0xff819dd6, 0xff829dd6, 0xff839dd6, 0xff849ed7, 0xff849fd8, 0xff859fd7,
    0xff859ed6, 0xff859ed5, 0xff849ed5, 0xff849ed6, 0xff879fd8, 0xff88a0d8, 0xff879fd7, 0xff869ed6,
    0xff869ed6, 0xff879fd6, 0xff89a0d7, 0xff8aa0d9, 0xff8ba1da, 0xff8ba4db, 0xff8ba5db, 0xff8ba5dc,
    0xff8aa3dc, 0xff8aa2da, 0xff89a0d7, 0xff89a0d6, 0xff88a1d8, 0xff88a1d9, 0xff88a1da, 0xff88a0da,
    0xff879fd9, 0xff879ed7, 0xff879ed7, 0xff88a0d8, 0xff88a0d8, 0xff87a0d9, 0xff87a0d9, 0xff87a0d9,
    0xff87a0da, 0xff87a1dc, 0xff87a3df, 0xff87a4e0, 0xff88a5e2, 0xff87a5e2, 0xff86a5e3, 0xff86a5e3,
    0xff89a7e5, 0xff8ca9e6, 0xff8da9e4, 0xff8ea9e1, 0xff8fa9e0, 0xff90a9e0, 0xff92a9df, 0xff94a8dd,
    0xff95a7dc, 0xff95a7dd, 0xff94a7dd, 0xff93a5dc, 0xff92a3d9, 0xff91a2d8, 0xff90a2d7, 0xff8fa1d5,
    0xff8ea0d5, 0xff8e9fd4, 0xff8e9ed2, 0xff8e9dd1, 0xff8c9cd0, 0xff8a9bce, 0xff899bcd, 0xff889acc,
    0xff889acc, 0xff8799cb, 0xff8798ca, 0xff8798c8, 0xff8898c6, 0xff8997c6, 0xff8996c5, 0xff8895c4,
    0xff8593c2, 0xff8392c1, 0xff8392c1, 0xff8392c1, 0xff8191bf, 0xff8090be, 0xff7f8fbd, 0xff7d8dbc,
    0xff7c8cbb, 0xff7b8bba, 0xff7b8bb9, 0xff7a8bb8, 0xff798ab8, 0xff7688b7, 0xff7587b6, 0xff7586b5,
    0xff7585b4, 0xff7484b3, 0xff7183b1, 0xff6f82b0, 0xff6e81b0, 0xff6d81b0, 0xff6a80ad, 0xff687fac,
    0xff677ead, 0xff667cad, 0xff667bab, 0xff657ba8, 0xff657ba6, 0xff647aa6, 0xff637aa6, 0xff6279a6,
    0xff6278a6, 0xff6178a5, 0xff6178a4, 0xff6178a4, 0xff6178a4, 0xff6178a4, 0xff6077a3, 0xff6076a3,
    0xff5f76a3, 0xff6077a3, 0xff6379a3, 0xff667ba5, 0xff667aa6, 0xff6477a8, 0xff5f75af, 0xff5a73b6,
    0xff5877bb, 0xff5b81bb, 0xff668eb4, 0xff7896a9, 0xff88989d, 0xff8c8d95, 0xff867e91, 0xff82758f,
    0xff5f7bc1, 0xff5f7bc1, 0xff6681bd, 0xff6a85b9, 0xff6785b8, 0xff6383b8, 0xff6583b8, 0xff6a85b8,
    0xff7088b9, 0xff758bbb, 0xff7a8fbc, 0xff8092bc, 0xff8494bd, 0xff8797c0, 0xff8a99c4, 0xff8e9dc4,
    0xff92a1c4, 0xff97a5c5, 0xff9ba6c6, 0xff9ea8c8, 0xffa1aac9, 0xffa5adcb, 0xffb0b5d1, 0xffbbbdd7,
    0xffc1c2db, 0xffc1c4db, 0xffbcc1da, 0xffb3bad8, 0xffb0b8d7, 0xffbabfd9, 0xffbbc0d9, 0xffa9b2d6,
    0xff95a4d2, 0xff93a2d1, 0xff9fabd2, 0xffa9b3d3, 0xffafb7d4, 0xffb3bad5, 0xffb7bcd7, 0xffb6bbd7,
    0xffb5bad5, 0xffadb6d3, 0xff9cacd4, 0xff8aa1d5, 0xff7e9bd6, 0xff7d9bd5, 0xff7f9dd5, 0xff809dd5,
    0xff829dd6, 0xff839fd8, 0xff84a1da, 0xff84a1d9, 0xff849fd7, 0xff849fd6, 0xff849fd7, 0xff85a0d8,
    0xff87a1d8, 0xff88a1d8, 0xff87a0d7, 0xff869fd7, 0xff869fd7, 0xff86a0d7, 0xff88a1d9, 0xff89a1db,
    0xff8aa2dd, 0xff8aa5df, 0xff89a7e0, 0xff89a7e2, 0xff8aa6e3, 0xff8aa5e2, 0xff89a4df, 0xff88a4de,
    0xff87a5e0, 0xff87a6e1, 0xff88a5e2, 0xff88a4e2, 0xff87a3e1, 0xff86a2df, 0xff86a2df, 0xff86a4e0,
    0xff86a4e0, 0xff86a4e1, 0xff86a4e1, 0xff86a4e2, 0xff86a5e3, 0xff86a6e5, 0xff86a7e7, 0xff86a8e9,
    0xff86aaeb, 0xff86aaec, 0xff85a9ec, 0xff86a9ec, 0xff89abee, 0xff8cadee, 0xff8eadeb, 0xff8face7,
    0xff90ace5, 0xff90abe5, 0xff92abe3, 0xff95aae0, 0xff97aadf, 0xff97aae0, 0xff96aae1, 0xff95a8df,
    0xff93a6dd, 0xff91a3da, 0xff8ea2d8, 0xff8ca0d6, 0xff8ca0d5, 0xff8d9fd4, 0xff8e9ed2, 0xff8e9dd1,
    0xff8c9bd0, 0xff899ace, 0xff889acd, 0xff889acc, 0xff8899ca, 0xff8798ca, 0xff8697c9, 0xff8697c7,
    0xff8697c6, 0xff8797c5, 0xff8795c4, 0xff8693c2, 0xff8391c0, 0xff8290bf, 0xff8291c0, 0xff8291c0,
    0xff808fbe, 0xff7e8ebc, 0xff7c8dbb, 0xff7a8cba, 0xff798bb9, 0xff7889b8, 0xff7889b7, 0xff7889b6,
    0xff7789b6, 0xff7487b6, 0xff7386b5, 0xff7385b4, 0xff7384b3, 0xff7283b2, 0xff7082b0, 0xff6e81af,
    0xff6c80af, 0xff6a80af, 0xff697fac, 0xff687eaa, 0xff677cac, 0xff657bad, 0xff647bab, 0xff647ba7,
    0xff647ba5, 0xff637ba6, 0xff627aa6, 0xff6179a6, 0xff6178a5, 0xff6078a3, 0xff6078a2, 0xff6078a2,
    0xff6178a3, 0xff6178a3, 0xff6177a3, 0xff6177a3, 0xff6177a3, 0xff6178a3, 0xff6279a5, 0xff647aa7,
    0xff657ba6, 0xff667ca4, 0xff6579a8, 0xff6374b1, 0xff5e73b9, 0xff5779be, 0xff5985bc, 0xff6a93b4,
    0xff809ca8, 0xff8c979e, 0xff8f8997, 0xff918293, 0xff5d79bc, 0xff5d79bc, 0xff627fb9, 0xff6683b6,
    0xff6383b6, 0xff5f81b7, 0xff6081b7, 0xff6583b7, 0xff6b85b8, 0xff7088ba, 0xff758cbb, 0xff7b8fbc,
    0xff7f91bd, 0xff8293be, 0xff8596c0, 0xff8898c1, 0xff8c9bc1, 0xff909fc3, 0xff94a1c4, 0xff97a2c5,
    0xff97a2c5, 0xff9aa5c6, 0xffa4accb, 0xffafb5d1, 0xffb7bbd5, 0xffbbbfd7, 0xffbdc1d9, 0xffbcc0da,
    0xffbcc0da, 0xffc1c4db, 0xffc0c3da, 0xffb3b9d8, 0xffa5afd5, 0xffa3add4, 0xffa9b2d4, 0xffb0b7d4,
    0xffb4bbd6, 0xffb8bdd7, 0xffb9bed7, 0xffb9bcd7, 0xffb9bcd6, 0xffb3b9d5, 0xffa5b1d5, 0xff92a6d5,
    0xff839dd5, 0xff7d9ad3, 0xff7b9ad3, 0xff7d9ad3, 0xff809cd5, 0xff839ed8, 0xff85a1db, 0xff85a2db,
    0xff85a2db, 0xff87a4dc, 0xff8ba6de, 0xff8da7df, 0xff8da6de, 0xff8ca5dc, 0xff8ba4dc, 0xff89a3dc,
    0xff88a3dd, 0xff88a4dd, 0xff88a3de, 0xff87a2df, 0xff86a2e0, 0xff86a5e3, 0xff86a8e5, 0xff87a8e8,
    0xff88a8ea, 0xff88a9eb, 0xff87a9ec, 0xff87abed, 0xff86acee, 0xff86acee, 0xff87aaed, 0xff87a9ec,
    0xff86a9ec, 0xff85a9ec, 0xff84a9ec, 0xff84aaec, 0xff84aaec, 0xff84a8ec, 0xff84a8ec, 0xff84a9ed,
    0xff84aaee, 0xff85abef, 0xff85abf0, 0xff84abf2, 0xff83acf4, 0xff84acf4, 0xff86acf2, 0xff89acf1,
    0xff8baef1, 0xff8daff0, 0xff8eafee, 0xff8eaeeb, 0xff8eaeea, 0xff8eade9, 0xff90ade8, 0xff93ace7,
    0xff94ace6, 0xff94ade7, 0xff93ace6, 0xff93a9e3, 0xff91a6df, 0xff8fa3dc, 0xff8ca2da, 0xff8aa0d8,
    0xff8a9fd6, 0xff8b9ed5, 0xff8c9dd3, 0xff8c9dd2, 0xff8b9cd1, 0xff899bcf, 0xff899bcd, 0xff899acc,
    0xff8899cb, 0xff8798ca, 0xff8697ca, 0xff8697c8, 0xff8697c7, 0xff8696c6, 0xff8594c4, 0xff8492c2,
    0xff8391bf, 0xff8290be, 0xff8290bf, 0xff8290bf, 0xff7f8ebd, 0xff7d8dbb, 0xff7b8cba, 0xff798bb9,
    0xff788ab8, 0xff7788b7, 0xff7788b6, 0xff7688b5, 0xff7588b5, 0xff7386b5, 0xff7285b4, 0xff7284b3,
    0xff7283b2, 0xff7182b1, 0xff7081af, 0xff6e80ae, 0xff6b7fae, 0xff697fae, 0xff677eab, 0xff677daa,
    0xff667bab, 0xff657aac, 0xff647aaa, 0xff637ba7, 0xff637ba5, 0xff627ba6, 0xff627aa6, 0xff6279a6,
    0xff6178a5, 0xff6077a3, 0xff5f77a1, 0xff5f77a1, 0xff5f77a1, 0xff6178a3, 0xff6379a5, 0xff647aa6,
    0xff647aa6, 0xff647aa6, 0xff647aa7, 0xff657ba7, 0xff667da6, 0xff687ea4, 0xff687ca6, 0xff6776ab,
    0xff6273b2, 0xff5b75ba, 0xff597ebe, 0xff628bbd, 0xff7197b5, 0xff8399aa, 0xff91959f, 0xff999299,
    0xff5d7cb7, 0xff5d7cb7, 0xff617fb6, 0xff6481b5, 0xff6281b6, 0xff5f80b7, 0xff6081b7, 0xff6382b7,
    0xff6784b7, 0xff6c86b9, 0xff7188ba, 0xff768cbc, 0xff7a8ebd, 0xff7d91bd, 0xff8193bd, 0xff8494be,
    0xff8796bf, 0xff8b99c1, 0xff8e9cc2, 0xff909ec3, 0xff8e9dc2, 0xff8f9dc3, 0xff94a1c6, 0xff9ca7c9,
    0xffa4adcc, 0xffaab2cf, 0xffb2b8d3, 0xffb7bcd7, 0xffbbbfd9, 0xffbcbfda, 0xffb9bdd9, 0xffb5bad8,
    0xffb0b7d6, 0xffacb4d4, 0xffaab2d2, 0xffadb4d3, 0xffb2b9d6, 0xffb6bcd8, 0xffb6bcd7, 0xffb6bad6,
    0xffb8bcd6, 0xffb6bbd6, 0xffaab4d6, 0xff9aaad5, 0xff899fd3, 0xff7e99d1, 0xff7995d0, 0xff7a96d0,
    0xff7f99d2, 0xff829cd5, 0xff859fd9, 0xff86a3dc, 0xff87a5df, 0xff8ca9e2, 0xff91ace5, 0xff94ade6,
    0xff93abe3, 0xff90a8e0, 0xff8ea7e0, 0xff8ca7e1, 0xff8ba7e2, 0xff8aa7e4, 0xff87a5e3, 0xff84a3e1,
    0xff82a2e1, 0xff82a4e5, 0xff84a7e9, 0xff85a8eb, 0xff86a9ed, 0xff86abf0, 0xff84aef4, 0xff84b0f7,
    0xff84b0f8, 0xff84aff7, 0xff85aef4, 0xff85adf3, 0xff84aef4, 0xff83aff6, 0xff83b0f6, 0xff83aff5,
    0xff83aef5, 0xff82acf4, 0xff82abf4, 0xff81acf4, 0xff81adf5, 0xff82adf5, 0xff83adf6, 0xff82adf7,
    0xff80adf7, 0xff83adf7, 0xff87aef5, 0xff8caef2, 0xff8daff0, 0xff8dafee, 0xff8cafee, 0xff8baeef,
    0xff8baeef, 0xff8badee, 0xff8caded, 0xff8daded, 0xff8eadec, 0xff8fadeb, 0xff8face9, 0xff8ea9e5,
    0xff8da6e1, 0xff8ca3dd, 0xff8ba2db, 0xff89a0d9, 0xff899ed6, 0xff899dd5, 0xff8a9dd4, 0xff8b9dd3,
    0xff8b9cd1, 0xff8a9bcf, 0xff8a9ace, 0xff8a9acd, 0xff8998cb, 0xff8898cb, 0xff8797ca, 0xff8797c8,
    0xff8797c7, 0xff8595c5, 0xff8393c3, 0xff8292c1, 0xff8291c0, 0xff8290bf, 0xff828fbe, 0xff818fbe,
    0xff7f8dbc, 0xff7d8cbb, 0xff7b8cba, 0xff798bb9, 0xff788ab8, 0xff7789b7, 0xff7587b6, 0xff7587b5,
    0xff7486b5, 0xff7284b3, 0xff7183b2, 0xff7183b2, 0xff7183b2, 0xff7082b0, 0xff6f80ad, 0xff6d7fac,
    0xff6a7eac, 0xff687ead, 0xff677cac, 0xff677bab, 0xff667aab, 0xff647aaa, 0xff637aa9, 0xff637aa7,
    0xff637aa5, 0xff6279a5, 0xff6279a5, 0xff6279a5, 0xff6279a5, 0xff6077a3, 0xff5e75a0, 0xff5d74a0,
    0xff5d74a1, 0xff6076a4, 0xff647aa7, 0xff677ca9, 0xff687daa, 0xff677da9, 0xff667ca8, 0xff667ca8,
    0xff677da8, 0xff697ea9, 0xff697da9, 0xff697ba8, 0xff6678ab, 0xff6277b4, 0xff5f7abd, 0xff5f83c1,
    0xff658dbe, 0xff7695b2, 0xff8a9aa4, 0xff969d9b, 0xff5e7eb2, 0xff5e7eb2, 0xff607fb4, 0xff617fb5,
    0xff617fb6, 0xff607fb6, 0xff6080b6, 0xff6281b7, 0xff6483b7, 0xff6884b8, 0xff6c86b9, 0xff7189bc,
    0xff758bbd, 0xff798ebc, 0xff7c90bb, 0xff7e91bb, 0xff8191bd, 0xff8494bf, 0xff8797c1, 0xff8899c2,
    0xff8596c1, 0xff8494c0, 0xff8595c0, 0xff8a99c1, 0xff919ec4, 0xff99a4c7, 0xffa5adcd, 0xffb0b6d3,
    0xffb6bad7, 0xffb3b9d7, 0xffb0b6d6, 0xffb4b9d7, 0xffb6bbd6, 0xffb1b7d4, 0xffa9b1d0, 0xffa8b1d1,
    0xffafb6d5, 0xffb4bad7, 0xffb3b9d6, 0xffb1b7d4, 0xffb5bad5, 0xffb6bbd6, 0xffafb6d5, 0xffa1add3,
    0xff8ea1d0, 0xff7e96cd, 0xff7590cc, 0xff7691cc, 0xff7c96cf, 0xff8099d3, 0xff839dd7, 0xff85a1dc,
    0xff87a5e0, 0xff8ca9e4, 0xff94ade8, 0xff97aee8, 0xff95abe4, 0xff91a8e1, 0xff8fa8e1, 0xff8ea9e2,
    0xff8ea9e5, 0xff8daae8, 0xff8aa8e7, 0xff85a5e5, 0xff82a4e4, 0xff82a5e8, 0xff83a7eb, 0xff84a7eb,
    0xff84a8ec, 0xff83abf1, 0xff82aff8, 0xff82b1fb, 0xff83b0fb, 0xff83aff9, 0xff83aef6, 0xff83aef5,
    0xff83b0f7, 0xff82b2fa, 0xff82b3fd, 0xff82b4fd, 0xff82b3fd, 0xff81b1fb, 0xff81affa, 0xff80affa,
    0xff80b0fa, 0xff81b0fa, 0xff83b0fa, 0xff82b0fa, 0xff80affa, 0xff83aff9, 0xff88b0f7, 0xff8db0f4,
    0xff8dafef, 0xff8caeec, 0xff8aaded, 0xff88adf0, 0xff87adf0, 0xff87acef, 0xff87acef, 0xff87acef,
    0xff88acef, 0xff8aaced, 0xff8babeb, 0xff8ba8e7, 0xff8aa5e4, 0xff8aa4e1, 0xff89a3df, 0xff89a1dc,
    0xff899fd9, 0xff899ed7, 0xff899ed6, 0xff899ed5, 0xff899dd3, 0xff899bd0, 0xff899ace, 0xff8999cd,
    0xff8897cb, 0xff8796cb, 0xff8696ca, 0xff8696c8, 0xff8696c7, 0xff8494c5, 0xff8192c3, 0xff8191c1,
    0xff8290c0, 0xff8290be, 0xff818fbe, 0xff808ebd, 0xff7e8cbb, 0xff7c8bba, 0xff7a8ab9, 0xff798ab8,
    0xff7889b7, 0xff7789b6, 0xff7587b5, 0xff7486b4, 0xff7385b4, 0xff7283b2, 0xff7182b1, 0xff7182b1,
    0xff7082b1, 0xff6f81af, 0xff6e7fac, 0xff6c7eab, 0xff697dab, 0xff677dac, 0xff657aac, 0xff6579ab,
    0xff6479aa, 0xff6379a8, 0xff6379a7, 0xff6279a6, 0xff6279a5, 0xff6178a5, 0xff6178a4, 0xff6178a4,
    0xff6178a4, 0xff5f76a2, 0xff5d74a0, 0xff5c739f, 0xff5c73a0, 0xff5f76a3, 0xff647ba8, 0xff697fac,
    0xff6a7fac, 0xff697eab, 0xff687eaa, 0xff687da9, 0xff697daa, 0xff6a7dac, 0xff6a7dab, 0xff6a7ea6,
    0xff697da6, 0xff697aae, 0xff6679b8, 0xff5f7bc0, 0xff5c83c2, 0xff6b8fb9, 0xff819bab, 0xff8ea3a2,
    0xff5d7fb2, 0xff5d7fb2, 0xff5e7eb4, 0xff5f7eb5, 0xff5f7eb5, 0xff5f7eb5, 0xff607fb6, 0xff6181b7,
    0xff6383b7, 0xff6584b7, 0xff6985b8, 0xff6d86bb, 0xff7088bc, 0xff748bbb, 0xff778eba, 0xff7b8fbb,
    0xff7d90bc, 0xff7f91be, 0xff8193c0, 0xff8193c0, 0xff7d90bf, 0xff7b8ebd, 0xff7a8dbb, 0xff7d8ebb,
    0xff8492bc, 0xff8e99bf, 0xff9ca4c5, 0xffa9aecc, 0xffb0b5d1, 0xffaeb3d1, 0xffabb1d1, 0xffb1b6d3,
    0xffb6bad4, 0xffb0b6d2, 0xffa6afce, 0xffa5aece, 0xffadb3d1, 0xffb3b7d4, 0xffb0b5d3, 0xffaeb4d2,
    0xffb4b8d4, 0xffb7bad6, 0xffb1b7d5, 0xffa5aed3, 0xff90a1cf, 0xff7c94ca, 0xff6f8cc7, 0xff718dc8,
    0xff7993cb, 0xff7d97cf, 0xff819bd4, 0xff839fd9, 0xff84a1dc, 0xff88a3de, 0xff8da5df, 0xff8fa6df,
    0xff8ea4dc, 0xff8ca3db, 0xff8ba4db, 0xff8ca5dd, 0xff8ea8e1, 0xff91aae6, 0xff91ace9, 0xff8eace9,
    0xff8aabe9, 0xff87a9eb, 0xff85a7eb, 0xff84a5e8, 0xff83a5e7, 0xff82a7ea, 0xff81aaf0, 0xff81abf3,
    0xff82abf2, 0xff82aaf1, 0xff81a9f0, 0xff81a9f0, 0xff81abf2, 0xff81adf6, 0xff81b1fb, 0xff81b4fe,
    0xff81b5ff, 0xff81b4fe, 0xff81b2fc, 0xff80b1fc, 0xff80b1fc, 0xff81b1fc, 0xff83b2fc, 0xff83b2fb,
    0xff82b3fa, 0xff85b4fa, 0xff89b5fa, 0xff8bb4f8, 0xff8bb0f2, 0xff89aced, 0xff87aaec, 0xff84a9ed,
    0xff83a8ed, 0xff83a7ec, 0xff83a7ec, 0xff85a9ec, 0xff87aaec, 0xff8aaaeb, 0xff8baaea, 0xff8baaea,
    0xff8aa9e9, 0xff89a8e8, 0xff89a7e6, 0xff8aa5e2, 0xff8ba3dd, 0xff8ca2da, 0xff8ba1d9, 0xff8aa0d8,
    0xff899dd5, 0xff879ad2, 0xff8699cf, 0xff8698cc, 0xff8696ca, 0xff8596c9, 0xff8495c8, 0xff8495c6,
    0xff8494c5, 0xff8292c4, 0xff7f90c2, 0xff7f8fc1, 0xff808ebf, 0xff808ebd, 0xff7e8dbd, 0xff7d8cbc,
    0xff7b8aba, 0xff7a89b9, 0xff7989b8, 0xff7889b7, 0xff7788b6, 0xff7687b5, 0xff7485b4, 0xff7385b3,
    0xff7284b3, 0xff7182b1, 0xff7081b0, 0xff6f81b0, 0xff6e81af, 0xff6d80ad, 0xff6b7eab, 0xff697caa,
    0xff677caa, 0xff657bab, 0xff6478ab, 0xff6377aa, 0xff6277a8, 0xff6177a5, 0xff6077a4, 0xff6077a4,
    0xff6077a4, 0xff6076a3, 0xff6076a2, 0xff6076a2, 0xff5f76a2, 0xff5e75a1, 0xff5d74a0, 0xff5c739f,
    0xff5b729f, 0xff5e75a2, 0xff637aa6, 0xff677da9, 0xff687eaa, 0xff687daa, 0xff687daa, 0xff697daa,
    0xff6a7dab, 0xff6b7dad, 0xff6b7eac, 0xff6b80a8, 0xff6b80a7, 0xff6d7daa, 0xff6b7bb2, 0xff647abb,
    0xff5f7dc1, 0xff6688bd, 0xff7496b3, 0xff7d9ead, 0xff5c7fb4, 0xff5c7fb4, 0xff5c7eb5, 0xff5d7db6,
    0xff5e7db6, 0xff5f7eb5, 0xff607fb5, 0xff6281b6, 0xff6483b7, 0xff6583b7, 0xff6684b8, 0xff6985bb,
    0xff6c86bc, 0xff7089bc, 0xff748cbc, 0xff788fbc, 0xff7a90bd, 0xff7c90be, 0xff7d90bf, 0xff7c8fc0,
    0xff798dbf, 0xff778cbd, 0xff758abb, 0xff788aba, 0xff808eba, 0xff8b94bd, 0xff999ec2, 0xffa3a8c7,
    0xffa9afcb, 0xffa9afcc, 0xffa8aecc, 0xffadb2cf, 0xffb0b5d1, 0xffabb2d0, 0xffa3adcd, 0xffa3adcc,
    0xffabb2ce, 0xffb1b5d0, 0xffaeb4d1, 0xffabb3d1, 0xffb0b7d3, 0xffb3b9d4, 0xffafb6d4, 0xffa3aed2,
    0xff8fa0cd, 0xff7991c8, 0xff6c89c4, 0xff6f8ac6, 0xff7790c9, 0xff7b96cd, 0xff7e9bd1, 0xff809cd4,
    0xff819bd5, 0xff829bd5, 0xff829bd4, 0xff839bd3, 0xff839cd2, 0xff849dd3, 0xff849fd4, 0xff86a1d6,
    0xff8ca5db, 0xff92aae2, 0xff97afe8, 0xff98b2ec, 0xff95b2ed, 0xff8eadec, 0xff88a8e8, 0xff85a4e3,
    0xff84a2df, 0xff83a2e0, 0xff82a3e4, 0xff82a3e6, 0xff82a3e5, 0xff82a3e5, 0xff80a2e5, 0xff7fa3e7,
    0xff7fa4e9, 0xff80a7ed, 0xff80adf4, 0xff81b3fc, 0xff81b6ff, 0xff82b6fd, 0xff82b4fb, 0xff81b2fb,
    0xff81b1fb, 0xff83b2fb, 0xff85b4fb, 0xff86b5fb, 0xff86b6fa, 0xff87b7fb, 0xff88b8fd, 0xff88b6fc,
    0xff88b0f5, 0xff86aaef, 0xff83a6eb, 0xff81a4e8, 0xff80a3e7, 0xff80a3e7, 0xff82a4e7, 0xff85a5e7,
    0xff88a7e7, 0xff8ba8e6, 0xff8ca9e7, 0xff8cabea, 0xff8baced, 0xff8aaced, 0xff89abeb, 0xff8aa9e6,
    0xff8da8e1, 0xff8fa6dd, 0xff8ea4db, 0xff8ba1da, 0xff879dd6, 0xff8499d2, 0xff8397ce, 0xff8396cb,
    0xff8395c8, 0xff8294c6, 0xff8293c5, 0xff8292c4, 0xff8191c3, 0xff7f90c2, 0xff7d8fc1, 0xff7d8ec0,
    0xff7e8ebe, 0xff7d8cbc, 0xff7c8bbc, 0xff7a8abb, 0xff7889b9, 0xff7788b8, 0xff7688b7, 0xff7688b6,
    0xff7587b5, 0xff7586b4, 0xff7484b4, 0xff7384b4, 0xff7283b3, 0xff7081b1, 0xff6f80af, 0xff6e81ae,
    0xff6d81ad, 0xff6b80ab, 0xff677daa, 0xff657ba9, 0xff647aaa, 0xff6479aa, 0xff6278aa, 0xff6177a8,
    0xff6076a5, 0xff5f75a2, 0xff5f75a1, 0xff5f76a2, 0xff5f76a2, 0xff5e76a1, 0xff5e75a1, 0xff5d74a0,
    0xff5d74a0, 0xff5d75a1, 0xff5e75a1, 0xff5d74a0, 0xff5d739f, 0xff5e74a0, 0xff6178a4, 0xff637aa6,
    0xff647aa7, 0xff657aa7, 0xff677ba8, 0xff697caa, 0xff6a7cab, 0xff6b7dac, 0xff6b7eac, 0xff6c7fab,
    0xff6c80aa, 0xff6e7fa9, 0xff6e7eac, 0xff697bb5, 0xff657cbc, 0xff6683bd, 0xff6a8db9, 0xff6d93b6,
    0xff5a7eb6, 0xff5a7eb6, 0xff5b7db7, 0xff5c7db7, 0xff5d7db6, 0xff5e7eb5, 0xff607fb6, 0xff6281b7,
    0xff6483b8, 0xff6384b9, 0xff6484b9, 0xff6684bb, 0xff6985bc, 0xff6c87bd, 0xff6f8abe, 0xff738dbe,
    0xff768fbf, 0xff788fc0, 0xff778dc1, 0xff768cc1, 0xff748bc0, 0xff738bbf, 0xff7289be, 0xff7589bd,
    0xff7c8dbd, 0xff8693bf, 0xff919bc2, 0xff99a2c5, 0xff9ea8c8, 0xffa0aac9, 0xffa1aaca, 0xffa5adce,
    0xffa6afd1, 0xffa2add0, 0xff9caace, 0xff9eaacd, 0xffa7aecd, 0xffacb1ce, 0xffa9b0ce, 0xffa6afcf,
    0xffabb3d1, 0xffadb5d2, 0xffaab2d2, 0xffa1abd1, 0xff8d9ecd, 0xff7891c7, 0xff6b89c3, 0xff6e89c4,
    0xff758ec7, 0xff7893cb, 0xff7a98ce, 0xff7b98cf, 0xff7c96cf, 0xff7b94cd, 0xff7a93cb, 0xff7993ca,
    0xff7b95cb, 0xff7e97cd, 0xff7f98ce, 0xff819bd0, 0xff87a0d5, 0xff8fa6dc, 0xff97ade4, 0xff9bb2ea,
    0xff99b3ec, 0xff91ade9, 0xff8aa7e4, 0xff86a3de, 0xff85a0d9, 0xff839ed8, 0xff829cd8, 0xff819cd9,
    0xff819cd9, 0xff819cda, 0xff7f9dde, 0xff7e9ee1, 0xff7f9fe3, 0xff80a3e7, 0xff80aaf0, 0xff81b1fa,
    0xff82b6ff, 0xff83b8fd, 0xff84b7fa, 0xff83b4f9, 0xff83b3f9, 0xff84b4f9, 0xff86b6fa, 0xff87b7fa,
    0xff88b9f9, 0xff88bafa, 0xff87bbfd, 0xff86b8fd, 0xff85b1f8, 0xff84abf2, 0xff82a6ec, 0xff80a4e7,
    0xff7fa3e6, 0xff7fa3e6, 0xff81a3e6, 0xff85a5e5, 0xff89a6e5, 0xff8da8e4, 0xff8ea9e5, 0xff8eacea,
    0xff8daeef, 0xff8aaef0, 0xff88acee, 0xff89aae9, 0xff8eaae3, 0xff90a8de, 0xff8fa5dd, 0xff8ba1db,
    0xff869bd6, 0xff8297d1, 0xff7f94cd, 0xff7f94ca, 0xff7f93c7, 0xff7e92c5, 0xff7e91c3, 0xff7e8fc1,
    0xff7d8ec1, 0xff7c8dc1, 0xff7b8dc0, 0xff7b8cbf, 0xff7c8cbd, 0xff7b8bbc, 0xff798abb, 0xff7789bb,
    0xff7588b9, 0xff7587b8, 0xff7587b7, 0xff7486b5, 0xff7385b4, 0xff7284b3, 0xff7283b3, 0xff7282b3,
    0xff7182b2, 0xff6f81b0, 0xff6e80af, 0xff6d80ae, 0xff6b80ac, 0xff697fab, 0xff657da9, 0xff637ba9,
    0xff6379a9, 0xff6378a9, 0xff6177a8, 0xff5f76a6, 0xff5e74a3, 0xff5d73a0, 0xff5d739f, 0xff5d74a0,
    0xff5d74a0, 0xff5c749f, 0xff5c739f, 0xff5b729e, 0xff5b729e, 0xff5c739f, 0xff5e75a1, 0xff5e74a0,
    0xff5d739f, 0xff5d74a0, 0xff5f76a2, 0xff6077a3, 0xff6077a3, 0xff6177a3, 0xff6579a6, 0xff687caa,
    0xff6a7cab, 0xff6b7cab, 0xff6c7cac, 0xff6c7ead, 0xff6d7fac, 0xff6f81aa, 0xff6f81a9, 0xff6e7eae,
    0xff6c7cb6, 0xff677fba, 0xff6385bc, 0xff6088be, 0xff597db6, 0xff597db6, 0xff5a7db7, 0xff5b7db8,
    0xff5c7db7, 0xff5d7eb7, 0xff5e7fb8, 0xff6081ba, 0xff6183bb, 0xff6283bb, 0xff6283bb, 0xff6483bd,
    0xff6684be, 0xff6786c0, 0xff6988c1, 0xff6b8ac1, 0xff6e8cc2, 0xff708cc3, 0xff708bc4, 0xff708bc5,
    0xff6f8bc5, 0xff6f8cc5, 0xff708dc6, 0xff748fc8, 0xff7a93ca, 0xff8096cb, 0xff879acb, 0xff8b9cc9,
    0xff8f9ec8, 0xff91a1c7, 0xff93a3c9, 0xff97a7ce, 0xff9aa9d3, 0xff97a8d4, 0xff93a5d2, 0xff95a6d0,
    0xff9ea9ce, 0xffa3abcd, 0xffa2abcc, 0xffa0aacc, 0xffa2accd, 0xffa3accf, 0xffa1abcf, 0xff9ca7ce,
    0xff8d9ecb, 0xff7b93c8, 0xff6e8cc6, 0xff6e8bc6, 0xff738ec7, 0xff7491c8, 0xff7694ca, 0xff7894cb,
    0xff7994cc, 0xff7993cc, 0xff7792ca, 0xff7692ca, 0xff7893cb, 0xff7a95cd, 0xff7b96cd, 0xff7d97cf,
    0xff819bd1, 0xff869fd4, 0xff8ca4da, 0xff8fa8df, 0xff90a9e3, 0xff8da8e2, 0xff89a5e0, 0xff88a3dd,
    0xff86a1da, 0xff839cd6, 0xff7f97d3, 0xff7d95d1, 0xff7e96d2, 0xff7f98d6, 0xff7d9cdd, 0xff7da0e3,
    0xff7fa3e8, 0xff82a8ed, 0xff83aff5, 0xff83b6fc, 0xff84bcff, 0xff87bdff, 0xff88bdfd, 0xff87bafb,
    0xff86b8fa, 0xff86b7fa, 0xff87b8fa, 0xff87b8f9, 0xff87b9f9, 0xff86b9fa, 0xff85bafc, 0xff84b9fc,
    0xff84b4fa, 0xff84b0f6, 0xff83acf1, 0xff81aaed, 0xff80a9ec, 0xff7faaec, 0xff81aaec, 0xff83a9ec,
    0xff87a9eb, 0xff8baae8, 0xff8caae7, 0xff8caae9, 0xff8aaaeb, 0xff86a9eb, 0xff83a8ea, 0xff84a7e7,
    0xff89a7e4, 0xff8ca6df, 0xff8ba3dc, 0xff889fd9, 0xff859bd4, 0xff8297cf, 0xff7f94cb, 0xff7d93c9,
    0xff7b91c6, 0xff7a8fc4, 0xff7a8ec2, 0xff7a8cc1, 0xff7a8cc1, 0xff7a8cc0, 0xff7a8cbe, 0xff7b8cbd,
    0xff7c8bbb, 0xff7c8bbb, 0xff7a8abb, 0xff7889bb, 0xff7588ba, 0xff7487b8, 0xff7386b7, 0xff7284b5,
    0xff7183b4, 0xff7083b3, 0xff7083b3, 0xff7082b2, 0xff6f81b1, 0xff6d80b0, 0xff6c80af, 0xff6b80ae,
    0xff6a7fac, 0xff687eab, 0xff657dab, 0xff637bab, 0xff6379aa, 0xff6378a9, 0xff6177a7, 0xff5f76a5,
    0xff5d74a2, 0xff5c729f, 0xff5b729e, 0xff5b729e, 0xff5b729e, 0xff5a719d, 0xff5a719d, 0xff5a719d,
    0xff5b719d, 0xff5b729e, 0xff5c739f, 0xff5c739f, 0xff5d739f, 0xff5e74a0, 0xff5f75a2, 0xff6076a3,
    0xff5f75a1, 0xff5f75a1, 0xff6479a6, 0xff697eaa, 0xff6b7eab, 0xff6b7ca9, 0xff6b7baa, 0xff6c7dac,
    0xff6d7fad, 0xff6f81ab, 0xff7081a9, 0xff717faa, 0xff6f7caf, 0xff697db6, 0xff627fbc, 0xff5d80c1,
    0xff597cb6, 0xff597cb6, 0xff5a7cb7, 0xff5b7cb9, 0xff5b7db9, 0xff5c7fb9, 0xff5d80bb, 0xff5d81bd,
    0xff5e82be, 0xff5f82bc, 0xff6083bc, 0xff6384bf, 0xff6584c1, 0xff6584c2, 0xff6485c3, 0xff6586c3,
    0xff6888c3, 0xff6a8ac5, 0xff6b8ac7, 0xff6c8bc9, 0xff6c8dca, 0xff6d8fcc, 0xff7193d0, 0xff7596d3,
    0xff789ad7, 0xff7b9cd8, 0xff7e9cd5, 0xff819acf, 0xff8399ca, 0xff859ac8, 0xff879dca, 0xff8ca1d0,
    0xff90a5d6, 0xff8fa5d9, 0xff8ca2d8, 0xff8ea2d5, 0xff95a5d1, 0xff9ba6cd, 0xff9ca6cb, 0xff9ba5cb,
    0xff9ba5cb, 0xff9aa4cc, 0xff98a4cc, 0xff95a3cc, 0xff8b9ecc, 0xff7d97cb, 0xff7291ca, 0xff708ec9,
    0xff728ec8, 0xff728fc8, 0xff7391c9, 0xff7492ca, 0xff7692cc, 0xff7894ce, 0xff7895cf, 0xff7896d0,
    0xff7896d1, 0xff7995d1, 0xff7a95d1, 0xff7b95d0, 0xff7c96d0, 0xff7c97d0, 0xff7e99d2, 0xff7f9ad4,
    0xff829dd8, 0xff84a1dc, 0xff86a3de, 0xff88a4df, 0xff87a3de, 0xff829ed9, 0xff7d98d4, 0xff7a95d2,
    0xff7b95d3, 0xff7c98d8, 0xff7c9ee1, 0xff7da4e9, 0xff80aaf1, 0xff83b0f6, 0xff83b6fb, 0xff83bafe,
    0xff85beff, 0xff89c1ff, 0xff8bc2ff, 0xff8bc0fd, 0xff8abdfb, 0xff89bbfa, 0xff87bafa, 0xff86b9fa,
    0xff86b9fa, 0xff85b9fa, 0xff84b9fa, 0xff84b9fa, 0xff85b7fa, 0xff85b5f9, 0xff85b4f7, 0xff84b3f4,
    0xff83b3f4, 0xff81b4f5, 0xff81b2f5, 0xff82aff5, 0xff85adf3, 0xff89acef, 0xff8babeb, 0xff8aa8e8,
    0xff87a6e6, 0xff82a3e5, 0xff7ea1e5, 0xff7fa1e3, 0xff83a2e2, 0xff86a2df, 0xff869edb, 0xff849bd6,
    0xff8499d1, 0xff8296ce, 0xff8094ca, 0xff7d91c8, 0xff7a8fc5, 0xff788dc3, 0xff778cc2, 0xff778bc1,
    0xff778bc1, 0xff778bbf, 0xff788cbd, 0xff7a8cbc, 0xff7b8bbb, 0xff7c8bbb, 0xff7c8bbc, 0xff7a8abc,
    0xff7789bb, 0xff7487b9, 0xff7285b7, 0xff7083b5, 0xff6f83b4, 0xff6f83b3, 0xff6e82b2, 0xff6d81b1,
    0xff6c80b1, 0xff6b81b1, 0xff6b81b0, 0xff6a80af, 0xff697ead, 0xff687ead, 0xff677dad, 0xff657cad,
    0xff647bab, 0xff6379aa, 0xff6177a8, 0xff5f76a6, 0xff5d74a3, 0xff5c72a0, 0xff5b719e, 0xff5a719d,
    0xff5a709c, 0xff596f9c, 0xff596f9c, 0xff5a719c, 0xff5b729d, 0xff5a719d, 0xff59709d, 0xff5a719e,
    0xff5d729f, 0xff5f74a1, 0xff6075a3, 0xff6075a4, 0xff5e73a0, 0xff5e739f, 0xff6479a4, 0xff6b7eaa,
    0xff6d7fab, 0xff6b7ca9, 0xff6a7ba9, 0xff6c7dab, 0xff6d7ead, 0xff6f80ac, 0xff7080ab, 0xff707ea9,
    0xff6f7caa, 0xff6a7cb0, 0xff657db9, 0xff627dbe, 0xff587bb6, 0xff587bb6, 0xff597bb8, 0xff5a7cba,
    0xff5b7dbb, 0xff5b7fbb, 0xff5b80bd, 0xff5c80bf, 0xff5d80c0, 0xff5e81bf, 0xff5f82be, 0xff6284c0,
    0xff6384c2, 0xff6283c4, 0xff6083c5, 0xff6084c5, 0xff6286c5, 0xff6488c7, 0xff6689ca, 0xff688bcc,
    0xff698dce, 0xff6b90d1, 0xff7096d7, 0xff749bdc, 0xff769fe0, 0xff75a0e1, 0xff759ede, 0xff7799d6,
    0xff7897d0, 0xff7997ce, 0xff7b9ad0, 0xff819fd6, 0xff86a4dc, 0xff86a4e0, 0xff84a3df, 0xff86a2dc,
    0xff8ca3d7, 0xff91a3d2, 0xff93a2cf, 0xff92a0cd, 0xff919ecb, 0xff8e9ccb, 0xff8e9ccb, 0xff8d9dcc,
    0xff879ccd, 0xff7e98ce, 0xff7694ce, 0xff7291cc, 0xff7190cb, 0xff708fca, 0xff7190ca, 0xff7291cb,
    0xff7594ce, 0xff7896d2, 0xff7a98d5, 0xff7b99d6, 0xff7a98d6, 0xff7997d5, 0xff7996d4, 0xff7995d2,
    0xff7794d1, 0xff7592d0, 0xff7391ce, 0xff7391cd, 0xff7794cf, 0xff7e9bd6, 0xff85a2dc, 0xff89a6e1,
    0xff89a6e2, 0xff84a1de, 0xff7d99d8, 0xff7996d5, 0xff7997d7, 0xff7a9bdc, 0xff7ba1e6, 0xff7ca7ee,
    0xff7fadf5, 0xff82b2fa, 0xff82b6fd, 0xff82b8ff, 0xff84bcff, 0xff88bfff, 0xff8ac1fe, 0xff8bc1fd,
    0xff8bc0fc, 0xff8abffb, 0xff89befb, 0xff88bcfb, 0xff87bafb, 0xff85b8fb, 0xff85b8f9, 0xff85b9f9,
    0xff86bbfb, 0xff87bcfc, 0xff88bcfc, 0xff88bbfb, 0xff87bcfc, 0xff86bcfd, 0xff84b9fd, 0xff84b5fc,
    0xff86b1fa, 0xff8ab0f4, 0xff8caeee, 0xff8ba9e7, 0xff87a3e2, 0xff829fdf, 0xff7e9ddf, 0xff7d9ddf,
    0xff7f9ee0, 0xff809ede, 0xff8099d8, 0xff7f96d2, 0xff8095ce, 0xff7f94cb, 0xff7d92c9, 0xff798fc7,
    0xff758cc5, 0xff748ac4, 0xff738ac3, 0xff738ac3, 0xff748ac2, 0xff758bbf, 0xff768bbc, 0xff788bbb,
    0xff798abb, 0xff7a8abb, 0xff7a89bc, 0xff7989bc, 0xff7588bb, 0xff7287b9, 0xff7084b7, 0xff6e82b5,
    0xff6d82b4, 0xff6d83b3, 0xff6b82b2, 0xff6a80b2, 0xff697fb1, 0xff6980b0, 0xff6980b0, 0xff687faf,
    0xff677dae, 0xff677dae, 0xff677dae, 0xff667cad, 0xff657bac, 0xff6379aa, 0xff6177a8, 0xff6076a6,
    0xff5f75a4, 0xff5d73a1, 0xff5c729f, 0xff5b719d, 0xff59709b, 0xff596f9c, 0xff596f9c, 0xff5b719d,
    0xff5c729d, 0xff5a719c, 0xff586f9c, 0xff59709d, 0xff5c729f, 0xff5f74a1, 0xff6175a4, 0xff6074a3,
    0xff5e72a0, 0xff5d729e, 0xff6479a3, 0xff6b7fa9, 0xff6d80aa, 0xff6b7ca8, 0xff6a7ba7, 0xff6b7ca9,
    0xff6c7dac, 0xff6e7ead, 0xff6f7ead, 0xff6e7ea8, 0xff6d7da6, 0xff6a7caa, 0xff677bb3, 0xff657bb8,
    0xff577ab6, 0xff577ab6, 0xff587ab8, 0xff597bba, 0xff5a7cbb, 0xff5b7ebc, 0xff5b7fbe, 0xff5c7fc0,
    0xff5c7fc1, 0xff5d80c0, 0xff5e81bf, 0xff5f82c0, 0xff6083c1, 0xff6183c3, 0xff6184c5, 0xff6184c5,
    0xff6185c4, 0xff6187c6, 0xff6288c9, 0xff638acc, 0xff658cce, 0xff678ed0, 0xff6c93d6, 0xff7098dc,
    0xff709ce1, 0xff6e9ee5, 0xff6e9ee5, 0xff6f9ce1, 0xff719bdd, 0xff739adb, 0xff759cdd, 0xff7aa1e2,
    0xff7fa6e8, 0xff7fa8ec, 0xff7ea8ec, 0xff7fa7ea, 0xff82a7e5, 0xff84a5de, 0xff84a0d6, 0xff839cd1,
    0xff8198cc, 0xff7f95ca, 0xff7f95c9, 0xff7f96ca, 0xff7c96cc, 0xff7895ce, 0xff7494cf, 0xff7192ce,
    0xff7091cd, 0xff7091cd, 0xff7292cf, 0xff7393d0, 0xff7494d2, 0xff7696d5, 0xff7899d7, 0xff799ad9,
    0xff7899d9, 0xff7797d8, 0xff7796d8, 0xff7696d7, 0xff7595d6, 0xff7395d4, 0xff7193d1, 0xff7190ce,
    0xff7492ce, 0xff7c9ad6, 0xff84a3dd, 0xff8aa8e3, 0xff8daae6, 0xff89a7e4, 0xff81a1e0, 0xff7c9edf,
    0xff799ee1, 0xff799fe5, 0xff7aa2ea, 0xff7ba5ed, 0xff7ba7ef, 0xff7aa9ef, 0xff7aa9ee, 0xff7aa9ed,
    0xff7dacef, 0xff80b1f2, 0xff85b7f7, 0xff88befc, 0xff8bc2ff, 0xff8ec7ff, 0xff90c8ff, 0xff8fc6ff,
    0xff8dc2ff, 0xff8bbfff, 0xff8abefd, 0xff8abffd, 0xff8bc2fe, 0xff8cc4ff, 0xff8cc5ff, 0xff8cc4ff,
    0xff8cc4ff, 0xff8bc3ff, 0xff8abeff, 0xff89b7fe, 0xff8ab3fb, 0xff8fb2f5, 0xff92b1ef, 0xff90ace8,
    0xff8ca6e2, 0xff88a2df, 0xff85a0df, 0xff819edf, 0xff7f9ddf, 0xff7b9adc, 0xff7593d5, 0xff728ecf,
    0xff728dcb, 0xff748dc9, 0xff738cc7, 0xff728bc6, 0xff708ac4, 0xff6f89c4, 0xff6f89c3, 0xff6f88c2,
    0xff7088c1, 0xff7189be, 0xff7389bb, 0xff7488ba, 0xff7587bb, 0xff7587bb, 0xff7587bb, 0xff7487bb,
    0xff7087ba, 0xff6e86b9, 0xff6d84b8, 0xff6c82b6, 0xff6b82b6, 0xff6a82b5, 0xff6881b4, 0xff677fb3,
    0xff677eb2, 0xff677eb1, 0xff677eb0, 0xff667daf, 0xff657cae, 0xff657cae, 0xff667cad, 0xff667cac,
    0xff647aab, 0xff6379aa, 0xff6278a8, 0xff6177a6, 0xff6076a4, 0xff5e74a1, 0xff5d739f, 0xff5b719d,
    0xff5b719c, 0xff5b719c, 0xff5c719d, 0xff5c729d, 0xff5c729d, 0xff5b719d, 0xff5b719e, 0xff5c719f,
    0xff5d729f, 0xff5f74a1, 0xff6175a3, 0xff6075a2, 0xff5e729f, 0xff5d729d, 0xff6378a1, 0xff6a7ea7,
    0xff6c7fa9, 0xff6b7da8, 0xff6b7ca8, 0xff6c7ca9, 0xff6c7daa, 0xff6d7dac, 0xff6d7dac, 0xff6d7da8,
    0xff6b7ca4, 0xff697ba6, 0xff6779ab, 0xff6578ae, 0xff5779b8, 0xff5779b8, 0xff587ab9, 0xff597bba,
    0xff5a7cbb, 0xff5b7dbc, 0xff5c7ebe, 0xff5d7fc0, 0xff5d7fc0, 0xff5e80bf, 0xff5e80be, 0xff5d80be,
    0xff5d81bf, 0xff6083c1, 0xff6486c3, 0xff6487c3, 0xff6287c3, 0xff6087c5, 0xff6087c8, 0xff6088ca,
    0xff6189cb, 0xff638bcd, 0xff668fd1, 0xff6a93d7, 0xff6b97dd, 0xff6b9ae2, 0xff6c9ee6, 0xff6da0e7,
    0xff6fa1e8, 0xff71a0e8, 0xff73a1e9, 0xff78a5ed, 0xff7caaf1, 0xff7dadf5, 0xff7badf6, 0xff7badf4,
    0xff7dacf1, 0xff7da8ea, 0xff7aa0df, 0xff789ad7, 0xff7695d0, 0xff7592cc, 0xff7491ca, 0xff7391ca,
    0xff7391cc, 0xff7291ce, 0xff7291cf, 0xff7091cf, 0xff7092cf, 0xff7294d2, 0xff7496d5, 0xff7596d6,
    0xff7596d6, 0xff7697d7, 0xff7798d8, 0xff7899d9, 0xff7799d9, 0xff7698d9, 0xff7698da, 0xff7699db,
    0xff769adc, 0xff769adc, 0xff7699d9, 0xff7596d5, 0xff7796d4, 0xff7e9cd9, 0xff85a3df, 0xff8ca9e5,
    0xff90ade9, 0xff8eacea, 0xff88a9e8, 0xff81a6e9, 0xff7ca5ea, 0xff79a4eb, 0xff79a3ec, 0xff7aa2ea,
    0xff779fe6, 0xff749ce2, 0xff7199de, 0xff7198dc, 0xff739bdf, 0xff77a1e5, 0xff7dabee, 0xff83b7f9,
    0xff89c1ff, 0xff90caff, 0xff95cfff, 0xff95ceff, 0xff93c8ff, 0xff90c5ff, 0xff8ec4ff, 0xff8ec4ff,
    0xff8fc6ff, 0xff90c8ff, 0xff90c9ff, 0xff8fc8ff, 0xff8fc7ff, 0xff90c5ff, 0xff90bffe, 0xff8eb8fb,
    0xff90b4f7, 0xff95b4f3, 0xff98b4ef, 0xff96b0e9, 0xff92abe5, 0xff8fa8e2, 0xff8da6e1, 0xff88a2df,
    0xff829fde, 0xff7999da, 0xff6f8fd3, 0xff6989cd, 0xff6786ca, 0xff6987c8, 0xff6b87c7, 0xff6c88c5,
    0xff6c88c5, 0xff6b88c4, 0xff6b88c4, 0xff6c87c3, 0xff6d87c1, 0xff6e87be, 0xff6f87bb, 0xff6f86ba,
    0xff6f85ba, 0xff6f84ba, 0xff6e84ba, 0xff6d84ba, 0xff6c84b9, 0xff6b84b8, 0xff6a83b7, 0xff6982b7,
    0xff6881b7, 0xff6781b7, 0xff6780b5, 0xff667fb3, 0xff667eb2, 0xff667db1, 0xff667cb0, 0xff657baf,
    0xff637bad, 0xff637bac, 0xff637aab, 0xff637aab, 0xff6379ab, 0xff6378aa, 0xff6278a8, 0xff6177a6,
    0xff6076a4, 0xff5e74a2, 0xff5d739f, 0xff5c729d, 0xff5c729c, 0xff5e749e, 0xff5f749f, 0xff5e729e,
    0xff5d719d, 0xff5d729f, 0xff5e74a1, 0xff5e74a1, 0xff5e739f, 0xff5e739f, 0xff6075a1, 0xff6075a1,
    0xff5e739e, 0xff5e729d, 0xff6276a0, 0xff687ba5, 0xff6c7ea8, 0xff6d7ea9, 0xff6d7ea9, 0xff6c7ea9,
    0xff6b7da9, 0xff6b7caa, 0xff6b7caa, 0xff6b7ca7, 0xff697ba4, 0xff677aa3, 0xff6478a4, 0xff6277a4,
    0xff5678b8, 0xff5678b8, 0xff5779b8, 0xff587ab9, 0xff597bba, 0xff5b7cbc, 0xff5c7dbd, 0xff5d7ebe,
    0xff5d7ebe, 0xff5d7fbe, 0xff5d7fbe, 0xff5b7fbd, 0xff5b80bd, 0xff6083bf, 0xff6587c1, 0xff6788c1,
    0xff6487c1, 0xff6287c3, 0xff6087c6, 0xff5f87c8, 0xff6087c8, 0xff6288c9, 0xff638acc, 0xff658dd1,
    0xff6791d6, 0xff6995db, 0xff6b9be3, 0xff6da1e9, 0xff6fa4ee, 0xff71a5f0, 0xff73a5f1, 0xff76a8f3,
    0xff79acf6, 0xff7aaff8, 0xff79b1fa, 0xff79b2fb, 0xff79b1fa, 0xff78adf5, 0xff74a4ea, 0xff719ddf,
    0xff7097d8, 0xff7093d2, 0xff6f91d0, 0xff6d90cf, 0xff6d8fcf, 0xff6f8fce, 0xff708fcf, 0xff7091d0,
    0xff7193d2, 0xff7497d7, 0xff779adb, 0xff789adc, 0xff7799db, 0xff7798da, 0xff7798da, 0xff7799da,
    0xff779ada, 0xff789bdb, 0xff799cdd, 0xff7a9ee0, 0xff7ba0e2, 0xff7ca1e3, 0xff7da0e1, 0xff7d9edd,
    0xff7e9ddb, 0xff80a0dd, 0xff84a4e1, 0xff8ba9e6, 0xff90adea, 0xff8fadeb, 0xff8aabec, 0xff83a9ed,
    0xff7ca8ee, 0xff79a6ee, 0xff7aa3ec, 0xff7aa0e7, 0xff769ae0, 0xff7195d9, 0xff6e90d4, 0xff6e8ed2,
    0xff6f90d4, 0xff7195db, 0xff769fe5, 0xff7dacf5, 0xff85b9fe, 0xff8ec5ff, 0xff95cdff, 0xff96cdff,
    0xff93c8ff, 0xff90c4ff, 0xff8fc2ff, 0xff8ec2ff, 0xff8ec3ff, 0xff8fc5ff, 0xff8ec6ff, 0xff8ec6ff,
    0xff90c5ff, 0xff93c3fe, 0xff95befc, 0xff95b8f8, 0xff97b5f4, 0xff9bb5f0, 0xff9db5ed, 0xff9bb2e9,
    0xff98afe6, 0xff97ade5, 0xff96abe4, 0xff91a7e2, 0xff89a2df, 0xff7e9ada, 0xff7190d4, 0xff6a8acf,
    0xff6687cc, 0xff6687ca, 0xff6787c8, 0xff6887c7, 0xff6887c5, 0xff6887c5, 0xff6887c4, 0xff6986c2,
    0xff6a85c0, 0xff6b85be, 0xff6b84bc, 0xff6a83bb, 0xff6982ba, 0xff6781ba, 0xff6681b9, 0xff6681b9,
    0xff6681b8, 0xff6681b8, 0xff6681b7, 0xff6681b7, 0xff6580b7, 0xff647fb7, 0xff647db6, 0xff647db4,
    0xff647cb2, 0xff647ab1, 0xff6379b0, 0xff6279ae, 0xff607aac, 0xff607aab, 0xff6079a9, 0xff6078a9,
    0xff6277a9, 0xff6277a9, 0xff6177a8, 0xff6077a6, 0xff5f76a4, 0xff5e74a2, 0xff5d73a0, 0xff5d739d,
    0xff5e749d, 0xff60769f, 0xff6176a0, 0xff5f739f, 0xff5d719e, 0xff5f73a1, 0xff6176a3, 0xff6075a2,
    0xff5e739f, 0xff5d729e, 0xff5d749f, 0xff5e759f, 0xff5d739d, 0xff5e739d, 0xff6176a0, 0xff6579a3,
    0xff697ca7, 0xff6c7ea9, 0xff6d7ea9, 0xff6c7da8, 0xff6a7ca7, 0xff697ba7, 0xff697ba7, 0xff697ba6,
    0xff677aa4, 0xff6579a2, 0xff61779f, 0xff5f769d, 0xff5477b7, 0xff5477b7, 0xff5579b8, 0xff577ab9,
    0xff597bba, 0xff5b7cbc, 0xff5c7cbd, 0xff5c7dbd, 0xff5c7dbd, 0xff5c7ebe, 0xff5b7fbe, 0xff597fbd,
    0xff5980bd, 0xff5e82be, 0xff6385c0, 0xff6586c1, 0xff6587c1, 0xff6387c3, 0xff6186c5, 0xff6086c6,
    0xff6288c7, 0xff6489c8, 0xff6489ca, 0xff648acc, 0xff678dd0, 0xff6b92d4, 0xff6e98db, 0xff6f9de2,
    0xff6fa1e9, 0xff70a3ee, 0xff71a4f0, 0xff72a6f1, 0xff74a8f2, 0xff75aaf4, 0xff76acf6, 0xff77aff9,
    0xff77b1fb, 0xff77b1fb, 0xff75aef5, 0xff74a9ee, 0xff74a4e7, 0xff739fe2, 0xff729cdf, 0xff709ade,
    0xff7097d9, 0xff7194d4, 0xff7292d0, 0xff7292d2, 0xff7395d5, 0xff7699d9, 0xff799cdd, 0xff7a9cde,
    0xff799bde, 0xff799bde, 0xff789add, 0xff799bdd, 0xff7b9dde, 0xff7ea0e0, 0xff82a5e3, 0xff87a9e6,
    0xff89abe8, 0xff89aae8, 0xff89aae7, 0xff8aa8e5, 0xff88a7e3, 0xff85a4e2, 0xff84a4e3, 0xff88a6e5,
    0xff8ca9e8, 0xff8aa8e8, 0xff84a5e7, 0xff7ea3e7, 0xff79a2e8, 0xff77a2e8, 0xff7aa3e9, 0xff7da2e8,
    0xff7c9fe4, 0xff799ce0, 0xff7999dc, 0xff7897da, 0xff7796da, 0xff7595db, 0xff7498df, 0xff76a0e8,
    0xff7aa9ef, 0xff81b2f2, 0xff86b9f1, 0xff88b9f1, 0xff86b5f1, 0xff85b2f1, 0xff85b2f2, 0xff85b2f2,
    0xff86b3f2, 0xff87b5f2, 0xff87b7f3, 0xff88baf5, 0xff8dbcf7, 0xff93bdfa, 0xff99bdfa, 0xff9bbcf9,
    0xff9ebaf5, 0xff9fb7f0, 0xff9fb5ec, 0xff9cb2e9, 0xff99afe7, 0xff9ab0e7, 0xff9db1e7, 0xff9cb0e5,
    0xff97ade2, 0xff90a7de, 0xff87a0d9, 0xff809ad6, 0xff7a95d4, 0xff7592d2, 0xff6e8dcd, 0xff6788c9,
    0xff6385c6, 0xff6384c5, 0xff6484c4, 0xff6583c2, 0xff6683c0, 0xff6783be, 0xff6782bd, 0xff6681bc,
    0xff6480bb, 0xff627eba, 0xff617eb9, 0xff617eb9, 0xff627fb9, 0xff637fb8, 0xff637fb7, 0xff627eb6,
    0xff617db6, 0xff607db6, 0xff607cb5, 0xff5f7bb3, 0xff5f7ab1, 0xff5f78b0, 0xff5f77af, 0xff5e78ae,
    0xff5d79ad, 0xff5d78ac, 0xff5e77aa, 0xff5f76a9, 0xff6077a9, 0xff6077a9, 0xff5f77a8, 0xff5e76a6,
    0xff5d74a4, 0xff5d73a2, 0xff5d73a0, 0xff5d739e, 0xff5e759e, 0xff5f76a0, 0xff6076a1, 0xff5f73a0,
    0xff5e719f, 0xff6073a1, 0xff6176a3, 0xff6075a2, 0xff5d729e, 0xff5b719c, 0xff5c729c, 0xff5c739c,
    0xff5c729c, 0xff5d739d, 0xff60769f, 0xff6379a2, 0xff687ca5, 0xff6b7da8, 0xff6c7da8, 0xff6b7ca7,
    0xff697ba6, 0xff687aa5, 0xff687aa5, 0xff687aa5, 0xff677aa5, 0xff6579a4, 0xff6278a3, 0xff6077a2,
    0xff5377b5, 0xff5377b5, 0xff5579b7, 0xff577ab9, 0xff597bbb, 0xff5a7cbc, 0xff5a7cbc, 0xff5a7cbb,
    0xff5a7dbc, 0xff5a7ebd, 0xff5a7fbe, 0xff5880bd, 0xff5880bd, 0xff5b81bd, 0xff5f82bf, 0xff6384c0,
    0xff6685c2, 0xff6686c4, 0xff6386c4, 0xff6286c5, 0xff6689c7, 0xff688ac8, 0xff6689c9, 0xff6588ca,
    0xff698acb, 0xff708fcd, 0xff7394d2, 0xff7197d7, 0xff709adf, 0xff709ee6, 0xff71a1ea, 0xff71a1ea,
    0xff71a1e9, 0xff72a2ea, 0xff73a5ed, 0xff75a9f2, 0xff77aef9, 0xff79b2fd, 0xff7bb6fc, 0xff7cb5f9,
    0xff7cb1f5, 0xff7aabf0, 0xff79a8ed, 0xff79a6eb, 0xff77a1e3, 0xff759ada, 0xff7495d3, 0xff7496d4,
    0xff7698d7, 0xff789ad9, 0xff7a9cdc, 0xff7b9dde, 0xff7c9fe0, 0xff7c9fe0, 0xff7a9edf, 0xff7b9edf,
    0xff7fa1e2, 0xff84a5e5, 0xff8cabe7, 0xff92b1e9, 0xff95b2ea, 0xff94b0ea, 0xff93afea, 0xff93afe9,
    0xff90ade8, 0xff89a7e5, 0xff84a3e3, 0xff84a3e4, 0xff85a3e5, 0xff82a0e3, 0xff7d9cde, 0xff789adc,
    0xff759adc, 0xff759ddf, 0xff7ba1e5, 0xff80a5ea, 0xff83a7eb, 0xff84a7ea, 0xff85a8ea, 0xff86a8e9,
    0xff82a3e6, 0xff7b9ce0, 0xff7596dd, 0xff7195dd, 0xff7198df, 0xff739de0, 0xff76a2e1, 0xff77a2e1,
    0xff77a0e1, 0xff779fe1, 0xff799ee2, 0xff7a9fe3, 0xff7ba1e2, 0xff7ca3e3, 0xff7da6e5, 0xff81aae9,
    0xff88afee, 0xff90b4f4, 0xff99baf8, 0xff9fbefa, 0xffa1bef7, 0xffa0b8f0, 0xff9db2ea, 0xff99aee7,
    0xff98ade6, 0xff9aafe6, 0xff9fb4e7, 0xffa2b6e7, 0xffa3b5e6, 0xffa2b3e4, 0xff9fb0e1, 0xff99acdf,
    0xff92a7dd, 0xff87a0d9, 0xff7995d2, 0xff6b8acb, 0xff6283c6, 0xff6182c5, 0xff6282c4, 0xff6282c1,
    0xff6382c0, 0xff6482c0, 0xff6481bf, 0xff6380bd, 0xff617fbb, 0xff5f7db9, 0xff5e7cb8, 0xff5e7cb8,
    0xff5f7db9, 0xff607db9, 0xff5f7db7, 0xff5e7cb5, 0xff5e7bb4, 0xff5d7bb4, 0xff5d79b2, 0xff5c78b0,
    0xff5b77af, 0xff5b76af, 0xff5b76af, 0xff5b77ae, 0xff5b77ad, 0xff5b76ac, 0xff5c75ab, 0xff5c75aa,
    0xff5d76a9, 0xff5d76a9, 0xff5d76a8, 0xff5c75a6, 0xff5b73a4, 0xff5b72a2, 0xff5b72a1, 0xff5c73a0,
    0xff5c75a0, 0xff5d76a1, 0xff5e76a1, 0xff5e74a0, 0xff5e72a0, 0xff5f73a1, 0xff6074a1, 0xff5f73a0,
    0xff5d729d, 0xff5b719b, 0xff5a719a, 0xff5a719a, 0xff5a719b, 0xff5c739d, 0xff5f769f, 0xff627aa2,
    0xff667ca4, 0xff687ca6, 0xff697ca7, 0xff697ba6, 0xff687aa5, 0xff6879a4, 0xff6879a4, 0xff6879a4,
    0xff6779a5, 0xff6679a6, 0xff6478a7, 0xff6378a8, 0xff5276b3, 0xff5276b3, 0xff5478b5, 0xff567ab8,
    0xff587bba, 0xff597cbb, 0xff597cbb, 0xff587cba, 0xff587dba, 0xff597ebc, 0xff597fbd, 0xff5880be,
    0xff5880be, 0xff597fbe, 0xff5b7fbf, 0xff5f81c0, 0xff6484c2, 0xff6585c3, 0xff6485c4, 0xff6386c4,
    0xff6889c7, 0xff6a8bc8, 0xff6889c8, 0xff6687c8, 0xff6a89c7, 0xff728dc7, 0xff7490c9, 0xff7290ce,
    0xff6f93d5, 0xff6f99dd, 0xff6f9de2, 0xff6e9ce2, 0xff6f9ae0, 0xff709be1, 0xff739fe5, 0xff77a5ec,
    0xff7aacf4, 0xff7eb3fb, 0xff81baff, 0xff82bcfe, 0xff82b9fb, 0xff80b2f7, 0xff80aff5, 0xff7faef3,
    0xff7ca7e9, 0xff799edd, 0xff7798d5, 0xff7797d6, 0xff7899d9, 0xff7999d9, 0xff7a9bda, 0xff7b9ddc,
    0xff7da0e0, 0xff7ea1e2, 0xff7ea1e1, 0xff7fa1e1, 0xff83a3e4, 0xff89a7e6, 0xff92aee8, 0xff99b4e9,
    0xff9bb4e9, 0xff99b0e9, 0xff97afe9, 0xff97b1ea, 0xff93afe9, 0xff89a7e4, 0xff82a1e1, 0xff809fe1,
    0xff7f9de0, 0xff7b99dc, 0xff7594d7, 0xff7192d3, 0xff7193d2, 0xff7397d6, 0xff7a9ee0, 0xff80a5e8,
    0xff87abee, 0xff8caff1, 0xff8fb2f3, 0xff8fb3f3, 0xff8aaced, 0xff80a1e4, 0xff7696da, 0xff6e8ed3,
    0xff6a8bd1, 0xff698bd1, 0xff6a8dd3, 0xff6b8ed3, 0xff6b8ed3, 0xff6d8ed4, 0xff7090d5, 0xff7291d6,
    0xff7392d5, 0xff7494d6, 0xff7697d9, 0xff7b9dde, 0xff83a4e5, 0xff8cabec, 0xff96b4f2, 0xff9dbbf5,
    0xffa0bcf3, 0xff9db5ec, 0xff99aee6, 0xff95a9e3, 0xff94a8e3, 0xff98ace4, 0xff9eb1e5, 0xffa4b6e6,
    0xffa9b7e6, 0xffacb9e6, 0xffadbae6, 0xffa9b8e4, 0xffa2b4e2, 0xff95aade, 0xff839dd7, 0xff718fce,
    0xff6585c7, 0xff6382c6, 0xff6382c5, 0xff6281c2, 0xff6281c1, 0xff6281c1, 0xff6180c0, 0xff607fbe,
    0xff5f7eba, 0xff5d7cb8, 0xff5c7bb8, 0xff5c7ab8, 0xff5d7bb8, 0xff5e7bb8, 0xff5d7ab6, 0xff5b79b4,
    0xff5b79b3, 0xff5a78b2, 0xff5977b0, 0xff5876ae, 0xff5775ad, 0xff5775ad, 0xff5875ad, 0xff5875ad,
    0xff5975ad, 0xff5974ac, 0xff5a73aa, 0xff5a73a9, 0xff5a74a8, 0xff5a75a8, 0xff5974a6, 0xff5973a5,
    0xff5972a4, 0xff5971a2, 0xff5a71a1, 0xff5b72a0, 0xff5b73a0, 0xff5c74a0, 0xff5c74a0, 0xff5d73a0,
    0xff5e72a0, 0xff5e729f, 0xff5d729e, 0xff5c719d, 0xff5c709c, 0xff5a709a, 0xff597099, 0xff597099,
    0xff59709a, 0xff5b729c, 0xff5e759e, 0xff6179a1, 0xff647aa3, 0xff6679a4, 0xff6679a4, 0xff6578a4,
    0xff6578a3, 0xff6677a2, 0xff6677a2, 0xff6677a1, 0xff6476a1, 0xff6275a1, 0xff6074a2, 0xff5e74a2,
    0xff5175b2, 0xff5175b2, 0xff5377b4, 0xff5579b7, 0xff577ab9, 0xff587bba, 0xff587bba, 0xff577cba,
    0xff577dbb, 0xff587ebc, 0xff587fbd, 0xff5880be, 0xff5880be, 0xff587fbe, 0xff5a7ebe, 0xff5c7fbf,
    0xff6082c1, 0xff6284c2, 0xff6283c3, 0xff6284c3, 0xff6587c5, 0xff6789c6, 0xff6688c7, 0xff6586c7,
    0xff6888c6, 0xff6d8bc5, 0xff6e8cc7, 0xff6c8bca, 0xff6b8dcf, 0xff6b93d7, 0xff6c98dc, 0xff6d98dc,
    0xff6e98db, 0xff729bde, 0xff76a1e4, 0xff7aa7ec, 0xff7cacf4, 0xff7fb1f9, 0xff81b6fb, 0xff81b6f9,
    0xff7fb2f5, 0xff7cacf1, 0xff7ca9ef, 0xff7da9ee, 0xff7ca4e7, 0xff799ede, 0xff7799d7, 0xff7798d8,
    0xff7899da, 0xff7899d9, 0xff799bda, 0xff7b9ddc, 0xff7ea0e0, 0xff80a3e3, 0xff81a4e4, 0xff83a5e4,
    0xff86a5e3, 0xff89a6e2, 0xff8fabe3, 0xff94afe4, 0xff94aee4, 0xff92aae3, 0xff91a9e4, 0xff91abe5,
    0xff8eaae5, 0xff86a3e1, 0xff7f9ddd, 0xff7b9bdc, 0xff7999da, 0xff7696d7, 0xff7291d3, 0xff708fcf,
    0xff6f8fce, 0xff7192d1, 0xff7699d9, 0xff7b9fe0, 0xff81a4e6, 0xff86a8ea, 0xff8aabed, 0xff8badee,
    0xff87a8e9, 0xff809ee0, 0xff7693d6, 0xff6c8ace, 0xff6686ca, 0xff6484c9, 0xff6585cb, 0xff6685cb,
    0xff6886cb, 0xff6b88cc, 0xff6f8ace, 0xff728ccf, 0xff738dcf, 0xff738fd0, 0xff7492d3, 0xff7896d7,
    0xff7e9bdc, 0xff84a1e1, 0xff8ca8e6, 0xff91aeea, 0xff95b0ea, 0xff94ace5, 0xff92a7e1, 0xff8fa4df,
    0xff8ea4df, 0xff90a7e0, 0xff96abe1, 0xff9cafe2, 0xffa0b1e3, 0xffa4b3e3, 0xffa8b6e4, 0xffa6b5e3,
    0xffa1b2e1, 0xff97aadd, 0xff8aa0d7, 0xff7d95d1, 0xff728ccb, 0xff6c88c9, 0xff6885c6, 0xff6583c4,
    0xff6382c2, 0xff6080c1, 0xff5e7ec0, 0xff5d7dbd, 0xff5c7cba, 0xff5a7ab7, 0xff5979b7, 0xff5978b7,
    0xff5a78b7, 0xff5a78b6, 0xff5a78b4, 0xff5977b2, 0xff5977b1, 0xff5876b1, 0xff5776af, 0xff5675ac,
    0xff5574ab, 0xff5573ab, 0xff5673ab, 0xff5672ab, 0xff5772ab, 0xff5772aa, 0xff5872a8, 0xff5872a7,
    0xff5872a6, 0xff5872a6, 0xff5772a4, 0xff5772a3, 0xff5771a2, 0xff5870a1, 0xff5970a0, 0xff5a72a0,
    0xff5a729e, 0xff5b729d, 0xff5b729d, 0xff5c729f, 0xff5d71a0, 0xff5c709e, 0xff5b709b, 0xff5a709b,
    0xff5a709d, 0xff5a709e, 0xff5a719e, 0xff5a729d, 0xff5a729b, 0xff5b729b, 0xff5e749d, 0xff61779f,
    0xff6377a0, 0xff6476a0, 0xff6476a0, 0xff63769f, 0xff62769f, 0xff6376a0, 0xff63759f, 0xff62739c,
    0xff5f7097, 0xff5a6e91, 0xff566d8b, 0xff536c88, 0xff5175b1, 0xff5175b1, 0xff5377b3, 0xff5578b5,
    0xff5679b7, 0xff577ab8, 0xff577bb9, 0xff577cba, 0xff577dbb, 0xff577ebb, 0xff577ebc, 0xff587fbd,
    0xff5980be, 0xff597fbe, 0xff597fbe, 0xff5a80bf, 0xff5c81c0, 0xff5e82c1, 0xff6082c2, 0xff6182c2,
    0xff6384c3, 0xff6385c4, 0xff6385c6, 0xff6386c7, 0xff6487c7, 0xff6688c7, 0xff6789c8, 0xff6789ca,
    0xff678bce, 0xff6790d5, 0xff6994d9, 0xff6b96d9, 0xff6f98da, 0xff749dde, 0xff7aa4e6, 0xff7eaaee,
    0xff7eaef3, 0xff7eb0f6, 0xff7eaff4, 0xff7cabef, 0xff79a5e9, 0xff76a0e4, 0xff769ee2, 0xff789ee2,
    0xff789ddf, 0xff779bdb, 0xff7699d9, 0xff7698d9, 0xff7799da, 0xff7699d9, 0xff779ada, 0xff799cdc,
    0xff7d9fdf, 0xff81a3e3, 0xff84a7e5, 0xff86a8e5, 0xff86a5e0, 0xff86a2dc, 0xff87a3dc, 0xff88a5dd,
    0xff87a4dd, 0xff86a1dc, 0xff85a0dd, 0xff86a3de, 0xff85a3de, 0xff809ddb, 0xff7c99d8, 0xff7998d7,
    0xff7798d6, 0xff7596d4, 0xff7292d2, 0xff7090d0, 0xff6f8fcf, 0xff7090d0, 0xff7294d4, 0xff7597d7,
    0xff7a9ada, 0xff7e9ddd, 0xff809fdf, 0xff80a0e0, 0xff7e9ddd, 0xff7b98d9, 0xff7692d3, 0xff6c8bce,
    0xff6788cb, 0xff6686ca, 0xff6887ca, 0xff6a87ca, 0xff6c88ca, 0xff708acc, 0xff748ece, 0xff7690d0,
    0xff7791d0, 0xff7792d1, 0xff7793d3, 0xff7996d6, 0xff7b98d7, 0xff7f9ad8, 0xff839eda, 0xff85a1dd,
    0xff88a2de, 0xff8ba1de, 0xff8ca0dd, 0xff8aa0db, 0xff88a1da, 0xff8aa2da, 0xff8da3db, 0xff90a5dc,
    0xff92a6dd, 0xff94a8dd, 0xff96aade, 0xff96aade, 0xff93a7db, 0xff8da2d8, 0xff899ed5, 0xff859ad4,
    0xff7e94d0, 0xff758fcc, 0xff6e8ac8, 0xff6886c6, 0xff6583c4, 0xff607fc2, 0xff5c7cc0, 0xff5b7abc,
    0xff5a79b8, 0xff5978b5, 0xff5978b5, 0xff5877b5, 0xff5876b4, 0xff5876b3, 0xff5876b2, 0xff5876b1,
    0xff5876b1, 0xff5876b1, 0xff5776af, 0xff5675ac, 0xff5574aa, 0xff5573aa, 0xff5672aa, 0xff5670a9,
    0xff556fa8, 0xff556fa7, 0xff5671a5, 0xff5671a4, 0xff5770a4, 0xff5770a4, 0xff5670a2, 0xff5670a1,
    0xff566fa1, 0xff576fa0, 0xff586f9f, 0xff59709e, 0xff59709c, 0xff5a719a, 0xff5a719a, 0xff5b719d,
    0xff5b709f, 0xff5a6f9c, 0xff596f99, 0xff596f9b, 0xff5a6f9e, 0xff5b71a1, 0xff5c73a1, 0xff5c74a0,
    0xff5b739c, 0xff5b729a, 0xff5d739b, 0xff60759d, 0xff61759d, 0xff62749c, 0xff62749c, 0xff60749b,
    0xff5f749c, 0xff60759d, 0xff60749c, 0xff5d7097, 0xff586b8e, 0xff516680, 0xff4a6372, 0xff45616a,
    0xff5074b0, 0xff5074b0, 0xff5276b2, 0xff5477b3, 0xff5578b4, 0xff5679b6, 0xff577bb8, 0xff577cb9,
    0xff577dba, 0xff577dbb, 0xff577dbb, 0xff587ebd, 0xff597fbe, 0xff597fbe, 0xff597fbe, 0xff597fbf,
    0xff5980c0, 0xff5b80c0, 0xff5d81c1, 0xff5f81c1, 0xff5f81c1, 0xff5f82c2, 0xff6084c4, 0xff6186c7,
    0xff6187c8, 0xff6087c8, 0xff6087ca, 0xff6287cb, 0xff6388ce, 0xff648cd2, 0xff6790d5, 0xff6b93d6,
    0xff7198d8, 0xff779fde, 0xff7da6e6, 0xff81aced, 0xff81adf1, 0xff80acf0, 0xff7da7eb, 0xff7aa1e4,
    0xff769bdd, 0xff7296d7, 0xff7295d6, 0xff7395d6, 0xff7496d7, 0xff7597d8, 0xff7597d8, 0xff7697d8,
    0xff7697d8, 0xff7597d8, 0xff7598d8, 0xff7799d9, 0xff7b9cdc, 0xff80a1df, 0xff84a6e2, 0xff86a7e2,
    0xff85a3db, 0xff829ed6, 0xff7f9cd4, 0xff7d9bd5, 0xff7c9ad5, 0xff7b98d5, 0xff7b98d5, 0xff7d9ad6,
    0xff7d9ad6, 0xff7c97d4, 0xff7a95d2, 0xff7995d2, 0xff7796d2, 0xff7695d2, 0xff7594d1, 0xff7392d1,
    0xff7391d0, 0xff7290d0, 0xff718fcf, 0xff7190cf, 0xff7391d0, 0xff7793d1, 0xff7894d2, 0xff7995d4,
    0xff7995d4, 0xff7994d2, 0xff7692d0, 0xff7190cf, 0xff6e8ece, 0xff6d8ccc, 0xff6f8ccb, 0xff728dcb,
    0xff758fcc, 0xff7991ce, 0xff7c94d0, 0xff7d96d1, 0xff7d97d2, 0xff7c97d3, 0xff7c97d5, 0xff7b96d5,
    0xff7a95d3, 0xff7994d1, 0xff7994d0, 0xff7a95d2, 0xff7d96d4, 0xff8298d7, 0xff859ad7, 0xff849cd6,
    0xff829cd4, 0xff839cd4, 0xff859ad4, 0xff859ad5, 0xff849ad6, 0xff839bd7, 0xff849dd8, 0xff849dd7,
    0xff829bd5, 0xff8198d2, 0xff8499d2, 0xff879ad3, 0xff8397d1, 0xff7a93cc, 0xff718dc8, 0xff6a88c6,
    0xff6684c4, 0xff6080c1, 0xff5c7cbf, 0xff5a7abb, 0xff5a79b7, 0xff5a79b5, 0xff5978b5, 0xff5978b5,
    0xff5776b3, 0xff5775b2, 0xff5876b2, 0xff5a77b2, 0xff5a77b2, 0xff5a76b2, 0xff5876af, 0xff5775ac,
    0xff5674a9, 0xff5672a8, 0xff5671a8, 0xff556fa7, 0xff536da5, 0xff536ea3, 0xff5470a2, 0xff5470a1,
    0xff556ea1, 0xff556da1, 0xff556ea0, 0xff556f9f, 0xff556f9f, 0xff566e9f, 0xff566e9e, 0xff576e9c,
    0xff576e9a, 0xff586f99, 0xff596f98, 0xff596f98, 0xff596e99, 0xff586e99, 0xff576e99, 0xff576e9b,
    0xff576e9d, 0xff59709f, 0xff5b729e, 0xff5c739d, 0xff5c729a, 0xff5b7198, 0xff5c7199, 0xff5e729a,
    0xff5f729a, 0xff5f7199, 0xff5e7198, 0xff5c7197, 0xff5b7198, 0xff5c729a, 0xff5b7199, 0xff586d93,
    0xff516685, 0xff465d6f, 0xff3b5658, 0xff35514b, 0xff4f72af, 0xff4f72af, 0xff5174b1, 0xff5376b2,
    0xff5477b3, 0xff5478b4, 0xff557ab6, 0xff567bb8, 0xff567cba, 0xff577cba, 0xff577cba, 0xff587dbd,
    0xff597ebe, 0xff5a7fbe, 0xff5a7fbe, 0xff5a7fbe, 0xff5a7fbf, 0xff5b7fbf, 0xff5d80c0, 0xff5e80c0,
    0xff5e80c1, 0xff5e81c2, 0xff5f83c4, 0xff6085c6, 0xff6086c8, 0xff6086c9, 0xff6086cb, 0xff6186cb,
    0xff6287cc, 0xff648ace, 0xff678dd0, 0xff6c91d2, 0xff7296d5, 0xff789cdb, 0xff7da2e0, 0xff81a8e5,
    0xff84aae8, 0xff84a9e7, 0xff82a4e3, 0xff7e9edd, 0xff7998d7, 0xff7494d1, 0xff7392cf, 0xff7392cf,
    0xff7392d1, 0xff7494d3, 0xff7495d4, 0xff7595d4, 0xff7595d4, 0xff7595d4, 0xff7596d4, 0xff7697d4,
    0xff7899d5, 0xff7c9cd7, 0xff81a0da, 0xff83a1da, 0xff809cd4, 0xff7c97cf, 0xff7994cd, 0xff7793cd,
    0xff7692cd, 0xff7792ce, 0xff7792ce, 0xff7893cf, 0xff7994cf, 0xff7a93ce, 0xff7a93ce, 0xff7993ce,
    0xff7894cf, 0xff7894d0, 0xff7794d0, 0xff7794d0, 0xff7793d0, 0xff7592cf, 0xff728ecb, 0xff718dc9,
    0xff728ec8, 0xff7590ca, 0xff7891cc, 0xff7a92ce, 0xff7a92cf, 0xff7992ce, 0xff7994ce, 0xff7d98d1,
    0xff7f99d2, 0xff7c96d0, 0xff7a92cd, 0xff7d94ce, 0xff8298d1, 0xff869bd3, 0xff869cd4, 0xff869cd4,
    0xff859cd5, 0xff839bd5, 0xff8199d5, 0xff7f97d3, 0xff7b93d0, 0xff7791cd, 0xff758fcb, 0xff7690cc,
    0xff7991cd, 0xff7e94d1, 0xff8196d2, 0xff8197d1, 0xff7e97ce, 0xff7e96cd, 0xff7e94ce, 0xff7e93cf,
    0xff7d94d0, 0xff7a94d1, 0xff7692d1, 0xff7490d0, 0xff738fcf, 0xff738fcd, 0xff7890cd, 0xff7c92ce,
    0xff7a91cc, 0xff738ec9, 0xff6c89c6, 0xff6785c4, 0xff6482c3, 0xff607fc1, 0xff5d7dbf, 0xff5c7cbb,
    0xff5c7ab8, 0xff5c7ab6, 0xff5b79b6, 0xff5b79b6, 0xff5a77b4, 0xff5a77b4, 0xff5c79b6, 0xff5e7bb7,
    0xff5f7bb6, 0xff5e79b4, 0xff5c77b0, 0xff5876ad, 0xff5675aa, 0xff5572a8, 0xff5470a7, 0xff526da5,
    0xff516ca3, 0xff516ca1, 0xff526ea0, 0xff526e9e, 0xff526c9e, 0xff526b9e, 0xff536d9e, 0xff546e9e,
    0xff556e9e, 0xff556e9e, 0xff556e9d, 0xff556d9c, 0xff556d9b, 0xff566d9b, 0xff576d97, 0xff576b90,
    0xff576b8c, 0xff586e95, 0xff58709f, 0xff566e9d, 0xff546b93, 0xff546a8d, 0xff576c8c, 0xff596e8e,
    0xff5a6f93, 0xff5a7097, 0xff5b7099, 0xff5c7098, 0xff5d7098, 0xff5c6f97, 0xff5b6f95, 0xff596f94,
    0xff586f95, 0xff597098, 0xff576e96, 0xff53698e, 0xff4b607c, 0xff3b5360, 0xff2c4545, 0xff233d35,
    0xff4e71af, 0xff4e71af, 0xff5072b0, 0xff5274b1, 0xff5376b2, 0xff5378b3, 0xff5479b4, 0xff547bb6,
    0xff567bb8, 0xff577bb8, 0xff587bb9, 0xff587dbc, 0xff587ebd, 0xff597fbe, 0xff5b7fbe, 0xff5c7fbe,
    0xff5c7ebf, 0xff5c7ebf, 0xff5d7fc0, 0xff5e80c0, 0xff5e80c1, 0xff5e81c2, 0xff5f82c4, 0xff6084c6,
    0xff6185c8, 0xff6286c9, 0xff6286ca, 0xff6287ca, 0xff6288ca, 0xff6489ca, 0xff678bcc, 0xff6c90cf,
    0xff7295d2, 0xff779ad6, 0xff7b9dd9, 0xff81a2dd, 0xff86a5df, 0xff89a6df, 0xff88a3dd, 0xff849fd9,
    0xff809cd5, 0xff7b98d2, 0xff7796cf, 0xff7594cd, 0xff7393cd, 0xff7393ce, 0xff7393cf, 0xff7392d0,
    0xff7492d0, 0xff7593d0, 0xff7694cf, 0xff7695cf, 0xff7695cf, 0xff7997d0, 0xff7c99d2, 0xff7e99d2,
    0xff7c95ce, 0xff7992cb, 0xff7890ca, 0xff7790ca, 0xff7790ca, 0xff7791cb, 0xff7791cb, 0xff7792cc,
    0xff7892cc, 0xff7a92cc, 0xff7b92cc, 0xff7b92cc, 0xff7a93cd, 0xff7a93cd, 0xff7a94ce, 0xff7b95ce,
    0xff7c96cf, 0xff7a94cd, 0xff7690c9, 0xff738dc7, 0xff748ec7, 0xff7891c9, 0xff7c94cc, 0xff7f95ce,
    0xff7e95cf, 0xff7a93ce, 0xff7d95cf, 0xff899ed3, 0xff90a3d5, 0xff8b9ed3, 0xff8499d0, 0xff869bd1,
    0xff8da1d5, 0xff90a4d7, 0xff8ea2d7, 0xff8ca0d6, 0xff8a9fd6, 0xff889ed5, 0xff859bd4, 0xff8297d2,
    0xff7c93d0, 0xff7690cd, 0xff758fcb, 0xff7790cb, 0xff7b92cc, 0xff7e94ce, 0xff7f94cf, 0xff7f94cd,
    0xff7d93ca, 0xff7c92c9, 0xff7b90ca, 0xff7a90cb, 0xff7a91cc, 0xff7791cd, 0xff708ccc, 0xff6b89cb,
    0xff6988ca, 0xff6a88c9, 0xff6b88c8, 0xff6c88c8, 0xff6b87c6, 0xff6986c4, 0xff6684c2, 0xff6381c1,
    0xff6280c1, 0xff607fc1, 0xff5f7ebf, 0xff5f7dbd, 0xff5f7cb9, 0xff5f7cb7, 0xff5e7cb8, 0xff5e7cb8,
    0xff5d7bb8, 0xff5d7bb8, 0xff607dba, 0xff637fbb, 0xff647eba, 0xff637cb6, 0xff5f79b2, 0xff5a78ae,
    0xff5575aa, 0xff5372a8, 0xff526fa6, 0xff516da4, 0xff506ca2, 0xff506ca0, 0xff516c9f, 0xff516c9d,
    0xff506b9c, 0xff506b9c, 0xff526b9d, 0xff536c9e, 0xff546d9e, 0xff556e9e, 0xff556e9d, 0xff546c9b,
    0xff546c9c, 0xff556d9f, 0xff556d99, 0xff556a88, 0xff556980, 0xff586d92, 0xff5971a5, 0xff576e9f,
    0xff526889, 0xff51657b, 0xff526678, 0xff54697e, 0xff566d8a, 0xff587096, 0xff5a7099, 0xff5b6f97,
    0xff5b6f96, 0xff5a6e95, 0xff586e94, 0xff566d93, 0xff556d93, 0xff556e96, 0xff536c95, 0xff50688b,
    0xff475e78, 0xff354b5b, 0xff22373d, 0xff172c2b, 0xff4d6fad, 0xff4d6fad, 0xff4f71ae, 0xff5173af,
    0xff5275b0, 0xff5277b2, 0xff5278b3, 0xff5379b3, 0xff5579b5, 0xff5779b6, 0xff587ab7, 0xff577cba,
    0xff577dbc, 0xff597ebd, 0xff5b7ebe, 0xff5c7ebe, 0xff5d7ebe, 0xff5d7ebe, 0xff5d7ebe, 0xff5d7fbf,
    0xff5d80c0, 0xff5e81c1, 0xff5f82c2, 0xff6083c4, 0xff6284c6, 0xff6384c8, 0xff6486ca, 0xff6387c9,
    0xff6388c9, 0xff6588c8, 0xff688ac9, 0xff6c8ecb, 0xff7192ce, 0xff7595d1, 0xff7997d2, 0xff809bd4,
    0xff87a0d6, 0xff8ca3d7, 0xff8da4d8, 0xff8aa2d7, 0xff869fd5, 0xff809cd3, 0xff7b99d0, 0xff7897cd,
    0xff7695cb, 0xff7493cb, 0xff7492cb, 0xff7391cc, 0xff7491cc, 0xff7692cc, 0xff7793cb, 0xff7693cb,
    0xff7592ca, 0xff7692ca, 0xff7893cb, 0xff7a93cb, 0xff7992cb, 0xff7891cb, 0xff7890ca, 0xff7890c9,
    0xff7890c9, 0xff7891c9, 0xff7891c9, 0xff7891ca, 0xff7991ca, 0xff7a92ca, 0xff7b92ca, 0xff7c92ca,
    0xff7c92cb, 0xff7c92cc, 0xff7c93cd, 0xff7d95cd, 0xff7f97ce, 0xff7f97cd, 0xff7a92ca, 0xff7890c8,
    0xff7991c8, 0xff7d94c9, 0xff8197cc, 0xff8498cf, 0xff8297d0, 0xff7d95cd, 0xff8097ce, 0xff90a2d3,
    0xff99a8d6, 0xff94a4d4, 0xff8b9ed1, 0xff8da1d3, 0xff96a8d8, 0xff98aada, 0xff94a6d9, 0xff90a2d7,
    0xff8da0d5, 0xff8a9fd4, 0xff879bd2, 0xff8397d0, 0xff7c92ce, 0xff7690cd, 0xff758fcb, 0xff7991cb,
    0xff7c93cb, 0xff7d93cb, 0xff7c92cb, 0xff7b91c9, 0xff7a8fc6, 0xff798ec5, 0xff788dc5, 0xff778dc6,
    0xff788fc7, 0xff758dc8, 0xff6c88c8, 0xff6584c7, 0xff6283c7, 0xff6283c6, 0xff6182c4, 0xff6081c2,
    0xff6080c0, 0xff607fbf, 0xff607fbf, 0xff617fbf, 0xff617fbf, 0xff6180c0, 0xff6281c0, 0xff6381be,
    0xff6380bb, 0xff637fb9, 0xff637eba, 0xff627eba, 0xff617eba, 0xff617eba, 0xff6380bc, 0xff6581bd,
    0xff6680bb, 0xff657eb7, 0xff617bb2, 0xff5b78af, 0xff5675ab, 0xff5371a8, 0xff526fa6, 0xff516ea4,
    0xff506da2, 0xff506ca0, 0xff506b9e, 0xff506b9c, 0xff4f6b9a, 0xff4f6b9a, 0xff506b9c, 0xff526b9d,
    0xff546d9d, 0xff556e9c, 0xff556d9c, 0xff536c9b, 0xff536b9d, 0xff546ca0, 0xff546b98, 0xff526782,
    0xff526575, 0xff556b8b, 0xff5870a3, 0xff566d9c, 0xff516682, 0xff4e616d, 0xff4d5f65, 0xff4e616b,
    0xff51677e, 0xff556e94, 0xff586f98, 0xff596e96, 0xff596d95, 0xff576c94, 0xff556c92, 0xff536b91,
    0xff526a91, 0xff526b93, 0xff516a92, 0xff4f688a, 0xff465f78, 0xff314758, 0xff192c36, 0xff0b1c21,
    0xff4b6eaa, 0xff4b6eaa, 0xff4d70ab, 0xff4f72ad, 0xff5174af, 0xff5276b1, 0xff5277b1, 0xff5377b1,
    0xff5477b2, 0xff5678b3, 0xff5779b6, 0xff567bb9, 0xff567cbb, 0xff587dbc, 0xff5a7dbd, 0xff5b7dbe,
    0xff5c7dbe, 0xff5c7dbe, 0xff5c7dbe, 0xff5c7ebe, 0xff5c7fbe, 0xff5c80bf, 0xff5d80c0, 0xff5f81c2,
    0xff6182c4, 0xff6283c6, 0xff6385c8, 0xff6386c8, 0xff6387c8, 0xff6588c7, 0xff6889c7, 0xff6c8cc9,
    0xff7090cc, 0xff7593cd, 0xff7a95cd, 0xff8199cf, 0xff889dd1, 0xff8da1d3, 0xff8fa4d5, 0xff8ea4d5,
    0xff8ba2d5, 0xff869fd3, 0xff829cd1, 0xff809acf, 0xff7c98cd, 0xff7995cc, 0xff7694cb, 0xff7592cb,
    0xff7592cb, 0xff7692cb, 0xff7893ca, 0xff7792c9, 0xff7591c9, 0xff7691c9, 0xff7892ca, 0xff7a93cc,
    0xff7b95cf, 0xff7a96d0, 0xff7a95ce, 0xff7992cc, 0xff7791c9, 0xff7590c8, 0xff7590c8, 0xff7791c9,
    0xff7891c9, 0xff7891c8, 0xff7891c8, 0xff7991c8, 0xff7b91c9, 0xff7c92ca, 0xff7c93cb, 0xff7e95cb,
    0xff8097cc, 0xff8198cc, 0xff8198cb, 0xff8197cb, 0xff8298cb, 0xff8599cc, 0xff879ace, 0xff899bd0,
    0xff879acf, 0xff8397cd, 0xff8398cc, 0xff8d9fd0, 0xff93a3d2, 0xff90a1d1, 0xff8b9ed0, 0xff90a2d3,
    0xff98a9d8, 0xff9aabd9, 0xff96a6d7, 0xff90a1d5, 0xff8c9fd3, 0xff899dd1, 0xff859ad0, 0xff8196ce,
    0xff7a91cc, 0xff748eca, 0xff738dc8, 0xff768fc7, 0xff7990c7, 0xff7890c7, 0xff778fc7, 0xff778dc5,
    0xff768bc3, 0xff758ac2, 0xff7488c1, 0xff7388c1, 0xff7389c1, 0xff7089c2, 0xff6985c4, 0xff6382c5,
    0xff6081c5, 0xff6081c4, 0xff5f80c3, 0xff5f7fc1, 0xff5f7fc0, 0xff617fc0, 0xff6280c0, 0xff6380c0,
    0xff6481c0, 0xff6683c1, 0xff6784c1, 0xff6784bf, 0xff6683bc, 0xff6681ba, 0xff6681bb, 0xff6580bb,
    0xff637fba, 0xff627fb9, 0xff627fb9, 0xff627eb8, 0xff627db7, 0xff627cb5, 0xff5f7ab1, 0xff5b78ae,
    0xff5776ac, 0xff5573aa, 0xff5471a8, 0xff526fa5, 0xff516ea2, 0xff516da0, 0xff516c9e, 0xff516c9c,
    0xff506b9b, 0xff4f6b9a, 0xff4f699a, 0xff50699b, 0xff536b9b, 0xff556d9a, 0xff546c9a, 0xff526b99,
    0xff536b9a, 0xff556c9d, 0xff546b94, 0xff50657c, 0xff4d616c, 0xff4f657c, 0xff526b92, 0xff556d95,
    0xff556b89, 0xff516473, 0xff495b5c, 0xff465959, 0xff4b6172, 0xff536c92, 0xff576e99, 0xff576c96,
    0xff566b94, 0xff546a92, 0xff526990, 0xff50688d, 0xff4f678d, 0xff4f678f, 0xff4f6790, 0xff50698e,
    0xff49627f, 0xff314659, 0xff13232e, 0xff010f15, 0xff4a6da7, 0xff4a6da7, 0xff4c6fa9, 0xff4e71ab,
    0xff5073ae, 0xff5275b0, 0xff5376af, 0xff5376ae, 0xff5376af, 0xff5477b1, 0xff5578b5, 0xff567bb8,
    0xff567cba, 0xff577dbb, 0xff587dbb, 0xff597dbc, 0xff5a7dbd, 0xff5a7dbd, 0xff5b7dbd, 0xff5b7dbd,
    0xff5a7dbc, 0xff5a7ebc, 0xff5b7fbd, 0xff5d80c0, 0xff5e81c2, 0xff6082c3, 0xff6284c5, 0xff6285c6,
    0xff6386c6, 0xff6587c6, 0xff6788c6, 0xff6a8bc8, 0xff6f8eca, 0xff7591cb, 0xff7b94cc, 0xff8198ce,
    0xff879cd0, 0xff8ba0d1, 0xff8fa3d3, 0xff8fa4d4, 0xff8da2d5, 0xff899fd5, 0xff879dd5, 0xff859cd3,
    0xff829ad1, 0xff7e99cf, 0xff7a97cd, 0xff7794cb, 0xff7693cb, 0xff7794cb, 0xff7895cb, 0xff7894cb,
    0xff7792cb, 0xff7892cb, 0xff7a94cd, 0xff7d97d0, 0xff7f9bd6, 0xff7f9dd8, 0xff7e9bd5, 0xff7b97cf,
    0xff7793cb, 0xff7491ca, 0xff7390c9, 0xff7590c9, 0xff7791c9, 0xff7690c8, 0xff7690c7, 0xff7890c7,
    0xff7a91c7, 0xff7b91c8, 0xff7b92c9, 0xff7d94cb, 0xff7f95cb, 0xff8298cc, 0xff869bce, 0xff889dcf,
    0xff899dcf, 0xff899cce, 0xff8a9cce, 0xff8a9ccf, 0xff899ace, 0xff8697cc, 0xff8496cb, 0xff8398cc,
    0xff849acd, 0xff849acc, 0xff879bcd, 0xff8ea1d0, 0xff96a7d5, 0xff98a7d6, 0xff93a2d4, 0xff8d9dd1,
    0xff899bcf, 0xff859ace, 0xff8297cd, 0xff7e94cc, 0xff7890ca, 0xff738cc7, 0xff718ac5, 0xff738bc5,
    0xff758cc5, 0xff748dc5, 0xff738dc4, 0xff738bc3, 0xff7288c1, 0xff7186c0, 0xff7185be, 0xff7085bd,
    0xff6f86bd, 0xff6c86be, 0xff6885c2, 0xff6584c4, 0xff6383c4, 0xff6383c2, 0xff6382c2, 0xff6482c2,
    0xff6482c2, 0xff6583c1, 0xff6684c1, 0xff6784c1, 0xff6884c1, 0xff6a86c1, 0xff6b87c1, 0xff6b86bf,
    0xff6984bd, 0xff6783bc, 0xff6782bc, 0xff6682bb, 0xff6481b8, 0xff627fb6, 0xff607cb3, 0xff5e79b1,
    0xff5d79b1, 0xff5d79b1, 0xff5c78b0, 0xff5b77ae, 0xff5a75ac, 0xff5874ab, 0xff5773a9, 0xff5571a6,
    0xff536fa3, 0xff526ea0, 0xff526d9f, 0xff516d9d, 0xff506d9c, 0xff4f6c9b, 0xff4d6999, 0xff4e6898,
    0xff516a97, 0xff546d97, 0xff536c97, 0xff516a97, 0xff526b98, 0xff566e99, 0xff556c90, 0xff50647a,
    0xff4a5d6a, 0xff4a5f6f, 0xff4d657e, 0xff546c8c, 0xff5a7092, 0xff55697f, 0xff46595a, 0xff3f524c,
    0xff465c68, 0xff516a8f, 0xff556d98, 0xff566b96, 0xff556a93, 0xff526a91, 0xff50688d, 0xff4d668a,
    0xff4c6589, 0xff4c648c, 0xff4d658f, 0xff536a92, 0xff4f6687, 0xff35485e, 0xff12212a, 0xff000a0c,
    0xff486ca4, 0xff486ca4, 0xff4a6ea6, 0xff4c70a8, 0xff4f72ab, 0xff5174ae, 0xff5275ae, 0xff5275ac,
    0xff5275ad, 0xff5376b0, 0xff5477b4, 0xff557ab7, 0xff557bb8, 0xff567cb9, 0xff577cb9, 0xff587dba,
    0xff597dbc, 0xff597dbc, 0xff5a7cbc, 0xff5a7cbb, 0xff597cba, 0xff597dba, 0xff5a7dbc, 0xff5c7ebe,
    0xff5d7fbf, 0xff5d80bf, 0xff5f82c1, 0xff6083c3, 0xff6284c4, 0xff6485c5, 0xff6687c5, 0xff6989c6,
    0xff6d8cc7, 0xff738fc9, 0xff7992cb, 0xff7f96cd, 0xff8399ce, 0xff879dcf, 0xff8ca1d1, 0xff8da2d2,
    0xff8ca0d4, 0xff899ed5, 0xff889cd5, 0xff889cd5, 0xff859cd3, 0xff819ad1, 0xff7c99ce, 0xff7896cc,
    0xff7794cb, 0xff7694cb, 0xff7795cc, 0xff7794cc, 0xff7793cc, 0xff7993ce, 0xff7b96d0, 0xff7e9ad4,
    0xff82a1db, 0xff83a4de, 0xff82a2db, 0xff7e9cd4, 0xff7897cf, 0xff7392cb, 0xff7290c9, 0xff7591ca,
    0xff7792ca, 0xff7591c7, 0xff7390c6, 0xff7490c6, 0xff7690c7, 0xff7890c8, 0xff7a91c9, 0xff7c93ca,
    0xff7d94cb, 0xff8197cd, 0xff889dd0, 0xff8ca1d2, 0xff8da1d2, 0xff8c9ed0, 0xff8a9ccf, 0xff899bcf,
    0xff8899cd, 0xff8797cb, 0xff8494c9, 0xff7b91c7, 0xff7791c7, 0xff7a93c7, 0xff8297c9, 0xff8b9dcd,
    0xff92a2d1, 0xff93a2d2, 0xff8f9dcf, 0xff8999cc, 0xff8497ca, 0xff8096ca, 0xff7d94ca, 0xff7a92ca,
    0xff758ec8, 0xff718bc4, 0xff6f89c2, 0xff7089c2, 0xff7189c2, 0xff708ac2, 0xff6f8ac1, 0xff6f88c0,
    0xff6e85be, 0xff6d83bd, 0xff6d82bc, 0xff6b82bb, 0xff6a82ba, 0xff6983bb, 0xff6885bf, 0xff6785c2,
    0xff6684c2, 0xff6583c0, 0xff6683c0, 0xff6784c2, 0xff6885c2, 0xff6986c2, 0xff6986c2, 0xff6985c2,
    0xff6a85c1, 0xff6b86c1, 0xff6c87c0, 0xff6b86be, 0xff6984bc, 0xff6783ba, 0xff6783ba, 0xff6682b9,
    0xff6380b5, 0xff607db2, 0xff5c79ae, 0xff5975ab, 0xff5875ac, 0xff5977ae, 0xff5977af, 0xff5a75ad,
    0xff5a74ab, 0xff5a74aa, 0xff5974a9, 0xff5772a6, 0xff5470a3, 0xff536fa0, 0xff536e9f, 0xff526e9d,
    0xff516d9d, 0xff4f6b9c, 0xff4d6898, 0xff4d6796, 0xff506995, 0xff536b95, 0xff526b95, 0xff506996,
    0xff516a95, 0xff556d95, 0xff556c8c, 0xff4f647a, 0xff485c68, 0xff455a62, 0xff465d68, 0xff4f667d,
    0xff586f93, 0xff536884, 0xff425556, 0xff394c41, 0xff42575f, 0xff4f6789, 0xff536b94, 0xff536a94,
    0xff516992, 0xff4f688e, 0xff4d668a, 0xff4b6388, 0xff4a6287, 0xff4a6188, 0xff4c638c, 0xff556d95,
    0xff546b8f, 0xff384b63, 0xff112028, 0xff000606, 0xff476ba2, 0xff476ba2, 0xff486da4, 0xff4a6fa6,
    0xff4c71a9, 0xff4f72ac, 0xff5073ac, 0xff5073ab, 0xff5275ad, 0xff5477b1, 0xff5578b4, 0xff5579b6,
    0xff557ab6, 0xff567ab6, 0xff577bb7, 0xff587cb8, 0xff597dba, 0xff597dba, 0xff5a7cba, 0xff5a7cb9,
    0xff597cb9, 0xff597cb9, 0xff5a7cba, 0xff5c7dbc, 0xff5c7ebc, 0xff5d7ebd, 0xff5e80be, 0xff5f81c0,
    0xff6082c1, 0xff6184c2, 0xff6385c2, 0xff6687c3, 0xff6a8ac4, 0xff6f8cc5, 0xff738ec7, 0xff7890c9,
    0xff7b93c9, 0xff7f96ca, 0xff839acc, 0xff859cce, 0xff869cd0, 0xff859bd2, 0xff869bd3, 0xff869ad3,
    0xff849ad2, 0xff8099d0, 0xff7c98cd, 0xff7895cb, 0xff7694ca, 0xff7594ca, 0xff7694cb, 0xff7693cb,
    0xff7692cc, 0xff7893ce, 0xff7996cf, 0xff7d9bd3, 0xff83a3db, 0xff86a6df, 0xff85a5de, 0xff81a0d8,
    0xff7b9ad2, 0xff7695cd, 0xff7492ca, 0xff7692ca, 0xff7892ca, 0xff7591c7, 0xff7390c6, 0xff738fc6,
    0xff748fc8, 0xff7690c9, 0xff7991ca, 0xff7b92cb, 0xff7d93cb, 0xff8096cd, 0xff869dd0, 0xff8aa0d2,
    0xff8a9fd2, 0xff889bd0, 0xff8598ce, 0xff8497cc, 0xff8395ca, 0xff8594c8, 0xff8192c6, 0xff778dc4,
    0xff718cc4, 0xff748fc5, 0xff7d94c6, 0xff8699ca, 0xff8d9dcd, 0xff8f9ece, 0xff8b9acb, 0xff8596c9,
    0xff8194c7, 0xff7e93c7, 0xff7a91c7, 0xff768ec7, 0xff748cc5, 0xff728ac3, 0xff7088c1, 0xff6f87c1,
    0xff6f87c1, 0xff6f87c0, 0xff6e87bf, 0xff6d85bc, 0xff6b82ba, 0xff6a81ba, 0xff6980bb, 0xff6780bb,
    0xff6680bb, 0xff6681bb, 0xff6683bd, 0xff6683be, 0xff6482bd, 0xff6380bb, 0xff6481bc, 0xff6682be,
    0xff6784c0, 0xff6784c0, 0xff6784bf, 0xff6783bd, 0xff6782bc, 0xff6883bc, 0xff6883bb, 0xff6682ba,
    0xff6480b8, 0xff637fb7, 0xff6481b7, 0xff6481b6, 0xff617eb3, 0xff5e7bb0, 0xff5b78ad, 0xff5875ab,
    0xff5875ab, 0xff5976ad, 0xff5976ad, 0xff5974ac, 0xff5973aa, 0xff5973a8, 0xff5873a6, 0xff5672a4,
    0xff5470a1, 0xff536fa0, 0xff536e9f, 0xff526e9d, 0xff516d9c, 0xff506c9b, 0xff4e6897, 0xff4e6795,
    0xff506893, 0xff526a94, 0xff526a96, 0xff516a9a, 0xff526b9b, 0xff566f9b, 0xff566d90, 0xff516679,
    0xff495c61, 0xff425555, 0xff3e5256, 0xff435a6b, 0xff4c6484, 0xff496079, 0xff3b4f4e, 0xff35473a,
    0xff3f5455, 0xff4e667e, 0xff516a8c, 0xff51698f, 0xff4f678f, 0xff4c658b, 0xff4a638a, 0xff4a628a,
    0xff4a628b, 0xff49628b, 0xff4d668e, 0xff58719e, 0xff58709c, 0xff3b4d6b, 0xff101c26, 0xff000000,
    0xff476aa1, 0xff476aa1, 0xff486ba2, 0xff496da4, 0xff4b6fa7, 0xff4e71aa, 0xff4f72ab, 0xff5073ac,
    0xff5275af, 0xff5578b3, 0xff5679b5, 0xff5679b5, 0xff5579b4, 0xff567ab4, 0xff577bb5, 0xff587cb6,
    0xff5a7db7, 0xff5a7db7, 0xff5a7cb8, 0xff5a7cb8, 0xff5a7cb8, 0xff5a7cb9, 0xff5a7cba, 0xff5b7cbc,
    0xff5b7cbc, 0xff5c7dbc, 0xff5d7fbc, 0xff5e80bc, 0xff5f81bd, 0xff6082bf, 0xff6183c0, 0xff6485c2,
    0xff6788c3, 0xff6b89c4, 0xff6d89c5, 0xff718bc5, 0xff738dc5, 0xff778fc6, 0xff7b92c7, 0xff7d94c9,
    0xff7f96cc, 0xff7f97cf, 0xff8097d0, 0xff7f96cf, 0xff7e96cf, 0xff7d95ce, 0xff7a95cd, 0xff7794ca,
    0xff7593c9, 0xff7492c9, 0xff7592ca, 0xff7591ca, 0xff7590cb, 0xff7792cc, 0xff7895cd, 0xff7c9ad1,
    0xff83a1d9, 0xff87a5dd, 0xff87a6dd, 0xff84a2d9, 0xff7f9dd4, 0xff7a96ce, 0xff7792ca, 0xff7892c9,
    0xff7892c9, 0xff7691c6, 0xff7490c6, 0xff738fc8, 0xff738fcb, 0xff7490cc, 0xff7791cc, 0xff7992cc,
    0xff7b93cc, 0xff7e95cc, 0xff839acf, 0xff859cd1, 0xff859ad1, 0xff8397cf, 0xff8094cc, 0xff7e93c9,
    0xff7d91c7, 0xff7f91c5, 0xff7e8fc4, 0xff768cc4, 0xff728bc4, 0xff748ec3, 0xff7a92c4, 0xff8296c7,
    0xff899aca, 0xff8b9acb, 0xff8797c9, 0xff8395c7, 0xff8093c5, 0xff7d92c4, 0xff798fc4, 0xff758cc5,
    0xff738bc5, 0xff738ac4, 0xff7188c2, 0xff6f88c1, 0xff6e87c0, 0xff6f86bf, 0xff6f85be, 0xff6d82ba,
    0xff6a80b7, 0xff687fb7, 0xff6780ba, 0xff6580bc, 0xff6481bd, 0xff6481bd, 0xff6482bc, 0xff6481bb,
    0xff627fb9, 0xff607db7, 0xff607db8, 0xff627eba, 0xff6480bc, 0xff6481bc, 0xff6481bb, 0xff637fb9,
    0xff627eb7, 0xff627db7, 0xff627db7, 0xff617cb6, 0xff5f7bb4, 0xff5e7cb3, 0xff607eb3, 0xff607fb3,
    0xff5e7cb1, 0xff5c79af, 0xff5a78ae, 0xff5977ad, 0xff5977ad, 0xff5a77ad, 0xff5a75ab, 0xff5873aa,
    0xff5771a8, 0xff5671a4, 0xff5671a2, 0xff5570a1, 0xff546fa0, 0xff546e9f, 0xff536e9e, 0xff526d9c,
    0xff516c9b, 0xff506b99, 0xff4f6896, 0xff4f6794, 0xff4f6792, 0xff506893, 0xff516998, 0xff516a9d,
    0xff536da0, 0xff5570a1, 0xff556f95, 0xff54697b, 0xff4e5f5e, 0xff43544f, 0xff394b4d, 0xff394e5c,
    0xff3e566f, 0xff3c5467, 0xff344846, 0xff334638, 0xff3e5350, 0xff4c6474, 0xff4f6884, 0xff4f688b,
    0xff4c658c, 0xff496289, 0xff486089, 0xff49618c, 0xff4a628e, 0xff4a648c, 0xff4d698f, 0xff5874a1,
    0xff5973a3, 0xff3c4e70, 0xff111b27, 0xff000000, 0xff4669a0, 0xff4669a0, 0xff476ba1, 0xff486ca2,
    0xff4a6da4, 0xff4c6fa6, 0xff4d70a9, 0xff4f72ab, 0xff5275af, 0xff5477b2, 0xff5679b4, 0xff5679b3,
    0xff5578b2, 0xff5679b2, 0xff577ab3, 0xff587bb4, 0xff5a7db5, 0xff5a7db5, 0xff597db5, 0xff597cb6,
    0xff597cb8, 0xff5a7cb9, 0xff5b7cba, 0xff5b7cba, 0xff5b7cba, 0xff5b7dba, 0xff5b7dba, 0xff5c7eba,
    0xff5d7fba, 0xff5e80bb, 0xff5f81bd, 0xff6283bf, 0xff6585c1, 0xff6686c2, 0xff6786c2, 0xff6987c2,
    0xff6c88c2, 0xff6f89c2, 0xff728bc3, 0xff758dc5, 0xff7890c8, 0xff7993ca, 0xff7a93cb, 0xff7992cb,
    0xff7991cb, 0xff7992cb, 0xff7892ca, 0xff7592c9, 0xff7391c8, 0xff7290c8, 0xff7390c9, 0xff738fca,
    0xff738fca, 0xff7491cb, 0xff7594cc, 0xff7998cf, 0xff809fd5, 0xff85a2d9, 0xff86a3db, 0xff84a1d9,
    0xff809dd5, 0xff7d98cf, 0xff7a94cb, 0xff7992ca, 0xff7891c8, 0xff7690c6, 0xff7490c6, 0xff728fc8,
    0xff718ecc, 0xff728fcd, 0xff7490cc, 0xff7792cc, 0xff7992cc, 0xff7c94cc, 0xff8096ce, 0xff8197cf,
    0xff8095cf, 0xff7d93cd, 0xff7a90ca, 0xff788fc7, 0xff788dc4, 0xff7a8dc2, 0xff7a8dc2, 0xff758bc3,
    0xff738bc4, 0xff738dc3, 0xff778fc2, 0xff7d92c4, 0xff8395c6, 0xff8595c7, 0xff8194c6, 0xff7e92c5,
    0xff7c90c3, 0xff7b8fc2, 0xff788cc2, 0xff748ac3, 0xff7389c3, 0xff7389c3, 0xff7289c3, 0xff6f88c1,
    0xff6e87c0, 0xff6f85be, 0xff6f83bc, 0xff6c81b7, 0xff687fb4, 0xff657fb5, 0xff6480b8, 0xff6280bb,
    0xff6280bd, 0xff6280bd, 0xff627fba, 0xff617eb7, 0xff5f7cb5, 0xff5d7ab4, 0xff5d7ab5, 0xff5e7ab7,
    0xff5f7cb9, 0xff607db9, 0xff607db8, 0xff5f7cb6, 0xff5e7bb5, 0xff5d7ab5, 0xff5d7ab5, 0xff5d79b5,
    0xff5c79b4, 0xff5c7ab3, 0xff5d7cb2, 0xff5d7cb1, 0xff5b79af, 0xff5977ae, 0xff5977ae, 0xff5a78af,
    0xff5a78af, 0xff5b76ad, 0xff5974ab, 0xff5772a9, 0xff5570a5, 0xff536ea1, 0xff536e9e, 0xff536e9d,
    0xff536e9e, 0xff536e9e, 0xff526d9d, 0xff516c9b, 0xff506b9a, 0xff4f6a98, 0xff506895, 0xff506793,
    0xff4f6692, 0xff4e6693, 0xff4e6695, 0xff506798, 0xff50699b, 0xff506b9e, 0xff516c95, 0xff546a7e,
    0xff526361, 0xff46564f, 0xff384945, 0xff31444b, 0xff304656, 0xff2e4550, 0xff2c403b, 0xff304234,
    0xff3b5048, 0xff486067, 0xff4c657b, 0xff4d6689, 0xff4b638c, 0xff476088, 0xff455d86, 0xff455d88,
    0xff455e87, 0xff456082, 0xff476583, 0xff526f97, 0xff526d9b, 0xff374b6c, 0xff101b28, 0xff000000,
    0xff45689e, 0xff45689e, 0xff466a9f, 0xff476ba1, 0xff496ca3, 0xff4b6ea5, 0xff4c6fa7, 0xff4e71aa,
    0xff5073ad, 0xff5376af, 0xff5477b0, 0xff5477af, 0xff5476af, 0xff5576b0, 0xff5678b2, 0xff577ab3,
    0xff597bb4, 0xff597cb4, 0xff587cb4, 0xff587bb4, 0xff587bb6, 0xff597bb8, 0xff5a7bb8, 0xff5a7cb8,
    0xff5a7cb8, 0xff5a7cb8, 0xff5a7cb8, 0xff5b7db8, 0xff5c7eb8, 0xff5e7fb9, 0xff5f80bb, 0xff6181bd,
    0xff6383bf, 0xff6383c0, 0xff6384c0, 0xff6585c0, 0xff6786c1, 0xff6987c1, 0xff6d88c1, 0xff6f89c2,
    0xff718cc4, 0xff738fc6, 0xff748fc7, 0xff748ec8, 0xff758fc8, 0xff7690c7, 0xff7691c7, 0xff7491c7,
    0xff7290c7, 0xff728fc8, 0xff728fc9, 0xff728fca, 0xff738fcb, 0xff7391cb, 0xff7493cc, 0xff7796ce,
    0xff7c99d1, 0xff7f9bd4, 0xff819dd6, 0xff809cd5, 0xff7f9bd3, 0xff7e99d0, 0xff7a95cc, 0xff7792ca,
    0xff7590c8, 0xff738fc6, 0xff728fc6, 0xff708ec9, 0xff708ecc, 0xff718ecc, 0xff738fcb, 0xff7590cb,
    0xff7891ca, 0xff7b92cb, 0xff7e94ce, 0xff7f95cf, 0xff7e94cf, 0xff7c92cd, 0xff798fc9, 0xff778ec6,
    0xff768cc3, 0xff768bc1, 0xff768bc1, 0xff758ac2, 0xff748ac3, 0xff738bc1, 0xff748cc0, 0xff778dc1,
    0xff7a8fc3, 0xff7b8fc4, 0xff798fc4, 0xff778ec3, 0xff768cc1, 0xff768bc0, 0xff758ac1, 0xff748ac3,
    0xff748ac4, 0xff7489c3, 0xff7289c3, 0xff7088c2, 0xff6e87c0, 0xff6c84bd, 0xff6b81ba, 0xff687fb6,
    0xff657eb4, 0xff637eb4, 0xff627fb7, 0xff607fb9, 0xff607fbb, 0xff607fbb, 0xff607db8, 0xff5f7cb5,
    0xff5e7bb4, 0xff5d7ab5, 0xff5d7ab6, 0xff5d7ab7, 0xff5d7ab9, 0xff5d7bbb, 0xff5d7cbc, 0xff5e7cbd,
    0xff5e7cbd, 0xff5e7cbe, 0xff5e7dbe, 0xff607ebf, 0xff627fbf, 0xff617ebc, 0xff5f7cb6, 0xff5b79b2,
    0xff5977b2, 0xff5876b4, 0xff5977b3, 0xff5a79b2, 0xff5a78b3, 0xff5876b5, 0xff5674b2, 0xff5471ab,
    0xff536fa4, 0xff526d9f, 0xff526d9d, 0xff536d9d, 0xff536d9e, 0xff526d9d, 0xff516c9b, 0xff4f6b99,
    0xff4e6a98, 0xff4e6997, 0xff4e6794, 0xff4e6592, 0xff4c6393, 0xff4a6293, 0xff4a628f, 0xff4b6489,
    0xff4a6489, 0xff486390, 0xff496492, 0xff516a8c, 0xff546a79, 0xff4b5d5b, 0xff3c4c3f, 0xff2f4037,
    0xff263a3d, 0xff223639, 0xff23352c, 0xff2b3d2b, 0xff374c3c, 0xff445c5a, 0xff496376, 0xff4a648c,
    0xff486293, 0xff455f8b, 0xff415983, 0xff3d547b, 0xff3a5271, 0xff395266, 0xff3a5563, 0xff3e5b73,
    0xff3d597b, 0xff2c415d, 0xff15202b, 0xff070d0e, 0xff44689d, 0xff44689d, 0xff45699f, 0xff466aa0,
    0xff486ba1, 0xff4b6da3, 0xff4c6ea5, 0xff4d70a7, 0xff4f72a9, 0xff5073ab, 0xff5174ac, 0xff5275ad,
    0xff5275ae, 0xff5376af, 0xff5477b1, 0xff5578b2, 0xff577ab3, 0xff577ab3, 0xff5679b3, 0xff5679b3,
    0xff5679b6, 0xff577ab7, 0xff577bb7, 0xff587cb6, 0xff597cb6, 0xff597cb7, 0xff5a7cb7, 0xff5b7cb7,
    0xff5c7db7, 0xff5e7eb9, 0xff607fbb, 0xff6180bd, 0xff6282be, 0xff6282be, 0xff6283bf, 0xff6484c0,
    0xff6586c1, 0xff6787c2, 0xff6a88c1, 0xff6c88c1, 0xff6e8ac2, 0xff708cc3, 0xff718cc4, 0xff718cc5,
    0xff728dc5, 0xff738fc5, 0xff7490c5, 0xff7391c6, 0xff7290c7, 0xff728fc8, 0xff728ec9, 0xff728ec9,
    0xff738fca, 0xff7390ca, 0xff7391cb, 0xff7492cc, 0xff7594cf, 0xff7795d0, 0xff7996d1, 0xff7b96d0,
    0xff7c97d0, 0xff7d97cf, 0xff7a95cd, 0xff7591cb, 0xff728fc8, 0xff718dc6, 0xff718dc6, 0xff708dc8,
    0xff6f8eca, 0xff708eca, 0xff718fc9, 0xff758fc9, 0xff7790ca, 0xff7b91cb, 0xff7e94ce, 0xff7f95cf,
    0xff7f94cf, 0xff7d93ce, 0xff7a91ca, 0xff788fc7, 0xff768dc4, 0xff748ac2, 0xff7389c2, 0xff738ac3,
    0xff748bc3, 0xff738ac2, 0xff7289c0, 0xff7289c0, 0xff738bc2, 0xff738bc2, 0xff738bc2, 0xff728ac1,
    0xff7188c0, 0xff7188c0, 0xff7389c1, 0xff758ac3, 0xff758bc3, 0xff738ac3, 0xff7189c2, 0xff6f88c1,
    0xff6c86c0, 0xff6982bb, 0xff6780b8, 0xff657eb6, 0xff647eb5, 0xff627eb5, 0xff607eb5, 0xff5f7eb7,
    0xff5f7db8, 0xff5f7db8, 0xff5e7cb5, 0xff5e7cb4, 0xff5e7cb5, 0xff5e7bb7, 0xff5d7bb7, 0xff5c7ab8,
    0xff5c7abb, 0xff5b7abe, 0xff5c7bc2, 0xff5e7dc4, 0xff607fc5, 0xff6180c6, 0xff6282c7, 0xff6585c9,
    0xff6987cb, 0xff6784c5, 0xff617ebb, 0xff5b78b3, 0xff5875b5, 0xff5875b7, 0xff5977b4, 0xff5a79b2,
    0xff5879b5, 0xff5577ba, 0xff5273b6, 0xff5170ac, 0xff516ea3, 0xff516c9e, 0xff526c9d, 0xff536c9d,
    0xff536c9e, 0xff526b9c, 0xff506a99, 0xff4e6997, 0xff4e6998, 0xff4d6897, 0xff4c6593, 0xff4b6291,
    0xff496093, 0xff475f92, 0xff465f86, 0xff455f77, 0xff425c73, 0xff3e587c, 0xff415b89, 0xff4b6694,
    0xff546d8d, 0xff4f6468, 0xff42533d, 0xff32412b, 0xff23322e, 0xff1b2b29, 0xff1d2e21, 0xff263922,
    0xff324731, 0xff3f574f, 0xff455f72, 0xff476290, 0xff486299, 0xff456090, 0xff3e577f, 0xff364d6d,
    0xff2f4559, 0xff2d4348, 0xff2c4442, 0xff2b464e, 0xff284458, 0xff213749, 0xff1a262d, 0xff151d1d,
    0xff42679b, 0xff42679b, 0xff43689d, 0xff45699f, 0xff476aa1, 0xff4a6ca2, 0xff4b6da3, 0xff4c6ea4,
    0xff4d70a6, 0xff4d70a7, 0xff4e71a8, 0xff4f72aa, 0xff5073ac, 0xff5174ae, 0xff5275b0, 0xff5376b1,
    0xff5578b2, 0xff5578b2, 0xff5578b2, 0xff5578b2, 0xff5678b4, 0xff5679b5, 0xff567ab5, 0xff577bb4,
    0xff587bb5, 0xff587bb6, 0xff597bb6, 0xff5a7cb6, 0xff5b7db6, 0xff5e7eb8, 0xff607fba, 0xff6180bc,
    0xff6181bd, 0xff6282bd, 0xff6282be, 0xff6484bf, 0xff6586c1, 0xff6687c2, 0xff6887c1, 0xff6a87c0,
    0xff6c88c0, 0xff6d89c1, 0xff6e8ac2, 0xff6f8ac3, 0xff708cc3, 0xff718ec3, 0xff718fc3, 0xff718fc5,
    0xff718ec6, 0xff708dc7, 0xff708dc8, 0xff708ec8, 0xff718fc9, 0xff718fc9, 0xff718fca, 0xff718fcb,
    0xff708fcc, 0xff718fcc, 0xff7490cc, 0xff7792cc, 0xff7b94cd, 0xff7d96ce, 0xff7a95cd, 0xff7592cb,
    0xff708ec9, 0xff6f8cc7, 0xff6f8cc6, 0xff6f8dc7, 0xff6f8ec8, 0xff6f8ec8, 0xff718ec7, 0xff738ec7,
    0xff768fc8, 0xff7a90c9, 0xff7d93cc, 0xff7f94ce, 0xff7f94cf, 0xff7e93ce, 0xff7c92cb, 0xff7a91c8,
    0xff778ec5, 0xff748bc3, 0xff738ac3, 0xff758cc4, 0xff768dc4, 0xff758bc3, 0xff7389c1, 0xff7089c1,
    0xff6f89c1, 0xff6e89c1, 0xff6e89c0, 0xff6e88c0, 0xff6d86bf, 0xff6d86bf, 0xff7188c0, 0xff758ac2,
    0xff758ac2, 0xff728ac1, 0xff6f88c0, 0xff6e87bf, 0xff6b85bd, 0xff6681b9, 0xff637fb6, 0xff627eb5,
    0xff627db5, 0xff617db4, 0xff5f7cb3, 0xff5d7cb3, 0xff5d7bb3, 0xff5d7bb3, 0xff5c7ab3, 0xff5c7ab3,
    0xff5d7ab5, 0xff5e7bb7, 0xff5d7bb7, 0xff5c7ab6, 0xff5a7ab8, 0xff5a79bc, 0xff5b7ac0, 0xff5f7ec2,
    0xff6281c4, 0xff6383c5, 0xff6485c7, 0xff6988cb, 0xff6e8bce, 0xff6b87c7, 0xff627eba, 0xff5976b0,
    0xff5673af, 0xff5673b0, 0xff5673ab, 0xff5674a8, 0xff5474ab, 0xff5173b1, 0xff4f71af, 0xff506fa7,
    0xff506d9f, 0xff506b9c, 0xff506a9c, 0xff516a9c, 0xff516a9c, 0xff50699a, 0xff4d6896, 0xff4b6794,
    0xff4a6794, 0xff4a6694, 0xff4a6391, 0xff496190, 0xff496092, 0xff475f8f, 0xff425a79, 0xff3d555e,
    0xff364e53, 0xff31485e, 0xff344c73, 0xff425d8d, 0xff506c92, 0xff50686d, 0xff47583c, 0xff344123,
    0xff212c20, 0xff17231c, 0xff1b2a18, 0xff23371c, 0xff2d4427, 0xff395142, 0xff41596a, 0xff455e8d,
    0xff486199, 0xff46618f, 0xff3c5577, 0xff2e4459, 0xff23363c, 0xff20332a, 0xff213524, 0xff1d352c,
    0xff193538, 0xff1a3036, 0xff1d2a2d, 0xff1f2727, 0xff40669a, 0xff40669a, 0xff42679b, 0xff44689d,
    0xff47699f, 0xff496ba1, 0xff4a6ca1, 0xff4a6da2, 0xff4a6ea3, 0xff4b6ea4, 0xff4c6fa6, 0xff4e70a9,
    0xff4f71ab, 0xff5072ad, 0xff5173ae, 0xff5274af, 0xff5375af, 0xff5476af, 0xff5477b0, 0xff5577b1,
    0xff5677b3, 0xff5678b4, 0xff5679b4, 0xff567ab3, 0xff577ab4, 0xff577ab5, 0xff587bb5, 0xff597cb5,
    0xff5a7db5, 0xff5d7eb7, 0xff5f7eb9, 0xff607fba, 0xff6080bb, 0xff6181bc, 0xff6181bd, 0xff6383bf,
    0xff6485c0, 0xff6586c0, 0xff6786c0, 0xff6886c0, 0xff6987c0, 0xff6a88c0, 0xff6b89c1, 0xff6c89c2,
    0xff6e8bc2, 0xff6e8cc2, 0xff6f8dc2, 0xff708dc4, 0xff708cc5, 0xff6f8cc6, 0xff6e8cc6, 0xff6e8cc6,
    0xff6e8cc7, 0xff6e8cc7, 0xff6e8cc8, 0xff6e8cc9, 0xff6e8dc9, 0xff708ec9, 0xff7490ca, 0xff7993cb,
    0xff7d95cc, 0xff8097cd, 0xff7e96cd, 0xff7893cc, 0xff738fca, 0xff708dc7, 0xff6f8cc5, 0xff6f8cc5,
    0xff708dc6, 0xff708dc6, 0xff708dc6, 0xff728dc6, 0xff748dc6, 0xff788ec7, 0xff7b91ca, 0xff7d92cc,
    0xff7d93cc, 0xff7c92cb, 0xff7c92ca, 0xff7b92c8, 0xff7990c6, 0xff778ec5, 0xff768dc4, 0xff7990c5,
    0xff7b92c5, 0xff7a90c4, 0xff778ec3, 0xff748cc2, 0xff718cc2, 0xff6f8ac0, 0xff6e88bf, 0xff6d87be,
    0xff6c86be, 0xff6d86be, 0xff7087bf, 0xff7388bf, 0xff7288bf, 0xff6f88be, 0xff6c86bd, 0xff6c85bc,
    0xff6983ba, 0xff647fb7, 0xff617db4, 0xff607cb4, 0xff607bb4, 0xff5f7bb3, 0xff5e7ab1, 0xff5c7aaf,
    0xff5b79af, 0xff5b78af, 0xff5b78b0, 0xff5b78b1, 0xff5c78b2, 0xff5c79b3, 0xff5c7ab4, 0xff5b7bb5,
    0xff5b7ab5, 0xff5a78b4, 0xff5b78b3, 0xff607eb4, 0xff6382b5, 0xff6484b5, 0xff6484b7, 0xff6887be,
    0xff6d89c5, 0xff6985c2, 0xff5e7bb6, 0xff5573a8, 0xff53719d, 0xff537098, 0xff506d93, 0xff4e6a92,
    0xff4e6a91, 0xff4f6c92, 0xff516e95, 0xff516e99, 0xff516d9c, 0xff4d699c, 0xff4b679b, 0xff4b679c,
    0xff4c679b, 0xff4c6798, 0xff4b6694, 0xff496491, 0xff47648f, 0xff47638f, 0xff496290, 0xff4c6390,
    0xff4e6691, 0xff4d6687, 0xff415965, 0xff32463d, 0xff25372a, 0xff1e3234, 0xff23384c, 0xff334b69,
    0xff455e77, 0xff4a6060, 0xff45563c, 0xff354023, 0xff232819, 0xff1a2113, 0xff1f2e16, 0xff253b1b,
    0xff293f1e, 0xff304430, 0xff3b5055, 0xff455b7b, 0xff4c648d, 0xff4c6789, 0xff3c566d, 0xff233943,
    0xff12241f, 0xff132311, 0xff1b2b12, 0xff1a3019, 0xff173223, 0xff172e27, 0xff182525, 0xff192024,
    0xff3f6699, 0xff3f6699, 0xff41679a, 0xff43689c, 0xff45699e, 0xff476ba0, 0xff486ca0, 0xff496ca0,
    0xff496ca2, 0xff4a6da4, 0xff4b6ea6, 0xff4d70a9, 0xff4e71ab, 0xff5072ac, 0xff5173ad, 0xff5273ad,
    0xff5274ad, 0xff5275ad, 0xff5376af, 0xff5477b0, 0xff5578b2, 0xff5578b3, 0xff5578b3, 0xff5579b2,
    0xff5679b3, 0xff577ab4, 0xff587bb5, 0xff587cb5, 0xff597db5, 0xff5b7eb7, 0xff5d7eb9, 0xff5f7fb9,
    0xff6080ba, 0xff6181bb, 0xff6281bd, 0xff6383be, 0xff6384bd, 0xff6485bd, 0xff6585bf, 0xff6685c0,
    0xff6786c0, 0xff6987bf, 0xff6a88c0, 0xff6b89c1, 0xff6d8bc2, 0xff6e8cc2, 0xff6e8cc2, 0xff6f8bc3,
    0xff6e8ac4, 0xff6d8ac4, 0xff6b8ac3, 0xff6b8ac3, 0xff6b89c4, 0xff6b89c6, 0xff6b8ac7, 0xff6c8bc8,
    0xff6e8dc7, 0xff728fc7, 0xff7893c9, 0xff7d96cb, 0xff8197cc, 0xff8298cc, 0xff8096cc, 0xff7b94cb,
    0xff7691ca, 0xff728fc6, 0xff708dc4, 0xff708cc4, 0xff718cc5, 0xff718cc5, 0xff718dc5, 0xff728dc5,
    0xff738dc5, 0xff758dc6, 0xff788fc8, 0xff7a90c9, 0xff7b91c9, 0xff7b91c8, 0xff7b91c8, 0xff7b91c7,
    0xff7b91c6, 0xff7a90c5, 0xff7a91c5, 0xff7e95c6, 0xff8096c7, 0xff7f94c6, 0xff7d92c5, 0xff7b90c5,
    0xff798fc4, 0xff758dc2, 0xff718abf, 0xff6f88bd, 0xff6f88bd, 0xff7088be, 0xff7187bd, 0xff7085bc,
    0xff6f85bc, 0xff6c85bc, 0xff6a84ba, 0xff6a83b9, 0xff6981b6, 0xff647eb3, 0xff617cb1, 0xff5f7bb1,
    0xff5e7ab1, 0xff5d79b0, 0xff5c79af, 0xff5b77ad, 0xff5b77ab, 0xff5a76ab, 0xff5a76ad, 0xff5a76af,
    0xff5976af, 0xff5976ae, 0xff5978af, 0xff5a7ab1, 0xff5b7aae, 0xff5b78a8, 0xff5d77a2, 0xff607ca0,
    0xff6380a0, 0xff63819f, 0xff6280a2, 0xff6482ab, 0xff6683b5, 0xff627fb6, 0xff5978ae, 0xff51719f,
    0xff506e8a, 0xff506c7d, 0xff4a6579, 0xff455f79, 0xff486074, 0xff4f656f, 0xff546a77, 0xff546c89,
    0xff516c98, 0xff4b679a, 0xff466498, 0xff456399, 0xff476498, 0xff486495, 0xff486491, 0xff47628d,
    0xff44608a, 0xff445f8b, 0xff49618f, 0xff4f6590, 0xff566e8e, 0xff546e7e, 0xff435854, 0xff2b3924,
    0xff17230b, 0xff0f1f13, 0xff152828, 0xff273b40, 0xff3b4f51, 0xff42574d, 0xff3f523e, 0xff343f29,
    0xff262718, 0xff212311, 0xff273418, 0xff2a401d, 0xff273e1a, 0xff283c23, 0xff364843, 0xff455866,
    0xff50657d, 0xff516b7f, 0xff3e5763, 0xff1e3334, 0xff091a0f, 0xff0d1b07, 0xff1b2a10, 0xff1f3518,
    0xff203b1f, 0xff1b3120, 0xff13201c, 0xff0e1619, 0xff3e6699, 0xff3e6699, 0xff40679a, 0xff42689b,
    0xff446a9e, 0xff466ba0, 0xff476ba0, 0xff486b9f, 0xff486ba1, 0xff496da4, 0xff4a6ea8, 0xff4c6faa,
    0xff4d70ab, 0xff4f71ac, 0xff5072ac, 0xff5072ac, 0xff5172ac, 0xff5274ac, 0xff5376ae, 0xff5477af,
    0xff5578b1, 0xff5578b2, 0xff5578b2, 0xff5578b2, 0xff5678b3, 0xff5779b4, 0xff577ab5, 0xff577bb5,
    0xff587cb5, 0xff597db7, 0xff5b7db8, 0xff5d7eb8, 0xff5f7fb8, 0xff6080ba, 0xff6181bc, 0xff6282bd,
    0xff6282bb, 0xff6383bb, 0xff6484be, 0xff6484c0, 0xff6585c0, 0xff6686bf, 0xff6787bf, 0xff6888c0,
    0xff6a88c1, 0xff6b89c2, 0xff6b89c2, 0xff6c88c3, 0xff6b87c3, 0xff6a87c2, 0xff6888c1, 0xff6787c1,
    0xff6786c2, 0xff6786c4, 0xff6887c5, 0xff6a89c6, 0xff6f8cc5, 0xff738fc5, 0xff7993c7, 0xff7e97ca,
    0xff8097cb, 0xff8196ca, 0xff7f94ca, 0xff7c93ca, 0xff7892c9, 0xff738fc5, 0xff708dc3, 0xff708bc2,
    0xff718bc3, 0xff718cc3, 0xff718dc4, 0xff718dc4, 0xff728bc4, 0xff738bc4, 0xff758cc5, 0xff778ec6,
    0xff788fc6, 0xff7990c5, 0xff7a90c6, 0xff7b91c7, 0xff7b91c7, 0xff7c92c6, 0xff7e94c5, 0xff8197c6,
    0xff8398c7, 0xff8397c7, 0xff8195c6, 0xff7f94c6, 0xff7e93c5, 0xff7a90c3, 0xff758cc1, 0xff728abf,
    0xff7289bf, 0xff7289be, 0xff7086bc, 0xff6d83b9, 0xff6a82b8, 0xff6881b8, 0xff6680b6, 0xff667fb4,
    0xff657eb2, 0xff627cb0, 0xff5f7aaf, 0xff5d78ae, 0xff5c77ad, 0xff5b76ac, 0xff5a75ab, 0xff5974a9,
    0xff5974a7, 0xff5873a7, 0xff5873a9, 0xff5873ab, 0xff5773ac, 0xff5673ab, 0xff5775a8, 0xff5877a5,
    0xff59769c, 0xff5a7493, 0xff5c738b, 0xff5f7787, 0xff607a86, 0xff5f7983, 0xff5d7684, 0xff5e778d,
    0xff5e799a, 0xff5b78a1, 0xff5473a0, 0xff4e6f92, 0xff4c6b75, 0xff496560, 0xff415a5b, 0xff3c525d,
    0xff425556, 0xff4e5e4f, 0xff54655a, 0xff546875, 0xff4f688b, 0xff486494, 0xff436193, 0xff426093,
    0xff436191, 0xff45618f, 0xff46628e, 0xff45608b, 0xff415d87, 0xff415c87, 0xff49608c, 0xff50668c,
    0xff587086, 0xff576f70, 0xff435543, 0xff262f12, 0xff0e1500, 0xff051000, 0xff09190a, 0xff1b2b1b,
    0xff31412d, 0xff394c39, 0xff394c3a, 0xff323b2c, 0xff292617, 0xff262410, 0xff2a3619, 0xff2b421e,
    0xff263c17, 0xff25371a, 0xff334334, 0xff435354, 0xff4e626b, 0xff4f6771, 0xff3d5556, 0xff1e3227,
    0xff0a1904, 0xff0d1901, 0xff1b280f, 0xff253917, 0xff29431d, 0xff20371c, 0xff111e16, 0xff081013,
    0xff3d669a, 0xff3d669a, 0xff3f669a, 0xff41679b, 0xff43699d, 0xff456ba0, 0xff466ba0, 0xff476b9f,
    0xff486ba1, 0xff496da4, 0xff496ea7, 0xff4a6fa9, 0xff4b70aa, 0xff4d71ab, 0xff4f72ac, 0xff5073ac,
    0xff5174ad, 0xff5275ad, 0xff5275ad, 0xff5376ae, 0xff5477b0, 0xff5477b1, 0xff5478b1, 0xff5578b1,
    0xff5678b2, 0xff5778b4, 0xff5779b5, 0xff577ab5, 0xff577bb5, 0xff597cb6, 0xff5a7cb7, 0xff5c7db6,
    0xff5d7eb6, 0xff5e7eb8, 0xff5f7fba, 0xff607fbb, 0xff6180ba, 0xff6181ba, 0xff6182bc, 0xff6182be,
    0xff6282be, 0xff6383be, 0xff6383be, 0xff6484bf, 0xff6484bf, 0xff6585c0, 0xff6685c1, 0xff6684c1,
    0xff6684c1, 0xff6584c0, 0xff6485c0, 0xff6485c0, 0xff6484c0, 0xff6484c2, 0xff6685c3, 0xff6887c4,
    0xff6c8ac3, 0xff708cc3, 0xff7490c5, 0xff7893c7, 0xff7a93c8, 0xff7a92c7, 0xff7a91c7, 0xff7890c7,
    0xff758fc6, 0xff718dc4, 0xff6f8cc3, 0xff6f8bc1, 0xff718bc1, 0xff728cc2, 0xff728dc4, 0xff728dc4,
    0xff718bc3, 0xff718ac2, 0xff728bc3, 0xff748cc4, 0xff768dc4, 0xff788fc4, 0xff7990c5, 0xff7a90c6,
    0xff7a90c6, 0xff7b91c5, 0xff7c92c4, 0xff7f95c4, 0xff8196c5, 0xff8296c5, 0xff8195c5, 0xff8194c4,
    0xff8094c4, 0xff7e93c5, 0xff7c92c8, 0xff7990c9, 0xff758cc9, 0xff7189c5, 0xff6c85bf, 0xff6881b8,
    0xff657fb5, 0xff637eb4, 0xff617cb2, 0xff607aaf, 0xff5f79ae, 0xff5c78af, 0xff5a77af, 0xff5976ad,
    0xff5874aa, 0xff5673aa, 0xff5472aa, 0xff5471a8, 0xff5570a5, 0xff5670a3, 0xff5670a4, 0xff5570a7,
    0xff5471ae, 0xff5472af, 0xff5472a1, 0xff54718c, 0xff56717b, 0xff5a7174, 0xff5b7170, 0xff5a6f6c,
    0xff576d68, 0xff536860, 0xff51665c, 0xff526964, 0xff566e73, 0xff567284, 0xff537290, 0xff4e6e89,
    0xff496465, 0xff415847, 0xff354a3e, 0xff2e413f, 0xff38483e, 0xff4b573d, 0xff536049, 0xff4f5f5b,
    0xff485d6f, 0xff445d82, 0xff435e8a, 0xff466089, 0xff496284, 0xff486288, 0xff456190, 0xff415e92,
    0xff3f5b8e, 0xff415a8b, 0xff47608b, 0xff4e6586, 0xff546b78, 0xff52665f, 0xff415037, 0xff28300f,
    0xff101600, 0xff010a00, 0xff020f01, 0xff16230b, 0xff2e3c1a, 0xff334528, 0xff30432f, 0xff2e3326,
    0xff2c2115, 0xff291f0f, 0xff263017, 0xff243d1a, 0xff253c14, 0xff2a3b16, 0xff34442d, 0xff3c4e48,
    0xff3f5459, 0xff3b535b, 0xff324944, 0xff28391e, 0xff1e2a02, 0xff172001, 0xff18240c, 0xff243813,
    0xff2f4919, 0xff284119, 0xff182917, 0xff0f1c16, 0xff3d679b, 0xff3d679b, 0xff3f679a, 0xff41679b,
    0xff43689e, 0xff456aa1, 0xff476aa2, 0xff496ba2, 0xff496ca3, 0xff486da5, 0xff486ea7, 0xff496fa8,
    0xff4a70a9, 0xff4c71ab, 0xff4f72ad, 0xff5074ae, 0xff5175af, 0xff5176af, 0xff5175ae, 0xff5175ae,
    0xff5276b0, 0xff5377b1, 0xff5478b1, 0xff5578b1, 0xff5678b2, 0xff5778b4, 0xff5778b5, 0xff5779b4,
    0xff577ab4, 0xff587bb5, 0xff597bb6, 0xff5a7bb5, 0xff5b7cb5, 0xff5c7db6, 0xff5c7db8, 0xff5e7fba,
    0xff5f80ba, 0xff6080ba, 0xff6080bb, 0xff5f80bc, 0xff5f80bc, 0xff6081bc, 0xff6081bd, 0xff5f81be,
    0xff6081be, 0xff6182bf, 0xff6282bf, 0xff6282c0, 0xff6182c0, 0xff6182c0, 0xff6183c0, 0xff6183c0,
    0xff6183c1, 0xff6383c1, 0xff6585c2, 0xff6786c2, 0xff6a88c2, 0xff6c89c2, 0xff6f8cc3, 0xff718ec4,
    0xff728ec4, 0xff738dc4, 0xff738cc4, 0xff728cc3, 0xff718cc3, 0xff6f8bc3, 0xff6e8bc3, 0xff6e8bc1,
    0xff708bc0, 0xff718cc1, 0xff728dc3, 0xff718dc4, 0xff708bc2, 0xff6f8ac1, 0xff7189c1, 0xff738ac2,
    0xff758bc2, 0xff778dc3, 0xff788ec4, 0xff788ec4, 0xff788ec4, 0xff798fc3, 0xff7a90c2, 0xff7b91c2,
    0xff7c92c2, 0xff7e93c3, 0xff7f93c4, 0xff7f93c3, 0xff7e92c2, 0xff7f93c6, 0xff8095ce, 0xff7d95d3,
    0xff758ed0, 0xff6e88ca, 0xff6884c1, 0xff6480b8, 0xff627db3, 0xff607ab2, 0xff5e78af, 0xff5c76ac,
    0xff5975ab, 0xff5774ae, 0xff5574af, 0xff5573ab, 0xff5571a7, 0xff5370a6, 0xff506ea8, 0xff4f6ea7,
    0xff526ea2, 0xff546e9f, 0xff536ea0, 0xff526ea4, 0xff5370b1, 0xff5371b4, 0xff516e9a, 0xff4f6a74,
    0xff516a5b, 0xff576d5a, 0xff596e5c, 0xff556859, 0xff4f6054, 0xff495948, 0xff465640, 0xff495b44,
    0xff4f6453, 0xff536d6a, 0xff547281, 0xff506f81, 0xff465f5c, 0xff3a4e3a, 0xff2c3d2e, 0xff26362e,
    0xff324033, 0xff47523b, 0xff505b43, 0xff485547, 0xff415255, 0xff425872, 0xff455d82, 0xff4b617d,
    0xff4f6275, 0xff4c627e, 0xff44608f, 0xff3f5d97, 0xff3d5b94, 0xff405b8d, 0xff465f88, 0xff4b627d,
    0xff4d616b, 0xff485951, 0xff3d4930, 0xff2d3613, 0xff181e00, 0xff050c00, 0xff030c03, 0xff17220c,
    0xff2f3d18, 0xff2f4221, 0xff2a3b24, 0xff2a2c1d, 0xff2e1d13, 0xff291b0e, 0xff1f2712, 0xff1d3515,
    0xff263d12, 0xff334418, 0xff36482f, 0xff354946, 0xff2f4450, 0xff273e4b, 0xff293d37, 0xff34431e,
    0xff353f0a, 0xff232c06, 0xff15220b, 0xff213510, 0xff304b16, 0xff2e481a, 0xff22361c, 0xff1b2c1e,
    0xff3d679d, 0xff3d679d, 0xff3e679c, 0xff40679d, 0xff42689f, 0xff446aa2, 0xff466ba3, 0xff486ca4,
    0xff496da5, 0xff486da6, 0xff476ea7, 0xff486fa7, 0xff4970a8, 0xff4b71aa, 0xff4e72ad, 0xff4f74af,
    0xff5076b0, 0xff5077b0, 0xff5075af, 0xff5074ae, 0xff5075b0, 0xff5176b1, 0xff5277b1, 0xff5478b1,
    0xff5578b2, 0xff5677b3, 0xff5677b4, 0xff5677b4, 0xff5678b4, 0xff5779b5, 0xff587ab5, 0xff587bb4,
    0xff587bb4, 0xff587bb4, 0xff597cb5, 0xff5b7cb7, 0xff5c7db8, 0xff5d7eb9, 0xff5d7eba, 0xff5c7eba,
    0xff5c7eba, 0xff5c7ebb, 0xff5c7ebb, 0xff5b7dbc, 0xff5b7dbc, 0xff5c7ebd, 0xff5d7fbe, 0xff5d80bf,
    0xff5d80bf, 0xff5e80c0, 0xff5f81c0, 0xff6082c0, 0xff6082c0, 0xff6284c0, 0xff6485c1, 0xff6585c1,
    0xff6685c1, 0xff6785c1, 0xff6887c1, 0xff6a89c1, 0xff6b89c1, 0xff6b88c1, 0xff6b88c1, 0xff6b88c1,
    0xff6b88c1, 0xff6b89c3, 0xff6c89c3, 0xff6d89c2, 0xff6e8ac0, 0xff708bc1, 0xff728cc3, 0xff718cc3,
    0xff6e8bc1, 0xff6d8ac0, 0xff6f89c0, 0xff7189c1, 0xff738ac2, 0xff758cc3, 0xff768cc3, 0xff768bc2,
    0xff768bc2, 0xff768cc1, 0xff768dc1, 0xff768dc0, 0xff778dc0, 0xff7a8ec1, 0xff7c8fc2, 0xff7c8fc2,
    0xff7b8fc2, 0xff7c91c6, 0xff8094cc, 0xff7e93ce, 0xff758cca, 0xff6c86c4, 0xff6884be, 0xff6582b8,
    0xff627fb3, 0xff607ab0, 0xff5c76ac, 0xff5a74aa, 0xff5773a9, 0xff5573aa, 0xff5473aa, 0xff5572a5,
    0xff5570a1, 0xff536e9f, 0xff506da0, 0xff4f6ca0, 0xff4f6c9f, 0xff506c9e, 0xff4e6b9d, 0xff4e6ba1,
    0xff516fae, 0xff5271b0, 0xff4e6b8d, 0xff48625b, 0xff495f3e, 0xff506441, 0xff536647, 0xff4d5e47,
    0xff455541, 0xff3f4d33, 0xff3d4928, 0xff404e2a, 0xff465836, 0xff4c634f, 0xff506c6c, 0xff4d6a72,
    0xff425953, 0xff364733, 0xff283725, 0xff233122, 0xff2f3c2a, 0xff434f37, 0xff4a563c, 0xff414e36,
    0xff3c4b3f, 0xff425562, 0xff4a5e77, 0xff4f606e, 0xff505f60, 0xff4a5d6b, 0xff415c82, 0xff3c5a90,
    0xff3c578f, 0xff3f5889, 0xff435d81, 0xff455d72, 0xff43575b, 0xff3e4c41, 0xff37412a, 0xff2f381a,
    0xff1e250c, 0xff0b1008, 0xff060d09, 0xff172210, 0xff2b3b18, 0xff293d1b, 0xff22331b, 0xff252517,
    0xff2b1812, 0xff27160f, 0xff191e0e, 0xff162d0f, 0xff253d11, 0xff374a1c, 0xff384d34, 0xff314849,
    0xff243c4c, 0xff193040, 0xff223531, 0xff3d4a24, 0xff454e17, 0xff2c340f, 0xff121e0c, 0xff1c2d0e,
    0xff2e4414, 0xff31481b, 0xff2a3f21, 0xff263a24, 0xff3b659d, 0xff3b659d, 0xff3c659e, 0xff3e669f,
    0xff4067a0, 0xff4269a2, 0xff456aa4, 0xff476aa5, 0xff486ca7, 0xff476da7, 0xff466ea7, 0xff476fa7,
    0xff486fa8, 0xff4a70aa, 0xff4c71ac, 0xff4d73ad, 0xff4e75af, 0xff4e75af, 0xff4f74ae, 0xff4f73ae,
    0xff4f74af, 0xff4f75b0, 0xff5076b1, 0xff5176b1, 0xff5276b1, 0xff5376b2, 0xff5476b2, 0xff5576b3,
    0xff5576b4, 0xff5677b4, 0xff5678b4, 0xff5678b4, 0xff5679b4, 0xff577ab4, 0xff577bb4, 0xff597bb4,
    0xff5a7bb6, 0xff5a7bb7, 0xff5a7cb8, 0xff597cb9, 0xff587cba, 0xff587bba, 0xff587aba, 0xff587abb,
    0xff587abb, 0xff587cbc, 0xff587dbd, 0xff5a7ebe, 0xff5b7ebe, 0xff5d7fbf, 0xff5e80c0, 0xff5f81c0,
    0xff5f82bf, 0xff6184bf, 0xff6285c0, 0xff6385c0, 0xff6484c0, 0xff6483c0, 0xff6484bf, 0xff6586bf,
    0xff6686bf, 0xff6786c0, 0xff6786c0, 0xff6886c1, 0xff6886c1, 0xff6987c2, 0xff6a87c2, 0xff6b87c2,
    0xff6c88c1, 0xff6e89c1, 0xff708ac2, 0xff6f8ac2, 0xff6c8ac0, 0xff6b8abf, 0xff6d88bf, 0xff7088c0,
    0xff7289c1, 0xff738bc2, 0xff748bc2, 0xff7489c3, 0xff7489c3, 0xff738ac3, 0xff738bc4, 0xff728bc6,
    0xff738bc7, 0xff758cc9, 0xff788eca, 0xff798fcc, 0xff7990cc, 0xff7990c6, 0xff7a8ebc, 0xff788bb3,
    0xff7288ae, 0xff6f87af, 0xff7289b6, 0xff738abd, 0xff6e86bc, 0xff657fb5, 0xff5e7ab0, 0xff5c78ae,
    0xff5b77ab, 0xff5976a5, 0xff5975a0, 0xff5a749b, 0xff5b7397, 0xff5c7293, 0xff5b7091, 0xff566d92,
    0xff4e6998, 0xff48669d, 0xff48669e, 0xff4a699d, 0xff4e6e9f, 0xff507095, 0xff486672, 0xff3c5647,
    0xff394e2c, 0xff40512e, 0xff445435, 0xff425237, 0xff3e4e36, 0xff3c492b, 0xff3b4622, 0xff3b461f,
    0xff3d4a25, 0xff405136, 0xff44594d, 0xff455b58, 0xff42544b, 0xff3a4937, 0xff2e3c28, 0xff27351f,
    0xff2e3c22, 0xff3c4b2c, 0xff425030, 0xff3d4a2c, 0xff3c4b36, 0xff475a59, 0xff4e6269, 0xff4a5a57,
    0xff434f40, 0xff3e4e47, 0xff3d5361, 0xff3d5774, 0xff3d5679, 0xff3f577a, 0xff425d78, 0xff425c6a,
    0xff3b4f4d, 0xff323f2e, 0xff2b351e, 0xff262f1b, 0xff1c2415, 0xff11160f, 0xff0f130d, 0xff171e10,
    0xff202d15, 0xff1c2f18, 0xff162918, 0xff191e16, 0xff1f1212, 0xff1c0e0d, 0xff111309, 0xff0f210a,
    0xff1e3512, 0xff314825, 0xff364f40, 0xff344e56, 0xff2a4457, 0xff213949, 0xff283d3d, 0xff3c4f38,
    0xff3f4f2e, 0xff25331d, 0xff09170d, 0xff0c1c08, 0xff192b0c, 0xff213516, 0xff263a22, 0xff283c28,
    0xff3b649f, 0xff3b649f, 0xff3c65a0, 0xff3d66a2, 0xff3e67a2, 0xff4068a2, 0xff4269a4, 0xff456aa6,
    0xff476ca8, 0xff466da8, 0xff466ea8, 0xff476fa9, 0xff486fa9, 0xff486fa9, 0xff4970aa, 0xff4a71ab,
    0xff4b72ac, 0xff4d73ae, 0xff4e73ae, 0xff4e73af, 0xff4e74b0, 0xff4e75b0, 0xff4e75b1, 0xff4e75b1,
    0xff4f75b1, 0xff5175b1, 0xff5375b2, 0xff5475b3, 0xff5475b4, 0xff5576b4, 0xff5577b3, 0xff5577b3,
    0xff5578b4, 0xff5679b4, 0xff577ab3, 0xff577ab3, 0xff5779b4, 0xff5779b5, 0xff567ab8, 0xff567ab9,
    0xff567ab9, 0xff567ab9, 0xff577aba, 0xff587abb, 0xff587abb, 0xff567bbc, 0xff567cbc, 0xff587cbd,
    0xff5a7dbe, 0xff5c7ebf, 0xff5e80c0, 0xff5f81c0, 0xff6082bf, 0xff6184bf, 0xff6285c1, 0xff6285c1,
    0xff6283c0, 0xff6282bf, 0xff6282bf, 0xff6384bf, 0xff6485bf, 0xff6486c0, 0xff6686c1, 0xff6686c2,
    0xff6786c2, 0xff6885c1, 0xff6885c1, 0xff6986c1, 0xff6a87c2, 0xff6c87c2, 0xff6e88c1, 0xff6d88c0,
    0xff6b89bf, 0xff6a89bf, 0xff6d88c0, 0xff7088c1, 0xff718ac1, 0xff718bc1, 0xff728ac2, 0xff7288c3,
    0xff7287c5, 0xff7188c6, 0xff7189c7, 0xff718acb, 0xff718bcd, 0xff728ccf, 0xff748dd0, 0xff768fd4,
    0xff7790d5, 0xff768cc4, 0xff7284a9, 0xff6e7f93, 0xff6e808d, 0xff728697, 0xff7b8dac, 0xff8092c1,
    0xff7a8ec4, 0xff6c85b9, 0xff627fb2, 0xff617eb2, 0xff617dac, 0xff617a9e, 0xff617894, 0xff617790,
    0xff61768e, 0xff657587, 0xff687480, 0xff5f6f85, 0xff4e6893, 0xff42639e, 0xff4363a2, 0xff49679b,
    0xff4d6e90, 0xff4d6f7b, 0xff42625b, 0xff334d3d, 0xff2c4029, 0xff314127, 0xff37452c, 0xff394930,
    0xff3a4c32, 0xff3d4c2d, 0xff3e4927, 0xff3b4522, 0xff364121, 0xff354229, 0xff384735, 0xff3d4d40,
    0xff425244, 0xff42513f, 0xff394832, 0xff304025, 0xff304220, 0xff364b22, 0xff3a4e26, 0xff3b4b29,
    0xff414f37, 0xff4e5f56, 0xff52655f, 0xff445445, 0xff334027, 0xff303f29, 0xff384a40, 0xff3c5155,
    0xff3d535f, 0xff3e5667, 0xff415d6e, 0xff405b63, 0xff384d45, 0xff2c3a24, 0xff232c17, 0xff1d2419,
    0xff181d17, 0xff161912, 0xff16190e, 0xff161b0f, 0xff152013, 0xff102419, 0xff0d241c, 0xff0f1b1a,
    0xff140f14, 0xff130a0d, 0xff0d0e06, 0xff0e1b07, 0xff182e13, 0xff27432b, 0xff325049, 0xff395660,
    0xff385363, 0xff314a56, 0xff30484d, 0xff354c4b, 0xff2f4440, 0xff1a2b28, 0xff051310, 0xff020d06,
    0xff081408, 0xff132112, 0xff1f2f20, 0xff253728, 0xff3e67a3, 0xff3e67a3, 0xff3e69a5, 0xff3f6aa7,
    0xff406ba6, 0xff426ba5, 0xff446ca6, 0xff456ca9, 0xff476eaa, 0xff476faa, 0xff4770aa, 0xff4870ab,
    0xff4970ab, 0xff4970ab, 0xff4971ab, 0xff4971ab, 0xff4a72ac, 0xff4c72ae, 0xff4d73af, 0xff4e74b0,
    0xff4e75b1, 0xff4d75b1, 0xff4d75b2, 0xff4d75b3, 0xff4e75b2, 0xff4f75b1, 0xff5175b2, 0xff5275b4,
    0xff5375b5, 0xff5376b4, 0xff5377b3, 0xff5378b4, 0xff5478b5, 0xff5579b5, 0xff5579b3, 0xff5579b3,
    0xff5477b3, 0xff5477b4, 0xff5478b7, 0xff5479b9, 0xff5479b9, 0xff5479b9, 0xff5579ba, 0xff587abb,
    0xff587abb, 0xff567bbc, 0xff557cbc, 0xff587dbd, 0xff5b7ebe, 0xff5d7fbf, 0xff5e81c0, 0xff5f82c0,
    0xff6083bf, 0xff6084bf, 0xff6185c1, 0xff6185c1, 0xff6183bf, 0xff6182be, 0xff6282be, 0xff6384bf,
    0xff6485c0, 0xff6586c1, 0xff6586c1, 0xff6686c2, 0xff6686c2, 0xff6785c1, 0xff6784c0, 0xff6784c1,
    0xff6885c2, 0xff6985c1, 0xff6b86c0, 0xff6b86be, 0xff6987be, 0xff6988be, 0xff6c88bf, 0xff6f88c0,
    0xff7089c0, 0xff6f8ac0, 0xff6f89c0, 0xff7087c1, 0xff7086c1, 0xff6f86c2, 0xff6f87c3, 0xff6f88c5,
    0xff6f89c6, 0xff6e88c6, 0xff6e88c5, 0xff708bcb, 0xff738ed0, 0xff7088b9, 0xff697b92, 0xff647372,
    0xff65766a, 0xff6d7f79, 0xff7c8a98, 0xff8693b7, 0xff7f90bd, 0xff6f86b2, 0xff6580ab, 0xff6580ac,
    0xff6780a5, 0xff677b91, 0xff667883, 0xff647680, 0xff637581, 0xff677476, 0xff6c726a, 0xff626e72,
    0xff4f698c, 0xff4165a2, 0xff4264a7, 0xff49679d, 0xff4e6f8b, 0xff4f7170, 0xff426153, 0xff30493b,
    0xff253828, 0xff263323, 0xff2b3724, 0xff31422b, 0xff384b30, 0xff3d4d30, 0xff3e4b2c, 0xff384226,
    0xff2f3920, 0xff2b361f, 0xff2e3a22, 0xff35422c, 0xff3f4e3b, 0xff445441, 0xff42523a, 0xff3c4c2d,
    0xff374b22, 0xff354c1d, 0xff354d1f, 0xff394c27, 0xff425237, 0xff51634f, 0xff526552, 0xff3f5035,
    0xff293715, 0xff263411, 0xff314122, 0xff374935, 0xff364841, 0xff364b4d, 0xff3a5459, 0xff3a5554,
    0xff344b3a, 0xff2a3b1c, 0xff1f2b12, 0xff161f17, 0xff131917, 0xff181b12, 0xff191c0e, 0xff14180f,
    0xff0e1815, 0xff0f211d, 0xff122823, 0xff102120, 0xff0d1217, 0xff0d0d0d, 0xff101207, 0xff131d09,
    0xff162a14, 0xff1f3c2c, 0xff2f4f4a, 0xff3e5b62, 0xff415b65, 0xff3a5157, 0xff324850, 0xff2c4351,
    0xff233848, 0xff16272f, 0xff0c1616, 0xff090d0c, 0xff0d0d0d, 0xff171915, 0xff232a21, 0xff2b3327,
    0xff4773ab, 0xff4773ab, 0xff4571ac, 0xff4470ad, 0xff4570ad, 0xff4671ac, 0xff4670ac, 0xff466fad,
    0xff466fad, 0xff4670ad, 0xff4771ad, 0xff4872ae, 0xff4972ae, 0xff4972ae, 0xff4972af, 0xff4972af,
    0xff4a72b0, 0xff4a72b0, 0xff4b72b1, 0xff4c73b2, 0xff4c74b3, 0xff4c75b3, 0xff4c75b4, 0xff4c75b5,
    0xff4c75b4, 0xff4d75b3, 0xff4e75b3, 0xff4f75b5, 0xff5075b6, 0xff5076b5, 0xff5076b4, 0xff5076b4,
    0xff5076b5, 0xff5076b5, 0xff5176b5, 0xff5176b5, 0xff5075b4, 0xff5075b4, 0xff5076b6, 0xff5177b8,
    0xff5178b9, 0xff5379ba, 0xff557abb, 0xff587bbc, 0xff597bbc, 0xff587cbd, 0xff577dbd, 0xff5a7fbe,
    0xff5c80bf, 0xff5d81bf, 0xff5e82bf, 0xff5f83bf, 0xff6084c0, 0xff6185c0, 0xff6285c1, 0xff6285c1,
    0xff6183bf, 0xff6182be, 0xff6182be, 0xff6284c0, 0xff6385c1, 0xff6487c2, 0xff6587c2, 0xff6587c1,
    0xff6586c0, 0xff6684bf, 0xff6683bf, 0xff6683c0, 0xff6784c1, 0xff6884c0, 0xff6884be, 0xff6884bd,
    0xff6785bd, 0xff6786bd, 0xff6a87be, 0xff6c87bf, 0xff6c87c0, 0xff6c87bf, 0xff6d87be, 0xff6f87bb,
    0xff6f87ba, 0xff6f86ba, 0xff6e86b8, 0xff6e88b2, 0xff6d88ab, 0xff6a83a2, 0xff677f9c, 0xff6983a6,
    0xff6d89b3, 0xff6b84a4, 0xff63757e, 0xff5a685c, 0xff51634d, 0xff546857, 0xff647674, 0xff758595,
    0xff75879e, 0xff6a8097, 0xff667d94, 0xff6a7f96, 0xff6c7e8f, 0xff69787a, 0xff65726b, 0xff606f6c,
    0xff5c6d6f, 0xff5c695e, 0xff5e654a, 0xff5b675c, 0xff556f8d, 0xff5073b3, 0xff4d6fb9, 0xff4f6ead,
    0xff5476a5, 0xff567a92, 0xff4a6a6e, 0xff375047, 0xff293b29, 0xff263321, 0xff283322, 0xff2f3d28,
    0xff34462d, 0xff37482d, 0xff354628, 0xff2e3d22, 0xff26321b, 0xff243017, 0xff283618, 0xff2d3e1f,
    0xff30432b, 0xff374935, 0xff455338, 0xff505a35, 0xff4a582b, 0xff3a5121, 0xff334c1d, 0xff364c22,
    0xff3e502d, 0xff495b3e, 0xff4b5d3f, 0xff3e4e2b, 0xff2f3c13, 0xff29350c, 0xff2a3813, 0xff27351b,
    0xff222e21, 0xff202f2b, 0xff283d39, 0xff2f493b, 0xff334c2e, 0xff31471c, 0xff263715, 0xff182516,
    0xff111813, 0xff12170e, 0xff13180b, 0xff0f180d, 0xff111e16, 0xff202f24, 0xff2c3d2e, 0xff233527,
    0xff112216, 0xff0e1c0e, 0xff1b2511, 0xff232e15, 0xff1b2f17, 0xff193521, 0xff2f4b3c, 0xff445b53,
    0xff40524f, 0xff2b3b3c, 0xff1e2c34, 0xff1f2c3b, 0xff212b3a, 0xff21262c, 0xff27241f, 0xff362720,
    0xff452e27, 0xff4b342b, 0xff49382b, 0xff483b2b, 0xff527eb5, 0xff527eb5, 0xff4e7bb4, 0xff4b78b3,
    0xff4b78b3, 0xff4c78b3, 0xff4b76b2, 0xff4974b1, 0xff4772b0, 0xff4772b0, 0xff4873b0, 0xff4a74b1,
    0xff4b75b2, 0xff4c75b3, 0xff4c74b3, 0xff4c74b3, 0xff4b74b4, 0xff4b74b4, 0xff4c74b4, 0xff4c74b4,
    0xff4c75b4, 0xff4c76b5, 0xff4d77b7, 0xff4e77b8, 0xff4e77b8, 0xff4d76b7, 0xff4d76b7, 0xff4e77b7,
    0xff4f77b7, 0xff4f77b6, 0xff4f77b6, 0xff4f77b6, 0xff4e76b6, 0xff4e75b6, 0xff4e74b7, 0xff4e74b7,
    0xff4f74b6, 0xff4f74b6, 0xff4f76b6, 0xff5077b7, 0xff5178b9, 0xff527abb, 0xff567bbc, 0xff5a7cbd,
    0xff5c7ebe, 0xff5b7fbe, 0xff5a80bf, 0xff5c81c1, 0xff5d82c1, 0xff5e83c0, 0xff5f83bf, 0xff6083c0,
    0xff6184c1, 0xff6284c2, 0xff6385c2, 0xff6385c1, 0xff6284bf, 0xff6283be, 0xff6284bf, 0xff6385c1,
    0xff6486c2, 0xff6687c2, 0xff6687c1, 0xff6587bf, 0xff6586be, 0xff6585be, 0xff6684bf, 0xff6784bf,
    0xff6784bf, 0xff6784be, 0xff6783bd, 0xff6783bb, 0xff6684bb, 0xff6685bb, 0xff6886bc, 0xff6986bd,
    0xff6985bf, 0xff6985c0, 0xff6b86bb, 0xff6d89b4, 0xff6e89af, 0xff6e87ae, 0xff6d85a9, 0xff6d869b,
    0xff6b858c, 0xff657c79, 0xff60756f, 0xff637a7c, 0xff688292, 0xff67808e, 0xff607473, 0xff536455,
    0xff425440, 0xff3d5240, 0xff4c6156, 0xff607572, 0xff667b7c, 0xff62777a, 0xff64777a, 0xff6b7a7d,
    0xff6e7978, 0xff697165, 0xff616958, 0xff59655c, 0xff526260, 0xff4c5b4b, 0xff495633, 0xff4f5f4c,
    0xff5a748d, 0xff6081bf, 0xff597ac4, 0xff5474ba, 0xff5a7cc3, 0xff5e81bd, 0xff547391, 0xff425a55,
    0xff33442b, 0xff2d3a22, 0xff2b3724, 0xff2f3c28, 0xff32422c, 0xff314429, 0xff2c4122, 0xff263a1c,
    0xff213219, 0xff213318, 0xff283b1b, 0xff2a401e, 0xff233b20, 0xff273d25, 0xff445030, 0xff5e6238,
    0xff5a6234, 0xff435628, 0xff354d20, 0xff354b1f, 0xff3a4d24, 0xff3f522f, 0xff425433, 0xff42512b,
    0xff3c481d, 0xff313e16, 0xff253413, 0xff172410, 0xff0e170f, 0xff0d1512, 0xff17271d, 0xff253d24,
    0xff334f25, 0xff395621, 0xff31491b, 0xff1f3015, 0xff111b0e, 0xff0a1209, 0xff091108, 0xff0b180c,
    0xff1a2b19, 0xff35422c, 0xff495338, 0xff3a492d, 0xff1a3316, 0xff142d0f, 0xff2a3c1c, 0xff354323,
    0xff253719, 0xff193014, 0xff314528, 0xff48563c, 0xff394334, 0xff161f1c, 0xff090e14, 0xff17171e,
    0xff282426, 0xff312a25, 0xff443527, 0xff664836, 0xff825743, 0xff825641, 0xff6e4a35, 0xff63432e,
    0xff5d8abc, 0xff5d8abc, 0xff5885ba, 0xff5481b8, 0xff5481b9, 0xff5581ba, 0xff537fb8, 0xff4f7cb5,
    0xff4d79b3, 0xff4d78b3, 0xff4e78b4, 0xff4f7ab5, 0xff507bb6, 0xff517ab7, 0xff5179b8, 0xff5179b8,
    0xff5079b8, 0xff5079b8, 0xff5078b7, 0xff5078b7, 0xff507ab7, 0xff507bb8, 0xff527cb9, 0xff537cbb,
    0xff537cbb, 0xff517bbb, 0xff517bbb, 0xff517bba, 0xff517bb9, 0xff527bb9, 0xff527bb9, 0xff517bb8,
    0xff507ab8, 0xff5079b9, 0xff5078bb, 0xff5077bb, 0xff5177ba, 0xff5177b9, 0xff5178b8, 0xff5279b8,
    0xff537aba, 0xff557cbc, 0xff577dbd, 0xff5b7ebe, 0xff5d80bf, 0xff5e81bf, 0xff5e82c0, 0xff5f83c1,
    0xff5f84c1, 0xff5f84bf, 0xff5f84be, 0xff5f84bf, 0xff6085c1, 0xff6285c2, 0xff6385c2, 0xff6485c1,
    0xff6384bf, 0xff6284bf, 0xff6285c0, 0xff6386c1, 0xff6587c2, 0xff6688c2, 0xff6788c1, 0xff6687be,
    0xff6586bd, 0xff6585be, 0xff6684bf, 0xff6784bf, 0xff6784be, 0xff6784bd, 0xff6683bc, 0xff6683bc,
    0xff6584bb, 0xff6584bb, 0xff6685ba, 0xff6785bc, 0xff6784bf, 0xff6883c0, 0xff6a85b8, 0xff6c89aa,
    0xff6d889f, 0xff6c849b, 0xff6a8192, 0xff69817f, 0xff667e6b, 0xff607555, 0xff5b6d4a, 0xff5d7158,
    0xff617b70, 0xff607a75, 0xff5b7165, 0xff4e614e, 0xff3a4d39, 0xff344834, 0xff415741, 0xff556b55,
    0xff5b715d, 0xff586d5d, 0xff5d6e5f, 0xff677263, 0xff6c735f, 0xff666a51, 0xff5d6248, 0xff535e4d,
    0xff495b52, 0xff3f513b, 0xff384a22, 0xff42563e, 0xff597382, 0xff6684b7, 0xff5d7cb9, 0xff5373b1,
    0xff597bc7, 0xff5e81cc, 0xff5875a0, 0xff4a605d, 0xff3b4a2d, 0xff303d22, 0xff2b3823, 0xff2e3c27,
    0xff31422b, 0xff2b4125, 0xff243d1d, 0xff203919, 0xff203619, 0xff253c1c, 0xff2d4721, 0xff2e4b22,
    0xff223e1c, 0xff243b1c, 0xff424d29, 0xff606137, 0xff606537, 0xff4b5b2e, 0xff3b5224, 0xff374d1e,
    0xff374b1c, 0xff3c5024, 0xff42552a, 0xff47572b, 0xff465227, 0xff394620, 0xff253517, 0xff101e0c,
    0xff030904, 0xff000300, 0xff081206, 0xff1a2c10, 0xff304b1d, 0xff405e25, 0xff3b5521, 0xff273916,
    0xff121e0b, 0xff050e05, 0xff020c05, 0xff0c1a0d, 0xff26361e, 0xff495133, 0xff606241, 0xff4e5834,
    0xff28401a, 0xff203d15, 0xff3a5027, 0xff46552d, 0xff303f1b, 0xff1c2d0b, 0xff303c18, 0xff444a27,
    0xff30331d, 0xff0a0c07, 0xff000000, 0xff170d0a, 0xff332217, 0xff463122, 0xff614531, 0xff8b6047,
    0xffa97255, 0xffa0694d, 0xff7f5138, 0xff6b432b, 0xff6894be, 0xff6894be, 0xff658fbc, 0xff628cbb,
    0xff628cbc, 0xff628dbe, 0xff608cbd, 0xff5e89bb, 0xff5c87b9, 0xff5c86b8, 0xff5c85b8, 0xff5c86b9,
    0xff5c86ba, 0xff5c85bb, 0xff5c83bb, 0xff5c83bb, 0xff5c84bb, 0xff5c84bb, 0xff5c83ba, 0xff5c83ba,
    0xff5a82ba, 0xff5a83bb, 0xff5c85bc, 0xff5f87be, 0xff5f87bf, 0xff5f86be, 0xff5e86bd, 0xff5d86bc,
    0xff5c85bb, 0xff5a82bb, 0xff5981bc, 0xff5981bb, 0xff5a82bb, 0xff5b82bc, 0xff5b81be, 0xff5b81bf,
    0xff5b80be, 0xff5a80bd, 0xff587fbb, 0xff567eba, 0xff557dba, 0xff557cbb, 0xff557cbc, 0xff557cbc,
    0xff577ebe, 0xff597fbf, 0xff5b80bf, 0xff5d82bf, 0xff5d83bf, 0xff5c82be, 0xff5a81bd, 0xff5a81bd,
    0xff5b82bf, 0xff5d82bf, 0xff5f82bf, 0xff6082bf, 0xff5d81c0, 0xff5b81c0, 0xff5b81c0, 0xff5c82bf,
    0xff5d83c0, 0xff5f84c0, 0xff6084bf, 0xff6083bc, 0xff6082bb, 0xff6081bc, 0xff6080bd, 0xff6180bd,
    0xff6281bd, 0xff6280bc, 0xff607fbb, 0xff607fbb, 0xff6080bb, 0xff6080ba, 0xff6080b7, 0xff6080b8,
    0xff6180be, 0xff6280bf, 0xff6682b0, 0xff69849a, 0xff6b8486, 0xff6a817d, 0xff667c72, 0xff5f7660,
    0xff5a7252, 0xff596e44, 0xff5b6c3e, 0xff5c6e47, 0xff5c7256, 0xff59705c, 0xff546a54, 0xff4f624a,
    0xff4d5840, 0xff51583e, 0xff5c6345, 0xff64704e, 0xff5c6d4d, 0xff4d6246, 0xff4a5e44, 0xff536547,
    0xff5d6848, 0xff5e6244, 0xff5a5c42, 0xff505846, 0xff455547, 0xff3a5036, 0xff354c23, 0xff3c5634,
    0xff4d6a63, 0xff577585, 0xff506e85, 0xff496781, 0xff4f6e96, 0xff5674a1, 0xff536c84, 0xff4a5b52,
    0xff39452a, 0xff28341c, 0xff21301b, 0xff2c3e25, 0xff344a2d, 0xff2b4526, 0xff203c1c, 0xff1f3b1a,
    0xff24401e, 0xff2e4b24, 0xff375728, 0xff3c5e2a, 0xff3b5a25, 0xff3a5422, 0xff405026, 0xff484f2b,
    0xff4d562f, 0xff4e5f2f, 0xff485e29, 0xff3e5320, 0xff3c521c, 0xff4b6325, 0xff566d2c, 0xff53662c,
    0xff485727, 0xff394b21, 0xff2a411b, 0xff172b10, 0xff071206, 0xff000100, 0xff000000, 0xff081301,
    0xff253a16, 0xff405d29, 0xff415c2a, 0xff2f421c, 0xff19240f, 0xff060d07, 0xff010807, 0xff111913,
    0xff313927, 0xff52503a, 0xff675e45, 0xff5c573b, 0xff404627, 0xff3b4923, 0xff505e30, 0xff566233,
    0xff3e4721, 0xff252a0f, 0xff2b2c12, 0xff35341a, 0xff2a2917, 0xff171710, 0xff16110f, 0xff291b14,
    0xff432b1f, 0xff5e3c2f, 0xff7a4f3f, 0xff94624c, 0xff9e6a4f, 0xff885b41, 0xff63412a, 0xff4d321d,
    0xff6e97be, 0xff6e97be, 0xff6d95bc, 0xff6c94bc, 0xff6b94bd, 0xff6b95bf, 0xff6b95bf, 0xff6c95bf,
    0xff6c93bd, 0xff6b92bc, 0xff6a91bb, 0xff6991bb, 0xff6890bc, 0xff668ebc, 0xff658cbc, 0xff668cbc,
    0xff678dbd, 0xff688dbd, 0xff698ebd, 0xff688ebd, 0xff658cbd, 0xff648bbd, 0xff678dbe, 0xff6a90c0,
    0xff6c91c1, 0xff6c90c0, 0xff6a90bf, 0xff698fbe, 0xff668dbd, 0xff628abd, 0xff6188be, 0xff6389be,
    0xff658bbf, 0xff688cc0, 0xff688cc2, 0xff688cc2, 0xff658bc1, 0xff6389c0, 0xff6086be, 0xff5d84bd,
    0xff5a80bb, 0xff567dba, 0xff537bba, 0xff517bbb, 0xff527bbc, 0xff567dbd, 0xff5a7fbd, 0xff5b82bc,
    0xff5b82bc, 0xff5981bc, 0xff577fbc, 0xff577fbc, 0xff5880bc, 0xff5a80bc, 0xff5d81bc, 0xff5e81bd,
    0xff5a80bf, 0xff5780c0, 0xff5680be, 0xff5780bc, 0xff5880bc, 0xff5a81be, 0xff5c81be, 0xff5d80bc,
    0xff5d7fbb, 0xff5c7ebc, 0xff5c7ebd, 0xff5d7fbd, 0xff5f80bd, 0xff5f80bc, 0xff5d7ebb, 0xff5d7ebb,
    0xff5e7fbb, 0xff5e7fb9, 0xff5d7eb6, 0xff5d7db6, 0xff5e7ebe, 0xff6080bf, 0xff6481ac, 0xff66808e,
    0xff687e72, 0xff687c64, 0xff627658, 0xff556b4c, 0xff4f6547, 0xff546744, 0xff5c6c45, 0xff5d6d49,
    0xff596b4c, 0xff52684c, 0xff4d6548, 0xff516547, 0xff65694b, 0xff776f51, 0xff7f7856, 0xff7b7c57,
    0xff646f4e, 0xff465c3f, 0xff395337, 0xff425a38, 0xff4e603d, 0xff575e42, 0xff585b45, 0xff515846,
    0xff465643, 0xff3e5539, 0xff3a552e, 0xff3a5832, 0xff3f5d42, 0xff415e4d, 0xff3d584b, 0xff3c554a,
    0xff425c57, 0xff486261, 0xff485e57, 0xff425141, 0xff333d28, 0xff1f2917, 0xff182614, 0xff293f24,
    0xff365130, 0xff2d4a29, 0xff213e1e, 0xff23401d, 0xff2d4c25, 0xff395b2c, 0xff42652f, 0xff4c6f32,
    0xff587833, 0xff56702f, 0xff405326, 0xff2b391e, 0xff344323, 0xff4d602d, 0xff54692d, 0xff455a24,
    0xff435921, 0xff5d782d, 0xff6b8834, 0xff5c742e, 0xff435624, 0xff364d20, 0xff33501f, 0xff264119,
    0xff16270f, 0xff060d05, 0xff000000, 0xff010201, 0xff1e2915, 0xff3b522a, 0xff40582d, 0xff334323,
    0xff1f2816, 0xff0b100b, 0xff07090b, 0xff1a1a18, 0xff39362d, 0xff50483b, 0xff5f5143, 0xff5d4e3e,
    0xff514432, 0xff514b2e, 0xff5c5f33, 0xff5b6232, 0xff474925, 0xff2e2a18, 0xff252015, 0xff242017,
    0xff26251f, 0xff2d2c28, 0xff36312d, 0xff3d322c, 0xff4f3830, 0xff6c463d, 0xff835248, 0xff855547,
    0xff754e3d, 0xff573d2b, 0xff352918, 0xff221d0d, 0xff7099bd, 0xff7099bd, 0xff7299bd, 0xff7399bd,
    0xff729abe, 0xff729bc0, 0xff749cc1, 0xff769dc2, 0xff779dc2, 0xff769cc0, 0xff759bbf, 0xff7399bf,
    0xff7298bf, 0xff7096bf, 0xff6f94be, 0xff7094be, 0xff7195be, 0xff7297be, 0xff7397bf, 0xff7297bf,
    0xff6f93bf, 0xff6e92bf, 0xff7194c0, 0xff7497c1, 0xff7799c1, 0xff7799c1, 0xff7599c0, 0xff7398bf,
    0xff6f95be, 0xff6b92bf, 0xff6a90c0, 0xff6c91c0, 0xff6f94c1, 0xff7295c2, 0xff7395c4, 0xff7295c4,
    0xff7093c4, 0xff6c91c3, 0xff688ec2, 0xff658bc0, 0xff6186bd, 0xff5d82bb, 0xff5a80bb, 0xff5880bc,
    0xff5980bd, 0xff5b82bd, 0xff5f83bd, 0xff6185bc, 0xff6185bc, 0xff6084bd, 0xff5f83be, 0xff5f83bd,
    0xff5f84bc, 0xff6084bc, 0xff6285bd, 0xff6385bf, 0xff6085c2, 0xff5e85c3, 0xff5e86c1, 0xff6086be,
    0xff6086be, 0xff6085bf, 0xff6285bf, 0xff6484bf, 0xff6584bf, 0xff6483bf, 0xff6483bf, 0xff6584c0,
    0xff6786c0, 0xff6786bf, 0xff6685be, 0xff6685be, 0xff6786bf, 0xff6786bd, 0xff6784b9, 0xff6783b9,
    0xff6986c2, 0xff6b87c3, 0xff6b85ac, 0xff698087, 0xff657963, 0xff61754f, 0xff586d41, 0xff4a603b,
    0xff455b3f, 0xff4d6145, 0xff596a4c, 0xff596a4a, 0xff526444, 0xff4a5f40, 0xff445d3e, 0xff4e6344,
    0xff737353, 0xff8e7f5f, 0xff958663, 0xff89825e, 0xff6a7050, 0xff465a3f, 0xff334f35, 0xff385534,
    0xff445b39, 0xff4f5b41, 0xff535a46, 0xff505946, 0xff485842, 0xff41583d, 0xff3c5737, 0xff35542e,
    0xff304f26, 0xff2c4a1e, 0xff2b461a, 0xff2d451b, 0xff31481f, 0xff354a25, 0xff38492b, 0xff38452e,
    0xff2c3526, 0xff172115, 0xff101e0f, 0xff223a20, 0xff32502d, 0xff2d4a28, 0xff264120, 0xff2d4923,
    0xff3b5c2d, 0xff486b34, 0xff4e7135, 0xff597b38, 0xff6e8b3e, 0xff6b843a, 0xff405627, 0xff182c15,
    0xff253819, 0xff50632a, 0xff5e712f, 0xff4b5c26, 0xff465823, 0xff647d30, 0xff738f36, 0xff5d742d,
    0xff3e5021, 0xff374c1f, 0xff3e5b23, 0xff395421, 0xff2a3b1a, 0xff161e0f, 0xff020201, 0xff010101,
    0xff161e12, 0xff304125, 0xff38492a, 0xff2f3b23, 0xff202719, 0xff0f130f, 0xff0e0d0f, 0xff241e1e,
    0xff413732, 0xff4d403a, 0xff52443c, 0xff56423a, 0xff593f37, 0xff5a4632, 0xff5b562e, 0xff55582a,
    0xff484626, 0xff352b21, 0xff211818, 0xff161215, 0xff222224, 0xff3b3c39, 0xff4a4942, 0xff48423b,
    0xff534139, 0xff704e45, 0xff81544b, 0xff6c453c, 0xff462f26, 0xff241c13, 0xff0b1108, 0xff000a01,
    0xff749dc6, 0xff749dc6, 0xff759fc6, 0xff77a0c6, 0xff77a0c7, 0xff77a1c9, 0xff79a3ca, 0xff7da4ca,
    0xff7fa5ca, 0xff7ea4ca, 0xff7da3c9, 0xff7da2c9, 0xff7ca1c8, 0xff7a9ec7, 0xff789cc5, 0xff789bc4,
    0xff789cc3, 0xff789cc3, 0xff799dc2, 0xff779bc2, 0xff7398c1, 0xff7296c1, 0xff7598c2, 0xff799bc4,
    0xff7c9ec5, 0xff7e9ec5, 0xff7c9dc3, 0xff779bc1, 0xff7499c0, 0xff7497c2, 0xff7597c4, 0xff7597c3,
    0xff7698c2, 0xff7899c2, 0xff7a9ac3, 0xff7a9ac4, 0xff799ac5, 0xff7699c5, 0xff7397c5, 0xff7094c4,
    0xff6d90c1, 0xff6d8ebf, 0xff718fbf, 0xff7693c0, 0xff7894c1, 0xff7693c2, 0xff7492c2, 0xff7492c0,
    0xff7593c0, 0xff7894c2, 0xff7b96c4, 0xff7b96c4, 0xff7996c3, 0xff7996c3, 0xff7a96c3, 0xff7b96c4,
    0xff7c98c7, 0xff7e9ac9, 0xff829dca, 0xff869fca, 0xff869fca, 0xff839dca, 0xff849cca, 0xff869dcb,
    0xff879dcb, 0xff869bca, 0xff859ac9, 0xff859bc9, 0xff879dca, 0xff899eca, 0xff8b9fc9, 0xff8d9fc9,
    0xff8d9fca, 0xff8d9fca, 0xff8e9ec7, 0xff8f9fc7, 0xff91a2d2, 0xff8fa1d2, 0xff8496b8, 0xff74868e,
    0xff60725f, 0xff4f633f, 0xff41582d, 0xff3b542f, 0xff3c563b, 0xff405941, 0xff455c44, 0xff475a41,
    0xff45543b, 0xff3e5036, 0xff344d34, 0xff3c533a, 0xff60654a, 0xff7c7357, 0xff84775a, 0xff7c7357,
    0xff666a51, 0xff4e604b, 0xff415a46, 0xff445c45, 0xff485d43, 0xff465841, 0xff465640, 0xff4a5944,
    0xff4a5a46, 0xff3f5340, 0xff2f4735, 0xff223e25, 0xff1e3b17, 0xff1c390c, 0xff1b3808, 0xff1b3607,
    0xff182e03, 0xff182904, 0xff202e12, 0xff2a3723, 0xff273425, 0xff192417, 0xff101e0f, 0xff162c15,
    0xff213b1d, 0xff284120, 0xff324924, 0xff465e2e, 0xff5a7639, 0xff64813d, 0xff5f7b39, 0xff5f7938,
    0xff70873f, 0xff6e833d, 0xff475a2b, 0xff243519, 0xff33431b, 0xff5d6b2a, 0xff67732d, 0xff4c5824,
    0xff3e491f, 0xff515e25, 0xff5e6a2a, 0xff4e5826, 0xff3b4322, 0xff3e4923, 0xff4c5c27, 0xff4b5b25,
    0xff3c451d, 0xff2c2e15, 0xff211d10, 0xff1c170f, 0xff191a11, 0xff182014, 0xff162015, 0xff141c14,
    0xff101511, 0xff0a0f0b, 0xff141510, 0xff2f2b22, 0xff494234, 0xff4a4533, 0xff44402d, 0xff463a2a,
    0xff4c362a, 0xff473524, 0xff3b391c, 0xff333a19, 0xff37381f, 0xff362e23, 0xff211b1a, 0xff101013,
    0xff1b1f1e, 0xff363a32, 0xff45483a, 0xff414333, 0xff4a4532, 0xff66593f, 0xff725e44, 0xff51402f,
    0xff221814, 0xff080504, 0xff010401, 0xff000300, 0xff729dcc, 0xff729dcc, 0xff749fcc, 0xff75a0cc,
    0xff75a0ce, 0xff75a1cf, 0xff77a2cf, 0xff7ba4cd, 0xff7da5cd, 0xff7da5cf, 0xff7da4cf, 0xff7ea4ce,
    0xff7ea3cc, 0xff7da2cb, 0xff7ba0ca, 0xff7a9fc8, 0xff799ec6, 0xff799dc4, 0xff799dc4, 0xff779bc3,
    0xff7398c1, 0xff7297c1, 0xff7499c3, 0xff789bc5, 0xff7c9ec6, 0xff7d9fc6, 0xff7b9dc4, 0xff7699c2,
    0xff7497c1, 0xff7899c4, 0xff7b9bc6, 0xff799ac4, 0xff7798c1, 0xff7898c1, 0xff7a99c1, 0xff7c9bc3,
    0xff7c9dc4, 0xff7c9dc5, 0xff7a9bc6, 0xff799ac6, 0xff7998c5, 0xff7c99c4, 0xff889fc4, 0xff95a6c5,
    0xff98a8c6, 0xff90a4c7, 0xff89a0c7, 0xff879fc5, 0xff89a1c5, 0xff90a5c7, 0xff97aaca, 0xff99aacb,
    0xff96a9cc, 0xff93a7cc, 0xff91a6cb, 0xff92a6cb, 0xff98aacc, 0xffa0aece, 0xffa7b3d2, 0xffacb6d5,
    0xffabb5d6, 0xffa7b2d5, 0xffa5b1d5, 0xffa7b4d6, 0xffa8b5d6, 0xffa6b3d4, 0xffa5b1d3, 0xffa4b1d3,
    0xffa5b2d3, 0xffaab4d3, 0xffafb6d4, 0xffb2b7d4, 0xffb2b6d5, 0xffb1b6d5, 0xffb3b7d3, 0xffb4b9d5,
    0xffb6bce0, 0xffb0b8e0, 0xff9da7c6, 0xff818e9a, 0xff5d6e66, 0xff40553c, 0xff304826, 0xff324e2d,
    0xff3a573c, 0xff38553d, 0xff35503a, 0xff374c38, 0xff3b4938, 0xff354635, 0xff294231, 0xff2a4533,
    0xff43523e, 0xff5a5d47, 0xff64614a, 0xff64614d, 0xff606553, 0xff5a695a, 0xff566a5d, 0xff57685b,
    0xff526352, 0xff415941, 0xff3a5539, 0xff455a42, 0xff4d5c4a, 0xff3e4d41, 0xff22362d, 0xff122a1d,
    0xff162e17, 0xff1a3313, 0xff163410, 0xff102f0d, 0xff081f05, 0xff041301, 0xff0f1c0d, 0xff1f2e20,
    0xff253426, 0xff1e2b1d, 0xff142112, 0xff0b1c0c, 0xff0f220e, 0xff213318, 0xff3d4d27, 0xff5b6e35,
    0xff72883f, 0xff778e41, 0xff687c39, 0xff5e6e35, 0xff647439, 0xff63733a, 0xff4d5b2e, 0xff3b4721,
    0xff4b5422, 0xff68702b, 0xff696e2a, 0xff4b4f21, 0xff353619, 0xff373518, 0xff3f3a1b, 0xff3c3720,
    0xff3b3824, 0xff464628, 0xff545729, 0xff555824, 0xff49481a, 0xff403b17, 0xff433c1f, 0xff3d3721,
    0xff221f14, 0xff050605, 0xff000000, 0xff000004, 0xff010606, 0xff060c07, 0xff171d10, 0xff353723,
    0xff4d4d31, 0xff484d2b, 0xff38421f, 0xff343819, 0xff353019, 0xff2a2512, 0xff181d09, 0xff131d08,
    0xff232915, 0xff323021, 0xff232419, 0xff131810, 0xff161e15, 0xff272f21, 0xff303925, 0xff2f3820,
    0xff394222, 0xff535c30, 0xff5e6437, 0xff3d3e23, 0xff110e0a, 0xff000000, 0xff000300, 0xff000600,
    0xff6894c5, 0xff6894c5, 0xff6995c4, 0xff6a97c4, 0xff6b97c5, 0xff6c97c7, 0xff6e98c6, 0xff719ac5,
    0xff739bc5, 0xff739bc7, 0xff749bc8, 0xff779cc6, 0xff789cc5, 0xff799cc5, 0xff789bc5, 0xff779ac4,
    0xff7699c3, 0xff7699c1, 0xff7799c1, 0xff7799c0, 0xff7598bf, 0xff7497bf, 0xff7598c0, 0xff7799c2,
    0xff789ac2, 0xff799ac2, 0xff7899c0, 0xff7596bf, 0xff7495bf, 0xff7999c2, 0xff7d9bc4, 0xff7c9ac2,
    0xff7998bf, 0xff7998be, 0xff7b98be, 0xff7d9ac0, 0xff7d9cc1, 0xff7e9dc3, 0xff7e9dc5, 0xff809ec6,
    0xff829fc6, 0xff89a2c6, 0xff98aac7, 0xffa9b2c7, 0xffadb4c9, 0xffa3b0ca, 0xff98abca, 0xff95aac9,
    0xff98acc9, 0xffa1b2cc, 0xffaab7cf, 0xffabb7d0, 0xffa6b4cf, 0xffa2b1cf, 0xff9fafce, 0xffa1afce,
    0xffa9b4ce, 0xffb3b9cf, 0xffbbbed3, 0xffc0c1d7, 0xffbebfd7, 0xffb8bbd6, 0xffb5bad6, 0xffb6bdd8,
    0xffb7bfd8, 0xffb7bed6, 0xffb6bcd4, 0xffb4bbd4, 0xffb4bbd4, 0xffb9bdd4, 0xffc0c1d5, 0xffc4c2d5,
    0xffc3c1d6, 0xffc4c2d6, 0xffc9c5d5, 0xffcbc8d7, 0xffcccae1, 0xffc2c3e0, 0xffabb1ca, 0xff8a96a3,
    0xff60726f, 0xff3d5141, 0xff2b4228, 0xff344d31, 0xff415a40, 0xff3d563e, 0xff364d39, 0xff364938,
    0xff3a4a39, 0xff344737, 0xff284232, 0xff264331, 0xff374c39, 0xff495440, 0xff515642, 0xff565a46,
    0xff5f6654, 0xff677364, 0xff6b786c, 0xff687369, 0xff5b695b, 0xff415d43, 0xff365838, 0xff445f43,
    0xff53624f, 0xff424f44, 0xff20322b, 0xff12251c, 0xff1b2e1e, 0xff223821, 0xff1d3b20, 0xff14331a,
    0xff071c0f, 0xff000907, 0xff08100e, 0xff1a261d, 0xff233124, 0xff212d1f, 0xff172115, 0xff041107,
    0xff031105, 0xff1c2914, 0xff414d2a, 0xff647039, 0xff79873f, 0xff7b883e, 0xff677235, 0xff555e2e,
    0xff4f592e, 0xff4d572f, 0xff47502a, 0xff474e25, 0xff565c25, 0xff686d28, 0xff636626, 0xff47491e,
    0xff2e2c16, 0xff22180f, 0xff24160f, 0xff2c1f19, 0xff3b3125, 0xff4b432a, 0xff575129, 0xff5c5624,
    0xff584e1d, 0xff574d1e, 0xff605a2c, 0xff58552f, 0xff302f1b, 0xff060603, 0xff000000, 0xff000000,
    0xff030605, 0xff0b1309, 0xff1d2813, 0xff394124, 0xff4c532e, 0xff445125, 0xff314315, 0xff27360d,
    0xff242a0c, 0xff161a07, 0xff040d00, 0xff020e02, 0xff182311, 0xff2e361e, 0xff27311a, 0xff192511,
    0xff141f0e, 0xff172010, 0xff192410, 0xff1b290d, 0xff263912, 0xff3b5520, 0xff425d27, 0xff283617,
    0xff050703, 0xff000000, 0xff000301, 0xff000903, 0xff557ca9, 0xff557ca9, 0xff557da8, 0xff567ea8,
    0xff577ea9, 0xff587eaa, 0xff597fa9, 0xff5b80a9, 0xff5d82aa, 0xff5f82ad, 0xff6083af, 0xff6284ad,
    0xff6485ac, 0xff6988ae, 0xff6e8cb2, 0xff728fb6, 0xff7492b8, 0xff7794b9, 0xff7996b9, 0xff7d99bb,
    0xff839ec0, 0xff84a0c3, 0xff809dc0, 0xff7a98bc, 0xff7695b9, 0xff7694b9, 0xff7996bb, 0xff7f9abf,
    0xff829cc1, 0xff809bc0, 0xff7f9abf, 0xff829dc1, 0xff86a0c4, 0xff89a2c4, 0xff89a2c3, 0xff87a1c3,
    0xff849ec3, 0xff839ec4, 0xff86a2c8, 0xff8ba6ca, 0xff8ea8cb, 0xff94abcb, 0xff9eafcb, 0xffa9b3cc,
    0xffabb4cc, 0xffa3b2cd, 0xff9db0ce, 0xff9db1cf, 0xffa0b3d0, 0xffa8b8d3, 0xffaebad5, 0xffabb7d3,
    0xffa4b2cf, 0xff9dadcc, 0xff99abcd, 0xff9bacce, 0xffa3b1cf, 0xffaab4cf, 0xffaeb5cd, 0xffadb3cb,
    0xffa9afc8, 0xffa3abc6, 0xff9ea8c5, 0xff9ca9c6, 0xff9caac6, 0xffa0adc4, 0xffa2adc3, 0xff9faac2,
    0xff9ca7c1, 0xffa0a9c1, 0xffa6adc2, 0xffaaafc2, 0xffa7adc0, 0xffaaaec0, 0xffb4b5c2, 0xffb9b9c4,
    0xffb4b7c7, 0xffa8afc4, 0xff9ca7b8, 0xff8d9ca2, 0xff6f8279, 0xff4e624d, 0xff3c4e30, 0xff455233,
    0xff545b40, 0xff585a44, 0xff575845, 0xff515742, 0xff49593d, 0xff3e5837, 0xff365632, 0xff395834,
    0xff4c6040, 0xff5c6749, 0xff5e6748, 0xff5c6847, 0xff656e4f, 0xff71775a, 0xff72795e, 0xff677459,
    0xff566b4d, 0xff43623d, 0xff3d6037, 0xff4a6741, 0xff576a4b, 0xff4a593f, 0xff303f29, 0xff24331f,
    0xff2b3b25, 0xff31442b, 0xff30472c, 0xff273e25, 0xff162517, 0xff060c09, 0xff050808, 0xff0d1210,
    0xff101612, 0xff0b120f, 0xff050a09, 0xff000002, 0xff000203, 0xff121813, 0xff2a3525, 0xff404a2b,
    0xff4d5428, 0xff4f5323, 0xff46481e, 0xff373918, 0xff262914, 0xff1c2111, 0xff1b220e, 0xff222b0d,
    0xff323b0f, 0xff434a13, 0xff434a15, 0xff343c13, 0xff21260e, 0xff0f0d04, 0xff0c0501, 0xff16110a,
    0xff292918, 0xff393c1f, 0xff454921, 0xff555524, 0xff625b26, 0xff675f28, 0xff5f642a, 0xff4d5b28,
    0xff344420, 0xff1d2a16, 0xff151b0f, 0xff191a0c, 0xff1a1e0b, 0xff17260c, 0xff1d3313, 0xff2d401f,
    0xff3a4727, 0xff354320, 0xff283714, 0xff1d2b0c, 0xff162109, 0xff101907, 0xff0e1508, 0xff131b0c,
    0xff1f2c13, 0xff283b18, 0xff253b16, 0xff1b3210, 0xff0f2208, 0xff051102, 0xff000c00, 0xff001300,
    0xff062101, 0xff123109, 0xff19350e, 0xff101f09, 0xff020401, 0xff000000, 0xff000000, 0xff000300,
    0xff416287, 0xff416287, 0xff416387, 0xff416487, 0xff426588, 0xff436589, 0xff446589, 0xff45658a,
    0xff47678c, 0xff496990, 0xff4b6b91, 0xff4a6a8e, 0xff4d6c8e, 0xff557294, 0xff5f7a9c, 0xff6782a4,
    0xff6e88ab, 0xff748eae, 0xff7890ae, 0xff7f96b2, 0xff8ca1bd, 0xff90a5c2, 0xff889fbd, 0xff7b95b4,
    0xff728eae, 0xff708bae, 0xff7791b3, 0xff849bbc, 0xff8aa1c0, 0xff819aba, 0xff7b96b7, 0xff849cbe,
    0xff90a5c6, 0xff94a9c8, 0xff92a9c6, 0xff8ca4c4, 0xff859ec2, 0xff839bc2, 0xff89a1c7, 0xff8fa7ca,
    0xff92aacb, 0xff94abca, 0xff96abca, 0xff97a9cb, 0xff97a9cb, 0xff95a9cc, 0xff95accd, 0xff98afd0,
    0xff9cb2d2, 0xffa0b4d5, 0xffa2b3d6, 0xff9cadd0, 0xff91a6c9, 0xff8aa1c5, 0xff879fc6, 0xff89a1c9,
    0xff8ea4cc, 0xff91a4ca, 0xff8d9fc2, 0xff8797b8, 0xff8192b1, 0xff7d8eaf, 0xff788bad, 0xff7389ad,
    0xff748bae, 0xff7b90ae, 0xff8093ae, 0xff7c8fad, 0xff788aab, 0xff798cab, 0xff7e90ab, 0xff8092aa,
    0xff7d90a7, 0xff8191a6, 0xff909ba9, 0xff979faa, 0xff8e99a7, 0xff8292a1, 0xff8397a0, 0xff899f9b,
    0xff7f9381, 0xff67795a, 0xff58633e, 0xff5d5b39, 0xff6a5e43, 0xff79634e, 0xff806b57, 0xff746e52,
    0xff5f6e45, 0xff50703b, 0xff4c7138, 0xff56753e, 0xff707e50, 0xff7f835b, 0xff7a8357, 0xff6e7f4e,
    0xff707c4b, 0xff78794b, 0xff727547, 0xff607140, 0xff506d3b, 0xff4b6a39, 0xff4e6b3c, 0xff557043,
    0xff5c7348, 0xff56683e, 0xff4a582e, 0xff434f28, 0xff43522e, 0xff455734, 0xff485936, 0xff435031,
    0xff323a22, 0xff1e1f12, 0xff120f0a, 0xff0d0909, 0xff060305, 0xff020001, 0xff000001, 0xff000005,
    0xff00060d, 0xff091319, 0xff142121, 0xff1b231d, 0xff1e1f13, 0xff221f0c, 0xff25240b, 0xff202009,
    0xff0e0c04, 0xff000000, 0xff000000, 0xff000800, 0xff0c1a02, 0xff1e2c05, 0xff29370a, 0xff28370f,
    0xff202d0e, 0xff101905, 0xff091000, 0xff0f1904, 0xff1d2d0e, 0xff293c15, 0xff33471b, 0xff4d5826,
    0xff6b6932, 0xff746f34, 0xff546325, 0xff39571c, 0xff3a5a26, 0xff445d32, 0xff4a5730, 0xff4a4b25,
    0xff3e411b, 0xff2b3e16, 0xff203d17, 0xff243c1d, 0xff2c3a23, 0xff2c3421, 0xff282d1b, 0xff1f2515,
    0xff171f10, 0xff1c2112, 0xff2c2c1b, 0xff363720, 0xff313c1c, 0xff273f15, 0xff234213, 0xff1e3c11,
    0xff12250a, 0xff050903, 0xff000000, 0xff000500, 0xff000e00, 0xff001000, 0xff000e00, 0xff000800,
    0xff000100, 0xff000000, 0xff000000, 0xff000000, 0xff2a4966, 0xff2a4966, 0xff2a4a67, 0xff2a4b68,
    0xff2b4c68, 0xff2d4c69, 0xff2d4c6a, 0xff2d4c6d, 0xff2f4e70, 0xff325072, 0xff345272, 0xff325170,
    0xff345471, 0xff3d5c78, 0xff4a6683, 0xff56708e, 0xff5e7896, 0xff677f9c, 0xff6b839c, 0xff748aa1,
    0xff8597b0, 0xff8a9cb6, 0xff8095af, 0xff6f88a3, 0xff647f9d, 0xff607c9d, 0xff6983a3, 0xff7b90ad,
    0xff8296b1, 0xff738daa, 0xff6a87a6, 0xff7890b0, 0xff899cbb, 0xff90a2bf, 0xff8ca1bd, 0xff849cba,
    0xff7a93b7, 0xff768fb6, 0xff7d96ba, 0xff849dbe, 0xff87a0bf, 0xff86a0be, 0xff819bbd, 0xff7a95bd,
    0xff7994bd, 0xff7d97be, 0xff829cc1, 0xff88a2c4, 0xff8ba4c7, 0xff8da5cb, 0xff89a1ca, 0xff819ac3,
    0xff7791b8, 0xff708cb4, 0xff6f8cb6, 0xff718eba, 0xff738fbe, 0xff728dbc, 0xff6b85b1, 0xff627ca3,
    0xff5c779b, 0xff5a7599, 0xff577297, 0xff537198, 0xff557399, 0xff5f7a9b, 0xff667f9c, 0xff667e9d,
    0xff637b9d, 0xff627a9c, 0xff637c9a, 0xff627b97, 0xff607a94, 0xff657c93, 0xff768696, 0xff7f8c97,
    0xff768691, 0xff6c828c, 0xff778f90, 0xff8aa297, 0xff90a38a, 0xff86936f, 0xff7c7f57, 0xff7a6f4c,
    0xff826b50, 0xff97745e, 0xffa5826b, 0xff978765, 0xff798754, 0xff678849, 0xff678c48, 0xff769251,
    0xff949c66, 0xffa3a072, 0xff989e6b, 0xff85965d, 0xff7f8b50, 0xff828048, 0xff77793f, 0xff637739,
    0xff58783a, 0xff607b44, 0xff6b7e4e, 0xff6f8252, 0xff708351, 0xff72814c, 0xff727b44, 0xff6f7841,
    0xff6b7744, 0xff697747, 0xff6d7547, 0xff6b6d42, 0xff5d5c38, 0xff49462b, 0xff373120, 0xff291f17,
    0xff190f10, 0xff0f080d, 0xff0a0a10, 0xff0d171b, 0xff132426, 0xff19292d, 0xff1c282d, 0xff191c22,
    0xff130f14, 0xff18110e, 0xff262112, 0xff272512, 0xff121008, 0xff000000, 0xff000000, 0xff000800,
    0xff0b1905, 0xff1c2b0d, 0xff2d3e17, 0xff374a1f, 0xff374b21, 0xff2b3e19, 0xff233514, 0xff263c16,
    0xff2f481c, 0xff314d1e, 0xff345021, 0xff516230, 0xff7e7e45, 0xff8b874a, 0xff5e7030, 0xff3f6323,
    0xff547938, 0xff779353, 0xff879355, 0xff828145, 0xff6e6d35, 0xff515f2b, 0xff395125, 0xff2f4224,
    0xff303626, 0xff343129, 0xff39312a, 0xff332d26, 0xff2c2b21, 0xff373626, 0xff524833, 0xff5d5437,
    0xff4c512c, 0xff344a1d, 0xff2f4d1c, 0xff2b491c, 0xff1b2f12, 0xff070d05, 0xff000000, 0xff000700,
    0xff000e00, 0xff000800, 0xff000000, 0xff000000, 0xff000000, 0xff000301, 0xff000802, 0xff000b02,
    0xff082a45, 0xff082a45, 0xff092c47, 0xff0a2f4a, 0xff0b304b, 0xff0d314c, 0xff0f334f, 0xff123654,
    0xff143858, 0xff153a58, 0xff143a57, 0xff123854, 0xff133955, 0xff1a3f5b, 0xff244764, 0xff2e506e,
    0xff365775, 0xff3d5c79, 0xff3e5d78, 0xff43617b, 0xff516c86, 0xff56708c, 0xff4e6b87, 0xff40617e,
    0xff385a79, 0xff365778, 0xff3b5a7b, 0xff456280, 0xff476481, 0xff395a7a, 0xff36597b, 0xff4b6b8b,
    0xff647f9e, 0xff6e87a5, 0xff6a84a1, 0xff627e9c, 0xff597698, 0xff557396, 0xff5b789a, 0xff617d9d,
    0xff65809e, 0xff64809d, 0xff5d7a9b, 0xff547499, 0xff537299, 0xff5a779c, 0xff637da0, 0xff6982a4,
    0xff6b84a6, 0xff6a84a9, 0xff6580a9, 0xff5e7aa3, 0xff57749a, 0xff547197, 0xff55739b, 0xff57759f,
    0xff5875a2, 0xff5773a1, 0xff55709a, 0xff526d92, 0xff506b8d, 0xff4f698b, 0xff526b8c, 0xff577090,
    0xff5f7694, 0xff687c96, 0xff71829a, 0xff7a8aa2, 0xff8090a9, 0xff7e8ea8, 0xff7788a1, 0xff74859c,
    0xff74859a, 0xff7b8999, 0xff87919b, 0xff90979c, 0xff91999b, 0xff909a99, 0xff94a19a, 0xff9ba99b,
    0xffa5af96, 0xffaeb08f, 0xffb0a985, 0xffa99879, 0xffa78f76, 0xffb5947d, 0xffc09f85, 0xffb5a37f,
    0xff9ea373, 0xff91a36c, 0xff92a56d, 0xff9faa75, 0xffb9b585, 0xffc5ba8d, 0xffb9b687, 0xffa5ad79,
    0xff9da16d, 0xff9d9863, 0xff95935d, 0xff88955b, 0xff869b61, 0xff99a36e, 0xffa9a978, 0xffabaa79,
    0xffa9aa77, 0xffafae78, 0xffb8b47b, 0xffbab77a, 0xffb5b774, 0xffb1b26c, 0xffb1a763, 0xffae9e5e,
    0xffa79b60, 0xff9b9663, 0xff8c875d, 0xff7e7454, 0xff70654e, 0xff675f4e, 0xff646252, 0xff6a6f57,
    0xff6f795a, 0xff70775b, 0xff6c6e58, 0xff656252, 0xff5d584a, 0xff615b48, 0xff6f6c4c, 0xff72714c,
    0xff5f5e42, 0xff4f4f3b, 0xff4a503a, 0xff4f5a3e, 0xff586643, 0xff647349, 0xff728251, 0xff7c8f57,
    0xff7e9358, 0xff768a51, 0xff70854e, 0xff788f57, 0xff80985f, 0xff768c56, 0xff677947, 0xff7e8450,
    0xffb0a96c, 0xffc5bb77, 0xff9da560, 0xff809651, 0xff97aa63, 0xffbac27a, 0xffcac67e, 0xffc5b872,
    0xffb2a262, 0xff978f56, 0xff797548, 0xff5e593b, 0xff504434, 0xff544037, 0xff60453e, 0xff62493f,
    0xff5f4d3d, 0xff685742, 0xff79634b, 0xff7e694c, 0xff6e6542, 0xff585d36, 0xff505c34, 0xff495733,
    0xff384129, 0xff26261d, 0xff221e19, 0xff2c2b1f, 0xff373423, 0xff3a2f22, 0xff3c2920, 0xff432f24,
    0xff463527, 0xff3d3424, 0xff2f2e1e, 0xff272a1a, 0xff001a36, 0xff001a36, 0xff001f3b, 0xff00233f,
    0xff002440, 0xff002641, 0xff022945, 0xff052e4c, 0xff06314f, 0xff05324f, 0xff03314c, 0xff012e4a,
    0xff012e4a, 0xff04304d, 0xff093452, 0xff0f3958, 0xff153d5d, 0xff183e5e, 0xff163c5b, 0xff173d5b,
    0xff1d4361, 0xff204665, 0xff1d4364, 0xff173e60, 0xff143b5d, 0xff133b5c, 0xff13395a, 0xff133859,
    0xff0f3556, 0xff053052, 0xff083558, 0xff20496b, 0xff3b5f7f, 0xff466786, 0xff436282, 0xff3e5d7d,
    0xff375a79, 0xff345877, 0xff385979, 0xff3c5b7b, 0xff3f5e7c, 0xff405e7b, 0xff3b5b79, 0xff355676,
    0xff365677, 0xff3d5a7b, 0xff455f7f, 0xff4b6382, 0xff4c6483, 0xff4a6485, 0xff466285, 0xff415f83,
    0xff3d5c80, 0xff3e5d7f, 0xff436082, 0xff466284, 0xff456087, 0xff456088, 0xff4b648a, 0xff52698a,
    0xff546a89, 0xff546a87, 0xff5d708a, 0xff6b7c91, 0xff788597, 0xff7f8799, 0xff878d9f, 0xff9a9faf,
    0xffa9afbc, 0xffa7acbb, 0xff9a9fb0, 0xff9598a9, 0xff999ba8, 0xff9fa0a9, 0xffa5a5a9, 0xffadacac,
    0xffb9b6b2, 0xffc0bdb6, 0xffb8b8ad, 0xffabada0, 0xffb0b09e, 0xffc5bfa7, 0xffd1c6ab, 0xffc6baa3,
    0xffbbaf9a, 0xffbeae96, 0xffc3b193, 0xffbfb290, 0xffb6b28e, 0xffb0b18c, 0xffaeaf8d, 0xffb6b392,
    0xffc9be9c, 0xffd2c3a0, 0xffc8be9b, 0xffb8b591, 0xffb1ae89, 0xffb1ab85, 0xffafad84, 0xffacb286,
    0xffb4bb8e, 0xffcac699, 0xffdacca0, 0xffdcca9f, 0xffdac99d, 0xffe1d1a4, 0xffebddae, 0xfff1e6ab,
    0xffefe89e, 0xffeae08c, 0xffe4ce78, 0xffe0c474, 0xffdfcc83, 0xffded896, 0xffd8d599, 0xffcfca91,
    0xffc7c18e, 0xffc3bf93, 0xffc2c094, 0xffc4c58e, 0xffc6c889, 0xffc6c386, 0xffc4bc85, 0xffbfb886,
    0xffbbb789, 0xffbdbb8b, 0xffc3c28d, 0xffc4c48b, 0xffbabb85, 0xffb2b481, 0xffb0b483, 0xffb3b987,
    0xffb7bf8a, 0xffbcc58c, 0xffc2cc8e, 0xffc7d390, 0xffc7d48f, 0xffc1cf89, 0xffbfcd8a, 0xffcbda99,
    0xffd2e1a2, 0xffbcc68d, 0xff9ea06d, 0xffa9a06b, 0xffd9c889, 0xfff4e29d, 0xffded691, 0xffcac885,
    0xffd6ce8a, 0xffead793, 0xfff3da96, 0xffefd692, 0xffe3c688, 0xffd3b27c, 0xffb7956a, 0xff937555,
    0xff795c46, 0xff7c5947, 0xff8a6250, 0xff926b55, 0xff947258, 0xff95765a, 0xff94755b, 0xff90735a,
    0xff897156, 0xff7e6d51, 0xff72684d, 0xff656049, 0xff575141, 0xff4d443a, 0xff53453b, 0xff655545,
    0xff78624c, 0xff80644a, 0xff856447, 0xff8e6c4d, 0xff8f7151, 0xff7b6648, 0xff5f543a, 0xff4e4932,
    0xff00233d, 0xff00233d, 0xff002741, 0xff002b45, 0xff002b45, 0xff002c46, 0xff03304a, 0xff093550,
    0xff0a3853, 0xff083751, 0xff06364f, 0xff05354e, 0xff05344e, 0xff05344f, 0xff053450, 0xff073552,
    0xff093553, 0xff083452, 0xff063250, 0xff04304e, 0xff03304e, 0xff043150, 0xff053152, 0xff073253,
    0xff093353, 0xff0a3452, 0xff08314f, 0xff032c4b, 0xff002848, 0xff002849, 0xff002d4e, 0xff0b3757,
    0xff164160, 0xff1c4463, 0xff1d4262, 0xff1c4160, 0xff19425e, 0xff18425d, 0xff19405d, 0xff1b3f5d,
    0xff1e405e, 0xff1f415e, 0xff1d405c, 0xff1a3e58, 0xff1d3f59, 0xff23435d, 0xff2a4762, 0xff2f4965,
    0xff304a66, 0xff2d4a67, 0xff2a4968, 0xff274868, 0xff284869, 0xff2b4b6a, 0xff314f6b, 0xff34516c,
    0xff314f6d, 0xff335070, 0xff3f5a78, 0xff4c647f, 0xff516781, 0xff516780, 0xff5e7085, 0xff72808e,
    0xff818a94, 0xff848995, 0xff8b8e9b, 0xffa5a7af, 0xffbabcc0, 0xffb8babe, 0xffa7a8b1, 0xffa09faa,
    0xffa6a3ab, 0xffaca8ad, 0xffadaaac, 0xffb3b1b0, 0xffc7c2bc, 0xffd5ccc3, 0xffc5bfb5, 0xffa9a7a0,
    0xffa9a69e, 0xffc5beb1, 0xffd7cdbe, 0xffc9c5b8, 0xffb7baac, 0xffb2b5a2, 0xffb2b39a, 0xffb4b298,
    0xffb5b19c, 0xffb5ae9f, 0xffb3aba0, 0xffb6aca2, 0xffc2b6a6, 0xffc7bca7, 0xffc0b7a4, 0xffb5af9f,
    0xffb0ad9c, 0xffb1b19b, 0xffb4b79f, 0xffbabea5, 0xffc6c7ac, 0xffdcd2b4, 0xffead7b7, 0xffedd4b5,
    0xffecd1b4, 0xfff2dbbf, 0xfffcebcc, 0xfffff8c9, 0xfffffbb8, 0xfffef4a0, 0xfff7de89, 0xfff4d585,
    0xfff8e59b, 0xfffefbb8, 0xffffffc0, 0xffffffbb, 0xfffefdbc, 0xfffdfdc2, 0xfffdfdc2, 0xfffefcb5,
    0xfffefaa8, 0xfffef3a2, 0xfffdeea3, 0xfffdf1aa, 0xfffcf8b4, 0xfffcfdba, 0xfffdfdba, 0xfffdfdb8,
    0xfffcfcb6, 0xfffbfbb6, 0xfffbfbb8, 0xfffcfcbb, 0xfffcfcbb, 0xfffcfdb9, 0xfffcfdb7, 0xfffdfeb6,
    0xfffdfeb4, 0xfffcfeb2, 0xfffdffb5, 0xffffffc2, 0xffffffc6, 0xffe0dba7, 0xffb7aa7d, 0xffb7a375,
    0xffe0cb92, 0xffffedab, 0xffffeead, 0xfffde5a7, 0xfffedea1, 0xffffd89c, 0xffffdb9e, 0xffffe1a2,
    0xfffed99f, 0xfffac996, 0xffe7af85, 0xffc4926e, 0xffa77d5d, 0xffa97c5e, 0xffb78667, 0xffc3916e,
    0xffc89973, 0xffc19671, 0xffb1886b, 0xffa47f66, 0xffa57f68, 0xffa37f69, 0xff927562, 0xff816a5a,
    0xff746254, 0xff726151, 0xff7e6957, 0xff957863, 0xffa9866a, 0xffb38b68, 0xffb88e65, 0xffc0966a,
    0xffbd976c, 0xffa38761, 0xff816e50, 0xff6d6047, 0xff3c5b6d, 0xff3c5b6d, 0xff395c6e, 0xff355c6d,
    0xff31596b, 0xff2d5568, 0xff2c5568, 0xff2d566a, 0xff2d566a, 0xff2c5668, 0xff2d5668, 0xff31596b,
    0xff335a6d, 0xff335a6e, 0xff31586d, 0xff2e566b, 0xff2b5469, 0xff2c536a, 0xff2f566c, 0xff2f556c,
    0xff295067, 0xff254d64, 0xff294f67, 0xff2f546b, 0xff31576d, 0xff31586d, 0xff365b6f, 0xff3c5e72,
    0xff446579, 0xff4f7084, 0xff486a7f, 0xff284c62, 0xff052a43, 0xff002039, 0xff002741, 0xff012f47,
    0xff04334a, 0xff05354b, 0xff04324a, 0xff032f49, 0xff042e48, 0xff052f48, 0xff053047, 0xff063147,
    0xff083349, 0xff0b344c, 0xff0f374f, 0xff143a51, 0xff163c53, 0xff163d54, 0xff143d55, 0xff143d57,
    0xff143e59, 0xff17405a, 0xff1a4358, 0xff1d4558, 0xff1c4459, 0xff1e465d, 0xff264d64, 0xff30556b,
    0xff35596e, 0xff375b6f, 0xff436474, 0xff54707b, 0xff5e777f, 0xff5c727d, 0xff607481, 0xff798991,
    0xff909da0, 0xff8e9c9f, 0xff7d8d94, 0xff76858f, 0xff7c8790, 0xff818b92, 0xff808c91, 0xff859295,
    0xff99a1a2, 0xffa8acab, 0xff9ca1a1, 0xff838c8f, 0xff828c8e, 0xff999fa0, 0xffa5acab, 0xff94a3a3,
    0xff839997, 0xff809791, 0xff82978d, 0xff85958d, 0xff899290, 0xff8a8f93, 0xff888c93, 0xff898e95,
    0xff909698, 0xff939b99, 0xff909797, 0xff8a9195, 0xff879094, 0xff879495, 0xff8c9b99, 0xff94a29f,
    0xffa0aaa5, 0xffafb1a9, 0xffb8b4aa, 0xffbbb2a8, 0xffbcb1a8, 0xffc2bab2, 0xffcbc6bd, 0xffd0cfbb,
    0xffcfd1ad, 0xffcccd9b, 0xffcbc18a, 0xffcdbe89, 0xffd4cd9a, 0xffdde0b1, 0xffe2e9b9, 0xffe5eab6,
    0xffe9ebb7, 0xffecedbc, 0xffeeedbb, 0xfff0edae, 0xfff0eba3, 0xfff0e59e, 0xfff1e1a0, 0xfff2e6a7,
    0xfff4efb1, 0xfff8f5b7, 0xfffaf3b7, 0xfffdf4b7, 0xfffff9ba, 0xfffffbbb, 0xfffdf7b8, 0xfffbf1b4,
    0xfffbeeb1, 0xfffbeeaf, 0xfffdeead, 0xfffeeeac, 0xfffff4af, 0xffffffb7, 0xffffffb9, 0xfff8f2b2,
    0xffe3d5a0, 0xffb3a47b, 0xff837657, 0xff7f7052, 0xffa8956d, 0xffd5bd8b, 0xfff3d29e, 0xfffcd4a1,
    0xfff7ca97, 0xffebbd8a, 0xffe8bf8b, 0xffedca95, 0xfff4ce99, 0xfffbca97, 0xfff9c190, 0xffeab786,
    0xffdcb07f, 0xffdeb280, 0xffe7b986, 0xfff1bf8b, 0xfff6c28c, 0xffeab685, 0xffd1a179, 0xffbf9171,
    0xffbf8f73, 0xffbe8e75, 0xffaa806a, 0xff94735f, 0xff8a6f5a, 0xff8d735b, 0xff967a60, 0xffa28266,
    0xffaa8769, 0xffaa8765, 0xffa58660, 0xffa38761, 0xff9d8460, 0xff8a7658, 0xff73644e, 0xff665948,
    0xff8399a2, 0xff8399a2, 0xff7c969f, 0xff73909a, 0xff6b8994, 0xff64828e, 0xff5d7c89, 0xff587986,
    0xff567784, 0xff587884, 0xff5d7b87, 0xff64818d, 0xff698591, 0xff6b8693, 0xff698592, 0xff63808d,
    0xff5d7c89, 0xff607e8c, 0xff698694, 0xff6d8a98, 0xff658290, 0xff5f7d8b, 0xff63808d, 0xff6a8692,
    0xff6a8894, 0xff6a8995, 0xff77949e, 0xff8da4ab, 0xffa4b7bc, 0xffb7cace, 0xffa3b6be, 0xff5a707d,
    0xff0b2537, 0xff000e21, 0xff001f30, 0xff012d3e, 0xff043446, 0xff05374b, 0xff023449, 0xff003046,
    0xff002e44, 0xff002f44, 0xff023146, 0xff043549, 0xff05364c, 0xff03364c, 0xff03364d, 0xff083b50,
    0xff0c3e52, 0xff0e4053, 0xff0e4054, 0xff0e4056, 0xff0f4158, 0xff0f4157, 0xff0f4153, 0xff104251,
    0xff114353, 0xff134557, 0xff15465a, 0xff17485d, 0xff1b4c60, 0xff1f4f63, 0xff265566, 0xff2d5a69,
    0xff305b69, 0xff2b5566, 0xff2d5666, 0xff40636f, 0xff527178, 0xff517178, 0xff446872, 0xff3e626f,
    0xff416270, 0xff456471, 0xff456671, 0xff4a6c76, 0xff57767f, 0xff637e88, 0xff617a85, 0xff57707c,
    0xff56707c, 0xff607985, 0xff627c87, 0xff52717c, 0xff476973, 0xff496c74, 0xff507279, 0xff52717a,
    0xff516c78, 0xff516978, 0xff516878, 0xff536b7b, 0xff56717f, 0xff587582, 0xff577282, 0xff546f80,
    0xff536e7f, 0xff547180, 0xff587583, 0xff5d7a87, 0xff637e8a, 0xff6a808b, 0xff6e818a, 0xff718189,
    0xff74828a, 0xff7a8790, 0xff7f8d96, 0xff809096, 0xff7d918f, 0xff7d9187, 0xff859282, 0xff8d9582,
    0xff939c89, 0xff98a492, 0xff9ea995, 0xffa3ad93, 0xffa9af94, 0xffadb096, 0xffb1b195, 0xffb4b38e,
    0xffb6b489, 0xffb7b087, 0xffb9ae88, 0xffbbb28c, 0xffbfb990, 0xffc5be93, 0xffcbbf93, 0xffd3c195,
    0xffdcc99d, 0xffdecb9e, 0xffd6c395, 0xffcdb98b, 0xffccb686, 0xffd2b887, 0xffd9bb88, 0xffdebe89,
    0xffebc991, 0xffffdea1, 0xffffdca0, 0xffd9b884, 0xff9f835c, 0xff635138, 0xff383122, 0xff363124,
    0xff5c523c, 0xff907a5b, 0xffc29e78, 0xffd8ab82, 0xffd1a479, 0xffbf966b, 0xffba976c, 0xffc2a478,
    0xffd0b082, 0xffdeb986, 0xffebc28a, 0xfff4cc91, 0xfff9d596, 0xfffdda9a, 0xffffdb9a, 0xffffdb9a,
    0xffffd798, 0xfff7c68d, 0xffe2b07e, 0xffd19e75, 0xffcd9975, 0xffc79575, 0xffb18568, 0xff9b765a,
    0xff937455, 0xff967958, 0xff977b59, 0xff957859, 0xff8f7357, 0xff826d52, 0xff73654c, 0xff695e46,
    0xff605842, 0xff595141, 0xff544b41, 0xff524841, 0xffb2c1c6, 0xffb2c1c6, 0xffa9bbc0, 0xff9eb2b8,
    0xff94a9b0, 0xff8ba1a9, 0xff8199a2, 0xff79949d, 0xff76919a, 0xff7b929b, 0xff82979f, 0xff8ca0a7,
    0xff92a5ac, 0xff94a7ae, 0xff93a5ad, 0xff8ca0a7, 0xff839ba2, 0xff879ea5, 0xff94aab1, 0xff9cb0b7,
    0xff95aab0, 0xff90a5ab, 0xff95a9ae, 0xff9db0b5, 0xff9db1b7, 0xff9cb3ba, 0xffafc3c7, 0xffcddada,
    0xffedf3f0, 0xffffffff, 0xffe5eeed, 0xff7e8f96, 0xff0f2b3a, 0xff000e1d, 0xff002634, 0xff043947,
    0xff0e4151, 0xff144557, 0xff114255, 0xff0d3e51, 0xff0a3b4e, 0xff093a4d, 0xff0b3c50, 0xff0e4156,
    0xff0f4459, 0xff0c4358, 0xff0b4358, 0xff0f475b, 0xff124a5d, 0xff144b5d, 0xff144a5c, 0xff144a5d,
    0xff14495f, 0xff12485c, 0xff104758, 0xff0f4755, 0xff114956, 0xff124a59, 0xff10485a, 0xff0e475b,
    0xff0f485d, 0xff114b5f, 0xff124c5f, 0xff124b5e, 0xff0f485b, 0xff094357, 0xff0a4255, 0xff154757,
    0xff214d5b, 0xff1f4d5a, 0xff154958, 0xff0f4556, 0xff0f4256, 0xff124357, 0xff184a5d, 0xff1f5062,
    0xff265568, 0xff2c586d, 0xff30596e, 0xff315a6e, 0xff30596d, 0xff2e586d, 0xff285368, 0xff1b495c,
    0xff164457, 0xff1c4a5e, 0xff265369, 0xff26536a, 0xff224e65, 0xff204b62, 0xff224c63, 0xff244f66,
    0xff25526a, 0xff26546d, 0xff27546e, 0xff28536d, 0xff29536d, 0xff29536e, 0xff2b556f, 0xff2e5771,
    0xff2f5871, 0xff2d556f, 0xff2d546d, 0xff30566d, 0xff34586f, 0xff385a70, 0xff3a5c72, 0xff3a5c73,
    0xff375b73, 0xff3a5e75, 0xff486878, 0xff526e79, 0xff556e76, 0xff566b73, 0xff5b6d71, 0xff617172,
    0xff687472, 0xff6c7370, 0xff6f756f, 0xff72796d, 0xff747b6c, 0xff767a6d, 0xff78796f, 0xff7b7b6f,
    0xff7f7e6d, 0xff86816d, 0xff8e826d, 0xff978771, 0xffa3917b, 0xffa7957e, 0xffa18d73, 0xff9a8465,
    0xff9c8360, 0xffa78864, 0xffb18e67, 0xffb89369, 0xffc99f73, 0xffe7b787, 0xffe1b082, 0xffaa7c57,
    0xff5f3b22, 0xff230f04, 0xff040000, 0xff050606, 0xff251f18, 0xff574333, 0xff916b53, 0xffae7f62,
    0xffa87d5c, 0xff957250, 0xff917351, 0xff9a7e5d, 0xffab9069, 0xffbba171, 0xffd2b77e, 0xffeccf90,
    0xffffe29f, 0xffffe9a4, 0xffffe7a2, 0xffffe29e, 0xffffda98, 0xfff8c98d, 0xffe7b680, 0xffd8a676,
    0xffd29f75, 0xffca9871, 0xffb58963, 0xffa17b56, 0xff9a7952, 0xff9c7d56, 0xff967a54, 0xff8c724f,
    0xff7c6649, 0xff6a5b44, 0xff564f3d, 0xff454535, 0xff3c3e30, 0xff413e33, 0xff4c433c, 0xff534641,
    0xffa6b4bc, 0xffa6b4bc, 0xff9fadb7, 0xff97a6b1, 0xff909fab, 0xff8a9aa7, 0xff8498a3, 0xff8197a1,
    0xff8297a1, 0xff8697a3, 0xff8c9ba7, 0xff94a2ad, 0xff98a7b0, 0xff9ba9b2, 0xff9aa7b1, 0xff93a1ac,
    0xff8b9ca6, 0xff8c9ea8, 0xff96a6b0, 0xff9faeb6, 0xffa2b0b7, 0xffa5b2b9, 0xffadb9c0, 0xffb5c1c9,
    0xffb8c5cd, 0xffb9c8d0, 0xffc8d5da, 0xffdfe6e7, 0xfff6f9f7, 0xffffffff, 0xffeceff2, 0xff8b9aa4,
    0xff254253, 0xff052c40, 0xff1d485a, 0xff305b6e, 0xff376176, 0xff3b6379, 0xff396177, 0xff355e73,
    0xff335b6f, 0xff30586d, 0xff2e586e, 0xff2c5971, 0xff2d5d74, 0xff326177, 0xff346479, 0xff33647b,
    0xff2f617a, 0xff2a5c75, 0xff255770, 0xff25576e, 0xff275970, 0xff26596f, 0xff22576d, 0xff1f566c,
    0xff1f556a, 0xff21566b, 0xff275b6f, 0xff2a5e73, 0xff275c72, 0xff1f576d, 0xff165067, 0xff0f4a63,
    0xff0a455e, 0xff07425a, 0xff074158, 0xff083f55, 0xff093d53, 0xff063b52, 0xff023951, 0xff00344e,
    0xff002e4b, 0xff01314e, 0xff0f425c, 0xff195068, 0xff1e536c, 0xff1e516d, 0xff20516d, 0xff20516c,
    0xff1b4e68, 0xff144962, 0xff0e435d, 0xff093e59, 0xff0a3e5a, 0xff0f4360, 0xff144866, 0xff144964,
    0xff104760, 0xff0f465e, 0xff124860, 0xff144962, 0xff114761, 0xff104661, 0xff114762, 0xff144964,
    0xff184c66, 0xff1a4f69, 0xff1c4f6a, 0xff1c4e69, 0xff194b66, 0xff134763, 0xff104460, 0xff10445e,
    0xff14455f, 0xff18475f, 0xff1c4961, 0xff1f4b65, 0xff204c6a, 0xff244f6e, 0xff2d5873, 0xff325b72,
    0xff2f5568, 0xff2c4e5e, 0xff304f5d, 0xff375462, 0xff3c5662, 0xff3e555e, 0xff3e5359, 0xff3b5256,
    0xff395155, 0xff395157, 0xff3a5059, 0xff3a4f58, 0xff3b4d56, 0xff3c4951, 0xff3d444b, 0xff44464d,
    0xff53555d, 0xff5f6166, 0xff666460, 0xff6c6657, 0xff7a6c55, 0xff89755a, 0xff957b5e, 0xff997b60,
    0xffa07f64, 0xffb0896f, 0xffa57c65, 0xff704b3b, 0xff33140e, 0xff0e0000, 0xff070001, 0xff0e050a,
    0xff211315, 0xff422a26, 0xff6e473d, 0xff865748, 0xff845946, 0xff78543f, 0xff765640, 0xff7d5d48,
    0xff8a6d53, 0xff967d5b, 0xffa99168, 0xffc2a779, 0xffd6b987, 0xffdac08c, 0xffd8bf8a, 0xffdabc88,
    0xffddb783, 0xffdaaf7c, 0xffd1a876, 0xffcaa071, 0xffc69a70, 0xffbf926c, 0xffb08661, 0xffa07c55,
    0xff9a7b54, 0xff9c7e59, 0xff967c59, 0xff8e7453, 0xff836c4d, 0xff7a664b, 0xff706049, 0xff645944,
    0xff605641, 0xff6b5c47, 0xff7e6750, 0xff8a6d56, 0xff798999, 0xff798999, 0xff768697, 0xff728395,
    0xff6f8092, 0xff6e8092, 0xff708393, 0xff748897, 0xff788b9b, 0xff7a8c9d, 0xff7e8ea0, 0xff8291a1,
    0xff8593a2, 0xff8795a3, 0xff8694a2, 0xff808f9e, 0xff798a9a, 0xff778999, 0xff7b8b9a, 0xff8492a0,
    0xff919da9, 0xff9da7b4, 0xffa6b1be, 0xffaeb9c8, 0xffb4bfce, 0xffb8c2d0, 0xffbfc9d4, 0xffc7cfd8,
    0xffd0d6de, 0xffdcdee7, 0xffc7ccd8, 0xff8393a5, 0xff3f5c73, 0xff31546e, 0xff4c6d87, 0xff5e7e98,
    0xff607f9b, 0xff607e9a, 0xff617e99, 0xff5f7d96, 0xff5d7b93, 0xff5a788f, 0xff52738c, 0xff4b708b,
    0xff4f748e, 0xff5c7d94, 0xff638399, 0xff5c7f9a, 0xff507696, 0xff446d8d, 0xff3b6684, 0xff3a6481,
    0xff3e6883, 0xff3e6985, 0xff3b6885, 0xff376684, 0xff336180, 0xff376380, 0xff456e88, 0xff517990,
    0xff4a758c, 0xff386881, 0xff285c76, 0xff205470, 0xff1d516b, 0xff1f526b, 0xff20526a, 0xff1b4d66,
    0xff134661, 0xff0b415e, 0xff063d5c, 0xff003658, 0xff002e52, 0xff033457, 0xff1e4f6e, 0xff32637f,
    0xff366681, 0xff305f7c, 0xff2a5a77, 0xff245773, 0xff1c516c, 0xff154b66, 0xff134964, 0xff174c69,
    0xff1b4f6d, 0xff1d506d, 0xff1c506b, 0xff1b5068, 0xff195166, 0xff1a5267, 0xff1e546a, 0xff1e536a,
    0xff194e64, 0xff154b60, 0xff164c61, 0xff1b5065, 0xff20556a, 0xff235a6f, 0xff245b70, 0xff23586d,
    0xff1f5368, 0xff194f65, 0xff164c62, 0xff14495e, 0xff16485d, 0xff1b4c5f, 0xff215163, 0xff295769,
    0xff2f5a6e, 0xff335d71, 0xff335e71, 0xff2f5c6c, 0xff285462, 0xff224e59, 0xff244e5a, 0xff2b5461,
    0xff2e5562, 0xff2d525d, 0xff294d56, 0xff20464f, 0xff1a424c, 0xff18414d, 0xff184050, 0xff173d50,
    0xff15384f, 0xff0f2e47, 0xff09223b, 0xff0a223a, 0xff1a334e, 0xff2f485d, 0xff43575f, 0xff59645c,
    0xff70725f, 0xff817d65, 0xff8c8168, 0xff8a7d67, 0xff867565, 0xff846e62, 0xff735c55, 0xff4e3837,
    0xff2c171c, 0xff240f15, 0xff311b1e, 0xff3d2527, 0xff442b2b, 0xff503331, 0xff643f3a, 0xff70473e,
    0xff744b3e, 0xff734d3d, 0xff744f3f, 0xff785244, 0xff7d5a4a, 0xff826450, 0xff8a6f58, 0xff967a60,
    0xffa08366, 0xffa48969, 0xffa58b6a, 0xffa98c6a, 0xffaf8d6a, 0xffb3906a, 0xffb4936b, 0xffb5946b,
    0xffb6916b, 0xffb38b68, 0xffa9835f, 0xff9f7d58, 0xff997b59, 0xff987d5f, 0xff977e61, 0xff967c5e,
    0xff987c5c, 0xff9c7e5c, 0xffa0805e, 0xff9e805e, 0xff9f8360, 0xffac8b65, 0xffbd966b, 0xffc89c6e,
    0xff4e6278, 0xff4e6278, 0xff4e627a, 0xff4f627c, 0xff4f627c, 0xff51647c, 0xff586b81, 0xff607487,
    0xff65798d, 0xff667a8f, 0xff667990, 0xff687a8f, 0xff697a8d, 0xff6a7a8d, 0xff697a8c, 0xff65768a,
    0xff607287, 0xff5c6e83, 0xff5a6c7f, 0xff617283, 0xff748392, 0xff8693a3, 0xff919db0, 0xff98a4ba,
    0xffa0abc0, 0xffa4aec2, 0xffa5afc0, 0xffa0adbd, 0xff9eaabb, 0xffa1a9bc, 0xff96a0b6, 0xff73869f,
    0xff536f8c, 0xff557392, 0xff6d87a7, 0xff7c93b3, 0xff7c92b2, 0xff7a91af, 0xff7d93af, 0xff7d93ad,
    0xff7d91aa, 0xff798ea7, 0xff6f88a2, 0xff66839e, 0xff6b88a2, 0xff7e95ab, 0xff889ab1, 0xff7c92af,
    0xff6b85a9, 0xff5d7b9f, 0xff537396, 0xff517292, 0xff547692, 0xff547793, 0xff4f7595, 0xff4a7194,
    0xff466b8e, 0xff4a6d8e, 0xff5c7b97, 0xff6b88a1, 0xff64859d, 0xff507691, 0xff3f6986, 0xff39637f,
    0xff3a637d, 0xff446981, 0xff486d84, 0xff406780, 0xff335e79, 0xff2a5775, 0xff265373, 0xff1d4b6e,
    0xff134368, 0xff1b4b6f, 0xff416b8a, 0xff5a809c, 0xff577d99, 0xff476e8b, 0xff386381, 0xff2e5d7a,
    0xff255774, 0xff215470, 0xff235672, 0xff2a5b7a, 0xff2f5e7e, 0xff2d5c7b, 0xff295874, 0xff275970,
    0xff275c6f, 0xff2a5f72, 0xff2d6176, 0xff2d5f76, 0xff27586c, 0xff235466, 0xff235567, 0xff275a6c,
    0xff2b5f71, 0xff2f6474, 0xff316575, 0xff306272, 0xff2c5e6f, 0xff275b6b, 0xff245868, 0xff215463,
    0xff225261, 0xff275764, 0xff2e5e6a, 0xff386670, 0xff416b74, 0xff436c75, 0xff3d6873, 0xff33616c,
    0xff2a5962, 0xff23535a, 0xff24545d, 0xff2a5865, 0xff2a5866, 0xff265360, 0xff1f4d57, 0xff164450,
    0xff11404d, 0xff11404f, 0xff124153, 0xff113e52, 0xff0e384e, 0xff082e46, 0xff00223b, 0xff00223b,
    0xff0c344d, 0xff234b5f, 0xff406066, 0xff5f7469, 0xff79856e, 0xff8a8f74, 0xff929176, 0xff8e8b75,
    0xff827e6f, 0xff716b62, 0xff5f5754, 0xff4a4244, 0xff403639, 0xff4d3b3c, 0xff684c46, 0xff77554c,
    0xff74534a, 0xff6f4f47, 0xff6f4d45, 0xff714e44, 0xff785446, 0xff805b49, 0xff845e4c, 0xff845e4e,
    0xff846050, 0xff816352, 0xff806453, 0xff7f6453, 0xff816554, 0xff836856, 0xff876c58, 0xff8d705a,
    0xff94755c, 0xff9d7f61, 0xffa48967, 0xffaa906b, 0xffae906b, 0xffae8b68, 0xffab8764, 0xffa68461,
    0xffa18262, 0xff9e8266, 0xff9f8469, 0xffa48769, 0xffae8d6a, 0xffbc946c, 0xffca9c70, 0xffd0a275,
    0xffd6a97a, 0xffe1b17e, 0xffeeb97f, 0xfff6be81, 0xff3b536b, 0xff3b536b, 0xff3e556f, 0xff405771,
    0xff3f566f, 0xff3e556d, 0xff41586f, 0xff465d72, 0xff496076, 0xff496078, 0xff496078, 0xff4b6276,
    0xff4b6274, 0xff4b6274, 0xff4a6174, 0xff465c72, 0xff41576d, 0xff3c5268, 0xff3a5063, 0xff3e5466,
    0xff4d6374, 0xff5d7184, 0xff697b92, 0xff71829b, 0xff77869f, 0xff78879d, 0xff76879a, 0xff718499,
    0xff6b7f96, 0xff677a92, 0xff637790, 0xff5d748e, 0xff597691, 0xff607d98, 0xff6b85a2, 0xff738ba8,
    0xff748ba9, 0xff768da8, 0xff7c91aa, 0xff7f94aa, 0xff7f94a8, 0xff7c92a5, 0xff778ea3, 0xff758da2,
    0xff7d92a7, 0xff8d9eb0, 0xff91a0b3, 0xff8193ad, 0xff7187a5, 0xff6c83a1, 0xff6c849e, 0xff6a839c,
    0xff67829a, 0xff607d96, 0xff577692, 0xff50708e, 0xff4d6d8b, 0xff506f8b, 0xff5a768e, 0xff637d91,
    0xff637e93, 0xff5d7b92, 0xff5a7991, 0xff5c788e, 0xff667e93, 0xff7b90a2, 0xff869aac, 0xff8399ac,
    0xff7990a6, 0xff7189a1, 0xff6d859f, 0xff67809b, 0xff627d97, 0xff6c879f, 0xff8ea3b9, 0xff9aadc3,
    0xff7f96b0, 0xff577493, 0xff406283, 0xff395f7e, 0xff375f7e, 0xff3b6383, 0xff3e6586, 0xff3d6385,
    0xff3b6082, 0xff3a5f80, 0xff385f7e, 0xff355e7c, 0xff315e7a, 0xff33617c, 0xff396581, 0xff3c6782,
    0xff39627a, 0xff355f74, 0xff355f75, 0xff366277, 0xff356377, 0xff346375, 0xff356474, 0xff386575,
    0xff396575, 0xff376474, 0xff346372, 0xff30606e, 0xff2f606c, 0xff33636e, 0xff3a6a73, 0xff427077,
    0xff477378, 0xff487378, 0xff426e75, 0xff396871, 0xff30616b, 0xff285b66, 0xff275967, 0xff2b5969,
    0xff275567, 0xff1d4d61, 0xff17485c, 0xff19485e, 0xff204b63, 0xff2a5169, 0xff35576c, 0xff3e5963,
    0xff425856, 0xff445b51, 0xff426055, 0xff456a5f, 0xff51776c, 0xff648676, 0xff7c967d, 0xff95a380,
    0xffa8ab82, 0xffb2ae83, 0xffb7b087, 0xffb5b28d, 0xffabab8b, 0xff9a9a7e, 0xff8d8b71, 0xff85826b,
    0xff868069, 0xff94876d, 0xffa89172, 0xffb09473, 0xffa98d6f, 0xffa0866a, 0xff9b8266, 0xff9c8365,
    0xffa58a68, 0xffb0936d, 0xffb49871, 0xffb29973, 0xffaf9873, 0xffab9571, 0xffa7916e, 0xffa38c6b,
    0xffa18869, 0xffa2896a, 0xffa68c6c, 0xffaa8d6c, 0xffae8e6b, 0xffb4946e, 0xffb99c73, 0xffbca076,
    0xffbd9e73, 0xffbd9a70, 0xffc19c72, 0xffc39d74, 0xffbc9873, 0xffb39171, 0xffb19071, 0xffb79572,
    0xffc09c74, 0xffcaa075, 0xffd5a578, 0xffdfac7d, 0xffe7b382, 0xffedb883, 0xfff0ba82, 0xfff2bc82,
    0xff3b576d, 0xff3b576d, 0xff3f5b72, 0xff415c74, 0xff3d576f, 0xff375168, 0xff344d64, 0xff334c63,
    0xff324c63, 0xff324c63, 0xff324d63, 0xff345062, 0xff355262, 0xff355364, 0xff345164, 0xff304c61,
    0xff2c465b, 0xff284255, 0xff264252, 0xff284454, 0xff2f4b5d, 0xff385468, 0xff425c74, 0xff4b637d,
    0xff4e647d, 0xff4c6377, 0xff4b6377, 0xff4a647b, 0xff48637c, 0xff435e78, 0xff435e77, 0xff4b667f,
    0xff547088, 0xff55738b, 0xff53738a, 0xff54748b, 0xff59768d, 0xff617a91, 0xff698194, 0xff6e8596,
    0xff6e8695, 0xff6c8694, 0xff6e8796, 0xff738a99, 0xff7c909f, 0xff8698a5, 0xff8596a5, 0xff72879b,
    0xff667d94, 0xff6e8397, 0xff7a8c9c, 0xff798d9c, 0xff6e8697, 0xff607b8e, 0xff556f83, 0xff4d677c,
    0xff4b697d, 0xff4d6c7f, 0xff496879, 0xff4a6676, 0xff516c7e, 0xff5e778b, 0xff6c8194, 0xff758796,
    0xff8695a0, 0xffa3aeb9, 0xffb5beca, 0xffb9c0cd, 0xffb5bbca, 0xffb0b6c6, 0xffacb2c4, 0xffaab2c2,
    0xffacb4c2, 0xffb8beca, 0xffd0d1de, 0xffcccddd, 0xff9aa4bb, 0xff5f7392, 0xff435d7f, 0xff435f7f,
    0xff496687, 0xff537093, 0xff567297, 0xff496589, 0xff3f5b7e, 0xff415c81, 0xff456187, 0xff406086,
    0xff385c81, 0xff385e82, 0xff406588, 0xff476a8b, 0xff466a87, 0xff446883, 0xff436883, 0xff426783,
    0xff3c627c, 0xff375d73, 0xff375e71, 0xff3e6476, 0xff446a7c, 0xff446a7d, 0xff426a7c, 0xff406b7a,
    0xff3f6d78, 0xff41707a, 0xff46737d, 0xff49757e, 0xff4a757d, 0xff49747b, 0xff477279, 0xff436f78,
    0xff3c6a77, 0xff366475, 0xff356073, 0xff365e70, 0xff2f566b, 0xff234c64, 0xff204a65, 0xff2f556f,
    0xff44627b, 0xff586d86, 0xff6c7889, 0xff7d7d78, 0xff8a8362, 0xff989561, 0xffa0ac77, 0xffa8bf8a,
    0xffb2c890, 0xffbbca90, 0xffc7cf93, 0xffd3d093, 0xffd9cc90, 0xffdbc78c, 0xffdeca91, 0xffe0d59e,
    0xffdddaa4, 0xffd5d29d, 0xffcfca94, 0xffccc791, 0xffcdc791, 0xffd1c790, 0xffd5c68f, 0xffd4c28c,
    0xffcfbc89, 0xffcbb887, 0xffccb987, 0xffd0be8a, 0xffd8c48d, 0xffdfcb90, 0xffe2d195, 0xffe0d69a,
    0xffdfd699, 0xffddd195, 0xffdbcb90, 0xffd9c48d, 0xffd7c08b, 0xffd8c18c, 0xffdac38c, 0xffdcc089,
    0xffddba85, 0xffddb683, 0xffdab684, 0xffd7b483, 0xffd3af7e, 0xffd2ac7a, 0xffd9b27f, 0xffdeb684,
    0xffd7af80, 0xffcaa179, 0xffc49c75, 0xffc7a076, 0xffcba378, 0xffc9a177, 0xffcaa077, 0xffd3a479,
    0xffdca87b, 0xffdda97b, 0xffd7a77a, 0xffd4a679, 0xff3f5c72, 0xff3f5c72, 0xff446177, 0xff456278,
    0xff3f5c71, 0xff355267, 0xff2d495f, 0xff27435a, 0xff234056, 0xff224056, 0xff234256, 0xff244555,
    0xff254655, 0xff264758, 0xff254759, 0xff234256, 0xff203d51, 0xff1e3a4c, 0xff1c3b49, 0xff1b3c4a,
    0xff1b3c4e, 0xff1d3e55, 0xff25445d, 0xff2c4a63, 0xff2d4961, 0xff29465b, 0xff29475c, 0xff2d4c63,
    0xff2e4f68, 0xff2b4c66, 0xff2e4f68, 0xff3d5b72, 0xff4c677c, 0xff4a677b, 0xff3e6173, 0xff3b5f71,
    0xff416276, 0xff4a687b, 0xff536f7f, 0xff597381, 0xff587581, 0xff587681, 0xff607c87, 0xff6c828e,
    0xff768996, 0xff798d99, 0xff738996, 0xff60798a, 0xff597184, 0xff697d8c, 0xff7c8c97, 0xff7b8e98,
    0xff6c8492, 0xff5b7685, 0xff4f6777, 0xff47606f, 0xff486573, 0xff476775, 0xff3b5c6a, 0xff345462,
    0xff405c6b, 0xff597080, 0xff728391, 0xff808d98, 0xff959ea6, 0xffb5bac3, 0xffc9cdd6, 0xffd3d3db,
    0xffd3d0d9, 0xffd0ccd5, 0xffcbc8d3, 0xffcecbd4, 0xffd6d3d9, 0xffe2dce1, 0xffefe6ec, 0xffded6e3,
    0xffa1a4b9, 0xff5f6e8c, 0xff435879, 0xff485e7f, 0xff54698c, 0xff63769c, 0xff65799f, 0xff51668a,
    0xff41587b, 0xff445b80, 0xff4c628b, 0xff49638d, 0xff425e89, 0xff415f89, 0xff48658d, 0xff4e6a8f,
    0xff506d8f, 0xff4f6e8e, 0xff4f6e8f, 0xff4c6b8d, 0xff446383, 0xff3d5b76, 0xff3e5c73, 0xff47657b,
    0xff4f6e83, 0xff517085, 0xff517185, 0xff507485, 0xff507885, 0xff527a86, 0xff567c88, 0xff557b87,
    0xff517883, 0xff4f7681, 0xff527881, 0xff557982, 0xff547785, 0xff527486, 0xff527082, 0xff526c7b,
    0xff4b6473, 0xff3f5b6e, 0xff405c71, 0xff586d81, 0xff758190, 0xff8f8e9d, 0xffa79a9f, 0xffbda38c,
    0xffcead72, 0xffe3c874, 0xfff1e892, 0xfffbfea8, 0xfffdffa7, 0xfffbf79f, 0xfffdf29e, 0xfffdeb9c,
    0xfffbdf96, 0xfff8d490, 0xfff9d796, 0xfffce6a5, 0xfffef2af, 0xfffdf3ac, 0xfffcf0a7, 0xfffdf1a7,
    0xfffcf1a6, 0xfff7eca3, 0xfff0e69f, 0xffeade9b, 0xffe8da99, 0xffe9d999, 0xffefdf9e, 0xfff5e5a2,
    0xfffae9a4, 0xfffeeda6, 0xfffff5ab, 0xfffefcb0, 0xfffefcb0, 0xfffdf6ab, 0xfffdefa5, 0xfffceaa3,
    0xfffce7a2, 0xfffce8a3, 0xfffde8a3, 0xfffee29e, 0xfffed897, 0xfff9ce92, 0xfff1c88f, 0xffe9c18c,
    0xffe4bc85, 0xffe4bc82, 0xffecc389, 0xfff2c78f, 0xffeabe8a, 0xffdbae7f, 0xffd3a679, 0xffd4a879,
    0xffd2a87a, 0xffc9a279, 0xffc39d77, 0xffca9e76, 0xffd1a074, 0xffce9d73, 0xffc39872, 0xffbd9572,
    0xff45617a, 0xff45617a, 0xff49657e, 0xff4a667f, 0xff45617a, 0xff3c5871, 0xff344f68, 0xff2d4862,
    0xff29455d, 0xff29465d, 0xff28475c, 0xff254559, 0xff234457, 0xff244558, 0xff27475b, 0xff28465b,
    0xff28455a, 0xff284458, 0xff264454, 0xff234353, 0xff1f4054, 0xff1e3f56, 0xff203f58, 0xff234159,
    0xff254259, 0xff254259, 0xff25445a, 0xff27455b, 0xff294960, 0xff2e4e68, 0xff35546e, 0xff3e5b74,
    0xff456075, 0xff435f72, 0xff3b5b6d, 0xff395a6c, 0xff3c5c6f, 0xff415e72, 0xff466173, 0xff496474,
    0xff496674, 0xff4b6976, 0xff546f7d, 0xff5f7786, 0xff687e8e, 0xff6b8193, 0xff667e91, 0xff567286,
    0xff506c80, 0xff5e7586, 0xff6d808f, 0xff6d8190, 0xff60798b, 0xff536f82, 0xff4b6478, 0xff465f72,
    0xff476275, 0xff456376, 0xff39596c, 0xff315164, 0xff3a576b, 0xff4e677b, 0xff637688, 0xff6e7f8e,
    0xff7f8d9a, 0xff98a5b2, 0xffa8b4c1, 0xffadb6c2, 0xffaab2bd, 0xffa6adb8, 0xffa4abb5, 0xffabb1bb,
    0xffb9bcc7, 0xffc4c5d0, 0xffc7c5d0, 0xffb2b3c1, 0xff818c9f, 0xff4f647e, 0xff3d5573, 0xff445c7c,
    0xff506789, 0xff5c7297, 0xff5e7399, 0xff4c6387, 0xff3d577a, 0xff3e577d, 0xff445e87, 0xff4a648e,
    0xff4e6891, 0xff4d6890, 0xff46648c, 0xff416188, 0xff406186, 0xff426487, 0xff47698c, 0xff4b6c8f,
    0xff486889, 0xff43617f, 0xff46627e, 0xff4f6a84, 0xff57728a, 0xff5a748b, 0xff5b758b, 0xff5c798d,
    0xff5d7d90, 0xff5f8195, 0xff628298, 0xff607f96, 0xff5a798f, 0xff59778b, 0xff607c8c, 0xff6b8290,
    0xff768994, 0xff808d95, 0xff858d93, 0xff858a8d, 0xff848687, 0xff808283, 0xff858683, 0xff99968b,
    0xffb0a695, 0xffc4b19f, 0xffd8bba1, 0xffebc293, 0xfff8c880, 0xffffda81, 0xffffef96, 0xfffffaa4,
    0xfffef39d, 0xfffce793, 0xfffae091, 0xfff8da91, 0xfff7d28e, 0xfff7cb8a, 0xfff5cb8c, 0xfff4d193,
    0xfff3d699, 0xfff2d698, 0xfff1d496, 0xffeed496, 0xffebd596, 0xffe9d596, 0xffe8d595, 0xffead595,
    0xffedd695, 0xfff1d796, 0xfff6db9a, 0xfff9de9d, 0xfffadf9d, 0xfff9e09d, 0xfffae7a2, 0xfffbeea8,
    0xfffaeea8, 0xfff6e6a1, 0xfff3df9c, 0xfff3de9c, 0xfff4de9d, 0xfff2dd9d, 0xfff1dc9c, 0xfff3d899,
    0xfff6d395, 0xfff4cc91, 0xffedc58d, 0xffe8c089, 0xffe7bf87, 0xffebc388, 0xfff2c88d, 0xfff7ca90,
    0xfff1c28c, 0xffe4b685, 0xffddae7f, 0xffdeaf7d, 0xffddaf7c, 0xffd7ac7c, 0xffd3a97c, 0xffd7a87b,
    0xffdba879, 0xffd8a679, 0xffd2a479, 0xffcea279, 0xff4a6482, 0xff4a6482, 0xff4d6784, 0xff4d6884,
    0xff4a6480, 0xff445e7a, 0xff3f5874, 0xff3a5370, 0xff39526d, 0xff3b546e, 0xff39536c, 0xff304c64,
    0xff2b4860, 0xff2d4960, 0xff324e64, 0xff375268, 0xff3a556c, 0xff3a556b, 0xff375267, 0xff345064,
    0xff314e64, 0xff2f4c64, 0xff2c4860, 0xff2b465d, 0xff2e4960, 0xff344f66, 0xff355167, 0xff314d61,
    0xff335064, 0xff405c75, 0xff496480, 0xff46627d, 0xff3f5c74, 0xff3f5b71, 0xff425e72, 0xff435f73,
    0xff425f73, 0xff415d73, 0xff405b71, 0xff405a70, 0xff415c6f, 0xff446072, 0xff4a6678, 0xff526c81,
    0xff5a7289, 0xff5f778f, 0xff5d7690, 0xff526f88, 0xff4b6a83, 0xff506c84, 0xff577088, 0xff566f87,
    0xff4f6b85, 0xff4a6781, 0xff47637e, 0xff45617c, 0xff45627d, 0xff44627d, 0xff3e5d78, 0xff395973,
    0xff3b5a73, 0xff426077, 0xff4a657c, 0xff50697f, 0xff5a7287, 0xff688196, 0xff6f899d, 0xff6d8799,
    0xff668091, 0xff617b8a, 0xff607a88, 0xff698191, 0xff778da1, 0xff8193aa, 0xff7f8fa3, 0xff708193,
    0xff566c7f, 0xff3d5a70, 0xff36556f, 0xff3d5a79, 0xff446182, 0xff4a6689, 0xff4a678a, 0xff416082,
    0xff39597c, 0xff36577b, 0xff395a80, 0xff47668b, 0xff587395, 0xff577395, 0xff46668b, 0xff355a80,
    0xff30567b, 0xff33597c, 0xff3c6284, 0xff466b8d, 0xff4a6c8e, 0xff4a698b, 0xff4e6b8b, 0xff55718e,
    0xff5b7590, 0xff5e768e, 0xff5f778d, 0xff627a90, 0xff647d96, 0xff69819d, 0xff6c84a3, 0xff6c82a1,
    0xff667b98, 0xff667993, 0xff707e96, 0xff80899b, 0xff95969d, 0xffa9a29d, 0xffb4a69d, 0xffb6a69b,
    0xffbba799, 0xffc0aa96, 0xffc7b092, 0xffd2ba8e, 0xffdcc18e, 0xffe7c793, 0xfff0cc97, 0xfff8cf92,
    0xfffed189, 0xffffd286, 0xffffd48a, 0xfff6ce8a, 0xffe3c082, 0xffd5b67b, 0xffd2b37a, 0xffd5b37b,
    0xffdab47d, 0xffdfb37d, 0xffdeaf7c, 0xffd7aa79, 0xffd0a477, 0xffcb9f75, 0xffc69c75, 0xffbf9973,
    0xffbb9a73, 0xffc1a177, 0xffccac7d, 0xffd7b582, 0xffdeba83, 0xffe3bc84, 0xffe5bb86, 0xffe3b986,
    0xffdfb784, 0xffdbb783, 0xffddbb87, 0xffe0c18c, 0xffdcc08c, 0xffd3b986, 0xffceb482, 0xffceb683,
    0xffd1b986, 0xffceb886, 0xffcdb786, 0xffd2b887, 0xffdaba88, 0xffddb987, 0xffdab583, 0xffd9b481,
    0xffdeb984, 0xffe6bf88, 0xffebc189, 0xffedbf88, 0xffe9ba87, 0xffe2b485, 0xffdeb081, 0xffdeaf7d,
    0xffe0b07b, 0xffe2b27e, 0xffe4b481, 0xffe4b280, 0xffe4b17f, 0xffe5b380, 0xffe7b682, 0xffe8b883,
    0xff486281, 0xff486281, 0xff496382, 0xff4a6482, 0xff486381, 0xff46607e, 0xff435c7a, 0xff405a76,
    0xff415a75, 0xff455d78, 0xff435c76, 0xff37516c, 0xff304b66, 0xff324d66, 0xff39536a, 0xff405a72,
    0xff455f78, 0xff466078, 0xff425b73, 0xff3e586f, 0xff3d5870, 0xff3b576f, 0xff345067, 0xff304c61,
    0xff355066, 0xff3e5971, 0xff405a71, 0xff385466, 0xff395567, 0xff4c667d, 0xff556e8a, 0xff48647f,
    0xff38576f, 0xff39566c, 0xff445d74, 0xff496178, 0xff466077, 0xff405c73, 0xff3a566f, 0xff37536c,
    0xff38536b, 0xff3c576e, 0xff405c73, 0xff44617a, 0xff4a6782, 0xff506b87, 0xff516c89, 0xff4a6a86,
    0xff446682, 0xff426280, 0xff415f7e, 0xff3f5d7d, 0xff3d5d7c, 0xff3d5e7d, 0xff406080, 0xff416182,
    0xff416082, 0xff405f81, 0xff406081, 0xff406080, 0xff3b5d7a, 0xff365974, 0xff335671, 0xff345672,
    0xff375976, 0xff3c5f7b, 0xff3c617c, 0xff355c75, 0xff2c546d, 0xff274f65, 0xff264e63, 0xff2e546c,
    0xff3c5e7d, 0xff446385, 0xff3e5c79, 0xff35546b, 0xff2f5065, 0xff2d5065, 0xff2f536b, 0xff355674,
    0xff38597a, 0xff395979, 0xff395a79, 0xff3a5d7d, 0xff395d7f, 0xff355a7c, 0xff365b7c, 0xff4a6988,
    0xff637b97, 0xff667e99, 0xff516f8e, 0xff3d6182, 0xff375b7c, 0xff3a5d7d, 0xff416483, 0xff4a6d8b,
    0xff517191, 0xff557294, 0xff5b7596, 0xff5f7896, 0xff627a94, 0xff657a90, 0xff677a8f, 0xff6b7c92,
    0xff717f98, 0xff7885a0, 0xff7e8aa6, 0xff808aa5, 0xff7e849b, 0xff808396, 0xff8b899a, 0xff9d959f,
    0xffb7a4a0, 0xffd1b4a0, 0xffddbca2, 0xffe1bea4, 0xffeac4a4, 0xfff6cba0, 0xfffed199, 0xffffd48d,
    0xffffd587, 0xffffd788, 0xffffd78c, 0xffffd790, 0xffffd491, 0xfffac88a, 0xffeeb87f, 0xffdba573,
    0xffc09268, 0xffb08864, 0xffaa8763, 0xffae8b66, 0xffb7926b, 0xffc1976e, 0xffc1916a, 0xffb88460,
    0xffae7758, 0xffa66f57, 0xffa06b58, 0xff966655, 0xff926755, 0xff9d745d, 0xffb08667, 0xffc0956f,
    0xffc79b71, 0xffca9b70, 0xffc7966f, 0xffc1906d, 0xffba8c69, 0xffb48a67, 0xffb68c69, 0xffba8f6d,
    0xffb78d6d, 0xffac8869, 0xffa68667, 0xffa88c6b, 0xffad926f, 0xffaa916e, 0xffa9916e, 0xffb19672,
    0xffbd9f78, 0xffc4a37a, 0xffc3a176, 0xffc5a376, 0xffcfad7d, 0xffd8b483, 0xffdbb281, 0xffdbad7d,
    0xffd9ab7e, 0xffd7ac81, 0xffd7ab7f, 0xffd7a879, 0xffdaa976, 0xffe1ae7b, 0xffe5b380, 0xffe0af7f,
    0xffdbab7c, 0xffdfaf7e, 0xffe8b782, 0xffeebc84, 0xff3b5774, 0xff3b5774, 0xff395572, 0xff385470,
    0xff37536f, 0xff37536e, 0xff36526c, 0xff35516a, 0xff37536b, 0xff3c576f, 0xff3c576e, 0xff314d65,
    0xff2b4760, 0xff2f4a62, 0xff365168, 0xff3c586e, 0xff3f5b72, 0xff3e5a72, 0xff3a556e, 0xff36526a,
    0xff35536b, 0xff34536a, 0xff2d4e62, 0xff294a5d, 0xff2d4e62, 0xff36556d, 0xff37566d, 0xff315164,
    0xff325263, 0xff405e74, 0xff47647d, 0xff3b5b73, 0xff2d4f66, 0xff2f4f66, 0xff3b566e, 0xff405b74,
    0xff3e5b75, 0xff395872, 0xff33536c, 0xff304f67, 0xff304e66, 0xff335068, 0xff36546c, 0xff385772,
    0xff3b5a76, 0xff3d5c78, 0xff3e5c78, 0xff3c5d78, 0xff385c77, 0xff355976, 0xff315674, 0xff2e5271,
    0xff2c516e, 0xff2f5270, 0xff345776, 0xff395a7c, 0xff3a5c7d, 0xff3b5c7d, 0xff3f6081, 0xff3f6181,
    0xff385b79, 0xff2d526f, 0xff274c6a, 0xff274d6d, 0xff284e6f, 0xff274d6d, 0xff254b6a, 0xff214a68,
    0xff1e4766, 0xff194460, 0xff17405c, 0xff1b425f, 0xff234869, 0xff274b6e, 0xff214565, 0xff1d425d,
    0xff20455d, 0xff264b61, 0xff2a4f66, 0xff2d506b, 0xff2e516d, 0xff2d506a, 0xff30536d, 0xff3b5e7a,
    0xff436684, 0xff436683, 0xff476681, 0xff597187, 0xff707f92, 0xff7d899b, 0xff7b899e, 0xff7789a0,
    0xff778aa3, 0xff7387a1, 0xff6a7e99, 0xff627792, 0xff627795, 0xff697d9c, 0xff6e80a0, 0xff6e809f,
    0xff6d7e9b, 0xff6b7b97, 0xff6d7b95, 0xff757e95, 0xff818497, 0xff8e8b99, 0xff99919b, 0xffa39698,
    0xffa79792, 0xffae9990, 0xffb8a095, 0xffc6aa99, 0xffdab699, 0xffedc199, 0xfff9c89c, 0xfffccba0,
    0xffffd0a0, 0xffffd59c, 0xffffd994, 0xffffdb8a, 0xffffdb84, 0xffffdb82, 0xffffd986, 0xffffd98e,
    0xffffd896, 0xfffac78e, 0xffe9af7a, 0xffd19467, 0xffb27d5b, 0xff9d7157, 0xff906a53, 0xff8d6a53,
    0xff936e56, 0xff9c7359, 0xff9e7157, 0xff99684f, 0xff95614b, 0xff925f4d, 0xff8f5e50, 0xff89584c,
    0xff87574b, 0xff906251, 0xff9d725b, 0xffa57b61, 0xffa37a5f, 0xff9f745c, 0xff986e59, 0xff916957,
    0xff896353, 0xff836051, 0xff836051, 0xff876253, 0xff876354, 0xff846254, 0xff856556, 0xff8d6e5a,
    0xff96785f, 0xff977a5f, 0xff997b5f, 0xffa58466, 0xffb4906e, 0xffbc9672, 0xffb8946e, 0xffb8956e,
    0xffc09c73, 0xffc8a278, 0xffc89f74, 0xffc69b6f, 0xffc89c72, 0xffcba178, 0xffcaa177, 0xffc69b70,
    0xffc5976c, 0xffc79a6f, 0xffc49a72, 0xffb6906b, 0xffa98665, 0xffab8765, 0xffb5906a, 0xffbc966d,
    0xff2a4a64, 0xff2a4a64, 0xff274760, 0xff25455d, 0xff25455c, 0xff26455b, 0xff244459, 0xff224258,
    0xff254559, 0xff2b4b5e, 0xff2d4c5e, 0xff274559, 0xff234156, 0xff28455a, 0xff2f4c61, 0xff325064,
    0xff325065, 0xff2e4e63, 0xff29495f, 0xff25475d, 0xff25495f, 0xff254a60, 0xff21485c, 0xff1f4659,
    0xff21485c, 0xff264d62, 0xff284e63, 0xff264c5f, 0xff274c5e, 0xff2c5164, 0xff2f5367, 0xff2a4f62,
    0xff254a5d, 0xff284b5f, 0xff2e4f66, 0xff33536c, 0xff345671, 0xff335671, 0xff30526a, 0xff2d4f65,
    0xff2c4d64, 0xff2d4e65, 0xff2e5068, 0xff30526b, 0xff31536c, 0xff30516a, 0xff2f5069, 0xff2f516a,
    0xff2f526b, 0xff2e546e, 0xff2c536e, 0xff27506a, 0xff234b63, 0xff244b63, 0xff2a4f69, 0xff305470,
    0xff345874, 0xff375a76, 0xff3b5d7a, 0xff3b5d7b, 0xff335775, 0xff294f6c, 0xff244b69, 0xff274e6d,
    0xff2a4f6f, 0xff274b6b, 0xff264968, 0xff2a4d6d, 0xff2e5173, 0xff2d4f70, 0xff294969, 0xff274665,
    0xff284868, 0xff284969, 0xff254866, 0xff244763, 0xff264862, 0xff294b63, 0xff2b4c64, 0xff2b4c65,
    0xff2b4d64, 0xff2b4d62, 0xff325368, 0xff41627b, 0xff4f6d88, 0xff57718b, 0xff5e7389, 0xff6a7788,
    0xff797e8c, 0xff8f8e9a, 0xffa4a1ad, 0xffb4b2bf, 0xffbcbbcb, 0xffb2b3c6, 0xff979ab1, 0xff7b8099,
    0xff737a95, 0xff7a829e, 0xff7d87a3, 0xff7c85a1, 0xff79829e, 0xff737e9b, 0xff757d99, 0xff7f8196,
    0xff908992, 0xffa1918e, 0xffb0998a, 0xffc2a388, 0xffceaa86, 0xffd8b087, 0xffdfb78a, 0xffe5bb8d,
    0xffefc18e, 0xfff8c58f, 0xfffdc991, 0xffffcc93, 0xffffce92, 0xffffce8d, 0xffffcf88, 0xffffd284,
    0xffffd483, 0xffffd383, 0xffffd186, 0xffffd48f, 0xffffd697, 0xfffac98f, 0xffebb27c, 0xffd49868,
    0xffb5805c, 0xff9e7156, 0xff8a634f, 0xff805c4c, 0xff7f5a4b, 0xff845d4c, 0xff88604c, 0xff8a614c,
    0xff8d644e, 0xff916954, 0xff936b57, 0xff936754, 0xff926451, 0xff966a55, 0xff99725c, 0xff95715c,
    0xff8a6757, 0xff7e5d51, 0xff76574e, 0xff6f544c, 0xff684f4a, 0xff624c48, 0xff614a47, 0xff634a47,
    0xff684d49, 0xff6d524c, 0xff765a50, 0xff826555, 0xff8d6f59, 0xff927259, 0xff977459, 0xffa67e60,
    0xffb68a69, 0xffbb906d, 0xffb38d6a, 0xffad8a68, 0xffb18c6b, 0xffb68e6c, 0xffb58c68, 0xffb38a64,
    0xffb78e68, 0xffbd936e, 0xffbb936e, 0xffb48b67, 0xffac8562, 0xffa68363, 0xff9b7c62, 0xff856c57,
    0xff735d4c, 0xff715c4a, 0xff7b644f, 0xff806952, 0xff1d4057, 0xff1d4057, 0xff193c52, 0xff16394e,
    0xff16394d, 0xff183b4e, 0xff163a4d, 0xff14394c, 0xff173c4e, 0xff1d4252, 0xff214554, 0xff1e4150,
    0xff1c3e4e, 0xff224254, 0xff27475b, 0xff28495d, 0xff25485a, 0xff1f4456, 0xff194052, 0xff163e51,
    0xff174155, 0xff194459, 0xff194559, 0xff194658, 0xff1a4659, 0xff1b475b, 0xff1d475c, 0xff1e485b,
    0xff1e485a, 0xff1c4757, 0xff1b4656, 0xff1d4757, 0xff1f4959, 0xff22495c, 0xff244a60, 0xff274d65,
    0xff2a516a, 0xff2b536c, 0xff2b5267, 0xff2a5063, 0xff294e62, 0xff294d64, 0xff2a4e65, 0xff2c5066,
    0xff2b4f63, 0xff274c5f, 0xff254a5d, 0xff264b5f, 0xff284d63, 0xff295168, 0xff28526a, 0xff234f64,
    0xff1e495c, 0xff1e475a, 0xff224960, 0xff284e67, 0xff2d546c, 0xff30576f, 0xff355a72, 0xff365973,
    0xff2f536e, 0xff264d67, 0xff244b67, 0xff2b506d, 0xff2f5170, 0xff2c4c6b, 0xff2c4a6a, 0xff355274,
    0xff3d5a7e, 0xff3e5a7e, 0xff395476, 0xff344f6f, 0xff304c6a, 0xff2e4b68, 0xff2e4c69, 0xff2f4e6a,
    0xff304e6a, 0xff304d68, 0xff2f4d66, 0xff2e4d64, 0xff2e4e62, 0xff2f4e60, 0xff385467, 0xff49637a,
    0xff5a7189, 0xff67788f, 0xff717d91, 0xff777c8d, 0xff7d7d8a, 0xff98909b, 0xffbcafb7, 0xffd9cad2,
    0xffe4d7e1, 0xffd5cbd9, 0xffb1a8ba, 0xff8a8498, 0xff7e798f, 0xff868399, 0xff8b899e, 0xff8a899d,
    0xff89879b, 0xff86859a, 0xff898698, 0xff958b94, 0xffa7948d, 0xffba9c85, 0xffcba47d, 0xffdfaf7a,
    0xffedb97c, 0xfff8c27f, 0xffffc882, 0xffffc983, 0xffffc884, 0xfffdc685, 0xfffdc886, 0xfffeca87,
    0xfffec984, 0xfffcc47f, 0xfffbc27c, 0xfffcc77e, 0xfffccb82, 0xfffbcb84, 0xfff9c986, 0xfffbcd8e,
    0xfffdd094, 0xfff6c78d, 0xffeab57c, 0xffd89f6c, 0xffbf8a61, 0xffa97a5b, 0xff936a54, 0xff84604e,
    0xff7e5a4a, 0xff805b48, 0xff855f4a, 0xff8b6750, 0xff927056, 0xff99785d, 0xff9d7b5f, 0xffa17a5d,
    0xffa2785a, 0xffa3795d, 0xff9f7c60, 0xff93745e, 0xff836456, 0xff73574f, 0xff69524b, 0xff63504a,
    0xff5c4c48, 0xff584846, 0xff554544, 0xff544342, 0xff594645, 0xff634d4a, 0xff6f564f, 0xff7b5e52,
    0xff856654, 0xff8a6953, 0xff906c53, 0xff9d7559, 0xffaa7e61, 0xffac8264, 0xffa27d62, 0xff99795f,
    0xff99775e, 0xff9c775d, 0xff9b755a, 0xff9b7559, 0xffa07b5c, 0xffa68160, 0xffa58060, 0xff9d795c,
    0xff927058, 0xff866b57, 0xff766152, 0xff5f4f46, 0xff4d403b, 0xff4b3e39, 0xff55463e, 0xff5a4a41,
    0xff163e53, 0xff163e53, 0xff123b4e, 0xff10394c, 0xff123b4f, 0xff163f53, 0xff153e52, 0xff133c4f,
    0xff143e4f, 0xff184253, 0xff1b4555, 0xff194351, 0xff194250, 0xff1e4556, 0xff23495b, 0xff23495c,
    0xff1e4859, 0xff174453, 0xff103e4d, 0xff0d3d4c, 0xff124354, 0xff18495b, 0xff1b4c5f, 0xff1c4c60,
    0xff1c4b5f, 0xff1b4a5d, 0xff1a495b, 0xff1a485a, 0xff184858, 0xff154554, 0xff154553, 0xff194856,
    0xff1e4c5a, 0xff1f4d5c, 0xff1d4c5c, 0xff1e4d5e, 0xff214f61, 0xff235163, 0xff255262, 0xff265261,
    0xff275262, 0xff285264, 0xff295264, 0xff2a5362, 0xff285160, 0xff244e5d, 0xff234d5d, 0xff264f62,
    0xff285165, 0xff285367, 0xff265266, 0xff224f61, 0xff1e4a5b, 0xff1d495a, 0xff214b5f, 0xff244e64,
    0xff265067, 0xff285268, 0xff2c536a, 0xff2d536a, 0xff294f66, 0xff244b61, 0xff244b63, 0xff2b506b,
    0xff305370, 0xff2f4f6e, 0xff2f4e6d, 0xff365475, 0xff3c5a7c, 0xff3e5b7e, 0xff3b577b, 0xff375375,
    0xff335170, 0xff31506b, 0xff31506a, 0xff33516b, 0xff36536f, 0xff3a5672, 0xff3b5772, 0xff3b566f,
    0xff3b556a, 0xff3b5365, 0xff405565, 0xff4d5e6f, 0xff5b697c, 0xff697388, 0xff757c93, 0xff7b7e95,
    0xff807e94, 0xff958da0, 0xffb3a6b5, 0xffc8bac7, 0xffc9bfce, 0xffb8b2c3, 0xff9995a9, 0xff7d798d,
    0xff787385, 0xff847d8b, 0xff90868e, 0xff988a8e, 0xffa0908e, 0xffac9891, 0xffb79f91, 0xffc4a78f,
    0xffd2af8b, 0xffe1b585, 0xffeebb7f, 0xfff9c27c, 0xfffec87e, 0xffffcd80, 0xffffd281, 0xffffd282,
    0xffffce82, 0xffffca82, 0xffffca82, 0xffffcd82, 0xffffcc7f, 0xffffc779, 0xffffc477, 0xfffec67c,
    0xfffdc882, 0xfffbc987, 0xfff9c98b, 0xfff5c98e, 0xfff1c88e, 0xffedc288, 0xffebbb7f, 0xffe5b074,
    0xffd8a16d, 0xffca9569, 0xffba8b66, 0xffad8563, 0xffa7805f, 0xffa67e5b, 0xffa77f5b, 0xffa9835f,
    0xffaa8663, 0xffaa8664, 0xffab8663, 0xffaf8a63, 0xffb38d65, 0xffb89169, 0xffb9926d, 0xffb18c6c,
    0xffa48166, 0xff96765f, 0xff8a6f5b, 0xff846b58, 0xff806753, 0xff7d6350, 0xff745c4c, 0xff6a554b,
    0xff68534c, 0xff6f584f, 0xff755b51, 0xff755b50, 0xff73594d, 0xff705749, 0xff705647, 0xff755949,
    0xff7c5d4d, 0xff7b5e4e, 0xff745a4d, 0xff6d564b, 0xff6c554a, 0xff6f564a, 0xff72594b, 0xff765c4c,
    0xff7b604d, 0xff7f624e, 0xff826450, 0xff836450, 0xff7f6250, 0xff755d4f, 0xff68554b, 0xff5d4d44,
    0xff57473f, 0xff5d4a40, 0xff685245, 0xff6e5648, 0xff164155, 0xff164155, 0xff144053, 0xff144053,
    0xff18445a, 0xff1c4960, 0xff1b495f, 0xff19475a, 0xff194658, 0xff1b495b, 0xff1d4a5c, 0xff1b4958,
    0xff1a4957, 0xff1e4a5b, 0xff224c5f, 0xff224d5f, 0xff1f4d5d, 0xff184a56, 0xff0f444f, 0xff0c424d,
    0xff164a57, 0xff1f5162, 0xff235468, 0xff24546a, 0xff235369, 0xff215165, 0xff1d4f60, 0xff1b4c5c,
    0xff194b59, 0xff184a59, 0xff1a4c5a, 0xff1e505d, 0xff215360, 0xff205360, 0xff1e525e, 0xff1d515c,
    0xff1e515c, 0xff1f515c, 0xff21525f, 0xff235461, 0xff265764, 0xff295965, 0xff2a5964, 0xff2a5762,
    0xff295561, 0xff275562, 0xff275565, 0xff2b576a, 0xff2d586c, 0xff2b566a, 0xff275466, 0xff235162,
    0xff214f60, 0xff214f61, 0xff245064, 0xff255166, 0xff235065, 0xff224f64, 0xff254f65, 0xff284e65,
    0xff274c61, 0xff254b5d, 0xff274c5f, 0xff2c5168, 0xff31546f, 0xff325472, 0xff325372, 0xff345573,
    0xff365875, 0xff375977, 0xff38587a, 0xff375879, 0xff355776, 0xff335571, 0xff32526b, 0xff34526a,
    0xff3a5770, 0xff425e79, 0xff47627d, 0xff49627d, 0xff4a5f78, 0xff495b6f, 0xff4a5868, 0xff4f5a68,
    0xff576070, 0xff636b80, 0xff6f7692, 0xff787d9c, 0xff7d80a0, 0xff8988a6, 0xff9692ac, 0xff9997ad,
    0xff8e92a6, 0xff7e869a, 0xff6e778c, 0xff666b7f, 0xff6c6b7a, 0xff7c747c, 0xff90807d, 0xff9f897d,
    0xffb39780, 0xffcda984, 0xffe0b787, 0xffedc08a, 0xfff4c58a, 0xfffac989, 0xfffeca87, 0xffffcb85,
    0xffffcb83, 0xffffcc83, 0xffffcf85, 0xffffd186, 0xffffce85, 0xffffca82, 0xffffcb82, 0xffffce81,
    0xffffcd7e, 0xffffca79, 0xffffc677, 0xfffec57a, 0xfffdc681, 0xfffcca88, 0xfff8cb8e, 0xffefc68d,
    0xffe5be88, 0xffe2ba83, 0xffe9bc80, 0xffeebb7c, 0xffedb378, 0xffe8ad76, 0xffe1ac79, 0xffdaad7b,
    0xffd7ac78, 0xffd7aa73, 0xffd3a670, 0xffcda270, 0xffc59b6e, 0xffbd9067, 0xffb98d64, 0xffb99366,
    0xffbe9e6b, 0xffc8a673, 0xffd2a978, 0xffd5a97b, 0xffd0a579, 0xffc79f75, 0xffbc9670, 0xffb48f6b,
    0xffb38b64, 0xffb0865e, 0xffa37d5a, 0xff927259, 0xff876a59, 0xff866a59, 0xff826756, 0xff765e51,
    0xff68524a, 0xff5d4a44, 0xff55443f, 0xff51423e, 0xff52423e, 0xff4f413d, 0xff4b3d3c, 0xff483c3b,
    0xff483d3b, 0xff4c403d, 0xff544541, 0xff5c4944, 0xff5f4a43, 0xff604a41, 0xff674e43, 0xff715648,
    0xff765a4c, 0xff71594b, 0xff6c574a, 0xff6f594c, 0xff775e4f, 0xff856754, 0xff937158, 0xff9b765b,
    0xff174659, 0xff174659, 0xff174658, 0xff18485a, 0xff1d4d62, 0xff21516a, 0xff215168, 0xff1e4f62,
    0xff1d4e60, 0xff1e4e61, 0xff1e4f62, 0xff1d4f5f, 0xff1d4f5d, 0xff20505f, 0xff225162, 0xff225263,
    0xff205361, 0xff1a505b, 0xff124a53, 0xff114951, 0xff1b515c, 0xff255868, 0xff295b6e, 0xff2a5b71,
    0xff295b6f, 0xff28596a, 0xff245564, 0xff1e515f, 0xff1c4f5d, 0xff1e525f, 0xff225562, 0xff245864,
    0xff255965, 0xff245964, 0xff215861, 0xff1f565d, 0xff1e5459, 0xff1f5359, 0xff21545e, 0xff245663,
    0xff285a66, 0xff2c5d67, 0xff2d5d66, 0xff2c5b63, 0xff2c5a64, 0xff2b5a68, 0xff2d5c6c, 0xff305e71,
    0xff315e71, 0xff2d5a6c, 0xff295566, 0xff275364, 0xff275465, 0xff275567, 0xff285669, 0xff265569,
    0xff235066, 0xff214d63, 0xff234c63, 0xff264d63, 0xff274d60, 0xff274e5d, 0xff2a5060, 0xff2f5467,
    0xff345770, 0xff365876, 0xff365878, 0xff345774, 0xff32566f, 0xff345772, 0xff385a78, 0xff3a5c7b,
    0xff395c79, 0xff375a73, 0xff36556b, 0xff38546a, 0xff405b72, 0xff4a647e, 0xff526a86, 0xff576b8a,
    0xff5b6a87, 0xff5b677f, 0xff5b6377, 0xff5a5f70, 0xff5c6174, 0xff646a84, 0xff6e7597, 0xff767da3,
    0xff7a7fa7, 0xff7b7fa5, 0xff787c9d, 0xff6e7490, 0xff5d677f, 0xff525f74, 0xff525d70, 0xff5b6170,
    0xff6a676f, 0xff7b6e6d, 0xff927b6d, 0xffa5876e, 0xffbf9970, 0xffe0b075, 0xfff5c07a, 0xffffc980,
    0xffffcc84, 0xffffcd88, 0xffffcc89, 0xfffdc787, 0xfff7c183, 0xfff5be81, 0xfffac082, 0xfffec383,
    0xfffcc282, 0xfff9c180, 0xfffac27e, 0xfffdc47c, 0xfffec379, 0xfffdc174, 0xfffbbe73, 0xfff7bc75,
    0xfff4bc7c, 0xfff4c285, 0xfff1c68c, 0xffe5bd88, 0xffd5b07e, 0xffd2ac79, 0xffddb47a, 0xffe7b97c,
    0xffedb579, 0xffefb47a, 0xfff0ba81, 0xfff0c287, 0xfff3c788, 0xfff6c785, 0xfff2c180, 0xffe8b87e,
    0xffdbab77, 0xffcd9a6b, 0xffc59466, 0xffc29a68, 0xffc7a770, 0xffd2b078, 0xffe0b47e, 0xffecba84,
    0xfff1bf86, 0xffeebe84, 0xffe1b37d, 0xffd7a876, 0xffd8a46f, 0xffd8a16a, 0xffcc9867, 0xffb88c67,
    0xffa78265, 0xff9e7d62, 0xff92755c, 0xff816754, 0xff6d574c, 0xff5d4c45, 0xff504440, 0xff463d3b,
    0xff403938, 0xff3c3536, 0xff3b3335, 0xff3c3335, 0xff3d3536, 0xff403939, 0xff453d3d, 0xff4a3f3f,
    0xff4b3e3d, 0xff4b3b3a, 0xff54413c, 0xff624b43, 0xff6b5248, 0xff6a5347, 0xff6b5648, 0xff796050,
    0xff8d6d59, 0xffa07a61, 0xffaf8465, 0xffb88967, 0xff174959, 0xff174959, 0xff184b58, 0xff1a4d5a,
    0xff1d5060, 0xff1f5366, 0xff1f5365, 0xff1d5261, 0xff1d5160, 0xff1e5161, 0xff1f5262, 0xff1f5361,
    0xff1f5461, 0xff215462, 0xff235564, 0xff245665, 0xff245765, 0xff215662, 0xff1b535c, 0xff1a525a,
    0xff21565f, 0xff275965, 0xff2a5b68, 0xff2a5c6a, 0xff2b5d6b, 0xff2c5d6b, 0xff2b5c68, 0xff275965,
    0xff255863, 0xff285a65, 0xff2b5d68, 0xff2c5f6a, 0xff2c5f6b, 0xff2c5f6a, 0xff2a5e68, 0xff285b64,
    0xff25585f, 0xff24565e, 0xff265662, 0xff295766, 0xff2b5967, 0xff2d5b67, 0xff2d5b66, 0xff2d5965,
    0xff2d5966, 0xff2e5a6b, 0xff2e5b6f, 0xff2f5b70, 0xff2e5a6e, 0xff2b5669, 0xff285265, 0xff285266,
    0xff2a5568, 0xff2b5669, 0xff2a5668, 0xff295466, 0xff265064, 0xff254e63, 0xff264e64, 0xff294f66,
    0xff2c5165, 0xff2d5364, 0xff315567, 0xff34576d, 0xff385a74, 0xff3b5d7b, 0xff3c5e7c, 0xff3a5c76,
    0xff385970, 0xff3b5c71, 0xff3f6076, 0xff3f5f76, 0xff3b596f, 0xff375368, 0xff354f63, 0xff385064,
    0xff3f556a, 0xff4a5e74, 0xff546781, 0xff5c6e8c, 0xff677495, 0xff6f7899, 0xff757a9a, 0xff777c9c,
    0xff777c9e, 0xff797fa5, 0xff7880aa, 0xff747eaa, 0xff6e79a5, 0xff657098, 0xff5c678a, 0xff535d78,
    0xff4b5366, 0xff4e535e, 0xff5c5b60, 0xff706766, 0xff7f6d66, 0xff897163, 0xff9a7a62, 0xffa98464,
    0xffbc9166, 0xffd4a068, 0xffe2aa6b, 0xffe8b171, 0xffe7b376, 0xffe3b179, 0xffdfad7a, 0xffd6a678,
    0xffcea075, 0xffcb9d73, 0xffd3a175, 0xffdda677, 0xffe2ab78, 0xffe4ad78, 0xffe2ac74, 0xffdea76f,
    0xffd9a369, 0xffd6a066, 0xffd49d65, 0xffd39c67, 0xffd59f6d, 0xffd9a775, 0xffd9ab7a, 0xffcfa375,
    0xffc0956a, 0xffb88e65, 0xffb99268, 0xffbc956b, 0xffbe936a, 0xffc3946b, 0xffc99c71, 0xffd3a879,
    0xffe2b67e, 0xfff0c081, 0xfff3c081, 0xffeab87e, 0xffdeab77, 0xffd39e6e, 0xffcb9969, 0xffc69b69,
    0xffc6a26e, 0xffc9a371, 0xffd0a374, 0xffdead7a, 0xffedbc82, 0xfff0bf82, 0xffddad77, 0xffcf9e6d,
    0xffd49e6b, 0xffdba16c, 0xffd8a06d, 0xffcd9a6d, 0xffbd916a, 0xffaf8965, 0xffa28060, 0xff97775c,
    0xff8e6f58, 0xff836855, 0xff796253, 0xff6f5c4e, 0xff685749, 0xff635246, 0xff614f45, 0xff614e45,
    0xff615046, 0xff5d4f45, 0xff524641, 0xff473d3d, 0xff463b3b, 0xff4c3d3b, 0xff51403c, 0xff52403d,
    0xff52423e, 0xff52443d, 0xff574a40, 0xff665448, 0xff7a6151, 0xff8e6d59, 0xff9d775d, 0xffa67d60,
    0xff174b58, 0xff174b58, 0xff194d57, 0xff1a4e57, 0xff1b4f59, 0xff1b505c, 0xff1b505c, 0xff1b515b,
    0xff1c515b, 0xff1e525d, 0xff20535e, 0xff205460, 0xff205562, 0xff225663, 0xff255764, 0xff265865,
    0xff275966, 0xff275965, 0xff255964, 0xff245862, 0xff245761, 0xff255761, 0xff265860, 0xff275a60,
    0xff2b5c63, 0xff2f5f68, 0xff30606b, 0xff2e5f69, 0xff2d5e68, 0xff306069, 0xff32626b, 0xff32636d,
    0xff31626e, 0xff31626f, 0xff31616f, 0xff305f6d, 0xff2d5b69, 0xff2c5967, 0xff2e5769, 0xff2f576a,
    0xff2e5668, 0xff2d5666, 0xff2d5666, 0xff2e5667, 0xff2e5669, 0xff2e576c, 0xff2e576d, 0xff2c566b,
    0xff2b5469, 0xff295167, 0xff295066, 0xff2a5267, 0xff2c5569, 0xff2d5668, 0xff2d5566, 0xff2c5464,
    0xff2b5264, 0xff2c5266, 0xff2d5369, 0xff2f556c, 0xff32566d, 0xff35586d, 0xff375a6f, 0xff395c73,
    0xff3c5d77, 0xff3e5f7d, 0xff40607e, 0xff405f7a, 0xff415e74, 0xff446174, 0xff486576, 0xff466070,
    0xff3e5465, 0xff384b5d, 0xff384a5d, 0xff3c4e62, 0xff415164, 0xff49576c, 0xff526079, 0xff5c6b8a,
    0xff6d799e, 0xff7c85ad, 0xff8a8fbb, 0xff9298c8, 0xff9199cb, 0xff8e97c7, 0xff858fba, 0xff7682ac,
    0xff66749c, 0xff586688, 0xff525d7a, 0xff51576c, 0xff58565f, 0xff675b5b, 0xff7b665c, 0xff8f7261,
    0xff997862, 0xff9b7960, 0xffa17c5f, 0xffa98061, 0xffb18562, 0xffb88961, 0xffbb8b62, 0xffbe8e66,
    0xffbd8f69, 0xffb98d69, 0xffb38967, 0xffaa8365, 0xffa27d62, 0xffa17c62, 0xffac8065, 0xffb98868,
    0xffc6926c, 0xffcd986e, 0xffc99569, 0xffbe8b62, 0xffb3825b, 0xffad7d58, 0xffac7c58, 0xffaf7e5b,
    0xffb68460, 0xffbe8d66, 0xffc39269, 0xffbf8d64, 0xffb4815b, 0xffa67756, 0xff9b7357, 0xff916f59,
    0xff896a56, 0xff8a6b56, 0xff917159, 0xffa07e5f, 0xffb99169, 0xffd2a373, 0xffe0ac78, 0xffdca977,
    0xffd5a374, 0xffd09f6f, 0xffcc9c6c, 0xffc7996a, 0xffc29669, 0xffbb8f67, 0xffb68a65, 0xffc1936b,
    0xffd6a776, 0xffdbad78, 0xffc39768, 0xffb2865d, 0xffb98960, 0xffc79368, 0xffd0996d, 0xffd09a6d,
    0xffc6956a, 0xffb68c66, 0xffab8663, 0xffad8763, 0xffb28a65, 0xffb28a68, 0xffae8868, 0xffa98465,
    0xffa2805f, 0xff9d7b5c, 0xff9a775b, 0xff98765b, 0xff97765b, 0xff8b6f56, 0xff6d5a4b, 0xff524540,
    0xff4f4340, 0xff5c4c45, 0xff5b4a44, 0xff4d3e3c, 0xff413636, 0xff3f3837, 0xff453f3b, 0xff4d443f,
    0xff5a4b44, 0xff6a544a, 0xff785d4e, 0xff806251, 0xff194c57, 0xff194c57, 0xff1a4e57, 0xff1b4f56,
    0xff194e55, 0xff174d54, 0xff174d55, 0xff194e56, 0xff1c5058, 0xff1f5258, 0xff21535b, 0xff22555f,
    0xff235662, 0xff255863, 0xff275964, 0xff295965, 0xff2a5a66, 0xff2c5b68, 0xff2d5d6a, 0xff2d5d69,
    0xff295864, 0xff26555f, 0xff25555a, 0xff265759, 0xff2b5b5e, 0xff305f66, 0xff33626b, 0xff33616a,
    0xff33616a, 0xff36636c, 0xff37646d, 0xff36636e, 0xff35626f, 0xff366271, 0xff396373, 0xff386173,
    0xff355e70, 0xff335b6e, 0xff34586c, 0xff34576b, 0xff325568, 0xff2f5366, 0xff2f5367, 0xff305469,
    0xff30546b, 0xff30546c, 0xff2e536a, 0xff2b5066, 0xff294f64, 0xff294f65, 0xff2b5167, 0xff2e536a,
    0xff30556a, 0xff315669, 0xff305565, 0xff305464, 0xff325566, 0xff34576a, 0xff35596e, 0xff375b72,
    0xff395c74, 0xff3c5d75, 0xff3e5d77, 0xff3f5e78, 0xff405f7a, 0xff43617c, 0xff45627d, 0xff48637c,
    0xff4b6479, 0xff506777, 0xff526a76, 0xff50646e, 0xff495764, 0xff454f5f, 0xff475265, 0xff4c586d,
    0xff4d586d, 0xff515a70, 0xff57617c, 0xff606d8d, 0xff717da5, 0xff838dbb, 0xff949ccf, 0xffa1a9e1,
    0xffa3ace2, 0xff9fa6d6, 0xff9298bf, 0xff7e86a6, 0xff6b748f, 0xff5d657a, 0xff5a5f6e, 0xff615d65,
    0xff71605d, 0xff84695b, 0xff9a745c, 0xffab7e5f, 0xffb08260, 0xffac815f, 0xffaa805f, 0xffab8061,
    0xffa97d61, 0xffa3785e, 0xff9e745c, 0xff9e755d, 0xff9d765e, 0xff99735c, 0xff936d59, 0xff886655,
    0xff7e6153, 0xff7c5e53, 0xff856254, 0xff946a57, 0xffa7775e, 0xffb48162, 0xffb27f5f, 0xffa57657,
    0xff9a6d52, 0xff946750, 0xff946750, 0xff9d6d52, 0xffa87756, 0xffb3815c, 0xffba875f, 0xffba855c,
    0xffb37b55, 0xffa26f50, 0xff8e6550, 0xff7a5a4e, 0xff674f49, 0xff624b45, 0xff634b44, 0xff715549,
    0xff906b55, 0xffb28564, 0xffc9976e, 0xffcc996f, 0xffcd9b6f, 0xffd3a271, 0xffd2a371, 0xffcb9b6d,
    0xffc08f66, 0xffb18260, 0xffa77b5c, 0xffad8261, 0xffc2966c, 0xffc89b6d, 0xffb0855d, 0xff9e7452,
    0xffa47858, 0xffb48564, 0xffc38f6a, 0xffcb946a, 0xffc79368, 0xffb88c65, 0xffb28b64, 0xffbf9469,
    0xffd19f70, 0xffd7a375, 0xffd8a377, 0xffd5a175, 0xffd09f71, 0xffca9b6e, 0xffc5976d, 0xffc1946c,
    0xffc0936b, 0xffb18964, 0xff8b6d54, 0xff665346, 0xff635147, 0xff735e50, 0xff6e594d, 0xff554640,
    0xff403736, 0xff3b3736, 0xff3f3c3a, 0xff413b3a, 0xff453c3b, 0xff4e403d, 0xff574640, 0xff5c4942,
    0xff1b4e59, 0xff1b4e59, 0xff1c505a, 0xff1d515a, 0xff1a4f55, 0xff174c51, 0xff174c52, 0xff194e55,
    0xff1d5058, 0xff1f5259, 0xff23545b, 0xff25565e, 0xff275761, 0xff285862, 0xff295963, 0xff2a5964,
    0xff2c5a65, 0xff2e5b68, 0xff315d6b, 0xff315d6c, 0xff2e5967, 0xff2b5763, 0xff2a5761, 0xff2c5961,
    0xff2e5c63, 0xff305e66, 0xff315e67, 0xff305c65, 0xff305c65, 0xff34606a, 0xff37636d, 0xff36626d,
    0xff35606d, 0xff37606f, 0xff3a6172, 0xff3b6074, 0xff385e74, 0xff365a71, 0xff34586b, 0xff335667,
    0xff325566, 0xff325567, 0xff325568, 0xff32566a, 0xff32556a, 0xff325469, 0xff305266, 0xff2d5063,
    0xff2c5062, 0xff2d5264, 0xff305468, 0xff33576c, 0xff35596e, 0xff36596e, 0xff36586b, 0xff36586b,
    0xff3a5a70, 0xff3d5c74, 0xff3f5e77, 0xff405f79, 0xff415f7a, 0xff425f79, 0xff435f79, 0xff436079,
    0xff446079, 0xff456079, 0xff486179, 0xff4c6379, 0xff516679, 0xff556878, 0xff596a76, 0xff5d6975,
    0xff5e6774, 0xff64697a, 0xff6e7589, 0xff747c94, 0xff737a96, 0xff6f7696, 0xff6d7598, 0xff6f799e,
    0xff7380ab, 0xff7987bb, 0xff8290c8, 0xff8d99ce, 0xff959cc8, 0xff989bbb, 0xff9794a7, 0xff8e8992,
    0xff847d80, 0xff807570, 0xff837569, 0xff8a7665, 0xff947660, 0xff9f785f, 0xffac7e5e, 0xffb68460,
    0xffbb8962, 0xffb98c63, 0xffb58a64, 0xffb18664, 0xffa97e62, 0xff9e765e, 0xff98715c, 0xff99725d,
    0xff9a735d, 0xff97705b, 0xff906a56, 0xff805f50, 0xff6d534c, 0xff624b48, 0xff634944, 0xff715046,
    0xff855e4e, 0xff9a6d56, 0xffa67559, 0xffa97757, 0xffab7757, 0xffab7758, 0xffaf7a59, 0xffba8459,
    0xffc48e5c, 0xffcc9864, 0xffd09e6a, 0xffcf9d6a, 0xffc99565, 0xffb98860, 0xffa87c5e, 0xff906b57,
    0xff74554b, 0xff614641, 0xff503a3b, 0xff523c3d, 0xff705249, 0xff9c725a, 0xffbf8c67, 0xffcb956a,
    0xffd5a06e, 0xffe6b278, 0xffe8b67b, 0xffdaa874, 0xffc69469, 0xffb88863, 0xffb48662, 0xffb88b65,
    0xffc2946a, 0xffc5966a, 0xffb7885f, 0xffad7e59, 0xffb0805d, 0xffba8765, 0xffc28d67, 0xffc88f65,
    0xffc69065, 0xffbd8d67, 0xffbe906a, 0xffcd9b6e, 0xffdfa672, 0xffe2a976, 0xffdfa777, 0xffdca576,
    0xffd8a274, 0xffd19e71, 0xffcb996f, 0xffc7976e, 0xffc9976d, 0xffc19168, 0xffa57d5e, 0xff886954,
    0xff846854, 0xff8f715a, 0xff8a6e59, 0xff796050, 0xff675348, 0xff5b4c44, 0xff544842, 0xff514541,
    0xff50433f, 0xff4c403c, 0xff483b38, 0xff453936, 0xff1d4e5b, 0xff1d4e5b, 0xff1e505e, 0xff1f515f,
    0xff1d4f5a, 0xff1a4c54, 0xff1a4c53, 0xff1d4d56, 0xff1f4f59, 0xff21525a, 0xff24545b, 0xff27565e,
    0xff295760, 0xff2a5861, 0xff2b5862, 0xff2c5863, 0xff2c5964, 0xff2e5967, 0xff305a6a, 0xff315a6b,
    0xff315a6a, 0xff305b69, 0xff315c6b, 0xff325d6c, 0xff325d6b, 0xff305b67, 0xff2d5862, 0xff2a555e,
    0xff2a555d, 0xff305b64, 0xff345f6a, 0xff335f6a, 0xff325c69, 0xff345d6b, 0xff385e6e, 0xff395e72,
    0xff385c74, 0xff355971, 0xff325568, 0xff305462, 0xff325664, 0xff355a68, 0xff355a6a, 0xff34596a,
    0xff345768, 0xff335466, 0xff335363, 0xff315261, 0xff315362, 0xff335665, 0xff365969, 0xff395c6d,
    0xff3a5d71, 0xff3b5d73, 0xff3b5c72, 0xff3c5c74, 0xff405e78, 0xff43607b, 0xff45627d, 0xff45627c,
    0xff45617b, 0xff465f79, 0xff465e77, 0xff465e77, 0xff475f77, 0xff485e75, 0xff4a5f75, 0xff4e6276,
    0xff546679, 0xff586779, 0xff5c6879, 0xff676f80, 0xff75798b, 0xff85879a, 0xff9598af, 0xff9a9fbc,
    0xff979cc1, 0xff8d92be, 0xff848bb7, 0xff7e86af, 0xff7480ac, 0xff6b7db1, 0xff687cb0, 0xff707da6,
    0xff7d819a, 0xff8a8791, 0xff978c88, 0xff9f8b7d, 0xffa28874, 0xffa98a6d, 0xffb18f6c, 0xffb5916a,
    0xffb28a67, 0xffaf8464, 0xffb08262, 0xffb38462, 0xffb98b65, 0xffbe9369, 0xffbd936a, 0xffb78d67,
    0xffb08664, 0xffa97f62, 0xffa67d61, 0xffa97f62, 0xffab8162, 0xffaa7f60, 0xffa4795d, 0xff8f6a55,
    0xff73584d, 0xff5e4945, 0xff56413d, 0xff5f453c, 0xff705043, 0xff8a624e, 0xffa37457, 0xffb7835d,
    0xffc98f63, 0xffd09365, 0xffd89966, 0xffe4a465, 0xffecaf67, 0xffefba72, 0xffeebf7c, 0xffebbe7f,
    0xffe4b77b, 0xffd9ab77, 0xffd0a173, 0xffbc8e69, 0xff9b7056, 0xff7c5747, 0xff5b403d, 0xff4e3a3d,
    0xff664b48, 0xff946a58, 0xffbb8765, 0xffcd9567, 0xffdfa66e, 0xfff6bf7c, 0xfffac582, 0xffe7b479,
    0xffce9e6d, 0xffc7976a, 0xffcd9d6f, 0xffcf9f70, 0xffcc9c6d, 0xffca986b, 0xffc79568, 0xffc69267,
    0xffc59067, 0xffc48e66, 0xffc28b64, 0xffc08861, 0xffbe8862, 0xffbc8a68, 0xffc1906d, 0xffce996e,
    0xffd89f6e, 0xffd59e6d, 0xffcd986c, 0xffc7946c, 0xffc4916c, 0xffbd8c6a, 0xffb58868, 0xffb28666,
    0xffb78866, 0xffb98965, 0xffaf8261, 0xffa37b5e, 0xff9f7a5e, 0xffa07e60, 0xffa07e60, 0xff9e7a60,
    0xff95725c, 0xff836554, 0xff72594c, 0xff6d574b, 0xff69564b, 0xff5c4c43, 0xff4c3f39, 0xff433733,
    0xff1f4f5c, 0xff1f4f5c, 0xff205061, 0xff215162, 0xff1f4f5d, 0xff1d4c57, 0xff1d4c56, 0xff1f4d58,
    0xff214f5b, 0xff22515c, 0xff25535d, 0xff29555e, 0xff2b565f, 0xff2c5660, 0xff2c5661, 0xff2c5661,
    0xff2c5761, 0xff2c5763, 0xff2d5666, 0xff2f5768, 0xff325a6b, 0xff345d6d, 0xff365f72, 0xff365f73,
    0xff345e70, 0xff305a69, 0xff2b5560, 0xff275059, 0xff264f57, 0xff2c5660, 0xff315b67, 0xff325b67,
    0xff315965, 0xff335967, 0xff365b6a, 0xff385b6e, 0xff385b71, 0xff35596f, 0xff315566, 0xff2f5460,
    0xff335863, 0xff375c69, 0xff395e6b, 0xff385c6a, 0xff375a68, 0xff375766, 0xff375663, 0xff365563,
    0xff375764, 0xff3b5b67, 0xff3e5f6c, 0xff406170, 0xff416073, 0xff416075, 0xff415f77, 0xff425f78,
    0xff445f7b, 0xff46607c, 0xff48617d, 0xff49617d, 0xff495f7a, 0xff485d76, 0xff485c73, 0xff485c73,
    0xff495d72, 0xff4a5c71, 0xff4e5e72, 0xff546578, 0xff5c6c7e, 0xff5f6c7e, 0xff62697e, 0xff73768b,
    0xff8b8da0, 0xffa3a4b7, 0xffb4b5cd, 0xffb6b8d7, 0xffb0b3dc, 0xffa1a5d8, 0xff9399cb, 0xff888eba,
    0xff7881aa, 0xff6a78a3, 0xff627095, 0xff656b7e, 0xff726e6f, 0xff86786b, 0xff9d866c, 0xffb18f6c,
    0xffbf956b, 0xffce9d6c, 0xffd7a56e, 0xffd7a66f, 0xffca9a6c, 0xffbb8e69, 0xffb18665, 0xffad8364,
    0xffb28967, 0xffbc936c, 0xffc0976d, 0xffbd936a, 0xffba9068, 0xffb98f67, 0xffba9068, 0xffbf936a,
    0xffc2956a, 0xffc29369, 0xffbb8c65, 0xffa2785c, 0xff816150, 0xff634c44, 0xff523f39, 0xff543f37,
    0xff5f473b, 0xff785846, 0xff996f53, 0xffb9865e, 0xffd49867, 0xffdf9e69, 0xffe9a66a, 0xfff7b369,
    0xffffbf6c, 0xffffcb7a, 0xffffd387, 0xfffcd48d, 0xfff9cf8b, 0xfff5c989, 0xfff4c487, 0xffe5b37c,
    0xffc39065, 0xff9f7053, 0xff765547, 0xff5f4845, 0xff6a514b, 0xff8e6756, 0xffb17f5f, 0xffc58f60,
    0xffdba368, 0xfff8be79, 0xffffc782, 0xffefbb7c, 0xffd8a972, 0xffd6a772, 0xffe1b079, 0xffe0ae78,
    0xffd4a271, 0xffcd9b6c, 0xffd39d6f, 0xffd69e70, 0xffce966a, 0xffc28c62, 0xffb7825c, 0xffb07c59,
    0xffac7b5c, 0xffae7f63, 0xffb58769, 0xffc28f6a, 0xffc99267, 0xffbf8c62, 0xffb0835e, 0xffa87d5e,
    0xffa77b61, 0xffa17860, 0xff9b745d, 0xff99735b, 0xff9f765b, 0xffa87b5e, 0xffae8061, 0xffb08364,
    0xffae8463, 0xffa98361, 0xffaa8563, 0xffb18868, 0xffaf8467, 0xff9f775f, 0xff8c6955, 0xff866755,
    0xff806554, 0xff6d584a, 0xff57473d, 0xff4a3c35, 0xff204f5c, 0xff204f5c, 0xff21505f, 0xff215061,
    0xff204f5f, 0xff1f4d5c, 0xff1f4d5b, 0xff204e5b, 0xff224f5c, 0xff23505d, 0xff24515e, 0xff28535f,
    0xff2a5460, 0xff2c5561, 0xff2c5562, 0xff2b5561, 0xff2a5560, 0xff2b5561, 0xff2d5663, 0xff305765,
    0xff325a68, 0xff345c6a, 0xff355d6d, 0xff355d6e, 0xff355d6e, 0xff335c6b, 0xff305964, 0xff2c545c,
    0xff2b5259, 0xff2e555f, 0xff315965, 0xff335a66, 0xff345965, 0xff355966, 0xff355968, 0xff375a6b,
    0xff395c6e, 0xff395d6f, 0xff345969, 0xff325765, 0xff345966, 0xff375c69, 0xff385e6b, 0xff385d6b,
    0xff385b6b, 0xff3a5a6a, 0xff3b596a, 0xff3c5a6b, 0xff3e5c6d, 0xff426070, 0xff466472, 0xff476473,
    0xff476273, 0xff466073, 0xff455f74, 0xff445e74, 0xff435b72, 0xff445a71, 0xff465b72, 0xff495c72,
    0xff495b70, 0xff47596d, 0xff47576b, 0xff48576b, 0xff4b596c, 0xff505c6e, 0xff586375, 0xff657085,
    0xff727c94, 0xff717993, 0xff6e718b, 0xff818098, 0xffa4a1b3, 0xffc0bbcc, 0xffc8c3d7, 0xffbfbcd7,
    0xffb0b1d6, 0xff9ca1cf, 0xff8f95c6, 0xff888eb9, 0xff8486a4, 0xff86808f, 0xff887a78, 0xff887360,
    0xff8e7457, 0xff9c7e58, 0xffaf8c62, 0xffc39867, 0xffd3a06a, 0xffdfa76d, 0xffe2ab6f, 0xffdda86f,
    0xffcf9d6e, 0xffbf8f6b, 0xffaf8265, 0xffa47b61, 0xffa47d62, 0xffad8666, 0xffb99069, 0xffc3976b,
    0xffce9f6e, 0xffd7a771, 0xffddac73, 0xffe2af75, 0xffe1ae75, 0xffdeaa73, 0xffd4a16f, 0xffb98b64,
    0xff997056, 0xff775748, 0xff5c463c, 0xff544239, 0xff564439, 0xff674e40, 0xff7f604a, 0xff9a7354,
    0xffaf805a, 0xffb5835a, 0xffc08a5a, 0xffd69a5d, 0xffe7ab65, 0xfff2bb74, 0xfff8c884, 0xfffcd08b,
    0xfffed48c, 0xffffd98f, 0xffffde94, 0xfffdd38e, 0xffe2b179, 0xffc39066, 0xffa57a5b, 0xff8f6d56,
    0xff846453, 0xff876352, 0xff926951, 0xffa27352, 0xffb98559, 0xffd8a069, 0xffebb275, 0xfff0b87a,
    0xffecb77a, 0xffebb87c, 0xffebb87d, 0xffe3b079, 0xffd7a471, 0xffce9a6b, 0xffce986c, 0xffc7916a,
    0xffb07f5d, 0xff976c50, 0xff8d644a, 0xff8e654c, 0xff8b654f, 0xff856351, 0xff8d6a57, 0xffa4795f,
    0xffb48463, 0xffa67b5c, 0xff906c52, 0xff886651, 0xff8a6856, 0xff8a6757, 0xff866454, 0xff866452,
    0xff896653, 0xff916b56, 0xff9b725a, 0xffa4795e, 0xffa87d5f, 0xffa77e5f, 0xffa57e5f, 0xffa17c60,
    0xff9e795f, 0xff9d765d, 0xff9a725a, 0xff967059, 0xff8e6b56, 0xff7f624f, 0xff6f5747, 0xff655142,
    0xff21505c, 0xff21505c, 0xff20505d, 0xff204f5f, 0xff204e60, 0xff214e5f, 0xff214f5f, 0xff21505e,
    0xff21505e, 0xff224f5e, 0xff234f5f, 0xff265160, 0xff285261, 0xff2b5363, 0xff2c5464, 0xff2b5463,
    0xff285360, 0xff29545f, 0xff2d5560, 0xff315762, 0xff325964, 0xff325a65, 0xff325a65, 0xff325a65,
    0xff345c68, 0xff375f6b, 0xff375e69, 0xff345b61, 0xff32595d, 0xff31575f, 0xff325863, 0xff355a65,
    0xff385c66, 0xff385b66, 0xff375966, 0xff385a68, 0xff3b5d6b, 0xff3c5f6d, 0xff395d6c, 0xff375b6b,
    0xff365b6a, 0xff375b6a, 0xff375b6b, 0xff375c6d, 0xff395c6f, 0xff3c5d71, 0xff3f5d72, 0xff415e73,
    0xff435f74, 0xff476376, 0xff4a6677, 0xff4b6676, 0xff4a6373, 0xff486070, 0xff475e6f, 0xff445b6c,
    0xff415566, 0xff405263, 0xff425364, 0xff465667, 0xff465767, 0xff455565, 0xff455465, 0xff475465,
    0xff4b5668, 0xff535d6d, 0xff606879, 0xff747b93, 0xff858aa8, 0xff8285a5, 0xff787996, 0xff8a879f,
    0xffb0aabb, 0xffcbc2cf, 0xffc6bdcd, 0xffb2acc2, 0xff9d9cba, 0xff8a8eb3, 0xff8087b1, 0xff8287af,
    0xff91899d, 0xffa88d82, 0xffb98d68, 0xffb88857, 0xffb48655, 0xffb88b5b, 0xffc19466, 0xffcd9d6c,
    0xffd7a36e, 0xffdca66f, 0xffd9a56e, 0xffd19f6d, 0xffc7976c, 0xffbb8d6a, 0xffab8064, 0xff9e7660,
    0xff99735d, 0xff9e785f, 0xffaf8664, 0xffc6976b, 0xffdca872, 0xffedb878, 0xfff5bf7b, 0xfff9c37d,
    0xfff5bf7c, 0xffefb979, 0xffe3ae75, 0xffc99668, 0xffad7b5a, 0xff8c624d, 0xff6d5144, 0xff5d4a41,
    0xff57473e, 0xff5d493e, 0xff685042, 0xff735948, 0xff7b5d48, 0xff7b5a44, 0xff855f43, 0xffa1714a,
    0xffbb8657, 0xffce9967, 0xffdeab77, 0xffeeba7f, 0xfffbc681, 0xffffd689, 0xffffe494, 0xfffee195,
    0xffecc487, 0xffdaa977, 0xffcf9d6f, 0xffc19367, 0xffa47d5c, 0xff876550, 0xff795747, 0xff7f5945,
    0xff93664a, 0xffb17c57, 0xffcd9466, 0xffe8ac74, 0xfff7bd7e, 0xfff5bf80, 0xffe7b57c, 0xffdaa975,
    0xffd4a26f, 0xffcb986a, 0xffc08c65, 0xffad7d5d, 0xff8b634d, 0xff6d4e3e, 0xff674a3c, 0xff715243,
    0xff6e5244, 0xff604a40, 0xff644e44, 0xff856554, 0xff9f775f, 0xff906c57, 0xff775a4b, 0xff6f5649,
    0xff755b4e, 0xff795d50, 0xff795c4d, 0xff795b4b, 0xff795c4c, 0xff7c5e4e, 0xff81614f, 0xff896652,
    0xff936d56, 0xff9a7259, 0xff936f57, 0xff7f6350, 0xff785f4d, 0xff886953, 0xff9b7359, 0xff997057,
    0xff8f6952, 0xff886550, 0xff846450, 0xff816450, 0xff215059, 0xff215059, 0xff204f5a, 0xff1f4e5b,
    0xff204e5e, 0xff214f61, 0xff215061, 0xff21505f, 0xff214f5e, 0xff224e5d, 0xff234d5e, 0xff244e60,
    0xff265061, 0xff295263, 0xff2b5464, 0xff2a5362, 0xff28525f, 0xff29535e, 0xff2e5760, 0xff315961,
    0xff325a62, 0xff315961, 0xff30575e, 0xff30575d, 0xff345b64, 0xff39606c, 0xff3c636d, 0xff3b6167,
    0xff385d61, 0xff355960, 0xff345861, 0xff375a64, 0xff3b5e67, 0xff3b5d67, 0xff395b67, 0xff3a5c68,
    0xff3d5f69, 0xff3f616c, 0xff3e606e, 0xff3c5d6f, 0xff395a6c, 0xff385969, 0xff38596a, 0xff3a5b6e,
    0xff3e5d72, 0xff425f75, 0xff456077, 0xff486178, 0xff496278, 0xff4c657a, 0xff4f6679, 0xff4f6576,
    0xff4d6272, 0xff4b5f6d, 0xff495d6a, 0xff455966, 0xff40515e, 0xff3e4d5b, 0xff404e5c, 0xff435260,
    0xff445462, 0xff435362, 0xff455262, 0xff485162, 0xff4d5465, 0xff565d6c, 0xff646a7c, 0xff7a7f98,
    0xff8d8fb0, 0xff898aad, 0xff7d7d9b, 0xff8b88a0, 0xffafa8b8, 0xffc4bac6, 0xffb6adbc, 0xff9d98ab,
    0xff8787a1, 0xff777b9a, 0xff71799e, 0xff797fa3, 0xff968996, 0xffbd957b, 0xffd99c64, 0xffd9995a,
    0xffcf955c, 0xffcc9561, 0xffcb9768, 0xffcf9d6e, 0xffd5a371, 0xffd4a371, 0xffcd9e6e, 0xffc6986b,
    0xffc2946b, 0xffbc8e6a, 0xffaf8366, 0xffa37861, 0xff99715c, 0xff98715a, 0xffa87e5f, 0xffc29367,
    0xffdda871, 0xfff1b978, 0xfffac17c, 0xfffec57f, 0xfffac27e, 0xfff1bb7b, 0xffe3b075, 0xffcd9969,
    0xffb6815c, 0xff9a6a50, 0xff7b5a4a, 0xff675347, 0xff5c4c42, 0xff59483e, 0xff55453d, 0xff53433c,
    0xff4e3d36, 0xff48362f, 0xff50392e, 0xff6d4a39, 0xff8b6048, 0xffa37457, 0xffb98866, 0xffd19c6e,
    0xffe6ac72, 0xfff8c37e, 0xffffd78d, 0xfffedc94, 0xfff1c98c, 0xffe7b781, 0xffeeb87e, 0xffecb477,
    0xffc69766, 0xff916e52, 0xff705243, 0xff6f4d40, 0xff7b5242, 0xff8e5e48, 0xffaa7555, 0xffd29869,
    0xfff0b67a, 0xffeeb87c, 0xffd7a773, 0xffc99c6d, 0xffca9a6b, 0xffc69468, 0xffb78561, 0xff9f7156,
    0xff7a5646, 0xff5a4138, 0xff553f37, 0xff624a3f, 0xff5d493f, 0xff4a3d37, 0xff4a3d38, 0xff685147,
    0xff836354, 0xff765a4e, 0xff5f4b44, 0xff5a4842, 0xff634f46, 0xff695348, 0xff6c5346, 0xff6c5245,
    0xff6a5246, 0xff685247, 0xff685145, 0xff6b5244, 0xff795a49, 0xff866350, 0xff7b5d4c, 0xff5c4b40,
    0xff53463c, 0xff6f5948, 0xff916d55, 0xff906951, 0xff86604b, 0xff86614d, 0xff8c6a54, 0xff8f6f58,
    0xff1f4d55, 0xff1f4d55, 0xff1e4c56, 0xff1e4c58, 0xff1f4d5b, 0xff204e5e, 0xff214f5e, 0xff224f5d,
    0xff224e5c, 0xff224d5c, 0xff234c5c, 0xff244e5e, 0xff26505f, 0xff295261, 0xff2b5462, 0xff2b5461,
    0xff29535e, 0xff2c545f, 0xff305863, 0xff335b65, 0xff335b64, 0xff325a62, 0xff30575e, 0xff31575c,
    0xff355b63, 0xff3a606d, 0xff3d626f, 0xff3c6068, 0xff395c61, 0xff35585d, 0xff34575d, 0xff385a61,
    0xff3c5e67, 0xff3e606b, 0xff3d606c, 0xff3d606c, 0xff3f616b, 0xff3f606a, 0xff3e5d6b, 0xff3d5b6b,
    0xff3b5968, 0xff3c5967, 0xff3e5a69, 0xff435d6e, 0xff475f72, 0xff4a6174, 0xff4d6275, 0xff4f6373,
    0xff506372, 0xff526574, 0xff526576, 0xff516474, 0xff4f6170, 0xff4d5e6c, 0xff4d5e6b, 0xff4a5b68,
    0xff455565, 0xff425163, 0xff425164, 0xff435366, 0xff445566, 0xff465565, 0xff495565, 0xff4d5465,
    0xff515667, 0xff565b6b, 0xff5e6475, 0xff6c7189, 0xff7a7d9a, 0xff7c7d9b, 0xff797992, 0xff838195,
    0xff9792a2, 0xff9f9aa9, 0xff918fa2, 0xff7e8099, 0xff707793, 0xff697290, 0xff677192, 0xff6f7595,
    0xff89808e, 0xffac8d81, 0xffc79876, 0xffcd9c74, 0xffc89a73, 0xffc5926a, 0xffc28b63, 0xffc58f65,
    0xffcc9a6b, 0xffcc9e6f, 0xffc89b6e, 0xffc5986d, 0xffc89a6e, 0xffc99a6e, 0xffc4966c, 0xffbc8f69,
    0xffb18563, 0xffa77d5e, 0xffa67c5d, 0xffae835f, 0xffba8d64, 0xffc89869, 0xffd4a26d, 0xffdfab72,
    0xffe2ae74, 0xffddaa73, 0xffcf9e6e, 0xffbb8b63, 0xffa97858, 0xff94674f, 0xff7d5b4b, 0xff6d5649,
    0xff635046, 0xff5b4b41, 0xff51433b, 0xff473a34, 0xff3c2f2b, 0xff332623, 0xff372622, 0xff4d342d,
    0xff64453a, 0xff765446, 0xff896451, 0xffa2775a, 0xffbb8962, 0xffd19f6d, 0xffdbb079, 0xffe0b980,
    0xffe3b782, 0xffe9b782, 0xfffcc585, 0xffffcb84, 0xffe4b376, 0xffb28b63, 0xff906c53, 0xff89624c,
    0xff865c47, 0xff7c5342, 0xff835a47, 0xffa27556, 0xffc29166, 0xffc7976a, 0xffba8d65, 0xffb58963,
    0xffbb8d65, 0xffc09067, 0xffc18e66, 0xffb68461, 0xff9e7355, 0xff83614a, 0xff765845, 0xff735846,
    0xff6a5244, 0xff5d4a41, 0xff55443d, 0xff56433b, 0xff58433a, 0xff50403a, 0xff493e3c, 0xff4b403d,
    0xff53443f, 0xff5a473f, 0xff5d493f, 0xff5e4940, 0xff5c4a42, 0xff594943, 0xff54453e, 0xff544339,
    0xff5f493d, 0xff6c5245, 0xff634c41, 0xff473a34, 0xff3f3630, 0xff5d4b3e, 0xff7e614d, 0xff7b5c49,
    0xff6e5242, 0xff6f5444, 0xff785d4c, 0xff7e6350, 0xff1c4b52, 0xff1c4b52, 0xff1d4b54, 0xff1d4b56,
    0xff1d4b58, 0xff1e4c5a, 0xff204d5a, 0xff234e5a, 0xff244e5a, 0xff234d5a, 0xff234d5a, 0xff264f5c,
    0xff28515d, 0xff2a535f, 0xff2b5560, 0xff2b555f, 0xff2c545e, 0xff2f5761, 0xff335b67, 0xff355d6a,
    0xff355d68, 0xff345c65, 0xff335a61, 0xff33595f, 0xff365b65, 0xff3b5f6e, 0xff3d606e, 0xff3b5d67,
    0xff38595e, 0xff35575a, 0xff34575a, 0xff385a5f, 0xff3d5e66, 0xff41626d, 0xff426571, 0xff416472,
    0xff3f616e, 0xff3d5c69, 0xff3c5866, 0xff3d5765, 0xff3e5764, 0xff405865, 0xff455b69, 0xff4b5e6d,
    0xff506171, 0xff506372, 0xff526370, 0xff55636c, 0xff56626a, 0xff56636d, 0xff546370, 0xff516271,
    0xff505f6f, 0xff4f5e6e, 0xff505e6e, 0xff505e6e, 0xff4b5a6f, 0xff485770, 0xff465771, 0xff465870,
    0xff47586f, 0xff49596d, 0xff4d5a6b, 0xff525b6b, 0xff545b6b, 0xff53596a, 0xff535a6d, 0xff585f74,
    0xff5f667c, 0xff686c81, 0xff707284, 0xff767688, 0xff797889, 0xff76778b, 0xff6d728e, 0xff666f90,
    0xff626f93, 0xff637193, 0xff646f91, 0xff696e8d, 0xff79758c, 0xff8d818e, 0xffa08e90, 0xffad9791,
    0xffb19589, 0xffb28972, 0xffb27d5d, 0xffb7815a, 0xffc08f65, 0xffc6986c, 0xffc89a6e, 0xffcb9d6f,
    0xffd2a471, 0xffd7a872, 0xffdbaa73, 0xffd9a772, 0xffce9e6d, 0xffbe9166, 0xffaa815e, 0xff9a7558,
    0xff936f55, 0xff977257, 0xffa47c5c, 0xffb48863, 0xffc09068, 0xffbe8e67, 0xffb28462, 0xffa1765a,
    0xff916a52, 0xff835f4b, 0xff775848, 0xff705548, 0xff695348, 0xff625045, 0xff57483d, 0xff4c3d32,
    0xff403128, 0xff392821, 0xff392721, 0xff45302a, 0xff523c34, 0xff5a433b, 0xff654d43, 0xff7a5b4c,
    0xff926b56, 0xffa77b5f, 0xffae8564, 0xffb88f69, 0xffca9a71, 0xffdca879, 0xfff5c083, 0xffffce87,
    0xfff1c281, 0xffd1a574, 0xffb88c66, 0xffb1825e, 0xffa17253, 0xff7d5845, 0xff6d4e40, 0xff795846,
    0xff916a51, 0xff9d7356, 0xff9f7457, 0xffa4795a, 0xffab805f, 0xffb88b66, 0xffcd996d, 0xffd69f6e,
    0xffcf996b, 0xffbd8c63, 0xffa77c5a, 0xff936d53, 0xff836350, 0xff806252, 0xff72584b, 0xff533f35,
    0xff392b24, 0xff382f2a, 0xff423a37, 0xff49403c, 0xff4e403b, 0xff52413a, 0xff54433b, 0xff55453d,
    0xff554741, 0xff534642, 0xff4d403b, 0xff493b34, 0xff4f3f35, 0xff59463b, 0xff534239, 0xff41342e,
    0xff3d322c, 0xff544239, 0xff6a5345, 0xff644e42, 0xff56453b, 0xff55443b, 0xff5d4b40, 0xff614e43,
    0xff1b4951, 0xff1b4951, 0xff1d4a53, 0xff1e4b55, 0xff1d4b55, 0xff1d4b55, 0xff1f4c55, 0xff234c56,
    0xff264d56, 0xff254e57, 0xff254f58, 0xff295159, 0xff2b535a, 0xff2c545b, 0xff2c555d, 0xff2d565d,
    0xff2f575d, 0xff335962, 0xff365c69, 0xff375e6d, 0xff375e6c, 0xff365d68, 0xff365c65, 0xff375b64,
    0xff395c67, 0xff3b5d6c, 0xff3b5c6b, 0xff395a64, 0xff37575d, 0xff355658, 0xff365758, 0xff3a5a5d,
    0xff3f5f65, 0xff44646d, 0xff476772, 0xff466672, 0xff415f6d, 0xff3c5967, 0xff3c5562, 0xff3e5461,
    0xff415562, 0xff465965, 0xff4c5d69, 0xff53616d, 0xff56636f, 0xff55636f, 0xff55636c, 0xff586266,
    0xff5a6264, 0xff596267, 0xff57626c, 0xff54616e, 0xff525f6f, 0xff515e70, 0xff535f71, 0xff536074,
    0xff505e78, 0xff4d5d7a, 0xff4b5d7b, 0xff4b5d79, 0xff4c5e78, 0xff4f5f76, 0xff536074, 0xff566073,
    0xff565e71, 0xff505a6e, 0xff4b556b, 0xff495367, 0xff4b5567, 0xff585f70, 0xff686b7c, 0xff6a6d80,
    0xff5e6379, 0xff535b76, 0xff515e81, 0xff54648c, 0xff5a6a94, 0xff617097, 0xff656f93, 0xff676d8d,
    0xff707391, 0xff7b7f9f, 0xff898ba8, 0xff9894a7, 0xffa19196, 0xffa38176, 0xffa57258, 0xffab7553,
    0xffb68560, 0xffc1946b, 0xffc99b6f, 0xffd1a372, 0xffdaac74, 0xffe2b375, 0xffedba78, 0xfff0bb79,
    0xffe7b375, 0xffd5a46e, 0xffb68b63, 0xff977357, 0xff80614f, 0xff795a4d, 0xff815f50, 0xff8e6955,
    0xff9b7159, 0xff9b7159, 0xff906955, 0xff83604f, 0xff785a4a, 0xff705546, 0xff6f5346, 0xff6f5346,
    0xff6c5448, 0xff665246, 0xff5b493c, 0xff4e3e2f, 0xff453325, 0xff422f23, 0xff422f25, 0xff45332b,
    0xff473831, 0xff463934, 0xff4a3d38, 0xff594641, 0xff6d524b, 0xff7e5b51, 0xff835e50, 0xff906753,
    0xffa87a5e, 0xffc2906b, 0xffe1ac78, 0xfff6bf81, 0xfff3bf81, 0xffdfaf79, 0xffd19f70, 0xffce9768,
    0xffb9855c, 0xff88644b, 0xff674f41, 0xff62493f, 0xff6e4e43, 0xff7b5648, 0xff87604d, 0xff926a53,
    0xff977057, 0xffa77e5f, 0xffc7966a, 0xffdea672, 0xffe8ad75, 0xffe2a872, 0xffca9568, 0xffaa7f5b,
    0xff987257, 0xff9a745d, 0xff896754, 0xff584135, 0xff2e211b, 0xff302924, 0xff433d37, 0xff4b423d,
    0xff4b3e39, 0xff4c3c37, 0xff4e3f39, 0xff50423c, 0xff50443f, 0xff4e433f, 0xff473d38, 0xff413732,
    0xff433832, 0xff473c36, 0xff463b34, 0xff3e332d, 0xff3f322c, 0xff4d3d35, 0xff58463e, 0xff4f413b,
    0xff433935, 0xff413834, 0xff473c37, 0xff4a3e38, 0xff1f4b52, 0xff1f4b52, 0xff214d54, 0xff224e55,
    0xff214d54, 0xff1f4c53, 0xff204c52, 0xff224c52, 0xff254e54, 0xff275157, 0xff2a5359, 0xff2c5457,
    0xff2e5456, 0xff2e5458, 0xff2e555a, 0xff30565c, 0xff33595d, 0xff365b62, 0xff385d68, 0xff385e6b,
    0xff375d69, 0xff375c67, 0xff385c68, 0xff3a5d69, 0xff3a5d69, 0xff3a5c68, 0xff3a5b66, 0xff3a5a64,
    0xff3a5860, 0xff39565b, 0xff3a5759, 0xff405c5c, 0xff466162, 0xff4a6568, 0xff4c666c, 0xff49636b,
    0xff445d67, 0xff405762, 0xff405461, 0xff435562, 0xff465765, 0xff4a5b68, 0xff4f5e6b, 0xff53606d,
    0xff55616f, 0xff54616f, 0xff54616e, 0xff58636a, 0xff5b6469, 0xff5d656b, 0xff5d656d, 0xff5a646f,
    0xff566270, 0xff536071, 0xff525f72, 0xff505e73, 0xff4e5d76, 0xff4d5e79, 0xff4e617c, 0xff51647f,
    0xff546580, 0xff566680, 0xff57647e, 0xff57627a, 0xff556077, 0xff515d77, 0xff4f5c76, 0xff4c5970,
    0xff4d596d, 0xff576277, 0xff636c85, 0xff616a86, 0xff515b7b, 0xff475477, 0xff4a5b84, 0xff526591,
    0xff576a98, 0xff5c6e9b, 0xff5f6f9d, 0xff64719f, 0xff737ea9, 0xff8792b7, 0xff999eb9, 0xffa39ba8,
    0xffa48f8d, 0xffa27e6f, 0xffa17058, 0xffa67454, 0xffb08260, 0xffbe9169, 0xffca9b6d, 0xffd5a470,
    0xffdfae73, 0xffe7b575, 0xfff1bc78, 0xfff5bf79, 0xfff2bc79, 0xffe6b376, 0xffcfa06d, 0xffb48b62,
    0xff9a7658, 0xff876553, 0xff7e5d50, 0xff79584c, 0xff775749, 0xff715346, 0xff694e44, 0xff624b42,
    0xff5f4b41, 0xff614c41, 0xff654f44, 0xff685147, 0xff685247, 0xff624f43, 0xff564335, 0xff483524,
    0xff433020, 0xff473528, 0xff4b3b31, 0xff4b3c33, 0xff493b33, 0xff443833, 0xff433735, 0xff4a3c3c,
    0xff564444, 0xff614948, 0xff654946, 0xff6f4e46, 0xff835c4d, 0xff996f57, 0xffb38865, 0xffc79c70,
    0xffcda071, 0xffc7986b, 0xffc89365, 0xffcf9261, 0xffc78b5d, 0xffa67a58, 0xff896a54, 0xff795b4d,
    0xff745348, 0xff765449, 0xff7d5b4c, 0xff805e4e, 0xff7d5d4d, 0xff85644f, 0xff9f7755, 0xffb7885d,
    0xffca9464, 0xffd09868, 0xffc58f66, 0xffaf805f, 0xff9e755a, 0xff9a735a, 0xff896751, 0xff684c3c,
    0xff4b382c, 0xff4d3d33, 0xff574940, 0xff564841, 0xff4e3f3a, 0xff4a3c38, 0xff4d3f3a, 0xff4e413c,
    0xff4c413b, 0xff483e39, 0xff453a35, 0xff423732, 0xff413733, 0xff413935, 0xff403834, 0xff403631,
    0xff423630, 0xff483a34, 0xff4c3d37, 0xff463a35, 0xff3f3733, 0xff403834, 0xff463c37, 0xff493e39,
    0xff234f55, 0xff234f55, 0xff255156, 0xff275157, 0xff265056, 0xff234e53, 0xff224d51, 0xff234c50,
    0xff264f53, 0xff2a5358, 0xff2e565b, 0xff305557, 0xff305454, 0xff305456, 0xff30555a, 0xff32575d,
    0xff365b5e, 0xff395d61, 0xff395d64, 0xff395d66, 0xff395b66, 0xff395b66, 0xff3b5d69, 0xff3d5f6b,
    0xff3c5e69, 0xff3a5c64, 0xff395b62, 0xff3b5b63, 0xff3d5a62, 0xff3d575e, 0xff3f575b, 0xff465c5c,
    0xff4c625e, 0xff4f6461, 0xff4e6262, 0xff4b5e61, 0xff475a5f, 0xff45575e, 0xff465762, 0xff495866,
    0xff4b5b6a, 0xff4d5e6d, 0xff4e5f6e, 0xff4e606f, 0xff4f6070, 0xff505f71, 0xff525f71, 0xff566371,
    0xff5a6671, 0xff5f6870, 0xff626970, 0xff606971, 0xff5b6774, 0xff556374, 0xff515e72, 0xff4d5a70,
    0xff4b5970, 0xff4c5c72, 0xff516278, 0xff57687f, 0xff5b6b84, 0xff5d6a86, 0xff5a6783, 0xff55627e,
    0xff52607b, 0xff526280, 0xff556584, 0xff586682, 0xff5a6782, 0xff5f6b89, 0xff626f93, 0xff5d6c93,
    0xff536189, 0xff4e5d85, 0xff566690, 0xff5d6e9a, 0xff5d6d9b, 0xff5d6d9c, 0xff5e71a5, 0xff667ab1,
    0xff8090be, 0xffa2a9c6, 0xffbab4bc, 0xffbca49a, 0xffb28e79, 0xffab7e64, 0xffa6765a, 0xffa8795b,
    0xffb08563, 0xffbe9269, 0xffcb9c6b, 0xffd7a56e, 0xffe0ad72, 0xffe5b174, 0xffebb575, 0xffeeb776,
    0xfff0b978, 0xffeeb879, 0xffe6b276, 0xffdaaa70, 0xffc79a68, 0xffac8361, 0xff946e58, 0xff7b5a4c,
    0xff674b40, 0xff58433a, 0xff514139, 0xff4f4139, 0xff54443a, 0xff5a483e, 0xff604d43, 0xff614f45,
    0xff614e44, 0xff5b483c, 0xff4e3b2c, 0xff412d1c, 0xff3f2d1d, 0xff4a3b2e, 0xff54463c, 0xff55463d,
    0xff534239, 0xff504038, 0xff4e3f39, 0xff50413d, 0xff544441, 0xff594744, 0xff5b4744, 0xff5f4943,
    0xff674c43, 0xff735547, 0xff846552, 0xff96755d, 0xff9d7a5d, 0xff9f7655, 0xffab7851, 0xffbc7e52,
    0xffc68558, 0xffc08c63, 0xffb18a67, 0xffa07b60, 0xff8f6955, 0xff856151, 0xff816151, 0xff765b4d,
    0xff6a5145, 0xff664d3f, 0xff6f533c, 0xff7f5e40, 0xff926949, 0xffa27354, 0xffa8785a, 0xffa4775b,
    0xff987056, 0xff8a664f, 0xff7d5d48, 0xff785946, 0xff765847, 0xff735948, 0xff6d5748, 0xff604f44,
    0xff53443e, 0xff4c3f3c, 0xff50413e, 0xff51433d, 0xff4c3f39, 0xff463b34, 0xff463b34, 0xff473c35,
    0xff453b37, 0xff433a38, 0xff423a38, 0xff443b38, 0xff463b37, 0xff483a35, 0xff483a33, 0xff473933,
    0xff473a34, 0xff4b3f38, 0xff52443c, 0xff55473e, 0xff275156, 0xff275156, 0xff2a5357, 0xff2b5357,
    0xff295156, 0xff274f53, 0xff244e51, 0xff234d4f, 0xff265052, 0xff2c5458, 0xff31575b, 0xff335756,
    0xff335553, 0xff335455, 0xff335559, 0xff35575c, 0xff395b5d, 0xff3b5d5f, 0xff3a5c5f, 0xff3a5b60,
    0xff3b5a61, 0xff3c5b63, 0xff3f5d68, 0xff405f6a, 0xff3e5e67, 0xff3b5c60, 0xff3c5b5e, 0xff3f5d61,
    0xff425c63, 0xff435961, 0xff44585e, 0xff4a5d5d, 0xff50625c, 0xff50615b, 0xff4e5d5a, 0xff4b595a,
    0xff49575a, 0xff49575d, 0xff4c5965, 0xff4e5b6b, 0xff4f5d6f, 0xff4f5f70, 0xff4e5f70, 0xff4d5f70,
    0xff4d5f71, 0xff4f5e72, 0xff515f75, 0xff546477, 0xff586777, 0xff5f6974, 0xff636a70, 0xff636b72,
    0xff5e6a75, 0xff586576, 0xff525f73, 0xff4d5a70, 0xff4b596d, 0xff4e5c6e, 0xff556375, 0xff5c6a7e,
    0xff606d85, 0xff5f6c88, 0xff5a6887, 0xff536281, 0xff50607f, 0xff546687, 0xff5b6c8e, 0xff617090,
    0xff657291, 0xff657396, 0xff62719d, 0xff5e6e9d, 0xff5a6996, 0xff5b6a93, 0xff65739a, 0xff6c79a0,
    0xff68749c, 0xff66719b, 0xff6977a7, 0xff7586b9, 0xff969fc4, 0xffbdbac5, 0xffd6c2b3, 0xffd1aa89,
    0xffc09069, 0xffb6845d, 0xffb0825f, 0xffb08462, 0xffb68b67, 0xffc2956a, 0xffce9d6a, 0xffd9a66c,
    0xffe1ac6f, 0xffe4af72, 0xffe5af72, 0xffe6b073, 0xffebb476, 0xfff2bb7b, 0xfff7c07d, 0xfff9c27b,
    0xffeeb977, 0xffd3a16f, 0xffb08462, 0xff8a6650, 0xff674d3f, 0xff513f36, 0xff493e34, 0xff493f35,
    0xff4f4238, 0xff57473d, 0xff5b4c43, 0xff5b4c44, 0xff5a4940, 0xff544136, 0xff473425, 0xff3c2818,
    0xff3e2d1e, 0xff4e4035, 0xff5c4e47, 0xff5e4d44, 0xff5c483e, 0xff5b473e, 0xff594740, 0xff574741,
    0xff554842, 0xff544843, 0xff554943, 0xff554741, 0xff53403a, 0xff543f38, 0xff5c4640, 0xff685048,
    0xff6f5447, 0xff765541, 0xff895c40, 0xffa06744, 0xffb77951, 0xffc89267, 0xffc79a72, 0xffb88e6b,
    0xffa1775d, 0xff906b57, 0xff856656, 0xff71594c, 0xff5e483f, 0xff4f3b32, 0xff473528, 0xff4e3929,
    0xff5e4232, 0xff735040, 0xff855f4c, 0xff8f6852, 0xff88654e, 0xff745641, 0xff6d513d, 0xff80604c,
    0xff936f5b, 0xff8d6a58, 0xff7b5e4f, 0xff675246, 0xff574841, 0xff4e423e, 0xff52443f, 0xff53433d,
    0xff4b3d36, 0xff453931, 0xff473b34, 0xff4b3f39, 0xff4a3f3b, 0xff463d3b, 0xff453d3c, 0xff483f3d,
    0xff4a403b, 0xff483c36, 0xff463932, 0xff473932, 0xff4c3d36, 0xff53433b, 0xff59493f, 0xff5e4c42,
    0xff275054, 0xff275054, 0xff2a5155, 0xff2c5255, 0xff2a5053, 0xff284d51, 0xff264d50, 0xff264e4f,
    0xff285051, 0xff2d5255, 0xff315457, 0xff345656, 0xff355655, 0xff365656, 0xff365659, 0xff38585a,
    0xff3a5a5b, 0xff3c5b5b, 0xff3c5a5a, 0xff3d5a5a, 0xff3f5c5e, 0xff415d61, 0xff435e64, 0xff435e64,
    0xff425d61, 0xff415c5d, 0xff425c5c, 0xff455e5e, 0xff475e60, 0xff475b61, 0xff475960, 0xff4a5b5f,
    0xff4d5d5d, 0xff4c5b5c, 0xff4a575b, 0xff48555b, 0xff48555c, 0xff495660, 0xff4d5968, 0xff505c6d,
    0xff525e6f, 0xff525f6f, 0xff526070, 0xff526170, 0xff536172, 0xff546174, 0xff566275, 0xff586576,
    0xff596675, 0xff5c6670, 0xff5e656c, 0xff5f666f, 0xff5f6875, 0xff5d6778, 0xff596378, 0xff556075,
    0xff545f72, 0xff556172, 0xff5a6677, 0xff5e6a7e, 0xff5e6a82, 0xff5b6885, 0xff576485, 0xff536283,
    0xff526283, 0xff556689, 0xff5a6b8e, 0xff606f90, 0xff647192, 0xff637195, 0xff606f99, 0xff606f9b,
    0xff63719b, 0xff6a759b, 0xff757d9c, 0xff7d819c, 0xff7e7e97, 0xff807e95, 0xff8a879d, 0xff9a95a7,
    0xffb4a8ac, 0xffccb7a8, 0xffdab898, 0xffd4a578, 0xffc79363, 0xffc18f60, 0xffbf9266, 0xffbf9469,
    0xffc3966a, 0xffcb9c6b, 0xffd4a26b, 0xffdda86c, 0xffe2ad70, 0xffe4af72, 0xffe3ae72, 0xffe3ae72,
    0xffe9b275, 0xfff1b979, 0xfffac27d, 0xffffc87e, 0xffffc57c, 0xffecb475, 0xffcf9c69, 0xffa97e59,
    0xff83624a, 0xff6b5341, 0xff604e3e, 0xff594b3d, 0xff5a4a3e, 0xff5b4a40, 0xff5b4c43, 0xff594a41,
    0xff534238, 0xff4b392d, 0xff422f22, 0xff3d2b1c, 0xff423224, 0xff514339, 0xff5d4f47, 0xff5f4e45,
    0xff5d4a40, 0xff5f4b42, 0xff5f4c45, 0xff5c4c45, 0xff574a43, 0xff544842, 0xff534842, 0xff50443f,
    0xff4a3c37, 0xff473733, 0xff463635, 0xff4a3a38, 0xff513d38, 0xff5b4136, 0xff6d4b38, 0xff7f553d,
    0xff946649, 0xffab7e5e, 0xffb18868, 0xffa88163, 0xff967056, 0xff8c6953, 0xff866754, 0xff745a4c,
    0xff5d483e, 0xff483730, 0xff392b24, 0xff392b23, 0xff45322b, 0xff583f38, 0xff694c41, 0xff725546,
    0xff6f5342, 0xff5f4736, 0xff5d4636, 0xff735847, 0xff886957, 0xff836455, 0xff72584b, 0xff624e43,
    0xff554740, 0xff4f423d, 0xff50423b, 0xff504039, 0xff4a3c35, 0xff453a32, 0xff473c35, 0xff4b3f39,
    0xff4b3f3b, 0xff483d3b, 0xff473e3c, 0xff48403d, 0xff49403b, 0xff473c36, 0xff463932, 0xff463932,
    0xff493c34, 0xff4e4138, 0xff54453c, 0xff57483f, 0xff264c52, 0xff264c52, 0xff294e52, 0xff2b4f52,
    0xff294d50, 0xff274a4f, 0xff284b50, 0xff2a4e51, 0xff2c4f52, 0xff2c4f51, 0xff2f5052, 0xff335456,
    0xff365659, 0xff375659, 0xff385658, 0xff395758, 0xff3a5858, 0xff3c5957, 0xff3e5856, 0xff415a58,
    0xff455e5d, 0xff476060, 0xff465f5f, 0xff455c5d, 0xff465c5c, 0xff485e5c, 0xff4a5e5c, 0xff4b5e5b,
    0xff4b5d5c, 0xff495b5f, 0xff485a61, 0xff485962, 0xff475861, 0xff465660, 0xff445460, 0xff445360,
    0xff455361, 0xff485664, 0xff4c5a6a, 0xff505d6e, 0xff525e6e, 0xff545f6c, 0xff56616d, 0xff586370,
    0xff5a6572, 0xff5c6674, 0xff5c6674, 0xff5b6572, 0xff5a636f, 0xff576069, 0xff565e67, 0xff58606b,
    0xff5d6573, 0xff606879, 0xff61697b, 0xff60697b, 0xff5e677a, 0xff5c6679, 0xff5d667b, 0xff5c667e,
    0xff59647f, 0xff54627f, 0xff516181, 0xff526284, 0xff546486, 0xff556587, 0xff576687, 0xff5a6788,
    0xff5c698a, 0xff5e6a8b, 0xff5f6b8e, 0xff657093, 0xff6c7699, 0xff767d9c, 0xff818299, 0xff8a8594,
    0xff918891, 0xff9a8d8f, 0xffab968e, 0xffbfa18d, 0xffcda889, 0xffcfa883, 0xffcea47a, 0xffcb9c6d,
    0xffc99867, 0xffca9a68, 0xffcc9f6c, 0xffcea16e, 0xffd0a06d, 0xffd4a36d, 0xffdaa76c, 0xffdfab6d,
    0xffe3af70, 0xffe5b072, 0xffe4af72, 0xffe4af72, 0xffe7b174, 0xffecb577, 0xfff3bb79, 0xfff9c17b,
    0xfffac279, 0xfff4ba73, 0xffe3ab6c, 0xffc89563, 0xffa87e59, 0xff916e52, 0xff82654e, 0xff735c4a,
    0xff6a5547, 0xff635045, 0xff5e4d43, 0xff5a473d, 0xff503d32, 0xff473327, 0xff422f22, 0xff423124,
    0xff49392d, 0xff53443a, 0xff5b4b43, 0xff5b4a41, 0xff5a483f, 0xff5e4b43, 0xff614f48, 0xff604f48,
    0xff5c4d46, 0xff584a43, 0xff564841, 0xff52443e, 0xff4d3f39, 0xff493b35, 0xff453631, 0xff443431,
    0xff493732, 0xff533e36, 0xff5e453b, 0xff664b3e, 0xff715544, 0xff816350, 0xff886955, 0xff866551,
    0xff7f5e4a, 0xff82604c, 0xff866451, 0xff7c5d4d, 0xff664e42, 0xff503e35, 0xff3f322a, 0xff3d3028,
    0xff45362f, 0xff523f39, 0xff59453d, 0xff5b463b, 0xff584437, 0xff523f32, 0xff534033, 0xff5f4a3d,
    0xff695347, 0xff685247, 0xff604c42, 0xff59473f, 0xff53453c, 0xff4e4139, 0xff4e3f37, 0xff4c3d36,
    0xff493c35, 0xff473c35, 0xff473c37, 0xff493d39, 0xff493d39, 0xff483d39, 0xff483d39, 0xff473e3a,
    0xff473e3a, 0xff483d38, 0xff483b35, 0xff453932, 0xff433932, 0xff453b34, 0xff493f38, 0xff4c413a,
    0xff24494f, 0xff24494f, 0xff284c50, 0xff2a4d50, 0xff284a4f, 0xff26474e, 0xff284a50, 0xff2d4e53,
    0xff2e5052, 0xff2c4d4e, 0xff2c4c4e, 0xff315256, 0xff36565c, 0xff39575b, 0xff3a5758, 0xff3a5756,
    0xff3a5756, 0xff3c5755, 0xff3f5753, 0xff435a55, 0xff49605c, 0xff4b625f, 0xff495f5b, 0xff465b56,
    0xff485b57, 0xff4d5f5c, 0xff50605d, 0xff505f5a, 0xff4e5d59, 0xff4c5c5e, 0xff495b62, 0xff455764,
    0xff415464, 0xff3f5164, 0xff3f5164, 0xff405165, 0xff425366, 0xff465669, 0xff4b5a6d, 0xff4f5d6e,
    0xff525d6c, 0xff545e69, 0xff59616b, 0xff5d656f, 0xff616973, 0xff626a75, 0xff616974, 0xff5f656f,
    0xff5a6069, 0xff545a63, 0xff505761, 0xff535a67, 0xff5c6272, 0xff646a7b, 0xff686e7f, 0xff697081,
    0xff676f81, 0xff636b80, 0xff60677e, 0xff5b637c, 0xff545e7a, 0xff4d5b7a, 0xff4d5d7e, 0xff536285,
    0xff576688, 0xff556585, 0xff536281, 0xff536180, 0xff566181, 0xff5a6483, 0xff5f6885, 0xff6a718d,
    0xff757b98, 0xff81839c, 0xff8b8695, 0xff94888d, 0xffa08f8c, 0xffb09889, 0xffc7a380, 0xffddaa75,
    0xffe1a769, 0xffd19b63, 0xffc39261, 0xffc39465, 0xffc99b6a, 0xffd1a36e, 0xffd8a971, 0xffdbab71,
    0xffdca96f, 0xffdda86e, 0xffdeaa6e, 0xffe1ad6f, 0xffe4b071, 0xffe6b172, 0xffe6b172, 0xffe5b072,
    0xffe5b072, 0xffe7b273, 0xffebb575, 0xfff0b877, 0xfff5bb77, 0xfffabe73, 0xfff4b86e, 0xffe2a96b,
    0xffc99567, 0xffb38562, 0xffa07a5c, 0xff896b55, 0xff78604f, 0xff6a5549, 0xff614d43, 0xff5b463b,
    0xff4e392d, 0xff442f23, 0xff423023, 0xff47382b, 0xff4e3f34, 0xff55453b, 0xff58473f, 0xff57463e,
    0xff57463e, 0xff5c4b44, 0xff615049, 0xff62524b, 0xff605048, 0xff5c4c44, 0xff594941, 0xff56463e,
    0xff53433b, 0xff4e3f37, 0xff463830, 0xff41332c, 0xff45362f, 0xff4d3d37, 0xff52433d, 0xff51443e,
    0xff534640, 0xff5b4943, 0xff634c44, 0xff664c41, 0xff6b4e3f, 0xff795745, 0xff87614e, 0xff83604e,
    0xff6e5445, 0xff58453a, 0xff483a31, 0xff43362f, 0xff473a35, 0xff4e403b, 0xff4d4039, 0xff483b32,
    0xff46382e, 0xff49392f, 0xff4c3b31, 0xff4d3e35, 0xff4d4038, 0xff4e413a, 0xff4f413b, 0xff50423b,
    0xff50433a, 0xff4e4037, 0xff4b3c33, 0xff493a32, 0xff493c35, 0xff493e38, 0xff473d39, 0xff463b38,
    0xff473b38, 0xff493d38, 0xff483d38, 0xff453c37, 0xff453b37, 0xff483d38, 0xff4a3d37, 0xff443a33,
    0xff3e362f, 0xff3d3630, 0xff403833, 0xff413935, 0xff24484e, 0xff24484e, 0xff284b4f, 0xff2a4c4f,
    0xff28494e, 0xff26464d, 0xff29494f, 0xff2d4e53, 0xff2f5051, 0xff2d4c4c, 0xff2c4b4c, 0xff315156,
    0xff36565d, 0xff39585c, 0xff3b5758, 0xff3b5756, 0xff3a5655, 0xff3c5654, 0xff3f5752, 0xff445a54,
    0xff4a605b, 0xff4d635f, 0xff4a5f5a, 0xff475a54, 0xff4a5b55, 0xff4f605b, 0xff52615d, 0xff515f59,
    0xff4f5d58, 0xff4d5d5d, 0xff4a5b62, 0xff445664, 0xff405265, 0xff3d4f65, 0xff3e4f66, 0xff405166,
    0xff425268, 0xff46566a, 0xff4b5a6d, 0xff4f5d6e, 0xff525d6b, 0xff555e68, 0xff5a616a, 0xff5f666f,
    0xff636a73, 0xff646b75, 0xff636a74, 0xff60656d, 0xff5a5f66, 0xff525860, 0xff4d555f, 0xff515866,
    0xff5c6171, 0xff656a7b, 0xff6b7080, 0xff6c7383, 0xff6a7184, 0xff656d82, 0xff616880, 0xff5b627d,
    0xff535c79, 0xff4b5977, 0xff4b5b7b, 0xff536384, 0xff586789, 0xff556484, 0xff52607e, 0xff515e7d,
    0xff535e7e, 0xff57617f, 0xff5e6781, 0xff6b728a, 0xff787d97, 0xff85869d, 0xff8f8894, 0xff988a8a,
    0xffa69389, 0xffb89d87, 0xffd3a87c, 0xffeaaf6c, 0xffe9a85d, 0xffd29655, 0xffbf8b55, 0xffc19160,
    0xffca9d6c, 0xffd3a671, 0xffdcae73, 0xffe0af73, 0xffdfac70, 0xffdfab6e, 0xffe0ac6e, 0xffe1ad6f,
    0xffe4b071, 0xffe6b172, 0xffe6b172, 0xffe5b072, 0xffe5b072, 0xffe6b073, 0xffe9b274, 0xffedb676,
    0xfff3bb76, 0xfffdc072, 0xfffbbd6f, 0xffedb16e, 0xffd69f6c, 0xffc08f67, 0xffac8261, 0xff927159,
    0xff7d6352, 0xff6c574b, 0xff624d43, 0xff5b453a, 0xff4d372b, 0xff422d20, 0xff413023, 0xff493a2e,
    0xff504238, 0xff56443b, 0xff58453d, 0xff56453d, 0xff56463e, 0xff5c4c45, 0xff62514a, 0xff64534b,
    0xff625148, 0xff5e4d44, 0xff5a4940, 0xff57463d, 0xff55443c, 0xff504038, 0xff47382f, 0xff3f3129,
    0xff42342d, 0xff4b3d38, 0xff4e413e, 0xff49413f, 0xff47403e, 0xff4d403f, 0xff55413e, 0xff5a433b,
    0xff62483a, 0xff745442, 0xff86604d, 0xff85614e, 0xff715546, 0xff5a483c, 0xff4a3c33, 0xff443831,
    0xff463b37, 0xff4b403d, 0xff473c38, 0xff3f352e, 0xff3e332a, 0xff45362d, 0xff493930, 0xff463931,
    0xff423932, 0xff453a35, 0xff493d38, 0xff4d4039, 0xff4f4239, 0xff4e4136, 0xff4a3c32, 0xff483931,
    0xff483c35, 0xff493f39, 0xff473d39, 0xff453a38, 0xff463b38, 0xff493d38, 0xff483d38, 0xff443b36,
    0xff443a36, 0xff483c38, 0xff4a3d38, 0xff443a33, 0xff3c362e, 0xff3a342f, 0xff3c3632, 0xff3d3634,
};

static uint32_t _gStretchBmp4[]=
{
    0xff7c91c0, 0xff7f94c3, 0xff8193c4, 0xff8397c6, 0xff8797c5, 0xff8a9bc7, 0xff8a9bca, 0xff8d9ecc,
    0xff919ecc, 0xff93a1cd, 0xff97a3ce, 0xff9aa7d2, 0xff9ba7d2, 0xff9ea9d4, 0xffa0acd6, 0xffa1add6,
    0xffa1b0d6, 0xffa3b2d7, 0xffa5b4d6, 0xffa9b4d6, 0xffaab6d6, 0xffacb6d6, 0xffaeb7d6, 0xffaeb6d7,
    0xffafb7d7, 0xffadb5d7, 0xffa9b1d6, 0xffa7b0d4, 0xffa5afd6, 0xffa4afd3, 0xffa2add5, 0xffa0add3,
    0xffa0abd4, 0xff9eabd3, 0xff9ca8d3, 0xff9aaad3, 0xff9baad3, 0xff98aad3, 0xff96a8d3, 0xff95a7d4,
    0xff93a5d7, 0xff889bd4, 0xff7f95d6, 0xff7c8fd4, 0xff768fd2, 0xff708bd1, 0xff6b8ad1, 0xff6384d1,
    0xff5d84d0, 0xff5b80d0, 0xff5a80d2, 0xff5b80d3, 0xff597ecd, 0xff5b7fca, 0xff587cca, 0xff5377c8,
    0xff5075c6, 0xff4f74c5, 0xff4e73c4, 0xff4b70c2, 0xff7e93c1, 0xff8094c4, 0xff8295c4, 0xff8596c4,
    0xff8798c7, 0xff8a9bc9, 0xff8b9cca, 0xff8e9ecb, 0xff93a0cf, 0xff95a2d1, 0xff96a3d2, 0xff99a6d3,
    0xff9caad4, 0xffa0aed4, 0xffa2b1d4, 0xffa5b3d4, 0xffa6b5d4, 0xffaab5d4, 0xffadb5d3, 0xffaeb3d3,
    0xffb1b5d6, 0xffb0b4d4, 0xffafb4d4, 0xffb2b2d4, 0xffb0b1d4, 0xffafb0d6, 0xffa7abd2, 0xffa6aad2,
    0xffa4a8d0, 0xffa5a7d3, 0xffa2a6d0, 0xffa2a3d1, 0xff9fa6d1, 0xffa1a4d0, 0xff9fa5d0, 0xffa0a5ce,
    0xff9ea5cf, 0xff9fa7cf, 0xff9da8cf, 0xff9ea9d0, 0xff9babd0, 0xff94a5d1, 0xff879fd1, 0xff7697d4,
    0xff6f8fd5, 0xff6b8dd5, 0xff6484d6, 0xff6283d4, 0xff6685d1, 0xff6384ce, 0xff6285cb, 0xff6182cc,
    0xff5c80cd, 0xff5d7ecc, 0xff5a7fc9, 0xff567bca, 0xff5479c9, 0xff5378c6, 0xff4f74c3, 0xff4d72bf,
    0xff8194c2, 0xff8395c3, 0xff8597c5, 0xff8596c4, 0xff8598c6, 0xff8799c7, 0xff8a9acc, 0xff8e9dce,
    0xff919fcf, 0xff94a2cf, 0xff99a7d4, 0xff9daccf, 0xffa1b1d3, 0xffa3b2d0, 0xffa8b3d0, 0xffacb2d0,
    0xffacb3d0, 0xffaeb1d2, 0xffabafd1, 0xffadb1d2, 0xffadafd1, 0xffadb0d2, 0xffacb0d5, 0xffacafd3,
    0xffa9afd4, 0xffa7abd3, 0xffa6a9d4, 0xffa1a6d3, 0xffa2a7d3, 0xff9fa4d1, 0xff9ea4d2, 0xff9ba3d1,
    0xff9ba2d0, 0xff98a0d1, 0xff999fcf, 0xff999fd0, 0xff979ecc, 0xff9b9ece, 0xff9ca1cf, 0xff9da2ce,
    0xff9aa0d1, 0xff97a2ce, 0xff92a1d0, 0xff829acf, 0xff7395d1, 0xff7094d4, 0xff688ed6, 0xff6488d4,
    0xff6686d3, 0xff6885cf, 0xff6a84cd, 0xff6985cc, 0xff6483ca, 0xff6282c9, 0xff5b7fcc, 0xff587cca,
    0xff557aca, 0xff547ac7, 0xff5377c5, 0xff5074c1, 0xff8496c4, 0xff8698c6, 0xff8797c5, 0xff8697c5,
    0xff879ac8, 0xff8798c9, 0xff889bcb, 0xff8c9ece, 0xff90a3d0, 0xff96a8cf, 0xff9faece, 0xffa4b0ce,
    0xffa6afcf, 0xffaab0cf, 0xffaaafce, 0xffaaaed0, 0xffaaadd1, 0xffa9afd0, 0xffa7acd1, 0xffa8aed1,
    0xffa8aed3, 0xffa8aed5, 0xffa9aed4, 0xffa7acd4, 0xffa7aed4, 0xffa3abd1, 0xffa1a9d4, 0xffa0a8d3,
    0xffa0a7d4, 0xff9ea7d2, 0xff9ba3d2, 0xff99a4d0, 0xff96a1d1, 0xff959fd1, 0xff939cce, 0xff919dce,
    0xff9099cc, 0xff939ccd, 0xff919bcd, 0xff919ad0, 0xff9198cc, 0xff8f96ce, 0xff8c96cc, 0xff8794d0,
    0xff8595ce, 0xff8095cd, 0xff7895cf, 0xff7393cf, 0xff7290cf, 0xff6a8bce, 0xff6985cc, 0xff6884ce,
    0xff6684cb, 0xff6383cb, 0xff6283c9, 0xff597fcd, 0xff597dcb, 0xff557bc6, 0xff5478c4, 0xff5275c2,
    0xff8598c4, 0xff8898c5, 0xff879ac9, 0xff889ac8, 0xff899acb, 0xff899cca, 0xff8e9ecc, 0xff8fa4ce,
    0xff9aa8cb, 0xff9eaacc, 0xffa3abcb, 0xffa6abce, 0xffa7abcc, 0xffa6aacf, 0xffa6abcc, 0xffa5aad1,
    0xffa6acd0, 0xffa5acd1, 0xffa6add2, 0xffa4aed2, 0xffa7add3, 0xffa6afd3, 0xffa6aed4, 0xffa5aed2,
    0xffa4acd4, 0xffa4acd2, 0xffa3a9d3, 0xffa1a9d1, 0xffa0a8d3, 0xffa0a9d3, 0xff9ea7d1, 0xff99a4d2,
    0xff98a4d1, 0xff95a3d2, 0xff949fd0, 0xff919ecd, 0xff8f9ccd, 0xff8f9acd, 0xff8e9acf, 0xff8a97cd,
    0xff8595ce, 0xff8391ce, 0xff8491ce, 0xff8190cb, 0xff8490cb, 0xff8591cd, 0xff8091cb, 0xff7f92cb,
    0xff7e95c9, 0xff7b93cb, 0xff708fcc, 0xff698bcf, 0xff6083ce, 0xff5f82d1, 0xff5e81cf, 0xff5c80cd,
    0xff5a7ecb, 0xff587bc7, 0xff567bc7, 0xff5479c1, 0xff8698c5, 0xff8999c9, 0xff8a9cc9, 0xff899cc9,
    0xff8b9fc9, 0xff91a3c8, 0xff93a3c8, 0xff9aa7c8, 0xff9ea6ca, 0xff9da4ca, 0xff9da4cb, 0xff9ea5cb,
    0xffa0a5cb, 0xffa1a6cd, 0xffa1a9cd, 0xffa1aacf, 0xffa2acd0, 0xffa3acd1, 0xffa3add0, 0xffa6aed3,
    0xffa5add2, 0xffa6aed3, 0xffa6aed3, 0xffa6aed3, 0xffa4add2, 0xffa4add2, 0xffa4acd2, 0xffa3acd2,
    0xffa2abd2, 0xffa0a8d0, 0xff9ea8d2, 0xff9aa8d0, 0xff99a6cf, 0xff98a4d0, 0xff95a3d0, 0xff94a0cf,
    0xff919dcc, 0xff8f9bd0, 0xff899acd, 0xff8897d0, 0xff8394cf, 0xff8192ce, 0xff8191cc, 0xff8191cb,
    0xff778ccd, 0xff7a8bcc, 0xff7c8dcb, 0xff7f8eca, 0xff8190c9, 0xff8293ca, 0xff7a93c8, 0xff6f8fcd,
    0xff628bce, 0xff5b83d3, 0xff5e81d2, 0xff5c7fcf, 0xff5b7fca, 0xff587fc9, 0xff567cc7, 0xff567ac6,
    0xff8799c7, 0xff8b9dca, 0xff8ea2ca, 0xff91a3c7, 0xff92a3c8, 0xff95a3c8, 0xff99a3c7, 0xff9ba2c9,
    0xff99a1c9, 0xff9aa1cb, 0xff97a0cc, 0xff9aa3ca, 0xff9ea6cd, 0xff9da7cd, 0xff9fa6cb, 0xffa0a7ce,
    0xffa1a9ce, 0xffa0aace, 0xffa3abd0, 0xffa5add2, 0xffa5add2, 0xffa5add2, 0xffa6aed3, 0xffa5add2,
    0xffa6aed3, 0xffa4acd1, 0xffa5add2, 0xffa4abd2, 0xffa4abd2, 0xff9fa9d0, 0xff9fa8d1, 0xff9da7d2,
    0xff9ca6d1, 0xff99a4d1, 0xff98a3cf, 0xff95a1d0, 0xff939ecf, 0xff8f9cd1, 0xff8c9bce, 0xff8797cf,
    0xff8495d0, 0xff8596ce, 0xff7f91cc, 0xff7c90ca, 0xff778ccc, 0xff778ace, 0xff788ccc, 0xff798bc9,
    0xff7b8bc8, 0xff7b8bc8, 0xff778ac9, 0xff728cc9, 0xff688ace, 0xff6089ce, 0xff6087cd, 0xff5c81ce,
    0xff597dca, 0xff597dcb, 0xff587cc7, 0xff577bc7, 0xff8b9fcb, 0xff90a4c9, 0xff94a6c5, 0xff97a4c7,
    0xff96a2c6, 0xff989ec7, 0xff969dc8, 0xff979fc9, 0xff959fcb, 0xff93a1cc, 0xff94a1cd, 0xff98a3cd,
    0xff97a4cf, 0xff99a4cb, 0xff9ca6cd, 0xff9ba9cd, 0xff9fa9ce, 0xffa0aace, 0xffa3aad0, 0xffa3acd1,
    0xffa5add2, 0xffa7afd4, 0xffa6aed3, 0xffa4acd1, 0xffa5add2, 0xffa4acd1, 0xffa3abd0, 0xffa3abd0,
    0xffa3abd2, 0xffa1a8d1, 0xffa0a9d3, 0xff9da7d2, 0xff9ea6d1, 0xff98a6ce, 0xff99a4d0, 0xff96a2cf,
    0xff94a0d0, 0xff909cd1, 0xff8c9bd1, 0xff899ace, 0xff8798cd, 0xff8496cb, 0xff8193cc, 0xff7e92cb,
    0xff7b90c9, 0xff788ecb, 0xff768ccc, 0xff728acc, 0xff7288c8, 0xff7587c7, 0xff6e83ce, 0xff6d84c9,
    0xff6c87cb, 0xff6c89c9, 0xff688ac9, 0xff5d86c9, 0xff5b80cb, 0xff597cc8, 0xff577ccb, 0xff5a7cc6,
    0xff90a5c6, 0xff98a5c6, 0xff97a5c7, 0xff96a3c6, 0xff93a0c6, 0xff909cc6, 0xff8f9cc6, 0xff909cc8,
    0xff919ecc, 0xff92a0cc, 0xff93a0cc, 0xff95a1ce, 0xff95a2ce, 0xff97a5ce, 0xff97a3cc, 0xff9aa6cc,
    0xff9ea7cb, 0xffa0a9cd, 0xffa1a8ce, 0xffa3abd0, 0xffa3abd0, 0xffa3abd0, 0xffa2aacf, 0xffa4acd1,
    0xffa3abd2, 0xffa3abd0, 0xffa3abd1, 0xffa1a9d0, 0xffa1aad0, 0xffa0a7d0, 0xff9fa8d1, 0xff9ea7d2,
    0xff9ba7d1, 0xff9ba6d1, 0xff98a5cf, 0xff95a1cf, 0xff94a0d0, 0xff929fd1, 0xff8d9bd1, 0xff8c9ccf,
    0xff8999cd, 0xff8797cb, 0xff8596cb, 0xff8292ca, 0xff7e91ca, 0xff7a8fc7, 0xff758bca, 0xff7089c9,
    0xff7089c6, 0xff6f85c9, 0xff6d85c6, 0xff6c82c7, 0xff6e83c7, 0xff6f85c6, 0xff6d84c2, 0xff6787c2,
    0xff6185c5, 0xff5980c6, 0xff577cc7, 0xff597bc9, 0xff94a1c5, 0xff95a2c6, 0xff95a0c7, 0xff949fc6,
    0xff919dc7, 0xff8f9cc8, 0xff8f9dc9, 0xff8f9cc9, 0xff909ecb, 0xff929fcc, 0xff94a1cc, 0xff93a0cd,
    0xff95a2cd, 0xff94a1cd, 0xff97a2cf, 0xff98a5ce, 0xff9da6cc, 0xff9ea8cb, 0xffa0a8cd, 0xffa1a9ce,
    0xffa0aacd, 0xffa1a9ce, 0xffa2abce, 0xffa1a9d0, 0xffa3abd2, 0xffa1a9d2, 0xffa0a9d1, 0xffa1a9d1,
    0xffa0a8d0, 0xff9ea8d3, 0xffa0a7d4, 0xff9ea8d3, 0xff9ea7d2, 0xff9da5d0, 0xff99a5cf, 0xff97a3d0,
    0xff96a3d2, 0xff949fd0, 0xff909dd0, 0xff8f99d0, 0xff8c99cc, 0xff8b96cc, 0xff8695c9, 0xff8494ca,
    0xff8192c7, 0xff7c8fca, 0xff778bc7, 0xff7289c9, 0xff7087c7, 0xff6d85c8, 0xff6c83c7, 0xff6c82c6,
    0xff6a82c6, 0xff6a7fc4, 0xff6c80c0, 0xff6d82be, 0xff6c82bc, 0xff6182bf, 0xff5d7fc2, 0xff587bc2,
    0xff909dc4, 0xff929ec5, 0xff909dc5, 0xff92a0c6, 0xff919dc8, 0xff909dc9, 0xff909dc9, 0xff8e9bc9,
    0xff919ecb, 0xff919ecb, 0xff93a0cd, 0xff94a1cd, 0xff93a1cc, 0xff94a1cc, 0xff94a1ce, 0xff95a2c9,
    0xff99a3cc, 0xff9ba5cb, 0xff9da7cc, 0xff9fa8cd, 0xffa0a7cc, 0xffa0a9ce, 0xffa0a7cf, 0xffa1aacf,
    0xffa1a9d0, 0xff9fa6cf, 0xff9ea5d0, 0xff9ea5d0, 0xff9ea6d0, 0xff9ea6d0, 0xff9fa8d0, 0xff9fa8cf,
    0xff9ea6d2, 0xff9da4d1, 0xff9aa4d0, 0xff9aa2d1, 0xff96a1cf, 0xff95a0cd, 0xff919dd0, 0xff909ccf,
    0xff8e9bcf, 0xff8a97cc, 0xff8a96cb, 0xff8494c8, 0xff8292c6, 0xff7d8fc9, 0xff798ec7, 0xff768ac4,
    0xff7389c4, 0xff6f87c4, 0xff6c83c5, 0xff6a83c4, 0xff6980c1, 0xff697ec0, 0xff677dbc, 0xff697cb8,
    0xff6a7eb7, 0xff677eb7, 0xff627eb8, 0xff5c7cb9, 0xff8a97c3, 0xff8d9ac6, 0xff8f9cc7, 0xff8f9cc9,
    0xff939fcb, 0xff919eca, 0xff919eca, 0xff909dc9, 0xff909ecb, 0xff929fcb, 0xff93a0cd, 0xff94a1cd,
    0xff93a1cf, 0xff95a1cd, 0xff94a1cc, 0xff94a1cb, 0xff96a5cb, 0xff9ba5cb, 0xff9da6cc, 0xff9fa6cb,
    0xff9ea8ce, 0xff9fa7cf, 0xff9ea8cd, 0xff9fa7ce, 0xff9ea7cd, 0xff9ea7cf, 0xff9da4ce, 0xff9ca6cd,
    0xff9da5ce, 0xff9ea7ce, 0xff9ea5cf, 0xff9fa6ce, 0xff9ea6d0, 0xff9ea7d0, 0xff9ba5cf, 0xff9ca3cf,
    0xff96a3ce, 0xff949ed0, 0xff929ece, 0xff909dcc, 0xff8e9acc, 0xff8c98cc, 0xff8b97ca, 0xff8995ca,
    0xff8391c7, 0xff7f91c6, 0xff7c8cc8, 0xff778cc4, 0xff7588c4, 0xff6f87c2, 0xff6c84c1, 0xff6b83c0,
    0xff6880bf, 0xff667ebd, 0xff647dbd, 0xff647aba, 0xff657ab6, 0xff6479b6, 0xff647ab3, 0xff617ab2,
    0xff8493c3, 0xff8897c3, 0xff8a9ac7, 0xff8d9bc7, 0xff8f9dc7, 0xff8f9bc8, 0xff909dc8, 0xff909dcb,
    0xff919ecc, 0xff919dcc, 0xff94a0cd, 0xff93a0cc, 0xff93a0cb, 0xff95a2ce, 0xff94a1cf, 0xff94a3ce,
    0xff99a4cd, 0xff96a4cb, 0xff9ba3cd, 0xff9ba4cc, 0xff9da5ce, 0xffa0a6ce, 0xffa0a6ce, 0xffa5a4cc,
    0xffaaa4cc, 0xffaea5ca, 0xffb9a7c9, 0xffbea7c6, 0xffc6a9c7, 0xffc6aac7, 0xffc5a8c8, 0xffc4a8c7,
    0xffbba7cb, 0xffb7a7ca, 0xffaba5cd, 0xffa5a5cc, 0xff9ea2cf, 0xff98a0cf, 0xff959fce, 0xff909cce,
    0xff919fcd, 0xff8d99c9, 0xff8c98ca, 0xff8896ca, 0xff8293c6, 0xff8291c5, 0xff798dc8, 0xff788dc6,
    0xff758ac3, 0xff7288c1, 0xff6d82c1, 0xff6b83c0, 0xff6780bd, 0xff6480bd, 0xff607dbd, 0xff627ab9,
    0xff6079b7, 0xff5f79b4, 0xff6176b0, 0xff6075ae, 0xff8395c2, 0xff8395c5, 0xff8397c2, 0xff8596c3,
    0xff8a9ac6, 0xff8c9bc7, 0xff8b9bc7, 0xff8f9cc9, 0xff8f9cc9, 0xff909ecb, 0xff929fca, 0xff929fcc,
    0xff94a1cd, 0xff94a2ce, 0xff94a1cb, 0xff96a3ce, 0xff99a2cc, 0xff9aa3ca, 0xff9da1ca, 0xffa1a3ca,
    0xffb2a6c9, 0xffc5aac4, 0xffd9b1c2, 0xffe8bcbe, 0xffefc6bf, 0xfff9d1c0, 0xfffcdec1, 0xffffe6c4,
    0xfffeebc5, 0xffffecc8, 0xffffedc4, 0xffffedc5, 0xffffe6c0, 0xffffddbd, 0xfffecdbc, 0xfff5bebd,
    0xffe0b1c0, 0xffc5a5c5, 0xffaca2c9, 0xff9f9ecb, 0xff949cca, 0xff8d99cc, 0xff8a98c7, 0xff8696c8,
    0xff8392c6, 0xff8090c4, 0xff7b8cc6, 0xff788ac3, 0xff758ac3, 0xff7186bf, 0xff6d85c0, 0xff6b84bb,
    0xff667fbd, 0xff637fbb, 0xff607cbc, 0xff5e7cb8, 0xff5f78b5, 0xff5e78b4, 0xff5e74af, 0xff5d73ac,
    0xff9aa6ca, 0xff8497c3, 0xff8394c3, 0xff8798c5, 0xff8899c3, 0xff889ac5, 0xff8c99c6, 0xff8c9ac7,
    0xff8f9bc8, 0xff919eca, 0xff909cca, 0xff929fca, 0xff919fcc, 0xff93a1ca, 0xff97a0cb, 0xff99a0c9,
    0xffa1a4c9, 0xffb3a7c6, 0xffc9aec0, 0xffecbdbb, 0xfff7d3be, 0xffefe3c7, 0xffd7e8d4, 0xffc3dfe0,
    0xffb6d5ea, 0xffaeccf3, 0xffaec8f8, 0xffb0c5fb, 0xffb0c4fc, 0xffb2c4fc, 0xffb3c8fe, 0xffb8ceff,
    0xffbddafe, 0xffc4e3fb, 0xffd6f8f0, 0xffe9ffe3, 0xfffdffd0, 0xfffff0c3, 0xffffd0b7, 0xffe9b7bc,
    0xffc5a2bf, 0xffa39bc3, 0xff9698c7, 0xff8793c6, 0xff8493c6, 0xff7e92c3, 0xff7b8cc1, 0xff7889bf,
    0xff7489bd, 0xff7186bd, 0xff6c82bc, 0xff6a82ba, 0xff657ebb, 0xff637cb8, 0xff5f7cb9, 0xff5d7ab7,
    0xff5b78b5, 0xff5a76b3, 0xff5b73ad, 0xff5970a9, 0xff97a4c8, 0xff869bc5, 0xff8191c0, 0xff8396c4,
    0xff8797c4, 0xff8899c5, 0xff8697c7, 0xff8a9ac6, 0xff8d9ac8, 0xff8d9bc9, 0xff8e9bcb, 0xff8e9dca,
    0xff919ecc, 0xff969ecb, 0xffa5a3c9, 0xffbaa9c6, 0xffe0bbc1, 0xfff1d1c1, 0xffe3e3cd, 0xffc1e2e1,
    0xffaacbef, 0xffa8bbf0, 0xffaab1ea, 0xffafb3e7, 0xffb3b8e1, 0xffbabee1, 0xffbdc1df, 0xffbdc4df,
    0xffc1c6de, 0xffc0c8dd, 0xffc7cbe4, 0xffcecfe7, 0xffcfcee8, 0xffd0cbee, 0xffcec5f2, 0xffc4c3fa,
    0xffb8c5ff, 0xffb7d5ff, 0xffccedf2, 0xffeefdda, 0xffffeabf, 0xfff5c3b6, 0xffd2aaba, 0xffa497c3,
    0xff8f90c0, 0xff848dc0, 0xff798abe, 0xff7788bd, 0xff7287bb, 0xff7085bf, 0xff6d81bb, 0xff6880ba,
    0xff647fb5, 0xff627ab4, 0xff5d7bb2, 0xff5c79b6, 0xff5a77b3, 0xff5b74b3, 0xff5773aa, 0xff576fa7,
    0xff899ac5, 0xff7e94c1, 0xff7b93c2, 0xff8394c1, 0xff8396c2, 0xff8394c2, 0xff8495c3, 0xff8798c6,
    0xff8896c5, 0xff8b9ac5, 0xff8c9bc7, 0xff929cc7, 0xff9f9ec7, 0xffbaa7c3, 0xffd7bec2, 0xffe5d6c6,
    0xffcce2db, 0xffa7c9ed, 0xffa2b5f1, 0xffadb3ea, 0xffb0b5de, 0xffadb7d8, 0xffacb3d6, 0xffacb6d6,
    0xffb1b5d9, 0xffb4bada, 0xffb9bddc, 0xffbabfdd, 0xffbdbfe0, 0xffbfc4de, 0xffc3c5e0, 0xffc4c7e2,
    0xffc7c8e3, 0xffc7c8e4, 0xffc9cce5, 0xffcbcde2, 0xffcbcfe2, 0xffcdc9e6, 0xffc0bfec, 0xffb1bafa,
    0xffa9cbff, 0xffcdebe8, 0xfff2ecc9, 0xfff8c8b3, 0xffc9a6b6, 0xffa192bc, 0xff8286b9, 0xff7586bb,
    0xff7386b9, 0xff6d83bc, 0xff6a81b9, 0xff677eb7, 0xff637db6, 0xff617ab3, 0xff5e78b1, 0xff5b77b3,
    0xff5976b0, 0xff5773b0, 0xff5371aa, 0xff526fa7, 0xffa1abcb, 0xff7991c0, 0xff7a8fc0, 0xff7c91c2,
    0xff8493c3, 0xff8596c3, 0xff8295c3, 0xff8293c1, 0xff8997c4, 0xff8996c4, 0xff989ac4, 0xffafa4c2,
    0xffcfb8c1, 0xffddd8c7, 0xffbed6db, 0xffa3bdec, 0xffa3b0e8, 0xffaab3de, 0xffaab5d7, 0xffabb2d5,
    0xffaab2d6, 0xffa7afd5, 0xffa7afd4, 0xffa9b1d4, 0xffacb4d5, 0xffb3b8d9, 0xffb6bbdb, 0xffb8bcdc,
    0xffbabedb, 0xffbcc0df, 0xffbdc1dd, 0xffbfc3df, 0xffc1c5df, 0xffc2c5e0, 0xffc1c3de, 0xffc0c4e0,
    0xffbfc3df, 0xffbcc0de, 0xffbcbfdd, 0xffbfc1db, 0xffbebfde, 0xffb2b3ec, 0xffa0b6f5, 0xffb5d8e8,
    0xffe6e4c7, 0xffe9bfb2, 0xffbb9ab2, 0xff8e83b5, 0xff7783b7, 0xff6c80b6, 0xff687fb7, 0xff667bb5,
    0xff6379b1, 0xff5f78b0, 0xff5c77ae, 0xff5c75ac, 0xff5772ab, 0xff5570a9, 0xff516fa7, 0xff506da3,
    0xff9ba8c9, 0xff6d86bb, 0xff788ec0, 0xff798fc1, 0xff7d90c0, 0xff8091c1, 0xff8294c2, 0xff8593c2,
    0xff8a93c1, 0xffa19bc0, 0xffc7b1bf, 0xffd5cac4, 0xffbcd4d5, 0xff9cb6e6, 0xff9fabe3, 0xffa8b0d4,
    0xffa8b2d2, 0xffa8b2d5, 0xffa7afd3, 0xffa3aed2, 0xffa5afd3, 0xffa3acd0, 0xffa3add1, 0xffa5add1,
    0xffaab1d5, 0xffafb5d6, 0xffb4b9d9, 0xffb6b9db, 0xffb8bbd9, 0xffbabcdb, 0xffbbbedb, 0xffbabfdb,
    0xffbbbedc, 0xffbbbfda, 0xffbbbfdb, 0xffbabddb, 0xffb9bbdd, 0xffb6b9d8, 0xffb4b8d8, 0xffb3b8d9,
    0xffb4b7d5, 0xffb0b6d4, 0xffb0b6d3, 0xffa7a9e0, 0xff96abef, 0xffafd3df, 0xffe4dcbd, 0xffcfacad,
    0xffa18bae, 0xff737ab0, 0xff667db3, 0xff647ab2, 0xff5f78af, 0xff5d75ad, 0xff5b76ad, 0xff5773aa,
    0xff5472aa, 0xff556fa7, 0xff4f6fa8, 0xff4f6da3, 0xff7b90c1, 0xff6e8ac0, 0xff768dbe, 0xff768cbf,
    0xff768ec0, 0xff778cc0, 0xff7d8dc1, 0xff8d90bc, 0xffad9fc1, 0xffc9b9bf, 0xffc3d4cf, 0xff9bbbe1,
    0xff9ca6e2, 0xff9fa9d4, 0xffa2aece, 0xffa4acd1, 0xffa0aed0, 0xff9eabce, 0xff9fabcf, 0xffa1adce,
    0xffa1aace, 0xffa1abd1, 0xffa0a8d0, 0xffa2aad0, 0xffa6add2, 0xffaab3d6, 0xffafb6d6, 0xffb3b8d7,
    0xffb4b9d9, 0xffb5bada, 0xffb5bbda, 0xffb5b9d7, 0xffb7bbd9, 0xffb7b9d9, 0xffb6bada, 0xffb4b9d8,
    0xffb1b6d6, 0xffb0b6d5, 0xffadb3d4, 0xffabb1d4, 0xffa8afd1, 0xffa6afd2, 0xffa5aecf, 0xffa4adcf,
    0xffa9afce, 0xff9da2dc, 0xff8daceb, 0xffb6d7ce, 0xffdac2b1, 0xffaf8ea7, 0xff7b7baa, 0xff637aae,
    0xff5d75ad, 0xff5b75ae, 0xff5974ab, 0xff5572ab, 0xff5371a7, 0xff536ea7, 0xff516ea7, 0xff4d6ba3,
    0xff6c88bb, 0xff6a87c2, 0xff748cbe, 0xff778dbf, 0xff7a8dbe, 0xff7b8bc1, 0xff918eba, 0xffb7a6bd,
    0xffcac7c2, 0xffaac9d9, 0xff91a7e4, 0xff9da8d8, 0xff9daccd, 0xff9daace, 0xff9ba9ce, 0xff9eaace,
    0xff9ba8cf, 0xff9ba6cf, 0xff9aa8d0, 0xff9ba6ce, 0xff9ba8d0, 0xff9ba7d0, 0xff9aa6d1, 0xffa2abcf,
    0xffa4acd2, 0xffa9b1d5, 0xffaab2d7, 0xffafb3d7, 0xffb0b7d7, 0xffb3b8d8, 0xffb2b7d7, 0xffb2b7d9,
    0xffb1b6d6, 0xffb2b7d6, 0xffb0b6d6, 0xffadb2d3, 0xffadb3d5, 0xffa6b0d5, 0xffa7aed3, 0xffa4acd0,
    0xffa3aad1, 0xffa2aacf, 0xffa0a8cd, 0xff9fa6cf, 0xff9da4cb, 0xff9ca4cd, 0xff9ea5cc, 0xff8e96dd,
    0xff8db7dc, 0xffc8cdb8, 0xffb295a6, 0xff7e78a6, 0xff5c72aa, 0xff5871ab, 0xff5771ab, 0xff5771a9,
    0xff5170a6, 0xff506da6, 0xff4f6ea3, 0xff4d6ba1, 0xff99a4c6, 0xff738dbc, 0xff6e8abf, 0xff788abd,
    0xff7e89bc, 0xffa094bc, 0xffc1b1bc, 0xffc6d0ca, 0xff97b8e0, 0xff98a2df, 0xff9ea8cf, 0xff9ba9cf,
    0xff99a6d2, 0xff98a5d2, 0xff97a5cf, 0xff9aa7d1, 0xff98a6cf, 0xff99a6d0, 0xff99a6d0, 0xff9aa6d2,
    0xff99a5cf, 0xff98a5cf, 0xff99a5cf, 0xffa0a9d0, 0xffa3abcf, 0xffa6add2, 0xffa6aed2, 0xffa8b1d3,
    0xffacb4d5, 0xffadb5d5, 0xffafb6d5, 0xffadb4d5, 0xffadb3d6, 0xffadb3d5, 0xffa9b1d3, 0xffa9b1d3,
    0xffa5aecf, 0xffa5acd2, 0xffa1aacf, 0xffa0a8cc, 0xff9fa8cd, 0xff9da5cd, 0xff9ca3cd, 0xff9aa1c9,
    0xff969eca, 0xff979ec8, 0xff949ec9, 0xff92a0c4, 0xff8f94cd, 0xff7496da, 0xffa2c1bd, 0xffb09aa6,
    0xff7d749d, 0xff5e71a5, 0xff576ea4, 0xff526ea5, 0xff516da5, 0xff516da7, 0xff4d6ba2, 0xff4b699f,
    0xffaab2cd, 0xff7a8fbd, 0xff7087ba, 0xff828abc, 0xffaa98b7, 0xffcebfbe, 0xffbed5d1, 0xff8cabe8,
    0xff99a1d9, 0xff9aaace, 0xff98a5d2, 0xff96a2cd, 0xff97a4cf, 0xff96a2ce, 0xff97a3d0, 0xff98a4d0,
    0xff97a4ce, 0xff96a2cf, 0xff97a4d0, 0xff96a3cf, 0xff96a3d0, 0xff96a3cf, 0xff98a5d0, 0xff9ea8d1,
    0xffa1aad1, 0xffa3acd2, 0xffa4abd0, 0xffa5acd2, 0xffa7afd4, 0xffa8b1d6, 0xffa8b1d4, 0xffa8b0d6,
    0xffa8afd4, 0xffa6afd3, 0xffa6add2, 0xffa2aacf, 0xffa2aad0, 0xff9fa8ce, 0xffa0a6ca, 0xff98a4cc,
    0xff96a1c9, 0xff96a0ca, 0xff939ec8, 0xff929cc8, 0xff909cc5, 0xff8e9bc4, 0xff8c98c4, 0xff8a98c2,
    0xff8693bf, 0xff8490c1, 0xff6d81ce, 0xff81aec1, 0xffb29fa4, 0xff7f759a, 0xff5e6fa3, 0xff506ca4,
    0xff526ea6, 0xff4e6ca4, 0xff4b6b9f, 0xff4b699f, 0xff95a2c4, 0xff647eb8, 0xff7083b9, 0xff8d85b1,
    0xffbbb9bc, 0xff9bc0d4, 0xff7e99e0, 0xff909ecd, 0xff8d9ecc, 0xff8b9cc9, 0xff8a9acb, 0xff8b9ccb,
    0xff8c9dcb, 0xff8f9fcd, 0xff8e9fcd, 0xff92a1cf, 0xff92a1cf, 0xff94a2d1, 0xff919fcf, 0xff92a0cf,
    0xff92a1d0, 0xff97a3ce, 0xff98a6d3, 0xff9ba7d2, 0xff9eaad3, 0xff9ca9d1, 0xff9fa8d1, 0xffa0a9d2,
    0xffa2abd1, 0xffa4acd1, 0xffa5acd3, 0xffa5abcf, 0xffa5add3, 0xffa2abd0, 0xff9fa8d2, 0xff9ca7d1,
    0xff9ba4cd, 0xff97a2cc, 0xff949fca, 0xff939fc9, 0xff919dc7, 0xff8f9bc6, 0xff8d9ac4, 0xff8e9bc3,
    0xff8c97c4, 0xff8a95c2, 0xff8895c1, 0xff8591c1, 0xff8490be, 0xff7989bb, 0xff7a8db8, 0xff707fc8,
    0xff71a4c3, 0xffa9a2a2, 0xff85779b, 0xff5d6b9e, 0xff4f6aa3, 0xff4e6aa0, 0xff4d68a0, 0xff48669c,
    0xff97a2c4, 0xff8e96bd, 0xff8986b3, 0xffc8c7c9, 0xff75a4cd, 0xff7389d2, 0xff8195c5, 0xff7d92c6,
    0xff7e92c6, 0xff7e92c4, 0xff7e93c5, 0xff8195c8, 0xff8497c9, 0xff8799ca, 0xff899bcd, 0xff8d9cce,
    0xff8d9ed0, 0xff8f9fcd, 0xff8fa0cd, 0xff8d9fcd, 0xff909fce, 0xff94a1d0, 0xff98a4d2, 0xff9ca9d3,
    0xff9ba7d3, 0xff9aa7d2, 0xff98a6d2, 0xff99a7d0, 0xff9ca6d1, 0xff9aa6d0, 0xff9ba6d2, 0xff9ca8d1,
    0xff9ea7d3, 0xff9ba3d2, 0xff98a4cf, 0xff98a1ce, 0xff94a0cb, 0xff919eca, 0xff8c99c8, 0xff8b98c4,
    0xff8b98c3, 0xff8e98c5, 0xff8d97c5, 0xff8b97c1, 0xff8896c2, 0xff8893c0, 0xff8795be, 0xff848ebd,
    0xff7c8cbb, 0xff7786ba, 0xff7485ba, 0xff7187b5, 0xff6a7bc3, 0xff6494c4, 0xffa2a3a3, 0xff88779a,
    0xff5b699a, 0xff4d689f, 0xff48669c, 0xff476396, 0xff9da4c0, 0xffb5abc3, 0xffb9c0c5, 0xffafc3dc,
    0xff909dd2, 0xff728cbf, 0xff758dc5, 0xff788ec1, 0xff798fc3, 0xff788fc8, 0xff7990c9, 0xff7f94c9,
    0xff7f95c9, 0xff8499ca, 0xff8798cb, 0xff899cce, 0xff8a9ccf, 0xff889bcd, 0xff8b9bcf, 0xff8d9ecf,
    0xff8e9ecf, 0xff91a1d0, 0xff98a4d2, 0xff99a6d2, 0xff97a4d1, 0xff95a2cf, 0xff94a0d0, 0xff95a1ce,
    0xff95a2cd, 0xff95a2cd, 0xff95a1cd, 0xff96a3cf, 0xff96a3ce, 0xff94a0cb, 0xff929ece, 0xff909dcc,
    0xff8e9aca, 0xff8b98c6, 0xff8895c4, 0xff8694c1, 0xff8794c2, 0xff8896c2, 0xff8995c1, 0xff8996c1,
    0xff8491bd, 0xff8592be, 0xff808cba, 0xff7c8aba, 0xff7688b6, 0xff7284b6, 0xff6d81b4, 0xff6d80b5,
    0xff6b82af, 0xff6d7cc0, 0xff6393c6, 0xffa2a2a3, 0xff7e7194, 0xff556695, 0xff486095, 0xff435e90,
    0xff9d99b9, 0xffb6bdc1, 0xff96b0d1, 0xff9ba4d2, 0xff97a7c8, 0xff6c88c4, 0xff728bc3, 0xff718ac4,
    0xff738ec6, 0xff778fc7, 0xff7890c8, 0xff7c90c8, 0xff8096cd, 0xff8499cf, 0xff869acd, 0xff889acd,
    0xff849acd, 0xff879acc, 0xff879acd, 0xff8a9acd, 0xff8e9fcf, 0xff91a0d0, 0xff94a3cf, 0xff939fcf,
    0xff939fd0, 0xff909ccc, 0xff919ece, 0xff8f9dcc, 0xff919dcc, 0xff909ecd, 0xff919ecd, 0xff929dcc,
    0xff939fcd, 0xff8f9ccc, 0xff8c9aca, 0xff8b98c9, 0xff8a97c8, 0xff8594c7, 0xff8593c5, 0xff8592c2,
    0xff8694c3, 0xff8895c1, 0xff8794c0, 0xff8491bf, 0xff8491bd, 0xff818dbb, 0xff7e8bba, 0xff7688b6,
    0xff7083b4, 0xff6c81b2, 0xff6b7fb2, 0xff677eb0, 0xff677caf, 0xff6a7fac, 0xff677aba, 0xff5d8ebf,
    0xff929899, 0xff766c8d, 0xff4e5f8d, 0xff425b8b, 0xffa1aab7, 0xff81a3c9, 0xff8b97c9, 0xff93a0c1,
    0xff9ba8cb, 0xff8597c4, 0xff708bc1, 0xff6884c0, 0xff718bc3, 0xff748dc5, 0xff768dc6, 0xff7c91ca,
    0xff7893cd, 0xff7f94cd, 0xff8199cb, 0xff8499ce, 0xff839ad0, 0xff849bd2, 0xff859bd3, 0xff8a9fd0,
    0xff8a9dd0, 0xff8fa0d1, 0xff909fcf, 0xff919fd0, 0xff8f9ecf, 0xff8d9bcf, 0xff8a9ccb, 0xff8c9acb,
    0xff8c9ccc, 0xff8b9ccb, 0xff8c9bcb, 0xff8c9bcc, 0xff8a99c9, 0xff8897c8, 0xff8796c9, 0xff8796c9,
    0xff8796c7, 0xff8694c7, 0xff8694c6, 0xff8a96c8, 0xff8b96c6, 0xff8c99c4, 0xff8b97c3, 0xff8a98c4,
    0xff8592bf, 0xff828fbc, 0xff7989b8, 0xff7687b3, 0xff7284b2, 0xff6d80b2, 0xff697eaf, 0xff667daa,
    0xff657baa, 0xff6479ac, 0xff637aa5, 0xff6174b5, 0xff5888b7, 0xff8c9295, 0xff6a6588, 0xff4a5e8c,
    0xff7498bd, 0xff7988bf, 0xff7e91b9, 0xff8092bd, 0xff97a4c8, 0xff9aa7c9, 0xffa9b1d1, 0xff97a6ce,
    0xff8195c8, 0xff6a88c1, 0xff7d93c9, 0xff6b8ac6, 0xff91a0d0, 0xff96a7d1, 0xff859bd2, 0xff829ad4,
    0xff8299d1, 0xff879dd5, 0xff899ed8, 0xff8ba0d8, 0xff8ca0d6, 0xff8ca0d5, 0xff8d9ed1, 0xff899dce,
    0xff8999cd, 0xff879acd, 0xff8b9bce, 0xff889bcc, 0xff889bd0, 0xff8b9ed0, 0xff899dd1, 0xff8ba0d6,
    0xff8ba2d8, 0xff8ba0d7, 0xff8c9ed3, 0xff90a0d4, 0xff8e9ed2, 0xff8b9ccf, 0xff8999cd, 0xff8898ca,
    0xff8c97c7, 0xff8897c6, 0xff8693c3, 0xff8492c0, 0xff828fbc, 0xff7c8bbb, 0xff7988b6, 0xff7284b2,
    0xff7082b1, 0xff667eaf, 0xff667cab, 0xff647aa7, 0xff6378a9, 0xff6177a6, 0xff6176a7, 0xff637ca7,
    0xff5f71b5, 0xff5b8ab4, 0xff918d90, 0xff636589, 0xff607cc0, 0xff6785b7, 0xff6a85b8, 0xff7b8fbc,
    0xff8897c1, 0xff93a1c5, 0xff9da7c8, 0xffb0b5d1, 0xffc1c4dc, 0xffb5bbd7, 0xffa7b1d6, 0xff9eabd2,
    0xffb3b9d6, 0xffb7bcd5, 0xff89a0d5, 0xff809dd5, 0xff819ed9, 0xff84a0d7, 0xff86a0d8, 0xff879fd7,
    0xff86a1d8, 0xff8aa3dd, 0xff89a8e3, 0xff89a4e0, 0xff87a6e3, 0xff87a2e1, 0xff86a4e1, 0xff86a4e2,
    0xff86a6e6, 0xff86aaec, 0xff87aaed, 0xff8fadea, 0xff90abe4, 0xff97aae0, 0xff95a8e0, 0xff8ea1d7,
    0xff8e9fd4, 0xff8b9bcf, 0xff889acb, 0xff8697c8, 0xff8897c5, 0xff8390c0, 0xff8291c0, 0xff7b8dba,
    0xff7889b8, 0xff7689b6, 0xff7385b5, 0xff7081af, 0xff6a80ae, 0xff667cac, 0xff647ba8, 0xff627aa6,
    0xff6078a3, 0xff6178a3, 0xff6177a2, 0xff6378a6, 0xff667da5, 0xff5d72b9, 0xff6c97b3, 0xff918997,
    0xff5e7fb2, 0xff607eb6, 0xff6282b7, 0xff6c86ba, 0xff7a8fbc, 0xff8192bd, 0xff8798c2, 0xff8495c0,
    0xff9aa5c8, 0xffb2b7d5, 0xffb6bad7, 0xffaab2d1, 0xffb3b9d7, 0xffb3b8d4, 0xff9facd4, 0xff7591cc,
    0xff819ad3, 0xff86a5e0, 0xff97ade7, 0xff8ea8e0, 0xff8daae8, 0xff82a5e5, 0xff84a7ec, 0xff82aff8,
    0xff83aff8, 0xff82b0f8, 0xff82b4fd, 0xff80affa, 0xff82b1fb, 0xff81aff9, 0xff8db0f3, 0xff89aded,
    0xff87acf0, 0xff89acef, 0xff8ba8e7, 0xff89a2de, 0xff899ed7, 0xff899dd3, 0xff8998cc, 0xff8696ca,
    0xff8394c5, 0xff8190bf, 0xff808ebd, 0xff7a8ab9, 0xff7688b5, 0xff7384b3, 0xff7082b1, 0xff6e7fac,
    0xff677cac, 0xff6478a9, 0xff6279a6, 0xff6178a4, 0xff5f76a2, 0xff5c73a0, 0xff697eac, 0xff687da8,
    0xff6a7dac, 0xff6c7ea6, 0xff5c7ac3, 0xff819ca9, 0xff5a7eb7, 0xff5c7db5, 0xff6282b7, 0xff6584b9,
    0xff6d88be, 0xff768fbf, 0xff758bc1, 0xff728abe, 0xff8895c0, 0xff9ba6c8, 0xffa7aecf, 0xff9daace,
    0xffabb1ce, 0xffa8b2d0, 0xff9ea9d0, 0xff6d89c4, 0xff7994cb, 0xff7a95ce, 0xff7992c9, 0xff809acf,
    0xff90a6dc, 0xff98b2ec, 0xff86a2dd, 0xff829cd8, 0xff809ddb, 0xff7e9fe3, 0xff81b2fa, 0xff84b6f9,
    0xff84b5fc, 0xff88b9f9, 0xff85b7fc, 0xff82a5ea, 0xff7fa3e6, 0xff89a6e5, 0xff8fadeb, 0xff88acee,
    0xff90a8df, 0xff859ad6, 0xff7f94c9, 0xff7e91c3, 0xff7b8dc1, 0xff7c8bbc, 0xff7789bb, 0xff7587b6,
    0xff7283b3, 0xff7182b2, 0xff6d80ad, 0xff657da9, 0xff6378a9, 0xff5d74a2, 0xff5d74a0, 0xff5b729e,
    0xff5d74a0, 0xff5d739f, 0xff6077a3, 0xff6579a7, 0xff6b7cac, 0xff6d80ac, 0xff6f7dae, 0xff6284bd,
    0xff587bb6, 0xff5b7eba, 0xff5c80bf, 0xff6082be, 0xff6283c4, 0xff6286c6, 0xff688bcd, 0xff7196d7,
    0xff76a0e2, 0xff7796d1, 0xff82a1d9, 0xff85a2e0, 0xff91a3d2, 0xff8f9dcb, 0xff8b9dcb, 0xff7594ce,
    0xff708fc9, 0xff7494cf, 0xff7b9ad7, 0xff7995d4, 0xff7593d0, 0xff7693cf, 0xff8aa7e2, 0xff7c9ad9,
    0xff7a9bde, 0xff7faef6, 0xff83b8fe, 0xff8ac0fe, 0xff8ac0fb, 0xff87bafb, 0xff85bafa, 0xff88bcfd,
    0xff85bcfc, 0xff86b1f9, 0xff8ba9e6, 0xff7d9cde, 0xff809dde, 0xff7e94cd, 0xff798ec7, 0xff738ac3,
    0xff758abf, 0xff798aba, 0xff7889bc, 0xff6f84b7, 0xff6c83b3, 0xff697fb1, 0xff687faf, 0xff677dae,
    0xff6379a9, 0xff5e74a4, 0xff5a719c, 0xff5a709c, 0xff5a709c, 0xff5d729f, 0xff5f73a2, 0xff657aa4,
    0xff6c7da9, 0xff6c7dad, 0xff6e7da7, 0xff677bb2, 0xff5678b8, 0xff5a7bbb, 0xff5d7ebe, 0xff5c7fbd,
    0xff6184bf, 0xff6588c2, 0xff5f87c8, 0xff638acc, 0xff6996dc, 0xff6fa4ee, 0xff77aaf5, 0xff79b1fa,
    0xff77acf3, 0xff7097d7, 0xff6e91d0, 0xff708fcf, 0xff7497d7, 0xff7899db, 0xff7799da, 0xff799cdd,
    0xff7ea2e3, 0xff7f9edc, 0xff8cabe7, 0xff89abec, 0xff79a5ed, 0xff7498de, 0xff6e8fd3, 0xff769fe7,
    0xff8ec7ff, 0xff93c6ff, 0xff8ec1fe, 0xff8dc5ff, 0xff93c1fc, 0xff98b6f4, 0xff9cb3e9, 0xff95aae3,
    0xff7d9ad9, 0xff6686cb, 0xff6887c6, 0xff6887c4, 0xff6b85bd, 0xff6981ba, 0xff6681b9, 0xff6681b7,
    0xff647fb7, 0xff647bb2, 0xff6179ae, 0xff6078a9, 0xff6277a9, 0xff5f76a4, 0xff5d739e, 0xff60759f,
    0xff5f74a1, 0xff5e739f, 0xff5e759f, 0xff61759f, 0xff6d7ea9, 0xff697ca7, 0xff697ba7, 0xff61769f,
    0xff5276b3, 0xff597cbb, 0xff587cba, 0xff5980bd, 0xff587ebe, 0xff6484c3, 0xff6586c4, 0xff6788c8,
    0xff718dc8, 0xff6f93d4, 0xff6f9ce1, 0xff74a0e5, 0xff7fb5fc, 0xff82b8fa, 0xff7facf1, 0xff7799d6,
    0xff7899d9, 0xff7da0df, 0xff7fa0e1, 0xff95b1ea, 0xff98b0e8, 0xff91ade7, 0xff7e9ddf, 0xff7594d6,
    0xff7598d8, 0xff88abef, 0xff8eb2f2, 0xff7595d9, 0xff698bd0, 0xff6a8dd2, 0xff7290d5, 0xff7698d8,
    0xff8dabec, 0xff9ebaf2, 0xff94a8e3, 0xff9eb3e6, 0xffacb8e6, 0xffa4b4e3, 0xff708dcd, 0xff6382c4,
    0xff5f7fc0, 0xff5e7dba, 0xff5d7ab8, 0xff5d7ab6, 0xff5a78b1, 0xff5775ad, 0xff5976ae, 0xff5a73a9,
    0xff5a75a8, 0xff5971a3, 0xff5b73a0, 0xff5c74a0, 0xff5e729f, 0xff5b719b, 0xff597099, 0xff5e769f,
    0xff6679a4, 0xff6578a3, 0xff6677a1, 0xff5f74a1, 0xff5175b0, 0xff5578b4, 0xff577cb9, 0xff577dbb,
    0xff597fbe, 0xff5a80c0, 0xff5f81c1, 0xff6084c4, 0xff6187c9, 0xff6389cf, 0xff6c95d7, 0xff7ea6e7,
    0xff7fabee, 0xff7599db, 0xff7395d6, 0xff7597d8, 0xff7598d8, 0xff7b9ddc, 0xff86a6e0, 0xff7e9bd3,
    0xff7a98d5, 0xff7c98d5, 0xff7895d2, 0xff7594d1, 0xff7290d0, 0xff7491ce, 0xff7894d3, 0xff7691d0,
    0xff6e8dcd, 0xff7790cd, 0xff7e97d2, 0xff7c98d5, 0xff7a95d1, 0xff7d96d4, 0xff849cd6, 0xff8399d4,
    0xff839bd7, 0xff8099d3, 0xff8599d2, 0xff708dc8, 0xff607fc2, 0xff5979b7, 0xff5978b5, 0xff5876b1,
    0xff5a76b2, 0xff5674a9, 0xff546ea7, 0xff536fa1, 0xff556da1, 0xff566f9f, 0xff576e9c, 0xff596f98,
    0xff586e98, 0xff586f9c, 0xff5c739b, 0xff5c7199, 0xff5f7198, 0xff5b7197, 0xff596d93, 0xff395454,
    0xff4e6fad, 0xff5275b0, 0xff5379b4, 0xff587ab8, 0xff597ebe, 0xff5d7ebe, 0xff5d7fbf, 0xff5e82c2,
    0xff6485c8, 0xff6387c8, 0xff6e8fcc, 0xff7a98d2, 0xff8ca3d7, 0xff86a0d5, 0xff7897cd, 0xff7492cb,
    0xff7692cb, 0xff7592ca, 0xff7a93cb, 0xff7790ca, 0xff7891c9, 0xff7991ca, 0xff7c92cb, 0xff7c93cd,
    0xff7e96cc, 0xff7891c8, 0xff859ad0, 0xff849acf, 0xff94a3d4, 0xff93a6d7, 0xff8ea1d7, 0xff889cd3,
    0xff768fcc, 0xff7d93cb, 0xff7b91c8, 0xff778dc5, 0xff738cc8, 0xff6182c7, 0xff6080c2, 0xff607fbf,
    0xff6180c0, 0xff6380bb, 0xff627eba, 0xff6380bd, 0xff647db6, 0xff5675ab, 0xff506da3, 0xff506b9e,
    0xff4f6b9a, 0xff556d9f, 0xff536c9b, 0xff536a90, 0xff566a8a, 0xff516784, 0xff4e616e, 0xff586f98,
    0xff566b91, 0xff50688f, 0xff506a8d, 0xff172932, 0xff486ca4, 0xff4f73ac, 0xff5275ac, 0xff5478b4,
    0xff567cb8, 0xff597dbc, 0xff597cba, 0xff5a7dbc, 0xff5e81c0, 0xff6284c4, 0xff698ac5, 0xff7a93cb,
    0xff879ecf, 0xff8ca1d5, 0xff879cd5, 0xff7c98ce, 0xff7694ca, 0xff7793cd, 0xff7e9bd5, 0xff83a2db,
    0xff7392ca, 0xff7692ca, 0xff728ec5, 0xff7b92ca, 0xff8298cd, 0xff8fa1d2, 0xff889ace, 0xff8394c9,
    0xff7892c7, 0xff91a1d1, 0xff8798cb, 0xff7e95cc, 0xff718ac4, 0xff718ac2, 0xff6e87bf, 0xff6c82bc,
    0xff6984bc, 0xff6584c2, 0xff6884c1, 0xff6986c2, 0xff6c87c2, 0xff6984bc, 0xff6682b9, 0xff5b77ac,
    0xff5976ae, 0xff5a74ab, 0xff5673a6, 0xff536e9e, 0xff4f6b9b, 0xff516a96, 0xff506995, 0xff566d8f,
    0xff3f5455, 0xff586e91, 0xff3b4f47, 0xff576f9f, 0xff4d6587, 0xff465d82, 0xff5a729d, 0xff0f1d24,
    0xff4669a0, 0xff4a6ea5, 0xff4f72ac, 0xff5679b4, 0xff5578b2, 0xff5a7db5, 0xff597cb6, 0xff5b7cba,
    0xff5b7dba, 0xff5d7fba, 0xff6283bf, 0xff6886c2, 0xff6f89c2, 0xff7791c8, 0xff7892cb, 0xff7792c9,
    0xff7190c8, 0xff7490cb, 0xff7a99cf, 0xff87a3db, 0xff7c97cf, 0xff7891c8, 0xff708ec8, 0xff7590cc,
    0xff7c94cc, 0xff8096cf, 0xff788ec6, 0xff7a8dc3, 0xff738cc2, 0xff8495c6, 0xff7e92c4, 0xff788dc3,
    0xff7389c3, 0xff6f87c0, 0xff6c80b7, 0xff6380b8, 0xff6280bd, 0xff5e7cb4, 0xff5e7ab8, 0xff607db8,
    0xff5e7bb5, 0xff5c79b3, 0xff5d7bb1, 0xff5977af, 0xff5a76ad, 0xff5570a5, 0xff536e9d, 0xff526c9c,
    0xff4f6a97, 0xff4f6695, 0xff4f6796, 0xff516c94, 0xff435245, 0xff2e4555, 0xff334537, 0xff4e6884,
    0xff465e86, 0xff41597d, 0xff55749d, 0xff0f1925, 0xff42679b, 0xff486aa1, 0xff4c6fa5, 0xff4e71a8,
    0xff5174ae, 0xff5578b2, 0xff5578b3, 0xff567ab5, 0xff597bb6, 0xff5c7db6, 0xff6180bd, 0xff6383be,
    0xff6687c2, 0xff6c88c0, 0xff6f8bc3, 0xff718fc3, 0xff708dc8, 0xff718fc9, 0xff718fcc, 0xff7490cc,
    0xff7c96ce, 0xff708ec8, 0xff6f8dc7, 0xff718ec7, 0xff7a91ca, 0xff7f94cf, 0xff7a91c7, 0xff738bc3,
    0xff758bc2, 0xff6e88c1, 0xff6d88c0, 0xff7288c1, 0xff718ac1, 0xff6a84bd, 0xff617db4, 0xff5f7cb4,
    0xff5d7bb2, 0xff5d7ab5, 0xff5c7ab7, 0xff5d7cc0, 0xff6283c3, 0xff6d8acc, 0xff5876b1, 0xff5774aa,
    0xff5072ad, 0xff506c9e, 0xff516a9e, 0xff4d6795, 0xff4a6590, 0xff475e93, 0xff3b545b, 0xff344d7a,
    0xff516861, 0xff20291c, 0xff273b1f, 0xff3f566f, 0xff445e8c, 0xff223536, 0xff1b362d, 0xff1b282b,
    0xff3e6698, 0xff456a9e, 0xff486ba0, 0xff4a6ea8, 0xff4f71ac, 0xff5173ac, 0xff5477b0, 0xff5578b2,
    0xff5779b5, 0xff587cb6, 0xff5d7eb8, 0xff6181bc, 0xff6383bc, 0xff6585c0, 0xff6988c0, 0xff6b88c2,
    0xff6987c2, 0xff6787c2, 0xff6b89c6, 0xff7a94c8, 0xff8096cb, 0xff7791c8, 0xff6f8bc2, 0xff718dc4,
    0xff748bc5, 0xff788fc5, 0xff7b91c7, 0xff7f94c5, 0xff8297c7, 0xff7d92c4, 0xff738abf, 0xff7086bb,
    0xff6781b7, 0xff647eb2, 0xff5c78ae, 0xff5a75aa, 0xff5873a8, 0xff5672ac, 0xff5876a1, 0xff5d758a,
    0xff5e7881, 0xff5c7796, 0xff506f89, 0xff3f575a, 0xff4d5d52, 0xff4e668b, 0xff42608f, 0xff47628f,
    0xff415984, 0xff5a7387, 0xff232d0d, 0xff0d1a0b, 0xff394d36, 0xff272418, 0xff2b4320, 0xff303d30,
    0xff4d666e, 0xff0a1704, 0xff2b421f, 0xff0e1b11, 0xff3e679c, 0xff42689f, 0xff496ca4, 0xff476fa7,
    0xff4c70aa, 0xff5077b0, 0xff5074ae, 0xff5278b1, 0xff5677b3, 0xff5678b4, 0xff587bb5, 0xff597cb5,
    0xff5d7eb9, 0xff5c7ebb, 0xff5b7dbc, 0xff5d7fbe, 0xff5e80c0, 0xff6183c0, 0xff6585c1, 0xff6887c1,
    0xff6b89c1, 0xff6b88c2, 0xff6c89c1, 0xff728cc2, 0xff6d89c0, 0xff748bc3, 0xff768bc2, 0xff758dc0,
    0xff7a8fc2, 0xff7b90c2, 0xff7d92cd, 0xff6783bc, 0xff607aaf, 0xff5773aa, 0xff5572a3, 0xff506c9e,
    0xff4e6a99, 0xff5372b5, 0xff486157, 0xff526448, 0xff3d4b2f, 0xff475837, 0xff4e696d, 0xff23301b,
    0xff44513e, 0xff3c4d47, 0xff54636e, 0xff405a7d, 0xff415a87, 0xff3f5259, 0xff2c3418, 0xff0d110d,
    0xff273f1a, 0xff261511, 0xff162d0e, 0xff42523a, 0xff18303f, 0xff3f4818, 0xff172a0c, 0xff304522,
    0xff3f68a4, 0xff406ba6, 0xff466da9, 0xff4770aa, 0xff4970ab, 0xff4b72ad, 0xff4e74b0, 0xff4d75b3,
    0xff5075b1, 0xff5375b5, 0xff5377b3, 0xff5579b4, 0xff5477b5, 0xff5379b9, 0xff587abb, 0xff567cbc,
    0xff5e80c0, 0xff5f83bf, 0xff6184c1, 0xff6282be, 0xff6586c1, 0xff6686c1, 0xff6784c1, 0xff6b86c0,
    0xff6a88be, 0xff708ac0, 0xff6f87c1, 0xff7089c7, 0xff6d86c0, 0xff728dca, 0xff61716d, 0xff808fa2,
    0xff6e85ae, 0xff697f9c, 0xff5f7480, 0xff69716b, 0xff4063a2, 0xff527185, 0xff2d473a, 0xff2b3827,
    0xff3c4c2d, 0xff2e3820, 0xff36442d, 0xff415039, 0xff344b1c, 0xff47583e, 0xff3a4b2f, 0xff2f3e20,
    0xff354b50, 0xff364d35, 0xff141d15, 0xff181a0e, 0xff0e201e, 0xff101517, 0xff131f09, 0xff335253,
    0xff3a5056, 0xff213544, 0xff080907, 0xff262b23, 0xff5c8abb, 0xff5581b9, 0xff517db5, 0xff4f7ab4,
    0xff527bb7, 0xff517ab8, 0xff5179b7, 0xff537dba, 0xff537cbb, 0xff527cb9, 0xff517bb8, 0xff5177ba,
    0xff5278b8, 0xff537aba, 0xff5b7fbe, 0xff5e82c1, 0xff6084bf, 0xff6185c1, 0xff6485c1, 0xff6185c0,
    0xff6788c2, 0xff6585bd, 0xff6784bf, 0xff6683bc, 0xff6685ba, 0xff6783c3, 0xff6c88a6, 0xff6b8392,
    0xff60744b, 0xff60786d, 0xff495c4b, 0xff455b48, 0xff5a6e5d, 0xff676d52, 0xff535f55, 0xff3a4d2b,
    0xff6481ad, 0xff5678c5, 0xff4c605f, 0xff2c3826, 0xff2b411d, 0xff203718, 0xff294821, 0xff464d29,
    0xff4e5f30, 0xff374c1e, 0xff47552b, 0xff223216, 0xff000400, 0xff314e1e, 0xff263615, 0xff000a02,
    0xff585c3d, 0xff2a401a, 0xff3b4b26, 0xff2d3b14, 0xff12110b, 0xff322215, 0xff92634b, 0xff7f5237,
    0xff7199bd, 0xff729abe, 0xff769dc2, 0xff759bbf, 0xff7096bf, 0xff7195be, 0xff7296bf, 0xff7195c0,
    0xff789ac1, 0xff7095be, 0xff6d91c1, 0xff7496c3, 0xff6d91c3, 0xff6287bd, 0xff5981bc, 0xff6085bd,
    0xff6185bd, 0xff6085bc, 0xff6386bf, 0xff5f87c1, 0xff6286be, 0xff6684bf, 0xff6686c0, 0xff6886be,
    0xff6986bb, 0xff6c88c5, 0xff697f83, 0xff546940, 0xff4a6044, 0xff546443, 0xff516345, 0xff9d8a65,
    0xff41583e, 0xff475c3d, 0xff4b5646, 0xff3a5736, 0xff2c491e, 0xff2c4319, 0xff35412b, 0xff142513,
    0xff2d4a29, 0xff3b5a2b, 0xff65853c, 0xff334822, 0xff4c5f28, 0xff4f6528, 0xff61762f, 0xff375221,
    0xff141a0e, 0xff162111, 0xff2f3a24, 0xff141012, 0xff51473c, 0xff553b33, 0xff54562c, 0xff170e14,
    0xff3d413a, 0xff58453c, 0xff6d473d, 0xff010b03, 0xff6793c3, 0xff6895c5, 0xff6f98c4, 0xff7299c7,
    0xff789bc4, 0xff7598c2, 0xff7698bf, 0xff7497c0, 0xff7899c0, 0xff7696c0, 0xff7c9ac1, 0xff7b98be,
    0xff809ec4, 0xff809ec6, 0xffaab2c8, 0xff97aac9, 0xffa6b3cc, 0xffa7b4d0, 0xffa1afcd, 0xffbec0d4,
    0xffb8bbd6, 0xffb8bfd6, 0xffb2b9d2, 0xffc1c1d4, 0xffc5c3d5, 0xffccc9e0, 0xff84919c, 0xff32482f,
    0xff39543c, 0xff364534, 0xff2b4734, 0xff545744, 0xff677364, 0xff526454, 0xff4c6648, 0xff23312b,
    0xff273f27, 0xff00130c, 0xff1b261e, 0xff152013, 0xff1f2b17, 0xff7b8740, 0xff555e2d, 0xff47512a,
    0xff646826, 0xff2c2914, 0xff2e2019, 0xff555029, 0xff5b5223, 0xff2a2b18, 0xff000000, 0xff262f18,
    0xff3f4e22, 0xff1e2709, 0xff081306, 0xff273119, 0xff111c0c, 0xff2a4115, 0xff232f14, 0xff000000,
    0xff294764, 0xff2a4a66, 0xff2d4c6b, 0xff305070, 0xff3b5975, 0xff5f7897, 0xff7388a1, 0xff8196af,
    0xff5e7a9a, 0xff7d93ad, 0xff738cae, 0xff8da3be, 0xff748db5, 0xff87a1bd, 0xff7691bb, 0xff809bbe,
    0xff8aa2ca, 0xff738eb6, 0xff6f8dba, 0xff6480ac, 0xff567295, 0xff557399, 0xff637b9b, 0xff607a99,
    0xff698196, 0xff71838d, 0xff889f92, 0xff7b7e56, 0xffa07964, 0xff7b8a55, 0xff829457, 0xff95a16b,
    0xff7c7f45, 0xff5c7a3d, 0xff748454, 0xff727e45, 0xff6e7a49, 0xff605c37, 0xff282019, 0xff0e0e14,
    0xff213233, 0xff130e14, 0xff272512, 0xff000000, 0xff233411, 0xff344920, 0xff34471d, 0xff3c5726,
    0xff848244, 0xff537e3b, 0xff8e884c, 0xff374e25, 0xff3d312d, 0xff302f23, 0xff5b5235, 0xff2e511b,
    0xff0a1007, 0xff011001, 0xff000000, 0xff020b03, 0xff012741, 0xff002f48, 0xff0b3752, 0xff083851,
    0xff083651, 0xff093654, 0xff05314f, 0xff063152, 0xff0a3453, 0xff00294a, 0xff0d3a59, 0xff1b4060,
    0xff16405b, 0xff1d3f5d, 0xff1a3e57, 0xff294661, 0xff2b4965, 0xff284968, 0xff304e6a, 0xff415c79,
    0xff576c83, 0xff7e8791, 0xffa9abb2, 0xffababb3, 0xffa6a3a8, 0xffcfc8c1, 0xffaaa7a0, 0xffd2cabd,
    0xffa5ac9a, 0xffb7b19e, 0xffb4aca2, 0xffbbb4a3, 0xffaeaf9d, 0xffcac9b1, 0xffecd4b4, 0xfffbeacb,
    0xfffcec9a, 0xfff8e8a3, 0xffffffbf, 0xffffffc1, 0xfffff29f, 0xfffffcb8, 0xffffffb9, 0xffffffbd,
    0xffffffbb, 0xfff8f7ae, 0xffffffcb, 0xffb8aa7d, 0xffffeead, 0xfff9d399, 0xffffdea2, 0xffe5ad83,
    0xffa87d5e, 0xffcc9b75, 0xffa47e66, 0xff957765, 0xff746253, 0xffaa8669, 0xffc49b6c, 0xff816f52,
    0xffb2c1c6, 0xff94a8af, 0xff7b959e, 0xff8499a0, 0xff99aab2, 0xff879da4, 0xff9baeb6, 0xff99acb0,
    0xffa4b9bf, 0xfffcfffd, 0xff6d7f88, 0xff002431, 0xff19495c, 0xff0b3d50, 0xff12445a, 0xff0f475c,
    0xff164d60, 0xff154b60, 0xff114957, 0xff114a5d, 0xff114b5e, 0xff0a465a, 0xff144656, 0xff134757,
    0xff114357, 0xff255569, 0xff2e576c, 0xff204d62, 0xff1c495e, 0xff204d65, 0xff214e64, 0xff24526c,
    0xff27526b, 0xff2a546d, 0xff29526a, 0xff37596f, 0xff385d74, 0xff516974, 0xff5b6b6d, 0xff676e6a,
    0xff70746a, 0xff7a776a, 0xff92826e, 0xff97856c, 0xffa2825d, 0xffc79e74, 0xff9c6e4b, 0xff000000,
    0xff5f4737, 0xff9c7455, 0xff987e5b, 0xffd4b980, 0xffffeba6, 0xffffd493, 0xffd9a878, 0xffb28660,
    0xff957851, 0xff786448, 0xff3e4032, 0xff4c423b, 0xff4a5f76, 0xff4a5e79, 0xff5d7185, 0xff63768d,
    0xff657788, 0xff5c6f85, 0xff617183, 0xff8f9cb0, 0xff9fa9bd, 0xff9ba6b8, 0xff6a7f99, 0xff6d87a7,
    0xff7a91af, 0xff8497af, 0xff6884a0, 0xff899bb2, 0xff58789e, 0xff577894, 0xff486f93, 0xff617f9a,
    0xff517792, 0xff416781, 0xff3e667f, 0xff285475, 0xff285577, 0xff5d819c, 0xff2a5977, 0xff295976,
    0xff2f5d7c, 0xff295d70, 0xff306077, 0xff265766, 0xff326777, 0xff2f606f, 0xff255765, 0xff33616c,
    0xff476f77, 0xff2b5a61, 0xff2c5a66, 0xff204d58, 0xff104050, 0xff133b4f, 0xff022a41, 0xff4a6a6b,
    0xff8d9073, 0xff837f70, 0xff4a4243, 0xff70524b, 0xff73534a, 0xff805a4a, 0xff886351, 0xff806453,
    0xff826855, 0xff94765d, 0xffaa8f6b, 0xffab8763, 0xff9f8468, 0xffb4916b, 0xffd4a579, 0xfff1bc81,
    0xff435f75, 0xff3f5c72, 0xff264258, 0xff234356, 0xff254757, 0xff203e50, 0xff1b3c4a, 0xff25445e,
    0xff29465b, 0xff2b4d66, 0xff3f5c72, 0xff3d6172, 0xff4a677a, 0xff55747e, 0xff6b818d, 0xff6b8392,
    0xff6b7d8b, 0xff6c8491, 0xff486171, 0xff325563, 0xff5b7080, 0xff97a0a9, 0xffd9d7e0, 0xffcac7d0,
    0xffe8e0e5, 0xff979cb4, 0xff445b7c, 0xff62759b, 0xff42587e, 0xff46628d, 0xff4d698d, 0xff4f6f90,
    0xff3e5c77, 0xff516e85, 0xff4e7383, 0xff577d8a, 0xff527780, 0xff547786, 0xff556d7b, 0xff485e70,
    0xff9a97a6, 0xffd6b473, 0xfffefea8, 0xfffff39a, 0xfffbd893, 0xfffff2ad, 0xfffeefa5, 0xffefe59f,
    0xffecdd9b, 0xfffceaa4, 0xfffffcb0, 0xfffff0a6, 0xffffeda7, 0xffffd997, 0xffe8c089, 0xfff1c58a,
    0xffdbae7f, 0xffcfa77a, 0xffc69a73, 0xffc19671, 0xff476181, 0xff496381, 0xff415a76, 0xff425c76,
    0xff314c65, 0xff47617a, 0xff405a72, 0xff324f64, 0xff3f5a71, 0xff405b6d, 0xff486581, 0xff415b71,
    0xff3f5b74, 0xff3a546c, 0xff45617c, 0xff4e6b88, 0xff40627f, 0xff3d5c7b, 0xff416081, 0xff416182,
    0xff355873, 0xff345775, 0xff305973, 0xff214a61, 0xff3d5e80, 0xff294c5f, 0xff365877, 0xff3c5d7b,
    0xff31587c, 0xff637b96, 0xff3d6082, 0xff466987, 0xff577395, 0xff627a94, 0xff6b7a91, 0xff818ba6,
    0xff818397, 0xffc0aaa2, 0xffe6c1a2, 0xffffd398, 0xffffd885, 0xfffdd08f, 0xffd39f6f, 0xffa38161,
    0xffbd916b, 0xffaa7357, 0xff916153, 0xffae8265, 0xffc6966e, 0xffb58666, 0xffb58a6a, 0xffa48466,
    0xffa58c6b, 0xffba9b76, 0xffc5a377, 0xffdbb17f, 0xffd5aa7e, 0xffdbaa77, 0xffddad7e, 0xffe7b580,
    0xff1a3e54, 0xff163a4c, 0xff15394c, 0xff1f4352, 0xff204154, 0xff24485a, 0xff153e51, 0xff194659,
    0xff1a465a, 0xff1c4759, 0xff1d4757, 0xff244b60, 0xff2c546b, 0xff284e61, 0xff2c5066, 0xff24495c,
    0xff2b536a, 0xff1e495c, 0xff274e66, 0xff355a72, 0xff274c68, 0xff2f5170, 0xff375476, 0xff3d5779,
    0xff2f4d69, 0xff304d69, 0xff2f4e64, 0xff385468, 0xff6d7e94, 0xff827f8c, 0xffdeced7, 0xffa9a0b3,
    0xff868397, 0xff8a879a, 0xff988e94, 0xffd1a87c, 0xfff9c480, 0xffffc781, 0xfffdc986, 0xfffac37d,
    0xfffbcb85, 0xfff8cb90, 0xffd69f6b, 0xff906a55, 0xff825c49, 0xff97765b, 0xffa57c5e, 0xff9f7c60,
    0xff72584f, 0xff5d4e4a, 0xff554543, 0xff745a51, 0xff896952, 0xffaa7e60, 0xff99785e, 0xff9c7559,
    0xffa17d5e, 0xff907058, 0xff5a4b44, 0xff52443c, 0xff174658, 0xff1f4f66, 0xff1f5064, 0xff1f5063,
    0xff1e4f5d, 0xff215362, 0xff144c54, 0xff2c5d70, 0xff275869, 0xff1d505d, 0xff265965, 0xff225861,
    0xff1f5259, 0xff295b67, 0xff2c5b63, 0xff2e5d6e, 0xff2d596b, 0xff275466, 0xff265467, 0xff234c63,
    0xff294f5f, 0xff355772, 0xff345772, 0xff385a78, 0xff385972, 0xff415c73, 0xff5a6d8b, 0xff5b6378,
    0xff686d88, 0xff797fa7, 0xff666e89, 0xff4c5a6d, 0xff82736d, 0xffc39c70, 0xffffca80, 0xffffc988,
    0xfff3bc81, 0xfffbc282, 0xfffac17b, 0xfff7bb72, 0xfff5c487, 0xffd5af7d, 0xffe8b87b, 0xffedb981,
    0xfff7c885, 0xffdba875, 0xffc39d68, 0xffe2b580, 0xffecbd84, 0xffdfa770, 0xffb98d67, 0xff93745c,
    0xff584944, 0xff403939, 0xff3c3436, 0xff473e3e, 0xff4d3d3b, 0xff6b5247, 0xff7b6250, 0xffb58868,
    0xff194d57, 0xff194e53, 0xff194e56, 0xff21535b, 0xff255965, 0xff2b5a66, 0xff2d5c69, 0xff245458,
    0xff316067, 0xff34626b, 0xff36646f, 0xff386272, 0xff345b6f, 0xff325568, 0xff2f5369, 0xff2e536a,
    0xff294f64, 0xff31566b, 0xff305464, 0xff375a70, 0xff3c5d75, 0xff41617b, 0xff48617b, 0xff536975,
    0xff455161, 0xff505a6f, 0xff636e90, 0xff949cd1, 0xff9fa7d7, 0xff6b728a, 0xff666165, 0xffa0765b,
    0xffad815f, 0xffa67c61, 0xff99725d, 0xff906b58, 0xff7a5c51, 0xffa7775e, 0xffa37457, 0xff966850,
    0xffb5845d, 0xffb07a55, 0xff795a4e, 0xff5c4540, 0xffb18563, 0xffc9996d, 0xffd4a271, 0xffa67a5c,
    0xffc39669, 0xff9a7054, 0xffce986c, 0xffb58d65, 0xffdfa878, 0xffcf9e71, 0xffca9b70, 0xff836750,
    0xff705b4f, 0xff433a38, 0xff433d3b, 0xff53423e, 0xff1f4f5e, 0xff1f4f5d, 0xff1f4d58, 0xff25545d,
    0xff2d5660, 0xff2c5762, 0xff305868, 0xff365f71, 0xff305969, 0xff285159, 0xff325c68, 0xff355a69,
    0xff34586d, 0xff335863, 0xff385d6b, 0xff375563, 0xff3b5d68, 0xff416073, 0xff425f78, 0xff48617e,
    0xff485d74, 0xff465a70, 0xff576678, 0xff666d83, 0xffa8a8bc, 0xffadb2e1, 0xff878db8, 0xff636e8f,
    0xff897a64, 0xffc2976b, 0xffd6a570, 0xffae8264, 0xffbd946c, 0xffbd9269, 0xffc4986c, 0xffb98a64,
    0xff644d44, 0xff5f463b, 0xffbd8960, 0xffeaa868, 0xffffd680, 0xfff8cf8c, 0xffe7b27b, 0xff6d4e44,
    0xff946d59, 0xffe1a86c, 0xffeeba7b, 0xffe0ae78, 0xffd09c6d, 0xffcf976c, 0xffab7957, 0xffb88769,
    0xffb8875e, 0xffa0775f, 0xff977059, 0xffb18264, 0xffa88261, 0xffab8064, 0xff876856, 0xff59493e,
    0xff205059, 0xff204e5f, 0xff21505f, 0xff234d5e, 0xff2a5364, 0xff28525f, 0xff325a63, 0xff2e565b,
    0xff3a616c, 0xff375c60, 0xff395c66, 0xff3a5c67, 0xff3f616c, 0xff38596b, 0xff3b5c6e, 0xff466077,
    0xff4d667b, 0xff4d6171, 0xff445764, 0xff3f4d5b, 0xff455563, 0xff4a5161, 0xff8488a2, 0xff81809e,
    0xffbcb5c5, 0xff7e7e95, 0xff8082a1, 0xffda9d65, 0xffc89566, 0xffd7a36f, 0xffc2956a, 0xffb08366,
    0xff9b745b, 0xffe0ab72, 0xffffc57e, 0xffdeab72, 0xff976951, 0xff554840, 0xff514039, 0xff51382d,
    0xffa5775c, 0xffe4ac71, 0xfff5d18e, 0xfff4bb7d, 0xff937154, 0xff7c5242, 0xffd49b6b, 0xffd3a471,
    0xffc79468, 0xff694a3e, 0xff5f493e, 0xff52423c, 0xff765b4e, 0xff5c4c44, 0xff6f5447, 0xff5e4b41,
    0xff83604e, 0xff57483e, 0xff946b52, 0xff866652, 0xff1c4951, 0xff1c4b56, 0xff244d56, 0xff264f58,
    0xff2d555d, 0xff30575e, 0xff375f6e, 0xff365b64, 0xff3b5d6c, 0xff37585d, 0xff3a5b5e, 0xff476772,
    0xff3c5866, 0xff415663, 0xff53616d, 0xff55626b, 0xff5b6367, 0xff515f70, 0xff526074, 0xff4a5e7d,
    0xff505f76, 0xff576073, 0xff454f63, 0xff676c7d, 0xff505875, 0xff5d709c, 0xff696e8d, 0xff898dac,
    0xffa27b6d, 0xffb78760, 0xffd4a573, 0xfff0bd79, 0xffd2a26e, 0xff7f604e, 0xff8e6854, 0xff896452,
    0xff6e5444, 0xff6b5449, 0xff4d3d2d, 0xff473328, 0xff413631, 0xff6f544c, 0xff8d6453, 0xffedb47d,
    0xffddab77, 0xffb3825b, 0xff58423c, 0xff8c634e, 0xffa77f5e, 0xfff8b87d, 0xffa77c5b, 0xff81604d,
    0xff2a2622, 0xff52423d, 0xff50433d, 0xff443a35, 0xff473c35, 0xff44362f, 0xff4e413b, 0xff423935,
    0xff275156, 0xff2a5256, 0xff234d50, 0xff31575a, 0xff325354, 0xff395c5f, 0xff395a5e, 0xff405f6a,
    0xff3c5c60, 0xff425b62, 0xff4a5d5b, 0xff4e5d5b, 0xff49575e, 0xff4f5d70, 0xff4d5f70, 0xff526076,
    0xff5f6a73, 0xff5e6975, 0xff4d5a70, 0xff556475, 0xff5e6b89, 0xff506181, 0xff637192, 0xff61709c,
    0xff5d6d99, 0xff6e78a0, 0xff7b89b7, 0xffd6bcaa, 0xffb3815a, 0xffbe926b, 0xffdaa76d, 0xffe7b174,
    0xfff1ba7a, 0xffeeb977, 0xff86624e, 0xff4b3f35, 0xff58463c, 0xff584a41, 0xff3d2919, 0xff5c4e46,
    0xff5b453c, 0xff584b44, 0xff53453f, 0xff5a453f, 0xff785541, 0xffb87d55, 0xffb88d6b, 0xff826352,
    0xff503c32, 0xff573c2f, 0xff8b6551, 0xff6e5240, 0xff95705d, 0xff50433d, 0xff52423c, 0xff463a33,
    0xff483e3c, 0xff4a3f3a, 0xff473932, 0xff5c4b40, 0xff254a50, 0xff27484d, 0xff2c4e52, 0xff2d4d50,
    0xff3a585c, 0xff3a5655, 0xff445c57, 0xff485e59, 0xff4d5e5b, 0xff4d5d5a, 0xff445765, 0xff405164,
    0xff47576a, 0xff525e6c, 0xff5d656f, 0xff616973, 0xff525961, 0xff5c6373, 0xff686f80, 0xff616880,
    0xff4e5c7a, 0xff566587, 0xff505e80, 0xff626a86, 0xff84849a, 0xffa08f8a, 0xffe0ab73, 0xffc09060,
    0xffd7a76f, 0xffdba86e, 0xffe1ad6f, 0xffe6b173, 0xffe7b173, 0xfff5bc75, 0xffe2a86b, 0xff9c775b,
    0xff6c564a, 0xff4a352a, 0xff46382c, 0xff58463e, 0xff5d4d46, 0xff615048, 0xff58463f, 0xff45372f,
    0xff4f3f38, 0xff564842, 0xff644b3f, 0xff84604d, 0xff554438, 0xff4d3f39, 0xff473a32, 0xff4c3c32,
    0xff4a3e37, 0xff50423a, 0xff493b33, 0xff473d39, 0xff483c37, 0xff463c38, 0xff443932, 0xff3e3733,
};

static uint32_t _gStretchBmp5[]=
{
    0xff7b92c0, 0xff7e92c2, 0xff7f95c4, 0xff8194c4, 0xff8397c5, 0xff8698c6, 0xff8899c7, 0xff8a9bc8,
    0xff8b9cca, 0xff8c9dcb, 0xff8f9ecc, 0xff929fcd, 0xff94a1cf, 0xff96a3cf, 0xff96a3d0, 0xff9aa5d3,
    0xff9ba7d3, 0xff9daad4, 0xff9eabd5, 0xffa0afd6, 0xffa2b0d6, 0xffa2b1d4, 0xffa4b3d6, 0xffa6b4d5,
    0xffa9b5d5, 0xffaab4d5, 0xffacb4d5, 0xffaeb6d7, 0xffaeb6d6, 0xffaeb5d4, 0xffb0b6d6, 0xffb1b5d6,
    0xffb1b5d6, 0xffb0b4d6, 0xffacb2d7, 0xffa8aed3, 0xffa8aed3, 0xffa6acd2, 0xffa6add4, 0xffa5abd3,
    0xffa3aad3, 0xffa1a9d2, 0xffa2a9d3, 0xffa0a9d2, 0xffa1a8d1, 0xff9fa8d2, 0xff9ea7d0, 0xff9ea9d1,
    0xff9ea9d2, 0xff9da8d2, 0xff9babd1, 0xff99a9d2, 0xff99a9d2, 0xff98a9d3, 0xff94a7d4, 0xff8c9fd3,
    0xff819ad4, 0xff7c95d4, 0xff7591d6, 0xff728ed4, 0xff6d8bd2, 0xff6988d3, 0xff6685d3, 0xff6283d3,
    0xff6184d1, 0xff6083cf, 0xff5d81cf, 0xff5d82ce, 0xff5d81d0, 0xff597fce, 0xff5b7ecd, 0xff5b7ecb,
    0xff597dc9, 0xff567aca, 0xff5378c8, 0xff5277c8, 0xff5176c6, 0xff4e74c4, 0xff4d72c2, 0xff4b71c0,
    0xff8194c3, 0xff8496c4, 0xff8496c4, 0xff8697c4, 0xff8696c4, 0xff8497c5, 0xff8698c7, 0xff8698c7,
    0xff889acb, 0xff8b9bcd, 0xff8e9dd0, 0xff8f9fd0, 0xff93a4cf, 0xff98a7d2, 0xff9dacd2, 0xff9fafcf,
    0xffa3b2d2, 0xffa4b2d1, 0xffa8b3cf, 0xffaab3cf, 0xffacb1cf, 0xffadb2d1, 0xffacb0cf, 0xffadb1d1,
    0xffaaadd1, 0xffabafd0, 0xffacafd1, 0xffabaed1, 0xffabafd2, 0xffabafd5, 0xffabaed3, 0xffaaadd4,
    0xffa8afd4, 0xffa6acd2, 0xffa5abd3, 0xffa4a8d4, 0xffa0a6d3, 0xffa1a7d4, 0xffa0a5d3, 0xff9ea4d2,
    0xff9ca3d2, 0xff9ba2d0, 0xff99a3d1, 0xff99a0d0, 0xff969fd1, 0xff959ece, 0xff979ecf, 0xff959ecf,
    0xff949ccc, 0xff969ccb, 0xff9a9ece, 0xff999ece, 0xff9a9fcf, 0xff989dcf, 0xff989ecf, 0xff969fcd,
    0xff939ecd, 0xff8b9bd0, 0xff8198d0, 0xff7996d1, 0xff7696d2, 0xff6f93d3, 0xff6a90d4, 0xff668bd3,
    0xff6789d3, 0xff6887d0, 0xff6685cf, 0xff6982cd, 0xff6984cc, 0xff6983cc, 0xff6484c9, 0xff6383c9,
    0xff5f81ca, 0xff5a7ecb, 0xff577ccb, 0xff567bcb, 0xff547bc6, 0xff5478c5, 0xff5277c3, 0xff5174c2,
    0xff8598c4, 0xff8797c4, 0xff8898c7, 0xff8799c8, 0xff8799c9, 0xff889ac9, 0xff899ccb, 0xff8a9dca,
    0xff8e9fcb, 0xff8fa3cc, 0xff95a7cb, 0xff9ca8cb, 0xff9ea9cc, 0xffa1a9ca, 0xffa3abcc, 0xffa5aacd,
    0xffa6aacb, 0xffa6a9cd, 0xffa5a9ce, 0xffa5abcd, 0xffa4aad1, 0xffa4abd0, 0xffa5acd1, 0xffa5acd1,
    0xffa5add2, 0xffa6aed3, 0xffa4add2, 0xffa7add3, 0xffa6aed3, 0xffa7afd4, 0xffa5add3, 0xffa5aed2,
    0xffa4acd3, 0xffa5acd3, 0xffa3abd2, 0xffa3a9d3, 0xffa1aad1, 0xffa0a8d2, 0xffa0a9d3, 0xffa0a9d2,
    0xff9fa7d1, 0xff9aa6d2, 0xff99a5d0, 0xff98a4d1, 0xff95a3d1, 0xff95a1d1, 0xff929fcf, 0xff919ecd,
    0xff909ccc, 0xff8e9bcd, 0xff8f9acd, 0xff8c9ace, 0xff8b97ce, 0xff8796cc, 0xff8393d0, 0xff8291cd,
    0xff8391ce, 0xff8491cd, 0xff818fca, 0xff828fcc, 0xff8390cc, 0xff8191cc, 0xff7f90cb, 0xff8192cb,
    0xff8094ca, 0xff7e95cb, 0xff7b92cb, 0xff7191cc, 0xff6b8ccf, 0xff6388ce, 0xff5f83d0, 0xff5e81d2,
    0xff5e80d1, 0xff5c80cf, 0xff5c7fcd, 0xff5a7fca, 0xff587cc7, 0xff567cc7, 0xff567ac6, 0xff5479c1,
    0xff8799c8, 0xff889bca, 0xff8c9fca, 0xff8ea2c9, 0xff90a3c7, 0xff93a3c7, 0xff93a2c8, 0xff97a3c8,
    0xff99a2c7, 0xff9aa2c8, 0xff9ba2c9, 0xff99a1c9, 0xff9aa1cb, 0xff98a1cc, 0xff98a2cc, 0xff9aa3ca,
    0xff9ea6cd, 0xff9ea7cd, 0xff9da7cd, 0xffa0a7cc, 0xffa0a8ce, 0xffa2aace, 0xffa0a9ce, 0xffa0aace,
    0xffa3abcf, 0xffa4add2, 0xffa5add2, 0xffa5add2, 0xffa6aed3, 0xffa7aed3, 0xffa6aed3, 0xffa5add2,
    0xffa6aed3, 0xffa5add2, 0xffa4acd1, 0xffa5add2, 0xffa4abd1, 0xffa4acd4, 0xffa2aad0, 0xff9fa9d1,
    0xff9fa8d1, 0xff9da8d2, 0xff9da7d1, 0xff9ca6d1, 0xff98a4d0, 0xff98a4d1, 0xff97a2cf, 0xff95a1d0,
    0xff939ece, 0xff919dd0, 0xff8e9bcf, 0xff8c9bce, 0xff8797ce, 0xff8496d1, 0xff8595ce, 0xff8495ce,
    0xff7f91cc, 0xff7d91ca, 0xff7b8fca, 0xff778ccb, 0xff778ace, 0xff788dcd, 0xff788bcb, 0xff798bc9,
    0xff7a8bc9, 0xff7c8bc7, 0xff7a8bc9, 0xff768acb, 0xff718cca, 0xff6d8ccc, 0xff6389ce, 0xff6189ce,
    0xff6088ce, 0xff5d83ce, 0xff597fce, 0xff597dcb, 0xff597ccb, 0xff587cc9, 0xff587cc8, 0xff587bc6,
    0xff8fa4c7, 0xff95a6c6, 0xff97a4c6, 0xff97a5c6, 0xff97a3c6, 0xff95a1c6, 0xff939ec6, 0xff919cc6,
    0xff8f9cc7, 0xff909cc7, 0xff909dca, 0xff919ecc, 0xff91a0cc, 0xff93a0cd, 0xff93a0cc, 0xff95a1ce,
    0xff94a2ce, 0xff96a3cd, 0xff96a3ce, 0xff97a3cd, 0xff99a6cc, 0xff9ca7cd, 0xff9fa8cb, 0xffa0a9ce,
    0xffa1a8ce, 0xffa2aacf, 0xffa3abd0, 0xffa3abd0, 0xffa3abd0, 0xffa2aacf, 0xffa2aacf, 0xffa3abd1,
    0xffa3abd2, 0xffa2aad1, 0xffa4abd0, 0xffa2abd1, 0xffa1a9d0, 0xffa2aacf, 0xffa0a9d0, 0xffa0a7d0,
    0xff9fa8d2, 0xff9ea6d1, 0xff9ea8d3, 0xff9ca7d1, 0xff9ba6d0, 0xff99a6d0, 0xff97a4ce, 0xff95a1cf,
    0xff94a1d0, 0xff94a0d0, 0xff909dd1, 0xff8d9bd1, 0xff8c9cd0, 0xff8a9acd, 0xff8999cd, 0xff8796cb,
    0xff8596ca, 0xff8493cb, 0xff8193c9, 0xff7e91c9, 0xff7a8fc7, 0xff778dc8, 0xff7389cb, 0xff7089c9,
    0xff6f88c6, 0xff7087c9, 0xff6d84c8, 0xff6d84c7, 0xff6b81c7, 0xff6d82c7, 0xff6f83c7, 0xff6f85c5,
    0xff6d84c2, 0xff6a86c2, 0xff6686c2, 0xff6184c5, 0xff5a81c6, 0xff597dc5, 0xff587cc8, 0xff5a7bc7,
    0xff929dc5, 0xff919dc4, 0xff929ec7, 0xff909dc5, 0xff929fc6, 0xff929dc8, 0xff909dc8, 0xff909dc9,
    0xff909dc9, 0xff8f9cc9, 0xff8f9cc9, 0xff919ecb, 0xff919ecb, 0xff929fcd, 0xff94a1cd, 0xff94a1cd,
    0xff93a0cb, 0xff95a2cd, 0xff93a0cc, 0xff94a2cf, 0xff95a2cb, 0xff98a2cb, 0xff9aa5cd, 0xff9ba5cb,
    0xff9da7cc, 0xff9fa7cc, 0xff9fa8cd, 0xff9fa7cc, 0xffa0a9ce, 0xff9fa7cf, 0xffa1a8cf, 0xffa0a9cf,
    0xffa1a9d0, 0xffa0a7cf, 0xff9fa6d1, 0xff9ea5d0, 0xff9ea6d0, 0xff9ea5d0, 0xff9ea7d0, 0xff9ea7d1,
    0xff9fa8d1, 0xff9fa9cf, 0xff9ea7d1, 0xff9ea6d2, 0xff9da4d1, 0xff9ba4d0, 0xff9aa3d0, 0xff9aa2d1,
    0xff96a2d0, 0xff96a0ce, 0xff939fce, 0xff919dd0, 0xff909bcf, 0xff8f9acf, 0xff8d9acd, 0xff8b96cc,
    0xff8a96cb, 0xff8794c9, 0xff8494c7, 0xff8291c6, 0xff7e8fca, 0xff7a8ec7, 0xff788cc7, 0xff768ac4,
    0xff7388c5, 0xff7088c4, 0xff6e85c5, 0xff6c83c5, 0xff6a83c4, 0xff6a81c3, 0xff6880c1, 0xff687dc0,
    0xff687dbd, 0xff697cbb, 0xff6b7db7, 0xff6c7eb7, 0xff677fb7, 0xff647fb8, 0xff607db9, 0xff5b7cb9,
    0xff8493c3, 0xff8796c3, 0xff8a98c5, 0xff8b9bc8, 0xff8d9bc7, 0xff909dc9, 0xff909dc8, 0xff909cca,
    0xff919ec9, 0xff909cca, 0xff919ecb, 0xff919dcc, 0xff919ecc, 0xff939fcc, 0xff94a1cd, 0xff93a0cb,
    0xff93a0cd, 0xff94a1cd, 0xff95a2ce, 0xff94a1ce, 0xff93a1cd, 0xff97a5cd, 0xff97a3cb, 0xff98a4cb,
    0xff9ba4cd, 0xff9ca4cc, 0xff9ba5cd, 0xff9ca6cf, 0xff9ea6cf, 0xff9da6ce, 0xff9ea6ce, 0xffa0a3cd,
    0xffa2a3cc, 0xffa7a4cd, 0xffa7a4cb, 0xffafa3ca, 0xffb1a4c7, 0xffb7a5c9, 0xffb7a4c8, 0xffb9a6c8,
    0xffb8a3ca, 0xffb8a3c9, 0xffb4a3c9, 0xffb0a4cd, 0xffaea5cc, 0xffa6a5cd, 0xffa2a2ce, 0xff9ea4cd,
    0xff99a2cf, 0xff97a1d0, 0xff949ed0, 0xff939fcd, 0xff8f9ccd, 0xff909dcd, 0xff8e9ccc, 0xff8d99ca,
    0xff8c98ca, 0xff8a97cb, 0xff8795ca, 0xff8293c5, 0xff8192c4, 0xff7e8ec8, 0xff798cc7, 0xff778dc6,
    0xff7589c3, 0xff7388c1, 0xff7086c1, 0xff6d83c0, 0xff6b83c0, 0xff6980bf, 0xff6680bc, 0xff647fbd,
    0xff617ebd, 0xff627abb, 0xff6179b9, 0xff6179b7, 0xff6078b5, 0xff6277b1, 0xff6277af, 0xff6176ae,
    0xff93a2c8, 0xff8698c4, 0xff8396c3, 0xff8294c1, 0xff8696c5, 0xff8699c3, 0xff8999c6, 0xff899bc5,
    0xff8b9ac6, 0xff8d9bc6, 0xff8d9ac8, 0xff8f9bc8, 0xff919fca, 0xff909dc9, 0xff919ecb, 0xff929fcb,
    0xff929fcc, 0xff94a3cd, 0xff93a0cb, 0xff95a1cb, 0xff95a0cb, 0xff97a0cb, 0xff99a1c9, 0xffa4a0c8,
    0xffb3a2c4, 0xffc7a9be, 0xffddb5bd, 0xffeac5bc, 0xffeed1bf, 0xffead8c5, 0xffe3dacc, 0xffded9cf,
    0xffdad9d7, 0xffd6d7dd, 0xffd8d8e1, 0xffd7dce5, 0xffd9dee8, 0xffd7dee9, 0xffd7dfea, 0xffd8dfeb,
    0xffd9e2e9, 0xffdbe5eb, 0xffdee7e8, 0xffe1ebe6, 0xffe5ece2, 0xfff0efdb, 0xfff7f4d6, 0xfffff0cd,
    0xffffebc3, 0xfffddfbd, 0xfff3cdba, 0xffe7b8b7, 0xffd1a7bd, 0xffb89cc0, 0xffa197c6, 0xff9096c8,
    0xff8a96c8, 0xff8594c6, 0xff8493c8, 0xff8393c6, 0xff7e92c4, 0xff7c8ec3, 0xff7a8bc2, 0xff7889c0,
    0xff758ac0, 0xff7388be, 0xff6f84bd, 0xff6c84bd, 0xff6b83b9, 0xff677fbb, 0xff647ebc, 0xff637db9,
    0xff607cba, 0xff5d7bb9, 0xff5d7bb6, 0xff5d78b5, 0xff5b77b3, 0xff5b74b1, 0xff5c73ac, 0xff5a71aa,
    0xff8a9bc4, 0xff8c9dc6, 0xff7d95c1, 0xff8093c1, 0xff8394c1, 0xff8597c4, 0xff8596c2, 0xff8596c4,
    0xff8596c5, 0xff8798c8, 0xff8a99c6, 0xff8a98c7, 0xff8c9bc6, 0xff8c9bcb, 0xff8b9bc8, 0xff8a9aca,
    0xff8f9acb, 0xff9999c9, 0xffaca0c5, 0xffc5aec1, 0xffdcc1bf, 0xffe2d1c4, 0xffe1d8d0, 0xffd4d6d9,
    0xffc9d5e3, 0xffbad4ea, 0xffaeccee, 0xffa2bfef, 0xffa0b5ec, 0xffa5afe7, 0xffa7ace2, 0xffadb0e0,
    0xffb2b2dc, 0xffb7b8dd, 0xffbbbcda, 0xffbebedb, 0xffbec2da, 0xffc1c3da, 0xffc2c4db, 0xffc3c7d9,
    0xffc8c9df, 0xffcccbe0, 0xffcdcbe3, 0xffcfcae3, 0xffcec8e8, 0xffcdc5eb, 0xffcac1ef, 0xffc2c1f3,
    0xffb9c3f8, 0xffbac9fc, 0xffbbd2fc, 0xffc1ddfa, 0xffcee6f3, 0xffdae6e9, 0xffe5e6db, 0xfff4e4c9,
    0xfff6d7ba, 0xffe8bcb3, 0xffc7a0b7, 0xffa28eb8, 0xff8887bf, 0xff7a86bf, 0xff7586bc, 0xff7387bd,
    0xff7287ba, 0xff6f85bd, 0xff6e84bd, 0xff6b81ba, 0xff697fba, 0xff647fb7, 0xff647eb6, 0xff627ab3,
    0xff5e7ab1, 0xff5d79b5, 0xff5a78b4, 0xff5a77b2, 0xff5a75b3, 0xff5772ae, 0xff5573a9, 0xff556ea7,
    0xffaeb4d0, 0xff8497c1, 0xff758dbf, 0xff7a8fc0, 0xff7a91c2, 0xff7f91c1, 0xff8494c4, 0xff8596c2,
    0xff8396c3, 0xff8395c2, 0xff8193c2, 0xff8393c3, 0xff8892c3, 0xff9b97c2, 0xffb5a3bd, 0xffcab7bd,
    0xffd3c9c4, 0xffcdd2cd, 0xffc1cedc, 0xffaec8e4, 0xffa0b9e8, 0xffa1afe7, 0xffa8b0dd, 0xffacb3db,
    0xffabb4d4, 0xffa9b2d3, 0xffa8b1d4, 0xffa9b2d5, 0xffa6aed3, 0xffa6aed3, 0xffa6afd3, 0xffa8b0d4,
    0xffacb4d5, 0xffb0b5d7, 0xffb4b9d9, 0xffb6bbdb, 0xffb7bbdc, 0xffb9bcda, 0xffbabedb, 0xffbdbfde,
    0xffbdc0dc, 0xffbdc2dd, 0xffbec2de, 0xffbfc3df, 0xffc0c4de, 0xffbfc2dd, 0xffbfc2dd, 0xffbec2df,
    0xffbec1df, 0xffbbbfde, 0xffbabddb, 0xffbabedb, 0xffbdc0d9, 0xffbfc0d8, 0xffbbb9dc, 0xffafafe6,
    0xffa2b1ec, 0xffa2c0ee, 0xffb8cfe6, 0xffcdd6da, 0xffddd2c4, 0xffdfc7b2, 0xffcda7ad, 0xffa385ad,
    0xff7e7bb3, 0xff6c7bb3, 0xff657eb7, 0xff657fb6, 0xff657ab5, 0xff647ab2, 0xff6077af, 0xff5f77af,
    0xff5c77ae, 0xff5a76ab, 0xff5a74ab, 0xff5572ab, 0xff5570a8, 0xff5270a8, 0xff506da5, 0xff506da3,
    0xff738bbd, 0xff6a88c2, 0xff718bbf, 0xff768dbe, 0xff768dbf, 0xff778dc0, 0xff748ebf, 0xff7189c1,
    0xff7889c0, 0xff868abd, 0xffa297ba, 0xffbfadbd, 0xffc7c2c2, 0xffbdc9cf, 0xffabc4db, 0xff9ab3e2,
    0xff9ca9de, 0xffa0a9d7, 0xffa0adce, 0xffa1aece, 0xffa3acd0, 0xffa1adcf, 0xff9facd0, 0xff9eaace,
    0xff9daacf, 0xffa0abce, 0xffa0aacd, 0xffa0aacf, 0xffa0aad0, 0xff9fa9d2, 0xff9fa8cf, 0xffa3abd0,
    0xffa6add2, 0xffa8b1d5, 0xffabb4d6, 0xffafb6d7, 0xffb3b7d8, 0xffb3b8d7, 0xffb4bada, 0xffb6bada,
    0xffb5bada, 0xffb6bad9, 0xffb5bad8, 0xffb6bad9, 0xffb7b9d9, 0xffb7bad9, 0xffb5bad9, 0xffb3b8d7,
    0xffb1b6d7, 0xffb0b5d5, 0xffadb5d6, 0xffadb2d4, 0xffaab1d4, 0xffa8afd1, 0xffa7aed2, 0xffa6afd1,
    0xffa4aecf, 0xffa3acd1, 0xffa5aecf, 0xffa8adcd, 0xffa0a5d7, 0xff94a2e3, 0xff98b7e1, 0xffb2c9d3,
    0xffc8c8bf, 0xffc8b5ae, 0xffb192a3, 0xff8177a7, 0xff6373ac, 0xff5974ad, 0xff5b76af, 0xff5a75ae,
    0xff5974ac, 0xff5773ac, 0xff5572aa, 0xff5371a7, 0xff526ea7, 0xff5270a6, 0xff506da6, 0xff4d6ba2,
    0xff9ca6c7, 0xff8799c1, 0xff6f8abd, 0xff708bbf, 0xff778cbf, 0xff7c89bd, 0xff8c8bbb, 0xffae9bb9,
    0xffc4b7bb, 0xffc5c6c7, 0xffafc5d6, 0xff9bb4df, 0xff9aa8de, 0xff9faad5, 0xff9da9d0, 0xff9caad0,
    0xff9ba8d2, 0xff99a5d1, 0xff9aa6d1, 0xff99a5cf, 0xff9ba7d1, 0xff9aa7cf, 0xff99a5d0, 0xff99a6d0,
    0xff99a7d0, 0xff9aa7d1, 0xff99a5d1, 0xff99a5cf, 0xff98a5d0, 0xff99a5cf, 0xff9ba6d0, 0xffa1aacf,
    0xffa3abcf, 0xffa5add2, 0xffa7aed3, 0xffa7aed2, 0xffa9b1d3, 0xffabb3d4, 0xffadb4d7, 0xffadb5d6,
    0xffafb6d5, 0xffaeb5d6, 0xffadb4d6, 0xffadb3d6, 0xffadb3d5, 0xffacb2d3, 0xffaab1d4, 0xffa9b1d2,
    0xffa6b0d0, 0xffa5add2, 0xffa5add1, 0xffa3aacf, 0xffa0a9cd, 0xffa0a8cd, 0xff9ea8cd, 0xff9ea5cd,
    0xff9da3cd, 0xff99a2cb, 0xff9aa1ca, 0xff969fca, 0xff969ec9, 0xff97a0c8, 0xff929dc9, 0xff929fc5,
    0xff8f98ca, 0xff8392d5, 0xff83a6ce, 0xffa1b4be, 0xffaaa4aa, 0xff98879e, 0xff76709f, 0xff586ca4,
    0xff526da6, 0xff526ea5, 0xff536ea6, 0xff526ea5, 0xff516da7, 0xff4e6ca4, 0xff4d6ba1, 0xff4c6aa0,
    0xff9faac8, 0xff7e8ebc, 0xff6b83ba, 0xff7582b7, 0xff908ab5, 0xffada5b9, 0xffb0bdc3, 0xff9abbd5,
    0xff83a4de, 0xff859bd7, 0xff8a9acd, 0xff8d9bcb, 0xff8b9dc7, 0xff899ac9, 0xff899acc, 0xff8a9bca,
    0xff8c9ccb, 0xff8d9ecc, 0xff8e9ecc, 0xff8e9fcd, 0xff92a0cf, 0xff92a1cf, 0xff92a1cf, 0xff93a1d0,
    0xff929fcf, 0xff90a0ce, 0xff93a0cf, 0xff92a1d0, 0xff96a3ce, 0xff97a4d0, 0xff9aa7d3, 0xff9ba7d2,
    0xff9ea9d4, 0xff9daad1, 0xff9ca8d2, 0xff9ea8d0, 0xff9fa8d1, 0xff9faad2, 0xffa2aad0, 0xffa2abd1,
    0xffa3abd2, 0xffa4abd2, 0xffa3aad0, 0xffa4acd4, 0xffa2aad0, 0xff9ea9d2, 0xff9ea6d0, 0xff9aa6d0,
    0xff9aa3cd, 0xff98a3cc, 0xff96a0ca, 0xff949ec9, 0xff929ec9, 0xff919dc7, 0xff8f9cc6, 0xff8f9bc6,
    0xff8c99c4, 0xff8e9ac4, 0xff8c99c3, 0xff8b97c3, 0xff8995c1, 0xff8895c1, 0xff8694bf, 0xff8490c0,
    0xff828fbe, 0xff7d8eb8, 0xff7986ba, 0xff7184bc, 0xff6d84c6, 0xff6d94c8, 0xff8ca8b6, 0xffa199a3,
    0xff8c7f9c, 0xff6c719f, 0xff596ca0, 0xff506ba3, 0xff4e6aa1, 0xff4c689f, 0xff4b689e, 0xff47669b,
    0xff9ca4c2, 0xffa9a7c2, 0xffb8afc2, 0xffb3b9c3, 0xffb9cbd9, 0xffa5b7de, 0xff6b88c9, 0xff7186c1,
    0xff778dc1, 0xff758dc1, 0xff778dc1, 0xff778ec3, 0xff778ec6, 0xff778fc8, 0xff7a91c7, 0xff7e93c9,
    0xff7f95c9, 0xff8197c9, 0xff8498cb, 0xff8798cb, 0xff899ace, 0xff8a9ccf, 0xff899bce, 0xff889bcc,
    0xff8b9cce, 0xff8c9dce, 0xff8d9ecf, 0xff8e9ecf, 0xff90a1cf, 0xff96a2d2, 0xff98a5d1, 0xff99a7d3,
    0xff98a5d2, 0xff95a2d0, 0xff95a2d0, 0xff93a1d1, 0xff94a2ce, 0xff95a1cd, 0xff95a2cf, 0xff94a2cd,
    0xff94a1cd, 0xff96a3cf, 0xff95a3cf, 0xff97a3cf, 0xff949fcc, 0xff92a0cd, 0xff919dcd, 0xff919dcc,
    0xff8e9aca, 0xff8c9ac8, 0xff8b97c6, 0xff8795c4, 0xff8694c1, 0xff8793c2, 0xff8794c2, 0xff8a96c3,
    0xff8a95c2, 0xff8996c2, 0xff8794bf, 0xff8492be, 0xff8592be, 0xff828fbb, 0xff808dba, 0xff7c8aba,
    0xff7688b6, 0xff7385b7, 0xff7183b6, 0xff6d81b5, 0xff6d83b1, 0xff6f80b2, 0xff6779b5, 0xff6180c8,
    0xff6c96c4, 0xff93a5ad, 0xff9a899a, 0xff756f94, 0xff586595, 0xff4d6597, 0xff496094, 0xff445f90,
    0xffa09eb4, 0xff9db4c0, 0xff86a1ca, 0xff8c9dce, 0xff949dc6, 0xff92a1c4, 0xff9aa9ca, 0xff758dc3,
    0xff6e89c0, 0xff6984c0, 0xff6c87c3, 0xff708bc5, 0xff758ec6, 0xff748dc6, 0xff798fc7, 0xff7b90c9,
    0xff7893cd, 0xff7e95d1, 0xff7f96cc, 0xff839acc, 0xff8699cd, 0xff829acf, 0xff849acf, 0xff849ad0,
    0xff849ad1, 0xff879dcf, 0xff8a9ccf, 0xff8b9ed0, 0xff90a0d1, 0xff90a0cf, 0xff919fcf, 0xff919ecf,
    0xff909dcf, 0xff8f9cce, 0xff8c9acd, 0xff8b9dcb, 0xff8b9acb, 0xff8d9ccd, 0xff8c9bcb, 0xff8b9ccb,
    0xff8d9bcb, 0xff8c9acb, 0xff8d9aca, 0xff8b9ac9, 0xff8998c9, 0xff8795c8, 0xff8897c9, 0xff8795c8,
    0xff8695c6, 0xff8795c7, 0xff8392c6, 0xff8694c5, 0xff8894c6, 0xff8895c7, 0xff8a96c3, 0xff8b98c3,
    0xff8a96c2, 0xff8895c2, 0xff8794c2, 0xff8491be, 0xff818ebb, 0xff7d8bba, 0xff7888b7, 0xff7587b3,
    0xff7183b2, 0xff6e81b3, 0xff6a7fb0, 0xff697eb0, 0xff657dac, 0xff657caa, 0xff647aad, 0xff667ba8,
    0xff6677a8, 0xff5a72b1, 0xff5580c0, 0xff7097ab, 0xff8f8e91, 0xff766d8a, 0xff535e89, 0xff445d8d,
    0xff5f86c2, 0xff6b80be, 0xff6e87b6, 0xff7189b7, 0xff7a8fbc, 0xff8997be, 0xff93a1c7, 0xff9da9c7,
    0xffacb2ce, 0xffb3b7d1, 0xffb4bbd7, 0xffacb5d6, 0xff90a3cd, 0xffa8b2d3, 0xff8197cd, 0xff8ea2ce,
    0xffa8b0d3, 0xffafb7d6, 0xffa2afd2, 0xff809bd6, 0xff819dd7, 0xff839dd6, 0xff849fd7, 0xff859ed5,
    0xff859ed6, 0xff89a0d9, 0xff869ed6, 0xff89a1d6, 0xff8ba1da, 0xff8ca4da, 0xff8aa2da, 0xff889fd5,
    0xff879fd7, 0xff879fd8, 0xff879dd5, 0xff899fd7, 0xff87a0d7, 0xff879ed8, 0xff87a2de, 0xff89a4e0,
    0xff86a4e1, 0xff8ba8e5, 0xff8ea9e2, 0xff91a9e1, 0xff95a7dd, 0xff94a7dd, 0xff92a3d9, 0xff91a3d7,
    0xff8fa0d5, 0xff8e9ed2, 0xff8a9ccf, 0xff899bcd, 0xff8798ca, 0xff8898c6, 0xff8996c6, 0xff8492c2,
    0xff8391c2, 0xff8090be, 0xff7d8dbc, 0xff7b8bb9, 0xff798ab8, 0xff7587b6, 0xff7585b4, 0xff7082b0,
    0xff6d81b0, 0xff687eac, 0xff667cad, 0xff657ba7, 0xff637aa6, 0xff6178a7, 0xff6178a4, 0xff6178a4,
    0xff6076a3, 0xff6077a4, 0xff677ca3, 0xff6272ad, 0xff5376be, 0xff6892b3, 0xff8f9799, 0xff82768e,
    0xff5d80b2, 0xff5e7db5, 0xff5f7eb4, 0xff6382b6, 0xff6784b8, 0xff6e87bc, 0xff778eba, 0xff7e90bd,
    0xff7f91bf, 0xff788cbb, 0xff798bb7, 0xff949abe, 0xffafb3cd, 0xffacb1ce, 0xffb8bad2, 0xffa5adcb,
    0xffb4b8d2, 0xffaeb4d2, 0xffb7bcd6, 0xff9da9d1, 0xff6f8ac5, 0xff7991ca, 0xff819cd4, 0xff85a0da,
    0xff8ba2da, 0xff8aa1d8, 0xff8ba5dc, 0xff95aee9, 0xff92b1ee, 0xff86a8eb, 0xff83a4e4, 0xff82a8ee,
    0xff83a8ed, 0xff80a7ec, 0xff80abf3, 0xff81b5ff, 0xff81b3fd, 0xff7fb1fc, 0xff83b3fc, 0xff84b4fa,
    0xff8ab5fb, 0xff88aaed, 0xff82a5ea, 0xff82a4e9, 0xff86a8e9, 0xff8ba9e8, 0xff8babec, 0xff8aa9e8,
    0xff8ea4db, 0xff8ba1da, 0xff8699d1, 0xff8697cb, 0xff8495c7, 0xff8393c4, 0xff7e90c2, 0xff808ebe,
    0xff7b8bbb, 0xff7989b9, 0xff7789b6, 0xff7586b4, 0xff7384b3, 0xff7081af, 0xff6e81ae, 0xff687ca9,
    0xff657aaa, 0xff6277a9, 0xff6076a3, 0xff6077a4, 0xff5f76a2, 0xff5e75a1, 0xff5e75a1, 0xff5c73a0,
    0xff657ca8, 0xff677ca9, 0xff697caa, 0xff6b7dad, 0xff6c80a7, 0xff6d7cae, 0xff5f7dc2, 0xff7499b4,
    0xff587ab7, 0xff5a7bba, 0xff5b7ebc, 0xff5d80c1, 0xff5f81bf, 0xff6083c1, 0xff6285c5, 0xff6187c5,
    0xff638acc, 0xff668dd0, 0xff6f99dd, 0xff6e9fe6, 0xff729de1, 0xff769edf, 0xff81aaeb, 0xff7fa9ed,
    0xff84a5df, 0xff8199ce, 0xff7e92c7, 0xff7c93c8, 0xff7492ce, 0xff6f90cc, 0xff7292cf, 0xff7594d2,
    0xff7999d8, 0xff7596d6, 0xff7394d6, 0xff7093d3, 0xff7290ce, 0xff84a2dd, 0xff8eabe7, 0xff81a2e2,
    0xff7aa1e7, 0xff7aa5ed, 0xff77a5ec, 0xff77a5ea, 0xff83b5f6, 0xff8dc6ff, 0xff94ceff, 0xff90c6ff,
    0xff8dc4ff, 0xff8fc9ff, 0xff8ec8ff, 0xff8bc3ff, 0xff89b2fa, 0xff92b2f0, 0xff8ca6e2, 0xff829edf,
    0xff7898dc, 0xff6c8acd, 0xff6f8ac7, 0xff718ac5, 0xff6f89c3, 0xff7189c1, 0xff7489bb, 0xff7688bb,
    0xff7588bb, 0xff6f86b9, 0xff6d83b6, 0xff6b82b5, 0xff697fb2, 0xff697eb1, 0xff667dad, 0xff667cad,
    0xff6479aa, 0xff6177a6, 0xff5e74a1, 0xff5b719b, 0xff5c719d, 0xff5c719d, 0xff5b729f, 0xff5e73a0,
    0xff6176a3, 0xff5e729d, 0xff6b7fa9, 0xff6c7da8, 0xff6c7daa, 0xff6e7dac, 0xff6b7da5, 0xff6679ac,
    0xff5176b2, 0xff567ab8, 0xff597cbb, 0xff587dbb, 0xff587fbd, 0xff5980be, 0xff5b7fbf, 0xff6284c3,
    0xff6384c4, 0xff6889c7, 0xff6587c8, 0xff6f8ec8, 0xff6c8fd1, 0xff6d9ae0, 0xff709bdf, 0xff78a6eb,
    0xff7cb2fb, 0xff7fb6fa, 0xff7baaf0, 0xff7ca6eb, 0xff7799d9, 0xff789adb, 0xff799bdc, 0xff7fa2e3,
    0xff82a6e5, 0xff89a7e4, 0xff94b0e6, 0xff91abe6, 0xff90ade7, 0xff809fdf, 0xff7c9cdd, 0xff7292d4,
    0xff7193d4, 0xff7ca0e4, 0xff86a8eb, 0xff87aaec, 0xff7796da, 0xff6488ce, 0xff678ad0, 0xff688acf,
    0xff718fd3, 0xff7493d5, 0xff7b9cdd, 0xff8ca9e8, 0xff97b3ee, 0xff95aae5, 0xff92a8e2, 0xff9cb0e5,
    0xffa4b4e5, 0xffa7b6e4, 0xff94a8dc, 0xff7791ce, 0xff6987c7, 0xff6482c2, 0xff5f7ebf, 0xff5c7bb8,
    0xff5a79b7, 0xff5b78b5, 0xff5977b2, 0xff5877b0, 0xff5774ac, 0xff5874ac, 0xff5873ac, 0xff5973a8,
    0xff5a74a8, 0xff5973a4, 0xff5970a2, 0xff5b729f, 0xff5c739e, 0xff5e73a4, 0xff5c719b, 0xff5c72a2,
    0xff5c74a2, 0xff5c729c, 0xff6278a0, 0xff6678a2, 0xff6478a2, 0xff6577a1, 0xff62749b, 0xff5c7596,
    0xff4d6fad, 0xff5174af, 0xff5377b3, 0xff5479b3, 0xff577ab7, 0xff577dbc, 0xff5a7ebe, 0xff5c7ebf,
    0xff5d7fbf, 0xff5d81c0, 0xff6083c4, 0xff6385c9, 0xff6488ca, 0xff698bcb, 0xff7394d0, 0xff7f9cd5,
    0xff8ca5da, 0xff8ca5d9, 0xff829dd4, 0xff7b98cf, 0xff7694cd, 0xff7592cd, 0xff7794cd, 0xff7794cc,
    0xff7c96cf, 0xff7a95cf, 0xff7892ca, 0xff7691ca, 0xff7992cb, 0xff7a92ca, 0xff7c92ca, 0xff7c94cd,
    0xff7f97cd, 0xff7c94ca, 0xff8298cd, 0xff869ad1, 0xff8097ce, 0xff92a4d4, 0xff889cd1, 0xff96a9d9,
    0xff8fa1d6, 0xff889ed4, 0xff8196d1, 0xff748fcb, 0xff7b92cb, 0xff7b93cc, 0xff7a90c8, 0xff788dc5,
    0xff768ec7, 0xff6987c9, 0xff6686c8, 0xff6583c4, 0xff6482c2, 0xff6481c1, 0xff6583c1, 0xff6480bb,
    0xff637fba, 0xff617eb9, 0xff637eb9, 0xff617bb4, 0xff5876ac, 0xff5471a8, 0xff516ea3, 0xff516c9e,
    0xff506c9b, 0xff516b9d, 0xff556e9c, 0xff536b9a, 0xff566d99, 0xff506476, 0xff5870a1, 0xff566a84,
    0xff4d606a, 0xff566e96, 0xff596d96, 0xff576d93, 0xff526a90, 0xff516992, 0xff465d76, 0xff12242a,
    0xff45689f, 0xff476ca1, 0xff4c6fa6, 0xff4f72ab, 0xff5477b2, 0xff5477b1, 0xff5679b3, 0xff597cb5,
    0xff587bb5, 0xff597bb8, 0xff5a7cb9, 0xff5a7db9, 0xff5d7fba, 0xff5f81bd, 0xff6584c0, 0xff6986c2,
    0xff6e8ac2, 0xff758ec5, 0xff7993ca, 0xff7a92cc, 0xff7893ca, 0xff7391c8, 0xff7390c9, 0xff7490cb,
    0xff7897cf, 0xff83a1d9, 0xff829fd7, 0xff7a96cd, 0xff7791c9, 0xff728fc6, 0xff718ecb, 0xff7690cb,
    0xff7b93cb, 0xff8399d0, 0xff7f94cd, 0xff7a8fc6, 0xff7b8dc2, 0xff7189c3, 0xff778fc2, 0xff8294c6,
    0xff7c90c4, 0xff788dc1, 0xff748ac3, 0xff7289c2, 0xff6d86bf, 0xff6c82bb, 0xff667eb4, 0xff627eb8,
    0xff617eba, 0xff617eb7, 0xff5e7bb5, 0xff607cb9, 0xff617eba, 0xff607db8, 0xff607db8, 0xff607db7,
    0xff5e7cb2, 0xff5977ae, 0xff5876ac, 0xff5874ac, 0xff5570a6, 0xff546e9f, 0xff536e9e, 0xff526c9b,
    0xff4f6a98, 0xff4e6692, 0xff4d6591, 0xff4d658e, 0xff4c668f, 0xff506369, 0xff374840, 0xff314656,
    0xff2c3e2e, 0xff455d61, 0xff4b648a, 0xff455e85, 0xff40587d, 0xff405b73, 0xff496289, 0xff040c0f,
    0xff3d6699, 0xff42689b, 0xff466ba0, 0xff486ba0, 0xff496da5, 0xff4d70aa, 0xff5072ac, 0xff5173ad,
    0xff5376af, 0xff5478b2, 0xff5578b1, 0xff5779b5, 0xff587cb5, 0xff5c7db8, 0xff5e7fb8, 0xff6081bc,
    0xff6283bc, 0xff6383bf, 0xff6585be, 0xff6887c0, 0xff6a89c1, 0xff6b87c3, 0xff6888c2, 0xff6887c4,
    0xff6a89c6, 0xff6f8cc4, 0xff7b94c8, 0xff7f95ca, 0xff7691c9, 0xff6f8cc3, 0xff708bc3, 0xff718dc4,
    0xff738bc4, 0xff788ec7, 0xff7a90c6, 0xff7b91c7, 0xff7a91c5, 0xff8196c6, 0xff7d92c5, 0xff778fc3,
    0xff7089bf, 0xff6f87be, 0xff6d84ba, 0xff6882b8, 0xff657eb3, 0xff5d7aaf, 0xff5c77ae, 0xff5975aa,
    0xff5873a7, 0xff5873ab, 0xff5774ad, 0xff58769f, 0xff5a7391, 0xff5f7a8e, 0xff5d788c, 0xff617ca3,
    0xff506f98, 0xff4b666a, 0xff3e5465, 0xff50645f, 0xff4e6686, 0xff456292, 0xff46628f, 0xff46618d,
    0xff425d88, 0xff4d638a, 0xff50676b, 0xff1b2504, 0xff0a1a11, 0xff344740, 0xff394b34, 0xff231d0c,
    0xff283d1b, 0xff26391a, 0xff435661, 0xff445d68, 0xff0e1e08, 0xff152205, 0xff1f3914, 0xff131e1b,
    0xff3d66a0, 0xff3e68a4, 0xff4169a4, 0xff476ca9, 0xff466fa9, 0xff486fa9, 0xff4a71ab, 0xff4c74ae,
    0xff4e73af, 0xff4d75b1, 0xff4e75b2, 0xff5175b1, 0xff5475b4, 0xff5477b3, 0xff5478b4, 0xff5579b2,
    0xff5578b5, 0xff5579b8, 0xff5479b9, 0xff5679ba, 0xff547bbc, 0xff597dbd, 0xff5d80c0, 0xff5f82bf,
    0xff6184c0, 0xff6181be, 0xff6183be, 0xff6384bf, 0xff6585c1, 0xff6885c1, 0xff6986c1, 0xff6d88c0,
    0xff6989be, 0xff6f88c0, 0xff708ac1, 0xff7186c2, 0xff7088c3, 0xff6f89c7, 0xff728ac8, 0xff758eca,
    0xff6e7e91, 0xff6d818f, 0xff7f90bd, 0xff657fae, 0xff617ba9, 0xff60778e, 0xff5f7488, 0xff626f79,
    0xff43659c, 0xff47659b, 0xff4d6e77, 0xff2c4228, 0xff334022, 0xff37472b, 0xff39421c, 0xff313c19,
    0xff3a4a36, 0xff3f4d39, 0xff303f1f, 0xff384c23, 0xff3b4929, 0xff526459, 0xff313d1c, 0xff384c45,
    0xff394e5c, 0xff3c575b, 0xff283419, 0xff1b231c, 0xff15170f, 0xff141e12, 0xff10241b, 0xff140d11,
    0xff0d1807, 0xff274228, 0xff37535e, 0xff283f46, 0xff374a44, 0xff0a1613, 0xff131b0d, 0xff2a3927,
    0xff709bc1, 0xff6c95bd, 0xff6b96c1, 0xff6a92be, 0xff688fbb, 0xff668fbd, 0xff648bbd, 0xff668cbd,
    0xff668cbd, 0xff6389bd, 0xff698fc0, 0xff698fc0, 0xff648dbd, 0xff5f87be, 0xff638abe, 0xff6589c2,
    0xff6187c0, 0xff5b82bc, 0xff557dbb, 0xff517bbd, 0xff5980bd, 0xff5b82bd, 0xff577fbc, 0xff5980bd,
    0xff5d81bd, 0xff5780c0, 0xff5780bd, 0xff5a81be, 0xff5c7fbb, 0xff5c7dbc, 0xff5e80bc, 0xff5c7dba,
    0xff5c7eba, 0xff5b7cb5, 0xff607ebc, 0xff67807e, 0xff65795c, 0xff506741, 0xff5b6b3a, 0xff566a48,
    0xff4e6445, 0xff696547, 0xff70764c, 0xff3d5434, 0xff4f6037, 0xff58593f, 0xff41533e, 0xff355226,
    0xff496759, 0xff405a56, 0xff4d6876, 0xff404c37, 0xff192615, 0xff35502f, 0xff1d3b1a, 0xff305127,
    0xff466b2f, 0xff4f6b2a, 0xff333f22, 0xff546930, 0xff3e541d, 0xff66822f, 0xff425424, 0xff284519,
    0xff020900, 0xff000000, 0xff425d2e, 0xff29361a, 0xff040708, 0xff38372b, 0xff685946, 0xff4c482c,
    0xff636a38, 0xff2d2914, 0xff292414, 0xff28231f, 0xff4a3126, 0xff875448, 0xff875b44, 0xff382815,
    0xff4f749e, 0xff50759d, 0xff52769f, 0xff55789f, 0xff5b7ba5, 0xff5e7da2, 0xff6f8aae, 0xff7a95b9,
    0xff849dbc, 0xff93aaca, 0xff809cbd, 0xff7b97bc, 0xff8fa6c9, 0xff869fc2, 0xff95aacc, 0xff93abcb,
    0xff8aa3ca, 0xff95aed2, 0xff9eb4d2, 0xffadb8d4, 0xffa3b6d5, 0xffa7bbd9, 0xffb3c0dd, 0xffa1b1d1,
    0xff9aadd2, 0xffa8b4d3, 0xffa2abc5, 0xff95a1be, 0xff8c9ebe, 0xff95a4bc, 0xff8a99b6, 0xff98a3b8,
    0xff96a1b5, 0xffabafb8, 0xff929fb1, 0xff829791, 0xff415232, 0xff58573a, 0xff645b47, 0xff455e36,
    0xff3c6030, 0xff656e4b, 0xff5d6e43, 0xff737651, 0xff516842, 0xff385d2f, 0xff516742, 0xff273719,
    0xff2d4027, 0xff283e26, 0xff000000, 0xff000001, 0xff000000, 0xff000000, 0xff16221c, 0xff2d2d10,
    0xff212006, 0xff000000, 0xff061000, 0xff293302, 0xff151e05, 0xff000000, 0xff1a210a, 0xff3f491b,
    0xff675f27, 0xff3c551b, 0xff213519, 0xff20230b, 0xff112f0c, 0xff2c3e21, 0xff1a2a0f, 0xff061503,
    0xff161d0e, 0xff1f3811, 0xff14310a, 0xff000000, 0xff000d00, 0xff001b00, 0xff000000, 0xff000000,
    0xff4c6978, 0xff416776, 0xff375e6f, 0xff325b6d, 0xff335b6b, 0xff3b6172, 0xff396073, 0xff345b6f,
    0xff3b6176, 0xff2c546a, 0xff355b70, 0xff385e72, 0xff506f80, 0xff58798b, 0xff002037, 0xff00253c,
    0xff002f44, 0xff002942, 0xff002941, 0xff012e44, 0xff033048, 0xff0e384e, 0xff0f3b52, 0xff103c56,
    0xff184253, 0xff1a4459, 0xff274f65, 0xff365a6d, 0xff56727b, 0xff556d7a, 0xff8b9a9b, 0xff71838c,
    0xff7c888e, 0xff798a8c, 0xffa0a7a5, 0xff7d8789, 0xffa0a7a5, 0xff7e9290, 0xff81948a, 0xff858c8d,
    0xff83898f, 0xff909997, 0xff858d92, 0xff859493, 0xff98a3a0, 0xffb2afa6, 0xffb8afa7, 0xffc7c5b9,
    0xffc4c89c, 0xffcabb88, 0xffdbdeb1, 0xffe4e4b0, 0xffece8b8, 0xfff1e9a3, 0xfff3dfa0, 0xfff9f2b2,
    0xfffff5b5, 0xfffffab8, 0xfff8e8ab, 0xfff8e5a7, 0xffffeda8, 0xffffffb7, 0xffd5c48f, 0xff696045,
    0xffc4af7f, 0xfffbd49f, 0xffe5ba85, 0xffeecd97, 0xfffdc993, 0xffe7bc86, 0xfff3c58d, 0xfffac58d,
    0xffc49471, 0xffbf8f74, 0xff8e6f5a, 0xff8d7458, 0xff9e7e62, 0xff917857, 0xff837153, 0xff564d41,
    0xff465d72, 0xff496077, 0xff455c72, 0xff4f6579, 0xff50667d, 0xff556b7c, 0xff53697b, 0xff475c70,
    0xff485d6e, 0xff66798a, 0xff7e8ea6, 0xff8391a4, 0xff7e90a5, 0xff75859c, 0xff54718c, 0xff6985a1,
    0xff7189a5, 0xff7b92a8, 0xff768ea2, 0xff718aa0, 0xff8b9cae, 0xff6b84a2, 0xff67819b, 0xff5f7e95,
    0xff4d6f8b, 0xff4b6d87, 0xff5f7c8f, 0xff577890, 0xff5e7a8e, 0xff7e95a6, 0xff728ca1, 0xff66809b,
    0xff607d95, 0xff96abc0, 0xff4f6e8e, 0xff375f7d, 0xff3c6484, 0xff365d7e, 0xff365d7c, 0xff295974,
    0xff39647f, 0xff325e72, 0xff325f74, 0xff2f6070, 0xff336171, 0xff2d5e6e, 0xff295b67, 0xff376770,
    0xff416e75, 0xff32636d, 0xff1b5261, 0xff1d5064, 0xff0a4058, 0xff12425e, 0xff284e67, 0xff36504e,
    0xff3b625b, 0xff608477, 0xff95a27e, 0xffb0ac82, 0xffadae8d, 0xff939175, 0xff7f7962, 0xff9a8467,
    0xff947c63, 0xff998063, 0xffac906b, 0xffac9671, 0xffab9570, 0xffa88f6d, 0xffae9571, 0xffb7946e,
    0xffbea075, 0xffbc976e, 0xffbb986f, 0xffaa8b6c, 0xffb6946f, 0xffc59a72, 0xffd7a87a, 0xffe2b07b,
    0xff425c7a, 0xff425c78, 0xff3d5772, 0xff38516c, 0xff3e576f, 0xff2d4860, 0xff385269, 0xff3f5971,
    0xff385269, 0xff345169, 0xff2c495e, 0xff3a566e, 0xff345164, 0xff4a6580, 0xff34536a, 0xff445c75,
    0xff405d77, 0xff39556d, 0xff3c576f, 0xff46627d, 0xff4d6783, 0xff41627d, 0xff42617d, 0xff3a5a77,
    0xff3e5d7c, 0xff41607f, 0xff3f607d, 0xff355773, 0xff3a5b78, 0xff42647e, 0xff3a5d77, 0xff35576e,
    0xff486585, 0xff3e5c74, 0xff2d4f66, 0xff325471, 0xff365976, 0xff3e6282, 0xff416280, 0xff6b7e94,
    0xff617a96, 0xff617b98, 0xff577392, 0xff5d779a, 0xff5f799a, 0xff5c7493, 0xff6c7c97, 0xff82899d,
    0xff8c8b91, 0xffa49a99, 0xffd0b49a, 0xffdcbb9e, 0xffeec595, 0xfff4ce87, 0xfff9d08c, 0xfffdd08f,
    0xffdca975, 0xffab8763, 0xffa18060, 0xffae8464, 0xffa6775a, 0xffa1745e, 0xff966c58, 0xffae8869,
    0xffaf8968, 0xffa88166, 0xff9c7c62, 0xffa58368, 0xff9f8165, 0xffaf936f, 0xffb49670, 0xffd0a97d,
    0xffcda779, 0xffdcb382, 0xffdcad7b, 0xffdaae81, 0xffd3a574, 0xffd5a87a, 0xffbe966e, 0xffc9a074,
    0xff144455, 0xff134454, 0xff1b4c60, 0xff184a59, 0xff1b4d5d, 0xff1b4e5b, 0xff215060, 0xff1d505d,
    0xff114952, 0xff215562, 0xff26586a, 0xff235564, 0xff1d505d, 0xff1f525d, 0xff255864, 0xff215660,
    0xff20535d, 0xff255663, 0xff2a5965, 0xff2a5661, 0xff285666, 0xff2c586b, 0xff265264, 0xff255263,
    0xff265265, 0xff234e63, 0xff294f65, 0xff2a4f61, 0xff345770, 0xff375776, 0xff3a5a74, 0xff3f5d7a,
    0xff39576f, 0xff3b546b, 0xff4b627d, 0xff586a87, 0xff606a82, 0xff696f86, 0xff7a7f9f, 0xff7b7d9e,
    0xff848197, 0xff727481, 0xff736b72, 0xff917a6f, 0xffb79271, 0xffe3b179, 0xfff1bd7f, 0xfff5bc7c,
    0xffeeb578, 0xfff7bb7a, 0xfff2b979, 0xfff2b973, 0xffecb16c, 0xffe9b275, 0xffe8bb84, 0xffcfa776,
    0xffd6aa75, 0xffd6a070, 0xffd3a879, 0xffe0b177, 0xffd3a675, 0xffc59768, 0xffc7a46f, 0xffd5a879,
    0xffd9ad7b, 0xffbe956b, 0xffc29163, 0xffa37d60, 0xff92735b, 0xff7b5f50, 0xff655147, 0xff594841,
    0xff52423e, 0xff52433f, 0xff4e403e, 0xff55433d, 0xff624b44, 0xff5b4c42, 0xff745b4e, 0xff926f57,
    0xff1d4f5a, 0xff20515f, 0xff1b4c53, 0xff1e4e58, 0xff24535b, 0xff2a5760, 0xff2c5862, 0xff2d5864,
    0xff335b6b, 0xff325b69, 0xff335d6b, 0xff315b66, 0xff2c555c, 0xff355e69, 0xff345c68, 0xff3b5e70,
    0xff395c73, 0xff335564, 0xff375a69, 0xff37596a, 0xff375566, 0xff355564, 0xff3d5d6d, 0xff405f73,
    0xff405d73, 0xff465f79, 0xff49627b, 0xff495e76, 0xff4a5e75, 0xff4f6075, 0xff616f82, 0xff6a7081,
    0xff9594a5, 0xffa8a9c5, 0xff9195c2, 0xff7f86af, 0xff7780a8, 0xff88838e, 0xffa58f7c, 0xffb58f6a,
    0xffc49868, 0xffbc8b65, 0xffb88661, 0xffbf9368, 0xffb78b65, 0xffad8363, 0xffb18664, 0xff9d7359,
    0xff5e4743, 0xff503a36, 0xff7b5848, 0xffaf7c59, 0xffc48a5e, 0xffe1a562, 0xffe9bc7b, 0xffe6b67b,
    0xffcc9f73, 0xff88614d, 0xff594241, 0xff9c7059, 0xffcc9563, 0xfff5bf7e, 0xffd19f6e, 0xffd0a070,
    0xffc79569, 0xffc38e65, 0xffb3815e, 0xffb27e5b, 0xffb18465, 0xffd49b6c, 0xffc29068, 0xffbc8b69,
    0xffaf8364, 0xffb78764, 0xffa57c5f, 0xffa58161, 0xff96745c, 0xff7b5f4f, 0xff6b564a, 0xff463a36,
    0xff1d4b52, 0xff1d4b55, 0xff1e4c5a, 0xff244e59, 0xff244d5a, 0xff28515d, 0xff2b5460, 0xff2d555e,
    0xff365d69, 0xff345b64, 0xff34585f, 0xff3d606f, 0xff3b5c62, 0xff355759, 0xff406068, 0xff436470,
    0xff3f5d69, 0xff3f5867, 0xff435966, 0xff4f6170, 0xff536473, 0xff58636c, 0xff566472, 0xff515e6e,
    0xff505e6d, 0xff48566d, 0xff47586f, 0xff4c5a6d, 0xff555a6b, 0xff555c70, 0xff646981, 0xff747589,
    0xff75768b, 0xff616a8b, 0xff606c8d, 0xff71728d, 0xffaa928f, 0xffbb9a89, 0xffb57d5a, 0xffc4956b,
    0xffc99b6f, 0xffd8a972, 0xffd9a771, 0xffb68a62, 0xff9a7458, 0xffa67d5d, 0xffbd8e66, 0xffa57b5d,
    0xff86614b, 0xff71574a, 0xff5b4c42, 0xff382d27, 0xff2b1e1c, 0xff44312f, 0xff5d443f, 0xff946c56,
    0xffaf8966, 0xffd8a578, 0xffffd188, 0xffbc9269, 0xffa07153, 0xff67483d, 0xff956c53, 0xff9a7156,
    0xffac8260, 0xffc99569, 0xffae815d, 0xff84644e, 0xff6d5549, 0xff352924, 0xff3f3938, 0xff493b37,
    0xff4f403a, 0xff4b403e, 0xff403530, 0xff524139, 0xff312a27, 0xff675043, 0xff514038, 0xff645044,
    0xff264d53, 0xff2d5153, 0xff284b50, 0xff2a4f51, 0xff2f5253, 0xff365657, 0xff385658, 0xff3c5a59,
    0xff3f5956, 0xff465f60, 0xff455d5e, 0xff475e5b, 0xff4b5e5e, 0xff495a61, 0xff4a595f, 0xff46525c,
    0xff495561, 0xff515d6f, 0xff545f6d, 0xff576371, 0xff5a6475, 0xff596472, 0xff596068, 0xff606978,
    0xff5d677a, 0xff5b6577, 0xff5e687f, 0xff556383, 0xff536487, 0xff59698c, 0xff616d90, 0xff616e95,
    0xff737c9f, 0xff898697, 0xff978b91, 0xffc2a796, 0xffd8ae84, 0xffcc9762, 0xffcb9f6d, 0xffd09f6c,
    0xffdea96c, 0xffe5af71, 0xffe3ae72, 0xfff4bc7a, 0xffffca7e, 0xffe5ad6e, 0xff977152, 0xff6f5a47,
    0xff604e43, 0xff58483f, 0xff453225, 0xff423224, 0xff5c4e46, 0xff5d4a41, 0xff624f48, 0xff564a42,
    0xff4e433e, 0xff403330, 0xff392c2d, 0xff533c34, 0xff735241, 0xff99765e, 0xff86644d, 0xff806151,
    0xff4b3b33, 0xff2e2420, 0xff4b3936, 0xff5e483b, 0xff503d30, 0xff785e50, 0xff654f44, 0xff51443d,
    0xff4e3e37, 0xff463a33, 0xff4b3f3a, 0xff473d3a, 0xff483f3c, 0xff463933, 0xff463b33, 0xff4f433b,
};

static uint32_t _gStretchBmp6[]=
{
    0xff7c91c0, 0xff7f94c3, 0xff8194c4, 0xff8397c5, 0xff8798c7, 0xff8a9bc8, 0xff8b9cca, 0xff8d9ecc,
    0xff929fcd, 0xff94a1cf, 0xff96a3cf, 0xff99a5d3, 0xff9ba8d3, 0xff9eaad5, 0xffa0aed6, 0xffa2b0d5,
    0xffa3b2d5, 0xffa6b4d5, 0xffa9b5d5, 0xffabb4d5, 0xffaeb6d7, 0xffaeb6d5, 0xffafb6d5, 0xffb1b5d6,
    0xffb1b5d6, 0xffaeb3d7, 0xffa8aed4, 0xffa8aed3, 0xffa6acd3, 0xffa5acd3, 0xffa2aad3, 0xffa2a9d2,
    0xffa0a9d2, 0xffa1a8d1, 0xff9ea7d1, 0xff9ea9d1, 0xff9ea8d2, 0xff9caad1, 0xff99aad2, 0xff99a9d2,
    0xff97a9d4, 0xff8da0d3, 0xff819ad4, 0xff7892d5, 0xff728ed5, 0xff6c8bd2, 0xff6786d3, 0xff6283d3,
    0xff6184d0, 0xff5e82cf, 0xff5d82ce, 0xff5c81d0, 0xff5a7ecd, 0xff5b7ecb, 0xff597dc9, 0xff5479c9,
    0xff5277c8, 0xff5176c6, 0xff4d73c3, 0xff4b71c0,
    0xff8295c3, 0xff8496c4, 0xff8697c4, 0xff8596c4, 0xff8598c6, 0xff8698c7, 0xff889acb, 0xff8d9ccf,
    0xff8f9fd0, 0xff93a4cf, 0xff9baad3, 0xff9fafcf, 0xffa3b2d2, 0xffa6b2cf, 0xffaab3cf, 0xffacb1d0,
    0xffacb1d0, 0xffadb1d0, 0xffaaadd1, 0xffacb0d0, 0xffabaed1, 0xffabafd3, 0xffabafd4, 0xffaaadd4,
    0xffa8afd4, 0xffa5abd2, 0xffa4a9d4, 0xffa0a6d3, 0xffa1a6d4, 0xff9ea4d2, 0xff9ca3d2, 0xff9aa3d1,
    0xff99a1d0, 0xff969fd1, 0xff969ece, 0xff969ecf, 0xff949ccb, 0xff999dcd, 0xff999ece, 0xff9a9fcf,
    0xff989dcf, 0xff969fcd, 0xff929ece, 0xff869ad0, 0xff7a96d1, 0xff7596d2, 0xff6b92d4, 0xff668cd3,
    0xff6889d3, 0xff6686cf, 0xff6882cd, 0xff6a84cc, 0xff6783ca, 0xff6383c9, 0xff5e81ca, 0xff587dcb,
    0xff567bcb, 0xff547bc6, 0xff5377c4, 0xff5175c2,
    0xff8598c4, 0xff8897c6, 0xff8799c8, 0xff8799c9, 0xff899bca, 0xff8a9dca, 0xff8e9fcb, 0xff91a6cc,
    0xff9ca8cb, 0xff9ea9cc, 0xffa3aaca, 0xffa5aacd, 0xffa6aacb, 0xffa6a8ce, 0xffa5abcd, 0xffa4aad1,
    0xffa5acd0, 0xffa5acd1, 0xffa5add2, 0xffa5aed2, 0xffa6add3, 0xffa6afd3, 0xffa6aed4, 0xffa5aed2,
    0xffa4acd3, 0xffa4acd2, 0xffa3a9d3, 0xffa1aad1, 0xffa0a8d3, 0xffa0a9d2, 0xff9ea7d1, 0xff99a6d1,
    0xff98a4d1, 0xff95a3d1, 0xff94a0d0, 0xff919ecd, 0xff909ccc, 0xff8f9acd, 0xff8d9ace, 0xff8b97cd,
    0xff8495ce, 0xff8291ce, 0xff8491ce, 0xff8290cb, 0xff828fcc, 0xff8390cc, 0xff7f90cb, 0xff8192cb,
    0xff8095ca, 0xff7e94cb, 0xff7291cc, 0xff6a8ccf, 0xff5f85cf, 0xff5e81d2, 0xff5e80d1, 0xff5c7fce,
    0xff5a7fca, 0xff587cc7, 0xff567bc7, 0xff5479c2,
    0xff8799c8, 0xff8a9dca, 0xff8ea2c9, 0xff91a3c7, 0xff93a2c7, 0xff96a3c8, 0xff99a2c7, 0xff9ba2c9,
    0xff99a1c9, 0xff9aa1cb, 0xff97a1cd, 0xff9aa3ca, 0xff9ea6cd, 0xff9da7cd, 0xffa0a7cc, 0xffa0a8ce,
    0xffa2aace, 0xffa0aace, 0xffa3abcf, 0xffa5add2, 0xffa5add2, 0xffa6aed3, 0xffa7aed3, 0xffa5add2,
    0xffa6aed3, 0xffa4acd1, 0xffa5add2, 0xffa4abd2, 0xffa4abd2, 0xff9fa9d0, 0xff9fa8d1, 0xff9ca8d2,
    0xff9ca6d1, 0xff98a4d0, 0xff98a3d0, 0xff95a1d0, 0xff939ece, 0xff8f9cd0, 0xff8c9bce, 0xff8797cf,
    0xff8495d0, 0xff8495ce, 0xff7e91cc, 0xff7c90ca, 0xff778ccb, 0xff778bce, 0xff788ccc, 0xff798bc9,
    0xff7b8bc9, 0xff7c8bc7, 0xff768acb, 0xff718cca, 0xff678ace, 0xff6089ce, 0xff6087ce, 0xff5a80cf,
    0xff597dcb, 0xff597ccb, 0xff587cc8, 0xff587bc6,
    0xff90a5c7, 0xff97a5c6, 0xff97a5c6, 0xff97a3c6, 0xff94a0c6, 0xff919cc6, 0xff8f9cc7, 0xff909cc8,
    0xff919ecc, 0xff91a0cc, 0xff93a0cd, 0xff95a1ce, 0xff94a2ce, 0xff96a3ce, 0xff97a3cd, 0xff99a6cc,
    0xff9ea7cc, 0xffa0a9cd, 0xffa1a8ce, 0xffa3abd0, 0xffa3abd0, 0xffa3abd0, 0xffa2aacf, 0xffa3abd1,
    0xffa3abd2, 0xffa3aad0, 0xffa3abd1, 0xffa1a9d0, 0xffa1aad0, 0xffa0a7d0, 0xff9fa8d2, 0xff9ea7d2,
    0xff9ca7d2, 0xff9ba6d0, 0xff98a5cf, 0xff95a1cf, 0xff94a1d0, 0xff929ed1, 0xff8d9bd1, 0xff8c9ccf,
    0xff899acd, 0xff8796cb, 0xff8596ca, 0xff8393ca, 0xff7e91c9, 0xff7a8fc7, 0xff758aca, 0xff7089ca,
    0xff7088c6, 0xff6e85c9, 0xff6d84c7, 0xff6b81c7, 0xff6f82c7, 0xff6f85c5, 0xff6d84c2, 0xff6887c2,
    0xff6284c4, 0xff5a80c6, 0xff587cc7, 0xff597bc7,
    0xff919dc4, 0xff929ec6, 0xff909dc6, 0xff929fc6, 0xff919dc8, 0xff909dc9, 0xff909dc9, 0xff8e9bc9,
    0xff919ecb, 0xff919ecb, 0xff93a0cd, 0xff94a1cd, 0xff93a1cc, 0xff94a1cc, 0xff94a1ce, 0xff95a2cb,
    0xff99a4cd, 0xff9ba5cb, 0xff9da7cc, 0xff9fa8cd, 0xff9fa7cc, 0xffa0a9ce, 0xffa0a7cf, 0xffa0a9cf,
    0xffa1a9d0, 0xff9fa6d0, 0xff9ea5d0, 0xff9ea6d0, 0xff9ea6d0, 0xff9ea7d1, 0xff9fa8d1, 0xff9fa8d0,
    0xff9ea6d2, 0xff9da4d1, 0xff9aa4d0, 0xff9aa2d1, 0xff96a2d0, 0xff959fcd, 0xff919dd0, 0xff909bcf,
    0xff8e9bce, 0xff8b97cc, 0xff8a96cb, 0xff8594c8, 0xff8292c6, 0xff7d8fca, 0xff798dc7, 0xff768ac5,
    0xff7388c5, 0xff6f87c4, 0xff6c83c5, 0xff6a83c4, 0xff6981c2, 0xff687dc0, 0xff687dbd, 0xff6a7cb9,
    0xff6c7eb7, 0xff667fb7, 0xff627eb9, 0xff5b7cb9,
    0xff8494c3, 0xff8997c3, 0xff8b9bc8, 0xff8d9bc7, 0xff919ec9, 0xff909cca, 0xff919ec9, 0xff909dcb,
    0xff919ecc, 0xff919ecc, 0xff94a0cd, 0xff93a0cb, 0xff93a0cd, 0xff94a2cd, 0xff94a1ce, 0xff93a2cd,
    0xff98a4cc, 0xff97a4cb, 0xff9ba4cd, 0xff9ca4cc, 0xff9ca6cf, 0xff9ea6cf, 0xff9da6ce, 0xffa0a3cd,
    0xffa3a3cc, 0xffa6a4cc, 0xffaea3ca, 0xffb2a5c7, 0xffb8a4c9, 0xffb8a6c8, 0xffb8a3ca, 0xffb7a3c8,
    0xffb0a4cd, 0xffada5cc, 0xffa3a3ce, 0xff9fa4cd, 0xff99a2cf, 0xff959fd0, 0xff939fce, 0xff8f9ccd,
    0xff8f9dcc, 0xff8d99ca, 0xff8c98ca, 0xff8996cb, 0xff8393c6, 0xff8192c5, 0xff7b8cc8, 0xff778dc6,
    0xff7589c3, 0xff7288c1, 0xff6d83c0, 0xff6b83c0, 0xff6780bd, 0xff647fbd, 0xff617dbd, 0xff6179ba,
    0xff6179b7, 0xff6078b4, 0xff6377af, 0xff6176ae,
    0xff90a0c7, 0xff8396c3, 0xff8295c1, 0xff8697c5, 0xff8799c4, 0xff899bc6, 0xff8b9ac6, 0xff8d9bc7,
    0xff8f9ac8, 0xff919fca, 0xff909dca, 0xff929fcb, 0xff92a0cc, 0xff93a2cc, 0xff95a0cb, 0xff95a0cb,
    0xff96a0ca, 0xffa2a0c8, 0xffb5a2c3, 0xffd5aebd, 0xffe9c3bc, 0xffeed2bf, 0xffe7dbc9, 0xffdfdacf,
    0xffd9d9d8, 0xffd7d7df, 0xffd7dbe5, 0xffd9dee8, 0xffd6dfe9, 0xffd8dfeb, 0xffd9e3ea, 0xffdce6ea,
    0xffe1ebe6, 0xffe7ece1, 0xfff4f4d9, 0xfffef1ce, 0xffffeac2, 0xfffad6bb, 0xffe8bbb7, 0xffcea6bd,
    0xffaa97c3, 0xff9195c8, 0xff8a96c7, 0xff8393c7, 0xff8393c7, 0xff7e91c4, 0xff7b8cc3, 0xff7889c0,
    0xff758ac0, 0xff7186bd, 0xff6c84bd, 0xff6b82b9, 0xff657ebd, 0xff637db9, 0xff607cba, 0xff5c7bb7,
    0xff5d78b5, 0xff5b77b3, 0xff5c73ae, 0xff5a71aa,
    0xff8c9cc5, 0xff8499c3, 0xff7e93c1, 0xff8495c2, 0xff8597c3, 0xff8596c3, 0xff8596c6, 0xff8999c7,
    0xff8a98c7, 0xff8c9bc7, 0xff8b9bca, 0xff8a9ac9, 0xff8f99cb, 0xffa19ac7, 0xffc2acc2, 0xffddc3bf,
    0xffe6d8ca, 0xffd7d7d8, 0xffc7d5e4, 0xffb2d1ee, 0xffa3c1ef, 0xffa1b4ec, 0xffa5abe4, 0xffacafe0,
    0xffb3b3dc, 0xffbabbdb, 0xffbebeda, 0xffbec2da, 0xffc2c3db, 0xffc3c7d9, 0xffc9c9df, 0xffcdcce1,
    0xffcfcae3, 0xffcec8e8, 0xffccc2ed, 0xffc3c1f3, 0xffb9c3f9, 0xffb9cdfd, 0xffbfdbfa, 0xffd0e7f2,
    0xffe0e8e3, 0xfff2e4cb, 0xfff6d4b8, 0xffdaacb4, 0xffa78fb7, 0xff8687c0, 0xff7485bd, 0xff7287bd,
    0xff7287ba, 0xff6f85be, 0xff6b82ba, 0xff687fba, 0xff637fb6, 0xff637ab4, 0xff5e7ab2, 0xff5b78b6,
    0xff5a77b2, 0xff5a74b3, 0xff5573ab, 0xff556fa7,
    0xffa7afcd, 0xff748dbe, 0xff7a8fc0, 0xff7b91c2, 0xff8392c3, 0xff8596c3, 0xff8396c3, 0xff8194c2,
    0xff8393c3, 0xff8a92c3, 0xffaa9bbf, 0xffc8b4bd, 0xffd3cbc5, 0xffc9d3d5, 0xffb1c9e4, 0xffa0b7e9,
    0xffa4aee2, 0xffabb2db, 0xffabb4d4, 0xffa8b1d3, 0xffa9b2d5, 0xffa6aed3, 0xffa6afd3, 0xffa8b0d4,
    0xffacb4d5, 0xffb2b7d8, 0xffb6bbdb, 0xffb7bbdc, 0xffbabdda, 0xffbdbfde, 0xffbdc0dc, 0xffbec2de,
    0xffbfc3df, 0xffc0c4de, 0xffbfc2dd, 0xffbec2df, 0xffbdc1df, 0xffbabedc, 0xffbabedb, 0xffbec0d9,
    0xffbebdd9, 0xffb1b0e4, 0xffa0b3ed, 0xffabc9ec, 0xffcad5dc, 0xffdfd1c1, 0xffdcb9ad, 0xffaa88ac,
    0xff7b7cb3, 0xff647ab5, 0xff637fb7, 0xff657ab5, 0xff6279b0, 0xff5f76af, 0xff5b77ae, 0xff5b75aa,
    0xff5672ab, 0xff5570a8, 0xff506ea7, 0xff506da3,
    0xff718abe, 0xff6c89c1, 0xff768dbe, 0xff768dbf, 0xff768ebf, 0xff718ac1, 0xff7988c0, 0xff938eba,
    0xffbcaabd, 0xffc6c4c4, 0xffb6cad7, 0xff9cb6e1, 0xff9da9dd, 0xff9faad2, 0xffa1aecd, 0xffa3acd0,
    0xffa0add0, 0xff9eaace, 0xff9daacf, 0xffa1abcd, 0xffa0aacf, 0xffa0aad1, 0xff9ea8d1, 0xffa2abd0,
    0xffa6add2, 0xffaab3d6, 0xffafb6d7, 0xffb3b7d8, 0xffb3b9d9, 0xffb6bada, 0xffb5bada, 0xffb6bad8,
    0xffb6bad9, 0xffb7b9d9, 0xffb6bada, 0xffb3b8d7, 0xffb1b6d7, 0xffaeb5d6, 0xffadb2d4, 0xffaab1d4,
    0xffa7aed1, 0xffa6afd1, 0xffa4aecf, 0xffa4add0, 0xffa8aecd, 0xff9ea3da, 0xff92ace6, 0xffadc7d5,
    0xffc9c6bd, 0xffc3a4a5, 0xff8979a5, 0xff6174ac, 0xff5774ae, 0xff5975af, 0xff5974ac, 0xff5672ab,
    0xff5371a7, 0xff526ea7, 0xff516fa6, 0xff4d6ba3,
    0xff9aa5c6, 0xff778fbe, 0xff6f8abf, 0xff788bbf, 0xff8187bb, 0xffa998ba, 0xffc5babc, 0xffbdcad0,
    0xff9db8de, 0xff9ba8dd, 0xff9ea9d2, 0xff9ca9d0, 0xff9aa7d2, 0xff99a5d1, 0xff99a5cf, 0xff9ba7d1,
    0xff99a6cf, 0xff99a6d0, 0xff99a7d0, 0xff9aa6d2, 0xff99a5cf, 0xff98a5d0, 0xff99a5cf, 0xffa0a9cf,
    0xffa3abcf, 0xffa7aed3, 0xffa7aed2, 0xffa9b1d3, 0xffacb4d6, 0xffadb5d6, 0xffafb6d5, 0xffadb5d6,
    0xffadb3d6, 0xffadb3d5, 0xffabb1d3, 0xffa9b1d3, 0xffa6afd0, 0xffa5add2, 0xffa3abcf, 0xffa0a9cd,
    0xff9fa8cd, 0xff9ea6cd, 0xff9ca3cd, 0xff99a1ca, 0xff979fca, 0xff979fc8, 0xff959ec9, 0xff919fc6,
    0xff8e97cd, 0xff7e9bd5, 0xff9cb3c0, 0xffa9a0a8, 0xff89789c, 0xff5b6ba3, 0xff536ea6, 0xff516ea6,
    0xff526ea5, 0xff516da7, 0xff4d6ba2, 0xff4c6aa0,
    0xff99a5c6, 0xff6c82b9, 0xff7383b8, 0xff958eb5, 0xffb5b6bd, 0xff9fbdd2, 0xff83a1de, 0xff879ad1,
    0xff8c9acb, 0xff8a9dc7, 0xff8999cb, 0xff8a9bca, 0xff8c9ccb, 0xff8e9ecc, 0xff8e9fcd, 0xff92a0cf,
    0xff92a1cf, 0xff93a1d0, 0xff919fcf, 0xff92a0ce, 0xff92a1d0, 0xff96a3ce, 0xff99a6d3, 0xff9ba7d2,
    0xff9ea9d3, 0xff9ca9d1, 0xff9ea8d1, 0xff9fa8d1, 0xffa1aad1, 0xffa2abd1, 0xffa3abd3, 0xffa4aad0,
    0xffa4acd3, 0xffa1aad0, 0xff9ea7d2, 0xff9ba6d0, 0xff9aa3cd, 0xff97a2cb, 0xff949ec9, 0xff929ec9,
    0xff8f9cc6, 0xff8f9bc6, 0xff8c99c4, 0xff8e9ac3, 0xff8b97c3, 0xff8995c1, 0xff8795c0, 0xff8490c0,
    0xff818fbc, 0xff7b89b8, 0xff7384bb, 0xff6c86c8, 0xff7ba3c1, 0xffa09da5, 0xff877c9d, 0xff606c9f,
    0xff506aa2, 0xff4e6aa0, 0xff4b689f, 0xff48669b,
    0xff9da3c1, 0xffb5acc2, 0xffb3b6c2, 0xffbbccdc, 0xff819bd4, 0xff6c84c1, 0xff778ec1, 0xff768cc0,
    0xff788ec3, 0xff778ec7, 0xff7890c7, 0xff7e93c9, 0xff7f95c9, 0xff8398ca, 0xff8798cb, 0xff899ace,
    0xff8a9ccf, 0xff889bcc, 0xff8b9cce, 0xff8c9ece, 0xff8e9ecf, 0xff91a1d0, 0xff98a3d2, 0xff99a7d2,
    0xff97a4d2, 0xff95a2d0, 0xff93a1d1, 0xff94a2cd, 0xff95a1ce, 0xff94a2cd, 0xff95a1cd, 0xff95a3cf,
    0xff97a3cf, 0xff949fcc, 0xff919fcd, 0xff919dcc, 0xff8e9aca, 0xff8c99c7, 0xff8895c4, 0xff8694c1,
    0xff8793c2, 0xff8996c3, 0xff8a95c2, 0xff8996c1, 0xff8492be, 0xff8592be, 0xff818eba, 0xff7d8aba,
    0xff7588b6, 0xff7284b7, 0xff6d81b5, 0xff6d83b2, 0xff6a7ab2, 0xff617ec5, 0xff729bc1, 0xffa19ba1,
    0xff7b7194, 0xff566696, 0xff486196, 0xff445e90,
    0xffa2a4b6, 0xff90aec6, 0xff899bce, 0xff929cc5, 0xff9caac8, 0xff7c92c4, 0xff6d88c0, 0xff6783c1,
    0xff6f8bc5, 0xff758ec6, 0xff768ec6, 0xff7c90c9, 0xff7994ce, 0xff8095cf, 0xff829acc, 0xff8599cd,
    0xff829acf, 0xff859ad0, 0xff849bd1, 0xff899dcf, 0xff8b9dd0, 0xff90a0d1, 0xff90a0cf, 0xff919ecf,
    0xff909dcf, 0xff8d9acd, 0xff8b9dcb, 0xff8b9acc, 0xff8d9ccc, 0xff8b9ccb, 0xff8d9bcb, 0xff8d9acb,
    0xff8c9ac9, 0xff8997c9, 0xff8796c8, 0xff8795c8, 0xff8695c6, 0xff8593c7, 0xff8593c5, 0xff8894c7,
    0xff8996c5, 0xff8b98c3, 0xff8a96c2, 0xff8895c3, 0xff8491bf, 0xff818ebb, 0xff7a89b9, 0xff7587b3,
    0xff7183b3, 0xff6b80b1, 0xff697eb0, 0xff657dab, 0xff657bac, 0xff657ba9, 0xff6476a8, 0xff5477bd,
    0xff6a94b0, 0xff8e898f, 0xff626287, 0xff465d8b,
    0xff6184c2, 0xff6e82b9, 0xff708ab6, 0xff7c90bc, 0xff8f9cc3, 0xff9ca8c8, 0xffaeb3cf, 0xffb3b9d4,
    0xffafb7d7, 0xff95a7ce, 0xff96a5d1, 0xff859ccc, 0xffaab1d4, 0xffaeb7d4, 0xff859ed5, 0xff829dd7,
    0xff819dd7, 0xff859ed5, 0xff869fd7, 0xff889fd8, 0xff88a0d6, 0xff8ba1da, 0xff8ba4db, 0xff889fd6,
    0xff879fd8, 0xff879ed6, 0xff899fd7, 0xff879fd7, 0xff869fdb, 0xff89a4e0, 0xff86a5e2, 0xff8da9e4,
    0xff90a9e1, 0xff95a7dd, 0xff93a5db, 0xff91a3d7, 0xff8fa0d5, 0xff8c9dd0, 0xff899bcd, 0xff8798c9,
    0xff8a98c6, 0xff8592c3, 0xff8391c2, 0xff7e8ebd, 0xff7b8bb9, 0xff788ab8, 0xff7586b5, 0xff7182b0,
    0xff6c81af, 0xff667dac, 0xff657ba8, 0xff637aa6, 0xff6178a5, 0xff6178a4, 0xff6075a3, 0xff637aa4,
    0xff6574aa, 0xff5279be, 0xff839da5, 0xff867a8f,
    0xff5d7fb3, 0xff5e7cb4, 0xff6282b5, 0xff6884b9, 0xff738cbb, 0xff7d90bc, 0xff7e90be, 0xff758ab8,
    0xff8f97bc, 0xffadb2cd, 0xffb7b8d2, 0xffaab1cd, 0xffb4b8d2, 0xffb1b7d3, 0xffa5afd3, 0xff6e89c5,
    0xff7f98d0, 0xff829ed9, 0xff8ba2da, 0xff8aa3d9, 0xff94ade7, 0xff90b0ef, 0xff84a4e6, 0xff82a8ec,
    0xff83a8ed, 0xff7fa8ef, 0xff81b4fe, 0xff80b2fc, 0xff81b3fe, 0xff84b4fa, 0xff8ab3f9, 0xff84a6e9,
    0xff82a4ea, 0xff87a8e9, 0xff8caaea, 0xff8aaae9, 0xff8ea4db, 0xff889dd6, 0xff8697cb, 0xff8595c7,
    0xff8091c3, 0xff7f8ebe, 0xff7b8bbb, 0xff7889b7, 0xff7586b4, 0xff7383b2, 0xff6f81af, 0xff697daa,
    0xff657aab, 0xff6076a5, 0xff6077a4, 0xff5e75a1, 0xff5e76a1, 0xff5c73a0, 0xff667ca9, 0xff687ca8,
    0xff6b7dae, 0xff6e81a6, 0xff6378bd, 0xff7095b7,
    0xff587ab8, 0xff5b7cbb, 0xff5d80c0, 0xff5f81be, 0xff6184c4, 0xff6187c5, 0xff638acc, 0xff6b93d6,
    0xff6f9fe6, 0xff719ce0, 0xff7da6e6, 0xff80aaee, 0xff84a4dc, 0xff7f93c8, 0xff7d93c7, 0xff7391ce,
    0xff7091cd, 0xff7494d2, 0xff7899d8, 0xff7393d5, 0xff7194d4, 0xff7492cf, 0xff8eabe5, 0xff83a3e3,
    0xff79a1e8, 0xff78a5ed, 0xff76a5ea, 0xff84b7f8, 0xff92cdff, 0xff91c8ff, 0xff8dc5ff, 0xff8ec9ff,
    0xff8bc4ff, 0xff8bb2f9, 0xff92aee8, 0xff839dde, 0xff7696da, 0xff6b87c8, 0xff718ac5, 0xff6f89c3,
    0xff7389be, 0xff7688ba, 0xff7488bb, 0xff6d84b7, 0xff6b82b5, 0xff697fb2, 0xff677eaf, 0xff667cad,
    0xff6479a9, 0xff5f76a4, 0xff5b719c, 0xff5c719d, 0xff5b729e, 0xff5d73a0, 0xff6074a1, 0xff6479a3,
    0xff6d7fa9, 0xff6c7dab, 0xff6e7da7, 0xff667aaa,
    0xff5277b3, 0xff597cbb, 0xff587dbb, 0xff5880bd, 0xff597fbe, 0xff6183c3, 0xff6585c4, 0xff6687c8,
    0xff6d8dc8, 0xff6c91d4, 0xff6e9be0, 0xff77a3e8, 0xff7db4fd, 0xff7db0f4, 0xff7ca7ed, 0xff7799d9,
    0xff789adb, 0xff7ea0e1, 0xff82a5e5, 0xff92aee6, 0xff92ace6, 0xff8dabe6, 0xff7c9bdd, 0xff7494d6,
    0xff7396d7, 0xff83a5ea, 0xff87aaec, 0xff7393d7, 0xff6388ce, 0xff688acf, 0xff718fd3, 0xff7697d9,
    0xff8aa7e7, 0xff97b2ed, 0xff92a7e2, 0xff9aafe5, 0xffa6b5e5, 0xffa2b3e2, 0xff7b94d0, 0xff6987c6,
    0xff5f7ec0, 0xff5c7bb9, 0xff5a79b7, 0xff5a77b3, 0xff5877b0, 0xff5774ac, 0xff5874ad, 0xff5973a8,
    0xff5a74a8, 0xff5871a2, 0xff5b71a0, 0xff5c73a0, 0xff5d729f, 0xff5c72a0, 0xff5c73a1, 0xff5e759d,
    0xff6679a2, 0xff6478a2, 0xff65759f, 0xff5d7596,
    0xff4e70ad, 0xff5376b1, 0xff5479b3, 0xff577ab8, 0xff587ebd, 0xff5c7ebf, 0xff5d7fbf, 0xff5e82c2,
    0xff6385c9, 0xff6488ca, 0xff6e90ce, 0xff7d9bd4, 0xff8da6da, 0xff88a2d7, 0xff7c99d0, 0xff7593cd,
    0xff7693cd, 0xff7794cc, 0xff7c96cf, 0xff7993cc, 0xff7691ca, 0xff7992cb, 0xff7b92ca, 0xff7c94cd,
    0xff7f97cd, 0xff7d94ca, 0xff879bd1, 0xff849acf, 0xff8ea0d3, 0xff92a6d7, 0xff8da0d5, 0xff879cd4,
    0xff758fcc, 0xff7c93cb, 0xff7a92ca, 0xff788dc5, 0xff748dc7, 0xff6586c9, 0xff6584c5, 0xff6482c2,
    0xff6582c2, 0xff6481bc, 0xff637fba, 0xff627eb9, 0xff627cb5, 0xff5775ab, 0xff526fa5, 0xff516c9e,
    0xff506b9b, 0xff546d9f, 0xff536c9a, 0xff556b90, 0xff526888, 0xff586d8f, 0xff4e6270, 0xff59709c,
    0xff576c90, 0xff50688f, 0xff536b8f, 0xff192c33,
    0xff45689f, 0xff4a6ea4, 0xff4f71aa, 0xff5477b2, 0xff5578b1, 0xff597cb5, 0xff587bb5, 0xff5a7cb9,
    0xff5a7db9, 0xff5d7fba, 0xff6283bf, 0xff6986c2, 0xff6f8ac2, 0xff7892c8, 0xff7a92cc, 0xff7792c9,
    0xff7290c8, 0xff7490cb, 0xff7a99d1, 0xff86a3db, 0xff7b97ce, 0xff7691c8, 0xff6f8dc7, 0xff758fcb,
    0xff7c94cc, 0xff8498d0, 0xff7a8fc7, 0xff7a8cc3, 0xff718bc2, 0xff8194c5, 0xff7b90c3, 0xff768cc2,
    0xff7289c2, 0xff6d86bf, 0xff697fb6, 0xff627eb7, 0xff617eba, 0xff5f7cb5, 0xff5f7cb8, 0xff617eba,
    0xff607db8, 0xff607db7, 0xff5d7bb2, 0xff5876ad, 0xff5875ac, 0xff5570a5, 0xff546e9e, 0xff526c9b,
    0xff4f6997, 0xff4d6593, 0xff4d658d, 0xff4f688f, 0xff425244, 0xff304554, 0xff304231, 0xff4d6684,
    0xff455e85, 0xff3c5473, 0xff4f6c90, 0xff0f1a24,
    0xff3e6699, 0xff446a9e, 0xff486ba0, 0xff496da6, 0xff4f71ab, 0xff5173ad, 0xff5376b0, 0xff5478b1,
    0xff5779b4, 0xff587cb6, 0xff5e7eb8, 0xff6081bb, 0xff6283bd, 0xff6484bf, 0xff6887bf, 0xff6a88c1,
    0xff6987c3, 0xff6887c3, 0xff6b89c6, 0xff7691c6, 0xff7f96ca, 0xff7490c8, 0xff6f8ac2, 0xff718dc4,
    0xff748bc5, 0xff798fc7, 0xff7b91c7, 0xff7b92c5, 0xff8195c6, 0xff778fc3, 0xff7089bf, 0xff6f85bc,
    0xff6882b8, 0xff647eb2, 0xff5b78ae, 0xff5a75ab, 0xff5873a7, 0xff5773ae, 0xff5876a2, 0xff5c7592,
    0xff5e7a8b, 0xff617b9e, 0xff516f8e, 0xff425a64, 0xff4c6060, 0xff4c668a, 0xff456290, 0xff47628e,
    0xff425b85, 0xff556d87, 0xff243011, 0xff0f1e19, 0xff3e5540, 0xff242110, 0xff283f1b, 0xff313f38,
    0xff496371, 0xff0b1902, 0xff203610, 0xff132117,
    0xff3d66a1, 0xff3f69a4, 0xff466ba8, 0xff466fa9, 0xff4a70aa, 0xff4c74ae, 0xff4e73af, 0xff4d75b2,
    0xff5175b1, 0xff5475b4, 0xff5478b3, 0xff5579b3, 0xff5578b5, 0xff5479b9, 0xff5679ba, 0xff547bbc,
    0xff5c7fbf, 0xff5f82bf, 0xff6183c0, 0xff6182be, 0xff6384bf, 0xff6685c1, 0xff6885c1, 0xff6d88c0,
    0xff6a88be, 0xff718ac1, 0xff7187c2, 0xff7089c6, 0xff7088c6, 0xff758ecc, 0xff6b7c8a, 0xff7b8dae,
    0xff6a82b1, 0xff637ba2, 0xff5c7489, 0xff63707a, 0xff40629d, 0xff517090, 0xff304933, 0xff334125,
    0xff374421, 0xff323b16, 0xff3d4d3a, 0xff344127, 0xff364921, 0xff425137, 0xff43523b, 0xff334536,
    0xff3b5263, 0xff344838, 0xff1b2318, 0xff16160f, 0xff0e2317, 0xff141114, 0xff0e1c06, 0xff3a5751,
    0xff29414b, 0xff31433e, 0xff020a02, 0xff2a3825,
    0xff6f9ac0, 0xff6b95bf, 0xff6a93bf, 0xff688fbb, 0xff658dbd, 0xff668bbd, 0xff658bbd, 0xff668cbe,
    0xff6a90c0, 0xff638cbd, 0xff6088be, 0xff658ac1, 0xff6086bf, 0xff587fbb, 0xff517bbd, 0xff5a81bd,
    0xff5980bc, 0xff5880bd, 0xff5c81be, 0xff5680bf, 0xff5a81be, 0xff5c7ebb, 0xff5e7fbd, 0xff5d7eba,
    0xff5c7eb7, 0xff5e7dc2, 0xff668089, 0xff617659, 0xff526734, 0xff596b45, 0xff4e6043, 0xff79754e,
    0xff435a38, 0xff525f35, 0xff4c5444, 0xff355228, 0xff496557, 0xff425f69, 0xff465547, 0xff1e2d1a,
    0xff2b4924, 0xff274720, 0xff4d7231, 0xff394a21, 0xff4e612f, 0xff476021, 0xff5f752e, 0xff28441a,
    0xff000000, 0xff223319, 0xff334421, 0xff040709, 0xff635845, 0xff4e472f, 0xff5a6133, 0xff1d1808,
    0xff2b2720, 0xff51342a, 0xff9b6453, 0xff43301b,
    0xff4f749d, 0xff51759e, 0xff55789f, 0xff5a7aa4, 0xff6582a5, 0xff7994b9, 0xff879fbe, 0xff8ea7c7,
    0xff7996ba, 0xff8ea5c8, 0xff8ba2c5, 0xff97adcd, 0xff8ca4cb, 0xff99b2d3, 0xffabb7d3, 0xffa1b6d5,
    0xffb1c1de, 0xffa5b4d3, 0xff9cafd3, 0xffa7b0cc, 0xff96a1be, 0xff8fa1bf, 0xff8c9cb7, 0xff94a0b7,
    0xff9da7b9, 0xffa0a7b5, 0xff849999, 0xff41502f, 0xff665b45, 0xff485b35, 0xff466336, 0xff626f48,
    0xff6e754d, 0xff47623a, 0xff4b6a3f, 0xff2e3e20, 0xff30462b, 0xff0e180e, 0xff000000, 0xff000000,
    0xff0a1211, 0xff2b2e14, 0xff1d1b04, 0xff000000, 0xff263001, 0xff0e1604, 0xff0d0c03, 0xff394419,
    0xff645f25, 0xff25461a, 0xff23240e, 0xff153310, 0xff2a361c, 0xff051702, 0xff19200f, 0xff1b3e0e,
    0xff030601, 0xff001300, 0xff000b00, 0xff000000,
    0xff4a6978, 0xff3a6272, 0xff335b6d, 0xff345c6c, 0xff3d6375, 0xff345b6f, 0xff375e73, 0xff2e556a,
    0xff375d72, 0xff597889, 0xff294a5f, 0xff001d34, 0xff013045, 0xff002740, 0xff012e44, 0xff043149,
    0xff103b50, 0xff0f3c56, 0xff174152, 0xff204a60, 0xff34596c, 0xff516d78, 0xff76888e, 0xff7b8c92,
    0xff758389, 0xff94a09f, 0xff848d8e, 0xff9ca5a3, 0xff758c85, 0xff88908e, 0xff858c90, 0xff8c9396,
    0xff839192, 0xff9da6a4, 0xffb6aea4, 0xffc5c2b8, 0xffc3c394, 0xffd4cc9f, 0xffe3e6b2, 0xffede9b6,
    0xfff3e19b, 0xfff8eeb0, 0xfffff7b6, 0xfffcf2b2, 0xfff7e3a6, 0xfff9eda8, 0xfff9f2af, 0xff74684b,
    0xffd4bd8b, 0xffedbf8c, 0xffecca93, 0xfffcc892, 0xffe7be88, 0xfffdc88f, 0xffc49472, 0xffa87f69,
    0xff866e54, 0xff9c7d60, 0xff8d7955, 0xff5d5344,
    0xff475e74, 0xff465d74, 0xff4d6377, 0xff50667d, 0xff556c7b, 0xff495e73, 0xff4b6070, 0xff76889e,
    0xff8291a5, 0xff7f90a5, 0xff5f758f, 0xff63819d, 0xff728aa5, 0xff7f95a8, 0xff70899f, 0xff889aae,
    0xff637d9c, 0xff648197, 0xff4a6d8a, 0xff557489, 0xff597991, 0xff647f92, 0xff7a93a5, 0xff66809b,
    0xff6d889f, 0xff7c94af, 0xff325a79, 0xff3b6383, 0xff365c7d, 0xff2b5a75, 0xff38637d, 0xff305d71,
    0xff306172, 0xff336171, 0xff295b69, 0xff34646e, 0xff426e76, 0xff225864, 0xff1d5164, 0xff093e56,
    0xff1c4867, 0xff355052, 0xff3e665f, 0xff81997e, 0xffaeab80, 0xffabac8c, 0xff817e66, 0xff968267,
    0xff937b63, 0xffa68a67, 0xffad9671, 0xffaa936f, 0xffaa9370, 0xffb6946f, 0xffbc9e74, 0xffbe986d,
    0xffad8e6d, 0xffb8956f, 0xffcea076, 0xffe2b07c,
    0xff425c7a, 0xff415b76, 0xff38516c, 0xff3b556d, 0xff2e4960, 0xff405a72, 0xff38536b, 0xff2c4a5f,
    0xff37536b, 0xff3a566a, 0xff415f79, 0xff3e586f, 0xff3f5c76, 0xff3a546c, 0xff44617b, 0xff4b6682,
    0xff41627e, 0xff3c5b78, 0xff3e5d7c, 0xff41617f, 0xff365874, 0xff3b5c78, 0xff40637e, 0xff34566d,
    0xff496585, 0xff315166, 0xff315370, 0xff3a5c79, 0xff3a5f80, 0xff657a90, 0xff617a97, 0xff5e7996,
    0xff5b7598, 0xff5e7899, 0xff607593, 0xff81889d, 0xff8c8b92, 0xffbfaa9c, 0xffddbb9d, 0xfff0c893,
    0xfff9d188, 0xfffed190, 0xffd5a472, 0xff9d7e5f, 0xffac8363, 0xffa7785c, 0xff986c5a, 0xffa98265,
    0xffaf8868, 0xff9f7d63, 0xffa48267, 0xffa28467, 0xffb0946f, 0xffcba67b, 0xffcfa97c, 0xffe0b27f,
    0xffdaad7f, 0xffd5a776, 0xffc79e75, 0xffc59c71,
    0xff134353, 0xff18495c, 0xff194b5b, 0xff1b4d5d, 0xff1d4e5c, 0xff1f515f, 0xff134a53, 0xff27596a,
    0xff235565, 0xff1c505c, 0xff235661, 0xff225761, 0xff20535d, 0xff285865, 0xff2a5661, 0xff295767,
    0xff2a5568, 0xff245162, 0xff255164, 0xff264e64, 0xff2a4f61, 0xff355773, 0xff385874, 0xff3f5e7a,
    0xff38556d, 0xff425a73, 0xff576a87, 0xff606980, 0xff767a96, 0xff7c7ea0, 0xff817f94, 0xff6a6a76,
    0xff8d776f, 0xffbe9772, 0xfff1bc7d, 0xfff6bd7d, 0xfff0b678, 0xfff6bb7a, 0xfff1b974, 0xffeaaf6b,
    0xffecbb81, 0xffd2aa79, 0xffd8a973, 0xffd1a074, 0xffdeb178, 0xffd0a273, 0xffc59e69, 0xffd2a878,
    0xffd4a979, 0xffc29366, 0xffaa8161, 0xff90715a, 0xff6c544a, 0xff5a4942, 0xff52423e, 0xff4f413f,
    0xff53423d, 0xff614b43, 0xff635146, 0xff906d57,
    0xff1e505c, 0xff1d4e58, 0xff1d4d56, 0xff25545c, 0xff2c5862, 0xff2d5863, 0xff335b6b, 0xff325b69,
    0xff325c68, 0xff2e575e, 0xff355f6a, 0xff395d6d, 0xff385b70, 0xff355765, 0xff385a6b, 0xff365465,
    0xff385967, 0xff405f73, 0xff415d73, 0xff49627c, 0xff495f77, 0xff485b72, 0xff59687b, 0xff687081,
    0xff9b9aab, 0xff9fa2cb, 0xff8288b2, 0xff787fa5, 0xff988a82, 0xffb38f6c, 0xffc49869, 0xffb88460,
    0xffbf9267, 0xffb78a65, 0xffb08665, 0xffa3785c, 0xff58423f, 0xff5d423b, 0xffa87858, 0xffc88d5d,
    0xfff0bb73, 0xffe6b87d, 0xffc5976e, 0xff5a3f3c, 0xff8e6756, 0xffd7a069, 0xffebb67b, 0xffce9d6e,
    0xffc89468, 0xffb88661, 0xffb17d5a, 0xffb88967, 0xffd0986a, 0xffba8a69, 0xffb28565, 0xffb08262,
    0xffa37f60, 0xff917059, 0xff745c4e, 0xff4b3e39,
    0xff1d4b52, 0xff1c4b58, 0xff234e59, 0xff244d5a, 0xff2b5460, 0xff2c545e, 0xff365e6a, 0xff32585d,
    0xff3c5f6d, 0xff395b5f, 0xff3a5b60, 0xff446470, 0xff3f5c69, 0xff405766, 0xff4d606e, 0xff546371,
    0xff5a656f, 0xff515f70, 0xff4f5d6d, 0xff45556e, 0xff4b5a6e, 0xff555a6b, 0xff5c6279, 0xff737489,
    0xff70728a, 0xff5d6a8d, 0xff6d708d, 0xffb09893, 0xffb6866c, 0xffc39065, 0xffcb9d70, 0xffdfaf75,
    0xffbd8f65, 0xff9a7458, 0xffb78963, 0xffa97f5f, 0xff825f4a, 0xff655248, 0xff3c312b, 0xff2e201e,
    0xff4a3635, 0xff8c6652, 0xffb08967, 0xffffce8a, 0xffcaa170, 0xff92664d, 0xff715144, 0xff9e7357,
    0xffb28662, 0xffc89368, 0xff88674f, 0xff644d42, 0xff2e2928, 0xff493d3a, 0xff52433d, 0xff3d3533,
    0xff514037, 0xff3b312c, 0xff644d41, 0xff5b493f,
    0xff284e53, 0xff2b4e51, 0xff294e51, 0xff305354, 0xff375657, 0xff3b5959, 0xff405a57, 0xff475f61,
    0xff465d5b, 0xff4a5d5e, 0xff495a60, 0xff47535c, 0xff4a5664, 0xff535e6f, 0xff56626f, 0xff5a6576,
    0xff58616a, 0xff5f6775, 0xff5c6679, 0xff5e687b, 0xff576483, 0xff526487, 0xff5d6b8f, 0xff616e94,
    0xff777fa0, 0xff8e8793, 0xffbba396, 0xffd6a97d, 0xffcb9963, 0xffd0a16e, 0xffe0aa6d, 0xffe4af72,
    0xfff0b878, 0xffffca7d, 0xffbd8c5e, 0xff715b47, 0xff604e43, 0xff4c3c32, 0xff402f21, 0xff5d4e46,
    0xff614c44, 0xff594d45, 0xff4c413c, 0xff35292a, 0xff4e3933, 0xff7e5b49, 0xff967359, 0xff81614f,
    0xff44362e, 0xff352827, 0xff5d473c, 0xff564235, 0xff7a5e51, 0xff50433b, 0xff4d3d36, 0xff473c37,
    0xff483d3a, 0xff483e3b, 0xff443830, 0xff4e423a,
};
#endif
#endif  // #ifndef _QC_VERIFY_SE_H_
