/**
* @file Merlin6_ATSC_Register_Table
* RBus systemc program.
*
* @author RS_MM2_SD
* @email mm_mm2_rd_sw_kernel@realtek.com
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_ATSC_REG_H_
#define _RBUS_ATSC_REG_H_

#include "rbus_types.h"



//  ATSC Register Address
#define  ATSC_ADDR_2001                                                         0x18154004
#define  ATSC_ADDR_2001_reg_addr                                                 "0xB8154004"
#define  ATSC_ADDR_2001_reg                                                      0xB8154004
#define  ATSC_ADDR_2001_inst_addr                                                "0x0000"
#define  set_ATSC_ADDR_2001_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2001_reg)=data)
#define  get_ATSC_ADDR_2001_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2001_reg))
#define  ATSC_ADDR_2001_atsc_version_shift                                       (0)
#define  ATSC_ADDR_2001_atsc_version_mask                                        (0x000000FF)
#define  ATSC_ADDR_2001_atsc_version(data)                                       (0x000000FF&(data))
#define  ATSC_ADDR_2001_get_atsc_version(data)                                   (0x000000FF&(data))

#define  ATSC_ADDR_2004                                                         0x18154010
#define  ATSC_ADDR_2004_reg_addr                                                 "0xB8154010"
#define  ATSC_ADDR_2004_reg                                                      0xB8154010
#define  ATSC_ADDR_2004_inst_addr                                                "0x0001"
#define  set_ATSC_ADDR_2004_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2004_reg)=data)
#define  get_ATSC_ADDR_2004_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2004_reg))
#define  ATSC_ADDR_2004_opt_atsc_on_shift                                        (0)
#define  ATSC_ADDR_2004_opt_atsc_on_mask                                         (0x00000001)
#define  ATSC_ADDR_2004_opt_atsc_on(data)                                        (0x00000001&(data))
#define  ATSC_ADDR_2004_get_opt_atsc_on(data)                                    (0x00000001&(data))

#define  ATSC_ADDR_2005                                                         0x18154014
#define  ATSC_ADDR_2005_reg_addr                                                 "0xB8154014"
#define  ATSC_ADDR_2005_reg                                                      0xB8154014
#define  ATSC_ADDR_2005_inst_addr                                                "0x0002"
#define  set_ATSC_ADDR_2005_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2005_reg)=data)
#define  get_ATSC_ADDR_2005_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2005_reg))
#define  ATSC_ADDR_2005_opt_soft_reset_atsc_shift                                (0)
#define  ATSC_ADDR_2005_opt_soft_reset_atsc_mask                                 (0x00000001)
#define  ATSC_ADDR_2005_opt_soft_reset_atsc(data)                                (0x00000001&(data))
#define  ATSC_ADDR_2005_get_opt_soft_reset_atsc(data)                            (0x00000001&(data))

#define  ATSC_ADDR_2007                                                         0x1815401C
#define  ATSC_ADDR_2007_reg_addr                                                 "0xB815401C"
#define  ATSC_ADDR_2007_reg                                                      0xB815401C
#define  ATSC_ADDR_2007_inst_addr                                                "0x0003"
#define  set_ATSC_ADDR_2007_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2007_reg)=data)
#define  get_ATSC_ADDR_2007_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2007_reg))
#define  ATSC_ADDR_2007_opt_adcclkin_atsc_shift                                  (4)
#define  ATSC_ADDR_2007_opt_adcdata_atsc_shift                                   (0)
#define  ATSC_ADDR_2007_opt_adcclkin_atsc_mask                                   (0x00000030)
#define  ATSC_ADDR_2007_opt_adcdata_atsc_mask                                    (0x00000003)
#define  ATSC_ADDR_2007_opt_adcclkin_atsc(data)                                  (0x00000030&((data)<<4))
#define  ATSC_ADDR_2007_opt_adcdata_atsc(data)                                   (0x00000003&(data))
#define  ATSC_ADDR_2007_get_opt_adcclkin_atsc(data)                              ((0x00000030&(data))>>4)
#define  ATSC_ADDR_2007_get_opt_adcdata_atsc(data)                               (0x00000003&(data))

#define  ATSC_ADDR_2009                                                         0x18154024
#define  ATSC_ADDR_2009_reg_addr                                                 "0xB8154024"
#define  ATSC_ADDR_2009_reg                                                      0xB8154024
#define  ATSC_ADDR_2009_inst_addr                                                "0x0004"
#define  set_ATSC_ADDR_2009_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2009_reg)=data)
#define  get_ATSC_ADDR_2009_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2009_reg))
#define  ATSC_ADDR_2009_opt_rf_aagc_oe_shift                                     (5)
#define  ATSC_ADDR_2009_opt_rf_aagc_pol_shift                                    (4)
#define  ATSC_ADDR_2009_opt_rf_agc_drive_shift                                   (3)
#define  ATSC_ADDR_2009_opt_rf_aagc_sel_shift                                    (0)
#define  ATSC_ADDR_2009_opt_rf_aagc_oe_mask                                      (0x00000020)
#define  ATSC_ADDR_2009_opt_rf_aagc_pol_mask                                     (0x00000010)
#define  ATSC_ADDR_2009_opt_rf_agc_drive_mask                                    (0x00000008)
#define  ATSC_ADDR_2009_opt_rf_aagc_sel_mask                                     (0x00000007)
#define  ATSC_ADDR_2009_opt_rf_aagc_oe(data)                                     (0x00000020&((data)<<5))
#define  ATSC_ADDR_2009_opt_rf_aagc_pol(data)                                    (0x00000010&((data)<<4))
#define  ATSC_ADDR_2009_opt_rf_agc_drive(data)                                   (0x00000008&((data)<<3))
#define  ATSC_ADDR_2009_opt_rf_aagc_sel(data)                                    (0x00000007&(data))
#define  ATSC_ADDR_2009_get_opt_rf_aagc_oe(data)                                 ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2009_get_opt_rf_aagc_pol(data)                                ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2009_get_opt_rf_agc_drive(data)                               ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2009_get_opt_rf_aagc_sel(data)                                (0x00000007&(data))

#define  ATSC_ADDR_200A                                                         0x18154028
#define  ATSC_ADDR_200A_reg_addr                                                 "0xB8154028"
#define  ATSC_ADDR_200A_reg                                                      0xB8154028
#define  ATSC_ADDR_200A_inst_addr                                                "0x0005"
#define  set_ATSC_ADDR_200A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_200A_reg)=data)
#define  get_ATSC_ADDR_200A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_200A_reg))
#define  ATSC_ADDR_200A_opt_if_aagc_oe_shift                                     (5)
#define  ATSC_ADDR_200A_opt_if_aagc_pol_shift                                    (4)
#define  ATSC_ADDR_200A_opt_if_agc_drive_shift                                   (3)
#define  ATSC_ADDR_200A_opt_if_aagc_sel_shift                                    (0)
#define  ATSC_ADDR_200A_opt_if_aagc_oe_mask                                      (0x00000020)
#define  ATSC_ADDR_200A_opt_if_aagc_pol_mask                                     (0x00000010)
#define  ATSC_ADDR_200A_opt_if_agc_drive_mask                                    (0x00000008)
#define  ATSC_ADDR_200A_opt_if_aagc_sel_mask                                     (0x00000007)
#define  ATSC_ADDR_200A_opt_if_aagc_oe(data)                                     (0x00000020&((data)<<5))
#define  ATSC_ADDR_200A_opt_if_aagc_pol(data)                                    (0x00000010&((data)<<4))
#define  ATSC_ADDR_200A_opt_if_agc_drive(data)                                   (0x00000008&((data)<<3))
#define  ATSC_ADDR_200A_opt_if_aagc_sel(data)                                    (0x00000007&(data))
#define  ATSC_ADDR_200A_get_opt_if_aagc_oe(data)                                 ((0x00000020&(data))>>5)
#define  ATSC_ADDR_200A_get_opt_if_aagc_pol(data)                                ((0x00000010&(data))>>4)
#define  ATSC_ADDR_200A_get_opt_if_agc_drive(data)                               ((0x00000008&(data))>>3)
#define  ATSC_ADDR_200A_get_opt_if_aagc_sel(data)                                (0x00000007&(data))

#define  ATSC_ADDR_200B                                                         0x1815402C
#define  ATSC_ADDR_200B_reg_addr                                                 "0xB815402C"
#define  ATSC_ADDR_200B_reg                                                      0xB815402C
#define  ATSC_ADDR_200B_inst_addr                                                "0x0006"
#define  set_ATSC_ADDR_200B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_200B_reg)=data)
#define  get_ATSC_ADDR_200B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_200B_reg))
#define  ATSC_ADDR_200B_opt_mpeg_out_reg_4_0_shift                               (3)
#define  ATSC_ADDR_200B_opt_mpeg_out_sel_shift                                   (0)
#define  ATSC_ADDR_200B_opt_mpeg_out_reg_4_0_mask                                (0x000000F8)
#define  ATSC_ADDR_200B_opt_mpeg_out_sel_mask                                    (0x00000007)
#define  ATSC_ADDR_200B_opt_mpeg_out_reg_4_0(data)                               (0x000000F8&((data)<<3))
#define  ATSC_ADDR_200B_opt_mpeg_out_sel(data)                                   (0x00000007&(data))
#define  ATSC_ADDR_200B_get_opt_mpeg_out_reg_4_0(data)                           ((0x000000F8&(data))>>3)
#define  ATSC_ADDR_200B_get_opt_mpeg_out_sel(data)                               (0x00000007&(data))

#define  ATSC_ADDR_200C                                                         0x18154030
#define  ATSC_ADDR_200C_reg_addr                                                 "0xB8154030"
#define  ATSC_ADDR_200C_reg                                                      0xB8154030
#define  ATSC_ADDR_200C_inst_addr                                                "0x0007"
#define  set_ATSC_ADDR_200C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_200C_reg)=data)
#define  get_ATSC_ADDR_200C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_200C_reg))
#define  ATSC_ADDR_200C_opt_mpeg_out_reg_11_5_shift                              (0)
#define  ATSC_ADDR_200C_opt_mpeg_out_reg_11_5_mask                               (0x0000007F)
#define  ATSC_ADDR_200C_opt_mpeg_out_reg_11_5(data)                              (0x0000007F&(data))
#define  ATSC_ADDR_200C_get_opt_mpeg_out_reg_11_5(data)                          (0x0000007F&(data))

#define  ATSC_ADDR_200D                                                         0x18154034
#define  ATSC_ADDR_200D_reg_addr                                                 "0xB8154034"
#define  ATSC_ADDR_200D_reg                                                      0xB8154034
#define  ATSC_ADDR_200D_inst_addr                                                "0x0008"
#define  set_ATSC_ADDR_200D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_200D_reg)=data)
#define  get_ATSC_ADDR_200D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_200D_reg))
#define  ATSC_ADDR_200D_opt_mpeg_out2_reg_4_0_shift                              (3)
#define  ATSC_ADDR_200D_opt_mpeg_out2_sel_shift                                  (0)
#define  ATSC_ADDR_200D_opt_mpeg_out2_reg_4_0_mask                               (0x000000F8)
#define  ATSC_ADDR_200D_opt_mpeg_out2_sel_mask                                   (0x00000007)
#define  ATSC_ADDR_200D_opt_mpeg_out2_reg_4_0(data)                              (0x000000F8&((data)<<3))
#define  ATSC_ADDR_200D_opt_mpeg_out2_sel(data)                                  (0x00000007&(data))
#define  ATSC_ADDR_200D_get_opt_mpeg_out2_reg_4_0(data)                          ((0x000000F8&(data))>>3)
#define  ATSC_ADDR_200D_get_opt_mpeg_out2_sel(data)                              (0x00000007&(data))

#define  ATSC_ADDR_200E                                                         0x18154038
#define  ATSC_ADDR_200E_reg_addr                                                 "0xB8154038"
#define  ATSC_ADDR_200E_reg                                                      0xB8154038
#define  ATSC_ADDR_200E_inst_addr                                                "0x0009"
#define  set_ATSC_ADDR_200E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_200E_reg)=data)
#define  get_ATSC_ADDR_200E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_200E_reg))
#define  ATSC_ADDR_200E_opt_mpeg_out2_reg_11_5_shift                             (0)
#define  ATSC_ADDR_200E_opt_mpeg_out2_reg_11_5_mask                              (0x0000007F)
#define  ATSC_ADDR_200E_opt_mpeg_out2_reg_11_5(data)                             (0x0000007F&(data))
#define  ATSC_ADDR_200E_get_opt_mpeg_out2_reg_11_5(data)                         (0x0000007F&(data))

#define  ATSC_ADDR_2010                                                         0x18154040
#define  ATSC_ADDR_2010_reg_addr                                                 "0xB8154040"
#define  ATSC_ADDR_2010_reg                                                      0xB8154040
#define  ATSC_ADDR_2010_inst_addr                                                "0x000A"
#define  set_ATSC_ADDR_2010_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2010_reg)=data)
#define  get_ATSC_ADDR_2010_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2010_reg))
#define  ATSC_ADDR_2010_opt_top_ant_rx_in_sel_shift                              (3)
#define  ATSC_ADDR_2010_opt_top_ant_tx_in_sel_shift                              (0)
#define  ATSC_ADDR_2010_opt_top_ant_rx_in_sel_mask                               (0x00000038)
#define  ATSC_ADDR_2010_opt_top_ant_tx_in_sel_mask                               (0x00000007)
#define  ATSC_ADDR_2010_opt_top_ant_rx_in_sel(data)                              (0x00000038&((data)<<3))
#define  ATSC_ADDR_2010_opt_top_ant_tx_in_sel(data)                              (0x00000007&(data))
#define  ATSC_ADDR_2010_get_opt_top_ant_rx_in_sel(data)                          ((0x00000038&(data))>>3)
#define  ATSC_ADDR_2010_get_opt_top_ant_tx_in_sel(data)                          (0x00000007&(data))

#define  ATSC_ADDR_2011                                                         0x18154044
#define  ATSC_ADDR_2011_reg_addr                                                 "0xB8154044"
#define  ATSC_ADDR_2011_reg                                                      0xB8154044
#define  ATSC_ADDR_2011_inst_addr                                                "0x000B"
#define  set_ATSC_ADDR_2011_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2011_reg)=data)
#define  get_ATSC_ADDR_2011_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2011_reg))
#define  ATSC_ADDR_2011_opt_top_ant_oe_in_sel_shift                              (3)
#define  ATSC_ADDR_2011_opt_top_ant_det_sel_shift                                (0)
#define  ATSC_ADDR_2011_opt_top_ant_oe_in_sel_mask                               (0x00000038)
#define  ATSC_ADDR_2011_opt_top_ant_det_sel_mask                                 (0x00000007)
#define  ATSC_ADDR_2011_opt_top_ant_oe_in_sel(data)                              (0x00000038&((data)<<3))
#define  ATSC_ADDR_2011_opt_top_ant_det_sel(data)                                (0x00000007&(data))
#define  ATSC_ADDR_2011_get_opt_top_ant_oe_in_sel(data)                          ((0x00000038&(data))>>3)
#define  ATSC_ADDR_2011_get_opt_top_ant_det_sel(data)                            (0x00000007&(data))

#define  ATSC_ADDR_2013                                                         0x1815404C
#define  ATSC_ADDR_2013_reg_addr                                                 "0xB815404C"
#define  ATSC_ADDR_2013_reg                                                      0xB815404C
#define  ATSC_ADDR_2013_inst_addr                                                "0x000C"
#define  set_ATSC_ADDR_2013_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2013_reg)=data)
#define  get_ATSC_ADDR_2013_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2013_reg))
#define  ATSC_ADDR_2013_opt_par_saclk_shift                                      (5)
#define  ATSC_ADDR_2013_opt_par_tstclk_shift                                     (4)
#define  ATSC_ADDR_2013_opt_sa_clk_sel_shift                                     (2)
#define  ATSC_ADDR_2013_opt_tst_clk_sel_shift                                    (0)
#define  ATSC_ADDR_2013_opt_par_saclk_mask                                       (0x00000020)
#define  ATSC_ADDR_2013_opt_par_tstclk_mask                                      (0x00000010)
#define  ATSC_ADDR_2013_opt_sa_clk_sel_mask                                      (0x0000000C)
#define  ATSC_ADDR_2013_opt_tst_clk_sel_mask                                     (0x00000003)
#define  ATSC_ADDR_2013_opt_par_saclk(data)                                      (0x00000020&((data)<<5))
#define  ATSC_ADDR_2013_opt_par_tstclk(data)                                     (0x00000010&((data)<<4))
#define  ATSC_ADDR_2013_opt_sa_clk_sel(data)                                     (0x0000000C&((data)<<2))
#define  ATSC_ADDR_2013_opt_tst_clk_sel(data)                                    (0x00000003&(data))
#define  ATSC_ADDR_2013_get_opt_par_saclk(data)                                  ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2013_get_opt_par_tstclk(data)                                 ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2013_get_opt_sa_clk_sel(data)                                 ((0x0000000C&(data))>>2)
#define  ATSC_ADDR_2013_get_opt_tst_clk_sel(data)                                (0x00000003&(data))

#define  ATSC_ADDR_2014                                                         0x18154050
#define  ATSC_ADDR_2014_reg_addr                                                 "0xB8154050"
#define  ATSC_ADDR_2014_reg                                                      0xB8154050
#define  ATSC_ADDR_2014_inst_addr                                                "0x000D"
#define  set_ATSC_ADDR_2014_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2014_reg)=data)
#define  get_ATSC_ADDR_2014_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2014_reg))
#define  ATSC_ADDR_2014_opt_atsc_tstmux2_sel_shift                               (4)
#define  ATSC_ADDR_2014_opt_atsc_tstmux1_sel_shift                               (0)
#define  ATSC_ADDR_2014_opt_atsc_tstmux2_sel_mask                                (0x000000F0)
#define  ATSC_ADDR_2014_opt_atsc_tstmux1_sel_mask                                (0x0000000F)
#define  ATSC_ADDR_2014_opt_atsc_tstmux2_sel(data)                               (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2014_opt_atsc_tstmux1_sel(data)                               (0x0000000F&(data))
#define  ATSC_ADDR_2014_get_opt_atsc_tstmux2_sel(data)                           ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2014_get_opt_atsc_tstmux1_sel(data)                           (0x0000000F&(data))

#define  ATSC_ADDR_2016                                                         0x18154058
#define  ATSC_ADDR_2016_reg_addr                                                 "0xB8154058"
#define  ATSC_ADDR_2016_reg                                                      0xB8154058
#define  ATSC_ADDR_2016_inst_addr                                                "0x000E"
#define  set_ATSC_ADDR_2016_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2016_reg)=data)
#define  get_ATSC_ADDR_2016_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2016_reg))
#define  ATSC_ADDR_2016_opt_tst_in_sel_shift                                     (0)
#define  ATSC_ADDR_2016_opt_tst_in_sel_mask                                      (0x0000000F)
#define  ATSC_ADDR_2016_opt_tst_in_sel(data)                                     (0x0000000F&(data))
#define  ATSC_ADDR_2016_get_opt_tst_in_sel(data)                                 (0x0000000F&(data))

#define  ATSC_ADDR_2017                                                         0x1815405C
#define  ATSC_ADDR_2017_reg_addr                                                 "0xB815405C"
#define  ATSC_ADDR_2017_reg                                                      0xB815405C
#define  ATSC_ADDR_2017_inst_addr                                                "0x000F"
#define  set_ATSC_ADDR_2017_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2017_reg)=data)
#define  get_ATSC_ADDR_2017_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2017_reg))
#define  ATSC_ADDR_2017_opt_debug_all_sel_shift                                  (0)
#define  ATSC_ADDR_2017_opt_debug_all_sel_mask                                   (0x0000001F)
#define  ATSC_ADDR_2017_opt_debug_all_sel(data)                                  (0x0000001F&(data))
#define  ATSC_ADDR_2017_get_opt_debug_all_sel(data)                              (0x0000001F&(data))

#define  ATSC_ADDR_2018                                                         0x18154060
#define  ATSC_ADDR_2018_reg_addr                                                 "0xB8154060"
#define  ATSC_ADDR_2018_reg                                                      0xB8154060
#define  ATSC_ADDR_2018_inst_addr                                                "0x0010"
#define  set_ATSC_ADDR_2018_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2018_reg)=data)
#define  get_ATSC_ADDR_2018_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2018_reg))
#define  ATSC_ADDR_2018_opt_debug_all_reg_7_0_shift                              (0)
#define  ATSC_ADDR_2018_opt_debug_all_reg_7_0_mask                               (0x000000FF)
#define  ATSC_ADDR_2018_opt_debug_all_reg_7_0(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_2018_get_opt_debug_all_reg_7_0(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_2019                                                         0x18154064
#define  ATSC_ADDR_2019_reg_addr                                                 "0xB8154064"
#define  ATSC_ADDR_2019_reg                                                      0xB8154064
#define  ATSC_ADDR_2019_inst_addr                                                "0x0011"
#define  set_ATSC_ADDR_2019_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2019_reg)=data)
#define  get_ATSC_ADDR_2019_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2019_reg))
#define  ATSC_ADDR_2019_opt_debug_all_reg_15_8_shift                             (0)
#define  ATSC_ADDR_2019_opt_debug_all_reg_15_8_mask                              (0x000000FF)
#define  ATSC_ADDR_2019_opt_debug_all_reg_15_8(data)                             (0x000000FF&(data))
#define  ATSC_ADDR_2019_get_opt_debug_all_reg_15_8(data)                         (0x000000FF&(data))

#define  ATSC_ADDR_201A                                                         0x18154068
#define  ATSC_ADDR_201A_reg_addr                                                 "0xB8154068"
#define  ATSC_ADDR_201A_reg                                                      0xB8154068
#define  ATSC_ADDR_201A_inst_addr                                                "0x0012"
#define  set_ATSC_ADDR_201A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_201A_reg)=data)
#define  get_ATSC_ADDR_201A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_201A_reg))
#define  ATSC_ADDR_201A_opt_debug_all_reg_23_16_shift                            (0)
#define  ATSC_ADDR_201A_opt_debug_all_reg_23_16_mask                             (0x000000FF)
#define  ATSC_ADDR_201A_opt_debug_all_reg_23_16(data)                            (0x000000FF&(data))
#define  ATSC_ADDR_201A_get_opt_debug_all_reg_23_16(data)                        (0x000000FF&(data))

#define  ATSC_ADDR_201B                                                         0x1815406C
#define  ATSC_ADDR_201B_reg_addr                                                 "0xB815406C"
#define  ATSC_ADDR_201B_reg                                                      0xB815406C
#define  ATSC_ADDR_201B_inst_addr                                                "0x0013"
#define  set_ATSC_ADDR_201B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_201B_reg)=data)
#define  get_ATSC_ADDR_201B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_201B_reg))
#define  ATSC_ADDR_201B_opt_debug_all_reg_31_24_shift                            (0)
#define  ATSC_ADDR_201B_opt_debug_all_reg_31_24_mask                             (0x000000FF)
#define  ATSC_ADDR_201B_opt_debug_all_reg_31_24(data)                            (0x000000FF&(data))
#define  ATSC_ADDR_201B_get_opt_debug_all_reg_31_24(data)                        (0x000000FF&(data))

#define  ATSC_ADDR_201C                                                         0x18154070
#define  ATSC_ADDR_201C_reg_addr                                                 "0xB8154070"
#define  ATSC_ADDR_201C_reg                                                      0xB8154070
#define  ATSC_ADDR_201C_inst_addr                                                "0x0014"
#define  set_ATSC_ADDR_201C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_201C_reg)=data)
#define  get_ATSC_ADDR_201C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_201C_reg))
#define  ATSC_ADDR_201C_opt_debug_all_reg_39_32_shift                            (0)
#define  ATSC_ADDR_201C_opt_debug_all_reg_39_32_mask                             (0x000000FF)
#define  ATSC_ADDR_201C_opt_debug_all_reg_39_32(data)                            (0x000000FF&(data))
#define  ATSC_ADDR_201C_get_opt_debug_all_reg_39_32(data)                        (0x000000FF&(data))

#define  ATSC_ADDR_201D                                                         0x18154074
#define  ATSC_ADDR_201D_reg_addr                                                 "0xB8154074"
#define  ATSC_ADDR_201D_reg                                                      0xB8154074
#define  ATSC_ADDR_201D_inst_addr                                                "0x0015"
#define  set_ATSC_ADDR_201D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_201D_reg)=data)
#define  get_ATSC_ADDR_201D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_201D_reg))
#define  ATSC_ADDR_201D_opt_debug_all_reg_47_40_shift                            (0)
#define  ATSC_ADDR_201D_opt_debug_all_reg_47_40_mask                             (0x000000FF)
#define  ATSC_ADDR_201D_opt_debug_all_reg_47_40(data)                            (0x000000FF&(data))
#define  ATSC_ADDR_201D_get_opt_debug_all_reg_47_40(data)                        (0x000000FF&(data))

#define  ATSC_ADDR_202A                                                         0x181540A8
#define  ATSC_ADDR_202A_reg_addr                                                 "0xB81540A8"
#define  ATSC_ADDR_202A_reg                                                      0xB81540A8
#define  ATSC_ADDR_202A_inst_addr                                                "0x0016"
#define  set_ATSC_ADDR_202A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_202A_reg)=data)
#define  get_ATSC_ADDR_202A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_202A_reg))
#define  ATSC_ADDR_202A_atsc_dummy_rw_reg_5_0_shift                              (2)
#define  ATSC_ADDR_202A_fs2_auto_switch_result_shift                             (0)
#define  ATSC_ADDR_202A_atsc_dummy_rw_reg_5_0_mask                               (0x000000FC)
#define  ATSC_ADDR_202A_fs2_auto_switch_result_mask                              (0x00000003)
#define  ATSC_ADDR_202A_atsc_dummy_rw_reg_5_0(data)                              (0x000000FC&((data)<<2))
#define  ATSC_ADDR_202A_fs2_auto_switch_result(data)                             (0x00000003&(data))
#define  ATSC_ADDR_202A_get_atsc_dummy_rw_reg_5_0(data)                          ((0x000000FC&(data))>>2)
#define  ATSC_ADDR_202A_get_fs2_auto_switch_result(data)                         (0x00000003&(data))

#define  ATSC_ADDR_202B                                                         0x181540AC
#define  ATSC_ADDR_202B_reg_addr                                                 "0xB81540AC"
#define  ATSC_ADDR_202B_reg                                                      0xB81540AC
#define  ATSC_ADDR_202B_inst_addr                                                "0x0017"
#define  set_ATSC_ADDR_202B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_202B_reg)=data)
#define  get_ATSC_ADDR_202B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_202B_reg))
#define  ATSC_ADDR_202B_atsc_dummy_rw_reg_13_6_shift                             (0)
#define  ATSC_ADDR_202B_atsc_dummy_rw_reg_13_6_mask                              (0x000000FF)
#define  ATSC_ADDR_202B_atsc_dummy_rw_reg_13_6(data)                             (0x000000FF&(data))
#define  ATSC_ADDR_202B_get_atsc_dummy_rw_reg_13_6(data)                         (0x000000FF&(data))

#define  ATSC_ADDR_202C                                                         0x181540B0
#define  ATSC_ADDR_202C_reg_addr                                                 "0xB81540B0"
#define  ATSC_ADDR_202C_reg                                                      0xB81540B0
#define  ATSC_ADDR_202C_inst_addr                                                "0x0018"
#define  set_ATSC_ADDR_202C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_202C_reg)=data)
#define  get_ATSC_ADDR_202C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_202C_reg))
#define  ATSC_ADDR_202C_atsc_dummy_rw_reg_21_14_shift                            (0)
#define  ATSC_ADDR_202C_atsc_dummy_rw_reg_21_14_mask                             (0x000000FF)
#define  ATSC_ADDR_202C_atsc_dummy_rw_reg_21_14(data)                            (0x000000FF&(data))
#define  ATSC_ADDR_202C_get_atsc_dummy_rw_reg_21_14(data)                        (0x000000FF&(data))

#define  ATSC_ADDR_2040                                                         0x18154100
#define  ATSC_ADDR_2040_reg_addr                                                 "0xB8154100"
#define  ATSC_ADDR_2040_reg                                                      0xB8154100
#define  ATSC_ADDR_2040_inst_addr                                                "0x0019"
#define  set_ATSC_ADDR_2040_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2040_reg)=data)
#define  get_ATSC_ADDR_2040_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2040_reg))
#define  ATSC_ADDR_2040_opt_demod_int_n_inv_shift                                (3)
#define  ATSC_ADDR_2040_opt_demod_int_n_sel_shift                                (0)
#define  ATSC_ADDR_2040_opt_demod_int_n_inv_mask                                 (0x00000008)
#define  ATSC_ADDR_2040_opt_demod_int_n_sel_mask                                 (0x00000007)
#define  ATSC_ADDR_2040_opt_demod_int_n_inv(data)                                (0x00000008&((data)<<3))
#define  ATSC_ADDR_2040_opt_demod_int_n_sel(data)                                (0x00000007&(data))
#define  ATSC_ADDR_2040_get_opt_demod_int_n_inv(data)                            ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2040_get_opt_demod_int_n_sel(data)                            (0x00000007&(data))

#define  ATSC_ADDR_2051                                                         0x18154144
#define  ATSC_ADDR_2051_reg_addr                                                 "0xB8154144"
#define  ATSC_ADDR_2051_reg                                                      0xB8154144
#define  ATSC_ADDR_2051_inst_addr                                                "0x001A"
#define  set_ATSC_ADDR_2051_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2051_reg)=data)
#define  get_ATSC_ADDR_2051_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2051_reg))
#define  ATSC_ADDR_2051_atsc_if_agc_oe_shift                                     (3)
#define  ATSC_ADDR_2051_atsc_if_agc_o_shift                                      (2)
#define  ATSC_ADDR_2051_atsc_rf_agc_oe_shift                                     (1)
#define  ATSC_ADDR_2051_atsc_rf_agc_o_shift                                      (0)
#define  ATSC_ADDR_2051_atsc_if_agc_oe_mask                                      (0x00000008)
#define  ATSC_ADDR_2051_atsc_if_agc_o_mask                                       (0x00000004)
#define  ATSC_ADDR_2051_atsc_rf_agc_oe_mask                                      (0x00000002)
#define  ATSC_ADDR_2051_atsc_rf_agc_o_mask                                       (0x00000001)
#define  ATSC_ADDR_2051_atsc_if_agc_oe(data)                                     (0x00000008&((data)<<3))
#define  ATSC_ADDR_2051_atsc_if_agc_o(data)                                      (0x00000004&((data)<<2))
#define  ATSC_ADDR_2051_atsc_rf_agc_oe(data)                                     (0x00000002&((data)<<1))
#define  ATSC_ADDR_2051_atsc_rf_agc_o(data)                                      (0x00000001&(data))
#define  ATSC_ADDR_2051_get_atsc_if_agc_oe(data)                                 ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2051_get_atsc_if_agc_o(data)                                  ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2051_get_atsc_rf_agc_oe(data)                                 ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2051_get_atsc_rf_agc_o(data)                                  (0x00000001&(data))

#define  ATSC_ADDR_2052                                                         0x18154148
#define  ATSC_ADDR_2052_reg_addr                                                 "0xB8154148"
#define  ATSC_ADDR_2052_reg                                                      0xB8154148
#define  ATSC_ADDR_2052_inst_addr                                                "0x001B"
#define  set_ATSC_ADDR_2052_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2052_reg)=data)
#define  get_ATSC_ADDR_2052_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2052_reg))
#define  ATSC_ADDR_2052_atsc_ant_det_shift                                       (6)
#define  ATSC_ADDR_2052_atsc_ant_rx_in_shift                                     (5)
#define  ATSC_ADDR_2052_atsc_ant_tx_in_shift                                     (4)
#define  ATSC_ADDR_2052_atsc_ant_oe_oe_shift                                     (3)
#define  ATSC_ADDR_2052_atsc_ant_oe_shift                                        (2)
#define  ATSC_ADDR_2052_atsc_ant_tx_oe_shift                                     (1)
#define  ATSC_ADDR_2052_atsc_ant_tx_shift                                        (0)
#define  ATSC_ADDR_2052_atsc_ant_det_mask                                        (0x00000040)
#define  ATSC_ADDR_2052_atsc_ant_rx_in_mask                                      (0x00000020)
#define  ATSC_ADDR_2052_atsc_ant_tx_in_mask                                      (0x00000010)
#define  ATSC_ADDR_2052_atsc_ant_oe_oe_mask                                      (0x00000008)
#define  ATSC_ADDR_2052_atsc_ant_oe_mask                                         (0x00000004)
#define  ATSC_ADDR_2052_atsc_ant_tx_oe_mask                                      (0x00000002)
#define  ATSC_ADDR_2052_atsc_ant_tx_mask                                         (0x00000001)
#define  ATSC_ADDR_2052_atsc_ant_det(data)                                       (0x00000040&((data)<<6))
#define  ATSC_ADDR_2052_atsc_ant_rx_in(data)                                     (0x00000020&((data)<<5))
#define  ATSC_ADDR_2052_atsc_ant_tx_in(data)                                     (0x00000010&((data)<<4))
#define  ATSC_ADDR_2052_atsc_ant_oe_oe(data)                                     (0x00000008&((data)<<3))
#define  ATSC_ADDR_2052_atsc_ant_oe(data)                                        (0x00000004&((data)<<2))
#define  ATSC_ADDR_2052_atsc_ant_tx_oe(data)                                     (0x00000002&((data)<<1))
#define  ATSC_ADDR_2052_atsc_ant_tx(data)                                        (0x00000001&(data))
#define  ATSC_ADDR_2052_get_atsc_ant_det(data)                                   ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2052_get_atsc_ant_rx_in(data)                                 ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2052_get_atsc_ant_tx_in(data)                                 ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2052_get_atsc_ant_oe_oe(data)                                 ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2052_get_atsc_ant_oe(data)                                    ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2052_get_atsc_ant_tx_oe(data)                                 ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2052_get_atsc_ant_tx(data)                                    (0x00000001&(data))

#define  ATSC_ADDR_205C                                                         0x18154170
#define  ATSC_ADDR_205C_reg_addr                                                 "0xB8154170"
#define  ATSC_ADDR_205C_reg                                                      0xB8154170
#define  ATSC_ADDR_205C_inst_addr                                                "0x001C"
#define  set_ATSC_ADDR_205C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_205C_reg)=data)
#define  get_ATSC_ADDR_205C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_205C_reg))
#define  ATSC_ADDR_205C_rssi_agc_level_q_7_0_shift                               (0)
#define  ATSC_ADDR_205C_rssi_agc_level_q_7_0_mask                                (0x000000FF)
#define  ATSC_ADDR_205C_rssi_agc_level_q_7_0(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_205C_get_rssi_agc_level_q_7_0(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_205D                                                         0x18154174
#define  ATSC_ADDR_205D_reg_addr                                                 "0xB8154174"
#define  ATSC_ADDR_205D_reg                                                      0xB8154174
#define  ATSC_ADDR_205D_inst_addr                                                "0x001D"
#define  set_ATSC_ADDR_205D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_205D_reg)=data)
#define  get_ATSC_ADDR_205D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_205D_reg))
#define  ATSC_ADDR_205D_rssi_agc_loop_sat_d_shift                                (6)
#define  ATSC_ADDR_205D_rssi_agc_level_q_13_8_shift                              (0)
#define  ATSC_ADDR_205D_rssi_agc_loop_sat_d_mask                                 (0x00000040)
#define  ATSC_ADDR_205D_rssi_agc_level_q_13_8_mask                               (0x0000003F)
#define  ATSC_ADDR_205D_rssi_agc_loop_sat_d(data)                                (0x00000040&((data)<<6))
#define  ATSC_ADDR_205D_rssi_agc_level_q_13_8(data)                              (0x0000003F&(data))
#define  ATSC_ADDR_205D_get_rssi_agc_loop_sat_d(data)                            ((0x00000040&(data))>>6)
#define  ATSC_ADDR_205D_get_rssi_agc_level_q_13_8(data)                          (0x0000003F&(data))

#define  ATSC_ADDR_205E                                                         0x18154178
#define  ATSC_ADDR_205E_reg_addr                                                 "0xB8154178"
#define  ATSC_ADDR_205E_reg                                                      0xB8154178
#define  ATSC_ADDR_205E_inst_addr                                                "0x001E"
#define  set_ATSC_ADDR_205E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_205E_reg)=data)
#define  get_ATSC_ADDR_205E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_205E_reg))
#define  ATSC_ADDR_205E_ad7_out_d_shift                                          (0)
#define  ATSC_ADDR_205E_ad7_out_d_mask                                           (0x0000007F)
#define  ATSC_ADDR_205E_ad7_out_d(data)                                          (0x0000007F&(data))
#define  ATSC_ADDR_205E_get_ad7_out_d(data)                                      (0x0000007F&(data))

#define  ATSC_ADDR_2080                                                         0x18154200
#define  ATSC_ADDR_2080_reg_addr                                                 "0xB8154200"
#define  ATSC_ADDR_2080_reg                                                      0xB8154200
#define  ATSC_ADDR_2080_inst_addr                                                "0x001F"
#define  set_ATSC_ADDR_2080_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2080_reg)=data)
#define  get_ATSC_ADDR_2080_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2080_reg))
#define  ATSC_ADDR_2080_opt_soft_reset_rssi_agc_shift                            (0)
#define  ATSC_ADDR_2080_opt_soft_reset_rssi_agc_mask                             (0x00000001)
#define  ATSC_ADDR_2080_opt_soft_reset_rssi_agc(data)                            (0x00000001&(data))
#define  ATSC_ADDR_2080_get_opt_soft_reset_rssi_agc(data)                        (0x00000001&(data))

#define  ATSC_ADDR_2081                                                         0x18154204
#define  ATSC_ADDR_2081_reg_addr                                                 "0xB8154204"
#define  ATSC_ADDR_2081_reg                                                      0xB8154204
#define  ATSC_ADDR_2081_inst_addr                                                "0x0020"
#define  set_ATSC_ADDR_2081_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2081_reg)=data)
#define  get_ATSC_ADDR_2081_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2081_reg))
#define  ATSC_ADDR_2081_rssi_in_ph_sel2_shift                                    (7)
#define  ATSC_ADDR_2081_opt_ad7_ckout_inv_shift                                  (6)
#define  ATSC_ADDR_2081_rssi_agc_pol_shift                                       (5)
#define  ATSC_ADDR_2081_u_rssi_agc_exp_shift                                     (2)
#define  ATSC_ADDR_2081_rssi_in_ph_sel_shift                                     (1)
#define  ATSC_ADDR_2081_opt_rssi_agc_on_shift                                    (0)
#define  ATSC_ADDR_2081_rssi_in_ph_sel2_mask                                     (0x00000080)
#define  ATSC_ADDR_2081_opt_ad7_ckout_inv_mask                                   (0x00000040)
#define  ATSC_ADDR_2081_rssi_agc_pol_mask                                        (0x00000020)
#define  ATSC_ADDR_2081_u_rssi_agc_exp_mask                                      (0x0000001C)
#define  ATSC_ADDR_2081_rssi_in_ph_sel_mask                                      (0x00000002)
#define  ATSC_ADDR_2081_opt_rssi_agc_on_mask                                     (0x00000001)
#define  ATSC_ADDR_2081_rssi_in_ph_sel2(data)                                    (0x00000080&((data)<<7))
#define  ATSC_ADDR_2081_opt_ad7_ckout_inv(data)                                  (0x00000040&((data)<<6))
#define  ATSC_ADDR_2081_rssi_agc_pol(data)                                       (0x00000020&((data)<<5))
#define  ATSC_ADDR_2081_u_rssi_agc_exp(data)                                     (0x0000001C&((data)<<2))
#define  ATSC_ADDR_2081_rssi_in_ph_sel(data)                                     (0x00000002&((data)<<1))
#define  ATSC_ADDR_2081_opt_rssi_agc_on(data)                                    (0x00000001&(data))
#define  ATSC_ADDR_2081_get_rssi_in_ph_sel2(data)                                ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2081_get_opt_ad7_ckout_inv(data)                              ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2081_get_rssi_agc_pol(data)                                   ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2081_get_u_rssi_agc_exp(data)                                 ((0x0000001C&(data))>>2)
#define  ATSC_ADDR_2081_get_rssi_in_ph_sel(data)                                 ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2081_get_opt_rssi_agc_on(data)                                (0x00000001&(data))

#define  ATSC_ADDR_2082                                                         0x18154208
#define  ATSC_ADDR_2082_reg_addr                                                 "0xB8154208"
#define  ATSC_ADDR_2082_reg                                                      0xB8154208
#define  ATSC_ADDR_2082_inst_addr                                                "0x0021"
#define  set_ATSC_ADDR_2082_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2082_reg)=data)
#define  get_ATSC_ADDR_2082_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2082_reg))
#define  ATSC_ADDR_2082_rssi_in_clk_ratio_shift                                  (0)
#define  ATSC_ADDR_2082_rssi_in_clk_ratio_mask                                   (0x000000FF)
#define  ATSC_ADDR_2082_rssi_in_clk_ratio(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2082_get_rssi_in_clk_ratio(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2083                                                         0x1815420C
#define  ATSC_ADDR_2083_reg_addr                                                 "0xB815420C"
#define  ATSC_ADDR_2083_reg                                                      0xB815420C
#define  ATSC_ADDR_2083_inst_addr                                                "0x0022"
#define  set_ATSC_ADDR_2083_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2083_reg)=data)
#define  get_ATSC_ADDR_2083_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2083_reg))
#define  ATSC_ADDR_2083_rssi_agc_max_shift                                       (0)
#define  ATSC_ADDR_2083_rssi_agc_max_mask                                        (0x000000FF)
#define  ATSC_ADDR_2083_rssi_agc_max(data)                                       (0x000000FF&(data))
#define  ATSC_ADDR_2083_get_rssi_agc_max(data)                                   (0x000000FF&(data))

#define  ATSC_ADDR_2084                                                         0x18154210
#define  ATSC_ADDR_2084_reg_addr                                                 "0xB8154210"
#define  ATSC_ADDR_2084_reg                                                      0xB8154210
#define  ATSC_ADDR_2084_inst_addr                                                "0x0023"
#define  set_ATSC_ADDR_2084_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2084_reg)=data)
#define  get_ATSC_ADDR_2084_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2084_reg))
#define  ATSC_ADDR_2084_rssi_agc_min_shift                                       (0)
#define  ATSC_ADDR_2084_rssi_agc_min_mask                                        (0x000000FF)
#define  ATSC_ADDR_2084_rssi_agc_min(data)                                       (0x000000FF&(data))
#define  ATSC_ADDR_2084_get_rssi_agc_min(data)                                   (0x000000FF&(data))

#define  ATSC_ADDR_2085                                                         0x18154214
#define  ATSC_ADDR_2085_reg_addr                                                 "0xB8154214"
#define  ATSC_ADDR_2085_reg                                                      0xB8154214
#define  ATSC_ADDR_2085_inst_addr                                                "0x0024"
#define  set_ATSC_ADDR_2085_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2085_reg)=data)
#define  get_ATSC_ADDR_2085_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2085_reg))
#define  ATSC_ADDR_2085_rssi_agc_targ_val_shift                                  (0)
#define  ATSC_ADDR_2085_rssi_agc_targ_val_mask                                   (0x0000007F)
#define  ATSC_ADDR_2085_rssi_agc_targ_val(data)                                  (0x0000007F&(data))
#define  ATSC_ADDR_2085_get_rssi_agc_targ_val(data)                              (0x0000007F&(data))

#define  ATSC_ADDR_2090                                                         0x18154240
#define  ATSC_ADDR_2090_reg_addr                                                 "0xB8154240"
#define  ATSC_ADDR_2090_reg                                                      0xB8154240
#define  ATSC_ADDR_2090_inst_addr                                                "0x0025"
#define  set_ATSC_ADDR_2090_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2090_reg)=data)
#define  get_ATSC_ADDR_2090_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2090_reg))
#define  ATSC_ADDR_2090_mh_in_sel_shift                                          (1)
#define  ATSC_ADDR_2090_mh_out_en_shift                                          (0)
#define  ATSC_ADDR_2090_mh_in_sel_mask                                           (0x0000000E)
#define  ATSC_ADDR_2090_mh_out_en_mask                                           (0x00000001)
#define  ATSC_ADDR_2090_mh_in_sel(data)                                          (0x0000000E&((data)<<1))
#define  ATSC_ADDR_2090_mh_out_en(data)                                          (0x00000001&(data))
#define  ATSC_ADDR_2090_get_mh_in_sel(data)                                      ((0x0000000E&(data))>>1)
#define  ATSC_ADDR_2090_get_mh_out_en(data)                                      (0x00000001&(data))

#define  ATSC_ADDR_20A0                                                         0x18154280
#define  ATSC_ADDR_20A0_reg_addr                                                 "0xB8154280"
#define  ATSC_ADDR_20A0_reg                                                      0xB8154280
#define  ATSC_ADDR_20A0_inst_addr                                                "0x0026"
#define  set_ATSC_ADDR_20A0_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20A0_reg)=data)
#define  get_ATSC_ADDR_20A0_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20A0_reg))
#define  ATSC_ADDR_20A0_reg_pset_aagc_shift                                      (7)
#define  ATSC_ADDR_20A0_reg_hold_pga_shift                                       (6)
#define  ATSC_ADDR_20A0_reg_aagc_cal_payload_shift                               (5)
#define  ATSC_ADDR_20A0_reg_aagc_hold_shift                                      (4)
#define  ATSC_ADDR_20A0_reg_en_gi_pga_shift                                      (3)
#define  ATSC_ADDR_20A0_reg_en_pga_mode_shift                                    (2)
#define  ATSC_ADDR_20A0_reg_en_dcr_shift                                         (1)
#define  ATSC_ADDR_20A0_reg_adc_clk_xor_shift                                    (0)
#define  ATSC_ADDR_20A0_reg_pset_aagc_mask                                       (0x00000080)
#define  ATSC_ADDR_20A0_reg_hold_pga_mask                                        (0x00000040)
#define  ATSC_ADDR_20A0_reg_aagc_cal_payload_mask                                (0x00000020)
#define  ATSC_ADDR_20A0_reg_aagc_hold_mask                                       (0x00000010)
#define  ATSC_ADDR_20A0_reg_en_gi_pga_mask                                       (0x00000008)
#define  ATSC_ADDR_20A0_reg_en_pga_mode_mask                                     (0x00000004)
#define  ATSC_ADDR_20A0_reg_en_dcr_mask                                          (0x00000002)
#define  ATSC_ADDR_20A0_reg_adc_clk_xor_mask                                     (0x00000001)
#define  ATSC_ADDR_20A0_reg_pset_aagc(data)                                      (0x00000080&((data)<<7))
#define  ATSC_ADDR_20A0_reg_hold_pga(data)                                       (0x00000040&((data)<<6))
#define  ATSC_ADDR_20A0_reg_aagc_cal_payload(data)                               (0x00000020&((data)<<5))
#define  ATSC_ADDR_20A0_reg_aagc_hold(data)                                      (0x00000010&((data)<<4))
#define  ATSC_ADDR_20A0_reg_en_gi_pga(data)                                      (0x00000008&((data)<<3))
#define  ATSC_ADDR_20A0_reg_en_pga_mode(data)                                    (0x00000004&((data)<<2))
#define  ATSC_ADDR_20A0_reg_en_dcr(data)                                         (0x00000002&((data)<<1))
#define  ATSC_ADDR_20A0_reg_adc_clk_xor(data)                                    (0x00000001&(data))
#define  ATSC_ADDR_20A0_get_reg_pset_aagc(data)                                  ((0x00000080&(data))>>7)
#define  ATSC_ADDR_20A0_get_reg_hold_pga(data)                                   ((0x00000040&(data))>>6)
#define  ATSC_ADDR_20A0_get_reg_aagc_cal_payload(data)                           ((0x00000020&(data))>>5)
#define  ATSC_ADDR_20A0_get_reg_aagc_hold(data)                                  ((0x00000010&(data))>>4)
#define  ATSC_ADDR_20A0_get_reg_en_gi_pga(data)                                  ((0x00000008&(data))>>3)
#define  ATSC_ADDR_20A0_get_reg_en_pga_mode(data)                                ((0x00000004&(data))>>2)
#define  ATSC_ADDR_20A0_get_reg_en_dcr(data)                                     ((0x00000002&(data))>>1)
#define  ATSC_ADDR_20A0_get_reg_adc_clk_xor(data)                                (0x00000001&(data))

#define  ATSC_ADDR_20A1                                                         0x18154284
#define  ATSC_ADDR_20A1_reg_addr                                                 "0xB8154284"
#define  ATSC_ADDR_20A1_reg                                                      0xB8154284
#define  ATSC_ADDR_20A1_inst_addr                                                "0x0027"
#define  set_ATSC_ADDR_20A1_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20A1_reg)=data)
#define  get_ATSC_ADDR_20A1_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20A1_reg))
#define  ATSC_ADDR_20A1_reg_pset_aagc_val_shift                                  (0)
#define  ATSC_ADDR_20A1_reg_pset_aagc_val_mask                                   (0x000000FF)
#define  ATSC_ADDR_20A1_reg_pset_aagc_val(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_20A1_get_reg_pset_aagc_val(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_20A2                                                         0x18154288
#define  ATSC_ADDR_20A2_reg_addr                                                 "0xB8154288"
#define  ATSC_ADDR_20A2_reg                                                      0xB8154288
#define  ATSC_ADDR_20A2_inst_addr                                                "0x0028"
#define  set_ATSC_ADDR_20A2_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20A2_reg)=data)
#define  get_ATSC_ADDR_20A2_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20A2_reg))
#define  ATSC_ADDR_20A2_reg_target_val_shift                                     (0)
#define  ATSC_ADDR_20A2_reg_target_val_mask                                      (0x000000FF)
#define  ATSC_ADDR_20A2_reg_target_val(data)                                     (0x000000FF&(data))
#define  ATSC_ADDR_20A2_get_reg_target_val(data)                                 (0x000000FF&(data))

#define  ATSC_ADDR_20A3                                                         0x1815428C
#define  ATSC_ADDR_20A3_reg_addr                                                 "0xB815428C"
#define  ATSC_ADDR_20A3_reg                                                      0xB815428C
#define  ATSC_ADDR_20A3_inst_addr                                                "0x0029"
#define  set_ATSC_ADDR_20A3_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20A3_reg)=data)
#define  get_ATSC_ADDR_20A3_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20A3_reg))
#define  ATSC_ADDR_20A3_reg_aagc_loopgain1_2_0_shift                             (5)
#define  ATSC_ADDR_20A3_reg_aagc_loopgain0_shift                                 (0)
#define  ATSC_ADDR_20A3_reg_aagc_loopgain1_2_0_mask                              (0x000000E0)
#define  ATSC_ADDR_20A3_reg_aagc_loopgain0_mask                                  (0x0000001F)
#define  ATSC_ADDR_20A3_reg_aagc_loopgain1_2_0(data)                             (0x000000E0&((data)<<5))
#define  ATSC_ADDR_20A3_reg_aagc_loopgain0(data)                                 (0x0000001F&(data))
#define  ATSC_ADDR_20A3_get_reg_aagc_loopgain1_2_0(data)                         ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_20A3_get_reg_aagc_loopgain0(data)                             (0x0000001F&(data))

#define  ATSC_ADDR_20A4                                                         0x18154290
#define  ATSC_ADDR_20A4_reg_addr                                                 "0xB8154290"
#define  ATSC_ADDR_20A4_reg                                                      0xB8154290
#define  ATSC_ADDR_20A4_inst_addr                                                "0x002A"
#define  set_ATSC_ADDR_20A4_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20A4_reg)=data)
#define  get_ATSC_ADDR_20A4_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20A4_reg))
#define  ATSC_ADDR_20A4_reg_integral_cnt_len_0_shift                             (7)
#define  ATSC_ADDR_20A4_reg_aagc_loopgain2_shift                                 (2)
#define  ATSC_ADDR_20A4_reg_aagc_loopgain1_4_3_shift                             (0)
#define  ATSC_ADDR_20A4_reg_integral_cnt_len_0_mask                              (0x00000080)
#define  ATSC_ADDR_20A4_reg_aagc_loopgain2_mask                                  (0x0000007C)
#define  ATSC_ADDR_20A4_reg_aagc_loopgain1_4_3_mask                              (0x00000003)
#define  ATSC_ADDR_20A4_reg_integral_cnt_len_0(data)                             (0x00000080&((data)<<7))
#define  ATSC_ADDR_20A4_reg_aagc_loopgain2(data)                                 (0x0000007C&((data)<<2))
#define  ATSC_ADDR_20A4_reg_aagc_loopgain1_4_3(data)                             (0x00000003&(data))
#define  ATSC_ADDR_20A4_get_reg_integral_cnt_len_0(data)                         ((0x00000080&(data))>>7)
#define  ATSC_ADDR_20A4_get_reg_aagc_loopgain2(data)                             ((0x0000007C&(data))>>2)
#define  ATSC_ADDR_20A4_get_reg_aagc_loopgain1_4_3(data)                         (0x00000003&(data))

#define  ATSC_ADDR_20A5                                                         0x18154294
#define  ATSC_ADDR_20A5_reg_addr                                                 "0xB8154294"
#define  ATSC_ADDR_20A5_reg                                                      0xB8154294
#define  ATSC_ADDR_20A5_inst_addr                                                "0x002B"
#define  set_ATSC_ADDR_20A5_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20A5_reg)=data)
#define  get_ATSC_ADDR_20A5_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20A5_reg))
#define  ATSC_ADDR_20A5_reg_aagc_lock_det_len_shift                              (4)
#define  ATSC_ADDR_20A5_reg_integral_cnt_len_4_1_shift                           (0)
#define  ATSC_ADDR_20A5_reg_aagc_lock_det_len_mask                               (0x000000F0)
#define  ATSC_ADDR_20A5_reg_integral_cnt_len_4_1_mask                            (0x0000000F)
#define  ATSC_ADDR_20A5_reg_aagc_lock_det_len(data)                              (0x000000F0&((data)<<4))
#define  ATSC_ADDR_20A5_reg_integral_cnt_len_4_1(data)                           (0x0000000F&(data))
#define  ATSC_ADDR_20A5_get_reg_aagc_lock_det_len(data)                          ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_20A5_get_reg_integral_cnt_len_4_1(data)                       (0x0000000F&(data))

#define  ATSC_ADDR_20A6                                                         0x18154298
#define  ATSC_ADDR_20A6_reg_addr                                                 "0xB8154298"
#define  ATSC_ADDR_20A6_reg                                                      0xB8154298
#define  ATSC_ADDR_20A6_inst_addr                                                "0x002C"
#define  set_ATSC_ADDR_20A6_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20A6_reg)=data)
#define  get_ATSC_ADDR_20A6_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20A6_reg))
#define  ATSC_ADDR_20A6_reg_aagc_latency_7_0_shift                               (0)
#define  ATSC_ADDR_20A6_reg_aagc_latency_7_0_mask                                (0x000000FF)
#define  ATSC_ADDR_20A6_reg_aagc_latency_7_0(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_20A6_get_reg_aagc_latency_7_0(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_20A7                                                         0x1815429C
#define  ATSC_ADDR_20A7_reg_addr                                                 "0xB815429C"
#define  ATSC_ADDR_20A7_reg                                                      0xB815429C
#define  ATSC_ADDR_20A7_inst_addr                                                "0x002D"
#define  set_ATSC_ADDR_20A7_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20A7_reg)=data)
#define  get_ATSC_ADDR_20A7_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20A7_reg))
#define  ATSC_ADDR_20A7_reg_aagc_lock_pga_hit_len_shift                          (5)
#define  ATSC_ADDR_20A7_reg_aagc_latency_12_8_shift                              (0)
#define  ATSC_ADDR_20A7_reg_aagc_lock_pga_hit_len_mask                           (0x000000E0)
#define  ATSC_ADDR_20A7_reg_aagc_latency_12_8_mask                               (0x0000001F)
#define  ATSC_ADDR_20A7_reg_aagc_lock_pga_hit_len(data)                          (0x000000E0&((data)<<5))
#define  ATSC_ADDR_20A7_reg_aagc_latency_12_8(data)                              (0x0000001F&(data))
#define  ATSC_ADDR_20A7_get_reg_aagc_lock_pga_hit_len(data)                      ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_20A7_get_reg_aagc_latency_12_8(data)                          (0x0000001F&(data))

#define  ATSC_ADDR_20A8                                                         0x181542A0
#define  ATSC_ADDR_20A8_reg_addr                                                 "0xB81542A0"
#define  ATSC_ADDR_20A8_reg                                                      0xB81542A0
#define  ATSC_ADDR_20A8_inst_addr                                                "0x002E"
#define  set_ATSC_ADDR_20A8_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20A8_reg)=data)
#define  get_ATSC_ADDR_20A8_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20A8_reg))
#define  ATSC_ADDR_20A8_reg_thd_lock_up_7_0_shift                                (0)
#define  ATSC_ADDR_20A8_reg_thd_lock_up_7_0_mask                                 (0x000000FF)
#define  ATSC_ADDR_20A8_reg_thd_lock_up_7_0(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_20A8_get_reg_thd_lock_up_7_0(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_20A9                                                         0x181542A4
#define  ATSC_ADDR_20A9_reg_addr                                                 "0xB81542A4"
#define  ATSC_ADDR_20A9_reg                                                      0xB81542A4
#define  ATSC_ADDR_20A9_inst_addr                                                "0x002F"
#define  set_ATSC_ADDR_20A9_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20A9_reg)=data)
#define  get_ATSC_ADDR_20A9_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20A9_reg))
#define  ATSC_ADDR_20A9_reg_thd_lock_dw_5_0_shift                                (2)
#define  ATSC_ADDR_20A9_reg_thd_lock_up_9_8_shift                                (0)
#define  ATSC_ADDR_20A9_reg_thd_lock_dw_5_0_mask                                 (0x000000FC)
#define  ATSC_ADDR_20A9_reg_thd_lock_up_9_8_mask                                 (0x00000003)
#define  ATSC_ADDR_20A9_reg_thd_lock_dw_5_0(data)                                (0x000000FC&((data)<<2))
#define  ATSC_ADDR_20A9_reg_thd_lock_up_9_8(data)                                (0x00000003&(data))
#define  ATSC_ADDR_20A9_get_reg_thd_lock_dw_5_0(data)                            ((0x000000FC&(data))>>2)
#define  ATSC_ADDR_20A9_get_reg_thd_lock_up_9_8(data)                            (0x00000003&(data))

#define  ATSC_ADDR_20AA                                                         0x181542A8
#define  ATSC_ADDR_20AA_reg_addr                                                 "0xB81542A8"
#define  ATSC_ADDR_20AA_reg                                                      0xB81542A8
#define  ATSC_ADDR_20AA_inst_addr                                                "0x0030"
#define  set_ATSC_ADDR_20AA_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20AA_reg)=data)
#define  get_ATSC_ADDR_20AA_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20AA_reg))
#define  ATSC_ADDR_20AA_reg_thd_up1_3_0_shift                                    (4)
#define  ATSC_ADDR_20AA_reg_thd_lock_dw_9_6_shift                                (0)
#define  ATSC_ADDR_20AA_reg_thd_up1_3_0_mask                                     (0x000000F0)
#define  ATSC_ADDR_20AA_reg_thd_lock_dw_9_6_mask                                 (0x0000000F)
#define  ATSC_ADDR_20AA_reg_thd_up1_3_0(data)                                    (0x000000F0&((data)<<4))
#define  ATSC_ADDR_20AA_reg_thd_lock_dw_9_6(data)                                (0x0000000F&(data))
#define  ATSC_ADDR_20AA_get_reg_thd_up1_3_0(data)                                ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_20AA_get_reg_thd_lock_dw_9_6(data)                            (0x0000000F&(data))

#define  ATSC_ADDR_20AB                                                         0x181542AC
#define  ATSC_ADDR_20AB_reg_addr                                                 "0xB81542AC"
#define  ATSC_ADDR_20AB_reg                                                      0xB81542AC
#define  ATSC_ADDR_20AB_inst_addr                                                "0x0031"
#define  set_ATSC_ADDR_20AB_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20AB_reg)=data)
#define  get_ATSC_ADDR_20AB_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20AB_reg))
#define  ATSC_ADDR_20AB_reg_thd_dw1_1_0_shift                                    (6)
#define  ATSC_ADDR_20AB_reg_thd_up1_9_4_shift                                    (0)
#define  ATSC_ADDR_20AB_reg_thd_dw1_1_0_mask                                     (0x000000C0)
#define  ATSC_ADDR_20AB_reg_thd_up1_9_4_mask                                     (0x0000003F)
#define  ATSC_ADDR_20AB_reg_thd_dw1_1_0(data)                                    (0x000000C0&((data)<<6))
#define  ATSC_ADDR_20AB_reg_thd_up1_9_4(data)                                    (0x0000003F&(data))
#define  ATSC_ADDR_20AB_get_reg_thd_dw1_1_0(data)                                ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_20AB_get_reg_thd_up1_9_4(data)                                (0x0000003F&(data))

#define  ATSC_ADDR_20AC                                                         0x181542B0
#define  ATSC_ADDR_20AC_reg_addr                                                 "0xB81542B0"
#define  ATSC_ADDR_20AC_reg                                                      0xB81542B0
#define  ATSC_ADDR_20AC_inst_addr                                                "0x0032"
#define  set_ATSC_ADDR_20AC_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20AC_reg)=data)
#define  get_ATSC_ADDR_20AC_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20AC_reg))
#define  ATSC_ADDR_20AC_reg_thd_dw1_9_2_shift                                    (0)
#define  ATSC_ADDR_20AC_reg_thd_dw1_9_2_mask                                     (0x000000FF)
#define  ATSC_ADDR_20AC_reg_thd_dw1_9_2(data)                                    (0x000000FF&(data))
#define  ATSC_ADDR_20AC_get_reg_thd_dw1_9_2(data)                                (0x000000FF&(data))

#define  ATSC_ADDR_20AD                                                         0x181542B4
#define  ATSC_ADDR_20AD_reg_addr                                                 "0xB81542B4"
#define  ATSC_ADDR_20AD_reg                                                      0xB81542B4
#define  ATSC_ADDR_20AD_inst_addr                                                "0x0033"
#define  set_ATSC_ADDR_20AD_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20AD_reg)=data)
#define  get_ATSC_ADDR_20AD_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20AD_reg))
#define  ATSC_ADDR_20AD_reg_thd_up2_shift                                        (0)
#define  ATSC_ADDR_20AD_reg_thd_up2_mask                                         (0x000000FF)
#define  ATSC_ADDR_20AD_reg_thd_up2(data)                                        (0x000000FF&(data))
#define  ATSC_ADDR_20AD_get_reg_thd_up2(data)                                    (0x000000FF&(data))

#define  ATSC_ADDR_20AE                                                         0x181542B8
#define  ATSC_ADDR_20AE_reg_addr                                                 "0xB81542B8"
#define  ATSC_ADDR_20AE_reg                                                      0xB81542B8
#define  ATSC_ADDR_20AE_inst_addr                                                "0x0034"
#define  set_ATSC_ADDR_20AE_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20AE_reg)=data)
#define  get_ATSC_ADDR_20AE_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20AE_reg))
#define  ATSC_ADDR_20AE_reg_thd_dw2_shift                                        (0)
#define  ATSC_ADDR_20AE_reg_thd_dw2_mask                                         (0x000000FF)
#define  ATSC_ADDR_20AE_reg_thd_dw2(data)                                        (0x000000FF&(data))
#define  ATSC_ADDR_20AE_get_reg_thd_dw2(data)                                    (0x000000FF&(data))

#define  ATSC_ADDR_20AF                                                         0x181542BC
#define  ATSC_ADDR_20AF_reg_addr                                                 "0xB81542BC"
#define  ATSC_ADDR_20AF_reg                                                      0xB81542BC
#define  ATSC_ADDR_20AF_inst_addr                                                "0x0035"
#define  set_ATSC_ADDR_20AF_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20AF_reg)=data)
#define  get_ATSC_ADDR_20AF_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20AF_reg))
#define  ATSC_ADDR_20AF_reg_aagc_lock_det_thd_shift                              (4)
#define  ATSC_ADDR_20AF_reg_aagc_lock_det_thd_mask                               (0x000000F0)
#define  ATSC_ADDR_20AF_reg_aagc_lock_det_thd(data)                              (0x000000F0&((data)<<4))
#define  ATSC_ADDR_20AF_get_reg_aagc_lock_det_thd(data)                          ((0x000000F0&(data))>>4)

#define  ATSC_ADDR_20B0                                                         0x181542C0
#define  ATSC_ADDR_20B0_reg_addr                                                 "0xB81542C0"
#define  ATSC_ADDR_20B0_reg                                                      0xB81542C0
#define  ATSC_ADDR_20B0_inst_addr                                                "0x0036"
#define  set_ATSC_ADDR_20B0_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20B0_reg)=data)
#define  get_ATSC_ADDR_20B0_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20B0_reg))
#define  ATSC_ADDR_20B0_reg_gain_step_sum_dw_thd_shift                           (4)
#define  ATSC_ADDR_20B0_reg_gain_step_sum_up_thd_shift                           (0)
#define  ATSC_ADDR_20B0_reg_gain_step_sum_dw_thd_mask                            (0x000000F0)
#define  ATSC_ADDR_20B0_reg_gain_step_sum_up_thd_mask                            (0x0000000F)
#define  ATSC_ADDR_20B0_reg_gain_step_sum_dw_thd(data)                           (0x000000F0&((data)<<4))
#define  ATSC_ADDR_20B0_reg_gain_step_sum_up_thd(data)                           (0x0000000F&(data))
#define  ATSC_ADDR_20B0_get_reg_gain_step_sum_dw_thd(data)                       ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_20B0_get_reg_gain_step_sum_up_thd(data)                       (0x0000000F&(data))

#define  ATSC_ADDR_20B1                                                         0x181542C4
#define  ATSC_ADDR_20B1_reg_addr                                                 "0xB81542C4"
#define  ATSC_ADDR_20B1_reg                                                      0xB81542C4
#define  ATSC_ADDR_20B1_inst_addr                                                "0x0037"
#define  set_ATSC_ADDR_20B1_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20B1_reg)=data)
#define  get_ATSC_ADDR_20B1_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20B1_reg))
#define  ATSC_ADDR_20B1_reg_gain_pulse_hold_len_shift                            (4)
#define  ATSC_ADDR_20B1_reg_gain_pulse_space_len_shift                           (0)
#define  ATSC_ADDR_20B1_reg_gain_pulse_hold_len_mask                             (0x000000F0)
#define  ATSC_ADDR_20B1_reg_gain_pulse_space_len_mask                            (0x0000000F)
#define  ATSC_ADDR_20B1_reg_gain_pulse_hold_len(data)                            (0x000000F0&((data)<<4))
#define  ATSC_ADDR_20B1_reg_gain_pulse_space_len(data)                           (0x0000000F&(data))
#define  ATSC_ADDR_20B1_get_reg_gain_pulse_hold_len(data)                        ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_20B1_get_reg_gain_pulse_space_len(data)                       (0x0000000F&(data))

#define  ATSC_ADDR_20B5                                                         0x181542D4
#define  ATSC_ADDR_20B5_reg_addr                                                 "0xB81542D4"
#define  ATSC_ADDR_20B5_reg                                                      0xB81542D4
#define  ATSC_ADDR_20B5_inst_addr                                                "0x0038"
#define  set_ATSC_ADDR_20B5_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20B5_reg)=data)
#define  get_ATSC_ADDR_20B5_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20B5_reg))
#define  ATSC_ADDR_20B5_aagc_lock_ext_shift                                      (0)
#define  ATSC_ADDR_20B5_aagc_lock_ext_mask                                       (0x00000001)
#define  ATSC_ADDR_20B5_aagc_lock_ext(data)                                      (0x00000001&(data))
#define  ATSC_ADDR_20B5_get_aagc_lock_ext(data)                                  (0x00000001&(data))

#define  ATSC_ADDR_20B6                                                         0x181542D8
#define  ATSC_ADDR_20B6_reg_addr                                                 "0xB81542D8"
#define  ATSC_ADDR_20B6_reg                                                      0xB81542D8
#define  ATSC_ADDR_20B6_inst_addr                                                "0x0039"
#define  set_ATSC_ADDR_20B6_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20B6_reg)=data)
#define  get_ATSC_ADDR_20B6_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20B6_reg))
#define  ATSC_ADDR_20B6_agc_level_pga_shift                                      (0)
#define  ATSC_ADDR_20B6_agc_level_pga_mask                                       (0x000000FF)
#define  ATSC_ADDR_20B6_agc_level_pga(data)                                      (0x000000FF&(data))
#define  ATSC_ADDR_20B6_get_agc_level_pga(data)                                  (0x000000FF&(data))

#define  ATSC_ADDR_20C4                                                         0x18154310
#define  ATSC_ADDR_20C4_reg_addr                                                 "0xB8154310"
#define  ATSC_ADDR_20C4_reg                                                      0xB8154310
#define  ATSC_ADDR_20C4_inst_addr                                                "0x003A"
#define  set_ATSC_ADDR_20C4_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20C4_reg)=data)
#define  get_ATSC_ADDR_20C4_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20C4_reg))
#define  ATSC_ADDR_20C4_opt_ant_rx_4b_on_shift                                   (7)
#define  ATSC_ADDR_20C4_opt_ant_auto_reply_ack_shift                             (6)
#define  ATSC_ADDR_20C4_opt_ant_ack_ctrl_mode_shift                              (5)
#define  ATSC_ADDR_20C4_opt_ant_rx_mode_shift                                    (4)
#define  ATSC_ADDR_20C4_opt_ant_force_a_shift                                    (3)
#define  ATSC_ADDR_20C4_opt_ant_force_b_shift                                    (2)
#define  ATSC_ADDR_20C4_opt_ant_enable_shift                                     (1)
#define  ATSC_ADDR_20C4_opt_ant_reset_n_shift                                    (0)
#define  ATSC_ADDR_20C4_opt_ant_rx_4b_on_mask                                    (0x00000080)
#define  ATSC_ADDR_20C4_opt_ant_auto_reply_ack_mask                              (0x00000040)
#define  ATSC_ADDR_20C4_opt_ant_ack_ctrl_mode_mask                               (0x00000020)
#define  ATSC_ADDR_20C4_opt_ant_rx_mode_mask                                     (0x00000010)
#define  ATSC_ADDR_20C4_opt_ant_force_a_mask                                     (0x00000008)
#define  ATSC_ADDR_20C4_opt_ant_force_b_mask                                     (0x00000004)
#define  ATSC_ADDR_20C4_opt_ant_enable_mask                                      (0x00000002)
#define  ATSC_ADDR_20C4_opt_ant_reset_n_mask                                     (0x00000001)
#define  ATSC_ADDR_20C4_opt_ant_rx_4b_on(data)                                   (0x00000080&((data)<<7))
#define  ATSC_ADDR_20C4_opt_ant_auto_reply_ack(data)                             (0x00000040&((data)<<6))
#define  ATSC_ADDR_20C4_opt_ant_ack_ctrl_mode(data)                              (0x00000020&((data)<<5))
#define  ATSC_ADDR_20C4_opt_ant_rx_mode(data)                                    (0x00000010&((data)<<4))
#define  ATSC_ADDR_20C4_opt_ant_force_a(data)                                    (0x00000008&((data)<<3))
#define  ATSC_ADDR_20C4_opt_ant_force_b(data)                                    (0x00000004&((data)<<2))
#define  ATSC_ADDR_20C4_opt_ant_enable(data)                                     (0x00000002&((data)<<1))
#define  ATSC_ADDR_20C4_opt_ant_reset_n(data)                                    (0x00000001&(data))
#define  ATSC_ADDR_20C4_get_opt_ant_rx_4b_on(data)                               ((0x00000080&(data))>>7)
#define  ATSC_ADDR_20C4_get_opt_ant_auto_reply_ack(data)                         ((0x00000040&(data))>>6)
#define  ATSC_ADDR_20C4_get_opt_ant_ack_ctrl_mode(data)                          ((0x00000020&(data))>>5)
#define  ATSC_ADDR_20C4_get_opt_ant_rx_mode(data)                                ((0x00000010&(data))>>4)
#define  ATSC_ADDR_20C4_get_opt_ant_force_a(data)                                ((0x00000008&(data))>>3)
#define  ATSC_ADDR_20C4_get_opt_ant_force_b(data)                                ((0x00000004&(data))>>2)
#define  ATSC_ADDR_20C4_get_opt_ant_enable(data)                                 ((0x00000002&(data))>>1)
#define  ATSC_ADDR_20C4_get_opt_ant_reset_n(data)                                (0x00000001&(data))

#define  ATSC_ADDR_20C5                                                         0x18154314
#define  ATSC_ADDR_20C5_reg_addr                                                 "0xB8154314"
#define  ATSC_ADDR_20C5_reg                                                      0xB8154314
#define  ATSC_ADDR_20C5_inst_addr                                                "0x003B"
#define  set_ATSC_ADDR_20C5_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20C5_reg)=data)
#define  get_ATSC_ADDR_20C5_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20C5_reg))
#define  ATSC_ADDR_20C5_opt_ant_data_tx_7_0_shift                                (0)
#define  ATSC_ADDR_20C5_opt_ant_data_tx_7_0_mask                                 (0x000000FF)
#define  ATSC_ADDR_20C5_opt_ant_data_tx_7_0(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_20C5_get_opt_ant_data_tx_7_0(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_20C6                                                         0x18154318
#define  ATSC_ADDR_20C6_reg_addr                                                 "0xB8154318"
#define  ATSC_ADDR_20C6_reg                                                      0xB8154318
#define  ATSC_ADDR_20C6_inst_addr                                                "0x003C"
#define  set_ATSC_ADDR_20C6_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20C6_reg)=data)
#define  get_ATSC_ADDR_20C6_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20C6_reg))
#define  ATSC_ADDR_20C6_opt_ant_data_tx_strobe_shift                             (7)
#define  ATSC_ADDR_20C6_opt_ant_data_tx_14_8_shift                               (0)
#define  ATSC_ADDR_20C6_opt_ant_data_tx_strobe_mask                              (0x00000080)
#define  ATSC_ADDR_20C6_opt_ant_data_tx_14_8_mask                                (0x0000007F)
#define  ATSC_ADDR_20C6_opt_ant_data_tx_strobe(data)                             (0x00000080&((data)<<7))
#define  ATSC_ADDR_20C6_opt_ant_data_tx_14_8(data)                               (0x0000007F&(data))
#define  ATSC_ADDR_20C6_get_opt_ant_data_tx_strobe(data)                         ((0x00000080&(data))>>7)
#define  ATSC_ADDR_20C6_get_opt_ant_data_tx_14_8(data)                           (0x0000007F&(data))

#define  ATSC_ADDR_20C7                                                         0x1815431C
#define  ATSC_ADDR_20C7_reg_addr                                                 "0xB815431C"
#define  ATSC_ADDR_20C7_reg                                                      0xB815431C
#define  ATSC_ADDR_20C7_inst_addr                                                "0x003D"
#define  set_ATSC_ADDR_20C7_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20C7_reg)=data)
#define  get_ATSC_ADDR_20C7_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20C7_reg))
#define  ATSC_ADDR_20C7_opt_ant_reply_ack_shift                                  (4)
#define  ATSC_ADDR_20C7_opt_ant_reply_strobe_shift                               (3)
#define  ATSC_ADDR_20C7_opt_ant_fix_tx_en_shift                                  (2)
#define  ATSC_ADDR_20C7_opt_ant_fix_tx_oe_shift                                  (1)
#define  ATSC_ADDR_20C7_opt_ant_fix_tx_shift                                     (0)
#define  ATSC_ADDR_20C7_opt_ant_reply_ack_mask                                   (0x00000010)
#define  ATSC_ADDR_20C7_opt_ant_reply_strobe_mask                                (0x00000008)
#define  ATSC_ADDR_20C7_opt_ant_fix_tx_en_mask                                   (0x00000004)
#define  ATSC_ADDR_20C7_opt_ant_fix_tx_oe_mask                                   (0x00000002)
#define  ATSC_ADDR_20C7_opt_ant_fix_tx_mask                                      (0x00000001)
#define  ATSC_ADDR_20C7_opt_ant_reply_ack(data)                                  (0x00000010&((data)<<4))
#define  ATSC_ADDR_20C7_opt_ant_reply_strobe(data)                               (0x00000008&((data)<<3))
#define  ATSC_ADDR_20C7_opt_ant_fix_tx_en(data)                                  (0x00000004&((data)<<2))
#define  ATSC_ADDR_20C7_opt_ant_fix_tx_oe(data)                                  (0x00000002&((data)<<1))
#define  ATSC_ADDR_20C7_opt_ant_fix_tx(data)                                     (0x00000001&(data))
#define  ATSC_ADDR_20C7_get_opt_ant_reply_ack(data)                              ((0x00000010&(data))>>4)
#define  ATSC_ADDR_20C7_get_opt_ant_reply_strobe(data)                           ((0x00000008&(data))>>3)
#define  ATSC_ADDR_20C7_get_opt_ant_fix_tx_en(data)                              ((0x00000004&(data))>>2)
#define  ATSC_ADDR_20C7_get_opt_ant_fix_tx_oe(data)                              ((0x00000002&(data))>>1)
#define  ATSC_ADDR_20C7_get_opt_ant_fix_tx(data)                                 (0x00000001&(data))

#define  ATSC_ADDR_20C8                                                         0x18154320
#define  ATSC_ADDR_20C8_reg_addr                                                 "0xB8154320"
#define  ATSC_ADDR_20C8_reg                                                      0xB8154320
#define  ATSC_ADDR_20C8_inst_addr                                                "0x003E"
#define  set_ATSC_ADDR_20C8_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20C8_reg)=data)
#define  get_ATSC_ADDR_20C8_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20C8_reg))
#define  ATSC_ADDR_20C8_opt_ant_8k_period_7_0_shift                              (0)
#define  ATSC_ADDR_20C8_opt_ant_8k_period_7_0_mask                               (0x000000FF)
#define  ATSC_ADDR_20C8_opt_ant_8k_period_7_0(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_20C8_get_opt_ant_8k_period_7_0(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_20C9                                                         0x18154324
#define  ATSC_ADDR_20C9_reg_addr                                                 "0xB8154324"
#define  ATSC_ADDR_20C9_reg                                                      0xB8154324
#define  ATSC_ADDR_20C9_inst_addr                                                "0x003F"
#define  set_ATSC_ADDR_20C9_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20C9_reg)=data)
#define  get_ATSC_ADDR_20C9_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20C9_reg))
#define  ATSC_ADDR_20C9_opt_ant_low_period_7_0_shift                             (0)
#define  ATSC_ADDR_20C9_opt_ant_low_period_7_0_mask                              (0x000000FF)
#define  ATSC_ADDR_20C9_opt_ant_low_period_7_0(data)                             (0x000000FF&(data))
#define  ATSC_ADDR_20C9_get_opt_ant_low_period_7_0(data)                         (0x000000FF&(data))

#define  ATSC_ADDR_20CA                                                         0x18154328
#define  ATSC_ADDR_20CA_reg_addr                                                 "0xB8154328"
#define  ATSC_ADDR_20CA_reg                                                      0xB8154328
#define  ATSC_ADDR_20CA_inst_addr                                                "0x0040"
#define  set_ATSC_ADDR_20CA_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20CA_reg)=data)
#define  get_ATSC_ADDR_20CA_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20CA_reg))
#define  ATSC_ADDR_20CA_opt_ant_low_period_11_8_shift                            (4)
#define  ATSC_ADDR_20CA_opt_ant_8k_period_11_8_shift                             (0)
#define  ATSC_ADDR_20CA_opt_ant_low_period_11_8_mask                             (0x000000F0)
#define  ATSC_ADDR_20CA_opt_ant_8k_period_11_8_mask                              (0x0000000F)
#define  ATSC_ADDR_20CA_opt_ant_low_period_11_8(data)                            (0x000000F0&((data)<<4))
#define  ATSC_ADDR_20CA_opt_ant_8k_period_11_8(data)                             (0x0000000F&(data))
#define  ATSC_ADDR_20CA_get_opt_ant_low_period_11_8(data)                        ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_20CA_get_opt_ant_8k_period_11_8(data)                         (0x0000000F&(data))

#define  ATSC_ADDR_20CB                                                         0x1815432C
#define  ATSC_ADDR_20CB_reg_addr                                                 "0xB815432C"
#define  ATSC_ADDR_20CB_reg                                                      0xB815432C
#define  ATSC_ADDR_20CB_inst_addr                                                "0x0041"
#define  set_ATSC_ADDR_20CB_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20CB_reg)=data)
#define  get_ATSC_ADDR_20CB_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20CB_reg))
#define  ATSC_ADDR_20CB_opt_ant_tx_to_cnt_th_7_0_shift                           (0)
#define  ATSC_ADDR_20CB_opt_ant_tx_to_cnt_th_7_0_mask                            (0x000000FF)
#define  ATSC_ADDR_20CB_opt_ant_tx_to_cnt_th_7_0(data)                           (0x000000FF&(data))
#define  ATSC_ADDR_20CB_get_opt_ant_tx_to_cnt_th_7_0(data)                       (0x000000FF&(data))

#define  ATSC_ADDR_20CC                                                         0x18154330
#define  ATSC_ADDR_20CC_reg_addr                                                 "0xB8154330"
#define  ATSC_ADDR_20CC_reg                                                      0xB8154330
#define  ATSC_ADDR_20CC_inst_addr                                                "0x0042"
#define  set_ATSC_ADDR_20CC_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20CC_reg)=data)
#define  get_ATSC_ADDR_20CC_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20CC_reg))
#define  ATSC_ADDR_20CC_opt_ant_rx_to_cnt_th_7_0_shift                           (0)
#define  ATSC_ADDR_20CC_opt_ant_rx_to_cnt_th_7_0_mask                            (0x000000FF)
#define  ATSC_ADDR_20CC_opt_ant_rx_to_cnt_th_7_0(data)                           (0x000000FF&(data))
#define  ATSC_ADDR_20CC_get_opt_ant_rx_to_cnt_th_7_0(data)                       (0x000000FF&(data))

#define  ATSC_ADDR_20CD                                                         0x18154334
#define  ATSC_ADDR_20CD_reg_addr                                                 "0xB8154334"
#define  ATSC_ADDR_20CD_reg                                                      0xB8154334
#define  ATSC_ADDR_20CD_inst_addr                                                "0x0043"
#define  set_ATSC_ADDR_20CD_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20CD_reg)=data)
#define  get_ATSC_ADDR_20CD_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20CD_reg))
#define  ATSC_ADDR_20CD_opt_ant_rx_startbit_on_shift                             (6)
#define  ATSC_ADDR_20CD_opt_ant_rx_timeout_en_shift                              (5)
#define  ATSC_ADDR_20CD_opt_ant_tx_timeout_en_shift                              (4)
#define  ATSC_ADDR_20CD_opt_ant_rx_to_cnt_th_9_8_shift                           (2)
#define  ATSC_ADDR_20CD_opt_ant_tx_to_cnt_th_9_8_shift                           (0)
#define  ATSC_ADDR_20CD_opt_ant_rx_startbit_on_mask                              (0x00000040)
#define  ATSC_ADDR_20CD_opt_ant_rx_timeout_en_mask                               (0x00000020)
#define  ATSC_ADDR_20CD_opt_ant_tx_timeout_en_mask                               (0x00000010)
#define  ATSC_ADDR_20CD_opt_ant_rx_to_cnt_th_9_8_mask                            (0x0000000C)
#define  ATSC_ADDR_20CD_opt_ant_tx_to_cnt_th_9_8_mask                            (0x00000003)
#define  ATSC_ADDR_20CD_opt_ant_rx_startbit_on(data)                             (0x00000040&((data)<<6))
#define  ATSC_ADDR_20CD_opt_ant_rx_timeout_en(data)                              (0x00000020&((data)<<5))
#define  ATSC_ADDR_20CD_opt_ant_tx_timeout_en(data)                              (0x00000010&((data)<<4))
#define  ATSC_ADDR_20CD_opt_ant_rx_to_cnt_th_9_8(data)                           (0x0000000C&((data)<<2))
#define  ATSC_ADDR_20CD_opt_ant_tx_to_cnt_th_9_8(data)                           (0x00000003&(data))
#define  ATSC_ADDR_20CD_get_opt_ant_rx_startbit_on(data)                         ((0x00000040&(data))>>6)
#define  ATSC_ADDR_20CD_get_opt_ant_rx_timeout_en(data)                          ((0x00000020&(data))>>5)
#define  ATSC_ADDR_20CD_get_opt_ant_tx_timeout_en(data)                          ((0x00000010&(data))>>4)
#define  ATSC_ADDR_20CD_get_opt_ant_rx_to_cnt_th_9_8(data)                       ((0x0000000C&(data))>>2)
#define  ATSC_ADDR_20CD_get_opt_ant_tx_to_cnt_th_9_8(data)                       (0x00000003&(data))

#define  ATSC_ADDR_20CE                                                         0x18154338
#define  ATSC_ADDR_20CE_reg_addr                                                 "0xB8154338"
#define  ATSC_ADDR_20CE_reg                                                      0xB8154338
#define  ATSC_ADDR_20CE_inst_addr                                                "0x0044"
#define  set_ATSC_ADDR_20CE_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20CE_reg)=data)
#define  get_ATSC_ADDR_20CE_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20CE_reg))
#define  ATSC_ADDR_20CE_opt_ant_init_msg_7_0_shift                               (0)
#define  ATSC_ADDR_20CE_opt_ant_init_msg_7_0_mask                                (0x000000FF)
#define  ATSC_ADDR_20CE_opt_ant_init_msg_7_0(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_20CE_get_opt_ant_init_msg_7_0(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_20CF                                                         0x1815433C
#define  ATSC_ADDR_20CF_reg_addr                                                 "0xB815433C"
#define  ATSC_ADDR_20CF_reg                                                      0xB815433C
#define  ATSC_ADDR_20CF_inst_addr                                                "0x0045"
#define  set_ATSC_ADDR_20CF_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20CF_reg)=data)
#define  get_ATSC_ADDR_20CF_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20CF_reg))
#define  ATSC_ADDR_20CF_opt_ant_init_msg_14_8_shift                              (0)
#define  ATSC_ADDR_20CF_opt_ant_init_msg_14_8_mask                               (0x0000007F)
#define  ATSC_ADDR_20CF_opt_ant_init_msg_14_8(data)                              (0x0000007F&(data))
#define  ATSC_ADDR_20CF_get_opt_ant_init_msg_14_8(data)                          (0x0000007F&(data))

#define  ATSC_ADDR_20D0                                                         0x18154340
#define  ATSC_ADDR_20D0_reg_addr                                                 "0xB8154340"
#define  ATSC_ADDR_20D0_reg                                                      0xB8154340
#define  ATSC_ADDR_20D0_inst_addr                                                "0x0046"
#define  set_ATSC_ADDR_20D0_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20D0_reg)=data)
#define  get_ATSC_ADDR_20D0_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20D0_reg))
#define  ATSC_ADDR_20D0_opt_ant_ack_msg_7_0_shift                                (0)
#define  ATSC_ADDR_20D0_opt_ant_ack_msg_7_0_mask                                 (0x000000FF)
#define  ATSC_ADDR_20D0_opt_ant_ack_msg_7_0(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_20D0_get_opt_ant_ack_msg_7_0(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_20D1                                                         0x18154344
#define  ATSC_ADDR_20D1_reg_addr                                                 "0xB8154344"
#define  ATSC_ADDR_20D1_reg                                                      0xB8154344
#define  ATSC_ADDR_20D1_inst_addr                                                "0x0047"
#define  set_ATSC_ADDR_20D1_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20D1_reg)=data)
#define  get_ATSC_ADDR_20D1_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20D1_reg))
#define  ATSC_ADDR_20D1_opt_ant_ack_msg_14_8_shift                               (0)
#define  ATSC_ADDR_20D1_opt_ant_ack_msg_14_8_mask                                (0x0000007F)
#define  ATSC_ADDR_20D1_opt_ant_ack_msg_14_8(data)                               (0x0000007F&(data))
#define  ATSC_ADDR_20D1_get_opt_ant_ack_msg_14_8(data)                           (0x0000007F&(data))

#define  ATSC_ADDR_20D2                                                         0x18154348
#define  ATSC_ADDR_20D2_reg_addr                                                 "0xB8154348"
#define  ATSC_ADDR_20D2_reg                                                      0xB8154348
#define  ATSC_ADDR_20D2_inst_addr                                                "0x0048"
#define  set_ATSC_ADDR_20D2_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20D2_reg)=data)
#define  get_ATSC_ADDR_20D2_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20D2_reg))
#define  ATSC_ADDR_20D2_opt_ant_nack_msg_7_0_shift                               (0)
#define  ATSC_ADDR_20D2_opt_ant_nack_msg_7_0_mask                                (0x000000FF)
#define  ATSC_ADDR_20D2_opt_ant_nack_msg_7_0(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_20D2_get_opt_ant_nack_msg_7_0(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_20D3                                                         0x1815434C
#define  ATSC_ADDR_20D3_reg_addr                                                 "0xB815434C"
#define  ATSC_ADDR_20D3_reg                                                      0xB815434C
#define  ATSC_ADDR_20D3_inst_addr                                                "0x0049"
#define  set_ATSC_ADDR_20D3_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20D3_reg)=data)
#define  get_ATSC_ADDR_20D3_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20D3_reg))
#define  ATSC_ADDR_20D3_opt_ant_nack_msg_14_8_shift                              (0)
#define  ATSC_ADDR_20D3_opt_ant_nack_msg_14_8_mask                               (0x0000007F)
#define  ATSC_ADDR_20D3_opt_ant_nack_msg_14_8(data)                              (0x0000007F&(data))
#define  ATSC_ADDR_20D3_get_opt_ant_nack_msg_14_8(data)                          (0x0000007F&(data))

#define  ATSC_ADDR_20D4                                                         0x18154350
#define  ATSC_ADDR_20D4_reg_addr                                                 "0xB8154350"
#define  ATSC_ADDR_20D4_reg                                                      0xB8154350
#define  ATSC_ADDR_20D4_inst_addr                                                "0x004A"
#define  set_ATSC_ADDR_20D4_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20D4_reg)=data)
#define  get_ATSC_ADDR_20D4_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20D4_reg))
#define  ATSC_ADDR_20D4_opt_ant_ack_dly_cnt_th_7_0_shift                         (0)
#define  ATSC_ADDR_20D4_opt_ant_ack_dly_cnt_th_7_0_mask                          (0x000000FF)
#define  ATSC_ADDR_20D4_opt_ant_ack_dly_cnt_th_7_0(data)                         (0x000000FF&(data))
#define  ATSC_ADDR_20D4_get_opt_ant_ack_dly_cnt_th_7_0(data)                     (0x000000FF&(data))

#define  ATSC_ADDR_20D5                                                         0x18154354
#define  ATSC_ADDR_20D5_reg_addr                                                 "0xB8154354"
#define  ATSC_ADDR_20D5_reg                                                      0xB8154354
#define  ATSC_ADDR_20D5_inst_addr                                                "0x004B"
#define  set_ATSC_ADDR_20D5_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20D5_reg)=data)
#define  get_ATSC_ADDR_20D5_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20D5_reg))
#define  ATSC_ADDR_20D5_opt_ant_rx_signal_pos_shift                              (2)
#define  ATSC_ADDR_20D5_opt_ant_ack_dly_cnt_th_9_8_shift                         (0)
#define  ATSC_ADDR_20D5_opt_ant_rx_signal_pos_mask                               (0x0000000C)
#define  ATSC_ADDR_20D5_opt_ant_ack_dly_cnt_th_9_8_mask                          (0x00000003)
#define  ATSC_ADDR_20D5_opt_ant_rx_signal_pos(data)                              (0x0000000C&((data)<<2))
#define  ATSC_ADDR_20D5_opt_ant_ack_dly_cnt_th_9_8(data)                         (0x00000003&(data))
#define  ATSC_ADDR_20D5_get_opt_ant_rx_signal_pos(data)                          ((0x0000000C&(data))>>2)
#define  ATSC_ADDR_20D5_get_opt_ant_ack_dly_cnt_th_9_8(data)                     (0x00000003&(data))

#define  ATSC_ADDR_20D6                                                         0x18154358
#define  ATSC_ADDR_20D6_reg_addr                                                 "0xB8154358"
#define  ATSC_ADDR_20D6_reg                                                      0xB8154358
#define  ATSC_ADDR_20D6_inst_addr                                                "0x004C"
#define  set_ATSC_ADDR_20D6_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20D6_reg)=data)
#define  get_ATSC_ADDR_20D6_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20D6_reg))
#define  ATSC_ADDR_20D6_opt_ant_tx_ant_oe_comb_shift                             (6)
#define  ATSC_ADDR_20D6_opt_ant_pad_config_shift                                 (4)
#define  ATSC_ADDR_20D6_opt_ant_tx_ant_oe_comb_mask                              (0x00000040)
#define  ATSC_ADDR_20D6_opt_ant_pad_config_mask                                  (0x00000030)
#define  ATSC_ADDR_20D6_opt_ant_tx_ant_oe_comb(data)                             (0x00000040&((data)<<6))
#define  ATSC_ADDR_20D6_opt_ant_pad_config(data)                                 (0x00000030&((data)<<4))
#define  ATSC_ADDR_20D6_get_opt_ant_tx_ant_oe_comb(data)                         ((0x00000040&(data))>>6)
#define  ATSC_ADDR_20D6_get_opt_ant_pad_config(data)                             ((0x00000030&(data))>>4)

#define  ATSC_ADDR_20D7                                                         0x1815435C
#define  ATSC_ADDR_20D7_reg_addr                                                 "0xB815435C"
#define  ATSC_ADDR_20D7_reg                                                      0xB815435C
#define  ATSC_ADDR_20D7_inst_addr                                                "0x004D"
#define  set_ATSC_ADDR_20D7_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20D7_reg)=data)
#define  get_ATSC_ADDR_20D7_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20D7_reg))
#define  ATSC_ADDR_20D7_opt_ant_test_bit_th_shift                                (4)
#define  ATSC_ADDR_20D7_opt_ant_test_4b_on_shift                                 (3)
#define  ATSC_ADDR_20D7_opt_ant_test_strobe_shift                                (2)
#define  ATSC_ADDR_20D7_opt_ant_test_trig_sel_shift                              (1)
#define  ATSC_ADDR_20D7_opt_ant_test_en_shift                                    (0)
#define  ATSC_ADDR_20D7_opt_ant_test_bit_th_mask                                 (0x000000F0)
#define  ATSC_ADDR_20D7_opt_ant_test_4b_on_mask                                  (0x00000008)
#define  ATSC_ADDR_20D7_opt_ant_test_strobe_mask                                 (0x00000004)
#define  ATSC_ADDR_20D7_opt_ant_test_trig_sel_mask                               (0x00000002)
#define  ATSC_ADDR_20D7_opt_ant_test_en_mask                                     (0x00000001)
#define  ATSC_ADDR_20D7_opt_ant_test_bit_th(data)                                (0x000000F0&((data)<<4))
#define  ATSC_ADDR_20D7_opt_ant_test_4b_on(data)                                 (0x00000008&((data)<<3))
#define  ATSC_ADDR_20D7_opt_ant_test_strobe(data)                                (0x00000004&((data)<<2))
#define  ATSC_ADDR_20D7_opt_ant_test_trig_sel(data)                              (0x00000002&((data)<<1))
#define  ATSC_ADDR_20D7_opt_ant_test_en(data)                                    (0x00000001&(data))
#define  ATSC_ADDR_20D7_get_opt_ant_test_bit_th(data)                            ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_20D7_get_opt_ant_test_4b_on(data)                             ((0x00000008&(data))>>3)
#define  ATSC_ADDR_20D7_get_opt_ant_test_strobe(data)                            ((0x00000004&(data))>>2)
#define  ATSC_ADDR_20D7_get_opt_ant_test_trig_sel(data)                          ((0x00000002&(data))>>1)
#define  ATSC_ADDR_20D7_get_opt_ant_test_en(data)                                (0x00000001&(data))

#define  ATSC_ADDR_20D8                                                         0x18154360
#define  ATSC_ADDR_20D8_reg_addr                                                 "0xB8154360"
#define  ATSC_ADDR_20D8_reg                                                      0xB8154360
#define  ATSC_ADDR_20D8_inst_addr                                                "0x004E"
#define  set_ATSC_ADDR_20D8_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20D8_reg)=data)
#define  get_ATSC_ADDR_20D8_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20D8_reg))
#define  ATSC_ADDR_20D8_opt_ant_test_msg_7_0_shift                               (0)
#define  ATSC_ADDR_20D8_opt_ant_test_msg_7_0_mask                                (0x000000FF)
#define  ATSC_ADDR_20D8_opt_ant_test_msg_7_0(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_20D8_get_opt_ant_test_msg_7_0(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_20D9                                                         0x18154364
#define  ATSC_ADDR_20D9_reg_addr                                                 "0xB8154364"
#define  ATSC_ADDR_20D9_reg                                                      0xB8154364
#define  ATSC_ADDR_20D9_inst_addr                                                "0x004F"
#define  set_ATSC_ADDR_20D9_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20D9_reg)=data)
#define  get_ATSC_ADDR_20D9_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20D9_reg))
#define  ATSC_ADDR_20D9_opt_ant_test_msg_15_8_shift                              (0)
#define  ATSC_ADDR_20D9_opt_ant_test_msg_15_8_mask                               (0x000000FF)
#define  ATSC_ADDR_20D9_opt_ant_test_msg_15_8(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_20D9_get_opt_ant_test_msg_15_8(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_20DA                                                         0x18154368
#define  ATSC_ADDR_20DA_reg_addr                                                 "0xB8154368"
#define  ATSC_ADDR_20DA_reg                                                      0xB8154368
#define  ATSC_ADDR_20DA_inst_addr                                                "0x0050"
#define  set_ATSC_ADDR_20DA_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20DA_reg)=data)
#define  get_ATSC_ADDR_20DA_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20DA_reg))
#define  ATSC_ADDR_20DA_opt_ant_test_dly_cnt_th_7_0_shift                        (0)
#define  ATSC_ADDR_20DA_opt_ant_test_dly_cnt_th_7_0_mask                         (0x000000FF)
#define  ATSC_ADDR_20DA_opt_ant_test_dly_cnt_th_7_0(data)                        (0x000000FF&(data))
#define  ATSC_ADDR_20DA_get_opt_ant_test_dly_cnt_th_7_0(data)                    (0x000000FF&(data))

#define  ATSC_ADDR_20DB                                                         0x1815436C
#define  ATSC_ADDR_20DB_reg_addr                                                 "0xB815436C"
#define  ATSC_ADDR_20DB_reg                                                      0xB815436C
#define  ATSC_ADDR_20DB_inst_addr                                                "0x0051"
#define  set_ATSC_ADDR_20DB_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20DB_reg)=data)
#define  get_ATSC_ADDR_20DB_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20DB_reg))
#define  ATSC_ADDR_20DB_opt_ant_rx_signal_neg_shift                              (6)
#define  ATSC_ADDR_20DB_opt_ant_timeout_clr_shift                                (5)
#define  ATSC_ADDR_20DB_opt_ant_sr11to12_shift                                   (4)
#define  ATSC_ADDR_20DB_opt_ant_loopback2_en_shift                               (3)
#define  ATSC_ADDR_20DB_opt_ant_loopback1_en_shift                               (2)
#define  ATSC_ADDR_20DB_opt_ant_test_dly_cnt_th_9_8_shift                        (0)
#define  ATSC_ADDR_20DB_opt_ant_rx_signal_neg_mask                               (0x000000C0)
#define  ATSC_ADDR_20DB_opt_ant_timeout_clr_mask                                 (0x00000020)
#define  ATSC_ADDR_20DB_opt_ant_sr11to12_mask                                    (0x00000010)
#define  ATSC_ADDR_20DB_opt_ant_loopback2_en_mask                                (0x00000008)
#define  ATSC_ADDR_20DB_opt_ant_loopback1_en_mask                                (0x00000004)
#define  ATSC_ADDR_20DB_opt_ant_test_dly_cnt_th_9_8_mask                         (0x00000003)
#define  ATSC_ADDR_20DB_opt_ant_rx_signal_neg(data)                              (0x000000C0&((data)<<6))
#define  ATSC_ADDR_20DB_opt_ant_timeout_clr(data)                                (0x00000020&((data)<<5))
#define  ATSC_ADDR_20DB_opt_ant_sr11to12(data)                                   (0x00000010&((data)<<4))
#define  ATSC_ADDR_20DB_opt_ant_loopback2_en(data)                               (0x00000008&((data)<<3))
#define  ATSC_ADDR_20DB_opt_ant_loopback1_en(data)                               (0x00000004&((data)<<2))
#define  ATSC_ADDR_20DB_opt_ant_test_dly_cnt_th_9_8(data)                        (0x00000003&(data))
#define  ATSC_ADDR_20DB_get_opt_ant_rx_signal_neg(data)                          ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_20DB_get_opt_ant_timeout_clr(data)                            ((0x00000020&(data))>>5)
#define  ATSC_ADDR_20DB_get_opt_ant_sr11to12(data)                               ((0x00000010&(data))>>4)
#define  ATSC_ADDR_20DB_get_opt_ant_loopback2_en(data)                           ((0x00000008&(data))>>3)
#define  ATSC_ADDR_20DB_get_opt_ant_loopback1_en(data)                           ((0x00000004&(data))>>2)
#define  ATSC_ADDR_20DB_get_opt_ant_test_dly_cnt_th_9_8(data)                    (0x00000003&(data))

#define  ATSC_ADDR_20DC                                                         0x18154370
#define  ATSC_ADDR_20DC_reg_addr                                                 "0xB8154370"
#define  ATSC_ADDR_20DC_reg                                                      0xB8154370
#define  ATSC_ADDR_20DC_inst_addr                                                "0x0052"
#define  set_ATSC_ADDR_20DC_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20DC_reg)=data)
#define  get_ATSC_ADDR_20DC_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20DC_reg))
#define  ATSC_ADDR_20DC_opt_ant_rx_dly_cnt_th_7_0_shift                          (0)
#define  ATSC_ADDR_20DC_opt_ant_rx_dly_cnt_th_7_0_mask                           (0x000000FF)
#define  ATSC_ADDR_20DC_opt_ant_rx_dly_cnt_th_7_0(data)                          (0x000000FF&(data))
#define  ATSC_ADDR_20DC_get_opt_ant_rx_dly_cnt_th_7_0(data)                      (0x000000FF&(data))

#define  ATSC_ADDR_20DD                                                         0x18154374
#define  ATSC_ADDR_20DD_reg_addr                                                 "0xB8154374"
#define  ATSC_ADDR_20DD_reg                                                      0xB8154374
#define  ATSC_ADDR_20DD_inst_addr                                                "0x0053"
#define  set_ATSC_ADDR_20DD_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20DD_reg)=data)
#define  get_ATSC_ADDR_20DD_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20DD_reg))
#define  ATSC_ADDR_20DD_opt_ant_tx_oe_next_st9_shift                             (7)
#define  ATSC_ADDR_20DD_opt_ant_tx_oe_next_st0_shift                             (6)
#define  ATSC_ADDR_20DD_opt_ant_tx_powerup_st0_shift                             (5)
#define  ATSC_ADDR_20DD_opt_ant_tx_silence_st0_shift                             (4)
#define  ATSC_ADDR_20DD_opt_ant_tx_upd_st0_shift                                 (3)
#define  ATSC_ADDR_20DD_opt_ant_rx_dly_cnt_th_9_8_shift                          (0)
#define  ATSC_ADDR_20DD_opt_ant_tx_oe_next_st9_mask                              (0x00000080)
#define  ATSC_ADDR_20DD_opt_ant_tx_oe_next_st0_mask                              (0x00000040)
#define  ATSC_ADDR_20DD_opt_ant_tx_powerup_st0_mask                              (0x00000020)
#define  ATSC_ADDR_20DD_opt_ant_tx_silence_st0_mask                              (0x00000010)
#define  ATSC_ADDR_20DD_opt_ant_tx_upd_st0_mask                                  (0x00000008)
#define  ATSC_ADDR_20DD_opt_ant_rx_dly_cnt_th_9_8_mask                           (0x00000003)
#define  ATSC_ADDR_20DD_opt_ant_tx_oe_next_st9(data)                             (0x00000080&((data)<<7))
#define  ATSC_ADDR_20DD_opt_ant_tx_oe_next_st0(data)                             (0x00000040&((data)<<6))
#define  ATSC_ADDR_20DD_opt_ant_tx_powerup_st0(data)                             (0x00000020&((data)<<5))
#define  ATSC_ADDR_20DD_opt_ant_tx_silence_st0(data)                             (0x00000010&((data)<<4))
#define  ATSC_ADDR_20DD_opt_ant_tx_upd_st0(data)                                 (0x00000008&((data)<<3))
#define  ATSC_ADDR_20DD_opt_ant_rx_dly_cnt_th_9_8(data)                          (0x00000003&(data))
#define  ATSC_ADDR_20DD_get_opt_ant_tx_oe_next_st9(data)                         ((0x00000080&(data))>>7)
#define  ATSC_ADDR_20DD_get_opt_ant_tx_oe_next_st0(data)                         ((0x00000040&(data))>>6)
#define  ATSC_ADDR_20DD_get_opt_ant_tx_powerup_st0(data)                         ((0x00000020&(data))>>5)
#define  ATSC_ADDR_20DD_get_opt_ant_tx_silence_st0(data)                         ((0x00000010&(data))>>4)
#define  ATSC_ADDR_20DD_get_opt_ant_tx_upd_st0(data)                             ((0x00000008&(data))>>3)
#define  ATSC_ADDR_20DD_get_opt_ant_rx_dly_cnt_th_9_8(data)                      (0x00000003&(data))

#define  ATSC_ADDR_20DE                                                         0x18154378
#define  ATSC_ADDR_20DE_reg_addr                                                 "0xB8154378"
#define  ATSC_ADDR_20DE_reg                                                      0xB8154378
#define  ATSC_ADDR_20DE_inst_addr                                                "0x0054"
#define  set_ATSC_ADDR_20DE_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20DE_reg)=data)
#define  get_ATSC_ADDR_20DE_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20DE_reg))
#define  ATSC_ADDR_20DE_opt_ant_tx_ini_period_shift                              (0)
#define  ATSC_ADDR_20DE_opt_ant_tx_ini_period_mask                               (0x000000FF)
#define  ATSC_ADDR_20DE_opt_ant_tx_ini_period(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_20DE_get_opt_ant_tx_ini_period(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_20DF                                                         0x1815437C
#define  ATSC_ADDR_20DF_reg_addr                                                 "0xB815437C"
#define  ATSC_ADDR_20DF_reg                                                      0xB815437C
#define  ATSC_ADDR_20DF_inst_addr                                                "0x0055"
#define  set_ATSC_ADDR_20DF_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20DF_reg)=data)
#define  get_ATSC_ADDR_20DF_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20DF_reg))
#define  ATSC_ADDR_20DF_opt_ant_tx_st9_period_shift                              (0)
#define  ATSC_ADDR_20DF_opt_ant_tx_st9_period_mask                               (0x000000FF)
#define  ATSC_ADDR_20DF_opt_ant_tx_st9_period(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_20DF_get_opt_ant_tx_st9_period(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_20E0                                                         0x18154380
#define  ATSC_ADDR_20E0_reg_addr                                                 "0xB8154380"
#define  ATSC_ADDR_20E0_reg                                                      0xB8154380
#define  ATSC_ADDR_20E0_inst_addr                                                "0x0056"
#define  set_ATSC_ADDR_20E0_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20E0_reg)=data)
#define  get_ATSC_ADDR_20E0_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20E0_reg))
#define  ATSC_ADDR_20E0_opt_ant_tx_st11_period_shift                             (0)
#define  ATSC_ADDR_20E0_opt_ant_tx_st11_period_mask                              (0x000000FF)
#define  ATSC_ADDR_20E0_opt_ant_tx_st11_period(data)                             (0x000000FF&(data))
#define  ATSC_ADDR_20E0_get_opt_ant_tx_st11_period(data)                         (0x000000FF&(data))

#define  ATSC_ADDR_20E1                                                         0x18154384
#define  ATSC_ADDR_20E1_reg_addr                                                 "0xB8154384"
#define  ATSC_ADDR_20E1_reg                                                      0xB8154384
#define  ATSC_ADDR_20E1_inst_addr                                                "0x0057"
#define  set_ATSC_ADDR_20E1_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20E1_reg)=data)
#define  get_ATSC_ADDR_20E1_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20E1_reg))
#define  ATSC_ADDR_20E1_opt_ant_tx_inv_shift                                     (7)
#define  ATSC_ADDR_20E1_opt_ant_tx_oe_opt_shift                                  (6)
#define  ATSC_ADDR_20E1_opt_ant_oe_inv_shift                                     (5)
#define  ATSC_ADDR_20E1_opt_ant_tx_pad_oe_shift                                  (4)
#define  ATSC_ADDR_20E1_opt_ant_oe_pad_oe_shift                                  (3)
#define  ATSC_ADDR_20E1_opt_ant_tx_end_st13_shift                                (2)
#define  ATSC_ADDR_20E1_opt_ant_tx_oe_next_st11_shift                            (1)
#define  ATSC_ADDR_20E1_opt_ant_tx_end_st10_shift                                (0)
#define  ATSC_ADDR_20E1_opt_ant_tx_inv_mask                                      (0x00000080)
#define  ATSC_ADDR_20E1_opt_ant_tx_oe_opt_mask                                   (0x00000040)
#define  ATSC_ADDR_20E1_opt_ant_oe_inv_mask                                      (0x00000020)
#define  ATSC_ADDR_20E1_opt_ant_tx_pad_oe_mask                                   (0x00000010)
#define  ATSC_ADDR_20E1_opt_ant_oe_pad_oe_mask                                   (0x00000008)
#define  ATSC_ADDR_20E1_opt_ant_tx_end_st13_mask                                 (0x00000004)
#define  ATSC_ADDR_20E1_opt_ant_tx_oe_next_st11_mask                             (0x00000002)
#define  ATSC_ADDR_20E1_opt_ant_tx_end_st10_mask                                 (0x00000001)
#define  ATSC_ADDR_20E1_opt_ant_tx_inv(data)                                     (0x00000080&((data)<<7))
#define  ATSC_ADDR_20E1_opt_ant_tx_oe_opt(data)                                  (0x00000040&((data)<<6))
#define  ATSC_ADDR_20E1_opt_ant_oe_inv(data)                                     (0x00000020&((data)<<5))
#define  ATSC_ADDR_20E1_opt_ant_tx_pad_oe(data)                                  (0x00000010&((data)<<4))
#define  ATSC_ADDR_20E1_opt_ant_oe_pad_oe(data)                                  (0x00000008&((data)<<3))
#define  ATSC_ADDR_20E1_opt_ant_tx_end_st13(data)                                (0x00000004&((data)<<2))
#define  ATSC_ADDR_20E1_opt_ant_tx_oe_next_st11(data)                            (0x00000002&((data)<<1))
#define  ATSC_ADDR_20E1_opt_ant_tx_end_st10(data)                                (0x00000001&(data))
#define  ATSC_ADDR_20E1_get_opt_ant_tx_inv(data)                                 ((0x00000080&(data))>>7)
#define  ATSC_ADDR_20E1_get_opt_ant_tx_oe_opt(data)                              ((0x00000040&(data))>>6)
#define  ATSC_ADDR_20E1_get_opt_ant_oe_inv(data)                                 ((0x00000020&(data))>>5)
#define  ATSC_ADDR_20E1_get_opt_ant_tx_pad_oe(data)                              ((0x00000010&(data))>>4)
#define  ATSC_ADDR_20E1_get_opt_ant_oe_pad_oe(data)                              ((0x00000008&(data))>>3)
#define  ATSC_ADDR_20E1_get_opt_ant_tx_end_st13(data)                            ((0x00000004&(data))>>2)
#define  ATSC_ADDR_20E1_get_opt_ant_tx_oe_next_st11(data)                        ((0x00000002&(data))>>1)
#define  ATSC_ADDR_20E1_get_opt_ant_tx_end_st10(data)                            (0x00000001&(data))

#define  ATSC_ADDR_20E2                                                         0x18154388
#define  ATSC_ADDR_20E2_reg_addr                                                 "0xB8154388"
#define  ATSC_ADDR_20E2_reg                                                      0xB8154388
#define  ATSC_ADDR_20E2_inst_addr                                                "0x0058"
#define  set_ATSC_ADDR_20E2_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20E2_reg)=data)
#define  get_ATSC_ADDR_20E2_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20E2_reg))
#define  ATSC_ADDR_20E2_opt_ant_rx_st_det_shift                                  (7)
#define  ATSC_ADDR_20E2_opt_ant_force_det_shift                                  (6)
#define  ATSC_ADDR_20E2_opt_ant_det_inv_shift                                    (5)
#define  ATSC_ADDR_20E2_opt_ant_det_sel_shift                                    (3)
#define  ATSC_ADDR_20E2_opt_ant_rx_inv_shift                                     (2)
#define  ATSC_ADDR_20E2_opt_ant_rx_sel_shift                                     (0)
#define  ATSC_ADDR_20E2_opt_ant_rx_st_det_mask                                   (0x00000080)
#define  ATSC_ADDR_20E2_opt_ant_force_det_mask                                   (0x00000040)
#define  ATSC_ADDR_20E2_opt_ant_det_inv_mask                                     (0x00000020)
#define  ATSC_ADDR_20E2_opt_ant_det_sel_mask                                     (0x00000018)
#define  ATSC_ADDR_20E2_opt_ant_rx_inv_mask                                      (0x00000004)
#define  ATSC_ADDR_20E2_opt_ant_rx_sel_mask                                      (0x00000003)
#define  ATSC_ADDR_20E2_opt_ant_rx_st_det(data)                                  (0x00000080&((data)<<7))
#define  ATSC_ADDR_20E2_opt_ant_force_det(data)                                  (0x00000040&((data)<<6))
#define  ATSC_ADDR_20E2_opt_ant_det_inv(data)                                    (0x00000020&((data)<<5))
#define  ATSC_ADDR_20E2_opt_ant_det_sel(data)                                    (0x00000018&((data)<<3))
#define  ATSC_ADDR_20E2_opt_ant_rx_inv(data)                                     (0x00000004&((data)<<2))
#define  ATSC_ADDR_20E2_opt_ant_rx_sel(data)                                     (0x00000003&(data))
#define  ATSC_ADDR_20E2_get_opt_ant_rx_st_det(data)                              ((0x00000080&(data))>>7)
#define  ATSC_ADDR_20E2_get_opt_ant_force_det(data)                              ((0x00000040&(data))>>6)
#define  ATSC_ADDR_20E2_get_opt_ant_det_inv(data)                                ((0x00000020&(data))>>5)
#define  ATSC_ADDR_20E2_get_opt_ant_det_sel(data)                                ((0x00000018&(data))>>3)
#define  ATSC_ADDR_20E2_get_opt_ant_rx_inv(data)                                 ((0x00000004&(data))>>2)
#define  ATSC_ADDR_20E2_get_opt_ant_rx_sel(data)                                 (0x00000003&(data))

#define  ATSC_ADDR_20F4                                                         0x181543D0
#define  ATSC_ADDR_20F4_reg_addr                                                 "0xB81543D0"
#define  ATSC_ADDR_20F4_reg                                                      0xB81543D0
#define  ATSC_ADDR_20F4_inst_addr                                                "0x0059"
#define  set_ATSC_ADDR_20F4_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20F4_reg)=data)
#define  get_ATSC_ADDR_20F4_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20F4_reg))
#define  ATSC_ADDR_20F4_ant_test_state_shift                                     (4)
#define  ATSC_ADDR_20F4_ant_test_state_mask                                      (0x00000070)
#define  ATSC_ADDR_20F4_ant_test_state(data)                                     (0x00000070&((data)<<4))
#define  ATSC_ADDR_20F4_get_ant_test_state(data)                                 ((0x00000070&(data))>>4)

#define  ATSC_ADDR_20F5                                                         0x181543D4
#define  ATSC_ADDR_20F5_reg_addr                                                 "0xB81543D4"
#define  ATSC_ADDR_20F5_reg                                                      0xB81543D4
#define  ATSC_ADDR_20F5_inst_addr                                                "0x005A"
#define  set_ATSC_ADDR_20F5_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20F5_reg)=data)
#define  get_ATSC_ADDR_20F5_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20F5_reg))
#define  ATSC_ADDR_20F5_ant_tx_state_shift                                       (4)
#define  ATSC_ADDR_20F5_ant_state_shift                                          (0)
#define  ATSC_ADDR_20F5_ant_tx_state_mask                                        (0x000000F0)
#define  ATSC_ADDR_20F5_ant_state_mask                                           (0x0000000F)
#define  ATSC_ADDR_20F5_ant_tx_state(data)                                       (0x000000F0&((data)<<4))
#define  ATSC_ADDR_20F5_ant_state(data)                                          (0x0000000F&(data))
#define  ATSC_ADDR_20F5_get_ant_tx_state(data)                                   ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_20F5_get_ant_state(data)                                      (0x0000000F&(data))

#define  ATSC_ADDR_20F6                                                         0x181543D8
#define  ATSC_ADDR_20F6_reg_addr                                                 "0xB81543D8"
#define  ATSC_ADDR_20F6_reg                                                      0xB81543D8
#define  ATSC_ADDR_20F6_inst_addr                                                "0x005B"
#define  set_ATSC_ADDR_20F6_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20F6_reg)=data)
#define  get_ATSC_ADDR_20F6_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20F6_reg))
#define  ATSC_ADDR_20F6_ant_tx_timeout_hold_shift                                (7)
#define  ATSC_ADDR_20F6_ant_rx_timeout_hold_shift                                (6)
#define  ATSC_ADDR_20F6_ant_init_shift                                           (5)
#define  ATSC_ADDR_20F6_ant_mode_shift                                           (4)
#define  ATSC_ADDR_20F6_ant_rx_state_shift                                       (0)
#define  ATSC_ADDR_20F6_ant_tx_timeout_hold_mask                                 (0x00000080)
#define  ATSC_ADDR_20F6_ant_rx_timeout_hold_mask                                 (0x00000040)
#define  ATSC_ADDR_20F6_ant_init_mask                                            (0x00000020)
#define  ATSC_ADDR_20F6_ant_mode_mask                                            (0x00000010)
#define  ATSC_ADDR_20F6_ant_rx_state_mask                                        (0x0000000F)
#define  ATSC_ADDR_20F6_ant_tx_timeout_hold(data)                                (0x00000080&((data)<<7))
#define  ATSC_ADDR_20F6_ant_rx_timeout_hold(data)                                (0x00000040&((data)<<6))
#define  ATSC_ADDR_20F6_ant_init(data)                                           (0x00000020&((data)<<5))
#define  ATSC_ADDR_20F6_ant_mode(data)                                           (0x00000010&((data)<<4))
#define  ATSC_ADDR_20F6_ant_rx_state(data)                                       (0x0000000F&(data))
#define  ATSC_ADDR_20F6_get_ant_tx_timeout_hold(data)                            ((0x00000080&(data))>>7)
#define  ATSC_ADDR_20F6_get_ant_rx_timeout_hold(data)                            ((0x00000040&(data))>>6)
#define  ATSC_ADDR_20F6_get_ant_init(data)                                       ((0x00000020&(data))>>5)
#define  ATSC_ADDR_20F6_get_ant_mode(data)                                       ((0x00000010&(data))>>4)
#define  ATSC_ADDR_20F6_get_ant_rx_state(data)                                   (0x0000000F&(data))

#define  ATSC_ADDR_20F7                                                         0x181543DC
#define  ATSC_ADDR_20F7_reg_addr                                                 "0xB81543DC"
#define  ATSC_ADDR_20F7_reg                                                      0xB81543DC
#define  ATSC_ADDR_20F7_inst_addr                                                "0x005C"
#define  set_ATSC_ADDR_20F7_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20F7_reg)=data)
#define  get_ATSC_ADDR_20F7_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20F7_reg))
#define  ATSC_ADDR_20F7_ant_tx_bit_cnt_shift                                     (4)
#define  ATSC_ADDR_20F7_ant_rx_bit_cnt_shift                                     (0)
#define  ATSC_ADDR_20F7_ant_tx_bit_cnt_mask                                      (0x000000F0)
#define  ATSC_ADDR_20F7_ant_rx_bit_cnt_mask                                      (0x0000000F)
#define  ATSC_ADDR_20F7_ant_tx_bit_cnt(data)                                     (0x000000F0&((data)<<4))
#define  ATSC_ADDR_20F7_ant_rx_bit_cnt(data)                                     (0x0000000F&(data))
#define  ATSC_ADDR_20F7_get_ant_tx_bit_cnt(data)                                 ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_20F7_get_ant_rx_bit_cnt(data)                                 (0x0000000F&(data))

#define  ATSC_ADDR_20F8                                                         0x181543E0
#define  ATSC_ADDR_20F8_reg_addr                                                 "0xB81543E0"
#define  ATSC_ADDR_20F8_reg                                                      0xB81543E0
#define  ATSC_ADDR_20F8_inst_addr                                                "0x005D"
#define  set_ATSC_ADDR_20F8_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20F8_reg)=data)
#define  get_ATSC_ADDR_20F8_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20F8_reg))
#define  ATSC_ADDR_20F8_ant_pid_7_0_shift                                        (0)
#define  ATSC_ADDR_20F8_ant_pid_7_0_mask                                         (0x000000FF)
#define  ATSC_ADDR_20F8_ant_pid_7_0(data)                                        (0x000000FF&(data))
#define  ATSC_ADDR_20F8_get_ant_pid_7_0(data)                                    (0x000000FF&(data))

#define  ATSC_ADDR_20F9                                                         0x181543E4
#define  ATSC_ADDR_20F9_reg_addr                                                 "0xB81543E4"
#define  ATSC_ADDR_20F9_reg                                                      0xB81543E4
#define  ATSC_ADDR_20F9_inst_addr                                                "0x005E"
#define  set_ATSC_ADDR_20F9_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20F9_reg)=data)
#define  get_ATSC_ADDR_20F9_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20F9_reg))
#define  ATSC_ADDR_20F9_ant_det_signal_shift                                     (5)
#define  ATSC_ADDR_20F9_ant_rx_signal_shift                                      (4)
#define  ATSC_ADDR_20F9_ant_oe_signal_shift                                      (3)
#define  ATSC_ADDR_20F9_ant_tx_signal_shift                                      (2)
#define  ATSC_ADDR_20F9_ant_pid_9_8_shift                                        (0)
#define  ATSC_ADDR_20F9_ant_det_signal_mask                                      (0x00000020)
#define  ATSC_ADDR_20F9_ant_rx_signal_mask                                       (0x00000010)
#define  ATSC_ADDR_20F9_ant_oe_signal_mask                                       (0x00000008)
#define  ATSC_ADDR_20F9_ant_tx_signal_mask                                       (0x00000004)
#define  ATSC_ADDR_20F9_ant_pid_9_8_mask                                         (0x00000003)
#define  ATSC_ADDR_20F9_ant_det_signal(data)                                     (0x00000020&((data)<<5))
#define  ATSC_ADDR_20F9_ant_rx_signal(data)                                      (0x00000010&((data)<<4))
#define  ATSC_ADDR_20F9_ant_oe_signal(data)                                      (0x00000008&((data)<<3))
#define  ATSC_ADDR_20F9_ant_tx_signal(data)                                      (0x00000004&((data)<<2))
#define  ATSC_ADDR_20F9_ant_pid_9_8(data)                                        (0x00000003&(data))
#define  ATSC_ADDR_20F9_get_ant_det_signal(data)                                 ((0x00000020&(data))>>5)
#define  ATSC_ADDR_20F9_get_ant_rx_signal(data)                                  ((0x00000010&(data))>>4)
#define  ATSC_ADDR_20F9_get_ant_oe_signal(data)                                  ((0x00000008&(data))>>3)
#define  ATSC_ADDR_20F9_get_ant_tx_signal(data)                                  ((0x00000004&(data))>>2)
#define  ATSC_ADDR_20F9_get_ant_pid_9_8(data)                                    (0x00000003&(data))

#define  ATSC_ADDR_20FA                                                         0x181543E8
#define  ATSC_ADDR_20FA_reg_addr                                                 "0xB81543E8"
#define  ATSC_ADDR_20FA_reg                                                      0xB81543E8
#define  ATSC_ADDR_20FA_inst_addr                                                "0x005F"
#define  set_ATSC_ADDR_20FA_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20FA_reg)=data)
#define  get_ATSC_ADDR_20FA_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20FA_reg))
#define  ATSC_ADDR_20FA_ant_pid_acc_7_0_shift                                    (0)
#define  ATSC_ADDR_20FA_ant_pid_acc_7_0_mask                                     (0x000000FF)
#define  ATSC_ADDR_20FA_ant_pid_acc_7_0(data)                                    (0x000000FF&(data))
#define  ATSC_ADDR_20FA_get_ant_pid_acc_7_0(data)                                (0x000000FF&(data))

#define  ATSC_ADDR_20FB                                                         0x181543EC
#define  ATSC_ADDR_20FB_reg_addr                                                 "0xB81543EC"
#define  ATSC_ADDR_20FB_reg                                                      0xB81543EC
#define  ATSC_ADDR_20FB_inst_addr                                                "0x0060"
#define  set_ATSC_ADDR_20FB_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_20FB_reg)=data)
#define  get_ATSC_ADDR_20FB_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_20FB_reg))
#define  ATSC_ADDR_20FB_ant_pid_acc_15_8_shift                                   (0)
#define  ATSC_ADDR_20FB_ant_pid_acc_15_8_mask                                    (0x000000FF)
#define  ATSC_ADDR_20FB_ant_pid_acc_15_8(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_20FB_get_ant_pid_acc_15_8(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_2101                                                         0x18154404
#define  ATSC_ADDR_2101_reg_addr                                                 "0xB8154404"
#define  ATSC_ADDR_2101_reg                                                      0xB8154404
#define  ATSC_ADDR_2101_inst_addr                                                "0x0061"
#define  set_ATSC_ADDR_2101_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2101_reg)=data)
#define  get_ATSC_ADDR_2101_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2101_reg))
#define  ATSC_ADDR_2101_adc_clk_ph_inv_shift                                     (0)
#define  ATSC_ADDR_2101_adc_clk_ph_inv_mask                                      (0x00000001)
#define  ATSC_ADDR_2101_adc_clk_ph_inv(data)                                     (0x00000001&(data))
#define  ATSC_ADDR_2101_get_adc_clk_ph_inv(data)                                 (0x00000001&(data))

#define  ATSC_ADDR_2102                                                         0x18154408
#define  ATSC_ADDR_2102_reg_addr                                                 "0xB8154408"
#define  ATSC_ADDR_2102_reg                                                      0xB8154408
#define  ATSC_ADDR_2102_inst_addr                                                "0x0062"
#define  set_ATSC_ADDR_2102_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2102_reg)=data)
#define  get_ATSC_ADDR_2102_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2102_reg))
#define  ATSC_ADDR_2102_agc_init_en_shift                                        (4)
#define  ATSC_ADDR_2102_adc_format_sel_shift                                     (3)
#define  ATSC_ADDR_2102_agc_init_en_mask                                         (0x00000010)
#define  ATSC_ADDR_2102_adc_format_sel_mask                                      (0x00000008)
#define  ATSC_ADDR_2102_agc_init_en(data)                                        (0x00000010&((data)<<4))
#define  ATSC_ADDR_2102_adc_format_sel(data)                                     (0x00000008&((data)<<3))
#define  ATSC_ADDR_2102_get_agc_init_en(data)                                    ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2102_get_adc_format_sel(data)                                 ((0x00000008&(data))>>3)

#define  ATSC_ADDR_2103                                                         0x1815440C
#define  ATSC_ADDR_2103_reg_addr                                                 "0xB815440C"
#define  ATSC_ADDR_2103_reg                                                      0xB815440C
#define  ATSC_ADDR_2103_inst_addr                                                "0x0063"
#define  set_ATSC_ADDR_2103_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2103_reg)=data)
#define  get_ATSC_ADDR_2103_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2103_reg))
#define  ATSC_ADDR_2103_aagc_target_val_shift                                    (0)
#define  ATSC_ADDR_2103_aagc_target_val_mask                                     (0x000000FF)
#define  ATSC_ADDR_2103_aagc_target_val(data)                                    (0x000000FF&(data))
#define  ATSC_ADDR_2103_get_aagc_target_val(data)                                (0x000000FF&(data))

#define  ATSC_ADDR_2104                                                         0x18154410
#define  ATSC_ADDR_2104_reg_addr                                                 "0xB8154410"
#define  ATSC_ADDR_2104_reg                                                      0xB8154410
#define  ATSC_ADDR_2104_inst_addr                                                "0x0064"
#define  set_ATSC_ADDR_2104_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2104_reg)=data)
#define  get_ATSC_ADDR_2104_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2104_reg))
#define  ATSC_ADDR_2104_adc_nb_mode_shift                                        (7)
#define  ATSC_ADDR_2104_adc_nb_on_shift                                          (6)
#define  ATSC_ADDR_2104_agc_mode_shift                                           (5)
#define  ATSC_ADDR_2104_en_if_agc_shift                                          (4)
#define  ATSC_ADDR_2104_en_rf_agc_shift                                          (3)
#define  ATSC_ADDR_2104_agc_manu1_shift                                          (2)
#define  ATSC_ADDR_2104_agc_manu0_shift                                          (1)
#define  ATSC_ADDR_2104_agc_polar_shift                                          (0)
#define  ATSC_ADDR_2104_adc_nb_mode_mask                                         (0x00000080)
#define  ATSC_ADDR_2104_adc_nb_on_mask                                           (0x00000040)
#define  ATSC_ADDR_2104_agc_mode_mask                                            (0x00000020)
#define  ATSC_ADDR_2104_en_if_agc_mask                                           (0x00000010)
#define  ATSC_ADDR_2104_en_rf_agc_mask                                           (0x00000008)
#define  ATSC_ADDR_2104_agc_manu1_mask                                           (0x00000004)
#define  ATSC_ADDR_2104_agc_manu0_mask                                           (0x00000002)
#define  ATSC_ADDR_2104_agc_polar_mask                                           (0x00000001)
#define  ATSC_ADDR_2104_adc_nb_mode(data)                                        (0x00000080&((data)<<7))
#define  ATSC_ADDR_2104_adc_nb_on(data)                                          (0x00000040&((data)<<6))
#define  ATSC_ADDR_2104_agc_mode(data)                                           (0x00000020&((data)<<5))
#define  ATSC_ADDR_2104_en_if_agc(data)                                          (0x00000010&((data)<<4))
#define  ATSC_ADDR_2104_en_rf_agc(data)                                          (0x00000008&((data)<<3))
#define  ATSC_ADDR_2104_agc_manu1(data)                                          (0x00000004&((data)<<2))
#define  ATSC_ADDR_2104_agc_manu0(data)                                          (0x00000002&((data)<<1))
#define  ATSC_ADDR_2104_agc_polar(data)                                          (0x00000001&(data))
#define  ATSC_ADDR_2104_get_adc_nb_mode(data)                                    ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2104_get_adc_nb_on(data)                                      ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2104_get_agc_mode(data)                                       ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2104_get_en_if_agc(data)                                      ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2104_get_en_rf_agc(data)                                      ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2104_get_agc_manu1(data)                                      ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2104_get_agc_manu0(data)                                      ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2104_get_agc_polar(data)                                      (0x00000001&(data))

#define  ATSC_ADDR_2105                                                         0x18154414
#define  ATSC_ADDR_2105_reg_addr                                                 "0xB8154414"
#define  ATSC_ADDR_2105_reg                                                      0xB8154414
#define  ATSC_ADDR_2105_inst_addr                                                "0x0065"
#define  set_ATSC_ADDR_2105_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2105_reg)=data)
#define  get_ATSC_ADDR_2105_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2105_reg))
#define  ATSC_ADDR_2105_agc_manu_val_shift                                       (0)
#define  ATSC_ADDR_2105_agc_manu_val_mask                                        (0x000000FF)
#define  ATSC_ADDR_2105_agc_manu_val(data)                                       (0x000000FF&(data))
#define  ATSC_ADDR_2105_get_agc_manu_val(data)                                   (0x000000FF&(data))

#define  ATSC_ADDR_2106                                                         0x18154418
#define  ATSC_ADDR_2106_reg_addr                                                 "0xB8154418"
#define  ATSC_ADDR_2106_reg                                                      0xB8154418
#define  ATSC_ADDR_2106_inst_addr                                                "0x0066"
#define  set_ATSC_ADDR_2106_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2106_reg)=data)
#define  get_ATSC_ADDR_2106_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2106_reg))
#define  ATSC_ADDR_2106_agc_rf_manu_val_shift                                    (0)
#define  ATSC_ADDR_2106_agc_rf_manu_val_mask                                     (0x000000FF)
#define  ATSC_ADDR_2106_agc_rf_manu_val(data)                                    (0x000000FF&(data))
#define  ATSC_ADDR_2106_get_agc_rf_manu_val(data)                                (0x000000FF&(data))

#define  ATSC_ADDR_2107                                                         0x1815441C
#define  ATSC_ADDR_2107_reg_addr                                                 "0xB815441C"
#define  ATSC_ADDR_2107_reg                                                      0xB815441C
#define  ATSC_ADDR_2107_inst_addr                                                "0x0067"
#define  set_ATSC_ADDR_2107_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2107_reg)=data)
#define  get_ATSC_ADDR_2107_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2107_reg))
#define  ATSC_ADDR_2107_agc_if_manu_val_shift                                    (0)
#define  ATSC_ADDR_2107_agc_if_manu_val_mask                                     (0x000000FF)
#define  ATSC_ADDR_2107_agc_if_manu_val(data)                                    (0x000000FF&(data))
#define  ATSC_ADDR_2107_get_agc_if_manu_val(data)                                (0x000000FF&(data))

#define  ATSC_ADDR_2108                                                         0x18154420
#define  ATSC_ADDR_2108_reg_addr                                                 "0xB8154420"
#define  ATSC_ADDR_2108_reg                                                      0xB8154420
#define  ATSC_ADDR_2108_inst_addr                                                "0x0068"
#define  set_ATSC_ADDR_2108_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2108_reg)=data)
#define  get_ATSC_ADDR_2108_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2108_reg))
#define  ATSC_ADDR_2108_vtop_shift                                               (0)
#define  ATSC_ADDR_2108_vtop_mask                                                (0x0000007F)
#define  ATSC_ADDR_2108_vtop(data)                                               (0x0000007F&(data))
#define  ATSC_ADDR_2108_get_vtop(data)                                           (0x0000007F&(data))

#define  ATSC_ADDR_2109                                                         0x18154424
#define  ATSC_ADDR_2109_reg_addr                                                 "0xB8154424"
#define  ATSC_ADDR_2109_reg                                                      0xB8154424
#define  ATSC_ADDR_2109_inst_addr                                                "0x0069"
#define  set_ATSC_ADDR_2109_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2109_reg)=data)
#define  get_ATSC_ADDR_2109_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2109_reg))
#define  ATSC_ADDR_2109_krf_shift                                                (0)
#define  ATSC_ADDR_2109_krf_mask                                                 (0x0000003F)
#define  ATSC_ADDR_2109_krf(data)                                                (0x0000003F&(data))
#define  ATSC_ADDR_2109_get_krf(data)                                            (0x0000003F&(data))

#define  ATSC_ADDR_210A                                                         0x18154428
#define  ATSC_ADDR_210A_reg_addr                                                 "0xB8154428"
#define  ATSC_ADDR_210A_reg                                                      0xB8154428
#define  ATSC_ADDR_210A_inst_addr                                                "0x006A"
#define  set_ATSC_ADDR_210A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_210A_reg)=data)
#define  get_ATSC_ADDR_210A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_210A_reg))
#define  ATSC_ADDR_210A_if_agc_min_shift                                         (0)
#define  ATSC_ADDR_210A_if_agc_min_mask                                          (0x000000FF)
#define  ATSC_ADDR_210A_if_agc_min(data)                                         (0x000000FF&(data))
#define  ATSC_ADDR_210A_get_if_agc_min(data)                                     (0x000000FF&(data))

#define  ATSC_ADDR_210B                                                         0x1815442C
#define  ATSC_ADDR_210B_reg_addr                                                 "0xB815442C"
#define  ATSC_ADDR_210B_reg                                                      0xB815442C
#define  ATSC_ADDR_210B_inst_addr                                                "0x006B"
#define  set_ATSC_ADDR_210B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_210B_reg)=data)
#define  get_ATSC_ADDR_210B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_210B_reg))
#define  ATSC_ADDR_210B_if_agc_max_shift                                         (0)
#define  ATSC_ADDR_210B_if_agc_max_mask                                          (0x000000FF)
#define  ATSC_ADDR_210B_if_agc_max(data)                                         (0x000000FF&(data))
#define  ATSC_ADDR_210B_get_if_agc_max(data)                                     (0x000000FF&(data))

#define  ATSC_ADDR_210C                                                         0x18154430
#define  ATSC_ADDR_210C_reg_addr                                                 "0xB8154430"
#define  ATSC_ADDR_210C_reg                                                      0xB8154430
#define  ATSC_ADDR_210C_inst_addr                                                "0x006C"
#define  set_ATSC_ADDR_210C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_210C_reg)=data)
#define  get_ATSC_ADDR_210C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_210C_reg))
#define  ATSC_ADDR_210C_rf_agc_min_shift                                         (0)
#define  ATSC_ADDR_210C_rf_agc_min_mask                                          (0x000000FF)
#define  ATSC_ADDR_210C_rf_agc_min(data)                                         (0x000000FF&(data))
#define  ATSC_ADDR_210C_get_rf_agc_min(data)                                     (0x000000FF&(data))

#define  ATSC_ADDR_210D                                                         0x18154434
#define  ATSC_ADDR_210D_reg_addr                                                 "0xB8154434"
#define  ATSC_ADDR_210D_reg                                                      0xB8154434
#define  ATSC_ADDR_210D_inst_addr                                                "0x006D"
#define  set_ATSC_ADDR_210D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_210D_reg)=data)
#define  get_ATSC_ADDR_210D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_210D_reg))
#define  ATSC_ADDR_210D_rf_agc_max_shift                                         (0)
#define  ATSC_ADDR_210D_rf_agc_max_mask                                          (0x000000FF)
#define  ATSC_ADDR_210D_rf_agc_max(data)                                         (0x000000FF&(data))
#define  ATSC_ADDR_210D_get_rf_agc_max(data)                                     (0x000000FF&(data))

#define  ATSC_ADDR_210E                                                         0x18154438
#define  ATSC_ADDR_210E_reg_addr                                                 "0xB8154438"
#define  ATSC_ADDR_210E_reg                                                      0xB8154438
#define  ATSC_ADDR_210E_inst_addr                                                "0x006E"
#define  set_ATSC_ADDR_210E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_210E_reg)=data)
#define  get_ATSC_ADDR_210E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_210E_reg))
#define  ATSC_ADDR_210E_agc_lock_cnt_len_off_shift                               (4)
#define  ATSC_ADDR_210E_agc_lock_th_shift                                        (0)
#define  ATSC_ADDR_210E_agc_lock_cnt_len_off_mask                                (0x00000030)
#define  ATSC_ADDR_210E_agc_lock_th_mask                                         (0x0000000F)
#define  ATSC_ADDR_210E_agc_lock_cnt_len_off(data)                               (0x00000030&((data)<<4))
#define  ATSC_ADDR_210E_agc_lock_th(data)                                        (0x0000000F&(data))
#define  ATSC_ADDR_210E_get_agc_lock_cnt_len_off(data)                           ((0x00000030&(data))>>4)
#define  ATSC_ADDR_210E_get_agc_lock_th(data)                                    (0x0000000F&(data))

#define  ATSC_ADDR_210F                                                         0x1815443C
#define  ATSC_ADDR_210F_reg_addr                                                 "0xB815443C"
#define  ATSC_ADDR_210F_reg                                                      0xB815443C
#define  ATSC_ADDR_210F_inst_addr                                                "0x006F"
#define  set_ATSC_ADDR_210F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_210F_reg)=data)
#define  get_ATSC_ADDR_210F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_210F_reg))
#define  ATSC_ADDR_210F_ddc_phase_inc_7_0_shift                                  (0)
#define  ATSC_ADDR_210F_ddc_phase_inc_7_0_mask                                   (0x000000FF)
#define  ATSC_ADDR_210F_ddc_phase_inc_7_0(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_210F_get_ddc_phase_inc_7_0(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2110                                                         0x18154440
#define  ATSC_ADDR_2110_reg_addr                                                 "0xB8154440"
#define  ATSC_ADDR_2110_reg                                                      0xB8154440
#define  ATSC_ADDR_2110_inst_addr                                                "0x0070"
#define  set_ATSC_ADDR_2110_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2110_reg)=data)
#define  get_ATSC_ADDR_2110_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2110_reg))
#define  ATSC_ADDR_2110_ddc_phase_inc_15_8_shift                                 (0)
#define  ATSC_ADDR_2110_ddc_phase_inc_15_8_mask                                  (0x000000FF)
#define  ATSC_ADDR_2110_ddc_phase_inc_15_8(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2110_get_ddc_phase_inc_15_8(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2111                                                         0x18154444
#define  ATSC_ADDR_2111_reg_addr                                                 "0xB8154444"
#define  ATSC_ADDR_2111_reg                                                      0xB8154444
#define  ATSC_ADDR_2111_inst_addr                                                "0x0071"
#define  set_ATSC_ADDR_2111_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2111_reg)=data)
#define  get_ATSC_ADDR_2111_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2111_reg))
#define  ATSC_ADDR_2111_spec_inv_on_shift                                        (4)
#define  ATSC_ADDR_2111_ddc_phase_inc_19_16_shift                                (0)
#define  ATSC_ADDR_2111_spec_inv_on_mask                                         (0x00000010)
#define  ATSC_ADDR_2111_ddc_phase_inc_19_16_mask                                 (0x0000000F)
#define  ATSC_ADDR_2111_spec_inv_on(data)                                        (0x00000010&((data)<<4))
#define  ATSC_ADDR_2111_ddc_phase_inc_19_16(data)                                (0x0000000F&(data))
#define  ATSC_ADDR_2111_get_spec_inv_on(data)                                    ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2111_get_ddc_phase_inc_19_16(data)                            (0x0000000F&(data))

#define  ATSC_ADDR_2112                                                         0x18154448
#define  ATSC_ADDR_2112_reg_addr                                                 "0xB8154448"
#define  ATSC_ADDR_2112_reg                                                      0xB8154448
#define  ATSC_ADDR_2112_inst_addr                                                "0x0072"
#define  set_ATSC_ADDR_2112_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2112_reg)=data)
#define  get_ATSC_ADDR_2112_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2112_reg))
#define  ATSC_ADDR_2112_down_converter_coef_0_7_0_shift                          (0)
#define  ATSC_ADDR_2112_down_converter_coef_0_7_0_mask                           (0x000000FF)
#define  ATSC_ADDR_2112_down_converter_coef_0_7_0(data)                          (0x000000FF&(data))
#define  ATSC_ADDR_2112_get_down_converter_coef_0_7_0(data)                      (0x000000FF&(data))

#define  ATSC_ADDR_2113                                                         0x1815444C
#define  ATSC_ADDR_2113_reg_addr                                                 "0xB815444C"
#define  ATSC_ADDR_2113_reg                                                      0xB815444C
#define  ATSC_ADDR_2113_inst_addr                                                "0x0073"
#define  set_ATSC_ADDR_2113_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2113_reg)=data)
#define  get_ATSC_ADDR_2113_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2113_reg))
#define  ATSC_ADDR_2113_down_converter_coef_0_9_8_shift                          (0)
#define  ATSC_ADDR_2113_down_converter_coef_0_9_8_mask                           (0x00000003)
#define  ATSC_ADDR_2113_down_converter_coef_0_9_8(data)                          (0x00000003&(data))
#define  ATSC_ADDR_2113_get_down_converter_coef_0_9_8(data)                      (0x00000003&(data))

#define  ATSC_ADDR_2114                                                         0x18154450
#define  ATSC_ADDR_2114_reg_addr                                                 "0xB8154450"
#define  ATSC_ADDR_2114_reg                                                      0xB8154450
#define  ATSC_ADDR_2114_inst_addr                                                "0x0074"
#define  set_ATSC_ADDR_2114_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2114_reg)=data)
#define  get_ATSC_ADDR_2114_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2114_reg))
#define  ATSC_ADDR_2114_down_converter_coef_1_7_0_shift                          (0)
#define  ATSC_ADDR_2114_down_converter_coef_1_7_0_mask                           (0x000000FF)
#define  ATSC_ADDR_2114_down_converter_coef_1_7_0(data)                          (0x000000FF&(data))
#define  ATSC_ADDR_2114_get_down_converter_coef_1_7_0(data)                      (0x000000FF&(data))

#define  ATSC_ADDR_2115                                                         0x18154454
#define  ATSC_ADDR_2115_reg_addr                                                 "0xB8154454"
#define  ATSC_ADDR_2115_reg                                                      0xB8154454
#define  ATSC_ADDR_2115_inst_addr                                                "0x0075"
#define  set_ATSC_ADDR_2115_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2115_reg)=data)
#define  get_ATSC_ADDR_2115_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2115_reg))
#define  ATSC_ADDR_2115_down_converter_coef_1_9_8_shift                          (0)
#define  ATSC_ADDR_2115_down_converter_coef_1_9_8_mask                           (0x00000003)
#define  ATSC_ADDR_2115_down_converter_coef_1_9_8(data)                          (0x00000003&(data))
#define  ATSC_ADDR_2115_get_down_converter_coef_1_9_8(data)                      (0x00000003&(data))

#define  ATSC_ADDR_2116                                                         0x18154458
#define  ATSC_ADDR_2116_reg_addr                                                 "0xB8154458"
#define  ATSC_ADDR_2116_reg                                                      0xB8154458
#define  ATSC_ADDR_2116_inst_addr                                                "0x0076"
#define  set_ATSC_ADDR_2116_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2116_reg)=data)
#define  get_ATSC_ADDR_2116_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2116_reg))
#define  ATSC_ADDR_2116_down_converter_coef_2_7_0_shift                          (0)
#define  ATSC_ADDR_2116_down_converter_coef_2_7_0_mask                           (0x000000FF)
#define  ATSC_ADDR_2116_down_converter_coef_2_7_0(data)                          (0x000000FF&(data))
#define  ATSC_ADDR_2116_get_down_converter_coef_2_7_0(data)                      (0x000000FF&(data))

#define  ATSC_ADDR_2117                                                         0x1815445C
#define  ATSC_ADDR_2117_reg_addr                                                 "0xB815445C"
#define  ATSC_ADDR_2117_reg                                                      0xB815445C
#define  ATSC_ADDR_2117_inst_addr                                                "0x0077"
#define  set_ATSC_ADDR_2117_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2117_reg)=data)
#define  get_ATSC_ADDR_2117_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2117_reg))
#define  ATSC_ADDR_2117_down_converter_coef_2_9_8_shift                          (0)
#define  ATSC_ADDR_2117_down_converter_coef_2_9_8_mask                           (0x00000003)
#define  ATSC_ADDR_2117_down_converter_coef_2_9_8(data)                          (0x00000003&(data))
#define  ATSC_ADDR_2117_get_down_converter_coef_2_9_8(data)                      (0x00000003&(data))

#define  ATSC_ADDR_2118                                                         0x18154460
#define  ATSC_ADDR_2118_reg_addr                                                 "0xB8154460"
#define  ATSC_ADDR_2118_reg                                                      0xB8154460
#define  ATSC_ADDR_2118_inst_addr                                                "0x0078"
#define  set_ATSC_ADDR_2118_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2118_reg)=data)
#define  get_ATSC_ADDR_2118_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2118_reg))
#define  ATSC_ADDR_2118_down_converter_coef_3_7_0_shift                          (0)
#define  ATSC_ADDR_2118_down_converter_coef_3_7_0_mask                           (0x000000FF)
#define  ATSC_ADDR_2118_down_converter_coef_3_7_0(data)                          (0x000000FF&(data))
#define  ATSC_ADDR_2118_get_down_converter_coef_3_7_0(data)                      (0x000000FF&(data))

#define  ATSC_ADDR_2119                                                         0x18154464
#define  ATSC_ADDR_2119_reg_addr                                                 "0xB8154464"
#define  ATSC_ADDR_2119_reg                                                      0xB8154464
#define  ATSC_ADDR_2119_inst_addr                                                "0x0079"
#define  set_ATSC_ADDR_2119_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2119_reg)=data)
#define  get_ATSC_ADDR_2119_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2119_reg))
#define  ATSC_ADDR_2119_down_converter_coef_3_9_8_shift                          (0)
#define  ATSC_ADDR_2119_down_converter_coef_3_9_8_mask                           (0x00000003)
#define  ATSC_ADDR_2119_down_converter_coef_3_9_8(data)                          (0x00000003&(data))
#define  ATSC_ADDR_2119_get_down_converter_coef_3_9_8(data)                      (0x00000003&(data))

#define  ATSC_ADDR_211A                                                         0x18154468
#define  ATSC_ADDR_211A_reg_addr                                                 "0xB8154468"
#define  ATSC_ADDR_211A_reg                                                      0xB8154468
#define  ATSC_ADDR_211A_inst_addr                                                "0x007A"
#define  set_ATSC_ADDR_211A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_211A_reg)=data)
#define  get_ATSC_ADDR_211A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_211A_reg))
#define  ATSC_ADDR_211A_down_converter_coef_4_7_0_shift                          (0)
#define  ATSC_ADDR_211A_down_converter_coef_4_7_0_mask                           (0x000000FF)
#define  ATSC_ADDR_211A_down_converter_coef_4_7_0(data)                          (0x000000FF&(data))
#define  ATSC_ADDR_211A_get_down_converter_coef_4_7_0(data)                      (0x000000FF&(data))

#define  ATSC_ADDR_211B                                                         0x1815446C
#define  ATSC_ADDR_211B_reg_addr                                                 "0xB815446C"
#define  ATSC_ADDR_211B_reg                                                      0xB815446C
#define  ATSC_ADDR_211B_inst_addr                                                "0x007B"
#define  set_ATSC_ADDR_211B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_211B_reg)=data)
#define  get_ATSC_ADDR_211B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_211B_reg))
#define  ATSC_ADDR_211B_down_converter_coef_4_9_8_shift                          (0)
#define  ATSC_ADDR_211B_down_converter_coef_4_9_8_mask                           (0x00000003)
#define  ATSC_ADDR_211B_down_converter_coef_4_9_8(data)                          (0x00000003&(data))
#define  ATSC_ADDR_211B_get_down_converter_coef_4_9_8(data)                      (0x00000003&(data))

#define  ATSC_ADDR_211C                                                         0x18154470
#define  ATSC_ADDR_211C_reg_addr                                                 "0xB8154470"
#define  ATSC_ADDR_211C_reg                                                      0xB8154470
#define  ATSC_ADDR_211C_inst_addr                                                "0x007C"
#define  set_ATSC_ADDR_211C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_211C_reg)=data)
#define  get_ATSC_ADDR_211C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_211C_reg))
#define  ATSC_ADDR_211C_down_converter_coef_5_7_0_shift                          (0)
#define  ATSC_ADDR_211C_down_converter_coef_5_7_0_mask                           (0x000000FF)
#define  ATSC_ADDR_211C_down_converter_coef_5_7_0(data)                          (0x000000FF&(data))
#define  ATSC_ADDR_211C_get_down_converter_coef_5_7_0(data)                      (0x000000FF&(data))

#define  ATSC_ADDR_211D                                                         0x18154474
#define  ATSC_ADDR_211D_reg_addr                                                 "0xB8154474"
#define  ATSC_ADDR_211D_reg                                                      0xB8154474
#define  ATSC_ADDR_211D_inst_addr                                                "0x007D"
#define  set_ATSC_ADDR_211D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_211D_reg)=data)
#define  get_ATSC_ADDR_211D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_211D_reg))
#define  ATSC_ADDR_211D_down_converter_coef_5_9_8_shift                          (0)
#define  ATSC_ADDR_211D_down_converter_coef_5_9_8_mask                           (0x00000003)
#define  ATSC_ADDR_211D_down_converter_coef_5_9_8(data)                          (0x00000003&(data))
#define  ATSC_ADDR_211D_get_down_converter_coef_5_9_8(data)                      (0x00000003&(data))

#define  ATSC_ADDR_211E                                                         0x18154478
#define  ATSC_ADDR_211E_reg_addr                                                 "0xB8154478"
#define  ATSC_ADDR_211E_reg                                                      0xB8154478
#define  ATSC_ADDR_211E_inst_addr                                                "0x007E"
#define  set_ATSC_ADDR_211E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_211E_reg)=data)
#define  get_ATSC_ADDR_211E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_211E_reg))
#define  ATSC_ADDR_211E_down_converter_coef_6_7_0_shift                          (0)
#define  ATSC_ADDR_211E_down_converter_coef_6_7_0_mask                           (0x000000FF)
#define  ATSC_ADDR_211E_down_converter_coef_6_7_0(data)                          (0x000000FF&(data))
#define  ATSC_ADDR_211E_get_down_converter_coef_6_7_0(data)                      (0x000000FF&(data))

#define  ATSC_ADDR_211F                                                         0x1815447C
#define  ATSC_ADDR_211F_reg_addr                                                 "0xB815447C"
#define  ATSC_ADDR_211F_reg                                                      0xB815447C
#define  ATSC_ADDR_211F_inst_addr                                                "0x007F"
#define  set_ATSC_ADDR_211F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_211F_reg)=data)
#define  get_ATSC_ADDR_211F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_211F_reg))
#define  ATSC_ADDR_211F_down_converter_coef_6_9_8_shift                          (0)
#define  ATSC_ADDR_211F_down_converter_coef_6_9_8_mask                           (0x00000003)
#define  ATSC_ADDR_211F_down_converter_coef_6_9_8(data)                          (0x00000003&(data))
#define  ATSC_ADDR_211F_get_down_converter_coef_6_9_8(data)                      (0x00000003&(data))

#define  ATSC_ADDR_2120                                                         0x18154480
#define  ATSC_ADDR_2120_reg_addr                                                 "0xB8154480"
#define  ATSC_ADDR_2120_reg                                                      0xB8154480
#define  ATSC_ADDR_2120_inst_addr                                                "0x0080"
#define  set_ATSC_ADDR_2120_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2120_reg)=data)
#define  get_ATSC_ADDR_2120_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2120_reg))
#define  ATSC_ADDR_2120_down_converter_coef_7_7_0_shift                          (0)
#define  ATSC_ADDR_2120_down_converter_coef_7_7_0_mask                           (0x000000FF)
#define  ATSC_ADDR_2120_down_converter_coef_7_7_0(data)                          (0x000000FF&(data))
#define  ATSC_ADDR_2120_get_down_converter_coef_7_7_0(data)                      (0x000000FF&(data))

#define  ATSC_ADDR_2121                                                         0x18154484
#define  ATSC_ADDR_2121_reg_addr                                                 "0xB8154484"
#define  ATSC_ADDR_2121_reg                                                      0xB8154484
#define  ATSC_ADDR_2121_inst_addr                                                "0x0081"
#define  set_ATSC_ADDR_2121_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2121_reg)=data)
#define  get_ATSC_ADDR_2121_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2121_reg))
#define  ATSC_ADDR_2121_down_converter_coef_7_9_8_shift                          (0)
#define  ATSC_ADDR_2121_down_converter_coef_7_9_8_mask                           (0x00000003)
#define  ATSC_ADDR_2121_down_converter_coef_7_9_8(data)                          (0x00000003&(data))
#define  ATSC_ADDR_2121_get_down_converter_coef_7_9_8(data)                      (0x00000003&(data))

#define  ATSC_ADDR_2122                                                         0x18154488
#define  ATSC_ADDR_2122_reg_addr                                                 "0xB8154488"
#define  ATSC_ADDR_2122_reg                                                      0xB8154488
#define  ATSC_ADDR_2122_inst_addr                                                "0x0082"
#define  set_ATSC_ADDR_2122_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2122_reg)=data)
#define  get_ATSC_ADDR_2122_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2122_reg))
#define  ATSC_ADDR_2122_agc_tune_period_exp_shift                                (5)
#define  ATSC_ADDR_2122_agc_tune_step_shift                                      (3)
#define  ATSC_ADDR_2122_agc_tune_en_shift                                        (2)
#define  ATSC_ADDR_2122_adc_trunc_bits_shift                                     (0)
#define  ATSC_ADDR_2122_agc_tune_period_exp_mask                                 (0x000000E0)
#define  ATSC_ADDR_2122_agc_tune_step_mask                                       (0x00000018)
#define  ATSC_ADDR_2122_agc_tune_en_mask                                         (0x00000004)
#define  ATSC_ADDR_2122_adc_trunc_bits_mask                                      (0x00000003)
#define  ATSC_ADDR_2122_agc_tune_period_exp(data)                                (0x000000E0&((data)<<5))
#define  ATSC_ADDR_2122_agc_tune_step(data)                                      (0x00000018&((data)<<3))
#define  ATSC_ADDR_2122_agc_tune_en(data)                                        (0x00000004&((data)<<2))
#define  ATSC_ADDR_2122_adc_trunc_bits(data)                                     (0x00000003&(data))
#define  ATSC_ADDR_2122_get_agc_tune_period_exp(data)                            ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_2122_get_agc_tune_step(data)                                  ((0x00000018&(data))>>3)
#define  ATSC_ADDR_2122_get_agc_tune_en(data)                                    ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2122_get_adc_trunc_bits(data)                                 (0x00000003&(data))

#define  ATSC_ADDR_2123                                                         0x1815448C
#define  ATSC_ADDR_2123_reg_addr                                                 "0xB815448C"
#define  ATSC_ADDR_2123_reg                                                      0xB815448C
#define  ATSC_ADDR_2123_inst_addr                                                "0x0083"
#define  set_ATSC_ADDR_2123_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2123_reg)=data)
#define  get_ATSC_ADDR_2123_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2123_reg))
#define  ATSC_ADDR_2123_agc_tune_period_wait_shift                               (0)
#define  ATSC_ADDR_2123_agc_tune_period_wait_mask                                (0x000000FF)
#define  ATSC_ADDR_2123_agc_tune_period_wait(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_2123_get_agc_tune_period_wait(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_2124                                                         0x18154490
#define  ATSC_ADDR_2124_reg_addr                                                 "0xB8154490"
#define  ATSC_ADDR_2124_reg                                                      0xB8154490
#define  ATSC_ADDR_2124_inst_addr                                                "0x0084"
#define  set_ATSC_ADDR_2124_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2124_reg)=data)
#define  get_ATSC_ADDR_2124_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2124_reg))
#define  ATSC_ADDR_2124_agc_tune_upper_th_shift                                  (0)
#define  ATSC_ADDR_2124_agc_tune_upper_th_mask                                   (0x000000FF)
#define  ATSC_ADDR_2124_agc_tune_upper_th(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2124_get_agc_tune_upper_th(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2125                                                         0x18154494
#define  ATSC_ADDR_2125_reg_addr                                                 "0xB8154494"
#define  ATSC_ADDR_2125_reg                                                      0xB8154494
#define  ATSC_ADDR_2125_inst_addr                                                "0x0085"
#define  set_ATSC_ADDR_2125_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2125_reg)=data)
#define  get_ATSC_ADDR_2125_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2125_reg))
#define  ATSC_ADDR_2125_agc_tune_lower_th_shift                                  (0)
#define  ATSC_ADDR_2125_agc_tune_lower_th_mask                                   (0x000000FF)
#define  ATSC_ADDR_2125_agc_tune_lower_th(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2125_get_agc_tune_lower_th(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2126                                                         0x18154498
#define  ATSC_ADDR_2126_reg_addr                                                 "0xB8154498"
#define  ATSC_ADDR_2126_reg                                                      0xB8154498
#define  ATSC_ADDR_2126_inst_addr                                                "0x0086"
#define  set_ATSC_ADDR_2126_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2126_reg)=data)
#define  get_ATSC_ADDR_2126_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2126_reg))
#define  ATSC_ADDR_2126_agc_tune_bn_stop_shift                                   (4)
#define  ATSC_ADDR_2126_agc_max_sat_sel_2_shift                                  (3)
#define  ATSC_ADDR_2126_agc_max_sat_sel_1_shift                                  (1)
#define  ATSC_ADDR_2126_agc_tune_sat_opt_shift                                   (0)
#define  ATSC_ADDR_2126_agc_tune_bn_stop_mask                                    (0x00000010)
#define  ATSC_ADDR_2126_agc_max_sat_sel_2_mask                                   (0x00000008)
#define  ATSC_ADDR_2126_agc_max_sat_sel_1_mask                                   (0x00000006)
#define  ATSC_ADDR_2126_agc_tune_sat_opt_mask                                    (0x00000001)
#define  ATSC_ADDR_2126_agc_tune_bn_stop(data)                                   (0x00000010&((data)<<4))
#define  ATSC_ADDR_2126_agc_max_sat_sel_2(data)                                  (0x00000008&((data)<<3))
#define  ATSC_ADDR_2126_agc_max_sat_sel_1(data)                                  (0x00000006&((data)<<1))
#define  ATSC_ADDR_2126_agc_tune_sat_opt(data)                                   (0x00000001&(data))
#define  ATSC_ADDR_2126_get_agc_tune_bn_stop(data)                               ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2126_get_agc_max_sat_sel_2(data)                              ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2126_get_agc_max_sat_sel_1(data)                              ((0x00000006&(data))>>1)
#define  ATSC_ADDR_2126_get_agc_tune_sat_opt(data)                               (0x00000001&(data))

#define  ATSC_ADDR_2127                                                         0x1815449C
#define  ATSC_ADDR_2127_reg_addr                                                 "0xB815449C"
#define  ATSC_ADDR_2127_reg                                                      0xB815449C
#define  ATSC_ADDR_2127_inst_addr                                                "0x0087"
#define  set_ATSC_ADDR_2127_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2127_reg)=data)
#define  get_ATSC_ADDR_2127_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2127_reg))
#define  ATSC_ADDR_2127_agc_tune_min_shift                                       (0)
#define  ATSC_ADDR_2127_agc_tune_min_mask                                        (0x000000FF)
#define  ATSC_ADDR_2127_agc_tune_min(data)                                       (0x000000FF&(data))
#define  ATSC_ADDR_2127_get_agc_tune_min(data)                                   (0x000000FF&(data))

#define  ATSC_ADDR_2128                                                         0x181544A0
#define  ATSC_ADDR_2128_reg_addr                                                 "0xB81544A0"
#define  ATSC_ADDR_2128_reg                                                      0xB81544A0
#define  ATSC_ADDR_2128_inst_addr                                                "0x0088"
#define  set_ATSC_ADDR_2128_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2128_reg)=data)
#define  get_ATSC_ADDR_2128_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2128_reg))
#define  ATSC_ADDR_2128_agc_tune_max_shift                                       (0)
#define  ATSC_ADDR_2128_agc_tune_max_mask                                        (0x000000FF)
#define  ATSC_ADDR_2128_agc_tune_max(data)                                       (0x000000FF&(data))
#define  ATSC_ADDR_2128_get_agc_tune_max(data)                                   (0x000000FF&(data))

#define  ATSC_ADDR_2129                                                         0x181544A4
#define  ATSC_ADDR_2129_reg_addr                                                 "0xB81544A4"
#define  ATSC_ADDR_2129_reg                                                      0xB81544A4
#define  ATSC_ADDR_2129_inst_addr                                                "0x0089"
#define  set_ATSC_ADDR_2129_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2129_reg)=data)
#define  get_ATSC_ADDR_2129_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2129_reg))
#define  ATSC_ADDR_2129_agc_tune_max_sat_shift                                   (0)
#define  ATSC_ADDR_2129_agc_tune_max_sat_mask                                    (0x000000FF)
#define  ATSC_ADDR_2129_agc_tune_max_sat(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_2129_get_agc_tune_max_sat(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_212A                                                         0x181544A8
#define  ATSC_ADDR_212A_reg_addr                                                 "0xB81544A8"
#define  ATSC_ADDR_212A_reg                                                      0xB81544A8
#define  ATSC_ADDR_212A_inst_addr                                                "0x008A"
#define  set_ATSC_ADDR_212A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_212A_reg)=data)
#define  get_ATSC_ADDR_212A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_212A_reg))
#define  ATSC_ADDR_212A_adc_clip_block_size_7_0_shift                            (0)
#define  ATSC_ADDR_212A_adc_clip_block_size_7_0_mask                             (0x000000FF)
#define  ATSC_ADDR_212A_adc_clip_block_size_7_0(data)                            (0x000000FF&(data))
#define  ATSC_ADDR_212A_get_adc_clip_block_size_7_0(data)                        (0x000000FF&(data))

#define  ATSC_ADDR_212B                                                         0x181544AC
#define  ATSC_ADDR_212B_reg_addr                                                 "0xB81544AC"
#define  ATSC_ADDR_212B_reg                                                      0xB81544AC
#define  ATSC_ADDR_212B_inst_addr                                                "0x008B"
#define  set_ATSC_ADDR_212B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_212B_reg)=data)
#define  get_ATSC_ADDR_212B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_212B_reg))
#define  ATSC_ADDR_212B_adc_clip_block_size_15_8_shift                           (0)
#define  ATSC_ADDR_212B_adc_clip_block_size_15_8_mask                            (0x000000FF)
#define  ATSC_ADDR_212B_adc_clip_block_size_15_8(data)                           (0x000000FF&(data))
#define  ATSC_ADDR_212B_get_adc_clip_block_size_15_8(data)                       (0x000000FF&(data))

#define  ATSC_ADDR_212C                                                         0x181544B0
#define  ATSC_ADDR_212C_reg_addr                                                 "0xB81544B0"
#define  ATSC_ADDR_212C_reg                                                      0xB81544B0
#define  ATSC_ADDR_212C_inst_addr                                                "0x008C"
#define  set_ATSC_ADDR_212C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_212C_reg)=data)
#define  get_ATSC_ADDR_212C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_212C_reg))
#define  ATSC_ADDR_212C_agc_lock_sel_shift                                       (0)
#define  ATSC_ADDR_212C_agc_lock_sel_mask                                        (0x00000001)
#define  ATSC_ADDR_212C_agc_lock_sel(data)                                       (0x00000001&(data))
#define  ATSC_ADDR_212C_get_agc_lock_sel(data)                                   (0x00000001&(data))

#define  ATSC_ADDR_212E                                                         0x181544B8
#define  ATSC_ADDR_212E_reg_addr                                                 "0xB81544B8"
#define  ATSC_ADDR_212E_reg                                                      0xB81544B8
#define  ATSC_ADDR_212E_inst_addr                                                "0x008D"
#define  set_ATSC_ADDR_212E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_212E_reg)=data)
#define  get_ATSC_ADDR_212E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_212E_reg))
#define  ATSC_ADDR_212E_opt_aagc_out_dcc_shift                                   (7)
#define  ATSC_ADDR_212E_opt_aagc_loop_in_shift                                   (4)
#define  ATSC_ADDR_212E_adc_clip_iq_shift                                        (2)
#define  ATSC_ADDR_212E_opt_ado_im_shift                                         (1)
#define  ATSC_ADDR_212E_aagc_iq_swap_shift                                       (0)
#define  ATSC_ADDR_212E_opt_aagc_out_dcc_mask                                    (0x00000080)
#define  ATSC_ADDR_212E_opt_aagc_loop_in_mask                                    (0x00000070)
#define  ATSC_ADDR_212E_adc_clip_iq_mask                                         (0x0000000C)
#define  ATSC_ADDR_212E_opt_ado_im_mask                                          (0x00000002)
#define  ATSC_ADDR_212E_aagc_iq_swap_mask                                        (0x00000001)
#define  ATSC_ADDR_212E_opt_aagc_out_dcc(data)                                   (0x00000080&((data)<<7))
#define  ATSC_ADDR_212E_opt_aagc_loop_in(data)                                   (0x00000070&((data)<<4))
#define  ATSC_ADDR_212E_adc_clip_iq(data)                                        (0x0000000C&((data)<<2))
#define  ATSC_ADDR_212E_opt_ado_im(data)                                         (0x00000002&((data)<<1))
#define  ATSC_ADDR_212E_aagc_iq_swap(data)                                       (0x00000001&(data))
#define  ATSC_ADDR_212E_get_opt_aagc_out_dcc(data)                               ((0x00000080&(data))>>7)
#define  ATSC_ADDR_212E_get_opt_aagc_loop_in(data)                               ((0x00000070&(data))>>4)
#define  ATSC_ADDR_212E_get_adc_clip_iq(data)                                    ((0x0000000C&(data))>>2)
#define  ATSC_ADDR_212E_get_opt_ado_im(data)                                     ((0x00000002&(data))>>1)
#define  ATSC_ADDR_212E_get_aagc_iq_swap(data)                                   (0x00000001&(data))

#define  ATSC_ADDR_212F                                                         0x181544BC
#define  ATSC_ADDR_212F_reg_addr                                                 "0xB81544BC"
#define  ATSC_ADDR_212F_reg                                                      0xB81544BC
#define  ATSC_ADDR_212F_inst_addr                                                "0x008E"
#define  set_ATSC_ADDR_212F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_212F_reg)=data)
#define  get_ATSC_ADDR_212F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_212F_reg))
#define  ATSC_ADDR_212F_fe_dcc1_acq_dly_prd_shift                                (5)
#define  ATSC_ADDR_212F_fe_dcc1_max_shift                                        (2)
#define  ATSC_ADDR_212F_fe_dcc1_max_en_shift                                     (1)
#define  ATSC_ADDR_212F_fe_dcc1_en_shift                                         (0)
#define  ATSC_ADDR_212F_fe_dcc1_acq_dly_prd_mask                                 (0x00000060)
#define  ATSC_ADDR_212F_fe_dcc1_max_mask                                         (0x0000001C)
#define  ATSC_ADDR_212F_fe_dcc1_max_en_mask                                      (0x00000002)
#define  ATSC_ADDR_212F_fe_dcc1_en_mask                                          (0x00000001)
#define  ATSC_ADDR_212F_fe_dcc1_acq_dly_prd(data)                                (0x00000060&((data)<<5))
#define  ATSC_ADDR_212F_fe_dcc1_max(data)                                        (0x0000001C&((data)<<2))
#define  ATSC_ADDR_212F_fe_dcc1_max_en(data)                                     (0x00000002&((data)<<1))
#define  ATSC_ADDR_212F_fe_dcc1_en(data)                                         (0x00000001&(data))
#define  ATSC_ADDR_212F_get_fe_dcc1_acq_dly_prd(data)                            ((0x00000060&(data))>>5)
#define  ATSC_ADDR_212F_get_fe_dcc1_max(data)                                    ((0x0000001C&(data))>>2)
#define  ATSC_ADDR_212F_get_fe_dcc1_max_en(data)                                 ((0x00000002&(data))>>1)
#define  ATSC_ADDR_212F_get_fe_dcc1_en(data)                                     (0x00000001&(data))

#define  ATSC_ADDR_2130                                                         0x181544C0
#define  ATSC_ADDR_2130_reg_addr                                                 "0xB81544C0"
#define  ATSC_ADDR_2130_reg                                                      0xB81544C0
#define  ATSC_ADDR_2130_inst_addr                                                "0x008F"
#define  set_ATSC_ADDR_2130_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2130_reg)=data)
#define  get_ATSC_ADDR_2130_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2130_reg))
#define  ATSC_ADDR_2130_fe_dcc1_u_trk_shift                                      (4)
#define  ATSC_ADDR_2130_fe_dcc1_u_acq_shift                                      (0)
#define  ATSC_ADDR_2130_fe_dcc1_u_trk_mask                                       (0x000000F0)
#define  ATSC_ADDR_2130_fe_dcc1_u_acq_mask                                       (0x0000000F)
#define  ATSC_ADDR_2130_fe_dcc1_u_trk(data)                                      (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2130_fe_dcc1_u_acq(data)                                      (0x0000000F&(data))
#define  ATSC_ADDR_2130_get_fe_dcc1_u_trk(data)                                  ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2130_get_fe_dcc1_u_acq(data)                                  (0x0000000F&(data))

#define  ATSC_ADDR_2131                                                         0x181544C4
#define  ATSC_ADDR_2131_reg_addr                                                 "0xB81544C4"
#define  ATSC_ADDR_2131_reg                                                      0xB81544C4
#define  ATSC_ADDR_2131_inst_addr                                                "0x0090"
#define  set_ATSC_ADDR_2131_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2131_reg)=data)
#define  get_ATSC_ADDR_2131_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2131_reg))
#define  ATSC_ADDR_2131_opt_fe_dcc1_upd_shift                                    (4)
#define  ATSC_ADDR_2131_opt_fe_dcc1_clr_shift                                    (2)
#define  ATSC_ADDR_2131_opt_fe_dcc1_u_shift                                      (0)
#define  ATSC_ADDR_2131_opt_fe_dcc1_upd_mask                                     (0x00000030)
#define  ATSC_ADDR_2131_opt_fe_dcc1_clr_mask                                     (0x0000000C)
#define  ATSC_ADDR_2131_opt_fe_dcc1_u_mask                                       (0x00000003)
#define  ATSC_ADDR_2131_opt_fe_dcc1_upd(data)                                    (0x00000030&((data)<<4))
#define  ATSC_ADDR_2131_opt_fe_dcc1_clr(data)                                    (0x0000000C&((data)<<2))
#define  ATSC_ADDR_2131_opt_fe_dcc1_u(data)                                      (0x00000003&(data))
#define  ATSC_ADDR_2131_get_opt_fe_dcc1_upd(data)                                ((0x00000030&(data))>>4)
#define  ATSC_ADDR_2131_get_opt_fe_dcc1_clr(data)                                ((0x0000000C&(data))>>2)
#define  ATSC_ADDR_2131_get_opt_fe_dcc1_u(data)                                  (0x00000003&(data))

#define  ATSC_ADDR_2132                                                         0x181544C8
#define  ATSC_ADDR_2132_reg_addr                                                 "0xB81544C8"
#define  ATSC_ADDR_2132_reg                                                      0xB81544C8
#define  ATSC_ADDR_2132_inst_addr                                                "0x0091"
#define  set_ATSC_ADDR_2132_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2132_reg)=data)
#define  get_ATSC_ADDR_2132_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2132_reg))
#define  ATSC_ADDR_2132_zif_spec_inv_on_shift                                    (1)
#define  ATSC_ADDR_2132_ddc_zif_mode_shift                                       (0)
#define  ATSC_ADDR_2132_zif_spec_inv_on_mask                                     (0x00000002)
#define  ATSC_ADDR_2132_ddc_zif_mode_mask                                        (0x00000001)
#define  ATSC_ADDR_2132_zif_spec_inv_on(data)                                    (0x00000002&((data)<<1))
#define  ATSC_ADDR_2132_ddc_zif_mode(data)                                       (0x00000001&(data))
#define  ATSC_ADDR_2132_get_zif_spec_inv_on(data)                                ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2132_get_ddc_zif_mode(data)                                   (0x00000001&(data))

#define  ATSC_ADDR_2133                                                         0x181544CC
#define  ATSC_ADDR_2133_reg_addr                                                 "0xB81544CC"
#define  ATSC_ADDR_2133_reg                                                      0xB81544CC
#define  ATSC_ADDR_2133_inst_addr                                                "0x0092"
#define  set_ATSC_ADDR_2133_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2133_reg)=data)
#define  get_ATSC_ADDR_2133_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2133_reg))
#define  ATSC_ADDR_2133_fe_dcc2_acq_dly_prd_shift                                (5)
#define  ATSC_ADDR_2133_fe_dcc2_max_shift                                        (2)
#define  ATSC_ADDR_2133_fe_dcc2_max_en_shift                                     (1)
#define  ATSC_ADDR_2133_fe_dcc2_en_shift                                         (0)
#define  ATSC_ADDR_2133_fe_dcc2_acq_dly_prd_mask                                 (0x00000060)
#define  ATSC_ADDR_2133_fe_dcc2_max_mask                                         (0x0000001C)
#define  ATSC_ADDR_2133_fe_dcc2_max_en_mask                                      (0x00000002)
#define  ATSC_ADDR_2133_fe_dcc2_en_mask                                          (0x00000001)
#define  ATSC_ADDR_2133_fe_dcc2_acq_dly_prd(data)                                (0x00000060&((data)<<5))
#define  ATSC_ADDR_2133_fe_dcc2_max(data)                                        (0x0000001C&((data)<<2))
#define  ATSC_ADDR_2133_fe_dcc2_max_en(data)                                     (0x00000002&((data)<<1))
#define  ATSC_ADDR_2133_fe_dcc2_en(data)                                         (0x00000001&(data))
#define  ATSC_ADDR_2133_get_fe_dcc2_acq_dly_prd(data)                            ((0x00000060&(data))>>5)
#define  ATSC_ADDR_2133_get_fe_dcc2_max(data)                                    ((0x0000001C&(data))>>2)
#define  ATSC_ADDR_2133_get_fe_dcc2_max_en(data)                                 ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2133_get_fe_dcc2_en(data)                                     (0x00000001&(data))

#define  ATSC_ADDR_2134                                                         0x181544D0
#define  ATSC_ADDR_2134_reg_addr                                                 "0xB81544D0"
#define  ATSC_ADDR_2134_reg                                                      0xB81544D0
#define  ATSC_ADDR_2134_inst_addr                                                "0x0093"
#define  set_ATSC_ADDR_2134_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2134_reg)=data)
#define  get_ATSC_ADDR_2134_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2134_reg))
#define  ATSC_ADDR_2134_fe_dcc2_u_trk_shift                                      (4)
#define  ATSC_ADDR_2134_fe_dcc2_u_acq_shift                                      (0)
#define  ATSC_ADDR_2134_fe_dcc2_u_trk_mask                                       (0x000000F0)
#define  ATSC_ADDR_2134_fe_dcc2_u_acq_mask                                       (0x0000000F)
#define  ATSC_ADDR_2134_fe_dcc2_u_trk(data)                                      (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2134_fe_dcc2_u_acq(data)                                      (0x0000000F&(data))
#define  ATSC_ADDR_2134_get_fe_dcc2_u_trk(data)                                  ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2134_get_fe_dcc2_u_acq(data)                                  (0x0000000F&(data))

#define  ATSC_ADDR_2135                                                         0x181544D4
#define  ATSC_ADDR_2135_reg_addr                                                 "0xB81544D4"
#define  ATSC_ADDR_2135_reg                                                      0xB81544D4
#define  ATSC_ADDR_2135_inst_addr                                                "0x0094"
#define  set_ATSC_ADDR_2135_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2135_reg)=data)
#define  get_ATSC_ADDR_2135_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2135_reg))
#define  ATSC_ADDR_2135_opt_fe_dcc2_upd_shift                                    (4)
#define  ATSC_ADDR_2135_opt_fe_dcc2_clr_shift                                    (2)
#define  ATSC_ADDR_2135_opt_fe_dcc2_u_shift                                      (0)
#define  ATSC_ADDR_2135_opt_fe_dcc2_upd_mask                                     (0x00000030)
#define  ATSC_ADDR_2135_opt_fe_dcc2_clr_mask                                     (0x0000000C)
#define  ATSC_ADDR_2135_opt_fe_dcc2_u_mask                                       (0x00000003)
#define  ATSC_ADDR_2135_opt_fe_dcc2_upd(data)                                    (0x00000030&((data)<<4))
#define  ATSC_ADDR_2135_opt_fe_dcc2_clr(data)                                    (0x0000000C&((data)<<2))
#define  ATSC_ADDR_2135_opt_fe_dcc2_u(data)                                      (0x00000003&(data))
#define  ATSC_ADDR_2135_get_opt_fe_dcc2_upd(data)                                ((0x00000030&(data))>>4)
#define  ATSC_ADDR_2135_get_opt_fe_dcc2_clr(data)                                ((0x0000000C&(data))>>2)
#define  ATSC_ADDR_2135_get_opt_fe_dcc2_u(data)                                  (0x00000003&(data))

#define  ATSC_ADDR_2136                                                         0x181544D8
#define  ATSC_ADDR_2136_reg_addr                                                 "0xB81544D8"
#define  ATSC_ADDR_2136_reg                                                      0xB81544D8
#define  ATSC_ADDR_2136_inst_addr                                                "0x0095"
#define  set_ATSC_ADDR_2136_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2136_reg)=data)
#define  get_ATSC_ADDR_2136_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2136_reg))
#define  ATSC_ADDR_2136_fe_dcc3_acq_dly_prd_shift                                (5)
#define  ATSC_ADDR_2136_fe_dcc3_max_shift                                        (2)
#define  ATSC_ADDR_2136_fe_dcc3_max_en_shift                                     (1)
#define  ATSC_ADDR_2136_fe_dcc3_en_shift                                         (0)
#define  ATSC_ADDR_2136_fe_dcc3_acq_dly_prd_mask                                 (0x00000060)
#define  ATSC_ADDR_2136_fe_dcc3_max_mask                                         (0x0000001C)
#define  ATSC_ADDR_2136_fe_dcc3_max_en_mask                                      (0x00000002)
#define  ATSC_ADDR_2136_fe_dcc3_en_mask                                          (0x00000001)
#define  ATSC_ADDR_2136_fe_dcc3_acq_dly_prd(data)                                (0x00000060&((data)<<5))
#define  ATSC_ADDR_2136_fe_dcc3_max(data)                                        (0x0000001C&((data)<<2))
#define  ATSC_ADDR_2136_fe_dcc3_max_en(data)                                     (0x00000002&((data)<<1))
#define  ATSC_ADDR_2136_fe_dcc3_en(data)                                         (0x00000001&(data))
#define  ATSC_ADDR_2136_get_fe_dcc3_acq_dly_prd(data)                            ((0x00000060&(data))>>5)
#define  ATSC_ADDR_2136_get_fe_dcc3_max(data)                                    ((0x0000001C&(data))>>2)
#define  ATSC_ADDR_2136_get_fe_dcc3_max_en(data)                                 ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2136_get_fe_dcc3_en(data)                                     (0x00000001&(data))

#define  ATSC_ADDR_2137                                                         0x181544DC
#define  ATSC_ADDR_2137_reg_addr                                                 "0xB81544DC"
#define  ATSC_ADDR_2137_reg                                                      0xB81544DC
#define  ATSC_ADDR_2137_inst_addr                                                "0x0096"
#define  set_ATSC_ADDR_2137_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2137_reg)=data)
#define  get_ATSC_ADDR_2137_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2137_reg))
#define  ATSC_ADDR_2137_fe_dcc3_u_trk_shift                                      (4)
#define  ATSC_ADDR_2137_fe_dcc3_u_acq_shift                                      (0)
#define  ATSC_ADDR_2137_fe_dcc3_u_trk_mask                                       (0x000000F0)
#define  ATSC_ADDR_2137_fe_dcc3_u_acq_mask                                       (0x0000000F)
#define  ATSC_ADDR_2137_fe_dcc3_u_trk(data)                                      (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2137_fe_dcc3_u_acq(data)                                      (0x0000000F&(data))
#define  ATSC_ADDR_2137_get_fe_dcc3_u_trk(data)                                  ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2137_get_fe_dcc3_u_acq(data)                                  (0x0000000F&(data))

#define  ATSC_ADDR_2138                                                         0x181544E0
#define  ATSC_ADDR_2138_reg_addr                                                 "0xB81544E0"
#define  ATSC_ADDR_2138_reg                                                      0xB81544E0
#define  ATSC_ADDR_2138_inst_addr                                                "0x0097"
#define  set_ATSC_ADDR_2138_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2138_reg)=data)
#define  get_ATSC_ADDR_2138_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2138_reg))
#define  ATSC_ADDR_2138_opt_fe_dcc3_upd_shift                                    (4)
#define  ATSC_ADDR_2138_opt_fe_dcc3_clr_shift                                    (2)
#define  ATSC_ADDR_2138_opt_fe_dcc3_u_shift                                      (0)
#define  ATSC_ADDR_2138_opt_fe_dcc3_upd_mask                                     (0x00000030)
#define  ATSC_ADDR_2138_opt_fe_dcc3_clr_mask                                     (0x0000000C)
#define  ATSC_ADDR_2138_opt_fe_dcc3_u_mask                                       (0x00000003)
#define  ATSC_ADDR_2138_opt_fe_dcc3_upd(data)                                    (0x00000030&((data)<<4))
#define  ATSC_ADDR_2138_opt_fe_dcc3_clr(data)                                    (0x0000000C&((data)<<2))
#define  ATSC_ADDR_2138_opt_fe_dcc3_u(data)                                      (0x00000003&(data))
#define  ATSC_ADDR_2138_get_opt_fe_dcc3_upd(data)                                ((0x00000030&(data))>>4)
#define  ATSC_ADDR_2138_get_opt_fe_dcc3_clr(data)                                ((0x0000000C&(data))>>2)
#define  ATSC_ADDR_2138_get_opt_fe_dcc3_u(data)                                  (0x00000003&(data))

#define  ATSC_ADDR_2139                                                         0x181544E4
#define  ATSC_ADDR_2139_reg_addr                                                 "0xB81544E4"
#define  ATSC_ADDR_2139_reg                                                      0xB81544E4
#define  ATSC_ADDR_2139_inst_addr                                                "0x0098"
#define  set_ATSC_ADDR_2139_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2139_reg)=data)
#define  get_ATSC_ADDR_2139_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2139_reg))
#define  ATSC_ADDR_2139_fe_iqamp_u_trk_shift                                     (4)
#define  ATSC_ADDR_2139_fe_iqamp_u_acq_shift                                     (0)
#define  ATSC_ADDR_2139_fe_iqamp_u_trk_mask                                      (0x000000F0)
#define  ATSC_ADDR_2139_fe_iqamp_u_acq_mask                                      (0x0000000F)
#define  ATSC_ADDR_2139_fe_iqamp_u_trk(data)                                     (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2139_fe_iqamp_u_acq(data)                                     (0x0000000F&(data))
#define  ATSC_ADDR_2139_get_fe_iqamp_u_trk(data)                                 ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2139_get_fe_iqamp_u_acq(data)                                 (0x0000000F&(data))

#define  ATSC_ADDR_213A                                                         0x181544E8
#define  ATSC_ADDR_213A_reg_addr                                                 "0xB81544E8"
#define  ATSC_ADDR_213A_reg                                                      0xB81544E8
#define  ATSC_ADDR_213A_inst_addr                                                "0x0099"
#define  set_ATSC_ADDR_213A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_213A_reg)=data)
#define  get_ATSC_ADDR_213A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_213A_reg))
#define  ATSC_ADDR_213A_fe_iqph_u_trk_shift                                      (4)
#define  ATSC_ADDR_213A_fe_iqph_u_acq_shift                                      (0)
#define  ATSC_ADDR_213A_fe_iqph_u_trk_mask                                       (0x000000F0)
#define  ATSC_ADDR_213A_fe_iqph_u_acq_mask                                       (0x0000000F)
#define  ATSC_ADDR_213A_fe_iqph_u_trk(data)                                      (0x000000F0&((data)<<4))
#define  ATSC_ADDR_213A_fe_iqph_u_acq(data)                                      (0x0000000F&(data))
#define  ATSC_ADDR_213A_get_fe_iqph_u_trk(data)                                  ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_213A_get_fe_iqph_u_acq(data)                                  (0x0000000F&(data))

#define  ATSC_ADDR_213B                                                         0x181544EC
#define  ATSC_ADDR_213B_reg_addr                                                 "0xB81544EC"
#define  ATSC_ADDR_213B_reg                                                      0xB81544EC
#define  ATSC_ADDR_213B_inst_addr                                                "0x009A"
#define  set_ATSC_ADDR_213B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_213B_reg)=data)
#define  get_ATSC_ADDR_213B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_213B_reg))
#define  ATSC_ADDR_213B_opt_fe_iq_upd_shift                                      (6)
#define  ATSC_ADDR_213B_opt_fe_iq_clr_shift                                      (4)
#define  ATSC_ADDR_213B_opt_fe_iq_u_shift                                        (2)
#define  ATSC_ADDR_213B_fe_iq_acq_dly_prd_shift                                  (0)
#define  ATSC_ADDR_213B_opt_fe_iq_upd_mask                                       (0x000000C0)
#define  ATSC_ADDR_213B_opt_fe_iq_clr_mask                                       (0x00000030)
#define  ATSC_ADDR_213B_opt_fe_iq_u_mask                                         (0x0000000C)
#define  ATSC_ADDR_213B_fe_iq_acq_dly_prd_mask                                   (0x00000003)
#define  ATSC_ADDR_213B_opt_fe_iq_upd(data)                                      (0x000000C0&((data)<<6))
#define  ATSC_ADDR_213B_opt_fe_iq_clr(data)                                      (0x00000030&((data)<<4))
#define  ATSC_ADDR_213B_opt_fe_iq_u(data)                                        (0x0000000C&((data)<<2))
#define  ATSC_ADDR_213B_fe_iq_acq_dly_prd(data)                                  (0x00000003&(data))
#define  ATSC_ADDR_213B_get_opt_fe_iq_upd(data)                                  ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_213B_get_opt_fe_iq_clr(data)                                  ((0x00000030&(data))>>4)
#define  ATSC_ADDR_213B_get_opt_fe_iq_u(data)                                    ((0x0000000C&(data))>>2)
#define  ATSC_ADDR_213B_get_fe_iq_acq_dly_prd(data)                              (0x00000003&(data))

#define  ATSC_ADDR_213C                                                         0x181544F0
#define  ATSC_ADDR_213C_reg_addr                                                 "0xB81544F0"
#define  ATSC_ADDR_213C_reg                                                      0xB81544F0
#define  ATSC_ADDR_213C_inst_addr                                                "0x009B"
#define  set_ATSC_ADDR_213C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_213C_reg)=data)
#define  get_ATSC_ADDR_213C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_213C_reg))
#define  ATSC_ADDR_213C_fe_iqamp_manu_7_0_shift                                  (0)
#define  ATSC_ADDR_213C_fe_iqamp_manu_7_0_mask                                   (0x000000FF)
#define  ATSC_ADDR_213C_fe_iqamp_manu_7_0(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_213C_get_fe_iqamp_manu_7_0(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_213D                                                         0x181544F4
#define  ATSC_ADDR_213D_reg_addr                                                 "0xB81544F4"
#define  ATSC_ADDR_213D_reg                                                      0xB81544F4
#define  ATSC_ADDR_213D_inst_addr                                                "0x009C"
#define  set_ATSC_ADDR_213D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_213D_reg)=data)
#define  get_ATSC_ADDR_213D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_213D_reg))
#define  ATSC_ADDR_213D_fe_iqamp_en_shift                                        (7)
#define  ATSC_ADDR_213D_fe_iqamp_max_en_shift                                    (6)
#define  ATSC_ADDR_213D_fe_iqamp_max_shift                                       (3)
#define  ATSC_ADDR_213D_fe_iqamp_manu_en_shift                                   (2)
#define  ATSC_ADDR_213D_fe_iqamp_manu_9_8_shift                                  (0)
#define  ATSC_ADDR_213D_fe_iqamp_en_mask                                         (0x00000080)
#define  ATSC_ADDR_213D_fe_iqamp_max_en_mask                                     (0x00000040)
#define  ATSC_ADDR_213D_fe_iqamp_max_mask                                        (0x00000038)
#define  ATSC_ADDR_213D_fe_iqamp_manu_en_mask                                    (0x00000004)
#define  ATSC_ADDR_213D_fe_iqamp_manu_9_8_mask                                   (0x00000003)
#define  ATSC_ADDR_213D_fe_iqamp_en(data)                                        (0x00000080&((data)<<7))
#define  ATSC_ADDR_213D_fe_iqamp_max_en(data)                                    (0x00000040&((data)<<6))
#define  ATSC_ADDR_213D_fe_iqamp_max(data)                                       (0x00000038&((data)<<3))
#define  ATSC_ADDR_213D_fe_iqamp_manu_en(data)                                   (0x00000004&((data)<<2))
#define  ATSC_ADDR_213D_fe_iqamp_manu_9_8(data)                                  (0x00000003&(data))
#define  ATSC_ADDR_213D_get_fe_iqamp_en(data)                                    ((0x00000080&(data))>>7)
#define  ATSC_ADDR_213D_get_fe_iqamp_max_en(data)                                ((0x00000040&(data))>>6)
#define  ATSC_ADDR_213D_get_fe_iqamp_max(data)                                   ((0x00000038&(data))>>3)
#define  ATSC_ADDR_213D_get_fe_iqamp_manu_en(data)                               ((0x00000004&(data))>>2)
#define  ATSC_ADDR_213D_get_fe_iqamp_manu_9_8(data)                              (0x00000003&(data))

#define  ATSC_ADDR_213E                                                         0x181544F8
#define  ATSC_ADDR_213E_reg_addr                                                 "0xB81544F8"
#define  ATSC_ADDR_213E_reg                                                      0xB81544F8
#define  ATSC_ADDR_213E_inst_addr                                                "0x009D"
#define  set_ATSC_ADDR_213E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_213E_reg)=data)
#define  get_ATSC_ADDR_213E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_213E_reg))
#define  ATSC_ADDR_213E_fe_iqph_manu_7_0_shift                                   (0)
#define  ATSC_ADDR_213E_fe_iqph_manu_7_0_mask                                    (0x000000FF)
#define  ATSC_ADDR_213E_fe_iqph_manu_7_0(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_213E_get_fe_iqph_manu_7_0(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_213F                                                         0x181544FC
#define  ATSC_ADDR_213F_reg_addr                                                 "0xB81544FC"
#define  ATSC_ADDR_213F_reg                                                      0xB81544FC
#define  ATSC_ADDR_213F_inst_addr                                                "0x009E"
#define  set_ATSC_ADDR_213F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_213F_reg)=data)
#define  get_ATSC_ADDR_213F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_213F_reg))
#define  ATSC_ADDR_213F_fe_iqph_en_shift                                         (7)
#define  ATSC_ADDR_213F_fe_iqph_max_en_shift                                     (6)
#define  ATSC_ADDR_213F_fe_iqph_max_shift                                        (3)
#define  ATSC_ADDR_213F_fe_iqph_manu_en_shift                                    (2)
#define  ATSC_ADDR_213F_fe_iqph_manu_9_8_shift                                   (0)
#define  ATSC_ADDR_213F_fe_iqph_en_mask                                          (0x00000080)
#define  ATSC_ADDR_213F_fe_iqph_max_en_mask                                      (0x00000040)
#define  ATSC_ADDR_213F_fe_iqph_max_mask                                         (0x00000038)
#define  ATSC_ADDR_213F_fe_iqph_manu_en_mask                                     (0x00000004)
#define  ATSC_ADDR_213F_fe_iqph_manu_9_8_mask                                    (0x00000003)
#define  ATSC_ADDR_213F_fe_iqph_en(data)                                         (0x00000080&((data)<<7))
#define  ATSC_ADDR_213F_fe_iqph_max_en(data)                                     (0x00000040&((data)<<6))
#define  ATSC_ADDR_213F_fe_iqph_max(data)                                        (0x00000038&((data)<<3))
#define  ATSC_ADDR_213F_fe_iqph_manu_en(data)                                    (0x00000004&((data)<<2))
#define  ATSC_ADDR_213F_fe_iqph_manu_9_8(data)                                   (0x00000003&(data))
#define  ATSC_ADDR_213F_get_fe_iqph_en(data)                                     ((0x00000080&(data))>>7)
#define  ATSC_ADDR_213F_get_fe_iqph_max_en(data)                                 ((0x00000040&(data))>>6)
#define  ATSC_ADDR_213F_get_fe_iqph_max(data)                                    ((0x00000038&(data))>>3)
#define  ATSC_ADDR_213F_get_fe_iqph_manu_en(data)                                ((0x00000004&(data))>>2)
#define  ATSC_ADDR_213F_get_fe_iqph_manu_9_8(data)                               (0x00000003&(data))

#define  ATSC_ADDR_2143                                                         0x1815450C
#define  ATSC_ADDR_2143_reg_addr                                                 "0xB815450C"
#define  ATSC_ADDR_2143_reg                                                      0xB815450C
#define  ATSC_ADDR_2143_inst_addr                                                "0x009F"
#define  set_ATSC_ADDR_2143_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2143_reg)=data)
#define  get_ATSC_ADDR_2143_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2143_reg))
#define  ATSC_ADDR_2143_det_adj_th_bn_shift                                      (0)
#define  ATSC_ADDR_2143_det_adj_th_bn_mask                                       (0x000000FF)
#define  ATSC_ADDR_2143_det_adj_th_bn(data)                                      (0x000000FF&(data))
#define  ATSC_ADDR_2143_get_det_adj_th_bn(data)                                  (0x000000FF&(data))

#define  ATSC_ADDR_2144                                                         0x18154510
#define  ATSC_ADDR_2144_reg_addr                                                 "0xB8154510"
#define  ATSC_ADDR_2144_reg                                                      0xB8154510
#define  ATSC_ADDR_2144_inst_addr                                                "0x00A0"
#define  set_ATSC_ADDR_2144_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2144_reg)=data)
#define  get_ATSC_ADDR_2144_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2144_reg))
#define  ATSC_ADDR_2144_det_adj_th_shift                                         (0)
#define  ATSC_ADDR_2144_det_adj_th_mask                                          (0x000000FF)
#define  ATSC_ADDR_2144_det_adj_th(data)                                         (0x000000FF&(data))
#define  ATSC_ADDR_2144_get_det_adj_th(data)                                     (0x000000FF&(data))

#define  ATSC_ADDR_2145                                                         0x18154514
#define  ATSC_ADDR_2145_reg_addr                                                 "0xB8154514"
#define  ATSC_ADDR_2145_reg                                                      0xB8154514
#define  ATSC_ADDR_2145_inst_addr                                                "0x00A1"
#define  set_ATSC_ADDR_2145_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2145_reg)=data)
#define  get_ATSC_ADDR_2145_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2145_reg))
#define  ATSC_ADDR_2145_dagc_target_power_shift                                  (0)
#define  ATSC_ADDR_2145_dagc_target_power_mask                                   (0x000000FF)
#define  ATSC_ADDR_2145_dagc_target_power(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2145_get_dagc_target_power(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2146                                                         0x18154518
#define  ATSC_ADDR_2146_reg_addr                                                 "0xB8154518"
#define  ATSC_ADDR_2146_reg                                                      0xB8154518
#define  ATSC_ADDR_2146_inst_addr                                                "0x00A2"
#define  set_ATSC_ADDR_2146_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2146_reg)=data)
#define  get_ATSC_ADDR_2146_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2146_reg))
#define  ATSC_ADDR_2146_dagc_level_exp_shift                                     (6)
#define  ATSC_ADDR_2146_dagc_load_shift                                          (5)
#define  ATSC_ADDR_2146_dagc_level_ini_shift                                     (0)
#define  ATSC_ADDR_2146_dagc_level_exp_mask                                      (0x000000C0)
#define  ATSC_ADDR_2146_dagc_load_mask                                           (0x00000020)
#define  ATSC_ADDR_2146_dagc_level_ini_mask                                      (0x0000001F)
#define  ATSC_ADDR_2146_dagc_level_exp(data)                                     (0x000000C0&((data)<<6))
#define  ATSC_ADDR_2146_dagc_load(data)                                          (0x00000020&((data)<<5))
#define  ATSC_ADDR_2146_dagc_level_ini(data)                                     (0x0000001F&(data))
#define  ATSC_ADDR_2146_get_dagc_level_exp(data)                                 ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_2146_get_dagc_load(data)                                      ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2146_get_dagc_level_ini(data)                                 (0x0000001F&(data))

#define  ATSC_ADDR_2147                                                         0x1815451C
#define  ATSC_ADDR_2147_reg_addr                                                 "0xB815451C"
#define  ATSC_ADDR_2147_reg                                                      0xB815451C
#define  ATSC_ADDR_2147_inst_addr                                                "0x00A3"
#define  set_ATSC_ADDR_2147_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2147_reg)=data)
#define  get_ATSC_ADDR_2147_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2147_reg))
#define  ATSC_ADDR_2147_dagc_lock_th_shift                                       (2)
#define  ATSC_ADDR_2147_dagc_mu_comp_en_shift                                    (1)
#define  ATSC_ADDR_2147_dagc_mu_sel_shift                                        (0)
#define  ATSC_ADDR_2147_dagc_lock_th_mask                                        (0x000000FC)
#define  ATSC_ADDR_2147_dagc_mu_comp_en_mask                                     (0x00000002)
#define  ATSC_ADDR_2147_dagc_mu_sel_mask                                         (0x00000001)
#define  ATSC_ADDR_2147_dagc_lock_th(data)                                       (0x000000FC&((data)<<2))
#define  ATSC_ADDR_2147_dagc_mu_comp_en(data)                                    (0x00000002&((data)<<1))
#define  ATSC_ADDR_2147_dagc_mu_sel(data)                                        (0x00000001&(data))
#define  ATSC_ADDR_2147_get_dagc_lock_th(data)                                   ((0x000000FC&(data))>>2)
#define  ATSC_ADDR_2147_get_dagc_mu_comp_en(data)                                ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2147_get_dagc_mu_sel(data)                                    (0x00000001&(data))

#define  ATSC_ADDR_2148                                                         0x18154520
#define  ATSC_ADDR_2148_reg_addr                                                 "0xB8154520"
#define  ATSC_ADDR_2148_reg                                                      0xB8154520
#define  ATSC_ADDR_2148_inst_addr                                                "0x00A4"
#define  set_ATSC_ADDR_2148_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2148_reg)=data)
#define  get_ATSC_ADDR_2148_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2148_reg))
#define  ATSC_ADDR_2148_dc_alpha_exp_shift                                       (0)
#define  ATSC_ADDR_2148_dc_alpha_exp_mask                                        (0x00000007)
#define  ATSC_ADDR_2148_dc_alpha_exp(data)                                       (0x00000007&(data))
#define  ATSC_ADDR_2148_get_dc_alpha_exp(data)                                   (0x00000007&(data))

#define  ATSC_ADDR_2165                                                         0x18154594
#define  ATSC_ADDR_2165_reg_addr                                                 "0xB8154594"
#define  ATSC_ADDR_2165_reg                                                      0xB8154594
#define  ATSC_ADDR_2165_inst_addr                                                "0x00A5"
#define  set_ATSC_ADDR_2165_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2165_reg)=data)
#define  get_ATSC_ADDR_2165_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2165_reg))
#define  ATSC_ADDR_2165_tr_phase_inc_7_0_shift                                   (0)
#define  ATSC_ADDR_2165_tr_phase_inc_7_0_mask                                    (0x000000FF)
#define  ATSC_ADDR_2165_tr_phase_inc_7_0(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_2165_get_tr_phase_inc_7_0(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_2166                                                         0x18154598
#define  ATSC_ADDR_2166_reg_addr                                                 "0xB8154598"
#define  ATSC_ADDR_2166_reg                                                      0xB8154598
#define  ATSC_ADDR_2166_inst_addr                                                "0x00A6"
#define  set_ATSC_ADDR_2166_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2166_reg)=data)
#define  get_ATSC_ADDR_2166_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2166_reg))
#define  ATSC_ADDR_2166_tr_phase_inc_15_8_shift                                  (0)
#define  ATSC_ADDR_2166_tr_phase_inc_15_8_mask                                   (0x000000FF)
#define  ATSC_ADDR_2166_tr_phase_inc_15_8(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2166_get_tr_phase_inc_15_8(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2167                                                         0x1815459C
#define  ATSC_ADDR_2167_reg_addr                                                 "0xB815459C"
#define  ATSC_ADDR_2167_reg                                                      0xB815459C
#define  ATSC_ADDR_2167_inst_addr                                                "0x00A7"
#define  set_ATSC_ADDR_2167_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2167_reg)=data)
#define  get_ATSC_ADDR_2167_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2167_reg))
#define  ATSC_ADDR_2167_tr_phase_inc_23_16_shift                                 (0)
#define  ATSC_ADDR_2167_tr_phase_inc_23_16_mask                                  (0x000000FF)
#define  ATSC_ADDR_2167_tr_phase_inc_23_16(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2167_get_tr_phase_inc_23_16(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2168                                                         0x181545A0
#define  ATSC_ADDR_2168_reg_addr                                                 "0xB81545A0"
#define  ATSC_ADDR_2168_reg                                                      0xB81545A0
#define  ATSC_ADDR_2168_inst_addr                                                "0x00A8"
#define  set_ATSC_ADDR_2168_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2168_reg)=data)
#define  get_ATSC_ADDR_2168_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2168_reg))
#define  ATSC_ADDR_2168_tr_phase_inc_26_24_shift                                 (0)
#define  ATSC_ADDR_2168_tr_phase_inc_26_24_mask                                  (0x00000007)
#define  ATSC_ADDR_2168_tr_phase_inc_26_24(data)                                 (0x00000007&(data))
#define  ATSC_ADDR_2168_get_tr_phase_inc_26_24(data)                             (0x00000007&(data))

#define  ATSC_ADDR_2169                                                         0x181545A4
#define  ATSC_ADDR_2169_reg_addr                                                 "0xB81545A4"
#define  ATSC_ADDR_2169_reg                                                      0xB81545A4
#define  ATSC_ADDR_2169_inst_addr                                                "0x00A9"
#define  set_ATSC_ADDR_2169_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2169_reg)=data)
#define  get_ATSC_ADDR_2169_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2169_reg))
#define  ATSC_ADDR_2169_tr_ld_comp_on_shift                                      (7)
#define  ATSC_ADDR_2169_tr_lock_th1_shift                                        (1)
#define  ATSC_ADDR_2169_tr_fmu_mode_shift                                        (0)
#define  ATSC_ADDR_2169_tr_ld_comp_on_mask                                       (0x00000080)
#define  ATSC_ADDR_2169_tr_lock_th1_mask                                         (0x0000007E)
#define  ATSC_ADDR_2169_tr_fmu_mode_mask                                         (0x00000001)
#define  ATSC_ADDR_2169_tr_ld_comp_on(data)                                      (0x00000080&((data)<<7))
#define  ATSC_ADDR_2169_tr_lock_th1(data)                                        (0x0000007E&((data)<<1))
#define  ATSC_ADDR_2169_tr_fmu_mode(data)                                        (0x00000001&(data))
#define  ATSC_ADDR_2169_get_tr_ld_comp_on(data)                                  ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2169_get_tr_lock_th1(data)                                    ((0x0000007E&(data))>>1)
#define  ATSC_ADDR_2169_get_tr_fmu_mode(data)                                    (0x00000001&(data))

#define  ATSC_ADDR_216A                                                         0x181545A8
#define  ATSC_ADDR_216A_reg_addr                                                 "0xB81545A8"
#define  ATSC_ADDR_216A_reg                                                      0xB81545A8
#define  ATSC_ADDR_216A_inst_addr                                                "0x00AA"
#define  set_ATSC_ADDR_216A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_216A_reg)=data)
#define  get_ATSC_ADDR_216A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_216A_reg))
#define  ATSC_ADDR_216A_tr_lock_th2_shift                                        (0)
#define  ATSC_ADDR_216A_tr_lock_th2_mask                                         (0x000000FF)
#define  ATSC_ADDR_216A_tr_lock_th2(data)                                        (0x000000FF&(data))
#define  ATSC_ADDR_216A_get_tr_lock_th2(data)                                    (0x000000FF&(data))

#define  ATSC_ADDR_216D                                                         0x181545B4
#define  ATSC_ADDR_216D_reg_addr                                                 "0xB81545B4"
#define  ATSC_ADDR_216D_reg                                                      0xB81545B4
#define  ATSC_ADDR_216D_inst_addr                                                "0x00AB"
#define  set_ATSC_ADDR_216D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_216D_reg)=data)
#define  get_ATSC_ADDR_216D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_216D_reg))
#define  ATSC_ADDR_216D_opt_gard_off_shift                                       (4)
#define  ATSC_ADDR_216D_tr_phase_inc_upd_n_shift                                 (3)
#define  ATSC_ADDR_216D_tr_min_sat_en_shift                                      (2)
#define  ATSC_ADDR_216D_tr_lock_ind_mode_shift                                   (0)
#define  ATSC_ADDR_216D_opt_gard_off_mask                                        (0x00000010)
#define  ATSC_ADDR_216D_tr_phase_inc_upd_n_mask                                  (0x00000008)
#define  ATSC_ADDR_216D_tr_min_sat_en_mask                                       (0x00000004)
#define  ATSC_ADDR_216D_tr_lock_ind_mode_mask                                    (0x00000003)
#define  ATSC_ADDR_216D_opt_gard_off(data)                                       (0x00000010&((data)<<4))
#define  ATSC_ADDR_216D_tr_phase_inc_upd_n(data)                                 (0x00000008&((data)<<3))
#define  ATSC_ADDR_216D_tr_min_sat_en(data)                                      (0x00000004&((data)<<2))
#define  ATSC_ADDR_216D_tr_lock_ind_mode(data)                                   (0x00000003&(data))
#define  ATSC_ADDR_216D_get_opt_gard_off(data)                                   ((0x00000010&(data))>>4)
#define  ATSC_ADDR_216D_get_tr_phase_inc_upd_n(data)                             ((0x00000008&(data))>>3)
#define  ATSC_ADDR_216D_get_tr_min_sat_en(data)                                  ((0x00000004&(data))>>2)
#define  ATSC_ADDR_216D_get_tr_lock_ind_mode(data)                               (0x00000003&(data))

#define  ATSC_ADDR_2E40                                                         0x18157900
#define  ATSC_ADDR_2E40_reg_addr                                                 "0xB8157900"
#define  ATSC_ADDR_2E40_reg                                                      0xB8157900
#define  ATSC_ADDR_2E40_inst_addr                                                "0x00AC"
#define  set_ATSC_ADDR_2E40_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E40_reg)=data)
#define  get_ATSC_ADDR_2E40_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E40_reg))
#define  ATSC_ADDR_2E40_cr_cr2_cr_offset_cnt_win_4_0_shift                       (3)
#define  ATSC_ADDR_2E40_cr_cr2_auto_shift                                        (2)
#define  ATSC_ADDR_2E40_correlation_tr_sel_shift                                 (1)
#define  ATSC_ADDR_2E40_tr_fs_fll_exp_sel_out_msb_shift                          (0)
#define  ATSC_ADDR_2E40_cr_cr2_cr_offset_cnt_win_4_0_mask                        (0x000000F8)
#define  ATSC_ADDR_2E40_cr_cr2_auto_mask                                         (0x00000004)
#define  ATSC_ADDR_2E40_correlation_tr_sel_mask                                  (0x00000002)
#define  ATSC_ADDR_2E40_tr_fs_fll_exp_sel_out_msb_mask                           (0x00000001)
#define  ATSC_ADDR_2E40_cr_cr2_cr_offset_cnt_win_4_0(data)                       (0x000000F8&((data)<<3))
#define  ATSC_ADDR_2E40_cr_cr2_auto(data)                                        (0x00000004&((data)<<2))
#define  ATSC_ADDR_2E40_correlation_tr_sel(data)                                 (0x00000002&((data)<<1))
#define  ATSC_ADDR_2E40_tr_fs_fll_exp_sel_out_msb(data)                          (0x00000001&(data))
#define  ATSC_ADDR_2E40_get_cr_cr2_cr_offset_cnt_win_4_0(data)                   ((0x000000F8&(data))>>3)
#define  ATSC_ADDR_2E40_get_cr_cr2_auto(data)                                    ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2E40_get_correlation_tr_sel(data)                             ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2E40_get_tr_fs_fll_exp_sel_out_msb(data)                      (0x00000001&(data))

#define  ATSC_ADDR_216E                                                         0x181545B8
#define  ATSC_ADDR_216E_reg_addr                                                 "0xB81545B8"
#define  ATSC_ADDR_216E_reg                                                      0xB81545B8
#define  ATSC_ADDR_216E_inst_addr                                                "0x00AD"
#define  set_ATSC_ADDR_216E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_216E_reg)=data)
#define  get_ATSC_ADDR_216E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_216E_reg))
#define  ATSC_ADDR_216E_tr_fs_cor_th_acq_shift                                   (0)
#define  ATSC_ADDR_216E_tr_fs_cor_th_acq_mask                                    (0x000000FF)
#define  ATSC_ADDR_216E_tr_fs_cor_th_acq(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_216E_get_tr_fs_cor_th_acq(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_216F                                                         0x181545BC
#define  ATSC_ADDR_216F_reg_addr                                                 "0xB81545BC"
#define  ATSC_ADDR_216F_reg                                                      0xB81545BC
#define  ATSC_ADDR_216F_inst_addr                                                "0x00AE"
#define  set_ATSC_ADDR_216F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_216F_reg)=data)
#define  get_ATSC_ADDR_216F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_216F_reg))
#define  ATSC_ADDR_216F_tr_fs_cor_th_trk_shift                                   (0)
#define  ATSC_ADDR_216F_tr_fs_cor_th_trk_mask                                    (0x000000FF)
#define  ATSC_ADDR_216F_tr_fs_cor_th_trk(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_216F_get_tr_fs_cor_th_trk(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_2170                                                         0x181545C0
#define  ATSC_ADDR_2170_reg_addr                                                 "0xB81545C0"
#define  ATSC_ADDR_2170_reg                                                      0xB81545C0
#define  ATSC_ADDR_2170_inst_addr                                                "0x00AF"
#define  set_ATSC_ADDR_2170_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2170_reg)=data)
#define  get_ATSC_ADDR_2170_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2170_reg))
#define  ATSC_ADDR_2170_tr_fs_win_start_shift                                    (0)
#define  ATSC_ADDR_2170_tr_fs_win_start_mask                                     (0x000000FF)
#define  ATSC_ADDR_2170_tr_fs_win_start(data)                                    (0x000000FF&(data))
#define  ATSC_ADDR_2170_get_tr_fs_win_start(data)                                (0x000000FF&(data))

#define  ATSC_ADDR_2171                                                         0x181545C4
#define  ATSC_ADDR_2171_reg_addr                                                 "0xB81545C4"
#define  ATSC_ADDR_2171_reg                                                      0xB81545C4
#define  ATSC_ADDR_2171_inst_addr                                                "0x00B0"
#define  set_ATSC_ADDR_2171_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2171_reg)=data)
#define  get_ATSC_ADDR_2171_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2171_reg))
#define  ATSC_ADDR_2171_tr_fs_win_len_shift                                      (0)
#define  ATSC_ADDR_2171_tr_fs_win_len_mask                                       (0x000000FF)
#define  ATSC_ADDR_2171_tr_fs_win_len(data)                                      (0x000000FF&(data))
#define  ATSC_ADDR_2171_get_tr_fs_win_len(data)                                  (0x000000FF&(data))

#define  ATSC_ADDR_2172                                                         0x181545C8
#define  ATSC_ADDR_2172_reg_addr                                                 "0xB81545C8"
#define  ATSC_ADDR_2172_reg                                                      0xB81545C8
#define  ATSC_ADDR_2172_inst_addr                                                "0x00B1"
#define  set_ATSC_ADDR_2172_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2172_reg)=data)
#define  get_ATSC_ADDR_2172_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2172_reg))
#define  ATSC_ADDR_2172_tr_fs_lost_cnt_th_shift                                  (0)
#define  ATSC_ADDR_2172_tr_fs_lost_cnt_th_mask                                   (0x000000FF)
#define  ATSC_ADDR_2172_tr_fs_lost_cnt_th(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2172_get_tr_fs_lost_cnt_th(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2173                                                         0x181545CC
#define  ATSC_ADDR_2173_reg_addr                                                 "0xB81545CC"
#define  ATSC_ADDR_2173_reg                                                      0xB81545CC
#define  ATSC_ADDR_2173_inst_addr                                                "0x00B2"
#define  set_ATSC_ADDR_2173_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2173_reg)=data)
#define  get_ATSC_ADDR_2173_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2173_reg))
#define  ATSC_ADDR_2173_tr_fs_pll_kp_exp_shift                                   (5)
#define  ATSC_ADDR_2173_tr_fs_fll_exp_shift                                      (3)
#define  ATSC_ADDR_2173_tr_fs_fll_hold_en_shift                                  (2)
#define  ATSC_ADDR_2173_tr_fs_acc_reset_shift                                    (1)
#define  ATSC_ADDR_2173_tr_fs_ld_wide_en_shift                                   (0)
#define  ATSC_ADDR_2173_tr_fs_pll_kp_exp_mask                                    (0x000000E0)
#define  ATSC_ADDR_2173_tr_fs_fll_exp_mask                                       (0x00000018)
#define  ATSC_ADDR_2173_tr_fs_fll_hold_en_mask                                   (0x00000004)
#define  ATSC_ADDR_2173_tr_fs_acc_reset_mask                                     (0x00000002)
#define  ATSC_ADDR_2173_tr_fs_ld_wide_en_mask                                    (0x00000001)
#define  ATSC_ADDR_2173_tr_fs_pll_kp_exp(data)                                   (0x000000E0&((data)<<5))
#define  ATSC_ADDR_2173_tr_fs_fll_exp(data)                                      (0x00000018&((data)<<3))
#define  ATSC_ADDR_2173_tr_fs_fll_hold_en(data)                                  (0x00000004&((data)<<2))
#define  ATSC_ADDR_2173_tr_fs_acc_reset(data)                                    (0x00000002&((data)<<1))
#define  ATSC_ADDR_2173_tr_fs_ld_wide_en(data)                                   (0x00000001&(data))
#define  ATSC_ADDR_2173_get_tr_fs_pll_kp_exp(data)                               ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_2173_get_tr_fs_fll_exp(data)                                  ((0x00000018&(data))>>3)
#define  ATSC_ADDR_2173_get_tr_fs_fll_hold_en(data)                              ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2173_get_tr_fs_acc_reset(data)                                ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2173_get_tr_fs_ld_wide_en(data)                               (0x00000001&(data))

#define  ATSC_ADDR_2174                                                         0x181545D0
#define  ATSC_ADDR_2174_reg_addr                                                 "0xB81545D0"
#define  ATSC_ADDR_2174_reg                                                      0xB81545D0
#define  ATSC_ADDR_2174_inst_addr                                                "0x00B3"
#define  set_ATSC_ADDR_2174_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2174_reg)=data)
#define  get_ATSC_ADDR_2174_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2174_reg))
#define  ATSC_ADDR_2174_tr_fs_fll_times_shift                                    (0)
#define  ATSC_ADDR_2174_tr_fs_fll_times_mask                                     (0x000000FF)
#define  ATSC_ADDR_2174_tr_fs_fll_times(data)                                    (0x000000FF&(data))
#define  ATSC_ADDR_2174_get_tr_fs_fll_times(data)                                (0x000000FF&(data))

#define  ATSC_ADDR_2175                                                         0x181545D4
#define  ATSC_ADDR_2175_reg_addr                                                 "0xB81545D4"
#define  ATSC_ADDR_2175_reg                                                      0xB81545D4
#define  ATSC_ADDR_2175_inst_addr                                                "0x00B4"
#define  set_ATSC_ADDR_2175_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2175_reg)=data)
#define  get_ATSC_ADDR_2175_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2175_reg))
#define  ATSC_ADDR_2175_tr_fs_acc2_size_7_0_shift                                (0)
#define  ATSC_ADDR_2175_tr_fs_acc2_size_7_0_mask                                 (0x000000FF)
#define  ATSC_ADDR_2175_tr_fs_acc2_size_7_0(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2175_get_tr_fs_acc2_size_7_0(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2176                                                         0x181545D8
#define  ATSC_ADDR_2176_reg_addr                                                 "0xB81545D8"
#define  ATSC_ADDR_2176_reg                                                      0xB81545D8
#define  ATSC_ADDR_2176_inst_addr                                                "0x00B5"
#define  set_ATSC_ADDR_2176_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2176_reg)=data)
#define  get_ATSC_ADDR_2176_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2176_reg))
#define  ATSC_ADDR_2176_tr_fs_pll_kf_off_shift                                   (5)
#define  ATSC_ADDR_2176_tr_fs_pll_kf_exp_shift                                   (2)
#define  ATSC_ADDR_2176_tr_fs_acc2_size_9_8_shift                                (0)
#define  ATSC_ADDR_2176_tr_fs_pll_kf_off_mask                                    (0x00000020)
#define  ATSC_ADDR_2176_tr_fs_pll_kf_exp_mask                                    (0x0000001C)
#define  ATSC_ADDR_2176_tr_fs_acc2_size_9_8_mask                                 (0x00000003)
#define  ATSC_ADDR_2176_tr_fs_pll_kf_off(data)                                   (0x00000020&((data)<<5))
#define  ATSC_ADDR_2176_tr_fs_pll_kf_exp(data)                                   (0x0000001C&((data)<<2))
#define  ATSC_ADDR_2176_tr_fs_acc2_size_9_8(data)                                (0x00000003&(data))
#define  ATSC_ADDR_2176_get_tr_fs_pll_kf_off(data)                               ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2176_get_tr_fs_pll_kf_exp(data)                               ((0x0000001C&(data))>>2)
#define  ATSC_ADDR_2176_get_tr_fs_acc2_size_9_8(data)                            (0x00000003&(data))

#define  ATSC_ADDR_2177                                                         0x181545DC
#define  ATSC_ADDR_2177_reg_addr                                                 "0xB81545DC"
#define  ATSC_ADDR_2177_reg                                                      0xB81545DC
#define  ATSC_ADDR_2177_inst_addr                                                "0x00B6"
#define  set_ATSC_ADDR_2177_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2177_reg)=data)
#define  get_ATSC_ADDR_2177_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2177_reg))
#define  ATSC_ADDR_2177_tr_fs_pll_sign_shift                                     (5)
#define  ATSC_ADDR_2177_tr_fs_pll_reacq_en_shift                                 (4)
#define  ATSC_ADDR_2177_tr_fs_ped_reacq_en_shift                                 (3)
#define  ATSC_ADDR_2177_tr_fs_fll_reacq_en_shift                                 (2)
#define  ATSC_ADDR_2177_tr_fs_fed_reacq_en_shift                                 (1)
#define  ATSC_ADDR_2177_tr_fs_trk_ind_reacq_en_shift                             (0)
#define  ATSC_ADDR_2177_tr_fs_pll_sign_mask                                      (0x00000020)
#define  ATSC_ADDR_2177_tr_fs_pll_reacq_en_mask                                  (0x00000010)
#define  ATSC_ADDR_2177_tr_fs_ped_reacq_en_mask                                  (0x00000008)
#define  ATSC_ADDR_2177_tr_fs_fll_reacq_en_mask                                  (0x00000004)
#define  ATSC_ADDR_2177_tr_fs_fed_reacq_en_mask                                  (0x00000002)
#define  ATSC_ADDR_2177_tr_fs_trk_ind_reacq_en_mask                              (0x00000001)
#define  ATSC_ADDR_2177_tr_fs_pll_sign(data)                                     (0x00000020&((data)<<5))
#define  ATSC_ADDR_2177_tr_fs_pll_reacq_en(data)                                 (0x00000010&((data)<<4))
#define  ATSC_ADDR_2177_tr_fs_ped_reacq_en(data)                                 (0x00000008&((data)<<3))
#define  ATSC_ADDR_2177_tr_fs_fll_reacq_en(data)                                 (0x00000004&((data)<<2))
#define  ATSC_ADDR_2177_tr_fs_fed_reacq_en(data)                                 (0x00000002&((data)<<1))
#define  ATSC_ADDR_2177_tr_fs_trk_ind_reacq_en(data)                             (0x00000001&(data))
#define  ATSC_ADDR_2177_get_tr_fs_pll_sign(data)                                 ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2177_get_tr_fs_pll_reacq_en(data)                             ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2177_get_tr_fs_ped_reacq_en(data)                             ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2177_get_tr_fs_fll_reacq_en(data)                             ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2177_get_tr_fs_fed_reacq_en(data)                             ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2177_get_tr_fs_trk_ind_reacq_en(data)                         (0x00000001&(data))

#define  ATSC_ADDR_2178                                                         0x181545E0
#define  ATSC_ADDR_2178_reg_addr                                                 "0xB81545E0"
#define  ATSC_ADDR_2178_reg                                                      0xB81545E0
#define  ATSC_ADDR_2178_inst_addr                                                "0x00B7"
#define  set_ATSC_ADDR_2178_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2178_reg)=data)
#define  get_ATSC_ADDR_2178_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2178_reg))
#define  ATSC_ADDR_2178_tr_fs_corr_sel2_shift                                    (6)
#define  ATSC_ADDR_2178_tr_fs_pll_wait_fll_en_shift                              (5)
#define  ATSC_ADDR_2178_tr_fs_cor_sel_shift                                      (4)
#define  ATSC_ADDR_2178_tr_fs_trk_cnt_th_shift                                   (0)
#define  ATSC_ADDR_2178_tr_fs_corr_sel2_mask                                     (0x00000040)
#define  ATSC_ADDR_2178_tr_fs_pll_wait_fll_en_mask                               (0x00000020)
#define  ATSC_ADDR_2178_tr_fs_cor_sel_mask                                       (0x00000010)
#define  ATSC_ADDR_2178_tr_fs_trk_cnt_th_mask                                    (0x0000000F)
#define  ATSC_ADDR_2178_tr_fs_corr_sel2(data)                                    (0x00000040&((data)<<6))
#define  ATSC_ADDR_2178_tr_fs_pll_wait_fll_en(data)                              (0x00000020&((data)<<5))
#define  ATSC_ADDR_2178_tr_fs_cor_sel(data)                                      (0x00000010&((data)<<4))
#define  ATSC_ADDR_2178_tr_fs_trk_cnt_th(data)                                   (0x0000000F&(data))
#define  ATSC_ADDR_2178_get_tr_fs_corr_sel2(data)                                ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2178_get_tr_fs_pll_wait_fll_en(data)                          ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2178_get_tr_fs_cor_sel(data)                                  ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2178_get_tr_fs_trk_cnt_th(data)                               (0x0000000F&(data))

#define  ATSC_ADDR_2179                                                         0x181545E4
#define  ATSC_ADDR_2179_reg_addr                                                 "0xB81545E4"
#define  ATSC_ADDR_2179_reg                                                      0xB81545E4
#define  ATSC_ADDR_2179_inst_addr                                                "0x00B8"
#define  set_ATSC_ADDR_2179_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2179_reg)=data)
#define  get_ATSC_ADDR_2179_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2179_reg))
#define  ATSC_ADDR_2179_opt_tr_fs_pk_trk_len_shift                               (0)
#define  ATSC_ADDR_2179_opt_tr_fs_pk_trk_len_mask                                (0x000000FF)
#define  ATSC_ADDR_2179_opt_tr_fs_pk_trk_len(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_2179_get_opt_tr_fs_pk_trk_len(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_217A                                                         0x181545E8
#define  ATSC_ADDR_217A_reg_addr                                                 "0xB81545E8"
#define  ATSC_ADDR_217A_reg                                                      0xB81545E8
#define  ATSC_ADDR_217A_inst_addr                                                "0x00B9"
#define  set_ATSC_ADDR_217A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_217A_reg)=data)
#define  get_ATSC_ADDR_217A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_217A_reg))
#define  ATSC_ADDR_217A_opt_tr_fs_fsm_lock_7_0_shift                             (0)
#define  ATSC_ADDR_217A_opt_tr_fs_fsm_lock_7_0_mask                              (0x000000FF)
#define  ATSC_ADDR_217A_opt_tr_fs_fsm_lock_7_0(data)                             (0x000000FF&(data))
#define  ATSC_ADDR_217A_get_opt_tr_fs_fsm_lock_7_0(data)                         (0x000000FF&(data))

#define  ATSC_ADDR_217B                                                         0x181545EC
#define  ATSC_ADDR_217B_reg_addr                                                 "0xB81545EC"
#define  ATSC_ADDR_217B_reg                                                      0xB81545EC
#define  ATSC_ADDR_217B_inst_addr                                                "0x00BA"
#define  set_ATSC_ADDR_217B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_217B_reg)=data)
#define  get_ATSC_ADDR_217B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_217B_reg))
#define  ATSC_ADDR_217B_opt_tr_fs_fsm_lock_12_8_shift                            (0)
#define  ATSC_ADDR_217B_opt_tr_fs_fsm_lock_12_8_mask                             (0x0000001F)
#define  ATSC_ADDR_217B_opt_tr_fs_fsm_lock_12_8(data)                            (0x0000001F&(data))
#define  ATSC_ADDR_217B_get_opt_tr_fs_fsm_lock_12_8(data)                        (0x0000001F&(data))

#define  ATSC_ADDR_217C                                                         0x181545F0
#define  ATSC_ADDR_217C_reg_addr                                                 "0xB81545F0"
#define  ATSC_ADDR_217C_reg                                                      0xB81545F0
#define  ATSC_ADDR_217C_inst_addr                                                "0x00BB"
#define  set_ATSC_ADDR_217C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_217C_reg)=data)
#define  get_ATSC_ADDR_217C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_217C_reg))
#define  ATSC_ADDR_217C_tr_fs_acc2_size_crs_1_0_shift                            (6)
#define  ATSC_ADDR_217C_tr_fs_fll_exp_crs_shift                                  (4)
#define  ATSC_ADDR_217C_opt_tr_fs_trk_hold_en_shift                              (3)
#define  ATSC_ADDR_217C_opt_tr_fs_el_space_shift                                 (2)
#define  ATSC_ADDR_217C_opt_tr_fs_pk_force_en_shift                              (1)
#define  ATSC_ADDR_217C_opt_tr_fs_pk2el_en_shift                                 (0)
#define  ATSC_ADDR_217C_tr_fs_acc2_size_crs_1_0_mask                             (0x000000C0)
#define  ATSC_ADDR_217C_tr_fs_fll_exp_crs_mask                                   (0x00000030)
#define  ATSC_ADDR_217C_opt_tr_fs_trk_hold_en_mask                               (0x00000008)
#define  ATSC_ADDR_217C_opt_tr_fs_el_space_mask                                  (0x00000004)
#define  ATSC_ADDR_217C_opt_tr_fs_pk_force_en_mask                               (0x00000002)
#define  ATSC_ADDR_217C_opt_tr_fs_pk2el_en_mask                                  (0x00000001)
#define  ATSC_ADDR_217C_tr_fs_acc2_size_crs_1_0(data)                            (0x000000C0&((data)<<6))
#define  ATSC_ADDR_217C_tr_fs_fll_exp_crs(data)                                  (0x00000030&((data)<<4))
#define  ATSC_ADDR_217C_opt_tr_fs_trk_hold_en(data)                              (0x00000008&((data)<<3))
#define  ATSC_ADDR_217C_opt_tr_fs_el_space(data)                                 (0x00000004&((data)<<2))
#define  ATSC_ADDR_217C_opt_tr_fs_pk_force_en(data)                              (0x00000002&((data)<<1))
#define  ATSC_ADDR_217C_opt_tr_fs_pk2el_en(data)                                 (0x00000001&(data))
#define  ATSC_ADDR_217C_get_tr_fs_acc2_size_crs_1_0(data)                        ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_217C_get_tr_fs_fll_exp_crs(data)                              ((0x00000030&(data))>>4)
#define  ATSC_ADDR_217C_get_opt_tr_fs_trk_hold_en(data)                          ((0x00000008&(data))>>3)
#define  ATSC_ADDR_217C_get_opt_tr_fs_el_space(data)                             ((0x00000004&(data))>>2)
#define  ATSC_ADDR_217C_get_opt_tr_fs_pk_force_en(data)                          ((0x00000002&(data))>>1)
#define  ATSC_ADDR_217C_get_opt_tr_fs_pk2el_en(data)                             (0x00000001&(data))

#define  ATSC_ADDR_217D                                                         0x181545F4
#define  ATSC_ADDR_217D_reg_addr                                                 "0xB81545F4"
#define  ATSC_ADDR_217D_reg                                                      0xB81545F4
#define  ATSC_ADDR_217D_inst_addr                                                "0x00BC"
#define  set_ATSC_ADDR_217D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_217D_reg)=data)
#define  get_ATSC_ADDR_217D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_217D_reg))
#define  ATSC_ADDR_217D_tr_fs_acc2_size_crs_9_2_shift                            (0)
#define  ATSC_ADDR_217D_tr_fs_acc2_size_crs_9_2_mask                             (0x000000FF)
#define  ATSC_ADDR_217D_tr_fs_acc2_size_crs_9_2(data)                            (0x000000FF&(data))
#define  ATSC_ADDR_217D_get_tr_fs_acc2_size_crs_9_2(data)                        (0x000000FF&(data))

#define  ATSC_ADDR_217E                                                         0x181545F8
#define  ATSC_ADDR_217E_reg_addr                                                 "0xB81545F8"
#define  ATSC_ADDR_217E_reg                                                      0xB81545F8
#define  ATSC_ADDR_217E_inst_addr                                                "0x00BD"
#define  set_ATSC_ADDR_217E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_217E_reg)=data)
#define  get_ATSC_ADDR_217E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_217E_reg))
#define  ATSC_ADDR_217E_tr_fs_fll_times_crs_shift                                (0)
#define  ATSC_ADDR_217E_tr_fs_fll_times_crs_mask                                 (0x000000FF)
#define  ATSC_ADDR_217E_tr_fs_fll_times_crs(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_217E_get_tr_fs_fll_times_crs(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_217F                                                         0x181545FC
#define  ATSC_ADDR_217F_reg_addr                                                 "0xB81545FC"
#define  ATSC_ADDR_217F_reg                                                      0xB81545FC
#define  ATSC_ADDR_217F_inst_addr                                                "0x00BE"
#define  set_ATSC_ADDR_217F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_217F_reg)=data)
#define  get_ATSC_ADDR_217F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_217F_reg))
#define  ATSC_ADDR_217F_tr_fs_win_crs_start_shift                                (0)
#define  ATSC_ADDR_217F_tr_fs_win_crs_start_mask                                 (0x000000FF)
#define  ATSC_ADDR_217F_tr_fs_win_crs_start(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_217F_get_tr_fs_win_crs_start(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2180                                                         0x18154600
#define  ATSC_ADDR_2180_reg_addr                                                 "0xB8154600"
#define  ATSC_ADDR_2180_reg                                                      0xB8154600
#define  ATSC_ADDR_2180_inst_addr                                                "0x00BF"
#define  set_ATSC_ADDR_2180_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2180_reg)=data)
#define  get_ATSC_ADDR_2180_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2180_reg))
#define  ATSC_ADDR_2180_tr_fs_win_crs_len_shift                                  (0)
#define  ATSC_ADDR_2180_tr_fs_win_crs_len_mask                                   (0x000000FF)
#define  ATSC_ADDR_2180_tr_fs_win_crs_len(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2180_get_tr_fs_win_crs_len(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2181                                                         0x18154604
#define  ATSC_ADDR_2181_reg_addr                                                 "0xB8154604"
#define  ATSC_ADDR_2181_reg                                                      0xB8154604
#define  ATSC_ADDR_2181_inst_addr                                                "0x00C0"
#define  set_ATSC_ADDR_2181_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2181_reg)=data)
#define  get_ATSC_ADDR_2181_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2181_reg))
#define  ATSC_ADDR_2181_tr_fs_win_el_start_shift                                 (0)
#define  ATSC_ADDR_2181_tr_fs_win_el_start_mask                                  (0x000000FF)
#define  ATSC_ADDR_2181_tr_fs_win_el_start(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2181_get_tr_fs_win_el_start(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2182                                                         0x18154608
#define  ATSC_ADDR_2182_reg_addr                                                 "0xB8154608"
#define  ATSC_ADDR_2182_reg                                                      0xB8154608
#define  ATSC_ADDR_2182_inst_addr                                                "0x00C1"
#define  set_ATSC_ADDR_2182_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2182_reg)=data)
#define  get_ATSC_ADDR_2182_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2182_reg))
#define  ATSC_ADDR_2182_tr_fs_win_el_len_shift                                   (0)
#define  ATSC_ADDR_2182_tr_fs_win_el_len_mask                                    (0x000000FF)
#define  ATSC_ADDR_2182_tr_fs_win_el_len(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_2182_get_tr_fs_win_el_len(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_2183                                                         0x1815460C
#define  ATSC_ADDR_2183_reg_addr                                                 "0xB815460C"
#define  ATSC_ADDR_2183_reg                                                      0xB815460C
#define  ATSC_ADDR_2183_inst_addr                                                "0x00C2"
#define  set_ATSC_ADDR_2183_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2183_reg)=data)
#define  get_ATSC_ADDR_2183_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2183_reg))
#define  ATSC_ADDR_2183_opt_tr_fs_el_kp_exp_fine_shift                           (3)
#define  ATSC_ADDR_2183_opt_tr_fs_el_kp_exp_crs_shift                            (0)
#define  ATSC_ADDR_2183_opt_tr_fs_el_kp_exp_fine_mask                            (0x00000038)
#define  ATSC_ADDR_2183_opt_tr_fs_el_kp_exp_crs_mask                             (0x00000007)
#define  ATSC_ADDR_2183_opt_tr_fs_el_kp_exp_fine(data)                           (0x00000038&((data)<<3))
#define  ATSC_ADDR_2183_opt_tr_fs_el_kp_exp_crs(data)                            (0x00000007&(data))
#define  ATSC_ADDR_2183_get_opt_tr_fs_el_kp_exp_fine(data)                       ((0x00000038&(data))>>3)
#define  ATSC_ADDR_2183_get_opt_tr_fs_el_kp_exp_crs(data)                        (0x00000007&(data))

#define  ATSC_ADDR_2184                                                         0x18154610
#define  ATSC_ADDR_2184_reg_addr                                                 "0xB8154610"
#define  ATSC_ADDR_2184_reg                                                      0xB8154610
#define  ATSC_ADDR_2184_inst_addr                                                "0x00C3"
#define  set_ATSC_ADDR_2184_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2184_reg)=data)
#define  get_ATSC_ADDR_2184_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2184_reg))
#define  ATSC_ADDR_2184_opt_tr_fs_el_kf_exp_crs_shift                            (3)
#define  ATSC_ADDR_2184_opt_tr_fs_el_kp_exp_trk_shift                            (0)
#define  ATSC_ADDR_2184_opt_tr_fs_el_kf_exp_crs_mask                             (0x00000078)
#define  ATSC_ADDR_2184_opt_tr_fs_el_kp_exp_trk_mask                             (0x00000007)
#define  ATSC_ADDR_2184_opt_tr_fs_el_kf_exp_crs(data)                            (0x00000078&((data)<<3))
#define  ATSC_ADDR_2184_opt_tr_fs_el_kp_exp_trk(data)                            (0x00000007&(data))
#define  ATSC_ADDR_2184_get_opt_tr_fs_el_kf_exp_crs(data)                        ((0x00000078&(data))>>3)
#define  ATSC_ADDR_2184_get_opt_tr_fs_el_kp_exp_trk(data)                        (0x00000007&(data))

#define  ATSC_ADDR_2185                                                         0x18154614
#define  ATSC_ADDR_2185_reg_addr                                                 "0xB8154614"
#define  ATSC_ADDR_2185_reg                                                      0xB8154614
#define  ATSC_ADDR_2185_inst_addr                                                "0x00C4"
#define  set_ATSC_ADDR_2185_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2185_reg)=data)
#define  get_ATSC_ADDR_2185_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2185_reg))
#define  ATSC_ADDR_2185_opt_tr_fs_el_kf_exp_trk_shift                            (4)
#define  ATSC_ADDR_2185_opt_tr_fs_el_kf_exp_fine_shift                           (0)
#define  ATSC_ADDR_2185_opt_tr_fs_el_kf_exp_trk_mask                             (0x000000F0)
#define  ATSC_ADDR_2185_opt_tr_fs_el_kf_exp_fine_mask                            (0x0000000F)
#define  ATSC_ADDR_2185_opt_tr_fs_el_kf_exp_trk(data)                            (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2185_opt_tr_fs_el_kf_exp_fine(data)                           (0x0000000F&(data))
#define  ATSC_ADDR_2185_get_opt_tr_fs_el_kf_exp_trk(data)                        ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2185_get_opt_tr_fs_el_kf_exp_fine(data)                       (0x0000000F&(data))

#define  ATSC_ADDR_2186                                                         0x18154618
#define  ATSC_ADDR_2186_reg_addr                                                 "0xB8154618"
#define  ATSC_ADDR_2186_reg                                                      0xB8154618
#define  ATSC_ADDR_2186_inst_addr                                                "0x00C5"
#define  set_ATSC_ADDR_2186_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2186_reg)=data)
#define  get_ATSC_ADDR_2186_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2186_reg))
#define  ATSC_ADDR_2186_opt_tr_fs_el_crs_len_7_0_shift                           (0)
#define  ATSC_ADDR_2186_opt_tr_fs_el_crs_len_7_0_mask                            (0x000000FF)
#define  ATSC_ADDR_2186_opt_tr_fs_el_crs_len_7_0(data)                           (0x000000FF&(data))
#define  ATSC_ADDR_2186_get_opt_tr_fs_el_crs_len_7_0(data)                       (0x000000FF&(data))

#define  ATSC_ADDR_2187                                                         0x1815461C
#define  ATSC_ADDR_2187_reg_addr                                                 "0xB815461C"
#define  ATSC_ADDR_2187_reg                                                      0xB815461C
#define  ATSC_ADDR_2187_inst_addr                                                "0x00C6"
#define  set_ATSC_ADDR_2187_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2187_reg)=data)
#define  get_ATSC_ADDR_2187_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2187_reg))
#define  ATSC_ADDR_2187_opt_tr_fs_el_fine_len_3_0_shift                          (4)
#define  ATSC_ADDR_2187_opt_tr_fs_el_crs_len_11_8_shift                          (0)
#define  ATSC_ADDR_2187_opt_tr_fs_el_fine_len_3_0_mask                           (0x000000F0)
#define  ATSC_ADDR_2187_opt_tr_fs_el_crs_len_11_8_mask                           (0x0000000F)
#define  ATSC_ADDR_2187_opt_tr_fs_el_fine_len_3_0(data)                          (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2187_opt_tr_fs_el_crs_len_11_8(data)                          (0x0000000F&(data))
#define  ATSC_ADDR_2187_get_opt_tr_fs_el_fine_len_3_0(data)                      ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2187_get_opt_tr_fs_el_crs_len_11_8(data)                      (0x0000000F&(data))

#define  ATSC_ADDR_2188                                                         0x18154620
#define  ATSC_ADDR_2188_reg_addr                                                 "0xB8154620"
#define  ATSC_ADDR_2188_reg                                                      0xB8154620
#define  ATSC_ADDR_2188_inst_addr                                                "0x00C7"
#define  set_ATSC_ADDR_2188_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2188_reg)=data)
#define  get_ATSC_ADDR_2188_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2188_reg))
#define  ATSC_ADDR_2188_opt_tr_fs_el_fine_len_11_4_shift                         (0)
#define  ATSC_ADDR_2188_opt_tr_fs_el_fine_len_11_4_mask                          (0x000000FF)
#define  ATSC_ADDR_2188_opt_tr_fs_el_fine_len_11_4(data)                         (0x000000FF&(data))
#define  ATSC_ADDR_2188_get_opt_tr_fs_el_fine_len_11_4(data)                     (0x000000FF&(data))

#define  ATSC_ADDR_2189                                                         0x18154624
#define  ATSC_ADDR_2189_reg_addr                                                 "0xB8154624"
#define  ATSC_ADDR_2189_reg                                                      0xB8154624
#define  ATSC_ADDR_2189_inst_addr                                                "0x00C8"
#define  set_ATSC_ADDR_2189_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2189_reg)=data)
#define  get_ATSC_ADDR_2189_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2189_reg))
#define  ATSC_ADDR_2189_opt_tr_fs_el_err_max_fine_shift                          (4)
#define  ATSC_ADDR_2189_opt_tr_fs_el_err_max_crs_shift                           (0)
#define  ATSC_ADDR_2189_opt_tr_fs_el_err_max_fine_mask                           (0x000000F0)
#define  ATSC_ADDR_2189_opt_tr_fs_el_err_max_crs_mask                            (0x0000000F)
#define  ATSC_ADDR_2189_opt_tr_fs_el_err_max_fine(data)                          (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2189_opt_tr_fs_el_err_max_crs(data)                           (0x0000000F&(data))
#define  ATSC_ADDR_2189_get_opt_tr_fs_el_err_max_fine(data)                      ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2189_get_opt_tr_fs_el_err_max_crs(data)                       (0x0000000F&(data))

#define  ATSC_ADDR_218A                                                         0x18154628
#define  ATSC_ADDR_218A_reg_addr                                                 "0xB8154628"
#define  ATSC_ADDR_218A_reg                                                      0xB8154628
#define  ATSC_ADDR_218A_inst_addr                                                "0x00C9"
#define  set_ATSC_ADDR_218A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_218A_reg)=data)
#define  get_ATSC_ADDR_218A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_218A_reg))
#define  ATSC_ADDR_218A_opt_tr_fs_el_trk_upd_prd_shift                           (4)
#define  ATSC_ADDR_218A_opt_tr_fs_el_err_max_trk_shift                           (0)
#define  ATSC_ADDR_218A_opt_tr_fs_el_trk_upd_prd_mask                            (0x00000070)
#define  ATSC_ADDR_218A_opt_tr_fs_el_err_max_trk_mask                            (0x0000000F)
#define  ATSC_ADDR_218A_opt_tr_fs_el_trk_upd_prd(data)                           (0x00000070&((data)<<4))
#define  ATSC_ADDR_218A_opt_tr_fs_el_err_max_trk(data)                           (0x0000000F&(data))
#define  ATSC_ADDR_218A_get_opt_tr_fs_el_trk_upd_prd(data)                       ((0x00000070&(data))>>4)
#define  ATSC_ADDR_218A_get_opt_tr_fs_el_err_max_trk(data)                       (0x0000000F&(data))

#define  ATSC_ADDR_218B                                                         0x1815462C
#define  ATSC_ADDR_218B_reg_addr                                                 "0xB815462C"
#define  ATSC_ADDR_218B_reg                                                      0xB815462C
#define  ATSC_ADDR_218B_inst_addr                                                "0x00CA"
#define  set_ATSC_ADDR_218B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_218B_reg)=data)
#define  get_ATSC_ADDR_218B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_218B_reg))
#define  ATSC_ADDR_218B_opt_tr_fs_el_erracc_th_shift                             (0)
#define  ATSC_ADDR_218B_opt_tr_fs_el_erracc_th_mask                              (0x000000FF)
#define  ATSC_ADDR_218B_opt_tr_fs_el_erracc_th(data)                             (0x000000FF&(data))
#define  ATSC_ADDR_218B_get_opt_tr_fs_el_erracc_th(data)                         (0x000000FF&(data))

#define  ATSC_ADDR_218C                                                         0x18154630
#define  ATSC_ADDR_218C_reg_addr                                                 "0xB8154630"
#define  ATSC_ADDR_218C_reg                                                      0xB8154630
#define  ATSC_ADDR_218C_inst_addr                                                "0x00CB"
#define  set_ATSC_ADDR_218C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_218C_reg)=data)
#define  get_ATSC_ADDR_218C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_218C_reg))
#define  ATSC_ADDR_218C_opt_tr_fs_el_errmax_th_shift                             (0)
#define  ATSC_ADDR_218C_opt_tr_fs_el_errmax_th_mask                              (0x000000FF)
#define  ATSC_ADDR_218C_opt_tr_fs_el_errmax_th(data)                             (0x000000FF&(data))
#define  ATSC_ADDR_218C_get_opt_tr_fs_el_errmax_th(data)                         (0x000000FF&(data))

#define  ATSC_ADDR_218D                                                         0x18154634
#define  ATSC_ADDR_218D_reg_addr                                                 "0xB8154634"
#define  ATSC_ADDR_218D_reg                                                      0xB8154634
#define  ATSC_ADDR_218D_inst_addr                                                "0x00CC"
#define  set_ATSC_ADDR_218D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_218D_reg)=data)
#define  get_ATSC_ADDR_218D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_218D_reg))
#define  ATSC_ADDR_218D_opt_tr_fs_el_lock_sel_shift                              (3)
#define  ATSC_ADDR_218D_opt_tr_fs_el_lock_prd_shift                              (0)
#define  ATSC_ADDR_218D_opt_tr_fs_el_lock_sel_mask                               (0x00000038)
#define  ATSC_ADDR_218D_opt_tr_fs_el_lock_prd_mask                               (0x00000007)
#define  ATSC_ADDR_218D_opt_tr_fs_el_lock_sel(data)                              (0x00000038&((data)<<3))
#define  ATSC_ADDR_218D_opt_tr_fs_el_lock_prd(data)                              (0x00000007&(data))
#define  ATSC_ADDR_218D_get_opt_tr_fs_el_lock_sel(data)                          ((0x00000038&(data))>>3)
#define  ATSC_ADDR_218D_get_opt_tr_fs_el_lock_prd(data)                          (0x00000007&(data))

#define  ATSC_ADDR_218E                                                         0x18154638
#define  ATSC_ADDR_218E_reg_addr                                                 "0xB8154638"
#define  ATSC_ADDR_218E_reg                                                      0xB8154638
#define  ATSC_ADDR_218E_inst_addr                                                "0x00CD"
#define  set_ATSC_ADDR_218E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_218E_reg)=data)
#define  get_ATSC_ADDR_218E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_218E_reg))
#define  ATSC_ADDR_218E_opt_tr_fs_el_weak_ratio_shift                            (5)
#define  ATSC_ADDR_218E_opt_tr_fs_el_chg_strobe_shift                            (4)
#define  ATSC_ADDR_218E_opt_tr_fs_el_loc_upd12_shift                             (3)
#define  ATSC_ADDR_218E_opt_tr_fs_el_loc_upd10_shift                             (2)
#define  ATSC_ADDR_218E_opt_tr_fs_el_loc_upd8_shift                              (1)
#define  ATSC_ADDR_218E_opt_tr_fs_el_loc_upd6_shift                              (0)
#define  ATSC_ADDR_218E_opt_tr_fs_el_weak_ratio_mask                             (0x000000E0)
#define  ATSC_ADDR_218E_opt_tr_fs_el_chg_strobe_mask                             (0x00000010)
#define  ATSC_ADDR_218E_opt_tr_fs_el_loc_upd12_mask                              (0x00000008)
#define  ATSC_ADDR_218E_opt_tr_fs_el_loc_upd10_mask                              (0x00000004)
#define  ATSC_ADDR_218E_opt_tr_fs_el_loc_upd8_mask                               (0x00000002)
#define  ATSC_ADDR_218E_opt_tr_fs_el_loc_upd6_mask                               (0x00000001)
#define  ATSC_ADDR_218E_opt_tr_fs_el_weak_ratio(data)                            (0x000000E0&((data)<<5))
#define  ATSC_ADDR_218E_opt_tr_fs_el_chg_strobe(data)                            (0x00000010&((data)<<4))
#define  ATSC_ADDR_218E_opt_tr_fs_el_loc_upd12(data)                             (0x00000008&((data)<<3))
#define  ATSC_ADDR_218E_opt_tr_fs_el_loc_upd10(data)                             (0x00000004&((data)<<2))
#define  ATSC_ADDR_218E_opt_tr_fs_el_loc_upd8(data)                              (0x00000002&((data)<<1))
#define  ATSC_ADDR_218E_opt_tr_fs_el_loc_upd6(data)                              (0x00000001&(data))
#define  ATSC_ADDR_218E_get_opt_tr_fs_el_weak_ratio(data)                        ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_218E_get_opt_tr_fs_el_chg_strobe(data)                        ((0x00000010&(data))>>4)
#define  ATSC_ADDR_218E_get_opt_tr_fs_el_loc_upd12(data)                         ((0x00000008&(data))>>3)
#define  ATSC_ADDR_218E_get_opt_tr_fs_el_loc_upd10(data)                         ((0x00000004&(data))>>2)
#define  ATSC_ADDR_218E_get_opt_tr_fs_el_loc_upd8(data)                          ((0x00000002&(data))>>1)
#define  ATSC_ADDR_218E_get_opt_tr_fs_el_loc_upd6(data)                          (0x00000001&(data))

#define  ATSC_ADDR_218F                                                         0x1815463C
#define  ATSC_ADDR_218F_reg_addr                                                 "0xB815463C"
#define  ATSC_ADDR_218F_reg                                                      0xB815463C
#define  ATSC_ADDR_218F_inst_addr                                                "0x00CE"
#define  set_ATSC_ADDR_218F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_218F_reg)=data)
#define  get_ATSC_ADDR_218F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_218F_reg))
#define  ATSC_ADDR_218F_opt_tr_fs_el_chg_stage_shift                             (4)
#define  ATSC_ADDR_218F_opt_tr_fs_el_weak_prd_shift                              (0)
#define  ATSC_ADDR_218F_opt_tr_fs_el_chg_stage_mask                              (0x00000030)
#define  ATSC_ADDR_218F_opt_tr_fs_el_weak_prd_mask                               (0x0000000F)
#define  ATSC_ADDR_218F_opt_tr_fs_el_chg_stage(data)                             (0x00000030&((data)<<4))
#define  ATSC_ADDR_218F_opt_tr_fs_el_weak_prd(data)                              (0x0000000F&(data))
#define  ATSC_ADDR_218F_get_opt_tr_fs_el_chg_stage(data)                         ((0x00000030&(data))>>4)
#define  ATSC_ADDR_218F_get_opt_tr_fs_el_weak_prd(data)                          (0x0000000F&(data))

#define  ATSC_ADDR_2190                                                         0x18154640
#define  ATSC_ADDR_2190_reg_addr                                                 "0xB8154640"
#define  ATSC_ADDR_2190_reg                                                      0xB8154640
#define  ATSC_ADDR_2190_inst_addr                                                "0x00CF"
#define  set_ATSC_ADDR_2190_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2190_reg)=data)
#define  get_ATSC_ADDR_2190_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2190_reg))
#define  ATSC_ADDR_2190_tr_fs_win_hold_start_7_0_shift                           (0)
#define  ATSC_ADDR_2190_tr_fs_win_hold_start_7_0_mask                            (0x000000FF)
#define  ATSC_ADDR_2190_tr_fs_win_hold_start_7_0(data)                           (0x000000FF&(data))
#define  ATSC_ADDR_2190_get_tr_fs_win_hold_start_7_0(data)                       (0x000000FF&(data))

#define  ATSC_ADDR_2191                                                         0x18154644
#define  ATSC_ADDR_2191_reg_addr                                                 "0xB8154644"
#define  ATSC_ADDR_2191_reg                                                      0xB8154644
#define  ATSC_ADDR_2191_inst_addr                                                "0x00D0"
#define  set_ATSC_ADDR_2191_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2191_reg)=data)
#define  get_ATSC_ADDR_2191_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2191_reg))
#define  ATSC_ADDR_2191_tr_fs_win_hold_start_11_8_shift                          (0)
#define  ATSC_ADDR_2191_tr_fs_win_hold_start_11_8_mask                           (0x0000000F)
#define  ATSC_ADDR_2191_tr_fs_win_hold_start_11_8(data)                          (0x0000000F&(data))
#define  ATSC_ADDR_2191_get_tr_fs_win_hold_start_11_8(data)                      (0x0000000F&(data))

#define  ATSC_ADDR_2192                                                         0x18154648
#define  ATSC_ADDR_2192_reg_addr                                                 "0xB8154648"
#define  ATSC_ADDR_2192_reg                                                      0xB8154648
#define  ATSC_ADDR_2192_inst_addr                                                "0x00D1"
#define  set_ATSC_ADDR_2192_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2192_reg)=data)
#define  get_ATSC_ADDR_2192_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2192_reg))
#define  ATSC_ADDR_2192_tr_fs_win_hold_len_7_0_shift                             (0)
#define  ATSC_ADDR_2192_tr_fs_win_hold_len_7_0_mask                              (0x000000FF)
#define  ATSC_ADDR_2192_tr_fs_win_hold_len_7_0(data)                             (0x000000FF&(data))
#define  ATSC_ADDR_2192_get_tr_fs_win_hold_len_7_0(data)                         (0x000000FF&(data))

#define  ATSC_ADDR_2193                                                         0x1815464C
#define  ATSC_ADDR_2193_reg_addr                                                 "0xB815464C"
#define  ATSC_ADDR_2193_reg                                                      0xB815464C
#define  ATSC_ADDR_2193_inst_addr                                                "0x00D2"
#define  set_ATSC_ADDR_2193_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2193_reg)=data)
#define  get_ATSC_ADDR_2193_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2193_reg))
#define  ATSC_ADDR_2193_tr_fs_win_hold_len_11_8_shift                            (0)
#define  ATSC_ADDR_2193_tr_fs_win_hold_len_11_8_mask                             (0x0000000F)
#define  ATSC_ADDR_2193_tr_fs_win_hold_len_11_8(data)                            (0x0000000F&(data))
#define  ATSC_ADDR_2193_get_tr_fs_win_hold_len_11_8(data)                        (0x0000000F&(data))

#define  ATSC_ADDR_2194                                                         0x18154650
#define  ATSC_ADDR_2194_reg_addr                                                 "0xB8154650"
#define  ATSC_ADDR_2194_reg                                                      0xB8154650
#define  ATSC_ADDR_2194_inst_addr                                                "0x00D3"
#define  set_ATSC_ADDR_2194_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2194_reg)=data)
#define  get_ATSC_ADDR_2194_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2194_reg))
#define  ATSC_ADDR_2194_opt_tr_fs_pkcrs2el_sel_shift                             (1)
#define  ATSC_ADDR_2194_tr_fs_pll_sign_sel_shift                                 (0)
#define  ATSC_ADDR_2194_opt_tr_fs_pkcrs2el_sel_mask                              (0x00000006)
#define  ATSC_ADDR_2194_tr_fs_pll_sign_sel_mask                                  (0x00000001)
#define  ATSC_ADDR_2194_opt_tr_fs_pkcrs2el_sel(data)                             (0x00000006&((data)<<1))
#define  ATSC_ADDR_2194_tr_fs_pll_sign_sel(data)                                 (0x00000001&(data))
#define  ATSC_ADDR_2194_get_opt_tr_fs_pkcrs2el_sel(data)                         ((0x00000006&(data))>>1)
#define  ATSC_ADDR_2194_get_tr_fs_pll_sign_sel(data)                             (0x00000001&(data))

#define  ATSC_ADDR_2195                                                         0x18154654
#define  ATSC_ADDR_2195_reg_addr                                                 "0xB8154654"
#define  ATSC_ADDR_2195_reg                                                      0xB8154654
#define  ATSC_ADDR_2195_inst_addr                                                "0x00D4"
#define  set_ATSC_ADDR_2195_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2195_reg)=data)
#define  get_ATSC_ADDR_2195_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2195_reg))
#define  ATSC_ADDR_2195_opt_tr_fs_bps_pk_trk_shift                               (7)
#define  ATSC_ADDR_2195_opt_tr_fs_bps_pk_crs_shift                               (6)
#define  ATSC_ADDR_2195_opt_tr_fs_fsm_pass0_shift                                (5)
#define  ATSC_ADDR_2195_opt_tr_fs_fsm_en_shift                                   (4)
#define  ATSC_ADDR_2195_opt_tr_fs_pk_go3_shift                                   (3)
#define  ATSC_ADDR_2195_opt_tr_fs_pk_go2_shift                                   (2)
#define  ATSC_ADDR_2195_opt_tr_fs_pk_go1_shift                                   (1)
#define  ATSC_ADDR_2195_opt_tr_fs_pk_go0_shift                                   (0)
#define  ATSC_ADDR_2195_opt_tr_fs_bps_pk_trk_mask                                (0x00000080)
#define  ATSC_ADDR_2195_opt_tr_fs_bps_pk_crs_mask                                (0x00000040)
#define  ATSC_ADDR_2195_opt_tr_fs_fsm_pass0_mask                                 (0x00000020)
#define  ATSC_ADDR_2195_opt_tr_fs_fsm_en_mask                                    (0x00000010)
#define  ATSC_ADDR_2195_opt_tr_fs_pk_go3_mask                                    (0x00000008)
#define  ATSC_ADDR_2195_opt_tr_fs_pk_go2_mask                                    (0x00000004)
#define  ATSC_ADDR_2195_opt_tr_fs_pk_go1_mask                                    (0x00000002)
#define  ATSC_ADDR_2195_opt_tr_fs_pk_go0_mask                                    (0x00000001)
#define  ATSC_ADDR_2195_opt_tr_fs_bps_pk_trk(data)                               (0x00000080&((data)<<7))
#define  ATSC_ADDR_2195_opt_tr_fs_bps_pk_crs(data)                               (0x00000040&((data)<<6))
#define  ATSC_ADDR_2195_opt_tr_fs_fsm_pass0(data)                                (0x00000020&((data)<<5))
#define  ATSC_ADDR_2195_opt_tr_fs_fsm_en(data)                                   (0x00000010&((data)<<4))
#define  ATSC_ADDR_2195_opt_tr_fs_pk_go3(data)                                   (0x00000008&((data)<<3))
#define  ATSC_ADDR_2195_opt_tr_fs_pk_go2(data)                                   (0x00000004&((data)<<2))
#define  ATSC_ADDR_2195_opt_tr_fs_pk_go1(data)                                   (0x00000002&((data)<<1))
#define  ATSC_ADDR_2195_opt_tr_fs_pk_go0(data)                                   (0x00000001&(data))
#define  ATSC_ADDR_2195_get_opt_tr_fs_bps_pk_trk(data)                           ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2195_get_opt_tr_fs_bps_pk_crs(data)                           ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2195_get_opt_tr_fs_fsm_pass0(data)                            ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2195_get_opt_tr_fs_fsm_en(data)                               ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2195_get_opt_tr_fs_pk_go3(data)                               ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2195_get_opt_tr_fs_pk_go2(data)                               ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2195_get_opt_tr_fs_pk_go1(data)                               ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2195_get_opt_tr_fs_pk_go0(data)                               (0x00000001&(data))

#define  ATSC_ADDR_2196                                                         0x18154658
#define  ATSC_ADDR_2196_reg_addr                                                 "0xB8154658"
#define  ATSC_ADDR_2196_reg                                                      0xB8154658
#define  ATSC_ADDR_2196_inst_addr                                                "0x00D5"
#define  set_ATSC_ADDR_2196_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2196_reg)=data)
#define  get_ATSC_ADDR_2196_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2196_reg))
#define  ATSC_ADDR_2196_tr_fs_cor_th_el_shift                                    (0)
#define  ATSC_ADDR_2196_tr_fs_cor_th_el_mask                                     (0x000000FF)
#define  ATSC_ADDR_2196_tr_fs_cor_th_el(data)                                    (0x000000FF&(data))
#define  ATSC_ADDR_2196_get_tr_fs_cor_th_el(data)                                (0x000000FF&(data))

#define  ATSC_ADDR_21A0                                                         0x18154680
#define  ATSC_ADDR_21A0_reg_addr                                                 "0xB8154680"
#define  ATSC_ADDR_21A0_reg                                                      0xB8154680
#define  ATSC_ADDR_21A0_inst_addr                                                "0x00D6"
#define  set_ATSC_ADDR_21A0_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21A0_reg)=data)
#define  get_ATSC_ADDR_21A0_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21A0_reg))
#define  ATSC_ADDR_21A0_pn63_pos_lb_7_0_shift                                    (0)
#define  ATSC_ADDR_21A0_pn63_pos_lb_7_0_mask                                     (0x000000FF)
#define  ATSC_ADDR_21A0_pn63_pos_lb_7_0(data)                                    (0x000000FF&(data))
#define  ATSC_ADDR_21A0_get_pn63_pos_lb_7_0(data)                                (0x000000FF&(data))

#define  ATSC_ADDR_21A1                                                         0x18154684
#define  ATSC_ADDR_21A1_reg_addr                                                 "0xB8154684"
#define  ATSC_ADDR_21A1_reg                                                      0xB8154684
#define  ATSC_ADDR_21A1_inst_addr                                                "0x00D7"
#define  set_ATSC_ADDR_21A1_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21A1_reg)=data)
#define  get_ATSC_ADDR_21A1_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21A1_reg))
#define  ATSC_ADDR_21A1_opt_eq_train2_cnt_shift                                  (3)
#define  ATSC_ADDR_21A1_opt_eq_train_cnt_shift                                   (2)
#define  ATSC_ADDR_21A1_pn63_pos_lb_9_8_shift                                    (0)
#define  ATSC_ADDR_21A1_opt_eq_train2_cnt_mask                                   (0x00000008)
#define  ATSC_ADDR_21A1_opt_eq_train_cnt_mask                                    (0x00000004)
#define  ATSC_ADDR_21A1_pn63_pos_lb_9_8_mask                                     (0x00000003)
#define  ATSC_ADDR_21A1_opt_eq_train2_cnt(data)                                  (0x00000008&((data)<<3))
#define  ATSC_ADDR_21A1_opt_eq_train_cnt(data)                                   (0x00000004&((data)<<2))
#define  ATSC_ADDR_21A1_pn63_pos_lb_9_8(data)                                    (0x00000003&(data))
#define  ATSC_ADDR_21A1_get_opt_eq_train2_cnt(data)                              ((0x00000008&(data))>>3)
#define  ATSC_ADDR_21A1_get_opt_eq_train_cnt(data)                               ((0x00000004&(data))>>2)
#define  ATSC_ADDR_21A1_get_pn63_pos_lb_9_8(data)                                (0x00000003&(data))

#define  ATSC_ADDR_21A2                                                         0x18154688
#define  ATSC_ADDR_21A2_reg_addr                                                 "0xB8154688"
#define  ATSC_ADDR_21A2_reg                                                      0xB8154688
#define  ATSC_ADDR_21A2_inst_addr                                                "0x00D8"
#define  set_ATSC_ADDR_21A2_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21A2_reg)=data)
#define  get_ATSC_ADDR_21A2_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21A2_reg))
#define  ATSC_ADDR_21A2_pn63_pos_ub_7_0_shift                                    (0)
#define  ATSC_ADDR_21A2_pn63_pos_ub_7_0_mask                                     (0x000000FF)
#define  ATSC_ADDR_21A2_pn63_pos_ub_7_0(data)                                    (0x000000FF&(data))
#define  ATSC_ADDR_21A2_get_pn63_pos_ub_7_0(data)                                (0x000000FF&(data))

#define  ATSC_ADDR_21A3                                                         0x1815468C
#define  ATSC_ADDR_21A3_reg_addr                                                 "0xB815468C"
#define  ATSC_ADDR_21A3_reg                                                      0xB815468C
#define  ATSC_ADDR_21A3_inst_addr                                                "0x00D9"
#define  set_ATSC_ADDR_21A3_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21A3_reg)=data)
#define  get_ATSC_ADDR_21A3_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21A3_reg))
#define  ATSC_ADDR_21A3_fsm_final_state_shift                                    (2)
#define  ATSC_ADDR_21A3_pn63_pos_ub_9_8_shift                                    (0)
#define  ATSC_ADDR_21A3_fsm_final_state_mask                                     (0x000000FC)
#define  ATSC_ADDR_21A3_pn63_pos_ub_9_8_mask                                     (0x00000003)
#define  ATSC_ADDR_21A3_fsm_final_state(data)                                    (0x000000FC&((data)<<2))
#define  ATSC_ADDR_21A3_pn63_pos_ub_9_8(data)                                    (0x00000003&(data))
#define  ATSC_ADDR_21A3_get_fsm_final_state(data)                                ((0x000000FC&(data))>>2)
#define  ATSC_ADDR_21A3_get_pn63_pos_ub_9_8(data)                                (0x00000003&(data))

#define  ATSC_ADDR_21A4                                                         0x18154690
#define  ATSC_ADDR_21A4_reg_addr                                                 "0xB8154690"
#define  ATSC_ADDR_21A4_reg                                                      0xB8154690
#define  ATSC_ADDR_21A4_inst_addr                                                "0x00DA"
#define  set_ATSC_ADDR_21A4_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21A4_reg)=data)
#define  get_ATSC_ADDR_21A4_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21A4_reg))
#define  ATSC_ADDR_21A4_eq_train_cnt_th_7_0_shift                                (0)
#define  ATSC_ADDR_21A4_eq_train_cnt_th_7_0_mask                                 (0x000000FF)
#define  ATSC_ADDR_21A4_eq_train_cnt_th_7_0(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_21A4_get_eq_train_cnt_th_7_0(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_21A5                                                         0x18154694
#define  ATSC_ADDR_21A5_reg_addr                                                 "0xB8154694"
#define  ATSC_ADDR_21A5_reg                                                      0xB8154694
#define  ATSC_ADDR_21A5_inst_addr                                                "0x00DB"
#define  set_ATSC_ADDR_21A5_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21A5_reg)=data)
#define  get_ATSC_ADDR_21A5_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21A5_reg))
#define  ATSC_ADDR_21A5_eq_train_cnt_th_15_8_shift                               (0)
#define  ATSC_ADDR_21A5_eq_train_cnt_th_15_8_mask                                (0x000000FF)
#define  ATSC_ADDR_21A5_eq_train_cnt_th_15_8(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_21A5_get_eq_train_cnt_th_15_8(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_21A6                                                         0x18154698
#define  ATSC_ADDR_21A6_reg_addr                                                 "0xB8154698"
#define  ATSC_ADDR_21A6_reg                                                      0xB8154698
#define  ATSC_ADDR_21A6_inst_addr                                                "0x00DC"
#define  set_ATSC_ADDR_21A6_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21A6_reg)=data)
#define  get_ATSC_ADDR_21A6_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21A6_reg))
#define  ATSC_ADDR_21A6_eq_train2_cnt_th_7_0_shift                               (0)
#define  ATSC_ADDR_21A6_eq_train2_cnt_th_7_0_mask                                (0x000000FF)
#define  ATSC_ADDR_21A6_eq_train2_cnt_th_7_0(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_21A6_get_eq_train2_cnt_th_7_0(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_21A7                                                         0x1815469C
#define  ATSC_ADDR_21A7_reg_addr                                                 "0xB815469C"
#define  ATSC_ADDR_21A7_reg                                                      0xB815469C
#define  ATSC_ADDR_21A7_inst_addr                                                "0x00DD"
#define  set_ATSC_ADDR_21A7_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21A7_reg)=data)
#define  get_ATSC_ADDR_21A7_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21A7_reg))
#define  ATSC_ADDR_21A7_eq_train2_cnt_th_15_8_shift                              (0)
#define  ATSC_ADDR_21A7_eq_train2_cnt_th_15_8_mask                               (0x000000FF)
#define  ATSC_ADDR_21A7_eq_train2_cnt_th_15_8(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_21A7_get_eq_train2_cnt_th_15_8(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_21A8                                                         0x181546A0
#define  ATSC_ADDR_21A8_reg_addr                                                 "0xB81546A0"
#define  ATSC_ADDR_21A8_reg                                                      0xB81546A0
#define  ATSC_ADDR_21A8_inst_addr                                                "0x00DE"
#define  set_ATSC_ADDR_21A8_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21A8_reg)=data)
#define  get_ATSC_ADDR_21A8_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21A8_reg))
#define  ATSC_ADDR_21A8_state_cnt1_inc_state_shift                               (0)
#define  ATSC_ADDR_21A8_state_cnt1_inc_state_mask                                (0x0000003F)
#define  ATSC_ADDR_21A8_state_cnt1_inc_state(data)                               (0x0000003F&(data))
#define  ATSC_ADDR_21A8_get_state_cnt1_inc_state(data)                           (0x0000003F&(data))

#define  ATSC_ADDR_21A9                                                         0x181546A4
#define  ATSC_ADDR_21A9_reg_addr                                                 "0xB81546A4"
#define  ATSC_ADDR_21A9_reg                                                      0xB81546A4
#define  ATSC_ADDR_21A9_inst_addr                                                "0x00DF"
#define  set_ATSC_ADDR_21A9_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21A9_reg)=data)
#define  get_ATSC_ADDR_21A9_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21A9_reg))
#define  ATSC_ADDR_21A9_state_cnt1_reset_state_shift                             (0)
#define  ATSC_ADDR_21A9_state_cnt1_reset_state_mask                              (0x0000003F)
#define  ATSC_ADDR_21A9_state_cnt1_reset_state(data)                             (0x0000003F&(data))
#define  ATSC_ADDR_21A9_get_state_cnt1_reset_state(data)                         (0x0000003F&(data))

#define  ATSC_ADDR_21AA                                                         0x181546A8
#define  ATSC_ADDR_21AA_reg_addr                                                 "0xB81546A8"
#define  ATSC_ADDR_21AA_reg                                                      0xB81546A8
#define  ATSC_ADDR_21AA_inst_addr                                                "0x00E0"
#define  set_ATSC_ADDR_21AA_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21AA_reg)=data)
#define  get_ATSC_ADDR_21AA_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21AA_reg))
#define  ATSC_ADDR_21AA_state_cnt1_th_shift                                      (0)
#define  ATSC_ADDR_21AA_state_cnt1_th_mask                                       (0x000000FF)
#define  ATSC_ADDR_21AA_state_cnt1_th(data)                                      (0x000000FF&(data))
#define  ATSC_ADDR_21AA_get_state_cnt1_th(data)                                  (0x000000FF&(data))

#define  ATSC_ADDR_21AB                                                         0x181546AC
#define  ATSC_ADDR_21AB_reg_addr                                                 "0xB81546AC"
#define  ATSC_ADDR_21AB_reg                                                      0xB81546AC
#define  ATSC_ADDR_21AB_inst_addr                                                "0x00E1"
#define  set_ATSC_ADDR_21AB_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21AB_reg)=data)
#define  get_ATSC_ADDR_21AB_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21AB_reg))
#define  ATSC_ADDR_21AB_state_cnt2_inc_state_shift                               (0)
#define  ATSC_ADDR_21AB_state_cnt2_inc_state_mask                                (0x0000003F)
#define  ATSC_ADDR_21AB_state_cnt2_inc_state(data)                               (0x0000003F&(data))
#define  ATSC_ADDR_21AB_get_state_cnt2_inc_state(data)                           (0x0000003F&(data))

#define  ATSC_ADDR_21AC                                                         0x181546B0
#define  ATSC_ADDR_21AC_reg_addr                                                 "0xB81546B0"
#define  ATSC_ADDR_21AC_reg                                                      0xB81546B0
#define  ATSC_ADDR_21AC_inst_addr                                                "0x00E2"
#define  set_ATSC_ADDR_21AC_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21AC_reg)=data)
#define  get_ATSC_ADDR_21AC_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21AC_reg))
#define  ATSC_ADDR_21AC_state_cnt2_reset_state_shift                             (0)
#define  ATSC_ADDR_21AC_state_cnt2_reset_state_mask                              (0x0000003F)
#define  ATSC_ADDR_21AC_state_cnt2_reset_state(data)                             (0x0000003F&(data))
#define  ATSC_ADDR_21AC_get_state_cnt2_reset_state(data)                         (0x0000003F&(data))

#define  ATSC_ADDR_21AD                                                         0x181546B4
#define  ATSC_ADDR_21AD_reg_addr                                                 "0xB81546B4"
#define  ATSC_ADDR_21AD_reg                                                      0xB81546B4
#define  ATSC_ADDR_21AD_inst_addr                                                "0x00E3"
#define  set_ATSC_ADDR_21AD_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21AD_reg)=data)
#define  get_ATSC_ADDR_21AD_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21AD_reg))
#define  ATSC_ADDR_21AD_state_cnt2_th_shift                                      (0)
#define  ATSC_ADDR_21AD_state_cnt2_th_mask                                       (0x000000FF)
#define  ATSC_ADDR_21AD_state_cnt2_th(data)                                      (0x000000FF&(data))
#define  ATSC_ADDR_21AD_get_state_cnt2_th(data)                                  (0x000000FF&(data))

#define  ATSC_ADDR_21AE                                                         0x181546B8
#define  ATSC_ADDR_21AE_reg_addr                                                 "0xB81546B8"
#define  ATSC_ADDR_21AE_reg                                                      0xB81546B8
#define  ATSC_ADDR_21AE_inst_addr                                                "0x00E4"
#define  set_ATSC_ADDR_21AE_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21AE_reg)=data)
#define  get_ATSC_ADDR_21AE_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21AE_reg))
#define  ATSC_ADDR_21AE_state_cnt1_delay_th_shift                                (0)
#define  ATSC_ADDR_21AE_state_cnt1_delay_th_mask                                 (0x000000FF)
#define  ATSC_ADDR_21AE_state_cnt1_delay_th(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_21AE_get_state_cnt1_delay_th(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_21AF                                                         0x181546BC
#define  ATSC_ADDR_21AF_reg_addr                                                 "0xB81546BC"
#define  ATSC_ADDR_21AF_reg                                                      0xB81546BC
#define  ATSC_ADDR_21AF_inst_addr                                                "0x00E5"
#define  set_ATSC_ADDR_21AF_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21AF_reg)=data)
#define  get_ATSC_ADDR_21AF_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21AF_reg))
#define  ATSC_ADDR_21AF_reg_fsm_cond0_shift                                      (7)
#define  ATSC_ADDR_21AF_fsm_cond0_config_shift                                   (6)
#define  ATSC_ADDR_21AF_reg_fsm_cond4_shift                                      (5)
#define  ATSC_ADDR_21AF_fsm_cond4_config_shift                                   (4)
#define  ATSC_ADDR_21AF_reg_fsm_cond3_shift                                      (3)
#define  ATSC_ADDR_21AF_fsm_cond3_config_shift                                   (2)
#define  ATSC_ADDR_21AF_reg_fsm_cond2_shift                                      (1)
#define  ATSC_ADDR_21AF_fsm_cond2_config_shift                                   (0)
#define  ATSC_ADDR_21AF_reg_fsm_cond0_mask                                       (0x00000080)
#define  ATSC_ADDR_21AF_fsm_cond0_config_mask                                    (0x00000040)
#define  ATSC_ADDR_21AF_reg_fsm_cond4_mask                                       (0x00000020)
#define  ATSC_ADDR_21AF_fsm_cond4_config_mask                                    (0x00000010)
#define  ATSC_ADDR_21AF_reg_fsm_cond3_mask                                       (0x00000008)
#define  ATSC_ADDR_21AF_fsm_cond3_config_mask                                    (0x00000004)
#define  ATSC_ADDR_21AF_reg_fsm_cond2_mask                                       (0x00000002)
#define  ATSC_ADDR_21AF_fsm_cond2_config_mask                                    (0x00000001)
#define  ATSC_ADDR_21AF_reg_fsm_cond0(data)                                      (0x00000080&((data)<<7))
#define  ATSC_ADDR_21AF_fsm_cond0_config(data)                                   (0x00000040&((data)<<6))
#define  ATSC_ADDR_21AF_reg_fsm_cond4(data)                                      (0x00000020&((data)<<5))
#define  ATSC_ADDR_21AF_fsm_cond4_config(data)                                   (0x00000010&((data)<<4))
#define  ATSC_ADDR_21AF_reg_fsm_cond3(data)                                      (0x00000008&((data)<<3))
#define  ATSC_ADDR_21AF_fsm_cond3_config(data)                                   (0x00000004&((data)<<2))
#define  ATSC_ADDR_21AF_reg_fsm_cond2(data)                                      (0x00000002&((data)<<1))
#define  ATSC_ADDR_21AF_fsm_cond2_config(data)                                   (0x00000001&(data))
#define  ATSC_ADDR_21AF_get_reg_fsm_cond0(data)                                  ((0x00000080&(data))>>7)
#define  ATSC_ADDR_21AF_get_fsm_cond0_config(data)                               ((0x00000040&(data))>>6)
#define  ATSC_ADDR_21AF_get_reg_fsm_cond4(data)                                  ((0x00000020&(data))>>5)
#define  ATSC_ADDR_21AF_get_fsm_cond4_config(data)                               ((0x00000010&(data))>>4)
#define  ATSC_ADDR_21AF_get_reg_fsm_cond3(data)                                  ((0x00000008&(data))>>3)
#define  ATSC_ADDR_21AF_get_fsm_cond3_config(data)                               ((0x00000004&(data))>>2)
#define  ATSC_ADDR_21AF_get_reg_fsm_cond2(data)                                  ((0x00000002&(data))>>1)
#define  ATSC_ADDR_21AF_get_fsm_cond2_config(data)                               (0x00000001&(data))

#define  ATSC_ADDR_21B0                                                         0x181546C0
#define  ATSC_ADDR_21B0_reg_addr                                                 "0xB81546C0"
#define  ATSC_ADDR_21B0_reg                                                      0xB81546C0
#define  ATSC_ADDR_21B0_inst_addr                                                "0x00E6"
#define  set_ATSC_ADDR_21B0_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21B0_reg)=data)
#define  get_ATSC_ADDR_21B0_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21B0_reg))
#define  ATSC_ADDR_21B0_fsm_cond8_seg_th_7_0_shift                               (0)
#define  ATSC_ADDR_21B0_fsm_cond8_seg_th_7_0_mask                                (0x000000FF)
#define  ATSC_ADDR_21B0_fsm_cond8_seg_th_7_0(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_21B0_get_fsm_cond8_seg_th_7_0(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_21B1                                                         0x181546C4
#define  ATSC_ADDR_21B1_reg_addr                                                 "0xB81546C4"
#define  ATSC_ADDR_21B1_reg                                                      0xB81546C4
#define  ATSC_ADDR_21B1_inst_addr                                                "0x00E7"
#define  set_ATSC_ADDR_21B1_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21B1_reg)=data)
#define  get_ATSC_ADDR_21B1_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21B1_reg))
#define  ATSC_ADDR_21B1_fsm_cond8_seg_th_8_shift                                 (0)
#define  ATSC_ADDR_21B1_fsm_cond8_seg_th_8_mask                                  (0x00000001)
#define  ATSC_ADDR_21B1_fsm_cond8_seg_th_8(data)                                 (0x00000001&(data))
#define  ATSC_ADDR_21B1_get_fsm_cond8_seg_th_8(data)                             (0x00000001&(data))

#define  ATSC_ADDR_21B2                                                         0x181546C8
#define  ATSC_ADDR_21B2_reg_addr                                                 "0xB81546C8"
#define  ATSC_ADDR_21B2_reg                                                      0xB81546C8
#define  ATSC_ADDR_21B2_inst_addr                                                "0x00E8"
#define  set_ATSC_ADDR_21B2_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21B2_reg)=data)
#define  get_ATSC_ADDR_21B2_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21B2_reg))
#define  ATSC_ADDR_21B2_fsm_cond9_sym_th_7_0_shift                               (0)
#define  ATSC_ADDR_21B2_fsm_cond9_sym_th_7_0_mask                                (0x000000FF)
#define  ATSC_ADDR_21B2_fsm_cond9_sym_th_7_0(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_21B2_get_fsm_cond9_sym_th_7_0(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_21B3                                                         0x181546CC
#define  ATSC_ADDR_21B3_reg_addr                                                 "0xB81546CC"
#define  ATSC_ADDR_21B3_reg                                                      0xB81546CC
#define  ATSC_ADDR_21B3_inst_addr                                                "0x00E9"
#define  set_ATSC_ADDR_21B3_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21B3_reg)=data)
#define  get_ATSC_ADDR_21B3_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21B3_reg))
#define  ATSC_ADDR_21B3_fsm_cond13_config_shift                                  (2)
#define  ATSC_ADDR_21B3_fsm_cond9_sym_th_9_8_shift                               (0)
#define  ATSC_ADDR_21B3_fsm_cond13_config_mask                                   (0x00000004)
#define  ATSC_ADDR_21B3_fsm_cond9_sym_th_9_8_mask                                (0x00000003)
#define  ATSC_ADDR_21B3_fsm_cond13_config(data)                                  (0x00000004&((data)<<2))
#define  ATSC_ADDR_21B3_fsm_cond9_sym_th_9_8(data)                               (0x00000003&(data))
#define  ATSC_ADDR_21B3_get_fsm_cond13_config(data)                              ((0x00000004&(data))>>2)
#define  ATSC_ADDR_21B3_get_fsm_cond9_sym_th_9_8(data)                           (0x00000003&(data))

#define  ATSC_ADDR_21B4                                                         0x181546D0
#define  ATSC_ADDR_21B4_reg_addr                                                 "0xB81546D0"
#define  ATSC_ADDR_21B4_reg                                                      0xB81546D0
#define  ATSC_ADDR_21B4_inst_addr                                                "0x00EA"
#define  set_ATSC_ADDR_21B4_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21B4_reg)=data)
#define  get_ATSC_ADDR_21B4_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21B4_reg))
#define  ATSC_ADDR_21B4_reg_fsm_cond14_shift                                     (7)
#define  ATSC_ADDR_21B4_fsm_cond14_config_shift                                  (6)
#define  ATSC_ADDR_21B4_reg_fsm_cond6_shift                                      (5)
#define  ATSC_ADDR_21B4_fsm_cond6_config_shift                                   (4)
#define  ATSC_ADDR_21B4_reg_fsm_cond11_shift                                     (3)
#define  ATSC_ADDR_21B4_fsm_cond11_config_shift                                  (2)
#define  ATSC_ADDR_21B4_reg_fsm_cond10_shift                                     (1)
#define  ATSC_ADDR_21B4_fsm_cond10_config_shift                                  (0)
#define  ATSC_ADDR_21B4_reg_fsm_cond14_mask                                      (0x00000080)
#define  ATSC_ADDR_21B4_fsm_cond14_config_mask                                   (0x00000040)
#define  ATSC_ADDR_21B4_reg_fsm_cond6_mask                                       (0x00000020)
#define  ATSC_ADDR_21B4_fsm_cond6_config_mask                                    (0x00000010)
#define  ATSC_ADDR_21B4_reg_fsm_cond11_mask                                      (0x00000008)
#define  ATSC_ADDR_21B4_fsm_cond11_config_mask                                   (0x00000004)
#define  ATSC_ADDR_21B4_reg_fsm_cond10_mask                                      (0x00000002)
#define  ATSC_ADDR_21B4_fsm_cond10_config_mask                                   (0x00000001)
#define  ATSC_ADDR_21B4_reg_fsm_cond14(data)                                     (0x00000080&((data)<<7))
#define  ATSC_ADDR_21B4_fsm_cond14_config(data)                                  (0x00000040&((data)<<6))
#define  ATSC_ADDR_21B4_reg_fsm_cond6(data)                                      (0x00000020&((data)<<5))
#define  ATSC_ADDR_21B4_fsm_cond6_config(data)                                   (0x00000010&((data)<<4))
#define  ATSC_ADDR_21B4_reg_fsm_cond11(data)                                     (0x00000008&((data)<<3))
#define  ATSC_ADDR_21B4_fsm_cond11_config(data)                                  (0x00000004&((data)<<2))
#define  ATSC_ADDR_21B4_reg_fsm_cond10(data)                                     (0x00000002&((data)<<1))
#define  ATSC_ADDR_21B4_fsm_cond10_config(data)                                  (0x00000001&(data))
#define  ATSC_ADDR_21B4_get_reg_fsm_cond14(data)                                 ((0x00000080&(data))>>7)
#define  ATSC_ADDR_21B4_get_fsm_cond14_config(data)                              ((0x00000040&(data))>>6)
#define  ATSC_ADDR_21B4_get_reg_fsm_cond6(data)                                  ((0x00000020&(data))>>5)
#define  ATSC_ADDR_21B4_get_fsm_cond6_config(data)                               ((0x00000010&(data))>>4)
#define  ATSC_ADDR_21B4_get_reg_fsm_cond11(data)                                 ((0x00000008&(data))>>3)
#define  ATSC_ADDR_21B4_get_fsm_cond11_config(data)                              ((0x00000004&(data))>>2)
#define  ATSC_ADDR_21B4_get_reg_fsm_cond10(data)                                 ((0x00000002&(data))>>1)
#define  ATSC_ADDR_21B4_get_fsm_cond10_config(data)                              (0x00000001&(data))

#define  ATSC_ADDR_21B5                                                         0x181546D4
#define  ATSC_ADDR_21B5_reg_addr                                                 "0xB81546D4"
#define  ATSC_ADDR_21B5_reg                                                      0xB81546D4
#define  ATSC_ADDR_21B5_inst_addr                                                "0x00EB"
#define  set_ATSC_ADDR_21B5_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21B5_reg)=data)
#define  get_ATSC_ADDR_21B5_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21B5_reg))
#define  ATSC_ADDR_21B5_fsm_cond16_seg_th_7_0_shift                              (0)
#define  ATSC_ADDR_21B5_fsm_cond16_seg_th_7_0_mask                               (0x000000FF)
#define  ATSC_ADDR_21B5_fsm_cond16_seg_th_7_0(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_21B5_get_fsm_cond16_seg_th_7_0(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_21B6                                                         0x181546D8
#define  ATSC_ADDR_21B6_reg_addr                                                 "0xB81546D8"
#define  ATSC_ADDR_21B6_reg                                                      0xB81546D8
#define  ATSC_ADDR_21B6_inst_addr                                                "0x00EC"
#define  set_ATSC_ADDR_21B6_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21B6_reg)=data)
#define  get_ATSC_ADDR_21B6_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21B6_reg))
#define  ATSC_ADDR_21B6_reg_fsm_cond25_n_shift                                   (7)
#define  ATSC_ADDR_21B6_reg_fsm_cond30_shift                                     (6)
#define  ATSC_ADDR_21B6_fsm_cond30_config_shift                                  (5)
#define  ATSC_ADDR_21B6_reg_fsm_cond20_shift                                     (4)
#define  ATSC_ADDR_21B6_fsm_cond20_config_shift                                  (3)
#define  ATSC_ADDR_21B6_reg_fsm_cond19_shift                                     (2)
#define  ATSC_ADDR_21B6_fsm_cond19_config_shift                                  (1)
#define  ATSC_ADDR_21B6_fsm_cond16_seg_th_8_shift                                (0)
#define  ATSC_ADDR_21B6_reg_fsm_cond25_n_mask                                    (0x00000080)
#define  ATSC_ADDR_21B6_reg_fsm_cond30_mask                                      (0x00000040)
#define  ATSC_ADDR_21B6_fsm_cond30_config_mask                                   (0x00000020)
#define  ATSC_ADDR_21B6_reg_fsm_cond20_mask                                      (0x00000010)
#define  ATSC_ADDR_21B6_fsm_cond20_config_mask                                   (0x00000008)
#define  ATSC_ADDR_21B6_reg_fsm_cond19_mask                                      (0x00000004)
#define  ATSC_ADDR_21B6_fsm_cond19_config_mask                                   (0x00000002)
#define  ATSC_ADDR_21B6_fsm_cond16_seg_th_8_mask                                 (0x00000001)
#define  ATSC_ADDR_21B6_reg_fsm_cond25_n(data)                                   (0x00000080&((data)<<7))
#define  ATSC_ADDR_21B6_reg_fsm_cond30(data)                                     (0x00000040&((data)<<6))
#define  ATSC_ADDR_21B6_fsm_cond30_config(data)                                  (0x00000020&((data)<<5))
#define  ATSC_ADDR_21B6_reg_fsm_cond20(data)                                     (0x00000010&((data)<<4))
#define  ATSC_ADDR_21B6_fsm_cond20_config(data)                                  (0x00000008&((data)<<3))
#define  ATSC_ADDR_21B6_reg_fsm_cond19(data)                                     (0x00000004&((data)<<2))
#define  ATSC_ADDR_21B6_fsm_cond19_config(data)                                  (0x00000002&((data)<<1))
#define  ATSC_ADDR_21B6_fsm_cond16_seg_th_8(data)                                (0x00000001&(data))
#define  ATSC_ADDR_21B6_get_reg_fsm_cond25_n(data)                               ((0x00000080&(data))>>7)
#define  ATSC_ADDR_21B6_get_reg_fsm_cond30(data)                                 ((0x00000040&(data))>>6)
#define  ATSC_ADDR_21B6_get_fsm_cond30_config(data)                              ((0x00000020&(data))>>5)
#define  ATSC_ADDR_21B6_get_reg_fsm_cond20(data)                                 ((0x00000010&(data))>>4)
#define  ATSC_ADDR_21B6_get_fsm_cond20_config(data)                              ((0x00000008&(data))>>3)
#define  ATSC_ADDR_21B6_get_reg_fsm_cond19(data)                                 ((0x00000004&(data))>>2)
#define  ATSC_ADDR_21B6_get_fsm_cond19_config(data)                              ((0x00000002&(data))>>1)
#define  ATSC_ADDR_21B6_get_fsm_cond16_seg_th_8(data)                            (0x00000001&(data))

#define  ATSC_ADDR_21B7                                                         0x181546DC
#define  ATSC_ADDR_21B7_reg_addr                                                 "0xB81546DC"
#define  ATSC_ADDR_21B7_reg                                                      0xB81546DC
#define  ATSC_ADDR_21B7_inst_addr                                                "0x00ED"
#define  set_ATSC_ADDR_21B7_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21B7_reg)=data)
#define  get_ATSC_ADDR_21B7_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21B7_reg))
#define  ATSC_ADDR_21B7_fsm_cond17_sym_th_7_0_shift                              (0)
#define  ATSC_ADDR_21B7_fsm_cond17_sym_th_7_0_mask                               (0x000000FF)
#define  ATSC_ADDR_21B7_fsm_cond17_sym_th_7_0(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_21B7_get_fsm_cond17_sym_th_7_0(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_21B8                                                         0x181546E0
#define  ATSC_ADDR_21B8_reg_addr                                                 "0xB81546E0"
#define  ATSC_ADDR_21B8_reg                                                      0xB81546E0
#define  ATSC_ADDR_21B8_inst_addr                                                "0x00EE"
#define  set_ATSC_ADDR_21B8_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21B8_reg)=data)
#define  get_ATSC_ADDR_21B8_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21B8_reg))
#define  ATSC_ADDR_21B8_fsm_cond26_config2_shift                                 (7)
#define  ATSC_ADDR_21B8_fsm_cond14_config2_shift                                 (6)
#define  ATSC_ADDR_21B8_fsm_cond31_config_shift                                  (5)
#define  ATSC_ADDR_21B8_fsm_cond26_config_shift                                  (4)
#define  ATSC_ADDR_21B8_fsm_cond25_config_shift                                  (3)
#define  ATSC_ADDR_21B8_fsm_cond15_config_shift                                  (2)
#define  ATSC_ADDR_21B8_fsm_cond17_sym_th_9_8_shift                              (0)
#define  ATSC_ADDR_21B8_fsm_cond26_config2_mask                                  (0x00000080)
#define  ATSC_ADDR_21B8_fsm_cond14_config2_mask                                  (0x00000040)
#define  ATSC_ADDR_21B8_fsm_cond31_config_mask                                   (0x00000020)
#define  ATSC_ADDR_21B8_fsm_cond26_config_mask                                   (0x00000010)
#define  ATSC_ADDR_21B8_fsm_cond25_config_mask                                   (0x00000008)
#define  ATSC_ADDR_21B8_fsm_cond15_config_mask                                   (0x00000004)
#define  ATSC_ADDR_21B8_fsm_cond17_sym_th_9_8_mask                               (0x00000003)
#define  ATSC_ADDR_21B8_fsm_cond26_config2(data)                                 (0x00000080&((data)<<7))
#define  ATSC_ADDR_21B8_fsm_cond14_config2(data)                                 (0x00000040&((data)<<6))
#define  ATSC_ADDR_21B8_fsm_cond31_config(data)                                  (0x00000020&((data)<<5))
#define  ATSC_ADDR_21B8_fsm_cond26_config(data)                                  (0x00000010&((data)<<4))
#define  ATSC_ADDR_21B8_fsm_cond25_config(data)                                  (0x00000008&((data)<<3))
#define  ATSC_ADDR_21B8_fsm_cond15_config(data)                                  (0x00000004&((data)<<2))
#define  ATSC_ADDR_21B8_fsm_cond17_sym_th_9_8(data)                              (0x00000003&(data))
#define  ATSC_ADDR_21B8_get_fsm_cond26_config2(data)                             ((0x00000080&(data))>>7)
#define  ATSC_ADDR_21B8_get_fsm_cond14_config2(data)                             ((0x00000040&(data))>>6)
#define  ATSC_ADDR_21B8_get_fsm_cond31_config(data)                              ((0x00000020&(data))>>5)
#define  ATSC_ADDR_21B8_get_fsm_cond26_config(data)                              ((0x00000010&(data))>>4)
#define  ATSC_ADDR_21B8_get_fsm_cond25_config(data)                              ((0x00000008&(data))>>3)
#define  ATSC_ADDR_21B8_get_fsm_cond15_config(data)                              ((0x00000004&(data))>>2)
#define  ATSC_ADDR_21B8_get_fsm_cond17_sym_th_9_8(data)                          (0x00000003&(data))

#define  ATSC_ADDR_21B9                                                         0x181546E4
#define  ATSC_ADDR_21B9_reg_addr                                                 "0xB81546E4"
#define  ATSC_ADDR_21B9_reg                                                      0xB81546E4
#define  ATSC_ADDR_21B9_inst_addr                                                "0x00EF"
#define  set_ATSC_ADDR_21B9_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21B9_reg)=data)
#define  get_ATSC_ADDR_21B9_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21B9_reg))
#define  ATSC_ADDR_21B9_fsm_cond29_config_shift                                  (3)
#define  ATSC_ADDR_21B9_fsm_cond28_config_shift                                  (0)
#define  ATSC_ADDR_21B9_fsm_cond29_config_mask                                   (0x00000018)
#define  ATSC_ADDR_21B9_fsm_cond28_config_mask                                   (0x00000007)
#define  ATSC_ADDR_21B9_fsm_cond29_config(data)                                  (0x00000018&((data)<<3))
#define  ATSC_ADDR_21B9_fsm_cond28_config(data)                                  (0x00000007&(data))
#define  ATSC_ADDR_21B9_get_fsm_cond29_config(data)                              ((0x00000018&(data))>>3)
#define  ATSC_ADDR_21B9_get_fsm_cond28_config(data)                              (0x00000007&(data))

#define  ATSC_ADDR_21BA                                                         0x181546E8
#define  ATSC_ADDR_21BA_reg_addr                                                 "0xB81546E8"
#define  ATSC_ADDR_21BA_reg                                                      0xB81546E8
#define  ATSC_ADDR_21BA_inst_addr                                                "0x00F0"
#define  set_ATSC_ADDR_21BA_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21BA_reg)=data)
#define  get_ATSC_ADDR_21BA_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21BA_reg))
#define  ATSC_ADDR_21BA_fsm_cond29_seg_th_7_0_shift                              (0)
#define  ATSC_ADDR_21BA_fsm_cond29_seg_th_7_0_mask                               (0x000000FF)
#define  ATSC_ADDR_21BA_fsm_cond29_seg_th_7_0(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_21BA_get_fsm_cond29_seg_th_7_0(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_21BB                                                         0x181546EC
#define  ATSC_ADDR_21BB_reg_addr                                                 "0xB81546EC"
#define  ATSC_ADDR_21BB_reg                                                      0xB81546EC
#define  ATSC_ADDR_21BB_inst_addr                                                "0x00F1"
#define  set_ATSC_ADDR_21BB_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21BB_reg)=data)
#define  get_ATSC_ADDR_21BB_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21BB_reg))
#define  ATSC_ADDR_21BB_fsm_cond29_seg_th_8_shift                                (0)
#define  ATSC_ADDR_21BB_fsm_cond29_seg_th_8_mask                                 (0x00000001)
#define  ATSC_ADDR_21BB_fsm_cond29_seg_th_8(data)                                (0x00000001&(data))
#define  ATSC_ADDR_21BB_get_fsm_cond29_seg_th_8(data)                            (0x00000001&(data))

#define  ATSC_ADDR_21BC                                                         0x181546F0
#define  ATSC_ADDR_21BC_reg_addr                                                 "0xB81546F0"
#define  ATSC_ADDR_21BC_reg                                                      0xB81546F0
#define  ATSC_ADDR_21BC_inst_addr                                                "0x00F2"
#define  set_ATSC_ADDR_21BC_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21BC_reg)=data)
#define  get_ATSC_ADDR_21BC_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21BC_reg))
#define  ATSC_ADDR_21BC_fsm_cond29_sym_th_7_0_shift                              (0)
#define  ATSC_ADDR_21BC_fsm_cond29_sym_th_7_0_mask                               (0x000000FF)
#define  ATSC_ADDR_21BC_fsm_cond29_sym_th_7_0(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_21BC_get_fsm_cond29_sym_th_7_0(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_21BD                                                         0x181546F4
#define  ATSC_ADDR_21BD_reg_addr                                                 "0xB81546F4"
#define  ATSC_ADDR_21BD_reg                                                      0xB81546F4
#define  ATSC_ADDR_21BD_inst_addr                                                "0x00F3"
#define  set_ATSC_ADDR_21BD_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21BD_reg)=data)
#define  get_ATSC_ADDR_21BD_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21BD_reg))
#define  ATSC_ADDR_21BD_fsm_cond29_sym_th_9_8_shift                              (0)
#define  ATSC_ADDR_21BD_fsm_cond29_sym_th_9_8_mask                               (0x00000003)
#define  ATSC_ADDR_21BD_fsm_cond29_sym_th_9_8(data)                              (0x00000003&(data))
#define  ATSC_ADDR_21BD_get_fsm_cond29_sym_th_9_8(data)                          (0x00000003&(data))

#define  ATSC_ADDR_21BE                                                         0x181546F8
#define  ATSC_ADDR_21BE_reg_addr                                                 "0xB81546F8"
#define  ATSC_ADDR_21BE_reg                                                      0xB81546F8
#define  ATSC_ADDR_21BE_inst_addr                                                "0x00F4"
#define  set_ATSC_ADDR_21BE_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21BE_reg)=data)
#define  get_ATSC_ADDR_21BE_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21BE_reg))
#define  ATSC_ADDR_21BE_fsm_seg_cnt_r1_7_0_shift                                 (0)
#define  ATSC_ADDR_21BE_fsm_seg_cnt_r1_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_21BE_fsm_seg_cnt_r1_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_21BE_get_fsm_seg_cnt_r1_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_21BF                                                         0x181546FC
#define  ATSC_ADDR_21BF_reg_addr                                                 "0xB81546FC"
#define  ATSC_ADDR_21BF_reg                                                      0xB81546FC
#define  ATSC_ADDR_21BF_inst_addr                                                "0x00F5"
#define  set_ATSC_ADDR_21BF_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21BF_reg)=data)
#define  get_ATSC_ADDR_21BF_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21BF_reg))
#define  ATSC_ADDR_21BF_fsm_seg_cnt_r1_8_shift                                   (0)
#define  ATSC_ADDR_21BF_fsm_seg_cnt_r1_8_mask                                    (0x00000001)
#define  ATSC_ADDR_21BF_fsm_seg_cnt_r1_8(data)                                   (0x00000001&(data))
#define  ATSC_ADDR_21BF_get_fsm_seg_cnt_r1_8(data)                               (0x00000001&(data))

#define  ATSC_ADDR_21C0                                                         0x18154700
#define  ATSC_ADDR_21C0_reg_addr                                                 "0xB8154700"
#define  ATSC_ADDR_21C0_reg                                                      0xB8154700
#define  ATSC_ADDR_21C0_inst_addr                                                "0x00F6"
#define  set_ATSC_ADDR_21C0_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21C0_reg)=data)
#define  get_ATSC_ADDR_21C0_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21C0_reg))
#define  ATSC_ADDR_21C0_fsm_sym_cnt_r1_7_0_shift                                 (0)
#define  ATSC_ADDR_21C0_fsm_sym_cnt_r1_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_21C0_fsm_sym_cnt_r1_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_21C0_get_fsm_sym_cnt_r1_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_21C1                                                         0x18154704
#define  ATSC_ADDR_21C1_reg_addr                                                 "0xB8154704"
#define  ATSC_ADDR_21C1_reg                                                      0xB8154704
#define  ATSC_ADDR_21C1_inst_addr                                                "0x00F7"
#define  set_ATSC_ADDR_21C1_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21C1_reg)=data)
#define  get_ATSC_ADDR_21C1_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21C1_reg))
#define  ATSC_ADDR_21C1_fsm_sym_cnt_r1_9_8_shift                                 (0)
#define  ATSC_ADDR_21C1_fsm_sym_cnt_r1_9_8_mask                                  (0x00000003)
#define  ATSC_ADDR_21C1_fsm_sym_cnt_r1_9_8(data)                                 (0x00000003&(data))
#define  ATSC_ADDR_21C1_get_fsm_sym_cnt_r1_9_8(data)                             (0x00000003&(data))

#define  ATSC_ADDR_21C2                                                         0x18154708
#define  ATSC_ADDR_21C2_reg_addr                                                 "0xB8154708"
#define  ATSC_ADDR_21C2_reg                                                      0xB8154708
#define  ATSC_ADDR_21C2_inst_addr                                                "0x00F8"
#define  set_ATSC_ADDR_21C2_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21C2_reg)=data)
#define  get_ATSC_ADDR_21C2_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21C2_reg))
#define  ATSC_ADDR_21C2_agc_tune_clear_state_shift                               (0)
#define  ATSC_ADDR_21C2_agc_tune_clear_state_mask                                (0x0000003F)
#define  ATSC_ADDR_21C2_agc_tune_clear_state(data)                               (0x0000003F&(data))
#define  ATSC_ADDR_21C2_get_agc_tune_clear_state(data)                           (0x0000003F&(data))

#define  ATSC_ADDR_21C3                                                         0x1815470C
#define  ATSC_ADDR_21C3_reg_addr                                                 "0xB815470C"
#define  ATSC_ADDR_21C3_reg                                                      0xB815470C
#define  ATSC_ADDR_21C3_inst_addr                                                "0x00F9"
#define  set_ATSC_ADDR_21C3_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21C3_reg)=data)
#define  get_ATSC_ADDR_21C3_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21C3_reg))
#define  ATSC_ADDR_21C3_bn_agc_start_state_shift                                 (0)
#define  ATSC_ADDR_21C3_bn_agc_start_state_mask                                  (0x0000003F)
#define  ATSC_ADDR_21C3_bn_agc_start_state(data)                                 (0x0000003F&(data))
#define  ATSC_ADDR_21C3_get_bn_agc_start_state(data)                             (0x0000003F&(data))

#define  ATSC_ADDR_21C4                                                         0x18154710
#define  ATSC_ADDR_21C4_reg_addr                                                 "0xB8154710"
#define  ATSC_ADDR_21C4_reg                                                      0xB8154710
#define  ATSC_ADDR_21C4_inst_addr                                                "0x00FA"
#define  set_ATSC_ADDR_21C4_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21C4_reg)=data)
#define  get_ATSC_ADDR_21C4_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21C4_reg))
#define  ATSC_ADDR_21C4_bn_agc_end_state_shift                                   (0)
#define  ATSC_ADDR_21C4_bn_agc_end_state_mask                                    (0x0000003F)
#define  ATSC_ADDR_21C4_bn_agc_end_state(data)                                   (0x0000003F&(data))
#define  ATSC_ADDR_21C4_get_bn_agc_end_state(data)                               (0x0000003F&(data))

#define  ATSC_ADDR_21C5                                                         0x18154714
#define  ATSC_ADDR_21C5_reg_addr                                                 "0xB8154714"
#define  ATSC_ADDR_21C5_reg                                                      0xB8154714
#define  ATSC_ADDR_21C5_inst_addr                                                "0x00FB"
#define  set_ATSC_ADDR_21C5_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21C5_reg)=data)
#define  get_ATSC_ADDR_21C5_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21C5_reg))
#define  ATSC_ADDR_21C5_pn_comp_start_state_shift                                (0)
#define  ATSC_ADDR_21C5_pn_comp_start_state_mask                                 (0x0000003F)
#define  ATSC_ADDR_21C5_pn_comp_start_state(data)                                (0x0000003F&(data))
#define  ATSC_ADDR_21C5_get_pn_comp_start_state(data)                            (0x0000003F&(data))

#define  ATSC_ADDR_21C6                                                         0x18154718
#define  ATSC_ADDR_21C6_reg_addr                                                 "0xB8154718"
#define  ATSC_ADDR_21C6_reg                                                      0xB8154718
#define  ATSC_ADDR_21C6_inst_addr                                                "0x00FC"
#define  set_ATSC_ADDR_21C6_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21C6_reg)=data)
#define  get_ATSC_ADDR_21C6_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21C6_reg))
#define  ATSC_ADDR_21C6_pn_comp_end_state_shift                                  (0)
#define  ATSC_ADDR_21C6_pn_comp_end_state_mask                                   (0x0000003F)
#define  ATSC_ADDR_21C6_pn_comp_end_state(data)                                  (0x0000003F&(data))
#define  ATSC_ADDR_21C6_get_pn_comp_end_state(data)                              (0x0000003F&(data))

#define  ATSC_ADDR_21C7                                                         0x1815471C
#define  ATSC_ADDR_21C7_reg_addr                                                 "0xB815471C"
#define  ATSC_ADDR_21C7_reg                                                      0xB815471C
#define  ATSC_ADDR_21C7_inst_addr                                                "0x00FD"
#define  set_ATSC_ADDR_21C7_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21C7_reg)=data)
#define  get_ATSC_ADDR_21C7_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21C7_reg))
#define  ATSC_ADDR_21C7_pn_cr_state_cnt2_end_opt_shift                           (2)
#define  ATSC_ADDR_21C7_pn_pt_state_cnt2_end_opt_shift                           (1)
#define  ATSC_ADDR_21C7_pn_state_cnt2_end_opt_shift                              (0)
#define  ATSC_ADDR_21C7_pn_cr_state_cnt2_end_opt_mask                            (0x00000004)
#define  ATSC_ADDR_21C7_pn_pt_state_cnt2_end_opt_mask                            (0x00000002)
#define  ATSC_ADDR_21C7_pn_state_cnt2_end_opt_mask                               (0x00000001)
#define  ATSC_ADDR_21C7_pn_cr_state_cnt2_end_opt(data)                           (0x00000004&((data)<<2))
#define  ATSC_ADDR_21C7_pn_pt_state_cnt2_end_opt(data)                           (0x00000002&((data)<<1))
#define  ATSC_ADDR_21C7_pn_state_cnt2_end_opt(data)                              (0x00000001&(data))
#define  ATSC_ADDR_21C7_get_pn_cr_state_cnt2_end_opt(data)                       ((0x00000004&(data))>>2)
#define  ATSC_ADDR_21C7_get_pn_pt_state_cnt2_end_opt(data)                       ((0x00000002&(data))>>1)
#define  ATSC_ADDR_21C7_get_pn_state_cnt2_end_opt(data)                          (0x00000001&(data))

#define  ATSC_ADDR_21C8                                                         0x18154720
#define  ATSC_ADDR_21C8_reg_addr                                                 "0xB8154720"
#define  ATSC_ADDR_21C8_reg                                                      0xB8154720
#define  ATSC_ADDR_21C8_inst_addr                                                "0x00FE"
#define  set_ATSC_ADDR_21C8_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21C8_reg)=data)
#define  get_ATSC_ADDR_21C8_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21C8_reg))
#define  ATSC_ADDR_21C8_adj_srrc_upd_state_shift                                 (0)
#define  ATSC_ADDR_21C8_adj_srrc_upd_state_mask                                  (0x0000003F)
#define  ATSC_ADDR_21C8_adj_srrc_upd_state(data)                                 (0x0000003F&(data))
#define  ATSC_ADDR_21C8_get_adj_srrc_upd_state(data)                             (0x0000003F&(data))

#define  ATSC_ADDR_21C9                                                         0x18154724
#define  ATSC_ADDR_21C9_reg_addr                                                 "0xB8154724"
#define  ATSC_ADDR_21C9_reg                                                      0xB8154724
#define  ATSC_ADDR_21C9_inst_addr                                                "0x00FF"
#define  set_ATSC_ADDR_21C9_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21C9_reg)=data)
#define  get_ATSC_ADDR_21C9_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21C9_reg))
#define  ATSC_ADDR_21C9_adj_srrc_clear_state_shift                               (0)
#define  ATSC_ADDR_21C9_adj_srrc_clear_state_mask                                (0x0000003F)
#define  ATSC_ADDR_21C9_adj_srrc_clear_state(data)                               (0x0000003F&(data))
#define  ATSC_ADDR_21C9_get_adj_srrc_clear_state(data)                           (0x0000003F&(data))

#define  ATSC_ADDR_21CA                                                         0x18154728
#define  ATSC_ADDR_21CA_reg_addr                                                 "0xB8154728"
#define  ATSC_ADDR_21CA_reg                                                      0xB8154728
#define  ATSC_ADDR_21CA_inst_addr                                                "0x0100"
#define  set_ATSC_ADDR_21CA_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21CA_reg)=data)
#define  get_ATSC_ADDR_21CA_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21CA_reg))
#define  ATSC_ADDR_21CA_state_cnt3_inc_state_shift                               (0)
#define  ATSC_ADDR_21CA_state_cnt3_inc_state_mask                                (0x0000003F)
#define  ATSC_ADDR_21CA_state_cnt3_inc_state(data)                               (0x0000003F&(data))
#define  ATSC_ADDR_21CA_get_state_cnt3_inc_state(data)                           (0x0000003F&(data))

#define  ATSC_ADDR_21CB                                                         0x1815472C
#define  ATSC_ADDR_21CB_reg_addr                                                 "0xB815472C"
#define  ATSC_ADDR_21CB_reg                                                      0xB815472C
#define  ATSC_ADDR_21CB_inst_addr                                                "0x0101"
#define  set_ATSC_ADDR_21CB_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21CB_reg)=data)
#define  get_ATSC_ADDR_21CB_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21CB_reg))
#define  ATSC_ADDR_21CB_state_cnt3_reset_state_shift                             (0)
#define  ATSC_ADDR_21CB_state_cnt3_reset_state_mask                              (0x0000003F)
#define  ATSC_ADDR_21CB_state_cnt3_reset_state(data)                             (0x0000003F&(data))
#define  ATSC_ADDR_21CB_get_state_cnt3_reset_state(data)                         (0x0000003F&(data))

#define  ATSC_ADDR_21CC                                                         0x18154730
#define  ATSC_ADDR_21CC_reg_addr                                                 "0xB8154730"
#define  ATSC_ADDR_21CC_reg                                                      0xB8154730
#define  ATSC_ADDR_21CC_inst_addr                                                "0x0102"
#define  set_ATSC_ADDR_21CC_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21CC_reg)=data)
#define  get_ATSC_ADDR_21CC_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21CC_reg))
#define  ATSC_ADDR_21CC_state_cnt3_th_shift                                      (0)
#define  ATSC_ADDR_21CC_state_cnt3_th_mask                                       (0x000000FF)
#define  ATSC_ADDR_21CC_state_cnt3_th(data)                                      (0x000000FF&(data))
#define  ATSC_ADDR_21CC_get_state_cnt3_th(data)                                  (0x000000FF&(data))

#define  ATSC_ADDR_21CD                                                         0x18154734
#define  ATSC_ADDR_21CD_reg_addr                                                 "0xB8154734"
#define  ATSC_ADDR_21CD_reg                                                      0xB8154734
#define  ATSC_ADDR_21CD_inst_addr                                                "0x0103"
#define  set_ATSC_ADDR_21CD_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21CD_reg)=data)
#define  get_ATSC_ADDR_21CD_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21CD_reg))
#define  ATSC_ADDR_21CD_state_cnt4_inc_state_shift                               (0)
#define  ATSC_ADDR_21CD_state_cnt4_inc_state_mask                                (0x0000003F)
#define  ATSC_ADDR_21CD_state_cnt4_inc_state(data)                               (0x0000003F&(data))
#define  ATSC_ADDR_21CD_get_state_cnt4_inc_state(data)                           (0x0000003F&(data))

#define  ATSC_ADDR_21CE                                                         0x18154738
#define  ATSC_ADDR_21CE_reg_addr                                                 "0xB8154738"
#define  ATSC_ADDR_21CE_reg                                                      0xB8154738
#define  ATSC_ADDR_21CE_inst_addr                                                "0x0104"
#define  set_ATSC_ADDR_21CE_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21CE_reg)=data)
#define  get_ATSC_ADDR_21CE_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21CE_reg))
#define  ATSC_ADDR_21CE_state_cnt4_reset_state_shift                             (0)
#define  ATSC_ADDR_21CE_state_cnt4_reset_state_mask                              (0x0000003F)
#define  ATSC_ADDR_21CE_state_cnt4_reset_state(data)                             (0x0000003F&(data))
#define  ATSC_ADDR_21CE_get_state_cnt4_reset_state(data)                         (0x0000003F&(data))

#define  ATSC_ADDR_21CF                                                         0x1815473C
#define  ATSC_ADDR_21CF_reg_addr                                                 "0xB815473C"
#define  ATSC_ADDR_21CF_reg                                                      0xB815473C
#define  ATSC_ADDR_21CF_inst_addr                                                "0x0105"
#define  set_ATSC_ADDR_21CF_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21CF_reg)=data)
#define  get_ATSC_ADDR_21CF_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21CF_reg))
#define  ATSC_ADDR_21CF_state_cnt4_th_shift                                      (0)
#define  ATSC_ADDR_21CF_state_cnt4_th_mask                                       (0x000000FF)
#define  ATSC_ADDR_21CF_state_cnt4_th(data)                                      (0x000000FF&(data))
#define  ATSC_ADDR_21CF_get_state_cnt4_th(data)                                  (0x000000FF&(data))

#define  ATSC_ADDR_21D0                                                         0x18154740
#define  ATSC_ADDR_21D0_reg_addr                                                 "0xB8154740"
#define  ATSC_ADDR_21D0_reg                                                      0xB8154740
#define  ATSC_ADDR_21D0_inst_addr                                                "0x0106"
#define  set_ATSC_ADDR_21D0_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21D0_reg)=data)
#define  get_ATSC_ADDR_21D0_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21D0_reg))
#define  ATSC_ADDR_21D0_state_cnt5_inc_state_shift                               (0)
#define  ATSC_ADDR_21D0_state_cnt5_inc_state_mask                                (0x0000003F)
#define  ATSC_ADDR_21D0_state_cnt5_inc_state(data)                               (0x0000003F&(data))
#define  ATSC_ADDR_21D0_get_state_cnt5_inc_state(data)                           (0x0000003F&(data))

#define  ATSC_ADDR_21D1                                                         0x18154744
#define  ATSC_ADDR_21D1_reg_addr                                                 "0xB8154744"
#define  ATSC_ADDR_21D1_reg                                                      0xB8154744
#define  ATSC_ADDR_21D1_inst_addr                                                "0x0107"
#define  set_ATSC_ADDR_21D1_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21D1_reg)=data)
#define  get_ATSC_ADDR_21D1_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21D1_reg))
#define  ATSC_ADDR_21D1_state_cnt5_reset_state_shift                             (0)
#define  ATSC_ADDR_21D1_state_cnt5_reset_state_mask                              (0x0000003F)
#define  ATSC_ADDR_21D1_state_cnt5_reset_state(data)                             (0x0000003F&(data))
#define  ATSC_ADDR_21D1_get_state_cnt5_reset_state(data)                         (0x0000003F&(data))

#define  ATSC_ADDR_21D2                                                         0x18154748
#define  ATSC_ADDR_21D2_reg_addr                                                 "0xB8154748"
#define  ATSC_ADDR_21D2_reg                                                      0xB8154748
#define  ATSC_ADDR_21D2_inst_addr                                                "0x0108"
#define  set_ATSC_ADDR_21D2_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21D2_reg)=data)
#define  get_ATSC_ADDR_21D2_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21D2_reg))
#define  ATSC_ADDR_21D2_state_cnt5_th_shift                                      (0)
#define  ATSC_ADDR_21D2_state_cnt5_th_mask                                       (0x000000FF)
#define  ATSC_ADDR_21D2_state_cnt5_th(data)                                      (0x000000FF&(data))
#define  ATSC_ADDR_21D2_get_state_cnt5_th(data)                                  (0x000000FF&(data))

#define  ATSC_ADDR_21D3                                                         0x1815474C
#define  ATSC_ADDR_21D3_reg_addr                                                 "0xB815474C"
#define  ATSC_ADDR_21D3_reg                                                      0xB815474C
#define  ATSC_ADDR_21D3_inst_addr                                                "0x0109"
#define  set_ATSC_ADDR_21D3_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21D3_reg)=data)
#define  get_ATSC_ADDR_21D3_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21D3_reg))
#define  ATSC_ADDR_21D3_fsm_mse_th_1_7_0_shift                                   (0)
#define  ATSC_ADDR_21D3_fsm_mse_th_1_7_0_mask                                    (0x000000FF)
#define  ATSC_ADDR_21D3_fsm_mse_th_1_7_0(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_21D3_get_fsm_mse_th_1_7_0(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_21D4                                                         0x18154750
#define  ATSC_ADDR_21D4_reg_addr                                                 "0xB8154750"
#define  ATSC_ADDR_21D4_reg                                                      0xB8154750
#define  ATSC_ADDR_21D4_inst_addr                                                "0x010A"
#define  set_ATSC_ADDR_21D4_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21D4_reg)=data)
#define  get_ATSC_ADDR_21D4_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21D4_reg))
#define  ATSC_ADDR_21D4_fsm_mse_inv_1_shift                                      (7)
#define  ATSC_ADDR_21D4_fsm_mse_sel_1_shift                                      (6)
#define  ATSC_ADDR_21D4_fsm_mse_th_1_13_8_shift                                  (0)
#define  ATSC_ADDR_21D4_fsm_mse_inv_1_mask                                       (0x00000080)
#define  ATSC_ADDR_21D4_fsm_mse_sel_1_mask                                       (0x00000040)
#define  ATSC_ADDR_21D4_fsm_mse_th_1_13_8_mask                                   (0x0000003F)
#define  ATSC_ADDR_21D4_fsm_mse_inv_1(data)                                      (0x00000080&((data)<<7))
#define  ATSC_ADDR_21D4_fsm_mse_sel_1(data)                                      (0x00000040&((data)<<6))
#define  ATSC_ADDR_21D4_fsm_mse_th_1_13_8(data)                                  (0x0000003F&(data))
#define  ATSC_ADDR_21D4_get_fsm_mse_inv_1(data)                                  ((0x00000080&(data))>>7)
#define  ATSC_ADDR_21D4_get_fsm_mse_sel_1(data)                                  ((0x00000040&(data))>>6)
#define  ATSC_ADDR_21D4_get_fsm_mse_th_1_13_8(data)                              (0x0000003F&(data))

#define  ATSC_ADDR_21D5                                                         0x18154754
#define  ATSC_ADDR_21D5_reg_addr                                                 "0xB8154754"
#define  ATSC_ADDR_21D5_reg                                                      0xB8154754
#define  ATSC_ADDR_21D5_inst_addr                                                "0x010B"
#define  set_ATSC_ADDR_21D5_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21D5_reg)=data)
#define  get_ATSC_ADDR_21D5_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21D5_reg))
#define  ATSC_ADDR_21D5_fsm_mse_th_2_7_0_shift                                   (0)
#define  ATSC_ADDR_21D5_fsm_mse_th_2_7_0_mask                                    (0x000000FF)
#define  ATSC_ADDR_21D5_fsm_mse_th_2_7_0(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_21D5_get_fsm_mse_th_2_7_0(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_21D6                                                         0x18154758
#define  ATSC_ADDR_21D6_reg_addr                                                 "0xB8154758"
#define  ATSC_ADDR_21D6_reg                                                      0xB8154758
#define  ATSC_ADDR_21D6_inst_addr                                                "0x010C"
#define  set_ATSC_ADDR_21D6_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21D6_reg)=data)
#define  get_ATSC_ADDR_21D6_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21D6_reg))
#define  ATSC_ADDR_21D6_fsm_mse_inv_2_shift                                      (7)
#define  ATSC_ADDR_21D6_fsm_mse_sel_2_shift                                      (6)
#define  ATSC_ADDR_21D6_fsm_mse_th_2_13_8_shift                                  (0)
#define  ATSC_ADDR_21D6_fsm_mse_inv_2_mask                                       (0x00000080)
#define  ATSC_ADDR_21D6_fsm_mse_sel_2_mask                                       (0x00000040)
#define  ATSC_ADDR_21D6_fsm_mse_th_2_13_8_mask                                   (0x0000003F)
#define  ATSC_ADDR_21D6_fsm_mse_inv_2(data)                                      (0x00000080&((data)<<7))
#define  ATSC_ADDR_21D6_fsm_mse_sel_2(data)                                      (0x00000040&((data)<<6))
#define  ATSC_ADDR_21D6_fsm_mse_th_2_13_8(data)                                  (0x0000003F&(data))
#define  ATSC_ADDR_21D6_get_fsm_mse_inv_2(data)                                  ((0x00000080&(data))>>7)
#define  ATSC_ADDR_21D6_get_fsm_mse_sel_2(data)                                  ((0x00000040&(data))>>6)
#define  ATSC_ADDR_21D6_get_fsm_mse_th_2_13_8(data)                              (0x0000003F&(data))

#define  ATSC_ADDR_21D7                                                         0x1815475C
#define  ATSC_ADDR_21D7_reg_addr                                                 "0xB815475C"
#define  ATSC_ADDR_21D7_reg                                                      0xB815475C
#define  ATSC_ADDR_21D7_inst_addr                                                "0x010D"
#define  set_ATSC_ADDR_21D7_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21D7_reg)=data)
#define  get_ATSC_ADDR_21D7_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21D7_reg))
#define  ATSC_ADDR_21D7_fsm_scan_lock_state_shift                                (0)
#define  ATSC_ADDR_21D7_fsm_scan_lock_state_mask                                 (0x0000003F)
#define  ATSC_ADDR_21D7_fsm_scan_lock_state(data)                                (0x0000003F&(data))
#define  ATSC_ADDR_21D7_get_fsm_scan_lock_state(data)                            (0x0000003F&(data))

#define  ATSC_ADDR_21D8                                                         0x18154760
#define  ATSC_ADDR_21D8_reg_addr                                                 "0xB8154760"
#define  ATSC_ADDR_21D8_reg                                                      0xB8154760
#define  ATSC_ADDR_21D8_inst_addr                                                "0x010E"
#define  set_ATSC_ADDR_21D8_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21D8_reg)=data)
#define  get_ATSC_ADDR_21D8_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21D8_reg))
#define  ATSC_ADDR_21D8_fsm_scan_ind_clear_shift                                 (6)
#define  ATSC_ADDR_21D8_fsm_scan_unlock_state_shift                              (0)
#define  ATSC_ADDR_21D8_fsm_scan_ind_clear_mask                                  (0x00000040)
#define  ATSC_ADDR_21D8_fsm_scan_unlock_state_mask                               (0x0000003F)
#define  ATSC_ADDR_21D8_fsm_scan_ind_clear(data)                                 (0x00000040&((data)<<6))
#define  ATSC_ADDR_21D8_fsm_scan_unlock_state(data)                              (0x0000003F&(data))
#define  ATSC_ADDR_21D8_get_fsm_scan_ind_clear(data)                             ((0x00000040&(data))>>6)
#define  ATSC_ADDR_21D8_get_fsm_scan_unlock_state(data)                          (0x0000003F&(data))

#define  ATSC_ADDR_21D9                                                         0x18154764
#define  ATSC_ADDR_21D9_reg_addr                                                 "0xB8154764"
#define  ATSC_ADDR_21D9_reg                                                      0xB8154764
#define  ATSC_ADDR_21D9_inst_addr                                                "0x010F"
#define  set_ATSC_ADDR_21D9_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21D9_reg)=data)
#define  get_ATSC_ADDR_21D9_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21D9_reg))
#define  ATSC_ADDR_21D9_fsm_cond8_sym_th_7_0_shift                               (0)
#define  ATSC_ADDR_21D9_fsm_cond8_sym_th_7_0_mask                                (0x000000FF)
#define  ATSC_ADDR_21D9_fsm_cond8_sym_th_7_0(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_21D9_get_fsm_cond8_sym_th_7_0(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_21DA                                                         0x18154768
#define  ATSC_ADDR_21DA_reg_addr                                                 "0xB8154768"
#define  ATSC_ADDR_21DA_reg                                                      0xB8154768
#define  ATSC_ADDR_21DA_inst_addr                                                "0x0110"
#define  set_ATSC_ADDR_21DA_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21DA_reg)=data)
#define  get_ATSC_ADDR_21DA_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21DA_reg))
#define  ATSC_ADDR_21DA_fsm_cond8_sym_th_9_8_shift                               (0)
#define  ATSC_ADDR_21DA_fsm_cond8_sym_th_9_8_mask                                (0x00000003)
#define  ATSC_ADDR_21DA_fsm_cond8_sym_th_9_8(data)                               (0x00000003&(data))
#define  ATSC_ADDR_21DA_get_fsm_cond8_sym_th_9_8(data)                           (0x00000003&(data))

#define  ATSC_ADDR_21E0                                                         0x18154780
#define  ATSC_ADDR_21E0_reg_addr                                                 "0xB8154780"
#define  ATSC_ADDR_21E0_reg                                                      0xB8154780
#define  ATSC_ADDR_21E0_inst_addr                                                "0x0111"
#define  set_ATSC_ADDR_21E0_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21E0_reg)=data)
#define  get_ATSC_ADDR_21E0_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21E0_reg))
#define  ATSC_ADDR_21E0_reg_fsm_load_ini_shift                                   (5)
#define  ATSC_ADDR_21E0_reg_fsm_ram_col_shift                                    (0)
#define  ATSC_ADDR_21E0_reg_fsm_load_ini_mask                                    (0x00000020)
#define  ATSC_ADDR_21E0_reg_fsm_ram_col_mask                                     (0x0000001F)
#define  ATSC_ADDR_21E0_reg_fsm_load_ini(data)                                   (0x00000020&((data)<<5))
#define  ATSC_ADDR_21E0_reg_fsm_ram_col(data)                                    (0x0000001F&(data))
#define  ATSC_ADDR_21E0_get_reg_fsm_load_ini(data)                               ((0x00000020&(data))>>5)
#define  ATSC_ADDR_21E0_get_reg_fsm_ram_col(data)                                (0x0000001F&(data))

#define  ATSC_ADDR_21E1                                                         0x18154784
#define  ATSC_ADDR_21E1_reg_addr                                                 "0xB8154784"
#define  ATSC_ADDR_21E1_reg                                                      0xB8154784
#define  ATSC_ADDR_21E1_inst_addr                                                "0x0112"
#define  set_ATSC_ADDR_21E1_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21E1_reg)=data)
#define  get_ATSC_ADDR_21E1_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21E1_reg))
#define  ATSC_ADDR_21E1_reg_fsm_bw_stop_shift                                    (7)
#define  ATSC_ADDR_21E1_reg_fsm_ram_rd_shift                                     (6)
#define  ATSC_ADDR_21E1_reg_fsm_ram_row_shift                                    (0)
#define  ATSC_ADDR_21E1_reg_fsm_bw_stop_mask                                     (0x00000080)
#define  ATSC_ADDR_21E1_reg_fsm_ram_rd_mask                                      (0x00000040)
#define  ATSC_ADDR_21E1_reg_fsm_ram_row_mask                                     (0x0000003F)
#define  ATSC_ADDR_21E1_reg_fsm_bw_stop(data)                                    (0x00000080&((data)<<7))
#define  ATSC_ADDR_21E1_reg_fsm_ram_rd(data)                                     (0x00000040&((data)<<6))
#define  ATSC_ADDR_21E1_reg_fsm_ram_row(data)                                    (0x0000003F&(data))
#define  ATSC_ADDR_21E1_get_reg_fsm_bw_stop(data)                                ((0x00000080&(data))>>7)
#define  ATSC_ADDR_21E1_get_reg_fsm_ram_rd(data)                                 ((0x00000040&(data))>>6)
#define  ATSC_ADDR_21E1_get_reg_fsm_ram_row(data)                                (0x0000003F&(data))

#define  ATSC_ADDR_21E2                                                         0x18154788
#define  ATSC_ADDR_21E2_reg_addr                                                 "0xB8154788"
#define  ATSC_ADDR_21E2_reg                                                      0xB8154788
#define  ATSC_ADDR_21E2_inst_addr                                                "0x0113"
#define  set_ATSC_ADDR_21E2_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21E2_reg)=data)
#define  get_ATSC_ADDR_21E2_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21E2_reg))
#define  ATSC_ADDR_21E2_reg_fsm_ram_wr_shift                                     (7)
#define  ATSC_ADDR_21E2_reg_fsm_ram_data_shift                                   (0)
#define  ATSC_ADDR_21E2_reg_fsm_ram_wr_mask                                      (0x00000080)
#define  ATSC_ADDR_21E2_reg_fsm_ram_data_mask                                    (0x0000007F)
#define  ATSC_ADDR_21E2_reg_fsm_ram_wr(data)                                     (0x00000080&((data)<<7))
#define  ATSC_ADDR_21E2_reg_fsm_ram_data(data)                                   (0x0000007F&(data))
#define  ATSC_ADDR_21E2_get_reg_fsm_ram_wr(data)                                 ((0x00000080&(data))>>7)
#define  ATSC_ADDR_21E2_get_reg_fsm_ram_data(data)                               (0x0000007F&(data))

#define  ATSC_ADDR_21E3                                                         0x1815478C
#define  ATSC_ADDR_21E3_reg_addr                                                 "0xB815478C"
#define  ATSC_ADDR_21E3_reg                                                      0xB815478C
#define  ATSC_ADDR_21E3_inst_addr                                                "0x0114"
#define  set_ATSC_ADDR_21E3_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21E3_reg)=data)
#define  get_ATSC_ADDR_21E3_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21E3_reg))
#define  ATSC_ADDR_21E3_fsm_ram_crc_7_0_shift                                    (0)
#define  ATSC_ADDR_21E3_fsm_ram_crc_7_0_mask                                     (0x000000FF)
#define  ATSC_ADDR_21E3_fsm_ram_crc_7_0(data)                                    (0x000000FF&(data))
#define  ATSC_ADDR_21E3_get_fsm_ram_crc_7_0(data)                                (0x000000FF&(data))

#define  ATSC_ADDR_21E4                                                         0x18154790
#define  ATSC_ADDR_21E4_reg_addr                                                 "0xB8154790"
#define  ATSC_ADDR_21E4_reg                                                      0xB8154790
#define  ATSC_ADDR_21E4_inst_addr                                                "0x0115"
#define  set_ATSC_ADDR_21E4_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21E4_reg)=data)
#define  get_ATSC_ADDR_21E4_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21E4_reg))
#define  ATSC_ADDR_21E4_fsm_ram_crc_15_8_shift                                   (0)
#define  ATSC_ADDR_21E4_fsm_ram_crc_15_8_mask                                    (0x000000FF)
#define  ATSC_ADDR_21E4_fsm_ram_crc_15_8(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_21E4_get_fsm_ram_crc_15_8(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_21E5                                                         0x18154794
#define  ATSC_ADDR_21E5_reg_addr                                                 "0xB8154794"
#define  ATSC_ADDR_21E5_reg                                                      0xB8154794
#define  ATSC_ADDR_21E5_inst_addr                                                "0x0116"
#define  set_ATSC_ADDR_21E5_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21E5_reg)=data)
#define  get_ATSC_ADDR_21E5_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21E5_reg))
#define  ATSC_ADDR_21E5_fsm_ram_crc_done_shift                                   (5)
#define  ATSC_ADDR_21E5_fsm_ram_state_shift                                      (0)
#define  ATSC_ADDR_21E5_fsm_ram_crc_done_mask                                    (0x00000020)
#define  ATSC_ADDR_21E5_fsm_ram_state_mask                                       (0x0000001F)
#define  ATSC_ADDR_21E5_fsm_ram_crc_done(data)                                   (0x00000020&((data)<<5))
#define  ATSC_ADDR_21E5_fsm_ram_state(data)                                      (0x0000001F&(data))
#define  ATSC_ADDR_21E5_get_fsm_ram_crc_done(data)                               ((0x00000020&(data))>>5)
#define  ATSC_ADDR_21E5_get_fsm_ram_state(data)                                  (0x0000001F&(data))

#define  ATSC_ADDR_21E6                                                         0x18154798
#define  ATSC_ADDR_21E6_reg_addr                                                 "0xB8154798"
#define  ATSC_ADDR_21E6_reg                                                      0xB8154798
#define  ATSC_ADDR_21E6_inst_addr                                                "0x0117"
#define  set_ATSC_ADDR_21E6_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21E6_reg)=data)
#define  get_ATSC_ADDR_21E6_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21E6_reg))
#define  ATSC_ADDR_21E6_fsm_ram_data_ro_shift                                    (0)
#define  ATSC_ADDR_21E6_fsm_ram_data_ro_mask                                     (0x0000007F)
#define  ATSC_ADDR_21E6_fsm_ram_data_ro(data)                                    (0x0000007F&(data))
#define  ATSC_ADDR_21E6_get_fsm_ram_data_ro(data)                                (0x0000007F&(data))

#define  ATSC_ADDR_21E7                                                         0x1815479C
#define  ATSC_ADDR_21E7_reg_addr                                                 "0xB815479C"
#define  ATSC_ADDR_21E7_reg                                                      0xB815479C
#define  ATSC_ADDR_21E7_inst_addr                                                "0x0118"
#define  set_ATSC_ADDR_21E7_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21E7_reg)=data)
#define  get_ATSC_ADDR_21E7_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21E7_reg))
#define  ATSC_ADDR_21E7_fsm_segment_counter_ini0_7_0_shift                       (0)
#define  ATSC_ADDR_21E7_fsm_segment_counter_ini0_7_0_mask                        (0x000000FF)
#define  ATSC_ADDR_21E7_fsm_segment_counter_ini0_7_0(data)                       (0x000000FF&(data))
#define  ATSC_ADDR_21E7_get_fsm_segment_counter_ini0_7_0(data)                   (0x000000FF&(data))

#define  ATSC_ADDR_21E8                                                         0x181547A0
#define  ATSC_ADDR_21E8_reg_addr                                                 "0xB81547A0"
#define  ATSC_ADDR_21E8_reg                                                      0xB81547A0
#define  ATSC_ADDR_21E8_inst_addr                                                "0x0119"
#define  set_ATSC_ADDR_21E8_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21E8_reg)=data)
#define  get_ATSC_ADDR_21E8_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21E8_reg))
#define  ATSC_ADDR_21E8_fsm_segment_counter_ini1_6_0_shift                       (1)
#define  ATSC_ADDR_21E8_fsm_segment_counter_ini0_8_shift                         (0)
#define  ATSC_ADDR_21E8_fsm_segment_counter_ini1_6_0_mask                        (0x000000FE)
#define  ATSC_ADDR_21E8_fsm_segment_counter_ini0_8_mask                          (0x00000001)
#define  ATSC_ADDR_21E8_fsm_segment_counter_ini1_6_0(data)                       (0x000000FE&((data)<<1))
#define  ATSC_ADDR_21E8_fsm_segment_counter_ini0_8(data)                         (0x00000001&(data))
#define  ATSC_ADDR_21E8_get_fsm_segment_counter_ini1_6_0(data)                   ((0x000000FE&(data))>>1)
#define  ATSC_ADDR_21E8_get_fsm_segment_counter_ini0_8(data)                     (0x00000001&(data))

#define  ATSC_ADDR_21E9                                                         0x181547A4
#define  ATSC_ADDR_21E9_reg_addr                                                 "0xB81547A4"
#define  ATSC_ADDR_21E9_reg                                                      0xB81547A4
#define  ATSC_ADDR_21E9_inst_addr                                                "0x011A"
#define  set_ATSC_ADDR_21E9_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21E9_reg)=data)
#define  get_ATSC_ADDR_21E9_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21E9_reg))
#define  ATSC_ADDR_21E9_fsm_segment_counter_ini1_8_7_shift                       (0)
#define  ATSC_ADDR_21E9_fsm_segment_counter_ini1_8_7_mask                        (0x00000003)
#define  ATSC_ADDR_21E9_fsm_segment_counter_ini1_8_7(data)                       (0x00000003&(data))
#define  ATSC_ADDR_21E9_get_fsm_segment_counter_ini1_8_7(data)                   (0x00000003&(data))

#define  ATSC_ADDR_21EA                                                         0x181547A8
#define  ATSC_ADDR_21EA_reg_addr                                                 "0xB81547A8"
#define  ATSC_ADDR_21EA_reg                                                      0xB81547A8
#define  ATSC_ADDR_21EA_inst_addr                                                "0x011B"
#define  set_ATSC_ADDR_21EA_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21EA_reg)=data)
#define  get_ATSC_ADDR_21EA_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21EA_reg))
#define  ATSC_ADDR_21EA_fsm_symbol_counter_ini0_7_0_shift                        (0)
#define  ATSC_ADDR_21EA_fsm_symbol_counter_ini0_7_0_mask                         (0x000000FF)
#define  ATSC_ADDR_21EA_fsm_symbol_counter_ini0_7_0(data)                        (0x000000FF&(data))
#define  ATSC_ADDR_21EA_get_fsm_symbol_counter_ini0_7_0(data)                    (0x000000FF&(data))

#define  ATSC_ADDR_21EB                                                         0x181547AC
#define  ATSC_ADDR_21EB_reg_addr                                                 "0xB81547AC"
#define  ATSC_ADDR_21EB_reg                                                      0xB81547AC
#define  ATSC_ADDR_21EB_inst_addr                                                "0x011C"
#define  set_ATSC_ADDR_21EB_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21EB_reg)=data)
#define  get_ATSC_ADDR_21EB_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21EB_reg))
#define  ATSC_ADDR_21EB_fsm_symbol_counter_ini1_5_0_shift                        (2)
#define  ATSC_ADDR_21EB_fsm_symbol_counter_ini0_9_8_shift                        (0)
#define  ATSC_ADDR_21EB_fsm_symbol_counter_ini1_5_0_mask                         (0x000000FC)
#define  ATSC_ADDR_21EB_fsm_symbol_counter_ini0_9_8_mask                         (0x00000003)
#define  ATSC_ADDR_21EB_fsm_symbol_counter_ini1_5_0(data)                        (0x000000FC&((data)<<2))
#define  ATSC_ADDR_21EB_fsm_symbol_counter_ini0_9_8(data)                        (0x00000003&(data))
#define  ATSC_ADDR_21EB_get_fsm_symbol_counter_ini1_5_0(data)                    ((0x000000FC&(data))>>2)
#define  ATSC_ADDR_21EB_get_fsm_symbol_counter_ini0_9_8(data)                    (0x00000003&(data))

#define  ATSC_ADDR_21EC                                                         0x181547B0
#define  ATSC_ADDR_21EC_reg_addr                                                 "0xB81547B0"
#define  ATSC_ADDR_21EC_reg                                                      0xB81547B0
#define  ATSC_ADDR_21EC_inst_addr                                                "0x011D"
#define  set_ATSC_ADDR_21EC_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21EC_reg)=data)
#define  get_ATSC_ADDR_21EC_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21EC_reg))
#define  ATSC_ADDR_21EC_fsm_symbol_counter_ini1_9_6_shift                        (0)
#define  ATSC_ADDR_21EC_fsm_symbol_counter_ini1_9_6_mask                         (0x0000000F)
#define  ATSC_ADDR_21EC_fsm_symbol_counter_ini1_9_6(data)                        (0x0000000F&(data))
#define  ATSC_ADDR_21EC_get_fsm_symbol_counter_ini1_9_6(data)                    (0x0000000F&(data))

#define  ATSC_ADDR_21ED                                                         0x181547B4
#define  ATSC_ADDR_21ED_reg_addr                                                 "0xB81547B4"
#define  ATSC_ADDR_21ED_reg                                                      0xB81547B4
#define  ATSC_ADDR_21ED_inst_addr                                                "0x011E"
#define  set_ATSC_ADDR_21ED_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21ED_reg)=data)
#define  get_ATSC_ADDR_21ED_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21ED_reg))
#define  ATSC_ADDR_21ED_fsm_train_ptr_ini0_7_0_shift                             (0)
#define  ATSC_ADDR_21ED_fsm_train_ptr_ini0_7_0_mask                              (0x000000FF)
#define  ATSC_ADDR_21ED_fsm_train_ptr_ini0_7_0(data)                             (0x000000FF&(data))
#define  ATSC_ADDR_21ED_get_fsm_train_ptr_ini0_7_0(data)                         (0x000000FF&(data))

#define  ATSC_ADDR_21EE                                                         0x181547B8
#define  ATSC_ADDR_21EE_reg_addr                                                 "0xB81547B8"
#define  ATSC_ADDR_21EE_reg                                                      0xB81547B8
#define  ATSC_ADDR_21EE_inst_addr                                                "0x011F"
#define  set_ATSC_ADDR_21EE_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21EE_reg)=data)
#define  get_ATSC_ADDR_21EE_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21EE_reg))
#define  ATSC_ADDR_21EE_fsm_train_ptr_ini1_5_0_shift                             (2)
#define  ATSC_ADDR_21EE_fsm_train_ptr_ini0_9_8_shift                             (0)
#define  ATSC_ADDR_21EE_fsm_train_ptr_ini1_5_0_mask                              (0x000000FC)
#define  ATSC_ADDR_21EE_fsm_train_ptr_ini0_9_8_mask                              (0x00000003)
#define  ATSC_ADDR_21EE_fsm_train_ptr_ini1_5_0(data)                             (0x000000FC&((data)<<2))
#define  ATSC_ADDR_21EE_fsm_train_ptr_ini0_9_8(data)                             (0x00000003&(data))
#define  ATSC_ADDR_21EE_get_fsm_train_ptr_ini1_5_0(data)                         ((0x000000FC&(data))>>2)
#define  ATSC_ADDR_21EE_get_fsm_train_ptr_ini0_9_8(data)                         (0x00000003&(data))

#define  ATSC_ADDR_21EF                                                         0x181547BC
#define  ATSC_ADDR_21EF_reg_addr                                                 "0xB81547BC"
#define  ATSC_ADDR_21EF_reg                                                      0xB81547BC
#define  ATSC_ADDR_21EF_inst_addr                                                "0x0120"
#define  set_ATSC_ADDR_21EF_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_21EF_reg)=data)
#define  get_ATSC_ADDR_21EF_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_21EF_reg))
#define  ATSC_ADDR_21EF_fsm_train_ptr_ini1_9_6_shift                             (0)
#define  ATSC_ADDR_21EF_fsm_train_ptr_ini1_9_6_mask                              (0x0000000F)
#define  ATSC_ADDR_21EF_fsm_train_ptr_ini1_9_6(data)                             (0x0000000F&(data))
#define  ATSC_ADDR_21EF_get_fsm_train_ptr_ini1_9_6(data)                         (0x0000000F&(data))

#define  ATSC_ADDR_2201                                                         0x18154804
#define  ATSC_ADDR_2201_reg_addr                                                 "0xB8154804"
#define  ATSC_ADDR_2201_reg                                                      0xB8154804
#define  ATSC_ADDR_2201_inst_addr                                                "0x0121"
#define  set_ATSC_ADDR_2201_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2201_reg)=data)
#define  get_ATSC_ADDR_2201_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2201_reg))
#define  ATSC_ADDR_2201_pt_dd_max_shift                                          (4)
#define  ATSC_ADDR_2201_pt_on_shift                                              (3)
#define  ATSC_ADDR_2201_pt_out_sel_shift                                         (2)
#define  ATSC_ADDR_2201_pt_mode_shift                                            (0)
#define  ATSC_ADDR_2201_pt_dd_max_mask                                           (0x00000070)
#define  ATSC_ADDR_2201_pt_on_mask                                               (0x00000008)
#define  ATSC_ADDR_2201_pt_out_sel_mask                                          (0x00000004)
#define  ATSC_ADDR_2201_pt_mode_mask                                             (0x00000003)
#define  ATSC_ADDR_2201_pt_dd_max(data)                                          (0x00000070&((data)<<4))
#define  ATSC_ADDR_2201_pt_on(data)                                              (0x00000008&((data)<<3))
#define  ATSC_ADDR_2201_pt_out_sel(data)                                         (0x00000004&((data)<<2))
#define  ATSC_ADDR_2201_pt_mode(data)                                            (0x00000003&(data))
#define  ATSC_ADDR_2201_get_pt_dd_max(data)                                      ((0x00000070&(data))>>4)
#define  ATSC_ADDR_2201_get_pt_on(data)                                          ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2201_get_pt_out_sel(data)                                     ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2201_get_pt_mode(data)                                        (0x00000003&(data))

#define  ATSC_ADDR_2202                                                         0x18154808
#define  ATSC_ADDR_2202_reg_addr                                                 "0xB8154808"
#define  ATSC_ADDR_2202_reg                                                      0xB8154808
#define  ATSC_ADDR_2202_inst_addr                                                "0x0122"
#define  set_ATSC_ADDR_2202_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2202_reg)=data)
#define  get_ATSC_ADDR_2202_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2202_reg))
#define  ATSC_ADDR_2202_pt_state_start_shift                                     (0)
#define  ATSC_ADDR_2202_pt_state_start_mask                                      (0x0000003F)
#define  ATSC_ADDR_2202_pt_state_start(data)                                     (0x0000003F&(data))
#define  ATSC_ADDR_2202_get_pt_state_start(data)                                 (0x0000003F&(data))

#define  ATSC_ADDR_2203                                                         0x1815480C
#define  ATSC_ADDR_2203_reg_addr                                                 "0xB815480C"
#define  ATSC_ADDR_2203_reg                                                      0xB815480C
#define  ATSC_ADDR_2203_inst_addr                                                "0x0123"
#define  set_ATSC_ADDR_2203_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2203_reg)=data)
#define  get_ATSC_ADDR_2203_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2203_reg))
#define  ATSC_ADDR_2203_pt_kb_exp_shift                                          (6)
#define  ATSC_ADDR_2203_pt_state_end_shift                                       (0)
#define  ATSC_ADDR_2203_pt_kb_exp_mask                                           (0x000000C0)
#define  ATSC_ADDR_2203_pt_state_end_mask                                        (0x0000003F)
#define  ATSC_ADDR_2203_pt_kb_exp(data)                                          (0x000000C0&((data)<<6))
#define  ATSC_ADDR_2203_pt_state_end(data)                                       (0x0000003F&(data))
#define  ATSC_ADDR_2203_get_pt_kb_exp(data)                                      ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_2203_get_pt_state_end(data)                                   (0x0000003F&(data))

#define  ATSC_ADDR_2220                                                         0x18154880
#define  ATSC_ADDR_2220_reg_addr                                                 "0xB8154880"
#define  ATSC_ADDR_2220_reg                                                      0xB8154880
#define  ATSC_ADDR_2220_inst_addr                                                "0x0124"
#define  set_ATSC_ADDR_2220_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2220_reg)=data)
#define  get_ATSC_ADDR_2220_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2220_reg))
#define  ATSC_ADDR_2220_pt_dec_sel_shift                                         (4)
#define  ATSC_ADDR_2220_pt_u_exp_1_shift                                         (2)
#define  ATSC_ADDR_2220_pt_u_exp_0_shift                                         (0)
#define  ATSC_ADDR_2220_pt_dec_sel_mask                                          (0x00000010)
#define  ATSC_ADDR_2220_pt_u_exp_1_mask                                          (0x0000000C)
#define  ATSC_ADDR_2220_pt_u_exp_0_mask                                          (0x00000003)
#define  ATSC_ADDR_2220_pt_dec_sel(data)                                         (0x00000010&((data)<<4))
#define  ATSC_ADDR_2220_pt_u_exp_1(data)                                         (0x0000000C&((data)<<2))
#define  ATSC_ADDR_2220_pt_u_exp_0(data)                                         (0x00000003&(data))
#define  ATSC_ADDR_2220_get_pt_dec_sel(data)                                     ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2220_get_pt_u_exp_1(data)                                     ((0x0000000C&(data))>>2)
#define  ATSC_ADDR_2220_get_pt_u_exp_0(data)                                     (0x00000003&(data))

#define  ATSC_ADDR_2221                                                         0x18154884
#define  ATSC_ADDR_2221_reg_addr                                                 "0xB8154884"
#define  ATSC_ADDR_2221_reg                                                      0xB8154884
#define  ATSC_ADDR_2221_inst_addr                                                "0x0125"
#define  set_ATSC_ADDR_2221_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2221_reg)=data)
#define  get_ATSC_ADDR_2221_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2221_reg))
#define  ATSC_ADDR_2221_pt_ph_max_shift                                          (0)
#define  ATSC_ADDR_2221_pt_ph_max_mask                                           (0x0000003F)
#define  ATSC_ADDR_2221_pt_ph_max(data)                                          (0x0000003F&(data))
#define  ATSC_ADDR_2221_get_pt_ph_max(data)                                      (0x0000003F&(data))

#define  ATSC_ADDR_2222                                                         0x18154888
#define  ATSC_ADDR_2222_reg_addr                                                 "0xB8154888"
#define  ATSC_ADDR_2222_reg                                                      0xB8154888
#define  ATSC_ADDR_2222_inst_addr                                                "0x0126"
#define  set_ATSC_ADDR_2222_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2222_reg)=data)
#define  get_ATSC_ADDR_2222_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2222_reg))
#define  ATSC_ADDR_2222_pt_dd_t_shift                                            (1)
#define  ATSC_ADDR_2222_pt_clear_en_shift                                        (0)
#define  ATSC_ADDR_2222_pt_dd_t_mask                                             (0x0000000E)
#define  ATSC_ADDR_2222_pt_clear_en_mask                                         (0x00000001)
#define  ATSC_ADDR_2222_pt_dd_t(data)                                            (0x0000000E&((data)<<1))
#define  ATSC_ADDR_2222_pt_clear_en(data)                                        (0x00000001&(data))
#define  ATSC_ADDR_2222_get_pt_dd_t(data)                                        ((0x0000000E&(data))>>1)
#define  ATSC_ADDR_2222_get_pt_clear_en(data)                                    (0x00000001&(data))

#define  ATSC_ADDR_2501                                                         0x18155404
#define  ATSC_ADDR_2501_reg_addr                                                 "0xB8155404"
#define  ATSC_ADDR_2501_reg                                                      0xB8155404
#define  ATSC_ADDR_2501_inst_addr                                                "0x0127"
#define  set_ATSC_ADDR_2501_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2501_reg)=data)
#define  get_ATSC_ADDR_2501_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2501_reg))
#define  ATSC_ADDR_2501_srrc_coeff_12_0_shift                                    (7)
#define  ATSC_ADDR_2501_srrc_coeff_0_shift                                       (0)
#define  ATSC_ADDR_2501_srrc_coeff_12_0_mask                                     (0x00000080)
#define  ATSC_ADDR_2501_srrc_coeff_0_mask                                        (0x0000007F)
#define  ATSC_ADDR_2501_srrc_coeff_12_0(data)                                    (0x00000080&((data)<<7))
#define  ATSC_ADDR_2501_srrc_coeff_0(data)                                       (0x0000007F&(data))
#define  ATSC_ADDR_2501_get_srrc_coeff_12_0(data)                                ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2501_get_srrc_coeff_0(data)                                   (0x0000007F&(data))

#define  ATSC_ADDR_2502                                                         0x18155408
#define  ATSC_ADDR_2502_reg_addr                                                 "0xB8155408"
#define  ATSC_ADDR_2502_reg                                                      0xB8155408
#define  ATSC_ADDR_2502_inst_addr                                                "0x0128"
#define  set_ATSC_ADDR_2502_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2502_reg)=data)
#define  get_ATSC_ADDR_2502_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2502_reg))
#define  ATSC_ADDR_2502_srrc_coeff_12_8_1_shift                                  (0)
#define  ATSC_ADDR_2502_srrc_coeff_12_8_1_mask                                   (0x000000FF)
#define  ATSC_ADDR_2502_srrc_coeff_12_8_1(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2502_get_srrc_coeff_12_8_1(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2503                                                         0x1815540C
#define  ATSC_ADDR_2503_reg_addr                                                 "0xB815540C"
#define  ATSC_ADDR_2503_reg                                                      0xB815540C
#define  ATSC_ADDR_2503_inst_addr                                                "0x0129"
#define  set_ATSC_ADDR_2503_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2503_reg)=data)
#define  get_ATSC_ADDR_2503_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2503_reg))
#define  ATSC_ADDR_2503_srrc_coeff_13_0_shift                                    (7)
#define  ATSC_ADDR_2503_srrc_coeff_1_shift                                       (0)
#define  ATSC_ADDR_2503_srrc_coeff_13_0_mask                                     (0x00000080)
#define  ATSC_ADDR_2503_srrc_coeff_1_mask                                        (0x0000007F)
#define  ATSC_ADDR_2503_srrc_coeff_13_0(data)                                    (0x00000080&((data)<<7))
#define  ATSC_ADDR_2503_srrc_coeff_1(data)                                       (0x0000007F&(data))
#define  ATSC_ADDR_2503_get_srrc_coeff_13_0(data)                                ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2503_get_srrc_coeff_1(data)                                   (0x0000007F&(data))

#define  ATSC_ADDR_2504                                                         0x18155410
#define  ATSC_ADDR_2504_reg_addr                                                 "0xB8155410"
#define  ATSC_ADDR_2504_reg                                                      0xB8155410
#define  ATSC_ADDR_2504_inst_addr                                                "0x012A"
#define  set_ATSC_ADDR_2504_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2504_reg)=data)
#define  get_ATSC_ADDR_2504_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2504_reg))
#define  ATSC_ADDR_2504_srrc_coeff_13_8_1_shift                                  (0)
#define  ATSC_ADDR_2504_srrc_coeff_13_8_1_mask                                   (0x000000FF)
#define  ATSC_ADDR_2504_srrc_coeff_13_8_1(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2504_get_srrc_coeff_13_8_1(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2505                                                         0x18155414
#define  ATSC_ADDR_2505_reg_addr                                                 "0xB8155414"
#define  ATSC_ADDR_2505_reg                                                      0xB8155414
#define  ATSC_ADDR_2505_inst_addr                                                "0x012B"
#define  set_ATSC_ADDR_2505_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2505_reg)=data)
#define  get_ATSC_ADDR_2505_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2505_reg))
#define  ATSC_ADDR_2505_srrc_coeff_14_0_shift                                    (7)
#define  ATSC_ADDR_2505_srrc_coeff_2_shift                                       (0)
#define  ATSC_ADDR_2505_srrc_coeff_14_0_mask                                     (0x00000080)
#define  ATSC_ADDR_2505_srrc_coeff_2_mask                                        (0x0000007F)
#define  ATSC_ADDR_2505_srrc_coeff_14_0(data)                                    (0x00000080&((data)<<7))
#define  ATSC_ADDR_2505_srrc_coeff_2(data)                                       (0x0000007F&(data))
#define  ATSC_ADDR_2505_get_srrc_coeff_14_0(data)                                ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2505_get_srrc_coeff_2(data)                                   (0x0000007F&(data))

#define  ATSC_ADDR_2506                                                         0x18155418
#define  ATSC_ADDR_2506_reg_addr                                                 "0xB8155418"
#define  ATSC_ADDR_2506_reg                                                      0xB8155418
#define  ATSC_ADDR_2506_inst_addr                                                "0x012C"
#define  set_ATSC_ADDR_2506_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2506_reg)=data)
#define  get_ATSC_ADDR_2506_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2506_reg))
#define  ATSC_ADDR_2506_srrc_coeff_14_8_1_shift                                  (0)
#define  ATSC_ADDR_2506_srrc_coeff_14_8_1_mask                                   (0x000000FF)
#define  ATSC_ADDR_2506_srrc_coeff_14_8_1(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2506_get_srrc_coeff_14_8_1(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2507                                                         0x1815541C
#define  ATSC_ADDR_2507_reg_addr                                                 "0xB815541C"
#define  ATSC_ADDR_2507_reg                                                      0xB815541C
#define  ATSC_ADDR_2507_inst_addr                                                "0x012D"
#define  set_ATSC_ADDR_2507_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2507_reg)=data)
#define  get_ATSC_ADDR_2507_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2507_reg))
#define  ATSC_ADDR_2507_srrc_coeff_15_0_shift                                    (7)
#define  ATSC_ADDR_2507_srrc_coeff_3_shift                                       (0)
#define  ATSC_ADDR_2507_srrc_coeff_15_0_mask                                     (0x00000080)
#define  ATSC_ADDR_2507_srrc_coeff_3_mask                                        (0x0000007F)
#define  ATSC_ADDR_2507_srrc_coeff_15_0(data)                                    (0x00000080&((data)<<7))
#define  ATSC_ADDR_2507_srrc_coeff_3(data)                                       (0x0000007F&(data))
#define  ATSC_ADDR_2507_get_srrc_coeff_15_0(data)                                ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2507_get_srrc_coeff_3(data)                                   (0x0000007F&(data))

#define  ATSC_ADDR_2508                                                         0x18155420
#define  ATSC_ADDR_2508_reg_addr                                                 "0xB8155420"
#define  ATSC_ADDR_2508_reg                                                      0xB8155420
#define  ATSC_ADDR_2508_inst_addr                                                "0x012E"
#define  set_ATSC_ADDR_2508_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2508_reg)=data)
#define  get_ATSC_ADDR_2508_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2508_reg))
#define  ATSC_ADDR_2508_srrc_coeff_15_8_1_shift                                  (0)
#define  ATSC_ADDR_2508_srrc_coeff_15_8_1_mask                                   (0x000000FF)
#define  ATSC_ADDR_2508_srrc_coeff_15_8_1(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2508_get_srrc_coeff_15_8_1(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2509                                                         0x18155424
#define  ATSC_ADDR_2509_reg_addr                                                 "0xB8155424"
#define  ATSC_ADDR_2509_reg                                                      0xB8155424
#define  ATSC_ADDR_2509_inst_addr                                                "0x012F"
#define  set_ATSC_ADDR_2509_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2509_reg)=data)
#define  get_ATSC_ADDR_2509_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2509_reg))
#define  ATSC_ADDR_2509_srrc_coeff_16_0_shift                                    (7)
#define  ATSC_ADDR_2509_srrc_coeff_4_shift                                       (0)
#define  ATSC_ADDR_2509_srrc_coeff_16_0_mask                                     (0x00000080)
#define  ATSC_ADDR_2509_srrc_coeff_4_mask                                        (0x0000007F)
#define  ATSC_ADDR_2509_srrc_coeff_16_0(data)                                    (0x00000080&((data)<<7))
#define  ATSC_ADDR_2509_srrc_coeff_4(data)                                       (0x0000007F&(data))
#define  ATSC_ADDR_2509_get_srrc_coeff_16_0(data)                                ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2509_get_srrc_coeff_4(data)                                   (0x0000007F&(data))

#define  ATSC_ADDR_250A                                                         0x18155428
#define  ATSC_ADDR_250A_reg_addr                                                 "0xB8155428"
#define  ATSC_ADDR_250A_reg                                                      0xB8155428
#define  ATSC_ADDR_250A_inst_addr                                                "0x0130"
#define  set_ATSC_ADDR_250A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_250A_reg)=data)
#define  get_ATSC_ADDR_250A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_250A_reg))
#define  ATSC_ADDR_250A_srrc_coeff_16_8_1_shift                                  (0)
#define  ATSC_ADDR_250A_srrc_coeff_16_8_1_mask                                   (0x000000FF)
#define  ATSC_ADDR_250A_srrc_coeff_16_8_1(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_250A_get_srrc_coeff_16_8_1(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_250B                                                         0x1815542C
#define  ATSC_ADDR_250B_reg_addr                                                 "0xB815542C"
#define  ATSC_ADDR_250B_reg                                                      0xB815542C
#define  ATSC_ADDR_250B_inst_addr                                                "0x0131"
#define  set_ATSC_ADDR_250B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_250B_reg)=data)
#define  get_ATSC_ADDR_250B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_250B_reg))
#define  ATSC_ADDR_250B_srrc_coeff_17_0_shift                                    (7)
#define  ATSC_ADDR_250B_srrc_coeff_5_shift                                       (0)
#define  ATSC_ADDR_250B_srrc_coeff_17_0_mask                                     (0x00000080)
#define  ATSC_ADDR_250B_srrc_coeff_5_mask                                        (0x0000007F)
#define  ATSC_ADDR_250B_srrc_coeff_17_0(data)                                    (0x00000080&((data)<<7))
#define  ATSC_ADDR_250B_srrc_coeff_5(data)                                       (0x0000007F&(data))
#define  ATSC_ADDR_250B_get_srrc_coeff_17_0(data)                                ((0x00000080&(data))>>7)
#define  ATSC_ADDR_250B_get_srrc_coeff_5(data)                                   (0x0000007F&(data))

#define  ATSC_ADDR_250C                                                         0x18155430
#define  ATSC_ADDR_250C_reg_addr                                                 "0xB8155430"
#define  ATSC_ADDR_250C_reg                                                      0xB8155430
#define  ATSC_ADDR_250C_inst_addr                                                "0x0132"
#define  set_ATSC_ADDR_250C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_250C_reg)=data)
#define  get_ATSC_ADDR_250C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_250C_reg))
#define  ATSC_ADDR_250C_srrc_coeff_17_8_1_shift                                  (0)
#define  ATSC_ADDR_250C_srrc_coeff_17_8_1_mask                                   (0x000000FF)
#define  ATSC_ADDR_250C_srrc_coeff_17_8_1(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_250C_get_srrc_coeff_17_8_1(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_250D                                                         0x18155434
#define  ATSC_ADDR_250D_reg_addr                                                 "0xB8155434"
#define  ATSC_ADDR_250D_reg                                                      0xB8155434
#define  ATSC_ADDR_250D_inst_addr                                                "0x0133"
#define  set_ATSC_ADDR_250D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_250D_reg)=data)
#define  get_ATSC_ADDR_250D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_250D_reg))
#define  ATSC_ADDR_250D_srrc_coeff_18_0_shift                                    (7)
#define  ATSC_ADDR_250D_srrc_coeff_6_shift                                       (0)
#define  ATSC_ADDR_250D_srrc_coeff_18_0_mask                                     (0x00000080)
#define  ATSC_ADDR_250D_srrc_coeff_6_mask                                        (0x0000007F)
#define  ATSC_ADDR_250D_srrc_coeff_18_0(data)                                    (0x00000080&((data)<<7))
#define  ATSC_ADDR_250D_srrc_coeff_6(data)                                       (0x0000007F&(data))
#define  ATSC_ADDR_250D_get_srrc_coeff_18_0(data)                                ((0x00000080&(data))>>7)
#define  ATSC_ADDR_250D_get_srrc_coeff_6(data)                                   (0x0000007F&(data))

#define  ATSC_ADDR_250E                                                         0x18155438
#define  ATSC_ADDR_250E_reg_addr                                                 "0xB8155438"
#define  ATSC_ADDR_250E_reg                                                      0xB8155438
#define  ATSC_ADDR_250E_inst_addr                                                "0x0134"
#define  set_ATSC_ADDR_250E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_250E_reg)=data)
#define  get_ATSC_ADDR_250E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_250E_reg))
#define  ATSC_ADDR_250E_srrc_coeff_18_8_1_shift                                  (0)
#define  ATSC_ADDR_250E_srrc_coeff_18_8_1_mask                                   (0x000000FF)
#define  ATSC_ADDR_250E_srrc_coeff_18_8_1(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_250E_get_srrc_coeff_18_8_1(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_250F                                                         0x1815543C
#define  ATSC_ADDR_250F_reg_addr                                                 "0xB815543C"
#define  ATSC_ADDR_250F_reg                                                      0xB815543C
#define  ATSC_ADDR_250F_inst_addr                                                "0x0135"
#define  set_ATSC_ADDR_250F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_250F_reg)=data)
#define  get_ATSC_ADDR_250F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_250F_reg))
#define  ATSC_ADDR_250F_srrc_coeff_19_0_shift                                    (7)
#define  ATSC_ADDR_250F_srrc_coeff_7_shift                                       (0)
#define  ATSC_ADDR_250F_srrc_coeff_19_0_mask                                     (0x00000080)
#define  ATSC_ADDR_250F_srrc_coeff_7_mask                                        (0x0000007F)
#define  ATSC_ADDR_250F_srrc_coeff_19_0(data)                                    (0x00000080&((data)<<7))
#define  ATSC_ADDR_250F_srrc_coeff_7(data)                                       (0x0000007F&(data))
#define  ATSC_ADDR_250F_get_srrc_coeff_19_0(data)                                ((0x00000080&(data))>>7)
#define  ATSC_ADDR_250F_get_srrc_coeff_7(data)                                   (0x0000007F&(data))

#define  ATSC_ADDR_2510                                                         0x18155440
#define  ATSC_ADDR_2510_reg_addr                                                 "0xB8155440"
#define  ATSC_ADDR_2510_reg                                                      0xB8155440
#define  ATSC_ADDR_2510_inst_addr                                                "0x0136"
#define  set_ATSC_ADDR_2510_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2510_reg)=data)
#define  get_ATSC_ADDR_2510_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2510_reg))
#define  ATSC_ADDR_2510_srrc_coeff_19_8_1_shift                                  (0)
#define  ATSC_ADDR_2510_srrc_coeff_19_8_1_mask                                   (0x000000FF)
#define  ATSC_ADDR_2510_srrc_coeff_19_8_1(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2510_get_srrc_coeff_19_8_1(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2511                                                         0x18155444
#define  ATSC_ADDR_2511_reg_addr                                                 "0xB8155444"
#define  ATSC_ADDR_2511_reg                                                      0xB8155444
#define  ATSC_ADDR_2511_inst_addr                                                "0x0137"
#define  set_ATSC_ADDR_2511_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2511_reg)=data)
#define  get_ATSC_ADDR_2511_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2511_reg))
#define  ATSC_ADDR_2511_srrc_coeff_20_0_shift                                    (7)
#define  ATSC_ADDR_2511_srrc_coeff_8_shift                                       (0)
#define  ATSC_ADDR_2511_srrc_coeff_20_0_mask                                     (0x00000080)
#define  ATSC_ADDR_2511_srrc_coeff_8_mask                                        (0x0000007F)
#define  ATSC_ADDR_2511_srrc_coeff_20_0(data)                                    (0x00000080&((data)<<7))
#define  ATSC_ADDR_2511_srrc_coeff_8(data)                                       (0x0000007F&(data))
#define  ATSC_ADDR_2511_get_srrc_coeff_20_0(data)                                ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2511_get_srrc_coeff_8(data)                                   (0x0000007F&(data))

#define  ATSC_ADDR_2512                                                         0x18155448
#define  ATSC_ADDR_2512_reg_addr                                                 "0xB8155448"
#define  ATSC_ADDR_2512_reg                                                      0xB8155448
#define  ATSC_ADDR_2512_inst_addr                                                "0x0138"
#define  set_ATSC_ADDR_2512_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2512_reg)=data)
#define  get_ATSC_ADDR_2512_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2512_reg))
#define  ATSC_ADDR_2512_srrc_coeff_20_8_1_shift                                  (0)
#define  ATSC_ADDR_2512_srrc_coeff_20_8_1_mask                                   (0x000000FF)
#define  ATSC_ADDR_2512_srrc_coeff_20_8_1(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2512_get_srrc_coeff_20_8_1(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2513                                                         0x1815544C
#define  ATSC_ADDR_2513_reg_addr                                                 "0xB815544C"
#define  ATSC_ADDR_2513_reg                                                      0xB815544C
#define  ATSC_ADDR_2513_inst_addr                                                "0x0139"
#define  set_ATSC_ADDR_2513_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2513_reg)=data)
#define  get_ATSC_ADDR_2513_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2513_reg))
#define  ATSC_ADDR_2513_srrc_coeff_21_0_shift                                    (7)
#define  ATSC_ADDR_2513_srrc_coeff_9_shift                                       (0)
#define  ATSC_ADDR_2513_srrc_coeff_21_0_mask                                     (0x00000080)
#define  ATSC_ADDR_2513_srrc_coeff_9_mask                                        (0x0000007F)
#define  ATSC_ADDR_2513_srrc_coeff_21_0(data)                                    (0x00000080&((data)<<7))
#define  ATSC_ADDR_2513_srrc_coeff_9(data)                                       (0x0000007F&(data))
#define  ATSC_ADDR_2513_get_srrc_coeff_21_0(data)                                ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2513_get_srrc_coeff_9(data)                                   (0x0000007F&(data))

#define  ATSC_ADDR_2514                                                         0x18155450
#define  ATSC_ADDR_2514_reg_addr                                                 "0xB8155450"
#define  ATSC_ADDR_2514_reg                                                      0xB8155450
#define  ATSC_ADDR_2514_inst_addr                                                "0x013A"
#define  set_ATSC_ADDR_2514_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2514_reg)=data)
#define  get_ATSC_ADDR_2514_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2514_reg))
#define  ATSC_ADDR_2514_srrc_coeff_21_8_1_shift                                  (0)
#define  ATSC_ADDR_2514_srrc_coeff_21_8_1_mask                                   (0x000000FF)
#define  ATSC_ADDR_2514_srrc_coeff_21_8_1(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2514_get_srrc_coeff_21_8_1(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2515                                                         0x18155454
#define  ATSC_ADDR_2515_reg_addr                                                 "0xB8155454"
#define  ATSC_ADDR_2515_reg                                                      0xB8155454
#define  ATSC_ADDR_2515_inst_addr                                                "0x013B"
#define  set_ATSC_ADDR_2515_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2515_reg)=data)
#define  get_ATSC_ADDR_2515_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2515_reg))
#define  ATSC_ADDR_2515_srrc_coeff_22_0_shift                                    (7)
#define  ATSC_ADDR_2515_srrc_coeff_10_shift                                      (0)
#define  ATSC_ADDR_2515_srrc_coeff_22_0_mask                                     (0x00000080)
#define  ATSC_ADDR_2515_srrc_coeff_10_mask                                       (0x0000007F)
#define  ATSC_ADDR_2515_srrc_coeff_22_0(data)                                    (0x00000080&((data)<<7))
#define  ATSC_ADDR_2515_srrc_coeff_10(data)                                      (0x0000007F&(data))
#define  ATSC_ADDR_2515_get_srrc_coeff_22_0(data)                                ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2515_get_srrc_coeff_10(data)                                  (0x0000007F&(data))

#define  ATSC_ADDR_2516                                                         0x18155458
#define  ATSC_ADDR_2516_reg_addr                                                 "0xB8155458"
#define  ATSC_ADDR_2516_reg                                                      0xB8155458
#define  ATSC_ADDR_2516_inst_addr                                                "0x013C"
#define  set_ATSC_ADDR_2516_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2516_reg)=data)
#define  get_ATSC_ADDR_2516_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2516_reg))
#define  ATSC_ADDR_2516_srrc_coeff_22_8_1_shift                                  (0)
#define  ATSC_ADDR_2516_srrc_coeff_22_8_1_mask                                   (0x000000FF)
#define  ATSC_ADDR_2516_srrc_coeff_22_8_1(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2516_get_srrc_coeff_22_8_1(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2517                                                         0x1815545C
#define  ATSC_ADDR_2517_reg_addr                                                 "0xB815545C"
#define  ATSC_ADDR_2517_reg                                                      0xB815545C
#define  ATSC_ADDR_2517_inst_addr                                                "0x013D"
#define  set_ATSC_ADDR_2517_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2517_reg)=data)
#define  get_ATSC_ADDR_2517_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2517_reg))
#define  ATSC_ADDR_2517_srrc_coeff_23_0_shift                                    (7)
#define  ATSC_ADDR_2517_srrc_coeff_11_shift                                      (0)
#define  ATSC_ADDR_2517_srrc_coeff_23_0_mask                                     (0x00000080)
#define  ATSC_ADDR_2517_srrc_coeff_11_mask                                       (0x0000007F)
#define  ATSC_ADDR_2517_srrc_coeff_23_0(data)                                    (0x00000080&((data)<<7))
#define  ATSC_ADDR_2517_srrc_coeff_11(data)                                      (0x0000007F&(data))
#define  ATSC_ADDR_2517_get_srrc_coeff_23_0(data)                                ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2517_get_srrc_coeff_11(data)                                  (0x0000007F&(data))

#define  ATSC_ADDR_2518                                                         0x18155460
#define  ATSC_ADDR_2518_reg_addr                                                 "0xB8155460"
#define  ATSC_ADDR_2518_reg                                                      0xB8155460
#define  ATSC_ADDR_2518_inst_addr                                                "0x013E"
#define  set_ATSC_ADDR_2518_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2518_reg)=data)
#define  get_ATSC_ADDR_2518_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2518_reg))
#define  ATSC_ADDR_2518_srrc_coeff_23_8_1_shift                                  (0)
#define  ATSC_ADDR_2518_srrc_coeff_23_8_1_mask                                   (0x000000FF)
#define  ATSC_ADDR_2518_srrc_coeff_23_8_1(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2518_get_srrc_coeff_23_8_1(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2519                                                         0x18155464
#define  ATSC_ADDR_2519_reg_addr                                                 "0xB8155464"
#define  ATSC_ADDR_2519_reg                                                      0xB8155464
#define  ATSC_ADDR_2519_inst_addr                                                "0x013F"
#define  set_ATSC_ADDR_2519_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2519_reg)=data)
#define  get_ATSC_ADDR_2519_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2519_reg))
#define  ATSC_ADDR_2519_srrc_coeff_24_7_0_shift                                  (0)
#define  ATSC_ADDR_2519_srrc_coeff_24_7_0_mask                                   (0x000000FF)
#define  ATSC_ADDR_2519_srrc_coeff_24_7_0(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2519_get_srrc_coeff_24_7_0(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_251A                                                         0x18155468
#define  ATSC_ADDR_251A_reg_addr                                                 "0xB8155468"
#define  ATSC_ADDR_251A_reg                                                      0xB8155468
#define  ATSC_ADDR_251A_inst_addr                                                "0x0140"
#define  set_ATSC_ADDR_251A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_251A_reg)=data)
#define  get_ATSC_ADDR_251A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_251A_reg))
#define  ATSC_ADDR_251A_srrc_coeff_25_3_0_shift                                  (4)
#define  ATSC_ADDR_251A_srrc_coeff_24_11_8_shift                                 (0)
#define  ATSC_ADDR_251A_srrc_coeff_25_3_0_mask                                   (0x000000F0)
#define  ATSC_ADDR_251A_srrc_coeff_24_11_8_mask                                  (0x0000000F)
#define  ATSC_ADDR_251A_srrc_coeff_25_3_0(data)                                  (0x000000F0&((data)<<4))
#define  ATSC_ADDR_251A_srrc_coeff_24_11_8(data)                                 (0x0000000F&(data))
#define  ATSC_ADDR_251A_get_srrc_coeff_25_3_0(data)                              ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_251A_get_srrc_coeff_24_11_8(data)                             (0x0000000F&(data))

#define  ATSC_ADDR_251B                                                         0x1815546C
#define  ATSC_ADDR_251B_reg_addr                                                 "0xB815546C"
#define  ATSC_ADDR_251B_reg                                                      0xB815546C
#define  ATSC_ADDR_251B_inst_addr                                                "0x0141"
#define  set_ATSC_ADDR_251B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_251B_reg)=data)
#define  get_ATSC_ADDR_251B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_251B_reg))
#define  ATSC_ADDR_251B_srrc_coeff_25_11_4_shift                                 (0)
#define  ATSC_ADDR_251B_srrc_coeff_25_11_4_mask                                  (0x000000FF)
#define  ATSC_ADDR_251B_srrc_coeff_25_11_4(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_251B_get_srrc_coeff_25_11_4(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_251C                                                         0x18155470
#define  ATSC_ADDR_251C_reg_addr                                                 "0xB8155470"
#define  ATSC_ADDR_251C_reg                                                      0xB8155470
#define  ATSC_ADDR_251C_inst_addr                                                "0x0142"
#define  set_ATSC_ADDR_251C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_251C_reg)=data)
#define  get_ATSC_ADDR_251C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_251C_reg))
#define  ATSC_ADDR_251C_srrc_coeff_26_7_0_shift                                  (0)
#define  ATSC_ADDR_251C_srrc_coeff_26_7_0_mask                                   (0x000000FF)
#define  ATSC_ADDR_251C_srrc_coeff_26_7_0(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_251C_get_srrc_coeff_26_7_0(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_251D                                                         0x18155474
#define  ATSC_ADDR_251D_reg_addr                                                 "0xB8155474"
#define  ATSC_ADDR_251D_reg                                                      0xB8155474
#define  ATSC_ADDR_251D_inst_addr                                                "0x0143"
#define  set_ATSC_ADDR_251D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_251D_reg)=data)
#define  get_ATSC_ADDR_251D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_251D_reg))
#define  ATSC_ADDR_251D_srrc_coeff_27_3_0_shift                                  (4)
#define  ATSC_ADDR_251D_srrc_coeff_26_11_8_shift                                 (0)
#define  ATSC_ADDR_251D_srrc_coeff_27_3_0_mask                                   (0x000000F0)
#define  ATSC_ADDR_251D_srrc_coeff_26_11_8_mask                                  (0x0000000F)
#define  ATSC_ADDR_251D_srrc_coeff_27_3_0(data)                                  (0x000000F0&((data)<<4))
#define  ATSC_ADDR_251D_srrc_coeff_26_11_8(data)                                 (0x0000000F&(data))
#define  ATSC_ADDR_251D_get_srrc_coeff_27_3_0(data)                              ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_251D_get_srrc_coeff_26_11_8(data)                             (0x0000000F&(data))

#define  ATSC_ADDR_251E                                                         0x18155478
#define  ATSC_ADDR_251E_reg_addr                                                 "0xB8155478"
#define  ATSC_ADDR_251E_reg                                                      0xB8155478
#define  ATSC_ADDR_251E_inst_addr                                                "0x0144"
#define  set_ATSC_ADDR_251E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_251E_reg)=data)
#define  get_ATSC_ADDR_251E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_251E_reg))
#define  ATSC_ADDR_251E_srrc_coeff_27_11_4_shift                                 (0)
#define  ATSC_ADDR_251E_srrc_coeff_27_11_4_mask                                  (0x000000FF)
#define  ATSC_ADDR_251E_srrc_coeff_27_11_4(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_251E_get_srrc_coeff_27_11_4(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_251F                                                         0x1815547C
#define  ATSC_ADDR_251F_reg_addr                                                 "0xB815547C"
#define  ATSC_ADDR_251F_reg                                                      0xB815547C
#define  ATSC_ADDR_251F_inst_addr                                                "0x0145"
#define  set_ATSC_ADDR_251F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_251F_reg)=data)
#define  get_ATSC_ADDR_251F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_251F_reg))
#define  ATSC_ADDR_251F_srrc_coeff_28_7_0_shift                                  (0)
#define  ATSC_ADDR_251F_srrc_coeff_28_7_0_mask                                   (0x000000FF)
#define  ATSC_ADDR_251F_srrc_coeff_28_7_0(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_251F_get_srrc_coeff_28_7_0(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2520                                                         0x18155480
#define  ATSC_ADDR_2520_reg_addr                                                 "0xB8155480"
#define  ATSC_ADDR_2520_reg                                                      0xB8155480
#define  ATSC_ADDR_2520_inst_addr                                                "0x0146"
#define  set_ATSC_ADDR_2520_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2520_reg)=data)
#define  get_ATSC_ADDR_2520_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2520_reg))
#define  ATSC_ADDR_2520_srrc_coeff_29_3_0_shift                                  (4)
#define  ATSC_ADDR_2520_srrc_coeff_28_11_8_shift                                 (0)
#define  ATSC_ADDR_2520_srrc_coeff_29_3_0_mask                                   (0x000000F0)
#define  ATSC_ADDR_2520_srrc_coeff_28_11_8_mask                                  (0x0000000F)
#define  ATSC_ADDR_2520_srrc_coeff_29_3_0(data)                                  (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2520_srrc_coeff_28_11_8(data)                                 (0x0000000F&(data))
#define  ATSC_ADDR_2520_get_srrc_coeff_29_3_0(data)                              ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2520_get_srrc_coeff_28_11_8(data)                             (0x0000000F&(data))

#define  ATSC_ADDR_2521                                                         0x18155484
#define  ATSC_ADDR_2521_reg_addr                                                 "0xB8155484"
#define  ATSC_ADDR_2521_reg                                                      0xB8155484
#define  ATSC_ADDR_2521_inst_addr                                                "0x0147"
#define  set_ATSC_ADDR_2521_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2521_reg)=data)
#define  get_ATSC_ADDR_2521_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2521_reg))
#define  ATSC_ADDR_2521_srrc_coeff_29_11_4_shift                                 (0)
#define  ATSC_ADDR_2521_srrc_coeff_29_11_4_mask                                  (0x000000FF)
#define  ATSC_ADDR_2521_srrc_coeff_29_11_4(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2521_get_srrc_coeff_29_11_4(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2522                                                         0x18155488
#define  ATSC_ADDR_2522_reg_addr                                                 "0xB8155488"
#define  ATSC_ADDR_2522_reg                                                      0xB8155488
#define  ATSC_ADDR_2522_inst_addr                                                "0x0148"
#define  set_ATSC_ADDR_2522_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2522_reg)=data)
#define  get_ATSC_ADDR_2522_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2522_reg))
#define  ATSC_ADDR_2522_srrc_coeff_30_7_0_shift                                  (0)
#define  ATSC_ADDR_2522_srrc_coeff_30_7_0_mask                                   (0x000000FF)
#define  ATSC_ADDR_2522_srrc_coeff_30_7_0(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2522_get_srrc_coeff_30_7_0(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2523                                                         0x1815548C
#define  ATSC_ADDR_2523_reg_addr                                                 "0xB815548C"
#define  ATSC_ADDR_2523_reg                                                      0xB815548C
#define  ATSC_ADDR_2523_inst_addr                                                "0x0149"
#define  set_ATSC_ADDR_2523_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2523_reg)=data)
#define  get_ATSC_ADDR_2523_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2523_reg))
#define  ATSC_ADDR_2523_srrc_coeff_31_3_0_shift                                  (4)
#define  ATSC_ADDR_2523_srrc_coeff_30_11_8_shift                                 (0)
#define  ATSC_ADDR_2523_srrc_coeff_31_3_0_mask                                   (0x000000F0)
#define  ATSC_ADDR_2523_srrc_coeff_30_11_8_mask                                  (0x0000000F)
#define  ATSC_ADDR_2523_srrc_coeff_31_3_0(data)                                  (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2523_srrc_coeff_30_11_8(data)                                 (0x0000000F&(data))
#define  ATSC_ADDR_2523_get_srrc_coeff_31_3_0(data)                              ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2523_get_srrc_coeff_30_11_8(data)                             (0x0000000F&(data))

#define  ATSC_ADDR_2524                                                         0x18155490
#define  ATSC_ADDR_2524_reg_addr                                                 "0xB8155490"
#define  ATSC_ADDR_2524_reg                                                      0xB8155490
#define  ATSC_ADDR_2524_inst_addr                                                "0x014A"
#define  set_ATSC_ADDR_2524_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2524_reg)=data)
#define  get_ATSC_ADDR_2524_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2524_reg))
#define  ATSC_ADDR_2524_srrc_coeff_31_11_4_shift                                 (0)
#define  ATSC_ADDR_2524_srrc_coeff_31_11_4_mask                                  (0x000000FF)
#define  ATSC_ADDR_2524_srrc_coeff_31_11_4(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2524_get_srrc_coeff_31_11_4(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2542                                                         0x18155508
#define  ATSC_ADDR_2542_reg_addr                                                 "0xB8155508"
#define  ATSC_ADDR_2542_reg                                                      0xB8155508
#define  ATSC_ADDR_2542_inst_addr                                                "0x014B"
#define  set_ATSC_ADDR_2542_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2542_reg)=data)
#define  get_ATSC_ADDR_2542_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2542_reg))
#define  ATSC_ADDR_2542_adj_ind_srrc_pol_shift                                   (7)
#define  ATSC_ADDR_2542_srrc_coeff_sel_auto_en_shift                             (6)
#define  ATSC_ADDR_2542_srrc_coeff_sel_auto1_shift                               (4)
#define  ATSC_ADDR_2542_srrc_coeff_sel_auto0_shift                               (2)
#define  ATSC_ADDR_2542_srrc_coeff_sel_shift                                     (0)
#define  ATSC_ADDR_2542_adj_ind_srrc_pol_mask                                    (0x00000080)
#define  ATSC_ADDR_2542_srrc_coeff_sel_auto_en_mask                              (0x00000040)
#define  ATSC_ADDR_2542_srrc_coeff_sel_auto1_mask                                (0x00000030)
#define  ATSC_ADDR_2542_srrc_coeff_sel_auto0_mask                                (0x0000000C)
#define  ATSC_ADDR_2542_srrc_coeff_sel_mask                                      (0x00000003)
#define  ATSC_ADDR_2542_adj_ind_srrc_pol(data)                                   (0x00000080&((data)<<7))
#define  ATSC_ADDR_2542_srrc_coeff_sel_auto_en(data)                             (0x00000040&((data)<<6))
#define  ATSC_ADDR_2542_srrc_coeff_sel_auto1(data)                               (0x00000030&((data)<<4))
#define  ATSC_ADDR_2542_srrc_coeff_sel_auto0(data)                               (0x0000000C&((data)<<2))
#define  ATSC_ADDR_2542_srrc_coeff_sel(data)                                     (0x00000003&(data))
#define  ATSC_ADDR_2542_get_adj_ind_srrc_pol(data)                               ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2542_get_srrc_coeff_sel_auto_en(data)                         ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2542_get_srrc_coeff_sel_auto1(data)                           ((0x00000030&(data))>>4)
#define  ATSC_ADDR_2542_get_srrc_coeff_sel_auto0(data)                           ((0x0000000C&(data))>>2)
#define  ATSC_ADDR_2542_get_srrc_coeff_sel(data)                                 (0x00000003&(data))

#define  ATSC_ADDR_2580                                                         0x18155600
#define  ATSC_ADDR_2580_reg_addr                                                 "0xB8155600"
#define  ATSC_ADDR_2580_reg                                                      0xB8155600
#define  ATSC_ADDR_2580_inst_addr                                                "0x014C"
#define  set_ATSC_ADDR_2580_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2580_reg)=data)
#define  get_ATSC_ADDR_2580_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2580_reg))
#define  ATSC_ADDR_2580_cr_comp_scale_exp_table1_shift                           (4)
#define  ATSC_ADDR_2580_cr_comp_scale_exp_table0_shift                           (0)
#define  ATSC_ADDR_2580_cr_comp_scale_exp_table1_mask                            (0x000000F0)
#define  ATSC_ADDR_2580_cr_comp_scale_exp_table0_mask                            (0x0000000F)
#define  ATSC_ADDR_2580_cr_comp_scale_exp_table1(data)                           (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2580_cr_comp_scale_exp_table0(data)                           (0x0000000F&(data))
#define  ATSC_ADDR_2580_get_cr_comp_scale_exp_table1(data)                       ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2580_get_cr_comp_scale_exp_table0(data)                       (0x0000000F&(data))

#define  ATSC_ADDR_2581                                                         0x18155604
#define  ATSC_ADDR_2581_reg_addr                                                 "0xB8155604"
#define  ATSC_ADDR_2581_reg                                                      0xB8155604
#define  ATSC_ADDR_2581_inst_addr                                                "0x014D"
#define  set_ATSC_ADDR_2581_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2581_reg)=data)
#define  get_ATSC_ADDR_2581_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2581_reg))
#define  ATSC_ADDR_2581_cr_comp_scale_exp_table3_shift                           (4)
#define  ATSC_ADDR_2581_cr_comp_scale_exp_table2_shift                           (0)
#define  ATSC_ADDR_2581_cr_comp_scale_exp_table3_mask                            (0x000000F0)
#define  ATSC_ADDR_2581_cr_comp_scale_exp_table2_mask                            (0x0000000F)
#define  ATSC_ADDR_2581_cr_comp_scale_exp_table3(data)                           (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2581_cr_comp_scale_exp_table2(data)                           (0x0000000F&(data))
#define  ATSC_ADDR_2581_get_cr_comp_scale_exp_table3(data)                       ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2581_get_cr_comp_scale_exp_table2(data)                       (0x0000000F&(data))

#define  ATSC_ADDR_2582                                                         0x18155608
#define  ATSC_ADDR_2582_reg_addr                                                 "0xB8155608"
#define  ATSC_ADDR_2582_reg                                                      0xB8155608
#define  ATSC_ADDR_2582_inst_addr                                                "0x014E"
#define  set_ATSC_ADDR_2582_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2582_reg)=data)
#define  get_ATSC_ADDR_2582_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2582_reg))
#define  ATSC_ADDR_2582_cr_comp_scale_exp_table5_shift                           (4)
#define  ATSC_ADDR_2582_cr_comp_scale_exp_table4_shift                           (0)
#define  ATSC_ADDR_2582_cr_comp_scale_exp_table5_mask                            (0x000000F0)
#define  ATSC_ADDR_2582_cr_comp_scale_exp_table4_mask                            (0x0000000F)
#define  ATSC_ADDR_2582_cr_comp_scale_exp_table5(data)                           (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2582_cr_comp_scale_exp_table4(data)                           (0x0000000F&(data))
#define  ATSC_ADDR_2582_get_cr_comp_scale_exp_table5(data)                       ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2582_get_cr_comp_scale_exp_table4(data)                       (0x0000000F&(data))

#define  ATSC_ADDR_2583                                                         0x1815560C
#define  ATSC_ADDR_2583_reg_addr                                                 "0xB815560C"
#define  ATSC_ADDR_2583_reg                                                      0xB815560C
#define  ATSC_ADDR_2583_inst_addr                                                "0x014F"
#define  set_ATSC_ADDR_2583_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2583_reg)=data)
#define  get_ATSC_ADDR_2583_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2583_reg))
#define  ATSC_ADDR_2583_cr_comp_scale_exp_table7_shift                           (4)
#define  ATSC_ADDR_2583_cr_comp_scale_exp_table6_shift                           (0)
#define  ATSC_ADDR_2583_cr_comp_scale_exp_table7_mask                            (0x000000F0)
#define  ATSC_ADDR_2583_cr_comp_scale_exp_table6_mask                            (0x0000000F)
#define  ATSC_ADDR_2583_cr_comp_scale_exp_table7(data)                           (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2583_cr_comp_scale_exp_table6(data)                           (0x0000000F&(data))
#define  ATSC_ADDR_2583_get_cr_comp_scale_exp_table7(data)                       ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2583_get_cr_comp_scale_exp_table6(data)                       (0x0000000F&(data))

#define  ATSC_ADDR_2584                                                         0x18155610
#define  ATSC_ADDR_2584_reg_addr                                                 "0xB8155610"
#define  ATSC_ADDR_2584_reg                                                      0xB8155610
#define  ATSC_ADDR_2584_inst_addr                                                "0x0150"
#define  set_ATSC_ADDR_2584_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2584_reg)=data)
#define  get_ATSC_ADDR_2584_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2584_reg))
#define  ATSC_ADDR_2584_cr_comp_scale_exp_table9_shift                           (4)
#define  ATSC_ADDR_2584_cr_comp_scale_exp_table8_shift                           (0)
#define  ATSC_ADDR_2584_cr_comp_scale_exp_table9_mask                            (0x000000F0)
#define  ATSC_ADDR_2584_cr_comp_scale_exp_table8_mask                            (0x0000000F)
#define  ATSC_ADDR_2584_cr_comp_scale_exp_table9(data)                           (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2584_cr_comp_scale_exp_table8(data)                           (0x0000000F&(data))
#define  ATSC_ADDR_2584_get_cr_comp_scale_exp_table9(data)                       ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2584_get_cr_comp_scale_exp_table8(data)                       (0x0000000F&(data))

#define  ATSC_ADDR_2585                                                         0x18155614
#define  ATSC_ADDR_2585_reg_addr                                                 "0xB8155614"
#define  ATSC_ADDR_2585_reg                                                      0xB8155614
#define  ATSC_ADDR_2585_inst_addr                                                "0x0151"
#define  set_ATSC_ADDR_2585_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2585_reg)=data)
#define  get_ATSC_ADDR_2585_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2585_reg))
#define  ATSC_ADDR_2585_cr_comp_scale_exp_table11_shift                          (4)
#define  ATSC_ADDR_2585_cr_comp_scale_exp_table10_shift                          (0)
#define  ATSC_ADDR_2585_cr_comp_scale_exp_table11_mask                           (0x000000F0)
#define  ATSC_ADDR_2585_cr_comp_scale_exp_table10_mask                           (0x0000000F)
#define  ATSC_ADDR_2585_cr_comp_scale_exp_table11(data)                          (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2585_cr_comp_scale_exp_table10(data)                          (0x0000000F&(data))
#define  ATSC_ADDR_2585_get_cr_comp_scale_exp_table11(data)                      ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2585_get_cr_comp_scale_exp_table10(data)                      (0x0000000F&(data))

#define  ATSC_ADDR_2586                                                         0x18155618
#define  ATSC_ADDR_2586_reg_addr                                                 "0xB8155618"
#define  ATSC_ADDR_2586_reg                                                      0xB8155618
#define  ATSC_ADDR_2586_inst_addr                                                "0x0152"
#define  set_ATSC_ADDR_2586_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2586_reg)=data)
#define  get_ATSC_ADDR_2586_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2586_reg))
#define  ATSC_ADDR_2586_cr_comp_scale_exp_table13_shift                          (4)
#define  ATSC_ADDR_2586_cr_comp_scale_exp_table12_shift                          (0)
#define  ATSC_ADDR_2586_cr_comp_scale_exp_table13_mask                           (0x000000F0)
#define  ATSC_ADDR_2586_cr_comp_scale_exp_table12_mask                           (0x0000000F)
#define  ATSC_ADDR_2586_cr_comp_scale_exp_table13(data)                          (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2586_cr_comp_scale_exp_table12(data)                          (0x0000000F&(data))
#define  ATSC_ADDR_2586_get_cr_comp_scale_exp_table13(data)                      ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2586_get_cr_comp_scale_exp_table12(data)                      (0x0000000F&(data))

#define  ATSC_ADDR_2587                                                         0x1815561C
#define  ATSC_ADDR_2587_reg_addr                                                 "0xB815561C"
#define  ATSC_ADDR_2587_reg                                                      0xB815561C
#define  ATSC_ADDR_2587_inst_addr                                                "0x0153"
#define  set_ATSC_ADDR_2587_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2587_reg)=data)
#define  get_ATSC_ADDR_2587_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2587_reg))
#define  ATSC_ADDR_2587_cr_comp_scale_exp_table15_shift                          (4)
#define  ATSC_ADDR_2587_cr_comp_scale_exp_table14_shift                          (0)
#define  ATSC_ADDR_2587_cr_comp_scale_exp_table15_mask                           (0x000000F0)
#define  ATSC_ADDR_2587_cr_comp_scale_exp_table14_mask                           (0x0000000F)
#define  ATSC_ADDR_2587_cr_comp_scale_exp_table15(data)                          (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2587_cr_comp_scale_exp_table14(data)                          (0x0000000F&(data))
#define  ATSC_ADDR_2587_get_cr_comp_scale_exp_table15(data)                      ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2587_get_cr_comp_scale_exp_table14(data)                      (0x0000000F&(data))

#define  ATSC_ADDR_2588                                                         0x18155620
#define  ATSC_ADDR_2588_reg_addr                                                 "0xB8155620"
#define  ATSC_ADDR_2588_reg                                                      0xB8155620
#define  ATSC_ADDR_2588_inst_addr                                                "0x0154"
#define  set_ATSC_ADDR_2588_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2588_reg)=data)
#define  get_ATSC_ADDR_2588_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2588_reg))
#define  ATSC_ADDR_2588_cr_comp_scale_exp_table17_shift                          (4)
#define  ATSC_ADDR_2588_cr_comp_scale_exp_table16_shift                          (0)
#define  ATSC_ADDR_2588_cr_comp_scale_exp_table17_mask                           (0x000000F0)
#define  ATSC_ADDR_2588_cr_comp_scale_exp_table16_mask                           (0x0000000F)
#define  ATSC_ADDR_2588_cr_comp_scale_exp_table17(data)                          (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2588_cr_comp_scale_exp_table16(data)                          (0x0000000F&(data))
#define  ATSC_ADDR_2588_get_cr_comp_scale_exp_table17(data)                      ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2588_get_cr_comp_scale_exp_table16(data)                      (0x0000000F&(data))

#define  ATSC_ADDR_2589                                                         0x18155624
#define  ATSC_ADDR_2589_reg_addr                                                 "0xB8155624"
#define  ATSC_ADDR_2589_reg                                                      0xB8155624
#define  ATSC_ADDR_2589_inst_addr                                                "0x0155"
#define  set_ATSC_ADDR_2589_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2589_reg)=data)
#define  get_ATSC_ADDR_2589_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2589_reg))
#define  ATSC_ADDR_2589_cr_comp_scale_exp_table19_shift                          (4)
#define  ATSC_ADDR_2589_cr_comp_scale_exp_table18_shift                          (0)
#define  ATSC_ADDR_2589_cr_comp_scale_exp_table19_mask                           (0x000000F0)
#define  ATSC_ADDR_2589_cr_comp_scale_exp_table18_mask                           (0x0000000F)
#define  ATSC_ADDR_2589_cr_comp_scale_exp_table19(data)                          (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2589_cr_comp_scale_exp_table18(data)                          (0x0000000F&(data))
#define  ATSC_ADDR_2589_get_cr_comp_scale_exp_table19(data)                      ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2589_get_cr_comp_scale_exp_table18(data)                      (0x0000000F&(data))

#define  ATSC_ADDR_258A                                                         0x18155628
#define  ATSC_ADDR_258A_reg_addr                                                 "0xB8155628"
#define  ATSC_ADDR_258A_reg                                                      0xB8155628
#define  ATSC_ADDR_258A_inst_addr                                                "0x0156"
#define  set_ATSC_ADDR_258A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_258A_reg)=data)
#define  get_ATSC_ADDR_258A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_258A_reg))
#define  ATSC_ADDR_258A_cr_comp_scale_exp_table21_shift                          (4)
#define  ATSC_ADDR_258A_cr_comp_scale_exp_table20_shift                          (0)
#define  ATSC_ADDR_258A_cr_comp_scale_exp_table21_mask                           (0x000000F0)
#define  ATSC_ADDR_258A_cr_comp_scale_exp_table20_mask                           (0x0000000F)
#define  ATSC_ADDR_258A_cr_comp_scale_exp_table21(data)                          (0x000000F0&((data)<<4))
#define  ATSC_ADDR_258A_cr_comp_scale_exp_table20(data)                          (0x0000000F&(data))
#define  ATSC_ADDR_258A_get_cr_comp_scale_exp_table21(data)                      ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_258A_get_cr_comp_scale_exp_table20(data)                      (0x0000000F&(data))

#define  ATSC_ADDR_258B                                                         0x1815562C
#define  ATSC_ADDR_258B_reg_addr                                                 "0xB815562C"
#define  ATSC_ADDR_258B_reg                                                      0xB815562C
#define  ATSC_ADDR_258B_inst_addr                                                "0x0157"
#define  set_ATSC_ADDR_258B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_258B_reg)=data)
#define  get_ATSC_ADDR_258B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_258B_reg))
#define  ATSC_ADDR_258B_cr_comp_scale_exp_table23_shift                          (4)
#define  ATSC_ADDR_258B_cr_comp_scale_exp_table22_shift                          (0)
#define  ATSC_ADDR_258B_cr_comp_scale_exp_table23_mask                           (0x000000F0)
#define  ATSC_ADDR_258B_cr_comp_scale_exp_table22_mask                           (0x0000000F)
#define  ATSC_ADDR_258B_cr_comp_scale_exp_table23(data)                          (0x000000F0&((data)<<4))
#define  ATSC_ADDR_258B_cr_comp_scale_exp_table22(data)                          (0x0000000F&(data))
#define  ATSC_ADDR_258B_get_cr_comp_scale_exp_table23(data)                      ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_258B_get_cr_comp_scale_exp_table22(data)                      (0x0000000F&(data))

#define  ATSC_ADDR_258C                                                         0x18155630
#define  ATSC_ADDR_258C_reg_addr                                                 "0xB8155630"
#define  ATSC_ADDR_258C_reg                                                      0xB8155630
#define  ATSC_ADDR_258C_inst_addr                                                "0x0158"
#define  set_ATSC_ADDR_258C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_258C_reg)=data)
#define  get_ATSC_ADDR_258C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_258C_reg))
#define  ATSC_ADDR_258C_cr_comp_scale_exp_table25_shift                          (4)
#define  ATSC_ADDR_258C_cr_comp_scale_exp_table24_shift                          (0)
#define  ATSC_ADDR_258C_cr_comp_scale_exp_table25_mask                           (0x000000F0)
#define  ATSC_ADDR_258C_cr_comp_scale_exp_table24_mask                           (0x0000000F)
#define  ATSC_ADDR_258C_cr_comp_scale_exp_table25(data)                          (0x000000F0&((data)<<4))
#define  ATSC_ADDR_258C_cr_comp_scale_exp_table24(data)                          (0x0000000F&(data))
#define  ATSC_ADDR_258C_get_cr_comp_scale_exp_table25(data)                      ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_258C_get_cr_comp_scale_exp_table24(data)                      (0x0000000F&(data))

#define  ATSC_ADDR_258D                                                         0x18155634
#define  ATSC_ADDR_258D_reg_addr                                                 "0xB8155634"
#define  ATSC_ADDR_258D_reg                                                      0xB8155634
#define  ATSC_ADDR_258D_inst_addr                                                "0x0159"
#define  set_ATSC_ADDR_258D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_258D_reg)=data)
#define  get_ATSC_ADDR_258D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_258D_reg))
#define  ATSC_ADDR_258D_cr_comp_scale_exp_table27_shift                          (4)
#define  ATSC_ADDR_258D_cr_comp_scale_exp_table26_shift                          (0)
#define  ATSC_ADDR_258D_cr_comp_scale_exp_table27_mask                           (0x000000F0)
#define  ATSC_ADDR_258D_cr_comp_scale_exp_table26_mask                           (0x0000000F)
#define  ATSC_ADDR_258D_cr_comp_scale_exp_table27(data)                          (0x000000F0&((data)<<4))
#define  ATSC_ADDR_258D_cr_comp_scale_exp_table26(data)                          (0x0000000F&(data))
#define  ATSC_ADDR_258D_get_cr_comp_scale_exp_table27(data)                      ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_258D_get_cr_comp_scale_exp_table26(data)                      (0x0000000F&(data))

#define  ATSC_ADDR_258E                                                         0x18155638
#define  ATSC_ADDR_258E_reg_addr                                                 "0xB8155638"
#define  ATSC_ADDR_258E_reg                                                      0xB8155638
#define  ATSC_ADDR_258E_inst_addr                                                "0x015A"
#define  set_ATSC_ADDR_258E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_258E_reg)=data)
#define  get_ATSC_ADDR_258E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_258E_reg))
#define  ATSC_ADDR_258E_cr_comp_scale_exp_table29_shift                          (4)
#define  ATSC_ADDR_258E_cr_comp_scale_exp_table28_shift                          (0)
#define  ATSC_ADDR_258E_cr_comp_scale_exp_table29_mask                           (0x000000F0)
#define  ATSC_ADDR_258E_cr_comp_scale_exp_table28_mask                           (0x0000000F)
#define  ATSC_ADDR_258E_cr_comp_scale_exp_table29(data)                          (0x000000F0&((data)<<4))
#define  ATSC_ADDR_258E_cr_comp_scale_exp_table28(data)                          (0x0000000F&(data))
#define  ATSC_ADDR_258E_get_cr_comp_scale_exp_table29(data)                      ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_258E_get_cr_comp_scale_exp_table28(data)                      (0x0000000F&(data))

#define  ATSC_ADDR_258F                                                         0x1815563C
#define  ATSC_ADDR_258F_reg_addr                                                 "0xB815563C"
#define  ATSC_ADDR_258F_reg                                                      0xB815563C
#define  ATSC_ADDR_258F_inst_addr                                                "0x015B"
#define  set_ATSC_ADDR_258F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_258F_reg)=data)
#define  get_ATSC_ADDR_258F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_258F_reg))
#define  ATSC_ADDR_258F_cr_comp_scale_exp_table31_shift                          (4)
#define  ATSC_ADDR_258F_cr_comp_scale_exp_table30_shift                          (0)
#define  ATSC_ADDR_258F_cr_comp_scale_exp_table31_mask                           (0x000000F0)
#define  ATSC_ADDR_258F_cr_comp_scale_exp_table30_mask                           (0x0000000F)
#define  ATSC_ADDR_258F_cr_comp_scale_exp_table31(data)                          (0x000000F0&((data)<<4))
#define  ATSC_ADDR_258F_cr_comp_scale_exp_table30(data)                          (0x0000000F&(data))
#define  ATSC_ADDR_258F_get_cr_comp_scale_exp_table31(data)                      ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_258F_get_cr_comp_scale_exp_table30(data)                      (0x0000000F&(data))

#define  ATSC_ADDR_2E41                                                         0x18157904
#define  ATSC_ADDR_2E41_reg_addr                                                 "0xB8157904"
#define  ATSC_ADDR_2E41_reg                                                      0xB8157904
#define  ATSC_ADDR_2E41_inst_addr                                                "0x015C"
#define  set_ATSC_ADDR_2E41_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E41_reg)=data)
#define  get_ATSC_ADDR_2E41_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E41_reg))
#define  ATSC_ADDR_2E41_cr_cr2_cr_offset_cnt_win_12_5_shift                      (0)
#define  ATSC_ADDR_2E41_cr_cr2_cr_offset_cnt_win_12_5_mask                       (0x000000FF)
#define  ATSC_ADDR_2E41_cr_cr2_cr_offset_cnt_win_12_5(data)                      (0x000000FF&(data))
#define  ATSC_ADDR_2E41_get_cr_cr2_cr_offset_cnt_win_12_5(data)                  (0x000000FF&(data))

#define  ATSC_ADDR_2E42                                                         0x18157908
#define  ATSC_ADDR_2E42_reg_addr                                                 "0xB8157908"
#define  ATSC_ADDR_2E42_reg                                                      0xB8157908
#define  ATSC_ADDR_2E42_inst_addr                                                "0x015D"
#define  set_ATSC_ADDR_2E42_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E42_reg)=data)
#define  get_ATSC_ADDR_2E42_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E42_reg))
#define  ATSC_ADDR_2E42_cr_cr2_cr_offset_dif_thd_0_shift                         (7)
#define  ATSC_ADDR_2E42_cr_cr2_cr_offset_cnt_win_18_13_shift                     (0)
#define  ATSC_ADDR_2E42_cr_cr2_cr_offset_dif_thd_0_mask                          (0x00000080)
#define  ATSC_ADDR_2E42_cr_cr2_cr_offset_cnt_win_18_13_mask                      (0x0000003F)
#define  ATSC_ADDR_2E42_cr_cr2_cr_offset_dif_thd_0(data)                         (0x00000080&((data)<<7))
#define  ATSC_ADDR_2E42_cr_cr2_cr_offset_cnt_win_18_13(data)                     (0x0000003F&(data))
#define  ATSC_ADDR_2E42_get_cr_cr2_cr_offset_dif_thd_0(data)                     ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2E42_get_cr_cr2_cr_offset_cnt_win_18_13(data)                 (0x0000003F&(data))

#define  ATSC_ADDR_2E43                                                         0x1815790C
#define  ATSC_ADDR_2E43_reg_addr                                                 "0xB815790C"
#define  ATSC_ADDR_2E43_reg                                                      0xB815790C
#define  ATSC_ADDR_2E43_inst_addr                                                "0x015E"
#define  set_ATSC_ADDR_2E43_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E43_reg)=data)
#define  get_ATSC_ADDR_2E43_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E43_reg))
#define  ATSC_ADDR_2E43_cr_cr2_cr_offset_dif_thd_8_1_shift                       (0)
#define  ATSC_ADDR_2E43_cr_cr2_cr_offset_dif_thd_8_1_mask                        (0x000000FF)
#define  ATSC_ADDR_2E43_cr_cr2_cr_offset_dif_thd_8_1(data)                       (0x000000FF&(data))
#define  ATSC_ADDR_2E43_get_cr_cr2_cr_offset_dif_thd_8_1(data)                   (0x000000FF&(data))

#define  ATSC_ADDR_2E44                                                         0x18157910
#define  ATSC_ADDR_2E44_reg_addr                                                 "0xB8157910"
#define  ATSC_ADDR_2E44_reg                                                      0xB8157910
#define  ATSC_ADDR_2E44_inst_addr                                                "0x015F"
#define  set_ATSC_ADDR_2E44_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E44_reg)=data)
#define  get_ATSC_ADDR_2E44_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E44_reg))
#define  ATSC_ADDR_2E44_cr_cr2_cr_offset_dif_thd_16_9_shift                      (0)
#define  ATSC_ADDR_2E44_cr_cr2_cr_offset_dif_thd_16_9_mask                       (0x000000FF)
#define  ATSC_ADDR_2E44_cr_cr2_cr_offset_dif_thd_16_9(data)                      (0x000000FF&(data))
#define  ATSC_ADDR_2E44_get_cr_cr2_cr_offset_dif_thd_16_9(data)                  (0x000000FF&(data))

#define  ATSC_ADDR_2E45                                                         0x18157914
#define  ATSC_ADDR_2E45_reg_addr                                                 "0xB8157914"
#define  ATSC_ADDR_2E45_reg                                                      0xB8157914
#define  ATSC_ADDR_2E45_inst_addr                                                "0x0160"
#define  set_ATSC_ADDR_2E45_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E45_reg)=data)
#define  get_ATSC_ADDR_2E45_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E45_reg))
#define  ATSC_ADDR_2E45_cr_cr2_cr_offset_dif_thd_24_17_shift                     (0)
#define  ATSC_ADDR_2E45_cr_cr2_cr_offset_dif_thd_24_17_mask                      (0x000000FF)
#define  ATSC_ADDR_2E45_cr_cr2_cr_offset_dif_thd_24_17(data)                     (0x000000FF&(data))
#define  ATSC_ADDR_2E45_get_cr_cr2_cr_offset_dif_thd_24_17(data)                 (0x000000FF&(data))

#define  ATSC_ADDR_2E46                                                         0x18157918
#define  ATSC_ADDR_2E46_reg_addr                                                 "0xB8157918"
#define  ATSC_ADDR_2E46_reg                                                      0xB8157918
#define  ATSC_ADDR_2E46_inst_addr                                                "0x0161"
#define  set_ATSC_ADDR_2E46_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E46_reg)=data)
#define  get_ATSC_ADDR_2E46_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E46_reg))
#define  ATSC_ADDR_2E46_cr_cr2_cr_offset_dif_thd_32_25_shift                     (0)
#define  ATSC_ADDR_2E46_cr_cr2_cr_offset_dif_thd_32_25_mask                      (0x000000FF)
#define  ATSC_ADDR_2E46_cr_cr2_cr_offset_dif_thd_32_25(data)                     (0x000000FF&(data))
#define  ATSC_ADDR_2E46_get_cr_cr2_cr_offset_dif_thd_32_25(data)                 (0x000000FF&(data))

#define  ATSC_ADDR_2E47                                                         0x1815791C
#define  ATSC_ADDR_2E47_reg_addr                                                 "0xB815791C"
#define  ATSC_ADDR_2E47_reg                                                      0xB815791C
#define  ATSC_ADDR_2E47_inst_addr                                                "0x0162"
#define  set_ATSC_ADDR_2E47_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E47_reg)=data)
#define  get_ATSC_ADDR_2E47_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E47_reg))
#define  ATSC_ADDR_2E47_cr_cr2_cr_offset_large_cnt_max_shift                     (0)
#define  ATSC_ADDR_2E47_cr_cr2_cr_offset_large_cnt_max_mask                      (0x000000FF)
#define  ATSC_ADDR_2E47_cr_cr2_cr_offset_large_cnt_max(data)                     (0x000000FF&(data))
#define  ATSC_ADDR_2E47_get_cr_cr2_cr_offset_large_cnt_max(data)                 (0x000000FF&(data))

#define  ATSC_ADDR_2E48                                                         0x18157920
#define  ATSC_ADDR_2E48_reg_addr                                                 "0xB8157920"
#define  ATSC_ADDR_2E48_reg                                                      0xB8157920
#define  ATSC_ADDR_2E48_inst_addr                                                "0x0163"
#define  set_ATSC_ADDR_2E48_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E48_reg)=data)
#define  get_ATSC_ADDR_2E48_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E48_reg))
#define  ATSC_ADDR_2E48_cr_cr2_cr_offset_large_cnt_thd_shift                     (0)
#define  ATSC_ADDR_2E48_cr_cr2_cr_offset_large_cnt_thd_mask                      (0x000000FF)
#define  ATSC_ADDR_2E48_cr_cr2_cr_offset_large_cnt_thd(data)                     (0x000000FF&(data))
#define  ATSC_ADDR_2E48_get_cr_cr2_cr_offset_large_cnt_thd(data)                 (0x000000FF&(data))

#define  ATSC_ADDR_2E49                                                         0x18157924
#define  ATSC_ADDR_2E49_reg_addr                                                 "0xB8157924"
#define  ATSC_ADDR_2E49_reg                                                      0xB8157924
#define  ATSC_ADDR_2E49_inst_addr                                                "0x0164"
#define  set_ATSC_ADDR_2E49_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E49_reg)=data)
#define  get_ATSC_ADDR_2E49_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E49_reg))
#define  ATSC_ADDR_2E49_cr_cr2_cr_offset_large_cnt_dec_shift                     (3)
#define  ATSC_ADDR_2E49_cr_cr2_cr_offset_large_cnt_inc_2_0_shift                 (0)
#define  ATSC_ADDR_2E49_cr_cr2_cr_offset_large_cnt_dec_mask                      (0x00000038)
#define  ATSC_ADDR_2E49_cr_cr2_cr_offset_large_cnt_inc_2_0_mask                  (0x00000007)
#define  ATSC_ADDR_2E49_cr_cr2_cr_offset_large_cnt_dec(data)                     (0x00000038&((data)<<3))
#define  ATSC_ADDR_2E49_cr_cr2_cr_offset_large_cnt_inc_2_0(data)                 (0x00000007&(data))
#define  ATSC_ADDR_2E49_get_cr_cr2_cr_offset_large_cnt_dec(data)                 ((0x00000038&(data))>>3)
#define  ATSC_ADDR_2E49_get_cr_cr2_cr_offset_large_cnt_inc_2_0(data)             (0x00000007&(data))

#define  ATSC_ADDR_2E50                                                         0x18157940
#define  ATSC_ADDR_2E50_reg_addr                                                 "0xB8157940"
#define  ATSC_ADDR_2E50_reg                                                      0xB8157940
#define  ATSC_ADDR_2E50_inst_addr                                                "0x0165"
#define  set_ATSC_ADDR_2E50_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E50_reg)=data)
#define  get_ATSC_ADDR_2E50_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E50_reg))
#define  ATSC_ADDR_2E50_cr_fmu_cr2_nb_comp_2_0_shift                             (5)
#define  ATSC_ADDR_2E50_cr_cr2_cr_offset_large_cnt_inc_7_3_shift                 (0)
#define  ATSC_ADDR_2E50_cr_fmu_cr2_nb_comp_2_0_mask                              (0x000000E0)
#define  ATSC_ADDR_2E50_cr_cr2_cr_offset_large_cnt_inc_7_3_mask                  (0x0000001F)
#define  ATSC_ADDR_2E50_cr_fmu_cr2_nb_comp_2_0(data)                             (0x000000E0&((data)<<5))
#define  ATSC_ADDR_2E50_cr_cr2_cr_offset_large_cnt_inc_7_3(data)                 (0x0000001F&(data))
#define  ATSC_ADDR_2E50_get_cr_fmu_cr2_nb_comp_2_0(data)                         ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_2E50_get_cr_cr2_cr_offset_large_cnt_inc_7_3(data)             (0x0000001F&(data))

#define  ATSC_ADDR_2E4A                                                         0x18157928
#define  ATSC_ADDR_2E4A_reg_addr                                                 "0xB8157928"
#define  ATSC_ADDR_2E4A_reg                                                      0xB8157928
#define  ATSC_ADDR_2E4A_inst_addr                                                "0x0166"
#define  set_ATSC_ADDR_2E4A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E4A_reg)=data)
#define  get_ATSC_ADDR_2E4A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E4A_reg))
#define  ATSC_ADDR_2E4A_cr_cr2_cargp_nb_shift                                    (4)
#define  ATSC_ADDR_2E4A_cr_cr2_cargp_wb_shift                                    (0)
#define  ATSC_ADDR_2E4A_cr_cr2_cargp_nb_mask                                     (0x000000F0)
#define  ATSC_ADDR_2E4A_cr_cr2_cargp_wb_mask                                     (0x0000000F)
#define  ATSC_ADDR_2E4A_cr_cr2_cargp_nb(data)                                    (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2E4A_cr_cr2_cargp_wb(data)                                    (0x0000000F&(data))
#define  ATSC_ADDR_2E4A_get_cr_cr2_cargp_nb(data)                                ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2E4A_get_cr_cr2_cargp_wb(data)                                (0x0000000F&(data))

#define  ATSC_ADDR_2E4B                                                         0x1815792C
#define  ATSC_ADDR_2E4B_reg_addr                                                 "0xB815792C"
#define  ATSC_ADDR_2E4B_reg                                                      0xB815792C
#define  ATSC_ADDR_2E4B_inst_addr                                                "0x0167"
#define  set_ATSC_ADDR_2E4B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E4B_reg)=data)
#define  get_ATSC_ADDR_2E4B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E4B_reg))
#define  ATSC_ADDR_2E4B_cr_cr2_cr_offset_dif_7_0_shift                           (0)
#define  ATSC_ADDR_2E4B_cr_cr2_cr_offset_dif_7_0_mask                            (0x000000FF)
#define  ATSC_ADDR_2E4B_cr_cr2_cr_offset_dif_7_0(data)                           (0x000000FF&(data))
#define  ATSC_ADDR_2E4B_get_cr_cr2_cr_offset_dif_7_0(data)                       (0x000000FF&(data))

#define  ATSC_ADDR_2E4C                                                         0x18157930
#define  ATSC_ADDR_2E4C_reg_addr                                                 "0xB8157930"
#define  ATSC_ADDR_2E4C_reg                                                      0xB8157930
#define  ATSC_ADDR_2E4C_inst_addr                                                "0x0168"
#define  set_ATSC_ADDR_2E4C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E4C_reg)=data)
#define  get_ATSC_ADDR_2E4C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E4C_reg))
#define  ATSC_ADDR_2E4C_cr_cr2_cr_offset_dif_15_8_shift                          (0)
#define  ATSC_ADDR_2E4C_cr_cr2_cr_offset_dif_15_8_mask                           (0x000000FF)
#define  ATSC_ADDR_2E4C_cr_cr2_cr_offset_dif_15_8(data)                          (0x000000FF&(data))
#define  ATSC_ADDR_2E4C_get_cr_cr2_cr_offset_dif_15_8(data)                      (0x000000FF&(data))

#define  ATSC_ADDR_2E4D                                                         0x18157934
#define  ATSC_ADDR_2E4D_reg_addr                                                 "0xB8157934"
#define  ATSC_ADDR_2E4D_reg                                                      0xB8157934
#define  ATSC_ADDR_2E4D_inst_addr                                                "0x0169"
#define  set_ATSC_ADDR_2E4D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E4D_reg)=data)
#define  get_ATSC_ADDR_2E4D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E4D_reg))
#define  ATSC_ADDR_2E4D_cr_cr2_cr_offset_dif_23_16_shift                         (0)
#define  ATSC_ADDR_2E4D_cr_cr2_cr_offset_dif_23_16_mask                          (0x000000FF)
#define  ATSC_ADDR_2E4D_cr_cr2_cr_offset_dif_23_16(data)                         (0x000000FF&(data))
#define  ATSC_ADDR_2E4D_get_cr_cr2_cr_offset_dif_23_16(data)                     (0x000000FF&(data))

#define  ATSC_ADDR_2E4E                                                         0x18157938
#define  ATSC_ADDR_2E4E_reg_addr                                                 "0xB8157938"
#define  ATSC_ADDR_2E4E_reg                                                      0xB8157938
#define  ATSC_ADDR_2E4E_inst_addr                                                "0x016A"
#define  set_ATSC_ADDR_2E4E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E4E_reg)=data)
#define  get_ATSC_ADDR_2E4E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E4E_reg))
#define  ATSC_ADDR_2E4E_cr_cr2_cr_offset_dif_31_24_shift                         (0)
#define  ATSC_ADDR_2E4E_cr_cr2_cr_offset_dif_31_24_mask                          (0x000000FF)
#define  ATSC_ADDR_2E4E_cr_cr2_cr_offset_dif_31_24(data)                         (0x000000FF&(data))
#define  ATSC_ADDR_2E4E_get_cr_cr2_cr_offset_dif_31_24(data)                     (0x000000FF&(data))

#define  ATSC_ADDR_2E4F                                                         0x1815793C
#define  ATSC_ADDR_2E4F_reg_addr                                                 "0xB815793C"
#define  ATSC_ADDR_2E4F_reg                                                      0xB815793C
#define  ATSC_ADDR_2E4F_inst_addr                                                "0x016B"
#define  set_ATSC_ADDR_2E4F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E4F_reg)=data)
#define  get_ATSC_ADDR_2E4F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E4F_reg))
#define  ATSC_ADDR_2E4F_cr_cr2_cr_offset_dif_32_shift                            (0)
#define  ATSC_ADDR_2E4F_cr_cr2_cr_offset_dif_32_mask                             (0x00000001)
#define  ATSC_ADDR_2E4F_cr_cr2_cr_offset_dif_32(data)                            (0x00000001&(data))
#define  ATSC_ADDR_2E4F_get_cr_cr2_cr_offset_dif_32(data)                        (0x00000001&(data))

#define  ATSC_ADDR_25A0                                                         0x18155680
#define  ATSC_ADDR_25A0_reg_addr                                                 "0xB8155680"
#define  ATSC_ADDR_25A0_reg                                                      0xB8155680
#define  ATSC_ADDR_25A0_inst_addr                                                "0x016C"
#define  set_ATSC_ADDR_25A0_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_25A0_reg)=data)
#define  get_ATSC_ADDR_25A0_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_25A0_reg))
#define  ATSC_ADDR_25A0_cr_fmu_upd_opt_shift                                     (4)
#define  ATSC_ADDR_25A0_cr_lpf_var_s0_floor_en_shift                             (0)
#define  ATSC_ADDR_25A0_cr_fmu_upd_opt_mask                                      (0x00000070)
#define  ATSC_ADDR_25A0_cr_lpf_var_s0_floor_en_mask                              (0x00000001)
#define  ATSC_ADDR_25A0_cr_fmu_upd_opt(data)                                     (0x00000070&((data)<<4))
#define  ATSC_ADDR_25A0_cr_lpf_var_s0_floor_en(data)                             (0x00000001&(data))
#define  ATSC_ADDR_25A0_get_cr_fmu_upd_opt(data)                                 ((0x00000070&(data))>>4)
#define  ATSC_ADDR_25A0_get_cr_lpf_var_s0_floor_en(data)                         (0x00000001&(data))

#define  ATSC_ADDR_25A1                                                         0x18155684
#define  ATSC_ADDR_25A1_reg_addr                                                 "0xB8155684"
#define  ATSC_ADDR_25A1_reg                                                      0xB8155684
#define  ATSC_ADDR_25A1_inst_addr                                                "0x016D"
#define  set_ATSC_ADDR_25A1_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_25A1_reg)=data)
#define  get_ATSC_ADDR_25A1_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_25A1_reg))
#define  ATSC_ADDR_25A1_cr_lpf_2_a_exp_reg1_shift                                (5)
#define  ATSC_ADDR_25A1_cr_lpf_2_a_exp_reg0_shift                                (2)
#define  ATSC_ADDR_25A1_cr_lpf_2_a_exp_reg1_mask                                 (0x000000E0)
#define  ATSC_ADDR_25A1_cr_lpf_2_a_exp_reg0_mask                                 (0x0000001C)
#define  ATSC_ADDR_25A1_cr_lpf_2_a_exp_reg1(data)                                (0x000000E0&((data)<<5))
#define  ATSC_ADDR_25A1_cr_lpf_2_a_exp_reg0(data)                                (0x0000001C&((data)<<2))
#define  ATSC_ADDR_25A1_get_cr_lpf_2_a_exp_reg1(data)                            ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_25A1_get_cr_lpf_2_a_exp_reg0(data)                            ((0x0000001C&(data))>>2)

#define  ATSC_ADDR_25A2                                                         0x18155688
#define  ATSC_ADDR_25A2_reg_addr                                                 "0xB8155688"
#define  ATSC_ADDR_25A2_reg                                                      0xB8155688
#define  ATSC_ADDR_25A2_inst_addr                                                "0x016E"
#define  set_ATSC_ADDR_25A2_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_25A2_reg)=data)
#define  get_ATSC_ADDR_25A2_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_25A2_reg))
#define  ATSC_ADDR_25A2_cr_lpf_2_b_exp_reg0_shift                                (3)
#define  ATSC_ADDR_25A2_cr_lpf_2_b_exp_reg0_mask                                 (0x00000038)
#define  ATSC_ADDR_25A2_cr_lpf_2_b_exp_reg0(data)                                (0x00000038&((data)<<3))
#define  ATSC_ADDR_25A2_get_cr_lpf_2_b_exp_reg0(data)                            ((0x00000038&(data))>>3)

#define  ATSC_ADDR_25A3                                                         0x1815568C
#define  ATSC_ADDR_25A3_reg_addr                                                 "0xB815568C"
#define  ATSC_ADDR_25A3_reg                                                      0xB815568C
#define  ATSC_ADDR_25A3_inst_addr                                                "0x016F"
#define  set_ATSC_ADDR_25A3_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_25A3_reg)=data)
#define  get_ATSC_ADDR_25A3_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_25A3_reg))
#define  ATSC_ADDR_25A3_cr_lpf_shift_en_shift                                    (7)
#define  ATSC_ADDR_25A3_cr_lpf_2_b_exp_reg1_shift                                (0)
#define  ATSC_ADDR_25A3_cr_lpf_shift_en_mask                                     (0x00000080)
#define  ATSC_ADDR_25A3_cr_lpf_2_b_exp_reg1_mask                                 (0x00000007)
#define  ATSC_ADDR_25A3_cr_lpf_shift_en(data)                                    (0x00000080&((data)<<7))
#define  ATSC_ADDR_25A3_cr_lpf_2_b_exp_reg1(data)                                (0x00000007&(data))
#define  ATSC_ADDR_25A3_get_cr_lpf_shift_en(data)                                ((0x00000080&(data))>>7)
#define  ATSC_ADDR_25A3_get_cr_lpf_2_b_exp_reg1(data)                            (0x00000007&(data))

#define  ATSC_ADDR_25A4                                                         0x18155690
#define  ATSC_ADDR_25A4_reg_addr                                                 "0xB8155690"
#define  ATSC_ADDR_25A4_reg                                                      0xB8155690
#define  ATSC_ADDR_25A4_inst_addr                                                "0x0170"
#define  set_ATSC_ADDR_25A4_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_25A4_reg)=data)
#define  get_ATSC_ADDR_25A4_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_25A4_reg))
#define  ATSC_ADDR_25A4_cr_comp_scale_en_sel_shift                               (4)
#define  ATSC_ADDR_25A4_cr_comp_input_sel1_shift                                 (0)
#define  ATSC_ADDR_25A4_cr_comp_scale_en_sel_mask                                (0x00000070)
#define  ATSC_ADDR_25A4_cr_comp_input_sel1_mask                                  (0x00000007)
#define  ATSC_ADDR_25A4_cr_comp_scale_en_sel(data)                               (0x00000070&((data)<<4))
#define  ATSC_ADDR_25A4_cr_comp_input_sel1(data)                                 (0x00000007&(data))
#define  ATSC_ADDR_25A4_get_cr_comp_scale_en_sel(data)                           ((0x00000070&(data))>>4)
#define  ATSC_ADDR_25A4_get_cr_comp_input_sel1(data)                             (0x00000007&(data))

#define  ATSC_ADDR_25A5                                                         0x18155694
#define  ATSC_ADDR_25A5_reg_addr                                                 "0xB8155694"
#define  ATSC_ADDR_25A5_reg                                                      0xB8155694
#define  ATSC_ADDR_25A5_inst_addr                                                "0x0171"
#define  set_ATSC_ADDR_25A5_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_25A5_reg)=data)
#define  get_ATSC_ADDR_25A5_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_25A5_reg))
#define  ATSC_ADDR_25A5_cr_dr1_im_pwr_alpha_shift                                (7)
#define  ATSC_ADDR_25A5_cr_comp_go_cond2_en_shift                                (5)
#define  ATSC_ADDR_25A5_cr_comp_go_cond1_en_shift                                (4)
#define  ATSC_ADDR_25A5_cr_comp_exp_max_shift                                    (0)
#define  ATSC_ADDR_25A5_cr_dr1_im_pwr_alpha_mask                                 (0x00000080)
#define  ATSC_ADDR_25A5_cr_comp_go_cond2_en_mask                                 (0x00000020)
#define  ATSC_ADDR_25A5_cr_comp_go_cond1_en_mask                                 (0x00000010)
#define  ATSC_ADDR_25A5_cr_comp_exp_max_mask                                     (0x00000007)
#define  ATSC_ADDR_25A5_cr_dr1_im_pwr_alpha(data)                                (0x00000080&((data)<<7))
#define  ATSC_ADDR_25A5_cr_comp_go_cond2_en(data)                                (0x00000020&((data)<<5))
#define  ATSC_ADDR_25A5_cr_comp_go_cond1_en(data)                                (0x00000010&((data)<<4))
#define  ATSC_ADDR_25A5_cr_comp_exp_max(data)                                    (0x00000007&(data))
#define  ATSC_ADDR_25A5_get_cr_dr1_im_pwr_alpha(data)                            ((0x00000080&(data))>>7)
#define  ATSC_ADDR_25A5_get_cr_comp_go_cond2_en(data)                            ((0x00000020&(data))>>5)
#define  ATSC_ADDR_25A5_get_cr_comp_go_cond1_en(data)                            ((0x00000010&(data))>>4)
#define  ATSC_ADDR_25A5_get_cr_comp_exp_max(data)                                (0x00000007&(data))

#define  ATSC_ADDR_25A6                                                         0x18155698
#define  ATSC_ADDR_25A6_reg_addr                                                 "0xB8155698"
#define  ATSC_ADDR_25A6_reg                                                      0xB8155698
#define  ATSC_ADDR_25A6_inst_addr                                                "0x0172"
#define  set_ATSC_ADDR_25A6_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_25A6_reg)=data)
#define  get_ATSC_ADDR_25A6_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_25A6_reg))
#define  ATSC_ADDR_25A6_cr_dr1_mean_alpha_shift                                  (6)
#define  ATSC_ADDR_25A6_cr_dr1_im_hpf_alpha_shift                                (4)
#define  ATSC_ADDR_25A6_cr_dr1_im_lpf_alpha2_shift                               (2)
#define  ATSC_ADDR_25A6_cr_dr1_im_lpf_alpha1_shift                               (0)
#define  ATSC_ADDR_25A6_cr_dr1_mean_alpha_mask                                   (0x000000C0)
#define  ATSC_ADDR_25A6_cr_dr1_im_hpf_alpha_mask                                 (0x00000030)
#define  ATSC_ADDR_25A6_cr_dr1_im_lpf_alpha2_mask                                (0x0000000C)
#define  ATSC_ADDR_25A6_cr_dr1_im_lpf_alpha1_mask                                (0x00000003)
#define  ATSC_ADDR_25A6_cr_dr1_mean_alpha(data)                                  (0x000000C0&((data)<<6))
#define  ATSC_ADDR_25A6_cr_dr1_im_hpf_alpha(data)                                (0x00000030&((data)<<4))
#define  ATSC_ADDR_25A6_cr_dr1_im_lpf_alpha2(data)                               (0x0000000C&((data)<<2))
#define  ATSC_ADDR_25A6_cr_dr1_im_lpf_alpha1(data)                               (0x00000003&(data))
#define  ATSC_ADDR_25A6_get_cr_dr1_mean_alpha(data)                              ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_25A6_get_cr_dr1_im_hpf_alpha(data)                            ((0x00000030&(data))>>4)
#define  ATSC_ADDR_25A6_get_cr_dr1_im_lpf_alpha2(data)                           ((0x0000000C&(data))>>2)
#define  ATSC_ADDR_25A6_get_cr_dr1_im_lpf_alpha1(data)                           (0x00000003&(data))

#define  ATSC_ADDR_25A7                                                         0x1815569C
#define  ATSC_ADDR_25A7_reg_addr                                                 "0xB815569C"
#define  ATSC_ADDR_25A7_reg                                                      0xB815569C
#define  ATSC_ADDR_25A7_inst_addr                                                "0x0173"
#define  set_ATSC_ADDR_25A7_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_25A7_reg)=data)
#define  get_ATSC_ADDR_25A7_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_25A7_reg))
#define  ATSC_ADDR_25A7_cr_fmu_upd_cnt_th_shift                                  (0)
#define  ATSC_ADDR_25A7_cr_fmu_upd_cnt_th_mask                                   (0x000000FF)
#define  ATSC_ADDR_25A7_cr_fmu_upd_cnt_th(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_25A7_get_cr_fmu_upd_cnt_th(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_25A8                                                         0x181556A0
#define  ATSC_ADDR_25A8_reg_addr                                                 "0xB81556A0"
#define  ATSC_ADDR_25A8_reg                                                      0xB81556A0
#define  ATSC_ADDR_25A8_inst_addr                                                "0x0174"
#define  set_ATSC_ADDR_25A8_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_25A8_reg)=data)
#define  get_ATSC_ADDR_25A8_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_25A8_reg))
#define  ATSC_ADDR_25A8_cr_snr_ind1_th_7_0_shift                                 (0)
#define  ATSC_ADDR_25A8_cr_snr_ind1_th_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_25A8_cr_snr_ind1_th_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_25A8_get_cr_snr_ind1_th_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_25A9                                                         0x181556A4
#define  ATSC_ADDR_25A9_reg_addr                                                 "0xB81556A4"
#define  ATSC_ADDR_25A9_reg                                                      0xB81556A4
#define  ATSC_ADDR_25A9_inst_addr                                                "0x0175"
#define  set_ATSC_ADDR_25A9_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_25A9_reg)=data)
#define  get_ATSC_ADDR_25A9_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_25A9_reg))
#define  ATSC_ADDR_25A9_cr_snr_ind1_th_15_8_shift                                (0)
#define  ATSC_ADDR_25A9_cr_snr_ind1_th_15_8_mask                                 (0x000000FF)
#define  ATSC_ADDR_25A9_cr_snr_ind1_th_15_8(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_25A9_get_cr_snr_ind1_th_15_8(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_25AA                                                         0x181556A8
#define  ATSC_ADDR_25AA_reg_addr                                                 "0xB81556A8"
#define  ATSC_ADDR_25AA_reg                                                      0xB81556A8
#define  ATSC_ADDR_25AA_inst_addr                                                "0x0176"
#define  set_ATSC_ADDR_25AA_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_25AA_reg)=data)
#define  get_ATSC_ADDR_25AA_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_25AA_reg))
#define  ATSC_ADDR_25AA_cr_snr_ind2_th_7_0_shift                                 (0)
#define  ATSC_ADDR_25AA_cr_snr_ind2_th_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_25AA_cr_snr_ind2_th_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_25AA_get_cr_snr_ind2_th_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_25AB                                                         0x181556AC
#define  ATSC_ADDR_25AB_reg_addr                                                 "0xB81556AC"
#define  ATSC_ADDR_25AB_reg                                                      0xB81556AC
#define  ATSC_ADDR_25AB_inst_addr                                                "0x0177"
#define  set_ATSC_ADDR_25AB_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_25AB_reg)=data)
#define  get_ATSC_ADDR_25AB_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_25AB_reg))
#define  ATSC_ADDR_25AB_cr_snr_ind2_th_15_8_shift                                (0)
#define  ATSC_ADDR_25AB_cr_snr_ind2_th_15_8_mask                                 (0x000000FF)
#define  ATSC_ADDR_25AB_cr_snr_ind2_th_15_8(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_25AB_get_cr_snr_ind2_th_15_8(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_25AC                                                         0x181556B0
#define  ATSC_ADDR_25AC_reg_addr                                                 "0xB81556B0"
#define  ATSC_ADDR_25AC_reg                                                      0xB81556B0
#define  ATSC_ADDR_25AC_inst_addr                                                "0x0178"
#define  set_ATSC_ADDR_25AC_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_25AC_reg)=data)
#define  get_ATSC_ADDR_25AC_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_25AC_reg))
#define  ATSC_ADDR_25AC_cr_pilot_cnr_th_exp2_shift                               (4)
#define  ATSC_ADDR_25AC_cr_pilot_cnr_th_exp1_shift                               (0)
#define  ATSC_ADDR_25AC_cr_pilot_cnr_th_exp2_mask                                (0x000000F0)
#define  ATSC_ADDR_25AC_cr_pilot_cnr_th_exp1_mask                                (0x0000000F)
#define  ATSC_ADDR_25AC_cr_pilot_cnr_th_exp2(data)                               (0x000000F0&((data)<<4))
#define  ATSC_ADDR_25AC_cr_pilot_cnr_th_exp1(data)                               (0x0000000F&(data))
#define  ATSC_ADDR_25AC_get_cr_pilot_cnr_th_exp2(data)                           ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_25AC_get_cr_pilot_cnr_th_exp1(data)                           (0x0000000F&(data))

#define  ATSC_ADDR_25AD                                                         0x181556B4
#define  ATSC_ADDR_25AD_reg_addr                                                 "0xB81556B4"
#define  ATSC_ADDR_25AD_reg                                                      0xB81556B4
#define  ATSC_ADDR_25AD_inst_addr                                                "0x0179"
#define  set_ATSC_ADDR_25AD_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_25AD_reg)=data)
#define  get_ATSC_ADDR_25AD_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_25AD_reg))
#define  ATSC_ADDR_25AD_cr_pilot_cnr_th_exp4_shift                               (4)
#define  ATSC_ADDR_25AD_cr_pilot_cnr_th_exp3_shift                               (0)
#define  ATSC_ADDR_25AD_cr_pilot_cnr_th_exp4_mask                                (0x000000F0)
#define  ATSC_ADDR_25AD_cr_pilot_cnr_th_exp3_mask                                (0x0000000F)
#define  ATSC_ADDR_25AD_cr_pilot_cnr_th_exp4(data)                               (0x000000F0&((data)<<4))
#define  ATSC_ADDR_25AD_cr_pilot_cnr_th_exp3(data)                               (0x0000000F&(data))
#define  ATSC_ADDR_25AD_get_cr_pilot_cnr_th_exp4(data)                           ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_25AD_get_cr_pilot_cnr_th_exp3(data)                           (0x0000000F&(data))

#define  ATSC_ADDR_25AE                                                         0x181556B8
#define  ATSC_ADDR_25AE_reg_addr                                                 "0xB81556B8"
#define  ATSC_ADDR_25AE_reg                                                      0xB81556B8
#define  ATSC_ADDR_25AE_inst_addr                                                "0x017A"
#define  set_ATSC_ADDR_25AE_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_25AE_reg)=data)
#define  get_ATSC_ADDR_25AE_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_25AE_reg))
#define  ATSC_ADDR_25AE_cr_pilot_cnr_th_exp6_shift                               (4)
#define  ATSC_ADDR_25AE_cr_pilot_cnr_th_exp5_shift                               (0)
#define  ATSC_ADDR_25AE_cr_pilot_cnr_th_exp6_mask                                (0x000000F0)
#define  ATSC_ADDR_25AE_cr_pilot_cnr_th_exp5_mask                                (0x0000000F)
#define  ATSC_ADDR_25AE_cr_pilot_cnr_th_exp6(data)                               (0x000000F0&((data)<<4))
#define  ATSC_ADDR_25AE_cr_pilot_cnr_th_exp5(data)                               (0x0000000F&(data))
#define  ATSC_ADDR_25AE_get_cr_pilot_cnr_th_exp6(data)                           ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_25AE_get_cr_pilot_cnr_th_exp5(data)                           (0x0000000F&(data))

#define  ATSC_ADDR_25AF                                                         0x181556BC
#define  ATSC_ADDR_25AF_reg_addr                                                 "0xB81556BC"
#define  ATSC_ADDR_25AF_reg                                                      0xB81556BC
#define  ATSC_ADDR_25AF_inst_addr                                                "0x017B"
#define  set_ATSC_ADDR_25AF_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_25AF_reg)=data)
#define  get_ATSC_ADDR_25AF_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_25AF_reg))
#define  ATSC_ADDR_25AF_cr_lpf_shift_3_0_shift                                   (4)
#define  ATSC_ADDR_25AF_cr_pilot_cnr_th_exp7_shift                               (0)
#define  ATSC_ADDR_25AF_cr_lpf_shift_3_0_mask                                    (0x000000F0)
#define  ATSC_ADDR_25AF_cr_pilot_cnr_th_exp7_mask                                (0x0000000F)
#define  ATSC_ADDR_25AF_cr_lpf_shift_3_0(data)                                   (0x000000F0&((data)<<4))
#define  ATSC_ADDR_25AF_cr_pilot_cnr_th_exp7(data)                               (0x0000000F&(data))
#define  ATSC_ADDR_25AF_get_cr_lpf_shift_3_0(data)                               ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_25AF_get_cr_pilot_cnr_th_exp7(data)                           (0x0000000F&(data))

#define  ATSC_ADDR_25B0                                                         0x181556C0
#define  ATSC_ADDR_25B0_reg_addr                                                 "0xB81556C0"
#define  ATSC_ADDR_25B0_reg                                                      0xB81556C0
#define  ATSC_ADDR_25B0_inst_addr                                                "0x017C"
#define  set_ATSC_ADDR_25B0_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_25B0_reg)=data)
#define  get_ATSC_ADDR_25B0_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_25B0_reg))
#define  ATSC_ADDR_25B0_cr_lpf_shift_11_4_shift                                  (0)
#define  ATSC_ADDR_25B0_cr_lpf_shift_11_4_mask                                   (0x000000FF)
#define  ATSC_ADDR_25B0_cr_lpf_shift_11_4(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_25B0_get_cr_lpf_shift_11_4(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_25B7                                                         0x181556DC
#define  ATSC_ADDR_25B7_reg_addr                                                 "0xB81556DC"
#define  ATSC_ADDR_25B7_reg                                                      0xB81556DC
#define  ATSC_ADDR_25B7_inst_addr                                                "0x017D"
#define  set_ATSC_ADDR_25B7_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_25B7_reg)=data)
#define  get_ATSC_ADDR_25B7_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_25B7_reg))
#define  ATSC_ADDR_25B7_cr_comp_scale_exp_fixed_shift                            (5)
#define  ATSC_ADDR_25B7_cr_pn_det_pilot_cnr_exp_shift                            (1)
#define  ATSC_ADDR_25B7_cr_pn_det_cond_en_shift                                  (0)
#define  ATSC_ADDR_25B7_cr_comp_scale_exp_fixed_mask                             (0x000000E0)
#define  ATSC_ADDR_25B7_cr_pn_det_pilot_cnr_exp_mask                             (0x0000001E)
#define  ATSC_ADDR_25B7_cr_pn_det_cond_en_mask                                   (0x00000001)
#define  ATSC_ADDR_25B7_cr_comp_scale_exp_fixed(data)                            (0x000000E0&((data)<<5))
#define  ATSC_ADDR_25B7_cr_pn_det_pilot_cnr_exp(data)                            (0x0000001E&((data)<<1))
#define  ATSC_ADDR_25B7_cr_pn_det_cond_en(data)                                  (0x00000001&(data))
#define  ATSC_ADDR_25B7_get_cr_comp_scale_exp_fixed(data)                        ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_25B7_get_cr_pn_det_pilot_cnr_exp(data)                        ((0x0000001E&(data))>>1)
#define  ATSC_ADDR_25B7_get_cr_pn_det_cond_en(data)                              (0x00000001&(data))

#define  ATSC_ADDR_2601                                                         0x18155804
#define  ATSC_ADDR_2601_reg_addr                                                 "0xB8155804"
#define  ATSC_ADDR_2601_reg                                                      0xB8155804
#define  ATSC_ADDR_2601_inst_addr                                                "0x017E"
#define  set_ATSC_ADDR_2601_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2601_reg)=data)
#define  get_ATSC_ADDR_2601_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2601_reg))
#define  ATSC_ADDR_2601_cr_lpf_scale_reg0_7_0_shift                              (0)
#define  ATSC_ADDR_2601_cr_lpf_scale_reg0_7_0_mask                               (0x000000FF)
#define  ATSC_ADDR_2601_cr_lpf_scale_reg0_7_0(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_2601_get_cr_lpf_scale_reg0_7_0(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_2602                                                         0x18155808
#define  ATSC_ADDR_2602_reg_addr                                                 "0xB8155808"
#define  ATSC_ADDR_2602_reg                                                      0xB8155808
#define  ATSC_ADDR_2602_inst_addr                                                "0x017F"
#define  set_ATSC_ADDR_2602_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2602_reg)=data)
#define  get_ATSC_ADDR_2602_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2602_reg))
#define  ATSC_ADDR_2602_cr_lpf_scale_reg0_15_8_shift                             (0)
#define  ATSC_ADDR_2602_cr_lpf_scale_reg0_15_8_mask                              (0x000000FF)
#define  ATSC_ADDR_2602_cr_lpf_scale_reg0_15_8(data)                             (0x000000FF&(data))
#define  ATSC_ADDR_2602_get_cr_lpf_scale_reg0_15_8(data)                         (0x000000FF&(data))

#define  ATSC_ADDR_2603                                                         0x1815580C
#define  ATSC_ADDR_2603_reg_addr                                                 "0xB815580C"
#define  ATSC_ADDR_2603_reg                                                      0xB815580C
#define  ATSC_ADDR_2603_inst_addr                                                "0x0180"
#define  set_ATSC_ADDR_2603_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2603_reg)=data)
#define  get_ATSC_ADDR_2603_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2603_reg))
#define  ATSC_ADDR_2603_cr_lpf_scale_reg1_7_0_shift                              (0)
#define  ATSC_ADDR_2603_cr_lpf_scale_reg1_7_0_mask                               (0x000000FF)
#define  ATSC_ADDR_2603_cr_lpf_scale_reg1_7_0(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_2603_get_cr_lpf_scale_reg1_7_0(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_2604                                                         0x18155810
#define  ATSC_ADDR_2604_reg_addr                                                 "0xB8155810"
#define  ATSC_ADDR_2604_reg                                                      0xB8155810
#define  ATSC_ADDR_2604_inst_addr                                                "0x0181"
#define  set_ATSC_ADDR_2604_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2604_reg)=data)
#define  get_ATSC_ADDR_2604_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2604_reg))
#define  ATSC_ADDR_2604_cr_lpf_scale_reg1_15_8_shift                             (0)
#define  ATSC_ADDR_2604_cr_lpf_scale_reg1_15_8_mask                              (0x000000FF)
#define  ATSC_ADDR_2604_cr_lpf_scale_reg1_15_8(data)                             (0x000000FF&(data))
#define  ATSC_ADDR_2604_get_cr_lpf_scale_reg1_15_8(data)                         (0x000000FF&(data))

#define  ATSC_ADDR_2607                                                         0x1815581C
#define  ATSC_ADDR_2607_reg_addr                                                 "0xB815581C"
#define  ATSC_ADDR_2607_reg                                                      0xB815581C
#define  ATSC_ADDR_2607_inst_addr                                                "0x0182"
#define  set_ATSC_ADDR_2607_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2607_reg)=data)
#define  get_ATSC_ADDR_2607_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2607_reg))
#define  ATSC_ADDR_2607_cr_lpf_a1_reg0_7_0_shift                                 (0)
#define  ATSC_ADDR_2607_cr_lpf_a1_reg0_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_2607_cr_lpf_a1_reg0_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2607_get_cr_lpf_a1_reg0_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2608                                                         0x18155820
#define  ATSC_ADDR_2608_reg_addr                                                 "0xB8155820"
#define  ATSC_ADDR_2608_reg                                                      0xB8155820
#define  ATSC_ADDR_2608_inst_addr                                                "0x0183"
#define  set_ATSC_ADDR_2608_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2608_reg)=data)
#define  get_ATSC_ADDR_2608_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2608_reg))
#define  ATSC_ADDR_2608_cr_lpf_a1_reg0_15_8_shift                                (0)
#define  ATSC_ADDR_2608_cr_lpf_a1_reg0_15_8_mask                                 (0x000000FF)
#define  ATSC_ADDR_2608_cr_lpf_a1_reg0_15_8(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2608_get_cr_lpf_a1_reg0_15_8(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2609                                                         0x18155824
#define  ATSC_ADDR_2609_reg_addr                                                 "0xB8155824"
#define  ATSC_ADDR_2609_reg                                                      0xB8155824
#define  ATSC_ADDR_2609_inst_addr                                                "0x0184"
#define  set_ATSC_ADDR_2609_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2609_reg)=data)
#define  get_ATSC_ADDR_2609_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2609_reg))
#define  ATSC_ADDR_2609_cr_lpf_a1_reg0_21_16_shift                               (0)
#define  ATSC_ADDR_2609_cr_lpf_a1_reg0_21_16_mask                                (0x0000003F)
#define  ATSC_ADDR_2609_cr_lpf_a1_reg0_21_16(data)                               (0x0000003F&(data))
#define  ATSC_ADDR_2609_get_cr_lpf_a1_reg0_21_16(data)                           (0x0000003F&(data))

#define  ATSC_ADDR_260A                                                         0x18155828
#define  ATSC_ADDR_260A_reg_addr                                                 "0xB8155828"
#define  ATSC_ADDR_260A_reg                                                      0xB8155828
#define  ATSC_ADDR_260A_inst_addr                                                "0x0185"
#define  set_ATSC_ADDR_260A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_260A_reg)=data)
#define  get_ATSC_ADDR_260A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_260A_reg))
#define  ATSC_ADDR_260A_cr_lpf_a1_reg1_7_0_shift                                 (0)
#define  ATSC_ADDR_260A_cr_lpf_a1_reg1_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_260A_cr_lpf_a1_reg1_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_260A_get_cr_lpf_a1_reg1_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_260B                                                         0x1815582C
#define  ATSC_ADDR_260B_reg_addr                                                 "0xB815582C"
#define  ATSC_ADDR_260B_reg                                                      0xB815582C
#define  ATSC_ADDR_260B_inst_addr                                                "0x0186"
#define  set_ATSC_ADDR_260B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_260B_reg)=data)
#define  get_ATSC_ADDR_260B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_260B_reg))
#define  ATSC_ADDR_260B_cr_lpf_a1_reg1_15_8_shift                                (0)
#define  ATSC_ADDR_260B_cr_lpf_a1_reg1_15_8_mask                                 (0x000000FF)
#define  ATSC_ADDR_260B_cr_lpf_a1_reg1_15_8(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_260B_get_cr_lpf_a1_reg1_15_8(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_260C                                                         0x18155830
#define  ATSC_ADDR_260C_reg_addr                                                 "0xB8155830"
#define  ATSC_ADDR_260C_reg                                                      0xB8155830
#define  ATSC_ADDR_260C_inst_addr                                                "0x0187"
#define  set_ATSC_ADDR_260C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_260C_reg)=data)
#define  get_ATSC_ADDR_260C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_260C_reg))
#define  ATSC_ADDR_260C_cr_lpf_a1_reg1_21_16_shift                               (0)
#define  ATSC_ADDR_260C_cr_lpf_a1_reg1_21_16_mask                                (0x0000003F)
#define  ATSC_ADDR_260C_cr_lpf_a1_reg1_21_16(data)                               (0x0000003F&(data))
#define  ATSC_ADDR_260C_get_cr_lpf_a1_reg1_21_16(data)                           (0x0000003F&(data))

#define  ATSC_ADDR_2610                                                         0x18155840
#define  ATSC_ADDR_2610_reg_addr                                                 "0xB8155840"
#define  ATSC_ADDR_2610_reg                                                      0xB8155840
#define  ATSC_ADDR_2610_inst_addr                                                "0x0188"
#define  set_ATSC_ADDR_2610_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2610_reg)=data)
#define  get_ATSC_ADDR_2610_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2610_reg))
#define  ATSC_ADDR_2610_cr_lpf_a2_reg0_7_0_shift                                 (0)
#define  ATSC_ADDR_2610_cr_lpf_a2_reg0_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_2610_cr_lpf_a2_reg0_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2610_get_cr_lpf_a2_reg0_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2611                                                         0x18155844
#define  ATSC_ADDR_2611_reg_addr                                                 "0xB8155844"
#define  ATSC_ADDR_2611_reg                                                      0xB8155844
#define  ATSC_ADDR_2611_inst_addr                                                "0x0189"
#define  set_ATSC_ADDR_2611_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2611_reg)=data)
#define  get_ATSC_ADDR_2611_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2611_reg))
#define  ATSC_ADDR_2611_cr_lpf_a2_reg0_15_8_shift                                (0)
#define  ATSC_ADDR_2611_cr_lpf_a2_reg0_15_8_mask                                 (0x000000FF)
#define  ATSC_ADDR_2611_cr_lpf_a2_reg0_15_8(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2611_get_cr_lpf_a2_reg0_15_8(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2612                                                         0x18155848
#define  ATSC_ADDR_2612_reg_addr                                                 "0xB8155848"
#define  ATSC_ADDR_2612_reg                                                      0xB8155848
#define  ATSC_ADDR_2612_inst_addr                                                "0x018A"
#define  set_ATSC_ADDR_2612_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2612_reg)=data)
#define  get_ATSC_ADDR_2612_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2612_reg))
#define  ATSC_ADDR_2612_cr_lpf_a2_reg0_21_16_shift                               (0)
#define  ATSC_ADDR_2612_cr_lpf_a2_reg0_21_16_mask                                (0x0000003F)
#define  ATSC_ADDR_2612_cr_lpf_a2_reg0_21_16(data)                               (0x0000003F&(data))
#define  ATSC_ADDR_2612_get_cr_lpf_a2_reg0_21_16(data)                           (0x0000003F&(data))

#define  ATSC_ADDR_2613                                                         0x1815584C
#define  ATSC_ADDR_2613_reg_addr                                                 "0xB815584C"
#define  ATSC_ADDR_2613_reg                                                      0xB815584C
#define  ATSC_ADDR_2613_inst_addr                                                "0x018B"
#define  set_ATSC_ADDR_2613_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2613_reg)=data)
#define  get_ATSC_ADDR_2613_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2613_reg))
#define  ATSC_ADDR_2613_cr_lpf_a2_reg1_7_0_shift                                 (0)
#define  ATSC_ADDR_2613_cr_lpf_a2_reg1_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_2613_cr_lpf_a2_reg1_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2613_get_cr_lpf_a2_reg1_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2614                                                         0x18155850
#define  ATSC_ADDR_2614_reg_addr                                                 "0xB8155850"
#define  ATSC_ADDR_2614_reg                                                      0xB8155850
#define  ATSC_ADDR_2614_inst_addr                                                "0x018C"
#define  set_ATSC_ADDR_2614_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2614_reg)=data)
#define  get_ATSC_ADDR_2614_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2614_reg))
#define  ATSC_ADDR_2614_cr_lpf_a2_reg1_15_8_shift                                (0)
#define  ATSC_ADDR_2614_cr_lpf_a2_reg1_15_8_mask                                 (0x000000FF)
#define  ATSC_ADDR_2614_cr_lpf_a2_reg1_15_8(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2614_get_cr_lpf_a2_reg1_15_8(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2615                                                         0x18155854
#define  ATSC_ADDR_2615_reg_addr                                                 "0xB8155854"
#define  ATSC_ADDR_2615_reg                                                      0xB8155854
#define  ATSC_ADDR_2615_inst_addr                                                "0x018D"
#define  set_ATSC_ADDR_2615_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2615_reg)=data)
#define  get_ATSC_ADDR_2615_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2615_reg))
#define  ATSC_ADDR_2615_cr_lpf_a2_reg1_21_16_shift                               (0)
#define  ATSC_ADDR_2615_cr_lpf_a2_reg1_21_16_mask                                (0x0000003F)
#define  ATSC_ADDR_2615_cr_lpf_a2_reg1_21_16(data)                               (0x0000003F&(data))
#define  ATSC_ADDR_2615_get_cr_lpf_a2_reg1_21_16(data)                           (0x0000003F&(data))

#define  ATSC_ADDR_2619                                                         0x18155864
#define  ATSC_ADDR_2619_reg_addr                                                 "0xB8155864"
#define  ATSC_ADDR_2619_reg                                                      0xB8155864
#define  ATSC_ADDR_2619_inst_addr                                                "0x018E"
#define  set_ATSC_ADDR_2619_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2619_reg)=data)
#define  get_ATSC_ADDR_2619_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2619_reg))
#define  ATSC_ADDR_2619_cr_lpf_b1_reg0_7_0_shift                                 (0)
#define  ATSC_ADDR_2619_cr_lpf_b1_reg0_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_2619_cr_lpf_b1_reg0_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2619_get_cr_lpf_b1_reg0_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_261A                                                         0x18155868
#define  ATSC_ADDR_261A_reg_addr                                                 "0xB8155868"
#define  ATSC_ADDR_261A_reg                                                      0xB8155868
#define  ATSC_ADDR_261A_inst_addr                                                "0x018F"
#define  set_ATSC_ADDR_261A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_261A_reg)=data)
#define  get_ATSC_ADDR_261A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_261A_reg))
#define  ATSC_ADDR_261A_cr_lpf_b1_reg0_15_8_shift                                (0)
#define  ATSC_ADDR_261A_cr_lpf_b1_reg0_15_8_mask                                 (0x000000FF)
#define  ATSC_ADDR_261A_cr_lpf_b1_reg0_15_8(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_261A_get_cr_lpf_b1_reg0_15_8(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_261B                                                         0x1815586C
#define  ATSC_ADDR_261B_reg_addr                                                 "0xB815586C"
#define  ATSC_ADDR_261B_reg                                                      0xB815586C
#define  ATSC_ADDR_261B_inst_addr                                                "0x0190"
#define  set_ATSC_ADDR_261B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_261B_reg)=data)
#define  get_ATSC_ADDR_261B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_261B_reg))
#define  ATSC_ADDR_261B_cr_lpf_b1_reg0_21_16_shift                               (0)
#define  ATSC_ADDR_261B_cr_lpf_b1_reg0_21_16_mask                                (0x0000003F)
#define  ATSC_ADDR_261B_cr_lpf_b1_reg0_21_16(data)                               (0x0000003F&(data))
#define  ATSC_ADDR_261B_get_cr_lpf_b1_reg0_21_16(data)                           (0x0000003F&(data))

#define  ATSC_ADDR_261C                                                         0x18155870
#define  ATSC_ADDR_261C_reg_addr                                                 "0xB8155870"
#define  ATSC_ADDR_261C_reg                                                      0xB8155870
#define  ATSC_ADDR_261C_inst_addr                                                "0x0191"
#define  set_ATSC_ADDR_261C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_261C_reg)=data)
#define  get_ATSC_ADDR_261C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_261C_reg))
#define  ATSC_ADDR_261C_cr_lpf_b1_reg1_7_0_shift                                 (0)
#define  ATSC_ADDR_261C_cr_lpf_b1_reg1_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_261C_cr_lpf_b1_reg1_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_261C_get_cr_lpf_b1_reg1_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_261D                                                         0x18155874
#define  ATSC_ADDR_261D_reg_addr                                                 "0xB8155874"
#define  ATSC_ADDR_261D_reg                                                      0xB8155874
#define  ATSC_ADDR_261D_inst_addr                                                "0x0192"
#define  set_ATSC_ADDR_261D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_261D_reg)=data)
#define  get_ATSC_ADDR_261D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_261D_reg))
#define  ATSC_ADDR_261D_cr_lpf_b1_reg1_15_8_shift                                (0)
#define  ATSC_ADDR_261D_cr_lpf_b1_reg1_15_8_mask                                 (0x000000FF)
#define  ATSC_ADDR_261D_cr_lpf_b1_reg1_15_8(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_261D_get_cr_lpf_b1_reg1_15_8(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_261E                                                         0x18155878
#define  ATSC_ADDR_261E_reg_addr                                                 "0xB8155878"
#define  ATSC_ADDR_261E_reg                                                      0xB8155878
#define  ATSC_ADDR_261E_inst_addr                                                "0x0193"
#define  set_ATSC_ADDR_261E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_261E_reg)=data)
#define  get_ATSC_ADDR_261E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_261E_reg))
#define  ATSC_ADDR_261E_cr_lpf_b1_reg1_21_16_shift                               (0)
#define  ATSC_ADDR_261E_cr_lpf_b1_reg1_21_16_mask                                (0x0000003F)
#define  ATSC_ADDR_261E_cr_lpf_b1_reg1_21_16(data)                               (0x0000003F&(data))
#define  ATSC_ADDR_261E_get_cr_lpf_b1_reg1_21_16(data)                           (0x0000003F&(data))

#define  ATSC_ADDR_2622                                                         0x18155888
#define  ATSC_ADDR_2622_reg_addr                                                 "0xB8155888"
#define  ATSC_ADDR_2622_reg                                                      0xB8155888
#define  ATSC_ADDR_2622_inst_addr                                                "0x0194"
#define  set_ATSC_ADDR_2622_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2622_reg)=data)
#define  get_ATSC_ADDR_2622_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2622_reg))
#define  ATSC_ADDR_2622_cr_lpf_b2_reg0_7_0_shift                                 (0)
#define  ATSC_ADDR_2622_cr_lpf_b2_reg0_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_2622_cr_lpf_b2_reg0_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2622_get_cr_lpf_b2_reg0_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2623                                                         0x1815588C
#define  ATSC_ADDR_2623_reg_addr                                                 "0xB815588C"
#define  ATSC_ADDR_2623_reg                                                      0xB815588C
#define  ATSC_ADDR_2623_inst_addr                                                "0x0195"
#define  set_ATSC_ADDR_2623_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2623_reg)=data)
#define  get_ATSC_ADDR_2623_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2623_reg))
#define  ATSC_ADDR_2623_cr_lpf_b2_reg0_15_8_shift                                (0)
#define  ATSC_ADDR_2623_cr_lpf_b2_reg0_15_8_mask                                 (0x000000FF)
#define  ATSC_ADDR_2623_cr_lpf_b2_reg0_15_8(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2623_get_cr_lpf_b2_reg0_15_8(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2624                                                         0x18155890
#define  ATSC_ADDR_2624_reg_addr                                                 "0xB8155890"
#define  ATSC_ADDR_2624_reg                                                      0xB8155890
#define  ATSC_ADDR_2624_inst_addr                                                "0x0196"
#define  set_ATSC_ADDR_2624_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2624_reg)=data)
#define  get_ATSC_ADDR_2624_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2624_reg))
#define  ATSC_ADDR_2624_cr_lpf_b2_reg0_21_16_shift                               (0)
#define  ATSC_ADDR_2624_cr_lpf_b2_reg0_21_16_mask                                (0x0000003F)
#define  ATSC_ADDR_2624_cr_lpf_b2_reg0_21_16(data)                               (0x0000003F&(data))
#define  ATSC_ADDR_2624_get_cr_lpf_b2_reg0_21_16(data)                           (0x0000003F&(data))

#define  ATSC_ADDR_2625                                                         0x18155894
#define  ATSC_ADDR_2625_reg_addr                                                 "0xB8155894"
#define  ATSC_ADDR_2625_reg                                                      0xB8155894
#define  ATSC_ADDR_2625_inst_addr                                                "0x0197"
#define  set_ATSC_ADDR_2625_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2625_reg)=data)
#define  get_ATSC_ADDR_2625_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2625_reg))
#define  ATSC_ADDR_2625_cr_lpf_b2_reg1_7_0_shift                                 (0)
#define  ATSC_ADDR_2625_cr_lpf_b2_reg1_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_2625_cr_lpf_b2_reg1_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2625_get_cr_lpf_b2_reg1_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2626                                                         0x18155898
#define  ATSC_ADDR_2626_reg_addr                                                 "0xB8155898"
#define  ATSC_ADDR_2626_reg                                                      0xB8155898
#define  ATSC_ADDR_2626_inst_addr                                                "0x0198"
#define  set_ATSC_ADDR_2626_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2626_reg)=data)
#define  get_ATSC_ADDR_2626_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2626_reg))
#define  ATSC_ADDR_2626_cr_lpf_b2_reg1_15_8_shift                                (0)
#define  ATSC_ADDR_2626_cr_lpf_b2_reg1_15_8_mask                                 (0x000000FF)
#define  ATSC_ADDR_2626_cr_lpf_b2_reg1_15_8(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2626_get_cr_lpf_b2_reg1_15_8(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2627                                                         0x1815589C
#define  ATSC_ADDR_2627_reg_addr                                                 "0xB815589C"
#define  ATSC_ADDR_2627_reg                                                      0xB815589C
#define  ATSC_ADDR_2627_inst_addr                                                "0x0199"
#define  set_ATSC_ADDR_2627_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2627_reg)=data)
#define  get_ATSC_ADDR_2627_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2627_reg))
#define  ATSC_ADDR_2627_cr_lpf_b2_reg1_21_16_shift                               (0)
#define  ATSC_ADDR_2627_cr_lpf_b2_reg1_21_16_mask                                (0x0000003F)
#define  ATSC_ADDR_2627_cr_lpf_b2_reg1_21_16(data)                               (0x0000003F&(data))
#define  ATSC_ADDR_2627_get_cr_lpf_b2_reg1_21_16(data)                           (0x0000003F&(data))

#define  ATSC_ADDR_2628                                                         0x181558A0
#define  ATSC_ADDR_2628_reg_addr                                                 "0xB81558A0"
#define  ATSC_ADDR_2628_reg                                                      0xB81558A0
#define  ATSC_ADDR_2628_inst_addr                                                "0x019A"
#define  set_ATSC_ADDR_2628_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2628_reg)=data)
#define  get_ATSC_ADDR_2628_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2628_reg))
#define  ATSC_ADDR_2628_cr_ld_re_diff_en_shift                                   (6)
#define  ATSC_ADDR_2628_cr_ld_freq_ub_sel_shift                                  (5)
#define  ATSC_ADDR_2628_cr_ld_freq_diff_sel_shift                                (4)
#define  ATSC_ADDR_2628_cr_ld_im_sel_shift                                       (3)
#define  ATSC_ADDR_2628_cr_ld_re_sel_shift                                       (2)
#define  ATSC_ADDR_2628_cr_ld_cnt_dec_shift                                      (1)
#define  ATSC_ADDR_2628_cr_ld_cnt_inc_shift                                      (0)
#define  ATSC_ADDR_2628_cr_ld_re_diff_en_mask                                    (0x00000040)
#define  ATSC_ADDR_2628_cr_ld_freq_ub_sel_mask                                   (0x00000020)
#define  ATSC_ADDR_2628_cr_ld_freq_diff_sel_mask                                 (0x00000010)
#define  ATSC_ADDR_2628_cr_ld_im_sel_mask                                        (0x00000008)
#define  ATSC_ADDR_2628_cr_ld_re_sel_mask                                        (0x00000004)
#define  ATSC_ADDR_2628_cr_ld_cnt_dec_mask                                       (0x00000002)
#define  ATSC_ADDR_2628_cr_ld_cnt_inc_mask                                       (0x00000001)
#define  ATSC_ADDR_2628_cr_ld_re_diff_en(data)                                   (0x00000040&((data)<<6))
#define  ATSC_ADDR_2628_cr_ld_freq_ub_sel(data)                                  (0x00000020&((data)<<5))
#define  ATSC_ADDR_2628_cr_ld_freq_diff_sel(data)                                (0x00000010&((data)<<4))
#define  ATSC_ADDR_2628_cr_ld_im_sel(data)                                       (0x00000008&((data)<<3))
#define  ATSC_ADDR_2628_cr_ld_re_sel(data)                                       (0x00000004&((data)<<2))
#define  ATSC_ADDR_2628_cr_ld_cnt_dec(data)                                      (0x00000002&((data)<<1))
#define  ATSC_ADDR_2628_cr_ld_cnt_inc(data)                                      (0x00000001&(data))
#define  ATSC_ADDR_2628_get_cr_ld_re_diff_en(data)                               ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2628_get_cr_ld_freq_ub_sel(data)                              ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2628_get_cr_ld_freq_diff_sel(data)                            ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2628_get_cr_ld_im_sel(data)                                   ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2628_get_cr_ld_re_sel(data)                                   ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2628_get_cr_ld_cnt_dec(data)                                  ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2628_get_cr_ld_cnt_inc(data)                                  (0x00000001&(data))

#define  ATSC_ADDR_2629                                                         0x181558A4
#define  ATSC_ADDR_2629_reg_addr                                                 "0xB81558A4"
#define  ATSC_ADDR_2629_reg                                                      0xB81558A4
#define  ATSC_ADDR_2629_inst_addr                                                "0x019B"
#define  set_ATSC_ADDR_2629_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2629_reg)=data)
#define  get_ATSC_ADDR_2629_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2629_reg))
#define  ATSC_ADDR_2629_cr_ld_det_alpha_shift                                    (0)
#define  ATSC_ADDR_2629_cr_ld_det_alpha_mask                                     (0x00000003)
#define  ATSC_ADDR_2629_cr_ld_det_alpha(data)                                    (0x00000003&(data))
#define  ATSC_ADDR_2629_get_cr_ld_det_alpha(data)                                (0x00000003&(data))

#define  ATSC_ADDR_262B                                                         0x181558AC
#define  ATSC_ADDR_262B_reg_addr                                                 "0xB81558AC"
#define  ATSC_ADDR_262B_reg                                                      0xB81558AC
#define  ATSC_ADDR_262B_inst_addr                                                "0x019C"
#define  set_ATSC_ADDR_262B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_262B_reg)=data)
#define  get_ATSC_ADDR_262B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_262B_reg))
#define  ATSC_ADDR_262B_cr_comp_exp_manu_shift                                   (4)
#define  ATSC_ADDR_262B_cr_comp_man_manu_shift                                   (3)
#define  ATSC_ADDR_262B_cr_comp_manu_shift                                       (2)
#define  ATSC_ADDR_262B_cr_comp_exp_manu_mask                                    (0x00000070)
#define  ATSC_ADDR_262B_cr_comp_man_manu_mask                                    (0x00000008)
#define  ATSC_ADDR_262B_cr_comp_manu_mask                                        (0x00000004)
#define  ATSC_ADDR_262B_cr_comp_exp_manu(data)                                   (0x00000070&((data)<<4))
#define  ATSC_ADDR_262B_cr_comp_man_manu(data)                                   (0x00000008&((data)<<3))
#define  ATSC_ADDR_262B_cr_comp_manu(data)                                       (0x00000004&((data)<<2))
#define  ATSC_ADDR_262B_get_cr_comp_exp_manu(data)                               ((0x00000070&(data))>>4)
#define  ATSC_ADDR_262B_get_cr_comp_man_manu(data)                               ((0x00000008&(data))>>3)
#define  ATSC_ADDR_262B_get_cr_comp_manu(data)                                   ((0x00000004&(data))>>2)

#define  ATSC_ADDR_262C                                                         0x181558B0
#define  ATSC_ADDR_262C_reg_addr                                                 "0xB81558B0"
#define  ATSC_ADDR_262C_reg                                                      0xB81558B0
#define  ATSC_ADDR_262C_inst_addr                                                "0x019D"
#define  set_ATSC_ADDR_262C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_262C_reg)=data)
#define  get_ATSC_ADDR_262C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_262C_reg))
#define  ATSC_ADDR_262C_cr_phase_shift_7_0_shift                                 (0)
#define  ATSC_ADDR_262C_cr_phase_shift_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_262C_cr_phase_shift_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_262C_get_cr_phase_shift_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_262D                                                         0x181558B4
#define  ATSC_ADDR_262D_reg_addr                                                 "0xB81558B4"
#define  ATSC_ADDR_262D_reg                                                      0xB81558B4
#define  ATSC_ADDR_262D_inst_addr                                                "0x019E"
#define  set_ATSC_ADDR_262D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_262D_reg)=data)
#define  get_ATSC_ADDR_262D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_262D_reg))
#define  ATSC_ADDR_262D_cr_offset_leak_prd_shift                                 (5)
#define  ATSC_ADDR_262D_cr_offset_leak_upd_opt_shift                             (3)
#define  ATSC_ADDR_262D_cr_phase_shift_9_8_shift                                 (0)
#define  ATSC_ADDR_262D_cr_offset_leak_prd_mask                                  (0x000000E0)
#define  ATSC_ADDR_262D_cr_offset_leak_upd_opt_mask                              (0x00000018)
#define  ATSC_ADDR_262D_cr_phase_shift_9_8_mask                                  (0x00000003)
#define  ATSC_ADDR_262D_cr_offset_leak_prd(data)                                 (0x000000E0&((data)<<5))
#define  ATSC_ADDR_262D_cr_offset_leak_upd_opt(data)                             (0x00000018&((data)<<3))
#define  ATSC_ADDR_262D_cr_phase_shift_9_8(data)                                 (0x00000003&(data))
#define  ATSC_ADDR_262D_get_cr_offset_leak_prd(data)                             ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_262D_get_cr_offset_leak_upd_opt(data)                         ((0x00000018&(data))>>3)
#define  ATSC_ADDR_262D_get_cr_phase_shift_9_8(data)                             (0x00000003&(data))

#define  ATSC_ADDR_262E                                                         0x181558B8
#define  ATSC_ADDR_262E_reg_addr                                                 "0xB81558B8"
#define  ATSC_ADDR_262E_reg                                                      0xB81558B8
#define  ATSC_ADDR_262E_inst_addr                                                "0x019F"
#define  set_ATSC_ADDR_262E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_262E_reg)=data)
#define  get_ATSC_ADDR_262E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_262E_reg))
#define  ATSC_ADDR_262E_cr_offset_leak_f_th_shift                                (0)
#define  ATSC_ADDR_262E_cr_offset_leak_f_th_mask                                 (0x000000FF)
#define  ATSC_ADDR_262E_cr_offset_leak_f_th(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_262E_get_cr_offset_leak_f_th(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2630                                                         0x181558C0
#define  ATSC_ADDR_2630_reg_addr                                                 "0xB81558C0"
#define  ATSC_ADDR_2630_reg                                                      0xB81558C0
#define  ATSC_ADDR_2630_inst_addr                                                "0x01A0"
#define  set_ATSC_ADDR_2630_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2630_reg)=data)
#define  get_ATSC_ADDR_2630_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2630_reg))
#define  ATSC_ADDR_2630_cr_phase_comp_slope_7_0_shift                            (0)
#define  ATSC_ADDR_2630_cr_phase_comp_slope_7_0_mask                             (0x000000FF)
#define  ATSC_ADDR_2630_cr_phase_comp_slope_7_0(data)                            (0x000000FF&(data))
#define  ATSC_ADDR_2630_get_cr_phase_comp_slope_7_0(data)                        (0x000000FF&(data))

#define  ATSC_ADDR_2631                                                         0x181558C4
#define  ATSC_ADDR_2631_reg_addr                                                 "0xB81558C4"
#define  ATSC_ADDR_2631_reg                                                      0xB81558C4
#define  ATSC_ADDR_2631_inst_addr                                                "0x01A1"
#define  set_ATSC_ADDR_2631_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2631_reg)=data)
#define  get_ATSC_ADDR_2631_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2631_reg))
#define  ATSC_ADDR_2631_cr_phase_comp_in_sel_shift                               (3)
#define  ATSC_ADDR_2631_cr_phase_comp_slope_10_8_shift                           (0)
#define  ATSC_ADDR_2631_cr_phase_comp_in_sel_mask                                (0x00000008)
#define  ATSC_ADDR_2631_cr_phase_comp_slope_10_8_mask                            (0x00000007)
#define  ATSC_ADDR_2631_cr_phase_comp_in_sel(data)                               (0x00000008&((data)<<3))
#define  ATSC_ADDR_2631_cr_phase_comp_slope_10_8(data)                           (0x00000007&(data))
#define  ATSC_ADDR_2631_get_cr_phase_comp_in_sel(data)                           ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2631_get_cr_phase_comp_slope_10_8(data)                       (0x00000007&(data))

#define  ATSC_ADDR_2632                                                         0x181558C8
#define  ATSC_ADDR_2632_reg_addr                                                 "0xB81558C8"
#define  ATSC_ADDR_2632_reg                                                      0xB81558C8
#define  ATSC_ADDR_2632_inst_addr                                                "0x01A2"
#define  set_ATSC_ADDR_2632_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2632_reg)=data)
#define  get_ATSC_ADDR_2632_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2632_reg))
#define  ATSC_ADDR_2632_cr_comp_target_7_0_shift                                 (0)
#define  ATSC_ADDR_2632_cr_comp_target_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_2632_cr_comp_target_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2632_get_cr_comp_target_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2633                                                         0x181558CC
#define  ATSC_ADDR_2633_reg_addr                                                 "0xB81558CC"
#define  ATSC_ADDR_2633_reg                                                      0xB81558CC
#define  ATSC_ADDR_2633_inst_addr                                                "0x01A3"
#define  set_ATSC_ADDR_2633_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2633_reg)=data)
#define  get_ATSC_ADDR_2633_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2633_reg))
#define  ATSC_ADDR_2633_cr_comp_target_8_shift                                   (0)
#define  ATSC_ADDR_2633_cr_comp_target_8_mask                                    (0x00000001)
#define  ATSC_ADDR_2633_cr_comp_target_8(data)                                   (0x00000001&(data))
#define  ATSC_ADDR_2633_get_cr_comp_target_8(data)                               (0x00000001&(data))

#define  ATSC_ADDR_2634                                                         0x181558D0
#define  ATSC_ADDR_2634_reg_addr                                                 "0xB81558D0"
#define  ATSC_ADDR_2634_reg                                                      0xB81558D0
#define  ATSC_ADDR_2634_inst_addr                                                "0x01A4"
#define  set_ATSC_ADDR_2634_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2634_reg)=data)
#define  get_ATSC_ADDR_2634_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2634_reg))
#define  ATSC_ADDR_2634_cr_pmu_comp0_shift                                       (4)
#define  ATSC_ADDR_2634_cr_ld_cnt_th_shift                                       (0)
#define  ATSC_ADDR_2634_cr_pmu_comp0_mask                                        (0x000000F0)
#define  ATSC_ADDR_2634_cr_ld_cnt_th_mask                                        (0x0000000F)
#define  ATSC_ADDR_2634_cr_pmu_comp0(data)                                       (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2634_cr_ld_cnt_th(data)                                       (0x0000000F&(data))
#define  ATSC_ADDR_2634_get_cr_pmu_comp0(data)                                   ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2634_get_cr_ld_cnt_th(data)                                   (0x0000000F&(data))

#define  ATSC_ADDR_2635                                                         0x181558D4
#define  ATSC_ADDR_2635_reg_addr                                                 "0xB81558D4"
#define  ATSC_ADDR_2635_reg                                                      0xB81558D4
#define  ATSC_ADDR_2635_inst_addr                                                "0x01A5"
#define  set_ATSC_ADDR_2635_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2635_reg)=data)
#define  get_ATSC_ADDR_2635_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2635_reg))
#define  ATSC_ADDR_2635_cr_pmu_comp1_shift                                       (0)
#define  ATSC_ADDR_2635_cr_pmu_comp1_mask                                        (0x0000000F)
#define  ATSC_ADDR_2635_cr_pmu_comp1(data)                                       (0x0000000F&(data))
#define  ATSC_ADDR_2635_get_cr_pmu_comp1(data)                                   (0x0000000F&(data))

#define  ATSC_ADDR_2636                                                         0x181558D8
#define  ATSC_ADDR_2636_reg_addr                                                 "0xB81558D8"
#define  ATSC_ADDR_2636_reg                                                      0xB81558D8
#define  ATSC_ADDR_2636_inst_addr                                                "0x01A6"
#define  set_ATSC_ADDR_2636_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2636_reg)=data)
#define  get_ATSC_ADDR_2636_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2636_reg))
#define  ATSC_ADDR_2636_cr_fmu_comp1_shift                                       (4)
#define  ATSC_ADDR_2636_cr_fmu_comp0_shift                                       (0)
#define  ATSC_ADDR_2636_cr_fmu_comp1_mask                                        (0x000000F0)
#define  ATSC_ADDR_2636_cr_fmu_comp0_mask                                        (0x0000000F)
#define  ATSC_ADDR_2636_cr_fmu_comp1(data)                                       (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2636_cr_fmu_comp0(data)                                       (0x0000000F&(data))
#define  ATSC_ADDR_2636_get_cr_fmu_comp1(data)                                   ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2636_get_cr_fmu_comp0(data)                                   (0x0000000F&(data))

#define  ATSC_ADDR_2637                                                         0x181558DC
#define  ATSC_ADDR_2637_reg_addr                                                 "0xB81558DC"
#define  ATSC_ADDR_2637_reg                                                      0xB81558DC
#define  ATSC_ADDR_2637_inst_addr                                                "0x01A7"
#define  set_ATSC_ADDR_2637_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2637_reg)=data)
#define  get_ATSC_ADDR_2637_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2637_reg))
#define  ATSC_ADDR_2637_cr_acq_fmu_shift                                         (4)
#define  ATSC_ADDR_2637_cr_acq_fmu_mask                                          (0x000000F0)
#define  ATSC_ADDR_2637_cr_acq_fmu(data)                                         (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2637_get_cr_acq_fmu(data)                                     ((0x000000F0&(data))>>4)

#define  ATSC_ADDR_2638                                                         0x181558E0
#define  ATSC_ADDR_2638_reg_addr                                                 "0xB81558E0"
#define  ATSC_ADDR_2638_reg                                                      0xB81558E0
#define  ATSC_ADDR_2638_inst_addr                                                "0x01A8"
#define  set_ATSC_ADDR_2638_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2638_reg)=data)
#define  get_ATSC_ADDR_2638_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2638_reg))
#define  ATSC_ADDR_2638_cr_acq_pmu_shift                                         (0)
#define  ATSC_ADDR_2638_cr_acq_pmu_mask                                          (0x0000000F)
#define  ATSC_ADDR_2638_cr_acq_pmu(data)                                         (0x0000000F&(data))
#define  ATSC_ADDR_2638_get_cr_acq_pmu(data)                                     (0x0000000F&(data))

#define  ATSC_ADDR_2639                                                         0x181558E4
#define  ATSC_ADDR_2639_reg_addr                                                 "0xB81558E4"
#define  ATSC_ADDR_2639_reg                                                      0xB81558E4
#define  ATSC_ADDR_2639_inst_addr                                                "0x01A9"
#define  set_ATSC_ADDR_2639_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2639_reg)=data)
#define  get_ATSC_ADDR_2639_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2639_reg))
#define  ATSC_ADDR_2639_cr_ld_freq_ub0_7_0_shift                                 (0)
#define  ATSC_ADDR_2639_cr_ld_freq_ub0_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_2639_cr_ld_freq_ub0_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2639_get_cr_ld_freq_ub0_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_263A                                                         0x181558E8
#define  ATSC_ADDR_263A_reg_addr                                                 "0xB81558E8"
#define  ATSC_ADDR_263A_reg                                                      0xB81558E8
#define  ATSC_ADDR_263A_inst_addr                                                "0x01AA"
#define  set_ATSC_ADDR_263A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_263A_reg)=data)
#define  get_ATSC_ADDR_263A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_263A_reg))
#define  ATSC_ADDR_263A_cr_ld_freq_ub0_10_8_shift                                (0)
#define  ATSC_ADDR_263A_cr_ld_freq_ub0_10_8_mask                                 (0x00000007)
#define  ATSC_ADDR_263A_cr_ld_freq_ub0_10_8(data)                                (0x00000007&(data))
#define  ATSC_ADDR_263A_get_cr_ld_freq_ub0_10_8(data)                            (0x00000007&(data))

#define  ATSC_ADDR_263B                                                         0x181558EC
#define  ATSC_ADDR_263B_reg_addr                                                 "0xB81558EC"
#define  ATSC_ADDR_263B_reg                                                      0xB81558EC
#define  ATSC_ADDR_263B_inst_addr                                                "0x01AB"
#define  set_ATSC_ADDR_263B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_263B_reg)=data)
#define  get_ATSC_ADDR_263B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_263B_reg))
#define  ATSC_ADDR_263B_cr_ld_freq_ub1_7_0_shift                                 (0)
#define  ATSC_ADDR_263B_cr_ld_freq_ub1_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_263B_cr_ld_freq_ub1_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_263B_get_cr_ld_freq_ub1_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_263C                                                         0x181558F0
#define  ATSC_ADDR_263C_reg_addr                                                 "0xB81558F0"
#define  ATSC_ADDR_263C_reg                                                      0xB81558F0
#define  ATSC_ADDR_263C_inst_addr                                                "0x01AC"
#define  set_ATSC_ADDR_263C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_263C_reg)=data)
#define  get_ATSC_ADDR_263C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_263C_reg))
#define  ATSC_ADDR_263C_cr_ld_freq_ub1_10_8_shift                                (0)
#define  ATSC_ADDR_263C_cr_ld_freq_ub1_10_8_mask                                 (0x00000007)
#define  ATSC_ADDR_263C_cr_ld_freq_ub1_10_8(data)                                (0x00000007&(data))
#define  ATSC_ADDR_263C_get_cr_ld_freq_ub1_10_8(data)                            (0x00000007&(data))

#define  ATSC_ADDR_263D                                                         0x181558F4
#define  ATSC_ADDR_263D_reg_addr                                                 "0xB81558F4"
#define  ATSC_ADDR_263D_reg                                                      0xB81558F4
#define  ATSC_ADDR_263D_inst_addr                                                "0x01AD"
#define  set_ATSC_ADDR_263D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_263D_reg)=data)
#define  get_ATSC_ADDR_263D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_263D_reg))
#define  ATSC_ADDR_263D_cr_ld_re_diff_th_7_0_shift                               (0)
#define  ATSC_ADDR_263D_cr_ld_re_diff_th_7_0_mask                                (0x000000FF)
#define  ATSC_ADDR_263D_cr_ld_re_diff_th_7_0(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_263D_get_cr_ld_re_diff_th_7_0(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_263E                                                         0x181558F8
#define  ATSC_ADDR_263E_reg_addr                                                 "0xB81558F8"
#define  ATSC_ADDR_263E_reg                                                      0xB81558F8
#define  ATSC_ADDR_263E_inst_addr                                                "0x01AE"
#define  set_ATSC_ADDR_263E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_263E_reg)=data)
#define  get_ATSC_ADDR_263E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_263E_reg))
#define  ATSC_ADDR_263E_cr_ld_re_diff_th_13_8_shift                              (0)
#define  ATSC_ADDR_263E_cr_ld_re_diff_th_13_8_mask                               (0x0000003F)
#define  ATSC_ADDR_263E_cr_ld_re_diff_th_13_8(data)                              (0x0000003F&(data))
#define  ATSC_ADDR_263E_get_cr_ld_re_diff_th_13_8(data)                          (0x0000003F&(data))

#define  ATSC_ADDR_263F                                                         0x181558FC
#define  ATSC_ADDR_263F_reg_addr                                                 "0xB81558FC"
#define  ATSC_ADDR_263F_reg                                                      0xB81558FC
#define  ATSC_ADDR_263F_inst_addr                                                "0x01AF"
#define  set_ATSC_ADDR_263F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_263F_reg)=data)
#define  get_ATSC_ADDR_263F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_263F_reg))
#define  ATSC_ADDR_263F_cr_ld_re_ub_en_shift                                     (5)
#define  ATSC_ADDR_263F_cr_ld_freq_max_en_shift                                  (4)
#define  ATSC_ADDR_263F_cr_ld_freq_en_shift                                      (3)
#define  ATSC_ADDR_263F_cr_ld_im_en_shift                                        (2)
#define  ATSC_ADDR_263F_cr_ld_re_lb_en_shift                                     (1)
#define  ATSC_ADDR_263F_cr_ld_comp_on_shift                                      (0)
#define  ATSC_ADDR_263F_cr_ld_re_ub_en_mask                                      (0x00000020)
#define  ATSC_ADDR_263F_cr_ld_freq_max_en_mask                                   (0x00000010)
#define  ATSC_ADDR_263F_cr_ld_freq_en_mask                                       (0x00000008)
#define  ATSC_ADDR_263F_cr_ld_im_en_mask                                         (0x00000004)
#define  ATSC_ADDR_263F_cr_ld_re_lb_en_mask                                      (0x00000002)
#define  ATSC_ADDR_263F_cr_ld_comp_on_mask                                       (0x00000001)
#define  ATSC_ADDR_263F_cr_ld_re_ub_en(data)                                     (0x00000020&((data)<<5))
#define  ATSC_ADDR_263F_cr_ld_freq_max_en(data)                                  (0x00000010&((data)<<4))
#define  ATSC_ADDR_263F_cr_ld_freq_en(data)                                      (0x00000008&((data)<<3))
#define  ATSC_ADDR_263F_cr_ld_im_en(data)                                        (0x00000004&((data)<<2))
#define  ATSC_ADDR_263F_cr_ld_re_lb_en(data)                                     (0x00000002&((data)<<1))
#define  ATSC_ADDR_263F_cr_ld_comp_on(data)                                      (0x00000001&(data))
#define  ATSC_ADDR_263F_get_cr_ld_re_ub_en(data)                                 ((0x00000020&(data))>>5)
#define  ATSC_ADDR_263F_get_cr_ld_freq_max_en(data)                              ((0x00000010&(data))>>4)
#define  ATSC_ADDR_263F_get_cr_ld_freq_en(data)                                  ((0x00000008&(data))>>3)
#define  ATSC_ADDR_263F_get_cr_ld_im_en(data)                                    ((0x00000004&(data))>>2)
#define  ATSC_ADDR_263F_get_cr_ld_re_lb_en(data)                                 ((0x00000002&(data))>>1)
#define  ATSC_ADDR_263F_get_cr_ld_comp_on(data)                                  (0x00000001&(data))

#define  ATSC_ADDR_2640                                                         0x18155900
#define  ATSC_ADDR_2640_reg_addr                                                 "0xB8155900"
#define  ATSC_ADDR_2640_reg                                                      0xB8155900
#define  ATSC_ADDR_2640_inst_addr                                                "0x01B0"
#define  set_ATSC_ADDR_2640_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2640_reg)=data)
#define  get_ATSC_ADDR_2640_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2640_reg))
#define  ATSC_ADDR_2640_cr_ld_re_th_lb_7_0_shift                                 (0)
#define  ATSC_ADDR_2640_cr_ld_re_th_lb_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_2640_cr_ld_re_th_lb_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2640_get_cr_ld_re_th_lb_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2641                                                         0x18155904
#define  ATSC_ADDR_2641_reg_addr                                                 "0xB8155904"
#define  ATSC_ADDR_2641_reg                                                      0xB8155904
#define  ATSC_ADDR_2641_inst_addr                                                "0x01B1"
#define  set_ATSC_ADDR_2641_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2641_reg)=data)
#define  get_ATSC_ADDR_2641_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2641_reg))
#define  ATSC_ADDR_2641_cr_ld_re_th_lb_12_8_shift                                (0)
#define  ATSC_ADDR_2641_cr_ld_re_th_lb_12_8_mask                                 (0x0000001F)
#define  ATSC_ADDR_2641_cr_ld_re_th_lb_12_8(data)                                (0x0000001F&(data))
#define  ATSC_ADDR_2641_get_cr_ld_re_th_lb_12_8(data)                            (0x0000001F&(data))

#define  ATSC_ADDR_2642                                                         0x18155908
#define  ATSC_ADDR_2642_reg_addr                                                 "0xB8155908"
#define  ATSC_ADDR_2642_reg                                                      0xB8155908
#define  ATSC_ADDR_2642_inst_addr                                                "0x01B2"
#define  set_ATSC_ADDR_2642_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2642_reg)=data)
#define  get_ATSC_ADDR_2642_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2642_reg))
#define  ATSC_ADDR_2642_cr_ld_im_th_7_0_shift                                    (0)
#define  ATSC_ADDR_2642_cr_ld_im_th_7_0_mask                                     (0x000000FF)
#define  ATSC_ADDR_2642_cr_ld_im_th_7_0(data)                                    (0x000000FF&(data))
#define  ATSC_ADDR_2642_get_cr_ld_im_th_7_0(data)                                (0x000000FF&(data))

#define  ATSC_ADDR_2643                                                         0x1815590C
#define  ATSC_ADDR_2643_reg_addr                                                 "0xB815590C"
#define  ATSC_ADDR_2643_reg                                                      0xB815590C
#define  ATSC_ADDR_2643_inst_addr                                                "0x01B3"
#define  set_ATSC_ADDR_2643_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2643_reg)=data)
#define  get_ATSC_ADDR_2643_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2643_reg))
#define  ATSC_ADDR_2643_cr_ld_im_th_12_8_shift                                   (0)
#define  ATSC_ADDR_2643_cr_ld_im_th_12_8_mask                                    (0x0000001F)
#define  ATSC_ADDR_2643_cr_ld_im_th_12_8(data)                                   (0x0000001F&(data))
#define  ATSC_ADDR_2643_get_cr_ld_im_th_12_8(data)                               (0x0000001F&(data))

#define  ATSC_ADDR_2644                                                         0x18155910
#define  ATSC_ADDR_2644_reg_addr                                                 "0xB8155910"
#define  ATSC_ADDR_2644_reg                                                      0xB8155910
#define  ATSC_ADDR_2644_inst_addr                                                "0x01B4"
#define  set_ATSC_ADDR_2644_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2644_reg)=data)
#define  get_ATSC_ADDR_2644_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2644_reg))
#define  ATSC_ADDR_2644_cr_ld_cr_freq_diff_th_7_0_shift                          (0)
#define  ATSC_ADDR_2644_cr_ld_cr_freq_diff_th_7_0_mask                           (0x000000FF)
#define  ATSC_ADDR_2644_cr_ld_cr_freq_diff_th_7_0(data)                          (0x000000FF&(data))
#define  ATSC_ADDR_2644_get_cr_ld_cr_freq_diff_th_7_0(data)                      (0x000000FF&(data))

#define  ATSC_ADDR_2645                                                         0x18155914
#define  ATSC_ADDR_2645_reg_addr                                                 "0xB8155914"
#define  ATSC_ADDR_2645_reg                                                      0xB8155914
#define  ATSC_ADDR_2645_inst_addr                                                "0x01B5"
#define  set_ATSC_ADDR_2645_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2645_reg)=data)
#define  get_ATSC_ADDR_2645_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2645_reg))
#define  ATSC_ADDR_2645_cr_ld_cr_freq_diff_th_11_8_shift                         (0)
#define  ATSC_ADDR_2645_cr_ld_cr_freq_diff_th_11_8_mask                          (0x0000000F)
#define  ATSC_ADDR_2645_cr_ld_cr_freq_diff_th_11_8(data)                         (0x0000000F&(data))
#define  ATSC_ADDR_2645_get_cr_ld_cr_freq_diff_th_11_8(data)                     (0x0000000F&(data))

#define  ATSC_ADDR_2646                                                         0x18155918
#define  ATSC_ADDR_2646_reg_addr                                                 "0xB8155918"
#define  ATSC_ADDR_2646_reg                                                      0xB8155918
#define  ATSC_ADDR_2646_inst_addr                                                "0x01B6"
#define  set_ATSC_ADDR_2646_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2646_reg)=data)
#define  get_ATSC_ADDR_2646_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2646_reg))
#define  ATSC_ADDR_2646_cr_ld_re_th_ub_7_0_shift                                 (0)
#define  ATSC_ADDR_2646_cr_ld_re_th_ub_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_2646_cr_ld_re_th_ub_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2646_get_cr_ld_re_th_ub_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2647                                                         0x1815591C
#define  ATSC_ADDR_2647_reg_addr                                                 "0xB815591C"
#define  ATSC_ADDR_2647_reg                                                      0xB815591C
#define  ATSC_ADDR_2647_inst_addr                                                "0x01B7"
#define  set_ATSC_ADDR_2647_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2647_reg)=data)
#define  get_ATSC_ADDR_2647_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2647_reg))
#define  ATSC_ADDR_2647_cr_ld_re_th_ub_13_8_shift                                (0)
#define  ATSC_ADDR_2647_cr_ld_re_th_ub_13_8_mask                                 (0x0000003F)
#define  ATSC_ADDR_2647_cr_ld_re_th_ub_13_8(data)                                (0x0000003F&(data))
#define  ATSC_ADDR_2647_get_cr_ld_re_th_ub_13_8(data)                            (0x0000003F&(data))

#define  ATSC_ADDR_2648                                                         0x18155920
#define  ATSC_ADDR_2648_reg_addr                                                 "0xB8155920"
#define  ATSC_ADDR_2648_reg                                                      0xB8155920
#define  ATSC_ADDR_2648_inst_addr                                                "0x01B8"
#define  set_ATSC_ADDR_2648_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2648_reg)=data)
#define  get_ATSC_ADDR_2648_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2648_reg))
#define  ATSC_ADDR_2648_cr_large_freq_th_7_0_shift                               (0)
#define  ATSC_ADDR_2648_cr_large_freq_th_7_0_mask                                (0x000000FF)
#define  ATSC_ADDR_2648_cr_large_freq_th_7_0(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_2648_get_cr_large_freq_th_7_0(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_2649                                                         0x18155924
#define  ATSC_ADDR_2649_reg_addr                                                 "0xB8155924"
#define  ATSC_ADDR_2649_reg                                                      0xB8155924
#define  ATSC_ADDR_2649_inst_addr                                                "0x01B9"
#define  set_ATSC_ADDR_2649_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2649_reg)=data)
#define  get_ATSC_ADDR_2649_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2649_reg))
#define  ATSC_ADDR_2649_cr_large_freq_th_10_8_shift                              (0)
#define  ATSC_ADDR_2649_cr_large_freq_th_10_8_mask                               (0x00000007)
#define  ATSC_ADDR_2649_cr_large_freq_th_10_8(data)                              (0x00000007&(data))
#define  ATSC_ADDR_2649_get_cr_large_freq_th_10_8(data)                          (0x00000007&(data))

#define  ATSC_ADDR_264A                                                         0x18155928
#define  ATSC_ADDR_264A_reg_addr                                                 "0xB8155928"
#define  ATSC_ADDR_264A_reg                                                      0xB8155928
#define  ATSC_ADDR_264A_inst_addr                                                "0x01BA"
#define  set_ATSC_ADDR_264A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_264A_reg)=data)
#define  get_ATSC_ADDR_264A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_264A_reg))
#define  ATSC_ADDR_264A_cr_fmu_pn_comp_shift                                     (3)
#define  ATSC_ADDR_264A_cr_pmu_pn_comp_shift                                     (0)
#define  ATSC_ADDR_264A_cr_fmu_pn_comp_mask                                      (0x00000038)
#define  ATSC_ADDR_264A_cr_pmu_pn_comp_mask                                      (0x00000007)
#define  ATSC_ADDR_264A_cr_fmu_pn_comp(data)                                     (0x00000038&((data)<<3))
#define  ATSC_ADDR_264A_cr_pmu_pn_comp(data)                                     (0x00000007&(data))
#define  ATSC_ADDR_264A_get_cr_fmu_pn_comp(data)                                 ((0x00000038&(data))>>3)
#define  ATSC_ADDR_264A_get_cr_pmu_pn_comp(data)                                 (0x00000007&(data))

#define  ATSC_ADDR_2002                                                         0x18154008
#define  ATSC_ADDR_2002_reg_addr                                                 "0xB8154008"
#define  ATSC_ADDR_2002_reg                                                      0xB8154008
#define  ATSC_ADDR_2002_inst_addr                                                "0x01BB"
#define  set_ATSC_ADDR_2002_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2002_reg)=data)
#define  get_ATSC_ADDR_2002_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2002_reg))
#define  ATSC_ADDR_2002_cr_cr2_carer_shift                                       (5)
#define  ATSC_ADDR_2002_cr_cr2_carb_shift                                        (2)
#define  ATSC_ADDR_2002_cr_cr2_en_sel_shift                                      (0)
#define  ATSC_ADDR_2002_cr_cr2_carer_mask                                        (0x00000020)
#define  ATSC_ADDR_2002_cr_cr2_carb_mask                                         (0x0000001C)
#define  ATSC_ADDR_2002_cr_cr2_en_sel_mask                                       (0x00000003)
#define  ATSC_ADDR_2002_cr_cr2_carer(data)                                       (0x00000020&((data)<<5))
#define  ATSC_ADDR_2002_cr_cr2_carb(data)                                        (0x0000001C&((data)<<2))
#define  ATSC_ADDR_2002_cr_cr2_en_sel(data)                                      (0x00000003&(data))
#define  ATSC_ADDR_2002_get_cr_cr2_carer(data)                                   ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2002_get_cr_cr2_carb(data)                                    ((0x0000001C&(data))>>2)
#define  ATSC_ADDR_2002_get_cr_cr2_en_sel(data)                                  (0x00000003&(data))

#define  ATSC_ADDR_2003                                                         0x1815400C
#define  ATSC_ADDR_2003_reg_addr                                                 "0xB815400C"
#define  ATSC_ADDR_2003_reg                                                      0xB815400C
#define  ATSC_ADDR_2003_inst_addr                                                "0x01BC"
#define  set_ATSC_ADDR_2003_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2003_reg)=data)
#define  get_ATSC_ADDR_2003_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2003_reg))
#define  ATSC_ADDR_2003_cr_cr2_cargi_shift                                       (4)
#define  ATSC_ADDR_2003_cr_cr2_cargp_shift                                       (0)
#define  ATSC_ADDR_2003_cr_cr2_cargi_mask                                        (0x00000070)
#define  ATSC_ADDR_2003_cr_cr2_cargp_mask                                        (0x0000000F)
#define  ATSC_ADDR_2003_cr_cr2_cargi(data)                                       (0x00000070&((data)<<4))
#define  ATSC_ADDR_2003_cr_cr2_cargp(data)                                       (0x0000000F&(data))
#define  ATSC_ADDR_2003_get_cr_cr2_cargi(data)                                   ((0x00000070&(data))>>4)
#define  ATSC_ADDR_2003_get_cr_cr2_cargp(data)                                   (0x0000000F&(data))

#define  ATSC_ADDR_2E51                                                         0x18157944
#define  ATSC_ADDR_2E51_reg_addr                                                 "0xB8157944"
#define  ATSC_ADDR_2E51_reg                                                      0xB8157944
#define  ATSC_ADDR_2E51_inst_addr                                                "0x01BD"
#define  set_ATSC_ADDR_2E51_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E51_reg)=data)
#define  get_ATSC_ADDR_2E51_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E51_reg))
#define  ATSC_ADDR_2E51_cr_pmu_cr2_nb_comp_4_0_shift                             (3)
#define  ATSC_ADDR_2E51_cr_fmu_cr2_nb_comp_5_3_shift                             (0)
#define  ATSC_ADDR_2E51_cr_pmu_cr2_nb_comp_4_0_mask                              (0x000000F8)
#define  ATSC_ADDR_2E51_cr_fmu_cr2_nb_comp_5_3_mask                              (0x00000007)
#define  ATSC_ADDR_2E51_cr_pmu_cr2_nb_comp_4_0(data)                             (0x000000F8&((data)<<3))
#define  ATSC_ADDR_2E51_cr_fmu_cr2_nb_comp_5_3(data)                             (0x00000007&(data))
#define  ATSC_ADDR_2E51_get_cr_pmu_cr2_nb_comp_4_0(data)                         ((0x000000F8&(data))>>3)
#define  ATSC_ADDR_2E51_get_cr_fmu_cr2_nb_comp_5_3(data)                         (0x00000007&(data))

#define  ATSC_ADDR_2E52                                                         0x18157948
#define  ATSC_ADDR_2E52_reg_addr                                                 "0xB8157948"
#define  ATSC_ADDR_2E52_reg                                                      0xB8157948
#define  ATSC_ADDR_2E52_inst_addr                                                "0x01BE"
#define  set_ATSC_ADDR_2E52_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E52_reg)=data)
#define  get_ATSC_ADDR_2E52_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E52_reg))
#define  ATSC_ADDR_2E52_cr_pmu_cr2_wb_comp_0_shift                               (7)
#define  ATSC_ADDR_2E52_cr_fmu_cr2_wb_comp_shift                                 (1)
#define  ATSC_ADDR_2E52_cr_pmu_cr2_nb_comp_5_shift                               (0)
#define  ATSC_ADDR_2E52_cr_pmu_cr2_wb_comp_0_mask                                (0x00000080)
#define  ATSC_ADDR_2E52_cr_fmu_cr2_wb_comp_mask                                  (0x0000007E)
#define  ATSC_ADDR_2E52_cr_pmu_cr2_nb_comp_5_mask                                (0x00000001)
#define  ATSC_ADDR_2E52_cr_pmu_cr2_wb_comp_0(data)                               (0x00000080&((data)<<7))
#define  ATSC_ADDR_2E52_cr_fmu_cr2_wb_comp(data)                                 (0x0000007E&((data)<<1))
#define  ATSC_ADDR_2E52_cr_pmu_cr2_nb_comp_5(data)                               (0x00000001&(data))
#define  ATSC_ADDR_2E52_get_cr_pmu_cr2_wb_comp_0(data)                           ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2E52_get_cr_fmu_cr2_wb_comp(data)                             ((0x0000007E&(data))>>1)
#define  ATSC_ADDR_2E52_get_cr_pmu_cr2_nb_comp_5(data)                           (0x00000001&(data))

#define  ATSC_ADDR_2E53                                                         0x1815794C
#define  ATSC_ADDR_2E53_reg_addr                                                 "0xB815794C"
#define  ATSC_ADDR_2E53_reg                                                      0xB815794C
#define  ATSC_ADDR_2E53_inst_addr                                                "0x01BF"
#define  set_ATSC_ADDR_2E53_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E53_reg)=data)
#define  get_ATSC_ADDR_2E53_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E53_reg))
#define  ATSC_ADDR_2E53_cr_cr2_carb_wb_shift                                     (5)
#define  ATSC_ADDR_2E53_cr_pmu_cr2_wb_comp_5_1_shift                             (0)
#define  ATSC_ADDR_2E53_cr_cr2_carb_wb_mask                                      (0x000000E0)
#define  ATSC_ADDR_2E53_cr_pmu_cr2_wb_comp_5_1_mask                              (0x0000001F)
#define  ATSC_ADDR_2E53_cr_cr2_carb_wb(data)                                     (0x000000E0&((data)<<5))
#define  ATSC_ADDR_2E53_cr_pmu_cr2_wb_comp_5_1(data)                             (0x0000001F&(data))
#define  ATSC_ADDR_2E53_get_cr_cr2_carb_wb(data)                                 ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_2E53_get_cr_pmu_cr2_wb_comp_5_1(data)                         (0x0000001F&(data))

#define  ATSC_ADDR_2E54                                                         0x18157950
#define  ATSC_ADDR_2E54_reg_addr                                                 "0xB8157950"
#define  ATSC_ADDR_2E54_reg                                                      0xB8157950
#define  ATSC_ADDR_2E54_inst_addr                                                "0x01C0"
#define  set_ATSC_ADDR_2E54_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E54_reg)=data)
#define  get_ATSC_ADDR_2E54_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E54_reg))
#define  ATSC_ADDR_2E54_cr_cr2_cargi_nb_1_0_shift                                (6)
#define  ATSC_ADDR_2E54_cr_cr2_cargi_wb_shift                                    (3)
#define  ATSC_ADDR_2E54_cr_cr2_carb_nb_shift                                     (0)
#define  ATSC_ADDR_2E54_cr_cr2_cargi_nb_1_0_mask                                 (0x000000C0)
#define  ATSC_ADDR_2E54_cr_cr2_cargi_wb_mask                                     (0x00000038)
#define  ATSC_ADDR_2E54_cr_cr2_carb_nb_mask                                      (0x00000007)
#define  ATSC_ADDR_2E54_cr_cr2_cargi_nb_1_0(data)                                (0x000000C0&((data)<<6))
#define  ATSC_ADDR_2E54_cr_cr2_cargi_wb(data)                                    (0x00000038&((data)<<3))
#define  ATSC_ADDR_2E54_cr_cr2_carb_nb(data)                                     (0x00000007&(data))
#define  ATSC_ADDR_2E54_get_cr_cr2_cargi_nb_1_0(data)                            ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_2E54_get_cr_cr2_cargi_wb(data)                                ((0x00000038&(data))>>3)
#define  ATSC_ADDR_2E54_get_cr_cr2_carb_nb(data)                                 (0x00000007&(data))

#define  ATSC_ADDR_2E55                                                         0x18157954
#define  ATSC_ADDR_2E55_reg_addr                                                 "0xB8157954"
#define  ATSC_ADDR_2E55_reg                                                      0xB8157954
#define  ATSC_ADDR_2E55_inst_addr                                                "0x01C1"
#define  set_ATSC_ADDR_2E55_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E55_reg)=data)
#define  get_ATSC_ADDR_2E55_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E55_reg))
#define  ATSC_ADDR_2E55_cr_cr2_cr_offset_tilt_smp_thd_0_shift                    (7)
#define  ATSC_ADDR_2E55_cr_cr2_start_state_shift                                 (1)
#define  ATSC_ADDR_2E55_cr_cr2_cargi_nb_2_shift                                  (0)
#define  ATSC_ADDR_2E55_cr_cr2_cr_offset_tilt_smp_thd_0_mask                     (0x00000080)
#define  ATSC_ADDR_2E55_cr_cr2_start_state_mask                                  (0x0000007E)
#define  ATSC_ADDR_2E55_cr_cr2_cargi_nb_2_mask                                   (0x00000001)
#define  ATSC_ADDR_2E55_cr_cr2_cr_offset_tilt_smp_thd_0(data)                    (0x00000080&((data)<<7))
#define  ATSC_ADDR_2E55_cr_cr2_start_state(data)                                 (0x0000007E&((data)<<1))
#define  ATSC_ADDR_2E55_cr_cr2_cargi_nb_2(data)                                  (0x00000001&(data))
#define  ATSC_ADDR_2E55_get_cr_cr2_cr_offset_tilt_smp_thd_0(data)                ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2E55_get_cr_cr2_start_state(data)                             ((0x0000007E&(data))>>1)
#define  ATSC_ADDR_2E55_get_cr_cr2_cargi_nb_2(data)                              (0x00000001&(data))

#define  ATSC_ADDR_2E56                                                         0x18157958
#define  ATSC_ADDR_2E56_reg_addr                                                 "0xB8157958"
#define  ATSC_ADDR_2E56_reg                                                      0xB8157958
#define  ATSC_ADDR_2E56_inst_addr                                                "0x01C2"
#define  set_ATSC_ADDR_2E56_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E56_reg)=data)
#define  get_ATSC_ADDR_2E56_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E56_reg))
#define  ATSC_ADDR_2E56_cr_cr2_cr_offset_tilt_smp_thd_8_1_shift                  (0)
#define  ATSC_ADDR_2E56_cr_cr2_cr_offset_tilt_smp_thd_8_1_mask                   (0x000000FF)
#define  ATSC_ADDR_2E56_cr_cr2_cr_offset_tilt_smp_thd_8_1(data)                  (0x000000FF&(data))
#define  ATSC_ADDR_2E56_get_cr_cr2_cr_offset_tilt_smp_thd_8_1(data)              (0x000000FF&(data))

#define  ATSC_ADDR_2E57                                                         0x1815795C
#define  ATSC_ADDR_2E57_reg_addr                                                 "0xB815795C"
#define  ATSC_ADDR_2E57_reg                                                      0xB815795C
#define  ATSC_ADDR_2E57_inst_addr                                                "0x01C3"
#define  set_ATSC_ADDR_2E57_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E57_reg)=data)
#define  get_ATSC_ADDR_2E57_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E57_reg))
#define  ATSC_ADDR_2E57_cr_cr2_cr_offset_tilt_val_thd_3_0_shift                  (4)
#define  ATSC_ADDR_2E57_cr_cr2_cr_offset_tilt_smp_thd_12_9_shift                 (0)
#define  ATSC_ADDR_2E57_cr_cr2_cr_offset_tilt_val_thd_3_0_mask                   (0x000000F0)
#define  ATSC_ADDR_2E57_cr_cr2_cr_offset_tilt_smp_thd_12_9_mask                  (0x0000000F)
#define  ATSC_ADDR_2E57_cr_cr2_cr_offset_tilt_val_thd_3_0(data)                  (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2E57_cr_cr2_cr_offset_tilt_smp_thd_12_9(data)                 (0x0000000F&(data))
#define  ATSC_ADDR_2E57_get_cr_cr2_cr_offset_tilt_val_thd_3_0(data)              ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2E57_get_cr_cr2_cr_offset_tilt_smp_thd_12_9(data)             (0x0000000F&(data))

#define  ATSC_ADDR_2E58                                                         0x18157960
#define  ATSC_ADDR_2E58_reg_addr                                                 "0xB8157960"
#define  ATSC_ADDR_2E58_reg                                                      0xB8157960
#define  ATSC_ADDR_2E58_inst_addr                                                "0x01C4"
#define  set_ATSC_ADDR_2E58_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E58_reg)=data)
#define  get_ATSC_ADDR_2E58_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E58_reg))
#define  ATSC_ADDR_2E58_cr_cr2_cr_offset_tilt_val_thd_11_4_shift                 (0)
#define  ATSC_ADDR_2E58_cr_cr2_cr_offset_tilt_val_thd_11_4_mask                  (0x000000FF)
#define  ATSC_ADDR_2E58_cr_cr2_cr_offset_tilt_val_thd_11_4(data)                 (0x000000FF&(data))
#define  ATSC_ADDR_2E58_get_cr_cr2_cr_offset_tilt_val_thd_11_4(data)             (0x000000FF&(data))

#define  ATSC_ADDR_2E59                                                         0x18157964
#define  ATSC_ADDR_2E59_reg_addr                                                 "0xB8157964"
#define  ATSC_ADDR_2E59_reg                                                      0xB8157964
#define  ATSC_ADDR_2E59_inst_addr                                                "0x01C5"
#define  set_ATSC_ADDR_2E59_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E59_reg)=data)
#define  get_ATSC_ADDR_2E59_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E59_reg))
#define  ATSC_ADDR_2E59_cr_cr2_cr_offset_tilt_val_thd_19_12_shift                (0)
#define  ATSC_ADDR_2E59_cr_cr2_cr_offset_tilt_val_thd_19_12_mask                 (0x000000FF)
#define  ATSC_ADDR_2E59_cr_cr2_cr_offset_tilt_val_thd_19_12(data)                (0x000000FF&(data))
#define  ATSC_ADDR_2E59_get_cr_cr2_cr_offset_tilt_val_thd_19_12(data)            (0x000000FF&(data))

#define  ATSC_ADDR_2E5A                                                         0x18157968
#define  ATSC_ADDR_2E5A_reg_addr                                                 "0xB8157968"
#define  ATSC_ADDR_2E5A_reg                                                      0xB8157968
#define  ATSC_ADDR_2E5A_inst_addr                                                "0x01C6"
#define  set_ATSC_ADDR_2E5A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E5A_reg)=data)
#define  get_ATSC_ADDR_2E5A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E5A_reg))
#define  ATSC_ADDR_2E5A_cr_cr2_cr_offset_tilt_val_thd_27_20_shift                (0)
#define  ATSC_ADDR_2E5A_cr_cr2_cr_offset_tilt_val_thd_27_20_mask                 (0x000000FF)
#define  ATSC_ADDR_2E5A_cr_cr2_cr_offset_tilt_val_thd_27_20(data)                (0x000000FF&(data))
#define  ATSC_ADDR_2E5A_get_cr_cr2_cr_offset_tilt_val_thd_27_20(data)            (0x000000FF&(data))

#define  ATSC_ADDR_2E5B                                                         0x1815796C
#define  ATSC_ADDR_2E5B_reg_addr                                                 "0xB815796C"
#define  ATSC_ADDR_2E5B_reg                                                      0xB815796C
#define  ATSC_ADDR_2E5B_inst_addr                                                "0x01C7"
#define  set_ATSC_ADDR_2E5B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E5B_reg)=data)
#define  get_ATSC_ADDR_2E5B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E5B_reg))
#define  ATSC_ADDR_2E5B_cr_cr2_cr_offset_lpf_sft_sel_1_0_shift                   (6)
#define  ATSC_ADDR_2E5B_cr_cr2_cr_offset_tilt_val_thd_32_28_shift                (0)
#define  ATSC_ADDR_2E5B_cr_cr2_cr_offset_lpf_sft_sel_1_0_mask                    (0x000000C0)
#define  ATSC_ADDR_2E5B_cr_cr2_cr_offset_tilt_val_thd_32_28_mask                 (0x0000001F)
#define  ATSC_ADDR_2E5B_cr_cr2_cr_offset_lpf_sft_sel_1_0(data)                   (0x000000C0&((data)<<6))
#define  ATSC_ADDR_2E5B_cr_cr2_cr_offset_tilt_val_thd_32_28(data)                (0x0000001F&(data))
#define  ATSC_ADDR_2E5B_get_cr_cr2_cr_offset_lpf_sft_sel_1_0(data)               ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_2E5B_get_cr_cr2_cr_offset_tilt_val_thd_32_28(data)            (0x0000001F&(data))

#define  ATSC_ADDR_2E5C                                                         0x18157970
#define  ATSC_ADDR_2E5C_reg_addr                                                 "0xB8157970"
#define  ATSC_ADDR_2E5C_reg                                                      0xB8157970
#define  ATSC_ADDR_2E5C_inst_addr                                                "0x01C8"
#define  set_ATSC_ADDR_2E5C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E5C_reg)=data)
#define  get_ATSC_ADDR_2E5C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E5C_reg))
#define  ATSC_ADDR_2E5C_cr_cr2_cr_offset_tilt_cnt_inc_1_0_shift                  (6)
#define  ATSC_ADDR_2E5C_cr_cr2_swbw_ofa_shift                                    (5)
#define  ATSC_ADDR_2E5C_cr_cr2_swbw_cond_sel_shift                               (1)
#define  ATSC_ADDR_2E5C_cr_cr2_cr_offset_lpf_sft_sel_2_shift                     (0)
#define  ATSC_ADDR_2E5C_cr_cr2_cr_offset_tilt_cnt_inc_1_0_mask                   (0x000000C0)
#define  ATSC_ADDR_2E5C_cr_cr2_swbw_ofa_mask                                     (0x00000020)
#define  ATSC_ADDR_2E5C_cr_cr2_swbw_cond_sel_mask                                (0x0000001E)
#define  ATSC_ADDR_2E5C_cr_cr2_cr_offset_lpf_sft_sel_2_mask                      (0x00000001)
#define  ATSC_ADDR_2E5C_cr_cr2_cr_offset_tilt_cnt_inc_1_0(data)                  (0x000000C0&((data)<<6))
#define  ATSC_ADDR_2E5C_cr_cr2_swbw_ofa(data)                                    (0x00000020&((data)<<5))
#define  ATSC_ADDR_2E5C_cr_cr2_swbw_cond_sel(data)                               (0x0000001E&((data)<<1))
#define  ATSC_ADDR_2E5C_cr_cr2_cr_offset_lpf_sft_sel_2(data)                     (0x00000001&(data))
#define  ATSC_ADDR_2E5C_get_cr_cr2_cr_offset_tilt_cnt_inc_1_0(data)              ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_2E5C_get_cr_cr2_swbw_ofa(data)                                ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2E5C_get_cr_cr2_swbw_cond_sel(data)                           ((0x0000001E&(data))>>1)
#define  ATSC_ADDR_2E5C_get_cr_cr2_cr_offset_lpf_sft_sel_2(data)                 (0x00000001&(data))

#define  ATSC_ADDR_2E5D                                                         0x18157974
#define  ATSC_ADDR_2E5D_reg_addr                                                 "0xB8157974"
#define  ATSC_ADDR_2E5D_reg                                                      0xB8157974
#define  ATSC_ADDR_2E5D_inst_addr                                                "0x01C9"
#define  set_ATSC_ADDR_2E5D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E5D_reg)=data)
#define  get_ATSC_ADDR_2E5D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E5D_reg))
#define  ATSC_ADDR_2E5D_cr_cr2_cr_offset_tilt_cnt_dec_1_0_shift                  (6)
#define  ATSC_ADDR_2E5D_cr_cr2_cr_offset_tilt_cnt_inc_7_2_shift                  (0)
#define  ATSC_ADDR_2E5D_cr_cr2_cr_offset_tilt_cnt_dec_1_0_mask                   (0x000000C0)
#define  ATSC_ADDR_2E5D_cr_cr2_cr_offset_tilt_cnt_inc_7_2_mask                   (0x0000003F)
#define  ATSC_ADDR_2E5D_cr_cr2_cr_offset_tilt_cnt_dec_1_0(data)                  (0x000000C0&((data)<<6))
#define  ATSC_ADDR_2E5D_cr_cr2_cr_offset_tilt_cnt_inc_7_2(data)                  (0x0000003F&(data))
#define  ATSC_ADDR_2E5D_get_cr_cr2_cr_offset_tilt_cnt_dec_1_0(data)              ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_2E5D_get_cr_cr2_cr_offset_tilt_cnt_inc_7_2(data)              (0x0000003F&(data))

#define  ATSC_ADDR_2E5E                                                         0x18157978
#define  ATSC_ADDR_2E5E_reg_addr                                                 "0xB8157978"
#define  ATSC_ADDR_2E5E_reg                                                      0xB8157978
#define  ATSC_ADDR_2E5E_inst_addr                                                "0x01CA"
#define  set_ATSC_ADDR_2E5E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E5E_reg)=data)
#define  get_ATSC_ADDR_2E5E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E5E_reg))
#define  ATSC_ADDR_2E5E_cr_cr2_cr_offset_tilt_cnt_thd_6_0_shift                  (1)
#define  ATSC_ADDR_2E5E_cr_cr2_cr_offset_tilt_cnt_dec_2_shift                    (0)
#define  ATSC_ADDR_2E5E_cr_cr2_cr_offset_tilt_cnt_thd_6_0_mask                   (0x000000FE)
#define  ATSC_ADDR_2E5E_cr_cr2_cr_offset_tilt_cnt_dec_2_mask                     (0x00000001)
#define  ATSC_ADDR_2E5E_cr_cr2_cr_offset_tilt_cnt_thd_6_0(data)                  (0x000000FE&((data)<<1))
#define  ATSC_ADDR_2E5E_cr_cr2_cr_offset_tilt_cnt_dec_2(data)                    (0x00000001&(data))
#define  ATSC_ADDR_2E5E_get_cr_cr2_cr_offset_tilt_cnt_thd_6_0(data)              ((0x000000FE&(data))>>1)
#define  ATSC_ADDR_2E5E_get_cr_cr2_cr_offset_tilt_cnt_dec_2(data)                (0x00000001&(data))

#define  ATSC_ADDR_2E5F                                                         0x1815797C
#define  ATSC_ADDR_2E5F_reg_addr                                                 "0xB815797C"
#define  ATSC_ADDR_2E5F_reg                                                      0xB815797C
#define  ATSC_ADDR_2E5F_inst_addr                                                "0x01CB"
#define  set_ATSC_ADDR_2E5F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E5F_reg)=data)
#define  get_ATSC_ADDR_2E5F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E5F_reg))
#define  ATSC_ADDR_2E5F_cr_cr2_cr_offset_tilt_cnt_max_6_0_shift                  (1)
#define  ATSC_ADDR_2E5F_cr_cr2_cr_offset_tilt_cnt_thd_7_shift                    (0)
#define  ATSC_ADDR_2E5F_cr_cr2_cr_offset_tilt_cnt_max_6_0_mask                   (0x000000FE)
#define  ATSC_ADDR_2E5F_cr_cr2_cr_offset_tilt_cnt_thd_7_mask                     (0x00000001)
#define  ATSC_ADDR_2E5F_cr_cr2_cr_offset_tilt_cnt_max_6_0(data)                  (0x000000FE&((data)<<1))
#define  ATSC_ADDR_2E5F_cr_cr2_cr_offset_tilt_cnt_thd_7(data)                    (0x00000001&(data))
#define  ATSC_ADDR_2E5F_get_cr_cr2_cr_offset_tilt_cnt_max_6_0(data)              ((0x000000FE&(data))>>1)
#define  ATSC_ADDR_2E5F_get_cr_cr2_cr_offset_tilt_cnt_thd_7(data)                (0x00000001&(data))

#define  ATSC_ADDR_2E60                                                         0x18157980
#define  ATSC_ADDR_2E60_reg_addr                                                 "0xB8157980"
#define  ATSC_ADDR_2E60_reg                                                      0xB8157980
#define  ATSC_ADDR_2E60_inst_addr                                                "0x01CC"
#define  set_ATSC_ADDR_2E60_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E60_reg)=data)
#define  get_ATSC_ADDR_2E60_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E60_reg))
#define  ATSC_ADDR_2E60_cci_rej_bypass_buf_shift                                 (3)
#define  ATSC_ADDR_2E60_comp_buf_out_shift                                       (2)
#define  ATSC_ADDR_2E60_tr_fs_ped_int_en_shift                                   (1)
#define  ATSC_ADDR_2E60_cr_cr2_cr_offset_tilt_cnt_max_7_shift                    (0)
#define  ATSC_ADDR_2E60_cci_rej_bypass_buf_mask                                  (0x00000008)
#define  ATSC_ADDR_2E60_comp_buf_out_mask                                        (0x00000004)
#define  ATSC_ADDR_2E60_tr_fs_ped_int_en_mask                                    (0x00000002)
#define  ATSC_ADDR_2E60_cr_cr2_cr_offset_tilt_cnt_max_7_mask                     (0x00000001)
#define  ATSC_ADDR_2E60_cci_rej_bypass_buf(data)                                 (0x00000008&((data)<<3))
#define  ATSC_ADDR_2E60_comp_buf_out(data)                                       (0x00000004&((data)<<2))
#define  ATSC_ADDR_2E60_tr_fs_ped_int_en(data)                                   (0x00000002&((data)<<1))
#define  ATSC_ADDR_2E60_cr_cr2_cr_offset_tilt_cnt_max_7(data)                    (0x00000001&(data))
#define  ATSC_ADDR_2E60_get_cci_rej_bypass_buf(data)                             ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2E60_get_comp_buf_out(data)                                   ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2E60_get_tr_fs_ped_int_en(data)                               ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2E60_get_cr_cr2_cr_offset_tilt_cnt_max_7(data)                (0x00000001&(data))

#define  ATSC_ADDR_2E61                                                         0x18157984
#define  ATSC_ADDR_2E61_reg_addr                                                 "0xB8157984"
#define  ATSC_ADDR_2E61_reg                                                      0xB8157984
#define  ATSC_ADDR_2E61_inst_addr                                                "0x01CD"
#define  set_ATSC_ADDR_2E61_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E61_reg)=data)
#define  get_ATSC_ADDR_2E61_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E61_reg))
#define  ATSC_ADDR_2E61_cr_cr2_swbw_shift                                        (4)
#define  ATSC_ADDR_2E61_cr_cr2_cr_offset_tilt_val_flag_shift                     (3)
#define  ATSC_ADDR_2E61_cr_cr2_cr_offset_tilt_smp_flag_shift                     (2)
#define  ATSC_ADDR_2E61_cr_cr2_cr_offset_large_flag2_shift                       (1)
#define  ATSC_ADDR_2E61_cr_cr2_cr_offset_large_flag_shift                        (0)
#define  ATSC_ADDR_2E61_cr_cr2_swbw_mask                                         (0x00000010)
#define  ATSC_ADDR_2E61_cr_cr2_cr_offset_tilt_val_flag_mask                      (0x00000008)
#define  ATSC_ADDR_2E61_cr_cr2_cr_offset_tilt_smp_flag_mask                      (0x00000004)
#define  ATSC_ADDR_2E61_cr_cr2_cr_offset_large_flag2_mask                        (0x00000002)
#define  ATSC_ADDR_2E61_cr_cr2_cr_offset_large_flag_mask                         (0x00000001)
#define  ATSC_ADDR_2E61_cr_cr2_swbw(data)                                        (0x00000010&((data)<<4))
#define  ATSC_ADDR_2E61_cr_cr2_cr_offset_tilt_val_flag(data)                     (0x00000008&((data)<<3))
#define  ATSC_ADDR_2E61_cr_cr2_cr_offset_tilt_smp_flag(data)                     (0x00000004&((data)<<2))
#define  ATSC_ADDR_2E61_cr_cr2_cr_offset_large_flag2(data)                       (0x00000002&((data)<<1))
#define  ATSC_ADDR_2E61_cr_cr2_cr_offset_large_flag(data)                        (0x00000001&(data))
#define  ATSC_ADDR_2E61_get_cr_cr2_swbw(data)                                    ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2E61_get_cr_cr2_cr_offset_tilt_val_flag(data)                 ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2E61_get_cr_cr2_cr_offset_tilt_smp_flag(data)                 ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2E61_get_cr_cr2_cr_offset_large_flag2(data)                   ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2E61_get_cr_cr2_cr_offset_large_flag(data)                    (0x00000001&(data))

#define  ATSC_ADDR_2E62                                                         0x18157988
#define  ATSC_ADDR_2E62_reg_addr                                                 "0xB8157988"
#define  ATSC_ADDR_2E62_reg                                                      0xB8157988
#define  ATSC_ADDR_2E62_inst_addr                                                "0x01CE"
#define  set_ATSC_ADDR_2E62_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E62_reg)=data)
#define  get_ATSC_ADDR_2E62_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E62_reg))
#define  ATSC_ADDR_2E62_cci_iir_pos_0_6_0_shift                                  (1)
#define  ATSC_ADDR_2E62_cci_iir23_en_shift                                       (0)
#define  ATSC_ADDR_2E62_cci_iir_pos_0_6_0_mask                                   (0x000000FE)
#define  ATSC_ADDR_2E62_cci_iir23_en_mask                                        (0x00000001)
#define  ATSC_ADDR_2E62_cci_iir_pos_0_6_0(data)                                  (0x000000FE&((data)<<1))
#define  ATSC_ADDR_2E62_cci_iir23_en(data)                                       (0x00000001&(data))
#define  ATSC_ADDR_2E62_get_cci_iir_pos_0_6_0(data)                              ((0x000000FE&(data))>>1)
#define  ATSC_ADDR_2E62_get_cci_iir23_en(data)                                   (0x00000001&(data))

#define  ATSC_ADDR_2E63                                                         0x1815798C
#define  ATSC_ADDR_2E63_reg_addr                                                 "0xB815798C"
#define  ATSC_ADDR_2E63_reg                                                      0xB815798C
#define  ATSC_ADDR_2E63_inst_addr                                                "0x01CF"
#define  set_ATSC_ADDR_2E63_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E63_reg)=data)
#define  get_ATSC_ADDR_2E63_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E63_reg))
#define  ATSC_ADDR_2E63_cci_iir_freq_offset_1_0_shift                            (6)
#define  ATSC_ADDR_2E63_cci_iir_pos_0_12_7_shift                                 (0)
#define  ATSC_ADDR_2E63_cci_iir_freq_offset_1_0_mask                             (0x000000C0)
#define  ATSC_ADDR_2E63_cci_iir_pos_0_12_7_mask                                  (0x0000003F)
#define  ATSC_ADDR_2E63_cci_iir_freq_offset_1_0(data)                            (0x000000C0&((data)<<6))
#define  ATSC_ADDR_2E63_cci_iir_pos_0_12_7(data)                                 (0x0000003F&(data))
#define  ATSC_ADDR_2E63_get_cci_iir_freq_offset_1_0(data)                        ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_2E63_get_cci_iir_pos_0_12_7(data)                             (0x0000003F&(data))

#define  ATSC_ADDR_2E64                                                         0x18157990
#define  ATSC_ADDR_2E64_reg_addr                                                 "0xB8157990"
#define  ATSC_ADDR_2E64_reg                                                      0xB8157990
#define  ATSC_ADDR_2E64_inst_addr                                                "0x01D0"
#define  set_ATSC_ADDR_2E64_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E64_reg)=data)
#define  get_ATSC_ADDR_2E64_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E64_reg))
#define  ATSC_ADDR_2E64_cci_iir_g_ratio_m1_1_0_shift                             (6)
#define  ATSC_ADDR_2E64_cci_iir_g_ratio_m0_shift                                 (1)
#define  ATSC_ADDR_2E64_cci_iir_freq_offset_2_shift                              (0)
#define  ATSC_ADDR_2E64_cci_iir_g_ratio_m1_1_0_mask                              (0x000000C0)
#define  ATSC_ADDR_2E64_cci_iir_g_ratio_m0_mask                                  (0x0000003E)
#define  ATSC_ADDR_2E64_cci_iir_freq_offset_2_mask                               (0x00000001)
#define  ATSC_ADDR_2E64_cci_iir_g_ratio_m1_1_0(data)                             (0x000000C0&((data)<<6))
#define  ATSC_ADDR_2E64_cci_iir_g_ratio_m0(data)                                 (0x0000003E&((data)<<1))
#define  ATSC_ADDR_2E64_cci_iir_freq_offset_2(data)                              (0x00000001&(data))
#define  ATSC_ADDR_2E64_get_cci_iir_g_ratio_m1_1_0(data)                         ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_2E64_get_cci_iir_g_ratio_m0(data)                             ((0x0000003E&(data))>>1)
#define  ATSC_ADDR_2E64_get_cci_iir_freq_offset_2(data)                          (0x00000001&(data))

#define  ATSC_ADDR_2E65                                                         0x18157994
#define  ATSC_ADDR_2E65_reg_addr                                                 "0xB8157994"
#define  ATSC_ADDR_2E65_reg                                                      0xB8157994
#define  ATSC_ADDR_2E65_inst_addr                                                "0x01D1"
#define  set_ATSC_ADDR_2E65_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E65_reg)=data)
#define  get_ATSC_ADDR_2E65_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E65_reg))
#define  ATSC_ADDR_2E65_cci_iir_g_ratio_l0_shift                                 (3)
#define  ATSC_ADDR_2E65_cci_iir_g_ratio_m1_4_2_shift                             (0)
#define  ATSC_ADDR_2E65_cci_iir_g_ratio_l0_mask                                  (0x000000F8)
#define  ATSC_ADDR_2E65_cci_iir_g_ratio_m1_4_2_mask                              (0x00000007)
#define  ATSC_ADDR_2E65_cci_iir_g_ratio_l0(data)                                 (0x000000F8&((data)<<3))
#define  ATSC_ADDR_2E65_cci_iir_g_ratio_m1_4_2(data)                             (0x00000007&(data))
#define  ATSC_ADDR_2E65_get_cci_iir_g_ratio_l0(data)                             ((0x000000F8&(data))>>3)
#define  ATSC_ADDR_2E65_get_cci_iir_g_ratio_m1_4_2(data)                         (0x00000007&(data))

#define  ATSC_ADDR_2E66                                                         0x18157998
#define  ATSC_ADDR_2E66_reg_addr                                                 "0xB8157998"
#define  ATSC_ADDR_2E66_reg                                                      0xB8157998
#define  ATSC_ADDR_2E66_inst_addr                                                "0x01D2"
#define  set_ATSC_ADDR_2E66_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E66_reg)=data)
#define  get_ATSC_ADDR_2E66_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E66_reg))
#define  ATSC_ADDR_2E66_cci_iir_a_1_s1_2_0_shift                                 (5)
#define  ATSC_ADDR_2E66_cci_iir_g_ratio_l1_shift                                 (0)
#define  ATSC_ADDR_2E66_cci_iir_a_1_s1_2_0_mask                                  (0x000000E0)
#define  ATSC_ADDR_2E66_cci_iir_g_ratio_l1_mask                                  (0x0000001F)
#define  ATSC_ADDR_2E66_cci_iir_a_1_s1_2_0(data)                                 (0x000000E0&((data)<<5))
#define  ATSC_ADDR_2E66_cci_iir_g_ratio_l1(data)                                 (0x0000001F&(data))
#define  ATSC_ADDR_2E66_get_cci_iir_a_1_s1_2_0(data)                             ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_2E66_get_cci_iir_g_ratio_l1(data)                             (0x0000001F&(data))

#define  ATSC_ADDR_2E67                                                         0x1815799C
#define  ATSC_ADDR_2E67_reg_addr                                                 "0xB815799C"
#define  ATSC_ADDR_2E67_reg                                                      0xB815799C
#define  ATSC_ADDR_2E67_inst_addr                                                "0x01D3"
#define  set_ATSC_ADDR_2E67_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E67_reg)=data)
#define  get_ATSC_ADDR_2E67_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E67_reg))
#define  ATSC_ADDR_2E67_cci_iir_a_1_s1_10_3_shift                                (0)
#define  ATSC_ADDR_2E67_cci_iir_a_1_s1_10_3_mask                                 (0x000000FF)
#define  ATSC_ADDR_2E67_cci_iir_a_1_s1_10_3(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2E67_get_cci_iir_a_1_s1_10_3(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2E68                                                         0x181579A0
#define  ATSC_ADDR_2E68_reg_addr                                                 "0xB81579A0"
#define  ATSC_ADDR_2E68_reg                                                      0xB81579A0
#define  ATSC_ADDR_2E68_inst_addr                                                "0x01D4"
#define  set_ATSC_ADDR_2E68_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E68_reg)=data)
#define  get_ATSC_ADDR_2E68_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E68_reg))
#define  ATSC_ADDR_2E68_cci_iir_a_1_s1_18_11_shift                               (0)
#define  ATSC_ADDR_2E68_cci_iir_a_1_s1_18_11_mask                                (0x000000FF)
#define  ATSC_ADDR_2E68_cci_iir_a_1_s1_18_11(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_2E68_get_cci_iir_a_1_s1_18_11(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_2E69                                                         0x181579A4
#define  ATSC_ADDR_2E69_reg_addr                                                 "0xB81579A4"
#define  ATSC_ADDR_2E69_reg                                                      0xB81579A4
#define  ATSC_ADDR_2E69_inst_addr                                                "0x01D5"
#define  set_ATSC_ADDR_2E69_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E69_reg)=data)
#define  get_ATSC_ADDR_2E69_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E69_reg))
#define  ATSC_ADDR_2E69_cci_iir_a_2_s1_5_0_shift                                 (2)
#define  ATSC_ADDR_2E69_cci_iir_a_1_s1_20_19_shift                               (0)
#define  ATSC_ADDR_2E69_cci_iir_a_2_s1_5_0_mask                                  (0x000000FC)
#define  ATSC_ADDR_2E69_cci_iir_a_1_s1_20_19_mask                                (0x00000003)
#define  ATSC_ADDR_2E69_cci_iir_a_2_s1_5_0(data)                                 (0x000000FC&((data)<<2))
#define  ATSC_ADDR_2E69_cci_iir_a_1_s1_20_19(data)                               (0x00000003&(data))
#define  ATSC_ADDR_2E69_get_cci_iir_a_2_s1_5_0(data)                             ((0x000000FC&(data))>>2)
#define  ATSC_ADDR_2E69_get_cci_iir_a_1_s1_20_19(data)                           (0x00000003&(data))

#define  ATSC_ADDR_2E6A                                                         0x181579A8
#define  ATSC_ADDR_2E6A_reg_addr                                                 "0xB81579A8"
#define  ATSC_ADDR_2E6A_reg                                                      0xB81579A8
#define  ATSC_ADDR_2E6A_inst_addr                                                "0x01D6"
#define  set_ATSC_ADDR_2E6A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E6A_reg)=data)
#define  get_ATSC_ADDR_2E6A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E6A_reg))
#define  ATSC_ADDR_2E6A_cci_iir_a_2_s1_13_6_shift                                (0)
#define  ATSC_ADDR_2E6A_cci_iir_a_2_s1_13_6_mask                                 (0x000000FF)
#define  ATSC_ADDR_2E6A_cci_iir_a_2_s1_13_6(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2E6A_get_cci_iir_a_2_s1_13_6(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2E6B                                                         0x181579AC
#define  ATSC_ADDR_2E6B_reg_addr                                                 "0xB81579AC"
#define  ATSC_ADDR_2E6B_reg                                                      0xB81579AC
#define  ATSC_ADDR_2E6B_inst_addr                                                "0x01D7"
#define  set_ATSC_ADDR_2E6B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E6B_reg)=data)
#define  get_ATSC_ADDR_2E6B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E6B_reg))
#define  ATSC_ADDR_2E6B_cci_iir_b_0_s1_0_shift                                   (7)
#define  ATSC_ADDR_2E6B_cci_iir_a_2_s1_20_14_shift                               (0)
#define  ATSC_ADDR_2E6B_cci_iir_b_0_s1_0_mask                                    (0x00000080)
#define  ATSC_ADDR_2E6B_cci_iir_a_2_s1_20_14_mask                                (0x0000007F)
#define  ATSC_ADDR_2E6B_cci_iir_b_0_s1_0(data)                                   (0x00000080&((data)<<7))
#define  ATSC_ADDR_2E6B_cci_iir_a_2_s1_20_14(data)                               (0x0000007F&(data))
#define  ATSC_ADDR_2E6B_get_cci_iir_b_0_s1_0(data)                               ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2E6B_get_cci_iir_a_2_s1_20_14(data)                           (0x0000007F&(data))

#define  ATSC_ADDR_2E6C                                                         0x181579B0
#define  ATSC_ADDR_2E6C_reg_addr                                                 "0xB81579B0"
#define  ATSC_ADDR_2E6C_reg                                                      0xB81579B0
#define  ATSC_ADDR_2E6C_inst_addr                                                "0x01D8"
#define  set_ATSC_ADDR_2E6C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E6C_reg)=data)
#define  get_ATSC_ADDR_2E6C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E6C_reg))
#define  ATSC_ADDR_2E6C_cci_iir_b_0_s1_8_1_shift                                 (0)
#define  ATSC_ADDR_2E6C_cci_iir_b_0_s1_8_1_mask                                  (0x000000FF)
#define  ATSC_ADDR_2E6C_cci_iir_b_0_s1_8_1(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2E6C_get_cci_iir_b_0_s1_8_1(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2E6D                                                         0x181579B4
#define  ATSC_ADDR_2E6D_reg_addr                                                 "0xB81579B4"
#define  ATSC_ADDR_2E6D_reg                                                      0xB81579B4
#define  ATSC_ADDR_2E6D_inst_addr                                                "0x01D9"
#define  set_ATSC_ADDR_2E6D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E6D_reg)=data)
#define  get_ATSC_ADDR_2E6D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E6D_reg))
#define  ATSC_ADDR_2E6D_cci_iir_b_0_s1_16_9_shift                                (0)
#define  ATSC_ADDR_2E6D_cci_iir_b_0_s1_16_9_mask                                 (0x000000FF)
#define  ATSC_ADDR_2E6D_cci_iir_b_0_s1_16_9(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2E6D_get_cci_iir_b_0_s1_16_9(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2E6E                                                         0x181579B8
#define  ATSC_ADDR_2E6E_reg_addr                                                 "0xB81579B8"
#define  ATSC_ADDR_2E6E_reg                                                      0xB81579B8
#define  ATSC_ADDR_2E6E_inst_addr                                                "0x01DA"
#define  set_ATSC_ADDR_2E6E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E6E_reg)=data)
#define  get_ATSC_ADDR_2E6E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E6E_reg))
#define  ATSC_ADDR_2E6E_cci_iir_b_1_s1_3_0_shift                                 (4)
#define  ATSC_ADDR_2E6E_cci_iir_b_0_s1_20_17_shift                               (0)
#define  ATSC_ADDR_2E6E_cci_iir_b_1_s1_3_0_mask                                  (0x000000F0)
#define  ATSC_ADDR_2E6E_cci_iir_b_0_s1_20_17_mask                                (0x0000000F)
#define  ATSC_ADDR_2E6E_cci_iir_b_1_s1_3_0(data)                                 (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2E6E_cci_iir_b_0_s1_20_17(data)                               (0x0000000F&(data))
#define  ATSC_ADDR_2E6E_get_cci_iir_b_1_s1_3_0(data)                             ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2E6E_get_cci_iir_b_0_s1_20_17(data)                           (0x0000000F&(data))

#define  ATSC_ADDR_2E6F                                                         0x181579BC
#define  ATSC_ADDR_2E6F_reg_addr                                                 "0xB81579BC"
#define  ATSC_ADDR_2E6F_reg                                                      0xB81579BC
#define  ATSC_ADDR_2E6F_inst_addr                                                "0x01DB"
#define  set_ATSC_ADDR_2E6F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E6F_reg)=data)
#define  get_ATSC_ADDR_2E6F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E6F_reg))
#define  ATSC_ADDR_2E6F_cci_iir_b_1_s1_11_4_shift                                (0)
#define  ATSC_ADDR_2E6F_cci_iir_b_1_s1_11_4_mask                                 (0x000000FF)
#define  ATSC_ADDR_2E6F_cci_iir_b_1_s1_11_4(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2E6F_get_cci_iir_b_1_s1_11_4(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2E70                                                         0x181579C0
#define  ATSC_ADDR_2E70_reg_addr                                                 "0xB81579C0"
#define  ATSC_ADDR_2E70_reg                                                      0xB81579C0
#define  ATSC_ADDR_2E70_inst_addr                                                "0x01DC"
#define  set_ATSC_ADDR_2E70_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E70_reg)=data)
#define  get_ATSC_ADDR_2E70_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E70_reg))
#define  ATSC_ADDR_2E70_cci_iir_b_1_s1_19_12_shift                               (0)
#define  ATSC_ADDR_2E70_cci_iir_b_1_s1_19_12_mask                                (0x000000FF)
#define  ATSC_ADDR_2E70_cci_iir_b_1_s1_19_12(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_2E70_get_cci_iir_b_1_s1_19_12(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_2E71                                                         0x181579C4
#define  ATSC_ADDR_2E71_reg_addr                                                 "0xB81579C4"
#define  ATSC_ADDR_2E71_reg                                                      0xB81579C4
#define  ATSC_ADDR_2E71_inst_addr                                                "0x01DD"
#define  set_ATSC_ADDR_2E71_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E71_reg)=data)
#define  get_ATSC_ADDR_2E71_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E71_reg))
#define  ATSC_ADDR_2E71_cci_iir_b_2_s1_6_0_shift                                 (1)
#define  ATSC_ADDR_2E71_cci_iir_b_1_s1_20_shift                                  (0)
#define  ATSC_ADDR_2E71_cci_iir_b_2_s1_6_0_mask                                  (0x000000FE)
#define  ATSC_ADDR_2E71_cci_iir_b_1_s1_20_mask                                   (0x00000001)
#define  ATSC_ADDR_2E71_cci_iir_b_2_s1_6_0(data)                                 (0x000000FE&((data)<<1))
#define  ATSC_ADDR_2E71_cci_iir_b_1_s1_20(data)                                  (0x00000001&(data))
#define  ATSC_ADDR_2E71_get_cci_iir_b_2_s1_6_0(data)                             ((0x000000FE&(data))>>1)
#define  ATSC_ADDR_2E71_get_cci_iir_b_1_s1_20(data)                              (0x00000001&(data))

#define  ATSC_ADDR_2E72                                                         0x181579C8
#define  ATSC_ADDR_2E72_reg_addr                                                 "0xB81579C8"
#define  ATSC_ADDR_2E72_reg                                                      0xB81579C8
#define  ATSC_ADDR_2E72_inst_addr                                                "0x01DE"
#define  set_ATSC_ADDR_2E72_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E72_reg)=data)
#define  get_ATSC_ADDR_2E72_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E72_reg))
#define  ATSC_ADDR_2E72_cci_iir_b_2_s1_14_7_shift                                (0)
#define  ATSC_ADDR_2E72_cci_iir_b_2_s1_14_7_mask                                 (0x000000FF)
#define  ATSC_ADDR_2E72_cci_iir_b_2_s1_14_7(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2E72_get_cci_iir_b_2_s1_14_7(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2E73                                                         0x181579CC
#define  ATSC_ADDR_2E73_reg_addr                                                 "0xB81579CC"
#define  ATSC_ADDR_2E73_reg                                                      0xB81579CC
#define  ATSC_ADDR_2E73_inst_addr                                                "0x01DF"
#define  set_ATSC_ADDR_2E73_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E73_reg)=data)
#define  get_ATSC_ADDR_2E73_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E73_reg))
#define  ATSC_ADDR_2E73_cci_iir_a_1_m0_1_0_shift                                 (6)
#define  ATSC_ADDR_2E73_cci_iir_b_2_s1_20_15_shift                               (0)
#define  ATSC_ADDR_2E73_cci_iir_a_1_m0_1_0_mask                                  (0x000000C0)
#define  ATSC_ADDR_2E73_cci_iir_b_2_s1_20_15_mask                                (0x0000003F)
#define  ATSC_ADDR_2E73_cci_iir_a_1_m0_1_0(data)                                 (0x000000C0&((data)<<6))
#define  ATSC_ADDR_2E73_cci_iir_b_2_s1_20_15(data)                               (0x0000003F&(data))
#define  ATSC_ADDR_2E73_get_cci_iir_a_1_m0_1_0(data)                             ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_2E73_get_cci_iir_b_2_s1_20_15(data)                           (0x0000003F&(data))

#define  ATSC_ADDR_2E74                                                         0x181579D0
#define  ATSC_ADDR_2E74_reg_addr                                                 "0xB81579D0"
#define  ATSC_ADDR_2E74_reg                                                      0xB81579D0
#define  ATSC_ADDR_2E74_inst_addr                                                "0x01E0"
#define  set_ATSC_ADDR_2E74_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E74_reg)=data)
#define  get_ATSC_ADDR_2E74_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E74_reg))
#define  ATSC_ADDR_2E74_cci_iir_a_1_m0_9_2_shift                                 (0)
#define  ATSC_ADDR_2E74_cci_iir_a_1_m0_9_2_mask                                  (0x000000FF)
#define  ATSC_ADDR_2E74_cci_iir_a_1_m0_9_2(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2E74_get_cci_iir_a_1_m0_9_2(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2E75                                                         0x181579D4
#define  ATSC_ADDR_2E75_reg_addr                                                 "0xB81579D4"
#define  ATSC_ADDR_2E75_reg                                                      0xB81579D4
#define  ATSC_ADDR_2E75_inst_addr                                                "0x01E1"
#define  set_ATSC_ADDR_2E75_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E75_reg)=data)
#define  get_ATSC_ADDR_2E75_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E75_reg))
#define  ATSC_ADDR_2E75_cci_iir_a_1_m0_17_10_shift                               (0)
#define  ATSC_ADDR_2E75_cci_iir_a_1_m0_17_10_mask                                (0x000000FF)
#define  ATSC_ADDR_2E75_cci_iir_a_1_m0_17_10(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_2E75_get_cci_iir_a_1_m0_17_10(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_2E76                                                         0x181579D8
#define  ATSC_ADDR_2E76_reg_addr                                                 "0xB81579D8"
#define  ATSC_ADDR_2E76_reg                                                      0xB81579D8
#define  ATSC_ADDR_2E76_inst_addr                                                "0x01E2"
#define  set_ATSC_ADDR_2E76_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E76_reg)=data)
#define  get_ATSC_ADDR_2E76_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E76_reg))
#define  ATSC_ADDR_2E76_cci_iir_a_2_m0_4_0_shift                                 (3)
#define  ATSC_ADDR_2E76_cci_iir_a_1_m0_20_18_shift                               (0)
#define  ATSC_ADDR_2E76_cci_iir_a_2_m0_4_0_mask                                  (0x000000F8)
#define  ATSC_ADDR_2E76_cci_iir_a_1_m0_20_18_mask                                (0x00000007)
#define  ATSC_ADDR_2E76_cci_iir_a_2_m0_4_0(data)                                 (0x000000F8&((data)<<3))
#define  ATSC_ADDR_2E76_cci_iir_a_1_m0_20_18(data)                               (0x00000007&(data))
#define  ATSC_ADDR_2E76_get_cci_iir_a_2_m0_4_0(data)                             ((0x000000F8&(data))>>3)
#define  ATSC_ADDR_2E76_get_cci_iir_a_1_m0_20_18(data)                           (0x00000007&(data))

#define  ATSC_ADDR_2E77                                                         0x181579DC
#define  ATSC_ADDR_2E77_reg_addr                                                 "0xB81579DC"
#define  ATSC_ADDR_2E77_reg                                                      0xB81579DC
#define  ATSC_ADDR_2E77_inst_addr                                                "0x01E3"
#define  set_ATSC_ADDR_2E77_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E77_reg)=data)
#define  get_ATSC_ADDR_2E77_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E77_reg))
#define  ATSC_ADDR_2E77_cci_iir_a_2_m0_12_5_shift                                (0)
#define  ATSC_ADDR_2E77_cci_iir_a_2_m0_12_5_mask                                 (0x000000FF)
#define  ATSC_ADDR_2E77_cci_iir_a_2_m0_12_5(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2E77_get_cci_iir_a_2_m0_12_5(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2E78                                                         0x181579E0
#define  ATSC_ADDR_2E78_reg_addr                                                 "0xB81579E0"
#define  ATSC_ADDR_2E78_reg                                                      0xB81579E0
#define  ATSC_ADDR_2E78_inst_addr                                                "0x01E4"
#define  set_ATSC_ADDR_2E78_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E78_reg)=data)
#define  get_ATSC_ADDR_2E78_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E78_reg))
#define  ATSC_ADDR_2E78_cci_iir_a_2_m0_20_13_shift                               (0)
#define  ATSC_ADDR_2E78_cci_iir_a_2_m0_20_13_mask                                (0x000000FF)
#define  ATSC_ADDR_2E78_cci_iir_a_2_m0_20_13(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_2E78_get_cci_iir_a_2_m0_20_13(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_2E79                                                         0x181579E4
#define  ATSC_ADDR_2E79_reg_addr                                                 "0xB81579E4"
#define  ATSC_ADDR_2E79_reg                                                      0xB81579E4
#define  ATSC_ADDR_2E79_inst_addr                                                "0x01E5"
#define  set_ATSC_ADDR_2E79_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E79_reg)=data)
#define  get_ATSC_ADDR_2E79_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E79_reg))
#define  ATSC_ADDR_2E79_cci_iir_b_0_m0_7_0_shift                                 (0)
#define  ATSC_ADDR_2E79_cci_iir_b_0_m0_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_2E79_cci_iir_b_0_m0_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2E79_get_cci_iir_b_0_m0_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2E7A                                                         0x181579E8
#define  ATSC_ADDR_2E7A_reg_addr                                                 "0xB81579E8"
#define  ATSC_ADDR_2E7A_reg                                                      0xB81579E8
#define  ATSC_ADDR_2E7A_inst_addr                                                "0x01E6"
#define  set_ATSC_ADDR_2E7A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E7A_reg)=data)
#define  get_ATSC_ADDR_2E7A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E7A_reg))
#define  ATSC_ADDR_2E7A_cci_iir_b_0_m0_15_8_shift                                (0)
#define  ATSC_ADDR_2E7A_cci_iir_b_0_m0_15_8_mask                                 (0x000000FF)
#define  ATSC_ADDR_2E7A_cci_iir_b_0_m0_15_8(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2E7A_get_cci_iir_b_0_m0_15_8(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2E7B                                                         0x181579EC
#define  ATSC_ADDR_2E7B_reg_addr                                                 "0xB81579EC"
#define  ATSC_ADDR_2E7B_reg                                                      0xB81579EC
#define  ATSC_ADDR_2E7B_inst_addr                                                "0x01E7"
#define  set_ATSC_ADDR_2E7B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E7B_reg)=data)
#define  get_ATSC_ADDR_2E7B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E7B_reg))
#define  ATSC_ADDR_2E7B_cci_iir_b_1_m0_2_0_shift                                 (5)
#define  ATSC_ADDR_2E7B_cci_iir_b_0_m0_20_16_shift                               (0)
#define  ATSC_ADDR_2E7B_cci_iir_b_1_m0_2_0_mask                                  (0x000000E0)
#define  ATSC_ADDR_2E7B_cci_iir_b_0_m0_20_16_mask                                (0x0000001F)
#define  ATSC_ADDR_2E7B_cci_iir_b_1_m0_2_0(data)                                 (0x000000E0&((data)<<5))
#define  ATSC_ADDR_2E7B_cci_iir_b_0_m0_20_16(data)                               (0x0000001F&(data))
#define  ATSC_ADDR_2E7B_get_cci_iir_b_1_m0_2_0(data)                             ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_2E7B_get_cci_iir_b_0_m0_20_16(data)                           (0x0000001F&(data))

#define  ATSC_ADDR_2E7C                                                         0x181579F0
#define  ATSC_ADDR_2E7C_reg_addr                                                 "0xB81579F0"
#define  ATSC_ADDR_2E7C_reg                                                      0xB81579F0
#define  ATSC_ADDR_2E7C_inst_addr                                                "0x01E8"
#define  set_ATSC_ADDR_2E7C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E7C_reg)=data)
#define  get_ATSC_ADDR_2E7C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E7C_reg))
#define  ATSC_ADDR_2E7C_cci_iir_b_1_m0_10_3_shift                                (0)
#define  ATSC_ADDR_2E7C_cci_iir_b_1_m0_10_3_mask                                 (0x000000FF)
#define  ATSC_ADDR_2E7C_cci_iir_b_1_m0_10_3(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2E7C_get_cci_iir_b_1_m0_10_3(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2E7D                                                         0x181579F4
#define  ATSC_ADDR_2E7D_reg_addr                                                 "0xB81579F4"
#define  ATSC_ADDR_2E7D_reg                                                      0xB81579F4
#define  ATSC_ADDR_2E7D_inst_addr                                                "0x01E9"
#define  set_ATSC_ADDR_2E7D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E7D_reg)=data)
#define  get_ATSC_ADDR_2E7D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E7D_reg))
#define  ATSC_ADDR_2E7D_cci_iir_b_1_m0_18_11_shift                               (0)
#define  ATSC_ADDR_2E7D_cci_iir_b_1_m0_18_11_mask                                (0x000000FF)
#define  ATSC_ADDR_2E7D_cci_iir_b_1_m0_18_11(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_2E7D_get_cci_iir_b_1_m0_18_11(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_2E7E                                                         0x181579F8
#define  ATSC_ADDR_2E7E_reg_addr                                                 "0xB81579F8"
#define  ATSC_ADDR_2E7E_reg                                                      0xB81579F8
#define  ATSC_ADDR_2E7E_inst_addr                                                "0x01EA"
#define  set_ATSC_ADDR_2E7E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E7E_reg)=data)
#define  get_ATSC_ADDR_2E7E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E7E_reg))
#define  ATSC_ADDR_2E7E_cci_iir_b_2_m0_5_0_shift                                 (2)
#define  ATSC_ADDR_2E7E_cci_iir_b_1_m0_20_19_shift                               (0)
#define  ATSC_ADDR_2E7E_cci_iir_b_2_m0_5_0_mask                                  (0x000000FC)
#define  ATSC_ADDR_2E7E_cci_iir_b_1_m0_20_19_mask                                (0x00000003)
#define  ATSC_ADDR_2E7E_cci_iir_b_2_m0_5_0(data)                                 (0x000000FC&((data)<<2))
#define  ATSC_ADDR_2E7E_cci_iir_b_1_m0_20_19(data)                               (0x00000003&(data))
#define  ATSC_ADDR_2E7E_get_cci_iir_b_2_m0_5_0(data)                             ((0x000000FC&(data))>>2)
#define  ATSC_ADDR_2E7E_get_cci_iir_b_1_m0_20_19(data)                           (0x00000003&(data))

#define  ATSC_ADDR_2E7F                                                         0x181579FC
#define  ATSC_ADDR_2E7F_reg_addr                                                 "0xB81579FC"
#define  ATSC_ADDR_2E7F_reg                                                      0xB81579FC
#define  ATSC_ADDR_2E7F_inst_addr                                                "0x01EB"
#define  set_ATSC_ADDR_2E7F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E7F_reg)=data)
#define  get_ATSC_ADDR_2E7F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E7F_reg))
#define  ATSC_ADDR_2E7F_cci_iir_b_2_m0_13_6_shift                                (0)
#define  ATSC_ADDR_2E7F_cci_iir_b_2_m0_13_6_mask                                 (0x000000FF)
#define  ATSC_ADDR_2E7F_cci_iir_b_2_m0_13_6(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2E7F_get_cci_iir_b_2_m0_13_6(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2E80                                                         0x18157A00
#define  ATSC_ADDR_2E80_reg_addr                                                 "0xB8157A00"
#define  ATSC_ADDR_2E80_reg                                                      0xB8157A00
#define  ATSC_ADDR_2E80_inst_addr                                                "0x01EC"
#define  set_ATSC_ADDR_2E80_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E80_reg)=data)
#define  get_ATSC_ADDR_2E80_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E80_reg))
#define  ATSC_ADDR_2E80_cci_iir_a_1_m1_0_shift                                   (7)
#define  ATSC_ADDR_2E80_cci_iir_b_2_m0_20_14_shift                               (0)
#define  ATSC_ADDR_2E80_cci_iir_a_1_m1_0_mask                                    (0x00000080)
#define  ATSC_ADDR_2E80_cci_iir_b_2_m0_20_14_mask                                (0x0000007F)
#define  ATSC_ADDR_2E80_cci_iir_a_1_m1_0(data)                                   (0x00000080&((data)<<7))
#define  ATSC_ADDR_2E80_cci_iir_b_2_m0_20_14(data)                               (0x0000007F&(data))
#define  ATSC_ADDR_2E80_get_cci_iir_a_1_m1_0(data)                               ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2E80_get_cci_iir_b_2_m0_20_14(data)                           (0x0000007F&(data))

#define  ATSC_ADDR_2E81                                                         0x18157A04
#define  ATSC_ADDR_2E81_reg_addr                                                 "0xB8157A04"
#define  ATSC_ADDR_2E81_reg                                                      0xB8157A04
#define  ATSC_ADDR_2E81_inst_addr                                                "0x01ED"
#define  set_ATSC_ADDR_2E81_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E81_reg)=data)
#define  get_ATSC_ADDR_2E81_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E81_reg))
#define  ATSC_ADDR_2E81_cci_iir_a_1_m1_8_1_shift                                 (0)
#define  ATSC_ADDR_2E81_cci_iir_a_1_m1_8_1_mask                                  (0x000000FF)
#define  ATSC_ADDR_2E81_cci_iir_a_1_m1_8_1(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2E81_get_cci_iir_a_1_m1_8_1(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2E82                                                         0x18157A08
#define  ATSC_ADDR_2E82_reg_addr                                                 "0xB8157A08"
#define  ATSC_ADDR_2E82_reg                                                      0xB8157A08
#define  ATSC_ADDR_2E82_inst_addr                                                "0x01EE"
#define  set_ATSC_ADDR_2E82_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E82_reg)=data)
#define  get_ATSC_ADDR_2E82_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E82_reg))
#define  ATSC_ADDR_2E82_cci_iir_a_1_m1_16_9_shift                                (0)
#define  ATSC_ADDR_2E82_cci_iir_a_1_m1_16_9_mask                                 (0x000000FF)
#define  ATSC_ADDR_2E82_cci_iir_a_1_m1_16_9(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2E82_get_cci_iir_a_1_m1_16_9(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2E83                                                         0x18157A0C
#define  ATSC_ADDR_2E83_reg_addr                                                 "0xB8157A0C"
#define  ATSC_ADDR_2E83_reg                                                      0xB8157A0C
#define  ATSC_ADDR_2E83_inst_addr                                                "0x01EF"
#define  set_ATSC_ADDR_2E83_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E83_reg)=data)
#define  get_ATSC_ADDR_2E83_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E83_reg))
#define  ATSC_ADDR_2E83_cci_iir_a_2_m1_3_0_shift                                 (4)
#define  ATSC_ADDR_2E83_cci_iir_a_1_m1_20_17_shift                               (0)
#define  ATSC_ADDR_2E83_cci_iir_a_2_m1_3_0_mask                                  (0x000000F0)
#define  ATSC_ADDR_2E83_cci_iir_a_1_m1_20_17_mask                                (0x0000000F)
#define  ATSC_ADDR_2E83_cci_iir_a_2_m1_3_0(data)                                 (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2E83_cci_iir_a_1_m1_20_17(data)                               (0x0000000F&(data))
#define  ATSC_ADDR_2E83_get_cci_iir_a_2_m1_3_0(data)                             ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2E83_get_cci_iir_a_1_m1_20_17(data)                           (0x0000000F&(data))

#define  ATSC_ADDR_2E84                                                         0x18157A10
#define  ATSC_ADDR_2E84_reg_addr                                                 "0xB8157A10"
#define  ATSC_ADDR_2E84_reg                                                      0xB8157A10
#define  ATSC_ADDR_2E84_inst_addr                                                "0x01F0"
#define  set_ATSC_ADDR_2E84_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E84_reg)=data)
#define  get_ATSC_ADDR_2E84_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E84_reg))
#define  ATSC_ADDR_2E84_cci_iir_a_2_m1_11_4_shift                                (0)
#define  ATSC_ADDR_2E84_cci_iir_a_2_m1_11_4_mask                                 (0x000000FF)
#define  ATSC_ADDR_2E84_cci_iir_a_2_m1_11_4(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2E84_get_cci_iir_a_2_m1_11_4(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2E85                                                         0x18157A14
#define  ATSC_ADDR_2E85_reg_addr                                                 "0xB8157A14"
#define  ATSC_ADDR_2E85_reg                                                      0xB8157A14
#define  ATSC_ADDR_2E85_inst_addr                                                "0x01F1"
#define  set_ATSC_ADDR_2E85_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E85_reg)=data)
#define  get_ATSC_ADDR_2E85_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E85_reg))
#define  ATSC_ADDR_2E85_cci_iir_a_2_m1_19_12_shift                               (0)
#define  ATSC_ADDR_2E85_cci_iir_a_2_m1_19_12_mask                                (0x000000FF)
#define  ATSC_ADDR_2E85_cci_iir_a_2_m1_19_12(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_2E85_get_cci_iir_a_2_m1_19_12(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_2E86                                                         0x18157A18
#define  ATSC_ADDR_2E86_reg_addr                                                 "0xB8157A18"
#define  ATSC_ADDR_2E86_reg                                                      0xB8157A18
#define  ATSC_ADDR_2E86_inst_addr                                                "0x01F2"
#define  set_ATSC_ADDR_2E86_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E86_reg)=data)
#define  get_ATSC_ADDR_2E86_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E86_reg))
#define  ATSC_ADDR_2E86_cci_iir_b_0_m1_6_0_shift                                 (1)
#define  ATSC_ADDR_2E86_cci_iir_a_2_m1_20_shift                                  (0)
#define  ATSC_ADDR_2E86_cci_iir_b_0_m1_6_0_mask                                  (0x000000FE)
#define  ATSC_ADDR_2E86_cci_iir_a_2_m1_20_mask                                   (0x00000001)
#define  ATSC_ADDR_2E86_cci_iir_b_0_m1_6_0(data)                                 (0x000000FE&((data)<<1))
#define  ATSC_ADDR_2E86_cci_iir_a_2_m1_20(data)                                  (0x00000001&(data))
#define  ATSC_ADDR_2E86_get_cci_iir_b_0_m1_6_0(data)                             ((0x000000FE&(data))>>1)
#define  ATSC_ADDR_2E86_get_cci_iir_a_2_m1_20(data)                              (0x00000001&(data))

#define  ATSC_ADDR_2E87                                                         0x18157A1C
#define  ATSC_ADDR_2E87_reg_addr                                                 "0xB8157A1C"
#define  ATSC_ADDR_2E87_reg                                                      0xB8157A1C
#define  ATSC_ADDR_2E87_inst_addr                                                "0x01F3"
#define  set_ATSC_ADDR_2E87_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E87_reg)=data)
#define  get_ATSC_ADDR_2E87_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E87_reg))
#define  ATSC_ADDR_2E87_cci_iir_b_0_m1_14_7_shift                                (0)
#define  ATSC_ADDR_2E87_cci_iir_b_0_m1_14_7_mask                                 (0x000000FF)
#define  ATSC_ADDR_2E87_cci_iir_b_0_m1_14_7(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2E87_get_cci_iir_b_0_m1_14_7(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2E88                                                         0x18157A20
#define  ATSC_ADDR_2E88_reg_addr                                                 "0xB8157A20"
#define  ATSC_ADDR_2E88_reg                                                      0xB8157A20
#define  ATSC_ADDR_2E88_inst_addr                                                "0x01F4"
#define  set_ATSC_ADDR_2E88_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E88_reg)=data)
#define  get_ATSC_ADDR_2E88_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E88_reg))
#define  ATSC_ADDR_2E88_cci_iir_b_1_m1_1_0_shift                                 (6)
#define  ATSC_ADDR_2E88_cci_iir_b_0_m1_20_15_shift                               (0)
#define  ATSC_ADDR_2E88_cci_iir_b_1_m1_1_0_mask                                  (0x000000C0)
#define  ATSC_ADDR_2E88_cci_iir_b_0_m1_20_15_mask                                (0x0000003F)
#define  ATSC_ADDR_2E88_cci_iir_b_1_m1_1_0(data)                                 (0x000000C0&((data)<<6))
#define  ATSC_ADDR_2E88_cci_iir_b_0_m1_20_15(data)                               (0x0000003F&(data))
#define  ATSC_ADDR_2E88_get_cci_iir_b_1_m1_1_0(data)                             ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_2E88_get_cci_iir_b_0_m1_20_15(data)                           (0x0000003F&(data))

#define  ATSC_ADDR_2E89                                                         0x18157A24
#define  ATSC_ADDR_2E89_reg_addr                                                 "0xB8157A24"
#define  ATSC_ADDR_2E89_reg                                                      0xB8157A24
#define  ATSC_ADDR_2E89_inst_addr                                                "0x01F5"
#define  set_ATSC_ADDR_2E89_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E89_reg)=data)
#define  get_ATSC_ADDR_2E89_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E89_reg))
#define  ATSC_ADDR_2E89_cci_iir_b_1_m1_9_2_shift                                 (0)
#define  ATSC_ADDR_2E89_cci_iir_b_1_m1_9_2_mask                                  (0x000000FF)
#define  ATSC_ADDR_2E89_cci_iir_b_1_m1_9_2(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2E89_get_cci_iir_b_1_m1_9_2(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2E8A                                                         0x18157A28
#define  ATSC_ADDR_2E8A_reg_addr                                                 "0xB8157A28"
#define  ATSC_ADDR_2E8A_reg                                                      0xB8157A28
#define  ATSC_ADDR_2E8A_inst_addr                                                "0x01F6"
#define  set_ATSC_ADDR_2E8A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E8A_reg)=data)
#define  get_ATSC_ADDR_2E8A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E8A_reg))
#define  ATSC_ADDR_2E8A_cci_iir_b_1_m1_17_10_shift                               (0)
#define  ATSC_ADDR_2E8A_cci_iir_b_1_m1_17_10_mask                                (0x000000FF)
#define  ATSC_ADDR_2E8A_cci_iir_b_1_m1_17_10(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_2E8A_get_cci_iir_b_1_m1_17_10(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_2E8B                                                         0x18157A2C
#define  ATSC_ADDR_2E8B_reg_addr                                                 "0xB8157A2C"
#define  ATSC_ADDR_2E8B_reg                                                      0xB8157A2C
#define  ATSC_ADDR_2E8B_inst_addr                                                "0x01F7"
#define  set_ATSC_ADDR_2E8B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E8B_reg)=data)
#define  get_ATSC_ADDR_2E8B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E8B_reg))
#define  ATSC_ADDR_2E8B_cci_iir_b_2_m1_4_0_shift                                 (3)
#define  ATSC_ADDR_2E8B_cci_iir_b_1_m1_20_18_shift                               (0)
#define  ATSC_ADDR_2E8B_cci_iir_b_2_m1_4_0_mask                                  (0x000000F8)
#define  ATSC_ADDR_2E8B_cci_iir_b_1_m1_20_18_mask                                (0x00000007)
#define  ATSC_ADDR_2E8B_cci_iir_b_2_m1_4_0(data)                                 (0x000000F8&((data)<<3))
#define  ATSC_ADDR_2E8B_cci_iir_b_1_m1_20_18(data)                               (0x00000007&(data))
#define  ATSC_ADDR_2E8B_get_cci_iir_b_2_m1_4_0(data)                             ((0x000000F8&(data))>>3)
#define  ATSC_ADDR_2E8B_get_cci_iir_b_1_m1_20_18(data)                           (0x00000007&(data))

#define  ATSC_ADDR_2E8C                                                         0x18157A30
#define  ATSC_ADDR_2E8C_reg_addr                                                 "0xB8157A30"
#define  ATSC_ADDR_2E8C_reg                                                      0xB8157A30
#define  ATSC_ADDR_2E8C_inst_addr                                                "0x01F8"
#define  set_ATSC_ADDR_2E8C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E8C_reg)=data)
#define  get_ATSC_ADDR_2E8C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E8C_reg))
#define  ATSC_ADDR_2E8C_cci_iir_b_2_m1_12_5_shift                                (0)
#define  ATSC_ADDR_2E8C_cci_iir_b_2_m1_12_5_mask                                 (0x000000FF)
#define  ATSC_ADDR_2E8C_cci_iir_b_2_m1_12_5(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2E8C_get_cci_iir_b_2_m1_12_5(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2E8D                                                         0x18157A34
#define  ATSC_ADDR_2E8D_reg_addr                                                 "0xB8157A34"
#define  ATSC_ADDR_2E8D_reg                                                      0xB8157A34
#define  ATSC_ADDR_2E8D_inst_addr                                                "0x01F9"
#define  set_ATSC_ADDR_2E8D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E8D_reg)=data)
#define  get_ATSC_ADDR_2E8D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E8D_reg))
#define  ATSC_ADDR_2E8D_cci_iir_b_2_m1_20_13_shift                               (0)
#define  ATSC_ADDR_2E8D_cci_iir_b_2_m1_20_13_mask                                (0x000000FF)
#define  ATSC_ADDR_2E8D_cci_iir_b_2_m1_20_13(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_2E8D_get_cci_iir_b_2_m1_20_13(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_2E8E                                                         0x18157A38
#define  ATSC_ADDR_2E8E_reg_addr                                                 "0xB8157A38"
#define  ATSC_ADDR_2E8E_reg                                                      0xB8157A38
#define  ATSC_ADDR_2E8E_inst_addr                                                "0x01FA"
#define  set_ATSC_ADDR_2E8E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E8E_reg)=data)
#define  get_ATSC_ADDR_2E8E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E8E_reg))
#define  ATSC_ADDR_2E8E_cci_iir_a_1_l0_7_0_shift                                 (0)
#define  ATSC_ADDR_2E8E_cci_iir_a_1_l0_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_2E8E_cci_iir_a_1_l0_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2E8E_get_cci_iir_a_1_l0_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2E8F                                                         0x18157A3C
#define  ATSC_ADDR_2E8F_reg_addr                                                 "0xB8157A3C"
#define  ATSC_ADDR_2E8F_reg                                                      0xB8157A3C
#define  ATSC_ADDR_2E8F_inst_addr                                                "0x01FB"
#define  set_ATSC_ADDR_2E8F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E8F_reg)=data)
#define  get_ATSC_ADDR_2E8F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E8F_reg))
#define  ATSC_ADDR_2E8F_cci_iir_a_1_l0_15_8_shift                                (0)
#define  ATSC_ADDR_2E8F_cci_iir_a_1_l0_15_8_mask                                 (0x000000FF)
#define  ATSC_ADDR_2E8F_cci_iir_a_1_l0_15_8(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2E8F_get_cci_iir_a_1_l0_15_8(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2E90                                                         0x18157A40
#define  ATSC_ADDR_2E90_reg_addr                                                 "0xB8157A40"
#define  ATSC_ADDR_2E90_reg                                                      0xB8157A40
#define  ATSC_ADDR_2E90_inst_addr                                                "0x01FC"
#define  set_ATSC_ADDR_2E90_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E90_reg)=data)
#define  get_ATSC_ADDR_2E90_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E90_reg))
#define  ATSC_ADDR_2E90_cci_iir_a_2_l0_2_0_shift                                 (5)
#define  ATSC_ADDR_2E90_cci_iir_a_1_l0_20_16_shift                               (0)
#define  ATSC_ADDR_2E90_cci_iir_a_2_l0_2_0_mask                                  (0x000000E0)
#define  ATSC_ADDR_2E90_cci_iir_a_1_l0_20_16_mask                                (0x0000001F)
#define  ATSC_ADDR_2E90_cci_iir_a_2_l0_2_0(data)                                 (0x000000E0&((data)<<5))
#define  ATSC_ADDR_2E90_cci_iir_a_1_l0_20_16(data)                               (0x0000001F&(data))
#define  ATSC_ADDR_2E90_get_cci_iir_a_2_l0_2_0(data)                             ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_2E90_get_cci_iir_a_1_l0_20_16(data)                           (0x0000001F&(data))

#define  ATSC_ADDR_2E91                                                         0x18157A44
#define  ATSC_ADDR_2E91_reg_addr                                                 "0xB8157A44"
#define  ATSC_ADDR_2E91_reg                                                      0xB8157A44
#define  ATSC_ADDR_2E91_inst_addr                                                "0x01FD"
#define  set_ATSC_ADDR_2E91_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E91_reg)=data)
#define  get_ATSC_ADDR_2E91_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E91_reg))
#define  ATSC_ADDR_2E91_cci_iir_a_2_l0_10_3_shift                                (0)
#define  ATSC_ADDR_2E91_cci_iir_a_2_l0_10_3_mask                                 (0x000000FF)
#define  ATSC_ADDR_2E91_cci_iir_a_2_l0_10_3(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2E91_get_cci_iir_a_2_l0_10_3(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2E92                                                         0x18157A48
#define  ATSC_ADDR_2E92_reg_addr                                                 "0xB8157A48"
#define  ATSC_ADDR_2E92_reg                                                      0xB8157A48
#define  ATSC_ADDR_2E92_inst_addr                                                "0x01FE"
#define  set_ATSC_ADDR_2E92_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E92_reg)=data)
#define  get_ATSC_ADDR_2E92_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E92_reg))
#define  ATSC_ADDR_2E92_cci_iir_a_2_l0_18_11_shift                               (0)
#define  ATSC_ADDR_2E92_cci_iir_a_2_l0_18_11_mask                                (0x000000FF)
#define  ATSC_ADDR_2E92_cci_iir_a_2_l0_18_11(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_2E92_get_cci_iir_a_2_l0_18_11(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_2E93                                                         0x18157A4C
#define  ATSC_ADDR_2E93_reg_addr                                                 "0xB8157A4C"
#define  ATSC_ADDR_2E93_reg                                                      0xB8157A4C
#define  ATSC_ADDR_2E93_inst_addr                                                "0x01FF"
#define  set_ATSC_ADDR_2E93_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E93_reg)=data)
#define  get_ATSC_ADDR_2E93_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E93_reg))
#define  ATSC_ADDR_2E93_cci_iir_b_0_l0_5_0_shift                                 (2)
#define  ATSC_ADDR_2E93_cci_iir_a_2_l0_20_19_shift                               (0)
#define  ATSC_ADDR_2E93_cci_iir_b_0_l0_5_0_mask                                  (0x000000FC)
#define  ATSC_ADDR_2E93_cci_iir_a_2_l0_20_19_mask                                (0x00000003)
#define  ATSC_ADDR_2E93_cci_iir_b_0_l0_5_0(data)                                 (0x000000FC&((data)<<2))
#define  ATSC_ADDR_2E93_cci_iir_a_2_l0_20_19(data)                               (0x00000003&(data))
#define  ATSC_ADDR_2E93_get_cci_iir_b_0_l0_5_0(data)                             ((0x000000FC&(data))>>2)
#define  ATSC_ADDR_2E93_get_cci_iir_a_2_l0_20_19(data)                           (0x00000003&(data))

#define  ATSC_ADDR_2E94                                                         0x18157A50
#define  ATSC_ADDR_2E94_reg_addr                                                 "0xB8157A50"
#define  ATSC_ADDR_2E94_reg                                                      0xB8157A50
#define  ATSC_ADDR_2E94_inst_addr                                                "0x0200"
#define  set_ATSC_ADDR_2E94_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E94_reg)=data)
#define  get_ATSC_ADDR_2E94_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E94_reg))
#define  ATSC_ADDR_2E94_cci_iir_b_0_l0_13_6_shift                                (0)
#define  ATSC_ADDR_2E94_cci_iir_b_0_l0_13_6_mask                                 (0x000000FF)
#define  ATSC_ADDR_2E94_cci_iir_b_0_l0_13_6(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2E94_get_cci_iir_b_0_l0_13_6(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2E95                                                         0x18157A54
#define  ATSC_ADDR_2E95_reg_addr                                                 "0xB8157A54"
#define  ATSC_ADDR_2E95_reg                                                      0xB8157A54
#define  ATSC_ADDR_2E95_inst_addr                                                "0x0201"
#define  set_ATSC_ADDR_2E95_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E95_reg)=data)
#define  get_ATSC_ADDR_2E95_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E95_reg))
#define  ATSC_ADDR_2E95_cci_iir_b_1_l0_0_shift                                   (7)
#define  ATSC_ADDR_2E95_cci_iir_b_0_l0_20_14_shift                               (0)
#define  ATSC_ADDR_2E95_cci_iir_b_1_l0_0_mask                                    (0x00000080)
#define  ATSC_ADDR_2E95_cci_iir_b_0_l0_20_14_mask                                (0x0000007F)
#define  ATSC_ADDR_2E95_cci_iir_b_1_l0_0(data)                                   (0x00000080&((data)<<7))
#define  ATSC_ADDR_2E95_cci_iir_b_0_l0_20_14(data)                               (0x0000007F&(data))
#define  ATSC_ADDR_2E95_get_cci_iir_b_1_l0_0(data)                               ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2E95_get_cci_iir_b_0_l0_20_14(data)                           (0x0000007F&(data))

#define  ATSC_ADDR_2E96                                                         0x18157A58
#define  ATSC_ADDR_2E96_reg_addr                                                 "0xB8157A58"
#define  ATSC_ADDR_2E96_reg                                                      0xB8157A58
#define  ATSC_ADDR_2E96_inst_addr                                                "0x0202"
#define  set_ATSC_ADDR_2E96_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E96_reg)=data)
#define  get_ATSC_ADDR_2E96_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E96_reg))
#define  ATSC_ADDR_2E96_cci_iir_b_1_l0_8_1_shift                                 (0)
#define  ATSC_ADDR_2E96_cci_iir_b_1_l0_8_1_mask                                  (0x000000FF)
#define  ATSC_ADDR_2E96_cci_iir_b_1_l0_8_1(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2E96_get_cci_iir_b_1_l0_8_1(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2E97                                                         0x18157A5C
#define  ATSC_ADDR_2E97_reg_addr                                                 "0xB8157A5C"
#define  ATSC_ADDR_2E97_reg                                                      0xB8157A5C
#define  ATSC_ADDR_2E97_inst_addr                                                "0x0203"
#define  set_ATSC_ADDR_2E97_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E97_reg)=data)
#define  get_ATSC_ADDR_2E97_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E97_reg))
#define  ATSC_ADDR_2E97_cci_iir_b_1_l0_16_9_shift                                (0)
#define  ATSC_ADDR_2E97_cci_iir_b_1_l0_16_9_mask                                 (0x000000FF)
#define  ATSC_ADDR_2E97_cci_iir_b_1_l0_16_9(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2E97_get_cci_iir_b_1_l0_16_9(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2E98                                                         0x18157A60
#define  ATSC_ADDR_2E98_reg_addr                                                 "0xB8157A60"
#define  ATSC_ADDR_2E98_reg                                                      0xB8157A60
#define  ATSC_ADDR_2E98_inst_addr                                                "0x0204"
#define  set_ATSC_ADDR_2E98_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E98_reg)=data)
#define  get_ATSC_ADDR_2E98_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E98_reg))
#define  ATSC_ADDR_2E98_cci_iir_b_2_l0_3_0_shift                                 (4)
#define  ATSC_ADDR_2E98_cci_iir_b_1_l0_20_17_shift                               (0)
#define  ATSC_ADDR_2E98_cci_iir_b_2_l0_3_0_mask                                  (0x000000F0)
#define  ATSC_ADDR_2E98_cci_iir_b_1_l0_20_17_mask                                (0x0000000F)
#define  ATSC_ADDR_2E98_cci_iir_b_2_l0_3_0(data)                                 (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2E98_cci_iir_b_1_l0_20_17(data)                               (0x0000000F&(data))
#define  ATSC_ADDR_2E98_get_cci_iir_b_2_l0_3_0(data)                             ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2E98_get_cci_iir_b_1_l0_20_17(data)                           (0x0000000F&(data))

#define  ATSC_ADDR_2E99                                                         0x18157A64
#define  ATSC_ADDR_2E99_reg_addr                                                 "0xB8157A64"
#define  ATSC_ADDR_2E99_reg                                                      0xB8157A64
#define  ATSC_ADDR_2E99_inst_addr                                                "0x0205"
#define  set_ATSC_ADDR_2E99_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E99_reg)=data)
#define  get_ATSC_ADDR_2E99_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E99_reg))
#define  ATSC_ADDR_2E99_cci_iir_b_2_l0_11_4_shift                                (0)
#define  ATSC_ADDR_2E99_cci_iir_b_2_l0_11_4_mask                                 (0x000000FF)
#define  ATSC_ADDR_2E99_cci_iir_b_2_l0_11_4(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2E99_get_cci_iir_b_2_l0_11_4(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2E9A                                                         0x18157A68
#define  ATSC_ADDR_2E9A_reg_addr                                                 "0xB8157A68"
#define  ATSC_ADDR_2E9A_reg                                                      0xB8157A68
#define  ATSC_ADDR_2E9A_inst_addr                                                "0x0206"
#define  set_ATSC_ADDR_2E9A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E9A_reg)=data)
#define  get_ATSC_ADDR_2E9A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E9A_reg))
#define  ATSC_ADDR_2E9A_cci_iir_b_2_l0_19_12_shift                               (0)
#define  ATSC_ADDR_2E9A_cci_iir_b_2_l0_19_12_mask                                (0x000000FF)
#define  ATSC_ADDR_2E9A_cci_iir_b_2_l0_19_12(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_2E9A_get_cci_iir_b_2_l0_19_12(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_2E9B                                                         0x18157A6C
#define  ATSC_ADDR_2E9B_reg_addr                                                 "0xB8157A6C"
#define  ATSC_ADDR_2E9B_reg                                                      0xB8157A6C
#define  ATSC_ADDR_2E9B_inst_addr                                                "0x0207"
#define  set_ATSC_ADDR_2E9B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E9B_reg)=data)
#define  get_ATSC_ADDR_2E9B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E9B_reg))
#define  ATSC_ADDR_2E9B_cci_iir_a_1_l1_6_0_shift                                 (1)
#define  ATSC_ADDR_2E9B_cci_iir_b_2_l0_20_shift                                  (0)
#define  ATSC_ADDR_2E9B_cci_iir_a_1_l1_6_0_mask                                  (0x000000FE)
#define  ATSC_ADDR_2E9B_cci_iir_b_2_l0_20_mask                                   (0x00000001)
#define  ATSC_ADDR_2E9B_cci_iir_a_1_l1_6_0(data)                                 (0x000000FE&((data)<<1))
#define  ATSC_ADDR_2E9B_cci_iir_b_2_l0_20(data)                                  (0x00000001&(data))
#define  ATSC_ADDR_2E9B_get_cci_iir_a_1_l1_6_0(data)                             ((0x000000FE&(data))>>1)
#define  ATSC_ADDR_2E9B_get_cci_iir_b_2_l0_20(data)                              (0x00000001&(data))

#define  ATSC_ADDR_2E9C                                                         0x18157A70
#define  ATSC_ADDR_2E9C_reg_addr                                                 "0xB8157A70"
#define  ATSC_ADDR_2E9C_reg                                                      0xB8157A70
#define  ATSC_ADDR_2E9C_inst_addr                                                "0x0208"
#define  set_ATSC_ADDR_2E9C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E9C_reg)=data)
#define  get_ATSC_ADDR_2E9C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E9C_reg))
#define  ATSC_ADDR_2E9C_cci_iir_a_1_l1_14_7_shift                                (0)
#define  ATSC_ADDR_2E9C_cci_iir_a_1_l1_14_7_mask                                 (0x000000FF)
#define  ATSC_ADDR_2E9C_cci_iir_a_1_l1_14_7(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2E9C_get_cci_iir_a_1_l1_14_7(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2E9D                                                         0x18157A74
#define  ATSC_ADDR_2E9D_reg_addr                                                 "0xB8157A74"
#define  ATSC_ADDR_2E9D_reg                                                      0xB8157A74
#define  ATSC_ADDR_2E9D_inst_addr                                                "0x0209"
#define  set_ATSC_ADDR_2E9D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E9D_reg)=data)
#define  get_ATSC_ADDR_2E9D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E9D_reg))
#define  ATSC_ADDR_2E9D_cci_iir_a_2_l1_1_0_shift                                 (6)
#define  ATSC_ADDR_2E9D_cci_iir_a_1_l1_20_15_shift                               (0)
#define  ATSC_ADDR_2E9D_cci_iir_a_2_l1_1_0_mask                                  (0x000000C0)
#define  ATSC_ADDR_2E9D_cci_iir_a_1_l1_20_15_mask                                (0x0000003F)
#define  ATSC_ADDR_2E9D_cci_iir_a_2_l1_1_0(data)                                 (0x000000C0&((data)<<6))
#define  ATSC_ADDR_2E9D_cci_iir_a_1_l1_20_15(data)                               (0x0000003F&(data))
#define  ATSC_ADDR_2E9D_get_cci_iir_a_2_l1_1_0(data)                             ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_2E9D_get_cci_iir_a_1_l1_20_15(data)                           (0x0000003F&(data))

#define  ATSC_ADDR_2E9E                                                         0x18157A78
#define  ATSC_ADDR_2E9E_reg_addr                                                 "0xB8157A78"
#define  ATSC_ADDR_2E9E_reg                                                      0xB8157A78
#define  ATSC_ADDR_2E9E_inst_addr                                                "0x020A"
#define  set_ATSC_ADDR_2E9E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E9E_reg)=data)
#define  get_ATSC_ADDR_2E9E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E9E_reg))
#define  ATSC_ADDR_2E9E_cci_iir_a_2_l1_9_2_shift                                 (0)
#define  ATSC_ADDR_2E9E_cci_iir_a_2_l1_9_2_mask                                  (0x000000FF)
#define  ATSC_ADDR_2E9E_cci_iir_a_2_l1_9_2(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2E9E_get_cci_iir_a_2_l1_9_2(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2E9F                                                         0x18157A7C
#define  ATSC_ADDR_2E9F_reg_addr                                                 "0xB8157A7C"
#define  ATSC_ADDR_2E9F_reg                                                      0xB8157A7C
#define  ATSC_ADDR_2E9F_inst_addr                                                "0x020B"
#define  set_ATSC_ADDR_2E9F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E9F_reg)=data)
#define  get_ATSC_ADDR_2E9F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E9F_reg))
#define  ATSC_ADDR_2E9F_cci_iir_a_2_l1_17_10_shift                               (0)
#define  ATSC_ADDR_2E9F_cci_iir_a_2_l1_17_10_mask                                (0x000000FF)
#define  ATSC_ADDR_2E9F_cci_iir_a_2_l1_17_10(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_2E9F_get_cci_iir_a_2_l1_17_10(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_2EA0                                                         0x18157A80
#define  ATSC_ADDR_2EA0_reg_addr                                                 "0xB8157A80"
#define  ATSC_ADDR_2EA0_reg                                                      0xB8157A80
#define  ATSC_ADDR_2EA0_inst_addr                                                "0x020C"
#define  set_ATSC_ADDR_2EA0_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EA0_reg)=data)
#define  get_ATSC_ADDR_2EA0_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EA0_reg))
#define  ATSC_ADDR_2EA0_cci_iir_b_0_l1_4_0_shift                                 (3)
#define  ATSC_ADDR_2EA0_cci_iir_a_2_l1_20_18_shift                               (0)
#define  ATSC_ADDR_2EA0_cci_iir_b_0_l1_4_0_mask                                  (0x000000F8)
#define  ATSC_ADDR_2EA0_cci_iir_a_2_l1_20_18_mask                                (0x00000007)
#define  ATSC_ADDR_2EA0_cci_iir_b_0_l1_4_0(data)                                 (0x000000F8&((data)<<3))
#define  ATSC_ADDR_2EA0_cci_iir_a_2_l1_20_18(data)                               (0x00000007&(data))
#define  ATSC_ADDR_2EA0_get_cci_iir_b_0_l1_4_0(data)                             ((0x000000F8&(data))>>3)
#define  ATSC_ADDR_2EA0_get_cci_iir_a_2_l1_20_18(data)                           (0x00000007&(data))

#define  ATSC_ADDR_2EA1                                                         0x18157A84
#define  ATSC_ADDR_2EA1_reg_addr                                                 "0xB8157A84"
#define  ATSC_ADDR_2EA1_reg                                                      0xB8157A84
#define  ATSC_ADDR_2EA1_inst_addr                                                "0x020D"
#define  set_ATSC_ADDR_2EA1_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EA1_reg)=data)
#define  get_ATSC_ADDR_2EA1_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EA1_reg))
#define  ATSC_ADDR_2EA1_cci_iir_b_0_l1_12_5_shift                                (0)
#define  ATSC_ADDR_2EA1_cci_iir_b_0_l1_12_5_mask                                 (0x000000FF)
#define  ATSC_ADDR_2EA1_cci_iir_b_0_l1_12_5(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2EA1_get_cci_iir_b_0_l1_12_5(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2EA2                                                         0x18157A88
#define  ATSC_ADDR_2EA2_reg_addr                                                 "0xB8157A88"
#define  ATSC_ADDR_2EA2_reg                                                      0xB8157A88
#define  ATSC_ADDR_2EA2_inst_addr                                                "0x020E"
#define  set_ATSC_ADDR_2EA2_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EA2_reg)=data)
#define  get_ATSC_ADDR_2EA2_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EA2_reg))
#define  ATSC_ADDR_2EA2_cci_iir_b_0_l1_20_13_shift                               (0)
#define  ATSC_ADDR_2EA2_cci_iir_b_0_l1_20_13_mask                                (0x000000FF)
#define  ATSC_ADDR_2EA2_cci_iir_b_0_l1_20_13(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_2EA2_get_cci_iir_b_0_l1_20_13(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_2EA3                                                         0x18157A8C
#define  ATSC_ADDR_2EA3_reg_addr                                                 "0xB8157A8C"
#define  ATSC_ADDR_2EA3_reg                                                      0xB8157A8C
#define  ATSC_ADDR_2EA3_inst_addr                                                "0x020F"
#define  set_ATSC_ADDR_2EA3_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EA3_reg)=data)
#define  get_ATSC_ADDR_2EA3_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EA3_reg))
#define  ATSC_ADDR_2EA3_cci_iir_b_1_l1_7_0_shift                                 (0)
#define  ATSC_ADDR_2EA3_cci_iir_b_1_l1_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_2EA3_cci_iir_b_1_l1_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2EA3_get_cci_iir_b_1_l1_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2EA4                                                         0x18157A90
#define  ATSC_ADDR_2EA4_reg_addr                                                 "0xB8157A90"
#define  ATSC_ADDR_2EA4_reg                                                      0xB8157A90
#define  ATSC_ADDR_2EA4_inst_addr                                                "0x0210"
#define  set_ATSC_ADDR_2EA4_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EA4_reg)=data)
#define  get_ATSC_ADDR_2EA4_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EA4_reg))
#define  ATSC_ADDR_2EA4_cci_iir_b_1_l1_15_8_shift                                (0)
#define  ATSC_ADDR_2EA4_cci_iir_b_1_l1_15_8_mask                                 (0x000000FF)
#define  ATSC_ADDR_2EA4_cci_iir_b_1_l1_15_8(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2EA4_get_cci_iir_b_1_l1_15_8(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2EA5                                                         0x18157A94
#define  ATSC_ADDR_2EA5_reg_addr                                                 "0xB8157A94"
#define  ATSC_ADDR_2EA5_reg                                                      0xB8157A94
#define  ATSC_ADDR_2EA5_inst_addr                                                "0x0211"
#define  set_ATSC_ADDR_2EA5_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EA5_reg)=data)
#define  get_ATSC_ADDR_2EA5_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EA5_reg))
#define  ATSC_ADDR_2EA5_cci_iir_b_2_l1_2_0_shift                                 (5)
#define  ATSC_ADDR_2EA5_cci_iir_b_1_l1_20_16_shift                               (0)
#define  ATSC_ADDR_2EA5_cci_iir_b_2_l1_2_0_mask                                  (0x000000E0)
#define  ATSC_ADDR_2EA5_cci_iir_b_1_l1_20_16_mask                                (0x0000001F)
#define  ATSC_ADDR_2EA5_cci_iir_b_2_l1_2_0(data)                                 (0x000000E0&((data)<<5))
#define  ATSC_ADDR_2EA5_cci_iir_b_1_l1_20_16(data)                               (0x0000001F&(data))
#define  ATSC_ADDR_2EA5_get_cci_iir_b_2_l1_2_0(data)                             ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_2EA5_get_cci_iir_b_1_l1_20_16(data)                           (0x0000001F&(data))

#define  ATSC_ADDR_2EA6                                                         0x18157A98
#define  ATSC_ADDR_2EA6_reg_addr                                                 "0xB8157A98"
#define  ATSC_ADDR_2EA6_reg                                                      0xB8157A98
#define  ATSC_ADDR_2EA6_inst_addr                                                "0x0212"
#define  set_ATSC_ADDR_2EA6_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EA6_reg)=data)
#define  get_ATSC_ADDR_2EA6_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EA6_reg))
#define  ATSC_ADDR_2EA6_cci_iir_b_2_l1_10_3_shift                                (0)
#define  ATSC_ADDR_2EA6_cci_iir_b_2_l1_10_3_mask                                 (0x000000FF)
#define  ATSC_ADDR_2EA6_cci_iir_b_2_l1_10_3(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2EA6_get_cci_iir_b_2_l1_10_3(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2EA7                                                         0x18157A9C
#define  ATSC_ADDR_2EA7_reg_addr                                                 "0xB8157A9C"
#define  ATSC_ADDR_2EA7_reg                                                      0xB8157A9C
#define  ATSC_ADDR_2EA7_inst_addr                                                "0x0213"
#define  set_ATSC_ADDR_2EA7_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EA7_reg)=data)
#define  get_ATSC_ADDR_2EA7_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EA7_reg))
#define  ATSC_ADDR_2EA7_cci_iir_b_2_l1_18_11_shift                               (0)
#define  ATSC_ADDR_2EA7_cci_iir_b_2_l1_18_11_mask                                (0x000000FF)
#define  ATSC_ADDR_2EA7_cci_iir_b_2_l1_18_11(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_2EA7_get_cci_iir_b_2_l1_18_11(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_2EA8                                                         0x18157AA0
#define  ATSC_ADDR_2EA8_reg_addr                                                 "0xB8157AA0"
#define  ATSC_ADDR_2EA8_reg                                                      0xB8157AA0
#define  ATSC_ADDR_2EA8_inst_addr                                                "0x0214"
#define  set_ATSC_ADDR_2EA8_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EA8_reg)=data)
#define  get_ATSC_ADDR_2EA8_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EA8_reg))
#define  ATSC_ADDR_2EA8_cci_det_start_st_1_0_shift                               (6)
#define  ATSC_ADDR_2EA8_cci_rej_manl_off_shift                                   (5)
#define  ATSC_ADDR_2EA8_cci_rej_manl_on_shift                                    (4)
#define  ATSC_ADDR_2EA8_cci_det_manl_on_shift                                    (3)
#define  ATSC_ADDR_2EA8_cci_rej_en_shift                                         (2)
#define  ATSC_ADDR_2EA8_cci_iir_b_2_l1_20_19_shift                               (0)
#define  ATSC_ADDR_2EA8_cci_det_start_st_1_0_mask                                (0x000000C0)
#define  ATSC_ADDR_2EA8_cci_rej_manl_off_mask                                    (0x00000020)
#define  ATSC_ADDR_2EA8_cci_rej_manl_on_mask                                     (0x00000010)
#define  ATSC_ADDR_2EA8_cci_det_manl_on_mask                                     (0x00000008)
#define  ATSC_ADDR_2EA8_cci_rej_en_mask                                          (0x00000004)
#define  ATSC_ADDR_2EA8_cci_iir_b_2_l1_20_19_mask                                (0x00000003)
#define  ATSC_ADDR_2EA8_cci_det_start_st_1_0(data)                               (0x000000C0&((data)<<6))
#define  ATSC_ADDR_2EA8_cci_rej_manl_off(data)                                   (0x00000020&((data)<<5))
#define  ATSC_ADDR_2EA8_cci_rej_manl_on(data)                                    (0x00000010&((data)<<4))
#define  ATSC_ADDR_2EA8_cci_det_manl_on(data)                                    (0x00000008&((data)<<3))
#define  ATSC_ADDR_2EA8_cci_rej_en(data)                                         (0x00000004&((data)<<2))
#define  ATSC_ADDR_2EA8_cci_iir_b_2_l1_20_19(data)                               (0x00000003&(data))
#define  ATSC_ADDR_2EA8_get_cci_det_start_st_1_0(data)                           ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_2EA8_get_cci_rej_manl_off(data)                               ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2EA8_get_cci_rej_manl_on(data)                                ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2EA8_get_cci_det_manl_on(data)                                ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2EA8_get_cci_rej_en(data)                                     ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2EA8_get_cci_iir_b_2_l1_20_19(data)                           (0x00000003&(data))

#define  ATSC_ADDR_2EA9                                                         0x18157AA4
#define  ATSC_ADDR_2EA9_reg_addr                                                 "0xB8157AA4"
#define  ATSC_ADDR_2EA9_reg                                                      0xB8157AA4
#define  ATSC_ADDR_2EA9_inst_addr                                                "0x0215"
#define  set_ATSC_ADDR_2EA9_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EA9_reg)=data)
#define  get_ATSC_ADDR_2EA9_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EA9_reg))
#define  ATSC_ADDR_2EA9_cci_det_fft_n_3_0_shift                                  (4)
#define  ATSC_ADDR_2EA9_cci_det_start_st_5_2_shift                               (0)
#define  ATSC_ADDR_2EA9_cci_det_fft_n_3_0_mask                                   (0x000000F0)
#define  ATSC_ADDR_2EA9_cci_det_start_st_5_2_mask                                (0x0000000F)
#define  ATSC_ADDR_2EA9_cci_det_fft_n_3_0(data)                                  (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2EA9_cci_det_start_st_5_2(data)                               (0x0000000F&(data))
#define  ATSC_ADDR_2EA9_get_cci_det_fft_n_3_0(data)                              ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2EA9_get_cci_det_start_st_5_2(data)                           (0x0000000F&(data))

#define  ATSC_ADDR_2EAA                                                         0x18157AA8
#define  ATSC_ADDR_2EAA_reg_addr                                                 "0xB8157AA8"
#define  ATSC_ADDR_2EAA_reg                                                      0xB8157AA8
#define  ATSC_ADDR_2EAA_inst_addr                                                "0x0216"
#define  set_ATSC_ADDR_2EAA_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EAA_reg)=data)
#define  get_ATSC_ADDR_2EAA_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EAA_reg))
#define  ATSC_ADDR_2EAA_cci_pos_dif_range_shift                                  (2)
#define  ATSC_ADDR_2EAA_cci_det_fft_n_5_4_shift                                  (0)
#define  ATSC_ADDR_2EAA_cci_pos_dif_range_mask                                   (0x000000FC)
#define  ATSC_ADDR_2EAA_cci_det_fft_n_5_4_mask                                   (0x00000003)
#define  ATSC_ADDR_2EAA_cci_pos_dif_range(data)                                  (0x000000FC&((data)<<2))
#define  ATSC_ADDR_2EAA_cci_det_fft_n_5_4(data)                                  (0x00000003&(data))
#define  ATSC_ADDR_2EAA_get_cci_pos_dif_range(data)                              ((0x000000FC&(data))>>2)
#define  ATSC_ADDR_2EAA_get_cci_det_fft_n_5_4(data)                              (0x00000003&(data))

#define  ATSC_ADDR_2EAB                                                         0x18157AAC
#define  ATSC_ADDR_2EAB_reg_addr                                                 "0xB8157AAC"
#define  ATSC_ADDR_2EAB_reg                                                      0xB8157AAC
#define  ATSC_ADDR_2EAB_inst_addr                                                "0x0217"
#define  set_ATSC_ADDR_2EAB_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EAB_reg)=data)
#define  get_ATSC_ADDR_2EAB_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EAB_reg))
#define  ATSC_ADDR_2EAB_cci_rej_start_st_1_0_shift                               (6)
#define  ATSC_ADDR_2EAB_cci_pos_around_cnt_thd_shift                             (0)
#define  ATSC_ADDR_2EAB_cci_rej_start_st_1_0_mask                                (0x000000C0)
#define  ATSC_ADDR_2EAB_cci_pos_around_cnt_thd_mask                              (0x0000003F)
#define  ATSC_ADDR_2EAB_cci_rej_start_st_1_0(data)                               (0x000000C0&((data)<<6))
#define  ATSC_ADDR_2EAB_cci_pos_around_cnt_thd(data)                             (0x0000003F&(data))
#define  ATSC_ADDR_2EAB_get_cci_rej_start_st_1_0(data)                           ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_2EAB_get_cci_pos_around_cnt_thd(data)                         (0x0000003F&(data))

#define  ATSC_ADDR_2EAC                                                         0x18157AB0
#define  ATSC_ADDR_2EAC_reg_addr                                                 "0xB8157AB0"
#define  ATSC_ADDR_2EAC_reg                                                      0xB8157AB0
#define  ATSC_ADDR_2EAC_inst_addr                                                "0x0218"
#define  set_ATSC_ADDR_2EAC_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EAC_reg)=data)
#define  get_ATSC_ADDR_2EAC_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EAC_reg))
#define  ATSC_ADDR_2EAC_cci_rej_freq_neg_3_0_shift                               (4)
#define  ATSC_ADDR_2EAC_cci_rej_start_st_5_2_shift                               (0)
#define  ATSC_ADDR_2EAC_cci_rej_freq_neg_3_0_mask                                (0x000000F0)
#define  ATSC_ADDR_2EAC_cci_rej_start_st_5_2_mask                                (0x0000000F)
#define  ATSC_ADDR_2EAC_cci_rej_freq_neg_3_0(data)                               (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2EAC_cci_rej_start_st_5_2(data)                               (0x0000000F&(data))
#define  ATSC_ADDR_2EAC_get_cci_rej_freq_neg_3_0(data)                           ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2EAC_get_cci_rej_start_st_5_2(data)                           (0x0000000F&(data))

#define  ATSC_ADDR_2EAD                                                         0x18157AB4
#define  ATSC_ADDR_2EAD_reg_addr                                                 "0xB8157AB4"
#define  ATSC_ADDR_2EAD_reg                                                      0xB8157AB4
#define  ATSC_ADDR_2EAD_inst_addr                                                "0x0219"
#define  set_ATSC_ADDR_2EAD_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EAD_reg)=data)
#define  get_ATSC_ADDR_2EAD_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EAD_reg))
#define  ATSC_ADDR_2EAD_cci_rej_freq_neg_11_4_shift                              (0)
#define  ATSC_ADDR_2EAD_cci_rej_freq_neg_11_4_mask                               (0x000000FF)
#define  ATSC_ADDR_2EAD_cci_rej_freq_neg_11_4(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_2EAD_get_cci_rej_freq_neg_11_4(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_2EAE                                                         0x18157AB8
#define  ATSC_ADDR_2EAE_reg_addr                                                 "0xB8157AB8"
#define  ATSC_ADDR_2EAE_reg                                                      0xB8157AB8
#define  ATSC_ADDR_2EAE_inst_addr                                                "0x021A"
#define  set_ATSC_ADDR_2EAE_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EAE_reg)=data)
#define  get_ATSC_ADDR_2EAE_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EAE_reg))
#define  ATSC_ADDR_2EAE_cci_rej_freq_post_6_0_shift                              (1)
#define  ATSC_ADDR_2EAE_cci_rej_freq_neg_12_shift                                (0)
#define  ATSC_ADDR_2EAE_cci_rej_freq_post_6_0_mask                               (0x000000FE)
#define  ATSC_ADDR_2EAE_cci_rej_freq_neg_12_mask                                 (0x00000001)
#define  ATSC_ADDR_2EAE_cci_rej_freq_post_6_0(data)                              (0x000000FE&((data)<<1))
#define  ATSC_ADDR_2EAE_cci_rej_freq_neg_12(data)                                (0x00000001&(data))
#define  ATSC_ADDR_2EAE_get_cci_rej_freq_post_6_0(data)                          ((0x000000FE&(data))>>1)
#define  ATSC_ADDR_2EAE_get_cci_rej_freq_neg_12(data)                            (0x00000001&(data))

#define  ATSC_ADDR_2EAF                                                         0x18157ABC
#define  ATSC_ADDR_2EAF_reg_addr                                                 "0xB8157ABC"
#define  ATSC_ADDR_2EAF_reg                                                      0xB8157ABC
#define  ATSC_ADDR_2EAF_inst_addr                                                "0x021B"
#define  set_ATSC_ADDR_2EAF_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EAF_reg)=data)
#define  get_ATSC_ADDR_2EAF_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EAF_reg))
#define  ATSC_ADDR_2EAF_cci_thd_ratio_1_0_shift                                  (6)
#define  ATSC_ADDR_2EAF_cci_rej_freq_post_12_7_shift                             (0)
#define  ATSC_ADDR_2EAF_cci_thd_ratio_1_0_mask                                   (0x000000C0)
#define  ATSC_ADDR_2EAF_cci_rej_freq_post_12_7_mask                              (0x0000003F)
#define  ATSC_ADDR_2EAF_cci_thd_ratio_1_0(data)                                  (0x000000C0&((data)<<6))
#define  ATSC_ADDR_2EAF_cci_rej_freq_post_12_7(data)                             (0x0000003F&(data))
#define  ATSC_ADDR_2EAF_get_cci_thd_ratio_1_0(data)                              ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_2EAF_get_cci_rej_freq_post_12_7(data)                         (0x0000003F&(data))

#define  ATSC_ADDR_2EB0                                                         0x18157AC0
#define  ATSC_ADDR_2EB0_reg_addr                                                 "0xB8157AC0"
#define  ATSC_ADDR_2EB0_reg                                                      0xB8157AC0
#define  ATSC_ADDR_2EB0_inst_addr                                                "0x021C"
#define  set_ATSC_ADDR_2EB0_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EB0_reg)=data)
#define  get_ATSC_ADDR_2EB0_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EB0_reg))
#define  ATSC_ADDR_2EB0_cci_thd_ratio_9_2_shift                                  (0)
#define  ATSC_ADDR_2EB0_cci_thd_ratio_9_2_mask                                   (0x000000FF)
#define  ATSC_ADDR_2EB0_cci_thd_ratio_9_2(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2EB0_get_cci_thd_ratio_9_2(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2EB1                                                         0x18157AC4
#define  ATSC_ADDR_2EB1_reg_addr                                                 "0xB8157AC4"
#define  ATSC_ADDR_2EB1_reg                                                      0xB8157AC4
#define  ATSC_ADDR_2EB1_inst_addr                                                "0x021D"
#define  set_ATSC_ADDR_2EB1_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EB1_reg)=data)
#define  get_ATSC_ADDR_2EB1_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EB1_reg))
#define  ATSC_ADDR_2EB1_cci_fft_dsp_first_out_idx_4_0_shift                      (3)
#define  ATSC_ADDR_2EB1_cci_iir_reset_each_frame_shift                           (2)
#define  ATSC_ADDR_2EB1_cci_thd_ratio_11_10_shift                                (0)
#define  ATSC_ADDR_2EB1_cci_fft_dsp_first_out_idx_4_0_mask                       (0x000000F8)
#define  ATSC_ADDR_2EB1_cci_iir_reset_each_frame_mask                            (0x00000004)
#define  ATSC_ADDR_2EB1_cci_thd_ratio_11_10_mask                                 (0x00000003)
#define  ATSC_ADDR_2EB1_cci_fft_dsp_first_out_idx_4_0(data)                      (0x000000F8&((data)<<3))
#define  ATSC_ADDR_2EB1_cci_iir_reset_each_frame(data)                           (0x00000004&((data)<<2))
#define  ATSC_ADDR_2EB1_cci_thd_ratio_11_10(data)                                (0x00000003&(data))
#define  ATSC_ADDR_2EB1_get_cci_fft_dsp_first_out_idx_4_0(data)                  ((0x000000F8&(data))>>3)
#define  ATSC_ADDR_2EB1_get_cci_iir_reset_each_frame(data)                       ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2EB1_get_cci_thd_ratio_11_10(data)                            (0x00000003&(data))

#define  ATSC_ADDR_2EB2                                                         0x18157AC8
#define  ATSC_ADDR_2EB2_reg_addr                                                 "0xB8157AC8"
#define  ATSC_ADDR_2EB2_reg                                                      0xB8157AC8
#define  ATSC_ADDR_2EB2_inst_addr                                                "0x021E"
#define  set_ATSC_ADDR_2EB2_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EB2_reg)=data)
#define  get_ATSC_ADDR_2EB2_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EB2_reg))
#define  ATSC_ADDR_2EB2_cci_fft_dsp_first_out_idx_12_5_shift                     (0)
#define  ATSC_ADDR_2EB2_cci_fft_dsp_first_out_idx_12_5_mask                      (0x000000FF)
#define  ATSC_ADDR_2EB2_cci_fft_dsp_first_out_idx_12_5(data)                     (0x000000FF&(data))
#define  ATSC_ADDR_2EB2_get_cci_fft_dsp_first_out_idx_12_5(data)                 (0x000000FF&(data))

#define  ATSC_ADDR_2EB3                                                         0x18157ACC
#define  ATSC_ADDR_2EB3_reg_addr                                                 "0xB8157ACC"
#define  ATSC_ADDR_2EB3_reg                                                      0xB8157ACC
#define  ATSC_ADDR_2EB3_inst_addr                                                "0x021F"
#define  set_ATSC_ADDR_2EB3_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EB3_reg)=data)
#define  get_ATSC_ADDR_2EB3_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EB3_reg))
#define  ATSC_ADDR_2EB3_cci_fft_act_num_2_0_shift                                (5)
#define  ATSC_ADDR_2EB3_cci_fft_abs_shift                                        (4)
#define  ATSC_ADDR_2EB3_cci_fft_idx_offset_shift                                 (0)
#define  ATSC_ADDR_2EB3_cci_fft_act_num_2_0_mask                                 (0x000000E0)
#define  ATSC_ADDR_2EB3_cci_fft_abs_mask                                         (0x00000010)
#define  ATSC_ADDR_2EB3_cci_fft_idx_offset_mask                                  (0x0000000F)
#define  ATSC_ADDR_2EB3_cci_fft_act_num_2_0(data)                                (0x000000E0&((data)<<5))
#define  ATSC_ADDR_2EB3_cci_fft_abs(data)                                        (0x00000010&((data)<<4))
#define  ATSC_ADDR_2EB3_cci_fft_idx_offset(data)                                 (0x0000000F&(data))
#define  ATSC_ADDR_2EB3_get_cci_fft_act_num_2_0(data)                            ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_2EB3_get_cci_fft_abs(data)                                    ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2EB3_get_cci_fft_idx_offset(data)                             (0x0000000F&(data))

#define  ATSC_ADDR_2EB4                                                         0x18157AD0
#define  ATSC_ADDR_2EB4_reg_addr                                                 "0xB8157AD0"
#define  ATSC_ADDR_2EB4_reg                                                      0xB8157AD0
#define  ATSC_ADDR_2EB4_inst_addr                                                "0x0220"
#define  set_ATSC_ADDR_2EB4_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EB4_reg)=data)
#define  get_ATSC_ADDR_2EB4_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EB4_reg))
#define  ATSC_ADDR_2EB4_cci_fft_trunc_num_shift                                  (5)
#define  ATSC_ADDR_2EB4_cci_fft_out_mode_shift                                   (4)
#define  ATSC_ADDR_2EB4_cci_fft_dsp_read_shift                                   (3)
#define  ATSC_ADDR_2EB4_cci_fft_act_num_5_3_shift                                (0)
#define  ATSC_ADDR_2EB4_cci_fft_trunc_num_mask                                   (0x000000E0)
#define  ATSC_ADDR_2EB4_cci_fft_out_mode_mask                                    (0x00000010)
#define  ATSC_ADDR_2EB4_cci_fft_dsp_read_mask                                    (0x00000008)
#define  ATSC_ADDR_2EB4_cci_fft_act_num_5_3_mask                                 (0x00000007)
#define  ATSC_ADDR_2EB4_cci_fft_trunc_num(data)                                  (0x000000E0&((data)<<5))
#define  ATSC_ADDR_2EB4_cci_fft_out_mode(data)                                   (0x00000010&((data)<<4))
#define  ATSC_ADDR_2EB4_cci_fft_dsp_read(data)                                   (0x00000008&((data)<<3))
#define  ATSC_ADDR_2EB4_cci_fft_act_num_5_3(data)                                (0x00000007&(data))
#define  ATSC_ADDR_2EB4_get_cci_fft_trunc_num(data)                              ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_2EB4_get_cci_fft_out_mode(data)                               ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2EB4_get_cci_fft_dsp_read(data)                               ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2EB4_get_cci_fft_act_num_5_3(data)                            (0x00000007&(data))

#define  ATSC_ADDR_2EB5                                                         0x18157AD4
#define  ATSC_ADDR_2EB5_reg_addr                                                 "0xB8157AD4"
#define  ATSC_ADDR_2EB5_reg                                                      0xB8157AD4
#define  ATSC_ADDR_2EB5_inst_addr                                                "0x0221"
#define  set_ATSC_ADDR_2EB5_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EB5_reg)=data)
#define  get_ATSC_ADDR_2EB5_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EB5_reg))
#define  ATSC_ADDR_2EB5_cci_pos_5_0_shift                                        (2)
#define  ATSC_ADDR_2EB5_cci_rej_on_shift                                         (1)
#define  ATSC_ADDR_2EB5_cci_detected_shift                                       (0)
#define  ATSC_ADDR_2EB5_cci_pos_5_0_mask                                         (0x000000FC)
#define  ATSC_ADDR_2EB5_cci_rej_on_mask                                          (0x00000002)
#define  ATSC_ADDR_2EB5_cci_detected_mask                                        (0x00000001)
#define  ATSC_ADDR_2EB5_cci_pos_5_0(data)                                        (0x000000FC&((data)<<2))
#define  ATSC_ADDR_2EB5_cci_rej_on(data)                                         (0x00000002&((data)<<1))
#define  ATSC_ADDR_2EB5_cci_detected(data)                                       (0x00000001&(data))
#define  ATSC_ADDR_2EB5_get_cci_pos_5_0(data)                                    ((0x000000FC&(data))>>2)
#define  ATSC_ADDR_2EB5_get_cci_rej_on(data)                                     ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2EB5_get_cci_detected(data)                                   (0x00000001&(data))

#define  ATSC_ADDR_2EB6                                                         0x18157AD8
#define  ATSC_ADDR_2EB6_reg_addr                                                 "0xB8157AD8"
#define  ATSC_ADDR_2EB6_reg                                                      0xB8157AD8
#define  ATSC_ADDR_2EB6_inst_addr                                                "0x0222"
#define  set_ATSC_ADDR_2EB6_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EB6_reg)=data)
#define  get_ATSC_ADDR_2EB6_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EB6_reg))
#define  ATSC_ADDR_2EB6_cci_val_0_shift                                          (7)
#define  ATSC_ADDR_2EB6_cci_pos_12_6_shift                                       (0)
#define  ATSC_ADDR_2EB6_cci_val_0_mask                                           (0x00000080)
#define  ATSC_ADDR_2EB6_cci_pos_12_6_mask                                        (0x0000007F)
#define  ATSC_ADDR_2EB6_cci_val_0(data)                                          (0x00000080&((data)<<7))
#define  ATSC_ADDR_2EB6_cci_pos_12_6(data)                                       (0x0000007F&(data))
#define  ATSC_ADDR_2EB6_get_cci_val_0(data)                                      ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2EB6_get_cci_pos_12_6(data)                                   (0x0000007F&(data))

#define  ATSC_ADDR_2EB7                                                         0x18157ADC
#define  ATSC_ADDR_2EB7_reg_addr                                                 "0xB8157ADC"
#define  ATSC_ADDR_2EB7_reg                                                      0xB8157ADC
#define  ATSC_ADDR_2EB7_inst_addr                                                "0x0223"
#define  set_ATSC_ADDR_2EB7_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EB7_reg)=data)
#define  get_ATSC_ADDR_2EB7_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EB7_reg))
#define  ATSC_ADDR_2EB7_cci_val_8_1_shift                                        (0)
#define  ATSC_ADDR_2EB7_cci_val_8_1_mask                                         (0x000000FF)
#define  ATSC_ADDR_2EB7_cci_val_8_1(data)                                        (0x000000FF&(data))
#define  ATSC_ADDR_2EB7_get_cci_val_8_1(data)                                    (0x000000FF&(data))

#define  ATSC_ADDR_2EB8                                                         0x18157AE0
#define  ATSC_ADDR_2EB8_reg_addr                                                 "0xB8157AE0"
#define  ATSC_ADDR_2EB8_reg                                                      0xB8157AE0
#define  ATSC_ADDR_2EB8_inst_addr                                                "0x0224"
#define  set_ATSC_ADDR_2EB8_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EB8_reg)=data)
#define  get_ATSC_ADDR_2EB8_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EB8_reg))
#define  ATSC_ADDR_2EB8_cci_val_13_9_shift                                       (0)
#define  ATSC_ADDR_2EB8_cci_val_13_9_mask                                        (0x0000001F)
#define  ATSC_ADDR_2EB8_cci_val_13_9(data)                                       (0x0000001F&(data))
#define  ATSC_ADDR_2EB8_get_cci_val_13_9(data)                                   (0x0000001F&(data))

#define  ATSC_ADDR_264B                                                         0x1815592C
#define  ATSC_ADDR_264B_reg_addr                                                 "0xB815592C"
#define  ATSC_ADDR_264B_reg                                                      0xB815592C
#define  ATSC_ADDR_264B_inst_addr                                                "0x0225"
#define  set_ATSC_ADDR_264B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_264B_reg)=data)
#define  get_ATSC_ADDR_264B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_264B_reg))
#define  ATSC_ADDR_264B_cr_trk1_period_ub_shift                                  (3)
#define  ATSC_ADDR_264B_cr_trk1_period_lb_shift                                  (0)
#define  ATSC_ADDR_264B_cr_trk1_period_ub_mask                                   (0x00000038)
#define  ATSC_ADDR_264B_cr_trk1_period_lb_mask                                   (0x00000007)
#define  ATSC_ADDR_264B_cr_trk1_period_ub(data)                                  (0x00000038&((data)<<3))
#define  ATSC_ADDR_264B_cr_trk1_period_lb(data)                                  (0x00000007&(data))
#define  ATSC_ADDR_264B_get_cr_trk1_period_ub(data)                              ((0x00000038&(data))>>3)
#define  ATSC_ADDR_264B_get_cr_trk1_period_lb(data)                              (0x00000007&(data))

#define  ATSC_ADDR_264C                                                         0x18155930
#define  ATSC_ADDR_264C_reg_addr                                                 "0xB8155930"
#define  ATSC_ADDR_264C_reg                                                      0xB8155930
#define  ATSC_ADDR_264C_inst_addr                                                "0x0226"
#define  set_ATSC_ADDR_264C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_264C_reg)=data)
#define  get_ATSC_ADDR_264C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_264C_reg))
#define  ATSC_ADDR_264C_cr_corr_th_shift                                         (1)
#define  ATSC_ADDR_264C_cr_ld_corr_en_shift                                      (0)
#define  ATSC_ADDR_264C_cr_corr_th_mask                                          (0x0000007E)
#define  ATSC_ADDR_264C_cr_ld_corr_en_mask                                       (0x00000001)
#define  ATSC_ADDR_264C_cr_corr_th(data)                                         (0x0000007E&((data)<<1))
#define  ATSC_ADDR_264C_cr_ld_corr_en(data)                                      (0x00000001&(data))
#define  ATSC_ADDR_264C_get_cr_corr_th(data)                                     ((0x0000007E&(data))>>1)
#define  ATSC_ADDR_264C_get_cr_ld_corr_en(data)                                  (0x00000001&(data))

#define  ATSC_ADDR_264D                                                         0x18155934
#define  ATSC_ADDR_264D_reg_addr                                                 "0xB8155934"
#define  ATSC_ADDR_264D_reg                                                      0xB8155934
#define  ATSC_ADDR_264D_inst_addr                                                "0x0227"
#define  set_ATSC_ADDR_264D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_264D_reg)=data)
#define  get_ATSC_ADDR_264D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_264D_reg))
#define  ATSC_ADDR_264D_cr_fs_reset_en_shift                                     (4)
#define  ATSC_ADDR_264D_cr_trk1_trk2_rst_en_shift                                (3)
#define  ATSC_ADDR_264D_cr_ld_trk2_unlock_and_or_shift                           (2)
#define  ATSC_ADDR_264D_cr_ld_trk2_unlock_in_en_shift                            (1)
#define  ATSC_ADDR_264D_cr_ld_trk2_unlock_corr_en_shift                          (0)
#define  ATSC_ADDR_264D_cr_fs_reset_en_mask                                      (0x00000010)
#define  ATSC_ADDR_264D_cr_trk1_trk2_rst_en_mask                                 (0x00000008)
#define  ATSC_ADDR_264D_cr_ld_trk2_unlock_and_or_mask                            (0x00000004)
#define  ATSC_ADDR_264D_cr_ld_trk2_unlock_in_en_mask                             (0x00000002)
#define  ATSC_ADDR_264D_cr_ld_trk2_unlock_corr_en_mask                           (0x00000001)
#define  ATSC_ADDR_264D_cr_fs_reset_en(data)                                     (0x00000010&((data)<<4))
#define  ATSC_ADDR_264D_cr_trk1_trk2_rst_en(data)                                (0x00000008&((data)<<3))
#define  ATSC_ADDR_264D_cr_ld_trk2_unlock_and_or(data)                           (0x00000004&((data)<<2))
#define  ATSC_ADDR_264D_cr_ld_trk2_unlock_in_en(data)                            (0x00000002&((data)<<1))
#define  ATSC_ADDR_264D_cr_ld_trk2_unlock_corr_en(data)                          (0x00000001&(data))
#define  ATSC_ADDR_264D_get_cr_fs_reset_en(data)                                 ((0x00000010&(data))>>4)
#define  ATSC_ADDR_264D_get_cr_trk1_trk2_rst_en(data)                            ((0x00000008&(data))>>3)
#define  ATSC_ADDR_264D_get_cr_ld_trk2_unlock_and_or(data)                       ((0x00000004&(data))>>2)
#define  ATSC_ADDR_264D_get_cr_ld_trk2_unlock_in_en(data)                        ((0x00000002&(data))>>1)
#define  ATSC_ADDR_264D_get_cr_ld_trk2_unlock_corr_en(data)                      (0x00000001&(data))

#define  ATSC_ADDR_2650                                                         0x18155940
#define  ATSC_ADDR_2650_reg_addr                                                 "0xB8155940"
#define  ATSC_ADDR_2650_reg                                                      0xB8155940
#define  ATSC_ADDR_2650_inst_addr                                                "0x0228"
#define  set_ATSC_ADDR_2650_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2650_reg)=data)
#define  get_ATSC_ADDR_2650_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2650_reg))
#define  ATSC_ADDR_2650_cr_acq_period1_ub1_shift                                 (5)
#define  ATSC_ADDR_2650_cr_acq_period1_ub0_shift                                 (2)
#define  ATSC_ADDR_2650_cr_search_mode_shift                                     (1)
#define  ATSC_ADDR_2650_cr_fsm_on_shift                                          (0)
#define  ATSC_ADDR_2650_cr_acq_period1_ub1_mask                                  (0x000000E0)
#define  ATSC_ADDR_2650_cr_acq_period1_ub0_mask                                  (0x0000001C)
#define  ATSC_ADDR_2650_cr_search_mode_mask                                      (0x00000002)
#define  ATSC_ADDR_2650_cr_fsm_on_mask                                           (0x00000001)
#define  ATSC_ADDR_2650_cr_acq_period1_ub1(data)                                 (0x000000E0&((data)<<5))
#define  ATSC_ADDR_2650_cr_acq_period1_ub0(data)                                 (0x0000001C&((data)<<2))
#define  ATSC_ADDR_2650_cr_search_mode(data)                                     (0x00000002&((data)<<1))
#define  ATSC_ADDR_2650_cr_fsm_on(data)                                          (0x00000001&(data))
#define  ATSC_ADDR_2650_get_cr_acq_period1_ub1(data)                             ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_2650_get_cr_acq_period1_ub0(data)                             ((0x0000001C&(data))>>2)
#define  ATSC_ADDR_2650_get_cr_search_mode(data)                                 ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2650_get_cr_fsm_on(data)                                      (0x00000001&(data))

#define  ATSC_ADDR_2651                                                         0x18155944
#define  ATSC_ADDR_2651_reg_addr                                                 "0xB8155944"
#define  ATSC_ADDR_2651_reg                                                      0xB8155944
#define  ATSC_ADDR_2651_inst_addr                                                "0x0229"
#define  set_ATSC_ADDR_2651_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2651_reg)=data)
#define  get_ATSC_ADDR_2651_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2651_reg))
#define  ATSC_ADDR_2651_cr_acq_period1_lb1_shift                                 (5)
#define  ATSC_ADDR_2651_cr_acq_period1_lb0_shift                                 (3)
#define  ATSC_ADDR_2651_cr_acq_period1_lb1_mask                                  (0x00000060)
#define  ATSC_ADDR_2651_cr_acq_period1_lb0_mask                                  (0x00000018)
#define  ATSC_ADDR_2651_cr_acq_period1_lb1(data)                                 (0x00000060&((data)<<5))
#define  ATSC_ADDR_2651_cr_acq_period1_lb0(data)                                 (0x00000018&((data)<<3))
#define  ATSC_ADDR_2651_get_cr_acq_period1_lb1(data)                             ((0x00000060&(data))>>5)
#define  ATSC_ADDR_2651_get_cr_acq_period1_lb0(data)                             ((0x00000018&(data))>>3)

#define  ATSC_ADDR_2652                                                         0x18155948
#define  ATSC_ADDR_2652_reg_addr                                                 "0xB8155948"
#define  ATSC_ADDR_2652_reg                                                      0xB8155948
#define  ATSC_ADDR_2652_inst_addr                                                "0x022A"
#define  set_ATSC_ADDR_2652_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2652_reg)=data)
#define  get_ATSC_ADDR_2652_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2652_reg))
#define  ATSC_ADDR_2652_cr_acq_unlock_period_shift                               (5)
#define  ATSC_ADDR_2652_cr_acq_unlock_period_mask                                (0x000000E0)
#define  ATSC_ADDR_2652_cr_acq_unlock_period(data)                               (0x000000E0&((data)<<5))
#define  ATSC_ADDR_2652_get_cr_acq_unlock_period(data)                           ((0x000000E0&(data))>>5)

#define  ATSC_ADDR_2653                                                         0x1815594C
#define  ATSC_ADDR_2653_reg_addr                                                 "0xB815594C"
#define  ATSC_ADDR_2653_reg                                                      0xB815594C
#define  ATSC_ADDR_2653_inst_addr                                                "0x022B"
#define  set_ATSC_ADDR_2653_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2653_reg)=data)
#define  get_ATSC_ADDR_2653_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2653_reg))
#define  ATSC_ADDR_2653_cr_ld_period_shift                                       (3)
#define  ATSC_ADDR_2653_cr_comp_period_shift                                     (0)
#define  ATSC_ADDR_2653_cr_ld_period_mask                                        (0x00000038)
#define  ATSC_ADDR_2653_cr_comp_period_mask                                      (0x00000007)
#define  ATSC_ADDR_2653_cr_ld_period(data)                                       (0x00000038&((data)<<3))
#define  ATSC_ADDR_2653_cr_comp_period(data)                                     (0x00000007&(data))
#define  ATSC_ADDR_2653_get_cr_ld_period(data)                                   ((0x00000038&(data))>>3)
#define  ATSC_ADDR_2653_get_cr_comp_period(data)                                 (0x00000007&(data))

#define  ATSC_ADDR_2654                                                         0x18155950
#define  ATSC_ADDR_2654_reg_addr                                                 "0xB8155950"
#define  ATSC_ADDR_2654_reg                                                      0xB8155950
#define  ATSC_ADDR_2654_inst_addr                                                "0x022C"
#define  set_ATSC_ADDR_2654_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2654_reg)=data)
#define  get_ATSC_ADDR_2654_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2654_reg))
#define  ATSC_ADDR_2654_cr_acq_freq_step0_shift                                  (0)
#define  ATSC_ADDR_2654_cr_acq_freq_step0_mask                                   (0x0000003F)
#define  ATSC_ADDR_2654_cr_acq_freq_step0(data)                                  (0x0000003F&(data))
#define  ATSC_ADDR_2654_get_cr_acq_freq_step0(data)                              (0x0000003F&(data))

#define  ATSC_ADDR_2655                                                         0x18155954
#define  ATSC_ADDR_2655_reg_addr                                                 "0xB8155954"
#define  ATSC_ADDR_2655_reg                                                      0xB8155954
#define  ATSC_ADDR_2655_inst_addr                                                "0x022D"
#define  set_ATSC_ADDR_2655_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2655_reg)=data)
#define  get_ATSC_ADDR_2655_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2655_reg))
#define  ATSC_ADDR_2655_cr_acq_freq_step1_shift                                  (0)
#define  ATSC_ADDR_2655_cr_acq_freq_step1_mask                                   (0x0000003F)
#define  ATSC_ADDR_2655_cr_acq_freq_step1(data)                                  (0x0000003F&(data))
#define  ATSC_ADDR_2655_get_cr_acq_freq_step1(data)                              (0x0000003F&(data))

#define  ATSC_ADDR_2657                                                         0x1815595C
#define  ATSC_ADDR_2657_reg_addr                                                 "0xB815595C"
#define  ATSC_ADDR_2657_reg                                                      0xB815595C
#define  ATSC_ADDR_2657_inst_addr                                                "0x022E"
#define  set_ATSC_ADDR_2657_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2657_reg)=data)
#define  get_ATSC_ADDR_2657_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2657_reg))
#define  ATSC_ADDR_2657_cr_acq_if_offset_ini1_shift                              (4)
#define  ATSC_ADDR_2657_cr_acq_if_offset_ini0_shift                              (0)
#define  ATSC_ADDR_2657_cr_acq_if_offset_ini1_mask                               (0x000000F0)
#define  ATSC_ADDR_2657_cr_acq_if_offset_ini0_mask                               (0x0000000F)
#define  ATSC_ADDR_2657_cr_acq_if_offset_ini1(data)                              (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2657_cr_acq_if_offset_ini0(data)                              (0x0000000F&(data))
#define  ATSC_ADDR_2657_get_cr_acq_if_offset_ini1(data)                          ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2657_get_cr_acq_if_offset_ini0(data)                          (0x0000000F&(data))

#define  ATSC_ADDR_2659                                                         0x18155964
#define  ATSC_ADDR_2659_reg_addr                                                 "0xB8155964"
#define  ATSC_ADDR_2659_reg                                                      0xB8155964
#define  ATSC_ADDR_2659_inst_addr                                                "0x022F"
#define  set_ATSC_ADDR_2659_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2659_reg)=data)
#define  get_ATSC_ADDR_2659_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2659_reg))
#define  ATSC_ADDR_2659_cr_acq_pre_shift_shift                                   (0)
#define  ATSC_ADDR_2659_cr_acq_pre_shift_mask                                    (0x0000007F)
#define  ATSC_ADDR_2659_cr_acq_pre_shift(data)                                   (0x0000007F&(data))
#define  ATSC_ADDR_2659_get_cr_acq_pre_shift(data)                               (0x0000007F&(data))

#define  ATSC_ADDR_265A                                                         0x18155968
#define  ATSC_ADDR_265A_reg_addr                                                 "0xB8155968"
#define  ATSC_ADDR_265A_reg                                                      0xB8155968
#define  ATSC_ADDR_265A_inst_addr                                                "0x0230"
#define  set_ATSC_ADDR_265A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_265A_reg)=data)
#define  get_ATSC_ADDR_265A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_265A_reg))
#define  ATSC_ADDR_265A_cr_const_inc_7_0_shift                                   (0)
#define  ATSC_ADDR_265A_cr_const_inc_7_0_mask                                    (0x000000FF)
#define  ATSC_ADDR_265A_cr_const_inc_7_0(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_265A_get_cr_const_inc_7_0(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_265B                                                         0x1815596C
#define  ATSC_ADDR_265B_reg_addr                                                 "0xB815596C"
#define  ATSC_ADDR_265B_reg                                                      0xB815596C
#define  ATSC_ADDR_265B_inst_addr                                                "0x0231"
#define  set_ATSC_ADDR_265B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_265B_reg)=data)
#define  get_ATSC_ADDR_265B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_265B_reg))
#define  ATSC_ADDR_265B_cr_const_inc_15_8_shift                                  (0)
#define  ATSC_ADDR_265B_cr_const_inc_15_8_mask                                   (0x000000FF)
#define  ATSC_ADDR_265B_cr_const_inc_15_8(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_265B_get_cr_const_inc_15_8(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_265C                                                         0x18155970
#define  ATSC_ADDR_265C_reg_addr                                                 "0xB8155970"
#define  ATSC_ADDR_265C_reg                                                      0xB8155970
#define  ATSC_ADDR_265C_inst_addr                                                "0x0232"
#define  set_ATSC_ADDR_265C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_265C_reg)=data)
#define  get_ATSC_ADDR_265C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_265C_reg))
#define  ATSC_ADDR_265C_cr_const_inc_16_shift                                    (0)
#define  ATSC_ADDR_265C_cr_const_inc_16_mask                                     (0x00000001)
#define  ATSC_ADDR_265C_cr_const_inc_16(data)                                    (0x00000001&(data))
#define  ATSC_ADDR_265C_get_cr_const_inc_16(data)                                (0x00000001&(data))

#define  ATSC_ADDR_265D                                                         0x18155974
#define  ATSC_ADDR_265D_reg_addr                                                 "0xB8155974"
#define  ATSC_ADDR_265D_reg                                                      0xB8155974
#define  ATSC_ADDR_265D_inst_addr                                                "0x0233"
#define  set_ATSC_ADDR_265D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_265D_reg)=data)
#define  get_ATSC_ADDR_265D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_265D_reg))
#define  ATSC_ADDR_265D_cr_acq_freq_ub_shift                                     (0)
#define  ATSC_ADDR_265D_cr_acq_freq_ub_mask                                      (0x0000003F)
#define  ATSC_ADDR_265D_cr_acq_freq_ub(data)                                     (0x0000003F&(data))
#define  ATSC_ADDR_265D_get_cr_acq_freq_ub(data)                                 (0x0000003F&(data))

#define  ATSC_ADDR_265E                                                         0x18155978
#define  ATSC_ADDR_265E_reg_addr                                                 "0xB8155978"
#define  ATSC_ADDR_265E_reg                                                      0xB8155978
#define  ATSC_ADDR_265E_inst_addr                                                "0x0234"
#define  set_ATSC_ADDR_265E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_265E_reg)=data)
#define  get_ATSC_ADDR_265E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_265E_reg))
#define  ATSC_ADDR_265E_fs2_main_addr_th1_7_0_shift                              (0)
#define  ATSC_ADDR_265E_fs2_main_addr_th1_7_0_mask                               (0x000000FF)
#define  ATSC_ADDR_265E_fs2_main_addr_th1_7_0(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_265E_get_fs2_main_addr_th1_7_0(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_265F                                                         0x1815597C
#define  ATSC_ADDR_265F_reg_addr                                                 "0xB815597C"
#define  ATSC_ADDR_265F_reg                                                      0xB815597C
#define  ATSC_ADDR_265F_inst_addr                                                "0x0235"
#define  set_ATSC_ADDR_265F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_265F_reg)=data)
#define  get_ATSC_ADDR_265F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_265F_reg))
#define  ATSC_ADDR_265F_fs2_main_addr_th1_11_8_shift                             (0)
#define  ATSC_ADDR_265F_fs2_main_addr_th1_11_8_mask                              (0x0000000F)
#define  ATSC_ADDR_265F_fs2_main_addr_th1_11_8(data)                             (0x0000000F&(data))
#define  ATSC_ADDR_265F_get_fs2_main_addr_th1_11_8(data)                         (0x0000000F&(data))

#define  ATSC_ADDR_2660                                                         0x18155980
#define  ATSC_ADDR_2660_reg_addr                                                 "0xB8155980"
#define  ATSC_ADDR_2660_reg                                                      0xB8155980
#define  ATSC_ADDR_2660_inst_addr                                                "0x0236"
#define  set_ATSC_ADDR_2660_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2660_reg)=data)
#define  get_ATSC_ADDR_2660_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2660_reg))
#define  ATSC_ADDR_2660_fs2_main_addr_th2_7_0_shift                              (0)
#define  ATSC_ADDR_2660_fs2_main_addr_th2_7_0_mask                               (0x000000FF)
#define  ATSC_ADDR_2660_fs2_main_addr_th2_7_0(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_2660_get_fs2_main_addr_th2_7_0(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_2661                                                         0x18155984
#define  ATSC_ADDR_2661_reg_addr                                                 "0xB8155984"
#define  ATSC_ADDR_2661_reg                                                      0xB8155984
#define  ATSC_ADDR_2661_inst_addr                                                "0x0237"
#define  set_ATSC_ADDR_2661_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2661_reg)=data)
#define  get_ATSC_ADDR_2661_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2661_reg))
#define  ATSC_ADDR_2661_fs2_main_addr_th2_11_8_shift                             (0)
#define  ATSC_ADDR_2661_fs2_main_addr_th2_11_8_mask                              (0x0000000F)
#define  ATSC_ADDR_2661_fs2_main_addr_th2_11_8(data)                             (0x0000000F&(data))
#define  ATSC_ADDR_2661_get_fs2_main_addr_th2_11_8(data)                         (0x0000000F&(data))

#define  ATSC_ADDR_2662                                                         0x18155988
#define  ATSC_ADDR_2662_reg_addr                                                 "0xB8155988"
#define  ATSC_ADDR_2662_reg                                                      0xB8155988
#define  ATSC_ADDR_2662_inst_addr                                                "0x0238"
#define  set_ATSC_ADDR_2662_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2662_reg)=data)
#define  get_ATSC_ADDR_2662_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2662_reg))
#define  ATSC_ADDR_2662_fs2_main_addr_th3_7_0_shift                              (0)
#define  ATSC_ADDR_2662_fs2_main_addr_th3_7_0_mask                               (0x000000FF)
#define  ATSC_ADDR_2662_fs2_main_addr_th3_7_0(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_2662_get_fs2_main_addr_th3_7_0(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_2663                                                         0x1815598C
#define  ATSC_ADDR_2663_reg_addr                                                 "0xB815598C"
#define  ATSC_ADDR_2663_reg                                                      0xB815598C
#define  ATSC_ADDR_2663_inst_addr                                                "0x0239"
#define  set_ATSC_ADDR_2663_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2663_reg)=data)
#define  get_ATSC_ADDR_2663_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2663_reg))
#define  ATSC_ADDR_2663_fs2_main_addr_th3_11_8_shift                             (0)
#define  ATSC_ADDR_2663_fs2_main_addr_th3_11_8_mask                              (0x0000000F)
#define  ATSC_ADDR_2663_fs2_main_addr_th3_11_8(data)                             (0x0000000F&(data))
#define  ATSC_ADDR_2663_get_fs2_main_addr_th3_11_8(data)                         (0x0000000F&(data))

#define  ATSC_ADDR_2664                                                         0x18155990
#define  ATSC_ADDR_2664_reg_addr                                                 "0xB8155990"
#define  ATSC_ADDR_2664_reg                                                      0xB8155990
#define  ATSC_ADDR_2664_inst_addr                                                "0x023A"
#define  set_ATSC_ADDR_2664_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2664_reg)=data)
#define  get_ATSC_ADDR_2664_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2664_reg))
#define  ATSC_ADDR_2664_fs2_main_addr_th4_7_0_shift                              (0)
#define  ATSC_ADDR_2664_fs2_main_addr_th4_7_0_mask                               (0x000000FF)
#define  ATSC_ADDR_2664_fs2_main_addr_th4_7_0(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_2664_get_fs2_main_addr_th4_7_0(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_2665                                                         0x18155994
#define  ATSC_ADDR_2665_reg_addr                                                 "0xB8155994"
#define  ATSC_ADDR_2665_reg                                                      0xB8155994
#define  ATSC_ADDR_2665_inst_addr                                                "0x023B"
#define  set_ATSC_ADDR_2665_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2665_reg)=data)
#define  get_ATSC_ADDR_2665_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2665_reg))
#define  ATSC_ADDR_2665_fs2_main_addr_th4_11_8_shift                             (0)
#define  ATSC_ADDR_2665_fs2_main_addr_th4_11_8_mask                              (0x0000000F)
#define  ATSC_ADDR_2665_fs2_main_addr_th4_11_8(data)                             (0x0000000F&(data))
#define  ATSC_ADDR_2665_get_fs2_main_addr_th4_11_8(data)                         (0x0000000F&(data))

#define  ATSC_ADDR_2666                                                         0x18155998
#define  ATSC_ADDR_2666_reg_addr                                                 "0xB8155998"
#define  ATSC_ADDR_2666_reg                                                      0xB8155998
#define  ATSC_ADDR_2666_inst_addr                                                "0x023C"
#define  set_ATSC_ADDR_2666_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2666_reg)=data)
#define  get_ATSC_ADDR_2666_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2666_reg))
#define  ATSC_ADDR_2666_fs2_main_addr_th5_7_0_shift                              (0)
#define  ATSC_ADDR_2666_fs2_main_addr_th5_7_0_mask                               (0x000000FF)
#define  ATSC_ADDR_2666_fs2_main_addr_th5_7_0(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_2666_get_fs2_main_addr_th5_7_0(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_2667                                                         0x1815599C
#define  ATSC_ADDR_2667_reg_addr                                                 "0xB815599C"
#define  ATSC_ADDR_2667_reg                                                      0xB815599C
#define  ATSC_ADDR_2667_inst_addr                                                "0x023D"
#define  set_ATSC_ADDR_2667_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2667_reg)=data)
#define  get_ATSC_ADDR_2667_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2667_reg))
#define  ATSC_ADDR_2667_fs2_main_addr_th5_11_8_shift                             (0)
#define  ATSC_ADDR_2667_fs2_main_addr_th5_11_8_mask                              (0x0000000F)
#define  ATSC_ADDR_2667_fs2_main_addr_th5_11_8(data)                             (0x0000000F&(data))
#define  ATSC_ADDR_2667_get_fs2_main_addr_th5_11_8(data)                         (0x0000000F&(data))

#define  ATSC_ADDR_2668                                                         0x181559A0
#define  ATSC_ADDR_2668_reg_addr                                                 "0xB81559A0"
#define  ATSC_ADDR_2668_reg                                                      0xB81559A0
#define  ATSC_ADDR_2668_inst_addr                                                "0x023E"
#define  set_ATSC_ADDR_2668_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2668_reg)=data)
#define  get_ATSC_ADDR_2668_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2668_reg))
#define  ATSC_ADDR_2668_fs2_main_addr_th6_7_0_shift                              (0)
#define  ATSC_ADDR_2668_fs2_main_addr_th6_7_0_mask                               (0x000000FF)
#define  ATSC_ADDR_2668_fs2_main_addr_th6_7_0(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_2668_get_fs2_main_addr_th6_7_0(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_2669                                                         0x181559A4
#define  ATSC_ADDR_2669_reg_addr                                                 "0xB81559A4"
#define  ATSC_ADDR_2669_reg                                                      0xB81559A4
#define  ATSC_ADDR_2669_inst_addr                                                "0x023F"
#define  set_ATSC_ADDR_2669_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2669_reg)=data)
#define  get_ATSC_ADDR_2669_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2669_reg))
#define  ATSC_ADDR_2669_fs2_main_addr_th6_11_8_shift                             (0)
#define  ATSC_ADDR_2669_fs2_main_addr_th6_11_8_mask                              (0x0000000F)
#define  ATSC_ADDR_2669_fs2_main_addr_th6_11_8(data)                             (0x0000000F&(data))
#define  ATSC_ADDR_2669_get_fs2_main_addr_th6_11_8(data)                         (0x0000000F&(data))

#define  ATSC_ADDR_266A                                                         0x181559A8
#define  ATSC_ADDR_266A_reg_addr                                                 "0xB81559A8"
#define  ATSC_ADDR_266A_reg                                                      0xB81559A8
#define  ATSC_ADDR_266A_inst_addr                                                "0x0240"
#define  set_ATSC_ADDR_266A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_266A_reg)=data)
#define  get_ATSC_ADDR_266A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_266A_reg))
#define  ATSC_ADDR_266A_fs2_main_max_ratio2_shift                                (0)
#define  ATSC_ADDR_266A_fs2_main_max_ratio2_mask                                 (0x0000007F)
#define  ATSC_ADDR_266A_fs2_main_max_ratio2(data)                                (0x0000007F&(data))
#define  ATSC_ADDR_266A_get_fs2_main_max_ratio2(data)                            (0x0000007F&(data))

#define  ATSC_ADDR_266B                                                         0x181559AC
#define  ATSC_ADDR_266B_reg_addr                                                 "0xB81559AC"
#define  ATSC_ADDR_266B_reg                                                      0xB81559AC
#define  ATSC_ADDR_266B_inst_addr                                                "0x0241"
#define  set_ATSC_ADDR_266B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_266B_reg)=data)
#define  get_ATSC_ADDR_266B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_266B_reg))
#define  ATSC_ADDR_266B_fs2_main_max_ratio3_shift                                (0)
#define  ATSC_ADDR_266B_fs2_main_max_ratio3_mask                                 (0x0000007F)
#define  ATSC_ADDR_266B_fs2_main_max_ratio3(data)                                (0x0000007F&(data))
#define  ATSC_ADDR_266B_get_fs2_main_max_ratio3(data)                            (0x0000007F&(data))

#define  ATSC_ADDR_266C                                                         0x181559B0
#define  ATSC_ADDR_266C_reg_addr                                                 "0xB81559B0"
#define  ATSC_ADDR_266C_reg                                                      0xB81559B0
#define  ATSC_ADDR_266C_inst_addr                                                "0x0242"
#define  set_ATSC_ADDR_266C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_266C_reg)=data)
#define  get_ATSC_ADDR_266C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_266C_reg))
#define  ATSC_ADDR_266C_fs2_main_max_ratio4_shift                                (0)
#define  ATSC_ADDR_266C_fs2_main_max_ratio4_mask                                 (0x0000007F)
#define  ATSC_ADDR_266C_fs2_main_max_ratio4(data)                                (0x0000007F&(data))
#define  ATSC_ADDR_266C_get_fs2_main_max_ratio4(data)                            (0x0000007F&(data))

#define  ATSC_ADDR_266D                                                         0x181559B4
#define  ATSC_ADDR_266D_reg_addr                                                 "0xB81559B4"
#define  ATSC_ADDR_266D_reg                                                      0xB81559B4
#define  ATSC_ADDR_266D_inst_addr                                                "0x0243"
#define  set_ATSC_ADDR_266D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_266D_reg)=data)
#define  get_ATSC_ADDR_266D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_266D_reg))
#define  ATSC_ADDR_266D_fs2_main_max_ratio5_shift                                (0)
#define  ATSC_ADDR_266D_fs2_main_max_ratio5_mask                                 (0x0000007F)
#define  ATSC_ADDR_266D_fs2_main_max_ratio5(data)                                (0x0000007F&(data))
#define  ATSC_ADDR_266D_get_fs2_main_max_ratio5(data)                            (0x0000007F&(data))

#define  ATSC_ADDR_266E                                                         0x181559B8
#define  ATSC_ADDR_266E_reg_addr                                                 "0xB81559B8"
#define  ATSC_ADDR_266E_reg                                                      0xB81559B8
#define  ATSC_ADDR_266E_inst_addr                                                "0x0244"
#define  set_ATSC_ADDR_266E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_266E_reg)=data)
#define  get_ATSC_ADDR_266E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_266E_reg))
#define  ATSC_ADDR_266E_fs2_main_max_ratio6_shift                                (0)
#define  ATSC_ADDR_266E_fs2_main_max_ratio6_mask                                 (0x0000007F)
#define  ATSC_ADDR_266E_fs2_main_max_ratio6(data)                                (0x0000007F&(data))
#define  ATSC_ADDR_266E_get_fs2_main_max_ratio6(data)                            (0x0000007F&(data))

#define  ATSC_ADDR_266F                                                         0x181559BC
#define  ATSC_ADDR_266F_reg_addr                                                 "0xB81559BC"
#define  ATSC_ADDR_266F_reg                                                      0xB81559BC
#define  ATSC_ADDR_266F_inst_addr                                                "0x0245"
#define  set_ATSC_ADDR_266F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_266F_reg)=data)
#define  get_ATSC_ADDR_266F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_266F_reg))
#define  ATSC_ADDR_266F_fs2_main_max_ratio7_shift                                (0)
#define  ATSC_ADDR_266F_fs2_main_max_ratio7_mask                                 (0x0000007F)
#define  ATSC_ADDR_266F_fs2_main_max_ratio7(data)                                (0x0000007F&(data))
#define  ATSC_ADDR_266F_get_fs2_main_max_ratio7(data)                            (0x0000007F&(data))

#define  ATSC_ADDR_2670                                                         0x181559C0
#define  ATSC_ADDR_2670_reg_addr                                                 "0xB81559C0"
#define  ATSC_ADDR_2670_reg                                                      0xB81559C0
#define  ATSC_ADDR_2670_inst_addr                                                "0x0246"
#define  set_ATSC_ADDR_2670_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2670_reg)=data)
#define  get_ATSC_ADDR_2670_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2670_reg))
#define  ATSC_ADDR_2670_fs2_corr_amp_sel_shift                                   (7)
#define  ATSC_ADDR_2670_fs2_main_max_ratio_shift                                 (0)
#define  ATSC_ADDR_2670_fs2_corr_amp_sel_mask                                    (0x00000080)
#define  ATSC_ADDR_2670_fs2_main_max_ratio_mask                                  (0x0000007F)
#define  ATSC_ADDR_2670_fs2_corr_amp_sel(data)                                   (0x00000080&((data)<<7))
#define  ATSC_ADDR_2670_fs2_main_max_ratio(data)                                 (0x0000007F&(data))
#define  ATSC_ADDR_2670_get_fs2_corr_amp_sel(data)                               ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2670_get_fs2_main_max_ratio(data)                             (0x0000007F&(data))

#define  ATSC_ADDR_2671                                                         0x181559C4
#define  ATSC_ADDR_2671_reg_addr                                                 "0xB81559C4"
#define  ATSC_ADDR_2671_reg                                                      0xB81559C4
#define  ATSC_ADDR_2671_inst_addr                                                "0x0247"
#define  set_ATSC_ADDR_2671_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2671_reg)=data)
#define  get_ATSC_ADDR_2671_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2671_reg))
#define  ATSC_ADDR_2671_fs2_wmax_size_7_0_shift                                  (0)
#define  ATSC_ADDR_2671_fs2_wmax_size_7_0_mask                                   (0x000000FF)
#define  ATSC_ADDR_2671_fs2_wmax_size_7_0(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2671_get_fs2_wmax_size_7_0(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2672                                                         0x181559C8
#define  ATSC_ADDR_2672_reg_addr                                                 "0xB81559C8"
#define  ATSC_ADDR_2672_reg                                                      0xB81559C8
#define  ATSC_ADDR_2672_inst_addr                                                "0x0248"
#define  set_ATSC_ADDR_2672_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2672_reg)=data)
#define  get_ATSC_ADDR_2672_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2672_reg))
#define  ATSC_ADDR_2672_fs2_wmax_size_11_8_shift                                 (0)
#define  ATSC_ADDR_2672_fs2_wmax_size_11_8_mask                                  (0x0000000F)
#define  ATSC_ADDR_2672_fs2_wmax_size_11_8(data)                                 (0x0000000F&(data))
#define  ATSC_ADDR_2672_get_fs2_wmax_size_11_8(data)                             (0x0000000F&(data))

#define  ATSC_ADDR_2673                                                         0x181559CC
#define  ATSC_ADDR_2673_reg_addr                                                 "0xB81559CC"
#define  ATSC_ADDR_2673_reg                                                      0xB81559CC
#define  ATSC_ADDR_2673_inst_addr                                                "0x0249"
#define  set_ATSC_ADDR_2673_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2673_reg)=data)
#define  get_ATSC_ADDR_2673_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2673_reg))
#define  ATSC_ADDR_2673_fs2_corr_amp_th1_7_0_shift                               (0)
#define  ATSC_ADDR_2673_fs2_corr_amp_th1_7_0_mask                                (0x000000FF)
#define  ATSC_ADDR_2673_fs2_corr_amp_th1_7_0(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_2673_get_fs2_corr_amp_th1_7_0(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_2674                                                         0x181559D0
#define  ATSC_ADDR_2674_reg_addr                                                 "0xB81559D0"
#define  ATSC_ADDR_2674_reg                                                      0xB81559D0
#define  ATSC_ADDR_2674_inst_addr                                                "0x024A"
#define  set_ATSC_ADDR_2674_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2674_reg)=data)
#define  get_ATSC_ADDR_2674_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2674_reg))
#define  ATSC_ADDR_2674_fs2_corr_amp_th1_12_8_shift                              (0)
#define  ATSC_ADDR_2674_fs2_corr_amp_th1_12_8_mask                               (0x0000001F)
#define  ATSC_ADDR_2674_fs2_corr_amp_th1_12_8(data)                              (0x0000001F&(data))
#define  ATSC_ADDR_2674_get_fs2_corr_amp_th1_12_8(data)                          (0x0000001F&(data))

#define  ATSC_ADDR_2675                                                         0x181559D4
#define  ATSC_ADDR_2675_reg_addr                                                 "0xB81559D4"
#define  ATSC_ADDR_2675_reg                                                      0xB81559D4
#define  ATSC_ADDR_2675_inst_addr                                                "0x024B"
#define  set_ATSC_ADDR_2675_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2675_reg)=data)
#define  get_ATSC_ADDR_2675_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2675_reg))
#define  ATSC_ADDR_2675_fs2_max_rec_sam_num_7_0_shift                            (0)
#define  ATSC_ADDR_2675_fs2_max_rec_sam_num_7_0_mask                             (0x000000FF)
#define  ATSC_ADDR_2675_fs2_max_rec_sam_num_7_0(data)                            (0x000000FF&(data))
#define  ATSC_ADDR_2675_get_fs2_max_rec_sam_num_7_0(data)                        (0x000000FF&(data))

#define  ATSC_ADDR_2676                                                         0x181559D8
#define  ATSC_ADDR_2676_reg_addr                                                 "0xB81559D8"
#define  ATSC_ADDR_2676_reg                                                      0xB81559D8
#define  ATSC_ADDR_2676_inst_addr                                                "0x024C"
#define  set_ATSC_ADDR_2676_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2676_reg)=data)
#define  get_ATSC_ADDR_2676_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2676_reg))
#define  ATSC_ADDR_2676_fs2_max_rec_sam_num_11_8_shift                           (0)
#define  ATSC_ADDR_2676_fs2_max_rec_sam_num_11_8_mask                            (0x0000000F)
#define  ATSC_ADDR_2676_fs2_max_rec_sam_num_11_8(data)                           (0x0000000F&(data))
#define  ATSC_ADDR_2676_get_fs2_max_rec_sam_num_11_8(data)                       (0x0000000F&(data))

#define  ATSC_ADDR_26AE                                                         0x18155AB8
#define  ATSC_ADDR_26AE_reg_addr                                                 "0xB8155AB8"
#define  ATSC_ADDR_26AE_reg                                                      0xB8155AB8
#define  ATSC_ADDR_26AE_inst_addr                                                "0x024D"
#define  set_ATSC_ADDR_26AE_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26AE_reg)=data)
#define  get_ATSC_ADDR_26AE_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26AE_reg))
#define  ATSC_ADDR_26AE_fs2_max_rec_sam_num_2_3_0_shift                          (4)
#define  ATSC_ADDR_26AE_fs2_wp_post_size_10_7_shift                              (0)
#define  ATSC_ADDR_26AE_fs2_max_rec_sam_num_2_3_0_mask                           (0x000000F0)
#define  ATSC_ADDR_26AE_fs2_wp_post_size_10_7_mask                               (0x0000000F)
#define  ATSC_ADDR_26AE_fs2_max_rec_sam_num_2_3_0(data)                          (0x000000F0&((data)<<4))
#define  ATSC_ADDR_26AE_fs2_wp_post_size_10_7(data)                              (0x0000000F&(data))
#define  ATSC_ADDR_26AE_get_fs2_max_rec_sam_num_2_3_0(data)                      ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_26AE_get_fs2_wp_post_size_10_7(data)                          (0x0000000F&(data))

#define  ATSC_ADDR_26AF                                                         0x18155ABC
#define  ATSC_ADDR_26AF_reg_addr                                                 "0xB8155ABC"
#define  ATSC_ADDR_26AF_reg                                                      0xB8155ABC
#define  ATSC_ADDR_26AF_inst_addr                                                "0x024E"
#define  set_ATSC_ADDR_26AF_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26AF_reg)=data)
#define  get_ATSC_ADDR_26AF_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26AF_reg))
#define  ATSC_ADDR_26AF_fs2_max_rec_sam_num_2_11_4_shift                         (0)
#define  ATSC_ADDR_26AF_fs2_max_rec_sam_num_2_11_4_mask                          (0x000000FF)
#define  ATSC_ADDR_26AF_fs2_max_rec_sam_num_2_11_4(data)                         (0x000000FF&(data))
#define  ATSC_ADDR_26AF_get_fs2_max_rec_sam_num_2_11_4(data)                     (0x000000FF&(data))

#define  ATSC_ADDR_2677                                                         0x181559DC
#define  ATSC_ADDR_2677_reg_addr                                                 "0xB81559DC"
#define  ATSC_ADDR_2677_reg                                                      0xB81559DC
#define  ATSC_ADDR_2677_inst_addr                                                "0x024F"
#define  set_ATSC_ADDR_2677_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2677_reg)=data)
#define  get_ATSC_ADDR_2677_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2677_reg))
#define  ATSC_ADDR_2677_fs2_wmain_size_7_0_shift                                 (0)
#define  ATSC_ADDR_2677_fs2_wmain_size_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_2677_fs2_wmain_size_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2677_get_fs2_wmain_size_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2678                                                         0x181559E0
#define  ATSC_ADDR_2678_reg_addr                                                 "0xB81559E0"
#define  ATSC_ADDR_2678_reg                                                      0xB81559E0
#define  ATSC_ADDR_2678_inst_addr                                                "0x0250"
#define  set_ATSC_ADDR_2678_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2678_reg)=data)
#define  get_ATSC_ADDR_2678_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2678_reg))
#define  ATSC_ADDR_2678_fs2_wmain_size_11_8_shift                                (0)
#define  ATSC_ADDR_2678_fs2_wmain_size_11_8_mask                                 (0x0000000F)
#define  ATSC_ADDR_2678_fs2_wmain_size_11_8(data)                                (0x0000000F&(data))
#define  ATSC_ADDR_2678_get_fs2_wmain_size_11_8(data)                            (0x0000000F&(data))

#define  ATSC_ADDR_2679                                                         0x181559E4
#define  ATSC_ADDR_2679_reg_addr                                                 "0xB81559E4"
#define  ATSC_ADDR_2679_reg                                                      0xB81559E4
#define  ATSC_ADDR_2679_inst_addr                                                "0x0251"
#define  set_ATSC_ADDR_2679_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2679_reg)=data)
#define  get_ATSC_ADDR_2679_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2679_reg))
#define  ATSC_ADDR_2679_fs2_wmain_size2_7_0_shift                                (0)
#define  ATSC_ADDR_2679_fs2_wmain_size2_7_0_mask                                 (0x000000FF)
#define  ATSC_ADDR_2679_fs2_wmain_size2_7_0(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2679_get_fs2_wmain_size2_7_0(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_267A                                                         0x181559E8
#define  ATSC_ADDR_267A_reg_addr                                                 "0xB81559E8"
#define  ATSC_ADDR_267A_reg                                                      0xB81559E8
#define  ATSC_ADDR_267A_inst_addr                                                "0x0252"
#define  set_ATSC_ADDR_267A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_267A_reg)=data)
#define  get_ATSC_ADDR_267A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_267A_reg))
#define  ATSC_ADDR_267A_fs2_wmain_size2_11_8_shift                               (0)
#define  ATSC_ADDR_267A_fs2_wmain_size2_11_8_mask                                (0x0000000F)
#define  ATSC_ADDR_267A_fs2_wmain_size2_11_8(data)                               (0x0000000F&(data))
#define  ATSC_ADDR_267A_get_fs2_wmain_size2_11_8(data)                           (0x0000000F&(data))

#define  ATSC_ADDR_267B                                                         0x181559EC
#define  ATSC_ADDR_267B_reg_addr                                                 "0xB81559EC"
#define  ATSC_ADDR_267B_reg                                                      0xB81559EC
#define  ATSC_ADDR_267B_inst_addr                                                "0x0253"
#define  set_ATSC_ADDR_267B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_267B_reg)=data)
#define  get_ATSC_ADDR_267B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_267B_reg))
#define  ATSC_ADDR_267B_fs2_wp_main_size_7_0_shift                               (0)
#define  ATSC_ADDR_267B_fs2_wp_main_size_7_0_mask                                (0x000000FF)
#define  ATSC_ADDR_267B_fs2_wp_main_size_7_0(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_267B_get_fs2_wp_main_size_7_0(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_267C                                                         0x181559F0
#define  ATSC_ADDR_267C_reg_addr                                                 "0xB81559F0"
#define  ATSC_ADDR_267C_reg                                                      0xB81559F0
#define  ATSC_ADDR_267C_inst_addr                                                "0x0254"
#define  set_ATSC_ADDR_267C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_267C_reg)=data)
#define  get_ATSC_ADDR_267C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_267C_reg))
#define  ATSC_ADDR_267C_fs2_wp_main_size_11_8_shift                              (0)
#define  ATSC_ADDR_267C_fs2_wp_main_size_11_8_mask                               (0x0000000F)
#define  ATSC_ADDR_267C_fs2_wp_main_size_11_8(data)                              (0x0000000F&(data))
#define  ATSC_ADDR_267C_get_fs2_wp_main_size_11_8(data)                          (0x0000000F&(data))

#define  ATSC_ADDR_267D                                                         0x181559F4
#define  ATSC_ADDR_267D_reg_addr                                                 "0xB81559F4"
#define  ATSC_ADDR_267D_reg                                                      0xB81559F4
#define  ATSC_ADDR_267D_inst_addr                                                "0x0255"
#define  set_ATSC_ADDR_267D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_267D_reg)=data)
#define  get_ATSC_ADDR_267D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_267D_reg))
#define  ATSC_ADDR_267D_fs2_wpre_size_7_0_shift                                  (0)
#define  ATSC_ADDR_267D_fs2_wpre_size_7_0_mask                                   (0x000000FF)
#define  ATSC_ADDR_267D_fs2_wpre_size_7_0(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_267D_get_fs2_wpre_size_7_0(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_267E                                                         0x181559F8
#define  ATSC_ADDR_267E_reg_addr                                                 "0xB81559F8"
#define  ATSC_ADDR_267E_reg                                                      0xB81559F8
#define  ATSC_ADDR_267E_inst_addr                                                "0x0256"
#define  set_ATSC_ADDR_267E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_267E_reg)=data)
#define  get_ATSC_ADDR_267E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_267E_reg))
#define  ATSC_ADDR_267E_fs2_wpre_size_11_8_shift                                 (0)
#define  ATSC_ADDR_267E_fs2_wpre_size_11_8_mask                                  (0x0000000F)
#define  ATSC_ADDR_267E_fs2_wpre_size_11_8(data)                                 (0x0000000F&(data))
#define  ATSC_ADDR_267E_get_fs2_wpre_size_11_8(data)                             (0x0000000F&(data))

#define  ATSC_ADDR_267F                                                         0x181559FC
#define  ATSC_ADDR_267F_reg_addr                                                 "0xB81559FC"
#define  ATSC_ADDR_267F_reg                                                      0xB81559FC
#define  ATSC_ADDR_267F_inst_addr                                                "0x0257"
#define  set_ATSC_ADDR_267F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_267F_reg)=data)
#define  get_ATSC_ADDR_267F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_267F_reg))
#define  ATSC_ADDR_267F_fs2_wpre_size2_7_0_shift                                 (0)
#define  ATSC_ADDR_267F_fs2_wpre_size2_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_267F_fs2_wpre_size2_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_267F_get_fs2_wpre_size2_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2680                                                         0x18155A00
#define  ATSC_ADDR_2680_reg_addr                                                 "0xB8155A00"
#define  ATSC_ADDR_2680_reg                                                      0xB8155A00
#define  ATSC_ADDR_2680_inst_addr                                                "0x0258"
#define  set_ATSC_ADDR_2680_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2680_reg)=data)
#define  get_ATSC_ADDR_2680_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2680_reg))
#define  ATSC_ADDR_2680_fs2_wpre_size2_11_8_shift                                (0)
#define  ATSC_ADDR_2680_fs2_wpre_size2_11_8_mask                                 (0x0000000F)
#define  ATSC_ADDR_2680_fs2_wpre_size2_11_8(data)                                (0x0000000F&(data))
#define  ATSC_ADDR_2680_get_fs2_wpre_size2_11_8(data)                            (0x0000000F&(data))

#define  ATSC_ADDR_2681                                                         0x18155A04
#define  ATSC_ADDR_2681_reg_addr                                                 "0xB8155A04"
#define  ATSC_ADDR_2681_reg                                                      0xB8155A04
#define  ATSC_ADDR_2681_inst_addr                                                "0x0259"
#define  set_ATSC_ADDR_2681_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2681_reg)=data)
#define  get_ATSC_ADDR_2681_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2681_reg))
#define  ATSC_ADDR_2681_fs2_corr_th_pre_7_0_shift                                (0)
#define  ATSC_ADDR_2681_fs2_corr_th_pre_7_0_mask                                 (0x000000FF)
#define  ATSC_ADDR_2681_fs2_corr_th_pre_7_0(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2681_get_fs2_corr_th_pre_7_0(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2682                                                         0x18155A08
#define  ATSC_ADDR_2682_reg_addr                                                 "0xB8155A08"
#define  ATSC_ADDR_2682_reg                                                      0xB8155A08
#define  ATSC_ADDR_2682_inst_addr                                                "0x025A"
#define  set_ATSC_ADDR_2682_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2682_reg)=data)
#define  get_ATSC_ADDR_2682_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2682_reg))
#define  ATSC_ADDR_2682_fs2_corr_th_pre_12_8_shift                               (0)
#define  ATSC_ADDR_2682_fs2_corr_th_pre_12_8_mask                                (0x0000001F)
#define  ATSC_ADDR_2682_fs2_corr_th_pre_12_8(data)                               (0x0000001F&(data))
#define  ATSC_ADDR_2682_get_fs2_corr_th_pre_12_8(data)                           (0x0000001F&(data))

#define  ATSC_ADDR_2683                                                         0x18155A0C
#define  ATSC_ADDR_2683_reg_addr                                                 "0xB8155A0C"
#define  ATSC_ADDR_2683_reg                                                      0xB8155A0C
#define  ATSC_ADDR_2683_inst_addr                                                "0x025B"
#define  set_ATSC_ADDR_2683_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2683_reg)=data)
#define  get_ATSC_ADDR_2683_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2683_reg))
#define  ATSC_ADDR_2683_fs2_wp_pre_size_7_0_shift                                (0)
#define  ATSC_ADDR_2683_fs2_wp_pre_size_7_0_mask                                 (0x000000FF)
#define  ATSC_ADDR_2683_fs2_wp_pre_size_7_0(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2683_get_fs2_wp_pre_size_7_0(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2684                                                         0x18155A10
#define  ATSC_ADDR_2684_reg_addr                                                 "0xB8155A10"
#define  ATSC_ADDR_2684_reg                                                      0xB8155A10
#define  ATSC_ADDR_2684_inst_addr                                                "0x025C"
#define  set_ATSC_ADDR_2684_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2684_reg)=data)
#define  get_ATSC_ADDR_2684_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2684_reg))
#define  ATSC_ADDR_2684_fs2_wp_pre_size_11_8_shift                               (0)
#define  ATSC_ADDR_2684_fs2_wp_pre_size_11_8_mask                                (0x0000000F)
#define  ATSC_ADDR_2684_fs2_wp_pre_size_11_8(data)                               (0x0000000F&(data))
#define  ATSC_ADDR_2684_get_fs2_wp_pre_size_11_8(data)                           (0x0000000F&(data))

#define  ATSC_ADDR_2685                                                         0x18155A14
#define  ATSC_ADDR_2685_reg_addr                                                 "0xB8155A14"
#define  ATSC_ADDR_2685_reg                                                      0xB8155A14
#define  ATSC_ADDR_2685_inst_addr                                                "0x025D"
#define  set_ATSC_ADDR_2685_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2685_reg)=data)
#define  get_ATSC_ADDR_2685_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2685_reg))
#define  ATSC_ADDR_2685_fs2_main_ind_offset_shift                                (4)
#define  ATSC_ADDR_2685_fs2_main_max_offset_shift                                (0)
#define  ATSC_ADDR_2685_fs2_main_ind_offset_mask                                 (0x000000F0)
#define  ATSC_ADDR_2685_fs2_main_max_offset_mask                                 (0x0000000F)
#define  ATSC_ADDR_2685_fs2_main_ind_offset(data)                                (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2685_fs2_main_max_offset(data)                                (0x0000000F&(data))
#define  ATSC_ADDR_2685_get_fs2_main_ind_offset(data)                            ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2685_get_fs2_main_max_offset(data)                            (0x0000000F&(data))

#define  ATSC_ADDR_2686                                                         0x18155A18
#define  ATSC_ADDR_2686_reg_addr                                                 "0xB8155A18"
#define  ATSC_ADDR_2686_reg                                                      0xB8155A18
#define  ATSC_ADDR_2686_inst_addr                                                "0x025E"
#define  set_ATSC_ADDR_2686_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2686_reg)=data)
#define  get_ATSC_ADDR_2686_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2686_reg))
#define  ATSC_ADDR_2686_fs2_max_re_ind_offset_shift                              (0)
#define  ATSC_ADDR_2686_fs2_max_re_ind_offset_mask                               (0x0000000F)
#define  ATSC_ADDR_2686_fs2_max_re_ind_offset(data)                              (0x0000000F&(data))
#define  ATSC_ADDR_2686_get_fs2_max_re_ind_offset(data)                          (0x0000000F&(data))

#define  ATSC_ADDR_2687                                                         0x18155A1C
#define  ATSC_ADDR_2687_reg_addr                                                 "0xB8155A1C"
#define  ATSC_ADDR_2687_reg                                                      0xB8155A1C
#define  ATSC_ADDR_2687_inst_addr                                                "0x025F"
#define  set_ATSC_ADDR_2687_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2687_reg)=data)
#define  get_ATSC_ADDR_2687_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2687_reg))
#define  ATSC_ADDR_2687_fs2_force_num_decode_default_shift                       (0)
#define  ATSC_ADDR_2687_fs2_force_num_decode_default_mask                        (0x0000007F)
#define  ATSC_ADDR_2687_fs2_force_num_decode_default(data)                       (0x0000007F&(data))
#define  ATSC_ADDR_2687_get_fs2_force_num_decode_default(data)                   (0x0000007F&(data))

#define  ATSC_ADDR_2688                                                         0x18155A20
#define  ATSC_ADDR_2688_reg_addr                                                 "0xB8155A20"
#define  ATSC_ADDR_2688_reg                                                      0xB8155A20
#define  ATSC_ADDR_2688_inst_addr                                                "0x0260"
#define  set_ATSC_ADDR_2688_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2688_reg)=data)
#define  get_ATSC_ADDR_2688_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2688_reg))
#define  ATSC_ADDR_2688_fs2_force_space_default_7_0_shift                        (0)
#define  ATSC_ADDR_2688_fs2_force_space_default_7_0_mask                         (0x000000FF)
#define  ATSC_ADDR_2688_fs2_force_space_default_7_0(data)                        (0x000000FF&(data))
#define  ATSC_ADDR_2688_get_fs2_force_space_default_7_0(data)                    (0x000000FF&(data))

#define  ATSC_ADDR_2689                                                         0x18155A24
#define  ATSC_ADDR_2689_reg_addr                                                 "0xB8155A24"
#define  ATSC_ADDR_2689_reg                                                      0xB8155A24
#define  ATSC_ADDR_2689_inst_addr                                                "0x0261"
#define  set_ATSC_ADDR_2689_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2689_reg)=data)
#define  get_ATSC_ADDR_2689_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2689_reg))
#define  ATSC_ADDR_2689_fs2_force_space_default_11_8_shift                       (0)
#define  ATSC_ADDR_2689_fs2_force_space_default_11_8_mask                        (0x0000000F)
#define  ATSC_ADDR_2689_fs2_force_space_default_11_8(data)                       (0x0000000F&(data))
#define  ATSC_ADDR_2689_get_fs2_force_space_default_11_8(data)                   (0x0000000F&(data))

#define  ATSC_ADDR_268A                                                         0x18155A28
#define  ATSC_ADDR_268A_reg_addr                                                 "0xB8155A28"
#define  ATSC_ADDR_268A_reg                                                      0xB8155A28
#define  ATSC_ADDR_268A_inst_addr                                                "0x0262"
#define  set_ATSC_ADDR_268A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_268A_reg)=data)
#define  get_ATSC_ADDR_268A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_268A_reg))
#define  ATSC_ADDR_268A_fs2_main_isnot_max_force_en_shift                        (7)
#define  ATSC_ADDR_268A_fs2_s11_wait_max_shift                                   (6)
#define  ATSC_ADDR_268A_fs2_pre_ram_off_shift                                    (5)
#define  ATSC_ADDR_268A_fs2_main_ram_off_shift                                   (4)
#define  ATSC_ADDR_268A_fs2_refresh_max_amp_s4_shift                             (3)
#define  ATSC_ADDR_268A_fs2_force_en_shift                                       (2)
#define  ATSC_ADDR_268A_fs2_main_isnot_max_off_shift                             (1)
#define  ATSC_ADDR_268A_fs2_force_manu_shift                                     (0)
#define  ATSC_ADDR_268A_fs2_main_isnot_max_force_en_mask                         (0x00000080)
#define  ATSC_ADDR_268A_fs2_s11_wait_max_mask                                    (0x00000040)
#define  ATSC_ADDR_268A_fs2_pre_ram_off_mask                                     (0x00000020)
#define  ATSC_ADDR_268A_fs2_main_ram_off_mask                                    (0x00000010)
#define  ATSC_ADDR_268A_fs2_refresh_max_amp_s4_mask                              (0x00000008)
#define  ATSC_ADDR_268A_fs2_force_en_mask                                        (0x00000004)
#define  ATSC_ADDR_268A_fs2_main_isnot_max_off_mask                              (0x00000002)
#define  ATSC_ADDR_268A_fs2_force_manu_mask                                      (0x00000001)
#define  ATSC_ADDR_268A_fs2_main_isnot_max_force_en(data)                        (0x00000080&((data)<<7))
#define  ATSC_ADDR_268A_fs2_s11_wait_max(data)                                   (0x00000040&((data)<<6))
#define  ATSC_ADDR_268A_fs2_pre_ram_off(data)                                    (0x00000020&((data)<<5))
#define  ATSC_ADDR_268A_fs2_main_ram_off(data)                                   (0x00000010&((data)<<4))
#define  ATSC_ADDR_268A_fs2_refresh_max_amp_s4(data)                             (0x00000008&((data)<<3))
#define  ATSC_ADDR_268A_fs2_force_en(data)                                       (0x00000004&((data)<<2))
#define  ATSC_ADDR_268A_fs2_main_isnot_max_off(data)                             (0x00000002&((data)<<1))
#define  ATSC_ADDR_268A_fs2_force_manu(data)                                     (0x00000001&(data))
#define  ATSC_ADDR_268A_get_fs2_main_isnot_max_force_en(data)                    ((0x00000080&(data))>>7)
#define  ATSC_ADDR_268A_get_fs2_s11_wait_max(data)                               ((0x00000040&(data))>>6)
#define  ATSC_ADDR_268A_get_fs2_pre_ram_off(data)                                ((0x00000020&(data))>>5)
#define  ATSC_ADDR_268A_get_fs2_main_ram_off(data)                               ((0x00000010&(data))>>4)
#define  ATSC_ADDR_268A_get_fs2_refresh_max_amp_s4(data)                         ((0x00000008&(data))>>3)
#define  ATSC_ADDR_268A_get_fs2_force_en(data)                                   ((0x00000004&(data))>>2)
#define  ATSC_ADDR_268A_get_fs2_main_isnot_max_off(data)                         ((0x00000002&(data))>>1)
#define  ATSC_ADDR_268A_get_fs2_force_manu(data)                                 (0x00000001&(data))

#define  ATSC_ADDR_268B                                                         0x18155A2C
#define  ATSC_ADDR_268B_reg_addr                                                 "0xB8155A2C"
#define  ATSC_ADDR_268B_reg                                                      0xB8155A2C
#define  ATSC_ADDR_268B_inst_addr                                                "0x0263"
#define  set_ATSC_ADDR_268B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_268B_reg)=data)
#define  get_ATSC_ADDR_268B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_268B_reg))
#define  ATSC_ADDR_268B_fs2_space_th_0_7_0_shift                                 (0)
#define  ATSC_ADDR_268B_fs2_space_th_0_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_268B_fs2_space_th_0_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_268B_get_fs2_space_th_0_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_268C                                                         0x18155A30
#define  ATSC_ADDR_268C_reg_addr                                                 "0xB8155A30"
#define  ATSC_ADDR_268C_reg                                                      0xB8155A30
#define  ATSC_ADDR_268C_inst_addr                                                "0x0264"
#define  set_ATSC_ADDR_268C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_268C_reg)=data)
#define  get_ATSC_ADDR_268C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_268C_reg))
#define  ATSC_ADDR_268C_fs2_space_th_0_11_8_shift                                (0)
#define  ATSC_ADDR_268C_fs2_space_th_0_11_8_mask                                 (0x0000000F)
#define  ATSC_ADDR_268C_fs2_space_th_0_11_8(data)                                (0x0000000F&(data))
#define  ATSC_ADDR_268C_get_fs2_space_th_0_11_8(data)                            (0x0000000F&(data))

#define  ATSC_ADDR_268D                                                         0x18155A34
#define  ATSC_ADDR_268D_reg_addr                                                 "0xB8155A34"
#define  ATSC_ADDR_268D_reg                                                      0xB8155A34
#define  ATSC_ADDR_268D_inst_addr                                                "0x0265"
#define  set_ATSC_ADDR_268D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_268D_reg)=data)
#define  get_ATSC_ADDR_268D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_268D_reg))
#define  ATSC_ADDR_268D_fs2_space_th_1_7_0_shift                                 (0)
#define  ATSC_ADDR_268D_fs2_space_th_1_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_268D_fs2_space_th_1_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_268D_get_fs2_space_th_1_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_268E                                                         0x18155A38
#define  ATSC_ADDR_268E_reg_addr                                                 "0xB8155A38"
#define  ATSC_ADDR_268E_reg                                                      0xB8155A38
#define  ATSC_ADDR_268E_inst_addr                                                "0x0266"
#define  set_ATSC_ADDR_268E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_268E_reg)=data)
#define  get_ATSC_ADDR_268E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_268E_reg))
#define  ATSC_ADDR_268E_fs2_space_th_1_11_8_shift                                (0)
#define  ATSC_ADDR_268E_fs2_space_th_1_11_8_mask                                 (0x0000000F)
#define  ATSC_ADDR_268E_fs2_space_th_1_11_8(data)                                (0x0000000F&(data))
#define  ATSC_ADDR_268E_get_fs2_space_th_1_11_8(data)                            (0x0000000F&(data))

#define  ATSC_ADDR_268F                                                         0x18155A3C
#define  ATSC_ADDR_268F_reg_addr                                                 "0xB8155A3C"
#define  ATSC_ADDR_268F_reg                                                      0xB8155A3C
#define  ATSC_ADDR_268F_inst_addr                                                "0x0267"
#define  set_ATSC_ADDR_268F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_268F_reg)=data)
#define  get_ATSC_ADDR_268F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_268F_reg))
#define  ATSC_ADDR_268F_fs2_space_th_2_7_0_shift                                 (0)
#define  ATSC_ADDR_268F_fs2_space_th_2_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_268F_fs2_space_th_2_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_268F_get_fs2_space_th_2_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2690                                                         0x18155A40
#define  ATSC_ADDR_2690_reg_addr                                                 "0xB8155A40"
#define  ATSC_ADDR_2690_reg                                                      0xB8155A40
#define  ATSC_ADDR_2690_inst_addr                                                "0x0268"
#define  set_ATSC_ADDR_2690_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2690_reg)=data)
#define  get_ATSC_ADDR_2690_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2690_reg))
#define  ATSC_ADDR_2690_fs2_space_th_2_11_8_shift                                (0)
#define  ATSC_ADDR_2690_fs2_space_th_2_11_8_mask                                 (0x0000000F)
#define  ATSC_ADDR_2690_fs2_space_th_2_11_8(data)                                (0x0000000F&(data))
#define  ATSC_ADDR_2690_get_fs2_space_th_2_11_8(data)                            (0x0000000F&(data))

#define  ATSC_ADDR_2691                                                         0x18155A44
#define  ATSC_ADDR_2691_reg_addr                                                 "0xB8155A44"
#define  ATSC_ADDR_2691_reg                                                      0xB8155A44
#define  ATSC_ADDR_2691_inst_addr                                                "0x0269"
#define  set_ATSC_ADDR_2691_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2691_reg)=data)
#define  get_ATSC_ADDR_2691_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2691_reg))
#define  ATSC_ADDR_2691_fs2_space_th_3_7_0_shift                                 (0)
#define  ATSC_ADDR_2691_fs2_space_th_3_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_2691_fs2_space_th_3_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2691_get_fs2_space_th_3_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2692                                                         0x18155A48
#define  ATSC_ADDR_2692_reg_addr                                                 "0xB8155A48"
#define  ATSC_ADDR_2692_reg                                                      0xB8155A48
#define  ATSC_ADDR_2692_inst_addr                                                "0x026A"
#define  set_ATSC_ADDR_2692_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2692_reg)=data)
#define  get_ATSC_ADDR_2692_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2692_reg))
#define  ATSC_ADDR_2692_fs2_space_th_3_11_8_shift                                (0)
#define  ATSC_ADDR_2692_fs2_space_th_3_11_8_mask                                 (0x0000000F)
#define  ATSC_ADDR_2692_fs2_space_th_3_11_8(data)                                (0x0000000F&(data))
#define  ATSC_ADDR_2692_get_fs2_space_th_3_11_8(data)                            (0x0000000F&(data))

#define  ATSC_ADDR_2693                                                         0x18155A4C
#define  ATSC_ADDR_2693_reg_addr                                                 "0xB8155A4C"
#define  ATSC_ADDR_2693_reg                                                      0xB8155A4C
#define  ATSC_ADDR_2693_inst_addr                                                "0x026B"
#define  set_ATSC_ADDR_2693_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2693_reg)=data)
#define  get_ATSC_ADDR_2693_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2693_reg))
#define  ATSC_ADDR_2693_fs2_space_th_4_7_0_shift                                 (0)
#define  ATSC_ADDR_2693_fs2_space_th_4_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_2693_fs2_space_th_4_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2693_get_fs2_space_th_4_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2694                                                         0x18155A50
#define  ATSC_ADDR_2694_reg_addr                                                 "0xB8155A50"
#define  ATSC_ADDR_2694_reg                                                      0xB8155A50
#define  ATSC_ADDR_2694_inst_addr                                                "0x026C"
#define  set_ATSC_ADDR_2694_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2694_reg)=data)
#define  get_ATSC_ADDR_2694_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2694_reg))
#define  ATSC_ADDR_2694_fs2_space_th_4_11_8_shift                                (0)
#define  ATSC_ADDR_2694_fs2_space_th_4_11_8_mask                                 (0x0000000F)
#define  ATSC_ADDR_2694_fs2_space_th_4_11_8(data)                                (0x0000000F&(data))
#define  ATSC_ADDR_2694_get_fs2_space_th_4_11_8(data)                            (0x0000000F&(data))

#define  ATSC_ADDR_2695                                                         0x18155A54
#define  ATSC_ADDR_2695_reg_addr                                                 "0xB8155A54"
#define  ATSC_ADDR_2695_reg                                                      0xB8155A54
#define  ATSC_ADDR_2695_inst_addr                                                "0x026D"
#define  set_ATSC_ADDR_2695_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2695_reg)=data)
#define  get_ATSC_ADDR_2695_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2695_reg))
#define  ATSC_ADDR_2695_fs2_space_th_5_7_0_shift                                 (0)
#define  ATSC_ADDR_2695_fs2_space_th_5_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_2695_fs2_space_th_5_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2695_get_fs2_space_th_5_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2696                                                         0x18155A58
#define  ATSC_ADDR_2696_reg_addr                                                 "0xB8155A58"
#define  ATSC_ADDR_2696_reg                                                      0xB8155A58
#define  ATSC_ADDR_2696_inst_addr                                                "0x026E"
#define  set_ATSC_ADDR_2696_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2696_reg)=data)
#define  get_ATSC_ADDR_2696_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2696_reg))
#define  ATSC_ADDR_2696_fs2_space_th_5_11_8_shift                                (0)
#define  ATSC_ADDR_2696_fs2_space_th_5_11_8_mask                                 (0x0000000F)
#define  ATSC_ADDR_2696_fs2_space_th_5_11_8(data)                                (0x0000000F&(data))
#define  ATSC_ADDR_2696_get_fs2_space_th_5_11_8(data)                            (0x0000000F&(data))

#define  ATSC_ADDR_2697                                                         0x18155A5C
#define  ATSC_ADDR_2697_reg_addr                                                 "0xB8155A5C"
#define  ATSC_ADDR_2697_reg                                                      0xB8155A5C
#define  ATSC_ADDR_2697_inst_addr                                                "0x026F"
#define  set_ATSC_ADDR_2697_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2697_reg)=data)
#define  get_ATSC_ADDR_2697_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2697_reg))
#define  ATSC_ADDR_2697_fs2_space_th_6_7_0_shift                                 (0)
#define  ATSC_ADDR_2697_fs2_space_th_6_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_2697_fs2_space_th_6_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2697_get_fs2_space_th_6_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2698                                                         0x18155A60
#define  ATSC_ADDR_2698_reg_addr                                                 "0xB8155A60"
#define  ATSC_ADDR_2698_reg                                                      0xB8155A60
#define  ATSC_ADDR_2698_inst_addr                                                "0x0270"
#define  set_ATSC_ADDR_2698_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2698_reg)=data)
#define  get_ATSC_ADDR_2698_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2698_reg))
#define  ATSC_ADDR_2698_fs2_space_th_6_11_8_shift                                (0)
#define  ATSC_ADDR_2698_fs2_space_th_6_11_8_mask                                 (0x0000000F)
#define  ATSC_ADDR_2698_fs2_space_th_6_11_8(data)                                (0x0000000F&(data))
#define  ATSC_ADDR_2698_get_fs2_space_th_6_11_8(data)                            (0x0000000F&(data))

#define  ATSC_ADDR_2699                                                         0x18155A64
#define  ATSC_ADDR_2699_reg_addr                                                 "0xB8155A64"
#define  ATSC_ADDR_2699_reg                                                      0xB8155A64
#define  ATSC_ADDR_2699_inst_addr                                                "0x0271"
#define  set_ATSC_ADDR_2699_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2699_reg)=data)
#define  get_ATSC_ADDR_2699_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2699_reg))
#define  ATSC_ADDR_2699_fs2_space_th_7_7_0_shift                                 (0)
#define  ATSC_ADDR_2699_fs2_space_th_7_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_2699_fs2_space_th_7_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2699_get_fs2_space_th_7_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_269A                                                         0x18155A68
#define  ATSC_ADDR_269A_reg_addr                                                 "0xB8155A68"
#define  ATSC_ADDR_269A_reg                                                      0xB8155A68
#define  ATSC_ADDR_269A_inst_addr                                                "0x0272"
#define  set_ATSC_ADDR_269A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_269A_reg)=data)
#define  get_ATSC_ADDR_269A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_269A_reg))
#define  ATSC_ADDR_269A_fs2_space_th_7_11_8_shift                                (0)
#define  ATSC_ADDR_269A_fs2_space_th_7_11_8_mask                                 (0x0000000F)
#define  ATSC_ADDR_269A_fs2_space_th_7_11_8(data)                                (0x0000000F&(data))
#define  ATSC_ADDR_269A_get_fs2_space_th_7_11_8(data)                            (0x0000000F&(data))

#define  ATSC_ADDR_269B                                                         0x18155A6C
#define  ATSC_ADDR_269B_reg_addr                                                 "0xB8155A6C"
#define  ATSC_ADDR_269B_reg                                                      0xB8155A6C
#define  ATSC_ADDR_269B_inst_addr                                                "0x0273"
#define  set_ATSC_ADDR_269B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_269B_reg)=data)
#define  get_ATSC_ADDR_269B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_269B_reg))
#define  ATSC_ADDR_269B_fs2_amp_ratio_0_shift                                    (0)
#define  ATSC_ADDR_269B_fs2_amp_ratio_0_mask                                     (0x0000003F)
#define  ATSC_ADDR_269B_fs2_amp_ratio_0(data)                                    (0x0000003F&(data))
#define  ATSC_ADDR_269B_get_fs2_amp_ratio_0(data)                                (0x0000003F&(data))

#define  ATSC_ADDR_269C                                                         0x18155A70
#define  ATSC_ADDR_269C_reg_addr                                                 "0xB8155A70"
#define  ATSC_ADDR_269C_reg                                                      0xB8155A70
#define  ATSC_ADDR_269C_inst_addr                                                "0x0274"
#define  set_ATSC_ADDR_269C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_269C_reg)=data)
#define  get_ATSC_ADDR_269C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_269C_reg))
#define  ATSC_ADDR_269C_fs2_amp_ratio_1_shift                                    (0)
#define  ATSC_ADDR_269C_fs2_amp_ratio_1_mask                                     (0x0000003F)
#define  ATSC_ADDR_269C_fs2_amp_ratio_1(data)                                    (0x0000003F&(data))
#define  ATSC_ADDR_269C_get_fs2_amp_ratio_1(data)                                (0x0000003F&(data))

#define  ATSC_ADDR_269D                                                         0x18155A74
#define  ATSC_ADDR_269D_reg_addr                                                 "0xB8155A74"
#define  ATSC_ADDR_269D_reg                                                      0xB8155A74
#define  ATSC_ADDR_269D_inst_addr                                                "0x0275"
#define  set_ATSC_ADDR_269D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_269D_reg)=data)
#define  get_ATSC_ADDR_269D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_269D_reg))
#define  ATSC_ADDR_269D_fs2_amp_ratio_2_shift                                    (0)
#define  ATSC_ADDR_269D_fs2_amp_ratio_2_mask                                     (0x0000003F)
#define  ATSC_ADDR_269D_fs2_amp_ratio_2(data)                                    (0x0000003F&(data))
#define  ATSC_ADDR_269D_get_fs2_amp_ratio_2(data)                                (0x0000003F&(data))

#define  ATSC_ADDR_269E                                                         0x18155A78
#define  ATSC_ADDR_269E_reg_addr                                                 "0xB8155A78"
#define  ATSC_ADDR_269E_reg                                                      0xB8155A78
#define  ATSC_ADDR_269E_inst_addr                                                "0x0276"
#define  set_ATSC_ADDR_269E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_269E_reg)=data)
#define  get_ATSC_ADDR_269E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_269E_reg))
#define  ATSC_ADDR_269E_fs2_amp_ratio_3_shift                                    (0)
#define  ATSC_ADDR_269E_fs2_amp_ratio_3_mask                                     (0x0000003F)
#define  ATSC_ADDR_269E_fs2_amp_ratio_3(data)                                    (0x0000003F&(data))
#define  ATSC_ADDR_269E_get_fs2_amp_ratio_3(data)                                (0x0000003F&(data))

#define  ATSC_ADDR_269F                                                         0x18155A7C
#define  ATSC_ADDR_269F_reg_addr                                                 "0xB8155A7C"
#define  ATSC_ADDR_269F_reg                                                      0xB8155A7C
#define  ATSC_ADDR_269F_inst_addr                                                "0x0277"
#define  set_ATSC_ADDR_269F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_269F_reg)=data)
#define  get_ATSC_ADDR_269F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_269F_reg))
#define  ATSC_ADDR_269F_fs2_amp_ratio_4_shift                                    (0)
#define  ATSC_ADDR_269F_fs2_amp_ratio_4_mask                                     (0x0000003F)
#define  ATSC_ADDR_269F_fs2_amp_ratio_4(data)                                    (0x0000003F&(data))
#define  ATSC_ADDR_269F_get_fs2_amp_ratio_4(data)                                (0x0000003F&(data))

#define  ATSC_ADDR_26A0                                                         0x18155A80
#define  ATSC_ADDR_26A0_reg_addr                                                 "0xB8155A80"
#define  ATSC_ADDR_26A0_reg                                                      0xB8155A80
#define  ATSC_ADDR_26A0_inst_addr                                                "0x0278"
#define  set_ATSC_ADDR_26A0_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26A0_reg)=data)
#define  get_ATSC_ADDR_26A0_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26A0_reg))
#define  ATSC_ADDR_26A0_fs2_amp_ratio_5_shift                                    (0)
#define  ATSC_ADDR_26A0_fs2_amp_ratio_5_mask                                     (0x0000003F)
#define  ATSC_ADDR_26A0_fs2_amp_ratio_5(data)                                    (0x0000003F&(data))
#define  ATSC_ADDR_26A0_get_fs2_amp_ratio_5(data)                                (0x0000003F&(data))

#define  ATSC_ADDR_26A1                                                         0x18155A84
#define  ATSC_ADDR_26A1_reg_addr                                                 "0xB8155A84"
#define  ATSC_ADDR_26A1_reg                                                      0xB8155A84
#define  ATSC_ADDR_26A1_inst_addr                                                "0x0279"
#define  set_ATSC_ADDR_26A1_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26A1_reg)=data)
#define  get_ATSC_ADDR_26A1_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26A1_reg))
#define  ATSC_ADDR_26A1_fs2_amp_ratio_6_shift                                    (0)
#define  ATSC_ADDR_26A1_fs2_amp_ratio_6_mask                                     (0x0000003F)
#define  ATSC_ADDR_26A1_fs2_amp_ratio_6(data)                                    (0x0000003F&(data))
#define  ATSC_ADDR_26A1_get_fs2_amp_ratio_6(data)                                (0x0000003F&(data))

#define  ATSC_ADDR_26A2                                                         0x18155A88
#define  ATSC_ADDR_26A2_reg_addr                                                 "0xB8155A88"
#define  ATSC_ADDR_26A2_reg                                                      0xB8155A88
#define  ATSC_ADDR_26A2_inst_addr                                                "0x027A"
#define  set_ATSC_ADDR_26A2_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26A2_reg)=data)
#define  get_ATSC_ADDR_26A2_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26A2_reg))
#define  ATSC_ADDR_26A2_fs2_amp_ratio_7_shift                                    (0)
#define  ATSC_ADDR_26A2_fs2_amp_ratio_7_mask                                     (0x0000003F)
#define  ATSC_ADDR_26A2_fs2_amp_ratio_7(data)                                    (0x0000003F&(data))
#define  ATSC_ADDR_26A2_get_fs2_amp_ratio_7(data)                                (0x0000003F&(data))

#define  ATSC_ADDR_26A3                                                         0x18155A8C
#define  ATSC_ADDR_26A3_reg_addr                                                 "0xB8155A8C"
#define  ATSC_ADDR_26A3_reg                                                      0xB8155A8C
#define  ATSC_ADDR_26A3_inst_addr                                                "0x027B"
#define  set_ATSC_ADDR_26A3_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26A3_reg)=data)
#define  get_ATSC_ADDR_26A3_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26A3_reg))
#define  ATSC_ADDR_26A3_fs2_precursor_7_0_shift                                  (0)
#define  ATSC_ADDR_26A3_fs2_precursor_7_0_mask                                   (0x000000FF)
#define  ATSC_ADDR_26A3_fs2_precursor_7_0(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_26A3_get_fs2_precursor_7_0(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_26A4                                                         0x18155A90
#define  ATSC_ADDR_26A4_reg_addr                                                 "0xB8155A90"
#define  ATSC_ADDR_26A4_reg                                                      0xB8155A90
#define  ATSC_ADDR_26A4_inst_addr                                                "0x027C"
#define  set_ATSC_ADDR_26A4_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26A4_reg)=data)
#define  get_ATSC_ADDR_26A4_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26A4_reg))
#define  ATSC_ADDR_26A4_fs2_wpost_start_11_shift                                 (7)
#define  ATSC_ADDR_26A4_fs2_wp_post_size_11_shift                                (6)
#define  ATSC_ADDR_26A4_fs2_wpost_size2_11_shift                                 (5)
#define  ATSC_ADDR_26A4_fs2_wpost_size_11_shift                                  (4)
#define  ATSC_ADDR_26A4_fs2_precursor_11_8_shift                                 (0)
#define  ATSC_ADDR_26A4_fs2_wpost_start_11_mask                                  (0x00000080)
#define  ATSC_ADDR_26A4_fs2_wp_post_size_11_mask                                 (0x00000040)
#define  ATSC_ADDR_26A4_fs2_wpost_size2_11_mask                                  (0x00000020)
#define  ATSC_ADDR_26A4_fs2_wpost_size_11_mask                                   (0x00000010)
#define  ATSC_ADDR_26A4_fs2_precursor_11_8_mask                                  (0x0000000F)
#define  ATSC_ADDR_26A4_fs2_wpost_start_11(data)                                 (0x00000080&((data)<<7))
#define  ATSC_ADDR_26A4_fs2_wp_post_size_11(data)                                (0x00000040&((data)<<6))
#define  ATSC_ADDR_26A4_fs2_wpost_size2_11(data)                                 (0x00000020&((data)<<5))
#define  ATSC_ADDR_26A4_fs2_wpost_size_11(data)                                  (0x00000010&((data)<<4))
#define  ATSC_ADDR_26A4_fs2_precursor_11_8(data)                                 (0x0000000F&(data))
#define  ATSC_ADDR_26A4_get_fs2_wpost_start_11(data)                             ((0x00000080&(data))>>7)
#define  ATSC_ADDR_26A4_get_fs2_wp_post_size_11(data)                            ((0x00000040&(data))>>6)
#define  ATSC_ADDR_26A4_get_fs2_wpost_size2_11(data)                             ((0x00000020&(data))>>5)
#define  ATSC_ADDR_26A4_get_fs2_wpost_size_11(data)                              ((0x00000010&(data))>>4)
#define  ATSC_ADDR_26A4_get_fs2_precursor_11_8(data)                             (0x0000000F&(data))

#define  ATSC_ADDR_26A5                                                         0x18155A94
#define  ATSC_ADDR_26A5_reg_addr                                                 "0xB8155A94"
#define  ATSC_ADDR_26A5_reg                                                      0xB8155A94
#define  ATSC_ADDR_26A5_inst_addr                                                "0x027D"
#define  set_ATSC_ADDR_26A5_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26A5_reg)=data)
#define  get_ATSC_ADDR_26A5_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26A5_reg))
#define  ATSC_ADDR_26A5_fs2_force_width_shift                                    (0)
#define  ATSC_ADDR_26A5_fs2_force_width_mask                                     (0x0000003F)
#define  ATSC_ADDR_26A5_fs2_force_width(data)                                    (0x0000003F&(data))
#define  ATSC_ADDR_26A5_get_fs2_force_width(data)                                (0x0000003F&(data))

#define  ATSC_ADDR_26A6                                                         0x18155A98
#define  ATSC_ADDR_26A6_reg_addr                                                 "0xB8155A98"
#define  ATSC_ADDR_26A6_reg                                                      0xB8155A98
#define  ATSC_ADDR_26A6_inst_addr                                                "0x027E"
#define  set_ATSC_ADDR_26A6_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26A6_reg)=data)
#define  get_ATSC_ADDR_26A6_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26A6_reg))
#define  ATSC_ADDR_26A6_fs2_addr_pl_offset_shift                                 (3)
#define  ATSC_ADDR_26A6_fs2_tr_reset_en_shift                                    (2)
#define  ATSC_ADDR_26A6_fs2_wm_start_sel_shift                                   (1)
#define  ATSC_ADDR_26A6_fs2_preload_on_shift                                     (0)
#define  ATSC_ADDR_26A6_fs2_addr_pl_offset_mask                                  (0x000000F8)
#define  ATSC_ADDR_26A6_fs2_tr_reset_en_mask                                     (0x00000004)
#define  ATSC_ADDR_26A6_fs2_wm_start_sel_mask                                    (0x00000002)
#define  ATSC_ADDR_26A6_fs2_preload_on_mask                                      (0x00000001)
#define  ATSC_ADDR_26A6_fs2_addr_pl_offset(data)                                 (0x000000F8&((data)<<3))
#define  ATSC_ADDR_26A6_fs2_tr_reset_en(data)                                    (0x00000004&((data)<<2))
#define  ATSC_ADDR_26A6_fs2_wm_start_sel(data)                                   (0x00000002&((data)<<1))
#define  ATSC_ADDR_26A6_fs2_preload_on(data)                                     (0x00000001&(data))
#define  ATSC_ADDR_26A6_get_fs2_addr_pl_offset(data)                             ((0x000000F8&(data))>>3)
#define  ATSC_ADDR_26A6_get_fs2_tr_reset_en(data)                                ((0x00000004&(data))>>2)
#define  ATSC_ADDR_26A6_get_fs2_wm_start_sel(data)                               ((0x00000002&(data))>>1)
#define  ATSC_ADDR_26A6_get_fs2_preload_on(data)                                 (0x00000001&(data))

#define  ATSC_ADDR_26A7                                                         0x18155A9C
#define  ATSC_ADDR_26A7_reg_addr                                                 "0xB8155A9C"
#define  ATSC_ADDR_26A7_reg                                                      0xB8155A9C
#define  ATSC_ADDR_26A7_inst_addr                                                "0x027F"
#define  set_ATSC_ADDR_26A7_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26A7_reg)=data)
#define  get_ATSC_ADDR_26A7_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26A7_reg))
#define  ATSC_ADDR_26A7_fs2_wpost_start_4_0_shift                                (3)
#define  ATSC_ADDR_26A7_fs2_post_ram_off_shift                                   (2)
#define  ATSC_ADDR_26A7_fs2_wpost_start_en_shift                                 (1)
#define  ATSC_ADDR_26A7_fs2_struc_sel_shift                                      (0)
#define  ATSC_ADDR_26A7_fs2_wpost_start_4_0_mask                                 (0x000000F8)
#define  ATSC_ADDR_26A7_fs2_post_ram_off_mask                                    (0x00000004)
#define  ATSC_ADDR_26A7_fs2_wpost_start_en_mask                                  (0x00000002)
#define  ATSC_ADDR_26A7_fs2_struc_sel_mask                                       (0x00000001)
#define  ATSC_ADDR_26A7_fs2_wpost_start_4_0(data)                                (0x000000F8&((data)<<3))
#define  ATSC_ADDR_26A7_fs2_post_ram_off(data)                                   (0x00000004&((data)<<2))
#define  ATSC_ADDR_26A7_fs2_wpost_start_en(data)                                 (0x00000002&((data)<<1))
#define  ATSC_ADDR_26A7_fs2_struc_sel(data)                                      (0x00000001&(data))
#define  ATSC_ADDR_26A7_get_fs2_wpost_start_4_0(data)                            ((0x000000F8&(data))>>3)
#define  ATSC_ADDR_26A7_get_fs2_post_ram_off(data)                               ((0x00000004&(data))>>2)
#define  ATSC_ADDR_26A7_get_fs2_wpost_start_en(data)                             ((0x00000002&(data))>>1)
#define  ATSC_ADDR_26A7_get_fs2_struc_sel(data)                                  (0x00000001&(data))

#define  ATSC_ADDR_26A8                                                         0x18155AA0
#define  ATSC_ADDR_26A8_reg_addr                                                 "0xB8155AA0"
#define  ATSC_ADDR_26A8_reg                                                      0xB8155AA0
#define  ATSC_ADDR_26A8_inst_addr                                                "0x0280"
#define  set_ATSC_ADDR_26A8_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26A8_reg)=data)
#define  get_ATSC_ADDR_26A8_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26A8_reg))
#define  ATSC_ADDR_26A8_fs2_wpost_size_1_0_shift                                 (6)
#define  ATSC_ADDR_26A8_fs2_wpost_start_10_5_shift                               (0)
#define  ATSC_ADDR_26A8_fs2_wpost_size_1_0_mask                                  (0x000000C0)
#define  ATSC_ADDR_26A8_fs2_wpost_start_10_5_mask                                (0x0000003F)
#define  ATSC_ADDR_26A8_fs2_wpost_size_1_0(data)                                 (0x000000C0&((data)<<6))
#define  ATSC_ADDR_26A8_fs2_wpost_start_10_5(data)                               (0x0000003F&(data))
#define  ATSC_ADDR_26A8_get_fs2_wpost_size_1_0(data)                             ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_26A8_get_fs2_wpost_start_10_5(data)                           (0x0000003F&(data))

#define  ATSC_ADDR_26A9                                                         0x18155AA4
#define  ATSC_ADDR_26A9_reg_addr                                                 "0xB8155AA4"
#define  ATSC_ADDR_26A9_reg                                                      0xB8155AA4
#define  ATSC_ADDR_26A9_inst_addr                                                "0x0281"
#define  set_ATSC_ADDR_26A9_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26A9_reg)=data)
#define  get_ATSC_ADDR_26A9_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26A9_reg))
#define  ATSC_ADDR_26A9_fs2_wpost_size_9_2_shift                                 (0)
#define  ATSC_ADDR_26A9_fs2_wpost_size_9_2_mask                                  (0x000000FF)
#define  ATSC_ADDR_26A9_fs2_wpost_size_9_2(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_26A9_get_fs2_wpost_size_9_2(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_26AA                                                         0x18155AA8
#define  ATSC_ADDR_26AA_reg_addr                                                 "0xB8155AA8"
#define  ATSC_ADDR_26AA_reg                                                      0xB8155AA8
#define  ATSC_ADDR_26AA_inst_addr                                                "0x0282"
#define  set_ATSC_ADDR_26AA_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26AA_reg)=data)
#define  get_ATSC_ADDR_26AA_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26AA_reg))
#define  ATSC_ADDR_26AA_fs2_wpost_size2_6_0_shift                                (1)
#define  ATSC_ADDR_26AA_fs2_wpost_size_10_shift                                  (0)
#define  ATSC_ADDR_26AA_fs2_wpost_size2_6_0_mask                                 (0x000000FE)
#define  ATSC_ADDR_26AA_fs2_wpost_size_10_mask                                   (0x00000001)
#define  ATSC_ADDR_26AA_fs2_wpost_size2_6_0(data)                                (0x000000FE&((data)<<1))
#define  ATSC_ADDR_26AA_fs2_wpost_size_10(data)                                  (0x00000001&(data))
#define  ATSC_ADDR_26AA_get_fs2_wpost_size2_6_0(data)                            ((0x000000FE&(data))>>1)
#define  ATSC_ADDR_26AA_get_fs2_wpost_size_10(data)                              (0x00000001&(data))

#define  ATSC_ADDR_26AB                                                         0x18155AAC
#define  ATSC_ADDR_26AB_reg_addr                                                 "0xB8155AAC"
#define  ATSC_ADDR_26AB_reg                                                      0xB8155AAC
#define  ATSC_ADDR_26AB_inst_addr                                                "0x0283"
#define  set_ATSC_ADDR_26AB_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26AB_reg)=data)
#define  get_ATSC_ADDR_26AB_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26AB_reg))
#define  ATSC_ADDR_26AB_fs2_corr_th_post_3_0_shift                               (4)
#define  ATSC_ADDR_26AB_fs2_wpost_size2_10_7_shift                               (0)
#define  ATSC_ADDR_26AB_fs2_corr_th_post_3_0_mask                                (0x000000F0)
#define  ATSC_ADDR_26AB_fs2_wpost_size2_10_7_mask                                (0x0000000F)
#define  ATSC_ADDR_26AB_fs2_corr_th_post_3_0(data)                               (0x000000F0&((data)<<4))
#define  ATSC_ADDR_26AB_fs2_wpost_size2_10_7(data)                               (0x0000000F&(data))
#define  ATSC_ADDR_26AB_get_fs2_corr_th_post_3_0(data)                           ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_26AB_get_fs2_wpost_size2_10_7(data)                           (0x0000000F&(data))

#define  ATSC_ADDR_26AC                                                         0x18155AB0
#define  ATSC_ADDR_26AC_reg_addr                                                 "0xB8155AB0"
#define  ATSC_ADDR_26AC_reg                                                      0xB8155AB0
#define  ATSC_ADDR_26AC_inst_addr                                                "0x0284"
#define  set_ATSC_ADDR_26AC_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26AC_reg)=data)
#define  get_ATSC_ADDR_26AC_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26AC_reg))
#define  ATSC_ADDR_26AC_fs2_corr_th_post_11_4_shift                              (0)
#define  ATSC_ADDR_26AC_fs2_corr_th_post_11_4_mask                               (0x000000FF)
#define  ATSC_ADDR_26AC_fs2_corr_th_post_11_4(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_26AC_get_fs2_corr_th_post_11_4(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_26AD                                                         0x18155AB4
#define  ATSC_ADDR_26AD_reg_addr                                                 "0xB8155AB4"
#define  ATSC_ADDR_26AD_reg                                                      0xB8155AB4
#define  ATSC_ADDR_26AD_inst_addr                                                "0x0285"
#define  set_ATSC_ADDR_26AD_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26AD_reg)=data)
#define  get_ATSC_ADDR_26AD_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26AD_reg))
#define  ATSC_ADDR_26AD_fs2_wp_post_size_6_0_shift                               (1)
#define  ATSC_ADDR_26AD_fs2_corr_th_post_12_shift                                (0)
#define  ATSC_ADDR_26AD_fs2_wp_post_size_6_0_mask                                (0x000000FE)
#define  ATSC_ADDR_26AD_fs2_corr_th_post_12_mask                                 (0x00000001)
#define  ATSC_ADDR_26AD_fs2_wp_post_size_6_0(data)                               (0x000000FE&((data)<<1))
#define  ATSC_ADDR_26AD_fs2_corr_th_post_12(data)                                (0x00000001&(data))
#define  ATSC_ADDR_26AD_get_fs2_wp_post_size_6_0(data)                           ((0x000000FE&(data))>>1)
#define  ATSC_ADDR_26AD_get_fs2_corr_th_post_12(data)                            (0x00000001&(data))

#define  ATSC_ADDR_2060                                                         0x18154180
#define  ATSC_ADDR_2060_reg_addr                                                 "0xB8154180"
#define  ATSC_ADDR_2060_reg                                                      0xB8154180
#define  ATSC_ADDR_2060_inst_addr                                                "0x0286"
#define  set_ATSC_ADDR_2060_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2060_reg)=data)
#define  get_ATSC_ADDR_2060_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2060_reg))
#define  ATSC_ADDR_2060_fs2_wparallel_size_5_0_shift                             (2)
#define  ATSC_ADDR_2060_fs2_parallel_ram_off_shift                               (1)
#define  ATSC_ADDR_2060_fs2_parallel_search_en_shift                             (0)
#define  ATSC_ADDR_2060_fs2_wparallel_size_5_0_mask                              (0x000000FC)
#define  ATSC_ADDR_2060_fs2_parallel_ram_off_mask                                (0x00000002)
#define  ATSC_ADDR_2060_fs2_parallel_search_en_mask                              (0x00000001)
#define  ATSC_ADDR_2060_fs2_wparallel_size_5_0(data)                             (0x000000FC&((data)<<2))
#define  ATSC_ADDR_2060_fs2_parallel_ram_off(data)                               (0x00000002&((data)<<1))
#define  ATSC_ADDR_2060_fs2_parallel_search_en(data)                             (0x00000001&(data))
#define  ATSC_ADDR_2060_get_fs2_wparallel_size_5_0(data)                         ((0x000000FC&(data))>>2)
#define  ATSC_ADDR_2060_get_fs2_parallel_ram_off(data)                           ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2060_get_fs2_parallel_search_en(data)                         (0x00000001&(data))

#define  ATSC_ADDR_2061                                                         0x18154184
#define  ATSC_ADDR_2061_reg_addr                                                 "0xB8154184"
#define  ATSC_ADDR_2061_reg                                                      0xB8154184
#define  ATSC_ADDR_2061_inst_addr                                                "0x0287"
#define  set_ATSC_ADDR_2061_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2061_reg)=data)
#define  get_ATSC_ADDR_2061_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2061_reg))
#define  ATSC_ADDR_2061_fs2_wparallel_size2_2_0_shift                            (5)
#define  ATSC_ADDR_2061_fs2_wparallel_size_10_6_shift                            (0)
#define  ATSC_ADDR_2061_fs2_wparallel_size2_2_0_mask                             (0x000000E0)
#define  ATSC_ADDR_2061_fs2_wparallel_size_10_6_mask                             (0x0000001F)
#define  ATSC_ADDR_2061_fs2_wparallel_size2_2_0(data)                            (0x000000E0&((data)<<5))
#define  ATSC_ADDR_2061_fs2_wparallel_size_10_6(data)                            (0x0000001F&(data))
#define  ATSC_ADDR_2061_get_fs2_wparallel_size2_2_0(data)                        ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_2061_get_fs2_wparallel_size_10_6(data)                        (0x0000001F&(data))

#define  ATSC_ADDR_2062                                                         0x18154188
#define  ATSC_ADDR_2062_reg_addr                                                 "0xB8154188"
#define  ATSC_ADDR_2062_reg                                                      0xB8154188
#define  ATSC_ADDR_2062_inst_addr                                                "0x0288"
#define  set_ATSC_ADDR_2062_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2062_reg)=data)
#define  get_ATSC_ADDR_2062_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2062_reg))
#define  ATSC_ADDR_2062_fs2_wparallel_size2_10_3_shift                           (0)
#define  ATSC_ADDR_2062_fs2_wparallel_size2_10_3_mask                            (0x000000FF)
#define  ATSC_ADDR_2062_fs2_wparallel_size2_10_3(data)                           (0x000000FF&(data))
#define  ATSC_ADDR_2062_get_fs2_wparallel_size2_10_3(data)                       (0x000000FF&(data))

#define  ATSC_ADDR_2063                                                         0x1815418C
#define  ATSC_ADDR_2063_reg_addr                                                 "0xB815418C"
#define  ATSC_ADDR_2063_reg                                                      0xB815418C
#define  ATSC_ADDR_2063_inst_addr                                                "0x0289"
#define  set_ATSC_ADDR_2063_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2063_reg)=data)
#define  get_ATSC_ADDR_2063_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2063_reg))
#define  ATSC_ADDR_2063_fs2_corr_th_parallel_7_0_shift                           (0)
#define  ATSC_ADDR_2063_fs2_corr_th_parallel_7_0_mask                            (0x000000FF)
#define  ATSC_ADDR_2063_fs2_corr_th_parallel_7_0(data)                           (0x000000FF&(data))
#define  ATSC_ADDR_2063_get_fs2_corr_th_parallel_7_0(data)                       (0x000000FF&(data))

#define  ATSC_ADDR_2064                                                         0x18154190
#define  ATSC_ADDR_2064_reg_addr                                                 "0xB8154190"
#define  ATSC_ADDR_2064_reg                                                      0xB8154190
#define  ATSC_ADDR_2064_inst_addr                                                "0x028A"
#define  set_ATSC_ADDR_2064_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2064_reg)=data)
#define  get_ATSC_ADDR_2064_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2064_reg))
#define  ATSC_ADDR_2064_fs2_wp_parallel_size_2_0_shift                           (5)
#define  ATSC_ADDR_2064_fs2_corr_th_parallel_12_8_shift                          (0)
#define  ATSC_ADDR_2064_fs2_wp_parallel_size_2_0_mask                            (0x000000E0)
#define  ATSC_ADDR_2064_fs2_corr_th_parallel_12_8_mask                           (0x0000001F)
#define  ATSC_ADDR_2064_fs2_wp_parallel_size_2_0(data)                           (0x000000E0&((data)<<5))
#define  ATSC_ADDR_2064_fs2_corr_th_parallel_12_8(data)                          (0x0000001F&(data))
#define  ATSC_ADDR_2064_get_fs2_wp_parallel_size_2_0(data)                       ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_2064_get_fs2_corr_th_parallel_12_8(data)                      (0x0000001F&(data))

#define  ATSC_ADDR_2065                                                         0x18154194
#define  ATSC_ADDR_2065_reg_addr                                                 "0xB8154194"
#define  ATSC_ADDR_2065_reg                                                      0xB8154194
#define  ATSC_ADDR_2065_inst_addr                                                "0x028B"
#define  set_ATSC_ADDR_2065_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2065_reg)=data)
#define  get_ATSC_ADDR_2065_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2065_reg))
#define  ATSC_ADDR_2065_fs2_wp_parallel_size_10_3_shift                          (0)
#define  ATSC_ADDR_2065_fs2_wp_parallel_size_10_3_mask                           (0x000000FF)
#define  ATSC_ADDR_2065_fs2_wp_parallel_size_10_3(data)                          (0x000000FF&(data))
#define  ATSC_ADDR_2065_get_fs2_wp_parallel_size_10_3(data)                      (0x000000FF&(data))

#define  ATSC_ADDR_2066                                                         0x18154198
#define  ATSC_ADDR_2066_reg_addr                                                 "0xB8154198"
#define  ATSC_ADDR_2066_reg                                                      0xB8154198
#define  ATSC_ADDR_2066_inst_addr                                                "0x028C"
#define  set_ATSC_ADDR_2066_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2066_reg)=data)
#define  get_ATSC_ADDR_2066_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2066_reg))
#define  ATSC_ADDR_2066_fs2_ffe_struc_sel_opt1_1_0_shift                         (6)
#define  ATSC_ADDR_2066_fs2_post_echo_num_th_shift                               (3)
#define  ATSC_ADDR_2066_fs2_pre_echo_num_th_shift                                (0)
#define  ATSC_ADDR_2066_fs2_ffe_struc_sel_opt1_1_0_mask                          (0x000000C0)
#define  ATSC_ADDR_2066_fs2_post_echo_num_th_mask                                (0x00000038)
#define  ATSC_ADDR_2066_fs2_pre_echo_num_th_mask                                 (0x00000007)
#define  ATSC_ADDR_2066_fs2_ffe_struc_sel_opt1_1_0(data)                         (0x000000C0&((data)<<6))
#define  ATSC_ADDR_2066_fs2_post_echo_num_th(data)                               (0x00000038&((data)<<3))
#define  ATSC_ADDR_2066_fs2_pre_echo_num_th(data)                                (0x00000007&(data))
#define  ATSC_ADDR_2066_get_fs2_ffe_struc_sel_opt1_1_0(data)                     ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_2066_get_fs2_post_echo_num_th(data)                           ((0x00000038&(data))>>3)
#define  ATSC_ADDR_2066_get_fs2_pre_echo_num_th(data)                            (0x00000007&(data))

#define  ATSC_ADDR_2067                                                         0x1815419C
#define  ATSC_ADDR_2067_reg_addr                                                 "0xB815419C"
#define  ATSC_ADDR_2067_reg                                                      0xB815419C
#define  ATSC_ADDR_2067_inst_addr                                                "0x028D"
#define  set_ATSC_ADDR_2067_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2067_reg)=data)
#define  get_ATSC_ADDR_2067_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2067_reg))
#define  ATSC_ADDR_2067_fs2_ffe_struc_sel_opt0_0_shift                           (7)
#define  ATSC_ADDR_2067_fs2_ffe_struc_sel_opt3_shift                             (4)
#define  ATSC_ADDR_2067_fs2_ffe_struc_sel_opt2_shift                             (1)
#define  ATSC_ADDR_2067_fs2_ffe_struc_sel_opt1_2_shift                           (0)
#define  ATSC_ADDR_2067_fs2_ffe_struc_sel_opt0_0_mask                            (0x00000080)
#define  ATSC_ADDR_2067_fs2_ffe_struc_sel_opt3_mask                              (0x00000070)
#define  ATSC_ADDR_2067_fs2_ffe_struc_sel_opt2_mask                              (0x0000000E)
#define  ATSC_ADDR_2067_fs2_ffe_struc_sel_opt1_2_mask                            (0x00000001)
#define  ATSC_ADDR_2067_fs2_ffe_struc_sel_opt0_0(data)                           (0x00000080&((data)<<7))
#define  ATSC_ADDR_2067_fs2_ffe_struc_sel_opt3(data)                             (0x00000070&((data)<<4))
#define  ATSC_ADDR_2067_fs2_ffe_struc_sel_opt2(data)                             (0x0000000E&((data)<<1))
#define  ATSC_ADDR_2067_fs2_ffe_struc_sel_opt1_2(data)                           (0x00000001&(data))
#define  ATSC_ADDR_2067_get_fs2_ffe_struc_sel_opt0_0(data)                       ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2067_get_fs2_ffe_struc_sel_opt3(data)                         ((0x00000070&(data))>>4)
#define  ATSC_ADDR_2067_get_fs2_ffe_struc_sel_opt2(data)                         ((0x0000000E&(data))>>1)
#define  ATSC_ADDR_2067_get_fs2_ffe_struc_sel_opt1_2(data)                       (0x00000001&(data))

#define  ATSC_ADDR_2068                                                         0x181541A0
#define  ATSC_ADDR_2068_reg_addr                                                 "0xB81541A0"
#define  ATSC_ADDR_2068_reg                                                      0xB81541A0
#define  ATSC_ADDR_2068_inst_addr                                                "0x028E"
#define  set_ATSC_ADDR_2068_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2068_reg)=data)
#define  get_ATSC_ADDR_2068_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2068_reg))
#define  ATSC_ADDR_2068_fs2_ffe_sp_hold_opt2_shift                               (7)
#define  ATSC_ADDR_2068_fs2_ffe_sp_hold_opt1_shift                               (6)
#define  ATSC_ADDR_2068_fs2_ffe_struc_sel_opt0_2_1_shift                         (0)
#define  ATSC_ADDR_2068_fs2_ffe_sp_hold_opt2_mask                                (0x00000080)
#define  ATSC_ADDR_2068_fs2_ffe_sp_hold_opt1_mask                                (0x00000040)
#define  ATSC_ADDR_2068_fs2_ffe_struc_sel_opt0_2_1_mask                          (0x00000003)
#define  ATSC_ADDR_2068_fs2_ffe_sp_hold_opt2(data)                               (0x00000080&((data)<<7))
#define  ATSC_ADDR_2068_fs2_ffe_sp_hold_opt1(data)                               (0x00000040&((data)<<6))
#define  ATSC_ADDR_2068_fs2_ffe_struc_sel_opt0_2_1(data)                         (0x00000003&(data))
#define  ATSC_ADDR_2068_get_fs2_ffe_sp_hold_opt2(data)                           ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2068_get_fs2_ffe_sp_hold_opt1(data)                           ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2068_get_fs2_ffe_struc_sel_opt0_2_1(data)                     (0x00000003&(data))

#define  ATSC_ADDR_2069                                                         0x181541A4
#define  ATSC_ADDR_2069_reg_addr                                                 "0xB81541A4"
#define  ATSC_ADDR_2069_reg                                                      0xB81541A4
#define  ATSC_ADDR_2069_inst_addr                                                "0x028F"
#define  set_ATSC_ADDR_2069_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2069_reg)=data)
#define  get_ATSC_ADDR_2069_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2069_reg))
#define  ATSC_ADDR_2069_fs2_auto_switch_opt_shift                                (7)
#define  ATSC_ADDR_2069_fs2_wp_parallel_size_11_shift                            (6)
#define  ATSC_ADDR_2069_fs2_wparallel_size2_11_shift                             (5)
#define  ATSC_ADDR_2069_fs2_wparallel_size_11_shift                              (4)
#define  ATSC_ADDR_2069_fs2_eq_auto_ffe_sp_hold_en_shift                         (3)
#define  ATSC_ADDR_2069_fs2_eq_auto_struc_en_shift                               (2)
#define  ATSC_ADDR_2069_fs2_ffe_sp_hold_opt0_shift                               (1)
#define  ATSC_ADDR_2069_fs2_ffe_sp_hold_opt3_shift                               (0)
#define  ATSC_ADDR_2069_fs2_auto_switch_opt_mask                                 (0x00000080)
#define  ATSC_ADDR_2069_fs2_wp_parallel_size_11_mask                             (0x00000040)
#define  ATSC_ADDR_2069_fs2_wparallel_size2_11_mask                              (0x00000020)
#define  ATSC_ADDR_2069_fs2_wparallel_size_11_mask                               (0x00000010)
#define  ATSC_ADDR_2069_fs2_eq_auto_ffe_sp_hold_en_mask                          (0x00000008)
#define  ATSC_ADDR_2069_fs2_eq_auto_struc_en_mask                                (0x00000004)
#define  ATSC_ADDR_2069_fs2_ffe_sp_hold_opt0_mask                                (0x00000002)
#define  ATSC_ADDR_2069_fs2_ffe_sp_hold_opt3_mask                                (0x00000001)
#define  ATSC_ADDR_2069_fs2_auto_switch_opt(data)                                (0x00000080&((data)<<7))
#define  ATSC_ADDR_2069_fs2_wp_parallel_size_11(data)                            (0x00000040&((data)<<6))
#define  ATSC_ADDR_2069_fs2_wparallel_size2_11(data)                             (0x00000020&((data)<<5))
#define  ATSC_ADDR_2069_fs2_wparallel_size_11(data)                              (0x00000010&((data)<<4))
#define  ATSC_ADDR_2069_fs2_eq_auto_ffe_sp_hold_en(data)                         (0x00000008&((data)<<3))
#define  ATSC_ADDR_2069_fs2_eq_auto_struc_en(data)                               (0x00000004&((data)<<2))
#define  ATSC_ADDR_2069_fs2_ffe_sp_hold_opt0(data)                               (0x00000002&((data)<<1))
#define  ATSC_ADDR_2069_fs2_ffe_sp_hold_opt3(data)                               (0x00000001&(data))
#define  ATSC_ADDR_2069_get_fs2_auto_switch_opt(data)                            ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2069_get_fs2_wp_parallel_size_11(data)                        ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2069_get_fs2_wparallel_size2_11(data)                         ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2069_get_fs2_wparallel_size_11(data)                          ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2069_get_fs2_eq_auto_ffe_sp_hold_en(data)                     ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2069_get_fs2_eq_auto_struc_en(data)                           ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2069_get_fs2_ffe_sp_hold_opt0(data)                           ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2069_get_fs2_ffe_sp_hold_opt3(data)                           (0x00000001&(data))

#define  ATSC_ADDR_206A                                                         0x181541A8
#define  ATSC_ADDR_206A_reg_addr                                                 "0xB81541A8"
#define  ATSC_ADDR_206A_reg                                                      0xB81541A8
#define  ATSC_ADDR_206A_inst_addr                                                "0x0290"
#define  set_ATSC_ADDR_206A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_206A_reg)=data)
#define  get_ATSC_ADDR_206A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_206A_reg))
#define  ATSC_ADDR_206A_reg_stage_length_1076_ini_7_0_shift                      (0)
#define  ATSC_ADDR_206A_reg_stage_length_1076_ini_7_0_mask                       (0x000000FF)
#define  ATSC_ADDR_206A_reg_stage_length_1076_ini_7_0(data)                      (0x000000FF&(data))
#define  ATSC_ADDR_206A_get_reg_stage_length_1076_ini_7_0(data)                  (0x000000FF&(data))

#define  ATSC_ADDR_206B                                                         0x181541AC
#define  ATSC_ADDR_206B_reg_addr                                                 "0xB81541AC"
#define  ATSC_ADDR_206B_reg                                                      0xB81541AC
#define  ATSC_ADDR_206B_inst_addr                                                "0x0291"
#define  set_ATSC_ADDR_206B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_206B_reg)=data)
#define  get_ATSC_ADDR_206B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_206B_reg))
#define  ATSC_ADDR_206B_stage_length_1076_ini_opt1_4_0_shift                     (3)
#define  ATSC_ADDR_206B_reg_stage_length_1076_ini_10_8_shift                     (0)
#define  ATSC_ADDR_206B_stage_length_1076_ini_opt1_4_0_mask                      (0x000000F8)
#define  ATSC_ADDR_206B_reg_stage_length_1076_ini_10_8_mask                      (0x00000007)
#define  ATSC_ADDR_206B_stage_length_1076_ini_opt1_4_0(data)                     (0x000000F8&((data)<<3))
#define  ATSC_ADDR_206B_reg_stage_length_1076_ini_10_8(data)                     (0x00000007&(data))
#define  ATSC_ADDR_206B_get_stage_length_1076_ini_opt1_4_0(data)                 ((0x000000F8&(data))>>3)
#define  ATSC_ADDR_206B_get_reg_stage_length_1076_ini_10_8(data)                 (0x00000007&(data))

#define  ATSC_ADDR_206C                                                         0x181541B0
#define  ATSC_ADDR_206C_reg_addr                                                 "0xB81541B0"
#define  ATSC_ADDR_206C_reg                                                      0xB81541B0
#define  ATSC_ADDR_206C_inst_addr                                                "0x0292"
#define  set_ATSC_ADDR_206C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_206C_reg)=data)
#define  get_ATSC_ADDR_206C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_206C_reg))
#define  ATSC_ADDR_206C_stage_length_1076_ini_opt2_1_0_shift                     (6)
#define  ATSC_ADDR_206C_stage_length_1076_ini_opt1_10_5_shift                    (0)
#define  ATSC_ADDR_206C_stage_length_1076_ini_opt2_1_0_mask                      (0x000000C0)
#define  ATSC_ADDR_206C_stage_length_1076_ini_opt1_10_5_mask                     (0x0000003F)
#define  ATSC_ADDR_206C_stage_length_1076_ini_opt2_1_0(data)                     (0x000000C0&((data)<<6))
#define  ATSC_ADDR_206C_stage_length_1076_ini_opt1_10_5(data)                    (0x0000003F&(data))
#define  ATSC_ADDR_206C_get_stage_length_1076_ini_opt2_1_0(data)                 ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_206C_get_stage_length_1076_ini_opt1_10_5(data)                (0x0000003F&(data))

#define  ATSC_ADDR_206D                                                         0x181541B4
#define  ATSC_ADDR_206D_reg_addr                                                 "0xB81541B4"
#define  ATSC_ADDR_206D_reg                                                      0xB81541B4
#define  ATSC_ADDR_206D_inst_addr                                                "0x0293"
#define  set_ATSC_ADDR_206D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_206D_reg)=data)
#define  get_ATSC_ADDR_206D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_206D_reg))
#define  ATSC_ADDR_206D_stage_length_1076_ini_opt2_9_2_shift                     (0)
#define  ATSC_ADDR_206D_stage_length_1076_ini_opt2_9_2_mask                      (0x000000FF)
#define  ATSC_ADDR_206D_stage_length_1076_ini_opt2_9_2(data)                     (0x000000FF&(data))
#define  ATSC_ADDR_206D_get_stage_length_1076_ini_opt2_9_2(data)                 (0x000000FF&(data))

#define  ATSC_ADDR_206E                                                         0x181541B8
#define  ATSC_ADDR_206E_reg_addr                                                 "0xB81541B8"
#define  ATSC_ADDR_206E_reg                                                      0xB81541B8
#define  ATSC_ADDR_206E_inst_addr                                                "0x0294"
#define  set_ATSC_ADDR_206E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_206E_reg)=data)
#define  get_ATSC_ADDR_206E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_206E_reg))
#define  ATSC_ADDR_206E_stage_length_1076_ini_opt3_6_0_shift                     (1)
#define  ATSC_ADDR_206E_stage_length_1076_ini_opt2_10_shift                      (0)
#define  ATSC_ADDR_206E_stage_length_1076_ini_opt3_6_0_mask                      (0x000000FE)
#define  ATSC_ADDR_206E_stage_length_1076_ini_opt2_10_mask                       (0x00000001)
#define  ATSC_ADDR_206E_stage_length_1076_ini_opt3_6_0(data)                     (0x000000FE&((data)<<1))
#define  ATSC_ADDR_206E_stage_length_1076_ini_opt2_10(data)                      (0x00000001&(data))
#define  ATSC_ADDR_206E_get_stage_length_1076_ini_opt3_6_0(data)                 ((0x000000FE&(data))>>1)
#define  ATSC_ADDR_206E_get_stage_length_1076_ini_opt2_10(data)                  (0x00000001&(data))

#define  ATSC_ADDR_206F                                                         0x181541BC
#define  ATSC_ADDR_206F_reg_addr                                                 "0xB81541BC"
#define  ATSC_ADDR_206F_reg                                                      0xB81541BC
#define  ATSC_ADDR_206F_inst_addr                                                "0x0295"
#define  set_ATSC_ADDR_206F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_206F_reg)=data)
#define  get_ATSC_ADDR_206F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_206F_reg))
#define  ATSC_ADDR_206F_stage_length_1076_ini_opt0_3_0_shift                     (4)
#define  ATSC_ADDR_206F_stage_length_1076_ini_opt3_10_7_shift                    (0)
#define  ATSC_ADDR_206F_stage_length_1076_ini_opt0_3_0_mask                      (0x000000F0)
#define  ATSC_ADDR_206F_stage_length_1076_ini_opt3_10_7_mask                     (0x0000000F)
#define  ATSC_ADDR_206F_stage_length_1076_ini_opt0_3_0(data)                     (0x000000F0&((data)<<4))
#define  ATSC_ADDR_206F_stage_length_1076_ini_opt3_10_7(data)                    (0x0000000F&(data))
#define  ATSC_ADDR_206F_get_stage_length_1076_ini_opt0_3_0(data)                 ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_206F_get_stage_length_1076_ini_opt3_10_7(data)                (0x0000000F&(data))

#define  ATSC_ADDR_2070                                                         0x181541C0
#define  ATSC_ADDR_2070_reg_addr                                                 "0xB81541C0"
#define  ATSC_ADDR_2070_reg                                                      0xB81541C0
#define  ATSC_ADDR_2070_inst_addr                                                "0x0296"
#define  set_ATSC_ADDR_2070_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2070_reg)=data)
#define  get_ATSC_ADDR_2070_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2070_reg))
#define  ATSC_ADDR_2070_ffe_in_ptr_ini_opt1_0_shift                              (7)
#define  ATSC_ADDR_2070_stage_length_1076_ini_opt0_10_4_shift                    (0)
#define  ATSC_ADDR_2070_ffe_in_ptr_ini_opt1_0_mask                               (0x00000080)
#define  ATSC_ADDR_2070_stage_length_1076_ini_opt0_10_4_mask                     (0x0000007F)
#define  ATSC_ADDR_2070_ffe_in_ptr_ini_opt1_0(data)                              (0x00000080&((data)<<7))
#define  ATSC_ADDR_2070_stage_length_1076_ini_opt0_10_4(data)                    (0x0000007F&(data))
#define  ATSC_ADDR_2070_get_ffe_in_ptr_ini_opt1_0(data)                          ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2070_get_stage_length_1076_ini_opt0_10_4(data)                (0x0000007F&(data))

#define  ATSC_ADDR_2071                                                         0x181541C4
#define  ATSC_ADDR_2071_reg_addr                                                 "0xB81541C4"
#define  ATSC_ADDR_2071_reg                                                      0xB81541C4
#define  ATSC_ADDR_2071_inst_addr                                                "0x0297"
#define  set_ATSC_ADDR_2071_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2071_reg)=data)
#define  get_ATSC_ADDR_2071_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2071_reg))
#define  ATSC_ADDR_2071_ffe_in_ptr_ini_opt1_8_1_shift                            (0)
#define  ATSC_ADDR_2071_ffe_in_ptr_ini_opt1_8_1_mask                             (0x000000FF)
#define  ATSC_ADDR_2071_ffe_in_ptr_ini_opt1_8_1(data)                            (0x000000FF&(data))
#define  ATSC_ADDR_2071_get_ffe_in_ptr_ini_opt1_8_1(data)                        (0x000000FF&(data))

#define  ATSC_ADDR_2072                                                         0x181541C8
#define  ATSC_ADDR_2072_reg_addr                                                 "0xB81541C8"
#define  ATSC_ADDR_2072_reg                                                      0xB81541C8
#define  ATSC_ADDR_2072_inst_addr                                                "0x0298"
#define  set_ATSC_ADDR_2072_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2072_reg)=data)
#define  get_ATSC_ADDR_2072_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2072_reg))
#define  ATSC_ADDR_2072_ffe_in_ptr_ini_opt2_2_0_shift                            (5)
#define  ATSC_ADDR_2072_ffe_in_ptr_ini_opt1_13_9_shift                           (0)
#define  ATSC_ADDR_2072_ffe_in_ptr_ini_opt2_2_0_mask                             (0x000000E0)
#define  ATSC_ADDR_2072_ffe_in_ptr_ini_opt1_13_9_mask                            (0x0000001F)
#define  ATSC_ADDR_2072_ffe_in_ptr_ini_opt2_2_0(data)                            (0x000000E0&((data)<<5))
#define  ATSC_ADDR_2072_ffe_in_ptr_ini_opt1_13_9(data)                           (0x0000001F&(data))
#define  ATSC_ADDR_2072_get_ffe_in_ptr_ini_opt2_2_0(data)                        ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_2072_get_ffe_in_ptr_ini_opt1_13_9(data)                       (0x0000001F&(data))

#define  ATSC_ADDR_2073                                                         0x181541CC
#define  ATSC_ADDR_2073_reg_addr                                                 "0xB81541CC"
#define  ATSC_ADDR_2073_reg                                                      0xB81541CC
#define  ATSC_ADDR_2073_inst_addr                                                "0x0299"
#define  set_ATSC_ADDR_2073_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2073_reg)=data)
#define  get_ATSC_ADDR_2073_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2073_reg))
#define  ATSC_ADDR_2073_ffe_in_ptr_ini_opt2_10_3_shift                           (0)
#define  ATSC_ADDR_2073_ffe_in_ptr_ini_opt2_10_3_mask                            (0x000000FF)
#define  ATSC_ADDR_2073_ffe_in_ptr_ini_opt2_10_3(data)                           (0x000000FF&(data))
#define  ATSC_ADDR_2073_get_ffe_in_ptr_ini_opt2_10_3(data)                       (0x000000FF&(data))

#define  ATSC_ADDR_2074                                                         0x181541D0
#define  ATSC_ADDR_2074_reg_addr                                                 "0xB81541D0"
#define  ATSC_ADDR_2074_reg                                                      0xB81541D0
#define  ATSC_ADDR_2074_inst_addr                                                "0x029A"
#define  set_ATSC_ADDR_2074_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2074_reg)=data)
#define  get_ATSC_ADDR_2074_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2074_reg))
#define  ATSC_ADDR_2074_ffe_in_ptr_ini_opt3_4_0_shift                            (3)
#define  ATSC_ADDR_2074_ffe_in_ptr_ini_opt2_13_11_shift                          (0)
#define  ATSC_ADDR_2074_ffe_in_ptr_ini_opt3_4_0_mask                             (0x000000F8)
#define  ATSC_ADDR_2074_ffe_in_ptr_ini_opt2_13_11_mask                           (0x00000007)
#define  ATSC_ADDR_2074_ffe_in_ptr_ini_opt3_4_0(data)                            (0x000000F8&((data)<<3))
#define  ATSC_ADDR_2074_ffe_in_ptr_ini_opt2_13_11(data)                          (0x00000007&(data))
#define  ATSC_ADDR_2074_get_ffe_in_ptr_ini_opt3_4_0(data)                        ((0x000000F8&(data))>>3)
#define  ATSC_ADDR_2074_get_ffe_in_ptr_ini_opt2_13_11(data)                      (0x00000007&(data))

#define  ATSC_ADDR_2075                                                         0x181541D4
#define  ATSC_ADDR_2075_reg_addr                                                 "0xB81541D4"
#define  ATSC_ADDR_2075_reg                                                      0xB81541D4
#define  ATSC_ADDR_2075_inst_addr                                                "0x029B"
#define  set_ATSC_ADDR_2075_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2075_reg)=data)
#define  get_ATSC_ADDR_2075_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2075_reg))
#define  ATSC_ADDR_2075_ffe_in_ptr_ini_opt3_12_5_shift                           (0)
#define  ATSC_ADDR_2075_ffe_in_ptr_ini_opt3_12_5_mask                            (0x000000FF)
#define  ATSC_ADDR_2075_ffe_in_ptr_ini_opt3_12_5(data)                           (0x000000FF&(data))
#define  ATSC_ADDR_2075_get_ffe_in_ptr_ini_opt3_12_5(data)                       (0x000000FF&(data))

#define  ATSC_ADDR_2076                                                         0x181541D8
#define  ATSC_ADDR_2076_reg_addr                                                 "0xB81541D8"
#define  ATSC_ADDR_2076_reg                                                      0xB81541D8
#define  ATSC_ADDR_2076_inst_addr                                                "0x029C"
#define  set_ATSC_ADDR_2076_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2076_reg)=data)
#define  get_ATSC_ADDR_2076_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2076_reg))
#define  ATSC_ADDR_2076_ffe_in_ptr_ini_opt0_6_0_shift                            (1)
#define  ATSC_ADDR_2076_ffe_in_ptr_ini_opt3_13_shift                             (0)
#define  ATSC_ADDR_2076_ffe_in_ptr_ini_opt0_6_0_mask                             (0x000000FE)
#define  ATSC_ADDR_2076_ffe_in_ptr_ini_opt3_13_mask                              (0x00000001)
#define  ATSC_ADDR_2076_ffe_in_ptr_ini_opt0_6_0(data)                            (0x000000FE&((data)<<1))
#define  ATSC_ADDR_2076_ffe_in_ptr_ini_opt3_13(data)                             (0x00000001&(data))
#define  ATSC_ADDR_2076_get_ffe_in_ptr_ini_opt0_6_0(data)                        ((0x000000FE&(data))>>1)
#define  ATSC_ADDR_2076_get_ffe_in_ptr_ini_opt3_13(data)                         (0x00000001&(data))

#define  ATSC_ADDR_2077                                                         0x181541DC
#define  ATSC_ADDR_2077_reg_addr                                                 "0xB81541DC"
#define  ATSC_ADDR_2077_reg                                                      0xB81541DC
#define  ATSC_ADDR_2077_inst_addr                                                "0x029D"
#define  set_ATSC_ADDR_2077_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2077_reg)=data)
#define  get_ATSC_ADDR_2077_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2077_reg))
#define  ATSC_ADDR_2077_ffe_in_ptr_ini_opt0_13_7_shift                           (0)
#define  ATSC_ADDR_2077_ffe_in_ptr_ini_opt0_13_7_mask                            (0x0000007F)
#define  ATSC_ADDR_2077_ffe_in_ptr_ini_opt0_13_7(data)                           (0x0000007F&(data))
#define  ATSC_ADDR_2077_get_ffe_in_ptr_ini_opt0_13_7(data)                       (0x0000007F&(data))

#define  ATSC_ADDR_2EB9                                                         0x18157AE4
#define  ATSC_ADDR_2EB9_reg_addr                                                 "0xB8157AE4"
#define  ATSC_ADDR_2EB9_reg                                                      0xB8157AE4
#define  ATSC_ADDR_2EB9_inst_addr                                                "0x029E"
#define  set_ATSC_ADDR_2EB9_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EB9_reg)=data)
#define  get_ATSC_ADDR_2EB9_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EB9_reg))
#define  ATSC_ADDR_2EB9_fs2_parallel_addr_th1_7_0_shift                          (0)
#define  ATSC_ADDR_2EB9_fs2_parallel_addr_th1_7_0_mask                           (0x000000FF)
#define  ATSC_ADDR_2EB9_fs2_parallel_addr_th1_7_0(data)                          (0x000000FF&(data))
#define  ATSC_ADDR_2EB9_get_fs2_parallel_addr_th1_7_0(data)                      (0x000000FF&(data))

#define  ATSC_ADDR_2EBA                                                         0x18157AE8
#define  ATSC_ADDR_2EBA_reg_addr                                                 "0xB8157AE8"
#define  ATSC_ADDR_2EBA_reg                                                      0xB8157AE8
#define  ATSC_ADDR_2EBA_inst_addr                                                "0x029F"
#define  set_ATSC_ADDR_2EBA_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EBA_reg)=data)
#define  get_ATSC_ADDR_2EBA_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EBA_reg))
#define  ATSC_ADDR_2EBA_fs2_parallel_addr_th1_11_8_shift                         (0)
#define  ATSC_ADDR_2EBA_fs2_parallel_addr_th1_11_8_mask                          (0x0000000F)
#define  ATSC_ADDR_2EBA_fs2_parallel_addr_th1_11_8(data)                         (0x0000000F&(data))
#define  ATSC_ADDR_2EBA_get_fs2_parallel_addr_th1_11_8(data)                     (0x0000000F&(data))

#define  ATSC_ADDR_2EBB                                                         0x18157AEC
#define  ATSC_ADDR_2EBB_reg_addr                                                 "0xB8157AEC"
#define  ATSC_ADDR_2EBB_reg                                                      0xB8157AEC
#define  ATSC_ADDR_2EBB_inst_addr                                                "0x02A0"
#define  set_ATSC_ADDR_2EBB_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EBB_reg)=data)
#define  get_ATSC_ADDR_2EBB_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EBB_reg))
#define  ATSC_ADDR_2EBB_fs2_parallel_addr_th2_7_0_shift                          (0)
#define  ATSC_ADDR_2EBB_fs2_parallel_addr_th2_7_0_mask                           (0x000000FF)
#define  ATSC_ADDR_2EBB_fs2_parallel_addr_th2_7_0(data)                          (0x000000FF&(data))
#define  ATSC_ADDR_2EBB_get_fs2_parallel_addr_th2_7_0(data)                      (0x000000FF&(data))

#define  ATSC_ADDR_2EBC                                                         0x18157AF0
#define  ATSC_ADDR_2EBC_reg_addr                                                 "0xB8157AF0"
#define  ATSC_ADDR_2EBC_reg                                                      0xB8157AF0
#define  ATSC_ADDR_2EBC_inst_addr                                                "0x02A1"
#define  set_ATSC_ADDR_2EBC_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EBC_reg)=data)
#define  get_ATSC_ADDR_2EBC_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EBC_reg))
#define  ATSC_ADDR_2EBC_fs2_parallel_addr_th2_11_8_shift                         (0)
#define  ATSC_ADDR_2EBC_fs2_parallel_addr_th2_11_8_mask                          (0x0000000F)
#define  ATSC_ADDR_2EBC_fs2_parallel_addr_th2_11_8(data)                         (0x0000000F&(data))
#define  ATSC_ADDR_2EBC_get_fs2_parallel_addr_th2_11_8(data)                     (0x0000000F&(data))

#define  ATSC_ADDR_2EBD                                                         0x18157AF4
#define  ATSC_ADDR_2EBD_reg_addr                                                 "0xB8157AF4"
#define  ATSC_ADDR_2EBD_reg                                                      0xB8157AF4
#define  ATSC_ADDR_2EBD_inst_addr                                                "0x02A2"
#define  set_ATSC_ADDR_2EBD_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EBD_reg)=data)
#define  get_ATSC_ADDR_2EBD_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EBD_reg))
#define  ATSC_ADDR_2EBD_fs2_parallel_addr_th3_7_0_shift                          (0)
#define  ATSC_ADDR_2EBD_fs2_parallel_addr_th3_7_0_mask                           (0x000000FF)
#define  ATSC_ADDR_2EBD_fs2_parallel_addr_th3_7_0(data)                          (0x000000FF&(data))
#define  ATSC_ADDR_2EBD_get_fs2_parallel_addr_th3_7_0(data)                      (0x000000FF&(data))

#define  ATSC_ADDR_2EBE                                                         0x18157AF8
#define  ATSC_ADDR_2EBE_reg_addr                                                 "0xB8157AF8"
#define  ATSC_ADDR_2EBE_reg                                                      0xB8157AF8
#define  ATSC_ADDR_2EBE_inst_addr                                                "0x02A3"
#define  set_ATSC_ADDR_2EBE_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EBE_reg)=data)
#define  get_ATSC_ADDR_2EBE_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EBE_reg))
#define  ATSC_ADDR_2EBE_fs2_parallel_addr_th3_11_8_shift                         (0)
#define  ATSC_ADDR_2EBE_fs2_parallel_addr_th3_11_8_mask                          (0x0000000F)
#define  ATSC_ADDR_2EBE_fs2_parallel_addr_th3_11_8(data)                         (0x0000000F&(data))
#define  ATSC_ADDR_2EBE_get_fs2_parallel_addr_th3_11_8(data)                     (0x0000000F&(data))

#define  ATSC_ADDR_2EBF                                                         0x18157AFC
#define  ATSC_ADDR_2EBF_reg_addr                                                 "0xB8157AFC"
#define  ATSC_ADDR_2EBF_reg                                                      0xB8157AFC
#define  ATSC_ADDR_2EBF_inst_addr                                                "0x02A4"
#define  set_ATSC_ADDR_2EBF_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EBF_reg)=data)
#define  get_ATSC_ADDR_2EBF_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EBF_reg))
#define  ATSC_ADDR_2EBF_fs2_parallel_addr_th4_7_0_shift                          (0)
#define  ATSC_ADDR_2EBF_fs2_parallel_addr_th4_7_0_mask                           (0x000000FF)
#define  ATSC_ADDR_2EBF_fs2_parallel_addr_th4_7_0(data)                          (0x000000FF&(data))
#define  ATSC_ADDR_2EBF_get_fs2_parallel_addr_th4_7_0(data)                      (0x000000FF&(data))

#define  ATSC_ADDR_2EC0                                                         0x18157B00
#define  ATSC_ADDR_2EC0_reg_addr                                                 "0xB8157B00"
#define  ATSC_ADDR_2EC0_reg                                                      0xB8157B00
#define  ATSC_ADDR_2EC0_inst_addr                                                "0x02A5"
#define  set_ATSC_ADDR_2EC0_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EC0_reg)=data)
#define  get_ATSC_ADDR_2EC0_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EC0_reg))
#define  ATSC_ADDR_2EC0_fs2_parallel_addr_th4_11_8_shift                         (0)
#define  ATSC_ADDR_2EC0_fs2_parallel_addr_th4_11_8_mask                          (0x0000000F)
#define  ATSC_ADDR_2EC0_fs2_parallel_addr_th4_11_8(data)                         (0x0000000F&(data))
#define  ATSC_ADDR_2EC0_get_fs2_parallel_addr_th4_11_8(data)                     (0x0000000F&(data))

#define  ATSC_ADDR_2EC1                                                         0x18157B04
#define  ATSC_ADDR_2EC1_reg_addr                                                 "0xB8157B04"
#define  ATSC_ADDR_2EC1_reg                                                      0xB8157B04
#define  ATSC_ADDR_2EC1_inst_addr                                                "0x02A6"
#define  set_ATSC_ADDR_2EC1_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EC1_reg)=data)
#define  get_ATSC_ADDR_2EC1_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EC1_reg))
#define  ATSC_ADDR_2EC1_fs2_parallel_addr_th5_7_0_shift                          (0)
#define  ATSC_ADDR_2EC1_fs2_parallel_addr_th5_7_0_mask                           (0x000000FF)
#define  ATSC_ADDR_2EC1_fs2_parallel_addr_th5_7_0(data)                          (0x000000FF&(data))
#define  ATSC_ADDR_2EC1_get_fs2_parallel_addr_th5_7_0(data)                      (0x000000FF&(data))

#define  ATSC_ADDR_2EC2                                                         0x18157B08
#define  ATSC_ADDR_2EC2_reg_addr                                                 "0xB8157B08"
#define  ATSC_ADDR_2EC2_reg                                                      0xB8157B08
#define  ATSC_ADDR_2EC2_inst_addr                                                "0x02A7"
#define  set_ATSC_ADDR_2EC2_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EC2_reg)=data)
#define  get_ATSC_ADDR_2EC2_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EC2_reg))
#define  ATSC_ADDR_2EC2_fs2_parallel_addr_th5_11_8_shift                         (0)
#define  ATSC_ADDR_2EC2_fs2_parallel_addr_th5_11_8_mask                          (0x0000000F)
#define  ATSC_ADDR_2EC2_fs2_parallel_addr_th5_11_8(data)                         (0x0000000F&(data))
#define  ATSC_ADDR_2EC2_get_fs2_parallel_addr_th5_11_8(data)                     (0x0000000F&(data))

#define  ATSC_ADDR_2EC3                                                         0x18157B0C
#define  ATSC_ADDR_2EC3_reg_addr                                                 "0xB8157B0C"
#define  ATSC_ADDR_2EC3_reg                                                      0xB8157B0C
#define  ATSC_ADDR_2EC3_inst_addr                                                "0x02A8"
#define  set_ATSC_ADDR_2EC3_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EC3_reg)=data)
#define  get_ATSC_ADDR_2EC3_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EC3_reg))
#define  ATSC_ADDR_2EC3_fs2_parallel_addr_th6_7_0_shift                          (0)
#define  ATSC_ADDR_2EC3_fs2_parallel_addr_th6_7_0_mask                           (0x000000FF)
#define  ATSC_ADDR_2EC3_fs2_parallel_addr_th6_7_0(data)                          (0x000000FF&(data))
#define  ATSC_ADDR_2EC3_get_fs2_parallel_addr_th6_7_0(data)                      (0x000000FF&(data))

#define  ATSC_ADDR_2EC4                                                         0x18157B10
#define  ATSC_ADDR_2EC4_reg_addr                                                 "0xB8157B10"
#define  ATSC_ADDR_2EC4_reg                                                      0xB8157B10
#define  ATSC_ADDR_2EC4_inst_addr                                                "0x02A9"
#define  set_ATSC_ADDR_2EC4_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EC4_reg)=data)
#define  get_ATSC_ADDR_2EC4_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EC4_reg))
#define  ATSC_ADDR_2EC4_fs2_parallel_addr_th6_11_8_shift                         (0)
#define  ATSC_ADDR_2EC4_fs2_parallel_addr_th6_11_8_mask                          (0x0000000F)
#define  ATSC_ADDR_2EC4_fs2_parallel_addr_th6_11_8(data)                         (0x0000000F&(data))
#define  ATSC_ADDR_2EC4_get_fs2_parallel_addr_th6_11_8(data)                     (0x0000000F&(data))

#define  ATSC_ADDR_2EC5                                                         0x18157B14
#define  ATSC_ADDR_2EC5_reg_addr                                                 "0xB8157B14"
#define  ATSC_ADDR_2EC5_reg                                                      0xB8157B14
#define  ATSC_ADDR_2EC5_inst_addr                                                "0x02AA"
#define  set_ATSC_ADDR_2EC5_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EC5_reg)=data)
#define  get_ATSC_ADDR_2EC5_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EC5_reg))
#define  ATSC_ADDR_2EC5_fs2_parallel_th_1_7_0_shift                              (0)
#define  ATSC_ADDR_2EC5_fs2_parallel_th_1_7_0_mask                               (0x000000FF)
#define  ATSC_ADDR_2EC5_fs2_parallel_th_1_7_0(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_2EC5_get_fs2_parallel_th_1_7_0(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_2EC6                                                         0x18157B18
#define  ATSC_ADDR_2EC6_reg_addr                                                 "0xB8157B18"
#define  ATSC_ADDR_2EC6_reg                                                      0xB8157B18
#define  ATSC_ADDR_2EC6_inst_addr                                                "0x02AB"
#define  set_ATSC_ADDR_2EC6_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EC6_reg)=data)
#define  get_ATSC_ADDR_2EC6_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EC6_reg))
#define  ATSC_ADDR_2EC6_fs2_parallel_th_1_12_8_shift                             (0)
#define  ATSC_ADDR_2EC6_fs2_parallel_th_1_12_8_mask                              (0x0000001F)
#define  ATSC_ADDR_2EC6_fs2_parallel_th_1_12_8(data)                             (0x0000001F&(data))
#define  ATSC_ADDR_2EC6_get_fs2_parallel_th_1_12_8(data)                         (0x0000001F&(data))

#define  ATSC_ADDR_2EC7                                                         0x18157B1C
#define  ATSC_ADDR_2EC7_reg_addr                                                 "0xB8157B1C"
#define  ATSC_ADDR_2EC7_reg                                                      0xB8157B1C
#define  ATSC_ADDR_2EC7_inst_addr                                                "0x02AC"
#define  set_ATSC_ADDR_2EC7_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EC7_reg)=data)
#define  get_ATSC_ADDR_2EC7_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EC7_reg))
#define  ATSC_ADDR_2EC7_fs2_parallel_th_2_7_0_shift                              (0)
#define  ATSC_ADDR_2EC7_fs2_parallel_th_2_7_0_mask                               (0x000000FF)
#define  ATSC_ADDR_2EC7_fs2_parallel_th_2_7_0(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_2EC7_get_fs2_parallel_th_2_7_0(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_2EC8                                                         0x18157B20
#define  ATSC_ADDR_2EC8_reg_addr                                                 "0xB8157B20"
#define  ATSC_ADDR_2EC8_reg                                                      0xB8157B20
#define  ATSC_ADDR_2EC8_inst_addr                                                "0x02AD"
#define  set_ATSC_ADDR_2EC8_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EC8_reg)=data)
#define  get_ATSC_ADDR_2EC8_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EC8_reg))
#define  ATSC_ADDR_2EC8_fs2_parallel_th_2_12_8_shift                             (0)
#define  ATSC_ADDR_2EC8_fs2_parallel_th_2_12_8_mask                              (0x0000001F)
#define  ATSC_ADDR_2EC8_fs2_parallel_th_2_12_8(data)                             (0x0000001F&(data))
#define  ATSC_ADDR_2EC8_get_fs2_parallel_th_2_12_8(data)                         (0x0000001F&(data))

#define  ATSC_ADDR_2EC9                                                         0x18157B24
#define  ATSC_ADDR_2EC9_reg_addr                                                 "0xB8157B24"
#define  ATSC_ADDR_2EC9_reg                                                      0xB8157B24
#define  ATSC_ADDR_2EC9_inst_addr                                                "0x02AE"
#define  set_ATSC_ADDR_2EC9_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EC9_reg)=data)
#define  get_ATSC_ADDR_2EC9_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EC9_reg))
#define  ATSC_ADDR_2EC9_fs2_parallel_th_3_7_0_shift                              (0)
#define  ATSC_ADDR_2EC9_fs2_parallel_th_3_7_0_mask                               (0x000000FF)
#define  ATSC_ADDR_2EC9_fs2_parallel_th_3_7_0(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_2EC9_get_fs2_parallel_th_3_7_0(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_2ECA                                                         0x18157B28
#define  ATSC_ADDR_2ECA_reg_addr                                                 "0xB8157B28"
#define  ATSC_ADDR_2ECA_reg                                                      0xB8157B28
#define  ATSC_ADDR_2ECA_inst_addr                                                "0x02AF"
#define  set_ATSC_ADDR_2ECA_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2ECA_reg)=data)
#define  get_ATSC_ADDR_2ECA_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2ECA_reg))
#define  ATSC_ADDR_2ECA_fs2_parallel_th_3_12_8_shift                             (0)
#define  ATSC_ADDR_2ECA_fs2_parallel_th_3_12_8_mask                              (0x0000001F)
#define  ATSC_ADDR_2ECA_fs2_parallel_th_3_12_8(data)                             (0x0000001F&(data))
#define  ATSC_ADDR_2ECA_get_fs2_parallel_th_3_12_8(data)                         (0x0000001F&(data))

#define  ATSC_ADDR_2ECB                                                         0x18157B2C
#define  ATSC_ADDR_2ECB_reg_addr                                                 "0xB8157B2C"
#define  ATSC_ADDR_2ECB_reg                                                      0xB8157B2C
#define  ATSC_ADDR_2ECB_inst_addr                                                "0x02B0"
#define  set_ATSC_ADDR_2ECB_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2ECB_reg)=data)
#define  get_ATSC_ADDR_2ECB_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2ECB_reg))
#define  ATSC_ADDR_2ECB_fs2_parallel_th_4_7_0_shift                              (0)
#define  ATSC_ADDR_2ECB_fs2_parallel_th_4_7_0_mask                               (0x000000FF)
#define  ATSC_ADDR_2ECB_fs2_parallel_th_4_7_0(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_2ECB_get_fs2_parallel_th_4_7_0(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_2ECC                                                         0x18157B30
#define  ATSC_ADDR_2ECC_reg_addr                                                 "0xB8157B30"
#define  ATSC_ADDR_2ECC_reg                                                      0xB8157B30
#define  ATSC_ADDR_2ECC_inst_addr                                                "0x02B1"
#define  set_ATSC_ADDR_2ECC_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2ECC_reg)=data)
#define  get_ATSC_ADDR_2ECC_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2ECC_reg))
#define  ATSC_ADDR_2ECC_fs2_parallel_th_4_12_8_shift                             (0)
#define  ATSC_ADDR_2ECC_fs2_parallel_th_4_12_8_mask                              (0x0000001F)
#define  ATSC_ADDR_2ECC_fs2_parallel_th_4_12_8(data)                             (0x0000001F&(data))
#define  ATSC_ADDR_2ECC_get_fs2_parallel_th_4_12_8(data)                         (0x0000001F&(data))

#define  ATSC_ADDR_2ECD                                                         0x18157B34
#define  ATSC_ADDR_2ECD_reg_addr                                                 "0xB8157B34"
#define  ATSC_ADDR_2ECD_reg                                                      0xB8157B34
#define  ATSC_ADDR_2ECD_inst_addr                                                "0x02B2"
#define  set_ATSC_ADDR_2ECD_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2ECD_reg)=data)
#define  get_ATSC_ADDR_2ECD_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2ECD_reg))
#define  ATSC_ADDR_2ECD_fs2_parallel_th_5_7_0_shift                              (0)
#define  ATSC_ADDR_2ECD_fs2_parallel_th_5_7_0_mask                               (0x000000FF)
#define  ATSC_ADDR_2ECD_fs2_parallel_th_5_7_0(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_2ECD_get_fs2_parallel_th_5_7_0(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_2ECE                                                         0x18157B38
#define  ATSC_ADDR_2ECE_reg_addr                                                 "0xB8157B38"
#define  ATSC_ADDR_2ECE_reg                                                      0xB8157B38
#define  ATSC_ADDR_2ECE_inst_addr                                                "0x02B3"
#define  set_ATSC_ADDR_2ECE_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2ECE_reg)=data)
#define  get_ATSC_ADDR_2ECE_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2ECE_reg))
#define  ATSC_ADDR_2ECE_fs2_parallel_th_5_12_8_shift                             (0)
#define  ATSC_ADDR_2ECE_fs2_parallel_th_5_12_8_mask                              (0x0000001F)
#define  ATSC_ADDR_2ECE_fs2_parallel_th_5_12_8(data)                             (0x0000001F&(data))
#define  ATSC_ADDR_2ECE_get_fs2_parallel_th_5_12_8(data)                         (0x0000001F&(data))

#define  ATSC_ADDR_2ECF                                                         0x18157B3C
#define  ATSC_ADDR_2ECF_reg_addr                                                 "0xB8157B3C"
#define  ATSC_ADDR_2ECF_reg                                                      0xB8157B3C
#define  ATSC_ADDR_2ECF_inst_addr                                                "0x02B4"
#define  set_ATSC_ADDR_2ECF_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2ECF_reg)=data)
#define  get_ATSC_ADDR_2ECF_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2ECF_reg))
#define  ATSC_ADDR_2ECF_fs2_parallel_th_6_7_0_shift                              (0)
#define  ATSC_ADDR_2ECF_fs2_parallel_th_6_7_0_mask                               (0x000000FF)
#define  ATSC_ADDR_2ECF_fs2_parallel_th_6_7_0(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_2ECF_get_fs2_parallel_th_6_7_0(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_2ED0                                                         0x18157B40
#define  ATSC_ADDR_2ED0_reg_addr                                                 "0xB8157B40"
#define  ATSC_ADDR_2ED0_reg                                                      0xB8157B40
#define  ATSC_ADDR_2ED0_inst_addr                                                "0x02B5"
#define  set_ATSC_ADDR_2ED0_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2ED0_reg)=data)
#define  get_ATSC_ADDR_2ED0_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2ED0_reg))
#define  ATSC_ADDR_2ED0_fs2_parallel_th_6_12_8_shift                             (0)
#define  ATSC_ADDR_2ED0_fs2_parallel_th_6_12_8_mask                              (0x0000001F)
#define  ATSC_ADDR_2ED0_fs2_parallel_th_6_12_8(data)                             (0x0000001F&(data))
#define  ATSC_ADDR_2ED0_get_fs2_parallel_th_6_12_8(data)                         (0x0000001F&(data))

#define  ATSC_ADDR_2ED1                                                         0x18157B44
#define  ATSC_ADDR_2ED1_reg_addr                                                 "0xB8157B44"
#define  ATSC_ADDR_2ED1_reg                                                      0xB8157B44
#define  ATSC_ADDR_2ED1_inst_addr                                                "0x02B6"
#define  set_ATSC_ADDR_2ED1_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2ED1_reg)=data)
#define  get_ATSC_ADDR_2ED1_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2ED1_reg))
#define  ATSC_ADDR_2ED1_fs2_parallel_th_7_7_0_shift                              (0)
#define  ATSC_ADDR_2ED1_fs2_parallel_th_7_7_0_mask                               (0x000000FF)
#define  ATSC_ADDR_2ED1_fs2_parallel_th_7_7_0(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_2ED1_get_fs2_parallel_th_7_7_0(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_2ED2                                                         0x18157B48
#define  ATSC_ADDR_2ED2_reg_addr                                                 "0xB8157B48"
#define  ATSC_ADDR_2ED2_reg                                                      0xB8157B48
#define  ATSC_ADDR_2ED2_inst_addr                                                "0x02B7"
#define  set_ATSC_ADDR_2ED2_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2ED2_reg)=data)
#define  get_ATSC_ADDR_2ED2_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2ED2_reg))
#define  ATSC_ADDR_2ED2_fs2_parallel_th_7_12_8_shift                             (0)
#define  ATSC_ADDR_2ED2_fs2_parallel_th_7_12_8_mask                              (0x0000001F)
#define  ATSC_ADDR_2ED2_fs2_parallel_th_7_12_8(data)                             (0x0000001F&(data))
#define  ATSC_ADDR_2ED2_get_fs2_parallel_th_7_12_8(data)                         (0x0000001F&(data))

#define  ATSC_ADDR_2ED3                                                         0x18157B4C
#define  ATSC_ADDR_2ED3_reg_addr                                                 "0xB8157B4C"
#define  ATSC_ADDR_2ED3_reg                                                      0xB8157B4C
#define  ATSC_ADDR_2ED3_inst_addr                                                "0x02B8"
#define  set_ATSC_ADDR_2ED3_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2ED3_reg)=data)
#define  get_ATSC_ADDR_2ED3_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2ED3_reg))
#define  ATSC_ADDR_2ED3_fs2_parallel_addr_ini_7_0_shift                          (0)
#define  ATSC_ADDR_2ED3_fs2_parallel_addr_ini_7_0_mask                           (0x000000FF)
#define  ATSC_ADDR_2ED3_fs2_parallel_addr_ini_7_0(data)                          (0x000000FF&(data))
#define  ATSC_ADDR_2ED3_get_fs2_parallel_addr_ini_7_0(data)                      (0x000000FF&(data))

#define  ATSC_ADDR_2ED4                                                         0x18157B50
#define  ATSC_ADDR_2ED4_reg_addr                                                 "0xB8157B50"
#define  ATSC_ADDR_2ED4_reg                                                      0xB8157B50
#define  ATSC_ADDR_2ED4_inst_addr                                                "0x02B9"
#define  set_ATSC_ADDR_2ED4_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2ED4_reg)=data)
#define  get_ATSC_ADDR_2ED4_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2ED4_reg))
#define  ATSC_ADDR_2ED4_fs2_parallel_addr_ini_11_8_shift                         (0)
#define  ATSC_ADDR_2ED4_fs2_parallel_addr_ini_11_8_mask                          (0x0000000F)
#define  ATSC_ADDR_2ED4_fs2_parallel_addr_ini_11_8(data)                         (0x0000000F&(data))
#define  ATSC_ADDR_2ED4_get_fs2_parallel_addr_ini_11_8(data)                     (0x0000000F&(data))

#define  ATSC_ADDR_2ED5                                                         0x18157B54
#define  ATSC_ADDR_2ED5_reg_addr                                                 "0xB8157B54"
#define  ATSC_ADDR_2ED5_reg                                                      0xB8157B54
#define  ATSC_ADDR_2ED5_inst_addr                                                "0x02BA"
#define  set_ATSC_ADDR_2ED5_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2ED5_reg)=data)
#define  get_ATSC_ADDR_2ED5_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2ED5_reg))
#define  ATSC_ADDR_2ED5_fs2_parallel_main_addr_7_0_shift                         (0)
#define  ATSC_ADDR_2ED5_fs2_parallel_main_addr_7_0_mask                          (0x000000FF)
#define  ATSC_ADDR_2ED5_fs2_parallel_main_addr_7_0(data)                         (0x000000FF&(data))
#define  ATSC_ADDR_2ED5_get_fs2_parallel_main_addr_7_0(data)                     (0x000000FF&(data))

#define  ATSC_ADDR_2ED6                                                         0x18157B58
#define  ATSC_ADDR_2ED6_reg_addr                                                 "0xB8157B58"
#define  ATSC_ADDR_2ED6_reg                                                      0xB8157B58
#define  ATSC_ADDR_2ED6_inst_addr                                                "0x02BB"
#define  set_ATSC_ADDR_2ED6_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2ED6_reg)=data)
#define  get_ATSC_ADDR_2ED6_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2ED6_reg))
#define  ATSC_ADDR_2ED6_fs2_parallel_main_addr_11_8_shift                        (0)
#define  ATSC_ADDR_2ED6_fs2_parallel_main_addr_11_8_mask                         (0x0000000F)
#define  ATSC_ADDR_2ED6_fs2_parallel_main_addr_11_8(data)                        (0x0000000F&(data))
#define  ATSC_ADDR_2ED6_get_fs2_parallel_main_addr_11_8(data)                    (0x0000000F&(data))

#define  ATSC_ADDR_2ED7                                                         0x18157B5C
#define  ATSC_ADDR_2ED7_reg_addr                                                 "0xB8157B5C"
#define  ATSC_ADDR_2ED7_reg                                                      0xB8157B5C
#define  ATSC_ADDR_2ED7_inst_addr                                                "0x02BC"
#define  set_ATSC_ADDR_2ED7_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2ED7_reg)=data)
#define  get_ATSC_ADDR_2ED7_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2ED7_reg))
#define  ATSC_ADDR_2ED7_fsm_segment_counter_opt0_7_0_shift                       (0)
#define  ATSC_ADDR_2ED7_fsm_segment_counter_opt0_7_0_mask                        (0x000000FF)
#define  ATSC_ADDR_2ED7_fsm_segment_counter_opt0_7_0(data)                       (0x000000FF&(data))
#define  ATSC_ADDR_2ED7_get_fsm_segment_counter_opt0_7_0(data)                   (0x000000FF&(data))

#define  ATSC_ADDR_2ED8                                                         0x18157B60
#define  ATSC_ADDR_2ED8_reg_addr                                                 "0xB8157B60"
#define  ATSC_ADDR_2ED8_reg                                                      0xB8157B60
#define  ATSC_ADDR_2ED8_inst_addr                                                "0x02BD"
#define  set_ATSC_ADDR_2ED8_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2ED8_reg)=data)
#define  get_ATSC_ADDR_2ED8_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2ED8_reg))
#define  ATSC_ADDR_2ED8_fsm_segment_counter_opt1_6_0_shift                       (1)
#define  ATSC_ADDR_2ED8_fsm_segment_counter_opt0_8_shift                         (0)
#define  ATSC_ADDR_2ED8_fsm_segment_counter_opt1_6_0_mask                        (0x000000FE)
#define  ATSC_ADDR_2ED8_fsm_segment_counter_opt0_8_mask                          (0x00000001)
#define  ATSC_ADDR_2ED8_fsm_segment_counter_opt1_6_0(data)                       (0x000000FE&((data)<<1))
#define  ATSC_ADDR_2ED8_fsm_segment_counter_opt0_8(data)                         (0x00000001&(data))
#define  ATSC_ADDR_2ED8_get_fsm_segment_counter_opt1_6_0(data)                   ((0x000000FE&(data))>>1)
#define  ATSC_ADDR_2ED8_get_fsm_segment_counter_opt0_8(data)                     (0x00000001&(data))

#define  ATSC_ADDR_2ED9                                                         0x18157B64
#define  ATSC_ADDR_2ED9_reg_addr                                                 "0xB8157B64"
#define  ATSC_ADDR_2ED9_reg                                                      0xB8157B64
#define  ATSC_ADDR_2ED9_inst_addr                                                "0x02BE"
#define  set_ATSC_ADDR_2ED9_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2ED9_reg)=data)
#define  get_ATSC_ADDR_2ED9_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2ED9_reg))
#define  ATSC_ADDR_2ED9_fsm_segment_counter_opt2_5_0_shift                       (2)
#define  ATSC_ADDR_2ED9_fsm_segment_counter_opt1_8_7_shift                       (0)
#define  ATSC_ADDR_2ED9_fsm_segment_counter_opt2_5_0_mask                        (0x000000FC)
#define  ATSC_ADDR_2ED9_fsm_segment_counter_opt1_8_7_mask                        (0x00000003)
#define  ATSC_ADDR_2ED9_fsm_segment_counter_opt2_5_0(data)                       (0x000000FC&((data)<<2))
#define  ATSC_ADDR_2ED9_fsm_segment_counter_opt1_8_7(data)                       (0x00000003&(data))
#define  ATSC_ADDR_2ED9_get_fsm_segment_counter_opt2_5_0(data)                   ((0x000000FC&(data))>>2)
#define  ATSC_ADDR_2ED9_get_fsm_segment_counter_opt1_8_7(data)                   (0x00000003&(data))

#define  ATSC_ADDR_2EDA                                                         0x18157B68
#define  ATSC_ADDR_2EDA_reg_addr                                                 "0xB8157B68"
#define  ATSC_ADDR_2EDA_reg                                                      0xB8157B68
#define  ATSC_ADDR_2EDA_inst_addr                                                "0x02BF"
#define  set_ATSC_ADDR_2EDA_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EDA_reg)=data)
#define  get_ATSC_ADDR_2EDA_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EDA_reg))
#define  ATSC_ADDR_2EDA_fsm_segment_counter_opt3_4_0_shift                       (3)
#define  ATSC_ADDR_2EDA_fsm_segment_counter_opt2_8_6_shift                       (0)
#define  ATSC_ADDR_2EDA_fsm_segment_counter_opt3_4_0_mask                        (0x000000F8)
#define  ATSC_ADDR_2EDA_fsm_segment_counter_opt2_8_6_mask                        (0x00000007)
#define  ATSC_ADDR_2EDA_fsm_segment_counter_opt3_4_0(data)                       (0x000000F8&((data)<<3))
#define  ATSC_ADDR_2EDA_fsm_segment_counter_opt2_8_6(data)                       (0x00000007&(data))
#define  ATSC_ADDR_2EDA_get_fsm_segment_counter_opt3_4_0(data)                   ((0x000000F8&(data))>>3)
#define  ATSC_ADDR_2EDA_get_fsm_segment_counter_opt2_8_6(data)                   (0x00000007&(data))

#define  ATSC_ADDR_2EDB                                                         0x18157B6C
#define  ATSC_ADDR_2EDB_reg_addr                                                 "0xB8157B6C"
#define  ATSC_ADDR_2EDB_reg                                                      0xB8157B6C
#define  ATSC_ADDR_2EDB_inst_addr                                                "0x02C0"
#define  set_ATSC_ADDR_2EDB_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EDB_reg)=data)
#define  get_ATSC_ADDR_2EDB_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EDB_reg))
#define  ATSC_ADDR_2EDB_fsm_symbol_counter_opt0_3_0_shift                        (4)
#define  ATSC_ADDR_2EDB_fsm_segment_counter_opt3_8_5_shift                       (0)
#define  ATSC_ADDR_2EDB_fsm_symbol_counter_opt0_3_0_mask                         (0x000000F0)
#define  ATSC_ADDR_2EDB_fsm_segment_counter_opt3_8_5_mask                        (0x0000000F)
#define  ATSC_ADDR_2EDB_fsm_symbol_counter_opt0_3_0(data)                        (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2EDB_fsm_segment_counter_opt3_8_5(data)                       (0x0000000F&(data))
#define  ATSC_ADDR_2EDB_get_fsm_symbol_counter_opt0_3_0(data)                    ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2EDB_get_fsm_segment_counter_opt3_8_5(data)                   (0x0000000F&(data))

#define  ATSC_ADDR_2EDC                                                         0x18157B70
#define  ATSC_ADDR_2EDC_reg_addr                                                 "0xB8157B70"
#define  ATSC_ADDR_2EDC_reg                                                      0xB8157B70
#define  ATSC_ADDR_2EDC_inst_addr                                                "0x02C1"
#define  set_ATSC_ADDR_2EDC_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EDC_reg)=data)
#define  get_ATSC_ADDR_2EDC_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EDC_reg))
#define  ATSC_ADDR_2EDC_fsm_symbol_counter_opt1_1_0_shift                        (6)
#define  ATSC_ADDR_2EDC_fsm_symbol_counter_opt0_9_4_shift                        (0)
#define  ATSC_ADDR_2EDC_fsm_symbol_counter_opt1_1_0_mask                         (0x000000C0)
#define  ATSC_ADDR_2EDC_fsm_symbol_counter_opt0_9_4_mask                         (0x0000003F)
#define  ATSC_ADDR_2EDC_fsm_symbol_counter_opt1_1_0(data)                        (0x000000C0&((data)<<6))
#define  ATSC_ADDR_2EDC_fsm_symbol_counter_opt0_9_4(data)                        (0x0000003F&(data))
#define  ATSC_ADDR_2EDC_get_fsm_symbol_counter_opt1_1_0(data)                    ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_2EDC_get_fsm_symbol_counter_opt0_9_4(data)                    (0x0000003F&(data))

#define  ATSC_ADDR_2EDD                                                         0x18157B74
#define  ATSC_ADDR_2EDD_reg_addr                                                 "0xB8157B74"
#define  ATSC_ADDR_2EDD_reg                                                      0xB8157B74
#define  ATSC_ADDR_2EDD_inst_addr                                                "0x02C2"
#define  set_ATSC_ADDR_2EDD_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EDD_reg)=data)
#define  get_ATSC_ADDR_2EDD_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EDD_reg))
#define  ATSC_ADDR_2EDD_fsm_symbol_counter_opt1_9_2_shift                        (0)
#define  ATSC_ADDR_2EDD_fsm_symbol_counter_opt1_9_2_mask                         (0x000000FF)
#define  ATSC_ADDR_2EDD_fsm_symbol_counter_opt1_9_2(data)                        (0x000000FF&(data))
#define  ATSC_ADDR_2EDD_get_fsm_symbol_counter_opt1_9_2(data)                    (0x000000FF&(data))

#define  ATSC_ADDR_2EDE                                                         0x18157B78
#define  ATSC_ADDR_2EDE_reg_addr                                                 "0xB8157B78"
#define  ATSC_ADDR_2EDE_reg                                                      0xB8157B78
#define  ATSC_ADDR_2EDE_inst_addr                                                "0x02C3"
#define  set_ATSC_ADDR_2EDE_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EDE_reg)=data)
#define  get_ATSC_ADDR_2EDE_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EDE_reg))
#define  ATSC_ADDR_2EDE_fsm_symbol_counter_opt2_7_0_shift                        (0)
#define  ATSC_ADDR_2EDE_fsm_symbol_counter_opt2_7_0_mask                         (0x000000FF)
#define  ATSC_ADDR_2EDE_fsm_symbol_counter_opt2_7_0(data)                        (0x000000FF&(data))
#define  ATSC_ADDR_2EDE_get_fsm_symbol_counter_opt2_7_0(data)                    (0x000000FF&(data))

#define  ATSC_ADDR_2EDF                                                         0x18157B7C
#define  ATSC_ADDR_2EDF_reg_addr                                                 "0xB8157B7C"
#define  ATSC_ADDR_2EDF_reg                                                      0xB8157B7C
#define  ATSC_ADDR_2EDF_inst_addr                                                "0x02C4"
#define  set_ATSC_ADDR_2EDF_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EDF_reg)=data)
#define  get_ATSC_ADDR_2EDF_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EDF_reg))
#define  ATSC_ADDR_2EDF_fsm_symbol_counter_opt3_5_0_shift                        (2)
#define  ATSC_ADDR_2EDF_fsm_symbol_counter_opt2_9_8_shift                        (0)
#define  ATSC_ADDR_2EDF_fsm_symbol_counter_opt3_5_0_mask                         (0x000000FC)
#define  ATSC_ADDR_2EDF_fsm_symbol_counter_opt2_9_8_mask                         (0x00000003)
#define  ATSC_ADDR_2EDF_fsm_symbol_counter_opt3_5_0(data)                        (0x000000FC&((data)<<2))
#define  ATSC_ADDR_2EDF_fsm_symbol_counter_opt2_9_8(data)                        (0x00000003&(data))
#define  ATSC_ADDR_2EDF_get_fsm_symbol_counter_opt3_5_0(data)                    ((0x000000FC&(data))>>2)
#define  ATSC_ADDR_2EDF_get_fsm_symbol_counter_opt2_9_8(data)                    (0x00000003&(data))

#define  ATSC_ADDR_2EE0                                                         0x18157B80
#define  ATSC_ADDR_2EE0_reg_addr                                                 "0xB8157B80"
#define  ATSC_ADDR_2EE0_reg                                                      0xB8157B80
#define  ATSC_ADDR_2EE0_inst_addr                                                "0x02C5"
#define  set_ATSC_ADDR_2EE0_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EE0_reg)=data)
#define  get_ATSC_ADDR_2EE0_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EE0_reg))
#define  ATSC_ADDR_2EE0_fsm_symbol_counter_opt3_9_6_shift                        (0)
#define  ATSC_ADDR_2EE0_fsm_symbol_counter_opt3_9_6_mask                         (0x0000000F)
#define  ATSC_ADDR_2EE0_fsm_symbol_counter_opt3_9_6(data)                        (0x0000000F&(data))
#define  ATSC_ADDR_2EE0_get_fsm_symbol_counter_opt3_9_6(data)                    (0x0000000F&(data))

#define  ATSC_ADDR_2EE1                                                         0x18157B84
#define  ATSC_ADDR_2EE1_reg_addr                                                 "0xB8157B84"
#define  ATSC_ADDR_2EE1_reg                                                      0xB8157B84
#define  ATSC_ADDR_2EE1_inst_addr                                                "0x02C6"
#define  set_ATSC_ADDR_2EE1_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EE1_reg)=data)
#define  get_ATSC_ADDR_2EE1_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EE1_reg))
#define  ATSC_ADDR_2EE1_field_sync_lock_delay_opt0_7_0_shift                     (0)
#define  ATSC_ADDR_2EE1_field_sync_lock_delay_opt0_7_0_mask                      (0x000000FF)
#define  ATSC_ADDR_2EE1_field_sync_lock_delay_opt0_7_0(data)                     (0x000000FF&(data))
#define  ATSC_ADDR_2EE1_get_field_sync_lock_delay_opt0_7_0(data)                 (0x000000FF&(data))

#define  ATSC_ADDR_2EE2                                                         0x18157B88
#define  ATSC_ADDR_2EE2_reg_addr                                                 "0xB8157B88"
#define  ATSC_ADDR_2EE2_reg                                                      0xB8157B88
#define  ATSC_ADDR_2EE2_inst_addr                                                "0x02C7"
#define  set_ATSC_ADDR_2EE2_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EE2_reg)=data)
#define  get_ATSC_ADDR_2EE2_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EE2_reg))
#define  ATSC_ADDR_2EE2_field_sync_lock_delay_opt0_15_8_shift                    (0)
#define  ATSC_ADDR_2EE2_field_sync_lock_delay_opt0_15_8_mask                     (0x000000FF)
#define  ATSC_ADDR_2EE2_field_sync_lock_delay_opt0_15_8(data)                    (0x000000FF&(data))
#define  ATSC_ADDR_2EE2_get_field_sync_lock_delay_opt0_15_8(data)                (0x000000FF&(data))

#define  ATSC_ADDR_2EE3                                                         0x18157B8C
#define  ATSC_ADDR_2EE3_reg_addr                                                 "0xB8157B8C"
#define  ATSC_ADDR_2EE3_reg                                                      0xB8157B8C
#define  ATSC_ADDR_2EE3_inst_addr                                                "0x02C8"
#define  set_ATSC_ADDR_2EE3_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EE3_reg)=data)
#define  get_ATSC_ADDR_2EE3_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EE3_reg))
#define  ATSC_ADDR_2EE3_field_sync_lock_delay_opt1_7_0_shift                     (0)
#define  ATSC_ADDR_2EE3_field_sync_lock_delay_opt1_7_0_mask                      (0x000000FF)
#define  ATSC_ADDR_2EE3_field_sync_lock_delay_opt1_7_0(data)                     (0x000000FF&(data))
#define  ATSC_ADDR_2EE3_get_field_sync_lock_delay_opt1_7_0(data)                 (0x000000FF&(data))

#define  ATSC_ADDR_2EE4                                                         0x18157B90
#define  ATSC_ADDR_2EE4_reg_addr                                                 "0xB8157B90"
#define  ATSC_ADDR_2EE4_reg                                                      0xB8157B90
#define  ATSC_ADDR_2EE4_inst_addr                                                "0x02C9"
#define  set_ATSC_ADDR_2EE4_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EE4_reg)=data)
#define  get_ATSC_ADDR_2EE4_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EE4_reg))
#define  ATSC_ADDR_2EE4_field_sync_lock_delay_opt1_15_8_shift                    (0)
#define  ATSC_ADDR_2EE4_field_sync_lock_delay_opt1_15_8_mask                     (0x000000FF)
#define  ATSC_ADDR_2EE4_field_sync_lock_delay_opt1_15_8(data)                    (0x000000FF&(data))
#define  ATSC_ADDR_2EE4_get_field_sync_lock_delay_opt1_15_8(data)                (0x000000FF&(data))

#define  ATSC_ADDR_2EE5                                                         0x18157B94
#define  ATSC_ADDR_2EE5_reg_addr                                                 "0xB8157B94"
#define  ATSC_ADDR_2EE5_reg                                                      0xB8157B94
#define  ATSC_ADDR_2EE5_inst_addr                                                "0x02CA"
#define  set_ATSC_ADDR_2EE5_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EE5_reg)=data)
#define  get_ATSC_ADDR_2EE5_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EE5_reg))
#define  ATSC_ADDR_2EE5_field_sync_lock_delay_opt2_7_0_shift                     (0)
#define  ATSC_ADDR_2EE5_field_sync_lock_delay_opt2_7_0_mask                      (0x000000FF)
#define  ATSC_ADDR_2EE5_field_sync_lock_delay_opt2_7_0(data)                     (0x000000FF&(data))
#define  ATSC_ADDR_2EE5_get_field_sync_lock_delay_opt2_7_0(data)                 (0x000000FF&(data))

#define  ATSC_ADDR_2EE6                                                         0x18157B98
#define  ATSC_ADDR_2EE6_reg_addr                                                 "0xB8157B98"
#define  ATSC_ADDR_2EE6_reg                                                      0xB8157B98
#define  ATSC_ADDR_2EE6_inst_addr                                                "0x02CB"
#define  set_ATSC_ADDR_2EE6_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EE6_reg)=data)
#define  get_ATSC_ADDR_2EE6_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EE6_reg))
#define  ATSC_ADDR_2EE6_field_sync_lock_delay_opt2_15_8_shift                    (0)
#define  ATSC_ADDR_2EE6_field_sync_lock_delay_opt2_15_8_mask                     (0x000000FF)
#define  ATSC_ADDR_2EE6_field_sync_lock_delay_opt2_15_8(data)                    (0x000000FF&(data))
#define  ATSC_ADDR_2EE6_get_field_sync_lock_delay_opt2_15_8(data)                (0x000000FF&(data))

#define  ATSC_ADDR_2EE7                                                         0x18157B9C
#define  ATSC_ADDR_2EE7_reg_addr                                                 "0xB8157B9C"
#define  ATSC_ADDR_2EE7_reg                                                      0xB8157B9C
#define  ATSC_ADDR_2EE7_inst_addr                                                "0x02CC"
#define  set_ATSC_ADDR_2EE7_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EE7_reg)=data)
#define  get_ATSC_ADDR_2EE7_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EE7_reg))
#define  ATSC_ADDR_2EE7_field_sync_lock_delay_opt3_7_0_shift                     (0)
#define  ATSC_ADDR_2EE7_field_sync_lock_delay_opt3_7_0_mask                      (0x000000FF)
#define  ATSC_ADDR_2EE7_field_sync_lock_delay_opt3_7_0(data)                     (0x000000FF&(data))
#define  ATSC_ADDR_2EE7_get_field_sync_lock_delay_opt3_7_0(data)                 (0x000000FF&(data))

#define  ATSC_ADDR_2EE8                                                         0x18157BA0
#define  ATSC_ADDR_2EE8_reg_addr                                                 "0xB8157BA0"
#define  ATSC_ADDR_2EE8_reg                                                      0xB8157BA0
#define  ATSC_ADDR_2EE8_inst_addr                                                "0x02CD"
#define  set_ATSC_ADDR_2EE8_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EE8_reg)=data)
#define  get_ATSC_ADDR_2EE8_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EE8_reg))
#define  ATSC_ADDR_2EE8_field_sync_lock_delay_opt3_15_8_shift                    (0)
#define  ATSC_ADDR_2EE8_field_sync_lock_delay_opt3_15_8_mask                     (0x000000FF)
#define  ATSC_ADDR_2EE8_field_sync_lock_delay_opt3_15_8(data)                    (0x000000FF&(data))
#define  ATSC_ADDR_2EE8_get_field_sync_lock_delay_opt3_15_8(data)                (0x000000FF&(data))

#define  ATSC_ADDR_2EE9                                                         0x18157BA4
#define  ATSC_ADDR_2EE9_reg_addr                                                 "0xB8157BA4"
#define  ATSC_ADDR_2EE9_reg                                                      0xB8157BA4
#define  ATSC_ADDR_2EE9_inst_addr                                                "0x02CE"
#define  set_ATSC_ADDR_2EE9_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EE9_reg)=data)
#define  get_ATSC_ADDR_2EE9_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EE9_reg))
#define  ATSC_ADDR_2EE9_ffe_main_head_opt0_7_0_shift                             (0)
#define  ATSC_ADDR_2EE9_ffe_main_head_opt0_7_0_mask                              (0x000000FF)
#define  ATSC_ADDR_2EE9_ffe_main_head_opt0_7_0(data)                             (0x000000FF&(data))
#define  ATSC_ADDR_2EE9_get_ffe_main_head_opt0_7_0(data)                         (0x000000FF&(data))

#define  ATSC_ADDR_2EEA                                                         0x18157BA8
#define  ATSC_ADDR_2EEA_reg_addr                                                 "0xB8157BA8"
#define  ATSC_ADDR_2EEA_reg                                                      0xB8157BA8
#define  ATSC_ADDR_2EEA_inst_addr                                                "0x02CF"
#define  set_ATSC_ADDR_2EEA_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EEA_reg)=data)
#define  get_ATSC_ADDR_2EEA_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EEA_reg))
#define  ATSC_ADDR_2EEA_ffe_main_head_opt1_6_0_shift                             (1)
#define  ATSC_ADDR_2EEA_ffe_main_head_opt0_8_shift                               (0)
#define  ATSC_ADDR_2EEA_ffe_main_head_opt1_6_0_mask                              (0x000000FE)
#define  ATSC_ADDR_2EEA_ffe_main_head_opt0_8_mask                                (0x00000001)
#define  ATSC_ADDR_2EEA_ffe_main_head_opt1_6_0(data)                             (0x000000FE&((data)<<1))
#define  ATSC_ADDR_2EEA_ffe_main_head_opt0_8(data)                               (0x00000001&(data))
#define  ATSC_ADDR_2EEA_get_ffe_main_head_opt1_6_0(data)                         ((0x000000FE&(data))>>1)
#define  ATSC_ADDR_2EEA_get_ffe_main_head_opt0_8(data)                           (0x00000001&(data))

#define  ATSC_ADDR_2EEB                                                         0x18157BAC
#define  ATSC_ADDR_2EEB_reg_addr                                                 "0xB8157BAC"
#define  ATSC_ADDR_2EEB_reg                                                      0xB8157BAC
#define  ATSC_ADDR_2EEB_inst_addr                                                "0x02D0"
#define  set_ATSC_ADDR_2EEB_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EEB_reg)=data)
#define  get_ATSC_ADDR_2EEB_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EEB_reg))
#define  ATSC_ADDR_2EEB_ffe_main_head_opt2_5_0_shift                             (2)
#define  ATSC_ADDR_2EEB_ffe_main_head_opt1_8_7_shift                             (0)
#define  ATSC_ADDR_2EEB_ffe_main_head_opt2_5_0_mask                              (0x000000FC)
#define  ATSC_ADDR_2EEB_ffe_main_head_opt1_8_7_mask                              (0x00000003)
#define  ATSC_ADDR_2EEB_ffe_main_head_opt2_5_0(data)                             (0x000000FC&((data)<<2))
#define  ATSC_ADDR_2EEB_ffe_main_head_opt1_8_7(data)                             (0x00000003&(data))
#define  ATSC_ADDR_2EEB_get_ffe_main_head_opt2_5_0(data)                         ((0x000000FC&(data))>>2)
#define  ATSC_ADDR_2EEB_get_ffe_main_head_opt1_8_7(data)                         (0x00000003&(data))

#define  ATSC_ADDR_2EEC                                                         0x18157BB0
#define  ATSC_ADDR_2EEC_reg_addr                                                 "0xB8157BB0"
#define  ATSC_ADDR_2EEC_reg                                                      0xB8157BB0
#define  ATSC_ADDR_2EEC_inst_addr                                                "0x02D1"
#define  set_ATSC_ADDR_2EEC_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EEC_reg)=data)
#define  get_ATSC_ADDR_2EEC_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EEC_reg))
#define  ATSC_ADDR_2EEC_ffe_main_head_opt3_4_0_shift                             (3)
#define  ATSC_ADDR_2EEC_ffe_main_head_opt2_8_6_shift                             (0)
#define  ATSC_ADDR_2EEC_ffe_main_head_opt3_4_0_mask                              (0x000000F8)
#define  ATSC_ADDR_2EEC_ffe_main_head_opt2_8_6_mask                              (0x00000007)
#define  ATSC_ADDR_2EEC_ffe_main_head_opt3_4_0(data)                             (0x000000F8&((data)<<3))
#define  ATSC_ADDR_2EEC_ffe_main_head_opt2_8_6(data)                             (0x00000007&(data))
#define  ATSC_ADDR_2EEC_get_ffe_main_head_opt3_4_0(data)                         ((0x000000F8&(data))>>3)
#define  ATSC_ADDR_2EEC_get_ffe_main_head_opt2_8_6(data)                         (0x00000007&(data))

#define  ATSC_ADDR_2EED                                                         0x18157BB4
#define  ATSC_ADDR_2EED_reg_addr                                                 "0xB8157BB4"
#define  ATSC_ADDR_2EED_reg                                                      0xB8157BB4
#define  ATSC_ADDR_2EED_inst_addr                                                "0x02D2"
#define  set_ATSC_ADDR_2EED_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EED_reg)=data)
#define  get_ATSC_ADDR_2EED_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EED_reg))
#define  ATSC_ADDR_2EED_ffe_main_head_opt3_8_5_shift                             (0)
#define  ATSC_ADDR_2EED_ffe_main_head_opt3_8_5_mask                              (0x0000000F)
#define  ATSC_ADDR_2EED_ffe_main_head_opt3_8_5(data)                             (0x0000000F&(data))
#define  ATSC_ADDR_2EED_get_ffe_main_head_opt3_8_5(data)                         (0x0000000F&(data))

#define  ATSC_ADDR_2EEE                                                         0x18157BB8
#define  ATSC_ADDR_2EEE_reg_addr                                                 "0xB8157BB8"
#define  ATSC_ADDR_2EEE_reg                                                      0xB8157BB8
#define  ATSC_ADDR_2EEE_inst_addr                                                "0x02D3"
#define  set_ATSC_ADDR_2EEE_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EEE_reg)=data)
#define  get_ATSC_ADDR_2EEE_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EEE_reg))
#define  ATSC_ADDR_2EEE_ffe_main_end_opt0_7_0_shift                              (0)
#define  ATSC_ADDR_2EEE_ffe_main_end_opt0_7_0_mask                               (0x000000FF)
#define  ATSC_ADDR_2EEE_ffe_main_end_opt0_7_0(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_2EEE_get_ffe_main_end_opt0_7_0(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_2EEF                                                         0x18157BBC
#define  ATSC_ADDR_2EEF_reg_addr                                                 "0xB8157BBC"
#define  ATSC_ADDR_2EEF_reg                                                      0xB8157BBC
#define  ATSC_ADDR_2EEF_inst_addr                                                "0x02D4"
#define  set_ATSC_ADDR_2EEF_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EEF_reg)=data)
#define  get_ATSC_ADDR_2EEF_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EEF_reg))
#define  ATSC_ADDR_2EEF_ffe_main_end_opt1_6_0_shift                              (1)
#define  ATSC_ADDR_2EEF_ffe_main_end_opt0_8_shift                                (0)
#define  ATSC_ADDR_2EEF_ffe_main_end_opt1_6_0_mask                               (0x000000FE)
#define  ATSC_ADDR_2EEF_ffe_main_end_opt0_8_mask                                 (0x00000001)
#define  ATSC_ADDR_2EEF_ffe_main_end_opt1_6_0(data)                              (0x000000FE&((data)<<1))
#define  ATSC_ADDR_2EEF_ffe_main_end_opt0_8(data)                                (0x00000001&(data))
#define  ATSC_ADDR_2EEF_get_ffe_main_end_opt1_6_0(data)                          ((0x000000FE&(data))>>1)
#define  ATSC_ADDR_2EEF_get_ffe_main_end_opt0_8(data)                            (0x00000001&(data))

#define  ATSC_ADDR_2EF0                                                         0x18157BC0
#define  ATSC_ADDR_2EF0_reg_addr                                                 "0xB8157BC0"
#define  ATSC_ADDR_2EF0_reg                                                      0xB8157BC0
#define  ATSC_ADDR_2EF0_inst_addr                                                "0x02D5"
#define  set_ATSC_ADDR_2EF0_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EF0_reg)=data)
#define  get_ATSC_ADDR_2EF0_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EF0_reg))
#define  ATSC_ADDR_2EF0_ffe_main_end_opt2_5_0_shift                              (2)
#define  ATSC_ADDR_2EF0_ffe_main_end_opt1_8_7_shift                              (0)
#define  ATSC_ADDR_2EF0_ffe_main_end_opt2_5_0_mask                               (0x000000FC)
#define  ATSC_ADDR_2EF0_ffe_main_end_opt1_8_7_mask                               (0x00000003)
#define  ATSC_ADDR_2EF0_ffe_main_end_opt2_5_0(data)                              (0x000000FC&((data)<<2))
#define  ATSC_ADDR_2EF0_ffe_main_end_opt1_8_7(data)                              (0x00000003&(data))
#define  ATSC_ADDR_2EF0_get_ffe_main_end_opt2_5_0(data)                          ((0x000000FC&(data))>>2)
#define  ATSC_ADDR_2EF0_get_ffe_main_end_opt1_8_7(data)                          (0x00000003&(data))

#define  ATSC_ADDR_2EF1                                                         0x18157BC4
#define  ATSC_ADDR_2EF1_reg_addr                                                 "0xB8157BC4"
#define  ATSC_ADDR_2EF1_reg                                                      0xB8157BC4
#define  ATSC_ADDR_2EF1_inst_addr                                                "0x02D6"
#define  set_ATSC_ADDR_2EF1_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EF1_reg)=data)
#define  get_ATSC_ADDR_2EF1_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EF1_reg))
#define  ATSC_ADDR_2EF1_ffe_main_end_opt3_4_0_shift                              (3)
#define  ATSC_ADDR_2EF1_ffe_main_end_opt2_8_6_shift                              (0)
#define  ATSC_ADDR_2EF1_ffe_main_end_opt3_4_0_mask                               (0x000000F8)
#define  ATSC_ADDR_2EF1_ffe_main_end_opt2_8_6_mask                               (0x00000007)
#define  ATSC_ADDR_2EF1_ffe_main_end_opt3_4_0(data)                              (0x000000F8&((data)<<3))
#define  ATSC_ADDR_2EF1_ffe_main_end_opt2_8_6(data)                              (0x00000007&(data))
#define  ATSC_ADDR_2EF1_get_ffe_main_end_opt3_4_0(data)                          ((0x000000F8&(data))>>3)
#define  ATSC_ADDR_2EF1_get_ffe_main_end_opt2_8_6(data)                          (0x00000007&(data))

#define  ATSC_ADDR_2EF2                                                         0x18157BC8
#define  ATSC_ADDR_2EF2_reg_addr                                                 "0xB8157BC8"
#define  ATSC_ADDR_2EF2_reg                                                      0xB8157BC8
#define  ATSC_ADDR_2EF2_inst_addr                                                "0x02D7"
#define  set_ATSC_ADDR_2EF2_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EF2_reg)=data)
#define  get_ATSC_ADDR_2EF2_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EF2_reg))
#define  ATSC_ADDR_2EF2_ffe_main_end_opt3_8_5_shift                              (0)
#define  ATSC_ADDR_2EF2_ffe_main_end_opt3_8_5_mask                               (0x0000000F)
#define  ATSC_ADDR_2EF2_ffe_main_end_opt3_8_5(data)                              (0x0000000F&(data))
#define  ATSC_ADDR_2EF2_get_ffe_main_end_opt3_8_5(data)                          (0x0000000F&(data))

#define  ATSC_ADDR_2EF3                                                         0x18157BCC
#define  ATSC_ADDR_2EF3_reg_addr                                                 "0xB8157BCC"
#define  ATSC_ADDR_2EF3_reg                                                      0xB8157BCC
#define  ATSC_ADDR_2EF3_inst_addr                                                "0x02D8"
#define  set_ATSC_ADDR_2EF3_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EF3_reg)=data)
#define  get_ATSC_ADDR_2EF3_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EF3_reg))
#define  ATSC_ADDR_2EF3_fs2_force_main_width_exp_shift                           (0)
#define  ATSC_ADDR_2EF3_fs2_force_main_width_exp_mask                            (0x00000007)
#define  ATSC_ADDR_2EF3_fs2_force_main_width_exp(data)                           (0x00000007&(data))
#define  ATSC_ADDR_2EF3_get_fs2_force_main_width_exp(data)                       (0x00000007&(data))

#define  ATSC_ADDR_2078                                                         0x181541E0
#define  ATSC_ADDR_2078_reg_addr                                                 "0xB81541E0"
#define  ATSC_ADDR_2078_reg                                                      0xB81541E0
#define  ATSC_ADDR_2078_inst_addr                                                "0x02D9"
#define  set_ATSC_ADDR_2078_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2078_reg)=data)
#define  get_ATSC_ADDR_2078_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2078_reg))
#define  ATSC_ADDR_2078_fs2_precursor_opt0_7_0_shift                             (0)
#define  ATSC_ADDR_2078_fs2_precursor_opt0_7_0_mask                              (0x000000FF)
#define  ATSC_ADDR_2078_fs2_precursor_opt0_7_0(data)                             (0x000000FF&(data))
#define  ATSC_ADDR_2078_get_fs2_precursor_opt0_7_0(data)                         (0x000000FF&(data))

#define  ATSC_ADDR_2079                                                         0x181541E4
#define  ATSC_ADDR_2079_reg_addr                                                 "0xB81541E4"
#define  ATSC_ADDR_2079_reg                                                      0xB81541E4
#define  ATSC_ADDR_2079_inst_addr                                                "0x02DA"
#define  set_ATSC_ADDR_2079_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2079_reg)=data)
#define  get_ATSC_ADDR_2079_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2079_reg))
#define  ATSC_ADDR_2079_fs2_precursor_opt1_3_0_shift                             (4)
#define  ATSC_ADDR_2079_fs2_precursor_opt0_11_8_shift                            (0)
#define  ATSC_ADDR_2079_fs2_precursor_opt1_3_0_mask                              (0x000000F0)
#define  ATSC_ADDR_2079_fs2_precursor_opt0_11_8_mask                             (0x0000000F)
#define  ATSC_ADDR_2079_fs2_precursor_opt1_3_0(data)                             (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2079_fs2_precursor_opt0_11_8(data)                            (0x0000000F&(data))
#define  ATSC_ADDR_2079_get_fs2_precursor_opt1_3_0(data)                         ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2079_get_fs2_precursor_opt0_11_8(data)                        (0x0000000F&(data))

#define  ATSC_ADDR_207A                                                         0x181541E8
#define  ATSC_ADDR_207A_reg_addr                                                 "0xB81541E8"
#define  ATSC_ADDR_207A_reg                                                      0xB81541E8
#define  ATSC_ADDR_207A_inst_addr                                                "0x02DB"
#define  set_ATSC_ADDR_207A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_207A_reg)=data)
#define  get_ATSC_ADDR_207A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_207A_reg))
#define  ATSC_ADDR_207A_fs2_precursor_opt1_11_4_shift                            (0)
#define  ATSC_ADDR_207A_fs2_precursor_opt1_11_4_mask                             (0x000000FF)
#define  ATSC_ADDR_207A_fs2_precursor_opt1_11_4(data)                            (0x000000FF&(data))
#define  ATSC_ADDR_207A_get_fs2_precursor_opt1_11_4(data)                        (0x000000FF&(data))

#define  ATSC_ADDR_207B                                                         0x181541EC
#define  ATSC_ADDR_207B_reg_addr                                                 "0xB81541EC"
#define  ATSC_ADDR_207B_reg                                                      0xB81541EC
#define  ATSC_ADDR_207B_inst_addr                                                "0x02DC"
#define  set_ATSC_ADDR_207B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_207B_reg)=data)
#define  get_ATSC_ADDR_207B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_207B_reg))
#define  ATSC_ADDR_207B_fs2_precursor_opt2_7_0_shift                             (0)
#define  ATSC_ADDR_207B_fs2_precursor_opt2_7_0_mask                              (0x000000FF)
#define  ATSC_ADDR_207B_fs2_precursor_opt2_7_0(data)                             (0x000000FF&(data))
#define  ATSC_ADDR_207B_get_fs2_precursor_opt2_7_0(data)                         (0x000000FF&(data))

#define  ATSC_ADDR_207C                                                         0x181541F0
#define  ATSC_ADDR_207C_reg_addr                                                 "0xB81541F0"
#define  ATSC_ADDR_207C_reg                                                      0xB81541F0
#define  ATSC_ADDR_207C_inst_addr                                                "0x02DD"
#define  set_ATSC_ADDR_207C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_207C_reg)=data)
#define  get_ATSC_ADDR_207C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_207C_reg))
#define  ATSC_ADDR_207C_fs2_precursor_opt3_3_0_shift                             (4)
#define  ATSC_ADDR_207C_fs2_precursor_opt2_11_8_shift                            (0)
#define  ATSC_ADDR_207C_fs2_precursor_opt3_3_0_mask                              (0x000000F0)
#define  ATSC_ADDR_207C_fs2_precursor_opt2_11_8_mask                             (0x0000000F)
#define  ATSC_ADDR_207C_fs2_precursor_opt3_3_0(data)                             (0x000000F0&((data)<<4))
#define  ATSC_ADDR_207C_fs2_precursor_opt2_11_8(data)                            (0x0000000F&(data))
#define  ATSC_ADDR_207C_get_fs2_precursor_opt3_3_0(data)                         ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_207C_get_fs2_precursor_opt2_11_8(data)                        (0x0000000F&(data))

#define  ATSC_ADDR_207D                                                         0x181541F4
#define  ATSC_ADDR_207D_reg_addr                                                 "0xB81541F4"
#define  ATSC_ADDR_207D_reg                                                      0xB81541F4
#define  ATSC_ADDR_207D_inst_addr                                                "0x02DE"
#define  set_ATSC_ADDR_207D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_207D_reg)=data)
#define  get_ATSC_ADDR_207D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_207D_reg))
#define  ATSC_ADDR_207D_fs2_precursor_opt3_11_4_shift                            (0)
#define  ATSC_ADDR_207D_fs2_precursor_opt3_11_4_mask                             (0x000000FF)
#define  ATSC_ADDR_207D_fs2_precursor_opt3_11_4(data)                            (0x000000FF&(data))
#define  ATSC_ADDR_207D_get_fs2_precursor_opt3_11_4(data)                        (0x000000FF&(data))

#define  ATSC_ADDR_2EF8                                                         0x18157BE0
#define  ATSC_ADDR_2EF8_reg_addr                                                 "0xB8157BE0"
#define  ATSC_ADDR_2EF8_reg                                                      0xB8157BE0
#define  ATSC_ADDR_2EF8_inst_addr                                                "0x02DF"
#define  set_ATSC_ADDR_2EF8_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EF8_reg)=data)
#define  get_ATSC_ADDR_2EF8_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EF8_reg))
#define  ATSC_ADDR_2EF8_cr_adp_state_clear_en_shift                              (5)
#define  ATSC_ADDR_2EF8_cr_adp_bw_en_shift                                       (4)
#define  ATSC_ADDR_2EF8_cr_adp_bw_cr_offset_dif_cond_32_shift                    (0)
#define  ATSC_ADDR_2EF8_cr_adp_state_clear_en_mask                               (0x00000020)
#define  ATSC_ADDR_2EF8_cr_adp_bw_en_mask                                        (0x00000010)
#define  ATSC_ADDR_2EF8_cr_adp_bw_cr_offset_dif_cond_32_mask                     (0x00000001)
#define  ATSC_ADDR_2EF8_cr_adp_state_clear_en(data)                              (0x00000020&((data)<<5))
#define  ATSC_ADDR_2EF8_cr_adp_bw_en(data)                                       (0x00000010&((data)<<4))
#define  ATSC_ADDR_2EF8_cr_adp_bw_cr_offset_dif_cond_32(data)                    (0x00000001&(data))
#define  ATSC_ADDR_2EF8_get_cr_adp_state_clear_en(data)                          ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2EF8_get_cr_adp_bw_en(data)                                   ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2EF8_get_cr_adp_bw_cr_offset_dif_cond_32(data)                (0x00000001&(data))

#define  ATSC_ADDR_2EF9                                                         0x18157BE4
#define  ATSC_ADDR_2EF9_reg_addr                                                 "0xB8157BE4"
#define  ATSC_ADDR_2EF9_reg                                                      0xB8157BE4
#define  ATSC_ADDR_2EF9_inst_addr                                                "0x02E0"
#define  set_ATSC_ADDR_2EF9_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EF9_reg)=data)
#define  get_ATSC_ADDR_2EF9_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EF9_reg))
#define  ATSC_ADDR_2EF9_cr_adp_bw_react_state_shift                              (0)
#define  ATSC_ADDR_2EF9_cr_adp_bw_react_state_mask                               (0x0000003F)
#define  ATSC_ADDR_2EF9_cr_adp_bw_react_state(data)                              (0x0000003F&(data))
#define  ATSC_ADDR_2EF9_get_cr_adp_bw_react_state(data)                          (0x0000003F&(data))

#define  ATSC_ADDR_2EFA                                                         0x18157BE8
#define  ATSC_ADDR_2EFA_reg_addr                                                 "0xB8157BE8"
#define  ATSC_ADDR_2EFA_reg                                                      0xB8157BE8
#define  ATSC_ADDR_2EFA_inst_addr                                                "0x02E1"
#define  set_ATSC_ADDR_2EFA_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EFA_reg)=data)
#define  get_ATSC_ADDR_2EFA_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EFA_reg))
#define  ATSC_ADDR_2EFA_cr_adp_bw_start_state_shift                              (0)
#define  ATSC_ADDR_2EFA_cr_adp_bw_start_state_mask                               (0x0000003F)
#define  ATSC_ADDR_2EFA_cr_adp_bw_start_state(data)                              (0x0000003F&(data))
#define  ATSC_ADDR_2EFA_get_cr_adp_bw_start_state(data)                          (0x0000003F&(data))

#define  ATSC_ADDR_2EFB                                                         0x18157BEC
#define  ATSC_ADDR_2EFB_reg_addr                                                 "0xB8157BEC"
#define  ATSC_ADDR_2EFB_reg                                                      0xB8157BEC
#define  ATSC_ADDR_2EFB_inst_addr                                                "0x02E2"
#define  set_ATSC_ADDR_2EFB_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EFB_reg)=data)
#define  get_ATSC_ADDR_2EFB_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EFB_reg))
#define  ATSC_ADDR_2EFB_cr_adp_bw_load_state_shift                               (0)
#define  ATSC_ADDR_2EFB_cr_adp_bw_load_state_mask                                (0x0000003F)
#define  ATSC_ADDR_2EFB_cr_adp_bw_load_state(data)                               (0x0000003F&(data))
#define  ATSC_ADDR_2EFB_get_cr_adp_bw_load_state(data)                           (0x0000003F&(data))

#define  ATSC_ADDR_2EF4                                                         0x18157BD0
#define  ATSC_ADDR_2EF4_reg_addr                                                 "0xB8157BD0"
#define  ATSC_ADDR_2EF4_reg                                                      0xB8157BD0
#define  ATSC_ADDR_2EF4_inst_addr                                                "0x02E3"
#define  set_ATSC_ADDR_2EF4_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EF4_reg)=data)
#define  get_ATSC_ADDR_2EF4_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EF4_reg))
#define  ATSC_ADDR_2EF4_cr_adp_bw_cr_offset_dif_cond_7_0_shift                   (0)
#define  ATSC_ADDR_2EF4_cr_adp_bw_cr_offset_dif_cond_7_0_mask                    (0x000000FF)
#define  ATSC_ADDR_2EF4_cr_adp_bw_cr_offset_dif_cond_7_0(data)                   (0x000000FF&(data))
#define  ATSC_ADDR_2EF4_get_cr_adp_bw_cr_offset_dif_cond_7_0(data)               (0x000000FF&(data))

#define  ATSC_ADDR_2EF5                                                         0x18157BD4
#define  ATSC_ADDR_2EF5_reg_addr                                                 "0xB8157BD4"
#define  ATSC_ADDR_2EF5_reg                                                      0xB8157BD4
#define  ATSC_ADDR_2EF5_inst_addr                                                "0x02E4"
#define  set_ATSC_ADDR_2EF5_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EF5_reg)=data)
#define  get_ATSC_ADDR_2EF5_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EF5_reg))
#define  ATSC_ADDR_2EF5_cr_adp_bw_cr_offset_dif_cond_15_8_shift                  (0)
#define  ATSC_ADDR_2EF5_cr_adp_bw_cr_offset_dif_cond_15_8_mask                   (0x000000FF)
#define  ATSC_ADDR_2EF5_cr_adp_bw_cr_offset_dif_cond_15_8(data)                  (0x000000FF&(data))
#define  ATSC_ADDR_2EF5_get_cr_adp_bw_cr_offset_dif_cond_15_8(data)              (0x000000FF&(data))

#define  ATSC_ADDR_2EF6                                                         0x18157BD8
#define  ATSC_ADDR_2EF6_reg_addr                                                 "0xB8157BD8"
#define  ATSC_ADDR_2EF6_reg                                                      0xB8157BD8
#define  ATSC_ADDR_2EF6_inst_addr                                                "0x02E5"
#define  set_ATSC_ADDR_2EF6_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EF6_reg)=data)
#define  get_ATSC_ADDR_2EF6_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EF6_reg))
#define  ATSC_ADDR_2EF6_cr_adp_bw_cr_offset_dif_cond_23_16_shift                 (0)
#define  ATSC_ADDR_2EF6_cr_adp_bw_cr_offset_dif_cond_23_16_mask                  (0x000000FF)
#define  ATSC_ADDR_2EF6_cr_adp_bw_cr_offset_dif_cond_23_16(data)                 (0x000000FF&(data))
#define  ATSC_ADDR_2EF6_get_cr_adp_bw_cr_offset_dif_cond_23_16(data)             (0x000000FF&(data))

#define  ATSC_ADDR_2EF7                                                         0x18157BDC
#define  ATSC_ADDR_2EF7_reg_addr                                                 "0xB8157BDC"
#define  ATSC_ADDR_2EF7_reg                                                      0xB8157BDC
#define  ATSC_ADDR_2EF7_inst_addr                                                "0x02E6"
#define  set_ATSC_ADDR_2EF7_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EF7_reg)=data)
#define  get_ATSC_ADDR_2EF7_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EF7_reg))
#define  ATSC_ADDR_2EF7_cr_adp_bw_cr_offset_dif_cond_31_24_shift                 (0)
#define  ATSC_ADDR_2EF7_cr_adp_bw_cr_offset_dif_cond_31_24_mask                  (0x000000FF)
#define  ATSC_ADDR_2EF7_cr_adp_bw_cr_offset_dif_cond_31_24(data)                 (0x000000FF&(data))
#define  ATSC_ADDR_2EF7_get_cr_adp_bw_cr_offset_dif_cond_31_24(data)             (0x000000FF&(data))

#define  ATSC_ADDR_2EFC                                                         0x18157BF0
#define  ATSC_ADDR_2EFC_reg_addr                                                 "0xB8157BF0"
#define  ATSC_ADDR_2EFC_reg                                                      0xB8157BF0
#define  ATSC_ADDR_2EFC_inst_addr                                                "0x02E7"
#define  set_ATSC_ADDR_2EFC_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EFC_reg)=data)
#define  get_ATSC_ADDR_2EFC_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EFC_reg))
#define  ATSC_ADDR_2EFC_cr_adp_bw_fs2_parallel_amp_0_cond_7_0_shift              (0)
#define  ATSC_ADDR_2EFC_cr_adp_bw_fs2_parallel_amp_0_cond_7_0_mask               (0x000000FF)
#define  ATSC_ADDR_2EFC_cr_adp_bw_fs2_parallel_amp_0_cond_7_0(data)              (0x000000FF&(data))
#define  ATSC_ADDR_2EFC_get_cr_adp_bw_fs2_parallel_amp_0_cond_7_0(data)          (0x000000FF&(data))

#define  ATSC_ADDR_2EFD                                                         0x18157BF4
#define  ATSC_ADDR_2EFD_reg_addr                                                 "0xB8157BF4"
#define  ATSC_ADDR_2EFD_reg                                                      0xB8157BF4
#define  ATSC_ADDR_2EFD_inst_addr                                                "0x02E8"
#define  set_ATSC_ADDR_2EFD_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EFD_reg)=data)
#define  get_ATSC_ADDR_2EFD_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EFD_reg))
#define  ATSC_ADDR_2EFD_cr_adp_bw_fs2_parallel_amp_0_cond_12_8_shift             (0)
#define  ATSC_ADDR_2EFD_cr_adp_bw_fs2_parallel_amp_0_cond_12_8_mask              (0x0000001F)
#define  ATSC_ADDR_2EFD_cr_adp_bw_fs2_parallel_amp_0_cond_12_8(data)             (0x0000001F&(data))
#define  ATSC_ADDR_2EFD_get_cr_adp_bw_fs2_parallel_amp_0_cond_12_8(data)         (0x0000001F&(data))

#define  ATSC_ADDR_2EFE                                                         0x18157BF8
#define  ATSC_ADDR_2EFE_reg_addr                                                 "0xB8157BF8"
#define  ATSC_ADDR_2EFE_reg                                                      0xB8157BF8
#define  ATSC_ADDR_2EFE_inst_addr                                                "0x02E9"
#define  set_ATSC_ADDR_2EFE_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EFE_reg)=data)
#define  get_ATSC_ADDR_2EFE_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EFE_reg))
#define  ATSC_ADDR_2EFE_cr_adp_bw_fs2_parallel_addr_0_cond_head_7_0_shift        (0)
#define  ATSC_ADDR_2EFE_cr_adp_bw_fs2_parallel_addr_0_cond_head_7_0_mask         (0x000000FF)
#define  ATSC_ADDR_2EFE_cr_adp_bw_fs2_parallel_addr_0_cond_head_7_0(data)        (0x000000FF&(data))
#define  ATSC_ADDR_2EFE_get_cr_adp_bw_fs2_parallel_addr_0_cond_head_7_0(data)    (0x000000FF&(data))

#define  ATSC_ADDR_2EFF                                                         0x18157BFC
#define  ATSC_ADDR_2EFF_reg_addr                                                 "0xB8157BFC"
#define  ATSC_ADDR_2EFF_reg                                                      0xB8157BFC
#define  ATSC_ADDR_2EFF_inst_addr                                                "0x02EA"
#define  set_ATSC_ADDR_2EFF_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2EFF_reg)=data)
#define  get_ATSC_ADDR_2EFF_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2EFF_reg))
#define  ATSC_ADDR_2EFF_cr_adp_bw_fs2_parallel_addr_0_cond_head_11_8_shift       (0)
#define  ATSC_ADDR_2EFF_cr_adp_bw_fs2_parallel_addr_0_cond_head_11_8_mask        (0x0000000F)
#define  ATSC_ADDR_2EFF_cr_adp_bw_fs2_parallel_addr_0_cond_head_11_8(data)       (0x0000000F&(data))
#define  ATSC_ADDR_2EFF_get_cr_adp_bw_fs2_parallel_addr_0_cond_head_11_8(data)   (0x0000000F&(data))

#define  ATSC_ADDR_2E07                                                         0x1815781C
#define  ATSC_ADDR_2E07_reg_addr                                                 "0xB815781C"
#define  ATSC_ADDR_2E07_reg                                                      0xB815781C
#define  ATSC_ADDR_2E07_inst_addr                                                "0x02EB"
#define  set_ATSC_ADDR_2E07_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E07_reg)=data)
#define  get_ATSC_ADDR_2E07_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E07_reg))
#define  ATSC_ADDR_2E07_cr_adp_bw_fs2_parallel_addr_0_cond_end_7_0_shift         (0)
#define  ATSC_ADDR_2E07_cr_adp_bw_fs2_parallel_addr_0_cond_end_7_0_mask          (0x000000FF)
#define  ATSC_ADDR_2E07_cr_adp_bw_fs2_parallel_addr_0_cond_end_7_0(data)         (0x000000FF&(data))
#define  ATSC_ADDR_2E07_get_cr_adp_bw_fs2_parallel_addr_0_cond_end_7_0(data)     (0x000000FF&(data))

#define  ATSC_ADDR_2E08                                                         0x18157820
#define  ATSC_ADDR_2E08_reg_addr                                                 "0xB8157820"
#define  ATSC_ADDR_2E08_reg                                                      0xB8157820
#define  ATSC_ADDR_2E08_inst_addr                                                "0x02EC"
#define  set_ATSC_ADDR_2E08_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E08_reg)=data)
#define  get_ATSC_ADDR_2E08_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E08_reg))
#define  ATSC_ADDR_2E08_cr_adp_bw_fs2_parallel_addr_0_cond_end_11_8_shift        (0)
#define  ATSC_ADDR_2E08_cr_adp_bw_fs2_parallel_addr_0_cond_end_11_8_mask         (0x0000000F)
#define  ATSC_ADDR_2E08_cr_adp_bw_fs2_parallel_addr_0_cond_end_11_8(data)        (0x0000000F&(data))
#define  ATSC_ADDR_2E08_get_cr_adp_bw_fs2_parallel_addr_0_cond_end_11_8(data)    (0x0000000F&(data))

#define  ATSC_ADDR_2E09                                                         0x18157824
#define  ATSC_ADDR_2E09_reg_addr                                                 "0xB8157824"
#define  ATSC_ADDR_2E09_reg                                                      0xB8157824
#define  ATSC_ADDR_2E09_inst_addr                                                "0x02ED"
#define  set_ATSC_ADDR_2E09_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E09_reg)=data)
#define  get_ATSC_ADDR_2E09_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E09_reg))
#define  ATSC_ADDR_2E09_cr_offset_dif_record_size_7_0_shift                      (0)
#define  ATSC_ADDR_2E09_cr_offset_dif_record_size_7_0_mask                       (0x000000FF)
#define  ATSC_ADDR_2E09_cr_offset_dif_record_size_7_0(data)                      (0x000000FF&(data))
#define  ATSC_ADDR_2E09_get_cr_offset_dif_record_size_7_0(data)                  (0x000000FF&(data))

#define  ATSC_ADDR_2E0A                                                         0x18157828
#define  ATSC_ADDR_2E0A_reg_addr                                                 "0xB8157828"
#define  ATSC_ADDR_2E0A_reg                                                      0xB8157828
#define  ATSC_ADDR_2E0A_inst_addr                                                "0x02EE"
#define  set_ATSC_ADDR_2E0A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E0A_reg)=data)
#define  get_ATSC_ADDR_2E0A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E0A_reg))
#define  ATSC_ADDR_2E0A_cr_offset_dif_record_size_10_8_shift                     (0)
#define  ATSC_ADDR_2E0A_cr_offset_dif_record_size_10_8_mask                      (0x00000007)
#define  ATSC_ADDR_2E0A_cr_offset_dif_record_size_10_8(data)                     (0x00000007&(data))
#define  ATSC_ADDR_2E0A_get_cr_offset_dif_record_size_10_8(data)                 (0x00000007&(data))

#define  ATSC_ADDR_2E0B                                                         0x1815782C
#define  ATSC_ADDR_2E0B_reg_addr                                                 "0xB815782C"
#define  ATSC_ADDR_2E0B_reg                                                      0xB815782C
#define  ATSC_ADDR_2E0B_inst_addr                                                "0x02EF"
#define  set_ATSC_ADDR_2E0B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E0B_reg)=data)
#define  get_ATSC_ADDR_2E0B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E0B_reg))
#define  ATSC_ADDR_2E0B_cr_adp_bw_cr_fmu_upd_cnt_th_default_shift                (0)
#define  ATSC_ADDR_2E0B_cr_adp_bw_cr_fmu_upd_cnt_th_default_mask                 (0x000000FF)
#define  ATSC_ADDR_2E0B_cr_adp_bw_cr_fmu_upd_cnt_th_default(data)                (0x000000FF&(data))
#define  ATSC_ADDR_2E0B_get_cr_adp_bw_cr_fmu_upd_cnt_th_default(data)            (0x000000FF&(data))

#define  ATSC_ADDR_2E0C                                                         0x18157830
#define  ATSC_ADDR_2E0C_reg_addr                                                 "0xB8157830"
#define  ATSC_ADDR_2E0C_reg                                                      0xB8157830
#define  ATSC_ADDR_2E0C_inst_addr                                                "0x02F0"
#define  set_ATSC_ADDR_2E0C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E0C_reg)=data)
#define  get_ATSC_ADDR_2E0C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E0C_reg))
#define  ATSC_ADDR_2E0C_cr_adp_bw_cr_lpf_shift_default_7_0_shift                 (0)
#define  ATSC_ADDR_2E0C_cr_adp_bw_cr_lpf_shift_default_7_0_mask                  (0x000000FF)
#define  ATSC_ADDR_2E0C_cr_adp_bw_cr_lpf_shift_default_7_0(data)                 (0x000000FF&(data))
#define  ATSC_ADDR_2E0C_get_cr_adp_bw_cr_lpf_shift_default_7_0(data)             (0x000000FF&(data))

#define  ATSC_ADDR_2E0D                                                         0x18157834
#define  ATSC_ADDR_2E0D_reg_addr                                                 "0xB8157834"
#define  ATSC_ADDR_2E0D_reg                                                      0xB8157834
#define  ATSC_ADDR_2E0D_inst_addr                                                "0x02F1"
#define  set_ATSC_ADDR_2E0D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E0D_reg)=data)
#define  get_ATSC_ADDR_2E0D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E0D_reg))
#define  ATSC_ADDR_2E0D_cr_adp_bw_cr_pmu_comp1_default_shift                     (4)
#define  ATSC_ADDR_2E0D_cr_adp_bw_cr_lpf_shift_default_11_8_shift                (0)
#define  ATSC_ADDR_2E0D_cr_adp_bw_cr_pmu_comp1_default_mask                      (0x000000F0)
#define  ATSC_ADDR_2E0D_cr_adp_bw_cr_lpf_shift_default_11_8_mask                 (0x0000000F)
#define  ATSC_ADDR_2E0D_cr_adp_bw_cr_pmu_comp1_default(data)                     (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2E0D_cr_adp_bw_cr_lpf_shift_default_11_8(data)                (0x0000000F&(data))
#define  ATSC_ADDR_2E0D_get_cr_adp_bw_cr_pmu_comp1_default(data)                 ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2E0D_get_cr_adp_bw_cr_lpf_shift_default_11_8(data)            (0x0000000F&(data))

#define  ATSC_ADDR_2E0E                                                         0x18157838
#define  ATSC_ADDR_2E0E_reg_addr                                                 "0xB8157838"
#define  ATSC_ADDR_2E0E_reg                                                      0xB8157838
#define  ATSC_ADDR_2E0E_inst_addr                                                "0x02F2"
#define  set_ATSC_ADDR_2E0E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E0E_reg)=data)
#define  get_ATSC_ADDR_2E0E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E0E_reg))
#define  ATSC_ADDR_2E0E_cr_adp_bw_fsm_cr_fmu_33_default_shift                    (4)
#define  ATSC_ADDR_2E0E_cr_adp_bw_fsm_cr_fmu_32_default_shift                    (0)
#define  ATSC_ADDR_2E0E_cr_adp_bw_fsm_cr_fmu_33_default_mask                     (0x000000F0)
#define  ATSC_ADDR_2E0E_cr_adp_bw_fsm_cr_fmu_32_default_mask                     (0x0000000F)
#define  ATSC_ADDR_2E0E_cr_adp_bw_fsm_cr_fmu_33_default(data)                    (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2E0E_cr_adp_bw_fsm_cr_fmu_32_default(data)                    (0x0000000F&(data))
#define  ATSC_ADDR_2E0E_get_cr_adp_bw_fsm_cr_fmu_33_default(data)                ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2E0E_get_cr_adp_bw_fsm_cr_fmu_32_default(data)                (0x0000000F&(data))

#define  ATSC_ADDR_2E0F                                                         0x1815783C
#define  ATSC_ADDR_2E0F_reg_addr                                                 "0xB815783C"
#define  ATSC_ADDR_2E0F_reg                                                      0xB815783C
#define  ATSC_ADDR_2E0F_inst_addr                                                "0x02F3"
#define  set_ATSC_ADDR_2E0F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E0F_reg)=data)
#define  get_ATSC_ADDR_2E0F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E0F_reg))
#define  ATSC_ADDR_2E0F_cr_adp_bw_fsm_cr_pmu_32_default_shift                    (4)
#define  ATSC_ADDR_2E0F_cr_adp_bw_fsm_cr_fmu_34_default_shift                    (0)
#define  ATSC_ADDR_2E0F_cr_adp_bw_fsm_cr_pmu_32_default_mask                     (0x000000F0)
#define  ATSC_ADDR_2E0F_cr_adp_bw_fsm_cr_fmu_34_default_mask                     (0x0000000F)
#define  ATSC_ADDR_2E0F_cr_adp_bw_fsm_cr_pmu_32_default(data)                    (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2E0F_cr_adp_bw_fsm_cr_fmu_34_default(data)                    (0x0000000F&(data))
#define  ATSC_ADDR_2E0F_get_cr_adp_bw_fsm_cr_pmu_32_default(data)                ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2E0F_get_cr_adp_bw_fsm_cr_fmu_34_default(data)                (0x0000000F&(data))

#define  ATSC_ADDR_2E10                                                         0x18157840
#define  ATSC_ADDR_2E10_reg_addr                                                 "0xB8157840"
#define  ATSC_ADDR_2E10_reg                                                      0xB8157840
#define  ATSC_ADDR_2E10_inst_addr                                                "0x02F4"
#define  set_ATSC_ADDR_2E10_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E10_reg)=data)
#define  get_ATSC_ADDR_2E10_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E10_reg))
#define  ATSC_ADDR_2E10_cr_adp_bw_fsm_cr_pmu_34_default_shift                    (4)
#define  ATSC_ADDR_2E10_cr_adp_bw_fsm_cr_pmu_33_default_shift                    (0)
#define  ATSC_ADDR_2E10_cr_adp_bw_fsm_cr_pmu_34_default_mask                     (0x000000F0)
#define  ATSC_ADDR_2E10_cr_adp_bw_fsm_cr_pmu_33_default_mask                     (0x0000000F)
#define  ATSC_ADDR_2E10_cr_adp_bw_fsm_cr_pmu_34_default(data)                    (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2E10_cr_adp_bw_fsm_cr_pmu_33_default(data)                    (0x0000000F&(data))
#define  ATSC_ADDR_2E10_get_cr_adp_bw_fsm_cr_pmu_34_default(data)                ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2E10_get_cr_adp_bw_fsm_cr_pmu_33_default(data)                (0x0000000F&(data))

#define  ATSC_ADDR_2E11                                                         0x18157844
#define  ATSC_ADDR_2E11_reg_addr                                                 "0xB8157844"
#define  ATSC_ADDR_2E11_reg                                                      0xB8157844
#define  ATSC_ADDR_2E11_inst_addr                                                "0x02F5"
#define  set_ATSC_ADDR_2E11_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E11_reg)=data)
#define  get_ATSC_ADDR_2E11_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E11_reg))
#define  ATSC_ADDR_2E11_cr_adp_bw_cr_fmu_upd_cnt_th_echo_shift                   (0)
#define  ATSC_ADDR_2E11_cr_adp_bw_cr_fmu_upd_cnt_th_echo_mask                    (0x000000FF)
#define  ATSC_ADDR_2E11_cr_adp_bw_cr_fmu_upd_cnt_th_echo(data)                   (0x000000FF&(data))
#define  ATSC_ADDR_2E11_get_cr_adp_bw_cr_fmu_upd_cnt_th_echo(data)               (0x000000FF&(data))

#define  ATSC_ADDR_2E12                                                         0x18157848
#define  ATSC_ADDR_2E12_reg_addr                                                 "0xB8157848"
#define  ATSC_ADDR_2E12_reg                                                      0xB8157848
#define  ATSC_ADDR_2E12_inst_addr                                                "0x02F6"
#define  set_ATSC_ADDR_2E12_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E12_reg)=data)
#define  get_ATSC_ADDR_2E12_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E12_reg))
#define  ATSC_ADDR_2E12_cr_adp_bw_cr_lpf_shift_echo_7_0_shift                    (0)
#define  ATSC_ADDR_2E12_cr_adp_bw_cr_lpf_shift_echo_7_0_mask                     (0x000000FF)
#define  ATSC_ADDR_2E12_cr_adp_bw_cr_lpf_shift_echo_7_0(data)                    (0x000000FF&(data))
#define  ATSC_ADDR_2E12_get_cr_adp_bw_cr_lpf_shift_echo_7_0(data)                (0x000000FF&(data))

#define  ATSC_ADDR_2E13                                                         0x1815784C
#define  ATSC_ADDR_2E13_reg_addr                                                 "0xB815784C"
#define  ATSC_ADDR_2E13_reg                                                      0xB815784C
#define  ATSC_ADDR_2E13_inst_addr                                                "0x02F7"
#define  set_ATSC_ADDR_2E13_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E13_reg)=data)
#define  get_ATSC_ADDR_2E13_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E13_reg))
#define  ATSC_ADDR_2E13_cr_adp_bw_cr_pmu_comp1_echo_shift                        (4)
#define  ATSC_ADDR_2E13_cr_adp_bw_cr_lpf_shift_echo_11_8_shift                   (0)
#define  ATSC_ADDR_2E13_cr_adp_bw_cr_pmu_comp1_echo_mask                         (0x000000F0)
#define  ATSC_ADDR_2E13_cr_adp_bw_cr_lpf_shift_echo_11_8_mask                    (0x0000000F)
#define  ATSC_ADDR_2E13_cr_adp_bw_cr_pmu_comp1_echo(data)                        (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2E13_cr_adp_bw_cr_lpf_shift_echo_11_8(data)                   (0x0000000F&(data))
#define  ATSC_ADDR_2E13_get_cr_adp_bw_cr_pmu_comp1_echo(data)                    ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2E13_get_cr_adp_bw_cr_lpf_shift_echo_11_8(data)               (0x0000000F&(data))

#define  ATSC_ADDR_2E14                                                         0x18157850
#define  ATSC_ADDR_2E14_reg_addr                                                 "0xB8157850"
#define  ATSC_ADDR_2E14_reg                                                      0xB8157850
#define  ATSC_ADDR_2E14_inst_addr                                                "0x02F8"
#define  set_ATSC_ADDR_2E14_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E14_reg)=data)
#define  get_ATSC_ADDR_2E14_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E14_reg))
#define  ATSC_ADDR_2E14_cr_adp_bw_fsm_cr_fmu_33_echo_shift                       (4)
#define  ATSC_ADDR_2E14_cr_adp_bw_fsm_cr_fmu_32_echo_shift                       (0)
#define  ATSC_ADDR_2E14_cr_adp_bw_fsm_cr_fmu_33_echo_mask                        (0x000000F0)
#define  ATSC_ADDR_2E14_cr_adp_bw_fsm_cr_fmu_32_echo_mask                        (0x0000000F)
#define  ATSC_ADDR_2E14_cr_adp_bw_fsm_cr_fmu_33_echo(data)                       (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2E14_cr_adp_bw_fsm_cr_fmu_32_echo(data)                       (0x0000000F&(data))
#define  ATSC_ADDR_2E14_get_cr_adp_bw_fsm_cr_fmu_33_echo(data)                   ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2E14_get_cr_adp_bw_fsm_cr_fmu_32_echo(data)                   (0x0000000F&(data))

#define  ATSC_ADDR_2E15                                                         0x18157854
#define  ATSC_ADDR_2E15_reg_addr                                                 "0xB8157854"
#define  ATSC_ADDR_2E15_reg                                                      0xB8157854
#define  ATSC_ADDR_2E15_inst_addr                                                "0x02F9"
#define  set_ATSC_ADDR_2E15_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E15_reg)=data)
#define  get_ATSC_ADDR_2E15_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E15_reg))
#define  ATSC_ADDR_2E15_cr_adp_bw_fsm_cr_pmu_32_echo_shift                       (4)
#define  ATSC_ADDR_2E15_cr_adp_bw_fsm_cr_fmu_34_echo_shift                       (0)
#define  ATSC_ADDR_2E15_cr_adp_bw_fsm_cr_pmu_32_echo_mask                        (0x000000F0)
#define  ATSC_ADDR_2E15_cr_adp_bw_fsm_cr_fmu_34_echo_mask                        (0x0000000F)
#define  ATSC_ADDR_2E15_cr_adp_bw_fsm_cr_pmu_32_echo(data)                       (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2E15_cr_adp_bw_fsm_cr_fmu_34_echo(data)                       (0x0000000F&(data))
#define  ATSC_ADDR_2E15_get_cr_adp_bw_fsm_cr_pmu_32_echo(data)                   ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2E15_get_cr_adp_bw_fsm_cr_fmu_34_echo(data)                   (0x0000000F&(data))

#define  ATSC_ADDR_2E16                                                         0x18157858
#define  ATSC_ADDR_2E16_reg_addr                                                 "0xB8157858"
#define  ATSC_ADDR_2E16_reg                                                      0xB8157858
#define  ATSC_ADDR_2E16_inst_addr                                                "0x02FA"
#define  set_ATSC_ADDR_2E16_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E16_reg)=data)
#define  get_ATSC_ADDR_2E16_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E16_reg))
#define  ATSC_ADDR_2E16_cr_adp_bw_fsm_cr_pmu_34_echo_shift                       (4)
#define  ATSC_ADDR_2E16_cr_adp_bw_fsm_cr_pmu_33_echo_shift                       (0)
#define  ATSC_ADDR_2E16_cr_adp_bw_fsm_cr_pmu_34_echo_mask                        (0x000000F0)
#define  ATSC_ADDR_2E16_cr_adp_bw_fsm_cr_pmu_33_echo_mask                        (0x0000000F)
#define  ATSC_ADDR_2E16_cr_adp_bw_fsm_cr_pmu_34_echo(data)                       (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2E16_cr_adp_bw_fsm_cr_pmu_33_echo(data)                       (0x0000000F&(data))
#define  ATSC_ADDR_2E16_get_cr_adp_bw_fsm_cr_pmu_34_echo(data)                   ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2E16_get_cr_adp_bw_fsm_cr_pmu_33_echo(data)                   (0x0000000F&(data))

#define  ATSC_ADDR_2E17                                                         0x1815785C
#define  ATSC_ADDR_2E17_reg_addr                                                 "0xB815785C"
#define  ATSC_ADDR_2E17_reg                                                      0xB815785C
#define  ATSC_ADDR_2E17_inst_addr                                                "0x02FB"
#define  set_ATSC_ADDR_2E17_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E17_reg)=data)
#define  get_ATSC_ADDR_2E17_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E17_reg))
#define  ATSC_ADDR_2E17_cr_adp_bw_cr_fmu_upd_cnt_th_aci_shift                    (0)
#define  ATSC_ADDR_2E17_cr_adp_bw_cr_fmu_upd_cnt_th_aci_mask                     (0x000000FF)
#define  ATSC_ADDR_2E17_cr_adp_bw_cr_fmu_upd_cnt_th_aci(data)                    (0x000000FF&(data))
#define  ATSC_ADDR_2E17_get_cr_adp_bw_cr_fmu_upd_cnt_th_aci(data)                (0x000000FF&(data))

#define  ATSC_ADDR_2E18                                                         0x18157860
#define  ATSC_ADDR_2E18_reg_addr                                                 "0xB8157860"
#define  ATSC_ADDR_2E18_reg                                                      0xB8157860
#define  ATSC_ADDR_2E18_inst_addr                                                "0x02FC"
#define  set_ATSC_ADDR_2E18_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E18_reg)=data)
#define  get_ATSC_ADDR_2E18_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E18_reg))
#define  ATSC_ADDR_2E18_cr_adp_bw_cr_lpf_shift_aci_7_0_shift                     (0)
#define  ATSC_ADDR_2E18_cr_adp_bw_cr_lpf_shift_aci_7_0_mask                      (0x000000FF)
#define  ATSC_ADDR_2E18_cr_adp_bw_cr_lpf_shift_aci_7_0(data)                     (0x000000FF&(data))
#define  ATSC_ADDR_2E18_get_cr_adp_bw_cr_lpf_shift_aci_7_0(data)                 (0x000000FF&(data))

#define  ATSC_ADDR_2E19                                                         0x18157864
#define  ATSC_ADDR_2E19_reg_addr                                                 "0xB8157864"
#define  ATSC_ADDR_2E19_reg                                                      0xB8157864
#define  ATSC_ADDR_2E19_inst_addr                                                "0x02FD"
#define  set_ATSC_ADDR_2E19_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E19_reg)=data)
#define  get_ATSC_ADDR_2E19_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E19_reg))
#define  ATSC_ADDR_2E19_cr_adp_bw_cr_pmu_comp1_aci_shift                         (4)
#define  ATSC_ADDR_2E19_cr_adp_bw_cr_lpf_shift_aci_11_8_shift                    (0)
#define  ATSC_ADDR_2E19_cr_adp_bw_cr_pmu_comp1_aci_mask                          (0x000000F0)
#define  ATSC_ADDR_2E19_cr_adp_bw_cr_lpf_shift_aci_11_8_mask                     (0x0000000F)
#define  ATSC_ADDR_2E19_cr_adp_bw_cr_pmu_comp1_aci(data)                         (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2E19_cr_adp_bw_cr_lpf_shift_aci_11_8(data)                    (0x0000000F&(data))
#define  ATSC_ADDR_2E19_get_cr_adp_bw_cr_pmu_comp1_aci(data)                     ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2E19_get_cr_adp_bw_cr_lpf_shift_aci_11_8(data)                (0x0000000F&(data))

#define  ATSC_ADDR_2E1A                                                         0x18157868
#define  ATSC_ADDR_2E1A_reg_addr                                                 "0xB8157868"
#define  ATSC_ADDR_2E1A_reg                                                      0xB8157868
#define  ATSC_ADDR_2E1A_inst_addr                                                "0x02FE"
#define  set_ATSC_ADDR_2E1A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E1A_reg)=data)
#define  get_ATSC_ADDR_2E1A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E1A_reg))
#define  ATSC_ADDR_2E1A_cr_adp_bw_fsm_cr_fmu_33_aci_shift                        (4)
#define  ATSC_ADDR_2E1A_cr_adp_bw_fsm_cr_fmu_32_aci_shift                        (0)
#define  ATSC_ADDR_2E1A_cr_adp_bw_fsm_cr_fmu_33_aci_mask                         (0x000000F0)
#define  ATSC_ADDR_2E1A_cr_adp_bw_fsm_cr_fmu_32_aci_mask                         (0x0000000F)
#define  ATSC_ADDR_2E1A_cr_adp_bw_fsm_cr_fmu_33_aci(data)                        (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2E1A_cr_adp_bw_fsm_cr_fmu_32_aci(data)                        (0x0000000F&(data))
#define  ATSC_ADDR_2E1A_get_cr_adp_bw_fsm_cr_fmu_33_aci(data)                    ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2E1A_get_cr_adp_bw_fsm_cr_fmu_32_aci(data)                    (0x0000000F&(data))

#define  ATSC_ADDR_2E1B                                                         0x1815786C
#define  ATSC_ADDR_2E1B_reg_addr                                                 "0xB815786C"
#define  ATSC_ADDR_2E1B_reg                                                      0xB815786C
#define  ATSC_ADDR_2E1B_inst_addr                                                "0x02FF"
#define  set_ATSC_ADDR_2E1B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E1B_reg)=data)
#define  get_ATSC_ADDR_2E1B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E1B_reg))
#define  ATSC_ADDR_2E1B_cr_adp_bw_fsm_cr_pmu_32_aci_shift                        (4)
#define  ATSC_ADDR_2E1B_cr_adp_bw_fsm_cr_fmu_34_aci_shift                        (0)
#define  ATSC_ADDR_2E1B_cr_adp_bw_fsm_cr_pmu_32_aci_mask                         (0x000000F0)
#define  ATSC_ADDR_2E1B_cr_adp_bw_fsm_cr_fmu_34_aci_mask                         (0x0000000F)
#define  ATSC_ADDR_2E1B_cr_adp_bw_fsm_cr_pmu_32_aci(data)                        (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2E1B_cr_adp_bw_fsm_cr_fmu_34_aci(data)                        (0x0000000F&(data))
#define  ATSC_ADDR_2E1B_get_cr_adp_bw_fsm_cr_pmu_32_aci(data)                    ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2E1B_get_cr_adp_bw_fsm_cr_fmu_34_aci(data)                    (0x0000000F&(data))

#define  ATSC_ADDR_2E1C                                                         0x18157870
#define  ATSC_ADDR_2E1C_reg_addr                                                 "0xB8157870"
#define  ATSC_ADDR_2E1C_reg                                                      0xB8157870
#define  ATSC_ADDR_2E1C_inst_addr                                                "0x0300"
#define  set_ATSC_ADDR_2E1C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E1C_reg)=data)
#define  get_ATSC_ADDR_2E1C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E1C_reg))
#define  ATSC_ADDR_2E1C_cr_adp_bw_fsm_cr_pmu_34_aci_shift                        (4)
#define  ATSC_ADDR_2E1C_cr_adp_bw_fsm_cr_pmu_33_aci_shift                        (0)
#define  ATSC_ADDR_2E1C_cr_adp_bw_fsm_cr_pmu_34_aci_mask                         (0x000000F0)
#define  ATSC_ADDR_2E1C_cr_adp_bw_fsm_cr_pmu_33_aci_mask                         (0x0000000F)
#define  ATSC_ADDR_2E1C_cr_adp_bw_fsm_cr_pmu_34_aci(data)                        (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2E1C_cr_adp_bw_fsm_cr_pmu_33_aci(data)                        (0x0000000F&(data))
#define  ATSC_ADDR_2E1C_get_cr_adp_bw_fsm_cr_pmu_34_aci(data)                    ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2E1C_get_cr_adp_bw_fsm_cr_pmu_33_aci(data)                    (0x0000000F&(data))

#define  ATSC_ADDR_2E1D                                                         0x18157874
#define  ATSC_ADDR_2E1D_reg_addr                                                 "0xB8157874"
#define  ATSC_ADDR_2E1D_reg                                                      0xB8157874
#define  ATSC_ADDR_2E1D_inst_addr                                                "0x0301"
#define  set_ATSC_ADDR_2E1D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E1D_reg)=data)
#define  get_ATSC_ADDR_2E1D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E1D_reg))
#define  ATSC_ADDR_2E1D_cr_adp_bw_cr_fmu_upd_cnt_th_no_echo_shift                (0)
#define  ATSC_ADDR_2E1D_cr_adp_bw_cr_fmu_upd_cnt_th_no_echo_mask                 (0x000000FF)
#define  ATSC_ADDR_2E1D_cr_adp_bw_cr_fmu_upd_cnt_th_no_echo(data)                (0x000000FF&(data))
#define  ATSC_ADDR_2E1D_get_cr_adp_bw_cr_fmu_upd_cnt_th_no_echo(data)            (0x000000FF&(data))

#define  ATSC_ADDR_2E1E                                                         0x18157878
#define  ATSC_ADDR_2E1E_reg_addr                                                 "0xB8157878"
#define  ATSC_ADDR_2E1E_reg                                                      0xB8157878
#define  ATSC_ADDR_2E1E_inst_addr                                                "0x0302"
#define  set_ATSC_ADDR_2E1E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E1E_reg)=data)
#define  get_ATSC_ADDR_2E1E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E1E_reg))
#define  ATSC_ADDR_2E1E_cr_adp_bw_cr_lpf_shift_no_echo_7_0_shift                 (0)
#define  ATSC_ADDR_2E1E_cr_adp_bw_cr_lpf_shift_no_echo_7_0_mask                  (0x000000FF)
#define  ATSC_ADDR_2E1E_cr_adp_bw_cr_lpf_shift_no_echo_7_0(data)                 (0x000000FF&(data))
#define  ATSC_ADDR_2E1E_get_cr_adp_bw_cr_lpf_shift_no_echo_7_0(data)             (0x000000FF&(data))

#define  ATSC_ADDR_2E1F                                                         0x1815787C
#define  ATSC_ADDR_2E1F_reg_addr                                                 "0xB815787C"
#define  ATSC_ADDR_2E1F_reg                                                      0xB815787C
#define  ATSC_ADDR_2E1F_inst_addr                                                "0x0303"
#define  set_ATSC_ADDR_2E1F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E1F_reg)=data)
#define  get_ATSC_ADDR_2E1F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E1F_reg))
#define  ATSC_ADDR_2E1F_cr_adp_bw_cr_pmu_comp1_no_echo_shift                     (4)
#define  ATSC_ADDR_2E1F_cr_adp_bw_cr_lpf_shift_no_echo_11_8_shift                (0)
#define  ATSC_ADDR_2E1F_cr_adp_bw_cr_pmu_comp1_no_echo_mask                      (0x000000F0)
#define  ATSC_ADDR_2E1F_cr_adp_bw_cr_lpf_shift_no_echo_11_8_mask                 (0x0000000F)
#define  ATSC_ADDR_2E1F_cr_adp_bw_cr_pmu_comp1_no_echo(data)                     (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2E1F_cr_adp_bw_cr_lpf_shift_no_echo_11_8(data)                (0x0000000F&(data))
#define  ATSC_ADDR_2E1F_get_cr_adp_bw_cr_pmu_comp1_no_echo(data)                 ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2E1F_get_cr_adp_bw_cr_lpf_shift_no_echo_11_8(data)            (0x0000000F&(data))

#define  ATSC_ADDR_2E20                                                         0x18157880
#define  ATSC_ADDR_2E20_reg_addr                                                 "0xB8157880"
#define  ATSC_ADDR_2E20_reg                                                      0xB8157880
#define  ATSC_ADDR_2E20_inst_addr                                                "0x0304"
#define  set_ATSC_ADDR_2E20_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E20_reg)=data)
#define  get_ATSC_ADDR_2E20_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E20_reg))
#define  ATSC_ADDR_2E20_cr_adp_bw_fsm_cr_fmu_33_no_echo_shift                    (4)
#define  ATSC_ADDR_2E20_cr_adp_bw_fsm_cr_fmu_32_no_echo_shift                    (0)
#define  ATSC_ADDR_2E20_cr_adp_bw_fsm_cr_fmu_33_no_echo_mask                     (0x000000F0)
#define  ATSC_ADDR_2E20_cr_adp_bw_fsm_cr_fmu_32_no_echo_mask                     (0x0000000F)
#define  ATSC_ADDR_2E20_cr_adp_bw_fsm_cr_fmu_33_no_echo(data)                    (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2E20_cr_adp_bw_fsm_cr_fmu_32_no_echo(data)                    (0x0000000F&(data))
#define  ATSC_ADDR_2E20_get_cr_adp_bw_fsm_cr_fmu_33_no_echo(data)                ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2E20_get_cr_adp_bw_fsm_cr_fmu_32_no_echo(data)                (0x0000000F&(data))

#define  ATSC_ADDR_2E21                                                         0x18157884
#define  ATSC_ADDR_2E21_reg_addr                                                 "0xB8157884"
#define  ATSC_ADDR_2E21_reg                                                      0xB8157884
#define  ATSC_ADDR_2E21_inst_addr                                                "0x0305"
#define  set_ATSC_ADDR_2E21_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E21_reg)=data)
#define  get_ATSC_ADDR_2E21_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E21_reg))
#define  ATSC_ADDR_2E21_cr_adp_bw_fsm_cr_pmu_32_no_echo_shift                    (4)
#define  ATSC_ADDR_2E21_cr_adp_bw_fsm_cr_fmu_34_no_echo_shift                    (0)
#define  ATSC_ADDR_2E21_cr_adp_bw_fsm_cr_pmu_32_no_echo_mask                     (0x000000F0)
#define  ATSC_ADDR_2E21_cr_adp_bw_fsm_cr_fmu_34_no_echo_mask                     (0x0000000F)
#define  ATSC_ADDR_2E21_cr_adp_bw_fsm_cr_pmu_32_no_echo(data)                    (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2E21_cr_adp_bw_fsm_cr_fmu_34_no_echo(data)                    (0x0000000F&(data))
#define  ATSC_ADDR_2E21_get_cr_adp_bw_fsm_cr_pmu_32_no_echo(data)                ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2E21_get_cr_adp_bw_fsm_cr_fmu_34_no_echo(data)                (0x0000000F&(data))

#define  ATSC_ADDR_2E22                                                         0x18157888
#define  ATSC_ADDR_2E22_reg_addr                                                 "0xB8157888"
#define  ATSC_ADDR_2E22_reg                                                      0xB8157888
#define  ATSC_ADDR_2E22_inst_addr                                                "0x0306"
#define  set_ATSC_ADDR_2E22_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E22_reg)=data)
#define  get_ATSC_ADDR_2E22_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E22_reg))
#define  ATSC_ADDR_2E22_cr_adp_bw_fsm_cr_pmu_34_no_echo_shift                    (4)
#define  ATSC_ADDR_2E22_cr_adp_bw_fsm_cr_pmu_33_no_echo_shift                    (0)
#define  ATSC_ADDR_2E22_cr_adp_bw_fsm_cr_pmu_34_no_echo_mask                     (0x000000F0)
#define  ATSC_ADDR_2E22_cr_adp_bw_fsm_cr_pmu_33_no_echo_mask                     (0x0000000F)
#define  ATSC_ADDR_2E22_cr_adp_bw_fsm_cr_pmu_34_no_echo(data)                    (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2E22_cr_adp_bw_fsm_cr_pmu_33_no_echo(data)                    (0x0000000F&(data))
#define  ATSC_ADDR_2E22_get_cr_adp_bw_fsm_cr_pmu_34_no_echo(data)                ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2E22_get_cr_adp_bw_fsm_cr_pmu_33_no_echo(data)                (0x0000000F&(data))

#define  ATSC_ADDR_2E23                                                         0x1815788C
#define  ATSC_ADDR_2E23_reg_addr                                                 "0xB815788C"
#define  ATSC_ADDR_2E23_reg                                                      0xB815788C
#define  ATSC_ADDR_2E23_inst_addr                                                "0x0307"
#define  set_ATSC_ADDR_2E23_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E23_reg)=data)
#define  get_ATSC_ADDR_2E23_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E23_reg))
#define  ATSC_ADDR_2E23_cr_adp_bw_cr_fmu_upd_cnt_th_ebs_shift                    (0)
#define  ATSC_ADDR_2E23_cr_adp_bw_cr_fmu_upd_cnt_th_ebs_mask                     (0x000000FF)
#define  ATSC_ADDR_2E23_cr_adp_bw_cr_fmu_upd_cnt_th_ebs(data)                    (0x000000FF&(data))
#define  ATSC_ADDR_2E23_get_cr_adp_bw_cr_fmu_upd_cnt_th_ebs(data)                (0x000000FF&(data))

#define  ATSC_ADDR_2E24                                                         0x18157890
#define  ATSC_ADDR_2E24_reg_addr                                                 "0xB8157890"
#define  ATSC_ADDR_2E24_reg                                                      0xB8157890
#define  ATSC_ADDR_2E24_inst_addr                                                "0x0308"
#define  set_ATSC_ADDR_2E24_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E24_reg)=data)
#define  get_ATSC_ADDR_2E24_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E24_reg))
#define  ATSC_ADDR_2E24_cr_adp_bw_cr_lpf_shift_ebs_7_0_shift                     (0)
#define  ATSC_ADDR_2E24_cr_adp_bw_cr_lpf_shift_ebs_7_0_mask                      (0x000000FF)
#define  ATSC_ADDR_2E24_cr_adp_bw_cr_lpf_shift_ebs_7_0(data)                     (0x000000FF&(data))
#define  ATSC_ADDR_2E24_get_cr_adp_bw_cr_lpf_shift_ebs_7_0(data)                 (0x000000FF&(data))

#define  ATSC_ADDR_2E25                                                         0x18157894
#define  ATSC_ADDR_2E25_reg_addr                                                 "0xB8157894"
#define  ATSC_ADDR_2E25_reg                                                      0xB8157894
#define  ATSC_ADDR_2E25_inst_addr                                                "0x0309"
#define  set_ATSC_ADDR_2E25_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E25_reg)=data)
#define  get_ATSC_ADDR_2E25_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E25_reg))
#define  ATSC_ADDR_2E25_cr_adp_bw_cr_pmu_comp1_ebs_shift                         (4)
#define  ATSC_ADDR_2E25_cr_adp_bw_cr_lpf_shift_ebs_11_8_shift                    (0)
#define  ATSC_ADDR_2E25_cr_adp_bw_cr_pmu_comp1_ebs_mask                          (0x000000F0)
#define  ATSC_ADDR_2E25_cr_adp_bw_cr_lpf_shift_ebs_11_8_mask                     (0x0000000F)
#define  ATSC_ADDR_2E25_cr_adp_bw_cr_pmu_comp1_ebs(data)                         (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2E25_cr_adp_bw_cr_lpf_shift_ebs_11_8(data)                    (0x0000000F&(data))
#define  ATSC_ADDR_2E25_get_cr_adp_bw_cr_pmu_comp1_ebs(data)                     ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2E25_get_cr_adp_bw_cr_lpf_shift_ebs_11_8(data)                (0x0000000F&(data))

#define  ATSC_ADDR_2E26                                                         0x18157898
#define  ATSC_ADDR_2E26_reg_addr                                                 "0xB8157898"
#define  ATSC_ADDR_2E26_reg                                                      0xB8157898
#define  ATSC_ADDR_2E26_inst_addr                                                "0x030A"
#define  set_ATSC_ADDR_2E26_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E26_reg)=data)
#define  get_ATSC_ADDR_2E26_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E26_reg))
#define  ATSC_ADDR_2E26_cr_adp_bw_fsm_cr_fmu_33_ebs_shift                        (4)
#define  ATSC_ADDR_2E26_cr_adp_bw_fsm_cr_fmu_32_ebs_shift                        (0)
#define  ATSC_ADDR_2E26_cr_adp_bw_fsm_cr_fmu_33_ebs_mask                         (0x000000F0)
#define  ATSC_ADDR_2E26_cr_adp_bw_fsm_cr_fmu_32_ebs_mask                         (0x0000000F)
#define  ATSC_ADDR_2E26_cr_adp_bw_fsm_cr_fmu_33_ebs(data)                        (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2E26_cr_adp_bw_fsm_cr_fmu_32_ebs(data)                        (0x0000000F&(data))
#define  ATSC_ADDR_2E26_get_cr_adp_bw_fsm_cr_fmu_33_ebs(data)                    ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2E26_get_cr_adp_bw_fsm_cr_fmu_32_ebs(data)                    (0x0000000F&(data))

#define  ATSC_ADDR_2E27                                                         0x1815789C
#define  ATSC_ADDR_2E27_reg_addr                                                 "0xB815789C"
#define  ATSC_ADDR_2E27_reg                                                      0xB815789C
#define  ATSC_ADDR_2E27_inst_addr                                                "0x030B"
#define  set_ATSC_ADDR_2E27_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E27_reg)=data)
#define  get_ATSC_ADDR_2E27_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E27_reg))
#define  ATSC_ADDR_2E27_cr_adp_bw_fsm_cr_pmu_32_ebs_shift                        (4)
#define  ATSC_ADDR_2E27_cr_adp_bw_fsm_cr_fmu_34_ebs_shift                        (0)
#define  ATSC_ADDR_2E27_cr_adp_bw_fsm_cr_pmu_32_ebs_mask                         (0x000000F0)
#define  ATSC_ADDR_2E27_cr_adp_bw_fsm_cr_fmu_34_ebs_mask                         (0x0000000F)
#define  ATSC_ADDR_2E27_cr_adp_bw_fsm_cr_pmu_32_ebs(data)                        (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2E27_cr_adp_bw_fsm_cr_fmu_34_ebs(data)                        (0x0000000F&(data))
#define  ATSC_ADDR_2E27_get_cr_adp_bw_fsm_cr_pmu_32_ebs(data)                    ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2E27_get_cr_adp_bw_fsm_cr_fmu_34_ebs(data)                    (0x0000000F&(data))

#define  ATSC_ADDR_2E28                                                         0x181578A0
#define  ATSC_ADDR_2E28_reg_addr                                                 "0xB81578A0"
#define  ATSC_ADDR_2E28_reg                                                      0xB81578A0
#define  ATSC_ADDR_2E28_inst_addr                                                "0x030C"
#define  set_ATSC_ADDR_2E28_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E28_reg)=data)
#define  get_ATSC_ADDR_2E28_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E28_reg))
#define  ATSC_ADDR_2E28_cr_adp_bw_fsm_cr_pmu_34_ebs_shift                        (4)
#define  ATSC_ADDR_2E28_cr_adp_bw_fsm_cr_pmu_33_ebs_shift                        (0)
#define  ATSC_ADDR_2E28_cr_adp_bw_fsm_cr_pmu_34_ebs_mask                         (0x000000F0)
#define  ATSC_ADDR_2E28_cr_adp_bw_fsm_cr_pmu_33_ebs_mask                         (0x0000000F)
#define  ATSC_ADDR_2E28_cr_adp_bw_fsm_cr_pmu_34_ebs(data)                        (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2E28_cr_adp_bw_fsm_cr_pmu_33_ebs(data)                        (0x0000000F&(data))
#define  ATSC_ADDR_2E28_get_cr_adp_bw_fsm_cr_pmu_34_ebs(data)                    ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2E28_get_cr_adp_bw_fsm_cr_pmu_33_ebs(data)                    (0x0000000F&(data))

#define  ATSC_ADDR_26B0                                                         0x18155AC0
#define  ATSC_ADDR_26B0_reg_addr                                                 "0xB8155AC0"
#define  ATSC_ADDR_26B0_reg                                                      0xB8155AC0
#define  ATSC_ADDR_26B0_inst_addr                                                "0x030D"
#define  set_ATSC_ADDR_26B0_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26B0_reg)=data)
#define  get_ATSC_ADDR_26B0_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26B0_reg))
#define  ATSC_ADDR_26B0_corr_th1_7_0_shift                                       (0)
#define  ATSC_ADDR_26B0_corr_th1_7_0_mask                                        (0x000000FF)
#define  ATSC_ADDR_26B0_corr_th1_7_0(data)                                       (0x000000FF&(data))
#define  ATSC_ADDR_26B0_get_corr_th1_7_0(data)                                   (0x000000FF&(data))

#define  ATSC_ADDR_26B1                                                         0x18155AC4
#define  ATSC_ADDR_26B1_reg_addr                                                 "0xB8155AC4"
#define  ATSC_ADDR_26B1_reg                                                      0xB8155AC4
#define  ATSC_ADDR_26B1_inst_addr                                                "0x030E"
#define  set_ATSC_ADDR_26B1_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26B1_reg)=data)
#define  get_ATSC_ADDR_26B1_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26B1_reg))
#define  ATSC_ADDR_26B1_corr_th1_12_8_shift                                      (0)
#define  ATSC_ADDR_26B1_corr_th1_12_8_mask                                       (0x0000001F)
#define  ATSC_ADDR_26B1_corr_th1_12_8(data)                                      (0x0000001F&(data))
#define  ATSC_ADDR_26B1_get_corr_th1_12_8(data)                                  (0x0000001F&(data))

#define  ATSC_ADDR_26B2                                                         0x18155AC8
#define  ATSC_ADDR_26B2_reg_addr                                                 "0xB8155AC8"
#define  ATSC_ADDR_26B2_reg                                                      0xB8155AC8
#define  ATSC_ADDR_26B2_inst_addr                                                "0x030F"
#define  set_ATSC_ADDR_26B2_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26B2_reg)=data)
#define  get_ATSC_ADDR_26B2_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26B2_reg))
#define  ATSC_ADDR_26B2_pn63_flag_error_and_or_shift                             (7)
#define  ATSC_ADDR_26B2_pn63_flag_error_02_en_shift                              (6)
#define  ATSC_ADDR_26B2_pn63_flag_error_2_en_shift                               (5)
#define  ATSC_ADDR_26B2_pn63_flag_error_0_en_shift                               (4)
#define  ATSC_ADDR_26B2_pn63_flag_type_sel_shift                                 (2)
#define  ATSC_ADDR_26B2_pn63_flag_source_sel_shift                               (1)
#define  ATSC_ADDR_26B2_pn63_flag_par_shift                                      (0)
#define  ATSC_ADDR_26B2_pn63_flag_error_and_or_mask                              (0x00000080)
#define  ATSC_ADDR_26B2_pn63_flag_error_02_en_mask                               (0x00000040)
#define  ATSC_ADDR_26B2_pn63_flag_error_2_en_mask                                (0x00000020)
#define  ATSC_ADDR_26B2_pn63_flag_error_0_en_mask                                (0x00000010)
#define  ATSC_ADDR_26B2_pn63_flag_type_sel_mask                                  (0x0000000C)
#define  ATSC_ADDR_26B2_pn63_flag_source_sel_mask                                (0x00000002)
#define  ATSC_ADDR_26B2_pn63_flag_par_mask                                       (0x00000001)
#define  ATSC_ADDR_26B2_pn63_flag_error_and_or(data)                             (0x00000080&((data)<<7))
#define  ATSC_ADDR_26B2_pn63_flag_error_02_en(data)                              (0x00000040&((data)<<6))
#define  ATSC_ADDR_26B2_pn63_flag_error_2_en(data)                               (0x00000020&((data)<<5))
#define  ATSC_ADDR_26B2_pn63_flag_error_0_en(data)                               (0x00000010&((data)<<4))
#define  ATSC_ADDR_26B2_pn63_flag_type_sel(data)                                 (0x0000000C&((data)<<2))
#define  ATSC_ADDR_26B2_pn63_flag_source_sel(data)                               (0x00000002&((data)<<1))
#define  ATSC_ADDR_26B2_pn63_flag_par(data)                                      (0x00000001&(data))
#define  ATSC_ADDR_26B2_get_pn63_flag_error_and_or(data)                         ((0x00000080&(data))>>7)
#define  ATSC_ADDR_26B2_get_pn63_flag_error_02_en(data)                          ((0x00000040&(data))>>6)
#define  ATSC_ADDR_26B2_get_pn63_flag_error_2_en(data)                           ((0x00000020&(data))>>5)
#define  ATSC_ADDR_26B2_get_pn63_flag_error_0_en(data)                           ((0x00000010&(data))>>4)
#define  ATSC_ADDR_26B2_get_pn63_flag_type_sel(data)                             ((0x0000000C&(data))>>2)
#define  ATSC_ADDR_26B2_get_pn63_flag_source_sel(data)                           ((0x00000002&(data))>>1)
#define  ATSC_ADDR_26B2_get_pn63_flag_par(data)                                  (0x00000001&(data))

#define  ATSC_ADDR_26B3                                                         0x18155ACC
#define  ATSC_ADDR_26B3_reg_addr                                                 "0xB8155ACC"
#define  ATSC_ADDR_26B3_reg                                                      0xB8155ACC
#define  ATSC_ADDR_26B3_inst_addr                                                "0x0310"
#define  set_ATSC_ADDR_26B3_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26B3_reg)=data)
#define  get_ATSC_ADDR_26B3_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26B3_reg))
#define  ATSC_ADDR_26B3_pn63_flag_load_delay_7_0_shift                           (0)
#define  ATSC_ADDR_26B3_pn63_flag_load_delay_7_0_mask                            (0x000000FF)
#define  ATSC_ADDR_26B3_pn63_flag_load_delay_7_0(data)                           (0x000000FF&(data))
#define  ATSC_ADDR_26B3_get_pn63_flag_load_delay_7_0(data)                       (0x000000FF&(data))

#define  ATSC_ADDR_26B4                                                         0x18155AD0
#define  ATSC_ADDR_26B4_reg_addr                                                 "0xB8155AD0"
#define  ATSC_ADDR_26B4_reg                                                      0xB8155AD0
#define  ATSC_ADDR_26B4_inst_addr                                                "0x0311"
#define  set_ATSC_ADDR_26B4_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26B4_reg)=data)
#define  get_ATSC_ADDR_26B4_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26B4_reg))
#define  ATSC_ADDR_26B4_pn63_flag_load_delay_13_8_shift                          (0)
#define  ATSC_ADDR_26B4_pn63_flag_load_delay_13_8_mask                           (0x0000003F)
#define  ATSC_ADDR_26B4_pn63_flag_load_delay_13_8(data)                          (0x0000003F&(data))
#define  ATSC_ADDR_26B4_get_pn63_flag_load_delay_13_8(data)                      (0x0000003F&(data))

#define  ATSC_ADDR_26B5                                                         0x18155AD4
#define  ATSC_ADDR_26B5_reg_addr                                                 "0xB8155AD4"
#define  ATSC_ADDR_26B5_reg                                                      0xB8155AD4
#define  ATSC_ADDR_26B5_inst_addr                                                "0x0312"
#define  set_ATSC_ADDR_26B5_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26B5_reg)=data)
#define  get_ATSC_ADDR_26B5_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26B5_reg))
#define  ATSC_ADDR_26B5_search_cursor_en_shift                                   (2)
#define  ATSC_ADDR_26B5_fs_pn63_re_find_en_shift                                 (1)
#define  ATSC_ADDR_26B5_fs_lock_sel_shift                                        (0)
#define  ATSC_ADDR_26B5_search_cursor_en_mask                                    (0x00000004)
#define  ATSC_ADDR_26B5_fs_pn63_re_find_en_mask                                  (0x00000002)
#define  ATSC_ADDR_26B5_fs_lock_sel_mask                                         (0x00000001)
#define  ATSC_ADDR_26B5_search_cursor_en(data)                                   (0x00000004&((data)<<2))
#define  ATSC_ADDR_26B5_fs_pn63_re_find_en(data)                                 (0x00000002&((data)<<1))
#define  ATSC_ADDR_26B5_fs_lock_sel(data)                                        (0x00000001&(data))
#define  ATSC_ADDR_26B5_get_search_cursor_en(data)                               ((0x00000004&(data))>>2)
#define  ATSC_ADDR_26B5_get_fs_pn63_re_find_en(data)                             ((0x00000002&(data))>>1)
#define  ATSC_ADDR_26B5_get_fs_lock_sel(data)                                    (0x00000001&(data))

#define  ATSC_ADDR_26B6                                                         0x18155AD8
#define  ATSC_ADDR_26B6_reg_addr                                                 "0xB8155AD8"
#define  ATSC_ADDR_26B6_reg                                                      0xB8155AD8
#define  ATSC_ADDR_26B6_inst_addr                                                "0x0313"
#define  set_ATSC_ADDR_26B6_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26B6_reg)=data)
#define  get_ATSC_ADDR_26B6_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26B6_reg))
#define  ATSC_ADDR_26B6_field_sync_lock_delay_7_0_shift                          (0)
#define  ATSC_ADDR_26B6_field_sync_lock_delay_7_0_mask                           (0x000000FF)
#define  ATSC_ADDR_26B6_field_sync_lock_delay_7_0(data)                          (0x000000FF&(data))
#define  ATSC_ADDR_26B6_get_field_sync_lock_delay_7_0(data)                      (0x000000FF&(data))

#define  ATSC_ADDR_26B7                                                         0x18155ADC
#define  ATSC_ADDR_26B7_reg_addr                                                 "0xB8155ADC"
#define  ATSC_ADDR_26B7_reg                                                      0xB8155ADC
#define  ATSC_ADDR_26B7_inst_addr                                                "0x0314"
#define  set_ATSC_ADDR_26B7_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26B7_reg)=data)
#define  get_ATSC_ADDR_26B7_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26B7_reg))
#define  ATSC_ADDR_26B7_field_sync_lock_delay_15_8_shift                         (0)
#define  ATSC_ADDR_26B7_field_sync_lock_delay_15_8_mask                          (0x000000FF)
#define  ATSC_ADDR_26B7_field_sync_lock_delay_15_8(data)                         (0x000000FF&(data))
#define  ATSC_ADDR_26B7_get_field_sync_lock_delay_15_8(data)                     (0x000000FF&(data))

#define  ATSC_ADDR_26B8                                                         0x18155AE0
#define  ATSC_ADDR_26B8_reg_addr                                                 "0xB8155AE0"
#define  ATSC_ADDR_26B8_reg                                                      0xB8155AE0
#define  ATSC_ADDR_26B8_inst_addr                                                "0x0315"
#define  set_ATSC_ADDR_26B8_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26B8_reg)=data)
#define  get_ATSC_ADDR_26B8_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26B8_reg))
#define  ATSC_ADDR_26B8_corr_th2_7_0_shift                                       (0)
#define  ATSC_ADDR_26B8_corr_th2_7_0_mask                                        (0x000000FF)
#define  ATSC_ADDR_26B8_corr_th2_7_0(data)                                       (0x000000FF&(data))
#define  ATSC_ADDR_26B8_get_corr_th2_7_0(data)                                   (0x000000FF&(data))

#define  ATSC_ADDR_26B9                                                         0x18155AE4
#define  ATSC_ADDR_26B9_reg_addr                                                 "0xB8155AE4"
#define  ATSC_ADDR_26B9_reg                                                      0xB8155AE4
#define  ATSC_ADDR_26B9_inst_addr                                                "0x0316"
#define  set_ATSC_ADDR_26B9_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26B9_reg)=data)
#define  get_ATSC_ADDR_26B9_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26B9_reg))
#define  ATSC_ADDR_26B9_training_reserved_en_shift                               (3)
#define  ATSC_ADDR_26B9_corr_th2_10_8_shift                                      (0)
#define  ATSC_ADDR_26B9_training_reserved_en_mask                                (0x00000008)
#define  ATSC_ADDR_26B9_corr_th2_10_8_mask                                       (0x00000007)
#define  ATSC_ADDR_26B9_training_reserved_en(data)                               (0x00000008&((data)<<3))
#define  ATSC_ADDR_26B9_corr_th2_10_8(data)                                      (0x00000007&(data))
#define  ATSC_ADDR_26B9_get_training_reserved_en(data)                           ((0x00000008&(data))>>3)
#define  ATSC_ADDR_26B9_get_corr_th2_10_8(data)                                  (0x00000007&(data))

#define  ATSC_ADDR_26BA                                                         0x18155AE8
#define  ATSC_ADDR_26BA_reg_addr                                                 "0xB8155AE8"
#define  ATSC_ADDR_26BA_reg                                                      0xB8155AE8
#define  ATSC_ADDR_26BA_inst_addr                                                "0x0317"
#define  set_ATSC_ADDR_26BA_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26BA_reg)=data)
#define  get_ATSC_ADDR_26BA_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26BA_reg))
#define  ATSC_ADDR_26BA_ch_esti_seg_6_0_shift                                    (1)
#define  ATSC_ADDR_26BA_ch_esti_en_shift                                         (0)
#define  ATSC_ADDR_26BA_ch_esti_seg_6_0_mask                                     (0x000000FE)
#define  ATSC_ADDR_26BA_ch_esti_en_mask                                          (0x00000001)
#define  ATSC_ADDR_26BA_ch_esti_seg_6_0(data)                                    (0x000000FE&((data)<<1))
#define  ATSC_ADDR_26BA_ch_esti_en(data)                                         (0x00000001&(data))
#define  ATSC_ADDR_26BA_get_ch_esti_seg_6_0(data)                                ((0x000000FE&(data))>>1)
#define  ATSC_ADDR_26BA_get_ch_esti_en(data)                                     (0x00000001&(data))

#define  ATSC_ADDR_26BB                                                         0x18155AEC
#define  ATSC_ADDR_26BB_reg_addr                                                 "0xB8155AEC"
#define  ATSC_ADDR_26BB_reg                                                      0xB8155AEC
#define  ATSC_ADDR_26BB_inst_addr                                                "0x0318"
#define  set_ATSC_ADDR_26BB_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26BB_reg)=data)
#define  get_ATSC_ADDR_26BB_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26BB_reg))
#define  ATSC_ADDR_26BB_ch_esti_seg_8_7_shift                                    (0)
#define  ATSC_ADDR_26BB_ch_esti_seg_8_7_mask                                     (0x00000003)
#define  ATSC_ADDR_26BB_ch_esti_seg_8_7(data)                                    (0x00000003&(data))
#define  ATSC_ADDR_26BB_get_ch_esti_seg_8_7(data)                                (0x00000003&(data))

#define  ATSC_ADDR_26BC                                                         0x18155AF0
#define  ATSC_ADDR_26BC_reg_addr                                                 "0xB8155AF0"
#define  ATSC_ADDR_26BC_reg                                                      0xB8155AF0
#define  ATSC_ADDR_26BC_inst_addr                                                "0x0319"
#define  set_ATSC_ADDR_26BC_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26BC_reg)=data)
#define  get_ATSC_ADDR_26BC_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26BC_reg))
#define  ATSC_ADDR_26BC_ch_esti_sym_1_0_shift                                    (6)
#define  ATSC_ADDR_26BC_ch_esti_volume_shift                                     (0)
#define  ATSC_ADDR_26BC_ch_esti_sym_1_0_mask                                     (0x000000C0)
#define  ATSC_ADDR_26BC_ch_esti_volume_mask                                      (0x0000003F)
#define  ATSC_ADDR_26BC_ch_esti_sym_1_0(data)                                    (0x000000C0&((data)<<6))
#define  ATSC_ADDR_26BC_ch_esti_volume(data)                                     (0x0000003F&(data))
#define  ATSC_ADDR_26BC_get_ch_esti_sym_1_0(data)                                ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_26BC_get_ch_esti_volume(data)                                 (0x0000003F&(data))

#define  ATSC_ADDR_26BD                                                         0x18155AF4
#define  ATSC_ADDR_26BD_reg_addr                                                 "0xB8155AF4"
#define  ATSC_ADDR_26BD_reg                                                      0xB8155AF4
#define  ATSC_ADDR_26BD_inst_addr                                                "0x031A"
#define  set_ATSC_ADDR_26BD_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26BD_reg)=data)
#define  get_ATSC_ADDR_26BD_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26BD_reg))
#define  ATSC_ADDR_26BD_ch_esti_sym_9_2_shift                                    (0)
#define  ATSC_ADDR_26BD_ch_esti_sym_9_2_mask                                     (0x000000FF)
#define  ATSC_ADDR_26BD_ch_esti_sym_9_2(data)                                    (0x000000FF&(data))
#define  ATSC_ADDR_26BD_get_ch_esti_sym_9_2(data)                                (0x000000FF&(data))

#define  ATSC_ADDR_26BE                                                         0x18155AF8
#define  ATSC_ADDR_26BE_reg_addr                                                 "0xB8155AF8"
#define  ATSC_ADDR_26BE_reg                                                      0xB8155AF8
#define  ATSC_ADDR_26BE_inst_addr                                                "0x031B"
#define  set_ATSC_ADDR_26BE_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26BE_reg)=data)
#define  get_ATSC_ADDR_26BE_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26BE_reg))
#define  ATSC_ADDR_26BE_ch_esti_rd_add_6_0_shift                                 (1)
#define  ATSC_ADDR_26BE_ch_esti_rd_en_shift                                      (0)
#define  ATSC_ADDR_26BE_ch_esti_rd_add_6_0_mask                                  (0x000000FE)
#define  ATSC_ADDR_26BE_ch_esti_rd_en_mask                                       (0x00000001)
#define  ATSC_ADDR_26BE_ch_esti_rd_add_6_0(data)                                 (0x000000FE&((data)<<1))
#define  ATSC_ADDR_26BE_ch_esti_rd_en(data)                                      (0x00000001&(data))
#define  ATSC_ADDR_26BE_get_ch_esti_rd_add_6_0(data)                             ((0x000000FE&(data))>>1)
#define  ATSC_ADDR_26BE_get_ch_esti_rd_en(data)                                  (0x00000001&(data))

#define  ATSC_ADDR_26BF                                                         0x18155AFC
#define  ATSC_ADDR_26BF_reg_addr                                                 "0xB8155AFC"
#define  ATSC_ADDR_26BF_reg                                                      0xB8155AFC
#define  ATSC_ADDR_26BF_inst_addr                                                "0x031C"
#define  set_ATSC_ADDR_26BF_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26BF_reg)=data)
#define  get_ATSC_ADDR_26BF_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26BF_reg))
#define  ATSC_ADDR_26BF_ch_esti_int_par_shift                                    (4)
#define  ATSC_ADDR_26BF_ch_esti_sel_shift                                        (3)
#define  ATSC_ADDR_26BF_ch_esti_rd_add_9_7_shift                                 (0)
#define  ATSC_ADDR_26BF_ch_esti_int_par_mask                                     (0x00000010)
#define  ATSC_ADDR_26BF_ch_esti_sel_mask                                         (0x00000008)
#define  ATSC_ADDR_26BF_ch_esti_rd_add_9_7_mask                                  (0x00000007)
#define  ATSC_ADDR_26BF_ch_esti_int_par(data)                                    (0x00000010&((data)<<4))
#define  ATSC_ADDR_26BF_ch_esti_sel(data)                                        (0x00000008&((data)<<3))
#define  ATSC_ADDR_26BF_ch_esti_rd_add_9_7(data)                                 (0x00000007&(data))
#define  ATSC_ADDR_26BF_get_ch_esti_int_par(data)                                ((0x00000010&(data))>>4)
#define  ATSC_ADDR_26BF_get_ch_esti_sel(data)                                    ((0x00000008&(data))>>3)
#define  ATSC_ADDR_26BF_get_ch_esti_rd_add_9_7(data)                             (0x00000007&(data))

#define  ATSC_ADDR_26C0                                                         0x18155B00
#define  ATSC_ADDR_26C0_reg_addr                                                 "0xB8155B00"
#define  ATSC_ADDR_26C0_reg                                                      0xB8155B00
#define  ATSC_ADDR_26C0_inst_addr                                                "0x031D"
#define  set_ATSC_ADDR_26C0_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26C0_reg)=data)
#define  get_ATSC_ADDR_26C0_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26C0_reg))
#define  ATSC_ADDR_26C0_deltaf_ratio_2_0_shift                                   (5)
#define  ATSC_ADDR_26C0_field_tr_offset_shift                                    (0)
#define  ATSC_ADDR_26C0_deltaf_ratio_2_0_mask                                    (0x000000E0)
#define  ATSC_ADDR_26C0_field_tr_offset_mask                                     (0x0000001F)
#define  ATSC_ADDR_26C0_deltaf_ratio_2_0(data)                                   (0x000000E0&((data)<<5))
#define  ATSC_ADDR_26C0_field_tr_offset(data)                                    (0x0000001F&(data))
#define  ATSC_ADDR_26C0_get_deltaf_ratio_2_0(data)                               ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_26C0_get_field_tr_offset(data)                                (0x0000001F&(data))

#define  ATSC_ADDR_26C1                                                         0x18155B04
#define  ATSC_ADDR_26C1_reg_addr                                                 "0xB8155B04"
#define  ATSC_ADDR_26C1_reg                                                      0xB8155B04
#define  ATSC_ADDR_26C1_inst_addr                                                "0x031E"
#define  set_ATSC_ADDR_26C1_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26C1_reg)=data)
#define  get_ATSC_ADDR_26C1_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26C1_reg))
#define  ATSC_ADDR_26C1_deltaf_ratio_6_3_shift                                   (0)
#define  ATSC_ADDR_26C1_deltaf_ratio_6_3_mask                                    (0x0000000F)
#define  ATSC_ADDR_26C1_deltaf_ratio_6_3(data)                                   (0x0000000F&(data))
#define  ATSC_ADDR_26C1_get_deltaf_ratio_6_3(data)                               (0x0000000F&(data))

#define  ATSC_ADDR_26C2                                                         0x18155B08
#define  ATSC_ADDR_26C2_reg_addr                                                 "0xB8155B08"
#define  ATSC_ADDR_26C2_reg                                                      0xB8155B08
#define  ATSC_ADDR_26C2_inst_addr                                                "0x031F"
#define  set_ATSC_ADDR_26C2_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26C2_reg)=data)
#define  get_ATSC_ADDR_26C2_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26C2_reg))
#define  ATSC_ADDR_26C2_fs_tr2_corr_th_4_0_shift                                 (3)
#define  ATSC_ADDR_26C2_fs_tr2_mode_sel_shift                                    (2)
#define  ATSC_ADDR_26C2_fs_tr_corr_sel_shift                                     (1)
#define  ATSC_ADDR_26C2_fs_tr_sel_shift                                          (0)
#define  ATSC_ADDR_26C2_fs_tr2_corr_th_4_0_mask                                  (0x000000F8)
#define  ATSC_ADDR_26C2_fs_tr2_mode_sel_mask                                     (0x00000004)
#define  ATSC_ADDR_26C2_fs_tr_corr_sel_mask                                      (0x00000002)
#define  ATSC_ADDR_26C2_fs_tr_sel_mask                                           (0x00000001)
#define  ATSC_ADDR_26C2_fs_tr2_corr_th_4_0(data)                                 (0x000000F8&((data)<<3))
#define  ATSC_ADDR_26C2_fs_tr2_mode_sel(data)                                    (0x00000004&((data)<<2))
#define  ATSC_ADDR_26C2_fs_tr_corr_sel(data)                                     (0x00000002&((data)<<1))
#define  ATSC_ADDR_26C2_fs_tr_sel(data)                                          (0x00000001&(data))
#define  ATSC_ADDR_26C2_get_fs_tr2_corr_th_4_0(data)                             ((0x000000F8&(data))>>3)
#define  ATSC_ADDR_26C2_get_fs_tr2_mode_sel(data)                                ((0x00000004&(data))>>2)
#define  ATSC_ADDR_26C2_get_fs_tr_corr_sel(data)                                 ((0x00000002&(data))>>1)
#define  ATSC_ADDR_26C2_get_fs_tr_sel(data)                                      (0x00000001&(data))

#define  ATSC_ADDR_26C3                                                         0x18155B0C
#define  ATSC_ADDR_26C3_reg_addr                                                 "0xB8155B0C"
#define  ATSC_ADDR_26C3_reg                                                      0xB8155B0C
#define  ATSC_ADDR_26C3_inst_addr                                                "0x0320"
#define  set_ATSC_ADDR_26C3_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26C3_reg)=data)
#define  get_ATSC_ADDR_26C3_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26C3_reg))
#define  ATSC_ADDR_26C3_fs_tr2_corr_th_12_5_shift                                (0)
#define  ATSC_ADDR_26C3_fs_tr2_corr_th_12_5_mask                                 (0x000000FF)
#define  ATSC_ADDR_26C3_fs_tr2_corr_th_12_5(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_26C3_get_fs_tr2_corr_th_12_5(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_26C4                                                         0x18155B10
#define  ATSC_ADDR_26C4_reg_addr                                                 "0xB8155B10"
#define  ATSC_ADDR_26C4_reg                                                      0xB8155B10
#define  ATSC_ADDR_26C4_inst_addr                                                "0x0321"
#define  set_ATSC_ADDR_26C4_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26C4_reg)=data)
#define  get_ATSC_ADDR_26C4_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26C4_reg))
#define  ATSC_ADDR_26C4_fs_tr2_diff_ratio_shift                                  (0)
#define  ATSC_ADDR_26C4_fs_tr2_diff_ratio_mask                                   (0x0000003F)
#define  ATSC_ADDR_26C4_fs_tr2_diff_ratio(data)                                  (0x0000003F&(data))
#define  ATSC_ADDR_26C4_get_fs_tr2_diff_ratio(data)                              (0x0000003F&(data))

#define  ATSC_ADDR_26C5                                                         0x18155B14
#define  ATSC_ADDR_26C5_reg_addr                                                 "0xB8155B14"
#define  ATSC_ADDR_26C5_reg                                                      0xB8155B14
#define  ATSC_ADDR_26C5_inst_addr                                                "0x0322"
#define  set_ATSC_ADDR_26C5_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26C5_reg)=data)
#define  get_ATSC_ADDR_26C5_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26C5_reg))
#define  ATSC_ADDR_26C5_fs_tr2_max_diff_th_shift                                 (0)
#define  ATSC_ADDR_26C5_fs_tr2_max_diff_th_mask                                  (0x0000003F)
#define  ATSC_ADDR_26C5_fs_tr2_max_diff_th(data)                                 (0x0000003F&(data))
#define  ATSC_ADDR_26C5_get_fs_tr2_max_diff_th(data)                             (0x0000003F&(data))

#define  ATSC_ADDR_26C6                                                         0x18155B18
#define  ATSC_ADDR_26C6_reg_addr                                                 "0xB8155B18"
#define  ATSC_ADDR_26C6_reg                                                      0xB8155B18
#define  ATSC_ADDR_26C6_inst_addr                                                "0x0323"
#define  set_ATSC_ADDR_26C6_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26C6_reg)=data)
#define  get_ATSC_ADDR_26C6_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26C6_reg))
#define  ATSC_ADDR_26C6_fs_tr2_max_offset_shift                                  (0)
#define  ATSC_ADDR_26C6_fs_tr2_max_offset_mask                                   (0x000000FF)
#define  ATSC_ADDR_26C6_fs_tr2_max_offset(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_26C6_get_fs_tr2_max_offset(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_26C7                                                         0x18155B1C
#define  ATSC_ADDR_26C7_reg_addr                                                 "0xB8155B1C"
#define  ATSC_ADDR_26C7_reg                                                      0xB8155B1C
#define  ATSC_ADDR_26C7_inst_addr                                                "0x0324"
#define  set_ATSC_ADDR_26C7_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26C7_reg)=data)
#define  get_ATSC_ADDR_26C7_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26C7_reg))
#define  ATSC_ADDR_26C7_fs_tr2_path_diff_offset_shift                            (0)
#define  ATSC_ADDR_26C7_fs_tr2_path_diff_offset_mask                             (0x00000007)
#define  ATSC_ADDR_26C7_fs_tr2_path_diff_offset(data)                            (0x00000007&(data))
#define  ATSC_ADDR_26C7_get_fs_tr2_path_diff_offset(data)                        (0x00000007&(data))

#define  ATSC_ADDR_26D0                                                         0x18155B40
#define  ATSC_ADDR_26D0_reg_addr                                                 "0xB8155B40"
#define  ATSC_ADDR_26D0_reg                                                      0xB8155B40
#define  ATSC_ADDR_26D0_inst_addr                                                "0x0325"
#define  set_ATSC_ADDR_26D0_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26D0_reg)=data)
#define  get_ATSC_ADDR_26D0_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26D0_reg))
#define  ATSC_ADDR_26D0_ffe_in_ptr_ini_7_0_shift                                 (0)
#define  ATSC_ADDR_26D0_ffe_in_ptr_ini_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_26D0_ffe_in_ptr_ini_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_26D0_get_ffe_in_ptr_ini_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_26D1                                                         0x18155B44
#define  ATSC_ADDR_26D1_reg_addr                                                 "0xB8155B44"
#define  ATSC_ADDR_26D1_reg                                                      0xB8155B44
#define  ATSC_ADDR_26D1_inst_addr                                                "0x0326"
#define  set_ATSC_ADDR_26D1_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_26D1_reg)=data)
#define  get_ATSC_ADDR_26D1_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_26D1_reg))
#define  ATSC_ADDR_26D1_ffe_in_ptr_ini_13_8_shift                                (0)
#define  ATSC_ADDR_26D1_ffe_in_ptr_ini_13_8_mask                                 (0x0000003F)
#define  ATSC_ADDR_26D1_ffe_in_ptr_ini_13_8(data)                                (0x0000003F&(data))
#define  ATSC_ADDR_26D1_get_ffe_in_ptr_ini_13_8(data)                            (0x0000003F&(data))

#define  ATSC_ADDR_2701                                                         0x18155C04
#define  ATSC_ADDR_2701_reg_addr                                                 "0xB8155C04"
#define  ATSC_ADDR_2701_reg                                                      0xB8155C04
#define  ATSC_ADDR_2701_inst_addr                                                "0x0327"
#define  set_ATSC_ADDR_2701_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2701_reg)=data)
#define  get_ATSC_ADDR_2701_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2701_reg))
#define  ATSC_ADDR_2701_ffe_ro_coeff_add_7_0_shift                               (0)
#define  ATSC_ADDR_2701_ffe_ro_coeff_add_7_0_mask                                (0x000000FF)
#define  ATSC_ADDR_2701_ffe_ro_coeff_add_7_0(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_2701_get_ffe_ro_coeff_add_7_0(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_2702                                                         0x18155C08
#define  ATSC_ADDR_2702_reg_addr                                                 "0xB8155C08"
#define  ATSC_ADDR_2702_reg                                                      0xB8155C08
#define  ATSC_ADDR_2702_inst_addr                                                "0x0328"
#define  set_ATSC_ADDR_2702_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2702_reg)=data)
#define  get_ATSC_ADDR_2702_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2702_reg))
#define  ATSC_ADDR_2702_ffe_ro_sum_add_2_0_shift                                 (5)
#define  ATSC_ADDR_2702_ffe_ro_coeff_add_12_8_shift                              (0)
#define  ATSC_ADDR_2702_ffe_ro_sum_add_2_0_mask                                  (0x000000E0)
#define  ATSC_ADDR_2702_ffe_ro_coeff_add_12_8_mask                               (0x0000001F)
#define  ATSC_ADDR_2702_ffe_ro_sum_add_2_0(data)                                 (0x000000E0&((data)<<5))
#define  ATSC_ADDR_2702_ffe_ro_coeff_add_12_8(data)                              (0x0000001F&(data))
#define  ATSC_ADDR_2702_get_ffe_ro_sum_add_2_0(data)                             ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_2702_get_ffe_ro_coeff_add_12_8(data)                          (0x0000001F&(data))

#define  ATSC_ADDR_2703                                                         0x18155C0C
#define  ATSC_ADDR_2703_reg_addr                                                 "0xB8155C0C"
#define  ATSC_ADDR_2703_reg                                                      0xB8155C0C
#define  ATSC_ADDR_2703_inst_addr                                                "0x0329"
#define  set_ATSC_ADDR_2703_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2703_reg)=data)
#define  get_ATSC_ADDR_2703_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2703_reg))
#define  ATSC_ADDR_2703_ffe_ro_max_add_1_0_shift                                 (6)
#define  ATSC_ADDR_2703_ffe_ro_sum_add_8_3_shift                                 (0)
#define  ATSC_ADDR_2703_ffe_ro_max_add_1_0_mask                                  (0x000000C0)
#define  ATSC_ADDR_2703_ffe_ro_sum_add_8_3_mask                                  (0x0000003F)
#define  ATSC_ADDR_2703_ffe_ro_max_add_1_0(data)                                 (0x000000C0&((data)<<6))
#define  ATSC_ADDR_2703_ffe_ro_sum_add_8_3(data)                                 (0x0000003F&(data))
#define  ATSC_ADDR_2703_get_ffe_ro_max_add_1_0(data)                             ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_2703_get_ffe_ro_sum_add_8_3(data)                             (0x0000003F&(data))

#define  ATSC_ADDR_2704                                                         0x18155C10
#define  ATSC_ADDR_2704_reg_addr                                                 "0xB8155C10"
#define  ATSC_ADDR_2704_reg                                                      0xB8155C10
#define  ATSC_ADDR_2704_inst_addr                                                "0x032A"
#define  set_ATSC_ADDR_2704_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2704_reg)=data)
#define  get_ATSC_ADDR_2704_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2704_reg))
#define  ATSC_ADDR_2704_ffe_ro_gc_add_0_shift                                    (7)
#define  ATSC_ADDR_2704_ffe_ro_max_add_8_2_shift                                 (0)
#define  ATSC_ADDR_2704_ffe_ro_gc_add_0_mask                                     (0x00000080)
#define  ATSC_ADDR_2704_ffe_ro_max_add_8_2_mask                                  (0x0000007F)
#define  ATSC_ADDR_2704_ffe_ro_gc_add_0(data)                                    (0x00000080&((data)<<7))
#define  ATSC_ADDR_2704_ffe_ro_max_add_8_2(data)                                 (0x0000007F&(data))
#define  ATSC_ADDR_2704_get_ffe_ro_gc_add_0(data)                                ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2704_get_ffe_ro_max_add_8_2(data)                             (0x0000007F&(data))

#define  ATSC_ADDR_2705                                                         0x18155C14
#define  ATSC_ADDR_2705_reg_addr                                                 "0xB8155C14"
#define  ATSC_ADDR_2705_reg                                                      0xB8155C14
#define  ATSC_ADDR_2705_inst_addr                                                "0x032B"
#define  set_ATSC_ADDR_2705_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2705_reg)=data)
#define  get_ATSC_ADDR_2705_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2705_reg))
#define  ATSC_ADDR_2705_ffe_ro_muc_add_1_0_shift                                 (6)
#define  ATSC_ADDR_2705_ffe_ro_gc_add_6_1_shift                                  (0)
#define  ATSC_ADDR_2705_ffe_ro_muc_add_1_0_mask                                  (0x000000C0)
#define  ATSC_ADDR_2705_ffe_ro_gc_add_6_1_mask                                   (0x0000003F)
#define  ATSC_ADDR_2705_ffe_ro_muc_add_1_0(data)                                 (0x000000C0&((data)<<6))
#define  ATSC_ADDR_2705_ffe_ro_gc_add_6_1(data)                                  (0x0000003F&(data))
#define  ATSC_ADDR_2705_get_ffe_ro_muc_add_1_0(data)                             ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_2705_get_ffe_ro_gc_add_6_1(data)                              (0x0000003F&(data))

#define  ATSC_ADDR_2706                                                         0x18155C18
#define  ATSC_ADDR_2706_reg_addr                                                 "0xB8155C18"
#define  ATSC_ADDR_2706_reg                                                      0xB8155C18
#define  ATSC_ADDR_2706_inst_addr                                                "0x032C"
#define  set_ATSC_ADDR_2706_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2706_reg)=data)
#define  get_ATSC_ADDR_2706_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2706_reg))
#define  ATSC_ADDR_2706_ffe_ro_gc_en_ind_add_1_0_shift                           (6)
#define  ATSC_ADDR_2706_ffe_ro_muc_add_7_2_shift                                 (0)
#define  ATSC_ADDR_2706_ffe_ro_gc_en_ind_add_1_0_mask                            (0x000000C0)
#define  ATSC_ADDR_2706_ffe_ro_muc_add_7_2_mask                                  (0x0000003F)
#define  ATSC_ADDR_2706_ffe_ro_gc_en_ind_add_1_0(data)                           (0x000000C0&((data)<<6))
#define  ATSC_ADDR_2706_ffe_ro_muc_add_7_2(data)                                 (0x0000003F&(data))
#define  ATSC_ADDR_2706_get_ffe_ro_gc_en_ind_add_1_0(data)                       ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_2706_get_ffe_ro_muc_add_7_2(data)                             (0x0000003F&(data))

#define  ATSC_ADDR_2707                                                         0x18155C1C
#define  ATSC_ADDR_2707_reg_addr                                                 "0xB8155C1C"
#define  ATSC_ADDR_2707_reg                                                      0xB8155C1C
#define  ATSC_ADDR_2707_inst_addr                                                "0x032D"
#define  set_ATSC_ADDR_2707_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2707_reg)=data)
#define  get_ATSC_ADDR_2707_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2707_reg))
#define  ATSC_ADDR_2707_ffe_ro_gc_dis_ind_add_2_0_shift                          (5)
#define  ATSC_ADDR_2707_ffe_ro_gc_en_ind_add_6_2_shift                           (0)
#define  ATSC_ADDR_2707_ffe_ro_gc_dis_ind_add_2_0_mask                           (0x000000E0)
#define  ATSC_ADDR_2707_ffe_ro_gc_en_ind_add_6_2_mask                            (0x0000001F)
#define  ATSC_ADDR_2707_ffe_ro_gc_dis_ind_add_2_0(data)                          (0x000000E0&((data)<<5))
#define  ATSC_ADDR_2707_ffe_ro_gc_en_ind_add_6_2(data)                           (0x0000001F&(data))
#define  ATSC_ADDR_2707_get_ffe_ro_gc_dis_ind_add_2_0(data)                      ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_2707_get_ffe_ro_gc_en_ind_add_6_2(data)                       (0x0000001F&(data))

#define  ATSC_ADDR_27FE                                                         0x18155FF8
#define  ATSC_ADDR_27FE_reg_addr                                                 "0xB8155FF8"
#define  ATSC_ADDR_27FE_reg                                                      0xB8155FF8
#define  ATSC_ADDR_27FE_inst_addr                                                "0x032E"
#define  set_ATSC_ADDR_27FE_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27FE_reg)=data)
#define  get_ATSC_ADDR_27FE_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27FE_reg))
#define  ATSC_ADDR_27FE_ffe_ro_gc_dis_ind_add_5_3_shift                          (0)
#define  ATSC_ADDR_27FE_ffe_ro_gc_dis_ind_add_5_3_mask                           (0x00000007)
#define  ATSC_ADDR_27FE_ffe_ro_gc_dis_ind_add_5_3(data)                          (0x00000007&(data))
#define  ATSC_ADDR_27FE_get_ffe_ro_gc_dis_ind_add_5_3(data)                      (0x00000007&(data))

#define  ATSC_ADDR_2708                                                         0x18155C20
#define  ATSC_ADDR_2708_reg_addr                                                 "0xB8155C20"
#define  ATSC_ADDR_2708_reg                                                      0xB8155C20
#define  ATSC_ADDR_2708_inst_addr                                                "0x032F"
#define  set_ATSC_ADDR_2708_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2708_reg)=data)
#define  get_ATSC_ADDR_2708_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2708_reg))
#define  ATSC_ADDR_2708_ffe_main_head_5_0_shift                                  (2)
#define  ATSC_ADDR_2708_ffe_mu_comp_exp_shift                                    (1)
#define  ATSC_ADDR_2708_ffe_mu_comp_on_shift                                     (0)
#define  ATSC_ADDR_2708_ffe_main_head_5_0_mask                                   (0x000000FC)
#define  ATSC_ADDR_2708_ffe_mu_comp_exp_mask                                     (0x00000002)
#define  ATSC_ADDR_2708_ffe_mu_comp_on_mask                                      (0x00000001)
#define  ATSC_ADDR_2708_ffe_main_head_5_0(data)                                  (0x000000FC&((data)<<2))
#define  ATSC_ADDR_2708_ffe_mu_comp_exp(data)                                    (0x00000002&((data)<<1))
#define  ATSC_ADDR_2708_ffe_mu_comp_on(data)                                     (0x00000001&(data))
#define  ATSC_ADDR_2708_get_ffe_main_head_5_0(data)                              ((0x000000FC&(data))>>2)
#define  ATSC_ADDR_2708_get_ffe_mu_comp_exp(data)                                ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2708_get_ffe_mu_comp_on(data)                                 (0x00000001&(data))

#define  ATSC_ADDR_2709                                                         0x18155C24
#define  ATSC_ADDR_2709_reg_addr                                                 "0xB8155C24"
#define  ATSC_ADDR_2709_reg                                                      0xB8155C24
#define  ATSC_ADDR_2709_inst_addr                                                "0x0330"
#define  set_ATSC_ADDR_2709_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2709_reg)=data)
#define  get_ATSC_ADDR_2709_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2709_reg))
#define  ATSC_ADDR_2709_ffe_in_sel_shift                                         (7)
#define  ATSC_ADDR_2709_ffe_out_clip_ind_rst_shift                               (6)
#define  ATSC_ADDR_2709_ffe_main_end_2_0_shift                                   (3)
#define  ATSC_ADDR_2709_ffe_main_head_8_6_shift                                  (0)
#define  ATSC_ADDR_2709_ffe_in_sel_mask                                          (0x00000080)
#define  ATSC_ADDR_2709_ffe_out_clip_ind_rst_mask                                (0x00000040)
#define  ATSC_ADDR_2709_ffe_main_end_2_0_mask                                    (0x00000038)
#define  ATSC_ADDR_2709_ffe_main_head_8_6_mask                                   (0x00000007)
#define  ATSC_ADDR_2709_ffe_in_sel(data)                                         (0x00000080&((data)<<7))
#define  ATSC_ADDR_2709_ffe_out_clip_ind_rst(data)                               (0x00000040&((data)<<6))
#define  ATSC_ADDR_2709_ffe_main_end_2_0(data)                                   (0x00000038&((data)<<3))
#define  ATSC_ADDR_2709_ffe_main_head_8_6(data)                                  (0x00000007&(data))
#define  ATSC_ADDR_2709_get_ffe_in_sel(data)                                     ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2709_get_ffe_out_clip_ind_rst(data)                           ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2709_get_ffe_main_end_2_0(data)                               ((0x00000038&(data))>>3)
#define  ATSC_ADDR_2709_get_ffe_main_head_8_6(data)                              (0x00000007&(data))

#define  ATSC_ADDR_27FF                                                         0x18155FFC
#define  ATSC_ADDR_27FF_reg_addr                                                 "0xB8155FFC"
#define  ATSC_ADDR_27FF_reg                                                      0xB8155FFC
#define  ATSC_ADDR_27FF_inst_addr                                                "0x0331"
#define  set_ATSC_ADDR_27FF_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27FF_reg)=data)
#define  get_ATSC_ADDR_27FF_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27FF_reg))
#define  ATSC_ADDR_27FF_ffe_main_end_8_3_shift                                   (0)
#define  ATSC_ADDR_27FF_ffe_main_end_8_3_mask                                    (0x0000003F)
#define  ATSC_ADDR_27FF_ffe_main_end_8_3(data)                                   (0x0000003F&(data))
#define  ATSC_ADDR_27FF_get_ffe_main_end_8_3(data)                               (0x0000003F&(data))

#define  ATSC_ADDR_2713                                                         0x18155C4C
#define  ATSC_ADDR_2713_reg_addr                                                 "0xB8155C4C"
#define  ATSC_ADDR_2713_reg                                                      0xB8155C4C
#define  ATSC_ADDR_2713_inst_addr                                                "0x0332"
#define  set_ATSC_ADDR_2713_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2713_reg)=data)
#define  get_ATSC_ADDR_2713_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2713_reg))
#define  ATSC_ADDR_2713_ffe_struc_sel_shift                                      (1)
#define  ATSC_ADDR_2713_ffe_sp_coeff_max_en_th_11_shift                          (0)
#define  ATSC_ADDR_2713_ffe_struc_sel_mask                                       (0x0000000E)
#define  ATSC_ADDR_2713_ffe_sp_coeff_max_en_th_11_mask                           (0x00000001)
#define  ATSC_ADDR_2713_ffe_struc_sel(data)                                      (0x0000000E&((data)<<1))
#define  ATSC_ADDR_2713_ffe_sp_coeff_max_en_th_11(data)                          (0x00000001&(data))
#define  ATSC_ADDR_2713_get_ffe_struc_sel(data)                                  ((0x0000000E&(data))>>1)
#define  ATSC_ADDR_2713_get_ffe_sp_coeff_max_en_th_11(data)                      (0x00000001&(data))

#define  ATSC_ADDR_270A                                                         0x18155C28
#define  ATSC_ADDR_270A_reg_addr                                                 "0xB8155C28"
#define  ATSC_ADDR_270A_reg                                                      0xB8155C28
#define  ATSC_ADDR_270A_inst_addr                                                "0x0333"
#define  set_ATSC_ADDR_270A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_270A_reg)=data)
#define  get_ATSC_ADDR_270A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_270A_reg))
#define  ATSC_ADDR_270A_ffe_cluster_addr_r_3_8_shift                             (7)
#define  ATSC_ADDR_270A_ffe_cluster_addr_r_2_8_shift                             (6)
#define  ATSC_ADDR_270A_ffe_cluster_addr_r_1_8_shift                             (5)
#define  ATSC_ADDR_270A_ffe_cluster_addr_r_0_8_shift                             (4)
#define  ATSC_ADDR_270A_ffe_sp_coeff_sum_max_clr_shift                           (3)
#define  ATSC_ADDR_270A_ffe_sp_dc_trig_r_shift                                   (2)
#define  ATSC_ADDR_270A_ffe_sp_ctrl_sel_shift                                    (1)
#define  ATSC_ADDR_270A_ffe_sp_hold_shift                                        (0)
#define  ATSC_ADDR_270A_ffe_cluster_addr_r_3_8_mask                              (0x00000080)
#define  ATSC_ADDR_270A_ffe_cluster_addr_r_2_8_mask                              (0x00000040)
#define  ATSC_ADDR_270A_ffe_cluster_addr_r_1_8_mask                              (0x00000020)
#define  ATSC_ADDR_270A_ffe_cluster_addr_r_0_8_mask                              (0x00000010)
#define  ATSC_ADDR_270A_ffe_sp_coeff_sum_max_clr_mask                            (0x00000008)
#define  ATSC_ADDR_270A_ffe_sp_dc_trig_r_mask                                    (0x00000004)
#define  ATSC_ADDR_270A_ffe_sp_ctrl_sel_mask                                     (0x00000002)
#define  ATSC_ADDR_270A_ffe_sp_hold_mask                                         (0x00000001)
#define  ATSC_ADDR_270A_ffe_cluster_addr_r_3_8(data)                             (0x00000080&((data)<<7))
#define  ATSC_ADDR_270A_ffe_cluster_addr_r_2_8(data)                             (0x00000040&((data)<<6))
#define  ATSC_ADDR_270A_ffe_cluster_addr_r_1_8(data)                             (0x00000020&((data)<<5))
#define  ATSC_ADDR_270A_ffe_cluster_addr_r_0_8(data)                             (0x00000010&((data)<<4))
#define  ATSC_ADDR_270A_ffe_sp_coeff_sum_max_clr(data)                           (0x00000008&((data)<<3))
#define  ATSC_ADDR_270A_ffe_sp_dc_trig_r(data)                                   (0x00000004&((data)<<2))
#define  ATSC_ADDR_270A_ffe_sp_ctrl_sel(data)                                    (0x00000002&((data)<<1))
#define  ATSC_ADDR_270A_ffe_sp_hold(data)                                        (0x00000001&(data))
#define  ATSC_ADDR_270A_get_ffe_cluster_addr_r_3_8(data)                         ((0x00000080&(data))>>7)
#define  ATSC_ADDR_270A_get_ffe_cluster_addr_r_2_8(data)                         ((0x00000040&(data))>>6)
#define  ATSC_ADDR_270A_get_ffe_cluster_addr_r_1_8(data)                         ((0x00000020&(data))>>5)
#define  ATSC_ADDR_270A_get_ffe_cluster_addr_r_0_8(data)                         ((0x00000010&(data))>>4)
#define  ATSC_ADDR_270A_get_ffe_sp_coeff_sum_max_clr(data)                       ((0x00000008&(data))>>3)
#define  ATSC_ADDR_270A_get_ffe_sp_dc_trig_r(data)                               ((0x00000004&(data))>>2)
#define  ATSC_ADDR_270A_get_ffe_sp_ctrl_sel(data)                                ((0x00000002&(data))>>1)
#define  ATSC_ADDR_270A_get_ffe_sp_hold(data)                                    (0x00000001&(data))

#define  ATSC_ADDR_2FCA                                                         0x18157F28
#define  ATSC_ADDR_2FCA_reg_addr                                                 "0xB8157F28"
#define  ATSC_ADDR_2FCA_reg                                                      0xB8157F28
#define  ATSC_ADDR_2FCA_inst_addr                                                "0x0334"
#define  set_ATSC_ADDR_2FCA_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FCA_reg)=data)
#define  get_ATSC_ADDR_2FCA_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FCA_reg))
#define  ATSC_ADDR_2FCA_ffe_cluster_addr_r_0_7_0_shift                           (0)
#define  ATSC_ADDR_2FCA_ffe_cluster_addr_r_0_7_0_mask                            (0x000000FF)
#define  ATSC_ADDR_2FCA_ffe_cluster_addr_r_0_7_0(data)                           (0x000000FF&(data))
#define  ATSC_ADDR_2FCA_get_ffe_cluster_addr_r_0_7_0(data)                       (0x000000FF&(data))

#define  ATSC_ADDR_270B                                                         0x18155C2C
#define  ATSC_ADDR_270B_reg_addr                                                 "0xB8155C2C"
#define  ATSC_ADDR_270B_reg                                                      0xB8155C2C
#define  ATSC_ADDR_270B_inst_addr                                                "0x0335"
#define  set_ATSC_ADDR_270B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_270B_reg)=data)
#define  get_ATSC_ADDR_270B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_270B_reg))
#define  ATSC_ADDR_270B_ffe_cluster_addr_r_1_7_0_shift                           (0)
#define  ATSC_ADDR_270B_ffe_cluster_addr_r_1_7_0_mask                            (0x000000FF)
#define  ATSC_ADDR_270B_ffe_cluster_addr_r_1_7_0(data)                           (0x000000FF&(data))
#define  ATSC_ADDR_270B_get_ffe_cluster_addr_r_1_7_0(data)                       (0x000000FF&(data))

#define  ATSC_ADDR_270C                                                         0x18155C30
#define  ATSC_ADDR_270C_reg_addr                                                 "0xB8155C30"
#define  ATSC_ADDR_270C_reg                                                      0xB8155C30
#define  ATSC_ADDR_270C_inst_addr                                                "0x0336"
#define  set_ATSC_ADDR_270C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_270C_reg)=data)
#define  get_ATSC_ADDR_270C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_270C_reg))
#define  ATSC_ADDR_270C_ffe_cluster_addr_r_2_7_0_shift                           (0)
#define  ATSC_ADDR_270C_ffe_cluster_addr_r_2_7_0_mask                            (0x000000FF)
#define  ATSC_ADDR_270C_ffe_cluster_addr_r_2_7_0(data)                           (0x000000FF&(data))
#define  ATSC_ADDR_270C_get_ffe_cluster_addr_r_2_7_0(data)                       (0x000000FF&(data))

#define  ATSC_ADDR_270D                                                         0x18155C34
#define  ATSC_ADDR_270D_reg_addr                                                 "0xB8155C34"
#define  ATSC_ADDR_270D_reg                                                      0xB8155C34
#define  ATSC_ADDR_270D_inst_addr                                                "0x0337"
#define  set_ATSC_ADDR_270D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_270D_reg)=data)
#define  get_ATSC_ADDR_270D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_270D_reg))
#define  ATSC_ADDR_270D_ffe_cluster_addr_r_3_7_0_shift                           (0)
#define  ATSC_ADDR_270D_ffe_cluster_addr_r_3_7_0_mask                            (0x000000FF)
#define  ATSC_ADDR_270D_ffe_cluster_addr_r_3_7_0(data)                           (0x000000FF&(data))
#define  ATSC_ADDR_270D_get_ffe_cluster_addr_r_3_7_0(data)                       (0x000000FF&(data))

#define  ATSC_ADDR_270E                                                         0x18155C38
#define  ATSC_ADDR_270E_reg_addr                                                 "0xB8155C38"
#define  ATSC_ADDR_270E_reg                                                      0xB8155C38
#define  ATSC_ADDR_270E_inst_addr                                                "0x0338"
#define  set_ATSC_ADDR_270E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_270E_reg)=data)
#define  get_ATSC_ADDR_270E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_270E_reg))
#define  ATSC_ADDR_270E_ffe_sp_prd_field_exp_shift                               (4)
#define  ATSC_ADDR_270E_ffe_sp_start_field_exp_shift                             (0)
#define  ATSC_ADDR_270E_ffe_sp_prd_field_exp_mask                                (0x000000F0)
#define  ATSC_ADDR_270E_ffe_sp_start_field_exp_mask                              (0x0000000F)
#define  ATSC_ADDR_270E_ffe_sp_prd_field_exp(data)                               (0x000000F0&((data)<<4))
#define  ATSC_ADDR_270E_ffe_sp_start_field_exp(data)                             (0x0000000F&(data))
#define  ATSC_ADDR_270E_get_ffe_sp_prd_field_exp(data)                           ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_270E_get_ffe_sp_start_field_exp(data)                         (0x0000000F&(data))

#define  ATSC_ADDR_270F                                                         0x18155C3C
#define  ATSC_ADDR_270F_reg_addr                                                 "0xB8155C3C"
#define  ATSC_ADDR_270F_reg                                                      0xB8155C3C
#define  ATSC_ADDR_270F_inst_addr                                                "0x0339"
#define  set_ATSC_ADDR_270F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_270F_reg)=data)
#define  get_ATSC_ADDR_270F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_270F_reg))
#define  ATSC_ADDR_270F_ffe_sp_check_seg_7_0_shift                               (0)
#define  ATSC_ADDR_270F_ffe_sp_check_seg_7_0_mask                                (0x000000FF)
#define  ATSC_ADDR_270F_ffe_sp_check_seg_7_0(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_270F_get_ffe_sp_check_seg_7_0(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_2710                                                         0x18155C40
#define  ATSC_ADDR_2710_reg_addr                                                 "0xB8155C40"
#define  ATSC_ADDR_2710_reg                                                      0xB8155C40
#define  ATSC_ADDR_2710_inst_addr                                                "0x033A"
#define  set_ATSC_ADDR_2710_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2710_reg)=data)
#define  get_ATSC_ADDR_2710_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2710_reg))
#define  ATSC_ADDR_2710_ffe_sp_coeff_max_dis_th_6_0_shift                        (1)
#define  ATSC_ADDR_2710_ffe_sp_check_seg_8_shift                                 (0)
#define  ATSC_ADDR_2710_ffe_sp_coeff_max_dis_th_6_0_mask                         (0x000000FE)
#define  ATSC_ADDR_2710_ffe_sp_check_seg_8_mask                                  (0x00000001)
#define  ATSC_ADDR_2710_ffe_sp_coeff_max_dis_th_6_0(data)                        (0x000000FE&((data)<<1))
#define  ATSC_ADDR_2710_ffe_sp_check_seg_8(data)                                 (0x00000001&(data))
#define  ATSC_ADDR_2710_get_ffe_sp_coeff_max_dis_th_6_0(data)                    ((0x000000FE&(data))>>1)
#define  ATSC_ADDR_2710_get_ffe_sp_check_seg_8(data)                             (0x00000001&(data))

#define  ATSC_ADDR_2711                                                         0x18155C44
#define  ATSC_ADDR_2711_reg_addr                                                 "0xB8155C44"
#define  ATSC_ADDR_2711_reg                                                      0xB8155C44
#define  ATSC_ADDR_2711_inst_addr                                                "0x033B"
#define  set_ATSC_ADDR_2711_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2711_reg)=data)
#define  get_ATSC_ADDR_2711_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2711_reg))
#define  ATSC_ADDR_2711_ffe_sp_coeff_max_en_th_2_0_shift                         (5)
#define  ATSC_ADDR_2711_ffe_sp_coeff_max_dis_th_11_7_shift                       (0)
#define  ATSC_ADDR_2711_ffe_sp_coeff_max_en_th_2_0_mask                          (0x000000E0)
#define  ATSC_ADDR_2711_ffe_sp_coeff_max_dis_th_11_7_mask                        (0x0000001F)
#define  ATSC_ADDR_2711_ffe_sp_coeff_max_en_th_2_0(data)                         (0x000000E0&((data)<<5))
#define  ATSC_ADDR_2711_ffe_sp_coeff_max_dis_th_11_7(data)                       (0x0000001F&(data))
#define  ATSC_ADDR_2711_get_ffe_sp_coeff_max_en_th_2_0(data)                     ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_2711_get_ffe_sp_coeff_max_dis_th_11_7(data)                   (0x0000001F&(data))

#define  ATSC_ADDR_2712                                                         0x18155C48
#define  ATSC_ADDR_2712_reg_addr                                                 "0xB8155C48"
#define  ATSC_ADDR_2712_reg                                                      0xB8155C48
#define  ATSC_ADDR_2712_inst_addr                                                "0x033C"
#define  set_ATSC_ADDR_2712_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2712_reg)=data)
#define  get_ATSC_ADDR_2712_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2712_reg))
#define  ATSC_ADDR_2712_ffe_sp_coeff_max_en_th_10_3_shift                        (0)
#define  ATSC_ADDR_2712_ffe_sp_coeff_max_en_th_10_3_mask                         (0x000000FF)
#define  ATSC_ADDR_2712_ffe_sp_coeff_max_en_th_10_3(data)                        (0x000000FF&(data))
#define  ATSC_ADDR_2712_get_ffe_sp_coeff_max_en_th_10_3(data)                    (0x000000FF&(data))

#define  ATSC_ADDR_2714                                                         0x18155C50
#define  ATSC_ADDR_2714_reg_addr                                                 "0xB8155C50"
#define  ATSC_ADDR_2714_reg                                                      0xB8155C50
#define  ATSC_ADDR_2714_inst_addr                                                "0x033D"
#define  set_ATSC_ADDR_2714_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2714_reg)=data)
#define  get_ATSC_ADDR_2714_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2714_reg))
#define  ATSC_ADDR_2714_ffe_gc_on_field_exp_shift                                (4)
#define  ATSC_ADDR_2714_ffe_gc_main_protect_en_shift                             (3)
#define  ATSC_ADDR_2714_ffe_gc_tr_odd_off_en_shift                               (2)
#define  ATSC_ADDR_2714_ffe_gc_coeff_sum_max_clr_shift                           (1)
#define  ATSC_ADDR_2714_ffe_gc_en_shift                                          (0)
#define  ATSC_ADDR_2714_ffe_gc_on_field_exp_mask                                 (0x000000F0)
#define  ATSC_ADDR_2714_ffe_gc_main_protect_en_mask                              (0x00000008)
#define  ATSC_ADDR_2714_ffe_gc_tr_odd_off_en_mask                                (0x00000004)
#define  ATSC_ADDR_2714_ffe_gc_coeff_sum_max_clr_mask                            (0x00000002)
#define  ATSC_ADDR_2714_ffe_gc_en_mask                                           (0x00000001)
#define  ATSC_ADDR_2714_ffe_gc_on_field_exp(data)                                (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2714_ffe_gc_main_protect_en(data)                             (0x00000008&((data)<<3))
#define  ATSC_ADDR_2714_ffe_gc_tr_odd_off_en(data)                               (0x00000004&((data)<<2))
#define  ATSC_ADDR_2714_ffe_gc_coeff_sum_max_clr(data)                           (0x00000002&((data)<<1))
#define  ATSC_ADDR_2714_ffe_gc_en(data)                                          (0x00000001&(data))
#define  ATSC_ADDR_2714_get_ffe_gc_on_field_exp(data)                            ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2714_get_ffe_gc_main_protect_en(data)                         ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2714_get_ffe_gc_tr_odd_off_en(data)                           ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2714_get_ffe_gc_coeff_sum_max_clr(data)                       ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2714_get_ffe_gc_en(data)                                      (0x00000001&(data))

#define  ATSC_ADDR_2715                                                         0x18155C54
#define  ATSC_ADDR_2715_reg_addr                                                 "0xB8155C54"
#define  ATSC_ADDR_2715_reg                                                      0xB8155C54
#define  ATSC_ADDR_2715_inst_addr                                                "0x033E"
#define  set_ATSC_ADDR_2715_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2715_reg)=data)
#define  get_ATSC_ADDR_2715_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2715_reg))
#define  ATSC_ADDR_2715_ffe_gc_prd_field_exp_shift                               (4)
#define  ATSC_ADDR_2715_ffe_gc_start_field_exp_shift                             (0)
#define  ATSC_ADDR_2715_ffe_gc_prd_field_exp_mask                                (0x000000F0)
#define  ATSC_ADDR_2715_ffe_gc_start_field_exp_mask                              (0x0000000F)
#define  ATSC_ADDR_2715_ffe_gc_prd_field_exp(data)                               (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2715_ffe_gc_start_field_exp(data)                             (0x0000000F&(data))
#define  ATSC_ADDR_2715_get_ffe_gc_prd_field_exp(data)                           ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2715_get_ffe_gc_start_field_exp(data)                         (0x0000000F&(data))

#define  ATSC_ADDR_2716                                                         0x18155C58
#define  ATSC_ADDR_2716_reg_addr                                                 "0xB8155C58"
#define  ATSC_ADDR_2716_reg                                                      0xB8155C58
#define  ATSC_ADDR_2716_inst_addr                                                "0x033F"
#define  set_ATSC_ADDR_2716_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2716_reg)=data)
#define  get_ATSC_ADDR_2716_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2716_reg))
#define  ATSC_ADDR_2716_ffe_gc_check_seg_7_0_shift                               (0)
#define  ATSC_ADDR_2716_ffe_gc_check_seg_7_0_mask                                (0x000000FF)
#define  ATSC_ADDR_2716_ffe_gc_check_seg_7_0(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_2716_get_ffe_gc_check_seg_7_0(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_2717                                                         0x18155C5C
#define  ATSC_ADDR_2717_reg_addr                                                 "0xB8155C5C"
#define  ATSC_ADDR_2717_reg                                                      0xB8155C5C
#define  ATSC_ADDR_2717_inst_addr                                                "0x0340"
#define  set_ATSC_ADDR_2717_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2717_reg)=data)
#define  get_ATSC_ADDR_2717_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2717_reg))
#define  ATSC_ADDR_2717_ffe_gc_en_sum_th_0_6_0_shift                             (1)
#define  ATSC_ADDR_2717_ffe_gc_check_seg_8_shift                                 (0)
#define  ATSC_ADDR_2717_ffe_gc_en_sum_th_0_6_0_mask                              (0x000000FE)
#define  ATSC_ADDR_2717_ffe_gc_check_seg_8_mask                                  (0x00000001)
#define  ATSC_ADDR_2717_ffe_gc_en_sum_th_0_6_0(data)                             (0x000000FE&((data)<<1))
#define  ATSC_ADDR_2717_ffe_gc_check_seg_8(data)                                 (0x00000001&(data))
#define  ATSC_ADDR_2717_get_ffe_gc_en_sum_th_0_6_0(data)                         ((0x000000FE&(data))>>1)
#define  ATSC_ADDR_2717_get_ffe_gc_check_seg_8(data)                             (0x00000001&(data))

#define  ATSC_ADDR_2718                                                         0x18155C60
#define  ATSC_ADDR_2718_reg_addr                                                 "0xB8155C60"
#define  ATSC_ADDR_2718_reg                                                      0xB8155C60
#define  ATSC_ADDR_2718_inst_addr                                                "0x0341"
#define  set_ATSC_ADDR_2718_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2718_reg)=data)
#define  get_ATSC_ADDR_2718_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2718_reg))
#define  ATSC_ADDR_2718_ffe_gc_en_sum_th_1_2_0_shift                             (5)
#define  ATSC_ADDR_2718_ffe_gc_en_sum_th_0_11_7_shift                            (0)
#define  ATSC_ADDR_2718_ffe_gc_en_sum_th_1_2_0_mask                              (0x000000E0)
#define  ATSC_ADDR_2718_ffe_gc_en_sum_th_0_11_7_mask                             (0x0000001F)
#define  ATSC_ADDR_2718_ffe_gc_en_sum_th_1_2_0(data)                             (0x000000E0&((data)<<5))
#define  ATSC_ADDR_2718_ffe_gc_en_sum_th_0_11_7(data)                            (0x0000001F&(data))
#define  ATSC_ADDR_2718_get_ffe_gc_en_sum_th_1_2_0(data)                         ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_2718_get_ffe_gc_en_sum_th_0_11_7(data)                        (0x0000001F&(data))

#define  ATSC_ADDR_2719                                                         0x18155C64
#define  ATSC_ADDR_2719_reg_addr                                                 "0xB8155C64"
#define  ATSC_ADDR_2719_reg                                                      0xB8155C64
#define  ATSC_ADDR_2719_inst_addr                                                "0x0342"
#define  set_ATSC_ADDR_2719_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2719_reg)=data)
#define  get_ATSC_ADDR_2719_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2719_reg))
#define  ATSC_ADDR_2719_ffe_gc_en_sum_th_1_10_3_shift                            (0)
#define  ATSC_ADDR_2719_ffe_gc_en_sum_th_1_10_3_mask                             (0x000000FF)
#define  ATSC_ADDR_2719_ffe_gc_en_sum_th_1_10_3(data)                            (0x000000FF&(data))
#define  ATSC_ADDR_2719_get_ffe_gc_en_sum_th_1_10_3(data)                        (0x000000FF&(data))

#define  ATSC_ADDR_271A                                                         0x18155C68
#define  ATSC_ADDR_271A_reg_addr                                                 "0xB8155C68"
#define  ATSC_ADDR_271A_reg                                                      0xB8155C68
#define  ATSC_ADDR_271A_inst_addr                                                "0x0343"
#define  set_ATSC_ADDR_271A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_271A_reg)=data)
#define  get_ATSC_ADDR_271A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_271A_reg))
#define  ATSC_ADDR_271A_ffe_gc_en_sum_th_2_6_0_shift                             (1)
#define  ATSC_ADDR_271A_ffe_gc_en_sum_th_1_11_shift                              (0)
#define  ATSC_ADDR_271A_ffe_gc_en_sum_th_2_6_0_mask                              (0x000000FE)
#define  ATSC_ADDR_271A_ffe_gc_en_sum_th_1_11_mask                               (0x00000001)
#define  ATSC_ADDR_271A_ffe_gc_en_sum_th_2_6_0(data)                             (0x000000FE&((data)<<1))
#define  ATSC_ADDR_271A_ffe_gc_en_sum_th_1_11(data)                              (0x00000001&(data))
#define  ATSC_ADDR_271A_get_ffe_gc_en_sum_th_2_6_0(data)                         ((0x000000FE&(data))>>1)
#define  ATSC_ADDR_271A_get_ffe_gc_en_sum_th_1_11(data)                          (0x00000001&(data))

#define  ATSC_ADDR_271B                                                         0x18155C6C
#define  ATSC_ADDR_271B_reg_addr                                                 "0xB8155C6C"
#define  ATSC_ADDR_271B_reg                                                      0xB8155C6C
#define  ATSC_ADDR_271B_inst_addr                                                "0x0344"
#define  set_ATSC_ADDR_271B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_271B_reg)=data)
#define  get_ATSC_ADDR_271B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_271B_reg))
#define  ATSC_ADDR_271B_ffe_gc_dis_th_2_0_shift                                  (5)
#define  ATSC_ADDR_271B_ffe_gc_en_sum_th_2_11_7_shift                            (0)
#define  ATSC_ADDR_271B_ffe_gc_dis_th_2_0_mask                                   (0x000000E0)
#define  ATSC_ADDR_271B_ffe_gc_en_sum_th_2_11_7_mask                             (0x0000001F)
#define  ATSC_ADDR_271B_ffe_gc_dis_th_2_0(data)                                  (0x000000E0&((data)<<5))
#define  ATSC_ADDR_271B_ffe_gc_en_sum_th_2_11_7(data)                            (0x0000001F&(data))
#define  ATSC_ADDR_271B_get_ffe_gc_dis_th_2_0(data)                              ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_271B_get_ffe_gc_en_sum_th_2_11_7(data)                        (0x0000001F&(data))

#define  ATSC_ADDR_271C                                                         0x18155C70
#define  ATSC_ADDR_271C_reg_addr                                                 "0xB8155C70"
#define  ATSC_ADDR_271C_reg                                                      0xB8155C70
#define  ATSC_ADDR_271C_inst_addr                                                "0x0345"
#define  set_ATSC_ADDR_271C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_271C_reg)=data)
#define  get_ATSC_ADDR_271C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_271C_reg))
#define  ATSC_ADDR_271C_ffe_gc_dis_th_10_3_shift                                 (0)
#define  ATSC_ADDR_271C_ffe_gc_dis_th_10_3_mask                                  (0x000000FF)
#define  ATSC_ADDR_271C_ffe_gc_dis_th_10_3(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_271C_get_ffe_gc_dis_th_10_3(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_271D                                                         0x18155C74
#define  ATSC_ADDR_271D_reg_addr                                                 "0xB8155C74"
#define  ATSC_ADDR_271D_reg                                                      0xB8155C74
#define  ATSC_ADDR_271D_inst_addr                                                "0x0346"
#define  set_ATSC_ADDR_271D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_271D_reg)=data)
#define  get_ATSC_ADDR_271D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_271D_reg))
#define  ATSC_ADDR_271D_ffe_gc_en_cnt_lb_1_1_0_shift                             (6)
#define  ATSC_ADDR_271D_ffe_gc_en_cnt_lb_0_shift                                 (1)
#define  ATSC_ADDR_271D_ffe_gc_dis_th_11_shift                                   (0)
#define  ATSC_ADDR_271D_ffe_gc_en_cnt_lb_1_1_0_mask                              (0x000000C0)
#define  ATSC_ADDR_271D_ffe_gc_en_cnt_lb_0_mask                                  (0x0000003E)
#define  ATSC_ADDR_271D_ffe_gc_dis_th_11_mask                                    (0x00000001)
#define  ATSC_ADDR_271D_ffe_gc_en_cnt_lb_1_1_0(data)                             (0x000000C0&((data)<<6))
#define  ATSC_ADDR_271D_ffe_gc_en_cnt_lb_0(data)                                 (0x0000003E&((data)<<1))
#define  ATSC_ADDR_271D_ffe_gc_dis_th_11(data)                                   (0x00000001&(data))
#define  ATSC_ADDR_271D_get_ffe_gc_en_cnt_lb_1_1_0(data)                         ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_271D_get_ffe_gc_en_cnt_lb_0(data)                             ((0x0000003E&(data))>>1)
#define  ATSC_ADDR_271D_get_ffe_gc_dis_th_11(data)                               (0x00000001&(data))

#define  ATSC_ADDR_271E                                                         0x18155C78
#define  ATSC_ADDR_271E_reg_addr                                                 "0xB8155C78"
#define  ATSC_ADDR_271E_reg                                                      0xB8155C78
#define  ATSC_ADDR_271E_inst_addr                                                "0x0347"
#define  set_ATSC_ADDR_271E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_271E_reg)=data)
#define  get_ATSC_ADDR_271E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_271E_reg))
#define  ATSC_ADDR_271E_ffe_gc_en_cnt_lb_2_shift                                 (3)
#define  ATSC_ADDR_271E_ffe_gc_en_cnt_lb_1_4_2_shift                             (0)
#define  ATSC_ADDR_271E_ffe_gc_en_cnt_lb_2_mask                                  (0x000000F8)
#define  ATSC_ADDR_271E_ffe_gc_en_cnt_lb_1_4_2_mask                              (0x00000007)
#define  ATSC_ADDR_271E_ffe_gc_en_cnt_lb_2(data)                                 (0x000000F8&((data)<<3))
#define  ATSC_ADDR_271E_ffe_gc_en_cnt_lb_1_4_2(data)                             (0x00000007&(data))
#define  ATSC_ADDR_271E_get_ffe_gc_en_cnt_lb_2(data)                             ((0x000000F8&(data))>>3)
#define  ATSC_ADDR_271E_get_ffe_gc_en_cnt_lb_1_4_2(data)                         (0x00000007&(data))

#define  ATSC_ADDR_271F                                                         0x18155C7C
#define  ATSC_ADDR_271F_reg_addr                                                 "0xB8155C7C"
#define  ATSC_ADDR_271F_reg                                                      0xB8155C7C
#define  ATSC_ADDR_271F_inst_addr                                                "0x0348"
#define  set_ATSC_ADDR_271F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_271F_reg)=data)
#define  get_ATSC_ADDR_271F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_271F_reg))
#define  ATSC_ADDR_271F_ffe_gc_dis_cnt_lb_2_0_shift                              (5)
#define  ATSC_ADDR_271F_ffe_gc_dis2en_cnt_lb_shift                               (0)
#define  ATSC_ADDR_271F_ffe_gc_dis_cnt_lb_2_0_mask                               (0x000000E0)
#define  ATSC_ADDR_271F_ffe_gc_dis2en_cnt_lb_mask                                (0x0000001F)
#define  ATSC_ADDR_271F_ffe_gc_dis_cnt_lb_2_0(data)                              (0x000000E0&((data)<<5))
#define  ATSC_ADDR_271F_ffe_gc_dis2en_cnt_lb(data)                               (0x0000001F&(data))
#define  ATSC_ADDR_271F_get_ffe_gc_dis_cnt_lb_2_0(data)                          ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_271F_get_ffe_gc_dis2en_cnt_lb(data)                           (0x0000001F&(data))

#define  ATSC_ADDR_2720                                                         0x18155C80
#define  ATSC_ADDR_2720_reg_addr                                                 "0xB8155C80"
#define  ATSC_ADDR_2720_reg                                                      0xB8155C80
#define  ATSC_ADDR_2720_inst_addr                                                "0x0349"
#define  set_ATSC_ADDR_2720_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2720_reg)=data)
#define  get_ATSC_ADDR_2720_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2720_reg))
#define  ATSC_ADDR_2720_ffe_gc_dis2en_num_ub_3_0_shift                           (4)
#define  ATSC_ADDR_2720_ffe_gc_range_exp_shift                                   (2)
#define  ATSC_ADDR_2720_ffe_gc_dis_cnt_lb_4_3_shift                              (0)
#define  ATSC_ADDR_2720_ffe_gc_dis2en_num_ub_3_0_mask                            (0x000000F0)
#define  ATSC_ADDR_2720_ffe_gc_range_exp_mask                                    (0x0000000C)
#define  ATSC_ADDR_2720_ffe_gc_dis_cnt_lb_4_3_mask                               (0x00000003)
#define  ATSC_ADDR_2720_ffe_gc_dis2en_num_ub_3_0(data)                           (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2720_ffe_gc_range_exp(data)                                   (0x0000000C&((data)<<2))
#define  ATSC_ADDR_2720_ffe_gc_dis_cnt_lb_4_3(data)                              (0x00000003&(data))
#define  ATSC_ADDR_2720_get_ffe_gc_dis2en_num_ub_3_0(data)                       ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2720_get_ffe_gc_range_exp(data)                               ((0x0000000C&(data))>>2)
#define  ATSC_ADDR_2720_get_ffe_gc_dis_cnt_lb_4_3(data)                          (0x00000003&(data))

#define  ATSC_ADDR_2721                                                         0x18155C84
#define  ATSC_ADDR_2721_reg_addr                                                 "0xB8155C84"
#define  ATSC_ADDR_2721_reg                                                      0xB8155C84
#define  ATSC_ADDR_2721_inst_addr                                                "0x034A"
#define  set_ATSC_ADDR_2721_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2721_reg)=data)
#define  get_ATSC_ADDR_2721_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2721_reg))
#define  ATSC_ADDR_2721_ffe_gc_dis2en_num_ub_6_4_shift                           (0)
#define  ATSC_ADDR_2721_ffe_gc_dis2en_num_ub_6_4_mask                            (0x00000007)
#define  ATSC_ADDR_2721_ffe_gc_dis2en_num_ub_6_4(data)                           (0x00000007&(data))
#define  ATSC_ADDR_2721_get_ffe_gc_dis2en_num_ub_6_4(data)                       (0x00000007&(data))

#define  ATSC_ADDR_2722                                                         0x18155C88
#define  ATSC_ADDR_2722_reg_addr                                                 "0xB8155C88"
#define  ATSC_ADDR_2722_reg                                                      0xB8155C88
#define  ATSC_ADDR_2722_inst_addr                                                "0x034B"
#define  set_ATSC_ADDR_2722_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2722_reg)=data)
#define  get_ATSC_ADDR_2722_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2722_reg))
#define  ATSC_ADDR_2722_ffe_sync_space_even_en_7_shift                           (7)
#define  ATSC_ADDR_2722_ffe_sync_space_even_en_6_shift                           (6)
#define  ATSC_ADDR_2722_ffe_sync_space_even_en_5_shift                           (5)
#define  ATSC_ADDR_2722_ffe_sync_space_even_en_4_shift                           (4)
#define  ATSC_ADDR_2722_ffe_sync_space_even_en_3_shift                           (3)
#define  ATSC_ADDR_2722_ffe_sync_space_even_en_2_shift                           (2)
#define  ATSC_ADDR_2722_ffe_sync_space_even_en_1_shift                           (1)
#define  ATSC_ADDR_2722_ffe_sync_space_even_en_0_shift                           (0)
#define  ATSC_ADDR_2722_ffe_sync_space_even_en_7_mask                            (0x00000080)
#define  ATSC_ADDR_2722_ffe_sync_space_even_en_6_mask                            (0x00000040)
#define  ATSC_ADDR_2722_ffe_sync_space_even_en_5_mask                            (0x00000020)
#define  ATSC_ADDR_2722_ffe_sync_space_even_en_4_mask                            (0x00000010)
#define  ATSC_ADDR_2722_ffe_sync_space_even_en_3_mask                            (0x00000008)
#define  ATSC_ADDR_2722_ffe_sync_space_even_en_2_mask                            (0x00000004)
#define  ATSC_ADDR_2722_ffe_sync_space_even_en_1_mask                            (0x00000002)
#define  ATSC_ADDR_2722_ffe_sync_space_even_en_0_mask                            (0x00000001)
#define  ATSC_ADDR_2722_ffe_sync_space_even_en_7(data)                           (0x00000080&((data)<<7))
#define  ATSC_ADDR_2722_ffe_sync_space_even_en_6(data)                           (0x00000040&((data)<<6))
#define  ATSC_ADDR_2722_ffe_sync_space_even_en_5(data)                           (0x00000020&((data)<<5))
#define  ATSC_ADDR_2722_ffe_sync_space_even_en_4(data)                           (0x00000010&((data)<<4))
#define  ATSC_ADDR_2722_ffe_sync_space_even_en_3(data)                           (0x00000008&((data)<<3))
#define  ATSC_ADDR_2722_ffe_sync_space_even_en_2(data)                           (0x00000004&((data)<<2))
#define  ATSC_ADDR_2722_ffe_sync_space_even_en_1(data)                           (0x00000002&((data)<<1))
#define  ATSC_ADDR_2722_ffe_sync_space_even_en_0(data)                           (0x00000001&(data))
#define  ATSC_ADDR_2722_get_ffe_sync_space_even_en_7(data)                       ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2722_get_ffe_sync_space_even_en_6(data)                       ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2722_get_ffe_sync_space_even_en_5(data)                       ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2722_get_ffe_sync_space_even_en_4(data)                       ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2722_get_ffe_sync_space_even_en_3(data)                       ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2722_get_ffe_sync_space_even_en_2(data)                       ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2722_get_ffe_sync_space_even_en_1(data)                       ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2722_get_ffe_sync_space_even_en_0(data)                       (0x00000001&(data))

#define  ATSC_ADDR_2723                                                         0x18155C8C
#define  ATSC_ADDR_2723_reg_addr                                                 "0xB8155C8C"
#define  ATSC_ADDR_2723_reg                                                      0xB8155C8C
#define  ATSC_ADDR_2723_inst_addr                                                "0x034C"
#define  set_ATSC_ADDR_2723_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2723_reg)=data)
#define  get_ATSC_ADDR_2723_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2723_reg))
#define  ATSC_ADDR_2723_ffe_sync_space_even_en_15_shift                          (7)
#define  ATSC_ADDR_2723_ffe_sync_space_even_en_14_shift                          (6)
#define  ATSC_ADDR_2723_ffe_sync_space_even_en_13_shift                          (5)
#define  ATSC_ADDR_2723_ffe_sync_space_even_en_12_shift                          (4)
#define  ATSC_ADDR_2723_ffe_sync_space_even_en_11_shift                          (3)
#define  ATSC_ADDR_2723_ffe_sync_space_even_en_10_shift                          (2)
#define  ATSC_ADDR_2723_ffe_sync_space_even_en_9_shift                           (1)
#define  ATSC_ADDR_2723_ffe_sync_space_even_en_8_shift                           (0)
#define  ATSC_ADDR_2723_ffe_sync_space_even_en_15_mask                           (0x00000080)
#define  ATSC_ADDR_2723_ffe_sync_space_even_en_14_mask                           (0x00000040)
#define  ATSC_ADDR_2723_ffe_sync_space_even_en_13_mask                           (0x00000020)
#define  ATSC_ADDR_2723_ffe_sync_space_even_en_12_mask                           (0x00000010)
#define  ATSC_ADDR_2723_ffe_sync_space_even_en_11_mask                           (0x00000008)
#define  ATSC_ADDR_2723_ffe_sync_space_even_en_10_mask                           (0x00000004)
#define  ATSC_ADDR_2723_ffe_sync_space_even_en_9_mask                            (0x00000002)
#define  ATSC_ADDR_2723_ffe_sync_space_even_en_8_mask                            (0x00000001)
#define  ATSC_ADDR_2723_ffe_sync_space_even_en_15(data)                          (0x00000080&((data)<<7))
#define  ATSC_ADDR_2723_ffe_sync_space_even_en_14(data)                          (0x00000040&((data)<<6))
#define  ATSC_ADDR_2723_ffe_sync_space_even_en_13(data)                          (0x00000020&((data)<<5))
#define  ATSC_ADDR_2723_ffe_sync_space_even_en_12(data)                          (0x00000010&((data)<<4))
#define  ATSC_ADDR_2723_ffe_sync_space_even_en_11(data)                          (0x00000008&((data)<<3))
#define  ATSC_ADDR_2723_ffe_sync_space_even_en_10(data)                          (0x00000004&((data)<<2))
#define  ATSC_ADDR_2723_ffe_sync_space_even_en_9(data)                           (0x00000002&((data)<<1))
#define  ATSC_ADDR_2723_ffe_sync_space_even_en_8(data)                           (0x00000001&(data))
#define  ATSC_ADDR_2723_get_ffe_sync_space_even_en_15(data)                      ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2723_get_ffe_sync_space_even_en_14(data)                      ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2723_get_ffe_sync_space_even_en_13(data)                      ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2723_get_ffe_sync_space_even_en_12(data)                      ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2723_get_ffe_sync_space_even_en_11(data)                      ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2723_get_ffe_sync_space_even_en_10(data)                      ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2723_get_ffe_sync_space_even_en_9(data)                       ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2723_get_ffe_sync_space_even_en_8(data)                       (0x00000001&(data))

#define  ATSC_ADDR_2724                                                         0x18155C90
#define  ATSC_ADDR_2724_reg_addr                                                 "0xB8155C90"
#define  ATSC_ADDR_2724_reg                                                      0xB8155C90
#define  ATSC_ADDR_2724_inst_addr                                                "0x034D"
#define  set_ATSC_ADDR_2724_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2724_reg)=data)
#define  get_ATSC_ADDR_2724_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2724_reg))
#define  ATSC_ADDR_2724_ffe_sync_space_even_en_23_shift                          (7)
#define  ATSC_ADDR_2724_ffe_sync_space_even_en_22_shift                          (6)
#define  ATSC_ADDR_2724_ffe_sync_space_even_en_21_shift                          (5)
#define  ATSC_ADDR_2724_ffe_sync_space_even_en_20_shift                          (4)
#define  ATSC_ADDR_2724_ffe_sync_space_even_en_19_shift                          (3)
#define  ATSC_ADDR_2724_ffe_sync_space_even_en_18_shift                          (2)
#define  ATSC_ADDR_2724_ffe_sync_space_even_en_17_shift                          (1)
#define  ATSC_ADDR_2724_ffe_sync_space_even_en_16_shift                          (0)
#define  ATSC_ADDR_2724_ffe_sync_space_even_en_23_mask                           (0x00000080)
#define  ATSC_ADDR_2724_ffe_sync_space_even_en_22_mask                           (0x00000040)
#define  ATSC_ADDR_2724_ffe_sync_space_even_en_21_mask                           (0x00000020)
#define  ATSC_ADDR_2724_ffe_sync_space_even_en_20_mask                           (0x00000010)
#define  ATSC_ADDR_2724_ffe_sync_space_even_en_19_mask                           (0x00000008)
#define  ATSC_ADDR_2724_ffe_sync_space_even_en_18_mask                           (0x00000004)
#define  ATSC_ADDR_2724_ffe_sync_space_even_en_17_mask                           (0x00000002)
#define  ATSC_ADDR_2724_ffe_sync_space_even_en_16_mask                           (0x00000001)
#define  ATSC_ADDR_2724_ffe_sync_space_even_en_23(data)                          (0x00000080&((data)<<7))
#define  ATSC_ADDR_2724_ffe_sync_space_even_en_22(data)                          (0x00000040&((data)<<6))
#define  ATSC_ADDR_2724_ffe_sync_space_even_en_21(data)                          (0x00000020&((data)<<5))
#define  ATSC_ADDR_2724_ffe_sync_space_even_en_20(data)                          (0x00000010&((data)<<4))
#define  ATSC_ADDR_2724_ffe_sync_space_even_en_19(data)                          (0x00000008&((data)<<3))
#define  ATSC_ADDR_2724_ffe_sync_space_even_en_18(data)                          (0x00000004&((data)<<2))
#define  ATSC_ADDR_2724_ffe_sync_space_even_en_17(data)                          (0x00000002&((data)<<1))
#define  ATSC_ADDR_2724_ffe_sync_space_even_en_16(data)                          (0x00000001&(data))
#define  ATSC_ADDR_2724_get_ffe_sync_space_even_en_23(data)                      ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2724_get_ffe_sync_space_even_en_22(data)                      ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2724_get_ffe_sync_space_even_en_21(data)                      ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2724_get_ffe_sync_space_even_en_20(data)                      ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2724_get_ffe_sync_space_even_en_19(data)                      ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2724_get_ffe_sync_space_even_en_18(data)                      ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2724_get_ffe_sync_space_even_en_17(data)                      ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2724_get_ffe_sync_space_even_en_16(data)                      (0x00000001&(data))

#define  ATSC_ADDR_2725                                                         0x18155C94
#define  ATSC_ADDR_2725_reg_addr                                                 "0xB8155C94"
#define  ATSC_ADDR_2725_reg                                                      0xB8155C94
#define  ATSC_ADDR_2725_inst_addr                                                "0x034E"
#define  set_ATSC_ADDR_2725_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2725_reg)=data)
#define  get_ATSC_ADDR_2725_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2725_reg))
#define  ATSC_ADDR_2725_ffe_sync_space_even_en_31_shift                          (7)
#define  ATSC_ADDR_2725_ffe_sync_space_even_en_30_shift                          (6)
#define  ATSC_ADDR_2725_ffe_sync_space_even_en_29_shift                          (5)
#define  ATSC_ADDR_2725_ffe_sync_space_even_en_28_shift                          (4)
#define  ATSC_ADDR_2725_ffe_sync_space_even_en_27_shift                          (3)
#define  ATSC_ADDR_2725_ffe_sync_space_even_en_26_shift                          (2)
#define  ATSC_ADDR_2725_ffe_sync_space_even_en_25_shift                          (1)
#define  ATSC_ADDR_2725_ffe_sync_space_even_en_24_shift                          (0)
#define  ATSC_ADDR_2725_ffe_sync_space_even_en_31_mask                           (0x00000080)
#define  ATSC_ADDR_2725_ffe_sync_space_even_en_30_mask                           (0x00000040)
#define  ATSC_ADDR_2725_ffe_sync_space_even_en_29_mask                           (0x00000020)
#define  ATSC_ADDR_2725_ffe_sync_space_even_en_28_mask                           (0x00000010)
#define  ATSC_ADDR_2725_ffe_sync_space_even_en_27_mask                           (0x00000008)
#define  ATSC_ADDR_2725_ffe_sync_space_even_en_26_mask                           (0x00000004)
#define  ATSC_ADDR_2725_ffe_sync_space_even_en_25_mask                           (0x00000002)
#define  ATSC_ADDR_2725_ffe_sync_space_even_en_24_mask                           (0x00000001)
#define  ATSC_ADDR_2725_ffe_sync_space_even_en_31(data)                          (0x00000080&((data)<<7))
#define  ATSC_ADDR_2725_ffe_sync_space_even_en_30(data)                          (0x00000040&((data)<<6))
#define  ATSC_ADDR_2725_ffe_sync_space_even_en_29(data)                          (0x00000020&((data)<<5))
#define  ATSC_ADDR_2725_ffe_sync_space_even_en_28(data)                          (0x00000010&((data)<<4))
#define  ATSC_ADDR_2725_ffe_sync_space_even_en_27(data)                          (0x00000008&((data)<<3))
#define  ATSC_ADDR_2725_ffe_sync_space_even_en_26(data)                          (0x00000004&((data)<<2))
#define  ATSC_ADDR_2725_ffe_sync_space_even_en_25(data)                          (0x00000002&((data)<<1))
#define  ATSC_ADDR_2725_ffe_sync_space_even_en_24(data)                          (0x00000001&(data))
#define  ATSC_ADDR_2725_get_ffe_sync_space_even_en_31(data)                      ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2725_get_ffe_sync_space_even_en_30(data)                      ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2725_get_ffe_sync_space_even_en_29(data)                      ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2725_get_ffe_sync_space_even_en_28(data)                      ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2725_get_ffe_sync_space_even_en_27(data)                      ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2725_get_ffe_sync_space_even_en_26(data)                      ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2725_get_ffe_sync_space_even_en_25(data)                      ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2725_get_ffe_sync_space_even_en_24(data)                      (0x00000001&(data))

#define  ATSC_ADDR_2726                                                         0x18155C98
#define  ATSC_ADDR_2726_reg_addr                                                 "0xB8155C98"
#define  ATSC_ADDR_2726_reg                                                      0xB8155C98
#define  ATSC_ADDR_2726_inst_addr                                                "0x034F"
#define  set_ATSC_ADDR_2726_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2726_reg)=data)
#define  get_ATSC_ADDR_2726_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2726_reg))
#define  ATSC_ADDR_2726_ffe_sync_space_even_en_39_shift                          (7)
#define  ATSC_ADDR_2726_ffe_sync_space_even_en_38_shift                          (6)
#define  ATSC_ADDR_2726_ffe_sync_space_even_en_37_shift                          (5)
#define  ATSC_ADDR_2726_ffe_sync_space_even_en_36_shift                          (4)
#define  ATSC_ADDR_2726_ffe_sync_space_even_en_35_shift                          (3)
#define  ATSC_ADDR_2726_ffe_sync_space_even_en_34_shift                          (2)
#define  ATSC_ADDR_2726_ffe_sync_space_even_en_33_shift                          (1)
#define  ATSC_ADDR_2726_ffe_sync_space_even_en_32_shift                          (0)
#define  ATSC_ADDR_2726_ffe_sync_space_even_en_39_mask                           (0x00000080)
#define  ATSC_ADDR_2726_ffe_sync_space_even_en_38_mask                           (0x00000040)
#define  ATSC_ADDR_2726_ffe_sync_space_even_en_37_mask                           (0x00000020)
#define  ATSC_ADDR_2726_ffe_sync_space_even_en_36_mask                           (0x00000010)
#define  ATSC_ADDR_2726_ffe_sync_space_even_en_35_mask                           (0x00000008)
#define  ATSC_ADDR_2726_ffe_sync_space_even_en_34_mask                           (0x00000004)
#define  ATSC_ADDR_2726_ffe_sync_space_even_en_33_mask                           (0x00000002)
#define  ATSC_ADDR_2726_ffe_sync_space_even_en_32_mask                           (0x00000001)
#define  ATSC_ADDR_2726_ffe_sync_space_even_en_39(data)                          (0x00000080&((data)<<7))
#define  ATSC_ADDR_2726_ffe_sync_space_even_en_38(data)                          (0x00000040&((data)<<6))
#define  ATSC_ADDR_2726_ffe_sync_space_even_en_37(data)                          (0x00000020&((data)<<5))
#define  ATSC_ADDR_2726_ffe_sync_space_even_en_36(data)                          (0x00000010&((data)<<4))
#define  ATSC_ADDR_2726_ffe_sync_space_even_en_35(data)                          (0x00000008&((data)<<3))
#define  ATSC_ADDR_2726_ffe_sync_space_even_en_34(data)                          (0x00000004&((data)<<2))
#define  ATSC_ADDR_2726_ffe_sync_space_even_en_33(data)                          (0x00000002&((data)<<1))
#define  ATSC_ADDR_2726_ffe_sync_space_even_en_32(data)                          (0x00000001&(data))
#define  ATSC_ADDR_2726_get_ffe_sync_space_even_en_39(data)                      ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2726_get_ffe_sync_space_even_en_38(data)                      ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2726_get_ffe_sync_space_even_en_37(data)                      ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2726_get_ffe_sync_space_even_en_36(data)                      ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2726_get_ffe_sync_space_even_en_35(data)                      ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2726_get_ffe_sync_space_even_en_34(data)                      ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2726_get_ffe_sync_space_even_en_33(data)                      ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2726_get_ffe_sync_space_even_en_32(data)                      (0x00000001&(data))

#define  ATSC_ADDR_2727                                                         0x18155C9C
#define  ATSC_ADDR_2727_reg_addr                                                 "0xB8155C9C"
#define  ATSC_ADDR_2727_reg                                                      0xB8155C9C
#define  ATSC_ADDR_2727_inst_addr                                                "0x0350"
#define  set_ATSC_ADDR_2727_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2727_reg)=data)
#define  get_ATSC_ADDR_2727_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2727_reg))
#define  ATSC_ADDR_2727_ffe_sync_space_even_en_47_shift                          (7)
#define  ATSC_ADDR_2727_ffe_sync_space_even_en_46_shift                          (6)
#define  ATSC_ADDR_2727_ffe_sync_space_even_en_45_shift                          (5)
#define  ATSC_ADDR_2727_ffe_sync_space_even_en_44_shift                          (4)
#define  ATSC_ADDR_2727_ffe_sync_space_even_en_43_shift                          (3)
#define  ATSC_ADDR_2727_ffe_sync_space_even_en_42_shift                          (2)
#define  ATSC_ADDR_2727_ffe_sync_space_even_en_41_shift                          (1)
#define  ATSC_ADDR_2727_ffe_sync_space_even_en_40_shift                          (0)
#define  ATSC_ADDR_2727_ffe_sync_space_even_en_47_mask                           (0x00000080)
#define  ATSC_ADDR_2727_ffe_sync_space_even_en_46_mask                           (0x00000040)
#define  ATSC_ADDR_2727_ffe_sync_space_even_en_45_mask                           (0x00000020)
#define  ATSC_ADDR_2727_ffe_sync_space_even_en_44_mask                           (0x00000010)
#define  ATSC_ADDR_2727_ffe_sync_space_even_en_43_mask                           (0x00000008)
#define  ATSC_ADDR_2727_ffe_sync_space_even_en_42_mask                           (0x00000004)
#define  ATSC_ADDR_2727_ffe_sync_space_even_en_41_mask                           (0x00000002)
#define  ATSC_ADDR_2727_ffe_sync_space_even_en_40_mask                           (0x00000001)
#define  ATSC_ADDR_2727_ffe_sync_space_even_en_47(data)                          (0x00000080&((data)<<7))
#define  ATSC_ADDR_2727_ffe_sync_space_even_en_46(data)                          (0x00000040&((data)<<6))
#define  ATSC_ADDR_2727_ffe_sync_space_even_en_45(data)                          (0x00000020&((data)<<5))
#define  ATSC_ADDR_2727_ffe_sync_space_even_en_44(data)                          (0x00000010&((data)<<4))
#define  ATSC_ADDR_2727_ffe_sync_space_even_en_43(data)                          (0x00000008&((data)<<3))
#define  ATSC_ADDR_2727_ffe_sync_space_even_en_42(data)                          (0x00000004&((data)<<2))
#define  ATSC_ADDR_2727_ffe_sync_space_even_en_41(data)                          (0x00000002&((data)<<1))
#define  ATSC_ADDR_2727_ffe_sync_space_even_en_40(data)                          (0x00000001&(data))
#define  ATSC_ADDR_2727_get_ffe_sync_space_even_en_47(data)                      ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2727_get_ffe_sync_space_even_en_46(data)                      ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2727_get_ffe_sync_space_even_en_45(data)                      ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2727_get_ffe_sync_space_even_en_44(data)                      ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2727_get_ffe_sync_space_even_en_43(data)                      ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2727_get_ffe_sync_space_even_en_42(data)                      ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2727_get_ffe_sync_space_even_en_41(data)                      ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2727_get_ffe_sync_space_even_en_40(data)                      (0x00000001&(data))

#define  ATSC_ADDR_2FC1                                                         0x18157F04
#define  ATSC_ADDR_2FC1_reg_addr                                                 "0xB8157F04"
#define  ATSC_ADDR_2FC1_reg                                                      0xB8157F04
#define  ATSC_ADDR_2FC1_inst_addr                                                "0x0351"
#define  set_ATSC_ADDR_2FC1_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FC1_reg)=data)
#define  get_ATSC_ADDR_2FC1_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FC1_reg))
#define  ATSC_ADDR_2FC1_ffe_sync_space_even_en_55_shift                          (7)
#define  ATSC_ADDR_2FC1_ffe_sync_space_even_en_54_shift                          (6)
#define  ATSC_ADDR_2FC1_ffe_sync_space_even_en_53_shift                          (5)
#define  ATSC_ADDR_2FC1_ffe_sync_space_even_en_52_shift                          (4)
#define  ATSC_ADDR_2FC1_ffe_sync_space_even_en_51_shift                          (3)
#define  ATSC_ADDR_2FC1_ffe_sync_space_even_en_50_shift                          (2)
#define  ATSC_ADDR_2FC1_ffe_sync_space_even_en_49_shift                          (1)
#define  ATSC_ADDR_2FC1_ffe_sync_space_even_en_48_shift                          (0)
#define  ATSC_ADDR_2FC1_ffe_sync_space_even_en_55_mask                           (0x00000080)
#define  ATSC_ADDR_2FC1_ffe_sync_space_even_en_54_mask                           (0x00000040)
#define  ATSC_ADDR_2FC1_ffe_sync_space_even_en_53_mask                           (0x00000020)
#define  ATSC_ADDR_2FC1_ffe_sync_space_even_en_52_mask                           (0x00000010)
#define  ATSC_ADDR_2FC1_ffe_sync_space_even_en_51_mask                           (0x00000008)
#define  ATSC_ADDR_2FC1_ffe_sync_space_even_en_50_mask                           (0x00000004)
#define  ATSC_ADDR_2FC1_ffe_sync_space_even_en_49_mask                           (0x00000002)
#define  ATSC_ADDR_2FC1_ffe_sync_space_even_en_48_mask                           (0x00000001)
#define  ATSC_ADDR_2FC1_ffe_sync_space_even_en_55(data)                          (0x00000080&((data)<<7))
#define  ATSC_ADDR_2FC1_ffe_sync_space_even_en_54(data)                          (0x00000040&((data)<<6))
#define  ATSC_ADDR_2FC1_ffe_sync_space_even_en_53(data)                          (0x00000020&((data)<<5))
#define  ATSC_ADDR_2FC1_ffe_sync_space_even_en_52(data)                          (0x00000010&((data)<<4))
#define  ATSC_ADDR_2FC1_ffe_sync_space_even_en_51(data)                          (0x00000008&((data)<<3))
#define  ATSC_ADDR_2FC1_ffe_sync_space_even_en_50(data)                          (0x00000004&((data)<<2))
#define  ATSC_ADDR_2FC1_ffe_sync_space_even_en_49(data)                          (0x00000002&((data)<<1))
#define  ATSC_ADDR_2FC1_ffe_sync_space_even_en_48(data)                          (0x00000001&(data))
#define  ATSC_ADDR_2FC1_get_ffe_sync_space_even_en_55(data)                      ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2FC1_get_ffe_sync_space_even_en_54(data)                      ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2FC1_get_ffe_sync_space_even_en_53(data)                      ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2FC1_get_ffe_sync_space_even_en_52(data)                      ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2FC1_get_ffe_sync_space_even_en_51(data)                      ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2FC1_get_ffe_sync_space_even_en_50(data)                      ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2FC1_get_ffe_sync_space_even_en_49(data)                      ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2FC1_get_ffe_sync_space_even_en_48(data)                      (0x00000001&(data))

#define  ATSC_ADDR_2FC2                                                         0x18157F08
#define  ATSC_ADDR_2FC2_reg_addr                                                 "0xB8157F08"
#define  ATSC_ADDR_2FC2_reg                                                      0xB8157F08
#define  ATSC_ADDR_2FC2_inst_addr                                                "0x0352"
#define  set_ATSC_ADDR_2FC2_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FC2_reg)=data)
#define  get_ATSC_ADDR_2FC2_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FC2_reg))
#define  ATSC_ADDR_2FC2_ffe_sync_space_even_en_63_shift                          (7)
#define  ATSC_ADDR_2FC2_ffe_sync_space_even_en_62_shift                          (6)
#define  ATSC_ADDR_2FC2_ffe_sync_space_even_en_61_shift                          (5)
#define  ATSC_ADDR_2FC2_ffe_sync_space_even_en_60_shift                          (4)
#define  ATSC_ADDR_2FC2_ffe_sync_space_even_en_59_shift                          (3)
#define  ATSC_ADDR_2FC2_ffe_sync_space_even_en_58_shift                          (2)
#define  ATSC_ADDR_2FC2_ffe_sync_space_even_en_57_shift                          (1)
#define  ATSC_ADDR_2FC2_ffe_sync_space_even_en_56_shift                          (0)
#define  ATSC_ADDR_2FC2_ffe_sync_space_even_en_63_mask                           (0x00000080)
#define  ATSC_ADDR_2FC2_ffe_sync_space_even_en_62_mask                           (0x00000040)
#define  ATSC_ADDR_2FC2_ffe_sync_space_even_en_61_mask                           (0x00000020)
#define  ATSC_ADDR_2FC2_ffe_sync_space_even_en_60_mask                           (0x00000010)
#define  ATSC_ADDR_2FC2_ffe_sync_space_even_en_59_mask                           (0x00000008)
#define  ATSC_ADDR_2FC2_ffe_sync_space_even_en_58_mask                           (0x00000004)
#define  ATSC_ADDR_2FC2_ffe_sync_space_even_en_57_mask                           (0x00000002)
#define  ATSC_ADDR_2FC2_ffe_sync_space_even_en_56_mask                           (0x00000001)
#define  ATSC_ADDR_2FC2_ffe_sync_space_even_en_63(data)                          (0x00000080&((data)<<7))
#define  ATSC_ADDR_2FC2_ffe_sync_space_even_en_62(data)                          (0x00000040&((data)<<6))
#define  ATSC_ADDR_2FC2_ffe_sync_space_even_en_61(data)                          (0x00000020&((data)<<5))
#define  ATSC_ADDR_2FC2_ffe_sync_space_even_en_60(data)                          (0x00000010&((data)<<4))
#define  ATSC_ADDR_2FC2_ffe_sync_space_even_en_59(data)                          (0x00000008&((data)<<3))
#define  ATSC_ADDR_2FC2_ffe_sync_space_even_en_58(data)                          (0x00000004&((data)<<2))
#define  ATSC_ADDR_2FC2_ffe_sync_space_even_en_57(data)                          (0x00000002&((data)<<1))
#define  ATSC_ADDR_2FC2_ffe_sync_space_even_en_56(data)                          (0x00000001&(data))
#define  ATSC_ADDR_2FC2_get_ffe_sync_space_even_en_63(data)                      ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2FC2_get_ffe_sync_space_even_en_62(data)                      ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2FC2_get_ffe_sync_space_even_en_61(data)                      ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2FC2_get_ffe_sync_space_even_en_60(data)                      ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2FC2_get_ffe_sync_space_even_en_59(data)                      ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2FC2_get_ffe_sync_space_even_en_58(data)                      ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2FC2_get_ffe_sync_space_even_en_57(data)                      ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2FC2_get_ffe_sync_space_even_en_56(data)                      (0x00000001&(data))

#define  ATSC_ADDR_28F0                                                         0x181563C0
#define  ATSC_ADDR_28F0_reg_addr                                                 "0xB81563C0"
#define  ATSC_ADDR_28F0_reg                                                      0xB81563C0
#define  ATSC_ADDR_28F0_inst_addr                                                "0x0353"
#define  set_ATSC_ADDR_28F0_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_28F0_reg)=data)
#define  get_ATSC_ADDR_28F0_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_28F0_reg))
#define  ATSC_ADDR_28F0_ffe_sync_space_even_en_71_shift                          (7)
#define  ATSC_ADDR_28F0_ffe_sync_space_even_en_70_shift                          (6)
#define  ATSC_ADDR_28F0_ffe_sync_space_even_en_69_shift                          (5)
#define  ATSC_ADDR_28F0_ffe_sync_space_even_en_68_shift                          (4)
#define  ATSC_ADDR_28F0_ffe_sync_space_even_en_67_shift                          (3)
#define  ATSC_ADDR_28F0_ffe_sync_space_even_en_66_shift                          (2)
#define  ATSC_ADDR_28F0_ffe_sync_space_even_en_65_shift                          (1)
#define  ATSC_ADDR_28F0_ffe_sync_space_even_en_64_shift                          (0)
#define  ATSC_ADDR_28F0_ffe_sync_space_even_en_71_mask                           (0x00000080)
#define  ATSC_ADDR_28F0_ffe_sync_space_even_en_70_mask                           (0x00000040)
#define  ATSC_ADDR_28F0_ffe_sync_space_even_en_69_mask                           (0x00000020)
#define  ATSC_ADDR_28F0_ffe_sync_space_even_en_68_mask                           (0x00000010)
#define  ATSC_ADDR_28F0_ffe_sync_space_even_en_67_mask                           (0x00000008)
#define  ATSC_ADDR_28F0_ffe_sync_space_even_en_66_mask                           (0x00000004)
#define  ATSC_ADDR_28F0_ffe_sync_space_even_en_65_mask                           (0x00000002)
#define  ATSC_ADDR_28F0_ffe_sync_space_even_en_64_mask                           (0x00000001)
#define  ATSC_ADDR_28F0_ffe_sync_space_even_en_71(data)                          (0x00000080&((data)<<7))
#define  ATSC_ADDR_28F0_ffe_sync_space_even_en_70(data)                          (0x00000040&((data)<<6))
#define  ATSC_ADDR_28F0_ffe_sync_space_even_en_69(data)                          (0x00000020&((data)<<5))
#define  ATSC_ADDR_28F0_ffe_sync_space_even_en_68(data)                          (0x00000010&((data)<<4))
#define  ATSC_ADDR_28F0_ffe_sync_space_even_en_67(data)                          (0x00000008&((data)<<3))
#define  ATSC_ADDR_28F0_ffe_sync_space_even_en_66(data)                          (0x00000004&((data)<<2))
#define  ATSC_ADDR_28F0_ffe_sync_space_even_en_65(data)                          (0x00000002&((data)<<1))
#define  ATSC_ADDR_28F0_ffe_sync_space_even_en_64(data)                          (0x00000001&(data))
#define  ATSC_ADDR_28F0_get_ffe_sync_space_even_en_71(data)                      ((0x00000080&(data))>>7)
#define  ATSC_ADDR_28F0_get_ffe_sync_space_even_en_70(data)                      ((0x00000040&(data))>>6)
#define  ATSC_ADDR_28F0_get_ffe_sync_space_even_en_69(data)                      ((0x00000020&(data))>>5)
#define  ATSC_ADDR_28F0_get_ffe_sync_space_even_en_68(data)                      ((0x00000010&(data))>>4)
#define  ATSC_ADDR_28F0_get_ffe_sync_space_even_en_67(data)                      ((0x00000008&(data))>>3)
#define  ATSC_ADDR_28F0_get_ffe_sync_space_even_en_66(data)                      ((0x00000004&(data))>>2)
#define  ATSC_ADDR_28F0_get_ffe_sync_space_even_en_65(data)                      ((0x00000002&(data))>>1)
#define  ATSC_ADDR_28F0_get_ffe_sync_space_even_en_64(data)                      (0x00000001&(data))

#define  ATSC_ADDR_28F1                                                         0x181563C4
#define  ATSC_ADDR_28F1_reg_addr                                                 "0xB81563C4"
#define  ATSC_ADDR_28F1_reg                                                      0xB81563C4
#define  ATSC_ADDR_28F1_inst_addr                                                "0x0354"
#define  set_ATSC_ADDR_28F1_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_28F1_reg)=data)
#define  get_ATSC_ADDR_28F1_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_28F1_reg))
#define  ATSC_ADDR_28F1_ffe_sync_space_even_en_79_shift                          (7)
#define  ATSC_ADDR_28F1_ffe_sync_space_even_en_78_shift                          (6)
#define  ATSC_ADDR_28F1_ffe_sync_space_even_en_77_shift                          (5)
#define  ATSC_ADDR_28F1_ffe_sync_space_even_en_76_shift                          (4)
#define  ATSC_ADDR_28F1_ffe_sync_space_even_en_75_shift                          (3)
#define  ATSC_ADDR_28F1_ffe_sync_space_even_en_74_shift                          (2)
#define  ATSC_ADDR_28F1_ffe_sync_space_even_en_73_shift                          (1)
#define  ATSC_ADDR_28F1_ffe_sync_space_even_en_72_shift                          (0)
#define  ATSC_ADDR_28F1_ffe_sync_space_even_en_79_mask                           (0x00000080)
#define  ATSC_ADDR_28F1_ffe_sync_space_even_en_78_mask                           (0x00000040)
#define  ATSC_ADDR_28F1_ffe_sync_space_even_en_77_mask                           (0x00000020)
#define  ATSC_ADDR_28F1_ffe_sync_space_even_en_76_mask                           (0x00000010)
#define  ATSC_ADDR_28F1_ffe_sync_space_even_en_75_mask                           (0x00000008)
#define  ATSC_ADDR_28F1_ffe_sync_space_even_en_74_mask                           (0x00000004)
#define  ATSC_ADDR_28F1_ffe_sync_space_even_en_73_mask                           (0x00000002)
#define  ATSC_ADDR_28F1_ffe_sync_space_even_en_72_mask                           (0x00000001)
#define  ATSC_ADDR_28F1_ffe_sync_space_even_en_79(data)                          (0x00000080&((data)<<7))
#define  ATSC_ADDR_28F1_ffe_sync_space_even_en_78(data)                          (0x00000040&((data)<<6))
#define  ATSC_ADDR_28F1_ffe_sync_space_even_en_77(data)                          (0x00000020&((data)<<5))
#define  ATSC_ADDR_28F1_ffe_sync_space_even_en_76(data)                          (0x00000010&((data)<<4))
#define  ATSC_ADDR_28F1_ffe_sync_space_even_en_75(data)                          (0x00000008&((data)<<3))
#define  ATSC_ADDR_28F1_ffe_sync_space_even_en_74(data)                          (0x00000004&((data)<<2))
#define  ATSC_ADDR_28F1_ffe_sync_space_even_en_73(data)                          (0x00000002&((data)<<1))
#define  ATSC_ADDR_28F1_ffe_sync_space_even_en_72(data)                          (0x00000001&(data))
#define  ATSC_ADDR_28F1_get_ffe_sync_space_even_en_79(data)                      ((0x00000080&(data))>>7)
#define  ATSC_ADDR_28F1_get_ffe_sync_space_even_en_78(data)                      ((0x00000040&(data))>>6)
#define  ATSC_ADDR_28F1_get_ffe_sync_space_even_en_77(data)                      ((0x00000020&(data))>>5)
#define  ATSC_ADDR_28F1_get_ffe_sync_space_even_en_76(data)                      ((0x00000010&(data))>>4)
#define  ATSC_ADDR_28F1_get_ffe_sync_space_even_en_75(data)                      ((0x00000008&(data))>>3)
#define  ATSC_ADDR_28F1_get_ffe_sync_space_even_en_74(data)                      ((0x00000004&(data))>>2)
#define  ATSC_ADDR_28F1_get_ffe_sync_space_even_en_73(data)                      ((0x00000002&(data))>>1)
#define  ATSC_ADDR_28F1_get_ffe_sync_space_even_en_72(data)                      (0x00000001&(data))

#define  ATSC_ADDR_28F2                                                         0x181563C8
#define  ATSC_ADDR_28F2_reg_addr                                                 "0xB81563C8"
#define  ATSC_ADDR_28F2_reg                                                      0xB81563C8
#define  ATSC_ADDR_28F2_inst_addr                                                "0x0355"
#define  set_ATSC_ADDR_28F2_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_28F2_reg)=data)
#define  get_ATSC_ADDR_28F2_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_28F2_reg))
#define  ATSC_ADDR_28F2_ffe_sync_space_even_en_87_shift                          (7)
#define  ATSC_ADDR_28F2_ffe_sync_space_even_en_86_shift                          (6)
#define  ATSC_ADDR_28F2_ffe_sync_space_even_en_85_shift                          (5)
#define  ATSC_ADDR_28F2_ffe_sync_space_even_en_84_shift                          (4)
#define  ATSC_ADDR_28F2_ffe_sync_space_even_en_83_shift                          (3)
#define  ATSC_ADDR_28F2_ffe_sync_space_even_en_82_shift                          (2)
#define  ATSC_ADDR_28F2_ffe_sync_space_even_en_81_shift                          (1)
#define  ATSC_ADDR_28F2_ffe_sync_space_even_en_80_shift                          (0)
#define  ATSC_ADDR_28F2_ffe_sync_space_even_en_87_mask                           (0x00000080)
#define  ATSC_ADDR_28F2_ffe_sync_space_even_en_86_mask                           (0x00000040)
#define  ATSC_ADDR_28F2_ffe_sync_space_even_en_85_mask                           (0x00000020)
#define  ATSC_ADDR_28F2_ffe_sync_space_even_en_84_mask                           (0x00000010)
#define  ATSC_ADDR_28F2_ffe_sync_space_even_en_83_mask                           (0x00000008)
#define  ATSC_ADDR_28F2_ffe_sync_space_even_en_82_mask                           (0x00000004)
#define  ATSC_ADDR_28F2_ffe_sync_space_even_en_81_mask                           (0x00000002)
#define  ATSC_ADDR_28F2_ffe_sync_space_even_en_80_mask                           (0x00000001)
#define  ATSC_ADDR_28F2_ffe_sync_space_even_en_87(data)                          (0x00000080&((data)<<7))
#define  ATSC_ADDR_28F2_ffe_sync_space_even_en_86(data)                          (0x00000040&((data)<<6))
#define  ATSC_ADDR_28F2_ffe_sync_space_even_en_85(data)                          (0x00000020&((data)<<5))
#define  ATSC_ADDR_28F2_ffe_sync_space_even_en_84(data)                          (0x00000010&((data)<<4))
#define  ATSC_ADDR_28F2_ffe_sync_space_even_en_83(data)                          (0x00000008&((data)<<3))
#define  ATSC_ADDR_28F2_ffe_sync_space_even_en_82(data)                          (0x00000004&((data)<<2))
#define  ATSC_ADDR_28F2_ffe_sync_space_even_en_81(data)                          (0x00000002&((data)<<1))
#define  ATSC_ADDR_28F2_ffe_sync_space_even_en_80(data)                          (0x00000001&(data))
#define  ATSC_ADDR_28F2_get_ffe_sync_space_even_en_87(data)                      ((0x00000080&(data))>>7)
#define  ATSC_ADDR_28F2_get_ffe_sync_space_even_en_86(data)                      ((0x00000040&(data))>>6)
#define  ATSC_ADDR_28F2_get_ffe_sync_space_even_en_85(data)                      ((0x00000020&(data))>>5)
#define  ATSC_ADDR_28F2_get_ffe_sync_space_even_en_84(data)                      ((0x00000010&(data))>>4)
#define  ATSC_ADDR_28F2_get_ffe_sync_space_even_en_83(data)                      ((0x00000008&(data))>>3)
#define  ATSC_ADDR_28F2_get_ffe_sync_space_even_en_82(data)                      ((0x00000004&(data))>>2)
#define  ATSC_ADDR_28F2_get_ffe_sync_space_even_en_81(data)                      ((0x00000002&(data))>>1)
#define  ATSC_ADDR_28F2_get_ffe_sync_space_even_en_80(data)                      (0x00000001&(data))

#define  ATSC_ADDR_28F3                                                         0x181563CC
#define  ATSC_ADDR_28F3_reg_addr                                                 "0xB81563CC"
#define  ATSC_ADDR_28F3_reg                                                      0xB81563CC
#define  ATSC_ADDR_28F3_inst_addr                                                "0x0356"
#define  set_ATSC_ADDR_28F3_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_28F3_reg)=data)
#define  get_ATSC_ADDR_28F3_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_28F3_reg))
#define  ATSC_ADDR_28F3_ffe_sync_space_even_en_95_shift                          (7)
#define  ATSC_ADDR_28F3_ffe_sync_space_even_en_94_shift                          (6)
#define  ATSC_ADDR_28F3_ffe_sync_space_even_en_93_shift                          (5)
#define  ATSC_ADDR_28F3_ffe_sync_space_even_en_92_shift                          (4)
#define  ATSC_ADDR_28F3_ffe_sync_space_even_en_91_shift                          (3)
#define  ATSC_ADDR_28F3_ffe_sync_space_even_en_90_shift                          (2)
#define  ATSC_ADDR_28F3_ffe_sync_space_even_en_89_shift                          (1)
#define  ATSC_ADDR_28F3_ffe_sync_space_even_en_88_shift                          (0)
#define  ATSC_ADDR_28F3_ffe_sync_space_even_en_95_mask                           (0x00000080)
#define  ATSC_ADDR_28F3_ffe_sync_space_even_en_94_mask                           (0x00000040)
#define  ATSC_ADDR_28F3_ffe_sync_space_even_en_93_mask                           (0x00000020)
#define  ATSC_ADDR_28F3_ffe_sync_space_even_en_92_mask                           (0x00000010)
#define  ATSC_ADDR_28F3_ffe_sync_space_even_en_91_mask                           (0x00000008)
#define  ATSC_ADDR_28F3_ffe_sync_space_even_en_90_mask                           (0x00000004)
#define  ATSC_ADDR_28F3_ffe_sync_space_even_en_89_mask                           (0x00000002)
#define  ATSC_ADDR_28F3_ffe_sync_space_even_en_88_mask                           (0x00000001)
#define  ATSC_ADDR_28F3_ffe_sync_space_even_en_95(data)                          (0x00000080&((data)<<7))
#define  ATSC_ADDR_28F3_ffe_sync_space_even_en_94(data)                          (0x00000040&((data)<<6))
#define  ATSC_ADDR_28F3_ffe_sync_space_even_en_93(data)                          (0x00000020&((data)<<5))
#define  ATSC_ADDR_28F3_ffe_sync_space_even_en_92(data)                          (0x00000010&((data)<<4))
#define  ATSC_ADDR_28F3_ffe_sync_space_even_en_91(data)                          (0x00000008&((data)<<3))
#define  ATSC_ADDR_28F3_ffe_sync_space_even_en_90(data)                          (0x00000004&((data)<<2))
#define  ATSC_ADDR_28F3_ffe_sync_space_even_en_89(data)                          (0x00000002&((data)<<1))
#define  ATSC_ADDR_28F3_ffe_sync_space_even_en_88(data)                          (0x00000001&(data))
#define  ATSC_ADDR_28F3_get_ffe_sync_space_even_en_95(data)                      ((0x00000080&(data))>>7)
#define  ATSC_ADDR_28F3_get_ffe_sync_space_even_en_94(data)                      ((0x00000040&(data))>>6)
#define  ATSC_ADDR_28F3_get_ffe_sync_space_even_en_93(data)                      ((0x00000020&(data))>>5)
#define  ATSC_ADDR_28F3_get_ffe_sync_space_even_en_92(data)                      ((0x00000010&(data))>>4)
#define  ATSC_ADDR_28F3_get_ffe_sync_space_even_en_91(data)                      ((0x00000008&(data))>>3)
#define  ATSC_ADDR_28F3_get_ffe_sync_space_even_en_90(data)                      ((0x00000004&(data))>>2)
#define  ATSC_ADDR_28F3_get_ffe_sync_space_even_en_89(data)                      ((0x00000002&(data))>>1)
#define  ATSC_ADDR_28F3_get_ffe_sync_space_even_en_88(data)                      (0x00000001&(data))

#define  ATSC_ADDR_2728                                                         0x18155CA0
#define  ATSC_ADDR_2728_reg_addr                                                 "0xB8155CA0"
#define  ATSC_ADDR_2728_reg                                                      0xB8155CA0
#define  ATSC_ADDR_2728_inst_addr                                                "0x0357"
#define  set_ATSC_ADDR_2728_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2728_reg)=data)
#define  get_ATSC_ADDR_2728_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2728_reg))
#define  ATSC_ADDR_2728_ffe_sync_space_odd_en_7_shift                            (7)
#define  ATSC_ADDR_2728_ffe_sync_space_odd_en_6_shift                            (6)
#define  ATSC_ADDR_2728_ffe_sync_space_odd_en_5_shift                            (5)
#define  ATSC_ADDR_2728_ffe_sync_space_odd_en_4_shift                            (4)
#define  ATSC_ADDR_2728_ffe_sync_space_odd_en_3_shift                            (3)
#define  ATSC_ADDR_2728_ffe_sync_space_odd_en_2_shift                            (2)
#define  ATSC_ADDR_2728_ffe_sync_space_odd_en_1_shift                            (1)
#define  ATSC_ADDR_2728_ffe_sync_space_odd_en_0_shift                            (0)
#define  ATSC_ADDR_2728_ffe_sync_space_odd_en_7_mask                             (0x00000080)
#define  ATSC_ADDR_2728_ffe_sync_space_odd_en_6_mask                             (0x00000040)
#define  ATSC_ADDR_2728_ffe_sync_space_odd_en_5_mask                             (0x00000020)
#define  ATSC_ADDR_2728_ffe_sync_space_odd_en_4_mask                             (0x00000010)
#define  ATSC_ADDR_2728_ffe_sync_space_odd_en_3_mask                             (0x00000008)
#define  ATSC_ADDR_2728_ffe_sync_space_odd_en_2_mask                             (0x00000004)
#define  ATSC_ADDR_2728_ffe_sync_space_odd_en_1_mask                             (0x00000002)
#define  ATSC_ADDR_2728_ffe_sync_space_odd_en_0_mask                             (0x00000001)
#define  ATSC_ADDR_2728_ffe_sync_space_odd_en_7(data)                            (0x00000080&((data)<<7))
#define  ATSC_ADDR_2728_ffe_sync_space_odd_en_6(data)                            (0x00000040&((data)<<6))
#define  ATSC_ADDR_2728_ffe_sync_space_odd_en_5(data)                            (0x00000020&((data)<<5))
#define  ATSC_ADDR_2728_ffe_sync_space_odd_en_4(data)                            (0x00000010&((data)<<4))
#define  ATSC_ADDR_2728_ffe_sync_space_odd_en_3(data)                            (0x00000008&((data)<<3))
#define  ATSC_ADDR_2728_ffe_sync_space_odd_en_2(data)                            (0x00000004&((data)<<2))
#define  ATSC_ADDR_2728_ffe_sync_space_odd_en_1(data)                            (0x00000002&((data)<<1))
#define  ATSC_ADDR_2728_ffe_sync_space_odd_en_0(data)                            (0x00000001&(data))
#define  ATSC_ADDR_2728_get_ffe_sync_space_odd_en_7(data)                        ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2728_get_ffe_sync_space_odd_en_6(data)                        ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2728_get_ffe_sync_space_odd_en_5(data)                        ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2728_get_ffe_sync_space_odd_en_4(data)                        ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2728_get_ffe_sync_space_odd_en_3(data)                        ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2728_get_ffe_sync_space_odd_en_2(data)                        ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2728_get_ffe_sync_space_odd_en_1(data)                        ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2728_get_ffe_sync_space_odd_en_0(data)                        (0x00000001&(data))

#define  ATSC_ADDR_2729                                                         0x18155CA4
#define  ATSC_ADDR_2729_reg_addr                                                 "0xB8155CA4"
#define  ATSC_ADDR_2729_reg                                                      0xB8155CA4
#define  ATSC_ADDR_2729_inst_addr                                                "0x0358"
#define  set_ATSC_ADDR_2729_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2729_reg)=data)
#define  get_ATSC_ADDR_2729_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2729_reg))
#define  ATSC_ADDR_2729_ffe_sync_space_odd_en_15_shift                           (7)
#define  ATSC_ADDR_2729_ffe_sync_space_odd_en_14_shift                           (6)
#define  ATSC_ADDR_2729_ffe_sync_space_odd_en_13_shift                           (5)
#define  ATSC_ADDR_2729_ffe_sync_space_odd_en_12_shift                           (4)
#define  ATSC_ADDR_2729_ffe_sync_space_odd_en_11_shift                           (3)
#define  ATSC_ADDR_2729_ffe_sync_space_odd_en_10_shift                           (2)
#define  ATSC_ADDR_2729_ffe_sync_space_odd_en_9_shift                            (1)
#define  ATSC_ADDR_2729_ffe_sync_space_odd_en_8_shift                            (0)
#define  ATSC_ADDR_2729_ffe_sync_space_odd_en_15_mask                            (0x00000080)
#define  ATSC_ADDR_2729_ffe_sync_space_odd_en_14_mask                            (0x00000040)
#define  ATSC_ADDR_2729_ffe_sync_space_odd_en_13_mask                            (0x00000020)
#define  ATSC_ADDR_2729_ffe_sync_space_odd_en_12_mask                            (0x00000010)
#define  ATSC_ADDR_2729_ffe_sync_space_odd_en_11_mask                            (0x00000008)
#define  ATSC_ADDR_2729_ffe_sync_space_odd_en_10_mask                            (0x00000004)
#define  ATSC_ADDR_2729_ffe_sync_space_odd_en_9_mask                             (0x00000002)
#define  ATSC_ADDR_2729_ffe_sync_space_odd_en_8_mask                             (0x00000001)
#define  ATSC_ADDR_2729_ffe_sync_space_odd_en_15(data)                           (0x00000080&((data)<<7))
#define  ATSC_ADDR_2729_ffe_sync_space_odd_en_14(data)                           (0x00000040&((data)<<6))
#define  ATSC_ADDR_2729_ffe_sync_space_odd_en_13(data)                           (0x00000020&((data)<<5))
#define  ATSC_ADDR_2729_ffe_sync_space_odd_en_12(data)                           (0x00000010&((data)<<4))
#define  ATSC_ADDR_2729_ffe_sync_space_odd_en_11(data)                           (0x00000008&((data)<<3))
#define  ATSC_ADDR_2729_ffe_sync_space_odd_en_10(data)                           (0x00000004&((data)<<2))
#define  ATSC_ADDR_2729_ffe_sync_space_odd_en_9(data)                            (0x00000002&((data)<<1))
#define  ATSC_ADDR_2729_ffe_sync_space_odd_en_8(data)                            (0x00000001&(data))
#define  ATSC_ADDR_2729_get_ffe_sync_space_odd_en_15(data)                       ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2729_get_ffe_sync_space_odd_en_14(data)                       ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2729_get_ffe_sync_space_odd_en_13(data)                       ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2729_get_ffe_sync_space_odd_en_12(data)                       ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2729_get_ffe_sync_space_odd_en_11(data)                       ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2729_get_ffe_sync_space_odd_en_10(data)                       ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2729_get_ffe_sync_space_odd_en_9(data)                        ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2729_get_ffe_sync_space_odd_en_8(data)                        (0x00000001&(data))

#define  ATSC_ADDR_272A                                                         0x18155CA8
#define  ATSC_ADDR_272A_reg_addr                                                 "0xB8155CA8"
#define  ATSC_ADDR_272A_reg                                                      0xB8155CA8
#define  ATSC_ADDR_272A_inst_addr                                                "0x0359"
#define  set_ATSC_ADDR_272A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_272A_reg)=data)
#define  get_ATSC_ADDR_272A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_272A_reg))
#define  ATSC_ADDR_272A_ffe_sync_space_odd_en_23_shift                           (7)
#define  ATSC_ADDR_272A_ffe_sync_space_odd_en_22_shift                           (6)
#define  ATSC_ADDR_272A_ffe_sync_space_odd_en_21_shift                           (5)
#define  ATSC_ADDR_272A_ffe_sync_space_odd_en_20_shift                           (4)
#define  ATSC_ADDR_272A_ffe_sync_space_odd_en_19_shift                           (3)
#define  ATSC_ADDR_272A_ffe_sync_space_odd_en_18_shift                           (2)
#define  ATSC_ADDR_272A_ffe_sync_space_odd_en_17_shift                           (1)
#define  ATSC_ADDR_272A_ffe_sync_space_odd_en_16_shift                           (0)
#define  ATSC_ADDR_272A_ffe_sync_space_odd_en_23_mask                            (0x00000080)
#define  ATSC_ADDR_272A_ffe_sync_space_odd_en_22_mask                            (0x00000040)
#define  ATSC_ADDR_272A_ffe_sync_space_odd_en_21_mask                            (0x00000020)
#define  ATSC_ADDR_272A_ffe_sync_space_odd_en_20_mask                            (0x00000010)
#define  ATSC_ADDR_272A_ffe_sync_space_odd_en_19_mask                            (0x00000008)
#define  ATSC_ADDR_272A_ffe_sync_space_odd_en_18_mask                            (0x00000004)
#define  ATSC_ADDR_272A_ffe_sync_space_odd_en_17_mask                            (0x00000002)
#define  ATSC_ADDR_272A_ffe_sync_space_odd_en_16_mask                            (0x00000001)
#define  ATSC_ADDR_272A_ffe_sync_space_odd_en_23(data)                           (0x00000080&((data)<<7))
#define  ATSC_ADDR_272A_ffe_sync_space_odd_en_22(data)                           (0x00000040&((data)<<6))
#define  ATSC_ADDR_272A_ffe_sync_space_odd_en_21(data)                           (0x00000020&((data)<<5))
#define  ATSC_ADDR_272A_ffe_sync_space_odd_en_20(data)                           (0x00000010&((data)<<4))
#define  ATSC_ADDR_272A_ffe_sync_space_odd_en_19(data)                           (0x00000008&((data)<<3))
#define  ATSC_ADDR_272A_ffe_sync_space_odd_en_18(data)                           (0x00000004&((data)<<2))
#define  ATSC_ADDR_272A_ffe_sync_space_odd_en_17(data)                           (0x00000002&((data)<<1))
#define  ATSC_ADDR_272A_ffe_sync_space_odd_en_16(data)                           (0x00000001&(data))
#define  ATSC_ADDR_272A_get_ffe_sync_space_odd_en_23(data)                       ((0x00000080&(data))>>7)
#define  ATSC_ADDR_272A_get_ffe_sync_space_odd_en_22(data)                       ((0x00000040&(data))>>6)
#define  ATSC_ADDR_272A_get_ffe_sync_space_odd_en_21(data)                       ((0x00000020&(data))>>5)
#define  ATSC_ADDR_272A_get_ffe_sync_space_odd_en_20(data)                       ((0x00000010&(data))>>4)
#define  ATSC_ADDR_272A_get_ffe_sync_space_odd_en_19(data)                       ((0x00000008&(data))>>3)
#define  ATSC_ADDR_272A_get_ffe_sync_space_odd_en_18(data)                       ((0x00000004&(data))>>2)
#define  ATSC_ADDR_272A_get_ffe_sync_space_odd_en_17(data)                       ((0x00000002&(data))>>1)
#define  ATSC_ADDR_272A_get_ffe_sync_space_odd_en_16(data)                       (0x00000001&(data))

#define  ATSC_ADDR_272B                                                         0x18155CAC
#define  ATSC_ADDR_272B_reg_addr                                                 "0xB8155CAC"
#define  ATSC_ADDR_272B_reg                                                      0xB8155CAC
#define  ATSC_ADDR_272B_inst_addr                                                "0x035A"
#define  set_ATSC_ADDR_272B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_272B_reg)=data)
#define  get_ATSC_ADDR_272B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_272B_reg))
#define  ATSC_ADDR_272B_ffe_sync_space_odd_en_31_shift                           (7)
#define  ATSC_ADDR_272B_ffe_sync_space_odd_en_30_shift                           (6)
#define  ATSC_ADDR_272B_ffe_sync_space_odd_en_29_shift                           (5)
#define  ATSC_ADDR_272B_ffe_sync_space_odd_en_28_shift                           (4)
#define  ATSC_ADDR_272B_ffe_sync_space_odd_en_27_shift                           (3)
#define  ATSC_ADDR_272B_ffe_sync_space_odd_en_26_shift                           (2)
#define  ATSC_ADDR_272B_ffe_sync_space_odd_en_25_shift                           (1)
#define  ATSC_ADDR_272B_ffe_sync_space_odd_en_24_shift                           (0)
#define  ATSC_ADDR_272B_ffe_sync_space_odd_en_31_mask                            (0x00000080)
#define  ATSC_ADDR_272B_ffe_sync_space_odd_en_30_mask                            (0x00000040)
#define  ATSC_ADDR_272B_ffe_sync_space_odd_en_29_mask                            (0x00000020)
#define  ATSC_ADDR_272B_ffe_sync_space_odd_en_28_mask                            (0x00000010)
#define  ATSC_ADDR_272B_ffe_sync_space_odd_en_27_mask                            (0x00000008)
#define  ATSC_ADDR_272B_ffe_sync_space_odd_en_26_mask                            (0x00000004)
#define  ATSC_ADDR_272B_ffe_sync_space_odd_en_25_mask                            (0x00000002)
#define  ATSC_ADDR_272B_ffe_sync_space_odd_en_24_mask                            (0x00000001)
#define  ATSC_ADDR_272B_ffe_sync_space_odd_en_31(data)                           (0x00000080&((data)<<7))
#define  ATSC_ADDR_272B_ffe_sync_space_odd_en_30(data)                           (0x00000040&((data)<<6))
#define  ATSC_ADDR_272B_ffe_sync_space_odd_en_29(data)                           (0x00000020&((data)<<5))
#define  ATSC_ADDR_272B_ffe_sync_space_odd_en_28(data)                           (0x00000010&((data)<<4))
#define  ATSC_ADDR_272B_ffe_sync_space_odd_en_27(data)                           (0x00000008&((data)<<3))
#define  ATSC_ADDR_272B_ffe_sync_space_odd_en_26(data)                           (0x00000004&((data)<<2))
#define  ATSC_ADDR_272B_ffe_sync_space_odd_en_25(data)                           (0x00000002&((data)<<1))
#define  ATSC_ADDR_272B_ffe_sync_space_odd_en_24(data)                           (0x00000001&(data))
#define  ATSC_ADDR_272B_get_ffe_sync_space_odd_en_31(data)                       ((0x00000080&(data))>>7)
#define  ATSC_ADDR_272B_get_ffe_sync_space_odd_en_30(data)                       ((0x00000040&(data))>>6)
#define  ATSC_ADDR_272B_get_ffe_sync_space_odd_en_29(data)                       ((0x00000020&(data))>>5)
#define  ATSC_ADDR_272B_get_ffe_sync_space_odd_en_28(data)                       ((0x00000010&(data))>>4)
#define  ATSC_ADDR_272B_get_ffe_sync_space_odd_en_27(data)                       ((0x00000008&(data))>>3)
#define  ATSC_ADDR_272B_get_ffe_sync_space_odd_en_26(data)                       ((0x00000004&(data))>>2)
#define  ATSC_ADDR_272B_get_ffe_sync_space_odd_en_25(data)                       ((0x00000002&(data))>>1)
#define  ATSC_ADDR_272B_get_ffe_sync_space_odd_en_24(data)                       (0x00000001&(data))

#define  ATSC_ADDR_272C                                                         0x18155CB0
#define  ATSC_ADDR_272C_reg_addr                                                 "0xB8155CB0"
#define  ATSC_ADDR_272C_reg                                                      0xB8155CB0
#define  ATSC_ADDR_272C_inst_addr                                                "0x035B"
#define  set_ATSC_ADDR_272C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_272C_reg)=data)
#define  get_ATSC_ADDR_272C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_272C_reg))
#define  ATSC_ADDR_272C_ffe_sync_space_odd_en_39_shift                           (7)
#define  ATSC_ADDR_272C_ffe_sync_space_odd_en_38_shift                           (6)
#define  ATSC_ADDR_272C_ffe_sync_space_odd_en_37_shift                           (5)
#define  ATSC_ADDR_272C_ffe_sync_space_odd_en_36_shift                           (4)
#define  ATSC_ADDR_272C_ffe_sync_space_odd_en_35_shift                           (3)
#define  ATSC_ADDR_272C_ffe_sync_space_odd_en_34_shift                           (2)
#define  ATSC_ADDR_272C_ffe_sync_space_odd_en_33_shift                           (1)
#define  ATSC_ADDR_272C_ffe_sync_space_odd_en_32_shift                           (0)
#define  ATSC_ADDR_272C_ffe_sync_space_odd_en_39_mask                            (0x00000080)
#define  ATSC_ADDR_272C_ffe_sync_space_odd_en_38_mask                            (0x00000040)
#define  ATSC_ADDR_272C_ffe_sync_space_odd_en_37_mask                            (0x00000020)
#define  ATSC_ADDR_272C_ffe_sync_space_odd_en_36_mask                            (0x00000010)
#define  ATSC_ADDR_272C_ffe_sync_space_odd_en_35_mask                            (0x00000008)
#define  ATSC_ADDR_272C_ffe_sync_space_odd_en_34_mask                            (0x00000004)
#define  ATSC_ADDR_272C_ffe_sync_space_odd_en_33_mask                            (0x00000002)
#define  ATSC_ADDR_272C_ffe_sync_space_odd_en_32_mask                            (0x00000001)
#define  ATSC_ADDR_272C_ffe_sync_space_odd_en_39(data)                           (0x00000080&((data)<<7))
#define  ATSC_ADDR_272C_ffe_sync_space_odd_en_38(data)                           (0x00000040&((data)<<6))
#define  ATSC_ADDR_272C_ffe_sync_space_odd_en_37(data)                           (0x00000020&((data)<<5))
#define  ATSC_ADDR_272C_ffe_sync_space_odd_en_36(data)                           (0x00000010&((data)<<4))
#define  ATSC_ADDR_272C_ffe_sync_space_odd_en_35(data)                           (0x00000008&((data)<<3))
#define  ATSC_ADDR_272C_ffe_sync_space_odd_en_34(data)                           (0x00000004&((data)<<2))
#define  ATSC_ADDR_272C_ffe_sync_space_odd_en_33(data)                           (0x00000002&((data)<<1))
#define  ATSC_ADDR_272C_ffe_sync_space_odd_en_32(data)                           (0x00000001&(data))
#define  ATSC_ADDR_272C_get_ffe_sync_space_odd_en_39(data)                       ((0x00000080&(data))>>7)
#define  ATSC_ADDR_272C_get_ffe_sync_space_odd_en_38(data)                       ((0x00000040&(data))>>6)
#define  ATSC_ADDR_272C_get_ffe_sync_space_odd_en_37(data)                       ((0x00000020&(data))>>5)
#define  ATSC_ADDR_272C_get_ffe_sync_space_odd_en_36(data)                       ((0x00000010&(data))>>4)
#define  ATSC_ADDR_272C_get_ffe_sync_space_odd_en_35(data)                       ((0x00000008&(data))>>3)
#define  ATSC_ADDR_272C_get_ffe_sync_space_odd_en_34(data)                       ((0x00000004&(data))>>2)
#define  ATSC_ADDR_272C_get_ffe_sync_space_odd_en_33(data)                       ((0x00000002&(data))>>1)
#define  ATSC_ADDR_272C_get_ffe_sync_space_odd_en_32(data)                       (0x00000001&(data))

#define  ATSC_ADDR_272D                                                         0x18155CB4
#define  ATSC_ADDR_272D_reg_addr                                                 "0xB8155CB4"
#define  ATSC_ADDR_272D_reg                                                      0xB8155CB4
#define  ATSC_ADDR_272D_inst_addr                                                "0x035C"
#define  set_ATSC_ADDR_272D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_272D_reg)=data)
#define  get_ATSC_ADDR_272D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_272D_reg))
#define  ATSC_ADDR_272D_ffe_sync_space_odd_en_47_shift                           (7)
#define  ATSC_ADDR_272D_ffe_sync_space_odd_en_46_shift                           (6)
#define  ATSC_ADDR_272D_ffe_sync_space_odd_en_45_shift                           (5)
#define  ATSC_ADDR_272D_ffe_sync_space_odd_en_44_shift                           (4)
#define  ATSC_ADDR_272D_ffe_sync_space_odd_en_43_shift                           (3)
#define  ATSC_ADDR_272D_ffe_sync_space_odd_en_42_shift                           (2)
#define  ATSC_ADDR_272D_ffe_sync_space_odd_en_41_shift                           (1)
#define  ATSC_ADDR_272D_ffe_sync_space_odd_en_40_shift                           (0)
#define  ATSC_ADDR_272D_ffe_sync_space_odd_en_47_mask                            (0x00000080)
#define  ATSC_ADDR_272D_ffe_sync_space_odd_en_46_mask                            (0x00000040)
#define  ATSC_ADDR_272D_ffe_sync_space_odd_en_45_mask                            (0x00000020)
#define  ATSC_ADDR_272D_ffe_sync_space_odd_en_44_mask                            (0x00000010)
#define  ATSC_ADDR_272D_ffe_sync_space_odd_en_43_mask                            (0x00000008)
#define  ATSC_ADDR_272D_ffe_sync_space_odd_en_42_mask                            (0x00000004)
#define  ATSC_ADDR_272D_ffe_sync_space_odd_en_41_mask                            (0x00000002)
#define  ATSC_ADDR_272D_ffe_sync_space_odd_en_40_mask                            (0x00000001)
#define  ATSC_ADDR_272D_ffe_sync_space_odd_en_47(data)                           (0x00000080&((data)<<7))
#define  ATSC_ADDR_272D_ffe_sync_space_odd_en_46(data)                           (0x00000040&((data)<<6))
#define  ATSC_ADDR_272D_ffe_sync_space_odd_en_45(data)                           (0x00000020&((data)<<5))
#define  ATSC_ADDR_272D_ffe_sync_space_odd_en_44(data)                           (0x00000010&((data)<<4))
#define  ATSC_ADDR_272D_ffe_sync_space_odd_en_43(data)                           (0x00000008&((data)<<3))
#define  ATSC_ADDR_272D_ffe_sync_space_odd_en_42(data)                           (0x00000004&((data)<<2))
#define  ATSC_ADDR_272D_ffe_sync_space_odd_en_41(data)                           (0x00000002&((data)<<1))
#define  ATSC_ADDR_272D_ffe_sync_space_odd_en_40(data)                           (0x00000001&(data))
#define  ATSC_ADDR_272D_get_ffe_sync_space_odd_en_47(data)                       ((0x00000080&(data))>>7)
#define  ATSC_ADDR_272D_get_ffe_sync_space_odd_en_46(data)                       ((0x00000040&(data))>>6)
#define  ATSC_ADDR_272D_get_ffe_sync_space_odd_en_45(data)                       ((0x00000020&(data))>>5)
#define  ATSC_ADDR_272D_get_ffe_sync_space_odd_en_44(data)                       ((0x00000010&(data))>>4)
#define  ATSC_ADDR_272D_get_ffe_sync_space_odd_en_43(data)                       ((0x00000008&(data))>>3)
#define  ATSC_ADDR_272D_get_ffe_sync_space_odd_en_42(data)                       ((0x00000004&(data))>>2)
#define  ATSC_ADDR_272D_get_ffe_sync_space_odd_en_41(data)                       ((0x00000002&(data))>>1)
#define  ATSC_ADDR_272D_get_ffe_sync_space_odd_en_40(data)                       (0x00000001&(data))

#define  ATSC_ADDR_2FC3                                                         0x18157F0C
#define  ATSC_ADDR_2FC3_reg_addr                                                 "0xB8157F0C"
#define  ATSC_ADDR_2FC3_reg                                                      0xB8157F0C
#define  ATSC_ADDR_2FC3_inst_addr                                                "0x035D"
#define  set_ATSC_ADDR_2FC3_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FC3_reg)=data)
#define  get_ATSC_ADDR_2FC3_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FC3_reg))
#define  ATSC_ADDR_2FC3_ffe_sync_space_odd_en_55_shift                           (7)
#define  ATSC_ADDR_2FC3_ffe_sync_space_odd_en_54_shift                           (6)
#define  ATSC_ADDR_2FC3_ffe_sync_space_odd_en_53_shift                           (5)
#define  ATSC_ADDR_2FC3_ffe_sync_space_odd_en_52_shift                           (4)
#define  ATSC_ADDR_2FC3_ffe_sync_space_odd_en_51_shift                           (3)
#define  ATSC_ADDR_2FC3_ffe_sync_space_odd_en_50_shift                           (2)
#define  ATSC_ADDR_2FC3_ffe_sync_space_odd_en_49_shift                           (1)
#define  ATSC_ADDR_2FC3_ffe_sync_space_odd_en_48_shift                           (0)
#define  ATSC_ADDR_2FC3_ffe_sync_space_odd_en_55_mask                            (0x00000080)
#define  ATSC_ADDR_2FC3_ffe_sync_space_odd_en_54_mask                            (0x00000040)
#define  ATSC_ADDR_2FC3_ffe_sync_space_odd_en_53_mask                            (0x00000020)
#define  ATSC_ADDR_2FC3_ffe_sync_space_odd_en_52_mask                            (0x00000010)
#define  ATSC_ADDR_2FC3_ffe_sync_space_odd_en_51_mask                            (0x00000008)
#define  ATSC_ADDR_2FC3_ffe_sync_space_odd_en_50_mask                            (0x00000004)
#define  ATSC_ADDR_2FC3_ffe_sync_space_odd_en_49_mask                            (0x00000002)
#define  ATSC_ADDR_2FC3_ffe_sync_space_odd_en_48_mask                            (0x00000001)
#define  ATSC_ADDR_2FC3_ffe_sync_space_odd_en_55(data)                           (0x00000080&((data)<<7))
#define  ATSC_ADDR_2FC3_ffe_sync_space_odd_en_54(data)                           (0x00000040&((data)<<6))
#define  ATSC_ADDR_2FC3_ffe_sync_space_odd_en_53(data)                           (0x00000020&((data)<<5))
#define  ATSC_ADDR_2FC3_ffe_sync_space_odd_en_52(data)                           (0x00000010&((data)<<4))
#define  ATSC_ADDR_2FC3_ffe_sync_space_odd_en_51(data)                           (0x00000008&((data)<<3))
#define  ATSC_ADDR_2FC3_ffe_sync_space_odd_en_50(data)                           (0x00000004&((data)<<2))
#define  ATSC_ADDR_2FC3_ffe_sync_space_odd_en_49(data)                           (0x00000002&((data)<<1))
#define  ATSC_ADDR_2FC3_ffe_sync_space_odd_en_48(data)                           (0x00000001&(data))
#define  ATSC_ADDR_2FC3_get_ffe_sync_space_odd_en_55(data)                       ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2FC3_get_ffe_sync_space_odd_en_54(data)                       ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2FC3_get_ffe_sync_space_odd_en_53(data)                       ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2FC3_get_ffe_sync_space_odd_en_52(data)                       ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2FC3_get_ffe_sync_space_odd_en_51(data)                       ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2FC3_get_ffe_sync_space_odd_en_50(data)                       ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2FC3_get_ffe_sync_space_odd_en_49(data)                       ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2FC3_get_ffe_sync_space_odd_en_48(data)                       (0x00000001&(data))

#define  ATSC_ADDR_2FC4                                                         0x18157F10
#define  ATSC_ADDR_2FC4_reg_addr                                                 "0xB8157F10"
#define  ATSC_ADDR_2FC4_reg                                                      0xB8157F10
#define  ATSC_ADDR_2FC4_inst_addr                                                "0x035E"
#define  set_ATSC_ADDR_2FC4_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FC4_reg)=data)
#define  get_ATSC_ADDR_2FC4_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FC4_reg))
#define  ATSC_ADDR_2FC4_ffe_sync_space_odd_en_63_shift                           (7)
#define  ATSC_ADDR_2FC4_ffe_sync_space_odd_en_62_shift                           (6)
#define  ATSC_ADDR_2FC4_ffe_sync_space_odd_en_61_shift                           (5)
#define  ATSC_ADDR_2FC4_ffe_sync_space_odd_en_60_shift                           (4)
#define  ATSC_ADDR_2FC4_ffe_sync_space_odd_en_59_shift                           (3)
#define  ATSC_ADDR_2FC4_ffe_sync_space_odd_en_58_shift                           (2)
#define  ATSC_ADDR_2FC4_ffe_sync_space_odd_en_57_shift                           (1)
#define  ATSC_ADDR_2FC4_ffe_sync_space_odd_en_56_shift                           (0)
#define  ATSC_ADDR_2FC4_ffe_sync_space_odd_en_63_mask                            (0x00000080)
#define  ATSC_ADDR_2FC4_ffe_sync_space_odd_en_62_mask                            (0x00000040)
#define  ATSC_ADDR_2FC4_ffe_sync_space_odd_en_61_mask                            (0x00000020)
#define  ATSC_ADDR_2FC4_ffe_sync_space_odd_en_60_mask                            (0x00000010)
#define  ATSC_ADDR_2FC4_ffe_sync_space_odd_en_59_mask                            (0x00000008)
#define  ATSC_ADDR_2FC4_ffe_sync_space_odd_en_58_mask                            (0x00000004)
#define  ATSC_ADDR_2FC4_ffe_sync_space_odd_en_57_mask                            (0x00000002)
#define  ATSC_ADDR_2FC4_ffe_sync_space_odd_en_56_mask                            (0x00000001)
#define  ATSC_ADDR_2FC4_ffe_sync_space_odd_en_63(data)                           (0x00000080&((data)<<7))
#define  ATSC_ADDR_2FC4_ffe_sync_space_odd_en_62(data)                           (0x00000040&((data)<<6))
#define  ATSC_ADDR_2FC4_ffe_sync_space_odd_en_61(data)                           (0x00000020&((data)<<5))
#define  ATSC_ADDR_2FC4_ffe_sync_space_odd_en_60(data)                           (0x00000010&((data)<<4))
#define  ATSC_ADDR_2FC4_ffe_sync_space_odd_en_59(data)                           (0x00000008&((data)<<3))
#define  ATSC_ADDR_2FC4_ffe_sync_space_odd_en_58(data)                           (0x00000004&((data)<<2))
#define  ATSC_ADDR_2FC4_ffe_sync_space_odd_en_57(data)                           (0x00000002&((data)<<1))
#define  ATSC_ADDR_2FC4_ffe_sync_space_odd_en_56(data)                           (0x00000001&(data))
#define  ATSC_ADDR_2FC4_get_ffe_sync_space_odd_en_63(data)                       ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2FC4_get_ffe_sync_space_odd_en_62(data)                       ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2FC4_get_ffe_sync_space_odd_en_61(data)                       ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2FC4_get_ffe_sync_space_odd_en_60(data)                       ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2FC4_get_ffe_sync_space_odd_en_59(data)                       ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2FC4_get_ffe_sync_space_odd_en_58(data)                       ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2FC4_get_ffe_sync_space_odd_en_57(data)                       ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2FC4_get_ffe_sync_space_odd_en_56(data)                       (0x00000001&(data))

#define  ATSC_ADDR_28F4                                                         0x181563D0
#define  ATSC_ADDR_28F4_reg_addr                                                 "0xB81563D0"
#define  ATSC_ADDR_28F4_reg                                                      0xB81563D0
#define  ATSC_ADDR_28F4_inst_addr                                                "0x035F"
#define  set_ATSC_ADDR_28F4_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_28F4_reg)=data)
#define  get_ATSC_ADDR_28F4_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_28F4_reg))
#define  ATSC_ADDR_28F4_ffe_sync_space_odd_en_71_shift                           (7)
#define  ATSC_ADDR_28F4_ffe_sync_space_odd_en_70_shift                           (6)
#define  ATSC_ADDR_28F4_ffe_sync_space_odd_en_69_shift                           (5)
#define  ATSC_ADDR_28F4_ffe_sync_space_odd_en_68_shift                           (4)
#define  ATSC_ADDR_28F4_ffe_sync_space_odd_en_67_shift                           (3)
#define  ATSC_ADDR_28F4_ffe_sync_space_odd_en_66_shift                           (2)
#define  ATSC_ADDR_28F4_ffe_sync_space_odd_en_65_shift                           (1)
#define  ATSC_ADDR_28F4_ffe_sync_space_odd_en_64_shift                           (0)
#define  ATSC_ADDR_28F4_ffe_sync_space_odd_en_71_mask                            (0x00000080)
#define  ATSC_ADDR_28F4_ffe_sync_space_odd_en_70_mask                            (0x00000040)
#define  ATSC_ADDR_28F4_ffe_sync_space_odd_en_69_mask                            (0x00000020)
#define  ATSC_ADDR_28F4_ffe_sync_space_odd_en_68_mask                            (0x00000010)
#define  ATSC_ADDR_28F4_ffe_sync_space_odd_en_67_mask                            (0x00000008)
#define  ATSC_ADDR_28F4_ffe_sync_space_odd_en_66_mask                            (0x00000004)
#define  ATSC_ADDR_28F4_ffe_sync_space_odd_en_65_mask                            (0x00000002)
#define  ATSC_ADDR_28F4_ffe_sync_space_odd_en_64_mask                            (0x00000001)
#define  ATSC_ADDR_28F4_ffe_sync_space_odd_en_71(data)                           (0x00000080&((data)<<7))
#define  ATSC_ADDR_28F4_ffe_sync_space_odd_en_70(data)                           (0x00000040&((data)<<6))
#define  ATSC_ADDR_28F4_ffe_sync_space_odd_en_69(data)                           (0x00000020&((data)<<5))
#define  ATSC_ADDR_28F4_ffe_sync_space_odd_en_68(data)                           (0x00000010&((data)<<4))
#define  ATSC_ADDR_28F4_ffe_sync_space_odd_en_67(data)                           (0x00000008&((data)<<3))
#define  ATSC_ADDR_28F4_ffe_sync_space_odd_en_66(data)                           (0x00000004&((data)<<2))
#define  ATSC_ADDR_28F4_ffe_sync_space_odd_en_65(data)                           (0x00000002&((data)<<1))
#define  ATSC_ADDR_28F4_ffe_sync_space_odd_en_64(data)                           (0x00000001&(data))
#define  ATSC_ADDR_28F4_get_ffe_sync_space_odd_en_71(data)                       ((0x00000080&(data))>>7)
#define  ATSC_ADDR_28F4_get_ffe_sync_space_odd_en_70(data)                       ((0x00000040&(data))>>6)
#define  ATSC_ADDR_28F4_get_ffe_sync_space_odd_en_69(data)                       ((0x00000020&(data))>>5)
#define  ATSC_ADDR_28F4_get_ffe_sync_space_odd_en_68(data)                       ((0x00000010&(data))>>4)
#define  ATSC_ADDR_28F4_get_ffe_sync_space_odd_en_67(data)                       ((0x00000008&(data))>>3)
#define  ATSC_ADDR_28F4_get_ffe_sync_space_odd_en_66(data)                       ((0x00000004&(data))>>2)
#define  ATSC_ADDR_28F4_get_ffe_sync_space_odd_en_65(data)                       ((0x00000002&(data))>>1)
#define  ATSC_ADDR_28F4_get_ffe_sync_space_odd_en_64(data)                       (0x00000001&(data))

#define  ATSC_ADDR_28F5                                                         0x181563D4
#define  ATSC_ADDR_28F5_reg_addr                                                 "0xB81563D4"
#define  ATSC_ADDR_28F5_reg                                                      0xB81563D4
#define  ATSC_ADDR_28F5_inst_addr                                                "0x0360"
#define  set_ATSC_ADDR_28F5_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_28F5_reg)=data)
#define  get_ATSC_ADDR_28F5_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_28F5_reg))
#define  ATSC_ADDR_28F5_ffe_sync_space_odd_en_79_shift                           (7)
#define  ATSC_ADDR_28F5_ffe_sync_space_odd_en_78_shift                           (6)
#define  ATSC_ADDR_28F5_ffe_sync_space_odd_en_77_shift                           (5)
#define  ATSC_ADDR_28F5_ffe_sync_space_odd_en_76_shift                           (4)
#define  ATSC_ADDR_28F5_ffe_sync_space_odd_en_75_shift                           (3)
#define  ATSC_ADDR_28F5_ffe_sync_space_odd_en_74_shift                           (2)
#define  ATSC_ADDR_28F5_ffe_sync_space_odd_en_73_shift                           (1)
#define  ATSC_ADDR_28F5_ffe_sync_space_odd_en_72_shift                           (0)
#define  ATSC_ADDR_28F5_ffe_sync_space_odd_en_79_mask                            (0x00000080)
#define  ATSC_ADDR_28F5_ffe_sync_space_odd_en_78_mask                            (0x00000040)
#define  ATSC_ADDR_28F5_ffe_sync_space_odd_en_77_mask                            (0x00000020)
#define  ATSC_ADDR_28F5_ffe_sync_space_odd_en_76_mask                            (0x00000010)
#define  ATSC_ADDR_28F5_ffe_sync_space_odd_en_75_mask                            (0x00000008)
#define  ATSC_ADDR_28F5_ffe_sync_space_odd_en_74_mask                            (0x00000004)
#define  ATSC_ADDR_28F5_ffe_sync_space_odd_en_73_mask                            (0x00000002)
#define  ATSC_ADDR_28F5_ffe_sync_space_odd_en_72_mask                            (0x00000001)
#define  ATSC_ADDR_28F5_ffe_sync_space_odd_en_79(data)                           (0x00000080&((data)<<7))
#define  ATSC_ADDR_28F5_ffe_sync_space_odd_en_78(data)                           (0x00000040&((data)<<6))
#define  ATSC_ADDR_28F5_ffe_sync_space_odd_en_77(data)                           (0x00000020&((data)<<5))
#define  ATSC_ADDR_28F5_ffe_sync_space_odd_en_76(data)                           (0x00000010&((data)<<4))
#define  ATSC_ADDR_28F5_ffe_sync_space_odd_en_75(data)                           (0x00000008&((data)<<3))
#define  ATSC_ADDR_28F5_ffe_sync_space_odd_en_74(data)                           (0x00000004&((data)<<2))
#define  ATSC_ADDR_28F5_ffe_sync_space_odd_en_73(data)                           (0x00000002&((data)<<1))
#define  ATSC_ADDR_28F5_ffe_sync_space_odd_en_72(data)                           (0x00000001&(data))
#define  ATSC_ADDR_28F5_get_ffe_sync_space_odd_en_79(data)                       ((0x00000080&(data))>>7)
#define  ATSC_ADDR_28F5_get_ffe_sync_space_odd_en_78(data)                       ((0x00000040&(data))>>6)
#define  ATSC_ADDR_28F5_get_ffe_sync_space_odd_en_77(data)                       ((0x00000020&(data))>>5)
#define  ATSC_ADDR_28F5_get_ffe_sync_space_odd_en_76(data)                       ((0x00000010&(data))>>4)
#define  ATSC_ADDR_28F5_get_ffe_sync_space_odd_en_75(data)                       ((0x00000008&(data))>>3)
#define  ATSC_ADDR_28F5_get_ffe_sync_space_odd_en_74(data)                       ((0x00000004&(data))>>2)
#define  ATSC_ADDR_28F5_get_ffe_sync_space_odd_en_73(data)                       ((0x00000002&(data))>>1)
#define  ATSC_ADDR_28F5_get_ffe_sync_space_odd_en_72(data)                       (0x00000001&(data))

#define  ATSC_ADDR_28F6                                                         0x181563D8
#define  ATSC_ADDR_28F6_reg_addr                                                 "0xB81563D8"
#define  ATSC_ADDR_28F6_reg                                                      0xB81563D8
#define  ATSC_ADDR_28F6_inst_addr                                                "0x0361"
#define  set_ATSC_ADDR_28F6_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_28F6_reg)=data)
#define  get_ATSC_ADDR_28F6_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_28F6_reg))
#define  ATSC_ADDR_28F6_ffe_sync_space_odd_en_87_shift                           (7)
#define  ATSC_ADDR_28F6_ffe_sync_space_odd_en_86_shift                           (6)
#define  ATSC_ADDR_28F6_ffe_sync_space_odd_en_85_shift                           (5)
#define  ATSC_ADDR_28F6_ffe_sync_space_odd_en_84_shift                           (4)
#define  ATSC_ADDR_28F6_ffe_sync_space_odd_en_83_shift                           (3)
#define  ATSC_ADDR_28F6_ffe_sync_space_odd_en_82_shift                           (2)
#define  ATSC_ADDR_28F6_ffe_sync_space_odd_en_81_shift                           (1)
#define  ATSC_ADDR_28F6_ffe_sync_space_odd_en_80_shift                           (0)
#define  ATSC_ADDR_28F6_ffe_sync_space_odd_en_87_mask                            (0x00000080)
#define  ATSC_ADDR_28F6_ffe_sync_space_odd_en_86_mask                            (0x00000040)
#define  ATSC_ADDR_28F6_ffe_sync_space_odd_en_85_mask                            (0x00000020)
#define  ATSC_ADDR_28F6_ffe_sync_space_odd_en_84_mask                            (0x00000010)
#define  ATSC_ADDR_28F6_ffe_sync_space_odd_en_83_mask                            (0x00000008)
#define  ATSC_ADDR_28F6_ffe_sync_space_odd_en_82_mask                            (0x00000004)
#define  ATSC_ADDR_28F6_ffe_sync_space_odd_en_81_mask                            (0x00000002)
#define  ATSC_ADDR_28F6_ffe_sync_space_odd_en_80_mask                            (0x00000001)
#define  ATSC_ADDR_28F6_ffe_sync_space_odd_en_87(data)                           (0x00000080&((data)<<7))
#define  ATSC_ADDR_28F6_ffe_sync_space_odd_en_86(data)                           (0x00000040&((data)<<6))
#define  ATSC_ADDR_28F6_ffe_sync_space_odd_en_85(data)                           (0x00000020&((data)<<5))
#define  ATSC_ADDR_28F6_ffe_sync_space_odd_en_84(data)                           (0x00000010&((data)<<4))
#define  ATSC_ADDR_28F6_ffe_sync_space_odd_en_83(data)                           (0x00000008&((data)<<3))
#define  ATSC_ADDR_28F6_ffe_sync_space_odd_en_82(data)                           (0x00000004&((data)<<2))
#define  ATSC_ADDR_28F6_ffe_sync_space_odd_en_81(data)                           (0x00000002&((data)<<1))
#define  ATSC_ADDR_28F6_ffe_sync_space_odd_en_80(data)                           (0x00000001&(data))
#define  ATSC_ADDR_28F6_get_ffe_sync_space_odd_en_87(data)                       ((0x00000080&(data))>>7)
#define  ATSC_ADDR_28F6_get_ffe_sync_space_odd_en_86(data)                       ((0x00000040&(data))>>6)
#define  ATSC_ADDR_28F6_get_ffe_sync_space_odd_en_85(data)                       ((0x00000020&(data))>>5)
#define  ATSC_ADDR_28F6_get_ffe_sync_space_odd_en_84(data)                       ((0x00000010&(data))>>4)
#define  ATSC_ADDR_28F6_get_ffe_sync_space_odd_en_83(data)                       ((0x00000008&(data))>>3)
#define  ATSC_ADDR_28F6_get_ffe_sync_space_odd_en_82(data)                       ((0x00000004&(data))>>2)
#define  ATSC_ADDR_28F6_get_ffe_sync_space_odd_en_81(data)                       ((0x00000002&(data))>>1)
#define  ATSC_ADDR_28F6_get_ffe_sync_space_odd_en_80(data)                       (0x00000001&(data))

#define  ATSC_ADDR_28F7                                                         0x181563DC
#define  ATSC_ADDR_28F7_reg_addr                                                 "0xB81563DC"
#define  ATSC_ADDR_28F7_reg                                                      0xB81563DC
#define  ATSC_ADDR_28F7_inst_addr                                                "0x0362"
#define  set_ATSC_ADDR_28F7_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_28F7_reg)=data)
#define  get_ATSC_ADDR_28F7_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_28F7_reg))
#define  ATSC_ADDR_28F7_ffe_sync_space_odd_en_95_shift                           (7)
#define  ATSC_ADDR_28F7_ffe_sync_space_odd_en_94_shift                           (6)
#define  ATSC_ADDR_28F7_ffe_sync_space_odd_en_93_shift                           (5)
#define  ATSC_ADDR_28F7_ffe_sync_space_odd_en_92_shift                           (4)
#define  ATSC_ADDR_28F7_ffe_sync_space_odd_en_91_shift                           (3)
#define  ATSC_ADDR_28F7_ffe_sync_space_odd_en_90_shift                           (2)
#define  ATSC_ADDR_28F7_ffe_sync_space_odd_en_89_shift                           (1)
#define  ATSC_ADDR_28F7_ffe_sync_space_odd_en_88_shift                           (0)
#define  ATSC_ADDR_28F7_ffe_sync_space_odd_en_95_mask                            (0x00000080)
#define  ATSC_ADDR_28F7_ffe_sync_space_odd_en_94_mask                            (0x00000040)
#define  ATSC_ADDR_28F7_ffe_sync_space_odd_en_93_mask                            (0x00000020)
#define  ATSC_ADDR_28F7_ffe_sync_space_odd_en_92_mask                            (0x00000010)
#define  ATSC_ADDR_28F7_ffe_sync_space_odd_en_91_mask                            (0x00000008)
#define  ATSC_ADDR_28F7_ffe_sync_space_odd_en_90_mask                            (0x00000004)
#define  ATSC_ADDR_28F7_ffe_sync_space_odd_en_89_mask                            (0x00000002)
#define  ATSC_ADDR_28F7_ffe_sync_space_odd_en_88_mask                            (0x00000001)
#define  ATSC_ADDR_28F7_ffe_sync_space_odd_en_95(data)                           (0x00000080&((data)<<7))
#define  ATSC_ADDR_28F7_ffe_sync_space_odd_en_94(data)                           (0x00000040&((data)<<6))
#define  ATSC_ADDR_28F7_ffe_sync_space_odd_en_93(data)                           (0x00000020&((data)<<5))
#define  ATSC_ADDR_28F7_ffe_sync_space_odd_en_92(data)                           (0x00000010&((data)<<4))
#define  ATSC_ADDR_28F7_ffe_sync_space_odd_en_91(data)                           (0x00000008&((data)<<3))
#define  ATSC_ADDR_28F7_ffe_sync_space_odd_en_90(data)                           (0x00000004&((data)<<2))
#define  ATSC_ADDR_28F7_ffe_sync_space_odd_en_89(data)                           (0x00000002&((data)<<1))
#define  ATSC_ADDR_28F7_ffe_sync_space_odd_en_88(data)                           (0x00000001&(data))
#define  ATSC_ADDR_28F7_get_ffe_sync_space_odd_en_95(data)                       ((0x00000080&(data))>>7)
#define  ATSC_ADDR_28F7_get_ffe_sync_space_odd_en_94(data)                       ((0x00000040&(data))>>6)
#define  ATSC_ADDR_28F7_get_ffe_sync_space_odd_en_93(data)                       ((0x00000020&(data))>>5)
#define  ATSC_ADDR_28F7_get_ffe_sync_space_odd_en_92(data)                       ((0x00000010&(data))>>4)
#define  ATSC_ADDR_28F7_get_ffe_sync_space_odd_en_91(data)                       ((0x00000008&(data))>>3)
#define  ATSC_ADDR_28F7_get_ffe_sync_space_odd_en_90(data)                       ((0x00000004&(data))>>2)
#define  ATSC_ADDR_28F7_get_ffe_sync_space_odd_en_89(data)                       ((0x00000002&(data))>>1)
#define  ATSC_ADDR_28F7_get_ffe_sync_space_odd_en_88(data)                       (0x00000001&(data))

#define  ATSC_ADDR_272E                                                         0x18155CB8
#define  ATSC_ADDR_272E_reg_addr                                                 "0xB8155CB8"
#define  ATSC_ADDR_272E_reg                                                      0xB8155CB8
#define  ATSC_ADDR_272E_inst_addr                                                "0x0363"
#define  set_ATSC_ADDR_272E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_272E_reg)=data)
#define  get_ATSC_ADDR_272E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_272E_reg))
#define  ATSC_ADDR_272E_ffe_gc_tr_coeff_th_shift                                 (0)
#define  ATSC_ADDR_272E_ffe_gc_tr_coeff_th_mask                                  (0x000000FF)
#define  ATSC_ADDR_272E_ffe_gc_tr_coeff_th(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_272E_get_ffe_gc_tr_coeff_th(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_272F                                                         0x18155CBC
#define  ATSC_ADDR_272F_reg_addr                                                 "0xB8155CBC"
#define  ATSC_ADDR_272F_reg                                                      0xB8155CBC
#define  ATSC_ADDR_272F_inst_addr                                                "0x0364"
#define  set_ATSC_ADDR_272F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_272F_reg)=data)
#define  get_ATSC_ADDR_272F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_272F_reg))
#define  ATSC_ADDR_272F_ffe_gc_dd_coeff_th_shift                                 (0)
#define  ATSC_ADDR_272F_ffe_gc_dd_coeff_th_mask                                  (0x000000FF)
#define  ATSC_ADDR_272F_ffe_gc_dd_coeff_th(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_272F_get_ffe_gc_dd_coeff_th(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2730                                                         0x18155CC0
#define  ATSC_ADDR_2730_reg_addr                                                 "0xB8155CC0"
#define  ATSC_ADDR_2730_reg                                                      0xB8155CC0
#define  ATSC_ADDR_2730_inst_addr                                                "0x0365"
#define  set_ATSC_ADDR_2730_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2730_reg)=data)
#define  get_ATSC_ADDR_2730_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2730_reg))
#define  ATSC_ADDR_2730_ffe_gc_tr_coeff_en_7_shift                               (7)
#define  ATSC_ADDR_2730_ffe_gc_tr_coeff_en_6_shift                               (6)
#define  ATSC_ADDR_2730_ffe_gc_tr_coeff_en_5_shift                               (5)
#define  ATSC_ADDR_2730_ffe_gc_tr_coeff_en_4_shift                               (4)
#define  ATSC_ADDR_2730_ffe_gc_tr_coeff_en_3_shift                               (3)
#define  ATSC_ADDR_2730_ffe_gc_tr_coeff_en_2_shift                               (2)
#define  ATSC_ADDR_2730_ffe_gc_tr_coeff_en_1_shift                               (1)
#define  ATSC_ADDR_2730_ffe_gc_tr_coeff_en_0_shift                               (0)
#define  ATSC_ADDR_2730_ffe_gc_tr_coeff_en_7_mask                                (0x00000080)
#define  ATSC_ADDR_2730_ffe_gc_tr_coeff_en_6_mask                                (0x00000040)
#define  ATSC_ADDR_2730_ffe_gc_tr_coeff_en_5_mask                                (0x00000020)
#define  ATSC_ADDR_2730_ffe_gc_tr_coeff_en_4_mask                                (0x00000010)
#define  ATSC_ADDR_2730_ffe_gc_tr_coeff_en_3_mask                                (0x00000008)
#define  ATSC_ADDR_2730_ffe_gc_tr_coeff_en_2_mask                                (0x00000004)
#define  ATSC_ADDR_2730_ffe_gc_tr_coeff_en_1_mask                                (0x00000002)
#define  ATSC_ADDR_2730_ffe_gc_tr_coeff_en_0_mask                                (0x00000001)
#define  ATSC_ADDR_2730_ffe_gc_tr_coeff_en_7(data)                               (0x00000080&((data)<<7))
#define  ATSC_ADDR_2730_ffe_gc_tr_coeff_en_6(data)                               (0x00000040&((data)<<6))
#define  ATSC_ADDR_2730_ffe_gc_tr_coeff_en_5(data)                               (0x00000020&((data)<<5))
#define  ATSC_ADDR_2730_ffe_gc_tr_coeff_en_4(data)                               (0x00000010&((data)<<4))
#define  ATSC_ADDR_2730_ffe_gc_tr_coeff_en_3(data)                               (0x00000008&((data)<<3))
#define  ATSC_ADDR_2730_ffe_gc_tr_coeff_en_2(data)                               (0x00000004&((data)<<2))
#define  ATSC_ADDR_2730_ffe_gc_tr_coeff_en_1(data)                               (0x00000002&((data)<<1))
#define  ATSC_ADDR_2730_ffe_gc_tr_coeff_en_0(data)                               (0x00000001&(data))
#define  ATSC_ADDR_2730_get_ffe_gc_tr_coeff_en_7(data)                           ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2730_get_ffe_gc_tr_coeff_en_6(data)                           ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2730_get_ffe_gc_tr_coeff_en_5(data)                           ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2730_get_ffe_gc_tr_coeff_en_4(data)                           ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2730_get_ffe_gc_tr_coeff_en_3(data)                           ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2730_get_ffe_gc_tr_coeff_en_2(data)                           ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2730_get_ffe_gc_tr_coeff_en_1(data)                           ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2730_get_ffe_gc_tr_coeff_en_0(data)                           (0x00000001&(data))

#define  ATSC_ADDR_2731                                                         0x18155CC4
#define  ATSC_ADDR_2731_reg_addr                                                 "0xB8155CC4"
#define  ATSC_ADDR_2731_reg                                                      0xB8155CC4
#define  ATSC_ADDR_2731_inst_addr                                                "0x0366"
#define  set_ATSC_ADDR_2731_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2731_reg)=data)
#define  get_ATSC_ADDR_2731_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2731_reg))
#define  ATSC_ADDR_2731_ffe_gc_tr_coeff_en_15_shift                              (7)
#define  ATSC_ADDR_2731_ffe_gc_tr_coeff_en_14_shift                              (6)
#define  ATSC_ADDR_2731_ffe_gc_tr_coeff_en_13_shift                              (5)
#define  ATSC_ADDR_2731_ffe_gc_tr_coeff_en_12_shift                              (4)
#define  ATSC_ADDR_2731_ffe_gc_tr_coeff_en_11_shift                              (3)
#define  ATSC_ADDR_2731_ffe_gc_tr_coeff_en_10_shift                              (2)
#define  ATSC_ADDR_2731_ffe_gc_tr_coeff_en_9_shift                               (1)
#define  ATSC_ADDR_2731_ffe_gc_tr_coeff_en_8_shift                               (0)
#define  ATSC_ADDR_2731_ffe_gc_tr_coeff_en_15_mask                               (0x00000080)
#define  ATSC_ADDR_2731_ffe_gc_tr_coeff_en_14_mask                               (0x00000040)
#define  ATSC_ADDR_2731_ffe_gc_tr_coeff_en_13_mask                               (0x00000020)
#define  ATSC_ADDR_2731_ffe_gc_tr_coeff_en_12_mask                               (0x00000010)
#define  ATSC_ADDR_2731_ffe_gc_tr_coeff_en_11_mask                               (0x00000008)
#define  ATSC_ADDR_2731_ffe_gc_tr_coeff_en_10_mask                               (0x00000004)
#define  ATSC_ADDR_2731_ffe_gc_tr_coeff_en_9_mask                                (0x00000002)
#define  ATSC_ADDR_2731_ffe_gc_tr_coeff_en_8_mask                                (0x00000001)
#define  ATSC_ADDR_2731_ffe_gc_tr_coeff_en_15(data)                              (0x00000080&((data)<<7))
#define  ATSC_ADDR_2731_ffe_gc_tr_coeff_en_14(data)                              (0x00000040&((data)<<6))
#define  ATSC_ADDR_2731_ffe_gc_tr_coeff_en_13(data)                              (0x00000020&((data)<<5))
#define  ATSC_ADDR_2731_ffe_gc_tr_coeff_en_12(data)                              (0x00000010&((data)<<4))
#define  ATSC_ADDR_2731_ffe_gc_tr_coeff_en_11(data)                              (0x00000008&((data)<<3))
#define  ATSC_ADDR_2731_ffe_gc_tr_coeff_en_10(data)                              (0x00000004&((data)<<2))
#define  ATSC_ADDR_2731_ffe_gc_tr_coeff_en_9(data)                               (0x00000002&((data)<<1))
#define  ATSC_ADDR_2731_ffe_gc_tr_coeff_en_8(data)                               (0x00000001&(data))
#define  ATSC_ADDR_2731_get_ffe_gc_tr_coeff_en_15(data)                          ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2731_get_ffe_gc_tr_coeff_en_14(data)                          ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2731_get_ffe_gc_tr_coeff_en_13(data)                          ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2731_get_ffe_gc_tr_coeff_en_12(data)                          ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2731_get_ffe_gc_tr_coeff_en_11(data)                          ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2731_get_ffe_gc_tr_coeff_en_10(data)                          ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2731_get_ffe_gc_tr_coeff_en_9(data)                           ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2731_get_ffe_gc_tr_coeff_en_8(data)                           (0x00000001&(data))

#define  ATSC_ADDR_2732                                                         0x18155CC8
#define  ATSC_ADDR_2732_reg_addr                                                 "0xB8155CC8"
#define  ATSC_ADDR_2732_reg                                                      0xB8155CC8
#define  ATSC_ADDR_2732_inst_addr                                                "0x0367"
#define  set_ATSC_ADDR_2732_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2732_reg)=data)
#define  get_ATSC_ADDR_2732_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2732_reg))
#define  ATSC_ADDR_2732_ffe_gc_tr_coeff_en_23_shift                              (7)
#define  ATSC_ADDR_2732_ffe_gc_tr_coeff_en_22_shift                              (6)
#define  ATSC_ADDR_2732_ffe_gc_tr_coeff_en_21_shift                              (5)
#define  ATSC_ADDR_2732_ffe_gc_tr_coeff_en_20_shift                              (4)
#define  ATSC_ADDR_2732_ffe_gc_tr_coeff_en_19_shift                              (3)
#define  ATSC_ADDR_2732_ffe_gc_tr_coeff_en_18_shift                              (2)
#define  ATSC_ADDR_2732_ffe_gc_tr_coeff_en_17_shift                              (1)
#define  ATSC_ADDR_2732_ffe_gc_tr_coeff_en_16_shift                              (0)
#define  ATSC_ADDR_2732_ffe_gc_tr_coeff_en_23_mask                               (0x00000080)
#define  ATSC_ADDR_2732_ffe_gc_tr_coeff_en_22_mask                               (0x00000040)
#define  ATSC_ADDR_2732_ffe_gc_tr_coeff_en_21_mask                               (0x00000020)
#define  ATSC_ADDR_2732_ffe_gc_tr_coeff_en_20_mask                               (0x00000010)
#define  ATSC_ADDR_2732_ffe_gc_tr_coeff_en_19_mask                               (0x00000008)
#define  ATSC_ADDR_2732_ffe_gc_tr_coeff_en_18_mask                               (0x00000004)
#define  ATSC_ADDR_2732_ffe_gc_tr_coeff_en_17_mask                               (0x00000002)
#define  ATSC_ADDR_2732_ffe_gc_tr_coeff_en_16_mask                               (0x00000001)
#define  ATSC_ADDR_2732_ffe_gc_tr_coeff_en_23(data)                              (0x00000080&((data)<<7))
#define  ATSC_ADDR_2732_ffe_gc_tr_coeff_en_22(data)                              (0x00000040&((data)<<6))
#define  ATSC_ADDR_2732_ffe_gc_tr_coeff_en_21(data)                              (0x00000020&((data)<<5))
#define  ATSC_ADDR_2732_ffe_gc_tr_coeff_en_20(data)                              (0x00000010&((data)<<4))
#define  ATSC_ADDR_2732_ffe_gc_tr_coeff_en_19(data)                              (0x00000008&((data)<<3))
#define  ATSC_ADDR_2732_ffe_gc_tr_coeff_en_18(data)                              (0x00000004&((data)<<2))
#define  ATSC_ADDR_2732_ffe_gc_tr_coeff_en_17(data)                              (0x00000002&((data)<<1))
#define  ATSC_ADDR_2732_ffe_gc_tr_coeff_en_16(data)                              (0x00000001&(data))
#define  ATSC_ADDR_2732_get_ffe_gc_tr_coeff_en_23(data)                          ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2732_get_ffe_gc_tr_coeff_en_22(data)                          ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2732_get_ffe_gc_tr_coeff_en_21(data)                          ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2732_get_ffe_gc_tr_coeff_en_20(data)                          ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2732_get_ffe_gc_tr_coeff_en_19(data)                          ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2732_get_ffe_gc_tr_coeff_en_18(data)                          ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2732_get_ffe_gc_tr_coeff_en_17(data)                          ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2732_get_ffe_gc_tr_coeff_en_16(data)                          (0x00000001&(data))

#define  ATSC_ADDR_2733                                                         0x18155CCC
#define  ATSC_ADDR_2733_reg_addr                                                 "0xB8155CCC"
#define  ATSC_ADDR_2733_reg                                                      0xB8155CCC
#define  ATSC_ADDR_2733_inst_addr                                                "0x0368"
#define  set_ATSC_ADDR_2733_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2733_reg)=data)
#define  get_ATSC_ADDR_2733_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2733_reg))
#define  ATSC_ADDR_2733_ffe_gc_tr_coeff_en_31_shift                              (7)
#define  ATSC_ADDR_2733_ffe_gc_tr_coeff_en_30_shift                              (6)
#define  ATSC_ADDR_2733_ffe_gc_tr_coeff_en_29_shift                              (5)
#define  ATSC_ADDR_2733_ffe_gc_tr_coeff_en_28_shift                              (4)
#define  ATSC_ADDR_2733_ffe_gc_tr_coeff_en_27_shift                              (3)
#define  ATSC_ADDR_2733_ffe_gc_tr_coeff_en_26_shift                              (2)
#define  ATSC_ADDR_2733_ffe_gc_tr_coeff_en_25_shift                              (1)
#define  ATSC_ADDR_2733_ffe_gc_tr_coeff_en_24_shift                              (0)
#define  ATSC_ADDR_2733_ffe_gc_tr_coeff_en_31_mask                               (0x00000080)
#define  ATSC_ADDR_2733_ffe_gc_tr_coeff_en_30_mask                               (0x00000040)
#define  ATSC_ADDR_2733_ffe_gc_tr_coeff_en_29_mask                               (0x00000020)
#define  ATSC_ADDR_2733_ffe_gc_tr_coeff_en_28_mask                               (0x00000010)
#define  ATSC_ADDR_2733_ffe_gc_tr_coeff_en_27_mask                               (0x00000008)
#define  ATSC_ADDR_2733_ffe_gc_tr_coeff_en_26_mask                               (0x00000004)
#define  ATSC_ADDR_2733_ffe_gc_tr_coeff_en_25_mask                               (0x00000002)
#define  ATSC_ADDR_2733_ffe_gc_tr_coeff_en_24_mask                               (0x00000001)
#define  ATSC_ADDR_2733_ffe_gc_tr_coeff_en_31(data)                              (0x00000080&((data)<<7))
#define  ATSC_ADDR_2733_ffe_gc_tr_coeff_en_30(data)                              (0x00000040&((data)<<6))
#define  ATSC_ADDR_2733_ffe_gc_tr_coeff_en_29(data)                              (0x00000020&((data)<<5))
#define  ATSC_ADDR_2733_ffe_gc_tr_coeff_en_28(data)                              (0x00000010&((data)<<4))
#define  ATSC_ADDR_2733_ffe_gc_tr_coeff_en_27(data)                              (0x00000008&((data)<<3))
#define  ATSC_ADDR_2733_ffe_gc_tr_coeff_en_26(data)                              (0x00000004&((data)<<2))
#define  ATSC_ADDR_2733_ffe_gc_tr_coeff_en_25(data)                              (0x00000002&((data)<<1))
#define  ATSC_ADDR_2733_ffe_gc_tr_coeff_en_24(data)                              (0x00000001&(data))
#define  ATSC_ADDR_2733_get_ffe_gc_tr_coeff_en_31(data)                          ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2733_get_ffe_gc_tr_coeff_en_30(data)                          ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2733_get_ffe_gc_tr_coeff_en_29(data)                          ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2733_get_ffe_gc_tr_coeff_en_28(data)                          ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2733_get_ffe_gc_tr_coeff_en_27(data)                          ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2733_get_ffe_gc_tr_coeff_en_26(data)                          ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2733_get_ffe_gc_tr_coeff_en_25(data)                          ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2733_get_ffe_gc_tr_coeff_en_24(data)                          (0x00000001&(data))

#define  ATSC_ADDR_2734                                                         0x18155CD0
#define  ATSC_ADDR_2734_reg_addr                                                 "0xB8155CD0"
#define  ATSC_ADDR_2734_reg                                                      0xB8155CD0
#define  ATSC_ADDR_2734_inst_addr                                                "0x0369"
#define  set_ATSC_ADDR_2734_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2734_reg)=data)
#define  get_ATSC_ADDR_2734_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2734_reg))
#define  ATSC_ADDR_2734_ffe_gc_tr_coeff_en_39_shift                              (7)
#define  ATSC_ADDR_2734_ffe_gc_tr_coeff_en_38_shift                              (6)
#define  ATSC_ADDR_2734_ffe_gc_tr_coeff_en_37_shift                              (5)
#define  ATSC_ADDR_2734_ffe_gc_tr_coeff_en_36_shift                              (4)
#define  ATSC_ADDR_2734_ffe_gc_tr_coeff_en_35_shift                              (3)
#define  ATSC_ADDR_2734_ffe_gc_tr_coeff_en_34_shift                              (2)
#define  ATSC_ADDR_2734_ffe_gc_tr_coeff_en_33_shift                              (1)
#define  ATSC_ADDR_2734_ffe_gc_tr_coeff_en_32_shift                              (0)
#define  ATSC_ADDR_2734_ffe_gc_tr_coeff_en_39_mask                               (0x00000080)
#define  ATSC_ADDR_2734_ffe_gc_tr_coeff_en_38_mask                               (0x00000040)
#define  ATSC_ADDR_2734_ffe_gc_tr_coeff_en_37_mask                               (0x00000020)
#define  ATSC_ADDR_2734_ffe_gc_tr_coeff_en_36_mask                               (0x00000010)
#define  ATSC_ADDR_2734_ffe_gc_tr_coeff_en_35_mask                               (0x00000008)
#define  ATSC_ADDR_2734_ffe_gc_tr_coeff_en_34_mask                               (0x00000004)
#define  ATSC_ADDR_2734_ffe_gc_tr_coeff_en_33_mask                               (0x00000002)
#define  ATSC_ADDR_2734_ffe_gc_tr_coeff_en_32_mask                               (0x00000001)
#define  ATSC_ADDR_2734_ffe_gc_tr_coeff_en_39(data)                              (0x00000080&((data)<<7))
#define  ATSC_ADDR_2734_ffe_gc_tr_coeff_en_38(data)                              (0x00000040&((data)<<6))
#define  ATSC_ADDR_2734_ffe_gc_tr_coeff_en_37(data)                              (0x00000020&((data)<<5))
#define  ATSC_ADDR_2734_ffe_gc_tr_coeff_en_36(data)                              (0x00000010&((data)<<4))
#define  ATSC_ADDR_2734_ffe_gc_tr_coeff_en_35(data)                              (0x00000008&((data)<<3))
#define  ATSC_ADDR_2734_ffe_gc_tr_coeff_en_34(data)                              (0x00000004&((data)<<2))
#define  ATSC_ADDR_2734_ffe_gc_tr_coeff_en_33(data)                              (0x00000002&((data)<<1))
#define  ATSC_ADDR_2734_ffe_gc_tr_coeff_en_32(data)                              (0x00000001&(data))
#define  ATSC_ADDR_2734_get_ffe_gc_tr_coeff_en_39(data)                          ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2734_get_ffe_gc_tr_coeff_en_38(data)                          ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2734_get_ffe_gc_tr_coeff_en_37(data)                          ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2734_get_ffe_gc_tr_coeff_en_36(data)                          ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2734_get_ffe_gc_tr_coeff_en_35(data)                          ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2734_get_ffe_gc_tr_coeff_en_34(data)                          ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2734_get_ffe_gc_tr_coeff_en_33(data)                          ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2734_get_ffe_gc_tr_coeff_en_32(data)                          (0x00000001&(data))

#define  ATSC_ADDR_2735                                                         0x18155CD4
#define  ATSC_ADDR_2735_reg_addr                                                 "0xB8155CD4"
#define  ATSC_ADDR_2735_reg                                                      0xB8155CD4
#define  ATSC_ADDR_2735_inst_addr                                                "0x036A"
#define  set_ATSC_ADDR_2735_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2735_reg)=data)
#define  get_ATSC_ADDR_2735_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2735_reg))
#define  ATSC_ADDR_2735_ffe_gc_tr_coeff_en_47_shift                              (7)
#define  ATSC_ADDR_2735_ffe_gc_tr_coeff_en_46_shift                              (6)
#define  ATSC_ADDR_2735_ffe_gc_tr_coeff_en_45_shift                              (5)
#define  ATSC_ADDR_2735_ffe_gc_tr_coeff_en_44_shift                              (4)
#define  ATSC_ADDR_2735_ffe_gc_tr_coeff_en_43_shift                              (3)
#define  ATSC_ADDR_2735_ffe_gc_tr_coeff_en_42_shift                              (2)
#define  ATSC_ADDR_2735_ffe_gc_tr_coeff_en_41_shift                              (1)
#define  ATSC_ADDR_2735_ffe_gc_tr_coeff_en_40_shift                              (0)
#define  ATSC_ADDR_2735_ffe_gc_tr_coeff_en_47_mask                               (0x00000080)
#define  ATSC_ADDR_2735_ffe_gc_tr_coeff_en_46_mask                               (0x00000040)
#define  ATSC_ADDR_2735_ffe_gc_tr_coeff_en_45_mask                               (0x00000020)
#define  ATSC_ADDR_2735_ffe_gc_tr_coeff_en_44_mask                               (0x00000010)
#define  ATSC_ADDR_2735_ffe_gc_tr_coeff_en_43_mask                               (0x00000008)
#define  ATSC_ADDR_2735_ffe_gc_tr_coeff_en_42_mask                               (0x00000004)
#define  ATSC_ADDR_2735_ffe_gc_tr_coeff_en_41_mask                               (0x00000002)
#define  ATSC_ADDR_2735_ffe_gc_tr_coeff_en_40_mask                               (0x00000001)
#define  ATSC_ADDR_2735_ffe_gc_tr_coeff_en_47(data)                              (0x00000080&((data)<<7))
#define  ATSC_ADDR_2735_ffe_gc_tr_coeff_en_46(data)                              (0x00000040&((data)<<6))
#define  ATSC_ADDR_2735_ffe_gc_tr_coeff_en_45(data)                              (0x00000020&((data)<<5))
#define  ATSC_ADDR_2735_ffe_gc_tr_coeff_en_44(data)                              (0x00000010&((data)<<4))
#define  ATSC_ADDR_2735_ffe_gc_tr_coeff_en_43(data)                              (0x00000008&((data)<<3))
#define  ATSC_ADDR_2735_ffe_gc_tr_coeff_en_42(data)                              (0x00000004&((data)<<2))
#define  ATSC_ADDR_2735_ffe_gc_tr_coeff_en_41(data)                              (0x00000002&((data)<<1))
#define  ATSC_ADDR_2735_ffe_gc_tr_coeff_en_40(data)                              (0x00000001&(data))
#define  ATSC_ADDR_2735_get_ffe_gc_tr_coeff_en_47(data)                          ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2735_get_ffe_gc_tr_coeff_en_46(data)                          ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2735_get_ffe_gc_tr_coeff_en_45(data)                          ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2735_get_ffe_gc_tr_coeff_en_44(data)                          ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2735_get_ffe_gc_tr_coeff_en_43(data)                          ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2735_get_ffe_gc_tr_coeff_en_42(data)                          ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2735_get_ffe_gc_tr_coeff_en_41(data)                          ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2735_get_ffe_gc_tr_coeff_en_40(data)                          (0x00000001&(data))

#define  ATSC_ADDR_2FC5                                                         0x18157F14
#define  ATSC_ADDR_2FC5_reg_addr                                                 "0xB8157F14"
#define  ATSC_ADDR_2FC5_reg                                                      0xB8157F14
#define  ATSC_ADDR_2FC5_inst_addr                                                "0x036B"
#define  set_ATSC_ADDR_2FC5_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FC5_reg)=data)
#define  get_ATSC_ADDR_2FC5_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FC5_reg))
#define  ATSC_ADDR_2FC5_ffe_gc_tr_coeff_en_55_shift                              (7)
#define  ATSC_ADDR_2FC5_ffe_gc_tr_coeff_en_54_shift                              (6)
#define  ATSC_ADDR_2FC5_ffe_gc_tr_coeff_en_53_shift                              (5)
#define  ATSC_ADDR_2FC5_ffe_gc_tr_coeff_en_52_shift                              (4)
#define  ATSC_ADDR_2FC5_ffe_gc_tr_coeff_en_51_shift                              (3)
#define  ATSC_ADDR_2FC5_ffe_gc_tr_coeff_en_50_shift                              (2)
#define  ATSC_ADDR_2FC5_ffe_gc_tr_coeff_en_49_shift                              (1)
#define  ATSC_ADDR_2FC5_ffe_gc_tr_coeff_en_48_shift                              (0)
#define  ATSC_ADDR_2FC5_ffe_gc_tr_coeff_en_55_mask                               (0x00000080)
#define  ATSC_ADDR_2FC5_ffe_gc_tr_coeff_en_54_mask                               (0x00000040)
#define  ATSC_ADDR_2FC5_ffe_gc_tr_coeff_en_53_mask                               (0x00000020)
#define  ATSC_ADDR_2FC5_ffe_gc_tr_coeff_en_52_mask                               (0x00000010)
#define  ATSC_ADDR_2FC5_ffe_gc_tr_coeff_en_51_mask                               (0x00000008)
#define  ATSC_ADDR_2FC5_ffe_gc_tr_coeff_en_50_mask                               (0x00000004)
#define  ATSC_ADDR_2FC5_ffe_gc_tr_coeff_en_49_mask                               (0x00000002)
#define  ATSC_ADDR_2FC5_ffe_gc_tr_coeff_en_48_mask                               (0x00000001)
#define  ATSC_ADDR_2FC5_ffe_gc_tr_coeff_en_55(data)                              (0x00000080&((data)<<7))
#define  ATSC_ADDR_2FC5_ffe_gc_tr_coeff_en_54(data)                              (0x00000040&((data)<<6))
#define  ATSC_ADDR_2FC5_ffe_gc_tr_coeff_en_53(data)                              (0x00000020&((data)<<5))
#define  ATSC_ADDR_2FC5_ffe_gc_tr_coeff_en_52(data)                              (0x00000010&((data)<<4))
#define  ATSC_ADDR_2FC5_ffe_gc_tr_coeff_en_51(data)                              (0x00000008&((data)<<3))
#define  ATSC_ADDR_2FC5_ffe_gc_tr_coeff_en_50(data)                              (0x00000004&((data)<<2))
#define  ATSC_ADDR_2FC5_ffe_gc_tr_coeff_en_49(data)                              (0x00000002&((data)<<1))
#define  ATSC_ADDR_2FC5_ffe_gc_tr_coeff_en_48(data)                              (0x00000001&(data))
#define  ATSC_ADDR_2FC5_get_ffe_gc_tr_coeff_en_55(data)                          ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2FC5_get_ffe_gc_tr_coeff_en_54(data)                          ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2FC5_get_ffe_gc_tr_coeff_en_53(data)                          ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2FC5_get_ffe_gc_tr_coeff_en_52(data)                          ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2FC5_get_ffe_gc_tr_coeff_en_51(data)                          ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2FC5_get_ffe_gc_tr_coeff_en_50(data)                          ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2FC5_get_ffe_gc_tr_coeff_en_49(data)                          ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2FC5_get_ffe_gc_tr_coeff_en_48(data)                          (0x00000001&(data))

#define  ATSC_ADDR_2FC6                                                         0x18157F18
#define  ATSC_ADDR_2FC6_reg_addr                                                 "0xB8157F18"
#define  ATSC_ADDR_2FC6_reg                                                      0xB8157F18
#define  ATSC_ADDR_2FC6_inst_addr                                                "0x036C"
#define  set_ATSC_ADDR_2FC6_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FC6_reg)=data)
#define  get_ATSC_ADDR_2FC6_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FC6_reg))
#define  ATSC_ADDR_2FC6_ffe_gc_tr_coeff_en_63_shift                              (7)
#define  ATSC_ADDR_2FC6_ffe_gc_tr_coeff_en_62_shift                              (6)
#define  ATSC_ADDR_2FC6_ffe_gc_tr_coeff_en_61_shift                              (5)
#define  ATSC_ADDR_2FC6_ffe_gc_tr_coeff_en_60_shift                              (4)
#define  ATSC_ADDR_2FC6_ffe_gc_tr_coeff_en_59_shift                              (3)
#define  ATSC_ADDR_2FC6_ffe_gc_tr_coeff_en_58_shift                              (2)
#define  ATSC_ADDR_2FC6_ffe_gc_tr_coeff_en_57_shift                              (1)
#define  ATSC_ADDR_2FC6_ffe_gc_tr_coeff_en_56_shift                              (0)
#define  ATSC_ADDR_2FC6_ffe_gc_tr_coeff_en_63_mask                               (0x00000080)
#define  ATSC_ADDR_2FC6_ffe_gc_tr_coeff_en_62_mask                               (0x00000040)
#define  ATSC_ADDR_2FC6_ffe_gc_tr_coeff_en_61_mask                               (0x00000020)
#define  ATSC_ADDR_2FC6_ffe_gc_tr_coeff_en_60_mask                               (0x00000010)
#define  ATSC_ADDR_2FC6_ffe_gc_tr_coeff_en_59_mask                               (0x00000008)
#define  ATSC_ADDR_2FC6_ffe_gc_tr_coeff_en_58_mask                               (0x00000004)
#define  ATSC_ADDR_2FC6_ffe_gc_tr_coeff_en_57_mask                               (0x00000002)
#define  ATSC_ADDR_2FC6_ffe_gc_tr_coeff_en_56_mask                               (0x00000001)
#define  ATSC_ADDR_2FC6_ffe_gc_tr_coeff_en_63(data)                              (0x00000080&((data)<<7))
#define  ATSC_ADDR_2FC6_ffe_gc_tr_coeff_en_62(data)                              (0x00000040&((data)<<6))
#define  ATSC_ADDR_2FC6_ffe_gc_tr_coeff_en_61(data)                              (0x00000020&((data)<<5))
#define  ATSC_ADDR_2FC6_ffe_gc_tr_coeff_en_60(data)                              (0x00000010&((data)<<4))
#define  ATSC_ADDR_2FC6_ffe_gc_tr_coeff_en_59(data)                              (0x00000008&((data)<<3))
#define  ATSC_ADDR_2FC6_ffe_gc_tr_coeff_en_58(data)                              (0x00000004&((data)<<2))
#define  ATSC_ADDR_2FC6_ffe_gc_tr_coeff_en_57(data)                              (0x00000002&((data)<<1))
#define  ATSC_ADDR_2FC6_ffe_gc_tr_coeff_en_56(data)                              (0x00000001&(data))
#define  ATSC_ADDR_2FC6_get_ffe_gc_tr_coeff_en_63(data)                          ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2FC6_get_ffe_gc_tr_coeff_en_62(data)                          ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2FC6_get_ffe_gc_tr_coeff_en_61(data)                          ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2FC6_get_ffe_gc_tr_coeff_en_60(data)                          ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2FC6_get_ffe_gc_tr_coeff_en_59(data)                          ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2FC6_get_ffe_gc_tr_coeff_en_58(data)                          ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2FC6_get_ffe_gc_tr_coeff_en_57(data)                          ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2FC6_get_ffe_gc_tr_coeff_en_56(data)                          (0x00000001&(data))

#define  ATSC_ADDR_2FCB                                                         0x18157F2C
#define  ATSC_ADDR_2FCB_reg_addr                                                 "0xB8157F2C"
#define  ATSC_ADDR_2FCB_reg                                                      0xB8157F2C
#define  ATSC_ADDR_2FCB_inst_addr                                                "0x036D"
#define  set_ATSC_ADDR_2FCB_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FCB_reg)=data)
#define  get_ATSC_ADDR_2FCB_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FCB_reg))
#define  ATSC_ADDR_2FCB_ffe_gc_tr_coeff_en_71_shift                              (7)
#define  ATSC_ADDR_2FCB_ffe_gc_tr_coeff_en_70_shift                              (6)
#define  ATSC_ADDR_2FCB_ffe_gc_tr_coeff_en_69_shift                              (5)
#define  ATSC_ADDR_2FCB_ffe_gc_tr_coeff_en_68_shift                              (4)
#define  ATSC_ADDR_2FCB_ffe_gc_tr_coeff_en_67_shift                              (3)
#define  ATSC_ADDR_2FCB_ffe_gc_tr_coeff_en_66_shift                              (2)
#define  ATSC_ADDR_2FCB_ffe_gc_tr_coeff_en_65_shift                              (1)
#define  ATSC_ADDR_2FCB_ffe_gc_tr_coeff_en_64_shift                              (0)
#define  ATSC_ADDR_2FCB_ffe_gc_tr_coeff_en_71_mask                               (0x00000080)
#define  ATSC_ADDR_2FCB_ffe_gc_tr_coeff_en_70_mask                               (0x00000040)
#define  ATSC_ADDR_2FCB_ffe_gc_tr_coeff_en_69_mask                               (0x00000020)
#define  ATSC_ADDR_2FCB_ffe_gc_tr_coeff_en_68_mask                               (0x00000010)
#define  ATSC_ADDR_2FCB_ffe_gc_tr_coeff_en_67_mask                               (0x00000008)
#define  ATSC_ADDR_2FCB_ffe_gc_tr_coeff_en_66_mask                               (0x00000004)
#define  ATSC_ADDR_2FCB_ffe_gc_tr_coeff_en_65_mask                               (0x00000002)
#define  ATSC_ADDR_2FCB_ffe_gc_tr_coeff_en_64_mask                               (0x00000001)
#define  ATSC_ADDR_2FCB_ffe_gc_tr_coeff_en_71(data)                              (0x00000080&((data)<<7))
#define  ATSC_ADDR_2FCB_ffe_gc_tr_coeff_en_70(data)                              (0x00000040&((data)<<6))
#define  ATSC_ADDR_2FCB_ffe_gc_tr_coeff_en_69(data)                              (0x00000020&((data)<<5))
#define  ATSC_ADDR_2FCB_ffe_gc_tr_coeff_en_68(data)                              (0x00000010&((data)<<4))
#define  ATSC_ADDR_2FCB_ffe_gc_tr_coeff_en_67(data)                              (0x00000008&((data)<<3))
#define  ATSC_ADDR_2FCB_ffe_gc_tr_coeff_en_66(data)                              (0x00000004&((data)<<2))
#define  ATSC_ADDR_2FCB_ffe_gc_tr_coeff_en_65(data)                              (0x00000002&((data)<<1))
#define  ATSC_ADDR_2FCB_ffe_gc_tr_coeff_en_64(data)                              (0x00000001&(data))
#define  ATSC_ADDR_2FCB_get_ffe_gc_tr_coeff_en_71(data)                          ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2FCB_get_ffe_gc_tr_coeff_en_70(data)                          ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2FCB_get_ffe_gc_tr_coeff_en_69(data)                          ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2FCB_get_ffe_gc_tr_coeff_en_68(data)                          ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2FCB_get_ffe_gc_tr_coeff_en_67(data)                          ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2FCB_get_ffe_gc_tr_coeff_en_66(data)                          ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2FCB_get_ffe_gc_tr_coeff_en_65(data)                          ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2FCB_get_ffe_gc_tr_coeff_en_64(data)                          (0x00000001&(data))

#define  ATSC_ADDR_2FCC                                                         0x18157F30
#define  ATSC_ADDR_2FCC_reg_addr                                                 "0xB8157F30"
#define  ATSC_ADDR_2FCC_reg                                                      0xB8157F30
#define  ATSC_ADDR_2FCC_inst_addr                                                "0x036E"
#define  set_ATSC_ADDR_2FCC_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FCC_reg)=data)
#define  get_ATSC_ADDR_2FCC_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FCC_reg))
#define  ATSC_ADDR_2FCC_ffe_gc_tr_coeff_en_79_shift                              (7)
#define  ATSC_ADDR_2FCC_ffe_gc_tr_coeff_en_78_shift                              (6)
#define  ATSC_ADDR_2FCC_ffe_gc_tr_coeff_en_77_shift                              (5)
#define  ATSC_ADDR_2FCC_ffe_gc_tr_coeff_en_76_shift                              (4)
#define  ATSC_ADDR_2FCC_ffe_gc_tr_coeff_en_75_shift                              (3)
#define  ATSC_ADDR_2FCC_ffe_gc_tr_coeff_en_74_shift                              (2)
#define  ATSC_ADDR_2FCC_ffe_gc_tr_coeff_en_73_shift                              (1)
#define  ATSC_ADDR_2FCC_ffe_gc_tr_coeff_en_72_shift                              (0)
#define  ATSC_ADDR_2FCC_ffe_gc_tr_coeff_en_79_mask                               (0x00000080)
#define  ATSC_ADDR_2FCC_ffe_gc_tr_coeff_en_78_mask                               (0x00000040)
#define  ATSC_ADDR_2FCC_ffe_gc_tr_coeff_en_77_mask                               (0x00000020)
#define  ATSC_ADDR_2FCC_ffe_gc_tr_coeff_en_76_mask                               (0x00000010)
#define  ATSC_ADDR_2FCC_ffe_gc_tr_coeff_en_75_mask                               (0x00000008)
#define  ATSC_ADDR_2FCC_ffe_gc_tr_coeff_en_74_mask                               (0x00000004)
#define  ATSC_ADDR_2FCC_ffe_gc_tr_coeff_en_73_mask                               (0x00000002)
#define  ATSC_ADDR_2FCC_ffe_gc_tr_coeff_en_72_mask                               (0x00000001)
#define  ATSC_ADDR_2FCC_ffe_gc_tr_coeff_en_79(data)                              (0x00000080&((data)<<7))
#define  ATSC_ADDR_2FCC_ffe_gc_tr_coeff_en_78(data)                              (0x00000040&((data)<<6))
#define  ATSC_ADDR_2FCC_ffe_gc_tr_coeff_en_77(data)                              (0x00000020&((data)<<5))
#define  ATSC_ADDR_2FCC_ffe_gc_tr_coeff_en_76(data)                              (0x00000010&((data)<<4))
#define  ATSC_ADDR_2FCC_ffe_gc_tr_coeff_en_75(data)                              (0x00000008&((data)<<3))
#define  ATSC_ADDR_2FCC_ffe_gc_tr_coeff_en_74(data)                              (0x00000004&((data)<<2))
#define  ATSC_ADDR_2FCC_ffe_gc_tr_coeff_en_73(data)                              (0x00000002&((data)<<1))
#define  ATSC_ADDR_2FCC_ffe_gc_tr_coeff_en_72(data)                              (0x00000001&(data))
#define  ATSC_ADDR_2FCC_get_ffe_gc_tr_coeff_en_79(data)                          ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2FCC_get_ffe_gc_tr_coeff_en_78(data)                          ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2FCC_get_ffe_gc_tr_coeff_en_77(data)                          ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2FCC_get_ffe_gc_tr_coeff_en_76(data)                          ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2FCC_get_ffe_gc_tr_coeff_en_75(data)                          ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2FCC_get_ffe_gc_tr_coeff_en_74(data)                          ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2FCC_get_ffe_gc_tr_coeff_en_73(data)                          ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2FCC_get_ffe_gc_tr_coeff_en_72(data)                          (0x00000001&(data))

#define  ATSC_ADDR_2FCD                                                         0x18157F34
#define  ATSC_ADDR_2FCD_reg_addr                                                 "0xB8157F34"
#define  ATSC_ADDR_2FCD_reg                                                      0xB8157F34
#define  ATSC_ADDR_2FCD_inst_addr                                                "0x036F"
#define  set_ATSC_ADDR_2FCD_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FCD_reg)=data)
#define  get_ATSC_ADDR_2FCD_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FCD_reg))
#define  ATSC_ADDR_2FCD_ffe_gc_tr_coeff_en_87_shift                              (7)
#define  ATSC_ADDR_2FCD_ffe_gc_tr_coeff_en_86_shift                              (6)
#define  ATSC_ADDR_2FCD_ffe_gc_tr_coeff_en_85_shift                              (5)
#define  ATSC_ADDR_2FCD_ffe_gc_tr_coeff_en_84_shift                              (4)
#define  ATSC_ADDR_2FCD_ffe_gc_tr_coeff_en_83_shift                              (3)
#define  ATSC_ADDR_2FCD_ffe_gc_tr_coeff_en_82_shift                              (2)
#define  ATSC_ADDR_2FCD_ffe_gc_tr_coeff_en_81_shift                              (1)
#define  ATSC_ADDR_2FCD_ffe_gc_tr_coeff_en_80_shift                              (0)
#define  ATSC_ADDR_2FCD_ffe_gc_tr_coeff_en_87_mask                               (0x00000080)
#define  ATSC_ADDR_2FCD_ffe_gc_tr_coeff_en_86_mask                               (0x00000040)
#define  ATSC_ADDR_2FCD_ffe_gc_tr_coeff_en_85_mask                               (0x00000020)
#define  ATSC_ADDR_2FCD_ffe_gc_tr_coeff_en_84_mask                               (0x00000010)
#define  ATSC_ADDR_2FCD_ffe_gc_tr_coeff_en_83_mask                               (0x00000008)
#define  ATSC_ADDR_2FCD_ffe_gc_tr_coeff_en_82_mask                               (0x00000004)
#define  ATSC_ADDR_2FCD_ffe_gc_tr_coeff_en_81_mask                               (0x00000002)
#define  ATSC_ADDR_2FCD_ffe_gc_tr_coeff_en_80_mask                               (0x00000001)
#define  ATSC_ADDR_2FCD_ffe_gc_tr_coeff_en_87(data)                              (0x00000080&((data)<<7))
#define  ATSC_ADDR_2FCD_ffe_gc_tr_coeff_en_86(data)                              (0x00000040&((data)<<6))
#define  ATSC_ADDR_2FCD_ffe_gc_tr_coeff_en_85(data)                              (0x00000020&((data)<<5))
#define  ATSC_ADDR_2FCD_ffe_gc_tr_coeff_en_84(data)                              (0x00000010&((data)<<4))
#define  ATSC_ADDR_2FCD_ffe_gc_tr_coeff_en_83(data)                              (0x00000008&((data)<<3))
#define  ATSC_ADDR_2FCD_ffe_gc_tr_coeff_en_82(data)                              (0x00000004&((data)<<2))
#define  ATSC_ADDR_2FCD_ffe_gc_tr_coeff_en_81(data)                              (0x00000002&((data)<<1))
#define  ATSC_ADDR_2FCD_ffe_gc_tr_coeff_en_80(data)                              (0x00000001&(data))
#define  ATSC_ADDR_2FCD_get_ffe_gc_tr_coeff_en_87(data)                          ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2FCD_get_ffe_gc_tr_coeff_en_86(data)                          ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2FCD_get_ffe_gc_tr_coeff_en_85(data)                          ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2FCD_get_ffe_gc_tr_coeff_en_84(data)                          ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2FCD_get_ffe_gc_tr_coeff_en_83(data)                          ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2FCD_get_ffe_gc_tr_coeff_en_82(data)                          ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2FCD_get_ffe_gc_tr_coeff_en_81(data)                          ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2FCD_get_ffe_gc_tr_coeff_en_80(data)                          (0x00000001&(data))

#define  ATSC_ADDR_2FCE                                                         0x18157F38
#define  ATSC_ADDR_2FCE_reg_addr                                                 "0xB8157F38"
#define  ATSC_ADDR_2FCE_reg                                                      0xB8157F38
#define  ATSC_ADDR_2FCE_inst_addr                                                "0x0370"
#define  set_ATSC_ADDR_2FCE_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FCE_reg)=data)
#define  get_ATSC_ADDR_2FCE_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FCE_reg))
#define  ATSC_ADDR_2FCE_ffe_gc_tr_coeff_en_95_shift                              (7)
#define  ATSC_ADDR_2FCE_ffe_gc_tr_coeff_en_94_shift                              (6)
#define  ATSC_ADDR_2FCE_ffe_gc_tr_coeff_en_93_shift                              (5)
#define  ATSC_ADDR_2FCE_ffe_gc_tr_coeff_en_92_shift                              (4)
#define  ATSC_ADDR_2FCE_ffe_gc_tr_coeff_en_91_shift                              (3)
#define  ATSC_ADDR_2FCE_ffe_gc_tr_coeff_en_90_shift                              (2)
#define  ATSC_ADDR_2FCE_ffe_gc_tr_coeff_en_89_shift                              (1)
#define  ATSC_ADDR_2FCE_ffe_gc_tr_coeff_en_88_shift                              (0)
#define  ATSC_ADDR_2FCE_ffe_gc_tr_coeff_en_95_mask                               (0x00000080)
#define  ATSC_ADDR_2FCE_ffe_gc_tr_coeff_en_94_mask                               (0x00000040)
#define  ATSC_ADDR_2FCE_ffe_gc_tr_coeff_en_93_mask                               (0x00000020)
#define  ATSC_ADDR_2FCE_ffe_gc_tr_coeff_en_92_mask                               (0x00000010)
#define  ATSC_ADDR_2FCE_ffe_gc_tr_coeff_en_91_mask                               (0x00000008)
#define  ATSC_ADDR_2FCE_ffe_gc_tr_coeff_en_90_mask                               (0x00000004)
#define  ATSC_ADDR_2FCE_ffe_gc_tr_coeff_en_89_mask                               (0x00000002)
#define  ATSC_ADDR_2FCE_ffe_gc_tr_coeff_en_88_mask                               (0x00000001)
#define  ATSC_ADDR_2FCE_ffe_gc_tr_coeff_en_95(data)                              (0x00000080&((data)<<7))
#define  ATSC_ADDR_2FCE_ffe_gc_tr_coeff_en_94(data)                              (0x00000040&((data)<<6))
#define  ATSC_ADDR_2FCE_ffe_gc_tr_coeff_en_93(data)                              (0x00000020&((data)<<5))
#define  ATSC_ADDR_2FCE_ffe_gc_tr_coeff_en_92(data)                              (0x00000010&((data)<<4))
#define  ATSC_ADDR_2FCE_ffe_gc_tr_coeff_en_91(data)                              (0x00000008&((data)<<3))
#define  ATSC_ADDR_2FCE_ffe_gc_tr_coeff_en_90(data)                              (0x00000004&((data)<<2))
#define  ATSC_ADDR_2FCE_ffe_gc_tr_coeff_en_89(data)                              (0x00000002&((data)<<1))
#define  ATSC_ADDR_2FCE_ffe_gc_tr_coeff_en_88(data)                              (0x00000001&(data))
#define  ATSC_ADDR_2FCE_get_ffe_gc_tr_coeff_en_95(data)                          ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2FCE_get_ffe_gc_tr_coeff_en_94(data)                          ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2FCE_get_ffe_gc_tr_coeff_en_93(data)                          ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2FCE_get_ffe_gc_tr_coeff_en_92(data)                          ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2FCE_get_ffe_gc_tr_coeff_en_91(data)                          ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2FCE_get_ffe_gc_tr_coeff_en_90(data)                          ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2FCE_get_ffe_gc_tr_coeff_en_89(data)                          ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2FCE_get_ffe_gc_tr_coeff_en_88(data)                          (0x00000001&(data))

#define  ATSC_ADDR_2736                                                         0x18155CD8
#define  ATSC_ADDR_2736_reg_addr                                                 "0xB8155CD8"
#define  ATSC_ADDR_2736_reg                                                      0xB8155CD8
#define  ATSC_ADDR_2736_inst_addr                                                "0x0371"
#define  set_ATSC_ADDR_2736_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2736_reg)=data)
#define  get_ATSC_ADDR_2736_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2736_reg))
#define  ATSC_ADDR_2736_ffe_gc_dd_coeff_en_7_shift                               (7)
#define  ATSC_ADDR_2736_ffe_gc_dd_coeff_en_6_shift                               (6)
#define  ATSC_ADDR_2736_ffe_gc_dd_coeff_en_5_shift                               (5)
#define  ATSC_ADDR_2736_ffe_gc_dd_coeff_en_4_shift                               (4)
#define  ATSC_ADDR_2736_ffe_gc_dd_coeff_en_3_shift                               (3)
#define  ATSC_ADDR_2736_ffe_gc_dd_coeff_en_2_shift                               (2)
#define  ATSC_ADDR_2736_ffe_gc_dd_coeff_en_1_shift                               (1)
#define  ATSC_ADDR_2736_ffe_gc_dd_coeff_en_0_shift                               (0)
#define  ATSC_ADDR_2736_ffe_gc_dd_coeff_en_7_mask                                (0x00000080)
#define  ATSC_ADDR_2736_ffe_gc_dd_coeff_en_6_mask                                (0x00000040)
#define  ATSC_ADDR_2736_ffe_gc_dd_coeff_en_5_mask                                (0x00000020)
#define  ATSC_ADDR_2736_ffe_gc_dd_coeff_en_4_mask                                (0x00000010)
#define  ATSC_ADDR_2736_ffe_gc_dd_coeff_en_3_mask                                (0x00000008)
#define  ATSC_ADDR_2736_ffe_gc_dd_coeff_en_2_mask                                (0x00000004)
#define  ATSC_ADDR_2736_ffe_gc_dd_coeff_en_1_mask                                (0x00000002)
#define  ATSC_ADDR_2736_ffe_gc_dd_coeff_en_0_mask                                (0x00000001)
#define  ATSC_ADDR_2736_ffe_gc_dd_coeff_en_7(data)                               (0x00000080&((data)<<7))
#define  ATSC_ADDR_2736_ffe_gc_dd_coeff_en_6(data)                               (0x00000040&((data)<<6))
#define  ATSC_ADDR_2736_ffe_gc_dd_coeff_en_5(data)                               (0x00000020&((data)<<5))
#define  ATSC_ADDR_2736_ffe_gc_dd_coeff_en_4(data)                               (0x00000010&((data)<<4))
#define  ATSC_ADDR_2736_ffe_gc_dd_coeff_en_3(data)                               (0x00000008&((data)<<3))
#define  ATSC_ADDR_2736_ffe_gc_dd_coeff_en_2(data)                               (0x00000004&((data)<<2))
#define  ATSC_ADDR_2736_ffe_gc_dd_coeff_en_1(data)                               (0x00000002&((data)<<1))
#define  ATSC_ADDR_2736_ffe_gc_dd_coeff_en_0(data)                               (0x00000001&(data))
#define  ATSC_ADDR_2736_get_ffe_gc_dd_coeff_en_7(data)                           ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2736_get_ffe_gc_dd_coeff_en_6(data)                           ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2736_get_ffe_gc_dd_coeff_en_5(data)                           ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2736_get_ffe_gc_dd_coeff_en_4(data)                           ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2736_get_ffe_gc_dd_coeff_en_3(data)                           ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2736_get_ffe_gc_dd_coeff_en_2(data)                           ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2736_get_ffe_gc_dd_coeff_en_1(data)                           ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2736_get_ffe_gc_dd_coeff_en_0(data)                           (0x00000001&(data))

#define  ATSC_ADDR_2737                                                         0x18155CDC
#define  ATSC_ADDR_2737_reg_addr                                                 "0xB8155CDC"
#define  ATSC_ADDR_2737_reg                                                      0xB8155CDC
#define  ATSC_ADDR_2737_inst_addr                                                "0x0372"
#define  set_ATSC_ADDR_2737_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2737_reg)=data)
#define  get_ATSC_ADDR_2737_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2737_reg))
#define  ATSC_ADDR_2737_ffe_gc_dd_coeff_en_15_shift                              (7)
#define  ATSC_ADDR_2737_ffe_gc_dd_coeff_en_14_shift                              (6)
#define  ATSC_ADDR_2737_ffe_gc_dd_coeff_en_13_shift                              (5)
#define  ATSC_ADDR_2737_ffe_gc_dd_coeff_en_12_shift                              (4)
#define  ATSC_ADDR_2737_ffe_gc_dd_coeff_en_11_shift                              (3)
#define  ATSC_ADDR_2737_ffe_gc_dd_coeff_en_10_shift                              (2)
#define  ATSC_ADDR_2737_ffe_gc_dd_coeff_en_9_shift                               (1)
#define  ATSC_ADDR_2737_ffe_gc_dd_coeff_en_8_shift                               (0)
#define  ATSC_ADDR_2737_ffe_gc_dd_coeff_en_15_mask                               (0x00000080)
#define  ATSC_ADDR_2737_ffe_gc_dd_coeff_en_14_mask                               (0x00000040)
#define  ATSC_ADDR_2737_ffe_gc_dd_coeff_en_13_mask                               (0x00000020)
#define  ATSC_ADDR_2737_ffe_gc_dd_coeff_en_12_mask                               (0x00000010)
#define  ATSC_ADDR_2737_ffe_gc_dd_coeff_en_11_mask                               (0x00000008)
#define  ATSC_ADDR_2737_ffe_gc_dd_coeff_en_10_mask                               (0x00000004)
#define  ATSC_ADDR_2737_ffe_gc_dd_coeff_en_9_mask                                (0x00000002)
#define  ATSC_ADDR_2737_ffe_gc_dd_coeff_en_8_mask                                (0x00000001)
#define  ATSC_ADDR_2737_ffe_gc_dd_coeff_en_15(data)                              (0x00000080&((data)<<7))
#define  ATSC_ADDR_2737_ffe_gc_dd_coeff_en_14(data)                              (0x00000040&((data)<<6))
#define  ATSC_ADDR_2737_ffe_gc_dd_coeff_en_13(data)                              (0x00000020&((data)<<5))
#define  ATSC_ADDR_2737_ffe_gc_dd_coeff_en_12(data)                              (0x00000010&((data)<<4))
#define  ATSC_ADDR_2737_ffe_gc_dd_coeff_en_11(data)                              (0x00000008&((data)<<3))
#define  ATSC_ADDR_2737_ffe_gc_dd_coeff_en_10(data)                              (0x00000004&((data)<<2))
#define  ATSC_ADDR_2737_ffe_gc_dd_coeff_en_9(data)                               (0x00000002&((data)<<1))
#define  ATSC_ADDR_2737_ffe_gc_dd_coeff_en_8(data)                               (0x00000001&(data))
#define  ATSC_ADDR_2737_get_ffe_gc_dd_coeff_en_15(data)                          ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2737_get_ffe_gc_dd_coeff_en_14(data)                          ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2737_get_ffe_gc_dd_coeff_en_13(data)                          ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2737_get_ffe_gc_dd_coeff_en_12(data)                          ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2737_get_ffe_gc_dd_coeff_en_11(data)                          ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2737_get_ffe_gc_dd_coeff_en_10(data)                          ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2737_get_ffe_gc_dd_coeff_en_9(data)                           ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2737_get_ffe_gc_dd_coeff_en_8(data)                           (0x00000001&(data))

#define  ATSC_ADDR_2738                                                         0x18155CE0
#define  ATSC_ADDR_2738_reg_addr                                                 "0xB8155CE0"
#define  ATSC_ADDR_2738_reg                                                      0xB8155CE0
#define  ATSC_ADDR_2738_inst_addr                                                "0x0373"
#define  set_ATSC_ADDR_2738_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2738_reg)=data)
#define  get_ATSC_ADDR_2738_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2738_reg))
#define  ATSC_ADDR_2738_ffe_gc_dd_coeff_en_23_shift                              (7)
#define  ATSC_ADDR_2738_ffe_gc_dd_coeff_en_22_shift                              (6)
#define  ATSC_ADDR_2738_ffe_gc_dd_coeff_en_21_shift                              (5)
#define  ATSC_ADDR_2738_ffe_gc_dd_coeff_en_20_shift                              (4)
#define  ATSC_ADDR_2738_ffe_gc_dd_coeff_en_19_shift                              (3)
#define  ATSC_ADDR_2738_ffe_gc_dd_coeff_en_18_shift                              (2)
#define  ATSC_ADDR_2738_ffe_gc_dd_coeff_en_17_shift                              (1)
#define  ATSC_ADDR_2738_ffe_gc_dd_coeff_en_16_shift                              (0)
#define  ATSC_ADDR_2738_ffe_gc_dd_coeff_en_23_mask                               (0x00000080)
#define  ATSC_ADDR_2738_ffe_gc_dd_coeff_en_22_mask                               (0x00000040)
#define  ATSC_ADDR_2738_ffe_gc_dd_coeff_en_21_mask                               (0x00000020)
#define  ATSC_ADDR_2738_ffe_gc_dd_coeff_en_20_mask                               (0x00000010)
#define  ATSC_ADDR_2738_ffe_gc_dd_coeff_en_19_mask                               (0x00000008)
#define  ATSC_ADDR_2738_ffe_gc_dd_coeff_en_18_mask                               (0x00000004)
#define  ATSC_ADDR_2738_ffe_gc_dd_coeff_en_17_mask                               (0x00000002)
#define  ATSC_ADDR_2738_ffe_gc_dd_coeff_en_16_mask                               (0x00000001)
#define  ATSC_ADDR_2738_ffe_gc_dd_coeff_en_23(data)                              (0x00000080&((data)<<7))
#define  ATSC_ADDR_2738_ffe_gc_dd_coeff_en_22(data)                              (0x00000040&((data)<<6))
#define  ATSC_ADDR_2738_ffe_gc_dd_coeff_en_21(data)                              (0x00000020&((data)<<5))
#define  ATSC_ADDR_2738_ffe_gc_dd_coeff_en_20(data)                              (0x00000010&((data)<<4))
#define  ATSC_ADDR_2738_ffe_gc_dd_coeff_en_19(data)                              (0x00000008&((data)<<3))
#define  ATSC_ADDR_2738_ffe_gc_dd_coeff_en_18(data)                              (0x00000004&((data)<<2))
#define  ATSC_ADDR_2738_ffe_gc_dd_coeff_en_17(data)                              (0x00000002&((data)<<1))
#define  ATSC_ADDR_2738_ffe_gc_dd_coeff_en_16(data)                              (0x00000001&(data))
#define  ATSC_ADDR_2738_get_ffe_gc_dd_coeff_en_23(data)                          ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2738_get_ffe_gc_dd_coeff_en_22(data)                          ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2738_get_ffe_gc_dd_coeff_en_21(data)                          ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2738_get_ffe_gc_dd_coeff_en_20(data)                          ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2738_get_ffe_gc_dd_coeff_en_19(data)                          ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2738_get_ffe_gc_dd_coeff_en_18(data)                          ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2738_get_ffe_gc_dd_coeff_en_17(data)                          ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2738_get_ffe_gc_dd_coeff_en_16(data)                          (0x00000001&(data))

#define  ATSC_ADDR_2739                                                         0x18155CE4
#define  ATSC_ADDR_2739_reg_addr                                                 "0xB8155CE4"
#define  ATSC_ADDR_2739_reg                                                      0xB8155CE4
#define  ATSC_ADDR_2739_inst_addr                                                "0x0374"
#define  set_ATSC_ADDR_2739_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2739_reg)=data)
#define  get_ATSC_ADDR_2739_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2739_reg))
#define  ATSC_ADDR_2739_ffe_gc_dd_coeff_en_31_shift                              (7)
#define  ATSC_ADDR_2739_ffe_gc_dd_coeff_en_30_shift                              (6)
#define  ATSC_ADDR_2739_ffe_gc_dd_coeff_en_29_shift                              (5)
#define  ATSC_ADDR_2739_ffe_gc_dd_coeff_en_28_shift                              (4)
#define  ATSC_ADDR_2739_ffe_gc_dd_coeff_en_27_shift                              (3)
#define  ATSC_ADDR_2739_ffe_gc_dd_coeff_en_26_shift                              (2)
#define  ATSC_ADDR_2739_ffe_gc_dd_coeff_en_25_shift                              (1)
#define  ATSC_ADDR_2739_ffe_gc_dd_coeff_en_24_shift                              (0)
#define  ATSC_ADDR_2739_ffe_gc_dd_coeff_en_31_mask                               (0x00000080)
#define  ATSC_ADDR_2739_ffe_gc_dd_coeff_en_30_mask                               (0x00000040)
#define  ATSC_ADDR_2739_ffe_gc_dd_coeff_en_29_mask                               (0x00000020)
#define  ATSC_ADDR_2739_ffe_gc_dd_coeff_en_28_mask                               (0x00000010)
#define  ATSC_ADDR_2739_ffe_gc_dd_coeff_en_27_mask                               (0x00000008)
#define  ATSC_ADDR_2739_ffe_gc_dd_coeff_en_26_mask                               (0x00000004)
#define  ATSC_ADDR_2739_ffe_gc_dd_coeff_en_25_mask                               (0x00000002)
#define  ATSC_ADDR_2739_ffe_gc_dd_coeff_en_24_mask                               (0x00000001)
#define  ATSC_ADDR_2739_ffe_gc_dd_coeff_en_31(data)                              (0x00000080&((data)<<7))
#define  ATSC_ADDR_2739_ffe_gc_dd_coeff_en_30(data)                              (0x00000040&((data)<<6))
#define  ATSC_ADDR_2739_ffe_gc_dd_coeff_en_29(data)                              (0x00000020&((data)<<5))
#define  ATSC_ADDR_2739_ffe_gc_dd_coeff_en_28(data)                              (0x00000010&((data)<<4))
#define  ATSC_ADDR_2739_ffe_gc_dd_coeff_en_27(data)                              (0x00000008&((data)<<3))
#define  ATSC_ADDR_2739_ffe_gc_dd_coeff_en_26(data)                              (0x00000004&((data)<<2))
#define  ATSC_ADDR_2739_ffe_gc_dd_coeff_en_25(data)                              (0x00000002&((data)<<1))
#define  ATSC_ADDR_2739_ffe_gc_dd_coeff_en_24(data)                              (0x00000001&(data))
#define  ATSC_ADDR_2739_get_ffe_gc_dd_coeff_en_31(data)                          ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2739_get_ffe_gc_dd_coeff_en_30(data)                          ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2739_get_ffe_gc_dd_coeff_en_29(data)                          ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2739_get_ffe_gc_dd_coeff_en_28(data)                          ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2739_get_ffe_gc_dd_coeff_en_27(data)                          ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2739_get_ffe_gc_dd_coeff_en_26(data)                          ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2739_get_ffe_gc_dd_coeff_en_25(data)                          ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2739_get_ffe_gc_dd_coeff_en_24(data)                          (0x00000001&(data))

#define  ATSC_ADDR_273A                                                         0x18155CE8
#define  ATSC_ADDR_273A_reg_addr                                                 "0xB8155CE8"
#define  ATSC_ADDR_273A_reg                                                      0xB8155CE8
#define  ATSC_ADDR_273A_inst_addr                                                "0x0375"
#define  set_ATSC_ADDR_273A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_273A_reg)=data)
#define  get_ATSC_ADDR_273A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_273A_reg))
#define  ATSC_ADDR_273A_ffe_gc_dd_coeff_en_39_shift                              (7)
#define  ATSC_ADDR_273A_ffe_gc_dd_coeff_en_38_shift                              (6)
#define  ATSC_ADDR_273A_ffe_gc_dd_coeff_en_37_shift                              (5)
#define  ATSC_ADDR_273A_ffe_gc_dd_coeff_en_36_shift                              (4)
#define  ATSC_ADDR_273A_ffe_gc_dd_coeff_en_35_shift                              (3)
#define  ATSC_ADDR_273A_ffe_gc_dd_coeff_en_34_shift                              (2)
#define  ATSC_ADDR_273A_ffe_gc_dd_coeff_en_33_shift                              (1)
#define  ATSC_ADDR_273A_ffe_gc_dd_coeff_en_32_shift                              (0)
#define  ATSC_ADDR_273A_ffe_gc_dd_coeff_en_39_mask                               (0x00000080)
#define  ATSC_ADDR_273A_ffe_gc_dd_coeff_en_38_mask                               (0x00000040)
#define  ATSC_ADDR_273A_ffe_gc_dd_coeff_en_37_mask                               (0x00000020)
#define  ATSC_ADDR_273A_ffe_gc_dd_coeff_en_36_mask                               (0x00000010)
#define  ATSC_ADDR_273A_ffe_gc_dd_coeff_en_35_mask                               (0x00000008)
#define  ATSC_ADDR_273A_ffe_gc_dd_coeff_en_34_mask                               (0x00000004)
#define  ATSC_ADDR_273A_ffe_gc_dd_coeff_en_33_mask                               (0x00000002)
#define  ATSC_ADDR_273A_ffe_gc_dd_coeff_en_32_mask                               (0x00000001)
#define  ATSC_ADDR_273A_ffe_gc_dd_coeff_en_39(data)                              (0x00000080&((data)<<7))
#define  ATSC_ADDR_273A_ffe_gc_dd_coeff_en_38(data)                              (0x00000040&((data)<<6))
#define  ATSC_ADDR_273A_ffe_gc_dd_coeff_en_37(data)                              (0x00000020&((data)<<5))
#define  ATSC_ADDR_273A_ffe_gc_dd_coeff_en_36(data)                              (0x00000010&((data)<<4))
#define  ATSC_ADDR_273A_ffe_gc_dd_coeff_en_35(data)                              (0x00000008&((data)<<3))
#define  ATSC_ADDR_273A_ffe_gc_dd_coeff_en_34(data)                              (0x00000004&((data)<<2))
#define  ATSC_ADDR_273A_ffe_gc_dd_coeff_en_33(data)                              (0x00000002&((data)<<1))
#define  ATSC_ADDR_273A_ffe_gc_dd_coeff_en_32(data)                              (0x00000001&(data))
#define  ATSC_ADDR_273A_get_ffe_gc_dd_coeff_en_39(data)                          ((0x00000080&(data))>>7)
#define  ATSC_ADDR_273A_get_ffe_gc_dd_coeff_en_38(data)                          ((0x00000040&(data))>>6)
#define  ATSC_ADDR_273A_get_ffe_gc_dd_coeff_en_37(data)                          ((0x00000020&(data))>>5)
#define  ATSC_ADDR_273A_get_ffe_gc_dd_coeff_en_36(data)                          ((0x00000010&(data))>>4)
#define  ATSC_ADDR_273A_get_ffe_gc_dd_coeff_en_35(data)                          ((0x00000008&(data))>>3)
#define  ATSC_ADDR_273A_get_ffe_gc_dd_coeff_en_34(data)                          ((0x00000004&(data))>>2)
#define  ATSC_ADDR_273A_get_ffe_gc_dd_coeff_en_33(data)                          ((0x00000002&(data))>>1)
#define  ATSC_ADDR_273A_get_ffe_gc_dd_coeff_en_32(data)                          (0x00000001&(data))

#define  ATSC_ADDR_273B                                                         0x18155CEC
#define  ATSC_ADDR_273B_reg_addr                                                 "0xB8155CEC"
#define  ATSC_ADDR_273B_reg                                                      0xB8155CEC
#define  ATSC_ADDR_273B_inst_addr                                                "0x0376"
#define  set_ATSC_ADDR_273B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_273B_reg)=data)
#define  get_ATSC_ADDR_273B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_273B_reg))
#define  ATSC_ADDR_273B_ffe_gc_dd_coeff_en_47_shift                              (7)
#define  ATSC_ADDR_273B_ffe_gc_dd_coeff_en_46_shift                              (6)
#define  ATSC_ADDR_273B_ffe_gc_dd_coeff_en_45_shift                              (5)
#define  ATSC_ADDR_273B_ffe_gc_dd_coeff_en_44_shift                              (4)
#define  ATSC_ADDR_273B_ffe_gc_dd_coeff_en_43_shift                              (3)
#define  ATSC_ADDR_273B_ffe_gc_dd_coeff_en_42_shift                              (2)
#define  ATSC_ADDR_273B_ffe_gc_dd_coeff_en_41_shift                              (1)
#define  ATSC_ADDR_273B_ffe_gc_dd_coeff_en_40_shift                              (0)
#define  ATSC_ADDR_273B_ffe_gc_dd_coeff_en_47_mask                               (0x00000080)
#define  ATSC_ADDR_273B_ffe_gc_dd_coeff_en_46_mask                               (0x00000040)
#define  ATSC_ADDR_273B_ffe_gc_dd_coeff_en_45_mask                               (0x00000020)
#define  ATSC_ADDR_273B_ffe_gc_dd_coeff_en_44_mask                               (0x00000010)
#define  ATSC_ADDR_273B_ffe_gc_dd_coeff_en_43_mask                               (0x00000008)
#define  ATSC_ADDR_273B_ffe_gc_dd_coeff_en_42_mask                               (0x00000004)
#define  ATSC_ADDR_273B_ffe_gc_dd_coeff_en_41_mask                               (0x00000002)
#define  ATSC_ADDR_273B_ffe_gc_dd_coeff_en_40_mask                               (0x00000001)
#define  ATSC_ADDR_273B_ffe_gc_dd_coeff_en_47(data)                              (0x00000080&((data)<<7))
#define  ATSC_ADDR_273B_ffe_gc_dd_coeff_en_46(data)                              (0x00000040&((data)<<6))
#define  ATSC_ADDR_273B_ffe_gc_dd_coeff_en_45(data)                              (0x00000020&((data)<<5))
#define  ATSC_ADDR_273B_ffe_gc_dd_coeff_en_44(data)                              (0x00000010&((data)<<4))
#define  ATSC_ADDR_273B_ffe_gc_dd_coeff_en_43(data)                              (0x00000008&((data)<<3))
#define  ATSC_ADDR_273B_ffe_gc_dd_coeff_en_42(data)                              (0x00000004&((data)<<2))
#define  ATSC_ADDR_273B_ffe_gc_dd_coeff_en_41(data)                              (0x00000002&((data)<<1))
#define  ATSC_ADDR_273B_ffe_gc_dd_coeff_en_40(data)                              (0x00000001&(data))
#define  ATSC_ADDR_273B_get_ffe_gc_dd_coeff_en_47(data)                          ((0x00000080&(data))>>7)
#define  ATSC_ADDR_273B_get_ffe_gc_dd_coeff_en_46(data)                          ((0x00000040&(data))>>6)
#define  ATSC_ADDR_273B_get_ffe_gc_dd_coeff_en_45(data)                          ((0x00000020&(data))>>5)
#define  ATSC_ADDR_273B_get_ffe_gc_dd_coeff_en_44(data)                          ((0x00000010&(data))>>4)
#define  ATSC_ADDR_273B_get_ffe_gc_dd_coeff_en_43(data)                          ((0x00000008&(data))>>3)
#define  ATSC_ADDR_273B_get_ffe_gc_dd_coeff_en_42(data)                          ((0x00000004&(data))>>2)
#define  ATSC_ADDR_273B_get_ffe_gc_dd_coeff_en_41(data)                          ((0x00000002&(data))>>1)
#define  ATSC_ADDR_273B_get_ffe_gc_dd_coeff_en_40(data)                          (0x00000001&(data))

#define  ATSC_ADDR_2FC7                                                         0x18157F1C
#define  ATSC_ADDR_2FC7_reg_addr                                                 "0xB8157F1C"
#define  ATSC_ADDR_2FC7_reg                                                      0xB8157F1C
#define  ATSC_ADDR_2FC7_inst_addr                                                "0x0377"
#define  set_ATSC_ADDR_2FC7_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FC7_reg)=data)
#define  get_ATSC_ADDR_2FC7_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FC7_reg))
#define  ATSC_ADDR_2FC7_ffe_gc_dd_coeff_en_55_shift                              (7)
#define  ATSC_ADDR_2FC7_ffe_gc_dd_coeff_en_54_shift                              (6)
#define  ATSC_ADDR_2FC7_ffe_gc_dd_coeff_en_53_shift                              (5)
#define  ATSC_ADDR_2FC7_ffe_gc_dd_coeff_en_52_shift                              (4)
#define  ATSC_ADDR_2FC7_ffe_gc_dd_coeff_en_51_shift                              (3)
#define  ATSC_ADDR_2FC7_ffe_gc_dd_coeff_en_50_shift                              (2)
#define  ATSC_ADDR_2FC7_ffe_gc_dd_coeff_en_49_shift                              (1)
#define  ATSC_ADDR_2FC7_ffe_gc_dd_coeff_en_48_shift                              (0)
#define  ATSC_ADDR_2FC7_ffe_gc_dd_coeff_en_55_mask                               (0x00000080)
#define  ATSC_ADDR_2FC7_ffe_gc_dd_coeff_en_54_mask                               (0x00000040)
#define  ATSC_ADDR_2FC7_ffe_gc_dd_coeff_en_53_mask                               (0x00000020)
#define  ATSC_ADDR_2FC7_ffe_gc_dd_coeff_en_52_mask                               (0x00000010)
#define  ATSC_ADDR_2FC7_ffe_gc_dd_coeff_en_51_mask                               (0x00000008)
#define  ATSC_ADDR_2FC7_ffe_gc_dd_coeff_en_50_mask                               (0x00000004)
#define  ATSC_ADDR_2FC7_ffe_gc_dd_coeff_en_49_mask                               (0x00000002)
#define  ATSC_ADDR_2FC7_ffe_gc_dd_coeff_en_48_mask                               (0x00000001)
#define  ATSC_ADDR_2FC7_ffe_gc_dd_coeff_en_55(data)                              (0x00000080&((data)<<7))
#define  ATSC_ADDR_2FC7_ffe_gc_dd_coeff_en_54(data)                              (0x00000040&((data)<<6))
#define  ATSC_ADDR_2FC7_ffe_gc_dd_coeff_en_53(data)                              (0x00000020&((data)<<5))
#define  ATSC_ADDR_2FC7_ffe_gc_dd_coeff_en_52(data)                              (0x00000010&((data)<<4))
#define  ATSC_ADDR_2FC7_ffe_gc_dd_coeff_en_51(data)                              (0x00000008&((data)<<3))
#define  ATSC_ADDR_2FC7_ffe_gc_dd_coeff_en_50(data)                              (0x00000004&((data)<<2))
#define  ATSC_ADDR_2FC7_ffe_gc_dd_coeff_en_49(data)                              (0x00000002&((data)<<1))
#define  ATSC_ADDR_2FC7_ffe_gc_dd_coeff_en_48(data)                              (0x00000001&(data))
#define  ATSC_ADDR_2FC7_get_ffe_gc_dd_coeff_en_55(data)                          ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2FC7_get_ffe_gc_dd_coeff_en_54(data)                          ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2FC7_get_ffe_gc_dd_coeff_en_53(data)                          ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2FC7_get_ffe_gc_dd_coeff_en_52(data)                          ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2FC7_get_ffe_gc_dd_coeff_en_51(data)                          ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2FC7_get_ffe_gc_dd_coeff_en_50(data)                          ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2FC7_get_ffe_gc_dd_coeff_en_49(data)                          ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2FC7_get_ffe_gc_dd_coeff_en_48(data)                          (0x00000001&(data))

#define  ATSC_ADDR_2FC8                                                         0x18157F20
#define  ATSC_ADDR_2FC8_reg_addr                                                 "0xB8157F20"
#define  ATSC_ADDR_2FC8_reg                                                      0xB8157F20
#define  ATSC_ADDR_2FC8_inst_addr                                                "0x0378"
#define  set_ATSC_ADDR_2FC8_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FC8_reg)=data)
#define  get_ATSC_ADDR_2FC8_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FC8_reg))
#define  ATSC_ADDR_2FC8_ffe_gc_dd_coeff_en_63_shift                              (7)
#define  ATSC_ADDR_2FC8_ffe_gc_dd_coeff_en_62_shift                              (6)
#define  ATSC_ADDR_2FC8_ffe_gc_dd_coeff_en_61_shift                              (5)
#define  ATSC_ADDR_2FC8_ffe_gc_dd_coeff_en_60_shift                              (4)
#define  ATSC_ADDR_2FC8_ffe_gc_dd_coeff_en_59_shift                              (3)
#define  ATSC_ADDR_2FC8_ffe_gc_dd_coeff_en_58_shift                              (2)
#define  ATSC_ADDR_2FC8_ffe_gc_dd_coeff_en_57_shift                              (1)
#define  ATSC_ADDR_2FC8_ffe_gc_dd_coeff_en_56_shift                              (0)
#define  ATSC_ADDR_2FC8_ffe_gc_dd_coeff_en_63_mask                               (0x00000080)
#define  ATSC_ADDR_2FC8_ffe_gc_dd_coeff_en_62_mask                               (0x00000040)
#define  ATSC_ADDR_2FC8_ffe_gc_dd_coeff_en_61_mask                               (0x00000020)
#define  ATSC_ADDR_2FC8_ffe_gc_dd_coeff_en_60_mask                               (0x00000010)
#define  ATSC_ADDR_2FC8_ffe_gc_dd_coeff_en_59_mask                               (0x00000008)
#define  ATSC_ADDR_2FC8_ffe_gc_dd_coeff_en_58_mask                               (0x00000004)
#define  ATSC_ADDR_2FC8_ffe_gc_dd_coeff_en_57_mask                               (0x00000002)
#define  ATSC_ADDR_2FC8_ffe_gc_dd_coeff_en_56_mask                               (0x00000001)
#define  ATSC_ADDR_2FC8_ffe_gc_dd_coeff_en_63(data)                              (0x00000080&((data)<<7))
#define  ATSC_ADDR_2FC8_ffe_gc_dd_coeff_en_62(data)                              (0x00000040&((data)<<6))
#define  ATSC_ADDR_2FC8_ffe_gc_dd_coeff_en_61(data)                              (0x00000020&((data)<<5))
#define  ATSC_ADDR_2FC8_ffe_gc_dd_coeff_en_60(data)                              (0x00000010&((data)<<4))
#define  ATSC_ADDR_2FC8_ffe_gc_dd_coeff_en_59(data)                              (0x00000008&((data)<<3))
#define  ATSC_ADDR_2FC8_ffe_gc_dd_coeff_en_58(data)                              (0x00000004&((data)<<2))
#define  ATSC_ADDR_2FC8_ffe_gc_dd_coeff_en_57(data)                              (0x00000002&((data)<<1))
#define  ATSC_ADDR_2FC8_ffe_gc_dd_coeff_en_56(data)                              (0x00000001&(data))
#define  ATSC_ADDR_2FC8_get_ffe_gc_dd_coeff_en_63(data)                          ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2FC8_get_ffe_gc_dd_coeff_en_62(data)                          ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2FC8_get_ffe_gc_dd_coeff_en_61(data)                          ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2FC8_get_ffe_gc_dd_coeff_en_60(data)                          ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2FC8_get_ffe_gc_dd_coeff_en_59(data)                          ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2FC8_get_ffe_gc_dd_coeff_en_58(data)                          ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2FC8_get_ffe_gc_dd_coeff_en_57(data)                          ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2FC8_get_ffe_gc_dd_coeff_en_56(data)                          (0x00000001&(data))

#define  ATSC_ADDR_2FCF                                                         0x18157F3C
#define  ATSC_ADDR_2FCF_reg_addr                                                 "0xB8157F3C"
#define  ATSC_ADDR_2FCF_reg                                                      0xB8157F3C
#define  ATSC_ADDR_2FCF_inst_addr                                                "0x0379"
#define  set_ATSC_ADDR_2FCF_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FCF_reg)=data)
#define  get_ATSC_ADDR_2FCF_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FCF_reg))
#define  ATSC_ADDR_2FCF_ffe_gc_dd_coeff_en_71_shift                              (7)
#define  ATSC_ADDR_2FCF_ffe_gc_dd_coeff_en_70_shift                              (6)
#define  ATSC_ADDR_2FCF_ffe_gc_dd_coeff_en_69_shift                              (5)
#define  ATSC_ADDR_2FCF_ffe_gc_dd_coeff_en_68_shift                              (4)
#define  ATSC_ADDR_2FCF_ffe_gc_dd_coeff_en_67_shift                              (3)
#define  ATSC_ADDR_2FCF_ffe_gc_dd_coeff_en_66_shift                              (2)
#define  ATSC_ADDR_2FCF_ffe_gc_dd_coeff_en_65_shift                              (1)
#define  ATSC_ADDR_2FCF_ffe_gc_dd_coeff_en_64_shift                              (0)
#define  ATSC_ADDR_2FCF_ffe_gc_dd_coeff_en_71_mask                               (0x00000080)
#define  ATSC_ADDR_2FCF_ffe_gc_dd_coeff_en_70_mask                               (0x00000040)
#define  ATSC_ADDR_2FCF_ffe_gc_dd_coeff_en_69_mask                               (0x00000020)
#define  ATSC_ADDR_2FCF_ffe_gc_dd_coeff_en_68_mask                               (0x00000010)
#define  ATSC_ADDR_2FCF_ffe_gc_dd_coeff_en_67_mask                               (0x00000008)
#define  ATSC_ADDR_2FCF_ffe_gc_dd_coeff_en_66_mask                               (0x00000004)
#define  ATSC_ADDR_2FCF_ffe_gc_dd_coeff_en_65_mask                               (0x00000002)
#define  ATSC_ADDR_2FCF_ffe_gc_dd_coeff_en_64_mask                               (0x00000001)
#define  ATSC_ADDR_2FCF_ffe_gc_dd_coeff_en_71(data)                              (0x00000080&((data)<<7))
#define  ATSC_ADDR_2FCF_ffe_gc_dd_coeff_en_70(data)                              (0x00000040&((data)<<6))
#define  ATSC_ADDR_2FCF_ffe_gc_dd_coeff_en_69(data)                              (0x00000020&((data)<<5))
#define  ATSC_ADDR_2FCF_ffe_gc_dd_coeff_en_68(data)                              (0x00000010&((data)<<4))
#define  ATSC_ADDR_2FCF_ffe_gc_dd_coeff_en_67(data)                              (0x00000008&((data)<<3))
#define  ATSC_ADDR_2FCF_ffe_gc_dd_coeff_en_66(data)                              (0x00000004&((data)<<2))
#define  ATSC_ADDR_2FCF_ffe_gc_dd_coeff_en_65(data)                              (0x00000002&((data)<<1))
#define  ATSC_ADDR_2FCF_ffe_gc_dd_coeff_en_64(data)                              (0x00000001&(data))
#define  ATSC_ADDR_2FCF_get_ffe_gc_dd_coeff_en_71(data)                          ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2FCF_get_ffe_gc_dd_coeff_en_70(data)                          ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2FCF_get_ffe_gc_dd_coeff_en_69(data)                          ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2FCF_get_ffe_gc_dd_coeff_en_68(data)                          ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2FCF_get_ffe_gc_dd_coeff_en_67(data)                          ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2FCF_get_ffe_gc_dd_coeff_en_66(data)                          ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2FCF_get_ffe_gc_dd_coeff_en_65(data)                          ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2FCF_get_ffe_gc_dd_coeff_en_64(data)                          (0x00000001&(data))

#define  ATSC_ADDR_2FD1                                                         0x18157F44
#define  ATSC_ADDR_2FD1_reg_addr                                                 "0xB8157F44"
#define  ATSC_ADDR_2FD1_reg                                                      0xB8157F44
#define  ATSC_ADDR_2FD1_inst_addr                                                "0x037A"
#define  set_ATSC_ADDR_2FD1_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FD1_reg)=data)
#define  get_ATSC_ADDR_2FD1_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FD1_reg))
#define  ATSC_ADDR_2FD1_ffe_gc_dd_coeff_en_79_shift                              (7)
#define  ATSC_ADDR_2FD1_ffe_gc_dd_coeff_en_78_shift                              (6)
#define  ATSC_ADDR_2FD1_ffe_gc_dd_coeff_en_77_shift                              (5)
#define  ATSC_ADDR_2FD1_ffe_gc_dd_coeff_en_76_shift                              (4)
#define  ATSC_ADDR_2FD1_ffe_gc_dd_coeff_en_75_shift                              (3)
#define  ATSC_ADDR_2FD1_ffe_gc_dd_coeff_en_74_shift                              (2)
#define  ATSC_ADDR_2FD1_ffe_gc_dd_coeff_en_73_shift                              (1)
#define  ATSC_ADDR_2FD1_ffe_gc_dd_coeff_en_72_shift                              (0)
#define  ATSC_ADDR_2FD1_ffe_gc_dd_coeff_en_79_mask                               (0x00000080)
#define  ATSC_ADDR_2FD1_ffe_gc_dd_coeff_en_78_mask                               (0x00000040)
#define  ATSC_ADDR_2FD1_ffe_gc_dd_coeff_en_77_mask                               (0x00000020)
#define  ATSC_ADDR_2FD1_ffe_gc_dd_coeff_en_76_mask                               (0x00000010)
#define  ATSC_ADDR_2FD1_ffe_gc_dd_coeff_en_75_mask                               (0x00000008)
#define  ATSC_ADDR_2FD1_ffe_gc_dd_coeff_en_74_mask                               (0x00000004)
#define  ATSC_ADDR_2FD1_ffe_gc_dd_coeff_en_73_mask                               (0x00000002)
#define  ATSC_ADDR_2FD1_ffe_gc_dd_coeff_en_72_mask                               (0x00000001)
#define  ATSC_ADDR_2FD1_ffe_gc_dd_coeff_en_79(data)                              (0x00000080&((data)<<7))
#define  ATSC_ADDR_2FD1_ffe_gc_dd_coeff_en_78(data)                              (0x00000040&((data)<<6))
#define  ATSC_ADDR_2FD1_ffe_gc_dd_coeff_en_77(data)                              (0x00000020&((data)<<5))
#define  ATSC_ADDR_2FD1_ffe_gc_dd_coeff_en_76(data)                              (0x00000010&((data)<<4))
#define  ATSC_ADDR_2FD1_ffe_gc_dd_coeff_en_75(data)                              (0x00000008&((data)<<3))
#define  ATSC_ADDR_2FD1_ffe_gc_dd_coeff_en_74(data)                              (0x00000004&((data)<<2))
#define  ATSC_ADDR_2FD1_ffe_gc_dd_coeff_en_73(data)                              (0x00000002&((data)<<1))
#define  ATSC_ADDR_2FD1_ffe_gc_dd_coeff_en_72(data)                              (0x00000001&(data))
#define  ATSC_ADDR_2FD1_get_ffe_gc_dd_coeff_en_79(data)                          ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2FD1_get_ffe_gc_dd_coeff_en_78(data)                          ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2FD1_get_ffe_gc_dd_coeff_en_77(data)                          ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2FD1_get_ffe_gc_dd_coeff_en_76(data)                          ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2FD1_get_ffe_gc_dd_coeff_en_75(data)                          ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2FD1_get_ffe_gc_dd_coeff_en_74(data)                          ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2FD1_get_ffe_gc_dd_coeff_en_73(data)                          ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2FD1_get_ffe_gc_dd_coeff_en_72(data)                          (0x00000001&(data))

#define  ATSC_ADDR_2FD2                                                         0x18157F48
#define  ATSC_ADDR_2FD2_reg_addr                                                 "0xB8157F48"
#define  ATSC_ADDR_2FD2_reg                                                      0xB8157F48
#define  ATSC_ADDR_2FD2_inst_addr                                                "0x037B"
#define  set_ATSC_ADDR_2FD2_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FD2_reg)=data)
#define  get_ATSC_ADDR_2FD2_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FD2_reg))
#define  ATSC_ADDR_2FD2_ffe_gc_dd_coeff_en_87_shift                              (7)
#define  ATSC_ADDR_2FD2_ffe_gc_dd_coeff_en_86_shift                              (6)
#define  ATSC_ADDR_2FD2_ffe_gc_dd_coeff_en_85_shift                              (5)
#define  ATSC_ADDR_2FD2_ffe_gc_dd_coeff_en_84_shift                              (4)
#define  ATSC_ADDR_2FD2_ffe_gc_dd_coeff_en_83_shift                              (3)
#define  ATSC_ADDR_2FD2_ffe_gc_dd_coeff_en_82_shift                              (2)
#define  ATSC_ADDR_2FD2_ffe_gc_dd_coeff_en_81_shift                              (1)
#define  ATSC_ADDR_2FD2_ffe_gc_dd_coeff_en_80_shift                              (0)
#define  ATSC_ADDR_2FD2_ffe_gc_dd_coeff_en_87_mask                               (0x00000080)
#define  ATSC_ADDR_2FD2_ffe_gc_dd_coeff_en_86_mask                               (0x00000040)
#define  ATSC_ADDR_2FD2_ffe_gc_dd_coeff_en_85_mask                               (0x00000020)
#define  ATSC_ADDR_2FD2_ffe_gc_dd_coeff_en_84_mask                               (0x00000010)
#define  ATSC_ADDR_2FD2_ffe_gc_dd_coeff_en_83_mask                               (0x00000008)
#define  ATSC_ADDR_2FD2_ffe_gc_dd_coeff_en_82_mask                               (0x00000004)
#define  ATSC_ADDR_2FD2_ffe_gc_dd_coeff_en_81_mask                               (0x00000002)
#define  ATSC_ADDR_2FD2_ffe_gc_dd_coeff_en_80_mask                               (0x00000001)
#define  ATSC_ADDR_2FD2_ffe_gc_dd_coeff_en_87(data)                              (0x00000080&((data)<<7))
#define  ATSC_ADDR_2FD2_ffe_gc_dd_coeff_en_86(data)                              (0x00000040&((data)<<6))
#define  ATSC_ADDR_2FD2_ffe_gc_dd_coeff_en_85(data)                              (0x00000020&((data)<<5))
#define  ATSC_ADDR_2FD2_ffe_gc_dd_coeff_en_84(data)                              (0x00000010&((data)<<4))
#define  ATSC_ADDR_2FD2_ffe_gc_dd_coeff_en_83(data)                              (0x00000008&((data)<<3))
#define  ATSC_ADDR_2FD2_ffe_gc_dd_coeff_en_82(data)                              (0x00000004&((data)<<2))
#define  ATSC_ADDR_2FD2_ffe_gc_dd_coeff_en_81(data)                              (0x00000002&((data)<<1))
#define  ATSC_ADDR_2FD2_ffe_gc_dd_coeff_en_80(data)                              (0x00000001&(data))
#define  ATSC_ADDR_2FD2_get_ffe_gc_dd_coeff_en_87(data)                          ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2FD2_get_ffe_gc_dd_coeff_en_86(data)                          ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2FD2_get_ffe_gc_dd_coeff_en_85(data)                          ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2FD2_get_ffe_gc_dd_coeff_en_84(data)                          ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2FD2_get_ffe_gc_dd_coeff_en_83(data)                          ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2FD2_get_ffe_gc_dd_coeff_en_82(data)                          ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2FD2_get_ffe_gc_dd_coeff_en_81(data)                          ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2FD2_get_ffe_gc_dd_coeff_en_80(data)                          (0x00000001&(data))

#define  ATSC_ADDR_2FD3                                                         0x18157F4C
#define  ATSC_ADDR_2FD3_reg_addr                                                 "0xB8157F4C"
#define  ATSC_ADDR_2FD3_reg                                                      0xB8157F4C
#define  ATSC_ADDR_2FD3_inst_addr                                                "0x037C"
#define  set_ATSC_ADDR_2FD3_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FD3_reg)=data)
#define  get_ATSC_ADDR_2FD3_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FD3_reg))
#define  ATSC_ADDR_2FD3_ffe_gc_dd_coeff_en_95_shift                              (7)
#define  ATSC_ADDR_2FD3_ffe_gc_dd_coeff_en_94_shift                              (6)
#define  ATSC_ADDR_2FD3_ffe_gc_dd_coeff_en_93_shift                              (5)
#define  ATSC_ADDR_2FD3_ffe_gc_dd_coeff_en_92_shift                              (4)
#define  ATSC_ADDR_2FD3_ffe_gc_dd_coeff_en_91_shift                              (3)
#define  ATSC_ADDR_2FD3_ffe_gc_dd_coeff_en_90_shift                              (2)
#define  ATSC_ADDR_2FD3_ffe_gc_dd_coeff_en_89_shift                              (1)
#define  ATSC_ADDR_2FD3_ffe_gc_dd_coeff_en_88_shift                              (0)
#define  ATSC_ADDR_2FD3_ffe_gc_dd_coeff_en_95_mask                               (0x00000080)
#define  ATSC_ADDR_2FD3_ffe_gc_dd_coeff_en_94_mask                               (0x00000040)
#define  ATSC_ADDR_2FD3_ffe_gc_dd_coeff_en_93_mask                               (0x00000020)
#define  ATSC_ADDR_2FD3_ffe_gc_dd_coeff_en_92_mask                               (0x00000010)
#define  ATSC_ADDR_2FD3_ffe_gc_dd_coeff_en_91_mask                               (0x00000008)
#define  ATSC_ADDR_2FD3_ffe_gc_dd_coeff_en_90_mask                               (0x00000004)
#define  ATSC_ADDR_2FD3_ffe_gc_dd_coeff_en_89_mask                               (0x00000002)
#define  ATSC_ADDR_2FD3_ffe_gc_dd_coeff_en_88_mask                               (0x00000001)
#define  ATSC_ADDR_2FD3_ffe_gc_dd_coeff_en_95(data)                              (0x00000080&((data)<<7))
#define  ATSC_ADDR_2FD3_ffe_gc_dd_coeff_en_94(data)                              (0x00000040&((data)<<6))
#define  ATSC_ADDR_2FD3_ffe_gc_dd_coeff_en_93(data)                              (0x00000020&((data)<<5))
#define  ATSC_ADDR_2FD3_ffe_gc_dd_coeff_en_92(data)                              (0x00000010&((data)<<4))
#define  ATSC_ADDR_2FD3_ffe_gc_dd_coeff_en_91(data)                              (0x00000008&((data)<<3))
#define  ATSC_ADDR_2FD3_ffe_gc_dd_coeff_en_90(data)                              (0x00000004&((data)<<2))
#define  ATSC_ADDR_2FD3_ffe_gc_dd_coeff_en_89(data)                              (0x00000002&((data)<<1))
#define  ATSC_ADDR_2FD3_ffe_gc_dd_coeff_en_88(data)                              (0x00000001&(data))
#define  ATSC_ADDR_2FD3_get_ffe_gc_dd_coeff_en_95(data)                          ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2FD3_get_ffe_gc_dd_coeff_en_94(data)                          ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2FD3_get_ffe_gc_dd_coeff_en_93(data)                          ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2FD3_get_ffe_gc_dd_coeff_en_92(data)                          ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2FD3_get_ffe_gc_dd_coeff_en_91(data)                          ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2FD3_get_ffe_gc_dd_coeff_en_90(data)                          ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2FD3_get_ffe_gc_dd_coeff_en_89(data)                          ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2FD3_get_ffe_gc_dd_coeff_en_88(data)                          (0x00000001&(data))

#define  ATSC_ADDR_273C                                                         0x18155CF0
#define  ATSC_ADDR_273C_reg_addr                                                 "0xB8155CF0"
#define  ATSC_ADDR_273C_reg                                                      0xB8155CF0
#define  ATSC_ADDR_273C_inst_addr                                                "0x037D"
#define  set_ATSC_ADDR_273C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_273C_reg)=data)
#define  get_ATSC_ADDR_273C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_273C_reg))
#define  ATSC_ADDR_273C_ffe_muc_field_size_exp_2_0_shift                         (5)
#define  ATSC_ADDR_273C_ffe_muc_start_field_exp_shift                            (1)
#define  ATSC_ADDR_273C_ffe_muc_en_shift                                         (0)
#define  ATSC_ADDR_273C_ffe_muc_field_size_exp_2_0_mask                          (0x000000E0)
#define  ATSC_ADDR_273C_ffe_muc_start_field_exp_mask                             (0x0000001E)
#define  ATSC_ADDR_273C_ffe_muc_en_mask                                          (0x00000001)
#define  ATSC_ADDR_273C_ffe_muc_field_size_exp_2_0(data)                         (0x000000E0&((data)<<5))
#define  ATSC_ADDR_273C_ffe_muc_start_field_exp(data)                            (0x0000001E&((data)<<1))
#define  ATSC_ADDR_273C_ffe_muc_en(data)                                         (0x00000001&(data))
#define  ATSC_ADDR_273C_get_ffe_muc_field_size_exp_2_0(data)                     ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_273C_get_ffe_muc_start_field_exp(data)                        ((0x0000001E&(data))>>1)
#define  ATSC_ADDR_273C_get_ffe_muc_en(data)                                     (0x00000001&(data))

#define  ATSC_ADDR_2FC9                                                         0x18157F24
#define  ATSC_ADDR_2FC9_reg_addr                                                 "0xB8157F24"
#define  ATSC_ADDR_2FC9_reg                                                      0xB8157F24
#define  ATSC_ADDR_2FC9_inst_addr                                                "0x037E"
#define  set_ATSC_ADDR_2FC9_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FC9_reg)=data)
#define  get_ATSC_ADDR_2FC9_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FC9_reg))
#define  ATSC_ADDR_2FC9_ffe_muc_cnt_size_shift                                   (0)
#define  ATSC_ADDR_2FC9_ffe_muc_cnt_size_mask                                    (0x000000FF)
#define  ATSC_ADDR_2FC9_ffe_muc_cnt_size(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_2FC9_get_ffe_muc_cnt_size(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_273D                                                         0x18155CF4
#define  ATSC_ADDR_273D_reg_addr                                                 "0xB8155CF4"
#define  ATSC_ADDR_273D_reg                                                      0xB8155CF4
#define  ATSC_ADDR_273D_inst_addr                                                "0x037F"
#define  set_ATSC_ADDR_273D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_273D_reg)=data)
#define  get_ATSC_ADDR_273D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_273D_reg))
#define  ATSC_ADDR_273D_ffe_muc_field_cnt_seg_6_0_shift                          (1)
#define  ATSC_ADDR_273D_ffe_muc_field_size_exp_3_shift                           (0)
#define  ATSC_ADDR_273D_ffe_muc_field_cnt_seg_6_0_mask                           (0x000000FE)
#define  ATSC_ADDR_273D_ffe_muc_field_size_exp_3_mask                            (0x00000001)
#define  ATSC_ADDR_273D_ffe_muc_field_cnt_seg_6_0(data)                          (0x000000FE&((data)<<1))
#define  ATSC_ADDR_273D_ffe_muc_field_size_exp_3(data)                           (0x00000001&(data))
#define  ATSC_ADDR_273D_get_ffe_muc_field_cnt_seg_6_0(data)                      ((0x000000FE&(data))>>1)
#define  ATSC_ADDR_273D_get_ffe_muc_field_size_exp_3(data)                       (0x00000001&(data))

#define  ATSC_ADDR_273E                                                         0x18155CF8
#define  ATSC_ADDR_273E_reg_addr                                                 "0xB8155CF8"
#define  ATSC_ADDR_273E_reg                                                      0xB8155CF8
#define  ATSC_ADDR_273E_inst_addr                                                "0x0380"
#define  set_ATSC_ADDR_273E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_273E_reg)=data)
#define  get_ATSC_ADDR_273E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_273E_reg))
#define  ATSC_ADDR_273E_ffe_muc_group_sum_th_0_2_0_shift                         (5)
#define  ATSC_ADDR_273E_ffe_muc_main_protect_en_shift                            (4)
#define  ATSC_ADDR_273E_ffe_muc_mu_bn_slow_en_shift                              (3)
#define  ATSC_ADDR_273E_ffe_muc_update_type_shift                                (2)
#define  ATSC_ADDR_273E_ffe_muc_field_cnt_seg_8_7_shift                          (0)
#define  ATSC_ADDR_273E_ffe_muc_group_sum_th_0_2_0_mask                          (0x000000E0)
#define  ATSC_ADDR_273E_ffe_muc_main_protect_en_mask                             (0x00000010)
#define  ATSC_ADDR_273E_ffe_muc_mu_bn_slow_en_mask                               (0x00000008)
#define  ATSC_ADDR_273E_ffe_muc_update_type_mask                                 (0x00000004)
#define  ATSC_ADDR_273E_ffe_muc_field_cnt_seg_8_7_mask                           (0x00000003)
#define  ATSC_ADDR_273E_ffe_muc_group_sum_th_0_2_0(data)                         (0x000000E0&((data)<<5))
#define  ATSC_ADDR_273E_ffe_muc_main_protect_en(data)                            (0x00000010&((data)<<4))
#define  ATSC_ADDR_273E_ffe_muc_mu_bn_slow_en(data)                              (0x00000008&((data)<<3))
#define  ATSC_ADDR_273E_ffe_muc_update_type(data)                                (0x00000004&((data)<<2))
#define  ATSC_ADDR_273E_ffe_muc_field_cnt_seg_8_7(data)                          (0x00000003&(data))
#define  ATSC_ADDR_273E_get_ffe_muc_group_sum_th_0_2_0(data)                     ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_273E_get_ffe_muc_main_protect_en(data)                        ((0x00000010&(data))>>4)
#define  ATSC_ADDR_273E_get_ffe_muc_mu_bn_slow_en(data)                          ((0x00000008&(data))>>3)
#define  ATSC_ADDR_273E_get_ffe_muc_update_type(data)                            ((0x00000004&(data))>>2)
#define  ATSC_ADDR_273E_get_ffe_muc_field_cnt_seg_8_7(data)                      (0x00000003&(data))

#define  ATSC_ADDR_273F                                                         0x18155CFC
#define  ATSC_ADDR_273F_reg_addr                                                 "0xB8155CFC"
#define  ATSC_ADDR_273F_reg                                                      0xB8155CFC
#define  ATSC_ADDR_273F_inst_addr                                                "0x0381"
#define  set_ATSC_ADDR_273F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_273F_reg)=data)
#define  get_ATSC_ADDR_273F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_273F_reg))
#define  ATSC_ADDR_273F_ffe_muc_group_sum_th_0_10_3_shift                        (0)
#define  ATSC_ADDR_273F_ffe_muc_group_sum_th_0_10_3_mask                         (0x000000FF)
#define  ATSC_ADDR_273F_ffe_muc_group_sum_th_0_10_3(data)                        (0x000000FF&(data))
#define  ATSC_ADDR_273F_get_ffe_muc_group_sum_th_0_10_3(data)                    (0x000000FF&(data))

#define  ATSC_ADDR_2740                                                         0x18155D00
#define  ATSC_ADDR_2740_reg_addr                                                 "0xB8155D00"
#define  ATSC_ADDR_2740_reg                                                      0xB8155D00
#define  ATSC_ADDR_2740_inst_addr                                                "0x0382"
#define  set_ATSC_ADDR_2740_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2740_reg)=data)
#define  get_ATSC_ADDR_2740_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2740_reg))
#define  ATSC_ADDR_2740_ffe_muc_group_sum_th_1_6_0_shift                         (1)
#define  ATSC_ADDR_2740_ffe_muc_group_sum_th_0_11_shift                          (0)
#define  ATSC_ADDR_2740_ffe_muc_group_sum_th_1_6_0_mask                          (0x000000FE)
#define  ATSC_ADDR_2740_ffe_muc_group_sum_th_0_11_mask                           (0x00000001)
#define  ATSC_ADDR_2740_ffe_muc_group_sum_th_1_6_0(data)                         (0x000000FE&((data)<<1))
#define  ATSC_ADDR_2740_ffe_muc_group_sum_th_0_11(data)                          (0x00000001&(data))
#define  ATSC_ADDR_2740_get_ffe_muc_group_sum_th_1_6_0(data)                     ((0x000000FE&(data))>>1)
#define  ATSC_ADDR_2740_get_ffe_muc_group_sum_th_0_11(data)                      (0x00000001&(data))

#define  ATSC_ADDR_2741                                                         0x18155D04
#define  ATSC_ADDR_2741_reg_addr                                                 "0xB8155D04"
#define  ATSC_ADDR_2741_reg                                                      0xB8155D04
#define  ATSC_ADDR_2741_inst_addr                                                "0x0383"
#define  set_ATSC_ADDR_2741_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2741_reg)=data)
#define  get_ATSC_ADDR_2741_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2741_reg))
#define  ATSC_ADDR_2741_ffe_muc_group_sum_th_2_2_0_shift                         (5)
#define  ATSC_ADDR_2741_ffe_muc_group_sum_th_1_11_7_shift                        (0)
#define  ATSC_ADDR_2741_ffe_muc_group_sum_th_2_2_0_mask                          (0x000000E0)
#define  ATSC_ADDR_2741_ffe_muc_group_sum_th_1_11_7_mask                         (0x0000001F)
#define  ATSC_ADDR_2741_ffe_muc_group_sum_th_2_2_0(data)                         (0x000000E0&((data)<<5))
#define  ATSC_ADDR_2741_ffe_muc_group_sum_th_1_11_7(data)                        (0x0000001F&(data))
#define  ATSC_ADDR_2741_get_ffe_muc_group_sum_th_2_2_0(data)                     ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_2741_get_ffe_muc_group_sum_th_1_11_7(data)                    (0x0000001F&(data))

#define  ATSC_ADDR_2742                                                         0x18155D08
#define  ATSC_ADDR_2742_reg_addr                                                 "0xB8155D08"
#define  ATSC_ADDR_2742_reg                                                      0xB8155D08
#define  ATSC_ADDR_2742_inst_addr                                                "0x0384"
#define  set_ATSC_ADDR_2742_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2742_reg)=data)
#define  get_ATSC_ADDR_2742_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2742_reg))
#define  ATSC_ADDR_2742_ffe_muc_group_sum_th_2_10_3_shift                        (0)
#define  ATSC_ADDR_2742_ffe_muc_group_sum_th_2_10_3_mask                         (0x000000FF)
#define  ATSC_ADDR_2742_ffe_muc_group_sum_th_2_10_3(data)                        (0x000000FF&(data))
#define  ATSC_ADDR_2742_get_ffe_muc_group_sum_th_2_10_3(data)                    (0x000000FF&(data))

#define  ATSC_ADDR_2743                                                         0x18155D0C
#define  ATSC_ADDR_2743_reg_addr                                                 "0xB8155D0C"
#define  ATSC_ADDR_2743_reg                                                      0xB8155D0C
#define  ATSC_ADDR_2743_inst_addr                                                "0x0385"
#define  set_ATSC_ADDR_2743_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2743_reg)=data)
#define  get_ATSC_ADDR_2743_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2743_reg))
#define  ATSC_ADDR_2743_ffe_muc_group_sum_th_3_6_0_shift                         (1)
#define  ATSC_ADDR_2743_ffe_muc_group_sum_th_2_11_shift                          (0)
#define  ATSC_ADDR_2743_ffe_muc_group_sum_th_3_6_0_mask                          (0x000000FE)
#define  ATSC_ADDR_2743_ffe_muc_group_sum_th_2_11_mask                           (0x00000001)
#define  ATSC_ADDR_2743_ffe_muc_group_sum_th_3_6_0(data)                         (0x000000FE&((data)<<1))
#define  ATSC_ADDR_2743_ffe_muc_group_sum_th_2_11(data)                          (0x00000001&(data))
#define  ATSC_ADDR_2743_get_ffe_muc_group_sum_th_3_6_0(data)                     ((0x000000FE&(data))>>1)
#define  ATSC_ADDR_2743_get_ffe_muc_group_sum_th_2_11(data)                      (0x00000001&(data))

#define  ATSC_ADDR_2744                                                         0x18155D10
#define  ATSC_ADDR_2744_reg_addr                                                 "0xB8155D10"
#define  ATSC_ADDR_2744_reg                                                      0xB8155D10
#define  ATSC_ADDR_2744_inst_addr                                                "0x0386"
#define  set_ATSC_ADDR_2744_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2744_reg)=data)
#define  get_ATSC_ADDR_2744_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2744_reg))
#define  ATSC_ADDR_2744_ffe_muc_group_sum_th_4_2_0_shift                         (5)
#define  ATSC_ADDR_2744_ffe_muc_group_sum_th_3_11_7_shift                        (0)
#define  ATSC_ADDR_2744_ffe_muc_group_sum_th_4_2_0_mask                          (0x000000E0)
#define  ATSC_ADDR_2744_ffe_muc_group_sum_th_3_11_7_mask                         (0x0000001F)
#define  ATSC_ADDR_2744_ffe_muc_group_sum_th_4_2_0(data)                         (0x000000E0&((data)<<5))
#define  ATSC_ADDR_2744_ffe_muc_group_sum_th_3_11_7(data)                        (0x0000001F&(data))
#define  ATSC_ADDR_2744_get_ffe_muc_group_sum_th_4_2_0(data)                     ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_2744_get_ffe_muc_group_sum_th_3_11_7(data)                    (0x0000001F&(data))

#define  ATSC_ADDR_2745                                                         0x18155D14
#define  ATSC_ADDR_2745_reg_addr                                                 "0xB8155D14"
#define  ATSC_ADDR_2745_reg                                                      0xB8155D14
#define  ATSC_ADDR_2745_inst_addr                                                "0x0387"
#define  set_ATSC_ADDR_2745_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2745_reg)=data)
#define  get_ATSC_ADDR_2745_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2745_reg))
#define  ATSC_ADDR_2745_ffe_muc_group_sum_th_4_10_3_shift                        (0)
#define  ATSC_ADDR_2745_ffe_muc_group_sum_th_4_10_3_mask                         (0x000000FF)
#define  ATSC_ADDR_2745_ffe_muc_group_sum_th_4_10_3(data)                        (0x000000FF&(data))
#define  ATSC_ADDR_2745_get_ffe_muc_group_sum_th_4_10_3(data)                    (0x000000FF&(data))

#define  ATSC_ADDR_2746                                                         0x18155D18
#define  ATSC_ADDR_2746_reg_addr                                                 "0xB8155D18"
#define  ATSC_ADDR_2746_reg                                                      0xB8155D18
#define  ATSC_ADDR_2746_inst_addr                                                "0x0388"
#define  set_ATSC_ADDR_2746_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2746_reg)=data)
#define  get_ATSC_ADDR_2746_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2746_reg))
#define  ATSC_ADDR_2746_ffe_muc_mu_1_1_0_shift                                   (6)
#define  ATSC_ADDR_2746_ffe_muc_mu_0_shift                                       (1)
#define  ATSC_ADDR_2746_ffe_muc_group_sum_th_4_11_shift                          (0)
#define  ATSC_ADDR_2746_ffe_muc_mu_1_1_0_mask                                    (0x000000C0)
#define  ATSC_ADDR_2746_ffe_muc_mu_0_mask                                        (0x0000003E)
#define  ATSC_ADDR_2746_ffe_muc_group_sum_th_4_11_mask                           (0x00000001)
#define  ATSC_ADDR_2746_ffe_muc_mu_1_1_0(data)                                   (0x000000C0&((data)<<6))
#define  ATSC_ADDR_2746_ffe_muc_mu_0(data)                                       (0x0000003E&((data)<<1))
#define  ATSC_ADDR_2746_ffe_muc_group_sum_th_4_11(data)                          (0x00000001&(data))
#define  ATSC_ADDR_2746_get_ffe_muc_mu_1_1_0(data)                               ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_2746_get_ffe_muc_mu_0(data)                                   ((0x0000003E&(data))>>1)
#define  ATSC_ADDR_2746_get_ffe_muc_group_sum_th_4_11(data)                      (0x00000001&(data))

#define  ATSC_ADDR_2747                                                         0x18155D1C
#define  ATSC_ADDR_2747_reg_addr                                                 "0xB8155D1C"
#define  ATSC_ADDR_2747_reg                                                      0xB8155D1C
#define  ATSC_ADDR_2747_inst_addr                                                "0x0389"
#define  set_ATSC_ADDR_2747_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2747_reg)=data)
#define  get_ATSC_ADDR_2747_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2747_reg))
#define  ATSC_ADDR_2747_ffe_muc_mu_2_shift                                       (3)
#define  ATSC_ADDR_2747_ffe_muc_mu_1_4_2_shift                                   (0)
#define  ATSC_ADDR_2747_ffe_muc_mu_2_mask                                        (0x000000F8)
#define  ATSC_ADDR_2747_ffe_muc_mu_1_4_2_mask                                    (0x00000007)
#define  ATSC_ADDR_2747_ffe_muc_mu_2(data)                                       (0x000000F8&((data)<<3))
#define  ATSC_ADDR_2747_ffe_muc_mu_1_4_2(data)                                   (0x00000007&(data))
#define  ATSC_ADDR_2747_get_ffe_muc_mu_2(data)                                   ((0x000000F8&(data))>>3)
#define  ATSC_ADDR_2747_get_ffe_muc_mu_1_4_2(data)                               (0x00000007&(data))

#define  ATSC_ADDR_2748                                                         0x18155D20
#define  ATSC_ADDR_2748_reg_addr                                                 "0xB8155D20"
#define  ATSC_ADDR_2748_reg                                                      0xB8155D20
#define  ATSC_ADDR_2748_inst_addr                                                "0x038A"
#define  set_ATSC_ADDR_2748_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2748_reg)=data)
#define  get_ATSC_ADDR_2748_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2748_reg))
#define  ATSC_ADDR_2748_ffe_muc_mu_4_2_0_shift                                   (5)
#define  ATSC_ADDR_2748_ffe_muc_mu_3_shift                                       (0)
#define  ATSC_ADDR_2748_ffe_muc_mu_4_2_0_mask                                    (0x000000E0)
#define  ATSC_ADDR_2748_ffe_muc_mu_3_mask                                        (0x0000001F)
#define  ATSC_ADDR_2748_ffe_muc_mu_4_2_0(data)                                   (0x000000E0&((data)<<5))
#define  ATSC_ADDR_2748_ffe_muc_mu_3(data)                                       (0x0000001F&(data))
#define  ATSC_ADDR_2748_get_ffe_muc_mu_4_2_0(data)                               ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_2748_get_ffe_muc_mu_3(data)                                   (0x0000001F&(data))

#define  ATSC_ADDR_2749                                                         0x18155D24
#define  ATSC_ADDR_2749_reg_addr                                                 "0xB8155D24"
#define  ATSC_ADDR_2749_reg                                                      0xB8155D24
#define  ATSC_ADDR_2749_inst_addr                                                "0x038B"
#define  set_ATSC_ADDR_2749_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2749_reg)=data)
#define  get_ATSC_ADDR_2749_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2749_reg))
#define  ATSC_ADDR_2749_ffe_muc_mu_main_0_0_shift                                (7)
#define  ATSC_ADDR_2749_ffe_muc_mu_5_shift                                       (2)
#define  ATSC_ADDR_2749_ffe_muc_mu_4_4_3_shift                                   (0)
#define  ATSC_ADDR_2749_ffe_muc_mu_main_0_0_mask                                 (0x00000080)
#define  ATSC_ADDR_2749_ffe_muc_mu_5_mask                                        (0x0000007C)
#define  ATSC_ADDR_2749_ffe_muc_mu_4_4_3_mask                                    (0x00000003)
#define  ATSC_ADDR_2749_ffe_muc_mu_main_0_0(data)                                (0x00000080&((data)<<7))
#define  ATSC_ADDR_2749_ffe_muc_mu_5(data)                                       (0x0000007C&((data)<<2))
#define  ATSC_ADDR_2749_ffe_muc_mu_4_4_3(data)                                   (0x00000003&(data))
#define  ATSC_ADDR_2749_get_ffe_muc_mu_main_0_0(data)                            ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2749_get_ffe_muc_mu_5(data)                                   ((0x0000007C&(data))>>2)
#define  ATSC_ADDR_2749_get_ffe_muc_mu_4_4_3(data)                               (0x00000003&(data))

#define  ATSC_ADDR_274A                                                         0x18155D28
#define  ATSC_ADDR_274A_reg_addr                                                 "0xB8155D28"
#define  ATSC_ADDR_274A_reg                                                      0xB8155D28
#define  ATSC_ADDR_274A_inst_addr                                                "0x038C"
#define  set_ATSC_ADDR_274A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_274A_reg)=data)
#define  get_ATSC_ADDR_274A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_274A_reg))
#define  ATSC_ADDR_274A_ffe_muc_mu_main_1_3_0_shift                              (4)
#define  ATSC_ADDR_274A_ffe_muc_mu_main_0_4_1_shift                              (0)
#define  ATSC_ADDR_274A_ffe_muc_mu_main_1_3_0_mask                               (0x000000F0)
#define  ATSC_ADDR_274A_ffe_muc_mu_main_0_4_1_mask                               (0x0000000F)
#define  ATSC_ADDR_274A_ffe_muc_mu_main_1_3_0(data)                              (0x000000F0&((data)<<4))
#define  ATSC_ADDR_274A_ffe_muc_mu_main_0_4_1(data)                              (0x0000000F&(data))
#define  ATSC_ADDR_274A_get_ffe_muc_mu_main_1_3_0(data)                          ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_274A_get_ffe_muc_mu_main_0_4_1(data)                          (0x0000000F&(data))

#define  ATSC_ADDR_274B                                                         0x18155D2C
#define  ATSC_ADDR_274B_reg_addr                                                 "0xB8155D2C"
#define  ATSC_ADDR_274B_reg                                                      0xB8155D2C
#define  ATSC_ADDR_274B_inst_addr                                                "0x038D"
#define  set_ATSC_ADDR_274B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_274B_reg)=data)
#define  get_ATSC_ADDR_274B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_274B_reg))
#define  ATSC_ADDR_274B_ffe_muc_mu_main_3_1_0_shift                              (6)
#define  ATSC_ADDR_274B_ffe_muc_mu_main_2_shift                                  (1)
#define  ATSC_ADDR_274B_ffe_muc_mu_main_1_4_shift                                (0)
#define  ATSC_ADDR_274B_ffe_muc_mu_main_3_1_0_mask                               (0x000000C0)
#define  ATSC_ADDR_274B_ffe_muc_mu_main_2_mask                                   (0x0000003E)
#define  ATSC_ADDR_274B_ffe_muc_mu_main_1_4_mask                                 (0x00000001)
#define  ATSC_ADDR_274B_ffe_muc_mu_main_3_1_0(data)                              (0x000000C0&((data)<<6))
#define  ATSC_ADDR_274B_ffe_muc_mu_main_2(data)                                  (0x0000003E&((data)<<1))
#define  ATSC_ADDR_274B_ffe_muc_mu_main_1_4(data)                                (0x00000001&(data))
#define  ATSC_ADDR_274B_get_ffe_muc_mu_main_3_1_0(data)                          ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_274B_get_ffe_muc_mu_main_2(data)                              ((0x0000003E&(data))>>1)
#define  ATSC_ADDR_274B_get_ffe_muc_mu_main_1_4(data)                            (0x00000001&(data))

#define  ATSC_ADDR_274C                                                         0x18155D30
#define  ATSC_ADDR_274C_reg_addr                                                 "0xB8155D30"
#define  ATSC_ADDR_274C_reg                                                      0xB8155D30
#define  ATSC_ADDR_274C_inst_addr                                                "0x038E"
#define  set_ATSC_ADDR_274C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_274C_reg)=data)
#define  get_ATSC_ADDR_274C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_274C_reg))
#define  ATSC_ADDR_274C_ffe_muc_mu_main_4_shift                                  (3)
#define  ATSC_ADDR_274C_ffe_muc_mu_main_3_4_2_shift                              (0)
#define  ATSC_ADDR_274C_ffe_muc_mu_main_4_mask                                   (0x000000F8)
#define  ATSC_ADDR_274C_ffe_muc_mu_main_3_4_2_mask                               (0x00000007)
#define  ATSC_ADDR_274C_ffe_muc_mu_main_4(data)                                  (0x000000F8&((data)<<3))
#define  ATSC_ADDR_274C_ffe_muc_mu_main_3_4_2(data)                              (0x00000007&(data))
#define  ATSC_ADDR_274C_get_ffe_muc_mu_main_4(data)                              ((0x000000F8&(data))>>3)
#define  ATSC_ADDR_274C_get_ffe_muc_mu_main_3_4_2(data)                          (0x00000007&(data))

#define  ATSC_ADDR_274D                                                         0x18155D34
#define  ATSC_ADDR_274D_reg_addr                                                 "0xB8155D34"
#define  ATSC_ADDR_274D_reg                                                      0xB8155D34
#define  ATSC_ADDR_274D_inst_addr                                                "0x038F"
#define  set_ATSC_ADDR_274D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_274D_reg)=data)
#define  get_ATSC_ADDR_274D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_274D_reg))
#define  ATSC_ADDR_274D_ffe_muc_mu_bn_slow_0_2_0_shift                           (5)
#define  ATSC_ADDR_274D_ffe_muc_mu_main_5_shift                                  (0)
#define  ATSC_ADDR_274D_ffe_muc_mu_bn_slow_0_2_0_mask                            (0x000000E0)
#define  ATSC_ADDR_274D_ffe_muc_mu_main_5_mask                                   (0x0000001F)
#define  ATSC_ADDR_274D_ffe_muc_mu_bn_slow_0_2_0(data)                           (0x000000E0&((data)<<5))
#define  ATSC_ADDR_274D_ffe_muc_mu_main_5(data)                                  (0x0000001F&(data))
#define  ATSC_ADDR_274D_get_ffe_muc_mu_bn_slow_0_2_0(data)                       ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_274D_get_ffe_muc_mu_main_5(data)                              (0x0000001F&(data))

#define  ATSC_ADDR_274E                                                         0x18155D38
#define  ATSC_ADDR_274E_reg_addr                                                 "0xB8155D38"
#define  ATSC_ADDR_274E_reg                                                      0xB8155D38
#define  ATSC_ADDR_274E_inst_addr                                                "0x0390"
#define  set_ATSC_ADDR_274E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_274E_reg)=data)
#define  get_ATSC_ADDR_274E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_274E_reg))
#define  ATSC_ADDR_274E_ffe_muc_mu_bn_slow_2_0_shift                             (7)
#define  ATSC_ADDR_274E_ffe_muc_mu_bn_slow_1_shift                               (2)
#define  ATSC_ADDR_274E_ffe_muc_mu_bn_slow_0_4_3_shift                           (0)
#define  ATSC_ADDR_274E_ffe_muc_mu_bn_slow_2_0_mask                              (0x00000080)
#define  ATSC_ADDR_274E_ffe_muc_mu_bn_slow_1_mask                                (0x0000007C)
#define  ATSC_ADDR_274E_ffe_muc_mu_bn_slow_0_4_3_mask                            (0x00000003)
#define  ATSC_ADDR_274E_ffe_muc_mu_bn_slow_2_0(data)                             (0x00000080&((data)<<7))
#define  ATSC_ADDR_274E_ffe_muc_mu_bn_slow_1(data)                               (0x0000007C&((data)<<2))
#define  ATSC_ADDR_274E_ffe_muc_mu_bn_slow_0_4_3(data)                           (0x00000003&(data))
#define  ATSC_ADDR_274E_get_ffe_muc_mu_bn_slow_2_0(data)                         ((0x00000080&(data))>>7)
#define  ATSC_ADDR_274E_get_ffe_muc_mu_bn_slow_1(data)                           ((0x0000007C&(data))>>2)
#define  ATSC_ADDR_274E_get_ffe_muc_mu_bn_slow_0_4_3(data)                       (0x00000003&(data))

#define  ATSC_ADDR_274F                                                         0x18155D3C
#define  ATSC_ADDR_274F_reg_addr                                                 "0xB8155D3C"
#define  ATSC_ADDR_274F_reg                                                      0xB8155D3C
#define  ATSC_ADDR_274F_inst_addr                                                "0x0391"
#define  set_ATSC_ADDR_274F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_274F_reg)=data)
#define  get_ATSC_ADDR_274F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_274F_reg))
#define  ATSC_ADDR_274F_ffe_muc_mu_bn_slow_3_3_0_shift                           (4)
#define  ATSC_ADDR_274F_ffe_muc_mu_bn_slow_2_4_1_shift                           (0)
#define  ATSC_ADDR_274F_ffe_muc_mu_bn_slow_3_3_0_mask                            (0x000000F0)
#define  ATSC_ADDR_274F_ffe_muc_mu_bn_slow_2_4_1_mask                            (0x0000000F)
#define  ATSC_ADDR_274F_ffe_muc_mu_bn_slow_3_3_0(data)                           (0x000000F0&((data)<<4))
#define  ATSC_ADDR_274F_ffe_muc_mu_bn_slow_2_4_1(data)                           (0x0000000F&(data))
#define  ATSC_ADDR_274F_get_ffe_muc_mu_bn_slow_3_3_0(data)                       ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_274F_get_ffe_muc_mu_bn_slow_2_4_1(data)                       (0x0000000F&(data))

#define  ATSC_ADDR_2750                                                         0x18155D40
#define  ATSC_ADDR_2750_reg_addr                                                 "0xB8155D40"
#define  ATSC_ADDR_2750_reg                                                      0xB8155D40
#define  ATSC_ADDR_2750_inst_addr                                                "0x0392"
#define  set_ATSC_ADDR_2750_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2750_reg)=data)
#define  get_ATSC_ADDR_2750_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2750_reg))
#define  ATSC_ADDR_2750_ffe_muc_mu_bn_slow_5_1_0_shift                           (6)
#define  ATSC_ADDR_2750_ffe_muc_mu_bn_slow_4_shift                               (1)
#define  ATSC_ADDR_2750_ffe_muc_mu_bn_slow_3_4_shift                             (0)
#define  ATSC_ADDR_2750_ffe_muc_mu_bn_slow_5_1_0_mask                            (0x000000C0)
#define  ATSC_ADDR_2750_ffe_muc_mu_bn_slow_4_mask                                (0x0000003E)
#define  ATSC_ADDR_2750_ffe_muc_mu_bn_slow_3_4_mask                              (0x00000001)
#define  ATSC_ADDR_2750_ffe_muc_mu_bn_slow_5_1_0(data)                           (0x000000C0&((data)<<6))
#define  ATSC_ADDR_2750_ffe_muc_mu_bn_slow_4(data)                               (0x0000003E&((data)<<1))
#define  ATSC_ADDR_2750_ffe_muc_mu_bn_slow_3_4(data)                             (0x00000001&(data))
#define  ATSC_ADDR_2750_get_ffe_muc_mu_bn_slow_5_1_0(data)                       ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_2750_get_ffe_muc_mu_bn_slow_4(data)                           ((0x0000003E&(data))>>1)
#define  ATSC_ADDR_2750_get_ffe_muc_mu_bn_slow_3_4(data)                         (0x00000001&(data))

#define  ATSC_ADDR_2751                                                         0x18155D44
#define  ATSC_ADDR_2751_reg_addr                                                 "0xB8155D44"
#define  ATSC_ADDR_2751_reg                                                      0xB8155D44
#define  ATSC_ADDR_2751_inst_addr                                                "0x0393"
#define  set_ATSC_ADDR_2751_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2751_reg)=data)
#define  get_ATSC_ADDR_2751_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2751_reg))
#define  ATSC_ADDR_2751_eqpt_h_hil_0_3_0_shift                                   (4)
#define  ATSC_ADDR_2751_eqpt_on_shift                                            (3)
#define  ATSC_ADDR_2751_ffe_muc_mu_bn_slow_5_4_2_shift                           (0)
#define  ATSC_ADDR_2751_eqpt_h_hil_0_3_0_mask                                    (0x000000F0)
#define  ATSC_ADDR_2751_eqpt_on_mask                                             (0x00000008)
#define  ATSC_ADDR_2751_ffe_muc_mu_bn_slow_5_4_2_mask                            (0x00000007)
#define  ATSC_ADDR_2751_eqpt_h_hil_0_3_0(data)                                   (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2751_eqpt_on(data)                                            (0x00000008&((data)<<3))
#define  ATSC_ADDR_2751_ffe_muc_mu_bn_slow_5_4_2(data)                           (0x00000007&(data))
#define  ATSC_ADDR_2751_get_eqpt_h_hil_0_3_0(data)                               ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2751_get_eqpt_on(data)                                        ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2751_get_ffe_muc_mu_bn_slow_5_4_2(data)                       (0x00000007&(data))

#define  ATSC_ADDR_2752                                                         0x18155D48
#define  ATSC_ADDR_2752_reg_addr                                                 "0xB8155D48"
#define  ATSC_ADDR_2752_reg                                                      0xB8155D48
#define  ATSC_ADDR_2752_inst_addr                                                "0x0394"
#define  set_ATSC_ADDR_2752_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2752_reg)=data)
#define  get_ATSC_ADDR_2752_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2752_reg))
#define  ATSC_ADDR_2752_eqpt_h_hil_2_3_0_shift                                   (4)
#define  ATSC_ADDR_2752_eqpt_h_hil_0_7_4_shift                                   (0)
#define  ATSC_ADDR_2752_eqpt_h_hil_2_3_0_mask                                    (0x000000F0)
#define  ATSC_ADDR_2752_eqpt_h_hil_0_7_4_mask                                    (0x0000000F)
#define  ATSC_ADDR_2752_eqpt_h_hil_2_3_0(data)                                   (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2752_eqpt_h_hil_0_7_4(data)                                   (0x0000000F&(data))
#define  ATSC_ADDR_2752_get_eqpt_h_hil_2_3_0(data)                               ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2752_get_eqpt_h_hil_0_7_4(data)                               (0x0000000F&(data))

#define  ATSC_ADDR_2753                                                         0x18155D4C
#define  ATSC_ADDR_2753_reg_addr                                                 "0xB8155D4C"
#define  ATSC_ADDR_2753_reg                                                      0xB8155D4C
#define  ATSC_ADDR_2753_inst_addr                                                "0x0395"
#define  set_ATSC_ADDR_2753_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2753_reg)=data)
#define  get_ATSC_ADDR_2753_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2753_reg))
#define  ATSC_ADDR_2753_eqpt_h_hil_2_7_4_shift                                   (0)
#define  ATSC_ADDR_2753_eqpt_h_hil_2_7_4_mask                                    (0x0000000F)
#define  ATSC_ADDR_2753_eqpt_h_hil_2_7_4(data)                                   (0x0000000F&(data))
#define  ATSC_ADDR_2753_get_eqpt_h_hil_2_7_4(data)                               (0x0000000F&(data))

#define  ATSC_ADDR_2754                                                         0x18155D50
#define  ATSC_ADDR_2754_reg_addr                                                 "0xB8155D50"
#define  ATSC_ADDR_2754_reg                                                      0xB8155D50
#define  ATSC_ADDR_2754_inst_addr                                                "0x0396"
#define  set_ATSC_ADDR_2754_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2754_reg)=data)
#define  get_ATSC_ADDR_2754_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2754_reg))
#define  ATSC_ADDR_2754_fbf_ro_tap_add_1_0_shift                                 (6)
#define  ATSC_ADDR_2754_fbf_ro_group_add_shift                                   (3)
#define  ATSC_ADDR_2754_fbf_ro_bank_add_shift                                    (0)
#define  ATSC_ADDR_2754_fbf_ro_tap_add_1_0_mask                                  (0x000000C0)
#define  ATSC_ADDR_2754_fbf_ro_group_add_mask                                    (0x00000038)
#define  ATSC_ADDR_2754_fbf_ro_bank_add_mask                                     (0x00000007)
#define  ATSC_ADDR_2754_fbf_ro_tap_add_1_0(data)                                 (0x000000C0&((data)<<6))
#define  ATSC_ADDR_2754_fbf_ro_group_add(data)                                   (0x00000038&((data)<<3))
#define  ATSC_ADDR_2754_fbf_ro_bank_add(data)                                    (0x00000007&(data))
#define  ATSC_ADDR_2754_get_fbf_ro_tap_add_1_0(data)                             ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_2754_get_fbf_ro_group_add(data)                               ((0x00000038&(data))>>3)
#define  ATSC_ADDR_2754_get_fbf_ro_bank_add(data)                                (0x00000007&(data))

#define  ATSC_ADDR_2755                                                         0x18155D54
#define  ATSC_ADDR_2755_reg_addr                                                 "0xB8155D54"
#define  ATSC_ADDR_2755_reg                                                      0xB8155D54
#define  ATSC_ADDR_2755_inst_addr                                                "0x0397"
#define  set_ATSC_ADDR_2755_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2755_reg)=data)
#define  get_ATSC_ADDR_2755_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2755_reg))
#define  ATSC_ADDR_2755_fbf_ro_sum_add_4_0_shift                                 (3)
#define  ATSC_ADDR_2755_fbf_ro_tap_add_4_2_shift                                 (0)
#define  ATSC_ADDR_2755_fbf_ro_sum_add_4_0_mask                                  (0x000000F8)
#define  ATSC_ADDR_2755_fbf_ro_tap_add_4_2_mask                                  (0x00000007)
#define  ATSC_ADDR_2755_fbf_ro_sum_add_4_0(data)                                 (0x000000F8&((data)<<3))
#define  ATSC_ADDR_2755_fbf_ro_tap_add_4_2(data)                                 (0x00000007&(data))
#define  ATSC_ADDR_2755_get_fbf_ro_sum_add_4_0(data)                             ((0x000000F8&(data))>>3)
#define  ATSC_ADDR_2755_get_fbf_ro_tap_add_4_2(data)                             (0x00000007&(data))

#define  ATSC_ADDR_2756                                                         0x18155D58
#define  ATSC_ADDR_2756_reg_addr                                                 "0xB8155D58"
#define  ATSC_ADDR_2756_reg                                                      0xB8155D58
#define  ATSC_ADDR_2756_inst_addr                                                "0x0398"
#define  set_ATSC_ADDR_2756_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2756_reg)=data)
#define  get_ATSC_ADDR_2756_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2756_reg))
#define  ATSC_ADDR_2756_fbf_ro_sum_add_6_5_shift                                 (0)
#define  ATSC_ADDR_2756_fbf_ro_sum_add_6_5_mask                                  (0x00000003)
#define  ATSC_ADDR_2756_fbf_ro_sum_add_6_5(data)                                 (0x00000003&(data))
#define  ATSC_ADDR_2756_get_fbf_ro_sum_add_6_5(data)                             (0x00000003&(data))

#define  ATSC_ADDR_2757                                                         0x18155D5C
#define  ATSC_ADDR_2757_reg_addr                                                 "0xB8155D5C"
#define  ATSC_ADDR_2757_reg                                                      0xB8155D5C
#define  ATSC_ADDR_2757_inst_addr                                                "0x0399"
#define  set_ATSC_ADDR_2757_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2757_reg)=data)
#define  get_ATSC_ADDR_2757_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2757_reg))
#define  ATSC_ADDR_2757_fbf_ro_muc_add_2_0_shift                                 (5)
#define  ATSC_ADDR_2757_fbf_ro_gc_add_shift                                      (1)
#define  ATSC_ADDR_2757_fbf_ro_muc_add_2_0_mask                                  (0x000000E0)
#define  ATSC_ADDR_2757_fbf_ro_gc_add_mask                                       (0x0000001E)
#define  ATSC_ADDR_2757_fbf_ro_muc_add_2_0(data)                                 (0x000000E0&((data)<<5))
#define  ATSC_ADDR_2757_fbf_ro_gc_add(data)                                      (0x0000001E&((data)<<1))
#define  ATSC_ADDR_2757_get_fbf_ro_muc_add_2_0(data)                             ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_2757_get_fbf_ro_gc_add(data)                                  ((0x0000001E&(data))>>1)

#define  ATSC_ADDR_2758                                                         0x18155D60
#define  ATSC_ADDR_2758_reg_addr                                                 "0xB8155D60"
#define  ATSC_ADDR_2758_reg                                                      0xB8155D60
#define  ATSC_ADDR_2758_inst_addr                                                "0x039A"
#define  set_ATSC_ADDR_2758_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2758_reg)=data)
#define  get_ATSC_ADDR_2758_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2758_reg))
#define  ATSC_ADDR_2758_fbf_ro_gc_en_ind_add_4_0_shift                           (3)
#define  ATSC_ADDR_2758_fbf_ro_muc_add_5_3_shift                                 (0)
#define  ATSC_ADDR_2758_fbf_ro_gc_en_ind_add_4_0_mask                            (0x000000F8)
#define  ATSC_ADDR_2758_fbf_ro_muc_add_5_3_mask                                  (0x00000007)
#define  ATSC_ADDR_2758_fbf_ro_gc_en_ind_add_4_0(data)                           (0x000000F8&((data)<<3))
#define  ATSC_ADDR_2758_fbf_ro_muc_add_5_3(data)                                 (0x00000007&(data))
#define  ATSC_ADDR_2758_get_fbf_ro_gc_en_ind_add_4_0(data)                       ((0x000000F8&(data))>>3)
#define  ATSC_ADDR_2758_get_fbf_ro_muc_add_5_3(data)                             (0x00000007&(data))

#define  ATSC_ADDR_2759                                                         0x18155D64
#define  ATSC_ADDR_2759_reg_addr                                                 "0xB8155D64"
#define  ATSC_ADDR_2759_reg                                                      0xB8155D64
#define  ATSC_ADDR_2759_inst_addr                                                "0x039B"
#define  set_ATSC_ADDR_2759_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2759_reg)=data)
#define  get_ATSC_ADDR_2759_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2759_reg))
#define  ATSC_ADDR_2759_zd_viterbi_in_sel_shift                                  (7)
#define  ATSC_ADDR_2759_pt_in_sel_shift                                          (6)
#define  ATSC_ADDR_2759_eqout_sel_shift                                          (5)
#define  ATSC_ADDR_2759_fs_705_820_en_shift                                      (4)
#define  ATSC_ADDR_2759_fbf_ro_gc_dis_ind_add_shift                              (0)
#define  ATSC_ADDR_2759_zd_viterbi_in_sel_mask                                   (0x00000080)
#define  ATSC_ADDR_2759_pt_in_sel_mask                                           (0x00000040)
#define  ATSC_ADDR_2759_eqout_sel_mask                                           (0x00000020)
#define  ATSC_ADDR_2759_fs_705_820_en_mask                                       (0x00000010)
#define  ATSC_ADDR_2759_fbf_ro_gc_dis_ind_add_mask                               (0x0000000F)
#define  ATSC_ADDR_2759_zd_viterbi_in_sel(data)                                  (0x00000080&((data)<<7))
#define  ATSC_ADDR_2759_pt_in_sel(data)                                          (0x00000040&((data)<<6))
#define  ATSC_ADDR_2759_eqout_sel(data)                                          (0x00000020&((data)<<5))
#define  ATSC_ADDR_2759_fs_705_820_en(data)                                      (0x00000010&((data)<<4))
#define  ATSC_ADDR_2759_fbf_ro_gc_dis_ind_add(data)                              (0x0000000F&(data))
#define  ATSC_ADDR_2759_get_zd_viterbi_in_sel(data)                              ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2759_get_pt_in_sel(data)                                      ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2759_get_eqout_sel(data)                                      ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2759_get_fs_705_820_en(data)                                  ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2759_get_fbf_ro_gc_dis_ind_add(data)                          (0x0000000F&(data))

#define  ATSC_ADDR_275A                                                         0x18155D68
#define  ATSC_ADDR_275A_reg_addr                                                 "0xB8155D68"
#define  ATSC_ADDR_275A_reg                                                      0xB8155D68
#define  ATSC_ADDR_275A_inst_addr                                                "0x039C"
#define  set_ATSC_ADDR_275A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_275A_reg)=data)
#define  get_ATSC_ADDR_275A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_275A_reg))
#define  ATSC_ADDR_275A_fbf_main_end_2_0_shift                                   (5)
#define  ATSC_ADDR_275A_fbf_mu_comp_exp_shift                                    (4)
#define  ATSC_ADDR_275A_fbf_mu_comp_on_shift                                     (3)
#define  ATSC_ADDR_275A_eq_out_mse_in_sel_shift                                  (2)
#define  ATSC_ADDR_275A_eq_out_er_in_sel_shift                                   (1)
#define  ATSC_ADDR_275A_slicer_in_sel_shift                                      (0)
#define  ATSC_ADDR_275A_fbf_main_end_2_0_mask                                    (0x000000E0)
#define  ATSC_ADDR_275A_fbf_mu_comp_exp_mask                                     (0x00000010)
#define  ATSC_ADDR_275A_fbf_mu_comp_on_mask                                      (0x00000008)
#define  ATSC_ADDR_275A_eq_out_mse_in_sel_mask                                   (0x00000004)
#define  ATSC_ADDR_275A_eq_out_er_in_sel_mask                                    (0x00000002)
#define  ATSC_ADDR_275A_slicer_in_sel_mask                                       (0x00000001)
#define  ATSC_ADDR_275A_fbf_main_end_2_0(data)                                   (0x000000E0&((data)<<5))
#define  ATSC_ADDR_275A_fbf_mu_comp_exp(data)                                    (0x00000010&((data)<<4))
#define  ATSC_ADDR_275A_fbf_mu_comp_on(data)                                     (0x00000008&((data)<<3))
#define  ATSC_ADDR_275A_eq_out_mse_in_sel(data)                                  (0x00000004&((data)<<2))
#define  ATSC_ADDR_275A_eq_out_er_in_sel(data)                                   (0x00000002&((data)<<1))
#define  ATSC_ADDR_275A_slicer_in_sel(data)                                      (0x00000001&(data))
#define  ATSC_ADDR_275A_get_fbf_main_end_2_0(data)                               ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_275A_get_fbf_mu_comp_exp(data)                                ((0x00000010&(data))>>4)
#define  ATSC_ADDR_275A_get_fbf_mu_comp_on(data)                                 ((0x00000008&(data))>>3)
#define  ATSC_ADDR_275A_get_eq_out_mse_in_sel(data)                              ((0x00000004&(data))>>2)
#define  ATSC_ADDR_275A_get_eq_out_er_in_sel(data)                               ((0x00000002&(data))>>1)
#define  ATSC_ADDR_275A_get_slicer_in_sel(data)                                  (0x00000001&(data))

#define  ATSC_ADDR_275B                                                         0x18155D6C
#define  ATSC_ADDR_275B_reg_addr                                                 "0xB8155D6C"
#define  ATSC_ADDR_275B_reg                                                      0xB8155D6C
#define  ATSC_ADDR_275B_inst_addr                                                "0x039D"
#define  set_ATSC_ADDR_275B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_275B_reg)=data)
#define  get_ATSC_ADDR_275B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_275B_reg))
#define  ATSC_ADDR_275B_fbf_const_en_shift                                       (7)
#define  ATSC_ADDR_275B_fbf_coeff_ub_shift                                       (3)
#define  ATSC_ADDR_275B_fbf_coeff_ub_en_shift                                    (2)
#define  ATSC_ADDR_275B_fbf_main_end_4_3_shift                                   (0)
#define  ATSC_ADDR_275B_fbf_const_en_mask                                        (0x00000080)
#define  ATSC_ADDR_275B_fbf_coeff_ub_mask                                        (0x00000078)
#define  ATSC_ADDR_275B_fbf_coeff_ub_en_mask                                     (0x00000004)
#define  ATSC_ADDR_275B_fbf_main_end_4_3_mask                                    (0x00000003)
#define  ATSC_ADDR_275B_fbf_const_en(data)                                       (0x00000080&((data)<<7))
#define  ATSC_ADDR_275B_fbf_coeff_ub(data)                                       (0x00000078&((data)<<3))
#define  ATSC_ADDR_275B_fbf_coeff_ub_en(data)                                    (0x00000004&((data)<<2))
#define  ATSC_ADDR_275B_fbf_main_end_4_3(data)                                   (0x00000003&(data))
#define  ATSC_ADDR_275B_get_fbf_const_en(data)                                   ((0x00000080&(data))>>7)
#define  ATSC_ADDR_275B_get_fbf_coeff_ub(data)                                   ((0x00000078&(data))>>3)
#define  ATSC_ADDR_275B_get_fbf_coeff_ub_en(data)                                ((0x00000004&(data))>>2)
#define  ATSC_ADDR_275B_get_fbf_main_end_4_3(data)                               (0x00000003&(data))

#define  ATSC_ADDR_275C                                                         0x18155D70
#define  ATSC_ADDR_275C_reg_addr                                                 "0xB8155D70"
#define  ATSC_ADDR_275C_reg                                                      0xB8155D70
#define  ATSC_ADDR_275C_inst_addr                                                "0x039E"
#define  set_ATSC_ADDR_275C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_275C_reg)=data)
#define  get_ATSC_ADDR_275C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_275C_reg))
#define  ATSC_ADDR_275C_fsm_fbf_const_seg_cnt_1_0_shift                          (6)
#define  ATSC_ADDR_275C_fbf_const_on_state_shift                                 (0)
#define  ATSC_ADDR_275C_fsm_fbf_const_seg_cnt_1_0_mask                           (0x000000C0)
#define  ATSC_ADDR_275C_fbf_const_on_state_mask                                  (0x0000003F)
#define  ATSC_ADDR_275C_fsm_fbf_const_seg_cnt_1_0(data)                          (0x000000C0&((data)<<6))
#define  ATSC_ADDR_275C_fbf_const_on_state(data)                                 (0x0000003F&(data))
#define  ATSC_ADDR_275C_get_fsm_fbf_const_seg_cnt_1_0(data)                      ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_275C_get_fbf_const_on_state(data)                             (0x0000003F&(data))

#define  ATSC_ADDR_275D                                                         0x18155D74
#define  ATSC_ADDR_275D_reg_addr                                                 "0xB8155D74"
#define  ATSC_ADDR_275D_reg                                                      0xB8155D74
#define  ATSC_ADDR_275D_inst_addr                                                "0x039F"
#define  set_ATSC_ADDR_275D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_275D_reg)=data)
#define  get_ATSC_ADDR_275D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_275D_reg))
#define  ATSC_ADDR_275D_fbf_const_field_cnt_th_exp_0_shift                       (7)
#define  ATSC_ADDR_275D_fsm_fbf_const_seg_cnt_8_2_shift                          (0)
#define  ATSC_ADDR_275D_fbf_const_field_cnt_th_exp_0_mask                        (0x00000080)
#define  ATSC_ADDR_275D_fsm_fbf_const_seg_cnt_8_2_mask                           (0x0000007F)
#define  ATSC_ADDR_275D_fbf_const_field_cnt_th_exp_0(data)                       (0x00000080&((data)<<7))
#define  ATSC_ADDR_275D_fsm_fbf_const_seg_cnt_8_2(data)                          (0x0000007F&(data))
#define  ATSC_ADDR_275D_get_fbf_const_field_cnt_th_exp_0(data)                   ((0x00000080&(data))>>7)
#define  ATSC_ADDR_275D_get_fsm_fbf_const_seg_cnt_8_2(data)                      (0x0000007F&(data))

#define  ATSC_ADDR_275E                                                         0x18155D78
#define  ATSC_ADDR_275E_reg_addr                                                 "0xB8155D78"
#define  ATSC_ADDR_275E_reg                                                      0xB8155D78
#define  ATSC_ADDR_275E_inst_addr                                                "0x03A0"
#define  set_ATSC_ADDR_275E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_275E_reg)=data)
#define  get_ATSC_ADDR_275E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_275E_reg))
#define  ATSC_ADDR_275E_fbf_const_coeff_sum_th_4_0_shift                         (3)
#define  ATSC_ADDR_275E_fbf_const_field_cnt_th_exp_3_1_shift                     (0)
#define  ATSC_ADDR_275E_fbf_const_coeff_sum_th_4_0_mask                          (0x000000F8)
#define  ATSC_ADDR_275E_fbf_const_field_cnt_th_exp_3_1_mask                      (0x00000007)
#define  ATSC_ADDR_275E_fbf_const_coeff_sum_th_4_0(data)                         (0x000000F8&((data)<<3))
#define  ATSC_ADDR_275E_fbf_const_field_cnt_th_exp_3_1(data)                     (0x00000007&(data))
#define  ATSC_ADDR_275E_get_fbf_const_coeff_sum_th_4_0(data)                     ((0x000000F8&(data))>>3)
#define  ATSC_ADDR_275E_get_fbf_const_field_cnt_th_exp_3_1(data)                 (0x00000007&(data))

#define  ATSC_ADDR_275F                                                         0x18155D7C
#define  ATSC_ADDR_275F_reg_addr                                                 "0xB8155D7C"
#define  ATSC_ADDR_275F_reg                                                      0xB8155D7C
#define  ATSC_ADDR_275F_inst_addr                                                "0x03A1"
#define  set_ATSC_ADDR_275F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_275F_reg)=data)
#define  get_ATSC_ADDR_275F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_275F_reg))
#define  ATSC_ADDR_275F_fbf_update_th_2_0_shift                                  (5)
#define  ATSC_ADDR_275F_fbf_const_coeff_sum_th_9_5_shift                         (0)
#define  ATSC_ADDR_275F_fbf_update_th_2_0_mask                                   (0x000000E0)
#define  ATSC_ADDR_275F_fbf_const_coeff_sum_th_9_5_mask                          (0x0000001F)
#define  ATSC_ADDR_275F_fbf_update_th_2_0(data)                                  (0x000000E0&((data)<<5))
#define  ATSC_ADDR_275F_fbf_const_coeff_sum_th_9_5(data)                         (0x0000001F&(data))
#define  ATSC_ADDR_275F_get_fbf_update_th_2_0(data)                              ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_275F_get_fbf_const_coeff_sum_th_9_5(data)                     (0x0000001F&(data))

#define  ATSC_ADDR_2760                                                         0x18155D80
#define  ATSC_ADDR_2760_reg_addr                                                 "0xB8155D80"
#define  ATSC_ADDR_2760_reg                                                      0xB8155D80
#define  ATSC_ADDR_2760_inst_addr                                                "0x03A2"
#define  set_ATSC_ADDR_2760_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2760_reg)=data)
#define  get_ATSC_ADDR_2760_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2760_reg))
#define  ATSC_ADDR_2760_fbf_update_th_10_3_shift                                 (0)
#define  ATSC_ADDR_2760_fbf_update_th_10_3_mask                                  (0x000000FF)
#define  ATSC_ADDR_2760_fbf_update_th_10_3(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2760_get_fbf_update_th_10_3(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2761                                                         0x18155D84
#define  ATSC_ADDR_2761_reg_addr                                                 "0xB8155D84"
#define  ATSC_ADDR_2761_reg                                                      0xB8155D84
#define  ATSC_ADDR_2761_inst_addr                                                "0x03A3"
#define  set_ATSC_ADDR_2761_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2761_reg)=data)
#define  get_ATSC_ADDR_2761_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2761_reg))
#define  ATSC_ADDR_2761_fbf_const_ratio1_2_0_shift                               (5)
#define  ATSC_ADDR_2761_fbf_coeff_sum_sel_shift                                  (4)
#define  ATSC_ADDR_2761_fbf_update_th_14_11_shift                                (0)
#define  ATSC_ADDR_2761_fbf_const_ratio1_2_0_mask                                (0x000000E0)
#define  ATSC_ADDR_2761_fbf_coeff_sum_sel_mask                                   (0x00000010)
#define  ATSC_ADDR_2761_fbf_update_th_14_11_mask                                 (0x0000000F)
#define  ATSC_ADDR_2761_fbf_const_ratio1_2_0(data)                               (0x000000E0&((data)<<5))
#define  ATSC_ADDR_2761_fbf_coeff_sum_sel(data)                                  (0x00000010&((data)<<4))
#define  ATSC_ADDR_2761_fbf_update_th_14_11(data)                                (0x0000000F&(data))
#define  ATSC_ADDR_2761_get_fbf_const_ratio1_2_0(data)                           ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_2761_get_fbf_coeff_sum_sel(data)                              ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2761_get_fbf_update_th_14_11(data)                            (0x0000000F&(data))

#define  ATSC_ADDR_2762                                                         0x18155D88
#define  ATSC_ADDR_2762_reg_addr                                                 "0xB8155D88"
#define  ATSC_ADDR_2762_reg                                                      0xB8155D88
#define  ATSC_ADDR_2762_inst_addr                                                "0x03A4"
#define  set_ATSC_ADDR_2762_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2762_reg)=data)
#define  get_ATSC_ADDR_2762_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2762_reg))
#define  ATSC_ADDR_2762_fbf_const_start_update_th1_2_0_shift                     (5)
#define  ATSC_ADDR_2762_fbf_const_ratio2_shift                                   (1)
#define  ATSC_ADDR_2762_fbf_const_ratio1_3_shift                                 (0)
#define  ATSC_ADDR_2762_fbf_const_start_update_th1_2_0_mask                      (0x000000E0)
#define  ATSC_ADDR_2762_fbf_const_ratio2_mask                                    (0x0000001E)
#define  ATSC_ADDR_2762_fbf_const_ratio1_3_mask                                  (0x00000001)
#define  ATSC_ADDR_2762_fbf_const_start_update_th1_2_0(data)                     (0x000000E0&((data)<<5))
#define  ATSC_ADDR_2762_fbf_const_ratio2(data)                                   (0x0000001E&((data)<<1))
#define  ATSC_ADDR_2762_fbf_const_ratio1_3(data)                                 (0x00000001&(data))
#define  ATSC_ADDR_2762_get_fbf_const_start_update_th1_2_0(data)                 ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_2762_get_fbf_const_ratio2(data)                               ((0x0000001E&(data))>>1)
#define  ATSC_ADDR_2762_get_fbf_const_ratio1_3(data)                             (0x00000001&(data))

#define  ATSC_ADDR_2763                                                         0x18155D8C
#define  ATSC_ADDR_2763_reg_addr                                                 "0xB8155D8C"
#define  ATSC_ADDR_2763_reg                                                      0xB8155D8C
#define  ATSC_ADDR_2763_inst_addr                                                "0x03A5"
#define  set_ATSC_ADDR_2763_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2763_reg)=data)
#define  get_ATSC_ADDR_2763_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2763_reg))
#define  ATSC_ADDR_2763_fbf_const_start_update_th2_0_shift                       (7)
#define  ATSC_ADDR_2763_fbf_const_start_update_th1_9_3_shift                     (0)
#define  ATSC_ADDR_2763_fbf_const_start_update_th2_0_mask                        (0x00000080)
#define  ATSC_ADDR_2763_fbf_const_start_update_th1_9_3_mask                      (0x0000007F)
#define  ATSC_ADDR_2763_fbf_const_start_update_th2_0(data)                       (0x00000080&((data)<<7))
#define  ATSC_ADDR_2763_fbf_const_start_update_th1_9_3(data)                     (0x0000007F&(data))
#define  ATSC_ADDR_2763_get_fbf_const_start_update_th2_0(data)                   ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2763_get_fbf_const_start_update_th1_9_3(data)                 (0x0000007F&(data))

#define  ATSC_ADDR_2764                                                         0x18155D90
#define  ATSC_ADDR_2764_reg_addr                                                 "0xB8155D90"
#define  ATSC_ADDR_2764_reg                                                      0xB8155D90
#define  ATSC_ADDR_2764_inst_addr                                                "0x03A6"
#define  set_ATSC_ADDR_2764_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2764_reg)=data)
#define  get_ATSC_ADDR_2764_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2764_reg))
#define  ATSC_ADDR_2764_fbf_const_start_update_th2_8_1_shift                     (0)
#define  ATSC_ADDR_2764_fbf_const_start_update_th2_8_1_mask                      (0x000000FF)
#define  ATSC_ADDR_2764_fbf_const_start_update_th2_8_1(data)                     (0x000000FF&(data))
#define  ATSC_ADDR_2764_get_fbf_const_start_update_th2_8_1(data)                 (0x000000FF&(data))

#define  ATSC_ADDR_2765                                                         0x18155D94
#define  ATSC_ADDR_2765_reg_addr                                                 "0xB8155D94"
#define  ATSC_ADDR_2765_reg                                                      0xB8155D94
#define  ATSC_ADDR_2765_inst_addr                                                "0x03A7"
#define  set_ATSC_ADDR_2765_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2765_reg)=data)
#define  get_ATSC_ADDR_2765_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2765_reg))
#define  ATSC_ADDR_2765_fbf_const_manu_val_6_0_shift                             (1)
#define  ATSC_ADDR_2765_fbf_const_start_update_th2_9_shift                       (0)
#define  ATSC_ADDR_2765_fbf_const_manu_val_6_0_mask                              (0x000000FE)
#define  ATSC_ADDR_2765_fbf_const_start_update_th2_9_mask                        (0x00000001)
#define  ATSC_ADDR_2765_fbf_const_manu_val_6_0(data)                             (0x000000FE&((data)<<1))
#define  ATSC_ADDR_2765_fbf_const_start_update_th2_9(data)                       (0x00000001&(data))
#define  ATSC_ADDR_2765_get_fbf_const_manu_val_6_0(data)                         ((0x000000FE&(data))>>1)
#define  ATSC_ADDR_2765_get_fbf_const_start_update_th2_9(data)                   (0x00000001&(data))

#define  ATSC_ADDR_2766                                                         0x18155D98
#define  ATSC_ADDR_2766_reg_addr                                                 "0xB8155D98"
#define  ATSC_ADDR_2766_reg                                                      0xB8155D98
#define  ATSC_ADDR_2766_inst_addr                                                "0x03A8"
#define  set_ATSC_ADDR_2766_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2766_reg)=data)
#define  get_ATSC_ADDR_2766_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2766_reg))
#define  ATSC_ADDR_2766_fbf_const_exp_shift                                      (4)
#define  ATSC_ADDR_2766_fbf_const_manu_en_shift                                  (3)
#define  ATSC_ADDR_2766_fbf_const_manu_val_9_7_shift                             (0)
#define  ATSC_ADDR_2766_fbf_const_exp_mask                                       (0x000000F0)
#define  ATSC_ADDR_2766_fbf_const_manu_en_mask                                   (0x00000008)
#define  ATSC_ADDR_2766_fbf_const_manu_val_9_7_mask                              (0x00000007)
#define  ATSC_ADDR_2766_fbf_const_exp(data)                                      (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2766_fbf_const_manu_en(data)                                  (0x00000008&((data)<<3))
#define  ATSC_ADDR_2766_fbf_const_manu_val_9_7(data)                             (0x00000007&(data))
#define  ATSC_ADDR_2766_get_fbf_const_exp(data)                                  ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2766_get_fbf_const_manu_en(data)                              ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2766_get_fbf_const_manu_val_9_7(data)                         (0x00000007&(data))

#define  ATSC_ADDR_2767                                                         0x18155D9C
#define  ATSC_ADDR_2767_reg_addr                                                 "0xB8155D9C"
#define  ATSC_ADDR_2767_reg                                                      0xB8155D9C
#define  ATSC_ADDR_2767_inst_addr                                                "0x03A9"
#define  set_ATSC_ADDR_2767_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2767_reg)=data)
#define  get_ATSC_ADDR_2767_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2767_reg))
#define  ATSC_ADDR_2767_fbf_const_lamda_max_0_shift                              (7)
#define  ATSC_ADDR_2767_fbf_const_lamda_sel_shift                                (6)
#define  ATSC_ADDR_2767_fbf_const_man_shift                                      (0)
#define  ATSC_ADDR_2767_fbf_const_lamda_max_0_mask                               (0x00000080)
#define  ATSC_ADDR_2767_fbf_const_lamda_sel_mask                                 (0x00000040)
#define  ATSC_ADDR_2767_fbf_const_man_mask                                       (0x0000003F)
#define  ATSC_ADDR_2767_fbf_const_lamda_max_0(data)                              (0x00000080&((data)<<7))
#define  ATSC_ADDR_2767_fbf_const_lamda_sel(data)                                (0x00000040&((data)<<6))
#define  ATSC_ADDR_2767_fbf_const_man(data)                                      (0x0000003F&(data))
#define  ATSC_ADDR_2767_get_fbf_const_lamda_max_0(data)                          ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2767_get_fbf_const_lamda_sel(data)                            ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2767_get_fbf_const_man(data)                                  (0x0000003F&(data))

#define  ATSC_ADDR_2768                                                         0x18155DA0
#define  ATSC_ADDR_2768_reg_addr                                                 "0xB8155DA0"
#define  ATSC_ADDR_2768_reg                                                      0xB8155DA0
#define  ATSC_ADDR_2768_inst_addr                                                "0x03AA"
#define  set_ATSC_ADDR_2768_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2768_reg)=data)
#define  get_ATSC_ADDR_2768_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2768_reg))
#define  ATSC_ADDR_2768_fbf_const_lamda_max_8_1_shift                            (0)
#define  ATSC_ADDR_2768_fbf_const_lamda_max_8_1_mask                             (0x000000FF)
#define  ATSC_ADDR_2768_fbf_const_lamda_max_8_1(data)                            (0x000000FF&(data))
#define  ATSC_ADDR_2768_get_fbf_const_lamda_max_8_1(data)                        (0x000000FF&(data))

#define  ATSC_ADDR_2769                                                         0x18155DA4
#define  ATSC_ADDR_2769_reg_addr                                                 "0xB8155DA4"
#define  ATSC_ADDR_2769_reg                                                      0xB8155DA4
#define  ATSC_ADDR_2769_inst_addr                                                "0x03AB"
#define  set_ATSC_ADDR_2769_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2769_reg)=data)
#define  get_ATSC_ADDR_2769_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2769_reg))
#define  ATSC_ADDR_2769_fbf_const_mse_en_shift                                   (7)
#define  ATSC_ADDR_2769_fbf_const_lamda_max_15_9_shift                           (0)
#define  ATSC_ADDR_2769_fbf_const_mse_en_mask                                    (0x00000080)
#define  ATSC_ADDR_2769_fbf_const_lamda_max_15_9_mask                            (0x0000007F)
#define  ATSC_ADDR_2769_fbf_const_mse_en(data)                                   (0x00000080&((data)<<7))
#define  ATSC_ADDR_2769_fbf_const_lamda_max_15_9(data)                           (0x0000007F&(data))
#define  ATSC_ADDR_2769_get_fbf_const_mse_en(data)                               ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2769_get_fbf_const_lamda_max_15_9(data)                       (0x0000007F&(data))

#define  ATSC_ADDR_276A                                                         0x18155DA8
#define  ATSC_ADDR_276A_reg_addr                                                 "0xB8155DA8"
#define  ATSC_ADDR_276A_reg                                                      0xB8155DA8
#define  ATSC_ADDR_276A_inst_addr                                                "0x03AC"
#define  set_ATSC_ADDR_276A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_276A_reg)=data)
#define  get_ATSC_ADDR_276A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_276A_reg))
#define  ATSC_ADDR_276A_fbf_const_mse_lamda_th_6_0_shift                         (1)
#define  ATSC_ADDR_276A_fbf_const_mse_sel_shift                                  (0)
#define  ATSC_ADDR_276A_fbf_const_mse_lamda_th_6_0_mask                          (0x000000FE)
#define  ATSC_ADDR_276A_fbf_const_mse_sel_mask                                   (0x00000001)
#define  ATSC_ADDR_276A_fbf_const_mse_lamda_th_6_0(data)                         (0x000000FE&((data)<<1))
#define  ATSC_ADDR_276A_fbf_const_mse_sel(data)                                  (0x00000001&(data))
#define  ATSC_ADDR_276A_get_fbf_const_mse_lamda_th_6_0(data)                     ((0x000000FE&(data))>>1)
#define  ATSC_ADDR_276A_get_fbf_const_mse_sel(data)                              (0x00000001&(data))

#define  ATSC_ADDR_276B                                                         0x18155DAC
#define  ATSC_ADDR_276B_reg_addr                                                 "0xB8155DAC"
#define  ATSC_ADDR_276B_reg                                                      0xB8155DAC
#define  ATSC_ADDR_276B_inst_addr                                                "0x03AD"
#define  set_ATSC_ADDR_276B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_276B_reg)=data)
#define  get_ATSC_ADDR_276B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_276B_reg))
#define  ATSC_ADDR_276B_fbf_const_mse_lamda_0_shift                              (7)
#define  ATSC_ADDR_276B_fbf_const_mse_lamda_th_13_7_shift                        (0)
#define  ATSC_ADDR_276B_fbf_const_mse_lamda_0_mask                               (0x00000080)
#define  ATSC_ADDR_276B_fbf_const_mse_lamda_th_13_7_mask                         (0x0000007F)
#define  ATSC_ADDR_276B_fbf_const_mse_lamda_0(data)                              (0x00000080&((data)<<7))
#define  ATSC_ADDR_276B_fbf_const_mse_lamda_th_13_7(data)                        (0x0000007F&(data))
#define  ATSC_ADDR_276B_get_fbf_const_mse_lamda_0(data)                          ((0x00000080&(data))>>7)
#define  ATSC_ADDR_276B_get_fbf_const_mse_lamda_th_13_7(data)                    (0x0000007F&(data))

#define  ATSC_ADDR_276C                                                         0x18155DB0
#define  ATSC_ADDR_276C_reg_addr                                                 "0xB8155DB0"
#define  ATSC_ADDR_276C_reg                                                      0xB8155DB0
#define  ATSC_ADDR_276C_inst_addr                                                "0x03AE"
#define  set_ATSC_ADDR_276C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_276C_reg)=data)
#define  get_ATSC_ADDR_276C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_276C_reg))
#define  ATSC_ADDR_276C_fbf_const_mse_lamda_8_1_shift                            (0)
#define  ATSC_ADDR_276C_fbf_const_mse_lamda_8_1_mask                             (0x000000FF)
#define  ATSC_ADDR_276C_fbf_const_mse_lamda_8_1(data)                            (0x000000FF&(data))
#define  ATSC_ADDR_276C_get_fbf_const_mse_lamda_8_1(data)                        (0x000000FF&(data))

#define  ATSC_ADDR_276D                                                         0x18155DB4
#define  ATSC_ADDR_276D_reg_addr                                                 "0xB8155DB4"
#define  ATSC_ADDR_276D_reg                                                      0xB8155DB4
#define  ATSC_ADDR_276D_inst_addr                                                "0x03AF"
#define  set_ATSC_ADDR_276D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_276D_reg)=data)
#define  get_ATSC_ADDR_276D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_276D_reg))
#define  ATSC_ADDR_276D_fbf_muc_en_shift                                         (7)
#define  ATSC_ADDR_276D_fbf_const_mse_lamda_15_9_shift                           (0)
#define  ATSC_ADDR_276D_fbf_muc_en_mask                                          (0x00000080)
#define  ATSC_ADDR_276D_fbf_const_mse_lamda_15_9_mask                            (0x0000007F)
#define  ATSC_ADDR_276D_fbf_muc_en(data)                                         (0x00000080&((data)<<7))
#define  ATSC_ADDR_276D_fbf_const_mse_lamda_15_9(data)                           (0x0000007F&(data))
#define  ATSC_ADDR_276D_get_fbf_muc_en(data)                                     ((0x00000080&(data))>>7)
#define  ATSC_ADDR_276D_get_fbf_const_mse_lamda_15_9(data)                       (0x0000007F&(data))

#define  ATSC_ADDR_276E                                                         0x18155DB8
#define  ATSC_ADDR_276E_reg_addr                                                 "0xB8155DB8"
#define  ATSC_ADDR_276E_reg                                                      0xB8155DB8
#define  ATSC_ADDR_276E_inst_addr                                                "0x03B0"
#define  set_ATSC_ADDR_276E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_276E_reg)=data)
#define  get_ATSC_ADDR_276E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_276E_reg))
#define  ATSC_ADDR_276E_fbf_muc_field_size_exp_shift                             (4)
#define  ATSC_ADDR_276E_fbf_muc_start_field_exp_shift                            (0)
#define  ATSC_ADDR_276E_fbf_muc_field_size_exp_mask                              (0x000000F0)
#define  ATSC_ADDR_276E_fbf_muc_start_field_exp_mask                             (0x0000000F)
#define  ATSC_ADDR_276E_fbf_muc_field_size_exp(data)                             (0x000000F0&((data)<<4))
#define  ATSC_ADDR_276E_fbf_muc_start_field_exp(data)                            (0x0000000F&(data))
#define  ATSC_ADDR_276E_get_fbf_muc_field_size_exp(data)                         ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_276E_get_fbf_muc_start_field_exp(data)                        (0x0000000F&(data))

#define  ATSC_ADDR_276F                                                         0x18155DBC
#define  ATSC_ADDR_276F_reg_addr                                                 "0xB8155DBC"
#define  ATSC_ADDR_276F_reg                                                      0xB8155DBC
#define  ATSC_ADDR_276F_inst_addr                                                "0x03B1"
#define  set_ATSC_ADDR_276F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_276F_reg)=data)
#define  get_ATSC_ADDR_276F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_276F_reg))
#define  ATSC_ADDR_276F_fbf_muc_field_cnt_seg_7_0_shift                          (0)
#define  ATSC_ADDR_276F_fbf_muc_field_cnt_seg_7_0_mask                           (0x000000FF)
#define  ATSC_ADDR_276F_fbf_muc_field_cnt_seg_7_0(data)                          (0x000000FF&(data))
#define  ATSC_ADDR_276F_get_fbf_muc_field_cnt_seg_7_0(data)                      (0x000000FF&(data))

#define  ATSC_ADDR_2770                                                         0x18155DC0
#define  ATSC_ADDR_2770_reg_addr                                                 "0xB8155DC0"
#define  ATSC_ADDR_2770_reg                                                      0xB8155DC0
#define  ATSC_ADDR_2770_inst_addr                                                "0x03B2"
#define  set_ATSC_ADDR_2770_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2770_reg)=data)
#define  get_ATSC_ADDR_2770_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2770_reg))
#define  ATSC_ADDR_2770_fbf_muc_group_sum_th_0_3_0_shift                         (4)
#define  ATSC_ADDR_2770_fbf_muc_main_protect_en_shift                            (3)
#define  ATSC_ADDR_2770_fbf_muc_mu_bn_slow_en_shift                              (2)
#define  ATSC_ADDR_2770_fbf_muc_update_type_shift                                (1)
#define  ATSC_ADDR_2770_fbf_muc_field_cnt_seg_8_shift                            (0)
#define  ATSC_ADDR_2770_fbf_muc_group_sum_th_0_3_0_mask                          (0x000000F0)
#define  ATSC_ADDR_2770_fbf_muc_main_protect_en_mask                             (0x00000008)
#define  ATSC_ADDR_2770_fbf_muc_mu_bn_slow_en_mask                               (0x00000004)
#define  ATSC_ADDR_2770_fbf_muc_update_type_mask                                 (0x00000002)
#define  ATSC_ADDR_2770_fbf_muc_field_cnt_seg_8_mask                             (0x00000001)
#define  ATSC_ADDR_2770_fbf_muc_group_sum_th_0_3_0(data)                         (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2770_fbf_muc_main_protect_en(data)                            (0x00000008&((data)<<3))
#define  ATSC_ADDR_2770_fbf_muc_mu_bn_slow_en(data)                              (0x00000004&((data)<<2))
#define  ATSC_ADDR_2770_fbf_muc_update_type(data)                                (0x00000002&((data)<<1))
#define  ATSC_ADDR_2770_fbf_muc_field_cnt_seg_8(data)                            (0x00000001&(data))
#define  ATSC_ADDR_2770_get_fbf_muc_group_sum_th_0_3_0(data)                     ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2770_get_fbf_muc_main_protect_en(data)                        ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2770_get_fbf_muc_mu_bn_slow_en(data)                          ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2770_get_fbf_muc_update_type(data)                            ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2770_get_fbf_muc_field_cnt_seg_8(data)                        (0x00000001&(data))

#define  ATSC_ADDR_2771                                                         0x18155DC4
#define  ATSC_ADDR_2771_reg_addr                                                 "0xB8155DC4"
#define  ATSC_ADDR_2771_reg                                                      0xB8155DC4
#define  ATSC_ADDR_2771_inst_addr                                                "0x03B3"
#define  set_ATSC_ADDR_2771_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2771_reg)=data)
#define  get_ATSC_ADDR_2771_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2771_reg))
#define  ATSC_ADDR_2771_fbf_muc_group_sum_th_0_11_4_shift                        (0)
#define  ATSC_ADDR_2771_fbf_muc_group_sum_th_0_11_4_mask                         (0x000000FF)
#define  ATSC_ADDR_2771_fbf_muc_group_sum_th_0_11_4(data)                        (0x000000FF&(data))
#define  ATSC_ADDR_2771_get_fbf_muc_group_sum_th_0_11_4(data)                    (0x000000FF&(data))

#define  ATSC_ADDR_2772                                                         0x18155DC8
#define  ATSC_ADDR_2772_reg_addr                                                 "0xB8155DC8"
#define  ATSC_ADDR_2772_reg                                                      0xB8155DC8
#define  ATSC_ADDR_2772_inst_addr                                                "0x03B4"
#define  set_ATSC_ADDR_2772_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2772_reg)=data)
#define  get_ATSC_ADDR_2772_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2772_reg))
#define  ATSC_ADDR_2772_fbf_muc_group_sum_th_1_7_0_shift                         (0)
#define  ATSC_ADDR_2772_fbf_muc_group_sum_th_1_7_0_mask                          (0x000000FF)
#define  ATSC_ADDR_2772_fbf_muc_group_sum_th_1_7_0(data)                         (0x000000FF&(data))
#define  ATSC_ADDR_2772_get_fbf_muc_group_sum_th_1_7_0(data)                     (0x000000FF&(data))

#define  ATSC_ADDR_2773                                                         0x18155DCC
#define  ATSC_ADDR_2773_reg_addr                                                 "0xB8155DCC"
#define  ATSC_ADDR_2773_reg                                                      0xB8155DCC
#define  ATSC_ADDR_2773_inst_addr                                                "0x03B5"
#define  set_ATSC_ADDR_2773_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2773_reg)=data)
#define  get_ATSC_ADDR_2773_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2773_reg))
#define  ATSC_ADDR_2773_fbf_muc_group_sum_th_2_3_0_shift                         (4)
#define  ATSC_ADDR_2773_fbf_muc_group_sum_th_1_11_8_shift                        (0)
#define  ATSC_ADDR_2773_fbf_muc_group_sum_th_2_3_0_mask                          (0x000000F0)
#define  ATSC_ADDR_2773_fbf_muc_group_sum_th_1_11_8_mask                         (0x0000000F)
#define  ATSC_ADDR_2773_fbf_muc_group_sum_th_2_3_0(data)                         (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2773_fbf_muc_group_sum_th_1_11_8(data)                        (0x0000000F&(data))
#define  ATSC_ADDR_2773_get_fbf_muc_group_sum_th_2_3_0(data)                     ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2773_get_fbf_muc_group_sum_th_1_11_8(data)                    (0x0000000F&(data))

#define  ATSC_ADDR_2774                                                         0x18155DD0
#define  ATSC_ADDR_2774_reg_addr                                                 "0xB8155DD0"
#define  ATSC_ADDR_2774_reg                                                      0xB8155DD0
#define  ATSC_ADDR_2774_inst_addr                                                "0x03B6"
#define  set_ATSC_ADDR_2774_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2774_reg)=data)
#define  get_ATSC_ADDR_2774_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2774_reg))
#define  ATSC_ADDR_2774_fbf_muc_group_sum_th_2_11_4_shift                        (0)
#define  ATSC_ADDR_2774_fbf_muc_group_sum_th_2_11_4_mask                         (0x000000FF)
#define  ATSC_ADDR_2774_fbf_muc_group_sum_th_2_11_4(data)                        (0x000000FF&(data))
#define  ATSC_ADDR_2774_get_fbf_muc_group_sum_th_2_11_4(data)                    (0x000000FF&(data))

#define  ATSC_ADDR_2775                                                         0x18155DD4
#define  ATSC_ADDR_2775_reg_addr                                                 "0xB8155DD4"
#define  ATSC_ADDR_2775_reg                                                      0xB8155DD4
#define  ATSC_ADDR_2775_inst_addr                                                "0x03B7"
#define  set_ATSC_ADDR_2775_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2775_reg)=data)
#define  get_ATSC_ADDR_2775_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2775_reg))
#define  ATSC_ADDR_2775_fbf_muc_group_sum_th_3_7_0_shift                         (0)
#define  ATSC_ADDR_2775_fbf_muc_group_sum_th_3_7_0_mask                          (0x000000FF)
#define  ATSC_ADDR_2775_fbf_muc_group_sum_th_3_7_0(data)                         (0x000000FF&(data))
#define  ATSC_ADDR_2775_get_fbf_muc_group_sum_th_3_7_0(data)                     (0x000000FF&(data))

#define  ATSC_ADDR_2776                                                         0x18155DD8
#define  ATSC_ADDR_2776_reg_addr                                                 "0xB8155DD8"
#define  ATSC_ADDR_2776_reg                                                      0xB8155DD8
#define  ATSC_ADDR_2776_inst_addr                                                "0x03B8"
#define  set_ATSC_ADDR_2776_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2776_reg)=data)
#define  get_ATSC_ADDR_2776_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2776_reg))
#define  ATSC_ADDR_2776_fbf_muc_group_sum_th_4_3_0_shift                         (4)
#define  ATSC_ADDR_2776_fbf_muc_group_sum_th_3_11_8_shift                        (0)
#define  ATSC_ADDR_2776_fbf_muc_group_sum_th_4_3_0_mask                          (0x000000F0)
#define  ATSC_ADDR_2776_fbf_muc_group_sum_th_3_11_8_mask                         (0x0000000F)
#define  ATSC_ADDR_2776_fbf_muc_group_sum_th_4_3_0(data)                         (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2776_fbf_muc_group_sum_th_3_11_8(data)                        (0x0000000F&(data))
#define  ATSC_ADDR_2776_get_fbf_muc_group_sum_th_4_3_0(data)                     ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2776_get_fbf_muc_group_sum_th_3_11_8(data)                    (0x0000000F&(data))

#define  ATSC_ADDR_2777                                                         0x18155DDC
#define  ATSC_ADDR_2777_reg_addr                                                 "0xB8155DDC"
#define  ATSC_ADDR_2777_reg                                                      0xB8155DDC
#define  ATSC_ADDR_2777_inst_addr                                                "0x03B9"
#define  set_ATSC_ADDR_2777_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2777_reg)=data)
#define  get_ATSC_ADDR_2777_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2777_reg))
#define  ATSC_ADDR_2777_fbf_muc_group_sum_th_4_11_4_shift                        (0)
#define  ATSC_ADDR_2777_fbf_muc_group_sum_th_4_11_4_mask                         (0x000000FF)
#define  ATSC_ADDR_2777_fbf_muc_group_sum_th_4_11_4(data)                        (0x000000FF&(data))
#define  ATSC_ADDR_2777_get_fbf_muc_group_sum_th_4_11_4(data)                    (0x000000FF&(data))

#define  ATSC_ADDR_2778                                                         0x18155DE0
#define  ATSC_ADDR_2778_reg_addr                                                 "0xB8155DE0"
#define  ATSC_ADDR_2778_reg                                                      0xB8155DE0
#define  ATSC_ADDR_2778_inst_addr                                                "0x03BA"
#define  set_ATSC_ADDR_2778_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2778_reg)=data)
#define  get_ATSC_ADDR_2778_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2778_reg))
#define  ATSC_ADDR_2778_fbf_muc_mu_1_2_0_shift                                   (5)
#define  ATSC_ADDR_2778_fbf_muc_mu_0_shift                                       (0)
#define  ATSC_ADDR_2778_fbf_muc_mu_1_2_0_mask                                    (0x000000E0)
#define  ATSC_ADDR_2778_fbf_muc_mu_0_mask                                        (0x0000001F)
#define  ATSC_ADDR_2778_fbf_muc_mu_1_2_0(data)                                   (0x000000E0&((data)<<5))
#define  ATSC_ADDR_2778_fbf_muc_mu_0(data)                                       (0x0000001F&(data))
#define  ATSC_ADDR_2778_get_fbf_muc_mu_1_2_0(data)                               ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_2778_get_fbf_muc_mu_0(data)                                   (0x0000001F&(data))

#define  ATSC_ADDR_2779                                                         0x18155DE4
#define  ATSC_ADDR_2779_reg_addr                                                 "0xB8155DE4"
#define  ATSC_ADDR_2779_reg                                                      0xB8155DE4
#define  ATSC_ADDR_2779_inst_addr                                                "0x03BB"
#define  set_ATSC_ADDR_2779_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2779_reg)=data)
#define  get_ATSC_ADDR_2779_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2779_reg))
#define  ATSC_ADDR_2779_fbf_muc_mu_3_0_shift                                     (7)
#define  ATSC_ADDR_2779_fbf_muc_mu_2_shift                                       (2)
#define  ATSC_ADDR_2779_fbf_muc_mu_1_4_3_shift                                   (0)
#define  ATSC_ADDR_2779_fbf_muc_mu_3_0_mask                                      (0x00000080)
#define  ATSC_ADDR_2779_fbf_muc_mu_2_mask                                        (0x0000007C)
#define  ATSC_ADDR_2779_fbf_muc_mu_1_4_3_mask                                    (0x00000003)
#define  ATSC_ADDR_2779_fbf_muc_mu_3_0(data)                                     (0x00000080&((data)<<7))
#define  ATSC_ADDR_2779_fbf_muc_mu_2(data)                                       (0x0000007C&((data)<<2))
#define  ATSC_ADDR_2779_fbf_muc_mu_1_4_3(data)                                   (0x00000003&(data))
#define  ATSC_ADDR_2779_get_fbf_muc_mu_3_0(data)                                 ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2779_get_fbf_muc_mu_2(data)                                   ((0x0000007C&(data))>>2)
#define  ATSC_ADDR_2779_get_fbf_muc_mu_1_4_3(data)                               (0x00000003&(data))

#define  ATSC_ADDR_277A                                                         0x18155DE8
#define  ATSC_ADDR_277A_reg_addr                                                 "0xB8155DE8"
#define  ATSC_ADDR_277A_reg                                                      0xB8155DE8
#define  ATSC_ADDR_277A_inst_addr                                                "0x03BC"
#define  set_ATSC_ADDR_277A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_277A_reg)=data)
#define  get_ATSC_ADDR_277A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_277A_reg))
#define  ATSC_ADDR_277A_fbf_muc_mu_4_3_0_shift                                   (4)
#define  ATSC_ADDR_277A_fbf_muc_mu_3_4_1_shift                                   (0)
#define  ATSC_ADDR_277A_fbf_muc_mu_4_3_0_mask                                    (0x000000F0)
#define  ATSC_ADDR_277A_fbf_muc_mu_3_4_1_mask                                    (0x0000000F)
#define  ATSC_ADDR_277A_fbf_muc_mu_4_3_0(data)                                   (0x000000F0&((data)<<4))
#define  ATSC_ADDR_277A_fbf_muc_mu_3_4_1(data)                                   (0x0000000F&(data))
#define  ATSC_ADDR_277A_get_fbf_muc_mu_4_3_0(data)                               ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_277A_get_fbf_muc_mu_3_4_1(data)                               (0x0000000F&(data))

#define  ATSC_ADDR_277B                                                         0x18155DEC
#define  ATSC_ADDR_277B_reg_addr                                                 "0xB8155DEC"
#define  ATSC_ADDR_277B_reg                                                      0xB8155DEC
#define  ATSC_ADDR_277B_inst_addr                                                "0x03BD"
#define  set_ATSC_ADDR_277B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_277B_reg)=data)
#define  get_ATSC_ADDR_277B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_277B_reg))
#define  ATSC_ADDR_277B_fbf_muc_mu_main_0_1_0_shift                              (6)
#define  ATSC_ADDR_277B_fbf_muc_mu_5_shift                                       (1)
#define  ATSC_ADDR_277B_fbf_muc_mu_4_4_shift                                     (0)
#define  ATSC_ADDR_277B_fbf_muc_mu_main_0_1_0_mask                               (0x000000C0)
#define  ATSC_ADDR_277B_fbf_muc_mu_5_mask                                        (0x0000003E)
#define  ATSC_ADDR_277B_fbf_muc_mu_4_4_mask                                      (0x00000001)
#define  ATSC_ADDR_277B_fbf_muc_mu_main_0_1_0(data)                              (0x000000C0&((data)<<6))
#define  ATSC_ADDR_277B_fbf_muc_mu_5(data)                                       (0x0000003E&((data)<<1))
#define  ATSC_ADDR_277B_fbf_muc_mu_4_4(data)                                     (0x00000001&(data))
#define  ATSC_ADDR_277B_get_fbf_muc_mu_main_0_1_0(data)                          ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_277B_get_fbf_muc_mu_5(data)                                   ((0x0000003E&(data))>>1)
#define  ATSC_ADDR_277B_get_fbf_muc_mu_4_4(data)                                 (0x00000001&(data))

#define  ATSC_ADDR_277C                                                         0x18155DF0
#define  ATSC_ADDR_277C_reg_addr                                                 "0xB8155DF0"
#define  ATSC_ADDR_277C_reg                                                      0xB8155DF0
#define  ATSC_ADDR_277C_inst_addr                                                "0x03BE"
#define  set_ATSC_ADDR_277C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_277C_reg)=data)
#define  get_ATSC_ADDR_277C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_277C_reg))
#define  ATSC_ADDR_277C_fbf_muc_mu_main_1_shift                                  (3)
#define  ATSC_ADDR_277C_fbf_muc_mu_main_0_4_2_shift                              (0)
#define  ATSC_ADDR_277C_fbf_muc_mu_main_1_mask                                   (0x000000F8)
#define  ATSC_ADDR_277C_fbf_muc_mu_main_0_4_2_mask                               (0x00000007)
#define  ATSC_ADDR_277C_fbf_muc_mu_main_1(data)                                  (0x000000F8&((data)<<3))
#define  ATSC_ADDR_277C_fbf_muc_mu_main_0_4_2(data)                              (0x00000007&(data))
#define  ATSC_ADDR_277C_get_fbf_muc_mu_main_1(data)                              ((0x000000F8&(data))>>3)
#define  ATSC_ADDR_277C_get_fbf_muc_mu_main_0_4_2(data)                          (0x00000007&(data))

#define  ATSC_ADDR_277D                                                         0x18155DF4
#define  ATSC_ADDR_277D_reg_addr                                                 "0xB8155DF4"
#define  ATSC_ADDR_277D_reg                                                      0xB8155DF4
#define  ATSC_ADDR_277D_inst_addr                                                "0x03BF"
#define  set_ATSC_ADDR_277D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_277D_reg)=data)
#define  get_ATSC_ADDR_277D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_277D_reg))
#define  ATSC_ADDR_277D_fbf_muc_mu_main_3_2_0_shift                              (5)
#define  ATSC_ADDR_277D_fbf_muc_mu_main_2_shift                                  (0)
#define  ATSC_ADDR_277D_fbf_muc_mu_main_3_2_0_mask                               (0x000000E0)
#define  ATSC_ADDR_277D_fbf_muc_mu_main_2_mask                                   (0x0000001F)
#define  ATSC_ADDR_277D_fbf_muc_mu_main_3_2_0(data)                              (0x000000E0&((data)<<5))
#define  ATSC_ADDR_277D_fbf_muc_mu_main_2(data)                                  (0x0000001F&(data))
#define  ATSC_ADDR_277D_get_fbf_muc_mu_main_3_2_0(data)                          ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_277D_get_fbf_muc_mu_main_2(data)                              (0x0000001F&(data))

#define  ATSC_ADDR_277E                                                         0x18155DF8
#define  ATSC_ADDR_277E_reg_addr                                                 "0xB8155DF8"
#define  ATSC_ADDR_277E_reg                                                      0xB8155DF8
#define  ATSC_ADDR_277E_inst_addr                                                "0x03C0"
#define  set_ATSC_ADDR_277E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_277E_reg)=data)
#define  get_ATSC_ADDR_277E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_277E_reg))
#define  ATSC_ADDR_277E_fbf_muc_mu_main_5_0_shift                                (7)
#define  ATSC_ADDR_277E_fbf_muc_mu_main_4_shift                                  (2)
#define  ATSC_ADDR_277E_fbf_muc_mu_main_3_4_3_shift                              (0)
#define  ATSC_ADDR_277E_fbf_muc_mu_main_5_0_mask                                 (0x00000080)
#define  ATSC_ADDR_277E_fbf_muc_mu_main_4_mask                                   (0x0000007C)
#define  ATSC_ADDR_277E_fbf_muc_mu_main_3_4_3_mask                               (0x00000003)
#define  ATSC_ADDR_277E_fbf_muc_mu_main_5_0(data)                                (0x00000080&((data)<<7))
#define  ATSC_ADDR_277E_fbf_muc_mu_main_4(data)                                  (0x0000007C&((data)<<2))
#define  ATSC_ADDR_277E_fbf_muc_mu_main_3_4_3(data)                              (0x00000003&(data))
#define  ATSC_ADDR_277E_get_fbf_muc_mu_main_5_0(data)                            ((0x00000080&(data))>>7)
#define  ATSC_ADDR_277E_get_fbf_muc_mu_main_4(data)                              ((0x0000007C&(data))>>2)
#define  ATSC_ADDR_277E_get_fbf_muc_mu_main_3_4_3(data)                          (0x00000003&(data))

#define  ATSC_ADDR_277F                                                         0x18155DFC
#define  ATSC_ADDR_277F_reg_addr                                                 "0xB8155DFC"
#define  ATSC_ADDR_277F_reg                                                      0xB8155DFC
#define  ATSC_ADDR_277F_inst_addr                                                "0x03C1"
#define  set_ATSC_ADDR_277F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_277F_reg)=data)
#define  get_ATSC_ADDR_277F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_277F_reg))
#define  ATSC_ADDR_277F_fbf_muc_mu_bn_slow_0_3_0_shift                           (4)
#define  ATSC_ADDR_277F_fbf_muc_mu_main_5_4_1_shift                              (0)
#define  ATSC_ADDR_277F_fbf_muc_mu_bn_slow_0_3_0_mask                            (0x000000F0)
#define  ATSC_ADDR_277F_fbf_muc_mu_main_5_4_1_mask                               (0x0000000F)
#define  ATSC_ADDR_277F_fbf_muc_mu_bn_slow_0_3_0(data)                           (0x000000F0&((data)<<4))
#define  ATSC_ADDR_277F_fbf_muc_mu_main_5_4_1(data)                              (0x0000000F&(data))
#define  ATSC_ADDR_277F_get_fbf_muc_mu_bn_slow_0_3_0(data)                       ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_277F_get_fbf_muc_mu_main_5_4_1(data)                          (0x0000000F&(data))

#define  ATSC_ADDR_2780                                                         0x18155E00
#define  ATSC_ADDR_2780_reg_addr                                                 "0xB8155E00"
#define  ATSC_ADDR_2780_reg                                                      0xB8155E00
#define  ATSC_ADDR_2780_inst_addr                                                "0x03C2"
#define  set_ATSC_ADDR_2780_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2780_reg)=data)
#define  get_ATSC_ADDR_2780_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2780_reg))
#define  ATSC_ADDR_2780_fbf_muc_mu_bn_slow_2_1_0_shift                           (6)
#define  ATSC_ADDR_2780_fbf_muc_mu_bn_slow_1_shift                               (1)
#define  ATSC_ADDR_2780_fbf_muc_mu_bn_slow_0_4_shift                             (0)
#define  ATSC_ADDR_2780_fbf_muc_mu_bn_slow_2_1_0_mask                            (0x000000C0)
#define  ATSC_ADDR_2780_fbf_muc_mu_bn_slow_1_mask                                (0x0000003E)
#define  ATSC_ADDR_2780_fbf_muc_mu_bn_slow_0_4_mask                              (0x00000001)
#define  ATSC_ADDR_2780_fbf_muc_mu_bn_slow_2_1_0(data)                           (0x000000C0&((data)<<6))
#define  ATSC_ADDR_2780_fbf_muc_mu_bn_slow_1(data)                               (0x0000003E&((data)<<1))
#define  ATSC_ADDR_2780_fbf_muc_mu_bn_slow_0_4(data)                             (0x00000001&(data))
#define  ATSC_ADDR_2780_get_fbf_muc_mu_bn_slow_2_1_0(data)                       ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_2780_get_fbf_muc_mu_bn_slow_1(data)                           ((0x0000003E&(data))>>1)
#define  ATSC_ADDR_2780_get_fbf_muc_mu_bn_slow_0_4(data)                         (0x00000001&(data))

#define  ATSC_ADDR_2781                                                         0x18155E04
#define  ATSC_ADDR_2781_reg_addr                                                 "0xB8155E04"
#define  ATSC_ADDR_2781_reg                                                      0xB8155E04
#define  ATSC_ADDR_2781_inst_addr                                                "0x03C3"
#define  set_ATSC_ADDR_2781_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2781_reg)=data)
#define  get_ATSC_ADDR_2781_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2781_reg))
#define  ATSC_ADDR_2781_fbf_muc_mu_bn_slow_3_shift                               (3)
#define  ATSC_ADDR_2781_fbf_muc_mu_bn_slow_2_4_2_shift                           (0)
#define  ATSC_ADDR_2781_fbf_muc_mu_bn_slow_3_mask                                (0x000000F8)
#define  ATSC_ADDR_2781_fbf_muc_mu_bn_slow_2_4_2_mask                            (0x00000007)
#define  ATSC_ADDR_2781_fbf_muc_mu_bn_slow_3(data)                               (0x000000F8&((data)<<3))
#define  ATSC_ADDR_2781_fbf_muc_mu_bn_slow_2_4_2(data)                           (0x00000007&(data))
#define  ATSC_ADDR_2781_get_fbf_muc_mu_bn_slow_3(data)                           ((0x000000F8&(data))>>3)
#define  ATSC_ADDR_2781_get_fbf_muc_mu_bn_slow_2_4_2(data)                       (0x00000007&(data))

#define  ATSC_ADDR_2782                                                         0x18155E08
#define  ATSC_ADDR_2782_reg_addr                                                 "0xB8155E08"
#define  ATSC_ADDR_2782_reg                                                      0xB8155E08
#define  ATSC_ADDR_2782_inst_addr                                                "0x03C4"
#define  set_ATSC_ADDR_2782_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2782_reg)=data)
#define  get_ATSC_ADDR_2782_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2782_reg))
#define  ATSC_ADDR_2782_fbf_muc_mu_bn_slow_5_2_0_shift                           (5)
#define  ATSC_ADDR_2782_fbf_muc_mu_bn_slow_4_shift                               (0)
#define  ATSC_ADDR_2782_fbf_muc_mu_bn_slow_5_2_0_mask                            (0x000000E0)
#define  ATSC_ADDR_2782_fbf_muc_mu_bn_slow_4_mask                                (0x0000001F)
#define  ATSC_ADDR_2782_fbf_muc_mu_bn_slow_5_2_0(data)                           (0x000000E0&((data)<<5))
#define  ATSC_ADDR_2782_fbf_muc_mu_bn_slow_4(data)                               (0x0000001F&(data))
#define  ATSC_ADDR_2782_get_fbf_muc_mu_bn_slow_5_2_0(data)                       ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_2782_get_fbf_muc_mu_bn_slow_4(data)                           (0x0000001F&(data))

#define  ATSC_ADDR_2783                                                         0x18155E0C
#define  ATSC_ADDR_2783_reg_addr                                                 "0xB8155E0C"
#define  ATSC_ADDR_2783_reg                                                      0xB8155E0C
#define  ATSC_ADDR_2783_inst_addr                                                "0x03C5"
#define  set_ATSC_ADDR_2783_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2783_reg)=data)
#define  get_ATSC_ADDR_2783_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2783_reg))
#define  ATSC_ADDR_2783_fbf_muc_mu_bn_slow_5_4_3_shift                           (0)
#define  ATSC_ADDR_2783_fbf_muc_mu_bn_slow_5_4_3_mask                            (0x00000003)
#define  ATSC_ADDR_2783_fbf_muc_mu_bn_slow_5_4_3(data)                           (0x00000003&(data))
#define  ATSC_ADDR_2783_get_fbf_muc_mu_bn_slow_5_4_3(data)                       (0x00000003&(data))

#define  ATSC_ADDR_2788                                                         0x18155E20
#define  ATSC_ADDR_2788_reg_addr                                                 "0xB8155E20"
#define  ATSC_ADDR_2788_reg                                                      0xB8155E20
#define  ATSC_ADDR_2788_inst_addr                                                "0x03C6"
#define  set_ATSC_ADDR_2788_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2788_reg)=data)
#define  get_ATSC_ADDR_2788_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2788_reg))
#define  ATSC_ADDR_2788_bn_eqpt_er_amp_th_en_shift                               (7)
#define  ATSC_ADDR_2788_eqpt_dd_xi_abs_q_manu_shift                              (4)
#define  ATSC_ADDR_2788_eqpt_dd_xi_abs_q_manu_en_shift                           (3)
#define  ATSC_ADDR_2788_eqpt_in_amp_th_disable_shift                             (2)
#define  ATSC_ADDR_2788_bn_det_adj_ind_enable_shift                              (1)
#define  ATSC_ADDR_2788_bn_det_mse_opt_shift                                     (0)
#define  ATSC_ADDR_2788_bn_eqpt_er_amp_th_en_mask                                (0x00000080)
#define  ATSC_ADDR_2788_eqpt_dd_xi_abs_q_manu_mask                               (0x00000070)
#define  ATSC_ADDR_2788_eqpt_dd_xi_abs_q_manu_en_mask                            (0x00000008)
#define  ATSC_ADDR_2788_eqpt_in_amp_th_disable_mask                              (0x00000004)
#define  ATSC_ADDR_2788_bn_det_adj_ind_enable_mask                               (0x00000002)
#define  ATSC_ADDR_2788_bn_det_mse_opt_mask                                      (0x00000001)
#define  ATSC_ADDR_2788_bn_eqpt_er_amp_th_en(data)                               (0x00000080&((data)<<7))
#define  ATSC_ADDR_2788_eqpt_dd_xi_abs_q_manu(data)                              (0x00000070&((data)<<4))
#define  ATSC_ADDR_2788_eqpt_dd_xi_abs_q_manu_en(data)                           (0x00000008&((data)<<3))
#define  ATSC_ADDR_2788_eqpt_in_amp_th_disable(data)                             (0x00000004&((data)<<2))
#define  ATSC_ADDR_2788_bn_det_adj_ind_enable(data)                              (0x00000002&((data)<<1))
#define  ATSC_ADDR_2788_bn_det_mse_opt(data)                                     (0x00000001&(data))
#define  ATSC_ADDR_2788_get_bn_eqpt_er_amp_th_en(data)                           ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2788_get_eqpt_dd_xi_abs_q_manu(data)                          ((0x00000070&(data))>>4)
#define  ATSC_ADDR_2788_get_eqpt_dd_xi_abs_q_manu_en(data)                       ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2788_get_eqpt_in_amp_th_disable(data)                         ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2788_get_bn_det_adj_ind_enable(data)                          ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2788_get_bn_det_mse_opt(data)                                 (0x00000001&(data))

#define  ATSC_ADDR_2789                                                         0x18155E24
#define  ATSC_ADDR_2789_reg_addr                                                 "0xB8155E24"
#define  ATSC_ADDR_2789_reg                                                      0xB8155E24
#define  ATSC_ADDR_2789_inst_addr                                                "0x03C7"
#define  set_ATSC_ADDR_2789_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2789_reg)=data)
#define  get_ATSC_ADDR_2789_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2789_reg))
#define  ATSC_ADDR_2789_eqpt_dd_delta_ph_max_bn_shift                            (4)
#define  ATSC_ADDR_2789_eqpt_dd_er_amp_th_bn_shift                               (0)
#define  ATSC_ADDR_2789_eqpt_dd_delta_ph_max_bn_mask                             (0x000000F0)
#define  ATSC_ADDR_2789_eqpt_dd_er_amp_th_bn_mask                                (0x0000000F)
#define  ATSC_ADDR_2789_eqpt_dd_delta_ph_max_bn(data)                            (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2789_eqpt_dd_er_amp_th_bn(data)                               (0x0000000F&(data))
#define  ATSC_ADDR_2789_get_eqpt_dd_delta_ph_max_bn(data)                        ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2789_get_eqpt_dd_er_amp_th_bn(data)                           (0x0000000F&(data))

#define  ATSC_ADDR_278A                                                         0x18155E28
#define  ATSC_ADDR_278A_reg_addr                                                 "0xB8155E28"
#define  ATSC_ADDR_278A_reg                                                      0xB8155E28
#define  ATSC_ADDR_278A_inst_addr                                                "0x03C8"
#define  set_ATSC_ADDR_278A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_278A_reg)=data)
#define  get_ATSC_ADDR_278A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_278A_reg))
#define  ATSC_ADDR_278A_eqpt_mse_src_sel_shift                                   (5)
#define  ATSC_ADDR_278A_bn_eqpt_u_en_shift                                       (4)
#define  ATSC_ADDR_278A_eqpt_dd_step_size_exp_bn_shift                           (1)
#define  ATSC_ADDR_278A_bn_eqpt_delta_max_en_shift                               (0)
#define  ATSC_ADDR_278A_eqpt_mse_src_sel_mask                                    (0x00000020)
#define  ATSC_ADDR_278A_bn_eqpt_u_en_mask                                        (0x00000010)
#define  ATSC_ADDR_278A_eqpt_dd_step_size_exp_bn_mask                            (0x0000000E)
#define  ATSC_ADDR_278A_bn_eqpt_delta_max_en_mask                                (0x00000001)
#define  ATSC_ADDR_278A_eqpt_mse_src_sel(data)                                   (0x00000020&((data)<<5))
#define  ATSC_ADDR_278A_bn_eqpt_u_en(data)                                       (0x00000010&((data)<<4))
#define  ATSC_ADDR_278A_eqpt_dd_step_size_exp_bn(data)                           (0x0000000E&((data)<<1))
#define  ATSC_ADDR_278A_bn_eqpt_delta_max_en(data)                               (0x00000001&(data))
#define  ATSC_ADDR_278A_get_eqpt_mse_src_sel(data)                               ((0x00000020&(data))>>5)
#define  ATSC_ADDR_278A_get_bn_eqpt_u_en(data)                                   ((0x00000010&(data))>>4)
#define  ATSC_ADDR_278A_get_eqpt_dd_step_size_exp_bn(data)                       ((0x0000000E&(data))>>1)
#define  ATSC_ADDR_278A_get_bn_eqpt_delta_max_en(data)                           (0x00000001&(data))

#define  ATSC_ADDR_278B                                                         0x18155E2C
#define  ATSC_ADDR_278B_reg_addr                                                 "0xB8155E2C"
#define  ATSC_ADDR_278B_reg                                                      0xB8155E2C
#define  ATSC_ADDR_278B_inst_addr                                                "0x03C9"
#define  set_ATSC_ADDR_278B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_278B_reg)=data)
#define  get_ATSC_ADDR_278B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_278B_reg))
#define  ATSC_ADDR_278B_eqpt_leak_exp_shift                                      (5)
#define  ATSC_ADDR_278B_eqpt_leak_opt2_shift                                     (4)
#define  ATSC_ADDR_278B_eqpt_leak_opt1_shift                                     (3)
#define  ATSC_ADDR_278B_eqpt_mse_field_th_out_sel_shift                          (2)
#define  ATSC_ADDR_278B_eqpt_state_ind_clear_opt_shift                           (1)
#define  ATSC_ADDR_278B_eqpt_mse_field_src_sel_shift                             (0)
#define  ATSC_ADDR_278B_eqpt_leak_exp_mask                                       (0x000000E0)
#define  ATSC_ADDR_278B_eqpt_leak_opt2_mask                                      (0x00000010)
#define  ATSC_ADDR_278B_eqpt_leak_opt1_mask                                      (0x00000008)
#define  ATSC_ADDR_278B_eqpt_mse_field_th_out_sel_mask                           (0x00000004)
#define  ATSC_ADDR_278B_eqpt_state_ind_clear_opt_mask                            (0x00000002)
#define  ATSC_ADDR_278B_eqpt_mse_field_src_sel_mask                              (0x00000001)
#define  ATSC_ADDR_278B_eqpt_leak_exp(data)                                      (0x000000E0&((data)<<5))
#define  ATSC_ADDR_278B_eqpt_leak_opt2(data)                                     (0x00000010&((data)<<4))
#define  ATSC_ADDR_278B_eqpt_leak_opt1(data)                                     (0x00000008&((data)<<3))
#define  ATSC_ADDR_278B_eqpt_mse_field_th_out_sel(data)                          (0x00000004&((data)<<2))
#define  ATSC_ADDR_278B_eqpt_state_ind_clear_opt(data)                           (0x00000002&((data)<<1))
#define  ATSC_ADDR_278B_eqpt_mse_field_src_sel(data)                             (0x00000001&(data))
#define  ATSC_ADDR_278B_get_eqpt_leak_exp(data)                                  ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_278B_get_eqpt_leak_opt2(data)                                 ((0x00000010&(data))>>4)
#define  ATSC_ADDR_278B_get_eqpt_leak_opt1(data)                                 ((0x00000008&(data))>>3)
#define  ATSC_ADDR_278B_get_eqpt_mse_field_th_out_sel(data)                      ((0x00000004&(data))>>2)
#define  ATSC_ADDR_278B_get_eqpt_state_ind_clear_opt(data)                       ((0x00000002&(data))>>1)
#define  ATSC_ADDR_278B_get_eqpt_mse_field_src_sel(data)                         (0x00000001&(data))

#define  ATSC_ADDR_278C                                                         0x18155E30
#define  ATSC_ADDR_278C_reg_addr                                                 "0xB8155E30"
#define  ATSC_ADDR_278C_reg                                                      0xB8155E30
#define  ATSC_ADDR_278C_inst_addr                                                "0x03CA"
#define  set_ATSC_ADDR_278C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_278C_reg)=data)
#define  get_ATSC_ADDR_278C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_278C_reg))
#define  ATSC_ADDR_278C_eqpt_mse_field_th2_7_0_shift                             (0)
#define  ATSC_ADDR_278C_eqpt_mse_field_th2_7_0_mask                              (0x000000FF)
#define  ATSC_ADDR_278C_eqpt_mse_field_th2_7_0(data)                             (0x000000FF&(data))
#define  ATSC_ADDR_278C_get_eqpt_mse_field_th2_7_0(data)                         (0x000000FF&(data))

#define  ATSC_ADDR_278D                                                         0x18155E34
#define  ATSC_ADDR_278D_reg_addr                                                 "0xB8155E34"
#define  ATSC_ADDR_278D_reg                                                      0xB8155E34
#define  ATSC_ADDR_278D_inst_addr                                                "0x03CB"
#define  set_ATSC_ADDR_278D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_278D_reg)=data)
#define  get_ATSC_ADDR_278D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_278D_reg))
#define  ATSC_ADDR_278D_eqpt_mse_field_th2_15_8_shift                            (0)
#define  ATSC_ADDR_278D_eqpt_mse_field_th2_15_8_mask                             (0x000000FF)
#define  ATSC_ADDR_278D_eqpt_mse_field_th2_15_8(data)                            (0x000000FF&(data))
#define  ATSC_ADDR_278D_get_eqpt_mse_field_th2_15_8(data)                        (0x000000FF&(data))

#define  ATSC_ADDR_278E                                                         0x18155E38
#define  ATSC_ADDR_278E_reg_addr                                                 "0xB8155E38"
#define  ATSC_ADDR_278E_reg                                                      0xB8155E38
#define  ATSC_ADDR_278E_inst_addr                                                "0x03CC"
#define  set_ATSC_ADDR_278E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_278E_reg)=data)
#define  get_ATSC_ADDR_278E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_278E_reg))
#define  ATSC_ADDR_278E_opt_bn_det_hold_input_shift                              (2)
#define  ATSC_ADDR_278E_opt_bn_slow_ind_shift                                    (0)
#define  ATSC_ADDR_278E_opt_bn_det_hold_input_mask                               (0x00000004)
#define  ATSC_ADDR_278E_opt_bn_slow_ind_mask                                     (0x00000001)
#define  ATSC_ADDR_278E_opt_bn_det_hold_input(data)                              (0x00000004&((data)<<2))
#define  ATSC_ADDR_278E_opt_bn_slow_ind(data)                                    (0x00000001&(data))
#define  ATSC_ADDR_278E_get_opt_bn_det_hold_input(data)                          ((0x00000004&(data))>>2)
#define  ATSC_ADDR_278E_get_opt_bn_slow_ind(data)                                (0x00000001&(data))

#define  ATSC_ADDR_2790                                                         0x18155E40
#define  ATSC_ADDR_2790_reg_addr                                                 "0xB8155E40"
#define  ATSC_ADDR_2790_reg                                                      0xB8155E40
#define  ATSC_ADDR_2790_inst_addr                                                "0x03CD"
#define  set_ATSC_ADDR_2790_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2790_reg)=data)
#define  get_ATSC_ADDR_2790_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2790_reg))
#define  ATSC_ADDR_2790_gamma_sato_shift                                         (0)
#define  ATSC_ADDR_2790_gamma_sato_mask                                          (0x0000007F)
#define  ATSC_ADDR_2790_gamma_sato(data)                                         (0x0000007F&(data))
#define  ATSC_ADDR_2790_get_gamma_sato(data)                                     (0x0000007F&(data))

#define  ATSC_ADDR_2791                                                         0x18155E44
#define  ATSC_ADDR_2791_reg_addr                                                 "0xB8155E44"
#define  ATSC_ADDR_2791_reg                                                      0xB8155E44
#define  ATSC_ADDR_2791_inst_addr                                                "0x03CE"
#define  set_ATSC_ADDR_2791_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2791_reg)=data)
#define  get_ATSC_ADDR_2791_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2791_reg))
#define  ATSC_ADDR_2791_gamma_godard2_7_0_shift                                  (0)
#define  ATSC_ADDR_2791_gamma_godard2_7_0_mask                                   (0x000000FF)
#define  ATSC_ADDR_2791_gamma_godard2_7_0(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2791_get_gamma_godard2_7_0(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2792                                                         0x18155E48
#define  ATSC_ADDR_2792_reg_addr                                                 "0xB8155E48"
#define  ATSC_ADDR_2792_reg                                                      0xB8155E48
#define  ATSC_ADDR_2792_inst_addr                                                "0x03CF"
#define  set_ATSC_ADDR_2792_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2792_reg)=data)
#define  get_ATSC_ADDR_2792_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2792_reg))
#define  ATSC_ADDR_2792_gamma_godard2_8_shift                                    (0)
#define  ATSC_ADDR_2792_gamma_godard2_8_mask                                     (0x00000001)
#define  ATSC_ADDR_2792_gamma_godard2_8(data)                                    (0x00000001&(data))
#define  ATSC_ADDR_2792_get_gamma_godard2_8(data)                                (0x00000001&(data))

#define  ATSC_ADDR_2793                                                         0x18155E4C
#define  ATSC_ADDR_2793_reg_addr                                                 "0xB8155E4C"
#define  ATSC_ADDR_2793_reg                                                      0xB8155E4C
#define  ATSC_ADDR_2793_inst_addr                                                "0x03D0"
#define  set_ATSC_ADDR_2793_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2793_reg)=data)
#define  get_ATSC_ADDR_2793_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2793_reg))
#define  ATSC_ADDR_2793_ffe_upd_cnt_max_shift                                    (0)
#define  ATSC_ADDR_2793_ffe_upd_cnt_max_mask                                     (0x000000FF)
#define  ATSC_ADDR_2793_ffe_upd_cnt_max(data)                                    (0x000000FF&(data))
#define  ATSC_ADDR_2793_get_ffe_upd_cnt_max(data)                                (0x000000FF&(data))

#define  ATSC_ADDR_2794                                                         0x18155E50
#define  ATSC_ADDR_2794_reg_addr                                                 "0xB8155E50"
#define  ATSC_ADDR_2794_reg                                                      0xB8155E50
#define  ATSC_ADDR_2794_inst_addr                                                "0x03D1"
#define  set_ATSC_ADDR_2794_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2794_reg)=data)
#define  get_ATSC_ADDR_2794_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2794_reg))
#define  ATSC_ADDR_2794_fbf_upd_cnt_max_shift                                    (0)
#define  ATSC_ADDR_2794_fbf_upd_cnt_max_mask                                     (0x000000FF)
#define  ATSC_ADDR_2794_fbf_upd_cnt_max(data)                                    (0x000000FF&(data))
#define  ATSC_ADDR_2794_get_fbf_upd_cnt_max(data)                                (0x000000FF&(data))

#define  ATSC_ADDR_2795                                                         0x18155E54
#define  ATSC_ADDR_2795_reg_addr                                                 "0xB8155E54"
#define  ATSC_ADDR_2795_reg                                                      0xB8155E54
#define  ATSC_ADDR_2795_inst_addr                                                "0x03D2"
#define  set_ATSC_ADDR_2795_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2795_reg)=data)
#define  get_ATSC_ADDR_2795_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2795_reg))
#define  ATSC_ADDR_2795_mse_exp_shift                                            (0)
#define  ATSC_ADDR_2795_mse_exp_mask                                             (0x00000003)
#define  ATSC_ADDR_2795_mse_exp(data)                                            (0x00000003&(data))
#define  ATSC_ADDR_2795_get_mse_exp(data)                                        (0x00000003&(data))

#define  ATSC_ADDR_279E                                                         0x18155E78
#define  ATSC_ADDR_279E_reg_addr                                                 "0xB8155E78"
#define  ATSC_ADDR_279E_reg                                                      0xB8155E78
#define  ATSC_ADDR_279E_inst_addr                                                "0x03D3"
#define  set_ATSC_ADDR_279E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_279E_reg)=data)
#define  get_ATSC_ADDR_279E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_279E_reg))
#define  ATSC_ADDR_279E_er_bound_6_0_shift                                       (1)
#define  ATSC_ADDR_279E_er_bound_en_shift                                        (0)
#define  ATSC_ADDR_279E_er_bound_6_0_mask                                        (0x000000FE)
#define  ATSC_ADDR_279E_er_bound_en_mask                                         (0x00000001)
#define  ATSC_ADDR_279E_er_bound_6_0(data)                                       (0x000000FE&((data)<<1))
#define  ATSC_ADDR_279E_er_bound_en(data)                                        (0x00000001&(data))
#define  ATSC_ADDR_279E_get_er_bound_6_0(data)                                   ((0x000000FE&(data))>>1)
#define  ATSC_ADDR_279E_get_er_bound_en(data)                                    (0x00000001&(data))

#define  ATSC_ADDR_279F                                                         0x18155E7C
#define  ATSC_ADDR_279F_reg_addr                                                 "0xB8155E7C"
#define  ATSC_ADDR_279F_reg                                                      0xB8155E7C
#define  ATSC_ADDR_279F_inst_addr                                                "0x03D4"
#define  set_ATSC_ADDR_279F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_279F_reg)=data)
#define  get_ATSC_ADDR_279F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_279F_reg))
#define  ATSC_ADDR_279F_er_bound_13_7_shift                                      (0)
#define  ATSC_ADDR_279F_er_bound_13_7_mask                                       (0x0000007F)
#define  ATSC_ADDR_279F_er_bound_13_7(data)                                      (0x0000007F&(data))
#define  ATSC_ADDR_279F_get_er_bound_13_7(data)                                  (0x0000007F&(data))

#define  ATSC_ADDR_27A0                                                         0x18155E80
#define  ATSC_ADDR_27A0_reg_addr                                                 "0xB8155E80"
#define  ATSC_ADDR_27A0_reg                                                      0xB8155E80
#define  ATSC_ADDR_27A0_inst_addr                                                "0x03D5"
#define  set_ATSC_ADDR_27A0_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27A0_reg)=data)
#define  get_ATSC_ADDR_27A0_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27A0_reg))
#define  ATSC_ADDR_27A0_mse_bound_en_shift                                       (0)
#define  ATSC_ADDR_27A0_mse_bound_en_mask                                        (0x00000001)
#define  ATSC_ADDR_27A0_mse_bound_en(data)                                       (0x00000001&(data))
#define  ATSC_ADDR_27A0_get_mse_bound_en(data)                                   (0x00000001&(data))

#define  ATSC_ADDR_27A1                                                         0x18155E84
#define  ATSC_ADDR_27A1_reg_addr                                                 "0xB8155E84"
#define  ATSC_ADDR_27A1_reg                                                      0xB8155E84
#define  ATSC_ADDR_27A1_inst_addr                                                "0x03D6"
#define  set_ATSC_ADDR_27A1_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27A1_reg)=data)
#define  get_ATSC_ADDR_27A1_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27A1_reg))
#define  ATSC_ADDR_27A1_mse_bound_7_0_shift                                      (0)
#define  ATSC_ADDR_27A1_mse_bound_7_0_mask                                       (0x000000FF)
#define  ATSC_ADDR_27A1_mse_bound_7_0(data)                                      (0x000000FF&(data))
#define  ATSC_ADDR_27A1_get_mse_bound_7_0(data)                                  (0x000000FF&(data))

#define  ATSC_ADDR_27A2                                                         0x18155E88
#define  ATSC_ADDR_27A2_reg_addr                                                 "0xB8155E88"
#define  ATSC_ADDR_27A2_reg                                                      0xB8155E88
#define  ATSC_ADDR_27A2_inst_addr                                                "0x03D7"
#define  set_ATSC_ADDR_27A2_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27A2_reg)=data)
#define  get_ATSC_ADDR_27A2_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27A2_reg))
#define  ATSC_ADDR_27A2_mse_bound_15_8_shift                                     (0)
#define  ATSC_ADDR_27A2_mse_bound_15_8_mask                                      (0x000000FF)
#define  ATSC_ADDR_27A2_mse_bound_15_8(data)                                     (0x000000FF&(data))
#define  ATSC_ADDR_27A2_get_mse_bound_15_8(data)                                 (0x000000FF&(data))

#define  ATSC_ADDR_27A3                                                         0x18155E8C
#define  ATSC_ADDR_27A3_reg_addr                                                 "0xB8155E8C"
#define  ATSC_ADDR_27A3_reg                                                      0xB8155E8C
#define  ATSC_ADDR_27A3_inst_addr                                                "0x03D8"
#define  set_ATSC_ADDR_27A3_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27A3_reg)=data)
#define  get_ATSC_ADDR_27A3_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27A3_reg))
#define  ATSC_ADDR_27A3_eqer_final_state_shift                                   (1)
#define  ATSC_ADDR_27A3_mse_th_eq_en_shift                                       (0)
#define  ATSC_ADDR_27A3_eqer_final_state_mask                                    (0x0000007E)
#define  ATSC_ADDR_27A3_mse_th_eq_en_mask                                        (0x00000001)
#define  ATSC_ADDR_27A3_eqer_final_state(data)                                   (0x0000007E&((data)<<1))
#define  ATSC_ADDR_27A3_mse_th_eq_en(data)                                       (0x00000001&(data))
#define  ATSC_ADDR_27A3_get_eqer_final_state(data)                               ((0x0000007E&(data))>>1)
#define  ATSC_ADDR_27A3_get_mse_th_eq_en(data)                                   (0x00000001&(data))

#define  ATSC_ADDR_27A4                                                         0x18155E90
#define  ATSC_ADDR_27A4_reg_addr                                                 "0xB8155E90"
#define  ATSC_ADDR_27A4_reg                                                      0xB8155E90
#define  ATSC_ADDR_27A4_inst_addr                                                "0x03D9"
#define  set_ATSC_ADDR_27A4_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27A4_reg)=data)
#define  get_ATSC_ADDR_27A4_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27A4_reg))
#define  ATSC_ADDR_27A4_mse_th_eq_tr2_7_0_shift                                  (0)
#define  ATSC_ADDR_27A4_mse_th_eq_tr2_7_0_mask                                   (0x000000FF)
#define  ATSC_ADDR_27A4_mse_th_eq_tr2_7_0(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_27A4_get_mse_th_eq_tr2_7_0(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_27A5                                                         0x18155E94
#define  ATSC_ADDR_27A5_reg_addr                                                 "0xB8155E94"
#define  ATSC_ADDR_27A5_reg                                                      0xB8155E94
#define  ATSC_ADDR_27A5_inst_addr                                                "0x03DA"
#define  set_ATSC_ADDR_27A5_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27A5_reg)=data)
#define  get_ATSC_ADDR_27A5_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27A5_reg))
#define  ATSC_ADDR_27A5_mse_th_eq_tr2_15_8_shift                                 (0)
#define  ATSC_ADDR_27A5_mse_th_eq_tr2_15_8_mask                                  (0x000000FF)
#define  ATSC_ADDR_27A5_mse_th_eq_tr2_15_8(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_27A5_get_mse_th_eq_tr2_15_8(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_27A6                                                         0x18155E98
#define  ATSC_ADDR_27A6_reg_addr                                                 "0xB8155E98"
#define  ATSC_ADDR_27A6_reg                                                      0xB8155E98
#define  ATSC_ADDR_27A6_inst_addr                                                "0x03DB"
#define  set_ATSC_ADDR_27A6_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27A6_reg)=data)
#define  get_ATSC_ADDR_27A6_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27A6_reg))
#define  ATSC_ADDR_27A6_mse_th_eq_tr1_7_0_shift                                  (0)
#define  ATSC_ADDR_27A6_mse_th_eq_tr1_7_0_mask                                   (0x000000FF)
#define  ATSC_ADDR_27A6_mse_th_eq_tr1_7_0(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_27A6_get_mse_th_eq_tr1_7_0(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_27A7                                                         0x18155E9C
#define  ATSC_ADDR_27A7_reg_addr                                                 "0xB8155E9C"
#define  ATSC_ADDR_27A7_reg                                                      0xB8155E9C
#define  ATSC_ADDR_27A7_inst_addr                                                "0x03DC"
#define  set_ATSC_ADDR_27A7_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27A7_reg)=data)
#define  get_ATSC_ADDR_27A7_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27A7_reg))
#define  ATSC_ADDR_27A7_mse_th_eq_tr1_15_8_shift                                 (0)
#define  ATSC_ADDR_27A7_mse_th_eq_tr1_15_8_mask                                  (0x000000FF)
#define  ATSC_ADDR_27A7_mse_th_eq_tr1_15_8(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_27A7_get_mse_th_eq_tr1_15_8(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_27A8                                                         0x18155EA0
#define  ATSC_ADDR_27A8_reg_addr                                                 "0xB8155EA0"
#define  ATSC_ADDR_27A8_reg                                                      0xB8155EA0
#define  ATSC_ADDR_27A8_inst_addr                                                "0x03DD"
#define  set_ATSC_ADDR_27A8_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27A8_reg)=data)
#define  get_ATSC_ADDR_27A8_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27A8_reg))
#define  ATSC_ADDR_27A8_mse_th_eq_dd2_7_0_shift                                  (0)
#define  ATSC_ADDR_27A8_mse_th_eq_dd2_7_0_mask                                   (0x000000FF)
#define  ATSC_ADDR_27A8_mse_th_eq_dd2_7_0(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_27A8_get_mse_th_eq_dd2_7_0(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_27A9                                                         0x18155EA4
#define  ATSC_ADDR_27A9_reg_addr                                                 "0xB8155EA4"
#define  ATSC_ADDR_27A9_reg                                                      0xB8155EA4
#define  ATSC_ADDR_27A9_inst_addr                                                "0x03DE"
#define  set_ATSC_ADDR_27A9_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27A9_reg)=data)
#define  get_ATSC_ADDR_27A9_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27A9_reg))
#define  ATSC_ADDR_27A9_mse_th_eq_dd2_15_8_shift                                 (0)
#define  ATSC_ADDR_27A9_mse_th_eq_dd2_15_8_mask                                  (0x000000FF)
#define  ATSC_ADDR_27A9_mse_th_eq_dd2_15_8(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_27A9_get_mse_th_eq_dd2_15_8(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_27AA                                                         0x18155EA8
#define  ATSC_ADDR_27AA_reg_addr                                                 "0xB8155EA8"
#define  ATSC_ADDR_27AA_reg                                                      0xB8155EA8
#define  ATSC_ADDR_27AA_inst_addr                                                "0x03DF"
#define  set_ATSC_ADDR_27AA_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27AA_reg)=data)
#define  get_ATSC_ADDR_27AA_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27AA_reg))
#define  ATSC_ADDR_27AA_mse_th_eq_dd1_7_0_shift                                  (0)
#define  ATSC_ADDR_27AA_mse_th_eq_dd1_7_0_mask                                   (0x000000FF)
#define  ATSC_ADDR_27AA_mse_th_eq_dd1_7_0(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_27AA_get_mse_th_eq_dd1_7_0(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_27AB                                                         0x18155EAC
#define  ATSC_ADDR_27AB_reg_addr                                                 "0xB8155EAC"
#define  ATSC_ADDR_27AB_reg                                                      0xB8155EAC
#define  ATSC_ADDR_27AB_inst_addr                                                "0x03E0"
#define  set_ATSC_ADDR_27AB_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27AB_reg)=data)
#define  get_ATSC_ADDR_27AB_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27AB_reg))
#define  ATSC_ADDR_27AB_mse_th_eq_dd1_15_8_shift                                 (0)
#define  ATSC_ADDR_27AB_mse_th_eq_dd1_15_8_mask                                  (0x000000FF)
#define  ATSC_ADDR_27AB_mse_th_eq_dd1_15_8(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_27AB_get_mse_th_eq_dd1_15_8(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_27AC                                                         0x18155EB0
#define  ATSC_ADDR_27AC_reg_addr                                                 "0xB8155EB0"
#define  ATSC_ADDR_27AC_reg                                                      0xB8155EB0
#define  ATSC_ADDR_27AC_inst_addr                                                "0x03E1"
#define  set_ATSC_ADDR_27AC_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27AC_reg)=data)
#define  get_ATSC_ADDR_27AC_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27AC_reg))
#define  ATSC_ADDR_27AC_ffe_exp_tr0_1_0_shift                                    (6)
#define  ATSC_ADDR_27AC_ffe_exp_tr1_shift                                        (3)
#define  ATSC_ADDR_27AC_ffe_exp_tr2_shift                                        (0)
#define  ATSC_ADDR_27AC_ffe_exp_tr0_1_0_mask                                     (0x000000C0)
#define  ATSC_ADDR_27AC_ffe_exp_tr1_mask                                         (0x00000038)
#define  ATSC_ADDR_27AC_ffe_exp_tr2_mask                                         (0x00000007)
#define  ATSC_ADDR_27AC_ffe_exp_tr0_1_0(data)                                    (0x000000C0&((data)<<6))
#define  ATSC_ADDR_27AC_ffe_exp_tr1(data)                                        (0x00000038&((data)<<3))
#define  ATSC_ADDR_27AC_ffe_exp_tr2(data)                                        (0x00000007&(data))
#define  ATSC_ADDR_27AC_get_ffe_exp_tr0_1_0(data)                                ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_27AC_get_ffe_exp_tr1(data)                                    ((0x00000038&(data))>>3)
#define  ATSC_ADDR_27AC_get_ffe_exp_tr2(data)                                    (0x00000007&(data))

#define  ATSC_ADDR_27AD                                                         0x18155EB4
#define  ATSC_ADDR_27AD_reg_addr                                                 "0xB8155EB4"
#define  ATSC_ADDR_27AD_reg                                                      0xB8155EB4
#define  ATSC_ADDR_27AD_inst_addr                                                "0x03E2"
#define  set_ATSC_ADDR_27AD_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27AD_reg)=data)
#define  get_ATSC_ADDR_27AD_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27AD_reg))
#define  ATSC_ADDR_27AD_ffe_exp_dd0_0_shift                                      (7)
#define  ATSC_ADDR_27AD_ffe_exp_dd1_shift                                        (4)
#define  ATSC_ADDR_27AD_ffe_exp_dd2_shift                                        (1)
#define  ATSC_ADDR_27AD_ffe_exp_tr0_2_shift                                      (0)
#define  ATSC_ADDR_27AD_ffe_exp_dd0_0_mask                                       (0x00000080)
#define  ATSC_ADDR_27AD_ffe_exp_dd1_mask                                         (0x00000070)
#define  ATSC_ADDR_27AD_ffe_exp_dd2_mask                                         (0x0000000E)
#define  ATSC_ADDR_27AD_ffe_exp_tr0_2_mask                                       (0x00000001)
#define  ATSC_ADDR_27AD_ffe_exp_dd0_0(data)                                      (0x00000080&((data)<<7))
#define  ATSC_ADDR_27AD_ffe_exp_dd1(data)                                        (0x00000070&((data)<<4))
#define  ATSC_ADDR_27AD_ffe_exp_dd2(data)                                        (0x0000000E&((data)<<1))
#define  ATSC_ADDR_27AD_ffe_exp_tr0_2(data)                                      (0x00000001&(data))
#define  ATSC_ADDR_27AD_get_ffe_exp_dd0_0(data)                                  ((0x00000080&(data))>>7)
#define  ATSC_ADDR_27AD_get_ffe_exp_dd1(data)                                    ((0x00000070&(data))>>4)
#define  ATSC_ADDR_27AD_get_ffe_exp_dd2(data)                                    ((0x0000000E&(data))>>1)
#define  ATSC_ADDR_27AD_get_ffe_exp_tr0_2(data)                                  (0x00000001&(data))

#define  ATSC_ADDR_27AE                                                         0x18155EB8
#define  ATSC_ADDR_27AE_reg_addr                                                 "0xB8155EB8"
#define  ATSC_ADDR_27AE_reg                                                      0xB8155EB8
#define  ATSC_ADDR_27AE_inst_addr                                                "0x03E3"
#define  set_ATSC_ADDR_27AE_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27AE_reg)=data)
#define  get_ATSC_ADDR_27AE_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27AE_reg))
#define  ATSC_ADDR_27AE_fbf_exp_tr1_shift                                        (5)
#define  ATSC_ADDR_27AE_fbf_exp_tr2_shift                                        (2)
#define  ATSC_ADDR_27AE_ffe_exp_dd0_2_1_shift                                    (0)
#define  ATSC_ADDR_27AE_fbf_exp_tr1_mask                                         (0x000000E0)
#define  ATSC_ADDR_27AE_fbf_exp_tr2_mask                                         (0x0000001C)
#define  ATSC_ADDR_27AE_ffe_exp_dd0_2_1_mask                                     (0x00000003)
#define  ATSC_ADDR_27AE_fbf_exp_tr1(data)                                        (0x000000E0&((data)<<5))
#define  ATSC_ADDR_27AE_fbf_exp_tr2(data)                                        (0x0000001C&((data)<<2))
#define  ATSC_ADDR_27AE_ffe_exp_dd0_2_1(data)                                    (0x00000003&(data))
#define  ATSC_ADDR_27AE_get_fbf_exp_tr1(data)                                    ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_27AE_get_fbf_exp_tr2(data)                                    ((0x0000001C&(data))>>2)
#define  ATSC_ADDR_27AE_get_ffe_exp_dd0_2_1(data)                                (0x00000003&(data))

#define  ATSC_ADDR_27AF                                                         0x18155EBC
#define  ATSC_ADDR_27AF_reg_addr                                                 "0xB8155EBC"
#define  ATSC_ADDR_27AF_reg                                                      0xB8155EBC
#define  ATSC_ADDR_27AF_inst_addr                                                "0x03E4"
#define  set_ATSC_ADDR_27AF_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27AF_reg)=data)
#define  get_ATSC_ADDR_27AF_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27AF_reg))
#define  ATSC_ADDR_27AF_fbf_exp_dd1_1_0_shift                                    (6)
#define  ATSC_ADDR_27AF_fbf_exp_dd2_shift                                        (3)
#define  ATSC_ADDR_27AF_fbf_exp_tr0_shift                                        (0)
#define  ATSC_ADDR_27AF_fbf_exp_dd1_1_0_mask                                     (0x000000C0)
#define  ATSC_ADDR_27AF_fbf_exp_dd2_mask                                         (0x00000038)
#define  ATSC_ADDR_27AF_fbf_exp_tr0_mask                                         (0x00000007)
#define  ATSC_ADDR_27AF_fbf_exp_dd1_1_0(data)                                    (0x000000C0&((data)<<6))
#define  ATSC_ADDR_27AF_fbf_exp_dd2(data)                                        (0x00000038&((data)<<3))
#define  ATSC_ADDR_27AF_fbf_exp_tr0(data)                                        (0x00000007&(data))
#define  ATSC_ADDR_27AF_get_fbf_exp_dd1_1_0(data)                                ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_27AF_get_fbf_exp_dd2(data)                                    ((0x00000038&(data))>>3)
#define  ATSC_ADDR_27AF_get_fbf_exp_tr0(data)                                    (0x00000007&(data))

#define  ATSC_ADDR_27B0                                                         0x18155EC0
#define  ATSC_ADDR_27B0_reg_addr                                                 "0xB8155EC0"
#define  ATSC_ADDR_27B0_reg                                                      0xB8155EC0
#define  ATSC_ADDR_27B0_inst_addr                                                "0x03E5"
#define  set_ATSC_ADDR_27B0_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27B0_reg)=data)
#define  get_ATSC_ADDR_27B0_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27B0_reg))
#define  ATSC_ADDR_27B0_fbf_exp_dd0_shift                                        (1)
#define  ATSC_ADDR_27B0_fbf_exp_dd1_2_shift                                      (0)
#define  ATSC_ADDR_27B0_fbf_exp_dd0_mask                                         (0x0000000E)
#define  ATSC_ADDR_27B0_fbf_exp_dd1_2_mask                                       (0x00000001)
#define  ATSC_ADDR_27B0_fbf_exp_dd0(data)                                        (0x0000000E&((data)<<1))
#define  ATSC_ADDR_27B0_fbf_exp_dd1_2(data)                                      (0x00000001&(data))
#define  ATSC_ADDR_27B0_get_fbf_exp_dd0(data)                                    ((0x0000000E&(data))>>1)
#define  ATSC_ADDR_27B0_get_fbf_exp_dd1_2(data)                                  (0x00000001&(data))

#define  ATSC_ADDR_27B1                                                         0x18155EC4
#define  ATSC_ADDR_27B1_reg_addr                                                 "0xB8155EC4"
#define  ATSC_ADDR_27B1_reg                                                      0xB8155EC4
#define  ATSC_ADDR_27B1_inst_addr                                                "0x03E6"
#define  set_ATSC_ADDR_27B1_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27B1_reg)=data)
#define  get_ATSC_ADDR_27B1_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27B1_reg))
#define  ATSC_ADDR_27B1_ffe_leak_cnt_max_shift                                   (0)
#define  ATSC_ADDR_27B1_ffe_leak_cnt_max_mask                                    (0x000000FF)
#define  ATSC_ADDR_27B1_ffe_leak_cnt_max(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_27B1_get_ffe_leak_cnt_max(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_27B2                                                         0x18155EC8
#define  ATSC_ADDR_27B2_reg_addr                                                 "0xB8155EC8"
#define  ATSC_ADDR_27B2_reg                                                      0xB8155EC8
#define  ATSC_ADDR_27B2_inst_addr                                                "0x03E7"
#define  set_ATSC_ADDR_27B2_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27B2_reg)=data)
#define  get_ATSC_ADDR_27B2_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27B2_reg))
#define  ATSC_ADDR_27B2_fbf_leak_en_shift                                        (1)
#define  ATSC_ADDR_27B2_ffe_leak_en_shift                                        (0)
#define  ATSC_ADDR_27B2_fbf_leak_en_mask                                         (0x00000002)
#define  ATSC_ADDR_27B2_ffe_leak_en_mask                                         (0x00000001)
#define  ATSC_ADDR_27B2_fbf_leak_en(data)                                        (0x00000002&((data)<<1))
#define  ATSC_ADDR_27B2_ffe_leak_en(data)                                        (0x00000001&(data))
#define  ATSC_ADDR_27B2_get_fbf_leak_en(data)                                    ((0x00000002&(data))>>1)
#define  ATSC_ADDR_27B2_get_ffe_leak_en(data)                                    (0x00000001&(data))

#define  ATSC_ADDR_27B3                                                         0x18155ECC
#define  ATSC_ADDR_27B3_reg_addr                                                 "0xB8155ECC"
#define  ATSC_ADDR_27B3_reg                                                      0xB8155ECC
#define  ATSC_ADDR_27B3_inst_addr                                                "0x03E8"
#define  set_ATSC_ADDR_27B3_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27B3_reg)=data)
#define  get_ATSC_ADDR_27B3_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27B3_reg))
#define  ATSC_ADDR_27B3_ffe_leak_val_7_0_shift                                   (0)
#define  ATSC_ADDR_27B3_ffe_leak_val_7_0_mask                                    (0x000000FF)
#define  ATSC_ADDR_27B3_ffe_leak_val_7_0(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_27B3_get_ffe_leak_val_7_0(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_27B4                                                         0x18155ED0
#define  ATSC_ADDR_27B4_reg_addr                                                 "0xB8155ED0"
#define  ATSC_ADDR_27B4_reg                                                      0xB8155ED0
#define  ATSC_ADDR_27B4_inst_addr                                                "0x03E9"
#define  set_ATSC_ADDR_27B4_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27B4_reg)=data)
#define  get_ATSC_ADDR_27B4_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27B4_reg))
#define  ATSC_ADDR_27B4_ffe_leak_val_15_8_shift                                  (0)
#define  ATSC_ADDR_27B4_ffe_leak_val_15_8_mask                                   (0x000000FF)
#define  ATSC_ADDR_27B4_ffe_leak_val_15_8(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_27B4_get_ffe_leak_val_15_8(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_27B5                                                         0x18155ED4
#define  ATSC_ADDR_27B5_reg_addr                                                 "0xB8155ED4"
#define  ATSC_ADDR_27B5_reg                                                      0xB8155ED4
#define  ATSC_ADDR_27B5_inst_addr                                                "0x03EA"
#define  set_ATSC_ADDR_27B5_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27B5_reg)=data)
#define  get_ATSC_ADDR_27B5_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27B5_reg))
#define  ATSC_ADDR_27B5_fbf_leak_cnt_max_shift                                   (0)
#define  ATSC_ADDR_27B5_fbf_leak_cnt_max_mask                                    (0x000000FF)
#define  ATSC_ADDR_27B5_fbf_leak_cnt_max(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_27B5_get_fbf_leak_cnt_max(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_27B6                                                         0x18155ED8
#define  ATSC_ADDR_27B6_reg_addr                                                 "0xB8155ED8"
#define  ATSC_ADDR_27B6_reg                                                      0xB8155ED8
#define  ATSC_ADDR_27B6_inst_addr                                                "0x03EB"
#define  set_ATSC_ADDR_27B6_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27B6_reg)=data)
#define  get_ATSC_ADDR_27B6_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27B6_reg))
#define  ATSC_ADDR_27B6_fbf_leak_val_7_0_shift                                   (0)
#define  ATSC_ADDR_27B6_fbf_leak_val_7_0_mask                                    (0x000000FF)
#define  ATSC_ADDR_27B6_fbf_leak_val_7_0(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_27B6_get_fbf_leak_val_7_0(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_27B7                                                         0x18155EDC
#define  ATSC_ADDR_27B7_reg_addr                                                 "0xB8155EDC"
#define  ATSC_ADDR_27B7_reg                                                      0xB8155EDC
#define  ATSC_ADDR_27B7_inst_addr                                                "0x03EC"
#define  set_ATSC_ADDR_27B7_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27B7_reg)=data)
#define  get_ATSC_ADDR_27B7_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27B7_reg))
#define  ATSC_ADDR_27B7_fbf_leak_val_15_8_shift                                  (0)
#define  ATSC_ADDR_27B7_fbf_leak_val_15_8_mask                                   (0x000000FF)
#define  ATSC_ADDR_27B7_fbf_leak_val_15_8(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_27B7_get_fbf_leak_val_15_8(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_27B8                                                         0x18155EE0
#define  ATSC_ADDR_27B8_reg_addr                                                 "0xB8155EE0"
#define  ATSC_ADDR_27B8_reg                                                      0xB8155EE0
#define  ATSC_ADDR_27B8_inst_addr                                                "0x03ED"
#define  set_ATSC_ADDR_27B8_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27B8_reg)=data)
#define  get_ATSC_ADDR_27B8_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27B8_reg))
#define  ATSC_ADDR_27B8_eqer_mse_zd_viterbi_sel_shift                            (6)
#define  ATSC_ADDR_27B8_eqer_mse_stepsize_sel_shift                              (4)
#define  ATSC_ADDR_27B8_eqer_mse_bound_sel_shift                                 (0)
#define  ATSC_ADDR_27B8_eqer_mse_zd_viterbi_sel_mask                             (0x000000C0)
#define  ATSC_ADDR_27B8_eqer_mse_stepsize_sel_mask                               (0x00000030)
#define  ATSC_ADDR_27B8_eqer_mse_bound_sel_mask                                  (0x00000003)
#define  ATSC_ADDR_27B8_eqer_mse_zd_viterbi_sel(data)                            (0x000000C0&((data)<<6))
#define  ATSC_ADDR_27B8_eqer_mse_stepsize_sel(data)                              (0x00000030&((data)<<4))
#define  ATSC_ADDR_27B8_eqer_mse_bound_sel(data)                                 (0x00000003&(data))
#define  ATSC_ADDR_27B8_get_eqer_mse_zd_viterbi_sel(data)                        ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_27B8_get_eqer_mse_stepsize_sel(data)                          ((0x00000030&(data))>>4)
#define  ATSC_ADDR_27B8_get_eqer_mse_bound_sel(data)                             (0x00000003&(data))

#define  ATSC_ADDR_27B9                                                         0x18155EE4
#define  ATSC_ADDR_27B9_reg_addr                                                 "0xB8155EE4"
#define  ATSC_ADDR_27B9_reg                                                      0xB8155EE4
#define  ATSC_ADDR_27B9_inst_addr                                                "0x03EE"
#define  set_ATSC_ADDR_27B9_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27B9_reg)=data)
#define  get_ATSC_ADDR_27B9_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27B9_reg))
#define  ATSC_ADDR_27B9_eqer_blind_type_sel_shift                                (6)
#define  ATSC_ADDR_27B9_eqer_sato_pwr_sel_shift                                  (4)
#define  ATSC_ADDR_27B9_eqer_godard_pwr_sel_shift                                (2)
#define  ATSC_ADDR_27B9_eqer_pwr_sel_shift                                       (0)
#define  ATSC_ADDR_27B9_eqer_blind_type_sel_mask                                 (0x00000040)
#define  ATSC_ADDR_27B9_eqer_sato_pwr_sel_mask                                   (0x00000030)
#define  ATSC_ADDR_27B9_eqer_godard_pwr_sel_mask                                 (0x0000000C)
#define  ATSC_ADDR_27B9_eqer_pwr_sel_mask                                        (0x00000003)
#define  ATSC_ADDR_27B9_eqer_blind_type_sel(data)                                (0x00000040&((data)<<6))
#define  ATSC_ADDR_27B9_eqer_sato_pwr_sel(data)                                  (0x00000030&((data)<<4))
#define  ATSC_ADDR_27B9_eqer_godard_pwr_sel(data)                                (0x0000000C&((data)<<2))
#define  ATSC_ADDR_27B9_eqer_pwr_sel(data)                                       (0x00000003&(data))
#define  ATSC_ADDR_27B9_get_eqer_blind_type_sel(data)                            ((0x00000040&(data))>>6)
#define  ATSC_ADDR_27B9_get_eqer_sato_pwr_sel(data)                              ((0x00000030&(data))>>4)
#define  ATSC_ADDR_27B9_get_eqer_godard_pwr_sel(data)                            ((0x0000000C&(data))>>2)
#define  ATSC_ADDR_27B9_get_eqer_pwr_sel(data)                                   (0x00000003&(data))

#define  ATSC_ADDR_27C0                                                         0x18155F00
#define  ATSC_ADDR_27C0_reg_addr                                                 "0xB8155F00"
#define  ATSC_ADDR_27C0_reg                                                      0xB8155F00
#define  ATSC_ADDR_27C0_inst_addr                                                "0x03EF"
#define  set_ATSC_ADDR_27C0_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27C0_reg)=data)
#define  get_ATSC_ADDR_27C0_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27C0_reg))
#define  ATSC_ADDR_27C0_eqer_msectrl_mse_sel_0_shift                             (5)
#define  ATSC_ADDR_27C0_eqer_msectrl_mse_sel_1_shift                             (3)
#define  ATSC_ADDR_27C0_eqer_msectrl_mse_sel_2_shift                             (1)
#define  ATSC_ADDR_27C0_eqer_msectrl_en_shift                                    (0)
#define  ATSC_ADDR_27C0_eqer_msectrl_mse_sel_0_mask                              (0x00000060)
#define  ATSC_ADDR_27C0_eqer_msectrl_mse_sel_1_mask                              (0x00000018)
#define  ATSC_ADDR_27C0_eqer_msectrl_mse_sel_2_mask                              (0x00000006)
#define  ATSC_ADDR_27C0_eqer_msectrl_en_mask                                     (0x00000001)
#define  ATSC_ADDR_27C0_eqer_msectrl_mse_sel_0(data)                             (0x00000060&((data)<<5))
#define  ATSC_ADDR_27C0_eqer_msectrl_mse_sel_1(data)                             (0x00000018&((data)<<3))
#define  ATSC_ADDR_27C0_eqer_msectrl_mse_sel_2(data)                             (0x00000006&((data)<<1))
#define  ATSC_ADDR_27C0_eqer_msectrl_en(data)                                    (0x00000001&(data))
#define  ATSC_ADDR_27C0_get_eqer_msectrl_mse_sel_0(data)                         ((0x00000060&(data))>>5)
#define  ATSC_ADDR_27C0_get_eqer_msectrl_mse_sel_1(data)                         ((0x00000018&(data))>>3)
#define  ATSC_ADDR_27C0_get_eqer_msectrl_mse_sel_2(data)                         ((0x00000006&(data))>>1)
#define  ATSC_ADDR_27C0_get_eqer_msectrl_en(data)                                (0x00000001&(data))

#define  ATSC_ADDR_27C1                                                         0x18155F04
#define  ATSC_ADDR_27C1_reg_addr                                                 "0xB8155F04"
#define  ATSC_ADDR_27C1_reg                                                      0xB8155F04
#define  ATSC_ADDR_27C1_inst_addr                                                "0x03F0"
#define  set_ATSC_ADDR_27C1_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27C1_reg)=data)
#define  get_ATSC_ADDR_27C1_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27C1_reg))
#define  ATSC_ADDR_27C1_eqer_msectrl_er_type_sel_1_1_0_shift                     (6)
#define  ATSC_ADDR_27C1_eqer_msectrl_er_type_sel_2_shift                         (3)
#define  ATSC_ADDR_27C1_eqer_msectrl_er_type_sel_3_shift                         (0)
#define  ATSC_ADDR_27C1_eqer_msectrl_er_type_sel_1_1_0_mask                      (0x000000C0)
#define  ATSC_ADDR_27C1_eqer_msectrl_er_type_sel_2_mask                          (0x00000038)
#define  ATSC_ADDR_27C1_eqer_msectrl_er_type_sel_3_mask                          (0x00000007)
#define  ATSC_ADDR_27C1_eqer_msectrl_er_type_sel_1_1_0(data)                     (0x000000C0&((data)<<6))
#define  ATSC_ADDR_27C1_eqer_msectrl_er_type_sel_2(data)                         (0x00000038&((data)<<3))
#define  ATSC_ADDR_27C1_eqer_msectrl_er_type_sel_3(data)                         (0x00000007&(data))
#define  ATSC_ADDR_27C1_get_eqer_msectrl_er_type_sel_1_1_0(data)                 ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_27C1_get_eqer_msectrl_er_type_sel_2(data)                     ((0x00000038&(data))>>3)
#define  ATSC_ADDR_27C1_get_eqer_msectrl_er_type_sel_3(data)                     (0x00000007&(data))

#define  ATSC_ADDR_27C2                                                         0x18155F08
#define  ATSC_ADDR_27C2_reg_addr                                                 "0xB8155F08"
#define  ATSC_ADDR_27C2_reg                                                      0xB8155F08
#define  ATSC_ADDR_27C2_inst_addr                                                "0x03F1"
#define  set_ATSC_ADDR_27C2_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27C2_reg)=data)
#define  get_ATSC_ADDR_27C2_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27C2_reg))
#define  ATSC_ADDR_27C2_eqer_msectrl_er_type_sel_0_shift                         (1)
#define  ATSC_ADDR_27C2_eqer_msectrl_er_type_sel_1_2_shift                       (0)
#define  ATSC_ADDR_27C2_eqer_msectrl_er_type_sel_0_mask                          (0x0000000E)
#define  ATSC_ADDR_27C2_eqer_msectrl_er_type_sel_1_2_mask                        (0x00000001)
#define  ATSC_ADDR_27C2_eqer_msectrl_er_type_sel_0(data)                         (0x0000000E&((data)<<1))
#define  ATSC_ADDR_27C2_eqer_msectrl_er_type_sel_1_2(data)                       (0x00000001&(data))
#define  ATSC_ADDR_27C2_get_eqer_msectrl_er_type_sel_0(data)                     ((0x0000000E&(data))>>1)
#define  ATSC_ADDR_27C2_get_eqer_msectrl_er_type_sel_1_2(data)                   (0x00000001&(data))

#define  ATSC_ADDR_27C3                                                         0x18155F0C
#define  ATSC_ADDR_27C3_reg_addr                                                 "0xB8155F0C"
#define  ATSC_ADDR_27C3_reg                                                      0xB8155F0C
#define  ATSC_ADDR_27C3_inst_addr                                                "0x03F2"
#define  set_ATSC_ADDR_27C3_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27C3_reg)=data)
#define  get_ATSC_ADDR_27C3_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27C3_reg))
#define  ATSC_ADDR_27C3_eqer_msectrl_mse_th_2_7_0_shift                          (0)
#define  ATSC_ADDR_27C3_eqer_msectrl_mse_th_2_7_0_mask                           (0x000000FF)
#define  ATSC_ADDR_27C3_eqer_msectrl_mse_th_2_7_0(data)                          (0x000000FF&(data))
#define  ATSC_ADDR_27C3_get_eqer_msectrl_mse_th_2_7_0(data)                      (0x000000FF&(data))

#define  ATSC_ADDR_27C4                                                         0x18155F10
#define  ATSC_ADDR_27C4_reg_addr                                                 "0xB8155F10"
#define  ATSC_ADDR_27C4_reg                                                      0xB8155F10
#define  ATSC_ADDR_27C4_inst_addr                                                "0x03F3"
#define  set_ATSC_ADDR_27C4_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27C4_reg)=data)
#define  get_ATSC_ADDR_27C4_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27C4_reg))
#define  ATSC_ADDR_27C4_eqer_msectrl_mse_th_2_15_8_shift                         (0)
#define  ATSC_ADDR_27C4_eqer_msectrl_mse_th_2_15_8_mask                          (0x000000FF)
#define  ATSC_ADDR_27C4_eqer_msectrl_mse_th_2_15_8(data)                         (0x000000FF&(data))
#define  ATSC_ADDR_27C4_get_eqer_msectrl_mse_th_2_15_8(data)                     (0x000000FF&(data))

#define  ATSC_ADDR_27C5                                                         0x18155F14
#define  ATSC_ADDR_27C5_reg_addr                                                 "0xB8155F14"
#define  ATSC_ADDR_27C5_reg                                                      0xB8155F14
#define  ATSC_ADDR_27C5_inst_addr                                                "0x03F4"
#define  set_ATSC_ADDR_27C5_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27C5_reg)=data)
#define  get_ATSC_ADDR_27C5_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27C5_reg))
#define  ATSC_ADDR_27C5_eqer_msectrl_mse_th_1_7_0_shift                          (0)
#define  ATSC_ADDR_27C5_eqer_msectrl_mse_th_1_7_0_mask                           (0x000000FF)
#define  ATSC_ADDR_27C5_eqer_msectrl_mse_th_1_7_0(data)                          (0x000000FF&(data))
#define  ATSC_ADDR_27C5_get_eqer_msectrl_mse_th_1_7_0(data)                      (0x000000FF&(data))

#define  ATSC_ADDR_27C6                                                         0x18155F18
#define  ATSC_ADDR_27C6_reg_addr                                                 "0xB8155F18"
#define  ATSC_ADDR_27C6_reg                                                      0xB8155F18
#define  ATSC_ADDR_27C6_inst_addr                                                "0x03F5"
#define  set_ATSC_ADDR_27C6_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27C6_reg)=data)
#define  get_ATSC_ADDR_27C6_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27C6_reg))
#define  ATSC_ADDR_27C6_eqer_msectrl_mse_th_1_15_8_shift                         (0)
#define  ATSC_ADDR_27C6_eqer_msectrl_mse_th_1_15_8_mask                          (0x000000FF)
#define  ATSC_ADDR_27C6_eqer_msectrl_mse_th_1_15_8(data)                         (0x000000FF&(data))
#define  ATSC_ADDR_27C6_get_eqer_msectrl_mse_th_1_15_8(data)                     (0x000000FF&(data))

#define  ATSC_ADDR_27C7                                                         0x18155F1C
#define  ATSC_ADDR_27C7_reg_addr                                                 "0xB8155F1C"
#define  ATSC_ADDR_27C7_reg                                                      0xB8155F1C
#define  ATSC_ADDR_27C7_inst_addr                                                "0x03F6"
#define  set_ATSC_ADDR_27C7_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27C7_reg)=data)
#define  get_ATSC_ADDR_27C7_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27C7_reg))
#define  ATSC_ADDR_27C7_eqer_msectrl_mse_th_0_7_0_shift                          (0)
#define  ATSC_ADDR_27C7_eqer_msectrl_mse_th_0_7_0_mask                           (0x000000FF)
#define  ATSC_ADDR_27C7_eqer_msectrl_mse_th_0_7_0(data)                          (0x000000FF&(data))
#define  ATSC_ADDR_27C7_get_eqer_msectrl_mse_th_0_7_0(data)                      (0x000000FF&(data))

#define  ATSC_ADDR_27C8                                                         0x18155F20
#define  ATSC_ADDR_27C8_reg_addr                                                 "0xB8155F20"
#define  ATSC_ADDR_27C8_reg                                                      0xB8155F20
#define  ATSC_ADDR_27C8_inst_addr                                                "0x03F7"
#define  set_ATSC_ADDR_27C8_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27C8_reg)=data)
#define  get_ATSC_ADDR_27C8_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27C8_reg))
#define  ATSC_ADDR_27C8_eqer_msectrl_mse_th_0_15_8_shift                         (0)
#define  ATSC_ADDR_27C8_eqer_msectrl_mse_th_0_15_8_mask                          (0x000000FF)
#define  ATSC_ADDR_27C8_eqer_msectrl_mse_th_0_15_8(data)                         (0x000000FF&(data))
#define  ATSC_ADDR_27C8_get_eqer_msectrl_mse_th_0_15_8(data)                     (0x000000FF&(data))

#define  ATSC_ADDR_27C9                                                         0x18155F24
#define  ATSC_ADDR_27C9_reg_addr                                                 "0xB8155F24"
#define  ATSC_ADDR_27C9_reg                                                      0xB8155F24
#define  ATSC_ADDR_27C9_inst_addr                                                "0x03F8"
#define  set_ATSC_ADDR_27C9_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27C9_reg)=data)
#define  get_ATSC_ADDR_27C9_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27C9_reg))
#define  ATSC_ADDR_27C9_eq_fifo_discard_ind_clear_shift                          (7)
#define  ATSC_ADDR_27C9_eq_fifo_full_ind_sel_shift                               (6)
#define  ATSC_ADDR_27C9_eq_fifo_full_ind_clear_shift                             (5)
#define  ATSC_ADDR_27C9_eq_fifo_size_shift                                       (2)
#define  ATSC_ADDR_27C9_eqer_mse_er_type_sel_shift                               (1)
#define  ATSC_ADDR_27C9_eqer_dd_er_type_sel_shift                                (0)
#define  ATSC_ADDR_27C9_eq_fifo_discard_ind_clear_mask                           (0x00000080)
#define  ATSC_ADDR_27C9_eq_fifo_full_ind_sel_mask                                (0x00000040)
#define  ATSC_ADDR_27C9_eq_fifo_full_ind_clear_mask                              (0x00000020)
#define  ATSC_ADDR_27C9_eq_fifo_size_mask                                        (0x0000001C)
#define  ATSC_ADDR_27C9_eqer_mse_er_type_sel_mask                                (0x00000002)
#define  ATSC_ADDR_27C9_eqer_dd_er_type_sel_mask                                 (0x00000001)
#define  ATSC_ADDR_27C9_eq_fifo_discard_ind_clear(data)                          (0x00000080&((data)<<7))
#define  ATSC_ADDR_27C9_eq_fifo_full_ind_sel(data)                               (0x00000040&((data)<<6))
#define  ATSC_ADDR_27C9_eq_fifo_full_ind_clear(data)                             (0x00000020&((data)<<5))
#define  ATSC_ADDR_27C9_eq_fifo_size(data)                                       (0x0000001C&((data)<<2))
#define  ATSC_ADDR_27C9_eqer_mse_er_type_sel(data)                               (0x00000002&((data)<<1))
#define  ATSC_ADDR_27C9_eqer_dd_er_type_sel(data)                                (0x00000001&(data))
#define  ATSC_ADDR_27C9_get_eq_fifo_discard_ind_clear(data)                      ((0x00000080&(data))>>7)
#define  ATSC_ADDR_27C9_get_eq_fifo_full_ind_sel(data)                           ((0x00000040&(data))>>6)
#define  ATSC_ADDR_27C9_get_eq_fifo_full_ind_clear(data)                         ((0x00000020&(data))>>5)
#define  ATSC_ADDR_27C9_get_eq_fifo_size(data)                                   ((0x0000001C&(data))>>2)
#define  ATSC_ADDR_27C9_get_eqer_mse_er_type_sel(data)                           ((0x00000002&(data))>>1)
#define  ATSC_ADDR_27C9_get_eqer_dd_er_type_sel(data)                            (0x00000001&(data))

#define  ATSC_ADDR_27CA                                                         0x18155F28
#define  ATSC_ADDR_27CA_reg_addr                                                 "0xB8155F28"
#define  ATSC_ADDR_27CA_reg                                                      0xB8155F28
#define  ATSC_ADDR_27CA_inst_addr                                                "0x03F9"
#define  set_ATSC_ADDR_27CA_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27CA_reg)=data)
#define  get_ATSC_ADDR_27CA_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27CA_reg))
#define  ATSC_ADDR_27CA_ffe_in_scale_shift                                       (0)
#define  ATSC_ADDR_27CA_ffe_in_scale_mask                                        (0x000000FF)
#define  ATSC_ADDR_27CA_ffe_in_scale(data)                                       (0x000000FF&(data))
#define  ATSC_ADDR_27CA_get_ffe_in_scale(data)                                   (0x000000FF&(data))

#define  ATSC_ADDR_27CB                                                         0x18155F2C
#define  ATSC_ADDR_27CB_reg_addr                                                 "0xB8155F2C"
#define  ATSC_ADDR_27CB_reg                                                      0xB8155F2C
#define  ATSC_ADDR_27CB_inst_addr                                                "0x03FA"
#define  set_ATSC_ADDR_27CB_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27CB_reg)=data)
#define  get_ATSC_ADDR_27CB_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27CB_reg))
#define  ATSC_ADDR_27CB_zd_viterbi_stage_en_4_0_shift                            (3)
#define  ATSC_ADDR_27CB_zd_viterbi_stage_en_4_0_mask                             (0x000000F8)
#define  ATSC_ADDR_27CB_zd_viterbi_stage_en_4_0(data)                            (0x000000F8&((data)<<3))
#define  ATSC_ADDR_27CB_get_zd_viterbi_stage_en_4_0(data)                        ((0x000000F8&(data))>>3)

#define  ATSC_ADDR_27CC                                                         0x18155F30
#define  ATSC_ADDR_27CC_reg_addr                                                 "0xB8155F30"
#define  ATSC_ADDR_27CC_reg                                                      0xB8155F30
#define  ATSC_ADDR_27CC_inst_addr                                                "0x03FB"
#define  set_ATSC_ADDR_27CC_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27CC_reg)=data)
#define  get_ATSC_ADDR_27CC_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27CC_reg))
#define  ATSC_ADDR_27CC_zd_viterbi_stage_en_9_5_shift                            (3)
#define  ATSC_ADDR_27CC_zd_viterbi_mse_en_shift                                  (2)
#define  ATSC_ADDR_27CC_zd_viterbi_en_shift                                      (1)
#define  ATSC_ADDR_27CC_segment_sync_en_shift                                    (0)
#define  ATSC_ADDR_27CC_zd_viterbi_stage_en_9_5_mask                             (0x000000F8)
#define  ATSC_ADDR_27CC_zd_viterbi_mse_en_mask                                   (0x00000004)
#define  ATSC_ADDR_27CC_zd_viterbi_en_mask                                       (0x00000002)
#define  ATSC_ADDR_27CC_segment_sync_en_mask                                     (0x00000001)
#define  ATSC_ADDR_27CC_zd_viterbi_stage_en_9_5(data)                            (0x000000F8&((data)<<3))
#define  ATSC_ADDR_27CC_zd_viterbi_mse_en(data)                                  (0x00000004&((data)<<2))
#define  ATSC_ADDR_27CC_zd_viterbi_en(data)                                      (0x00000002&((data)<<1))
#define  ATSC_ADDR_27CC_segment_sync_en(data)                                    (0x00000001&(data))
#define  ATSC_ADDR_27CC_get_zd_viterbi_stage_en_9_5(data)                        ((0x000000F8&(data))>>3)
#define  ATSC_ADDR_27CC_get_zd_viterbi_mse_en(data)                              ((0x00000004&(data))>>2)
#define  ATSC_ADDR_27CC_get_zd_viterbi_en(data)                                  ((0x00000002&(data))>>1)
#define  ATSC_ADDR_27CC_get_segment_sync_en(data)                                (0x00000001&(data))

#define  ATSC_ADDR_27CD                                                         0x18155F34
#define  ATSC_ADDR_27CD_reg_addr                                                 "0xB8155F34"
#define  ATSC_ADDR_27CD_reg                                                      0xB8155F34
#define  ATSC_ADDR_27CD_inst_addr                                                "0x03FC"
#define  set_ATSC_ADDR_27CD_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27CD_reg)=data)
#define  get_ATSC_ADDR_27CD_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27CD_reg))
#define  ATSC_ADDR_27CD_zd_viterbi_mse_th_7_0_shift                              (0)
#define  ATSC_ADDR_27CD_zd_viterbi_mse_th_7_0_mask                               (0x000000FF)
#define  ATSC_ADDR_27CD_zd_viterbi_mse_th_7_0(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_27CD_get_zd_viterbi_mse_th_7_0(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_27CE                                                         0x18155F38
#define  ATSC_ADDR_27CE_reg_addr                                                 "0xB8155F38"
#define  ATSC_ADDR_27CE_reg                                                      0xB8155F38
#define  ATSC_ADDR_27CE_inst_addr                                                "0x03FD"
#define  set_ATSC_ADDR_27CE_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27CE_reg)=data)
#define  get_ATSC_ADDR_27CE_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27CE_reg))
#define  ATSC_ADDR_27CE_zd_viterbi_mse_th_15_8_shift                             (0)
#define  ATSC_ADDR_27CE_zd_viterbi_mse_th_15_8_mask                              (0x000000FF)
#define  ATSC_ADDR_27CE_zd_viterbi_mse_th_15_8(data)                             (0x000000FF&(data))
#define  ATSC_ADDR_27CE_get_zd_viterbi_mse_th_15_8(data)                         (0x000000FF&(data))

#define  ATSC_ADDR_27DA                                                         0x18155F68
#define  ATSC_ADDR_27DA_reg_addr                                                 "0xB8155F68"
#define  ATSC_ADDR_27DA_reg                                                      0xB8155F68
#define  ATSC_ADDR_27DA_inst_addr                                                "0x03FE"
#define  set_ATSC_ADDR_27DA_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27DA_reg)=data)
#define  get_ATSC_ADDR_27DA_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27DA_reg))
#define  ATSC_ADDR_27DA_fbf_mu_bn_slow_shift                                     (5)
#define  ATSC_ADDR_27DA_fbf_mu_bn_slow_en_shift                                  (4)
#define  ATSC_ADDR_27DA_ffe_mu_bn_slow_shift                                     (1)
#define  ATSC_ADDR_27DA_ffe_mu_bn_slow_en_shift                                  (0)
#define  ATSC_ADDR_27DA_fbf_mu_bn_slow_mask                                      (0x000000E0)
#define  ATSC_ADDR_27DA_fbf_mu_bn_slow_en_mask                                   (0x00000010)
#define  ATSC_ADDR_27DA_ffe_mu_bn_slow_mask                                      (0x0000000E)
#define  ATSC_ADDR_27DA_ffe_mu_bn_slow_en_mask                                   (0x00000001)
#define  ATSC_ADDR_27DA_fbf_mu_bn_slow(data)                                     (0x000000E0&((data)<<5))
#define  ATSC_ADDR_27DA_fbf_mu_bn_slow_en(data)                                  (0x00000010&((data)<<4))
#define  ATSC_ADDR_27DA_ffe_mu_bn_slow(data)                                     (0x0000000E&((data)<<1))
#define  ATSC_ADDR_27DA_ffe_mu_bn_slow_en(data)                                  (0x00000001&(data))
#define  ATSC_ADDR_27DA_get_fbf_mu_bn_slow(data)                                 ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_27DA_get_fbf_mu_bn_slow_en(data)                              ((0x00000010&(data))>>4)
#define  ATSC_ADDR_27DA_get_ffe_mu_bn_slow(data)                                 ((0x0000000E&(data))>>1)
#define  ATSC_ADDR_27DA_get_ffe_mu_bn_slow_en(data)                              (0x00000001&(data))

#define  ATSC_ADDR_27DB                                                         0x18155F6C
#define  ATSC_ADDR_27DB_reg_addr                                                 "0xB8155F6C"
#define  ATSC_ADDR_27DB_reg                                                      0xB8155F6C
#define  ATSC_ADDR_27DB_inst_addr                                                "0x03FF"
#define  set_ATSC_ADDR_27DB_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27DB_reg)=data)
#define  get_ATSC_ADDR_27DB_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27DB_reg))
#define  ATSC_ADDR_27DB_mse_th_eq_tr3_7_0_shift                                  (0)
#define  ATSC_ADDR_27DB_mse_th_eq_tr3_7_0_mask                                   (0x000000FF)
#define  ATSC_ADDR_27DB_mse_th_eq_tr3_7_0(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_27DB_get_mse_th_eq_tr3_7_0(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_27DC                                                         0x18155F70
#define  ATSC_ADDR_27DC_reg_addr                                                 "0xB8155F70"
#define  ATSC_ADDR_27DC_reg                                                      0xB8155F70
#define  ATSC_ADDR_27DC_inst_addr                                                "0x0400"
#define  set_ATSC_ADDR_27DC_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27DC_reg)=data)
#define  get_ATSC_ADDR_27DC_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27DC_reg))
#define  ATSC_ADDR_27DC_mse_th_eq_tr3_15_8_shift                                 (0)
#define  ATSC_ADDR_27DC_mse_th_eq_tr3_15_8_mask                                  (0x000000FF)
#define  ATSC_ADDR_27DC_mse_th_eq_tr3_15_8(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_27DC_get_mse_th_eq_tr3_15_8(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_27DD                                                         0x18155F74
#define  ATSC_ADDR_27DD_reg_addr                                                 "0xB8155F74"
#define  ATSC_ADDR_27DD_reg                                                      0xB8155F74
#define  ATSC_ADDR_27DD_inst_addr                                                "0x0401"
#define  set_ATSC_ADDR_27DD_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27DD_reg)=data)
#define  get_ATSC_ADDR_27DD_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27DD_reg))
#define  ATSC_ADDR_27DD_mse_th_eq_dd3_7_0_shift                                  (0)
#define  ATSC_ADDR_27DD_mse_th_eq_dd3_7_0_mask                                   (0x000000FF)
#define  ATSC_ADDR_27DD_mse_th_eq_dd3_7_0(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_27DD_get_mse_th_eq_dd3_7_0(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_27DE                                                         0x18155F78
#define  ATSC_ADDR_27DE_reg_addr                                                 "0xB8155F78"
#define  ATSC_ADDR_27DE_reg                                                      0xB8155F78
#define  ATSC_ADDR_27DE_inst_addr                                                "0x0402"
#define  set_ATSC_ADDR_27DE_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27DE_reg)=data)
#define  get_ATSC_ADDR_27DE_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27DE_reg))
#define  ATSC_ADDR_27DE_mse_th_eq_dd3_15_8_shift                                 (0)
#define  ATSC_ADDR_27DE_mse_th_eq_dd3_15_8_mask                                  (0x000000FF)
#define  ATSC_ADDR_27DE_mse_th_eq_dd3_15_8(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_27DE_get_mse_th_eq_dd3_15_8(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_27DF                                                         0x18155F7C
#define  ATSC_ADDR_27DF_reg_addr                                                 "0xB8155F7C"
#define  ATSC_ADDR_27DF_reg                                                      0xB8155F7C
#define  ATSC_ADDR_27DF_inst_addr                                                "0x0403"
#define  set_ATSC_ADDR_27DF_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27DF_reg)=data)
#define  get_ATSC_ADDR_27DF_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27DF_reg))
#define  ATSC_ADDR_27DF_ffe_exp_dd3_shift                                        (3)
#define  ATSC_ADDR_27DF_ffe_exp_tr3_shift                                        (0)
#define  ATSC_ADDR_27DF_ffe_exp_dd3_mask                                         (0x00000038)
#define  ATSC_ADDR_27DF_ffe_exp_tr3_mask                                         (0x00000007)
#define  ATSC_ADDR_27DF_ffe_exp_dd3(data)                                        (0x00000038&((data)<<3))
#define  ATSC_ADDR_27DF_ffe_exp_tr3(data)                                        (0x00000007&(data))
#define  ATSC_ADDR_27DF_get_ffe_exp_dd3(data)                                    ((0x00000038&(data))>>3)
#define  ATSC_ADDR_27DF_get_ffe_exp_tr3(data)                                    (0x00000007&(data))

#define  ATSC_ADDR_27E0                                                         0x18155F80
#define  ATSC_ADDR_27E0_reg_addr                                                 "0xB8155F80"
#define  ATSC_ADDR_27E0_reg                                                      0xB8155F80
#define  ATSC_ADDR_27E0_inst_addr                                                "0x0404"
#define  set_ATSC_ADDR_27E0_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27E0_reg)=data)
#define  get_ATSC_ADDR_27E0_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27E0_reg))
#define  ATSC_ADDR_27E0_fbf_exp_dd3_shift                                        (3)
#define  ATSC_ADDR_27E0_fbf_exp_tr3_shift                                        (0)
#define  ATSC_ADDR_27E0_fbf_exp_dd3_mask                                         (0x00000038)
#define  ATSC_ADDR_27E0_fbf_exp_tr3_mask                                         (0x00000007)
#define  ATSC_ADDR_27E0_fbf_exp_dd3(data)                                        (0x00000038&((data)<<3))
#define  ATSC_ADDR_27E0_fbf_exp_tr3(data)                                        (0x00000007&(data))
#define  ATSC_ADDR_27E0_get_fbf_exp_dd3(data)                                    ((0x00000038&(data))>>3)
#define  ATSC_ADDR_27E0_get_fbf_exp_tr3(data)                                    (0x00000007&(data))

#define  ATSC_ADDR_27E1                                                         0x18155F84
#define  ATSC_ADDR_27E1_reg_addr                                                 "0xB8155F84"
#define  ATSC_ADDR_27E1_reg                                                      0xB8155F84
#define  ATSC_ADDR_27E1_inst_addr                                                "0x0405"
#define  set_ATSC_ADDR_27E1_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27E1_reg)=data)
#define  get_ATSC_ADDR_27E1_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27E1_reg))
#define  ATSC_ADDR_27E1_fbf_gc_main_protect_en_shift                             (2)
#define  ATSC_ADDR_27E1_fbf_gc_coeff_sum_max_clr_shift                           (1)
#define  ATSC_ADDR_27E1_fbf_gc_en_shift                                          (0)
#define  ATSC_ADDR_27E1_fbf_gc_main_protect_en_mask                              (0x00000004)
#define  ATSC_ADDR_27E1_fbf_gc_coeff_sum_max_clr_mask                            (0x00000002)
#define  ATSC_ADDR_27E1_fbf_gc_en_mask                                           (0x00000001)
#define  ATSC_ADDR_27E1_fbf_gc_main_protect_en(data)                             (0x00000004&((data)<<2))
#define  ATSC_ADDR_27E1_fbf_gc_coeff_sum_max_clr(data)                           (0x00000002&((data)<<1))
#define  ATSC_ADDR_27E1_fbf_gc_en(data)                                          (0x00000001&(data))
#define  ATSC_ADDR_27E1_get_fbf_gc_main_protect_en(data)                         ((0x00000004&(data))>>2)
#define  ATSC_ADDR_27E1_get_fbf_gc_coeff_sum_max_clr(data)                       ((0x00000002&(data))>>1)
#define  ATSC_ADDR_27E1_get_fbf_gc_en(data)                                      (0x00000001&(data))

#define  ATSC_ADDR_27E2                                                         0x18155F88
#define  ATSC_ADDR_27E2_reg_addr                                                 "0xB8155F88"
#define  ATSC_ADDR_27E2_reg                                                      0xB8155F88
#define  ATSC_ADDR_27E2_inst_addr                                                "0x0406"
#define  set_ATSC_ADDR_27E2_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27E2_reg)=data)
#define  get_ATSC_ADDR_27E2_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27E2_reg))
#define  ATSC_ADDR_27E2_fbf_gc_start_field_exp_shift                             (4)
#define  ATSC_ADDR_27E2_fbf_gc_on_field_exp_shift                                (0)
#define  ATSC_ADDR_27E2_fbf_gc_start_field_exp_mask                              (0x000000F0)
#define  ATSC_ADDR_27E2_fbf_gc_on_field_exp_mask                                 (0x0000000F)
#define  ATSC_ADDR_27E2_fbf_gc_start_field_exp(data)                             (0x000000F0&((data)<<4))
#define  ATSC_ADDR_27E2_fbf_gc_on_field_exp(data)                                (0x0000000F&(data))
#define  ATSC_ADDR_27E2_get_fbf_gc_start_field_exp(data)                         ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_27E2_get_fbf_gc_on_field_exp(data)                            (0x0000000F&(data))

#define  ATSC_ADDR_27E3                                                         0x18155F8C
#define  ATSC_ADDR_27E3_reg_addr                                                 "0xB8155F8C"
#define  ATSC_ADDR_27E3_reg                                                      0xB8155F8C
#define  ATSC_ADDR_27E3_inst_addr                                                "0x0407"
#define  set_ATSC_ADDR_27E3_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27E3_reg)=data)
#define  get_ATSC_ADDR_27E3_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27E3_reg))
#define  ATSC_ADDR_27E3_fbf_gc_check_seg_3_0_shift                               (4)
#define  ATSC_ADDR_27E3_fbf_gc_prd_field_exp_shift                               (0)
#define  ATSC_ADDR_27E3_fbf_gc_check_seg_3_0_mask                                (0x000000F0)
#define  ATSC_ADDR_27E3_fbf_gc_prd_field_exp_mask                                (0x0000000F)
#define  ATSC_ADDR_27E3_fbf_gc_check_seg_3_0(data)                               (0x000000F0&((data)<<4))
#define  ATSC_ADDR_27E3_fbf_gc_prd_field_exp(data)                               (0x0000000F&(data))
#define  ATSC_ADDR_27E3_get_fbf_gc_check_seg_3_0(data)                           ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_27E3_get_fbf_gc_prd_field_exp(data)                           (0x0000000F&(data))

#define  ATSC_ADDR_27E4                                                         0x18155F90
#define  ATSC_ADDR_27E4_reg_addr                                                 "0xB8155F90"
#define  ATSC_ADDR_27E4_reg                                                      0xB8155F90
#define  ATSC_ADDR_27E4_inst_addr                                                "0x0408"
#define  set_ATSC_ADDR_27E4_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27E4_reg)=data)
#define  get_ATSC_ADDR_27E4_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27E4_reg))
#define  ATSC_ADDR_27E4_fbf_gc_en_sum_th_0_2_0_shift                             (5)
#define  ATSC_ADDR_27E4_fbf_gc_check_seg_8_4_shift                               (0)
#define  ATSC_ADDR_27E4_fbf_gc_en_sum_th_0_2_0_mask                              (0x000000E0)
#define  ATSC_ADDR_27E4_fbf_gc_check_seg_8_4_mask                                (0x0000001F)
#define  ATSC_ADDR_27E4_fbf_gc_en_sum_th_0_2_0(data)                             (0x000000E0&((data)<<5))
#define  ATSC_ADDR_27E4_fbf_gc_check_seg_8_4(data)                               (0x0000001F&(data))
#define  ATSC_ADDR_27E4_get_fbf_gc_en_sum_th_0_2_0(data)                         ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_27E4_get_fbf_gc_check_seg_8_4(data)                           (0x0000001F&(data))

#define  ATSC_ADDR_27E5                                                         0x18155F94
#define  ATSC_ADDR_27E5_reg_addr                                                 "0xB8155F94"
#define  ATSC_ADDR_27E5_reg                                                      0xB8155F94
#define  ATSC_ADDR_27E5_inst_addr                                                "0x0409"
#define  set_ATSC_ADDR_27E5_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27E5_reg)=data)
#define  get_ATSC_ADDR_27E5_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27E5_reg))
#define  ATSC_ADDR_27E5_fbf_gc_en_sum_th_0_10_3_shift                            (0)
#define  ATSC_ADDR_27E5_fbf_gc_en_sum_th_0_10_3_mask                             (0x000000FF)
#define  ATSC_ADDR_27E5_fbf_gc_en_sum_th_0_10_3(data)                            (0x000000FF&(data))
#define  ATSC_ADDR_27E5_get_fbf_gc_en_sum_th_0_10_3(data)                        (0x000000FF&(data))

#define  ATSC_ADDR_27E6                                                         0x18155F98
#define  ATSC_ADDR_27E6_reg_addr                                                 "0xB8155F98"
#define  ATSC_ADDR_27E6_reg                                                      0xB8155F98
#define  ATSC_ADDR_27E6_inst_addr                                                "0x040A"
#define  set_ATSC_ADDR_27E6_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27E6_reg)=data)
#define  get_ATSC_ADDR_27E6_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27E6_reg))
#define  ATSC_ADDR_27E6_fbf_gc_en_sum_th_1_6_0_shift                             (1)
#define  ATSC_ADDR_27E6_fbf_gc_en_sum_th_0_11_shift                              (0)
#define  ATSC_ADDR_27E6_fbf_gc_en_sum_th_1_6_0_mask                              (0x000000FE)
#define  ATSC_ADDR_27E6_fbf_gc_en_sum_th_0_11_mask                               (0x00000001)
#define  ATSC_ADDR_27E6_fbf_gc_en_sum_th_1_6_0(data)                             (0x000000FE&((data)<<1))
#define  ATSC_ADDR_27E6_fbf_gc_en_sum_th_0_11(data)                              (0x00000001&(data))
#define  ATSC_ADDR_27E6_get_fbf_gc_en_sum_th_1_6_0(data)                         ((0x000000FE&(data))>>1)
#define  ATSC_ADDR_27E6_get_fbf_gc_en_sum_th_0_11(data)                          (0x00000001&(data))

#define  ATSC_ADDR_27E7                                                         0x18155F9C
#define  ATSC_ADDR_27E7_reg_addr                                                 "0xB8155F9C"
#define  ATSC_ADDR_27E7_reg                                                      0xB8155F9C
#define  ATSC_ADDR_27E7_inst_addr                                                "0x040B"
#define  set_ATSC_ADDR_27E7_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27E7_reg)=data)
#define  get_ATSC_ADDR_27E7_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27E7_reg))
#define  ATSC_ADDR_27E7_fbf_gc_en_sum_th_2_2_0_shift                             (5)
#define  ATSC_ADDR_27E7_fbf_gc_en_sum_th_1_11_7_shift                            (0)
#define  ATSC_ADDR_27E7_fbf_gc_en_sum_th_2_2_0_mask                              (0x000000E0)
#define  ATSC_ADDR_27E7_fbf_gc_en_sum_th_1_11_7_mask                             (0x0000001F)
#define  ATSC_ADDR_27E7_fbf_gc_en_sum_th_2_2_0(data)                             (0x000000E0&((data)<<5))
#define  ATSC_ADDR_27E7_fbf_gc_en_sum_th_1_11_7(data)                            (0x0000001F&(data))
#define  ATSC_ADDR_27E7_get_fbf_gc_en_sum_th_2_2_0(data)                         ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_27E7_get_fbf_gc_en_sum_th_1_11_7(data)                        (0x0000001F&(data))

#define  ATSC_ADDR_27E8                                                         0x18155FA0
#define  ATSC_ADDR_27E8_reg_addr                                                 "0xB8155FA0"
#define  ATSC_ADDR_27E8_reg                                                      0xB8155FA0
#define  ATSC_ADDR_27E8_inst_addr                                                "0x040C"
#define  set_ATSC_ADDR_27E8_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27E8_reg)=data)
#define  get_ATSC_ADDR_27E8_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27E8_reg))
#define  ATSC_ADDR_27E8_fbf_gc_en_sum_th_2_10_3_shift                            (0)
#define  ATSC_ADDR_27E8_fbf_gc_en_sum_th_2_10_3_mask                             (0x000000FF)
#define  ATSC_ADDR_27E8_fbf_gc_en_sum_th_2_10_3(data)                            (0x000000FF&(data))
#define  ATSC_ADDR_27E8_get_fbf_gc_en_sum_th_2_10_3(data)                        (0x000000FF&(data))

#define  ATSC_ADDR_27E9                                                         0x18155FA4
#define  ATSC_ADDR_27E9_reg_addr                                                 "0xB8155FA4"
#define  ATSC_ADDR_27E9_reg                                                      0xB8155FA4
#define  ATSC_ADDR_27E9_inst_addr                                                "0x040D"
#define  set_ATSC_ADDR_27E9_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27E9_reg)=data)
#define  get_ATSC_ADDR_27E9_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27E9_reg))
#define  ATSC_ADDR_27E9_fbf_gc_dis_th_6_0_shift                                  (1)
#define  ATSC_ADDR_27E9_fbf_gc_en_sum_th_2_11_shift                              (0)
#define  ATSC_ADDR_27E9_fbf_gc_dis_th_6_0_mask                                   (0x000000FE)
#define  ATSC_ADDR_27E9_fbf_gc_en_sum_th_2_11_mask                               (0x00000001)
#define  ATSC_ADDR_27E9_fbf_gc_dis_th_6_0(data)                                  (0x000000FE&((data)<<1))
#define  ATSC_ADDR_27E9_fbf_gc_en_sum_th_2_11(data)                              (0x00000001&(data))
#define  ATSC_ADDR_27E9_get_fbf_gc_dis_th_6_0(data)                              ((0x000000FE&(data))>>1)
#define  ATSC_ADDR_27E9_get_fbf_gc_en_sum_th_2_11(data)                          (0x00000001&(data))

#define  ATSC_ADDR_27EA                                                         0x18155FA8
#define  ATSC_ADDR_27EA_reg_addr                                                 "0xB8155FA8"
#define  ATSC_ADDR_27EA_reg                                                      0xB8155FA8
#define  ATSC_ADDR_27EA_inst_addr                                                "0x040E"
#define  set_ATSC_ADDR_27EA_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27EA_reg)=data)
#define  get_ATSC_ADDR_27EA_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27EA_reg))
#define  ATSC_ADDR_27EA_fbf_gc_en_cnt_lb_0_2_0_shift                             (5)
#define  ATSC_ADDR_27EA_fbf_gc_dis_th_11_7_shift                                 (0)
#define  ATSC_ADDR_27EA_fbf_gc_en_cnt_lb_0_2_0_mask                              (0x000000E0)
#define  ATSC_ADDR_27EA_fbf_gc_dis_th_11_7_mask                                  (0x0000001F)
#define  ATSC_ADDR_27EA_fbf_gc_en_cnt_lb_0_2_0(data)                             (0x000000E0&((data)<<5))
#define  ATSC_ADDR_27EA_fbf_gc_dis_th_11_7(data)                                 (0x0000001F&(data))
#define  ATSC_ADDR_27EA_get_fbf_gc_en_cnt_lb_0_2_0(data)                         ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_27EA_get_fbf_gc_dis_th_11_7(data)                             (0x0000001F&(data))

#define  ATSC_ADDR_27EB                                                         0x18155FAC
#define  ATSC_ADDR_27EB_reg_addr                                                 "0xB8155FAC"
#define  ATSC_ADDR_27EB_reg                                                      0xB8155FAC
#define  ATSC_ADDR_27EB_inst_addr                                                "0x040F"
#define  set_ATSC_ADDR_27EB_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27EB_reg)=data)
#define  get_ATSC_ADDR_27EB_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27EB_reg))
#define  ATSC_ADDR_27EB_fbf_gc_en_cnt_lb_2_0_shift                               (7)
#define  ATSC_ADDR_27EB_fbf_gc_en_cnt_lb_1_shift                                 (2)
#define  ATSC_ADDR_27EB_fbf_gc_en_cnt_lb_0_4_3_shift                             (0)
#define  ATSC_ADDR_27EB_fbf_gc_en_cnt_lb_2_0_mask                                (0x00000080)
#define  ATSC_ADDR_27EB_fbf_gc_en_cnt_lb_1_mask                                  (0x0000007C)
#define  ATSC_ADDR_27EB_fbf_gc_en_cnt_lb_0_4_3_mask                              (0x00000003)
#define  ATSC_ADDR_27EB_fbf_gc_en_cnt_lb_2_0(data)                               (0x00000080&((data)<<7))
#define  ATSC_ADDR_27EB_fbf_gc_en_cnt_lb_1(data)                                 (0x0000007C&((data)<<2))
#define  ATSC_ADDR_27EB_fbf_gc_en_cnt_lb_0_4_3(data)                             (0x00000003&(data))
#define  ATSC_ADDR_27EB_get_fbf_gc_en_cnt_lb_2_0(data)                           ((0x00000080&(data))>>7)
#define  ATSC_ADDR_27EB_get_fbf_gc_en_cnt_lb_1(data)                             ((0x0000007C&(data))>>2)
#define  ATSC_ADDR_27EB_get_fbf_gc_en_cnt_lb_0_4_3(data)                         (0x00000003&(data))

#define  ATSC_ADDR_27EC                                                         0x18155FB0
#define  ATSC_ADDR_27EC_reg_addr                                                 "0xB8155FB0"
#define  ATSC_ADDR_27EC_reg                                                      0xB8155FB0
#define  ATSC_ADDR_27EC_inst_addr                                                "0x0410"
#define  set_ATSC_ADDR_27EC_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27EC_reg)=data)
#define  get_ATSC_ADDR_27EC_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27EC_reg))
#define  ATSC_ADDR_27EC_fbf_gc_dis2en_cnt_lb_3_0_shift                           (4)
#define  ATSC_ADDR_27EC_fbf_gc_en_cnt_lb_2_4_1_shift                             (0)
#define  ATSC_ADDR_27EC_fbf_gc_dis2en_cnt_lb_3_0_mask                            (0x000000F0)
#define  ATSC_ADDR_27EC_fbf_gc_en_cnt_lb_2_4_1_mask                              (0x0000000F)
#define  ATSC_ADDR_27EC_fbf_gc_dis2en_cnt_lb_3_0(data)                           (0x000000F0&((data)<<4))
#define  ATSC_ADDR_27EC_fbf_gc_en_cnt_lb_2_4_1(data)                             (0x0000000F&(data))
#define  ATSC_ADDR_27EC_get_fbf_gc_dis2en_cnt_lb_3_0(data)                       ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_27EC_get_fbf_gc_en_cnt_lb_2_4_1(data)                         (0x0000000F&(data))

#define  ATSC_ADDR_27ED                                                         0x18155FB4
#define  ATSC_ADDR_27ED_reg_addr                                                 "0xB8155FB4"
#define  ATSC_ADDR_27ED_reg                                                      0xB8155FB4
#define  ATSC_ADDR_27ED_inst_addr                                                "0x0411"
#define  set_ATSC_ADDR_27ED_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27ED_reg)=data)
#define  get_ATSC_ADDR_27ED_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27ED_reg))
#define  ATSC_ADDR_27ED_fbf_gc_range_exp_shift                                   (6)
#define  ATSC_ADDR_27ED_fbf_gc_dis_cnt_lb_shift                                  (1)
#define  ATSC_ADDR_27ED_fbf_gc_dis2en_cnt_lb_4_shift                             (0)
#define  ATSC_ADDR_27ED_fbf_gc_range_exp_mask                                    (0x000000C0)
#define  ATSC_ADDR_27ED_fbf_gc_dis_cnt_lb_mask                                   (0x0000003E)
#define  ATSC_ADDR_27ED_fbf_gc_dis2en_cnt_lb_4_mask                              (0x00000001)
#define  ATSC_ADDR_27ED_fbf_gc_range_exp(data)                                   (0x000000C0&((data)<<6))
#define  ATSC_ADDR_27ED_fbf_gc_dis_cnt_lb(data)                                  (0x0000003E&((data)<<1))
#define  ATSC_ADDR_27ED_fbf_gc_dis2en_cnt_lb_4(data)                             (0x00000001&(data))
#define  ATSC_ADDR_27ED_get_fbf_gc_range_exp(data)                               ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_27ED_get_fbf_gc_dis_cnt_lb(data)                              ((0x0000003E&(data))>>1)
#define  ATSC_ADDR_27ED_get_fbf_gc_dis2en_cnt_lb_4(data)                         (0x00000001&(data))

#define  ATSC_ADDR_27EE                                                         0x18155FB8
#define  ATSC_ADDR_27EE_reg_addr                                                 "0xB8155FB8"
#define  ATSC_ADDR_27EE_reg                                                      0xB8155FB8
#define  ATSC_ADDR_27EE_inst_addr                                                "0x0412"
#define  set_ATSC_ADDR_27EE_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27EE_reg)=data)
#define  get_ATSC_ADDR_27EE_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27EE_reg))
#define  ATSC_ADDR_27EE_fbf_gc_tr_coeff_th_0_shift                               (7)
#define  ATSC_ADDR_27EE_fbf_gc_dis2en_num_ub_shift                               (0)
#define  ATSC_ADDR_27EE_fbf_gc_tr_coeff_th_0_mask                                (0x00000080)
#define  ATSC_ADDR_27EE_fbf_gc_dis2en_num_ub_mask                                (0x0000007F)
#define  ATSC_ADDR_27EE_fbf_gc_tr_coeff_th_0(data)                               (0x00000080&((data)<<7))
#define  ATSC_ADDR_27EE_fbf_gc_dis2en_num_ub(data)                               (0x0000007F&(data))
#define  ATSC_ADDR_27EE_get_fbf_gc_tr_coeff_th_0(data)                           ((0x00000080&(data))>>7)
#define  ATSC_ADDR_27EE_get_fbf_gc_dis2en_num_ub(data)                           (0x0000007F&(data))

#define  ATSC_ADDR_27EF                                                         0x18155FBC
#define  ATSC_ADDR_27EF_reg_addr                                                 "0xB8155FBC"
#define  ATSC_ADDR_27EF_reg                                                      0xB8155FBC
#define  ATSC_ADDR_27EF_inst_addr                                                "0x0413"
#define  set_ATSC_ADDR_27EF_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27EF_reg)=data)
#define  get_ATSC_ADDR_27EF_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27EF_reg))
#define  ATSC_ADDR_27EF_fbf_gc_dd_coeff_th_0_shift                               (7)
#define  ATSC_ADDR_27EF_fbf_gc_tr_coeff_th_7_1_shift                             (0)
#define  ATSC_ADDR_27EF_fbf_gc_dd_coeff_th_0_mask                                (0x00000080)
#define  ATSC_ADDR_27EF_fbf_gc_tr_coeff_th_7_1_mask                              (0x0000007F)
#define  ATSC_ADDR_27EF_fbf_gc_dd_coeff_th_0(data)                               (0x00000080&((data)<<7))
#define  ATSC_ADDR_27EF_fbf_gc_tr_coeff_th_7_1(data)                             (0x0000007F&(data))
#define  ATSC_ADDR_27EF_get_fbf_gc_dd_coeff_th_0(data)                           ((0x00000080&(data))>>7)
#define  ATSC_ADDR_27EF_get_fbf_gc_tr_coeff_th_7_1(data)                         (0x0000007F&(data))

#define  ATSC_ADDR_27F0                                                         0x18155FC0
#define  ATSC_ADDR_27F0_reg_addr                                                 "0xB8155FC0"
#define  ATSC_ADDR_27F0_reg                                                      0xB8155FC0
#define  ATSC_ADDR_27F0_inst_addr                                                "0x0414"
#define  set_ATSC_ADDR_27F0_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27F0_reg)=data)
#define  get_ATSC_ADDR_27F0_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27F0_reg))
#define  ATSC_ADDR_27F0_fbf_gc_coeff_en_sel_0_shift                              (7)
#define  ATSC_ADDR_27F0_fbf_gc_dd_coeff_th_7_1_shift                             (0)
#define  ATSC_ADDR_27F0_fbf_gc_coeff_en_sel_0_mask                               (0x00000080)
#define  ATSC_ADDR_27F0_fbf_gc_dd_coeff_th_7_1_mask                              (0x0000007F)
#define  ATSC_ADDR_27F0_fbf_gc_coeff_en_sel_0(data)                              (0x00000080&((data)<<7))
#define  ATSC_ADDR_27F0_fbf_gc_dd_coeff_th_7_1(data)                             (0x0000007F&(data))
#define  ATSC_ADDR_27F0_get_fbf_gc_coeff_en_sel_0(data)                          ((0x00000080&(data))>>7)
#define  ATSC_ADDR_27F0_get_fbf_gc_dd_coeff_th_7_1(data)                         (0x0000007F&(data))

#define  ATSC_ADDR_27F1                                                         0x18155FC4
#define  ATSC_ADDR_27F1_reg_addr                                                 "0xB8155FC4"
#define  ATSC_ADDR_27F1_reg                                                      0xB8155FC4
#define  ATSC_ADDR_27F1_inst_addr                                                "0x0415"
#define  set_ATSC_ADDR_27F1_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27F1_reg)=data)
#define  get_ATSC_ADDR_27F1_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27F1_reg))
#define  ATSC_ADDR_27F1_fbf_gc_coeff_en_sel_1_shift                              (0)
#define  ATSC_ADDR_27F1_fbf_gc_coeff_en_sel_1_mask                               (0x00000001)
#define  ATSC_ADDR_27F1_fbf_gc_coeff_en_sel_1(data)                              (0x00000001&(data))
#define  ATSC_ADDR_27F1_get_fbf_gc_coeff_en_sel_1(data)                          (0x00000001&(data))

#define  ATSC_ADDR_27F2                                                         0x18155FC8
#define  ATSC_ADDR_27F2_reg_addr                                                 "0xB8155FC8"
#define  ATSC_ADDR_27F2_reg                                                      0xB8155FC8
#define  ATSC_ADDR_27F2_inst_addr                                                "0x0416"
#define  set_ATSC_ADDR_27F2_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27F2_reg)=data)
#define  get_ATSC_ADDR_27F2_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27F2_reg))
#define  ATSC_ADDR_27F2_fbf_gc_tr_coeff_en_7_shift                               (7)
#define  ATSC_ADDR_27F2_fbf_gc_tr_coeff_en_6_shift                               (6)
#define  ATSC_ADDR_27F2_fbf_gc_tr_coeff_en_5_shift                               (5)
#define  ATSC_ADDR_27F2_fbf_gc_tr_coeff_en_4_shift                               (4)
#define  ATSC_ADDR_27F2_fbf_gc_tr_coeff_en_3_shift                               (3)
#define  ATSC_ADDR_27F2_fbf_gc_tr_coeff_en_2_shift                               (2)
#define  ATSC_ADDR_27F2_fbf_gc_tr_coeff_en_1_shift                               (1)
#define  ATSC_ADDR_27F2_fbf_gc_tr_coeff_en_0_shift                               (0)
#define  ATSC_ADDR_27F2_fbf_gc_tr_coeff_en_7_mask                                (0x00000080)
#define  ATSC_ADDR_27F2_fbf_gc_tr_coeff_en_6_mask                                (0x00000040)
#define  ATSC_ADDR_27F2_fbf_gc_tr_coeff_en_5_mask                                (0x00000020)
#define  ATSC_ADDR_27F2_fbf_gc_tr_coeff_en_4_mask                                (0x00000010)
#define  ATSC_ADDR_27F2_fbf_gc_tr_coeff_en_3_mask                                (0x00000008)
#define  ATSC_ADDR_27F2_fbf_gc_tr_coeff_en_2_mask                                (0x00000004)
#define  ATSC_ADDR_27F2_fbf_gc_tr_coeff_en_1_mask                                (0x00000002)
#define  ATSC_ADDR_27F2_fbf_gc_tr_coeff_en_0_mask                                (0x00000001)
#define  ATSC_ADDR_27F2_fbf_gc_tr_coeff_en_7(data)                               (0x00000080&((data)<<7))
#define  ATSC_ADDR_27F2_fbf_gc_tr_coeff_en_6(data)                               (0x00000040&((data)<<6))
#define  ATSC_ADDR_27F2_fbf_gc_tr_coeff_en_5(data)                               (0x00000020&((data)<<5))
#define  ATSC_ADDR_27F2_fbf_gc_tr_coeff_en_4(data)                               (0x00000010&((data)<<4))
#define  ATSC_ADDR_27F2_fbf_gc_tr_coeff_en_3(data)                               (0x00000008&((data)<<3))
#define  ATSC_ADDR_27F2_fbf_gc_tr_coeff_en_2(data)                               (0x00000004&((data)<<2))
#define  ATSC_ADDR_27F2_fbf_gc_tr_coeff_en_1(data)                               (0x00000002&((data)<<1))
#define  ATSC_ADDR_27F2_fbf_gc_tr_coeff_en_0(data)                               (0x00000001&(data))
#define  ATSC_ADDR_27F2_get_fbf_gc_tr_coeff_en_7(data)                           ((0x00000080&(data))>>7)
#define  ATSC_ADDR_27F2_get_fbf_gc_tr_coeff_en_6(data)                           ((0x00000040&(data))>>6)
#define  ATSC_ADDR_27F2_get_fbf_gc_tr_coeff_en_5(data)                           ((0x00000020&(data))>>5)
#define  ATSC_ADDR_27F2_get_fbf_gc_tr_coeff_en_4(data)                           ((0x00000010&(data))>>4)
#define  ATSC_ADDR_27F2_get_fbf_gc_tr_coeff_en_3(data)                           ((0x00000008&(data))>>3)
#define  ATSC_ADDR_27F2_get_fbf_gc_tr_coeff_en_2(data)                           ((0x00000004&(data))>>2)
#define  ATSC_ADDR_27F2_get_fbf_gc_tr_coeff_en_1(data)                           ((0x00000002&(data))>>1)
#define  ATSC_ADDR_27F2_get_fbf_gc_tr_coeff_en_0(data)                           (0x00000001&(data))

#define  ATSC_ADDR_27F3                                                         0x18155FCC
#define  ATSC_ADDR_27F3_reg_addr                                                 "0xB8155FCC"
#define  ATSC_ADDR_27F3_reg                                                      0xB8155FCC
#define  ATSC_ADDR_27F3_inst_addr                                                "0x0417"
#define  set_ATSC_ADDR_27F3_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27F3_reg)=data)
#define  get_ATSC_ADDR_27F3_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27F3_reg))
#define  ATSC_ADDR_27F3_fbf_gc_tr_coeff_en_15_shift                              (7)
#define  ATSC_ADDR_27F3_fbf_gc_tr_coeff_en_14_shift                              (6)
#define  ATSC_ADDR_27F3_fbf_gc_tr_coeff_en_13_shift                              (5)
#define  ATSC_ADDR_27F3_fbf_gc_tr_coeff_en_12_shift                              (4)
#define  ATSC_ADDR_27F3_fbf_gc_tr_coeff_en_11_shift                              (3)
#define  ATSC_ADDR_27F3_fbf_gc_tr_coeff_en_10_shift                              (2)
#define  ATSC_ADDR_27F3_fbf_gc_tr_coeff_en_9_shift                               (1)
#define  ATSC_ADDR_27F3_fbf_gc_tr_coeff_en_8_shift                               (0)
#define  ATSC_ADDR_27F3_fbf_gc_tr_coeff_en_15_mask                               (0x00000080)
#define  ATSC_ADDR_27F3_fbf_gc_tr_coeff_en_14_mask                               (0x00000040)
#define  ATSC_ADDR_27F3_fbf_gc_tr_coeff_en_13_mask                               (0x00000020)
#define  ATSC_ADDR_27F3_fbf_gc_tr_coeff_en_12_mask                               (0x00000010)
#define  ATSC_ADDR_27F3_fbf_gc_tr_coeff_en_11_mask                               (0x00000008)
#define  ATSC_ADDR_27F3_fbf_gc_tr_coeff_en_10_mask                               (0x00000004)
#define  ATSC_ADDR_27F3_fbf_gc_tr_coeff_en_9_mask                                (0x00000002)
#define  ATSC_ADDR_27F3_fbf_gc_tr_coeff_en_8_mask                                (0x00000001)
#define  ATSC_ADDR_27F3_fbf_gc_tr_coeff_en_15(data)                              (0x00000080&((data)<<7))
#define  ATSC_ADDR_27F3_fbf_gc_tr_coeff_en_14(data)                              (0x00000040&((data)<<6))
#define  ATSC_ADDR_27F3_fbf_gc_tr_coeff_en_13(data)                              (0x00000020&((data)<<5))
#define  ATSC_ADDR_27F3_fbf_gc_tr_coeff_en_12(data)                              (0x00000010&((data)<<4))
#define  ATSC_ADDR_27F3_fbf_gc_tr_coeff_en_11(data)                              (0x00000008&((data)<<3))
#define  ATSC_ADDR_27F3_fbf_gc_tr_coeff_en_10(data)                              (0x00000004&((data)<<2))
#define  ATSC_ADDR_27F3_fbf_gc_tr_coeff_en_9(data)                               (0x00000002&((data)<<1))
#define  ATSC_ADDR_27F3_fbf_gc_tr_coeff_en_8(data)                               (0x00000001&(data))
#define  ATSC_ADDR_27F3_get_fbf_gc_tr_coeff_en_15(data)                          ((0x00000080&(data))>>7)
#define  ATSC_ADDR_27F3_get_fbf_gc_tr_coeff_en_14(data)                          ((0x00000040&(data))>>6)
#define  ATSC_ADDR_27F3_get_fbf_gc_tr_coeff_en_13(data)                          ((0x00000020&(data))>>5)
#define  ATSC_ADDR_27F3_get_fbf_gc_tr_coeff_en_12(data)                          ((0x00000010&(data))>>4)
#define  ATSC_ADDR_27F3_get_fbf_gc_tr_coeff_en_11(data)                          ((0x00000008&(data))>>3)
#define  ATSC_ADDR_27F3_get_fbf_gc_tr_coeff_en_10(data)                          ((0x00000004&(data))>>2)
#define  ATSC_ADDR_27F3_get_fbf_gc_tr_coeff_en_9(data)                           ((0x00000002&(data))>>1)
#define  ATSC_ADDR_27F3_get_fbf_gc_tr_coeff_en_8(data)                           (0x00000001&(data))

#define  ATSC_ADDR_27F4                                                         0x18155FD0
#define  ATSC_ADDR_27F4_reg_addr                                                 "0xB8155FD0"
#define  ATSC_ADDR_27F4_reg                                                      0xB8155FD0
#define  ATSC_ADDR_27F4_inst_addr                                                "0x0418"
#define  set_ATSC_ADDR_27F4_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27F4_reg)=data)
#define  get_ATSC_ADDR_27F4_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27F4_reg))
#define  ATSC_ADDR_27F4_fbf_gc_tr_coeff_en_23_shift                              (7)
#define  ATSC_ADDR_27F4_fbf_gc_tr_coeff_en_22_shift                              (6)
#define  ATSC_ADDR_27F4_fbf_gc_tr_coeff_en_21_shift                              (5)
#define  ATSC_ADDR_27F4_fbf_gc_tr_coeff_en_20_shift                              (4)
#define  ATSC_ADDR_27F4_fbf_gc_tr_coeff_en_19_shift                              (3)
#define  ATSC_ADDR_27F4_fbf_gc_tr_coeff_en_18_shift                              (2)
#define  ATSC_ADDR_27F4_fbf_gc_tr_coeff_en_17_shift                              (1)
#define  ATSC_ADDR_27F4_fbf_gc_tr_coeff_en_16_shift                              (0)
#define  ATSC_ADDR_27F4_fbf_gc_tr_coeff_en_23_mask                               (0x00000080)
#define  ATSC_ADDR_27F4_fbf_gc_tr_coeff_en_22_mask                               (0x00000040)
#define  ATSC_ADDR_27F4_fbf_gc_tr_coeff_en_21_mask                               (0x00000020)
#define  ATSC_ADDR_27F4_fbf_gc_tr_coeff_en_20_mask                               (0x00000010)
#define  ATSC_ADDR_27F4_fbf_gc_tr_coeff_en_19_mask                               (0x00000008)
#define  ATSC_ADDR_27F4_fbf_gc_tr_coeff_en_18_mask                               (0x00000004)
#define  ATSC_ADDR_27F4_fbf_gc_tr_coeff_en_17_mask                               (0x00000002)
#define  ATSC_ADDR_27F4_fbf_gc_tr_coeff_en_16_mask                               (0x00000001)
#define  ATSC_ADDR_27F4_fbf_gc_tr_coeff_en_23(data)                              (0x00000080&((data)<<7))
#define  ATSC_ADDR_27F4_fbf_gc_tr_coeff_en_22(data)                              (0x00000040&((data)<<6))
#define  ATSC_ADDR_27F4_fbf_gc_tr_coeff_en_21(data)                              (0x00000020&((data)<<5))
#define  ATSC_ADDR_27F4_fbf_gc_tr_coeff_en_20(data)                              (0x00000010&((data)<<4))
#define  ATSC_ADDR_27F4_fbf_gc_tr_coeff_en_19(data)                              (0x00000008&((data)<<3))
#define  ATSC_ADDR_27F4_fbf_gc_tr_coeff_en_18(data)                              (0x00000004&((data)<<2))
#define  ATSC_ADDR_27F4_fbf_gc_tr_coeff_en_17(data)                              (0x00000002&((data)<<1))
#define  ATSC_ADDR_27F4_fbf_gc_tr_coeff_en_16(data)                              (0x00000001&(data))
#define  ATSC_ADDR_27F4_get_fbf_gc_tr_coeff_en_23(data)                          ((0x00000080&(data))>>7)
#define  ATSC_ADDR_27F4_get_fbf_gc_tr_coeff_en_22(data)                          ((0x00000040&(data))>>6)
#define  ATSC_ADDR_27F4_get_fbf_gc_tr_coeff_en_21(data)                          ((0x00000020&(data))>>5)
#define  ATSC_ADDR_27F4_get_fbf_gc_tr_coeff_en_20(data)                          ((0x00000010&(data))>>4)
#define  ATSC_ADDR_27F4_get_fbf_gc_tr_coeff_en_19(data)                          ((0x00000008&(data))>>3)
#define  ATSC_ADDR_27F4_get_fbf_gc_tr_coeff_en_18(data)                          ((0x00000004&(data))>>2)
#define  ATSC_ADDR_27F4_get_fbf_gc_tr_coeff_en_17(data)                          ((0x00000002&(data))>>1)
#define  ATSC_ADDR_27F4_get_fbf_gc_tr_coeff_en_16(data)                          (0x00000001&(data))

#define  ATSC_ADDR_27F5                                                         0x18155FD4
#define  ATSC_ADDR_27F5_reg_addr                                                 "0xB8155FD4"
#define  ATSC_ADDR_27F5_reg                                                      0xB8155FD4
#define  ATSC_ADDR_27F5_inst_addr                                                "0x0419"
#define  set_ATSC_ADDR_27F5_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27F5_reg)=data)
#define  get_ATSC_ADDR_27F5_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27F5_reg))
#define  ATSC_ADDR_27F5_fbf_gc_tr_coeff_en_31_shift                              (7)
#define  ATSC_ADDR_27F5_fbf_gc_tr_coeff_en_30_shift                              (6)
#define  ATSC_ADDR_27F5_fbf_gc_tr_coeff_en_29_shift                              (5)
#define  ATSC_ADDR_27F5_fbf_gc_tr_coeff_en_28_shift                              (4)
#define  ATSC_ADDR_27F5_fbf_gc_tr_coeff_en_27_shift                              (3)
#define  ATSC_ADDR_27F5_fbf_gc_tr_coeff_en_26_shift                              (2)
#define  ATSC_ADDR_27F5_fbf_gc_tr_coeff_en_25_shift                              (1)
#define  ATSC_ADDR_27F5_fbf_gc_tr_coeff_en_24_shift                              (0)
#define  ATSC_ADDR_27F5_fbf_gc_tr_coeff_en_31_mask                               (0x00000080)
#define  ATSC_ADDR_27F5_fbf_gc_tr_coeff_en_30_mask                               (0x00000040)
#define  ATSC_ADDR_27F5_fbf_gc_tr_coeff_en_29_mask                               (0x00000020)
#define  ATSC_ADDR_27F5_fbf_gc_tr_coeff_en_28_mask                               (0x00000010)
#define  ATSC_ADDR_27F5_fbf_gc_tr_coeff_en_27_mask                               (0x00000008)
#define  ATSC_ADDR_27F5_fbf_gc_tr_coeff_en_26_mask                               (0x00000004)
#define  ATSC_ADDR_27F5_fbf_gc_tr_coeff_en_25_mask                               (0x00000002)
#define  ATSC_ADDR_27F5_fbf_gc_tr_coeff_en_24_mask                               (0x00000001)
#define  ATSC_ADDR_27F5_fbf_gc_tr_coeff_en_31(data)                              (0x00000080&((data)<<7))
#define  ATSC_ADDR_27F5_fbf_gc_tr_coeff_en_30(data)                              (0x00000040&((data)<<6))
#define  ATSC_ADDR_27F5_fbf_gc_tr_coeff_en_29(data)                              (0x00000020&((data)<<5))
#define  ATSC_ADDR_27F5_fbf_gc_tr_coeff_en_28(data)                              (0x00000010&((data)<<4))
#define  ATSC_ADDR_27F5_fbf_gc_tr_coeff_en_27(data)                              (0x00000008&((data)<<3))
#define  ATSC_ADDR_27F5_fbf_gc_tr_coeff_en_26(data)                              (0x00000004&((data)<<2))
#define  ATSC_ADDR_27F5_fbf_gc_tr_coeff_en_25(data)                              (0x00000002&((data)<<1))
#define  ATSC_ADDR_27F5_fbf_gc_tr_coeff_en_24(data)                              (0x00000001&(data))
#define  ATSC_ADDR_27F5_get_fbf_gc_tr_coeff_en_31(data)                          ((0x00000080&(data))>>7)
#define  ATSC_ADDR_27F5_get_fbf_gc_tr_coeff_en_30(data)                          ((0x00000040&(data))>>6)
#define  ATSC_ADDR_27F5_get_fbf_gc_tr_coeff_en_29(data)                          ((0x00000020&(data))>>5)
#define  ATSC_ADDR_27F5_get_fbf_gc_tr_coeff_en_28(data)                          ((0x00000010&(data))>>4)
#define  ATSC_ADDR_27F5_get_fbf_gc_tr_coeff_en_27(data)                          ((0x00000008&(data))>>3)
#define  ATSC_ADDR_27F5_get_fbf_gc_tr_coeff_en_26(data)                          ((0x00000004&(data))>>2)
#define  ATSC_ADDR_27F5_get_fbf_gc_tr_coeff_en_25(data)                          ((0x00000002&(data))>>1)
#define  ATSC_ADDR_27F5_get_fbf_gc_tr_coeff_en_24(data)                          (0x00000001&(data))

#define  ATSC_ADDR_27F6                                                         0x18155FD8
#define  ATSC_ADDR_27F6_reg_addr                                                 "0xB8155FD8"
#define  ATSC_ADDR_27F6_reg                                                      0xB8155FD8
#define  ATSC_ADDR_27F6_inst_addr                                                "0x041A"
#define  set_ATSC_ADDR_27F6_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27F6_reg)=data)
#define  get_ATSC_ADDR_27F6_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27F6_reg))
#define  ATSC_ADDR_27F6_fbf_gc_tr_coeff_en_39_shift                              (7)
#define  ATSC_ADDR_27F6_fbf_gc_tr_coeff_en_38_shift                              (6)
#define  ATSC_ADDR_27F6_fbf_gc_tr_coeff_en_37_shift                              (5)
#define  ATSC_ADDR_27F6_fbf_gc_tr_coeff_en_36_shift                              (4)
#define  ATSC_ADDR_27F6_fbf_gc_tr_coeff_en_35_shift                              (3)
#define  ATSC_ADDR_27F6_fbf_gc_tr_coeff_en_34_shift                              (2)
#define  ATSC_ADDR_27F6_fbf_gc_tr_coeff_en_33_shift                              (1)
#define  ATSC_ADDR_27F6_fbf_gc_tr_coeff_en_32_shift                              (0)
#define  ATSC_ADDR_27F6_fbf_gc_tr_coeff_en_39_mask                               (0x00000080)
#define  ATSC_ADDR_27F6_fbf_gc_tr_coeff_en_38_mask                               (0x00000040)
#define  ATSC_ADDR_27F6_fbf_gc_tr_coeff_en_37_mask                               (0x00000020)
#define  ATSC_ADDR_27F6_fbf_gc_tr_coeff_en_36_mask                               (0x00000010)
#define  ATSC_ADDR_27F6_fbf_gc_tr_coeff_en_35_mask                               (0x00000008)
#define  ATSC_ADDR_27F6_fbf_gc_tr_coeff_en_34_mask                               (0x00000004)
#define  ATSC_ADDR_27F6_fbf_gc_tr_coeff_en_33_mask                               (0x00000002)
#define  ATSC_ADDR_27F6_fbf_gc_tr_coeff_en_32_mask                               (0x00000001)
#define  ATSC_ADDR_27F6_fbf_gc_tr_coeff_en_39(data)                              (0x00000080&((data)<<7))
#define  ATSC_ADDR_27F6_fbf_gc_tr_coeff_en_38(data)                              (0x00000040&((data)<<6))
#define  ATSC_ADDR_27F6_fbf_gc_tr_coeff_en_37(data)                              (0x00000020&((data)<<5))
#define  ATSC_ADDR_27F6_fbf_gc_tr_coeff_en_36(data)                              (0x00000010&((data)<<4))
#define  ATSC_ADDR_27F6_fbf_gc_tr_coeff_en_35(data)                              (0x00000008&((data)<<3))
#define  ATSC_ADDR_27F6_fbf_gc_tr_coeff_en_34(data)                              (0x00000004&((data)<<2))
#define  ATSC_ADDR_27F6_fbf_gc_tr_coeff_en_33(data)                              (0x00000002&((data)<<1))
#define  ATSC_ADDR_27F6_fbf_gc_tr_coeff_en_32(data)                              (0x00000001&(data))
#define  ATSC_ADDR_27F6_get_fbf_gc_tr_coeff_en_39(data)                          ((0x00000080&(data))>>7)
#define  ATSC_ADDR_27F6_get_fbf_gc_tr_coeff_en_38(data)                          ((0x00000040&(data))>>6)
#define  ATSC_ADDR_27F6_get_fbf_gc_tr_coeff_en_37(data)                          ((0x00000020&(data))>>5)
#define  ATSC_ADDR_27F6_get_fbf_gc_tr_coeff_en_36(data)                          ((0x00000010&(data))>>4)
#define  ATSC_ADDR_27F6_get_fbf_gc_tr_coeff_en_35(data)                          ((0x00000008&(data))>>3)
#define  ATSC_ADDR_27F6_get_fbf_gc_tr_coeff_en_34(data)                          ((0x00000004&(data))>>2)
#define  ATSC_ADDR_27F6_get_fbf_gc_tr_coeff_en_33(data)                          ((0x00000002&(data))>>1)
#define  ATSC_ADDR_27F6_get_fbf_gc_tr_coeff_en_32(data)                          (0x00000001&(data))

#define  ATSC_ADDR_27F7                                                         0x18155FDC
#define  ATSC_ADDR_27F7_reg_addr                                                 "0xB8155FDC"
#define  ATSC_ADDR_27F7_reg                                                      0xB8155FDC
#define  ATSC_ADDR_27F7_inst_addr                                                "0x041B"
#define  set_ATSC_ADDR_27F7_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27F7_reg)=data)
#define  get_ATSC_ADDR_27F7_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27F7_reg))
#define  ATSC_ADDR_27F7_fbf_gc_tr_coeff_en_42_shift                              (2)
#define  ATSC_ADDR_27F7_fbf_gc_tr_coeff_en_41_shift                              (1)
#define  ATSC_ADDR_27F7_fbf_gc_tr_coeff_en_40_shift                              (0)
#define  ATSC_ADDR_27F7_fbf_gc_tr_coeff_en_42_mask                               (0x00000004)
#define  ATSC_ADDR_27F7_fbf_gc_tr_coeff_en_41_mask                               (0x00000002)
#define  ATSC_ADDR_27F7_fbf_gc_tr_coeff_en_40_mask                               (0x00000001)
#define  ATSC_ADDR_27F7_fbf_gc_tr_coeff_en_42(data)                              (0x00000004&((data)<<2))
#define  ATSC_ADDR_27F7_fbf_gc_tr_coeff_en_41(data)                              (0x00000002&((data)<<1))
#define  ATSC_ADDR_27F7_fbf_gc_tr_coeff_en_40(data)                              (0x00000001&(data))
#define  ATSC_ADDR_27F7_get_fbf_gc_tr_coeff_en_42(data)                          ((0x00000004&(data))>>2)
#define  ATSC_ADDR_27F7_get_fbf_gc_tr_coeff_en_41(data)                          ((0x00000002&(data))>>1)
#define  ATSC_ADDR_27F7_get_fbf_gc_tr_coeff_en_40(data)                          (0x00000001&(data))

#define  ATSC_ADDR_27F8                                                         0x18155FE0
#define  ATSC_ADDR_27F8_reg_addr                                                 "0xB8155FE0"
#define  ATSC_ADDR_27F8_reg                                                      0xB8155FE0
#define  ATSC_ADDR_27F8_inst_addr                                                "0x041C"
#define  set_ATSC_ADDR_27F8_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27F8_reg)=data)
#define  get_ATSC_ADDR_27F8_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27F8_reg))
#define  ATSC_ADDR_27F8_fbf_gc_dd_coeff_en_7_shift                               (7)
#define  ATSC_ADDR_27F8_fbf_gc_dd_coeff_en_6_shift                               (6)
#define  ATSC_ADDR_27F8_fbf_gc_dd_coeff_en_5_shift                               (5)
#define  ATSC_ADDR_27F8_fbf_gc_dd_coeff_en_4_shift                               (4)
#define  ATSC_ADDR_27F8_fbf_gc_dd_coeff_en_3_shift                               (3)
#define  ATSC_ADDR_27F8_fbf_gc_dd_coeff_en_2_shift                               (2)
#define  ATSC_ADDR_27F8_fbf_gc_dd_coeff_en_1_shift                               (1)
#define  ATSC_ADDR_27F8_fbf_gc_dd_coeff_en_0_shift                               (0)
#define  ATSC_ADDR_27F8_fbf_gc_dd_coeff_en_7_mask                                (0x00000080)
#define  ATSC_ADDR_27F8_fbf_gc_dd_coeff_en_6_mask                                (0x00000040)
#define  ATSC_ADDR_27F8_fbf_gc_dd_coeff_en_5_mask                                (0x00000020)
#define  ATSC_ADDR_27F8_fbf_gc_dd_coeff_en_4_mask                                (0x00000010)
#define  ATSC_ADDR_27F8_fbf_gc_dd_coeff_en_3_mask                                (0x00000008)
#define  ATSC_ADDR_27F8_fbf_gc_dd_coeff_en_2_mask                                (0x00000004)
#define  ATSC_ADDR_27F8_fbf_gc_dd_coeff_en_1_mask                                (0x00000002)
#define  ATSC_ADDR_27F8_fbf_gc_dd_coeff_en_0_mask                                (0x00000001)
#define  ATSC_ADDR_27F8_fbf_gc_dd_coeff_en_7(data)                               (0x00000080&((data)<<7))
#define  ATSC_ADDR_27F8_fbf_gc_dd_coeff_en_6(data)                               (0x00000040&((data)<<6))
#define  ATSC_ADDR_27F8_fbf_gc_dd_coeff_en_5(data)                               (0x00000020&((data)<<5))
#define  ATSC_ADDR_27F8_fbf_gc_dd_coeff_en_4(data)                               (0x00000010&((data)<<4))
#define  ATSC_ADDR_27F8_fbf_gc_dd_coeff_en_3(data)                               (0x00000008&((data)<<3))
#define  ATSC_ADDR_27F8_fbf_gc_dd_coeff_en_2(data)                               (0x00000004&((data)<<2))
#define  ATSC_ADDR_27F8_fbf_gc_dd_coeff_en_1(data)                               (0x00000002&((data)<<1))
#define  ATSC_ADDR_27F8_fbf_gc_dd_coeff_en_0(data)                               (0x00000001&(data))
#define  ATSC_ADDR_27F8_get_fbf_gc_dd_coeff_en_7(data)                           ((0x00000080&(data))>>7)
#define  ATSC_ADDR_27F8_get_fbf_gc_dd_coeff_en_6(data)                           ((0x00000040&(data))>>6)
#define  ATSC_ADDR_27F8_get_fbf_gc_dd_coeff_en_5(data)                           ((0x00000020&(data))>>5)
#define  ATSC_ADDR_27F8_get_fbf_gc_dd_coeff_en_4(data)                           ((0x00000010&(data))>>4)
#define  ATSC_ADDR_27F8_get_fbf_gc_dd_coeff_en_3(data)                           ((0x00000008&(data))>>3)
#define  ATSC_ADDR_27F8_get_fbf_gc_dd_coeff_en_2(data)                           ((0x00000004&(data))>>2)
#define  ATSC_ADDR_27F8_get_fbf_gc_dd_coeff_en_1(data)                           ((0x00000002&(data))>>1)
#define  ATSC_ADDR_27F8_get_fbf_gc_dd_coeff_en_0(data)                           (0x00000001&(data))

#define  ATSC_ADDR_27F9                                                         0x18155FE4
#define  ATSC_ADDR_27F9_reg_addr                                                 "0xB8155FE4"
#define  ATSC_ADDR_27F9_reg                                                      0xB8155FE4
#define  ATSC_ADDR_27F9_inst_addr                                                "0x041D"
#define  set_ATSC_ADDR_27F9_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27F9_reg)=data)
#define  get_ATSC_ADDR_27F9_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27F9_reg))
#define  ATSC_ADDR_27F9_fbf_gc_dd_coeff_en_15_shift                              (7)
#define  ATSC_ADDR_27F9_fbf_gc_dd_coeff_en_14_shift                              (6)
#define  ATSC_ADDR_27F9_fbf_gc_dd_coeff_en_13_shift                              (5)
#define  ATSC_ADDR_27F9_fbf_gc_dd_coeff_en_12_shift                              (4)
#define  ATSC_ADDR_27F9_fbf_gc_dd_coeff_en_11_shift                              (3)
#define  ATSC_ADDR_27F9_fbf_gc_dd_coeff_en_10_shift                              (2)
#define  ATSC_ADDR_27F9_fbf_gc_dd_coeff_en_9_shift                               (1)
#define  ATSC_ADDR_27F9_fbf_gc_dd_coeff_en_8_shift                               (0)
#define  ATSC_ADDR_27F9_fbf_gc_dd_coeff_en_15_mask                               (0x00000080)
#define  ATSC_ADDR_27F9_fbf_gc_dd_coeff_en_14_mask                               (0x00000040)
#define  ATSC_ADDR_27F9_fbf_gc_dd_coeff_en_13_mask                               (0x00000020)
#define  ATSC_ADDR_27F9_fbf_gc_dd_coeff_en_12_mask                               (0x00000010)
#define  ATSC_ADDR_27F9_fbf_gc_dd_coeff_en_11_mask                               (0x00000008)
#define  ATSC_ADDR_27F9_fbf_gc_dd_coeff_en_10_mask                               (0x00000004)
#define  ATSC_ADDR_27F9_fbf_gc_dd_coeff_en_9_mask                                (0x00000002)
#define  ATSC_ADDR_27F9_fbf_gc_dd_coeff_en_8_mask                                (0x00000001)
#define  ATSC_ADDR_27F9_fbf_gc_dd_coeff_en_15(data)                              (0x00000080&((data)<<7))
#define  ATSC_ADDR_27F9_fbf_gc_dd_coeff_en_14(data)                              (0x00000040&((data)<<6))
#define  ATSC_ADDR_27F9_fbf_gc_dd_coeff_en_13(data)                              (0x00000020&((data)<<5))
#define  ATSC_ADDR_27F9_fbf_gc_dd_coeff_en_12(data)                              (0x00000010&((data)<<4))
#define  ATSC_ADDR_27F9_fbf_gc_dd_coeff_en_11(data)                              (0x00000008&((data)<<3))
#define  ATSC_ADDR_27F9_fbf_gc_dd_coeff_en_10(data)                              (0x00000004&((data)<<2))
#define  ATSC_ADDR_27F9_fbf_gc_dd_coeff_en_9(data)                               (0x00000002&((data)<<1))
#define  ATSC_ADDR_27F9_fbf_gc_dd_coeff_en_8(data)                               (0x00000001&(data))
#define  ATSC_ADDR_27F9_get_fbf_gc_dd_coeff_en_15(data)                          ((0x00000080&(data))>>7)
#define  ATSC_ADDR_27F9_get_fbf_gc_dd_coeff_en_14(data)                          ((0x00000040&(data))>>6)
#define  ATSC_ADDR_27F9_get_fbf_gc_dd_coeff_en_13(data)                          ((0x00000020&(data))>>5)
#define  ATSC_ADDR_27F9_get_fbf_gc_dd_coeff_en_12(data)                          ((0x00000010&(data))>>4)
#define  ATSC_ADDR_27F9_get_fbf_gc_dd_coeff_en_11(data)                          ((0x00000008&(data))>>3)
#define  ATSC_ADDR_27F9_get_fbf_gc_dd_coeff_en_10(data)                          ((0x00000004&(data))>>2)
#define  ATSC_ADDR_27F9_get_fbf_gc_dd_coeff_en_9(data)                           ((0x00000002&(data))>>1)
#define  ATSC_ADDR_27F9_get_fbf_gc_dd_coeff_en_8(data)                           (0x00000001&(data))

#define  ATSC_ADDR_27FA                                                         0x18155FE8
#define  ATSC_ADDR_27FA_reg_addr                                                 "0xB8155FE8"
#define  ATSC_ADDR_27FA_reg                                                      0xB8155FE8
#define  ATSC_ADDR_27FA_inst_addr                                                "0x041E"
#define  set_ATSC_ADDR_27FA_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27FA_reg)=data)
#define  get_ATSC_ADDR_27FA_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27FA_reg))
#define  ATSC_ADDR_27FA_fbf_gc_dd_coeff_en_23_shift                              (7)
#define  ATSC_ADDR_27FA_fbf_gc_dd_coeff_en_22_shift                              (6)
#define  ATSC_ADDR_27FA_fbf_gc_dd_coeff_en_21_shift                              (5)
#define  ATSC_ADDR_27FA_fbf_gc_dd_coeff_en_20_shift                              (4)
#define  ATSC_ADDR_27FA_fbf_gc_dd_coeff_en_19_shift                              (3)
#define  ATSC_ADDR_27FA_fbf_gc_dd_coeff_en_18_shift                              (2)
#define  ATSC_ADDR_27FA_fbf_gc_dd_coeff_en_17_shift                              (1)
#define  ATSC_ADDR_27FA_fbf_gc_dd_coeff_en_16_shift                              (0)
#define  ATSC_ADDR_27FA_fbf_gc_dd_coeff_en_23_mask                               (0x00000080)
#define  ATSC_ADDR_27FA_fbf_gc_dd_coeff_en_22_mask                               (0x00000040)
#define  ATSC_ADDR_27FA_fbf_gc_dd_coeff_en_21_mask                               (0x00000020)
#define  ATSC_ADDR_27FA_fbf_gc_dd_coeff_en_20_mask                               (0x00000010)
#define  ATSC_ADDR_27FA_fbf_gc_dd_coeff_en_19_mask                               (0x00000008)
#define  ATSC_ADDR_27FA_fbf_gc_dd_coeff_en_18_mask                               (0x00000004)
#define  ATSC_ADDR_27FA_fbf_gc_dd_coeff_en_17_mask                               (0x00000002)
#define  ATSC_ADDR_27FA_fbf_gc_dd_coeff_en_16_mask                               (0x00000001)
#define  ATSC_ADDR_27FA_fbf_gc_dd_coeff_en_23(data)                              (0x00000080&((data)<<7))
#define  ATSC_ADDR_27FA_fbf_gc_dd_coeff_en_22(data)                              (0x00000040&((data)<<6))
#define  ATSC_ADDR_27FA_fbf_gc_dd_coeff_en_21(data)                              (0x00000020&((data)<<5))
#define  ATSC_ADDR_27FA_fbf_gc_dd_coeff_en_20(data)                              (0x00000010&((data)<<4))
#define  ATSC_ADDR_27FA_fbf_gc_dd_coeff_en_19(data)                              (0x00000008&((data)<<3))
#define  ATSC_ADDR_27FA_fbf_gc_dd_coeff_en_18(data)                              (0x00000004&((data)<<2))
#define  ATSC_ADDR_27FA_fbf_gc_dd_coeff_en_17(data)                              (0x00000002&((data)<<1))
#define  ATSC_ADDR_27FA_fbf_gc_dd_coeff_en_16(data)                              (0x00000001&(data))
#define  ATSC_ADDR_27FA_get_fbf_gc_dd_coeff_en_23(data)                          ((0x00000080&(data))>>7)
#define  ATSC_ADDR_27FA_get_fbf_gc_dd_coeff_en_22(data)                          ((0x00000040&(data))>>6)
#define  ATSC_ADDR_27FA_get_fbf_gc_dd_coeff_en_21(data)                          ((0x00000020&(data))>>5)
#define  ATSC_ADDR_27FA_get_fbf_gc_dd_coeff_en_20(data)                          ((0x00000010&(data))>>4)
#define  ATSC_ADDR_27FA_get_fbf_gc_dd_coeff_en_19(data)                          ((0x00000008&(data))>>3)
#define  ATSC_ADDR_27FA_get_fbf_gc_dd_coeff_en_18(data)                          ((0x00000004&(data))>>2)
#define  ATSC_ADDR_27FA_get_fbf_gc_dd_coeff_en_17(data)                          ((0x00000002&(data))>>1)
#define  ATSC_ADDR_27FA_get_fbf_gc_dd_coeff_en_16(data)                          (0x00000001&(data))

#define  ATSC_ADDR_27FB                                                         0x18155FEC
#define  ATSC_ADDR_27FB_reg_addr                                                 "0xB8155FEC"
#define  ATSC_ADDR_27FB_reg                                                      0xB8155FEC
#define  ATSC_ADDR_27FB_inst_addr                                                "0x041F"
#define  set_ATSC_ADDR_27FB_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27FB_reg)=data)
#define  get_ATSC_ADDR_27FB_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27FB_reg))
#define  ATSC_ADDR_27FB_fbf_gc_dd_coeff_en_31_shift                              (7)
#define  ATSC_ADDR_27FB_fbf_gc_dd_coeff_en_30_shift                              (6)
#define  ATSC_ADDR_27FB_fbf_gc_dd_coeff_en_29_shift                              (5)
#define  ATSC_ADDR_27FB_fbf_gc_dd_coeff_en_28_shift                              (4)
#define  ATSC_ADDR_27FB_fbf_gc_dd_coeff_en_27_shift                              (3)
#define  ATSC_ADDR_27FB_fbf_gc_dd_coeff_en_26_shift                              (2)
#define  ATSC_ADDR_27FB_fbf_gc_dd_coeff_en_25_shift                              (1)
#define  ATSC_ADDR_27FB_fbf_gc_dd_coeff_en_24_shift                              (0)
#define  ATSC_ADDR_27FB_fbf_gc_dd_coeff_en_31_mask                               (0x00000080)
#define  ATSC_ADDR_27FB_fbf_gc_dd_coeff_en_30_mask                               (0x00000040)
#define  ATSC_ADDR_27FB_fbf_gc_dd_coeff_en_29_mask                               (0x00000020)
#define  ATSC_ADDR_27FB_fbf_gc_dd_coeff_en_28_mask                               (0x00000010)
#define  ATSC_ADDR_27FB_fbf_gc_dd_coeff_en_27_mask                               (0x00000008)
#define  ATSC_ADDR_27FB_fbf_gc_dd_coeff_en_26_mask                               (0x00000004)
#define  ATSC_ADDR_27FB_fbf_gc_dd_coeff_en_25_mask                               (0x00000002)
#define  ATSC_ADDR_27FB_fbf_gc_dd_coeff_en_24_mask                               (0x00000001)
#define  ATSC_ADDR_27FB_fbf_gc_dd_coeff_en_31(data)                              (0x00000080&((data)<<7))
#define  ATSC_ADDR_27FB_fbf_gc_dd_coeff_en_30(data)                              (0x00000040&((data)<<6))
#define  ATSC_ADDR_27FB_fbf_gc_dd_coeff_en_29(data)                              (0x00000020&((data)<<5))
#define  ATSC_ADDR_27FB_fbf_gc_dd_coeff_en_28(data)                              (0x00000010&((data)<<4))
#define  ATSC_ADDR_27FB_fbf_gc_dd_coeff_en_27(data)                              (0x00000008&((data)<<3))
#define  ATSC_ADDR_27FB_fbf_gc_dd_coeff_en_26(data)                              (0x00000004&((data)<<2))
#define  ATSC_ADDR_27FB_fbf_gc_dd_coeff_en_25(data)                              (0x00000002&((data)<<1))
#define  ATSC_ADDR_27FB_fbf_gc_dd_coeff_en_24(data)                              (0x00000001&(data))
#define  ATSC_ADDR_27FB_get_fbf_gc_dd_coeff_en_31(data)                          ((0x00000080&(data))>>7)
#define  ATSC_ADDR_27FB_get_fbf_gc_dd_coeff_en_30(data)                          ((0x00000040&(data))>>6)
#define  ATSC_ADDR_27FB_get_fbf_gc_dd_coeff_en_29(data)                          ((0x00000020&(data))>>5)
#define  ATSC_ADDR_27FB_get_fbf_gc_dd_coeff_en_28(data)                          ((0x00000010&(data))>>4)
#define  ATSC_ADDR_27FB_get_fbf_gc_dd_coeff_en_27(data)                          ((0x00000008&(data))>>3)
#define  ATSC_ADDR_27FB_get_fbf_gc_dd_coeff_en_26(data)                          ((0x00000004&(data))>>2)
#define  ATSC_ADDR_27FB_get_fbf_gc_dd_coeff_en_25(data)                          ((0x00000002&(data))>>1)
#define  ATSC_ADDR_27FB_get_fbf_gc_dd_coeff_en_24(data)                          (0x00000001&(data))

#define  ATSC_ADDR_27FC                                                         0x18155FF0
#define  ATSC_ADDR_27FC_reg_addr                                                 "0xB8155FF0"
#define  ATSC_ADDR_27FC_reg                                                      0xB8155FF0
#define  ATSC_ADDR_27FC_inst_addr                                                "0x0420"
#define  set_ATSC_ADDR_27FC_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27FC_reg)=data)
#define  get_ATSC_ADDR_27FC_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27FC_reg))
#define  ATSC_ADDR_27FC_fbf_gc_dd_coeff_en_39_shift                              (7)
#define  ATSC_ADDR_27FC_fbf_gc_dd_coeff_en_38_shift                              (6)
#define  ATSC_ADDR_27FC_fbf_gc_dd_coeff_en_37_shift                              (5)
#define  ATSC_ADDR_27FC_fbf_gc_dd_coeff_en_36_shift                              (4)
#define  ATSC_ADDR_27FC_fbf_gc_dd_coeff_en_35_shift                              (3)
#define  ATSC_ADDR_27FC_fbf_gc_dd_coeff_en_34_shift                              (2)
#define  ATSC_ADDR_27FC_fbf_gc_dd_coeff_en_33_shift                              (1)
#define  ATSC_ADDR_27FC_fbf_gc_dd_coeff_en_32_shift                              (0)
#define  ATSC_ADDR_27FC_fbf_gc_dd_coeff_en_39_mask                               (0x00000080)
#define  ATSC_ADDR_27FC_fbf_gc_dd_coeff_en_38_mask                               (0x00000040)
#define  ATSC_ADDR_27FC_fbf_gc_dd_coeff_en_37_mask                               (0x00000020)
#define  ATSC_ADDR_27FC_fbf_gc_dd_coeff_en_36_mask                               (0x00000010)
#define  ATSC_ADDR_27FC_fbf_gc_dd_coeff_en_35_mask                               (0x00000008)
#define  ATSC_ADDR_27FC_fbf_gc_dd_coeff_en_34_mask                               (0x00000004)
#define  ATSC_ADDR_27FC_fbf_gc_dd_coeff_en_33_mask                               (0x00000002)
#define  ATSC_ADDR_27FC_fbf_gc_dd_coeff_en_32_mask                               (0x00000001)
#define  ATSC_ADDR_27FC_fbf_gc_dd_coeff_en_39(data)                              (0x00000080&((data)<<7))
#define  ATSC_ADDR_27FC_fbf_gc_dd_coeff_en_38(data)                              (0x00000040&((data)<<6))
#define  ATSC_ADDR_27FC_fbf_gc_dd_coeff_en_37(data)                              (0x00000020&((data)<<5))
#define  ATSC_ADDR_27FC_fbf_gc_dd_coeff_en_36(data)                              (0x00000010&((data)<<4))
#define  ATSC_ADDR_27FC_fbf_gc_dd_coeff_en_35(data)                              (0x00000008&((data)<<3))
#define  ATSC_ADDR_27FC_fbf_gc_dd_coeff_en_34(data)                              (0x00000004&((data)<<2))
#define  ATSC_ADDR_27FC_fbf_gc_dd_coeff_en_33(data)                              (0x00000002&((data)<<1))
#define  ATSC_ADDR_27FC_fbf_gc_dd_coeff_en_32(data)                              (0x00000001&(data))
#define  ATSC_ADDR_27FC_get_fbf_gc_dd_coeff_en_39(data)                          ((0x00000080&(data))>>7)
#define  ATSC_ADDR_27FC_get_fbf_gc_dd_coeff_en_38(data)                          ((0x00000040&(data))>>6)
#define  ATSC_ADDR_27FC_get_fbf_gc_dd_coeff_en_37(data)                          ((0x00000020&(data))>>5)
#define  ATSC_ADDR_27FC_get_fbf_gc_dd_coeff_en_36(data)                          ((0x00000010&(data))>>4)
#define  ATSC_ADDR_27FC_get_fbf_gc_dd_coeff_en_35(data)                          ((0x00000008&(data))>>3)
#define  ATSC_ADDR_27FC_get_fbf_gc_dd_coeff_en_34(data)                          ((0x00000004&(data))>>2)
#define  ATSC_ADDR_27FC_get_fbf_gc_dd_coeff_en_33(data)                          ((0x00000002&(data))>>1)
#define  ATSC_ADDR_27FC_get_fbf_gc_dd_coeff_en_32(data)                          (0x00000001&(data))

#define  ATSC_ADDR_27FD                                                         0x18155FF4
#define  ATSC_ADDR_27FD_reg_addr                                                 "0xB8155FF4"
#define  ATSC_ADDR_27FD_reg                                                      0xB8155FF4
#define  ATSC_ADDR_27FD_inst_addr                                                "0x0421"
#define  set_ATSC_ADDR_27FD_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_27FD_reg)=data)
#define  get_ATSC_ADDR_27FD_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_27FD_reg))
#define  ATSC_ADDR_27FD_fbf_gc_dd_coeff_en_42_shift                              (2)
#define  ATSC_ADDR_27FD_fbf_gc_dd_coeff_en_41_shift                              (1)
#define  ATSC_ADDR_27FD_fbf_gc_dd_coeff_en_40_shift                              (0)
#define  ATSC_ADDR_27FD_fbf_gc_dd_coeff_en_42_mask                               (0x00000004)
#define  ATSC_ADDR_27FD_fbf_gc_dd_coeff_en_41_mask                               (0x00000002)
#define  ATSC_ADDR_27FD_fbf_gc_dd_coeff_en_40_mask                               (0x00000001)
#define  ATSC_ADDR_27FD_fbf_gc_dd_coeff_en_42(data)                              (0x00000004&((data)<<2))
#define  ATSC_ADDR_27FD_fbf_gc_dd_coeff_en_41(data)                              (0x00000002&((data)<<1))
#define  ATSC_ADDR_27FD_fbf_gc_dd_coeff_en_40(data)                              (0x00000001&(data))
#define  ATSC_ADDR_27FD_get_fbf_gc_dd_coeff_en_42(data)                          ((0x00000004&(data))>>2)
#define  ATSC_ADDR_27FD_get_fbf_gc_dd_coeff_en_41(data)                          ((0x00000002&(data))>>1)
#define  ATSC_ADDR_27FD_get_fbf_gc_dd_coeff_en_40(data)                          (0x00000001&(data))

#define  ATSC_ADDR_2802                                                         0x18156008
#define  ATSC_ADDR_2802_reg_addr                                                 "0xB8156008"
#define  ATSC_ADDR_2802_reg                                                      0xB8156008
#define  ATSC_ADDR_2802_inst_addr                                                "0x0422"
#define  set_ATSC_ADDR_2802_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2802_reg)=data)
#define  get_ATSC_ADDR_2802_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2802_reg))
#define  ATSC_ADDR_2802_eqpt_in_amp_th_shift                                     (0)
#define  ATSC_ADDR_2802_eqpt_in_amp_th_mask                                      (0x000000FF)
#define  ATSC_ADDR_2802_eqpt_in_amp_th(data)                                     (0x000000FF&(data))
#define  ATSC_ADDR_2802_get_eqpt_in_amp_th(data)                                 (0x000000FF&(data))

#define  ATSC_ADDR_2803                                                         0x1815600C
#define  ATSC_ADDR_2803_reg_addr                                                 "0xB815600C"
#define  ATSC_ADDR_2803_reg                                                      0xB815600C
#define  ATSC_ADDR_2803_inst_addr                                                "0x0423"
#define  set_ATSC_ADDR_2803_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2803_reg)=data)
#define  get_ATSC_ADDR_2803_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2803_reg))
#define  ATSC_ADDR_2803_eqpt_dd_t_shift                                          (0)
#define  ATSC_ADDR_2803_eqpt_dd_t_mask                                           (0x000000FF)
#define  ATSC_ADDR_2803_eqpt_dd_t(data)                                          (0x000000FF&(data))
#define  ATSC_ADDR_2803_get_eqpt_dd_t(data)                                      (0x000000FF&(data))

#define  ATSC_ADDR_2804                                                         0x18156010
#define  ATSC_ADDR_2804_reg_addr                                                 "0xB8156010"
#define  ATSC_ADDR_2804_reg                                                      0xB8156010
#define  ATSC_ADDR_2804_inst_addr                                                "0x0424"
#define  set_ATSC_ADDR_2804_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2804_reg)=data)
#define  get_ATSC_ADDR_2804_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2804_reg))
#define  ATSC_ADDR_2804_eqpt_dd_delta_ph_max_shift                               (0)
#define  ATSC_ADDR_2804_eqpt_dd_delta_ph_max_mask                                (0x0000000F)
#define  ATSC_ADDR_2804_eqpt_dd_delta_ph_max(data)                               (0x0000000F&(data))
#define  ATSC_ADDR_2804_get_eqpt_dd_delta_ph_max(data)                           (0x0000000F&(data))

#define  ATSC_ADDR_2805                                                         0x18156014
#define  ATSC_ADDR_2805_reg_addr                                                 "0xB8156014"
#define  ATSC_ADDR_2805_reg                                                      0xB8156014
#define  ATSC_ADDR_2805_inst_addr                                                "0x0425"
#define  set_ATSC_ADDR_2805_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2805_reg)=data)
#define  get_ATSC_ADDR_2805_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2805_reg))
#define  ATSC_ADDR_2805_eqpt_eq_out_mse_lower_th_7_0_shift                       (0)
#define  ATSC_ADDR_2805_eqpt_eq_out_mse_lower_th_7_0_mask                        (0x000000FF)
#define  ATSC_ADDR_2805_eqpt_eq_out_mse_lower_th_7_0(data)                       (0x000000FF&(data))
#define  ATSC_ADDR_2805_get_eqpt_eq_out_mse_lower_th_7_0(data)                   (0x000000FF&(data))

#define  ATSC_ADDR_2806                                                         0x18156018
#define  ATSC_ADDR_2806_reg_addr                                                 "0xB8156018"
#define  ATSC_ADDR_2806_reg                                                      0xB8156018
#define  ATSC_ADDR_2806_inst_addr                                                "0x0426"
#define  set_ATSC_ADDR_2806_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2806_reg)=data)
#define  get_ATSC_ADDR_2806_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2806_reg))
#define  ATSC_ADDR_2806_eqpt_eq_out_mse_lower_th_12_8_shift                      (0)
#define  ATSC_ADDR_2806_eqpt_eq_out_mse_lower_th_12_8_mask                       (0x0000001F)
#define  ATSC_ADDR_2806_eqpt_eq_out_mse_lower_th_12_8(data)                      (0x0000001F&(data))
#define  ATSC_ADDR_2806_get_eqpt_eq_out_mse_lower_th_12_8(data)                  (0x0000001F&(data))

#define  ATSC_ADDR_2807                                                         0x1815601C
#define  ATSC_ADDR_2807_reg_addr                                                 "0xB815601C"
#define  ATSC_ADDR_2807_reg                                                      0xB815601C
#define  ATSC_ADDR_2807_inst_addr                                                "0x0427"
#define  set_ATSC_ADDR_2807_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2807_reg)=data)
#define  get_ATSC_ADDR_2807_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2807_reg))
#define  ATSC_ADDR_2807_eqpt_eq_out_mse_upper_th_7_0_shift                       (0)
#define  ATSC_ADDR_2807_eqpt_eq_out_mse_upper_th_7_0_mask                        (0x000000FF)
#define  ATSC_ADDR_2807_eqpt_eq_out_mse_upper_th_7_0(data)                       (0x000000FF&(data))
#define  ATSC_ADDR_2807_get_eqpt_eq_out_mse_upper_th_7_0(data)                   (0x000000FF&(data))

#define  ATSC_ADDR_2808                                                         0x18156020
#define  ATSC_ADDR_2808_reg_addr                                                 "0xB8156020"
#define  ATSC_ADDR_2808_reg                                                      0xB8156020
#define  ATSC_ADDR_2808_inst_addr                                                "0x0428"
#define  set_ATSC_ADDR_2808_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2808_reg)=data)
#define  get_ATSC_ADDR_2808_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2808_reg))
#define  ATSC_ADDR_2808_eqpt_eq_out_mse_upper_th_12_8_shift                      (0)
#define  ATSC_ADDR_2808_eqpt_eq_out_mse_upper_th_12_8_mask                       (0x0000001F)
#define  ATSC_ADDR_2808_eqpt_eq_out_mse_upper_th_12_8(data)                      (0x0000001F&(data))
#define  ATSC_ADDR_2808_get_eqpt_eq_out_mse_upper_th_12_8(data)                  (0x0000001F&(data))

#define  ATSC_ADDR_2809                                                         0x18156024
#define  ATSC_ADDR_2809_reg_addr                                                 "0xB8156024"
#define  ATSC_ADDR_2809_reg                                                      0xB8156024
#define  ATSC_ADDR_2809_inst_addr                                                "0x0429"
#define  set_ATSC_ADDR_2809_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2809_reg)=data)
#define  get_ATSC_ADDR_2809_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2809_reg))
#define  ATSC_ADDR_2809_eqpt_mse_field_th_7_0_shift                              (0)
#define  ATSC_ADDR_2809_eqpt_mse_field_th_7_0_mask                               (0x000000FF)
#define  ATSC_ADDR_2809_eqpt_mse_field_th_7_0(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_2809_get_eqpt_mse_field_th_7_0(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_280A                                                         0x18156028
#define  ATSC_ADDR_280A_reg_addr                                                 "0xB8156028"
#define  ATSC_ADDR_280A_reg                                                      0xB8156028
#define  ATSC_ADDR_280A_inst_addr                                                "0x042A"
#define  set_ATSC_ADDR_280A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_280A_reg)=data)
#define  get_ATSC_ADDR_280A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_280A_reg))
#define  ATSC_ADDR_280A_eqpt_mse_field_th_12_8_shift                             (0)
#define  ATSC_ADDR_280A_eqpt_mse_field_th_12_8_mask                              (0x0000001F)
#define  ATSC_ADDR_280A_eqpt_mse_field_th_12_8(data)                             (0x0000001F&(data))
#define  ATSC_ADDR_280A_get_eqpt_mse_field_th_12_8(data)                         (0x0000001F&(data))

#define  ATSC_ADDR_280B                                                         0x1815602C
#define  ATSC_ADDR_280B_reg_addr                                                 "0xB815602C"
#define  ATSC_ADDR_280B_reg                                                      0xB815602C
#define  ATSC_ADDR_280B_inst_addr                                                "0x042B"
#define  set_ATSC_ADDR_280B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_280B_reg)=data)
#define  get_ATSC_ADDR_280B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_280B_reg))
#define  ATSC_ADDR_280B_eqpt_bypass_shift                                        (7)
#define  ATSC_ADDR_280B_eqpt_bn_det_period_shift                                 (4)
#define  ATSC_ADDR_280B_eqpt_mse_est_64_shift                                    (3)
#define  ATSC_ADDR_280B_eqpt_mse_est_late_shift                                  (2)
#define  ATSC_ADDR_280B_eqpt_mse_exp_shift                                       (0)
#define  ATSC_ADDR_280B_eqpt_bypass_mask                                         (0x00000080)
#define  ATSC_ADDR_280B_eqpt_bn_det_period_mask                                  (0x00000070)
#define  ATSC_ADDR_280B_eqpt_mse_est_64_mask                                     (0x00000008)
#define  ATSC_ADDR_280B_eqpt_mse_est_late_mask                                   (0x00000004)
#define  ATSC_ADDR_280B_eqpt_mse_exp_mask                                        (0x00000003)
#define  ATSC_ADDR_280B_eqpt_bypass(data)                                        (0x00000080&((data)<<7))
#define  ATSC_ADDR_280B_eqpt_bn_det_period(data)                                 (0x00000070&((data)<<4))
#define  ATSC_ADDR_280B_eqpt_mse_est_64(data)                                    (0x00000008&((data)<<3))
#define  ATSC_ADDR_280B_eqpt_mse_est_late(data)                                  (0x00000004&((data)<<2))
#define  ATSC_ADDR_280B_eqpt_mse_exp(data)                                       (0x00000003&(data))
#define  ATSC_ADDR_280B_get_eqpt_bypass(data)                                    ((0x00000080&(data))>>7)
#define  ATSC_ADDR_280B_get_eqpt_bn_det_period(data)                             ((0x00000070&(data))>>4)
#define  ATSC_ADDR_280B_get_eqpt_mse_est_64(data)                                ((0x00000008&(data))>>3)
#define  ATSC_ADDR_280B_get_eqpt_mse_est_late(data)                              ((0x00000004&(data))>>2)
#define  ATSC_ADDR_280B_get_eqpt_mse_exp(data)                                   (0x00000003&(data))

#define  ATSC_ADDR_280C                                                         0x18156030
#define  ATSC_ADDR_280C_reg_addr                                                 "0xB8156030"
#define  ATSC_ADDR_280C_reg                                                      0xB8156030
#define  ATSC_ADDR_280C_inst_addr                                                "0x042C"
#define  set_ATSC_ADDR_280C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_280C_reg)=data)
#define  get_ATSC_ADDR_280C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_280C_reg))
#define  ATSC_ADDR_280C_bn_eq_stop_en_shift                                      (6)
#define  ATSC_ADDR_280C_bn_dagc_stop_en_shift                                    (5)
#define  ATSC_ADDR_280C_bn_aagc_stop_en_shift                                    (4)
#define  ATSC_ADDR_280C_eqpt_dd_er_amp_th_shift                                  (0)
#define  ATSC_ADDR_280C_bn_eq_stop_en_mask                                       (0x00000040)
#define  ATSC_ADDR_280C_bn_dagc_stop_en_mask                                     (0x00000020)
#define  ATSC_ADDR_280C_bn_aagc_stop_en_mask                                     (0x00000010)
#define  ATSC_ADDR_280C_eqpt_dd_er_amp_th_mask                                   (0x0000000F)
#define  ATSC_ADDR_280C_bn_eq_stop_en(data)                                      (0x00000040&((data)<<6))
#define  ATSC_ADDR_280C_bn_dagc_stop_en(data)                                    (0x00000020&((data)<<5))
#define  ATSC_ADDR_280C_bn_aagc_stop_en(data)                                    (0x00000010&((data)<<4))
#define  ATSC_ADDR_280C_eqpt_dd_er_amp_th(data)                                  (0x0000000F&(data))
#define  ATSC_ADDR_280C_get_bn_eq_stop_en(data)                                  ((0x00000040&(data))>>6)
#define  ATSC_ADDR_280C_get_bn_dagc_stop_en(data)                                ((0x00000020&(data))>>5)
#define  ATSC_ADDR_280C_get_bn_aagc_stop_en(data)                                ((0x00000010&(data))>>4)
#define  ATSC_ADDR_280C_get_eqpt_dd_er_amp_th(data)                              (0x0000000F&(data))

#define  ATSC_ADDR_280D                                                         0x18156034
#define  ATSC_ADDR_280D_reg_addr                                                 "0xB8156034"
#define  ATSC_ADDR_280D_reg                                                      0xB8156034
#define  ATSC_ADDR_280D_inst_addr                                                "0x042D"
#define  set_ATSC_ADDR_280D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_280D_reg)=data)
#define  get_ATSC_ADDR_280D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_280D_reg))
#define  ATSC_ADDR_280D_bn_agc_eqpt_mse_th_7_0_shift                             (0)
#define  ATSC_ADDR_280D_bn_agc_eqpt_mse_th_7_0_mask                              (0x000000FF)
#define  ATSC_ADDR_280D_bn_agc_eqpt_mse_th_7_0(data)                             (0x000000FF&(data))
#define  ATSC_ADDR_280D_get_bn_agc_eqpt_mse_th_7_0(data)                         (0x000000FF&(data))

#define  ATSC_ADDR_280E                                                         0x18156038
#define  ATSC_ADDR_280E_reg_addr                                                 "0xB8156038"
#define  ATSC_ADDR_280E_reg                                                      0xB8156038
#define  ATSC_ADDR_280E_inst_addr                                                "0x042E"
#define  set_ATSC_ADDR_280E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_280E_reg)=data)
#define  get_ATSC_ADDR_280E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_280E_reg))
#define  ATSC_ADDR_280E_bn_agc_eqpt_mse_th_11_8_shift                            (0)
#define  ATSC_ADDR_280E_bn_agc_eqpt_mse_th_11_8_mask                             (0x0000000F)
#define  ATSC_ADDR_280E_bn_agc_eqpt_mse_th_11_8(data)                            (0x0000000F&(data))
#define  ATSC_ADDR_280E_get_bn_agc_eqpt_mse_th_11_8(data)                        (0x0000000F&(data))

#define  ATSC_ADDR_280F                                                         0x1815603C
#define  ATSC_ADDR_280F_reg_addr                                                 "0xB815603C"
#define  ATSC_ADDR_280F_reg                                                      0xB815603C
#define  ATSC_ADDR_280F_inst_addr                                                "0x042F"
#define  set_ATSC_ADDR_280F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_280F_reg)=data)
#define  get_ATSC_ADDR_280F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_280F_reg))
#define  ATSC_ADDR_280F_bn_agc_mse_field_th_7_0_shift                            (0)
#define  ATSC_ADDR_280F_bn_agc_mse_field_th_7_0_mask                             (0x000000FF)
#define  ATSC_ADDR_280F_bn_agc_mse_field_th_7_0(data)                            (0x000000FF&(data))
#define  ATSC_ADDR_280F_get_bn_agc_mse_field_th_7_0(data)                        (0x000000FF&(data))

#define  ATSC_ADDR_2810                                                         0x18156040
#define  ATSC_ADDR_2810_reg_addr                                                 "0xB8156040"
#define  ATSC_ADDR_2810_reg                                                      0xB8156040
#define  ATSC_ADDR_2810_inst_addr                                                "0x0430"
#define  set_ATSC_ADDR_2810_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2810_reg)=data)
#define  get_ATSC_ADDR_2810_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2810_reg))
#define  ATSC_ADDR_2810_eqpt_ind_cnt1_prd_shift                                  (4)
#define  ATSC_ADDR_2810_bn_agc_mse_field_th_11_8_shift                           (0)
#define  ATSC_ADDR_2810_eqpt_ind_cnt1_prd_mask                                   (0x000000F0)
#define  ATSC_ADDR_2810_bn_agc_mse_field_th_11_8_mask                            (0x0000000F)
#define  ATSC_ADDR_2810_eqpt_ind_cnt1_prd(data)                                  (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2810_bn_agc_mse_field_th_11_8(data)                           (0x0000000F&(data))
#define  ATSC_ADDR_2810_get_eqpt_ind_cnt1_prd(data)                              ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2810_get_bn_agc_mse_field_th_11_8(data)                       (0x0000000F&(data))

#define  ATSC_ADDR_2811                                                         0x18156044
#define  ATSC_ADDR_2811_reg_addr                                                 "0xB8156044"
#define  ATSC_ADDR_2811_reg                                                      0xB8156044
#define  ATSC_ADDR_2811_inst_addr                                                "0x0431"
#define  set_ATSC_ADDR_2811_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2811_reg)=data)
#define  get_ATSC_ADDR_2811_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2811_reg))
#define  ATSC_ADDR_2811_eqpt_ind_cnt2_prd_shift                                  (4)
#define  ATSC_ADDR_2811_eqpt_ind_cnt1_th_shift                                   (0)
#define  ATSC_ADDR_2811_eqpt_ind_cnt2_prd_mask                                   (0x000000F0)
#define  ATSC_ADDR_2811_eqpt_ind_cnt1_th_mask                                    (0x0000000F)
#define  ATSC_ADDR_2811_eqpt_ind_cnt2_prd(data)                                  (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2811_eqpt_ind_cnt1_th(data)                                   (0x0000000F&(data))
#define  ATSC_ADDR_2811_get_eqpt_ind_cnt2_prd(data)                              ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2811_get_eqpt_ind_cnt1_th(data)                               (0x0000000F&(data))

#define  ATSC_ADDR_2812                                                         0x18156048
#define  ATSC_ADDR_2812_reg_addr                                                 "0xB8156048"
#define  ATSC_ADDR_2812_reg                                                      0xB8156048
#define  ATSC_ADDR_2812_inst_addr                                                "0x0432"
#define  set_ATSC_ADDR_2812_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2812_reg)=data)
#define  get_ATSC_ADDR_2812_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2812_reg))
#define  ATSC_ADDR_2812_eqpt_ind_cnt2_th_shift                                   (0)
#define  ATSC_ADDR_2812_eqpt_ind_cnt2_th_mask                                    (0x000000FF)
#define  ATSC_ADDR_2812_eqpt_ind_cnt2_th(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_2812_get_eqpt_ind_cnt2_th(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_2813                                                         0x1815604C
#define  ATSC_ADDR_2813_reg_addr                                                 "0xB815604C"
#define  ATSC_ADDR_2813_reg                                                      0xB815604C
#define  ATSC_ADDR_2813_inst_addr                                                "0x0433"
#define  set_ATSC_ADDR_2813_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2813_reg)=data)
#define  get_ATSC_ADDR_2813_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2813_reg))
#define  ATSC_ADDR_2813_bn_pred_wait_th_shift                                    (0)
#define  ATSC_ADDR_2813_bn_pred_wait_th_mask                                     (0x000000FF)
#define  ATSC_ADDR_2813_bn_pred_wait_th(data)                                    (0x000000FF&(data))
#define  ATSC_ADDR_2813_get_bn_pred_wait_th(data)                                (0x000000FF&(data))

#define  ATSC_ADDR_2814                                                         0x18156050
#define  ATSC_ADDR_2814_reg_addr                                                 "0xB8156050"
#define  ATSC_ADDR_2814_reg                                                      0xB8156050
#define  ATSC_ADDR_2814_inst_addr                                                "0x0434"
#define  set_ATSC_ADDR_2814_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2814_reg)=data)
#define  get_ATSC_ADDR_2814_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2814_reg))
#define  ATSC_ADDR_2814_bn_pred_period_7_0_shift                                 (0)
#define  ATSC_ADDR_2814_bn_pred_period_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_2814_bn_pred_period_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2814_get_bn_pred_period_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2815                                                         0x18156054
#define  ATSC_ADDR_2815_reg_addr                                                 "0xB8156054"
#define  ATSC_ADDR_2815_reg                                                      0xB8156054
#define  ATSC_ADDR_2815_inst_addr                                                "0x0435"
#define  set_ATSC_ADDR_2815_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2815_reg)=data)
#define  get_ATSC_ADDR_2815_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2815_reg))
#define  ATSC_ADDR_2815_bn_pred_period_15_8_shift                                (0)
#define  ATSC_ADDR_2815_bn_pred_period_15_8_mask                                 (0x000000FF)
#define  ATSC_ADDR_2815_bn_pred_period_15_8(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2815_get_bn_pred_period_15_8(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2816                                                         0x18156058
#define  ATSC_ADDR_2816_reg_addr                                                 "0xB8156058"
#define  ATSC_ADDR_2816_reg                                                      0xB8156058
#define  ATSC_ADDR_2816_inst_addr                                                "0x0436"
#define  set_ATSC_ADDR_2816_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2816_reg)=data)
#define  get_ATSC_ADDR_2816_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2816_reg))
#define  ATSC_ADDR_2816_bn_pred_regular_shift                                    (5)
#define  ATSC_ADDR_2816_bn_pred_period_20_16_shift                               (0)
#define  ATSC_ADDR_2816_bn_pred_regular_mask                                     (0x00000020)
#define  ATSC_ADDR_2816_bn_pred_period_20_16_mask                                (0x0000001F)
#define  ATSC_ADDR_2816_bn_pred_regular(data)                                    (0x00000020&((data)<<5))
#define  ATSC_ADDR_2816_bn_pred_period_20_16(data)                               (0x0000001F&(data))
#define  ATSC_ADDR_2816_get_bn_pred_regular(data)                                ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2816_get_bn_pred_period_20_16(data)                           (0x0000001F&(data))

#define  ATSC_ADDR_2817                                                         0x1815605C
#define  ATSC_ADDR_2817_reg_addr                                                 "0xB815605C"
#define  ATSC_ADDR_2817_reg                                                      0xB815605C
#define  ATSC_ADDR_2817_inst_addr                                                "0x0437"
#define  set_ATSC_ADDR_2817_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2817_reg)=data)
#define  get_ATSC_ADDR_2817_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2817_reg))
#define  ATSC_ADDR_2817_bn_pred_cnt_th1_7_0_shift                                (0)
#define  ATSC_ADDR_2817_bn_pred_cnt_th1_7_0_mask                                 (0x000000FF)
#define  ATSC_ADDR_2817_bn_pred_cnt_th1_7_0(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2817_get_bn_pred_cnt_th1_7_0(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2818                                                         0x18156060
#define  ATSC_ADDR_2818_reg_addr                                                 "0xB8156060"
#define  ATSC_ADDR_2818_reg                                                      0xB8156060
#define  ATSC_ADDR_2818_inst_addr                                                "0x0438"
#define  set_ATSC_ADDR_2818_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2818_reg)=data)
#define  get_ATSC_ADDR_2818_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2818_reg))
#define  ATSC_ADDR_2818_bn_pred_cnt_th1_13_8_shift                               (0)
#define  ATSC_ADDR_2818_bn_pred_cnt_th1_13_8_mask                                (0x0000003F)
#define  ATSC_ADDR_2818_bn_pred_cnt_th1_13_8(data)                               (0x0000003F&(data))
#define  ATSC_ADDR_2818_get_bn_pred_cnt_th1_13_8(data)                           (0x0000003F&(data))

#define  ATSC_ADDR_2819                                                         0x18156064
#define  ATSC_ADDR_2819_reg_addr                                                 "0xB8156064"
#define  ATSC_ADDR_2819_reg                                                      0xB8156064
#define  ATSC_ADDR_2819_inst_addr                                                "0x0439"
#define  set_ATSC_ADDR_2819_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2819_reg)=data)
#define  get_ATSC_ADDR_2819_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2819_reg))
#define  ATSC_ADDR_2819_bn_pred_cnt_th2_7_0_shift                                (0)
#define  ATSC_ADDR_2819_bn_pred_cnt_th2_7_0_mask                                 (0x000000FF)
#define  ATSC_ADDR_2819_bn_pred_cnt_th2_7_0(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2819_get_bn_pred_cnt_th2_7_0(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_281A                                                         0x18156068
#define  ATSC_ADDR_281A_reg_addr                                                 "0xB8156068"
#define  ATSC_ADDR_281A_reg                                                      0xB8156068
#define  ATSC_ADDR_281A_inst_addr                                                "0x043A"
#define  set_ATSC_ADDR_281A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_281A_reg)=data)
#define  get_ATSC_ADDR_281A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_281A_reg))
#define  ATSC_ADDR_281A_bn_pred_cnt_th2_13_8_shift                               (0)
#define  ATSC_ADDR_281A_bn_pred_cnt_th2_13_8_mask                                (0x0000003F)
#define  ATSC_ADDR_281A_bn_pred_cnt_th2_13_8(data)                               (0x0000003F&(data))
#define  ATSC_ADDR_281A_get_bn_pred_cnt_th2_13_8(data)                           (0x0000003F&(data))

#define  ATSC_ADDR_281B                                                         0x1815606C
#define  ATSC_ADDR_281B_reg_addr                                                 "0xB815606C"
#define  ATSC_ADDR_281B_reg                                                      0xB815606C
#define  ATSC_ADDR_281B_inst_addr                                                "0x043B"
#define  set_ATSC_ADDR_281B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_281B_reg)=data)
#define  get_ATSC_ADDR_281B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_281B_reg))
#define  ATSC_ADDR_281B_bn_pred_cnt_th3_7_0_shift                                (0)
#define  ATSC_ADDR_281B_bn_pred_cnt_th3_7_0_mask                                 (0x000000FF)
#define  ATSC_ADDR_281B_bn_pred_cnt_th3_7_0(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_281B_get_bn_pred_cnt_th3_7_0(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_281C                                                         0x18156070
#define  ATSC_ADDR_281C_reg_addr                                                 "0xB8156070"
#define  ATSC_ADDR_281C_reg                                                      0xB8156070
#define  ATSC_ADDR_281C_inst_addr                                                "0x043C"
#define  set_ATSC_ADDR_281C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_281C_reg)=data)
#define  get_ATSC_ADDR_281C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_281C_reg))
#define  ATSC_ADDR_281C_bn_pred_cnt_th3_13_8_shift                               (0)
#define  ATSC_ADDR_281C_bn_pred_cnt_th3_13_8_mask                                (0x0000003F)
#define  ATSC_ADDR_281C_bn_pred_cnt_th3_13_8(data)                               (0x0000003F&(data))
#define  ATSC_ADDR_281C_get_bn_pred_cnt_th3_13_8(data)                           (0x0000003F&(data))

#define  ATSC_ADDR_281D                                                         0x18156074
#define  ATSC_ADDR_281D_reg_addr                                                 "0xB8156074"
#define  ATSC_ADDR_281D_reg                                                      0xB8156074
#define  ATSC_ADDR_281D_inst_addr                                                "0x043D"
#define  set_ATSC_ADDR_281D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_281D_reg)=data)
#define  get_ATSC_ADDR_281D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_281D_reg))
#define  ATSC_ADDR_281D_eqpt_dd_step_size_exp_1_shift                            (5)
#define  ATSC_ADDR_281D_eqpt_dd_step_size_exp_0_shift                            (2)
#define  ATSC_ADDR_281D_pn_det_acc_exp_shift                                     (0)
#define  ATSC_ADDR_281D_eqpt_dd_step_size_exp_1_mask                             (0x000000E0)
#define  ATSC_ADDR_281D_eqpt_dd_step_size_exp_0_mask                             (0x0000001C)
#define  ATSC_ADDR_281D_pn_det_acc_exp_mask                                      (0x00000003)
#define  ATSC_ADDR_281D_eqpt_dd_step_size_exp_1(data)                            (0x000000E0&((data)<<5))
#define  ATSC_ADDR_281D_eqpt_dd_step_size_exp_0(data)                            (0x0000001C&((data)<<2))
#define  ATSC_ADDR_281D_pn_det_acc_exp(data)                                     (0x00000003&(data))
#define  ATSC_ADDR_281D_get_eqpt_dd_step_size_exp_1(data)                        ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_281D_get_eqpt_dd_step_size_exp_0(data)                        ((0x0000001C&(data))>>2)
#define  ATSC_ADDR_281D_get_pn_det_acc_exp(data)                                 (0x00000003&(data))

#define  ATSC_ADDR_281E                                                         0x18156078
#define  ATSC_ADDR_281E_reg_addr                                                 "0xB8156078"
#define  ATSC_ADDR_281E_reg                                                      0xB8156078
#define  ATSC_ADDR_281E_inst_addr                                                "0x043E"
#define  set_ATSC_ADDR_281E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_281E_reg)=data)
#define  get_ATSC_ADDR_281E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_281E_reg))
#define  ATSC_ADDR_281E_pn_det_mse_field_th_7_0_shift                            (0)
#define  ATSC_ADDR_281E_pn_det_mse_field_th_7_0_mask                             (0x000000FF)
#define  ATSC_ADDR_281E_pn_det_mse_field_th_7_0(data)                            (0x000000FF&(data))
#define  ATSC_ADDR_281E_get_pn_det_mse_field_th_7_0(data)                        (0x000000FF&(data))

#define  ATSC_ADDR_281F                                                         0x1815607C
#define  ATSC_ADDR_281F_reg_addr                                                 "0xB815607C"
#define  ATSC_ADDR_281F_reg                                                      0xB815607C
#define  ATSC_ADDR_281F_inst_addr                                                "0x043F"
#define  set_ATSC_ADDR_281F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_281F_reg)=data)
#define  get_ATSC_ADDR_281F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_281F_reg))
#define  ATSC_ADDR_281F_pn_det_mse_field_th_9_8_shift                            (0)
#define  ATSC_ADDR_281F_pn_det_mse_field_th_9_8_mask                             (0x00000003)
#define  ATSC_ADDR_281F_pn_det_mse_field_th_9_8(data)                            (0x00000003&(data))
#define  ATSC_ADDR_281F_get_pn_det_mse_field_th_9_8(data)                        (0x00000003&(data))

#define  ATSC_ADDR_2820                                                         0x18156080
#define  ATSC_ADDR_2820_reg_addr                                                 "0xB8156080"
#define  ATSC_ADDR_2820_reg                                                      0xB8156080
#define  ATSC_ADDR_2820_inst_addr                                                "0x0440"
#define  set_ATSC_ADDR_2820_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2820_reg)=data)
#define  get_ATSC_ADDR_2820_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2820_reg))
#define  ATSC_ADDR_2820_pn_det_mse_th_7_0_shift                                  (0)
#define  ATSC_ADDR_2820_pn_det_mse_th_7_0_mask                                   (0x000000FF)
#define  ATSC_ADDR_2820_pn_det_mse_th_7_0(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2820_get_pn_det_mse_th_7_0(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2821                                                         0x18156084
#define  ATSC_ADDR_2821_reg_addr                                                 "0xB8156084"
#define  ATSC_ADDR_2821_reg                                                      0xB8156084
#define  ATSC_ADDR_2821_inst_addr                                                "0x0441"
#define  set_ATSC_ADDR_2821_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2821_reg)=data)
#define  get_ATSC_ADDR_2821_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2821_reg))
#define  ATSC_ADDR_2821_pn_det_mse_th_9_8_shift                                  (0)
#define  ATSC_ADDR_2821_pn_det_mse_th_9_8_mask                                   (0x00000003)
#define  ATSC_ADDR_2821_pn_det_mse_th_9_8(data)                                  (0x00000003&(data))
#define  ATSC_ADDR_2821_get_pn_det_mse_th_9_8(data)                              (0x00000003&(data))

#define  ATSC_ADDR_2822                                                         0x18156088
#define  ATSC_ADDR_2822_reg_addr                                                 "0xB8156088"
#define  ATSC_ADDR_2822_reg                                                      0xB8156088
#define  ATSC_ADDR_2822_inst_addr                                                "0x0442"
#define  set_ATSC_ADDR_2822_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2822_reg)=data)
#define  get_ATSC_ADDR_2822_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2822_reg))
#define  ATSC_ADDR_2822_pn_det_acc_th_7_0_shift                                  (0)
#define  ATSC_ADDR_2822_pn_det_acc_th_7_0_mask                                   (0x000000FF)
#define  ATSC_ADDR_2822_pn_det_acc_th_7_0(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2822_get_pn_det_acc_th_7_0(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2823                                                         0x1815608C
#define  ATSC_ADDR_2823_reg_addr                                                 "0xB815608C"
#define  ATSC_ADDR_2823_reg                                                      0xB815608C
#define  ATSC_ADDR_2823_inst_addr                                                "0x0443"
#define  set_ATSC_ADDR_2823_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2823_reg)=data)
#define  get_ATSC_ADDR_2823_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2823_reg))
#define  ATSC_ADDR_2823_pn_det_acc_th_9_8_shift                                  (0)
#define  ATSC_ADDR_2823_pn_det_acc_th_9_8_mask                                   (0x00000003)
#define  ATSC_ADDR_2823_pn_det_acc_th_9_8(data)                                  (0x00000003&(data))
#define  ATSC_ADDR_2823_get_pn_det_acc_th_9_8(data)                              (0x00000003&(data))

#define  ATSC_ADDR_2824                                                         0x18156090
#define  ATSC_ADDR_2824_reg_addr                                                 "0xB8156090"
#define  ATSC_ADDR_2824_reg                                                      0xB8156090
#define  ATSC_ADDR_2824_inst_addr                                                "0x0444"
#define  set_ATSC_ADDR_2824_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2824_reg)=data)
#define  get_ATSC_ADDR_2824_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2824_reg))
#define  ATSC_ADDR_2824_bn_pt_stop_en_shift                                      (6)
#define  ATSC_ADDR_2824_eqpt_dd_ph_max_shift                                     (0)
#define  ATSC_ADDR_2824_bn_pt_stop_en_mask                                       (0x00000040)
#define  ATSC_ADDR_2824_eqpt_dd_ph_max_mask                                      (0x0000003F)
#define  ATSC_ADDR_2824_bn_pt_stop_en(data)                                      (0x00000040&((data)<<6))
#define  ATSC_ADDR_2824_eqpt_dd_ph_max(data)                                     (0x0000003F&(data))
#define  ATSC_ADDR_2824_get_bn_pt_stop_en(data)                                  ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2824_get_eqpt_dd_ph_max(data)                                 (0x0000003F&(data))

#define  ATSC_ADDR_2825                                                         0x18156094
#define  ATSC_ADDR_2825_reg_addr                                                 "0xB8156094"
#define  ATSC_ADDR_2825_reg                                                      0xB8156094
#define  ATSC_ADDR_2825_inst_addr                                                "0x0445"
#define  set_ATSC_ADDR_2825_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2825_reg)=data)
#define  get_ATSC_ADDR_2825_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2825_reg))
#define  ATSC_ADDR_2825_pn_det_mse_field_th_cr_7_0_shift                         (0)
#define  ATSC_ADDR_2825_pn_det_mse_field_th_cr_7_0_mask                          (0x000000FF)
#define  ATSC_ADDR_2825_pn_det_mse_field_th_cr_7_0(data)                         (0x000000FF&(data))
#define  ATSC_ADDR_2825_get_pn_det_mse_field_th_cr_7_0(data)                     (0x000000FF&(data))

#define  ATSC_ADDR_2826                                                         0x18156098
#define  ATSC_ADDR_2826_reg_addr                                                 "0xB8156098"
#define  ATSC_ADDR_2826_reg                                                      0xB8156098
#define  ATSC_ADDR_2826_inst_addr                                                "0x0446"
#define  set_ATSC_ADDR_2826_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2826_reg)=data)
#define  get_ATSC_ADDR_2826_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2826_reg))
#define  ATSC_ADDR_2826_pn_det_mse_th_cr_5_0_shift                               (2)
#define  ATSC_ADDR_2826_pn_det_mse_field_th_cr_9_8_shift                         (0)
#define  ATSC_ADDR_2826_pn_det_mse_th_cr_5_0_mask                                (0x000000FC)
#define  ATSC_ADDR_2826_pn_det_mse_field_th_cr_9_8_mask                          (0x00000003)
#define  ATSC_ADDR_2826_pn_det_mse_th_cr_5_0(data)                               (0x000000FC&((data)<<2))
#define  ATSC_ADDR_2826_pn_det_mse_field_th_cr_9_8(data)                         (0x00000003&(data))
#define  ATSC_ADDR_2826_get_pn_det_mse_th_cr_5_0(data)                           ((0x000000FC&(data))>>2)
#define  ATSC_ADDR_2826_get_pn_det_mse_field_th_cr_9_8(data)                     (0x00000003&(data))

#define  ATSC_ADDR_2827                                                         0x1815609C
#define  ATSC_ADDR_2827_reg_addr                                                 "0xB815609C"
#define  ATSC_ADDR_2827_reg                                                      0xB815609C
#define  ATSC_ADDR_2827_inst_addr                                                "0x0447"
#define  set_ATSC_ADDR_2827_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2827_reg)=data)
#define  get_ATSC_ADDR_2827_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2827_reg))
#define  ATSC_ADDR_2827_pn_det_mse_th_cr_9_6_shift                               (0)
#define  ATSC_ADDR_2827_pn_det_mse_th_cr_9_6_mask                                (0x0000000F)
#define  ATSC_ADDR_2827_pn_det_mse_th_cr_9_6(data)                               (0x0000000F&(data))
#define  ATSC_ADDR_2827_get_pn_det_mse_th_cr_9_6(data)                           (0x0000000F&(data))

#define  ATSC_ADDR_2828                                                         0x181560A0
#define  ATSC_ADDR_2828_reg_addr                                                 "0xB81560A0"
#define  ATSC_ADDR_2828_reg                                                      0xB81560A0
#define  ATSC_ADDR_2828_inst_addr                                                "0x0448"
#define  set_ATSC_ADDR_2828_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2828_reg)=data)
#define  get_ATSC_ADDR_2828_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2828_reg))
#define  ATSC_ADDR_2828_pn_det_acc_th_cr_7_0_shift                               (0)
#define  ATSC_ADDR_2828_pn_det_acc_th_cr_7_0_mask                                (0x000000FF)
#define  ATSC_ADDR_2828_pn_det_acc_th_cr_7_0(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_2828_get_pn_det_acc_th_cr_7_0(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_2829                                                         0x181560A4
#define  ATSC_ADDR_2829_reg_addr                                                 "0xB81560A4"
#define  ATSC_ADDR_2829_reg                                                      0xB81560A4
#define  ATSC_ADDR_2829_inst_addr                                                "0x0449"
#define  set_ATSC_ADDR_2829_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2829_reg)=data)
#define  get_ATSC_ADDR_2829_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2829_reg))
#define  ATSC_ADDR_2829_pn_det_acc_th_cr_9_8_shift                               (0)
#define  ATSC_ADDR_2829_pn_det_acc_th_cr_9_8_mask                                (0x00000003)
#define  ATSC_ADDR_2829_pn_det_acc_th_cr_9_8(data)                               (0x00000003&(data))
#define  ATSC_ADDR_2829_get_pn_det_acc_th_cr_9_8(data)                           (0x00000003&(data))

#define  ATSC_ADDR_282A                                                         0x181560A8
#define  ATSC_ADDR_282A_reg_addr                                                 "0xB81560A8"
#define  ATSC_ADDR_282A_reg                                                      0xB81560A8
#define  ATSC_ADDR_282A_inst_addr                                                "0x044A"
#define  set_ATSC_ADDR_282A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_282A_reg)=data)
#define  get_ATSC_ADDR_282A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_282A_reg))
#define  ATSC_ADDR_282A_pn_det_mse_field_th_pt_7_0_shift                         (0)
#define  ATSC_ADDR_282A_pn_det_mse_field_th_pt_7_0_mask                          (0x000000FF)
#define  ATSC_ADDR_282A_pn_det_mse_field_th_pt_7_0(data)                         (0x000000FF&(data))
#define  ATSC_ADDR_282A_get_pn_det_mse_field_th_pt_7_0(data)                     (0x000000FF&(data))

#define  ATSC_ADDR_282B                                                         0x181560AC
#define  ATSC_ADDR_282B_reg_addr                                                 "0xB81560AC"
#define  ATSC_ADDR_282B_reg                                                      0xB81560AC
#define  ATSC_ADDR_282B_inst_addr                                                "0x044B"
#define  set_ATSC_ADDR_282B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_282B_reg)=data)
#define  get_ATSC_ADDR_282B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_282B_reg))
#define  ATSC_ADDR_282B_pn_det_mse_field_th_pt_9_8_shift                         (0)
#define  ATSC_ADDR_282B_pn_det_mse_field_th_pt_9_8_mask                          (0x00000003)
#define  ATSC_ADDR_282B_pn_det_mse_field_th_pt_9_8(data)                         (0x00000003&(data))
#define  ATSC_ADDR_282B_get_pn_det_mse_field_th_pt_9_8(data)                     (0x00000003&(data))

#define  ATSC_ADDR_282C                                                         0x181560B0
#define  ATSC_ADDR_282C_reg_addr                                                 "0xB81560B0"
#define  ATSC_ADDR_282C_reg                                                      0xB81560B0
#define  ATSC_ADDR_282C_inst_addr                                                "0x044C"
#define  set_ATSC_ADDR_282C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_282C_reg)=data)
#define  get_ATSC_ADDR_282C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_282C_reg))
#define  ATSC_ADDR_282C_pn_det_mse_th_pt_7_0_shift                               (0)
#define  ATSC_ADDR_282C_pn_det_mse_th_pt_7_0_mask                                (0x000000FF)
#define  ATSC_ADDR_282C_pn_det_mse_th_pt_7_0(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_282C_get_pn_det_mse_th_pt_7_0(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_282D                                                         0x181560B4
#define  ATSC_ADDR_282D_reg_addr                                                 "0xB81560B4"
#define  ATSC_ADDR_282D_reg                                                      0xB81560B4
#define  ATSC_ADDR_282D_inst_addr                                                "0x044D"
#define  set_ATSC_ADDR_282D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_282D_reg)=data)
#define  get_ATSC_ADDR_282D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_282D_reg))
#define  ATSC_ADDR_282D_pn_det_mse_th_pt_9_8_shift                               (0)
#define  ATSC_ADDR_282D_pn_det_mse_th_pt_9_8_mask                                (0x00000003)
#define  ATSC_ADDR_282D_pn_det_mse_th_pt_9_8(data)                               (0x00000003&(data))
#define  ATSC_ADDR_282D_get_pn_det_mse_th_pt_9_8(data)                           (0x00000003&(data))

#define  ATSC_ADDR_282E                                                         0x181560B8
#define  ATSC_ADDR_282E_reg_addr                                                 "0xB81560B8"
#define  ATSC_ADDR_282E_reg                                                      0xB81560B8
#define  ATSC_ADDR_282E_inst_addr                                                "0x044E"
#define  set_ATSC_ADDR_282E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_282E_reg)=data)
#define  get_ATSC_ADDR_282E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_282E_reg))
#define  ATSC_ADDR_282E_pn_det_acc_th_pt_7_0_shift                               (0)
#define  ATSC_ADDR_282E_pn_det_acc_th_pt_7_0_mask                                (0x000000FF)
#define  ATSC_ADDR_282E_pn_det_acc_th_pt_7_0(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_282E_get_pn_det_acc_th_pt_7_0(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_282F                                                         0x181560BC
#define  ATSC_ADDR_282F_reg_addr                                                 "0xB81560BC"
#define  ATSC_ADDR_282F_reg                                                      0xB81560BC
#define  ATSC_ADDR_282F_inst_addr                                                "0x044F"
#define  set_ATSC_ADDR_282F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_282F_reg)=data)
#define  get_ATSC_ADDR_282F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_282F_reg))
#define  ATSC_ADDR_282F_pn_det_acc_th_pt_9_8_shift                               (0)
#define  ATSC_ADDR_282F_pn_det_acc_th_pt_9_8_mask                                (0x00000003)
#define  ATSC_ADDR_282F_pn_det_acc_th_pt_9_8(data)                               (0x00000003&(data))
#define  ATSC_ADDR_282F_get_pn_det_acc_th_pt_9_8(data)                           (0x00000003&(data))

#define  ATSC_ADDR_2830                                                         0x181560C0
#define  ATSC_ADDR_2830_reg_addr                                                 "0xB81560C0"
#define  ATSC_ADDR_2830_reg                                                      0xB81560C0
#define  ATSC_ADDR_2830_inst_addr                                                "0x0450"
#define  set_ATSC_ADDR_2830_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2830_reg)=data)
#define  get_ATSC_ADDR_2830_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2830_reg))
#define  ATSC_ADDR_2830_ld_rst_n_shift                                           (0)
#define  ATSC_ADDR_2830_ld_rst_n_mask                                            (0x00000001)
#define  ATSC_ADDR_2830_ld_rst_n(data)                                           (0x00000001&(data))
#define  ATSC_ADDR_2830_get_ld_rst_n(data)                                       (0x00000001&(data))

#define  ATSC_ADDR_2831                                                         0x181560C4
#define  ATSC_ADDR_2831_reg_addr                                                 "0xB81560C4"
#define  ATSC_ADDR_2831_reg                                                      0xB81560C4
#define  ATSC_ADDR_2831_inst_addr                                                "0x0451"
#define  set_ATSC_ADDR_2831_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2831_reg)=data)
#define  get_ATSC_ADDR_2831_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2831_reg))
#define  ATSC_ADDR_2831_ld_ai_start_cnt_7_0_shift                                (0)
#define  ATSC_ADDR_2831_ld_ai_start_cnt_7_0_mask                                 (0x000000FF)
#define  ATSC_ADDR_2831_ld_ai_start_cnt_7_0(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2831_get_ld_ai_start_cnt_7_0(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2832                                                         0x181560C8
#define  ATSC_ADDR_2832_reg_addr                                                 "0xB81560C8"
#define  ATSC_ADDR_2832_reg                                                      0xB81560C8
#define  ATSC_ADDR_2832_inst_addr                                                "0x0452"
#define  set_ATSC_ADDR_2832_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2832_reg)=data)
#define  get_ATSC_ADDR_2832_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2832_reg))
#define  ATSC_ADDR_2832_ld_ai_start_cnt_15_8_shift                               (0)
#define  ATSC_ADDR_2832_ld_ai_start_cnt_15_8_mask                                (0x000000FF)
#define  ATSC_ADDR_2832_ld_ai_start_cnt_15_8(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_2832_get_ld_ai_start_cnt_15_8(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_2833                                                         0x181560CC
#define  ATSC_ADDR_2833_reg_addr                                                 "0xB81560CC"
#define  ATSC_ADDR_2833_reg                                                      0xB81560CC
#define  ATSC_ADDR_2833_inst_addr                                                "0x0453"
#define  set_ATSC_ADDR_2833_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2833_reg)=data)
#define  get_ATSC_ADDR_2833_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2833_reg))
#define  ATSC_ADDR_2833_ld_ai_en_7_0_shift                                       (0)
#define  ATSC_ADDR_2833_ld_ai_en_7_0_mask                                        (0x000000FF)
#define  ATSC_ADDR_2833_ld_ai_en_7_0(data)                                       (0x000000FF&(data))
#define  ATSC_ADDR_2833_get_ld_ai_en_7_0(data)                                   (0x000000FF&(data))

#define  ATSC_ADDR_2834                                                         0x181560D0
#define  ATSC_ADDR_2834_reg_addr                                                 "0xB81560D0"
#define  ATSC_ADDR_2834_reg                                                      0xB81560D0
#define  ATSC_ADDR_2834_inst_addr                                                "0x0454"
#define  set_ATSC_ADDR_2834_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2834_reg)=data)
#define  get_ATSC_ADDR_2834_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2834_reg))
#define  ATSC_ADDR_2834_ld_ai_ck_cnt_shift                                       (1)
#define  ATSC_ADDR_2834_ld_ai_and_or_shift                                       (0)
#define  ATSC_ADDR_2834_ld_ai_ck_cnt_mask                                        (0x0000001E)
#define  ATSC_ADDR_2834_ld_ai_and_or_mask                                        (0x00000001)
#define  ATSC_ADDR_2834_ld_ai_ck_cnt(data)                                       (0x0000001E&((data)<<1))
#define  ATSC_ADDR_2834_ld_ai_and_or(data)                                       (0x00000001&(data))
#define  ATSC_ADDR_2834_get_ld_ai_ck_cnt(data)                                   ((0x0000001E&(data))>>1)
#define  ATSC_ADDR_2834_get_ld_ai_and_or(data)                                   (0x00000001&(data))

#define  ATSC_ADDR_2835                                                         0x181560D4
#define  ATSC_ADDR_2835_reg_addr                                                 "0xB81560D4"
#define  ATSC_ADDR_2835_reg                                                      0xB81560D4
#define  ATSC_ADDR_2835_inst_addr                                                "0x0455"
#define  set_ATSC_ADDR_2835_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2835_reg)=data)
#define  get_ATSC_ADDR_2835_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2835_reg))
#define  ATSC_ADDR_2835_ld_mse_th_7_0_shift                                      (0)
#define  ATSC_ADDR_2835_ld_mse_th_7_0_mask                                       (0x000000FF)
#define  ATSC_ADDR_2835_ld_mse_th_7_0(data)                                      (0x000000FF&(data))
#define  ATSC_ADDR_2835_get_ld_mse_th_7_0(data)                                  (0x000000FF&(data))

#define  ATSC_ADDR_2836                                                         0x181560D8
#define  ATSC_ADDR_2836_reg_addr                                                 "0xB81560D8"
#define  ATSC_ADDR_2836_reg                                                      0xB81560D8
#define  ATSC_ADDR_2836_inst_addr                                                "0x0456"
#define  set_ATSC_ADDR_2836_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2836_reg)=data)
#define  get_ATSC_ADDR_2836_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2836_reg))
#define  ATSC_ADDR_2836_ld_mse_th_15_8_shift                                     (0)
#define  ATSC_ADDR_2836_ld_mse_th_15_8_mask                                      (0x000000FF)
#define  ATSC_ADDR_2836_ld_mse_th_15_8(data)                                     (0x000000FF&(data))
#define  ATSC_ADDR_2836_get_ld_mse_th_15_8(data)                                 (0x000000FF&(data))

#define  ATSC_ADDR_2837                                                         0x181560DC
#define  ATSC_ADDR_2837_reg_addr                                                 "0xB81560DC"
#define  ATSC_ADDR_2837_reg                                                      0xB81560DC
#define  ATSC_ADDR_2837_inst_addr                                                "0x0457"
#define  set_ATSC_ADDR_2837_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2837_reg)=data)
#define  get_ATSC_ADDR_2837_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2837_reg))
#define  ATSC_ADDR_2837_ld_mse_th_23_16_shift                                    (0)
#define  ATSC_ADDR_2837_ld_mse_th_23_16_mask                                     (0x000000FF)
#define  ATSC_ADDR_2837_ld_mse_th_23_16(data)                                    (0x000000FF&(data))
#define  ATSC_ADDR_2837_get_ld_mse_th_23_16(data)                                (0x000000FF&(data))

#define  ATSC_ADDR_2838                                                         0x181560E0
#define  ATSC_ADDR_2838_reg_addr                                                 "0xB81560E0"
#define  ATSC_ADDR_2838_reg                                                      0xB81560E0
#define  ATSC_ADDR_2838_inst_addr                                                "0x0458"
#define  set_ATSC_ADDR_2838_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2838_reg)=data)
#define  get_ATSC_ADDR_2838_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2838_reg))
#define  ATSC_ADDR_2838_ld_mse_th_31_24_shift                                    (0)
#define  ATSC_ADDR_2838_ld_mse_th_31_24_mask                                     (0x000000FF)
#define  ATSC_ADDR_2838_ld_mse_th_31_24(data)                                    (0x000000FF&(data))
#define  ATSC_ADDR_2838_get_ld_mse_th_31_24(data)                                (0x000000FF&(data))

#define  ATSC_ADDR_2839                                                         0x181560E4
#define  ATSC_ADDR_2839_reg_addr                                                 "0xB81560E4"
#define  ATSC_ADDR_2839_reg                                                      0xB81560E4
#define  ATSC_ADDR_2839_inst_addr                                                "0x0459"
#define  set_ATSC_ADDR_2839_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2839_reg)=data)
#define  get_ATSC_ADDR_2839_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2839_reg))
#define  ATSC_ADDR_2839_ld_mse_field_th_0_5_0_shift                              (2)
#define  ATSC_ADDR_2839_ld_mse_th_33_32_shift                                    (0)
#define  ATSC_ADDR_2839_ld_mse_field_th_0_5_0_mask                               (0x000000FC)
#define  ATSC_ADDR_2839_ld_mse_th_33_32_mask                                     (0x00000003)
#define  ATSC_ADDR_2839_ld_mse_field_th_0_5_0(data)                              (0x000000FC&((data)<<2))
#define  ATSC_ADDR_2839_ld_mse_th_33_32(data)                                    (0x00000003&(data))
#define  ATSC_ADDR_2839_get_ld_mse_field_th_0_5_0(data)                          ((0x000000FC&(data))>>2)
#define  ATSC_ADDR_2839_get_ld_mse_th_33_32(data)                                (0x00000003&(data))

#define  ATSC_ADDR_283A                                                         0x181560E8
#define  ATSC_ADDR_283A_reg_addr                                                 "0xB81560E8"
#define  ATSC_ADDR_283A_reg                                                      0xB81560E8
#define  ATSC_ADDR_283A_inst_addr                                                "0x045A"
#define  set_ATSC_ADDR_283A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_283A_reg)=data)
#define  get_ATSC_ADDR_283A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_283A_reg))
#define  ATSC_ADDR_283A_ld_mse_field_th_0_13_6_shift                             (0)
#define  ATSC_ADDR_283A_ld_mse_field_th_0_13_6_mask                              (0x000000FF)
#define  ATSC_ADDR_283A_ld_mse_field_th_0_13_6(data)                             (0x000000FF&(data))
#define  ATSC_ADDR_283A_get_ld_mse_field_th_0_13_6(data)                         (0x000000FF&(data))

#define  ATSC_ADDR_283B                                                         0x181560EC
#define  ATSC_ADDR_283B_reg_addr                                                 "0xB81560EC"
#define  ATSC_ADDR_283B_reg                                                      0xB81560EC
#define  ATSC_ADDR_283B_inst_addr                                                "0x045B"
#define  set_ATSC_ADDR_283B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_283B_reg)=data)
#define  get_ATSC_ADDR_283B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_283B_reg))
#define  ATSC_ADDR_283B_ld_mse_field_th_0_21_14_shift                            (0)
#define  ATSC_ADDR_283B_ld_mse_field_th_0_21_14_mask                             (0x000000FF)
#define  ATSC_ADDR_283B_ld_mse_field_th_0_21_14(data)                            (0x000000FF&(data))
#define  ATSC_ADDR_283B_get_ld_mse_field_th_0_21_14(data)                        (0x000000FF&(data))

#define  ATSC_ADDR_283C                                                         0x181560F0
#define  ATSC_ADDR_283C_reg_addr                                                 "0xB81560F0"
#define  ATSC_ADDR_283C_reg                                                      0xB81560F0
#define  ATSC_ADDR_283C_inst_addr                                                "0x045C"
#define  set_ATSC_ADDR_283C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_283C_reg)=data)
#define  get_ATSC_ADDR_283C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_283C_reg))
#define  ATSC_ADDR_283C_ld_mse_field_th_0_29_22_shift                            (0)
#define  ATSC_ADDR_283C_ld_mse_field_th_0_29_22_mask                             (0x000000FF)
#define  ATSC_ADDR_283C_ld_mse_field_th_0_29_22(data)                            (0x000000FF&(data))
#define  ATSC_ADDR_283C_get_ld_mse_field_th_0_29_22(data)                        (0x000000FF&(data))

#define  ATSC_ADDR_283D                                                         0x181560F4
#define  ATSC_ADDR_283D_reg_addr                                                 "0xB81560F4"
#define  ATSC_ADDR_283D_reg                                                      0xB81560F4
#define  ATSC_ADDR_283D_inst_addr                                                "0x045D"
#define  set_ATSC_ADDR_283D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_283D_reg)=data)
#define  get_ATSC_ADDR_283D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_283D_reg))
#define  ATSC_ADDR_283D_ld_mse_viterbi_th_3_0_shift                              (4)
#define  ATSC_ADDR_283D_ld_mse_field_th_0_33_30_shift                            (0)
#define  ATSC_ADDR_283D_ld_mse_viterbi_th_3_0_mask                               (0x000000F0)
#define  ATSC_ADDR_283D_ld_mse_field_th_0_33_30_mask                             (0x0000000F)
#define  ATSC_ADDR_283D_ld_mse_viterbi_th_3_0(data)                              (0x000000F0&((data)<<4))
#define  ATSC_ADDR_283D_ld_mse_field_th_0_33_30(data)                            (0x0000000F&(data))
#define  ATSC_ADDR_283D_get_ld_mse_viterbi_th_3_0(data)                          ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_283D_get_ld_mse_field_th_0_33_30(data)                        (0x0000000F&(data))

#define  ATSC_ADDR_283E                                                         0x181560F8
#define  ATSC_ADDR_283E_reg_addr                                                 "0xB81560F8"
#define  ATSC_ADDR_283E_reg                                                      0xB81560F8
#define  ATSC_ADDR_283E_inst_addr                                                "0x045E"
#define  set_ATSC_ADDR_283E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_283E_reg)=data)
#define  get_ATSC_ADDR_283E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_283E_reg))
#define  ATSC_ADDR_283E_ld_mse_viterbi_th_11_4_shift                             (0)
#define  ATSC_ADDR_283E_ld_mse_viterbi_th_11_4_mask                              (0x000000FF)
#define  ATSC_ADDR_283E_ld_mse_viterbi_th_11_4(data)                             (0x000000FF&(data))
#define  ATSC_ADDR_283E_get_ld_mse_viterbi_th_11_4(data)                         (0x000000FF&(data))

#define  ATSC_ADDR_283F                                                         0x181560FC
#define  ATSC_ADDR_283F_reg_addr                                                 "0xB81560FC"
#define  ATSC_ADDR_283F_reg                                                      0xB81560FC
#define  ATSC_ADDR_283F_inst_addr                                                "0x045F"
#define  set_ATSC_ADDR_283F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_283F_reg)=data)
#define  get_ATSC_ADDR_283F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_283F_reg))
#define  ATSC_ADDR_283F_ld_mse_viterbi_th_19_12_shift                            (0)
#define  ATSC_ADDR_283F_ld_mse_viterbi_th_19_12_mask                             (0x000000FF)
#define  ATSC_ADDR_283F_ld_mse_viterbi_th_19_12(data)                            (0x000000FF&(data))
#define  ATSC_ADDR_283F_get_ld_mse_viterbi_th_19_12(data)                        (0x000000FF&(data))

#define  ATSC_ADDR_2840                                                         0x18156100
#define  ATSC_ADDR_2840_reg_addr                                                 "0xB8156100"
#define  ATSC_ADDR_2840_reg                                                      0xB8156100
#define  ATSC_ADDR_2840_inst_addr                                                "0x0460"
#define  set_ATSC_ADDR_2840_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2840_reg)=data)
#define  get_ATSC_ADDR_2840_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2840_reg))
#define  ATSC_ADDR_2840_ld_mse_viterbi_th_27_20_shift                            (0)
#define  ATSC_ADDR_2840_ld_mse_viterbi_th_27_20_mask                             (0x000000FF)
#define  ATSC_ADDR_2840_ld_mse_viterbi_th_27_20(data)                            (0x000000FF&(data))
#define  ATSC_ADDR_2840_get_ld_mse_viterbi_th_27_20(data)                        (0x000000FF&(data))

#define  ATSC_ADDR_2841                                                         0x18156104
#define  ATSC_ADDR_2841_reg_addr                                                 "0xB8156104"
#define  ATSC_ADDR_2841_reg                                                      0xB8156104
#define  ATSC_ADDR_2841_inst_addr                                                "0x0461"
#define  set_ATSC_ADDR_2841_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2841_reg)=data)
#define  get_ATSC_ADDR_2841_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2841_reg))
#define  ATSC_ADDR_2841_ld_mse_viterbi_th_33_28_shift                            (0)
#define  ATSC_ADDR_2841_ld_mse_viterbi_th_33_28_mask                             (0x0000003F)
#define  ATSC_ADDR_2841_ld_mse_viterbi_th_33_28(data)                            (0x0000003F&(data))
#define  ATSC_ADDR_2841_get_ld_mse_viterbi_th_33_28(data)                        (0x0000003F&(data))

#define  ATSC_ADDR_2842                                                         0x18156108
#define  ATSC_ADDR_2842_reg_addr                                                 "0xB8156108"
#define  ATSC_ADDR_2842_reg                                                      0xB8156108
#define  ATSC_ADDR_2842_inst_addr                                                "0x0462"
#define  set_ATSC_ADDR_2842_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2842_reg)=data)
#define  get_ATSC_ADDR_2842_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2842_reg))
#define  ATSC_ADDR_2842_ld_max_correlation_th_shift                              (0)
#define  ATSC_ADDR_2842_ld_max_correlation_th_mask                               (0x000000FF)
#define  ATSC_ADDR_2842_ld_max_correlation_th(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_2842_get_ld_max_correlation_th(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_2846                                                         0x18156118
#define  ATSC_ADDR_2846_reg_addr                                                 "0xB8156118"
#define  ATSC_ADDR_2846_reg                                                      0xB8156118
#define  ATSC_ADDR_2846_inst_addr                                                "0x0463"
#define  set_ATSC_ADDR_2846_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2846_reg)=data)
#define  get_ATSC_ADDR_2846_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2846_reg))
#define  ATSC_ADDR_2846_ld_and_or_shift                                          (7)
#define  ATSC_ADDR_2846_ld_en0_shift                                             (6)
#define  ATSC_ADDR_2846_ld_en1_shift                                             (5)
#define  ATSC_ADDR_2846_ld_and_or_mask                                           (0x00000080)
#define  ATSC_ADDR_2846_ld_en0_mask                                              (0x00000040)
#define  ATSC_ADDR_2846_ld_en1_mask                                              (0x00000020)
#define  ATSC_ADDR_2846_ld_and_or(data)                                          (0x00000080&((data)<<7))
#define  ATSC_ADDR_2846_ld_en0(data)                                             (0x00000040&((data)<<6))
#define  ATSC_ADDR_2846_ld_en1(data)                                             (0x00000020&((data)<<5))
#define  ATSC_ADDR_2846_get_ld_and_or(data)                                      ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2846_get_ld_en0(data)                                         ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2846_get_ld_en1(data)                                         ((0x00000020&(data))>>5)

#define  ATSC_ADDR_2847                                                         0x1815611C
#define  ATSC_ADDR_2847_reg_addr                                                 "0xB815611C"
#define  ATSC_ADDR_2847_reg                                                      0xB815611C
#define  ATSC_ADDR_2847_inst_addr                                                "0x0464"
#define  set_ATSC_ADDR_2847_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2847_reg)=data)
#define  get_ATSC_ADDR_2847_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2847_reg))
#define  ATSC_ADDR_2847_ld_mse_field_th_1_7_0_shift                              (0)
#define  ATSC_ADDR_2847_ld_mse_field_th_1_7_0_mask                               (0x000000FF)
#define  ATSC_ADDR_2847_ld_mse_field_th_1_7_0(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_2847_get_ld_mse_field_th_1_7_0(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_2848                                                         0x18156120
#define  ATSC_ADDR_2848_reg_addr                                                 "0xB8156120"
#define  ATSC_ADDR_2848_reg                                                      0xB8156120
#define  ATSC_ADDR_2848_inst_addr                                                "0x0465"
#define  set_ATSC_ADDR_2848_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2848_reg)=data)
#define  get_ATSC_ADDR_2848_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2848_reg))
#define  ATSC_ADDR_2848_ld_mse_field_th_1_15_8_shift                             (0)
#define  ATSC_ADDR_2848_ld_mse_field_th_1_15_8_mask                              (0x000000FF)
#define  ATSC_ADDR_2848_ld_mse_field_th_1_15_8(data)                             (0x000000FF&(data))
#define  ATSC_ADDR_2848_get_ld_mse_field_th_1_15_8(data)                         (0x000000FF&(data))

#define  ATSC_ADDR_2849                                                         0x18156124
#define  ATSC_ADDR_2849_reg_addr                                                 "0xB8156124"
#define  ATSC_ADDR_2849_reg                                                      0xB8156124
#define  ATSC_ADDR_2849_inst_addr                                                "0x0466"
#define  set_ATSC_ADDR_2849_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2849_reg)=data)
#define  get_ATSC_ADDR_2849_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2849_reg))
#define  ATSC_ADDR_2849_ld_mse_field_th_1_23_16_shift                            (0)
#define  ATSC_ADDR_2849_ld_mse_field_th_1_23_16_mask                             (0x000000FF)
#define  ATSC_ADDR_2849_ld_mse_field_th_1_23_16(data)                            (0x000000FF&(data))
#define  ATSC_ADDR_2849_get_ld_mse_field_th_1_23_16(data)                        (0x000000FF&(data))

#define  ATSC_ADDR_284A                                                         0x18156128
#define  ATSC_ADDR_284A_reg_addr                                                 "0xB8156128"
#define  ATSC_ADDR_284A_reg                                                      0xB8156128
#define  ATSC_ADDR_284A_inst_addr                                                "0x0467"
#define  set_ATSC_ADDR_284A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_284A_reg)=data)
#define  get_ATSC_ADDR_284A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_284A_reg))
#define  ATSC_ADDR_284A_ld_mse_field_th_1_31_24_shift                            (0)
#define  ATSC_ADDR_284A_ld_mse_field_th_1_31_24_mask                             (0x000000FF)
#define  ATSC_ADDR_284A_ld_mse_field_th_1_31_24(data)                            (0x000000FF&(data))
#define  ATSC_ADDR_284A_get_ld_mse_field_th_1_31_24(data)                        (0x000000FF&(data))

#define  ATSC_ADDR_284B                                                         0x1815612C
#define  ATSC_ADDR_284B_reg_addr                                                 "0xB815612C"
#define  ATSC_ADDR_284B_reg                                                      0xB815612C
#define  ATSC_ADDR_284B_inst_addr                                                "0x0468"
#define  set_ATSC_ADDR_284B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_284B_reg)=data)
#define  get_ATSC_ADDR_284B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_284B_reg))
#define  ATSC_ADDR_284B_ld_ai_en_8_shift                                         (2)
#define  ATSC_ADDR_284B_ld_mse_field_th_1_33_32_shift                            (0)
#define  ATSC_ADDR_284B_ld_ai_en_8_mask                                          (0x00000004)
#define  ATSC_ADDR_284B_ld_mse_field_th_1_33_32_mask                             (0x00000003)
#define  ATSC_ADDR_284B_ld_ai_en_8(data)                                         (0x00000004&((data)<<2))
#define  ATSC_ADDR_284B_ld_mse_field_th_1_33_32(data)                            (0x00000003&(data))
#define  ATSC_ADDR_284B_get_ld_ai_en_8(data)                                     ((0x00000004&(data))>>2)
#define  ATSC_ADDR_284B_get_ld_mse_field_th_1_33_32(data)                        (0x00000003&(data))

#define  ATSC_ADDR_284C                                                         0x18156130
#define  ATSC_ADDR_284C_reg_addr                                                 "0xB8156130"
#define  ATSC_ADDR_284C_reg                                                      0xB8156130
#define  ATSC_ADDR_284C_inst_addr                                                "0x0469"
#define  set_ATSC_ADDR_284C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_284C_reg)=data)
#define  get_ATSC_ADDR_284C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_284C_reg))
#define  ATSC_ADDR_284C_ld_mse_field_sel_cnt_7_0_shift                           (0)
#define  ATSC_ADDR_284C_ld_mse_field_sel_cnt_7_0_mask                            (0x000000FF)
#define  ATSC_ADDR_284C_ld_mse_field_sel_cnt_7_0(data)                           (0x000000FF&(data))
#define  ATSC_ADDR_284C_get_ld_mse_field_sel_cnt_7_0(data)                       (0x000000FF&(data))

#define  ATSC_ADDR_284D                                                         0x18156134
#define  ATSC_ADDR_284D_reg_addr                                                 "0xB8156134"
#define  ATSC_ADDR_284D_reg                                                      0xB8156134
#define  ATSC_ADDR_284D_inst_addr                                                "0x046A"
#define  set_ATSC_ADDR_284D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_284D_reg)=data)
#define  get_ATSC_ADDR_284D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_284D_reg))
#define  ATSC_ADDR_284D_ld_mse_field_sel_cnt_15_8_shift                          (0)
#define  ATSC_ADDR_284D_ld_mse_field_sel_cnt_15_8_mask                           (0x000000FF)
#define  ATSC_ADDR_284D_ld_mse_field_sel_cnt_15_8(data)                          (0x000000FF&(data))
#define  ATSC_ADDR_284D_get_ld_mse_field_sel_cnt_15_8(data)                      (0x000000FF&(data))

#define  ATSC_ADDR_2851                                                         0x18156144
#define  ATSC_ADDR_2851_reg_addr                                                 "0xB8156144"
#define  ATSC_ADDR_2851_reg                                                      0xB8156144
#define  ATSC_ADDR_2851_inst_addr                                                "0x046B"
#define  set_ATSC_ADDR_2851_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2851_reg)=data)
#define  get_ATSC_ADDR_2851_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2851_reg))
#define  ATSC_ADDR_2851_tre_ber_rst_shift                                        (5)
#define  ATSC_ADDR_2851_tre_ber_hold_shift                                       (4)
#define  ATSC_ADDR_2851_dis_tre_auto_mode_shift                                  (3)
#define  ATSC_ADDR_2851_tre_test_volume_shift                                    (0)
#define  ATSC_ADDR_2851_tre_ber_rst_mask                                         (0x00000020)
#define  ATSC_ADDR_2851_tre_ber_hold_mask                                        (0x00000010)
#define  ATSC_ADDR_2851_dis_tre_auto_mode_mask                                   (0x00000008)
#define  ATSC_ADDR_2851_tre_test_volume_mask                                     (0x00000007)
#define  ATSC_ADDR_2851_tre_ber_rst(data)                                        (0x00000020&((data)<<5))
#define  ATSC_ADDR_2851_tre_ber_hold(data)                                       (0x00000010&((data)<<4))
#define  ATSC_ADDR_2851_dis_tre_auto_mode(data)                                  (0x00000008&((data)<<3))
#define  ATSC_ADDR_2851_tre_test_volume(data)                                    (0x00000007&(data))
#define  ATSC_ADDR_2851_get_tre_ber_rst(data)                                    ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2851_get_tre_ber_hold(data)                                   ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2851_get_dis_tre_auto_mode(data)                              ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2851_get_tre_test_volume(data)                                (0x00000007&(data))

#define  ATSC_ADDR_2852                                                         0x18156148
#define  ATSC_ADDR_2852_reg_addr                                                 "0xB8156148"
#define  ATSC_ADDR_2852_reg                                                      0xB8156148
#define  ATSC_ADDR_2852_inst_addr                                                "0x046C"
#define  set_ATSC_ADDR_2852_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2852_reg)=data)
#define  get_ATSC_ADDR_2852_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2852_reg))
#define  ATSC_ADDR_2852_val_lvl_shift                                            (6)
#define  ATSC_ADDR_2852_err_lvl_shift                                            (5)
#define  ATSC_ADDR_2852_err_dur_shift                                            (4)
#define  ATSC_ADDR_2852_sync_dur_shift                                           (3)
#define  ATSC_ADDR_2852_ckout_pwr_shift                                          (2)
#define  ATSC_ADDR_2852_ckoutpar_shift                                           (1)
#define  ATSC_ADDR_2852_fix_tei_shift                                            (0)
#define  ATSC_ADDR_2852_val_lvl_mask                                             (0x00000040)
#define  ATSC_ADDR_2852_err_lvl_mask                                             (0x00000020)
#define  ATSC_ADDR_2852_err_dur_mask                                             (0x00000010)
#define  ATSC_ADDR_2852_sync_dur_mask                                            (0x00000008)
#define  ATSC_ADDR_2852_ckout_pwr_mask                                           (0x00000004)
#define  ATSC_ADDR_2852_ckoutpar_mask                                            (0x00000002)
#define  ATSC_ADDR_2852_fix_tei_mask                                             (0x00000001)
#define  ATSC_ADDR_2852_val_lvl(data)                                            (0x00000040&((data)<<6))
#define  ATSC_ADDR_2852_err_lvl(data)                                            (0x00000020&((data)<<5))
#define  ATSC_ADDR_2852_err_dur(data)                                            (0x00000010&((data)<<4))
#define  ATSC_ADDR_2852_sync_dur(data)                                           (0x00000008&((data)<<3))
#define  ATSC_ADDR_2852_ckout_pwr(data)                                          (0x00000004&((data)<<2))
#define  ATSC_ADDR_2852_ckoutpar(data)                                           (0x00000002&((data)<<1))
#define  ATSC_ADDR_2852_fix_tei(data)                                            (0x00000001&(data))
#define  ATSC_ADDR_2852_get_val_lvl(data)                                        ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2852_get_err_lvl(data)                                        ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2852_get_err_dur(data)                                        ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2852_get_sync_dur(data)                                       ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2852_get_ckout_pwr(data)                                      ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2852_get_ckoutpar(data)                                       ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2852_get_fix_tei(data)                                        (0x00000001&(data))

#define  ATSC_ADDR_2853                                                         0x1815614C
#define  ATSC_ADDR_2853_reg_addr                                                 "0xB815614C"
#define  ATSC_ADDR_2853_reg                                                      0xB815614C
#define  ATSC_ADDR_2853_inst_addr                                                "0x046D"
#define  set_ATSC_ADDR_2853_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2853_reg)=data)
#define  get_ATSC_ADDR_2853_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2853_reg))
#define  ATSC_ADDR_2853_ser_lsb_shift                                            (1)
#define  ATSC_ADDR_2853_serial_shift                                             (0)
#define  ATSC_ADDR_2853_ser_lsb_mask                                             (0x00000002)
#define  ATSC_ADDR_2853_serial_mask                                              (0x00000001)
#define  ATSC_ADDR_2853_ser_lsb(data)                                            (0x00000002&((data)<<1))
#define  ATSC_ADDR_2853_serial(data)                                             (0x00000001&(data))
#define  ATSC_ADDR_2853_get_ser_lsb(data)                                        ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2853_get_serial(data)                                         (0x00000001&(data))

#define  ATSC_ADDR_2854                                                         0x18156150
#define  ATSC_ADDR_2854_reg_addr                                                 "0xB8156150"
#define  ATSC_ADDR_2854_reg                                                      0xB8156150
#define  ATSC_ADDR_2854_inst_addr                                                "0x046E"
#define  set_ATSC_ADDR_2854_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2854_reg)=data)
#define  get_ATSC_ADDR_2854_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2854_reg))
#define  ATSC_ADDR_2854_cdiv_ph1_shift                                           (4)
#define  ATSC_ADDR_2854_cdiv_ph0_shift                                           (0)
#define  ATSC_ADDR_2854_cdiv_ph1_mask                                            (0x000000F0)
#define  ATSC_ADDR_2854_cdiv_ph0_mask                                            (0x0000000F)
#define  ATSC_ADDR_2854_cdiv_ph1(data)                                           (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2854_cdiv_ph0(data)                                           (0x0000000F&(data))
#define  ATSC_ADDR_2854_get_cdiv_ph1(data)                                       ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2854_get_cdiv_ph0(data)                                       (0x0000000F&(data))

#define  ATSC_ADDR_2855                                                         0x18156154
#define  ATSC_ADDR_2855_reg_addr                                                 "0xB8156154"
#define  ATSC_ADDR_2855_reg                                                      0xB8156154
#define  ATSC_ADDR_2855_inst_addr                                                "0x046F"
#define  set_ATSC_ADDR_2855_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2855_reg)=data)
#define  get_ATSC_ADDR_2855_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2855_reg))
#define  ATSC_ADDR_2855_rsd_disable_shift                                        (1)
#define  ATSC_ADDR_2855_no_corr_shift                                            (0)
#define  ATSC_ADDR_2855_rsd_disable_mask                                         (0x00000002)
#define  ATSC_ADDR_2855_no_corr_mask                                             (0x00000001)
#define  ATSC_ADDR_2855_rsd_disable(data)                                        (0x00000002&((data)<<1))
#define  ATSC_ADDR_2855_no_corr(data)                                            (0x00000001&(data))
#define  ATSC_ADDR_2855_get_rsd_disable(data)                                    ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2855_get_no_corr(data)                                        (0x00000001&(data))

#define  ATSC_ADDR_2856                                                         0x18156158
#define  ATSC_ADDR_2856_reg_addr                                                 "0xB8156158"
#define  ATSC_ADDR_2856_reg                                                      0xB8156158
#define  ATSC_ADDR_2856_inst_addr                                                "0x0470"
#define  set_ATSC_ADDR_2856_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2856_reg)=data)
#define  get_ATSC_ADDR_2856_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2856_reg))
#define  ATSC_ADDR_2856_ber_rst_shift                                            (7)
#define  ATSC_ADDR_2856_ber_sel_shift                                            (5)
#define  ATSC_ADDR_2856_ber_once_shift                                           (4)
#define  ATSC_ADDR_2856_test_volume_shift                                        (0)
#define  ATSC_ADDR_2856_ber_rst_mask                                             (0x00000080)
#define  ATSC_ADDR_2856_ber_sel_mask                                             (0x00000020)
#define  ATSC_ADDR_2856_ber_once_mask                                            (0x00000010)
#define  ATSC_ADDR_2856_test_volume_mask                                         (0x0000000F)
#define  ATSC_ADDR_2856_ber_rst(data)                                            (0x00000080&((data)<<7))
#define  ATSC_ADDR_2856_ber_sel(data)                                            (0x00000020&((data)<<5))
#define  ATSC_ADDR_2856_ber_once(data)                                           (0x00000010&((data)<<4))
#define  ATSC_ADDR_2856_test_volume(data)                                        (0x0000000F&(data))
#define  ATSC_ADDR_2856_get_ber_rst(data)                                        ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2856_get_ber_sel(data)                                        ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2856_get_ber_once(data)                                       ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2856_get_test_volume(data)                                    (0x0000000F&(data))

#define  ATSC_ADDR_2857                                                         0x1815615C
#define  ATSC_ADDR_2857_reg_addr                                                 "0xB815615C"
#define  ATSC_ADDR_2857_reg                                                      0xB815615C
#define  ATSC_ADDR_2857_inst_addr                                                "0x0471"
#define  set_ATSC_ADDR_2857_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2857_reg)=data)
#define  get_ATSC_ADDR_2857_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2857_reg))
#define  ATSC_ADDR_2857_dera_disable_shift                                       (0)
#define  ATSC_ADDR_2857_dera_disable_mask                                        (0x00000001)
#define  ATSC_ADDR_2857_dera_disable(data)                                       (0x00000001&(data))
#define  ATSC_ADDR_2857_get_dera_disable(data)                                   (0x00000001&(data))

#define  ATSC_ADDR_2858                                                         0x18156160
#define  ATSC_ADDR_2858_reg_addr                                                 "0xB8156160"
#define  ATSC_ADDR_2858_reg                                                      0xB8156160
#define  ATSC_ADDR_2858_inst_addr                                                "0x0472"
#define  set_ATSC_ADDR_2858_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2858_reg)=data)
#define  get_ATSC_ADDR_2858_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2858_reg))
#define  ATSC_ADDR_2858_ao_ld_ser_thr_7_0_shift                                  (0)
#define  ATSC_ADDR_2858_ao_ld_ser_thr_7_0_mask                                   (0x000000FF)
#define  ATSC_ADDR_2858_ao_ld_ser_thr_7_0(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2858_get_ao_ld_ser_thr_7_0(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2859                                                         0x18156164
#define  ATSC_ADDR_2859_reg_addr                                                 "0xB8156164"
#define  ATSC_ADDR_2859_reg                                                      0xB8156164
#define  ATSC_ADDR_2859_inst_addr                                                "0x0473"
#define  set_ATSC_ADDR_2859_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2859_reg)=data)
#define  get_ATSC_ADDR_2859_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2859_reg))
#define  ATSC_ADDR_2859_ao_ld_ser_thr_15_8_shift                                 (0)
#define  ATSC_ADDR_2859_ao_ld_ser_thr_15_8_mask                                  (0x000000FF)
#define  ATSC_ADDR_2859_ao_ld_ser_thr_15_8(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2859_get_ao_ld_ser_thr_15_8(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_285A                                                         0x18156168
#define  ATSC_ADDR_285A_reg_addr                                                 "0xB8156168"
#define  ATSC_ADDR_285A_reg                                                      0xB8156168
#define  ATSC_ADDR_285A_inst_addr                                                "0x0474"
#define  set_ATSC_ADDR_285A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_285A_reg)=data)
#define  get_ATSC_ADDR_285A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_285A_reg))
#define  ATSC_ADDR_285A_ao_ld_ser_thr_23_16_shift                                (0)
#define  ATSC_ADDR_285A_ao_ld_ser_thr_23_16_mask                                 (0x000000FF)
#define  ATSC_ADDR_285A_ao_ld_ser_thr_23_16(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_285A_get_ao_ld_ser_thr_23_16(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_285B                                                         0x1815616C
#define  ATSC_ADDR_285B_reg_addr                                                 "0xB815616C"
#define  ATSC_ADDR_285B_reg                                                      0xB815616C
#define  ATSC_ADDR_285B_inst_addr                                                "0x0475"
#define  set_ATSC_ADDR_285B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_285B_reg)=data)
#define  get_ATSC_ADDR_285B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_285B_reg))
#define  ATSC_ADDR_285B_ao_ld_rstn_shift                                         (6)
#define  ATSC_ADDR_285B_ao_ld_volume_shift                                       (3)
#define  ATSC_ADDR_285B_ao_ld_ck_cnt_shift                                       (0)
#define  ATSC_ADDR_285B_ao_ld_rstn_mask                                          (0x00000040)
#define  ATSC_ADDR_285B_ao_ld_volume_mask                                        (0x00000038)
#define  ATSC_ADDR_285B_ao_ld_ck_cnt_mask                                        (0x00000007)
#define  ATSC_ADDR_285B_ao_ld_rstn(data)                                         (0x00000040&((data)<<6))
#define  ATSC_ADDR_285B_ao_ld_volume(data)                                       (0x00000038&((data)<<3))
#define  ATSC_ADDR_285B_ao_ld_ck_cnt(data)                                       (0x00000007&(data))
#define  ATSC_ADDR_285B_get_ao_ld_rstn(data)                                     ((0x00000040&(data))>>6)
#define  ATSC_ADDR_285B_get_ao_ld_volume(data)                                   ((0x00000038&(data))>>3)
#define  ATSC_ADDR_285B_get_ao_ld_ck_cnt(data)                                   (0x00000007&(data))

#define  ATSC_ADDR_285C                                                         0x18156170
#define  ATSC_ADDR_285C_reg_addr                                                 "0xB8156170"
#define  ATSC_ADDR_285C_reg                                                      0xB8156170
#define  ATSC_ADDR_285C_inst_addr                                                "0x0476"
#define  set_ATSC_ADDR_285C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_285C_reg)=data)
#define  get_ATSC_ADDR_285C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_285C_reg))
#define  ATSC_ADDR_285C_ld_ao_start_cnt_7_0_shift                                (0)
#define  ATSC_ADDR_285C_ld_ao_start_cnt_7_0_mask                                 (0x000000FF)
#define  ATSC_ADDR_285C_ld_ao_start_cnt_7_0(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_285C_get_ld_ao_start_cnt_7_0(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_285D                                                         0x18156174
#define  ATSC_ADDR_285D_reg_addr                                                 "0xB8156174"
#define  ATSC_ADDR_285D_reg                                                      0xB8156174
#define  ATSC_ADDR_285D_inst_addr                                                "0x0477"
#define  set_ATSC_ADDR_285D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_285D_reg)=data)
#define  get_ATSC_ADDR_285D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_285D_reg))
#define  ATSC_ADDR_285D_ld_ao_start_cnt_15_8_shift                               (0)
#define  ATSC_ADDR_285D_ld_ao_start_cnt_15_8_mask                                (0x000000FF)
#define  ATSC_ADDR_285D_ld_ao_start_cnt_15_8(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_285D_get_ld_ao_start_cnt_15_8(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_285E                                                         0x18156178
#define  ATSC_ADDR_285E_reg_addr                                                 "0xB8156178"
#define  ATSC_ADDR_285E_reg                                                      0xB8156178
#define  ATSC_ADDR_285E_inst_addr                                                "0x0478"
#define  set_ATSC_ADDR_285E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_285E_reg)=data)
#define  get_ATSC_ADDR_285E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_285E_reg))
#define  ATSC_ADDR_285E_data_lost_flag_clr_shift                                 (3)
#define  ATSC_ADDR_285E_reg_outer_null_in_clear_shift                            (1)
#define  ATSC_ADDR_285E_data_lost_flag_clr_mask                                  (0x00000008)
#define  ATSC_ADDR_285E_reg_outer_null_in_clear_mask                             (0x00000002)
#define  ATSC_ADDR_285E_data_lost_flag_clr(data)                                 (0x00000008&((data)<<3))
#define  ATSC_ADDR_285E_reg_outer_null_in_clear(data)                            (0x00000002&((data)<<1))
#define  ATSC_ADDR_285E_get_data_lost_flag_clr(data)                             ((0x00000008&(data))>>3)
#define  ATSC_ADDR_285E_get_reg_outer_null_in_clear(data)                        ((0x00000002&(data))>>1)

#define  ATSC_ADDR_285F                                                         0x1815617C
#define  ATSC_ADDR_285F_reg_addr                                                 "0xB815617C"
#define  ATSC_ADDR_285F_reg                                                      0xB815617C
#define  ATSC_ADDR_285F_inst_addr                                                "0x0479"
#define  set_ATSC_ADDR_285F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_285F_reg)=data)
#define  get_ATSC_ADDR_285F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_285F_reg))
#define  ATSC_ADDR_285F_ro_data_lost_flag_shift                                  (5)
#define  ATSC_ADDR_285F_reg_outer_null_in_shift                                  (4)
#define  ATSC_ADDR_285F_deint_sf_err_cnt_shift                                   (0)
#define  ATSC_ADDR_285F_ro_data_lost_flag_mask                                   (0x00000020)
#define  ATSC_ADDR_285F_reg_outer_null_in_mask                                   (0x00000010)
#define  ATSC_ADDR_285F_deint_sf_err_cnt_mask                                    (0x0000000F)
#define  ATSC_ADDR_285F_ro_data_lost_flag(data)                                  (0x00000020&((data)<<5))
#define  ATSC_ADDR_285F_reg_outer_null_in(data)                                  (0x00000010&((data)<<4))
#define  ATSC_ADDR_285F_deint_sf_err_cnt(data)                                   (0x0000000F&(data))
#define  ATSC_ADDR_285F_get_ro_data_lost_flag(data)                              ((0x00000020&(data))>>5)
#define  ATSC_ADDR_285F_get_reg_outer_null_in(data)                              ((0x00000010&(data))>>4)
#define  ATSC_ADDR_285F_get_deint_sf_err_cnt(data)                               (0x0000000F&(data))

#define  ATSC_ADDR_2860                                                         0x18156180
#define  ATSC_ADDR_2860_reg_addr                                                 "0xB8156180"
#define  ATSC_ADDR_2860_reg                                                      0xB8156180
#define  ATSC_ADDR_2860_inst_addr                                                "0x047A"
#define  set_ATSC_ADDR_2860_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2860_reg)=data)
#define  get_ATSC_ADDR_2860_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2860_reg))
#define  ATSC_ADDR_2860_ft_rst_n_shift                                           (0)
#define  ATSC_ADDR_2860_ft_rst_n_mask                                            (0x00000001)
#define  ATSC_ADDR_2860_ft_rst_n(data)                                           (0x00000001&(data))
#define  ATSC_ADDR_2860_get_ft_rst_n(data)                                       (0x00000001&(data))

#define  ATSC_ADDR_2861                                                         0x18156184
#define  ATSC_ADDR_2861_reg_addr                                                 "0xB8156184"
#define  ATSC_ADDR_2861_reg                                                      0xB8156184
#define  ATSC_ADDR_2861_inst_addr                                                "0x047B"
#define  set_ATSC_ADDR_2861_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2861_reg)=data)
#define  get_ATSC_ADDR_2861_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2861_reg))
#define  ATSC_ADDR_2861_ft_valid_th_7_0_shift                                    (0)
#define  ATSC_ADDR_2861_ft_valid_th_7_0_mask                                     (0x000000FF)
#define  ATSC_ADDR_2861_ft_valid_th_7_0(data)                                    (0x000000FF&(data))
#define  ATSC_ADDR_2861_get_ft_valid_th_7_0(data)                                (0x000000FF&(data))

#define  ATSC_ADDR_2862                                                         0x18156188
#define  ATSC_ADDR_2862_reg_addr                                                 "0xB8156188"
#define  ATSC_ADDR_2862_reg                                                      0xB8156188
#define  ATSC_ADDR_2862_inst_addr                                                "0x047C"
#define  set_ATSC_ADDR_2862_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2862_reg)=data)
#define  get_ATSC_ADDR_2862_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2862_reg))
#define  ATSC_ADDR_2862_ft_valid_th_15_8_shift                                   (0)
#define  ATSC_ADDR_2862_ft_valid_th_15_8_mask                                    (0x000000FF)
#define  ATSC_ADDR_2862_ft_valid_th_15_8(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_2862_get_ft_valid_th_15_8(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_2863                                                         0x1815618C
#define  ATSC_ADDR_2863_reg_addr                                                 "0xB815618C"
#define  ATSC_ADDR_2863_reg                                                      0xB815618C
#define  ATSC_ADDR_2863_inst_addr                                                "0x047D"
#define  set_ATSC_ADDR_2863_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2863_reg)=data)
#define  get_ATSC_ADDR_2863_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2863_reg))
#define  ATSC_ADDR_2863_ft_caagc_target_th_7_0_shift                             (0)
#define  ATSC_ADDR_2863_ft_caagc_target_th_7_0_mask                              (0x000000FF)
#define  ATSC_ADDR_2863_ft_caagc_target_th_7_0(data)                             (0x000000FF&(data))
#define  ATSC_ADDR_2863_get_ft_caagc_target_th_7_0(data)                         (0x000000FF&(data))

#define  ATSC_ADDR_2864                                                         0x18156190
#define  ATSC_ADDR_2864_reg_addr                                                 "0xB8156190"
#define  ATSC_ADDR_2864_reg                                                      0xB8156190
#define  ATSC_ADDR_2864_inst_addr                                                "0x047E"
#define  set_ATSC_ADDR_2864_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2864_reg)=data)
#define  get_ATSC_ADDR_2864_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2864_reg))
#define  ATSC_ADDR_2864_ft_caagc_target_th_15_8_shift                            (0)
#define  ATSC_ADDR_2864_ft_caagc_target_th_15_8_mask                             (0x000000FF)
#define  ATSC_ADDR_2864_ft_caagc_target_th_15_8(data)                            (0x000000FF&(data))
#define  ATSC_ADDR_2864_get_ft_caagc_target_th_15_8(data)                        (0x000000FF&(data))

#define  ATSC_ADDR_2865                                                         0x18156194
#define  ATSC_ADDR_2865_reg_addr                                                 "0xB8156194"
#define  ATSC_ADDR_2865_reg                                                      0xB8156194
#define  ATSC_ADDR_2865_inst_addr                                                "0x047F"
#define  set_ATSC_ADDR_2865_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2865_reg)=data)
#define  get_ATSC_ADDR_2865_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2865_reg))
#define  ATSC_ADDR_2865_ft_final_state_flag_en_shift                             (0)
#define  ATSC_ADDR_2865_ft_final_state_flag_en_mask                              (0x00000001)
#define  ATSC_ADDR_2865_ft_final_state_flag_en(data)                             (0x00000001&(data))
#define  ATSC_ADDR_2865_get_ft_final_state_flag_en(data)                         (0x00000001&(data))

#define  ATSC_ADDR_2866                                                         0x18156198
#define  ATSC_ADDR_2866_reg_addr                                                 "0xB8156198"
#define  ATSC_ADDR_2866_reg                                                      0xB8156198
#define  ATSC_ADDR_2866_inst_addr                                                "0x0480"
#define  set_ATSC_ADDR_2866_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2866_reg)=data)
#define  get_ATSC_ADDR_2866_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2866_reg))
#define  ATSC_ADDR_2866_ft_mse_th_7_0_shift                                      (0)
#define  ATSC_ADDR_2866_ft_mse_th_7_0_mask                                       (0x000000FF)
#define  ATSC_ADDR_2866_ft_mse_th_7_0(data)                                      (0x000000FF&(data))
#define  ATSC_ADDR_2866_get_ft_mse_th_7_0(data)                                  (0x000000FF&(data))

#define  ATSC_ADDR_2867                                                         0x1815619C
#define  ATSC_ADDR_2867_reg_addr                                                 "0xB815619C"
#define  ATSC_ADDR_2867_reg                                                      0xB815619C
#define  ATSC_ADDR_2867_inst_addr                                                "0x0481"
#define  set_ATSC_ADDR_2867_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2867_reg)=data)
#define  get_ATSC_ADDR_2867_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2867_reg))
#define  ATSC_ADDR_2867_ft_mse_en_shift                                          (2)
#define  ATSC_ADDR_2867_ft_mse_th_9_8_shift                                      (0)
#define  ATSC_ADDR_2867_ft_mse_en_mask                                           (0x00000004)
#define  ATSC_ADDR_2867_ft_mse_th_9_8_mask                                       (0x00000003)
#define  ATSC_ADDR_2867_ft_mse_en(data)                                          (0x00000004&((data)<<2))
#define  ATSC_ADDR_2867_ft_mse_th_9_8(data)                                      (0x00000003&(data))
#define  ATSC_ADDR_2867_get_ft_mse_en(data)                                      ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2867_get_ft_mse_th_9_8(data)                                  (0x00000003&(data))

#define  ATSC_ADDR_2868                                                         0x181561A0
#define  ATSC_ADDR_2868_reg_addr                                                 "0xB81561A0"
#define  ATSC_ADDR_2868_reg                                                      0xB81561A0
#define  ATSC_ADDR_2868_inst_addr                                                "0x0482"
#define  set_ATSC_ADDR_2868_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2868_reg)=data)
#define  get_ATSC_ADDR_2868_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2868_reg))
#define  ATSC_ADDR_2868_ft_mse_field_th_7_0_shift                                (0)
#define  ATSC_ADDR_2868_ft_mse_field_th_7_0_mask                                 (0x000000FF)
#define  ATSC_ADDR_2868_ft_mse_field_th_7_0(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2868_get_ft_mse_field_th_7_0(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2869                                                         0x181561A4
#define  ATSC_ADDR_2869_reg_addr                                                 "0xB81561A4"
#define  ATSC_ADDR_2869_reg                                                      0xB81561A4
#define  ATSC_ADDR_2869_inst_addr                                                "0x0483"
#define  set_ATSC_ADDR_2869_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2869_reg)=data)
#define  get_ATSC_ADDR_2869_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2869_reg))
#define  ATSC_ADDR_2869_ft_mse_field_en_shift                                    (2)
#define  ATSC_ADDR_2869_ft_mse_field_th_9_8_shift                                (0)
#define  ATSC_ADDR_2869_ft_mse_field_en_mask                                     (0x00000004)
#define  ATSC_ADDR_2869_ft_mse_field_th_9_8_mask                                 (0x00000003)
#define  ATSC_ADDR_2869_ft_mse_field_en(data)                                    (0x00000004&((data)<<2))
#define  ATSC_ADDR_2869_ft_mse_field_th_9_8(data)                                (0x00000003&(data))
#define  ATSC_ADDR_2869_get_ft_mse_field_en(data)                                ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2869_get_ft_mse_field_th_9_8(data)                            (0x00000003&(data))

#define  ATSC_ADDR_286A                                                         0x181561A8
#define  ATSC_ADDR_286A_reg_addr                                                 "0xB81561A8"
#define  ATSC_ADDR_286A_reg                                                      0xB81561A8
#define  ATSC_ADDR_286A_inst_addr                                                "0x0484"
#define  set_ATSC_ADDR_286A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_286A_reg)=data)
#define  get_ATSC_ADDR_286A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_286A_reg))
#define  ATSC_ADDR_286A_ft_ser_en_shift                                          (0)
#define  ATSC_ADDR_286A_ft_ser_en_mask                                           (0x00000001)
#define  ATSC_ADDR_286A_ft_ser_en(data)                                          (0x00000001&(data))
#define  ATSC_ADDR_286A_get_ft_ser_en(data)                                      (0x00000001&(data))

#define  ATSC_ADDR_286B                                                         0x181561AC
#define  ATSC_ADDR_286B_reg_addr                                                 "0xB81561AC"
#define  ATSC_ADDR_286B_reg                                                      0xB81561AC
#define  ATSC_ADDR_286B_inst_addr                                                "0x0485"
#define  set_ATSC_ADDR_286B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_286B_reg)=data)
#define  get_ATSC_ADDR_286B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_286B_reg))
#define  ATSC_ADDR_286B_ft_rs_corr_cnt_th_7_0_shift                              (0)
#define  ATSC_ADDR_286B_ft_rs_corr_cnt_th_7_0_mask                               (0x000000FF)
#define  ATSC_ADDR_286B_ft_rs_corr_cnt_th_7_0(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_286B_get_ft_rs_corr_cnt_th_7_0(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_286C                                                         0x181561B0
#define  ATSC_ADDR_286C_reg_addr                                                 "0xB81561B0"
#define  ATSC_ADDR_286C_reg                                                      0xB81561B0
#define  ATSC_ADDR_286C_inst_addr                                                "0x0486"
#define  set_ATSC_ADDR_286C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_286C_reg)=data)
#define  get_ATSC_ADDR_286C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_286C_reg))
#define  ATSC_ADDR_286C_ft_rs_corr_cnt_th_15_8_shift                             (0)
#define  ATSC_ADDR_286C_ft_rs_corr_cnt_th_15_8_mask                              (0x000000FF)
#define  ATSC_ADDR_286C_ft_rs_corr_cnt_th_15_8(data)                             (0x000000FF&(data))
#define  ATSC_ADDR_286C_get_ft_rs_corr_cnt_th_15_8(data)                         (0x000000FF&(data))

#define  ATSC_ADDR_286D                                                         0x181561B4
#define  ATSC_ADDR_286D_reg_addr                                                 "0xB81561B4"
#define  ATSC_ADDR_286D_reg                                                      0xB81561B4
#define  ATSC_ADDR_286D_inst_addr                                                "0x0487"
#define  set_ATSC_ADDR_286D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_286D_reg)=data)
#define  get_ATSC_ADDR_286D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_286D_reg))
#define  ATSC_ADDR_286D_ft_rs_corr_cnt_th_23_16_shift                            (0)
#define  ATSC_ADDR_286D_ft_rs_corr_cnt_th_23_16_mask                             (0x000000FF)
#define  ATSC_ADDR_286D_ft_rs_corr_cnt_th_23_16(data)                            (0x000000FF&(data))
#define  ATSC_ADDR_286D_get_ft_rs_corr_cnt_th_23_16(data)                        (0x000000FF&(data))

#define  ATSC_ADDR_286E                                                         0x181561B8
#define  ATSC_ADDR_286E_reg_addr                                                 "0xB81561B8"
#define  ATSC_ADDR_286E_reg                                                      0xB81561B8
#define  ATSC_ADDR_286E_inst_addr                                                "0x0488"
#define  set_ATSC_ADDR_286E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_286E_reg)=data)
#define  get_ATSC_ADDR_286E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_286E_reg))
#define  ATSC_ADDR_286E_ft_rs_un_corr_cnt_th_7_0_shift                           (0)
#define  ATSC_ADDR_286E_ft_rs_un_corr_cnt_th_7_0_mask                            (0x000000FF)
#define  ATSC_ADDR_286E_ft_rs_un_corr_cnt_th_7_0(data)                           (0x000000FF&(data))
#define  ATSC_ADDR_286E_get_ft_rs_un_corr_cnt_th_7_0(data)                       (0x000000FF&(data))

#define  ATSC_ADDR_286F                                                         0x181561BC
#define  ATSC_ADDR_286F_reg_addr                                                 "0xB81561BC"
#define  ATSC_ADDR_286F_reg                                                      0xB81561BC
#define  ATSC_ADDR_286F_inst_addr                                                "0x0489"
#define  set_ATSC_ADDR_286F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_286F_reg)=data)
#define  get_ATSC_ADDR_286F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_286F_reg))
#define  ATSC_ADDR_286F_ft_rs_un_corr_cnt_th_15_8_shift                          (0)
#define  ATSC_ADDR_286F_ft_rs_un_corr_cnt_th_15_8_mask                           (0x000000FF)
#define  ATSC_ADDR_286F_ft_rs_un_corr_cnt_th_15_8(data)                          (0x000000FF&(data))
#define  ATSC_ADDR_286F_get_ft_rs_un_corr_cnt_th_15_8(data)                      (0x000000FF&(data))

#define  ATSC_ADDR_2870                                                         0x181561C0
#define  ATSC_ADDR_2870_reg_addr                                                 "0xB81561C0"
#define  ATSC_ADDR_2870_reg                                                      0xB81561C0
#define  ATSC_ADDR_2870_inst_addr                                                "0x048A"
#define  set_ATSC_ADDR_2870_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2870_reg)=data)
#define  get_ATSC_ADDR_2870_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2870_reg))
#define  ATSC_ADDR_2870_ft_rs_un_corr_cnt_th_23_16_shift                         (0)
#define  ATSC_ADDR_2870_ft_rs_un_corr_cnt_th_23_16_mask                          (0x000000FF)
#define  ATSC_ADDR_2870_ft_rs_un_corr_cnt_th_23_16(data)                         (0x000000FF&(data))
#define  ATSC_ADDR_2870_get_ft_rs_un_corr_cnt_th_23_16(data)                     (0x000000FF&(data))

#define  ATSC_ADDR_2871                                                         0x181561C4
#define  ATSC_ADDR_2871_reg_addr                                                 "0xB81561C4"
#define  ATSC_ADDR_2871_reg                                                      0xB81561C4
#define  ATSC_ADDR_2871_inst_addr                                                "0x048B"
#define  set_ATSC_ADDR_2871_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2871_reg)=data)
#define  get_ATSC_ADDR_2871_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2871_reg))
#define  ATSC_ADDR_2871_ft_if_agc_u_th_5_0_shift                                 (2)
#define  ATSC_ADDR_2871_ft_rf_agc_en_shift                                       (1)
#define  ATSC_ADDR_2871_ft_if_agc_en_shift                                       (0)
#define  ATSC_ADDR_2871_ft_if_agc_u_th_5_0_mask                                  (0x000000FC)
#define  ATSC_ADDR_2871_ft_rf_agc_en_mask                                        (0x00000002)
#define  ATSC_ADDR_2871_ft_if_agc_en_mask                                        (0x00000001)
#define  ATSC_ADDR_2871_ft_if_agc_u_th_5_0(data)                                 (0x000000FC&((data)<<2))
#define  ATSC_ADDR_2871_ft_rf_agc_en(data)                                       (0x00000002&((data)<<1))
#define  ATSC_ADDR_2871_ft_if_agc_en(data)                                       (0x00000001&(data))
#define  ATSC_ADDR_2871_get_ft_if_agc_u_th_5_0(data)                             ((0x000000FC&(data))>>2)
#define  ATSC_ADDR_2871_get_ft_rf_agc_en(data)                                   ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2871_get_ft_if_agc_en(data)                                   (0x00000001&(data))

#define  ATSC_ADDR_2872                                                         0x181561C8
#define  ATSC_ADDR_2872_reg_addr                                                 "0xB81561C8"
#define  ATSC_ADDR_2872_reg                                                      0xB81561C8
#define  ATSC_ADDR_2872_inst_addr                                                "0x048C"
#define  set_ATSC_ADDR_2872_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2872_reg)=data)
#define  get_ATSC_ADDR_2872_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2872_reg))
#define  ATSC_ADDR_2872_ft_if_agc_u_th_13_6_shift                                (0)
#define  ATSC_ADDR_2872_ft_if_agc_u_th_13_6_mask                                 (0x000000FF)
#define  ATSC_ADDR_2872_ft_if_agc_u_th_13_6(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2872_get_ft_if_agc_u_th_13_6(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2873                                                         0x181561CC
#define  ATSC_ADDR_2873_reg_addr                                                 "0xB81561CC"
#define  ATSC_ADDR_2873_reg                                                      0xB81561CC
#define  ATSC_ADDR_2873_inst_addr                                                "0x048D"
#define  set_ATSC_ADDR_2873_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2873_reg)=data)
#define  get_ATSC_ADDR_2873_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2873_reg))
#define  ATSC_ADDR_2873_ft_rf_agc_u_th_7_0_shift                                 (0)
#define  ATSC_ADDR_2873_ft_rf_agc_u_th_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_2873_ft_rf_agc_u_th_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2873_get_ft_rf_agc_u_th_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2874                                                         0x181561D0
#define  ATSC_ADDR_2874_reg_addr                                                 "0xB81561D0"
#define  ATSC_ADDR_2874_reg                                                      0xB81561D0
#define  ATSC_ADDR_2874_inst_addr                                                "0x048E"
#define  set_ATSC_ADDR_2874_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2874_reg)=data)
#define  get_ATSC_ADDR_2874_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2874_reg))
#define  ATSC_ADDR_2874_ft_if_agc_l_th_1_0_shift                                 (6)
#define  ATSC_ADDR_2874_ft_rf_agc_u_th_13_8_shift                                (0)
#define  ATSC_ADDR_2874_ft_if_agc_l_th_1_0_mask                                  (0x000000C0)
#define  ATSC_ADDR_2874_ft_rf_agc_u_th_13_8_mask                                 (0x0000003F)
#define  ATSC_ADDR_2874_ft_if_agc_l_th_1_0(data)                                 (0x000000C0&((data)<<6))
#define  ATSC_ADDR_2874_ft_rf_agc_u_th_13_8(data)                                (0x0000003F&(data))
#define  ATSC_ADDR_2874_get_ft_if_agc_l_th_1_0(data)                             ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_2874_get_ft_rf_agc_u_th_13_8(data)                            (0x0000003F&(data))

#define  ATSC_ADDR_2875                                                         0x181561D4
#define  ATSC_ADDR_2875_reg_addr                                                 "0xB81561D4"
#define  ATSC_ADDR_2875_reg                                                      0xB81561D4
#define  ATSC_ADDR_2875_inst_addr                                                "0x048F"
#define  set_ATSC_ADDR_2875_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2875_reg)=data)
#define  get_ATSC_ADDR_2875_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2875_reg))
#define  ATSC_ADDR_2875_ft_if_agc_l_th_9_2_shift                                 (0)
#define  ATSC_ADDR_2875_ft_if_agc_l_th_9_2_mask                                  (0x000000FF)
#define  ATSC_ADDR_2875_ft_if_agc_l_th_9_2(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2875_get_ft_if_agc_l_th_9_2(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2876                                                         0x181561D8
#define  ATSC_ADDR_2876_reg_addr                                                 "0xB81561D8"
#define  ATSC_ADDR_2876_reg                                                      0xB81561D8
#define  ATSC_ADDR_2876_inst_addr                                                "0x0490"
#define  set_ATSC_ADDR_2876_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2876_reg)=data)
#define  get_ATSC_ADDR_2876_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2876_reg))
#define  ATSC_ADDR_2876_ft_rf_agc_l_th_3_0_shift                                 (4)
#define  ATSC_ADDR_2876_ft_if_agc_l_th_13_10_shift                               (0)
#define  ATSC_ADDR_2876_ft_rf_agc_l_th_3_0_mask                                  (0x000000F0)
#define  ATSC_ADDR_2876_ft_if_agc_l_th_13_10_mask                                (0x0000000F)
#define  ATSC_ADDR_2876_ft_rf_agc_l_th_3_0(data)                                 (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2876_ft_if_agc_l_th_13_10(data)                               (0x0000000F&(data))
#define  ATSC_ADDR_2876_get_ft_rf_agc_l_th_3_0(data)                             ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2876_get_ft_if_agc_l_th_13_10(data)                           (0x0000000F&(data))

#define  ATSC_ADDR_2877                                                         0x181561DC
#define  ATSC_ADDR_2877_reg_addr                                                 "0xB81561DC"
#define  ATSC_ADDR_2877_reg                                                      0xB81561DC
#define  ATSC_ADDR_2877_inst_addr                                                "0x0491"
#define  set_ATSC_ADDR_2877_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2877_reg)=data)
#define  get_ATSC_ADDR_2877_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2877_reg))
#define  ATSC_ADDR_2877_ft_rf_agc_l_th_11_4_shift                                (0)
#define  ATSC_ADDR_2877_ft_rf_agc_l_th_11_4_mask                                 (0x000000FF)
#define  ATSC_ADDR_2877_ft_rf_agc_l_th_11_4(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2877_get_ft_rf_agc_l_th_11_4(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2878                                                         0x181561E0
#define  ATSC_ADDR_2878_reg_addr                                                 "0xB81561E0"
#define  ATSC_ADDR_2878_reg                                                      0xB81561E0
#define  ATSC_ADDR_2878_inst_addr                                                "0x0492"
#define  set_ATSC_ADDR_2878_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2878_reg)=data)
#define  get_ATSC_ADDR_2878_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2878_reg))
#define  ATSC_ADDR_2878_ft_rf_agc_polar_shift                                    (3)
#define  ATSC_ADDR_2878_ft_if_agc_polar_shift                                    (2)
#define  ATSC_ADDR_2878_ft_rf_agc_l_th_13_12_shift                               (0)
#define  ATSC_ADDR_2878_ft_rf_agc_polar_mask                                     (0x00000008)
#define  ATSC_ADDR_2878_ft_if_agc_polar_mask                                     (0x00000004)
#define  ATSC_ADDR_2878_ft_rf_agc_l_th_13_12_mask                                (0x00000003)
#define  ATSC_ADDR_2878_ft_rf_agc_polar(data)                                    (0x00000008&((data)<<3))
#define  ATSC_ADDR_2878_ft_if_agc_polar(data)                                    (0x00000004&((data)<<2))
#define  ATSC_ADDR_2878_ft_rf_agc_l_th_13_12(data)                               (0x00000003&(data))
#define  ATSC_ADDR_2878_get_ft_rf_agc_polar(data)                                ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2878_get_ft_if_agc_polar(data)                                ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2878_get_ft_rf_agc_l_th_13_12(data)                           (0x00000003&(data))

#define  ATSC_ADDR_2879                                                         0x181561E4
#define  ATSC_ADDR_2879_reg_addr                                                 "0xB81561E4"
#define  ATSC_ADDR_2879_reg                                                      0xB81561E4
#define  ATSC_ADDR_2879_inst_addr                                                "0x0493"
#define  set_ATSC_ADDR_2879_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2879_reg)=data)
#define  get_ATSC_ADDR_2879_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2879_reg))
#define  ATSC_ADDR_2879_ft_aagc_target_value1_shift                              (0)
#define  ATSC_ADDR_2879_ft_aagc_target_value1_mask                               (0x000000FF)
#define  ATSC_ADDR_2879_ft_aagc_target_value1(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_2879_get_ft_aagc_target_value1(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_287A                                                         0x181561E8
#define  ATSC_ADDR_287A_reg_addr                                                 "0xB81561E8"
#define  ATSC_ADDR_287A_reg                                                      0xB81561E8
#define  ATSC_ADDR_287A_inst_addr                                                "0x0494"
#define  set_ATSC_ADDR_287A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_287A_reg)=data)
#define  get_ATSC_ADDR_287A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_287A_reg))
#define  ATSC_ADDR_287A_ft_aagc_target_value2_shift                              (0)
#define  ATSC_ADDR_287A_ft_aagc_target_value2_mask                               (0x000000FF)
#define  ATSC_ADDR_287A_ft_aagc_target_value2(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_287A_get_ft_aagc_target_value2(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_287B                                                         0x181561EC
#define  ATSC_ADDR_287B_reg_addr                                                 "0xB81561EC"
#define  ATSC_ADDR_287B_reg                                                      0xB81561EC
#define  ATSC_ADDR_287B_inst_addr                                                "0x0495"
#define  set_ATSC_ADDR_287B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_287B_reg)=data)
#define  get_ATSC_ADDR_287B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_287B_reg))
#define  ATSC_ADDR_287B_ft_dagc_lvl_th_6_0_shift                                 (1)
#define  ATSC_ADDR_287B_ft_dagc_en_shift                                         (0)
#define  ATSC_ADDR_287B_ft_dagc_lvl_th_6_0_mask                                  (0x000000FE)
#define  ATSC_ADDR_287B_ft_dagc_en_mask                                          (0x00000001)
#define  ATSC_ADDR_287B_ft_dagc_lvl_th_6_0(data)                                 (0x000000FE&((data)<<1))
#define  ATSC_ADDR_287B_ft_dagc_en(data)                                         (0x00000001&(data))
#define  ATSC_ADDR_287B_get_ft_dagc_lvl_th_6_0(data)                             ((0x000000FE&(data))>>1)
#define  ATSC_ADDR_287B_get_ft_dagc_en(data)                                     (0x00000001&(data))

#define  ATSC_ADDR_287C                                                         0x181561F0
#define  ATSC_ADDR_287C_reg_addr                                                 "0xB81561F0"
#define  ATSC_ADDR_287C_reg                                                      0xB81561F0
#define  ATSC_ADDR_287C_inst_addr                                                "0x0496"
#define  set_ATSC_ADDR_287C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_287C_reg)=data)
#define  get_ATSC_ADDR_287C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_287C_reg))
#define  ATSC_ADDR_287C_ft_dagc_diff_th_1_0_shift                                (6)
#define  ATSC_ADDR_287C_ft_dagc_lvl_th_12_7_shift                                (0)
#define  ATSC_ADDR_287C_ft_dagc_diff_th_1_0_mask                                 (0x000000C0)
#define  ATSC_ADDR_287C_ft_dagc_lvl_th_12_7_mask                                 (0x0000003F)
#define  ATSC_ADDR_287C_ft_dagc_diff_th_1_0(data)                                (0x000000C0&((data)<<6))
#define  ATSC_ADDR_287C_ft_dagc_lvl_th_12_7(data)                                (0x0000003F&(data))
#define  ATSC_ADDR_287C_get_ft_dagc_diff_th_1_0(data)                            ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_287C_get_ft_dagc_lvl_th_12_7(data)                            (0x0000003F&(data))

#define  ATSC_ADDR_287D                                                         0x181561F4
#define  ATSC_ADDR_287D_reg_addr                                                 "0xB81561F4"
#define  ATSC_ADDR_287D_reg                                                      0xB81561F4
#define  ATSC_ADDR_287D_inst_addr                                                "0x0497"
#define  set_ATSC_ADDR_287D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_287D_reg)=data)
#define  get_ATSC_ADDR_287D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_287D_reg))
#define  ATSC_ADDR_287D_ft_dagc_diff_th_9_2_shift                                (0)
#define  ATSC_ADDR_287D_ft_dagc_diff_th_9_2_mask                                 (0x000000FF)
#define  ATSC_ADDR_287D_ft_dagc_diff_th_9_2(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_287D_get_ft_dagc_diff_th_9_2(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_287E                                                         0x181561F8
#define  ATSC_ADDR_287E_reg_addr                                                 "0xB81561F8"
#define  ATSC_ADDR_287E_reg                                                      0xB81561F8
#define  ATSC_ADDR_287E_inst_addr                                                "0x0498"
#define  set_ATSC_ADDR_287E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_287E_reg)=data)
#define  get_ATSC_ADDR_287E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_287E_reg))
#define  ATSC_ADDR_287E_ft_dagc_diff_th_12_10_shift                              (0)
#define  ATSC_ADDR_287E_ft_dagc_diff_th_12_10_mask                               (0x00000007)
#define  ATSC_ADDR_287E_ft_dagc_diff_th_12_10(data)                              (0x00000007&(data))
#define  ATSC_ADDR_287E_get_ft_dagc_diff_th_12_10(data)                          (0x00000007&(data))

#define  ATSC_ADDR_2890                                                         0x18156240
#define  ATSC_ADDR_2890_reg_addr                                                 "0xB8156240"
#define  ATSC_ADDR_2890_reg                                                      0xB8156240
#define  ATSC_ADDR_2890_inst_addr                                                "0x0499"
#define  set_ATSC_ADDR_2890_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2890_reg)=data)
#define  get_ATSC_ADDR_2890_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2890_reg))
#define  ATSC_ADDR_2890_clip_mo_period_shift                                     (0)
#define  ATSC_ADDR_2890_clip_mo_period_mask                                      (0x000000FF)
#define  ATSC_ADDR_2890_clip_mo_period(data)                                     (0x000000FF&(data))
#define  ATSC_ADDR_2890_get_clip_mo_period(data)                                 (0x000000FF&(data))

#define  ATSC_ADDR_28A0                                                         0x18156280
#define  ATSC_ADDR_28A0_reg_addr                                                 "0xB8156280"
#define  ATSC_ADDR_28A0_reg                                                      0xB8156280
#define  ATSC_ADDR_28A0_inst_addr                                                "0x049A"
#define  set_ATSC_ADDR_28A0_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_28A0_reg)=data)
#define  get_ATSC_ADDR_28A0_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_28A0_reg))
#define  ATSC_ADDR_28A0_tst_dat_1_sel_shift                                      (0)
#define  ATSC_ADDR_28A0_tst_dat_1_sel_mask                                       (0x000000FF)
#define  ATSC_ADDR_28A0_tst_dat_1_sel(data)                                      (0x000000FF&(data))
#define  ATSC_ADDR_28A0_get_tst_dat_1_sel(data)                                  (0x000000FF&(data))

#define  ATSC_ADDR_28A1                                                         0x18156284
#define  ATSC_ADDR_28A1_reg_addr                                                 "0xB8156284"
#define  ATSC_ADDR_28A1_reg                                                      0xB8156284
#define  ATSC_ADDR_28A1_inst_addr                                                "0x049B"
#define  set_ATSC_ADDR_28A1_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_28A1_reg)=data)
#define  get_ATSC_ADDR_28A1_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_28A1_reg))
#define  ATSC_ADDR_28A1_tst_dat_2_sel_shift                                      (0)
#define  ATSC_ADDR_28A1_tst_dat_2_sel_mask                                       (0x000000FF)
#define  ATSC_ADDR_28A1_tst_dat_2_sel(data)                                      (0x000000FF&(data))
#define  ATSC_ADDR_28A1_get_tst_dat_2_sel(data)                                  (0x000000FF&(data))

#define  ATSC_ADDR_28A2                                                         0x18156288
#define  ATSC_ADDR_28A2_reg_addr                                                 "0xB8156288"
#define  ATSC_ADDR_28A2_reg                                                      0xB8156288
#define  ATSC_ADDR_28A2_inst_addr                                                "0x049C"
#define  set_ATSC_ADDR_28A2_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_28A2_reg)=data)
#define  get_ATSC_ADDR_28A2_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_28A2_reg))
#define  ATSC_ADDR_28A2_tst_ena_sel_shift                                        (0)
#define  ATSC_ADDR_28A2_tst_ena_sel_mask                                         (0x000000FF)
#define  ATSC_ADDR_28A2_tst_ena_sel(data)                                        (0x000000FF&(data))
#define  ATSC_ADDR_28A2_get_tst_ena_sel(data)                                    (0x000000FF&(data))

#define  ATSC_ADDR_28A3                                                         0x1815628C
#define  ATSC_ADDR_28A3_reg_addr                                                 "0xB815628C"
#define  ATSC_ADDR_28A3_reg                                                      0xB815628C
#define  ATSC_ADDR_28A3_inst_addr                                                "0x049D"
#define  set_ATSC_ADDR_28A3_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_28A3_reg)=data)
#define  get_ATSC_ADDR_28A3_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_28A3_reg))
#define  ATSC_ADDR_28A3_tst_irq1_sel_shift                                       (0)
#define  ATSC_ADDR_28A3_tst_irq1_sel_mask                                        (0x000000FF)
#define  ATSC_ADDR_28A3_tst_irq1_sel(data)                                       (0x000000FF&(data))
#define  ATSC_ADDR_28A3_get_tst_irq1_sel(data)                                   (0x000000FF&(data))

#define  ATSC_ADDR_28A4                                                         0x18156290
#define  ATSC_ADDR_28A4_reg_addr                                                 "0xB8156290"
#define  ATSC_ADDR_28A4_reg                                                      0xB8156290
#define  ATSC_ADDR_28A4_inst_addr                                                "0x049E"
#define  set_ATSC_ADDR_28A4_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_28A4_reg)=data)
#define  get_ATSC_ADDR_28A4_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_28A4_reg))
#define  ATSC_ADDR_28A4_tst_irq2_sel_shift                                       (0)
#define  ATSC_ADDR_28A4_tst_irq2_sel_mask                                        (0x000000FF)
#define  ATSC_ADDR_28A4_tst_irq2_sel(data)                                       (0x000000FF&(data))
#define  ATSC_ADDR_28A4_get_tst_irq2_sel(data)                                   (0x000000FF&(data))

#define  ATSC_ADDR_28A5                                                         0x18156294
#define  ATSC_ADDR_28A5_reg_addr                                                 "0xB8156294"
#define  ATSC_ADDR_28A5_reg                                                      0xB8156294
#define  ATSC_ADDR_28A5_inst_addr                                                "0x049F"
#define  set_ATSC_ADDR_28A5_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_28A5_reg)=data)
#define  get_ATSC_ADDR_28A5_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_28A5_reg))
#define  ATSC_ADDR_28A5_mse_th_irq1_7_0_shift                                    (0)
#define  ATSC_ADDR_28A5_mse_th_irq1_7_0_mask                                     (0x000000FF)
#define  ATSC_ADDR_28A5_mse_th_irq1_7_0(data)                                    (0x000000FF&(data))
#define  ATSC_ADDR_28A5_get_mse_th_irq1_7_0(data)                                (0x000000FF&(data))

#define  ATSC_ADDR_28A6                                                         0x18156298
#define  ATSC_ADDR_28A6_reg_addr                                                 "0xB8156298"
#define  ATSC_ADDR_28A6_reg                                                      0xB8156298
#define  ATSC_ADDR_28A6_inst_addr                                                "0x04A0"
#define  set_ATSC_ADDR_28A6_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_28A6_reg)=data)
#define  get_ATSC_ADDR_28A6_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_28A6_reg))
#define  ATSC_ADDR_28A6_mse_th_irq1_15_8_shift                                   (0)
#define  ATSC_ADDR_28A6_mse_th_irq1_15_8_mask                                    (0x000000FF)
#define  ATSC_ADDR_28A6_mse_th_irq1_15_8(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_28A6_get_mse_th_irq1_15_8(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_28A7                                                         0x1815629C
#define  ATSC_ADDR_28A7_reg_addr                                                 "0xB815629C"
#define  ATSC_ADDR_28A7_reg                                                      0xB815629C
#define  ATSC_ADDR_28A7_inst_addr                                                "0x04A1"
#define  set_ATSC_ADDR_28A7_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_28A7_reg)=data)
#define  get_ATSC_ADDR_28A7_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_28A7_reg))
#define  ATSC_ADDR_28A7_mse_th_irq1_23_16_shift                                  (0)
#define  ATSC_ADDR_28A7_mse_th_irq1_23_16_mask                                   (0x000000FF)
#define  ATSC_ADDR_28A7_mse_th_irq1_23_16(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_28A7_get_mse_th_irq1_23_16(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_28A8                                                         0x181562A0
#define  ATSC_ADDR_28A8_reg_addr                                                 "0xB81562A0"
#define  ATSC_ADDR_28A8_reg                                                      0xB81562A0
#define  ATSC_ADDR_28A8_inst_addr                                                "0x04A2"
#define  set_ATSC_ADDR_28A8_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_28A8_reg)=data)
#define  get_ATSC_ADDR_28A8_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_28A8_reg))
#define  ATSC_ADDR_28A8_mse_th_irq1_31_24_shift                                  (0)
#define  ATSC_ADDR_28A8_mse_th_irq1_31_24_mask                                   (0x000000FF)
#define  ATSC_ADDR_28A8_mse_th_irq1_31_24(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_28A8_get_mse_th_irq1_31_24(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_28A9                                                         0x181562A4
#define  ATSC_ADDR_28A9_reg_addr                                                 "0xB81562A4"
#define  ATSC_ADDR_28A9_reg                                                      0xB81562A4
#define  ATSC_ADDR_28A9_inst_addr                                                "0x04A3"
#define  set_ATSC_ADDR_28A9_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_28A9_reg)=data)
#define  get_ATSC_ADDR_28A9_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_28A9_reg))
#define  ATSC_ADDR_28A9_mse_th_irq2_7_0_shift                                    (0)
#define  ATSC_ADDR_28A9_mse_th_irq2_7_0_mask                                     (0x000000FF)
#define  ATSC_ADDR_28A9_mse_th_irq2_7_0(data)                                    (0x000000FF&(data))
#define  ATSC_ADDR_28A9_get_mse_th_irq2_7_0(data)                                (0x000000FF&(data))

#define  ATSC_ADDR_28AA                                                         0x181562A8
#define  ATSC_ADDR_28AA_reg_addr                                                 "0xB81562A8"
#define  ATSC_ADDR_28AA_reg                                                      0xB81562A8
#define  ATSC_ADDR_28AA_inst_addr                                                "0x04A4"
#define  set_ATSC_ADDR_28AA_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_28AA_reg)=data)
#define  get_ATSC_ADDR_28AA_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_28AA_reg))
#define  ATSC_ADDR_28AA_mse_th_irq2_15_8_shift                                   (0)
#define  ATSC_ADDR_28AA_mse_th_irq2_15_8_mask                                    (0x000000FF)
#define  ATSC_ADDR_28AA_mse_th_irq2_15_8(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_28AA_get_mse_th_irq2_15_8(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_28AB                                                         0x181562AC
#define  ATSC_ADDR_28AB_reg_addr                                                 "0xB81562AC"
#define  ATSC_ADDR_28AB_reg                                                      0xB81562AC
#define  ATSC_ADDR_28AB_inst_addr                                                "0x04A5"
#define  set_ATSC_ADDR_28AB_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_28AB_reg)=data)
#define  get_ATSC_ADDR_28AB_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_28AB_reg))
#define  ATSC_ADDR_28AB_mse_th_irq2_23_16_shift                                  (0)
#define  ATSC_ADDR_28AB_mse_th_irq2_23_16_mask                                   (0x000000FF)
#define  ATSC_ADDR_28AB_mse_th_irq2_23_16(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_28AB_get_mse_th_irq2_23_16(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_28AC                                                         0x181562B0
#define  ATSC_ADDR_28AC_reg_addr                                                 "0xB81562B0"
#define  ATSC_ADDR_28AC_reg                                                      0xB81562B0
#define  ATSC_ADDR_28AC_inst_addr                                                "0x04A6"
#define  set_ATSC_ADDR_28AC_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_28AC_reg)=data)
#define  get_ATSC_ADDR_28AC_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_28AC_reg))
#define  ATSC_ADDR_28AC_mse_th_irq2_31_24_shift                                  (0)
#define  ATSC_ADDR_28AC_mse_th_irq2_31_24_mask                                   (0x000000FF)
#define  ATSC_ADDR_28AC_mse_th_irq2_31_24(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_28AC_get_mse_th_irq2_31_24(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_28AD                                                         0x181562B4
#define  ATSC_ADDR_28AD_reg_addr                                                 "0xB81562B4"
#define  ATSC_ADDR_28AD_reg                                                      0xB81562B4
#define  ATSC_ADDR_28AD_inst_addr                                                "0x04A7"
#define  set_ATSC_ADDR_28AD_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_28AD_reg)=data)
#define  get_ATSC_ADDR_28AD_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_28AD_reg))
#define  ATSC_ADDR_28AD_tst_irq1_reg_shift                                       (6)
#define  ATSC_ADDR_28AD_tst_state_irq1_shift                                     (0)
#define  ATSC_ADDR_28AD_tst_irq1_reg_mask                                        (0x00000040)
#define  ATSC_ADDR_28AD_tst_state_irq1_mask                                      (0x0000003F)
#define  ATSC_ADDR_28AD_tst_irq1_reg(data)                                       (0x00000040&((data)<<6))
#define  ATSC_ADDR_28AD_tst_state_irq1(data)                                     (0x0000003F&(data))
#define  ATSC_ADDR_28AD_get_tst_irq1_reg(data)                                   ((0x00000040&(data))>>6)
#define  ATSC_ADDR_28AD_get_tst_state_irq1(data)                                 (0x0000003F&(data))

#define  ATSC_ADDR_28AE                                                         0x181562B8
#define  ATSC_ADDR_28AE_reg_addr                                                 "0xB81562B8"
#define  ATSC_ADDR_28AE_reg                                                      0xB81562B8
#define  ATSC_ADDR_28AE_inst_addr                                                "0x04A8"
#define  set_ATSC_ADDR_28AE_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_28AE_reg)=data)
#define  get_ATSC_ADDR_28AE_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_28AE_reg))
#define  ATSC_ADDR_28AE_tst_irq2_reg_shift                                       (6)
#define  ATSC_ADDR_28AE_tst_state_irq2_shift                                     (0)
#define  ATSC_ADDR_28AE_tst_irq2_reg_mask                                        (0x00000040)
#define  ATSC_ADDR_28AE_tst_state_irq2_mask                                      (0x0000003F)
#define  ATSC_ADDR_28AE_tst_irq2_reg(data)                                       (0x00000040&((data)<<6))
#define  ATSC_ADDR_28AE_tst_state_irq2(data)                                     (0x0000003F&(data))
#define  ATSC_ADDR_28AE_get_tst_irq2_reg(data)                                   ((0x00000040&(data))>>6)
#define  ATSC_ADDR_28AE_get_tst_state_irq2(data)                                 (0x0000003F&(data))

#define  ATSC_ADDR_28AF                                                         0x181562BC
#define  ATSC_ADDR_28AF_reg_addr                                                 "0xB81562BC"
#define  ATSC_ADDR_28AF_reg                                                      0xB81562BC
#define  ATSC_ADDR_28AF_inst_addr                                                "0x04A9"
#define  set_ATSC_ADDR_28AF_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_28AF_reg)=data)
#define  get_ATSC_ADDR_28AF_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_28AF_reg))
#define  ATSC_ADDR_28AF_tst_norm_sel_shift                                       (0)
#define  ATSC_ADDR_28AF_tst_norm_sel_mask                                        (0x000000FF)
#define  ATSC_ADDR_28AF_tst_norm_sel(data)                                       (0x000000FF&(data))
#define  ATSC_ADDR_28AF_get_tst_norm_sel(data)                                   (0x000000FF&(data))

#define  ATSC_ADDR_28B0                                                         0x181562C0
#define  ATSC_ADDR_28B0_reg_addr                                                 "0xB81562C0"
#define  ATSC_ADDR_28B0_reg                                                      0xB81562C0
#define  ATSC_ADDR_28B0_inst_addr                                                "0x04AA"
#define  set_ATSC_ADDR_28B0_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_28B0_reg)=data)
#define  get_ATSC_ADDR_28B0_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_28B0_reg))
#define  ATSC_ADDR_28B0_mse_th_norm_7_0_shift                                    (0)
#define  ATSC_ADDR_28B0_mse_th_norm_7_0_mask                                     (0x000000FF)
#define  ATSC_ADDR_28B0_mse_th_norm_7_0(data)                                    (0x000000FF&(data))
#define  ATSC_ADDR_28B0_get_mse_th_norm_7_0(data)                                (0x000000FF&(data))

#define  ATSC_ADDR_28B1                                                         0x181562C4
#define  ATSC_ADDR_28B1_reg_addr                                                 "0xB81562C4"
#define  ATSC_ADDR_28B1_reg                                                      0xB81562C4
#define  ATSC_ADDR_28B1_inst_addr                                                "0x04AB"
#define  set_ATSC_ADDR_28B1_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_28B1_reg)=data)
#define  get_ATSC_ADDR_28B1_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_28B1_reg))
#define  ATSC_ADDR_28B1_mse_th_norm_15_8_shift                                   (0)
#define  ATSC_ADDR_28B1_mse_th_norm_15_8_mask                                    (0x000000FF)
#define  ATSC_ADDR_28B1_mse_th_norm_15_8(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_28B1_get_mse_th_norm_15_8(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_28B2                                                         0x181562C8
#define  ATSC_ADDR_28B2_reg_addr                                                 "0xB81562C8"
#define  ATSC_ADDR_28B2_reg                                                      0xB81562C8
#define  ATSC_ADDR_28B2_inst_addr                                                "0x04AC"
#define  set_ATSC_ADDR_28B2_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_28B2_reg)=data)
#define  get_ATSC_ADDR_28B2_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_28B2_reg))
#define  ATSC_ADDR_28B2_mse_th_norm_23_16_shift                                  (0)
#define  ATSC_ADDR_28B2_mse_th_norm_23_16_mask                                   (0x000000FF)
#define  ATSC_ADDR_28B2_mse_th_norm_23_16(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_28B2_get_mse_th_norm_23_16(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_28B3                                                         0x181562CC
#define  ATSC_ADDR_28B3_reg_addr                                                 "0xB81562CC"
#define  ATSC_ADDR_28B3_reg                                                      0xB81562CC
#define  ATSC_ADDR_28B3_inst_addr                                                "0x04AD"
#define  set_ATSC_ADDR_28B3_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_28B3_reg)=data)
#define  get_ATSC_ADDR_28B3_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_28B3_reg))
#define  ATSC_ADDR_28B3_mse_th_norm_31_24_shift                                  (0)
#define  ATSC_ADDR_28B3_mse_th_norm_31_24_mask                                   (0x000000FF)
#define  ATSC_ADDR_28B3_mse_th_norm_31_24(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_28B3_get_mse_th_norm_31_24(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_28B4                                                         0x181562D0
#define  ATSC_ADDR_28B4_reg_addr                                                 "0xB81562D0"
#define  ATSC_ADDR_28B4_reg                                                      0xB81562D0
#define  ATSC_ADDR_28B4_inst_addr                                                "0x04AE"
#define  set_ATSC_ADDR_28B4_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_28B4_reg)=data)
#define  get_ATSC_ADDR_28B4_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_28B4_reg))
#define  ATSC_ADDR_28B4_tst_norm_reg_shift                                       (6)
#define  ATSC_ADDR_28B4_tst_state_norm_shift                                     (0)
#define  ATSC_ADDR_28B4_tst_norm_reg_mask                                        (0x00000040)
#define  ATSC_ADDR_28B4_tst_state_norm_mask                                      (0x0000003F)
#define  ATSC_ADDR_28B4_tst_norm_reg(data)                                       (0x00000040&((data)<<6))
#define  ATSC_ADDR_28B4_tst_state_norm(data)                                     (0x0000003F&(data))
#define  ATSC_ADDR_28B4_get_tst_norm_reg(data)                                   ((0x00000040&(data))>>6)
#define  ATSC_ADDR_28B4_get_tst_state_norm(data)                                 (0x0000003F&(data))

#define  ATSC_ADDR_28C0                                                         0x18156300
#define  ATSC_ADDR_28C0_reg_addr                                                 "0xB8156300"
#define  ATSC_ADDR_28C0_reg                                                      0xB8156300
#define  ATSC_ADDR_28C0_inst_addr                                                "0x04AF"
#define  set_ATSC_ADDR_28C0_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_28C0_reg)=data)
#define  get_ATSC_ADDR_28C0_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_28C0_reg))
#define  ATSC_ADDR_28C0_bist_reset_n_shift                                       (1)
#define  ATSC_ADDR_28C0_bist_mode_shift                                          (0)
#define  ATSC_ADDR_28C0_bist_reset_n_mask                                        (0x00000002)
#define  ATSC_ADDR_28C0_bist_mode_mask                                           (0x00000001)
#define  ATSC_ADDR_28C0_bist_reset_n(data)                                       (0x00000002&((data)<<1))
#define  ATSC_ADDR_28C0_bist_mode(data)                                          (0x00000001&(data))
#define  ATSC_ADDR_28C0_get_bist_reset_n(data)                                   ((0x00000002&(data))>>1)
#define  ATSC_ADDR_28C0_get_bist_mode(data)                                      (0x00000001&(data))

#define  ATSC_ADDR_28CB                                                         0x1815632C
#define  ATSC_ADDR_28CB_reg_addr                                                 "0xB815632C"
#define  ATSC_ADDR_28CB_reg                                                      0xB815632C
#define  ATSC_ADDR_28CB_inst_addr                                                "0x04B0"
#define  set_ATSC_ADDR_28CB_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_28CB_reg)=data)
#define  get_ATSC_ADDR_28CB_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_28CB_reg))
#define  ATSC_ADDR_28CB_drf_menu_resume_shift                                    (4)
#define  ATSC_ADDR_28CB_opt_drf_resume_shift                                     (3)
#define  ATSC_ADDR_28CB_dvse_0_shift                                             (2)
#define  ATSC_ADDR_28CB_drf_bist_mode_shift                                      (1)
#define  ATSC_ADDR_28CB_drf_menu_resume_mask                                     (0x00000010)
#define  ATSC_ADDR_28CB_opt_drf_resume_mask                                      (0x00000008)
#define  ATSC_ADDR_28CB_dvse_0_mask                                              (0x00000004)
#define  ATSC_ADDR_28CB_drf_bist_mode_mask                                       (0x00000002)
#define  ATSC_ADDR_28CB_drf_menu_resume(data)                                    (0x00000010&((data)<<4))
#define  ATSC_ADDR_28CB_opt_drf_resume(data)                                     (0x00000008&((data)<<3))
#define  ATSC_ADDR_28CB_dvse_0(data)                                             (0x00000004&((data)<<2))
#define  ATSC_ADDR_28CB_drf_bist_mode(data)                                      (0x00000002&((data)<<1))
#define  ATSC_ADDR_28CB_get_drf_menu_resume(data)                                ((0x00000010&(data))>>4)
#define  ATSC_ADDR_28CB_get_opt_drf_resume(data)                                 ((0x00000008&(data))>>3)
#define  ATSC_ADDR_28CB_get_dvse_0(data)                                         ((0x00000004&(data))>>2)
#define  ATSC_ADDR_28CB_get_drf_bist_mode(data)                                  ((0x00000002&(data))>>1)

#define  ATSC_ADDR_28CC                                                         0x18156330
#define  ATSC_ADDR_28CC_reg_addr                                                 "0xB8156330"
#define  ATSC_ADDR_28CC_reg                                                      0xB8156330
#define  ATSC_ADDR_28CC_inst_addr                                                "0x04B1"
#define  set_ATSC_ADDR_28CC_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_28CC_reg)=data)
#define  get_ATSC_ADDR_28CC_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_28CC_reg))
#define  ATSC_ADDR_28CC_drf_dvs_shift                                            (0)
#define  ATSC_ADDR_28CC_drf_dvs_mask                                             (0x0000000F)
#define  ATSC_ADDR_28CC_drf_dvs(data)                                            (0x0000000F&(data))
#define  ATSC_ADDR_28CC_get_drf_dvs(data)                                        (0x0000000F&(data))

#define  ATSC_ADDR_28CD                                                         0x18156334
#define  ATSC_ADDR_28CD_reg_addr                                                 "0xB8156334"
#define  ATSC_ADDR_28CD_reg                                                      0xB8156334
#define  ATSC_ADDR_28CD_inst_addr                                                "0x04B2"
#define  set_ATSC_ADDR_28CD_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_28CD_reg)=data)
#define  get_ATSC_ADDR_28CD_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_28CD_reg))
#define  ATSC_ADDR_28CD_reg_drf_time_cnt_th_7_0_shift                            (0)
#define  ATSC_ADDR_28CD_reg_drf_time_cnt_th_7_0_mask                             (0x000000FF)
#define  ATSC_ADDR_28CD_reg_drf_time_cnt_th_7_0(data)                            (0x000000FF&(data))
#define  ATSC_ADDR_28CD_get_reg_drf_time_cnt_th_7_0(data)                        (0x000000FF&(data))

#define  ATSC_ADDR_28CE                                                         0x18156338
#define  ATSC_ADDR_28CE_reg_addr                                                 "0xB8156338"
#define  ATSC_ADDR_28CE_reg                                                      0xB8156338
#define  ATSC_ADDR_28CE_inst_addr                                                "0x04B3"
#define  set_ATSC_ADDR_28CE_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_28CE_reg)=data)
#define  get_ATSC_ADDR_28CE_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_28CE_reg))
#define  ATSC_ADDR_28CE_reg_drf_time_cnt_th_12_8_shift                           (0)
#define  ATSC_ADDR_28CE_reg_drf_time_cnt_th_12_8_mask                            (0x0000001F)
#define  ATSC_ADDR_28CE_reg_drf_time_cnt_th_12_8(data)                           (0x0000001F&(data))
#define  ATSC_ADDR_28CE_get_reg_drf_time_cnt_th_12_8(data)                       (0x0000001F&(data))

#define  ATSC_ADDR_2E01                                                         0x18157804
#define  ATSC_ADDR_2E01_reg_addr                                                 "0xB8157804"
#define  ATSC_ADDR_2E01_reg                                                      0xB8157804
#define  ATSC_ADDR_2E01_inst_addr                                                "0x04B4"
#define  set_ATSC_ADDR_2E01_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E01_reg)=data)
#define  get_ATSC_ADDR_2E01_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E01_reg))
#define  ATSC_ADDR_2E01_cr_dr1_mean_pwr_7_0_shift                                (0)
#define  ATSC_ADDR_2E01_cr_dr1_mean_pwr_7_0_mask                                 (0x000000FF)
#define  ATSC_ADDR_2E01_cr_dr1_mean_pwr_7_0(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2E01_get_cr_dr1_mean_pwr_7_0(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2E02                                                         0x18157808
#define  ATSC_ADDR_2E02_reg_addr                                                 "0xB8157808"
#define  ATSC_ADDR_2E02_reg                                                      0xB8157808
#define  ATSC_ADDR_2E02_inst_addr                                                "0x04B5"
#define  set_ATSC_ADDR_2E02_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E02_reg)=data)
#define  get_ATSC_ADDR_2E02_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E02_reg))
#define  ATSC_ADDR_2E02_cr_dr1_mean_pwr_15_8_shift                               (0)
#define  ATSC_ADDR_2E02_cr_dr1_mean_pwr_15_8_mask                                (0x000000FF)
#define  ATSC_ADDR_2E02_cr_dr1_mean_pwr_15_8(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_2E02_get_cr_dr1_mean_pwr_15_8(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_2E03                                                         0x1815780C
#define  ATSC_ADDR_2E03_reg_addr                                                 "0xB815780C"
#define  ATSC_ADDR_2E03_reg                                                      0xB815780C
#define  ATSC_ADDR_2E03_inst_addr                                                "0x04B6"
#define  set_ATSC_ADDR_2E03_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E03_reg)=data)
#define  get_ATSC_ADDR_2E03_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E03_reg))
#define  ATSC_ADDR_2E03_cr_dr1_mean_pwr_22_16_shift                              (0)
#define  ATSC_ADDR_2E03_cr_dr1_mean_pwr_22_16_mask                               (0x0000007F)
#define  ATSC_ADDR_2E03_cr_dr1_mean_pwr_22_16(data)                              (0x0000007F&(data))
#define  ATSC_ADDR_2E03_get_cr_dr1_mean_pwr_22_16(data)                          (0x0000007F&(data))

#define  ATSC_ADDR_2E04                                                         0x18157810
#define  ATSC_ADDR_2E04_reg_addr                                                 "0xB8157810"
#define  ATSC_ADDR_2E04_reg                                                      0xB8157810
#define  ATSC_ADDR_2E04_inst_addr                                                "0x04B7"
#define  set_ATSC_ADDR_2E04_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E04_reg)=data)
#define  get_ATSC_ADDR_2E04_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E04_reg))
#define  ATSC_ADDR_2E04_cr_dr1_im_hpf_pwr_qtz_7_0_shift                          (0)
#define  ATSC_ADDR_2E04_cr_dr1_im_hpf_pwr_qtz_7_0_mask                           (0x000000FF)
#define  ATSC_ADDR_2E04_cr_dr1_im_hpf_pwr_qtz_7_0(data)                          (0x000000FF&(data))
#define  ATSC_ADDR_2E04_get_cr_dr1_im_hpf_pwr_qtz_7_0(data)                      (0x000000FF&(data))

#define  ATSC_ADDR_2E05                                                         0x18157814
#define  ATSC_ADDR_2E05_reg_addr                                                 "0xB8157814"
#define  ATSC_ADDR_2E05_reg                                                      0xB8157814
#define  ATSC_ADDR_2E05_inst_addr                                                "0x04B8"
#define  set_ATSC_ADDR_2E05_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E05_reg)=data)
#define  get_ATSC_ADDR_2E05_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E05_reg))
#define  ATSC_ADDR_2E05_cr_dr1_im_hpf_pwr_qtz_15_8_shift                         (0)
#define  ATSC_ADDR_2E05_cr_dr1_im_hpf_pwr_qtz_15_8_mask                          (0x000000FF)
#define  ATSC_ADDR_2E05_cr_dr1_im_hpf_pwr_qtz_15_8(data)                         (0x000000FF&(data))
#define  ATSC_ADDR_2E05_get_cr_dr1_im_hpf_pwr_qtz_15_8(data)                     (0x000000FF&(data))

#define  ATSC_ADDR_2E06                                                         0x18157818
#define  ATSC_ADDR_2E06_reg_addr                                                 "0xB8157818"
#define  ATSC_ADDR_2E06_reg                                                      0xB8157818
#define  ATSC_ADDR_2E06_inst_addr                                                "0x04B9"
#define  set_ATSC_ADDR_2E06_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E06_reg)=data)
#define  get_ATSC_ADDR_2E06_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E06_reg))
#define  ATSC_ADDR_2E06_cr_comp_scale_exp_shift                                  (4)
#define  ATSC_ADDR_2E06_cr_dr1_im_hpf_pwr_qtz_19_16_shift                        (0)
#define  ATSC_ADDR_2E06_cr_comp_scale_exp_mask                                   (0x000000F0)
#define  ATSC_ADDR_2E06_cr_dr1_im_hpf_pwr_qtz_19_16_mask                         (0x0000000F)
#define  ATSC_ADDR_2E06_cr_comp_scale_exp(data)                                  (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2E06_cr_dr1_im_hpf_pwr_qtz_19_16(data)                        (0x0000000F&(data))
#define  ATSC_ADDR_2E06_get_cr_comp_scale_exp(data)                              ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2E06_get_cr_dr1_im_hpf_pwr_qtz_19_16(data)                    (0x0000000F&(data))

#define  ATSC_ADDR_2E2E                                                         0x181578B8
#define  ATSC_ADDR_2E2E_reg_addr                                                 "0xB81578B8"
#define  ATSC_ADDR_2E2E_reg                                                      0xB81578B8
#define  ATSC_ADDR_2E2E_inst_addr                                                "0x04BA"
#define  set_ATSC_ADDR_2E2E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E2E_reg)=data)
#define  get_ATSC_ADDR_2E2E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E2E_reg))
#define  ATSC_ADDR_2E2E_ro_fsm_addr_col_cnt_7_0_shift                            (0)
#define  ATSC_ADDR_2E2E_ro_fsm_addr_col_cnt_7_0_mask                             (0x000000FF)
#define  ATSC_ADDR_2E2E_ro_fsm_addr_col_cnt_7_0(data)                            (0x000000FF&(data))
#define  ATSC_ADDR_2E2E_get_ro_fsm_addr_col_cnt_7_0(data)                        (0x000000FF&(data))

#define  ATSC_ADDR_2E2F                                                         0x181578BC
#define  ATSC_ADDR_2E2F_reg_addr                                                 "0xB81578BC"
#define  ATSC_ADDR_2E2F_reg                                                      0xB81578BC
#define  ATSC_ADDR_2E2F_inst_addr                                                "0x04BB"
#define  set_ATSC_ADDR_2E2F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E2F_reg)=data)
#define  get_ATSC_ADDR_2E2F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E2F_reg))
#define  ATSC_ADDR_2E2F_ro_fsm_addr_row_cnt_shift                                (1)
#define  ATSC_ADDR_2E2F_ro_fsm_addr_col_cnt_8_shift                              (0)
#define  ATSC_ADDR_2E2F_ro_fsm_addr_row_cnt_mask                                 (0x0000007E)
#define  ATSC_ADDR_2E2F_ro_fsm_addr_col_cnt_8_mask                               (0x00000001)
#define  ATSC_ADDR_2E2F_ro_fsm_addr_row_cnt(data)                                (0x0000007E&((data)<<1))
#define  ATSC_ADDR_2E2F_ro_fsm_addr_col_cnt_8(data)                              (0x00000001&(data))
#define  ATSC_ADDR_2E2F_get_ro_fsm_addr_row_cnt(data)                            ((0x0000007E&(data))>>1)
#define  ATSC_ADDR_2E2F_get_ro_fsm_addr_col_cnt_8(data)                          (0x00000001&(data))

#define  ATSC_ADDR_2E30                                                         0x181578C0
#define  ATSC_ADDR_2E30_reg_addr                                                 "0xB81578C0"
#define  ATSC_ADDR_2E30_reg                                                      0xB81578C0
#define  ATSC_ADDR_2E30_inst_addr                                                "0x04BC"
#define  set_ATSC_ADDR_2E30_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E30_reg)=data)
#define  get_ATSC_ADDR_2E30_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E30_reg))
#define  ATSC_ADDR_2E30_ado_dc_1_q_7_0_shift                                     (0)
#define  ATSC_ADDR_2E30_ado_dc_1_q_7_0_mask                                      (0x000000FF)
#define  ATSC_ADDR_2E30_ado_dc_1_q_7_0(data)                                     (0x000000FF&(data))
#define  ATSC_ADDR_2E30_get_ado_dc_1_q_7_0(data)                                 (0x000000FF&(data))

#define  ATSC_ADDR_2E31                                                         0x181578C4
#define  ATSC_ADDR_2E31_reg_addr                                                 "0xB81578C4"
#define  ATSC_ADDR_2E31_reg                                                      0xB81578C4
#define  ATSC_ADDR_2E31_inst_addr                                                "0x04BD"
#define  set_ATSC_ADDR_2E31_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E31_reg)=data)
#define  get_ATSC_ADDR_2E31_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E31_reg))
#define  ATSC_ADDR_2E31_ado_dc_1_q_im_3_0_shift                                  (4)
#define  ATSC_ADDR_2E31_ado_dc_1_q_11_8_shift                                    (0)
#define  ATSC_ADDR_2E31_ado_dc_1_q_im_3_0_mask                                   (0x000000F0)
#define  ATSC_ADDR_2E31_ado_dc_1_q_11_8_mask                                     (0x0000000F)
#define  ATSC_ADDR_2E31_ado_dc_1_q_im_3_0(data)                                  (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2E31_ado_dc_1_q_11_8(data)                                    (0x0000000F&(data))
#define  ATSC_ADDR_2E31_get_ado_dc_1_q_im_3_0(data)                              ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2E31_get_ado_dc_1_q_11_8(data)                                (0x0000000F&(data))

#define  ATSC_ADDR_2E32                                                         0x181578C8
#define  ATSC_ADDR_2E32_reg_addr                                                 "0xB81578C8"
#define  ATSC_ADDR_2E32_reg                                                      0xB81578C8
#define  ATSC_ADDR_2E32_inst_addr                                                "0x04BE"
#define  set_ATSC_ADDR_2E32_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E32_reg)=data)
#define  get_ATSC_ADDR_2E32_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E32_reg))
#define  ATSC_ADDR_2E32_ado_dc_1_q_im_11_4_shift                                 (0)
#define  ATSC_ADDR_2E32_ado_dc_1_q_im_11_4_mask                                  (0x000000FF)
#define  ATSC_ADDR_2E32_ado_dc_1_q_im_11_4(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2E32_get_ado_dc_1_q_im_11_4(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2E33                                                         0x181578CC
#define  ATSC_ADDR_2E33_reg_addr                                                 "0xB81578CC"
#define  ATSC_ADDR_2E33_reg                                                      0xB81578CC
#define  ATSC_ADDR_2E33_inst_addr                                                "0x04BF"
#define  set_ATSC_ADDR_2E33_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E33_reg)=data)
#define  get_ATSC_ADDR_2E33_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E33_reg))
#define  ATSC_ADDR_2E33_ado_dc_2_q_7_0_shift                                     (0)
#define  ATSC_ADDR_2E33_ado_dc_2_q_7_0_mask                                      (0x000000FF)
#define  ATSC_ADDR_2E33_ado_dc_2_q_7_0(data)                                     (0x000000FF&(data))
#define  ATSC_ADDR_2E33_get_ado_dc_2_q_7_0(data)                                 (0x000000FF&(data))

#define  ATSC_ADDR_2E34                                                         0x181578D0
#define  ATSC_ADDR_2E34_reg_addr                                                 "0xB81578D0"
#define  ATSC_ADDR_2E34_reg                                                      0xB81578D0
#define  ATSC_ADDR_2E34_inst_addr                                                "0x04C0"
#define  set_ATSC_ADDR_2E34_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E34_reg)=data)
#define  get_ATSC_ADDR_2E34_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E34_reg))
#define  ATSC_ADDR_2E34_ado_dc_2_q_im_3_0_shift                                  (4)
#define  ATSC_ADDR_2E34_ado_dc_2_q_11_8_shift                                    (0)
#define  ATSC_ADDR_2E34_ado_dc_2_q_im_3_0_mask                                   (0x000000F0)
#define  ATSC_ADDR_2E34_ado_dc_2_q_11_8_mask                                     (0x0000000F)
#define  ATSC_ADDR_2E34_ado_dc_2_q_im_3_0(data)                                  (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2E34_ado_dc_2_q_11_8(data)                                    (0x0000000F&(data))
#define  ATSC_ADDR_2E34_get_ado_dc_2_q_im_3_0(data)                              ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2E34_get_ado_dc_2_q_11_8(data)                                (0x0000000F&(data))

#define  ATSC_ADDR_2E35                                                         0x181578D4
#define  ATSC_ADDR_2E35_reg_addr                                                 "0xB81578D4"
#define  ATSC_ADDR_2E35_reg                                                      0xB81578D4
#define  ATSC_ADDR_2E35_inst_addr                                                "0x04C1"
#define  set_ATSC_ADDR_2E35_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E35_reg)=data)
#define  get_ATSC_ADDR_2E35_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E35_reg))
#define  ATSC_ADDR_2E35_ado_dc_2_q_im_11_4_shift                                 (0)
#define  ATSC_ADDR_2E35_ado_dc_2_q_im_11_4_mask                                  (0x000000FF)
#define  ATSC_ADDR_2E35_ado_dc_2_q_im_11_4(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2E35_get_ado_dc_2_q_im_11_4(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2E36                                                         0x181578D8
#define  ATSC_ADDR_2E36_reg_addr                                                 "0xB81578D8"
#define  ATSC_ADDR_2E36_reg                                                      0xB81578D8
#define  ATSC_ADDR_2E36_inst_addr                                                "0x04C2"
#define  set_ATSC_ADDR_2E36_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E36_reg)=data)
#define  get_ATSC_ADDR_2E36_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E36_reg))
#define  ATSC_ADDR_2E36_ado_dc_3_q_7_0_shift                                     (0)
#define  ATSC_ADDR_2E36_ado_dc_3_q_7_0_mask                                      (0x000000FF)
#define  ATSC_ADDR_2E36_ado_dc_3_q_7_0(data)                                     (0x000000FF&(data))
#define  ATSC_ADDR_2E36_get_ado_dc_3_q_7_0(data)                                 (0x000000FF&(data))

#define  ATSC_ADDR_2E37                                                         0x181578DC
#define  ATSC_ADDR_2E37_reg_addr                                                 "0xB81578DC"
#define  ATSC_ADDR_2E37_reg                                                      0xB81578DC
#define  ATSC_ADDR_2E37_inst_addr                                                "0x04C3"
#define  set_ATSC_ADDR_2E37_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E37_reg)=data)
#define  get_ATSC_ADDR_2E37_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E37_reg))
#define  ATSC_ADDR_2E37_ado_dc_3_q_im_3_0_shift                                  (4)
#define  ATSC_ADDR_2E37_ado_dc_3_q_11_8_shift                                    (0)
#define  ATSC_ADDR_2E37_ado_dc_3_q_im_3_0_mask                                   (0x000000F0)
#define  ATSC_ADDR_2E37_ado_dc_3_q_11_8_mask                                     (0x0000000F)
#define  ATSC_ADDR_2E37_ado_dc_3_q_im_3_0(data)                                  (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2E37_ado_dc_3_q_11_8(data)                                    (0x0000000F&(data))
#define  ATSC_ADDR_2E37_get_ado_dc_3_q_im_3_0(data)                              ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2E37_get_ado_dc_3_q_11_8(data)                                (0x0000000F&(data))

#define  ATSC_ADDR_2E38                                                         0x181578E0
#define  ATSC_ADDR_2E38_reg_addr                                                 "0xB81578E0"
#define  ATSC_ADDR_2E38_reg                                                      0xB81578E0
#define  ATSC_ADDR_2E38_inst_addr                                                "0x04C4"
#define  set_ATSC_ADDR_2E38_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E38_reg)=data)
#define  get_ATSC_ADDR_2E38_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E38_reg))
#define  ATSC_ADDR_2E38_ado_dc_3_q_im_11_4_shift                                 (0)
#define  ATSC_ADDR_2E38_ado_dc_3_q_im_11_4_mask                                  (0x000000FF)
#define  ATSC_ADDR_2E38_ado_dc_3_q_im_11_4(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2E38_get_ado_dc_3_q_im_11_4(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2E39                                                         0x181578E4
#define  ATSC_ADDR_2E39_reg_addr                                                 "0xB81578E4"
#define  ATSC_ADDR_2E39_reg                                                      0xB81578E4
#define  ATSC_ADDR_2E39_inst_addr                                                "0x04C5"
#define  set_ATSC_ADDR_2E39_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E39_reg)=data)
#define  get_ATSC_ADDR_2E39_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E39_reg))
#define  ATSC_ADDR_2E39_fe_iqamp_q_7_0_shift                                     (0)
#define  ATSC_ADDR_2E39_fe_iqamp_q_7_0_mask                                      (0x000000FF)
#define  ATSC_ADDR_2E39_fe_iqamp_q_7_0(data)                                     (0x000000FF&(data))
#define  ATSC_ADDR_2E39_get_fe_iqamp_q_7_0(data)                                 (0x000000FF&(data))

#define  ATSC_ADDR_2E3A                                                         0x181578E8
#define  ATSC_ADDR_2E3A_reg_addr                                                 "0xB81578E8"
#define  ATSC_ADDR_2E3A_reg                                                      0xB81578E8
#define  ATSC_ADDR_2E3A_inst_addr                                                "0x04C6"
#define  set_ATSC_ADDR_2E3A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E3A_reg)=data)
#define  get_ATSC_ADDR_2E3A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E3A_reg))
#define  ATSC_ADDR_2E3A_fe_iqph_q_5_0_shift                                      (2)
#define  ATSC_ADDR_2E3A_fe_iqamp_q_9_8_shift                                     (0)
#define  ATSC_ADDR_2E3A_fe_iqph_q_5_0_mask                                       (0x000000FC)
#define  ATSC_ADDR_2E3A_fe_iqamp_q_9_8_mask                                      (0x00000003)
#define  ATSC_ADDR_2E3A_fe_iqph_q_5_0(data)                                      (0x000000FC&((data)<<2))
#define  ATSC_ADDR_2E3A_fe_iqamp_q_9_8(data)                                     (0x00000003&(data))
#define  ATSC_ADDR_2E3A_get_fe_iqph_q_5_0(data)                                  ((0x000000FC&(data))>>2)
#define  ATSC_ADDR_2E3A_get_fe_iqamp_q_9_8(data)                                 (0x00000003&(data))

#define  ATSC_ADDR_2E3B                                                         0x181578EC
#define  ATSC_ADDR_2E3B_reg_addr                                                 "0xB81578EC"
#define  ATSC_ADDR_2E3B_reg                                                      0xB81578EC
#define  ATSC_ADDR_2E3B_inst_addr                                                "0x04C7"
#define  set_ATSC_ADDR_2E3B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2E3B_reg)=data)
#define  get_ATSC_ADDR_2E3B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2E3B_reg))
#define  ATSC_ADDR_2E3B_fe_iqph_q_9_6_shift                                      (0)
#define  ATSC_ADDR_2E3B_fe_iqph_q_9_6_mask                                       (0x0000000F)
#define  ATSC_ADDR_2E3B_fe_iqph_q_9_6(data)                                      (0x0000000F&(data))
#define  ATSC_ADDR_2E3B_get_fe_iqph_q_9_6(data)                                  (0x0000000F&(data))

#define  ATSC_ADDR_2F01                                                         0x18157C04
#define  ATSC_ADDR_2F01_reg_addr                                                 "0xB8157C04"
#define  ATSC_ADDR_2F01_reg                                                      0xB8157C04
#define  ATSC_ADDR_2F01_inst_addr                                                "0x04C8"
#define  set_ATSC_ADDR_2F01_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F01_reg)=data)
#define  get_ATSC_ADDR_2F01_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F01_reg))
#define  ATSC_ADDR_2F01_strobe_shift                                             (0)
#define  ATSC_ADDR_2F01_strobe_mask                                              (0x00000001)
#define  ATSC_ADDR_2F01_strobe(data)                                             (0x00000001&(data))
#define  ATSC_ADDR_2F01_get_strobe(data)                                         (0x00000001&(data))

#define  ATSC_ADDR_2F02                                                         0x18157C08
#define  ATSC_ADDR_2F02_reg_addr                                                 "0xB8157C08"
#define  ATSC_ADDR_2F02_reg                                                      0xB8157C08
#define  ATSC_ADDR_2F02_inst_addr                                                "0x04C9"
#define  set_ATSC_ADDR_2F02_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F02_reg)=data)
#define  get_ATSC_ADDR_2F02_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F02_reg))
#define  ATSC_ADDR_2F02_acc_rf3_7_0_shift                                        (0)
#define  ATSC_ADDR_2F02_acc_rf3_7_0_mask                                         (0x000000FF)
#define  ATSC_ADDR_2F02_acc_rf3_7_0(data)                                        (0x000000FF&(data))
#define  ATSC_ADDR_2F02_get_acc_rf3_7_0(data)                                    (0x000000FF&(data))

#define  ATSC_ADDR_2F03                                                         0x18157C0C
#define  ATSC_ADDR_2F03_reg_addr                                                 "0xB8157C0C"
#define  ATSC_ADDR_2F03_reg                                                      0xB8157C0C
#define  ATSC_ADDR_2F03_inst_addr                                                "0x04CA"
#define  set_ATSC_ADDR_2F03_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F03_reg)=data)
#define  get_ATSC_ADDR_2F03_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F03_reg))
#define  ATSC_ADDR_2F03_acc_rf3_13_8_shift                                       (0)
#define  ATSC_ADDR_2F03_acc_rf3_13_8_mask                                        (0x0000003F)
#define  ATSC_ADDR_2F03_acc_rf3_13_8(data)                                       (0x0000003F&(data))
#define  ATSC_ADDR_2F03_get_acc_rf3_13_8(data)                                   (0x0000003F&(data))

#define  ATSC_ADDR_2F04                                                         0x18157C10
#define  ATSC_ADDR_2F04_reg_addr                                                 "0xB8157C10"
#define  ATSC_ADDR_2F04_reg                                                      0xB8157C10
#define  ATSC_ADDR_2F04_inst_addr                                                "0x04CB"
#define  set_ATSC_ADDR_2F04_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F04_reg)=data)
#define  get_ATSC_ADDR_2F04_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F04_reg))
#define  ATSC_ADDR_2F04_acc_if3_7_0_shift                                        (0)
#define  ATSC_ADDR_2F04_acc_if3_7_0_mask                                         (0x000000FF)
#define  ATSC_ADDR_2F04_acc_if3_7_0(data)                                        (0x000000FF&(data))
#define  ATSC_ADDR_2F04_get_acc_if3_7_0(data)                                    (0x000000FF&(data))

#define  ATSC_ADDR_2F05                                                         0x18157C14
#define  ATSC_ADDR_2F05_reg_addr                                                 "0xB8157C14"
#define  ATSC_ADDR_2F05_reg                                                      0xB8157C14
#define  ATSC_ADDR_2F05_inst_addr                                                "0x04CC"
#define  set_ATSC_ADDR_2F05_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F05_reg)=data)
#define  get_ATSC_ADDR_2F05_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F05_reg))
#define  ATSC_ADDR_2F05_acc_if3_13_8_shift                                       (0)
#define  ATSC_ADDR_2F05_acc_if3_13_8_mask                                        (0x0000003F)
#define  ATSC_ADDR_2F05_acc_if3_13_8(data)                                       (0x0000003F&(data))
#define  ATSC_ADDR_2F05_get_acc_if3_13_8(data)                                   (0x0000003F&(data))

#define  ATSC_ADDR_2F06                                                         0x18157C18
#define  ATSC_ADDR_2F06_reg_addr                                                 "0xB8157C18"
#define  ATSC_ADDR_2F06_reg                                                      0xB8157C18
#define  ATSC_ADDR_2F06_inst_addr                                                "0x04CD"
#define  set_ATSC_ADDR_2F06_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F06_reg)=data)
#define  get_ATSC_ADDR_2F06_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F06_reg))
#define  ATSC_ADDR_2F06_fsm_scan_unlock_ind_shift                                (1)
#define  ATSC_ADDR_2F06_fsm_scan_lock_ind_shift                                  (0)
#define  ATSC_ADDR_2F06_fsm_scan_unlock_ind_mask                                 (0x00000002)
#define  ATSC_ADDR_2F06_fsm_scan_lock_ind_mask                                   (0x00000001)
#define  ATSC_ADDR_2F06_fsm_scan_unlock_ind(data)                                (0x00000002&((data)<<1))
#define  ATSC_ADDR_2F06_fsm_scan_lock_ind(data)                                  (0x00000001&(data))
#define  ATSC_ADDR_2F06_get_fsm_scan_unlock_ind(data)                            ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2F06_get_fsm_scan_lock_ind(data)                              (0x00000001&(data))

#define  ATSC_ADDR_2F07                                                         0x18157C1C
#define  ATSC_ADDR_2F07_reg_addr                                                 "0xB8157C1C"
#define  ATSC_ADDR_2F07_reg                                                      0xB8157C1C
#define  ATSC_ADDR_2F07_inst_addr                                                "0x04CE"
#define  set_ATSC_ADDR_2F07_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F07_reg)=data)
#define  get_ATSC_ADDR_2F07_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F07_reg))
#define  ATSC_ADDR_2F07_converge_cnt_7_0_shift                                   (0)
#define  ATSC_ADDR_2F07_converge_cnt_7_0_mask                                    (0x000000FF)
#define  ATSC_ADDR_2F07_converge_cnt_7_0(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_2F07_get_converge_cnt_7_0(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_2F08                                                         0x18157C20
#define  ATSC_ADDR_2F08_reg_addr                                                 "0xB8157C20"
#define  ATSC_ADDR_2F08_reg                                                      0xB8157C20
#define  ATSC_ADDR_2F08_inst_addr                                                "0x04CF"
#define  set_ATSC_ADDR_2F08_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F08_reg)=data)
#define  get_ATSC_ADDR_2F08_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F08_reg))
#define  ATSC_ADDR_2F08_converge_cnt_15_8_shift                                  (0)
#define  ATSC_ADDR_2F08_converge_cnt_15_8_mask                                   (0x000000FF)
#define  ATSC_ADDR_2F08_converge_cnt_15_8(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2F08_get_converge_cnt_15_8(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2F09                                                         0x18157C24
#define  ATSC_ADDR_2F09_reg_addr                                                 "0xB8157C24"
#define  ATSC_ADDR_2F09_reg                                                      0xB8157C24
#define  ATSC_ADDR_2F09_inst_addr                                                "0x04D0"
#define  set_ATSC_ADDR_2F09_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F09_reg)=data)
#define  get_ATSC_ADDR_2F09_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F09_reg))
#define  ATSC_ADDR_2F09_current_state_shift                                      (2)
#define  ATSC_ADDR_2F09_fsm_final_flag_shift                                     (1)
#define  ATSC_ADDR_2F09_fsm_final_flag_hold_shift                                (0)
#define  ATSC_ADDR_2F09_current_state_mask                                       (0x000000FC)
#define  ATSC_ADDR_2F09_fsm_final_flag_mask                                      (0x00000002)
#define  ATSC_ADDR_2F09_fsm_final_flag_hold_mask                                 (0x00000001)
#define  ATSC_ADDR_2F09_current_state(data)                                      (0x000000FC&((data)<<2))
#define  ATSC_ADDR_2F09_fsm_final_flag(data)                                     (0x00000002&((data)<<1))
#define  ATSC_ADDR_2F09_fsm_final_flag_hold(data)                                (0x00000001&(data))
#define  ATSC_ADDR_2F09_get_current_state(data)                                  ((0x000000FC&(data))>>2)
#define  ATSC_ADDR_2F09_get_fsm_final_flag(data)                                 ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2F09_get_fsm_final_flag_hold(data)                            (0x00000001&(data))

#define  ATSC_ADDR_2F0A                                                         0x18157C28
#define  ATSC_ADDR_2F0A_reg_addr                                                 "0xB8157C28"
#define  ATSC_ADDR_2F0A_reg                                                      0xB8157C28
#define  ATSC_ADDR_2F0A_inst_addr                                                "0x04D1"
#define  set_ATSC_ADDR_2F0A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F0A_reg)=data)
#define  get_ATSC_ADDR_2F0A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F0A_reg))
#define  ATSC_ADDR_2F0A_aagc_lock_shift                                          (7)
#define  ATSC_ADDR_2F0A_adj_ind_shift                                            (6)
#define  ATSC_ADDR_2F0A_tr_lock_ind_shift                                        (2)
#define  ATSC_ADDR_2F0A_aagc_lock_mask                                           (0x00000080)
#define  ATSC_ADDR_2F0A_adj_ind_mask                                             (0x00000040)
#define  ATSC_ADDR_2F0A_tr_lock_ind_mask                                         (0x00000004)
#define  ATSC_ADDR_2F0A_aagc_lock(data)                                          (0x00000080&((data)<<7))
#define  ATSC_ADDR_2F0A_adj_ind(data)                                            (0x00000040&((data)<<6))
#define  ATSC_ADDR_2F0A_tr_lock_ind(data)                                        (0x00000004&((data)<<2))
#define  ATSC_ADDR_2F0A_get_aagc_lock(data)                                      ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2F0A_get_adj_ind(data)                                        ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2F0A_get_tr_lock_ind(data)                                    ((0x00000004&(data))>>2)

#define  ATSC_ADDR_2F0B                                                         0x18157C2C
#define  ATSC_ADDR_2F0B_reg_addr                                                 "0xB8157C2C"
#define  ATSC_ADDR_2F0B_reg                                                      0xB8157C2C
#define  ATSC_ADDR_2F0B_inst_addr                                                "0x04D2"
#define  set_ATSC_ADDR_2F0B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F0B_reg)=data)
#define  get_ATSC_ADDR_2F0B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F0B_reg))
#define  ATSC_ADDR_2F0B_tr_fs_lock_ind_shift                                     (7)
#define  ATSC_ADDR_2F0B_tr_fs_lost_d_shift                                       (6)
#define  ATSC_ADDR_2F0B_tr_fs_trk_ind_d_shift                                    (5)
#define  ATSC_ADDR_2F0B_tr_fs_loc2_eq_loc3_shift                                 (4)
#define  ATSC_ADDR_2F0B_tr_fs_loc2_lead_loc3_1_shift                             (3)
#define  ATSC_ADDR_2F0B_tr_fs_loc2_lag_loc3_1_shift                              (2)
#define  ATSC_ADDR_2F0B_tr_fs_loc2_lead_loc3_n_shift                             (1)
#define  ATSC_ADDR_2F0B_tr_fs_loc2_lag_loc3_n_shift                              (0)
#define  ATSC_ADDR_2F0B_tr_fs_lock_ind_mask                                      (0x00000080)
#define  ATSC_ADDR_2F0B_tr_fs_lost_d_mask                                        (0x00000040)
#define  ATSC_ADDR_2F0B_tr_fs_trk_ind_d_mask                                     (0x00000020)
#define  ATSC_ADDR_2F0B_tr_fs_loc2_eq_loc3_mask                                  (0x00000010)
#define  ATSC_ADDR_2F0B_tr_fs_loc2_lead_loc3_1_mask                              (0x00000008)
#define  ATSC_ADDR_2F0B_tr_fs_loc2_lag_loc3_1_mask                               (0x00000004)
#define  ATSC_ADDR_2F0B_tr_fs_loc2_lead_loc3_n_mask                              (0x00000002)
#define  ATSC_ADDR_2F0B_tr_fs_loc2_lag_loc3_n_mask                               (0x00000001)
#define  ATSC_ADDR_2F0B_tr_fs_lock_ind(data)                                     (0x00000080&((data)<<7))
#define  ATSC_ADDR_2F0B_tr_fs_lost_d(data)                                       (0x00000040&((data)<<6))
#define  ATSC_ADDR_2F0B_tr_fs_trk_ind_d(data)                                    (0x00000020&((data)<<5))
#define  ATSC_ADDR_2F0B_tr_fs_loc2_eq_loc3(data)                                 (0x00000010&((data)<<4))
#define  ATSC_ADDR_2F0B_tr_fs_loc2_lead_loc3_1(data)                             (0x00000008&((data)<<3))
#define  ATSC_ADDR_2F0B_tr_fs_loc2_lag_loc3_1(data)                              (0x00000004&((data)<<2))
#define  ATSC_ADDR_2F0B_tr_fs_loc2_lead_loc3_n(data)                             (0x00000002&((data)<<1))
#define  ATSC_ADDR_2F0B_tr_fs_loc2_lag_loc3_n(data)                              (0x00000001&(data))
#define  ATSC_ADDR_2F0B_get_tr_fs_lock_ind(data)                                 ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2F0B_get_tr_fs_lost_d(data)                                   ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2F0B_get_tr_fs_trk_ind_d(data)                                ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2F0B_get_tr_fs_loc2_eq_loc3(data)                             ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2F0B_get_tr_fs_loc2_lead_loc3_1(data)                         ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2F0B_get_tr_fs_loc2_lag_loc3_1(data)                          ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2F0B_get_tr_fs_loc2_lead_loc3_n(data)                         ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2F0B_get_tr_fs_loc2_lag_loc3_n(data)                          (0x00000001&(data))

#define  ATSC_ADDR_2F0C                                                         0x18157C30
#define  ATSC_ADDR_2F0C_reg_addr                                                 "0xB8157C30"
#define  ATSC_ADDR_2F0C_reg                                                      0xB8157C30
#define  ATSC_ADDR_2F0C_inst_addr                                                "0x04D3"
#define  set_ATSC_ADDR_2F0C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F0C_reg)=data)
#define  get_ATSC_ADDR_2F0C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F0C_reg))
#define  ATSC_ADDR_2F0C_acc3_7_0_shift                                           (0)
#define  ATSC_ADDR_2F0C_acc3_7_0_mask                                            (0x000000FF)
#define  ATSC_ADDR_2F0C_acc3_7_0(data)                                           (0x000000FF&(data))
#define  ATSC_ADDR_2F0C_get_acc3_7_0(data)                                       (0x000000FF&(data))

#define  ATSC_ADDR_2F0D                                                         0x18157C34
#define  ATSC_ADDR_2F0D_reg_addr                                                 "0xB8157C34"
#define  ATSC_ADDR_2F0D_reg                                                      0xB8157C34
#define  ATSC_ADDR_2F0D_inst_addr                                                "0x04D4"
#define  set_ATSC_ADDR_2F0D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F0D_reg)=data)
#define  get_ATSC_ADDR_2F0D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F0D_reg))
#define  ATSC_ADDR_2F0D_agc_max_sat_flag_shift                                   (6)
#define  ATSC_ADDR_2F0D_acc3_13_8_shift                                          (0)
#define  ATSC_ADDR_2F0D_agc_max_sat_flag_mask                                    (0x00000040)
#define  ATSC_ADDR_2F0D_acc3_13_8_mask                                           (0x0000003F)
#define  ATSC_ADDR_2F0D_agc_max_sat_flag(data)                                   (0x00000040&((data)<<6))
#define  ATSC_ADDR_2F0D_acc3_13_8(data)                                          (0x0000003F&(data))
#define  ATSC_ADDR_2F0D_get_agc_max_sat_flag(data)                               ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2F0D_get_acc3_13_8(data)                                      (0x0000003F&(data))

#define  ATSC_ADDR_2F0E                                                         0x18157C38
#define  ATSC_ADDR_2F0E_reg_addr                                                 "0xB8157C38"
#define  ATSC_ADDR_2F0E_reg                                                      0xB8157C38
#define  ATSC_ADDR_2F0E_inst_addr                                                "0x04D5"
#define  set_ATSC_ADDR_2F0E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F0E_reg)=data)
#define  get_ATSC_ADDR_2F0E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F0E_reg))
#define  ATSC_ADDR_2F0E_dagc_level_q_7_0_shift                                   (0)
#define  ATSC_ADDR_2F0E_dagc_level_q_7_0_mask                                    (0x000000FF)
#define  ATSC_ADDR_2F0E_dagc_level_q_7_0(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_2F0E_get_dagc_level_q_7_0(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_2F0F                                                         0x18157C3C
#define  ATSC_ADDR_2F0F_reg_addr                                                 "0xB8157C3C"
#define  ATSC_ADDR_2F0F_reg                                                      0xB8157C3C
#define  ATSC_ADDR_2F0F_inst_addr                                                "0x04D6"
#define  set_ATSC_ADDR_2F0F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F0F_reg)=data)
#define  get_ATSC_ADDR_2F0F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F0F_reg))
#define  ATSC_ADDR_2F0F_dagc_level_q_12_8_shift                                  (0)
#define  ATSC_ADDR_2F0F_dagc_level_q_12_8_mask                                   (0x0000001F)
#define  ATSC_ADDR_2F0F_dagc_level_q_12_8(data)                                  (0x0000001F&(data))
#define  ATSC_ADDR_2F0F_get_dagc_level_q_12_8(data)                              (0x0000001F&(data))

#define  ATSC_ADDR_2F10                                                         0x18157C40
#define  ATSC_ADDR_2F10_reg_addr                                                 "0xB8157C40"
#define  ATSC_ADDR_2F10_reg                                                      0xB8157C40
#define  ATSC_ADDR_2F10_inst_addr                                                "0x04D7"
#define  set_ATSC_ADDR_2F10_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F10_reg)=data)
#define  get_ATSC_ADDR_2F10_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F10_reg))
#define  ATSC_ADDR_2F10_adc_out_7_0_shift                                        (0)
#define  ATSC_ADDR_2F10_adc_out_7_0_mask                                         (0x000000FF)
#define  ATSC_ADDR_2F10_adc_out_7_0(data)                                        (0x000000FF&(data))
#define  ATSC_ADDR_2F10_get_adc_out_7_0(data)                                    (0x000000FF&(data))

#define  ATSC_ADDR_2F11                                                         0x18157C44
#define  ATSC_ADDR_2F11_reg_addr                                                 "0xB8157C44"
#define  ATSC_ADDR_2F11_reg                                                      0xB8157C44
#define  ATSC_ADDR_2F11_inst_addr                                                "0x04D8"
#define  set_ATSC_ADDR_2F11_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F11_reg)=data)
#define  get_ATSC_ADDR_2F11_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F11_reg))
#define  ATSC_ADDR_2F11_adc_out_11_8_shift                                       (0)
#define  ATSC_ADDR_2F11_adc_out_11_8_mask                                        (0x0000000F)
#define  ATSC_ADDR_2F11_adc_out_11_8(data)                                       (0x0000000F&(data))
#define  ATSC_ADDR_2F11_get_adc_out_11_8(data)                                   (0x0000000F&(data))

#define  ATSC_ADDR_2F12                                                         0x18157C48
#define  ATSC_ADDR_2F12_reg_addr                                                 "0xB8157C48"
#define  ATSC_ADDR_2F12_reg                                                      0xB8157C48
#define  ATSC_ADDR_2F12_inst_addr                                                "0x04D9"
#define  set_ATSC_ADDR_2F12_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F12_reg)=data)
#define  get_ATSC_ADDR_2F12_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F12_reg))
#define  ATSC_ADDR_2F12_timing_offset_d_q_7_0_shift                              (0)
#define  ATSC_ADDR_2F12_timing_offset_d_q_7_0_mask                               (0x000000FF)
#define  ATSC_ADDR_2F12_timing_offset_d_q_7_0(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_2F12_get_timing_offset_d_q_7_0(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_2F13                                                         0x18157C4C
#define  ATSC_ADDR_2F13_reg_addr                                                 "0xB8157C4C"
#define  ATSC_ADDR_2F13_reg                                                      0xB8157C4C
#define  ATSC_ADDR_2F13_inst_addr                                                "0x04DA"
#define  set_ATSC_ADDR_2F13_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F13_reg)=data)
#define  get_ATSC_ADDR_2F13_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F13_reg))
#define  ATSC_ADDR_2F13_timing_offset_d_q_15_8_shift                             (0)
#define  ATSC_ADDR_2F13_timing_offset_d_q_15_8_mask                              (0x000000FF)
#define  ATSC_ADDR_2F13_timing_offset_d_q_15_8(data)                             (0x000000FF&(data))
#define  ATSC_ADDR_2F13_get_timing_offset_d_q_15_8(data)                         (0x000000FF&(data))

#define  ATSC_ADDR_2F14                                                         0x18157C50
#define  ATSC_ADDR_2F14_reg_addr                                                 "0xB8157C50"
#define  ATSC_ADDR_2F14_reg                                                      0xB8157C50
#define  ATSC_ADDR_2F14_inst_addr                                                "0x04DB"
#define  set_ATSC_ADDR_2F14_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F14_reg)=data)
#define  get_ATSC_ADDR_2F14_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F14_reg))
#define  ATSC_ADDR_2F14_tr_fs_acc_cnt_7_0_shift                                  (0)
#define  ATSC_ADDR_2F14_tr_fs_acc_cnt_7_0_mask                                   (0x000000FF)
#define  ATSC_ADDR_2F14_tr_fs_acc_cnt_7_0(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2F14_get_tr_fs_acc_cnt_7_0(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2F15                                                         0x18157C54
#define  ATSC_ADDR_2F15_reg_addr                                                 "0xB8157C54"
#define  ATSC_ADDR_2F15_reg                                                      0xB8157C54
#define  ATSC_ADDR_2F15_inst_addr                                                "0x04DC"
#define  set_ATSC_ADDR_2F15_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F15_reg)=data)
#define  get_ATSC_ADDR_2F15_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F15_reg))
#define  ATSC_ADDR_2F15_tr_fs_acc_cnt_14_8_shift                                 (0)
#define  ATSC_ADDR_2F15_tr_fs_acc_cnt_14_8_mask                                  (0x0000007F)
#define  ATSC_ADDR_2F15_tr_fs_acc_cnt_14_8(data)                                 (0x0000007F&(data))
#define  ATSC_ADDR_2F15_get_tr_fs_acc_cnt_14_8(data)                             (0x0000007F&(data))

#define  ATSC_ADDR_2F16                                                         0x18157C58
#define  ATSC_ADDR_2F16_reg_addr                                                 "0xB8157C58"
#define  ATSC_ADDR_2F16_reg                                                      0xB8157C58
#define  ATSC_ADDR_2F16_inst_addr                                                "0x04DD"
#define  set_ATSC_ADDR_2F16_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F16_reg)=data)
#define  get_ATSC_ADDR_2F16_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F16_reg))
#define  ATSC_ADDR_2F16_tr_fs_lock_diff_acc_7_0_shift                            (0)
#define  ATSC_ADDR_2F16_tr_fs_lock_diff_acc_7_0_mask                             (0x000000FF)
#define  ATSC_ADDR_2F16_tr_fs_lock_diff_acc_7_0(data)                            (0x000000FF&(data))
#define  ATSC_ADDR_2F16_get_tr_fs_lock_diff_acc_7_0(data)                        (0x000000FF&(data))

#define  ATSC_ADDR_2F17                                                         0x18157C5C
#define  ATSC_ADDR_2F17_reg_addr                                                 "0xB8157C5C"
#define  ATSC_ADDR_2F17_reg                                                      0xB8157C5C
#define  ATSC_ADDR_2F17_inst_addr                                                "0x04DE"
#define  set_ATSC_ADDR_2F17_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F17_reg)=data)
#define  get_ATSC_ADDR_2F17_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F17_reg))
#define  ATSC_ADDR_2F17_tr_fs_lock_diff_acc_15_8_shift                           (0)
#define  ATSC_ADDR_2F17_tr_fs_lock_diff_acc_15_8_mask                            (0x000000FF)
#define  ATSC_ADDR_2F17_tr_fs_lock_diff_acc_15_8(data)                           (0x000000FF&(data))
#define  ATSC_ADDR_2F17_get_tr_fs_lock_diff_acc_15_8(data)                       (0x000000FF&(data))

#define  ATSC_ADDR_2F18                                                         0x18157C60
#define  ATSC_ADDR_2F18_reg_addr                                                 "0xB8157C60"
#define  ATSC_ADDR_2F18_reg                                                      0xB8157C60
#define  ATSC_ADDR_2F18_inst_addr                                                "0x04DF"
#define  set_ATSC_ADDR_2F18_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F18_reg)=data)
#define  get_ATSC_ADDR_2F18_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F18_reg))
#define  ATSC_ADDR_2F18_tr_fs_lock_diff_acc_23_16_shift                          (0)
#define  ATSC_ADDR_2F18_tr_fs_lock_diff_acc_23_16_mask                           (0x000000FF)
#define  ATSC_ADDR_2F18_tr_fs_lock_diff_acc_23_16(data)                          (0x000000FF&(data))
#define  ATSC_ADDR_2F18_get_tr_fs_lock_diff_acc_23_16(data)                      (0x000000FF&(data))

#define  ATSC_ADDR_2F19                                                         0x18157C64
#define  ATSC_ADDR_2F19_reg_addr                                                 "0xB8157C64"
#define  ATSC_ADDR_2F19_reg                                                      0xB8157C64
#define  ATSC_ADDR_2F19_inst_addr                                                "0x04E0"
#define  set_ATSC_ADDR_2F19_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F19_reg)=data)
#define  get_ATSC_ADDR_2F19_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F19_reg))
#define  ATSC_ADDR_2F19_tr_fs_lock_diff_acc_24_shift                             (0)
#define  ATSC_ADDR_2F19_tr_fs_lock_diff_acc_24_mask                              (0x00000001)
#define  ATSC_ADDR_2F19_tr_fs_lock_diff_acc_24(data)                             (0x00000001&(data))
#define  ATSC_ADDR_2F19_get_tr_fs_lock_diff_acc_24(data)                         (0x00000001&(data))

#define  ATSC_ADDR_2F1A                                                         0x18157C68
#define  ATSC_ADDR_2F1A_reg_addr                                                 "0xB8157C68"
#define  ATSC_ADDR_2F1A_reg                                                      0xB8157C68
#define  ATSC_ADDR_2F1A_inst_addr                                                "0x04E1"
#define  set_ATSC_ADDR_2F1A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F1A_reg)=data)
#define  get_ATSC_ADDR_2F1A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F1A_reg))
#define  ATSC_ADDR_2F1A_cond_7_0_shift                                           (0)
#define  ATSC_ADDR_2F1A_cond_7_0_mask                                            (0x000000FF)
#define  ATSC_ADDR_2F1A_cond_7_0(data)                                           (0x000000FF&(data))
#define  ATSC_ADDR_2F1A_get_cond_7_0(data)                                       (0x000000FF&(data))

#define  ATSC_ADDR_2F1B                                                         0x18157C6C
#define  ATSC_ADDR_2F1B_reg_addr                                                 "0xB8157C6C"
#define  ATSC_ADDR_2F1B_reg                                                      0xB8157C6C
#define  ATSC_ADDR_2F1B_inst_addr                                                "0x04E2"
#define  set_ATSC_ADDR_2F1B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F1B_reg)=data)
#define  get_ATSC_ADDR_2F1B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F1B_reg))
#define  ATSC_ADDR_2F1B_cond_15_8_shift                                          (0)
#define  ATSC_ADDR_2F1B_cond_15_8_mask                                           (0x000000FF)
#define  ATSC_ADDR_2F1B_cond_15_8(data)                                          (0x000000FF&(data))
#define  ATSC_ADDR_2F1B_get_cond_15_8(data)                                      (0x000000FF&(data))

#define  ATSC_ADDR_2F1C                                                         0x18157C70
#define  ATSC_ADDR_2F1C_reg_addr                                                 "0xB8157C70"
#define  ATSC_ADDR_2F1C_reg                                                      0xB8157C70
#define  ATSC_ADDR_2F1C_inst_addr                                                "0x04E3"
#define  set_ATSC_ADDR_2F1C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F1C_reg)=data)
#define  get_ATSC_ADDR_2F1C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F1C_reg))
#define  ATSC_ADDR_2F1C_cond_23_16_shift                                         (0)
#define  ATSC_ADDR_2F1C_cond_23_16_mask                                          (0x000000FF)
#define  ATSC_ADDR_2F1C_cond_23_16(data)                                         (0x000000FF&(data))
#define  ATSC_ADDR_2F1C_get_cond_23_16(data)                                     (0x000000FF&(data))

#define  ATSC_ADDR_2F1D                                                         0x18157C74
#define  ATSC_ADDR_2F1D_reg_addr                                                 "0xB8157C74"
#define  ATSC_ADDR_2F1D_reg                                                      0xB8157C74
#define  ATSC_ADDR_2F1D_inst_addr                                                "0x04E4"
#define  set_ATSC_ADDR_2F1D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F1D_reg)=data)
#define  get_ATSC_ADDR_2F1D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F1D_reg))
#define  ATSC_ADDR_2F1D_cond_31_24_shift                                         (0)
#define  ATSC_ADDR_2F1D_cond_31_24_mask                                          (0x000000FF)
#define  ATSC_ADDR_2F1D_cond_31_24(data)                                         (0x000000FF&(data))
#define  ATSC_ADDR_2F1D_get_cond_31_24(data)                                     (0x000000FF&(data))

#define  ATSC_ADDR_2F1E                                                         0x18157C78
#define  ATSC_ADDR_2F1E_reg_addr                                                 "0xB8157C78"
#define  ATSC_ADDR_2F1E_reg                                                      0xB8157C78
#define  ATSC_ADDR_2F1E_inst_addr                                                "0x04E5"
#define  set_ATSC_ADDR_2F1E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F1E_reg)=data)
#define  get_ATSC_ADDR_2F1E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F1E_reg))
#define  ATSC_ADDR_2F1E_adc_clip_cnt_shift                                       (0)
#define  ATSC_ADDR_2F1E_adc_clip_cnt_mask                                        (0x000000FF)
#define  ATSC_ADDR_2F1E_adc_clip_cnt(data)                                       (0x000000FF&(data))
#define  ATSC_ADDR_2F1E_get_adc_clip_cnt(data)                                   (0x000000FF&(data))

#define  ATSC_ADDR_2F1F                                                         0x18157C7C
#define  ATSC_ADDR_2F1F_reg_addr                                                 "0xB8157C7C"
#define  ATSC_ADDR_2F1F_reg                                                      0xB8157C7C
#define  ATSC_ADDR_2F1F_inst_addr                                                "0x04E6"
#define  set_ATSC_ADDR_2F1F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F1F_reg)=data)
#define  get_ATSC_ADDR_2F1F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F1F_reg))
#define  ATSC_ADDR_2F1F_agc_targ_val_tune_shift                                  (0)
#define  ATSC_ADDR_2F1F_agc_targ_val_tune_mask                                   (0x000000FF)
#define  ATSC_ADDR_2F1F_agc_targ_val_tune(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2F1F_get_agc_targ_val_tune(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2F20                                                         0x18157C80
#define  ATSC_ADDR_2F20_reg_addr                                                 "0xB8157C80"
#define  ATSC_ADDR_2F20_reg                                                      0xB8157C80
#define  ATSC_ADDR_2F20_inst_addr                                                "0x04E7"
#define  set_ATSC_ADDR_2F20_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F20_reg)=data)
#define  get_ATSC_ADDR_2F20_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F20_reg))
#define  ATSC_ADDR_2F20_agc_tune_wait_cnt_shift                                  (0)
#define  ATSC_ADDR_2F20_agc_tune_wait_cnt_mask                                   (0x000000FF)
#define  ATSC_ADDR_2F20_agc_tune_wait_cnt(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2F20_get_agc_tune_wait_cnt(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2F21                                                         0x18157C84
#define  ATSC_ADDR_2F21_reg_addr                                                 "0xB8157C84"
#define  ATSC_ADDR_2F21_reg                                                      0xB8157C84
#define  ATSC_ADDR_2F21_inst_addr                                                "0x04E8"
#define  set_ATSC_ADDR_2F21_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F21_reg)=data)
#define  get_ATSC_ADDR_2F21_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F21_reg))
#define  ATSC_ADDR_2F21_eqpt_eq_out_mse_est_7_0_shift                            (0)
#define  ATSC_ADDR_2F21_eqpt_eq_out_mse_est_7_0_mask                             (0x000000FF)
#define  ATSC_ADDR_2F21_eqpt_eq_out_mse_est_7_0(data)                            (0x000000FF&(data))
#define  ATSC_ADDR_2F21_get_eqpt_eq_out_mse_est_7_0(data)                        (0x000000FF&(data))

#define  ATSC_ADDR_2F22                                                         0x18157C88
#define  ATSC_ADDR_2F22_reg_addr                                                 "0xB8157C88"
#define  ATSC_ADDR_2F22_reg                                                      0xB8157C88
#define  ATSC_ADDR_2F22_inst_addr                                                "0x04E9"
#define  set_ATSC_ADDR_2F22_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F22_reg)=data)
#define  get_ATSC_ADDR_2F22_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F22_reg))
#define  ATSC_ADDR_2F22_eqpt_eq_out_mse_est_15_8_shift                           (0)
#define  ATSC_ADDR_2F22_eqpt_eq_out_mse_est_15_8_mask                            (0x000000FF)
#define  ATSC_ADDR_2F22_eqpt_eq_out_mse_est_15_8(data)                           (0x000000FF&(data))
#define  ATSC_ADDR_2F22_get_eqpt_eq_out_mse_est_15_8(data)                       (0x000000FF&(data))

#define  ATSC_ADDR_2F23                                                         0x18157C8C
#define  ATSC_ADDR_2F23_reg_addr                                                 "0xB8157C8C"
#define  ATSC_ADDR_2F23_reg                                                      0xB8157C8C
#define  ATSC_ADDR_2F23_inst_addr                                                "0x04EA"
#define  set_ATSC_ADDR_2F23_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F23_reg)=data)
#define  get_ATSC_ADDR_2F23_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F23_reg))
#define  ATSC_ADDR_2F23_eqpt_eq_out_mse_est_21_16_shift                          (0)
#define  ATSC_ADDR_2F23_eqpt_eq_out_mse_est_21_16_mask                           (0x0000003F)
#define  ATSC_ADDR_2F23_eqpt_eq_out_mse_est_21_16(data)                          (0x0000003F&(data))
#define  ATSC_ADDR_2F23_get_eqpt_eq_out_mse_est_21_16(data)                      (0x0000003F&(data))

#define  ATSC_ADDR_2F24                                                         0x18157C90
#define  ATSC_ADDR_2F24_reg_addr                                                 "0xB8157C90"
#define  ATSC_ADDR_2F24_reg                                                      0xB8157C90
#define  ATSC_ADDR_2F24_inst_addr                                                "0x04EB"
#define  set_ATSC_ADDR_2F24_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F24_reg)=data)
#define  get_ATSC_ADDR_2F24_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F24_reg))
#define  ATSC_ADDR_2F24_mse_viterbi_7_0_shift                                    (0)
#define  ATSC_ADDR_2F24_mse_viterbi_7_0_mask                                     (0x000000FF)
#define  ATSC_ADDR_2F24_mse_viterbi_7_0(data)                                    (0x000000FF&(data))
#define  ATSC_ADDR_2F24_get_mse_viterbi_7_0(data)                                (0x000000FF&(data))

#define  ATSC_ADDR_2F25                                                         0x18157C94
#define  ATSC_ADDR_2F25_reg_addr                                                 "0xB8157C94"
#define  ATSC_ADDR_2F25_reg                                                      0xB8157C94
#define  ATSC_ADDR_2F25_inst_addr                                                "0x04EC"
#define  set_ATSC_ADDR_2F25_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F25_reg)=data)
#define  get_ATSC_ADDR_2F25_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F25_reg))
#define  ATSC_ADDR_2F25_mse_viterbi_15_8_shift                                   (0)
#define  ATSC_ADDR_2F25_mse_viterbi_15_8_mask                                    (0x000000FF)
#define  ATSC_ADDR_2F25_mse_viterbi_15_8(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_2F25_get_mse_viterbi_15_8(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_2F26                                                         0x18157C98
#define  ATSC_ADDR_2F26_reg_addr                                                 "0xB8157C98"
#define  ATSC_ADDR_2F26_reg                                                      0xB8157C98
#define  ATSC_ADDR_2F26_inst_addr                                                "0x04ED"
#define  set_ATSC_ADDR_2F26_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F26_reg)=data)
#define  get_ATSC_ADDR_2F26_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F26_reg))
#define  ATSC_ADDR_2F26_mse_viterbi_23_16_shift                                  (0)
#define  ATSC_ADDR_2F26_mse_viterbi_23_16_mask                                   (0x000000FF)
#define  ATSC_ADDR_2F26_mse_viterbi_23_16(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2F26_get_mse_viterbi_23_16(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2F27                                                         0x18157C9C
#define  ATSC_ADDR_2F27_reg_addr                                                 "0xB8157C9C"
#define  ATSC_ADDR_2F27_reg                                                      0xB8157C9C
#define  ATSC_ADDR_2F27_inst_addr                                                "0x04EE"
#define  set_ATSC_ADDR_2F27_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F27_reg)=data)
#define  get_ATSC_ADDR_2F27_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F27_reg))
#define  ATSC_ADDR_2F27_mse_viterbi_31_24_shift                                  (0)
#define  ATSC_ADDR_2F27_mse_viterbi_31_24_mask                                   (0x000000FF)
#define  ATSC_ADDR_2F27_mse_viterbi_31_24(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2F27_get_mse_viterbi_31_24(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2F28                                                         0x18157CA0
#define  ATSC_ADDR_2F28_reg_addr                                                 "0xB8157CA0"
#define  ATSC_ADDR_2F28_reg                                                      0xB8157CA0
#define  ATSC_ADDR_2F28_inst_addr                                                "0x04EF"
#define  set_ATSC_ADDR_2F28_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F28_reg)=data)
#define  get_ATSC_ADDR_2F28_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F28_reg))
#define  ATSC_ADDR_2F28_mse_viterbi_33_32_shift                                  (0)
#define  ATSC_ADDR_2F28_mse_viterbi_33_32_mask                                   (0x00000003)
#define  ATSC_ADDR_2F28_mse_viterbi_33_32(data)                                  (0x00000003&(data))
#define  ATSC_ADDR_2F28_get_mse_viterbi_33_32(data)                              (0x00000003&(data))

#define  ATSC_ADDR_2F29                                                         0x18157CA4
#define  ATSC_ADDR_2F29_reg_addr                                                 "0xB8157CA4"
#define  ATSC_ADDR_2F29_reg                                                      0xB8157CA4
#define  ATSC_ADDR_2F29_inst_addr                                                "0x04F0"
#define  set_ATSC_ADDR_2F29_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F29_reg)=data)
#define  get_ATSC_ADDR_2F29_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F29_reg))
#define  ATSC_ADDR_2F29_bn_pred_wait_cnt_ovf_shift                               (7)
#define  ATSC_ADDR_2F29_bn_pred_cnt_ovf_shift                                    (6)
#define  ATSC_ADDR_2F29_bn_pred_flag_shift                                       (5)
#define  ATSC_ADDR_2F29_bn_aagc_stop_shift                                       (4)
#define  ATSC_ADDR_2F29_bn_dagc_stop_shift                                       (3)
#define  ATSC_ADDR_2F29_bn_eq_stop_shift                                         (2)
#define  ATSC_ADDR_2F29_eqpt_bn_det_flag_hold_shift                              (1)
#define  ATSC_ADDR_2F29_eqpt_bn_det_flag_shift                                   (0)
#define  ATSC_ADDR_2F29_bn_pred_wait_cnt_ovf_mask                                (0x00000080)
#define  ATSC_ADDR_2F29_bn_pred_cnt_ovf_mask                                     (0x00000040)
#define  ATSC_ADDR_2F29_bn_pred_flag_mask                                        (0x00000020)
#define  ATSC_ADDR_2F29_bn_aagc_stop_mask                                        (0x00000010)
#define  ATSC_ADDR_2F29_bn_dagc_stop_mask                                        (0x00000008)
#define  ATSC_ADDR_2F29_bn_eq_stop_mask                                          (0x00000004)
#define  ATSC_ADDR_2F29_eqpt_bn_det_flag_hold_mask                               (0x00000002)
#define  ATSC_ADDR_2F29_eqpt_bn_det_flag_mask                                    (0x00000001)
#define  ATSC_ADDR_2F29_bn_pred_wait_cnt_ovf(data)                               (0x00000080&((data)<<7))
#define  ATSC_ADDR_2F29_bn_pred_cnt_ovf(data)                                    (0x00000040&((data)<<6))
#define  ATSC_ADDR_2F29_bn_pred_flag(data)                                       (0x00000020&((data)<<5))
#define  ATSC_ADDR_2F29_bn_aagc_stop(data)                                       (0x00000010&((data)<<4))
#define  ATSC_ADDR_2F29_bn_dagc_stop(data)                                       (0x00000008&((data)<<3))
#define  ATSC_ADDR_2F29_bn_eq_stop(data)                                         (0x00000004&((data)<<2))
#define  ATSC_ADDR_2F29_eqpt_bn_det_flag_hold(data)                              (0x00000002&((data)<<1))
#define  ATSC_ADDR_2F29_eqpt_bn_det_flag(data)                                   (0x00000001&(data))
#define  ATSC_ADDR_2F29_get_bn_pred_wait_cnt_ovf(data)                           ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2F29_get_bn_pred_cnt_ovf(data)                                ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2F29_get_bn_pred_flag(data)                                   ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2F29_get_bn_aagc_stop(data)                                   ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2F29_get_bn_dagc_stop(data)                                   ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2F29_get_bn_eq_stop(data)                                     ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2F29_get_eqpt_bn_det_flag_hold(data)                          ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2F29_get_eqpt_bn_det_flag(data)                               (0x00000001&(data))

#define  ATSC_ADDR_2F2A                                                         0x18157CA8
#define  ATSC_ADDR_2F2A_reg_addr                                                 "0xB8157CA8"
#define  ATSC_ADDR_2F2A_reg                                                      0xB8157CA8
#define  ATSC_ADDR_2F2A_inst_addr                                                "0x04F1"
#define  set_ATSC_ADDR_2F2A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F2A_reg)=data)
#define  get_ATSC_ADDR_2F2A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F2A_reg))
#define  ATSC_ADDR_2F2A_adj_ind_bn_shift                                         (7)
#define  ATSC_ADDR_2F2A_eqpt_state_ind_shift                                     (6)
#define  ATSC_ADDR_2F2A_pn_det_flag_pt_shift                                     (5)
#define  ATSC_ADDR_2F2A_pn_det_flag_cr_shift                                     (4)
#define  ATSC_ADDR_2F2A_pn_det_flag_shift                                        (3)
#define  ATSC_ADDR_2F2A_eqpt_dd_step_size_exp_ro_shift                           (0)
#define  ATSC_ADDR_2F2A_adj_ind_bn_mask                                          (0x00000080)
#define  ATSC_ADDR_2F2A_eqpt_state_ind_mask                                      (0x00000040)
#define  ATSC_ADDR_2F2A_pn_det_flag_pt_mask                                      (0x00000020)
#define  ATSC_ADDR_2F2A_pn_det_flag_cr_mask                                      (0x00000010)
#define  ATSC_ADDR_2F2A_pn_det_flag_mask                                         (0x00000008)
#define  ATSC_ADDR_2F2A_eqpt_dd_step_size_exp_ro_mask                            (0x00000007)
#define  ATSC_ADDR_2F2A_adj_ind_bn(data)                                         (0x00000080&((data)<<7))
#define  ATSC_ADDR_2F2A_eqpt_state_ind(data)                                     (0x00000040&((data)<<6))
#define  ATSC_ADDR_2F2A_pn_det_flag_pt(data)                                     (0x00000020&((data)<<5))
#define  ATSC_ADDR_2F2A_pn_det_flag_cr(data)                                     (0x00000010&((data)<<4))
#define  ATSC_ADDR_2F2A_pn_det_flag(data)                                        (0x00000008&((data)<<3))
#define  ATSC_ADDR_2F2A_eqpt_dd_step_size_exp_ro(data)                           (0x00000007&(data))
#define  ATSC_ADDR_2F2A_get_adj_ind_bn(data)                                     ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2F2A_get_eqpt_state_ind(data)                                 ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2F2A_get_pn_det_flag_pt(data)                                 ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2F2A_get_pn_det_flag_cr(data)                                 ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2F2A_get_pn_det_flag(data)                                    ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2F2A_get_eqpt_dd_step_size_exp_ro(data)                       (0x00000007&(data))

#define  ATSC_ADDR_2F2B                                                         0x18157CAC
#define  ATSC_ADDR_2F2B_reg_addr                                                 "0xB8157CAC"
#define  ATSC_ADDR_2F2B_reg                                                      0xB8157CAC
#define  ATSC_ADDR_2F2B_inst_addr                                                "0x04F2"
#define  set_ATSC_ADDR_2F2B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F2B_reg)=data)
#define  get_ATSC_ADDR_2F2B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F2B_reg))
#define  ATSC_ADDR_2F2B_pn_det_acc_q_7_0_shift                                   (0)
#define  ATSC_ADDR_2F2B_pn_det_acc_q_7_0_mask                                    (0x000000FF)
#define  ATSC_ADDR_2F2B_pn_det_acc_q_7_0(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_2F2B_get_pn_det_acc_q_7_0(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_2F2C                                                         0x18157CB0
#define  ATSC_ADDR_2F2C_reg_addr                                                 "0xB8157CB0"
#define  ATSC_ADDR_2F2C_reg                                                      0xB8157CB0
#define  ATSC_ADDR_2F2C_inst_addr                                                "0x04F3"
#define  set_ATSC_ADDR_2F2C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F2C_reg)=data)
#define  get_ATSC_ADDR_2F2C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F2C_reg))
#define  ATSC_ADDR_2F2C_pn_det_acc_q_15_8_shift                                  (0)
#define  ATSC_ADDR_2F2C_pn_det_acc_q_15_8_mask                                   (0x000000FF)
#define  ATSC_ADDR_2F2C_pn_det_acc_q_15_8(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2F2C_get_pn_det_acc_q_15_8(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2F2D                                                         0x18157CB4
#define  ATSC_ADDR_2F2D_reg_addr                                                 "0xB8157CB4"
#define  ATSC_ADDR_2F2D_reg                                                      0xB8157CB4
#define  ATSC_ADDR_2F2D_inst_addr                                                "0x04F4"
#define  set_ATSC_ADDR_2F2D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F2D_reg)=data)
#define  get_ATSC_ADDR_2F2D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F2D_reg))
#define  ATSC_ADDR_2F2D_eqpt_dd_ph_q_7_0_shift                                   (0)
#define  ATSC_ADDR_2F2D_eqpt_dd_ph_q_7_0_mask                                    (0x000000FF)
#define  ATSC_ADDR_2F2D_eqpt_dd_ph_q_7_0(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_2F2D_get_eqpt_dd_ph_q_7_0(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_2F2E                                                         0x18157CB8
#define  ATSC_ADDR_2F2E_reg_addr                                                 "0xB8157CB8"
#define  ATSC_ADDR_2F2E_reg                                                      0xB8157CB8
#define  ATSC_ADDR_2F2E_inst_addr                                                "0x04F5"
#define  set_ATSC_ADDR_2F2E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F2E_reg)=data)
#define  get_ATSC_ADDR_2F2E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F2E_reg))
#define  ATSC_ADDR_2F2E_adj_ind_srrc_shift                                       (7)
#define  ATSC_ADDR_2F2E_srrc_coeff_sel_mux_out_shift                             (5)
#define  ATSC_ADDR_2F2E_eqpt_dd_ph_q_9_8_shift                                   (0)
#define  ATSC_ADDR_2F2E_adj_ind_srrc_mask                                        (0x00000080)
#define  ATSC_ADDR_2F2E_srrc_coeff_sel_mux_out_mask                              (0x00000060)
#define  ATSC_ADDR_2F2E_eqpt_dd_ph_q_9_8_mask                                    (0x00000003)
#define  ATSC_ADDR_2F2E_adj_ind_srrc(data)                                       (0x00000080&((data)<<7))
#define  ATSC_ADDR_2F2E_srrc_coeff_sel_mux_out(data)                             (0x00000060&((data)<<5))
#define  ATSC_ADDR_2F2E_eqpt_dd_ph_q_9_8(data)                                   (0x00000003&(data))
#define  ATSC_ADDR_2F2E_get_adj_ind_srrc(data)                                   ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2F2E_get_srrc_coeff_sel_mux_out(data)                         ((0x00000060&(data))>>5)
#define  ATSC_ADDR_2F2E_get_eqpt_dd_ph_q_9_8(data)                               (0x00000003&(data))

#define  ATSC_ADDR_2F32                                                         0x18157CC8
#define  ATSC_ADDR_2F32_reg_addr                                                 "0xB8157CC8"
#define  ATSC_ADDR_2F32_reg                                                      0xB8157CC8
#define  ATSC_ADDR_2F32_inst_addr                                                "0x04F6"
#define  set_ATSC_ADDR_2F32_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F32_reg)=data)
#define  get_ATSC_ADDR_2F32_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F32_reg))
#define  ATSC_ADDR_2F32_pre_srrc_q_d_7_0_shift                                   (0)
#define  ATSC_ADDR_2F32_pre_srrc_q_d_7_0_mask                                    (0x000000FF)
#define  ATSC_ADDR_2F32_pre_srrc_q_d_7_0(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_2F32_get_pre_srrc_q_d_7_0(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_2F33                                                         0x18157CCC
#define  ATSC_ADDR_2F33_reg_addr                                                 "0xB8157CCC"
#define  ATSC_ADDR_2F33_reg                                                      0xB8157CCC
#define  ATSC_ADDR_2F33_inst_addr                                                "0x04F7"
#define  set_ATSC_ADDR_2F33_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F33_reg)=data)
#define  get_ATSC_ADDR_2F33_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F33_reg))
#define  ATSC_ADDR_2F33_pre_srrc_q_d_15_8_shift                                  (0)
#define  ATSC_ADDR_2F33_pre_srrc_q_d_15_8_mask                                   (0x000000FF)
#define  ATSC_ADDR_2F33_pre_srrc_q_d_15_8(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2F33_get_pre_srrc_q_d_15_8(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2F34                                                         0x18157CD0
#define  ATSC_ADDR_2F34_reg_addr                                                 "0xB8157CD0"
#define  ATSC_ADDR_2F34_reg                                                      0xB8157CD0
#define  ATSC_ADDR_2F34_inst_addr                                                "0x04F8"
#define  set_ATSC_ADDR_2F34_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F34_reg)=data)
#define  get_ATSC_ADDR_2F34_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F34_reg))
#define  ATSC_ADDR_2F34_post_srrc_q_d_7_0_shift                                  (0)
#define  ATSC_ADDR_2F34_post_srrc_q_d_7_0_mask                                   (0x000000FF)
#define  ATSC_ADDR_2F34_post_srrc_q_d_7_0(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2F34_get_post_srrc_q_d_7_0(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2F35                                                         0x18157CD4
#define  ATSC_ADDR_2F35_reg_addr                                                 "0xB8157CD4"
#define  ATSC_ADDR_2F35_reg                                                      0xB8157CD4
#define  ATSC_ADDR_2F35_inst_addr                                                "0x04F9"
#define  set_ATSC_ADDR_2F35_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F35_reg)=data)
#define  get_ATSC_ADDR_2F35_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F35_reg))
#define  ATSC_ADDR_2F35_post_srrc_q_d_15_8_shift                                 (0)
#define  ATSC_ADDR_2F35_post_srrc_q_d_15_8_mask                                  (0x000000FF)
#define  ATSC_ADDR_2F35_post_srrc_q_d_15_8(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2F35_get_post_srrc_q_d_15_8(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2F36                                                         0x18157CD8
#define  ATSC_ADDR_2F36_reg_addr                                                 "0xB8157CD8"
#define  ATSC_ADDR_2F36_reg                                                      0xB8157CD8
#define  ATSC_ADDR_2F36_inst_addr                                                "0x04FA"
#define  set_ATSC_ADDR_2F36_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F36_reg)=data)
#define  get_ATSC_ADDR_2F36_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F36_reg))
#define  ATSC_ADDR_2F36_tr_fs_el_weak_ind_shift                                  (7)
#define  ATSC_ADDR_2F36_tr_fs_el_lock_ind_shift                                  (6)
#define  ATSC_ADDR_2F36_tr_fs_fsm_lock_shift                                     (5)
#define  ATSC_ADDR_2F36_tr_fs_fsm_run_shift                                      (4)
#define  ATSC_ADDR_2F36_tr_fs_fsm_state_shift                                    (0)
#define  ATSC_ADDR_2F36_tr_fs_el_weak_ind_mask                                   (0x00000080)
#define  ATSC_ADDR_2F36_tr_fs_el_lock_ind_mask                                   (0x00000040)
#define  ATSC_ADDR_2F36_tr_fs_fsm_lock_mask                                      (0x00000020)
#define  ATSC_ADDR_2F36_tr_fs_fsm_run_mask                                       (0x00000010)
#define  ATSC_ADDR_2F36_tr_fs_fsm_state_mask                                     (0x0000000F)
#define  ATSC_ADDR_2F36_tr_fs_el_weak_ind(data)                                  (0x00000080&((data)<<7))
#define  ATSC_ADDR_2F36_tr_fs_el_lock_ind(data)                                  (0x00000040&((data)<<6))
#define  ATSC_ADDR_2F36_tr_fs_fsm_lock(data)                                     (0x00000020&((data)<<5))
#define  ATSC_ADDR_2F36_tr_fs_fsm_run(data)                                      (0x00000010&((data)<<4))
#define  ATSC_ADDR_2F36_tr_fs_fsm_state(data)                                    (0x0000000F&(data))
#define  ATSC_ADDR_2F36_get_tr_fs_el_weak_ind(data)                              ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2F36_get_tr_fs_el_lock_ind(data)                              ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2F36_get_tr_fs_fsm_lock(data)                                 ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2F36_get_tr_fs_fsm_run(data)                                  ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2F36_get_tr_fs_fsm_state(data)                                (0x0000000F&(data))

#define  ATSC_ADDR_2F37                                                         0x18157CDC
#define  ATSC_ADDR_2F37_reg_addr                                                 "0xB8157CDC"
#define  ATSC_ADDR_2F37_reg                                                      0xB8157CDC
#define  ATSC_ADDR_2F37_inst_addr                                                "0x04FB"
#define  set_ATSC_ADDR_2F37_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F37_reg)=data)
#define  get_ATSC_ADDR_2F37_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F37_reg))
#define  ATSC_ADDR_2F37_tr_fs_el_kf_out_q16_7_0_shift                            (0)
#define  ATSC_ADDR_2F37_tr_fs_el_kf_out_q16_7_0_mask                             (0x000000FF)
#define  ATSC_ADDR_2F37_tr_fs_el_kf_out_q16_7_0(data)                            (0x000000FF&(data))
#define  ATSC_ADDR_2F37_get_tr_fs_el_kf_out_q16_7_0(data)                        (0x000000FF&(data))

#define  ATSC_ADDR_2F38                                                         0x18157CE0
#define  ATSC_ADDR_2F38_reg_addr                                                 "0xB8157CE0"
#define  ATSC_ADDR_2F38_reg                                                      0xB8157CE0
#define  ATSC_ADDR_2F38_inst_addr                                                "0x04FC"
#define  set_ATSC_ADDR_2F38_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F38_reg)=data)
#define  get_ATSC_ADDR_2F38_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F38_reg))
#define  ATSC_ADDR_2F38_tr_fs_el_kf_out_q16_15_8_shift                           (0)
#define  ATSC_ADDR_2F38_tr_fs_el_kf_out_q16_15_8_mask                            (0x000000FF)
#define  ATSC_ADDR_2F38_tr_fs_el_kf_out_q16_15_8(data)                           (0x000000FF&(data))
#define  ATSC_ADDR_2F38_get_tr_fs_el_kf_out_q16_15_8(data)                       (0x000000FF&(data))

#define  ATSC_ADDR_2F39                                                         0x18157CE4
#define  ATSC_ADDR_2F39_reg_addr                                                 "0xB8157CE4"
#define  ATSC_ADDR_2F39_reg                                                      0xB8157CE4
#define  ATSC_ADDR_2F39_inst_addr                                                "0x04FD"
#define  set_ATSC_ADDR_2F39_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F39_reg)=data)
#define  get_ATSC_ADDR_2F39_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F39_reg))
#define  ATSC_ADDR_2F39_tr_fs_el_trk_corr_7_0_shift                              (0)
#define  ATSC_ADDR_2F39_tr_fs_el_trk_corr_7_0_mask                               (0x000000FF)
#define  ATSC_ADDR_2F39_tr_fs_el_trk_corr_7_0(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_2F39_get_tr_fs_el_trk_corr_7_0(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_2F3A                                                         0x18157CE8
#define  ATSC_ADDR_2F3A_reg_addr                                                 "0xB8157CE8"
#define  ATSC_ADDR_2F3A_reg                                                      0xB8157CE8
#define  ATSC_ADDR_2F3A_inst_addr                                                "0x04FE"
#define  set_ATSC_ADDR_2F3A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F3A_reg)=data)
#define  get_ATSC_ADDR_2F3A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F3A_reg))
#define  ATSC_ADDR_2F3A_tr_fs_el_trk_corr_12_8_shift                             (0)
#define  ATSC_ADDR_2F3A_tr_fs_el_trk_corr_12_8_mask                              (0x0000001F)
#define  ATSC_ADDR_2F3A_tr_fs_el_trk_corr_12_8(data)                             (0x0000001F&(data))
#define  ATSC_ADDR_2F3A_get_tr_fs_el_trk_corr_12_8(data)                         (0x0000001F&(data))

#define  ATSC_ADDR_2F3D                                                         0x18157CF4
#define  ATSC_ADDR_2F3D_reg_addr                                                 "0xB8157CF4"
#define  ATSC_ADDR_2F3D_reg                                                      0xB8157CF4
#define  ATSC_ADDR_2F3D_inst_addr                                                "0x04FF"
#define  set_ATSC_ADDR_2F3D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F3D_reg)=data)
#define  get_ATSC_ADDR_2F3D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F3D_reg))
#define  ATSC_ADDR_2F3D_dc_mean_d_q_re_7_0_shift                                 (0)
#define  ATSC_ADDR_2F3D_dc_mean_d_q_re_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_2F3D_dc_mean_d_q_re_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2F3D_get_dc_mean_d_q_re_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2F3E                                                         0x18157CF8
#define  ATSC_ADDR_2F3E_reg_addr                                                 "0xB8157CF8"
#define  ATSC_ADDR_2F3E_reg                                                      0xB8157CF8
#define  ATSC_ADDR_2F3E_inst_addr                                                "0x0500"
#define  set_ATSC_ADDR_2F3E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F3E_reg)=data)
#define  get_ATSC_ADDR_2F3E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F3E_reg))
#define  ATSC_ADDR_2F3E_dc_mean_d_q_re_15_8_shift                                (0)
#define  ATSC_ADDR_2F3E_dc_mean_d_q_re_15_8_mask                                 (0x000000FF)
#define  ATSC_ADDR_2F3E_dc_mean_d_q_re_15_8(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2F3E_get_dc_mean_d_q_re_15_8(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2F40                                                         0x18157D00
#define  ATSC_ADDR_2F40_reg_addr                                                 "0xB8157D00"
#define  ATSC_ADDR_2F40_reg                                                      0xB8157D00
#define  ATSC_ADDR_2F40_inst_addr                                                "0x0501"
#define  set_ATSC_ADDR_2F40_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F40_reg)=data)
#define  get_ATSC_ADDR_2F40_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F40_reg))
#define  ATSC_ADDR_2F40_dc_mean_d_q_im_7_0_shift                                 (0)
#define  ATSC_ADDR_2F40_dc_mean_d_q_im_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_2F40_dc_mean_d_q_im_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2F40_get_dc_mean_d_q_im_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2F41                                                         0x18157D04
#define  ATSC_ADDR_2F41_reg_addr                                                 "0xB8157D04"
#define  ATSC_ADDR_2F41_reg                                                      0xB8157D04
#define  ATSC_ADDR_2F41_inst_addr                                                "0x0502"
#define  set_ATSC_ADDR_2F41_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F41_reg)=data)
#define  get_ATSC_ADDR_2F41_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F41_reg))
#define  ATSC_ADDR_2F41_dc_mean_d_q_im_15_8_shift                                (0)
#define  ATSC_ADDR_2F41_dc_mean_d_q_im_15_8_mask                                 (0x000000FF)
#define  ATSC_ADDR_2F41_dc_mean_d_q_im_15_8(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2F41_get_dc_mean_d_q_im_15_8(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2F45                                                         0x18157D14
#define  ATSC_ADDR_2F45_reg_addr                                                 "0xB8157D14"
#define  ATSC_ADDR_2F45_reg                                                      0xB8157D14
#define  ATSC_ADDR_2F45_inst_addr                                                "0x0503"
#define  set_ATSC_ADDR_2F45_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F45_reg)=data)
#define  get_ATSC_ADDR_2F45_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F45_reg))
#define  ATSC_ADDR_2F45_tr_lock_ind_reg_shift                                    (0)
#define  ATSC_ADDR_2F45_tr_lock_ind_reg_mask                                     (0x000000FF)
#define  ATSC_ADDR_2F45_tr_lock_ind_reg(data)                                    (0x000000FF&(data))
#define  ATSC_ADDR_2F45_get_tr_lock_ind_reg(data)                                (0x000000FF&(data))

#define  ATSC_ADDR_2F46                                                         0x18157D18
#define  ATSC_ADDR_2F46_reg_addr                                                 "0xB8157D18"
#define  ATSC_ADDR_2F46_reg                                                      0xB8157D18
#define  ATSC_ADDR_2F46_inst_addr                                                "0x0504"
#define  set_ATSC_ADDR_2F46_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F46_reg)=data)
#define  get_ATSC_ADDR_2F46_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F46_reg))
#define  ATSC_ADDR_2F46_tr_lock_ted_reg_shift                                    (0)
#define  ATSC_ADDR_2F46_tr_lock_ted_reg_mask                                     (0x000000FF)
#define  ATSC_ADDR_2F46_tr_lock_ted_reg(data)                                    (0x000000FF&(data))
#define  ATSC_ADDR_2F46_get_tr_lock_ted_reg(data)                                (0x000000FF&(data))

#define  ATSC_ADDR_2F47                                                         0x18157D1C
#define  ATSC_ADDR_2F47_reg_addr                                                 "0xB8157D1C"
#define  ATSC_ADDR_2F47_reg                                                      0xB8157D1C
#define  ATSC_ADDR_2F47_inst_addr                                                "0x0505"
#define  set_ATSC_ADDR_2F47_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F47_reg)=data)
#define  get_ATSC_ADDR_2F47_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F47_reg))
#define  ATSC_ADDR_2F47_tr_fs_tr_freq_7_0_shift                                  (0)
#define  ATSC_ADDR_2F47_tr_fs_tr_freq_7_0_mask                                   (0x000000FF)
#define  ATSC_ADDR_2F47_tr_fs_tr_freq_7_0(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2F47_get_tr_fs_tr_freq_7_0(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2F48                                                         0x18157D20
#define  ATSC_ADDR_2F48_reg_addr                                                 "0xB8157D20"
#define  ATSC_ADDR_2F48_reg                                                      0xB8157D20
#define  ATSC_ADDR_2F48_inst_addr                                                "0x0506"
#define  set_ATSC_ADDR_2F48_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F48_reg)=data)
#define  get_ATSC_ADDR_2F48_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F48_reg))
#define  ATSC_ADDR_2F48_tr_fs_tr_freq_15_8_shift                                 (0)
#define  ATSC_ADDR_2F48_tr_fs_tr_freq_15_8_mask                                  (0x000000FF)
#define  ATSC_ADDR_2F48_tr_fs_tr_freq_15_8(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2F48_get_tr_fs_tr_freq_15_8(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2F49                                                         0x18157D24
#define  ATSC_ADDR_2F49_reg_addr                                                 "0xB8157D24"
#define  ATSC_ADDR_2F49_reg                                                      0xB8157D24
#define  ATSC_ADDR_2F49_inst_addr                                                "0x0507"
#define  set_ATSC_ADDR_2F49_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F49_reg)=data)
#define  get_ATSC_ADDR_2F49_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F49_reg))
#define  ATSC_ADDR_2F49_tr_fs_tr_freq_23_16_shift                                (0)
#define  ATSC_ADDR_2F49_tr_fs_tr_freq_23_16_mask                                 (0x000000FF)
#define  ATSC_ADDR_2F49_tr_fs_tr_freq_23_16(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2F49_get_tr_fs_tr_freq_23_16(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2F4A                                                         0x18157D28
#define  ATSC_ADDR_2F4A_reg_addr                                                 "0xB8157D28"
#define  ATSC_ADDR_2F4A_reg                                                      0xB8157D28
#define  ATSC_ADDR_2F4A_inst_addr                                                "0x0508"
#define  set_ATSC_ADDR_2F4A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F4A_reg)=data)
#define  get_ATSC_ADDR_2F4A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F4A_reg))
#define  ATSC_ADDR_2F4A_pt_phase_q_7_0_shift                                     (0)
#define  ATSC_ADDR_2F4A_pt_phase_q_7_0_mask                                      (0x000000FF)
#define  ATSC_ADDR_2F4A_pt_phase_q_7_0(data)                                     (0x000000FF&(data))
#define  ATSC_ADDR_2F4A_get_pt_phase_q_7_0(data)                                 (0x000000FF&(data))

#define  ATSC_ADDR_2F4B                                                         0x18157D2C
#define  ATSC_ADDR_2F4B_reg_addr                                                 "0xB8157D2C"
#define  ATSC_ADDR_2F4B_reg                                                      0xB8157D2C
#define  ATSC_ADDR_2F4B_inst_addr                                                "0x0509"
#define  set_ATSC_ADDR_2F4B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F4B_reg)=data)
#define  get_ATSC_ADDR_2F4B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F4B_reg))
#define  ATSC_ADDR_2F4B_pt_phase_q_8_shift                                       (0)
#define  ATSC_ADDR_2F4B_pt_phase_q_8_mask                                        (0x00000001)
#define  ATSC_ADDR_2F4B_pt_phase_q_8(data)                                       (0x00000001&(data))
#define  ATSC_ADDR_2F4B_get_pt_phase_q_8(data)                                   (0x00000001&(data))

#define  ATSC_ADDR_2F4F                                                         0x18157D3C
#define  ATSC_ADDR_2F4F_reg_addr                                                 "0xB8157D3C"
#define  ATSC_ADDR_2F4F_reg                                                      0xB8157D3C
#define  ATSC_ADDR_2F4F_inst_addr                                                "0x050A"
#define  set_ATSC_ADDR_2F4F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F4F_reg)=data)
#define  get_ATSC_ADDR_2F4F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F4F_reg))
#define  ATSC_ADDR_2F4F_cm_7_0_shift                                             (0)
#define  ATSC_ADDR_2F4F_cm_7_0_mask                                              (0x000000FF)
#define  ATSC_ADDR_2F4F_cm_7_0(data)                                             (0x000000FF&(data))
#define  ATSC_ADDR_2F4F_get_cm_7_0(data)                                         (0x000000FF&(data))

#define  ATSC_ADDR_2F50                                                         0x18157D40
#define  ATSC_ADDR_2F50_reg_addr                                                 "0xB8157D40"
#define  ATSC_ADDR_2F50_reg                                                      0xB8157D40
#define  ATSC_ADDR_2F50_inst_addr                                                "0x050B"
#define  set_ATSC_ADDR_2F50_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F50_reg)=data)
#define  get_ATSC_ADDR_2F50_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F50_reg))
#define  ATSC_ADDR_2F50_cm_15_8_shift                                            (0)
#define  ATSC_ADDR_2F50_cm_15_8_mask                                             (0x000000FF)
#define  ATSC_ADDR_2F50_cm_15_8(data)                                            (0x000000FF&(data))
#define  ATSC_ADDR_2F50_get_cm_15_8(data)                                        (0x000000FF&(data))

#define  ATSC_ADDR_2F51                                                         0x18157D44
#define  ATSC_ADDR_2F51_reg_addr                                                 "0xB8157D44"
#define  ATSC_ADDR_2F51_reg                                                      0xB8157D44
#define  ATSC_ADDR_2F51_inst_addr                                                "0x050C"
#define  set_ATSC_ADDR_2F51_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F51_reg)=data)
#define  get_ATSC_ADDR_2F51_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F51_reg))
#define  ATSC_ADDR_2F51_cm_23_16_shift                                           (0)
#define  ATSC_ADDR_2F51_cm_23_16_mask                                            (0x000000FF)
#define  ATSC_ADDR_2F51_cm_23_16(data)                                           (0x000000FF&(data))
#define  ATSC_ADDR_2F51_get_cm_23_16(data)                                       (0x000000FF&(data))

#define  ATSC_ADDR_2F52                                                         0x18157D48
#define  ATSC_ADDR_2F52_reg_addr                                                 "0xB8157D48"
#define  ATSC_ADDR_2F52_reg                                                      0xB8157D48
#define  ATSC_ADDR_2F52_inst_addr                                                "0x050D"
#define  set_ATSC_ADDR_2F52_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F52_reg)=data)
#define  get_ATSC_ADDR_2F52_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F52_reg))
#define  ATSC_ADDR_2F52_cm_26_24_shift                                           (0)
#define  ATSC_ADDR_2F52_cm_26_24_mask                                            (0x00000007)
#define  ATSC_ADDR_2F52_cm_26_24(data)                                           (0x00000007&(data))
#define  ATSC_ADDR_2F52_get_cm_26_24(data)                                       (0x00000007&(data))

#define  ATSC_ADDR_2F53                                                         0x18157D4C
#define  ATSC_ADDR_2F53_reg_addr                                                 "0xB8157D4C"
#define  ATSC_ADDR_2F53_reg                                                      0xB8157D4C
#define  ATSC_ADDR_2F53_inst_addr                                                "0x050E"
#define  set_ATSC_ADDR_2F53_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F53_reg)=data)
#define  get_ATSC_ADDR_2F53_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F53_reg))
#define  ATSC_ADDR_2F53_pt_out_7_0_shift                                         (0)
#define  ATSC_ADDR_2F53_pt_out_7_0_mask                                          (0x000000FF)
#define  ATSC_ADDR_2F53_pt_out_7_0(data)                                         (0x000000FF&(data))
#define  ATSC_ADDR_2F53_get_pt_out_7_0(data)                                     (0x000000FF&(data))

#define  ATSC_ADDR_2F54                                                         0x18157D50
#define  ATSC_ADDR_2F54_reg_addr                                                 "0xB8157D50"
#define  ATSC_ADDR_2F54_reg                                                      0xB8157D50
#define  ATSC_ADDR_2F54_inst_addr                                                "0x050F"
#define  set_ATSC_ADDR_2F54_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F54_reg)=data)
#define  get_ATSC_ADDR_2F54_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F54_reg))
#define  ATSC_ADDR_2F54_pt_out_11_8_shift                                        (0)
#define  ATSC_ADDR_2F54_pt_out_11_8_mask                                         (0x0000000F)
#define  ATSC_ADDR_2F54_pt_out_11_8(data)                                        (0x0000000F&(data))
#define  ATSC_ADDR_2F54_get_pt_out_11_8(data)                                    (0x0000000F&(data))

#define  ATSC_ADDR_2F5C                                                         0x18157D70
#define  ATSC_ADDR_2F5C_reg_addr                                                 "0xB8157D70"
#define  ATSC_ADDR_2F5C_reg                                                      0xB8157D70
#define  ATSC_ADDR_2F5C_inst_addr                                                "0x0510"
#define  set_ATSC_ADDR_2F5C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F5C_reg)=data)
#define  get_ATSC_ADDR_2F5C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F5C_reg))
#define  ATSC_ADDR_2F5C_fs2_main_is_max_shift                                    (3)
#define  ATSC_ADDR_2F5C_fs2_precursor_exist_shift                                (2)
#define  ATSC_ADDR_2F5C_fs2_run_shift                                            (1)
#define  ATSC_ADDR_2F5C_fs2_lock_shift                                           (0)
#define  ATSC_ADDR_2F5C_fs2_main_is_max_mask                                     (0x00000008)
#define  ATSC_ADDR_2F5C_fs2_precursor_exist_mask                                 (0x00000004)
#define  ATSC_ADDR_2F5C_fs2_run_mask                                             (0x00000002)
#define  ATSC_ADDR_2F5C_fs2_lock_mask                                            (0x00000001)
#define  ATSC_ADDR_2F5C_fs2_main_is_max(data)                                    (0x00000008&((data)<<3))
#define  ATSC_ADDR_2F5C_fs2_precursor_exist(data)                                (0x00000004&((data)<<2))
#define  ATSC_ADDR_2F5C_fs2_run(data)                                            (0x00000002&((data)<<1))
#define  ATSC_ADDR_2F5C_fs2_lock(data)                                           (0x00000001&(data))
#define  ATSC_ADDR_2F5C_get_fs2_main_is_max(data)                                ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2F5C_get_fs2_precursor_exist(data)                            ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2F5C_get_fs2_run(data)                                        ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2F5C_get_fs2_lock(data)                                       (0x00000001&(data))

#define  ATSC_ADDR_2F5D                                                         0x18157D74
#define  ATSC_ADDR_2F5D_reg_addr                                                 "0xB8157D74"
#define  ATSC_ADDR_2F5D_reg                                                      0xB8157D74
#define  ATSC_ADDR_2F5D_inst_addr                                                "0x0511"
#define  set_ATSC_ADDR_2F5D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F5D_reg)=data)
#define  get_ATSC_ADDR_2F5D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F5D_reg))
#define  ATSC_ADDR_2F5D_fs2_state_one_hot_7_0_shift                              (0)
#define  ATSC_ADDR_2F5D_fs2_state_one_hot_7_0_mask                               (0x000000FF)
#define  ATSC_ADDR_2F5D_fs2_state_one_hot_7_0(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_2F5D_get_fs2_state_one_hot_7_0(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_2F5E                                                         0x18157D78
#define  ATSC_ADDR_2F5E_reg_addr                                                 "0xB8157D78"
#define  ATSC_ADDR_2F5E_reg                                                      0xB8157D78
#define  ATSC_ADDR_2F5E_inst_addr                                                "0x0512"
#define  set_ATSC_ADDR_2F5E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F5E_reg)=data)
#define  get_ATSC_ADDR_2F5E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F5E_reg))
#define  ATSC_ADDR_2F5E_fs2_state_one_hot_11_8_shift                             (0)
#define  ATSC_ADDR_2F5E_fs2_state_one_hot_11_8_mask                              (0x0000000F)
#define  ATSC_ADDR_2F5E_fs2_state_one_hot_11_8(data)                             (0x0000000F&(data))
#define  ATSC_ADDR_2F5E_get_fs2_state_one_hot_11_8(data)                         (0x0000000F&(data))

#define  ATSC_ADDR_2F5F                                                         0x18157D7C
#define  ATSC_ADDR_2F5F_reg_addr                                                 "0xB8157D7C"
#define  ATSC_ADDR_2F5F_reg                                                      0xB8157D7C
#define  ATSC_ADDR_2F5F_inst_addr                                                "0x0513"
#define  set_ATSC_ADDR_2F5F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F5F_reg)=data)
#define  get_ATSC_ADDR_2F5F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F5F_reg))
#define  ATSC_ADDR_2F5F_fs2_corr_amp_7_0_shift                                   (0)
#define  ATSC_ADDR_2F5F_fs2_corr_amp_7_0_mask                                    (0x000000FF)
#define  ATSC_ADDR_2F5F_fs2_corr_amp_7_0(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_2F5F_get_fs2_corr_amp_7_0(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_2F60                                                         0x18157D80
#define  ATSC_ADDR_2F60_reg_addr                                                 "0xB8157D80"
#define  ATSC_ADDR_2F60_reg                                                      0xB8157D80
#define  ATSC_ADDR_2F60_inst_addr                                                "0x0514"
#define  set_ATSC_ADDR_2F60_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F60_reg)=data)
#define  get_ATSC_ADDR_2F60_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F60_reg))
#define  ATSC_ADDR_2F60_fs2_corr_amp_12_8_shift                                  (0)
#define  ATSC_ADDR_2F60_fs2_corr_amp_12_8_mask                                   (0x0000001F)
#define  ATSC_ADDR_2F60_fs2_corr_amp_12_8(data)                                  (0x0000001F&(data))
#define  ATSC_ADDR_2F60_get_fs2_corr_amp_12_8(data)                              (0x0000001F&(data))

#define  ATSC_ADDR_2F61                                                         0x18157D84
#define  ATSC_ADDR_2F61_reg_addr                                                 "0xB8157D84"
#define  ATSC_ADDR_2F61_reg                                                      0xB8157D84
#define  ATSC_ADDR_2F61_inst_addr                                                "0x0515"
#define  set_ATSC_ADDR_2F61_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F61_reg)=data)
#define  get_ATSC_ADDR_2F61_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F61_reg))
#define  ATSC_ADDR_2F61_fs2_force_num_decode_shift                               (0)
#define  ATSC_ADDR_2F61_fs2_force_num_decode_mask                                (0x0000007F)
#define  ATSC_ADDR_2F61_fs2_force_num_decode(data)                               (0x0000007F&(data))
#define  ATSC_ADDR_2F61_get_fs2_force_num_decode(data)                           (0x0000007F&(data))

#define  ATSC_ADDR_2F62                                                         0x18157D88
#define  ATSC_ADDR_2F62_reg_addr                                                 "0xB8157D88"
#define  ATSC_ADDR_2F62_reg                                                      0xB8157D88
#define  ATSC_ADDR_2F62_inst_addr                                                "0x0516"
#define  set_ATSC_ADDR_2F62_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F62_reg)=data)
#define  get_ATSC_ADDR_2F62_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F62_reg))
#define  ATSC_ADDR_2F62_force_space_7_0_shift                                    (0)
#define  ATSC_ADDR_2F62_force_space_7_0_mask                                     (0x000000FF)
#define  ATSC_ADDR_2F62_force_space_7_0(data)                                    (0x000000FF&(data))
#define  ATSC_ADDR_2F62_get_force_space_7_0(data)                                (0x000000FF&(data))

#define  ATSC_ADDR_2F63                                                         0x18157D8C
#define  ATSC_ADDR_2F63_reg_addr                                                 "0xB8157D8C"
#define  ATSC_ADDR_2F63_reg                                                      0xB8157D8C
#define  ATSC_ADDR_2F63_inst_addr                                                "0x0517"
#define  set_ATSC_ADDR_2F63_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F63_reg)=data)
#define  get_ATSC_ADDR_2F63_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F63_reg))
#define  ATSC_ADDR_2F63_force_space_11_8_shift                                   (0)
#define  ATSC_ADDR_2F63_force_space_11_8_mask                                    (0x0000000F)
#define  ATSC_ADDR_2F63_force_space_11_8(data)                                   (0x0000000F&(data))
#define  ATSC_ADDR_2F63_get_force_space_11_8(data)                               (0x0000000F&(data))

#define  ATSC_ADDR_2F64                                                         0x18157D90
#define  ATSC_ADDR_2F64_reg_addr                                                 "0xB8157D90"
#define  ATSC_ADDR_2F64_reg                                                      0xB8157D90
#define  ATSC_ADDR_2F64_inst_addr                                                "0x0518"
#define  set_ATSC_ADDR_2F64_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F64_reg)=data)
#define  get_ATSC_ADDR_2F64_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F64_reg))
#define  ATSC_ADDR_2F64_fs2_main_amp_7_0_shift                                   (0)
#define  ATSC_ADDR_2F64_fs2_main_amp_7_0_mask                                    (0x000000FF)
#define  ATSC_ADDR_2F64_fs2_main_amp_7_0(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_2F64_get_fs2_main_amp_7_0(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_2F65                                                         0x18157D94
#define  ATSC_ADDR_2F65_reg_addr                                                 "0xB8157D94"
#define  ATSC_ADDR_2F65_reg                                                      0xB8157D94
#define  ATSC_ADDR_2F65_inst_addr                                                "0x0519"
#define  set_ATSC_ADDR_2F65_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F65_reg)=data)
#define  get_ATSC_ADDR_2F65_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F65_reg))
#define  ATSC_ADDR_2F65_fs2_main_amp_12_8_shift                                  (0)
#define  ATSC_ADDR_2F65_fs2_main_amp_12_8_mask                                   (0x0000001F)
#define  ATSC_ADDR_2F65_fs2_main_amp_12_8(data)                                  (0x0000001F&(data))
#define  ATSC_ADDR_2F65_get_fs2_main_amp_12_8(data)                              (0x0000001F&(data))

#define  ATSC_ADDR_2F66                                                         0x18157D98
#define  ATSC_ADDR_2F66_reg_addr                                                 "0xB8157D98"
#define  ATSC_ADDR_2F66_reg                                                      0xB8157D98
#define  ATSC_ADDR_2F66_inst_addr                                                "0x051A"
#define  set_ATSC_ADDR_2F66_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F66_reg)=data)
#define  get_ATSC_ADDR_2F66_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F66_reg))
#define  ATSC_ADDR_2F66_fs2_max_amp_7_0_shift                                    (0)
#define  ATSC_ADDR_2F66_fs2_max_amp_7_0_mask                                     (0x000000FF)
#define  ATSC_ADDR_2F66_fs2_max_amp_7_0(data)                                    (0x000000FF&(data))
#define  ATSC_ADDR_2F66_get_fs2_max_amp_7_0(data)                                (0x000000FF&(data))

#define  ATSC_ADDR_2F67                                                         0x18157D9C
#define  ATSC_ADDR_2F67_reg_addr                                                 "0xB8157D9C"
#define  ATSC_ADDR_2F67_reg                                                      0xB8157D9C
#define  ATSC_ADDR_2F67_inst_addr                                                "0x051B"
#define  set_ATSC_ADDR_2F67_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F67_reg)=data)
#define  get_ATSC_ADDR_2F67_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F67_reg))
#define  ATSC_ADDR_2F67_fs2_max_amp_12_8_shift                                   (0)
#define  ATSC_ADDR_2F67_fs2_max_amp_12_8_mask                                    (0x0000001F)
#define  ATSC_ADDR_2F67_fs2_max_amp_12_8(data)                                   (0x0000001F&(data))
#define  ATSC_ADDR_2F67_get_fs2_max_amp_12_8(data)                               (0x0000001F&(data))

#define  ATSC_ADDR_2F68                                                         0x18157DA0
#define  ATSC_ADDR_2F68_reg_addr                                                 "0xB8157DA0"
#define  ATSC_ADDR_2F68_reg                                                      0xB8157DA0
#define  ATSC_ADDR_2F68_inst_addr                                                "0x051C"
#define  set_ATSC_ADDR_2F68_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F68_reg)=data)
#define  get_ATSC_ADDR_2F68_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F68_reg))
#define  ATSC_ADDR_2F68_fs2_pre_amp_7_0_shift                                    (0)
#define  ATSC_ADDR_2F68_fs2_pre_amp_7_0_mask                                     (0x000000FF)
#define  ATSC_ADDR_2F68_fs2_pre_amp_7_0(data)                                    (0x000000FF&(data))
#define  ATSC_ADDR_2F68_get_fs2_pre_amp_7_0(data)                                (0x000000FF&(data))

#define  ATSC_ADDR_2F69                                                         0x18157DA4
#define  ATSC_ADDR_2F69_reg_addr                                                 "0xB8157DA4"
#define  ATSC_ADDR_2F69_reg                                                      0xB8157DA4
#define  ATSC_ADDR_2F69_inst_addr                                                "0x051D"
#define  set_ATSC_ADDR_2F69_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F69_reg)=data)
#define  get_ATSC_ADDR_2F69_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F69_reg))
#define  ATSC_ADDR_2F69_fs2_pre_amp_12_8_shift                                   (0)
#define  ATSC_ADDR_2F69_fs2_pre_amp_12_8_mask                                    (0x0000001F)
#define  ATSC_ADDR_2F69_fs2_pre_amp_12_8(data)                                   (0x0000001F&(data))
#define  ATSC_ADDR_2F69_get_fs2_pre_amp_12_8(data)                               (0x0000001F&(data))

#define  ATSC_ADDR_2F6A                                                         0x18157DA8
#define  ATSC_ADDR_2F6A_reg_addr                                                 "0xB8157DA8"
#define  ATSC_ADDR_2F6A_reg                                                      0xB8157DA8
#define  ATSC_ADDR_2F6A_inst_addr                                                "0x051E"
#define  set_ATSC_ADDR_2F6A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F6A_reg)=data)
#define  get_ATSC_ADDR_2F6A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F6A_reg))
#define  ATSC_ADDR_2F6A_fs2_max_re_7_0_shift                                     (0)
#define  ATSC_ADDR_2F6A_fs2_max_re_7_0_mask                                      (0x000000FF)
#define  ATSC_ADDR_2F6A_fs2_max_re_7_0(data)                                     (0x000000FF&(data))
#define  ATSC_ADDR_2F6A_get_fs2_max_re_7_0(data)                                 (0x000000FF&(data))

#define  ATSC_ADDR_2F6B                                                         0x18157DAC
#define  ATSC_ADDR_2F6B_reg_addr                                                 "0xB8157DAC"
#define  ATSC_ADDR_2F6B_reg                                                      0xB8157DAC
#define  ATSC_ADDR_2F6B_inst_addr                                                "0x051F"
#define  set_ATSC_ADDR_2F6B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F6B_reg)=data)
#define  get_ATSC_ADDR_2F6B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F6B_reg))
#define  ATSC_ADDR_2F6B_fs2_max_re_12_8_shift                                    (0)
#define  ATSC_ADDR_2F6B_fs2_max_re_12_8_mask                                     (0x0000001F)
#define  ATSC_ADDR_2F6B_fs2_max_re_12_8(data)                                    (0x0000001F&(data))
#define  ATSC_ADDR_2F6B_get_fs2_max_re_12_8(data)                                (0x0000001F&(data))

#define  ATSC_ADDR_2F6C                                                         0x18157DB0
#define  ATSC_ADDR_2F6C_reg_addr                                                 "0xB8157DB0"
#define  ATSC_ADDR_2F6C_reg                                                      0xB8157DB0
#define  ATSC_ADDR_2F6C_inst_addr                                                "0x0520"
#define  set_ATSC_ADDR_2F6C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F6C_reg)=data)
#define  get_ATSC_ADDR_2F6C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F6C_reg))
#define  ATSC_ADDR_2F6C_fs2_max_amp_sam_7_0_shift                                (0)
#define  ATSC_ADDR_2F6C_fs2_max_amp_sam_7_0_mask                                 (0x000000FF)
#define  ATSC_ADDR_2F6C_fs2_max_amp_sam_7_0(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2F6C_get_fs2_max_amp_sam_7_0(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2F6D                                                         0x18157DB4
#define  ATSC_ADDR_2F6D_reg_addr                                                 "0xB8157DB4"
#define  ATSC_ADDR_2F6D_reg                                                      0xB8157DB4
#define  ATSC_ADDR_2F6D_inst_addr                                                "0x0521"
#define  set_ATSC_ADDR_2F6D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F6D_reg)=data)
#define  get_ATSC_ADDR_2F6D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F6D_reg))
#define  ATSC_ADDR_2F6D_fs2_max_amp_sam_15_8_shift                               (0)
#define  ATSC_ADDR_2F6D_fs2_max_amp_sam_15_8_mask                                (0x000000FF)
#define  ATSC_ADDR_2F6D_fs2_max_amp_sam_15_8(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_2F6D_get_fs2_max_amp_sam_15_8(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_2F6E                                                         0x18157DB8
#define  ATSC_ADDR_2F6E_reg_addr                                                 "0xB8157DB8"
#define  ATSC_ADDR_2F6E_reg                                                      0xB8157DB8
#define  ATSC_ADDR_2F6E_inst_addr                                                "0x0522"
#define  set_ATSC_ADDR_2F6E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F6E_reg)=data)
#define  get_ATSC_ADDR_2F6E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F6E_reg))
#define  ATSC_ADDR_2F6E_fs2_max_amp_sam_18_16_shift                              (0)
#define  ATSC_ADDR_2F6E_fs2_max_amp_sam_18_16_mask                               (0x00000007)
#define  ATSC_ADDR_2F6E_fs2_max_amp_sam_18_16(data)                              (0x00000007&(data))
#define  ATSC_ADDR_2F6E_get_fs2_max_amp_sam_18_16(data)                          (0x00000007&(data))

#define  ATSC_ADDR_2F6F                                                         0x18157DBC
#define  ATSC_ADDR_2F6F_reg_addr                                                 "0xB8157DBC"
#define  ATSC_ADDR_2F6F_reg                                                      0xB8157DBC
#define  ATSC_ADDR_2F6F_inst_addr                                                "0x0523"
#define  set_ATSC_ADDR_2F6F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F6F_reg)=data)
#define  get_ATSC_ADDR_2F6F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F6F_reg))
#define  ATSC_ADDR_2F6F_fs2_main_sam_7_0_shift                                   (0)
#define  ATSC_ADDR_2F6F_fs2_main_sam_7_0_mask                                    (0x000000FF)
#define  ATSC_ADDR_2F6F_fs2_main_sam_7_0(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_2F6F_get_fs2_main_sam_7_0(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_2F70                                                         0x18157DC0
#define  ATSC_ADDR_2F70_reg_addr                                                 "0xB8157DC0"
#define  ATSC_ADDR_2F70_reg                                                      0xB8157DC0
#define  ATSC_ADDR_2F70_inst_addr                                                "0x0524"
#define  set_ATSC_ADDR_2F70_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F70_reg)=data)
#define  get_ATSC_ADDR_2F70_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F70_reg))
#define  ATSC_ADDR_2F70_fs2_main_sam_15_8_shift                                  (0)
#define  ATSC_ADDR_2F70_fs2_main_sam_15_8_mask                                   (0x000000FF)
#define  ATSC_ADDR_2F70_fs2_main_sam_15_8(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2F70_get_fs2_main_sam_15_8(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2F71                                                         0x18157DC4
#define  ATSC_ADDR_2F71_reg_addr                                                 "0xB8157DC4"
#define  ATSC_ADDR_2F71_reg                                                      0xB8157DC4
#define  ATSC_ADDR_2F71_inst_addr                                                "0x0525"
#define  set_ATSC_ADDR_2F71_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F71_reg)=data)
#define  get_ATSC_ADDR_2F71_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F71_reg))
#define  ATSC_ADDR_2F71_fs2_main_sam_20_16_shift                                 (0)
#define  ATSC_ADDR_2F71_fs2_main_sam_20_16_mask                                  (0x0000001F)
#define  ATSC_ADDR_2F71_fs2_main_sam_20_16(data)                                 (0x0000001F&(data))
#define  ATSC_ADDR_2F71_get_fs2_main_sam_20_16(data)                             (0x0000001F&(data))

#define  ATSC_ADDR_2F72                                                         0x18157DC8
#define  ATSC_ADDR_2F72_reg_addr                                                 "0xB8157DC8"
#define  ATSC_ADDR_2F72_reg                                                      0xB8157DC8
#define  ATSC_ADDR_2F72_inst_addr                                                "0x0526"
#define  set_ATSC_ADDR_2F72_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F72_reg)=data)
#define  get_ATSC_ADDR_2F72_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F72_reg))
#define  ATSC_ADDR_2F72_fs2_pre_sam_7_0_shift                                    (0)
#define  ATSC_ADDR_2F72_fs2_pre_sam_7_0_mask                                     (0x000000FF)
#define  ATSC_ADDR_2F72_fs2_pre_sam_7_0(data)                                    (0x000000FF&(data))
#define  ATSC_ADDR_2F72_get_fs2_pre_sam_7_0(data)                                (0x000000FF&(data))

#define  ATSC_ADDR_2F73                                                         0x18157DCC
#define  ATSC_ADDR_2F73_reg_addr                                                 "0xB8157DCC"
#define  ATSC_ADDR_2F73_reg                                                      0xB8157DCC
#define  ATSC_ADDR_2F73_inst_addr                                                "0x0527"
#define  set_ATSC_ADDR_2F73_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F73_reg)=data)
#define  get_ATSC_ADDR_2F73_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F73_reg))
#define  ATSC_ADDR_2F73_fs2_pre_sam_15_8_shift                                   (0)
#define  ATSC_ADDR_2F73_fs2_pre_sam_15_8_mask                                    (0x000000FF)
#define  ATSC_ADDR_2F73_fs2_pre_sam_15_8(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_2F73_get_fs2_pre_sam_15_8(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_2F74                                                         0x18157DD0
#define  ATSC_ADDR_2F74_reg_addr                                                 "0xB8157DD0"
#define  ATSC_ADDR_2F74_reg                                                      0xB8157DD0
#define  ATSC_ADDR_2F74_inst_addr                                                "0x0528"
#define  set_ATSC_ADDR_2F74_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F74_reg)=data)
#define  get_ATSC_ADDR_2F74_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F74_reg))
#define  ATSC_ADDR_2F74_fs2_pre_sam_20_16_shift                                  (0)
#define  ATSC_ADDR_2F74_fs2_pre_sam_20_16_mask                                   (0x0000001F)
#define  ATSC_ADDR_2F74_fs2_pre_sam_20_16(data)                                  (0x0000001F&(data))
#define  ATSC_ADDR_2F74_get_fs2_pre_sam_20_16(data)                              (0x0000001F&(data))

#define  ATSC_ADDR_2F75                                                         0x18157DD4
#define  ATSC_ADDR_2F75_reg_addr                                                 "0xB8157DD4"
#define  ATSC_ADDR_2F75_reg                                                      0xB8157DD4
#define  ATSC_ADDR_2F75_inst_addr                                                "0x0529"
#define  set_ATSC_ADDR_2F75_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F75_reg)=data)
#define  get_ATSC_ADDR_2F75_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F75_reg))
#define  ATSC_ADDR_2F75_fs2_max_re_sam_7_0_shift                                 (0)
#define  ATSC_ADDR_2F75_fs2_max_re_sam_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_2F75_fs2_max_re_sam_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2F75_get_fs2_max_re_sam_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2F76                                                         0x18157DD8
#define  ATSC_ADDR_2F76_reg_addr                                                 "0xB8157DD8"
#define  ATSC_ADDR_2F76_reg                                                      0xB8157DD8
#define  ATSC_ADDR_2F76_inst_addr                                                "0x052A"
#define  set_ATSC_ADDR_2F76_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F76_reg)=data)
#define  get_ATSC_ADDR_2F76_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F76_reg))
#define  ATSC_ADDR_2F76_fs2_max_re_sam_15_8_shift                                (0)
#define  ATSC_ADDR_2F76_fs2_max_re_sam_15_8_mask                                 (0x000000FF)
#define  ATSC_ADDR_2F76_fs2_max_re_sam_15_8(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2F76_get_fs2_max_re_sam_15_8(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2F77                                                         0x18157DDC
#define  ATSC_ADDR_2F77_reg_addr                                                 "0xB8157DDC"
#define  ATSC_ADDR_2F77_reg                                                      0xB8157DDC
#define  ATSC_ADDR_2F77_inst_addr                                                "0x052B"
#define  set_ATSC_ADDR_2F77_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F77_reg)=data)
#define  get_ATSC_ADDR_2F77_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F77_reg))
#define  ATSC_ADDR_2F77_fs2_max_re_sam_18_16_shift                               (0)
#define  ATSC_ADDR_2F77_fs2_max_re_sam_18_16_mask                                (0x00000007)
#define  ATSC_ADDR_2F77_fs2_max_re_sam_18_16(data)                               (0x00000007&(data))
#define  ATSC_ADDR_2F77_get_fs2_max_re_sam_18_16(data)                           (0x00000007&(data))

#define  ATSC_ADDR_2F78                                                         0x18157DE0
#define  ATSC_ADDR_2F78_reg_addr                                                 "0xB8157DE0"
#define  ATSC_ADDR_2F78_reg                                                      0xB8157DE0
#define  ATSC_ADDR_2F78_inst_addr                                                "0x052C"
#define  set_ATSC_ADDR_2F78_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F78_reg)=data)
#define  get_ATSC_ADDR_2F78_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F78_reg))
#define  ATSC_ADDR_2F78_fs2_main_addr_7_0_shift                                  (0)
#define  ATSC_ADDR_2F78_fs2_main_addr_7_0_mask                                   (0x000000FF)
#define  ATSC_ADDR_2F78_fs2_main_addr_7_0(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2F78_get_fs2_main_addr_7_0(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2F79                                                         0x18157DE4
#define  ATSC_ADDR_2F79_reg_addr                                                 "0xB8157DE4"
#define  ATSC_ADDR_2F79_reg                                                      0xB8157DE4
#define  ATSC_ADDR_2F79_inst_addr                                                "0x052D"
#define  set_ATSC_ADDR_2F79_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F79_reg)=data)
#define  get_ATSC_ADDR_2F79_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F79_reg))
#define  ATSC_ADDR_2F79_fs2_main_addr_11_8_shift                                 (0)
#define  ATSC_ADDR_2F79_fs2_main_addr_11_8_mask                                  (0x0000000F)
#define  ATSC_ADDR_2F79_fs2_main_addr_11_8(data)                                 (0x0000000F&(data))
#define  ATSC_ADDR_2F79_get_fs2_main_addr_11_8(data)                             (0x0000000F&(data))

#define  ATSC_ADDR_2F7A                                                         0x18157DE8
#define  ATSC_ADDR_2F7A_reg_addr                                                 "0xB8157DE8"
#define  ATSC_ADDR_2F7A_reg                                                      0xB8157DE8
#define  ATSC_ADDR_2F7A_inst_addr                                                "0x052E"
#define  set_ATSC_ADDR_2F7A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F7A_reg)=data)
#define  get_ATSC_ADDR_2F7A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F7A_reg))
#define  ATSC_ADDR_2F7A_fs2_pre_addr_7_0_shift                                   (0)
#define  ATSC_ADDR_2F7A_fs2_pre_addr_7_0_mask                                    (0x000000FF)
#define  ATSC_ADDR_2F7A_fs2_pre_addr_7_0(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_2F7A_get_fs2_pre_addr_7_0(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_2F7B                                                         0x18157DEC
#define  ATSC_ADDR_2F7B_reg_addr                                                 "0xB8157DEC"
#define  ATSC_ADDR_2F7B_reg                                                      0xB8157DEC
#define  ATSC_ADDR_2F7B_inst_addr                                                "0x052F"
#define  set_ATSC_ADDR_2F7B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F7B_reg)=data)
#define  get_ATSC_ADDR_2F7B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F7B_reg))
#define  ATSC_ADDR_2F7B_fs2_pre_addr_11_8_shift                                  (0)
#define  ATSC_ADDR_2F7B_fs2_pre_addr_11_8_mask                                   (0x0000000F)
#define  ATSC_ADDR_2F7B_fs2_pre_addr_11_8(data)                                  (0x0000000F&(data))
#define  ATSC_ADDR_2F7B_get_fs2_pre_addr_11_8(data)                              (0x0000000F&(data))

#define  ATSC_ADDR_2F55                                                         0x18157D54
#define  ATSC_ADDR_2F55_reg_addr                                                 "0xB8157D54"
#define  ATSC_ADDR_2F55_reg                                                      0xB8157D54
#define  ATSC_ADDR_2F55_inst_addr                                                "0x0530"
#define  set_ATSC_ADDR_2F55_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F55_reg)=data)
#define  get_ATSC_ADDR_2F55_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F55_reg))
#define  ATSC_ADDR_2F55_fs2_post_amp_7_0_shift                                   (0)
#define  ATSC_ADDR_2F55_fs2_post_amp_7_0_mask                                    (0x000000FF)
#define  ATSC_ADDR_2F55_fs2_post_amp_7_0(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_2F55_get_fs2_post_amp_7_0(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_2F56                                                         0x18157D58
#define  ATSC_ADDR_2F56_reg_addr                                                 "0xB8157D58"
#define  ATSC_ADDR_2F56_reg                                                      0xB8157D58
#define  ATSC_ADDR_2F56_inst_addr                                                "0x0531"
#define  set_ATSC_ADDR_2F56_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F56_reg)=data)
#define  get_ATSC_ADDR_2F56_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F56_reg))
#define  ATSC_ADDR_2F56_fs2_post_amp_12_8_shift                                  (0)
#define  ATSC_ADDR_2F56_fs2_post_amp_12_8_mask                                   (0x0000001F)
#define  ATSC_ADDR_2F56_fs2_post_amp_12_8(data)                                  (0x0000001F&(data))
#define  ATSC_ADDR_2F56_get_fs2_post_amp_12_8(data)                              (0x0000001F&(data))

#define  ATSC_ADDR_2F57                                                         0x18157D5C
#define  ATSC_ADDR_2F57_reg_addr                                                 "0xB8157D5C"
#define  ATSC_ADDR_2F57_reg                                                      0xB8157D5C
#define  ATSC_ADDR_2F57_inst_addr                                                "0x0532"
#define  set_ATSC_ADDR_2F57_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F57_reg)=data)
#define  get_ATSC_ADDR_2F57_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F57_reg))
#define  ATSC_ADDR_2F57_fs2_post_sam_7_0_shift                                   (0)
#define  ATSC_ADDR_2F57_fs2_post_sam_7_0_mask                                    (0x000000FF)
#define  ATSC_ADDR_2F57_fs2_post_sam_7_0(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_2F57_get_fs2_post_sam_7_0(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_2F58                                                         0x18157D60
#define  ATSC_ADDR_2F58_reg_addr                                                 "0xB8157D60"
#define  ATSC_ADDR_2F58_reg                                                      0xB8157D60
#define  ATSC_ADDR_2F58_inst_addr                                                "0x0533"
#define  set_ATSC_ADDR_2F58_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F58_reg)=data)
#define  get_ATSC_ADDR_2F58_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F58_reg))
#define  ATSC_ADDR_2F58_fs2_post_sam_15_8_shift                                  (0)
#define  ATSC_ADDR_2F58_fs2_post_sam_15_8_mask                                   (0x000000FF)
#define  ATSC_ADDR_2F58_fs2_post_sam_15_8(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2F58_get_fs2_post_sam_15_8(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2F59                                                         0x18157D64
#define  ATSC_ADDR_2F59_reg_addr                                                 "0xB8157D64"
#define  ATSC_ADDR_2F59_reg                                                      0xB8157D64
#define  ATSC_ADDR_2F59_inst_addr                                                "0x0534"
#define  set_ATSC_ADDR_2F59_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F59_reg)=data)
#define  get_ATSC_ADDR_2F59_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F59_reg))
#define  ATSC_ADDR_2F59_fs2_post_sam_20_16_shift                                 (0)
#define  ATSC_ADDR_2F59_fs2_post_sam_20_16_mask                                  (0x0000001F)
#define  ATSC_ADDR_2F59_fs2_post_sam_20_16(data)                                 (0x0000001F&(data))
#define  ATSC_ADDR_2F59_get_fs2_post_sam_20_16(data)                             (0x0000001F&(data))

#define  ATSC_ADDR_2F5A                                                         0x18157D68
#define  ATSC_ADDR_2F5A_reg_addr                                                 "0xB8157D68"
#define  ATSC_ADDR_2F5A_reg                                                      0xB8157D68
#define  ATSC_ADDR_2F5A_inst_addr                                                "0x0535"
#define  set_ATSC_ADDR_2F5A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F5A_reg)=data)
#define  get_ATSC_ADDR_2F5A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F5A_reg))
#define  ATSC_ADDR_2F5A_fs2_post_addr_7_0_shift                                  (0)
#define  ATSC_ADDR_2F5A_fs2_post_addr_7_0_mask                                   (0x000000FF)
#define  ATSC_ADDR_2F5A_fs2_post_addr_7_0(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2F5A_get_fs2_post_addr_7_0(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2F5B                                                         0x18157D6C
#define  ATSC_ADDR_2F5B_reg_addr                                                 "0xB8157D6C"
#define  ATSC_ADDR_2F5B_reg                                                      0xB8157D6C
#define  ATSC_ADDR_2F5B_inst_addr                                                "0x0536"
#define  set_ATSC_ADDR_2F5B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F5B_reg)=data)
#define  get_ATSC_ADDR_2F5B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F5B_reg))
#define  ATSC_ADDR_2F5B_fs2_post_addr_11_8_shift                                 (0)
#define  ATSC_ADDR_2F5B_fs2_post_addr_11_8_mask                                  (0x0000000F)
#define  ATSC_ADDR_2F5B_fs2_post_addr_11_8(data)                                 (0x0000000F&(data))
#define  ATSC_ADDR_2F5B_get_fs2_post_addr_11_8(data)                             (0x0000000F&(data))

#define  ATSC_ADDR_2F4C                                                         0x18157D30
#define  ATSC_ADDR_2F4C_reg_addr                                                 "0xB8157D30"
#define  ATSC_ADDR_2F4C_reg                                                      0xB8157D30
#define  ATSC_ADDR_2F4C_inst_addr                                                "0x0537"
#define  set_ATSC_ADDR_2F4C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F4C_reg)=data)
#define  get_ATSC_ADDR_2F4C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F4C_reg))
#define  ATSC_ADDR_2F4C_fs2_parallel_amp_0_7_0_shift                             (0)
#define  ATSC_ADDR_2F4C_fs2_parallel_amp_0_7_0_mask                              (0x000000FF)
#define  ATSC_ADDR_2F4C_fs2_parallel_amp_0_7_0(data)                             (0x000000FF&(data))
#define  ATSC_ADDR_2F4C_get_fs2_parallel_amp_0_7_0(data)                         (0x000000FF&(data))

#define  ATSC_ADDR_2F4D                                                         0x18157D34
#define  ATSC_ADDR_2F4D_reg_addr                                                 "0xB8157D34"
#define  ATSC_ADDR_2F4D_reg                                                      0xB8157D34
#define  ATSC_ADDR_2F4D_inst_addr                                                "0x0538"
#define  set_ATSC_ADDR_2F4D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F4D_reg)=data)
#define  get_ATSC_ADDR_2F4D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F4D_reg))
#define  ATSC_ADDR_2F4D_fs2_parallel_amp_1_2_0_shift                             (5)
#define  ATSC_ADDR_2F4D_fs2_parallel_amp_0_12_8_shift                            (0)
#define  ATSC_ADDR_2F4D_fs2_parallel_amp_1_2_0_mask                              (0x000000E0)
#define  ATSC_ADDR_2F4D_fs2_parallel_amp_0_12_8_mask                             (0x0000001F)
#define  ATSC_ADDR_2F4D_fs2_parallel_amp_1_2_0(data)                             (0x000000E0&((data)<<5))
#define  ATSC_ADDR_2F4D_fs2_parallel_amp_0_12_8(data)                            (0x0000001F&(data))
#define  ATSC_ADDR_2F4D_get_fs2_parallel_amp_1_2_0(data)                         ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_2F4D_get_fs2_parallel_amp_0_12_8(data)                        (0x0000001F&(data))

#define  ATSC_ADDR_2F4E                                                         0x18157D38
#define  ATSC_ADDR_2F4E_reg_addr                                                 "0xB8157D38"
#define  ATSC_ADDR_2F4E_reg                                                      0xB8157D38
#define  ATSC_ADDR_2F4E_inst_addr                                                "0x0539"
#define  set_ATSC_ADDR_2F4E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F4E_reg)=data)
#define  get_ATSC_ADDR_2F4E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F4E_reg))
#define  ATSC_ADDR_2F4E_fs2_parallel_amp_1_10_3_shift                            (0)
#define  ATSC_ADDR_2F4E_fs2_parallel_amp_1_10_3_mask                             (0x000000FF)
#define  ATSC_ADDR_2F4E_fs2_parallel_amp_1_10_3(data)                            (0x000000FF&(data))
#define  ATSC_ADDR_2F4E_get_fs2_parallel_amp_1_10_3(data)                        (0x000000FF&(data))

#define  ATSC_ADDR_2F42                                                         0x18157D08
#define  ATSC_ADDR_2F42_reg_addr                                                 "0xB8157D08"
#define  ATSC_ADDR_2F42_reg                                                      0xB8157D08
#define  ATSC_ADDR_2F42_inst_addr                                                "0x053A"
#define  set_ATSC_ADDR_2F42_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F42_reg)=data)
#define  get_ATSC_ADDR_2F42_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F42_reg))
#define  ATSC_ADDR_2F42_fs2_parallel_amp_2_5_0_shift                             (2)
#define  ATSC_ADDR_2F42_fs2_parallel_amp_1_12_11_shift                           (0)
#define  ATSC_ADDR_2F42_fs2_parallel_amp_2_5_0_mask                              (0x000000FC)
#define  ATSC_ADDR_2F42_fs2_parallel_amp_1_12_11_mask                            (0x00000003)
#define  ATSC_ADDR_2F42_fs2_parallel_amp_2_5_0(data)                             (0x000000FC&((data)<<2))
#define  ATSC_ADDR_2F42_fs2_parallel_amp_1_12_11(data)                           (0x00000003&(data))
#define  ATSC_ADDR_2F42_get_fs2_parallel_amp_2_5_0(data)                         ((0x000000FC&(data))>>2)
#define  ATSC_ADDR_2F42_get_fs2_parallel_amp_1_12_11(data)                       (0x00000003&(data))

#define  ATSC_ADDR_2F43                                                         0x18157D0C
#define  ATSC_ADDR_2F43_reg_addr                                                 "0xB8157D0C"
#define  ATSC_ADDR_2F43_reg                                                      0xB8157D0C
#define  ATSC_ADDR_2F43_inst_addr                                                "0x053B"
#define  set_ATSC_ADDR_2F43_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F43_reg)=data)
#define  get_ATSC_ADDR_2F43_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F43_reg))
#define  ATSC_ADDR_2F43_fs2_parallel_amp_3_0_shift                               (7)
#define  ATSC_ADDR_2F43_fs2_parallel_amp_2_12_6_shift                            (0)
#define  ATSC_ADDR_2F43_fs2_parallel_amp_3_0_mask                                (0x00000080)
#define  ATSC_ADDR_2F43_fs2_parallel_amp_2_12_6_mask                             (0x0000007F)
#define  ATSC_ADDR_2F43_fs2_parallel_amp_3_0(data)                               (0x00000080&((data)<<7))
#define  ATSC_ADDR_2F43_fs2_parallel_amp_2_12_6(data)                            (0x0000007F&(data))
#define  ATSC_ADDR_2F43_get_fs2_parallel_amp_3_0(data)                           ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2F43_get_fs2_parallel_amp_2_12_6(data)                        (0x0000007F&(data))

#define  ATSC_ADDR_2F44                                                         0x18157D10
#define  ATSC_ADDR_2F44_reg_addr                                                 "0xB8157D10"
#define  ATSC_ADDR_2F44_reg                                                      0xB8157D10
#define  ATSC_ADDR_2F44_inst_addr                                                "0x053C"
#define  set_ATSC_ADDR_2F44_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F44_reg)=data)
#define  get_ATSC_ADDR_2F44_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F44_reg))
#define  ATSC_ADDR_2F44_fs2_parallel_amp_3_8_1_shift                             (0)
#define  ATSC_ADDR_2F44_fs2_parallel_amp_3_8_1_mask                              (0x000000FF)
#define  ATSC_ADDR_2F44_fs2_parallel_amp_3_8_1(data)                             (0x000000FF&(data))
#define  ATSC_ADDR_2F44_get_fs2_parallel_amp_3_8_1(data)                         (0x000000FF&(data))

#define  ATSC_ADDR_2FBD                                                         0x18157EF4
#define  ATSC_ADDR_2FBD_reg_addr                                                 "0xB8157EF4"
#define  ATSC_ADDR_2FBD_reg                                                      0xB8157EF4
#define  ATSC_ADDR_2FBD_inst_addr                                                "0x053D"
#define  set_ATSC_ADDR_2FBD_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FBD_reg)=data)
#define  get_ATSC_ADDR_2FBD_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FBD_reg))
#define  ATSC_ADDR_2FBD_fs2_parallel_addr_0_3_0_shift                            (4)
#define  ATSC_ADDR_2FBD_fs2_parallel_amp_3_12_9_shift                            (0)
#define  ATSC_ADDR_2FBD_fs2_parallel_addr_0_3_0_mask                             (0x000000F0)
#define  ATSC_ADDR_2FBD_fs2_parallel_amp_3_12_9_mask                             (0x0000000F)
#define  ATSC_ADDR_2FBD_fs2_parallel_addr_0_3_0(data)                            (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2FBD_fs2_parallel_amp_3_12_9(data)                            (0x0000000F&(data))
#define  ATSC_ADDR_2FBD_get_fs2_parallel_addr_0_3_0(data)                        ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2FBD_get_fs2_parallel_amp_3_12_9(data)                        (0x0000000F&(data))

#define  ATSC_ADDR_2FBE                                                         0x18157EF8
#define  ATSC_ADDR_2FBE_reg_addr                                                 "0xB8157EF8"
#define  ATSC_ADDR_2FBE_reg                                                      0xB8157EF8
#define  ATSC_ADDR_2FBE_inst_addr                                                "0x053E"
#define  set_ATSC_ADDR_2FBE_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FBE_reg)=data)
#define  get_ATSC_ADDR_2FBE_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FBE_reg))
#define  ATSC_ADDR_2FBE_fs2_parallel_addr_1_0_shift                              (7)
#define  ATSC_ADDR_2FBE_fs2_parallel_addr_0_10_4_shift                           (0)
#define  ATSC_ADDR_2FBE_fs2_parallel_addr_1_0_mask                               (0x00000080)
#define  ATSC_ADDR_2FBE_fs2_parallel_addr_0_10_4_mask                            (0x0000007F)
#define  ATSC_ADDR_2FBE_fs2_parallel_addr_1_0(data)                              (0x00000080&((data)<<7))
#define  ATSC_ADDR_2FBE_fs2_parallel_addr_0_10_4(data)                           (0x0000007F&(data))
#define  ATSC_ADDR_2FBE_get_fs2_parallel_addr_1_0(data)                          ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2FBE_get_fs2_parallel_addr_0_10_4(data)                       (0x0000007F&(data))

#define  ATSC_ADDR_2FD5                                                         0x18157F54
#define  ATSC_ADDR_2FD5_reg_addr                                                 "0xB8157F54"
#define  ATSC_ADDR_2FD5_reg                                                      0xB8157F54
#define  ATSC_ADDR_2FD5_inst_addr                                                "0x053F"
#define  set_ATSC_ADDR_2FD5_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FD5_reg)=data)
#define  get_ATSC_ADDR_2FD5_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FD5_reg))
#define  ATSC_ADDR_2FD5_fs2_parallel_addr_3_11_shift                             (3)
#define  ATSC_ADDR_2FD5_fs2_parallel_addr_2_11_shift                             (2)
#define  ATSC_ADDR_2FD5_fs2_parallel_addr_1_11_shift                             (1)
#define  ATSC_ADDR_2FD5_fs2_parallel_addr_0_11_shift                             (0)
#define  ATSC_ADDR_2FD5_fs2_parallel_addr_3_11_mask                              (0x00000008)
#define  ATSC_ADDR_2FD5_fs2_parallel_addr_2_11_mask                              (0x00000004)
#define  ATSC_ADDR_2FD5_fs2_parallel_addr_1_11_mask                              (0x00000002)
#define  ATSC_ADDR_2FD5_fs2_parallel_addr_0_11_mask                              (0x00000001)
#define  ATSC_ADDR_2FD5_fs2_parallel_addr_3_11(data)                             (0x00000008&((data)<<3))
#define  ATSC_ADDR_2FD5_fs2_parallel_addr_2_11(data)                             (0x00000004&((data)<<2))
#define  ATSC_ADDR_2FD5_fs2_parallel_addr_1_11(data)                             (0x00000002&((data)<<1))
#define  ATSC_ADDR_2FD5_fs2_parallel_addr_0_11(data)                             (0x00000001&(data))
#define  ATSC_ADDR_2FD5_get_fs2_parallel_addr_3_11(data)                         ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2FD5_get_fs2_parallel_addr_2_11(data)                         ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2FD5_get_fs2_parallel_addr_1_11(data)                         ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2FD5_get_fs2_parallel_addr_0_11(data)                         (0x00000001&(data))

#define  ATSC_ADDR_2FBF                                                         0x18157EFC
#define  ATSC_ADDR_2FBF_reg_addr                                                 "0xB8157EFC"
#define  ATSC_ADDR_2FBF_reg                                                      0xB8157EFC
#define  ATSC_ADDR_2FBF_inst_addr                                                "0x0540"
#define  set_ATSC_ADDR_2FBF_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FBF_reg)=data)
#define  get_ATSC_ADDR_2FBF_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FBF_reg))
#define  ATSC_ADDR_2FBF_fs2_parallel_addr_1_8_1_shift                            (0)
#define  ATSC_ADDR_2FBF_fs2_parallel_addr_1_8_1_mask                             (0x000000FF)
#define  ATSC_ADDR_2FBF_fs2_parallel_addr_1_8_1(data)                            (0x000000FF&(data))
#define  ATSC_ADDR_2FBF_get_fs2_parallel_addr_1_8_1(data)                        (0x000000FF&(data))

#define  ATSC_ADDR_2FC0                                                         0x18157F00
#define  ATSC_ADDR_2FC0_reg_addr                                                 "0xB8157F00"
#define  ATSC_ADDR_2FC0_reg                                                      0xB8157F00
#define  ATSC_ADDR_2FC0_inst_addr                                                "0x0541"
#define  set_ATSC_ADDR_2FC0_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FC0_reg)=data)
#define  get_ATSC_ADDR_2FC0_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FC0_reg))
#define  ATSC_ADDR_2FC0_fs2_parallel_addr_2_5_0_shift                            (2)
#define  ATSC_ADDR_2FC0_fs2_parallel_addr_1_10_9_shift                           (0)
#define  ATSC_ADDR_2FC0_fs2_parallel_addr_2_5_0_mask                             (0x000000FC)
#define  ATSC_ADDR_2FC0_fs2_parallel_addr_1_10_9_mask                            (0x00000003)
#define  ATSC_ADDR_2FC0_fs2_parallel_addr_2_5_0(data)                            (0x000000FC&((data)<<2))
#define  ATSC_ADDR_2FC0_fs2_parallel_addr_1_10_9(data)                           (0x00000003&(data))
#define  ATSC_ADDR_2FC0_get_fs2_parallel_addr_2_5_0(data)                        ((0x000000FC&(data))>>2)
#define  ATSC_ADDR_2FC0_get_fs2_parallel_addr_1_10_9(data)                       (0x00000003&(data))

#define  ATSC_ADDR_2FD0                                                         0x18157F40
#define  ATSC_ADDR_2FD0_reg_addr                                                 "0xB8157F40"
#define  ATSC_ADDR_2FD0_reg                                                      0xB8157F40
#define  ATSC_ADDR_2FD0_inst_addr                                                "0x0542"
#define  set_ATSC_ADDR_2FD0_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FD0_reg)=data)
#define  get_ATSC_ADDR_2FD0_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FD0_reg))
#define  ATSC_ADDR_2FD0_fs2_parallel_addr_3_2_0_shift                            (5)
#define  ATSC_ADDR_2FD0_fs2_parallel_addr_2_10_6_shift                           (0)
#define  ATSC_ADDR_2FD0_fs2_parallel_addr_3_2_0_mask                             (0x000000E0)
#define  ATSC_ADDR_2FD0_fs2_parallel_addr_2_10_6_mask                            (0x0000001F)
#define  ATSC_ADDR_2FD0_fs2_parallel_addr_3_2_0(data)                            (0x000000E0&((data)<<5))
#define  ATSC_ADDR_2FD0_fs2_parallel_addr_2_10_6(data)                           (0x0000001F&(data))
#define  ATSC_ADDR_2FD0_get_fs2_parallel_addr_3_2_0(data)                        ((0x000000E0&(data))>>5)
#define  ATSC_ADDR_2FD0_get_fs2_parallel_addr_2_10_6(data)                       (0x0000001F&(data))

#define  ATSC_ADDR_2FD4                                                         0x18157F50
#define  ATSC_ADDR_2FD4_reg_addr                                                 "0xB8157F50"
#define  ATSC_ADDR_2FD4_reg                                                      0xB8157F50
#define  ATSC_ADDR_2FD4_inst_addr                                                "0x0543"
#define  set_ATSC_ADDR_2FD4_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FD4_reg)=data)
#define  get_ATSC_ADDR_2FD4_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FD4_reg))
#define  ATSC_ADDR_2FD4_fs2_parallel_addr_3_10_3_shift                           (0)
#define  ATSC_ADDR_2FD4_fs2_parallel_addr_3_10_3_mask                            (0x000000FF)
#define  ATSC_ADDR_2FD4_fs2_parallel_addr_3_10_3(data)                           (0x000000FF&(data))
#define  ATSC_ADDR_2FD4_get_fs2_parallel_addr_3_10_3(data)                       (0x000000FF&(data))

#define  ATSC_ADDR_2F7C                                                         0x18157DF0
#define  ATSC_ADDR_2F7C_reg_addr                                                 "0xB8157DF0"
#define  ATSC_ADDR_2F7C_reg                                                      0xB8157DF0
#define  ATSC_ADDR_2F7C_inst_addr                                                "0x0544"
#define  set_ATSC_ADDR_2F7C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F7C_reg)=data)
#define  get_ATSC_ADDR_2F7C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F7C_reg))
#define  ATSC_ADDR_2F7C_state_cnt1_shift                                         (0)
#define  ATSC_ADDR_2F7C_state_cnt1_mask                                          (0x000000FF)
#define  ATSC_ADDR_2F7C_state_cnt1(data)                                         (0x000000FF&(data))
#define  ATSC_ADDR_2F7C_get_state_cnt1(data)                                     (0x000000FF&(data))

#define  ATSC_ADDR_2F7D                                                         0x18157DF4
#define  ATSC_ADDR_2F7D_reg_addr                                                 "0xB8157DF4"
#define  ATSC_ADDR_2F7D_reg                                                      0xB8157DF4
#define  ATSC_ADDR_2F7D_inst_addr                                                "0x0545"
#define  set_ATSC_ADDR_2F7D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F7D_reg)=data)
#define  get_ATSC_ADDR_2F7D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F7D_reg))
#define  ATSC_ADDR_2F7D_state_cnt2_shift                                         (0)
#define  ATSC_ADDR_2F7D_state_cnt2_mask                                          (0x000000FF)
#define  ATSC_ADDR_2F7D_state_cnt2(data)                                         (0x000000FF&(data))
#define  ATSC_ADDR_2F7D_get_state_cnt2(data)                                     (0x000000FF&(data))

#define  ATSC_ADDR_2F7E                                                         0x18157DF8
#define  ATSC_ADDR_2F7E_reg_addr                                                 "0xB8157DF8"
#define  ATSC_ADDR_2F7E_reg                                                      0xB8157DF8
#define  ATSC_ADDR_2F7E_inst_addr                                                "0x0546"
#define  set_ATSC_ADDR_2F7E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F7E_reg)=data)
#define  get_ATSC_ADDR_2F7E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F7E_reg))
#define  ATSC_ADDR_2F7E_cr_offset_leak_acc_7_0_shift                             (0)
#define  ATSC_ADDR_2F7E_cr_offset_leak_acc_7_0_mask                              (0x000000FF)
#define  ATSC_ADDR_2F7E_cr_offset_leak_acc_7_0(data)                             (0x000000FF&(data))
#define  ATSC_ADDR_2F7E_get_cr_offset_leak_acc_7_0(data)                         (0x000000FF&(data))

#define  ATSC_ADDR_2F7F                                                         0x18157DFC
#define  ATSC_ADDR_2F7F_reg_addr                                                 "0xB8157DFC"
#define  ATSC_ADDR_2F7F_reg                                                      0xB8157DFC
#define  ATSC_ADDR_2F7F_inst_addr                                                "0x0547"
#define  set_ATSC_ADDR_2F7F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F7F_reg)=data)
#define  get_ATSC_ADDR_2F7F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F7F_reg))
#define  ATSC_ADDR_2F7F_cr_offset_leak_acc_12_8_shift                            (0)
#define  ATSC_ADDR_2F7F_cr_offset_leak_acc_12_8_mask                             (0x0000001F)
#define  ATSC_ADDR_2F7F_cr_offset_leak_acc_12_8(data)                            (0x0000001F&(data))
#define  ATSC_ADDR_2F7F_get_cr_offset_leak_acc_12_8(data)                        (0x0000001F&(data))

#define  ATSC_ADDR_2F80                                                         0x18157E00
#define  ATSC_ADDR_2F80_reg_addr                                                 "0xB8157E00"
#define  ATSC_ADDR_2F80_reg                                                      0xB8157E00
#define  ATSC_ADDR_2F80_inst_addr                                                "0x0548"
#define  set_ATSC_ADDR_2F80_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F80_reg)=data)
#define  get_ATSC_ADDR_2F80_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F80_reg))
#define  ATSC_ADDR_2F80_if_offset_7_0_shift                                      (0)
#define  ATSC_ADDR_2F80_if_offset_7_0_mask                                       (0x000000FF)
#define  ATSC_ADDR_2F80_if_offset_7_0(data)                                      (0x000000FF&(data))
#define  ATSC_ADDR_2F80_get_if_offset_7_0(data)                                  (0x000000FF&(data))

#define  ATSC_ADDR_2F81                                                         0x18157E04
#define  ATSC_ADDR_2F81_reg_addr                                                 "0xB8157E04"
#define  ATSC_ADDR_2F81_reg                                                      0xB8157E04
#define  ATSC_ADDR_2F81_inst_addr                                                "0x0549"
#define  set_ATSC_ADDR_2F81_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F81_reg)=data)
#define  get_ATSC_ADDR_2F81_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F81_reg))
#define  ATSC_ADDR_2F81_if_offset_15_8_shift                                     (0)
#define  ATSC_ADDR_2F81_if_offset_15_8_mask                                      (0x000000FF)
#define  ATSC_ADDR_2F81_if_offset_15_8(data)                                     (0x000000FF&(data))
#define  ATSC_ADDR_2F81_get_if_offset_15_8(data)                                 (0x000000FF&(data))

#define  ATSC_ADDR_2F82                                                         0x18157E08
#define  ATSC_ADDR_2F82_reg_addr                                                 "0xB8157E08"
#define  ATSC_ADDR_2F82_reg                                                      0xB8157E08
#define  ATSC_ADDR_2F82_inst_addr                                                "0x054A"
#define  set_ATSC_ADDR_2F82_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F82_reg)=data)
#define  get_ATSC_ADDR_2F82_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F82_reg))
#define  ATSC_ADDR_2F82_cr_offset_1_0_shift                                      (6)
#define  ATSC_ADDR_2F82_cr_in_lock_ind_shift                                     (5)
#define  ATSC_ADDR_2F82_cr_large_freq_ind_shift                                  (4)
#define  ATSC_ADDR_2F82_cr_unlock_ind_shift                                      (3)
#define  ATSC_ADDR_2F82_cr_lock_ind_shift                                        (2)
#define  ATSC_ADDR_2F82_if_offset_17_16_shift                                    (0)
#define  ATSC_ADDR_2F82_cr_offset_1_0_mask                                       (0x000000C0)
#define  ATSC_ADDR_2F82_cr_in_lock_ind_mask                                      (0x00000020)
#define  ATSC_ADDR_2F82_cr_large_freq_ind_mask                                   (0x00000010)
#define  ATSC_ADDR_2F82_cr_unlock_ind_mask                                       (0x00000008)
#define  ATSC_ADDR_2F82_cr_lock_ind_mask                                         (0x00000004)
#define  ATSC_ADDR_2F82_if_offset_17_16_mask                                     (0x00000003)
#define  ATSC_ADDR_2F82_cr_offset_1_0(data)                                      (0x000000C0&((data)<<6))
#define  ATSC_ADDR_2F82_cr_in_lock_ind(data)                                     (0x00000020&((data)<<5))
#define  ATSC_ADDR_2F82_cr_large_freq_ind(data)                                  (0x00000010&((data)<<4))
#define  ATSC_ADDR_2F82_cr_unlock_ind(data)                                      (0x00000008&((data)<<3))
#define  ATSC_ADDR_2F82_cr_lock_ind(data)                                        (0x00000004&((data)<<2))
#define  ATSC_ADDR_2F82_if_offset_17_16(data)                                    (0x00000003&(data))
#define  ATSC_ADDR_2F82_get_cr_offset_1_0(data)                                  ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_2F82_get_cr_in_lock_ind(data)                                 ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2F82_get_cr_large_freq_ind(data)                              ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2F82_get_cr_unlock_ind(data)                                  ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2F82_get_cr_lock_ind(data)                                    ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2F82_get_if_offset_17_16(data)                                (0x00000003&(data))

#define  ATSC_ADDR_2F83                                                         0x18157E0C
#define  ATSC_ADDR_2F83_reg_addr                                                 "0xB8157E0C"
#define  ATSC_ADDR_2F83_reg                                                      0xB8157E0C
#define  ATSC_ADDR_2F83_inst_addr                                                "0x054B"
#define  set_ATSC_ADDR_2F83_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F83_reg)=data)
#define  get_ATSC_ADDR_2F83_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F83_reg))
#define  ATSC_ADDR_2F83_cr_offset_9_2_shift                                      (0)
#define  ATSC_ADDR_2F83_cr_offset_9_2_mask                                       (0x000000FF)
#define  ATSC_ADDR_2F83_cr_offset_9_2(data)                                      (0x000000FF&(data))
#define  ATSC_ADDR_2F83_get_cr_offset_9_2(data)                                  (0x000000FF&(data))

#define  ATSC_ADDR_2F84                                                         0x18157E10
#define  ATSC_ADDR_2F84_reg_addr                                                 "0xB8157E10"
#define  ATSC_ADDR_2F84_reg                                                      0xB8157E10
#define  ATSC_ADDR_2F84_inst_addr                                                "0x054C"
#define  set_ATSC_ADDR_2F84_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F84_reg)=data)
#define  get_ATSC_ADDR_2F84_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F84_reg))
#define  ATSC_ADDR_2F84_cr_offset_17_10_shift                                    (0)
#define  ATSC_ADDR_2F84_cr_offset_17_10_mask                                     (0x000000FF)
#define  ATSC_ADDR_2F84_cr_offset_17_10(data)                                    (0x000000FF&(data))
#define  ATSC_ADDR_2F84_get_cr_offset_17_10(data)                                (0x000000FF&(data))

#define  ATSC_ADDR_2F85                                                         0x18157E14
#define  ATSC_ADDR_2F85_reg_addr                                                 "0xB8157E14"
#define  ATSC_ADDR_2F85_reg                                                      0xB8157E14
#define  ATSC_ADDR_2F85_inst_addr                                                "0x054D"
#define  set_ATSC_ADDR_2F85_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F85_reg)=data)
#define  get_ATSC_ADDR_2F85_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F85_reg))
#define  ATSC_ADDR_2F85_cr_offset_25_18_shift                                    (0)
#define  ATSC_ADDR_2F85_cr_offset_25_18_mask                                     (0x000000FF)
#define  ATSC_ADDR_2F85_cr_offset_25_18(data)                                    (0x000000FF&(data))
#define  ATSC_ADDR_2F85_get_cr_offset_25_18(data)                                (0x000000FF&(data))

#define  ATSC_ADDR_2F86                                                         0x18157E18
#define  ATSC_ADDR_2F86_reg_addr                                                 "0xB8157E18"
#define  ATSC_ADDR_2F86_reg                                                      0xB8157E18
#define  ATSC_ADDR_2F86_inst_addr                                                "0x054E"
#define  set_ATSC_ADDR_2F86_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F86_reg)=data)
#define  get_ATSC_ADDR_2F86_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F86_reg))
#define  ATSC_ADDR_2F86_cr_offset_32_26_shift                                    (0)
#define  ATSC_ADDR_2F86_cr_offset_32_26_mask                                     (0x0000007F)
#define  ATSC_ADDR_2F86_cr_offset_32_26(data)                                    (0x0000007F&(data))
#define  ATSC_ADDR_2F86_get_cr_offset_32_26(data)                                (0x0000007F&(data))

#define  ATSC_ADDR_2F87                                                         0x18157E1C
#define  ATSC_ADDR_2F87_reg_addr                                                 "0xB8157E1C"
#define  ATSC_ADDR_2F87_reg                                                      0xB8157E1C
#define  ATSC_ADDR_2F87_inst_addr                                                "0x054F"
#define  set_ATSC_ADDR_2F87_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F87_reg)=data)
#define  get_ATSC_ADDR_2F87_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F87_reg))
#define  ATSC_ADDR_2F87_cr_lock_det_out_qtz_re_7_0_shift                         (0)
#define  ATSC_ADDR_2F87_cr_lock_det_out_qtz_re_7_0_mask                          (0x000000FF)
#define  ATSC_ADDR_2F87_cr_lock_det_out_qtz_re_7_0(data)                         (0x000000FF&(data))
#define  ATSC_ADDR_2F87_get_cr_lock_det_out_qtz_re_7_0(data)                     (0x000000FF&(data))

#define  ATSC_ADDR_2F88                                                         0x18157E20
#define  ATSC_ADDR_2F88_reg_addr                                                 "0xB8157E20"
#define  ATSC_ADDR_2F88_reg                                                      0xB8157E20
#define  ATSC_ADDR_2F88_inst_addr                                                "0x0550"
#define  set_ATSC_ADDR_2F88_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F88_reg)=data)
#define  get_ATSC_ADDR_2F88_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F88_reg))
#define  ATSC_ADDR_2F88_cr_lock_det_out_qtz_im_1_0_shift                         (6)
#define  ATSC_ADDR_2F88_cr_lock_det_out_qtz_re_13_8_shift                        (0)
#define  ATSC_ADDR_2F88_cr_lock_det_out_qtz_im_1_0_mask                          (0x000000C0)
#define  ATSC_ADDR_2F88_cr_lock_det_out_qtz_re_13_8_mask                         (0x0000003F)
#define  ATSC_ADDR_2F88_cr_lock_det_out_qtz_im_1_0(data)                         (0x000000C0&((data)<<6))
#define  ATSC_ADDR_2F88_cr_lock_det_out_qtz_re_13_8(data)                        (0x0000003F&(data))
#define  ATSC_ADDR_2F88_get_cr_lock_det_out_qtz_im_1_0(data)                     ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_2F88_get_cr_lock_det_out_qtz_re_13_8(data)                    (0x0000003F&(data))

#define  ATSC_ADDR_2F89                                                         0x18157E24
#define  ATSC_ADDR_2F89_reg_addr                                                 "0xB8157E24"
#define  ATSC_ADDR_2F89_reg                                                      0xB8157E24
#define  ATSC_ADDR_2F89_inst_addr                                                "0x0551"
#define  set_ATSC_ADDR_2F89_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F89_reg)=data)
#define  get_ATSC_ADDR_2F89_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F89_reg))
#define  ATSC_ADDR_2F89_cr_lock_det_out_qtz_im_9_2_shift                         (0)
#define  ATSC_ADDR_2F89_cr_lock_det_out_qtz_im_9_2_mask                          (0x000000FF)
#define  ATSC_ADDR_2F89_cr_lock_det_out_qtz_im_9_2(data)                         (0x000000FF&(data))
#define  ATSC_ADDR_2F89_get_cr_lock_det_out_qtz_im_9_2(data)                     (0x000000FF&(data))

#define  ATSC_ADDR_2F8A                                                         0x18157E28
#define  ATSC_ADDR_2F8A_reg_addr                                                 "0xB8157E28"
#define  ATSC_ADDR_2F8A_reg                                                      0xB8157E28
#define  ATSC_ADDR_2F8A_inst_addr                                                "0x0552"
#define  set_ATSC_ADDR_2F8A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F8A_reg)=data)
#define  get_ATSC_ADDR_2F8A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F8A_reg))
#define  ATSC_ADDR_2F8A_cr_pwr_est_3_0_shift                                     (4)
#define  ATSC_ADDR_2F8A_cr_lock_det_out_qtz_im_13_10_shift                       (0)
#define  ATSC_ADDR_2F8A_cr_pwr_est_3_0_mask                                      (0x000000F0)
#define  ATSC_ADDR_2F8A_cr_lock_det_out_qtz_im_13_10_mask                        (0x0000000F)
#define  ATSC_ADDR_2F8A_cr_pwr_est_3_0(data)                                     (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2F8A_cr_lock_det_out_qtz_im_13_10(data)                       (0x0000000F&(data))
#define  ATSC_ADDR_2F8A_get_cr_pwr_est_3_0(data)                                 ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2F8A_get_cr_lock_det_out_qtz_im_13_10(data)                   (0x0000000F&(data))

#define  ATSC_ADDR_2F8B                                                         0x18157E2C
#define  ATSC_ADDR_2F8B_reg_addr                                                 "0xB8157E2C"
#define  ATSC_ADDR_2F8B_reg                                                      0xB8157E2C
#define  ATSC_ADDR_2F8B_inst_addr                                                "0x0553"
#define  set_ATSC_ADDR_2F8B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F8B_reg)=data)
#define  get_ATSC_ADDR_2F8B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F8B_reg))
#define  ATSC_ADDR_2F8B_cr_pwr_est_11_4_shift                                    (0)
#define  ATSC_ADDR_2F8B_cr_pwr_est_11_4_mask                                     (0x000000FF)
#define  ATSC_ADDR_2F8B_cr_pwr_est_11_4(data)                                    (0x000000FF&(data))
#define  ATSC_ADDR_2F8B_get_cr_pwr_est_11_4(data)                                (0x000000FF&(data))

#define  ATSC_ADDR_2F8C                                                         0x18157E30
#define  ATSC_ADDR_2F8C_reg_addr                                                 "0xB8157E30"
#define  ATSC_ADDR_2F8C_reg                                                      0xB8157E30
#define  ATSC_ADDR_2F8C_inst_addr                                                "0x0554"
#define  set_ATSC_ADDR_2F8C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F8C_reg)=data)
#define  get_ATSC_ADDR_2F8C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F8C_reg))
#define  ATSC_ADDR_2F8C_cr_pwr_est_19_12_shift                                   (0)
#define  ATSC_ADDR_2F8C_cr_pwr_est_19_12_mask                                    (0x000000FF)
#define  ATSC_ADDR_2F8C_cr_pwr_est_19_12(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_2F8C_get_cr_pwr_est_19_12(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_2F8D                                                         0x18157E34
#define  ATSC_ADDR_2F8D_reg_addr                                                 "0xB8157E34"
#define  ATSC_ADDR_2F8D_reg                                                      0xB8157E34
#define  ATSC_ADDR_2F8D_inst_addr                                                "0x0555"
#define  set_ATSC_ADDR_2F8D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F8D_reg)=data)
#define  get_ATSC_ADDR_2F8D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F8D_reg))
#define  ATSC_ADDR_2F8D_cr_pwr_est_26_20_shift                                   (0)
#define  ATSC_ADDR_2F8D_cr_pwr_est_26_20_mask                                    (0x0000007F)
#define  ATSC_ADDR_2F8D_cr_pwr_est_26_20(data)                                   (0x0000007F&(data))
#define  ATSC_ADDR_2F8D_get_cr_pwr_est_26_20(data)                               (0x0000007F&(data))

#define  ATSC_ADDR_2F8E                                                         0x18157E38
#define  ATSC_ADDR_2F8E_reg_addr                                                 "0xB8157E38"
#define  ATSC_ADDR_2F8E_reg                                                      0xB8157E38
#define  ATSC_ADDR_2F8E_inst_addr                                                "0x0556"
#define  set_ATSC_ADDR_2F8E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F8E_reg)=data)
#define  get_ATSC_ADDR_2F8E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F8E_reg))
#define  ATSC_ADDR_2F8E_cr_out_re_7_0_shift                                      (0)
#define  ATSC_ADDR_2F8E_cr_out_re_7_0_mask                                       (0x000000FF)
#define  ATSC_ADDR_2F8E_cr_out_re_7_0(data)                                      (0x000000FF&(data))
#define  ATSC_ADDR_2F8E_get_cr_out_re_7_0(data)                                  (0x000000FF&(data))

#define  ATSC_ADDR_2F8F                                                         0x18157E3C
#define  ATSC_ADDR_2F8F_reg_addr                                                 "0xB8157E3C"
#define  ATSC_ADDR_2F8F_reg                                                      0xB8157E3C
#define  ATSC_ADDR_2F8F_inst_addr                                                "0x0557"
#define  set_ATSC_ADDR_2F8F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F8F_reg)=data)
#define  get_ATSC_ADDR_2F8F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F8F_reg))
#define  ATSC_ADDR_2F8F_cr_out_im_3_0_shift                                      (4)
#define  ATSC_ADDR_2F8F_cr_out_re_11_8_shift                                     (0)
#define  ATSC_ADDR_2F8F_cr_out_im_3_0_mask                                       (0x000000F0)
#define  ATSC_ADDR_2F8F_cr_out_re_11_8_mask                                      (0x0000000F)
#define  ATSC_ADDR_2F8F_cr_out_im_3_0(data)                                      (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2F8F_cr_out_re_11_8(data)                                     (0x0000000F&(data))
#define  ATSC_ADDR_2F8F_get_cr_out_im_3_0(data)                                  ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2F8F_get_cr_out_re_11_8(data)                                 (0x0000000F&(data))

#define  ATSC_ADDR_2F90                                                         0x18157E40
#define  ATSC_ADDR_2F90_reg_addr                                                 "0xB8157E40"
#define  ATSC_ADDR_2F90_reg                                                      0xB8157E40
#define  ATSC_ADDR_2F90_inst_addr                                                "0x0558"
#define  set_ATSC_ADDR_2F90_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F90_reg)=data)
#define  get_ATSC_ADDR_2F90_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F90_reg))
#define  ATSC_ADDR_2F90_cr_out_im_11_4_shift                                     (0)
#define  ATSC_ADDR_2F90_cr_out_im_11_4_mask                                      (0x000000FF)
#define  ATSC_ADDR_2F90_cr_out_im_11_4(data)                                     (0x000000FF&(data))
#define  ATSC_ADDR_2F90_get_cr_out_im_11_4(data)                                 (0x000000FF&(data))

#define  ATSC_ADDR_2F91                                                         0x18157E44
#define  ATSC_ADDR_2F91_reg_addr                                                 "0xB8157E44"
#define  ATSC_ADDR_2F91_reg                                                      0xB8157E44
#define  ATSC_ADDR_2F91_inst_addr                                                "0x0559"
#define  set_ATSC_ADDR_2F91_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F91_reg)=data)
#define  get_ATSC_ADDR_2F91_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F91_reg))
#define  ATSC_ADDR_2F91_cr_dr1_re_7_0_shift                                      (0)
#define  ATSC_ADDR_2F91_cr_dr1_re_7_0_mask                                       (0x000000FF)
#define  ATSC_ADDR_2F91_cr_dr1_re_7_0(data)                                      (0x000000FF&(data))
#define  ATSC_ADDR_2F91_get_cr_dr1_re_7_0(data)                                  (0x000000FF&(data))

#define  ATSC_ADDR_2F92                                                         0x18157E48
#define  ATSC_ADDR_2F92_reg_addr                                                 "0xB8157E48"
#define  ATSC_ADDR_2F92_reg                                                      0xB8157E48
#define  ATSC_ADDR_2F92_inst_addr                                                "0x055A"
#define  set_ATSC_ADDR_2F92_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F92_reg)=data)
#define  get_ATSC_ADDR_2F92_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F92_reg))
#define  ATSC_ADDR_2F92_cr_dr1_im_3_0_shift                                      (4)
#define  ATSC_ADDR_2F92_cr_dr1_re_11_8_shift                                     (0)
#define  ATSC_ADDR_2F92_cr_dr1_im_3_0_mask                                       (0x000000F0)
#define  ATSC_ADDR_2F92_cr_dr1_re_11_8_mask                                      (0x0000000F)
#define  ATSC_ADDR_2F92_cr_dr1_im_3_0(data)                                      (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2F92_cr_dr1_re_11_8(data)                                     (0x0000000F&(data))
#define  ATSC_ADDR_2F92_get_cr_dr1_im_3_0(data)                                  ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2F92_get_cr_dr1_re_11_8(data)                                 (0x0000000F&(data))

#define  ATSC_ADDR_2F93                                                         0x18157E4C
#define  ATSC_ADDR_2F93_reg_addr                                                 "0xB8157E4C"
#define  ATSC_ADDR_2F93_reg                                                      0xB8157E4C
#define  ATSC_ADDR_2F93_inst_addr                                                "0x055B"
#define  set_ATSC_ADDR_2F93_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F93_reg)=data)
#define  get_ATSC_ADDR_2F93_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F93_reg))
#define  ATSC_ADDR_2F93_cr_dr1_im_11_4_shift                                     (0)
#define  ATSC_ADDR_2F93_cr_dr1_im_11_4_mask                                      (0x000000FF)
#define  ATSC_ADDR_2F93_cr_dr1_im_11_4(data)                                     (0x000000FF&(data))
#define  ATSC_ADDR_2F93_get_cr_dr1_im_11_4(data)                                 (0x000000FF&(data))

#define  ATSC_ADDR_2F94                                                         0x18157E50
#define  ATSC_ADDR_2F94_reg_addr                                                 "0xB8157E50"
#define  ATSC_ADDR_2F94_reg                                                      0xB8157E50
#define  ATSC_ADDR_2F94_inst_addr                                                "0x055C"
#define  set_ATSC_ADDR_2F94_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F94_reg)=data)
#define  get_ATSC_ADDR_2F94_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F94_reg))
#define  ATSC_ADDR_2F94_cr_phase_comp_7_0_shift                                  (0)
#define  ATSC_ADDR_2F94_cr_phase_comp_7_0_mask                                   (0x000000FF)
#define  ATSC_ADDR_2F94_cr_phase_comp_7_0(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2F94_get_cr_phase_comp_7_0(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2F95                                                         0x18157E54
#define  ATSC_ADDR_2F95_reg_addr                                                 "0xB8157E54"
#define  ATSC_ADDR_2F95_reg                                                      0xB8157E54
#define  ATSC_ADDR_2F95_inst_addr                                                "0x055D"
#define  set_ATSC_ADDR_2F95_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F95_reg)=data)
#define  get_ATSC_ADDR_2F95_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F95_reg))
#define  ATSC_ADDR_2F95_cr_comp_exp_shift                                        (3)
#define  ATSC_ADDR_2F95_cr_comp_man_shift                                        (2)
#define  ATSC_ADDR_2F95_cr_phase_comp_9_8_shift                                  (0)
#define  ATSC_ADDR_2F95_cr_comp_exp_mask                                         (0x00000038)
#define  ATSC_ADDR_2F95_cr_comp_man_mask                                         (0x00000004)
#define  ATSC_ADDR_2F95_cr_phase_comp_9_8_mask                                   (0x00000003)
#define  ATSC_ADDR_2F95_cr_comp_exp(data)                                        (0x00000038&((data)<<3))
#define  ATSC_ADDR_2F95_cr_comp_man(data)                                        (0x00000004&((data)<<2))
#define  ATSC_ADDR_2F95_cr_phase_comp_9_8(data)                                  (0x00000003&(data))
#define  ATSC_ADDR_2F95_get_cr_comp_exp(data)                                    ((0x00000038&(data))>>3)
#define  ATSC_ADDR_2F95_get_cr_comp_man(data)                                    ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2F95_get_cr_phase_comp_9_8(data)                              (0x00000003&(data))

#define  ATSC_ADDR_2F96                                                         0x18157E58
#define  ATSC_ADDR_2F96_reg_addr                                                 "0xB8157E58"
#define  ATSC_ADDR_2F96_reg                                                      0xB8157E58
#define  ATSC_ADDR_2F96_inst_addr                                                "0x055E"
#define  set_ATSC_ADDR_2F96_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F96_reg)=data)
#define  get_ATSC_ADDR_2F96_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F96_reg))
#define  ATSC_ADDR_2F96_dagc_out_d_re_7_0_shift                                  (0)
#define  ATSC_ADDR_2F96_dagc_out_d_re_7_0_mask                                   (0x000000FF)
#define  ATSC_ADDR_2F96_dagc_out_d_re_7_0(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2F96_get_dagc_out_d_re_7_0(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2F97                                                         0x18157E5C
#define  ATSC_ADDR_2F97_reg_addr                                                 "0xB8157E5C"
#define  ATSC_ADDR_2F97_reg                                                      0xB8157E5C
#define  ATSC_ADDR_2F97_inst_addr                                                "0x055F"
#define  set_ATSC_ADDR_2F97_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F97_reg)=data)
#define  get_ATSC_ADDR_2F97_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F97_reg))
#define  ATSC_ADDR_2F97_dagc_out_d_im_3_0_shift                                  (4)
#define  ATSC_ADDR_2F97_dagc_out_d_re_11_8_shift                                 (0)
#define  ATSC_ADDR_2F97_dagc_out_d_im_3_0_mask                                   (0x000000F0)
#define  ATSC_ADDR_2F97_dagc_out_d_re_11_8_mask                                  (0x0000000F)
#define  ATSC_ADDR_2F97_dagc_out_d_im_3_0(data)                                  (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2F97_dagc_out_d_re_11_8(data)                                 (0x0000000F&(data))
#define  ATSC_ADDR_2F97_get_dagc_out_d_im_3_0(data)                              ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2F97_get_dagc_out_d_re_11_8(data)                             (0x0000000F&(data))

#define  ATSC_ADDR_2F98                                                         0x18157E60
#define  ATSC_ADDR_2F98_reg_addr                                                 "0xB8157E60"
#define  ATSC_ADDR_2F98_reg                                                      0xB8157E60
#define  ATSC_ADDR_2F98_inst_addr                                                "0x0560"
#define  set_ATSC_ADDR_2F98_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F98_reg)=data)
#define  get_ATSC_ADDR_2F98_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F98_reg))
#define  ATSC_ADDR_2F98_dagc_out_d_im_11_4_shift                                 (0)
#define  ATSC_ADDR_2F98_dagc_out_d_im_11_4_mask                                  (0x000000FF)
#define  ATSC_ADDR_2F98_dagc_out_d_im_11_4(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2F98_get_dagc_out_d_im_11_4(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2F99                                                         0x18157E64
#define  ATSC_ADDR_2F99_reg_addr                                                 "0xB8157E64"
#define  ATSC_ADDR_2F99_reg                                                      0xB8157E64
#define  ATSC_ADDR_2F99_inst_addr                                                "0x0561"
#define  set_ATSC_ADDR_2F99_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F99_reg)=data)
#define  get_ATSC_ADDR_2F99_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F99_reg))
#define  ATSC_ADDR_2F99_deltaf_7_0_shift                                         (0)
#define  ATSC_ADDR_2F99_deltaf_7_0_mask                                          (0x000000FF)
#define  ATSC_ADDR_2F99_deltaf_7_0(data)                                         (0x000000FF&(data))
#define  ATSC_ADDR_2F99_get_deltaf_7_0(data)                                     (0x000000FF&(data))

#define  ATSC_ADDR_2F9A                                                         0x18157E68
#define  ATSC_ADDR_2F9A_reg_addr                                                 "0xB8157E68"
#define  ATSC_ADDR_2F9A_reg                                                      0xB8157E68
#define  ATSC_ADDR_2F9A_inst_addr                                                "0x0562"
#define  set_ATSC_ADDR_2F9A_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F9A_reg)=data)
#define  get_ATSC_ADDR_2F9A_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F9A_reg))
#define  ATSC_ADDR_2F9A_pn63_flag_shift                                          (7)
#define  ATSC_ADDR_2F9A_training_length_ind_shift                                (6)
#define  ATSC_ADDR_2F9A_tr_esti_lock_ind_shift                                   (5)
#define  ATSC_ADDR_2F9A_field_sync2_lock_shift                                   (4)
#define  ATSC_ADDR_2F9A_field_sync_lock_ind_shift                                (3)
#define  ATSC_ADDR_2F9A_deltaf_10_8_shift                                        (0)
#define  ATSC_ADDR_2F9A_pn63_flag_mask                                           (0x00000080)
#define  ATSC_ADDR_2F9A_training_length_ind_mask                                 (0x00000040)
#define  ATSC_ADDR_2F9A_tr_esti_lock_ind_mask                                    (0x00000020)
#define  ATSC_ADDR_2F9A_field_sync2_lock_mask                                    (0x00000010)
#define  ATSC_ADDR_2F9A_field_sync_lock_ind_mask                                 (0x00000008)
#define  ATSC_ADDR_2F9A_deltaf_10_8_mask                                         (0x00000007)
#define  ATSC_ADDR_2F9A_pn63_flag(data)                                          (0x00000080&((data)<<7))
#define  ATSC_ADDR_2F9A_training_length_ind(data)                                (0x00000040&((data)<<6))
#define  ATSC_ADDR_2F9A_tr_esti_lock_ind(data)                                   (0x00000020&((data)<<5))
#define  ATSC_ADDR_2F9A_field_sync2_lock(data)                                   (0x00000010&((data)<<4))
#define  ATSC_ADDR_2F9A_field_sync_lock_ind(data)                                (0x00000008&((data)<<3))
#define  ATSC_ADDR_2F9A_deltaf_10_8(data)                                        (0x00000007&(data))
#define  ATSC_ADDR_2F9A_get_pn63_flag(data)                                      ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2F9A_get_training_length_ind(data)                            ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2F9A_get_tr_esti_lock_ind(data)                               ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2F9A_get_field_sync2_lock(data)                               ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2F9A_get_field_sync_lock_ind(data)                            ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2F9A_get_deltaf_10_8(data)                                    (0x00000007&(data))

#define  ATSC_ADDR_2F9B                                                         0x18157E6C
#define  ATSC_ADDR_2F9B_reg_addr                                                 "0xB8157E6C"
#define  ATSC_ADDR_2F9B_reg                                                      0xB8157E6C
#define  ATSC_ADDR_2F9B_inst_addr                                                "0x0563"
#define  set_ATSC_ADDR_2F9B_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F9B_reg)=data)
#define  get_ATSC_ADDR_2F9B_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F9B_reg))
#define  ATSC_ADDR_2F9B_max_correlation_7_0_shift                                (0)
#define  ATSC_ADDR_2F9B_max_correlation_7_0_mask                                 (0x000000FF)
#define  ATSC_ADDR_2F9B_max_correlation_7_0(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2F9B_get_max_correlation_7_0(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2F9C                                                         0x18157E70
#define  ATSC_ADDR_2F9C_reg_addr                                                 "0xB8157E70"
#define  ATSC_ADDR_2F9C_reg                                                      0xB8157E70
#define  ATSC_ADDR_2F9C_inst_addr                                                "0x0564"
#define  set_ATSC_ADDR_2F9C_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F9C_reg)=data)
#define  get_ATSC_ADDR_2F9C_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F9C_reg))
#define  ATSC_ADDR_2F9C_field_sync_lock_shift                                    (6)
#define  ATSC_ADDR_2F9C_max_correlation_13_8_shift                               (0)
#define  ATSC_ADDR_2F9C_field_sync_lock_mask                                     (0x000000C0)
#define  ATSC_ADDR_2F9C_max_correlation_13_8_mask                                (0x0000003F)
#define  ATSC_ADDR_2F9C_field_sync_lock(data)                                    (0x000000C0&((data)<<6))
#define  ATSC_ADDR_2F9C_max_correlation_13_8(data)                               (0x0000003F&(data))
#define  ATSC_ADDR_2F9C_get_field_sync_lock(data)                                ((0x000000C0&(data))>>6)
#define  ATSC_ADDR_2F9C_get_max_correlation_13_8(data)                           (0x0000003F&(data))

#define  ATSC_ADDR_2F9D                                                         0x18157E74
#define  ATSC_ADDR_2F9D_reg_addr                                                 "0xB8157E74"
#define  ATSC_ADDR_2F9D_reg                                                      0xB8157E74
#define  ATSC_ADDR_2F9D_inst_addr                                                "0x0565"
#define  set_ATSC_ADDR_2F9D_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F9D_reg)=data)
#define  get_ATSC_ADDR_2F9D_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F9D_reg))
#define  ATSC_ADDR_2F9D_ch_esti_val_7_0_shift                                    (0)
#define  ATSC_ADDR_2F9D_ch_esti_val_7_0_mask                                     (0x000000FF)
#define  ATSC_ADDR_2F9D_ch_esti_val_7_0(data)                                    (0x000000FF&(data))
#define  ATSC_ADDR_2F9D_get_ch_esti_val_7_0(data)                                (0x000000FF&(data))

#define  ATSC_ADDR_2F9E                                                         0x18157E78
#define  ATSC_ADDR_2F9E_reg_addr                                                 "0xB8157E78"
#define  ATSC_ADDR_2F9E_reg                                                      0xB8157E78
#define  ATSC_ADDR_2F9E_inst_addr                                                "0x0566"
#define  set_ATSC_ADDR_2F9E_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F9E_reg)=data)
#define  get_ATSC_ADDR_2F9E_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F9E_reg))
#define  ATSC_ADDR_2F9E_ch_esti_val_15_8_shift                                   (0)
#define  ATSC_ADDR_2F9E_ch_esti_val_15_8_mask                                    (0x000000FF)
#define  ATSC_ADDR_2F9E_ch_esti_val_15_8(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_2F9E_get_ch_esti_val_15_8(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_2F9F                                                         0x18157E7C
#define  ATSC_ADDR_2F9F_reg_addr                                                 "0xB8157E7C"
#define  ATSC_ADDR_2F9F_reg                                                      0xB8157E7C
#define  ATSC_ADDR_2F9F_inst_addr                                                "0x0567"
#define  set_ATSC_ADDR_2F9F_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2F9F_reg)=data)
#define  get_ATSC_ADDR_2F9F_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2F9F_reg))
#define  ATSC_ADDR_2F9F_pn63_flag_error_ind_shift                                (7)
#define  ATSC_ADDR_2F9F_pn63_corr_flag_2_shift                                   (6)
#define  ATSC_ADDR_2F9F_pn63_corr_flag_1_shift                                   (5)
#define  ATSC_ADDR_2F9F_pn63_corr_flag_0_shift                                   (4)
#define  ATSC_ADDR_2F9F_ch_esti_val_19_16_shift                                  (0)
#define  ATSC_ADDR_2F9F_pn63_flag_error_ind_mask                                 (0x00000080)
#define  ATSC_ADDR_2F9F_pn63_corr_flag_2_mask                                    (0x00000040)
#define  ATSC_ADDR_2F9F_pn63_corr_flag_1_mask                                    (0x00000020)
#define  ATSC_ADDR_2F9F_pn63_corr_flag_0_mask                                    (0x00000010)
#define  ATSC_ADDR_2F9F_ch_esti_val_19_16_mask                                   (0x0000000F)
#define  ATSC_ADDR_2F9F_pn63_flag_error_ind(data)                                (0x00000080&((data)<<7))
#define  ATSC_ADDR_2F9F_pn63_corr_flag_2(data)                                   (0x00000040&((data)<<6))
#define  ATSC_ADDR_2F9F_pn63_corr_flag_1(data)                                   (0x00000020&((data)<<5))
#define  ATSC_ADDR_2F9F_pn63_corr_flag_0(data)                                   (0x00000010&((data)<<4))
#define  ATSC_ADDR_2F9F_ch_esti_val_19_16(data)                                  (0x0000000F&(data))
#define  ATSC_ADDR_2F9F_get_pn63_flag_error_ind(data)                            ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2F9F_get_pn63_corr_flag_2(data)                               ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2F9F_get_pn63_corr_flag_1(data)                               ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2F9F_get_pn63_corr_flag_0(data)                               ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2F9F_get_ch_esti_val_19_16(data)                              (0x0000000F&(data))

#define  ATSC_ADDR_2FA0                                                         0x18157E80
#define  ATSC_ADDR_2FA0_reg_addr                                                 "0xB8157E80"
#define  ATSC_ADDR_2FA0_reg                                                      0xB8157E80
#define  ATSC_ADDR_2FA0_inst_addr                                                "0x0568"
#define  set_ATSC_ADDR_2FA0_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FA0_reg)=data)
#define  get_ATSC_ADDR_2FA0_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FA0_reg))
#define  ATSC_ADDR_2FA0_ffe_coeff_15_8_shift                                     (0)
#define  ATSC_ADDR_2FA0_ffe_coeff_15_8_mask                                      (0x000000FF)
#define  ATSC_ADDR_2FA0_ffe_coeff_15_8(data)                                     (0x000000FF&(data))
#define  ATSC_ADDR_2FA0_get_ffe_coeff_15_8(data)                                 (0x000000FF&(data))

#define  ATSC_ADDR_2FA1                                                         0x18157E84
#define  ATSC_ADDR_2FA1_reg_addr                                                 "0xB8157E84"
#define  ATSC_ADDR_2FA1_reg                                                      0xB8157E84
#define  ATSC_ADDR_2FA1_inst_addr                                                "0x0569"
#define  set_ATSC_ADDR_2FA1_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FA1_reg)=data)
#define  get_ATSC_ADDR_2FA1_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FA1_reg))
#define  ATSC_ADDR_2FA1_ffe_coeff_7_0_shift                                      (0)
#define  ATSC_ADDR_2FA1_ffe_coeff_7_0_mask                                       (0x000000FF)
#define  ATSC_ADDR_2FA1_ffe_coeff_7_0(data)                                      (0x000000FF&(data))
#define  ATSC_ADDR_2FA1_get_ffe_coeff_7_0(data)                                  (0x000000FF&(data))

#define  ATSC_ADDR_2FA2                                                         0x18157E88
#define  ATSC_ADDR_2FA2_reg_addr                                                 "0xB8157E88"
#define  ATSC_ADDR_2FA2_reg                                                      0xB8157E88
#define  ATSC_ADDR_2FA2_inst_addr                                                "0x056A"
#define  set_ATSC_ADDR_2FA2_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FA2_reg)=data)
#define  get_ATSC_ADDR_2FA2_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FA2_reg))
#define  ATSC_ADDR_2FA2_ffe_sat_d_shift                                          (7)
#define  ATSC_ADDR_2FA2_cr_corr_lock_ind_shift                                   (5)
#define  ATSC_ADDR_2FA2_cr_ld_re_diff_flag_shift                                 (4)
#define  ATSC_ADDR_2FA2_cr_ld_freq_max_flag_shift                                (3)
#define  ATSC_ADDR_2FA2_cr_ld_freq_diff_flag_shift                               (2)
#define  ATSC_ADDR_2FA2_cr_ld_im_flag_shift                                      (1)
#define  ATSC_ADDR_2FA2_cr_ld_re_lb_flag_shift                                   (0)
#define  ATSC_ADDR_2FA2_ffe_sat_d_mask                                           (0x00000080)
#define  ATSC_ADDR_2FA2_cr_corr_lock_ind_mask                                    (0x00000020)
#define  ATSC_ADDR_2FA2_cr_ld_re_diff_flag_mask                                  (0x00000010)
#define  ATSC_ADDR_2FA2_cr_ld_freq_max_flag_mask                                 (0x00000008)
#define  ATSC_ADDR_2FA2_cr_ld_freq_diff_flag_mask                                (0x00000004)
#define  ATSC_ADDR_2FA2_cr_ld_im_flag_mask                                       (0x00000002)
#define  ATSC_ADDR_2FA2_cr_ld_re_lb_flag_mask                                    (0x00000001)
#define  ATSC_ADDR_2FA2_ffe_sat_d(data)                                          (0x00000080&((data)<<7))
#define  ATSC_ADDR_2FA2_cr_corr_lock_ind(data)                                   (0x00000020&((data)<<5))
#define  ATSC_ADDR_2FA2_cr_ld_re_diff_flag(data)                                 (0x00000010&((data)<<4))
#define  ATSC_ADDR_2FA2_cr_ld_freq_max_flag(data)                                (0x00000008&((data)<<3))
#define  ATSC_ADDR_2FA2_cr_ld_freq_diff_flag(data)                               (0x00000004&((data)<<2))
#define  ATSC_ADDR_2FA2_cr_ld_im_flag(data)                                      (0x00000002&((data)<<1))
#define  ATSC_ADDR_2FA2_cr_ld_re_lb_flag(data)                                   (0x00000001&(data))
#define  ATSC_ADDR_2FA2_get_ffe_sat_d(data)                                      ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2FA2_get_cr_corr_lock_ind(data)                               ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2FA2_get_cr_ld_re_diff_flag(data)                             ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2FA2_get_cr_ld_freq_max_flag(data)                            ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2FA2_get_cr_ld_freq_diff_flag(data)                           ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2FA2_get_cr_ld_im_flag(data)                                  ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2FA2_get_cr_ld_re_lb_flag(data)                               (0x00000001&(data))

#define  ATSC_ADDR_2FA3                                                         0x18157E8C
#define  ATSC_ADDR_2FA3_reg_addr                                                 "0xB8157E8C"
#define  ATSC_ADDR_2FA3_reg                                                      0xB8157E8C
#define  ATSC_ADDR_2FA3_inst_addr                                                "0x056B"
#define  set_ATSC_ADDR_2FA3_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FA3_reg)=data)
#define  get_ATSC_ADDR_2FA3_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FA3_reg))
#define  ATSC_ADDR_2FA3_ro_ffe_coeff_sum_13_6_shift                              (0)
#define  ATSC_ADDR_2FA3_ro_ffe_coeff_sum_13_6_mask                               (0x000000FF)
#define  ATSC_ADDR_2FA3_ro_ffe_coeff_sum_13_6(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_2FA3_get_ro_ffe_coeff_sum_13_6(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_2FA4                                                         0x18157E90
#define  ATSC_ADDR_2FA4_reg_addr                                                 "0xB8157E90"
#define  ATSC_ADDR_2FA4_reg                                                      0xB8157E90
#define  ATSC_ADDR_2FA4_inst_addr                                                "0x056C"
#define  set_ATSC_ADDR_2FA4_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FA4_reg)=data)
#define  get_ATSC_ADDR_2FA4_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FA4_reg))
#define  ATSC_ADDR_2FA4_ro_ffe_coeff_sum_5_0_shift                               (0)
#define  ATSC_ADDR_2FA4_ro_ffe_coeff_sum_5_0_mask                                (0x0000003F)
#define  ATSC_ADDR_2FA4_ro_ffe_coeff_sum_5_0(data)                               (0x0000003F&(data))
#define  ATSC_ADDR_2FA4_get_ro_ffe_coeff_sum_5_0(data)                           (0x0000003F&(data))

#define  ATSC_ADDR_2FA5                                                         0x18157E94
#define  ATSC_ADDR_2FA5_reg_addr                                                 "0xB8157E94"
#define  ATSC_ADDR_2FA5_reg                                                      0xB8157E94
#define  ATSC_ADDR_2FA5_inst_addr                                                "0x056D"
#define  set_ATSC_ADDR_2FA5_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FA5_reg)=data)
#define  get_ATSC_ADDR_2FA5_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FA5_reg))
#define  ATSC_ADDR_2FA5_ro_ffe_sp_coeff_max_11_4_shift                           (0)
#define  ATSC_ADDR_2FA5_ro_ffe_sp_coeff_max_11_4_mask                            (0x000000FF)
#define  ATSC_ADDR_2FA5_ro_ffe_sp_coeff_max_11_4(data)                           (0x000000FF&(data))
#define  ATSC_ADDR_2FA5_get_ro_ffe_sp_coeff_max_11_4(data)                       (0x000000FF&(data))

#define  ATSC_ADDR_2FA6                                                         0x18157E98
#define  ATSC_ADDR_2FA6_reg_addr                                                 "0xB8157E98"
#define  ATSC_ADDR_2FA6_reg                                                      0xB8157E98
#define  ATSC_ADDR_2FA6_inst_addr                                                "0x056E"
#define  set_ATSC_ADDR_2FA6_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FA6_reg)=data)
#define  get_ATSC_ADDR_2FA6_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FA6_reg))
#define  ATSC_ADDR_2FA6_ro_ffe_sp_coeff_max_3_0_shift                            (0)
#define  ATSC_ADDR_2FA6_ro_ffe_sp_coeff_max_3_0_mask                             (0x0000000F)
#define  ATSC_ADDR_2FA6_ro_ffe_sp_coeff_max_3_0(data)                            (0x0000000F&(data))
#define  ATSC_ADDR_2FA6_get_ro_ffe_sp_coeff_max_3_0(data)                        (0x0000000F&(data))

#define  ATSC_ADDR_2FA7                                                         0x18157E9C
#define  ATSC_ADDR_2FA7_reg_addr                                                 "0xB8157E9C"
#define  ATSC_ADDR_2FA7_reg                                                      0xB8157E9C
#define  ATSC_ADDR_2FA7_inst_addr                                                "0x056F"
#define  set_ATSC_ADDR_2FA7_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FA7_reg)=data)
#define  get_ATSC_ADDR_2FA7_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FA7_reg))
#define  ATSC_ADDR_2FA7_ro_ffe_gc_odd_coeff_en_shift                             (4)
#define  ATSC_ADDR_2FA7_ro_ffe_gc_even_coeff_en_shift                            (0)
#define  ATSC_ADDR_2FA7_ro_ffe_gc_odd_coeff_en_mask                              (0x000000F0)
#define  ATSC_ADDR_2FA7_ro_ffe_gc_even_coeff_en_mask                             (0x0000000F)
#define  ATSC_ADDR_2FA7_ro_ffe_gc_odd_coeff_en(data)                             (0x000000F0&((data)<<4))
#define  ATSC_ADDR_2FA7_ro_ffe_gc_even_coeff_en(data)                            (0x0000000F&(data))
#define  ATSC_ADDR_2FA7_get_ro_ffe_gc_odd_coeff_en(data)                         ((0x000000F0&(data))>>4)
#define  ATSC_ADDR_2FA7_get_ro_ffe_gc_even_coeff_en(data)                        (0x0000000F&(data))

#define  ATSC_ADDR_2FA8                                                         0x18157EA0
#define  ATSC_ADDR_2FA8_reg_addr                                                 "0xB8157EA0"
#define  ATSC_ADDR_2FA8_reg                                                      0xB8157EA0
#define  ATSC_ADDR_2FA8_inst_addr                                                "0x0570"
#define  set_ATSC_ADDR_2FA8_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FA8_reg)=data)
#define  get_ATSC_ADDR_2FA8_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FA8_reg))
#define  ATSC_ADDR_2FA8_ro_ffe_muc_coeff_mu_0_1_shift                            (0)
#define  ATSC_ADDR_2FA8_ro_ffe_muc_coeff_mu_0_1_mask                             (0x000000FF)
#define  ATSC_ADDR_2FA8_ro_ffe_muc_coeff_mu_0_1(data)                            (0x000000FF&(data))
#define  ATSC_ADDR_2FA8_get_ro_ffe_muc_coeff_mu_0_1(data)                        (0x000000FF&(data))

#define  ATSC_ADDR_2FA9                                                         0x18157EA4
#define  ATSC_ADDR_2FA9_reg_addr                                                 "0xB8157EA4"
#define  ATSC_ADDR_2FA9_reg                                                      0xB8157EA4
#define  ATSC_ADDR_2FA9_inst_addr                                                "0x0571"
#define  set_ATSC_ADDR_2FA9_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FA9_reg)=data)
#define  get_ATSC_ADDR_2FA9_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FA9_reg))
#define  ATSC_ADDR_2FA9_ro_ffe_gc_en_coeff_sum_ind_max_shift                     (0)
#define  ATSC_ADDR_2FA9_ro_ffe_gc_en_coeff_sum_ind_max_mask                      (0x000000FF)
#define  ATSC_ADDR_2FA9_ro_ffe_gc_en_coeff_sum_ind_max(data)                     (0x000000FF&(data))
#define  ATSC_ADDR_2FA9_get_ro_ffe_gc_en_coeff_sum_ind_max(data)                 (0x000000FF&(data))

#define  ATSC_ADDR_2FAA                                                         0x18157EA8
#define  ATSC_ADDR_2FAA_reg_addr                                                 "0xB8157EA8"
#define  ATSC_ADDR_2FAA_reg                                                      0xB8157EA8
#define  ATSC_ADDR_2FAA_inst_addr                                                "0x0572"
#define  set_ATSC_ADDR_2FAA_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FAA_reg)=data)
#define  get_ATSC_ADDR_2FAA_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FAA_reg))
#define  ATSC_ADDR_2FAA_ro_ffe_gc_dis_coeff_sum_ind_max_shift                    (0)
#define  ATSC_ADDR_2FAA_ro_ffe_gc_dis_coeff_sum_ind_max_mask                     (0x000000FF)
#define  ATSC_ADDR_2FAA_ro_ffe_gc_dis_coeff_sum_ind_max(data)                    (0x000000FF&(data))
#define  ATSC_ADDR_2FAA_get_ro_ffe_gc_dis_coeff_sum_ind_max(data)                (0x000000FF&(data))

#define  ATSC_ADDR_2FAB                                                         0x18157EAC
#define  ATSC_ADDR_2FAB_reg_addr                                                 "0xB8157EAC"
#define  ATSC_ADDR_2FAB_reg                                                      0xB8157EAC
#define  ATSC_ADDR_2FAB_inst_addr                                                "0x0573"
#define  set_ATSC_ADDR_2FAB_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FAB_reg)=data)
#define  get_ATSC_ADDR_2FAB_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FAB_reg))
#define  ATSC_ADDR_2FAB_ro_ffe_cluster_addr_0_7_0_shift                          (0)
#define  ATSC_ADDR_2FAB_ro_ffe_cluster_addr_0_7_0_mask                           (0x000000FF)
#define  ATSC_ADDR_2FAB_ro_ffe_cluster_addr_0_7_0(data)                          (0x000000FF&(data))
#define  ATSC_ADDR_2FAB_get_ro_ffe_cluster_addr_0_7_0(data)                      (0x000000FF&(data))

#define  ATSC_ADDR_2FAC                                                         0x18157EB0
#define  ATSC_ADDR_2FAC_reg_addr                                                 "0xB8157EB0"
#define  ATSC_ADDR_2FAC_reg                                                      0xB8157EB0
#define  ATSC_ADDR_2FAC_inst_addr                                                "0x0574"
#define  set_ATSC_ADDR_2FAC_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FAC_reg)=data)
#define  get_ATSC_ADDR_2FAC_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FAC_reg))
#define  ATSC_ADDR_2FAC_ro_ffe_cluster_addr_1_7_0_shift                          (0)
#define  ATSC_ADDR_2FAC_ro_ffe_cluster_addr_1_7_0_mask                           (0x000000FF)
#define  ATSC_ADDR_2FAC_ro_ffe_cluster_addr_1_7_0(data)                          (0x000000FF&(data))
#define  ATSC_ADDR_2FAC_get_ro_ffe_cluster_addr_1_7_0(data)                      (0x000000FF&(data))

#define  ATSC_ADDR_2FAD                                                         0x18157EB4
#define  ATSC_ADDR_2FAD_reg_addr                                                 "0xB8157EB4"
#define  ATSC_ADDR_2FAD_reg                                                      0xB8157EB4
#define  ATSC_ADDR_2FAD_inst_addr                                                "0x0575"
#define  set_ATSC_ADDR_2FAD_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FAD_reg)=data)
#define  get_ATSC_ADDR_2FAD_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FAD_reg))
#define  ATSC_ADDR_2FAD_ro_ffe_cluster_addr_2_7_0_shift                          (0)
#define  ATSC_ADDR_2FAD_ro_ffe_cluster_addr_2_7_0_mask                           (0x000000FF)
#define  ATSC_ADDR_2FAD_ro_ffe_cluster_addr_2_7_0(data)                          (0x000000FF&(data))
#define  ATSC_ADDR_2FAD_get_ro_ffe_cluster_addr_2_7_0(data)                      (0x000000FF&(data))

#define  ATSC_ADDR_2FAE                                                         0x18157EB8
#define  ATSC_ADDR_2FAE_reg_addr                                                 "0xB8157EB8"
#define  ATSC_ADDR_2FAE_reg                                                      0xB8157EB8
#define  ATSC_ADDR_2FAE_inst_addr                                                "0x0576"
#define  set_ATSC_ADDR_2FAE_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FAE_reg)=data)
#define  get_ATSC_ADDR_2FAE_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FAE_reg))
#define  ATSC_ADDR_2FAE_ro_ffe_cluster_addr_3_7_0_shift                          (0)
#define  ATSC_ADDR_2FAE_ro_ffe_cluster_addr_3_7_0_mask                           (0x000000FF)
#define  ATSC_ADDR_2FAE_ro_ffe_cluster_addr_3_7_0(data)                          (0x000000FF&(data))
#define  ATSC_ADDR_2FAE_get_ro_ffe_cluster_addr_3_7_0(data)                      (0x000000FF&(data))

#define  ATSC_ADDR_2FAF                                                         0x18157EBC
#define  ATSC_ADDR_2FAF_reg_addr                                                 "0xB8157EBC"
#define  ATSC_ADDR_2FAF_reg                                                      0xB8157EBC
#define  ATSC_ADDR_2FAF_inst_addr                                                "0x0577"
#define  set_ATSC_ADDR_2FAF_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FAF_reg)=data)
#define  get_ATSC_ADDR_2FAF_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FAF_reg))
#define  ATSC_ADDR_2FAF_ro_fbf_coeff_sum_13_6_shift                              (0)
#define  ATSC_ADDR_2FAF_ro_fbf_coeff_sum_13_6_mask                               (0x000000FF)
#define  ATSC_ADDR_2FAF_ro_fbf_coeff_sum_13_6(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_2FAF_get_ro_fbf_coeff_sum_13_6(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_2FB0                                                         0x18157EC0
#define  ATSC_ADDR_2FB0_reg_addr                                                 "0xB8157EC0"
#define  ATSC_ADDR_2FB0_reg                                                      0xB8157EC0
#define  ATSC_ADDR_2FB0_inst_addr                                                "0x0578"
#define  set_ATSC_ADDR_2FB0_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FB0_reg)=data)
#define  get_ATSC_ADDR_2FB0_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FB0_reg))
#define  ATSC_ADDR_2FB0_ro_fbf_coeff_sum_5_0_shift                               (0)
#define  ATSC_ADDR_2FB0_ro_fbf_coeff_sum_5_0_mask                                (0x0000003F)
#define  ATSC_ADDR_2FB0_ro_fbf_coeff_sum_5_0(data)                               (0x0000003F&(data))
#define  ATSC_ADDR_2FB0_get_ro_fbf_coeff_sum_5_0(data)                           (0x0000003F&(data))

#define  ATSC_ADDR_2FB1                                                         0x18157EC4
#define  ATSC_ADDR_2FB1_reg_addr                                                 "0xB8157EC4"
#define  ATSC_ADDR_2FB1_reg                                                      0xB8157EC4
#define  ATSC_ADDR_2FB1_inst_addr                                                "0x0579"
#define  set_ATSC_ADDR_2FB1_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FB1_reg)=data)
#define  get_ATSC_ADDR_2FB1_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FB1_reg))
#define  ATSC_ADDR_2FB1_ro_fbf_const_coeff_sum_7_0_shift                         (0)
#define  ATSC_ADDR_2FB1_ro_fbf_const_coeff_sum_7_0_mask                          (0x000000FF)
#define  ATSC_ADDR_2FB1_ro_fbf_const_coeff_sum_7_0(data)                         (0x000000FF&(data))
#define  ATSC_ADDR_2FB1_get_ro_fbf_const_coeff_sum_7_0(data)                     (0x000000FF&(data))

#define  ATSC_ADDR_2FB2                                                         0x18157EC8
#define  ATSC_ADDR_2FB2_reg_addr                                                 "0xB8157EC8"
#define  ATSC_ADDR_2FB2_reg                                                      0xB8157EC8
#define  ATSC_ADDR_2FB2_inst_addr                                                "0x057A"
#define  set_ATSC_ADDR_2FB2_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FB2_reg)=data)
#define  get_ATSC_ADDR_2FB2_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FB2_reg))
#define  ATSC_ADDR_2FB2_ro_fbf_const_coeff_sum_cnt_5_0_shift                     (2)
#define  ATSC_ADDR_2FB2_ro_fbf_const_coeff_sum_9_8_shift                         (0)
#define  ATSC_ADDR_2FB2_ro_fbf_const_coeff_sum_cnt_5_0_mask                      (0x000000FC)
#define  ATSC_ADDR_2FB2_ro_fbf_const_coeff_sum_9_8_mask                          (0x00000003)
#define  ATSC_ADDR_2FB2_ro_fbf_const_coeff_sum_cnt_5_0(data)                     (0x000000FC&((data)<<2))
#define  ATSC_ADDR_2FB2_ro_fbf_const_coeff_sum_9_8(data)                         (0x00000003&(data))
#define  ATSC_ADDR_2FB2_get_ro_fbf_const_coeff_sum_cnt_5_0(data)                 ((0x000000FC&(data))>>2)
#define  ATSC_ADDR_2FB2_get_ro_fbf_const_coeff_sum_9_8(data)                     (0x00000003&(data))

#define  ATSC_ADDR_2FB3                                                         0x18157ECC
#define  ATSC_ADDR_2FB3_reg_addr                                                 "0xB8157ECC"
#define  ATSC_ADDR_2FB3_reg                                                      0xB8157ECC
#define  ATSC_ADDR_2FB3_inst_addr                                                "0x057B"
#define  set_ATSC_ADDR_2FB3_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FB3_reg)=data)
#define  get_ATSC_ADDR_2FB3_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FB3_reg))
#define  ATSC_ADDR_2FB3_ro_fbf_const_coeff_sum_cnt_9_6_shift                     (0)
#define  ATSC_ADDR_2FB3_ro_fbf_const_coeff_sum_cnt_9_6_mask                      (0x0000000F)
#define  ATSC_ADDR_2FB3_ro_fbf_const_coeff_sum_cnt_9_6(data)                     (0x0000000F&(data))
#define  ATSC_ADDR_2FB3_get_ro_fbf_const_coeff_sum_cnt_9_6(data)                 (0x0000000F&(data))

#define  ATSC_ADDR_2FB4                                                         0x18157ED0
#define  ATSC_ADDR_2FB4_reg_addr                                                 "0xB8157ED0"
#define  ATSC_ADDR_2FB4_reg                                                      0xB8157ED0
#define  ATSC_ADDR_2FB4_inst_addr                                                "0x057C"
#define  set_ATSC_ADDR_2FB4_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FB4_reg)=data)
#define  get_ATSC_ADDR_2FB4_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FB4_reg))
#define  ATSC_ADDR_2FB4_ro_fbf_gc_coeff_en_shift                                 (0)
#define  ATSC_ADDR_2FB4_ro_fbf_gc_coeff_en_mask                                  (0x000000FF)
#define  ATSC_ADDR_2FB4_ro_fbf_gc_coeff_en(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2FB4_get_ro_fbf_gc_coeff_en(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2FB5                                                         0x18157ED4
#define  ATSC_ADDR_2FB5_reg_addr                                                 "0xB8157ED4"
#define  ATSC_ADDR_2FB5_reg                                                      0xB8157ED4
#define  ATSC_ADDR_2FB5_inst_addr                                                "0x057D"
#define  set_ATSC_ADDR_2FB5_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FB5_reg)=data)
#define  get_ATSC_ADDR_2FB5_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FB5_reg))
#define  ATSC_ADDR_2FB5_ro_fbf_muc_coeff_mu_0_1_shift                            (0)
#define  ATSC_ADDR_2FB5_ro_fbf_muc_coeff_mu_0_1_mask                             (0x000000FF)
#define  ATSC_ADDR_2FB5_ro_fbf_muc_coeff_mu_0_1(data)                            (0x000000FF&(data))
#define  ATSC_ADDR_2FB5_get_ro_fbf_muc_coeff_mu_0_1(data)                        (0x000000FF&(data))

#define  ATSC_ADDR_2FB6                                                         0x18157ED8
#define  ATSC_ADDR_2FB6_reg_addr                                                 "0xB8157ED8"
#define  ATSC_ADDR_2FB6_reg                                                      0xB8157ED8
#define  ATSC_ADDR_2FB6_inst_addr                                                "0x057E"
#define  set_ATSC_ADDR_2FB6_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FB6_reg)=data)
#define  get_ATSC_ADDR_2FB6_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FB6_reg))
#define  ATSC_ADDR_2FB6_ro_fbf_gc_en_coeff_sum_ind_max_shift                     (0)
#define  ATSC_ADDR_2FB6_ro_fbf_gc_en_coeff_sum_ind_max_mask                      (0x000000FF)
#define  ATSC_ADDR_2FB6_ro_fbf_gc_en_coeff_sum_ind_max(data)                     (0x000000FF&(data))
#define  ATSC_ADDR_2FB6_get_ro_fbf_gc_en_coeff_sum_ind_max(data)                 (0x000000FF&(data))

#define  ATSC_ADDR_2FB7                                                         0x18157EDC
#define  ATSC_ADDR_2FB7_reg_addr                                                 "0xB8157EDC"
#define  ATSC_ADDR_2FB7_reg                                                      0xB8157EDC
#define  ATSC_ADDR_2FB7_inst_addr                                                "0x057F"
#define  set_ATSC_ADDR_2FB7_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FB7_reg)=data)
#define  get_ATSC_ADDR_2FB7_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FB7_reg))
#define  ATSC_ADDR_2FB7_ro_fbf_gc_dis_coeff_sum_ind_max_shift                    (0)
#define  ATSC_ADDR_2FB7_ro_fbf_gc_dis_coeff_sum_ind_max_mask                     (0x000000FF)
#define  ATSC_ADDR_2FB7_ro_fbf_gc_dis_coeff_sum_ind_max(data)                    (0x000000FF&(data))
#define  ATSC_ADDR_2FB7_get_ro_fbf_gc_dis_coeff_sum_ind_max(data)                (0x000000FF&(data))

#define  ATSC_ADDR_2FB8                                                         0x18157EE0
#define  ATSC_ADDR_2FB8_reg_addr                                                 "0xB8157EE0"
#define  ATSC_ADDR_2FB8_reg                                                      0xB8157EE0
#define  ATSC_ADDR_2FB8_inst_addr                                                "0x0580"
#define  set_ATSC_ADDR_2FB8_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FB8_reg)=data)
#define  get_ATSC_ADDR_2FB8_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FB8_reg))
#define  ATSC_ADDR_2FB8_ffe_out_clip_ind_3_shift                                 (3)
#define  ATSC_ADDR_2FB8_ffe_out_clip_ind_2_shift                                 (2)
#define  ATSC_ADDR_2FB8_ffe_out_clip_ind_1_shift                                 (1)
#define  ATSC_ADDR_2FB8_ffe_out_clip_ind_0_shift                                 (0)
#define  ATSC_ADDR_2FB8_ffe_out_clip_ind_3_mask                                  (0x00000008)
#define  ATSC_ADDR_2FB8_ffe_out_clip_ind_2_mask                                  (0x00000004)
#define  ATSC_ADDR_2FB8_ffe_out_clip_ind_1_mask                                  (0x00000002)
#define  ATSC_ADDR_2FB8_ffe_out_clip_ind_0_mask                                  (0x00000001)
#define  ATSC_ADDR_2FB8_ffe_out_clip_ind_3(data)                                 (0x00000008&((data)<<3))
#define  ATSC_ADDR_2FB8_ffe_out_clip_ind_2(data)                                 (0x00000004&((data)<<2))
#define  ATSC_ADDR_2FB8_ffe_out_clip_ind_1(data)                                 (0x00000002&((data)<<1))
#define  ATSC_ADDR_2FB8_ffe_out_clip_ind_0(data)                                 (0x00000001&(data))
#define  ATSC_ADDR_2FB8_get_ffe_out_clip_ind_3(data)                             ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2FB8_get_ffe_out_clip_ind_2(data)                             ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2FB8_get_ffe_out_clip_ind_1(data)                             ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2FB8_get_ffe_out_clip_ind_0(data)                             (0x00000001&(data))

#define  ATSC_ADDR_2FBA                                                         0x18157EE8
#define  ATSC_ADDR_2FBA_reg_addr                                                 "0xB8157EE8"
#define  ATSC_ADDR_2FBA_reg                                                      0xB8157EE8
#define  ATSC_ADDR_2FBA_inst_addr                                                "0x0581"
#define  set_ATSC_ADDR_2FBA_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FBA_reg)=data)
#define  get_ATSC_ADDR_2FBA_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FBA_reg))
#define  ATSC_ADDR_2FBA_fbf_coeff_15_8_shift                                     (0)
#define  ATSC_ADDR_2FBA_fbf_coeff_15_8_mask                                      (0x000000FF)
#define  ATSC_ADDR_2FBA_fbf_coeff_15_8(data)                                     (0x000000FF&(data))
#define  ATSC_ADDR_2FBA_get_fbf_coeff_15_8(data)                                 (0x000000FF&(data))

#define  ATSC_ADDR_2FBB                                                         0x18157EEC
#define  ATSC_ADDR_2FBB_reg_addr                                                 "0xB8157EEC"
#define  ATSC_ADDR_2FBB_reg                                                      0xB8157EEC
#define  ATSC_ADDR_2FBB_inst_addr                                                "0x0582"
#define  set_ATSC_ADDR_2FBB_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FBB_reg)=data)
#define  get_ATSC_ADDR_2FBB_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FBB_reg))
#define  ATSC_ADDR_2FBB_fbf_coeff_7_0_shift                                      (0)
#define  ATSC_ADDR_2FBB_fbf_coeff_7_0_mask                                       (0x000000FF)
#define  ATSC_ADDR_2FBB_fbf_coeff_7_0(data)                                      (0x000000FF&(data))
#define  ATSC_ADDR_2FBB_get_fbf_coeff_7_0(data)                                  (0x000000FF&(data))

#define  ATSC_ADDR_2FBC                                                         0x18157EF0
#define  ATSC_ADDR_2FBC_reg_addr                                                 "0xB8157EF0"
#define  ATSC_ADDR_2FBC_reg                                                      0xB8157EF0
#define  ATSC_ADDR_2FBC_inst_addr                                                "0x0583"
#define  set_ATSC_ADDR_2FBC_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FBC_reg)=data)
#define  get_ATSC_ADDR_2FBC_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FBC_reg))
#define  ATSC_ADDR_2FBC_ro_ffe_cluster_addr_3_8_shift                            (3)
#define  ATSC_ADDR_2FBC_ro_ffe_cluster_addr_2_8_shift                            (2)
#define  ATSC_ADDR_2FBC_ro_ffe_cluster_addr_1_8_shift                            (1)
#define  ATSC_ADDR_2FBC_ro_ffe_cluster_addr_0_8_shift                            (0)
#define  ATSC_ADDR_2FBC_ro_ffe_cluster_addr_3_8_mask                             (0x00000008)
#define  ATSC_ADDR_2FBC_ro_ffe_cluster_addr_2_8_mask                             (0x00000004)
#define  ATSC_ADDR_2FBC_ro_ffe_cluster_addr_1_8_mask                             (0x00000002)
#define  ATSC_ADDR_2FBC_ro_ffe_cluster_addr_0_8_mask                             (0x00000001)
#define  ATSC_ADDR_2FBC_ro_ffe_cluster_addr_3_8(data)                            (0x00000008&((data)<<3))
#define  ATSC_ADDR_2FBC_ro_ffe_cluster_addr_2_8(data)                            (0x00000004&((data)<<2))
#define  ATSC_ADDR_2FBC_ro_ffe_cluster_addr_1_8(data)                            (0x00000002&((data)<<1))
#define  ATSC_ADDR_2FBC_ro_ffe_cluster_addr_0_8(data)                            (0x00000001&(data))
#define  ATSC_ADDR_2FBC_get_ro_ffe_cluster_addr_3_8(data)                        ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2FBC_get_ro_ffe_cluster_addr_2_8(data)                        ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2FBC_get_ro_ffe_cluster_addr_1_8(data)                        ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2FBC_get_ro_ffe_cluster_addr_0_8(data)                        (0x00000001&(data))

#define  ATSC_ADDR_2FD6                                                         0x18157F58
#define  ATSC_ADDR_2FD6_reg_addr                                                 "0xB8157F58"
#define  ATSC_ADDR_2FD6_reg                                                      0xB8157F58
#define  ATSC_ADDR_2FD6_inst_addr                                                "0x0584"
#define  set_ATSC_ADDR_2FD6_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FD6_reg)=data)
#define  get_ATSC_ADDR_2FD6_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FD6_reg))
#define  ATSC_ADDR_2FD6_eq_out_er_7_0_shift                                      (0)
#define  ATSC_ADDR_2FD6_eq_out_er_7_0_mask                                       (0x000000FF)
#define  ATSC_ADDR_2FD6_eq_out_er_7_0(data)                                      (0x000000FF&(data))
#define  ATSC_ADDR_2FD6_get_eq_out_er_7_0(data)                                  (0x000000FF&(data))

#define  ATSC_ADDR_2FD7                                                         0x18157F5C
#define  ATSC_ADDR_2FD7_reg_addr                                                 "0xB8157F5C"
#define  ATSC_ADDR_2FD7_reg                                                      0xB8157F5C
#define  ATSC_ADDR_2FD7_inst_addr                                                "0x0585"
#define  set_ATSC_ADDR_2FD7_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FD7_reg)=data)
#define  get_ATSC_ADDR_2FD7_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FD7_reg))
#define  ATSC_ADDR_2FD7_eq_out_er_15_8_shift                                     (0)
#define  ATSC_ADDR_2FD7_eq_out_er_15_8_mask                                      (0x000000FF)
#define  ATSC_ADDR_2FD7_eq_out_er_15_8(data)                                     (0x000000FF&(data))
#define  ATSC_ADDR_2FD7_get_eq_out_er_15_8(data)                                 (0x000000FF&(data))

#define  ATSC_ADDR_2FD8                                                         0x18157F60
#define  ATSC_ADDR_2FD8_reg_addr                                                 "0xB8157F60"
#define  ATSC_ADDR_2FD8_reg                                                      0xB8157F60
#define  ATSC_ADDR_2FD8_inst_addr                                                "0x0586"
#define  set_ATSC_ADDR_2FD8_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FD8_reg)=data)
#define  get_ATSC_ADDR_2FD8_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FD8_reg))
#define  ATSC_ADDR_2FD8_eq_out_pt_7_0_shift                                      (0)
#define  ATSC_ADDR_2FD8_eq_out_pt_7_0_mask                                       (0x000000FF)
#define  ATSC_ADDR_2FD8_eq_out_pt_7_0(data)                                      (0x000000FF&(data))
#define  ATSC_ADDR_2FD8_get_eq_out_pt_7_0(data)                                  (0x000000FF&(data))

#define  ATSC_ADDR_2FD9                                                         0x18157F64
#define  ATSC_ADDR_2FD9_reg_addr                                                 "0xB8157F64"
#define  ATSC_ADDR_2FD9_reg                                                      0xB8157F64
#define  ATSC_ADDR_2FD9_inst_addr                                                "0x0587"
#define  set_ATSC_ADDR_2FD9_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FD9_reg)=data)
#define  get_ATSC_ADDR_2FD9_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FD9_reg))
#define  ATSC_ADDR_2FD9_eq_out_pt_15_8_shift                                     (0)
#define  ATSC_ADDR_2FD9_eq_out_pt_15_8_mask                                      (0x000000FF)
#define  ATSC_ADDR_2FD9_eq_out_pt_15_8(data)                                     (0x000000FF&(data))
#define  ATSC_ADDR_2FD9_get_eq_out_pt_15_8(data)                                 (0x000000FF&(data))

#define  ATSC_ADDR_2FDA                                                         0x18157F68
#define  ATSC_ADDR_2FDA_reg_addr                                                 "0xB8157F68"
#define  ATSC_ADDR_2FDA_reg                                                      0xB8157F68
#define  ATSC_ADDR_2FDA_inst_addr                                                "0x0588"
#define  set_ATSC_ADDR_2FDA_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FDA_reg)=data)
#define  get_ATSC_ADDR_2FDA_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FDA_reg))
#define  ATSC_ADDR_2FDA_mse_7_0_shift                                            (0)
#define  ATSC_ADDR_2FDA_mse_7_0_mask                                             (0x000000FF)
#define  ATSC_ADDR_2FDA_mse_7_0(data)                                            (0x000000FF&(data))
#define  ATSC_ADDR_2FDA_get_mse_7_0(data)                                        (0x000000FF&(data))

#define  ATSC_ADDR_2FDB                                                         0x18157F6C
#define  ATSC_ADDR_2FDB_reg_addr                                                 "0xB8157F6C"
#define  ATSC_ADDR_2FDB_reg                                                      0xB8157F6C
#define  ATSC_ADDR_2FDB_inst_addr                                                "0x0589"
#define  set_ATSC_ADDR_2FDB_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FDB_reg)=data)
#define  get_ATSC_ADDR_2FDB_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FDB_reg))
#define  ATSC_ADDR_2FDB_mse_15_8_shift                                           (0)
#define  ATSC_ADDR_2FDB_mse_15_8_mask                                            (0x000000FF)
#define  ATSC_ADDR_2FDB_mse_15_8(data)                                           (0x000000FF&(data))
#define  ATSC_ADDR_2FDB_get_mse_15_8(data)                                       (0x000000FF&(data))

#define  ATSC_ADDR_2FDC                                                         0x18157F70
#define  ATSC_ADDR_2FDC_reg_addr                                                 "0xB8157F70"
#define  ATSC_ADDR_2FDC_reg                                                      0xB8157F70
#define  ATSC_ADDR_2FDC_inst_addr                                                "0x058A"
#define  set_ATSC_ADDR_2FDC_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FDC_reg)=data)
#define  get_ATSC_ADDR_2FDC_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FDC_reg))
#define  ATSC_ADDR_2FDC_mse_23_16_shift                                          (0)
#define  ATSC_ADDR_2FDC_mse_23_16_mask                                           (0x000000FF)
#define  ATSC_ADDR_2FDC_mse_23_16(data)                                          (0x000000FF&(data))
#define  ATSC_ADDR_2FDC_get_mse_23_16(data)                                      (0x000000FF&(data))

#define  ATSC_ADDR_2FDD                                                         0x18157F74
#define  ATSC_ADDR_2FDD_reg_addr                                                 "0xB8157F74"
#define  ATSC_ADDR_2FDD_reg                                                      0xB8157F74
#define  ATSC_ADDR_2FDD_inst_addr                                                "0x058B"
#define  set_ATSC_ADDR_2FDD_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FDD_reg)=data)
#define  get_ATSC_ADDR_2FDD_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FDD_reg))
#define  ATSC_ADDR_2FDD_mse_31_24_shift                                          (0)
#define  ATSC_ADDR_2FDD_mse_31_24_mask                                           (0x000000FF)
#define  ATSC_ADDR_2FDD_mse_31_24(data)                                          (0x000000FF&(data))
#define  ATSC_ADDR_2FDD_get_mse_31_24(data)                                      (0x000000FF&(data))

#define  ATSC_ADDR_2FDE                                                         0x18157F78
#define  ATSC_ADDR_2FDE_reg_addr                                                 "0xB8157F78"
#define  ATSC_ADDR_2FDE_reg                                                      0xB8157F78
#define  ATSC_ADDR_2FDE_inst_addr                                                "0x058C"
#define  set_ATSC_ADDR_2FDE_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FDE_reg)=data)
#define  get_ATSC_ADDR_2FDE_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FDE_reg))
#define  ATSC_ADDR_2FDE_mse_field_5_0_shift                                      (2)
#define  ATSC_ADDR_2FDE_mse_33_32_shift                                          (0)
#define  ATSC_ADDR_2FDE_mse_field_5_0_mask                                       (0x000000FC)
#define  ATSC_ADDR_2FDE_mse_33_32_mask                                           (0x00000003)
#define  ATSC_ADDR_2FDE_mse_field_5_0(data)                                      (0x000000FC&((data)<<2))
#define  ATSC_ADDR_2FDE_mse_33_32(data)                                          (0x00000003&(data))
#define  ATSC_ADDR_2FDE_get_mse_field_5_0(data)                                  ((0x000000FC&(data))>>2)
#define  ATSC_ADDR_2FDE_get_mse_33_32(data)                                      (0x00000003&(data))

#define  ATSC_ADDR_2FDF                                                         0x18157F7C
#define  ATSC_ADDR_2FDF_reg_addr                                                 "0xB8157F7C"
#define  ATSC_ADDR_2FDF_reg                                                      0xB8157F7C
#define  ATSC_ADDR_2FDF_inst_addr                                                "0x058D"
#define  set_ATSC_ADDR_2FDF_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FDF_reg)=data)
#define  get_ATSC_ADDR_2FDF_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FDF_reg))
#define  ATSC_ADDR_2FDF_mse_field_13_6_shift                                     (0)
#define  ATSC_ADDR_2FDF_mse_field_13_6_mask                                      (0x000000FF)
#define  ATSC_ADDR_2FDF_mse_field_13_6(data)                                     (0x000000FF&(data))
#define  ATSC_ADDR_2FDF_get_mse_field_13_6(data)                                 (0x000000FF&(data))

#define  ATSC_ADDR_2FE0                                                         0x18157F80
#define  ATSC_ADDR_2FE0_reg_addr                                                 "0xB8157F80"
#define  ATSC_ADDR_2FE0_reg                                                      0xB8157F80
#define  ATSC_ADDR_2FE0_inst_addr                                                "0x058E"
#define  set_ATSC_ADDR_2FE0_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FE0_reg)=data)
#define  get_ATSC_ADDR_2FE0_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FE0_reg))
#define  ATSC_ADDR_2FE0_mse_field_21_14_shift                                    (0)
#define  ATSC_ADDR_2FE0_mse_field_21_14_mask                                     (0x000000FF)
#define  ATSC_ADDR_2FE0_mse_field_21_14(data)                                    (0x000000FF&(data))
#define  ATSC_ADDR_2FE0_get_mse_field_21_14(data)                                (0x000000FF&(data))

#define  ATSC_ADDR_2FE1                                                         0x18157F84
#define  ATSC_ADDR_2FE1_reg_addr                                                 "0xB8157F84"
#define  ATSC_ADDR_2FE1_reg                                                      0xB8157F84
#define  ATSC_ADDR_2FE1_inst_addr                                                "0x058F"
#define  set_ATSC_ADDR_2FE1_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FE1_reg)=data)
#define  get_ATSC_ADDR_2FE1_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FE1_reg))
#define  ATSC_ADDR_2FE1_mse_field_29_22_shift                                    (0)
#define  ATSC_ADDR_2FE1_mse_field_29_22_mask                                     (0x000000FF)
#define  ATSC_ADDR_2FE1_mse_field_29_22(data)                                    (0x000000FF&(data))
#define  ATSC_ADDR_2FE1_get_mse_field_29_22(data)                                (0x000000FF&(data))

#define  ATSC_ADDR_2FE2                                                         0x18157F88
#define  ATSC_ADDR_2FE2_reg_addr                                                 "0xB8157F88"
#define  ATSC_ADDR_2FE2_reg                                                      0xB8157F88
#define  ATSC_ADDR_2FE2_inst_addr                                                "0x0590"
#define  set_ATSC_ADDR_2FE2_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FE2_reg)=data)
#define  get_ATSC_ADDR_2FE2_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FE2_reg))
#define  ATSC_ADDR_2FE2_mse_field_33_30_shift                                    (0)
#define  ATSC_ADDR_2FE2_mse_field_33_30_mask                                     (0x0000000F)
#define  ATSC_ADDR_2FE2_mse_field_33_30(data)                                    (0x0000000F&(data))
#define  ATSC_ADDR_2FE2_get_mse_field_33_30(data)                                (0x0000000F&(data))

#define  ATSC_ADDR_2FE3                                                         0x18157F8C
#define  ATSC_ADDR_2FE3_reg_addr                                                 "0xB8157F8C"
#define  ATSC_ADDR_2FE3_reg                                                      0xB8157F8C
#define  ATSC_ADDR_2FE3_inst_addr                                                "0x0591"
#define  set_ATSC_ADDR_2FE3_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FE3_reg)=data)
#define  get_ATSC_ADDR_2FE3_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FE3_reg))
#define  ATSC_ADDR_2FE3_ld_mse_field_sel_shift                                   (7)
#define  ATSC_ADDR_2FE3_out_unlock_valid_shift                                   (6)
#define  ATSC_ADDR_2FE3_unlock_ind_shift                                         (5)
#define  ATSC_ADDR_2FE3_ld_start_shift                                           (4)
#define  ATSC_ADDR_2FE3_outer_unlock_ind_shift                                   (3)
#define  ATSC_ADDR_2FE3_ld_ao_start_shift                                        (2)
#define  ATSC_ADDR_2FE3_inner_unlock_ind_shift                                   (1)
#define  ATSC_ADDR_2FE3_ld_ai_start_shift                                        (0)
#define  ATSC_ADDR_2FE3_ld_mse_field_sel_mask                                    (0x00000080)
#define  ATSC_ADDR_2FE3_out_unlock_valid_mask                                    (0x00000040)
#define  ATSC_ADDR_2FE3_unlock_ind_mask                                          (0x00000020)
#define  ATSC_ADDR_2FE3_ld_start_mask                                            (0x00000010)
#define  ATSC_ADDR_2FE3_outer_unlock_ind_mask                                    (0x00000008)
#define  ATSC_ADDR_2FE3_ld_ao_start_mask                                         (0x00000004)
#define  ATSC_ADDR_2FE3_inner_unlock_ind_mask                                    (0x00000002)
#define  ATSC_ADDR_2FE3_ld_ai_start_mask                                         (0x00000001)
#define  ATSC_ADDR_2FE3_ld_mse_field_sel(data)                                   (0x00000080&((data)<<7))
#define  ATSC_ADDR_2FE3_out_unlock_valid(data)                                   (0x00000040&((data)<<6))
#define  ATSC_ADDR_2FE3_unlock_ind(data)                                         (0x00000020&((data)<<5))
#define  ATSC_ADDR_2FE3_ld_start(data)                                           (0x00000010&((data)<<4))
#define  ATSC_ADDR_2FE3_outer_unlock_ind(data)                                   (0x00000008&((data)<<3))
#define  ATSC_ADDR_2FE3_ld_ao_start(data)                                        (0x00000004&((data)<<2))
#define  ATSC_ADDR_2FE3_inner_unlock_ind(data)                                   (0x00000002&((data)<<1))
#define  ATSC_ADDR_2FE3_ld_ai_start(data)                                        (0x00000001&(data))
#define  ATSC_ADDR_2FE3_get_ld_mse_field_sel(data)                               ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2FE3_get_out_unlock_valid(data)                               ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2FE3_get_unlock_ind(data)                                     ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2FE3_get_ld_start(data)                                       ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2FE3_get_outer_unlock_ind(data)                               ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2FE3_get_ld_ao_start(data)                                    ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2FE3_get_inner_unlock_ind(data)                               ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2FE3_get_ld_ai_start(data)                                    (0x00000001&(data))

#define  ATSC_ADDR_2FE4                                                         0x18157F90
#define  ATSC_ADDR_2FE4_reg_addr                                                 "0xB8157F90"
#define  ATSC_ADDR_2FE4_reg                                                      0xB8157F90
#define  ATSC_ADDR_2FE4_inst_addr                                                "0x0592"
#define  set_ATSC_ADDR_2FE4_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FE4_reg)=data)
#define  get_ATSC_ADDR_2FE4_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FE4_reg))
#define  ATSC_ADDR_2FE4_ft_if_agc_ind_shift                                      (7)
#define  ATSC_ADDR_2FE4_ft_rs_un_corr_ind_shift                                  (6)
#define  ATSC_ADDR_2FE4_ft_rs_corr_ind_shift                                     (5)
#define  ATSC_ADDR_2FE4_ft_rs_ser_trig_ind_shift                                 (4)
#define  ATSC_ADDR_2FE4_ft_mse_field_ind_shift                                   (3)
#define  ATSC_ADDR_2FE4_ft_mse_ind_shift                                         (2)
#define  ATSC_ADDR_2FE4_ft_final_state_ind_shift                                 (1)
#define  ATSC_ADDR_2FE4_ft_valid_flag_shift                                      (0)
#define  ATSC_ADDR_2FE4_ft_if_agc_ind_mask                                       (0x00000080)
#define  ATSC_ADDR_2FE4_ft_rs_un_corr_ind_mask                                   (0x00000040)
#define  ATSC_ADDR_2FE4_ft_rs_corr_ind_mask                                      (0x00000020)
#define  ATSC_ADDR_2FE4_ft_rs_ser_trig_ind_mask                                  (0x00000010)
#define  ATSC_ADDR_2FE4_ft_mse_field_ind_mask                                    (0x00000008)
#define  ATSC_ADDR_2FE4_ft_mse_ind_mask                                          (0x00000004)
#define  ATSC_ADDR_2FE4_ft_final_state_ind_mask                                  (0x00000002)
#define  ATSC_ADDR_2FE4_ft_valid_flag_mask                                       (0x00000001)
#define  ATSC_ADDR_2FE4_ft_if_agc_ind(data)                                      (0x00000080&((data)<<7))
#define  ATSC_ADDR_2FE4_ft_rs_un_corr_ind(data)                                  (0x00000040&((data)<<6))
#define  ATSC_ADDR_2FE4_ft_rs_corr_ind(data)                                     (0x00000020&((data)<<5))
#define  ATSC_ADDR_2FE4_ft_rs_ser_trig_ind(data)                                 (0x00000010&((data)<<4))
#define  ATSC_ADDR_2FE4_ft_mse_field_ind(data)                                   (0x00000008&((data)<<3))
#define  ATSC_ADDR_2FE4_ft_mse_ind(data)                                         (0x00000004&((data)<<2))
#define  ATSC_ADDR_2FE4_ft_final_state_ind(data)                                 (0x00000002&((data)<<1))
#define  ATSC_ADDR_2FE4_ft_valid_flag(data)                                      (0x00000001&(data))
#define  ATSC_ADDR_2FE4_get_ft_if_agc_ind(data)                                  ((0x00000080&(data))>>7)
#define  ATSC_ADDR_2FE4_get_ft_rs_un_corr_ind(data)                              ((0x00000040&(data))>>6)
#define  ATSC_ADDR_2FE4_get_ft_rs_corr_ind(data)                                 ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2FE4_get_ft_rs_ser_trig_ind(data)                             ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2FE4_get_ft_mse_field_ind(data)                               ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2FE4_get_ft_mse_ind(data)                                     ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2FE4_get_ft_final_state_ind(data)                             ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2FE4_get_ft_valid_flag(data)                                  (0x00000001&(data))

#define  ATSC_ADDR_2FE5                                                         0x18157F94
#define  ATSC_ADDR_2FE5_reg_addr                                                 "0xB8157F94"
#define  ATSC_ADDR_2FE5_reg                                                      0xB8157F94
#define  ATSC_ADDR_2FE5_inst_addr                                                "0x0593"
#define  set_ATSC_ADDR_2FE5_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FE5_reg)=data)
#define  get_ATSC_ADDR_2FE5_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FE5_reg))
#define  ATSC_ADDR_2FE5_eq_fifo_full_ind_shift                                   (3)
#define  ATSC_ADDR_2FE5_ft_ind_shift                                             (2)
#define  ATSC_ADDR_2FE5_ft_dagc_lvl_ind_shift                                    (1)
#define  ATSC_ADDR_2FE5_ft_rf_agc_ind_shift                                      (0)
#define  ATSC_ADDR_2FE5_eq_fifo_full_ind_mask                                    (0x00000008)
#define  ATSC_ADDR_2FE5_ft_ind_mask                                              (0x00000004)
#define  ATSC_ADDR_2FE5_ft_dagc_lvl_ind_mask                                     (0x00000002)
#define  ATSC_ADDR_2FE5_ft_rf_agc_ind_mask                                       (0x00000001)
#define  ATSC_ADDR_2FE5_eq_fifo_full_ind(data)                                   (0x00000008&((data)<<3))
#define  ATSC_ADDR_2FE5_ft_ind(data)                                             (0x00000004&((data)<<2))
#define  ATSC_ADDR_2FE5_ft_dagc_lvl_ind(data)                                    (0x00000002&((data)<<1))
#define  ATSC_ADDR_2FE5_ft_rf_agc_ind(data)                                      (0x00000001&(data))
#define  ATSC_ADDR_2FE5_get_eq_fifo_full_ind(data)                               ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2FE5_get_ft_ind(data)                                         ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2FE5_get_ft_dagc_lvl_ind(data)                                ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2FE5_get_ft_rf_agc_ind(data)                                  (0x00000001&(data))

#define  ATSC_ADDR_2FE6                                                         0x18157F98
#define  ATSC_ADDR_2FE6_reg_addr                                                 "0xB8157F98"
#define  ATSC_ADDR_2FE6_reg                                                      0xB8157F98
#define  ATSC_ADDR_2FE6_inst_addr                                                "0x0594"
#define  set_ATSC_ADDR_2FE6_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FE6_reg)=data)
#define  get_ATSC_ADDR_2FE6_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FE6_reg))
#define  ATSC_ADDR_2FE6_ao_rs_ber_cnt_7_0_shift                                  (0)
#define  ATSC_ADDR_2FE6_ao_rs_ber_cnt_7_0_mask                                   (0x000000FF)
#define  ATSC_ADDR_2FE6_ao_rs_ber_cnt_7_0(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2FE6_get_ao_rs_ber_cnt_7_0(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2FE7                                                         0x18157F9C
#define  ATSC_ADDR_2FE7_reg_addr                                                 "0xB8157F9C"
#define  ATSC_ADDR_2FE7_reg                                                      0xB8157F9C
#define  ATSC_ADDR_2FE7_inst_addr                                                "0x0595"
#define  set_ATSC_ADDR_2FE7_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FE7_reg)=data)
#define  get_ATSC_ADDR_2FE7_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FE7_reg))
#define  ATSC_ADDR_2FE7_ao_rs_ber_cnt_15_8_shift                                 (0)
#define  ATSC_ADDR_2FE7_ao_rs_ber_cnt_15_8_mask                                  (0x000000FF)
#define  ATSC_ADDR_2FE7_ao_rs_ber_cnt_15_8(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2FE7_get_ao_rs_ber_cnt_15_8(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2FE8                                                         0x18157FA0
#define  ATSC_ADDR_2FE8_reg_addr                                                 "0xB8157FA0"
#define  ATSC_ADDR_2FE8_reg                                                      0xB8157FA0
#define  ATSC_ADDR_2FE8_inst_addr                                                "0x0596"
#define  set_ATSC_ADDR_2FE8_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FE8_reg)=data)
#define  get_ATSC_ADDR_2FE8_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FE8_reg))
#define  ATSC_ADDR_2FE8_ao_rs_ber_cnt_23_16_shift                                (0)
#define  ATSC_ADDR_2FE8_ao_rs_ber_cnt_23_16_mask                                 (0x000000FF)
#define  ATSC_ADDR_2FE8_ao_rs_ber_cnt_23_16(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2FE8_get_ao_rs_ber_cnt_23_16(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2FE9                                                         0x18157FA4
#define  ATSC_ADDR_2FE9_reg_addr                                                 "0xB8157FA4"
#define  ATSC_ADDR_2FE9_reg                                                      0xB8157FA4
#define  ATSC_ADDR_2FE9_inst_addr                                                "0x0597"
#define  set_ATSC_ADDR_2FE9_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FE9_reg)=data)
#define  get_ATSC_ADDR_2FE9_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FE9_reg))
#define  ATSC_ADDR_2FE9_ao_rs_ser_trig_shift                                     (4)
#define  ATSC_ADDR_2FE9_ao_rs_ber_cnt_27_24_shift                                (0)
#define  ATSC_ADDR_2FE9_ao_rs_ser_trig_mask                                      (0x00000010)
#define  ATSC_ADDR_2FE9_ao_rs_ber_cnt_27_24_mask                                 (0x0000000F)
#define  ATSC_ADDR_2FE9_ao_rs_ser_trig(data)                                     (0x00000010&((data)<<4))
#define  ATSC_ADDR_2FE9_ao_rs_ber_cnt_27_24(data)                                (0x0000000F&(data))
#define  ATSC_ADDR_2FE9_get_ao_rs_ser_trig(data)                                 ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2FE9_get_ao_rs_ber_cnt_27_24(data)                            (0x0000000F&(data))

#define  ATSC_ADDR_2FEA                                                         0x18157FA8
#define  ATSC_ADDR_2FEA_reg_addr                                                 "0xB8157FA8"
#define  ATSC_ADDR_2FEA_reg                                                      0xB8157FA8
#define  ATSC_ADDR_2FEA_inst_addr                                                "0x0598"
#define  set_ATSC_ADDR_2FEA_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FEA_reg)=data)
#define  get_ATSC_ADDR_2FEA_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FEA_reg))
#define  ATSC_ADDR_2FEA_ao_rs_pkt_cnt_7_0_shift                                  (0)
#define  ATSC_ADDR_2FEA_ao_rs_pkt_cnt_7_0_mask                                   (0x000000FF)
#define  ATSC_ADDR_2FEA_ao_rs_pkt_cnt_7_0(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2FEA_get_ao_rs_pkt_cnt_7_0(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2FEB                                                         0x18157FAC
#define  ATSC_ADDR_2FEB_reg_addr                                                 "0xB8157FAC"
#define  ATSC_ADDR_2FEB_reg                                                      0xB8157FAC
#define  ATSC_ADDR_2FEB_inst_addr                                                "0x0599"
#define  set_ATSC_ADDR_2FEB_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FEB_reg)=data)
#define  get_ATSC_ADDR_2FEB_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FEB_reg))
#define  ATSC_ADDR_2FEB_ao_rs_pkt_cnt_15_8_shift                                 (0)
#define  ATSC_ADDR_2FEB_ao_rs_pkt_cnt_15_8_mask                                  (0x000000FF)
#define  ATSC_ADDR_2FEB_ao_rs_pkt_cnt_15_8(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2FEB_get_ao_rs_pkt_cnt_15_8(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2FEC                                                         0x18157FB0
#define  ATSC_ADDR_2FEC_reg_addr                                                 "0xB8157FB0"
#define  ATSC_ADDR_2FEC_reg                                                      0xB8157FB0
#define  ATSC_ADDR_2FEC_inst_addr                                                "0x059A"
#define  set_ATSC_ADDR_2FEC_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FEC_reg)=data)
#define  get_ATSC_ADDR_2FEC_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FEC_reg))
#define  ATSC_ADDR_2FEC_ao_rs_pkt_cnt_23_16_shift                                (0)
#define  ATSC_ADDR_2FEC_ao_rs_pkt_cnt_23_16_mask                                 (0x000000FF)
#define  ATSC_ADDR_2FEC_ao_rs_pkt_cnt_23_16(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2FEC_get_ao_rs_pkt_cnt_23_16(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2FED                                                         0x18157FB4
#define  ATSC_ADDR_2FED_reg_addr                                                 "0xB8157FB4"
#define  ATSC_ADDR_2FED_reg                                                      0xB8157FB4
#define  ATSC_ADDR_2FED_inst_addr                                                "0x059B"
#define  set_ATSC_ADDR_2FED_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FED_reg)=data)
#define  get_ATSC_ADDR_2FED_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FED_reg))
#define  ATSC_ADDR_2FED_ao_rs_corr_cnt_7_0_shift                                 (0)
#define  ATSC_ADDR_2FED_ao_rs_corr_cnt_7_0_mask                                  (0x000000FF)
#define  ATSC_ADDR_2FED_ao_rs_corr_cnt_7_0(data)                                 (0x000000FF&(data))
#define  ATSC_ADDR_2FED_get_ao_rs_corr_cnt_7_0(data)                             (0x000000FF&(data))

#define  ATSC_ADDR_2FEE                                                         0x18157FB8
#define  ATSC_ADDR_2FEE_reg_addr                                                 "0xB8157FB8"
#define  ATSC_ADDR_2FEE_reg                                                      0xB8157FB8
#define  ATSC_ADDR_2FEE_inst_addr                                                "0x059C"
#define  set_ATSC_ADDR_2FEE_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FEE_reg)=data)
#define  get_ATSC_ADDR_2FEE_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FEE_reg))
#define  ATSC_ADDR_2FEE_ao_rs_corr_cnt_15_8_shift                                (0)
#define  ATSC_ADDR_2FEE_ao_rs_corr_cnt_15_8_mask                                 (0x000000FF)
#define  ATSC_ADDR_2FEE_ao_rs_corr_cnt_15_8(data)                                (0x000000FF&(data))
#define  ATSC_ADDR_2FEE_get_ao_rs_corr_cnt_15_8(data)                            (0x000000FF&(data))

#define  ATSC_ADDR_2FEF                                                         0x18157FBC
#define  ATSC_ADDR_2FEF_reg_addr                                                 "0xB8157FBC"
#define  ATSC_ADDR_2FEF_reg                                                      0xB8157FBC
#define  ATSC_ADDR_2FEF_inst_addr                                                "0x059D"
#define  set_ATSC_ADDR_2FEF_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FEF_reg)=data)
#define  get_ATSC_ADDR_2FEF_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FEF_reg))
#define  ATSC_ADDR_2FEF_ao_rs_corr_cnt_23_16_shift                               (0)
#define  ATSC_ADDR_2FEF_ao_rs_corr_cnt_23_16_mask                                (0x000000FF)
#define  ATSC_ADDR_2FEF_ao_rs_corr_cnt_23_16(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_2FEF_get_ao_rs_corr_cnt_23_16(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_2FF0                                                         0x18157FC0
#define  ATSC_ADDR_2FF0_reg_addr                                                 "0xB8157FC0"
#define  ATSC_ADDR_2FF0_reg                                                      0xB8157FC0
#define  ATSC_ADDR_2FF0_inst_addr                                                "0x059E"
#define  set_ATSC_ADDR_2FF0_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FF0_reg)=data)
#define  get_ATSC_ADDR_2FF0_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FF0_reg))
#define  ATSC_ADDR_2FF0_ao_rs_uncorr_cnt_7_0_shift                               (0)
#define  ATSC_ADDR_2FF0_ao_rs_uncorr_cnt_7_0_mask                                (0x000000FF)
#define  ATSC_ADDR_2FF0_ao_rs_uncorr_cnt_7_0(data)                               (0x000000FF&(data))
#define  ATSC_ADDR_2FF0_get_ao_rs_uncorr_cnt_7_0(data)                           (0x000000FF&(data))

#define  ATSC_ADDR_2FF1                                                         0x18157FC4
#define  ATSC_ADDR_2FF1_reg_addr                                                 "0xB8157FC4"
#define  ATSC_ADDR_2FF1_reg                                                      0xB8157FC4
#define  ATSC_ADDR_2FF1_inst_addr                                                "0x059F"
#define  set_ATSC_ADDR_2FF1_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FF1_reg)=data)
#define  get_ATSC_ADDR_2FF1_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FF1_reg))
#define  ATSC_ADDR_2FF1_ao_rs_uncorr_cnt_15_8_shift                              (0)
#define  ATSC_ADDR_2FF1_ao_rs_uncorr_cnt_15_8_mask                               (0x000000FF)
#define  ATSC_ADDR_2FF1_ao_rs_uncorr_cnt_15_8(data)                              (0x000000FF&(data))
#define  ATSC_ADDR_2FF1_get_ao_rs_uncorr_cnt_15_8(data)                          (0x000000FF&(data))

#define  ATSC_ADDR_2FF2                                                         0x18157FC8
#define  ATSC_ADDR_2FF2_reg_addr                                                 "0xB8157FC8"
#define  ATSC_ADDR_2FF2_reg                                                      0xB8157FC8
#define  ATSC_ADDR_2FF2_inst_addr                                                "0x05A0"
#define  set_ATSC_ADDR_2FF2_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FF2_reg)=data)
#define  get_ATSC_ADDR_2FF2_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FF2_reg))
#define  ATSC_ADDR_2FF2_ao_rs_uncorr_cnt_23_16_shift                             (0)
#define  ATSC_ADDR_2FF2_ao_rs_uncorr_cnt_23_16_mask                              (0x000000FF)
#define  ATSC_ADDR_2FF2_ao_rs_uncorr_cnt_23_16(data)                             (0x000000FF&(data))
#define  ATSC_ADDR_2FF2_get_ao_rs_uncorr_cnt_23_16(data)                         (0x000000FF&(data))

#define  ATSC_ADDR_2FF3                                                         0x18157FCC
#define  ATSC_ADDR_2FF3_reg_addr                                                 "0xB8157FCC"
#define  ATSC_ADDR_2FF3_reg                                                      0xB8157FCC
#define  ATSC_ADDR_2FF3_inst_addr                                                "0x05A1"
#define  set_ATSC_ADDR_2FF3_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FF3_reg)=data)
#define  get_ATSC_ADDR_2FF3_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FF3_reg))
#define  ATSC_ADDR_2FF3_tre_ber_cnt_7_0_shift                                    (0)
#define  ATSC_ADDR_2FF3_tre_ber_cnt_7_0_mask                                     (0x000000FF)
#define  ATSC_ADDR_2FF3_tre_ber_cnt_7_0(data)                                    (0x000000FF&(data))
#define  ATSC_ADDR_2FF3_get_tre_ber_cnt_7_0(data)                                (0x000000FF&(data))

#define  ATSC_ADDR_2FF4                                                         0x18157FD0
#define  ATSC_ADDR_2FF4_reg_addr                                                 "0xB8157FD0"
#define  ATSC_ADDR_2FF4_reg                                                      0xB8157FD0
#define  ATSC_ADDR_2FF4_inst_addr                                                "0x05A2"
#define  set_ATSC_ADDR_2FF4_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FF4_reg)=data)
#define  get_ATSC_ADDR_2FF4_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FF4_reg))
#define  ATSC_ADDR_2FF4_tre_ber_cnt_15_8_shift                                   (0)
#define  ATSC_ADDR_2FF4_tre_ber_cnt_15_8_mask                                    (0x000000FF)
#define  ATSC_ADDR_2FF4_tre_ber_cnt_15_8(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_2FF4_get_tre_ber_cnt_15_8(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_2FF5                                                         0x18157FD4
#define  ATSC_ADDR_2FF5_reg_addr                                                 "0xB8157FD4"
#define  ATSC_ADDR_2FF5_reg                                                      0xB8157FD4
#define  ATSC_ADDR_2FF5_inst_addr                                                "0x05A3"
#define  set_ATSC_ADDR_2FF5_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FF5_reg)=data)
#define  get_ATSC_ADDR_2FF5_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FF5_reg))
#define  ATSC_ADDR_2FF5_tre_ber_cnt_23_16_shift                                  (0)
#define  ATSC_ADDR_2FF5_tre_ber_cnt_23_16_mask                                   (0x000000FF)
#define  ATSC_ADDR_2FF5_tre_ber_cnt_23_16(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2FF5_get_tre_ber_cnt_23_16(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2FF6                                                         0x18157FD8
#define  ATSC_ADDR_2FF6_reg_addr                                                 "0xB8157FD8"
#define  ATSC_ADDR_2FF6_reg                                                      0xB8157FD8
#define  ATSC_ADDR_2FF6_inst_addr                                                "0x05A4"
#define  set_ATSC_ADDR_2FF6_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FF6_reg)=data)
#define  get_ATSC_ADDR_2FF6_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FF6_reg))
#define  ATSC_ADDR_2FF6_tre_ber_cnt_31_24_shift                                  (0)
#define  ATSC_ADDR_2FF6_tre_ber_cnt_31_24_mask                                   (0x000000FF)
#define  ATSC_ADDR_2FF6_tre_ber_cnt_31_24(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2FF6_get_tre_ber_cnt_31_24(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2FF7                                                         0x18157FDC
#define  ATSC_ADDR_2FF7_reg_addr                                                 "0xB8157FDC"
#define  ATSC_ADDR_2FF7_reg                                                      0xB8157FDC
#define  ATSC_ADDR_2FF7_inst_addr                                                "0x05A5"
#define  set_ATSC_ADDR_2FF7_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FF7_reg)=data)
#define  get_ATSC_ADDR_2FF7_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FF7_reg))
#define  ATSC_ADDR_2FF7_tre_ber_cnt_39_32_shift                                  (0)
#define  ATSC_ADDR_2FF7_tre_ber_cnt_39_32_mask                                   (0x000000FF)
#define  ATSC_ADDR_2FF7_tre_ber_cnt_39_32(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2FF7_get_tre_ber_cnt_39_32(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2FF8                                                         0x18157FE0
#define  ATSC_ADDR_2FF8_reg_addr                                                 "0xB8157FE0"
#define  ATSC_ADDR_2FF8_reg                                                      0xB8157FE0
#define  ATSC_ADDR_2FF8_inst_addr                                                "0x05A6"
#define  set_ATSC_ADDR_2FF8_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FF8_reg)=data)
#define  get_ATSC_ADDR_2FF8_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FF8_reg))
#define  ATSC_ADDR_2FF8_tre_seg_cnt_7_0_shift                                    (0)
#define  ATSC_ADDR_2FF8_tre_seg_cnt_7_0_mask                                     (0x000000FF)
#define  ATSC_ADDR_2FF8_tre_seg_cnt_7_0(data)                                    (0x000000FF&(data))
#define  ATSC_ADDR_2FF8_get_tre_seg_cnt_7_0(data)                                (0x000000FF&(data))

#define  ATSC_ADDR_2FF9                                                         0x18157FE4
#define  ATSC_ADDR_2FF9_reg_addr                                                 "0xB8157FE4"
#define  ATSC_ADDR_2FF9_reg                                                      0xB8157FE4
#define  ATSC_ADDR_2FF9_inst_addr                                                "0x05A7"
#define  set_ATSC_ADDR_2FF9_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FF9_reg)=data)
#define  get_ATSC_ADDR_2FF9_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FF9_reg))
#define  ATSC_ADDR_2FF9_tre_seg_cnt_15_8_shift                                   (0)
#define  ATSC_ADDR_2FF9_tre_seg_cnt_15_8_mask                                    (0x000000FF)
#define  ATSC_ADDR_2FF9_tre_seg_cnt_15_8(data)                                   (0x000000FF&(data))
#define  ATSC_ADDR_2FF9_get_tre_seg_cnt_15_8(data)                               (0x000000FF&(data))

#define  ATSC_ADDR_2FFA                                                         0x18157FE8
#define  ATSC_ADDR_2FFA_reg_addr                                                 "0xB8157FE8"
#define  ATSC_ADDR_2FFA_reg                                                      0xB8157FE8
#define  ATSC_ADDR_2FFA_inst_addr                                                "0x05A8"
#define  set_ATSC_ADDR_2FFA_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FFA_reg)=data)
#define  get_ATSC_ADDR_2FFA_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FFA_reg))
#define  ATSC_ADDR_2FFA_tre_seg_cnt_23_16_shift                                  (0)
#define  ATSC_ADDR_2FFA_tre_seg_cnt_23_16_mask                                   (0x000000FF)
#define  ATSC_ADDR_2FFA_tre_seg_cnt_23_16(data)                                  (0x000000FF&(data))
#define  ATSC_ADDR_2FFA_get_tre_seg_cnt_23_16(data)                              (0x000000FF&(data))

#define  ATSC_ADDR_2FFB                                                         0x18157FEC
#define  ATSC_ADDR_2FFB_reg_addr                                                 "0xB8157FEC"
#define  ATSC_ADDR_2FFB_reg                                                      0xB8157FEC
#define  ATSC_ADDR_2FFB_inst_addr                                                "0x05A9"
#define  set_ATSC_ADDR_2FFB_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FFB_reg)=data)
#define  get_ATSC_ADDR_2FFB_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FFB_reg))
#define  ATSC_ADDR_2FFB_fsm_mbist_fail_1_shift                                   (5)
#define  ATSC_ADDR_2FFB_fsm_mbist_fail_0_shift                                   (4)
#define  ATSC_ADDR_2FFB_fsm_drf_fail_1_shift                                     (3)
#define  ATSC_ADDR_2FFB_fsm_drf_fail_0_shift                                     (2)
#define  ATSC_ADDR_2FFB_atsc_drf_bist_done_shift                                 (1)
#define  ATSC_ADDR_2FFB_atsc_bist_done_shift                                     (0)
#define  ATSC_ADDR_2FFB_fsm_mbist_fail_1_mask                                    (0x00000020)
#define  ATSC_ADDR_2FFB_fsm_mbist_fail_0_mask                                    (0x00000010)
#define  ATSC_ADDR_2FFB_fsm_drf_fail_1_mask                                      (0x00000008)
#define  ATSC_ADDR_2FFB_fsm_drf_fail_0_mask                                      (0x00000004)
#define  ATSC_ADDR_2FFB_atsc_drf_bist_done_mask                                  (0x00000002)
#define  ATSC_ADDR_2FFB_atsc_bist_done_mask                                      (0x00000001)
#define  ATSC_ADDR_2FFB_fsm_mbist_fail_1(data)                                   (0x00000020&((data)<<5))
#define  ATSC_ADDR_2FFB_fsm_mbist_fail_0(data)                                   (0x00000010&((data)<<4))
#define  ATSC_ADDR_2FFB_fsm_drf_fail_1(data)                                     (0x00000008&((data)<<3))
#define  ATSC_ADDR_2FFB_fsm_drf_fail_0(data)                                     (0x00000004&((data)<<2))
#define  ATSC_ADDR_2FFB_atsc_drf_bist_done(data)                                 (0x00000002&((data)<<1))
#define  ATSC_ADDR_2FFB_atsc_bist_done(data)                                     (0x00000001&(data))
#define  ATSC_ADDR_2FFB_get_fsm_mbist_fail_1(data)                               ((0x00000020&(data))>>5)
#define  ATSC_ADDR_2FFB_get_fsm_mbist_fail_0(data)                               ((0x00000010&(data))>>4)
#define  ATSC_ADDR_2FFB_get_fsm_drf_fail_1(data)                                 ((0x00000008&(data))>>3)
#define  ATSC_ADDR_2FFB_get_fsm_drf_fail_0(data)                                 ((0x00000004&(data))>>2)
#define  ATSC_ADDR_2FFB_get_atsc_drf_bist_done(data)                             ((0x00000002&(data))>>1)
#define  ATSC_ADDR_2FFB_get_atsc_bist_done(data)                                 (0x00000001&(data))

#define  ATSC_ADDR_2FFD                                                         0x18157FF4
#define  ATSC_ADDR_2FFD_reg_addr                                                 "0xB8157FF4"
#define  ATSC_ADDR_2FFD_reg                                                      0xB8157FF4
#define  ATSC_ADDR_2FFD_inst_addr                                                "0x05AA"
#define  set_ATSC_ADDR_2FFD_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FFD_reg)=data)
#define  get_ATSC_ADDR_2FFD_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FFD_reg))
#define  ATSC_ADDR_2FFD_ao_pkt_ser_num_shift                                     (0)
#define  ATSC_ADDR_2FFD_ao_pkt_ser_num_mask                                      (0x000000FF)
#define  ATSC_ADDR_2FFD_ao_pkt_ser_num(data)                                     (0x000000FF&(data))
#define  ATSC_ADDR_2FFD_get_ao_pkt_ser_num(data)                                 (0x000000FF&(data))

#define  ATSC_ADDR_2FFE                                                         0x18157FF8
#define  ATSC_ADDR_2FFE_reg_addr                                                 "0xB8157FF8"
#define  ATSC_ADDR_2FFE_reg                                                      0xB8157FF8
#define  ATSC_ADDR_2FFE_inst_addr                                                "0x05AB"
#define  set_ATSC_ADDR_2FFE_reg(data)                                            (*((volatile unsigned int*)ATSC_ADDR_2FFE_reg)=data)
#define  get_ATSC_ADDR_2FFE_reg                                                  (*((volatile unsigned int*)ATSC_ADDR_2FFE_reg))
#define  ATSC_ADDR_2FFE_atsc_drf_pause_shift                                     (0)
#define  ATSC_ADDR_2FFE_atsc_drf_pause_mask                                      (0x00000001)
#define  ATSC_ADDR_2FFE_atsc_drf_pause(data)                                     (0x00000001&(data))
#define  ATSC_ADDR_2FFE_get_atsc_drf_pause(data)                                 (0x00000001&(data))

#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======ATSC register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  atsc_version:8;
    };
}atsc_addr_2001_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  opt_atsc_on:1;
    };
}atsc_addr_2004_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  opt_soft_reset_atsc:1;
    };
}atsc_addr_2005_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  opt_adcclkin_atsc:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  opt_adcdata_atsc:2;
    };
}atsc_addr_2007_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  opt_rf_aagc_oe:1;
        RBus_UInt32  opt_rf_aagc_pol:1;
        RBus_UInt32  opt_rf_agc_drive:1;
        RBus_UInt32  opt_rf_aagc_sel:3;
    };
}atsc_addr_2009_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  opt_if_aagc_oe:1;
        RBus_UInt32  opt_if_aagc_pol:1;
        RBus_UInt32  opt_if_agc_drive:1;
        RBus_UInt32  opt_if_aagc_sel:3;
    };
}atsc_addr_200a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_mpeg_out_reg_4_0:5;
        RBus_UInt32  opt_mpeg_out_sel:3;
    };
}atsc_addr_200b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  opt_mpeg_out_reg_11_5:7;
    };
}atsc_addr_200c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_mpeg_out2_reg_4_0:5;
        RBus_UInt32  opt_mpeg_out2_sel:3;
    };
}atsc_addr_200d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  opt_mpeg_out2_reg_11_5:7;
    };
}atsc_addr_200e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  opt_top_ant_rx_in_sel:3;
        RBus_UInt32  opt_top_ant_tx_in_sel:3;
    };
}atsc_addr_2010_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  opt_top_ant_oe_in_sel:3;
        RBus_UInt32  opt_top_ant_det_sel:3;
    };
}atsc_addr_2011_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  opt_par_saclk:1;
        RBus_UInt32  opt_par_tstclk:1;
        RBus_UInt32  opt_sa_clk_sel:2;
        RBus_UInt32  opt_tst_clk_sel:2;
    };
}atsc_addr_2013_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_atsc_tstmux2_sel:4;
        RBus_UInt32  opt_atsc_tstmux1_sel:4;
    };
}atsc_addr_2014_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  opt_tst_in_sel:4;
    };
}atsc_addr_2016_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  opt_debug_all_sel:5;
    };
}atsc_addr_2017_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_debug_all_reg_7_0:8;
    };
}atsc_addr_2018_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_debug_all_reg_15_8:8;
    };
}atsc_addr_2019_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_debug_all_reg_23_16:8;
    };
}atsc_addr_201a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_debug_all_reg_31_24:8;
    };
}atsc_addr_201b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_debug_all_reg_39_32:8;
    };
}atsc_addr_201c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_debug_all_reg_47_40:8;
    };
}atsc_addr_201d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  atsc_dummy_rw_reg_5_0:6;
        RBus_UInt32  fs2_auto_switch_result:2;
    };
}atsc_addr_202a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  atsc_dummy_rw_reg_13_6:8;
    };
}atsc_addr_202b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  atsc_dummy_rw_reg_21_14:8;
    };
}atsc_addr_202c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  opt_demod_int_n_inv:1;
        RBus_UInt32  opt_demod_int_n_sel:3;
    };
}atsc_addr_2040_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  atsc_if_agc_oe:1;
        RBus_UInt32  atsc_if_agc_o:1;
        RBus_UInt32  atsc_rf_agc_oe:1;
        RBus_UInt32  atsc_rf_agc_o:1;
    };
}atsc_addr_2051_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  atsc_ant_det:1;
        RBus_UInt32  atsc_ant_rx_in:1;
        RBus_UInt32  atsc_ant_tx_in:1;
        RBus_UInt32  atsc_ant_oe_oe:1;
        RBus_UInt32  atsc_ant_oe:1;
        RBus_UInt32  atsc_ant_tx_oe:1;
        RBus_UInt32  atsc_ant_tx:1;
    };
}atsc_addr_2052_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  rssi_agc_level_q_7_0:8;
    };
}atsc_addr_205c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  rssi_agc_loop_sat_d:1;
        RBus_UInt32  rssi_agc_level_q_13_8:6;
    };
}atsc_addr_205d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  ad7_out_d:7;
    };
}atsc_addr_205e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  opt_soft_reset_rssi_agc:1;
    };
}atsc_addr_2080_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  rssi_in_ph_sel2:1;
        RBus_UInt32  opt_ad7_ckout_inv:1;
        RBus_UInt32  rssi_agc_pol:1;
        RBus_UInt32  u_rssi_agc_exp:3;
        RBus_UInt32  rssi_in_ph_sel:1;
        RBus_UInt32  opt_rssi_agc_on:1;
    };
}atsc_addr_2081_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  rssi_in_clk_ratio:8;
    };
}atsc_addr_2082_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  rssi_agc_max:8;
    };
}atsc_addr_2083_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  rssi_agc_min:8;
    };
}atsc_addr_2084_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  rssi_agc_targ_val:7;
    };
}atsc_addr_2085_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  res2:4;
        RBus_UInt32  mh_in_sel:3;
        RBus_UInt32  mh_out_en:1;
    };
}atsc_addr_2090_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  reg_pset_aagc:1;
        RBus_UInt32  reg_hold_pga:1;
        RBus_UInt32  reg_aagc_cal_payload:1;
        RBus_UInt32  reg_aagc_hold:1;
        RBus_UInt32  reg_en_gi_pga:1;
        RBus_UInt32  reg_en_pga_mode:1;
        RBus_UInt32  reg_en_dcr:1;
        RBus_UInt32  reg_adc_clk_xor:1;
    };
}atsc_addr_20a0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  reg_pset_aagc_val:8;
    };
}atsc_addr_20a1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  reg_target_val:8;
    };
}atsc_addr_20a2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  reg_aagc_loopgain1_2_0:3;
        RBus_UInt32  reg_aagc_loopgain0:5;
    };
}atsc_addr_20a3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  reg_integral_cnt_len_0:1;
        RBus_UInt32  reg_aagc_loopgain2:5;
        RBus_UInt32  reg_aagc_loopgain1_4_3:2;
    };
}atsc_addr_20a4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  reg_aagc_lock_det_len:4;
        RBus_UInt32  reg_integral_cnt_len_4_1:4;
    };
}atsc_addr_20a5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  reg_aagc_latency_7_0:8;
    };
}atsc_addr_20a6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  reg_aagc_lock_pga_hit_len:3;
        RBus_UInt32  reg_aagc_latency_12_8:5;
    };
}atsc_addr_20a7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  reg_thd_lock_up_7_0:8;
    };
}atsc_addr_20a8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  reg_thd_lock_dw_5_0:6;
        RBus_UInt32  reg_thd_lock_up_9_8:2;
    };
}atsc_addr_20a9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  reg_thd_up1_3_0:4;
        RBus_UInt32  reg_thd_lock_dw_9_6:4;
    };
}atsc_addr_20aa_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  reg_thd_dw1_1_0:2;
        RBus_UInt32  reg_thd_up1_9_4:6;
    };
}atsc_addr_20ab_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  reg_thd_dw1_9_2:8;
    };
}atsc_addr_20ac_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  reg_thd_up2:8;
    };
}atsc_addr_20ad_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  reg_thd_dw2:8;
    };
}atsc_addr_20ae_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  reg_aagc_lock_det_thd:4;
        RBus_UInt32  res2:4;
    };
}atsc_addr_20af_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  reg_gain_step_sum_dw_thd:4;
        RBus_UInt32  reg_gain_step_sum_up_thd:4;
    };
}atsc_addr_20b0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  reg_gain_pulse_hold_len:4;
        RBus_UInt32  reg_gain_pulse_space_len:4;
    };
}atsc_addr_20b1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  aagc_lock_ext:1;
    };
}atsc_addr_20b5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  agc_level_pga:8;
    };
}atsc_addr_20b6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_ant_rx_4b_on:1;
        RBus_UInt32  opt_ant_auto_reply_ack:1;
        RBus_UInt32  opt_ant_ack_ctrl_mode:1;
        RBus_UInt32  opt_ant_rx_mode:1;
        RBus_UInt32  opt_ant_force_a:1;
        RBus_UInt32  opt_ant_force_b:1;
        RBus_UInt32  opt_ant_enable:1;
        RBus_UInt32  opt_ant_reset_n:1;
    };
}atsc_addr_20c4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_ant_data_tx_7_0:8;
    };
}atsc_addr_20c5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_ant_data_tx_strobe:1;
        RBus_UInt32  opt_ant_data_tx_14_8:7;
    };
}atsc_addr_20c6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  opt_ant_reply_ack:1;
        RBus_UInt32  opt_ant_reply_strobe:1;
        RBus_UInt32  opt_ant_fix_tx_en:1;
        RBus_UInt32  opt_ant_fix_tx_oe:1;
        RBus_UInt32  opt_ant_fix_tx:1;
    };
}atsc_addr_20c7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_ant_8k_period_7_0:8;
    };
}atsc_addr_20c8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_ant_low_period_7_0:8;
    };
}atsc_addr_20c9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_ant_low_period_11_8:4;
        RBus_UInt32  opt_ant_8k_period_11_8:4;
    };
}atsc_addr_20ca_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_ant_tx_to_cnt_th_7_0:8;
    };
}atsc_addr_20cb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_ant_rx_to_cnt_th_7_0:8;
    };
}atsc_addr_20cc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  opt_ant_rx_startbit_on:1;
        RBus_UInt32  opt_ant_rx_timeout_en:1;
        RBus_UInt32  opt_ant_tx_timeout_en:1;
        RBus_UInt32  opt_ant_rx_to_cnt_th_9_8:2;
        RBus_UInt32  opt_ant_tx_to_cnt_th_9_8:2;
    };
}atsc_addr_20cd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_ant_init_msg_7_0:8;
    };
}atsc_addr_20ce_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  opt_ant_init_msg_14_8:7;
    };
}atsc_addr_20cf_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_ant_ack_msg_7_0:8;
    };
}atsc_addr_20d0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  opt_ant_ack_msg_14_8:7;
    };
}atsc_addr_20d1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_ant_nack_msg_7_0:8;
    };
}atsc_addr_20d2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  opt_ant_nack_msg_14_8:7;
    };
}atsc_addr_20d3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_ant_ack_dly_cnt_th_7_0:8;
    };
}atsc_addr_20d4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  opt_ant_rx_signal_pos:2;
        RBus_UInt32  opt_ant_ack_dly_cnt_th_9_8:2;
    };
}atsc_addr_20d5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  opt_ant_tx_ant_oe_comb:1;
        RBus_UInt32  opt_ant_pad_config:2;
        RBus_UInt32  res2:4;
    };
}atsc_addr_20d6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_ant_test_bit_th:4;
        RBus_UInt32  opt_ant_test_4b_on:1;
        RBus_UInt32  opt_ant_test_strobe:1;
        RBus_UInt32  opt_ant_test_trig_sel:1;
        RBus_UInt32  opt_ant_test_en:1;
    };
}atsc_addr_20d7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_ant_test_msg_7_0:8;
    };
}atsc_addr_20d8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_ant_test_msg_15_8:8;
    };
}atsc_addr_20d9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_ant_test_dly_cnt_th_7_0:8;
    };
}atsc_addr_20da_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_ant_rx_signal_neg:2;
        RBus_UInt32  opt_ant_timeout_clr:1;
        RBus_UInt32  opt_ant_sr11to12:1;
        RBus_UInt32  opt_ant_loopback2_en:1;
        RBus_UInt32  opt_ant_loopback1_en:1;
        RBus_UInt32  opt_ant_test_dly_cnt_th_9_8:2;
    };
}atsc_addr_20db_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_ant_rx_dly_cnt_th_7_0:8;
    };
}atsc_addr_20dc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_ant_tx_oe_next_st9:1;
        RBus_UInt32  opt_ant_tx_oe_next_st0:1;
        RBus_UInt32  opt_ant_tx_powerup_st0:1;
        RBus_UInt32  opt_ant_tx_silence_st0:1;
        RBus_UInt32  opt_ant_tx_upd_st0:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  opt_ant_rx_dly_cnt_th_9_8:2;
    };
}atsc_addr_20dd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_ant_tx_ini_period:8;
    };
}atsc_addr_20de_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_ant_tx_st9_period:8;
    };
}atsc_addr_20df_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_ant_tx_st11_period:8;
    };
}atsc_addr_20e0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_ant_tx_inv:1;
        RBus_UInt32  opt_ant_tx_oe_opt:1;
        RBus_UInt32  opt_ant_oe_inv:1;
        RBus_UInt32  opt_ant_tx_pad_oe:1;
        RBus_UInt32  opt_ant_oe_pad_oe:1;
        RBus_UInt32  opt_ant_tx_end_st13:1;
        RBus_UInt32  opt_ant_tx_oe_next_st11:1;
        RBus_UInt32  opt_ant_tx_end_st10:1;
    };
}atsc_addr_20e1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_ant_rx_st_det:1;
        RBus_UInt32  opt_ant_force_det:1;
        RBus_UInt32  opt_ant_det_inv:1;
        RBus_UInt32  opt_ant_det_sel:2;
        RBus_UInt32  opt_ant_rx_inv:1;
        RBus_UInt32  opt_ant_rx_sel:2;
    };
}atsc_addr_20e2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  ant_test_state:3;
        RBus_UInt32  res2:4;
    };
}atsc_addr_20f4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ant_tx_state:4;
        RBus_UInt32  ant_state:4;
    };
}atsc_addr_20f5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ant_tx_timeout_hold:1;
        RBus_UInt32  ant_rx_timeout_hold:1;
        RBus_UInt32  ant_init:1;
        RBus_UInt32  ant_mode:1;
        RBus_UInt32  ant_rx_state:4;
    };
}atsc_addr_20f6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ant_tx_bit_cnt:4;
        RBus_UInt32  ant_rx_bit_cnt:4;
    };
}atsc_addr_20f7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ant_pid_7_0:8;
    };
}atsc_addr_20f8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  ant_det_signal:1;
        RBus_UInt32  ant_rx_signal:1;
        RBus_UInt32  ant_oe_signal:1;
        RBus_UInt32  ant_tx_signal:1;
        RBus_UInt32  ant_pid_9_8:2;
    };
}atsc_addr_20f9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ant_pid_acc_7_0:8;
    };
}atsc_addr_20fa_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ant_pid_acc_15_8:8;
    };
}atsc_addr_20fb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  adc_clk_ph_inv:1;
    };
}atsc_addr_2101_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  agc_init_en:1;
        RBus_UInt32  adc_format_sel:1;
        RBus_UInt32  res2:3;
    };
}atsc_addr_2102_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  aagc_target_val:8;
    };
}atsc_addr_2103_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  adc_nb_mode:1;
        RBus_UInt32  adc_nb_on:1;
        RBus_UInt32  agc_mode:1;
        RBus_UInt32  en_if_agc:1;
        RBus_UInt32  en_rf_agc:1;
        RBus_UInt32  agc_manu1:1;
        RBus_UInt32  agc_manu0:1;
        RBus_UInt32  agc_polar:1;
    };
}atsc_addr_2104_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  agc_manu_val:8;
    };
}atsc_addr_2105_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  agc_rf_manu_val:8;
    };
}atsc_addr_2106_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  agc_if_manu_val:8;
    };
}atsc_addr_2107_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  vtop:7;
    };
}atsc_addr_2108_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  krf:6;
    };
}atsc_addr_2109_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  if_agc_min:8;
    };
}atsc_addr_210a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  if_agc_max:8;
    };
}atsc_addr_210b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  rf_agc_min:8;
    };
}atsc_addr_210c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  rf_agc_max:8;
    };
}atsc_addr_210d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  agc_lock_cnt_len_off:2;
        RBus_UInt32  agc_lock_th:4;
    };
}atsc_addr_210e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ddc_phase_inc_7_0:8;
    };
}atsc_addr_210f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ddc_phase_inc_15_8:8;
    };
}atsc_addr_2110_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  spec_inv_on:1;
        RBus_UInt32  ddc_phase_inc_19_16:4;
    };
}atsc_addr_2111_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  down_converter_coef_0_7_0:8;
    };
}atsc_addr_2112_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  down_converter_coef_0_9_8:2;
    };
}atsc_addr_2113_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  down_converter_coef_1_7_0:8;
    };
}atsc_addr_2114_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  down_converter_coef_1_9_8:2;
    };
}atsc_addr_2115_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  down_converter_coef_2_7_0:8;
    };
}atsc_addr_2116_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  down_converter_coef_2_9_8:2;
    };
}atsc_addr_2117_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  down_converter_coef_3_7_0:8;
    };
}atsc_addr_2118_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  down_converter_coef_3_9_8:2;
    };
}atsc_addr_2119_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  down_converter_coef_4_7_0:8;
    };
}atsc_addr_211a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  down_converter_coef_4_9_8:2;
    };
}atsc_addr_211b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  down_converter_coef_5_7_0:8;
    };
}atsc_addr_211c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  down_converter_coef_5_9_8:2;
    };
}atsc_addr_211d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  down_converter_coef_6_7_0:8;
    };
}atsc_addr_211e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  down_converter_coef_6_9_8:2;
    };
}atsc_addr_211f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  down_converter_coef_7_7_0:8;
    };
}atsc_addr_2120_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  down_converter_coef_7_9_8:2;
    };
}atsc_addr_2121_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  agc_tune_period_exp:3;
        RBus_UInt32  agc_tune_step:2;
        RBus_UInt32  agc_tune_en:1;
        RBus_UInt32  adc_trunc_bits:2;
    };
}atsc_addr_2122_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  agc_tune_period_wait:8;
    };
}atsc_addr_2123_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  agc_tune_upper_th:8;
    };
}atsc_addr_2124_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  agc_tune_lower_th:8;
    };
}atsc_addr_2125_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  agc_tune_bn_stop:1;
        RBus_UInt32  agc_max_sat_sel_2:1;
        RBus_UInt32  agc_max_sat_sel_1:2;
        RBus_UInt32  agc_tune_sat_opt:1;
    };
}atsc_addr_2126_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  agc_tune_min:8;
    };
}atsc_addr_2127_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  agc_tune_max:8;
    };
}atsc_addr_2128_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  agc_tune_max_sat:8;
    };
}atsc_addr_2129_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  adc_clip_block_size_7_0:8;
    };
}atsc_addr_212a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  adc_clip_block_size_15_8:8;
    };
}atsc_addr_212b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  agc_lock_sel:1;
    };
}atsc_addr_212c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_aagc_out_dcc:1;
        RBus_UInt32  opt_aagc_loop_in:3;
        RBus_UInt32  adc_clip_iq:2;
        RBus_UInt32  opt_ado_im:1;
        RBus_UInt32  aagc_iq_swap:1;
    };
}atsc_addr_212e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  fe_dcc1_acq_dly_prd:2;
        RBus_UInt32  fe_dcc1_max:3;
        RBus_UInt32  fe_dcc1_max_en:1;
        RBus_UInt32  fe_dcc1_en:1;
    };
}atsc_addr_212f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fe_dcc1_u_trk:4;
        RBus_UInt32  fe_dcc1_u_acq:4;
    };
}atsc_addr_2130_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  opt_fe_dcc1_upd:2;
        RBus_UInt32  opt_fe_dcc1_clr:2;
        RBus_UInt32  opt_fe_dcc1_u:2;
    };
}atsc_addr_2131_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  zif_spec_inv_on:1;
        RBus_UInt32  ddc_zif_mode:1;
    };
}atsc_addr_2132_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  fe_dcc2_acq_dly_prd:2;
        RBus_UInt32  fe_dcc2_max:3;
        RBus_UInt32  fe_dcc2_max_en:1;
        RBus_UInt32  fe_dcc2_en:1;
    };
}atsc_addr_2133_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fe_dcc2_u_trk:4;
        RBus_UInt32  fe_dcc2_u_acq:4;
    };
}atsc_addr_2134_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  opt_fe_dcc2_upd:2;
        RBus_UInt32  opt_fe_dcc2_clr:2;
        RBus_UInt32  opt_fe_dcc2_u:2;
    };
}atsc_addr_2135_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  fe_dcc3_acq_dly_prd:2;
        RBus_UInt32  fe_dcc3_max:3;
        RBus_UInt32  fe_dcc3_max_en:1;
        RBus_UInt32  fe_dcc3_en:1;
    };
}atsc_addr_2136_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fe_dcc3_u_trk:4;
        RBus_UInt32  fe_dcc3_u_acq:4;
    };
}atsc_addr_2137_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  opt_fe_dcc3_upd:2;
        RBus_UInt32  opt_fe_dcc3_clr:2;
        RBus_UInt32  opt_fe_dcc3_u:2;
    };
}atsc_addr_2138_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fe_iqamp_u_trk:4;
        RBus_UInt32  fe_iqamp_u_acq:4;
    };
}atsc_addr_2139_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fe_iqph_u_trk:4;
        RBus_UInt32  fe_iqph_u_acq:4;
    };
}atsc_addr_213a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_fe_iq_upd:2;
        RBus_UInt32  opt_fe_iq_clr:2;
        RBus_UInt32  opt_fe_iq_u:2;
        RBus_UInt32  fe_iq_acq_dly_prd:2;
    };
}atsc_addr_213b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fe_iqamp_manu_7_0:8;
    };
}atsc_addr_213c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fe_iqamp_en:1;
        RBus_UInt32  fe_iqamp_max_en:1;
        RBus_UInt32  fe_iqamp_max:3;
        RBus_UInt32  fe_iqamp_manu_en:1;
        RBus_UInt32  fe_iqamp_manu_9_8:2;
    };
}atsc_addr_213d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fe_iqph_manu_7_0:8;
    };
}atsc_addr_213e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fe_iqph_en:1;
        RBus_UInt32  fe_iqph_max_en:1;
        RBus_UInt32  fe_iqph_max:3;
        RBus_UInt32  fe_iqph_manu_en:1;
        RBus_UInt32  fe_iqph_manu_9_8:2;
    };
}atsc_addr_213f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  det_adj_th_bn:8;
    };
}atsc_addr_2143_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  det_adj_th:8;
    };
}atsc_addr_2144_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  dagc_target_power:8;
    };
}atsc_addr_2145_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  dagc_level_exp:2;
        RBus_UInt32  dagc_load:1;
        RBus_UInt32  dagc_level_ini:5;
    };
}atsc_addr_2146_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  dagc_lock_th:6;
        RBus_UInt32  dagc_mu_comp_en:1;
        RBus_UInt32  dagc_mu_sel:1;
    };
}atsc_addr_2147_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  dc_alpha_exp:3;
    };
}atsc_addr_2148_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tr_phase_inc_7_0:8;
    };
}atsc_addr_2165_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tr_phase_inc_15_8:8;
    };
}atsc_addr_2166_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tr_phase_inc_23_16:8;
    };
}atsc_addr_2167_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  tr_phase_inc_26_24:3;
    };
}atsc_addr_2168_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tr_ld_comp_on:1;
        RBus_UInt32  tr_lock_th1:6;
        RBus_UInt32  tr_fmu_mode:1;
    };
}atsc_addr_2169_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tr_lock_th2:8;
    };
}atsc_addr_216a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  opt_gard_off:1;
        RBus_UInt32  tr_phase_inc_upd_n:1;
        RBus_UInt32  tr_min_sat_en:1;
        RBus_UInt32  tr_lock_ind_mode:2;
    };
}atsc_addr_216d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_cr2_cr_offset_cnt_win_4_0:5;
        RBus_UInt32  cr_cr2_auto:1;
        RBus_UInt32  correlation_tr_sel:1;
        RBus_UInt32  tr_fs_fll_exp_sel_out_msb:1;
    };
}atsc_addr_2e40_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tr_fs_cor_th_acq:8;
    };
}atsc_addr_216e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tr_fs_cor_th_trk:8;
    };
}atsc_addr_216f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tr_fs_win_start:8;
    };
}atsc_addr_2170_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tr_fs_win_len:8;
    };
}atsc_addr_2171_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tr_fs_lost_cnt_th:8;
    };
}atsc_addr_2172_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tr_fs_pll_kp_exp:3;
        RBus_UInt32  tr_fs_fll_exp:2;
        RBus_UInt32  tr_fs_fll_hold_en:1;
        RBus_UInt32  tr_fs_acc_reset:1;
        RBus_UInt32  tr_fs_ld_wide_en:1;
    };
}atsc_addr_2173_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tr_fs_fll_times:8;
    };
}atsc_addr_2174_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tr_fs_acc2_size_7_0:8;
    };
}atsc_addr_2175_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  tr_fs_pll_kf_off:1;
        RBus_UInt32  tr_fs_pll_kf_exp:3;
        RBus_UInt32  tr_fs_acc2_size_9_8:2;
    };
}atsc_addr_2176_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  tr_fs_pll_sign:1;
        RBus_UInt32  tr_fs_pll_reacq_en:1;
        RBus_UInt32  tr_fs_ped_reacq_en:1;
        RBus_UInt32  tr_fs_fll_reacq_en:1;
        RBus_UInt32  tr_fs_fed_reacq_en:1;
        RBus_UInt32  tr_fs_trk_ind_reacq_en:1;
    };
}atsc_addr_2177_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  tr_fs_corr_sel2:1;
        RBus_UInt32  tr_fs_pll_wait_fll_en:1;
        RBus_UInt32  tr_fs_cor_sel:1;
        RBus_UInt32  tr_fs_trk_cnt_th:4;
    };
}atsc_addr_2178_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_tr_fs_pk_trk_len:8;
    };
}atsc_addr_2179_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_tr_fs_fsm_lock_7_0:8;
    };
}atsc_addr_217a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  opt_tr_fs_fsm_lock_12_8:5;
    };
}atsc_addr_217b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tr_fs_acc2_size_crs_1_0:2;
        RBus_UInt32  tr_fs_fll_exp_crs:2;
        RBus_UInt32  opt_tr_fs_trk_hold_en:1;
        RBus_UInt32  opt_tr_fs_el_space:1;
        RBus_UInt32  opt_tr_fs_pk_force_en:1;
        RBus_UInt32  opt_tr_fs_pk2el_en:1;
    };
}atsc_addr_217c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tr_fs_acc2_size_crs_9_2:8;
    };
}atsc_addr_217d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tr_fs_fll_times_crs:8;
    };
}atsc_addr_217e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tr_fs_win_crs_start:8;
    };
}atsc_addr_217f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tr_fs_win_crs_len:8;
    };
}atsc_addr_2180_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tr_fs_win_el_start:8;
    };
}atsc_addr_2181_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tr_fs_win_el_len:8;
    };
}atsc_addr_2182_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  opt_tr_fs_el_kp_exp_fine:3;
        RBus_UInt32  opt_tr_fs_el_kp_exp_crs:3;
    };
}atsc_addr_2183_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  opt_tr_fs_el_kf_exp_crs:4;
        RBus_UInt32  opt_tr_fs_el_kp_exp_trk:3;
    };
}atsc_addr_2184_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_tr_fs_el_kf_exp_trk:4;
        RBus_UInt32  opt_tr_fs_el_kf_exp_fine:4;
    };
}atsc_addr_2185_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_tr_fs_el_crs_len_7_0:8;
    };
}atsc_addr_2186_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_tr_fs_el_fine_len_3_0:4;
        RBus_UInt32  opt_tr_fs_el_crs_len_11_8:4;
    };
}atsc_addr_2187_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_tr_fs_el_fine_len_11_4:8;
    };
}atsc_addr_2188_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_tr_fs_el_err_max_fine:4;
        RBus_UInt32  opt_tr_fs_el_err_max_crs:4;
    };
}atsc_addr_2189_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  opt_tr_fs_el_trk_upd_prd:3;
        RBus_UInt32  opt_tr_fs_el_err_max_trk:4;
    };
}atsc_addr_218a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_tr_fs_el_erracc_th:8;
    };
}atsc_addr_218b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_tr_fs_el_errmax_th:8;
    };
}atsc_addr_218c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  opt_tr_fs_el_lock_sel:3;
        RBus_UInt32  opt_tr_fs_el_lock_prd:3;
    };
}atsc_addr_218d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_tr_fs_el_weak_ratio:3;
        RBus_UInt32  opt_tr_fs_el_chg_strobe:1;
        RBus_UInt32  opt_tr_fs_el_loc_upd12:1;
        RBus_UInt32  opt_tr_fs_el_loc_upd10:1;
        RBus_UInt32  opt_tr_fs_el_loc_upd8:1;
        RBus_UInt32  opt_tr_fs_el_loc_upd6:1;
    };
}atsc_addr_218e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  opt_tr_fs_el_chg_stage:2;
        RBus_UInt32  opt_tr_fs_el_weak_prd:4;
    };
}atsc_addr_218f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tr_fs_win_hold_start_7_0:8;
    };
}atsc_addr_2190_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  tr_fs_win_hold_start_11_8:4;
    };
}atsc_addr_2191_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tr_fs_win_hold_len_7_0:8;
    };
}atsc_addr_2192_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  tr_fs_win_hold_len_11_8:4;
    };
}atsc_addr_2193_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  opt_tr_fs_pkcrs2el_sel:2;
        RBus_UInt32  tr_fs_pll_sign_sel:1;
    };
}atsc_addr_2194_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  opt_tr_fs_bps_pk_trk:1;
        RBus_UInt32  opt_tr_fs_bps_pk_crs:1;
        RBus_UInt32  opt_tr_fs_fsm_pass0:1;
        RBus_UInt32  opt_tr_fs_fsm_en:1;
        RBus_UInt32  opt_tr_fs_pk_go3:1;
        RBus_UInt32  opt_tr_fs_pk_go2:1;
        RBus_UInt32  opt_tr_fs_pk_go1:1;
        RBus_UInt32  opt_tr_fs_pk_go0:1;
    };
}atsc_addr_2195_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tr_fs_cor_th_el:8;
    };
}atsc_addr_2196_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  pn63_pos_lb_7_0:8;
    };
}atsc_addr_21a0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  opt_eq_train2_cnt:1;
        RBus_UInt32  opt_eq_train_cnt:1;
        RBus_UInt32  pn63_pos_lb_9_8:2;
    };
}atsc_addr_21a1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  pn63_pos_ub_7_0:8;
    };
}atsc_addr_21a2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fsm_final_state:6;
        RBus_UInt32  pn63_pos_ub_9_8:2;
    };
}atsc_addr_21a3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  eq_train_cnt_th_7_0:8;
    };
}atsc_addr_21a4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  eq_train_cnt_th_15_8:8;
    };
}atsc_addr_21a5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  eq_train2_cnt_th_7_0:8;
    };
}atsc_addr_21a6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  eq_train2_cnt_th_15_8:8;
    };
}atsc_addr_21a7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  state_cnt1_inc_state:6;
    };
}atsc_addr_21a8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  state_cnt1_reset_state:6;
    };
}atsc_addr_21a9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  state_cnt1_th:8;
    };
}atsc_addr_21aa_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  state_cnt2_inc_state:6;
    };
}atsc_addr_21ab_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  state_cnt2_reset_state:6;
    };
}atsc_addr_21ac_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  state_cnt2_th:8;
    };
}atsc_addr_21ad_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  state_cnt1_delay_th:8;
    };
}atsc_addr_21ae_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  reg_fsm_cond0:1;
        RBus_UInt32  fsm_cond0_config:1;
        RBus_UInt32  reg_fsm_cond4:1;
        RBus_UInt32  fsm_cond4_config:1;
        RBus_UInt32  reg_fsm_cond3:1;
        RBus_UInt32  fsm_cond3_config:1;
        RBus_UInt32  reg_fsm_cond2:1;
        RBus_UInt32  fsm_cond2_config:1;
    };
}atsc_addr_21af_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fsm_cond8_seg_th_7_0:8;
    };
}atsc_addr_21b0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  fsm_cond8_seg_th_8:1;
    };
}atsc_addr_21b1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fsm_cond9_sym_th_7_0:8;
    };
}atsc_addr_21b2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  fsm_cond13_config:1;
        RBus_UInt32  fsm_cond9_sym_th_9_8:2;
    };
}atsc_addr_21b3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  reg_fsm_cond14:1;
        RBus_UInt32  fsm_cond14_config:1;
        RBus_UInt32  reg_fsm_cond6:1;
        RBus_UInt32  fsm_cond6_config:1;
        RBus_UInt32  reg_fsm_cond11:1;
        RBus_UInt32  fsm_cond11_config:1;
        RBus_UInt32  reg_fsm_cond10:1;
        RBus_UInt32  fsm_cond10_config:1;
    };
}atsc_addr_21b4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fsm_cond16_seg_th_7_0:8;
    };
}atsc_addr_21b5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  reg_fsm_cond25_n:1;
        RBus_UInt32  reg_fsm_cond30:1;
        RBus_UInt32  fsm_cond30_config:1;
        RBus_UInt32  reg_fsm_cond20:1;
        RBus_UInt32  fsm_cond20_config:1;
        RBus_UInt32  reg_fsm_cond19:1;
        RBus_UInt32  fsm_cond19_config:1;
        RBus_UInt32  fsm_cond16_seg_th_8:1;
    };
}atsc_addr_21b6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fsm_cond17_sym_th_7_0:8;
    };
}atsc_addr_21b7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fsm_cond26_config2:1;
        RBus_UInt32  fsm_cond14_config2:1;
        RBus_UInt32  fsm_cond31_config:1;
        RBus_UInt32  fsm_cond26_config:1;
        RBus_UInt32  fsm_cond25_config:1;
        RBus_UInt32  fsm_cond15_config:1;
        RBus_UInt32  fsm_cond17_sym_th_9_8:2;
    };
}atsc_addr_21b8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  fsm_cond29_config:2;
        RBus_UInt32  fsm_cond28_config:3;
    };
}atsc_addr_21b9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fsm_cond29_seg_th_7_0:8;
    };
}atsc_addr_21ba_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  fsm_cond29_seg_th_8:1;
    };
}atsc_addr_21bb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fsm_cond29_sym_th_7_0:8;
    };
}atsc_addr_21bc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  fsm_cond29_sym_th_9_8:2;
    };
}atsc_addr_21bd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fsm_seg_cnt_r1_7_0:8;
    };
}atsc_addr_21be_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  fsm_seg_cnt_r1_8:1;
    };
}atsc_addr_21bf_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fsm_sym_cnt_r1_7_0:8;
    };
}atsc_addr_21c0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  fsm_sym_cnt_r1_9_8:2;
    };
}atsc_addr_21c1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  agc_tune_clear_state:6;
    };
}atsc_addr_21c2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  bn_agc_start_state:6;
    };
}atsc_addr_21c3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  bn_agc_end_state:6;
    };
}atsc_addr_21c4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  pn_comp_start_state:6;
    };
}atsc_addr_21c5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  pn_comp_end_state:6;
    };
}atsc_addr_21c6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  pn_cr_state_cnt2_end_opt:1;
        RBus_UInt32  pn_pt_state_cnt2_end_opt:1;
        RBus_UInt32  pn_state_cnt2_end_opt:1;
    };
}atsc_addr_21c7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  adj_srrc_upd_state:6;
    };
}atsc_addr_21c8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  adj_srrc_clear_state:6;
    };
}atsc_addr_21c9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  state_cnt3_inc_state:6;
    };
}atsc_addr_21ca_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  state_cnt3_reset_state:6;
    };
}atsc_addr_21cb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  state_cnt3_th:8;
    };
}atsc_addr_21cc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  state_cnt4_inc_state:6;
    };
}atsc_addr_21cd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  state_cnt4_reset_state:6;
    };
}atsc_addr_21ce_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  state_cnt4_th:8;
    };
}atsc_addr_21cf_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  state_cnt5_inc_state:6;
    };
}atsc_addr_21d0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  state_cnt5_reset_state:6;
    };
}atsc_addr_21d1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  state_cnt5_th:8;
    };
}atsc_addr_21d2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fsm_mse_th_1_7_0:8;
    };
}atsc_addr_21d3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fsm_mse_inv_1:1;
        RBus_UInt32  fsm_mse_sel_1:1;
        RBus_UInt32  fsm_mse_th_1_13_8:6;
    };
}atsc_addr_21d4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fsm_mse_th_2_7_0:8;
    };
}atsc_addr_21d5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fsm_mse_inv_2:1;
        RBus_UInt32  fsm_mse_sel_2:1;
        RBus_UInt32  fsm_mse_th_2_13_8:6;
    };
}atsc_addr_21d6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  fsm_scan_lock_state:6;
    };
}atsc_addr_21d7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  fsm_scan_ind_clear:1;
        RBus_UInt32  fsm_scan_unlock_state:6;
    };
}atsc_addr_21d8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fsm_cond8_sym_th_7_0:8;
    };
}atsc_addr_21d9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  fsm_cond8_sym_th_9_8:2;
    };
}atsc_addr_21da_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  reg_fsm_load_ini:1;
        RBus_UInt32  reg_fsm_ram_col:5;
    };
}atsc_addr_21e0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  reg_fsm_bw_stop:1;
        RBus_UInt32  reg_fsm_ram_rd:1;
        RBus_UInt32  reg_fsm_ram_row:6;
    };
}atsc_addr_21e1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  reg_fsm_ram_wr:1;
        RBus_UInt32  reg_fsm_ram_data:7;
    };
}atsc_addr_21e2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fsm_ram_crc_7_0:8;
    };
}atsc_addr_21e3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fsm_ram_crc_15_8:8;
    };
}atsc_addr_21e4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  fsm_ram_crc_done:1;
        RBus_UInt32  fsm_ram_state:5;
    };
}atsc_addr_21e5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  fsm_ram_data_ro:7;
    };
}atsc_addr_21e6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fsm_segment_counter_ini0_7_0:8;
    };
}atsc_addr_21e7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fsm_segment_counter_ini1_6_0:7;
        RBus_UInt32  fsm_segment_counter_ini0_8:1;
    };
}atsc_addr_21e8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  fsm_segment_counter_ini1_8_7:2;
    };
}atsc_addr_21e9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fsm_symbol_counter_ini0_7_0:8;
    };
}atsc_addr_21ea_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fsm_symbol_counter_ini1_5_0:6;
        RBus_UInt32  fsm_symbol_counter_ini0_9_8:2;
    };
}atsc_addr_21eb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fsm_symbol_counter_ini1_9_6:4;
    };
}atsc_addr_21ec_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fsm_train_ptr_ini0_7_0:8;
    };
}atsc_addr_21ed_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fsm_train_ptr_ini1_5_0:6;
        RBus_UInt32  fsm_train_ptr_ini0_9_8:2;
    };
}atsc_addr_21ee_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fsm_train_ptr_ini1_9_6:4;
    };
}atsc_addr_21ef_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  pt_dd_max:3;
        RBus_UInt32  pt_on:1;
        RBus_UInt32  pt_out_sel:1;
        RBus_UInt32  pt_mode:2;
    };
}atsc_addr_2201_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  pt_state_start:6;
    };
}atsc_addr_2202_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  pt_kb_exp:2;
        RBus_UInt32  pt_state_end:6;
    };
}atsc_addr_2203_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  pt_dec_sel:1;
        RBus_UInt32  pt_u_exp_1:2;
        RBus_UInt32  pt_u_exp_0:2;
    };
}atsc_addr_2220_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  pt_ph_max:6;
    };
}atsc_addr_2221_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  pt_dd_t:3;
        RBus_UInt32  pt_clear_en:1;
    };
}atsc_addr_2222_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  srrc_coeff_12_0:1;
        RBus_UInt32  srrc_coeff_0:7;
    };
}atsc_addr_2501_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  srrc_coeff_12_8_1:8;
    };
}atsc_addr_2502_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  srrc_coeff_13_0:1;
        RBus_UInt32  srrc_coeff_1:7;
    };
}atsc_addr_2503_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  srrc_coeff_13_8_1:8;
    };
}atsc_addr_2504_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  srrc_coeff_14_0:1;
        RBus_UInt32  srrc_coeff_2:7;
    };
}atsc_addr_2505_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  srrc_coeff_14_8_1:8;
    };
}atsc_addr_2506_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  srrc_coeff_15_0:1;
        RBus_UInt32  srrc_coeff_3:7;
    };
}atsc_addr_2507_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  srrc_coeff_15_8_1:8;
    };
}atsc_addr_2508_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  srrc_coeff_16_0:1;
        RBus_UInt32  srrc_coeff_4:7;
    };
}atsc_addr_2509_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  srrc_coeff_16_8_1:8;
    };
}atsc_addr_250a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  srrc_coeff_17_0:1;
        RBus_UInt32  srrc_coeff_5:7;
    };
}atsc_addr_250b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  srrc_coeff_17_8_1:8;
    };
}atsc_addr_250c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  srrc_coeff_18_0:1;
        RBus_UInt32  srrc_coeff_6:7;
    };
}atsc_addr_250d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  srrc_coeff_18_8_1:8;
    };
}atsc_addr_250e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  srrc_coeff_19_0:1;
        RBus_UInt32  srrc_coeff_7:7;
    };
}atsc_addr_250f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  srrc_coeff_19_8_1:8;
    };
}atsc_addr_2510_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  srrc_coeff_20_0:1;
        RBus_UInt32  srrc_coeff_8:7;
    };
}atsc_addr_2511_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  srrc_coeff_20_8_1:8;
    };
}atsc_addr_2512_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  srrc_coeff_21_0:1;
        RBus_UInt32  srrc_coeff_9:7;
    };
}atsc_addr_2513_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  srrc_coeff_21_8_1:8;
    };
}atsc_addr_2514_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  srrc_coeff_22_0:1;
        RBus_UInt32  srrc_coeff_10:7;
    };
}atsc_addr_2515_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  srrc_coeff_22_8_1:8;
    };
}atsc_addr_2516_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  srrc_coeff_23_0:1;
        RBus_UInt32  srrc_coeff_11:7;
    };
}atsc_addr_2517_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  srrc_coeff_23_8_1:8;
    };
}atsc_addr_2518_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  srrc_coeff_24_7_0:8;
    };
}atsc_addr_2519_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  srrc_coeff_25_3_0:4;
        RBus_UInt32  srrc_coeff_24_11_8:4;
    };
}atsc_addr_251a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  srrc_coeff_25_11_4:8;
    };
}atsc_addr_251b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  srrc_coeff_26_7_0:8;
    };
}atsc_addr_251c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  srrc_coeff_27_3_0:4;
        RBus_UInt32  srrc_coeff_26_11_8:4;
    };
}atsc_addr_251d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  srrc_coeff_27_11_4:8;
    };
}atsc_addr_251e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  srrc_coeff_28_7_0:8;
    };
}atsc_addr_251f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  srrc_coeff_29_3_0:4;
        RBus_UInt32  srrc_coeff_28_11_8:4;
    };
}atsc_addr_2520_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  srrc_coeff_29_11_4:8;
    };
}atsc_addr_2521_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  srrc_coeff_30_7_0:8;
    };
}atsc_addr_2522_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  srrc_coeff_31_3_0:4;
        RBus_UInt32  srrc_coeff_30_11_8:4;
    };
}atsc_addr_2523_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  srrc_coeff_31_11_4:8;
    };
}atsc_addr_2524_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  adj_ind_srrc_pol:1;
        RBus_UInt32  srrc_coeff_sel_auto_en:1;
        RBus_UInt32  srrc_coeff_sel_auto1:2;
        RBus_UInt32  srrc_coeff_sel_auto0:2;
        RBus_UInt32  srrc_coeff_sel:2;
    };
}atsc_addr_2542_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_comp_scale_exp_table1:4;
        RBus_UInt32  cr_comp_scale_exp_table0:4;
    };
}atsc_addr_2580_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_comp_scale_exp_table3:4;
        RBus_UInt32  cr_comp_scale_exp_table2:4;
    };
}atsc_addr_2581_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_comp_scale_exp_table5:4;
        RBus_UInt32  cr_comp_scale_exp_table4:4;
    };
}atsc_addr_2582_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_comp_scale_exp_table7:4;
        RBus_UInt32  cr_comp_scale_exp_table6:4;
    };
}atsc_addr_2583_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_comp_scale_exp_table9:4;
        RBus_UInt32  cr_comp_scale_exp_table8:4;
    };
}atsc_addr_2584_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_comp_scale_exp_table11:4;
        RBus_UInt32  cr_comp_scale_exp_table10:4;
    };
}atsc_addr_2585_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_comp_scale_exp_table13:4;
        RBus_UInt32  cr_comp_scale_exp_table12:4;
    };
}atsc_addr_2586_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_comp_scale_exp_table15:4;
        RBus_UInt32  cr_comp_scale_exp_table14:4;
    };
}atsc_addr_2587_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_comp_scale_exp_table17:4;
        RBus_UInt32  cr_comp_scale_exp_table16:4;
    };
}atsc_addr_2588_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_comp_scale_exp_table19:4;
        RBus_UInt32  cr_comp_scale_exp_table18:4;
    };
}atsc_addr_2589_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_comp_scale_exp_table21:4;
        RBus_UInt32  cr_comp_scale_exp_table20:4;
    };
}atsc_addr_258a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_comp_scale_exp_table23:4;
        RBus_UInt32  cr_comp_scale_exp_table22:4;
    };
}atsc_addr_258b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_comp_scale_exp_table25:4;
        RBus_UInt32  cr_comp_scale_exp_table24:4;
    };
}atsc_addr_258c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_comp_scale_exp_table27:4;
        RBus_UInt32  cr_comp_scale_exp_table26:4;
    };
}atsc_addr_258d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_comp_scale_exp_table29:4;
        RBus_UInt32  cr_comp_scale_exp_table28:4;
    };
}atsc_addr_258e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_comp_scale_exp_table31:4;
        RBus_UInt32  cr_comp_scale_exp_table30:4;
    };
}atsc_addr_258f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_cr2_cr_offset_cnt_win_12_5:8;
    };
}atsc_addr_2e41_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_cr2_cr_offset_dif_thd_0:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  cr_cr2_cr_offset_cnt_win_18_13:6;
    };
}atsc_addr_2e42_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_cr2_cr_offset_dif_thd_8_1:8;
    };
}atsc_addr_2e43_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_cr2_cr_offset_dif_thd_16_9:8;
    };
}atsc_addr_2e44_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_cr2_cr_offset_dif_thd_24_17:8;
    };
}atsc_addr_2e45_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_cr2_cr_offset_dif_thd_32_25:8;
    };
}atsc_addr_2e46_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_cr2_cr_offset_large_cnt_max:8;
    };
}atsc_addr_2e47_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_cr2_cr_offset_large_cnt_thd:8;
    };
}atsc_addr_2e48_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  cr_cr2_cr_offset_large_cnt_dec:3;
        RBus_UInt32  cr_cr2_cr_offset_large_cnt_inc_2_0:3;
    };
}atsc_addr_2e49_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_fmu_cr2_nb_comp_2_0:3;
        RBus_UInt32  cr_cr2_cr_offset_large_cnt_inc_7_3:5;
    };
}atsc_addr_2e50_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_cr2_cargp_nb:4;
        RBus_UInt32  cr_cr2_cargp_wb:4;
    };
}atsc_addr_2e4a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_cr2_cr_offset_dif_7_0:8;
    };
}atsc_addr_2e4b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_cr2_cr_offset_dif_15_8:8;
    };
}atsc_addr_2e4c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_cr2_cr_offset_dif_23_16:8;
    };
}atsc_addr_2e4d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_cr2_cr_offset_dif_31_24:8;
    };
}atsc_addr_2e4e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  cr_cr2_cr_offset_dif_32:1;
    };
}atsc_addr_2e4f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  cr_fmu_upd_opt:3;
        RBus_UInt32  res2:3;
        RBus_UInt32  cr_lpf_var_s0_floor_en:1;
    };
}atsc_addr_25a0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_lpf_2_a_exp_reg1:3;
        RBus_UInt32  cr_lpf_2_a_exp_reg0:3;
        RBus_UInt32  res2:2;
    };
}atsc_addr_25a1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  cr_lpf_2_b_exp_reg0:3;
        RBus_UInt32  res2:3;
    };
}atsc_addr_25a2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_lpf_shift_en:1;
        RBus_UInt32  res2:4;
        RBus_UInt32  cr_lpf_2_b_exp_reg1:3;
    };
}atsc_addr_25a3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  cr_comp_scale_en_sel:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  cr_comp_input_sel1:3;
    };
}atsc_addr_25a4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_dr1_im_pwr_alpha:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  cr_comp_go_cond2_en:1;
        RBus_UInt32  cr_comp_go_cond1_en:1;
        RBus_UInt32  res3:1;
        RBus_UInt32  cr_comp_exp_max:3;
    };
}atsc_addr_25a5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_dr1_mean_alpha:2;
        RBus_UInt32  cr_dr1_im_hpf_alpha:2;
        RBus_UInt32  cr_dr1_im_lpf_alpha2:2;
        RBus_UInt32  cr_dr1_im_lpf_alpha1:2;
    };
}atsc_addr_25a6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_fmu_upd_cnt_th:8;
    };
}atsc_addr_25a7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_snr_ind1_th_7_0:8;
    };
}atsc_addr_25a8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_snr_ind1_th_15_8:8;
    };
}atsc_addr_25a9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_snr_ind2_th_7_0:8;
    };
}atsc_addr_25aa_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_snr_ind2_th_15_8:8;
    };
}atsc_addr_25ab_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_pilot_cnr_th_exp2:4;
        RBus_UInt32  cr_pilot_cnr_th_exp1:4;
    };
}atsc_addr_25ac_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_pilot_cnr_th_exp4:4;
        RBus_UInt32  cr_pilot_cnr_th_exp3:4;
    };
}atsc_addr_25ad_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_pilot_cnr_th_exp6:4;
        RBus_UInt32  cr_pilot_cnr_th_exp5:4;
    };
}atsc_addr_25ae_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_lpf_shift_3_0:4;
        RBus_UInt32  cr_pilot_cnr_th_exp7:4;
    };
}atsc_addr_25af_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_lpf_shift_11_4:8;
    };
}atsc_addr_25b0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_comp_scale_exp_fixed:3;
        RBus_UInt32  cr_pn_det_pilot_cnr_exp:4;
        RBus_UInt32  cr_pn_det_cond_en:1;
    };
}atsc_addr_25b7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_lpf_scale_reg0_7_0:8;
    };
}atsc_addr_2601_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_lpf_scale_reg0_15_8:8;
    };
}atsc_addr_2602_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_lpf_scale_reg1_7_0:8;
    };
}atsc_addr_2603_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_lpf_scale_reg1_15_8:8;
    };
}atsc_addr_2604_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_lpf_a1_reg0_7_0:8;
    };
}atsc_addr_2607_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_lpf_a1_reg0_15_8:8;
    };
}atsc_addr_2608_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  cr_lpf_a1_reg0_21_16:6;
    };
}atsc_addr_2609_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_lpf_a1_reg1_7_0:8;
    };
}atsc_addr_260a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_lpf_a1_reg1_15_8:8;
    };
}atsc_addr_260b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  cr_lpf_a1_reg1_21_16:6;
    };
}atsc_addr_260c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_lpf_a2_reg0_7_0:8;
    };
}atsc_addr_2610_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_lpf_a2_reg0_15_8:8;
    };
}atsc_addr_2611_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  cr_lpf_a2_reg0_21_16:6;
    };
}atsc_addr_2612_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_lpf_a2_reg1_7_0:8;
    };
}atsc_addr_2613_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_lpf_a2_reg1_15_8:8;
    };
}atsc_addr_2614_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  cr_lpf_a2_reg1_21_16:6;
    };
}atsc_addr_2615_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_lpf_b1_reg0_7_0:8;
    };
}atsc_addr_2619_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_lpf_b1_reg0_15_8:8;
    };
}atsc_addr_261a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  cr_lpf_b1_reg0_21_16:6;
    };
}atsc_addr_261b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_lpf_b1_reg1_7_0:8;
    };
}atsc_addr_261c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_lpf_b1_reg1_15_8:8;
    };
}atsc_addr_261d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  cr_lpf_b1_reg1_21_16:6;
    };
}atsc_addr_261e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_lpf_b2_reg0_7_0:8;
    };
}atsc_addr_2622_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_lpf_b2_reg0_15_8:8;
    };
}atsc_addr_2623_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  cr_lpf_b2_reg0_21_16:6;
    };
}atsc_addr_2624_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_lpf_b2_reg1_7_0:8;
    };
}atsc_addr_2625_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_lpf_b2_reg1_15_8:8;
    };
}atsc_addr_2626_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  cr_lpf_b2_reg1_21_16:6;
    };
}atsc_addr_2627_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  cr_ld_re_diff_en:1;
        RBus_UInt32  cr_ld_freq_ub_sel:1;
        RBus_UInt32  cr_ld_freq_diff_sel:1;
        RBus_UInt32  cr_ld_im_sel:1;
        RBus_UInt32  cr_ld_re_sel:1;
        RBus_UInt32  cr_ld_cnt_dec:1;
        RBus_UInt32  cr_ld_cnt_inc:1;
    };
}atsc_addr_2628_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  cr_ld_det_alpha:2;
    };
}atsc_addr_2629_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  cr_comp_exp_manu:3;
        RBus_UInt32  cr_comp_man_manu:1;
        RBus_UInt32  cr_comp_manu:1;
        RBus_UInt32  res2:2;
    };
}atsc_addr_262b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_phase_shift_7_0:8;
    };
}atsc_addr_262c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_offset_leak_prd:3;
        RBus_UInt32  cr_offset_leak_upd_opt:2;
        RBus_UInt32  res2:1;
        RBus_UInt32  cr_phase_shift_9_8:2;
    };
}atsc_addr_262d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_offset_leak_f_th:8;
    };
}atsc_addr_262e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_phase_comp_slope_7_0:8;
    };
}atsc_addr_2630_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  cr_phase_comp_in_sel:1;
        RBus_UInt32  cr_phase_comp_slope_10_8:3;
    };
}atsc_addr_2631_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_comp_target_7_0:8;
    };
}atsc_addr_2632_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  cr_comp_target_8:1;
    };
}atsc_addr_2633_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_pmu_comp0:4;
        RBus_UInt32  cr_ld_cnt_th:4;
    };
}atsc_addr_2634_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  cr_pmu_comp1:4;
    };
}atsc_addr_2635_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_fmu_comp1:4;
        RBus_UInt32  cr_fmu_comp0:4;
    };
}atsc_addr_2636_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_acq_fmu:4;
        RBus_UInt32  res2:4;
    };
}atsc_addr_2637_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  cr_acq_pmu:4;
    };
}atsc_addr_2638_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_ld_freq_ub0_7_0:8;
    };
}atsc_addr_2639_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  cr_ld_freq_ub0_10_8:3;
    };
}atsc_addr_263a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_ld_freq_ub1_7_0:8;
    };
}atsc_addr_263b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  cr_ld_freq_ub1_10_8:3;
    };
}atsc_addr_263c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_ld_re_diff_th_7_0:8;
    };
}atsc_addr_263d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  cr_ld_re_diff_th_13_8:6;
    };
}atsc_addr_263e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  cr_ld_re_ub_en:1;
        RBus_UInt32  cr_ld_freq_max_en:1;
        RBus_UInt32  cr_ld_freq_en:1;
        RBus_UInt32  cr_ld_im_en:1;
        RBus_UInt32  cr_ld_re_lb_en:1;
        RBus_UInt32  cr_ld_comp_on:1;
    };
}atsc_addr_263f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_ld_re_th_lb_7_0:8;
    };
}atsc_addr_2640_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  cr_ld_re_th_lb_12_8:5;
    };
}atsc_addr_2641_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_ld_im_th_7_0:8;
    };
}atsc_addr_2642_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  cr_ld_im_th_12_8:5;
    };
}atsc_addr_2643_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_ld_cr_freq_diff_th_7_0:8;
    };
}atsc_addr_2644_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  cr_ld_cr_freq_diff_th_11_8:4;
    };
}atsc_addr_2645_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_ld_re_th_ub_7_0:8;
    };
}atsc_addr_2646_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  cr_ld_re_th_ub_13_8:6;
    };
}atsc_addr_2647_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_large_freq_th_7_0:8;
    };
}atsc_addr_2648_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  cr_large_freq_th_10_8:3;
    };
}atsc_addr_2649_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  cr_fmu_pn_comp:3;
        RBus_UInt32  cr_pmu_pn_comp:3;
    };
}atsc_addr_264a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  cr_cr2_carer:1;
        RBus_UInt32  cr_cr2_carb:3;
        RBus_UInt32  cr_cr2_en_sel:2;
    };
}atsc_addr_2002_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  cr_cr2_cargi:3;
        RBus_UInt32  cr_cr2_cargp:4;
    };
}atsc_addr_2003_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_pmu_cr2_nb_comp_4_0:5;
        RBus_UInt32  cr_fmu_cr2_nb_comp_5_3:3;
    };
}atsc_addr_2e51_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_pmu_cr2_wb_comp_0:1;
        RBus_UInt32  cr_fmu_cr2_wb_comp:6;
        RBus_UInt32  cr_pmu_cr2_nb_comp_5:1;
    };
}atsc_addr_2e52_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_cr2_carb_wb:3;
        RBus_UInt32  cr_pmu_cr2_wb_comp_5_1:5;
    };
}atsc_addr_2e53_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_cr2_cargi_nb_1_0:2;
        RBus_UInt32  cr_cr2_cargi_wb:3;
        RBus_UInt32  cr_cr2_carb_nb:3;
    };
}atsc_addr_2e54_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_cr2_cr_offset_tilt_smp_thd_0:1;
        RBus_UInt32  cr_cr2_start_state:6;
        RBus_UInt32  cr_cr2_cargi_nb_2:1;
    };
}atsc_addr_2e55_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_cr2_cr_offset_tilt_smp_thd_8_1:8;
    };
}atsc_addr_2e56_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_cr2_cr_offset_tilt_val_thd_3_0:4;
        RBus_UInt32  cr_cr2_cr_offset_tilt_smp_thd_12_9:4;
    };
}atsc_addr_2e57_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_cr2_cr_offset_tilt_val_thd_11_4:8;
    };
}atsc_addr_2e58_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_cr2_cr_offset_tilt_val_thd_19_12:8;
    };
}atsc_addr_2e59_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_cr2_cr_offset_tilt_val_thd_27_20:8;
    };
}atsc_addr_2e5a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_cr2_cr_offset_lpf_sft_sel_1_0:2;
        RBus_UInt32  res2:1;
        RBus_UInt32  cr_cr2_cr_offset_tilt_val_thd_32_28:5;
    };
}atsc_addr_2e5b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_cr2_cr_offset_tilt_cnt_inc_1_0:2;
        RBus_UInt32  cr_cr2_swbw_ofa:1;
        RBus_UInt32  cr_cr2_swbw_cond_sel:4;
        RBus_UInt32  cr_cr2_cr_offset_lpf_sft_sel_2:1;
    };
}atsc_addr_2e5c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_cr2_cr_offset_tilt_cnt_dec_1_0:2;
        RBus_UInt32  cr_cr2_cr_offset_tilt_cnt_inc_7_2:6;
    };
}atsc_addr_2e5d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_cr2_cr_offset_tilt_cnt_thd_6_0:7;
        RBus_UInt32  cr_cr2_cr_offset_tilt_cnt_dec_2:1;
    };
}atsc_addr_2e5e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_cr2_cr_offset_tilt_cnt_max_6_0:7;
        RBus_UInt32  cr_cr2_cr_offset_tilt_cnt_thd_7:1;
    };
}atsc_addr_2e5f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  cci_rej_bypass_buf:1;
        RBus_UInt32  comp_buf_out:1;
        RBus_UInt32  tr_fs_ped_int_en:1;
        RBus_UInt32  cr_cr2_cr_offset_tilt_cnt_max_7:1;
    };
}atsc_addr_2e60_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  cr_cr2_swbw:1;
        RBus_UInt32  cr_cr2_cr_offset_tilt_val_flag:1;
        RBus_UInt32  cr_cr2_cr_offset_tilt_smp_flag:1;
        RBus_UInt32  cr_cr2_cr_offset_large_flag2:1;
        RBus_UInt32  cr_cr2_cr_offset_large_flag:1;
    };
}atsc_addr_2e61_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_pos_0_6_0:7;
        RBus_UInt32  cci_iir23_en:1;
    };
}atsc_addr_2e62_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_freq_offset_1_0:2;
        RBus_UInt32  cci_iir_pos_0_12_7:6;
    };
}atsc_addr_2e63_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_g_ratio_m1_1_0:2;
        RBus_UInt32  cci_iir_g_ratio_m0:5;
        RBus_UInt32  cci_iir_freq_offset_2:1;
    };
}atsc_addr_2e64_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_g_ratio_l0:5;
        RBus_UInt32  cci_iir_g_ratio_m1_4_2:3;
    };
}atsc_addr_2e65_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_a_1_s1_2_0:3;
        RBus_UInt32  cci_iir_g_ratio_l1:5;
    };
}atsc_addr_2e66_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_a_1_s1_10_3:8;
    };
}atsc_addr_2e67_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_a_1_s1_18_11:8;
    };
}atsc_addr_2e68_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_a_2_s1_5_0:6;
        RBus_UInt32  cci_iir_a_1_s1_20_19:2;
    };
}atsc_addr_2e69_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_a_2_s1_13_6:8;
    };
}atsc_addr_2e6a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_0_s1_0:1;
        RBus_UInt32  cci_iir_a_2_s1_20_14:7;
    };
}atsc_addr_2e6b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_0_s1_8_1:8;
    };
}atsc_addr_2e6c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_0_s1_16_9:8;
    };
}atsc_addr_2e6d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_1_s1_3_0:4;
        RBus_UInt32  cci_iir_b_0_s1_20_17:4;
    };
}atsc_addr_2e6e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_1_s1_11_4:8;
    };
}atsc_addr_2e6f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_1_s1_19_12:8;
    };
}atsc_addr_2e70_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_2_s1_6_0:7;
        RBus_UInt32  cci_iir_b_1_s1_20:1;
    };
}atsc_addr_2e71_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_2_s1_14_7:8;
    };
}atsc_addr_2e72_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_a_1_m0_1_0:2;
        RBus_UInt32  cci_iir_b_2_s1_20_15:6;
    };
}atsc_addr_2e73_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_a_1_m0_9_2:8;
    };
}atsc_addr_2e74_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_a_1_m0_17_10:8;
    };
}atsc_addr_2e75_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_a_2_m0_4_0:5;
        RBus_UInt32  cci_iir_a_1_m0_20_18:3;
    };
}atsc_addr_2e76_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_a_2_m0_12_5:8;
    };
}atsc_addr_2e77_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_a_2_m0_20_13:8;
    };
}atsc_addr_2e78_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_0_m0_7_0:8;
    };
}atsc_addr_2e79_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_0_m0_15_8:8;
    };
}atsc_addr_2e7a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_1_m0_2_0:3;
        RBus_UInt32  cci_iir_b_0_m0_20_16:5;
    };
}atsc_addr_2e7b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_1_m0_10_3:8;
    };
}atsc_addr_2e7c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_1_m0_18_11:8;
    };
}atsc_addr_2e7d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_2_m0_5_0:6;
        RBus_UInt32  cci_iir_b_1_m0_20_19:2;
    };
}atsc_addr_2e7e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_2_m0_13_6:8;
    };
}atsc_addr_2e7f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_a_1_m1_0:1;
        RBus_UInt32  cci_iir_b_2_m0_20_14:7;
    };
}atsc_addr_2e80_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_a_1_m1_8_1:8;
    };
}atsc_addr_2e81_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_a_1_m1_16_9:8;
    };
}atsc_addr_2e82_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_a_2_m1_3_0:4;
        RBus_UInt32  cci_iir_a_1_m1_20_17:4;
    };
}atsc_addr_2e83_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_a_2_m1_11_4:8;
    };
}atsc_addr_2e84_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_a_2_m1_19_12:8;
    };
}atsc_addr_2e85_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_0_m1_6_0:7;
        RBus_UInt32  cci_iir_a_2_m1_20:1;
    };
}atsc_addr_2e86_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_0_m1_14_7:8;
    };
}atsc_addr_2e87_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_1_m1_1_0:2;
        RBus_UInt32  cci_iir_b_0_m1_20_15:6;
    };
}atsc_addr_2e88_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_1_m1_9_2:8;
    };
}atsc_addr_2e89_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_1_m1_17_10:8;
    };
}atsc_addr_2e8a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_2_m1_4_0:5;
        RBus_UInt32  cci_iir_b_1_m1_20_18:3;
    };
}atsc_addr_2e8b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_2_m1_12_5:8;
    };
}atsc_addr_2e8c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_2_m1_20_13:8;
    };
}atsc_addr_2e8d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_a_1_l0_7_0:8;
    };
}atsc_addr_2e8e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_a_1_l0_15_8:8;
    };
}atsc_addr_2e8f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_a_2_l0_2_0:3;
        RBus_UInt32  cci_iir_a_1_l0_20_16:5;
    };
}atsc_addr_2e90_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_a_2_l0_10_3:8;
    };
}atsc_addr_2e91_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_a_2_l0_18_11:8;
    };
}atsc_addr_2e92_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_0_l0_5_0:6;
        RBus_UInt32  cci_iir_a_2_l0_20_19:2;
    };
}atsc_addr_2e93_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_0_l0_13_6:8;
    };
}atsc_addr_2e94_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_1_l0_0:1;
        RBus_UInt32  cci_iir_b_0_l0_20_14:7;
    };
}atsc_addr_2e95_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_1_l0_8_1:8;
    };
}atsc_addr_2e96_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_1_l0_16_9:8;
    };
}atsc_addr_2e97_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_2_l0_3_0:4;
        RBus_UInt32  cci_iir_b_1_l0_20_17:4;
    };
}atsc_addr_2e98_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_2_l0_11_4:8;
    };
}atsc_addr_2e99_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_2_l0_19_12:8;
    };
}atsc_addr_2e9a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_a_1_l1_6_0:7;
        RBus_UInt32  cci_iir_b_2_l0_20:1;
    };
}atsc_addr_2e9b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_a_1_l1_14_7:8;
    };
}atsc_addr_2e9c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_a_2_l1_1_0:2;
        RBus_UInt32  cci_iir_a_1_l1_20_15:6;
    };
}atsc_addr_2e9d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_a_2_l1_9_2:8;
    };
}atsc_addr_2e9e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_a_2_l1_17_10:8;
    };
}atsc_addr_2e9f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_0_l1_4_0:5;
        RBus_UInt32  cci_iir_a_2_l1_20_18:3;
    };
}atsc_addr_2ea0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_0_l1_12_5:8;
    };
}atsc_addr_2ea1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_0_l1_20_13:8;
    };
}atsc_addr_2ea2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_1_l1_7_0:8;
    };
}atsc_addr_2ea3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_1_l1_15_8:8;
    };
}atsc_addr_2ea4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_2_l1_2_0:3;
        RBus_UInt32  cci_iir_b_1_l1_20_16:5;
    };
}atsc_addr_2ea5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_2_l1_10_3:8;
    };
}atsc_addr_2ea6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_iir_b_2_l1_18_11:8;
    };
}atsc_addr_2ea7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_det_start_st_1_0:2;
        RBus_UInt32  cci_rej_manl_off:1;
        RBus_UInt32  cci_rej_manl_on:1;
        RBus_UInt32  cci_det_manl_on:1;
        RBus_UInt32  cci_rej_en:1;
        RBus_UInt32  cci_iir_b_2_l1_20_19:2;
    };
}atsc_addr_2ea8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_det_fft_n_3_0:4;
        RBus_UInt32  cci_det_start_st_5_2:4;
    };
}atsc_addr_2ea9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_pos_dif_range:6;
        RBus_UInt32  cci_det_fft_n_5_4:2;
    };
}atsc_addr_2eaa_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_rej_start_st_1_0:2;
        RBus_UInt32  cci_pos_around_cnt_thd:6;
    };
}atsc_addr_2eab_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_rej_freq_neg_3_0:4;
        RBus_UInt32  cci_rej_start_st_5_2:4;
    };
}atsc_addr_2eac_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_rej_freq_neg_11_4:8;
    };
}atsc_addr_2ead_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_rej_freq_post_6_0:7;
        RBus_UInt32  cci_rej_freq_neg_12:1;
    };
}atsc_addr_2eae_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_thd_ratio_1_0:2;
        RBus_UInt32  cci_rej_freq_post_12_7:6;
    };
}atsc_addr_2eaf_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_thd_ratio_9_2:8;
    };
}atsc_addr_2eb0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_fft_dsp_first_out_idx_4_0:5;
        RBus_UInt32  cci_iir_reset_each_frame:1;
        RBus_UInt32  cci_thd_ratio_11_10:2;
    };
}atsc_addr_2eb1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_fft_dsp_first_out_idx_12_5:8;
    };
}atsc_addr_2eb2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_fft_act_num_2_0:3;
        RBus_UInt32  cci_fft_abs:1;
        RBus_UInt32  cci_fft_idx_offset:4;
    };
}atsc_addr_2eb3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_fft_trunc_num:3;
        RBus_UInt32  cci_fft_out_mode:1;
        RBus_UInt32  cci_fft_dsp_read:1;
        RBus_UInt32  cci_fft_act_num_5_3:3;
    };
}atsc_addr_2eb4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_pos_5_0:6;
        RBus_UInt32  cci_rej_on:1;
        RBus_UInt32  cci_detected:1;
    };
}atsc_addr_2eb5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_val_0:1;
        RBus_UInt32  cci_pos_12_6:7;
    };
}atsc_addr_2eb6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cci_val_8_1:8;
    };
}atsc_addr_2eb7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  cci_val_13_9:5;
    };
}atsc_addr_2eb8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  cr_trk1_period_ub:3;
        RBus_UInt32  cr_trk1_period_lb:3;
    };
}atsc_addr_264b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  cr_corr_th:6;
        RBus_UInt32  cr_ld_corr_en:1;
    };
}atsc_addr_264c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  cr_fs_reset_en:1;
        RBus_UInt32  cr_trk1_trk2_rst_en:1;
        RBus_UInt32  cr_ld_trk2_unlock_and_or:1;
        RBus_UInt32  cr_ld_trk2_unlock_in_en:1;
        RBus_UInt32  cr_ld_trk2_unlock_corr_en:1;
    };
}atsc_addr_264d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_acq_period1_ub1:3;
        RBus_UInt32  cr_acq_period1_ub0:3;
        RBus_UInt32  cr_search_mode:1;
        RBus_UInt32  cr_fsm_on:1;
    };
}atsc_addr_2650_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  cr_acq_period1_lb1:2;
        RBus_UInt32  cr_acq_period1_lb0:2;
        RBus_UInt32  res2:3;
    };
}atsc_addr_2651_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_acq_unlock_period:3;
        RBus_UInt32  res2:5;
    };
}atsc_addr_2652_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  cr_ld_period:3;
        RBus_UInt32  cr_comp_period:3;
    };
}atsc_addr_2653_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  cr_acq_freq_step0:6;
    };
}atsc_addr_2654_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  cr_acq_freq_step1:6;
    };
}atsc_addr_2655_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_acq_if_offset_ini1:4;
        RBus_UInt32  cr_acq_if_offset_ini0:4;
    };
}atsc_addr_2657_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  cr_acq_pre_shift:7;
    };
}atsc_addr_2659_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_const_inc_7_0:8;
    };
}atsc_addr_265a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_const_inc_15_8:8;
    };
}atsc_addr_265b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  cr_const_inc_16:1;
    };
}atsc_addr_265c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  cr_acq_freq_ub:6;
    };
}atsc_addr_265d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_main_addr_th1_7_0:8;
    };
}atsc_addr_265e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_main_addr_th1_11_8:4;
    };
}atsc_addr_265f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_main_addr_th2_7_0:8;
    };
}atsc_addr_2660_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_main_addr_th2_11_8:4;
    };
}atsc_addr_2661_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_main_addr_th3_7_0:8;
    };
}atsc_addr_2662_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_main_addr_th3_11_8:4;
    };
}atsc_addr_2663_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_main_addr_th4_7_0:8;
    };
}atsc_addr_2664_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_main_addr_th4_11_8:4;
    };
}atsc_addr_2665_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_main_addr_th5_7_0:8;
    };
}atsc_addr_2666_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_main_addr_th5_11_8:4;
    };
}atsc_addr_2667_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_main_addr_th6_7_0:8;
    };
}atsc_addr_2668_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_main_addr_th6_11_8:4;
    };
}atsc_addr_2669_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  fs2_main_max_ratio2:7;
    };
}atsc_addr_266a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  fs2_main_max_ratio3:7;
    };
}atsc_addr_266b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  fs2_main_max_ratio4:7;
    };
}atsc_addr_266c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  fs2_main_max_ratio5:7;
    };
}atsc_addr_266d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  fs2_main_max_ratio6:7;
    };
}atsc_addr_266e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  fs2_main_max_ratio7:7;
    };
}atsc_addr_266f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_corr_amp_sel:1;
        RBus_UInt32  fs2_main_max_ratio:7;
    };
}atsc_addr_2670_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_wmax_size_7_0:8;
    };
}atsc_addr_2671_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_wmax_size_11_8:4;
    };
}atsc_addr_2672_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_corr_amp_th1_7_0:8;
    };
}atsc_addr_2673_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  fs2_corr_amp_th1_12_8:5;
    };
}atsc_addr_2674_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_max_rec_sam_num_7_0:8;
    };
}atsc_addr_2675_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_max_rec_sam_num_11_8:4;
    };
}atsc_addr_2676_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_max_rec_sam_num_2_3_0:4;
        RBus_UInt32  fs2_wp_post_size_10_7:4;
    };
}atsc_addr_26ae_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_max_rec_sam_num_2_11_4:8;
    };
}atsc_addr_26af_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_wmain_size_7_0:8;
    };
}atsc_addr_2677_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_wmain_size_11_8:4;
    };
}atsc_addr_2678_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_wmain_size2_7_0:8;
    };
}atsc_addr_2679_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_wmain_size2_11_8:4;
    };
}atsc_addr_267a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_wp_main_size_7_0:8;
    };
}atsc_addr_267b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_wp_main_size_11_8:4;
    };
}atsc_addr_267c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_wpre_size_7_0:8;
    };
}atsc_addr_267d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_wpre_size_11_8:4;
    };
}atsc_addr_267e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_wpre_size2_7_0:8;
    };
}atsc_addr_267f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_wpre_size2_11_8:4;
    };
}atsc_addr_2680_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_corr_th_pre_7_0:8;
    };
}atsc_addr_2681_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  fs2_corr_th_pre_12_8:5;
    };
}atsc_addr_2682_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_wp_pre_size_7_0:8;
    };
}atsc_addr_2683_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_wp_pre_size_11_8:4;
    };
}atsc_addr_2684_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_main_ind_offset:4;
        RBus_UInt32  fs2_main_max_offset:4;
    };
}atsc_addr_2685_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_max_re_ind_offset:4;
    };
}atsc_addr_2686_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  fs2_force_num_decode_default:7;
    };
}atsc_addr_2687_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_force_space_default_7_0:8;
    };
}atsc_addr_2688_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_force_space_default_11_8:4;
    };
}atsc_addr_2689_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_main_isnot_max_force_en:1;
        RBus_UInt32  fs2_s11_wait_max:1;
        RBus_UInt32  fs2_pre_ram_off:1;
        RBus_UInt32  fs2_main_ram_off:1;
        RBus_UInt32  fs2_refresh_max_amp_s4:1;
        RBus_UInt32  fs2_force_en:1;
        RBus_UInt32  fs2_main_isnot_max_off:1;
        RBus_UInt32  fs2_force_manu:1;
    };
}atsc_addr_268a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_space_th_0_7_0:8;
    };
}atsc_addr_268b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_space_th_0_11_8:4;
    };
}atsc_addr_268c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_space_th_1_7_0:8;
    };
}atsc_addr_268d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_space_th_1_11_8:4;
    };
}atsc_addr_268e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_space_th_2_7_0:8;
    };
}atsc_addr_268f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_space_th_2_11_8:4;
    };
}atsc_addr_2690_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_space_th_3_7_0:8;
    };
}atsc_addr_2691_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_space_th_3_11_8:4;
    };
}atsc_addr_2692_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_space_th_4_7_0:8;
    };
}atsc_addr_2693_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_space_th_4_11_8:4;
    };
}atsc_addr_2694_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_space_th_5_7_0:8;
    };
}atsc_addr_2695_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_space_th_5_11_8:4;
    };
}atsc_addr_2696_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_space_th_6_7_0:8;
    };
}atsc_addr_2697_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_space_th_6_11_8:4;
    };
}atsc_addr_2698_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_space_th_7_7_0:8;
    };
}atsc_addr_2699_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_space_th_7_11_8:4;
    };
}atsc_addr_269a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  fs2_amp_ratio_0:6;
    };
}atsc_addr_269b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  fs2_amp_ratio_1:6;
    };
}atsc_addr_269c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  fs2_amp_ratio_2:6;
    };
}atsc_addr_269d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  fs2_amp_ratio_3:6;
    };
}atsc_addr_269e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  fs2_amp_ratio_4:6;
    };
}atsc_addr_269f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  fs2_amp_ratio_5:6;
    };
}atsc_addr_26a0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  fs2_amp_ratio_6:6;
    };
}atsc_addr_26a1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  fs2_amp_ratio_7:6;
    };
}atsc_addr_26a2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_precursor_7_0:8;
    };
}atsc_addr_26a3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_wpost_start_11:1;
        RBus_UInt32  fs2_wp_post_size_11:1;
        RBus_UInt32  fs2_wpost_size2_11:1;
        RBus_UInt32  fs2_wpost_size_11:1;
        RBus_UInt32  fs2_precursor_11_8:4;
    };
}atsc_addr_26a4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  fs2_force_width:6;
    };
}atsc_addr_26a5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_addr_pl_offset:5;
        RBus_UInt32  fs2_tr_reset_en:1;
        RBus_UInt32  fs2_wm_start_sel:1;
        RBus_UInt32  fs2_preload_on:1;
    };
}atsc_addr_26a6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_wpost_start_4_0:5;
        RBus_UInt32  fs2_post_ram_off:1;
        RBus_UInt32  fs2_wpost_start_en:1;
        RBus_UInt32  fs2_struc_sel:1;
    };
}atsc_addr_26a7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_wpost_size_1_0:2;
        RBus_UInt32  fs2_wpost_start_10_5:6;
    };
}atsc_addr_26a8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_wpost_size_9_2:8;
    };
}atsc_addr_26a9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_wpost_size2_6_0:7;
        RBus_UInt32  fs2_wpost_size_10:1;
    };
}atsc_addr_26aa_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_corr_th_post_3_0:4;
        RBus_UInt32  fs2_wpost_size2_10_7:4;
    };
}atsc_addr_26ab_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_corr_th_post_11_4:8;
    };
}atsc_addr_26ac_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_wp_post_size_6_0:7;
        RBus_UInt32  fs2_corr_th_post_12:1;
    };
}atsc_addr_26ad_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_wparallel_size_5_0:6;
        RBus_UInt32  fs2_parallel_ram_off:1;
        RBus_UInt32  fs2_parallel_search_en:1;
    };
}atsc_addr_2060_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_wparallel_size2_2_0:3;
        RBus_UInt32  fs2_wparallel_size_10_6:5;
    };
}atsc_addr_2061_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_wparallel_size2_10_3:8;
    };
}atsc_addr_2062_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_corr_th_parallel_7_0:8;
    };
}atsc_addr_2063_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_wp_parallel_size_2_0:3;
        RBus_UInt32  fs2_corr_th_parallel_12_8:5;
    };
}atsc_addr_2064_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_wp_parallel_size_10_3:8;
    };
}atsc_addr_2065_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_ffe_struc_sel_opt1_1_0:2;
        RBus_UInt32  fs2_post_echo_num_th:3;
        RBus_UInt32  fs2_pre_echo_num_th:3;
    };
}atsc_addr_2066_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_ffe_struc_sel_opt0_0:1;
        RBus_UInt32  fs2_ffe_struc_sel_opt3:3;
        RBus_UInt32  fs2_ffe_struc_sel_opt2:3;
        RBus_UInt32  fs2_ffe_struc_sel_opt1_2:1;
    };
}atsc_addr_2067_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_ffe_sp_hold_opt2:1;
        RBus_UInt32  fs2_ffe_sp_hold_opt1:1;
        RBus_UInt32  res2:4;
        RBus_UInt32  fs2_ffe_struc_sel_opt0_2_1:2;
    };
}atsc_addr_2068_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_auto_switch_opt:1;
        RBus_UInt32  fs2_wp_parallel_size_11:1;
        RBus_UInt32  fs2_wparallel_size2_11:1;
        RBus_UInt32  fs2_wparallel_size_11:1;
        RBus_UInt32  fs2_eq_auto_ffe_sp_hold_en:1;
        RBus_UInt32  fs2_eq_auto_struc_en:1;
        RBus_UInt32  fs2_ffe_sp_hold_opt0:1;
        RBus_UInt32  fs2_ffe_sp_hold_opt3:1;
    };
}atsc_addr_2069_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  reg_stage_length_1076_ini_7_0:8;
    };
}atsc_addr_206a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  stage_length_1076_ini_opt1_4_0:5;
        RBus_UInt32  reg_stage_length_1076_ini_10_8:3;
    };
}atsc_addr_206b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  stage_length_1076_ini_opt2_1_0:2;
        RBus_UInt32  stage_length_1076_ini_opt1_10_5:6;
    };
}atsc_addr_206c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  stage_length_1076_ini_opt2_9_2:8;
    };
}atsc_addr_206d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  stage_length_1076_ini_opt3_6_0:7;
        RBus_UInt32  stage_length_1076_ini_opt2_10:1;
    };
}atsc_addr_206e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  stage_length_1076_ini_opt0_3_0:4;
        RBus_UInt32  stage_length_1076_ini_opt3_10_7:4;
    };
}atsc_addr_206f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_in_ptr_ini_opt1_0:1;
        RBus_UInt32  stage_length_1076_ini_opt0_10_4:7;
    };
}atsc_addr_2070_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_in_ptr_ini_opt1_8_1:8;
    };
}atsc_addr_2071_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_in_ptr_ini_opt2_2_0:3;
        RBus_UInt32  ffe_in_ptr_ini_opt1_13_9:5;
    };
}atsc_addr_2072_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_in_ptr_ini_opt2_10_3:8;
    };
}atsc_addr_2073_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_in_ptr_ini_opt3_4_0:5;
        RBus_UInt32  ffe_in_ptr_ini_opt2_13_11:3;
    };
}atsc_addr_2074_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_in_ptr_ini_opt3_12_5:8;
    };
}atsc_addr_2075_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_in_ptr_ini_opt0_6_0:7;
        RBus_UInt32  ffe_in_ptr_ini_opt3_13:1;
    };
}atsc_addr_2076_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  ffe_in_ptr_ini_opt0_13_7:7;
    };
}atsc_addr_2077_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_parallel_addr_th1_7_0:8;
    };
}atsc_addr_2eb9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_parallel_addr_th1_11_8:4;
    };
}atsc_addr_2eba_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_parallel_addr_th2_7_0:8;
    };
}atsc_addr_2ebb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_parallel_addr_th2_11_8:4;
    };
}atsc_addr_2ebc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_parallel_addr_th3_7_0:8;
    };
}atsc_addr_2ebd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_parallel_addr_th3_11_8:4;
    };
}atsc_addr_2ebe_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_parallel_addr_th4_7_0:8;
    };
}atsc_addr_2ebf_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_parallel_addr_th4_11_8:4;
    };
}atsc_addr_2ec0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_parallel_addr_th5_7_0:8;
    };
}atsc_addr_2ec1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_parallel_addr_th5_11_8:4;
    };
}atsc_addr_2ec2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_parallel_addr_th6_7_0:8;
    };
}atsc_addr_2ec3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_parallel_addr_th6_11_8:4;
    };
}atsc_addr_2ec4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_parallel_th_1_7_0:8;
    };
}atsc_addr_2ec5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  fs2_parallel_th_1_12_8:5;
    };
}atsc_addr_2ec6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_parallel_th_2_7_0:8;
    };
}atsc_addr_2ec7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  fs2_parallel_th_2_12_8:5;
    };
}atsc_addr_2ec8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_parallel_th_3_7_0:8;
    };
}atsc_addr_2ec9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  fs2_parallel_th_3_12_8:5;
    };
}atsc_addr_2eca_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_parallel_th_4_7_0:8;
    };
}atsc_addr_2ecb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  fs2_parallel_th_4_12_8:5;
    };
}atsc_addr_2ecc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_parallel_th_5_7_0:8;
    };
}atsc_addr_2ecd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  fs2_parallel_th_5_12_8:5;
    };
}atsc_addr_2ece_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_parallel_th_6_7_0:8;
    };
}atsc_addr_2ecf_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  fs2_parallel_th_6_12_8:5;
    };
}atsc_addr_2ed0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_parallel_th_7_7_0:8;
    };
}atsc_addr_2ed1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  fs2_parallel_th_7_12_8:5;
    };
}atsc_addr_2ed2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_parallel_addr_ini_7_0:8;
    };
}atsc_addr_2ed3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_parallel_addr_ini_11_8:4;
    };
}atsc_addr_2ed4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_parallel_main_addr_7_0:8;
    };
}atsc_addr_2ed5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_parallel_main_addr_11_8:4;
    };
}atsc_addr_2ed6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fsm_segment_counter_opt0_7_0:8;
    };
}atsc_addr_2ed7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fsm_segment_counter_opt1_6_0:7;
        RBus_UInt32  fsm_segment_counter_opt0_8:1;
    };
}atsc_addr_2ed8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fsm_segment_counter_opt2_5_0:6;
        RBus_UInt32  fsm_segment_counter_opt1_8_7:2;
    };
}atsc_addr_2ed9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fsm_segment_counter_opt3_4_0:5;
        RBus_UInt32  fsm_segment_counter_opt2_8_6:3;
    };
}atsc_addr_2eda_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fsm_symbol_counter_opt0_3_0:4;
        RBus_UInt32  fsm_segment_counter_opt3_8_5:4;
    };
}atsc_addr_2edb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fsm_symbol_counter_opt1_1_0:2;
        RBus_UInt32  fsm_symbol_counter_opt0_9_4:6;
    };
}atsc_addr_2edc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fsm_symbol_counter_opt1_9_2:8;
    };
}atsc_addr_2edd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fsm_symbol_counter_opt2_7_0:8;
    };
}atsc_addr_2ede_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fsm_symbol_counter_opt3_5_0:6;
        RBus_UInt32  fsm_symbol_counter_opt2_9_8:2;
    };
}atsc_addr_2edf_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fsm_symbol_counter_opt3_9_6:4;
    };
}atsc_addr_2ee0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  field_sync_lock_delay_opt0_7_0:8;
    };
}atsc_addr_2ee1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  field_sync_lock_delay_opt0_15_8:8;
    };
}atsc_addr_2ee2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  field_sync_lock_delay_opt1_7_0:8;
    };
}atsc_addr_2ee3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  field_sync_lock_delay_opt1_15_8:8;
    };
}atsc_addr_2ee4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  field_sync_lock_delay_opt2_7_0:8;
    };
}atsc_addr_2ee5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  field_sync_lock_delay_opt2_15_8:8;
    };
}atsc_addr_2ee6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  field_sync_lock_delay_opt3_7_0:8;
    };
}atsc_addr_2ee7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  field_sync_lock_delay_opt3_15_8:8;
    };
}atsc_addr_2ee8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_main_head_opt0_7_0:8;
    };
}atsc_addr_2ee9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_main_head_opt1_6_0:7;
        RBus_UInt32  ffe_main_head_opt0_8:1;
    };
}atsc_addr_2eea_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_main_head_opt2_5_0:6;
        RBus_UInt32  ffe_main_head_opt1_8_7:2;
    };
}atsc_addr_2eeb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_main_head_opt3_4_0:5;
        RBus_UInt32  ffe_main_head_opt2_8_6:3;
    };
}atsc_addr_2eec_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  ffe_main_head_opt3_8_5:4;
    };
}atsc_addr_2eed_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_main_end_opt0_7_0:8;
    };
}atsc_addr_2eee_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_main_end_opt1_6_0:7;
        RBus_UInt32  ffe_main_end_opt0_8:1;
    };
}atsc_addr_2eef_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_main_end_opt2_5_0:6;
        RBus_UInt32  ffe_main_end_opt1_8_7:2;
    };
}atsc_addr_2ef0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_main_end_opt3_4_0:5;
        RBus_UInt32  ffe_main_end_opt2_8_6:3;
    };
}atsc_addr_2ef1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  ffe_main_end_opt3_8_5:4;
    };
}atsc_addr_2ef2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  fs2_force_main_width_exp:3;
    };
}atsc_addr_2ef3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_precursor_opt0_7_0:8;
    };
}atsc_addr_2078_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_precursor_opt1_3_0:4;
        RBus_UInt32  fs2_precursor_opt0_11_8:4;
    };
}atsc_addr_2079_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_precursor_opt1_11_4:8;
    };
}atsc_addr_207a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_precursor_opt2_7_0:8;
    };
}atsc_addr_207b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_precursor_opt3_3_0:4;
        RBus_UInt32  fs2_precursor_opt2_11_8:4;
    };
}atsc_addr_207c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_precursor_opt3_11_4:8;
    };
}atsc_addr_207d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  cr_adp_state_clear_en:1;
        RBus_UInt32  cr_adp_bw_en:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  cr_adp_bw_cr_offset_dif_cond_32:1;
    };
}atsc_addr_2ef8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  cr_adp_bw_react_state:6;
    };
}atsc_addr_2ef9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  cr_adp_bw_start_state:6;
    };
}atsc_addr_2efa_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  cr_adp_bw_load_state:6;
    };
}atsc_addr_2efb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_adp_bw_cr_offset_dif_cond_7_0:8;
    };
}atsc_addr_2ef4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_adp_bw_cr_offset_dif_cond_15_8:8;
    };
}atsc_addr_2ef5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_adp_bw_cr_offset_dif_cond_23_16:8;
    };
}atsc_addr_2ef6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_adp_bw_cr_offset_dif_cond_31_24:8;
    };
}atsc_addr_2ef7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_adp_bw_fs2_parallel_amp_0_cond_7_0:8;
    };
}atsc_addr_2efc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  cr_adp_bw_fs2_parallel_amp_0_cond_12_8:5;
    };
}atsc_addr_2efd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_adp_bw_fs2_parallel_addr_0_cond_head_7_0:8;
    };
}atsc_addr_2efe_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  cr_adp_bw_fs2_parallel_addr_0_cond_head_11_8:4;
    };
}atsc_addr_2eff_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_adp_bw_fs2_parallel_addr_0_cond_end_7_0:8;
    };
}atsc_addr_2e07_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  cr_adp_bw_fs2_parallel_addr_0_cond_end_11_8:4;
    };
}atsc_addr_2e08_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_offset_dif_record_size_7_0:8;
    };
}atsc_addr_2e09_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  cr_offset_dif_record_size_10_8:3;
    };
}atsc_addr_2e0a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_adp_bw_cr_fmu_upd_cnt_th_default:8;
    };
}atsc_addr_2e0b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_adp_bw_cr_lpf_shift_default_7_0:8;
    };
}atsc_addr_2e0c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_adp_bw_cr_pmu_comp1_default:4;
        RBus_UInt32  cr_adp_bw_cr_lpf_shift_default_11_8:4;
    };
}atsc_addr_2e0d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_adp_bw_fsm_cr_fmu_33_default:4;
        RBus_UInt32  cr_adp_bw_fsm_cr_fmu_32_default:4;
    };
}atsc_addr_2e0e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_adp_bw_fsm_cr_pmu_32_default:4;
        RBus_UInt32  cr_adp_bw_fsm_cr_fmu_34_default:4;
    };
}atsc_addr_2e0f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_adp_bw_fsm_cr_pmu_34_default:4;
        RBus_UInt32  cr_adp_bw_fsm_cr_pmu_33_default:4;
    };
}atsc_addr_2e10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_adp_bw_cr_fmu_upd_cnt_th_echo:8;
    };
}atsc_addr_2e11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_adp_bw_cr_lpf_shift_echo_7_0:8;
    };
}atsc_addr_2e12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_adp_bw_cr_pmu_comp1_echo:4;
        RBus_UInt32  cr_adp_bw_cr_lpf_shift_echo_11_8:4;
    };
}atsc_addr_2e13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_adp_bw_fsm_cr_fmu_33_echo:4;
        RBus_UInt32  cr_adp_bw_fsm_cr_fmu_32_echo:4;
    };
}atsc_addr_2e14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_adp_bw_fsm_cr_pmu_32_echo:4;
        RBus_UInt32  cr_adp_bw_fsm_cr_fmu_34_echo:4;
    };
}atsc_addr_2e15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_adp_bw_fsm_cr_pmu_34_echo:4;
        RBus_UInt32  cr_adp_bw_fsm_cr_pmu_33_echo:4;
    };
}atsc_addr_2e16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_adp_bw_cr_fmu_upd_cnt_th_aci:8;
    };
}atsc_addr_2e17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_adp_bw_cr_lpf_shift_aci_7_0:8;
    };
}atsc_addr_2e18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_adp_bw_cr_pmu_comp1_aci:4;
        RBus_UInt32  cr_adp_bw_cr_lpf_shift_aci_11_8:4;
    };
}atsc_addr_2e19_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_adp_bw_fsm_cr_fmu_33_aci:4;
        RBus_UInt32  cr_adp_bw_fsm_cr_fmu_32_aci:4;
    };
}atsc_addr_2e1a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_adp_bw_fsm_cr_pmu_32_aci:4;
        RBus_UInt32  cr_adp_bw_fsm_cr_fmu_34_aci:4;
    };
}atsc_addr_2e1b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_adp_bw_fsm_cr_pmu_34_aci:4;
        RBus_UInt32  cr_adp_bw_fsm_cr_pmu_33_aci:4;
    };
}atsc_addr_2e1c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_adp_bw_cr_fmu_upd_cnt_th_no_echo:8;
    };
}atsc_addr_2e1d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_adp_bw_cr_lpf_shift_no_echo_7_0:8;
    };
}atsc_addr_2e1e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_adp_bw_cr_pmu_comp1_no_echo:4;
        RBus_UInt32  cr_adp_bw_cr_lpf_shift_no_echo_11_8:4;
    };
}atsc_addr_2e1f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_adp_bw_fsm_cr_fmu_33_no_echo:4;
        RBus_UInt32  cr_adp_bw_fsm_cr_fmu_32_no_echo:4;
    };
}atsc_addr_2e20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_adp_bw_fsm_cr_pmu_32_no_echo:4;
        RBus_UInt32  cr_adp_bw_fsm_cr_fmu_34_no_echo:4;
    };
}atsc_addr_2e21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_adp_bw_fsm_cr_pmu_34_no_echo:4;
        RBus_UInt32  cr_adp_bw_fsm_cr_pmu_33_no_echo:4;
    };
}atsc_addr_2e22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_adp_bw_cr_fmu_upd_cnt_th_ebs:8;
    };
}atsc_addr_2e23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_adp_bw_cr_lpf_shift_ebs_7_0:8;
    };
}atsc_addr_2e24_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_adp_bw_cr_pmu_comp1_ebs:4;
        RBus_UInt32  cr_adp_bw_cr_lpf_shift_ebs_11_8:4;
    };
}atsc_addr_2e25_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_adp_bw_fsm_cr_fmu_33_ebs:4;
        RBus_UInt32  cr_adp_bw_fsm_cr_fmu_32_ebs:4;
    };
}atsc_addr_2e26_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_adp_bw_fsm_cr_pmu_32_ebs:4;
        RBus_UInt32  cr_adp_bw_fsm_cr_fmu_34_ebs:4;
    };
}atsc_addr_2e27_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_adp_bw_fsm_cr_pmu_34_ebs:4;
        RBus_UInt32  cr_adp_bw_fsm_cr_pmu_33_ebs:4;
    };
}atsc_addr_2e28_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  corr_th1_7_0:8;
    };
}atsc_addr_26b0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  corr_th1_12_8:5;
    };
}atsc_addr_26b1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  pn63_flag_error_and_or:1;
        RBus_UInt32  pn63_flag_error_02_en:1;
        RBus_UInt32  pn63_flag_error_2_en:1;
        RBus_UInt32  pn63_flag_error_0_en:1;
        RBus_UInt32  pn63_flag_type_sel:2;
        RBus_UInt32  pn63_flag_source_sel:1;
        RBus_UInt32  pn63_flag_par:1;
    };
}atsc_addr_26b2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  pn63_flag_load_delay_7_0:8;
    };
}atsc_addr_26b3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  pn63_flag_load_delay_13_8:6;
    };
}atsc_addr_26b4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  search_cursor_en:1;
        RBus_UInt32  fs_pn63_re_find_en:1;
        RBus_UInt32  fs_lock_sel:1;
    };
}atsc_addr_26b5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  field_sync_lock_delay_7_0:8;
    };
}atsc_addr_26b6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  field_sync_lock_delay_15_8:8;
    };
}atsc_addr_26b7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  corr_th2_7_0:8;
    };
}atsc_addr_26b8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  training_reserved_en:1;
        RBus_UInt32  corr_th2_10_8:3;
    };
}atsc_addr_26b9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ch_esti_seg_6_0:7;
        RBus_UInt32  ch_esti_en:1;
    };
}atsc_addr_26ba_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  ch_esti_seg_8_7:2;
    };
}atsc_addr_26bb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ch_esti_sym_1_0:2;
        RBus_UInt32  ch_esti_volume:6;
    };
}atsc_addr_26bc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ch_esti_sym_9_2:8;
    };
}atsc_addr_26bd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ch_esti_rd_add_6_0:7;
        RBus_UInt32  ch_esti_rd_en:1;
    };
}atsc_addr_26be_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  ch_esti_int_par:1;
        RBus_UInt32  ch_esti_sel:1;
        RBus_UInt32  ch_esti_rd_add_9_7:3;
    };
}atsc_addr_26bf_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  deltaf_ratio_2_0:3;
        RBus_UInt32  field_tr_offset:5;
    };
}atsc_addr_26c0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  deltaf_ratio_6_3:4;
    };
}atsc_addr_26c1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs_tr2_corr_th_4_0:5;
        RBus_UInt32  fs_tr2_mode_sel:1;
        RBus_UInt32  fs_tr_corr_sel:1;
        RBus_UInt32  fs_tr_sel:1;
    };
}atsc_addr_26c2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs_tr2_corr_th_12_5:8;
    };
}atsc_addr_26c3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  fs_tr2_diff_ratio:6;
    };
}atsc_addr_26c4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  fs_tr2_max_diff_th:6;
    };
}atsc_addr_26c5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs_tr2_max_offset:8;
    };
}atsc_addr_26c6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  fs_tr2_path_diff_offset:3;
    };
}atsc_addr_26c7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_in_ptr_ini_7_0:8;
    };
}atsc_addr_26d0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  ffe_in_ptr_ini_13_8:6;
    };
}atsc_addr_26d1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_ro_coeff_add_7_0:8;
    };
}atsc_addr_2701_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_ro_sum_add_2_0:3;
        RBus_UInt32  ffe_ro_coeff_add_12_8:5;
    };
}atsc_addr_2702_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_ro_max_add_1_0:2;
        RBus_UInt32  ffe_ro_sum_add_8_3:6;
    };
}atsc_addr_2703_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_ro_gc_add_0:1;
        RBus_UInt32  ffe_ro_max_add_8_2:7;
    };
}atsc_addr_2704_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_ro_muc_add_1_0:2;
        RBus_UInt32  ffe_ro_gc_add_6_1:6;
    };
}atsc_addr_2705_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_ro_gc_en_ind_add_1_0:2;
        RBus_UInt32  ffe_ro_muc_add_7_2:6;
    };
}atsc_addr_2706_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_ro_gc_dis_ind_add_2_0:3;
        RBus_UInt32  ffe_ro_gc_en_ind_add_6_2:5;
    };
}atsc_addr_2707_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  ffe_ro_gc_dis_ind_add_5_3:3;
    };
}atsc_addr_27fe_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_main_head_5_0:6;
        RBus_UInt32  ffe_mu_comp_exp:1;
        RBus_UInt32  ffe_mu_comp_on:1;
    };
}atsc_addr_2708_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_in_sel:1;
        RBus_UInt32  ffe_out_clip_ind_rst:1;
        RBus_UInt32  ffe_main_end_2_0:3;
        RBus_UInt32  ffe_main_head_8_6:3;
    };
}atsc_addr_2709_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  ffe_main_end_8_3:6;
    };
}atsc_addr_27ff_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  ffe_struc_sel:3;
        RBus_UInt32  ffe_sp_coeff_max_en_th_11:1;
    };
}atsc_addr_2713_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_cluster_addr_r_3_8:1;
        RBus_UInt32  ffe_cluster_addr_r_2_8:1;
        RBus_UInt32  ffe_cluster_addr_r_1_8:1;
        RBus_UInt32  ffe_cluster_addr_r_0_8:1;
        RBus_UInt32  ffe_sp_coeff_sum_max_clr:1;
        RBus_UInt32  ffe_sp_dc_trig_r:1;
        RBus_UInt32  ffe_sp_ctrl_sel:1;
        RBus_UInt32  ffe_sp_hold:1;
    };
}atsc_addr_270a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_cluster_addr_r_0_7_0:8;
    };
}atsc_addr_2fca_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_cluster_addr_r_1_7_0:8;
    };
}atsc_addr_270b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_cluster_addr_r_2_7_0:8;
    };
}atsc_addr_270c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_cluster_addr_r_3_7_0:8;
    };
}atsc_addr_270d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_sp_prd_field_exp:4;
        RBus_UInt32  ffe_sp_start_field_exp:4;
    };
}atsc_addr_270e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_sp_check_seg_7_0:8;
    };
}atsc_addr_270f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_sp_coeff_max_dis_th_6_0:7;
        RBus_UInt32  ffe_sp_check_seg_8:1;
    };
}atsc_addr_2710_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_sp_coeff_max_en_th_2_0:3;
        RBus_UInt32  ffe_sp_coeff_max_dis_th_11_7:5;
    };
}atsc_addr_2711_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_sp_coeff_max_en_th_10_3:8;
    };
}atsc_addr_2712_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_on_field_exp:4;
        RBus_UInt32  ffe_gc_main_protect_en:1;
        RBus_UInt32  ffe_gc_tr_odd_off_en:1;
        RBus_UInt32  ffe_gc_coeff_sum_max_clr:1;
        RBus_UInt32  ffe_gc_en:1;
    };
}atsc_addr_2714_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_prd_field_exp:4;
        RBus_UInt32  ffe_gc_start_field_exp:4;
    };
}atsc_addr_2715_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_check_seg_7_0:8;
    };
}atsc_addr_2716_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_en_sum_th_0_6_0:7;
        RBus_UInt32  ffe_gc_check_seg_8:1;
    };
}atsc_addr_2717_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_en_sum_th_1_2_0:3;
        RBus_UInt32  ffe_gc_en_sum_th_0_11_7:5;
    };
}atsc_addr_2718_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_en_sum_th_1_10_3:8;
    };
}atsc_addr_2719_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_en_sum_th_2_6_0:7;
        RBus_UInt32  ffe_gc_en_sum_th_1_11:1;
    };
}atsc_addr_271a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_dis_th_2_0:3;
        RBus_UInt32  ffe_gc_en_sum_th_2_11_7:5;
    };
}atsc_addr_271b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_dis_th_10_3:8;
    };
}atsc_addr_271c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_en_cnt_lb_1_1_0:2;
        RBus_UInt32  ffe_gc_en_cnt_lb_0:5;
        RBus_UInt32  ffe_gc_dis_th_11:1;
    };
}atsc_addr_271d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_en_cnt_lb_2:5;
        RBus_UInt32  ffe_gc_en_cnt_lb_1_4_2:3;
    };
}atsc_addr_271e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_dis_cnt_lb_2_0:3;
        RBus_UInt32  ffe_gc_dis2en_cnt_lb:5;
    };
}atsc_addr_271f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_dis2en_num_ub_3_0:4;
        RBus_UInt32  ffe_gc_range_exp:2;
        RBus_UInt32  ffe_gc_dis_cnt_lb_4_3:2;
    };
}atsc_addr_2720_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  ffe_gc_dis2en_num_ub_6_4:3;
    };
}atsc_addr_2721_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_sync_space_even_en_7:1;
        RBus_UInt32  ffe_sync_space_even_en_6:1;
        RBus_UInt32  ffe_sync_space_even_en_5:1;
        RBus_UInt32  ffe_sync_space_even_en_4:1;
        RBus_UInt32  ffe_sync_space_even_en_3:1;
        RBus_UInt32  ffe_sync_space_even_en_2:1;
        RBus_UInt32  ffe_sync_space_even_en_1:1;
        RBus_UInt32  ffe_sync_space_even_en_0:1;
    };
}atsc_addr_2722_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_sync_space_even_en_15:1;
        RBus_UInt32  ffe_sync_space_even_en_14:1;
        RBus_UInt32  ffe_sync_space_even_en_13:1;
        RBus_UInt32  ffe_sync_space_even_en_12:1;
        RBus_UInt32  ffe_sync_space_even_en_11:1;
        RBus_UInt32  ffe_sync_space_even_en_10:1;
        RBus_UInt32  ffe_sync_space_even_en_9:1;
        RBus_UInt32  ffe_sync_space_even_en_8:1;
    };
}atsc_addr_2723_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_sync_space_even_en_23:1;
        RBus_UInt32  ffe_sync_space_even_en_22:1;
        RBus_UInt32  ffe_sync_space_even_en_21:1;
        RBus_UInt32  ffe_sync_space_even_en_20:1;
        RBus_UInt32  ffe_sync_space_even_en_19:1;
        RBus_UInt32  ffe_sync_space_even_en_18:1;
        RBus_UInt32  ffe_sync_space_even_en_17:1;
        RBus_UInt32  ffe_sync_space_even_en_16:1;
    };
}atsc_addr_2724_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_sync_space_even_en_31:1;
        RBus_UInt32  ffe_sync_space_even_en_30:1;
        RBus_UInt32  ffe_sync_space_even_en_29:1;
        RBus_UInt32  ffe_sync_space_even_en_28:1;
        RBus_UInt32  ffe_sync_space_even_en_27:1;
        RBus_UInt32  ffe_sync_space_even_en_26:1;
        RBus_UInt32  ffe_sync_space_even_en_25:1;
        RBus_UInt32  ffe_sync_space_even_en_24:1;
    };
}atsc_addr_2725_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_sync_space_even_en_39:1;
        RBus_UInt32  ffe_sync_space_even_en_38:1;
        RBus_UInt32  ffe_sync_space_even_en_37:1;
        RBus_UInt32  ffe_sync_space_even_en_36:1;
        RBus_UInt32  ffe_sync_space_even_en_35:1;
        RBus_UInt32  ffe_sync_space_even_en_34:1;
        RBus_UInt32  ffe_sync_space_even_en_33:1;
        RBus_UInt32  ffe_sync_space_even_en_32:1;
    };
}atsc_addr_2726_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_sync_space_even_en_47:1;
        RBus_UInt32  ffe_sync_space_even_en_46:1;
        RBus_UInt32  ffe_sync_space_even_en_45:1;
        RBus_UInt32  ffe_sync_space_even_en_44:1;
        RBus_UInt32  ffe_sync_space_even_en_43:1;
        RBus_UInt32  ffe_sync_space_even_en_42:1;
        RBus_UInt32  ffe_sync_space_even_en_41:1;
        RBus_UInt32  ffe_sync_space_even_en_40:1;
    };
}atsc_addr_2727_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_sync_space_even_en_55:1;
        RBus_UInt32  ffe_sync_space_even_en_54:1;
        RBus_UInt32  ffe_sync_space_even_en_53:1;
        RBus_UInt32  ffe_sync_space_even_en_52:1;
        RBus_UInt32  ffe_sync_space_even_en_51:1;
        RBus_UInt32  ffe_sync_space_even_en_50:1;
        RBus_UInt32  ffe_sync_space_even_en_49:1;
        RBus_UInt32  ffe_sync_space_even_en_48:1;
    };
}atsc_addr_2fc1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_sync_space_even_en_63:1;
        RBus_UInt32  ffe_sync_space_even_en_62:1;
        RBus_UInt32  ffe_sync_space_even_en_61:1;
        RBus_UInt32  ffe_sync_space_even_en_60:1;
        RBus_UInt32  ffe_sync_space_even_en_59:1;
        RBus_UInt32  ffe_sync_space_even_en_58:1;
        RBus_UInt32  ffe_sync_space_even_en_57:1;
        RBus_UInt32  ffe_sync_space_even_en_56:1;
    };
}atsc_addr_2fc2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_sync_space_even_en_71:1;
        RBus_UInt32  ffe_sync_space_even_en_70:1;
        RBus_UInt32  ffe_sync_space_even_en_69:1;
        RBus_UInt32  ffe_sync_space_even_en_68:1;
        RBus_UInt32  ffe_sync_space_even_en_67:1;
        RBus_UInt32  ffe_sync_space_even_en_66:1;
        RBus_UInt32  ffe_sync_space_even_en_65:1;
        RBus_UInt32  ffe_sync_space_even_en_64:1;
    };
}atsc_addr_28f0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_sync_space_even_en_79:1;
        RBus_UInt32  ffe_sync_space_even_en_78:1;
        RBus_UInt32  ffe_sync_space_even_en_77:1;
        RBus_UInt32  ffe_sync_space_even_en_76:1;
        RBus_UInt32  ffe_sync_space_even_en_75:1;
        RBus_UInt32  ffe_sync_space_even_en_74:1;
        RBus_UInt32  ffe_sync_space_even_en_73:1;
        RBus_UInt32  ffe_sync_space_even_en_72:1;
    };
}atsc_addr_28f1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_sync_space_even_en_87:1;
        RBus_UInt32  ffe_sync_space_even_en_86:1;
        RBus_UInt32  ffe_sync_space_even_en_85:1;
        RBus_UInt32  ffe_sync_space_even_en_84:1;
        RBus_UInt32  ffe_sync_space_even_en_83:1;
        RBus_UInt32  ffe_sync_space_even_en_82:1;
        RBus_UInt32  ffe_sync_space_even_en_81:1;
        RBus_UInt32  ffe_sync_space_even_en_80:1;
    };
}atsc_addr_28f2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_sync_space_even_en_95:1;
        RBus_UInt32  ffe_sync_space_even_en_94:1;
        RBus_UInt32  ffe_sync_space_even_en_93:1;
        RBus_UInt32  ffe_sync_space_even_en_92:1;
        RBus_UInt32  ffe_sync_space_even_en_91:1;
        RBus_UInt32  ffe_sync_space_even_en_90:1;
        RBus_UInt32  ffe_sync_space_even_en_89:1;
        RBus_UInt32  ffe_sync_space_even_en_88:1;
    };
}atsc_addr_28f3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_sync_space_odd_en_7:1;
        RBus_UInt32  ffe_sync_space_odd_en_6:1;
        RBus_UInt32  ffe_sync_space_odd_en_5:1;
        RBus_UInt32  ffe_sync_space_odd_en_4:1;
        RBus_UInt32  ffe_sync_space_odd_en_3:1;
        RBus_UInt32  ffe_sync_space_odd_en_2:1;
        RBus_UInt32  ffe_sync_space_odd_en_1:1;
        RBus_UInt32  ffe_sync_space_odd_en_0:1;
    };
}atsc_addr_2728_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_sync_space_odd_en_15:1;
        RBus_UInt32  ffe_sync_space_odd_en_14:1;
        RBus_UInt32  ffe_sync_space_odd_en_13:1;
        RBus_UInt32  ffe_sync_space_odd_en_12:1;
        RBus_UInt32  ffe_sync_space_odd_en_11:1;
        RBus_UInt32  ffe_sync_space_odd_en_10:1;
        RBus_UInt32  ffe_sync_space_odd_en_9:1;
        RBus_UInt32  ffe_sync_space_odd_en_8:1;
    };
}atsc_addr_2729_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_sync_space_odd_en_23:1;
        RBus_UInt32  ffe_sync_space_odd_en_22:1;
        RBus_UInt32  ffe_sync_space_odd_en_21:1;
        RBus_UInt32  ffe_sync_space_odd_en_20:1;
        RBus_UInt32  ffe_sync_space_odd_en_19:1;
        RBus_UInt32  ffe_sync_space_odd_en_18:1;
        RBus_UInt32  ffe_sync_space_odd_en_17:1;
        RBus_UInt32  ffe_sync_space_odd_en_16:1;
    };
}atsc_addr_272a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_sync_space_odd_en_31:1;
        RBus_UInt32  ffe_sync_space_odd_en_30:1;
        RBus_UInt32  ffe_sync_space_odd_en_29:1;
        RBus_UInt32  ffe_sync_space_odd_en_28:1;
        RBus_UInt32  ffe_sync_space_odd_en_27:1;
        RBus_UInt32  ffe_sync_space_odd_en_26:1;
        RBus_UInt32  ffe_sync_space_odd_en_25:1;
        RBus_UInt32  ffe_sync_space_odd_en_24:1;
    };
}atsc_addr_272b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_sync_space_odd_en_39:1;
        RBus_UInt32  ffe_sync_space_odd_en_38:1;
        RBus_UInt32  ffe_sync_space_odd_en_37:1;
        RBus_UInt32  ffe_sync_space_odd_en_36:1;
        RBus_UInt32  ffe_sync_space_odd_en_35:1;
        RBus_UInt32  ffe_sync_space_odd_en_34:1;
        RBus_UInt32  ffe_sync_space_odd_en_33:1;
        RBus_UInt32  ffe_sync_space_odd_en_32:1;
    };
}atsc_addr_272c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_sync_space_odd_en_47:1;
        RBus_UInt32  ffe_sync_space_odd_en_46:1;
        RBus_UInt32  ffe_sync_space_odd_en_45:1;
        RBus_UInt32  ffe_sync_space_odd_en_44:1;
        RBus_UInt32  ffe_sync_space_odd_en_43:1;
        RBus_UInt32  ffe_sync_space_odd_en_42:1;
        RBus_UInt32  ffe_sync_space_odd_en_41:1;
        RBus_UInt32  ffe_sync_space_odd_en_40:1;
    };
}atsc_addr_272d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_sync_space_odd_en_55:1;
        RBus_UInt32  ffe_sync_space_odd_en_54:1;
        RBus_UInt32  ffe_sync_space_odd_en_53:1;
        RBus_UInt32  ffe_sync_space_odd_en_52:1;
        RBus_UInt32  ffe_sync_space_odd_en_51:1;
        RBus_UInt32  ffe_sync_space_odd_en_50:1;
        RBus_UInt32  ffe_sync_space_odd_en_49:1;
        RBus_UInt32  ffe_sync_space_odd_en_48:1;
    };
}atsc_addr_2fc3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_sync_space_odd_en_63:1;
        RBus_UInt32  ffe_sync_space_odd_en_62:1;
        RBus_UInt32  ffe_sync_space_odd_en_61:1;
        RBus_UInt32  ffe_sync_space_odd_en_60:1;
        RBus_UInt32  ffe_sync_space_odd_en_59:1;
        RBus_UInt32  ffe_sync_space_odd_en_58:1;
        RBus_UInt32  ffe_sync_space_odd_en_57:1;
        RBus_UInt32  ffe_sync_space_odd_en_56:1;
    };
}atsc_addr_2fc4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_sync_space_odd_en_71:1;
        RBus_UInt32  ffe_sync_space_odd_en_70:1;
        RBus_UInt32  ffe_sync_space_odd_en_69:1;
        RBus_UInt32  ffe_sync_space_odd_en_68:1;
        RBus_UInt32  ffe_sync_space_odd_en_67:1;
        RBus_UInt32  ffe_sync_space_odd_en_66:1;
        RBus_UInt32  ffe_sync_space_odd_en_65:1;
        RBus_UInt32  ffe_sync_space_odd_en_64:1;
    };
}atsc_addr_28f4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_sync_space_odd_en_79:1;
        RBus_UInt32  ffe_sync_space_odd_en_78:1;
        RBus_UInt32  ffe_sync_space_odd_en_77:1;
        RBus_UInt32  ffe_sync_space_odd_en_76:1;
        RBus_UInt32  ffe_sync_space_odd_en_75:1;
        RBus_UInt32  ffe_sync_space_odd_en_74:1;
        RBus_UInt32  ffe_sync_space_odd_en_73:1;
        RBus_UInt32  ffe_sync_space_odd_en_72:1;
    };
}atsc_addr_28f5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_sync_space_odd_en_87:1;
        RBus_UInt32  ffe_sync_space_odd_en_86:1;
        RBus_UInt32  ffe_sync_space_odd_en_85:1;
        RBus_UInt32  ffe_sync_space_odd_en_84:1;
        RBus_UInt32  ffe_sync_space_odd_en_83:1;
        RBus_UInt32  ffe_sync_space_odd_en_82:1;
        RBus_UInt32  ffe_sync_space_odd_en_81:1;
        RBus_UInt32  ffe_sync_space_odd_en_80:1;
    };
}atsc_addr_28f6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_sync_space_odd_en_95:1;
        RBus_UInt32  ffe_sync_space_odd_en_94:1;
        RBus_UInt32  ffe_sync_space_odd_en_93:1;
        RBus_UInt32  ffe_sync_space_odd_en_92:1;
        RBus_UInt32  ffe_sync_space_odd_en_91:1;
        RBus_UInt32  ffe_sync_space_odd_en_90:1;
        RBus_UInt32  ffe_sync_space_odd_en_89:1;
        RBus_UInt32  ffe_sync_space_odd_en_88:1;
    };
}atsc_addr_28f7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_tr_coeff_th:8;
    };
}atsc_addr_272e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_dd_coeff_th:8;
    };
}atsc_addr_272f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_tr_coeff_en_7:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_6:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_5:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_4:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_3:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_2:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_1:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_0:1;
    };
}atsc_addr_2730_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_tr_coeff_en_15:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_14:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_13:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_12:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_11:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_10:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_9:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_8:1;
    };
}atsc_addr_2731_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_tr_coeff_en_23:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_22:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_21:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_20:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_19:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_18:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_17:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_16:1;
    };
}atsc_addr_2732_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_tr_coeff_en_31:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_30:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_29:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_28:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_27:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_26:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_25:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_24:1;
    };
}atsc_addr_2733_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_tr_coeff_en_39:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_38:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_37:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_36:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_35:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_34:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_33:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_32:1;
    };
}atsc_addr_2734_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_tr_coeff_en_47:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_46:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_45:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_44:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_43:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_42:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_41:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_40:1;
    };
}atsc_addr_2735_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_tr_coeff_en_55:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_54:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_53:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_52:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_51:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_50:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_49:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_48:1;
    };
}atsc_addr_2fc5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_tr_coeff_en_63:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_62:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_61:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_60:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_59:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_58:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_57:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_56:1;
    };
}atsc_addr_2fc6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_tr_coeff_en_71:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_70:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_69:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_68:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_67:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_66:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_65:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_64:1;
    };
}atsc_addr_2fcb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_tr_coeff_en_79:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_78:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_77:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_76:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_75:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_74:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_73:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_72:1;
    };
}atsc_addr_2fcc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_tr_coeff_en_87:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_86:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_85:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_84:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_83:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_82:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_81:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_80:1;
    };
}atsc_addr_2fcd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_tr_coeff_en_95:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_94:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_93:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_92:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_91:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_90:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_89:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_88:1;
    };
}atsc_addr_2fce_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_dd_coeff_en_7:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_6:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_5:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_4:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_3:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_2:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_1:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_0:1;
    };
}atsc_addr_2736_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_dd_coeff_en_15:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_14:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_13:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_12:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_11:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_10:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_9:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_8:1;
    };
}atsc_addr_2737_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_dd_coeff_en_23:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_22:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_21:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_20:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_19:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_18:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_17:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_16:1;
    };
}atsc_addr_2738_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_dd_coeff_en_31:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_30:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_29:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_28:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_27:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_26:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_25:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_24:1;
    };
}atsc_addr_2739_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_dd_coeff_en_39:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_38:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_37:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_36:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_35:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_34:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_33:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_32:1;
    };
}atsc_addr_273a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_dd_coeff_en_47:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_46:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_45:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_44:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_43:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_42:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_41:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_40:1;
    };
}atsc_addr_273b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_dd_coeff_en_55:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_54:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_53:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_52:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_51:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_50:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_49:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_48:1;
    };
}atsc_addr_2fc7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_dd_coeff_en_63:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_62:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_61:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_60:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_59:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_58:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_57:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_56:1;
    };
}atsc_addr_2fc8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_dd_coeff_en_71:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_70:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_69:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_68:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_67:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_66:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_65:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_64:1;
    };
}atsc_addr_2fcf_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_dd_coeff_en_79:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_78:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_77:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_76:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_75:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_74:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_73:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_72:1;
    };
}atsc_addr_2fd1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_dd_coeff_en_87:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_86:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_85:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_84:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_83:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_82:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_81:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_80:1;
    };
}atsc_addr_2fd2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_gc_dd_coeff_en_95:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_94:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_93:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_92:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_91:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_90:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_89:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_88:1;
    };
}atsc_addr_2fd3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_muc_field_size_exp_2_0:3;
        RBus_UInt32  ffe_muc_start_field_exp:4;
        RBus_UInt32  ffe_muc_en:1;
    };
}atsc_addr_273c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_muc_cnt_size:8;
    };
}atsc_addr_2fc9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_muc_field_cnt_seg_6_0:7;
        RBus_UInt32  ffe_muc_field_size_exp_3:1;
    };
}atsc_addr_273d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_muc_group_sum_th_0_2_0:3;
        RBus_UInt32  ffe_muc_main_protect_en:1;
        RBus_UInt32  ffe_muc_mu_bn_slow_en:1;
        RBus_UInt32  ffe_muc_update_type:1;
        RBus_UInt32  ffe_muc_field_cnt_seg_8_7:2;
    };
}atsc_addr_273e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_muc_group_sum_th_0_10_3:8;
    };
}atsc_addr_273f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_muc_group_sum_th_1_6_0:7;
        RBus_UInt32  ffe_muc_group_sum_th_0_11:1;
    };
}atsc_addr_2740_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_muc_group_sum_th_2_2_0:3;
        RBus_UInt32  ffe_muc_group_sum_th_1_11_7:5;
    };
}atsc_addr_2741_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_muc_group_sum_th_2_10_3:8;
    };
}atsc_addr_2742_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_muc_group_sum_th_3_6_0:7;
        RBus_UInt32  ffe_muc_group_sum_th_2_11:1;
    };
}atsc_addr_2743_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_muc_group_sum_th_4_2_0:3;
        RBus_UInt32  ffe_muc_group_sum_th_3_11_7:5;
    };
}atsc_addr_2744_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_muc_group_sum_th_4_10_3:8;
    };
}atsc_addr_2745_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_muc_mu_1_1_0:2;
        RBus_UInt32  ffe_muc_mu_0:5;
        RBus_UInt32  ffe_muc_group_sum_th_4_11:1;
    };
}atsc_addr_2746_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_muc_mu_2:5;
        RBus_UInt32  ffe_muc_mu_1_4_2:3;
    };
}atsc_addr_2747_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_muc_mu_4_2_0:3;
        RBus_UInt32  ffe_muc_mu_3:5;
    };
}atsc_addr_2748_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_muc_mu_main_0_0:1;
        RBus_UInt32  ffe_muc_mu_5:5;
        RBus_UInt32  ffe_muc_mu_4_4_3:2;
    };
}atsc_addr_2749_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_muc_mu_main_1_3_0:4;
        RBus_UInt32  ffe_muc_mu_main_0_4_1:4;
    };
}atsc_addr_274a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_muc_mu_main_3_1_0:2;
        RBus_UInt32  ffe_muc_mu_main_2:5;
        RBus_UInt32  ffe_muc_mu_main_1_4:1;
    };
}atsc_addr_274b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_muc_mu_main_4:5;
        RBus_UInt32  ffe_muc_mu_main_3_4_2:3;
    };
}atsc_addr_274c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_muc_mu_bn_slow_0_2_0:3;
        RBus_UInt32  ffe_muc_mu_main_5:5;
    };
}atsc_addr_274d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_muc_mu_bn_slow_2_0:1;
        RBus_UInt32  ffe_muc_mu_bn_slow_1:5;
        RBus_UInt32  ffe_muc_mu_bn_slow_0_4_3:2;
    };
}atsc_addr_274e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_muc_mu_bn_slow_3_3_0:4;
        RBus_UInt32  ffe_muc_mu_bn_slow_2_4_1:4;
    };
}atsc_addr_274f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_muc_mu_bn_slow_5_1_0:2;
        RBus_UInt32  ffe_muc_mu_bn_slow_4:5;
        RBus_UInt32  ffe_muc_mu_bn_slow_3_4:1;
    };
}atsc_addr_2750_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  eqpt_h_hil_0_3_0:4;
        RBus_UInt32  eqpt_on:1;
        RBus_UInt32  ffe_muc_mu_bn_slow_5_4_2:3;
    };
}atsc_addr_2751_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  eqpt_h_hil_2_3_0:4;
        RBus_UInt32  eqpt_h_hil_0_7_4:4;
    };
}atsc_addr_2752_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  eqpt_h_hil_2_7_4:4;
    };
}atsc_addr_2753_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_ro_tap_add_1_0:2;
        RBus_UInt32  fbf_ro_group_add:3;
        RBus_UInt32  fbf_ro_bank_add:3;
    };
}atsc_addr_2754_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_ro_sum_add_4_0:5;
        RBus_UInt32  fbf_ro_tap_add_4_2:3;
    };
}atsc_addr_2755_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  fbf_ro_sum_add_6_5:2;
    };
}atsc_addr_2756_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_ro_muc_add_2_0:3;
        RBus_UInt32  fbf_ro_gc_add:4;
        RBus_UInt32  res2:1;
    };
}atsc_addr_2757_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_ro_gc_en_ind_add_4_0:5;
        RBus_UInt32  fbf_ro_muc_add_5_3:3;
    };
}atsc_addr_2758_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  zd_viterbi_in_sel:1;
        RBus_UInt32  pt_in_sel:1;
        RBus_UInt32  eqout_sel:1;
        RBus_UInt32  fs_705_820_en:1;
        RBus_UInt32  fbf_ro_gc_dis_ind_add:4;
    };
}atsc_addr_2759_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_main_end_2_0:3;
        RBus_UInt32  fbf_mu_comp_exp:1;
        RBus_UInt32  fbf_mu_comp_on:1;
        RBus_UInt32  eq_out_mse_in_sel:1;
        RBus_UInt32  eq_out_er_in_sel:1;
        RBus_UInt32  slicer_in_sel:1;
    };
}atsc_addr_275a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_const_en:1;
        RBus_UInt32  fbf_coeff_ub:4;
        RBus_UInt32  fbf_coeff_ub_en:1;
        RBus_UInt32  fbf_main_end_4_3:2;
    };
}atsc_addr_275b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fsm_fbf_const_seg_cnt_1_0:2;
        RBus_UInt32  fbf_const_on_state:6;
    };
}atsc_addr_275c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_const_field_cnt_th_exp_0:1;
        RBus_UInt32  fsm_fbf_const_seg_cnt_8_2:7;
    };
}atsc_addr_275d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_const_coeff_sum_th_4_0:5;
        RBus_UInt32  fbf_const_field_cnt_th_exp_3_1:3;
    };
}atsc_addr_275e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_update_th_2_0:3;
        RBus_UInt32  fbf_const_coeff_sum_th_9_5:5;
    };
}atsc_addr_275f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_update_th_10_3:8;
    };
}atsc_addr_2760_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_const_ratio1_2_0:3;
        RBus_UInt32  fbf_coeff_sum_sel:1;
        RBus_UInt32  fbf_update_th_14_11:4;
    };
}atsc_addr_2761_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_const_start_update_th1_2_0:3;
        RBus_UInt32  fbf_const_ratio2:4;
        RBus_UInt32  fbf_const_ratio1_3:1;
    };
}atsc_addr_2762_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_const_start_update_th2_0:1;
        RBus_UInt32  fbf_const_start_update_th1_9_3:7;
    };
}atsc_addr_2763_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_const_start_update_th2_8_1:8;
    };
}atsc_addr_2764_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_const_manu_val_6_0:7;
        RBus_UInt32  fbf_const_start_update_th2_9:1;
    };
}atsc_addr_2765_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_const_exp:4;
        RBus_UInt32  fbf_const_manu_en:1;
        RBus_UInt32  fbf_const_manu_val_9_7:3;
    };
}atsc_addr_2766_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_const_lamda_max_0:1;
        RBus_UInt32  fbf_const_lamda_sel:1;
        RBus_UInt32  fbf_const_man:6;
    };
}atsc_addr_2767_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_const_lamda_max_8_1:8;
    };
}atsc_addr_2768_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_const_mse_en:1;
        RBus_UInt32  fbf_const_lamda_max_15_9:7;
    };
}atsc_addr_2769_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_const_mse_lamda_th_6_0:7;
        RBus_UInt32  fbf_const_mse_sel:1;
    };
}atsc_addr_276a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_const_mse_lamda_0:1;
        RBus_UInt32  fbf_const_mse_lamda_th_13_7:7;
    };
}atsc_addr_276b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_const_mse_lamda_8_1:8;
    };
}atsc_addr_276c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_muc_en:1;
        RBus_UInt32  fbf_const_mse_lamda_15_9:7;
    };
}atsc_addr_276d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_muc_field_size_exp:4;
        RBus_UInt32  fbf_muc_start_field_exp:4;
    };
}atsc_addr_276e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_muc_field_cnt_seg_7_0:8;
    };
}atsc_addr_276f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_muc_group_sum_th_0_3_0:4;
        RBus_UInt32  fbf_muc_main_protect_en:1;
        RBus_UInt32  fbf_muc_mu_bn_slow_en:1;
        RBus_UInt32  fbf_muc_update_type:1;
        RBus_UInt32  fbf_muc_field_cnt_seg_8:1;
    };
}atsc_addr_2770_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_muc_group_sum_th_0_11_4:8;
    };
}atsc_addr_2771_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_muc_group_sum_th_1_7_0:8;
    };
}atsc_addr_2772_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_muc_group_sum_th_2_3_0:4;
        RBus_UInt32  fbf_muc_group_sum_th_1_11_8:4;
    };
}atsc_addr_2773_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_muc_group_sum_th_2_11_4:8;
    };
}atsc_addr_2774_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_muc_group_sum_th_3_7_0:8;
    };
}atsc_addr_2775_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_muc_group_sum_th_4_3_0:4;
        RBus_UInt32  fbf_muc_group_sum_th_3_11_8:4;
    };
}atsc_addr_2776_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_muc_group_sum_th_4_11_4:8;
    };
}atsc_addr_2777_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_muc_mu_1_2_0:3;
        RBus_UInt32  fbf_muc_mu_0:5;
    };
}atsc_addr_2778_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_muc_mu_3_0:1;
        RBus_UInt32  fbf_muc_mu_2:5;
        RBus_UInt32  fbf_muc_mu_1_4_3:2;
    };
}atsc_addr_2779_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_muc_mu_4_3_0:4;
        RBus_UInt32  fbf_muc_mu_3_4_1:4;
    };
}atsc_addr_277a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_muc_mu_main_0_1_0:2;
        RBus_UInt32  fbf_muc_mu_5:5;
        RBus_UInt32  fbf_muc_mu_4_4:1;
    };
}atsc_addr_277b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_muc_mu_main_1:5;
        RBus_UInt32  fbf_muc_mu_main_0_4_2:3;
    };
}atsc_addr_277c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_muc_mu_main_3_2_0:3;
        RBus_UInt32  fbf_muc_mu_main_2:5;
    };
}atsc_addr_277d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_muc_mu_main_5_0:1;
        RBus_UInt32  fbf_muc_mu_main_4:5;
        RBus_UInt32  fbf_muc_mu_main_3_4_3:2;
    };
}atsc_addr_277e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_muc_mu_bn_slow_0_3_0:4;
        RBus_UInt32  fbf_muc_mu_main_5_4_1:4;
    };
}atsc_addr_277f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_muc_mu_bn_slow_2_1_0:2;
        RBus_UInt32  fbf_muc_mu_bn_slow_1:5;
        RBus_UInt32  fbf_muc_mu_bn_slow_0_4:1;
    };
}atsc_addr_2780_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_muc_mu_bn_slow_3:5;
        RBus_UInt32  fbf_muc_mu_bn_slow_2_4_2:3;
    };
}atsc_addr_2781_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_muc_mu_bn_slow_5_2_0:3;
        RBus_UInt32  fbf_muc_mu_bn_slow_4:5;
    };
}atsc_addr_2782_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  fbf_muc_mu_bn_slow_5_4_3:2;
    };
}atsc_addr_2783_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  bn_eqpt_er_amp_th_en:1;
        RBus_UInt32  eqpt_dd_xi_abs_q_manu:3;
        RBus_UInt32  eqpt_dd_xi_abs_q_manu_en:1;
        RBus_UInt32  eqpt_in_amp_th_disable:1;
        RBus_UInt32  bn_det_adj_ind_enable:1;
        RBus_UInt32  bn_det_mse_opt:1;
    };
}atsc_addr_2788_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  eqpt_dd_delta_ph_max_bn:4;
        RBus_UInt32  eqpt_dd_er_amp_th_bn:4;
    };
}atsc_addr_2789_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  eqpt_mse_src_sel:1;
        RBus_UInt32  bn_eqpt_u_en:1;
        RBus_UInt32  eqpt_dd_step_size_exp_bn:3;
        RBus_UInt32  bn_eqpt_delta_max_en:1;
    };
}atsc_addr_278a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  eqpt_leak_exp:3;
        RBus_UInt32  eqpt_leak_opt2:1;
        RBus_UInt32  eqpt_leak_opt1:1;
        RBus_UInt32  eqpt_mse_field_th_out_sel:1;
        RBus_UInt32  eqpt_state_ind_clear_opt:1;
        RBus_UInt32  eqpt_mse_field_src_sel:1;
    };
}atsc_addr_278b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  eqpt_mse_field_th2_7_0:8;
    };
}atsc_addr_278c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  eqpt_mse_field_th2_15_8:8;
    };
}atsc_addr_278d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  opt_bn_det_hold_input:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  opt_bn_slow_ind:1;
    };
}atsc_addr_278e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  gamma_sato:7;
    };
}atsc_addr_2790_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  gamma_godard2_7_0:8;
    };
}atsc_addr_2791_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  gamma_godard2_8:1;
    };
}atsc_addr_2792_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_upd_cnt_max:8;
    };
}atsc_addr_2793_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_upd_cnt_max:8;
    };
}atsc_addr_2794_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  mse_exp:2;
    };
}atsc_addr_2795_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  er_bound_6_0:7;
        RBus_UInt32  er_bound_en:1;
    };
}atsc_addr_279e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  er_bound_13_7:7;
    };
}atsc_addr_279f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  mse_bound_en:1;
    };
}atsc_addr_27a0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_bound_7_0:8;
    };
}atsc_addr_27a1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_bound_15_8:8;
    };
}atsc_addr_27a2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  eqer_final_state:6;
        RBus_UInt32  mse_th_eq_en:1;
    };
}atsc_addr_27a3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_th_eq_tr2_7_0:8;
    };
}atsc_addr_27a4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_th_eq_tr2_15_8:8;
    };
}atsc_addr_27a5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_th_eq_tr1_7_0:8;
    };
}atsc_addr_27a6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_th_eq_tr1_15_8:8;
    };
}atsc_addr_27a7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_th_eq_dd2_7_0:8;
    };
}atsc_addr_27a8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_th_eq_dd2_15_8:8;
    };
}atsc_addr_27a9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_th_eq_dd1_7_0:8;
    };
}atsc_addr_27aa_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_th_eq_dd1_15_8:8;
    };
}atsc_addr_27ab_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_exp_tr0_1_0:2;
        RBus_UInt32  ffe_exp_tr1:3;
        RBus_UInt32  ffe_exp_tr2:3;
    };
}atsc_addr_27ac_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_exp_dd0_0:1;
        RBus_UInt32  ffe_exp_dd1:3;
        RBus_UInt32  ffe_exp_dd2:3;
        RBus_UInt32  ffe_exp_tr0_2:1;
    };
}atsc_addr_27ad_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_exp_tr1:3;
        RBus_UInt32  fbf_exp_tr2:3;
        RBus_UInt32  ffe_exp_dd0_2_1:2;
    };
}atsc_addr_27ae_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_exp_dd1_1_0:2;
        RBus_UInt32  fbf_exp_dd2:3;
        RBus_UInt32  fbf_exp_tr0:3;
    };
}atsc_addr_27af_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fbf_exp_dd0:3;
        RBus_UInt32  fbf_exp_dd1_2:1;
    };
}atsc_addr_27b0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_leak_cnt_max:8;
    };
}atsc_addr_27b1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  fbf_leak_en:1;
        RBus_UInt32  ffe_leak_en:1;
    };
}atsc_addr_27b2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_leak_val_7_0:8;
    };
}atsc_addr_27b3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_leak_val_15_8:8;
    };
}atsc_addr_27b4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_leak_cnt_max:8;
    };
}atsc_addr_27b5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_leak_val_7_0:8;
    };
}atsc_addr_27b6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_leak_val_15_8:8;
    };
}atsc_addr_27b7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  eqer_mse_zd_viterbi_sel:2;
        RBus_UInt32  eqer_mse_stepsize_sel:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  eqer_mse_bound_sel:2;
    };
}atsc_addr_27b8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  eqer_blind_type_sel:1;
        RBus_UInt32  eqer_sato_pwr_sel:2;
        RBus_UInt32  eqer_godard_pwr_sel:2;
        RBus_UInt32  eqer_pwr_sel:2;
    };
}atsc_addr_27b9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  eqer_msectrl_mse_sel_0:2;
        RBus_UInt32  eqer_msectrl_mse_sel_1:2;
        RBus_UInt32  eqer_msectrl_mse_sel_2:2;
        RBus_UInt32  eqer_msectrl_en:1;
    };
}atsc_addr_27c0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  eqer_msectrl_er_type_sel_1_1_0:2;
        RBus_UInt32  eqer_msectrl_er_type_sel_2:3;
        RBus_UInt32  eqer_msectrl_er_type_sel_3:3;
    };
}atsc_addr_27c1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  eqer_msectrl_er_type_sel_0:3;
        RBus_UInt32  eqer_msectrl_er_type_sel_1_2:1;
    };
}atsc_addr_27c2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  eqer_msectrl_mse_th_2_7_0:8;
    };
}atsc_addr_27c3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  eqer_msectrl_mse_th_2_15_8:8;
    };
}atsc_addr_27c4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  eqer_msectrl_mse_th_1_7_0:8;
    };
}atsc_addr_27c5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  eqer_msectrl_mse_th_1_15_8:8;
    };
}atsc_addr_27c6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  eqer_msectrl_mse_th_0_7_0:8;
    };
}atsc_addr_27c7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  eqer_msectrl_mse_th_0_15_8:8;
    };
}atsc_addr_27c8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  eq_fifo_discard_ind_clear:1;
        RBus_UInt32  eq_fifo_full_ind_sel:1;
        RBus_UInt32  eq_fifo_full_ind_clear:1;
        RBus_UInt32  eq_fifo_size:3;
        RBus_UInt32  eqer_mse_er_type_sel:1;
        RBus_UInt32  eqer_dd_er_type_sel:1;
    };
}atsc_addr_27c9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_in_scale:8;
    };
}atsc_addr_27ca_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  zd_viterbi_stage_en_4_0:5;
        RBus_UInt32  res2:3;
    };
}atsc_addr_27cb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  zd_viterbi_stage_en_9_5:5;
        RBus_UInt32  zd_viterbi_mse_en:1;
        RBus_UInt32  zd_viterbi_en:1;
        RBus_UInt32  segment_sync_en:1;
    };
}atsc_addr_27cc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  zd_viterbi_mse_th_7_0:8;
    };
}atsc_addr_27cd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  zd_viterbi_mse_th_15_8:8;
    };
}atsc_addr_27ce_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_mu_bn_slow:3;
        RBus_UInt32  fbf_mu_bn_slow_en:1;
        RBus_UInt32  ffe_mu_bn_slow:3;
        RBus_UInt32  ffe_mu_bn_slow_en:1;
    };
}atsc_addr_27da_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_th_eq_tr3_7_0:8;
    };
}atsc_addr_27db_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_th_eq_tr3_15_8:8;
    };
}atsc_addr_27dc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_th_eq_dd3_7_0:8;
    };
}atsc_addr_27dd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_th_eq_dd3_15_8:8;
    };
}atsc_addr_27de_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  ffe_exp_dd3:3;
        RBus_UInt32  ffe_exp_tr3:3;
    };
}atsc_addr_27df_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  fbf_exp_dd3:3;
        RBus_UInt32  fbf_exp_tr3:3;
    };
}atsc_addr_27e0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  fbf_gc_main_protect_en:1;
        RBus_UInt32  fbf_gc_coeff_sum_max_clr:1;
        RBus_UInt32  fbf_gc_en:1;
    };
}atsc_addr_27e1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_gc_start_field_exp:4;
        RBus_UInt32  fbf_gc_on_field_exp:4;
    };
}atsc_addr_27e2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_gc_check_seg_3_0:4;
        RBus_UInt32  fbf_gc_prd_field_exp:4;
    };
}atsc_addr_27e3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_gc_en_sum_th_0_2_0:3;
        RBus_UInt32  fbf_gc_check_seg_8_4:5;
    };
}atsc_addr_27e4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_gc_en_sum_th_0_10_3:8;
    };
}atsc_addr_27e5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_gc_en_sum_th_1_6_0:7;
        RBus_UInt32  fbf_gc_en_sum_th_0_11:1;
    };
}atsc_addr_27e6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_gc_en_sum_th_2_2_0:3;
        RBus_UInt32  fbf_gc_en_sum_th_1_11_7:5;
    };
}atsc_addr_27e7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_gc_en_sum_th_2_10_3:8;
    };
}atsc_addr_27e8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_gc_dis_th_6_0:7;
        RBus_UInt32  fbf_gc_en_sum_th_2_11:1;
    };
}atsc_addr_27e9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_gc_en_cnt_lb_0_2_0:3;
        RBus_UInt32  fbf_gc_dis_th_11_7:5;
    };
}atsc_addr_27ea_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_gc_en_cnt_lb_2_0:1;
        RBus_UInt32  fbf_gc_en_cnt_lb_1:5;
        RBus_UInt32  fbf_gc_en_cnt_lb_0_4_3:2;
    };
}atsc_addr_27eb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_gc_dis2en_cnt_lb_3_0:4;
        RBus_UInt32  fbf_gc_en_cnt_lb_2_4_1:4;
    };
}atsc_addr_27ec_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_gc_range_exp:2;
        RBus_UInt32  fbf_gc_dis_cnt_lb:5;
        RBus_UInt32  fbf_gc_dis2en_cnt_lb_4:1;
    };
}atsc_addr_27ed_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_gc_tr_coeff_th_0:1;
        RBus_UInt32  fbf_gc_dis2en_num_ub:7;
    };
}atsc_addr_27ee_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_gc_dd_coeff_th_0:1;
        RBus_UInt32  fbf_gc_tr_coeff_th_7_1:7;
    };
}atsc_addr_27ef_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_gc_coeff_en_sel_0:1;
        RBus_UInt32  fbf_gc_dd_coeff_th_7_1:7;
    };
}atsc_addr_27f0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  fbf_gc_coeff_en_sel_1:1;
    };
}atsc_addr_27f1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_gc_tr_coeff_en_7:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_6:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_5:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_4:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_3:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_2:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_1:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_0:1;
    };
}atsc_addr_27f2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_gc_tr_coeff_en_15:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_14:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_13:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_12:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_11:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_10:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_9:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_8:1;
    };
}atsc_addr_27f3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_gc_tr_coeff_en_23:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_22:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_21:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_20:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_19:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_18:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_17:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_16:1;
    };
}atsc_addr_27f4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_gc_tr_coeff_en_31:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_30:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_29:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_28:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_27:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_26:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_25:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_24:1;
    };
}atsc_addr_27f5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_gc_tr_coeff_en_39:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_38:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_37:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_36:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_35:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_34:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_33:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_32:1;
    };
}atsc_addr_27f6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  fbf_gc_tr_coeff_en_42:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_41:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_40:1;
    };
}atsc_addr_27f7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_gc_dd_coeff_en_7:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_6:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_5:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_4:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_3:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_2:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_1:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_0:1;
    };
}atsc_addr_27f8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_gc_dd_coeff_en_15:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_14:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_13:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_12:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_11:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_10:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_9:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_8:1;
    };
}atsc_addr_27f9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_gc_dd_coeff_en_23:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_22:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_21:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_20:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_19:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_18:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_17:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_16:1;
    };
}atsc_addr_27fa_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_gc_dd_coeff_en_31:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_30:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_29:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_28:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_27:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_26:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_25:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_24:1;
    };
}atsc_addr_27fb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_gc_dd_coeff_en_39:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_38:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_37:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_36:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_35:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_34:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_33:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_32:1;
    };
}atsc_addr_27fc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  fbf_gc_dd_coeff_en_42:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_41:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_40:1;
    };
}atsc_addr_27fd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  eqpt_in_amp_th:8;
    };
}atsc_addr_2802_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  eqpt_dd_t:8;
    };
}atsc_addr_2803_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  eqpt_dd_delta_ph_max:4;
    };
}atsc_addr_2804_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  eqpt_eq_out_mse_lower_th_7_0:8;
    };
}atsc_addr_2805_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  eqpt_eq_out_mse_lower_th_12_8:5;
    };
}atsc_addr_2806_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  eqpt_eq_out_mse_upper_th_7_0:8;
    };
}atsc_addr_2807_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  eqpt_eq_out_mse_upper_th_12_8:5;
    };
}atsc_addr_2808_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  eqpt_mse_field_th_7_0:8;
    };
}atsc_addr_2809_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  eqpt_mse_field_th_12_8:5;
    };
}atsc_addr_280a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  eqpt_bypass:1;
        RBus_UInt32  eqpt_bn_det_period:3;
        RBus_UInt32  eqpt_mse_est_64:1;
        RBus_UInt32  eqpt_mse_est_late:1;
        RBus_UInt32  eqpt_mse_exp:2;
    };
}atsc_addr_280b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  bn_eq_stop_en:1;
        RBus_UInt32  bn_dagc_stop_en:1;
        RBus_UInt32  bn_aagc_stop_en:1;
        RBus_UInt32  eqpt_dd_er_amp_th:4;
    };
}atsc_addr_280c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  bn_agc_eqpt_mse_th_7_0:8;
    };
}atsc_addr_280d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  bn_agc_eqpt_mse_th_11_8:4;
    };
}atsc_addr_280e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  bn_agc_mse_field_th_7_0:8;
    };
}atsc_addr_280f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  eqpt_ind_cnt1_prd:4;
        RBus_UInt32  bn_agc_mse_field_th_11_8:4;
    };
}atsc_addr_2810_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  eqpt_ind_cnt2_prd:4;
        RBus_UInt32  eqpt_ind_cnt1_th:4;
    };
}atsc_addr_2811_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  eqpt_ind_cnt2_th:8;
    };
}atsc_addr_2812_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  bn_pred_wait_th:8;
    };
}atsc_addr_2813_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  bn_pred_period_7_0:8;
    };
}atsc_addr_2814_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  bn_pred_period_15_8:8;
    };
}atsc_addr_2815_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  bn_pred_regular:1;
        RBus_UInt32  bn_pred_period_20_16:5;
    };
}atsc_addr_2816_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  bn_pred_cnt_th1_7_0:8;
    };
}atsc_addr_2817_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  bn_pred_cnt_th1_13_8:6;
    };
}atsc_addr_2818_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  bn_pred_cnt_th2_7_0:8;
    };
}atsc_addr_2819_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  bn_pred_cnt_th2_13_8:6;
    };
}atsc_addr_281a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  bn_pred_cnt_th3_7_0:8;
    };
}atsc_addr_281b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  bn_pred_cnt_th3_13_8:6;
    };
}atsc_addr_281c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  eqpt_dd_step_size_exp_1:3;
        RBus_UInt32  eqpt_dd_step_size_exp_0:3;
        RBus_UInt32  pn_det_acc_exp:2;
    };
}atsc_addr_281d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  pn_det_mse_field_th_7_0:8;
    };
}atsc_addr_281e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  pn_det_mse_field_th_9_8:2;
    };
}atsc_addr_281f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  pn_det_mse_th_7_0:8;
    };
}atsc_addr_2820_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  pn_det_mse_th_9_8:2;
    };
}atsc_addr_2821_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  pn_det_acc_th_7_0:8;
    };
}atsc_addr_2822_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  pn_det_acc_th_9_8:2;
    };
}atsc_addr_2823_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  bn_pt_stop_en:1;
        RBus_UInt32  eqpt_dd_ph_max:6;
    };
}atsc_addr_2824_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  pn_det_mse_field_th_cr_7_0:8;
    };
}atsc_addr_2825_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  pn_det_mse_th_cr_5_0:6;
        RBus_UInt32  pn_det_mse_field_th_cr_9_8:2;
    };
}atsc_addr_2826_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  pn_det_mse_th_cr_9_6:4;
    };
}atsc_addr_2827_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  pn_det_acc_th_cr_7_0:8;
    };
}atsc_addr_2828_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  pn_det_acc_th_cr_9_8:2;
    };
}atsc_addr_2829_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  pn_det_mse_field_th_pt_7_0:8;
    };
}atsc_addr_282a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  pn_det_mse_field_th_pt_9_8:2;
    };
}atsc_addr_282b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  pn_det_mse_th_pt_7_0:8;
    };
}atsc_addr_282c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  pn_det_mse_th_pt_9_8:2;
    };
}atsc_addr_282d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  pn_det_acc_th_pt_7_0:8;
    };
}atsc_addr_282e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  pn_det_acc_th_pt_9_8:2;
    };
}atsc_addr_282f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  ld_rst_n:1;
    };
}atsc_addr_2830_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ld_ai_start_cnt_7_0:8;
    };
}atsc_addr_2831_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ld_ai_start_cnt_15_8:8;
    };
}atsc_addr_2832_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ld_ai_en_7_0:8;
    };
}atsc_addr_2833_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  ld_ai_ck_cnt:4;
        RBus_UInt32  ld_ai_and_or:1;
    };
}atsc_addr_2834_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ld_mse_th_7_0:8;
    };
}atsc_addr_2835_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ld_mse_th_15_8:8;
    };
}atsc_addr_2836_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ld_mse_th_23_16:8;
    };
}atsc_addr_2837_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ld_mse_th_31_24:8;
    };
}atsc_addr_2838_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ld_mse_field_th_0_5_0:6;
        RBus_UInt32  ld_mse_th_33_32:2;
    };
}atsc_addr_2839_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ld_mse_field_th_0_13_6:8;
    };
}atsc_addr_283a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ld_mse_field_th_0_21_14:8;
    };
}atsc_addr_283b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ld_mse_field_th_0_29_22:8;
    };
}atsc_addr_283c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ld_mse_viterbi_th_3_0:4;
        RBus_UInt32  ld_mse_field_th_0_33_30:4;
    };
}atsc_addr_283d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ld_mse_viterbi_th_11_4:8;
    };
}atsc_addr_283e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ld_mse_viterbi_th_19_12:8;
    };
}atsc_addr_283f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ld_mse_viterbi_th_27_20:8;
    };
}atsc_addr_2840_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  ld_mse_viterbi_th_33_28:6;
    };
}atsc_addr_2841_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ld_max_correlation_th:8;
    };
}atsc_addr_2842_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ld_and_or:1;
        RBus_UInt32  ld_en0:1;
        RBus_UInt32  ld_en1:1;
        RBus_UInt32  res2:5;
    };
}atsc_addr_2846_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ld_mse_field_th_1_7_0:8;
    };
}atsc_addr_2847_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ld_mse_field_th_1_15_8:8;
    };
}atsc_addr_2848_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ld_mse_field_th_1_23_16:8;
    };
}atsc_addr_2849_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ld_mse_field_th_1_31_24:8;
    };
}atsc_addr_284a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  ld_ai_en_8:1;
        RBus_UInt32  ld_mse_field_th_1_33_32:2;
    };
}atsc_addr_284b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ld_mse_field_sel_cnt_7_0:8;
    };
}atsc_addr_284c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ld_mse_field_sel_cnt_15_8:8;
    };
}atsc_addr_284d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  tre_ber_rst:1;
        RBus_UInt32  tre_ber_hold:1;
        RBus_UInt32  dis_tre_auto_mode:1;
        RBus_UInt32  tre_test_volume:3;
    };
}atsc_addr_2851_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  val_lvl:1;
        RBus_UInt32  err_lvl:1;
        RBus_UInt32  err_dur:1;
        RBus_UInt32  sync_dur:1;
        RBus_UInt32  ckout_pwr:1;
        RBus_UInt32  ckoutpar:1;
        RBus_UInt32  fix_tei:1;
    };
}atsc_addr_2852_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  ser_lsb:1;
        RBus_UInt32  serial:1;
    };
}atsc_addr_2853_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cdiv_ph1:4;
        RBus_UInt32  cdiv_ph0:4;
    };
}atsc_addr_2854_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  rsd_disable:1;
        RBus_UInt32  no_corr:1;
    };
}atsc_addr_2855_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ber_rst:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  ber_sel:1;
        RBus_UInt32  ber_once:1;
        RBus_UInt32  test_volume:4;
    };
}atsc_addr_2856_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  dera_disable:1;
    };
}atsc_addr_2857_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ao_ld_ser_thr_7_0:8;
    };
}atsc_addr_2858_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ao_ld_ser_thr_15_8:8;
    };
}atsc_addr_2859_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ao_ld_ser_thr_23_16:8;
    };
}atsc_addr_285a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  ao_ld_rstn:1;
        RBus_UInt32  ao_ld_volume:3;
        RBus_UInt32  ao_ld_ck_cnt:3;
    };
}atsc_addr_285b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ld_ao_start_cnt_7_0:8;
    };
}atsc_addr_285c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ld_ao_start_cnt_15_8:8;
    };
}atsc_addr_285d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  data_lost_flag_clr:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  reg_outer_null_in_clear:1;
        RBus_UInt32  res3:1;
    };
}atsc_addr_285e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  ro_data_lost_flag:1;
        RBus_UInt32  reg_outer_null_in:1;
        RBus_UInt32  deint_sf_err_cnt:4;
    };
}atsc_addr_285f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  ft_rst_n:1;
    };
}atsc_addr_2860_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ft_valid_th_7_0:8;
    };
}atsc_addr_2861_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ft_valid_th_15_8:8;
    };
}atsc_addr_2862_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ft_caagc_target_th_7_0:8;
    };
}atsc_addr_2863_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ft_caagc_target_th_15_8:8;
    };
}atsc_addr_2864_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  ft_final_state_flag_en:1;
    };
}atsc_addr_2865_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ft_mse_th_7_0:8;
    };
}atsc_addr_2866_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  ft_mse_en:1;
        RBus_UInt32  ft_mse_th_9_8:2;
    };
}atsc_addr_2867_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ft_mse_field_th_7_0:8;
    };
}atsc_addr_2868_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  ft_mse_field_en:1;
        RBus_UInt32  ft_mse_field_th_9_8:2;
    };
}atsc_addr_2869_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  ft_ser_en:1;
    };
}atsc_addr_286a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ft_rs_corr_cnt_th_7_0:8;
    };
}atsc_addr_286b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ft_rs_corr_cnt_th_15_8:8;
    };
}atsc_addr_286c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ft_rs_corr_cnt_th_23_16:8;
    };
}atsc_addr_286d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ft_rs_un_corr_cnt_th_7_0:8;
    };
}atsc_addr_286e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ft_rs_un_corr_cnt_th_15_8:8;
    };
}atsc_addr_286f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ft_rs_un_corr_cnt_th_23_16:8;
    };
}atsc_addr_2870_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ft_if_agc_u_th_5_0:6;
        RBus_UInt32  ft_rf_agc_en:1;
        RBus_UInt32  ft_if_agc_en:1;
    };
}atsc_addr_2871_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ft_if_agc_u_th_13_6:8;
    };
}atsc_addr_2872_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ft_rf_agc_u_th_7_0:8;
    };
}atsc_addr_2873_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ft_if_agc_l_th_1_0:2;
        RBus_UInt32  ft_rf_agc_u_th_13_8:6;
    };
}atsc_addr_2874_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ft_if_agc_l_th_9_2:8;
    };
}atsc_addr_2875_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ft_rf_agc_l_th_3_0:4;
        RBus_UInt32  ft_if_agc_l_th_13_10:4;
    };
}atsc_addr_2876_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ft_rf_agc_l_th_11_4:8;
    };
}atsc_addr_2877_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  ft_rf_agc_polar:1;
        RBus_UInt32  ft_if_agc_polar:1;
        RBus_UInt32  ft_rf_agc_l_th_13_12:2;
    };
}atsc_addr_2878_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ft_aagc_target_value1:8;
    };
}atsc_addr_2879_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ft_aagc_target_value2:8;
    };
}atsc_addr_287a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ft_dagc_lvl_th_6_0:7;
        RBus_UInt32  ft_dagc_en:1;
    };
}atsc_addr_287b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ft_dagc_diff_th_1_0:2;
        RBus_UInt32  ft_dagc_lvl_th_12_7:6;
    };
}atsc_addr_287c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ft_dagc_diff_th_9_2:8;
    };
}atsc_addr_287d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  ft_dagc_diff_th_12_10:3;
    };
}atsc_addr_287e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  clip_mo_period:8;
    };
}atsc_addr_2890_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tst_dat_1_sel:8;
    };
}atsc_addr_28a0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tst_dat_2_sel:8;
    };
}atsc_addr_28a1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tst_ena_sel:8;
    };
}atsc_addr_28a2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tst_irq1_sel:8;
    };
}atsc_addr_28a3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tst_irq2_sel:8;
    };
}atsc_addr_28a4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_th_irq1_7_0:8;
    };
}atsc_addr_28a5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_th_irq1_15_8:8;
    };
}atsc_addr_28a6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_th_irq1_23_16:8;
    };
}atsc_addr_28a7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_th_irq1_31_24:8;
    };
}atsc_addr_28a8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_th_irq2_7_0:8;
    };
}atsc_addr_28a9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_th_irq2_15_8:8;
    };
}atsc_addr_28aa_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_th_irq2_23_16:8;
    };
}atsc_addr_28ab_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_th_irq2_31_24:8;
    };
}atsc_addr_28ac_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  tst_irq1_reg:1;
        RBus_UInt32  tst_state_irq1:6;
    };
}atsc_addr_28ad_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  tst_irq2_reg:1;
        RBus_UInt32  tst_state_irq2:6;
    };
}atsc_addr_28ae_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tst_norm_sel:8;
    };
}atsc_addr_28af_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_th_norm_7_0:8;
    };
}atsc_addr_28b0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_th_norm_15_8:8;
    };
}atsc_addr_28b1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_th_norm_23_16:8;
    };
}atsc_addr_28b2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_th_norm_31_24:8;
    };
}atsc_addr_28b3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  tst_norm_reg:1;
        RBus_UInt32  tst_state_norm:6;
    };
}atsc_addr_28b4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  bist_reset_n:1;
        RBus_UInt32  bist_mode:1;
    };
}atsc_addr_28c0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  drf_menu_resume:1;
        RBus_UInt32  opt_drf_resume:1;
        RBus_UInt32  dvse_0:1;
        RBus_UInt32  drf_bist_mode:1;
        RBus_UInt32  res2:1;
    };
}atsc_addr_28cb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  drf_dvs:4;
    };
}atsc_addr_28cc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  reg_drf_time_cnt_th_7_0:8;
    };
}atsc_addr_28cd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  reg_drf_time_cnt_th_12_8:5;
    };
}atsc_addr_28ce_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_dr1_mean_pwr_7_0:8;
    };
}atsc_addr_2e01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_dr1_mean_pwr_15_8:8;
    };
}atsc_addr_2e02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  cr_dr1_mean_pwr_22_16:7;
    };
}atsc_addr_2e03_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_dr1_im_hpf_pwr_qtz_7_0:8;
    };
}atsc_addr_2e04_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_dr1_im_hpf_pwr_qtz_15_8:8;
    };
}atsc_addr_2e05_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_comp_scale_exp:4;
        RBus_UInt32  cr_dr1_im_hpf_pwr_qtz_19_16:4;
    };
}atsc_addr_2e06_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ro_fsm_addr_col_cnt_7_0:8;
    };
}atsc_addr_2e2e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  ro_fsm_addr_row_cnt:6;
        RBus_UInt32  ro_fsm_addr_col_cnt_8:1;
    };
}atsc_addr_2e2f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ado_dc_1_q_7_0:8;
    };
}atsc_addr_2e30_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ado_dc_1_q_im_3_0:4;
        RBus_UInt32  ado_dc_1_q_11_8:4;
    };
}atsc_addr_2e31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ado_dc_1_q_im_11_4:8;
    };
}atsc_addr_2e32_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ado_dc_2_q_7_0:8;
    };
}atsc_addr_2e33_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ado_dc_2_q_im_3_0:4;
        RBus_UInt32  ado_dc_2_q_11_8:4;
    };
}atsc_addr_2e34_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ado_dc_2_q_im_11_4:8;
    };
}atsc_addr_2e35_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ado_dc_3_q_7_0:8;
    };
}atsc_addr_2e36_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ado_dc_3_q_im_3_0:4;
        RBus_UInt32  ado_dc_3_q_11_8:4;
    };
}atsc_addr_2e37_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ado_dc_3_q_im_11_4:8;
    };
}atsc_addr_2e38_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fe_iqamp_q_7_0:8;
    };
}atsc_addr_2e39_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fe_iqph_q_5_0:6;
        RBus_UInt32  fe_iqamp_q_9_8:2;
    };
}atsc_addr_2e3a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fe_iqph_q_9_6:4;
    };
}atsc_addr_2e3b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  strobe:1;
    };
}atsc_addr_2f01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  acc_rf3_7_0:8;
    };
}atsc_addr_2f02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  acc_rf3_13_8:6;
    };
}atsc_addr_2f03_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  acc_if3_7_0:8;
    };
}atsc_addr_2f04_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  acc_if3_13_8:6;
    };
}atsc_addr_2f05_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  fsm_scan_unlock_ind:1;
        RBus_UInt32  fsm_scan_lock_ind:1;
    };
}atsc_addr_2f06_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  converge_cnt_7_0:8;
    };
}atsc_addr_2f07_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  converge_cnt_15_8:8;
    };
}atsc_addr_2f08_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  current_state:6;
        RBus_UInt32  fsm_final_flag:1;
        RBus_UInt32  fsm_final_flag_hold:1;
    };
}atsc_addr_2f09_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  aagc_lock:1;
        RBus_UInt32  adj_ind:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  tr_lock_ind:1;
        RBus_UInt32  res3:2;
    };
}atsc_addr_2f0a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tr_fs_lock_ind:1;
        RBus_UInt32  tr_fs_lost_d:1;
        RBus_UInt32  tr_fs_trk_ind_d:1;
        RBus_UInt32  tr_fs_loc2_eq_loc3:1;
        RBus_UInt32  tr_fs_loc2_lead_loc3_1:1;
        RBus_UInt32  tr_fs_loc2_lag_loc3_1:1;
        RBus_UInt32  tr_fs_loc2_lead_loc3_n:1;
        RBus_UInt32  tr_fs_loc2_lag_loc3_n:1;
    };
}atsc_addr_2f0b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  acc3_7_0:8;
    };
}atsc_addr_2f0c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  agc_max_sat_flag:1;
        RBus_UInt32  acc3_13_8:6;
    };
}atsc_addr_2f0d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  dagc_level_q_7_0:8;
    };
}atsc_addr_2f0e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  dagc_level_q_12_8:5;
    };
}atsc_addr_2f0f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  adc_out_7_0:8;
    };
}atsc_addr_2f10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  adc_out_11_8:4;
    };
}atsc_addr_2f11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  timing_offset_d_q_7_0:8;
    };
}atsc_addr_2f12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  timing_offset_d_q_15_8:8;
    };
}atsc_addr_2f13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tr_fs_acc_cnt_7_0:8;
    };
}atsc_addr_2f14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  tr_fs_acc_cnt_14_8:7;
    };
}atsc_addr_2f15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tr_fs_lock_diff_acc_7_0:8;
    };
}atsc_addr_2f16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tr_fs_lock_diff_acc_15_8:8;
    };
}atsc_addr_2f17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tr_fs_lock_diff_acc_23_16:8;
    };
}atsc_addr_2f18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  tr_fs_lock_diff_acc_24:1;
    };
}atsc_addr_2f19_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cond_7_0:8;
    };
}atsc_addr_2f1a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cond_15_8:8;
    };
}atsc_addr_2f1b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cond_23_16:8;
    };
}atsc_addr_2f1c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cond_31_24:8;
    };
}atsc_addr_2f1d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  adc_clip_cnt:8;
    };
}atsc_addr_2f1e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  agc_targ_val_tune:8;
    };
}atsc_addr_2f1f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  agc_tune_wait_cnt:8;
    };
}atsc_addr_2f20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  eqpt_eq_out_mse_est_7_0:8;
    };
}atsc_addr_2f21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  eqpt_eq_out_mse_est_15_8:8;
    };
}atsc_addr_2f22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  eqpt_eq_out_mse_est_21_16:6;
    };
}atsc_addr_2f23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_viterbi_7_0:8;
    };
}atsc_addr_2f24_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_viterbi_15_8:8;
    };
}atsc_addr_2f25_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_viterbi_23_16:8;
    };
}atsc_addr_2f26_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_viterbi_31_24:8;
    };
}atsc_addr_2f27_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:30;
        RBus_UInt32  mse_viterbi_33_32:2;
    };
}atsc_addr_2f28_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  bn_pred_wait_cnt_ovf:1;
        RBus_UInt32  bn_pred_cnt_ovf:1;
        RBus_UInt32  bn_pred_flag:1;
        RBus_UInt32  bn_aagc_stop:1;
        RBus_UInt32  bn_dagc_stop:1;
        RBus_UInt32  bn_eq_stop:1;
        RBus_UInt32  eqpt_bn_det_flag_hold:1;
        RBus_UInt32  eqpt_bn_det_flag:1;
    };
}atsc_addr_2f29_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  adj_ind_bn:1;
        RBus_UInt32  eqpt_state_ind:1;
        RBus_UInt32  pn_det_flag_pt:1;
        RBus_UInt32  pn_det_flag_cr:1;
        RBus_UInt32  pn_det_flag:1;
        RBus_UInt32  eqpt_dd_step_size_exp_ro:3;
    };
}atsc_addr_2f2a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  pn_det_acc_q_7_0:8;
    };
}atsc_addr_2f2b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  pn_det_acc_q_15_8:8;
    };
}atsc_addr_2f2c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  eqpt_dd_ph_q_7_0:8;
    };
}atsc_addr_2f2d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  adj_ind_srrc:1;
        RBus_UInt32  srrc_coeff_sel_mux_out:2;
        RBus_UInt32  res2:3;
        RBus_UInt32  eqpt_dd_ph_q_9_8:2;
    };
}atsc_addr_2f2e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  pre_srrc_q_d_7_0:8;
    };
}atsc_addr_2f32_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  pre_srrc_q_d_15_8:8;
    };
}atsc_addr_2f33_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  post_srrc_q_d_7_0:8;
    };
}atsc_addr_2f34_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  post_srrc_q_d_15_8:8;
    };
}atsc_addr_2f35_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tr_fs_el_weak_ind:1;
        RBus_UInt32  tr_fs_el_lock_ind:1;
        RBus_UInt32  tr_fs_fsm_lock:1;
        RBus_UInt32  tr_fs_fsm_run:1;
        RBus_UInt32  tr_fs_fsm_state:4;
    };
}atsc_addr_2f36_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tr_fs_el_kf_out_q16_7_0:8;
    };
}atsc_addr_2f37_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tr_fs_el_kf_out_q16_15_8:8;
    };
}atsc_addr_2f38_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tr_fs_el_trk_corr_7_0:8;
    };
}atsc_addr_2f39_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  tr_fs_el_trk_corr_12_8:5;
    };
}atsc_addr_2f3a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  dc_mean_d_q_re_7_0:8;
    };
}atsc_addr_2f3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  dc_mean_d_q_re_15_8:8;
    };
}atsc_addr_2f3e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  dc_mean_d_q_im_7_0:8;
    };
}atsc_addr_2f40_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  dc_mean_d_q_im_15_8:8;
    };
}atsc_addr_2f41_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tr_lock_ind_reg:8;
    };
}atsc_addr_2f45_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tr_lock_ted_reg:8;
    };
}atsc_addr_2f46_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tr_fs_tr_freq_7_0:8;
    };
}atsc_addr_2f47_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tr_fs_tr_freq_15_8:8;
    };
}atsc_addr_2f48_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tr_fs_tr_freq_23_16:8;
    };
}atsc_addr_2f49_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  pt_phase_q_7_0:8;
    };
}atsc_addr_2f4a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  pt_phase_q_8:1;
    };
}atsc_addr_2f4b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cm_7_0:8;
    };
}atsc_addr_2f4f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cm_15_8:8;
    };
}atsc_addr_2f50_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cm_23_16:8;
    };
}atsc_addr_2f51_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  cm_26_24:3;
    };
}atsc_addr_2f52_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  pt_out_7_0:8;
    };
}atsc_addr_2f53_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  pt_out_11_8:4;
    };
}atsc_addr_2f54_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_main_is_max:1;
        RBus_UInt32  fs2_precursor_exist:1;
        RBus_UInt32  fs2_run:1;
        RBus_UInt32  fs2_lock:1;
    };
}atsc_addr_2f5c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_state_one_hot_7_0:8;
    };
}atsc_addr_2f5d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_state_one_hot_11_8:4;
    };
}atsc_addr_2f5e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_corr_amp_7_0:8;
    };
}atsc_addr_2f5f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  fs2_corr_amp_12_8:5;
    };
}atsc_addr_2f60_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  fs2_force_num_decode:7;
    };
}atsc_addr_2f61_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  force_space_7_0:8;
    };
}atsc_addr_2f62_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  force_space_11_8:4;
    };
}atsc_addr_2f63_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_main_amp_7_0:8;
    };
}atsc_addr_2f64_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  fs2_main_amp_12_8:5;
    };
}atsc_addr_2f65_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_max_amp_7_0:8;
    };
}atsc_addr_2f66_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  fs2_max_amp_12_8:5;
    };
}atsc_addr_2f67_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_pre_amp_7_0:8;
    };
}atsc_addr_2f68_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  fs2_pre_amp_12_8:5;
    };
}atsc_addr_2f69_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_max_re_7_0:8;
    };
}atsc_addr_2f6a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  fs2_max_re_12_8:5;
    };
}atsc_addr_2f6b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_max_amp_sam_7_0:8;
    };
}atsc_addr_2f6c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_max_amp_sam_15_8:8;
    };
}atsc_addr_2f6d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  fs2_max_amp_sam_18_16:3;
    };
}atsc_addr_2f6e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_main_sam_7_0:8;
    };
}atsc_addr_2f6f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_main_sam_15_8:8;
    };
}atsc_addr_2f70_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  fs2_main_sam_20_16:5;
    };
}atsc_addr_2f71_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_pre_sam_7_0:8;
    };
}atsc_addr_2f72_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_pre_sam_15_8:8;
    };
}atsc_addr_2f73_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  fs2_pre_sam_20_16:5;
    };
}atsc_addr_2f74_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_max_re_sam_7_0:8;
    };
}atsc_addr_2f75_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_max_re_sam_15_8:8;
    };
}atsc_addr_2f76_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:29;
        RBus_UInt32  fs2_max_re_sam_18_16:3;
    };
}atsc_addr_2f77_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_main_addr_7_0:8;
    };
}atsc_addr_2f78_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_main_addr_11_8:4;
    };
}atsc_addr_2f79_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_pre_addr_7_0:8;
    };
}atsc_addr_2f7a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_pre_addr_11_8:4;
    };
}atsc_addr_2f7b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_post_amp_7_0:8;
    };
}atsc_addr_2f55_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  fs2_post_amp_12_8:5;
    };
}atsc_addr_2f56_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_post_sam_7_0:8;
    };
}atsc_addr_2f57_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_post_sam_15_8:8;
    };
}atsc_addr_2f58_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  fs2_post_sam_20_16:5;
    };
}atsc_addr_2f59_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_post_addr_7_0:8;
    };
}atsc_addr_2f5a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_post_addr_11_8:4;
    };
}atsc_addr_2f5b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_parallel_amp_0_7_0:8;
    };
}atsc_addr_2f4c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_parallel_amp_1_2_0:3;
        RBus_UInt32  fs2_parallel_amp_0_12_8:5;
    };
}atsc_addr_2f4d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_parallel_amp_1_10_3:8;
    };
}atsc_addr_2f4e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_parallel_amp_2_5_0:6;
        RBus_UInt32  fs2_parallel_amp_1_12_11:2;
    };
}atsc_addr_2f42_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_parallel_amp_3_0:1;
        RBus_UInt32  fs2_parallel_amp_2_12_6:7;
    };
}atsc_addr_2f43_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_parallel_amp_3_8_1:8;
    };
}atsc_addr_2f44_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_parallel_addr_0_3_0:4;
        RBus_UInt32  fs2_parallel_amp_3_12_9:4;
    };
}atsc_addr_2fbd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_parallel_addr_1_0:1;
        RBus_UInt32  fs2_parallel_addr_0_10_4:7;
    };
}atsc_addr_2fbe_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  fs2_parallel_addr_3_11:1;
        RBus_UInt32  fs2_parallel_addr_2_11:1;
        RBus_UInt32  fs2_parallel_addr_1_11:1;
        RBus_UInt32  fs2_parallel_addr_0_11:1;
    };
}atsc_addr_2fd5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_parallel_addr_1_8_1:8;
    };
}atsc_addr_2fbf_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_parallel_addr_2_5_0:6;
        RBus_UInt32  fs2_parallel_addr_1_10_9:2;
    };
}atsc_addr_2fc0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_parallel_addr_3_2_0:3;
        RBus_UInt32  fs2_parallel_addr_2_10_6:5;
    };
}atsc_addr_2fd0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fs2_parallel_addr_3_10_3:8;
    };
}atsc_addr_2fd4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  state_cnt1:8;
    };
}atsc_addr_2f7c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  state_cnt2:8;
    };
}atsc_addr_2f7d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_offset_leak_acc_7_0:8;
    };
}atsc_addr_2f7e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  cr_offset_leak_acc_12_8:5;
    };
}atsc_addr_2f7f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  if_offset_7_0:8;
    };
}atsc_addr_2f80_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  if_offset_15_8:8;
    };
}atsc_addr_2f81_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_offset_1_0:2;
        RBus_UInt32  cr_in_lock_ind:1;
        RBus_UInt32  cr_large_freq_ind:1;
        RBus_UInt32  cr_unlock_ind:1;
        RBus_UInt32  cr_lock_ind:1;
        RBus_UInt32  if_offset_17_16:2;
    };
}atsc_addr_2f82_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_offset_9_2:8;
    };
}atsc_addr_2f83_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_offset_17_10:8;
    };
}atsc_addr_2f84_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_offset_25_18:8;
    };
}atsc_addr_2f85_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  cr_offset_32_26:7;
    };
}atsc_addr_2f86_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_lock_det_out_qtz_re_7_0:8;
    };
}atsc_addr_2f87_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_lock_det_out_qtz_im_1_0:2;
        RBus_UInt32  cr_lock_det_out_qtz_re_13_8:6;
    };
}atsc_addr_2f88_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_lock_det_out_qtz_im_9_2:8;
    };
}atsc_addr_2f89_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_pwr_est_3_0:4;
        RBus_UInt32  cr_lock_det_out_qtz_im_13_10:4;
    };
}atsc_addr_2f8a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_pwr_est_11_4:8;
    };
}atsc_addr_2f8b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_pwr_est_19_12:8;
    };
}atsc_addr_2f8c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:25;
        RBus_UInt32  cr_pwr_est_26_20:7;
    };
}atsc_addr_2f8d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_out_re_7_0:8;
    };
}atsc_addr_2f8e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_out_im_3_0:4;
        RBus_UInt32  cr_out_re_11_8:4;
    };
}atsc_addr_2f8f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_out_im_11_4:8;
    };
}atsc_addr_2f90_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_dr1_re_7_0:8;
    };
}atsc_addr_2f91_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_dr1_im_3_0:4;
        RBus_UInt32  cr_dr1_re_11_8:4;
    };
}atsc_addr_2f92_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_dr1_im_11_4:8;
    };
}atsc_addr_2f93_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  cr_phase_comp_7_0:8;
    };
}atsc_addr_2f94_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  cr_comp_exp:3;
        RBus_UInt32  cr_comp_man:1;
        RBus_UInt32  cr_phase_comp_9_8:2;
    };
}atsc_addr_2f95_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  dagc_out_d_re_7_0:8;
    };
}atsc_addr_2f96_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  dagc_out_d_im_3_0:4;
        RBus_UInt32  dagc_out_d_re_11_8:4;
    };
}atsc_addr_2f97_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  dagc_out_d_im_11_4:8;
    };
}atsc_addr_2f98_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  deltaf_7_0:8;
    };
}atsc_addr_2f99_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  pn63_flag:1;
        RBus_UInt32  training_length_ind:1;
        RBus_UInt32  tr_esti_lock_ind:1;
        RBus_UInt32  field_sync2_lock:1;
        RBus_UInt32  field_sync_lock_ind:1;
        RBus_UInt32  deltaf_10_8:3;
    };
}atsc_addr_2f9a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  max_correlation_7_0:8;
    };
}atsc_addr_2f9b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  field_sync_lock:2;
        RBus_UInt32  max_correlation_13_8:6;
    };
}atsc_addr_2f9c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ch_esti_val_7_0:8;
    };
}atsc_addr_2f9d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ch_esti_val_15_8:8;
    };
}atsc_addr_2f9e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  pn63_flag_error_ind:1;
        RBus_UInt32  pn63_corr_flag_2:1;
        RBus_UInt32  pn63_corr_flag_1:1;
        RBus_UInt32  pn63_corr_flag_0:1;
        RBus_UInt32  ch_esti_val_19_16:4;
    };
}atsc_addr_2f9f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_coeff_15_8:8;
    };
}atsc_addr_2fa0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_coeff_7_0:8;
    };
}atsc_addr_2fa1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ffe_sat_d:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  cr_corr_lock_ind:1;
        RBus_UInt32  cr_ld_re_diff_flag:1;
        RBus_UInt32  cr_ld_freq_max_flag:1;
        RBus_UInt32  cr_ld_freq_diff_flag:1;
        RBus_UInt32  cr_ld_im_flag:1;
        RBus_UInt32  cr_ld_re_lb_flag:1;
    };
}atsc_addr_2fa2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ro_ffe_coeff_sum_13_6:8;
    };
}atsc_addr_2fa3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  ro_ffe_coeff_sum_5_0:6;
    };
}atsc_addr_2fa4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ro_ffe_sp_coeff_max_11_4:8;
    };
}atsc_addr_2fa5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  ro_ffe_sp_coeff_max_3_0:4;
    };
}atsc_addr_2fa6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ro_ffe_gc_odd_coeff_en:4;
        RBus_UInt32  ro_ffe_gc_even_coeff_en:4;
    };
}atsc_addr_2fa7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ro_ffe_muc_coeff_mu_0_1:8;
    };
}atsc_addr_2fa8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ro_ffe_gc_en_coeff_sum_ind_max:8;
    };
}atsc_addr_2fa9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ro_ffe_gc_dis_coeff_sum_ind_max:8;
    };
}atsc_addr_2faa_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ro_ffe_cluster_addr_0_7_0:8;
    };
}atsc_addr_2fab_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ro_ffe_cluster_addr_1_7_0:8;
    };
}atsc_addr_2fac_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ro_ffe_cluster_addr_2_7_0:8;
    };
}atsc_addr_2fad_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ro_ffe_cluster_addr_3_7_0:8;
    };
}atsc_addr_2fae_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ro_fbf_coeff_sum_13_6:8;
    };
}atsc_addr_2faf_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  ro_fbf_coeff_sum_5_0:6;
    };
}atsc_addr_2fb0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ro_fbf_const_coeff_sum_7_0:8;
    };
}atsc_addr_2fb1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ro_fbf_const_coeff_sum_cnt_5_0:6;
        RBus_UInt32  ro_fbf_const_coeff_sum_9_8:2;
    };
}atsc_addr_2fb2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  ro_fbf_const_coeff_sum_cnt_9_6:4;
    };
}atsc_addr_2fb3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ro_fbf_gc_coeff_en:8;
    };
}atsc_addr_2fb4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ro_fbf_muc_coeff_mu_0_1:8;
    };
}atsc_addr_2fb5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ro_fbf_gc_en_coeff_sum_ind_max:8;
    };
}atsc_addr_2fb6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ro_fbf_gc_dis_coeff_sum_ind_max:8;
    };
}atsc_addr_2fb7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  ffe_out_clip_ind_3:1;
        RBus_UInt32  ffe_out_clip_ind_2:1;
        RBus_UInt32  ffe_out_clip_ind_1:1;
        RBus_UInt32  ffe_out_clip_ind_0:1;
    };
}atsc_addr_2fb8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_coeff_15_8:8;
    };
}atsc_addr_2fba_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  fbf_coeff_7_0:8;
    };
}atsc_addr_2fbb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  ro_ffe_cluster_addr_3_8:1;
        RBus_UInt32  ro_ffe_cluster_addr_2_8:1;
        RBus_UInt32  ro_ffe_cluster_addr_1_8:1;
        RBus_UInt32  ro_ffe_cluster_addr_0_8:1;
    };
}atsc_addr_2fbc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  eq_out_er_7_0:8;
    };
}atsc_addr_2fd6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  eq_out_er_15_8:8;
    };
}atsc_addr_2fd7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  eq_out_pt_7_0:8;
    };
}atsc_addr_2fd8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  eq_out_pt_15_8:8;
    };
}atsc_addr_2fd9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_7_0:8;
    };
}atsc_addr_2fda_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_15_8:8;
    };
}atsc_addr_2fdb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_23_16:8;
    };
}atsc_addr_2fdc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_31_24:8;
    };
}atsc_addr_2fdd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_field_5_0:6;
        RBus_UInt32  mse_33_32:2;
    };
}atsc_addr_2fde_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_field_13_6:8;
    };
}atsc_addr_2fdf_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_field_21_14:8;
    };
}atsc_addr_2fe0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  mse_field_29_22:8;
    };
}atsc_addr_2fe1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  mse_field_33_30:4;
    };
}atsc_addr_2fe2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ld_mse_field_sel:1;
        RBus_UInt32  out_unlock_valid:1;
        RBus_UInt32  unlock_ind:1;
        RBus_UInt32  ld_start:1;
        RBus_UInt32  outer_unlock_ind:1;
        RBus_UInt32  ld_ao_start:1;
        RBus_UInt32  inner_unlock_ind:1;
        RBus_UInt32  ld_ai_start:1;
    };
}atsc_addr_2fe3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ft_if_agc_ind:1;
        RBus_UInt32  ft_rs_un_corr_ind:1;
        RBus_UInt32  ft_rs_corr_ind:1;
        RBus_UInt32  ft_rs_ser_trig_ind:1;
        RBus_UInt32  ft_mse_field_ind:1;
        RBus_UInt32  ft_mse_ind:1;
        RBus_UInt32  ft_final_state_ind:1;
        RBus_UInt32  ft_valid_flag:1;
    };
}atsc_addr_2fe4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:28;
        RBus_UInt32  eq_fifo_full_ind:1;
        RBus_UInt32  ft_ind:1;
        RBus_UInt32  ft_dagc_lvl_ind:1;
        RBus_UInt32  ft_rf_agc_ind:1;
    };
}atsc_addr_2fe5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ao_rs_ber_cnt_7_0:8;
    };
}atsc_addr_2fe6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ao_rs_ber_cnt_15_8:8;
    };
}atsc_addr_2fe7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ao_rs_ber_cnt_23_16:8;
    };
}atsc_addr_2fe8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:27;
        RBus_UInt32  ao_rs_ser_trig:1;
        RBus_UInt32  ao_rs_ber_cnt_27_24:4;
    };
}atsc_addr_2fe9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ao_rs_pkt_cnt_7_0:8;
    };
}atsc_addr_2fea_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ao_rs_pkt_cnt_15_8:8;
    };
}atsc_addr_2feb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ao_rs_pkt_cnt_23_16:8;
    };
}atsc_addr_2fec_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ao_rs_corr_cnt_7_0:8;
    };
}atsc_addr_2fed_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ao_rs_corr_cnt_15_8:8;
    };
}atsc_addr_2fee_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ao_rs_corr_cnt_23_16:8;
    };
}atsc_addr_2fef_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ao_rs_uncorr_cnt_7_0:8;
    };
}atsc_addr_2ff0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ao_rs_uncorr_cnt_15_8:8;
    };
}atsc_addr_2ff1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ao_rs_uncorr_cnt_23_16:8;
    };
}atsc_addr_2ff2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tre_ber_cnt_7_0:8;
    };
}atsc_addr_2ff3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tre_ber_cnt_15_8:8;
    };
}atsc_addr_2ff4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tre_ber_cnt_23_16:8;
    };
}atsc_addr_2ff5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tre_ber_cnt_31_24:8;
    };
}atsc_addr_2ff6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tre_ber_cnt_39_32:8;
    };
}atsc_addr_2ff7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tre_seg_cnt_7_0:8;
    };
}atsc_addr_2ff8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tre_seg_cnt_15_8:8;
    };
}atsc_addr_2ff9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  tre_seg_cnt_23_16:8;
    };
}atsc_addr_2ffa_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:26;
        RBus_UInt32  fsm_mbist_fail_1:1;
        RBus_UInt32  fsm_mbist_fail_0:1;
        RBus_UInt32  fsm_drf_fail_1:1;
        RBus_UInt32  fsm_drf_fail_0:1;
        RBus_UInt32  atsc_drf_bist_done:1;
        RBus_UInt32  atsc_bist_done:1;
    };
}atsc_addr_2ffb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  ao_pkt_ser_num:8;
    };
}atsc_addr_2ffd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:31;
        RBus_UInt32  atsc_drf_pause:1;
    };
}atsc_addr_2ffe_RBUS;

#else //apply LITTLE_ENDIAN

//======ATSC register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  atsc_version:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2001_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_atsc_on:1;
        RBus_UInt32  res1:31;
    };
}atsc_addr_2004_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_soft_reset_atsc:1;
        RBus_UInt32  res1:31;
    };
}atsc_addr_2005_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_adcdata_atsc:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  opt_adcclkin_atsc:2;
        RBus_UInt32  res2:26;
    };
}atsc_addr_2007_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_rf_aagc_sel:3;
        RBus_UInt32  opt_rf_agc_drive:1;
        RBus_UInt32  opt_rf_aagc_pol:1;
        RBus_UInt32  opt_rf_aagc_oe:1;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2009_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_if_aagc_sel:3;
        RBus_UInt32  opt_if_agc_drive:1;
        RBus_UInt32  opt_if_aagc_pol:1;
        RBus_UInt32  opt_if_aagc_oe:1;
        RBus_UInt32  res1:26;
    };
}atsc_addr_200a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_mpeg_out_sel:3;
        RBus_UInt32  opt_mpeg_out_reg_4_0:5;
        RBus_UInt32  res1:24;
    };
}atsc_addr_200b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_mpeg_out_reg_11_5:7;
        RBus_UInt32  res1:25;
    };
}atsc_addr_200c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_mpeg_out2_sel:3;
        RBus_UInt32  opt_mpeg_out2_reg_4_0:5;
        RBus_UInt32  res1:24;
    };
}atsc_addr_200d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_mpeg_out2_reg_11_5:7;
        RBus_UInt32  res1:25;
    };
}atsc_addr_200e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_top_ant_tx_in_sel:3;
        RBus_UInt32  opt_top_ant_rx_in_sel:3;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2010_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_top_ant_det_sel:3;
        RBus_UInt32  opt_top_ant_oe_in_sel:3;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2011_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_tst_clk_sel:2;
        RBus_UInt32  opt_sa_clk_sel:2;
        RBus_UInt32  opt_par_tstclk:1;
        RBus_UInt32  opt_par_saclk:1;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2013_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_atsc_tstmux1_sel:4;
        RBus_UInt32  opt_atsc_tstmux2_sel:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2014_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_tst_in_sel:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2016_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_debug_all_sel:5;
        RBus_UInt32  res1:27;
    };
}atsc_addr_2017_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_debug_all_reg_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2018_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_debug_all_reg_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2019_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_debug_all_reg_23_16:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_201a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_debug_all_reg_31_24:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_201b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_debug_all_reg_39_32:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_201c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_debug_all_reg_47_40:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_201d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_auto_switch_result:2;
        RBus_UInt32  atsc_dummy_rw_reg_5_0:6;
        RBus_UInt32  res1:24;
    };
}atsc_addr_202a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  atsc_dummy_rw_reg_13_6:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_202b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  atsc_dummy_rw_reg_21_14:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_202c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_demod_int_n_sel:3;
        RBus_UInt32  opt_demod_int_n_inv:1;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2040_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  atsc_rf_agc_o:1;
        RBus_UInt32  atsc_rf_agc_oe:1;
        RBus_UInt32  atsc_if_agc_o:1;
        RBus_UInt32  atsc_if_agc_oe:1;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2051_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  atsc_ant_tx:1;
        RBus_UInt32  atsc_ant_tx_oe:1;
        RBus_UInt32  atsc_ant_oe:1;
        RBus_UInt32  atsc_ant_oe_oe:1;
        RBus_UInt32  atsc_ant_tx_in:1;
        RBus_UInt32  atsc_ant_rx_in:1;
        RBus_UInt32  atsc_ant_det:1;
        RBus_UInt32  res1:25;
    };
}atsc_addr_2052_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rssi_agc_level_q_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_205c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rssi_agc_level_q_13_8:6;
        RBus_UInt32  rssi_agc_loop_sat_d:1;
        RBus_UInt32  res1:25;
    };
}atsc_addr_205d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ad7_out_d:7;
        RBus_UInt32  res1:25;
    };
}atsc_addr_205e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_soft_reset_rssi_agc:1;
        RBus_UInt32  res1:31;
    };
}atsc_addr_2080_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_rssi_agc_on:1;
        RBus_UInt32  rssi_in_ph_sel:1;
        RBus_UInt32  u_rssi_agc_exp:3;
        RBus_UInt32  rssi_agc_pol:1;
        RBus_UInt32  opt_ad7_ckout_inv:1;
        RBus_UInt32  rssi_in_ph_sel2:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2081_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rssi_in_clk_ratio:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2082_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rssi_agc_max:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2083_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rssi_agc_min:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2084_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rssi_agc_targ_val:7;
        RBus_UInt32  res1:25;
    };
}atsc_addr_2085_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mh_out_en:1;
        RBus_UInt32  mh_in_sel:3;
        RBus_UInt32  res1:4;
        RBus_UInt32  res2:24;
    };
}atsc_addr_2090_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_adc_clk_xor:1;
        RBus_UInt32  reg_en_dcr:1;
        RBus_UInt32  reg_en_pga_mode:1;
        RBus_UInt32  reg_en_gi_pga:1;
        RBus_UInt32  reg_aagc_hold:1;
        RBus_UInt32  reg_aagc_cal_payload:1;
        RBus_UInt32  reg_hold_pga:1;
        RBus_UInt32  reg_pset_aagc:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20a0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_pset_aagc_val:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20a1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_target_val:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20a2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_aagc_loopgain0:5;
        RBus_UInt32  reg_aagc_loopgain1_2_0:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20a3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_aagc_loopgain1_4_3:2;
        RBus_UInt32  reg_aagc_loopgain2:5;
        RBus_UInt32  reg_integral_cnt_len_0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20a4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_integral_cnt_len_4_1:4;
        RBus_UInt32  reg_aagc_lock_det_len:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20a5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_aagc_latency_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20a6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_aagc_latency_12_8:5;
        RBus_UInt32  reg_aagc_lock_pga_hit_len:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20a7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_thd_lock_up_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20a8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_thd_lock_up_9_8:2;
        RBus_UInt32  reg_thd_lock_dw_5_0:6;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20a9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_thd_lock_dw_9_6:4;
        RBus_UInt32  reg_thd_up1_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20aa_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_thd_up1_9_4:6;
        RBus_UInt32  reg_thd_dw1_1_0:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20ab_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_thd_dw1_9_2:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20ac_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_thd_up2:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20ad_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_thd_dw2:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20ae_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  reg_aagc_lock_det_thd:4;
        RBus_UInt32  res2:24;
    };
}atsc_addr_20af_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_gain_step_sum_up_thd:4;
        RBus_UInt32  reg_gain_step_sum_dw_thd:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20b0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_gain_pulse_space_len:4;
        RBus_UInt32  reg_gain_pulse_hold_len:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20b1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  aagc_lock_ext:1;
        RBus_UInt32  res1:31;
    };
}atsc_addr_20b5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  agc_level_pga:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20b6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_ant_reset_n:1;
        RBus_UInt32  opt_ant_enable:1;
        RBus_UInt32  opt_ant_force_b:1;
        RBus_UInt32  opt_ant_force_a:1;
        RBus_UInt32  opt_ant_rx_mode:1;
        RBus_UInt32  opt_ant_ack_ctrl_mode:1;
        RBus_UInt32  opt_ant_auto_reply_ack:1;
        RBus_UInt32  opt_ant_rx_4b_on:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20c4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_ant_data_tx_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20c5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_ant_data_tx_14_8:7;
        RBus_UInt32  opt_ant_data_tx_strobe:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20c6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_ant_fix_tx:1;
        RBus_UInt32  opt_ant_fix_tx_oe:1;
        RBus_UInt32  opt_ant_fix_tx_en:1;
        RBus_UInt32  opt_ant_reply_strobe:1;
        RBus_UInt32  opt_ant_reply_ack:1;
        RBus_UInt32  res1:27;
    };
}atsc_addr_20c7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_ant_8k_period_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20c8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_ant_low_period_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20c9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_ant_8k_period_11_8:4;
        RBus_UInt32  opt_ant_low_period_11_8:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20ca_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_ant_tx_to_cnt_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20cb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_ant_rx_to_cnt_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20cc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_ant_tx_to_cnt_th_9_8:2;
        RBus_UInt32  opt_ant_rx_to_cnt_th_9_8:2;
        RBus_UInt32  opt_ant_tx_timeout_en:1;
        RBus_UInt32  opt_ant_rx_timeout_en:1;
        RBus_UInt32  opt_ant_rx_startbit_on:1;
        RBus_UInt32  res1:25;
    };
}atsc_addr_20cd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_ant_init_msg_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20ce_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_ant_init_msg_14_8:7;
        RBus_UInt32  res1:25;
    };
}atsc_addr_20cf_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_ant_ack_msg_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20d0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_ant_ack_msg_14_8:7;
        RBus_UInt32  res1:25;
    };
}atsc_addr_20d1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_ant_nack_msg_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20d2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_ant_nack_msg_14_8:7;
        RBus_UInt32  res1:25;
    };
}atsc_addr_20d3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_ant_ack_dly_cnt_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20d4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_ant_ack_dly_cnt_th_9_8:2;
        RBus_UInt32  opt_ant_rx_signal_pos:2;
        RBus_UInt32  res1:28;
    };
}atsc_addr_20d5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  opt_ant_pad_config:2;
        RBus_UInt32  opt_ant_tx_ant_oe_comb:1;
        RBus_UInt32  res2:25;
    };
}atsc_addr_20d6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_ant_test_en:1;
        RBus_UInt32  opt_ant_test_trig_sel:1;
        RBus_UInt32  opt_ant_test_strobe:1;
        RBus_UInt32  opt_ant_test_4b_on:1;
        RBus_UInt32  opt_ant_test_bit_th:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20d7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_ant_test_msg_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20d8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_ant_test_msg_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20d9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_ant_test_dly_cnt_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20da_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_ant_test_dly_cnt_th_9_8:2;
        RBus_UInt32  opt_ant_loopback1_en:1;
        RBus_UInt32  opt_ant_loopback2_en:1;
        RBus_UInt32  opt_ant_sr11to12:1;
        RBus_UInt32  opt_ant_timeout_clr:1;
        RBus_UInt32  opt_ant_rx_signal_neg:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20db_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_ant_rx_dly_cnt_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20dc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_ant_rx_dly_cnt_th_9_8:2;
        RBus_UInt32  res1:1;
        RBus_UInt32  opt_ant_tx_upd_st0:1;
        RBus_UInt32  opt_ant_tx_silence_st0:1;
        RBus_UInt32  opt_ant_tx_powerup_st0:1;
        RBus_UInt32  opt_ant_tx_oe_next_st0:1;
        RBus_UInt32  opt_ant_tx_oe_next_st9:1;
        RBus_UInt32  res2:24;
    };
}atsc_addr_20dd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_ant_tx_ini_period:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20de_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_ant_tx_st9_period:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20df_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_ant_tx_st11_period:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20e0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_ant_tx_end_st10:1;
        RBus_UInt32  opt_ant_tx_oe_next_st11:1;
        RBus_UInt32  opt_ant_tx_end_st13:1;
        RBus_UInt32  opt_ant_oe_pad_oe:1;
        RBus_UInt32  opt_ant_tx_pad_oe:1;
        RBus_UInt32  opt_ant_oe_inv:1;
        RBus_UInt32  opt_ant_tx_oe_opt:1;
        RBus_UInt32  opt_ant_tx_inv:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20e1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_ant_rx_sel:2;
        RBus_UInt32  opt_ant_rx_inv:1;
        RBus_UInt32  opt_ant_det_sel:2;
        RBus_UInt32  opt_ant_det_inv:1;
        RBus_UInt32  opt_ant_force_det:1;
        RBus_UInt32  opt_ant_rx_st_det:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20e2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  ant_test_state:3;
        RBus_UInt32  res2:25;
    };
}atsc_addr_20f4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ant_state:4;
        RBus_UInt32  ant_tx_state:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20f5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ant_rx_state:4;
        RBus_UInt32  ant_mode:1;
        RBus_UInt32  ant_init:1;
        RBus_UInt32  ant_rx_timeout_hold:1;
        RBus_UInt32  ant_tx_timeout_hold:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20f6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ant_rx_bit_cnt:4;
        RBus_UInt32  ant_tx_bit_cnt:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20f7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ant_pid_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20f8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ant_pid_9_8:2;
        RBus_UInt32  ant_tx_signal:1;
        RBus_UInt32  ant_oe_signal:1;
        RBus_UInt32  ant_rx_signal:1;
        RBus_UInt32  ant_det_signal:1;
        RBus_UInt32  res1:26;
    };
}atsc_addr_20f9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ant_pid_acc_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20fa_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ant_pid_acc_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_20fb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  adc_clk_ph_inv:1;
        RBus_UInt32  res1:31;
    };
}atsc_addr_2101_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  adc_format_sel:1;
        RBus_UInt32  agc_init_en:1;
        RBus_UInt32  res2:27;
    };
}atsc_addr_2102_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  aagc_target_val:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2103_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  agc_polar:1;
        RBus_UInt32  agc_manu0:1;
        RBus_UInt32  agc_manu1:1;
        RBus_UInt32  en_rf_agc:1;
        RBus_UInt32  en_if_agc:1;
        RBus_UInt32  agc_mode:1;
        RBus_UInt32  adc_nb_on:1;
        RBus_UInt32  adc_nb_mode:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2104_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  agc_manu_val:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2105_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  agc_rf_manu_val:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2106_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  agc_if_manu_val:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2107_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vtop:7;
        RBus_UInt32  res1:25;
    };
}atsc_addr_2108_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  krf:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2109_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  if_agc_min:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_210a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  if_agc_max:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_210b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rf_agc_min:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_210c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  rf_agc_max:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_210d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  agc_lock_th:4;
        RBus_UInt32  agc_lock_cnt_len_off:2;
        RBus_UInt32  res1:26;
    };
}atsc_addr_210e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ddc_phase_inc_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_210f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ddc_phase_inc_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2110_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ddc_phase_inc_19_16:4;
        RBus_UInt32  spec_inv_on:1;
        RBus_UInt32  res1:27;
    };
}atsc_addr_2111_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  down_converter_coef_0_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2112_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  down_converter_coef_0_9_8:2;
        RBus_UInt32  res1:30;
    };
}atsc_addr_2113_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  down_converter_coef_1_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2114_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  down_converter_coef_1_9_8:2;
        RBus_UInt32  res1:30;
    };
}atsc_addr_2115_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  down_converter_coef_2_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2116_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  down_converter_coef_2_9_8:2;
        RBus_UInt32  res1:30;
    };
}atsc_addr_2117_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  down_converter_coef_3_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2118_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  down_converter_coef_3_9_8:2;
        RBus_UInt32  res1:30;
    };
}atsc_addr_2119_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  down_converter_coef_4_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_211a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  down_converter_coef_4_9_8:2;
        RBus_UInt32  res1:30;
    };
}atsc_addr_211b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  down_converter_coef_5_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_211c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  down_converter_coef_5_9_8:2;
        RBus_UInt32  res1:30;
    };
}atsc_addr_211d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  down_converter_coef_6_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_211e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  down_converter_coef_6_9_8:2;
        RBus_UInt32  res1:30;
    };
}atsc_addr_211f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  down_converter_coef_7_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2120_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  down_converter_coef_7_9_8:2;
        RBus_UInt32  res1:30;
    };
}atsc_addr_2121_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  adc_trunc_bits:2;
        RBus_UInt32  agc_tune_en:1;
        RBus_UInt32  agc_tune_step:2;
        RBus_UInt32  agc_tune_period_exp:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2122_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  agc_tune_period_wait:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2123_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  agc_tune_upper_th:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2124_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  agc_tune_lower_th:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2125_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  agc_tune_sat_opt:1;
        RBus_UInt32  agc_max_sat_sel_1:2;
        RBus_UInt32  agc_max_sat_sel_2:1;
        RBus_UInt32  agc_tune_bn_stop:1;
        RBus_UInt32  res1:27;
    };
}atsc_addr_2126_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  agc_tune_min:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2127_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  agc_tune_max:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2128_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  agc_tune_max_sat:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2129_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  adc_clip_block_size_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_212a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  adc_clip_block_size_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_212b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  agc_lock_sel:1;
        RBus_UInt32  res1:31;
    };
}atsc_addr_212c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  aagc_iq_swap:1;
        RBus_UInt32  opt_ado_im:1;
        RBus_UInt32  adc_clip_iq:2;
        RBus_UInt32  opt_aagc_loop_in:3;
        RBus_UInt32  opt_aagc_out_dcc:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_212e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fe_dcc1_en:1;
        RBus_UInt32  fe_dcc1_max_en:1;
        RBus_UInt32  fe_dcc1_max:3;
        RBus_UInt32  fe_dcc1_acq_dly_prd:2;
        RBus_UInt32  res1:25;
    };
}atsc_addr_212f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fe_dcc1_u_acq:4;
        RBus_UInt32  fe_dcc1_u_trk:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2130_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_fe_dcc1_u:2;
        RBus_UInt32  opt_fe_dcc1_clr:2;
        RBus_UInt32  opt_fe_dcc1_upd:2;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2131_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ddc_zif_mode:1;
        RBus_UInt32  zif_spec_inv_on:1;
        RBus_UInt32  res1:30;
    };
}atsc_addr_2132_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fe_dcc2_en:1;
        RBus_UInt32  fe_dcc2_max_en:1;
        RBus_UInt32  fe_dcc2_max:3;
        RBus_UInt32  fe_dcc2_acq_dly_prd:2;
        RBus_UInt32  res1:25;
    };
}atsc_addr_2133_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fe_dcc2_u_acq:4;
        RBus_UInt32  fe_dcc2_u_trk:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2134_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_fe_dcc2_u:2;
        RBus_UInt32  opt_fe_dcc2_clr:2;
        RBus_UInt32  opt_fe_dcc2_upd:2;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2135_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fe_dcc3_en:1;
        RBus_UInt32  fe_dcc3_max_en:1;
        RBus_UInt32  fe_dcc3_max:3;
        RBus_UInt32  fe_dcc3_acq_dly_prd:2;
        RBus_UInt32  res1:25;
    };
}atsc_addr_2136_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fe_dcc3_u_acq:4;
        RBus_UInt32  fe_dcc3_u_trk:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2137_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_fe_dcc3_u:2;
        RBus_UInt32  opt_fe_dcc3_clr:2;
        RBus_UInt32  opt_fe_dcc3_upd:2;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2138_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fe_iqamp_u_acq:4;
        RBus_UInt32  fe_iqamp_u_trk:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2139_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fe_iqph_u_acq:4;
        RBus_UInt32  fe_iqph_u_trk:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_213a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fe_iq_acq_dly_prd:2;
        RBus_UInt32  opt_fe_iq_u:2;
        RBus_UInt32  opt_fe_iq_clr:2;
        RBus_UInt32  opt_fe_iq_upd:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_213b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fe_iqamp_manu_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_213c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fe_iqamp_manu_9_8:2;
        RBus_UInt32  fe_iqamp_manu_en:1;
        RBus_UInt32  fe_iqamp_max:3;
        RBus_UInt32  fe_iqamp_max_en:1;
        RBus_UInt32  fe_iqamp_en:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_213d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fe_iqph_manu_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_213e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fe_iqph_manu_9_8:2;
        RBus_UInt32  fe_iqph_manu_en:1;
        RBus_UInt32  fe_iqph_max:3;
        RBus_UInt32  fe_iqph_max_en:1;
        RBus_UInt32  fe_iqph_en:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_213f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  det_adj_th_bn:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2143_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  det_adj_th:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2144_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dagc_target_power:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2145_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dagc_level_ini:5;
        RBus_UInt32  dagc_load:1;
        RBus_UInt32  dagc_level_exp:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2146_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dagc_mu_sel:1;
        RBus_UInt32  dagc_mu_comp_en:1;
        RBus_UInt32  dagc_lock_th:6;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2147_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dc_alpha_exp:3;
        RBus_UInt32  res1:29;
    };
}atsc_addr_2148_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_phase_inc_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2165_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_phase_inc_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2166_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_phase_inc_23_16:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2167_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_phase_inc_26_24:3;
        RBus_UInt32  res1:29;
    };
}atsc_addr_2168_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fmu_mode:1;
        RBus_UInt32  tr_lock_th1:6;
        RBus_UInt32  tr_ld_comp_on:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2169_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_lock_th2:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_216a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_lock_ind_mode:2;
        RBus_UInt32  tr_min_sat_en:1;
        RBus_UInt32  tr_phase_inc_upd_n:1;
        RBus_UInt32  opt_gard_off:1;
        RBus_UInt32  res1:27;
    };
}atsc_addr_216d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_fll_exp_sel_out_msb:1;
        RBus_UInt32  correlation_tr_sel:1;
        RBus_UInt32  cr_cr2_auto:1;
        RBus_UInt32  cr_cr2_cr_offset_cnt_win_4_0:5;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e40_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_cor_th_acq:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_216e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_cor_th_trk:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_216f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_win_start:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2170_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_win_len:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2171_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_lost_cnt_th:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2172_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_ld_wide_en:1;
        RBus_UInt32  tr_fs_acc_reset:1;
        RBus_UInt32  tr_fs_fll_hold_en:1;
        RBus_UInt32  tr_fs_fll_exp:2;
        RBus_UInt32  tr_fs_pll_kp_exp:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2173_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_fll_times:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2174_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_acc2_size_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2175_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_acc2_size_9_8:2;
        RBus_UInt32  tr_fs_pll_kf_exp:3;
        RBus_UInt32  tr_fs_pll_kf_off:1;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2176_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_trk_ind_reacq_en:1;
        RBus_UInt32  tr_fs_fed_reacq_en:1;
        RBus_UInt32  tr_fs_fll_reacq_en:1;
        RBus_UInt32  tr_fs_ped_reacq_en:1;
        RBus_UInt32  tr_fs_pll_reacq_en:1;
        RBus_UInt32  tr_fs_pll_sign:1;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2177_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_trk_cnt_th:4;
        RBus_UInt32  tr_fs_cor_sel:1;
        RBus_UInt32  tr_fs_pll_wait_fll_en:1;
        RBus_UInt32  tr_fs_corr_sel2:1;
        RBus_UInt32  res1:25;
    };
}atsc_addr_2178_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_tr_fs_pk_trk_len:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2179_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_tr_fs_fsm_lock_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_217a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_tr_fs_fsm_lock_12_8:5;
        RBus_UInt32  res1:27;
    };
}atsc_addr_217b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_tr_fs_pk2el_en:1;
        RBus_UInt32  opt_tr_fs_pk_force_en:1;
        RBus_UInt32  opt_tr_fs_el_space:1;
        RBus_UInt32  opt_tr_fs_trk_hold_en:1;
        RBus_UInt32  tr_fs_fll_exp_crs:2;
        RBus_UInt32  tr_fs_acc2_size_crs_1_0:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_217c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_acc2_size_crs_9_2:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_217d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_fll_times_crs:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_217e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_win_crs_start:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_217f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_win_crs_len:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2180_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_win_el_start:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2181_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_win_el_len:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2182_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_tr_fs_el_kp_exp_crs:3;
        RBus_UInt32  opt_tr_fs_el_kp_exp_fine:3;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2183_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_tr_fs_el_kp_exp_trk:3;
        RBus_UInt32  opt_tr_fs_el_kf_exp_crs:4;
        RBus_UInt32  res1:25;
    };
}atsc_addr_2184_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_tr_fs_el_kf_exp_fine:4;
        RBus_UInt32  opt_tr_fs_el_kf_exp_trk:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2185_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_tr_fs_el_crs_len_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2186_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_tr_fs_el_crs_len_11_8:4;
        RBus_UInt32  opt_tr_fs_el_fine_len_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2187_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_tr_fs_el_fine_len_11_4:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2188_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_tr_fs_el_err_max_crs:4;
        RBus_UInt32  opt_tr_fs_el_err_max_fine:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2189_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_tr_fs_el_err_max_trk:4;
        RBus_UInt32  opt_tr_fs_el_trk_upd_prd:3;
        RBus_UInt32  res1:25;
    };
}atsc_addr_218a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_tr_fs_el_erracc_th:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_218b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_tr_fs_el_errmax_th:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_218c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_tr_fs_el_lock_prd:3;
        RBus_UInt32  opt_tr_fs_el_lock_sel:3;
        RBus_UInt32  res1:26;
    };
}atsc_addr_218d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_tr_fs_el_loc_upd6:1;
        RBus_UInt32  opt_tr_fs_el_loc_upd8:1;
        RBus_UInt32  opt_tr_fs_el_loc_upd10:1;
        RBus_UInt32  opt_tr_fs_el_loc_upd12:1;
        RBus_UInt32  opt_tr_fs_el_chg_strobe:1;
        RBus_UInt32  opt_tr_fs_el_weak_ratio:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_218e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_tr_fs_el_weak_prd:4;
        RBus_UInt32  opt_tr_fs_el_chg_stage:2;
        RBus_UInt32  res1:26;
    };
}atsc_addr_218f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_win_hold_start_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2190_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_win_hold_start_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2191_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_win_hold_len_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2192_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_win_hold_len_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2193_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_pll_sign_sel:1;
        RBus_UInt32  opt_tr_fs_pkcrs2el_sel:2;
        RBus_UInt32  res1:29;
    };
}atsc_addr_2194_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_tr_fs_pk_go0:1;
        RBus_UInt32  opt_tr_fs_pk_go1:1;
        RBus_UInt32  opt_tr_fs_pk_go2:1;
        RBus_UInt32  opt_tr_fs_pk_go3:1;
        RBus_UInt32  opt_tr_fs_fsm_en:1;
        RBus_UInt32  opt_tr_fs_fsm_pass0:1;
        RBus_UInt32  opt_tr_fs_bps_pk_crs:1;
        RBus_UInt32  opt_tr_fs_bps_pk_trk:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2195_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_cor_th_el:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2196_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pn63_pos_lb_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21a0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pn63_pos_lb_9_8:2;
        RBus_UInt32  opt_eq_train_cnt:1;
        RBus_UInt32  opt_eq_train2_cnt:1;
        RBus_UInt32  res1:28;
    };
}atsc_addr_21a1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pn63_pos_ub_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21a2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pn63_pos_ub_9_8:2;
        RBus_UInt32  fsm_final_state:6;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21a3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eq_train_cnt_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21a4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eq_train_cnt_th_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21a5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eq_train2_cnt_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21a6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eq_train2_cnt_th_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21a7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  state_cnt1_inc_state:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_21a8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  state_cnt1_reset_state:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_21a9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  state_cnt1_th:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21aa_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  state_cnt2_inc_state:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_21ab_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  state_cnt2_reset_state:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_21ac_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  state_cnt2_th:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21ad_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  state_cnt1_delay_th:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21ae_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_cond2_config:1;
        RBus_UInt32  reg_fsm_cond2:1;
        RBus_UInt32  fsm_cond3_config:1;
        RBus_UInt32  reg_fsm_cond3:1;
        RBus_UInt32  fsm_cond4_config:1;
        RBus_UInt32  reg_fsm_cond4:1;
        RBus_UInt32  fsm_cond0_config:1;
        RBus_UInt32  reg_fsm_cond0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21af_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_cond8_seg_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21b0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_cond8_seg_th_8:1;
        RBus_UInt32  res1:31;
    };
}atsc_addr_21b1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_cond9_sym_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21b2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_cond9_sym_th_9_8:2;
        RBus_UInt32  fsm_cond13_config:1;
        RBus_UInt32  res1:29;
    };
}atsc_addr_21b3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_cond10_config:1;
        RBus_UInt32  reg_fsm_cond10:1;
        RBus_UInt32  fsm_cond11_config:1;
        RBus_UInt32  reg_fsm_cond11:1;
        RBus_UInt32  fsm_cond6_config:1;
        RBus_UInt32  reg_fsm_cond6:1;
        RBus_UInt32  fsm_cond14_config:1;
        RBus_UInt32  reg_fsm_cond14:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21b4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_cond16_seg_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21b5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_cond16_seg_th_8:1;
        RBus_UInt32  fsm_cond19_config:1;
        RBus_UInt32  reg_fsm_cond19:1;
        RBus_UInt32  fsm_cond20_config:1;
        RBus_UInt32  reg_fsm_cond20:1;
        RBus_UInt32  fsm_cond30_config:1;
        RBus_UInt32  reg_fsm_cond30:1;
        RBus_UInt32  reg_fsm_cond25_n:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21b6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_cond17_sym_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21b7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_cond17_sym_th_9_8:2;
        RBus_UInt32  fsm_cond15_config:1;
        RBus_UInt32  fsm_cond25_config:1;
        RBus_UInt32  fsm_cond26_config:1;
        RBus_UInt32  fsm_cond31_config:1;
        RBus_UInt32  fsm_cond14_config2:1;
        RBus_UInt32  fsm_cond26_config2:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21b8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_cond28_config:3;
        RBus_UInt32  fsm_cond29_config:2;
        RBus_UInt32  res1:27;
    };
}atsc_addr_21b9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_cond29_seg_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21ba_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_cond29_seg_th_8:1;
        RBus_UInt32  res1:31;
    };
}atsc_addr_21bb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_cond29_sym_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21bc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_cond29_sym_th_9_8:2;
        RBus_UInt32  res1:30;
    };
}atsc_addr_21bd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_seg_cnt_r1_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21be_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_seg_cnt_r1_8:1;
        RBus_UInt32  res1:31;
    };
}atsc_addr_21bf_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_sym_cnt_r1_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21c0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_sym_cnt_r1_9_8:2;
        RBus_UInt32  res1:30;
    };
}atsc_addr_21c1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  agc_tune_clear_state:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_21c2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bn_agc_start_state:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_21c3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bn_agc_end_state:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_21c4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pn_comp_start_state:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_21c5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pn_comp_end_state:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_21c6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pn_state_cnt2_end_opt:1;
        RBus_UInt32  pn_pt_state_cnt2_end_opt:1;
        RBus_UInt32  pn_cr_state_cnt2_end_opt:1;
        RBus_UInt32  res1:29;
    };
}atsc_addr_21c7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  adj_srrc_upd_state:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_21c8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  adj_srrc_clear_state:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_21c9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  state_cnt3_inc_state:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_21ca_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  state_cnt3_reset_state:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_21cb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  state_cnt3_th:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21cc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  state_cnt4_inc_state:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_21cd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  state_cnt4_reset_state:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_21ce_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  state_cnt4_th:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21cf_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  state_cnt5_inc_state:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_21d0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  state_cnt5_reset_state:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_21d1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  state_cnt5_th:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21d2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_mse_th_1_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21d3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_mse_th_1_13_8:6;
        RBus_UInt32  fsm_mse_sel_1:1;
        RBus_UInt32  fsm_mse_inv_1:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21d4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_mse_th_2_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21d5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_mse_th_2_13_8:6;
        RBus_UInt32  fsm_mse_sel_2:1;
        RBus_UInt32  fsm_mse_inv_2:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21d6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_scan_lock_state:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_21d7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_scan_unlock_state:6;
        RBus_UInt32  fsm_scan_ind_clear:1;
        RBus_UInt32  res1:25;
    };
}atsc_addr_21d8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_cond8_sym_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21d9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_cond8_sym_th_9_8:2;
        RBus_UInt32  res1:30;
    };
}atsc_addr_21da_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_fsm_ram_col:5;
        RBus_UInt32  reg_fsm_load_ini:1;
        RBus_UInt32  res1:26;
    };
}atsc_addr_21e0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_fsm_ram_row:6;
        RBus_UInt32  reg_fsm_ram_rd:1;
        RBus_UInt32  reg_fsm_bw_stop:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21e1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_fsm_ram_data:7;
        RBus_UInt32  reg_fsm_ram_wr:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21e2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_ram_crc_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21e3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_ram_crc_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21e4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_ram_state:5;
        RBus_UInt32  fsm_ram_crc_done:1;
        RBus_UInt32  res1:26;
    };
}atsc_addr_21e5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_ram_data_ro:7;
        RBus_UInt32  res1:25;
    };
}atsc_addr_21e6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_segment_counter_ini0_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21e7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_segment_counter_ini0_8:1;
        RBus_UInt32  fsm_segment_counter_ini1_6_0:7;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21e8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_segment_counter_ini1_8_7:2;
        RBus_UInt32  res1:30;
    };
}atsc_addr_21e9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_symbol_counter_ini0_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21ea_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_symbol_counter_ini0_9_8:2;
        RBus_UInt32  fsm_symbol_counter_ini1_5_0:6;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21eb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_symbol_counter_ini1_9_6:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_21ec_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_train_ptr_ini0_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21ed_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_train_ptr_ini0_9_8:2;
        RBus_UInt32  fsm_train_ptr_ini1_5_0:6;
        RBus_UInt32  res1:24;
    };
}atsc_addr_21ee_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_train_ptr_ini1_9_6:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_21ef_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pt_mode:2;
        RBus_UInt32  pt_out_sel:1;
        RBus_UInt32  pt_on:1;
        RBus_UInt32  pt_dd_max:3;
        RBus_UInt32  res1:25;
    };
}atsc_addr_2201_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pt_state_start:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2202_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pt_state_end:6;
        RBus_UInt32  pt_kb_exp:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2203_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pt_u_exp_0:2;
        RBus_UInt32  pt_u_exp_1:2;
        RBus_UInt32  pt_dec_sel:1;
        RBus_UInt32  res1:27;
    };
}atsc_addr_2220_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pt_ph_max:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2221_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pt_clear_en:1;
        RBus_UInt32  pt_dd_t:3;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2222_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srrc_coeff_0:7;
        RBus_UInt32  srrc_coeff_12_0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2501_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srrc_coeff_12_8_1:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2502_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srrc_coeff_1:7;
        RBus_UInt32  srrc_coeff_13_0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2503_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srrc_coeff_13_8_1:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2504_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srrc_coeff_2:7;
        RBus_UInt32  srrc_coeff_14_0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2505_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srrc_coeff_14_8_1:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2506_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srrc_coeff_3:7;
        RBus_UInt32  srrc_coeff_15_0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2507_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srrc_coeff_15_8_1:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2508_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srrc_coeff_4:7;
        RBus_UInt32  srrc_coeff_16_0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2509_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srrc_coeff_16_8_1:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_250a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srrc_coeff_5:7;
        RBus_UInt32  srrc_coeff_17_0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_250b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srrc_coeff_17_8_1:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_250c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srrc_coeff_6:7;
        RBus_UInt32  srrc_coeff_18_0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_250d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srrc_coeff_18_8_1:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_250e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srrc_coeff_7:7;
        RBus_UInt32  srrc_coeff_19_0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_250f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srrc_coeff_19_8_1:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2510_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srrc_coeff_8:7;
        RBus_UInt32  srrc_coeff_20_0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2511_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srrc_coeff_20_8_1:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2512_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srrc_coeff_9:7;
        RBus_UInt32  srrc_coeff_21_0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2513_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srrc_coeff_21_8_1:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2514_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srrc_coeff_10:7;
        RBus_UInt32  srrc_coeff_22_0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2515_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srrc_coeff_22_8_1:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2516_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srrc_coeff_11:7;
        RBus_UInt32  srrc_coeff_23_0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2517_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srrc_coeff_23_8_1:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2518_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srrc_coeff_24_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2519_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srrc_coeff_24_11_8:4;
        RBus_UInt32  srrc_coeff_25_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_251a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srrc_coeff_25_11_4:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_251b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srrc_coeff_26_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_251c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srrc_coeff_26_11_8:4;
        RBus_UInt32  srrc_coeff_27_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_251d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srrc_coeff_27_11_4:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_251e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srrc_coeff_28_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_251f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srrc_coeff_28_11_8:4;
        RBus_UInt32  srrc_coeff_29_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2520_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srrc_coeff_29_11_4:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2521_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srrc_coeff_30_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2522_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srrc_coeff_30_11_8:4;
        RBus_UInt32  srrc_coeff_31_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2523_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srrc_coeff_31_11_4:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2524_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  srrc_coeff_sel:2;
        RBus_UInt32  srrc_coeff_sel_auto0:2;
        RBus_UInt32  srrc_coeff_sel_auto1:2;
        RBus_UInt32  srrc_coeff_sel_auto_en:1;
        RBus_UInt32  adj_ind_srrc_pol:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2542_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_comp_scale_exp_table0:4;
        RBus_UInt32  cr_comp_scale_exp_table1:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2580_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_comp_scale_exp_table2:4;
        RBus_UInt32  cr_comp_scale_exp_table3:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2581_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_comp_scale_exp_table4:4;
        RBus_UInt32  cr_comp_scale_exp_table5:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2582_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_comp_scale_exp_table6:4;
        RBus_UInt32  cr_comp_scale_exp_table7:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2583_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_comp_scale_exp_table8:4;
        RBus_UInt32  cr_comp_scale_exp_table9:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2584_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_comp_scale_exp_table10:4;
        RBus_UInt32  cr_comp_scale_exp_table11:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2585_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_comp_scale_exp_table12:4;
        RBus_UInt32  cr_comp_scale_exp_table13:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2586_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_comp_scale_exp_table14:4;
        RBus_UInt32  cr_comp_scale_exp_table15:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2587_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_comp_scale_exp_table16:4;
        RBus_UInt32  cr_comp_scale_exp_table17:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2588_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_comp_scale_exp_table18:4;
        RBus_UInt32  cr_comp_scale_exp_table19:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2589_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_comp_scale_exp_table20:4;
        RBus_UInt32  cr_comp_scale_exp_table21:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_258a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_comp_scale_exp_table22:4;
        RBus_UInt32  cr_comp_scale_exp_table23:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_258b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_comp_scale_exp_table24:4;
        RBus_UInt32  cr_comp_scale_exp_table25:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_258c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_comp_scale_exp_table26:4;
        RBus_UInt32  cr_comp_scale_exp_table27:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_258d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_comp_scale_exp_table28:4;
        RBus_UInt32  cr_comp_scale_exp_table29:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_258e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_comp_scale_exp_table30:4;
        RBus_UInt32  cr_comp_scale_exp_table31:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_258f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_cr2_cr_offset_cnt_win_12_5:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e41_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_cr2_cr_offset_cnt_win_18_13:6;
        RBus_UInt32  res1:1;
        RBus_UInt32  cr_cr2_cr_offset_dif_thd_0:1;
        RBus_UInt32  res2:24;
    };
}atsc_addr_2e42_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_cr2_cr_offset_dif_thd_8_1:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e43_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_cr2_cr_offset_dif_thd_16_9:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e44_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_cr2_cr_offset_dif_thd_24_17:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e45_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_cr2_cr_offset_dif_thd_32_25:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e46_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_cr2_cr_offset_large_cnt_max:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e47_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_cr2_cr_offset_large_cnt_thd:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e48_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_cr2_cr_offset_large_cnt_inc_2_0:3;
        RBus_UInt32  cr_cr2_cr_offset_large_cnt_dec:3;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2e49_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_cr2_cr_offset_large_cnt_inc_7_3:5;
        RBus_UInt32  cr_fmu_cr2_nb_comp_2_0:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e50_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_cr2_cargp_wb:4;
        RBus_UInt32  cr_cr2_cargp_nb:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e4a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_cr2_cr_offset_dif_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e4b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_cr2_cr_offset_dif_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e4c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_cr2_cr_offset_dif_23_16:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e4d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_cr2_cr_offset_dif_31_24:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e4e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_cr2_cr_offset_dif_32:1;
        RBus_UInt32  res1:31;
    };
}atsc_addr_2e4f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_lpf_var_s0_floor_en:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  cr_fmu_upd_opt:3;
        RBus_UInt32  res2:25;
    };
}atsc_addr_25a0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  cr_lpf_2_a_exp_reg0:3;
        RBus_UInt32  cr_lpf_2_a_exp_reg1:3;
        RBus_UInt32  res2:24;
    };
}atsc_addr_25a1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  cr_lpf_2_b_exp_reg0:3;
        RBus_UInt32  res2:26;
    };
}atsc_addr_25a2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_lpf_2_b_exp_reg1:3;
        RBus_UInt32  res1:4;
        RBus_UInt32  cr_lpf_shift_en:1;
        RBus_UInt32  res2:24;
    };
}atsc_addr_25a3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_comp_input_sel1:3;
        RBus_UInt32  res1:1;
        RBus_UInt32  cr_comp_scale_en_sel:3;
        RBus_UInt32  res2:25;
    };
}atsc_addr_25a4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_comp_exp_max:3;
        RBus_UInt32  res1:1;
        RBus_UInt32  cr_comp_go_cond1_en:1;
        RBus_UInt32  cr_comp_go_cond2_en:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  cr_dr1_im_pwr_alpha:1;
        RBus_UInt32  res3:24;
    };
}atsc_addr_25a5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_dr1_im_lpf_alpha1:2;
        RBus_UInt32  cr_dr1_im_lpf_alpha2:2;
        RBus_UInt32  cr_dr1_im_hpf_alpha:2;
        RBus_UInt32  cr_dr1_mean_alpha:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_25a6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_fmu_upd_cnt_th:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_25a7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_snr_ind1_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_25a8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_snr_ind1_th_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_25a9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_snr_ind2_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_25aa_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_snr_ind2_th_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_25ab_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_pilot_cnr_th_exp1:4;
        RBus_UInt32  cr_pilot_cnr_th_exp2:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_25ac_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_pilot_cnr_th_exp3:4;
        RBus_UInt32  cr_pilot_cnr_th_exp4:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_25ad_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_pilot_cnr_th_exp5:4;
        RBus_UInt32  cr_pilot_cnr_th_exp6:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_25ae_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_pilot_cnr_th_exp7:4;
        RBus_UInt32  cr_lpf_shift_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_25af_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_lpf_shift_11_4:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_25b0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_pn_det_cond_en:1;
        RBus_UInt32  cr_pn_det_pilot_cnr_exp:4;
        RBus_UInt32  cr_comp_scale_exp_fixed:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_25b7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_lpf_scale_reg0_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2601_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_lpf_scale_reg0_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2602_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_lpf_scale_reg1_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2603_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_lpf_scale_reg1_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2604_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_lpf_a1_reg0_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2607_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_lpf_a1_reg0_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2608_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_lpf_a1_reg0_21_16:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2609_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_lpf_a1_reg1_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_260a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_lpf_a1_reg1_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_260b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_lpf_a1_reg1_21_16:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_260c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_lpf_a2_reg0_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2610_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_lpf_a2_reg0_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2611_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_lpf_a2_reg0_21_16:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2612_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_lpf_a2_reg1_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2613_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_lpf_a2_reg1_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2614_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_lpf_a2_reg1_21_16:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2615_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_lpf_b1_reg0_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2619_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_lpf_b1_reg0_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_261a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_lpf_b1_reg0_21_16:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_261b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_lpf_b1_reg1_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_261c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_lpf_b1_reg1_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_261d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_lpf_b1_reg1_21_16:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_261e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_lpf_b2_reg0_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2622_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_lpf_b2_reg0_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2623_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_lpf_b2_reg0_21_16:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2624_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_lpf_b2_reg1_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2625_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_lpf_b2_reg1_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2626_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_lpf_b2_reg1_21_16:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2627_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_ld_cnt_inc:1;
        RBus_UInt32  cr_ld_cnt_dec:1;
        RBus_UInt32  cr_ld_re_sel:1;
        RBus_UInt32  cr_ld_im_sel:1;
        RBus_UInt32  cr_ld_freq_diff_sel:1;
        RBus_UInt32  cr_ld_freq_ub_sel:1;
        RBus_UInt32  cr_ld_re_diff_en:1;
        RBus_UInt32  res1:25;
    };
}atsc_addr_2628_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_ld_det_alpha:2;
        RBus_UInt32  res1:30;
    };
}atsc_addr_2629_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  cr_comp_manu:1;
        RBus_UInt32  cr_comp_man_manu:1;
        RBus_UInt32  cr_comp_exp_manu:3;
        RBus_UInt32  res2:25;
    };
}atsc_addr_262b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_phase_shift_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_262c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_phase_shift_9_8:2;
        RBus_UInt32  res1:1;
        RBus_UInt32  cr_offset_leak_upd_opt:2;
        RBus_UInt32  cr_offset_leak_prd:3;
        RBus_UInt32  res2:24;
    };
}atsc_addr_262d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_offset_leak_f_th:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_262e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_phase_comp_slope_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2630_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_phase_comp_slope_10_8:3;
        RBus_UInt32  cr_phase_comp_in_sel:1;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2631_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_comp_target_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2632_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_comp_target_8:1;
        RBus_UInt32  res1:31;
    };
}atsc_addr_2633_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_ld_cnt_th:4;
        RBus_UInt32  cr_pmu_comp0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2634_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_pmu_comp1:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2635_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_fmu_comp0:4;
        RBus_UInt32  cr_fmu_comp1:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2636_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  cr_acq_fmu:4;
        RBus_UInt32  res2:24;
    };
}atsc_addr_2637_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_acq_pmu:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2638_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_ld_freq_ub0_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2639_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_ld_freq_ub0_10_8:3;
        RBus_UInt32  res1:29;
    };
}atsc_addr_263a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_ld_freq_ub1_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_263b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_ld_freq_ub1_10_8:3;
        RBus_UInt32  res1:29;
    };
}atsc_addr_263c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_ld_re_diff_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_263d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_ld_re_diff_th_13_8:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_263e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_ld_comp_on:1;
        RBus_UInt32  cr_ld_re_lb_en:1;
        RBus_UInt32  cr_ld_im_en:1;
        RBus_UInt32  cr_ld_freq_en:1;
        RBus_UInt32  cr_ld_freq_max_en:1;
        RBus_UInt32  cr_ld_re_ub_en:1;
        RBus_UInt32  res1:26;
    };
}atsc_addr_263f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_ld_re_th_lb_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2640_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_ld_re_th_lb_12_8:5;
        RBus_UInt32  res1:27;
    };
}atsc_addr_2641_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_ld_im_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2642_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_ld_im_th_12_8:5;
        RBus_UInt32  res1:27;
    };
}atsc_addr_2643_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_ld_cr_freq_diff_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2644_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_ld_cr_freq_diff_th_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2645_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_ld_re_th_ub_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2646_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_ld_re_th_ub_13_8:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2647_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_large_freq_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2648_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_large_freq_th_10_8:3;
        RBus_UInt32  res1:29;
    };
}atsc_addr_2649_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_pmu_pn_comp:3;
        RBus_UInt32  cr_fmu_pn_comp:3;
        RBus_UInt32  res1:26;
    };
}atsc_addr_264a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_cr2_en_sel:2;
        RBus_UInt32  cr_cr2_carb:3;
        RBus_UInt32  cr_cr2_carer:1;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2002_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_cr2_cargp:4;
        RBus_UInt32  cr_cr2_cargi:3;
        RBus_UInt32  res1:25;
    };
}atsc_addr_2003_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_fmu_cr2_nb_comp_5_3:3;
        RBus_UInt32  cr_pmu_cr2_nb_comp_4_0:5;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e51_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_pmu_cr2_nb_comp_5:1;
        RBus_UInt32  cr_fmu_cr2_wb_comp:6;
        RBus_UInt32  cr_pmu_cr2_wb_comp_0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e52_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_pmu_cr2_wb_comp_5_1:5;
        RBus_UInt32  cr_cr2_carb_wb:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e53_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_cr2_carb_nb:3;
        RBus_UInt32  cr_cr2_cargi_wb:3;
        RBus_UInt32  cr_cr2_cargi_nb_1_0:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e54_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_cr2_cargi_nb_2:1;
        RBus_UInt32  cr_cr2_start_state:6;
        RBus_UInt32  cr_cr2_cr_offset_tilt_smp_thd_0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e55_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_cr2_cr_offset_tilt_smp_thd_8_1:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e56_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_cr2_cr_offset_tilt_smp_thd_12_9:4;
        RBus_UInt32  cr_cr2_cr_offset_tilt_val_thd_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e57_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_cr2_cr_offset_tilt_val_thd_11_4:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e58_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_cr2_cr_offset_tilt_val_thd_19_12:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e59_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_cr2_cr_offset_tilt_val_thd_27_20:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e5a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_cr2_cr_offset_tilt_val_thd_32_28:5;
        RBus_UInt32  res1:1;
        RBus_UInt32  cr_cr2_cr_offset_lpf_sft_sel_1_0:2;
        RBus_UInt32  res2:24;
    };
}atsc_addr_2e5b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_cr2_cr_offset_lpf_sft_sel_2:1;
        RBus_UInt32  cr_cr2_swbw_cond_sel:4;
        RBus_UInt32  cr_cr2_swbw_ofa:1;
        RBus_UInt32  cr_cr2_cr_offset_tilt_cnt_inc_1_0:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e5c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_cr2_cr_offset_tilt_cnt_inc_7_2:6;
        RBus_UInt32  cr_cr2_cr_offset_tilt_cnt_dec_1_0:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e5d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_cr2_cr_offset_tilt_cnt_dec_2:1;
        RBus_UInt32  cr_cr2_cr_offset_tilt_cnt_thd_6_0:7;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e5e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_cr2_cr_offset_tilt_cnt_thd_7:1;
        RBus_UInt32  cr_cr2_cr_offset_tilt_cnt_max_6_0:7;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e5f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_cr2_cr_offset_tilt_cnt_max_7:1;
        RBus_UInt32  tr_fs_ped_int_en:1;
        RBus_UInt32  comp_buf_out:1;
        RBus_UInt32  cci_rej_bypass_buf:1;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2e60_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_cr2_cr_offset_large_flag:1;
        RBus_UInt32  cr_cr2_cr_offset_large_flag2:1;
        RBus_UInt32  cr_cr2_cr_offset_tilt_smp_flag:1;
        RBus_UInt32  cr_cr2_cr_offset_tilt_val_flag:1;
        RBus_UInt32  cr_cr2_swbw:1;
        RBus_UInt32  res1:27;
    };
}atsc_addr_2e61_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir23_en:1;
        RBus_UInt32  cci_iir_pos_0_6_0:7;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e62_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_pos_0_12_7:6;
        RBus_UInt32  cci_iir_freq_offset_1_0:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e63_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_freq_offset_2:1;
        RBus_UInt32  cci_iir_g_ratio_m0:5;
        RBus_UInt32  cci_iir_g_ratio_m1_1_0:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e64_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_g_ratio_m1_4_2:3;
        RBus_UInt32  cci_iir_g_ratio_l0:5;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e65_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_g_ratio_l1:5;
        RBus_UInt32  cci_iir_a_1_s1_2_0:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e66_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_a_1_s1_10_3:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e67_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_a_1_s1_18_11:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e68_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_a_1_s1_20_19:2;
        RBus_UInt32  cci_iir_a_2_s1_5_0:6;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e69_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_a_2_s1_13_6:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e6a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_a_2_s1_20_14:7;
        RBus_UInt32  cci_iir_b_0_s1_0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e6b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_0_s1_8_1:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e6c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_0_s1_16_9:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e6d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_0_s1_20_17:4;
        RBus_UInt32  cci_iir_b_1_s1_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e6e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_1_s1_11_4:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e6f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_1_s1_19_12:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e70_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_1_s1_20:1;
        RBus_UInt32  cci_iir_b_2_s1_6_0:7;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e71_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_2_s1_14_7:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e72_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_2_s1_20_15:6;
        RBus_UInt32  cci_iir_a_1_m0_1_0:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e73_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_a_1_m0_9_2:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e74_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_a_1_m0_17_10:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e75_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_a_1_m0_20_18:3;
        RBus_UInt32  cci_iir_a_2_m0_4_0:5;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e76_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_a_2_m0_12_5:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e77_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_a_2_m0_20_13:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e78_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_0_m0_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e79_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_0_m0_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e7a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_0_m0_20_16:5;
        RBus_UInt32  cci_iir_b_1_m0_2_0:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e7b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_1_m0_10_3:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e7c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_1_m0_18_11:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e7d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_1_m0_20_19:2;
        RBus_UInt32  cci_iir_b_2_m0_5_0:6;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e7e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_2_m0_13_6:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e7f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_2_m0_20_14:7;
        RBus_UInt32  cci_iir_a_1_m1_0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e80_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_a_1_m1_8_1:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e81_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_a_1_m1_16_9:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e82_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_a_1_m1_20_17:4;
        RBus_UInt32  cci_iir_a_2_m1_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e83_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_a_2_m1_11_4:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e84_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_a_2_m1_19_12:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e85_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_a_2_m1_20:1;
        RBus_UInt32  cci_iir_b_0_m1_6_0:7;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e86_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_0_m1_14_7:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e87_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_0_m1_20_15:6;
        RBus_UInt32  cci_iir_b_1_m1_1_0:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e88_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_1_m1_9_2:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e89_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_1_m1_17_10:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e8a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_1_m1_20_18:3;
        RBus_UInt32  cci_iir_b_2_m1_4_0:5;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e8b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_2_m1_12_5:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e8c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_2_m1_20_13:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e8d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_a_1_l0_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e8e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_a_1_l0_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e8f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_a_1_l0_20_16:5;
        RBus_UInt32  cci_iir_a_2_l0_2_0:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e90_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_a_2_l0_10_3:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e91_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_a_2_l0_18_11:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e92_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_a_2_l0_20_19:2;
        RBus_UInt32  cci_iir_b_0_l0_5_0:6;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e93_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_0_l0_13_6:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e94_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_0_l0_20_14:7;
        RBus_UInt32  cci_iir_b_1_l0_0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e95_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_1_l0_8_1:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e96_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_1_l0_16_9:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e97_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_1_l0_20_17:4;
        RBus_UInt32  cci_iir_b_2_l0_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e98_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_2_l0_11_4:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e99_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_2_l0_19_12:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e9a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_2_l0_20:1;
        RBus_UInt32  cci_iir_a_1_l1_6_0:7;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e9b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_a_1_l1_14_7:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e9c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_a_1_l1_20_15:6;
        RBus_UInt32  cci_iir_a_2_l1_1_0:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e9d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_a_2_l1_9_2:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e9e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_a_2_l1_17_10:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e9f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_a_2_l1_20_18:3;
        RBus_UInt32  cci_iir_b_0_l1_4_0:5;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ea0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_0_l1_12_5:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ea1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_0_l1_20_13:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ea2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_1_l1_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ea3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_1_l1_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ea4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_1_l1_20_16:5;
        RBus_UInt32  cci_iir_b_2_l1_2_0:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ea5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_2_l1_10_3:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ea6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_2_l1_18_11:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ea7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_iir_b_2_l1_20_19:2;
        RBus_UInt32  cci_rej_en:1;
        RBus_UInt32  cci_det_manl_on:1;
        RBus_UInt32  cci_rej_manl_on:1;
        RBus_UInt32  cci_rej_manl_off:1;
        RBus_UInt32  cci_det_start_st_1_0:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ea8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_det_start_st_5_2:4;
        RBus_UInt32  cci_det_fft_n_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ea9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_det_fft_n_5_4:2;
        RBus_UInt32  cci_pos_dif_range:6;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2eaa_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_pos_around_cnt_thd:6;
        RBus_UInt32  cci_rej_start_st_1_0:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2eab_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_rej_start_st_5_2:4;
        RBus_UInt32  cci_rej_freq_neg_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2eac_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_rej_freq_neg_11_4:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ead_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_rej_freq_neg_12:1;
        RBus_UInt32  cci_rej_freq_post_6_0:7;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2eae_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_rej_freq_post_12_7:6;
        RBus_UInt32  cci_thd_ratio_1_0:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2eaf_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_thd_ratio_9_2:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2eb0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_thd_ratio_11_10:2;
        RBus_UInt32  cci_iir_reset_each_frame:1;
        RBus_UInt32  cci_fft_dsp_first_out_idx_4_0:5;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2eb1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_fft_dsp_first_out_idx_12_5:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2eb2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_fft_idx_offset:4;
        RBus_UInt32  cci_fft_abs:1;
        RBus_UInt32  cci_fft_act_num_2_0:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2eb3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_fft_act_num_5_3:3;
        RBus_UInt32  cci_fft_dsp_read:1;
        RBus_UInt32  cci_fft_out_mode:1;
        RBus_UInt32  cci_fft_trunc_num:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2eb4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_detected:1;
        RBus_UInt32  cci_rej_on:1;
        RBus_UInt32  cci_pos_5_0:6;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2eb5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_pos_12_6:7;
        RBus_UInt32  cci_val_0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2eb6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_val_8_1:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2eb7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cci_val_13_9:5;
        RBus_UInt32  res1:27;
    };
}atsc_addr_2eb8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_trk1_period_lb:3;
        RBus_UInt32  cr_trk1_period_ub:3;
        RBus_UInt32  res1:26;
    };
}atsc_addr_264b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_ld_corr_en:1;
        RBus_UInt32  cr_corr_th:6;
        RBus_UInt32  res1:25;
    };
}atsc_addr_264c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_ld_trk2_unlock_corr_en:1;
        RBus_UInt32  cr_ld_trk2_unlock_in_en:1;
        RBus_UInt32  cr_ld_trk2_unlock_and_or:1;
        RBus_UInt32  cr_trk1_trk2_rst_en:1;
        RBus_UInt32  cr_fs_reset_en:1;
        RBus_UInt32  res1:27;
    };
}atsc_addr_264d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_fsm_on:1;
        RBus_UInt32  cr_search_mode:1;
        RBus_UInt32  cr_acq_period1_ub0:3;
        RBus_UInt32  cr_acq_period1_ub1:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2650_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  cr_acq_period1_lb0:2;
        RBus_UInt32  cr_acq_period1_lb1:2;
        RBus_UInt32  res2:25;
    };
}atsc_addr_2651_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  cr_acq_unlock_period:3;
        RBus_UInt32  res2:24;
    };
}atsc_addr_2652_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_comp_period:3;
        RBus_UInt32  cr_ld_period:3;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2653_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_acq_freq_step0:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2654_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_acq_freq_step1:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2655_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_acq_if_offset_ini0:4;
        RBus_UInt32  cr_acq_if_offset_ini1:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2657_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_acq_pre_shift:7;
        RBus_UInt32  res1:25;
    };
}atsc_addr_2659_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_const_inc_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_265a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_const_inc_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_265b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_const_inc_16:1;
        RBus_UInt32  res1:31;
    };
}atsc_addr_265c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_acq_freq_ub:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_265d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_main_addr_th1_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_265e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_main_addr_th1_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_265f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_main_addr_th2_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2660_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_main_addr_th2_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2661_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_main_addr_th3_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2662_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_main_addr_th3_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2663_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_main_addr_th4_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2664_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_main_addr_th4_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2665_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_main_addr_th5_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2666_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_main_addr_th5_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2667_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_main_addr_th6_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2668_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_main_addr_th6_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2669_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_main_max_ratio2:7;
        RBus_UInt32  res1:25;
    };
}atsc_addr_266a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_main_max_ratio3:7;
        RBus_UInt32  res1:25;
    };
}atsc_addr_266b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_main_max_ratio4:7;
        RBus_UInt32  res1:25;
    };
}atsc_addr_266c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_main_max_ratio5:7;
        RBus_UInt32  res1:25;
    };
}atsc_addr_266d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_main_max_ratio6:7;
        RBus_UInt32  res1:25;
    };
}atsc_addr_266e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_main_max_ratio7:7;
        RBus_UInt32  res1:25;
    };
}atsc_addr_266f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_main_max_ratio:7;
        RBus_UInt32  fs2_corr_amp_sel:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2670_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_wmax_size_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2671_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_wmax_size_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2672_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_corr_amp_th1_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2673_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_corr_amp_th1_12_8:5;
        RBus_UInt32  res1:27;
    };
}atsc_addr_2674_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_max_rec_sam_num_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2675_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_max_rec_sam_num_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2676_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_wp_post_size_10_7:4;
        RBus_UInt32  fs2_max_rec_sam_num_2_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_26ae_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_max_rec_sam_num_2_11_4:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_26af_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_wmain_size_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2677_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_wmain_size_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2678_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_wmain_size2_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2679_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_wmain_size2_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_267a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_wp_main_size_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_267b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_wp_main_size_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_267c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_wpre_size_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_267d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_wpre_size_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_267e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_wpre_size2_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_267f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_wpre_size2_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2680_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_corr_th_pre_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2681_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_corr_th_pre_12_8:5;
        RBus_UInt32  res1:27;
    };
}atsc_addr_2682_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_wp_pre_size_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2683_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_wp_pre_size_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2684_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_main_max_offset:4;
        RBus_UInt32  fs2_main_ind_offset:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2685_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_max_re_ind_offset:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2686_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_force_num_decode_default:7;
        RBus_UInt32  res1:25;
    };
}atsc_addr_2687_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_force_space_default_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2688_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_force_space_default_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2689_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_force_manu:1;
        RBus_UInt32  fs2_main_isnot_max_off:1;
        RBus_UInt32  fs2_force_en:1;
        RBus_UInt32  fs2_refresh_max_amp_s4:1;
        RBus_UInt32  fs2_main_ram_off:1;
        RBus_UInt32  fs2_pre_ram_off:1;
        RBus_UInt32  fs2_s11_wait_max:1;
        RBus_UInt32  fs2_main_isnot_max_force_en:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_268a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_space_th_0_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_268b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_space_th_0_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_268c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_space_th_1_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_268d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_space_th_1_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_268e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_space_th_2_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_268f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_space_th_2_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2690_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_space_th_3_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2691_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_space_th_3_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2692_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_space_th_4_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2693_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_space_th_4_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2694_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_space_th_5_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2695_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_space_th_5_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2696_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_space_th_6_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2697_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_space_th_6_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2698_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_space_th_7_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2699_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_space_th_7_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_269a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_amp_ratio_0:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_269b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_amp_ratio_1:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_269c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_amp_ratio_2:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_269d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_amp_ratio_3:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_269e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_amp_ratio_4:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_269f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_amp_ratio_5:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_26a0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_amp_ratio_6:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_26a1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_amp_ratio_7:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_26a2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_precursor_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_26a3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_precursor_11_8:4;
        RBus_UInt32  fs2_wpost_size_11:1;
        RBus_UInt32  fs2_wpost_size2_11:1;
        RBus_UInt32  fs2_wp_post_size_11:1;
        RBus_UInt32  fs2_wpost_start_11:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_26a4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_force_width:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_26a5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_preload_on:1;
        RBus_UInt32  fs2_wm_start_sel:1;
        RBus_UInt32  fs2_tr_reset_en:1;
        RBus_UInt32  fs2_addr_pl_offset:5;
        RBus_UInt32  res1:24;
    };
}atsc_addr_26a6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_struc_sel:1;
        RBus_UInt32  fs2_wpost_start_en:1;
        RBus_UInt32  fs2_post_ram_off:1;
        RBus_UInt32  fs2_wpost_start_4_0:5;
        RBus_UInt32  res1:24;
    };
}atsc_addr_26a7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_wpost_start_10_5:6;
        RBus_UInt32  fs2_wpost_size_1_0:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_26a8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_wpost_size_9_2:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_26a9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_wpost_size_10:1;
        RBus_UInt32  fs2_wpost_size2_6_0:7;
        RBus_UInt32  res1:24;
    };
}atsc_addr_26aa_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_wpost_size2_10_7:4;
        RBus_UInt32  fs2_corr_th_post_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_26ab_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_corr_th_post_11_4:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_26ac_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_corr_th_post_12:1;
        RBus_UInt32  fs2_wp_post_size_6_0:7;
        RBus_UInt32  res1:24;
    };
}atsc_addr_26ad_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_search_en:1;
        RBus_UInt32  fs2_parallel_ram_off:1;
        RBus_UInt32  fs2_wparallel_size_5_0:6;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2060_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_wparallel_size_10_6:5;
        RBus_UInt32  fs2_wparallel_size2_2_0:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2061_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_wparallel_size2_10_3:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2062_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_corr_th_parallel_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2063_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_corr_th_parallel_12_8:5;
        RBus_UInt32  fs2_wp_parallel_size_2_0:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2064_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_wp_parallel_size_10_3:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2065_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_pre_echo_num_th:3;
        RBus_UInt32  fs2_post_echo_num_th:3;
        RBus_UInt32  fs2_ffe_struc_sel_opt1_1_0:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2066_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_ffe_struc_sel_opt1_2:1;
        RBus_UInt32  fs2_ffe_struc_sel_opt2:3;
        RBus_UInt32  fs2_ffe_struc_sel_opt3:3;
        RBus_UInt32  fs2_ffe_struc_sel_opt0_0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2067_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_ffe_struc_sel_opt0_2_1:2;
        RBus_UInt32  res1:4;
        RBus_UInt32  fs2_ffe_sp_hold_opt1:1;
        RBus_UInt32  fs2_ffe_sp_hold_opt2:1;
        RBus_UInt32  res2:24;
    };
}atsc_addr_2068_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_ffe_sp_hold_opt3:1;
        RBus_UInt32  fs2_ffe_sp_hold_opt0:1;
        RBus_UInt32  fs2_eq_auto_struc_en:1;
        RBus_UInt32  fs2_eq_auto_ffe_sp_hold_en:1;
        RBus_UInt32  fs2_wparallel_size_11:1;
        RBus_UInt32  fs2_wparallel_size2_11:1;
        RBus_UInt32  fs2_wp_parallel_size_11:1;
        RBus_UInt32  fs2_auto_switch_opt:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2069_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_stage_length_1076_ini_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_206a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_stage_length_1076_ini_10_8:3;
        RBus_UInt32  stage_length_1076_ini_opt1_4_0:5;
        RBus_UInt32  res1:24;
    };
}atsc_addr_206b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  stage_length_1076_ini_opt1_10_5:6;
        RBus_UInt32  stage_length_1076_ini_opt2_1_0:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_206c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  stage_length_1076_ini_opt2_9_2:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_206d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  stage_length_1076_ini_opt2_10:1;
        RBus_UInt32  stage_length_1076_ini_opt3_6_0:7;
        RBus_UInt32  res1:24;
    };
}atsc_addr_206e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  stage_length_1076_ini_opt3_10_7:4;
        RBus_UInt32  stage_length_1076_ini_opt0_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_206f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  stage_length_1076_ini_opt0_10_4:7;
        RBus_UInt32  ffe_in_ptr_ini_opt1_0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2070_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_in_ptr_ini_opt1_8_1:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2071_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_in_ptr_ini_opt1_13_9:5;
        RBus_UInt32  ffe_in_ptr_ini_opt2_2_0:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2072_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_in_ptr_ini_opt2_10_3:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2073_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_in_ptr_ini_opt2_13_11:3;
        RBus_UInt32  ffe_in_ptr_ini_opt3_4_0:5;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2074_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_in_ptr_ini_opt3_12_5:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2075_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_in_ptr_ini_opt3_13:1;
        RBus_UInt32  ffe_in_ptr_ini_opt0_6_0:7;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2076_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_in_ptr_ini_opt0_13_7:7;
        RBus_UInt32  res1:25;
    };
}atsc_addr_2077_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_addr_th1_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2eb9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_addr_th1_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2eba_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_addr_th2_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ebb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_addr_th2_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2ebc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_addr_th3_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ebd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_addr_th3_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2ebe_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_addr_th4_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ebf_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_addr_th4_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2ec0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_addr_th5_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ec1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_addr_th5_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2ec2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_addr_th6_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ec3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_addr_th6_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2ec4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_th_1_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ec5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_th_1_12_8:5;
        RBus_UInt32  res1:27;
    };
}atsc_addr_2ec6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_th_2_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ec7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_th_2_12_8:5;
        RBus_UInt32  res1:27;
    };
}atsc_addr_2ec8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_th_3_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ec9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_th_3_12_8:5;
        RBus_UInt32  res1:27;
    };
}atsc_addr_2eca_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_th_4_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ecb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_th_4_12_8:5;
        RBus_UInt32  res1:27;
    };
}atsc_addr_2ecc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_th_5_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ecd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_th_5_12_8:5;
        RBus_UInt32  res1:27;
    };
}atsc_addr_2ece_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_th_6_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ecf_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_th_6_12_8:5;
        RBus_UInt32  res1:27;
    };
}atsc_addr_2ed0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_th_7_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ed1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_th_7_12_8:5;
        RBus_UInt32  res1:27;
    };
}atsc_addr_2ed2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_addr_ini_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ed3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_addr_ini_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2ed4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_main_addr_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ed5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_main_addr_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2ed6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_segment_counter_opt0_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ed7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_segment_counter_opt0_8:1;
        RBus_UInt32  fsm_segment_counter_opt1_6_0:7;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ed8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_segment_counter_opt1_8_7:2;
        RBus_UInt32  fsm_segment_counter_opt2_5_0:6;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ed9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_segment_counter_opt2_8_6:3;
        RBus_UInt32  fsm_segment_counter_opt3_4_0:5;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2eda_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_segment_counter_opt3_8_5:4;
        RBus_UInt32  fsm_symbol_counter_opt0_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2edb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_symbol_counter_opt0_9_4:6;
        RBus_UInt32  fsm_symbol_counter_opt1_1_0:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2edc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_symbol_counter_opt1_9_2:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2edd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_symbol_counter_opt2_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ede_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_symbol_counter_opt2_9_8:2;
        RBus_UInt32  fsm_symbol_counter_opt3_5_0:6;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2edf_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_symbol_counter_opt3_9_6:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2ee0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  field_sync_lock_delay_opt0_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ee1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  field_sync_lock_delay_opt0_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ee2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  field_sync_lock_delay_opt1_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ee3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  field_sync_lock_delay_opt1_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ee4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  field_sync_lock_delay_opt2_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ee5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  field_sync_lock_delay_opt2_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ee6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  field_sync_lock_delay_opt3_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ee7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  field_sync_lock_delay_opt3_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ee8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_main_head_opt0_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ee9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_main_head_opt0_8:1;
        RBus_UInt32  ffe_main_head_opt1_6_0:7;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2eea_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_main_head_opt1_8_7:2;
        RBus_UInt32  ffe_main_head_opt2_5_0:6;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2eeb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_main_head_opt2_8_6:3;
        RBus_UInt32  ffe_main_head_opt3_4_0:5;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2eec_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_main_head_opt3_8_5:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2eed_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_main_end_opt0_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2eee_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_main_end_opt0_8:1;
        RBus_UInt32  ffe_main_end_opt1_6_0:7;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2eef_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_main_end_opt1_8_7:2;
        RBus_UInt32  ffe_main_end_opt2_5_0:6;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ef0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_main_end_opt2_8_6:3;
        RBus_UInt32  ffe_main_end_opt3_4_0:5;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ef1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_main_end_opt3_8_5:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2ef2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_force_main_width_exp:3;
        RBus_UInt32  res1:29;
    };
}atsc_addr_2ef3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_precursor_opt0_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2078_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_precursor_opt0_11_8:4;
        RBus_UInt32  fs2_precursor_opt1_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2079_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_precursor_opt1_11_4:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_207a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_precursor_opt2_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_207b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_precursor_opt2_11_8:4;
        RBus_UInt32  fs2_precursor_opt3_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_207c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_precursor_opt3_11_4:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_207d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_cr_offset_dif_cond_32:1;
        RBus_UInt32  res1:3;
        RBus_UInt32  cr_adp_bw_en:1;
        RBus_UInt32  cr_adp_state_clear_en:1;
        RBus_UInt32  res2:26;
    };
}atsc_addr_2ef8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_react_state:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2ef9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_start_state:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2efa_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_load_state:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2efb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_cr_offset_dif_cond_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ef4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_cr_offset_dif_cond_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ef5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_cr_offset_dif_cond_23_16:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ef6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_cr_offset_dif_cond_31_24:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ef7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_fs2_parallel_amp_0_cond_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2efc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_fs2_parallel_amp_0_cond_12_8:5;
        RBus_UInt32  res1:27;
    };
}atsc_addr_2efd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_fs2_parallel_addr_0_cond_head_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2efe_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_fs2_parallel_addr_0_cond_head_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2eff_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_fs2_parallel_addr_0_cond_end_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e07_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_fs2_parallel_addr_0_cond_end_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2e08_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_offset_dif_record_size_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e09_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_offset_dif_record_size_10_8:3;
        RBus_UInt32  res1:29;
    };
}atsc_addr_2e0a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_cr_fmu_upd_cnt_th_default:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e0b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_cr_lpf_shift_default_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e0c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_cr_lpf_shift_default_11_8:4;
        RBus_UInt32  cr_adp_bw_cr_pmu_comp1_default:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e0d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_fsm_cr_fmu_32_default:4;
        RBus_UInt32  cr_adp_bw_fsm_cr_fmu_33_default:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e0e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_fsm_cr_fmu_34_default:4;
        RBus_UInt32  cr_adp_bw_fsm_cr_pmu_32_default:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e0f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_fsm_cr_pmu_33_default:4;
        RBus_UInt32  cr_adp_bw_fsm_cr_pmu_34_default:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_cr_fmu_upd_cnt_th_echo:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_cr_lpf_shift_echo_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_cr_lpf_shift_echo_11_8:4;
        RBus_UInt32  cr_adp_bw_cr_pmu_comp1_echo:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_fsm_cr_fmu_32_echo:4;
        RBus_UInt32  cr_adp_bw_fsm_cr_fmu_33_echo:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_fsm_cr_fmu_34_echo:4;
        RBus_UInt32  cr_adp_bw_fsm_cr_pmu_32_echo:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_fsm_cr_pmu_33_echo:4;
        RBus_UInt32  cr_adp_bw_fsm_cr_pmu_34_echo:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_cr_fmu_upd_cnt_th_aci:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_cr_lpf_shift_aci_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_cr_lpf_shift_aci_11_8:4;
        RBus_UInt32  cr_adp_bw_cr_pmu_comp1_aci:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e19_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_fsm_cr_fmu_32_aci:4;
        RBus_UInt32  cr_adp_bw_fsm_cr_fmu_33_aci:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e1a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_fsm_cr_fmu_34_aci:4;
        RBus_UInt32  cr_adp_bw_fsm_cr_pmu_32_aci:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e1b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_fsm_cr_pmu_33_aci:4;
        RBus_UInt32  cr_adp_bw_fsm_cr_pmu_34_aci:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e1c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_cr_fmu_upd_cnt_th_no_echo:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e1d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_cr_lpf_shift_no_echo_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e1e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_cr_lpf_shift_no_echo_11_8:4;
        RBus_UInt32  cr_adp_bw_cr_pmu_comp1_no_echo:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e1f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_fsm_cr_fmu_32_no_echo:4;
        RBus_UInt32  cr_adp_bw_fsm_cr_fmu_33_no_echo:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_fsm_cr_fmu_34_no_echo:4;
        RBus_UInt32  cr_adp_bw_fsm_cr_pmu_32_no_echo:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_fsm_cr_pmu_33_no_echo:4;
        RBus_UInt32  cr_adp_bw_fsm_cr_pmu_34_no_echo:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_cr_fmu_upd_cnt_th_ebs:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_cr_lpf_shift_ebs_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e24_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_cr_lpf_shift_ebs_11_8:4;
        RBus_UInt32  cr_adp_bw_cr_pmu_comp1_ebs:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e25_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_fsm_cr_fmu_32_ebs:4;
        RBus_UInt32  cr_adp_bw_fsm_cr_fmu_33_ebs:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e26_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_fsm_cr_fmu_34_ebs:4;
        RBus_UInt32  cr_adp_bw_fsm_cr_pmu_32_ebs:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e27_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_adp_bw_fsm_cr_pmu_33_ebs:4;
        RBus_UInt32  cr_adp_bw_fsm_cr_pmu_34_ebs:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e28_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  corr_th1_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_26b0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  corr_th1_12_8:5;
        RBus_UInt32  res1:27;
    };
}atsc_addr_26b1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pn63_flag_par:1;
        RBus_UInt32  pn63_flag_source_sel:1;
        RBus_UInt32  pn63_flag_type_sel:2;
        RBus_UInt32  pn63_flag_error_0_en:1;
        RBus_UInt32  pn63_flag_error_2_en:1;
        RBus_UInt32  pn63_flag_error_02_en:1;
        RBus_UInt32  pn63_flag_error_and_or:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_26b2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pn63_flag_load_delay_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_26b3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pn63_flag_load_delay_13_8:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_26b4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs_lock_sel:1;
        RBus_UInt32  fs_pn63_re_find_en:1;
        RBus_UInt32  search_cursor_en:1;
        RBus_UInt32  res1:29;
    };
}atsc_addr_26b5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  field_sync_lock_delay_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_26b6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  field_sync_lock_delay_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_26b7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  corr_th2_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_26b8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  corr_th2_10_8:3;
        RBus_UInt32  training_reserved_en:1;
        RBus_UInt32  res1:28;
    };
}atsc_addr_26b9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch_esti_en:1;
        RBus_UInt32  ch_esti_seg_6_0:7;
        RBus_UInt32  res1:24;
    };
}atsc_addr_26ba_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch_esti_seg_8_7:2;
        RBus_UInt32  res1:30;
    };
}atsc_addr_26bb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch_esti_volume:6;
        RBus_UInt32  ch_esti_sym_1_0:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_26bc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch_esti_sym_9_2:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_26bd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch_esti_rd_en:1;
        RBus_UInt32  ch_esti_rd_add_6_0:7;
        RBus_UInt32  res1:24;
    };
}atsc_addr_26be_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch_esti_rd_add_9_7:3;
        RBus_UInt32  ch_esti_sel:1;
        RBus_UInt32  ch_esti_int_par:1;
        RBus_UInt32  res1:27;
    };
}atsc_addr_26bf_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  field_tr_offset:5;
        RBus_UInt32  deltaf_ratio_2_0:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_26c0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  deltaf_ratio_6_3:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_26c1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs_tr_sel:1;
        RBus_UInt32  fs_tr_corr_sel:1;
        RBus_UInt32  fs_tr2_mode_sel:1;
        RBus_UInt32  fs_tr2_corr_th_4_0:5;
        RBus_UInt32  res1:24;
    };
}atsc_addr_26c2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs_tr2_corr_th_12_5:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_26c3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs_tr2_diff_ratio:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_26c4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs_tr2_max_diff_th:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_26c5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs_tr2_max_offset:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_26c6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs_tr2_path_diff_offset:3;
        RBus_UInt32  res1:29;
    };
}atsc_addr_26c7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_in_ptr_ini_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_26d0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_in_ptr_ini_13_8:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_26d1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_ro_coeff_add_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2701_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_ro_coeff_add_12_8:5;
        RBus_UInt32  ffe_ro_sum_add_2_0:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2702_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_ro_sum_add_8_3:6;
        RBus_UInt32  ffe_ro_max_add_1_0:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2703_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_ro_max_add_8_2:7;
        RBus_UInt32  ffe_ro_gc_add_0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2704_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_ro_gc_add_6_1:6;
        RBus_UInt32  ffe_ro_muc_add_1_0:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2705_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_ro_muc_add_7_2:6;
        RBus_UInt32  ffe_ro_gc_en_ind_add_1_0:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2706_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_ro_gc_en_ind_add_6_2:5;
        RBus_UInt32  ffe_ro_gc_dis_ind_add_2_0:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2707_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_ro_gc_dis_ind_add_5_3:3;
        RBus_UInt32  res1:29;
    };
}atsc_addr_27fe_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_mu_comp_on:1;
        RBus_UInt32  ffe_mu_comp_exp:1;
        RBus_UInt32  ffe_main_head_5_0:6;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2708_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_main_head_8_6:3;
        RBus_UInt32  ffe_main_end_2_0:3;
        RBus_UInt32  ffe_out_clip_ind_rst:1;
        RBus_UInt32  ffe_in_sel:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2709_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_main_end_8_3:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_27ff_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_sp_coeff_max_en_th_11:1;
        RBus_UInt32  ffe_struc_sel:3;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2713_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_sp_hold:1;
        RBus_UInt32  ffe_sp_ctrl_sel:1;
        RBus_UInt32  ffe_sp_dc_trig_r:1;
        RBus_UInt32  ffe_sp_coeff_sum_max_clr:1;
        RBus_UInt32  ffe_cluster_addr_r_0_8:1;
        RBus_UInt32  ffe_cluster_addr_r_1_8:1;
        RBus_UInt32  ffe_cluster_addr_r_2_8:1;
        RBus_UInt32  ffe_cluster_addr_r_3_8:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_270a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_cluster_addr_r_0_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fca_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_cluster_addr_r_1_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_270b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_cluster_addr_r_2_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_270c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_cluster_addr_r_3_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_270d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_sp_start_field_exp:4;
        RBus_UInt32  ffe_sp_prd_field_exp:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_270e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_sp_check_seg_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_270f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_sp_check_seg_8:1;
        RBus_UInt32  ffe_sp_coeff_max_dis_th_6_0:7;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2710_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_sp_coeff_max_dis_th_11_7:5;
        RBus_UInt32  ffe_sp_coeff_max_en_th_2_0:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2711_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_sp_coeff_max_en_th_10_3:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2712_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_en:1;
        RBus_UInt32  ffe_gc_coeff_sum_max_clr:1;
        RBus_UInt32  ffe_gc_tr_odd_off_en:1;
        RBus_UInt32  ffe_gc_main_protect_en:1;
        RBus_UInt32  ffe_gc_on_field_exp:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2714_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_start_field_exp:4;
        RBus_UInt32  ffe_gc_prd_field_exp:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2715_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_check_seg_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2716_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_check_seg_8:1;
        RBus_UInt32  ffe_gc_en_sum_th_0_6_0:7;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2717_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_en_sum_th_0_11_7:5;
        RBus_UInt32  ffe_gc_en_sum_th_1_2_0:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2718_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_en_sum_th_1_10_3:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2719_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_en_sum_th_1_11:1;
        RBus_UInt32  ffe_gc_en_sum_th_2_6_0:7;
        RBus_UInt32  res1:24;
    };
}atsc_addr_271a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_en_sum_th_2_11_7:5;
        RBus_UInt32  ffe_gc_dis_th_2_0:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_271b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_dis_th_10_3:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_271c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_dis_th_11:1;
        RBus_UInt32  ffe_gc_en_cnt_lb_0:5;
        RBus_UInt32  ffe_gc_en_cnt_lb_1_1_0:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_271d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_en_cnt_lb_1_4_2:3;
        RBus_UInt32  ffe_gc_en_cnt_lb_2:5;
        RBus_UInt32  res1:24;
    };
}atsc_addr_271e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_dis2en_cnt_lb:5;
        RBus_UInt32  ffe_gc_dis_cnt_lb_2_0:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_271f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_dis_cnt_lb_4_3:2;
        RBus_UInt32  ffe_gc_range_exp:2;
        RBus_UInt32  ffe_gc_dis2en_num_ub_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2720_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_dis2en_num_ub_6_4:3;
        RBus_UInt32  res1:29;
    };
}atsc_addr_2721_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_sync_space_even_en_0:1;
        RBus_UInt32  ffe_sync_space_even_en_1:1;
        RBus_UInt32  ffe_sync_space_even_en_2:1;
        RBus_UInt32  ffe_sync_space_even_en_3:1;
        RBus_UInt32  ffe_sync_space_even_en_4:1;
        RBus_UInt32  ffe_sync_space_even_en_5:1;
        RBus_UInt32  ffe_sync_space_even_en_6:1;
        RBus_UInt32  ffe_sync_space_even_en_7:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2722_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_sync_space_even_en_8:1;
        RBus_UInt32  ffe_sync_space_even_en_9:1;
        RBus_UInt32  ffe_sync_space_even_en_10:1;
        RBus_UInt32  ffe_sync_space_even_en_11:1;
        RBus_UInt32  ffe_sync_space_even_en_12:1;
        RBus_UInt32  ffe_sync_space_even_en_13:1;
        RBus_UInt32  ffe_sync_space_even_en_14:1;
        RBus_UInt32  ffe_sync_space_even_en_15:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2723_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_sync_space_even_en_16:1;
        RBus_UInt32  ffe_sync_space_even_en_17:1;
        RBus_UInt32  ffe_sync_space_even_en_18:1;
        RBus_UInt32  ffe_sync_space_even_en_19:1;
        RBus_UInt32  ffe_sync_space_even_en_20:1;
        RBus_UInt32  ffe_sync_space_even_en_21:1;
        RBus_UInt32  ffe_sync_space_even_en_22:1;
        RBus_UInt32  ffe_sync_space_even_en_23:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2724_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_sync_space_even_en_24:1;
        RBus_UInt32  ffe_sync_space_even_en_25:1;
        RBus_UInt32  ffe_sync_space_even_en_26:1;
        RBus_UInt32  ffe_sync_space_even_en_27:1;
        RBus_UInt32  ffe_sync_space_even_en_28:1;
        RBus_UInt32  ffe_sync_space_even_en_29:1;
        RBus_UInt32  ffe_sync_space_even_en_30:1;
        RBus_UInt32  ffe_sync_space_even_en_31:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2725_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_sync_space_even_en_32:1;
        RBus_UInt32  ffe_sync_space_even_en_33:1;
        RBus_UInt32  ffe_sync_space_even_en_34:1;
        RBus_UInt32  ffe_sync_space_even_en_35:1;
        RBus_UInt32  ffe_sync_space_even_en_36:1;
        RBus_UInt32  ffe_sync_space_even_en_37:1;
        RBus_UInt32  ffe_sync_space_even_en_38:1;
        RBus_UInt32  ffe_sync_space_even_en_39:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2726_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_sync_space_even_en_40:1;
        RBus_UInt32  ffe_sync_space_even_en_41:1;
        RBus_UInt32  ffe_sync_space_even_en_42:1;
        RBus_UInt32  ffe_sync_space_even_en_43:1;
        RBus_UInt32  ffe_sync_space_even_en_44:1;
        RBus_UInt32  ffe_sync_space_even_en_45:1;
        RBus_UInt32  ffe_sync_space_even_en_46:1;
        RBus_UInt32  ffe_sync_space_even_en_47:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2727_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_sync_space_even_en_48:1;
        RBus_UInt32  ffe_sync_space_even_en_49:1;
        RBus_UInt32  ffe_sync_space_even_en_50:1;
        RBus_UInt32  ffe_sync_space_even_en_51:1;
        RBus_UInt32  ffe_sync_space_even_en_52:1;
        RBus_UInt32  ffe_sync_space_even_en_53:1;
        RBus_UInt32  ffe_sync_space_even_en_54:1;
        RBus_UInt32  ffe_sync_space_even_en_55:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fc1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_sync_space_even_en_56:1;
        RBus_UInt32  ffe_sync_space_even_en_57:1;
        RBus_UInt32  ffe_sync_space_even_en_58:1;
        RBus_UInt32  ffe_sync_space_even_en_59:1;
        RBus_UInt32  ffe_sync_space_even_en_60:1;
        RBus_UInt32  ffe_sync_space_even_en_61:1;
        RBus_UInt32  ffe_sync_space_even_en_62:1;
        RBus_UInt32  ffe_sync_space_even_en_63:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fc2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_sync_space_even_en_64:1;
        RBus_UInt32  ffe_sync_space_even_en_65:1;
        RBus_UInt32  ffe_sync_space_even_en_66:1;
        RBus_UInt32  ffe_sync_space_even_en_67:1;
        RBus_UInt32  ffe_sync_space_even_en_68:1;
        RBus_UInt32  ffe_sync_space_even_en_69:1;
        RBus_UInt32  ffe_sync_space_even_en_70:1;
        RBus_UInt32  ffe_sync_space_even_en_71:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_28f0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_sync_space_even_en_72:1;
        RBus_UInt32  ffe_sync_space_even_en_73:1;
        RBus_UInt32  ffe_sync_space_even_en_74:1;
        RBus_UInt32  ffe_sync_space_even_en_75:1;
        RBus_UInt32  ffe_sync_space_even_en_76:1;
        RBus_UInt32  ffe_sync_space_even_en_77:1;
        RBus_UInt32  ffe_sync_space_even_en_78:1;
        RBus_UInt32  ffe_sync_space_even_en_79:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_28f1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_sync_space_even_en_80:1;
        RBus_UInt32  ffe_sync_space_even_en_81:1;
        RBus_UInt32  ffe_sync_space_even_en_82:1;
        RBus_UInt32  ffe_sync_space_even_en_83:1;
        RBus_UInt32  ffe_sync_space_even_en_84:1;
        RBus_UInt32  ffe_sync_space_even_en_85:1;
        RBus_UInt32  ffe_sync_space_even_en_86:1;
        RBus_UInt32  ffe_sync_space_even_en_87:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_28f2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_sync_space_even_en_88:1;
        RBus_UInt32  ffe_sync_space_even_en_89:1;
        RBus_UInt32  ffe_sync_space_even_en_90:1;
        RBus_UInt32  ffe_sync_space_even_en_91:1;
        RBus_UInt32  ffe_sync_space_even_en_92:1;
        RBus_UInt32  ffe_sync_space_even_en_93:1;
        RBus_UInt32  ffe_sync_space_even_en_94:1;
        RBus_UInt32  ffe_sync_space_even_en_95:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_28f3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_sync_space_odd_en_0:1;
        RBus_UInt32  ffe_sync_space_odd_en_1:1;
        RBus_UInt32  ffe_sync_space_odd_en_2:1;
        RBus_UInt32  ffe_sync_space_odd_en_3:1;
        RBus_UInt32  ffe_sync_space_odd_en_4:1;
        RBus_UInt32  ffe_sync_space_odd_en_5:1;
        RBus_UInt32  ffe_sync_space_odd_en_6:1;
        RBus_UInt32  ffe_sync_space_odd_en_7:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2728_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_sync_space_odd_en_8:1;
        RBus_UInt32  ffe_sync_space_odd_en_9:1;
        RBus_UInt32  ffe_sync_space_odd_en_10:1;
        RBus_UInt32  ffe_sync_space_odd_en_11:1;
        RBus_UInt32  ffe_sync_space_odd_en_12:1;
        RBus_UInt32  ffe_sync_space_odd_en_13:1;
        RBus_UInt32  ffe_sync_space_odd_en_14:1;
        RBus_UInt32  ffe_sync_space_odd_en_15:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2729_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_sync_space_odd_en_16:1;
        RBus_UInt32  ffe_sync_space_odd_en_17:1;
        RBus_UInt32  ffe_sync_space_odd_en_18:1;
        RBus_UInt32  ffe_sync_space_odd_en_19:1;
        RBus_UInt32  ffe_sync_space_odd_en_20:1;
        RBus_UInt32  ffe_sync_space_odd_en_21:1;
        RBus_UInt32  ffe_sync_space_odd_en_22:1;
        RBus_UInt32  ffe_sync_space_odd_en_23:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_272a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_sync_space_odd_en_24:1;
        RBus_UInt32  ffe_sync_space_odd_en_25:1;
        RBus_UInt32  ffe_sync_space_odd_en_26:1;
        RBus_UInt32  ffe_sync_space_odd_en_27:1;
        RBus_UInt32  ffe_sync_space_odd_en_28:1;
        RBus_UInt32  ffe_sync_space_odd_en_29:1;
        RBus_UInt32  ffe_sync_space_odd_en_30:1;
        RBus_UInt32  ffe_sync_space_odd_en_31:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_272b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_sync_space_odd_en_32:1;
        RBus_UInt32  ffe_sync_space_odd_en_33:1;
        RBus_UInt32  ffe_sync_space_odd_en_34:1;
        RBus_UInt32  ffe_sync_space_odd_en_35:1;
        RBus_UInt32  ffe_sync_space_odd_en_36:1;
        RBus_UInt32  ffe_sync_space_odd_en_37:1;
        RBus_UInt32  ffe_sync_space_odd_en_38:1;
        RBus_UInt32  ffe_sync_space_odd_en_39:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_272c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_sync_space_odd_en_40:1;
        RBus_UInt32  ffe_sync_space_odd_en_41:1;
        RBus_UInt32  ffe_sync_space_odd_en_42:1;
        RBus_UInt32  ffe_sync_space_odd_en_43:1;
        RBus_UInt32  ffe_sync_space_odd_en_44:1;
        RBus_UInt32  ffe_sync_space_odd_en_45:1;
        RBus_UInt32  ffe_sync_space_odd_en_46:1;
        RBus_UInt32  ffe_sync_space_odd_en_47:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_272d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_sync_space_odd_en_48:1;
        RBus_UInt32  ffe_sync_space_odd_en_49:1;
        RBus_UInt32  ffe_sync_space_odd_en_50:1;
        RBus_UInt32  ffe_sync_space_odd_en_51:1;
        RBus_UInt32  ffe_sync_space_odd_en_52:1;
        RBus_UInt32  ffe_sync_space_odd_en_53:1;
        RBus_UInt32  ffe_sync_space_odd_en_54:1;
        RBus_UInt32  ffe_sync_space_odd_en_55:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fc3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_sync_space_odd_en_56:1;
        RBus_UInt32  ffe_sync_space_odd_en_57:1;
        RBus_UInt32  ffe_sync_space_odd_en_58:1;
        RBus_UInt32  ffe_sync_space_odd_en_59:1;
        RBus_UInt32  ffe_sync_space_odd_en_60:1;
        RBus_UInt32  ffe_sync_space_odd_en_61:1;
        RBus_UInt32  ffe_sync_space_odd_en_62:1;
        RBus_UInt32  ffe_sync_space_odd_en_63:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fc4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_sync_space_odd_en_64:1;
        RBus_UInt32  ffe_sync_space_odd_en_65:1;
        RBus_UInt32  ffe_sync_space_odd_en_66:1;
        RBus_UInt32  ffe_sync_space_odd_en_67:1;
        RBus_UInt32  ffe_sync_space_odd_en_68:1;
        RBus_UInt32  ffe_sync_space_odd_en_69:1;
        RBus_UInt32  ffe_sync_space_odd_en_70:1;
        RBus_UInt32  ffe_sync_space_odd_en_71:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_28f4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_sync_space_odd_en_72:1;
        RBus_UInt32  ffe_sync_space_odd_en_73:1;
        RBus_UInt32  ffe_sync_space_odd_en_74:1;
        RBus_UInt32  ffe_sync_space_odd_en_75:1;
        RBus_UInt32  ffe_sync_space_odd_en_76:1;
        RBus_UInt32  ffe_sync_space_odd_en_77:1;
        RBus_UInt32  ffe_sync_space_odd_en_78:1;
        RBus_UInt32  ffe_sync_space_odd_en_79:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_28f5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_sync_space_odd_en_80:1;
        RBus_UInt32  ffe_sync_space_odd_en_81:1;
        RBus_UInt32  ffe_sync_space_odd_en_82:1;
        RBus_UInt32  ffe_sync_space_odd_en_83:1;
        RBus_UInt32  ffe_sync_space_odd_en_84:1;
        RBus_UInt32  ffe_sync_space_odd_en_85:1;
        RBus_UInt32  ffe_sync_space_odd_en_86:1;
        RBus_UInt32  ffe_sync_space_odd_en_87:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_28f6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_sync_space_odd_en_88:1;
        RBus_UInt32  ffe_sync_space_odd_en_89:1;
        RBus_UInt32  ffe_sync_space_odd_en_90:1;
        RBus_UInt32  ffe_sync_space_odd_en_91:1;
        RBus_UInt32  ffe_sync_space_odd_en_92:1;
        RBus_UInt32  ffe_sync_space_odd_en_93:1;
        RBus_UInt32  ffe_sync_space_odd_en_94:1;
        RBus_UInt32  ffe_sync_space_odd_en_95:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_28f7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_tr_coeff_th:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_272e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_dd_coeff_th:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_272f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_tr_coeff_en_0:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_1:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_2:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_3:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_4:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_5:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_6:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_7:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2730_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_tr_coeff_en_8:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_9:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_10:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_11:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_12:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_13:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_14:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_15:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2731_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_tr_coeff_en_16:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_17:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_18:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_19:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_20:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_21:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_22:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_23:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2732_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_tr_coeff_en_24:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_25:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_26:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_27:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_28:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_29:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_30:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_31:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2733_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_tr_coeff_en_32:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_33:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_34:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_35:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_36:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_37:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_38:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_39:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2734_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_tr_coeff_en_40:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_41:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_42:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_43:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_44:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_45:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_46:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_47:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2735_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_tr_coeff_en_48:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_49:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_50:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_51:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_52:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_53:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_54:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_55:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fc5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_tr_coeff_en_56:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_57:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_58:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_59:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_60:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_61:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_62:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_63:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fc6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_tr_coeff_en_64:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_65:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_66:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_67:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_68:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_69:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_70:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_71:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fcb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_tr_coeff_en_72:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_73:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_74:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_75:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_76:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_77:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_78:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_79:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fcc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_tr_coeff_en_80:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_81:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_82:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_83:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_84:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_85:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_86:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_87:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fcd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_tr_coeff_en_88:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_89:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_90:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_91:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_92:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_93:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_94:1;
        RBus_UInt32  ffe_gc_tr_coeff_en_95:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fce_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_dd_coeff_en_0:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_1:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_2:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_3:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_4:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_5:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_6:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_7:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2736_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_dd_coeff_en_8:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_9:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_10:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_11:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_12:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_13:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_14:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_15:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2737_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_dd_coeff_en_16:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_17:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_18:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_19:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_20:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_21:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_22:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_23:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2738_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_dd_coeff_en_24:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_25:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_26:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_27:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_28:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_29:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_30:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_31:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2739_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_dd_coeff_en_32:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_33:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_34:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_35:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_36:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_37:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_38:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_39:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_273a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_dd_coeff_en_40:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_41:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_42:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_43:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_44:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_45:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_46:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_47:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_273b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_dd_coeff_en_48:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_49:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_50:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_51:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_52:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_53:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_54:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_55:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fc7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_dd_coeff_en_56:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_57:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_58:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_59:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_60:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_61:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_62:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_63:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fc8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_dd_coeff_en_64:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_65:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_66:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_67:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_68:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_69:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_70:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_71:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fcf_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_dd_coeff_en_72:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_73:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_74:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_75:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_76:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_77:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_78:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_79:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fd1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_dd_coeff_en_80:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_81:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_82:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_83:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_84:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_85:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_86:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_87:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fd2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_gc_dd_coeff_en_88:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_89:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_90:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_91:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_92:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_93:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_94:1;
        RBus_UInt32  ffe_gc_dd_coeff_en_95:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fd3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_muc_en:1;
        RBus_UInt32  ffe_muc_start_field_exp:4;
        RBus_UInt32  ffe_muc_field_size_exp_2_0:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_273c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_muc_cnt_size:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fc9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_muc_field_size_exp_3:1;
        RBus_UInt32  ffe_muc_field_cnt_seg_6_0:7;
        RBus_UInt32  res1:24;
    };
}atsc_addr_273d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_muc_field_cnt_seg_8_7:2;
        RBus_UInt32  ffe_muc_update_type:1;
        RBus_UInt32  ffe_muc_mu_bn_slow_en:1;
        RBus_UInt32  ffe_muc_main_protect_en:1;
        RBus_UInt32  ffe_muc_group_sum_th_0_2_0:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_273e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_muc_group_sum_th_0_10_3:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_273f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_muc_group_sum_th_0_11:1;
        RBus_UInt32  ffe_muc_group_sum_th_1_6_0:7;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2740_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_muc_group_sum_th_1_11_7:5;
        RBus_UInt32  ffe_muc_group_sum_th_2_2_0:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2741_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_muc_group_sum_th_2_10_3:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2742_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_muc_group_sum_th_2_11:1;
        RBus_UInt32  ffe_muc_group_sum_th_3_6_0:7;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2743_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_muc_group_sum_th_3_11_7:5;
        RBus_UInt32  ffe_muc_group_sum_th_4_2_0:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2744_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_muc_group_sum_th_4_10_3:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2745_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_muc_group_sum_th_4_11:1;
        RBus_UInt32  ffe_muc_mu_0:5;
        RBus_UInt32  ffe_muc_mu_1_1_0:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2746_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_muc_mu_1_4_2:3;
        RBus_UInt32  ffe_muc_mu_2:5;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2747_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_muc_mu_3:5;
        RBus_UInt32  ffe_muc_mu_4_2_0:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2748_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_muc_mu_4_4_3:2;
        RBus_UInt32  ffe_muc_mu_5:5;
        RBus_UInt32  ffe_muc_mu_main_0_0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2749_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_muc_mu_main_0_4_1:4;
        RBus_UInt32  ffe_muc_mu_main_1_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_274a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_muc_mu_main_1_4:1;
        RBus_UInt32  ffe_muc_mu_main_2:5;
        RBus_UInt32  ffe_muc_mu_main_3_1_0:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_274b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_muc_mu_main_3_4_2:3;
        RBus_UInt32  ffe_muc_mu_main_4:5;
        RBus_UInt32  res1:24;
    };
}atsc_addr_274c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_muc_mu_main_5:5;
        RBus_UInt32  ffe_muc_mu_bn_slow_0_2_0:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_274d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_muc_mu_bn_slow_0_4_3:2;
        RBus_UInt32  ffe_muc_mu_bn_slow_1:5;
        RBus_UInt32  ffe_muc_mu_bn_slow_2_0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_274e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_muc_mu_bn_slow_2_4_1:4;
        RBus_UInt32  ffe_muc_mu_bn_slow_3_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_274f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_muc_mu_bn_slow_3_4:1;
        RBus_UInt32  ffe_muc_mu_bn_slow_4:5;
        RBus_UInt32  ffe_muc_mu_bn_slow_5_1_0:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2750_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_muc_mu_bn_slow_5_4_2:3;
        RBus_UInt32  eqpt_on:1;
        RBus_UInt32  eqpt_h_hil_0_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2751_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqpt_h_hil_0_7_4:4;
        RBus_UInt32  eqpt_h_hil_2_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2752_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqpt_h_hil_2_7_4:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2753_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_ro_bank_add:3;
        RBus_UInt32  fbf_ro_group_add:3;
        RBus_UInt32  fbf_ro_tap_add_1_0:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2754_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_ro_tap_add_4_2:3;
        RBus_UInt32  fbf_ro_sum_add_4_0:5;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2755_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_ro_sum_add_6_5:2;
        RBus_UInt32  res1:30;
    };
}atsc_addr_2756_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  fbf_ro_gc_add:4;
        RBus_UInt32  fbf_ro_muc_add_2_0:3;
        RBus_UInt32  res2:24;
    };
}atsc_addr_2757_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_ro_muc_add_5_3:3;
        RBus_UInt32  fbf_ro_gc_en_ind_add_4_0:5;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2758_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_ro_gc_dis_ind_add:4;
        RBus_UInt32  fs_705_820_en:1;
        RBus_UInt32  eqout_sel:1;
        RBus_UInt32  pt_in_sel:1;
        RBus_UInt32  zd_viterbi_in_sel:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2759_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  slicer_in_sel:1;
        RBus_UInt32  eq_out_er_in_sel:1;
        RBus_UInt32  eq_out_mse_in_sel:1;
        RBus_UInt32  fbf_mu_comp_on:1;
        RBus_UInt32  fbf_mu_comp_exp:1;
        RBus_UInt32  fbf_main_end_2_0:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_275a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_main_end_4_3:2;
        RBus_UInt32  fbf_coeff_ub_en:1;
        RBus_UInt32  fbf_coeff_ub:4;
        RBus_UInt32  fbf_const_en:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_275b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_const_on_state:6;
        RBus_UInt32  fsm_fbf_const_seg_cnt_1_0:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_275c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_fbf_const_seg_cnt_8_2:7;
        RBus_UInt32  fbf_const_field_cnt_th_exp_0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_275d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_const_field_cnt_th_exp_3_1:3;
        RBus_UInt32  fbf_const_coeff_sum_th_4_0:5;
        RBus_UInt32  res1:24;
    };
}atsc_addr_275e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_const_coeff_sum_th_9_5:5;
        RBus_UInt32  fbf_update_th_2_0:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_275f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_update_th_10_3:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2760_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_update_th_14_11:4;
        RBus_UInt32  fbf_coeff_sum_sel:1;
        RBus_UInt32  fbf_const_ratio1_2_0:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2761_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_const_ratio1_3:1;
        RBus_UInt32  fbf_const_ratio2:4;
        RBus_UInt32  fbf_const_start_update_th1_2_0:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2762_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_const_start_update_th1_9_3:7;
        RBus_UInt32  fbf_const_start_update_th2_0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2763_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_const_start_update_th2_8_1:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2764_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_const_start_update_th2_9:1;
        RBus_UInt32  fbf_const_manu_val_6_0:7;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2765_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_const_manu_val_9_7:3;
        RBus_UInt32  fbf_const_manu_en:1;
        RBus_UInt32  fbf_const_exp:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2766_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_const_man:6;
        RBus_UInt32  fbf_const_lamda_sel:1;
        RBus_UInt32  fbf_const_lamda_max_0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2767_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_const_lamda_max_8_1:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2768_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_const_lamda_max_15_9:7;
        RBus_UInt32  fbf_const_mse_en:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2769_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_const_mse_sel:1;
        RBus_UInt32  fbf_const_mse_lamda_th_6_0:7;
        RBus_UInt32  res1:24;
    };
}atsc_addr_276a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_const_mse_lamda_th_13_7:7;
        RBus_UInt32  fbf_const_mse_lamda_0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_276b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_const_mse_lamda_8_1:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_276c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_const_mse_lamda_15_9:7;
        RBus_UInt32  fbf_muc_en:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_276d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_muc_start_field_exp:4;
        RBus_UInt32  fbf_muc_field_size_exp:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_276e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_muc_field_cnt_seg_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_276f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_muc_field_cnt_seg_8:1;
        RBus_UInt32  fbf_muc_update_type:1;
        RBus_UInt32  fbf_muc_mu_bn_slow_en:1;
        RBus_UInt32  fbf_muc_main_protect_en:1;
        RBus_UInt32  fbf_muc_group_sum_th_0_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2770_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_muc_group_sum_th_0_11_4:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2771_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_muc_group_sum_th_1_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2772_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_muc_group_sum_th_1_11_8:4;
        RBus_UInt32  fbf_muc_group_sum_th_2_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2773_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_muc_group_sum_th_2_11_4:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2774_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_muc_group_sum_th_3_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2775_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_muc_group_sum_th_3_11_8:4;
        RBus_UInt32  fbf_muc_group_sum_th_4_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2776_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_muc_group_sum_th_4_11_4:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2777_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_muc_mu_0:5;
        RBus_UInt32  fbf_muc_mu_1_2_0:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2778_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_muc_mu_1_4_3:2;
        RBus_UInt32  fbf_muc_mu_2:5;
        RBus_UInt32  fbf_muc_mu_3_0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2779_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_muc_mu_3_4_1:4;
        RBus_UInt32  fbf_muc_mu_4_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_277a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_muc_mu_4_4:1;
        RBus_UInt32  fbf_muc_mu_5:5;
        RBus_UInt32  fbf_muc_mu_main_0_1_0:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_277b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_muc_mu_main_0_4_2:3;
        RBus_UInt32  fbf_muc_mu_main_1:5;
        RBus_UInt32  res1:24;
    };
}atsc_addr_277c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_muc_mu_main_2:5;
        RBus_UInt32  fbf_muc_mu_main_3_2_0:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_277d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_muc_mu_main_3_4_3:2;
        RBus_UInt32  fbf_muc_mu_main_4:5;
        RBus_UInt32  fbf_muc_mu_main_5_0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_277e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_muc_mu_main_5_4_1:4;
        RBus_UInt32  fbf_muc_mu_bn_slow_0_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_277f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_muc_mu_bn_slow_0_4:1;
        RBus_UInt32  fbf_muc_mu_bn_slow_1:5;
        RBus_UInt32  fbf_muc_mu_bn_slow_2_1_0:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2780_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_muc_mu_bn_slow_2_4_2:3;
        RBus_UInt32  fbf_muc_mu_bn_slow_3:5;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2781_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_muc_mu_bn_slow_4:5;
        RBus_UInt32  fbf_muc_mu_bn_slow_5_2_0:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2782_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_muc_mu_bn_slow_5_4_3:2;
        RBus_UInt32  res1:30;
    };
}atsc_addr_2783_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bn_det_mse_opt:1;
        RBus_UInt32  bn_det_adj_ind_enable:1;
        RBus_UInt32  eqpt_in_amp_th_disable:1;
        RBus_UInt32  eqpt_dd_xi_abs_q_manu_en:1;
        RBus_UInt32  eqpt_dd_xi_abs_q_manu:3;
        RBus_UInt32  bn_eqpt_er_amp_th_en:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2788_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqpt_dd_er_amp_th_bn:4;
        RBus_UInt32  eqpt_dd_delta_ph_max_bn:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2789_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bn_eqpt_delta_max_en:1;
        RBus_UInt32  eqpt_dd_step_size_exp_bn:3;
        RBus_UInt32  bn_eqpt_u_en:1;
        RBus_UInt32  eqpt_mse_src_sel:1;
        RBus_UInt32  res1:26;
    };
}atsc_addr_278a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqpt_mse_field_src_sel:1;
        RBus_UInt32  eqpt_state_ind_clear_opt:1;
        RBus_UInt32  eqpt_mse_field_th_out_sel:1;
        RBus_UInt32  eqpt_leak_opt1:1;
        RBus_UInt32  eqpt_leak_opt2:1;
        RBus_UInt32  eqpt_leak_exp:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_278b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqpt_mse_field_th2_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_278c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqpt_mse_field_th2_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_278d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  opt_bn_slow_ind:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  opt_bn_det_hold_input:1;
        RBus_UInt32  res2:29;
    };
}atsc_addr_278e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gamma_sato:7;
        RBus_UInt32  res1:25;
    };
}atsc_addr_2790_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gamma_godard2_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2791_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  gamma_godard2_8:1;
        RBus_UInt32  res1:31;
    };
}atsc_addr_2792_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_upd_cnt_max:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2793_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_upd_cnt_max:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2794_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_exp:2;
        RBus_UInt32  res1:30;
    };
}atsc_addr_2795_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  er_bound_en:1;
        RBus_UInt32  er_bound_6_0:7;
        RBus_UInt32  res1:24;
    };
}atsc_addr_279e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  er_bound_13_7:7;
        RBus_UInt32  res1:25;
    };
}atsc_addr_279f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_bound_en:1;
        RBus_UInt32  res1:31;
    };
}atsc_addr_27a0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_bound_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27a1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_bound_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27a2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_th_eq_en:1;
        RBus_UInt32  eqer_final_state:6;
        RBus_UInt32  res1:25;
    };
}atsc_addr_27a3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_th_eq_tr2_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27a4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_th_eq_tr2_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27a5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_th_eq_tr1_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27a6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_th_eq_tr1_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27a7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_th_eq_dd2_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27a8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_th_eq_dd2_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27a9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_th_eq_dd1_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27aa_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_th_eq_dd1_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27ab_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_exp_tr2:3;
        RBus_UInt32  ffe_exp_tr1:3;
        RBus_UInt32  ffe_exp_tr0_1_0:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27ac_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_exp_tr0_2:1;
        RBus_UInt32  ffe_exp_dd2:3;
        RBus_UInt32  ffe_exp_dd1:3;
        RBus_UInt32  ffe_exp_dd0_0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27ad_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_exp_dd0_2_1:2;
        RBus_UInt32  fbf_exp_tr2:3;
        RBus_UInt32  fbf_exp_tr1:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27ae_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_exp_tr0:3;
        RBus_UInt32  fbf_exp_dd2:3;
        RBus_UInt32  fbf_exp_dd1_1_0:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27af_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_exp_dd1_2:1;
        RBus_UInt32  fbf_exp_dd0:3;
        RBus_UInt32  res1:28;
    };
}atsc_addr_27b0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_leak_cnt_max:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27b1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_leak_en:1;
        RBus_UInt32  fbf_leak_en:1;
        RBus_UInt32  res1:30;
    };
}atsc_addr_27b2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_leak_val_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27b3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_leak_val_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27b4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_leak_cnt_max:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27b5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_leak_val_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27b6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_leak_val_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27b7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqer_mse_bound_sel:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  eqer_mse_stepsize_sel:2;
        RBus_UInt32  eqer_mse_zd_viterbi_sel:2;
        RBus_UInt32  res2:24;
    };
}atsc_addr_27b8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqer_pwr_sel:2;
        RBus_UInt32  eqer_godard_pwr_sel:2;
        RBus_UInt32  eqer_sato_pwr_sel:2;
        RBus_UInt32  eqer_blind_type_sel:1;
        RBus_UInt32  res1:25;
    };
}atsc_addr_27b9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqer_msectrl_en:1;
        RBus_UInt32  eqer_msectrl_mse_sel_2:2;
        RBus_UInt32  eqer_msectrl_mse_sel_1:2;
        RBus_UInt32  eqer_msectrl_mse_sel_0:2;
        RBus_UInt32  res1:25;
    };
}atsc_addr_27c0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqer_msectrl_er_type_sel_3:3;
        RBus_UInt32  eqer_msectrl_er_type_sel_2:3;
        RBus_UInt32  eqer_msectrl_er_type_sel_1_1_0:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27c1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqer_msectrl_er_type_sel_1_2:1;
        RBus_UInt32  eqer_msectrl_er_type_sel_0:3;
        RBus_UInt32  res1:28;
    };
}atsc_addr_27c2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqer_msectrl_mse_th_2_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27c3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqer_msectrl_mse_th_2_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27c4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqer_msectrl_mse_th_1_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27c5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqer_msectrl_mse_th_1_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27c6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqer_msectrl_mse_th_0_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27c7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqer_msectrl_mse_th_0_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27c8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqer_dd_er_type_sel:1;
        RBus_UInt32  eqer_mse_er_type_sel:1;
        RBus_UInt32  eq_fifo_size:3;
        RBus_UInt32  eq_fifo_full_ind_clear:1;
        RBus_UInt32  eq_fifo_full_ind_sel:1;
        RBus_UInt32  eq_fifo_discard_ind_clear:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27c9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_in_scale:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27ca_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  zd_viterbi_stage_en_4_0:5;
        RBus_UInt32  res2:24;
    };
}atsc_addr_27cb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  segment_sync_en:1;
        RBus_UInt32  zd_viterbi_en:1;
        RBus_UInt32  zd_viterbi_mse_en:1;
        RBus_UInt32  zd_viterbi_stage_en_9_5:5;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27cc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  zd_viterbi_mse_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27cd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  zd_viterbi_mse_th_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27ce_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_mu_bn_slow_en:1;
        RBus_UInt32  ffe_mu_bn_slow:3;
        RBus_UInt32  fbf_mu_bn_slow_en:1;
        RBus_UInt32  fbf_mu_bn_slow:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27da_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_th_eq_tr3_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27db_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_th_eq_tr3_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27dc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_th_eq_dd3_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27dd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_th_eq_dd3_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27de_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_exp_tr3:3;
        RBus_UInt32  ffe_exp_dd3:3;
        RBus_UInt32  res1:26;
    };
}atsc_addr_27df_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_exp_tr3:3;
        RBus_UInt32  fbf_exp_dd3:3;
        RBus_UInt32  res1:26;
    };
}atsc_addr_27e0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_gc_en:1;
        RBus_UInt32  fbf_gc_coeff_sum_max_clr:1;
        RBus_UInt32  fbf_gc_main_protect_en:1;
        RBus_UInt32  res1:29;
    };
}atsc_addr_27e1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_gc_on_field_exp:4;
        RBus_UInt32  fbf_gc_start_field_exp:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27e2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_gc_prd_field_exp:4;
        RBus_UInt32  fbf_gc_check_seg_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27e3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_gc_check_seg_8_4:5;
        RBus_UInt32  fbf_gc_en_sum_th_0_2_0:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27e4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_gc_en_sum_th_0_10_3:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27e5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_gc_en_sum_th_0_11:1;
        RBus_UInt32  fbf_gc_en_sum_th_1_6_0:7;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27e6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_gc_en_sum_th_1_11_7:5;
        RBus_UInt32  fbf_gc_en_sum_th_2_2_0:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27e7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_gc_en_sum_th_2_10_3:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27e8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_gc_en_sum_th_2_11:1;
        RBus_UInt32  fbf_gc_dis_th_6_0:7;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27e9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_gc_dis_th_11_7:5;
        RBus_UInt32  fbf_gc_en_cnt_lb_0_2_0:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27ea_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_gc_en_cnt_lb_0_4_3:2;
        RBus_UInt32  fbf_gc_en_cnt_lb_1:5;
        RBus_UInt32  fbf_gc_en_cnt_lb_2_0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27eb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_gc_en_cnt_lb_2_4_1:4;
        RBus_UInt32  fbf_gc_dis2en_cnt_lb_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27ec_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_gc_dis2en_cnt_lb_4:1;
        RBus_UInt32  fbf_gc_dis_cnt_lb:5;
        RBus_UInt32  fbf_gc_range_exp:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27ed_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_gc_dis2en_num_ub:7;
        RBus_UInt32  fbf_gc_tr_coeff_th_0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27ee_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_gc_tr_coeff_th_7_1:7;
        RBus_UInt32  fbf_gc_dd_coeff_th_0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27ef_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_gc_dd_coeff_th_7_1:7;
        RBus_UInt32  fbf_gc_coeff_en_sel_0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27f0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_gc_coeff_en_sel_1:1;
        RBus_UInt32  res1:31;
    };
}atsc_addr_27f1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_gc_tr_coeff_en_0:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_1:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_2:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_3:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_4:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_5:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_6:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_7:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27f2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_gc_tr_coeff_en_8:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_9:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_10:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_11:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_12:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_13:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_14:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_15:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27f3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_gc_tr_coeff_en_16:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_17:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_18:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_19:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_20:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_21:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_22:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_23:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27f4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_gc_tr_coeff_en_24:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_25:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_26:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_27:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_28:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_29:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_30:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_31:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27f5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_gc_tr_coeff_en_32:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_33:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_34:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_35:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_36:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_37:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_38:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_39:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27f6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_gc_tr_coeff_en_40:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_41:1;
        RBus_UInt32  fbf_gc_tr_coeff_en_42:1;
        RBus_UInt32  res1:29;
    };
}atsc_addr_27f7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_gc_dd_coeff_en_0:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_1:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_2:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_3:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_4:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_5:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_6:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_7:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27f8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_gc_dd_coeff_en_8:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_9:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_10:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_11:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_12:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_13:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_14:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_15:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27f9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_gc_dd_coeff_en_16:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_17:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_18:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_19:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_20:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_21:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_22:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_23:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27fa_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_gc_dd_coeff_en_24:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_25:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_26:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_27:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_28:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_29:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_30:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_31:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27fb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_gc_dd_coeff_en_32:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_33:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_34:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_35:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_36:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_37:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_38:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_39:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_27fc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_gc_dd_coeff_en_40:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_41:1;
        RBus_UInt32  fbf_gc_dd_coeff_en_42:1;
        RBus_UInt32  res1:29;
    };
}atsc_addr_27fd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqpt_in_amp_th:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2802_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqpt_dd_t:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2803_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqpt_dd_delta_ph_max:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2804_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqpt_eq_out_mse_lower_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2805_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqpt_eq_out_mse_lower_th_12_8:5;
        RBus_UInt32  res1:27;
    };
}atsc_addr_2806_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqpt_eq_out_mse_upper_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2807_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqpt_eq_out_mse_upper_th_12_8:5;
        RBus_UInt32  res1:27;
    };
}atsc_addr_2808_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqpt_mse_field_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2809_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqpt_mse_field_th_12_8:5;
        RBus_UInt32  res1:27;
    };
}atsc_addr_280a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqpt_mse_exp:2;
        RBus_UInt32  eqpt_mse_est_late:1;
        RBus_UInt32  eqpt_mse_est_64:1;
        RBus_UInt32  eqpt_bn_det_period:3;
        RBus_UInt32  eqpt_bypass:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_280b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqpt_dd_er_amp_th:4;
        RBus_UInt32  bn_aagc_stop_en:1;
        RBus_UInt32  bn_dagc_stop_en:1;
        RBus_UInt32  bn_eq_stop_en:1;
        RBus_UInt32  res1:25;
    };
}atsc_addr_280c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bn_agc_eqpt_mse_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_280d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bn_agc_eqpt_mse_th_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_280e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bn_agc_mse_field_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_280f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bn_agc_mse_field_th_11_8:4;
        RBus_UInt32  eqpt_ind_cnt1_prd:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2810_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqpt_ind_cnt1_th:4;
        RBus_UInt32  eqpt_ind_cnt2_prd:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2811_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqpt_ind_cnt2_th:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2812_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bn_pred_wait_th:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2813_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bn_pred_period_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2814_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bn_pred_period_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2815_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bn_pred_period_20_16:5;
        RBus_UInt32  bn_pred_regular:1;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2816_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bn_pred_cnt_th1_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2817_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bn_pred_cnt_th1_13_8:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2818_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bn_pred_cnt_th2_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2819_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bn_pred_cnt_th2_13_8:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_281a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bn_pred_cnt_th3_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_281b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bn_pred_cnt_th3_13_8:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_281c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pn_det_acc_exp:2;
        RBus_UInt32  eqpt_dd_step_size_exp_0:3;
        RBus_UInt32  eqpt_dd_step_size_exp_1:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_281d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pn_det_mse_field_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_281e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pn_det_mse_field_th_9_8:2;
        RBus_UInt32  res1:30;
    };
}atsc_addr_281f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pn_det_mse_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2820_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pn_det_mse_th_9_8:2;
        RBus_UInt32  res1:30;
    };
}atsc_addr_2821_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pn_det_acc_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2822_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pn_det_acc_th_9_8:2;
        RBus_UInt32  res1:30;
    };
}atsc_addr_2823_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqpt_dd_ph_max:6;
        RBus_UInt32  bn_pt_stop_en:1;
        RBus_UInt32  res1:25;
    };
}atsc_addr_2824_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pn_det_mse_field_th_cr_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2825_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pn_det_mse_field_th_cr_9_8:2;
        RBus_UInt32  pn_det_mse_th_cr_5_0:6;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2826_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pn_det_mse_th_cr_9_6:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2827_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pn_det_acc_th_cr_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2828_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pn_det_acc_th_cr_9_8:2;
        RBus_UInt32  res1:30;
    };
}atsc_addr_2829_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pn_det_mse_field_th_pt_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_282a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pn_det_mse_field_th_pt_9_8:2;
        RBus_UInt32  res1:30;
    };
}atsc_addr_282b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pn_det_mse_th_pt_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_282c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pn_det_mse_th_pt_9_8:2;
        RBus_UInt32  res1:30;
    };
}atsc_addr_282d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pn_det_acc_th_pt_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_282e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pn_det_acc_th_pt_9_8:2;
        RBus_UInt32  res1:30;
    };
}atsc_addr_282f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ld_rst_n:1;
        RBus_UInt32  res1:31;
    };
}atsc_addr_2830_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ld_ai_start_cnt_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2831_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ld_ai_start_cnt_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2832_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ld_ai_en_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2833_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ld_ai_and_or:1;
        RBus_UInt32  ld_ai_ck_cnt:4;
        RBus_UInt32  res1:27;
    };
}atsc_addr_2834_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ld_mse_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2835_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ld_mse_th_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2836_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ld_mse_th_23_16:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2837_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ld_mse_th_31_24:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2838_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ld_mse_th_33_32:2;
        RBus_UInt32  ld_mse_field_th_0_5_0:6;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2839_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ld_mse_field_th_0_13_6:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_283a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ld_mse_field_th_0_21_14:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_283b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ld_mse_field_th_0_29_22:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_283c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ld_mse_field_th_0_33_30:4;
        RBus_UInt32  ld_mse_viterbi_th_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_283d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ld_mse_viterbi_th_11_4:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_283e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ld_mse_viterbi_th_19_12:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_283f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ld_mse_viterbi_th_27_20:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2840_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ld_mse_viterbi_th_33_28:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2841_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ld_max_correlation_th:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2842_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:5;
        RBus_UInt32  ld_en1:1;
        RBus_UInt32  ld_en0:1;
        RBus_UInt32  ld_and_or:1;
        RBus_UInt32  res2:24;
    };
}atsc_addr_2846_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ld_mse_field_th_1_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2847_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ld_mse_field_th_1_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2848_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ld_mse_field_th_1_23_16:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2849_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ld_mse_field_th_1_31_24:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_284a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ld_mse_field_th_1_33_32:2;
        RBus_UInt32  ld_ai_en_8:1;
        RBus_UInt32  res1:29;
    };
}atsc_addr_284b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ld_mse_field_sel_cnt_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_284c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ld_mse_field_sel_cnt_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_284d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tre_test_volume:3;
        RBus_UInt32  dis_tre_auto_mode:1;
        RBus_UInt32  tre_ber_hold:1;
        RBus_UInt32  tre_ber_rst:1;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2851_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fix_tei:1;
        RBus_UInt32  ckoutpar:1;
        RBus_UInt32  ckout_pwr:1;
        RBus_UInt32  sync_dur:1;
        RBus_UInt32  err_dur:1;
        RBus_UInt32  err_lvl:1;
        RBus_UInt32  val_lvl:1;
        RBus_UInt32  res1:25;
    };
}atsc_addr_2852_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  serial:1;
        RBus_UInt32  ser_lsb:1;
        RBus_UInt32  res1:30;
    };
}atsc_addr_2853_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cdiv_ph0:4;
        RBus_UInt32  cdiv_ph1:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2854_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  no_corr:1;
        RBus_UInt32  rsd_disable:1;
        RBus_UInt32  res1:30;
    };
}atsc_addr_2855_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  test_volume:4;
        RBus_UInt32  ber_once:1;
        RBus_UInt32  ber_sel:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  ber_rst:1;
        RBus_UInt32  res2:24;
    };
}atsc_addr_2856_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dera_disable:1;
        RBus_UInt32  res1:31;
    };
}atsc_addr_2857_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ao_ld_ser_thr_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2858_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ao_ld_ser_thr_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2859_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ao_ld_ser_thr_23_16:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_285a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ao_ld_ck_cnt:3;
        RBus_UInt32  ao_ld_volume:3;
        RBus_UInt32  ao_ld_rstn:1;
        RBus_UInt32  res1:25;
    };
}atsc_addr_285b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ld_ao_start_cnt_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_285c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ld_ao_start_cnt_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_285d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  reg_outer_null_in_clear:1;
        RBus_UInt32  res2:1;
        RBus_UInt32  data_lost_flag_clr:1;
        RBus_UInt32  res3:28;
    };
}atsc_addr_285e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  deint_sf_err_cnt:4;
        RBus_UInt32  reg_outer_null_in:1;
        RBus_UInt32  ro_data_lost_flag:1;
        RBus_UInt32  res1:26;
    };
}atsc_addr_285f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ft_rst_n:1;
        RBus_UInt32  res1:31;
    };
}atsc_addr_2860_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ft_valid_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2861_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ft_valid_th_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2862_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ft_caagc_target_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2863_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ft_caagc_target_th_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2864_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ft_final_state_flag_en:1;
        RBus_UInt32  res1:31;
    };
}atsc_addr_2865_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ft_mse_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2866_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ft_mse_th_9_8:2;
        RBus_UInt32  ft_mse_en:1;
        RBus_UInt32  res1:29;
    };
}atsc_addr_2867_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ft_mse_field_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2868_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ft_mse_field_th_9_8:2;
        RBus_UInt32  ft_mse_field_en:1;
        RBus_UInt32  res1:29;
    };
}atsc_addr_2869_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ft_ser_en:1;
        RBus_UInt32  res1:31;
    };
}atsc_addr_286a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ft_rs_corr_cnt_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_286b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ft_rs_corr_cnt_th_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_286c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ft_rs_corr_cnt_th_23_16:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_286d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ft_rs_un_corr_cnt_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_286e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ft_rs_un_corr_cnt_th_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_286f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ft_rs_un_corr_cnt_th_23_16:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2870_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ft_if_agc_en:1;
        RBus_UInt32  ft_rf_agc_en:1;
        RBus_UInt32  ft_if_agc_u_th_5_0:6;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2871_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ft_if_agc_u_th_13_6:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2872_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ft_rf_agc_u_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2873_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ft_rf_agc_u_th_13_8:6;
        RBus_UInt32  ft_if_agc_l_th_1_0:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2874_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ft_if_agc_l_th_9_2:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2875_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ft_if_agc_l_th_13_10:4;
        RBus_UInt32  ft_rf_agc_l_th_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2876_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ft_rf_agc_l_th_11_4:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2877_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ft_rf_agc_l_th_13_12:2;
        RBus_UInt32  ft_if_agc_polar:1;
        RBus_UInt32  ft_rf_agc_polar:1;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2878_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ft_aagc_target_value1:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2879_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ft_aagc_target_value2:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_287a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ft_dagc_en:1;
        RBus_UInt32  ft_dagc_lvl_th_6_0:7;
        RBus_UInt32  res1:24;
    };
}atsc_addr_287b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ft_dagc_lvl_th_12_7:6;
        RBus_UInt32  ft_dagc_diff_th_1_0:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_287c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ft_dagc_diff_th_9_2:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_287d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ft_dagc_diff_th_12_10:3;
        RBus_UInt32  res1:29;
    };
}atsc_addr_287e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  clip_mo_period:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2890_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tst_dat_1_sel:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_28a0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tst_dat_2_sel:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_28a1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tst_ena_sel:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_28a2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tst_irq1_sel:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_28a3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tst_irq2_sel:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_28a4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_th_irq1_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_28a5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_th_irq1_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_28a6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_th_irq1_23_16:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_28a7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_th_irq1_31_24:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_28a8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_th_irq2_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_28a9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_th_irq2_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_28aa_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_th_irq2_23_16:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_28ab_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_th_irq2_31_24:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_28ac_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tst_state_irq1:6;
        RBus_UInt32  tst_irq1_reg:1;
        RBus_UInt32  res1:25;
    };
}atsc_addr_28ad_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tst_state_irq2:6;
        RBus_UInt32  tst_irq2_reg:1;
        RBus_UInt32  res1:25;
    };
}atsc_addr_28ae_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tst_norm_sel:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_28af_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_th_norm_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_28b0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_th_norm_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_28b1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_th_norm_23_16:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_28b2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_th_norm_31_24:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_28b3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tst_state_norm:6;
        RBus_UInt32  tst_norm_reg:1;
        RBus_UInt32  res1:25;
    };
}atsc_addr_28b4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  bist_mode:1;
        RBus_UInt32  bist_reset_n:1;
        RBus_UInt32  res1:30;
    };
}atsc_addr_28c0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  drf_bist_mode:1;
        RBus_UInt32  dvse_0:1;
        RBus_UInt32  opt_drf_resume:1;
        RBus_UInt32  drf_menu_resume:1;
        RBus_UInt32  res2:27;
    };
}atsc_addr_28cb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  drf_dvs:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_28cc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_drf_time_cnt_th_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_28cd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  reg_drf_time_cnt_th_12_8:5;
        RBus_UInt32  res1:27;
    };
}atsc_addr_28ce_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_dr1_mean_pwr_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_dr1_mean_pwr_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_dr1_mean_pwr_22_16:7;
        RBus_UInt32  res1:25;
    };
}atsc_addr_2e03_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_dr1_im_hpf_pwr_qtz_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e04_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_dr1_im_hpf_pwr_qtz_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e05_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_dr1_im_hpf_pwr_qtz_19_16:4;
        RBus_UInt32  cr_comp_scale_exp:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e06_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ro_fsm_addr_col_cnt_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e2e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ro_fsm_addr_col_cnt_8:1;
        RBus_UInt32  ro_fsm_addr_row_cnt:6;
        RBus_UInt32  res1:25;
    };
}atsc_addr_2e2f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ado_dc_1_q_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e30_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ado_dc_1_q_11_8:4;
        RBus_UInt32  ado_dc_1_q_im_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ado_dc_1_q_im_11_4:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e32_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ado_dc_2_q_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e33_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ado_dc_2_q_11_8:4;
        RBus_UInt32  ado_dc_2_q_im_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e34_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ado_dc_2_q_im_11_4:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e35_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ado_dc_3_q_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e36_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ado_dc_3_q_11_8:4;
        RBus_UInt32  ado_dc_3_q_im_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e37_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ado_dc_3_q_im_11_4:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e38_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fe_iqamp_q_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e39_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fe_iqamp_q_9_8:2;
        RBus_UInt32  fe_iqph_q_5_0:6;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2e3a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fe_iqph_q_9_6:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2e3b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  strobe:1;
        RBus_UInt32  res1:31;
    };
}atsc_addr_2f01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  acc_rf3_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  acc_rf3_13_8:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2f03_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  acc_if3_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f04_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  acc_if3_13_8:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2f05_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_scan_lock_ind:1;
        RBus_UInt32  fsm_scan_unlock_ind:1;
        RBus_UInt32  res1:30;
    };
}atsc_addr_2f06_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  converge_cnt_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f07_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  converge_cnt_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f08_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fsm_final_flag_hold:1;
        RBus_UInt32  fsm_final_flag:1;
        RBus_UInt32  current_state:6;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f09_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  tr_lock_ind:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  adj_ind:1;
        RBus_UInt32  aagc_lock:1;
        RBus_UInt32  res3:24;
    };
}atsc_addr_2f0a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_loc2_lag_loc3_n:1;
        RBus_UInt32  tr_fs_loc2_lead_loc3_n:1;
        RBus_UInt32  tr_fs_loc2_lag_loc3_1:1;
        RBus_UInt32  tr_fs_loc2_lead_loc3_1:1;
        RBus_UInt32  tr_fs_loc2_eq_loc3:1;
        RBus_UInt32  tr_fs_trk_ind_d:1;
        RBus_UInt32  tr_fs_lost_d:1;
        RBus_UInt32  tr_fs_lock_ind:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f0b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  acc3_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f0c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  acc3_13_8:6;
        RBus_UInt32  agc_max_sat_flag:1;
        RBus_UInt32  res1:25;
    };
}atsc_addr_2f0d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dagc_level_q_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f0e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dagc_level_q_12_8:5;
        RBus_UInt32  res1:27;
    };
}atsc_addr_2f0f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  adc_out_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  adc_out_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2f11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  timing_offset_d_q_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f12_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  timing_offset_d_q_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f13_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_acc_cnt_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f14_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_acc_cnt_14_8:7;
        RBus_UInt32  res1:25;
    };
}atsc_addr_2f15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_lock_diff_acc_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f16_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_lock_diff_acc_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f17_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_lock_diff_acc_23_16:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f18_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_lock_diff_acc_24:1;
        RBus_UInt32  res1:31;
    };
}atsc_addr_2f19_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cond_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f1a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cond_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f1b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cond_23_16:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f1c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cond_31_24:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f1d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  adc_clip_cnt:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f1e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  agc_targ_val_tune:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f1f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  agc_tune_wait_cnt:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f20_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqpt_eq_out_mse_est_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f21_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqpt_eq_out_mse_est_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f22_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqpt_eq_out_mse_est_21_16:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2f23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_viterbi_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f24_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_viterbi_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f25_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_viterbi_23_16:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f26_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_viterbi_31_24:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f27_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_viterbi_33_32:2;
        RBus_UInt32  res1:30;
    };
}atsc_addr_2f28_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqpt_bn_det_flag:1;
        RBus_UInt32  eqpt_bn_det_flag_hold:1;
        RBus_UInt32  bn_eq_stop:1;
        RBus_UInt32  bn_dagc_stop:1;
        RBus_UInt32  bn_aagc_stop:1;
        RBus_UInt32  bn_pred_flag:1;
        RBus_UInt32  bn_pred_cnt_ovf:1;
        RBus_UInt32  bn_pred_wait_cnt_ovf:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f29_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqpt_dd_step_size_exp_ro:3;
        RBus_UInt32  pn_det_flag:1;
        RBus_UInt32  pn_det_flag_cr:1;
        RBus_UInt32  pn_det_flag_pt:1;
        RBus_UInt32  eqpt_state_ind:1;
        RBus_UInt32  adj_ind_bn:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f2a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pn_det_acc_q_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f2b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pn_det_acc_q_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f2c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqpt_dd_ph_q_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f2d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eqpt_dd_ph_q_9_8:2;
        RBus_UInt32  res1:3;
        RBus_UInt32  srrc_coeff_sel_mux_out:2;
        RBus_UInt32  adj_ind_srrc:1;
        RBus_UInt32  res2:24;
    };
}atsc_addr_2f2e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pre_srrc_q_d_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f32_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pre_srrc_q_d_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f33_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  post_srrc_q_d_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f34_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  post_srrc_q_d_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f35_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_fsm_state:4;
        RBus_UInt32  tr_fs_fsm_run:1;
        RBus_UInt32  tr_fs_fsm_lock:1;
        RBus_UInt32  tr_fs_el_lock_ind:1;
        RBus_UInt32  tr_fs_el_weak_ind:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f36_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_el_kf_out_q16_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f37_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_el_kf_out_q16_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f38_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_el_trk_corr_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f39_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_el_trk_corr_12_8:5;
        RBus_UInt32  res1:27;
    };
}atsc_addr_2f3a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dc_mean_d_q_re_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f3d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dc_mean_d_q_re_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f3e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dc_mean_d_q_im_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f40_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dc_mean_d_q_im_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f41_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_lock_ind_reg:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f45_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_lock_ted_reg:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f46_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_tr_freq_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f47_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_tr_freq_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f48_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tr_fs_tr_freq_23_16:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f49_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pt_phase_q_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f4a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pt_phase_q_8:1;
        RBus_UInt32  res1:31;
    };
}atsc_addr_2f4b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cm_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f4f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cm_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f50_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cm_23_16:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f51_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cm_26_24:3;
        RBus_UInt32  res1:29;
    };
}atsc_addr_2f52_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pt_out_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f53_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  pt_out_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2f54_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_lock:1;
        RBus_UInt32  fs2_run:1;
        RBus_UInt32  fs2_precursor_exist:1;
        RBus_UInt32  fs2_main_is_max:1;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2f5c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_state_one_hot_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f5d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_state_one_hot_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2f5e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_corr_amp_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f5f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_corr_amp_12_8:5;
        RBus_UInt32  res1:27;
    };
}atsc_addr_2f60_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_force_num_decode:7;
        RBus_UInt32  res1:25;
    };
}atsc_addr_2f61_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  force_space_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f62_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  force_space_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2f63_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_main_amp_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f64_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_main_amp_12_8:5;
        RBus_UInt32  res1:27;
    };
}atsc_addr_2f65_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_max_amp_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f66_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_max_amp_12_8:5;
        RBus_UInt32  res1:27;
    };
}atsc_addr_2f67_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_pre_amp_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f68_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_pre_amp_12_8:5;
        RBus_UInt32  res1:27;
    };
}atsc_addr_2f69_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_max_re_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f6a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_max_re_12_8:5;
        RBus_UInt32  res1:27;
    };
}atsc_addr_2f6b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_max_amp_sam_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f6c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_max_amp_sam_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f6d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_max_amp_sam_18_16:3;
        RBus_UInt32  res1:29;
    };
}atsc_addr_2f6e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_main_sam_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f6f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_main_sam_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f70_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_main_sam_20_16:5;
        RBus_UInt32  res1:27;
    };
}atsc_addr_2f71_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_pre_sam_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f72_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_pre_sam_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f73_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_pre_sam_20_16:5;
        RBus_UInt32  res1:27;
    };
}atsc_addr_2f74_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_max_re_sam_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f75_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_max_re_sam_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f76_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_max_re_sam_18_16:3;
        RBus_UInt32  res1:29;
    };
}atsc_addr_2f77_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_main_addr_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f78_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_main_addr_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2f79_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_pre_addr_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f7a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_pre_addr_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2f7b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_post_amp_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f55_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_post_amp_12_8:5;
        RBus_UInt32  res1:27;
    };
}atsc_addr_2f56_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_post_sam_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f57_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_post_sam_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f58_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_post_sam_20_16:5;
        RBus_UInt32  res1:27;
    };
}atsc_addr_2f59_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_post_addr_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f5a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_post_addr_11_8:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2f5b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_amp_0_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f4c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_amp_0_12_8:5;
        RBus_UInt32  fs2_parallel_amp_1_2_0:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f4d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_amp_1_10_3:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f4e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_amp_1_12_11:2;
        RBus_UInt32  fs2_parallel_amp_2_5_0:6;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f42_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_amp_2_12_6:7;
        RBus_UInt32  fs2_parallel_amp_3_0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f43_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_amp_3_8_1:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f44_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_amp_3_12_9:4;
        RBus_UInt32  fs2_parallel_addr_0_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fbd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_addr_0_10_4:7;
        RBus_UInt32  fs2_parallel_addr_1_0:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fbe_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_addr_0_11:1;
        RBus_UInt32  fs2_parallel_addr_1_11:1;
        RBus_UInt32  fs2_parallel_addr_2_11:1;
        RBus_UInt32  fs2_parallel_addr_3_11:1;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2fd5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_addr_1_8_1:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fbf_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_addr_1_10_9:2;
        RBus_UInt32  fs2_parallel_addr_2_5_0:6;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fc0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_addr_2_10_6:5;
        RBus_UInt32  fs2_parallel_addr_3_2_0:3;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fd0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fs2_parallel_addr_3_10_3:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fd4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  state_cnt1:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f7c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  state_cnt2:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f7d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_offset_leak_acc_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f7e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_offset_leak_acc_12_8:5;
        RBus_UInt32  res1:27;
    };
}atsc_addr_2f7f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  if_offset_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f80_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  if_offset_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f81_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  if_offset_17_16:2;
        RBus_UInt32  cr_lock_ind:1;
        RBus_UInt32  cr_unlock_ind:1;
        RBus_UInt32  cr_large_freq_ind:1;
        RBus_UInt32  cr_in_lock_ind:1;
        RBus_UInt32  cr_offset_1_0:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f82_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_offset_9_2:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f83_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_offset_17_10:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f84_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_offset_25_18:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f85_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_offset_32_26:7;
        RBus_UInt32  res1:25;
    };
}atsc_addr_2f86_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_lock_det_out_qtz_re_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f87_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_lock_det_out_qtz_re_13_8:6;
        RBus_UInt32  cr_lock_det_out_qtz_im_1_0:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f88_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_lock_det_out_qtz_im_9_2:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f89_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_lock_det_out_qtz_im_13_10:4;
        RBus_UInt32  cr_pwr_est_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f8a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_pwr_est_11_4:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f8b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_pwr_est_19_12:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f8c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_pwr_est_26_20:7;
        RBus_UInt32  res1:25;
    };
}atsc_addr_2f8d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_out_re_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f8e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_out_re_11_8:4;
        RBus_UInt32  cr_out_im_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f8f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_out_im_11_4:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f90_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_dr1_re_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f91_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_dr1_re_11_8:4;
        RBus_UInt32  cr_dr1_im_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f92_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_dr1_im_11_4:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f93_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_phase_comp_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f94_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_phase_comp_9_8:2;
        RBus_UInt32  cr_comp_man:1;
        RBus_UInt32  cr_comp_exp:3;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2f95_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dagc_out_d_re_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f96_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dagc_out_d_re_11_8:4;
        RBus_UInt32  dagc_out_d_im_3_0:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f97_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dagc_out_d_im_11_4:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f98_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  deltaf_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f99_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  deltaf_10_8:3;
        RBus_UInt32  field_sync_lock_ind:1;
        RBus_UInt32  field_sync2_lock:1;
        RBus_UInt32  tr_esti_lock_ind:1;
        RBus_UInt32  training_length_ind:1;
        RBus_UInt32  pn63_flag:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f9a_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  max_correlation_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f9b_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  max_correlation_13_8:6;
        RBus_UInt32  field_sync_lock:2;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f9c_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch_esti_val_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f9d_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch_esti_val_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f9e_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ch_esti_val_19_16:4;
        RBus_UInt32  pn63_corr_flag_0:1;
        RBus_UInt32  pn63_corr_flag_1:1;
        RBus_UInt32  pn63_corr_flag_2:1;
        RBus_UInt32  pn63_flag_error_ind:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2f9f_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_coeff_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fa0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_coeff_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fa1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  cr_ld_re_lb_flag:1;
        RBus_UInt32  cr_ld_im_flag:1;
        RBus_UInt32  cr_ld_freq_diff_flag:1;
        RBus_UInt32  cr_ld_freq_max_flag:1;
        RBus_UInt32  cr_ld_re_diff_flag:1;
        RBus_UInt32  cr_corr_lock_ind:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  ffe_sat_d:1;
        RBus_UInt32  res2:24;
    };
}atsc_addr_2fa2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ro_ffe_coeff_sum_13_6:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fa3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ro_ffe_coeff_sum_5_0:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2fa4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ro_ffe_sp_coeff_max_11_4:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fa5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ro_ffe_sp_coeff_max_3_0:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2fa6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ro_ffe_gc_even_coeff_en:4;
        RBus_UInt32  ro_ffe_gc_odd_coeff_en:4;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fa7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ro_ffe_muc_coeff_mu_0_1:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fa8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ro_ffe_gc_en_coeff_sum_ind_max:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fa9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ro_ffe_gc_dis_coeff_sum_ind_max:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2faa_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ro_ffe_cluster_addr_0_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fab_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ro_ffe_cluster_addr_1_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fac_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ro_ffe_cluster_addr_2_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fad_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ro_ffe_cluster_addr_3_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fae_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ro_fbf_coeff_sum_13_6:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2faf_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ro_fbf_coeff_sum_5_0:6;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2fb0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ro_fbf_const_coeff_sum_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fb1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ro_fbf_const_coeff_sum_9_8:2;
        RBus_UInt32  ro_fbf_const_coeff_sum_cnt_5_0:6;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fb2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ro_fbf_const_coeff_sum_cnt_9_6:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2fb3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ro_fbf_gc_coeff_en:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fb4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ro_fbf_muc_coeff_mu_0_1:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fb5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ro_fbf_gc_en_coeff_sum_ind_max:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fb6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ro_fbf_gc_dis_coeff_sum_ind_max:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fb7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ffe_out_clip_ind_0:1;
        RBus_UInt32  ffe_out_clip_ind_1:1;
        RBus_UInt32  ffe_out_clip_ind_2:1;
        RBus_UInt32  ffe_out_clip_ind_3:1;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2fb8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_coeff_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fba_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  fbf_coeff_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fbb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ro_ffe_cluster_addr_0_8:1;
        RBus_UInt32  ro_ffe_cluster_addr_1_8:1;
        RBus_UInt32  ro_ffe_cluster_addr_2_8:1;
        RBus_UInt32  ro_ffe_cluster_addr_3_8:1;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2fbc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eq_out_er_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fd6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eq_out_er_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fd7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eq_out_pt_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fd8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  eq_out_pt_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fd9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fda_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fdb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_23_16:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fdc_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_31_24:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fdd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_33_32:2;
        RBus_UInt32  mse_field_5_0:6;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fde_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_field_13_6:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fdf_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_field_21_14:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fe0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_field_29_22:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fe1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  mse_field_33_30:4;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2fe2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ld_ai_start:1;
        RBus_UInt32  inner_unlock_ind:1;
        RBus_UInt32  ld_ao_start:1;
        RBus_UInt32  outer_unlock_ind:1;
        RBus_UInt32  ld_start:1;
        RBus_UInt32  unlock_ind:1;
        RBus_UInt32  out_unlock_valid:1;
        RBus_UInt32  ld_mse_field_sel:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fe3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ft_valid_flag:1;
        RBus_UInt32  ft_final_state_ind:1;
        RBus_UInt32  ft_mse_ind:1;
        RBus_UInt32  ft_mse_field_ind:1;
        RBus_UInt32  ft_rs_ser_trig_ind:1;
        RBus_UInt32  ft_rs_corr_ind:1;
        RBus_UInt32  ft_rs_un_corr_ind:1;
        RBus_UInt32  ft_if_agc_ind:1;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fe4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ft_rf_agc_ind:1;
        RBus_UInt32  ft_dagc_lvl_ind:1;
        RBus_UInt32  ft_ind:1;
        RBus_UInt32  eq_fifo_full_ind:1;
        RBus_UInt32  res1:28;
    };
}atsc_addr_2fe5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ao_rs_ber_cnt_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fe6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ao_rs_ber_cnt_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fe7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ao_rs_ber_cnt_23_16:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fe8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ao_rs_ber_cnt_27_24:4;
        RBus_UInt32  ao_rs_ser_trig:1;
        RBus_UInt32  res1:27;
    };
}atsc_addr_2fe9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ao_rs_pkt_cnt_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fea_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ao_rs_pkt_cnt_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2feb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ao_rs_pkt_cnt_23_16:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fec_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ao_rs_corr_cnt_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fed_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ao_rs_corr_cnt_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fee_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ao_rs_corr_cnt_23_16:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2fef_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ao_rs_uncorr_cnt_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ff0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ao_rs_uncorr_cnt_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ff1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ao_rs_uncorr_cnt_23_16:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ff2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tre_ber_cnt_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ff3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tre_ber_cnt_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ff4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tre_ber_cnt_23_16:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ff5_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tre_ber_cnt_31_24:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ff6_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tre_ber_cnt_39_32:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ff7_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tre_seg_cnt_7_0:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ff8_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tre_seg_cnt_15_8:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ff9_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tre_seg_cnt_23_16:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ffa_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  atsc_bist_done:1;
        RBus_UInt32  atsc_drf_bist_done:1;
        RBus_UInt32  fsm_drf_fail_0:1;
        RBus_UInt32  fsm_drf_fail_1:1;
        RBus_UInt32  fsm_mbist_fail_0:1;
        RBus_UInt32  fsm_mbist_fail_1:1;
        RBus_UInt32  res1:26;
    };
}atsc_addr_2ffb_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  ao_pkt_ser_num:8;
        RBus_UInt32  res1:24;
    };
}atsc_addr_2ffd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  atsc_drf_pause:1;
        RBus_UInt32  res1:31;
    };
}atsc_addr_2ffe_RBUS;




#endif 


#endif 
