/**
* @file Merlin6-DesignSpec-D-Domain_USIT
* RBus systemc program.
*
* @author RS_MM2_SD
* @email mm_mm2_rd_sw_kernel@realtek.com
* @ingroup model_rbus
 * @version { 1.0 }
 **
 */

#ifndef _RBUS_USIT_REG_H_
#define _RBUS_USIT_REG_H_

#include "rbus_types.h"



//  USIT Register Address
#define  USIT_USIT_CTRL1                                                        0x18026A00
#define  USIT_USIT_CTRL1_reg_addr                                                "0xB8026A00"
#define  USIT_USIT_CTRL1_reg                                                     0xB8026A00
#define  USIT_USIT_CTRL1_inst_addr                                               "0x0000"
#define  set_USIT_USIT_CTRL1_reg(data)                                           (*((volatile unsigned int*)USIT_USIT_CTRL1_reg)=data)
#define  get_USIT_USIT_CTRL1_reg                                                 (*((volatile unsigned int*)USIT_USIT_CTRL1_reg))
#define  USIT_USIT_CTRL1_sbc_cmd_done_irq_en_shift                               (28)
#define  USIT_USIT_CTRL1_sbc_in_change_irq_en_shift                              (27)
#define  USIT_USIT_CTRL1_sbc_in_unlock_irq_en_shift                              (26)
#define  USIT_USIT_CTRL1_fifo_data_stay_irq_en_shift                             (25)
#define  USIT_USIT_CTRL1_fifo_align_err_irq_en_shift                             (24)
#define  USIT_USIT_CTRL1_sbc_cmd_done_irq_shift                                  (20)
#define  USIT_USIT_CTRL1_sbc_in_change_irq_shift                                 (19)
#define  USIT_USIT_CTRL1_sbc_in_unlock_irq_shift                                 (18)
#define  USIT_USIT_CTRL1_fifo_data_stay_irq_shift                                (17)
#define  USIT_USIT_CTRL1_fifo_align_err_irq_shift                                (16)
#define  USIT_USIT_CTRL1_hit_w_cnt_error_shift                                   (4)
#define  USIT_USIT_CTRL1_pair_sel_shift                                          (3)
#define  USIT_USIT_CTRL1_bit_sel_shift                                           (1)
#define  USIT_USIT_CTRL1_usit_en_shift                                           (0)
#define  USIT_USIT_CTRL1_sbc_cmd_done_irq_en_mask                                (0x10000000)
#define  USIT_USIT_CTRL1_sbc_in_change_irq_en_mask                               (0x08000000)
#define  USIT_USIT_CTRL1_sbc_in_unlock_irq_en_mask                               (0x04000000)
#define  USIT_USIT_CTRL1_fifo_data_stay_irq_en_mask                              (0x02000000)
#define  USIT_USIT_CTRL1_fifo_align_err_irq_en_mask                              (0x01000000)
#define  USIT_USIT_CTRL1_sbc_cmd_done_irq_mask                                   (0x00100000)
#define  USIT_USIT_CTRL1_sbc_in_change_irq_mask                                  (0x00080000)
#define  USIT_USIT_CTRL1_sbc_in_unlock_irq_mask                                  (0x00040000)
#define  USIT_USIT_CTRL1_fifo_data_stay_irq_mask                                 (0x00020000)
#define  USIT_USIT_CTRL1_fifo_align_err_irq_mask                                 (0x00010000)
#define  USIT_USIT_CTRL1_hit_w_cnt_error_mask                                    (0x00001FF0)
#define  USIT_USIT_CTRL1_pair_sel_mask                                           (0x00000008)
#define  USIT_USIT_CTRL1_bit_sel_mask                                            (0x00000002)
#define  USIT_USIT_CTRL1_usit_en_mask                                            (0x00000001)
#define  USIT_USIT_CTRL1_sbc_cmd_done_irq_en(data)                               (0x10000000&((data)<<28))
#define  USIT_USIT_CTRL1_sbc_in_change_irq_en(data)                              (0x08000000&((data)<<27))
#define  USIT_USIT_CTRL1_sbc_in_unlock_irq_en(data)                              (0x04000000&((data)<<26))
#define  USIT_USIT_CTRL1_fifo_data_stay_irq_en(data)                             (0x02000000&((data)<<25))
#define  USIT_USIT_CTRL1_fifo_align_err_irq_en(data)                             (0x01000000&((data)<<24))
#define  USIT_USIT_CTRL1_sbc_cmd_done_irq(data)                                  (0x00100000&((data)<<20))
#define  USIT_USIT_CTRL1_sbc_in_change_irq(data)                                 (0x00080000&((data)<<19))
#define  USIT_USIT_CTRL1_sbc_in_unlock_irq(data)                                 (0x00040000&((data)<<18))
#define  USIT_USIT_CTRL1_fifo_data_stay_irq(data)                                (0x00020000&((data)<<17))
#define  USIT_USIT_CTRL1_fifo_align_err_irq(data)                                (0x00010000&((data)<<16))
#define  USIT_USIT_CTRL1_hit_w_cnt_error(data)                                   (0x00001FF0&((data)<<4))
#define  USIT_USIT_CTRL1_pair_sel(data)                                          (0x00000008&((data)<<3))
#define  USIT_USIT_CTRL1_bit_sel(data)                                           (0x00000002&((data)<<1))
#define  USIT_USIT_CTRL1_usit_en(data)                                           (0x00000001&(data))
#define  USIT_USIT_CTRL1_get_sbc_cmd_done_irq_en(data)                           ((0x10000000&(data))>>28)
#define  USIT_USIT_CTRL1_get_sbc_in_change_irq_en(data)                          ((0x08000000&(data))>>27)
#define  USIT_USIT_CTRL1_get_sbc_in_unlock_irq_en(data)                          ((0x04000000&(data))>>26)
#define  USIT_USIT_CTRL1_get_fifo_data_stay_irq_en(data)                         ((0x02000000&(data))>>25)
#define  USIT_USIT_CTRL1_get_fifo_align_err_irq_en(data)                         ((0x01000000&(data))>>24)
#define  USIT_USIT_CTRL1_get_sbc_cmd_done_irq(data)                              ((0x00100000&(data))>>20)
#define  USIT_USIT_CTRL1_get_sbc_in_change_irq(data)                             ((0x00080000&(data))>>19)
#define  USIT_USIT_CTRL1_get_sbc_in_unlock_irq(data)                             ((0x00040000&(data))>>18)
#define  USIT_USIT_CTRL1_get_fifo_data_stay_irq(data)                            ((0x00020000&(data))>>17)
#define  USIT_USIT_CTRL1_get_fifo_align_err_irq(data)                            ((0x00010000&(data))>>16)
#define  USIT_USIT_CTRL1_get_hit_w_cnt_error(data)                               ((0x00001FF0&(data))>>4)
#define  USIT_USIT_CTRL1_get_pair_sel(data)                                      ((0x00000008&(data))>>3)
#define  USIT_USIT_CTRL1_get_bit_sel(data)                                       ((0x00000002&(data))>>1)
#define  USIT_USIT_CTRL1_get_usit_en(data)                                       (0x00000001&(data))

#define  USIT_USIT_CTRL2                                                        0x18026A04
#define  USIT_USIT_CTRL2_reg_addr                                                "0xB8026A04"
#define  USIT_USIT_CTRL2_reg                                                     0xB8026A04
#define  USIT_USIT_CTRL2_inst_addr                                               "0x0001"
#define  set_USIT_USIT_CTRL2_reg(data)                                           (*((volatile unsigned int*)USIT_USIT_CTRL2_reg)=data)
#define  get_USIT_USIT_CTRL2_reg                                                 (*((volatile unsigned int*)USIT_USIT_CTRL2_reg))
#define  USIT_USIT_CTRL2_hs_to_rdata0_shift                                      (24)
#define  USIT_USIT_CTRL2_config_line_position_shift                              (16)
#define  USIT_USIT_CTRL2_back_dmy_line_num_shift                                 (8)
#define  USIT_USIT_CTRL2_front_dmy_line_num_shift                                (0)
#define  USIT_USIT_CTRL2_hs_to_rdata0_mask                                       (0xFF000000)
#define  USIT_USIT_CTRL2_config_line_position_mask                               (0x00010000)
#define  USIT_USIT_CTRL2_back_dmy_line_num_mask                                  (0x0000FF00)
#define  USIT_USIT_CTRL2_front_dmy_line_num_mask                                 (0x000000FF)
#define  USIT_USIT_CTRL2_hs_to_rdata0(data)                                      (0xFF000000&((data)<<24))
#define  USIT_USIT_CTRL2_config_line_position(data)                              (0x00010000&((data)<<16))
#define  USIT_USIT_CTRL2_back_dmy_line_num(data)                                 (0x0000FF00&((data)<<8))
#define  USIT_USIT_CTRL2_front_dmy_line_num(data)                                (0x000000FF&(data))
#define  USIT_USIT_CTRL2_get_hs_to_rdata0(data)                                  ((0xFF000000&(data))>>24)
#define  USIT_USIT_CTRL2_get_config_line_position(data)                          ((0x00010000&(data))>>16)
#define  USIT_USIT_CTRL2_get_back_dmy_line_num(data)                             ((0x0000FF00&(data))>>8)
#define  USIT_USIT_CTRL2_get_front_dmy_line_num(data)                            (0x000000FF&(data))

#define  USIT_USIT_CTRL3                                                        0x18026A08
#define  USIT_USIT_CTRL3_reg_addr                                                "0xB8026A08"
#define  USIT_USIT_CTRL3_reg                                                     0xB8026A08
#define  USIT_USIT_CTRL3_inst_addr                                               "0x0002"
#define  set_USIT_USIT_CTRL3_reg(data)                                           (*((volatile unsigned int*)USIT_USIT_CTRL3_reg)=data)
#define  get_USIT_USIT_CTRL3_reg                                                 (*((volatile unsigned int*)USIT_USIT_CTRL3_reg))
#define  USIT_USIT_CTRL3_force_training_pattern_shift                            (28)
#define  USIT_USIT_CTRL3_sfc_training_pat_type_shift                             (24)
#define  USIT_USIT_CTRL3_sfc_training_pat_offset_shift                           (16)
#define  USIT_USIT_CTRL3_sfc_training_period_shift                               (12)
#define  USIT_USIT_CTRL3_sfc_src_sel_shift                                       (8)
#define  USIT_USIT_CTRL3_send_dga_frm_data_shift                                 (4)
#define  USIT_USIT_CTRL3_send_frm_data_period_shift                              (0)
#define  USIT_USIT_CTRL3_force_training_pattern_mask                             (0x10000000)
#define  USIT_USIT_CTRL3_sfc_training_pat_type_mask                              (0x03000000)
#define  USIT_USIT_CTRL3_sfc_training_pat_offset_mask                            (0x007F0000)
#define  USIT_USIT_CTRL3_sfc_training_period_mask                                (0x0000F000)
#define  USIT_USIT_CTRL3_sfc_src_sel_mask                                        (0x00000F00)
#define  USIT_USIT_CTRL3_send_dga_frm_data_mask                                  (0x00000010)
#define  USIT_USIT_CTRL3_send_frm_data_period_mask                               (0x00000003)
#define  USIT_USIT_CTRL3_force_training_pattern(data)                            (0x10000000&((data)<<28))
#define  USIT_USIT_CTRL3_sfc_training_pat_type(data)                             (0x03000000&((data)<<24))
#define  USIT_USIT_CTRL3_sfc_training_pat_offset(data)                           (0x007F0000&((data)<<16))
#define  USIT_USIT_CTRL3_sfc_training_period(data)                               (0x0000F000&((data)<<12))
#define  USIT_USIT_CTRL3_sfc_src_sel(data)                                       (0x00000F00&((data)<<8))
#define  USIT_USIT_CTRL3_send_dga_frm_data(data)                                 (0x00000010&((data)<<4))
#define  USIT_USIT_CTRL3_send_frm_data_period(data)                              (0x00000003&(data))
#define  USIT_USIT_CTRL3_get_force_training_pattern(data)                        ((0x10000000&(data))>>28)
#define  USIT_USIT_CTRL3_get_sfc_training_pat_type(data)                         ((0x03000000&(data))>>24)
#define  USIT_USIT_CTRL3_get_sfc_training_pat_offset(data)                       ((0x007F0000&(data))>>16)
#define  USIT_USIT_CTRL3_get_sfc_training_period(data)                           ((0x0000F000&(data))>>12)
#define  USIT_USIT_CTRL3_get_sfc_src_sel(data)                                   ((0x00000F00&(data))>>8)
#define  USIT_USIT_CTRL3_get_send_dga_frm_data(data)                             ((0x00000010&(data))>>4)
#define  USIT_USIT_CTRL3_get_send_frm_data_period(data)                          (0x00000003&(data))

#define  USIT_USIT_CTRL4                                                        0x18026A0C
#define  USIT_USIT_CTRL4_reg_addr                                                "0xB8026A0C"
#define  USIT_USIT_CTRL4_reg                                                     0xB8026A0C
#define  USIT_USIT_CTRL4_inst_addr                                               "0x0003"
#define  set_USIT_USIT_CTRL4_reg(data)                                           (*((volatile unsigned int*)USIT_USIT_CTRL4_reg)=data)
#define  get_USIT_USIT_CTRL4_reg                                                 (*((volatile unsigned int*)USIT_USIT_CTRL4_reg))
#define  USIT_USIT_CTRL4_pacmod_rgb_shift                                        (28)
#define  USIT_USIT_CTRL4_pacmod_dga_shift                                        (24)
#define  USIT_USIT_CTRL4_pacmod_dga_frm_shift                                    (20)
#define  USIT_USIT_CTRL4_dummy_19_12_shift                                       (12)
#define  USIT_USIT_CTRL4_frm_data_sel_shift                                      (0)
#define  USIT_USIT_CTRL4_pacmod_rgb_mask                                         (0x70000000)
#define  USIT_USIT_CTRL4_pacmod_dga_mask                                         (0x07000000)
#define  USIT_USIT_CTRL4_pacmod_dga_frm_mask                                     (0x00700000)
#define  USIT_USIT_CTRL4_dummy_19_12_mask                                        (0x000FF000)
#define  USIT_USIT_CTRL4_frm_data_sel_mask                                       (0x00000FFF)
#define  USIT_USIT_CTRL4_pacmod_rgb(data)                                        (0x70000000&((data)<<28))
#define  USIT_USIT_CTRL4_pacmod_dga(data)                                        (0x07000000&((data)<<24))
#define  USIT_USIT_CTRL4_pacmod_dga_frm(data)                                    (0x00700000&((data)<<20))
#define  USIT_USIT_CTRL4_dummy_19_12(data)                                       (0x000FF000&((data)<<12))
#define  USIT_USIT_CTRL4_frm_data_sel(data)                                      (0x00000FFF&(data))
#define  USIT_USIT_CTRL4_get_pacmod_rgb(data)                                    ((0x70000000&(data))>>28)
#define  USIT_USIT_CTRL4_get_pacmod_dga(data)                                    ((0x07000000&(data))>>24)
#define  USIT_USIT_CTRL4_get_pacmod_dga_frm(data)                                ((0x00700000&(data))>>20)
#define  USIT_USIT_CTRL4_get_dummy_19_12(data)                                   ((0x000FF000&(data))>>12)
#define  USIT_USIT_CTRL4_get_frm_data_sel(data)                                  (0x00000FFF&(data))

#define  USIT_USIT_SCR                                                          0x18026A10
#define  USIT_USIT_SCR_reg_addr                                                  "0xB8026A10"
#define  USIT_USIT_SCR_reg                                                       0xB8026A10
#define  USIT_USIT_SCR_inst_addr                                                 "0x0004"
#define  set_USIT_USIT_SCR_reg(data)                                             (*((volatile unsigned int*)USIT_USIT_SCR_reg)=data)
#define  get_USIT_USIT_SCR_reg                                                   (*((volatile unsigned int*)USIT_USIT_SCR_reg))
#define  USIT_USIT_SCR_force_scramble_hbp_shift                                  (29)
#define  USIT_USIT_SCR_scrambler_en_shift                                        (28)
#define  USIT_USIT_SCR_scrambler_rst_sel_shift                                   (24)
#define  USIT_USIT_SCR_lfsr_ini_val_shift                                        (0)
#define  USIT_USIT_SCR_force_scramble_hbp_mask                                   (0x20000000)
#define  USIT_USIT_SCR_scrambler_en_mask                                         (0x10000000)
#define  USIT_USIT_SCR_scrambler_rst_sel_mask                                    (0x0F000000)
#define  USIT_USIT_SCR_lfsr_ini_val_mask                                         (0x0003FFFF)
#define  USIT_USIT_SCR_force_scramble_hbp(data)                                  (0x20000000&((data)<<29))
#define  USIT_USIT_SCR_scrambler_en(data)                                        (0x10000000&((data)<<28))
#define  USIT_USIT_SCR_scrambler_rst_sel(data)                                   (0x0F000000&((data)<<24))
#define  USIT_USIT_SCR_lfsr_ini_val(data)                                        (0x0003FFFF&(data))
#define  USIT_USIT_SCR_get_force_scramble_hbp(data)                              ((0x20000000&(data))>>29)
#define  USIT_USIT_SCR_get_scrambler_en(data)                                    ((0x10000000&(data))>>28)
#define  USIT_USIT_SCR_get_scrambler_rst_sel(data)                               ((0x0F000000&(data))>>24)
#define  USIT_USIT_SCR_get_lfsr_ini_val(data)                                    (0x0003FFFF&(data))

#define  USIT_USIT_TRAINING_PAT01                                               0x18026A14
#define  USIT_USIT_TRAINING_PAT01_reg_addr                                       "0xB8026A14"
#define  USIT_USIT_TRAINING_PAT01_reg                                            0xB8026A14
#define  USIT_USIT_TRAINING_PAT01_inst_addr                                      "0x0005"
#define  set_USIT_USIT_TRAINING_PAT01_reg(data)                                  (*((volatile unsigned int*)USIT_USIT_TRAINING_PAT01_reg)=data)
#define  get_USIT_USIT_TRAINING_PAT01_reg                                        (*((volatile unsigned int*)USIT_USIT_TRAINING_PAT01_reg))
#define  USIT_USIT_TRAINING_PAT01_training_pattern1_shift                        (16)
#define  USIT_USIT_TRAINING_PAT01_training_pattern0_shift                        (0)
#define  USIT_USIT_TRAINING_PAT01_training_pattern1_mask                         (0x03FF0000)
#define  USIT_USIT_TRAINING_PAT01_training_pattern0_mask                         (0x000003FF)
#define  USIT_USIT_TRAINING_PAT01_training_pattern1(data)                        (0x03FF0000&((data)<<16))
#define  USIT_USIT_TRAINING_PAT01_training_pattern0(data)                        (0x000003FF&(data))
#define  USIT_USIT_TRAINING_PAT01_get_training_pattern1(data)                    ((0x03FF0000&(data))>>16)
#define  USIT_USIT_TRAINING_PAT01_get_training_pattern0(data)                    (0x000003FF&(data))

#define  USIT_USIT_TRAINING_PAT23                                               0x18026A18
#define  USIT_USIT_TRAINING_PAT23_reg_addr                                       "0xB8026A18"
#define  USIT_USIT_TRAINING_PAT23_reg                                            0xB8026A18
#define  USIT_USIT_TRAINING_PAT23_inst_addr                                      "0x0006"
#define  set_USIT_USIT_TRAINING_PAT23_reg(data)                                  (*((volatile unsigned int*)USIT_USIT_TRAINING_PAT23_reg)=data)
#define  get_USIT_USIT_TRAINING_PAT23_reg                                        (*((volatile unsigned int*)USIT_USIT_TRAINING_PAT23_reg))
#define  USIT_USIT_TRAINING_PAT23_training_pattern3_shift                        (16)
#define  USIT_USIT_TRAINING_PAT23_training_pattern2_shift                        (0)
#define  USIT_USIT_TRAINING_PAT23_training_pattern3_mask                         (0x03FF0000)
#define  USIT_USIT_TRAINING_PAT23_training_pattern2_mask                         (0x000003FF)
#define  USIT_USIT_TRAINING_PAT23_training_pattern3(data)                        (0x03FF0000&((data)<<16))
#define  USIT_USIT_TRAINING_PAT23_training_pattern2(data)                        (0x000003FF&(data))
#define  USIT_USIT_TRAINING_PAT23_get_training_pattern3(data)                    ((0x03FF0000&(data))>>16)
#define  USIT_USIT_TRAINING_PAT23_get_training_pattern2(data)                    (0x000003FF&(data))

#define  USIT_USIT_DMY_HBP                                                      0x18026A1C
#define  USIT_USIT_DMY_HBP_reg_addr                                              "0xB8026A1C"
#define  USIT_USIT_DMY_HBP_reg                                                   0xB8026A1C
#define  USIT_USIT_DMY_HBP_inst_addr                                             "0x0007"
#define  set_USIT_USIT_DMY_HBP_reg(data)                                         (*((volatile unsigned int*)USIT_USIT_DMY_HBP_reg)=data)
#define  get_USIT_USIT_DMY_HBP_reg                                               (*((volatile unsigned int*)USIT_USIT_DMY_HBP_reg))
#define  USIT_USIT_DMY_HBP_dmy_data_value_shift                                  (16)
#define  USIT_USIT_DMY_HBP_hbp_shift                                             (0)
#define  USIT_USIT_DMY_HBP_dmy_data_value_mask                                   (0x03FF0000)
#define  USIT_USIT_DMY_HBP_hbp_mask                                              (0x000003FF)
#define  USIT_USIT_DMY_HBP_dmy_data_value(data)                                  (0x03FF0000&((data)<<16))
#define  USIT_USIT_DMY_HBP_hbp(data)                                             (0x000003FF&(data))
#define  USIT_USIT_DMY_HBP_get_dmy_data_value(data)                              ((0x03FF0000&(data))>>16)
#define  USIT_USIT_DMY_HBP_get_hbp(data)                                         (0x000003FF&(data))

#define  USIT_USIT_SETTING00_L                                                  0x18026A20
#define  USIT_USIT_SETTING00_L_reg_addr                                          "0xB8026A20"
#define  USIT_USIT_SETTING00_L_reg                                               0xB8026A20
#define  USIT_USIT_SETTING00_L_inst_addr                                         "0x0008"
#define  set_USIT_USIT_SETTING00_L_reg(data)                                     (*((volatile unsigned int*)USIT_USIT_SETTING00_L_reg)=data)
#define  get_USIT_USIT_SETTING00_L_reg                                           (*((volatile unsigned int*)USIT_USIT_SETTING00_L_reg))
#define  USIT_USIT_SETTING00_L_setting_00_l_shift                                (0)
#define  USIT_USIT_SETTING00_L_setting_00_l_mask                                 (0xFFFFFFFF)
#define  USIT_USIT_SETTING00_L_setting_00_l(data)                                (0xFFFFFFFF&(data))
#define  USIT_USIT_SETTING00_L_get_setting_00_l(data)                            (0xFFFFFFFF&(data))

#define  USIT_USIT_SETTING00_M                                                  0x18026A24
#define  USIT_USIT_SETTING00_M_reg_addr                                          "0xB8026A24"
#define  USIT_USIT_SETTING00_M_reg                                               0xB8026A24
#define  USIT_USIT_SETTING00_M_inst_addr                                         "0x0009"
#define  set_USIT_USIT_SETTING00_M_reg(data)                                     (*((volatile unsigned int*)USIT_USIT_SETTING00_M_reg)=data)
#define  get_USIT_USIT_SETTING00_M_reg                                           (*((volatile unsigned int*)USIT_USIT_SETTING00_M_reg))
#define  USIT_USIT_SETTING00_M_hs_to_rdata_last_00_shift                         (16)
#define  USIT_USIT_SETTING00_M_setting_00_m_shift                                (0)
#define  USIT_USIT_SETTING00_M_hs_to_rdata_last_00_mask                          (0x0FFF0000)
#define  USIT_USIT_SETTING00_M_setting_00_m_mask                                 (0x0000FFFF)
#define  USIT_USIT_SETTING00_M_hs_to_rdata_last_00(data)                         (0x0FFF0000&((data)<<16))
#define  USIT_USIT_SETTING00_M_setting_00_m(data)                                (0x0000FFFF&(data))
#define  USIT_USIT_SETTING00_M_get_hs_to_rdata_last_00(data)                     ((0x0FFF0000&(data))>>16)
#define  USIT_USIT_SETTING00_M_get_setting_00_m(data)                            (0x0000FFFF&(data))

#define  USIT_USIT_SETTING01_L                                                  0x18026A28
#define  USIT_USIT_SETTING01_L_reg_addr                                          "0xB8026A28"
#define  USIT_USIT_SETTING01_L_reg                                               0xB8026A28
#define  USIT_USIT_SETTING01_L_inst_addr                                         "0x000A"
#define  set_USIT_USIT_SETTING01_L_reg(data)                                     (*((volatile unsigned int*)USIT_USIT_SETTING01_L_reg)=data)
#define  get_USIT_USIT_SETTING01_L_reg                                           (*((volatile unsigned int*)USIT_USIT_SETTING01_L_reg))
#define  USIT_USIT_SETTING01_L_setting_01_l_shift                                (0)
#define  USIT_USIT_SETTING01_L_setting_01_l_mask                                 (0xFFFFFFFF)
#define  USIT_USIT_SETTING01_L_setting_01_l(data)                                (0xFFFFFFFF&(data))
#define  USIT_USIT_SETTING01_L_get_setting_01_l(data)                            (0xFFFFFFFF&(data))

#define  USIT_USIT_SETTING01_M                                                  0x18026A2C
#define  USIT_USIT_SETTING01_M_reg_addr                                          "0xB8026A2C"
#define  USIT_USIT_SETTING01_M_reg                                               0xB8026A2C
#define  USIT_USIT_SETTING01_M_inst_addr                                         "0x000B"
#define  set_USIT_USIT_SETTING01_M_reg(data)                                     (*((volatile unsigned int*)USIT_USIT_SETTING01_M_reg)=data)
#define  get_USIT_USIT_SETTING01_M_reg                                           (*((volatile unsigned int*)USIT_USIT_SETTING01_M_reg))
#define  USIT_USIT_SETTING01_M_hs_to_rdata_last_01_shift                         (16)
#define  USIT_USIT_SETTING01_M_setting_01_m_shift                                (0)
#define  USIT_USIT_SETTING01_M_hs_to_rdata_last_01_mask                          (0x0FFF0000)
#define  USIT_USIT_SETTING01_M_setting_01_m_mask                                 (0x0000FFFF)
#define  USIT_USIT_SETTING01_M_hs_to_rdata_last_01(data)                         (0x0FFF0000&((data)<<16))
#define  USIT_USIT_SETTING01_M_setting_01_m(data)                                (0x0000FFFF&(data))
#define  USIT_USIT_SETTING01_M_get_hs_to_rdata_last_01(data)                     ((0x0FFF0000&(data))>>16)
#define  USIT_USIT_SETTING01_M_get_setting_01_m(data)                            (0x0000FFFF&(data))

#define  USIT_USIT_SETTING02_L                                                  0x18026A30
#define  USIT_USIT_SETTING02_L_reg_addr                                          "0xB8026A30"
#define  USIT_USIT_SETTING02_L_reg                                               0xB8026A30
#define  USIT_USIT_SETTING02_L_inst_addr                                         "0x000C"
#define  set_USIT_USIT_SETTING02_L_reg(data)                                     (*((volatile unsigned int*)USIT_USIT_SETTING02_L_reg)=data)
#define  get_USIT_USIT_SETTING02_L_reg                                           (*((volatile unsigned int*)USIT_USIT_SETTING02_L_reg))
#define  USIT_USIT_SETTING02_L_setting_02_l_shift                                (0)
#define  USIT_USIT_SETTING02_L_setting_02_l_mask                                 (0xFFFFFFFF)
#define  USIT_USIT_SETTING02_L_setting_02_l(data)                                (0xFFFFFFFF&(data))
#define  USIT_USIT_SETTING02_L_get_setting_02_l(data)                            (0xFFFFFFFF&(data))

#define  USIT_USIT_SETTING02_M                                                  0x18026A34
#define  USIT_USIT_SETTING02_M_reg_addr                                          "0xB8026A34"
#define  USIT_USIT_SETTING02_M_reg                                               0xB8026A34
#define  USIT_USIT_SETTING02_M_inst_addr                                         "0x000D"
#define  set_USIT_USIT_SETTING02_M_reg(data)                                     (*((volatile unsigned int*)USIT_USIT_SETTING02_M_reg)=data)
#define  get_USIT_USIT_SETTING02_M_reg                                           (*((volatile unsigned int*)USIT_USIT_SETTING02_M_reg))
#define  USIT_USIT_SETTING02_M_hs_to_rdata_last_02_shift                         (16)
#define  USIT_USIT_SETTING02_M_setting_02_m_shift                                (0)
#define  USIT_USIT_SETTING02_M_hs_to_rdata_last_02_mask                          (0x0FFF0000)
#define  USIT_USIT_SETTING02_M_setting_02_m_mask                                 (0x0000FFFF)
#define  USIT_USIT_SETTING02_M_hs_to_rdata_last_02(data)                         (0x0FFF0000&((data)<<16))
#define  USIT_USIT_SETTING02_M_setting_02_m(data)                                (0x0000FFFF&(data))
#define  USIT_USIT_SETTING02_M_get_hs_to_rdata_last_02(data)                     ((0x0FFF0000&(data))>>16)
#define  USIT_USIT_SETTING02_M_get_setting_02_m(data)                            (0x0000FFFF&(data))

#define  USIT_USIT_SETTING03_L                                                  0x18026A38
#define  USIT_USIT_SETTING03_L_reg_addr                                          "0xB8026A38"
#define  USIT_USIT_SETTING03_L_reg                                               0xB8026A38
#define  USIT_USIT_SETTING03_L_inst_addr                                         "0x000E"
#define  set_USIT_USIT_SETTING03_L_reg(data)                                     (*((volatile unsigned int*)USIT_USIT_SETTING03_L_reg)=data)
#define  get_USIT_USIT_SETTING03_L_reg                                           (*((volatile unsigned int*)USIT_USIT_SETTING03_L_reg))
#define  USIT_USIT_SETTING03_L_setting_03_l_shift                                (0)
#define  USIT_USIT_SETTING03_L_setting_03_l_mask                                 (0xFFFFFFFF)
#define  USIT_USIT_SETTING03_L_setting_03_l(data)                                (0xFFFFFFFF&(data))
#define  USIT_USIT_SETTING03_L_get_setting_03_l(data)                            (0xFFFFFFFF&(data))

#define  USIT_USIT_SETTING03_M                                                  0x18026A3C
#define  USIT_USIT_SETTING03_M_reg_addr                                          "0xB8026A3C"
#define  USIT_USIT_SETTING03_M_reg                                               0xB8026A3C
#define  USIT_USIT_SETTING03_M_inst_addr                                         "0x000F"
#define  set_USIT_USIT_SETTING03_M_reg(data)                                     (*((volatile unsigned int*)USIT_USIT_SETTING03_M_reg)=data)
#define  get_USIT_USIT_SETTING03_M_reg                                           (*((volatile unsigned int*)USIT_USIT_SETTING03_M_reg))
#define  USIT_USIT_SETTING03_M_hs_to_rdata_last_03_shift                         (16)
#define  USIT_USIT_SETTING03_M_setting_03_m_shift                                (0)
#define  USIT_USIT_SETTING03_M_hs_to_rdata_last_03_mask                          (0x0FFF0000)
#define  USIT_USIT_SETTING03_M_setting_03_m_mask                                 (0x0000FFFF)
#define  USIT_USIT_SETTING03_M_hs_to_rdata_last_03(data)                         (0x0FFF0000&((data)<<16))
#define  USIT_USIT_SETTING03_M_setting_03_m(data)                                (0x0000FFFF&(data))
#define  USIT_USIT_SETTING03_M_get_hs_to_rdata_last_03(data)                     ((0x0FFF0000&(data))>>16)
#define  USIT_USIT_SETTING03_M_get_setting_03_m(data)                            (0x0000FFFF&(data))

#define  USIT_USIT_SETTING04_L                                                  0x18026A40
#define  USIT_USIT_SETTING04_L_reg_addr                                          "0xB8026A40"
#define  USIT_USIT_SETTING04_L_reg                                               0xB8026A40
#define  USIT_USIT_SETTING04_L_inst_addr                                         "0x0010"
#define  set_USIT_USIT_SETTING04_L_reg(data)                                     (*((volatile unsigned int*)USIT_USIT_SETTING04_L_reg)=data)
#define  get_USIT_USIT_SETTING04_L_reg                                           (*((volatile unsigned int*)USIT_USIT_SETTING04_L_reg))
#define  USIT_USIT_SETTING04_L_setting_04_l_shift                                (0)
#define  USIT_USIT_SETTING04_L_setting_04_l_mask                                 (0xFFFFFFFF)
#define  USIT_USIT_SETTING04_L_setting_04_l(data)                                (0xFFFFFFFF&(data))
#define  USIT_USIT_SETTING04_L_get_setting_04_l(data)                            (0xFFFFFFFF&(data))

#define  USIT_USIT_SETTING04_M                                                  0x18026A44
#define  USIT_USIT_SETTING04_M_reg_addr                                          "0xB8026A44"
#define  USIT_USIT_SETTING04_M_reg                                               0xB8026A44
#define  USIT_USIT_SETTING04_M_inst_addr                                         "0x0011"
#define  set_USIT_USIT_SETTING04_M_reg(data)                                     (*((volatile unsigned int*)USIT_USIT_SETTING04_M_reg)=data)
#define  get_USIT_USIT_SETTING04_M_reg                                           (*((volatile unsigned int*)USIT_USIT_SETTING04_M_reg))
#define  USIT_USIT_SETTING04_M_hs_to_rdata_last_04_shift                         (16)
#define  USIT_USIT_SETTING04_M_setting_04_m_shift                                (0)
#define  USIT_USIT_SETTING04_M_hs_to_rdata_last_04_mask                          (0x0FFF0000)
#define  USIT_USIT_SETTING04_M_setting_04_m_mask                                 (0x0000FFFF)
#define  USIT_USIT_SETTING04_M_hs_to_rdata_last_04(data)                         (0x0FFF0000&((data)<<16))
#define  USIT_USIT_SETTING04_M_setting_04_m(data)                                (0x0000FFFF&(data))
#define  USIT_USIT_SETTING04_M_get_hs_to_rdata_last_04(data)                     ((0x0FFF0000&(data))>>16)
#define  USIT_USIT_SETTING04_M_get_setting_04_m(data)                            (0x0000FFFF&(data))

#define  USIT_USIT_SETTING05_L                                                  0x18026A48
#define  USIT_USIT_SETTING05_L_reg_addr                                          "0xB8026A48"
#define  USIT_USIT_SETTING05_L_reg                                               0xB8026A48
#define  USIT_USIT_SETTING05_L_inst_addr                                         "0x0012"
#define  set_USIT_USIT_SETTING05_L_reg(data)                                     (*((volatile unsigned int*)USIT_USIT_SETTING05_L_reg)=data)
#define  get_USIT_USIT_SETTING05_L_reg                                           (*((volatile unsigned int*)USIT_USIT_SETTING05_L_reg))
#define  USIT_USIT_SETTING05_L_setting_05_l_shift                                (0)
#define  USIT_USIT_SETTING05_L_setting_05_l_mask                                 (0xFFFFFFFF)
#define  USIT_USIT_SETTING05_L_setting_05_l(data)                                (0xFFFFFFFF&(data))
#define  USIT_USIT_SETTING05_L_get_setting_05_l(data)                            (0xFFFFFFFF&(data))

#define  USIT_USIT_SETTING05_M                                                  0x18026A4C
#define  USIT_USIT_SETTING05_M_reg_addr                                          "0xB8026A4C"
#define  USIT_USIT_SETTING05_M_reg                                               0xB8026A4C
#define  USIT_USIT_SETTING05_M_inst_addr                                         "0x0013"
#define  set_USIT_USIT_SETTING05_M_reg(data)                                     (*((volatile unsigned int*)USIT_USIT_SETTING05_M_reg)=data)
#define  get_USIT_USIT_SETTING05_M_reg                                           (*((volatile unsigned int*)USIT_USIT_SETTING05_M_reg))
#define  USIT_USIT_SETTING05_M_hs_to_rdata_last_05_shift                         (16)
#define  USIT_USIT_SETTING05_M_setting_05_m_shift                                (0)
#define  USIT_USIT_SETTING05_M_hs_to_rdata_last_05_mask                          (0x0FFF0000)
#define  USIT_USIT_SETTING05_M_setting_05_m_mask                                 (0x0000FFFF)
#define  USIT_USIT_SETTING05_M_hs_to_rdata_last_05(data)                         (0x0FFF0000&((data)<<16))
#define  USIT_USIT_SETTING05_M_setting_05_m(data)                                (0x0000FFFF&(data))
#define  USIT_USIT_SETTING05_M_get_hs_to_rdata_last_05(data)                     ((0x0FFF0000&(data))>>16)
#define  USIT_USIT_SETTING05_M_get_setting_05_m(data)                            (0x0000FFFF&(data))

#define  USIT_USIT_SETTING06_L                                                  0x18026A50
#define  USIT_USIT_SETTING06_L_reg_addr                                          "0xB8026A50"
#define  USIT_USIT_SETTING06_L_reg                                               0xB8026A50
#define  USIT_USIT_SETTING06_L_inst_addr                                         "0x0014"
#define  set_USIT_USIT_SETTING06_L_reg(data)                                     (*((volatile unsigned int*)USIT_USIT_SETTING06_L_reg)=data)
#define  get_USIT_USIT_SETTING06_L_reg                                           (*((volatile unsigned int*)USIT_USIT_SETTING06_L_reg))
#define  USIT_USIT_SETTING06_L_setting_06_l_shift                                (0)
#define  USIT_USIT_SETTING06_L_setting_06_l_mask                                 (0xFFFFFFFF)
#define  USIT_USIT_SETTING06_L_setting_06_l(data)                                (0xFFFFFFFF&(data))
#define  USIT_USIT_SETTING06_L_get_setting_06_l(data)                            (0xFFFFFFFF&(data))

#define  USIT_USIT_SETTING06_M                                                  0x18026A54
#define  USIT_USIT_SETTING06_M_reg_addr                                          "0xB8026A54"
#define  USIT_USIT_SETTING06_M_reg                                               0xB8026A54
#define  USIT_USIT_SETTING06_M_inst_addr                                         "0x0015"
#define  set_USIT_USIT_SETTING06_M_reg(data)                                     (*((volatile unsigned int*)USIT_USIT_SETTING06_M_reg)=data)
#define  get_USIT_USIT_SETTING06_M_reg                                           (*((volatile unsigned int*)USIT_USIT_SETTING06_M_reg))
#define  USIT_USIT_SETTING06_M_hs_to_rdata_last_06_shift                         (16)
#define  USIT_USIT_SETTING06_M_setting_06_m_shift                                (0)
#define  USIT_USIT_SETTING06_M_hs_to_rdata_last_06_mask                          (0x0FFF0000)
#define  USIT_USIT_SETTING06_M_setting_06_m_mask                                 (0x0000FFFF)
#define  USIT_USIT_SETTING06_M_hs_to_rdata_last_06(data)                         (0x0FFF0000&((data)<<16))
#define  USIT_USIT_SETTING06_M_setting_06_m(data)                                (0x0000FFFF&(data))
#define  USIT_USIT_SETTING06_M_get_hs_to_rdata_last_06(data)                     ((0x0FFF0000&(data))>>16)
#define  USIT_USIT_SETTING06_M_get_setting_06_m(data)                            (0x0000FFFF&(data))

#define  USIT_USIT_SETTING07_L                                                  0x18026A58
#define  USIT_USIT_SETTING07_L_reg_addr                                          "0xB8026A58"
#define  USIT_USIT_SETTING07_L_reg                                               0xB8026A58
#define  USIT_USIT_SETTING07_L_inst_addr                                         "0x0016"
#define  set_USIT_USIT_SETTING07_L_reg(data)                                     (*((volatile unsigned int*)USIT_USIT_SETTING07_L_reg)=data)
#define  get_USIT_USIT_SETTING07_L_reg                                           (*((volatile unsigned int*)USIT_USIT_SETTING07_L_reg))
#define  USIT_USIT_SETTING07_L_setting_07_l_shift                                (0)
#define  USIT_USIT_SETTING07_L_setting_07_l_mask                                 (0xFFFFFFFF)
#define  USIT_USIT_SETTING07_L_setting_07_l(data)                                (0xFFFFFFFF&(data))
#define  USIT_USIT_SETTING07_L_get_setting_07_l(data)                            (0xFFFFFFFF&(data))

#define  USIT_USIT_SETTING07_M                                                  0x18026A5C
#define  USIT_USIT_SETTING07_M_reg_addr                                          "0xB8026A5C"
#define  USIT_USIT_SETTING07_M_reg                                               0xB8026A5C
#define  USIT_USIT_SETTING07_M_inst_addr                                         "0x0017"
#define  set_USIT_USIT_SETTING07_M_reg(data)                                     (*((volatile unsigned int*)USIT_USIT_SETTING07_M_reg)=data)
#define  get_USIT_USIT_SETTING07_M_reg                                           (*((volatile unsigned int*)USIT_USIT_SETTING07_M_reg))
#define  USIT_USIT_SETTING07_M_hs_to_rdata_last_07_shift                         (16)
#define  USIT_USIT_SETTING07_M_setting_07_m_shift                                (0)
#define  USIT_USIT_SETTING07_M_hs_to_rdata_last_07_mask                          (0x0FFF0000)
#define  USIT_USIT_SETTING07_M_setting_07_m_mask                                 (0x0000FFFF)
#define  USIT_USIT_SETTING07_M_hs_to_rdata_last_07(data)                         (0x0FFF0000&((data)<<16))
#define  USIT_USIT_SETTING07_M_setting_07_m(data)                                (0x0000FFFF&(data))
#define  USIT_USIT_SETTING07_M_get_hs_to_rdata_last_07(data)                     ((0x0FFF0000&(data))>>16)
#define  USIT_USIT_SETTING07_M_get_setting_07_m(data)                            (0x0000FFFF&(data))

#define  USIT_USIT_SETTING08_L                                                  0x18026A60
#define  USIT_USIT_SETTING08_L_reg_addr                                          "0xB8026A60"
#define  USIT_USIT_SETTING08_L_reg                                               0xB8026A60
#define  USIT_USIT_SETTING08_L_inst_addr                                         "0x0018"
#define  set_USIT_USIT_SETTING08_L_reg(data)                                     (*((volatile unsigned int*)USIT_USIT_SETTING08_L_reg)=data)
#define  get_USIT_USIT_SETTING08_L_reg                                           (*((volatile unsigned int*)USIT_USIT_SETTING08_L_reg))
#define  USIT_USIT_SETTING08_L_setting_08_l_shift                                (0)
#define  USIT_USIT_SETTING08_L_setting_08_l_mask                                 (0xFFFFFFFF)
#define  USIT_USIT_SETTING08_L_setting_08_l(data)                                (0xFFFFFFFF&(data))
#define  USIT_USIT_SETTING08_L_get_setting_08_l(data)                            (0xFFFFFFFF&(data))

#define  USIT_USIT_SETTING08_M                                                  0x18026A64
#define  USIT_USIT_SETTING08_M_reg_addr                                          "0xB8026A64"
#define  USIT_USIT_SETTING08_M_reg                                               0xB8026A64
#define  USIT_USIT_SETTING08_M_inst_addr                                         "0x0019"
#define  set_USIT_USIT_SETTING08_M_reg(data)                                     (*((volatile unsigned int*)USIT_USIT_SETTING08_M_reg)=data)
#define  get_USIT_USIT_SETTING08_M_reg                                           (*((volatile unsigned int*)USIT_USIT_SETTING08_M_reg))
#define  USIT_USIT_SETTING08_M_hs_to_rdata_last_08_shift                         (16)
#define  USIT_USIT_SETTING08_M_setting_08_m_shift                                (0)
#define  USIT_USIT_SETTING08_M_hs_to_rdata_last_08_mask                          (0x0FFF0000)
#define  USIT_USIT_SETTING08_M_setting_08_m_mask                                 (0x0000FFFF)
#define  USIT_USIT_SETTING08_M_hs_to_rdata_last_08(data)                         (0x0FFF0000&((data)<<16))
#define  USIT_USIT_SETTING08_M_setting_08_m(data)                                (0x0000FFFF&(data))
#define  USIT_USIT_SETTING08_M_get_hs_to_rdata_last_08(data)                     ((0x0FFF0000&(data))>>16)
#define  USIT_USIT_SETTING08_M_get_setting_08_m(data)                            (0x0000FFFF&(data))

#define  USIT_USIT_SETTING09_L                                                  0x18026A68
#define  USIT_USIT_SETTING09_L_reg_addr                                          "0xB8026A68"
#define  USIT_USIT_SETTING09_L_reg                                               0xB8026A68
#define  USIT_USIT_SETTING09_L_inst_addr                                         "0x001A"
#define  set_USIT_USIT_SETTING09_L_reg(data)                                     (*((volatile unsigned int*)USIT_USIT_SETTING09_L_reg)=data)
#define  get_USIT_USIT_SETTING09_L_reg                                           (*((volatile unsigned int*)USIT_USIT_SETTING09_L_reg))
#define  USIT_USIT_SETTING09_L_setting_09_l_shift                                (0)
#define  USIT_USIT_SETTING09_L_setting_09_l_mask                                 (0xFFFFFFFF)
#define  USIT_USIT_SETTING09_L_setting_09_l(data)                                (0xFFFFFFFF&(data))
#define  USIT_USIT_SETTING09_L_get_setting_09_l(data)                            (0xFFFFFFFF&(data))

#define  USIT_USIT_SETTING09_M                                                  0x18026A6C
#define  USIT_USIT_SETTING09_M_reg_addr                                          "0xB8026A6C"
#define  USIT_USIT_SETTING09_M_reg                                               0xB8026A6C
#define  USIT_USIT_SETTING09_M_inst_addr                                         "0x001B"
#define  set_USIT_USIT_SETTING09_M_reg(data)                                     (*((volatile unsigned int*)USIT_USIT_SETTING09_M_reg)=data)
#define  get_USIT_USIT_SETTING09_M_reg                                           (*((volatile unsigned int*)USIT_USIT_SETTING09_M_reg))
#define  USIT_USIT_SETTING09_M_hs_to_rdata_last_09_shift                         (16)
#define  USIT_USIT_SETTING09_M_setting_09_m_shift                                (0)
#define  USIT_USIT_SETTING09_M_hs_to_rdata_last_09_mask                          (0x0FFF0000)
#define  USIT_USIT_SETTING09_M_setting_09_m_mask                                 (0x0000FFFF)
#define  USIT_USIT_SETTING09_M_hs_to_rdata_last_09(data)                         (0x0FFF0000&((data)<<16))
#define  USIT_USIT_SETTING09_M_setting_09_m(data)                                (0x0000FFFF&(data))
#define  USIT_USIT_SETTING09_M_get_hs_to_rdata_last_09(data)                     ((0x0FFF0000&(data))>>16)
#define  USIT_USIT_SETTING09_M_get_setting_09_m(data)                            (0x0000FFFF&(data))

#define  USIT_USIT_SETTING10_L                                                  0x18026A70
#define  USIT_USIT_SETTING10_L_reg_addr                                          "0xB8026A70"
#define  USIT_USIT_SETTING10_L_reg                                               0xB8026A70
#define  USIT_USIT_SETTING10_L_inst_addr                                         "0x001C"
#define  set_USIT_USIT_SETTING10_L_reg(data)                                     (*((volatile unsigned int*)USIT_USIT_SETTING10_L_reg)=data)
#define  get_USIT_USIT_SETTING10_L_reg                                           (*((volatile unsigned int*)USIT_USIT_SETTING10_L_reg))
#define  USIT_USIT_SETTING10_L_setting_10_l_shift                                (0)
#define  USIT_USIT_SETTING10_L_setting_10_l_mask                                 (0xFFFFFFFF)
#define  USIT_USIT_SETTING10_L_setting_10_l(data)                                (0xFFFFFFFF&(data))
#define  USIT_USIT_SETTING10_L_get_setting_10_l(data)                            (0xFFFFFFFF&(data))

#define  USIT_USIT_SETTING10_M                                                  0x18026A74
#define  USIT_USIT_SETTING10_M_reg_addr                                          "0xB8026A74"
#define  USIT_USIT_SETTING10_M_reg                                               0xB8026A74
#define  USIT_USIT_SETTING10_M_inst_addr                                         "0x001D"
#define  set_USIT_USIT_SETTING10_M_reg(data)                                     (*((volatile unsigned int*)USIT_USIT_SETTING10_M_reg)=data)
#define  get_USIT_USIT_SETTING10_M_reg                                           (*((volatile unsigned int*)USIT_USIT_SETTING10_M_reg))
#define  USIT_USIT_SETTING10_M_hs_to_rdata_last_10_shift                         (16)
#define  USIT_USIT_SETTING10_M_setting_10_m_shift                                (0)
#define  USIT_USIT_SETTING10_M_hs_to_rdata_last_10_mask                          (0x0FFF0000)
#define  USIT_USIT_SETTING10_M_setting_10_m_mask                                 (0x0000FFFF)
#define  USIT_USIT_SETTING10_M_hs_to_rdata_last_10(data)                         (0x0FFF0000&((data)<<16))
#define  USIT_USIT_SETTING10_M_setting_10_m(data)                                (0x0000FFFF&(data))
#define  USIT_USIT_SETTING10_M_get_hs_to_rdata_last_10(data)                     ((0x0FFF0000&(data))>>16)
#define  USIT_USIT_SETTING10_M_get_setting_10_m(data)                            (0x0000FFFF&(data))

#define  USIT_USIT_SETTING11_L                                                  0x18026A78
#define  USIT_USIT_SETTING11_L_reg_addr                                          "0xB8026A78"
#define  USIT_USIT_SETTING11_L_reg                                               0xB8026A78
#define  USIT_USIT_SETTING11_L_inst_addr                                         "0x001E"
#define  set_USIT_USIT_SETTING11_L_reg(data)                                     (*((volatile unsigned int*)USIT_USIT_SETTING11_L_reg)=data)
#define  get_USIT_USIT_SETTING11_L_reg                                           (*((volatile unsigned int*)USIT_USIT_SETTING11_L_reg))
#define  USIT_USIT_SETTING11_L_setting_11_l_shift                                (0)
#define  USIT_USIT_SETTING11_L_setting_11_l_mask                                 (0xFFFFFFFF)
#define  USIT_USIT_SETTING11_L_setting_11_l(data)                                (0xFFFFFFFF&(data))
#define  USIT_USIT_SETTING11_L_get_setting_11_l(data)                            (0xFFFFFFFF&(data))

#define  USIT_USIT_SETTING11_M                                                  0x18026A7C
#define  USIT_USIT_SETTING11_M_reg_addr                                          "0xB8026A7C"
#define  USIT_USIT_SETTING11_M_reg                                               0xB8026A7C
#define  USIT_USIT_SETTING11_M_inst_addr                                         "0x001F"
#define  set_USIT_USIT_SETTING11_M_reg(data)                                     (*((volatile unsigned int*)USIT_USIT_SETTING11_M_reg)=data)
#define  get_USIT_USIT_SETTING11_M_reg                                           (*((volatile unsigned int*)USIT_USIT_SETTING11_M_reg))
#define  USIT_USIT_SETTING11_M_hs_to_rdata_last_11_shift                         (16)
#define  USIT_USIT_SETTING11_M_setting_11_m_shift                                (0)
#define  USIT_USIT_SETTING11_M_hs_to_rdata_last_11_mask                          (0x0FFF0000)
#define  USIT_USIT_SETTING11_M_setting_11_m_mask                                 (0x0000FFFF)
#define  USIT_USIT_SETTING11_M_hs_to_rdata_last_11(data)                         (0x0FFF0000&((data)<<16))
#define  USIT_USIT_SETTING11_M_setting_11_m(data)                                (0x0000FFFF&(data))
#define  USIT_USIT_SETTING11_M_get_hs_to_rdata_last_11(data)                     ((0x0FFF0000&(data))>>16)
#define  USIT_USIT_SETTING11_M_get_setting_11_m(data)                            (0x0000FFFF&(data))

#define  USIT_USIT_VGMA_00                                                      0x18026AA0
#define  USIT_USIT_VGMA_00_reg_addr                                              "0xB8026AA0"
#define  USIT_USIT_VGMA_00_reg                                                   0xB8026AA0
#define  USIT_USIT_VGMA_00_inst_addr                                             "0x0020"
#define  set_USIT_USIT_VGMA_00_reg(data)                                         (*((volatile unsigned int*)USIT_USIT_VGMA_00_reg)=data)
#define  get_USIT_USIT_VGMA_00_reg                                               (*((volatile unsigned int*)USIT_USIT_VGMA_00_reg))
#define  USIT_USIT_VGMA_00_vgma_00_shift                                         (0)
#define  USIT_USIT_VGMA_00_vgma_00_mask                                          (0xFFFFFFFF)
#define  USIT_USIT_VGMA_00_vgma_00(data)                                         (0xFFFFFFFF&(data))
#define  USIT_USIT_VGMA_00_get_vgma_00(data)                                     (0xFFFFFFFF&(data))

#define  USIT_USIT_VGMA_01                                                      0x18026AA4
#define  USIT_USIT_VGMA_01_reg_addr                                              "0xB8026AA4"
#define  USIT_USIT_VGMA_01_reg                                                   0xB8026AA4
#define  USIT_USIT_VGMA_01_inst_addr                                             "0x0021"
#define  set_USIT_USIT_VGMA_01_reg(data)                                         (*((volatile unsigned int*)USIT_USIT_VGMA_01_reg)=data)
#define  get_USIT_USIT_VGMA_01_reg                                               (*((volatile unsigned int*)USIT_USIT_VGMA_01_reg))
#define  USIT_USIT_VGMA_01_vgma_01_shift                                         (0)
#define  USIT_USIT_VGMA_01_vgma_01_mask                                          (0xFFFFFFFF)
#define  USIT_USIT_VGMA_01_vgma_01(data)                                         (0xFFFFFFFF&(data))
#define  USIT_USIT_VGMA_01_get_vgma_01(data)                                     (0xFFFFFFFF&(data))

#define  USIT_USIT_VGMA_02                                                      0x18026AA8
#define  USIT_USIT_VGMA_02_reg_addr                                              "0xB8026AA8"
#define  USIT_USIT_VGMA_02_reg                                                   0xB8026AA8
#define  USIT_USIT_VGMA_02_inst_addr                                             "0x0022"
#define  set_USIT_USIT_VGMA_02_reg(data)                                         (*((volatile unsigned int*)USIT_USIT_VGMA_02_reg)=data)
#define  get_USIT_USIT_VGMA_02_reg                                               (*((volatile unsigned int*)USIT_USIT_VGMA_02_reg))
#define  USIT_USIT_VGMA_02_vgma_02_shift                                         (0)
#define  USIT_USIT_VGMA_02_vgma_02_mask                                          (0xFFFFFFFF)
#define  USIT_USIT_VGMA_02_vgma_02(data)                                         (0xFFFFFFFF&(data))
#define  USIT_USIT_VGMA_02_get_vgma_02(data)                                     (0xFFFFFFFF&(data))

#define  USIT_USIT_VGMA_03                                                      0x18026AAC
#define  USIT_USIT_VGMA_03_reg_addr                                              "0xB8026AAC"
#define  USIT_USIT_VGMA_03_reg                                                   0xB8026AAC
#define  USIT_USIT_VGMA_03_inst_addr                                             "0x0023"
#define  set_USIT_USIT_VGMA_03_reg(data)                                         (*((volatile unsigned int*)USIT_USIT_VGMA_03_reg)=data)
#define  get_USIT_USIT_VGMA_03_reg                                               (*((volatile unsigned int*)USIT_USIT_VGMA_03_reg))
#define  USIT_USIT_VGMA_03_vgma_03_shift                                         (0)
#define  USIT_USIT_VGMA_03_vgma_03_mask                                          (0xFFFFFFFF)
#define  USIT_USIT_VGMA_03_vgma_03(data)                                         (0xFFFFFFFF&(data))
#define  USIT_USIT_VGMA_03_get_vgma_03(data)                                     (0xFFFFFFFF&(data))

#define  USIT_USIT_VGMA_04                                                      0x18026AB0
#define  USIT_USIT_VGMA_04_reg_addr                                              "0xB8026AB0"
#define  USIT_USIT_VGMA_04_reg                                                   0xB8026AB0
#define  USIT_USIT_VGMA_04_inst_addr                                             "0x0024"
#define  set_USIT_USIT_VGMA_04_reg(data)                                         (*((volatile unsigned int*)USIT_USIT_VGMA_04_reg)=data)
#define  get_USIT_USIT_VGMA_04_reg                                               (*((volatile unsigned int*)USIT_USIT_VGMA_04_reg))
#define  USIT_USIT_VGMA_04_vgma_04_shift                                         (0)
#define  USIT_USIT_VGMA_04_vgma_04_mask                                          (0xFFFFFFFF)
#define  USIT_USIT_VGMA_04_vgma_04(data)                                         (0xFFFFFFFF&(data))
#define  USIT_USIT_VGMA_04_get_vgma_04(data)                                     (0xFFFFFFFF&(data))

#define  USIT_USIT_VGMA_05                                                      0x18026AB4
#define  USIT_USIT_VGMA_05_reg_addr                                              "0xB8026AB4"
#define  USIT_USIT_VGMA_05_reg                                                   0xB8026AB4
#define  USIT_USIT_VGMA_05_inst_addr                                             "0x0025"
#define  set_USIT_USIT_VGMA_05_reg(data)                                         (*((volatile unsigned int*)USIT_USIT_VGMA_05_reg)=data)
#define  get_USIT_USIT_VGMA_05_reg                                               (*((volatile unsigned int*)USIT_USIT_VGMA_05_reg))
#define  USIT_USIT_VGMA_05_vgma_05_shift                                         (0)
#define  USIT_USIT_VGMA_05_vgma_05_mask                                          (0xFFFFFFFF)
#define  USIT_USIT_VGMA_05_vgma_05(data)                                         (0xFFFFFFFF&(data))
#define  USIT_USIT_VGMA_05_get_vgma_05(data)                                     (0xFFFFFFFF&(data))

#define  USIT_USIT_VGMA_06                                                      0x18026AB8
#define  USIT_USIT_VGMA_06_reg_addr                                              "0xB8026AB8"
#define  USIT_USIT_VGMA_06_reg                                                   0xB8026AB8
#define  USIT_USIT_VGMA_06_inst_addr                                             "0x0026"
#define  set_USIT_USIT_VGMA_06_reg(data)                                         (*((volatile unsigned int*)USIT_USIT_VGMA_06_reg)=data)
#define  get_USIT_USIT_VGMA_06_reg                                               (*((volatile unsigned int*)USIT_USIT_VGMA_06_reg))
#define  USIT_USIT_VGMA_06_vgma_06_shift                                         (0)
#define  USIT_USIT_VGMA_06_vgma_06_mask                                          (0xFFFFFFFF)
#define  USIT_USIT_VGMA_06_vgma_06(data)                                         (0xFFFFFFFF&(data))
#define  USIT_USIT_VGMA_06_get_vgma_06(data)                                     (0xFFFFFFFF&(data))

#define  USIT_USIT_VGMA_07                                                      0x18026ABC
#define  USIT_USIT_VGMA_07_reg_addr                                              "0xB8026ABC"
#define  USIT_USIT_VGMA_07_reg                                                   0xB8026ABC
#define  USIT_USIT_VGMA_07_inst_addr                                             "0x0027"
#define  set_USIT_USIT_VGMA_07_reg(data)                                         (*((volatile unsigned int*)USIT_USIT_VGMA_07_reg)=data)
#define  get_USIT_USIT_VGMA_07_reg                                               (*((volatile unsigned int*)USIT_USIT_VGMA_07_reg))
#define  USIT_USIT_VGMA_07_vgma_07_shift                                         (0)
#define  USIT_USIT_VGMA_07_vgma_07_mask                                          (0xFFFFFFFF)
#define  USIT_USIT_VGMA_07_vgma_07(data)                                         (0xFFFFFFFF&(data))
#define  USIT_USIT_VGMA_07_get_vgma_07(data)                                     (0xFFFFFFFF&(data))

#define  USIT_USIT_VGMA_08                                                      0x18026AC0
#define  USIT_USIT_VGMA_08_reg_addr                                              "0xB8026AC0"
#define  USIT_USIT_VGMA_08_reg                                                   0xB8026AC0
#define  USIT_USIT_VGMA_08_inst_addr                                             "0x0028"
#define  set_USIT_USIT_VGMA_08_reg(data)                                         (*((volatile unsigned int*)USIT_USIT_VGMA_08_reg)=data)
#define  get_USIT_USIT_VGMA_08_reg                                               (*((volatile unsigned int*)USIT_USIT_VGMA_08_reg))
#define  USIT_USIT_VGMA_08_vgma_08_shift                                         (0)
#define  USIT_USIT_VGMA_08_vgma_08_mask                                          (0xFFFFFFFF)
#define  USIT_USIT_VGMA_08_vgma_08(data)                                         (0xFFFFFFFF&(data))
#define  USIT_USIT_VGMA_08_get_vgma_08(data)                                     (0xFFFFFFFF&(data))

#define  USIT_USIT_VGMA_09                                                      0x18026AC4
#define  USIT_USIT_VGMA_09_reg_addr                                              "0xB8026AC4"
#define  USIT_USIT_VGMA_09_reg                                                   0xB8026AC4
#define  USIT_USIT_VGMA_09_inst_addr                                             "0x0029"
#define  set_USIT_USIT_VGMA_09_reg(data)                                         (*((volatile unsigned int*)USIT_USIT_VGMA_09_reg)=data)
#define  get_USIT_USIT_VGMA_09_reg                                               (*((volatile unsigned int*)USIT_USIT_VGMA_09_reg))
#define  USIT_USIT_VGMA_09_vgma_09_shift                                         (0)
#define  USIT_USIT_VGMA_09_vgma_09_mask                                          (0xFFFFFFFF)
#define  USIT_USIT_VGMA_09_vgma_09(data)                                         (0xFFFFFFFF&(data))
#define  USIT_USIT_VGMA_09_get_vgma_09(data)                                     (0xFFFFFFFF&(data))

#define  USIT_USIT_VGMA_10                                                      0x18026AC8
#define  USIT_USIT_VGMA_10_reg_addr                                              "0xB8026AC8"
#define  USIT_USIT_VGMA_10_reg                                                   0xB8026AC8
#define  USIT_USIT_VGMA_10_inst_addr                                             "0x002A"
#define  set_USIT_USIT_VGMA_10_reg(data)                                         (*((volatile unsigned int*)USIT_USIT_VGMA_10_reg)=data)
#define  get_USIT_USIT_VGMA_10_reg                                               (*((volatile unsigned int*)USIT_USIT_VGMA_10_reg))
#define  USIT_USIT_VGMA_10_vgma_10_shift                                         (0)
#define  USIT_USIT_VGMA_10_vgma_10_mask                                          (0xFFFFFFFF)
#define  USIT_USIT_VGMA_10_vgma_10(data)                                         (0xFFFFFFFF&(data))
#define  USIT_USIT_VGMA_10_get_vgma_10(data)                                     (0xFFFFFFFF&(data))

#define  USIT_USIT_VGMA_11                                                      0x18026ACC
#define  USIT_USIT_VGMA_11_reg_addr                                              "0xB8026ACC"
#define  USIT_USIT_VGMA_11_reg                                                   0xB8026ACC
#define  USIT_USIT_VGMA_11_inst_addr                                             "0x002B"
#define  set_USIT_USIT_VGMA_11_reg(data)                                         (*((volatile unsigned int*)USIT_USIT_VGMA_11_reg)=data)
#define  get_USIT_USIT_VGMA_11_reg                                               (*((volatile unsigned int*)USIT_USIT_VGMA_11_reg))
#define  USIT_USIT_VGMA_11_vgma_11_shift                                         (0)
#define  USIT_USIT_VGMA_11_vgma_11_mask                                          (0xFFFFFFFF)
#define  USIT_USIT_VGMA_11_vgma_11(data)                                         (0xFFFFFFFF&(data))
#define  USIT_USIT_VGMA_11_get_vgma_11(data)                                     (0xFFFFFFFF&(data))

#define  USIT_USIT_FRM_CONF_0                                                   0x18026AD0
#define  USIT_USIT_FRM_CONF_0_reg_addr                                           "0xB8026AD0"
#define  USIT_USIT_FRM_CONF_0_reg                                                0xB8026AD0
#define  USIT_USIT_FRM_CONF_0_inst_addr                                          "0x002C"
#define  set_USIT_USIT_FRM_CONF_0_reg(data)                                      (*((volatile unsigned int*)USIT_USIT_FRM_CONF_0_reg)=data)
#define  get_USIT_USIT_FRM_CONF_0_reg                                            (*((volatile unsigned int*)USIT_USIT_FRM_CONF_0_reg))
#define  USIT_USIT_FRM_CONF_0_frm_conf_00_shift                                  (0)
#define  USIT_USIT_FRM_CONF_0_frm_conf_00_mask                                   (0xFFFFFFFF)
#define  USIT_USIT_FRM_CONF_0_frm_conf_00(data)                                  (0xFFFFFFFF&(data))
#define  USIT_USIT_FRM_CONF_0_get_frm_conf_00(data)                              (0xFFFFFFFF&(data))

#define  USIT_USIT_FRM_CONF_1                                                   0x18026AD4
#define  USIT_USIT_FRM_CONF_1_reg_addr                                           "0xB8026AD4"
#define  USIT_USIT_FRM_CONF_1_reg                                                0xB8026AD4
#define  USIT_USIT_FRM_CONF_1_inst_addr                                          "0x002D"
#define  set_USIT_USIT_FRM_CONF_1_reg(data)                                      (*((volatile unsigned int*)USIT_USIT_FRM_CONF_1_reg)=data)
#define  get_USIT_USIT_FRM_CONF_1_reg                                            (*((volatile unsigned int*)USIT_USIT_FRM_CONF_1_reg))
#define  USIT_USIT_FRM_CONF_1_frm_conf_01_shift                                  (0)
#define  USIT_USIT_FRM_CONF_1_frm_conf_01_mask                                   (0xFFFFFFFF)
#define  USIT_USIT_FRM_CONF_1_frm_conf_01(data)                                  (0xFFFFFFFF&(data))
#define  USIT_USIT_FRM_CONF_1_get_frm_conf_01(data)                              (0xFFFFFFFF&(data))

#define  USIT_USIT_FRM_CONF_2                                                   0x18026AD8
#define  USIT_USIT_FRM_CONF_2_reg_addr                                           "0xB8026AD8"
#define  USIT_USIT_FRM_CONF_2_reg                                                0xB8026AD8
#define  USIT_USIT_FRM_CONF_2_inst_addr                                          "0x002E"
#define  set_USIT_USIT_FRM_CONF_2_reg(data)                                      (*((volatile unsigned int*)USIT_USIT_FRM_CONF_2_reg)=data)
#define  get_USIT_USIT_FRM_CONF_2_reg                                            (*((volatile unsigned int*)USIT_USIT_FRM_CONF_2_reg))
#define  USIT_USIT_FRM_CONF_2_frm_conf_02_shift                                  (0)
#define  USIT_USIT_FRM_CONF_2_frm_conf_02_mask                                   (0x000000FF)
#define  USIT_USIT_FRM_CONF_2_frm_conf_02(data)                                  (0x000000FF&(data))
#define  USIT_USIT_FRM_CONF_2_get_frm_conf_02(data)                              (0x000000FF&(data))

#define  USIT_USIT_TCON_ABCD                                                    0x18026B00
#define  USIT_USIT_TCON_ABCD_reg_addr                                            "0xB8026B00"
#define  USIT_USIT_TCON_ABCD_reg                                                 0xB8026B00
#define  USIT_USIT_TCON_ABCD_inst_addr                                           "0x002F"
#define  set_USIT_USIT_TCON_ABCD_reg(data)                                       (*((volatile unsigned int*)USIT_USIT_TCON_ABCD_reg)=data)
#define  get_USIT_USIT_TCON_ABCD_reg                                             (*((volatile unsigned int*)USIT_USIT_TCON_ABCD_reg))
#define  USIT_USIT_TCON_ABCD_tcon_d_sel_shift                                    (24)
#define  USIT_USIT_TCON_ABCD_tcon_c_sel_shift                                    (16)
#define  USIT_USIT_TCON_ABCD_tcon_b_sel_shift                                    (8)
#define  USIT_USIT_TCON_ABCD_tcon_a_sel_shift                                    (0)
#define  USIT_USIT_TCON_ABCD_tcon_d_sel_mask                                     (0x1F000000)
#define  USIT_USIT_TCON_ABCD_tcon_c_sel_mask                                     (0x001F0000)
#define  USIT_USIT_TCON_ABCD_tcon_b_sel_mask                                     (0x00001F00)
#define  USIT_USIT_TCON_ABCD_tcon_a_sel_mask                                     (0x0000001F)
#define  USIT_USIT_TCON_ABCD_tcon_d_sel(data)                                    (0x1F000000&((data)<<24))
#define  USIT_USIT_TCON_ABCD_tcon_c_sel(data)                                    (0x001F0000&((data)<<16))
#define  USIT_USIT_TCON_ABCD_tcon_b_sel(data)                                    (0x00001F00&((data)<<8))
#define  USIT_USIT_TCON_ABCD_tcon_a_sel(data)                                    (0x0000001F&(data))
#define  USIT_USIT_TCON_ABCD_get_tcon_d_sel(data)                                ((0x1F000000&(data))>>24)
#define  USIT_USIT_TCON_ABCD_get_tcon_c_sel(data)                                ((0x001F0000&(data))>>16)
#define  USIT_USIT_TCON_ABCD_get_tcon_b_sel(data)                                ((0x00001F00&(data))>>8)
#define  USIT_USIT_TCON_ABCD_get_tcon_a_sel(data)                                (0x0000001F&(data))

#define  USIT_USIT_TCON_EFGH                                                    0x18026B04
#define  USIT_USIT_TCON_EFGH_reg_addr                                            "0xB8026B04"
#define  USIT_USIT_TCON_EFGH_reg                                                 0xB8026B04
#define  USIT_USIT_TCON_EFGH_inst_addr                                           "0x0030"
#define  set_USIT_USIT_TCON_EFGH_reg(data)                                       (*((volatile unsigned int*)USIT_USIT_TCON_EFGH_reg)=data)
#define  get_USIT_USIT_TCON_EFGH_reg                                             (*((volatile unsigned int*)USIT_USIT_TCON_EFGH_reg))
#define  USIT_USIT_TCON_EFGH_tcon_h_sel_shift                                    (24)
#define  USIT_USIT_TCON_EFGH_tcon_g_sel_shift                                    (16)
#define  USIT_USIT_TCON_EFGH_tcon_f_sel_shift                                    (8)
#define  USIT_USIT_TCON_EFGH_tcon_e_sel_shift                                    (0)
#define  USIT_USIT_TCON_EFGH_tcon_h_sel_mask                                     (0x1F000000)
#define  USIT_USIT_TCON_EFGH_tcon_g_sel_mask                                     (0x001F0000)
#define  USIT_USIT_TCON_EFGH_tcon_f_sel_mask                                     (0x00001F00)
#define  USIT_USIT_TCON_EFGH_tcon_e_sel_mask                                     (0x0000001F)
#define  USIT_USIT_TCON_EFGH_tcon_h_sel(data)                                    (0x1F000000&((data)<<24))
#define  USIT_USIT_TCON_EFGH_tcon_g_sel(data)                                    (0x001F0000&((data)<<16))
#define  USIT_USIT_TCON_EFGH_tcon_f_sel(data)                                    (0x00001F00&((data)<<8))
#define  USIT_USIT_TCON_EFGH_tcon_e_sel(data)                                    (0x0000001F&(data))
#define  USIT_USIT_TCON_EFGH_get_tcon_h_sel(data)                                ((0x1F000000&(data))>>24)
#define  USIT_USIT_TCON_EFGH_get_tcon_g_sel(data)                                ((0x001F0000&(data))>>16)
#define  USIT_USIT_TCON_EFGH_get_tcon_f_sel(data)                                ((0x00001F00&(data))>>8)
#define  USIT_USIT_TCON_EFGH_get_tcon_e_sel(data)                                (0x0000001F&(data))

#define  USIT_USIT_MUX_00_07                                                    0x18026B10
#define  USIT_USIT_MUX_00_07_reg_addr                                            "0xB8026B10"
#define  USIT_USIT_MUX_00_07_reg                                                 0xB8026B10
#define  USIT_USIT_MUX_00_07_inst_addr                                           "0x0031"
#define  set_USIT_USIT_MUX_00_07_reg(data)                                       (*((volatile unsigned int*)USIT_USIT_MUX_00_07_reg)=data)
#define  get_USIT_USIT_MUX_00_07_reg                                             (*((volatile unsigned int*)USIT_USIT_MUX_00_07_reg))
#define  USIT_USIT_MUX_00_07_lane_c07_sel_shift                                  (28)
#define  USIT_USIT_MUX_00_07_lane_c06_sel_shift                                  (24)
#define  USIT_USIT_MUX_00_07_lane_c05_sel_shift                                  (20)
#define  USIT_USIT_MUX_00_07_lane_c04_sel_shift                                  (16)
#define  USIT_USIT_MUX_00_07_lane_c03_sel_shift                                  (12)
#define  USIT_USIT_MUX_00_07_lane_c02_sel_shift                                  (8)
#define  USIT_USIT_MUX_00_07_lane_c01_sel_shift                                  (4)
#define  USIT_USIT_MUX_00_07_lane_c00_sel_shift                                  (0)
#define  USIT_USIT_MUX_00_07_lane_c07_sel_mask                                   (0xF0000000)
#define  USIT_USIT_MUX_00_07_lane_c06_sel_mask                                   (0x0F000000)
#define  USIT_USIT_MUX_00_07_lane_c05_sel_mask                                   (0x00F00000)
#define  USIT_USIT_MUX_00_07_lane_c04_sel_mask                                   (0x000F0000)
#define  USIT_USIT_MUX_00_07_lane_c03_sel_mask                                   (0x0000F000)
#define  USIT_USIT_MUX_00_07_lane_c02_sel_mask                                   (0x00000F00)
#define  USIT_USIT_MUX_00_07_lane_c01_sel_mask                                   (0x000000F0)
#define  USIT_USIT_MUX_00_07_lane_c00_sel_mask                                   (0x0000000F)
#define  USIT_USIT_MUX_00_07_lane_c07_sel(data)                                  (0xF0000000&((data)<<28))
#define  USIT_USIT_MUX_00_07_lane_c06_sel(data)                                  (0x0F000000&((data)<<24))
#define  USIT_USIT_MUX_00_07_lane_c05_sel(data)                                  (0x00F00000&((data)<<20))
#define  USIT_USIT_MUX_00_07_lane_c04_sel(data)                                  (0x000F0000&((data)<<16))
#define  USIT_USIT_MUX_00_07_lane_c03_sel(data)                                  (0x0000F000&((data)<<12))
#define  USIT_USIT_MUX_00_07_lane_c02_sel(data)                                  (0x00000F00&((data)<<8))
#define  USIT_USIT_MUX_00_07_lane_c01_sel(data)                                  (0x000000F0&((data)<<4))
#define  USIT_USIT_MUX_00_07_lane_c00_sel(data)                                  (0x0000000F&(data))
#define  USIT_USIT_MUX_00_07_get_lane_c07_sel(data)                              ((0xF0000000&(data))>>28)
#define  USIT_USIT_MUX_00_07_get_lane_c06_sel(data)                              ((0x0F000000&(data))>>24)
#define  USIT_USIT_MUX_00_07_get_lane_c05_sel(data)                              ((0x00F00000&(data))>>20)
#define  USIT_USIT_MUX_00_07_get_lane_c04_sel(data)                              ((0x000F0000&(data))>>16)
#define  USIT_USIT_MUX_00_07_get_lane_c03_sel(data)                              ((0x0000F000&(data))>>12)
#define  USIT_USIT_MUX_00_07_get_lane_c02_sel(data)                              ((0x00000F00&(data))>>8)
#define  USIT_USIT_MUX_00_07_get_lane_c01_sel(data)                              ((0x000000F0&(data))>>4)
#define  USIT_USIT_MUX_00_07_get_lane_c00_sel(data)                              (0x0000000F&(data))

#define  USIT_USIT_MUX_08_15                                                    0x18026B14
#define  USIT_USIT_MUX_08_15_reg_addr                                            "0xB8026B14"
#define  USIT_USIT_MUX_08_15_reg                                                 0xB8026B14
#define  USIT_USIT_MUX_08_15_inst_addr                                           "0x0032"
#define  set_USIT_USIT_MUX_08_15_reg(data)                                       (*((volatile unsigned int*)USIT_USIT_MUX_08_15_reg)=data)
#define  get_USIT_USIT_MUX_08_15_reg                                             (*((volatile unsigned int*)USIT_USIT_MUX_08_15_reg))
#define  USIT_USIT_MUX_08_15_lane_c15_sel_shift                                  (28)
#define  USIT_USIT_MUX_08_15_lane_c14_sel_shift                                  (24)
#define  USIT_USIT_MUX_08_15_lane_c13_sel_shift                                  (20)
#define  USIT_USIT_MUX_08_15_lane_c12_sel_shift                                  (16)
#define  USIT_USIT_MUX_08_15_lane_c11_sel_shift                                  (12)
#define  USIT_USIT_MUX_08_15_lane_c10_sel_shift                                  (8)
#define  USIT_USIT_MUX_08_15_lane_c09_sel_shift                                  (4)
#define  USIT_USIT_MUX_08_15_lane_c08_sel_shift                                  (0)
#define  USIT_USIT_MUX_08_15_lane_c15_sel_mask                                   (0xF0000000)
#define  USIT_USIT_MUX_08_15_lane_c14_sel_mask                                   (0x0F000000)
#define  USIT_USIT_MUX_08_15_lane_c13_sel_mask                                   (0x00F00000)
#define  USIT_USIT_MUX_08_15_lane_c12_sel_mask                                   (0x000F0000)
#define  USIT_USIT_MUX_08_15_lane_c11_sel_mask                                   (0x0000F000)
#define  USIT_USIT_MUX_08_15_lane_c10_sel_mask                                   (0x00000F00)
#define  USIT_USIT_MUX_08_15_lane_c09_sel_mask                                   (0x000000F0)
#define  USIT_USIT_MUX_08_15_lane_c08_sel_mask                                   (0x0000000F)
#define  USIT_USIT_MUX_08_15_lane_c15_sel(data)                                  (0xF0000000&((data)<<28))
#define  USIT_USIT_MUX_08_15_lane_c14_sel(data)                                  (0x0F000000&((data)<<24))
#define  USIT_USIT_MUX_08_15_lane_c13_sel(data)                                  (0x00F00000&((data)<<20))
#define  USIT_USIT_MUX_08_15_lane_c12_sel(data)                                  (0x000F0000&((data)<<16))
#define  USIT_USIT_MUX_08_15_lane_c11_sel(data)                                  (0x0000F000&((data)<<12))
#define  USIT_USIT_MUX_08_15_lane_c10_sel(data)                                  (0x00000F00&((data)<<8))
#define  USIT_USIT_MUX_08_15_lane_c09_sel(data)                                  (0x000000F0&((data)<<4))
#define  USIT_USIT_MUX_08_15_lane_c08_sel(data)                                  (0x0000000F&(data))
#define  USIT_USIT_MUX_08_15_get_lane_c15_sel(data)                              ((0xF0000000&(data))>>28)
#define  USIT_USIT_MUX_08_15_get_lane_c14_sel(data)                              ((0x0F000000&(data))>>24)
#define  USIT_USIT_MUX_08_15_get_lane_c13_sel(data)                              ((0x00F00000&(data))>>20)
#define  USIT_USIT_MUX_08_15_get_lane_c12_sel(data)                              ((0x000F0000&(data))>>16)
#define  USIT_USIT_MUX_08_15_get_lane_c11_sel(data)                              ((0x0000F000&(data))>>12)
#define  USIT_USIT_MUX_08_15_get_lane_c10_sel(data)                              ((0x00000F00&(data))>>8)
#define  USIT_USIT_MUX_08_15_get_lane_c09_sel(data)                              ((0x000000F0&(data))>>4)
#define  USIT_USIT_MUX_08_15_get_lane_c08_sel(data)                              (0x0000000F&(data))

#define  USIT_USIT_MUX_16_23                                                    0x18026B18
#define  USIT_USIT_MUX_16_23_reg_addr                                            "0xB8026B18"
#define  USIT_USIT_MUX_16_23_reg                                                 0xB8026B18
#define  USIT_USIT_MUX_16_23_inst_addr                                           "0x0033"
#define  set_USIT_USIT_MUX_16_23_reg(data)                                       (*((volatile unsigned int*)USIT_USIT_MUX_16_23_reg)=data)
#define  get_USIT_USIT_MUX_16_23_reg                                             (*((volatile unsigned int*)USIT_USIT_MUX_16_23_reg))
#define  USIT_USIT_MUX_16_23_lane_c23_sel_shift                                  (28)
#define  USIT_USIT_MUX_16_23_lane_c22_sel_shift                                  (24)
#define  USIT_USIT_MUX_16_23_lane_c21_sel_shift                                  (20)
#define  USIT_USIT_MUX_16_23_lane_c20_sel_shift                                  (16)
#define  USIT_USIT_MUX_16_23_lane_c19_sel_shift                                  (12)
#define  USIT_USIT_MUX_16_23_lane_c18_sel_shift                                  (8)
#define  USIT_USIT_MUX_16_23_lane_c17_sel_shift                                  (4)
#define  USIT_USIT_MUX_16_23_lane_c16_sel_shift                                  (0)
#define  USIT_USIT_MUX_16_23_lane_c23_sel_mask                                   (0xF0000000)
#define  USIT_USIT_MUX_16_23_lane_c22_sel_mask                                   (0x0F000000)
#define  USIT_USIT_MUX_16_23_lane_c21_sel_mask                                   (0x00F00000)
#define  USIT_USIT_MUX_16_23_lane_c20_sel_mask                                   (0x000F0000)
#define  USIT_USIT_MUX_16_23_lane_c19_sel_mask                                   (0x0000F000)
#define  USIT_USIT_MUX_16_23_lane_c18_sel_mask                                   (0x00000F00)
#define  USIT_USIT_MUX_16_23_lane_c17_sel_mask                                   (0x000000F0)
#define  USIT_USIT_MUX_16_23_lane_c16_sel_mask                                   (0x0000000F)
#define  USIT_USIT_MUX_16_23_lane_c23_sel(data)                                  (0xF0000000&((data)<<28))
#define  USIT_USIT_MUX_16_23_lane_c22_sel(data)                                  (0x0F000000&((data)<<24))
#define  USIT_USIT_MUX_16_23_lane_c21_sel(data)                                  (0x00F00000&((data)<<20))
#define  USIT_USIT_MUX_16_23_lane_c20_sel(data)                                  (0x000F0000&((data)<<16))
#define  USIT_USIT_MUX_16_23_lane_c19_sel(data)                                  (0x0000F000&((data)<<12))
#define  USIT_USIT_MUX_16_23_lane_c18_sel(data)                                  (0x00000F00&((data)<<8))
#define  USIT_USIT_MUX_16_23_lane_c17_sel(data)                                  (0x000000F0&((data)<<4))
#define  USIT_USIT_MUX_16_23_lane_c16_sel(data)                                  (0x0000000F&(data))
#define  USIT_USIT_MUX_16_23_get_lane_c23_sel(data)                              ((0xF0000000&(data))>>28)
#define  USIT_USIT_MUX_16_23_get_lane_c22_sel(data)                              ((0x0F000000&(data))>>24)
#define  USIT_USIT_MUX_16_23_get_lane_c21_sel(data)                              ((0x00F00000&(data))>>20)
#define  USIT_USIT_MUX_16_23_get_lane_c20_sel(data)                              ((0x000F0000&(data))>>16)
#define  USIT_USIT_MUX_16_23_get_lane_c19_sel(data)                              ((0x0000F000&(data))>>12)
#define  USIT_USIT_MUX_16_23_get_lane_c18_sel(data)                              ((0x00000F00&(data))>>8)
#define  USIT_USIT_MUX_16_23_get_lane_c17_sel(data)                              ((0x000000F0&(data))>>4)
#define  USIT_USIT_MUX_16_23_get_lane_c16_sel(data)                              (0x0000000F&(data))

#define  USIT_USIT_MUX_24_31                                                    0x18026B1C
#define  USIT_USIT_MUX_24_31_reg_addr                                            "0xB8026B1C"
#define  USIT_USIT_MUX_24_31_reg                                                 0xB8026B1C
#define  USIT_USIT_MUX_24_31_inst_addr                                           "0x0034"
#define  set_USIT_USIT_MUX_24_31_reg(data)                                       (*((volatile unsigned int*)USIT_USIT_MUX_24_31_reg)=data)
#define  get_USIT_USIT_MUX_24_31_reg                                             (*((volatile unsigned int*)USIT_USIT_MUX_24_31_reg))
#define  USIT_USIT_MUX_24_31_lane_c31_sel_shift                                  (28)
#define  USIT_USIT_MUX_24_31_lane_c30_sel_shift                                  (24)
#define  USIT_USIT_MUX_24_31_lane_c29_sel_shift                                  (20)
#define  USIT_USIT_MUX_24_31_lane_c28_sel_shift                                  (16)
#define  USIT_USIT_MUX_24_31_lane_c27_sel_shift                                  (12)
#define  USIT_USIT_MUX_24_31_lane_c26_sel_shift                                  (8)
#define  USIT_USIT_MUX_24_31_lane_c25_sel_shift                                  (4)
#define  USIT_USIT_MUX_24_31_lane_c24_sel_shift                                  (0)
#define  USIT_USIT_MUX_24_31_lane_c31_sel_mask                                   (0xF0000000)
#define  USIT_USIT_MUX_24_31_lane_c30_sel_mask                                   (0x0F000000)
#define  USIT_USIT_MUX_24_31_lane_c29_sel_mask                                   (0x00F00000)
#define  USIT_USIT_MUX_24_31_lane_c28_sel_mask                                   (0x000F0000)
#define  USIT_USIT_MUX_24_31_lane_c27_sel_mask                                   (0x0000F000)
#define  USIT_USIT_MUX_24_31_lane_c26_sel_mask                                   (0x00000F00)
#define  USIT_USIT_MUX_24_31_lane_c25_sel_mask                                   (0x000000F0)
#define  USIT_USIT_MUX_24_31_lane_c24_sel_mask                                   (0x0000000F)
#define  USIT_USIT_MUX_24_31_lane_c31_sel(data)                                  (0xF0000000&((data)<<28))
#define  USIT_USIT_MUX_24_31_lane_c30_sel(data)                                  (0x0F000000&((data)<<24))
#define  USIT_USIT_MUX_24_31_lane_c29_sel(data)                                  (0x00F00000&((data)<<20))
#define  USIT_USIT_MUX_24_31_lane_c28_sel(data)                                  (0x000F0000&((data)<<16))
#define  USIT_USIT_MUX_24_31_lane_c27_sel(data)                                  (0x0000F000&((data)<<12))
#define  USIT_USIT_MUX_24_31_lane_c26_sel(data)                                  (0x00000F00&((data)<<8))
#define  USIT_USIT_MUX_24_31_lane_c25_sel(data)                                  (0x000000F0&((data)<<4))
#define  USIT_USIT_MUX_24_31_lane_c24_sel(data)                                  (0x0000000F&(data))
#define  USIT_USIT_MUX_24_31_get_lane_c31_sel(data)                              ((0xF0000000&(data))>>28)
#define  USIT_USIT_MUX_24_31_get_lane_c30_sel(data)                              ((0x0F000000&(data))>>24)
#define  USIT_USIT_MUX_24_31_get_lane_c29_sel(data)                              ((0x00F00000&(data))>>20)
#define  USIT_USIT_MUX_24_31_get_lane_c28_sel(data)                              ((0x000F0000&(data))>>16)
#define  USIT_USIT_MUX_24_31_get_lane_c27_sel(data)                              ((0x0000F000&(data))>>12)
#define  USIT_USIT_MUX_24_31_get_lane_c26_sel(data)                              ((0x00000F00&(data))>>8)
#define  USIT_USIT_MUX_24_31_get_lane_c25_sel(data)                              ((0x000000F0&(data))>>4)
#define  USIT_USIT_MUX_24_31_get_lane_c24_sel(data)                              (0x0000000F&(data))

#define  USIT_USIT_MUX_32_39                                                    0x18026B20
#define  USIT_USIT_MUX_32_39_reg_addr                                            "0xB8026B20"
#define  USIT_USIT_MUX_32_39_reg                                                 0xB8026B20
#define  USIT_USIT_MUX_32_39_inst_addr                                           "0x0035"
#define  set_USIT_USIT_MUX_32_39_reg(data)                                       (*((volatile unsigned int*)USIT_USIT_MUX_32_39_reg)=data)
#define  get_USIT_USIT_MUX_32_39_reg                                             (*((volatile unsigned int*)USIT_USIT_MUX_32_39_reg))
#define  USIT_USIT_MUX_32_39_lane_c39_sel_shift                                  (28)
#define  USIT_USIT_MUX_32_39_lane_c38_sel_shift                                  (24)
#define  USIT_USIT_MUX_32_39_lane_c37_sel_shift                                  (20)
#define  USIT_USIT_MUX_32_39_lane_c36_sel_shift                                  (16)
#define  USIT_USIT_MUX_32_39_lane_c35_sel_shift                                  (12)
#define  USIT_USIT_MUX_32_39_lane_c34_sel_shift                                  (8)
#define  USIT_USIT_MUX_32_39_lane_c33_sel_shift                                  (4)
#define  USIT_USIT_MUX_32_39_lane_c32_sel_shift                                  (0)
#define  USIT_USIT_MUX_32_39_lane_c39_sel_mask                                   (0xF0000000)
#define  USIT_USIT_MUX_32_39_lane_c38_sel_mask                                   (0x0F000000)
#define  USIT_USIT_MUX_32_39_lane_c37_sel_mask                                   (0x00F00000)
#define  USIT_USIT_MUX_32_39_lane_c36_sel_mask                                   (0x000F0000)
#define  USIT_USIT_MUX_32_39_lane_c35_sel_mask                                   (0x0000F000)
#define  USIT_USIT_MUX_32_39_lane_c34_sel_mask                                   (0x00000F00)
#define  USIT_USIT_MUX_32_39_lane_c33_sel_mask                                   (0x000000F0)
#define  USIT_USIT_MUX_32_39_lane_c32_sel_mask                                   (0x0000000F)
#define  USIT_USIT_MUX_32_39_lane_c39_sel(data)                                  (0xF0000000&((data)<<28))
#define  USIT_USIT_MUX_32_39_lane_c38_sel(data)                                  (0x0F000000&((data)<<24))
#define  USIT_USIT_MUX_32_39_lane_c37_sel(data)                                  (0x00F00000&((data)<<20))
#define  USIT_USIT_MUX_32_39_lane_c36_sel(data)                                  (0x000F0000&((data)<<16))
#define  USIT_USIT_MUX_32_39_lane_c35_sel(data)                                  (0x0000F000&((data)<<12))
#define  USIT_USIT_MUX_32_39_lane_c34_sel(data)                                  (0x00000F00&((data)<<8))
#define  USIT_USIT_MUX_32_39_lane_c33_sel(data)                                  (0x000000F0&((data)<<4))
#define  USIT_USIT_MUX_32_39_lane_c32_sel(data)                                  (0x0000000F&(data))
#define  USIT_USIT_MUX_32_39_get_lane_c39_sel(data)                              ((0xF0000000&(data))>>28)
#define  USIT_USIT_MUX_32_39_get_lane_c38_sel(data)                              ((0x0F000000&(data))>>24)
#define  USIT_USIT_MUX_32_39_get_lane_c37_sel(data)                              ((0x00F00000&(data))>>20)
#define  USIT_USIT_MUX_32_39_get_lane_c36_sel(data)                              ((0x000F0000&(data))>>16)
#define  USIT_USIT_MUX_32_39_get_lane_c35_sel(data)                              ((0x0000F000&(data))>>12)
#define  USIT_USIT_MUX_32_39_get_lane_c34_sel(data)                              ((0x00000F00&(data))>>8)
#define  USIT_USIT_MUX_32_39_get_lane_c33_sel(data)                              ((0x000000F0&(data))>>4)
#define  USIT_USIT_MUX_32_39_get_lane_c32_sel(data)                              (0x0000000F&(data))

#define  USIT_USIT_MUX_40_47                                                    0x18026B24
#define  USIT_USIT_MUX_40_47_reg_addr                                            "0xB8026B24"
#define  USIT_USIT_MUX_40_47_reg                                                 0xB8026B24
#define  USIT_USIT_MUX_40_47_inst_addr                                           "0x0036"
#define  set_USIT_USIT_MUX_40_47_reg(data)                                       (*((volatile unsigned int*)USIT_USIT_MUX_40_47_reg)=data)
#define  get_USIT_USIT_MUX_40_47_reg                                             (*((volatile unsigned int*)USIT_USIT_MUX_40_47_reg))
#define  USIT_USIT_MUX_40_47_lane_c47_sel_shift                                  (28)
#define  USIT_USIT_MUX_40_47_lane_c46_sel_shift                                  (24)
#define  USIT_USIT_MUX_40_47_lane_c45_sel_shift                                  (20)
#define  USIT_USIT_MUX_40_47_lane_c44_sel_shift                                  (16)
#define  USIT_USIT_MUX_40_47_lane_c43_sel_shift                                  (12)
#define  USIT_USIT_MUX_40_47_lane_c42_sel_shift                                  (8)
#define  USIT_USIT_MUX_40_47_lane_c41_sel_shift                                  (4)
#define  USIT_USIT_MUX_40_47_lane_c40_sel_shift                                  (0)
#define  USIT_USIT_MUX_40_47_lane_c47_sel_mask                                   (0xF0000000)
#define  USIT_USIT_MUX_40_47_lane_c46_sel_mask                                   (0x0F000000)
#define  USIT_USIT_MUX_40_47_lane_c45_sel_mask                                   (0x00F00000)
#define  USIT_USIT_MUX_40_47_lane_c44_sel_mask                                   (0x000F0000)
#define  USIT_USIT_MUX_40_47_lane_c43_sel_mask                                   (0x0000F000)
#define  USIT_USIT_MUX_40_47_lane_c42_sel_mask                                   (0x00000F00)
#define  USIT_USIT_MUX_40_47_lane_c41_sel_mask                                   (0x000000F0)
#define  USIT_USIT_MUX_40_47_lane_c40_sel_mask                                   (0x0000000F)
#define  USIT_USIT_MUX_40_47_lane_c47_sel(data)                                  (0xF0000000&((data)<<28))
#define  USIT_USIT_MUX_40_47_lane_c46_sel(data)                                  (0x0F000000&((data)<<24))
#define  USIT_USIT_MUX_40_47_lane_c45_sel(data)                                  (0x00F00000&((data)<<20))
#define  USIT_USIT_MUX_40_47_lane_c44_sel(data)                                  (0x000F0000&((data)<<16))
#define  USIT_USIT_MUX_40_47_lane_c43_sel(data)                                  (0x0000F000&((data)<<12))
#define  USIT_USIT_MUX_40_47_lane_c42_sel(data)                                  (0x00000F00&((data)<<8))
#define  USIT_USIT_MUX_40_47_lane_c41_sel(data)                                  (0x000000F0&((data)<<4))
#define  USIT_USIT_MUX_40_47_lane_c40_sel(data)                                  (0x0000000F&(data))
#define  USIT_USIT_MUX_40_47_get_lane_c47_sel(data)                              ((0xF0000000&(data))>>28)
#define  USIT_USIT_MUX_40_47_get_lane_c46_sel(data)                              ((0x0F000000&(data))>>24)
#define  USIT_USIT_MUX_40_47_get_lane_c45_sel(data)                              ((0x00F00000&(data))>>20)
#define  USIT_USIT_MUX_40_47_get_lane_c44_sel(data)                              ((0x000F0000&(data))>>16)
#define  USIT_USIT_MUX_40_47_get_lane_c43_sel(data)                              ((0x0000F000&(data))>>12)
#define  USIT_USIT_MUX_40_47_get_lane_c42_sel(data)                              ((0x00000F00&(data))>>8)
#define  USIT_USIT_MUX_40_47_get_lane_c41_sel(data)                              ((0x000000F0&(data))>>4)
#define  USIT_USIT_MUX_40_47_get_lane_c40_sel(data)                              (0x0000000F&(data))

#define  USIT_USIT_PORT_EN                                                      0x18026B2C
#define  USIT_USIT_PORT_EN_reg_addr                                              "0xB8026B2C"
#define  USIT_USIT_PORT_EN_reg                                                   0xB8026B2C
#define  USIT_USIT_PORT_EN_inst_addr                                             "0x0037"
#define  set_USIT_USIT_PORT_EN_reg(data)                                         (*((volatile unsigned int*)USIT_USIT_PORT_EN_reg)=data)
#define  get_USIT_USIT_PORT_EN_reg                                               (*((volatile unsigned int*)USIT_USIT_PORT_EN_reg))
#define  USIT_USIT_PORT_EN_dummy_31_12_shift                                     (12)
#define  USIT_USIT_PORT_EN_usit_port_en_shift                                    (0)
#define  USIT_USIT_PORT_EN_dummy_31_12_mask                                      (0xFFFFF000)
#define  USIT_USIT_PORT_EN_usit_port_en_mask                                     (0x00000FFF)
#define  USIT_USIT_PORT_EN_dummy_31_12(data)                                     (0xFFFFF000&((data)<<12))
#define  USIT_USIT_PORT_EN_usit_port_en(data)                                    (0x00000FFF&(data))
#define  USIT_USIT_PORT_EN_get_dummy_31_12(data)                                 ((0xFFFFF000&(data))>>12)
#define  USIT_USIT_PORT_EN_get_usit_port_en(data)                                (0x00000FFF&(data))

#define  USIT_USIT_SBC_CTRL1                                                    0x18026B30
#define  USIT_USIT_SBC_CTRL1_reg_addr                                            "0xB8026B30"
#define  USIT_USIT_SBC_CTRL1_reg                                                 0xB8026B30
#define  USIT_USIT_SBC_CTRL1_inst_addr                                           "0x0038"
#define  set_USIT_USIT_SBC_CTRL1_reg(data)                                       (*((volatile unsigned int*)USIT_USIT_SBC_CTRL1_reg)=data)
#define  get_USIT_USIT_SBC_CTRL1_reg                                             (*((volatile unsigned int*)USIT_USIT_SBC_CTRL1_reg))
#define  USIT_USIT_SBC_CTRL1_sbc_payload_num_shift                               (16)
#define  USIT_USIT_SBC_CTRL1_sbc_cmd_trigger_shift                               (12)
#define  USIT_USIT_SBC_CTRL1_sbc_td_shift                                        (0)
#define  USIT_USIT_SBC_CTRL1_sbc_payload_num_mask                                (0x00070000)
#define  USIT_USIT_SBC_CTRL1_sbc_cmd_trigger_mask                                (0x00001000)
#define  USIT_USIT_SBC_CTRL1_sbc_td_mask                                         (0x000003FF)
#define  USIT_USIT_SBC_CTRL1_sbc_payload_num(data)                               (0x00070000&((data)<<16))
#define  USIT_USIT_SBC_CTRL1_sbc_cmd_trigger(data)                               (0x00001000&((data)<<12))
#define  USIT_USIT_SBC_CTRL1_sbc_td(data)                                        (0x000003FF&(data))
#define  USIT_USIT_SBC_CTRL1_get_sbc_payload_num(data)                           ((0x00070000&(data))>>16)
#define  USIT_USIT_SBC_CTRL1_get_sbc_cmd_trigger(data)                           ((0x00001000&(data))>>12)
#define  USIT_USIT_SBC_CTRL1_get_sbc_td(data)                                    (0x000003FF&(data))

#define  USIT_USIT_SBC_CTRL2                                                    0x18026B34
#define  USIT_USIT_SBC_CTRL2_reg_addr                                            "0xB8026B34"
#define  USIT_USIT_SBC_CTRL2_reg                                                 0xB8026B34
#define  USIT_USIT_SBC_CTRL2_inst_addr                                           "0x0039"
#define  set_USIT_USIT_SBC_CTRL2_reg(data)                                       (*((volatile unsigned int*)USIT_USIT_SBC_CTRL2_reg)=data)
#define  get_USIT_USIT_SBC_CTRL2_reg                                             (*((volatile unsigned int*)USIT_USIT_SBC_CTRL2_reg))
#define  USIT_USIT_SBC_CTRL2_t_cs2start_shift                                    (28)
#define  USIT_USIT_SBC_CTRL2_t_sfcr2sbcr_shift                                   (24)
#define  USIT_USIT_SBC_CTRL2_t_sfcf2sbcf_shift                                   (16)
#define  USIT_USIT_SBC_CTRL2_t_standby_shift                                     (8)
#define  USIT_USIT_SBC_CTRL2_t_sfcr2start_shift                                  (0)
#define  USIT_USIT_SBC_CTRL2_t_cs2start_mask                                     (0xF0000000)
#define  USIT_USIT_SBC_CTRL2_t_sfcr2sbcr_mask                                    (0x0F000000)
#define  USIT_USIT_SBC_CTRL2_t_sfcf2sbcf_mask                                    (0x00FF0000)
#define  USIT_USIT_SBC_CTRL2_t_standby_mask                                      (0x0000FF00)
#define  USIT_USIT_SBC_CTRL2_t_sfcr2start_mask                                   (0x000000FF)
#define  USIT_USIT_SBC_CTRL2_t_cs2start(data)                                    (0xF0000000&((data)<<28))
#define  USIT_USIT_SBC_CTRL2_t_sfcr2sbcr(data)                                   (0x0F000000&((data)<<24))
#define  USIT_USIT_SBC_CTRL2_t_sfcf2sbcf(data)                                   (0x00FF0000&((data)<<16))
#define  USIT_USIT_SBC_CTRL2_t_standby(data)                                     (0x0000FF00&((data)<<8))
#define  USIT_USIT_SBC_CTRL2_t_sfcr2start(data)                                  (0x000000FF&(data))
#define  USIT_USIT_SBC_CTRL2_get_t_cs2start(data)                                ((0xF0000000&(data))>>28)
#define  USIT_USIT_SBC_CTRL2_get_t_sfcr2sbcr(data)                               ((0x0F000000&(data))>>24)
#define  USIT_USIT_SBC_CTRL2_get_t_sfcf2sbcf(data)                               ((0x00FF0000&(data))>>16)
#define  USIT_USIT_SBC_CTRL2_get_t_standby(data)                                 ((0x0000FF00&(data))>>8)
#define  USIT_USIT_SBC_CTRL2_get_t_sfcr2start(data)                              (0x000000FF&(data))

#define  USIT_USIT_SBC_CTRL3                                                    0x18026B38
#define  USIT_USIT_SBC_CTRL3_reg_addr                                            "0xB8026B38"
#define  USIT_USIT_SBC_CTRL3_reg                                                 0xB8026B38
#define  USIT_USIT_SBC_CTRL3_inst_addr                                           "0x003A"
#define  set_USIT_USIT_SBC_CTRL3_reg(data)                                       (*((volatile unsigned int*)USIT_USIT_SBC_CTRL3_reg)=data)
#define  get_USIT_USIT_SBC_CTRL3_reg                                             (*((volatile unsigned int*)USIT_USIT_SBC_CTRL3_reg))
#define  USIT_USIT_SBC_CTRL3_sbc_cmd_lane_en_shift                               (16)
#define  USIT_USIT_SBC_CTRL3_sbc_out_manual_value_shift                          (3)
#define  USIT_USIT_SBC_CTRL3_sbc_out_manual_mode_shift                           (2)
#define  USIT_USIT_SBC_CTRL3_sbc_in_manual_value_shift                           (1)
#define  USIT_USIT_SBC_CTRL3_sbc_in_manual_mode_shift                            (0)
#define  USIT_USIT_SBC_CTRL3_sbc_cmd_lane_en_mask                                (0x0FFF0000)
#define  USIT_USIT_SBC_CTRL3_sbc_out_manual_value_mask                           (0x00000008)
#define  USIT_USIT_SBC_CTRL3_sbc_out_manual_mode_mask                            (0x00000004)
#define  USIT_USIT_SBC_CTRL3_sbc_in_manual_value_mask                            (0x00000002)
#define  USIT_USIT_SBC_CTRL3_sbc_in_manual_mode_mask                             (0x00000001)
#define  USIT_USIT_SBC_CTRL3_sbc_cmd_lane_en(data)                               (0x0FFF0000&((data)<<16))
#define  USIT_USIT_SBC_CTRL3_sbc_out_manual_value(data)                          (0x00000008&((data)<<3))
#define  USIT_USIT_SBC_CTRL3_sbc_out_manual_mode(data)                           (0x00000004&((data)<<2))
#define  USIT_USIT_SBC_CTRL3_sbc_in_manual_value(data)                           (0x00000002&((data)<<1))
#define  USIT_USIT_SBC_CTRL3_sbc_in_manual_mode(data)                            (0x00000001&(data))
#define  USIT_USIT_SBC_CTRL3_get_sbc_cmd_lane_en(data)                           ((0x0FFF0000&(data))>>16)
#define  USIT_USIT_SBC_CTRL3_get_sbc_out_manual_value(data)                      ((0x00000008&(data))>>3)
#define  USIT_USIT_SBC_CTRL3_get_sbc_out_manual_mode(data)                       ((0x00000004&(data))>>2)
#define  USIT_USIT_SBC_CTRL3_get_sbc_in_manual_value(data)                       ((0x00000002&(data))>>1)
#define  USIT_USIT_SBC_CTRL3_get_sbc_in_manual_mode(data)                        (0x00000001&(data))

#define  USIT_USIT_SBC_CTRL4                                                    0x18026B3C
#define  USIT_USIT_SBC_CTRL4_reg_addr                                            "0xB8026B3C"
#define  USIT_USIT_SBC_CTRL4_reg                                                 0xB8026B3C
#define  USIT_USIT_SBC_CTRL4_inst_addr                                           "0x003B"
#define  set_USIT_USIT_SBC_CTRL4_reg(data)                                       (*((volatile unsigned int*)USIT_USIT_SBC_CTRL4_reg)=data)
#define  get_USIT_USIT_SBC_CTRL4_reg                                             (*((volatile unsigned int*)USIT_USIT_SBC_CTRL4_reg))
#define  USIT_USIT_SBC_CTRL4_sbc_ui_period_shift                                 (0)
#define  USIT_USIT_SBC_CTRL4_sbc_ui_period_mask                                  (0x000003FF)
#define  USIT_USIT_SBC_CTRL4_sbc_ui_period(data)                                 (0x000003FF&(data))
#define  USIT_USIT_SBC_CTRL4_get_sbc_ui_period(data)                             (0x000003FF&(data))

#define  USIT_USIT_SBC_PAYLOAD_00                                               0x18026B40
#define  USIT_USIT_SBC_PAYLOAD_00_reg_addr                                       "0xB8026B40"
#define  USIT_USIT_SBC_PAYLOAD_00_reg                                            0xB8026B40
#define  USIT_USIT_SBC_PAYLOAD_00_inst_addr                                      "0x003C"
#define  set_USIT_USIT_SBC_PAYLOAD_00_reg(data)                                  (*((volatile unsigned int*)USIT_USIT_SBC_PAYLOAD_00_reg)=data)
#define  get_USIT_USIT_SBC_PAYLOAD_00_reg                                        (*((volatile unsigned int*)USIT_USIT_SBC_PAYLOAD_00_reg))
#define  USIT_USIT_SBC_PAYLOAD_00_sbc_payload3_00_shift                          (24)
#define  USIT_USIT_SBC_PAYLOAD_00_sbc_payload2_00_shift                          (16)
#define  USIT_USIT_SBC_PAYLOAD_00_sbc_payload1_00_shift                          (8)
#define  USIT_USIT_SBC_PAYLOAD_00_sbc_payload0_00_shift                          (0)
#define  USIT_USIT_SBC_PAYLOAD_00_sbc_payload3_00_mask                           (0xFF000000)
#define  USIT_USIT_SBC_PAYLOAD_00_sbc_payload2_00_mask                           (0x00FF0000)
#define  USIT_USIT_SBC_PAYLOAD_00_sbc_payload1_00_mask                           (0x0000FF00)
#define  USIT_USIT_SBC_PAYLOAD_00_sbc_payload0_00_mask                           (0x000000FF)
#define  USIT_USIT_SBC_PAYLOAD_00_sbc_payload3_00(data)                          (0xFF000000&((data)<<24))
#define  USIT_USIT_SBC_PAYLOAD_00_sbc_payload2_00(data)                          (0x00FF0000&((data)<<16))
#define  USIT_USIT_SBC_PAYLOAD_00_sbc_payload1_00(data)                          (0x0000FF00&((data)<<8))
#define  USIT_USIT_SBC_PAYLOAD_00_sbc_payload0_00(data)                          (0x000000FF&(data))
#define  USIT_USIT_SBC_PAYLOAD_00_get_sbc_payload3_00(data)                      ((0xFF000000&(data))>>24)
#define  USIT_USIT_SBC_PAYLOAD_00_get_sbc_payload2_00(data)                      ((0x00FF0000&(data))>>16)
#define  USIT_USIT_SBC_PAYLOAD_00_get_sbc_payload1_00(data)                      ((0x0000FF00&(data))>>8)
#define  USIT_USIT_SBC_PAYLOAD_00_get_sbc_payload0_00(data)                      (0x000000FF&(data))

#define  USIT_USIT_SBC_PAYLOAD_01                                               0x18026B48
#define  USIT_USIT_SBC_PAYLOAD_01_reg_addr                                       "0xB8026B48"
#define  USIT_USIT_SBC_PAYLOAD_01_reg                                            0xB8026B48
#define  USIT_USIT_SBC_PAYLOAD_01_inst_addr                                      "0x003D"
#define  set_USIT_USIT_SBC_PAYLOAD_01_reg(data)                                  (*((volatile unsigned int*)USIT_USIT_SBC_PAYLOAD_01_reg)=data)
#define  get_USIT_USIT_SBC_PAYLOAD_01_reg                                        (*((volatile unsigned int*)USIT_USIT_SBC_PAYLOAD_01_reg))
#define  USIT_USIT_SBC_PAYLOAD_01_sbc_payload3_01_shift                          (24)
#define  USIT_USIT_SBC_PAYLOAD_01_sbc_payload2_01_shift                          (16)
#define  USIT_USIT_SBC_PAYLOAD_01_sbc_payload1_01_shift                          (8)
#define  USIT_USIT_SBC_PAYLOAD_01_sbc_payload0_01_shift                          (0)
#define  USIT_USIT_SBC_PAYLOAD_01_sbc_payload3_01_mask                           (0xFF000000)
#define  USIT_USIT_SBC_PAYLOAD_01_sbc_payload2_01_mask                           (0x00FF0000)
#define  USIT_USIT_SBC_PAYLOAD_01_sbc_payload1_01_mask                           (0x0000FF00)
#define  USIT_USIT_SBC_PAYLOAD_01_sbc_payload0_01_mask                           (0x000000FF)
#define  USIT_USIT_SBC_PAYLOAD_01_sbc_payload3_01(data)                          (0xFF000000&((data)<<24))
#define  USIT_USIT_SBC_PAYLOAD_01_sbc_payload2_01(data)                          (0x00FF0000&((data)<<16))
#define  USIT_USIT_SBC_PAYLOAD_01_sbc_payload1_01(data)                          (0x0000FF00&((data)<<8))
#define  USIT_USIT_SBC_PAYLOAD_01_sbc_payload0_01(data)                          (0x000000FF&(data))
#define  USIT_USIT_SBC_PAYLOAD_01_get_sbc_payload3_01(data)                      ((0xFF000000&(data))>>24)
#define  USIT_USIT_SBC_PAYLOAD_01_get_sbc_payload2_01(data)                      ((0x00FF0000&(data))>>16)
#define  USIT_USIT_SBC_PAYLOAD_01_get_sbc_payload1_01(data)                      ((0x0000FF00&(data))>>8)
#define  USIT_USIT_SBC_PAYLOAD_01_get_sbc_payload0_01(data)                      (0x000000FF&(data))

#define  USIT_USIT_SBC_PAYLOAD_02                                               0x18026B50
#define  USIT_USIT_SBC_PAYLOAD_02_reg_addr                                       "0xB8026B50"
#define  USIT_USIT_SBC_PAYLOAD_02_reg                                            0xB8026B50
#define  USIT_USIT_SBC_PAYLOAD_02_inst_addr                                      "0x003E"
#define  set_USIT_USIT_SBC_PAYLOAD_02_reg(data)                                  (*((volatile unsigned int*)USIT_USIT_SBC_PAYLOAD_02_reg)=data)
#define  get_USIT_USIT_SBC_PAYLOAD_02_reg                                        (*((volatile unsigned int*)USIT_USIT_SBC_PAYLOAD_02_reg))
#define  USIT_USIT_SBC_PAYLOAD_02_sbc_payload3_02_shift                          (24)
#define  USIT_USIT_SBC_PAYLOAD_02_sbc_payload2_02_shift                          (16)
#define  USIT_USIT_SBC_PAYLOAD_02_sbc_payload1_02_shift                          (8)
#define  USIT_USIT_SBC_PAYLOAD_02_sbc_payload0_02_shift                          (0)
#define  USIT_USIT_SBC_PAYLOAD_02_sbc_payload3_02_mask                           (0xFF000000)
#define  USIT_USIT_SBC_PAYLOAD_02_sbc_payload2_02_mask                           (0x00FF0000)
#define  USIT_USIT_SBC_PAYLOAD_02_sbc_payload1_02_mask                           (0x0000FF00)
#define  USIT_USIT_SBC_PAYLOAD_02_sbc_payload0_02_mask                           (0x000000FF)
#define  USIT_USIT_SBC_PAYLOAD_02_sbc_payload3_02(data)                          (0xFF000000&((data)<<24))
#define  USIT_USIT_SBC_PAYLOAD_02_sbc_payload2_02(data)                          (0x00FF0000&((data)<<16))
#define  USIT_USIT_SBC_PAYLOAD_02_sbc_payload1_02(data)                          (0x0000FF00&((data)<<8))
#define  USIT_USIT_SBC_PAYLOAD_02_sbc_payload0_02(data)                          (0x000000FF&(data))
#define  USIT_USIT_SBC_PAYLOAD_02_get_sbc_payload3_02(data)                      ((0xFF000000&(data))>>24)
#define  USIT_USIT_SBC_PAYLOAD_02_get_sbc_payload2_02(data)                      ((0x00FF0000&(data))>>16)
#define  USIT_USIT_SBC_PAYLOAD_02_get_sbc_payload1_02(data)                      ((0x0000FF00&(data))>>8)
#define  USIT_USIT_SBC_PAYLOAD_02_get_sbc_payload0_02(data)                      (0x000000FF&(data))

#define  USIT_USIT_SBC_PAYLOAD_03                                               0x18026B58
#define  USIT_USIT_SBC_PAYLOAD_03_reg_addr                                       "0xB8026B58"
#define  USIT_USIT_SBC_PAYLOAD_03_reg                                            0xB8026B58
#define  USIT_USIT_SBC_PAYLOAD_03_inst_addr                                      "0x003F"
#define  set_USIT_USIT_SBC_PAYLOAD_03_reg(data)                                  (*((volatile unsigned int*)USIT_USIT_SBC_PAYLOAD_03_reg)=data)
#define  get_USIT_USIT_SBC_PAYLOAD_03_reg                                        (*((volatile unsigned int*)USIT_USIT_SBC_PAYLOAD_03_reg))
#define  USIT_USIT_SBC_PAYLOAD_03_sbc_payload3_03_shift                          (24)
#define  USIT_USIT_SBC_PAYLOAD_03_sbc_payload2_03_shift                          (16)
#define  USIT_USIT_SBC_PAYLOAD_03_sbc_payload1_03_shift                          (8)
#define  USIT_USIT_SBC_PAYLOAD_03_sbc_payload0_03_shift                          (0)
#define  USIT_USIT_SBC_PAYLOAD_03_sbc_payload3_03_mask                           (0xFF000000)
#define  USIT_USIT_SBC_PAYLOAD_03_sbc_payload2_03_mask                           (0x00FF0000)
#define  USIT_USIT_SBC_PAYLOAD_03_sbc_payload1_03_mask                           (0x0000FF00)
#define  USIT_USIT_SBC_PAYLOAD_03_sbc_payload0_03_mask                           (0x000000FF)
#define  USIT_USIT_SBC_PAYLOAD_03_sbc_payload3_03(data)                          (0xFF000000&((data)<<24))
#define  USIT_USIT_SBC_PAYLOAD_03_sbc_payload2_03(data)                          (0x00FF0000&((data)<<16))
#define  USIT_USIT_SBC_PAYLOAD_03_sbc_payload1_03(data)                          (0x0000FF00&((data)<<8))
#define  USIT_USIT_SBC_PAYLOAD_03_sbc_payload0_03(data)                          (0x000000FF&(data))
#define  USIT_USIT_SBC_PAYLOAD_03_get_sbc_payload3_03(data)                      ((0xFF000000&(data))>>24)
#define  USIT_USIT_SBC_PAYLOAD_03_get_sbc_payload2_03(data)                      ((0x00FF0000&(data))>>16)
#define  USIT_USIT_SBC_PAYLOAD_03_get_sbc_payload1_03(data)                      ((0x0000FF00&(data))>>8)
#define  USIT_USIT_SBC_PAYLOAD_03_get_sbc_payload0_03(data)                      (0x000000FF&(data))

#define  USIT_USIT_SBC_PAYLOAD_04                                               0x18026B60
#define  USIT_USIT_SBC_PAYLOAD_04_reg_addr                                       "0xB8026B60"
#define  USIT_USIT_SBC_PAYLOAD_04_reg                                            0xB8026B60
#define  USIT_USIT_SBC_PAYLOAD_04_inst_addr                                      "0x0040"
#define  set_USIT_USIT_SBC_PAYLOAD_04_reg(data)                                  (*((volatile unsigned int*)USIT_USIT_SBC_PAYLOAD_04_reg)=data)
#define  get_USIT_USIT_SBC_PAYLOAD_04_reg                                        (*((volatile unsigned int*)USIT_USIT_SBC_PAYLOAD_04_reg))
#define  USIT_USIT_SBC_PAYLOAD_04_sbc_payload3_04_shift                          (24)
#define  USIT_USIT_SBC_PAYLOAD_04_sbc_payload2_04_shift                          (16)
#define  USIT_USIT_SBC_PAYLOAD_04_sbc_payload1_04_shift                          (8)
#define  USIT_USIT_SBC_PAYLOAD_04_sbc_payload0_04_shift                          (0)
#define  USIT_USIT_SBC_PAYLOAD_04_sbc_payload3_04_mask                           (0xFF000000)
#define  USIT_USIT_SBC_PAYLOAD_04_sbc_payload2_04_mask                           (0x00FF0000)
#define  USIT_USIT_SBC_PAYLOAD_04_sbc_payload1_04_mask                           (0x0000FF00)
#define  USIT_USIT_SBC_PAYLOAD_04_sbc_payload0_04_mask                           (0x000000FF)
#define  USIT_USIT_SBC_PAYLOAD_04_sbc_payload3_04(data)                          (0xFF000000&((data)<<24))
#define  USIT_USIT_SBC_PAYLOAD_04_sbc_payload2_04(data)                          (0x00FF0000&((data)<<16))
#define  USIT_USIT_SBC_PAYLOAD_04_sbc_payload1_04(data)                          (0x0000FF00&((data)<<8))
#define  USIT_USIT_SBC_PAYLOAD_04_sbc_payload0_04(data)                          (0x000000FF&(data))
#define  USIT_USIT_SBC_PAYLOAD_04_get_sbc_payload3_04(data)                      ((0xFF000000&(data))>>24)
#define  USIT_USIT_SBC_PAYLOAD_04_get_sbc_payload2_04(data)                      ((0x00FF0000&(data))>>16)
#define  USIT_USIT_SBC_PAYLOAD_04_get_sbc_payload1_04(data)                      ((0x0000FF00&(data))>>8)
#define  USIT_USIT_SBC_PAYLOAD_04_get_sbc_payload0_04(data)                      (0x000000FF&(data))

#define  USIT_USIT_SBC_PAYLOAD_05                                               0x18026B68
#define  USIT_USIT_SBC_PAYLOAD_05_reg_addr                                       "0xB8026B68"
#define  USIT_USIT_SBC_PAYLOAD_05_reg                                            0xB8026B68
#define  USIT_USIT_SBC_PAYLOAD_05_inst_addr                                      "0x0041"
#define  set_USIT_USIT_SBC_PAYLOAD_05_reg(data)                                  (*((volatile unsigned int*)USIT_USIT_SBC_PAYLOAD_05_reg)=data)
#define  get_USIT_USIT_SBC_PAYLOAD_05_reg                                        (*((volatile unsigned int*)USIT_USIT_SBC_PAYLOAD_05_reg))
#define  USIT_USIT_SBC_PAYLOAD_05_sbc_payload3_05_shift                          (24)
#define  USIT_USIT_SBC_PAYLOAD_05_sbc_payload2_05_shift                          (16)
#define  USIT_USIT_SBC_PAYLOAD_05_sbc_payload1_05_shift                          (8)
#define  USIT_USIT_SBC_PAYLOAD_05_sbc_payload0_05_shift                          (0)
#define  USIT_USIT_SBC_PAYLOAD_05_sbc_payload3_05_mask                           (0xFF000000)
#define  USIT_USIT_SBC_PAYLOAD_05_sbc_payload2_05_mask                           (0x00FF0000)
#define  USIT_USIT_SBC_PAYLOAD_05_sbc_payload1_05_mask                           (0x0000FF00)
#define  USIT_USIT_SBC_PAYLOAD_05_sbc_payload0_05_mask                           (0x000000FF)
#define  USIT_USIT_SBC_PAYLOAD_05_sbc_payload3_05(data)                          (0xFF000000&((data)<<24))
#define  USIT_USIT_SBC_PAYLOAD_05_sbc_payload2_05(data)                          (0x00FF0000&((data)<<16))
#define  USIT_USIT_SBC_PAYLOAD_05_sbc_payload1_05(data)                          (0x0000FF00&((data)<<8))
#define  USIT_USIT_SBC_PAYLOAD_05_sbc_payload0_05(data)                          (0x000000FF&(data))
#define  USIT_USIT_SBC_PAYLOAD_05_get_sbc_payload3_05(data)                      ((0xFF000000&(data))>>24)
#define  USIT_USIT_SBC_PAYLOAD_05_get_sbc_payload2_05(data)                      ((0x00FF0000&(data))>>16)
#define  USIT_USIT_SBC_PAYLOAD_05_get_sbc_payload1_05(data)                      ((0x0000FF00&(data))>>8)
#define  USIT_USIT_SBC_PAYLOAD_05_get_sbc_payload0_05(data)                      (0x000000FF&(data))

#define  USIT_USIT_SBC_PAYLOAD_06                                               0x18026B70
#define  USIT_USIT_SBC_PAYLOAD_06_reg_addr                                       "0xB8026B70"
#define  USIT_USIT_SBC_PAYLOAD_06_reg                                            0xB8026B70
#define  USIT_USIT_SBC_PAYLOAD_06_inst_addr                                      "0x0042"
#define  set_USIT_USIT_SBC_PAYLOAD_06_reg(data)                                  (*((volatile unsigned int*)USIT_USIT_SBC_PAYLOAD_06_reg)=data)
#define  get_USIT_USIT_SBC_PAYLOAD_06_reg                                        (*((volatile unsigned int*)USIT_USIT_SBC_PAYLOAD_06_reg))
#define  USIT_USIT_SBC_PAYLOAD_06_sbc_payload3_06_shift                          (24)
#define  USIT_USIT_SBC_PAYLOAD_06_sbc_payload2_06_shift                          (16)
#define  USIT_USIT_SBC_PAYLOAD_06_sbc_payload1_06_shift                          (8)
#define  USIT_USIT_SBC_PAYLOAD_06_sbc_payload0_06_shift                          (0)
#define  USIT_USIT_SBC_PAYLOAD_06_sbc_payload3_06_mask                           (0xFF000000)
#define  USIT_USIT_SBC_PAYLOAD_06_sbc_payload2_06_mask                           (0x00FF0000)
#define  USIT_USIT_SBC_PAYLOAD_06_sbc_payload1_06_mask                           (0x0000FF00)
#define  USIT_USIT_SBC_PAYLOAD_06_sbc_payload0_06_mask                           (0x000000FF)
#define  USIT_USIT_SBC_PAYLOAD_06_sbc_payload3_06(data)                          (0xFF000000&((data)<<24))
#define  USIT_USIT_SBC_PAYLOAD_06_sbc_payload2_06(data)                          (0x00FF0000&((data)<<16))
#define  USIT_USIT_SBC_PAYLOAD_06_sbc_payload1_06(data)                          (0x0000FF00&((data)<<8))
#define  USIT_USIT_SBC_PAYLOAD_06_sbc_payload0_06(data)                          (0x000000FF&(data))
#define  USIT_USIT_SBC_PAYLOAD_06_get_sbc_payload3_06(data)                      ((0xFF000000&(data))>>24)
#define  USIT_USIT_SBC_PAYLOAD_06_get_sbc_payload2_06(data)                      ((0x00FF0000&(data))>>16)
#define  USIT_USIT_SBC_PAYLOAD_06_get_sbc_payload1_06(data)                      ((0x0000FF00&(data))>>8)
#define  USIT_USIT_SBC_PAYLOAD_06_get_sbc_payload0_06(data)                      (0x000000FF&(data))

#define  USIT_USIT_SBC_PAYLOAD_07                                               0x18026B78
#define  USIT_USIT_SBC_PAYLOAD_07_reg_addr                                       "0xB8026B78"
#define  USIT_USIT_SBC_PAYLOAD_07_reg                                            0xB8026B78
#define  USIT_USIT_SBC_PAYLOAD_07_inst_addr                                      "0x0043"
#define  set_USIT_USIT_SBC_PAYLOAD_07_reg(data)                                  (*((volatile unsigned int*)USIT_USIT_SBC_PAYLOAD_07_reg)=data)
#define  get_USIT_USIT_SBC_PAYLOAD_07_reg                                        (*((volatile unsigned int*)USIT_USIT_SBC_PAYLOAD_07_reg))
#define  USIT_USIT_SBC_PAYLOAD_07_sbc_payload3_07_shift                          (24)
#define  USIT_USIT_SBC_PAYLOAD_07_sbc_payload2_07_shift                          (16)
#define  USIT_USIT_SBC_PAYLOAD_07_sbc_payload1_07_shift                          (8)
#define  USIT_USIT_SBC_PAYLOAD_07_sbc_payload0_07_shift                          (0)
#define  USIT_USIT_SBC_PAYLOAD_07_sbc_payload3_07_mask                           (0xFF000000)
#define  USIT_USIT_SBC_PAYLOAD_07_sbc_payload2_07_mask                           (0x00FF0000)
#define  USIT_USIT_SBC_PAYLOAD_07_sbc_payload1_07_mask                           (0x0000FF00)
#define  USIT_USIT_SBC_PAYLOAD_07_sbc_payload0_07_mask                           (0x000000FF)
#define  USIT_USIT_SBC_PAYLOAD_07_sbc_payload3_07(data)                          (0xFF000000&((data)<<24))
#define  USIT_USIT_SBC_PAYLOAD_07_sbc_payload2_07(data)                          (0x00FF0000&((data)<<16))
#define  USIT_USIT_SBC_PAYLOAD_07_sbc_payload1_07(data)                          (0x0000FF00&((data)<<8))
#define  USIT_USIT_SBC_PAYLOAD_07_sbc_payload0_07(data)                          (0x000000FF&(data))
#define  USIT_USIT_SBC_PAYLOAD_07_get_sbc_payload3_07(data)                      ((0xFF000000&(data))>>24)
#define  USIT_USIT_SBC_PAYLOAD_07_get_sbc_payload2_07(data)                      ((0x00FF0000&(data))>>16)
#define  USIT_USIT_SBC_PAYLOAD_07_get_sbc_payload1_07(data)                      ((0x0000FF00&(data))>>8)
#define  USIT_USIT_SBC_PAYLOAD_07_get_sbc_payload0_07(data)                      (0x000000FF&(data))

#define  USIT_USIT_SBC_PAYLOAD_08                                               0x18026B80
#define  USIT_USIT_SBC_PAYLOAD_08_reg_addr                                       "0xB8026B80"
#define  USIT_USIT_SBC_PAYLOAD_08_reg                                            0xB8026B80
#define  USIT_USIT_SBC_PAYLOAD_08_inst_addr                                      "0x0044"
#define  set_USIT_USIT_SBC_PAYLOAD_08_reg(data)                                  (*((volatile unsigned int*)USIT_USIT_SBC_PAYLOAD_08_reg)=data)
#define  get_USIT_USIT_SBC_PAYLOAD_08_reg                                        (*((volatile unsigned int*)USIT_USIT_SBC_PAYLOAD_08_reg))
#define  USIT_USIT_SBC_PAYLOAD_08_sbc_payload3_08_shift                          (24)
#define  USIT_USIT_SBC_PAYLOAD_08_sbc_payload2_08_shift                          (16)
#define  USIT_USIT_SBC_PAYLOAD_08_sbc_payload1_08_shift                          (8)
#define  USIT_USIT_SBC_PAYLOAD_08_sbc_payload0_08_shift                          (0)
#define  USIT_USIT_SBC_PAYLOAD_08_sbc_payload3_08_mask                           (0xFF000000)
#define  USIT_USIT_SBC_PAYLOAD_08_sbc_payload2_08_mask                           (0x00FF0000)
#define  USIT_USIT_SBC_PAYLOAD_08_sbc_payload1_08_mask                           (0x0000FF00)
#define  USIT_USIT_SBC_PAYLOAD_08_sbc_payload0_08_mask                           (0x000000FF)
#define  USIT_USIT_SBC_PAYLOAD_08_sbc_payload3_08(data)                          (0xFF000000&((data)<<24))
#define  USIT_USIT_SBC_PAYLOAD_08_sbc_payload2_08(data)                          (0x00FF0000&((data)<<16))
#define  USIT_USIT_SBC_PAYLOAD_08_sbc_payload1_08(data)                          (0x0000FF00&((data)<<8))
#define  USIT_USIT_SBC_PAYLOAD_08_sbc_payload0_08(data)                          (0x000000FF&(data))
#define  USIT_USIT_SBC_PAYLOAD_08_get_sbc_payload3_08(data)                      ((0xFF000000&(data))>>24)
#define  USIT_USIT_SBC_PAYLOAD_08_get_sbc_payload2_08(data)                      ((0x00FF0000&(data))>>16)
#define  USIT_USIT_SBC_PAYLOAD_08_get_sbc_payload1_08(data)                      ((0x0000FF00&(data))>>8)
#define  USIT_USIT_SBC_PAYLOAD_08_get_sbc_payload0_08(data)                      (0x000000FF&(data))

#define  USIT_USIT_SBC_PAYLOAD_09                                               0x18026B88
#define  USIT_USIT_SBC_PAYLOAD_09_reg_addr                                       "0xB8026B88"
#define  USIT_USIT_SBC_PAYLOAD_09_reg                                            0xB8026B88
#define  USIT_USIT_SBC_PAYLOAD_09_inst_addr                                      "0x0045"
#define  set_USIT_USIT_SBC_PAYLOAD_09_reg(data)                                  (*((volatile unsigned int*)USIT_USIT_SBC_PAYLOAD_09_reg)=data)
#define  get_USIT_USIT_SBC_PAYLOAD_09_reg                                        (*((volatile unsigned int*)USIT_USIT_SBC_PAYLOAD_09_reg))
#define  USIT_USIT_SBC_PAYLOAD_09_sbc_payload3_09_shift                          (24)
#define  USIT_USIT_SBC_PAYLOAD_09_sbc_payload2_09_shift                          (16)
#define  USIT_USIT_SBC_PAYLOAD_09_sbc_payload1_09_shift                          (8)
#define  USIT_USIT_SBC_PAYLOAD_09_sbc_payload0_09_shift                          (0)
#define  USIT_USIT_SBC_PAYLOAD_09_sbc_payload3_09_mask                           (0xFF000000)
#define  USIT_USIT_SBC_PAYLOAD_09_sbc_payload2_09_mask                           (0x00FF0000)
#define  USIT_USIT_SBC_PAYLOAD_09_sbc_payload1_09_mask                           (0x0000FF00)
#define  USIT_USIT_SBC_PAYLOAD_09_sbc_payload0_09_mask                           (0x000000FF)
#define  USIT_USIT_SBC_PAYLOAD_09_sbc_payload3_09(data)                          (0xFF000000&((data)<<24))
#define  USIT_USIT_SBC_PAYLOAD_09_sbc_payload2_09(data)                          (0x00FF0000&((data)<<16))
#define  USIT_USIT_SBC_PAYLOAD_09_sbc_payload1_09(data)                          (0x0000FF00&((data)<<8))
#define  USIT_USIT_SBC_PAYLOAD_09_sbc_payload0_09(data)                          (0x000000FF&(data))
#define  USIT_USIT_SBC_PAYLOAD_09_get_sbc_payload3_09(data)                      ((0xFF000000&(data))>>24)
#define  USIT_USIT_SBC_PAYLOAD_09_get_sbc_payload2_09(data)                      ((0x00FF0000&(data))>>16)
#define  USIT_USIT_SBC_PAYLOAD_09_get_sbc_payload1_09(data)                      ((0x0000FF00&(data))>>8)
#define  USIT_USIT_SBC_PAYLOAD_09_get_sbc_payload0_09(data)                      (0x000000FF&(data))

#define  USIT_USIT_SBC_PAYLOAD_10                                               0x18026B90
#define  USIT_USIT_SBC_PAYLOAD_10_reg_addr                                       "0xB8026B90"
#define  USIT_USIT_SBC_PAYLOAD_10_reg                                            0xB8026B90
#define  USIT_USIT_SBC_PAYLOAD_10_inst_addr                                      "0x0046"
#define  set_USIT_USIT_SBC_PAYLOAD_10_reg(data)                                  (*((volatile unsigned int*)USIT_USIT_SBC_PAYLOAD_10_reg)=data)
#define  get_USIT_USIT_SBC_PAYLOAD_10_reg                                        (*((volatile unsigned int*)USIT_USIT_SBC_PAYLOAD_10_reg))
#define  USIT_USIT_SBC_PAYLOAD_10_sbc_payload3_10_shift                          (24)
#define  USIT_USIT_SBC_PAYLOAD_10_sbc_payload2_10_shift                          (16)
#define  USIT_USIT_SBC_PAYLOAD_10_sbc_payload1_10_shift                          (8)
#define  USIT_USIT_SBC_PAYLOAD_10_sbc_payload0_10_shift                          (0)
#define  USIT_USIT_SBC_PAYLOAD_10_sbc_payload3_10_mask                           (0xFF000000)
#define  USIT_USIT_SBC_PAYLOAD_10_sbc_payload2_10_mask                           (0x00FF0000)
#define  USIT_USIT_SBC_PAYLOAD_10_sbc_payload1_10_mask                           (0x0000FF00)
#define  USIT_USIT_SBC_PAYLOAD_10_sbc_payload0_10_mask                           (0x000000FF)
#define  USIT_USIT_SBC_PAYLOAD_10_sbc_payload3_10(data)                          (0xFF000000&((data)<<24))
#define  USIT_USIT_SBC_PAYLOAD_10_sbc_payload2_10(data)                          (0x00FF0000&((data)<<16))
#define  USIT_USIT_SBC_PAYLOAD_10_sbc_payload1_10(data)                          (0x0000FF00&((data)<<8))
#define  USIT_USIT_SBC_PAYLOAD_10_sbc_payload0_10(data)                          (0x000000FF&(data))
#define  USIT_USIT_SBC_PAYLOAD_10_get_sbc_payload3_10(data)                      ((0xFF000000&(data))>>24)
#define  USIT_USIT_SBC_PAYLOAD_10_get_sbc_payload2_10(data)                      ((0x00FF0000&(data))>>16)
#define  USIT_USIT_SBC_PAYLOAD_10_get_sbc_payload1_10(data)                      ((0x0000FF00&(data))>>8)
#define  USIT_USIT_SBC_PAYLOAD_10_get_sbc_payload0_10(data)                      (0x000000FF&(data))

#define  USIT_USIT_SBC_PAYLOAD_11                                               0x18026B98
#define  USIT_USIT_SBC_PAYLOAD_11_reg_addr                                       "0xB8026B98"
#define  USIT_USIT_SBC_PAYLOAD_11_reg                                            0xB8026B98
#define  USIT_USIT_SBC_PAYLOAD_11_inst_addr                                      "0x0047"
#define  set_USIT_USIT_SBC_PAYLOAD_11_reg(data)                                  (*((volatile unsigned int*)USIT_USIT_SBC_PAYLOAD_11_reg)=data)
#define  get_USIT_USIT_SBC_PAYLOAD_11_reg                                        (*((volatile unsigned int*)USIT_USIT_SBC_PAYLOAD_11_reg))
#define  USIT_USIT_SBC_PAYLOAD_11_sbc_payload3_11_shift                          (24)
#define  USIT_USIT_SBC_PAYLOAD_11_sbc_payload2_11_shift                          (16)
#define  USIT_USIT_SBC_PAYLOAD_11_sbc_payload1_11_shift                          (8)
#define  USIT_USIT_SBC_PAYLOAD_11_sbc_payload0_11_shift                          (0)
#define  USIT_USIT_SBC_PAYLOAD_11_sbc_payload3_11_mask                           (0xFF000000)
#define  USIT_USIT_SBC_PAYLOAD_11_sbc_payload2_11_mask                           (0x00FF0000)
#define  USIT_USIT_SBC_PAYLOAD_11_sbc_payload1_11_mask                           (0x0000FF00)
#define  USIT_USIT_SBC_PAYLOAD_11_sbc_payload0_11_mask                           (0x000000FF)
#define  USIT_USIT_SBC_PAYLOAD_11_sbc_payload3_11(data)                          (0xFF000000&((data)<<24))
#define  USIT_USIT_SBC_PAYLOAD_11_sbc_payload2_11(data)                          (0x00FF0000&((data)<<16))
#define  USIT_USIT_SBC_PAYLOAD_11_sbc_payload1_11(data)                          (0x0000FF00&((data)<<8))
#define  USIT_USIT_SBC_PAYLOAD_11_sbc_payload0_11(data)                          (0x000000FF&(data))
#define  USIT_USIT_SBC_PAYLOAD_11_get_sbc_payload3_11(data)                      ((0xFF000000&(data))>>24)
#define  USIT_USIT_SBC_PAYLOAD_11_get_sbc_payload2_11(data)                      ((0x00FF0000&(data))>>16)
#define  USIT_USIT_SBC_PAYLOAD_11_get_sbc_payload1_11(data)                      ((0x0000FF00&(data))>>8)
#define  USIT_USIT_SBC_PAYLOAD_11_get_sbc_payload0_11(data)                      (0x000000FF&(data))

#define  USIT_USIT_CRC_CTRL                                                     0x18026BC0
#define  USIT_USIT_CRC_CTRL_reg_addr                                             "0xB8026BC0"
#define  USIT_USIT_CRC_CTRL_reg                                                  0xB8026BC0
#define  USIT_USIT_CRC_CTRL_inst_addr                                            "0x0048"
#define  set_USIT_USIT_CRC_CTRL_reg(data)                                        (*((volatile unsigned int*)USIT_USIT_CRC_CTRL_reg)=data)
#define  get_USIT_USIT_CRC_CTRL_reg                                              (*((volatile unsigned int*)USIT_USIT_CRC_CTRL_reg))
#define  USIT_USIT_CRC_CTRL_crc_err_cnt_shift                                    (16)
#define  USIT_USIT_CRC_CTRL_crc_port_en_shift                                    (4)
#define  USIT_USIT_CRC_CTRL_crc_auto_cmp_en_shift                                (2)
#define  USIT_USIT_CRC_CTRL_crc_conti_shift                                      (1)
#define  USIT_USIT_CRC_CTRL_crc_start_shift                                      (0)
#define  USIT_USIT_CRC_CTRL_crc_err_cnt_mask                                     (0xFFFF0000)
#define  USIT_USIT_CRC_CTRL_crc_port_en_mask                                     (0x0000FFF0)
#define  USIT_USIT_CRC_CTRL_crc_auto_cmp_en_mask                                 (0x00000004)
#define  USIT_USIT_CRC_CTRL_crc_conti_mask                                       (0x00000002)
#define  USIT_USIT_CRC_CTRL_crc_start_mask                                       (0x00000001)
#define  USIT_USIT_CRC_CTRL_crc_err_cnt(data)                                    (0xFFFF0000&((data)<<16))
#define  USIT_USIT_CRC_CTRL_crc_port_en(data)                                    (0x0000FFF0&((data)<<4))
#define  USIT_USIT_CRC_CTRL_crc_auto_cmp_en(data)                                (0x00000004&((data)<<2))
#define  USIT_USIT_CRC_CTRL_crc_conti(data)                                      (0x00000002&((data)<<1))
#define  USIT_USIT_CRC_CTRL_crc_start(data)                                      (0x00000001&(data))
#define  USIT_USIT_CRC_CTRL_get_crc_err_cnt(data)                                ((0xFFFF0000&(data))>>16)
#define  USIT_USIT_CRC_CTRL_get_crc_port_en(data)                                ((0x0000FFF0&(data))>>4)
#define  USIT_USIT_CRC_CTRL_get_crc_auto_cmp_en(data)                            ((0x00000004&(data))>>2)
#define  USIT_USIT_CRC_CTRL_get_crc_conti(data)                                  ((0x00000002&(data))>>1)
#define  USIT_USIT_CRC_CTRL_get_crc_start(data)                                  (0x00000001&(data))

#define  USIT_USIT_CRC_RESULT                                                   0x18026BC4
#define  USIT_USIT_CRC_RESULT_reg_addr                                           "0xB8026BC4"
#define  USIT_USIT_CRC_RESULT_reg                                                0xB8026BC4
#define  USIT_USIT_CRC_RESULT_inst_addr                                          "0x0049"
#define  set_USIT_USIT_CRC_RESULT_reg(data)                                      (*((volatile unsigned int*)USIT_USIT_CRC_RESULT_reg)=data)
#define  get_USIT_USIT_CRC_RESULT_reg                                            (*((volatile unsigned int*)USIT_USIT_CRC_RESULT_reg))
#define  USIT_USIT_CRC_RESULT_crc_result_shift                                   (0)
#define  USIT_USIT_CRC_RESULT_crc_result_mask                                    (0xFFFFFFFF)
#define  USIT_USIT_CRC_RESULT_crc_result(data)                                   (0xFFFFFFFF&(data))
#define  USIT_USIT_CRC_RESULT_get_crc_result(data)                               (0xFFFFFFFF&(data))

#define  USIT_USIT_CRC_GOLDEN                                                   0x18026BC8
#define  USIT_USIT_CRC_GOLDEN_reg_addr                                           "0xB8026BC8"
#define  USIT_USIT_CRC_GOLDEN_reg                                                0xB8026BC8
#define  USIT_USIT_CRC_GOLDEN_inst_addr                                          "0x004A"
#define  set_USIT_USIT_CRC_GOLDEN_reg(data)                                      (*((volatile unsigned int*)USIT_USIT_CRC_GOLDEN_reg)=data)
#define  get_USIT_USIT_CRC_GOLDEN_reg                                            (*((volatile unsigned int*)USIT_USIT_CRC_GOLDEN_reg))
#define  USIT_USIT_CRC_GOLDEN_crc_golden_shift                                   (0)
#define  USIT_USIT_CRC_GOLDEN_crc_golden_mask                                    (0xFFFFFFFF)
#define  USIT_USIT_CRC_GOLDEN_crc_golden(data)                                   (0xFFFFFFFF&(data))
#define  USIT_USIT_CRC_GOLDEN_get_crc_golden(data)                               (0xFFFFFFFF&(data))

#define  USIT_USIT_DEBUG                                                        0x18026BD0
#define  USIT_USIT_DEBUG_reg_addr                                                "0xB8026BD0"
#define  USIT_USIT_DEBUG_reg                                                     0xB8026BD0
#define  USIT_USIT_DEBUG_inst_addr                                               "0x004B"
#define  set_USIT_USIT_DEBUG_reg(data)                                           (*((volatile unsigned int*)USIT_USIT_DEBUG_reg)=data)
#define  get_USIT_USIT_DEBUG_reg                                                 (*((volatile unsigned int*)USIT_USIT_DEBUG_reg))
#define  USIT_USIT_DEBUG_dbg_en_shift                                            (31)
#define  USIT_USIT_DEBUG_dbg_data_sel_shift                                      (8)
#define  USIT_USIT_DEBUG_dbg_sel_shift                                           (0)
#define  USIT_USIT_DEBUG_dbg_en_mask                                             (0x80000000)
#define  USIT_USIT_DEBUG_dbg_data_sel_mask                                       (0x00000300)
#define  USIT_USIT_DEBUG_dbg_sel_mask                                            (0x0000003F)
#define  USIT_USIT_DEBUG_dbg_en(data)                                            (0x80000000&((data)<<31))
#define  USIT_USIT_DEBUG_dbg_data_sel(data)                                      (0x00000300&((data)<<8))
#define  USIT_USIT_DEBUG_dbg_sel(data)                                           (0x0000003F&(data))
#define  USIT_USIT_DEBUG_get_dbg_en(data)                                        ((0x80000000&(data))>>31)
#define  USIT_USIT_DEBUG_get_dbg_data_sel(data)                                  ((0x00000300&(data))>>8)
#define  USIT_USIT_DEBUG_get_dbg_sel(data)                                       (0x0000003F&(data))

#define  USIT_USIT_TST_OUT                                                      0x18026BD4
#define  USIT_USIT_TST_OUT_reg_addr                                              "0xB8026BD4"
#define  USIT_USIT_TST_OUT_reg                                                   0xB8026BD4
#define  USIT_USIT_TST_OUT_inst_addr                                             "0x004C"
#define  set_USIT_USIT_TST_OUT_reg(data)                                         (*((volatile unsigned int*)USIT_USIT_TST_OUT_reg)=data)
#define  get_USIT_USIT_TST_OUT_reg                                               (*((volatile unsigned int*)USIT_USIT_TST_OUT_reg))
#define  USIT_USIT_TST_OUT_usit_tst_out_shift                                    (0)
#define  USIT_USIT_TST_OUT_usit_tst_out_mask                                     (0xFFFFFFFF)
#define  USIT_USIT_TST_OUT_usit_tst_out(data)                                    (0xFFFFFFFF&(data))
#define  USIT_USIT_TST_OUT_get_usit_tst_out(data)                                (0xFFFFFFFF&(data))

#define  USIT_USIT_FIFO_BIST                                                    0x18026BE0
#define  USIT_USIT_FIFO_BIST_reg_addr                                            "0xB8026BE0"
#define  USIT_USIT_FIFO_BIST_reg                                                 0xB8026BE0
#define  USIT_USIT_FIFO_BIST_inst_addr                                           "0x004D"
#define  set_USIT_USIT_FIFO_BIST_reg(data)                                       (*((volatile unsigned int*)USIT_USIT_FIFO_BIST_reg)=data)
#define  get_USIT_USIT_FIFO_BIST_reg                                             (*((volatile unsigned int*)USIT_USIT_FIFO_BIST_reg))
#define  USIT_USIT_FIFO_BIST_usit_bist_enable_shift                              (31)
#define  USIT_USIT_FIFO_BIST_usit_bist_done_shift                                (30)
#define  USIT_USIT_FIFO_BIST_usit_bist_result_shift                              (29)
#define  USIT_USIT_FIFO_BIST_usit_bist_length_shift                              (0)
#define  USIT_USIT_FIFO_BIST_usit_bist_enable_mask                               (0x80000000)
#define  USIT_USIT_FIFO_BIST_usit_bist_done_mask                                 (0x40000000)
#define  USIT_USIT_FIFO_BIST_usit_bist_result_mask                               (0x20000000)
#define  USIT_USIT_FIFO_BIST_usit_bist_length_mask                               (0x000FFFFF)
#define  USIT_USIT_FIFO_BIST_usit_bist_enable(data)                              (0x80000000&((data)<<31))
#define  USIT_USIT_FIFO_BIST_usit_bist_done(data)                                (0x40000000&((data)<<30))
#define  USIT_USIT_FIFO_BIST_usit_bist_result(data)                              (0x20000000&((data)<<29))
#define  USIT_USIT_FIFO_BIST_usit_bist_length(data)                              (0x000FFFFF&(data))
#define  USIT_USIT_FIFO_BIST_get_usit_bist_enable(data)                          ((0x80000000&(data))>>31)
#define  USIT_USIT_FIFO_BIST_get_usit_bist_done(data)                            ((0x40000000&(data))>>30)
#define  USIT_USIT_FIFO_BIST_get_usit_bist_result(data)                          ((0x20000000&(data))>>29)
#define  USIT_USIT_FIFO_BIST_get_usit_bist_length(data)                          (0x000FFFFF&(data))

#define  USIT_USIT_DUMMY0                                                       0x18026BF0
#define  USIT_USIT_DUMMY0_reg_addr                                               "0xB8026BF0"
#define  USIT_USIT_DUMMY0_reg                                                    0xB8026BF0
#define  USIT_USIT_DUMMY0_inst_addr                                              "0x004E"
#define  set_USIT_USIT_DUMMY0_reg(data)                                          (*((volatile unsigned int*)USIT_USIT_DUMMY0_reg)=data)
#define  get_USIT_USIT_DUMMY0_reg                                                (*((volatile unsigned int*)USIT_USIT_DUMMY0_reg))
#define  USIT_USIT_DUMMY0_dummy0_shift                                           (0)
#define  USIT_USIT_DUMMY0_dummy0_mask                                            (0xFFFFFFFF)
#define  USIT_USIT_DUMMY0_dummy0(data)                                           (0xFFFFFFFF&(data))
#define  USIT_USIT_DUMMY0_get_dummy0(data)                                       (0xFFFFFFFF&(data))

#define  USIT_USIT_DUMMY1                                                       0x18026BF4
#define  USIT_USIT_DUMMY1_reg_addr                                               "0xB8026BF4"
#define  USIT_USIT_DUMMY1_reg                                                    0xB8026BF4
#define  USIT_USIT_DUMMY1_inst_addr                                              "0x004F"
#define  set_USIT_USIT_DUMMY1_reg(data)                                          (*((volatile unsigned int*)USIT_USIT_DUMMY1_reg)=data)
#define  get_USIT_USIT_DUMMY1_reg                                                (*((volatile unsigned int*)USIT_USIT_DUMMY1_reg))
#define  USIT_USIT_DUMMY1_dummy1_shift                                           (0)
#define  USIT_USIT_DUMMY1_dummy1_mask                                            (0xFFFFFFFF)
#define  USIT_USIT_DUMMY1_dummy1(data)                                           (0xFFFFFFFF&(data))
#define  USIT_USIT_DUMMY1_get_dummy1(data)                                       (0xFFFFFFFF&(data))

#define  USIT_USIT_DUMMY2                                                       0x18026BF8
#define  USIT_USIT_DUMMY2_reg_addr                                               "0xB8026BF8"
#define  USIT_USIT_DUMMY2_reg                                                    0xB8026BF8
#define  USIT_USIT_DUMMY2_inst_addr                                              "0x0050"
#define  set_USIT_USIT_DUMMY2_reg(data)                                          (*((volatile unsigned int*)USIT_USIT_DUMMY2_reg)=data)
#define  get_USIT_USIT_DUMMY2_reg                                                (*((volatile unsigned int*)USIT_USIT_DUMMY2_reg))
#define  USIT_USIT_DUMMY2_dummy2_shift                                           (0)
#define  USIT_USIT_DUMMY2_dummy2_mask                                            (0xFFFFFFFF)
#define  USIT_USIT_DUMMY2_dummy2(data)                                           (0xFFFFFFFF&(data))
#define  USIT_USIT_DUMMY2_get_dummy2(data)                                       (0xFFFFFFFF&(data))

#define  USIT_USIT_DUMMY3                                                       0x18026BFC
#define  USIT_USIT_DUMMY3_reg_addr                                               "0xB8026BFC"
#define  USIT_USIT_DUMMY3_reg                                                    0xB8026BFC
#define  USIT_USIT_DUMMY3_inst_addr                                              "0x0051"
#define  set_USIT_USIT_DUMMY3_reg(data)                                          (*((volatile unsigned int*)USIT_USIT_DUMMY3_reg)=data)
#define  get_USIT_USIT_DUMMY3_reg                                                (*((volatile unsigned int*)USIT_USIT_DUMMY3_reg))
#define  USIT_USIT_DUMMY3_dummy3_shift                                           (0)
#define  USIT_USIT_DUMMY3_dummy3_mask                                            (0xFFFFFFFF)
#define  USIT_USIT_DUMMY3_dummy3(data)                                           (0xFFFFFFFF&(data))
#define  USIT_USIT_DUMMY3_get_dummy3(data)                                       (0xFFFFFFFF&(data))

#ifndef LITTLE_ENDIAN //apply BIG_ENDIAN

//======USIT register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  sbc_cmd_done_irq_en:1;
        RBus_UInt32  sbc_in_change_irq_en:1;
        RBus_UInt32  sbc_in_unlock_irq_en:1;
        RBus_UInt32  fifo_data_stay_irq_en:1;
        RBus_UInt32  fifo_align_err_irq_en:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  sbc_cmd_done_irq:1;
        RBus_UInt32  sbc_in_change_irq:1;
        RBus_UInt32  sbc_in_unlock_irq:1;
        RBus_UInt32  fifo_data_stay_irq:1;
        RBus_UInt32  fifo_align_err_irq:1;
        RBus_UInt32  res3:3;
        RBus_UInt32  hit_w_cnt_error:9;
        RBus_UInt32  pair_sel:1;
        RBus_UInt32  res4:1;
        RBus_UInt32  bit_sel:1;
        RBus_UInt32  usit_en:1;
    };
}usit_usit_ctrl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hs_to_rdata0:8;
        RBus_UInt32  res1:7;
        RBus_UInt32  config_line_position:1;
        RBus_UInt32  back_dmy_line_num:8;
        RBus_UInt32  front_dmy_line_num:8;
    };
}usit_usit_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  force_training_pattern:1;
        RBus_UInt32  res2:2;
        RBus_UInt32  sfc_training_pat_type:2;
        RBus_UInt32  res3:1;
        RBus_UInt32  sfc_training_pat_offset:7;
        RBus_UInt32  sfc_training_period:4;
        RBus_UInt32  sfc_src_sel:4;
        RBus_UInt32  res4:3;
        RBus_UInt32  send_dga_frm_data:1;
        RBus_UInt32  res5:2;
        RBus_UInt32  send_frm_data_period:2;
    };
}usit_usit_ctrl3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:1;
        RBus_UInt32  pacmod_rgb:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  pacmod_dga:3;
        RBus_UInt32  res3:1;
        RBus_UInt32  pacmod_dga_frm:3;
        RBus_UInt32  dummy18026a0c_19_12:8;
        RBus_UInt32  frm_data_sel:12;
    };
}usit_usit_ctrl4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:2;
        RBus_UInt32  force_scramble_hbp:1;
        RBus_UInt32  scrambler_en:1;
        RBus_UInt32  scrambler_rst_sel:4;
        RBus_UInt32  res2:6;
        RBus_UInt32  lfsr_ini_val:18;
    };
}usit_usit_scr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  training_pattern1:10;
        RBus_UInt32  res2:6;
        RBus_UInt32  training_pattern0:10;
    };
}usit_usit_training_pat01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  training_pattern3:10;
        RBus_UInt32  res2:6;
        RBus_UInt32  training_pattern2:10;
    };
}usit_usit_training_pat23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:6;
        RBus_UInt32  dmy_data_value:10;
        RBus_UInt32  res2:6;
        RBus_UInt32  hbp:10;
    };
}usit_usit_dmy_hbp_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  setting_00_l:32;
    };
}usit_usit_setting00_l_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  hs_to_rdata_last_00:12;
        RBus_UInt32  setting_00_m:16;
    };
}usit_usit_setting00_m_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  setting_01_l:32;
    };
}usit_usit_setting01_l_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  hs_to_rdata_last_01:12;
        RBus_UInt32  setting_01_m:16;
    };
}usit_usit_setting01_m_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  setting_02_l:32;
    };
}usit_usit_setting02_l_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  hs_to_rdata_last_02:12;
        RBus_UInt32  setting_02_m:16;
    };
}usit_usit_setting02_m_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  setting_03_l:32;
    };
}usit_usit_setting03_l_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  hs_to_rdata_last_03:12;
        RBus_UInt32  setting_03_m:16;
    };
}usit_usit_setting03_m_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  setting_04_l:32;
    };
}usit_usit_setting04_l_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  hs_to_rdata_last_04:12;
        RBus_UInt32  setting_04_m:16;
    };
}usit_usit_setting04_m_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  setting_05_l:32;
    };
}usit_usit_setting05_l_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  hs_to_rdata_last_05:12;
        RBus_UInt32  setting_05_m:16;
    };
}usit_usit_setting05_m_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  setting_06_l:32;
    };
}usit_usit_setting06_l_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  hs_to_rdata_last_06:12;
        RBus_UInt32  setting_06_m:16;
    };
}usit_usit_setting06_m_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  setting_07_l:32;
    };
}usit_usit_setting07_l_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  hs_to_rdata_last_07:12;
        RBus_UInt32  setting_07_m:16;
    };
}usit_usit_setting07_m_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  setting_08_l:32;
    };
}usit_usit_setting08_l_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  hs_to_rdata_last_08:12;
        RBus_UInt32  setting_08_m:16;
    };
}usit_usit_setting08_m_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  setting_09_l:32;
    };
}usit_usit_setting09_l_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  hs_to_rdata_last_09:12;
        RBus_UInt32  setting_09_m:16;
    };
}usit_usit_setting09_m_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  setting_10_l:32;
    };
}usit_usit_setting10_l_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  hs_to_rdata_last_10:12;
        RBus_UInt32  setting_10_m:16;
    };
}usit_usit_setting10_m_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  setting_11_l:32;
    };
}usit_usit_setting11_l_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  hs_to_rdata_last_11:12;
        RBus_UInt32  setting_11_m:16;
    };
}usit_usit_setting11_m_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vgma_00:32;
    };
}usit_usit_vgma_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vgma_01:32;
    };
}usit_usit_vgma_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vgma_02:32;
    };
}usit_usit_vgma_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vgma_03:32;
    };
}usit_usit_vgma_03_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vgma_04:32;
    };
}usit_usit_vgma_04_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vgma_05:32;
    };
}usit_usit_vgma_05_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vgma_06:32;
    };
}usit_usit_vgma_06_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vgma_07:32;
    };
}usit_usit_vgma_07_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vgma_08:32;
    };
}usit_usit_vgma_08_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vgma_09:32;
    };
}usit_usit_vgma_09_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vgma_10:32;
    };
}usit_usit_vgma_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vgma_11:32;
    };
}usit_usit_vgma_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  frm_conf_00:32;
    };
}usit_usit_frm_conf_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  frm_conf_01:32;
    };
}usit_usit_frm_conf_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:24;
        RBus_UInt32  frm_conf_02:8;
    };
}usit_usit_frm_conf_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  tcon_d_sel:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  tcon_c_sel:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  tcon_b_sel:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  tcon_a_sel:5;
    };
}usit_usit_tcon_abcd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:3;
        RBus_UInt32  tcon_h_sel:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  tcon_g_sel:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  tcon_f_sel:5;
        RBus_UInt32  res4:3;
        RBus_UInt32  tcon_e_sel:5;
    };
}usit_usit_tcon_efgh_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_c07_sel:4;
        RBus_UInt32  lane_c06_sel:4;
        RBus_UInt32  lane_c05_sel:4;
        RBus_UInt32  lane_c04_sel:4;
        RBus_UInt32  lane_c03_sel:4;
        RBus_UInt32  lane_c02_sel:4;
        RBus_UInt32  lane_c01_sel:4;
        RBus_UInt32  lane_c00_sel:4;
    };
}usit_usit_mux_00_07_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_c15_sel:4;
        RBus_UInt32  lane_c14_sel:4;
        RBus_UInt32  lane_c13_sel:4;
        RBus_UInt32  lane_c12_sel:4;
        RBus_UInt32  lane_c11_sel:4;
        RBus_UInt32  lane_c10_sel:4;
        RBus_UInt32  lane_c09_sel:4;
        RBus_UInt32  lane_c08_sel:4;
    };
}usit_usit_mux_08_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_c23_sel:4;
        RBus_UInt32  lane_c22_sel:4;
        RBus_UInt32  lane_c21_sel:4;
        RBus_UInt32  lane_c20_sel:4;
        RBus_UInt32  lane_c19_sel:4;
        RBus_UInt32  lane_c18_sel:4;
        RBus_UInt32  lane_c17_sel:4;
        RBus_UInt32  lane_c16_sel:4;
    };
}usit_usit_mux_16_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_c31_sel:4;
        RBus_UInt32  lane_c30_sel:4;
        RBus_UInt32  lane_c29_sel:4;
        RBus_UInt32  lane_c28_sel:4;
        RBus_UInt32  lane_c27_sel:4;
        RBus_UInt32  lane_c26_sel:4;
        RBus_UInt32  lane_c25_sel:4;
        RBus_UInt32  lane_c24_sel:4;
    };
}usit_usit_mux_24_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_c39_sel:4;
        RBus_UInt32  lane_c38_sel:4;
        RBus_UInt32  lane_c37_sel:4;
        RBus_UInt32  lane_c36_sel:4;
        RBus_UInt32  lane_c35_sel:4;
        RBus_UInt32  lane_c34_sel:4;
        RBus_UInt32  lane_c33_sel:4;
        RBus_UInt32  lane_c32_sel:4;
    };
}usit_usit_mux_32_39_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_c47_sel:4;
        RBus_UInt32  lane_c46_sel:4;
        RBus_UInt32  lane_c45_sel:4;
        RBus_UInt32  lane_c44_sel:4;
        RBus_UInt32  lane_c43_sel:4;
        RBus_UInt32  lane_c42_sel:4;
        RBus_UInt32  lane_c41_sel:4;
        RBus_UInt32  lane_c40_sel:4;
    };
}usit_usit_mux_40_47_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy18026b2c_31_12:20;
        RBus_UInt32  usit_port_en:12;
    };
}usit_usit_port_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:13;
        RBus_UInt32  sbc_payload_num:3;
        RBus_UInt32  res2:3;
        RBus_UInt32  sbc_cmd_trigger:1;
        RBus_UInt32  res3:2;
        RBus_UInt32  sbc_td:10;
    };
}usit_usit_sbc_ctrl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  t_cs2start:4;
        RBus_UInt32  t_sfcr2sbcr:4;
        RBus_UInt32  t_sfcf2sbcf:8;
        RBus_UInt32  t_standby:8;
        RBus_UInt32  t_sfcr2start:8;
    };
}usit_usit_sbc_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:4;
        RBus_UInt32  sbc_cmd_lane_en:12;
        RBus_UInt32  res2:12;
        RBus_UInt32  sbc_out_manual_value:1;
        RBus_UInt32  sbc_out_manual_mode:1;
        RBus_UInt32  sbc_in_manual_value:1;
        RBus_UInt32  sbc_in_manual_mode:1;
    };
}usit_usit_sbc_ctrl3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  res1:22;
        RBus_UInt32  sbc_ui_period:10;
    };
}usit_usit_sbc_ctrl4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sbc_payload3_00:8;
        RBus_UInt32  sbc_payload2_00:8;
        RBus_UInt32  sbc_payload1_00:8;
        RBus_UInt32  sbc_payload0_00:8;
    };
}usit_usit_sbc_payload_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sbc_payload3_01:8;
        RBus_UInt32  sbc_payload2_01:8;
        RBus_UInt32  sbc_payload1_01:8;
        RBus_UInt32  sbc_payload0_01:8;
    };
}usit_usit_sbc_payload_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sbc_payload3_02:8;
        RBus_UInt32  sbc_payload2_02:8;
        RBus_UInt32  sbc_payload1_02:8;
        RBus_UInt32  sbc_payload0_02:8;
    };
}usit_usit_sbc_payload_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sbc_payload3_03:8;
        RBus_UInt32  sbc_payload2_03:8;
        RBus_UInt32  sbc_payload1_03:8;
        RBus_UInt32  sbc_payload0_03:8;
    };
}usit_usit_sbc_payload_03_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sbc_payload3_04:8;
        RBus_UInt32  sbc_payload2_04:8;
        RBus_UInt32  sbc_payload1_04:8;
        RBus_UInt32  sbc_payload0_04:8;
    };
}usit_usit_sbc_payload_04_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sbc_payload3_05:8;
        RBus_UInt32  sbc_payload2_05:8;
        RBus_UInt32  sbc_payload1_05:8;
        RBus_UInt32  sbc_payload0_05:8;
    };
}usit_usit_sbc_payload_05_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sbc_payload3_06:8;
        RBus_UInt32  sbc_payload2_06:8;
        RBus_UInt32  sbc_payload1_06:8;
        RBus_UInt32  sbc_payload0_06:8;
    };
}usit_usit_sbc_payload_06_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sbc_payload3_07:8;
        RBus_UInt32  sbc_payload2_07:8;
        RBus_UInt32  sbc_payload1_07:8;
        RBus_UInt32  sbc_payload0_07:8;
    };
}usit_usit_sbc_payload_07_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sbc_payload3_08:8;
        RBus_UInt32  sbc_payload2_08:8;
        RBus_UInt32  sbc_payload1_08:8;
        RBus_UInt32  sbc_payload0_08:8;
    };
}usit_usit_sbc_payload_08_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sbc_payload3_09:8;
        RBus_UInt32  sbc_payload2_09:8;
        RBus_UInt32  sbc_payload1_09:8;
        RBus_UInt32  sbc_payload0_09:8;
    };
}usit_usit_sbc_payload_09_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sbc_payload3_10:8;
        RBus_UInt32  sbc_payload2_10:8;
        RBus_UInt32  sbc_payload1_10:8;
        RBus_UInt32  sbc_payload0_10:8;
    };
}usit_usit_sbc_payload_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sbc_payload3_11:8;
        RBus_UInt32  sbc_payload2_11:8;
        RBus_UInt32  sbc_payload1_11:8;
        RBus_UInt32  sbc_payload0_11:8;
    };
}usit_usit_sbc_payload_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_err_cnt:16;
        RBus_UInt32  crc_port_en:12;
        RBus_UInt32  res1:1;
        RBus_UInt32  crc_auto_cmp_en:1;
        RBus_UInt32  crc_conti:1;
        RBus_UInt32  crc_start:1;
    };
}usit_usit_crc_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_result:32;
    };
}usit_usit_crc_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_golden:32;
    };
}usit_usit_crc_golden_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dbg_en:1;
        RBus_UInt32  res1:21;
        RBus_UInt32  dbg_data_sel:2;
        RBus_UInt32  res2:2;
        RBus_UInt32  dbg_sel:6;
    };
}usit_usit_debug_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  usit_tst_out:32;
    };
}usit_usit_tst_out_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  usit_bist_enable:1;
        RBus_UInt32  usit_bist_done:1;
        RBus_UInt32  usit_bist_result:1;
        RBus_UInt32  res1:9;
        RBus_UInt32  usit_bist_length:20;
    };
}usit_usit_fifo_bist_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy0:32;
    };
}usit_usit_dummy0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1:32;
    };
}usit_usit_dummy1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy2:32;
    };
}usit_usit_dummy2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy3:32;
    };
}usit_usit_dummy3_RBUS;

#else //apply LITTLE_ENDIAN

//======USIT register structure define==========

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  usit_en:1;
        RBus_UInt32  bit_sel:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  pair_sel:1;
        RBus_UInt32  hit_w_cnt_error:9;
        RBus_UInt32  res2:3;
        RBus_UInt32  fifo_align_err_irq:1;
        RBus_UInt32  fifo_data_stay_irq:1;
        RBus_UInt32  sbc_in_unlock_irq:1;
        RBus_UInt32  sbc_in_change_irq:1;
        RBus_UInt32  sbc_cmd_done_irq:1;
        RBus_UInt32  res3:3;
        RBus_UInt32  fifo_align_err_irq_en:1;
        RBus_UInt32  fifo_data_stay_irq_en:1;
        RBus_UInt32  sbc_in_unlock_irq_en:1;
        RBus_UInt32  sbc_in_change_irq_en:1;
        RBus_UInt32  sbc_cmd_done_irq_en:1;
        RBus_UInt32  res4:3;
    };
}usit_usit_ctrl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  front_dmy_line_num:8;
        RBus_UInt32  back_dmy_line_num:8;
        RBus_UInt32  config_line_position:1;
        RBus_UInt32  res1:7;
        RBus_UInt32  hs_to_rdata0:8;
    };
}usit_usit_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  send_frm_data_period:2;
        RBus_UInt32  res1:2;
        RBus_UInt32  send_dga_frm_data:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  sfc_src_sel:4;
        RBus_UInt32  sfc_training_period:4;
        RBus_UInt32  sfc_training_pat_offset:7;
        RBus_UInt32  res3:1;
        RBus_UInt32  sfc_training_pat_type:2;
        RBus_UInt32  res4:2;
        RBus_UInt32  force_training_pattern:1;
        RBus_UInt32  res5:3;
    };
}usit_usit_ctrl3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  frm_data_sel:12;
        RBus_UInt32  dummy18026a0c_19_12:8;
        RBus_UInt32  pacmod_dga_frm:3;
        RBus_UInt32  res1:1;
        RBus_UInt32  pacmod_dga:3;
        RBus_UInt32  res2:1;
        RBus_UInt32  pacmod_rgb:3;
        RBus_UInt32  res3:1;
    };
}usit_usit_ctrl4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lfsr_ini_val:18;
        RBus_UInt32  res1:6;
        RBus_UInt32  scrambler_rst_sel:4;
        RBus_UInt32  scrambler_en:1;
        RBus_UInt32  force_scramble_hbp:1;
        RBus_UInt32  res2:2;
    };
}usit_usit_scr_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  training_pattern0:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  training_pattern1:10;
        RBus_UInt32  res2:6;
    };
}usit_usit_training_pat01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  training_pattern2:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  training_pattern3:10;
        RBus_UInt32  res2:6;
    };
}usit_usit_training_pat23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  hbp:10;
        RBus_UInt32  res1:6;
        RBus_UInt32  dmy_data_value:10;
        RBus_UInt32  res2:6;
    };
}usit_usit_dmy_hbp_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  setting_00_l:32;
    };
}usit_usit_setting00_l_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  setting_00_m:16;
        RBus_UInt32  hs_to_rdata_last_00:12;
        RBus_UInt32  res1:4;
    };
}usit_usit_setting00_m_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  setting_01_l:32;
    };
}usit_usit_setting01_l_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  setting_01_m:16;
        RBus_UInt32  hs_to_rdata_last_01:12;
        RBus_UInt32  res1:4;
    };
}usit_usit_setting01_m_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  setting_02_l:32;
    };
}usit_usit_setting02_l_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  setting_02_m:16;
        RBus_UInt32  hs_to_rdata_last_02:12;
        RBus_UInt32  res1:4;
    };
}usit_usit_setting02_m_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  setting_03_l:32;
    };
}usit_usit_setting03_l_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  setting_03_m:16;
        RBus_UInt32  hs_to_rdata_last_03:12;
        RBus_UInt32  res1:4;
    };
}usit_usit_setting03_m_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  setting_04_l:32;
    };
}usit_usit_setting04_l_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  setting_04_m:16;
        RBus_UInt32  hs_to_rdata_last_04:12;
        RBus_UInt32  res1:4;
    };
}usit_usit_setting04_m_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  setting_05_l:32;
    };
}usit_usit_setting05_l_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  setting_05_m:16;
        RBus_UInt32  hs_to_rdata_last_05:12;
        RBus_UInt32  res1:4;
    };
}usit_usit_setting05_m_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  setting_06_l:32;
    };
}usit_usit_setting06_l_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  setting_06_m:16;
        RBus_UInt32  hs_to_rdata_last_06:12;
        RBus_UInt32  res1:4;
    };
}usit_usit_setting06_m_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  setting_07_l:32;
    };
}usit_usit_setting07_l_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  setting_07_m:16;
        RBus_UInt32  hs_to_rdata_last_07:12;
        RBus_UInt32  res1:4;
    };
}usit_usit_setting07_m_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  setting_08_l:32;
    };
}usit_usit_setting08_l_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  setting_08_m:16;
        RBus_UInt32  hs_to_rdata_last_08:12;
        RBus_UInt32  res1:4;
    };
}usit_usit_setting08_m_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  setting_09_l:32;
    };
}usit_usit_setting09_l_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  setting_09_m:16;
        RBus_UInt32  hs_to_rdata_last_09:12;
        RBus_UInt32  res1:4;
    };
}usit_usit_setting09_m_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  setting_10_l:32;
    };
}usit_usit_setting10_l_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  setting_10_m:16;
        RBus_UInt32  hs_to_rdata_last_10:12;
        RBus_UInt32  res1:4;
    };
}usit_usit_setting10_m_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  setting_11_l:32;
    };
}usit_usit_setting11_l_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  setting_11_m:16;
        RBus_UInt32  hs_to_rdata_last_11:12;
        RBus_UInt32  res1:4;
    };
}usit_usit_setting11_m_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vgma_00:32;
    };
}usit_usit_vgma_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vgma_01:32;
    };
}usit_usit_vgma_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vgma_02:32;
    };
}usit_usit_vgma_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vgma_03:32;
    };
}usit_usit_vgma_03_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vgma_04:32;
    };
}usit_usit_vgma_04_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vgma_05:32;
    };
}usit_usit_vgma_05_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vgma_06:32;
    };
}usit_usit_vgma_06_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vgma_07:32;
    };
}usit_usit_vgma_07_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vgma_08:32;
    };
}usit_usit_vgma_08_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vgma_09:32;
    };
}usit_usit_vgma_09_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vgma_10:32;
    };
}usit_usit_vgma_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  vgma_11:32;
    };
}usit_usit_vgma_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  frm_conf_00:32;
    };
}usit_usit_frm_conf_0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  frm_conf_01:32;
    };
}usit_usit_frm_conf_1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  frm_conf_02:8;
        RBus_UInt32  res1:24;
    };
}usit_usit_frm_conf_2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tcon_a_sel:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  tcon_b_sel:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  tcon_c_sel:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  tcon_d_sel:5;
        RBus_UInt32  res4:3;
    };
}usit_usit_tcon_abcd_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  tcon_e_sel:5;
        RBus_UInt32  res1:3;
        RBus_UInt32  tcon_f_sel:5;
        RBus_UInt32  res2:3;
        RBus_UInt32  tcon_g_sel:5;
        RBus_UInt32  res3:3;
        RBus_UInt32  tcon_h_sel:5;
        RBus_UInt32  res4:3;
    };
}usit_usit_tcon_efgh_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_c00_sel:4;
        RBus_UInt32  lane_c01_sel:4;
        RBus_UInt32  lane_c02_sel:4;
        RBus_UInt32  lane_c03_sel:4;
        RBus_UInt32  lane_c04_sel:4;
        RBus_UInt32  lane_c05_sel:4;
        RBus_UInt32  lane_c06_sel:4;
        RBus_UInt32  lane_c07_sel:4;
    };
}usit_usit_mux_00_07_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_c08_sel:4;
        RBus_UInt32  lane_c09_sel:4;
        RBus_UInt32  lane_c10_sel:4;
        RBus_UInt32  lane_c11_sel:4;
        RBus_UInt32  lane_c12_sel:4;
        RBus_UInt32  lane_c13_sel:4;
        RBus_UInt32  lane_c14_sel:4;
        RBus_UInt32  lane_c15_sel:4;
    };
}usit_usit_mux_08_15_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_c16_sel:4;
        RBus_UInt32  lane_c17_sel:4;
        RBus_UInt32  lane_c18_sel:4;
        RBus_UInt32  lane_c19_sel:4;
        RBus_UInt32  lane_c20_sel:4;
        RBus_UInt32  lane_c21_sel:4;
        RBus_UInt32  lane_c22_sel:4;
        RBus_UInt32  lane_c23_sel:4;
    };
}usit_usit_mux_16_23_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_c24_sel:4;
        RBus_UInt32  lane_c25_sel:4;
        RBus_UInt32  lane_c26_sel:4;
        RBus_UInt32  lane_c27_sel:4;
        RBus_UInt32  lane_c28_sel:4;
        RBus_UInt32  lane_c29_sel:4;
        RBus_UInt32  lane_c30_sel:4;
        RBus_UInt32  lane_c31_sel:4;
    };
}usit_usit_mux_24_31_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_c32_sel:4;
        RBus_UInt32  lane_c33_sel:4;
        RBus_UInt32  lane_c34_sel:4;
        RBus_UInt32  lane_c35_sel:4;
        RBus_UInt32  lane_c36_sel:4;
        RBus_UInt32  lane_c37_sel:4;
        RBus_UInt32  lane_c38_sel:4;
        RBus_UInt32  lane_c39_sel:4;
    };
}usit_usit_mux_32_39_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  lane_c40_sel:4;
        RBus_UInt32  lane_c41_sel:4;
        RBus_UInt32  lane_c42_sel:4;
        RBus_UInt32  lane_c43_sel:4;
        RBus_UInt32  lane_c44_sel:4;
        RBus_UInt32  lane_c45_sel:4;
        RBus_UInt32  lane_c46_sel:4;
        RBus_UInt32  lane_c47_sel:4;
    };
}usit_usit_mux_40_47_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  usit_port_en:12;
        RBus_UInt32  dummy18026b2c_31_12:20;
    };
}usit_usit_port_en_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sbc_td:10;
        RBus_UInt32  res1:2;
        RBus_UInt32  sbc_cmd_trigger:1;
        RBus_UInt32  res2:3;
        RBus_UInt32  sbc_payload_num:3;
        RBus_UInt32  res3:13;
    };
}usit_usit_sbc_ctrl1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  t_sfcr2start:8;
        RBus_UInt32  t_standby:8;
        RBus_UInt32  t_sfcf2sbcf:8;
        RBus_UInt32  t_sfcr2sbcr:4;
        RBus_UInt32  t_cs2start:4;
    };
}usit_usit_sbc_ctrl2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sbc_in_manual_mode:1;
        RBus_UInt32  sbc_in_manual_value:1;
        RBus_UInt32  sbc_out_manual_mode:1;
        RBus_UInt32  sbc_out_manual_value:1;
        RBus_UInt32  res1:12;
        RBus_UInt32  sbc_cmd_lane_en:12;
        RBus_UInt32  res2:4;
    };
}usit_usit_sbc_ctrl3_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sbc_ui_period:10;
        RBus_UInt32  res1:22;
    };
}usit_usit_sbc_ctrl4_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sbc_payload0_00:8;
        RBus_UInt32  sbc_payload1_00:8;
        RBus_UInt32  sbc_payload2_00:8;
        RBus_UInt32  sbc_payload3_00:8;
    };
}usit_usit_sbc_payload_00_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sbc_payload0_01:8;
        RBus_UInt32  sbc_payload1_01:8;
        RBus_UInt32  sbc_payload2_01:8;
        RBus_UInt32  sbc_payload3_01:8;
    };
}usit_usit_sbc_payload_01_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sbc_payload0_02:8;
        RBus_UInt32  sbc_payload1_02:8;
        RBus_UInt32  sbc_payload2_02:8;
        RBus_UInt32  sbc_payload3_02:8;
    };
}usit_usit_sbc_payload_02_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sbc_payload0_03:8;
        RBus_UInt32  sbc_payload1_03:8;
        RBus_UInt32  sbc_payload2_03:8;
        RBus_UInt32  sbc_payload3_03:8;
    };
}usit_usit_sbc_payload_03_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sbc_payload0_04:8;
        RBus_UInt32  sbc_payload1_04:8;
        RBus_UInt32  sbc_payload2_04:8;
        RBus_UInt32  sbc_payload3_04:8;
    };
}usit_usit_sbc_payload_04_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sbc_payload0_05:8;
        RBus_UInt32  sbc_payload1_05:8;
        RBus_UInt32  sbc_payload2_05:8;
        RBus_UInt32  sbc_payload3_05:8;
    };
}usit_usit_sbc_payload_05_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sbc_payload0_06:8;
        RBus_UInt32  sbc_payload1_06:8;
        RBus_UInt32  sbc_payload2_06:8;
        RBus_UInt32  sbc_payload3_06:8;
    };
}usit_usit_sbc_payload_06_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sbc_payload0_07:8;
        RBus_UInt32  sbc_payload1_07:8;
        RBus_UInt32  sbc_payload2_07:8;
        RBus_UInt32  sbc_payload3_07:8;
    };
}usit_usit_sbc_payload_07_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sbc_payload0_08:8;
        RBus_UInt32  sbc_payload1_08:8;
        RBus_UInt32  sbc_payload2_08:8;
        RBus_UInt32  sbc_payload3_08:8;
    };
}usit_usit_sbc_payload_08_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sbc_payload0_09:8;
        RBus_UInt32  sbc_payload1_09:8;
        RBus_UInt32  sbc_payload2_09:8;
        RBus_UInt32  sbc_payload3_09:8;
    };
}usit_usit_sbc_payload_09_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sbc_payload0_10:8;
        RBus_UInt32  sbc_payload1_10:8;
        RBus_UInt32  sbc_payload2_10:8;
        RBus_UInt32  sbc_payload3_10:8;
    };
}usit_usit_sbc_payload_10_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  sbc_payload0_11:8;
        RBus_UInt32  sbc_payload1_11:8;
        RBus_UInt32  sbc_payload2_11:8;
        RBus_UInt32  sbc_payload3_11:8;
    };
}usit_usit_sbc_payload_11_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_start:1;
        RBus_UInt32  crc_conti:1;
        RBus_UInt32  crc_auto_cmp_en:1;
        RBus_UInt32  res1:1;
        RBus_UInt32  crc_port_en:12;
        RBus_UInt32  crc_err_cnt:16;
    };
}usit_usit_crc_ctrl_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_result:32;
    };
}usit_usit_crc_result_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  crc_golden:32;
    };
}usit_usit_crc_golden_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dbg_sel:6;
        RBus_UInt32  res1:2;
        RBus_UInt32  dbg_data_sel:2;
        RBus_UInt32  res2:21;
        RBus_UInt32  dbg_en:1;
    };
}usit_usit_debug_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  usit_tst_out:32;
    };
}usit_usit_tst_out_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  usit_bist_length:20;
        RBus_UInt32  res1:9;
        RBus_UInt32  usit_bist_result:1;
        RBus_UInt32  usit_bist_done:1;
        RBus_UInt32  usit_bist_enable:1;
    };
}usit_usit_fifo_bist_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy0:32;
    };
}usit_usit_dummy0_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy1:32;
    };
}usit_usit_dummy1_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy2:32;
    };
}usit_usit_dummy2_RBUS;

typedef union
{
    RBus_UInt32 regValue;
    struct{
        RBus_UInt32  dummy3:32;
    };
}usit_usit_dummy3_RBUS;




#endif 


#endif 
